/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/path","vs/platform/files/common/files","vs/base/common/types","vs/platform/environment/common/environment","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/arrays","vs/base/common/resources","vs/platform/telemetry/common/telemetry","vs/base/common/cancellation","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/map","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/extensions/common/extensions","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/common/processes","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/platform/environment/common/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/lifecycle/electron-browser/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataProfile/electron-sandbox/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensions","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ae=function(ee){for(var e=[],k=0,i=ee.length;k<i;k++)e[k]=oe[ee[k]];return e};define(oe[51],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function k(A){return A?A.replace(/\$\((.*?)\)/g,(O,P)=>` ${P} `).trim():""}e.getCodiconAriaLabel=k;class i{constructor(O,P,I){this.id=O,this.definition=P,this.description=I,i.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i.a}}e.Codicon=i,i.a=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",i.circleFilled.definition),i.closeDirty=new i("close-dirty",i.circleFilled.definition),i.debugBreakpoint=new i("debug-breakpoint",i.circleFilled.definition),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",i.circleFilled.definition),i.debugHint=new i("debug-hint",i.circleFilled.definition),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circle=new i("circle",{fontCharacter:"\\eabc"}),i.circleOutline=new i("circle-outline",i.circle.definition),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",i.circle.definition),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.circleSmallFilled=new i("circle-small-filled",{fontCharacter:"\\eb8a"}),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.definition),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLarge=new i("circle-large",{fontCharacter:"\\ebb5"}),i.circleLargeOutline=new i("circle-large-outline",i.circleLarge.definition),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.heartFilled=new i("heart-filled",{fontCharacter:"\\ec04"}),i.map=new i("map",{fontCharacter:"\\ec05"}),i.mapFilled=new i("map-filled",{fontCharacter:"\\ec06"}),i.circleSmall=new i("circle-small",{fontCharacter:"\\ec07"}),i.bellSlash=new i("bell-slash",{fontCharacter:"\\ec08"}),i.bellSlashDot=new i("bell-slash-dot",{fontCharacter:"\\ec09"}),i.commentUnresolved=new i("comment-unresolved",{fontCharacter:"\\ec0a"}),i.gitPullRequestGoToChanges=new i("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),i.gitPullRequestNewChanges=new i("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),i.searchFuzzy=new i("search-fuzzy",{fontCharacter:"\\ec0d"}),i.commentDraft=new i("comment-draft",{fontCharacter:"\\ec0e"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);var D;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const O=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function P(C){if(C instanceof i)return["codicon","codicon-"+C.id];const E=O.exec(C.id);if(!E)return P(i.error);const[,w,p]=E,f=["codicon","codicon-"+w];return p&&f.push("codicon-modifier-"+p.substring(1)),f}A.asClassNameArray=P;function I(C){return P(C).join(" ")}A.asClassName=I;function S(C){return"."+P(C).join(".")}A.asCSSSelector=S})(D=e.CSSIcon||(e.CSSIcon={}))}),define(oe[63],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function k(O){return(P,I,S)=>{let C=null,E=null;if(typeof S.value=="function"?(C="value",E=S.value):typeof S.get=="function"&&(C="get",E=S.get),!E)throw new Error("not supported");S[C]=O(E,I)}}function i(O,P,I){let S=null,C=null;if(typeof I.value=="function"?(S="value",C=I.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(S="get",C=I.get),!C)throw new Error("not supported");const E=`$memoize$${P}`;I[S]=function(...w){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,w)}),this[E]}}e.memoize=i;function D(O,P,I){return k((S,C)=>{const E=`$debounce$${C}`,w=`$debounce$result$${C}`;return function(...p){this[w]||(this[w]=I?I():void 0),clearTimeout(this[E]),P&&(this[w]=P(this[w],...p),p=[this[w]]),this[E]=setTimeout(()=>{S.apply(this,p),this[w]=I?I():void 0},O)}})}e.debounce=D;function A(O,P,I){return k((S,C)=>{const E=`$throttle$timer$${C}`,w=`$throttle$result$${C}`,p=`$throttle$lastRun$${C}`,f=`$throttle$pending$${C}`;return function(...y){if(this[w]||(this[w]=I?I():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),P&&(this[w]=P(this[w],...y)),this[f])return;const v=this[p]+O;v<=Date.now()?(this[p]=Date.now(),S.apply(this,[this[w]]),this[w]=I?I():void 0):(this[f]=!0,this[E]=setTimeout(()=>{this[f]=!1,this[p]=Date.now(),S.apply(this,[this[w]]),this[w]=I?I():void 0},v-Date.now()))}})}e.throttle=A}),define(oe[9],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?u.isErrorNoTelemetry(n)?new u(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(r=>{r(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.ErrorHandler=k,e.errorHandler=new k;function i(h){e.errorHandler.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=i;function D(h){I(h)||e.errorHandler.onUnexpectedError(h)}e.onUnexpectedError=D;function A(h){I(h)||e.errorHandler.onUnexpectedExternalError(h)}e.onUnexpectedExternalError=A;function O(h){if(h instanceof Error){const{name:n,message:r}=h,t=h.stacktrace||h.stack;return{$isError:!0,name:n,message:r,stack:t,noTelemetry:u.isErrorNoTelemetry(h)}}return h}e.transformErrorForSerialization=O;const P="Canceled";function I(h){return h instanceof S?!0:h instanceof Error&&h.name===P&&h.message===P}e.isCancellationError=I;class S extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=S;function C(){const h=new Error(P);return h.name=h.message,h}e.canceled=C;function E(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.illegalArgument=E;function w(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.illegalState=w;function p(h){return h?new Error(`readonly property '${h} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function f(h){const n=new Error(`${h} has been disposed`);return n.name="DISPOSED",n}e.disposed=f;function y(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.getErrorMessage=y;class v extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=v;class l extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=l;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=m;class u extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof u)return n;const r=new u;return r.message=n.message,r.stack=n.stack,r}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=u;class d extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype);debugger}}e.BugIndicatingError=d}),define(oe[20],ae([0,1,9]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function i(X,te=0){return X[X.length-(1+te)]}e.tail=i;function D(X){if(X.length===0)throw new Error("Invalid tail call");return[X.slice(0,X.length-1),X[X.length-1]]}e.tail2=D;function A(X,te,se=(le,ue)=>le===ue){if(X===te)return!0;if(!X||!te||X.length!==te.length)return!1;for(let le=0,ue=X.length;le<ue;le++)if(!se(X[le],te[le]))return!1;return!0}e.equals=A;function O(X,te){const se=X.length-1;te<se&&(X[te]=X[se]),X.pop()}e.removeFastWithoutKeepingOrder=O;function P(X,te,se){return I(X.length,le=>se(X[le],te))}e.binarySearch=P;function I(X,te){let se=0,le=X-1;for(;se<=le;){const ue=(se+le)/2|0,ye=te(ue);if(ye<0)se=ue+1;else if(ye>0)le=ue-1;else return ue}return-(se+1)}e.binarySearch2=I;function S(X,te){let se=0,le=X.length;if(le===0)return 0;for(;se<le;){const ue=Math.floor((se+le)/2);te(X[ue])?le=ue:se=ue+1}return se}e.findFirstInSorted=S;function C(X,te,se){if(X=X|0,X>=te.length)throw new TypeError("invalid index");const le=te[Math.floor(te.length*Math.random())],ue=[],ye=[],Se=[];for(const be of te){const Ee=se(be,le);Ee<0?ue.push(be):Ee>0?ye.push(be):Se.push(be)}return X<ue.length?C(X,ue,se):X<ue.length+Se.length?Se[0]:C(X-(ue.length+Se.length),ye,se)}e.quickSelect=C;function E(X,te){const se=[];let le;for(const ue of X.slice(0).sort(te))!le||te(le[0],ue)!==0?(le=[ue],se.push(le)):le.push(ue);return se}e.groupBy=E;function w(X,te,se){const le=[];function ue(be,Ee,Ne){if(Ee===0&&Ne.length===0)return;const Fe=le[le.length-1];Fe&&Fe.start+Fe.deleteCount===be?(Fe.deleteCount+=Ee,Fe.toInsert.push(...Ne)):le.push({start:be,deleteCount:Ee,toInsert:Ne})}let ye=0,Se=0;for(;;){if(ye===X.length){ue(ye,0,te.slice(Se));break}if(Se===te.length){ue(ye,X.length-ye,[]);break}const be=X[ye],Ee=te[Se],Ne=se(be,Ee);Ne===0?(ye+=1,Se+=1):Ne<0?(ue(ye,1,[]),ye+=1):Ne>0&&(ue(ye,0,[Ee]),Se+=1)}return le}e.sortedDiff=w;function p(X,te,se){const le=w(X,te,se),ue=[],ye=[];for(const Se of le)ue.push(...X.slice(Se.start,Se.start+Se.deleteCount)),ye.push(...Se.toInsert);return{removed:ue,added:ye}}e.delta=p;function f(X,te,se){if(se===0)return[];const le=X.slice(0,se).sort(te);return v(X,te,le,se,X.length),le}e.top=f;function y(X,te,se,le,ue){return se===0?Promise.resolve([]):new Promise((ye,Se)=>{(async()=>{const be=X.length,Ee=X.slice(0,se).sort(te);for(let Ne=se,Fe=Math.min(se+le,be);Ne<be;Ne=Fe,Fe=Math.min(Fe+le,be)){if(Ne>se&&await new Promise(Ye=>setTimeout(Ye)),ue&&ue.isCancellationRequested)throw new k.CancellationError;v(X,te,Ee,Ne,Fe)}return Ee})().then(ye,Se)})}e.topAsync=y;function v(X,te,se,le,ue){for(const ye=se.length;le<ue;le++){const Se=X[le];if(te(Se,se[ye-1])<0){se.pop();const be=S(se,Ee=>te(Se,Ee)<0);se.splice(be,0,Se)}}}function l(X){return X.filter(te=>!!te)}e.coalesce=l;function m(X){let te=0;for(let se=0;se<X.length;se++)X[se]&&(X[te]=X[se],te+=1);X.length=te}e.coalesceInPlace=m;function u(X,te,se){X.splice(se,0,X.splice(te,1)[0])}e.move=u;function d(X){return!Array.isArray(X)||X.length===0}e.isFalsyOrEmpty=d;function h(X){return Array.isArray(X)&&X.length>0}e.isNonEmptyArray=h;function n(X,te=se=>se){const se=new Set;return X.filter(le=>{const ue=te(le);return se.has(ue)?!1:(se.add(ue),!0)})}e.distinct=n;function r(X){const te=new Set;return se=>{const le=X(se);return te.has(le)?!1:(te.add(le),!0)}}e.uniqueFilter=r;function t(X,te){const se=o(X,te);if(se!==-1)return X[se]}e.findLast=t;function o(X,te){for(let se=X.length-1;se>=0;se--){const le=X[se];if(te(le))return se}return-1}e.lastIndex=o;function s(X,te){return X.length>0?X[0]:te}e.firstOrDefault=s;function c(X,te){return X.length>0?X[X.length-1]:te}e.lastOrDefault=c;function a(X,te,se=(le,ue)=>le===ue){let le=0;for(let ue=0,ye=Math.min(X.length,te.length);ue<ye&&se(X[ue],te[ue]);ue++)le++;return le}e.commonPrefixLength=a;function g(X){return[].concat(...X)}e.flatten=g;function b(X,te){let se=typeof te=="number"?X:0;typeof te=="number"?se=X:(se=0,te=X);const le=[];if(se<=te)for(let ue=se;ue<te;ue++)le.push(ue);else for(let ue=se;ue>te;ue--)le.push(ue);return le}e.range=b;function R(X,te,se){return X.reduce((le,ue)=>(le[te(ue)]=se?se(ue):ue,le),Object.create(null))}e.index=R;function j(X,te){return X.push(te),()=>U(X,te)}e.insert=j;function U(X,te){const se=X.indexOf(te);if(se>-1)return X.splice(se,1),te}e.remove=U;function z(X,te,se){const le=X.slice(0,te),ue=X.slice(te);return le.concat(se,ue)}e.arrayInsert=z;function F(X,te){let se;if(typeof te=="number"){let le=te;se=()=>{const ue=Math.sin(le++)*179426549;return ue-Math.floor(ue)}}else se=Math.random;for(let le=X.length-1;le>0;le-=1){const ue=Math.floor(se()*(le+1)),ye=X[le];X[le]=X[ue],X[ue]=ye}}e.shuffle=F;function L(X,te){const se=X.indexOf(te);se>-1&&(X.splice(se,1),X.unshift(te))}e.pushToStart=L;function M(X,te){const se=X.indexOf(te);se>-1&&(X.splice(se,1),X.push(te))}e.pushToEnd=M;function $(X,te){for(const se of te)X.push(se)}e.pushMany=$;function G(X,te){return Array.isArray(X)?X.map(te):te(X)}e.mapArrayOrNot=G;function W(X){return Array.isArray(X)?X:[X]}e.asArray=W;function _(X){return X[Math.floor(Math.random()*X.length)]}e.getRandomElement=_;function K(X,te){for(const se of X){const le=te(se);if(le!==void 0)return le}}e.mapFind=K;function q(X,te,se){const le=Z(X,te),ue=X.length,ye=se.length;X.length=ue+ye;for(let Se=ue-1;Se>=le;Se--)X[Se+ye]=X[Se];for(let Se=0;Se<ye;Se++)X[Se+le]=se[Se]}e.insertInto=q;function V(X,te,se,le){const ue=Z(X,te),ye=X.splice(ue,se);return q(X,ue,le),ye}e.splice=V;function Z(X,te){return te<0?Math.max(te+X.length,0):Math.min(te,X.length)}var ne;(function(X){function te(ue){return ue<0}X.isLessThan=te;function se(ue){return ue>0}X.isGreaterThan=se;function le(ue){return ue===0}X.isNeitherLessOrGreaterThan=le,X.greaterThan=1,X.lessThan=-1,X.neitherLessOrGreaterThan=0})(ne=e.CompareResult||(e.CompareResult={}));function J(X,te){return(se,le)=>te(X(se),X(le))}e.compareBy=J;function x(...X){return(te,se)=>{for(const le of X){const ue=le(te,se);if(!ne.isNeitherLessOrGreaterThan(ue))return ue}return ne.neitherLessOrGreaterThan}}e.tieBreakComparators=x;const T=(X,te)=>X-te;e.numberComparator=T;function N(X,te){if(X.length===0)return;let se=X[0];for(let le=1;le<X.length;le++){const ue=X[le];te(ue,se)>0&&(se=ue)}return se}e.findMaxBy=N;function H(X,te){if(X.length===0)return;let se=X[0];for(let le=1;le<X.length;le++){const ue=X[le];te(ue,se)>=0&&(se=ue)}return se}e.findLastMaxBy=H;function B(X,te){return N(X,(se,le)=>-te(se,le))}e.findMinBy=B;class Q{constructor(te){this.f=te,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(te){let se=this.c;for(;se<this.f.length&&te(this.f[se]);)se++;const le=se===this.c?null:this.f.slice(this.c,se);return this.c=se,le}takeFromEndWhile(te){let se=this.d;for(;se>=0&&te(this.f[se]);)se--;const le=se===this.d?null:this.f.slice(se+1,this.d+1);return this.d=se,le}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const te=this.f[this.c];return this.c++,te}removeLast(){const te=this.f[this.d];return this.d--,te}takeCount(te){const se=this.f.slice(this.c,this.c+te);return this.c+=te,se}}e.ArrayQueue=Q;class re{constructor(te){this.iterate=te}forEach(te){this.iterate(se=>(te(se),!0))}toArray(){const te=[];return this.iterate(se=>(te.push(se),!0)),te}filter(te){return new re(se=>this.iterate(le=>te(le)?se(le):!0))}map(te){return new re(se=>this.iterate(le=>se(te(le))))}some(te){let se=!1;return this.iterate(le=>(se=te(le),!se)),se}findFirst(te){let se;return this.iterate(le=>te(le)?(se=le,!1):!0),se}findLast(te){let se;return this.iterate(le=>(te(le)&&(se=le),!0)),se}findLastMaxBy(te){let se,le=!0;return this.iterate(ue=>((le||ne.isGreaterThan(te(ue,se)))&&(le=!1,se=ue),!0)),se}}e.CallbackIterable=re,re.empty=new re(X=>{})}),define(oe[126],ae([0,1,9]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function i(I,S){if(!I)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=i;function D(I,S="Unreachable"){throw new Error(S)}e.assertNever=D;function A(I){if(!I)throw new k.BugIndicatingError("Assertion Failed")}e.assert=A;function O(I){if(!I()){debugger;I(),(0,k.onUnexpectedError)(new k.BugIndicatingError("Assertion Failed"))}}e.assertFn=O;function P(I,S){let C=0;for(;C<I.length-1;){const E=I[C],w=I[C+1];if(!S(E,w))return!1;C++}return!0}e.checkAdjacentItems=P}),define(oe[82],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function k(i){const D=this;let A=!1,O;return function(){return A||(A=!0,O=i.apply(D,arguments)),O}}e.once=k}),define(oe[64],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(i){function D(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}i.is=D;const A=Object.freeze([]);function O(){return A}i.empty=O;function*P(d){yield d}i.single=P;function I(d){return D(d)?d:P(d)}i.wrap=I;function S(d){return d||A}i.from=S;function C(d){return!d||d[Symbol.iterator]().next().done===!0}i.isEmpty=C;function E(d){return d[Symbol.iterator]().next().value}i.first=E;function w(d,h){for(const n of d)if(h(n))return!0;return!1}i.some=w;function p(d,h){for(const n of d)if(h(n))return n}i.find=p;function*f(d,h){for(const n of d)h(n)&&(yield n)}i.filter=f;function*y(d,h){let n=0;for(const r of d)yield h(r,n++)}i.map=y;function*v(...d){for(const h of d)for(const n of h)yield n}i.concat=v;function l(d,h,n){let r=n;for(const t of d)r=h(r,t);return r}i.reduce=l;function*m(d,h,n=d.length){for(h<0&&(h+=d.length),n<0?n+=d.length:n>d.length&&(n=d.length);h<n;h++)yield d[h]}i.slice=m;function u(d,h=Number.POSITIVE_INFINITY){const n=[];if(h===0)return[n,d];const r=d[Symbol.iterator]();for(let t=0;t<h;t++){const o=r.next();if(o.done)return[n,i.empty()];n.push(o.value)}return[n,{[Symbol.iterator](){return r}}]}i.consume=u})(k=e.Iterable||(e.Iterable={}))}),define(oe[35],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(k=e.ScanError||(e.ScanError={}));var i;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(i=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(n){n.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function O(n,r=!1){let t=0;const o=n.length;let s="",c=0,a=16,g=0;function b(M){let $=0,G=0;for(;$<M;){const W=n.charCodeAt(t);if(W>=48&&W<=57)G=G*16+W-48;else if(W>=65&&W<=70)G=G*16+W-65+10;else if(W>=97&&W<=102)G=G*16+W-97+10;else break;t++,$++}return $<M&&(G=-1),G}function R(M){t=M,s="",c=0,a=16,g=0}function j(){const M=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&S(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&S(n.charCodeAt(t)))for(t++;t<n.length&&S(n.charCodeAt(t));)t++;else return g=3,n.substring(M,t);let $=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&S(n.charCodeAt(t))){for(t++;t<n.length&&S(n.charCodeAt(t));)t++;$=t}else g=3;return n.substring(M,$)}function U(){let M="",$=t;for(;;){if(t>=o){M+=n.substring($,t),g=2;break}const G=n.charCodeAt(t);if(G===34){M+=n.substring($,t),t++;break}if(G===92){if(M+=n.substring($,t),t++,t>=o){g=2;break}switch(n.charCodeAt(t++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const _=b(4);_>=0?M+=String.fromCharCode(_):g=4;break}default:g=5}$=t;continue}if(G>=0&&G<=31)if(I(G)){M+=n.substring($,t),g=2;break}else g=6;t++}return M}function z(){if(s="",g=0,c=t,t>=o)return c=o,a=17;let M=n.charCodeAt(t);if(P(M)){do t++,s+=String.fromCharCode(M),M=n.charCodeAt(t);while(P(M));return a=15}if(I(M))return t++,s+=String.fromCharCode(M),M===13&&n.charCodeAt(t)===10&&(t++,s+=`
`),a=14;switch(M){case 123:return t++,a=1;case 125:return t++,a=2;case 91:return t++,a=3;case 93:return t++,a=4;case 58:return t++,a=6;case 44:return t++,a=5;case 34:return t++,s=U(),a=10;case 47:{const $=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<o&&!I(n.charCodeAt(t));)t++;return s=n.substring($,t),a=12}if(n.charCodeAt(t+1)===42){t+=2;const G=o-1;let W=!1;for(;t<G;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,W=!0;break}t++}return W||(t++,g=1),s=n.substring($,t),a=13}return s+=String.fromCharCode(M),t++,a=16}case 45:if(s+=String.fromCharCode(M),t++,t===o||!S(n.charCodeAt(t)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=j(),a=11;default:for(;t<o&&F(M);)t++,M=n.charCodeAt(t);if(c!==t){switch(s=n.substring(c,t),s){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return s+=String.fromCharCode(M),t++,a=16}}function F(M){if(P(M)||I(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let M;do M=z();while(M>=12&&M<=15);return M}return{setPosition:R,getPosition:()=>t,scan:r?L:z,getToken:()=>a,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>t-c,getTokenError:()=>g}}e.createScanner=O;function P(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function I(n){return n===10||n===13||n===8232||n===8233}function S(n){return n>=48&&n<=57}var C;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(C||(C={}));function E(n,r){const t=[],o=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function g(b,R,j,U){c.value=b,c.offset=R,c.length=j,c.type=U,c.colonOffset=void 0,s=c}try{u(n,{onObjectBegin:(b,R)=>{if(r<=b)throw o;s=void 0,a=r>b,t.push("")},onObjectProperty:(b,R,j)=>{if(r<R||(g(b,R,j,"property"),t[t.length-1]=b,r<=R+j))throw o},onObjectEnd:(b,R)=>{if(r<=b)throw o;s=void 0,t.pop()},onArrayBegin:(b,R)=>{if(r<=b)throw o;s=void 0,t.push(0)},onArrayEnd:(b,R)=>{if(r<=b)throw o;s=void 0,t.pop()},onLiteralValue:(b,R,j)=>{if(r<R||(g(b,R,j,h(b)),r<=R+j))throw o},onSeparator:(b,R,j)=>{if(r<=R)throw o;if(b===":"&&s&&s.type==="property")s.colonOffset=R,a=!1,s=void 0;else if(b===","){const U=t[t.length-1];typeof U=="number"?t[t.length-1]=U+1:(a=!0,t[t.length-1]=""),s=void 0}}})}catch(b){if(b!==o)throw b}return{path:t,previousNode:s,isAtPropertyKey:a,matches:b=>{let R=0;for(let j=0;R<b.length&&j<t.length;j++)if(b[R]===t[j]||b[R]==="*")R++;else if(b[R]!=="**")return!1;return R===b.length}}}e.getLocation=E;function w(n,r=[],t=A.DEFAULT){let o=null,s=[];const c=[];function a(b){Array.isArray(s)?s.push(b):o!==null&&(s[o]=b)}return u(n,{onObjectBegin:()=>{const b={};a(b),c.push(s),s=b,o=null},onObjectProperty:b=>{o=b},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const b=[];a(b),c.push(s),s=b,o=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:a,onError:(b,R,j)=>{r.push({error:b,offset:R,length:j})}},t),s[0]}e.parse=w;function p(n,r=[],t=A.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(b){o.type==="property"&&(o.length=b-o.offset,o=o.parent)}function c(b){return o.children.push(b),b}u(n,{onObjectBegin:b=>{o=c({type:"object",offset:b,length:-1,parent:o,children:[]})},onObjectProperty:(b,R,j)=>{o=c({type:"property",offset:R,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:b,offset:R,length:j,parent:o})},onObjectEnd:(b,R)=>{o.length=b+R-o.offset,o=o.parent,s(b+R)},onArrayBegin:(b,R)=>{o=c({type:"array",offset:b,length:-1,parent:o,children:[]})},onArrayEnd:(b,R)=>{o.length=b+R-o.offset,o=o.parent,s(b+R)},onLiteralValue:(b,R,j)=>{c({type:h(b),offset:R,length:j,parent:o,value:b}),s(R+j)},onSeparator:(b,R,j)=>{o.type==="property"&&(b===":"?o.colonOffset=R:b===","&&s(R))},onError:(b,R,j)=>{r.push({error:b,offset:R,length:j})}},t);const g=o.children[0];return g&&delete g.parent,g}e.parseTree=p;function f(n,r){if(!n)return;let t=n;for(const o of r)if(typeof o=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const c of t.children)if(Array.isArray(c.children)&&c.children[0].value===o){t=c.children[1],s=!0;break}if(!s)return}else{const s=o;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}e.findNodeAtLocation=f;function y(n){if(!n.parent||!n.parent.children)return[];const r=y(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;r.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&r.push(t)}return r}e.getNodePath=y;function v(n){switch(n.type){case"array":return n.children.map(v);case"object":{const r=Object.create(null);for(const t of n.children){const o=t.children[1];o&&(r[t.children[0].value]=v(o))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=v;function l(n,r,t=!1){return r>=n.offset&&r<n.offset+n.length||t&&r===n.offset+n.length}e.contains=l;function m(n,r,t=!1){if(l(n,r,t)){const o=n.children;if(Array.isArray(o))for(let s=0;s<o.length&&o[s].offset<=r;s++){const c=m(o[s],r,t);if(c)return c}return n}}e.findNodeAtOffset=m;function u(n,r,t=A.DEFAULT){const o=O(n,!1);function s(J){return J?()=>J(o.getTokenOffset(),o.getTokenLength()):()=>!0}function c(J){return J?x=>J(x,o.getTokenOffset(),o.getTokenLength()):()=>!0}const a=s(r.onObjectBegin),g=c(r.onObjectProperty),b=s(r.onObjectEnd),R=s(r.onArrayBegin),j=s(r.onArrayEnd),U=c(r.onLiteralValue),z=c(r.onSeparator),F=s(r.onComment),L=c(r.onError),M=t&&t.disallowComments,$=t&&t.allowTrailingComma;function G(){for(;;){const J=o.scan();switch(o.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:M||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(J){case 12:case 13:M?W(10):F();break;case 16:W(1);break;case 15:case 14:break;default:return J}}}function W(J,x=[],T=[]){if(L(J),x.length+T.length>0){let N=o.getToken();for(;N!==17;){if(x.indexOf(N)!==-1){G();break}else if(T.indexOf(N)!==-1)break;N=G()}}}function _(J){const x=o.getTokenValue();return J?U(x):g(x),G(),!0}function K(){switch(o.getToken()){case 11:{let J=0;try{J=JSON.parse(o.getTokenValue()),typeof J!="number"&&(W(2),J=0)}catch{W(2)}U(J);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return G(),!0}function q(){return o.getToken()!==10?(W(3,[],[2,5]),!1):(_(!1),o.getToken()===6?(z(":"),G(),ne()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function V(){a(),G();let J=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(J||W(4,[],[]),z(","),G(),o.getToken()===2&&$)break}else J&&W(6,[],[]);q()||W(4,[],[2,5]),J=!0}return b(),o.getToken()!==2?W(7,[2],[]):G(),!0}function Z(){R(),G();let J=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(J||W(4,[],[]),z(","),G(),o.getToken()===4&&$)break}else J&&W(6,[],[]);ne()||W(4,[],[4,5]),J=!0}return j(),o.getToken()!==4?W(8,[4],[]):G(),!0}function ne(){switch(o.getToken()){case 3:return Z();case 1:return V();case 10:return _(!0);default:return K()}}return G(),o.getToken()===17?t.allowEmptyContent?!0:(W(4,[],[]),!1):ne()?(o.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=u;function d(n,r){const t=O(n),o=[];let s,c=0,a;do switch(a=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:c!==a&&o.push(n.substring(c,a)),r!==void 0&&o.push(t.getTokenValue().replace(/[^\r\n]/g,r)),c=t.getPosition();break}while(s!==17);return o.join("")}e.stripComments=d;function h(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=h}),define(oe[43],ae([0,1,35]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function i(S,C,E){let w,p,f,y,v;if(C){for(y=C.offset,v=y+C.length,f=y;f>0&&!I(S,f-1);)f--;let a=v;for(;a<S.length&&!I(S,a);)a++;p=S.substring(f,a),w=O(p,E)}else p=S,w=0,f=0,y=0,v=S.length;const l=P(E,S);let m=!1,u=0,d;E.insertSpaces?d=A(" ",E.tabSize||4):d="	";const h=(0,k.createScanner)(p,!1);let n=!1;function r(){return l+A(d,w+u)}function t(){let a=h.scan();for(m=!1;a===15||a===14;)m=m||a===14,a=h.scan();return n=a===16||h.getTokenError()!==0,a}const o=[];function s(a,g,b){!n&&g<v&&b>y&&S.substring(g,b)!==a&&o.push({offset:g,length:b-g,content:a})}let c=t();if(c!==17){const a=h.getTokenOffset()+f,g=A(d,w);s(g,f,a)}for(;c!==17;){let a=h.getTokenOffset()+h.getTokenLength()+f,g=t(),b="";for(;!m&&(g===12||g===13);){const j=h.getTokenOffset()+f;s(" ",a,j),a=h.getTokenOffset()+h.getTokenLength()+f,b=g===12?r():"",g=t()}if(g===2)c!==1&&(u--,b=r());else if(g===4)c!==3&&(u--,b=r());else{switch(c){case 3:case 1:u++,b=r();break;case 5:case 12:b=r();break;case 13:m?b=r():b=" ";break;case 6:b=" ";break;case 10:if(g===6){b="";break}case 7:case 8:case 9:case 11:case 2:case 4:g===12||g===13?b=" ":g!==5&&g!==17&&(n=!0);break;case 16:n=!0;break}m&&(g===12||g===13)&&(b=r())}const R=h.getTokenOffset()+f;s(b,a,R),c=g}return o}e.format=i;function D(S,C){const E=JSON.stringify(S,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?E.replace(/\r\n|\r|\n/g,C.eol):E}e.toFormattedString=D;function A(S,C){let E="";for(let w=0;w<C;w++)E+=S;return E}function O(S,C){let E=0,w=0;const p=C.tabSize||4;for(;E<S.length;){const f=S.charAt(E);if(f===" ")w++;else if(f==="	")w+=p;else break;E++}return Math.floor(w/p)}function P(S,C){for(let E=0;E<C.length;E++){const w=C.charAt(E);if(w==="\r")return E+1<C.length&&C.charAt(E+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=P;function I(S,C){return`\r
`.indexOf(S.charAt(C))!==-1}e.isEOL=I}),define(oe[83],ae([0,1,35,43]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(S,C,E){return A(S,C,void 0,E)}e.removeProperty=D;function A(S,C,E,w,p){const f=C.slice(),y=[],v=(0,k.parseTree)(S,y);let l,m;for(;f.length>0&&(m=f.pop(),l=(0,k.findNodeAtLocation)(v,f),l===void 0&&E!==void 0);)typeof m=="string"?E={[m]:E}:E=[E];if(l)if(l.type==="object"&&typeof m=="string"&&Array.isArray(l.children)){const u=(0,k.findNodeAtLocation)(l,[m]);if(u!==void 0)if(E===void 0){if(!u.parent)throw new Error("Malformed AST");const d=l.children.indexOf(u.parent);let h,n=u.parent.offset+u.parent.length;if(d>0){const r=l.children[d-1];h=r.offset+r.length}else h=l.offset+1,l.children.length>1&&(n=l.children[1].offset);return O(S,{offset:h,length:n-h,content:""},w)}else return O(S,{offset:u.offset,length:u.length,content:JSON.stringify(E)},w);else{if(E===void 0)return[];const d=`${JSON.stringify(m)}: ${JSON.stringify(E)}`,h=p?p(l.children.map(r=>r.children[0].value)):l.children.length;let n;if(h>0){const r=l.children[h-1];n={offset:r.offset+r.length,length:0,content:","+d}}else l.children.length===0?n={offset:l.offset+1,length:0,content:d}:n={offset:l.offset+1,length:0,content:d+","};return O(S,n,w)}}else if(l.type==="array"&&typeof m=="number"&&Array.isArray(l.children))if(E!==void 0){const u=`${JSON.stringify(E)}`;let d;if(l.children.length===0||m===0)d={offset:l.offset+1,length:0,content:l.children.length===0?u:u+","};else{const h=m===-1||m>l.children.length?l.children.length:m,n=l.children[h-1];d={offset:n.offset+n.length,length:0,content:","+u}}return O(S,d,w)}else{const u=m,d=l.children[u];let h;if(l.children.length===1)h={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===u){const n=l.children[u-1],r=n.offset+n.length,t=l.offset+l.length;h={offset:r,length:t-2-r,content:""}}else h={offset:d.offset,length:l.children[u+1].offset-d.offset,content:""};return O(S,h,w)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${l.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return O(S,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(E)},w)}}e.setProperty=A;function O(S,C,E){let w=P(S,C),p=C.offset,f=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;p>0&&!(0,i.isEOL)(w,p-1);)p--;for(;f<w.length&&!(0,i.isEOL)(w,f);)f++}const y=(0,i.format)(w,{offset:p,length:f-p},E);for(let l=y.length-1;l>=0;l--){const m=y[l];w=P(w,m),p=Math.min(p,m.offset),f=Math.max(f,m.offset+m.length),f+=m.content.length-m.length}const v=S.length-(w.length-f)-p;return[{offset:p,length:v,content:w.substring(p,f)}]}e.withFormatting=O;function P(S,C){return S.substring(0,C.offset)+C.content+S.substring(C.offset+C.length)}e.applyEdit=P;function I(S,C){const E=C.slice(0).sort((p,f)=>{const y=p.offset-f.offset;return y===0?p.length-f.length:y});let w=S.length;for(let p=E.length-1;p>=0;p--){const f=E[p];if(f.offset+f.length<=w)S=P(S,f);else throw new Error("Overlapping edit");w=f.offset}return S}e.applyEdits=I}),define(oe[127],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class k{constructor(D){this.d=D,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(D){this.c=D}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(D){return new k(()=>D(this.getValue()))}}e.Lazy=k}),define(oe[2],ae([0,1,82,64]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let A=null;function O(c){A=c}if(e.setDisposableTracker=O,D){const c="__is_disposable_tracked__";O(new class{trackDisposable(a){const g=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[c]||console.log(g)},3e3)}setParent(a,g){if(a&&a!==m.None)try{a[c]=!0}catch{}}markAsDisposed(a){if(a&&a!==m.None)try{a[c]=!0}catch{}}markAsSingleton(a){}})}function P(c){return A?.trackDisposable(c),c}function I(c){A?.markAsDisposed(c)}function S(c,a){A?.setParent(c,a)}function C(c,a){if(!!A)for(const g of c)A.setParent(g,a)}function E(c){return A?.markAsSingleton(c),c}e.markAsSingleton=E;function w(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=w;function p(c){if(i.Iterable.is(c)){const a=[];for(const g of c)if(g)try{g.dispose()}catch(b){a.push(b)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=p;function f(c){for(const a of c)w(a)&&a.dispose();return[]}e.disposeIfDisposable=f;function y(...c){const a=v(()=>p(c));return C(c,a),a}e.combinedDisposable=y;function v(c){const a=P({dispose:(0,k.once)(()=>{I(a),c()})});return a}e.toDisposable=v;class l{constructor(){this.c=new Set,this.f=!1,P(this)}dispose(){this.f||(I(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{p(this.c)}finally{this.c.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return S(a,this),this.f?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(a),a}}e.DisposableStore=l,l.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this.q=new l,P(this),S(this.q,this)}dispose(){I(this),this.q.dispose()}B(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(a)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class u{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(a){this.b||a===this.a||(this.a?.dispose(),a&&S(a,this),this.a=a)}clear(){this.value=void 0}dispose(){this.b=!0,I(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const a=this.a;return this.a=void 0,a&&S(a,null),a}}e.MutableDisposable=u;class d{constructor(a){this.b=a,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=d;class h{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(a){let g=a;return this.unset=()=>g=void 0,this.isset=()=>g!==void 0,this.dispose=()=>{g&&(g(),g=void 0,I(this))},this}}e.SafeDisposable=h;class n{constructor(){this.a=new Map}acquire(a,...g){let b=this.a.get(a);b||(b={counter:0,object:this.b(a,...g)},this.a.set(a,b));const{object:R}=b,j=(0,k.once)(()=>{--b.counter===0&&(this.c(a,b.object),this.a.delete(a))});return b.counter++,{object:R,dispose:j}}}e.ReferenceCollection=n;class r{constructor(a){this.a=a}async acquire(a,...g){const b=this.a.acquire(a,...g);try{return{object:await b.object,dispose:()=>b.dispose()}}catch(R){throw b.dispose(),R}}}e.AsyncReferenceCollection=r;class t{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=t;function o(c){const a=new l;try{c(a)}finally{a.dispose()}}e.disposeOnReturn=o;class s{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){I(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{p(this.a.values())}finally{this.a.clear()}}has(a){return this.a.has(a)}get(a){return this.a.get(a)}set(a,g,b=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),b||this.a.get(a)?.dispose(),this.a.set(a,g)}deleteAndDispose(a){this.a.get(a)?.dispose(),this.a.delete(a)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=s}),define(oe[84],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{constructor(A){this.element=A,this.next=k.Undefined,this.prev=k.Undefined}}k.Undefined=new k(void 0);class i{constructor(){this.a=k.Undefined,this.b=k.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===k.Undefined}clear(){let A=this.a;for(;A!==k.Undefined;){const O=A.next;A.prev=k.Undefined,A.next=k.Undefined,A=O}this.a=k.Undefined,this.b=k.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,O){const P=new k(A);if(this.a===k.Undefined)this.a=P,this.b=P;else if(O){const S=this.b;this.b=P,P.prev=S,S.next=P}else{const S=this.a;this.a=P,P.next=S,S.prev=P}this.c+=1;let I=!1;return()=>{I||(I=!0,this.e(P))}}shift(){if(this.a!==k.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==k.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==k.Undefined&&A.next!==k.Undefined){const O=A.prev;O.next=A.next,A.next.prev=O}else A.prev===k.Undefined&&A.next===k.Undefined?(this.a=k.Undefined,this.b=k.Undefined):A.next===k.Undefined?(this.b=this.b.prev,this.b.next=k.Undefined):A.prev===k.Undefined&&(this.a=this.a.next,this.a.prev=k.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==k.Undefined;)yield A.element,A=A.next}}e.LinkedList=i}),define(oe[37],ae([0,1]),function(ee,e){"use strict";var k,i,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(f,y,v){let l=f.get(y);return l===void 0&&(l=v,f.set(y,l)),l}e.getOrSet=A;function O(f){const y=[];return f.forEach((v,l)=>{y.push(`${l} => ${v}`)}),`Map(${f.size}) {${y.join(", ")}}`}e.mapToString=O;function P(f){const y=[];return f.forEach(v=>{y.push(v)}),`Set(${f.size}) {${y.join(", ")}}`}e.setToString=P;class I{constructor(y,v){this.uri=y,this.value=v}}class S{constructor(y,v){this[k]="ResourceMap",y instanceof S?(this.b=new Map(y.b),this.c=v??S.a):(this.b=new Map,this.c=y??S.a)}set(y,v){return this.b.set(this.c(y),new I(y,v)),this}get(y){return this.b.get(this.c(y))?.value}has(y){return this.b.has(this.c(y))}get size(){return this.b.size}clear(){this.b.clear()}delete(y){return this.b.delete(this.c(y))}forEach(y,v){typeof v<"u"&&(y=y.bind(v));for(const[l,m]of this.b)y(m.value,m.uri,this)}*values(){for(const y of this.b.values())yield y.value}*keys(){for(const y of this.b.values())yield y.uri}*entries(){for(const y of this.b.values())yield[y.uri,y.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,y]of this.b)yield[y.uri,y.value]}}e.ResourceMap=S,S.a=f=>f.toString();class C{constructor(y,v){this[i]="ResourceSet",!y||typeof y=="function"?this.a=new S(y):(this.a=new S(v),y.forEach(this.add,this))}get size(){return this.a.size}add(y){return this.a.set(y,y),this}clear(){this.a.clear()}delete(y){return this.a.delete(y)}forEach(y,v){this.a.forEach((l,m)=>y.call(v,m,m,this))}has(y){return this.a.has(y)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=C;var E;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class w{constructor(){this[D]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(y){return this.a.has(y)}get(y,v=0){const l=this.a.get(y);if(!!l)return v!==0&&this.j(l,v),l.value}set(y,v,l=0){let m=this.a.get(y);if(m)m.value=v,l!==0&&this.j(m,l);else{switch(m={key:y,value:v,next:void 0,previous:void 0},l){case 0:this.h(m);break;case 1:this.g(m);break;case 2:this.h(m);break;default:this.h(m);break}this.a.set(y,m),this.d++}return this}delete(y){return!!this.remove(y)}remove(y){const v=this.a.get(y);if(!!v)return this.a.delete(y),this.i(v),this.d--,v.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const y=this.b;return this.a.delete(y.key),this.i(y),this.d--,y.value}forEach(y,v){const l=this.e;let m=this.b;for(;m;){if(v?y.bind(v)(m.value,m.key,this):y(m.value,m.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const y=this,v=this.e;let l=this.b;const m={[Symbol.iterator](){return m},next(){if(y.e!==v)throw new Error("LinkedMap got modified during iteration.");if(l){const u={value:l.key,done:!1};return l=l.next,u}else return{value:void 0,done:!0}}};return m}values(){const y=this,v=this.e;let l=this.b;const m={[Symbol.iterator](){return m},next(){if(y.e!==v)throw new Error("LinkedMap got modified during iteration.");if(l){const u={value:l.value,done:!1};return l=l.next,u}else return{value:void 0,done:!0}}};return m}entries(){const y=this,v=this.e;let l=this.b;const m={[Symbol.iterator](){return m},next(){if(y.e!==v)throw new Error("LinkedMap got modified during iteration.");if(l){const u={value:[l.key,l.value],done:!1};return l=l.next,u}else return{value:void 0,done:!0}}};return m}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(y){if(y>=this.size)return;if(y===0){this.clear();return}let v=this.b,l=this.size;for(;v&&l>y;)this.a.delete(v.key),v=v.next,l--;this.b=v,this.d=l,v&&(v.previous=void 0),this.e++}g(y){if(!this.b&&!this.c)this.c=y;else if(this.b)y.next=this.b,this.b.previous=y;else throw new Error("Invalid list");this.b=y,this.e++}h(y){if(!this.b&&!this.c)this.b=y;else if(this.c)y.previous=this.c,this.c.next=y;else throw new Error("Invalid list");this.c=y,this.e++}i(y){if(y===this.b&&y===this.c)this.b=void 0,this.c=void 0;else if(y===this.b){if(!y.next)throw new Error("Invalid list");y.next.previous=void 0,this.b=y.next}else if(y===this.c){if(!y.previous)throw new Error("Invalid list");y.previous.next=void 0,this.c=y.previous}else{const v=y.next,l=y.previous;if(!v||!l)throw new Error("Invalid list");v.previous=l,l.next=v}y.next=void 0,y.previous=void 0,this.e++}j(y,v){if(!this.b||!this.c)throw new Error("Invalid list");if(!(v!==1&&v!==2)){if(v===1){if(y===this.b)return;const l=y.next,m=y.previous;y===this.c?(m.next=void 0,this.c=m):(l.previous=m,m.next=l),y.previous=void 0,y.next=this.b,this.b.previous=y,this.b=y,this.e++}else if(v===2){if(y===this.c)return;const l=y.next,m=y.previous;y===this.b?(l.previous=void 0,this.b=l):(l.previous=m,m.next=l),y.next=void 0,y.previous=this.c,this.c.next=y,this.c=y,this.e++}}}toJSON(){const y=[];return this.forEach((v,l)=>{y.push([l,v])}),y}fromJSON(y){this.clear();for(const[v,l]of y)this.set(v,l)}}e.LinkedMap=w;class p extends w{constructor(y,v=1){super(),this.k=y,this.l=Math.min(Math.max(0,v),1)}get limit(){return this.k}set limit(y){this.k=y,this.m()}get ratio(){return this.l}set ratio(y){this.l=Math.min(Math.max(0,y),1),this.m()}get(y,v=2){return super.get(y,v)}peek(y){return super.get(y,0)}set(y,v){return super.set(y,v,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=p}),define(oe[85],ae([0,1,37]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new k.LRUCache(1e4);function D(S){return I(S,"NFC",i)}e.normalizeNFC=D;const A=new k.LRUCache(1e4);function O(S){return I(S,"NFD",A)}e.normalizeNFD=O;const P=/[^\u0000-\u0080]/;function I(S,C,E){if(!S)return S;const w=E.get(S);if(w)return w;let p;return P.test(S)?p=S.normalize(C):p=S,E.set(S,p),p}e.removeAccents=function(){const S=/[\u0300-\u036f]/g;return function(C){return O(C).replace(S,"")}}()}),function(){function ee(D){const A=[];typeof D=="number"&&A.push("code/timeOrigin",D);function O(I){A.push(I,Date.now())}function P(){const I=[];for(let S=0;S<A.length;S+=2)I.push({name:A[S],startTime:A[S+1]});return I}return{mark:O,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const O of performance.getEntriesByType("mark"))A.push({name:O.name,startTime:Math.round(D+O.startTime)});return A}};if(typeof process=="object"){const D=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function k(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=k(i))}(),function(ee,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var i in k)(typeof exports=="object"?exports:ee)[i]=k[i]}}(typeof self<"u"?self:this,function(){return function(ee){var e={};function k(i){if(e[i])return e[i].exports;var D=e[i]={i,l:!1,exports:{}};return ee[i].call(D.exports,D,D.exports,k),D.l=!0,D.exports}return k.m=ee,k.c=e,k.d=function(i,D,A){k.o(i,D)||Object.defineProperty(i,D,{enumerable:!0,get:A})},k.r=function(i){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(i,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(i,"__esModule",{value:!0})},k.t=function(i,D){if(1&D&&(i=k(i)),8&D||4&D&&typeof i=="object"&&i&&i.__esModule)return i;var A=Object.create(null);if(k.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:i}),2&D&&typeof i!="string")for(var O in i)k.d(A,O,function(P){return i[P]}.bind(null,O));return A},k.n=function(i){var D=i&&i.__esModule?function(){return i.default}:function(){return i};return k.d(D,"a",D),D},k.o=function(i,D){return Object.prototype.hasOwnProperty.call(i,D)},k.p="",k(k.s=0)}([function(ee,e,k){(function(i){var D;e=ee.exports=T,D=typeof i=="object"&&i.env&&i.env.NODE_DEBUG&&/\bsemver\b/i.test(i.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],I=e.src=[],S=0,C=S++;I[C]="0|[1-9]\\d*";var E=S++;I[E]="[0-9]+";var w=S++;I[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=S++;I[p]="("+I[C]+")\\.("+I[C]+")\\.("+I[C]+")";var f=S++;I[f]="("+I[E]+")\\.("+I[E]+")\\.("+I[E]+")";var y=S++;I[y]="(?:"+I[C]+"|"+I[w]+")";var v=S++;I[v]="(?:"+I[E]+"|"+I[w]+")";var l=S++;I[l]="(?:-("+I[y]+"(?:\\."+I[y]+")*))";var m=S++;I[m]="(?:-?("+I[v]+"(?:\\."+I[v]+")*))";var u=S++;I[u]="[0-9A-Za-z-]+";var d=S++;I[d]="(?:\\+("+I[u]+"(?:\\."+I[u]+")*))";var h=S++,n="v?"+I[p]+I[l]+"?"+I[d]+"?";I[h]="^"+n+"$";var r="[v=\\s]*"+I[f]+I[m]+"?"+I[d]+"?",t=S++;I[t]="^"+r+"$";var o=S++;I[o]="((?:<|>)?=?)";var s=S++;I[s]=I[E]+"|x|X|\\*";var c=S++;I[c]=I[C]+"|x|X|\\*";var a=S++;I[a]="[v=\\s]*("+I[c]+")(?:\\.("+I[c]+")(?:\\.("+I[c]+")(?:"+I[l]+")?"+I[d]+"?)?)?";var g=S++;I[g]="[v=\\s]*("+I[s]+")(?:\\.("+I[s]+")(?:\\.("+I[s]+")(?:"+I[m]+")?"+I[d]+"?)?)?";var b=S++;I[b]="^"+I[o]+"\\s*"+I[a]+"$";var R=S++;I[R]="^"+I[o]+"\\s*"+I[g]+"$";var j=S++;I[j]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=S++;I[U]="(?:~>?)";var z=S++;I[z]="(\\s*)"+I[U]+"\\s+",P[z]=new RegExp(I[z],"g");var F=S++;I[F]="^"+I[U]+I[a]+"$";var L=S++;I[L]="^"+I[U]+I[g]+"$";var M=S++;I[M]="(?:\\^)";var $=S++;I[$]="(\\s*)"+I[M]+"\\s+",P[$]=new RegExp(I[$],"g");var G=S++;I[G]="^"+I[M]+I[a]+"$";var W=S++;I[W]="^"+I[M]+I[g]+"$";var _=S++;I[_]="^"+I[o]+"\\s*("+r+")$|^$";var K=S++;I[K]="^"+I[o]+"\\s*("+n+")$|^$";var q=S++;I[q]="(\\s*)"+I[o]+"\\s*("+r+"|"+I[a]+")",P[q]=new RegExp(I[q],"g");var V=S++;I[V]="^\\s*("+I[a]+")\\s+-\\s+("+I[a]+")\\s*$";var Z=S++;I[Z]="^\\s*("+I[g]+")\\s+-\\s+("+I[g]+")\\s*$";var ne=S++;I[ne]="(<|>)?=?\\s*\\*";for(var J=0;J<35;J++)D(J,I[J]),P[J]||(P[J]=new RegExp(I[J]));function x(ce,de){if(ce instanceof T)return ce;if(typeof ce!="string"||ce.length>A||!(de?P[t]:P[h]).test(ce))return null;try{return new T(ce,de)}catch{return null}}function T(ce,de){if(ce instanceof T){if(ce.loose===de)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof T))return new T(ce,de);D("SemVer",ce,de),this.loose=de;var ge=ce.trim().match(de?P[t]:P[h]);if(!ge)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Pe=+Ce;if(Pe>=0&&Pe<O)return Pe}return Ce}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=x,e.valid=function(ce,de){var ge=x(ce,de);return ge?ge.version:null},e.clean=function(ce,de){var ge=x(ce.trim().replace(/^[=v]+/,""),de);return ge?ge.version:null},e.SemVer=T,T.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},T.prototype.toString=function(){return this.version},T.prototype.compare=function(ce){return D("SemVer.compare",this.version,this.loose,ce),ce instanceof T||(ce=new T(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},T.prototype.compareMain=function(ce){return ce instanceof T||(ce=new T(ce,this.loose)),H(this.major,ce.major)||H(this.minor,ce.minor)||H(this.patch,ce.patch)},T.prototype.comparePre=function(ce){if(ce instanceof T||(ce=new T(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var de=0;do{var ge=this.prerelease[de],Ce=ce.prerelease[de];if(D("prerelease compare",de,ge,Ce),ge===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ce)return H(ge,Ce)}while(++de)},T.prototype.inc=function(ce,de){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,de,ge,Ce){typeof ge=="string"&&(Ce=ge,ge=void 0);try{return new T(ce,ge).inc(de,Ce).version}catch{return null}},e.diff=function(ce,de){if(X(ce,de))return null;var ge=x(ce),Ce=x(de);if(ge.prerelease.length||Ce.prerelease.length){for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ce[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ce[Pe])return Pe},e.compareIdentifiers=H;var N=/^[0-9]+$/;function H(ce,de){var ge=N.test(ce),Ce=N.test(de);return ge&&Ce&&(ce=+ce,de=+de),ge&&!Ce?-1:Ce&&!ge?1:ce<de?-1:ce>de?1:0}function B(ce,de,ge){return new T(ce,ge).compare(new T(de,ge))}function Q(ce,de,ge){return B(ce,de,ge)>0}function re(ce,de,ge){return B(ce,de,ge)<0}function X(ce,de,ge){return B(ce,de,ge)===0}function te(ce,de,ge){return B(ce,de,ge)!==0}function se(ce,de,ge){return B(ce,de,ge)>=0}function le(ce,de,ge){return B(ce,de,ge)<=0}function ue(ce,de,ge,Ce){var Pe;switch(de){case"===":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce===ge;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce!==ge;break;case"":case"=":case"==":Pe=X(ce,ge,Ce);break;case"!=":Pe=te(ce,ge,Ce);break;case">":Pe=Q(ce,ge,Ce);break;case">=":Pe=se(ce,ge,Ce);break;case"<":Pe=re(ce,ge,Ce);break;case"<=":Pe=le(ce,ge,Ce);break;default:throw new TypeError("Invalid operator: "+de)}return Pe}function ye(ce,de){if(ce instanceof ye){if(ce.loose===de)return ce;ce=ce.value}if(!(this instanceof ye))return new ye(ce,de);D("comparator",ce,de),this.loose=de,this.parse(ce),this.semver===Se?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ce,de){return H(de,ce)},e.major=function(ce,de){return new T(ce,de).major},e.minor=function(ce,de){return new T(ce,de).minor},e.patch=function(ce,de){return new T(ce,de).patch},e.compare=B,e.compareLoose=function(ce,de){return B(ce,de,!0)},e.rcompare=function(ce,de,ge){return B(de,ce,ge)},e.sort=function(ce,de){return ce.sort(function(ge,Ce){return e.compare(ge,Ce,de)})},e.rsort=function(ce,de){return ce.sort(function(ge,Ce){return e.rcompare(ge,Ce,de)})},e.gt=Q,e.lt=re,e.eq=X,e.neq=te,e.gte=se,e.lte=le,e.cmp=ue,e.Comparator=ye;var Se={};function be(ce,de){if(ce instanceof be)return ce.loose===de?ce:new be(ce.raw,de);if(ce instanceof ye)return new be(ce.value,de);if(!(this instanceof be))return new be(ce,de);if(this.loose=de,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function Ee(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function Ne(ce,de,ge,Ce,Pe,Ae,De,je,Oe,Me,Be,ke,Te){return((de=Ee(ge)?"":Ee(Ce)?">="+ge+".0.0":Ee(Pe)?">="+ge+"."+Ce+".0":">="+de)+" "+(je=Ee(Oe)?"":Ee(Me)?"<"+(+Oe+1)+".0.0":Ee(Be)?"<"+Oe+"."+(+Me+1)+".0":ke?"<="+Oe+"."+Me+"."+Be+"-"+ke:"<="+je)).trim()}function Fe(ce,de){for(var ge=0;ge<ce.length;ge++)if(!ce[ge].test(de))return!1;if(de.prerelease.length){for(ge=0;ge<ce.length;ge++)if(D(ce[ge].semver),ce[ge].semver!==Se&&ce[ge].semver.prerelease.length>0){var Ce=ce[ge].semver;if(Ce.major===de.major&&Ce.minor===de.minor&&Ce.patch===de.patch)return!0}return!1}return!0}function Ye(ce,de,ge){try{de=new be(de,ge)}catch{return!1}return de.test(ce)}function ze(ce,de,ge,Ce){var Pe,Ae,De,je,Oe;switch(ce=new T(ce,Ce),de=new be(de,Ce),ge){case">":Pe=Q,Ae=le,De=re,je=">",Oe=">=";break;case"<":Pe=re,Ae=se,De=Q,je="<",Oe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ye(ce,de,Ce))return!1;for(var Me=0;Me<de.set.length;++Me){var Be=de.set[Me],ke=null,Te=null;if(Be.forEach(function(ie){ie.semver===Se&&(ie=new ye(">=0.0.0")),ke=ke||ie,Te=Te||ie,Pe(ie.semver,ke.semver,Ce)?ke=ie:De(ie.semver,Te.semver,Ce)&&(Te=ie)}),ke.operator===je||ke.operator===Oe||(!Te.operator||Te.operator===je)&&Ae(ce,Te.semver)||Te.operator===Oe&&De(ce,Te.semver))return!1}return!0}ye.prototype.parse=function(ce){var de=this.loose?P[_]:P[K],ge=ce.match(de);if(!ge)throw new TypeError("Invalid comparator: "+ce);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new T(ge[2],this.loose):this.semver=Se},ye.prototype.toString=function(){return this.value},ye.prototype.test=function(ce){return D("Comparator.test",ce,this.loose),this.semver===Se||(typeof ce=="string"&&(ce=new T(ce,this.loose)),ue(ce,this.operator,this.semver,this.loose))},ye.prototype.intersects=function(ce,de){if(!(ce instanceof ye))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new be(ce.value,de),Ye(this.value,ge,de);if(ce.operator==="")return ge=new be(this.value,de),Ye(ce.semver,ge,de);var Ce=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Ae=this.semver.version===ce.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),je=ue(this.semver,"<",ce.semver,de)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Oe=ue(this.semver,">",ce.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return Ce||Pe||Ae&&De||je||Oe},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(ce){var de=this.loose;ce=ce.trim(),D("range",ce,de);var ge=de?P[Z]:P[V];ce=ce.replace(ge,Ne),D("hyphen replace",ce),ce=ce.replace(P[q],"$1$2$3"),D("comparator trim",ce,P[q]),ce=(ce=(ce=ce.replace(P[z],"$1~")).replace(P[$],"$1^")).split(/\s+/).join(" ");var Ce=de?P[_]:P[K],Pe=ce.split(" ").map(function(Ae){return function(De,je){return D("comp",De),De=function(Oe,Me){return Oe.trim().split(/\s+/).map(function(Be){return function(ke,Te){D("caret",ke,Te);var ie=Te?P[W]:P[G];return ke.replace(ie,function(he,fe,me,we,Ie){var Re;return D("caret",ke,he,fe,me,we,Ie),Ee(fe)?Re="":Ee(me)?Re=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ee(we)?Re=fe==="0"?">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+".0 <"+(+fe+1)+".0.0":Ie?(D("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Re=fe==="0"?me==="0"?">="+fe+"."+me+"."+we+Ie+" <"+fe+"."+me+"."+(+we+1):">="+fe+"."+me+"."+we+Ie+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+we+Ie+" <"+(+fe+1)+".0.0"):(D("no pr"),Re=fe==="0"?me==="0"?">="+fe+"."+me+"."+we+" <"+fe+"."+me+"."+(+we+1):">="+fe+"."+me+"."+we+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+we+" <"+(+fe+1)+".0.0"),D("caret return",Re),Re})}(Be,Me)}).join(" ")}(De,je),D("caret",De),De=function(Oe,Me){return Oe.trim().split(/\s+/).map(function(Be){return function(ke,Te){var ie=Te?P[L]:P[F];return ke.replace(ie,function(he,fe,me,we,Ie){var Re;return D("tilde",ke,he,fe,me,we,Ie),Ee(fe)?Re="":Ee(me)?Re=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ee(we)?Re=">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":Ie?(D("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Re=">="+fe+"."+me+"."+we+Ie+" <"+fe+"."+(+me+1)+".0"):Re=">="+fe+"."+me+"."+we+" <"+fe+"."+(+me+1)+".0",D("tilde return",Re),Re})}(Be,Me)}).join(" ")}(De,je),D("tildes",De),De=function(Oe,Me){return D("replaceXRanges",Oe,Me),Oe.split(/\s+/).map(function(Be){return function(ke,Te){ke=ke.trim();var ie=Te?P[R]:P[b];return ke.replace(ie,function(he,fe,me,we,Ie,Re){D("xRange",ke,he,fe,me,we,Ie,Re);var He=Ee(me),$e=He||Ee(we),Le=$e||Ee(Ie);return fe==="="&&Le&&(fe=""),He?he=fe===">"||fe==="<"?"<0.0.0":"*":fe&&Le?($e&&(we=0),Le&&(Ie=0),fe===">"?(fe=">=",$e?(me=+me+1,we=0,Ie=0):Le&&(we=+we+1,Ie=0)):fe==="<="&&(fe="<",$e?me=+me+1:we=+we+1),he=fe+me+"."+we+"."+Ie):$e?he=">="+me+".0.0 <"+(+me+1)+".0.0":Le&&(he=">="+me+"."+we+".0 <"+me+"."+(+we+1)+".0"),D("xRange return",he),he})}(Be,Me)}).join(" ")}(De,je),D("xrange",De),De=function(Oe,Me){return D("replaceStars",Oe,Me),Oe.trim().replace(P[ne],"")}(De,je),D("stars",De),De}(Ae,de)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Ae){return!!Ae.match(Ce)})),Pe=Pe.map(function(Ae){return new ye(Ae,de)})},be.prototype.intersects=function(ce,de){if(!(ce instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ce){return ce.set.some(function(Pe){return Pe.every(function(Ae){return Ce.intersects(Ae,de)})})})})},e.toComparators=function(ce,de){return new be(ce,de).set.map(function(ge){return ge.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},be.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new T(ce,this.loose));for(var de=0;de<this.set.length;de++)if(Fe(this.set[de],ce))return!0;return!1},e.satisfies=Ye,e.maxSatisfying=function(ce,de,ge){var Ce=null,Pe=null;try{var Ae=new be(de,ge)}catch{return null}return ce.forEach(function(De){Ae.test(De)&&(Ce&&Pe.compare(De)!==-1||(Pe=new T(Ce=De,ge)))}),Ce},e.minSatisfying=function(ce,de,ge){var Ce=null,Pe=null;try{var Ae=new be(de,ge)}catch{return null}return ce.forEach(function(De){Ae.test(De)&&(Ce&&Pe.compare(De)!==1||(Pe=new T(Ce=De,ge)))}),Ce},e.validRange=function(ce,de){try{return new be(ce,de).range||"*"}catch{return null}},e.ltr=function(ce,de,ge){return ze(ce,de,"<",ge)},e.gtr=function(ce,de,ge){return ze(ce,de,">",ge)},e.outside=ze,e.prerelease=function(ce,de){var ge=x(ce,de);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ce,de,ge){return ce=new be(ce,ge),de=new be(de,ge),ce.intersects(de)},e.coerce=function(ce){if(ce instanceof T)return ce;if(typeof ce!="string")return null;var de=ce.match(P[j]);return de==null?null:x((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,k(1))},function(ee,e){var k,i,D=ee.exports={};function A(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function P(v){if(k===setTimeout)return setTimeout(v,0);if((k===A||!k)&&setTimeout)return k=setTimeout,setTimeout(v,0);try{return k(v,0)}catch{try{return k.call(null,v,0)}catch{return k.call(this,v,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:A}catch{k=A}try{i=typeof clearTimeout=="function"?clearTimeout:O}catch{i=O}})();var I,S=[],C=!1,E=-1;function w(){C&&I&&(C=!1,I.length?S=I.concat(S):E=-1,S.length&&p())}function p(){if(!C){var v=P(w);C=!0;for(var l=S.length;l;){for(I=S,S=[];++E<l;)I&&I[E].run();E=-1,l=S.length}I=null,C=!1,function(m){if(i===clearTimeout)return clearTimeout(m);if((i===O||!i)&&clearTimeout)return i=clearTimeout,clearTimeout(m);try{i(m)}catch{try{return i.call(null,m)}catch{return i.call(this,m)}}}(v)}}function f(v,l){this.fun=v,this.array=l}function y(){}D.nextTick=function(v){var l=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)l[m-1]=arguments[m];S.push(new f(v,l)),S.length!==1||C||P(p)},f.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=y,D.addListener=y,D.once=y,D.off=y,D.removeListener=y,D.removeAllListeners=y,D.emit=y,D.prependListener=y,D.prependOnceListener=y,D.listeners=function(v){return[]},D.binding=function(v){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(v){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(oe[128],ae([0,1]),function(ee,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class i{constructor(P,I,S){this.level=P,this.key=I,this.value=S,this.forward=[]}}const D=void 0;class A{constructor(P,I=2**16){this.comparator=P,this[k]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(I)|0),this.e=new i(this.c,D,D)}get size(){return this.f}clear(){this.e=new i(this.c,D,D)}has(P){return Boolean(A.g(this,P,this.comparator))}get(P){return A.g(this,P,this.comparator)?.value}set(P,I){return A.h(this,P,I,this.comparator)&&(this.f+=1),this}delete(P){const I=A.k(this,P,this.comparator);return I&&(this.f-=1),I}forEach(P,I){let S=this.e.forward[0];for(;S;)P.call(I,S.value,S.key,this),S=S.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",I=this.e.forward[0];for(;I;)P+=`node(${I.key}, ${I.value}, lvl:${I.level})`,I=I.forward[0];return P}static g(P,I,S){let C=P.e;for(let E=P.d-1;E>=0;E--)for(;C.forward[E]&&S(C.forward[E].key,I)<0;)C=C.forward[E];if(C=C.forward[0],C&&S(C.key,I)===0)return C}static h(P,I,S,C){const E=[];let w=P.e;for(let p=P.d-1;p>=0;p--){for(;w.forward[p]&&C(w.forward[p].key,I)<0;)w=w.forward[p];E[p]=w}if(w=w.forward[0],w&&C(w.key,I)===0)return w.value=S,!1;{const p=A.j(P);if(p>P.d){for(let f=P.d;f<p;f++)E[f]=P.e;P.d=p}w=new i(p,I,S);for(let f=0;f<p;f++)w.forward[f]=E[f].forward[f],E[f].forward[f]=w;return!0}}static j(P,I=.5){let S=1;for(;Math.random()<I&&S<P.c;)S+=1;return S}static k(P,I,S){const C=[];let E=P.e;for(let w=P.d-1;w>=0;w--){for(;E.forward[w]&&S(E.forward[w].key,I)<0;)E=E.forward[w];C[w]=E}if(E=E.forward[0],!E||S(E.key,I)!==0)return!1;for(let w=0;w<P.d&&C[w].forward[w]===E;w++)C[w].forward[w]=E.forward[w];for(;P.d>0&&P.e.forward[P.d-1]===D;)P.d-=1;return!0}}e.SkipList=A}),define(oe[44],ae([0,1,9,2]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(d){const h=d;return h?typeof h.read=="function":!1}e.isReadable=D;function A(d){const h=d;return h?[h.on,h.pause,h.resume,h.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=A;function O(d){const h=d;return h?A(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=O;function P(d,h){return new I(d,h)}e.newWriteableStream=P;class I{constructor(h,n){this.e=h,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(n=>n(h))}h(h){this.c.error.length===0?(0,k.onUnexpectedError)(h):this.c.error.slice(0).forEach(n=>n(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,n){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(h,n){if(this.a.destroyed)return;let r;switch(h){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(n);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function S(d,h){const n=[];let r;for(;(r=d.read())!==null;)n.push(r);return h(n)}e.consumeReadable=S;function C(d,h,n){const r=[];let t;for(;(t=d.read())!==null&&r.length<n;)r.push(t);return t===null&&r.length>0?h(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const o=t;return t=void 0,o}return d.read()}}}e.peekReadable=C;function E(d,h){return new Promise((n,r)=>{const t=[];w(d,{onData:o=>{h&&t.push(o)},onError:o=>{h?r(o):n(void 0)},onEnd:()=>{n(h?h(t):void 0)}})})}e.consumeStream=E;function w(d,h){let n=!1;return d.on("error",r=>{n||h.onError(r)}),d.on("end",()=>{n||h.onEnd()}),d.on("data",r=>{n||h.onData(r)}),(0,i.toDisposable)(()=>n=!0)}e.listenStream=w;function p(d,h){return new Promise((n,r)=>{const t=new i.DisposableStore,o=[],s=g=>{if(o.push(g),o.length>h)return t.dispose(),d.pause(),n({stream:d,buffer:o,ended:!1})},c=g=>r(g),a=()=>n({stream:d,buffer:o,ended:!0});t.add((0,i.toDisposable)(()=>d.removeListener("error",c))),d.on("error",c),t.add((0,i.toDisposable)(()=>d.removeListener("end",a))),d.on("end",a),t.add((0,i.toDisposable)(()=>d.removeListener("data",s))),d.on("data",s)})}e.peekStream=p;function f(d,h){const n=P(h);return n.end(d),n}e.toStream=f;function y(){const d=P(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=y;function v(d){let h=!1;return{read:()=>h?null:(h=!0,d)}}e.toReadable=v;function l(d,h,n){const r=P(n);return w(d,{onData:t=>r.write(h.data(t)),onError:t=>r.error(h.error?h.error(t):t),onEnd:()=>r.end()}),r}e.transform=l;function m(d,h,n){let r=!1;return{read:()=>{const t=h.read();return r?t:(r=!0,t!==null?n([d,t]):d)}}}e.prefixedReadable=m;function u(d,h,n){let r=!1;const t=P(n);return w(h,{onData:o=>r?t.write(o):(r=!0,t.write(n([d,o]))),onError:o=>t.error(o),onEnd:()=>{r||(r=!0,t.write(d)),t.end()}}),t}e.prefixedStream=u}),define(oe[17],ae([0,1,44]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer<"u";let D,A;class O{static alloc(g){return i?new O(Buffer.allocUnsafe(g)):new O(new Uint8Array(g))}static wrap(g){return i&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new O(g)}static fromString(g,b){return!(b?.dontUseNodeBuffer||!1)&&i?new O(Buffer.from(g)):(D||(D=new TextEncoder),new O(D.encode(g)))}static fromByteArray(g){const b=O.alloc(g.length);for(let R=0,j=g.length;R<j;R++)b.buffer[R]=g[R];return b}static concat(g,b){if(typeof b>"u"){b=0;for(let U=0,z=g.length;U<z;U++)b+=g[U].byteLength}const R=O.alloc(b);let j=0;for(let U=0,z=g.length;U<z;U++){const F=g[U];R.set(F,j),j+=F.byteLength}return R}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=O.alloc(this.byteLength);return g.set(this),g}toString(){return i?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(g,b){return new O(this.buffer.subarray(g,b))}set(g,b){if(g instanceof O)this.buffer.set(g.buffer,b);else if(g instanceof Uint8Array)this.buffer.set(g,b);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),b);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return S(this.buffer,g)}writeUInt32BE(g,b){C(this.buffer,g,b)}readUInt32LE(g){return E(this.buffer,g)}writeUInt32LE(g,b){w(this.buffer,g,b)}readUInt8(g){return p(this.buffer,g)}writeUInt8(g,b){f(this.buffer,g,b)}}e.VSBuffer=O;function P(a,g){return a[g+0]<<0>>>0|a[g+1]<<8>>>0}e.readUInt16LE=P;function I(a,g,b){a[b+0]=g&255,g=g>>>8,a[b+1]=g&255}e.writeUInt16LE=I;function S(a,g){return a[g]*2**24+a[g+1]*2**16+a[g+2]*2**8+a[g+3]}e.readUInt32BE=S;function C(a,g,b){a[b+3]=g,g=g>>>8,a[b+2]=g,g=g>>>8,a[b+1]=g,g=g>>>8,a[b]=g}e.writeUInt32BE=C;function E(a,g){return a[g+0]<<0>>>0|a[g+1]<<8>>>0|a[g+2]<<16>>>0|a[g+3]<<24>>>0}e.readUInt32LE=E;function w(a,g,b){a[b+0]=g&255,g=g>>>8,a[b+1]=g&255,g=g>>>8,a[b+2]=g&255,g=g>>>8,a[b+3]=g&255}e.writeUInt32LE=w;function p(a,g){return a[g]}e.readUInt8=p;function f(a,g,b){a[b]=g}e.writeUInt8=f;function y(a){return k.consumeReadable(a,g=>O.concat(g))}e.readableToBuffer=y;function v(a){return k.toReadable(a)}e.bufferToReadable=v;function l(a){return k.consumeStream(a,g=>O.concat(g))}e.streamToBuffer=l;async function m(a){return a.ended?O.concat(a.buffer):O.concat([...a.buffer,await l(a.stream)])}e.bufferedStreamToBuffer=m;function u(a){return k.toStream(a,g=>O.concat(g))}e.bufferToStream=u;function d(a){return k.transform(a,{data:g=>typeof g=="string"?O.fromString(g):O.wrap(g)},g=>O.concat(g))}e.streamToBufferReadableStream=d;function h(a){return k.newWriteableStream(g=>O.concat(g),a)}e.newWriteableBufferStream=h;function n(a,g){return k.prefixedReadable(a,g,b=>O.concat(b))}e.prefixedBufferReadable=n;function r(a,g){return k.prefixedStream(a,g,b=>O.concat(b))}e.prefixedBufferStream=r;function t(a){let g=0,b=0,R=0;const j=new Uint8Array(Math.floor(a.length/4*3)),U=F=>{switch(b){case 3:j[R++]=g|F,b=0;break;case 2:j[R++]=g|F>>>2,g=F<<6,b=3;break;case 1:j[R++]=g|F>>>4,g=F<<4,b=2;break;default:g=F<<2,b=1}};for(let F=0;F<a.length;F++){const L=a.charCodeAt(F);if(L>=65&&L<=90)U(L-65);else if(L>=97&&L<=122)U(L-97+26);else if(L>=48&&L<=57)U(L-48+52);else if(L===43||L===45)U(62);else if(L===47||L===95)U(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${a[F]}`)}}const z=R;for(;b>0;)U(0);return O.wrap(j).slice(0,z)}e.decodeBase64=t;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:a},g=!0,b=!1){const R=b?s:o;let j="";const U=a.byteLength%3;let z=0;for(;z<a.byteLength-U;z+=3){const F=a[z+0],L=a[z+1],M=a[z+2];j+=R[F>>>2],j+=R[(F<<4|L>>>4)&63],j+=R[(L<<2|M>>>6)&63],j+=R[M&63]}if(U===1){const F=a[z+0];j+=R[F>>>2],j+=R[F<<4&63],g&&(j+="==")}else if(U===2){const F=a[z+0],L=a[z+1];j+=R[F>>>2],j+=R[(F<<4|L>>>4)&63],j+=R[L<<2&63],g&&(j+="=")}return j}e.encodeBase64=c}),define(oe[14],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function k(r){return typeof r=="string"}e.isString=k;function i(r){return Array.isArray(r)&&r.every(t=>k(t))}e.isStringArray=i;function D(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=D;function A(r){const t=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof t}e.isTypedArray=A;function O(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=O;function P(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=P;function I(r){return r===!0||r===!1}e.isBoolean=I;function S(r){return typeof r>"u"}e.isUndefined=S;function C(r){return!E(r)}e.isDefined=C;function E(r){return S(r)||r===null}e.isUndefinedOrNull=E;function w(r,t){if(!r)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=w;function p(r){if(E(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=p;function f(...r){const t=[];for(let o=0;o<r.length;o++){const s=r[o];if(E(s))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(s)}return t}e.assertAllDefined=f;const y=Object.prototype.hasOwnProperty;function v(r){if(!D(r))return!1;for(const t in r)if(y.call(r,t))return!1;return!0}e.isEmptyObject=v;function l(r){return typeof r=="function"}e.isFunction=l;function m(...r){return r.length>0&&r.every(l)}e.areFunctions=m;function u(r,t){const o=Math.min(r.length,t.length);for(let s=0;s<o;s++)d(r[s],t[s])}e.validateConstraints=u;function d(r,t){if(k(t)){if(typeof r!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(l(t)){try{if(r instanceof t)return}catch{}if(!E(r)&&r.constructor===t||t.length===1&&t.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=d;function h(r){return r===null?void 0:r}e.withNullAsUndefined=h;function n(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=n}),define(oe[32],ae([0,1,14]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const m=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([u,d])=>{m[u]=d&&typeof d=="object"?i(d):d}),m}e.deepClone=i;function D(l){if(!l||typeof l!="object")return l;const m=[l];for(;m.length>0;){const u=m.shift();Object.freeze(u);for(const d in u)if(A.call(u,d)){const h=u[d];typeof h=="object"&&!Object.isFrozen(h)&&!(0,k.isTypedArray)(h)&&m.push(h)}}return l}e.deepFreeze=D;const A=Object.prototype.hasOwnProperty;function O(l,m){return P(l,m,new Set)}e.cloneAndChange=O;function P(l,m,u){if((0,k.isUndefinedOrNull)(l))return l;const d=m(l);if(typeof d<"u")return d;if(Array.isArray(l)){const h=[];for(const n of l)h.push(P(n,m,u));return h}if((0,k.isObject)(l)){if(u.has(l))throw new Error("Cannot clone recursive data-structure");u.add(l);const h={};for(const n in l)A.call(l,n)&&(h[n]=P(l[n],m,u));return u.delete(l),h}return l}function I(l,m,u=!0){return(0,k.isObject)(l)?((0,k.isObject)(m)&&Object.keys(m).forEach(d=>{d in l?u&&((0,k.isObject)(l[d])&&(0,k.isObject)(m[d])?I(l[d],m[d],u):l[d]=m[d]):l[d]=m[d]}),l):m}e.mixin=I;function S(l,m){if(l===m)return!0;if(l==null||m===null||m===void 0||typeof l!=typeof m||typeof l!="object"||Array.isArray(l)!==Array.isArray(m))return!1;let u,d;if(Array.isArray(l)){if(l.length!==m.length)return!1;for(u=0;u<l.length;u++)if(!S(l[u],m[u]))return!1}else{const h=[];for(d in l)h.push(d);h.sort();const n=[];for(d in m)n.push(d);if(n.sort(),!S(h,n))return!1;for(u=0;u<h.length;u++)if(!S(l[h[u]],m[h[u]]))return!1}return!0}e.equals=S;function C(l){const m=new Set;return JSON.stringify(l,(u,d)=>{if((0,k.isObject)(d)||Array.isArray(d)){if(m.has(d))return"[Circular]";m.add(d)}return d})}e.safeStringify=C;function E(l,m){const u=Object.create(null);return!l||!m||Object.keys(m).forEach(h=>{const n=l[h],r=m[h];S(n,r)||(u[h]=r)}),u}e.distinct=E;function w(l,m){const u=m.toLowerCase(),d=Object.keys(l).find(h=>h.toLowerCase()===u);return d?l[d]:l[m]}e.getCaseInsensitive=w;function p(l,m){const u=Object.create(null);for(const[d,h]of Object.entries(l))m(d,h)&&(u[d]=h);return u}e.filter=p;function f(l){let m=[],u=Object.getPrototypeOf(l);for(;Object.prototype!==u;)m=m.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return m}e.getAllPropertyNames=f;function y(l){const m=[];for(const u of f(l))typeof l[u]=="function"&&m.push(u);return m}e.getAllMethodNames=y;function v(l,m){const u=h=>function(){const n=Array.prototype.slice.call(arguments,0);return m(h,n)},d={};for(const h of l)d[h]=u(h);return d}e.createProxyObject=v}),define(oe[31],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(D){return k.test(D)}e.isUUID=i,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(P){for(let I=0;I<P.length;I++)P[I]=Math.floor(Math.random()*256);return P};const A=new Uint8Array(16),O=[];for(let P=0;P<256;P++)O.push(P.toString(16).padStart(2,"0"));return function(){D(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let I=0,S="";return S+=O[A[I++]],S+=O[A[I++]],S+=O[A[I++]],S+=O[A[I++]],S+="-",S+=O[A[I++]],S+=O[A[I++]],S+="-",S+=O[A[I++]],S+=O[A[I++]],S+="-",S+=O[A[I++]],S+=O[A[I++]],S+="-",S+=O[A[I++]],S+=O[A[I++]],S+=O[A[I++]],S+=O[A[I++]],S+=O[A[I++]],S+=O[A[I++]],S}}()}),define(oe[129],ae([0,1,34]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const i=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(O){const P=O.replace(/\-/g,":").toLowerCase();return!i.has(P)}function A(){const O=(0,k.networkInterfaces)();for(const P in O){const I=O[P];if(I){for(const{mac:S}of I)if(D(S))return S}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(oe[130],ae([0,1,86]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function i(P,I,S,C=1){let E=!1;return new Promise(w=>{const p=setTimeout(()=>{if(!E)return E=!0,w(0)},S);D(P,I,C,f=>{if(!E)return E=!0,clearTimeout(p),w(f)})})}e.findFreePort=i;function D(P,I,S,C){if(I===0)return C(0);const E=new k.Socket;E.once("connect",()=>(O(E),D(P+S,I-1,S,C))),E.once("data",()=>{}),E.once("error",w=>(O(E),w.code!=="ECONNREFUSED"?D(P+S,I-1,S,C):C(P))),E.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(P,I,S,C="127.0.0.1"){let E=!1,w,p=1;const f=k.createServer({pauseOnConnect:!0});function y(v,l){E||(E=!0,f.removeAllListeners(),f.close(),w&&clearTimeout(w),l(v))}return new Promise(v=>{w=setTimeout(()=>{y(0,v)},S),f.on("listening",()=>{y(P,v)}),f.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&p<I?(P++,p++,f.listen(P,C)):y(0,v)}),f.on("close",()=>{y(0,v)}),f.listen(P,C)})}e.findFreePortFaster=A;function O(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(I){console.error(I)}}}),define(oe[131],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const k="Offline";function i(A){return A instanceof D?!0:A instanceof Error&&A.name===k&&A.message===k}e.isOfflineError=i;class D extends Error{constructor(){super(k),this.name=this.message}}e.OfflineError=D}),define(oe[132],ae([0,1,17,9,131]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function A(I,S){if(!navigator.onLine)throw new D.OfflineError;I.proxyAuthorization&&(I.headers={...I.headers||{},"Proxy-Authorization":I.proxyAuthorization});const C=new XMLHttpRequest;return new Promise((E,w)=>{C.open(I.type||"GET",I.url||"",!0,I.user,I.password),O(C,I),C.responseType="arraybuffer",C.onerror=p=>w(new Error(C.statusText&&"XHR failed: "+C.statusText||"XHR failed")),C.onload=p=>{E({res:{statusCode:C.status,headers:P(C)},stream:(0,k.bufferToStream)(k.VSBuffer.wrap(new Uint8Array(C.response)))})},C.ontimeout=p=>w(new Error(`XHR timeout: ${I.timeout}ms`)),I.timeout&&(C.timeout=I.timeout),C.send(I.data),S.onCancellationRequested(()=>{C.abort(),w((0,i.canceled)())})})}e.request=A;function O(I,S){if(S.headers){e:for(const C in S.headers){switch(C){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}I.setRequestHeader(C,S.headers[C])}}}function P(I){const S=Object.create(null);for(const C of I.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(C){const E=C.indexOf(":");S[C.substr(0,E).trim().toLowerCase()]=C.substr(E+1).trim()}return S}}),define(oe[133],ae([10,11]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(oe[65],ae([0,1,133]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,D=i*60,A=D*24,O=A*7,P=A*30,I=A*365;function S(E,w,p){typeof E!="number"&&(E=E.getTime());const f=Math.round((new Date().getTime()-E)/1e3);if(f<-30)return(0,k.localize)(0,null,S(new Date().getTime()+f*1e3,!1));if(f<30)return(0,k.localize)(1,null);let y;return f<i?(y=f,w?y===1?p?(0,k.localize)(2,null,y):(0,k.localize)(3,null,y):p?(0,k.localize)(4,null,y):(0,k.localize)(5,null,y):y===1?p?(0,k.localize)(6,null,y):(0,k.localize)(7,null,y):p?(0,k.localize)(8,null,y):(0,k.localize)(9,null,y)):f<D?(y=Math.floor(f/i),w?y===1?p?(0,k.localize)(10,null,y):(0,k.localize)(11,null,y):p?(0,k.localize)(12,null,y):(0,k.localize)(13,null,y):y===1?p?(0,k.localize)(14,null,y):(0,k.localize)(15,null,y):p?(0,k.localize)(16,null,y):(0,k.localize)(17,null,y)):f<A?(y=Math.floor(f/D),w?y===1?p?(0,k.localize)(18,null,y):(0,k.localize)(19,null,y):p?(0,k.localize)(20,null,y):(0,k.localize)(21,null,y):y===1?p?(0,k.localize)(22,null,y):(0,k.localize)(23,null,y):p?(0,k.localize)(24,null,y):(0,k.localize)(25,null,y)):f<O?(y=Math.floor(f/A),w?y===1?(0,k.localize)(26,null,y):(0,k.localize)(27,null,y):y===1?(0,k.localize)(28,null,y):(0,k.localize)(29,null,y)):f<P?(y=Math.floor(f/O),w?y===1?p?(0,k.localize)(30,null,y):(0,k.localize)(31,null,y):p?(0,k.localize)(32,null,y):(0,k.localize)(33,null,y):y===1?p?(0,k.localize)(34,null,y):(0,k.localize)(35,null,y):p?(0,k.localize)(36,null,y):(0,k.localize)(37,null,y)):f<I?(y=Math.floor(f/P),w?y===1?p?(0,k.localize)(38,null,y):(0,k.localize)(39,null,y):p?(0,k.localize)(40,null,y):(0,k.localize)(41,null,y):y===1?p?(0,k.localize)(42,null,y):(0,k.localize)(43,null,y):p?(0,k.localize)(44,null,y):(0,k.localize)(45,null,y)):(y=Math.floor(f/I),w?y===1?p?(0,k.localize)(46,null,y):(0,k.localize)(47,null,y):p?(0,k.localize)(48,null,y):(0,k.localize)(49,null,y):y===1?p?(0,k.localize)(50,null,y):(0,k.localize)(51,null,y):p?(0,k.localize)(52,null,y):(0,k.localize)(53,null,y))}e.fromNow=S;function C(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=C}),define(oe[134],ae([10,11]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,20,14,134]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(E,w){return w&&(E.stack||E.stacktrace)?D.localize(0,null,P(E),O(E.stack)||O(E.stacktrace)):P(E)}function O(E){return Array.isArray(E)?E.join(`
`):E}function P(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?D.localize(1,null,E.message):E.message||D.localize(2,null)}function I(E=null,w=!1){if(!E)return D.localize(3,null);if(Array.isArray(E)){const p=k.coalesce(E),f=I(p[0],w);return p.length>1?D.localize(4,null,f,p.length):f}if(i.isString(E))return E;if(E.detail){const p=E.detail;if(p.error)return A(p.error,w);if(p.exception)return A(p.exception,w)}return E.stack?A(E,w):E.message?E.message:D.localize(5,null)}e.toErrorMessage=I;function S(E){const w=E;return w instanceof Error&&Array.isArray(w.actions)}e.isErrorWithActions=S;function C(E,w){let p;return typeof E=="string"?p=new Error(E):p=E,p.actions=w,p}e.createErrorWithActions=C}),define(oe[135],ae([10,11]),function(ee,e){return ee.create("vs/base/common/jsonErrorMessages",e)}),define(oe[136],ae([0,1,135]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function i(D){switch(D){case 1:return(0,k.localize)(0,null);case 2:return(0,k.localize)(1,null);case 3:return(0,k.localize)(2,null);case 4:return(0,k.localize)(3,null);case 5:return(0,k.localize)(4,null);case 6:return(0,k.localize)(5,null);case 7:return(0,k.localize)(6,null);case 8:return(0,k.localize)(7,null);case 9:return(0,k.localize)(8,null);default:return""}}e.getParseErrorMessage=i}),define(oe[137],ae([10,11]),function(ee,e){return ee.create("vs/base/common/platform",e)}),define(oe[5],ae([0,1,137]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let i=!1,D=!1,A=!1,O=!1,P=!1,I=!1,S=!1,C=!1,E=!1,w=!1,p,f=e.LANGUAGE_DEFAULT,y,v;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?l=e.globals.vscode.process:typeof process<"u"&&(l=process);const m=typeof l?.versions?.electron=="string",u=m&&l?.type==="renderer";if(typeof navigator=="object"&&!u)v=navigator.userAgent,i=v.indexOf("Windows")>=0,D=v.indexOf("Macintosh")>=0,C=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=v.indexOf("Linux")>=0,w=v?.indexOf("Mobi")>=0,I=!0,p=k.getConfiguredDefaultLocale(k.localize(0,null))||e.LANGUAGE_DEFAULT,f=p;else if(typeof l=="object"){i=l.platform==="win32",D=l.platform==="darwin",A=l.platform==="linux",O=A&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,S=m,E=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,p=e.LANGUAGE_DEFAULT,f=e.LANGUAGE_DEFAULT;const a=l.env.VSCODE_NLS_CONFIG;if(a)try{const g=JSON.parse(a),b=g.availableLanguages["*"];p=g.locale,f=b||e.LANGUAGE_DEFAULT,y=g._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var d;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(d=e.Platform||(e.Platform={}));function h(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=h;let n=0;D?n=1:i?n=3:A&&(n=2),e.isWindows=i,e.isMacintosh=D,e.isLinux=A,e.isLinuxSnap=O,e.isNative=P,e.isElectron=S,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=C,e.isMobile=w,e.isCI=E,e.platform=n,e.userAgent=v,e.language=f;var r;(function(a){function g(){return e.language}a.value=g;function b(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=b;function R(){return e.language==="en"}a.isDefault=R})(r=e.Language||(e.Language={})),e.locale=p,e.translationsConfigFile=y,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",b=>{if(b.data&&b.data.vscodeScheduleAsyncWork)for(let R=0,j=a.length;R<j;R++){const U=a[R];if(U.id===b.data.vscodeScheduleAsyncWork){a.splice(R,1),U.callback();return}}});let g=0;return b=>{const R=++g;a.push({id:R,callback:b}),e.globals.postMessage({vscodeScheduleAsyncWork:R},"*")}}return a=>setTimeout(a)})();var t;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||C?2:i?1:3;let o=!0,s=!1;function c(){if(!s){s=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,o=new Uint16Array(a.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(oe[36],ae([0,1,5]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof k.globals.vscode<"u"&&typeof k.globals.vscode.process<"u"){const D=k.globals.vscode.process;i={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(oe[12],ae([0,1,36]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,D=97,A=90,O=122,P=46,I=47,S=92,C=58,E=63;class w extends Error{constructor(d,h,n){let r;typeof h=="string"&&h.indexOf("not ")===0?(r="must not be",h=h.replace(/^not /,"")):r="must be";const t=d.indexOf(".")!==-1?"property":"argument";let o=`The "${d}" ${t} ${r} of type ${h}`;o+=`. Received type ${typeof n}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function p(u,d){if(typeof u!="string")throw new w(d,"string",u)}function f(u){return u===I||u===S}function y(u){return u===I}function v(u){return u>=i&&u<=A||u>=D&&u<=O}function l(u,d,h,n){let r="",t=0,o=-1,s=0,c=0;for(let a=0;a<=u.length;++a){if(a<u.length)c=u.charCodeAt(a);else{if(n(c))break;c=I}if(n(c)){if(!(o===a-1||s===1))if(s===2){if(r.length<2||t!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const g=r.lastIndexOf(h);g===-1?(r="",t=0):(r=r.slice(0,g),t=r.length-1-r.lastIndexOf(h)),o=a,s=0;continue}else if(r.length!==0){r="",t=0,o=a,s=0;continue}}d&&(r+=r.length>0?`${h}..`:"..",t=2)}else r.length>0?r+=`${h}${u.slice(o+1,a)}`:r=u.slice(o+1,a),t=a-o-1;o=a,s=0}else c===P&&s!==-1?++s:s=-1}return r}function m(u,d){if(d===null||typeof d!="object")throw new w("pathObject","Object",d);const h=d.dir||d.root,n=d.base||`${d.name||""}${d.ext||""}`;return h?h===d.root?`${h}${n}`:`${h}${u}${n}`:n}e.win32={resolve(...u){let d="",h="",n=!1;for(let r=u.length-1;r>=-1;r--){let t;if(r>=0){if(t=u[r],p(t,"path"),t.length===0)continue}else d.length===0?t=k.cwd():(t=k.env[`=${d}`]||k.cwd(),(t===void 0||t.slice(0,2).toLowerCase()!==d.toLowerCase()&&t.charCodeAt(2)===S)&&(t=`${d}\\`));const o=t.length;let s=0,c="",a=!1;const g=t.charCodeAt(0);if(o===1)f(g)&&(s=1,a=!0);else if(f(g))if(a=!0,f(t.charCodeAt(1))){let b=2,R=b;for(;b<o&&!f(t.charCodeAt(b));)b++;if(b<o&&b!==R){const j=t.slice(R,b);for(R=b;b<o&&f(t.charCodeAt(b));)b++;if(b<o&&b!==R){for(R=b;b<o&&!f(t.charCodeAt(b));)b++;(b===o||b!==R)&&(c=`\\\\${j}\\${t.slice(R,b)}`,s=b)}}}else s=1;else v(g)&&t.charCodeAt(1)===C&&(c=t.slice(0,2),s=2,o>2&&f(t.charCodeAt(2))&&(a=!0,s=3));if(c.length>0)if(d.length>0){if(c.toLowerCase()!==d.toLowerCase())continue}else d=c;if(n){if(d.length>0)break}else if(h=`${t.slice(s)}\\${h}`,n=a,a&&d.length>0)break}return h=l(h,!n,"\\",f),n?`${d}\\${h}`:`${d}${h}`||"."},normalize(u){p(u,"path");const d=u.length;if(d===0)return".";let h=0,n,r=!1;const t=u.charCodeAt(0);if(d===1)return y(t)?"\\":u;if(f(t))if(r=!0,f(u.charCodeAt(1))){let s=2,c=s;for(;s<d&&!f(u.charCodeAt(s));)s++;if(s<d&&s!==c){const a=u.slice(c,s);for(c=s;s<d&&f(u.charCodeAt(s));)s++;if(s<d&&s!==c){for(c=s;s<d&&!f(u.charCodeAt(s));)s++;if(s===d)return`\\\\${a}\\${u.slice(c)}\\`;s!==c&&(n=`\\\\${a}\\${u.slice(c,s)}`,h=s)}}}else h=1;else v(t)&&u.charCodeAt(1)===C&&(n=u.slice(0,2),h=2,d>2&&f(u.charCodeAt(2))&&(r=!0,h=3));let o=h<d?l(u.slice(h),!r,"\\",f):"";return o.length===0&&!r&&(o="."),o.length>0&&f(u.charCodeAt(d-1))&&(o+="\\"),n===void 0?r?`\\${o}`:o:r?`${n}\\${o}`:`${n}${o}`},isAbsolute(u){p(u,"path");const d=u.length;if(d===0)return!1;const h=u.charCodeAt(0);return f(h)||d>2&&v(h)&&u.charCodeAt(1)===C&&f(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let d,h;for(let t=0;t<u.length;++t){const o=u[t];p(o,"path"),o.length>0&&(d===void 0?d=h=o:d+=`\\${o}`)}if(d===void 0)return".";let n=!0,r=0;if(typeof h=="string"&&f(h.charCodeAt(0))){++r;const t=h.length;t>1&&f(h.charCodeAt(1))&&(++r,t>2&&(f(h.charCodeAt(2))?++r:n=!1))}if(n){for(;r<d.length&&f(d.charCodeAt(r));)r++;r>=2&&(d=`\\${d.slice(r)}`)}return e.win32.normalize(d)},relative(u,d){if(p(u,"from"),p(d,"to"),u===d)return"";const h=e.win32.resolve(u),n=e.win32.resolve(d);if(h===n||(u=h.toLowerCase(),d=n.toLowerCase(),u===d))return"";let r=0;for(;r<u.length&&u.charCodeAt(r)===S;)r++;let t=u.length;for(;t-1>r&&u.charCodeAt(t-1)===S;)t--;const o=t-r;let s=0;for(;s<d.length&&d.charCodeAt(s)===S;)s++;let c=d.length;for(;c-1>s&&d.charCodeAt(c-1)===S;)c--;const a=c-s,g=o<a?o:a;let b=-1,R=0;for(;R<g;R++){const U=u.charCodeAt(r+R);if(U!==d.charCodeAt(s+R))break;U===S&&(b=R)}if(R!==g){if(b===-1)return n}else{if(a>g){if(d.charCodeAt(s+R)===S)return n.slice(s+R+1);if(R===2)return n.slice(s+R)}o>g&&(u.charCodeAt(r+R)===S?b=R:R===2&&(b=3)),b===-1&&(b=0)}let j="";for(R=r+b+1;R<=t;++R)(R===t||u.charCodeAt(R)===S)&&(j+=j.length===0?"..":"\\..");return s+=b,j.length>0?`${j}${n.slice(s,c)}`:(n.charCodeAt(s)===S&&++s,n.slice(s,c))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const d=e.win32.resolve(u);if(d.length<=2)return u;if(d.charCodeAt(0)===S){if(d.charCodeAt(1)===S){const h=d.charCodeAt(2);if(h!==E&&h!==P)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(v(d.charCodeAt(0))&&d.charCodeAt(1)===C&&d.charCodeAt(2)===S)return`\\\\?\\${d}`;return u},dirname(u){p(u,"path");const d=u.length;if(d===0)return".";let h=-1,n=0;const r=u.charCodeAt(0);if(d===1)return f(r)?u:".";if(f(r)){if(h=n=1,f(u.charCodeAt(1))){let s=2,c=s;for(;s<d&&!f(u.charCodeAt(s));)s++;if(s<d&&s!==c){for(c=s;s<d&&f(u.charCodeAt(s));)s++;if(s<d&&s!==c){for(c=s;s<d&&!f(u.charCodeAt(s));)s++;if(s===d)return u;s!==c&&(h=n=s+1)}}}}else v(r)&&u.charCodeAt(1)===C&&(h=d>2&&f(u.charCodeAt(2))?3:2,n=h);let t=-1,o=!0;for(let s=d-1;s>=n;--s)if(f(u.charCodeAt(s))){if(!o){t=s;break}}else o=!1;if(t===-1){if(h===-1)return".";t=h}return u.slice(0,t)},basename(u,d){d!==void 0&&p(d,"ext"),p(u,"path");let h=0,n=-1,r=!0,t;if(u.length>=2&&v(u.charCodeAt(0))&&u.charCodeAt(1)===C&&(h=2),d!==void 0&&d.length>0&&d.length<=u.length){if(d===u)return"";let o=d.length-1,s=-1;for(t=u.length-1;t>=h;--t){const c=u.charCodeAt(t);if(f(c)){if(!r){h=t+1;break}}else s===-1&&(r=!1,s=t+1),o>=0&&(c===d.charCodeAt(o)?--o===-1&&(n=t):(o=-1,n=s))}return h===n?n=s:n===-1&&(n=u.length),u.slice(h,n)}for(t=u.length-1;t>=h;--t)if(f(u.charCodeAt(t))){if(!r){h=t+1;break}}else n===-1&&(r=!1,n=t+1);return n===-1?"":u.slice(h,n)},extname(u){p(u,"path");let d=0,h=-1,n=0,r=-1,t=!0,o=0;u.length>=2&&u.charCodeAt(1)===C&&v(u.charCodeAt(0))&&(d=n=2);for(let s=u.length-1;s>=d;--s){const c=u.charCodeAt(s);if(f(c)){if(!t){n=s+1;break}continue}r===-1&&(t=!1,r=s+1),c===P?h===-1?h=s:o!==1&&(o=1):h!==-1&&(o=-1)}return h===-1||r===-1||o===0||o===1&&h===r-1&&h===n+1?"":u.slice(h,r)},format:m.bind(null,"\\"),parse(u){p(u,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return d;const h=u.length;let n=0,r=u.charCodeAt(0);if(h===1)return f(r)?(d.root=d.dir=u,d):(d.base=d.name=u,d);if(f(r)){if(n=1,f(u.charCodeAt(1))){let b=2,R=b;for(;b<h&&!f(u.charCodeAt(b));)b++;if(b<h&&b!==R){for(R=b;b<h&&f(u.charCodeAt(b));)b++;if(b<h&&b!==R){for(R=b;b<h&&!f(u.charCodeAt(b));)b++;b===h?n=b:b!==R&&(n=b+1)}}}}else if(v(r)&&u.charCodeAt(1)===C){if(h<=2)return d.root=d.dir=u,d;if(n=2,f(u.charCodeAt(2))){if(h===3)return d.root=d.dir=u,d;n=3}}n>0&&(d.root=u.slice(0,n));let t=-1,o=n,s=-1,c=!0,a=u.length-1,g=0;for(;a>=n;--a){if(r=u.charCodeAt(a),f(r)){if(!c){o=a+1;break}continue}s===-1&&(c=!1,s=a+1),r===P?t===-1?t=a:g!==1&&(g=1):t!==-1&&(g=-1)}return s!==-1&&(t===-1||g===0||g===1&&t===s-1&&t===o+1?d.base=d.name=u.slice(o,s):(d.name=u.slice(o,t),d.base=u.slice(o,s),d.ext=u.slice(t,s))),o>0&&o!==n?d.dir=u.slice(0,o-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let d="",h=!1;for(let n=u.length-1;n>=-1&&!h;n--){const r=n>=0?u[n]:k.cwd();p(r,"path"),r.length!==0&&(d=`${r}/${d}`,h=r.charCodeAt(0)===I)}return d=l(d,!h,"/",y),h?`/${d}`:d.length>0?d:"."},normalize(u){if(p(u,"path"),u.length===0)return".";const d=u.charCodeAt(0)===I,h=u.charCodeAt(u.length-1)===I;return u=l(u,!d,"/",y),u.length===0?d?"/":h?"./":".":(h&&(u+="/"),d?`/${u}`:u)},isAbsolute(u){return p(u,"path"),u.length>0&&u.charCodeAt(0)===I},join(...u){if(u.length===0)return".";let d;for(let h=0;h<u.length;++h){const n=u[h];p(n,"path"),n.length>0&&(d===void 0?d=n:d+=`/${n}`)}return d===void 0?".":e.posix.normalize(d)},relative(u,d){if(p(u,"from"),p(d,"to"),u===d||(u=e.posix.resolve(u),d=e.posix.resolve(d),u===d))return"";const h=1,n=u.length,r=n-h,t=1,o=d.length-t,s=r<o?r:o;let c=-1,a=0;for(;a<s;a++){const b=u.charCodeAt(h+a);if(b!==d.charCodeAt(t+a))break;b===I&&(c=a)}if(a===s)if(o>s){if(d.charCodeAt(t+a)===I)return d.slice(t+a+1);if(a===0)return d.slice(t+a)}else r>s&&(u.charCodeAt(h+a)===I?c=a:a===0&&(c=0));let g="";for(a=h+c+1;a<=n;++a)(a===n||u.charCodeAt(a)===I)&&(g+=g.length===0?"..":"/..");return`${g}${d.slice(t+c)}`},toNamespacedPath(u){return u},dirname(u){if(p(u,"path"),u.length===0)return".";const d=u.charCodeAt(0)===I;let h=-1,n=!0;for(let r=u.length-1;r>=1;--r)if(u.charCodeAt(r)===I){if(!n){h=r;break}}else n=!1;return h===-1?d?"/":".":d&&h===1?"//":u.slice(0,h)},basename(u,d){d!==void 0&&p(d,"ext"),p(u,"path");let h=0,n=-1,r=!0,t;if(d!==void 0&&d.length>0&&d.length<=u.length){if(d===u)return"";let o=d.length-1,s=-1;for(t=u.length-1;t>=0;--t){const c=u.charCodeAt(t);if(c===I){if(!r){h=t+1;break}}else s===-1&&(r=!1,s=t+1),o>=0&&(c===d.charCodeAt(o)?--o===-1&&(n=t):(o=-1,n=s))}return h===n?n=s:n===-1&&(n=u.length),u.slice(h,n)}for(t=u.length-1;t>=0;--t)if(u.charCodeAt(t)===I){if(!r){h=t+1;break}}else n===-1&&(r=!1,n=t+1);return n===-1?"":u.slice(h,n)},extname(u){p(u,"path");let d=-1,h=0,n=-1,r=!0,t=0;for(let o=u.length-1;o>=0;--o){const s=u.charCodeAt(o);if(s===I){if(!r){h=o+1;break}continue}n===-1&&(r=!1,n=o+1),s===P?d===-1?d=o:t!==1&&(t=1):d!==-1&&(t=-1)}return d===-1||n===-1||t===0||t===1&&d===n-1&&d===h+1?"":u.slice(d,n)},format:m.bind(null,"/"),parse(u){p(u,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return d;const h=u.charCodeAt(0)===I;let n;h?(d.root="/",n=1):n=0;let r=-1,t=0,o=-1,s=!0,c=u.length-1,a=0;for(;c>=n;--c){const g=u.charCodeAt(c);if(g===I){if(!s){t=c+1;break}continue}o===-1&&(s=!1,o=c+1),g===P?r===-1?r=c:a!==1&&(a=1):r!==-1&&(a=-1)}if(o!==-1){const g=t===0&&h?1:t;r===-1||a===0||a===1&&r===o-1&&r===t+1?d.base=d.name=u.slice(g,o):(d.name=u.slice(g,r),d.base=u.slice(g,o),d.ext=u.slice(r,o))}return t>0?d.dir=u.slice(0,t-1):h&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=k.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=k.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=k.platform==="win32"?e.win32.join:e.posix.join,e.resolve=k.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=k.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=k.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=k.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=k.platform==="win32"?e.win32.extname:e.posix.extname,e.format=k.platform==="win32"?e.win32.format:e.posix.format,e.parse=k.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=k.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=k.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=k.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(oe[138],ae([0,1,12]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(C){const E=(0,k.extname)(C),w=i[E.toLowerCase()];return w!==void 0?w:O(C)}e.getMediaOrTextMime=A;function O(C){const E=(0,k.extname)(C);return D[E.toLowerCase()]}e.getMediaMime=O;function P(C){for(const E in D)if(D[E]===C)return E}e.getExtensionForMimeType=P;const I=/^(.+)\/(.+?)(;.+)?$/;function S(C,E){const w=I.exec(C);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:E?void 0:C}e.normalizeMimeType=S}),define(oe[87],ae([0,1,5]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var i;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(i=e.Source||(e.Source={}));var D;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(P,...I){const S=I.reduce((w,p)=>(w[p]=!0,w),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(w=>!S[w]).forEach(w=>{for(let p=0;p<C.length;p++)if(w.search(C[p])!==-1){delete P[w];break}})}e.sanitizeProcessEnvironment=A;function O(P){!P||(delete P.DEBUG,k.isMacintosh&&delete P.DYLD_LIBRARY_PATH,k.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=O}),define(oe[139],ae([0,1,5]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=k.globals.performance&&typeof k.globals.performance.now=="function";class D{static create(O=!0){return new D(O)}constructor(O){this.a=i&&O,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?k.globals.performance.now():Date.now()}}e.StopWatch=D}),define(oe[3],ae([0,1,9,82,2,84,139]),function(ee,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,I=!1;var S;(function(c){c.None=()=>D.Disposable.None;function a(B){if(I){const{onDidAddListener:Q}=B,re=f.create();let X=0;B.onDidAddListener=()=>{++X===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),re.print()),Q?.()}}}function g(B,Q){return $(B,()=>{},0,void 0,void 0,Q)}c.defer=g;function b(B){return(Q,re=null,X)=>{let te=!1,se;return se=B(le=>{if(!te)return se?se.dispose():te=!0,Q.call(re,le)},null,X),te&&se.dispose(),se}}c.once=b;function R(B,Q,re){return M((X,te=null,se)=>B(le=>X.call(te,Q(le)),null,se),re)}c.map=R;function j(B,Q,re){return M((X,te=null,se)=>B(le=>{Q(le),X.call(te,le)},null,se),re)}c.forEach=j;function U(B,Q,re){return M((X,te=null,se)=>B(le=>Q(le)&&X.call(te,le),null,se),re)}c.filter=U;function z(B){return B}c.signal=z;function F(...B){return(Q,re=null,X)=>(0,D.combinedDisposable)(...B.map(te=>te(se=>Q.call(re,se),null,X)))}c.any=F;function L(B,Q,re,X){let te=re;return R(B,se=>(te=Q(te,se),te),X)}c.reduce=L;function M(B,Q){let re;const X={onWillAddFirstListener(){re=B(te.fire,te)},onDidRemoveLastListener(){re?.dispose()}};Q||a(X);const te=new v(X);return Q?.add(te),te.event}function $(B,Q,re=100,X=!1,te,se){let le,ue,ye,Se=0;const be={leakWarningThreshold:te,onWillAddFirstListener(){le=B(Ne=>{Se++,ue=Q(ue,Ne),X&&!ye&&(Ee.fire(ue),ue=void 0),clearTimeout(ye),ye=setTimeout(()=>{const Fe=ue;ue=void 0,ye=void 0,(!X||Se>1)&&Ee.fire(Fe),Se=0},re)})},onDidRemoveLastListener(){le.dispose()}};se||a(be);const Ee=new v(be);return se?.add(Ee),Ee.event}c.debounce=$;function G(B,Q=0,re){return c.debounce(B,(X,te)=>X?(X.push(te),X):[te],Q,void 0,void 0,re)}c.accumulate=G;function W(B,Q=(X,te)=>X===te,re){let X=!0,te;return U(B,se=>{const le=X||!Q(se,te);return X=!1,te=se,le},re)}c.latch=W;function _(B,Q,re){return[c.filter(B,Q,re),c.filter(B,X=>!Q(X),re)]}c.split=_;function K(B,Q=!1,re=[]){let X=re.slice(),te=B(ue=>{X?X.push(ue):le.fire(ue)});const se=()=>{X?.forEach(ue=>le.fire(ue)),X=null},le=new v({onWillAddFirstListener(){te||(te=B(ue=>le.fire(ue)))},onDidAddFirstListener(){X&&(Q?setTimeout(se):se())},onDidRemoveLastListener(){te&&te.dispose(),te=null}});return le.event}c.buffer=K;class q{constructor(Q){this.event=Q,this.c=new D.DisposableStore}map(Q){return new q(R(this.event,Q,this.c))}forEach(Q){return new q(j(this.event,Q,this.c))}filter(Q){return new q(U(this.event,Q,this.c))}reduce(Q,re){return new q(L(this.event,Q,re,this.c))}latch(){return new q(W(this.event,void 0,this.c))}debounce(Q,re=100,X=!1,te){return new q($(this.event,Q,re,X,te,this.c))}on(Q,re,X){return this.event(Q,re,X)}once(Q,re,X){return b(this.event)(Q,re,X)}dispose(){this.c.dispose()}}function V(B){return new q(B)}c.chain=V;function Z(B,Q,re=X=>X){const X=(...ue)=>le.fire(re(...ue)),te=()=>B.on(Q,X),se=()=>B.removeListener(Q,X),le=new v({onWillAddFirstListener:te,onDidRemoveLastListener:se});return le.event}c.fromNodeEventEmitter=Z;function ne(B,Q,re=X=>X){const X=(...ue)=>le.fire(re(...ue)),te=()=>B.addEventListener(Q,X),se=()=>B.removeEventListener(Q,X),le=new v({onWillAddFirstListener:te,onDidRemoveLastListener:se});return le.event}c.fromDOMEventEmitter=ne;function J(B){return new Promise(Q=>b(B)(Q))}c.toPromise=J;function x(B,Q){return Q(void 0),B(re=>Q(re))}c.runAndSubscribe=x;function T(B,Q){let re=null;function X(se){re?.dispose(),re=new D.DisposableStore,Q(se,re)}X(void 0);const te=B(se=>X(se));return(0,D.toDisposable)(()=>{te.dispose(),re?.dispose()})}c.runAndSubscribeWithStore=T;class N{constructor(Q,re){this.obs=Q,this.c=0,this.d=!1;const X={onWillAddFirstListener:()=>{Q.addObserver(this)},onDidRemoveLastListener:()=>{Q.removeObserver(this)}};re||a(X),this.emitter=new v(X),re&&re.add(this.emitter)}beginUpdate(Q){this.c++}handleChange(Q,re){this.d=!0}endUpdate(Q){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function H(B,Q){return new N(B,Q).emitter.event}c.fromObservable=H})(S=e.Event||(e.Event={}));class C{constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${C.c++}`,C.all.add(this)}start(a){this.d=new O.StopWatch(!0),this.listenerCount=a}stop(){if(this.d){const a=this.d.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=C,C.all=new Set,C.c=0;let E=-1;function w(c){const a=E;return E=c,{dispose(){E=a}}}e.setGlobalLeakWarningThreshold=w;class p{constructor(a,g=Math.random().toString(18).slice(2,5)){this.threshold=a,this.name=g,this.d=0}dispose(){this.c?.clear()}check(a,g){const b=this.threshold;if(b<=0||g<b)return;this.c||(this.c=new Map);const R=this.c.get(a.value)||0;if(this.c.set(a.value,R+1),this.d-=1,this.d<=0){this.d=b*.5;let j,U=0;for(const[z,F]of this.c)(!j||U<F)&&(j=z,U=F);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${U}):`),console.warn(j)}return()=>{const j=this.c.get(a.value)||0;this.c.set(a.value,j-1)}}}class f{static create(){return new f(new Error().stack??"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class y{constructor(a,g,b){this.callback=a,this.callbackThis=g,this.stack=b,this.subscription=new D.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class v{constructor(a){this.j=!1,this.d=a,this.f=E>0||this.d?.leakWarningThreshold?new p(this.d?.leakWarningThreshold??E):void 0,this.g=this.d?._profName?new C(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const a=Array.from(this.q);queueMicrotask(()=>{for(const g of a)g.subscription.isset()&&(g.subscription.unset(),g.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(a,g,b)=>{if(this.q||(this.q=new A.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),D.Disposable.None;const R=this.q.isEmpty();R&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let j,U;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(U=f.create(),j=this.f.check(U,this.q.size+1)),P&&(U=U??f.create());const z=new y(a,g,U),F=this.q.push(z);R&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,a,g);const L=z.subscription.set(()=>{j?.(),this.j||(F(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return b instanceof D.DisposableStore?b.add(L):Array.isArray(b)&&b.push(L),L}),this.l}fire(a){if(this.q){this.m||(this.m=new m);for(const g of this.q)this.m.push(this,g,a);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=v;class l{constructor(){this.c=new A.LinkedList}get size(){return this.c.size}push(a,g,b){this.c.push(new u(a,g,b))}clear(a){const g=new A.LinkedList;for(const b of this.c)b.emitter!==a&&g.push(b);this.c=g}deliver(){for(;this.c.size>0;){const a=this.c.shift();try{a.listener.invoke(a.event)}catch(g){(0,k.onUnexpectedError)(g)}}}}e.EventDeliveryQueue=l;class m extends l{clear(a){this.c.clear()}}class u{constructor(a,g,b){this.emitter=a,this.listener=g,this.event=b}}class d extends v{async fireAsync(a,g,b){if(!!this.q){this.c||(this.c=new A.LinkedList);for(const R of this.q)this.c.push([R,a]);for(;this.c.size>0&&!g.isCancellationRequested;){const[R,j]=this.c.shift(),U=[],z={...j,token:g,waitUntil:F=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");b&&(F=b(F,R.callback)),U.push(F)}};try{R.invoke(z)}catch(F){(0,k.onUnexpectedError)(F);continue}Object.freeze(U),await Promise.allSettled(U).then(F=>{for(const L of F)L.status==="rejected"&&(0,k.onUnexpectedError)(L.reason)})}}}}e.AsyncEmitter=d;class h extends v{constructor(a){super(a),this.h=0,this.s=new A.LinkedList,this.t=a?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const a=Array.from(this.s);this.s.clear(),super.fire(this.t(a))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(a){this.q&&(this.h!==0?this.s.push(a):super.fire(a))}}e.PauseableEmitter=h;class n extends h{constructor(a){super(a),this.c=a.delay??100}fire(a){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(a)}}e.DebounceEmitter=n;class r extends v{constructor(a){super(a),this.c=[],this.h=a?.merge}fire(a){!this.hasListeners()||(this.c.push(a),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(g=>super.fire(g)),this.c=[]}))}}e.MicrotaskEmitter=r;class t{constructor(){this.d=!1,this.f=[],this.c=new v({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(a){const g={event:a,listener:null};this.f.push(g),this.d&&this.j(g);const b=()=>{this.d&&this.k(g);const R=this.f.indexOf(g);this.f.splice(R,1)};return(0,D.toDisposable)((0,i.once)(b))}g(){this.d=!0,this.f.forEach(a=>this.j(a))}h(){this.d=!1,this.f.forEach(a=>this.k(a))}j(a){a.listener=a.event(g=>this.c.fire(g))}k(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=t;class o{constructor(){this.c=[]}wrapEvent(a){return(g,b,R)=>a(j=>{const U=this.c[this.c.length-1];U?U.push(()=>g.call(b,j)):g.call(b,j)},void 0,R)}bufferEvents(a){const g=[];this.c.push(g);const b=a();return this.c.pop(),g.forEach(R=>R()),b}}e.EventBufferer=o;class s{constructor(){this.c=!1,this.d=S.None,this.f=D.Disposable.None,this.g=new v({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(a){this.d=a,this.c&&(this.f.dispose(),this.f=a(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=s}),define(oe[23],ae([0,1,3]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(P,I){const S=setTimeout(P.bind(I),0);return{dispose(){clearTimeout(S)}}});var D;(function(P){function I(S){return S===P.None||S===P.Cancelled||S instanceof A?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}P.isCancellationToken=I,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(D=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?i:(this.b||(this.b=new k.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(I){this.a=void 0,this.b=void 0,this.b=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new A),this.a}cancel(){this.a?this.a instanceof A&&this.a.cancel():this.a=D.Cancelled}dispose(I=!1){I&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof A&&this.a.dispose():this.a=D.None}}e.CancellationTokenSource=O}),define(oe[140],ae([0,1,23]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class i{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new k.CancellationTokenSource,I=this.b(P.token);return this.a={promise:I,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=i;class D{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const I=JSON.stringify(P);return this.b!==I&&(this.b=I,this.a=this.c(P)),this.a}}e.LRUCachedFunction=D;class A{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const I=this.b(P);return this.a.set(P,I),I}}e.CachedFunction=A}),define(oe[27],ae([0,1,140,127]),function(ee,e,k,i){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.isFalsyOrWhitespace=A;const O=/{(\d+)}/g;function P(ie,...he){return he.length===0?ie:ie.replace(O,function(fe,me){const we=parseInt(me,10);return isNaN(we)||we<0||we>=he.length?fe:he[we]})}e.format=P;const I=/{([^}]+)}/g;function S(ie,he){return ie.replace(I,(fe,me)=>he[me]??fe)}e.format2=S;function C(ie){return ie.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=C;function E(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function w(ie,he){let fe=0;const me=he.charCodeAt(0);for(let we=ie.length-1;we>=0;we--)ie.charCodeAt(we)===me&&fe++;return fe}e.count=w;function p(ie,he,fe="\u2026"){return ie.length<=he?ie:`${ie.substr(0,he)}${fe}`}e.truncate=p;function f(ie,he=" "){const fe=y(ie,he);return v(fe,he)}e.trim=f;function y(ie,he){if(!ie||!he)return ie;const fe=he.length;if(fe===0||ie.length===0)return ie;let me=0;for(;ie.indexOf(he,me)===me;)me=me+fe;return ie.substring(me)}e.ltrim=y;function v(ie,he){if(!ie||!he)return ie;const fe=he.length,me=ie.length;if(fe===0||me===0)return ie;let we=me,Ie=-1;for(;Ie=ie.lastIndexOf(he,we-1),!(Ie===-1||Ie+fe!==we);){if(Ie===0)return"";we=Ie}return ie.substring(0,we)}e.rtrim=v;function l(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function m(ie){return ie.replace(/\*/g,"")}e.stripWildcards=m;function u(ie,he,fe={}){if(!ie)throw new Error("Cannot create regex from empty string");he||(ie=E(ie)),fe.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let me="";return fe.global&&(me+="g"),fe.matchCase||(me+="i"),fe.multiline&&(me+="m"),fe.unicode&&(me+="u"),new RegExp(ie,me)}e.createRegExp=u;function d(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function h(ie){return!!ie.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=h;function n(ie){return(ie.global?"g":"")+(ie.ignoreCase?"i":"")+(ie.multiline?"m":"")+(ie.unicode?"u":"")}e.regExpFlags=n;function r(ie){return ie.split(/\r\n|\r|\n/)}e.splitLines=r;function t(ie){for(let he=0,fe=ie.length;he<fe;he++){const me=ie.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.firstNonWhitespaceIndex=t;function o(ie,he=0,fe=ie.length){for(let me=he;me<fe;me++){const we=ie.charCodeAt(me);if(we!==32&&we!==9)return ie.substring(he,me)}return ie.substring(he,fe)}e.getLeadingWhitespace=o;function s(ie,he=ie.length-1){for(let fe=he;fe>=0;fe--){const me=ie.charCodeAt(fe);if(me!==32&&me!==9)return fe}return-1}e.lastNonWhitespaceIndex=s;function c(ie,he,fe){const me=[];let we=0;for(const Ie of ie.matchAll(he)){if(me.push(ie.slice(we,Ie.index)),Ie.index===void 0)throw new Error("match.index should be defined");we=Ie.index+Ie[0].length,me.push(fe(Ie[0],...Ie.slice(1),Ie.index,ie,Ie.groups))}return me.push(ie.slice(we)),Promise.all(me).then(Ie=>Ie.join(""))}e.replaceAsync=c;function a(ie,he){return ie<he?-1:ie>he?1:0}e.compare=a;function g(ie,he,fe=0,me=ie.length,we=0,Ie=he.length){for(;fe<me&&we<Ie;fe++,we++){const $e=ie.charCodeAt(fe),Le=he.charCodeAt(we);if($e<Le)return-1;if($e>Le)return 1}const Re=me-fe,He=Ie-we;return Re<He?-1:Re>He?1:0}e.compareSubstring=g;function b(ie,he){return R(ie,he,0,ie.length,0,he.length)}e.compareIgnoreCase=b;function R(ie,he,fe=0,me=ie.length,we=0,Ie=he.length){for(;fe<me&&we<Ie;fe++,we++){let $e=ie.charCodeAt(fe),Le=he.charCodeAt(we);if($e===Le)continue;if($e>=128||Le>=128)return g(ie.toLowerCase(),he.toLowerCase(),fe,me,we,Ie);U($e)&&($e-=32),U(Le)&&(Le-=32);const qe=$e-Le;if(qe!==0)return qe}const Re=me-fe,He=Ie-we;return Re<He?-1:Re>He?1:0}e.compareSubstringIgnoreCase=R;function j(ie){return ie>=48&&ie<=57}e.isAsciiDigit=j;function U(ie){return ie>=97&&ie<=122}e.isLowerAsciiLetter=U;function z(ie){return ie>=65&&ie<=90}e.isUpperAsciiLetter=z;function F(ie,he){return ie.length===he.length&&R(ie,he)===0}e.equalsIgnoreCase=F;function L(ie,he){const fe=he.length;return he.length>ie.length?!1:R(ie,he,0,fe)===0}e.startsWithIgnoreCase=L;function M(ie,he){const fe=Math.min(ie.length,he.length);let me;for(me=0;me<fe;me++)if(ie.charCodeAt(me)!==he.charCodeAt(me))return me;return fe}e.commonPrefixLength=M;function $(ie,he){const fe=Math.min(ie.length,he.length);let me;const we=ie.length-1,Ie=he.length-1;for(me=0;me<fe;me++)if(ie.charCodeAt(we-me)!==he.charCodeAt(Ie-me))return me;return fe}e.commonSuffixLength=$;function G(ie){return 55296<=ie&&ie<=56319}e.isHighSurrogate=G;function W(ie){return 56320<=ie&&ie<=57343}e.isLowSurrogate=W;function _(ie,he){return(ie-55296<<10)+(he-56320)+65536}e.computeCodePoint=_;function K(ie,he,fe){const me=ie.charCodeAt(fe);if(G(me)&&fe+1<he){const we=ie.charCodeAt(fe+1);if(W(we))return _(me,we)}return me}e.getNextCodePoint=K;function q(ie,he){const fe=ie.charCodeAt(he-1);if(W(fe)&&he>1){const me=ie.charCodeAt(he-2);if(G(me))return _(me,fe)}return fe}class V{get offset(){return this.e}constructor(he,fe=0){this.c=he,this.d=he.length,this.e=fe}setOffset(he){this.e=he}prevCodePoint(){const he=q(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=K(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}e.CodePointIterator=V;class Z{get offset(){return this.c.offset}constructor(he,fe=0){this.c=new V(he,fe)}nextGraphemeLength(){const he=Ae.getInstance(),fe=this.c,me=fe.offset;let we=he.getGraphemeBreakType(fe.nextCodePoint());for(;!fe.eol();){const Ie=fe.offset,Re=he.getGraphemeBreakType(fe.nextCodePoint());if(Ce(we,Re)){fe.setOffset(Ie);break}we=Re}return fe.offset-me}prevGraphemeLength(){const he=Ae.getInstance(),fe=this.c,me=fe.offset;let we=he.getGraphemeBreakType(fe.prevCodePoint());for(;fe.offset>0;){const Ie=fe.offset,Re=he.getGraphemeBreakType(fe.prevCodePoint());if(Ce(Re,we)){fe.setOffset(Ie);break}we=Re}return me-fe.offset}eol(){return this.c.eol()}}e.GraphemeIterator=Z;function ne(ie,he){return new Z(ie,he).nextGraphemeLength()}e.nextCharLength=ne;function J(ie,he){return new Z(ie,he).prevGraphemeLength()}e.prevCharLength=J;function x(ie,he){he>0&&W(ie.charCodeAt(he))&&he--;const fe=he+ne(ie,he);return[fe-J(ie,fe),fe]}e.getCharContainingOffset=x;function T(ie){const he=new Z(ie);let fe=0;for(;!he.eol();)fe++,he.nextGraphemeLength();return fe}e.charCount=T;let N;function H(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function B(ie){return N||(N=H()),N.test(ie)}e.containsRTL=B;const Q=/^[\t\n\r\x20-\x7E]*$/;function re(ie){return Q.test(ie)}e.isBasicASCII=re,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function X(ie){return e.UNUSUAL_LINE_TERMINATORS.test(ie)}e.containsUnusualLineTerminators=X;function te(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.isFullWidthCharacter=te;function se(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.isEmojiImprecise=se;function le(ie,he){if(ie.length<he)return ie;const fe=/\b/g;let me=0;for(;fe.test(ie)&&!(ie.length-fe.lastIndex<he);)me=fe.lastIndex,fe.lastIndex+=1;return ie.substring(me).replace(/^\s/,"")}e.lcut=le;const ue=/\x1B\x5B[12]?K/g,ye=/\x1b\[\d+m/g,Se=/\x1b\[0?m/g;function be(ie){return ie&&(ie=ie.replace(ue,""),ie=ie.replace(ye,""),ie=ie.replace(Se,"")),ie}e.removeAnsiEscapeCodes=be,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Ne(ie){return Ee(ie)?ie.substr(1):ie}e.stripUTF8BOM=Ne;function Fe(ie,he){if(!ie||!he||ie.length<he.length)return!1;const fe=he.length,me=ie.toLowerCase();let we=0,Ie=-1;for(;we<fe;){const Re=me.indexOf(he[we],Ie+1);if(Re<0)return!1;Ie=Re,we++}return!0}e.fuzzyContains=Fe;function Ye(ie,he=!1){return ie?(he&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.containsUppercaseCharacter=Ye;function ze(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.uppercaseFirstLetter=ze;function ce(ie,he=1){if(he===0)return"";let fe=-1;do fe=ie.indexOf(`
`,fe+1),he--;while(he>0&&fe>=0);return fe===-1?ie:(ie[fe-1]==="\r"&&fe--,ie.substr(0,fe))}e.getNLines=ce;function de(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.singleLetterHash=de;function ge(ie){return Ae.getInstance().getGraphemeBreakType(ie)}e.getGraphemeBreakType=ge;function Ce(ie,he){return ie===0?he!==5&&he!==7:ie===2&&he===3?!1:ie===4||ie===2||ie===3||he===4||he===2||he===3?!0:!(ie===8&&(he===8||he===9||he===11||he===12)||(ie===11||ie===9)&&(he===9||he===10)||(ie===12||ie===10)&&he===10||he===5||he===13||he===7||ie===1||ie===13&&he===14||ie===6&&he===6)}var Pe;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(Pe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ae{static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=De()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const fe=this.d,me=fe.length/3;let we=1;for(;we<=me;)if(he<fe[3*we])we=2*we;else if(he>fe[3*we+1])we=2*we+1;else return fe[3*we+2];return 0}}Ae.c=null;function De(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(ie,he){if(ie===0)return 0;const fe=Oe(ie,he);if(fe!==void 0)return fe;const me=new V(he,ie);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=je;function Oe(ie,he){const fe=new V(he,ie);let me=fe.prevCodePoint();for(;Me(me)||me===65039||me===8419;){if(fe.offset===0)return;me=fe.prevCodePoint()}if(!se(me))return;let we=fe.offset;return we>0&&fe.prevCodePoint()===8205&&(we=fe.offset),we}function Me(ie){return 127995<=ie&&ie<=127999}var Be;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),e.noBreakWhitespace="\xA0";class ke{static getInstance(he){return ke.d.get(Array.from(he))}static getLocales(){return ke.e.getValue()}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=ke,D=ke,ke.c=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ke.d=new k.LRUCachedFunction(ie=>{function he(Le){const qe=new Map;for(let Ge=0;Ge<Le.length;Ge+=2)qe.set(Le[Ge],Le[Ge+1]);return qe}function fe(Le,qe){const Ge=new Map(Le);for(const[et,ot]of qe)Ge.set(et,ot);return Ge}function me(Le,qe){if(!Le)return qe;const Ge=new Map;for(const[et,ot]of Le)qe.has(et)&&Ge.set(et,ot);return Ge}const we=D.c.getValue();let Ie=ie.filter(Le=>!Le.startsWith("_")&&Le in we);Ie.length===0&&(Ie=["_default"]);let Re;for(const Le of Ie){const qe=he(we[Le]);Re=me(Re,qe)}const He=he(we._common),$e=fe(He,Re);return new ke($e)}),ke.e=new i.Lazy(()=>Object.keys(ke.c.getValue()).filter(ie=>!ie.startsWith("_")));class Te{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Te.c())),this.d}static isInvisibleCharacter(he){return Te.e().has(he)}static get codePoints(){return Te.e()}}e.InvisibleCharacters=Te,Te.d=void 0}),define(oe[47],ae([0,1,12,5,27,14]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function O(s){return s===47||s===92}e.isPathSeparator=O;function P(s){return s.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=P;function I(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=I;function S(s,c=k.posix.sep){if(!s)return"";const a=s.length,g=s.charCodeAt(0);if(O(g)){if(O(s.charCodeAt(1))&&!O(s.charCodeAt(2))){let R=3;const j=R;for(;R<a&&!O(s.charCodeAt(R));R++);if(j!==R&&!O(s.charCodeAt(R+1))){for(R+=1;R<a;R++)if(O(s.charCodeAt(R)))return s.slice(0,R+1).replace(/[\\/]/g,c)}}return c}else if(l(g)&&s.charCodeAt(1)===58)return O(s.charCodeAt(2))?s.slice(0,2)+c:s.slice(0,2);let b=s.indexOf("://");if(b!==-1){for(b+=3;b<a;b++)if(O(s.charCodeAt(b)))return s.slice(0,b+1)}return""}e.getRoot=S;function C(s){if(!i.isWindows||!s||s.length<5)return!1;let c=s.charCodeAt(0);if(c!==92||(c=s.charCodeAt(1),c!==92))return!1;let a=2;const g=a;for(;a<s.length&&(c=s.charCodeAt(a),c!==92);a++);return!(g===a||(c=s.charCodeAt(a+1),isNaN(c)||c===92))}e.isUNC=C;const E=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(s,c=i.isWindows){const a=c?E:w;return!(!s||s.length===0||/^\s+$/.test(s)||(a.lastIndex=0,a.test(s))||c&&p.test(s)||s==="."||s===".."||c&&s[s.length-1]==="."||c&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=f;function y(s,c,a){const g=s===c;return!a||g?g:!s||!c?!1:(0,D.equalsIgnoreCase)(s,c)}e.isEqual=y;function v(s,c,a,g=k.sep){if(s===c)return!0;if(!s||!c||c.length>s.length)return!1;if(a){if(!(0,D.startsWithIgnoreCase)(s,c))return!1;if(c.length===s.length)return!0;let R=c.length;return c.charAt(c.length-1)===g&&R--,s.charAt(R)===g}return c.charAt(c.length-1)!==g&&(c+=g),s.indexOf(c)===0}e.isEqualOrParent=v;function l(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=l;function m(s,c){return i.isWindows&&s.endsWith(":")&&(s+=k.sep),(0,k.isAbsolute)(s)||(s=(0,k.join)(c,s)),s=(0,k.normalize)(s),i.isWindows?(s=(0,D.rtrim)(s,k.sep),s.endsWith(":")&&(s+=k.sep)):(s=(0,D.rtrim)(s,k.sep),s||(s=k.sep)),s}e.sanitizeFilePath=m;function u(s){const c=(0,k.normalize)(s);return i.isWindows?s.length>3?!1:d(c)&&(s.length===2||c.charCodeAt(2)===92):c===k.posix.sep}e.isRootOrDriveLetter=u;function d(s,c=i.isWindows){return c?l(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function h(s){return d(s)?s[0]:void 0}e.getDriveLetter=h;function n(s,c,a){return c.length>s.length?-1:s===c?0:(a&&(s=s.toLowerCase(),c=c.toLowerCase()),s.indexOf(c))}e.indexOfPath=n;function r(s){const c=s.split(":");let a,g,b;for(const R of c){const j=Number(R);(0,A.isNumber)(j)?g===void 0?g=j:b===void 0&&(b=j):a=a?[a,R].join(":"):R}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:g!==void 0?g:void 0,column:b!==void 0?b:g!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function o(s,c,a=8){let g="";for(let R=0;R<a;R++)g+=t.charAt(Math.floor(Math.random()*t.length));let b;return c?b=`${c}-${g}`:b=g,s?(0,k.join)(s,b):b}e.randomPath=o}),define(oe[66],ae([0,1,27]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(l){return D(l,0)}e.hash=i;function D(l,m){switch(typeof l){case"object":return l===null?A(349,m):Array.isArray(l)?I(l,m):S(l,m);case"string":return P(l,m);case"boolean":return O(l,m);case"number":return A(l,m);case"undefined":return A(937,m);default:return A(617,m)}}e.doHash=D;function A(l,m){return(m<<5)-m+l|0}e.numberHash=A;function O(l,m){return A(l?433:863,m)}function P(l,m){m=A(149417,m);for(let u=0,d=l.length;u<d;u++)m=A(l.charCodeAt(u),m);return m}e.stringHash=P;function I(l,m){return m=A(104579,m),l.reduce((u,d)=>D(d,u),m)}function S(l,m){return m=A(181387,m),Object.keys(l).sort().reduce((u,d)=>(u=P(d,u),D(l[d],u)),m)}class C{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=D(m,this.g),this.g}}e.Hasher=C;var E;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function w(l,m,u=32){const d=u-m,h=~((1<<d)-1);return(l<<m|(h&l)>>>d)>>>0}function p(l,m=0,u=l.byteLength,d=0){for(let h=0;h<u;h++)l[m+h]=d}function f(l,m,u="0"){for(;l.length<m;)l=u+l;return l}function y(l,m=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(u=>u.toString(16).padStart(2,"0")).join(""):f((l>>>0).toString(16),m/4)}e.toHexString=y;class v{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const u=m.length;if(u===0)return;const d=this.p;let h=this.r,n=this.u,r,t;for(n!==0?(r=n,t=-1,n=0):(r=m.charCodeAt(0),t=0);;){let o=r;if(k.isHighSurrogate(r))if(t+1<u){const s=m.charCodeAt(t+1);k.isLowSurrogate(s)?(t++,o=k.computeCodePoint(r,s)):o=65533}else{n=r;break}else k.isLowSurrogate(r)&&(o=65533);if(h=this.w(d,h,o),t++,t<u)r=m.charCodeAt(t);else break}this.r=h,this.u=n}w(m,u,d){return d<128?m[u++]=d:d<2048?(m[u++]=192|(d&1984)>>>6,m[u++]=128|(d&63)>>>0):d<65536?(m[u++]=224|(d&61440)>>>12,m[u++]=128|(d&4032)>>>6,m[u++]=128|(d&63)>>>0):(m[u++]=240|(d&1835008)>>>18,m[u++]=128|(d&258048)>>>12,m[u++]=128|(d&4032)>>>6,m[u++]=128|(d&63)>>>0),u>=64&&(this.y(),u-=64,this.t+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),u}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,p(this.p,this.r),this.r>56&&(this.y(),p(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=v.g,u=this.q;for(let a=0;a<64;a+=4)m.setUint32(a,u.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)m.setUint32(a,w(m.getUint32(a-12,!1)^m.getUint32(a-32,!1)^m.getUint32(a-56,!1)^m.getUint32(a-64,!1),1),!1);let d=this.h,h=this.l,n=this.m,r=this.n,t=this.o,o,s,c;for(let a=0;a<80;a++)a<20?(o=h&n|~h&r,s=1518500249):a<40?(o=h^n^r,s=1859775393):a<60?(o=h&n|h&r|n&r,s=2400959708):(o=h^n^r,s=3395469782),c=w(d,5)+o+t+s+m.getUint32(a*4,!1)&4294967295,t=r,r=n,n=w(h,30),h=d,d=c;this.h=this.h+d&4294967295,this.l=this.l+h&4294967295,this.m=this.m+n&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.StringSHA1=v,v.g=new DataView(new ArrayBuffer(320))}),define(oe[88],ae([0,1,27]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(i||(i={})),function(D){const A="error",O="warning",P="warn",I="info",S="ignore";function C(w){return w?k.equalsIgnoreCase(A,w)?D.Error:k.equalsIgnoreCase(O,w)||k.equalsIgnoreCase(P,w)?D.Warning:k.equalsIgnoreCase(I,w)?D.Info:D.Ignore:D.Ignore}D.fromValue=C;function E(w){switch(w){case D.Error:return A;case D.Warning:return O;case D.Info:return I;default:return S}}D.toString=E}(i||(i={})),e.default=i}),define(oe[48],ae([0,1,20,27]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class D{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const f=p.charCodeAt(0),y=this.b.charCodeAt(this.c);return f-y}value(){return this.b[this.c]}}e.StringIterator=D;class A{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,i.compareSubstring)(p,this.b,0,p.length,this.c,this.d):(0,i.compareSubstringIgnoreCase)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=A;class O{constructor(p=!0,f=!0){this.f=p,this.g=f}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let f=p.length-1;f>=0;f--,this.c--){const y=this.b.charCodeAt(f);if(!(y===47||this.f&&y===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,i.compareSubstring)(p,this.b,0,p.length,this.d,this.e):(0,i.compareSubstringIgnoreCase)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=O;var P;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(P||(P={}));class I{constructor(p,f){this.f=p,this.g=f,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,i.compareIgnoreCase)(p,this.c.scheme);if(this.d[this.e]===2)return(0,i.compareIgnoreCase)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,i.compare)(p,this.c.query);if(this.d[this.e]===5)return(0,i.compare)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=I;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(C||(C={}));class E{static forUris(p=()=>!1,f=()=>!1){return new E(new I(p,f))}static forPaths(p=!1){return new E(new O(void 0,!p))}static forStrings(){return new E(new D)}static forConfigKeys(){return new E(new A)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,f){if(f){const y=f.slice(0);(0,k.shuffle)(y);for(const v of y)this.set(v,p)}else{const y=p.slice(0);(0,k.shuffle)(y);for(const v of y)this.set(v[0],v[1])}}set(p,f){const y=this.b.reset(p);let v;this.c||(this.c=new S,this.c.segment=y.value());const l=[];for(v=this.c;;){const u=y.cmp(v.segment);if(u>0)v.left||(v.left=new S,v.left.segment=y.value()),l.push([-1,v]),v=v.left;else if(u<0)v.right||(v.right=new S,v.right.segment=y.value()),l.push([1,v]),v=v.right;else if(y.hasNext())y.next(),v.mid||(v.mid=new S,v.mid.segment=y.value()),l.push([0,v]),v=v.mid;else break}const m=v.value;v.value=f,v.key=p;for(let u=l.length-1;u>=0;u--){const d=l[u][1];d.updateHeight();const h=d.balanceFactor();if(h<-1||h>1){const n=l[u][0],r=l[u+1][0];if(n===1&&r===1)l[u][1]=d.rotateLeft();else if(n===-1&&r===-1)l[u][1]=d.rotateRight();else if(n===1&&r===-1)d.right=l[u+1][1]=l[u+1][1].rotateRight(),l[u][1]=d.rotateLeft();else if(n===-1&&r===1)d.left=l[u+1][1]=l[u+1][1].rotateLeft(),l[u][1]=d.rotateRight();else throw new Error;if(u>0)switch(l[u-1][0]){case-1:l[u-1][1].left=l[u][1];break;case 1:l[u-1][1].right=l[u][1];break;case 0:l[u-1][1].mid=l[u][1];break}else this.c=l[0][1]}}return m}get(p){return this.d(p)?.value}d(p){const f=this.b.reset(p);let y=this.c;for(;y;){const v=f.cmp(y.segment);if(v>0)y=y.left;else if(v<0)y=y.right;else if(f.hasNext())f.next(),y=y.mid;else break}return y}has(p){const f=this.d(p);return!(f?.value===void 0&&f?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,f){const y=this.b.reset(p),v=[];let l=this.c;for(;l;){const m=y.cmp(l.segment);if(m>0)v.push([-1,l]),l=l.left;else if(m<0)v.push([1,l]),l=l.right;else if(y.hasNext())y.next(),v.push([0,l]),l=l.mid;else break}if(!!l){if(f?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const m=this.f(l.right);if(m.key){const{key:u,value:d,segment:h}=m;this.e(m.key,!1),l.key=u,l.value=d,l.segment=h}}else{const m=l.left??l.right;if(v.length>0){const[u,d]=v[v.length-1];switch(u){case-1:d.left=m;break;case 0:d.mid=m;break;case 1:d.right=m;break}}else this.c=m}for(let m=v.length-1;m>=0;m--){const u=v[m][1];u.updateHeight();const d=u.balanceFactor();if(d>1?(u.right.balanceFactor()>=0||(u.right=u.right.rotateRight()),v[m][1]=u.rotateLeft()):d<-1&&(u.left.balanceFactor()<=0||(u.left=u.left.rotateLeft()),v[m][1]=u.rotateRight()),m>0)switch(v[m-1][0]){case-1:v[m-1][1].left=v[m][1];break;case 1:v[m-1][1].right=v[m][1];break;case 0:v[m-1][1].mid=v[m][1];break}else this.c=v[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const f=this.b.reset(p);let y=this.c,v;for(;y;){const l=f.cmp(y.segment);if(l>0)y=y.left;else if(l<0)y=y.right;else if(f.hasNext())f.next(),v=y.value||v,y=y.mid;else break}return y&&y.value||v}findSuperstr(p){const f=this.b.reset(p);let y=this.c;for(;y;){const v=f.cmp(y.segment);if(v>0)y=y.left;else if(v<0)y=y.right;else if(f.hasNext())f.next(),y=y.mid;else return y.mid?this.g(y.mid):void 0}}forEach(p){for(const[f,y]of this)p(y,f)}*[Symbol.iterator](){yield*this.g(this.c)}g(p){const f=[];return this.h(p,f),f[Symbol.iterator]()}h(p,f){!p||(p.left&&this.h(p.left,f),p.value&&f.push([p.key,p.value]),p.mid&&this.h(p.mid,f),p.right&&this.h(p.right,f))}_isBalanced(){const p=f=>{if(!f)return!0;const y=f.balanceFactor();return y<-1||y>1?!1:p(f.left)&&p(f.right)};return p(this.c)}}e.TernarySearchTree=E}),define(oe[7],ae([0,1,12,5]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,A=/^\//,O=/^\/\//;function P(t,o){if(!t.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!D.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!A.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(t,o){return!t&&!o?"file":t}function S(t,o){switch(t){case"https":case"http":case"file":o?o[0]!==E&&(o=E+o):o=E;break}return o}const C="",E="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{static isUri(o){return o instanceof p?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,s,c,a,g,b=!1){typeof o=="object"?(this.scheme=o.scheme||C,this.authority=o.authority||C,this.path=o.path||C,this.query=o.query||C,this.fragment=o.fragment||C):(this.scheme=I(o,b),this.authority=s||C,this.path=S(this.scheme,c||C),this.query=a||C,this.fragment=g||C,P(this,b))}get fsPath(){return u(this,!1)}with(o){if(!o)return this;let{scheme:s,authority:c,path:a,query:g,fragment:b}=o;return s===void 0?s=this.scheme:s===null&&(s=C),c===void 0?c=this.authority:c===null&&(c=C),a===void 0?a=this.path:a===null&&(a=C),g===void 0?g=this.query:g===null&&(g=C),b===void 0?b=this.fragment:b===null&&(b=C),s===this.scheme&&c===this.authority&&a===this.path&&g===this.query&&b===this.fragment?this:new y(s,c,a,g,b)}static parse(o,s=!1){const c=w.exec(o);return c?new y(c[2]||C,r(c[4]||C),r(c[5]||C),r(c[7]||C),r(c[9]||C),s):new y(C,C,C,C,C)}static file(o){let s=C;if(i.isWindows&&(o=o.replace(/\\/g,E)),o[0]===E&&o[1]===E){const c=o.indexOf(E,2);c===-1?(s=o.substring(2),o=E):(s=o.substring(2,c),o=o.substring(c)||E)}return new y("file",s,o,C,C)}static from(o){const s=new y(o.scheme,o.authority,o.path,o.query,o.fragment);return P(s,!0),s}static joinPath(o,...s){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return i.isWindows&&o.scheme==="file"?c=p.file(k.win32.join(u(o,!0),...s)).path:c=k.posix.join(o.path,...s),o.with({path:c})}toString(o=!1){return d(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof p)return o;{const s=new y(o);return s._formatted=o.external,s._fsPath=o._sep===f?o.fsPath:null,s}}else return o}}e.URI=p;const f=i.isWindows?1:void 0;class y extends p{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(o=!1){return o?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=f),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function l(t,o,s){let c,a=-1;for(let g=0;g<t.length;g++){const b=t.charCodeAt(g);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||o&&b===47||s&&b===91||s&&b===93||s&&b===58)a!==-1&&(c+=encodeURIComponent(t.substring(a,g)),a=-1),c!==void 0&&(c+=t.charAt(g));else{c===void 0&&(c=t.substr(0,g));const R=v[b];R!==void 0?(a!==-1&&(c+=encodeURIComponent(t.substring(a,g)),a=-1),c+=R):a===-1&&(a=g)}}return a!==-1&&(c+=encodeURIComponent(t.substring(a))),c!==void 0?c:t}function m(t){let o;for(let s=0;s<t.length;s++){const c=t.charCodeAt(s);c===35||c===63?(o===void 0&&(o=t.substr(0,s)),o+=v[c]):o!==void 0&&(o+=t[s])}return o!==void 0?o:t}function u(t,o){let s;return t.authority&&t.path.length>1&&t.scheme==="file"?s=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?o?s=t.path.substr(1):s=t.path[1].toLowerCase()+t.path.substr(2):s=t.path,i.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=u;function d(t,o){const s=o?m:l;let c="",{scheme:a,authority:g,path:b,query:R,fragment:j}=t;if(a&&(c+=a,c+=":"),(g||a==="file")&&(c+=E,c+=E),g){let U=g.indexOf("@");if(U!==-1){const z=g.substr(0,U);g=g.substr(U+1),U=z.lastIndexOf(":"),U===-1?c+=s(z,!1,!1):(c+=s(z.substr(0,U),!1,!1),c+=":",c+=s(z.substr(U+1),!1,!0)),c+="@"}g=g.toLowerCase(),U=g.lastIndexOf(":"),U===-1?c+=s(g,!1,!0):(c+=s(g.substr(0,U),!1,!0),c+=g.substr(U))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const U=b.charCodeAt(1);U>=65&&U<=90&&(b=`/${String.fromCharCode(U+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const U=b.charCodeAt(0);U>=65&&U<=90&&(b=`${String.fromCharCode(U+32)}:${b.substr(2)}`)}c+=s(b,!0,!1)}return R&&(c+="?",c+=s(R,!1,!1)),j&&(c+="#",c+=o?j:l(j,!1,!1)),c}function h(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+h(t.substr(3)):t}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(t){return t.match(n)?t.replace(n,o=>h(o)):t}}),define(oe[141],ae([0,1,7]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function i(S){const C=S;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.isRemoteConsoleLog=i;function D(S){const C=[];let E;try{const w=JSON.parse(S.arguments),p=w[w.length-1];p&&p.__$stack&&(w.pop(),E=p.__$stack),C.push(...w)}catch{C.push("Unable to log remote console arguments",S.arguments)}return{args:C,stack:E}}e.parse=D;function A(S){if(typeof S!="string")return A(D(S).stack);const C=S;if(C){const E=O(C),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(w&&w.length===4)return{uri:k.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.getFirstFrame=A;function O(S){if(!S)return S;const C=S.indexOf(`
`);return C===-1?S:S.substring(0,C)}function P(S,C){const{args:E,stack:w}=D(S),p=typeof E[0]=="string"&&E.length===1;let f=O(w);f&&(f=`(${f.trim()})`);let y=[];if(typeof E[0]=="string"?f&&p?y=[`%c[${C}] %c${E[0]} %c${f}`,I("blue"),I(""),I("grey")]:y=[`%c[${C}] %c${E[0]}`,I("blue"),I(""),...E.slice(1)]:y=[`%c[${C}]%`,I("blue"),...E],f&&!p&&y.push(f),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,y)}e.log=P;function I(S){return`color: ${S}`}}),define(oe[67],ae([0,1,17,27,7]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(S){return JSON.stringify(S,P)}e.stringify=A;function O(S){let C=JSON.parse(S);return C=I(C),C}e.parse=O;function P(S,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,i.regExpFlags)(C)}:C}function I(S,C=0){if(!S||C>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return D.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 16:return new Date(S.source)}if(S instanceof k.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let E=0;E<S.length;++E)S[E]=I(S[E],C+1);else for(const E in S)Object.hasOwnProperty.call(S,E)&&(S[E]=I(S[E],C+1))}return S}e.revive=I}),define(oe[24],ae([0,1,5,7]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.vscodeUserData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls",I.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(S){this.d=S}setDelegate(S){this.e=S}setServerRootPath(S){this.f=`${S}/${D.vscodeRemoteResource}`}set(S,C,E){this.a[S]=C,this.b[S]=E}setConnectionToken(S,C){this.c[S]=C}getPreferredWebSchema(){return this.d}rewrite(S){if(this.e)return this.e(S);const C=S.authority;let E=this.a[C];E&&E.indexOf(":")!==-1&&E.indexOf("[")===-1&&(E=`[${E}]`);const w=this.b[C],p=this.c[C];let f=`path=${encodeURIComponent(S.path)}`;return typeof p=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),i.URI.from({scheme:k.isWeb?this.d:D.vscodeRemoteResource,authority:`${E}:${w}`,path:this.f,query:f})}}e.RemoteAuthorities=new A,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class O{asBrowserUri(S){const C=this.b(S,ee);return this.uriToBrowserUri(C)}uriToBrowserUri(S){return S.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(S):S.scheme===D.file&&(k.isNative||k.isWebWorker&&k.globals.origin===`${D.vscodeFileResource}://${O.a}`)?S.with({scheme:D.vscodeFileResource,authority:S.authority||O.a,query:null,fragment:null}):S}asFileUri(S){const C=this.b(S,ee);return this.uriToFileUri(C)}uriToFileUri(S){return S.scheme===D.vscodeFileResource?S.with({scheme:D.file,authority:S.authority!==O.a?S.authority:null,query:null,fragment:null}):S}b(S,C){return i.URI.isUri(S)?S:i.URI.parse(C.toUrl(S))}}O.a="vscode-app",e.FileAccess=new O;var P;(function(I){const S=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);I.CoopAndCoep=Object.freeze(S.get("3"));const C="vscode-coi";function E(p){let f;typeof p=="string"?f=new URL(p).searchParams:p instanceof URL?f=p.searchParams:i.URI.isUri(p)&&(f=new URL(p.toString(!0)).searchParams);const y=f?.get(C);if(!!y)return S.get(y)}I.getHeadersFromQuery=E;function w(p,f,y){if(!globalThis.crossOriginIsolated)return;const v=f&&y?"3":y?"2":"1";p instanceof URLSearchParams?p.set(C,v):p[C]=v}I.addSearchParam=w})(P=e.COI||(e.COI={}))}),define(oe[21],ae([0,1,47,24,12,5,27,7]),function(ee,e,k,i,D,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(p){return(0,P.uriToFsPath)(p,!0)}e.originalFSPath=I;class S{constructor(f){this.a=f}compare(f,y,v=!1){return f===y?0:(0,O.compare)(this.getComparisonKey(f,v),this.getComparisonKey(y,v))}isEqual(f,y,v=!1){return f===y?!0:!f||!y?!1:this.getComparisonKey(f,v)===this.getComparisonKey(y,v)}getComparisonKey(f,y=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,y,v=!1){if(f.scheme===y.scheme){if(f.scheme===i.Schemas.file)return k.isEqualOrParent(I(f),I(y),this.a(f))&&f.query===y.query&&(v||f.fragment===y.fragment);if((0,e.isEqualAuthority)(f.authority,y.authority))return k.isEqualOrParent(f.path,y.path,this.a(f),"/")&&f.query===y.query&&(v||f.fragment===y.fragment)}return!1}joinPath(f,...y){return P.URI.joinPath(f,...y)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return D.posix.basename(f.path)}extname(f){return D.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let y;return f.scheme===i.Schemas.file?y=P.URI.file(D.dirname(I(f))).path:(y=D.posix.dirname(f.path),f.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),y="/")),f.with({path:y})}normalizePath(f){if(!f.path.length)return f;let y;return f.scheme===i.Schemas.file?y=P.URI.file(D.normalize(I(f))).path:y=D.posix.normalize(f.path),f.with({path:y})}relativePath(f,y){if(f.scheme!==y.scheme||!(0,e.isEqualAuthority)(f.authority,y.authority))return;if(f.scheme===i.Schemas.file){const m=D.relative(I(f),I(y));return A.isWindows?k.toSlashes(m):m}let v=f.path||"/";const l=y.path||"/";if(this.a(f)){let m=0;for(const u=Math.min(v.length,l.length);m<u&&!(v.charCodeAt(m)!==l.charCodeAt(m)&&v.charAt(m).toLowerCase()!==l.charAt(m).toLowerCase());m++);v=l.substr(0,m)+v.substr(m)}return D.posix.relative(v,l)}resolvePath(f,y){if(f.scheme===i.Schemas.file){const v=P.URI.file(D.resolve(I(f),y));return f.with({authority:v.authority,path:v.path})}return y=k.toPosixPath(y),f.with({path:D.posix.resolve(f.path,y)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,y){return f===y||f!==void 0&&y!==void 0&&(0,O.equalsIgnoreCase)(f,y)}hasTrailingPathSeparator(f,y=D.sep){if(f.scheme===i.Schemas.file){const v=I(f);return v.length>k.getRoot(v).length&&v[v.length-1]===y}else{const v=f.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,y=D.sep){return(0,e.hasTrailingPathSeparator)(f,y)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,y=D.sep){let v=!1;if(f.scheme===i.Schemas.file){const l=I(f);v=l!==void 0&&l.length===k.getRoot(l).length&&l[l.length-1]===y}else{y="/";const l=f.path;v=l.length===1&&l.charCodeAt(l.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(f,y)?f.with({path:f.path+"/"}):f}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(p=>p.scheme===i.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new S(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function C(p,f){const y=[];for(let v=0;v<p.length;v++){const l=f(p[v]);p.some((m,u)=>u===v?!1:(0,e.isEqualOrParent)(l,f(m)))||y.push(p[v])}return y}e.distinctParents=C;var E;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function f(y){const v=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(u=>{const[d,h]=u.split(":");d&&h&&v.set(d,h)});const m=y.path.substring(0,y.path.indexOf(";"));return m&&v.set(p.META_DATA_MIME,m),v}p.parseMetaData=f})(E=e.DataUri||(e.DataUri={}));function w(p,f,y){if(f){let v=p.path;return v&&v[0]!==D.posix.sep&&(v=D.posix.sep+v),p.with({scheme:y,authority:f,path:v})}return p.with({scheme:y})}e.toLocalResource=w}),define(oe[6],ae([0,1,23,9,3,2,21,5]),function(ee,e,k,i,D,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(x){return!!x&&typeof x.then=="function"}e.isThenable=I;function S(x){const T=new k.CancellationTokenSource,N=x(T.token),H=new Promise((B,Q)=>{const re=T.token.onCancellationRequested(()=>{re.dispose(),T.dispose(),Q(new i.CancellationError)});Promise.resolve(N).then(X=>{re.dispose(),T.dispose(),B(X)},X=>{re.dispose(),T.dispose(),Q(X)})});return new class{cancel(){T.cancel()}then(B,Q){return H.then(B,Q)}catch(B){return this.then(void 0,B)}finally(B){return H.finally(B)}}}e.createCancelablePromise=S;function C(x,T,N){return new Promise((H,B)=>{const Q=T.onCancellationRequested(()=>{Q.dispose(),H(N)});x.then(H,B).finally(()=>Q.dispose())})}e.raceCancellation=C;function E(x,T){return new Promise((N,H)=>{const B=T.onCancellationRequested(()=>{B.dispose(),H(new i.CancellationError)});x.then(N,H).finally(()=>B.dispose())})}e.raceCancellationError=E;async function w(x){let T=-1;const N=x.map((B,Q)=>B.then(re=>(T=Q,re))),H=await Promise.race(N);return x.forEach((B,Q)=>{Q!==T&&B.cancel()}),H}e.raceCancellablePromises=w;function p(x,T,N){let H;const B=setTimeout(()=>{H?.(void 0),N?.()},T);return Promise.race([x.finally(()=>clearTimeout(B)),new Promise(Q=>H=Q)])}e.raceTimeout=p;function f(x){return new Promise((T,N)=>{const H=x();I(H)?H.then(T,N):T(H)})}e.asPromise=f;class y{constructor(){this.a=null,this.b=null,this.d=null}queue(T){if(this.a){if(this.d=T,!this.b){const N=()=>{this.b=null;const H=this.queue(this.d);return this.d=null,H};this.b=new Promise(H=>{this.a.then(N,N).then(H)})}return new Promise((N,H)=>{this.b.then(N,H)})}return this.a=T(),new Promise((N,H)=>{this.a.then(B=>{this.a=null,N(B)},B=>{this.a=null,H(B)})})}}e.Throttler=y;class v{constructor(){this.a=Promise.resolve(null)}queue(T){return this.a=this.a.then(()=>T(),()=>T())}}e.Sequencer=v;class l{constructor(){this.a=new Map}queue(T,N){const B=(this.a.get(T)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.a.get(T)===B&&this.a.delete(T)});return this.a.set(T,B),B}}e.SequencerByKey=l;const m=(x,T)=>{let N=!0;const H=setTimeout(()=>{N=!1,T()},x);return{isTriggered:()=>N,dispose:()=>{clearTimeout(H),N=!1}}},u=x=>{let T=!0;return queueMicrotask(()=>{T&&(T=!1,x())}),{isTriggered:()=>T,dispose:()=>{T=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class d{constructor(T){this.defaultDelay=T,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(T,N=this.defaultDelay){this.g=T,this.h(),this.b||(this.b=new Promise((B,Q)=>{this.d=B,this.f=Q}).then(()=>{if(this.b=null,this.d=null,this.g){const B=this.g;return this.g=null,B()}}));const H=()=>{this.a=null,this.d?.(null)};return this.a=N===e.MicrotaskDelay?u(H):m(N,H),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new i.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=d;class h{constructor(T){this.a=new d(T),this.b=new y}trigger(T,N){return this.a.trigger(()=>this.b.queue(T),N)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=h;class n{constructor(){this.a=!1,this.b=new Promise((T,N)=>{this.d=T})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=n;class r extends n{constructor(T){super(),this.f=setTimeout(()=>this.open(),T)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function t(x,T){return T?new Promise((N,H)=>{const B=setTimeout(()=>{Q.dispose(),N()},x),Q=T.onCancellationRequested(()=>{clearTimeout(B),Q.dispose(),H(new i.CancellationError)})}):S(N=>t(x,N))}e.timeout=t;function o(x,T=0){const N=setTimeout(x,T);return(0,A.toDisposable)(()=>clearTimeout(N))}e.disposableTimeout=o;function s(x){const T=[];let N=0;const H=x.length;function B(){return N<H?x[N++]():null}function Q(re){re!=null&&T.push(re);const X=B();return X?X.then(Q):Promise.resolve(T)}return Promise.resolve(null).then(Q)}e.sequence=s;function c(x,T=H=>!!H,N=null){let H=0;const B=x.length,Q=()=>{if(H>=B)return Promise.resolve(N);const re=x[H++];return Promise.resolve(re()).then(te=>T(te)?Promise.resolve(te):Q())};return Q()}e.first=c;function a(x,T=H=>!!H,N=null){if(x.length===0)return Promise.resolve(N);let H=x.length;const B=()=>{H=-1;for(const Q of x)Q.cancel?.()};return new Promise((Q,re)=>{for(const X of x)X.then(te=>{--H>=0&&T(te)?(B(),Q(te)):H===0&&Q(N)}).catch(te=>{--H>=0&&(B(),re(te))})})}e.firstParallel=a;class g{constructor(T){this.a=0,this.d=T,this.f=[],this.b=0,this.g=new D.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(T){return this.a++,new Promise((N,H)=>{this.f.push({factory:T,c:N,e:H}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const T=this.f.shift();this.b++;const N=T.factory();N.then(T.c,T.e),N.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=g;class b extends g{constructor(){super(1)}}e.Queue=b;class R{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const T=new K;return this.b.add(T),T.p}d(){for(const[,T]of this.a)if(T.size>0)return!1;return!0}queueFor(T,N=O.extUri){const H=N.getComparisonKey(T);let B=this.a.get(H);return B||(B=new b,D.Event.once(B.onDrained)(()=>{B?.dispose(),this.a.delete(H),this.f()}),this.a.set(H,B)),B}f(){!this.d()||this.g()}g(){for(const T of this.b)T.complete();this.b.clear()}dispose(){for(const[,T]of this.a)T.dispose();this.a.clear(),this.g()}}e.ResourceQueue=R;class j{constructor(T,N){this.a=-1,typeof T=="function"&&typeof N=="number"&&this.setIfNotSet(T,N)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(T,N){this.cancel(),this.a=setTimeout(()=>{this.a=-1,T()},N)}setIfNotSet(T,N){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,T()},N))}}e.TimeoutTimer=j;class U{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(T,N){this.cancel(),this.a=setInterval(()=>{T()},N)}}e.IntervalTimer=U;class z{constructor(T,N){this.b=-1,this.a=T,this.d=N,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(T=this.d){this.cancel(),this.b=setTimeout(this.f,T)}get delay(){return this.d}set delay(T){this.d=T}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=z;class F{constructor(T,N){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.a=T,this.b=N,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(T=this.b){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(T/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=F;class L extends z{constructor(T,N){super(T,N),this.j=[]}work(T){this.j.push(T),this.isScheduled()||this.schedule()}h(){const T=this.j;this.j=[],this.a?.(T)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=L;class M extends A.Disposable{constructor(T,N){super(),this.g=T,this.h=N,this.a=[],this.b=this.B(new A.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(T){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+T.length>this.g.maxBufferedWork)return!1}else if(this.pending+T.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(...T),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=x=>{(0,P.setTimeout0)(()=>{if(T)return;const N=Date.now()+15;x(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,N-Date.now())}}))});let T=!1;return{dispose(){T||(T=!0)}}}:e.runWhenIdle=(x,T)=>{const N=requestIdleCallback(x,typeof T=="number"?{timeout:T}:void 0);let H=!1;return{dispose(){H||(H=!0,cancelIdleCallback(N))}}}}();class ${constructor(T){this.d=!1,this.a=()=>{try{this.f=T()}catch(N){this.g=N}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=$;async function G(x,T,N){let H;for(let B=0;B<N;B++)try{return await x()}catch(Q){H=Q,await t(T)}throw H}e.retry=G;class W{hasPending(T){return this.a?typeof T=="number"?this.a.taskId===T:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(T,N,H){return this.a={taskId:T,cancel:()=>H?.(),promise:N},N.then(()=>this.d(T),()=>this.d(T)),N}d(T){this.a&&T===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const T=this.b;this.b=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}setNext(T){if(this.b)this.b.run=T;else{let N,H;const B=new Promise((Q,re)=>{N=Q,H=re});this.b={run:T,promise:B,promiseResolve:N,promiseReject:H}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=W;class _{constructor(T,N=()=>Date.now()){this.d=T,this.f=N,this.a=0,this.b=0}increment(){const T=this.f();return T-this.a>this.d&&(this.a=T,this.b=0),this.b++,this.b}}e.IntervalCounter=_;class K{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((T,N)=>{this.a=T,this.b=N})}complete(T){return new Promise(N=>{this.a(T),this.f=!0,N()})}error(T){return new Promise(N=>{this.b(T),this.d=!0,N()})}cancel(){new Promise(T=>{this.b(new i.CancellationError),this.d=!0,T()})}}e.DeferredPromise=K;var q;(function(x){async function T(H){let B;const Q=await Promise.all(H.map(re=>re.then(X=>X,X=>{B||(B=X)})));if(typeof B<"u")throw B;return Q}x.settled=T;function N(H){return new Promise(async(B,Q)=>{try{await H(B,Q)}catch(re){Q(re)}})}x.withAsyncBody=N})(q=e.Promises||(e.Promises={}));var V;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(V||(V={}));class Z{static fromArray(T){return new Z(N=>{N.emitMany(T)})}static fromPromise(T){return new Z(async N=>{N.emitMany(await T)})}static fromPromises(T){return new Z(async N=>{await Promise.all(T.map(async H=>N.emitOne(await H)))})}static merge(T){return new Z(async N=>{await Promise.all(T.map(async H=>{for await(const B of H)N.emitOne(B)}))})}constructor(T){this.a=0,this.b=[],this.d=null,this.f=new D.Emitter,queueMicrotask(async()=>{const N={emitOne:H=>this.g(H),emitMany:H=>this.h(H),reject:H=>this.k(H)};try{await Promise.resolve(T(N)),this.j()}catch(H){this.k(H)}finally{N.emitOne=void 0,N.emitMany=void 0,N.reject=void 0}})}[Symbol.asyncIterator](){let T=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(T<this.b.length)return{done:!1,value:this.b[T++]};if(this.a===1)return{done:!0,value:void 0};await D.Event.toPromise(this.f.event)}while(!0)}}}static map(T,N){return new Z(async H=>{for await(const B of T)H.emitOne(N(B))})}map(T){return Z.map(this,T)}static filter(T,N){return new Z(async H=>{for await(const B of T)N(B)&&H.emitOne(B)})}filter(T){return Z.filter(this,T)}static coalesce(T){return Z.filter(T,N=>!!N)}coalesce(){return Z.coalesce(this)}static async toPromise(T){const N=[];for await(const H of T)N.push(H);return N}toPromise(){return Z.toPromise(this)}g(T){this.a===0&&(this.b.push(T),this.f.fire())}h(T){this.a===0&&(this.b=this.b.concat(T),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(T){this.a===0&&(this.a=2,this.d=T,this.f.fire())}}e.AsyncIterableObject=Z,Z.EMPTY=Z.fromArray([]);class ne extends Z{constructor(T,N){super(N),this.l=T}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ne;function J(x){const T=new k.CancellationTokenSource,N=x(T.token);return new ne(T,async H=>{const B=T.token.onCancellationRequested(()=>{B.dispose(),T.dispose(),H.reject(new i.CancellationError)});try{for await(const Q of N){if(T.token.isCancellationRequested)return;H.emitOne(Q)}B.dispose(),T.dispose()}catch(Q){B.dispose(),T.dispose(),H.reject(Q)}})}e.createCancelableAsyncIterable=J}),define(oe[89],ae([0,1,20,6,47,37,12,5,27]),function(ee,e,k,i,D,A,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const C="[/\\\\]",E="[^/\\\\]",w=/\//g;function p(K,q){switch(K){case 0:return"";case 1:return`${E}*?`;default:return`(?:${C}|${E}+${C}${q?`|${C}${E}+`:""})*?`}}function f(K,q){if(!K)return[];const V=[];let Z=!1,ne=!1,J="";for(const x of K){switch(x){case q:if(!Z&&!ne){V.push(J),J="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}J+=x}return J&&V.push(J),V}e.splitGlobAware=f;function y(K){if(!K)return"";let q="";const V=f(K,e.GLOB_SPLIT);if(V.every(Z=>Z===e.GLOBSTAR))q=".*";else{let Z=!1;V.forEach((ne,J)=>{if(ne===e.GLOBSTAR){if(Z)return;q+=p(2,J===V.length-1)}else{let x=!1,T="",N=!1,H="";for(const B of ne){if(B!=="}"&&x){T+=B;continue}if(N&&(B!=="]"||!H)){let Q;B==="-"?Q=B:(B==="^"||B==="!")&&!H?Q="^":B===e.GLOB_SPLIT?Q="":Q=(0,I.escapeRegExpCharacters)(B),H+=Q;continue}switch(B){case"{":x=!0;continue;case"[":N=!0;continue;case"}":{q+=`(?:${f(T,",").map(X=>y(X)).join("|")})`,x=!1,T="";break}case"]":{q+="["+H+"]",N=!1,H="";break}case"?":q+=E;continue;case"*":q+=p(1);continue;default:q+=(0,I.escapeRegExpCharacters)(B)}}J<V.length-1&&(V[J+1]!==e.GLOBSTAR||J+2<V.length)&&(q+=C)}Z=ne===e.GLOBSTAR})}return q}const v=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new A.LRUCache(1e4),r=function(){return!1},t=function(){return null};function o(K,q){if(!K)return t;let V;typeof K!="string"?V=K.pattern:V=K,V=V.trim();const Z=`${V}_${!!q.trimForExclusions}`;let ne=n.get(Z);if(ne)return s(ne,K);let J;return v.test(V)?ne=a(V.substr(4),V):(J=l.exec(c(V,q)))?ne=g(J[1],V):(q.trimForExclusions?u:m).test(V)?ne=b(V,q):(J=d.exec(c(V,q)))?ne=R(J[1].substr(1),V,!0):(J=h.exec(c(V,q)))?ne=R(J[1],V,!1):ne=j(V),n.set(Z,ne),s(ne,K)}function s(K,q){if(typeof q=="string")return K;const V=function(Z,ne){return(0,D.isEqualOrParent)(Z,q.base,!P.isLinux)?K((0,I.ltrim)(Z.substr(q.base.length),O.sep),ne):null};return V.allBasenames=K.allBasenames,V.allPaths=K.allPaths,V.basenames=K.basenames,V.patterns=K.patterns,V}function c(K,q){return q.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function a(K,q){return function(V,Z){return typeof V=="string"&&V.endsWith(K)?q:null}}function g(K,q){const V=`/${K}`,Z=`\\${K}`,ne=function(x,T){return typeof x!="string"?null:T?T===K?q:null:x===K||x.endsWith(V)||x.endsWith(Z)?q:null},J=[K];return ne.basenames=J,ne.patterns=[q],ne.allBasenames=J,ne}function b(K,q){const V=W(K.slice(1,-1).split(",").map(T=>o(T,q)).filter(T=>T!==t),K),Z=V.length;if(!Z)return t;if(Z===1)return V[0];const ne=function(T,N){for(let H=0,B=V.length;H<B;H++)if(V[H](T,N))return K;return null},J=V.find(T=>!!T.allBasenames);J&&(ne.allBasenames=J.allBasenames);const x=V.reduce((T,N)=>N.allPaths?T.concat(N.allPaths):T,[]);return x.length&&(ne.allPaths=x),ne}function R(K,q,V){const Z=O.sep===O.posix.sep,ne=Z?K:K.replace(w,O.sep),J=O.sep+ne,x=O.posix.sep+K;let T;return V?T=function(N,H){return typeof N=="string"&&(N===ne||N.endsWith(J)||!Z&&(N===K||N.endsWith(x)))?q:null}:T=function(N,H){return typeof N=="string"&&(N===ne||!Z&&N===K)?q:null},T.allPaths=[(V?"*/":"./")+K],T}function j(K){try{const q=new RegExp(`^${y(K)}$`);return function(V){return q.lastIndex=0,typeof V=="string"&&q.test(V)?K:null}}catch{return t}}function U(K,q,V){return!K||typeof q!="string"?!1:z(K)(q,void 0,V)}e.match=U;function z(K,q={}){if(!K)return r;if(typeof K=="string"||F(K)){const V=o(K,q);if(V===t)return r;const Z=function(ne,J){return!!V(ne,J)};return V.allBasenames&&(Z.allBasenames=V.allBasenames),V.allPaths&&(Z.allPaths=V.allPaths),Z}return $(K,q)}e.parse=z;function F(K){const q=K;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}e.isRelativePattern=F;function L(K){return K.allBasenames||[]}e.getBasenameTerms=L;function M(K){return K.allPaths||[]}e.getPathTerms=M;function $(K,q){const V=W(Object.getOwnPropertyNames(K).map(T=>G(T,K[T],q)).filter(T=>T!==t)),Z=V.length;if(!Z)return t;if(!V.some(T=>!!T.requiresSiblings)){if(Z===1)return V[0];const T=function(B,Q){let re;for(let X=0,te=V.length;X<te;X++){const se=V[X](B,Q);if(typeof se=="string")return se;(0,i.isThenable)(se)&&(re||(re=[]),re.push(se))}return re?(async()=>{for(const X of re){const te=await X;if(typeof te=="string")return te}return null})():null},N=V.find(B=>!!B.allBasenames);N&&(T.allBasenames=N.allBasenames);const H=V.reduce((B,Q)=>Q.allPaths?B.concat(Q.allPaths):B,[]);return H.length&&(T.allPaths=H),T}const ne=function(T,N,H){let B,Q;for(let re=0,X=V.length;re<X;re++){const te=V[re];te.requiresSiblings&&H&&(N||(N=(0,O.basename)(T)),B||(B=N.substr(0,N.length-(0,O.extname)(T).length)));const se=te(T,N,B,H);if(typeof se=="string")return se;(0,i.isThenable)(se)&&(Q||(Q=[]),Q.push(se))}return Q?(async()=>{for(const re of Q){const X=await re;if(typeof X=="string")return X}return null})():null},J=V.find(T=>!!T.allBasenames);J&&(ne.allBasenames=J.allBasenames);const x=V.reduce((T,N)=>N.allPaths?T.concat(N.allPaths):T,[]);return x.length&&(ne.allPaths=x),ne}function G(K,q,V){if(q===!1)return t;const Z=o(K,V);if(Z===t)return t;if(typeof q=="boolean")return Z;if(q){const ne=q.when;if(typeof ne=="string"){const J=(x,T,N,H)=>{if(!H||!Z(x,T))return null;const B=ne.replace("$(basename)",()=>N),Q=H(B);return(0,i.isThenable)(Q)?Q.then(re=>re?K:null):Q?K:null};return J.requiresSiblings=!0,J}}return Z}function W(K,q){const V=K.filter(T=>!!T.basenames);if(V.length<2)return K;const Z=V.reduce((T,N)=>{const H=N.basenames;return H?T.concat(H):T},[]);let ne;if(q){ne=[];for(let T=0,N=Z.length;T<N;T++)ne.push(q)}else ne=V.reduce((T,N)=>{const H=N.patterns;return H?T.concat(H):T},[]);const J=function(T,N){if(typeof T!="string")return null;if(!N){let B;for(B=T.length;B>0;B--){const Q=T.charCodeAt(B-1);if(Q===47||Q===92)break}N=T.substr(B)}const H=Z.indexOf(N);return H!==-1?ne[H]:null};J.basenames=Z,J.patterns=ne,J.allBasenames=Z;const x=K.filter(T=>!T.basenames);return x.push(J),x}function _(K,q){return(0,k.equals)(K,q,(V,Z)=>typeof V=="string"&&typeof Z=="string"?V===Z:typeof V!="string"&&typeof Z!="string"?V.base===Z.base&&V.pattern===Z.pattern:!1)}e.patternsEquals=_}),define(oe[142],ae([0,1,7]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function i(C){return C.toJSON()}class D{constructor(E){this.a=E}transformIncoming(E){const w=this.a.transformIncoming(E);return w===E?E:i(k.URI.from(w))}transformOutgoing(E){const w=this.a.transformOutgoing(E);return w===E?E:i(k.URI.from(w))}transformOutgoingURI(E){const w=this.a.transformOutgoing(E);return w===E?E:k.URI.from(w)}transformOutgoingScheme(E){return this.a.transformOutgoingScheme(E)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function A(C,E,w){if(!C||w>200)return null;if(typeof C=="object"){if(C instanceof k.URI)return E.transformOutgoing(C);for(const p in C)if(Object.hasOwnProperty.call(C,p)){const f=A(C[p],E,w+1);f!==null&&(C[p]=f)}}return null}function O(C,E){const w=A(C,E,0);return w===null?C:w}e.transformOutgoingURIs=O;function P(C,E,w,p){if(!C||p>200)return null;if(typeof C=="object"){if(C.$mid===1)return w?k.URI.revive(E.transformIncoming(C)):E.transformIncoming(C);for(const f in C)if(Object.hasOwnProperty.call(C,f)){const y=P(C[f],E,w,p+1);y!==null&&(C[f]=y)}}return null}function I(C,E){const w=P(C,E,!1,0);return w===null?C:w}e.transformIncomingURIs=I;function S(C,E){const w=P(C,E,!0,0);return w===null?C:w}e.transformAndReviveIncomingURIs=S}),define(oe[143],ae([0,1,34,9,48,31,129]),function(ee,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(C){return this.a||(this.a=D.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(C)}value(){if(this.b===void 0){let C=0,E=0;const w=(0,k.networkInterfaces)();for(const p in w){const f=w[p];if(f)for(const{mac:y,internal:v}of f)v||(E+=1,this.c(y.toUpperCase())&&(C+=1))}this.b=E>0?C/E:0}return this.b}};let P;async function I(){return P||(P=(async()=>await S()||A.generateUuid())()),P}e.getMachineId=I;async function S(){try{const C=await new Promise((w,p)=>{ee(["crypto"],w,p)}),E=(0,O.getMac)();return C.createHash("sha256").update(E,"utf8").digest("hex")}catch(C){i.onUnexpectedError(C);return}}}),define(oe[28],ae([0,1,52,34,282,6,47,85,12,5,21,7]),function(ee,e,k,i,D,A,O,P,I,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(w=e.RimRafMode||(e.RimRafMode={}));async function p($,G=w.UNLINK){if((0,O.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return G===w.UNLINK?y($):f($)}async function f($){try{const G=(0,O.randomPath)((0,i.tmpdir)());try{await k.promises.rename($,G)}catch(W){return W.code==="ENOENT"?void 0:y($)}y(G).catch(W=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function y($){return(0,D.promisify)(k.rm)($,{recursive:!0,force:!0,maxRetries:3})}function v($){if((0,O.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync($,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=v;async function l($,G){return d(await(G?m($):(0,D.promisify)(k.readdir)($)))}async function m($){try{return await(0,D.promisify)(k.readdir)($,{withFileTypes:!0})}catch(_){console.warn("[node.js fs] readdir with filetypes failed with error: ",_)}const G=[],W=await l($);for(const _ of W){let K=!1,q=!1,V=!1;try{const Z=await e.Promises.lstat((0,I.join)($,_));K=Z.isFile(),q=Z.isDirectory(),V=Z.isSymbolicLink()}catch(Z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Z)}G.push({name:_,isFile:()=>K,isDirectory:()=>q,isSymbolicLink:()=>V})}return G}function u($){return d(k.readdirSync($))}e.readdirSync=u;function d($){return $.map(G=>typeof G=="string"?S.isMacintosh?(0,P.normalizeNFC)(G):G:(G.name=S.isMacintosh?(0,P.normalizeNFC)(G.name):G.name,G))}async function h($){const G=await l($),W=[];for(const _ of G)await r.existsDirectory((0,I.join)($,_))&&W.push(_);return W}function n($,G=1e3){return new Promise(W=>{let _=!1;const K=setInterval(()=>{_||(_=!0,k.access($,q=>{_=!1,q&&(clearInterval(K),W(void 0))}))},G)})}e.whenDeleted=n;var r;(function($){async function G(K){let q;try{if(q=await e.Promises.lstat(K),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(K),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(S.isWindows&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(K)),symbolicLink:{dangling:!1}}}catch(Z){if(Z.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw Z}throw V}}$.stat=G;async function W(K){try{const{stat:q,symbolicLink:V}=await $.stat(K);return q.isFile()&&V?.dangling!==!0}catch{}return!1}$.existsFile=W;async function _(K){try{const{stat:q,symbolicLink:V}=await $.stat(K);return q.isDirectory()&&V?.dangling!==!0}catch{}return!1}$.existsDirectory=_})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new A.ResourceQueue;function o($,G,W){return t.queueFor(E.URI.file($),C.extUriBiasedIgnorePathCase).queue(()=>{const _=b(W);return new Promise((K,q)=>a($,G,_,V=>V?q(V):K()))})}let s=!0;function c($){s=$}e.configureFlushOnWrite=c;function a($,G,W,_){if(!s)return k.writeFile($,G,{mode:W.mode,flag:W.flag},_);k.open($,W.flag,W.mode,(K,q)=>{if(K)return _(K);k.writeFile(q,G,V=>{if(V)return k.close(q,()=>_(V));k.fdatasync(q,Z=>(Z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Z),c(!1)),k.close(q,ne=>_(ne))))})})}function g($,G,W){const _=b(W);if(!s)return k.writeFileSync($,G,{mode:_.mode,flag:_.flag});const K=k.openSync($,_.flag,_.mode);try{k.writeFileSync(K,G);try{k.fdatasyncSync(K)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),c(!1)}}finally{k.closeSync(K)}}e.writeFileSync=g;function b($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function R($,G){if($!==G)try{await e.Promises.rename($,G)}catch(W){if($.toLowerCase()!==G.toLowerCase()&&W.code==="EXDEV"||$.endsWith("."))await j($,G,{preserveSymlinks:!1}),await p($,w.MOVE);else throw W}}async function j($,G,W){return z($,G,{root:{source:$,target:G},options:W,handledSourcePaths:new Set})}const U=511;async function z($,G,W){if(W.handledSourcePaths.has($))return;W.handledSourcePaths.add($);const{stat:_,symbolicLink:K}=await r.stat($);if(K){if(W.options.preserveSymlinks)try{return await M($,G,W)}catch(q){console.warn("[node.js fs] copy of symlink failed: ",q)}if(K.dangling)return}return _.isDirectory()?F($,G,_.mode&U,W):L($,G,_.mode&U)}async function F($,G,W,_){await e.Promises.mkdir(G,{recursive:!0,mode:W});const K=await l($);for(const q of K)await z((0,I.join)($,q),(0,I.join)(G,q),_)}async function L($,G,W){await e.Promises.copyFile($,G),await e.Promises.chmod(G,W)}async function M($,G,W){let _=await e.Promises.readlink($);(0,O.isEqualOrParent)(_,W.root.source,!S.isLinux)&&(_=(0,I.join)(W.root.target,_.substr(W.root.source.length+1))),await e.Promises.symlink(_,G)}e.Promises=new class{get access(){return(0,D.promisify)(k.access)}get stat(){return(0,D.promisify)(k.stat)}get lstat(){return(0,D.promisify)(k.lstat)}get utimes(){return(0,D.promisify)(k.utimes)}get read(){return($,G,W,_,K)=>new Promise((q,V)=>{k.read($,G,W,_,K,(Z,ne,J)=>Z?V(Z):q({bytesRead:ne,buffer:J}))})}get readFile(){return(0,D.promisify)(k.readFile)}get write(){return($,G,W,_,K)=>new Promise((q,V)=>{k.write($,G,W,_,K,(Z,ne,J)=>Z?V(Z):q({bytesWritten:ne,buffer:J}))})}get appendFile(){return(0,D.promisify)(k.appendFile)}get fdatasync(){return(0,D.promisify)(k.fdatasync)}get truncate(){return(0,D.promisify)(k.truncate)}get rename(){return(0,D.promisify)(k.rename)}get copyFile(){return(0,D.promisify)(k.copyFile)}get open(){return(0,D.promisify)(k.open)}get close(){return(0,D.promisify)(k.close)}get symlink(){return(0,D.promisify)(k.symlink)}get readlink(){return(0,D.promisify)(k.readlink)}get chmod(){return(0,D.promisify)(k.chmod)}get mkdir(){return(0,D.promisify)(k.mkdir)}get unlink(){return(0,D.promisify)(k.unlink)}get rmdir(){return(0,D.promisify)(k.rmdir)}get realpath(){return(0,D.promisify)(k.realpath)}async exists($){try{return await e.Promises.access($),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return h}get writeFile(){return o}get rm(){return p}get move(){return R}get copy(){return j}}}),define(oe[144],ae([0,1,52,12,5,27,28]),function(ee,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(w){if(D.isLinux)return w;const p=(0,i.dirname)(w);if(w===p)return w;const f=((0,i.basename)(w)||w).toLowerCase();try{const v=(0,O.readdirSync)(p).filter(l=>l.toLowerCase()===f);if(v.length===1){const l=P(p);if(l)return(0,i.join)(l,v[0])}else if(v.length>1){const l=v.indexOf(f);if(l>=0){const m=P(p);if(m)return(0,i.join)(m,v[l])}}}catch{}return null}e.realcaseSync=P;async function I(w){if(D.isLinux)return w;const p=(0,i.dirname)(w);if(w===p)return w;const f=((0,i.basename)(w)||w).toLowerCase();try{const v=(await O.Promises.readdir(p)).filter(l=>l.toLowerCase()===f);if(v.length===1){const l=await I(p);if(l)return(0,i.join)(l,v[0])}else if(v.length>1){const l=v.indexOf(f);if(l>=0){const m=await I(p);if(m)return(0,i.join)(m,v[l])}}}catch{}return null}e.realcase=I;async function S(w){try{return await O.Promises.realpath(w)}catch{const f=E(w);return await O.Promises.access(f,k.constants.R_OK),f}}e.realpath=S;function C(w){try{return k.realpathSync(w)}catch{const f=E(w);return k.accessSync(f,k.constants.R_OK),f}}e.realpathSync=C;function E(w){return(0,A.rtrim)((0,i.normalize)(w),i.sep)}}),define(oe[90],ae([0,1,34,12,28]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,O=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var I;(function(d){d[d.x64=0]="x64",d[d.x86=1]="x86",d[d.ARM=2]="ARM"})(I||(I={}));let S;switch(process.arch){case"ia32":case"x32":S=1;break;case"arm":case"arm64":S=2;break;default:S=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class E{constructor(h,n,r){this.exePath=h,this.displayName=n,this.a=r}async exists(){return this.a===void 0&&(this.a=await D.SymlinkSupport.existsFile(this.exePath)),this.a}}function w({useAlternateBitness:d=!1}={}){return d?S===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:d=!1,findPreview:h=!1}={}){const n=w({useAlternateBitness:d});if(!n)return null;const r=i.join(n,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(r))return null;let t=-1,o=null;for(const a of await D.Promises.readdir(r)){let g=-1;if(h){const R=a.indexOf("-");if(R<0)continue;const j=a.substring(0,R);if(!A.test(j)||a.substring(R+1)!=="preview")continue;g=parseInt(j,10)}else{if(!A.test(a))continue;g=parseInt(a,10)}if(g<=t)continue;const b=i.join(r,a,"pwsh.exe");!await D.SymlinkSupport.existsFile(b)||(o=b,t=g)}if(!o)return null;const s=n.includes("x86")?" (x86)":"",c=h?" Preview":"";return new E(o,`PowerShell${c}${s}`,!0)}async function f({findPreview:d}={}){if(!process.env.LOCALAPPDATA)return null;const h=i.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(h))return null;const{pwshMsixDirRegex:n,pwshMsixName:r}=d?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const t of await D.Promises.readdir(h))if(n.test(t)){const o=i.join(h,t,"pwsh.exe");return new E(o,r)}return null}function y(){const d=i.join(k.homedir(),".dotnet","tools","pwsh.exe");return new E(d,".NET Core PowerShell Global Tool")}function v(){const d=i.join(process.env.windir,S===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(d,"Windows PowerShell",!0)}async function*l(){let d=await p();d&&(yield d),d=await p({useAlternateBitness:!0}),d&&(yield d),d=await f(),d&&(yield d),d=y(),d&&(yield d),d=await p({findPreview:!0}),d&&(yield d),d=await f({findPreview:!0}),d&&(yield d),d=await p({useAlternateBitness:!0,findPreview:!0}),d&&(yield d),d=v(),d&&(yield d)}async function*m(){for await(const d of l())await d.exists()&&(yield d)}e.enumeratePowerShellInstallations=m;async function u(){for await(const d of m())return d;return null}e.getFirstAvailablePowerShellInstallation=u}),define(oe[91],ae([0,1,12,5,36,87,14,28]),function(ee,e,k,i,D,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function I(E=D.env){return E.comspec||"cmd.exe"}e.getWindowsShell=I;function S(E){let w=[],p=!1;const f=function(y){if(p){w.push(y);return}(!E.send(y,l=>{if(l&&console.error(l),p=!1,w.length>0){const m=w.slice(0);w=[],m.forEach(u=>f(u))}})||i.isWindows)&&(p=!0)};return{send:f}}e.createQueuedSender=S;var C;(function(E){async function w(p,f,y){if(k.isAbsolute(p))return p;if(f===void 0&&(f=D.cwd()),k.dirname(p)!=="."||(y===void 0&&O.isString(D.env.PATH)&&(y=D.env.PATH.split(k.delimiter)),y===void 0||y.length===0))return k.join(f,p);async function l(m){if(await P.Promises.exists(m)){let u;try{u=await P.Promises.stat(m)}catch(d){d.message.startsWith("EACCES")&&(u=await P.Promises.lstat(m))}return u?!u.isDirectory():!1}return!1}for(const m of y){let u;if(k.isAbsolute(m)?u=k.join(m,p):u=k.join(f,m,p),await l(u))return u;let d=u+".com";if(await l(d)||(d=u+".exe",await l(d)))return d}return k.join(f,p)}E.findExecutable=w})(C=e.win32||(e.win32={}))}),define(oe[145],ae([0,1,49,24]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(O){return new Promise((P,I)=>{let S;const C=new Map;function E(p,f,y,v,l){const m=C.get(f);if(p===O||m){const u={name:w(y),cmd:y,pid:p,ppid:f,load:v,mem:l};C.set(p,u),p===O&&(S=u),m&&(m.children||(m.children=[]),m.children.push(u),m.children.length>1&&(m.children=m.children.sort((d,h)=>d.pid-h.pid)))}}function w(p){const f=/--vscode-window-kind=shared-process/,y=/--vscode-window-kind=issue-reporter/,v=/--vscode-window-kind=process-explorer/,l=/--utility-sub-type=network/,m=/--utility-sub-type=node.mojom.NodeService/,u=/--crashes-directory/,d=/\\pipe\\winpty-control/,h=/conhost\.exe/,n=/--type=([a-zA-Z-]+)/;if(u.exec(p))return"electron-crash-reporter";if(d.exec(p))return"winpty-process";if(h.exec(p))return"console-window-host (Windows internal process)";let r=n.exec(p);if(r&&r.length===2){if(r[1]==="renderer")return f.exec(p)?"shared-process":y.exec(p)?"issue-reporter":v.exec(p)?"process-explorer":"window";if(r[1]==="utility"){if(l.exec(p))return"utility-network-service";if(m.exec(p))return"extension-host"}return r[1]}const t=/[a-zA-Z-]+\.js/g;let o="";do r=t.exec(p),r&&(o+=r+" ");while(r);return o&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${o}`:p}if(process.platform==="win32"){const p=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substr(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substr(5):f;new Promise((f,y)=>{ee(["windows-process-tree"],f,y)}).then(f=>{f.getProcessList(O,y=>{if(!y){I(new Error(`Root process ${O} not found`));return}f.getProcessCpuUsage(y,v=>{const l=new Map;v.forEach(m=>{const u=p(m.commandLine||"");l.set(m.pid,{name:w(u),cmd:u,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),S=l.get(O),S?(l.forEach(m=>{const u=l.get(m.ppid);u&&(u.children||(u.children=[]),u.children.push(m))}),l.forEach(m=>{m.children&&(m.children=m.children.sort((u,d)=>u.pid-d.pid))}),P(S)):I(new Error(`Root process ${O} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let p=function(){let f=[S];const y=[];for(;f.length;){const l=f.shift();l&&(y.push(l.pid),l.children&&(f=f.concat(l.children)))}let v=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);v+=" "+y.join(" "),(0,k.exec)(v,{},(l,m,u)=>{if(l||u)I(l||new Error(u.toString()));else{const d=m.toString().split(`
`);for(let h=0;h<y.length;h++){const n=C.get(y[h]);n.load=parseFloat(d[h])}if(!S){I(new Error(`Root process ${O} not found`));return}P(S)}})};(0,k.exec)("which ps",{},(f,y,v)=>{if(f||v)if(process.platform!=="linux")I(f||new Error(v.toString()));else{const l=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,k.exec)(l,{},(m,u,d)=>{m||d?I(m||new Error(d.toString())):(A(u,E),p())})}else{const l=y.toString().trim(),m="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${l} ${m}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,d,h)=>{u||h&&!h.includes("screen size is bogus")?I(u||new Error(h.toString())):(A(d,E),process.platform==="linux"?p():S?P(S):I(new Error(`Root process ${O} not found`)))})}})}})}e.listProcesses=D;function A(O,P){const I=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,S=O.toString().split(`
`);for(const C of S){const E=I.exec(C.trim());E&&E.length===6&&P(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(oe[146],ae([0,1,34,5,90,91]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function O(E,w){return E===1?i.isWindows?C():A.getWindowsShell(w):I(E,w)}e.getSystemShell=O;let P=null;function I(E,w){if(i.isLinux&&E===2||i.isMacintosh&&E===3)return"/bin/bash";if(!P){let p;if(i.isWindows)p="/bin/bash";else{if(p=w.SHELL,!p)try{p=(0,k.userInfo)().shell}catch{}p||(p="sh"),p==="/bin/false"&&(p="/bin/bash")}P=p}return P}let S=null;async function C(){return S||(S=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),S}});var pe=this&&this.__decorate||function(ee,e,k,i){var D=arguments.length,A=D<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,k):i,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ee,e,k,i);else for(var P=ee.length-1;P>=0;P--)(O=ee[P])&&(A=(D<3?O(A):D>3?O(e,k,A):O(e,k))||A);return D>3&&A&&Object.defineProperty(e,k,A),A};define(oe[39],ae([0,1,20,6,17,23,63,9,3,2,67,27,14]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var p;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(p||(p={}));function f(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(y||(y={}));function v(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(l||(l={}));function m(q){let V=0;for(let Z=0;;Z+=7){const ne=q.read(1);if(V|=(ne.buffer[0]&127)<<Z,!(ne.buffer[0]&128))return V}}const u=t(0);function d(q,V){if(V===0){q.write(u);return}let Z=0;for(let J=V;J!==0;J=J>>>7)Z++;const ne=D.VSBuffer.alloc(Z);for(let J=0;V!==0;J++)ne.buffer[J]=V&127,V=V>>>7,V>0&&(ne.buffer[J]|=128);q.write(ne)}class h{constructor(V){this.b=V,this.a=0}read(V){const Z=this.b.slice(this.a,this.a+V);return this.a+=Z.byteLength,Z}}e.BufferReader=h;class n{constructor(){this.a=[]}get buffer(){return D.VSBuffer.concat(this.a)}write(V){this.a.push(V)}}e.BufferWriter=n;var r;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(r||(r={}));function t(q){const V=D.VSBuffer.alloc(1);return V.writeUInt8(q,0),V}const o={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},s=typeof Buffer<"u";function c(q,V){if(typeof V>"u")q.write(o.Undefined);else if(typeof V=="string"){const Z=D.VSBuffer.fromString(V);q.write(o.String),d(q,Z.byteLength),q.write(Z)}else if(s&&Buffer.isBuffer(V)){const Z=D.VSBuffer.wrap(V);q.write(o.Buffer),d(q,Z.byteLength),q.write(Z)}else if(V instanceof D.VSBuffer)q.write(o.VSBuffer),d(q,V.byteLength),q.write(V);else if(Array.isArray(V)){q.write(o.Array),d(q,V.length);for(const Z of V)c(q,Z)}else if(typeof V=="number"&&(V|0)===V)q.write(o.Uint),d(q,V);else{const Z=D.VSBuffer.fromString(JSON.stringify(V));q.write(o.Object),d(q,Z.byteLength),q.write(Z)}}e.serialize=c;function a(q){switch(q.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return q.read(m(q)).toString();case r.Buffer:return q.read(m(q)).buffer;case r.VSBuffer:return q.read(m(q));case r.Array:{const Z=m(q),ne=[];for(let J=0;J<Z;J++)ne.push(a(q));return ne}case r.Object:return JSON.parse(q.read(m(q)).toString());case r.Int:return m(q)}}e.deserialize=a;class g{constructor(V,Z,ne=null,J=1e3){this.h=V,this.j=Z,this.k=ne,this.l=J,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(x=>this.q(x)),this.m({type:200})}registerChannel(V,Z){this.b.set(V,Z),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const Z=this.o([V.type]);this.k?.logOutgoing(Z,0,1,v(V.type));return}case 201:case 202:case 204:case 203:{const Z=this.o([V.type,V.id],V.data);this.k?.logOutgoing(Z,V.id,1,v(V.type),V.data);return}}}o(V,Z=void 0){const ne=new n;return c(ne,V),c(ne,Z),this.p(ne.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const Z=new h(V),ne=a(Z),J=a(Z),x=ne[0];switch(x){case 100:return this.k?.logIncoming(V.byteLength,ne[1],1,`${f(x)}: ${ne[2]}.${ne[3]}`,J),this.s({type:x,id:ne[1],channelName:ne[2],name:ne[3],arg:J});case 102:return this.k?.logIncoming(V.byteLength,ne[1],1,`${f(x)}: ${ne[2]}.${ne[3]}`,J),this.t({type:x,id:ne[1],channelName:ne[2],name:ne[3],arg:J});case 101:return this.k?.logIncoming(V.byteLength,ne[1],1,`${f(x)}`),this.u({type:x,id:ne[1]});case 103:return this.k?.logIncoming(V.byteLength,ne[1],1,`${f(x)}`),this.u({type:x,id:ne[1]})}}s(V){const Z=this.b.get(V.channelName);if(!Z){this.v(V);return}const ne=new A.CancellationTokenSource;let J;try{J=Z.call(this.j,V.name,V.arg,ne.token)}catch(N){J=Promise.reject(N)}const x=V.id;J.then(N=>{this.m({id:x,data:N,type:201}),this.d.delete(V.id)},N=>{N instanceof Error?this.m({id:x,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.m({id:x,data:N,type:203}),this.d.delete(V.id)});const T=(0,S.toDisposable)(()=>ne.cancel());this.d.set(V.id,T)}t(V){const Z=this.b.get(V.channelName);if(!Z){this.v(V);return}const ne=V.id,x=Z.listen(this.j,V.name,V.arg)(T=>this.m({id:ne,data:T,type:204}));this.d.set(V.id,x)}u(V){const Z=this.d.get(V.id);Z&&(Z.dispose(),this.d.delete(V.id))}v(V){let Z=this.g.get(V.channelName);Z||(Z=[],this.g.set(V.channelName,Z));const ne=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Z.push({request:V,timeoutTimer:ne})}w(V){const Z=this.g.get(V);if(Z){for(const ne of Z)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,S.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=g;var b;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(b=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(V,Z=null){this.l=V,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new I.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=Z}getChannel(V){const Z=this;return{call(ne,J,x){return Z.a?Promise.reject(new P.CancellationError):Z.m(V,ne,J,x)},listen(ne,J){return Z.a?I.Event.None:Z.o(V,ne,J)}}}m(V,Z,ne,J=A.CancellationToken.None){const x=this.g++,N={id:x,type:100,channelName:V,name:Z,arg:ne};if(J.isCancellationRequested)return Promise.reject(new P.CancellationError);let H;return new Promise((Q,re)=>{if(J.isCancellationRequested)return re(new P.CancellationError);const X=()=>{const ue=ye=>{switch(ye.type){case 201:this.f.delete(x),Q(ye.data);break;case 202:{this.f.delete(x);const Se=new Error(ye.data.message);Se.stack=Array.isArray(ye.data.stack)?ye.data.stack.join(`
`):ye.data.stack,Se.name=ye.data.name,re(Se);break}case 203:this.f.delete(x),re(ye.data);break}};this.f.set(x,ue),this.p(N)};let te=null;this.b===l.Idle?X():(te=(0,i.createCancelablePromise)(ue=>this.u()),te.then(()=>{te=null,X()}));const se=()=>{te?(te.cancel(),te=null):this.p({id:x,type:101}),re(new P.CancellationError)},le=J.onCancellationRequested(se);H=(0,S.combinedDisposable)((0,S.toDisposable)(se),le),this.d.add(H)}).finally(()=>{this.d.delete(H)})}o(V,Z,ne){const J=this.g++,T={id:J,type:102,channelName:V,name:Z,arg:ne};let N=null;const H=new I.Emitter({onWillAddFirstListener:()=>{N=(0,i.createCancelablePromise)(Q=>this.u()),N.then(()=>{N=null,this.d.add(H),this.p(T)})},onDidRemoveLastListener:()=>{N?(N.cancel(),N=null):(this.d.delete(H),this.p({id:J,type:103}))}}),B=Q=>H.fire(Q.data);return this.f.set(J,B),H.event}p(V){switch(V.type){case 100:case 102:{const Z=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(Z,V.id,0,`${f(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const Z=this.q([V.type,V.id]);this.j?.logOutgoing(Z,V.id,0,f(V.type));return}}}q(V,Z=void 0){const ne=new n;return c(ne,V),c(ne,Z),this.r(ne.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const Z=new h(V),ne=a(Z),J=a(Z),x=ne[0];switch(x){case 200:return this.j?.logIncoming(V.byteLength,0,0,v(x)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,ne[1],0,v(x),J),this.t({type:ne[0],id:ne[1],data:J})}}t(V){if(V.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return I.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,S.dispose)(this.d.values()),this.d.clear()}}pe([O.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class j{get connections(){const V=[];return this.f.forEach(Z=>V.push(Z)),V}constructor(V){this.a=new Map,this.f=new Set,this.g=new I.Emitter,this.onDidAddConnection=this.g.event,this.h=new I.Emitter,this.onDidRemoveConnection=this.h.event,V(({protocol:Z,onDidClientDisconnect:ne})=>{I.Event.once(Z.onMessage)(x=>{const T=new h(x),N=a(T),H=new g(Z,N),B=new R(Z);this.a.forEach((re,X)=>H.registerChannel(X,re));const Q={channelServer:H,channelClient:B,ctx:N};this.f.add(Q),this.g.fire(Q),ne(()=>{H.dispose(),B.dispose(),this.f.delete(Q),this.h.fire(Q)})})})}getChannel(V,Z){const ne=this;return{call(J,x,T){let N;if((0,w.isFunction)(Z)){const B=(0,k.getRandomElement)(ne.connections.filter(Z));N=B?Promise.resolve(B):I.Event.toPromise(I.Event.filter(ne.onDidAddConnection,Z))}else N=Z.routeCall(ne,J,x);const H=N.then(B=>B.channelClient.getChannel(V));return z(H).call(J,x,T)},listen(J,x){if((0,w.isFunction)(Z))return ne.j(V,Z,J,x);const T=Z.routeEvent(ne,J,x).then(N=>N.channelClient.getChannel(V));return z(T).listen(J,x)}}}j(V,Z,ne,J){const x=this;let T=new S.DisposableStore;const N=new I.Emitter({onWillAddFirstListener:()=>{T=new S.DisposableStore;const H=new I.EventMultiplexer,B=new Map,Q=X=>{const se=X.channelClient.getChannel(V).listen(ne,J),le=H.add(se);B.set(X,le)},re=X=>{const te=B.get(X);!te||(te.dispose(),B.delete(X))};x.connections.filter(Z).forEach(Q),I.Event.filter(x.onDidAddConnection,Z)(Q,void 0,T),x.onDidRemoveConnection(re,void 0,T),H.event(N.fire,N,T),T.add(H)},onDidRemoveLastListener:()=>{T.dispose()}});return N.event}registerChannel(V,Z){this.a.set(V,Z),this.f.forEach(ne=>{ne.channelServer.registerChannel(V,Z)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=j;class U{constructor(V,Z,ne=null){const J=new n;c(J,Z),V.send(J.buffer),this.a=new R(V,ne),this.d=new g(V,Z,ne)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,Z){this.d.registerChannel(V,Z)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=U;function z(q){return{call(V,Z,ne){return q.then(J=>J.call(V,Z,ne))},listen(V,Z){const ne=new I.Relay;return q.then(J=>ne.input=J.listen(V,Z)),ne.event}}}e.getDelayedChannel=z;function F(q){let V=!1;return{call(Z,ne,J){return V?q.call(Z,ne,J):(0,i.timeout)(0).then(()=>V=!0).then(()=>q.call(Z,ne,J))},listen(Z,ne){if(V)return q.listen(Z,ne);const J=new I.Relay;return(0,i.timeout)(0).then(()=>V=!0).then(()=>J.input=q.listen(Z,ne)),J.event}}}e.getNextTickChannel=F;class L{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const Z of V.connections)if(await Promise.resolve(this.a(Z.ctx)))return Promise.resolve(Z);return await I.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.StaticRouter=L;var M;(function(q){function V(x,T){const N=x,H=T&&T.disableMarshalling,B=new Map;for(const Q in N)ne(Q)&&B.set(Q,I.Event.buffer(N[Q],!0));return new class{listen(Q,re,X){const te=B.get(re);if(te)return te;if(J(re)){const se=N[re];if(typeof se=="function")return se.call(N,X)}throw new Error(`Event not found: ${re}`)}call(Q,re,X){const te=N[re];if(typeof te=="function"){if(!H&&Array.isArray(X))for(let se=0;se<X.length;se++)X[se]=(0,C.revive)(X[se]);return te.apply(N,X)}throw new Error(`Method not found: ${re}`)}}}q.fromService=V;function Z(x,T){const N=T&&T.disableMarshalling;return new Proxy({},{get(H,B){if(typeof B=="string")return T?.properties?.has(B)?T.properties.get(B):J(B)?function(Q){return x.listen(B,Q)}:ne(B)?x.listen(B):async function(...Q){let re;T&&!(0,w.isUndefinedOrNull)(T.context)?re=[T.context,...Q]:re=Q;const X=await x.call(B,re);return N?X:(0,C.revive)(X)};throw new Error(`Property not found: ${String(B)}`)}})}q.toService=Z;function ne(x){return x[0]==="o"&&x[1]==="n"&&E.isUpperAsciiLetter(x.charCodeAt(2))}function J(x){return/^onDynamic/.test(x)&&E.isUpperAsciiLetter(x.charCodeAt(9))}})(M=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function G(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const V=q.toString();if(V!=="[object Object]")return V}return q}function W(q){return Array.isArray(q)?q.map(G):G(q)}function _(q,V,Z,ne,J,x,T){T=W(T);const N=$[J],H=N[ne%N.length];let B=[`%c[${q}]%c[${String(V).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${H}`];/\($/.test(x)?(B=B.concat(T),B.push(")")):B.push(T),console.log.apply(console,B)}class K{constructor(V,Z){this.d=V,this.f=Z,this.a=0,this.b=0}logOutgoing(V,Z,ne,J,x){this.b+=V,_(this.d,this.b,V,Z,ne,J,x)}logIncoming(V,Z,ne,J,x){this.a+=V,_(this.f,this.a,V,Z,ne,J,x)}}e.IPCLogger=K}),define(oe[147],ae([0,1,17,3,39]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(I){this.a=I,this.onMessage=i.Event.fromDOMEventEmitter(this.a,"message",S=>k.VSBuffer.wrap(S.data)),I.start()}send(I){this.a.postMessage(I.buffer)}disconnect(){this.a.close()}}e.Protocol=A;class O extends D.IPCClient{constructor(I,S){const C=new A(I);super(C,S),this.b=C}dispose(){this.b.disconnect()}}e.Client=O}),define(oe[92],ae([0,1,17,3,2,39]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(o){o.Created="created",o.Read="read",o.Write="write",o.Open="open",o.Error="error",o.Close="close",o.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",o.NodeEndReceived="nodeEndReceived",o.NodeEndSent="nodeEndSent",o.NodeDrainBegin="nodeDrainBegin",o.NodeDrainEnd="nodeDrainEnd",o.zlibInflateError="zlibInflateError",o.zlibInflateData="zlibInflateData",o.zlibInflateInitialWrite="zlibInflateInitialWrite",o.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",o.zlibInflateWrite="zlibInflateWrite",o.zlibInflateFlushFired="zlibInflateFlushFired",o.zlibDeflateError="zlibDeflateError",o.zlibDeflateData="zlibDeflateData",o.zlibDeflateWrite="zlibDeflateWrite",o.zlibDeflateFlushFired="zlibDeflateFlushFired",o.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",o.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",o.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",o.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",o.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",o.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",o.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",o.ProtocolHeaderRead="protocolHeaderRead",o.ProtocolMessageRead="protocolMessageRead",o.ProtocolHeaderWrite="protocolHeaderWrite",o.ProtocolMessageWrite="protocolMessageWrite",o.ProtocolWrite="protocolWrite"})(O=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(o){o.enableDiagnostics=!1,o.records=[];const s=new WeakMap;let c=0;function a(b,R){if(!s.has(b)){const j=String(++c);s.set(b,j)}return s.get(b)}function g(b,R,j,U){if(!o.enableDiagnostics)return;const z=a(b,R);if(U instanceof k.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const F=k.VSBuffer.alloc(U.byteLength);F.set(U),o.records.push({timestamp:Date.now(),id:z,label:R,type:j,buff:F})}else o.records.push({timestamp:Date.now(),id:z,label:R,type:j,data:U})}o.traceSocketEvent=g})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var I;(function(o){o[o.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",o[o.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(I=e.SocketCloseEventType||(e.SocketCloseEventType={}));let S=null;function C(){return S||(S=k.VSBuffer.alloc(0)),S}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,c){if(s===0)return C();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const R=this.a[0];return c&&(this.a.shift(),this.b-=s),R}if(this.a[0].byteLength>s){const R=this.a[0].slice(0,s);return c&&(this.a[0]=this.a[0].slice(s),this.b-=s),R}const a=k.VSBuffer.alloc(s);let g=0,b=0;for(;s>0;){const R=this.a[b];if(R.byteLength>s){const j=R.slice(0,s);a.set(j,g),g+=s,c&&(this.a[b]=R.slice(s),this.b-=s),s-=s}else a.set(R,g),g+=R.byteLength,c?(this.a.shift(),this.b-=R.byteLength):b++,s-=R.byteLength}return a}}e.ChunkStream=E;var w;(function(o){o[o.None=0]="None",o[o.Regular=1]="Regular",o[o.Control=2]="Control",o[o.Ack=3]="Ack",o[o.Disconnect=5]="Disconnect",o[o.ReplayRequest=6]="ReplayRequest",o[o.Pause=7]="Pause",o[o.Resume=8]="Resume",o[o.KeepAlive=9]="KeepAlive"})(w||(w={}));function p(o){switch(o){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var f;(function(o){o[o.HeaderLength=13]="HeaderLength",o[o.AcknowledgeTime=2e3]="AcknowledgeTime",o[o.TimeoutTime=2e4]="TimeoutTime",o[o.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",o[o.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class y{constructor(s,c,a,g){this.type=s,this.id=c,this.ack=a,this.data=g,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends D.Disposable{constructor(s){super(),this.f=this.B(new i.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=s,this.b=!1,this.c=new E,this.B(this.a.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const c=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=c.readUInt32BE(9),this.g.messageType=c.readUInt8(0),this.g.id=c.readUInt32BE(1),this.g.ack=c.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:p(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,g=this.g.id,b=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",c),this.f.fire(new y(a,g,b,c)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class l{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=k.VSBuffer.alloc(13);c.writeUInt8(s.type,0),c.writeUInt32BE(s.id,1),c.writeUInt32BE(s.ack,5),c.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:p(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",s.data),this.j(c,s.data)}g(s,c){const a=this.f===0;return this.d.push(s,c),this.f+=s.byteLength+c.byteLength,a}h(){const s=k.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,c){this.g(s,c)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this.c.write(s)}}class m extends D.Disposable{constructor(s){super(),this.f=new i.Emitter,this.onMessage=this.f.event,this.g=new i.Emitter,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new l(this.a)),this.c=this.B(new v(this.a)),this.B(this.c.onMessage(c=>{c.type===1&&this.f.fire(c.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new y(1,0,0,s))}}e.Protocol=m;class u extends A.IPCClient{static fromSocket(s,c){return new u(new m(s),c)}get onDidDispose(){return this.b.onDidDispose}constructor(s,c,a=null){super(s,c,a),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.Client=u;class d{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new i.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.BufferedEmitter=d;class h{constructor(s){this.data=s,this.next=null}}class n{constructor(){this.a=null,this.b=null}length(){let s=0,c=this.a;for(;c;)c=c.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let c=0,a=this.a;for(;a;)s[c++]=a.data,a=a.next;return s}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const c=new h(s);if(!this.a){this.a=c,this.b=c;return}this.b.next=c,this.b=c}}class r{static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const s=Date.now();for(let c=0;c<r.a;c++)this.c[c]=s-1e3*c;setInterval(()=>{for(let c=r.a;c>=1;c--)this.c[c]=this.c[c-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),c=(1+r.a)*1e3;let a=0;for(let g=0;g<r.a;g++)s-this.c[g]<=c&&a++;return 1-a/r.a}hasHighLoad(){return this.d()>=.5}}r.a=10,r.b=null;class t{get unacknowledgedCount(){return this.c-this.d}constructor(s,c=null,a=r.getInstance()){this.t=new d,this.onControlMessage=this.t.event,this.u=new d,this.onMessage=this.u.event,this.v=new d,this.onDidDispose=this.v.event,this.w=new d,this.onSocketClose=this.w.event,this.x=new d,this.onSocketTimeout=this.x.event,this.s=a,this.a=!1,this.b=new n,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=[],this.o=s,this.p=new l(this.o),this.r.push(this.p),this.q=new v(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(g=>this.y(g))),this.r.push(this.o.onClose(g=>this.w.fire(g))),c&&this.q.acceptChunk(c),this.l=setInterval(()=>{this.C()},5e3)}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r=(0,D.dispose)(this.r)}drain(){return this.p.drain()}sendDisconnect(){const s=new y(5,0,0,C());this.p.write(s),this.p.flush()}sendPause(){const s=new y(7,0,0,C());this.p.write(s)}sendResume(){const s=new y(8,0,0,C());this.p.write(s)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(s,c){this.a=!0,this.r=(0,D.dispose)(this.r),this.t.flushBuffer(),this.w.flushBuffer(),this.x.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=s,this.p=new l(this.o),this.r.push(this.p),this.q=new v(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(a=>this.y(a))),this.r.push(this.o.onClose(a=>this.w.fire(a))),this.q.acceptChunk(c)}endAcceptReconnection(){this.a=!1,this.h=this.g;const s=new y(3,0,this.h,C());this.p.write(s);const c=this.b.toArray();for(let a=0,g=c.length;a<g;a++)this.p.write(c[a]);this.A()}acceptDisconnect(){this.v.fire()}y(s){if(s.ack>this.d){this.d=s.ack;do{const c=this.b.peek();if(c&&c.id<=s.ack)this.b.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this.g)if(s.id!==this.g+1){const c=Date.now();c-this.m>1e4&&(this.m=c,this.p.write(new y(6,0,0,C())))}else this.g=s.id,this.j=Date.now(),this.z(),this.u.fire(s.data);break}case 2:{this.t.fire(s.data);break}case 3:break;case 5:{this.v.fire();break}case 6:{const c=this.b.toArray();for(let a=0,g=c.length;a<g;a++)this.p.write(c[a]);this.A();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(s){const c=++this.c;this.h=this.g;const a=new y(1,c,this.h,s);this.b.push(a),this.a||(this.p.write(a),this.A())}sendControl(s){const c=new y(2,0,0,s);this.p.write(c)}z(){if(this.g<=this.h||this.k)return;const s=Date.now()-this.j;if(s>=2e3){this.B();return}this.k=setTimeout(()=>{this.k=null,this.z()},2e3-s+5)}A(){if(this.c<=this.d||this.f||this.a)return;const s=this.b.peek(),c=Date.now()-s.writtenTime,a=Date.now()-this.q.lastReadTime,g=Date.now()-this.n;if(c>=2e4&&a>=2e4&&g>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.x.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:a});return}const b=Math.max(2e4-c,2e4-a,2e4-g,500);this.f=setTimeout(()=>{this.f=null,this.A()},b)}B(){if(this.g<=this.h)return;this.h=this.g;const s=new y(3,0,this.h,C());this.p.write(s)}C(){const s=new y(9,0,0,C());this.p.write(s)}}e.PersistentProtocol=t}),define(oe[148],ae([0,1,93,3,39,147]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class O extends D.IPCServer{static b(){const I=i.Event.fromNodeEventEmitter(k.ipcRenderer,"vscode:createMessageChannel",(S,C)=>C);return i.Event.map(I,S=>{const{port1:C,port2:E}=new MessageChannel,p={protocol:new A.Protocol(C),onDidClientDisconnect:i.Event.fromDOMEventEmitter(C,"close")};return k.ipcRenderer.postMessage("vscode:createMessageChannelResult",S,[E]),p})}constructor(){super(O.b())}}e.Server=O}),define(oe[68],ae([0,1,49,6,17,23,141,9,3,2,32,91,87,39]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends p.ChannelServer{constructor(l){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:I.Event.fromNodeEventEmitter(process,"message",m=>D.VSBuffer.wrap(Buffer.from(m,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.Server=f;class y{constructor(l,m){this.i=l,this.j=m,this.c=new Set,this.g=new Map,this.h=new I.Emitter,this.onDidProcessExit=this.h.event;const u=m&&m.timeout?m.timeout:6e4;this.b=new i.Delayer(u),this.d=null,this.f=null}getChannel(l){const m=this;return{call(u,d,h){return m.k(l,u,d,h)},listen(u,d){return m.l(l,u,d)}}}k(l,m,u,d=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(P.canceled());this.b.cancel();const h=this.n(l),n=(0,i.createCancelablePromise)(o=>h.call(m,u,o)),r=d.onCancellationRequested(()=>n.cancel()),t=(0,S.toDisposable)(()=>n.cancel());return this.c.add(t),n.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(l,m,u){if(!this.b)return I.Event.None;this.b.cancel();let d;const h=new I.Emitter({onWillAddFirstListener:()=>{d=this.n(l).listen(m,u)(h.fire,h),this.c.add(d)},onDidRemoveLastListener:()=>{this.c.delete(d),d.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return h.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,w.removeDangerousEnvVariables)(m.env),this.d=(0,k.fork)(this.i,l,m);const u=new I.Emitter;I.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,O.isRemoteConsoleLog)(s)){(0,O.log)(s,`IPC Library: ${this.j.serverName}`);return}u.fire(D.VSBuffer.wrap(Buffer.from(s,"base64")))});const h=this.j.useQueue?(0,E.createQueuedSender)(this.d):this.d,n=s=>this.d&&this.d.connected&&h.send(s.buffer.toString("base64")),r=u.event,t={send:n,onMessage:r};this.f=new p.ChannelClient(t);const o=()=>this.o();process.once("exit",o),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,c)=>{process.removeListener("exit",o),this.c.forEach(a=>(0,S.dispose)(a)),this.c.clear(),s!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:c})})}return this.f}n(l){let m=this.g.get(l);return m||(m=this.m.getChannel(l),this.g.set(l,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=y}),define(oe[149],ae([0,1,17,9,3,2,12,5,31,39,92]),function(ee,e,k,i,D,A,O,P,I,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function E(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class w{traceSocketEvent(a,g){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,g)}constructor(a,g=""){this.f=!0,this.debugLabel=g,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=b=>{if(this.traceSocketEvent("error",{code:b?.code,message:b?.message}),b){if(b.code==="EPIPE")return;(0,i.onUnexpectedError)(b)}},this.socket.on("error",this.a),this.b=b=>{this.traceSocketEvent("close",{hadError:b}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(a){const g=b=>{this.traceSocketEvent("read",b),a(k.VSBuffer.wrap(b))};return this.socket.on("data",g),{dispose:()=>this.socket.off("data",g)}}onClose(a){const g=b=>{a({type:0,hadError:b,error:void 0})};return this.socket.on("close",g),{dispose:()=>this.socket.off("close",g)}}onEnd(a){const g=()=>{a()};return this.socket.on("end",g),{dispose:()=>this.socket.off("end",g)}}write(a){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,g=>{if(g){if(g.code==="EPIPE")return;(0,i.onUnexpectedError)(g)}})}catch(g){if(g.code==="EPIPE")return;(0,i.onUnexpectedError)(g)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,g)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const b=()=>{this.socket.off("close",b),this.socket.off("end",b),this.socket.off("error",b),this.socket.off("timeout",b),this.socket.off("drain",b),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",b),this.socket.on("end",b),this.socket.on("error",b),this.socket.on("timeout",b),this.socket.on("drain",b)})}}e.NodeSocket=w;var p;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(p||(p={}));var f;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(f||(f={}));class y extends A.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(a,g){this.socket.traceSocketEvent(a,g)}constructor(a,g,b,R){super(),this.f=this.B(new D.Emitter),this.g=this.B(new D.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:g,inflateBytesLength:b?.byteLength||0,recordInflateBytes:R}),this.a=this.B(new v(this,g,b,R,this.f,(j,U)=>this.k(j,U))),this.B(this.a.onError(j=>{console.error(j),(0,i.onUnexpectedError)(j),this.g.fire({type:0,hadError:!0,error:j})})),this.b=new C.ChunkStream,this.B(this.socket.onData(j=>this.l(j))),this.B(this.socket.onClose(j=>this.g.fire(j)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this.f.event(a)}onClose(a){return this.g.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){this.a.writeMessage(a)}k(a,g){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let b=2;a.byteLength<126?b+=0:a.byteLength<2**16?b+=2:b+=8;const R=k.VSBuffer.alloc(b);if(g?R.writeUInt8(194,0):R.writeUInt8(130,0),a.byteLength<126)R.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){R.writeUInt8(126,1);let j=1;R.writeUInt8(a.byteLength>>>8&255,++j),R.writeUInt8(a.byteLength>>>0&255,++j)}else{R.writeUInt8(127,1);let j=1;R.writeUInt8(0,++j),R.writeUInt8(0,++j),R.writeUInt8(0,++j),R.writeUInt8(0,++j),R.writeUInt8(a.byteLength>>>24&255,++j),R.writeUInt8(a.byteLength>>>16&255,++j),R.writeUInt8(a.byteLength>>>8&255,++j),R.writeUInt8(a.byteLength>>>0&255,++j)}this.socket.write(k.VSBuffer.concat([R,a]))}end(){this.h=!0,this.socket.end()}l(a){if(a.byteLength!==0){for(this.b.acceptChunk(a);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const g=this.b.peek(this.j.readLen),b=g.readUInt8(0),R=(b&128)>>>7,j=(b&64)>>>6,U=g.readUInt8(1),z=(U&128)>>>7,F=U&127;this.j.state=2,this.j.readLen=2+(z?4:0)+(F===126?2:0)+(F===127?8:0),this.j.fin=R,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(j)),this.j.firstFrameOfMessage=Boolean(R),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const g=this.b.read(this.j.readLen),b=g.readUInt8(1),R=(b&128)>>>7;let j=b&127,U=1;j===126?j=g.readUInt8(++U)*2**8+g.readUInt8(++U):j===127&&(j=g.readUInt8(++U)*0+g.readUInt8(++U)*0+g.readUInt8(++U)*0+g.readUInt8(++U)*0+g.readUInt8(++U)*2**24+g.readUInt8(++U)*2**16+g.readUInt8(++U)*2**8+g.readUInt8(++U));let z=0;R&&(z=g.readUInt8(++U)*2**24+g.readUInt8(++U)*2**16+g.readUInt8(++U)*2**8+g.readUInt8(++U)),this.j.state=3,this.j.readLen=j,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const g=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",g),u(g,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",g),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(g,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await D.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=y;class v extends A.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:k.VSBuffer.alloc(0)}constructor(a,g,b,R,j,U){super(),this.k=a,this.l=j,this.m=U,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new D.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,g?(this.b=this.B(new l(this.k,R,b,{windowBits:15})),this.f=this.B(new m(this.k,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(a){this.g.push(a),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const a=this.g.shift();if(this.f){const g=await this.r(this.f,a);this.m(g,!0)}else this.m(a,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(a,g){return new Promise((b,R)=>{a.write(g),a.flush(j=>b(j))})}acceptFrame(a,g,b){this.h.push({data:a,isCompressed:g,isLastFrameOfMessage:b}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const a=this.h.shift();if(this.b&&a.isCompressed){const g=await this.u(this.b,a.data,a.isLastFrameOfMessage);this.l.fire(g)}else this.l.fire(a.data)}this.s=!1}}u(a,g,b){return new Promise((R,j)=>{a.write(g),b&&a.write(k.VSBuffer.fromByteArray([0,0,255,255])),a.flush(U=>R(U))})}}class l extends A.Disposable{get recordedInflateBytes(){return this.j?k.VSBuffer.concat(this.f):k.VSBuffer.alloc(0)}constructor(a,g,b,R){super(),this.h=a,this.j=g,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=E().zlib.createInflateRaw(R),this.b.on("error",j=>{this.h.traceSocketEvent("zlibInflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.h.traceSocketEvent("zlibInflateData",j),this.g.push(k.VSBuffer.wrap(j))}),b&&(this.h.traceSocketEvent("zlibInflateInitialWrite",b.buffer),this.b.write(b.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(a){this.j&&this.f.push(a.clone()),this.h.traceSocketEvent("zlibInflateWrite",a),this.b.write(a.buffer)}flush(a){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const g=k.VSBuffer.concat(this.g);this.g.length=0,a(g)})}}class m extends A.Disposable{constructor(a,g){super(),this.g=a,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.f=[],this.b=E().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",b=>{this.g.traceSocketEvent("zlibDeflateError",{message:b?.message,code:b?.code}),this.a.fire(b)}),this.b.on("data",b=>{this.g.traceSocketEvent("zlibDeflateData",b),this.f.push(k.VSBuffer.wrap(b))})}write(a){this.g.traceSocketEvent("zlibDeflateWrite",a.buffer),this.b.write(a.buffer)}flush(a){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let g=k.VSBuffer.concat(this.f);this.f.length=0,g=g.slice(0,g.byteLength-4),a(g)})}}function u(c,a){if(a===0)return;const g=c.byteLength>>>2;for(let F=0;F<g;F++){const L=c.readUInt32BE(F*4);c.writeUInt32BE(L^a,F*4)}const b=g*4,R=c.byteLength-b,j=a>>>24&255,U=a>>>16&255,z=a>>>8&255;R>=1&&c.writeUInt8(c.readUInt8(b)^j,b),R>=2&&c.writeUInt8(c.readUInt8(b+1)^U,b+1),R>=3&&c.writeUInt8(c.readUInt8(b+2)^z,b+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const d={[2]:107,[1]:103};function h(){const c=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let a;return e.XDG_RUNTIME_DIR?a=(0,O.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):a=(0,O.join)(E().os.tmpdir(),`vscode-ipc-${c}.sock`),r(a),a}e.createRandomIPCHandle=h;function n(c,a,g){const b=E().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${b}-${g}-${a}-sock`;let R;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?R=(0,O.join)(e.XDG_RUNTIME_DIR,`vscode-${b.substr(0,8)}-${g}-${a}.sock`):R=(0,O.join)(c,`${g}-${a}.sock`),r(R),R}e.createStaticIPCHandle=n;function r(c){const a=d[P.platform];typeof a=="number"&&c.length>=a&&console.warn(`WARNING: IPC handle "${c}" is longer than ${a} chars, try a shorter --user-data-dir`)}class t extends S.IPCServer{static b(a){const g=D.Event.fromNodeEventEmitter(a,"connection");return D.Event.map(g,b=>({protocol:new C.Protocol(new w(b,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(b,"close"))}))}constructor(a){super(t.b(a)),this.d=a}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=t;function o(c){return new Promise((a,g)=>{const b=E().net.createServer();b.on("error",g),b.listen(c,()=>{b.removeListener("error",g),a(new t(b))})})}e.serve=o;function s(c,a){return new Promise((g,b)=>{const R=E().net.createConnection(c,()=>{R.removeListener("error",b),g(C.Client.fromSocket(new w(R,`ipc-client${a}`),a))});R.once("error",b)})}e.connect=s}),define(oe[69],ae([0,1,6,3,2,14]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var O;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",E[E.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O=e.StorageHint||(e.StorageHint={}));function P(E){const w=E;return w?.changed instanceof Map||w?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var I;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(I=e.StorageState||(e.StorageState={}));class S extends D.Disposable{constructor(w,p=Object.create(null)){super(),this.m=w,this.n=p,this.b=this.B(new i.Emitter),this.onDidChangeStorage=this.b.event,this.c=I.None,this.f=new Map,this.g=new k.ThrottledDelayer(S.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(w=>this.r(w)))}r(w){w.changed?.forEach((p,f)=>this.s(f,p)),w.deleted?.forEach(p=>this.s(p,void 0))}s(w,p){if(this.c===I.Closed)return;let f=!1;(0,A.isUndefinedOrNull)(p)?f=this.f.delete(w):this.f.get(w)!==p&&(this.f.set(w,p),f=!0),f&&this.b.fire(w)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===I.None&&(this.c=I.Initialized,this.n.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(w,p){const f=this.f.get(w);return(0,A.isUndefinedOrNull)(f)?p:f}getBoolean(w,p){const f=this.get(w);return(0,A.isUndefinedOrNull)(f)?p:f==="true"}getNumber(w,p){const f=this.get(w);return(0,A.isUndefinedOrNull)(f)?p:parseInt(f,10)}async set(w,p){if(this.c===I.Closed)return;if((0,A.isUndefinedOrNull)(p))return this.delete(w);const f=String(p);if(this.f.get(w)!==f)return this.f.set(w,f),this.j.set(w,f),this.h.delete(w),this.b.fire(w),this.w()}async delete(w){if(!(this.c===I.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire(w),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=I.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(w).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(w){if(!!this.u)return this.w(w)}async w(w){return this.g.trigger(()=>this.v(),w)}async whenFlushed(){if(!!this.u)return new Promise(w=>this.l.push(w))}isInMemory(){return this.n.hint===O.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=S,S.a=100;class C{constructor(){this.onDidChangeItemsExternal=i.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((p,f)=>this.a.set(f,p)),w.delete?.forEach(p=>this.a.delete(p))}async close(){}}e.InMemoryStorageDatabase=C}),define(oe[150],ae([10,11]),function(ee,e){return ee.create("vs/base/node/zip",e)}),define(oe[151],ae([10,11]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[152],ae([10,11]),function(ee,e){return ee.create("vs/platform/environment/node/argv",e)}),define(oe[153],ae([10,11]),function(ee,e){return ee.create("vs/platform/environment/node/argvHelper",e)}),define(oe[154],ae([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[155],ae([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[156],ae([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[157],ae([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[158],ae([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(oe[159],ae([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[160],ae([10,11]),function(ee,e){return ee.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[161],ae([10,11]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[162],ae([10,11]),function(ee,e){return ee.create("vs/platform/files/common/fileService",e)}),define(oe[163],ae([10,11]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(oe[164],ae([10,11]),function(ee,e){return ee.create("vs/platform/files/common/io",e)}),define(oe[165],ae([10,11]),function(ee,e){return ee.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[166],ae([10,11]),function(ee,e){return ee.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[167],ae([10,11]),function(ee,e){return ee.create("vs/platform/remoteTunnel/electron-browser/remoteTunnelService",e)}),define(oe[168],ae([10,11]),function(ee,e){return ee.create("vs/platform/request/common/request",e)}),define(oe[169],ae([10,11]),function(ee,e){return ee.create("vs/platform/shell/node/shellEnv",e)}),define(oe[170],ae([10,11]),function(ee,e){return ee.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[171],ae([10,11]),function(ee,e){return ee.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(oe[172],ae([10,11]),function(ee,e){return ee.create("vs/platform/terminal/common/terminalProfiles",e)}),define(oe[173],ae([10,11]),function(ee,e){return ee.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[174],ae([10,11]),function(ee,e){return ee.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[175],ae([10,11]),function(ee,e){return ee.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[176],ae([10,11]),function(ee,e){return ee.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[177],ae([10,11]),function(ee,e){return ee.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[178],ae([10,11]),function(ee,e){return ee.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[179],ae([10,11]),function(ee,e){return ee.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[180],ae([10,11]),function(ee,e){return ee.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[181],ae([10,11]),function(ee,e){return ee.create("vs/platform/workspace/common/workspace",e)}),define(oe[94],ae([0,1,65,63,24,12,36,21,7]),function(ee,e,k,i,D,A,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class S{get appRoot(){return(0,A.dirname)(D.FileAccess.asFileUri("").fsPath)}get userHome(){return I.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return I.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return I.URI.file(this.b.tmpDir)}get cacheHome(){return I.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const f=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",f)}return this.args.logsPath}get userDataSyncLogResource(){return I.URI.file((0,A.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return I.URI.file((0,A.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(I.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=O.env.VSCODE_PORTABLE;return f?I.URI.file((0,A.join)(f,"argv.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,A.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,A.resolve)(f):(0,A.normalize)((0,A.join)(D.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?I.URI.file((0,A.resolve)(f)):I.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,A.resolve)(f);const y=O.env.VSCODE_EXTENSIONS;if(y)return y;const v=O.env.VSCODE_PORTABLE;return v?(0,A.join)(v,"extensions"):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(y=>/^[^:/?#]+?:\/\//.test(y)?I.URI.parse(y):I.URI.file((0,A.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?I.URI.parse(f):I.URI.file((0,A.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(f))}get extensionLogLevel(){const f=[];for(const y of this.args.log||[]){const v=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(y);v&&v[1]&&v[2]&&f.push([v[1],v[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return I.URI.file((0,A.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=O.env.VSCODE_PORTABLE;return f?I.URI.file((0,A.join)(f,"policy.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,y,v){this.a=f,this.b=y,this.c=v,this.editSessionId=this.args.editSessionId}}pe([i.memoize],S.prototype,"appRoot",null),pe([i.memoize],S.prototype,"userHome",null),pe([i.memoize],S.prototype,"userDataPath",null),pe([i.memoize],S.prototype,"appSettingsHome",null),pe([i.memoize],S.prototype,"tmpDir",null),pe([i.memoize],S.prototype,"cacheHome",null),pe([i.memoize],S.prototype,"stateResource",null),pe([i.memoize],S.prototype,"userRoamingDataHome",null),pe([i.memoize],S.prototype,"userDataSyncHome",null),pe([i.memoize],S.prototype,"userDataSyncLogResource",null),pe([i.memoize],S.prototype,"editSessionsLogResource",null),pe([i.memoize],S.prototype,"sync",null),pe([i.memoize],S.prototype,"machineSettingsResource",null),pe([i.memoize],S.prototype,"workspaceStorageHome",null),pe([i.memoize],S.prototype,"localHistoryHome",null),pe([i.memoize],S.prototype,"keyboardLayoutResource",null),pe([i.memoize],S.prototype,"argvResource",null),pe([i.memoize],S.prototype,"isExtensionDevelopment",null),pe([i.memoize],S.prototype,"untitledWorkspacesHome",null),pe([i.memoize],S.prototype,"installSourcePath",null),pe([i.memoize],S.prototype,"builtinExtensionsPath",null),pe([i.memoize],S.prototype,"extensionsPath",null),pe([i.memoize],S.prototype,"extensionDevelopmentLocationURI",null),pe([i.memoize],S.prototype,"extensionDevelopmentKind",null),pe([i.memoize],S.prototype,"extensionTestsLocationURI",null),pe([i.memoize],S.prototype,"debugExtensionHost",null),pe([i.memoize],S.prototype,"logLevel",null),pe([i.memoize],S.prototype,"extensionLogLevel",null),pe([i.memoize],S.prototype,"serviceMachineIdResource",null),pe([i.memoize],S.prototype,"telemetryLogResource",null),pe([i.memoize],S.prototype,"disableWorkspaceTrust",null),pe([i.memoize],S.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=S;function C(p,f){return w(p["inspect-extensions"],p["inspect-brk-extensions"],5870,f,p.debugId,p.extensionEnvironment)}e.parseExtensionHostPort=C;function E(p,f){return w(p["inspect-ptyhost"],p["inspect-brk-ptyhost"],5877,f,p.extensionEnvironment)}e.parsePtyHostPort=E;function w(p,f,y,v,l,m){const d=Number(f||p)||(v?null:y),h=d?Boolean(!!f):!1;let n;if(m)try{n=JSON.parse(m)}catch{}return{port:d,break:h,debugId:l,env:n}}}),define(oe[182],ae([0,1,283,5,152]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const A={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,D.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,D.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,D.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(17,null)},category:{type:"string",cat:"e",description:(0,D.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,D.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,D.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,D.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,D.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,D.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,D.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const O={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(y,v,l=O){const m=y.find(c=>c.length>0&&c[0]!=="-"),u={},d=["_"],h=[],n={};let r;for(const c in v){const a=v[c];a.type==="subcommand"?c===m&&(r=a):(a.alias&&(u[c]=a.alias),a.type==="string"||a.type==="string[]"?(d.push(c),a.deprecates&&d.push(...a.deprecates)):a.type==="boolean"&&(h.push(c),a.deprecates&&h.push(...a.deprecates)),a.global&&(n[c]=a))}if(r&&m){const c=n;for(const R in r.options)c[R]=r.options[R];const a=y.filter(R=>R!==m),g=l.getSubcommandReporter?l.getSubcommandReporter(m):void 0,b=P(a,c,g);return{[m]:b,_:[]}}const t=k(y,{string:d,boolean:h,alias:u}),o={},s=t;o._=t._.map(c=>String(c)).filter(c=>c.length>0),delete s._;for(const c in v){const a=v[c];if(a.type==="subcommand")continue;a.alias&&delete s[a.alias];let g=s[c];if(a.deprecates)for(const b of a.deprecates)s.hasOwnProperty(b)&&(g||(g=s[b],g&&l.onDeprecatedOption(b,a.deprecationMessage||(0,D.localize)(36,null,c))),delete s[b]);if(typeof g<"u"){if(a.type==="string[]"){if(Array.isArray(g)||(g=[g]),!a.allowEmptyValue){const b=g.filter(R=>R.length>0);b.length!==g.length&&(l.onEmptyValue(c),g=b.length>0?b:void 0)}}else a.type==="string"&&(Array.isArray(g)?(g=g.pop(),l.onMultipleValues(c,g)):!g&&!a.allowEmptyValue&&(l.onEmptyValue(c),g=void 0));o[c]=g,a.deprecationMessage&&l.onDeprecatedOption(c,a.deprecationMessage)}delete s[c]}for(const c in s)l.onUnknownOption(c);return o}e.parseArgs=P;function I(y,v){let l="";return v.args&&(Array.isArray(v.args)?l=` <${v.args.join("> <")}>`:l=` <${v.args}>`),v.alias?`-${v.alias} --${y}${l}`:`--${y}${l}`}function S(y,v){const l=[];for(const m in y){const u=y[m],d=I(m,u);l.push([d,u.description])}return C(l,v)}e.formatOptions=S;function C(y,v){const m=y.reduce((h,n)=>Math.max(h,n[0].length),12)+2+1;if(v-m<25)return y.reduce((h,n)=>h.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const u=v-m-1,d=[];for(const h of y){const n=h[0],r=w(h[1],u),t=E(m-n.length-2);d.push("  "+n+t+r[0]);for(let o=1;o<r.length;o++)d.push(E(m)+r[o])}return d}function E(y){return" ".repeat(y)}function w(y,v){const l=[];for(;y.length;){const m=y.length<v?y.length:y.lastIndexOf(" ",v),u=y.slice(0,m).trim();y=y.slice(m),l.push(u)}return l}function p(y,v,l,m,u){const d=process.stdout.isTTY&&process.stdout.columns||80,h=u?.noInputFiles!==!0?`[${(0,D.localize)(37,null)}...]`:"",n=[`${y} ${l}`];n.push(""),n.push(`${(0,D.localize)(38,null)}: ${v} [${(0,D.localize)(39,null)}]${h}`),n.push(""),u?.noPipe!==!0&&(i.isWindows?n.push((0,D.localize)(40,null,v)):n.push((0,D.localize)(41,null,v)),n.push(""));const r={},t=[];for(const o in m){const s=m[o];if(s.type==="subcommand")s.description&&t.push({command:o,description:s.description});else if(s.description&&s.cat){let c=r[s.cat];c||(r[s.cat]=c={}),c[o]=s}}for(const o in r){const s=o,c=r[s];c&&(n.push(A[s]),n.push(...S(c,d)),n.push(""))}return t.length&&(n.push((0,D.localize)(42,null)),n.push(...C(t.map(o=>[o.command,o.description]),d)),n.push("")),n.join(`
`)}e.buildHelpMessage=p;function f(y,v){return`${y||(0,D.localize)(43,null)}
${v||(0,D.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=f}),define(oe[183],ae([0,1,284,153,182]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const A=2048;function O(w,p){const f=(d,h)=>{console.warn((0,i.localize)(0,null,d,h))},y=d=>{console.warn((0,i.localize)(1,null,d))},v=(d,h)=>{console.warn((0,i.localize)(2,null,d,h))},l=d=>({onUnknownOption:h=>{d!=="tunnel"&&console.warn((0,i.localize)(3,null,h,d))},onMultipleValues:f,onEmptyValue:y,onDeprecatedOption:v,getSubcommandReporter:d!=="tunnel"?l:void 0}),m={onUnknownOption:d=>{console.warn((0,i.localize)(4,null,d))},onMultipleValues:f,onEmptyValue:y,onDeprecatedOption:v,getSubcommandReporter:l},u=(0,D.parseArgs)(w,D.OPTIONS,p?m:void 0);return u.goto&&u._.forEach(d=>k(/^(\w:)?[^:]+(:\d*){0,2}$/.test(d),(0,i.localize)(5,null))),u["max-memory"]&&k(parseInt(u["max-memory"])>=A,`The max-memory argument cannot be specified lower than ${A} MB.`),u}function P(w){const p=w.findIndex(f=>!/^-/.test(f));if(p>-1)return[...w.slice(0,p),...w.slice(p+1)]}function I(w){let[,...p]=w;process.env.VSCODE_DEV&&(p=P(p)||[]);const f=!E(process.env);return O(p,f)}e.parseMainProcessArgv=I;function S(w){let[,,...p]=w;return process.env.VSCODE_DEV&&(p=P(p)||[]),O(p,!0)}e.parseCLIProcessArgv=S;function C(w,...p){const f=w.indexOf("--");return f===-1?w.push(...p):w.splice(f,0,...p),w}e.addArg=C;function E(w){return w.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),function(){"use strict";function ee(e,k,i){function D(O,P){const I=A(O,P),S=[I];return e.isAbsolute(I)||S.unshift(i),e.resolve(...S)}function A(O,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const I=process.env.VSCODE_PORTABLE;if(I)return e.join(I,"user-data");let S=process.env.VSCODE_APPDATA;if(S)return e.join(S,P);const C=O["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(S=process.env.APPDATA,!S){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");S=e.join(E,"AppData","Roaming")}break;case"darwin":S=e.join(k.homedir(),"Library","Application Support");break;case"linux":S=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(S,P)}return{getUserDataPath:D}}if(typeof define=="function")define(oe[184],ae([285,34,36]),function(e,k,i){return ee(e,k,i.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),k=require("os");module.exports=ee(e,k,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[185],ae([0,1,34,94,184]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class A extends i.AbstractNativeEnvironmentService{constructor(P,I){super(P,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,D.getUserDataPath)(P,I.nameShort)},I)}}e.NativeEnvironmentService=A}),define(oe[186],ae([0,1,7]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const i=/^([^@:]+@)?([^:]+):/,D=/^([^@:]+@)?([^:]+):(.+)$/,A=/^([^@]+@)?([^:]+)(:\d+)?$/,O=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,I=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function S(v){const l=v.match(O);return l?l[1]:null}function C(v){if(v.indexOf("://")===-1){const l=v.match(i);return l?S(l[2]):null}try{const l=k.URI.parse(v);if(l.authority)return S(l.authority)}catch{}return null}function E(v,l){const m=new Set;let u;for(;u=P.exec(v);){const h=C(u[1]);h&&m.add(h)}const d=new Set(l);return Array.from(m).map(h=>d.has(h)?h:h.replace(I,"a"))}e.getDomainsOfRemotes=E;function w(v){const l=v.match(A);return l?l[2]:null}function p(v,l,m){return v&&l?(m&&l.endsWith(".git")&&(l=l.substr(0,l.length-4)),l.indexOf("/")===0?`${v}${l}`:`${v}/${l}`):null}function f(v,l){if(v.indexOf("://")===-1){const m=v.match(D);if(m)return p(m[2],m[3],l)}try{const m=k.URI.parse(v);if(m.authority)return p(w(m.authority),m.path,l)}catch{}return null}function y(v,l=!1){const m=[];let u;for(;u=P.exec(v);){const d=f(u[1],l);d&&m.push(d)}return m}e.getRemotes=y}),define(oe[187],ae([0,1,14,156]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function D(O,P,I){try{A(O,P,I)}catch(S){console.error(S?.message??S)}return O}e.localizeManifest=D;function A(O,P,I){const S=(C,E,w)=>{const p=C[E];if((0,k.isString)(p)){const f=p,y=f.length;if(y>1&&f[0]==="%"&&f[y-1]==="%"){const v=f.substr(1,y-2);let l=P[v];l===void 0&&I&&(l=I[v]);const m=typeof l=="string"?l:l?.message,u=I?.[v],d=typeof u=="string"?u:u?.message;if(!m){d||console.warn(`[${O.name}]: ${(0,i.localize)(0,null,v)}`);return}if(w&&(E==="title"||E==="category")&&d&&d!==m){const h={value:m,original:d};C[E]=h}else C[E]=m}}else if((0,k.isObject)(p))for(const f in p)p.hasOwnProperty(f)&&(f==="commands"?S(p,f,!0):S(p,f,w));else if(Array.isArray(p))for(let f=0;f<p.length;f++)S(p,f,w)};for(const C in O)O.hasOwnProperty(C)&&S(O,C)}}),define(oe[188],ae([0,1,9]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class i{constructor(){this.a=new Map}register(A,O){this.a.set(A,O)}updateManifest(A){if(!(typeof A.main>"u"&&typeof A.browser>"u")&&(A.activationEvents===void 0&&Object.assign(A,{activationEvents:[]}),!(!Array.isArray(A.activationEvents)||!A.contributes)))for(const O in A.contributes){const P=this.a.get(O);if(!P)continue;const I=A.contributes[O],S=Array.isArray(I)?I:[I];try{P(S,A.activationEvents)}catch(C){(0,k.onUnexpectedError)(C)}}}}e.ImplicitActivationEventsImpl=i,e.ImplicitActivationEvents=new i}),define(oe[189],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class k{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A,O,P,I){return this.a.call("promptImportantExtensionsInstallNotification",[A,O,P,I])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=k;class i{constructor(A){this.a=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,P){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${O}`)}}e.ExtensionRecommendationNotificationServiceChannel=i}),define(oe[70],ae([0,1,21,88,161,53]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function I(l){return l=l.trim(),l==="*"||O.test(l)}e.isValidVersionStr=I;function S(l){if(!I(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=l.match(O);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=S;function C(l){if(!l)return null;const m=l.majorBase,u=l.majorMustEqual,d=l.minorBase;let h=l.minorMustEqual;const n=l.patchBase;let r=l.patchMustEqual;l.hasCaret&&(m===0||(h=!1),r=!1);let t=0;if(l.preRelease){const o=P.exec(l.preRelease);if(o){const[,s,c,a]=o;t=Date.UTC(Number(s),Number(c)-1,Number(a))}}return{majorBase:m,majorMustEqual:u,minorBase:d,minorMustEqual:h,patchBase:n,patchMustEqual:r,isMinimum:l.hasGreaterEquals,notBefore:t}}e.normalizeVersion=C;function E(l,m,u){let d;typeof l=="string"?d=C(S(l)):d=l;let h;m instanceof Date?h=m.getTime():typeof m=="string"&&(h=new Date(m).getTime());let n;if(typeof u=="string"?n=C(S(u)):n=u,!d||!n)return!1;const r=d.majorBase,t=d.minorBase,o=d.patchBase;let s=n.majorBase,c=n.minorBase,a=n.patchBase;const g=n.notBefore;let b=n.majorMustEqual,R=n.minorMustEqual,j=n.patchMustEqual;return n.isMinimum?r>s?!0:r<s?!1:t>c?!0:t<c||h&&h<g?!1:o>=a:(r===1&&s===0&&(!b||!R||!j)&&(s=1,c=0,a=0,b=!0,R=!1,j=!1),r<s?!1:r>s?!b:t<c?!1:t>c?!R:o<a?!1:o>a?!j:!(h&&h<g))}e.isValidVersion=E;function w(l,m,u,d,h){const n=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return n.push([i.default.Error,D.localize(0,null)]),n;if(typeof d.name!="string")return n.push([i.default.Error,D.localize(1,null,"name")]),n;if(typeof d.version!="string")return n.push([i.default.Error,D.localize(2,null,"version")]),n;if(!d.engines)return n.push([i.default.Error,D.localize(3,null,"engines")]),n;if(typeof d.engines.vscode!="string")return n.push([i.default.Error,D.localize(4,null,"engines.vscode")]),n;if(typeof d.extensionDependencies<"u"&&!v(d.extensionDependencies))return n.push([i.default.Error,D.localize(5,null,"extensionDependencies")]),n;if(typeof d.activationEvents<"u"){if(!v(d.activationEvents))return n.push([i.default.Error,D.localize(6,null,"activationEvents")]),n;if(typeof d.main>"u"&&typeof d.browser>"u")return n.push([i.default.Error,D.localize(7,null,"activationEvents","main")]),n}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&n.push([i.default.Warning,D.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return n.push([i.default.Error,D.localize(9,null,"main")]),n;{const o=(0,k.joinPath)(u,d.main);(0,k.isEqualOrParent)(o,u)||n.push([i.default.Warning,D.localize(10,null,o.path,u.path)])}if(typeof d.activationEvents>"u")return n.push([i.default.Error,D.localize(11,null,"activationEvents","main")]),n}if(typeof d.browser<"u"){if(typeof d.browser!="string")return n.push([i.default.Error,D.localize(12,null,"browser")]),n;{const o=(0,k.joinPath)(u,d.browser);(0,k.isEqualOrParent)(o,u)||n.push([i.default.Warning,D.localize(13,null,o.path,u.path)])}if(typeof d.activationEvents>"u")return n.push([i.default.Error,D.localize(14,null,"activationEvents","browser")]),n}if(!A.valid(d.version))return n.push([i.default.Error,D.localize(15,null)]),n;const r=[];if(!p(l,m,d,h,r))for(const o of r)n.push([i.default.Error,o]);return n}e.validateExtensionManifest=w;function p(l,m,u,d,h){return d||typeof u.main>"u"&&typeof u.browser>"u"?!0:y(l,m,u.engines.vscode,h)}e.isValidExtensionVersion=p;function f(l,m,u){return l==="*"||y(m,u,l)}e.isEngineValid=f;function y(l,m,u,d=[]){const h=C(S(u));if(!h)return d.push(D.localize(16,null,u)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return d.push(D.localize(17,null,u)),!1}else if(!h.majorMustEqual)return d.push(D.localize(18,null,u)),!1;return E(l,m,h)?!0:(d.push(D.localize(19,null,l,u)),!1)}function v(l){if(!Array.isArray(l))return!1;for(let m=0,u=l.length;m<u;m++)if(typeof l[m]!="string")return!1;return!0}}),define(oe[45],ae([0,1,17,31]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(A,O,P){let I=P&&P.get("storage.serviceMachineId",-1)||null;if(I)return I;try{const C=(await O.readFile(A.serviceMachineIdResource)).value.toString();I=(0,i.isUUID)(C)?C:null}catch{I=null}if(!I){I=(0,i.generateUuid)();try{await O.writeFile(A.serviceMachineIdResource,k.VSBuffer.fromString(I))}catch{}}return P?.store("storage.serviceMachineId",I,-1,1),I}e.getServiceMachineId=D}),define(oe[54],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(D,A=[],O=!1){this.ctor=D,this.staticArguments=A,this.supportsDelayedInstantiation=O}}e.SyncDescriptor=k}),define(oe[71],ae([0,1,54]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const i=[];var D;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function A(P,I,S){I instanceof k.SyncDescriptor||(I=new k.SyncDescriptor(I,[],Boolean(S))),i.push([P,I])}e.registerSingleton=A;function O(){return i}e.getSingletonServiceDescriptors=O}),define(oe[190],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(A,O){this.key=A,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.Node=k;class i{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const O of this.a.values())O.outgoing.size===0&&A.push(O);return A}insertEdge(A,O){const P=this.lookupOrInsertNode(A),I=this.lookupOrInsertNode(O);P.outgoing.set(I.key,I),I.incoming.set(P.key,P)}removeNode(A){const O=this.b(A);this.a.delete(O);for(const P of this.a.values())P.outgoing.delete(O),P.incoming.delete(O)}lookupOrInsertNode(A){const O=this.b(A);let P=this.a.get(O);return P||(P=new k(O,A),this.a.set(O,P)),P}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[O,P]of this.a)A.push(`${O}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,O]of this.a){const P=new Set([A]),I=this.c(O,P);if(I)return I}}c(A,O){for(const[P,I]of A.outgoing){if(O.has(P))return[...O,P].join(" -> ");O.add(P);const S=this.c(I,O);if(S)return S;O.delete(P)}}}e.Graph=i}),define(oe[4],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function P(I){return I[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=P})(k=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function i(O,P,I){P[k.DI_TARGET]===P?P[k.DI_DEPENDENCIES].push({id:O,index:I}):(P[k.DI_DEPENDENCIES]=[{id:O,index:I}],P[k.DI_TARGET]=P)}function D(O){if(k.serviceIds.has(O))return k.serviceIds.get(O);const P=function(I,S,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(P,I,C)};return P.toString=()=>O,k.serviceIds.set(O,P),P}e.createDecorator=D;function A(O){return O}e.refineServiceDecorator=A}),define(oe[191],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,k.createDecorator)("checksumService")}),define(oe[16],ae([0,1,14,7,4]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function A(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof i.URI)}e.isConfigurationOverrides=A;function O(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=O;var P;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=I;function S(l,m){const u=Object.create(null);for(const d in l)C(u,d,l[d],m);return u}e.toValuesTree=S;function C(l,m,u,d){const h=m.split("."),n=h.pop();let r=l;for(let t=0;t<h.length;t++){const o=h[t];let s=r[o];switch(typeof s){case"undefined":s=r[o]=Object.create(null);break;case"object":break;default:d(`Ignoring ${m} as ${h.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[n]=u}catch{d(`Ignoring ${m} as ${h.join(".")} is ${JSON.stringify(r)}`)}else d(`Ignoring ${m} as ${h.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=C;function E(l,m){const u=m.split(".");w(l,u)}e.removeFromValueTree=E;function w(l,m){const u=m.shift();if(m.length===0){delete l[u];return}if(Object.keys(l).indexOf(u)!==-1){const d=l[u];typeof d=="object"&&!Array.isArray(d)&&(w(d,m),Object.keys(d).length===0&&delete l[u])}}function p(l,m,u){function d(r,t){let o=r;for(const s of t){if(typeof o!="object"||o===null)return;o=o[s]}return o}const h=m.split("."),n=d(l,h);return typeof n>"u"?u:n}e.getConfigurationValue=p;function f(l,m,u){Object.keys(m).forEach(d=>{d!=="__proto__"&&(d in l?k.isObject(l[d])&&k.isObject(m[d])?f(l[d],m[d],u):u&&(l[d]=m[d]):l[d]=m[d])})}e.merge=f;function y(l,m,u){const d=l.inspect(m),h=l.inspect(u);return typeof d.userValue<"u"||typeof d.workspaceValue<"u"||typeof d.workspaceFolderValue<"u"?d.value:typeof h.userValue<"u"||typeof h.workspaceValue<"u"||typeof h.workspaceFolderValue<"u"?h.value:d.defaultValue}e.getMigratedSettingValue=y;function v(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=v}),define(oe[192],ae([0,1,5,27,4]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",k.isMacintosh),A.set("isLinux",k.isLinux),A.set("isWindows",k.isWindows),A.set("isWeb",k.isWeb),A.set("isMacNative",k.isMacintosh&&!k.isWeb),A.set("isEdge",k.isEdge),A.set("isFirefox",k.isFirefox),A.set("isChrome",k.isChrome),A.set("isSafari",k.isSafari);const O=Object.prototype.hasOwnProperty;var P;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return E.INSTANCE}static true(){return w.INSTANCE}static has(L){return p.create(L)}static equals(L,M){return f.create(L,M)}static notEquals(L,M){return l.create(L,M)}static regex(L,M){return t.create(L,M)}static in(L,M){return y.create(L,M)}static notIn(L,M){return v.create(L,M)}static not(L){return m.create(L)}static and(...L){return c.create(L,null,!0)}static or(...L){return a.create(L,null,!0)}static greater(L,M){return d.create(L,M)}static greaterEquals(L,M){return h.create(L,M)}static smaller(L,M){return n.create(L,M)}static smallerEquals(L,M){return r.create(L,M)}static deserialize(L,M=!1){if(!!L)return this.c(L,M)}static c(L,M){const $=L.split("||");return a.create($.map(G=>this.d(G,M)),null,!0)}static d(L,M){const $=L.split("&&");return c.create($.map(G=>this.f(G,M)),null,!0)}static f(L,M){if(L=L.trim(),L.indexOf("!=")>=0){const $=L.split("!=");return l.create($[0].trim(),this.g($[1],M))}if(L.indexOf("==")>=0){const $=L.split("==");return f.create($[0].trim(),this.g($[1],M))}if(L.indexOf("=~")>=0){const $=L.split("=~");return t.create($[0].trim(),this.h($[1],M))}if(L.indexOf(" not in ")>=0){const $=L.split(" not in ");return v.create($[0].trim(),this.g($[1],M))}if(L.indexOf(" in ")>=0){const $=L.split(" in ");return y.create($[0].trim(),this.g($[1],M))}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const $=L.split(">=");return h.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const $=L.split(">");return d.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const $=L.split("<=");return r.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const $=L.split("<");return n.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(L)?m.create(L.substr(1).trim()):p.create(L)}static g(L,M){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;const $=/^'([^']*)'$/.exec(L);return $?$[1].trim():L}static h(L,M){if((0,i.isFalsyOrWhitespace)(L)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const $=L.indexOf("/"),G=L.lastIndexOf("/");if($===G||$<0){if(M)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}const W=L.slice($+1,G),_=L[G+1]==="i"?"i":"";try{return new RegExp(W,_)}catch(K){if(M)throw new Error(`bad regexp-value '${L}', parse error: ${K}`);return console.warn(`bad regexp-value '${L}', parse error: ${K}`),null}}}e.ContextKeyExpr=I;function S(F,L){const M=F?F.substituteConstants():void 0,$=L?L.substituteConstants():void 0;return!M&&!$?!0:!M||!$?!1:M.equals($)}e.expressionsAreEqualWithConstantSubstitution=S;function C(F,L){return F.cmp(L)}class E{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return w.INSTANCE}}e.ContextKeyFalseExpr=E,E.INSTANCE=new E;class w{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=w,w.INSTANCE=new w;class p{static create(L,M=null){const $=A.get(L);return typeof $=="boolean"?$?w.INSTANCE:E.INSTANCE:new p(L,M)}constructor(L,M){this.key=L,this.c=M,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:b(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=A.get(this.key);return typeof L=="boolean"?L?w.INSTANCE:E.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.c||(this.c=m.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=p;class f{static create(L,M,$=null){if(typeof M=="boolean")return M?p.create(L,$):m.create(L,$);const G=A.get(L);return typeof G=="boolean"?M===(G?"true":"false")?w.INSTANCE:E.INSTANCE:new f(L,M,$)}constructor(L,M,$){this.c=L,this.d=M,this.f=$,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:R(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=A.get(this.c);if(typeof L=="boolean"){const M=L?"true":"false";return this.d===M?w.INSTANCE:E.INSTANCE}return this}evaluate(L){return L.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(L){return L.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=f;class y{static create(L,M){return new y(L,M)}constructor(L,M){this.d=L,this.f=M,this.type=10,this.c=null}cmp(L){return L.type!==this.type?this.type-L.type:R(this.d,this.f,L.d,L.f)}equals(L){return L.type===this.type?this.d===L.d&&this.f===L.f:!1}substituteConstants(){return this}evaluate(L){const M=L.getValue(this.f),$=L.getValue(this.d);return Array.isArray(M)?M.includes($):typeof $=="string"&&typeof M=="object"&&M!==null?O.call(M,$):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(L){return L.mapIn(this.d,this.f)}negate(){return this.c||(this.c=v.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=y;class v{static create(L,M){return new v(L,M)}constructor(L,M){this.d=L,this.f=M,this.type=11,this.c=y.create(L,M)}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(L){return L.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=v;class l{static create(L,M,$=null){if(typeof M=="boolean")return M?m.create(L,$):p.create(L,$);const G=A.get(L);return typeof G=="boolean"?M===(G?"true":"false")?E.INSTANCE:w.INSTANCE:new l(L,M,$)}constructor(L,M,$){this.c=L,this.d=M,this.f=$,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:R(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=A.get(this.c);if(typeof L=="boolean"){const M=L?"true":"false";return this.d===M?E.INSTANCE:w.INSTANCE}return this}evaluate(L){return L.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(L){return L.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=l;class m{static create(L,M=null){const $=A.get(L);return typeof $=="boolean"?$?E.INSTANCE:w.INSTANCE:new m(L,M)}constructor(L,M){this.c=L,this.d=M,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:b(this.c,L.c)}equals(L){return L.type===this.type?this.c===L.c:!1}substituteConstants(){const L=A.get(this.c);return typeof L=="boolean"?L?E.INSTANCE:w.INSTANCE:this}evaluate(L){return!L.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(L){return L.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.ContextKeyNotExpr=m;function u(F,L){if(typeof F=="string"){const M=parseFloat(F);isNaN(M)||(F=M)}return typeof F=="string"||typeof F=="number"?L(F):E.INSTANCE}class d{static create(L,M,$=null){return u(M,G=>new d(L,G,$))}constructor(L,M,$){this.c=L,this.d=M,this.f=$,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:R(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=d;class h{static create(L,M,$=null){return u(M,G=>new h(L,G,$))}constructor(L,M,$){this.c=L,this.d=M,this.f=$,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:R(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=n.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=h;class n{static create(L,M,$=null){return u(M,G=>new n(L,G,$))}constructor(L,M,$){this.c=L,this.d=M,this.f=$,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:R(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=n;class r{static create(L,M,$=null){return u(M,G=>new r(L,G,$))}constructor(L,M,$){this.c=L,this.d=M,this.f=$,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:R(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=d.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=r;class t{static create(L,M){return new t(L,M)}constructor(L,M){this.d=L,this.f=M,this.type=7,this.c=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.d<L.d)return-1;if(this.d>L.d)return 1;const M=this.f?this.f.source:"",$=L.f?L.f.source:"";return M<$?-1:M>$?1:0}equals(L){if(L.type===this.type){const M=this.f?this.f.source:"",$=L.f?L.f.source:"";return this.d===L.d&&M===$}return!1}substituteConstants(){return this}evaluate(L){const M=L.getValue(this.d);return this.f?this.f.test(M):!1}serialize(){const L=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${L}`}keys(){return[this.d]}map(L){return L.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=o.create(this)),this.c}}e.ContextKeyRegexExpr=t;class o{static create(L){return new o(L)}constructor(L){this.c=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(L){return new o(this.c.map(L))}negate(){return this.c}}e.ContextKeyNotRegexExpr=o;function s(F){let L=null;for(let M=0,$=F.length;M<$;M++){const G=F[M].substituteConstants();if(F[M]!==G&&L===null){L=[];for(let W=0;W<M;W++)L[W]=F[W]}L!==null&&(L[M]=G)}return L===null?F:L}class c{static create(L,M,$){return c.d(L,M,$)}constructor(L,M){this.expr=L,this.c=M,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let M=0,$=this.expr.length;M<$;M++){const G=C(this.expr[M],L.expr[M]);if(G!==0)return G}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let M=0,$=this.expr.length;M<$;M++)if(!this.expr[M].equals(L.expr[M]))return!1;return!0}return!1}substituteConstants(){const L=s(this.expr);return L===this.expr?this:c.create(L,this.c,!1)}evaluate(L){for(let M=0,$=this.expr.length;M<$;M++)if(!this.expr[M].evaluate(L))return!1;return!0}static d(L,M,$){const G=[];let W=!1;for(const _ of L)if(!!_){if(_.type===1){W=!0;continue}if(_.type===0)return E.INSTANCE;if(_.type===6){G.push(..._.expr);continue}G.push(_)}if(G.length===0&&W)return w.INSTANCE;if(G.length!==0){if(G.length===1)return G[0];G.sort(C);for(let _=1;_<G.length;_++)G[_-1].equals(G[_])&&(G.splice(_,1),_--);if(G.length===1)return G[0];for(;G.length>1;){const _=G[G.length-1];if(_.type!==9)break;G.pop();const K=G.pop(),q=G.length===0,V=a.create(_.expr.map(Z=>c.create([Z,K],null,$)),null,q);V&&(G.push(V),G.sort(C))}if(G.length===1)return G[0];if($){for(let _=0;_<G.length;_++)for(let K=_+1;K<G.length;K++)if(G[_].negate().equals(G[K]))return E.INSTANCE;if(G.length===1)return G[0]}return new c(G,M)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const M of this.expr)L.push(...M.keys());return L}map(L){return new c(this.expr.map(M=>M.map(L)),null)}negate(){if(!this.c){const L=[];for(const M of this.expr)L.push(M.negate());this.c=a.create(L,this,!0)}return this.c}}class a{static create(L,M,$){return a.d(L,M,$)}constructor(L,M){this.expr=L,this.c=M,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let M=0,$=this.expr.length;M<$;M++){const G=C(this.expr[M],L.expr[M]);if(G!==0)return G}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let M=0,$=this.expr.length;M<$;M++)if(!this.expr[M].equals(L.expr[M]))return!1;return!0}return!1}substituteConstants(){const L=s(this.expr);return L===this.expr?this:a.create(L,this.c,!1)}evaluate(L){for(let M=0,$=this.expr.length;M<$;M++)if(this.expr[M].evaluate(L))return!0;return!1}static d(L,M,$){let G=[],W=!1;if(L){for(let _=0,K=L.length;_<K;_++){const q=L[_];if(!!q){if(q.type===0){W=!0;continue}if(q.type===1)return w.INSTANCE;if(q.type===9){G=G.concat(q.expr);continue}G.push(q)}}if(G.length===0&&W)return E.INSTANCE;G.sort(C)}if(G.length!==0){if(G.length===1)return G[0];for(let _=1;_<G.length;_++)G[_-1].equals(G[_])&&(G.splice(_,1),_--);if(G.length===1)return G[0];if($){for(let _=0;_<G.length;_++)for(let K=_+1;K<G.length;K++)if(G[_].negate().equals(G[K]))return w.INSTANCE;if(G.length===1)return G[0]}return new a(G,M)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const M of this.expr)L.push(...M.keys());return L}map(L){return new a(this.expr.map(M=>M.map(L)),null)}negate(){if(!this.c){const L=[];for(const M of this.expr)L.push(M.negate());for(;L.length>1;){const M=L.shift(),$=L.shift(),G=[];for(const W of z(M))for(const _ of z($))G.push(c.create([W,_],null,!1));L.unshift(a.create(G,null,!1))}this.c=a.create(L,this,!0)}return this.c}}class g extends p{static all(){return g.d.values()}constructor(L,M,$){super(L,null),this.f=M,typeof $=="object"?g.d.push({...$,key:L}):$!==!0&&g.d.push({key:L,description:$,type:M!=null?typeof M:void 0})}bindTo(L){return L.createKey(this.key,this.f)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return f.create(this.key,L)}notEqualsTo(L){return l.create(this.key,L)}}e.RawContextKey=g,g.d=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService");function b(F,L){return F<L?-1:F>L?1:0}function R(F,L,M,$){return F<M?-1:F>M?1:L<$?-1:L>$?1:0}function j(F,L){if(F.type===0||L.type===1)return!0;if(F.type===9)return L.type===9?U(F.expr,L.expr):!1;if(L.type===9){for(const M of L.expr)if(j(F,M))return!0;return!1}if(F.type===6){if(L.type===6)return U(L.expr,F.expr);for(const M of F.expr)if(j(M,L))return!0;return!1}return F.equals(L)}e.implies=j;function U(F,L){let M=0,$=0;for(;M<F.length&&$<L.length;){const G=F[M].cmp(L[$]);if(G<0)return!1;G===0&&M++,$++}return M===F.length}function z(F){return F.type===9?F.expr:[F]}}),define(oe[95],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function i(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=i;class D{async getPerformanceInfo(O,P){return{}}async getSystemInfo(O,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,P){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.NullDiagnosticsService=D}),define(oe[96],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(oe[15],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(oe[29],ae([0,1,155,4]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function A(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function O(l,m){switch(l){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=O;function P(l,m){return m==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function I(l,m,u){return P(m,u)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===u?!0:S(u).includes(l)}e.isTargetPlatformCompatible=I;function S(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=S;function C(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=C;var E;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var w;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(w=e.SortOrder||(e.SortOrder={}));var p;(function(l){l.Install="install",l.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var f;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,i.createDecorator)("extensionGalleryService");var y;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(y=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class v extends Error{constructor(m,u){super(m),this.code=u,this.name=u}}e.ExtensionManagementError=v,e.IExtensionManagementService=(0,i.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,i.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,i.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,k.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,k.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(oe[193],ae([0,1,3,2,67,32,7,142,29]),function(ee,e,k,i,D,A,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function S(v,l){return O.URI.revive(l?l.transformIncoming(v):v)}function C(v,l){return l?l.transformOutgoingURI(v):v}function E(v,l){l=l||P.DefaultURITransformer;const m=v.manifest;return{...(0,P.transformAndReviveIncomingURIs)({...v,manifest:void 0},l),manifest:m}}function w(v,l){return l?(0,A.cloneAndChange)(v,m=>m instanceof O.URI?l.transformOutgoingURI(m):void 0):v}class p{constructor(l,m){this.a=l,this.b=m,this.onInstallExtension=k.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(l.onDidUninstallExtension,!0)}listen(l,m){const u=this.b(l);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,d=>d.map(h=>({...h,local:h.local?w(h.local,u):h.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(l,m,u){const d=this.b(l);switch(m){case"zip":return this.a.zip(E(u[0],d)).then(h=>C(h,d));case"unzip":return this.a.unzip(S(u[0],d));case"install":return this.a.install(S(u[0],d),(0,D.revive)(u[1]));case"installFromLocation":return this.a.installFromLocation(S(u[0],d),O.URI.revive(u[1]));case"getManifest":return this.a.getManifest(S(u[0],d));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(u[0]);case"installFromGallery":return this.a.installFromGallery(u[0],(0,D.revive)(u[1]));case"uninstall":return this.a.uninstall(E(u[0],d),(0,D.revive)(u[1]));case"reinstallFromGallery":return this.a.reinstallFromGallery(E(u[0],d));case"getInstalled":return this.a.getInstalled(u[0],O.URI.revive(u[1])).then(h=>h.map(n=>w(n,d)));case"getMetadata":return this.a.getMetadata(E(u[0],d));case"updateMetadata":return this.a.updateMetadata(E(u[0],d),u[1]).then(h=>w(h,d));case"updateExtensionScope":return this.a.updateExtensionScope(E(u[0],d),u[1]).then(h=>w(h,d));case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(u[0],u[1])}throw new Error("Invalid call")}}e.ExtensionManagementChannel=p;class f extends i.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}constructor(l){super(),this.j=l,this.c=this.B(new k.Emitter),this.f=this.B(new k.Emitter),this.g=this.B(new k.Emitter),this.h=this.B(new k.Emitter),this.B(this.j.listen("onInstallExtension")(m=>this.c.fire({identifier:m.identifier,source:this.k(m.source)?O.URI.revive(m.source):m.source,profileLocation:O.URI.revive(m.profileLocation)}))),this.B(this.j.listen("onDidInstallExtensions")(m=>this.f.fire(m.map(u=>({...u,local:u.local?E(u.local,null):u.local,source:this.k(u.source)?O.URI.revive(u.source):u.source,profileLocation:O.URI.revive(u.profileLocation)}))))),this.B(this.j.listen("onUninstallExtension")(m=>this.g.fire({identifier:m.identifier,profileLocation:O.URI.revive(m.profileLocation)}))),this.B(this.j.listen("onDidUninstallExtension")(m=>this.h.fire({...m,profileLocation:O.URI.revive(m.profileLocation)})))}k(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this.l||(this.l=this.j.call("getTargetPlatform")),this.l}async canInstall(l){const m=await this.getTargetPlatform();return l.allTargetPlatforms.some(u=>(0,I.isTargetPlatformCompatible)(u,l.allTargetPlatforms,m))}zip(l){return Promise.resolve(this.j.call("zip",[l]).then(m=>O.URI.revive(m)))}unzip(l){return Promise.resolve(this.j.call("unzip",[l]))}install(l,m){return Promise.resolve(this.j.call("install",[l,m])).then(u=>E(u,null))}installFromLocation(l,m){return Promise.resolve(this.j.call("installFromLocation",[l,m])).then(u=>E(u,null))}getManifest(l){return Promise.resolve(this.j.call("getManifest",[l]))}installFromGallery(l,m){return Promise.resolve(this.j.call("installFromGallery",[l,m])).then(u=>E(u,null))}uninstall(l,m){return Promise.resolve(this.j.call("uninstall",[l,m]))}reinstallFromGallery(l){return Promise.resolve(this.j.call("reinstallFromGallery",[l]))}getInstalled(l=null,m){return Promise.resolve(this.j.call("getInstalled",[l,m])).then(u=>u.map(d=>E(d,null)))}getMetadata(l){return Promise.resolve(this.j.call("getMetadata",[l]))}updateMetadata(l,m){return Promise.resolve(this.j.call("updateMetadata",[l,m])).then(u=>E(u,null))}updateExtensionScope(l,m){return Promise.resolve(this.j.call("updateExtensionScope",[l,m])).then(u=>E(u,null))}getExtensionsControlManifest(){return Promise.resolve(this.j.call("getExtensionsControlManifest"))}async download(l,m){const u=await this.j.call("download",[l,m]);return O.URI.revive(u)}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=f;class y{constructor(l){this.a=l}listen(l,m){throw new Error("Invalid listen")}call(l,m,u){switch(m){case"getConfigBasedTips":return this.a.getConfigBasedTips(O.URI.revive(u[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=y}),define(oe[97],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,k.createDecorator)("IExtensionSignatureVerificationService");class i{b(){return this.a||(this.a=new Promise((A,O)=>ee(["node-vsce-sign"],async P=>A(P),O))),this.a}async verify(A,O){let P;try{P=await this.b()}catch{return!1}return P.verify(A,O)}}e.ExtensionSignatureVerificationService=i}),define(oe[98],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var i;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(i=e.RecommendationSource||(e.RecommendationSource={}));function D(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=D;var A;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(A=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,k.createDecorator)("IExtensionRecommendationNotificationService")}),define(oe[13],ae([0,1,48,12,27,14,7,163,4]),function(ee,e,k,i,D,A,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function S(W){return W.create===!0}e.isFileOpenForWriteOptions=S;var C;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(C=e.FileType||(e.FileType={}));var E;(function(W){W[W.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var w;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileClone=32768]="FileClone"})(w=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=p;function f(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=f;function y(W){return!!(W.capabilities&32768)}e.hasFileCloneCapability=y;function v(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function l(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=l;function m(W){return p(W)?!!(W.capabilities&16384):!1}e.hasFileAtomicReadCapability=m;var u;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(u=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class d extends Error{constructor(_,K){super(_),this.code=K}}e.FileSystemProviderError=d;function h(W,_){const K=new d(W.toString(),_);return r(K,_),K}e.createFileSystemProviderError=h;function n(W){return W||h((0,P.localize)(0,null),u.Unknown)}e.ensureFileSystemProviderError=n;function r(W,_){return W.name=_?`${_} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=r;function t(W){if(!W)return u.Unknown;if(W instanceof d)return W.code;const _=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!_)return u.Unknown;switch(_[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileExceedsMemoryLimit:return u.FileExceedsMemoryLimit;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}e.toFileSystemProviderErrorCode=t;function o(W){if(W instanceof R)return W.fileOperationResult;switch(t(W)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 10;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileExceedsMemoryLimit:return 9;case u.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var s;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class c{constructor(_,K,q){this.resource=_,this.operation=K,this.target=q}isOperation(_){return this.operation===_}}e.FileOperationEvent=c;var a;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class g{constructor(_,K){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=_;const q=new Map;for(const V of _){const Z=q.get(V.type);switch(Z?Z.push([V.resource,V]):q.set(V.type,[[V.resource,V]]),V.type){case 1:this.rawAdded.push(V.resource);break;case 0:this.rawUpdated.push(V.resource);break;case 2:this.rawDeleted.push(V.resource);break}}for(const[V,Z]of q)switch(V){case 1:this.a=k.TernarySearchTree.forUris(()=>K),this.a.fill(Z);break;case 0:this.b=k.TernarySearchTree.forUris(()=>K),this.b.fill(Z);break;case 2:this.c=k.TernarySearchTree.forUris(()=>K),this.c.fill(Z);break}}contains(_,...K){return this.d(_,{includeChildren:!1},...K)}affects(_,...K){return this.d(_,{includeChildren:!0},...K)}d(_,K,...q){if(!_)return!1;const V=q.length>0;return!!((!V||q.includes(1))&&(this.a?.get(_)||K.includeChildren&&this.a?.findSuperstr(_))||(!V||q.includes(0))&&(this.b?.get(_)||K.includeChildren&&this.b?.findSuperstr(_))||(!V||q.includes(2))&&(this.c?.findSubstr(_)||K.includeChildren&&this.c?.findSuperstr(_)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=g;function b(W,_,K){return!W||!_||W===_||_.length>W.length?!1:(_.charAt(_.length-1)!==i.sep&&(_+=i.sep),K?(0,D.startsWithIgnoreCase)(W,_):W.indexOf(_)===0)}e.isParent=b;class R extends Error{constructor(_,K,q){super(_),this.fileOperationResult=K,this.options=q}}e.FileOperationError=R;class j extends R{constructor(_,K,q){super(_,2,q),this.stat=K}}e.NotModifiedSinceFileOperationError=j;var U;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(U=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var z;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(z=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=F;async function L(W,_){if(!_.hasProvider(O.URI.from({scheme:W.scheme})))return new Promise(K=>{const q=_.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===W.scheme&&V.added&&(q.dispose(),K())})})}e.whenProviderRegistered=L,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(_){return(0,A.isNumber)(_)||(_=0),_<M.KB?(0,P.localize)(1,null,_.toFixed(0)):_<M.MB?(0,P.localize)(2,null,(_/M.KB).toFixed(2)):_<M.GB?(0,P.localize)(3,null,(_/M.MB).toFixed(2)):_<M.TB?(0,P.localize)(4,null,(_/M.GB).toFixed(2)):(0,P.localize)(5,null,(_/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var $;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})($=e.Arch||(e.Arch={}));function G(W){return{maxFileSize:W===0?300*M.MB:16*M.GB,maxHeapSize:W===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=G});var Y=this&&this.__param||function(ee,e){return function(k,i){e(k,i,ee)}};define(oe[194],ae([0,1,99,44,13]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let A=class{constructor(P){this.a=P}async checksum(P){const I=(await this.a.readFileStream(P)).value;return new Promise((S,C)=>{const E=(0,k.createHash)("md5");(0,i.listenStream)(I,{onData:w=>E.update(w.buffer),onError:w=>C(w),onEnd:()=>S(E.digest("base64").replace(/=+$/,""))})})}};A=pe([Y(0,D.IFileService)],A),e.ChecksumService=A}),define(oe[195],ae([0,1,17,38,9,3,2,44,7,31,13]),function(ee,e,k,i,D,A,O,P,I,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class E extends O.Disposable{constructor(p,f){super(),this.a=p,this.b=f,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new A.Emitter),this.onDidWatchError=this.g.event,this.h=(0,S.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(p){return this.a.call("stat",[p])}readdir(p){return this.a.call("readdir",[p])}async readFile(p,f){const{buffer:y}=await this.a.call("readFile",[p,f]);return y}readFileStream(p,f,y){const v=(0,P.newWriteableStream)(m=>k.VSBuffer.concat(m.map(u=>k.VSBuffer.wrap(u))).buffer),l=this.a.listen("readFileStream",[p,f])(m=>{if(m instanceof k.VSBuffer)v.write(m.buffer);else{if(m==="end")v.end();else{let u=m;u instanceof Error||(u=(0,C.createFileSystemProviderError)((0,i.toErrorMessage)(u),C.FileSystemProviderErrorCode.Unknown)),v.error(u),v.end()}l.dispose()}});return y.onCancellationRequested(()=>{v.error((0,D.canceled)()),v.end(),l.dispose()}),v}writeFile(p,f,y){return this.a.call("writeFile",[p,k.VSBuffer.wrap(f),y])}open(p,f){return this.a.call("open",[p,f])}close(p){return this.a.call("close",[p])}async read(p,f,y,v,l){const[m,u]=await this.a.call("read",[p,f,l]);return y.set(m.buffer.slice(0,u),v),u}write(p,f,y,v,l){return this.a.call("write",[p,f,k.VSBuffer.wrap(y),v,l])}mkdir(p){return this.a.call("mkdir",[p])}delete(p,f){return this.a.call("delete",[p,f])}rename(p,f,y){return this.a.call("rename",[p,f,y])}copy(p,f,y){return this.a.call("copy",[p,f,y])}cloneFile(p,f){return this.a.call("cloneFile",[p,f])}i(){this.B(this.a.listen("fileChange",[this.h])(p=>{if(Array.isArray(p)){const f=p;this.f.fire(f.map(y=>({resource:I.URI.revive(y.resource),type:y.type})))}else{const f=p;this.g.fire(f)}}))}watch(p,f){const y=(0,S.generateUuid)();return this.a.call("watch",[this.h,y,p,f]),(0,O.toDisposable)(()=>this.a.call("unwatch",[this.h,y]))}}e.DiskFileSystemProviderClient=E}),define(oe[100],ae([0,1,17,9,164,13]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function O(C,E,w,p,f,y){let v;try{await P(C,E,w,p,f,y)}catch(l){v=l}finally{v&&f.errorTransformer&&(v=f.errorTransformer(v)),typeof v<"u"&&w.error(v),w.end()}}e.readFileIntoStream=O;async function P(C,E,w,p,f,y){I(y);const v=await C.open(E,{create:!1});try{I(y);let l=0,m=0,u=f&&typeof f.length=="number"?f.length:void 0,d=k.VSBuffer.alloc(Math.min(f.bufferSize,typeof u=="number"?u:f.bufferSize)),h=f&&typeof f.position=="number"?f.position:0,n=0;do m=await C.read(v,h,d.buffer,n,d.byteLength-n),h+=m,n+=m,l+=m,typeof u=="number"&&(u-=m),n===d.byteLength&&(await w.write(p(d)),d=k.VSBuffer.alloc(Math.min(f.bufferSize,typeof u=="number"?u:f.bufferSize)),n=0);while(m>0&&(typeof u!="number"||u>0)&&I(y)&&S(l,f));if(n>0){let r=n;typeof u=="number"&&(r=Math.min(n,u)),w.write(p(d.slice(0,r)))}}catch(l){throw(0,A.ensureFileSystemProviderError)(l)}finally{await C.close(v)}}function I(C){if(C.isCancellationRequested)throw(0,i.canceled)();return!0}function S(C,E){if(E?.limits){if(typeof E.limits.memory=="number"&&C>E.limits.memory)throw(0,A.createFileSystemProviderError)((0,D.localize)(0,null),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&C>E.limits.size)throw(0,A.createFileSystemProviderError)((0,D.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(oe[55],ae([0,1,89,2,12,5,7,13]),function(ee,e,k,i,D,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function I(l){return l.recursive===!0}e.isRecursiveWatchRequest=I;class S extends i.Disposable{constructor(m,u,d,h){super(),this.h=m,this.i=u,this.j=d,this.k=h,this.c=this.B(new i.MutableDisposable),this.f=void 0,this.g=0}m(){const m=new i.DisposableStore;this.c.value=m,this.b=this.l(m),this.b.setVerboseLogging(this.j),m.add(this.b.onDidChangeFile(u=>this.h(u))),m.add(this.b.onDidLogMessage(u=>this.i(u))),m.add(this.b.onDidError(u=>this.n(u)))}n(m){this.k.restartOnError?this.g<S.a&&this.f?(this.r(`restarting watcher after error: ${m}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${m}`):this.r(m)}p(m){this.g++,this.m(),this.watch(m)}async watch(m){this.f=m,await this.b?.watch(m)}async setVerboseLogging(m){this.j=m,await this.b?.setVerboseLogging(m)}r(m){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${m}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=S,S.a=5;class C extends S{constructor(m,u,d){super(m,u,d,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=C;class E extends S{constructor(m,u,d){super(m,u,d,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=E;function w(l){return l.map(m=>({type:m.type,resource:O.URI.file(m.path)}))}e.toFileChanges=w;function p(l){const m=new v;for(const u of l)m.processEvent(u);return m.coalesce()}e.coalesceEvents=p;function f(l,m){return typeof m=="string"&&!m.startsWith(k.GLOBSTAR)&&!(0,D.isAbsolute)(m)?{base:l,pattern:m}:m}e.normalizeWatcherPattern=f;function y(l,m){const u=[];for(const d of m)u.push((0,k.parse)(f(l,d)));return u}e.parseWatcherPatterns=y;class v{constructor(){this.a=new Set,this.b=new Map}c(m){return A.isLinux?m.path:m.path.toLowerCase()}processEvent(m){const u=this.b.get(this.c(m));let d=!1;if(u){const h=u.type,n=m.type;u.path!==m.path&&(m.type===2||m.type===1)?d=!0:h===1&&n===2?(this.b.delete(this.c(m)),this.a.delete(u)):h===2&&n===1?u.type=0:h===1&&n===0||(u.type=n)}else d=!0;d&&(this.a.add(m),this.b.set(this.c(m),m))}coalesce(){const m=[],u=[];return Array.from(this.a).filter(d=>d.type!==2?(m.push(d),!1):!0).sort((d,h)=>d.path.length-h.path.length).filter(d=>u.some(h=>(0,P.isParent)(d.path,h,!A.isLinux))?!1:(u.push(d.path),!0)).concat(m)}}}),define(oe[196],ae([0,1,52,6,23,47,2,85,12,5,144,28,55]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class p extends O.Disposable{constructor(v,l,m,u){super(),this.k=v,this.l=l,this.m=m,this.n=u,this.c=new i.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},d=>this.l(d)),this.f=this.B(new i.ThrottledDelayer(p.b)),this.g=[],this.h=(0,w.parseWatcherPatterns)(this.k.path,this.k.excludes),this.i=this.k.includes?(0,w.parseWatcherPatterns)(this.k.path,this.k.includes):void 0,this.j=new D.CancellationTokenSource,this.ready=this.r()}async r(){try{const v=await this.s(this.k);if(this.j.token.isCancellationRequested)return;const l=await E.Promises.stat(v);this.B(await this.t(v,l.isDirectory()))}catch(v){v.code!=="ENOENT"?this.w(v):this.z(v)}}async s(v){let l=v.path;try{l=await E.Promises.realpath(v.path),v.path===l&&(l=await(0,C.realcase)(v.path)??v.path),v.path!==l&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${v.path}, real: ${l})`)}catch{}return l}async t(v,l){if(S.isMacintosh&&(0,A.isEqualOrParent)(v,"/Volumes/",!0))return this.w(`Refusing to watch ${v} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),O.Disposable.None;const m=new D.CancellationTokenSource(this.j.token),u=new O.DisposableStore;try{const d=(0,I.basename)(v),h=(0,k.watch)(v);u.add((0,O.toDisposable)(()=>{h.removeAllListeners(),h.close()})),this.z(`Started watching: '${v}'`);const n=new Set;if(l)try{for(const t of await E.Promises.readdir(v))n.add(t)}catch(t){this.w(t)}const r=new Map;u.add((0,O.toDisposable)(()=>{for(const[,t]of r)t.dispose();r.clear()})),h.on("error",(t,o)=>{this.w(`Failed to watch ${v} for changes using fs.watch() (${t}, ${o})`),this.dispose()}),h.on("change",(t,o)=>{if(m.token.isCancellationRequested)return;this.z(`[raw] ["${t}"] ${o}`);let s="";if(o&&(s=o.toString(),S.isMacintosh&&(s=(0,P.normalizeNFC)(s))),!(!s||t!=="change"&&t!=="rename"))if(l)if(t==="rename"){r.get(s)?.dispose();const c=setTimeout(async()=>{if(r.delete(s),s===d&&!await E.Promises.exists(v)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.v((0,I.join)(v,s));if(m.token.isCancellationRequested)return;let g;a?n.has(s)?g=0:(g=1,n.add(s)):(n.delete(s),g=2),this.u({path:(0,I.join)(this.k.path,s),type:g})},p.a);r.set(s,(0,O.toDisposable)(()=>clearTimeout(c)))}else{let c;n.has(s)?c=0:(c=1,n.add(s)),this.u({path:(0,I.join)(this.k.path,s),type:c})}else if(t==="rename"||s!==d){const c=setTimeout(async()=>{const a=await E.Promises.exists(v);m.token.isCancellationRequested||(a?(this.u({path:this.k.path,type:0},!0),u.add(await this.t(v,!1))):(await this.u({path:this.k.path,type:2},!0),this.dispose()))},p.a);u.clear(),u.add((0,O.toDisposable)(()=>clearTimeout(c)))}else this.u({path:this.k.path,type:0},!0)})}catch(d){await E.Promises.exists(v)&&!m.token.isCancellationRequested&&this.w(`Failed to watch ${v} for changes using fs.watch() (${d.toString()})`)}return(0,O.toDisposable)(()=>{m.dispose(!0),u.dispose()})}async u(v,l=!1){if(!this.j.token.isCancellationRequested){this.n&&this.z(`${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.path}`),!l&&this.h.some(m=>m(v.path))?this.n&&this.z(` >> ignored (excluded) ${v.path}`):!l&&this.i&&this.i.length>0&&!this.i.some(m=>m(v.path))?this.n&&this.z(` >> ignored (not included) ${v.path}`):this.g.push(v);try{await this.f.trigger(async()=>{const m=this.g;this.g=[];const u=(0,w.coalesceEvents)(m);if(u.length>0){if(this.n)for(const h of u)this.z(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);this.c.work(u)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async v(v){if(S.isLinux)return E.Promises.exists(v);try{const l=(0,I.basename)(v);return(await E.Promises.readdir((0,I.dirname)(v))).some(u=>u===l)}catch(l){return this.z(l),!1}}setVerboseLogging(v){this.n=v}w(v){this.j.token.isCancellationRequested||this.m?.({type:"error",message:`[File Watcher (node.js)] ${v}`})}y(v){this.j.token.isCancellationRequested||this.m?.({type:"warn",message:`[File Watcher (node.js)] ${v}`})}z(v){!this.j.token.isCancellationRequested&&this.n&&this.m?.({type:"trace",message:`[File Watcher (node.js)] ${v}`})}dispose(){this.z(`stopping file watcher on ${this.k.path}`),this.j.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=p,p.a=100,p.b=50;async function f(y,v,l,m,u=512){const d=await E.Promises.open(y,"r"),h=Buffer.allocUnsafe(u),n=new D.CancellationTokenSource(m);let r,t=!1;const o={path:y,excludes:[],recursive:!1},s=new p(o,c=>{(async()=>{for(const{type:a}of c)if(a===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:g}=await E.Promises.read(d,h,0,u,null);if(!g||n.token.isCancellationRequested)break;v(h.slice(0,g))}}catch(g){r=new Error(g),n.dispose(!0)}finally{t=!1}}})()});return await s.ready,l(),new Promise((c,a)=>{n.token.onCancellationRequested(async()=>{s.dispose();try{await E.Promises.close(d)}catch(g){r=new Error(g)}r?a(r):c()})})}e.watchFileContents=f}),define(oe[197],ae([0,1,3,89,2,5,196]),function(ee,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends D.Disposable{constructor(){super(...arguments),this.a=this.B(new k.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new k.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=k.Event.None,this.c=new Map,this.f=!1}async watch(S){const C=this.i(S),E=C.filter(p=>{const f=this.c.get(p.path);return f?!(0,i.patternsEquals)(f.request.excludes,p.excludes)||!(0,i.patternsEquals)(f.request.includes,p.includes):!0}),w=Array.from(this.c.values()).filter(({request:p})=>!C.find(f=>f.path===p.path&&(0,i.patternsEquals)(f.excludes,p.excludes)&&(0,i.patternsEquals)(f.includes,p.includes))).map(({request:p})=>p.path);E.length&&this.j(`Request to start watching: ${E.map(p=>`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"}, includes: ${p.includes&&p.includes.length>0?JSON.stringify(p.includes):"<all>"})`).join(",")}`),w.length&&this.j(`Request to stop watching: ${w.join(",")}`);for(const p of w)this.h(p);for(const p of E)this.g(p)}g(S){const C=new O.NodeJSFileWatcherLibrary(S,w=>this.a.fire(w),w=>this.b.fire(w),this.f),E={request:S,instance:C};this.c.set(S.path,E)}async stop(){for(const[S]of this.c)this.h(S);this.c.clear()}h(S){const C=this.c.get(S);C&&(this.c.delete(S),C.instance.dispose())}i(S){const C=new Map;for(const E of S){const w=A.isLinux?E.path:E.path.toLowerCase();C.set(w,E)}return Array.from(C.values())}async setVerboseLogging(S){this.f=S;for(const[,C]of this.c)C.instance.setVerboseLogging(S)}j(S){this.f&&this.b.fire({type:"trace",message:this.k(S)})}k(S,C){return C?`[File Watcher (node.js)] ${S} (path: ${C.request.path})`:`[File Watcher (node.js)] ${S}`}}e.NodeJSWatcher=P}),define(oe[198],ae([0,1,55,197]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends k.AbstractNonRecursiveWatcherClient{constructor(O,P,I){super(O,P,I),this.m()}l(){return new i.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(oe[199],ae([0,1,24,39,68,55]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class O extends A.AbstractUniversalWatcherClient{constructor(I,S,C){super(I,S,C),this.m()}l(I){const S=I.add(new D.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return I.add(S.onDidProcessExit(({code:C,signal:E})=>this.n(`terminated by itself with code ${C}, signal: ${E}`))),i.ProxyChannel.toService((0,i.getNextTickChannel)(S.getChannel("watcher")))}}e.UniversalWatcherClient=O}),define(oe[72],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...D){this.a=new Map;for(const[A,O]of D)this.set(A,O)}set(D,A){const O=this.a.get(D);return this.a.set(D,A),O}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.ServiceCollection=k}),define(oe[200],ae([0,1,6,9,2,54,190,4,72,84]),function(ee,e,k,i,D,A,O,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const C=!1;class E extends Error{constructor(v){super("cyclic dependency between services"),this.message=v.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${v.toString()}`}}class w{constructor(v=new I.ServiceCollection,l=!1,m,u=C){this.f=v,this.g=l,this.h=m,this.i=u,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=u?m?._globalGraph??new O.Graph(d=>d):void 0}createChild(v){return new w(v,this.g,this,this.i)}invokeFunction(v,...l){const m=f.traceInvocation(this.i,v);let u=!1;try{return v({get:h=>{if(u)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const n=this.m(h,m);if(!n)throw new Error(`[invokeFunction] unknown service '${h}'`);return n}},...l)}finally{u=!0,m.stop()}}createInstance(v,...l){let m,u;return v instanceof A.SyncDescriptor?(m=f.traceCreation(this.i,v.ctor),u=this.j(v.ctor,v.staticArguments.concat(l),m)):(m=f.traceCreation(this.i,v),u=this.j(v,l,m)),m.stop(),u}j(v,l=[],m){const u=P._util.getServiceDependencies(v).sort((n,r)=>n.index-r.index),d=[];for(const n of u){const r=this.m(n.id,m);r||this.u(`[createInstance] ${v.name} depends on UNKNOWN service ${n.id}.`,!1),d.push(r)}const h=u.length>0?u[0].index:l.length;if(l.length!==h){console.trace(`[createInstance] First service dependency of ${v.name} at position ${h+1} conflicts with ${l.length} static arguments`);const n=h-l.length;n>0?l=l.concat(new Array(n)):l=l.slice(0,h)}return Reflect.construct(v,l.concat(d))}k(v,l){if(this.f.get(v)instanceof A.SyncDescriptor)this.f.set(v,l);else if(this.h)this.h.k(v,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(v){const l=this.f.get(v);return!l&&this.h?this.h.l(v):l}m(v,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(v));const m=this.l(v);return m instanceof A.SyncDescriptor?this.q(v,m,l.branch(v,!0)):(l.branch(v,!1),m)}q(v,l,m){if(this.o.has(v))throw new Error(`illegal state - RECURSIVELY instantiating service '${v}'`);this.o.add(v);try{return this.r(v,l,m)}finally{this.o.delete(v)}}r(v,l,m){const u=new O.Graph(n=>n.id.toString());let d=0;const h=[{id:v,desc:l,_trace:m}];for(;h.length;){const n=h.pop();if(u.lookupOrInsertNode(n),d++>1e3)throw new E(u);for(const r of P._util.getServiceDependencies(n.desc.ctor)){const t=this.l(r.id);if(t||this.u(`[createInstance] ${v} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),t instanceof A.SyncDescriptor){const o={id:r.id,desc:t,_trace:n._trace.branch(r.id,!0)};u.insertEdge(n,o),h.push(o)}}}for(;;){const n=u.roots();if(n.length===0){if(!u.isEmpty())throw new E(u);break}for(const{data:r}of n){if(this.l(r.id)instanceof A.SyncDescriptor){const o=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,o)}u.removeNode(r)}}return this.l(v)}s(v,l,m=[],u,d){if(this.f.get(v)instanceof A.SyncDescriptor)return this.t(v,l,m,u,d);if(this.h)return this.h.s(v,l,m,u,d);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(v,l,m=[],u,d){if(u){const h=new w(void 0,this.g,this,this.i);h.c=String(v);const n=new Map,r=new k.IdleValue(()=>{const t=h.j(l,m,d);for(const[o,s]of n){const c=t[o];if(typeof c=="function")for(const a of s)c.apply(t,a)}return n.clear(),t});return new Proxy(Object.create(null),{get(t,o){if(!r.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let a=n.get(o);return a||(a=new S.LinkedList,n.set(o,a)),(b,R,j)=>{const U=a.push([b,R,j]);return(0,D.toDisposable)(U)}}if(o in t)return t[o];const s=r.value;let c=s[o];return typeof c!="function"||(c=c.bind(s),t[o]=c),c},set(t,o,s){return r.value[o]=s,!0},getPrototypeOf(t){return l.prototype}})}else return this.j(l,m,d)}u(v,l){if(l&&console.warn(v),this.g)throw new Error(v)}}e.InstantiationService=w;var p;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(p||(p={}));class f{static traceInvocation(v,l){return v?new f(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(v,l){return v?new f(1,l.name):f.c}constructor(v,l){this.type=v,this.name=l,this.g=Date.now(),this.h=[]}branch(v,l){const m=new f(3,v.toString());return this.h.push([v,l,m]),m}stop(){const v=Date.now()-this.g;f.f+=v;let l=!1;function m(d,h){const n=[],r=new Array(d+1).join("	");for(const[t,o,s]of h.h)if(o&&s){l=!0,n.push(`${r}CREATES -> ${t}`);const c=m(d+1,s);c&&n.push(c)}else n.push(`${r}uses -> ${t}`);return n.join(`
`)}const u=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${v.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(v>2||l)&&f.all.add(u.join(`
`))}}e.Trace=f,f.all=new Set,f.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}},f.f=0}),define(oe[201],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class k{constructor(D,A){this.a=D,this.b=A}getChannel(D){return this.a.getChannel(D,this.b)}registerChannel(D,A){this.a.registerChannel(D,A)}}e.MessagePortMainProcessService=k}),define(oe[56],ae([0,1,39,54,71,4]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class O{constructor(p,f,y,v){const l=y.getChannel(p);return P(f)?v.createInstance(new i.SyncDescriptor(f.channelClientCtor,[l])):k.ProxyChannel.toService(l,f?.proxyOptions)}}function P(w){return!!w?.channelClientCtor}e.IMainProcessService=(0,A.createDecorator)("mainProcessService");let I=class extends O{constructor(p,f,y,v){super(p,f,y,v)}};I=pe([Y(2,e.IMainProcessService),Y(3,A.IInstantiationService)],I);function S(w,p,f){(0,D.registerSingleton)(w,new i.SyncDescriptor(I,[p,f],!0))}e.registerMainProcessRemoteService=S,e.ISharedProcessService=(0,A.createDecorator)("sharedProcessService");let C=class extends O{constructor(p,f,y,v){super(p,f,y,v)}};C=pe([Y(2,e.ISharedProcessService),Y(3,A.IInstantiationService)],C);function E(w,p,f){(0,D.registerSingleton)(w,new i.SyncDescriptor(C,[p,f],!0))}e.registerSharedProcessRemoteService=E}),define(oe[73],ae([0,1,23,2,5,166,29,4]),function(ee,e,k,i,D,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function I(C){return C.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=I,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let S=class extends i.Disposable{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new k.CancellationTokenSource;setTimeout(()=>E.cancel(),1e3);let w;try{w=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const f=w.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(v=>v.startsWith("lp-"))).map(y=>{const v=y.properties.localizedLanguages?.[0],l=I(y);return{...this.f(l,v,y),extensionId:y.identifier.id,galleryExtension:y}});return f.push({...this.f("en","English"),extensionId:"default"}),f}f(E,w,p){const f=w??E;let y;if(f!==E&&(y=`(${E})`),E.toLowerCase()===D.language.toLowerCase()&&(y??="",y+=(0,A.localize)(0,null)),p?.installCount){y??="";const v=p.installCount;let l;v>1e6?l=`${Math.floor(v/1e5)/10}M`:v>1e3?l=`${Math.floor(v/1e3)}K`:l=String(v),y+=` $(cloud-download) ${l}`}return{id:E,label:f,description:y}}};S=pe([Y(0,O.IExtensionGalleryService)],S),e.LanguagePackBaseService=S}),define(oe[202],ae([0,1,2,73]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let D=class extends k.Disposable{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};D=pe([Y(0,i.ILanguagePackService)],D),e.LocalizationsUpdater=D}),define(oe[8],ae([0,1,38,3,2,37,5,7,4]),function(ee,e,k,i,D,A,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function S(){return new Date().toISOString()}var C;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function E(c,a,g){switch(a){case C.Trace:c.trace(g);break;case C.Debug:c.debug(g);break;case C.Info:c.info(g);break;case C.Warning:c.warn(g);break;case C.Error:c.error(g);break;case C.Off:break;default:throw new Error(`Invalid log level ${a}`)}}e.log=E;function w(c){let a="";for(let g=0;g<c.length;g++){let b=c[g];if(typeof b=="object")try{b=JSON.stringify(b)}catch{}a+=(g>0?" ":"")+b}return a}e.format=w;class p extends D.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new i.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(a){this.b!==a&&(this.b=a,this.c.fire(this.b))}getLevel(){return this.b}f(a){return this.b!==C.Off&&this.b<=a}}e.AbstractLogger=p;class f extends p{constructor(a){super(),this.h=a}f(a){return this.h||super.f(a)}trace(a,...g){this.f(C.Trace)&&this.g(C.Trace,w([a,...g]))}debug(a,...g){this.f(C.Debug)&&this.g(C.Debug,w([a,...g]))}info(a,...g){this.f(C.Info)&&this.g(C.Info,w([a,...g]))}warn(a,...g){this.f(C.Warning)&&this.g(C.Warning,w([a,...g]))}error(a,...g){if(this.f(C.Error))if(a instanceof Error){const b=Array.prototype.slice.call(arguments);b[0]=a.stack,this.g(C.Error,w(b))}else this.g(C.Error,w([a,...g]))}flush(){}}e.AbstractMessageLogger=f;class y extends p{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.g=!O.isWindows}trace(a,...g){this.f(C.Trace)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,a,...g):console.log(`[main ${S()}]`,a,...g))}debug(a,...g){this.f(C.Debug)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,a,...g):console.log(`[main ${S()}]`,a,...g))}info(a,...g){this.f(C.Info)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,a,...g):console.log(`[main ${S()}]`,a,...g))}warn(a,...g){this.f(C.Warning)&&(this.g?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,a,...g):console.warn(`[main ${S()}]`,a,...g))}error(a,...g){this.f(C.Error)&&(this.g?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,a,...g):console.error(`[main ${S()}]`,a,...g))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class v extends p{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...g){this.f(C.Trace)&&console.log("%cTRACE","color: #888",a,...g)}debug(a,...g){this.f(C.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",a,...g)}info(a,...g){this.f(C.Info)&&console.log("%c INFO","color: #33f",a,...g)}warn(a,...g){this.f(C.Warning)&&console.log("%c WARN","color: #993",a,...g)}error(a,...g){this.f(C.Error)&&console.log("%c  ERR","color: #f33",a,...g)}dispose(){}flush(){}}e.ConsoleLogger=v;class l extends p{constructor(a,g=e.DEFAULT_LOG_LEVEL){super(),this.g=a,this.setLevel(g)}trace(a,...g){this.f(C.Trace)&&this.g.log(C.Trace,[this.h(a),...g])}debug(a,...g){this.f(C.Debug)&&this.g.log(C.Debug,[this.h(a),...g])}info(a,...g){this.f(C.Info)&&this.g.log(C.Info,[this.h(a),...g])}warn(a,...g){this.f(C.Warning)&&this.g.log(C.Warning,[this.h(a),...g])}error(a,...g){this.f(C.Error)&&this.g.log(C.Error,[this.h(a),...g])}h(a){return typeof a=="string"?a:(0,k.toErrorMessage)(a,this.f(C.Trace))}dispose(){}flush(){}}e.AdapterLogger=l;class m extends p{constructor(a){super(),this.g=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const g of this.g)g.setLevel(a);super.setLevel(a)}trace(a,...g){for(const b of this.g)b.trace(a,...g)}debug(a,...g){for(const b of this.g)b.debug(a,...g)}info(a,...g){for(const b of this.g)b.info(a,...g)}warn(a,...g){for(const b of this.g)b.warn(a,...g)}error(a,...g){for(const b of this.g)b.error(a,...g)}flush(){for(const a of this.g)a.flush()}dispose(){for(const a of this.g)a.dispose()}}e.MultiplexLogService=m;class u extends D.Disposable{constructor(a){super(),this.b=a,this.B(a)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(a){this.b.setLevel(a)}getLevel(){return this.b.getLevel()}trace(a,...g){this.b.trace(a,...g)}debug(a,...g){this.b.debug(a,...g)}info(a,...g){this.b.info(a,...g)}warn(a,...g){this.b.warn(a,...g)}error(a,...g){this.b.error(a,...g)}flush(){this.b.flush()}}e.LogService=u;class d extends D.Disposable{constructor(a,g){super(),this.c=a,this.b=new A.ResourceMap,this.B(g(b=>this.setLevel(b)))}getLoggers(){return[...this.b.values()].map(({logger:a})=>a)}getLogger(a){return this.b.get(a)?.logger}createLogger(a,g,b){let R=this.b.get(a)?.logger;return R||(b=g?.always?C.Trace:b,R=this.f(a,b??this.c,g),this.b.set(a,{logger:R,logLevel:b})),R}setLevel(a,g){const b=P.URI.isUri(a)?a:void 0,R=b?g:a;if(b){const j=this.b.get(b);j&&j.logLevel!==R&&(j.logLevel=R,j.logger.setLevel(R))}else this.c=R,this.b.forEach(({logLevel:j,logger:U})=>{j===void 0&&U.setLevel(this.c)})}getLogLevel(a){return this.b.get(a)?.logLevel}dispose(){this.b.forEach(({logger:a})=>a.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=d;class h{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(a){}getLevel(){return C.Info}trace(a,...g){}debug(a,...g){}info(a,...g){}warn(a,...g){}error(a,...g){}critical(a,...g){}dispose(){}flush(){}}e.NullLogger=h;class n extends h{}e.NullLogService=n;class r extends d{constructor(){super(C.Info,i.Event.None)}f(a,g,b){return new h}}e.NullLoggerService=r;function t(c){if(c.verbose)return C.Trace;if(typeof c.logLevel=="string"){const a=s(c.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=t;function o(c){switch(c){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Off:return"off"}}e.LogLevelToString=o;function s(c){switch(c){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Error;case"off":return C.Off}}e.parseLogLevel=s}),define(oe[203],ae([0,1,6,9,2,12,28,15,8]),function(ee,e,k,i,D,A,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let S=class extends D.Disposable{constructor(E,w){super(),this.a=E,this.b=w,this.B(new k.RunOnceScheduler(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const E=(0,A.basename)(this.a.logsPath),w=(0,A.dirname)(this.a.logsPath),y=(await O.Promises.readdir(w)).filter(l=>/^\d{8}T\d{6}$/.test(l)).sort().filter(l=>l!==E),v=y.slice(0,Math.max(0,y.length-9));v.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${v.join(", ")}'`),await Promise.all(v.map(l=>O.Promises.rm((0,A.join)(w,l)))))}catch(E){(0,i.onUnexpectedError)(E)}}};S=pe([Y(0,P.IEnvironmentService),Y(1,I.ILogService)],S),e.LogsDataCleaner=S}),define(oe[204],ae([0,1,20,6,9,3,2,12,55,8]),function(ee,e,k,i,D,A,O,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class C extends O.Disposable{constructor(w,p){super(),this.a=w,this.b=p,this.c=this.B(new A.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new A.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new i.ThrottledDelayer(0)),this.s=[],this.t=this.B(new i.ThrottledDelayer(0))}watch(w,p){return p.recursive||this.b?.watcher?.forceUniversal?this.l(w,p):this.u(w,p)}l(w,p){const f={path:this.C(w),excludes:p.excludes,includes:p.includes,recursive:p.recursive},y=(0,k.insert)(this.j,f);return this.m(),(0,O.toDisposable)(()=>{y(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(w=>(0,D.onUnexpectedError)(w))}n(){this.h||(this.h=this.B(this.p(p=>this.c.fire((0,I.toFileChanges)(p)),p=>this.z(p),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const p of this.j)(0,I.isRecursiveWatchRequest)(p)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const p of this.j)(0,I.isRecursiveWatchRequest)(p)&&w.includes(p.path)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(w,p){const f={path:this.C(w),excludes:p.excludes,includes:p.includes,recursive:!1},y=(0,k.insert)(this.s,f);return this.v(),(0,O.toDisposable)(()=>{y(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(w=>(0,D.onUnexpectedError)(w))}w(){return this.r||(this.r=this.B(this.y(w=>this.c.fire((0,I.toFileChanges)(w)),w=>this.z(w),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.r.watch(this.s)}z(w){w.type==="error"&&this.g.fire(w.message),this.a[w.type](w.message)}C(w){return(0,P.normalize)(w.fsPath)}}e.AbstractDiskFileSystemProvider=C}),define(oe[205],ae([0,1,20,6,17,23,3,66,64,2,48,24,206,21,44,162,13,100,8]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p,f,y,v,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let u=class extends S.Disposable{constructor(h){super(),this.b=h,this.a=256*1024,this.c=this.B(new O.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new O.Emitter),this.onDidRunOperation=this.m.event,this.Q=this.B(new O.Emitter),this.onDidFilesChange=this.Q.event,this.R=this.B(new O.Emitter),this.onDidWatchError=this.R.event,this.S=new Map,this.W=this.B(new i.ResourceQueue)}registerProvider(h,n){if(this.h.has(h))throw new Error(`A filesystem provider for the scheme '${h}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${h}`);const r=new S.DisposableStore;return this.h.set(h,n),this.c.fire({added:!0,scheme:h,provider:n}),r.add(n.onDidChangeFile(t=>this.Q.fire(new v.FileChangesEvent(t,!this.N(n))))),typeof n.onDidWatchError=="function"&&r.add(n.onDidWatchError(t=>this.R.fire(new Error(t)))),r.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:h}))),(0,S.toDisposable)(()=>{this.c.fire({added:!1,scheme:h,provider:n}),this.h.delete(h),(0,S.dispose)(r)})}getProvider(h){return this.h.get(h)}async activateProvider(h){const n=[];this.f.fire({scheme:h,join(r){n.push(r)}}),!this.h.has(h)&&await i.Promises.settled(n)}async canHandleResource(h){return await this.activateProvider(h.scheme),this.hasProvider(h)}hasProvider(h){return this.h.has(h.scheme)}hasCapability(h,n){const r=this.h.get(h.scheme);return!!(r&&r.capabilities&n)}listCapabilities(){return I.Iterable.map(this.h,([h,n])=>({scheme:h,capabilities:n.capabilities}))}async j(h){if(!(0,p.isAbsolutePath)(h))throw new v.FileOperationError((0,y.localize)(0,null,this.mb(h)),8);await this.activateProvider(h.scheme);const n=this.h.get(h.scheme);if(!n){const r=new Error;throw r.name="ENOPRO",r.message=(0,y.localize)(1,null,h.toString()),r}return n}async k(h){const n=await this.j(h);if((0,v.hasOpenReadWriteCloseCapability)(n)||(0,v.hasReadWriteCapability)(n)||(0,v.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${h.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(h){const n=await this.j(h);if((0,v.hasOpenReadWriteCloseCapability)(n)||(0,v.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${h.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(h,n){try{return await this.n(h,n)}catch(r){throw(0,v.toFileSystemProviderErrorCode)(r)===v.FileSystemProviderErrorCode.FileNotFound?new v.FileOperationError((0,y.localize)(2,null,this.mb(h)),1):(0,v.ensureFileSystemProviderError)(r)}}async n(h,n){const r=await this.j(h),t=this.N(r),o=n?.resolveTo,s=n?.resolveSingleChildDescendants,c=n?.resolveMetadata,a=await r.stat(h);let g;return this.p(r,h,a,void 0,!!c,(b,R)=>(g||(g=C.TernarySearchTree.forUris(()=>!t),g.set(h,!0),o&&g.fill(!0,o)),g.get(b.resource)||g.findSuperstr(b.resource.with({query:null,fragment:null}))?!0:b.isDirectory&&s?R===1:!1))}async p(h,n,r,t,o,s){const{providerExtUri:c}=this.M(h),a={resource:n,name:c.basename(n),isFile:(r.type&v.FileType.File)!==0,isDirectory:(r.type&v.FileType.Directory)!==0,isSymbolicLink:(r.type&v.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&v.FilePermission.Readonly)||Boolean(h.capabilities&2048),etag:(0,v.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(a.isDirectory&&s(a,t)){try{const g=await h.readdir(n),b=await i.Promises.settled(g.map(async([R,j])=>{try{const U=c.joinPath(n,R),z=o?await h.stat(U):{type:j};return await this.p(h,U,z,g.length,o,s)}catch(U){return this.b.trace(U),null}}));a.children=(0,k.coalesce)(b)}catch(g){this.b.trace(g),a.children=[]}return a}return a}async resolveAll(h){return i.Promises.settled(h.map(async n=>{try{return{stat:await this.n(n.resource,n.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(h){const n=await this.j(h),r=await n.stat(h);return this.p(n,h,r,void 0,!0,()=>!1)}async exists(h){const n=await this.j(h);try{return!!await n.stat(h)}catch{return!1}}async canCreateFile(h,n){try{await this.r(h,n)}catch(r){return r}return!0}async r(h,n){if(!n?.overwrite&&await this.exists(h))throw new v.FileOperationError((0,y.localize)(3,null,this.mb(h)),3,n)}async createFile(h,n=D.VSBuffer.fromString(""),r){await this.r(h,r);const t=await this.writeFile(h,n);return this.m.fire(new v.FileOperationEvent(h,0,t)),t}async writeFile(h,n,r){const t=this.kb(await this.l(h),h),{providerExtUri:o}=this.M(t);try{await this.s(t,h,r)||await this.O(t,o.dirname(h));let c;if((0,v.hasReadWriteCapability)(t)&&!(n instanceof D.VSBuffer))if((0,f.isReadableStream)(n)){const a=await(0,f.peekStream)(n,3);a.ended?c=D.VSBuffer.concat(a.buffer):c=a}else c=(0,f.peekReadable)(n,a=>D.VSBuffer.concat(a),3);else c=n;!(0,v.hasOpenReadWriteCloseCapability)(t)||(0,v.hasReadWriteCapability)(t)&&c instanceof D.VSBuffer?await this.bb(t,h,r,c):await this.X(t,h,r,c instanceof D.VSBuffer?(0,D.bufferToReadable)(c):c),this.m.fire(new v.FileOperationEvent(h,4))}catch(s){throw new v.FileOperationError((0,y.localize)(4,null,this.mb(h),(0,v.ensureFileSystemProviderError)(s).toString()),(0,v.toFileOperationResult)(s),r)}return this.resolve(h,{resolveMetadata:!0})}async s(h,n,r){if(!!r?.unlock&&!(h.capabilities&8192))throw new Error((0,y.localize)(5,null,this.mb(n)));let o;try{o=await h.stat(n)}catch{return}if((o.type&v.FileType.Directory)!==0)throw new v.FileOperationError((0,y.localize)(6,null,this.mb(n)),0,r);if(this.lb(n,o),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==v.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&r.mtime<o.mtime&&r.etag!==(0,v.etag)({mtime:r.mtime,size:o.size}))throw new v.FileOperationError((0,y.localize)(7,null),3,r);return o}async readFile(h,n,r){const t=await this.k(h);return n?.atomic?this.t(t,h,n,r):this.u(t,h,n,r)}async t(h,n,r,t){return new Promise((o,s)=>{this.W.queueFor(n,this.M(h).providerExtUri).queue(async()=>{try{const c=await this.u(h,n,r,t);o(c)}catch(c){s(c)}})})}async u(h,n,r,t){const o=await this.v(h,n,{...r,preferUnbuffered:!0},t);return{...o,value:await(0,D.streamToBuffer)(o.value)}}async readFileStream(h,n,r){const t=await this.k(h);return this.v(t,h,n,r)}async v(h,n,r,t){const o=new A.CancellationTokenSource(t),s=this.D(n,r).then(a=>a,a=>{throw o.cancel(),a});let c;try{return typeof r?.etag=="string"&&r.etag!==v.ETAG_DISABLED&&await s,r?.atomic&&(0,v.hasFileAtomicReadCapability)(h)||!((0,v.hasOpenReadWriteCloseCapability)(h)||(0,v.hasFileReadStreamCapability)(h))||(0,v.hasReadWriteCapability)(h)&&r?.preferUnbuffered?c=this.C(h,n,r):(0,v.hasFileReadStreamCapability)(h)?c=this.w(h,n,o.token,r):c=this.z(h,n,o.token,r),{...await s,value:c}}catch(a){c&&await(0,f.consumeStream)(c);const g=(0,y.localize)(8,null,this.mb(n),(0,v.ensureFileSystemProviderError)(a).toString());throw a instanceof v.NotModifiedSinceFileOperationError?new v.NotModifiedSinceFileOperationError(g,a.stat,r):new v.FileOperationError(g,(0,v.toFileOperationResult)(a),r)}}w(h,n,r,t=Object.create(null)){const o=h.readFileStream(n,t,r);return(0,f.transform)(o,{data:s=>s instanceof D.VSBuffer?s:D.VSBuffer.wrap(s),error:s=>new v.FileOperationError((0,y.localize)(9,null,this.mb(n),(0,v.ensureFileSystemProviderError)(s).toString()),(0,v.toFileOperationResult)(s),t)},s=>D.VSBuffer.concat(s))}z(h,n,r,t=Object.create(null)){const o=(0,D.newWriteableBufferStream)();return(0,l.readFileIntoStream)(h,n,o,s=>s,{...t,bufferSize:this.a,errorTransformer:s=>new v.FileOperationError((0,y.localize)(10,null,this.mb(n),(0,v.ensureFileSystemProviderError)(s).toString()),(0,v.toFileOperationResult)(s),t)},r),o}C(h,n,r){const t=(0,f.newWriteableStream)(o=>D.VSBuffer.concat(o));return(async()=>{try{let o;r?.atomic&&(0,v.hasFileAtomicReadCapability)(h)?o=await h.readFile(n,{atomic:!0}):o=await h.readFile(n),typeof r?.position=="number"&&(o=o.slice(r.position)),typeof r?.length=="number"&&(o=o.slice(0,r.length)),this.F(n,o.byteLength,r),t.end(D.VSBuffer.wrap(o))}catch(o){t.error(o),t.end()}})(),t}async D(h,n){const r=await this.resolve(h,{resolveMetadata:!0});if(r.isDirectory)throw new v.FileOperationError((0,y.localize)(11,null,this.mb(h)),0,n);if(typeof n?.etag=="string"&&n.etag!==v.ETAG_DISABLED&&n.etag===r.etag)throw new v.NotModifiedSinceFileOperationError((0,y.localize)(12,null),r,n);return this.F(h,r.size,n),r}F(h,n,r){if(r?.limits){let t;if(typeof r.limits.memory=="number"&&n>r.limits.memory&&(t=9),typeof r.limits.size=="number"&&n>r.limits.size&&(t=7),typeof t=="number")throw new v.FileOperationError((0,y.localize)(13,null,this.mb(h)),t)}}async canMove(h,n,r){return this.G(h,n,"move",r)}async canCopy(h,n,r){return this.G(h,n,"copy",r)}async G(h,n,r,t){if(h.toString()!==n.toString())try{const o=r==="move"?this.kb(await this.l(h),h):await this.k(h),s=this.kb(await this.l(n),n);await this.L(o,h,s,n,r,t)}catch(o){return o}return!0}async move(h,n,r){const t=this.kb(await this.l(h),h),o=this.kb(await this.l(n),n),s=await this.H(t,h,o,n,"move",!!r),c=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new v.FileOperationEvent(h,s==="move"?2:3,c)),c}async copy(h,n,r){const t=await this.k(h),o=this.kb(await this.l(n),n),s=await this.H(t,h,o,n,"copy",!!r),c=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new v.FileOperationEvent(h,s==="copy"?3:2,c)),c}async H(h,n,r,t,o,s){if(n.toString()===t.toString())return o;const{exists:c,isSameResourceWithDifferentPathCase:a}=await this.L(h,n,r,t,o,s);if(c&&!a&&s&&await this.del(t,{recursive:!0}),await this.O(r,this.M(r).providerExtUri.dirname(t)),o==="copy"){if(h===r&&(0,v.hasFileFolderCopyCapability)(h))await h.copy(n,t,{overwrite:s});else{const g=await this.resolve(n);g.isDirectory?await this.J(h,g,r,t):await this.I(h,n,r,t)}return o}else return h===r?(await h.rename(n,t,{overwrite:s}),o):(await this.H(h,n,r,t,"copy",s),await this.del(n,{recursive:!0}),"copy")}async I(h,n,r,t){if((0,v.hasOpenReadWriteCloseCapability)(h)&&(0,v.hasOpenReadWriteCloseCapability)(r))return this.db(h,n,r,t);if((0,v.hasOpenReadWriteCloseCapability)(h)&&(0,v.hasReadWriteCapability)(r))return this.jb(h,n,r,t);if((0,v.hasReadWriteCapability)(h)&&(0,v.hasOpenReadWriteCloseCapability)(r))return this.hb(h,n,r,t);if((0,v.hasReadWriteCapability)(h)&&(0,v.hasReadWriteCapability)(r))return this.fb(h,n,r,t)}async J(h,n,r,t){await r.mkdir(t),Array.isArray(n.children)&&await i.Promises.settled(n.children.map(async o=>{const s=this.M(r).providerExtUri.joinPath(t,o.name);return o.isDirectory?this.J(h,await this.resolve(o.resource),r,s):this.I(h,o.resource,r,s)}))}async L(h,n,r,t,o,s){let c=!1;if(h===r){const{providerExtUri:g,isPathCaseSensitive:b}=this.M(h);if(b||(c=g.isEqual(n,t)),c&&o==="copy")throw new Error((0,y.localize)(14,null,this.mb(n),this.mb(t)));if(!c&&g.isEqualOrParent(t,n))throw new Error((0,y.localize)(15,null,this.mb(n),this.mb(t)))}const a=await this.exists(t);if(a&&!c){if(!s)throw new v.FileOperationError((0,y.localize)(16,null,this.mb(n),this.mb(t)),4);if(h===r){const{providerExtUri:g}=this.M(h);if(g.isEqualOrParent(n,t))throw new Error((0,y.localize)(17,null,this.mb(n),this.mb(t)))}}return{exists:a,isSameResourceWithDifferentPathCase:c}}M(h){const n=this.N(h);return{providerExtUri:n?p.extUri:p.extUriIgnorePathCase,isPathCaseSensitive:n}}N(h){return!!(h.capabilities&1024)}async createFolder(h){const n=this.kb(await this.j(h),h);await this.O(n,h);const r=await this.resolve(h,{resolveMetadata:!0});return this.m.fire(new v.FileOperationEvent(h,0,r)),r}async O(h,n){const r=[],{providerExtUri:t}=this.M(h);for(;!t.isEqual(n,t.dirname(n));)try{if(((await h.stat(n)).type&v.FileType.Directory)===0)throw new Error((0,y.localize)(18,null,this.mb(n)));break}catch(o){if((0,v.toFileSystemProviderErrorCode)(o)!==v.FileSystemProviderErrorCode.FileNotFound)throw o;r.push(t.basename(n)),n=t.dirname(n)}for(let o=r.length-1;o>=0;o--){n=t.joinPath(n,r[o]);try{await h.mkdir(n)}catch(s){if((0,v.toFileSystemProviderErrorCode)(s)!==v.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(h,n){try{await this.P(h,n)}catch(r){return r}return!0}async P(h,n){const r=this.kb(await this.j(h),h);if(!!n?.useTrash&&!(r.capabilities&4096))throw new Error((0,y.localize)(19,null,this.mb(h)));let o;try{o=await r.stat(h)}catch{}if(o)this.lb(h,o);else throw new v.FileOperationError((0,y.localize)(20,null,this.mb(h)),1);if(!!!n?.recursive){const c=await this.resolve(h);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,y.localize)(21,null,this.mb(h)))}return r}async del(h,n){const r=await this.P(h,n),t=!!n?.useTrash,o=!!n?.recursive;await r.delete(h,{recursive:o,useTrash:t}),this.m.fire(new v.FileOperationEvent(h,1))}async cloneFile(h,n){const r=await this.j(h),t=this.kb(await this.l(n),n);if(r===t&&this.M(r).providerExtUri.isEqual(h,n))return;if(r===t&&(0,v.hasFileCloneCapability)(r))return r.cloneFile(h,n);await this.O(t,this.M(t).providerExtUri.dirname(n));const o=this.W.queueFor(h,this.M(r).providerExtUri);return r===t&&(0,v.hasFileFolderCopyCapability)(r)?o.queue(()=>r.copy(h,n,{overwrite:!0})):o.queue(()=>this.I(r,h,t,n))}watch(h,n={recursive:!1,excludes:[]}){const r=new S.DisposableStore;let t=!1,o=()=>{t=!0};return r.add((0,S.toDisposable)(()=>o())),(async()=>{try{const s=await this.U(h,n);t?(0,S.dispose)(s):o=()=>(0,S.dispose)(s)}catch(s){this.b.error(s)}})(),r}async U(h,n){const r=await this.j(h),t=(0,P.hash)([this.M(r).providerExtUri.getComparisonKey(h),n]);let o=this.S.get(t);return o||(o={count:0,disposable:r.watch(h,n)},this.S.set(t,o)),o.count+=1,(0,S.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,S.dispose)(o.disposable),this.S.delete(t)))})}dispose(){super.dispose();for(const[,h]of this.S)(0,S.dispose)(h.disposable);this.S.clear()}async X(h,n,r,t){return this.W.queueFor(n,this.M(h).providerExtUri).queue(async()=>{const o=await h.open(n,{create:!0,unlock:r?.unlock??!1});try{(0,f.isReadableStream)(t)||(0,f.isReadableBufferedStream)(t)?await this.Y(h,o,t):await this.Z(h,o,t)}catch(s){throw(0,v.ensureFileSystemProviderError)(s)}finally{await h.close(o)}})}async Y(h,n,r){let t=0,o;if((0,f.isReadableBufferedStream)(r)){if(r.buffer.length>0){const s=D.VSBuffer.concat(r.buffer);await this.ab(h,n,s,s.byteLength,t,0),t+=s.byteLength}if(r.ended)return;o=r.stream}else o=r;return new Promise((s,c)=>{(0,f.listenStream)(o,{onData:async a=>{o.pause();try{await this.ab(h,n,a,a.byteLength,t,0)}catch(g){return c(g)}t+=a.byteLength,setTimeout(()=>o.resume())},onError:a=>c(a),onEnd:()=>s()})})}async Z(h,n,r){let t=0,o;for(;(o=r.read())!==null;)await this.ab(h,n,o,o.byteLength,t,0),t+=o.byteLength}async ab(h,n,r,t,o,s){let c=0;for(;c<t;)c+=await h.write(n,o+c,r.buffer,s+c,t-c)}async bb(h,n,r,t){return this.W.queueFor(n,this.M(h).providerExtUri).queue(()=>this.cb(h,n,r,t))}async cb(h,n,r,t){let o;t instanceof D.VSBuffer?o=t:(0,f.isReadableStream)(t)?o=await(0,D.streamToBuffer)(t):(0,f.isReadableBufferedStream)(t)?o=await(0,D.bufferedStreamToBuffer)(t):o=(0,D.readableToBuffer)(t),await h.writeFile(n,o.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async db(h,n,r,t){return this.W.queueFor(t,this.M(r).providerExtUri).queue(()=>this.eb(h,n,r,t))}async eb(h,n,r,t){let o,s;try{o=await h.open(n,{create:!1}),s=await r.open(t,{create:!0,unlock:!1});const c=D.VSBuffer.alloc(this.a);let a=0,g=0,b=0;do b=await h.read(o,a,c.buffer,g,c.byteLength-g),await this.ab(r,s,c,b,a,g),a+=b,g+=b,g===c.byteLength&&(g=0);while(b>0)}catch(c){throw(0,v.ensureFileSystemProviderError)(c)}finally{await i.Promises.settled([typeof o=="number"?h.close(o):Promise.resolve(),typeof s=="number"?r.close(s):Promise.resolve()])}}async fb(h,n,r,t){return this.W.queueFor(t,this.M(r).providerExtUri).queue(()=>this.gb(h,n,r,t))}async gb(h,n,r,t){return r.writeFile(t,await h.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async hb(h,n,r,t){return this.W.queueFor(t,this.M(r).providerExtUri).queue(()=>this.ib(h,n,r,t))}async ib(h,n,r,t){const o=await r.open(t,{create:!0,unlock:!1});try{const s=await h.readFile(n);await this.ab(r,o,D.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,v.ensureFileSystemProviderError)(s)}finally{await r.close(o)}}async jb(h,n,r,t){const o=await(0,D.streamToBuffer)(this.z(h,n,A.CancellationToken.None));await this.bb(r,t,void 0,o)}kb(h,n){if(h.capabilities&2048)throw new v.FileOperationError((0,y.localize)(22,null,this.mb(n)),6);return h}lb(h,n){if((n.permissions??0)&v.FilePermission.Readonly)throw new v.FileOperationError((0,y.localize)(23,null,this.mb(h)),6)}mb(h){return h.scheme===E.Schemas.file?h.fsPath:h.toString(!0)}};u=pe([Y(0,m.ILogService)],u),e.FileService=u}),define(oe[207],ae([0,1,52,286,6,37,17,3,47,2,12,5,21,44,28,165,13,100,204,38,199,198]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p,f,y,v,l,m,u,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,i.gracefulify)(k)}catch(r){console.error(`Error enabling graceful-fs: ${(0,u.toErrorMessage)(r)}`)}})();class n extends m.AbstractDiskFileSystemProvider{constructor(t,o){super(t,o),this.onDidChangeCapabilities=P.Event.None,this.H=new A.ResourceMap(s=>w.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,E.isLinux&&(this.F|=1024)),this.F}async stat(t){try{const{stat:o,symbolicLink:s}=await f.SymlinkSupport.stat(this.C(t));return{type:this.G(o,s),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.Y(o)}}async readdir(t){try{const o=await f.Promises.readdir(this.C(t),{withFileTypes:!0}),s=[];return await Promise.all(o.map(async c=>{try{let a;c.isSymbolicLink()?a=(await this.stat((0,w.joinPath)(t,c.name))).type:a=this.G(c),s.push([c.name,a])}catch(a){this.a.trace(a)}})),s}catch(o){throw this.Y(o)}}G(t,o){let s;return o?.dangling?s=v.FileType.Unknown:t.isFile()?s=v.FileType.File:t.isDirectory()?s=v.FileType.Directory:s=v.FileType.Unknown,o&&(s|=v.FileType.SymbolicLink),s}async I(t){const o=this.C(t);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${o})`);let s;for(;s=this.H.get(t);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${o})`),await s.wait();const c=new D.Barrier;return this.H.set(t,c),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${o})`),(0,S.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${o})`),this.H.get(t)===c&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${o})`),this.H.delete(t)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${o})`),c.open()})}async readFile(t,o){let s;try{o?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(t)})`),s=await this.I(t));const c=this.C(t);return await f.Promises.readFile(c)}catch(c){throw this.Y(c)}finally{s?.dispose()}}J(t){n.D&&this.a.trace(t)}readFileStream(t,o,s){const c=(0,p.newWriteableStream)(a=>O.VSBuffer.concat(a.map(g=>O.VSBuffer.wrap(g))).buffer);return(0,l.readFileIntoStream)(this,t,c,a=>a.buffer,{...o,bufferSize:256*1024},s),c}async writeFile(t,o,s){let c;try{const a=this.C(t);if(!s.create||!s.overwrite){if(await f.Promises.exists(a)){if(!s.overwrite)throw(0,v.createFileSystemProviderError)((0,y.localize)(0,null),v.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,v.createFileSystemProviderError)((0,y.localize)(1,null),v.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(t,{create:!0,unlock:s.unlock}),await this.write(c,0,o,0,o.byteLength)}catch(a){throw await this.Z(t,a)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(t){n.O=t}async open(t,o){const s=this.C(t);let c;(0,v.isFileOpenForWriteOptions)(o)&&(c=await this.I(t));let a;try{if((0,v.isFileOpenForWriteOptions)(o)&&o.unlock)try{const{stat:b}=await f.SymlinkSupport.stat(s);b.mode&128||await f.Promises.chmod(s,b.mode|128)}catch(b){this.a.trace(b)}let g;if((0,v.isFileOpenForWriteOptions)(o)){if(E.isWindows)try{await f.Promises.truncate(s,0),g="r+"}catch(b){b.code!=="ENOENT"&&this.a.trace(b)}g||(g="w")}else g="r";a=await f.Promises.open(s,g)}catch(g){throw c?.dispose(),(0,v.isFileOpenForWriteOptions)(o)?await this.Z(t,g):this.Y(g)}if(this.L.set(a,0),(0,v.isFileOpenForWriteOptions)(o)&&this.N.set(a,t),c){const g=this.M.get(a);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${s})`),this.M.set(a,c),g&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${s})`),g.dispose())}return a}async close(t){const o=this.M.get(t);try{if(this.L.delete(t),this.N.delete(t)&&n.O)try{await f.Promises.fdatasync(t)}catch(s){n.configureFlushOnWrite(!1),this.a.error(s)}return await f.Promises.close(t)}catch(s){throw this.Y(s)}finally{o&&(this.M.get(t)===o&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.M.delete(t)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),o.dispose())}}async read(t,o,s,c,a){const g=this.P(t,o);let b=null;try{b=(await f.Promises.read(t,s,c,a,g)).bytesRead}catch(R){throw this.Y(R)}finally{this.Q(t,g,b)}return b}P(t,o){return o===this.L.get(t)?null:o}Q(t,o,s){const c=this.L.get(t);typeof c=="number"&&(typeof o=="number"||(typeof s=="number"?this.L.set(t,c+s):this.L.delete(t)))}async write(t,o,s,c,a){return(0,D.retry)(()=>this.R(t,o,s,c,a),100,3)}async R(t,o,s,c,a){const g=this.P(t,o);let b=null;try{b=(await f.Promises.write(t,s,c,a,g)).bytesWritten}catch(R){throw await this.Z(this.N.get(t),R)}finally{this.Q(t,g,b)}return b}async mkdir(t){try{await f.Promises.mkdir(this.C(t))}catch(o){throw this.Y(o)}}async delete(t,o){try{const s=this.C(t);o.recursive?await f.Promises.rm(s,f.RimRafMode.MOVE):await f.Promises.unlink(s)}catch(s){throw this.Y(s)}}async rename(t,o,s){const c=this.C(t),a=this.C(o);if(c!==a)try{await this.S(t,o,"move",s.overwrite),await f.Promises.move(c,a)}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,y.localize)(2,null,(0,C.basename)(c),(0,C.basename)((0,C.dirname)(a)),g.toString()))),this.Y(g)}}async copy(t,o,s){const c=this.C(t),a=this.C(o);if(c!==a)try{await this.S(t,o,"copy",s.overwrite),await f.Promises.copy(c,a,{preserveSymlinks:!0})}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,y.localize)(3,null,(0,C.basename)(c),(0,C.basename)((0,C.dirname)(a)),g.toString()))),this.Y(g)}}async S(t,o,s,c){const a=this.C(t),g=this.C(o);let b=!1;if(!!(this.capabilities&1024)||(b=(0,I.isEqual)(a,g,!0)),b&&s==="copy")throw(0,v.createFileSystemProviderError)((0,y.localize)(4,null),v.FileSystemProviderErrorCode.FileExists);if(!b&&await f.Promises.exists(g)){if(!c)throw(0,v.createFileSystemProviderError)((0,y.localize)(5,null),v.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}async cloneFile(t,o){return this.U(t,o,!1)}async U(t,o,s){const c=this.C(t),a=this.C(o),g=!!(this.capabilities&1024);if((0,I.isEqual)(c,a,!g))return;const b=new S.DisposableStore;try{const[R,j]=await Promise.all([this.I(t),this.I(o)]);b.add(R),b.add(j),s&&await f.Promises.mkdir((0,C.dirname)(a),{recursive:!0}),await f.Promises.copyFile(c,a)}catch(R){if(R.code==="ENOENT"&&!s)return this.U(t,o,!0);throw this.Y(R)}finally{b.dispose()}}p(t,o,s){return new d.UniversalWatcherClient(c=>t(c),c=>o(c),s)}y(t,o,s){return new h.NodeJSWatcherClient(c=>t(c),c=>o(c),s)}Y(t){if(t instanceof v.FileSystemProviderError)return t;let o;switch(t.code){case"ENOENT":o=v.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=v.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=v.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=v.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=v.FileSystemProviderErrorCode.NoPermissions;break;default:o=v.FileSystemProviderErrorCode.Unknown}return(0,v.createFileSystemProviderError)(t,o)}async Z(t,o){let s=this.Y(o);if(t&&s.code===v.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await f.SymlinkSupport.stat(this.C(t));c.mode&128||(s=(0,v.createFileSystemProviderError)(o,v.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return s}}e.DiskFileSystemProvider=n,n.D=!1,n.O=!0}),define(oe[101],ae([0,1,6,3,2,4,8]),function(ee,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,A.createDecorator)("lifecycleSharedProcessService");let P=class extends D.Disposable{constructor(S){super(),this.c=S,this.a=void 0,this.b=this.B(new i.Emitter),this.onWillShutdown=this.b.event}fireOnWillShutdown(){if(this.a)return this.a;this.c.trace("Lifecycle#onWillShutdown.fire()");const S=[];return this.b.fire({join(C){S.push(C)}}),this.a=(async()=>{try{await k.Promises.settled(S)}catch(C){this.c.error(C)}})(),this.a}};P=pe([Y(0,O.ILogService)],P),e.SharedProcessLifecycleService=P}),define(oe[102],ae([0,1,3,7,8]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class A{constructor(w,p){this.a=w,this.b=p,this.onDidChangeLogLevel=k.Event.buffer(w.onDidChangeLogLevel,!0)}listen(w,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(w,p,f){switch(p){case"setLevel":return f[1]?this.b.setLevel(i.URI.revive(f[1]),f[0]):this.a.setLevel(f[0])}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=A;class O{constructor(w){this.a=w}get onDidChangeLogLevel(){return this.a.listen("onDidChangeLogLevel")}setLevel(w,p){O.setLevel(this.a,w,p)}static setLevel(w,p,f){return w.call("setLevel",[p,f])}}e.LogLevelChannelClient=O;class P{constructor(w){this.b=w,this.a=new Map}listen(w,p){throw new Error(`Event not found: ${p}`)}async call(w,p,f){switch(p){case"createLogger":this.c(i.URI.revive(f[0]),f[1]);return;case"log":return this.e(i.URI.revive(f[0]),f[1]);case"consoleLog":return this.d(f[0],f[1])}throw new Error(`Call not found: ${p}`)}c(w,p){this.a.set(w.toString(),this.b.createLogger(w,p))}d(w,p){let f=console.log;switch(w){case D.LogLevel.Error:f=console.error;break;case D.LogLevel.Warning:f=console.warn;break;case D.LogLevel.Info:f=console.info;break}f.call(console,...p)}e(w,p){const f=this.a.get(w.toString());if(!f)throw new Error("Create the logger before logging");for(const[y,v]of p)(0,D.log)(f,y,v)}}e.LoggerChannel=P;class I extends D.AbstractLoggerService{constructor(w,p,f){super(w,p),this.g=f}createConsoleMainLogger(){return new D.AdapterLogger({log:(w,p)=>{this.g.call("consoleLog",[w,p])}})}f(w,p,f){return new S(this.g,w,p,f)}}e.LoggerChannelClient=I;class S extends D.AbstractMessageLogger{constructor(w,p,f,y){super(y?.always),this.m=w,this.n=p,this.k=!1,this.l=[],this.setLevel(f),this.m.call("createLogger",[p,y]).then(()=>{this.r(this.l),this.k=!0})}g(w,p){const f=[[w,p]];this.k?this.r(f):this.l.push(...f)}r(w){this.m.call("log",[this.n,w])}}class C extends D.LogService{constructor(w,p){super(p),this.c=w,this.B(w.onDidChangeLogLevel(f=>p.setLevel(f)))}setLevel(w){super.setLevel(w),this.c.setLevel(w)}}e.FollowerLogService=C}),define(oe[57],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,k.createDecorator)("nativeHostService")}),define(oe[58],ae([0,1,3,64,2,4]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,A.createDecorator)("policy");class O extends D.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new k.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(S){const C=Object.keys(this.f).length;return this.f={...S,...this.f},C!==Object.keys(this.f).length&&await this.i(S),i.Iterable.reduce(this.g.entries(),(E,[w,p])=>({...E,[w]:p}),{})}getPolicyValue(S){return this.g.get(S)}serialize(){return i.Iterable.reduce(Object.entries(this.f),(S,[C,E])=>({...S,[C]:{definition:E,value:this.g.get(C)}}),{})}}e.AbstractPolicyService=O;class P{constructor(){this.onDidChange=k.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(oe[208],ae([0,1,3,2,58]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class A{constructor(I){this.b=I,this.a=new i.DisposableStore}listen(I,S){switch(S){case"onDidChange":return k.Event.map(this.b.onDidChange,C=>C.reduce((E,w)=>({...E,[w]:this.b.getPolicyValue(w)??null}),{}),this.a)}throw new Error(`Event not found: ${S}`)}call(I,S,C){switch(S){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${S}`)}dispose(){this.a.dispose()}}e.PolicyChannel=A;class O extends D.AbstractPolicyService{constructor(I,S){super(),this.a=S;for(const C in I){const{definition:E,value:w}=I[C];this.f[C]=E,w!==void 0&&this.g.set(C,w)}this.a.listen("onDidChange")(C=>{for(const E in C){const w=C[E];w===null?this.g.delete(E):this.g.set(E,w)}this.h.fire(Object.keys(C))})}async i(I){const S=await this.a.call("updatePolicyDefinitions",I);for(const C in S)this.g.set(C,S[C])}}e.PolicyChannelClient=O}),define(oe[103],ae([0,1,5,36]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof k.globals.vscode<"u"&&typeof k.globals.vscode.context<"u"){const A=k.globals.vscode.context.configuration();if(A)D=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(D=globalThis._VSCODE_PRODUCT_JSON,i.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(D,{version:A.version})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(oe[25],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(oe[209],ae([0,1,6,9,2,12,28,8,25]),function(ee,e,k,i,D,A,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let S=class extends D.Disposable{constructor(E,w,p){super(),this.b=w,this.c=p,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this.B(new k.RunOnceScheduler(()=>{this.f(E)},3e4)).schedule()}async f(E){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const w=Date.now(),p=(0,A.dirname)(E),f=(0,A.basename)(E),y=await O.Promises.readdir(p);await Promise.all(y.map(async v=>{if(v===f)return;const l=(0,A.join)(p,v),m=await O.Promises.stat(l);if(m.isDirectory()&&w-m.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${v}.`),O.Promises.rm(l)}))}catch(w){(0,i.onUnexpectedError)(w)}}};S=pe([Y(1,I.IProductService),Y(2,P.ILogService)],S),e.CodeCacheCleaner=S}),define(oe[210],ae([0,1,6,9,2,12,28,15,8,25]),function(ee,e,k,i,D,A,O,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let C=class extends D.Disposable{constructor(w,p,f){super(),this.b=w,this.c=p,this.f=f,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new k.RunOnceScheduler(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const w=Object.create(null),p=JSON.parse(await O.Promises.readFile((0,A.join)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const m of Object.keys(p)){const u=p[m];w[`${u.hash}.${m}`]=!0}const f=(0,A.join)(this.b.userDataPath,"clp");if(!await O.Promises.exists(f))return;const v=await O.Promises.readdir(f);for(const m of v){if(w[m]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${m}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${m}`),await O.Promises.rm((0,A.join)(f,m))}const l=Date.now();for(const m of Object.keys(w)){const u=(0,A.join)(f,m),d=await O.Promises.readdir(u);for(const h of d){if(h==="tcf.json")continue;const n=(0,A.join)(u,h),r=await O.Promises.stat(n);r.isDirectory()&&l-r.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.join)(m,h)}`),await O.Promises.rm(n))}}}catch(w){(0,i.onUnexpectedError)(w)}}};C=pe([Y(0,P.INativeEnvironmentService),Y(1,I.ILogService),Y(2,S.IProductService)],C),e.LanguagePackCachedDataCleaner=C}),define(oe[211],ae([0,1,20,2,21,186,13,25]),function(ee,e,k,i,D,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let I=class extends i.Disposable{constructor(C,E){super(),this.b=C,this.c=E,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,w])=>this.a.set(w.configPath,w))}getConfigBasedTips(C){return this.f(C)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(C){const E=[];for(const[w,p]of this.a)if(!(p.configScheme&&p.configScheme!==C.scheme))try{const f=await this.b.readFile((0,D.joinPath)(C,w)),y=new Map;Object.entries(p.recommendations).forEach(([l,m])=>{if((0,k.isNonEmptyArray)(m.remotes))for(const u of m.remotes)y.set(u,{extensionId:l,extensionName:m.name,configName:p.configName,important:!!m.important,isExtensionPack:!!m.isExtensionPack,whenNotInstalled:m.whenNotInstalled});else E.push({extensionId:l,extensionName:m.name,configName:p.configName,important:!!m.important,isExtensionPack:!!m.isExtensionPack,whenNotInstalled:m.whenNotInstalled})});const v=(0,A.getDomainsOfRemotes)(f.value.toString(),[...y.keys()]);for(const l of v){const m=y.get(l);m&&E.push(m)}}catch{}return E}};I=pe([Y(0,O.IFileService),Y(1,P.IProductService)],I),e.ExtensionTipsService=I}),define(oe[212],ae([0,1,12,4]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,i.createDecorator)("IV8InspectProfilingService");var D;(function(A){function O(I){return Boolean(I.samples&&I.timeDeltas)}A.isValidProfile=O;function P(I,S="noAbsolutePaths"){for(const C of I.nodes)C.callFrame&&C.callFrame.url&&((0,k.isAbsolute)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,k.join)(S,(0,k.basename)(C.callFrame.url)));return I}A.rewriteAbsolutePaths=P})(D=e.Utils||(e.Utils={}))}),define(oe[213],ae([0,1,31]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class i{constructor(){this.a=new Map}async startProfiling(A){const P=await(await new Promise((S,C)=>{ee(["v8-inspect-profiler"],S,C)})).startProfiling({port:A.port,checkForPaused:!0}),I=(0,k.generateUuid)();return this.a.set(I,P),I}async stopProfiling(A){const O=this.a.get(A);if(!O)throw new Error(`UNKNOWN session '${A}'`);const P=await O.stop();return this.a.delete(A),P.profile}}e.InspectProfilingService=i}),define(oe[40],ae([0,1,126,14]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.a=new Map}add(O,P){k.ok(i.isString(O)),k.ok(i.isObject(P)),k.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,P)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.Registry=new D}),define(oe[104],ae([0,1,3,40]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class A{constructor(){this.b=new k.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(I,S){this.a[D(I)]=S,this.b.fire(I)}notifySchemaChanged(I){this.b.fire(I)}getSchemaContributions(){return{schemas:this.a}}}const O=new A;i.Registry.add(e.Extensions.JSONContribution,O)}),define(oe[46],ae([0,1,20,3,14,151,16,104,40]),function(ee,e,k,i,D,A,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=I.Registry.as(P.Extensions.JSONContribution);class w{constructor(){this.h=new Set,this.i=new i.Emitter,this.onDidSchemaChange=this.i.event,this.j=new i.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const t=this.k(n,r);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(n){const r=this.l(n);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:n,remove:r}){const t=[];t.push(...this.l(r)),t.push(...this.k(n,!1)),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,k.distinct)(t)})}registerDefaultConfigurations(n){const r=[],t=[];for(const{overrides:o,source:s}of n)for(const c in o)if(r.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const a=this.a.get(c),g=a?.valuesSources??new Map;if(s)for(const U of Object.keys(o[c]))g.set(U,s);const b={...a?.value||{},...o[c]};this.a.set(c,{source:s,value:b,valuesSources:g});const R=(0,O.getLanguageTagSettingPlainKey)(c),j={type:"object",default:b,description:A.localize(1,null,R),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:b,source:D.isString(s)?void 0:s,defaultValueSource:s};t.push(...y(c)),this.d[c]=j,this.b.properties[c]=j}else{this.a.set(c,{value:o[c],source:s});const a=this.d[c];a&&(this.s(c,a),this.o(c,a))}this.registerOverrideIdentifiers(t),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const r=[];for(const{overrides:t,source:o}of n)for(const s in t){const c=this.a.get(s),a=D.isString(o)?o:o?.id,g=D.isString(c?.source)?c?.source:c?.source?.id;if(a===g)if(r.push(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const b=this.d[s];b&&(this.s(s,b),this.o(s,b))}}this.q(),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){for(const r of n)this.h.add(r);this.q()}k(n,r){const t=[];return n.forEach(o=>{t.push(...this.m(o,r,o.extensionInfo,o.restrictedProperties)),this.c.push(o),this.n(o)}),t}l(n){const r=[],t=o=>{if(o.properties)for(const s in o.properties){r.push(s);const c=this.d[s];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[s],this.p(s,o.properties[s])}o.allOf?.forEach(s=>t(s))};for(const o of n){t(o);const s=this.c.indexOf(o);s!==-1&&this.c.splice(s,1)}return r}m(n,r=!0,t,o,s=3){s=D.isUndefinedOrNull(n.scope)?s:n.scope;const c=[],a=n.properties;if(a)for(const b in a){const R=a[b];if(r&&u(b,R)){delete a[b];continue}if(R.source=t,R.defaultDefaultValue=a[b].default,this.s(b,R),e.OVERRIDE_PROPERTY_REGEX.test(b)?R.scope=void 0:(R.scope=D.isUndefinedOrNull(R.scope)?s:R.scope,R.restricted=D.isUndefinedOrNull(R.restricted)?!!o?.includes(b):R.restricted),a[b].hasOwnProperty("included")&&!a[b].included){this.f[b]=a[b],delete a[b];continue}else this.d[b]=a[b],a[b].policy?.name&&this.e.set(a[b].policy.name,b);!a[b].deprecationMessage&&a[b].markdownDeprecationMessage&&(a[b].deprecationMessage=a[b].markdownDeprecationMessage),c.push(b)}const g=n.allOf;if(g)for(const b of g)c.push(...this.m(b,r,t,o,s));return c}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(n){const r=t=>{const o=t.properties;if(o)for(const c in o)this.o(c,o[c]);t.allOf?.forEach(r)};r(n)}o(n,r){switch(e.allSettings.properties[n]=r,r.scope){case 1:e.applicationSettings.properties[n]=r;break;case 2:e.machineSettings.properties[n]=r;break;case 6:e.machineOverridableSettings.properties[n]=r;break;case 3:e.windowSettings.properties[n]=r;break;case 4:e.resourceSettings.properties[n]=r;break;case 5:e.resourceSettings.properties[n]=r,this.g.properties[n]=r;break}}p(n,r){switch(delete e.allSettings.properties[n],r.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.g.properties[n];break}}q(){for(const n of this.h.values()){const r=`[${n}]`,t={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(r,t),e.allSettings.properties[r]=t,e.applicationSettings.properties[r]=t,e.machineSettings.properties[r]=t,e.machineOverridableSettings.properties[r]=t,e.windowSettings.properties[r]=t,e.resourceSettings.properties[r]=t}this.i.fire()}r(){const n={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this.i.fire()}s(n,r){const t=this.a.get(n);let o=t?.value,s=t?.source;D.isUndefined(o)&&(o=r.defaultDefaultValue,s=void 0),D.isUndefined(o)&&(o=l(r.type)),r.default=o,r.defaultValueSource=s}}const p="\\[([^\\]]+)\\]",f=new RegExp(p,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${p})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function y(h){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(h)){let r=f.exec(h);for(;r?.length;){const t=r[1].trim();t&&n.push(t),r=f.exec(h)}}return(0,k.distinct)(n)}e.overrideIdentifiersFromKey=y;function v(h){return h.reduce((n,r)=>`${n}[${r}]`,"")}e.keyFromOverrideIdentifiers=v;function l(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const m=new w;I.Registry.add(e.Extensions.Configuration,m);function u(h,n){return h.trim()?e.OVERRIDE_PROPERTY_REGEX.test(h)?A.localize(7,null,h):m.getConfigurationProperties()[h]!==void 0?A.localize(8,null,h):n.policy?.name&&m.getPolicyConfigurations().get(n.policy?.name)!==void 0?A.localize(9,null,h,n.policy?.name,m.getPolicyConfigurations().get(n.policy?.name)):null:A.localize(6,null)}e.validateProperty=u;function d(){const h=[],n=m.getConfigurationProperties();for(const r of Object.keys(n))h.push([r,n[r].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.getScopes=d}),define(oe[74],ae([0,1,20,3,35,2,37,32,14,7,16,46,40]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class p{constructor(r={},t=[],o=[],s){this.c=r,this.d=t,this.f=o,this.raw=s,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(t=>{if(t instanceof p)return t;const o=new f("");return o.parseRaw(t),o.configurationModel});this.g=r.reduce((t,o)=>o===t?o:t.merge(o),r[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(r){return r?(0,C.getConfigurationValue)(this.contents,r):this.contents}inspect(r,t){const o=this.rawConfiguration.getValue(r),s=t?this.rawConfiguration.getOverrideValue(r,t):void 0,c=t?this.rawConfiguration.override(t).getValue(r):o;return{value:o,override:s,merged:c}}getOverrideValue(r,t){const o=this.l(t);return o?r?(0,C.getConfigurationValue)(o,r):o:void 0}getKeysForOverrideIdentifier(r){const t=[];for(const o of this.overrides)o.identifiers.includes(r)&&t.push(...o.keys);return k.distinct(t)}getAllOverrideIdentifiers(){const r=[];for(const t of this.overrides)r.push(...t.identifiers);return k.distinct(r)}override(r){let t=this.b.get(r);return t||(t=this.h(r),this.b.set(r,t)),t}merge(...r){const t=P.deepClone(this.contents),o=P.deepClone(this.overrides),s=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const a of r)if(c.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.j(t,a.contents);for(const g of a.overrides){const[b]=o.filter(R=>k.equals(R.identifiers,g.identifiers));b?(this.j(b.contents,g.contents),b.keys.push(...g.keys),b.keys=k.distinct(b.keys)):o.push(P.deepClone(g))}for(const g of a.keys)s.indexOf(g)===-1&&s.push(g)}return new p(t,s,o,c.every(a=>a instanceof p)?void 0:c)}freeze(){return this.a=!0,this}clone(){return new p(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}h(r){const t=this.l(r);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const o={};for(const s of k.distinct([...Object.keys(this.contents),...Object.keys(t)])){let c=this.contents[s];const a=t[s];a&&(typeof c=="object"&&typeof a=="object"?(c=P.deepClone(c),this.j(c,a)):c=a),o[s]=c}return new p(o,this.keys,this.overrides)}j(r,t){for(const o of Object.keys(t)){if(o in r&&I.isObject(r[o])&&I.isObject(t[o])){this.j(r[o],t[o]);continue}r[o]=P.deepClone(t[o])}}k(r){return this.a&&!Object.isFrozen(r)?P.deepFreeze(r):r}l(r){let t=null,o=null;const s=c=>{c&&(o?this.j(o,c):o=P.deepClone(c))};for(const c of this.overrides)k.equals(c.identifiers,[r])?t=c.contents:c.identifiers.includes(r)&&s(c.contents);return s(t),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,t){this.m(r),(0,C.addToValueTree)(this.contents,r,t,o=>{throw new Error(o)})}removeValue(r){this.n(r)&&(0,C.removeFromValueTree)(this.contents,r)}m(r){let t=this.keys.length;for(let o=0;o<t;o++)r.indexOf(this.keys[o])===0&&(t=o);this.keys.splice(t,1,r)}n(r){const t=this.keys.indexOf(r);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=p;class f{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,t){if(!I.isUndefinedOrNull(r)){const o=this.g(r);this.parseRaw(o,t)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,t){this.a=r;const{contents:o,keys:s,overrides:c,restricted:a,hasExcludedProperties:g}=this.h(r,t);this.b=new p(o,s,c,g?[r]:void 0),this.c=a||[]}g(r){let t={},o=null,s=[];const c=[],a=[];function g(R){Array.isArray(s)?s.push(R):o!==null&&(s[o]=R)}const b={onObjectBegin:()=>{const R={};g(R),c.push(s),s=R,o=null},onObjectProperty:R=>{o=R},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const R=[];g(R),c.push(s),s=R,o=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:g,onError:(R,j,U)=>{a.push({error:R,offset:j,length:U})}};if(r)try{D.visit(r,b),t=s[0]||{}}catch(R){console.error(`Error while parsing settings file ${this.f}: ${R}`),this.d=[R]}return t}h(r,t){const o=w.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),s=this.j(r,o,!0,t);r=s.raw;const c=(0,C.toValuesTree)(r,b=>console.error(`Conflict in settings file ${this.f}: ${b}`)),a=Object.keys(r),g=this.l(r,b=>console.error(`Conflict in settings file ${this.f}: ${b}`));return{contents:c,keys:a,overrides:g,restricted:s.restricted,hasExcludedProperties:s.hasExcludedProperties}}j(r,t,o,s){let c=!1;if(!s?.scopes&&!s?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:c};const a={},g=[];for(const b in r)if(E.OVERRIDE_PROPERTY_REGEX.test(b)&&o){const R=this.j(r[b],t,!1,s);a[b]=R.raw,c=c||R.hasExcludedProperties,g.push(...R.restricted)}else{const R=t[b],j=R?typeof R.scope<"u"?R.scope:3:void 0;R?.restricted&&g.push(b),(j===void 0||s.scopes===void 0||s.scopes.includes(j))&&!(s.skipRestricted&&R?.restricted)?a[b]=r[b]:c=!0}return{raw:a,restricted:g,hasExcludedProperties:c}}l(r,t){const o=[];for(const s of Object.keys(r))if(E.OVERRIDE_PROPERTY_REGEX.test(s)){const c={};for(const a in r[s])c[a]=r[s][a];o.push({identifiers:(0,E.overrideIdentifiersFromKey)(s),keys:Object.keys(c),contents:(0,C.toValuesTree)(c,t)})}return o}}e.ConfigurationModelParser=f;class y extends A.Disposable{constructor(r,t,o,s){super(),this.f=r,this.g=t,this.h=s,this.c=this.B(new i.Emitter),this.onDidChange=this.c.event,this.a=new f(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(o.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(i.Event.any(i.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),i.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&o.isEqual(c.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new p}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=y;class v{constructor(r,t,o,s,c,a,g,b,R,j,U,z,F){this.a=r,this.b=t,this.value=o,this.overrideIdentifiers=s,this.c=c,this.d=a,this.f=g,this.g=b,this.h=R,this.j=j,this.k=U,this.l=z,this.m=F}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class l{constructor(r,t,o,s,c=new p,a=new p,g=new O.ResourceMap,b=new p,R=new O.ResourceMap,j=!0){this.c=r,this.d=t,this.f=o,this.g=s,this.h=c,this.j=a,this.l=g,this.m=b,this.n=R,this.p=j,this.a=null,this.b=new O.ResourceMap,this.q=null}getValue(r,t,o){return this.s(r,t,o).getValue(r)}updateValue(r,t,o={}){let s;o.resource?(s=this.n.get(o.resource),s||(s=new p,this.n.set(o.resource,s))):s=this.m,t===void 0?s.removeValue(r):s.setValue(r,t),o.resource||(this.a=null)}inspect(r,t,o){const s=this.s(r,t,o),c=k.distinct(s.overrides.map(b=>b.identifiers).flat()).filter(b=>s.getOverrideValue(r,b)!==void 0),a=this.w(t.resource,o),g=t.resource?this.n.get(t.resource)||this.m:this.m;return new v(r,t,s.getValue(r),c.length?c:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),o?this.j.freeze():void 0,a?a.freeze():void 0,g.inspect(r,t.overrideIdentifier))}keys(r){const t=this.w(void 0,r);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.j=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,t){this.l.set(r,t),this.b.delete(r)}deleteFolderConfiguration(r){this.r.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,t){const o=[];if(!t){const{added:s,updated:c,removed:a}=d(this.c,r);t=[...s,...c,...a]}for(const s of t)for(const c of(0,E.overrideIdentifiersFromKey)(s)){const a=this.c.getKeysForOverrideIdentifier(c),g=r.getKeysForOverrideIdentifier(c),b=[...g.filter(R=>a.indexOf(R)===-1),...a.filter(R=>g.indexOf(R)===-1),...a.filter(R=>!P.equals(this.c.override(c).getValue(R),r.override(c).getValue(R)))];o.push([c,b])}return this.updateDefaultConfiguration(r),{keys:t,overrides:o}}compareAndUpdatePolicyConfiguration(r){const{added:t,updated:o,removed:s}=d(this.d,r),c=[...t,...o,...s];return c.length&&this.updatePolicyConfiguration(r),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:t,updated:o,removed:s,overrides:c}=d(this.applicationConfiguration,r),a=[...t,...o,...s];return a.length&&this.updateApplicationConfiguration(r),{keys:a,overrides:c}}compareAndUpdateLocalUserConfiguration(r){const{added:t,updated:o,removed:s,overrides:c}=d(this.localUserConfiguration,r),a=[...t,...o,...s];return a.length&&this.updateLocalUserConfiguration(r),{keys:a,overrides:c}}compareAndUpdateRemoteUserConfiguration(r){const{added:t,updated:o,removed:s,overrides:c}=d(this.remoteUserConfiguration,r),a=[...t,...o,...s];return a.length&&this.updateRemoteUserConfiguration(r),{keys:a,overrides:c}}compareAndUpdateWorkspaceConfiguration(r){const{added:t,updated:o,removed:s,overrides:c}=d(this.workspaceConfiguration,r),a=[...t,...o,...s];return a.length&&this.updateWorkspaceConfiguration(r),{keys:a,overrides:c}}compareAndUpdateFolderConfiguration(r,t){const o=this.r.get(r),{added:s,updated:c,removed:a,overrides:g}=d(o,t),b=[...s,...c,...a];return(b.length||!o)&&this.updateFolderConfiguration(r,t),{keys:b,overrides:g}}compareAndDeleteFolderConfiguration(r){const t=this.r.get(r);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:o,updated:s,removed:c,overrides:a}=d(t,void 0);return{keys:[...o,...s,...c],overrides:a}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(r,t,o){let s=this.t(t,o);return t.overrideIdentifier&&(s=s.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(s=s.merge(this.d)),s}t({resource:r},t){let o=this.u();if(t&&r){const s=t.getFolder(r);s&&(o=this.v(s.uri)||o);const c=this.n.get(r);c&&(o=o.merge(c))}return o}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(r){let t=this.b.get(r);if(!t){const o=this.u(),s=this.l.get(r);s?(t=o.merge(s),this.p&&(t=t.freeze()),this.b.set(r,t)):t=o}return t}w(r,t){if(t&&r){const o=t.getFolder(r);if(o)return this.l.get(o.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((r,t)=>{const{contents:o,overrides:s,keys:c}=this.l.get(t);return r.push([t,{contents:o,overrides:s,keys:c}]),r},[])}}allKeys(){const r=new Set;return this.c.freeze().keys.forEach(t=>r.add(t)),this.userConfiguration.freeze().keys.forEach(t=>r.add(t)),this.j.freeze().keys.forEach(t=>r.add(t)),this.l.forEach(t=>t.freeze().keys.forEach(o=>r.add(o))),[...r.values()]}x(){const r=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.j.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.l.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o))),[...r.values()]}y(r){const t=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(o=>t.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>t.add(o)),this.j.getKeysForOverrideIdentifier(r).forEach(o=>t.add(o)),this.l.forEach(o=>o.getKeysForOverrideIdentifier(r).forEach(s=>t.add(s))),[...t.values()]}static parse(r){const t=this.z(r.defaults),o=this.z(r.policy),s=this.z(r.application),c=this.z(r.user),a=this.z(r.workspace),g=r.folders.reduce((b,R)=>(b.set(S.URI.revive(R[0]),this.z(R[1])),b),new O.ResourceMap);return new l(t,o,s,c,new p,a,g,new p,new O.ResourceMap,!1)}static z(r){return new p(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=l;function m(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const r=new Set,t=new Map;for(const s of n)s.keys.forEach(c=>r.add(c)),s.overrides.forEach(([c,a])=>{const g=(0,O.getOrSet)(t,c,new Set);a.forEach(b=>g.add(b))});const o=[];return t.forEach((s,c)=>o.push([c,[...s.values()]])),{keys:[...r.values()],overrides:o}}e.mergeChanges=m;class u{constructor(r,t,o,s){this.change=r,this.b=t,this.c=o,this.d=s,this.f=void 0;const c=new Set;r.keys.forEach(g=>c.add(g)),r.overrides.forEach(([,g])=>g.forEach(b=>c.add(b))),this.affectedKeys=[...c.values()];const a=new p;this.affectedKeys.forEach(g=>a.setValue(g,{})),this.a=a.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=l.parse(this.b.data)),this.f}affectsConfiguration(r,t){if(this.g(this.a,r)){if(t){const o=this.previousConfiguration?this.previousConfiguration.getValue(r,t,this.b?.workspace):void 0,s=this.c.getValue(r,t,this.d);return!P.equals(o,s)}return!0}return!1}g(r,t){let o=(0,C.toValuesTree)({[t]:!0},()=>{}),s;for(;typeof o=="object"&&(s=Object.keys(o)[0]);){if(r=r[s],!r)return!1;o=o[s]}return!0}}e.ConfigurationChangeEvent=u;function d(n,r){const{added:t,removed:o,updated:s}=h(r?.rawConfiguration,n?.rawConfiguration),c=[],a=n?.getAllOverrideIdentifiers()||[],g=r?.getAllOverrideIdentifiers()||[];if(r){const b=g.filter(R=>!a.includes(R));for(const R of b)c.push([R,r.getKeysForOverrideIdentifier(R)])}if(n){const b=a.filter(R=>!g.includes(R));for(const R of b)c.push([R,n.getKeysForOverrideIdentifier(R)])}if(r&&n){for(const b of a)if(g.includes(b)){const R=h({contents:n.getOverrideValue(void 0,b)||{},keys:n.getKeysForOverrideIdentifier(b)},{contents:r.getOverrideValue(void 0,b)||{},keys:r.getKeysForOverrideIdentifier(b)});c.push([b,[...R.added,...R.removed,...R.updated]])}}return{added:t,removed:o,updated:s,overrides:c}}function h(n,r){const t=n?r?n.keys.filter(c=>r.keys.indexOf(c)===-1):[...n.keys]:[],o=r?n?r.keys.filter(c=>n.keys.indexOf(c)===-1):[...r.keys]:[],s=[];if(n&&r){for(const c of r.keys)if(n.keys.indexOf(c)!==-1){const a=(0,C.getConfigurationValue)(r.contents,c),g=(0,C.getConfigurationValue)(n.contents,c);P.equals(a,g)||s.push(c)}}return{added:t,removed:o,updated:s}}}),define(oe[214],ae([0,1,20,3,2,32,14,16,74,46,8,58,40]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class p extends D.Disposable{constructor(){super(...arguments),this.a=this.B(new i.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new f(this.f())),this.b}async initialize(){return this.b=void 0,this.B(w.Registry.as(S.Extensions.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:u})=>this.c(m,u))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(m,u){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:m})}f(){return{}}}e.DefaultConfiguration=p;class f extends I.ConfigurationModel{constructor(m={}){const u=w.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),d=Object.keys(u),h=Object.create(null),n=[];for(const r in u){const t=m[r],o=t!==void 0?t:u[r].default;(0,P.addToValueTree)(h,r,o,s=>console.error(`Conflict in default settings: ${s}`))}for(const r of Object.keys(h))S.OVERRIDE_PROPERTY_REGEX.test(r)&&n.push({identifiers:(0,S.overrideIdentifiersFromKey)(r),keys:Object.keys(h[r]),contents:(0,P.toValuesTree)(h[r],t=>console.error(`Conflict in default settings file: ${t}`))});super(h,d,n)}}e.DefaultConfigurationModel=f;class y{constructor(){this.onDidChangeConfiguration=i.Event.None,this.configurationModel=new I.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=y;let v=class extends D.Disposable{get configurationModel(){return this.b}constructor(m,u,d){super(),this.c=m,this.f=u,this.g=d,this.a=this.B(new i.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new I.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(m=>this.i(m))),this.B(this.c.onDidChangeConfiguration(async({properties:m})=>this.j(await this.h(m),!0))),this.b}async h(m){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",m);const u={},d=[],h=w.Registry.as(S.Extensions.Configuration).getConfigurationProperties();for(const n of m){const r=h[n];if(!r){d.push(n);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.g.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}d.push(n),u[r.policy.name]={type:r.type}}}return(0,O.isEmptyObject)(u)||await this.f.updatePolicyDefinitions(u),d}i(m){this.g.trace("PolicyConfiguration#onDidChangePolicies",m);const u=w.Registry.as(S.Extensions.Configuration).getPolicyConfigurations(),d=(0,k.coalesce)(m.map(h=>u.get(h)));this.j(d,!0)}j(m,u){this.g.trace("PolicyConfiguration#update",m);const d=w.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),h=[],n=this.b.isEmpty();for(const r of m){const t=d[r]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);(n?o!==void 0:!(0,A.equals)(this.b.getValue(r),o))&&h.push([r,o])}else this.b.getValue(r)!==void 0&&h.push([r,void 0])}if(h.length){this.g.trace("PolicyConfiguration#changed",h);const r=this.b;this.b=new I.ConfigurationModel;for(const t of r.keys)this.b.setValue(t,r.getValue(t));for(const[t,o]of h)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);u&&this.a.fire(this.b)}}};v=pe([Y(1,E.IPolicyService),Y(2,C.ILogService)],v),e.PolicyConfiguration=v}),define(oe[215],ae([0,1,6,3,2,21,16,74,214,58]),function(ee,e,k,i,D,A,O,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class C extends D.Disposable{constructor(w,p,f,y){super(),this.i=w,this.h=this.B(new i.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new I.DefaultConfiguration),this.c=f instanceof S.NullPolicyService?new I.NullPolicyConfiguration:this.B(new I.PolicyConfiguration(this.b,f,y)),this.f=this.B(new P.UserSettings(this.i,void 0,A.extUriBiasedIgnorePathCase,p)),this.a=new P.Configuration(this.b.configurationModel,this.c.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.g=this.B(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:v,properties:l})=>this.k(v,l))),this.B(this.c.onDidChangeConfiguration(v=>this.l(v))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[w,p,f]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.Configuration(w,p,new P.ConfigurationModel,f)}getConfigurationData(){return this.a.toData()}getValue(w,p){const f=typeof w=="string"?w:void 0,y=(0,O.isConfigurationOverrides)(w)?w:(0,O.isConfigurationOverrides)(p)?p:{};return this.a.getValue(f,y,void 0)}updateValue(w,p,f,y){return Promise.reject(new Error("not supported"))}inspect(w){return this.a.inspect(w,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const w=await this.f.loadConfiguration();this.j(w)}j(w){const p=this.a.toData(),f=this.a.compareAndUpdateLocalUserConfiguration(w);this.m(f,p,2)}k(w,p){const f=this.a.toData(),y=this.a.compareAndUpdateDefaultConfiguration(w,p);this.m(y,f,7)}l(w){const p=this.a.toData(),f=this.a.compareAndUpdatePolicyConfiguration(w);this.m(f,p,7)}m(w,p,f){const y=new P.ConfigurationChangeEvent(w,{data:p},this.a);y.source=f,y.sourceConfig=this.n(f),this.h.fire(y)}n(w){switch(w){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=C}),define(oe[216],ae([0,1,9,4]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,i.createDecorator)("remoteAuthorityResolverService");var D;(function(O){O.Unknown="Unknown",O.NotAvailable="NotAvailable",O.TemporarilyNotAvailable="TemporarilyNotAvailable",O.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends k.ErrorNoTelemetry{static isNotAvailable(P){return P instanceof A&&P._code===D.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof A&&P._code===D.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof A&&P._code===D.NoResolverFound}static isHandled(P){return P instanceof A&&P.isHandled}constructor(P,I=D.Unknown,S){super(P),this._message=P,this._code=I,this._detail=S,this.isHandled=I===D.NotAvailable&&S===!0,Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A}),define(oe[75],ae([0,1,24]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function i(S){return S.scheme===k.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=i;function D(S){if(!S)return;const C=S.indexOf("+");return C<0?S:S.substr(0,C)}e.getRemoteName=D;function A(S){return`/${S.quality??"oss"}-${S.commit??"dev"}`}e.getRemoteServerRootPath=A;function O(S){const{host:C,port:E}=I(S);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:E}}e.parseAuthorityWithPort=O;function P(S,C){let{host:E,port:w}=I(S);return typeof w>"u"&&(w=C),{host:E,port:w}}e.parseAuthorityWithOptionalPort=P;function I(S){const C=S.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const E=S.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const w=S.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:S,port:void 0}}}),define(oe[42],ae([0,1,27,4,75]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=A;function O(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=O,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var I;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(I=e.TargetPlatform||(e.TargetPlatform={}));class S{constructor(y){this.value=y,this.c=y.toLowerCase()}static equals(y,v){if(typeof y>"u"||y===null)return typeof v>"u"||v===null;if(typeof v>"u"||v===null)return!1;if(typeof y=="string"||typeof v=="string"){const l=typeof y=="string"?y:y.value,m=typeof v=="string"?v:v.value;return k.equalsIgnoreCase(l,m)}return y.c===v.c}static toKey(y){return typeof y=="string"?y.toLowerCase():y.c}}e.ExtensionIdentifier=S;function C(f){return E(f)}e.isApplicationScopedExtension=C;function E(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function w(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=w;function p(f,y){if(y){const v=`onResolveRemoteAuthority:${(0,D.getRemoteName)(y)}`;return f.activationEvents?.indexOf(v)!==-1}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(oe[33],ae([0,1,27,29,42,5,7,9,36]),function(ee,e,k,i,D,A,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function S(r,t){return r.uuid&&t.uuid?r.uuid===t.uuid:r.id===t.id?!0:(0,k.compareIgnoreCase)(r.id,t.id)===0}e.areSameExtensions=S;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class E{static create(t){const o=t.manifest?t.manifest.version:t.version,s=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new E(t.identifier,o,s)}static parse(t){const o=C.exec(t);return o&&o[1]&&o[2]?new E({id:o[1]},o[2],o[4]||void 0):null}constructor(t,o,s="undefined"){this.version=o,this.targetPlatform=s,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof E?S(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=E;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(r){const t=w.exec(r);return t&&t[1]?[y(t[1]),t[2]]:[y(r),void 0]}e.getIdAndVersion=p;function f(r,t){return`${r}.${t}`}e.getExtensionId=f;function y(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=y;function v(r,t){return y(f(r,t))}e.getGalleryExtensionId=v;function l(r,t){const o=[],s=c=>{for(const a of o)if(a.some(g=>S(t(g),t(c))))return a;return null};for(const c of r){const a=s(c);a?a.push(c):o.push([c])}return o}e.groupByExtension=l;function m(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=m;function u(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=u,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function d(r,t){const o=[],s=t.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const c=s.shift();if(c&&o.every(a=>!S(a.identifier,{id:c}))){const a=r.filter(g=>S(g.identifier,{id:c}));a.length===1&&(o.push(a[0]),s.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=d;async function h(r,t){if(!A.isLinux)return!1;let o;try{o=(await r.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await r.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){t.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(c))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=h;async function n(r,t){const o=await h(r,t),s=(0,i.getTargetPlatform)(o?"alpine":A.platform,I.arch);return t.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=n}),define(oe[217],ae([0,1,23,33]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function D(A,O,P,I,S){try{const C=await A.getExtensionsControlManifest();if(!C.deprecated)return;const E=await A.getInstalled(1);for(const[w,p]of Object.entries(C.deprecated)){if(!p?.extension)continue;const{id:f,autoMigrate:y,preRelease:v}=p.extension;if(!y)continue;const l=E.find(u=>(0,i.areSameExtensions)(u.identifier,{id:w}));if(!l)continue;const m=(await O.getExtensions([{id:f,preRelease:v}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},k.CancellationToken.None))[0];if(!m){S.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${f}' extension is not found`);continue}try{S.info(`Migrating '${l.identifier.id}' extension to '${f}' extension...`);const u=!I.getDisabledExtensions().some(h=>(0,i.areSameExtensions)(h,l.identifier));await A.uninstall(l),S.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let d=E.find(h=>(0,i.areSameExtensions)(h.identifier,{id:f}));(!d||!d.isPreReleaseVersion&&u)&&(d=await A.installFromGallery(m,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),S.info(`Installed the pre-release extension '${d.identifier.id}'`),u||(await I.disableExtension(d.identifier),S.info(`Disabled the pre-release extension '${d.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),y.storage&&(P.addToMigrationList((0,i.getExtensionId)(l.manifest.publisher,l.manifest.name),(0,i.getExtensionId)(d.manifest.publisher,d.manifest.name)),S.info("Added pre-release extension to the storage migration list"))),S.info(`Migrated '${l.identifier.id}' extension to '${f}' extension.`)}catch(u){S.error(u)}}}catch(C){S.error(C)}}e.migrateUnsupportedExtensions=D}),define(oe[218],ae([0,1,6,9,2,24,5,21,53,14,31,28,16,15,29,33,97,13,8,25]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p,f,y,v,l,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let d=class yt extends D.Disposable{constructor(n,r,t,o,s,c,a,g){super(),this.h=n,this.i=t,this.j=o,this.k=s,this.l=c,this.m=a,this.n=g,this.extensionsDownloadDir=r.extensionsDownloadLocation,this.f=20,this.g=this.w()}async download(n,r){await this.g;const t=(0,P.joinPath)(this.extensionsDownloadDir,this.y(n));try{await this.u(n,t,s=>this.j.download(n,s,r))}catch(s){throw new f.ExtensionManagementError(s.message,f.ExtensionManagementErrorCode.Download)}let o=!1;if(await this.r(n)){const s=await this.t(n);try{o=await this.m.verify(t.fsPath,s.fsPath),this.n.info(`Verified extension: ${n.identifier.id}`,o)}catch(c){throw await this.delete(s),await this.delete(t),new f.ExtensionManagementError(c.code,f.ExtensionManagementErrorCode.Signature)}}return{location:t,verified:o}}async r(n){if(!n.isSigned||await this.h==="linux-armhf")return!1;const t=this.k.getValue("extensions.verifySignature");return(0,S.isBoolean)(t)?t:this.l.quality!=="stable"}async t(n){await this.g;const r=(0,P.joinPath)(this.extensionsDownloadDir,`${this.y(n)}${yt.c}`);return await this.u(n,r,t=>this.j.downloadSignatureArchive(n,t)),r}async u(n,r,t){if(await this.i.exists(r))return;if(r.scheme!==A.Schemas.file){await t(r);return}const o=(0,P.joinPath)(this.extensionsDownloadDir,`.${(0,C.generateUuid)()}`);await this.i.exists(o)||await t(o);try{await this.v(o,r,Date.now()+2*60*1e3)}catch(s){try{await this.i.del(o)}catch{}if(s.code==="ENOTEMPTY")this.n.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,r.path);else throw this.n.info(`Rename failed because of ${(0,i.getErrorMessage)(s)}. Deleted the file from downloaded location`,o.path),s}}async delete(n){await this.g,await this.i.del(n)}async v(n,r,t){try{await E.Promises.rename(n.fsPath,r.fsPath)}catch(o){if(O.isWindows&&o&&o.code==="EPERM"&&Date.now()<t)return this.n.info(`Failed renaming ${n} to ${r} with 'EPERM' error. Trying again...`),this.v(n,r,t);throw o}}async w(){try{if(!await this.i.exists(this.extensionsDownloadDir)){this.n.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.i.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const r=[],t=[],o=[];for(const a of n.children)if(a.name.endsWith(yt.c))o.push(a.resource);else{const g=y.ExtensionKey.parse(a.name);g&&t.push([g,a])}const s=(0,y.groupByExtension)(t,([a])=>a),c=[];for(const a of s)a.sort((g,b)=>I.rcompare(g[0].version,b[0].version)),r.push(...a.slice(1).map(g=>g[1].resource)),c.push(a[0][1]);c.sort((a,g)=>a.mtime-g.mtime),r.push(...c.slice(0,Math.max(0,c.length-this.f)).map(a=>a.resource)),r.push(...o),await k.Promises.settled(r.map(a=>(this.n.trace("Deleting from cache",a.path),this.i.del(a))))}}catch(n){this.n.error(n)}}y(n){return this.f?y.ExtensionKey.create(n).toString().toLowerCase():(0,C.generateUuid)()}};d.c=".sigzip",d=pe([Y(1,p.INativeEnvironmentService),Y(2,l.IFileService),Y(3,f.IExtensionGalleryService),Y(4,w.IConfigurationService),Y(5,u.IProductService),Y(6,v.IExtensionSignatureVerificationService),Y(7,m.ILogService)],d),e.ExtensionsDownloader=d}),define(oe[219],ae([0,1,2,12,28,42]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class O extends k.Disposable{constructor(I,S){super(),this.b=I,this.a=(0,i.join)(this.b.userDataPath,A.MANIFEST_CACHE_FOLDER,A.USER_MANIFEST_CACHE_FILE),this.B(S.onDidInstallExtensions(C=>this.c(C))),this.B(S.onDidUninstallExtension(C=>this.f(C)))}c(I){I.some(S=>!!S.local)&&this.invalidate()}f(I){I.error||this.invalidate()}invalidate(){D.Promises.rm(this.a,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=O}),define(oe[220],ae([0,1,3,2,37,33,42]),function(ee,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class P extends i.Disposable{constructor(S,C,E,w,p,f,y){super(),this.f=S,this.g=C,this.h=E,this.i=w,this.j=p,this.k=f,this.l=y,this.a=this.B(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new i.DisposableMap),this.m().then(null,v=>y.error(v))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(S=>this.p(S.added,S.removed))),this.B(this.i.onAddExtensions(S=>this.r(S))),this.B(this.i.onDidAddExtensions(S=>this.s(S))),this.B(this.i.onRemoveExtensions(S=>this.t(S))),this.B(this.i.onDidRemoveExtensions(S=>this.u(S))),this.B(this.k.onDidFilesChange(S=>this.v(S)))}async p(S,C){try{await Promise.all(C.map(E=>(this.c.deleteAndDispose(E.id),this.z(E.extensionsResource)))),S.length&&await Promise.all(S.map(E=>(this.c.set(E.id,(0,i.combinedDisposable)(this.k.watch(this.j.extUri.dirname(E.extensionsResource)),this.k.watch(E.extensionsResource))),this.y(E.extensionsResource))))}catch(E){throw this.l.error(E),E}}async r(S){for(const C of S.extensions)this.D(this.G(C.identifier,C.version),S.profileLocation)}async s(S){for(const C of S.extensions){const E=this.G(C.identifier,C.version);S.error?this.F(E,S.profileLocation):this.D(E,S.profileLocation)}}async t(S){for(const C of S.extensions)this.F(this.G(C.identifier,C.version),S.profileLocation)}async u(S){let C=!1;for(const E of S.extensions){const w=this.G(E.identifier,E.version);S.error?this.D(w,S.profileLocation):(this.F(w,S.profileLocation),C=C||!this.b.has(w))}C&&await this.C()}v(S){for(const C of this.h.profiles)S.contains(C.extensionsResource,0,1)&&this.w(C.extensionsResource)}async w(S){const C=[],E=[],w=await this.i.scanProfileExtensions(S),p=new Set,f=new Set;for(const[y,v]of this.b)v.has(S)&&f.add(y);for(const y of w){const v=this.G(y.identifier,y.version);p.add(v),f.has(v)||(C.push(y.identifier),this.D(v,S))}for(const y of f)if(!p.has(y)){const v=this.H(y);v&&(E.push(v.identifier),this.F(y,S))}(C.length||E.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:S}:void 0,removed:E.length?{extensions:E,profileLocation:S}:void 0})}async y(S){const C=await this.i.scanProfileExtensions(S);for(const E of C)this.D(this.G(E.identifier,E.version),S)}async z(S){for(const C of[...this.b.keys()])this.F(C,S);await this.C()}async C(){const C=(await this.f.getAllUserInstalled()).filter(E=>E.installedTimestamp&&!this.b.has(this.G(E.identifier,E.manifest.version)));C.length&&await this.f.markAsUninstalled(...C)}D(S,C){let E=this.b.get(S);E||this.b.set(S,E=new D.ResourceSet(w=>this.j.extUri.getComparisonKey(w))),E.add(C)}F(S,C){const E=this.b.get(S);E&&E.delete(C),E?.size||this.b.delete(S)}G(S,C){return`${O.ExtensionIdentifier.toKey(S.id)}@${C}`}H(S){const[C,E]=(0,A.getIdAndVersion)(S);return E?{identifier:{id:C},version:E}:void 0}}e.ExtensionsWatcher=P}),define(oe[221],ae([0,1,99,20,6,2,24,12,28,15,29,33,8,73,5,7]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let v=class extends p.LanguagePackBaseService{constructor(d,h,n,r){super(n),this.h=d,this.i=r,this.g=this.B(new l(h,r)),this.h.registerParticipant({postInstall:async t=>this.j(t),postUninstall:async t=>this.k(t)})}async getBuiltInExtensionTranslationsUri(d){const n=(await this.g.getLanguagePacks())[f.Language.value()];if(!n){this.i.warn(`No language pack found for ${f.Language.value()}`);return}const r=n.translations[d];return r?y.URI.file(r):void 0}async getInstalledLanguages(){const d=await this.g.getLanguagePacks(),h=Object.keys(d).map(n=>{const r=d[n];return{...this.f(n,r.label),extensionId:r.extensions[0].extensionIdentifier.id}});return h.push({...this.f("en","English"),extensionId:"default"}),h.sort((n,r)=>n.label.localeCompare(r.label)),h}async j(d){d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",d.identifier.id),await this.update())}async k(d){const h=await this.g.getLanguagePacks();Object.keys(h).some(n=>h[n]&&h[n].extensions.some(r=>(0,E.areSameExtensions)(r.extensionIdentifier,d.identifier)))&&(this.i.info("Removing language packs from the extension",d.identifier.id),await this.update())}async update(){const[d,h]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),n=await this.g.update(h);return!(0,i.equals)(Object.keys(d),Object.keys(n))}};v=pe([Y(0,C.IExtensionManagementService),Y(1,S.INativeEnvironmentService),Y(2,C.IExtensionGalleryService),Y(3,w.ILogService)],v),e.NativeLanguagePackService=v;let l=class extends A.Disposable{constructor(d,h){super(),this.i=h,this.c={},this.f=(0,P.join)(d.userDataPath,"languagepacks.json"),this.g=new D.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(d){return this.m(h=>{Object.keys(h).forEach(n=>delete h[n]),this.j(h,...d)}).then(()=>this.c)}j(d,...h){for(const n of h)n&&n.manifest&&n.manifest.contributes&&n.manifest.contributes.localizations&&n.manifest.contributes.localizations.length&&this.k(d,n);Object.keys(d).forEach(n=>this.l(d[n]))}k(d,h){const n=h.identifier,r=h.manifest.contributes&&h.manifest.contributes.localizations?h.manifest.contributes.localizations:[];for(const t of r)if(h.location.scheme===O.Schemas.file&&m(t)){let o=d[t.languageId];o||(o={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},d[t.languageId]=o);const s=o.extensions.filter(c=>(0,E.areSameExtensions)(c.extensionIdentifier,n))[0];s?s.version=h.manifest.version:o.extensions.push({extensionIdentifier:n,version:h.manifest.version});for(const c of t.translations)o.translations[c.id]=(0,P.join)(h.location.fsPath,c.path)}}l(d){if(d){const h=(0,k.createHash)("md5");for(const n of d.extensions)h.update(n.extensionIdentifier.uuid||n.extensionIdentifier.id).update(n.version);d.hash=h.digest("hex")}}m(d=()=>null){return this.g.queue(()=>{let h=null;return I.Promises.readFile(this.f,"utf8").then(void 0,n=>n.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(n)).then(n=>{try{return JSON.parse(n)}catch{return{}}}).then(n=>(h=d(n),n)).then(n=>{for(const t of Object.keys(n))n[t]||delete n[t];this.c=n,this.h=!0;const r=JSON.stringify(this.c);return this.i.debug("Writing language packs",r),I.Promises.writeFile(this.f,r)}).then(()=>h,n=>this.i.error(n))})}};l=pe([Y(0,S.INativeEnvironmentService),Y(1,w.ILogService)],l);function m(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const d of u.translations)if(typeof d.id!="string"||typeof d.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(oe[222],ae([0,1,6,17,23,9,3,2,31,92,216,75]),function(ee,e,k,i,D,A,O,P,I,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const w=30*1e3;var p;(function(J){J[J.Management=1]="Management",J[J.ExtensionHost=2]="ExtensionHost",J[J.Tunnel=3]="Tunnel"})(p=e.ConnectionType||(e.ConnectionType={}));function f(J){switch(J){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function y(J){const x=new D.CancellationTokenSource;return setTimeout(()=>x.cancel(),J),x.token}function v(J,x){if(J.isCancellationRequested||x.isCancellationRequested)return D.CancellationToken.Cancelled;const T=new D.CancellationTokenSource;return J.onCancellationRequested(()=>T.cancel()),x.onCancellationRequested(()=>T.cancel()),T.token}class l{get didTimeout(){return this.c==="timedout"}constructor(x){this.c="pending",this.d=new P.DisposableStore,this.promise=new Promise((T,N)=>{this.f=T,this.g=N}),x.isCancellationRequested?this.h():this.d.add(x.onCancellationRequested(()=>this.h()))}registerDisposable(x){this.c==="pending"?this.d.add(x):x.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const x=new Error("Time limit reached");return x.code="ETIMEDOUT",x.syscall="connect",x}resolve(x){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(x))}reject(x){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(x))}}function m(J,x){const T=new l(x);return T.registerDisposable(J.onControlMessage(N=>{const H=JSON.parse(N.toString()),B=K(H);B?T.reject(B):T.resolve(H)})),T.promise}function u(J,x,T,N,H,B,Q,re){const X=new l(re);return x.connect(T,N,H,B,Q,(te,se)=>{X.didTimeout?(te&&J.error(te),se?.dispose()):te||!se?X.reject(te):X.resolve(se)}),X.promise}function d(J,x){const T=new l(x);return J.then(N=>{T.didTimeout||T.resolve(N)},N=>{T.didTimeout||T.reject(N)}),T.promise}async function h(J,x,T,N){const H=Z(J,x);J.logService.trace(`${H} 1/6. invoking socketFactory.connect().`);let B;try{B=await u(J.logService,J.socketFactory,J.host,J.port,(0,E.getRemoteServerRootPath)(J),`reconnectionToken=${J.reconnectionToken}&reconnection=${J.reconnectionProtocol?"true":"false"}`,`renderer-${f(x)}-${J.reconnectionToken}`,N)}catch(se){throw J.logService.error(`${H} socketFactory.connect() failed or timed out. Error:`),J.logService.error(se),se}J.logService.trace(`${H} 2/6. socketFactory.connect() was successful.`);let Q,re;J.reconnectionProtocol?(J.reconnectionProtocol.beginAcceptReconnection(B,null),Q=J.reconnectionProtocol,re=!1):(Q=new S.PersistentProtocol(B,null),re=!0),J.logService.trace(`${H} 3/6. sending AuthRequest control message.`);const X=await d(J.signService.createNewMessage((0,I.generateUuid)()),N),te={type:"auth",auth:J.connectionToken||"00000000000000000000",data:X.data};Q.sendControl(i.VSBuffer.fromString(JSON.stringify(te)));try{const se=await m(Q,v(N,y(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const Se=new Error("Unexpected handshake message");throw Se.code="VSCODE_CONNECTION_ERROR",Se}if(J.logService.trace(`${H} 4/6. received SignRequest control message.`),!await d(J.signService.validate(X,se.signedData),N)){const Se=new Error("Refused to connect to unsupported server");throw Se.code="VSCODE_CONNECTION_ERROR",Se}const ue=await d(J.signService.sign(se.data),N),ye={type:"connectionType",commit:J.commit,signedData:ue,desiredConnectionType:x};return T&&(ye.args=T),J.logService.trace(`${H} 5/6. sending ConnectionTypeRequest control message.`),Q.sendControl(i.VSBuffer.fromString(JSON.stringify(ye))),{protocol:Q,ownsProtocol:re}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(J.logService.error(`${H} the handshake timed out. Error:`),J.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(J.logService.error(`${H} received error control message when negotiating connection. Error:`),J.logService.error(se)),re&&_(Q),se}}async function n(J,x,T,N){const H=Date.now(),B=Z(J,x),{protocol:Q,ownsProtocol:re}=await h(J,x,T,N),X=new l(N);return X.registerDisposable(Q.onControlMessage(te=>{const se=JSON.parse(te.toString()),le=K(se);le?(J.logService.error(`${B} received error control message when negotiating connection. Error:`),J.logService.error(le),re&&_(Q),X.reject(le)):(J.reconnectionProtocol?.endAcceptReconnection(),J.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${ne(H)}!`),X.resolve({protocol:Q,firstMessage:se}))})),X.promise}async function r(J,x){const{protocol:T}=await n(J,1,void 0,x);return{protocol:T}}async function t(J,x,T){const{protocol:N,firstMessage:H}=await n(J,2,x,T),B=H&&H.debugPort;return{protocol:N,debugPort:B}}async function o(J,x,T){const N=Date.now(),H=Z(J,3),{protocol:B}=await h(J,3,x,T);return J.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${ne(N)}!`),B}async function s(J,x,T){const{host:N,port:H,connectionToken:B}=await J.addressProvider.getAddress();return{commit:J.commit,quality:J.quality,host:N,port:H,connectionToken:B,reconnectionToken:x,reconnectionProtocol:T,socketFactory:J.socketFactory,signService:J.signService,logService:J.logService}}async function c(J,x,T){return g(J,async N=>{const{protocol:H}=await r(N,D.CancellationToken.None);return new G(J,x,T,N.reconnectionToken,H)})}e.connectRemoteAgentManagement=c;async function a(J,x){return g(J,async T=>{const{protocol:N,debugPort:H}=await t(T,x,D.CancellationToken.None);return new W(J,x,T.reconnectionToken,N,H)})}e.connectRemoteAgentExtensionHost=a;async function g(J,x){for(let N=1;;N++)try{const H=(0,I.generateUuid)(),B=await s(J,H,null);return await x(B)}catch(H){if(N<5)J.logService.error(`[remote-connection][attempt ${N}] An error occurred in initial connection! Will retry... Error:`),J.logService.error(H);else throw J.logService.error(`[remote-connection][attempt ${N}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),J.logService.error(H),$.triggerPermanentFailure(0,0,C.RemoteAuthorityResolverError.isHandled(H)),H}}async function b(J,x,T){const N=await s(J,(0,I.generateUuid)(),null);return await o(N,{host:x,port:T},D.CancellationToken.None)}e.connectRemoteAgentTunnel=b;function R(J){return(0,k.createCancelablePromise)(x=>new Promise((T,N)=>{const H=setTimeout(T,J*1e3);x.onCancellationRequested(()=>{clearTimeout(H),T()})}))}var j;(function(J){J[J.ConnectionLost=0]="ConnectionLost",J[J.ReconnectionWait=1]="ReconnectionWait",J[J.ReconnectionRunning=2]="ReconnectionRunning",J[J.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",J[J.ConnectionGain=4]="ConnectionGain"})(j=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class U{constructor(x,T){this.reconnectionToken=x,this.millisSinceLastIncomingData=T,this.type=0}}e.ConnectionLostEvent=U;class z{constructor(x,T,N,H){this.reconnectionToken=x,this.millisSinceLastIncomingData=T,this.durationSeconds=N,this.c=H,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=z;class F{constructor(x,T,N){this.reconnectionToken=x,this.millisSinceLastIncomingData=T,this.attempt=N,this.type=2}}e.ReconnectionRunningEvent=F;class L{constructor(x,T,N){this.reconnectionToken=x,this.millisSinceLastIncomingData=T,this.attempt=N,this.type=4}}e.ConnectionGainEvent=L;class M{constructor(x,T,N,H){this.reconnectionToken=x,this.millisSinceLastIncomingData=T,this.attempt=N,this.handled=H,this.type=3}}e.ReconnectionPermanentFailureEvent=M;class $ extends P.Disposable{static triggerPermanentFailure(x,T,N){this._permanentFailure=!0,this.f=x,this.g=T,this.h=N,this.i.forEach(H=>H.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(x=>x.r())}static debugPauseSocketWriting(){this.i.forEach(x=>x.v())}get k(){return this.c||$._permanentFailure}constructor(x,T,N,H,B){super(),this.m=x,this.n=T,this.reconnectionToken=N,this.protocol=H,this.p=B,this.j=this.B(new O.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new L(this.reconnectionToken,0,0)),this.B(H.onSocketClose(Q=>{const re=V(this.m,this.reconnectionToken,!0);Q?Q.type===0?(this.n.logService.info(`${re} received socket close event (hadError: ${Q.hadError}).`),Q.error&&this.n.logService.error(Q.error)):(this.n.logService.info(`${re} received socket close event (wasClean: ${Q.wasClean}, code: ${Q.code}, reason: ${Q.reason}).`),Q.event&&this.n.logService.error(Q.event)):this.n.logService.info(`${re} received socket close event.`),this.r()})),this.B(H.onSocketTimeout(Q=>{const re=V(this.m,this.reconnectionToken,!0);this.n.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${Q.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Q.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Q.timeSinceLastReceivedSomeData}).`),this.r()})),$.i.push(this),this.B((0,P.toDisposable)(()=>{const Q=$.i.indexOf(this);Q>=0&&$.i.splice(Q,1)})),this.k&&this.u($.f,$.g,$.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const x=V(this.m,this.reconnectionToken,!0);this.n.logService.info(`${x} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const T=[0,5,5,10,10,10,10,10,30];let N=-1;do{N++;const H=N<T.length?T[N]:T[T.length-1];try{if(H>0){const Q=R(H);this.j.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H,Q)),this.n.logService.info(`${x} waiting for ${H} seconds before reconnecting...`);try{await Q}catch{}}if(this.k){this.n.logService.error(`${x} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1)),this.n.logService.info(`${x} resolving connection...`);const B=await s(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${x} connecting to ${B.host}:${B.port}...`),await this.w(B,y(w)),this.n.logService.info(`${x} reconnected!`),this.j.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1));break}catch(B){if(B.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${x} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(B),this.t(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(N>360){this.n.logService.error(`${x} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(B),this.t(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(C.RemoteAuthorityResolverError.isTemporarilyNotAvailable(B)){this.n.logService.info(`${x} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(B);continue}if((B.code==="ETIMEDOUT"||B.code==="ENETUNREACH"||B.code==="ECONNREFUSED"||B.code==="ECONNRESET")&&B.syscall==="connect"){this.n.logService.info(`${x} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(B);continue}if((0,A.isCancellationError)(B)){this.n.logService.info(`${x} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(B);continue}if(B instanceof C.RemoteAuthorityResolverError){this.n.logService.error(`${x} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(B),this.t(this.protocol.getMillisSinceLastIncomingData(),N+1,C.RemoteAuthorityResolverError.isHandled(B));break}this.n.logService.error(`${x} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(B),this.t(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}}while(!this.k)}t(x,T,N){this.p?$.triggerPermanentFailure(x,T,N):this.u(x,T,N)}u(x,T,N){this.j.fire(new M(this.reconnectionToken,x,T,N)),_(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=$,$._permanentFailure=!1,$.f=0,$.g=0,$.h=!1,$.i=[];class G extends ${constructor(x,T,N,H,B){super(1,x,H,B,!0),this.client=this.B(new S.Client(B,{remoteAuthority:T,clientId:N},x.ipcLogger))}async w(x,T){await r(x,T)}}e.ManagementPersistentConnection=G;class W extends ${constructor(x,T,N,H,B){super(2,x,N,H,!1),this.y=T,this.debugPort=B}async w(x,T){await t(x,this.y,T)}}e.ExtensionHostPersistentConnection=W;function _(J){try{J.acceptDisconnect();const x=J.getSocket();J.dispose(),x.dispose()}catch(x){(0,A.onUnexpectedError)(x)}}function K(J){if(J&&J.type==="error"){const x=new Error(`Connection error: ${J.reason}`);return x.code="VSCODE_CONNECTION_ERROR",x}return null}function q(J,x){for(;J.length<x;)J+=" ";return J}function V(J,x,T){return`[remote-connection][${q(f(J),13)}][${x.substr(0,5)}\u2026][${T?"reconnect":"initial"}]`}function Z(J,x){return`${V(x,J.reconnectionToken,!!J.reconnectionProtocol)}[${J.host}:${J.port}]`}function ne(J){return`${Date.now()-J} ms`}}),define(oe[223],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,k.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(oe[224],ae([0,1,86,149]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,A,O,P,I,S){const C=w=>S(w,void 0),E=k.createConnection({host:D,port:A},()=>{E.removeListener("error",C);const w=Buffer.alloc(16);for(let v=0;v<16;v++)w[v]=Math.round(Math.random()*256);const p=w.toString("base64"),f=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${A}${O}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${p}`];E.write(f.join(`\r
`)+`\r
\r
`);const y=v=>{v.toString().indexOf(`\r
\r
`)>=0&&(E.off("data",y),S(void 0,new i.NodeSocket(E,I)))};E.on("data",y)});E.setNoDelay(!0),E.once("error",C)}}}),define(oe[105],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOG_CHANNEL_ID=e.LOGGER_NAME=e.LOG_FILE_NAME=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,k.createDecorator)("IRemoteTunnelService");var i;(function(D){D.disconnected={type:"disconnected"},D.uninitialized={type:"uninitialized"},D.connected=A=>({type:"connected",info:A}),D.connecting=A=>({type:"connecting",progress:A})})(i=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.LOG_FILE_NAME="remoteTunnelService.log",e.LOGGER_NAME="remoteTunnelService",e.LOG_CHANNEL_ID="remoteTunnelServiceLog"}),define(oe[225],ae([0,1,132,16,8]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let A=class{constructor(P,I){this.a=P,this.b=I}async request(P,I){this.b.trace("RequestService#request (browser) - begin",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.a.getValue("http.proxyAuthorization"));try{const S=await(0,k.request)(P,I);return this.b.trace("RequestService#request (browser) - success",P.url),S}catch(S){throw this.b.error("RequestService#request (browser) - error",P.url,S),S}}async resolveProxy(P){}};A=pe([Y(0,i.IConfigurationService),Y(1,D.ILogService)],A),e.RequestService=A}),define(oe[59],ae([0,1,17,168,46,4,40]),function(ee,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,A.createDecorator)("requestService");function P(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}e.isSuccess=P;function I(y){return y.res.statusCode===204}async function S(y){return I(y)?null:(await(0,k.streamToBuffer)(y.stream)).toString()}e.asText=S;async function C(y){if(!P(y))throw new Error("Server returned "+y.res.statusCode);return S(y)}e.asTextOrError=C;async function E(y){if(!P(y))throw new Error("Server returned "+y.res.statusCode);if(I(y))return null;const l=(await(0,k.streamToBuffer)(y.stream)).toString();try{return JSON.parse(l)}catch(m){throw m.message+=`:
`+l,m}}e.asJson=E;function w(y){f(y)}e.updateProxyConfigurationsScope=w;let p;function f(y){const v=O.Registry.as(D.Extensions.Configuration),l=p;p={id:"http",order:15,title:(0,i.localize)(0,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,i.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,i.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,i.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,i.localize)(4,null),(0,i.localize)(5,null),(0,i.localize)(6,null),(0,i.localize)(7,null)],default:"override",description:(0,i.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,i.localize)(9,null),restricted:!0}}},v.updateConfigurations({add:[p],remove:l?[l]:[]})}f(2)}),define(oe[226],ae([0,1,23,24,13,59]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let O=class{constructor(I,S){this.a=I,this.b=S}async download(I,S,C=k.CancellationToken.None){if(I.scheme===i.Schemas.file||I.scheme===i.Schemas.vscodeRemote){await this.b.copy(I,S);return}const E={type:"GET",url:I.toString(!0)},w=await this.a.request(E,C);if(w.res.statusCode===200)await this.b.writeFile(S,w.stream);else{const p=await(0,A.asTextOrError)(w);throw new Error(`Expected 200, got back ${w.res.statusCode} instead.

${p}`)}}};O=pe([Y(0,A.IRequestService),Y(1,D.IFileService)],O),e.DownloadService=O}),define(oe[227],ae([0,1,17,23]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class D{constructor(P){this.a=P}listen(P,I){throw new Error("Invalid listen")}call(P,I,S,C=i.CancellationToken.None){switch(I){case"request":return this.a.request(S[0],C).then(async({res:E,stream:w})=>{const p=await(0,k.streamToBuffer)(w);return[{statusCode:E.statusCode,headers:E.headers},p]});case"resolveProxy":return this.a.resolveProxy(S[0])}throw new Error("Invalid call")}}e.RequestChannel=D;class A{constructor(P){this.a=P}async request(P,I){const[S,C]=await this.a.call("request",[P],I);return{res:S,stream:(0,k.bufferToStream)(C)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.RequestChannelClient=A}),define(oe[228],ae([0,1,14,225,227]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class A{constructor(P,I,S,C){this.c=I,this.d=S,this.e=C,this.a=new i.RequestService(I,C),this.b=new D.RequestChannelClient(P.getChannel("request"))}request(P,I){return this.f().request(P,I)}async resolveProxy(P){return this.f().resolveProxy(P)}f(){return this.g()?(this.e.trace("Using main request service"),this.b):(this.e.trace("Using browser request service"),this.a)}g(){const P=this.c.getValue("developer.sharedProcess.redirectRequestsToMain");return(0,k.isBoolean)(P)?P:this.d.quality!=="stable"}}e.SharedProcessRequestService=A}),define(oe[106],ae([0,1,66,4]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function D(A){return(0,k.hash)({moduleId:A.process.moduleId,windowId:A.reply.windowId})}e.hash=D,e.ISharedProcessWorkerService=(0,i.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(oe[229],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var k;(function(i){i.Spawn="vscode:shared-process->shared-process-worker=spawn",i.Terminate="vscode:shared-process->shared-process-worker=terminate",i.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",i.Ready="vscode:shared-process-worker->shared-process=ready",i.Ack="vscode:shared-process-worker->shared-process=ack",i.Trace="vscode:shared-process-worker->shared-process=trace",i.Info="vscode:shared-process-worker->shared-process=info",i.Warn="vscode:shared-process-worker->shared-process=warn",i.Error="vscode:shared-process-worker->shared-process=error"})(k=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(oe[230],ae([0,1,93,6,23,3,2,24,31,8,106,229]),function(ee,e,k,i,D,A,O,P,I,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let w=class{constructor(y){this.d=y,this.a=new Map,this.b=new Map,this.c=new Map}async createWorker(y){const v=`window: ${y.reply.windowId}, moduleId: ${y.process.moduleId}`;this.d.trace(`SharedProcess: createWorker (${v})`);const l=(0,C.hash)(y);this.b.has(l)&&(this.d.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${v})`),this.f(y));const m=new D.CancellationTokenSource;let u,d,h;this.b.set(l,o=>{m.dispose(!0),u?.terminate(y,D.CancellationToken.None),d?.close(),h?.close(),this.b.delete(l);const s=this.c.get(l);s&&(this.c.delete(l),s({reason:o}))}),u=await this.e(y);const n=new Promise(o=>{this.c.set(l,o)});if(m.token.isCancellationRequested)return n;const{port1:r,port2:t}=new MessageChannel;return d=r,h=t,await u.spawn(y,h,m.token),m.token.isCancellationRequested||(this.d.trace(`SharedProcess: createWorker sending message port back to window (${v})`),k.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",y,[d])),n}e(y){let v=this.a.get(y.process.moduleId);if(!v){this.d.trace(`SharedProcess: creating new web worker (${y.process.moduleId})`);const l=new p(y.process.type,this.d);v=l.init(),l.onDidProcessSelfTerminate(({configuration:m,reason:u})=>{this.f(m,u)}),this.a.set(y.process.moduleId,v)}return v}async disposeWorker(y){return this.f(y)}f(y,v){const l=this.b.get((0,C.hash)(y));l&&(this.d.trace(`SharedProcess: disposeWorker (window: ${y.reply.windowId}, moduleId: ${y.process.moduleId})`),l(v))}};w=pe([Y(0,S.ILogService)],w),e.SharedProcessWorkerService=w;class p extends O.Disposable{constructor(y,v){super(),this.f=y,this.g=v,this.a=this.B(new A.Emitter),this.onDidProcessSelfTerminate=this.a.event,this.b=this.h(),this.c=new Map}async init(){return await this.b,this}h(){const y=new i.DeferredPromise,v=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.f})`});return v.onerror=l=>{this.g.error(`SharedProcess: worker error (${this.f})`,l.message)},v.onmessageerror=l=>{this.g.error(`SharedProcess: worker message error (${this.f})`,l)},v.onmessage=l=>{const{id:m,message:u,configuration:d,nonce:h}=l.data;switch(m){case E.SharedProcessWorkerMessages.Ready:y.complete(v);break;case E.SharedProcessWorkerMessages.Ack:if(h){const n=this.c.get(h);n&&(this.c.delete(h),n())}break;case E.SharedProcessWorkerMessages.SelfTerminated:d&&u&&this.a.fire({configuration:d,reason:JSON.parse(u)});break;case E.SharedProcessWorkerMessages.Trace:this.g.trace(`SharedProcess (worker, ${this.f}):`,u);break;case E.SharedProcessWorkerMessages.Info:u&&this.g.info(u);break;case E.SharedProcessWorkerMessages.Warn:this.g.warn(`SharedProcess (worker, ${this.f}):`,u);break;case E.SharedProcessWorkerMessages.Error:this.g.error(`SharedProcess (worker, ${this.f}):`,u);break;default:this.g.warn(`SharedProcess: unexpected worker message (${this.f})`,l)}},v.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),y.p}async i(y,v,l){const m=await this.b;if(!v.isCancellationRequested)return new Promise(u=>{const d=(0,I.generateUuid)();this.c.set(d,u);const h={...y,nonce:d};l?m.postMessage(h,[l]):m.postMessage(h),v.onCancellationRequested(()=>{this.c.delete(d)&&u()})})}spawn(y,v,l){const m={id:E.SharedProcessWorkerMessages.Spawn,configuration:y,environment:{bootstrapPath:P.FileAccess.asFileUri("bootstrap-fork").fsPath}};return this.i(m,l,v)}terminate(y,v){const l={id:E.SharedProcessWorkerMessages.Terminate,configuration:y};return this.i(l,v)}}}),define(oe[231],ae([0,1,63,24,185]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class A extends D.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:i.Schemas.vscodeUserData})}}pe([k.memoize],A.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=A}),define(oe[232],ae([0,1,49,12,169,23,38,9,5,31,146,183,6]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const p=1e4;let f;async function y(l,m,u){return m["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):I.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(u)&&!m["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(u)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=w.Promises.withAsyncBody(async(d,h)=>{const n=new A.CancellationTokenSource,r=setTimeout(()=>{n.dispose(!0),h(new Error((0,D.localize)(0,null)))},p);try{d(await v(l,n.token))}catch(t){!(0,P.isCancellationError)(t)&&!n.token.isCancellationRequested?h(new Error((0,D.localize)(1,null,(0,O.toErrorMessage)(t)))):d({})}finally{clearTimeout(r),n.dispose()}})),f)}e.getResolvedShellEnv=y;async function v(l,m){const u=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",u);const d=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",d);const h=(0,S.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(h+"({.*})"+h),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};l.trace("getUnixShellEnvironment#env",r);const t=await(0,C.getSystemShell)(I.OS,r);return l.trace("getUnixShellEnvironment#shell",t),new Promise((o,s)=>{if(m.isCancellationRequested)return s((0,P.canceled)());const c=(0,i.basename)(t);let a,g;const b=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(a=`& '${process.execPath}' ${b} -p '''${h}'' + JSON.stringify(process.env) + ''${h}'''`,g=["-Login","-Command"]):(a=`'${process.execPath}' ${b} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,c==="tcsh"?g=["-ic"]:g=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(g),a);const R=(0,k.spawn)(t,[...g,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});m.onCancellationRequested(()=>(R.kill(),s((0,P.canceled)()))),R.on("error",z=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,O.toErrorMessage)(z)),s(z)});const j=[];R.stdout.on("data",z=>j.push(z));const U=[];R.stderr.on("data",z=>U.push(z)),R.on("close",(z,F)=>{const L=Buffer.concat(j).toString("utf8");l.trace("getUnixShellEnvironment#raw",L);const M=Buffer.concat(U).toString("utf8");if(M.trim()&&l.trace("getUnixShellEnvironment#stderr",M),z||F)return s(new Error((0,D.localize)(2,null,z,F)));const $=n.exec(L),G=$?$[1]:"{}";try{const W=JSON.parse(G);u?W.ELECTRON_RUN_AS_NODE=u:delete W.ELECTRON_RUN_AS_NODE,d?W.ELECTRON_NO_ATTACH_CONSOLE=d:delete W.ELECTRON_NO_ATTACH_CONSOLE,delete W.VSCODE_RESOLVING_ENVIRONMENT,delete W.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",W),o(W)}catch(W){l.error("getUnixShellEnvironment#errorCaught",(0,O.toErrorMessage)(W)),s(W)}})})}}),define(oe[107],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,k.createDecorator)(e.SIGN_SERVICE_ID)}),define(oe[233],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class k{constructor(){this.b=new Map}c(){return new Promise((D,A)=>ee(["vsda"],D,A))}async createNewMessage(D){try{const A=await this.c(),O=new A.validator;if(O){const P=String(k.a++);return this.b.set(P,O),{id:P,data:O.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,A){if(!D.id)return!0;const O=this.b.get(D.id);if(!O)return!1;this.b.delete(D.id);try{return O.validate(A)==="ok"}catch{return!1}}async sign(D){try{const A=await this.c(),O=new A.signer;if(O)return O.sign(D)}catch{}return D}}e.SignService=k,k.a=1}),define(oe[76],ae([0,1,3,2]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class D extends i.Disposable{constructor(E,w,p){super(),this.a=E,this.b=w,this.c=p}async getItems(){const E={profile:this.b,workspace:this.c},w=await this.a.call("getItems",E);return new Map(w)}updateItems(E){const w={profile:this.b,workspace:this.c};return E.insert&&(w.insert=Array.from(E.insert.entries())),E.delete&&(w.delete=Array.from(E.delete.values())),this.a.call("updateItems",w)}}class A extends D{constructor(E,w){super(E,w,void 0),this.f=this.B(new k.Emitter),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(E=>this.h(E)))}h(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this.f.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}}class O extends A{constructor(E){super(E,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=O;class P extends A{constructor(E,w){super(E,w)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=P;class I extends D{constructor(E,w){super(E,void 0,w),this.onDidChangeItemsExternal=k.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=I;class S{constructor(E){this.a=E}isUsed(E){const w={payload:E,profile:void 0,workspace:void 0};return this.a.call("isUsed",w)}}e.StorageClient=S}),define(oe[108],ae([0,1,5,36,7,31]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function O(S){if(k.platform===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}async function P(S,C,E,w,p,f,y,v,l,m){const u=Object.create(null);u["common.machineId"]=y,u.sessionID=(0,A.generateUuid)()+Date.now(),u.commitHash=p,u.version=f,u["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,k.PlatformToString)(k.platform),u["common.nodePlatform"]=i.platform,u["common.nodeArch"]=w,u["common.product"]=m||"desktop",v&&(u["common.msftInternal"]=v);let d=0;const h=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),k.isLinuxSnap&&(u["common.snap"]="true");const n=O(E);n&&(u["common.platformDetail"]=n);try{const r=await S.readFile(D.URI.file(l));u["common.source"]=r.value.toString().slice(0,30)}catch{}return u}e.resolveCommonProperties=P;function I(S){const C=i.env.USERDNSDOMAIN;if(!C)return!1;const E=C.toLowerCase();return S.some(w=>E===w)}e.verifyMicrosoftInternalDomain=I}),define(oe[22],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var i;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(i=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(oe[234],ae([0,1,34,6,35,24,12,5,7,143,28,145,95,13,25,22]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const v=new Map;async function l(n,r){const t=`${n}::${r.join(":")}`,o=v.get(t);if(o)return o;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,a=new Map,g=2e4;function b(j,U,z,F){const L=U.substring(j.length+1);return i.Promises.withAsyncBody(async M=>{let $;try{$=await C.Promises.readdir(U,{withFileTypes:!0})}catch{M();return}if(F.count>=g){F.count+=$.length,F.maxReached=!0,M();return}let G=$.length;if(G===0){M();return}let W=$;F.count+$.length>g&&(F.maxReached=!0,G=g-F.count,W=$.slice(0,G)),F.count+=$.length;for(const _ of W)if(_.isDirectory()){if(z.includes(_.name)||await b(j,(0,O.join)(U,_.name),z,F),--G===0){M();return}}else{const K=_.name.lastIndexOf(".");if(K>=0){const q=_.name.substring(K+1);q&&c.set(q,(c.get(q)??0)+1)}for(const q of s)q.relativePathPattern?.test(L)!==!1&&q.filePattern.test(_.name)&&a.set(q.tag,(a.get(q.tag)??0)+1);if(--G===0){M();return}}})}const R=i.Promises.withAsyncBody(async j=>{const U={count:0,maxReached:!1};await b(n,n,r,U);const z=await d(n);j({configFiles:m(a),fileTypes:m(c),fileCount:U.count,maxFilesReached:U.maxReached,launchConfigFiles:z})});return v.set(t,R),R}e.collectWorkspaceStats=l;function m(n){return Array.from(n.entries(),([r,t])=>({name:r,count:t})).sort((r,t)=>t.count-r.count)}function u(){const n={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(S.virtualMachineHint.value()*100)}%`},r=k.cpus();return r&&r.length>0&&(n.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),n}e.getMachineInfo=u;async function d(n){try{const r=new Map,t=(0,O.join)(n,".vscode","launch.json"),o=await C.Promises.readFile(t),s=[],c=(0,D.parse)(o.toString(),s);if(s.length)return console.log(`Unable to parse ${t}`),[];if((0,D.getNodeType)(c)==="object"&&c.configurations)for(const a of c.configurations){const g=a.type;g&&(r.has(g)?r.set(g,r.get(g)+1):r.set(g,1))}return m(r)}catch{return[]}}e.collectLaunchConfigs=d;let h=class{constructor(r,t){this.c=r,this.d=t}f(r){const t=[];return t.push(`OS Version:       ${r.os}`),t.push(`CPUs:             ${r.cpus}`),t.push(`Memory (System):  ${r.memory}`),t.push(`VM:               ${r.vmHint}`),t.join(`
`)}g(r){const t=[];t.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),t.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const o=k.cpus();return o&&o.length>0&&t.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),t.push(`Memory (System):  ${(k.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||t.push(`Load (avg):       ${k.loadavg().map(s=>Math.round(s)).join(", ")}`),t.push(`VM:               ${Math.round(S.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${r.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(r,t){return Promise.all([(0,E.listProcesses)(r.mainPID),this.k(r)]).then(async o=>{let[s,c]=o,a=this.m(r,s);return t.forEach(g=>{if((0,w.isRemoteDiagnosticError)(g))a+=`
${g.errorMessage}`,c+=`
${g.errorMessage}`;else if(a+=`

Remote: ${g.hostName}`,g.processes&&(a+=`
${this.m(r,g.processes)}`),g.workspaceMetadata){c+=`
|  Remote: ${g.hostName}`;for(const b of Object.keys(g.workspaceMetadata)){const R=g.workspaceMetadata[b];let j=`${R.fileCount} files`;R.maxFilesReached&&(j=`more than ${j}`),c+=`|    Folder (${b}): ${j}`,c+=this.h(R)}}}),{processInfo:a,workspaceInfo:c}})}async getSystemInfo(r,t){const{memory:o,vmHint:s,os:c,cpus:a}=u(),g={os:c,memory:o,cpus:a,vmHint:s,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:t};return P.isWindows||(g.load=`${k.loadavg().map(b=>Math.round(b)).join(", ")}`),P.isLinux&&(g.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(g)}async getDiagnostics(r,t){const o=[];return(0,E.listProcesses)(r.mainPID).then(async s=>(o.push(""),o.push(this.g(r)),o.push(""),o.push(this.m(r,s)),r.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.k(r))),t.forEach(c=>{if((0,w.isRemoteDiagnosticError)(c))o.push(`
${c.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${c.hostName}`),o.push(this.f(c.machineInfo)),c.processes&&o.push(this.m(r,c.processes)),c.workspaceMetadata)for(const a of Object.keys(c.workspaceMetadata)){const g=c.workspaceMetadata[a];let b=`${g.fileCount} files`;g.maxFilesReached&&(b=`more than ${b}`),o.push(`Folder (${a}): ${b}`),o.push(this.h(g))}}),o.push(""),o.push(""),o.join(`
`)))}h(r){const t=[];let s=0;const c=(R,j)=>{const U=` ${R}(${j})`;s+U.length>60?(t.push(a),a="|                 ",s=a.length):s+=U.length,a+=U};let a="|      File types:";const g=10,b=r.fileTypes.length>g?g:r.fileTypes.length;for(let R=0;R<b;R++){const j=r.fileTypes[R];c(j.name,j.count)}if(t.push(a),r.configFiles.length>=0&&(a="|      Conf files:",s=0,r.configFiles.forEach(R=>{c(R.name,R.count)}),t.push(a)),r.launchConfigFiles.length>0){let R="|      Launch Configs:";r.launchConfigFiles.forEach(j=>{R+=j.count>1?` ${j.name}(${j.count})`:` ${j.name}`}),t.push(R)}return t.join(`
`)}j(r){const t=Math.max(...Object.keys(r).map(o=>o.length));return Object.keys(r).map(o=>`${o}:  ${" ".repeat(t-o.length)}  ${r[o]}`).join(`
                  `)}k(r){const t=[],o=[];return r.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(t.push(`|  Window (${s.title})`),s.folderURIs.forEach(c=>{const a=I.URI.revive(c);if(a.scheme===A.Schemas.file){const g=a.fsPath;o.push(l(g,["node_modules",".git"]).then(b=>{let R=`${b.fileCount} files`;b.maxFilesReached&&(R=`more than ${R}`),t.push(`|    Folder (${(0,O.basename)(g)}): ${R}`),t.push(this.h(b))}).catch(b=>{t.push(`|      Error: Unable to collect workspace stats for folder ${g} (${b.toString()})`)}))}else t.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(s=>t.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(r,t){const o=new Map;r.windows.forEach(c=>o.set(c.pid,c.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),t&&this.n(r.mainPID,o,s,t,0),s.join(`
`)}n(r,t,o,s,c){const a=c===0;let g;a?g=s.pid===r?`${this.d.applicationName} main`:"remote agent":(g=`${"  ".repeat(c)} ${s.name}`,s.name==="window"&&(g=`${g} (${t.get(s.pid)})`));const b=process.platform==="win32"?s.mem:k.totalmem()*(s.mem/100);o.push(`${s.load.toFixed(0).padStart(5," ")}	${(b/p.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${g}`),Array.isArray(s.children)&&s.children.forEach(R=>this.n(r,t,o,R,c+1))}async getWorkspaceFileExtensions(r){const t=new Set;for(const{uri:o}of r.folders){const s=I.URI.revive(o);if(s.scheme!==A.Schemas.file)continue;const c=s.fsPath;try{(await l(c,["node_modules",".git"])).fileTypes.forEach(g=>t.add(g.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(r){for(const{uri:t}of r.folders){const o=I.URI.revive(t);if(o.scheme!==A.Schemas.file)continue;const s=o.fsPath;try{const c=await l(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),c.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),c.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),c.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};h=pe([Y(0,y.ITelemetryService),Y(1,f.IProductService)],h),e.DiagnosticsService=h}),define(oe[235],ae([0,1,105,3,22,15,2,8,12,49,25,5,6,101,16,167,34,7]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p,f,y,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;let m=class extends O.Disposable{constructor(d,h,n,r,t,o){super(),this.p=d,this.r=h,this.s=n,this.t=o,this.b=new i.Emitter,this.onDidTokenFailed=this.b.event,this.c=new i.Emitter,this.onDidChangeTunnelStatus=this.c.event,this.f=new i.Emitter,this.onDidChangeAccount=this.f.event,this.j=k.TunnelStates.disconnected;const s=l.URI.file((0,I.join)(n.logsPath,k.LOG_FILE_NAME));this.g=this.B(r.createLogger(s,{name:k.LOGGER_NAME})),this.k=new w.Delayer(100),this.B(this.g.onDidChangeLogLevel(c=>this.g.info("Log level changed to "+(0,P.LogLevelToString)(c)))),this.B(t.onWillShutdown(c=>{this.i&&(this.i.cancel(),this.i=void 0),this.dispose()})),this.B(o.onDidChangeConfiguration(c=>{c.affectsConfiguration(k.CONFIGURATION_KEY_HOST_NAME)&&this.k.trigger(()=>this.v())}))}async getAccount(){return this.h}async updateAccount(d){if(d&&this.h?d.token!==this.h.token||d.providerId!==this.h.providerId:d!==this.h){this.h=d,this.f.fire(d),d?this.g.info(`Account updated: ${d.accountLabel} (${d.providerId})`):this.g.info("Account reset"),this.p.publicLog2("remoteTunnel.enablement",{enabled:!!d});try{await this.k.trigger(()=>this.v())}catch(h){this.g.error(h)}}return this.j}u(){if(!this.n){let d;E.isMacintosh?d=this.s.appRoot:d=(0,I.dirname)((0,I.dirname)(this.s.appRoot)),this.n=(0,I.join)(d,"bin",`${this.r.tunnelApplicationName}${E.isWindows?".exe":""}`)}return this.n}async v(){if(this.i&&(this.i.cancel(),this.i=void 0),!this.h){this.w(k.TunnelStates.disconnected);return}const{token:d,providerId:h,accountLabel:n}=this.h;this.w(k.TunnelStates.connecting((0,y.localize)(0,null,n,h)));const r=(a,g)=>{a=a.replaceAll(d,"*".repeat(4)),g?this.g.error(a):this.g.info(a),!this.s.isBuilt&&a.startsWith("   Compiling")&&this.w(k.TunnelStates.connecting((0,y.localize)(1,null)))},t=this.y("login",["user","login","--provider",h,"--access-token",d,"--log",(0,P.LogLevelToString)(this.g.getLevel())],r);this.i=t;try{if(await t,this.i!==t)return}catch(a){this.g.error(a),this.i=void 0,this.b.fire(!0),this.w(k.TunnelStates.disconnected);return}const o=this.z();o?this.w(k.TunnelStates.connecting((0,y.localize)(2,null,o))):this.w(k.TunnelStates.connecting((0,y.localize)(3,null)));const s=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,P.LogLevelToString)(this.g.getLevel())];o?s.push("--name",o):s.push("--random-name");const c=this.y("tunnel",s,(a,g)=>{g?this.g.error(a):this.g.info(a);const b=a.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(b){const R={link:b[1],domain:b[2],hostName:b[4]};this.w(k.TunnelStates.connected(R))}else a.match(/error refreshing token/)&&(c.cancel(),this.b.fire(!0),this.w(k.TunnelStates.disconnected))});this.i=c,c.finally(()=>{c===this.i&&(this.g.info("tunnel process terminated"),this.i=void 0,this.h=void 0,this.w(k.TunnelStates.disconnected))})}async getTunnelStatus(){return this.j}w(d){this.j=d,this.c.fire(d)}y(d,h,n=()=>{}){return(0,w.createCancelablePromise)(r=>new Promise((t,o)=>{r.isCancellationRequested&&t();let s;if(r.onCancellationRequested(()=>{s&&(this.g.info(`${d} terminating(${s.pid})`),s.kill())}),!this.s.isBuilt)n("Building tunnel CLI from sources and run",!1),n(`${d} Spawning: cargo run -- tunnel ${h.join(" ")}`,!1),s=(0,S.spawn)("cargo",["run","--","tunnel",...h],{cwd:(0,I.join)(this.s.appRoot,"cli")});else{n("Running tunnel CLI",!1);const c=this.u();n(`${d} Spawning: ${c} tunnel ${h.join(" ")}`,!1),s=(0,S.spawn)(c,["tunnel",...h],{cwd:(0,v.homedir)()})}s.stdout.on("data",c=>{if(s){const a=c.toString();n(a,!1)}}),s.stderr.on("data",c=>{if(s){const a=c.toString();n(a,!0)}}),s.on("exit",c=>{s&&(n(`${d} exit(${s.pid}): + ${c} `,!1),s=void 0,c===0?t():o())}),s.on("error",c=>{s&&(n(`${d} error(${s.pid}): + ${c} `,!0),s=void 0,o())})}))}async getHostName(){return this.z()}z(){let d=this.t.getValue(k.CONFIGURATION_KEY_HOST_NAME)||(0,v.hostname)();return d=d.replace(/[^\w-]/g,"").substring(0,20),d||void 0}};m=pe([Y(0,D.ITelemetryService),Y(1,C.IProductService),Y(2,A.INativeEnvironmentService),Y(3,P.ILoggerService),Y(4,p.ISharedProcessLifecycleService),Y(5,f.IConfigurationService)],m),e.RemoteTunnelService=m}),define(oe[109],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class k{constructor(A){this.b=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,{eventName:P,data:I}){return this.b.forEach(S=>S.log(P,I)),Promise.resolve(null)}}e.TelemetryAppenderChannel=k;class i{constructor(A){this.b=A}log(A,O){return this.b.call("log",{eventName:A,data:O}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=i}),define(oe[50],ae([0,1,32,14,16,75,108,22]),function(ee,e,k,i,D,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class I{constructor(c){this.value=c}}e.TrustedTelemetryValue=I;class S{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(c,a){return Promise.resolve(void 0)}publicLog2(c,a){return this.publicLog(c,a)}publicLogError(c,a){return Promise.resolve(void 0)}publicLogError2(c,a){return this.publicLogError(c,a)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=S,e.NullTelemetryService=new S;class C{async publicLog(c,a,g){}async publicLogError(c,a,g){}}e.NullEndpointTelemetryService=C,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function E(s,c){return c.onDidChangeConfiguration(a=>{a.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(a.source),configurationKeys:u(a.sourceConfig)})})}e.configurationTelemetry=E;function w(s,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!s.enableTelemetry||c.extensionTestsLocationURI)}e.supportsTelemetry=w;function p(s,c){return!(c.isBuilt||c.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.isLoggingOnly=p;function f(s){const c=s.getValue(P.TELEMETRY_SETTING_ID),a=s.getValue("telemetry.enableCrashReporter");if(s.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||a===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=f;function y(s){const c={},a={},g={};m(s,g);for(let b in g){b=b.length>150?b.substr(b.length-149):b;const R=g[b];typeof R=="number"?a[b]=R:typeof R=="boolean"?a[b]=R?1:0:typeof R=="string"?(R.length>8192&&console.warn(`Telemetry property: ${b} has been trimmed to 8192, the original length is ${R.length}`),c[b]=R.substring(0,8191)):typeof R<"u"&&R!==null&&(c[b]=R)}return{properties:c,measurements:a}}e.validateTelemetryData=y;const v=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function l(s){if(!s)return"none";const c=(0,A.getRemoteName)(s);return v.has(c)?c:"other"}e.cleanRemoteAuthority=l;function m(s,c,a=0,g){if(!!s)for(const b of Object.getOwnPropertyNames(s)){const R=s[b],j=g?g+b:b;Array.isArray(R)?c[j]=(0,k.safeStringify)(R):R instanceof Date?c[j]=R.toISOString():(0,i.isObject)(R)?a<2?m(R,c,a+1,j+"."):c[j]=(0,k.safeStringify)(R):c[j]=R}}function u(s){if(!s)return[];const c=[];return d(c,"",s),c}function d(s,c,a){a&&typeof a=="object"&&!Array.isArray(a)?Object.keys(a).forEach(g=>d(s,c?`${c}.${g}`:g,a[g])):s.push(c)}function h(s,c){const a=s.msftInternalDomains||[],g=c.getValue("telemetry.internalTesting");return(0,O.verifyMicrosoftInternalDomain)(a)||g}e.isInternalTelemetry=h;function n(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.getPiiPathsFromEnvironment=n;function r(s,c){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let a=s;const g=[];for(const U of c)for(;;){const z=U.exec(s);if(!z)break;g.push([z.index,U.lastIndex])}const b=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,R=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let j=0;for(a="";;){const U=R.exec(s);if(!U)break;const z=g.some(([F,L])=>U.index<L&&F<R.lastIndex);!b.test(U[0])&&!z&&(a+=s.substring(j,U.index)+"<REDACTED: user-file-path>",j=R.lastIndex)}return j<s.length&&(a+=s.substr(j)),a}function t(s){if(!s)return s;const c=s.toLowerCase(),a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const g of a)if(g.regex.test(c))return`<REDACTED: ${g.label}>`;return s}function o(s,c){return(0,k.cloneAndChange)(s,a=>{if(a instanceof I)return a.value;if(typeof a=="string"){let g=a.replaceAll("%20"," ");g=r(g,c);for(const b of c)g=g.replace(b,"");return g=t(g),g}})}e.cleanData=o}),define(oe[236],ae([0,1,45,50]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(A,O,P,I,S,C,E){const w={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${O.nameShort})`};if((0,i.supportsTelemetry)(O,P)&&(0,i.getTelemetryLevel)(I)===3){const p=await(0,k.getServiceMachineId)(P,S,C),{machineId:f}=await E.getTelemetryInfo();w["X-Market-User-Id"]=p,w["VSCode-SessionId"]=f||p}return w}e.resolveMarketplaceHeaders=D}),define(oe[237],ae([0,1,9,32,50]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",O="https://mobile.events.data.microsoft.com/ping";async function P(S,C,E){const w=await new Promise((l,m)=>{ee(["@microsoft/1ds-core-js"],l,m)}),p=await new Promise((l,m)=>{ee(["@microsoft/1ds-post-js"],l,m)}),f=new w.AppInsightsCore,y=new p.PostChannel,v={instrumentationKey:S,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[y]]};if(E){v.extensionConfig={};const l={alwaysUseXhrOverride:!0,httpXHROverride:E};v.extensionConfig[y.identifier]=l}return f.initialize(v,[]),f.addTelemetryInitializer(l=>{C&&(l.ext=l.ext??{},l.ext.utc=l.ext.utc??{},l.ext.utc.flags=8462029)}),f}class I{constructor(C,E,w,p,f){this.e=C,this.f=E,this.g=w,this.h=f,this.c=A,this.d=O,this.g||(this.g={}),typeof p=="function"?this.a=p():this.a=p,this.b=null}i(C){if(!!this.a){if(typeof this.a!="string"){C(this.a);return}this.b||(this.b=P(this.a,this.e,this.h)),this.b.then(E=>{C(E)},E=>{(0,k.onUnexpectedError)(E),console.error(E)})}}log(C,E){if(!this.a)return;E=(0,i.mixin)(E,this.g),E=(0,D.validateTelemetryData)(E);const w=this.f+"/"+C;try{this.i(p=>{p.pluginVersionString=E?.properties.version??"Unknown",p.track({name:w,baseData:{name:w,properties:E?.properties,measurements:E?.measurements}})})}catch{}}flush(){return this.a?new Promise(C=>{this.i(E=>{E.unload(!0,()=>{this.a=void 0,C(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=I}),define(oe[110],ae([0,1,2,15,8,50]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let O=class extends k.Disposable{constructor(I,S,C=""){super(),this.b=C;const E=I.getLogger(S.telemetryLogResource);E?this.a=this.B(E):(this.a=this.B(I.createLogger(S.telemetryLogResource)),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(I,S){this.a.trace(`${this.b}telemetry/${I}`,(0,A.validateTelemetryData)(S))}};O=pe([Y(0,D.ILoggerService),Y(1,i.IEnvironmentService)],O),e.TelemetryLogAppender=O}),define(oe[111],ae([0,1,2,32,5,27,170,16,46,103,25,40,22,50]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let f=class{constructor(l,m,u){this.k=m,this.l=u,this.d={},this.i=new k.DisposableStore,this.j=[],this.b=l.appenders,this.c=l.commonProperties||Promise.resolve({}),this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const d of this.f)this.j.push(new RegExp((0,A.escapeRegExpCharacters)(d),"gi")),d.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.escapeRegExpCharacters)(d.replace(/\\/g,"/")),"gi"));this.m(),this.k.onDidChangeConfiguration(this.m,this,this.i)}setExperimentProperty(l,m){this.d[l]=m}m(){let l=(0,p.getTelemetryLevel)(this.k);const m=this.l.enabledTelemetryLevels;if(m){this.h=this.sendErrorTelemetry?m.error:!1;const u=m.usage?3:m.error?2:0;l=Math.min(l,u)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const l=await this.c,m=l.sessionID,u=l["common.machineId"],d=l["common.firstSessionDate"],h=l["common.msftInternal"];return{sessionId:m,machineId:u,firstSessionDate:d,msftInternal:h}}dispose(){this.i.dispose()}n(l,m,u){return this.g<m?Promise.resolve(void 0):this.c.then(d=>{u=(0,i.mixin)(u,this.d),u=(0,p.cleanData)(u,this.j),u=(0,i.mixin)(u,d),this.b.forEach(h=>h.log(l,u))},d=>{console.error(d)})}publicLog(l,m){return this.n(l,3,m)}publicLog2(l,m){return this.publicLog(l,m)}publicLogError(l,m){return this.h?this.n(l,2,m):Promise.resolve(void 0)}publicLogError2(l,m){return this.publicLogError(l,m)}};f.IDLE_START_EVENT_NAME="UserIdleStart",f.IDLE_STOP_EVENT_NAME="UserIdleStop",f=pe([Y(1,P.IConfigurationService),Y(2,C.IProductService)],f),e.TelemetryService=f;function y(){const v=(0,O.localize)(0,null,S.default.nameLong),l=S.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",S.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=D.isWeb?"":(0,O.localize)(3,null),u=(0,O.localize)(4,null),d=(0,O.localize)(5,null),h=(0,O.localize)(6,null),n=(0,O.localize)(7,null),r=`
|       | ${u} | ${d} | ${h} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,O.localize)(8,null);return`
${v} ${l} ${m}

&nbsp;

${n}
${r}

&nbsp;

${t}
`}E.Registry.as(I.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,O.localize)(9,null),properties:{[w.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.Registry.as(I.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[w.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:S.default.privacyStatementUrl?(0,O.localize)(16,null,S.default.nameLong,S.default.privacyStatementUrl):(0,O.localize)(15,null,S.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${w.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[238],ae([0,1,287,237]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class D extends i.AbstractOneDataSystemAppender{constructor(O,P,I,S){const C={sendPOST:(E,w)=>{const p={method:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data)}};try{const f=k.request(E.urlString,p,y=>{y.on("data",function(v){w(y.statusCode??200,y.headers,v.toString())}),y.on("error",function(v){w(0,{})})});f.write(E.data),f.end()}catch{w(0,{})}}};super(O,P,I,S,C)}}e.OneDataSystemAppender=D}),define(oe[239],ae([0,1,24,68,16,15,8,25,22,109,110,111]),function(ee,e,k,i,D,A,O,P,I,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let w=class{constructor(f,y,v,l,m){this.b=f,this.c=y,this.d=v,this.e=l,this.f=m,this.a=new Map}async g(f){if(!this.a.has(f.id)){const{machineId:y,sessionId:v}=await this.c.getTelemetryInfo(),l=Object.create(null);l["common.vscodemachineid"]=y,l["common.vscodesessionid"]=v;const m=[f.id,JSON.stringify(l),f.aiKey],d=new i.Client(k.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),h=[new S.TelemetryAppenderClient(d),new C.TelemetryLogAppender(this.d,this.e,`[${f.id}] `)];this.a.set(f.id,new E.TelemetryService({appenders:h,sendErrorTelemetry:f.sendErrorTelemetry},this.b,this.f))}return this.a.get(f.id)}async publicLog(f,y,v){await(await this.g(f)).publicLog(y,v)}async publicLogError(f,y,v){await(await this.g(f)).publicLogError(y,v)}};w=pe([Y(0,D.IConfigurationService),Y(1,I.ITelemetryService),Y(2,O.ILoggerService),Y(3,A.IEnvironmentService),Y(4,P.IProductService)],w),e.CustomEndpointTelemetryService=w}),define(oe[240],ae([0,1,6,23,3,2,8]),function(ee,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends A.Disposable{constructor(S,C){super(),this.h=C,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new D.Emitter),this.onCreateRequest=this.g.event,this.b=S===void 0?15e3:S}createRequest(S){return new Promise((C,E)=>{const w=++this.a;this.c.set(w,C),this.g.fire({requestId:w,...S});const p=new i.CancellationTokenSource;(0,k.timeout)(this.b,p.token).then(()=>E(`Request ${w} timed out (${this.b}ms)`)),this.f.set(w,[(0,A.toDisposable)(()=>p.cancel())])})}acceptReply(S,C){const E=this.c.get(S);E?(this.c.delete(S),(0,A.dispose)(this.f.get(S)||[]),this.f.delete(S),E(C)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${S}`)}};P=pe([Y(1,O.ILogService)],P),e.RequestStore=P}),define(oe[112],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var i;(function(u){u.Shell="terminal.integrated.shell.",u.ShellArgs="terminal.integrated.shellArgs.",u.DefaultProfile="terminal.integrated.defaultProfile.",u.Profiles="terminal.integrated.profiles."})(i=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(u){u.ShellLinux="terminal.integrated.shell.linux",u.ShellMacOs="terminal.integrated.shell.osx",u.ShellWindows="terminal.integrated.shell.windows",u.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",u.AutomationShellLinux="terminal.integrated.automationShell.linux",u.AutomationShellMacOs="terminal.integrated.automationShell.osx",u.AutomationShellWindows="terminal.integrated.automationShell.windows",u.AutomationProfileLinux="terminal.integrated.automationProfile.linux",u.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",u.AutomationProfileWindows="terminal.integrated.automationProfile.windows",u.ShellArgsLinux="terminal.integrated.shellArgs.linux",u.ShellArgsMacOs="terminal.integrated.shellArgs.osx",u.ShellArgsWindows="terminal.integrated.shellArgs.windows",u.ProfilesWindows="terminal.integrated.profiles.windows",u.ProfilesMacOs="terminal.integrated.profiles.osx",u.ProfilesLinux="terminal.integrated.profiles.linux",u.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",u.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",u.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",u.UseWslProfiles="terminal.integrated.useWslProfiles",u.TabsDefaultColor="terminal.integrated.tabs.defaultColor",u.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",u.TabsEnabled="terminal.integrated.tabs.enabled",u.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",u.TabsHideCondition="terminal.integrated.tabs.hideCondition",u.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",u.TabsShowActions="terminal.integrated.tabs.showActions",u.TabsLocation="terminal.integrated.tabs.location",u.TabsFocusMode="terminal.integrated.tabs.focusMode",u.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",u.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",u.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",u.CopyOnSelection="terminal.integrated.copyOnSelection",u.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",u.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",u.FontFamily="terminal.integrated.fontFamily",u.FontSize="terminal.integrated.fontSize",u.LetterSpacing="terminal.integrated.letterSpacing",u.LineHeight="terminal.integrated.lineHeight",u.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",u.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",u.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",u.BellDuration="terminal.integrated.bellDuration",u.FontWeight="terminal.integrated.fontWeight",u.FontWeightBold="terminal.integrated.fontWeightBold",u.CursorBlinking="terminal.integrated.cursorBlinking",u.CursorStyle="terminal.integrated.cursorStyle",u.CursorWidth="terminal.integrated.cursorWidth",u.Scrollback="terminal.integrated.scrollback",u.DetectLocale="terminal.integrated.detectLocale",u.DefaultLocation="terminal.integrated.defaultLocation",u.GpuAcceleration="terminal.integrated.gpuAcceleration",u.TerminalTitleSeparator="terminal.integrated.tabs.separator",u.TerminalTitle="terminal.integrated.tabs.title",u.TerminalDescription="terminal.integrated.tabs.description",u.RightClickBehavior="terminal.integrated.rightClickBehavior",u.Cwd="terminal.integrated.cwd",u.ConfirmOnExit="terminal.integrated.confirmOnExit",u.ConfirmOnKill="terminal.integrated.confirmOnKill",u.EnableBell="terminal.integrated.enableBell",u.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",u.AllowChords="terminal.integrated.allowChords",u.AllowMnemonics="terminal.integrated.allowMnemonics",u.EnvMacOs="terminal.integrated.env.osx",u.EnvLinux="terminal.integrated.env.linux",u.EnvWindows="terminal.integrated.env.windows",u.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",u.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",u.ShowExitAlert="terminal.integrated.showExitAlert",u.SplitCwd="terminal.integrated.splitCwd",u.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",u.WordSeparators="terminal.integrated.wordSeparators",u.EnableFileLinks="terminal.integrated.enableFileLinks",u.UnicodeVersion="terminal.integrated.unicodeVersion",u.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",u.LocalEchoEnabled="terminal.integrated.localEchoEnabled",u.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",u.LocalEchoStyle="terminal.integrated.localEchoStyle",u.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",u.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",u.CustomGlyphs="terminal.integrated.customGlyphs",u.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",u.InheritEnv="terminal.integrated.inheritEnv",u.ShowLinkHover="terminal.integrated.showLinkHover",u.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",u.AutoReplies="terminal.integrated.autoReplies",u.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",u.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",u.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",u.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",u.SmoothScrolling="terminal.integrated.smoothScrolling"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var A;(function(u){u.FileName="ptyhost"})(A=e.TerminalLogConstants||(e.TerminalLogConstants={}));var O;(function(u){u.PowerShell="pwsh",u.Bash="bash",u.Fish="fish",u.Sh="sh",u.Csh="csh",u.Ksh="ksh",u.Zsh="zsh"})(O=e.PosixShellType||(e.PosixShellType={}));var P;(function(u){u.CommandPrompt="cmd",u.PowerShell="pwsh",u.Wsl="wsl",u.GitBash="gitbash"})(P=e.WindowsShellType||(e.WindowsShellType={}));var I;(function(u){u[u.Api=0]="Api",u[u.Process=1]="Process",u[u.Sequence=2]="Sequence",u[u.Config=3]="Config"})(I=e.TitleEventSource||(e.TitleEventSource={}));var S;(function(u){u.LocalPty="localPty",u.PtyHost="ptyHost",u.Log="log",u.Heartbeat="heartbeat"})(S=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,k.createDecorator)("ptyService");var C;(function(u){u.Cwd="cwd",u.InitialCwd="initialCwd",u.FixedDimensions="fixedDimensions",u.Title="title",u.ShellType="shellType",u.HasChildProcesses="hasChildProcesses",u.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",u.OverrideDimensions="overrideDimensions",u.FailedShellIntegrationActivation="failedShellIntegrationActivation",u.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(C=e.ProcessPropertyType||(e.ProcessPropertyType={}));var E;(function(u){u[u.BeatInterval=5e3]="BeatInterval",u[u.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",u[u.SecondWaitMultiplier=1]="SecondWaitMultiplier",u[u.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E=e.HeartbeatConstants||(e.HeartbeatConstants={}));var w;(function(u){u[u.Panel=1]="Panel",u[u.Editor=2]="Editor"})(w=e.TerminalLocation||(e.TerminalLocation={}));var p;(function(u){u.TerminalView="view",u.Editor="editor"})(p=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(u){u[u.GraceTime=6e4]="GraceTime",u[u.ShortGraceTime=6e3]="ShortGraceTime"})(f=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var y;(function(u){u[u.HighWatermarkChars=1e5]="HighWatermarkChars",u[u.LowWatermarkChars=5e3]="LowWatermarkChars",u[u.CharCountAckSize=5e3]="CharCountAckSize"})(y=e.FlowControlConstants||(e.FlowControlConstants={}));var v;(function(u){u.GitBash="Git Bash",u.Pwsh="PowerShell"})(v=e.ProfileSource||(e.ProfileSource={}));var l;(function(u){u[u.Off=0]="Off",u[u.FinalTerm=1]="FinalTerm",u[u.VSCode=2]="VSCode"})(l=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var m;(function(u){u[u.Unknown=0]="Unknown",u[u.Shutdown=1]="Shutdown",u[u.Process=2]="Process",u[u.User=3]="User",u[u.Extension=4]="Extension"})(m=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(oe[241],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,k.createDecorator)("localPtyService")}),define(oe[242],ae([0,1,34,24,32,12,5,36,27,14,28]),function(ee,e,k,i,D,A,O,P,I,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function E(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(k.release());let n=0;return h&&h.length===4&&(n=parseInt(h[3])),n}e.getWindowsBuildNumber=E;async function w(h,n,r,t=P.env,o=C.Promises.exists){if(A.isAbsolute(h))return await o(h)?h:void 0;if(n===void 0&&(n=P.cwd()),A.dirname(h)!=="."){const g=A.join(n,h);return await o(g)?g:void 0}const c=(0,D.getCaseInsensitive)(t,"PATH");if(r===void 0&&(0,S.isString)(c)&&(r=c.split(A.delimiter)),r===void 0||r.length===0){const g=A.join(n,h);return await o(g)?g:void 0}for(const g of r){let b;if(A.isAbsolute(g)?b=A.join(g,h):b=A.join(n,g,h),await o(b))return b;if(O.isWindows){let R=b+".com";if(await o(R)||(R=b+".exe",await o(R)))return R}}const a=A.join(n,h);return await o(a)?a:void 0}e.findExecutable=w;function p(h,n,r,t,o){if(!n.shellIntegration.enabled||!h.executable||h.isFeatureTerminal||h.hideFromUser||h.ignoreShellIntegration||O.isWindows&&!n.windowsEnableConpty)return;const s=h.args,c=P.platform==="win32"?A.basename(h.executable).toLowerCase():A.basename(h.executable),a=A.dirname(i.FileAccess.asFileUri("").fsPath);let g;const b={VSCODE_INJECTION:"1"};if(O.isWindows){if(c==="pwsh.exe"||c==="powershell.exe")return!s||u(s)?g=y.get(f.WindowsPwsh):m(s)&&(g=y.get(f.WindowsPwshLogin)),g?(g=[...g],g[g.length-1]=(0,I.format)(g[g.length-1],a,""),{newArgs:g,envMixin:b}):void 0;t.warn(`Shell integration cannot be enabled for executable "${h.executable}" and args`,h.args);return}switch(c){case"bash":return!s||s.length===0?g=y.get(f.Bash):d(s)&&(b.VSCODE_SHELL_LOGIN="1",g=y.get(f.Bash)),g?(g=[...g],g[g.length-1]=(0,I.format)(g[g.length-1],a),{newArgs:g,envMixin:b}):void 0;case"pwsh":return!s||u(s)?g=y.get(f.Pwsh):m(s)&&(g=y.get(f.PwshLogin)),g?(g=[...g],g[g.length-1]=(0,I.format)(g[g.length-1],a,""),{newArgs:g,envMixin:b}):void 0;case"zsh":{if(!s||s.length===0?g=y.get(f.Zsh):d(s)?g=y.get(f.ZshLogin):(s===y.get(f.Zsh)||s===y.get(f.ZshLogin))&&(g=s),!g)return;g=[...g],g[g.length-1]=(0,I.format)(g[g.length-1],a);const R=A.join(k.tmpdir(),`${k.userInfo().username}-${o.applicationName}-zsh`);b.ZDOTDIR=R;const j=r?.ZDOTDIR??k.homedir()??"~";b.USER_ZDOTDIR=j;const U=[];return U.push({source:A.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:A.join(R,".zshrc")}),U.push({source:A.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:A.join(R,".zprofile")}),U.push({source:A.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:A.join(R,".zshenv")}),U.push({source:A.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:A.join(R,".zlogin")}),{newArgs:g,envMixin:b,filesToCopy:U}}}t.warn(`Shell integration cannot be enabled for executable "${h.executable}" and args`,h.args)}e.getShellIntegrationInjection=p;var f;(function(h){h.WindowsPwsh="windows-pwsh",h.WindowsPwshLogin="windows-pwsh-login",h.Pwsh="pwsh",h.PwshLogin="pwsh-login",h.Zsh="zsh",h.ZshLogin="zsh-login",h.Bash="bash"})(f||(f={}));const y=new Map;y.set(f.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),y.set(f.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),y.set(f.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),y.set(f.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),y.set(f.Zsh,["-i"]),y.set(f.ZshLogin,["-il"]),y.set(f.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const v=["-login","-l"],l=["-nol","-nologo"];function m(h){return typeof h=="string"?v.includes(h.toLowerCase()):h.length===1&&v.includes(h[0].toLowerCase())||h.length===2&&(v.includes(h[0].toLowerCase())||v.includes(h[1].toLowerCase()))&&(l.includes(h[0].toLowerCase())||l.includes(h[1].toLowerCase()))}function u(h){return typeof h=="string"?l.includes(h.toLowerCase()):h.length===0||h?.length===1&&l.includes(h[0].toLowerCase())}function d(h){return h==="string"&&v.includes(h.toLowerCase())||typeof h!="string"&&h.length===1&&v.includes(h[0].toLowerCase())}}),define(oe[243],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var k;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST_DARK="hcDark",A.HIGH_CONTRAST_LIGHT="hcLight"})(k=e.ColorScheme||(e.ColorScheme={}));function i(A){return A===k.HIGH_CONTRAST_DARK||A===k.HIGH_CONTRAST_LIGHT}e.isHighContrast=i;function D(A){return A===k.DARK||A===k.HIGH_CONTRAST_DARK}e.isDark=D}),define(oe[113],ae([0,1,51,3,2,4,40,243]),function(ee,e,k,i,D,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var I;(function(v){function l(m){return m&&typeof m=="object"&&typeof m.id=="string"}v.isThemeColor=l})(I=e.ThemeColor||(e.ThemeColor={}));function S(v){return{id:v}}e.themeColorFromId=S;var C;(function(v){function l(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color>"u"||I.isThemeColor(o.color))}v.isThemeIcon=l;const m=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function u(o){const s=m.exec(o);if(!s)return;const[,c]=s;return{id:c}}v.fromString=u;function d(o){return{id:o}}v.fromId=d;function h(o,s){let c=o.id;const a=c.lastIndexOf("~");return a!==-1&&(c=c.substring(0,a)),s&&(c=`${c}~${s}`),{id:c}}v.modify=h;function n(o){const s=o.id.lastIndexOf("~");if(s!==-1)return o.id.substring(s+1)}v.getModifier=n;function r(o,s){return o.id===s.id&&o.color?.id===s.color?.id}v.isEqual=r;function t(o,s){return{id:o.id,color:s?S(s):void 0}}v.asThemeIcon=t,v.asClassNameArray=k.CSSIcon.asClassNameArray,v.asClassName=k.CSSIcon.asClassName,v.asCSSSelector=k.CSSIcon.asCSSSelector})(C=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function E(v){switch(v){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class w{constructor(){this.a=[],this.a=[],this.b=new i.Emitter}onColorThemeChange(l){return this.a.push(l),this.b.fire(l),(0,D.toDisposable)(()=>{const m=this.a.indexOf(l);this.a.splice(m,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const p=new w;O.Registry.add(e.Extensions.ThemingContribution,p);function f(v){return p.onColorThemeChange(v)}e.registerThemingParticipant=f;class y extends D.Disposable{constructor(l){super(),this.k=l,this.h=l.getColorTheme(),this.B(this.k.onDidColorThemeChange(m=>this.n(m)))}n(l){this.h=l,this.updateStyles()}updateStyles(){}w(l,m){let u=this.h.getColor(l);return u&&m&&(u=m(u,this.h)),u?u.toString():null}}e.Themable=y}),define(oe[244],ae([0,1,51,7,172,113]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function O(w,p){const f=[{name:null,description:(0,D.localize)(0,null)}];return f.push(...w.map(y=>({name:y.profileName,description:P(y)}))),p&&f.push(...p.map(y=>({name:y.title,description:I(y)}))),{values:f.map(y=>y.name),markdownDescriptions:f.map(y=>y.description)}}e.createProfileSchemaEnums=O;function P(w){let p=`$(${A.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:k.Codicon.terminal.id}) ${w.profileName}
- path: ${w.path}`;return w.args&&(typeof w.args=="string"?p+=`
- args: "${w.args}"`:p+=`
- args: [${w.args.length===0?"":`'${w.args.join("','")}'`}]`),w.overrideName!==void 0&&(p+=`
- overrideName: ${w.overrideName}`),w.color&&(p+=`
- color: ${w.color}`),w.env&&(p+=`
- env: ${JSON.stringify(w.env)}`),p}function I(w){return`$(${A.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:k.Codicon.terminal.id}) ${w.title}
- extensionIdentifier: ${w.extensionIdentifier}`}function S(w,p){if(!w&&!p)return!0;if(typeof w=="string"&&typeof p=="string")return w===p;if(Array.isArray(w)&&Array.isArray(p)){if(w.length!==p.length)return!1;for(let f=0;f<w.length;f++)if(w[f]!==p[f])return!1;return!0}return!1}e.terminalProfileArgsMatch=S;function C(w,p){if(!w&&!p)return!0;if(!w||!p)return!1;if(A.ThemeIcon.isThemeIcon(w)&&A.ThemeIcon.isThemeIcon(p))return w.id===p.id&&w.color===p.color;if(typeof w=="object"&&"light"in w&&"dark"in w&&typeof p=="object"&&"light"in p&&"dark"in p){const f=w,y=p;if((i.URI.isUri(f.light)||E(f.light))&&(i.URI.isUri(f.dark)||E(f.dark))&&(i.URI.isUri(y.light)||E(y.light))&&(i.URI.isUri(y.dark)||E(y.dark)))return f.light.path===y.light.path&&f.dark.path===y.dark.path}if(i.URI.isUri(w)&&i.URI.isUri(p)||E(w)||E(p)){const f=w,y=p;return f.path===y.path&&f.scheme===y.scheme}return!1}e.terminalIconsEqual=C;function E(w){return w?typeof w.path=="string"&&typeof w.scheme=="string":!1}e.isUriComponents=E}),define(oe[245],ae([0,1,51,171,46,40,244]),function(ee,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(k.Codicon.getAll(),d=>d.id),markdownEnumDescriptions:Array.from(k.Codicon.getAll(),d=>`$(${d.id})`)};const P={args:{description:(0,i.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,i.localize)(1,null),type:"boolean"},icon:{description:(0,i.localize)(2,null),...e.terminalIconSchema},color:{description:(0,i.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,i.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},I={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},S={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(6,null),type:["string"],items:{type:"string"}},...P}},C=(0,i.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),E=(0,i.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),w=(0,i.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),p=(0,i.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),f=(0,i.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),y=(0,i.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),v={id:"terminal",order:100,title:(0,i.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,i.localize)(26,null)}},{type:"string",markdownDescription:(0,i.localize)(27,null)}],default:[],markdownDeprecationMessage:w},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,i.localize)(29,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(30,null),type:"string"},id:{description:(0,i.localize)(31,null),type:"string"},title:{description:(0,i.localize)(32,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(34,null),type:"string"},id:{description:(0,i.localize)(35,null),type:"string"},title:{description:(0,i.localize)(36,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(38,null),type:"string"},id:{description:(0,i.localize)(39,null),type:"string"},title:{description:(0,i.localize)(40,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.useWslProfiles"]:{description:(0,i.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,i.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,i.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,i.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,i.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function l(){A.Registry.as(D.Extensions.Configuration).registerConfiguration(v),u()}e.registerTerminalPlatformConfiguration=l;let m;function u(d,h){const n=A.Registry.as(D.Extensions.Configuration);let r;d&&(r=(0,O.createProfileSchemaEnums)(d?.profiles,h));const t=m;m={id:"terminal",order:100,title:(0,i.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:d?.os===3?r?.values:void 0,markdownEnumDescriptions:d?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:d?.os===2?r?.values:void 0,markdownEnumDescriptions:d?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:d?.os===1?r?.values:void 0,markdownEnumDescriptions:d?.os===1?r?.markdownDescriptions:void 0}}},n.updateConfigurations({add:[m],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=u}),define(oe[246],ae([0,1,49,51,12,5,28,90,242,113]),function(ee,e,k,i,D,A,O,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let C,E=!0;function w(r,t,o,s,c=process.env,a,g,b,R){return a=a||{existsFile:O.SymlinkSupport.existsFile,readFile:O.Promises.readFile},A.isWindows?p(o,a,c,g,s.getValue("terminal.integrated.useWslProfiles")!==!1,r&&typeof r=="object"?{...r}:s.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:s.getValue("terminal.integrated.defaultProfile.windows"),R,b):d(a,g,o,r&&typeof r=="object"?{...r}:s.getValue(A.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:s.getValue(A.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),R,b,c)}e.detectAvailableProfiles=w;async function p(r,t,o,s,c,a,g,b,R){const j=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),U=`${process.env.windir}\\${j?"Sysnative":"System32"}`;let z=!1;(0,I.getWindowsBuildNumber)()>=16299&&(z=!0),await v(b);const F=new Map;r&&(F.set("PowerShell",{source:"PowerShell",icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),F.set("Windows PowerShell",{path:`${U}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),F.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),F.set("Command Prompt",{path:`${U}\\cmd.exe`,icon:i.Codicon.terminalCmd,isAutoDetected:!0})),h(a,F);const L=await f(F.entries(),g,t,o,s,R);if(r||c)try{const M=await m(`${U}\\${z?"wsl":"bash"}.exe`,g);for(const $ of M)(!a||!($.profileName in a))&&L.push($)}catch{E&&(s?.info("WSL is not installed, so could not detect WSL profiles"),E=!1)}return L}async function f(r,t,o,s=process.env,c,a){const g=[];for(const[b,R]of r){if(R===null)continue;let j,U,z;if("source"in R){const M=C?.get(R.source);if(!M)continue;j=M.paths,U=R.args||M.args,R.icon?z=y(R.icon):M.icon&&(z=M.icon)}else j=Array.isArray(R.path)?R.path:[R.path],U=A.isWindows||Array.isArray(R.args)?R.args:void 0,z=y(R.icon);const F=await a?.(j)||j.slice(),L=await n(b,t,F,o,s,U,R.env,R.overrideName,R.isAutoDetected,c);L?(L.isAutoDetected=R.isAutoDetected,L.icon=z,L.color=R.color,g.push(L)):c?.debug("Terminal profile not validated",b,j)}return c?.debug("Validated terminal profiles",g),g}function y(r){return typeof r=="string"?{id:r}:r}async function v(r){C&&!r||(C=new Map,C.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login","-i"]}),C.set("PowerShell",{profileName:"PowerShell",paths:r||await l(),icon:S.ThemeIcon.asThemeIcon(i.Codicon.terminalPowershell)}))}async function l(){const r=[];for await(const t of(0,P.enumeratePowerShellInstallations)())r.push(t.exePath);return r}async function m(r,t){const o=[],s=await new Promise((g,b)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(R,j)=>{if(R)return b("Problem occurred when getting wsl distros");g(j)})});if(!s)return[];const c=new RegExp(/[\r?\n]/),a=s.split(c).filter(g=>g.trim().length>0&&g!=="");for(const g of a){if(g===""||g.startsWith("docker-desktop"))continue;const b=`${g} (WSL)`,R={profileName:b,path:r,args:["-d",`${g}`],isDefault:b===t,icon:u(g),isAutoDetected:!1};o.push(R)}return o}function u(r){return r.includes("Ubuntu")?S.ThemeIcon.asThemeIcon(i.Codicon.terminalUbuntu):r.includes("Debian")?S.ThemeIcon.asThemeIcon(i.Codicon.terminalDebian):S.ThemeIcon.asThemeIcon(i.Codicon.terminalLinux)}async function d(r,t,o,s,c,a,g,b){const R=new Map;if(o){const j=(await r.readFile("/etc/shells")).toString(),U=a||j.split(`
`).filter(F=>F.trim().indexOf("#")!==0&&F.trim().length>0),z=new Map;for(const F of U){let L=(0,D.basename)(F),M=z.get(L)||0;M++,M>1&&(L=`${L} (${M})`),z.set(L,M),R.set(L,{path:F,isAutoDetected:!0})}}return h(s,R),await f(R.entries(),c,r,b,t,g)}function h(r,t){if(!!r)for(const[o,s]of Object.entries(r))s===null||!("path"in s)&&!("source"in s)?t.delete(o):(s.icon=s.icon||t.get(o)?.icon,t.set(o,s))}async function n(r,t,o,s,c,a,g,b,R,j){if(o.length===0)return Promise.resolve(void 0);const U=o.shift();if(U==="")return n(r,t,o,s,c,a,g,b,R);const z={profileName:r,path:U,args:a,env:g,overrideName:b,isAutoDetected:R,isDefault:r===t};if((0,D.basename)(U)===U){const L=c.PATH?c.PATH.split(D.delimiter):void 0,M=await(0,I.findExecutable)(U,void 0,L,void 0,s.existsFile);return M?(z.path=M,z.isFromPath=!0,z):n(r,t,o,s,c,a)}return await s.existsFile((0,D.normalize)(U))?z:n(r,t,o,s,c,a,g,b,R)}}),define(oe[247],ae([0,1,3,2,24,5,39,68,16,15,94,232,8,102,240,112,245,246]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p,f,y,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var m;(function(h){h[h.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let u=0,d=class extends i.Disposable{constructor(n,r,t,o){super(),this.C=n,this.D=r,this.F=t,this.G=o,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new k.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new k.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new k.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new k.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new k.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new k.Emitter),this.onProcessData=this.s.event,this.t=this.B(new k.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new k.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new k.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new k.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new k.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new k.Emitter),this.onProcessExit=this.z.event,(0,v.registerTerminalPlatformConfiguration)(),this.c=this.J(),this.B((0,i.toDisposable)(()=>this.M())),this.f=this.B(new f.RequestStore(void 0,this.G)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.L(),this.B(this.D.onDidChangeConfiguration(async s=>{s.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.I()}))}initialize(){this.I()}get H(){return this.D.getValue("terminal.integrated.ignoreProcessNames")}async I(){return this.b.refreshIgnoreProcessNames?.(this.H)}async J(){if(A.isWindows)return process.env;try{return await(0,E.getResolvedShellEnv)(this.G,{_:[]},process.env)}catch(n){return this.G.error("ptyHost was unable to resolve shell environment",n),{}}}L(){const n={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.F.logsPath],env:{VSCODE_LAST_PTY_ID:u,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},r=(0,C.parsePtyHostPort)(this.F.args,this.F.isBuilt);r&&(r.break&&r.port?n.debugBrk=r.port:!r.break&&r.port&&(n.debug=r.port));const t=new P.Client(D.FileAccess.asFileUri("bootstrap-fork").fsPath,n);this.m.fire(),O.ProxyChannel.toService(t.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.N()),this.N(),this.B(t.onDidProcessExit(a=>{this.l.fire(a.code),this.i||(this.g<=m.MaxRestarts?(this.G.error(`ptyHost terminated unexpectedly with code ${a.code}`),this.g++,this.restartPtyHost()):this.G.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const s=t.getChannel(y.TerminalIpcChannels.Log);p.LogLevelChannelClient.setLevel(s,this.G.getLevel()),this.B(this.G.onDidChangeLogLevel(()=>{p.LogLevelChannelClient.setLevel(s,this.G.getLevel())}));const c=O.ProxyChannel.toService(t.getChannel(y.TerminalIpcChannels.PtyHost));return this.B(c.onProcessData(a=>this.s.fire(a))),this.B(c.onProcessReady(a=>this.t.fire(a))),this.B(c.onProcessExit(a=>this.z.fire(a))),this.B(c.onDidChangeProperty(a=>this.y.fire(a))),this.B(c.onProcessReplay(a=>this.u.fire(a))),this.B(c.onProcessOrphanQuestion(a=>this.v.fire(a))),this.B(c.onDidRequestDetach(a=>this.w.fire(a))),[t,c]}dispose(){this.i=!0,super.dispose()}async createProcess(n,r,t,o,s,c,a,g,b,R,j){const U=setTimeout(()=>this.Q(),y.HeartbeatConstants.CreateProcessTimeout),z=await this.b.createProcess(n,r,t,o,s,c,a,g,b,R,j);return clearTimeout(U),u=Math.max(u,z),z}updateTitle(n,r,t){return this.b.updateTitle(n,r,t)}updateIcon(n,r,t,o){return this.b.updateIcon(n,r,t,o)}attachToProcess(n){return this.b.attachToProcess(n)}detachFromProcess(n,r){return this.b.detachFromProcess(n,r)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(n){return this.b.start(n)}shutdown(n,r){return this.b.shutdown(n,r)}input(n,r){return this.b.input(n,r)}processBinary(n,r){return this.b.processBinary(n,r)}resize(n,r,t){return this.b.resize(n,r,t)}acknowledgeDataEvent(n,r){return this.b.acknowledgeDataEvent(n,r)}setUnicodeVersion(n,r){return this.b.setUnicodeVersion(n,r)}getInitialCwd(n){return this.b.getInitialCwd(n)}getCwd(n){return this.b.getCwd(n)}getLatency(n){return this.b.getLatency(n)}orphanQuestionReply(n){return this.b.orphanQuestionReply(n)}installAutoReply(n,r){return this.b.installAutoReply(n,r)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(n){return this.b.uninstallAutoReply(n)}getDefaultSystemShell(n){return this.b.getDefaultSystemShell(n)}async getProfiles(n,r,t,o=!1){const s=await this.c;return(0,l.detectAvailableProfiles)(r,t,o,this.D,s,void 0,this.G,this.S.bind(this,n))}getEnvironment(){return this.b.getEnvironment()}getWslPath(n){return this.b.getWslPath(n)}getRevivedPtyNewId(n){return this.b.getRevivedPtyNewId(n)}setTerminalLayoutInfo(n){return this.b.setTerminalLayoutInfo(n)}async getTerminalLayoutInfo(n){return await this.b.getTerminalLayoutInfo(n)}async requestDetachInstance(n,r){return this.b.requestDetachInstance(n,r)}async acceptDetachInstanceReply(n,r){return this.b.acceptDetachInstanceReply(n,r)}async freePortKillProcess(n){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(n)}async serializeTerminalState(n){return this.b.serializeTerminalState(n)}async reviveTerminalProcesses(n,r){return this.b.reviveTerminalProcesses(n,r)}async refreshProperty(n,r){return this.b.refreshProperty(n,r)}async updateProperty(n,r,t){return this.b.updateProperty(n,r,t)}async restartPtyHost(){this.h=!0,this.M(),[this.a,this.b]=this.L()}M(){this.b.shutdownAll?.(),this.a.dispose()}N(){this.R(),this.j=setTimeout(()=>this.O(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}O(){this.G.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.P(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}P(){this.G.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}Q(){this.R(),this.G.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}R(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}S(n,r){return this.f.createRequest({workspaceId:n,originalText:r})}async acceptPtyHostResolvedVariables(n,r){this.f.acceptReply(n,r)}};d=pe([Y(1,I.IConfigurationService),Y(2,S.IEnvironmentService),Y(3,w.ILogService)],d),e.PtyHostService=d}),define(oe[77],ae([0,1,3,16,4,8]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var O;(function(y){y.Http="http",y.Https="https"})(O=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(y){y.ConstantPrivate="constantPrivate",y.Private="private",y.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var I;(function(y){y[y.Notify=1]="Notify",y[y.OpenBrowser=2]="OpenBrowser",y[y.OpenPreview=3]="OpenPreview",y[y.Silent=4]="Silent",y[y.Ignore=5]="Ignore",y[y.OpenBrowserOnce=6]="OpenBrowserOnce"})(I=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function S(y){if(y.scheme!=="http"&&y.scheme!=="https")return;const v=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(y.authority);if(!!v)return{address:v[1],port:+v[2]}}e.extractLocalHostUriMetaDataForPortMapping=S,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(y){return e.LOCALHOST_ADDRESSES.indexOf(y)>=0}e.isLocalhost=C,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(y){return e.ALL_INTERFACES_ADDRESSES.indexOf(y)>=0}e.isAllInterfaces=E;function w(y,v,l,m){if(l===1)return!1;if(l===2&&E(v)){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(u?.length===4&&parseInt(u[1])>=18)return!1}return y<1024}e.isPortPrivileged=w;class p{constructor(v,l,m){this.remoteAddress=v,this.localAddress=l,this.b=m,this.a=new k.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=p;let f=class{constructor(v,l){this.i=v,this.j=l,this.a=new k.Emitter,this.onTunnelOpened=this.a.event,this.b=new k.Emitter,this.onTunnelClosed=this.b.event,this.c=new k.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const v=this.j.getValue("remote.localPortHost");return!v||v==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(v){return this.e=v,v?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(v){this.f=v.elevation,this.g=v.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const v=[],l=Array.from(this.d.values());for(const m of l){const u=Array.from(m.values());for(const d of u){const h=await d.value;h&&v.push(h)}}return v}async dispose(){for(const v of this.d.values()){for(const{value:l}of v.values())await l.then(m=>m?.dispose());v.clear()}this.d.clear()}setEnvironmentTunnel(v,l,m,u,d){this.o(v,l,Promise.resolve({tunnelRemoteHost:v,tunnelRemotePort:l,localAddress:m,privacy:u,protocol:d,dispose:()=>Promise.resolve()}))}async getExistingTunnel(v,l){(E(v)||C(v))&&(v=e.LOCALHOST_ADDRESSES[0]);const m=this.q(v,l);if(m)return++m.refcount,m.value}openTunnel(v,l,m,u,d=!1,h,n){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${m} on local port ${u}.`),!v)return;if(l||(l="localhost"),this.e&&this.h.has(m)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(v,l,m,u,d,h,n);return r?r.then(t=>{if(!t){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(l,m);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.m(t);return(t.tunnelRemoteHost!==l||t.tunnelRemotePort!==m)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(o),o}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(v){return{tunnelRemotePort:v.tunnelRemotePort,tunnelRemoteHost:v.tunnelRemoteHost,tunnelLocalPort:v.tunnelLocalPort,localAddress:v.localAddress,privacy:v.privacy,protocol:v.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${v.tunnelRemoteHost}:${v.tunnelRemotePort} `);const l=this.d.get(v.tunnelRemoteHost);if(l){const m=l.get(v.tunnelRemotePort);m&&(m.refcount--,await this.n(v.tunnelRemoteHost,v.tunnelRemotePort,m))}}}}async n(v,l,m){if(m.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${v}:${l}.`);const u=m.value.then(async d=>{d&&(await d.dispose(!0),this.b.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this.d.has(v)&&this.d.get(v).delete(l),u}}async closeTunnel(v,l){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${v}:${l} `);const m=this.d.get(v);if(m&&m.has(l)){const u=m.get(l);u.refcount=0,await this.n(v,l,u)}}o(v,l,m){this.d.has(v)||this.d.set(v,new Map),this.d.get(v).set(l,{refcount:1,value:m})}async p(v,l){const m=this.d.get(v);m&&(await m.get(l)||m.delete(l),m.size===0&&this.d.delete(v))}q(v,l){const m=[v];C(v)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):E(v)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const u=m.map(d=>this.d.get(d));for(const d of u){const h=d?.get(l);if(h)return h}}canTunnel(v){return!!S(v)}s(v,l,m,u,d,h,n){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${m} on local port ${u}.`);const r=m;this.h.add(r);const t=u===void 0?m:u,o={elevationRequired:d?this.isPortPrivileged(t):!1},s={remoteAddress:{host:l,port:m},localAddressPort:u,privacy:h,public:h?h!==P.Private:void 0,protocol:n},c=v.forwardPort(s,o);return c?(this.o(l,m,c),c.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(r)})):this.h.delete(r),c}};f=pe([Y(0,A.ILogService),Y(1,i.IConfigurationService)],f),e.AbstractTunnelService=f}),define(oe[248],ae([0,1,8,77,2,9,6]),function(ee,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends D.Disposable{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.DeferredPromise),this.b.p)}setAddress(C){this.a=C,this.b&&(this.b.complete(C),this.b=null)}setTunnel(C){this.B(C)}}let I=class kt extends D.Disposable{constructor(C,E){super(),this.f=C,this.g=E,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(C=>C.dispose())}async createTunnel(){return{id:String(++kt.a)}}async startTunnel(C,E,w,p,f,y){const v=new P,l=await Promise.resolve(this.f.openTunnel(C,v,w,p,f,y));if(!l)throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${w}:${p} (remote).`),v.dispose(),new Error("Could not create tunnel");if(this.c.has(E))throw this.c.delete(E),v.dispose(),await l.dispose(),(0,A.canceled)();return v.setTunnel(l),this.b.set(E,v),this.g.info(`[SharedProcessTunnelService] Created tunnel ${E}: ${l.localAddress} (local) to ${w}:${p} (remote).`),{tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress}}async setAddress(C,E){const w=this.b.get(C);!w||w.setAddress(E)}async destroyTunnel(C){const E=this.b.get(C);if(E){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${C}.`),this.b.delete(C),await E.dispose();return}this.c.add(C)}};I.a=0,I=pe([Y(0,i.ISharedTunnelsService),Y(1,k.ILogService)],I),e.SharedProcessTunnelService=I}),define(oe[249],ae([0,1,86,34,130,224,6,2,16,8,25,222,77,107,5]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function y(d,h,n,r,t){let o;for(let s=3;s&&(o?.dispose(),o=await new v(d,h,n,r,t).waitForReady(),!(t&&D.BROWSER_RESTRICTED_PORTS[t]||!D.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));s--);return o}class v extends P.Disposable{constructor(h,n,r,t,o){super(),this.j=n,this.k=o,this.privacy=w.TunnelPrivacyId.Private,this.i=new Map,this.a=h,this.b=k.createServer(),this.c=new O.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=s=>this.l(s),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(n=>{n()})}async waitForReady(){const h=this.k??this.tunnelRemotePort,n=(0,w.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let r=await(0,D.findFreePortFaster)(h,2,1e3,n),t=null;return this.b.listen(r,this.j),await this.c.wait(),t=this.b.address(),t||(r=0,this.b.listen(r,this.j),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async l(h){h.pause();const n=(0,w.isLocalhost)(this.tunnelRemoteHost)||(0,w.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,E.connectRemoteAgentTunnel)(this.a,n,this.tunnelRemotePort),t=r.getSocket().socket,o=r.readEntireBuffer();r.dispose(),o.byteLength>0&&h.write(o.buffer),h.on("end",()=>{h.localAddress&&this.i.delete(h.localAddress),t.end()}),h.on("close",()=>t.end()),h.on("error",()=>{h.localAddress&&this.i.delete(h.localAddress),t.destroy()}),t.on("end",()=>h.end()),t.on("close",()=>h.end()),t.on("error",()=>{h.destroy()}),h.pipe(t),t.pipe(h),h.localAddress&&this.i.set(h.localAddress,()=>{h.end(),t.end()})}}let l=class extends w.AbstractTunnelService{constructor(h,n,r,t,o){super(n,o),this.t=h,this.u=r,this.v=t}isPortPrivileged(h){return(0,w.isPortPrivileged)(h,this.k,f.OS,i.release())}r(h,n,r,t,o,s,c){const a=this.q(n,r);if(a)return++a.refcount,a.value;if(this.e)return this.s(this.e,n,r,t,o,s,c);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${r} on local port ${t}.`);const g={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:h,signService:this.u,logService:this.i,ipcLogger:null},b=y(g,this.k,n,r,t);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(n,r,b),b}}};l=pe([Y(1,S.ILogService),Y(2,p.ISignService),Y(3,C.IProductService),Y(4,I.IConfigurationService)],l),e.BaseTunnelService=l;let m=class extends l{constructor(h,n,r,t){super(A.nodeSocketFactory,h,n,r,t)}};m=pe([Y(0,S.ILogService),Y(1,p.ISignService),Y(2,C.IProductService),Y(3,I.IConfigurationService)],m),e.TunnelService=m;let u=class extends P.Disposable{constructor(h,n,r,t){super(),this.b=h,this.c=n,this.f=r,this.g=t,this.a=new Map}async openTunnel(h,n,r,t,o,s,c,a){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${t} on local port ${o}.`),!this.a.has(h)){const g=new m(this.b,this.f,this.c,this.g);this.B(g),this.a.set(h,g),g.onTunnelClosed(async()=>{(await g.tunnels).length===0&&(g.dispose(),this.a.delete(h))})}return this.a.get(h).openTunnel(n,r,t,o,s,c,a)}};u=pe([Y(0,S.ILogService),Y(1,C.IProductService),Y(2,p.ISignService),Y(3,I.IConfigurationService)],u),e.SharedTunnelsService=u}),define(oe[30],ae([0,1,4]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(oe[250],ae([0,1,30,71,13,21,128,3,2]),function(ee,e,k,i,D,A,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class S{constructor(w){this.uri=w,this.time=S._clock++}touch(){return this.time=S._clock++,this}}S._clock=0;let C=class{constructor(w){this.g=w,this.c=new I.DisposableStore,this.f=2**16;const p=new Map,f=y=>{let v=p.get(y.scheme);return v===void 0&&(v=w.hasProvider(y)&&!this.g.hasCapability(y,1024),p.set(y.scheme,v)),v};this.c.add(P.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(y=>{p.delete(y.scheme)})),this.extUri=new A.ExtUri(f),this.d=new O.SkipList((y,v)=>this.extUri.compare(y,v,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(w){this.g.hasProvider(w)&&(w=(0,A.normalizePath)(w));const p=this.d.get(w);return p?p.touch().uri.with({fragment:w.fragment}):(this.d.set(w,new S(w)),this.h(),w)}h(){if(this.d.size<this.f)return;const w=[...this.d.entries()].sort((f,y)=>f[1].touch<y[1].touch?1:f[1].touch>y[1].touch?-1:0);S._clock=0,this.d.clear();const p=this.f*.5;for(let f=0;f<p;f++)this.d.set(w[f][0],w[f][1].touch())}};C=pe([Y(0,D.IFileService)],C),e.UriIdentityService=C,(0,i.registerSingleton)(k.IUriIdentityService,C,1)}),define(oe[251],ae([0,1,3,2,13,44,48,17]),function(ee,e,k,i,D,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class I extends i.Disposable{get capabilities(){return this.f.capabilities&-5}constructor(C,E,w,p){super(),this.c=C,this.f=E,this.g=w,this.h=p,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new k.Emitter),this.onDidChangeFile=this.a.event,this.b=O.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(f=>this.i(f)))}watch(C,E){this.b.set(C,C);const w=this.f.watch(this.j(C),E);return(0,i.toDisposable)(()=>{this.b.delete(C),w.dispose()})}stat(C){return this.f.stat(this.j(C))}mkdir(C){return this.f.mkdir(this.j(C))}rename(C,E,w){return this.f.rename(this.j(C),this.j(E),w)}readFile(C){return this.f.readFile(this.j(C),{atomic:!0})}readFileStream(C,E,w){const p=(0,A.newWriteableStream)(f=>P.VSBuffer.concat(f.map(y=>P.VSBuffer.wrap(y))).buffer);return(async()=>{try{const f=await this.readFile(C);p.end(f)}catch(f){p.error(f),p.end()}})(),p}readdir(C){return this.f.readdir(this.j(C))}writeFile(C,E,w){return this.f.writeFile(this.j(C),E,w)}delete(C,E){return this.f.delete(this.j(C),E)}copy(C,E,w){if((0,D.hasFileFolderCopyCapability)(this.f))return this.f.copy(this.j(C),this.j(E),w);throw new Error("copy not supported")}i(C){const E=[];for(const w of C){if(w.resource.scheme!==this.c)continue;const p=this.k(w.resource);this.b.findSubstr(p)&&E.push({resource:p,type:w.type})}E.length&&(this.h.debug("User data changed"),this.a.fire(E))}j(C){return C.with({scheme:this.c})}k(C){return C.with({scheme:this.g})}}e.FileUserDataProvider=I}),define(oe[60],ae([0,1,83]),function(ee,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function i(O,P,I,S){const C=(0,k.setProperty)(O,P,I,S)[0];return C&&(O=O.substring(0,C.offset)+C.content+O.substring(C.offset+C.length)),O}e.edit=i;function D(O,P,I){let S=I;for(;S>=0;){if(O.charAt(S)===P.charAt(P.length-1)&&P.length===1)return S+1;if(S--,P.length===2&&S>=0&&O.charAt(S)===P.charAt(0))return S+2}return 0}e.getLineStartOffset=D;function A(O,P,I){let S=I;for(;S>=0;)if(O.charAt(S)===P.charAt(P.length-1)&&P.length===1||(S++,P.length===2&&S>=0&&O.charAt(S)===P.charAt(1)))return S;return O.length-1}e.getLineEndOffset=A}),define(oe[252],ae([0,1,32,53,14]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(p,f,y,v,l,m){const u=[],d=[],h=[];if(!f){const M=p.filter(({identifier:$})=>l.every(G=>G.toLowerCase()!==$.id.toLowerCase()));return{local:{added:u,removed:d,updated:h},remote:M.length>0?{added:M,updated:[],removed:[],all:M}:null}}p=p.map(E),f=f.map(E),y=y?y.map(E):null;const n=new Map,r=M=>{M.uuid&&n.set(M.id.toLowerCase(),M.uuid)};p.forEach(({identifier:M})=>r(M)),f.forEach(({identifier:M})=>r(M)),y?.forEach(({identifier:M})=>r(M));const t=M=>{const $=M.identifier.uuid||n.get(M.identifier.id.toLowerCase());return $?`uuid:${$}`:`id:${M.identifier.id.toLowerCase()}`},o=(M,$)=>(M.set(t($),$),M),s=p.reduce(o,new Map),c=f.reduce(o,new Map),a=f.reduce((M,$)=>o(M,(0,k.deepClone)($)),new Map),g=y?y.reduce(o,new Map):null,b=v.reduce(o,new Map),R=l.reduce((M,$)=>{const G=n.get($.toLowerCase());return M.add(G?`uuid:${G}`:`id:${$.toLowerCase()}`)},new Set),j=m.reduce((M,{id:$,uuid:G})=>(G=G??n.get($.toLowerCase()),M.add(G?`uuid:${G}`:`id:${$.toLowerCase()}`)),new Set),U=O(s,c,R,!1);if(U.added.size>0||U.removed.size>0||U.updated.size>0){const M=O(g,s,R,!1),$=O(g,c,R,!0),G=(W,_,K,q)=>({...q,installed:_.installed||K.installed,version:K.version&&(!_.installed||i.gt(K.version,_.version))?K.version:_.version,state:I(_,K,g?.get(W)),preRelease:(_.installed?q.preRelease:K.preRelease)??_.preRelease});for(const W of $.removed.values()){const _=s.get(W);if(!_)continue;const K=(0,D.assertIsDefined)(g?.get(W)),q=!j.has(W)&&K.installed;_.installed&&q?d.push(_.identifier):a.set(W,_)}for(const W of $.added.values()){const _=(0,D.assertIsDefined)(c.get(W)),K=s.get(W);if(K){if(U.updated.has(W)){const q=G(W,K,_,_);P(K,_,!1,!1)||h.push(w(q,W)),a.set(W,q)}}else _.installed&&u.push(w(_,W))}for(const W of $.updated.values()){const _=(0,D.assertIsDefined)(c.get(W)),K=(0,D.assertIsDefined)(g?.get(W)),q=s.get(W);if(q)if(!j.has(W)&&K.installed&&q.installed&&!_.installed)d.push(q.identifier);else{const Z=G(W,q,_,_);h.push(w(Z,W)),a.set(W,Z)}else _.installed&&u.push(w(_,W))}for(const W of M.added.values())$.added.has(W)||a.set(W,(0,D.assertIsDefined)(s.get(W)));for(const W of M.updated.values()){if($.removed.has(W)||$.updated.has(W))continue;const _=(0,D.assertIsDefined)(s.get(W)),K=(0,D.assertIsDefined)(c.get(W));a.set(W,G(W,_,K,_))}for(const W of M.removed.values())$.updated.has(W)||$.removed.has(W)||b.has(W)||!(0,D.assertIsDefined)(c.get(W)).installed||j.has(W)||!(0,D.assertIsDefined)(g?.get(W)).installed||a.delete(W)}const z=[],F=O(c,a,new Set,!0),L=F.added.size>0||F.updated.size>0||F.removed.size>0;return L&&a.forEach((M,$)=>z.push(w(M,$))),{local:{added:u,removed:d,updated:h},remote:L?{added:[...F.added].map(M=>a.get(M)),updated:[...F.updated].map(M=>a.get(M)),removed:[...F.removed].map(M=>c.get(M)),all:z}:null}}e.merge=A;function O(p,f,y,v){const l=p?[...p.keys()].filter(n=>!y.has(n)):[],m=[...f.keys()].filter(n=>!y.has(n)),u=m.filter(n=>l.indexOf(n)===-1).reduce((n,r)=>(n.add(r),n),new Set),d=l.filter(n=>m.indexOf(n)===-1).reduce((n,r)=>(n.add(r),n),new Set),h=new Set;for(const n of l){if(d.has(n))continue;const r=p.get(n),t=f.get(n);(!t||!P(r,t,v,!0))&&h.add(n)}return{added:u,removed:d,updated:h}}function P(p,f,y,v){return!(p.disabled!==f.disabled||v&&p.installed!==f.installed||p.installed&&f.installed&&p.preRelease!==f.preRelease||!C(p.state,f.state)||y&&p.version!==f.version)}function I(p,f,y){const v=p.state,l=f.state,m=y?.state;if(!f.version||v&&i.gt(p.version,f.version))return v;if(l&&i.gt(f.version,p.version)||!v)return l;if(!l)return v;const u=(0,k.deepClone)(v),d=m?S(m,l):{added:Object.keys(l).reduce((n,r)=>(n.add(r),n),new Set),removed:new Set,updated:new Set},h=m?S(m,v):{added:Object.keys(v).reduce((n,r)=>(n.add(r),n),new Set),removed:new Set,updated:new Set};for(const n of[...d.added.values(),...d.updated.values()])u[n]=l[n];for(const n of d.removed.values())h.updated.has(n)||delete u[n];return u}function S(p,f){const y=Object.keys(p),v=Object.keys(f),l=v.filter(d=>y.indexOf(d)===-1).reduce((d,h)=>(d.add(h),d),new Set),m=y.filter(d=>v.indexOf(d)===-1).reduce((d,h)=>(d.add(h),d),new Set),u=new Set;for(const d of y){if(m.has(d))continue;const h=p[d],n=f[d];(0,k.equals)(h,n)||u.add(d)}return{added:l,removed:m,updated:u}}function C(p={},f={}){const{added:y,removed:v,updated:l}=S(p,f);return y.size===0&&v.size===0&&l.size===0}function E(p){return{...p,disabled:!!p.disabled,installed:!!p.installed}}function w(p,f){const y={identifier:{id:p.identifier.id,uuid:f.startsWith("uuid:")?f.substring(5):void 0},preRelease:!!p.preRelease};return p.version&&(y.version=p.version),p.disabled&&(y.disabled=!0),p.installed&&(y.installed=!0),p.state&&(y.state=p.state),y}}),define(oe[114],ae([0,1,20,16,4]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,D.createDecorator)("IIgnoredExtensionsManagementService");let A=class{constructor(P){this.a=P}hasToNeverSyncExtension(P){return this.b().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.b().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,I){let S=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return S=S.filter(C=>C!==P&&C!==`-${P}`),I&&S.push(P.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}updateSynchronizedExtensions(P,I){let S=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return S=S.filter(C=>C!==P&&C!==`-${P}`),I&&S.push(`-${P.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}getIgnoredExtensions(P){const I=P.filter(w=>w.isMachineScoped).map(w=>w.identifier.id.toLowerCase()),S=this.b().map(w=>w.toLowerCase()),C=[],E=[];if(Array.isArray(S))for(const w of S)w.startsWith("-")?E.push(w.substring(1)):C.push(w);return(0,k.distinct)([...I,...C].filter(w=>E.indexOf(w)===-1))}b(){let P=this.a.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.a.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(I=>I.toLowerCase())}};A=pe([Y(0,i.IConfigurationService)],A),e.IgnoredExtensionsManagementService=A}),define(oe[253],ae([0,1,20,35,32,192,60]),function(ee,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(d){return(0,i.parse)(d)||[]}e.parseKeybindings=P;async function I(d,h,n,r,t){const o=P(d),s=P(h),c=n?P(n):null,a=[...o,...s,...c||[]].map(G=>G.key),g=await t.resolveUserBindings(a),b=C(o,s,c,g);if(!b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:d,hasChanges:!1,hasConflicts:!1};if(!b.hasLocalForwarded&&b.hasRemoteForwarded)return{mergeContent:h,hasChanges:!0,hasConflicts:!1};if(b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:d,hasChanges:!0,hasConflicts:!1};const R=w(o),j=w(s),U=c?w(c):null,z=f(R,j,g),F=U?f(U,R,g):{added:[...R.keys()].reduce((G,W)=>(G.add(W),G),new Set),removed:new Set,updated:new Set},L=U?f(U,j,g):{added:[...j.keys()].reduce((G,W)=>(G.add(W),G),new Set),removed:new Set,updated:new Set},M=S(z,F,L);let $=d;for(const G of M.removed.values())M.conflicts.has(G)||($=m($,G,r));for(const G of M.added.values()){if(M.conflicts.has(G))continue;const W=j.get(G);if(W.some(_=>_.command!==`-${G}`&&b.conflicts.has(g[_.key]))){M.conflicts.add(G);continue}$=l($,W,r)}for(const G of M.updated.values()){if(M.conflicts.has(G))continue;const W=j.get(G);if(W.some(_=>_.command!==`-${G}`&&b.conflicts.has(g[_.key]))){M.conflicts.add(G);continue}$=u($,G,W,r)}return{mergeContent:$,hasChanges:!0,hasConflicts:M.conflicts.size>0}}e.merge=I;function S(d,h,n){const r=new Set,t=new Set,o=new Set,s=new Set;for(const c of h.removed.values())n.updated.has(c)&&s.add(c);for(const c of n.removed.values())s.has(c)||(h.updated.has(c)?s.add(c):t.add(c));for(const c of h.added.values())s.has(c)||n.added.has(c)&&d.updated.has(c)&&s.add(c);for(const c of n.added.values())s.has(c)||(h.added.has(c)?d.updated.has(c)&&s.add(c):r.add(c));for(const c of h.updated.values())s.has(c)||n.updated.has(c)&&d.updated.has(c)&&s.add(c);for(const c of n.updated.values())s.has(c)||(h.updated.has(c)?d.updated.has(c)&&s.add(c):o.add(c));return{added:r,removed:t,updated:o,conflicts:s}}function C(d,h,n,r){const t=new Set,o=E(d,r),s=E(h,r),c=n?E(n,r):null,a=p(o,s);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const g=c?p(c,o):{added:[...o.keys()].reduce((F,L)=>(F.add(L),F),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const b=c?p(c,s):{added:[...s.keys()].reduce((F,L)=>(F.add(L),F),new Set),removed:new Set,updated:new Set};if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:R,removed:j,updated:U,conflicts:z}=S(a,g,b);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:R,removed:j,updated:U,conflicts:z}}function E(d,h){const n=new Map;for(const r of d){const t=h[r.key];let o=n.get(t);o||(o=[],n.set(t,o)),o.push(r)}return n}function w(d){const h=new Map;for(const n of d){const r=n.command[0]==="-"?n.command.substring(1):n.command;let t=h.get(r);t||(t=[],h.set(r,t)),t.push(n)}return h}function p(d,h){const n=[...d.keys()],r=[...h.keys()],t=r.filter(c=>n.indexOf(c)===-1).reduce((c,a)=>(c.add(a),c),new Set),o=n.filter(c=>r.indexOf(c)===-1).reduce((c,a)=>(c.add(a),c),new Set),s=new Set;for(const c of n){if(o.has(c))continue;const a=d.get(c).map(b=>({...b,key:c})),g=h.get(c).map(b=>({...b,key:c}));(0,k.equals)(a,g,(b,R)=>v(b,R))||s.add(c)}return{added:t,removed:o,updated:s}}function f(d,h,n){const r=[...d.keys()],t=[...h.keys()],o=t.filter(a=>r.indexOf(a)===-1).reduce((a,g)=>(a.add(g),a),new Set),s=r.filter(a=>t.indexOf(a)===-1).reduce((a,g)=>(a.add(g),a),new Set),c=new Set;for(const a of r){if(s.has(a))continue;const g=d.get(a).map(R=>({...R,key:n[R.key]})),b=h.get(a).map(R=>({...R,key:n[R.key]}));y(g,b)||c.add(a)}return{added:o,removed:s,updated:c}}function y(d,h){return!(!(0,k.equals)(d.filter(({command:n})=>n[0]!=="-"),h.filter(({command:n})=>n[0]!=="-"),(n,r)=>v(n,r))||!(0,k.equals)(d.filter(({command:n})=>n[0]==="-"),h.filter(({command:n})=>n[0]==="-"),(n,r)=>v(n,r)))}function v(d,h){if(d.command!==h.command||d.key!==h.key)return!1;const n=A.ContextKeyExpr.deserialize(d.when),r=A.ContextKeyExpr.deserialize(h.when);return!(n&&!r||!n&&r||n&&r&&!n.equals(r)||!D.equals(d.args,h.args))}function l(d,h,n){for(const r of h)d=O.edit(d,[-1],r,n);return d}function m(d,h,n){const r=P(d);for(let t=r.length-1;t>=0;t--)(r[t].command===h||r[t].command===`-${h}`)&&(d=O.edit(d,[t],void 0,n));return d}function u(d,h,n,r){const t=P(d),o=t.findIndex(s=>s.command===h||s.command===`-${h}`);for(let s=t.length-1;s>=0;s--)(t[s].command===h||t[s].command===`-${h}`)&&(d=O.edit(d,[s],void 0,r));for(let s=n.length-1;s>=0;s--)d=O.edit(d,[o],n[s],r);return d}}),define(oe[254],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function k(A,O,P){const I={},S={},C=new Set;if(!O)return{local:{added:I,updated:S,removed:[...C.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const E=i(A,O);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:I,updated:S,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const w=i(P,A),p=i(P,O),f={},y={},v=new Set,l=new Set;for(const m of w.removed.values())p.updated.has(m)?I[m]=O[m]:v.add(m);for(const m of p.removed.values())l.has(m)||(w.updated.has(m)?l.add(m):C.add(m));for(const m of w.updated.values())l.has(m)||(p.updated.has(m)?E.updated.has(m)&&l.add(m):y[m]=A[m]);for(const m of p.updated.values())l.has(m)||(w.updated.has(m)?E.updated.has(m)&&l.add(m):A[m]!==void 0&&(S[m]=O[m]));for(const m of w.added.values())l.has(m)||(p.added.has(m)?E.updated.has(m)&&l.add(m):f[m]=A[m]);for(const m of p.added.values())l.has(m)||(w.added.has(m)?E.updated.has(m)&&l.add(m):I[m]=O[m]);return{local:{added:I,removed:[...C.values()],updated:S},remote:{added:f,removed:[...v.values()],updated:y},conflicts:[...l.values()]}}e.merge=k;function i(A,O){const P=A?Object.keys(A):[],I=O?Object.keys(O):[],S=I.filter(w=>P.indexOf(w)===-1).reduce((w,p)=>(w.add(p),w),new Set),C=P.filter(w=>I.indexOf(w)===-1).reduce((w,p)=>(w.add(p),w),new Set),E=new Set;for(const w of P){if(C.has(w))continue;const p=A[w],f=O[w];p!==f&&E.add(w)}return{added:S,removed:C,updated:E}}function D(A,O){const{added:P,removed:I,updated:S}=i(A,O);return P.size===0&&I.size===0&&S.size===0}e.areSame=D}),define(oe[255],ae([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(D,A,O,P){const I={added:[],removed:[],updated:[]};let S={added:[],removed:[],updated:[]};if(!A){const E=D.filter(({id:w})=>!P.includes(w));return E.length?S.added=E:S=null,{local:I,remote:S}}const C=i(D,A,P);if(C.added.length>0||C.removed.length>0||C.updated.length>0){const E=i(O,D,P),w=i(O,A,P);for(const p of w.removed){const f=D.find(y=>y.id===p);f&&I.removed.push(f)}for(const p of w.added){const f=A.find(y=>y.id===p);E.added.includes(p)?C.updated.includes(p)&&I.updated.push(f):I.added.push(f)}for(const p of w.updated)I.updated.push(A.find(f=>f.id===p));for(const p of E.added)w.added.includes(p)||S.added.push(D.find(f=>f.id===p));for(const p of E.updated)w.removed.includes(p)||w.updated.includes(p)||S.updated.push(D.find(f=>f.id===p));for(const p of E.removed){const f=A.find(y=>y.id===p);f&&S.removed.push(f)}}return S.added.length===0&&S.removed.length===0&&S.updated.length===0&&(S=null),{local:I,remote:S}}e.merge=k;function i(D,A,O){D=D?D.filter(({id:w})=>!O.includes(w)):[],A=A.filter(({id:w})=>!O.includes(w));const P=D.map(({id:w})=>w),I=A.map(({id:w})=>w),S=I.filter(w=>P.indexOf(w)===-1),C=P.filter(w=>I.indexOf(w)===-1),E=[];for(const{id:w,name:p,shortName:f}of D){if(C.includes(w))continue;const y=A.find(v=>v.id===w);(!y||y.name!==p||y.shortName!==f)&&E.push(w)}return{added:S,removed:C,updated:E}}}),define(oe[26],ae([0,1,20,14,178,46,29,4,104,40]),function(ee,e,k,i,D,A,O,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function C(){const s=S.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(c=>!!s[c].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=C;function E(){const s=S.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(s).filter(b=>!!s[b].ignoreSync),a=Object.keys(s).filter(b=>s[b].scope===2||s[b].scope===6),g=C();return(0,k.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...c,...a,...g])}e.getDefaultIgnoredSettings=E,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function w(){const s="vscode://schemas/ignoredSettings",c=S.Registry.as(A.Extensions.Configuration);c.registerConfiguration({id:"settingsSync",order:30,title:(0,D.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,D.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,D.localize)(2,null),items:[{type:"string",pattern:O.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,D.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,D.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=S.Registry.as(I.Extensions.JSONContribution),g=()=>{const b=C(),R=E().filter(F=>F!==e.CONFIGURATION_SYNC_STORE_KEY),j=Object.keys(A.allSettings.properties).filter(F=>R.indexOf(F)===-1),U=R.filter(F=>b.indexOf(F)===-1),z={items:{type:"string",enum:[...j,...U.map(F=>`-${F}`)]}};a.registerSchema(s,z)};return c.onDidUpdateConfiguration(()=>g())}e.registerConfiguration=w;function p(s){return s&&(0,i.isObject)(s)&&(0,i.isString)(s.id)&&Array.isArray(s.scopes)}e.isAuthenticationProvider=p;var f;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState",s.Profiles="profiles"})(f=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function y(s,...c){return s?[s,...c]:c}e.getPathSegments=y;function v(s,c,a,g){return g.joinPath(a.userDataSyncHome,...y(s,c,`lastSync${c}.json`))}e.getLastSyncResourceUri=v,e.IUserDataSyncStoreManagementService=(0,P.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,P.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,P.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function l(s){const c={};return c[e.HEADER_EXECUTION_ID]=s,c}e.createSyncHeaders=l;var m;(function(s){s.Unauthorized="Unauthorized",s.NotFound="NotFound",s.MethodNotFound="MethodNotFound",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoCollection="NoCollection",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyProfiles="LocalTooManyProfiles",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.Unknown="Unknown"})(m=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class u extends Error{constructor(c,a,g,b){super(c),this.code=a,this.resource=g,this.operationId=b,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=u;class d extends u{constructor(c,a,g,b,R){super(c,g,void 0,R),this.url=a,this.serverCode=b}}e.UserDataSyncStoreError=d;class h extends u{constructor(c,a){super(c,a)}}e.UserDataAutoSyncError=h,function(s){function c(a){if(a instanceof s)return a;const g=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(g&&g[1]){const b=g[2]==="unknown"?void 0:g[2],R=g[3]==="unknown"?void 0:g[3];return new s(a.message,g[1],b,R)}return new s(a.message,"Unknown")}s.toUserDataSyncError=c}(u=e.UserDataSyncError||(e.UserDataSyncError={}));var n;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(n=e.SyncStatus||(e.SyncStatus={}));var r;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var t;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function o(s){return`sync.enable.${s}`}e.getEnablementKey=o,e.IUserDataSyncEnablementService=(0,P.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,P.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,P.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,P.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,P.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,P.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(oe[256],ae([0,1,32,26]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(O,P,I,S,C){if(!P)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const E=A(O,P);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const w=I?A(I,P):{added:Object.keys(P).reduce((m,u)=>(m.add(u),m),new Set),removed:new Set,updated:new Set},p=I?A(I,O):{added:Object.keys(O).reduce((m,u)=>(m.add(u),m),new Set),removed:new Set,updated:new Set},f={added:{},removed:[],updated:{}},y=k.deepClone(P),v=!I;for(const m of p.added.values())m!==i.SYNC_SERVICE_URL_TYPE&&v&&w.added.has(m)||(y[m]=O[m]);for(const m of p.updated.values())y[m]=O[m];for(const m of p.removed.values())S.unregistered.includes(m)||delete y[m];for(const m of w.added.values()){const u=P[m];if(S.machine.includes(m)){C.info(`GlobalState: Skipped adding ${m} in local storage because it is declared as machine scoped.`);continue}if(I&&p.added.has(m))continue;const d=O[m];d&&d.value===u.value||m===i.SYNC_SERVICE_URL_TYPE&&v&&p.added.has(m)||(d?f.updated[m]=u:f.added[m]=u)}for(const m of w.updated.values()){const u=P[m];if(S.machine.includes(m)){C.info(`GlobalState: Skipped updating ${m} in local storage because it is declared as machine scoped.`);continue}if(p.updated.has(m)||p.removed.has(m))continue;const d=O[m];d&&d.value===u.value||(f.updated[m]=u)}for(const m of w.removed.values()){if(S.machine.includes(m)){C.trace(`GlobalState: Skipped removing ${m} in local storage because it is declared as machine scoped.`);continue}p.updated.has(m)||p.removed.has(m)||f.removed.push(m)}const l=A(P,y);return{local:f,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:y}}}e.merge=D;function A(O,P){const I=Object.keys(O),S=Object.keys(P),C=S.filter(p=>I.indexOf(p)===-1).reduce((p,f)=>(p.add(f),p),new Set),E=I.filter(p=>S.indexOf(p)===-1).reduce((p,f)=>(p.add(f),p),new Set),w=new Set;for(const p of I){if(E.has(p))continue;const f=O[p],y=P[p];k.equals(f,y)||w.add(p)}return{added:C,removed:E,updated:w}}}),define(oe[257],ae([0,1,20,35,83,43,32,60,26]),function(ee,e,k,i,D,A,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function S(a,g,b){let R=[];b?R=E(b):R=C(g);const j=[],U=[...(0,I.getDisallowedIgnoredSettings)()];if(Array.isArray(R))for(const z of R)z.startsWith("-")?U.push(z.substring(1)):j.push(z);return(0,k.distinct)([...a,...j].filter(z=>U.indexOf(z)===-1))}e.getIgnoredSettings=S;function C(a){let g=a.inspect("settingsSync.ignoredSettings").userValue;return g!==void 0||(g=a.inspect("sync.ignoredSettings").userValue,g!==void 0)?g:a.getValue("settingsSync.ignoredSettings")||[]}function E(a){const g=(0,i.parse)(a);return g?g["settingsSync.ignoredSettings"]||g["sync.ignoredSettings"]||[]:[]}function w(a,g){const b=(0,i.parse)(a)||{};let R="{}";for(const j of Object.keys(b)){const U=(0,D.setProperty)(R,[j],b[j],g);R=(0,D.applyEdits)(R,U)}return R}e.removeComments=w;function p(a,g,b,R){if(b.length){const j=c(g),U=(0,i.parse)(g)||{},z=(0,i.parse)(a);if(!z)return a;const F=[];for(const L of b){const M=U[L],$=z[L];M===void 0?a=P.edit(a,[L],void 0,R):$!==void 0?a=P.edit(a,[L],M,R):F.push(n(L,j))}F.sort((L,M)=>L.startOffset-M.startOffset),F.forEach(L=>a=m(L.setting.key,g,a,R))}return a}e.updateIgnoredSettings=p;function f(a,g,b,R,j,U){const z=p(a,g,R,U),F=b!==z,L=b!==g;if(!F&&!L)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!L)return{conflictsSettings:[],localContent:null,remoteContent:z,hasConflicts:!1};if(L&&!F)return{conflictsSettings:[],localContent:p(g,a,R,U),remoteContent:null,hasConflicts:!1};if(b===null&&v(a)){const B=y(a,g,R)?null:p(g,a,R,U);return{conflictsSettings:[],localContent:B,remoteContent:null,hasConflicts:!1}}let M=a,$=g;const G=(0,i.parse)(a),W=(0,i.parse)(g),_=b?(0,i.parse)(b):null,K=R.reduce((B,Q)=>(B.add(Q),B),new Set),q=l(G,W,K),V=l(_,G,K),Z=l(_,W,K),ne=new Map,J=new Set,x=B=>{J.add(B);const Q=j.filter(({key:re})=>re===B)[0];Q?(M=P.edit(M,[B],Q.value,U),$=P.edit($,[B],Q.value,U)):ne.set(B,{key:B,localValue:G[B],remoteValue:W[B]})};for(const B of V.removed.values())Z.updated.has(B)?x(B):$=P.edit($,[B],void 0,U);for(const B of Z.removed.values())J.has(B)||(V.updated.has(B)?x(B):M=P.edit(M,[B],void 0,U));for(const B of V.updated.values())J.has(B)||(Z.updated.has(B)?q.updated.has(B)&&x(B):$=P.edit($,[B],G[B],U));for(const B of Z.updated.values())J.has(B)||(V.updated.has(B)?q.updated.has(B)&&x(B):M=P.edit(M,[B],W[B],U));for(const B of V.added.values())J.has(B)||(Z.added.has(B)?q.updated.has(B)&&x(B):$=m(B,M,$,U));for(const B of Z.added.values())J.has(B)||(V.added.has(B)?q.updated.has(B)&&x(B):M=m(B,$,M,U));const T=ne.size>0||!y(M,$,R),N=T||!y(M,a,[]),H=T||!y($,g,[]);return{localContent:N?M:null,remoteContent:H?$:null,conflictsSettings:[...ne.values()],hasConflicts:T}}e.merge=f;function y(a,g,b){if(a===g)return!0;const R=(0,i.parse)(a),j=(0,i.parse)(g),U=b.reduce((L,M)=>(L.add(M),L),new Set),z=c(a).filter(L=>!(L.setting&&U.has(L.setting.key))),F=c(g).filter(L=>!(L.setting&&U.has(L.setting.key)));if(z.length!==F.length)return!1;for(let L=0;L<z.length;L++){const M=z[L],$=F[L];if(M.setting&&$.setting){if(M.setting.key!==$.setting.key||!O.equals(R[M.setting.key],j[M.setting.key]))return!1}else if(!M.setting&&!$.setting){if(M.value!==$.value)return!1}else return!1}return!0}e.areSame=y;function v(a){return a?c(a).length===0:!0}e.isEmpty=v;function l(a,g,b){const R=a?Object.keys(a).filter(L=>!b.has(L)):[],j=Object.keys(g).filter(L=>!b.has(L)),U=j.filter(L=>R.indexOf(L)===-1).reduce((L,M)=>(L.add(M),L),new Set),z=R.filter(L=>j.indexOf(L)===-1).reduce((L,M)=>(L.add(M),L),new Set),F=new Set;if(a)for(const L of R){if(z.has(L))continue;const M=a[L],$=g[L];O.equals(M,$)||F.add(L)}return{added:U,removed:z,updated:F}}function m(a,g,b,R){const j=(0,i.parse)(g),U=c(g),z=c(b),F=u(a,U,z);return d(b,a,j[a],F,z,R)}e.addSetting=m;function u(a,g,b){const R=g.findIndex(U=>U.setting?.key===a),j=g[R-1];if(j){if(j.setting){const z=n(j.setting.key,b);if(z)return{index:b.indexOf(z),insertAfter:!0}}else{const z=r(R,g);if(z){const F=n(z.setting.key,b);if(F){const L=t(b.indexOf(F),b),M=o(g,z,g[R]);if(L){const $=o(b,F,L),G=s(M,$);return G?{index:b.indexOf(G),insertAfter:!0}:{index:b.indexOf(L),insertAfter:!1}}else{const $=o(b,F,b[b.length-1]),G=s(M,$);return G?{index:b.indexOf(G),insertAfter:!0}:{index:b.length-1,insertAfter:!0}}}}}const U=g[R+1];if(U)if(U.setting){const z=n(U.setting.key,b);if(z)return{index:b.indexOf(z),insertAfter:!1}}else{const z=t(R,g);if(z){const F=n(z.setting.key,b);if(F){const L=r(b.indexOf(F),b),M=o(g,g[R],z);if(L){const $=o(b,L,F),G=s(M.reverse(),$.reverse());return G?{index:b.indexOf(G),insertAfter:!1}:{index:b.indexOf(L),insertAfter:!0}}else{const $=o(b,b[0],F),G=s(M.reverse(),$.reverse());return G?{index:b.indexOf(G),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:b.length-1,insertAfter:!0}}function d(a,g,b,R,j,U){let z;return R.index===-1?z=(0,D.setProperty)(a,[g],b,U):z=h(a,g,b,R,j,U).map(F=>(0,D.withFormatting)(a,F,U)[0]),(0,D.applyEdits)(a,z)}function h(a,g,b,R,j,U){const z=`${JSON.stringify(g)}: ${JSON.stringify(b)}`,F=(0,A.getEOL)(U,a),L=j[R.index];if(R.insertAfter){const M=[];if(L.setting)M.push({offset:L.endOffset,length:0,content:","+z});else{const $=t(R.index,j),G=r(R.index,j),W=G?.setting?.commaOffset;G&&W===void 0&&M.push({offset:G.endOffset,length:0,content:","});const _=W!==void 0&&W>L.endOffset;M.push({offset:_?W+1:L.endOffset,length:0,content:$?F+z+",":F+z})}return M}else{if(L.setting)return[{offset:L.startOffset,length:0,content:z+","}];const M=(j[R.index-1]&&!j[R.index-1].setting?F:"")+z+(t(R.index,j)?",":"")+F;return[{offset:L.startOffset,length:0,content:M}]}}function n(a,g){return g.filter(b=>b.setting?.key===a)[0]}function r(a,g){for(let b=a-1;b>=0;b--)if(g[b].setting)return g[b]}function t(a,g){for(let b=a+1;b<g.length;b++)if(g[b].setting)return g[b]}function o(a,g,b){const R=a.indexOf(g),j=a.indexOf(b);return a.filter((U,z)=>R<z&&z<j)}function s(a,g){if(a.length&&g.length){let b=0;for(;b<g.length&&b<a.length;b++)if(a[b].value!==g[b].value)return g[b-1];return g[b-1]}}function c(a){const g=[];let b=-1,R,j;const U={onObjectBegin:z=>{b++},onObjectProperty:(z,F,L)=>{b===0&&(R=F,j=z)},onObjectEnd:(z,F)=>{b--,b===0&&g.push({startOffset:R,endOffset:z+F,value:a.substring(R,z+F),setting:{key:j,commaOffset:void 0}})},onArrayBegin:(z,F)=>{b++},onArrayEnd:(z,F)=>{b--,b===0&&g.push({startOffset:R,endOffset:z+F,value:a.substring(R,z+F),setting:{key:j,commaOffset:void 0}})},onLiteralValue:(z,F,L)=>{b===0&&g.push({startOffset:R,endOffset:F+L,value:a.substring(R,F+L),setting:{key:j,commaOffset:void 0}})},onSeparator:(z,F,L)=>{if(b===0&&z===","){let M=g.length-1;for(;M>=0&&!g[M].setting;M--);const $=g[M];$&&g.splice(M,1,{startOffset:$.startOffset,endOffset:$.endOffset,value:$.value,setting:{key:$.setting.key,commaOffset:F}})}},onComment:(z,F)=>{b===0&&g.push({startOffset:z,endOffset:z+F,value:a.substring(z,z+F)})}};return(0,i.visit)(a,U),g}}),define(oe[78],ae([0,1,3,2,4,26]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,D.createDecorator)("IUserDataSyncAccountService");let O=class extends i.Disposable{get account(){return this.a}constructor(I,S){super(),this.g=I,this.h=S,this.b=this.B(new k.Emitter),this.onDidChangeAccount=this.b.event,this.c=this.B(new k.Emitter),this.onTokenFailed=this.c.event,this.f=!1,this.B(I.onTokenFailed(()=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f),this.updateAccount(void 0),this.c.fire(this.f),this.f=!0})),this.B(I.onTokenSucceed(()=>this.f=!1))}async updateAccount(I){(I&&this.a?I.token!==this.a.token||I.authenticationProviderId!==this.a.authenticationProviderId:I!==this.a)&&(this.a=I,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(I))}};O=pe([Y(0,A.IUserDataSyncStoreService),Y(1,A.IUserDataSyncLogService)],O),e.UserDataSyncAccountService=O}),define(oe[258],ae([0,1,2,7]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class D{constructor(w){this.a=w}listen(w,p){switch(p){case"onError":return this.a.onError}throw new Error(`Event not found: ${p}`)}call(w,p,f){switch(p){case"triggerSync":return this.a.triggerSync(f[0],f[1],f[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(f[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=D;class A{constructor(w){this.a=w}listen(w,p){throw new Error(`Event not found: ${p}`)}call(w,p,f){switch(p){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(f[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(i.URI.revive(f[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=A;class O{constructor(w){this.a=w}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(w){return this.a.call("resolveUserKeybindings",[w])}async resolveFormattingOptions(w){return this.a.call("resolveFormattingOptions",[w])}}e.UserDataSyncUtilServiceClient=O;class P{constructor(w){this.a=w}listen(w,p){switch(p){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${p}`)}async call(w,p,f){switch(p){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(f[0],f[1]);case"setEnablements":return this.a.setEnablements(f)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class I{constructor(w){this.a=w}listen(w,p){switch(p){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${p}`)}call(w,p,f){switch(p){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(f)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=I;class S{constructor(w){this.a=w}listen(w,p){switch(p){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${p}`)}call(w,p,f){switch(p){case"switch":return this.a.switch(f[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=S;class C extends k.Disposable{constructor(w){super(),this.a=w,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(w){return this.a.call("switch",[w])}async getPreviousUserDataSyncStore(){const w=await this.a.call("getPreviousUserDataSyncStore");return this.b(w)}b(w){return{url:i.URI.revive(w.url),type:w.type,defaultUrl:i.URI.revive(w.defaultUrl),insidersUrl:i.URI.revive(w.insidersUrl),stableUrl:i.URI.revive(w.stableUrl),canSwitch:w.canSwitch,authenticationProviders:w.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=C}),define(oe[259],ae([0,1,15,8]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends i.AbstractLogger{constructor(O,P){super(),this.g=this.B(O.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(O,...P){this.g.trace(O,...P)}debug(O,...P){this.g.debug(O,...P)}info(O,...P){this.g.info(O,...P)}warn(O,...P){this.g.warn(O,...P)}error(O,...P){this.g.error(O,...P)}flush(){this.g.flush()}};D=pe([Y(0,i.ILoggerService),Y(1,k.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(oe[260],ae([0,1,6,3,2]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends D.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:I,getActiveWindowId:S}){super(),this.a=this.B(new D.DisposableStore),i.Event.latch(i.Event.any(P,I))(this.f,this,this.a),this.b=(0,k.createCancelablePromise)(()=>S()),(async()=>{try{const E=await this.b;this.c=typeof this.c=="number"?this.c:E}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=A}),define(oe[115],ae([0,1,181,12,48,21,7,4,24]),function(ee,e,k,i,D,A,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function S(r){const t=r;return typeof t?.id=="string"&&O.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=S,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function C(r,t){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,i.basename)(r)}:t?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const o=r;if(o.configuration)return{id:o.id,configPath:o.configuration};if(o.folders.length===1)return{id:o.id,uri:o.folders[0].uri}}e.toWorkspaceIdentifier=C;function E(r){const t=r;return typeof t?.id=="string"&&O.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=E;function w(r){const t=r;if(t?.uri)return{id:t.id,uri:O.URI.revive(t.uri)};const o=r;if(o?.configPath)return{id:o.id,configPath:O.URI.revive(o.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=w;var p;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(p=e.WorkbenchState||(e.WorkbenchState={}));function f(r){const t=r;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=f;function y(r){const t=r;return!!(t&&typeof t=="object"&&O.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=y;class v{constructor(t,o,s,c,a){this.h=t,this.j=s,this.k=c,this.l=a,this.c=D.TernarySearchTree.forUris(this.l,()=>!0),this.folders=o}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=D.TernarySearchTree.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=v;class l{constructor(t,o){this.raw=o,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,A.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=l;function m(r){return new l({uri:r,index:0,name:(0,A.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=m,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function u(r,t){return A.extUriBiasedIgnorePathCase.isEqualOrParent(r,t.untitledWorkspacesHome)}e.isUntitledWorkspace=u;function d(r){let t;return O.URI.isUri(r)?t=r:t=r.configuration,t?.scheme===I.Schemas.tmp}e.isTemporaryWorkspace=d;function h(r,t){return!u(r,t)&&!d(r)}e.isSavedWorkspace=h;function n(r){return(typeof r=="string"?(0,i.extname)(r):(0,A.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(oe[18],ae([0,1,66,3,2,21,7,173,15,13,4,8,115,37,30,6,31,27,14]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p,f,y,v,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function u(t){const o=t;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&typeof o.isDefault=="boolean"&&typeof o.name=="string"&&O.URI.isUri(o.location)&&O.URI.isUri(o.globalStorageHome)&&O.URI.isUri(o.settingsResource)&&O.URI.isUri(o.keybindingsResource)&&O.URI.isUri(o.tasksResource)&&O.URI.isUri(o.snippetsHome)&&O.URI.isUri(o.extensionsResource))}e.isUserDataProfile=u,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,C.createDecorator)("IUserDataProfilesService");function d(t,o){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,location:O.URI.revive(t.location).with({scheme:o}),globalStorageHome:O.URI.revive(t.globalStorageHome).with({scheme:o}),settingsResource:O.URI.revive(t.settingsResource).with({scheme:o}),keybindingsResource:O.URI.revive(t.keybindingsResource).with({scheme:o}),tasksResource:O.URI.revive(t.tasksResource).with({scheme:o}),snippetsHome:O.URI.revive(t.snippetsHome).with({scheme:o}),extensionsResource:O.URI.revive(t.extensionsResource)?.with({scheme:o}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=d;function h(t,o,s,c){return{id:t,name:o,location:s,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,A.joinPath)(s,"globalStorage"),settingsResource:(0,A.joinPath)(s,"settings.json"),keybindingsResource:(0,A.joinPath)(s,"keybindings.json"),tasksResource:(0,A.joinPath)(s,"tasks.json"),snippetsHome:(0,A.joinPath)(s,"snippets"),extensionsResource:(0,A.joinPath)(s,"extensions.json"),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=h;let n=class extends D.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(o,s,c,a){super(),this.m=o,this.n=s,this.r=c,this.s=a,this.f=!1,this.g=this.B(new i.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new i.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new i.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new i.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new p.ResourceMap},this.profilesHome=(0,A.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(o){this.f!==o&&(this.t=void 0,this.f=o)}isEnabled(){return this.f}get u(){if(!this.t){const o=[];if(this.f)for(const g of this.H()){if(!g.name||!(0,m.isString)(g.name)||!g.location){this.s.warn("Skipping the invalid stored profile",g.location||g.name);continue}o.push(h((0,A.basename)(g.location),g.name,g.location,{shortName:g.shortName,useDefaultFlags:g.useDefaultFlags}))}let s;const c=new p.ResourceMap,a=h((0,k.hash)(this.m.userRoamingDataHome.path).toString(16),(0,P.localize)(0,null),this.m.userRoamingDataHome);if(o.unshift({...a,extensionsResource:this.M()??a.extensionsResource,isDefault:!0}),o.length){const g=this.J();if(g.workspaces)for(const[b,R]of Object.entries(g.workspaces)){const j=O.URI.parse(b),U=O.URI.parse(R),z=o.find(F=>this.r.extUri.isEqual(F.location,U));z&&c.set(j,z)}if(g.emptyWindow){const b=O.URI.parse(g.emptyWindow);s=o.find(R=>this.r.extUri.isEqual(R.location,b))}}this.t={profiles:o,workspaces:c,emptyWindow:s}}return this.t}async createTransientProfile(o){const s="Temp",c=new RegExp(`${(0,l.escapeRegExpCharacters)(s)}\\s(\\d+)`);let a=0;for(const b of this.profiles){const R=c.exec(b.name),j=R?parseInt(R[1]):0;a=j>a?j:a}const g=`${s} ${a+1}`;return this.createProfile((0,k.hash)((0,v.generateUuid)()).toString(16),g,{transient:!0},o)}async createNamedProfile(o,s,c){return this.createProfile((0,k.hash)((0,v.generateUuid)()).toString(16),o,s,c)}async createProfile(o,s,c,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const g=await this.v(o,s,c);return a&&await this.setProfileForWorkspace(a,g),g}async v(o,s,c){if(!(0,m.isString)(s)||!s)throw new Error("Name of the profile is mandatory and must be of type `string`");let a=this.k.get(s);return a||(a=(async()=>{try{const g=this.profiles.find(j=>j.name===s||j.id===o);if(g)return g;const b=h(o,s,(0,A.joinPath)(this.profilesHome,o),c);await this.n.createFolder(b.location);const R=[];return this.h.fire({profile:b,join(j){R.push(j)}}),await y.Promises.settled(R),this.C([b],[],[]),b}finally{this.k.delete(s)}})(),this.k.set(s,a)),a}async updateProfile(o,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let c=this.profiles.find(a=>a.id===o.id);if(!c)throw new Error(`Profile '${o.name}' does not exist`);return c=h(c.id,s.name??c.name,c.location,{shortName:s.shortName??c.shortName,transient:s.transient??c.isTransient,useDefaultFlags:s.useDefaultFlags??c.useDefaultFlags}),this.C([],[],[c]),c}async removeProfile(o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(o.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(a=>a.id===o.id);if(!s)throw new Error(`Profile '${o.name}' does not exist`);const c=[];this.i.fire({profile:s,join(a){c.push(a)}});try{await Promise.allSettled(c)}catch(a){this.s.error(a)}s.id===this.u.emptyWindow?.id&&(this.u.emptyWindow=void 0);for(const a of[...this.u.workspaces.keys()])s.id===this.u.workspaces.get(a)?.id&&this.u.workspaces.delete(a);this.G(),this.C([],[s],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(s.location,{recursive:!0})}catch(a){this.s.error(a)}}getOrSetProfileForWorkspace(o,s=this.defaultProfile){if(!this.f)return this.defaultProfile;let c=this.w(o);return c||(c=s,this.profiles.length>1&&this.setProfileForWorkspaceSync(o,c)),c}async setProfileForWorkspace(o,s){this.setProfileForWorkspaceSync(o,s)}setProfileForWorkspaceSync(o,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=this.profiles.find(a=>a.id===s.id);if(!c)throw new Error(`Profile '${s.name}' does not exist`);this.F(o,c)}unsetWorkspace(o,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.F(o,void 0,s)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindow=void 0,this.u.workspaces.clear(),this.u.emptyWindow=void 0,this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const o=await this.n.resolve(this.profilesHome);await Promise.all((o.children||[]).filter(s=>s.isDirectory&&this.profiles.every(c=>!this.r.extUri.isEqual(c.location,s.resource))).map(s=>this.n.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const o=this.l.profiles.filter(s=>!this.z(s));await Promise.allSettled(o.map(s=>this.removeProfile(s)))}w(o){const s=this.y(o);return O.URI.isUri(s)?this.l.workspaces.get(s)??this.u.workspaces.get(s):this.l.emptyWindow??this.u.emptyWindow}y(o){return(0,w.isSingleFolderWorkspaceIdentifier)(o)?o.uri:(0,w.isWorkspaceIdentifier)(o)?o.configPath:"empty-window"}z(o){return!!(this.r.extUri.isEqual(this.l.emptyWindow?.location,o.location)||[...this.l.workspaces.values()].some(s=>this.r.extUri.isEqual(s.location,o.location))||this.r.extUri.isEqual(this.u.emptyWindow?.location,o.location)||[...this.u.workspaces.values()].some(s=>this.r.extUri.isEqual(s.location,o.location)))}C(o,s,c){const a=[...this.profiles,...o],g=[];this.l.profiles=[];for(let b of a)b.isDefault||s.some(R=>b.id===R.id)||(b=c.find(R=>b.id===R.id)??b,b.isTransient?this.l.profiles.push(b):g.push({location:b.location,name:b.name,shortName:b.shortName,useDefaultFlags:b.useDefaultFlags}));this.I(g),this.t=void 0,this.D(o,s,c)}D(o,s,c){this.g.fire({added:o,removed:s,updated:c,all:this.profiles})}F(o,s,c){c=s?.isTransient?!0:c,c||this.F(o,void 0,!0);const a=this.y(o),g=c?this.l:this.u;O.URI.isUri(a)?(g.workspaces.delete(a),s&&g.workspaces.set(a,s)):g.emptyWindow=s,c||this.G()}G(){const o={};for(const[c,a]of this.u.workspaces.entries())o[c.toString()]=a.location.toString();const s=this.u.emptyWindow?.location.toString();this.L({workspaces:o,emptyWindow:s}),this.t=void 0}H(){return[]}I(o){throw new Error("not implemented")}J(){return{}}L(o){throw new Error("not implemented")}M(){}};n.b="userDataProfiles",n.c="profileAssociations",n=pe([Y(0,I.IEnvironmentService),Y(1,S.IFileService),Y(2,f.IUriIdentityService),Y(3,E.ILogService)],n),e.UserDataProfilesService=n;class r extends n{constructor(){super(...arguments),this.a=[],this.P={}}H(){return this.a}I(o){this.a=o}J(){return this.P}L(o){this.P=o}}e.InMemoryUserDataProfilesService=r}),define(oe[261],ae([0,1,6,2,18]),function(ee,e,k,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let A=class extends i.Disposable{constructor(P){super(),this.B(new k.RunOnceScheduler(()=>{P.cleanUp()},10*1e3)).schedule()}};A=pe([Y(0,D.IUserDataProfilesService)],A),e.UserDataProfilesCleaner=A}),define(oe[262],ae([0,1,20,6,23,9,3,2,5,7,154,29,33,42,8,25,22,18]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p,f,y,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let m=class extends P.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(t,o,s,c,a){super(),this.t=t,this.u=o,this.v=s,this.w=c,this.y=a,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new O.Emitter),this.m=this.B(new O.Emitter),this.n=this.B(new O.Emitter),this.p=this.B(new O.Emitter),this.s=[],this.B((0,P.toDisposable)(()=>{this.j.forEach(({task:g})=>g.cancel()),this.k.forEach(g=>g.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(t){const o=await this.getTargetPlatform();return t.allTargetPlatforms.some(s=>(0,E.isTargetPlatformCompatible)(s,t.allTargetPlatforms,o))}async installFromGallery(t,o={}){try{if(!this.t.isEnabled())throw new E.ExtensionManagementError(C.localize(0,null),E.ExtensionManagementErrorCode.Internal);const s=await this.G(t,!!o.installGivenVersion,!!o.installPreReleaseVersion);return await this.z(s.manifest,s.extension,o)}catch(s){throw h(this.u,"extensionGallery:install",{extensionData:(0,w.getGalleryExtensionTelemetryData)(t),error:s}),this.v.error("Failed to install extension.",t.identifier.id),this.v.error(s),d(s)}}async uninstall(t,o={}){return this.v.trace("ExtensionManagementService#uninstall",t.identifier.id),this.I(t,o)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.O(),this.h=t),this.g}registerParticipant(t){this.s.push(t)}async z(t,o,s){const c={...s,installOnlyNewlyAddedFromExtensionPack:S.URI.isUri(o)?s.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,p.isApplicationScopedExtension)(t)?this.y.defaultProfile.extensionsResource:s.profileLocation??this.P()},a=z=>`${w.ExtensionKey.create(z).toString()}${c.profileLocation?`-${c.profileLocation.toString()}`:""}`;if(!S.URI.isUri(o)){const z=this.j.get(a(o));if(z){this.v.info("Extensions is already requested to install",o.identifier.id);const{local:F}=await z.task.waitUntilTaskIsFinished();return F}}const g=[],b=[],R=[],j=this.Q(t,o,c);S.URI.isUri(o)||this.j.set(a(o),{task:j,waitingTasks:[]}),this.l.fire({identifier:j.identifier,source:o,profileLocation:c.profileLocation}),this.v.info("Installing extension:",j.identifier.id),g.push({task:j,manifest:t});let U=!1;try{if(c.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",j.identifier.id);else try{const F=await this.F(j.identifier,t,!!c.installOnlyNewlyAddedFromExtensionPack,!!c.installPreReleaseVersion,c.profileLocation),L=await this.getInstalled(void 0,c.profileLocation);for(const{gallery:M,manifest:$}of(0,k.distinct)(F,({gallery:G})=>G.identifier.id)){U=U||!!$.extensionDependencies?.some(_=>(0,w.areSameExtensions)({id:_},j.identifier));const G=a(M),W=this.j.get(G);if(W){if(this.C(j,W.task)){const _=W.task.identifier;this.v.info("Waiting for already requested installing extension",_.id,j.identifier.id),W.waitingTasks.push(j),b.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,K=>K.some(q=>(0,w.areSameExtensions)(q.identifier,_)))).then(K=>{if(this.v.info("Finished waiting for already requested installing extension",_.id,j.identifier.id),!K.find(V=>(0,w.areSameExtensions)(V.identifier,_))?.local)throw new Error(`Extension ${_.id} is not installed`)}))}}else if(!L.some(({identifier:_})=>(0,w.areSameExtensions)(_,M.identifier))){const _=this.Q($,M,{...c,donotIncludePackAndDependencies:!0});this.j.set(G,{task:_,waitingTasks:[j]}),this.l.fire({identifier:_.identifier,source:M,profileLocation:c.profileLocation}),this.v.info("Installing extension:",_.identifier.id,j.identifier.id),g.push({task:_,manifest:$})}}}catch(F){if(S.URI.isUri(j.source))(0,k.isNonEmptyArray)(t.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",j.identifier.id,F.message),(0,k.isNonEmptyArray)(t.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",j.identifier.id,F.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",j.identifier.id),F}const z=g.reduce((F,{task:L,manifest:M})=>(F.set(L.identifier.id.toLowerCase(),{task:L,manifest:M}),F),new Map);for(;z.size;){let F;const L=[...z.values()].filter(({manifest:M})=>!M.extensionDependencies?.some($=>z.has($.toLowerCase())));L.length?F=z.size===1?L:L.filter(({task:M})=>!(M===j&&!U)):(this.v.info("Found extensions with circular dependencies",L.map(({task:M})=>M.identifier.id)),F=[...z.values()]),await this.D(F.map(async({task:M})=>{const $=new Date().getTime();try{const{local:G}=await M.run();if(await this.D(this.s.map(W=>W.postInstall(G,M.source,c,D.CancellationToken.None))),!S.URI.isUri(M.source)){const W=M.operation===3,_=W?void 0:(new Date().getTime()-M.source.lastUpdated)/1e3;if(h(this.u,W?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.getGalleryExtensionTelemetryData)(M.source),wasVerified:M.wasVerified,duration:new Date().getTime()-$,durationSinceUpdate:_}),I.isWeb&&M.operation!==3)try{await this.t.reportStatistic(G.manifest.publisher,G.manifest.name,G.manifest.version,"install")}catch{}}R.push({local:G,identifier:M.identifier,operation:M.operation,source:M.source,context:c.context,profileLocation:c.profileLocation,applicationScoped:G.isApplicationScoped})}catch(G){throw S.URI.isUri(M.source)||h(this.u,M.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.getGalleryExtensionTelemetryData)(M.source),wasVerified:M.wasVerified,duration:new Date().getTime()-$,error:G}),this.v.error("Error while installing the extension:",M.identifier.id),G}finally{z.delete(M.identifier.id.toLowerCase())}}))}return b.length&&await this.D(b),R.forEach(({identifier:F})=>this.v.info("Extension installed successfully:",F.id)),this.m.fire(R),R.filter(({identifier:F})=>(0,w.areSameExtensions)(F,j.identifier))[0].local}catch(z){if(g.forEach(({task:F})=>F.cancel()),R.length)try{const F=await Promise.allSettled(R.map(({local:L})=>this.R(L,{versionOnly:!0,profileLocation:c.profileLocation}).run()));for(let L=0;L<F.length;L++){const M=F[L],{identifier:$}=R[L];M.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",$.id):this.v.warn("Rollback: Error while uninstalling extension",$.id,(0,A.getErrorMessage)(M.reason))}}catch(F){this.v.warn("Error while rolling back extensions",(0,A.getErrorMessage)(F),R.map(({identifier:L})=>L.id))}throw this.m.fire(g.map(({task:F})=>({identifier:F.identifier,operation:2,source:F.source,context:c.context,profileLocation:c.profileLocation}))),z}finally{for(const{task:z}of g)z.source&&!S.URI.isUri(z.source)&&this.j.delete(a(z.source))}}C(t,o){for(const[,{task:s,waitingTasks:c}]of this.j.entries())if(s===t&&(c.includes(o)||c.some(a=>this.C(a,o)))||s===o&&c[0]&&!this.C(t,c[0]))return!1;return!0}async D(t){const o=[],s=[],c=await Promise.allSettled(t);for(const a of c)a.status==="fulfilled"?o.push(a.value):s.push(a.reason);if(s.length)throw u(s);return o}async F(t,o,s,c,a){if(!this.t.isEnabled())return[];const g=await this.getInstalled(void 0,a),b=[],R=[],j=async(U,z)=>{b.push(U);const F=z.extensionDependencies||[],L=[...F];if(z.extensionPack){const M=s?g.find($=>(0,w.areSameExtensions)($.identifier,U)):void 0;for(const $ of z.extensionPack)M&&M.manifest.extensionPack&&M.manifest.extensionPack.some(G=>(0,w.areSameExtensions)({id:G},{id:$}))||L.every(G=>!(0,w.areSameExtensions)({id:G},{id:$}))&&L.push($)}if(L.length){const M=L.filter($=>b.every(G=>!(0,w.areSameExtensions)(G,{id:$})));if(M.length){const $=await this.t.getExtensions(M.map(G=>({id:G,preRelease:c})),D.CancellationToken.None);for(const G of $){if(b.find(K=>(0,w.areSameExtensions)(K,G.identifier)))continue;const W=F.some(K=>(0,w.areSameExtensions)({id:K},G.identifier));let _;try{_=await this.G(G,!1,c)}catch(K){if(K instanceof E.ExtensionManagementError&&K.code===E.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!W){this.v.info("Skipping the packed extension as it cannot be installed",G.identifier.id);continue}else throw K}R.push({gallery:_.extension,manifest:_.manifest}),await j(_.extension.identifier,_.manifest)}}}};return await j(t,o),R}async G(t,o,s){if((await this.getExtensionsControlManifest()).malicious.some(b=>(0,w.areSameExtensions)(t.identifier,b)))throw new E.ExtensionManagementError(C.localize(1,null,t.identifier.id),E.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const b=await this.getTargetPlatform();throw new E.ExtensionManagementError(C.localize(2,null,t.identifier.id,this.w.nameLong,(0,E.TargetPlatformToString)(b)),E.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.H(t,o,s);if(a){if(s&&!o&&t.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new E.ExtensionManagementError(C.localize(3,null,t.identifier.id,this.w.nameLong,this.w.version),E.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!s&&t.properties.isPreReleaseVersion&&(await this.t.getExtensions([t.identifier],D.CancellationToken.None))[0]?new E.ExtensionManagementError(C.localize(4,null,t.identifier.id),E.ExtensionManagementErrorCode.ReleaseVersionNotFound):new E.ExtensionManagementError(C.localize(5,null,t.identifier.id,this.w.nameLong,this.w.version),E.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",a.identifier.id);const g=await this.t.getManifest(a,D.CancellationToken.None);if(g===null)throw new E.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,E.ExtensionManagementErrorCode.Invalid);if(g.version!==a.version)throw new E.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,E.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:g}}async H(t,o,s){const c=await this.getTargetPlatform();let a=null;return!o&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==s&&(a=(await this.t.getExtensions([{...t.identifier,preRelease:s}],{targetPlatform:c,compatible:!0},D.CancellationToken.None))[0]||null),!a&&await this.t.isExtensionCompatible(t,s,c)&&(a=t),a||(o?a=(await this.t.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:c,compatible:!0},D.CancellationToken.None))[0]||null:a=await this.t.getCompatibleExtension(t,s,c)),a}async I(t,o){const s={...o,profileLocation:t.isApplicationScoped?this.y.defaultProfile.extensionsResource:o.profileLocation??this.P()},c=U=>`${U.id.toLowerCase()}${s.versionOnly?`-${t.manifest.version}`:""}${s.profileLocation?`@${s.profileLocation.toString()}`:""}`,a=this.k.get(c(t.identifier));if(a)return this.v.info("Extensions is already requested to uninstall",t.identifier.id),a.waitUntilTaskIsFinished();const g=U=>{const z=this.R(U,s);return this.k.set(c(z.extension.identifier),z),s.profileLocation?this.v.info("Uninstalling extension from the profile:",`${U.identifier.id}@${U.manifest.version}`,s.profileLocation.toString()):this.v.info("Uninstalling extension:",`${U.identifier.id}@${U.manifest.version}`),this.n.fire({identifier:U.identifier,profileLocation:s.profileLocation,applicationScoped:U.isApplicationScoped}),z},b=(U,z)=>{z?s.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${U.identifier.id}@${U.manifest.version}`,s.profileLocation.toString(),z.message):this.v.error("Failed to uninstall extension:",`${U.identifier.id}@${U.manifest.version}`,z.message):s.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${U.identifier.id}@${U.manifest.version}`,s.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${U.identifier.id}@${U.manifest.version}`),h(this.u,"extensionGallery:uninstall",{extensionData:(0,w.getLocalExtensionTelemetryData)(U),error:z}),this.p.fire({identifier:U.identifier,error:z?.code,profileLocation:s.profileLocation,applicationScoped:U.isApplicationScoped})},R=[],j=[];try{R.push(g(t));const U=await this.getInstalled(1,s.profileLocation);if(s.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const z=this.M(t,U);for(const F of z)this.k.has(c(F.identifier))?this.v.info("Extensions is already requested to uninstall",F.identifier.id):R.push(g(F))}s.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.J(R.map(z=>z.extension),U,t),await this.D(R.map(async z=>{try{if(await z.run(),await this.D(this.s.map(F=>F.postUninstall(z.extension,s,D.CancellationToken.None))),z.extension.identifier.uuid)try{await this.t.reportStatistic(z.extension.manifest.publisher,z.extension.manifest.name,z.extension.manifest.version,"uninstall")}catch{}b(z.extension)}catch(F){const L=F instanceof E.ExtensionManagementError?F:new E.ExtensionManagementError((0,A.getErrorMessage)(F),E.ExtensionManagementErrorCode.Internal);throw b(z.extension,L),L}finally{j.push(z)}}))}catch(U){const z=U instanceof E.ExtensionManagementError?U:new E.ExtensionManagementError((0,A.getErrorMessage)(U),E.ExtensionManagementErrorCode.Internal);for(const F of R){try{F.cancel()}catch{}j.includes(F)||b(F.extension,z)}throw z}finally{for(const U of R)this.k.delete(c(U.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",U.extension.identifier.id)}}J(t,o,s){for(const c of t){const a=this.N(c,o);if(a.length){const g=a.filter(b=>!t.some(R=>(0,w.areSameExtensions)(R.identifier,b.identifier)));if(g.length)throw new Error(this.L(c,g,s))}}}L(t,o,s){return s===t?o.length===1?C.localize(6,null,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?C.localize(7,null,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):C.localize(8,null,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?C.localize(9,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?C.localize(10,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):C.localize(11,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}M(t,o,s=[]){if(s.indexOf(t)!==-1)return[];s.push(t);const c=t.manifest.extensionPack?t.manifest.extensionPack:[];if(c.length){const a=o.filter(b=>!b.isBuiltin&&c.some(R=>(0,w.areSameExtensions)({id:R},b.identifier))),g=[];for(const b of a)g.push(...this.M(b,o,s));return[...a,...g]}return[]}N(t,o){return o.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(c=>(0,w.areSameExtensions)({id:c},t.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const t=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};m=pe([Y(0,E.IExtensionGalleryService),Y(1,v.ITelemetryService),Y(2,f.ILogService),Y(3,y.IProductService),Y(4,l.IUserDataProfilesService)],m),e.AbstractExtensionManagementService=m;function u(r){const t=Array.isArray(r)?r:[r];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((o,s)=>new Error(`${o.message}${o.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=u;function d(r){if(r instanceof E.ExtensionManagementError)return r;const t=new E.ExtensionManagementError(r.message,E.ExtensionManagementErrorCode.Internal);return t.stack=r.stack,t}function h(r,t,{extensionData:o,wasVerified:s,duration:c,error:a,durationSinceUpdate:g}){let b,R;a&&(a instanceof E.ExtensionManagementError?(b=a.code,a.code===E.ExtensionManagementErrorCode.Signature&&(R=a.message)):b=E.ExtensionManagementErrorCode.Internal),r.publicLog(t,{...o,wasVerified:s,success:!a,duration:c,errorcode:b,errorcodeDetail:R,durationSinceUpdate:g})}e.reportTelemetry=h;class n{constructor(){this.d=new i.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,i.createCancelablePromise)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,i.createCancelablePromise)(t=>new Promise((o,s)=>{const c=t.onCancellationRequested(()=>{c.dispose(),s(new A.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=n}),define(oe[61],ae([0,1,6,17,2,3,37,7,33,42,13,4,8,18,30]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,E.createDecorator)("IExtensionsProfileScannerService");let y=class extends D.Disposable{constructor(m,u,d,h){super(),this.h=m,this.i=u,this.j=d,this.k=h,this.a=this.B(new A.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new A.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new A.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new A.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new O.ResourceMap}scanProfileExtensions(m){return this.l(m)}async addExtensionsToProfile(m,u){const d=[],h=[];try{return await this.l(u,n=>{const r=[];for(const t of n)m.some(([o])=>(0,I.areSameExtensions)(o.identifier,t.identifier)&&o.manifest.version!==t.version)?d.push(t):r.push(t);for(const[t,o]of m)if(!r.some(s=>(0,I.areSameExtensions)(s.identifier,t.identifier)&&s.version===t.manifest.version)){const s={identifier:t.identifier,version:t.manifest.version,location:t.location,metadata:o};h.push(s),r.push(s)}return h.length&&this.a.fire({extensions:h,profileLocation:u}),d.length&&this.c.fire({extensions:d,profileLocation:u}),r}),h.length&&this.b.fire({extensions:h,profileLocation:u}),d.length&&this.f.fire({extensions:d,profileLocation:u}),h}catch(n){throw h.length&&this.b.fire({extensions:h,error:n,profileLocation:u}),d.length&&this.f.fire({extensions:d,error:n,profileLocation:u}),n}}async removeExtensionFromProfile(m,u){const d=[];this.c.fire({extensions:d,profileLocation:u});try{await this.l(u,h=>{const n=[];for(const r of h)(0,I.areSameExtensions)(r.identifier,m.identifier)?d.push(r):n.push(r);return d.length&&this.c.fire({extensions:d,profileLocation:u}),n}),d.length&&this.f.fire({extensions:d,profileLocation:u})}catch(h){throw d.length&&this.f.fire({extensions:d,error:h,profileLocation:u}),h}}async l(m,u){return this.p(m).queue(async()=>{let d=[],h;try{const n=await this.h.readFile(m);h=JSON.parse(n.value.toString())}catch(n){if((0,C.toFileOperationResult)(n)!==1)throw n;this.j.extUri.isEqual(m,this.i.defaultProfile.extensionsResource)&&(h=await this.n())}if(h)for(const n of h){if(!n.identifier){this.k.info("Ignoring invalid extension while scanning. Identifier does not exist.",n);continue}if(!n.location){this.k.info("Ignoring invalid extension while scanning. Location does not exist.",n);continue}if(!n.version){this.k.info("Ignoring invalid extension while scanning. Version does not exist.",n);continue}d.push({identifier:n.identifier,location:P.URI.revive(n.location),version:n.version,metadata:n.metadata})}if(u){d=u(d);const n=d.map(r=>({identifier:r.identifier,version:r.version,location:r.location.toJSON(),metadata:r.metadata}));await this.h.writeFile(m,i.VSBuffer.fromString(JSON.stringify(n)))}return d})}async n(){return this.m||(this.m=(async()=>{const m=this.j.extUri.joinPath(this.i.defaultProfile.location,"extensions.json");let u;try{u=(await this.h.readFile(m)).value.toString()}catch(h){if((0,C.toFileOperationResult)(h)===1)return;throw h}this.k.info("Migrating extensions from old default profile location",m.toString());let d;try{const h=JSON.parse(u);Array.isArray(h)&&h.every(n=>!!(n&&typeof n=="object"&&(0,S.isIExtensionIdentifier)(n.identifier)&&v(n.location)&&n.version&&typeof n.version=="string"))?d=h:this.k.warn("Skipping migrating from old default profile locaiton: Found invalid data",h)}catch(h){this.k.error(h)}if(d)try{await this.h.createFile(this.i.defaultProfile.extensionsResource,i.VSBuffer.fromString(JSON.stringify(d)),{overwrite:!1}),this.k.info("Migrated extensions from old default profile location to new location",m.toString(),this.i.defaultProfile.extensionsResource.toString())}catch(h){if((0,C.toFileOperationResult)(h)===3)this.k.info("Migration from old default profile location to new location is done by another window",m.toString(),this.i.defaultProfile.extensionsResource.toString());else throw h}try{await this.h.del(m)}catch(h){(0,C.toFileOperationResult)(h)!==1&&this.k.error(h)}return d})()),this.m}p(m){let u=this.g.get(m);return u||(u=new k.Queue,this.g.set(m,u)),u}};y=pe([Y(0,C.IFileService),Y(1,p.IUserDataProfilesService),Y(2,f.IUriIdentityService),Y(3,w.ILogService)],y),e.ExtensionsProfileScannerService=y;function v(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}}),define(oe[79],ae([0,1,20,6,32,17,9,35,136,2,24,12,5,21,53,88,14,7,157,15,33,42,70,13,4,8,25,3,67,61,18,30,187,188]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p,f,y,v,l,m,u,d,h,n,r,t,o,s,c,a,g,b,R,j,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var z;(function(_){function K(q,V){if(q===V)return!0;const Z=Object.keys(q),ne=new Set;for(const J of Object.keys(V))ne.add(J);if(Z.length!==ne.size)return!1;for(const J of Z){if(q[J]!==V[J])return!1;ne.delete(J)}return ne.size===0}_.equals=K})(z=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let F=class extends S.Disposable{constructor(K,q,V,Z,ne,J,x,T,N,H,B,Q){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=q,this.l=V,this.m=Z,this.n=ne,this.p=J,this.r=x,this.s=T,this.t=N,this.u=H,this.v=B,this.w=Q,this.g=this.B(new c.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,p.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance($,(0,p.joinPath)(this.m,h.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance($,(0,p.joinPath)(this.m,h.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(M,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,d.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(K,q,V){const[Z,ne]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(q)]),J=V?await this.scanExtensionsUnderDevelopment(K,[...Z,...ne]):[];return this.D(Z,ne,J,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const q=[];q.push(this.F(!!K.useCache,K.language)),q.push(this.G(K.language,!!K.checkControlFile));const[V,Z]=await Promise.all(q);return this.C([...V,...Z],0,K,!1)}async scanUserExtensions(K){const q=K.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",q);const V=await this.I(q,!!K.profileLocation,1,!K.includeUninstalled,K.language);let ne=await(K.useCache&&!V.devMode&&V.excludeObsolete?this.j:this.k).scanExtensions(V);return ne=await this.C(ne,1,K,!0),this.s.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(K,q){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const V=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(Z=>Z.scheme===C.Schemas.file).map(async Z=>{const ne=await this.I(Z,!1,1,!0,K.language,!1);return(await this.k.scanOneOrMultipleExtensions(ne)).map(x=>(x.type=q.find(T=>(0,d.areSameExtensions)(T.identifier,x.identifier))?.type??x.type,this.k.validate(x,ne)))}))).flat();return this.C(V,"development",K,!0)}return[]}async scanExistingExtension(K,q,V){const Z=await this.I(K,!1,q,!0,V.language),ne=await this.k.scanExtension(Z);return!ne||!V.includeInvalid&&!ne.isValid?null:ne}async scanOneOrMultipleExtensions(K,q,V){const Z=await this.I(K,!1,q,!0,V.language),ne=await this.k.scanOneOrMultipleExtensions(Z);return this.C(ne,q,V,!0)}async scanMetadata(K){const q=(0,p.joinPath)(K,"package.json"),V=(await this.r.readFile(q)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(K,q){const V=(0,p.joinPath)(K,"package.json"),Z=(await this.r.readFile(V)).value.toString(),ne=JSON.parse(Z);q.isMachineScoped=q.isMachineScoped||void 0,q.isBuiltin=q.isBuiltin||void 0,q.installedTimestamp=q.installedTimestamp||void 0,ne.__metadata={...ne.__metadata,...q},await this.r.writeFile((0,p.joinPath)(K,"package.json"),A.VSBuffer.fromString(JSON.stringify(ne,null,"	")))}initializeDefaultProfileExtensions(){return this.z||(this.z=(async()=>{try{const K=this.v.extUri.joinPath(this.userExtensionsLocation,".init-default-profile-extensions");if(await this.r.exists(K))return;if(!await this.r.exists(this.n.defaultProfile.extensionsResource)&&!await this.r.exists(this.v.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"))){this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});await this.p.addExtensionsToProfile(q.map(V=>[V,V.metadata]),this.n.defaultProfile.extensionsResource),this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}try{await this.r.createFile(K,A.VSBuffer.fromString(""))}catch(q){(0,r.toFileOperationResult)(q)!==1&&this.s.warn("Failed to create default profile extensions initialize marker in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.getErrorMessage)(q))}}catch(K){throw this.s.error(K),K}})()),this.z}async C(K,q,V,Z){return V.includeAllVersions||(K=this.D(q===0?K:void 0,q===1?K:void 0,q==="development"?K:void 0,await this.getTargetPlatform(),Z)),V.includeInvalid||(K=K.filter(ne=>ne.isValid)),K.sort((ne,J)=>{const x=E.basename(ne.location.fsPath),T=E.basename(J.location.fsPath);return x<T?-1:x>T?1:0})}D(K,q,V,Z,ne){const J=(T,N,H)=>{if(T.isValid&&!N.isValid)return!1;if(T.isValid===N.isValid){if(ne&&f.gt(T.manifest.version,N.manifest.version))return this.s.debug(`Skipping extension ${N.location.path} with lower version ${N.manifest.version} in favour of ${T.location.path} with version ${T.manifest.version}`),!1;if(f.eq(T.manifest.version,N.manifest.version)){if(T.type===0)return this.s.debug(`Skipping extension ${N.location.path} in favour of system extension ${T.location.path} with same version`),!1;if(T.targetPlatform===Z)return this.s.debug(`Skipping extension ${N.location.path} from different target platform ${N.targetPlatform}`),!1}}return H?this.s.warn(`Overwriting user extension ${T.location.path} with ${N.location.path}.`):this.s.debug(`Overwriting user extension ${T.location.path} with ${N.location.path}.`),!0},x=new Map;return K?.forEach(T=>{const N=h.ExtensionIdentifier.toKey(T.identifier.id),H=x.get(N);(!H||J(H,T,!1))&&x.set(N,T)}),q?.forEach(T=>{const N=h.ExtensionIdentifier.toKey(T.identifier.id),H=x.get(N);if(!H&&K&&T.type===0){this.s.debug(`Skipping obsolete system extension ${T.location.path}.`);return}(!H||J(H,T,!1))&&x.set(N,T)}),V?.forEach(T=>{const N=h.ExtensionIdentifier.toKey(T.identifier.id),H=x.get(N);(!H||J(H,T,!0))&&x.set(N,T),x.set(N,T)}),[...x.values()]}async F(K,q){this.s.trace("Started scanning system extensions");const V=await this.I(this.systemExtensionsLocation,!1,0,!0,q),ne=await(K&&!V.devMode?this.i:this.k).scanExtensions(V);return this.s.trace("Scanned system extensions:",ne.length),ne}async G(K,q){const V=this.t.isBuilt?[]:this.u.builtInExtensions;if(!V?.length)return[];this.s.trace("Started scanning dev system extensions");const Z=q?await this.H():{},ne=[],J=l.URI.file(E.normalize(E.join(C.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const T of V){const N=Z[T.name]||"marketplace";switch(N){case"disabled":break;case"marketplace":ne.push((0,p.joinPath)(J,T.name));break;default:ne.push(l.URI.file(N));break}}const x=await Promise.all(ne.map(async T=>this.k.scanExtension(await this.I(T,!1,0,!0,K))));return this.s.trace("Scanned dev system extensions:",x.length),(0,k.coalesce)(x)}async H(){try{const K=await this.r.readFile(this.l);return JSON.parse(K.value.toString())}catch{return{}}}async I(K,q,V,Z,ne,J=!0){const x=await this.f(ne??w.language),T=await this.J(K),N=q&&!this.v.extUri.isEqual(K,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,H=N?await this.J(N):void 0;return new L(K,T,N,H,q,V,Z,J,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,ne,x)}async J(K){try{const q=await this.r.stat(K);if(typeof q.mtime=="number")return q.mtime}catch{}}};F=pe([Y(4,b.IUserDataProfilesService),Y(5,g.IExtensionsProfileScannerService),Y(6,r.IFileService),Y(7,o.ILogService),Y(8,u.IEnvironmentService),Y(9,s.IProductService),Y(10,R.IUriIdentityService),Y(11,t.IInstantiationService)],F),e.AbstractExtensionsScannerService=F;class L{constructor(K,q,V,Z,ne,J,x,T,N,H,B,Q,re,X){this.location=K,this.mtime=q,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=Z,this.profile=ne,this.type=J,this.excludeObsolete=x,this.validate=T,this.productVersion=N,this.productDate=H,this.productCommit=B,this.devMode=Q,this.language=re,this.translations=X}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,q){return(0,p.isEqual)(K.location,q.location)&&K.mtime===q.mtime&&(0,p.isEqual)(K.applicationExtensionslocation,q.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===q.applicationExtensionslocationMtime&&K.profile===q.profile&&K.type===q.type&&K.excludeObsolete===q.excludeObsolete&&K.validate===q.validate&&K.productVersion===q.productVersion&&K.productDate===q.productDate&&K.productCommit===q.productCommit&&K.devMode===q.devMode&&K.language===q.language&&z.equals(K.translations,q.translations)}}let M=class extends S.Disposable{constructor(K,q,V,Z,ne){super(),this.f=K,this.g=q,this.h=V,this.i=Z,this.j=ne}async scanExtensions(K){const q=K.profile?await this.l(K):await this.k(K);let V={};if(K.excludeObsolete&&K.type===1)try{const Z=(await this.i.readFile(this.f)).value.toString();V=JSON.parse(Z)}catch{}return(0,v.isEmptyObject)(V)?q:q.filter(Z=>!V[d.ExtensionKey.create(Z).toString()])}async k(K){const q=await this.i.resolve(K.location);if(!q.children?.length)return[];const V=await Promise.all(q.children.map(async Z=>{if(!Z.isDirectory||K.type===1&&(0,p.basename)(Z.resource).indexOf(".")===0)return null;const ne=new L(Z.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(ne)}));return(0,k.coalesce)(V).sort((Z,ne)=>Z.location.path<ne.location.path?-1:1)}async l(K){let q=await this.m(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.h.extUri.isEqual(K.location,K.applicationExtensionslocation)){q=q.filter(Z=>!Z.metadata?.isApplicationScoped);const V=await this.m(K.applicationExtensionslocation,Z=>!!Z.metadata?.isApplicationScoped,K);q.push(...V)}return q}async m(K,q,V){const Z=await this.g.scanProfileExtensions(K);if(!Z.length)return[];const ne=await Promise.all(Z.map(async J=>{if(q(J)){const x=new L(J.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(x,J.metadata)}return null}));return(0,k.coalesce)(ne)}async scanOneOrMultipleExtensions(K){try{if(await this.i.exists((0,p.joinPath)(K.location,"package.json"))){const q=await this.scanExtension(K);return q?[q]:[]}else return await this.scanExtensions(K)}catch(q){return this.j.error(`Error scanning extensions at ${K.location.path}:`,(0,O.getErrorMessage)(q)),[]}}async scanExtension(K,q){try{let V=await this.scanExtensionManifest(K.location);if(V){V.publisher||(V.publisher=h.UNDEFINED_PUBLISHER),q=q??V.__metadata,delete V.__metadata;const Z=(0,d.getGalleryExtensionId)(V.publisher,V.name),ne=q?.id?{id:Z,uuid:q.id}:{id:Z},J=q?.isSystem?0:K.type,x=J===0||!!q?.isBuiltin;U.ImplicitActivationEvents.updateManifest(V),V=await this.n(K.location,V,L.createNlsConfiguration(K));const T={type:J,identifier:ne,manifest:V,location:K.location,isBuiltin:x,targetPlatform:q?.targetPlatform??"undefined",metadata:q,isValid:!0,validations:[]};return K.validate?this.validate(T,K):T}}catch(V){K.type!==0&&this.j.error(V)}return null}validate(K,q){let V=!0;const Z=(0,n.validateExtensionManifest)(q.productVersion,q.productDate,q.location,K.manifest,K.isBuiltin);for(const[ne,J]of Z)ne===y.default.Error&&(V=!1,this.j.error(this.t(q.location,J)));return K.isValid=V,K.validations=Z,K}async scanExtensionManifest(K){const q=(0,p.joinPath)(K,"package.json");let V;try{V=(await this.i.readFile(q)).value.toString()}catch(ne){return(0,r.toFileOperationResult)(ne)!==1&&this.j.error(this.t(K,(0,m.localize)(0,null,q.path,ne.message))),null}let Z;try{Z=JSON.parse(V)}catch{const J=[];(0,P.parse)(V,J);for(const x of J)this.j.error(this.t(K,(0,m.localize)(1,null,q.path,x.offset,x.length,(0,I.getParseErrorMessage)(x.error))));return null}return(0,P.getNodeType)(Z)!=="object"?(this.j.error(this.t(K,(0,m.localize)(2,null,q.path))),null):Z}async n(K,q,V){const Z=await this.p(K,q,V);if(Z)try{const ne=[],J=await this.r(Z.default,ne);if(ne.length>0)return ne.forEach(T=>{this.j.error(this.t(K,(0,m.localize)(3,null,Z.default?.path,(0,I.getParseErrorMessage)(T.error))))}),q;if((0,P.getNodeType)(Z)!=="object")return this.j.error(this.t(K,(0,m.localize)(4,null,Z.default?.path))),q;const x=Z.values||Object.create(null);return(0,j.localizeManifest)(q,x,J)}catch{}return q}async p(K,q,V){const Z=(0,p.joinPath)(K,"package.nls.json"),ne=(N,H)=>{H.forEach(B=>{this.j.error(this.t(K,(0,m.localize)(5,null,N?.path,(0,I.getParseErrorMessage)(B.error))))})},J=N=>{this.j.error(this.t(K,(0,m.localize)(6,null,N?.path)))},x=`${q.publisher}.${q.name}`,T=V.translations[x];if(T)try{const N=l.URI.file(T),H=(await this.i.readFile(N)).value.toString(),B=[],Q=(0,P.parse)(H,B);return B.length>0?(ne(N,B),{values:void 0,default:Z}):(0,P.getNodeType)(Q)!=="object"?(J(N),{values:void 0,default:Z}):{values:Q.contents?Q.contents.package:void 0,default:Z}}catch{return{values:void 0,default:Z}}else{if(!await this.i.exists(Z))return;let H;try{H=await this.s(K,V)}catch{return}if(!H.localized)return{values:void 0,default:H.original};try{const B=(await this.i.readFile(H.localized)).value.toString(),Q=[],re=(0,P.parse)(B,Q);return Q.length>0?(ne(H.localized,Q),{values:void 0,default:H.original}):(0,P.getNodeType)(re)!=="object"?(J(H.localized),{values:void 0,default:H.original}):{values:re,default:H.original}}catch{return{values:void 0,default:H.original}}}}async r(K,q){if(K)try{const V=(await this.i.readFile(K)).value.toString();return(0,P.parse)(V,q)}catch{}}s(K,q){return new Promise((V,Z)=>{const ne=J=>{const x=(0,p.joinPath)(K,`package.nls.${J}.json`);this.i.exists(x).then(T=>{T&&V({localized:x,original:(0,p.joinPath)(K,"package.nls.json")});const N=J.lastIndexOf("-");N===-1?V({localized:(0,p.joinPath)(K,"package.nls.json"),original:null}):(J=J.substring(0,N),ne(J))})};if(q.devMode||q.pseudo||!q.language)return V({localized:(0,p.joinPath)(K,"package.nls.json"),original:null});ne(q.language)})}t(K,q){return`[${K.path}]: ${q}`}};M=pe([Y(1,g.IExtensionsProfileScannerService),Y(2,R.IUriIdentityService),Y(3,r.IFileService),Y(4,o.ILogService)],M);let $=class extends M{constructor(K,q,V,Z,ne,J){super(q,V,Z,ne,J),this.y=K,this.v=this.B(new i.ThrottledDelayer(3e3)),this.w=this.B(new c.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(K){const q=await this.z();if(this.u=K,q&&q.input&&L.equals(q.input,this.u))return this.v.trigger(()=>this.D()),q.result.map(Z=>(Z.location=l.URI.revive(Z.location),Z));const V=await super.scanExtensions(K);return await this.C({input:K,result:V}),V}async z(){try{const K=await this.i.readFile(this.y),q=JSON.parse(K.value.toString());return{result:q.result,input:(0,a.revive)(q.input)}}catch(K){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,O.getErrorMessage)(K))}return null}async C(K){try{await this.i.writeFile(this.y,A.VSBuffer.fromString(JSON.stringify(K)))}catch(q){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,O.getErrorMessage)(q))}}async D(){if(!this.u)return;const K=await this.z();if(!K)return;const q=K.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!D.equals(V,q))try{await this.i.del(this.y),this.w.fire()}catch(Z){this.j.error(Z)}}};$=pe([Y(2,g.IExtensionsProfileScannerService),Y(3,R.IUriIdentityService),Y(4,r.IFileService),Y(5,o.ILogService)],$);function G(_,K){const q=(0,d.getExtensionId)(_.manifest.publisher,_.manifest.name);return{id:q,identifier:new h.ExtensionIdentifier(q),isBuiltin:_.type===0,isUserBuiltin:_.type===1&&_.isBuiltin,isUnderDevelopment:K,extensionLocation:_.location,uuid:_.identifier.uuid,targetPlatform:_.targetPlatform,..._.manifest}}e.toExtensionDescription=G;class W extends F{constructor(K,q,V,Z,ne,J,x,T,N,H,B,Q){super(K,q,(0,p.joinPath)(V,".vscode-oss-dev","extensions","control.json"),(0,p.joinPath)(Z,h.MANIFEST_CACHE_FOLDER),ne,J,x,T,N,H,B,Q),this.L=(async()=>{if(w.translationsConfigFile)try{const re=await this.r.readFile(l.URI.file(w.translationsConfigFile));return JSON.parse(re.value.toString())}catch{}return Object.create(null)})()}f(K){return this.L}}e.NativeExtensionsScannerService=W}),define(oe[263],ae([0,1,49,6,38,3,2,24,12,28,8,18]),function(ee,e,k,i,D,A,O,P,I,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let w=class extends O.Disposable{constructor(f,y){super(),this.b=f,this.f=y,this.a=new i.Limiter(5)}async postUninstall(f){const y=this.g(f,"uninstall");return y&&(this.f.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(y.script,"uninstall",y.args,!0,f).then(()=>this.f.info(f.identifier.id,f.manifest.version,"Finished running post uninstall script"),v=>this.f.error(f.identifier.id,f.manifest.version,`Failed to run post uninstall script: ${v}`)))),S.Promises.rm(this.j(f)).then(void 0,v=>this.f.error("Error while removing extension storage path",v))}g(f,y){const v=`vscode:${y}`;if(f.location.scheme===P.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[v]=="string"){const l=f.manifest.scripts[v].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(f.identifier.id,f.manifest.version,`${v} should be a node script`),null):{script:(0,I.join)(f.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(f,y,v,l,m){return new Promise((u,d)=>{const h=this.i(f,y,v,m);let n;const r=t=>{n&&(clearTimeout(n),n=null),t?d(t):u(void 0)};h.on("error",t=>{r((0,D.toErrorMessage)(t)||"Unknown")}),h.on("exit",(t,o)=>{r(t?`post-${y} process exited with code ${t}`:void 0)}),l&&(n=setTimeout(()=>{n=null,h.kill(),d("timed out")},5e3))})}i(f,y,v,l){const m={silent:!0,execArgv:void 0},u=(0,k.fork)(f,[`--type=extension-post-${y}`,...v],m);u.stdout.setEncoding("utf8"),u.stderr.setEncoding("utf8");const d=A.Event.fromNodeEventEmitter(u.stdout,"data"),h=A.Event.fromNodeEventEmitter(u.stderr,"data");d(t=>this.f.info(l.identifier.id,l.manifest.version,`post-${y}`,t)),h(t=>this.f.error(l.identifier.id,l.manifest.version,`post-${y}`,t));const n=A.Event.any(A.Event.map(d,t=>({data:`%c${t}`,format:[""]})),A.Event.map(h,t=>({data:`%c${t}`,format:["color: red"]})));return A.Event.debounce(n,(t,o)=>t?{data:t.data+o.data,format:[...t.format,...o.format]}:{data:o.data,format:o.format},100)(t=>{console.group(l.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),u}j(f){return(0,I.join)(this.b.defaultProfile.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};w=pe([Y(0,E.IUserDataProfilesService),Y(1,C.ILogService)],w),e.ExtensionsLifecycle=w}),define(oe[264],ae([0,1,7,15,61,79,13,4,8,25,30,18]),function(ee,e,k,i,D,A,O,P,I,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let w=class extends A.NativeExtensionsScannerService{constructor(f,y,v,l,m,u,d,h){super(k.URI.file(m.builtinExtensionsPath),k.URI.file(m.extensionsPath),m.userHome,k.URI.file(m.userDataPath),f,y,v,l,m,u,d,h)}};w=pe([Y(0,E.IUserDataProfilesService),Y(1,D.IExtensionsProfileScannerService),Y(2,O.IFileService),Y(3,I.ILogService),Y(4,i.INativeEnvironmentService),Y(5,S.IProductService),Y(6,C.IUriIdentityService),Y(7,P.IInstantiationService)],w),e.ExtensionsScannerService=w}),define(oe[19],ae([0,1,6,3,2,206,14,69,4,18]),function(ee,e,k,i,D,A,O,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,I.createDecorator)("storageService");var C;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(C=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var w;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(w=e.StorageTarget||(e.StorageTarget={}));function p(m){const u=m.get(e.TARGET_KEY);if(u)try{return JSON.parse(u)}catch{}return Object.create(null)}e.loadKeyTargets=p;class f extends D.Disposable{constructor(u={flushInterval:f.a}){super(),this.j=u,this.b=this.B(new i.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new i.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new i.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new k.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new D.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,k.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,D.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.J()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(u,d){if(d===e.TARGET_KEY){switch(u){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:u})}else this.b.fire({scope:u,key:d,target:this.F(u)[d]})}r(u){this.f.fire({reason:u})}get(u,d,h){return this.L(d)?.get(u,h)}getBoolean(u,d,h){return this.L(d)?.getBoolean(u,h)}getNumber(u,d,h){return this.L(d)?.getNumber(u,h)}store(u,d,h,n){if((0,O.isUndefinedOrNull)(d)){this.remove(u,h);return}this.t(()=>{this.u(u,h,n),this.L(h)?.set(u,d)})}remove(u,d){this.t(()=>{this.u(u,d,void 0),this.L(d)?.delete(u)})}t(u){this.b.pause(),this.c.pause();try{u()}finally{this.b.resume(),this.c.resume()}}keys(u,d){const h=[],n=this.F(u);for(const r of Object.keys(n))n[r]===d&&h.push(r);return h}u(u,d,h){const n=this.F(d);typeof h=="number"?n[u]!==h&&(n[u]=h,this.L(d)?.set(e.TARGET_KEY,JSON.stringify(n))):typeof n[u]=="number"&&(delete n[u],this.L(d)?.set(e.TARGET_KEY,JSON.stringify(n)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(u){switch(u){case-1:return this.D;case 0:return this.z;default:return this.w}}G(u){const d=this.L(u);return d?p(d):Object.create(null)}isNew(u){return this.getBoolean(e.IS_NEW_KEY,u)===!0}async flush(u=C.NONE){this.f.fire({reason:u});const d=this.L(-1),h=this.L(0),n=this.L(1);switch(u){case C.NONE:await k.Promises.settled([d?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await k.Promises.settled([d?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const u=this.L(-1)?.items??new Map,d=this.L(0)?.items??new Map,h=this.L(1)?.items??new Map;return l(u,d,h,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(u,d){return this.r(C.NONE),(0,S.isUserDataProfile)(u)?this.N(u,d):this.O(u,d)}H(u,d){return!(u.id===d.id||y(d)&&y(u))}I(u,d,h,n){this.t(()=>{if(n)for(const[r,t]of u)d.set(r,t);else{const r=new Set;for(const[t,o]of u)r.add(t),d.get(t)!==o&&this.n(h,t);for(const[t]of d.items)r.has(t)||this.n(h,t)}})}}e.AbstractStorageService=f,f.a=60*1e3;function y(m){return m.isDefault||!!m.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=y;class v extends f{constructor(){super(),this.p=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(u=>this.n(1,u))),this.B(this.P.onDidChangeStorage(u=>this.n(0,u))),this.B(this.p.onDidChangeStorage(u=>this.n(-1,u)))}L(u){switch(u){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(u){switch(u){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(u){return!1}}e.InMemoryStorageService=v;async function l(m,u,d,h,n,r){const t=U=>{try{return JSON.parse(U)}catch{return U}},o=new Map,s=new Map;m.forEach((U,z)=>{o.set(z,U),s.set(z,t(U))});const c=new Map,a=new Map;u.forEach((U,z)=>{c.set(z,U),a.set(z,t(U))});const g=new Map,b=new Map;d.forEach((U,z)=>{g.set(z,U),b.set(z,t(U))}),console.group(h!==n?`Storage: Application (path: ${h})`:`Storage: Application & Profile (path: ${h}, default profile)`);const R=[];if(o.forEach((U,z)=>{R.push({key:z,value:U})}),console.table(R),console.groupEnd(),console.log(s),h!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const U=[];c.forEach((z,F)=>{U.push({key:F,value:z})}),console.table(U),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${r})`);const j=[];g.forEach((U,z)=>{j.push({key:z,value:U})}),console.table(j),console.groupEnd(),console.log(b)}e.logStorage=l}),define(oe[116],ae([0,1,3,2,14,29,33,19]),function(ee,e,k,i,D,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let I=class extends i.Disposable{constructor(E,w){super(),this.a=new k.Emitter,this.onDidChangeEnablement=this.a.event,this.b=this.B(new S(E)),this.B(this.b.onDidChange(p=>this.a.fire({extensions:p,source:"storage"}))),this.B(w.onDidInstallExtensions(p=>p.forEach(({local:f,operation:y})=>{f&&y===4&&this.f(f.identifier)})))}async enableExtension(E,w){return this.f(E)?(this.a.fire({extensions:[E],source:w}),!0):!1}async disableExtension(E,w){return this.c(E)?(this.a.fire({extensions:[E],source:w}),!0):!1}getDisabledExtensions(){return this.h(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(E){const w=this.getDisabledExtensions();return w.every(p=>!(0,O.areSameExtensions)(p,E))?(w.push(E),this.g(w),!0):!1}f(E){const w=this.getDisabledExtensions();for(let p=0;p<w.length;p++){const f=w[p];if((0,O.areSameExtensions)(f,E))return w.splice(p,1),this.g(w),!0}return!1}g(E){this.i(A.DISABLED_EXTENSIONS_STORAGE_PATH,E)}h(E){return this.b.get(E,0)}i(E,w){this.b.set(E,w,0)}};I=pe([Y(0,P.IStorageService),Y(1,A.IExtensionManagementService)],I),e.GlobalExtensionEnablementService=I;class S extends i.Disposable{constructor(E){super(),this.c=E,this.a=Object.create(null),this.b=this.B(new k.Emitter),this.onDidChange=this.b.event,this.B(E.onDidChangeValue(w=>this.f(w)))}get(E,w){let p;return w===0?((0,D.isUndefinedOrNull)(this.a[E])&&(this.a[E]=this.g(E,w)),p=this.a[E]):p=this.g(E,w),JSON.parse(p)}set(E,w,p){const f=JSON.stringify(w.map(({id:v,uuid:l})=>({id:v,uuid:l})));this.g(E,p)!==f&&(p===0&&(w.length?this.a[E]=f:delete this.a[E]),this.h(E,w.length?f:void 0,p))}f(E){if(E.scope===0&&!(0,D.isUndefinedOrNull)(this.a[E.key])&&this.g(E.key,E.scope)!==this.a[E.key]){const p=this.get(E.key,E.scope);delete this.a[E.key];const f=this.get(E.key,E.scope),y=p.filter(l=>!f.some(m=>(0,O.areSameExtensions)(l,m))),v=f.filter(l=>!p.some(m=>(0,O.areSameExtensions)(m,l)));(y.length||v.length)&&this.b.fire([...y,...v])}}g(E,w){return this.c.get(E,w,"[]")}h(E,w,p){w?this.c.store(E,w,p,1):this.c.remove(E,p)}}e.StorageManager=S}),define(oe[265],ae([0,1,20,23,9,5,36,14,7,16,15,29,33,70,13,8,25,59,236,19,22]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p,f,y,v,l,m,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const h=A.isWeb?"web":(0,E.getTargetPlatform)(A.platform,O.arch);var n;(function(T){T[T.None=0]="None",T[T.IncludeVersions=1]="IncludeVersions",T[T.IncludeFiles=2]="IncludeFiles",T[T.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",T[T.IncludeSharedAccounts=8]="IncludeSharedAccounts",T[T.IncludeVersionProperties=16]="IncludeVersionProperties",T[T.ExcludeNonValidated=32]="ExcludeNonValidated",T[T.IncludeInstallationTargets=64]="IncludeInstallationTargets",T[T.IncludeAssetUri=128]="IncludeAssetUri",T[T.IncludeStatistics=256]="IncludeStatistics",T[T.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",T[T.Unpublished=4096]="Unpublished",T[T.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function r(...T){return String(T.reduce((N,H)=>N|H,0))}var t;(function(T){T[T.Tag=1]="Tag",T[T.ExtensionId=4]="ExtensionId",T[T.Category=5]="Category",T[T.ExtensionName=7]="ExtensionName",T[T.Target=8]="Target",T[T.Featured=9]="Featured",T[T.SearchText=10]="SearchText",T[T.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class g{constructor(N=a){this.d=N}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(N,H=this.d.pageSize){return new g({...this.d,pageNumber:N,pageSize:H})}withFilter(N,...H){const B=[...this.d.criteria,...H.length?H.map(Q=>({filterType:N,value:Q})):[{filterType:N}]];return new g({...this.d,criteria:B})}withSortBy(N){return new g({...this.d,sortBy:N})}withSortOrder(N){return new g({...this.d,sortOrder:N})}withFlags(...N){return new g({...this.d,flags:N.reduce((H,B)=>H|B,0)})}withAssetTypes(...N){return new g({...this.d,assetTypes:N})}withSource(N){return new g({...this.d,source:N})}get raw(){const{criteria:N,pageNumber:H,pageSize:B,sortBy:Q,sortOrder:re,flags:X,assetTypes:te}=this.d;return{filters:[{criteria:N,pageNumber:H,pageSize:B,sortBy:Q,sortOrder:re}],assetTypes:te,flags:X}}get searchText(){const N=this.d.criteria.filter(H=>H.filterType===t.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(N=>String(N.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function b(T,N){const H=(T||[]).filter(B=>B.statisticName===N)[0];return H?H.value:0}function R(T){const N="Microsoft.VisualStudio.Code.Translation.";return T.files.filter(B=>B.assetType.indexOf(N)===0).reduce((B,Q)=>{const re=z(T,Q.assetType);return re&&B.push([Q.assetType.substring(N.length),re]),B},[])}function j(T){if(T.properties){const N=T.properties.filter(Q=>Q.key===o.Repository),H=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),B=N.filter(Q=>H.test(Q.value))[0];return B?{uri:B.value,fallbackUri:B.value}:null}return z(T,o.Repository)}function U(T){return{uri:`${T.fallbackAssetUri}/${o.VSIX}?redirect=true${T.targetPlatform?`&targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${o.VSIX}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}}function z(T,N){return T.files.filter(B=>B.assetType===N)[0]?{uri:`${T.assetUri}/${N}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${N}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}:null}function F(T,N){const H=T.properties?T.properties.filter(Q=>Q.key===N):[],B=H.length>0&&H[0].value;return B?B.split(",").map(Q=>(0,w.adoptToGalleryExtensionId)(Q)):[]}function L(T){const N=T.properties?T.properties.filter(H=>H.key===s.Engine):[];return N.length>0&&N[0].value||""}function M(T){const N=T.properties?T.properties.filter(H=>H.key===s.PreRelease):[];return N.length>0&&N[0].value==="true"}function $(T){const N=T.properties?T.properties.filter(B=>B.key===s.LocalizedLanguages):[],H=N.length>0&&N[0].value||"";return H?H.split(","):[]}function G(T){return T.properties?.find(N=>N.key===s.SponsorLink)?.value}function W(T){return T.indexOf("preview")!==-1}function _(T){return T.targetPlatform?(0,E.toTargetPlatform)(T.targetPlatform):"undefined"}function K(T){const N=(0,k.distinct)(T.versions.map(_)),H=!!T.tags?.includes(E.WEB_EXTENSION_TAG),B=N.indexOf("web");return H?B===-1&&N.push("web"):B!==-1&&N.splice(B,1),N}function q(T,N){const H=(0,E.getFallbackTargetPlarforms)(N);for(let B=0;B<T.length;B++){const Q=T[B];if(Q.version===T[B-1]?.version){let re=B;const X=_(Q);if(X===N)for(;re>0&&T[re-1].version===Q.version;)re--;else if(H.includes(X))for(;re>0&&T[re-1].version===Q.version&&_(T[re-1])!==N;)re--;re!==B&&(T.splice(B,1),T.splice(re,0,Q))}}return T}e.sortExtensionVersions=q;function V(T,N,H){T.telemetryData={index:N,querySource:H}}function Z(T,N,H){const B=T.versions[0],Q={manifest:z(N,o.Manifest),readme:z(N,o.Details),changelog:z(N,o.Changelog),license:z(N,o.License),repository:j(N),download:U(N),icon:z(N,o.Icon),signature:z(N,o.Signature),coreTranslations:R(N)};return{identifier:{id:(0,w.getGalleryExtensionId)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},name:T.extensionName,version:N.version,displayName:T.displayName,publisherId:T.publisher.publisherId,publisher:T.publisher.publisherName,publisherDisplayName:T.publisher.displayName,publisherDomain:T.publisher.domain?{link:T.publisher.domain,verified:!!T.publisher.isDomainVerified}:void 0,publisherSponsorLink:G(B),description:T.shortDescription||"",installCount:b(T.statistics,"install"),rating:b(T.statistics,"averagerating"),ratingCount:b(T.statistics,"ratingcount"),categories:T.categories||[],tags:T.tags||[],releaseDate:Date.parse(T.releaseDate),lastUpdated:Date.parse(T.lastUpdated),allTargetPlatforms:H,assets:Q,properties:{dependencies:F(N,s.Dependency),extensionPack:F(N,s.ExtensionPack),engine:L(N),localizedLanguages:$(N),targetPlatform:_(N),isPreReleaseVersion:M(N)},hasPreReleaseVersion:M(B),hasReleaseVersion:!0,preview:W(T.flags),isSigned:!!Q.signature}}let ne=class{constructor(N,H,B,Q,re,X,te,se){this.k=H,this.l=B,this.n=Q,this.o=re,this.q=X,this.u=te,this.w=se;const le=te.extensionsGallery,ue=le?.servicePPEUrl&&se.getValue("_extensionsGallery.enablePPE");this.d=ue?le.servicePPEUrl:le?.serviceUrl,this.g=ue?void 0:le?.searchUrl,this.h=le?.controlUrl,this.j=(0,m.resolveMarketplaceHeaders)(te.version,te,this.n,this.w,this.q,N,this.o)}x(N=""){return`${this.d}${N}`}isEnabled(){return!!this.d}async getExtensions(N,H,B){const Q=i.CancellationToken.isCancellationToken(H)?{}:H,re=i.CancellationToken.isCancellationToken(H)?H:B,X=[],te=[],se=[],le=[];let ue=!0;for(const be of N){be.uuid?te.push(be.uuid):X.push(be.id);const Ee=!!(be.version||be.preRelease);se.push({id:be.id,uuid:be.uuid,includePreRelease:Ee}),be.version&&le.push({id:be.id,uuid:be.uuid,version:be.version}),ue=ue&&!!be.hasPreRelease&&!Ee}if(!te.length&&!X.length)return[];let ye=new g().withPage(1,N.length);te.length&&(ye=ye.withFilter(t.ExtensionId,...te)),X.length&&(ye=ye.withFilter(t.ExtensionName,...X)),(Q.queryAllVersions||ue)&&(ye=ye.withFlags(ye.flags,n.IncludeVersions)),Q.source&&(ye=ye.withSource(Q.source));const{extensions:Se}=await this.z(ye,{targetPlatform:Q.targetPlatform??h,includePreRelease:se,versions:le,compatible:!!Q.compatible},re);return Q.source&&Se.forEach((be,Ee)=>V(be,Ee,Q.source)),Se}async getCompatibleExtension(N,H,B){if((0,E.isNotWebExtensionInWebTargetPlatform)(N.allTargetPlatforms,B))return null;if(await this.isExtensionCompatible(N,H,B))return N;const Q=new g().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,N.identifier.uuid),{extensions:re}=await this.z(Q,{targetPlatform:B,compatible:!0,includePreRelease:H},i.CancellationToken.None);return re[0]||null}async isExtensionCompatible(N,H,B){if(!(0,E.isTargetPlatformCompatible)(N.properties.targetPlatform,N.allTargetPlatforms,B)||!H&&N.properties.isPreReleaseVersion)return!1;let Q=N.properties.engine;if(!Q){const re=await this.getManifest(N,i.CancellationToken.None);if(!re)throw new Error("Manifest was not found");Q=re.engines.vscode}return(0,p.isEngineValid)(Q,this.u.version,this.u.date)}async y(N,H,B,Q,re){if(!(0,E.isTargetPlatformCompatible)(_(N),Q,re)||H!=="any"&&M(N)!==(H==="prerelease"))return!1;if(B)try{const X=await this.E(N);if(!(0,p.isEngineValid)(X,this.u.version,this.u.date))return!1}catch(X){return this.l.error(`Error while getting the engine for the version ${N.version}.`,(0,D.getErrorMessage)(X)),!1}return!0}async query(N,H){let B=N.text||"";const Q=N.pageSize??50;let re=new g().withPage(1,Q);B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ye,Se)=>(re=re.withFilter(t.Category,Se||ye),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ye,Se)=>(re=re.withFilter(t.Tag,Se||ye),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(re=re.withFilter(t.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),re=re.withFilter(t.SearchText,B)),re=re.withSortBy(0)):N.ids?re=re.withFilter(t.ExtensionId,...N.ids):N.names?re=re.withFilter(t.ExtensionName,...N.names):re=re.withSortBy(4),typeof N.sortBy=="number"&&(re=re.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(re=re.withSortOrder(N.sortOrder)),N.source&&(re=re.withSource(N.source));const X=async(ue,ye)=>{const{extensions:Se,total:be}=await this.z(ue,{targetPlatform:h,compatible:!1,includePreRelease:!!N.includePreRelease},ye);return Se.forEach((Ee,Ne)=>V(Ee,(ue.pageNumber-1)*ue.pageSize+Ne,N.source)),{extensions:Se,total:be}},{extensions:te,total:se}=await X(re,H),le=async(ue,ye)=>{if(ye.isCancellationRequested)throw new D.CancellationError;const{extensions:Se}=await X(re.withPage(ue+1),ye);return Se};return{firstPage:te,total:se,pageSize:re.pageSize,getPage:le}}async z(N,H,B){const Q=N.flags;!!(N.flags&n.IncludeLatestVersionOnly)&&!!(N.flags&n.IncludeVersions)&&(N=N.withFlags(N.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(N.flags&n.IncludeLatestVersionOnly)&&!(N.flags&n.IncludeVersions)&&(N=N.withFlags(N.flags,n.IncludeLatestVersionOnly)),H.versions?.length&&(N=N.withFlags(N.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),N=N.withFlags(N.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:re,total:X}=await this.B(N,B);if(!(N.flags&n.IncludeLatestVersionOnly)){const ue=[];for(const ye of re){const Se=await this.A(ye,H);Se&&ue.push(Se)}return{extensions:ue,total:X}}const se=[],le=new Map;for(let ue=0;ue<re.length;ue++){const ye=re[ue],Se={id:(0,w.getGalleryExtensionId)(ye.publisher.publisherName,ye.extensionName),uuid:ye.extensionId},be=(0,P.isBoolean)(H.includePreRelease)?H.includePreRelease:!!H.includePreRelease.find(Ne=>(0,w.areSameExtensions)(Ne,Se))?.includePreRelease;if(H.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(K(ye),H.targetPlatform))continue;const Ee=await this.A(ye,H);!Ee||Ee.properties.isPreReleaseVersion&&(!be||!Ee.hasReleaseVersion)||!Ee.properties.isPreReleaseVersion&&Ee.properties.targetPlatform!==H.targetPlatform&&Ee.hasPreReleaseVersion?le.set(ye.extensionId,ue):se.push([ue,Ee])}if(le.size){const ue=new Date().getTime(),ye=new g().withFlags(Q&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,le.size).withFilter(t.ExtensionId,...le.keys()),{extensions:Se}=await this.z(ye,H,B);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ue,count:le.size});for(const be of Se){const Ee=le.get(be.identifier.uuid);se.push([Ee,be])}}return{extensions:se.sort((ue,ye)=>ue[0]-ye[0]).map(([,ue])=>ue),total:X}}async A(N,H){const B={id:(0,w.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},Q=H.versions?.find(se=>(0,w.areSameExtensions)(se,B))?.version,re=(0,P.isBoolean)(H.includePreRelease)?H.includePreRelease:!!H.includePreRelease.find(se=>(0,w.areSameExtensions)(se,B))?.includePreRelease,X=K(N),te=q(N.versions,H.targetPlatform);if(H.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(X,H.targetPlatform))return null;for(let se=0;se<te.length;se++){const le=te[se];if(!(Q&&le.version!==Q)){if(await this.y(le,re?"any":"release",H.compatible,X,H.targetPlatform))return Z(N,le,X);if(Q&&le.version===Q)return null}}return Q||H.compatible?null:Z(N,N.versions[0],X)}async B(N,H){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,r(n.Unpublished));const B=await this.j,Q=JSON.stringify(N.raw),re={...B,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Q.length)},X=new Date().getTime();let te,se,le=0;try{if(te=await this.k.request({type:"POST",url:this.g&&N.criteria.some(ye=>ye.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:Q,headers:re},H),te.res.statusCode&&te.res.statusCode>=400&&te.res.statusCode<500)return{galleryExtensions:[],total:le};const ue=await(0,l.asJson)(te);if(ue){const ye=ue.results[0],Se=ye.extensions,be=ye.resultMetadata&&ye.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return le=be&&be.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:Se,total:le}}return{galleryExtensions:[],total:le}}catch(ue){throw se=ue,ue}finally{this.o.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(Q.length),duration:new Date().getTime()-X,success:!!te&&(0,l.isSuccess)(te),responseBodySize:te?.res.headers["Content-Length"],statusCode:te?String(te.res.statusCode):void 0,errorCode:se?(0,D.isCancellationError)(se)?"canceled":(0,D.getErrorMessage)(se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(le)})}}async reportStatistic(N,H,B,Q){if(!this.isEnabled())return;const re=A.isWeb?this.x(`/itemName/${N}.${H}/version/${B}/statType/${Q==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${N}/extensions/${H}/${B}/stats?statType=${Q}`),X=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",se={...await this.j,Accept:X};try{await this.k.request({type:"POST",url:re,headers:se},i.CancellationToken.None)}catch{}}async download(N,H,B){this.l.trace("ExtensionGalleryService#download",N.identifier.id);const Q=(0,w.getGalleryExtensionTelemetryData)(N),re=new Date().getTime(),X=ue=>this.o.publicLog("galleryService:downloadVSIX",{...Q,duration:ue}),te=B===2?"install":B===3?"update":"",se=te?{uri:`${N.assets.download.uri}${I.URI.parse(N.assets.download.uri).query?"&":"?"}${te}=true`,fallbackUri:`${N.assets.download.fallbackUri}${I.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${te}=true`}:N.assets.download,le=await this.D(se);await this.q.writeFile(H,le.stream),X(new Date().getTime()-re)}async downloadSignatureArchive(N,H){if(!N.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",N.identifier.id);const B=await this.D(N.assets.signature);await this.q.writeFile(H,B.stream)}async getReadme(N,H){if(N.assets.readme){const B=await this.D(N.assets.readme,{},H);return await(0,l.asTextOrError)(B)||""}return""}async getManifest(N,H){if(N.assets.manifest){const B=await this.D(N.assets.manifest,{},H),Q=await(0,l.asTextOrError)(B);return Q?JSON.parse(Q):null}return null}async C(N,H){const B=z(N,o.Manifest);if(!B)throw new Error("Manifest was not found");const Q={"Accept-Encoding":"gzip"},re=await this.D(B,{headers:Q});return await(0,l.asJson)(re)}async getCoreTranslation(N,H){const B=N.assets.coreTranslations.filter(Q=>Q[0]===H.toUpperCase())[0];if(B){const Q=await this.D(B[1]),re=await(0,l.asTextOrError)(Q);return re?JSON.parse(re):null}return null}async getChangelog(N,H){if(N.assets.changelog){const B=await this.D(N.assets.changelog,{},H);return await(0,l.asTextOrError)(B)||""}return""}async getAllCompatibleVersions(N,H,B){let Q=new g().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);N.identifier.uuid?Q=Q.withFilter(t.ExtensionId,N.identifier.uuid):Q=Q.withFilter(t.ExtensionName,N.identifier.id);const{galleryExtensions:re}=await this.B(Q,i.CancellationToken.None);if(!re.length)return[];const X=K(re[0]);if((0,E.isNotWebExtensionInWebTargetPlatform)(X,B))return[];const te=[];await Promise.all(re[0].versions.map(async ue=>{try{await this.y(ue,H?"any":"release",!0,X,B)&&te.push(ue)}catch{}}));const se=[],le=new Set;for(const ue of q(te,B))le.has(ue.version)||(le.add(ue.version),se.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:M(ue)}));return se}async D(N,H={},B=i.CancellationToken.None){const Q=await this.j,re={type:"GET"},X={...Q,...H.headers||{}};H={...H,...re,headers:X};const te=N.uri,se=N.fallbackUri,le={...H,url:te};try{const ue=await this.k.request(le,B);if(ue.res.statusCode===200)return ue;const ye=await(0,l.asTextOrError)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${ye}`)}catch(ue){if((0,D.isCancellationError)(ue))throw ue;const ye=(0,D.getErrorMessage)(ue);this.o.publicLog2("galleryService:cdnFallback",{url:te,message:ye});const Se={...H,url:se};return this.k.request(Se,B)}}async E(N){let H=L(N);if(!H){const B=await this.C(N,i.CancellationToken.None);if(!B)throw new Error("Manifest was not found");H=B.engines.vscode}return H}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const N=await this.k.request({type:"GET",url:this.h},i.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const H=await(0,l.asJson)(N),B=[],Q={};if(H){for(const re of H.malicious)B.push({id:re});if(H.migrateToPreRelease)for(const[re,X]of Object.entries(H.migrateToPreRelease))(!X.engine||(0,p.isEngineValid)(X.engine,this.u.version,this.u.date))&&(Q[re.toLowerCase()]={disallowInstall:!0,extension:{id:X.id,displayName:X.displayName,autoMigrate:{storage:!!X.migrateStorage},preRelease:!0}});if(H.deprecated)for(const[re,X]of Object.entries(H.deprecated))X&&(Q[re.toLowerCase()]=(0,P.isBoolean)(X)?{}:X)}return{malicious:B,deprecated:Q}}};ne=pe([Y(1,l.IRequestService),Y(2,y.ILogService),Y(3,C.IEnvironmentService),Y(4,d.ITelemetryService),Y(5,f.IFileService),Y(6,v.IProductService),Y(7,S.IConfigurationService)],ne);let J=class extends ne{constructor(N,H,B,Q,re,X,te,se){super(N,H,B,Q,re,X,te,se)}};J=pe([Y(0,u.IStorageService),Y(1,l.IRequestService),Y(2,y.ILogService),Y(3,C.IEnvironmentService),Y(4,d.ITelemetryService),Y(5,f.IFileService),Y(6,v.IProductService),Y(7,S.IConfigurationService)],J),e.ExtensionGalleryService=J;let x=class extends ne{constructor(N,H,B,Q,re,X,te){super(void 0,N,H,B,Q,re,X,te)}};x=pe([Y(0,l.IRequestService),Y(1,y.ILogService),Y(2,C.IEnvironmentService),Y(3,d.ITelemetryService),Y(4,f.IFileService),Y(5,v.IProductService),Y(6,S.IConfigurationService)],x),e.ExtensionGalleryServiceWithNoStorageService=x}),define(oe[80],ae([0,1,4,3,2,19,33,25,20,8,14]),function(ee,e,k,i,D,A,O,P,I,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,k.createDecorator)("IExtensionStorageService");const E=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let w=class Ze extends D.Disposable{static b(f){return`extensionKeys/${(0,O.adoptToGalleryExtensionId)(f.id)}@${f.version}`}static c(f){const y=E.exec(f);if(y&&y[1])return{id:y[1],version:y[2]}}static async removeOutdatedExtensionVersions(f,y){const v=await f.getInstalled(),l=[];for(const[m,u]of Ze.f(y)){const d=v.find(h=>(0,O.areSameExtensions)(h.identifier,{id:m}))?.manifest.version;for(const h of u)d!==h&&l.push(Ze.b({id:m,version:h}))}for(const m of l)y.remove(m,0)}static f(f){const y=new Map,v=f.keys(0,1);for(const l of v){const m=Ze.c(l);if(m){let u=y.get(m.id.toLowerCase());u||y.set(m.id.toLowerCase(),u=[]),u.push(m.version)}}return y}constructor(f,y,v){super(),this.i=f,this.j=y,this.k=v,this.g=this.B(new i.Emitter),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=Ze.f(f),this.B(this.i.onDidChangeValue(l=>this.l(l)))}l(f){if(f.scope!==0)return;if(this.h.has(f.key.toLowerCase())){this.g.fire();return}const y=Ze.c(f.key);if(y){if(this.i.get(f.key,0)===void 0)this.h.delete(y.id.toLowerCase());else{let v=this.h.get(y.id.toLowerCase());v||this.h.set(y.id.toLowerCase(),v=[]),v.push(y.version),this.g.fire()}return}}m(f){if((0,C.isString)(f))return f;const y=f.manifest?f.manifest.publisher:f.publisher,v=f.manifest?f.manifest.name:f.name;return(0,O.getExtensionId)(y,v)}getExtensionState(f,y){const v=this.m(f),l=this.getExtensionStateRaw(f,y);if(l)try{return JSON.parse(l)}catch(m){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${v}, global: ${y}): ${m}`)}}getExtensionStateRaw(f,y){const v=this.m(f),l=this.i.get(v,y?0:1);return l&&l?.length>Ze.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${v}, global: ${y}): ${l.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),l}setExtensionState(f,y,v){const l=this.m(f);y===void 0?this.i.remove(l,v?0:1):this.i.store(l,JSON.stringify(y),v?0:1,1)}setKeysForSync(f,y){this.i.store(Ze.b(f),JSON.stringify(y),0,1)}getKeysForSync(f){const y=this.j.extensionSyncedKeys?.[f.id.toLowerCase()],v=this.i.get(Ze.b(f),0),l=v?JSON.parse(v):void 0;return l&&y?(0,I.distinct)([...l,...y]):l||y}addToMigrationList(f,y){if(f!==y){const v=this.n.filter(l=>!l.includes(f)&&!l.includes(y));v.push([f,y]),this.n=v}}getSourceExtensionToMigrate(f){const y=this.n.find(([,v])=>f===v);return y?y[0]:void 0}get n(){const f=this.i.get("extensionStorage.migrationList",-1,"[]");try{const y=JSON.parse(f);if(Array.isArray(y))return y}catch{}return[]}set n(f){f.length?this.i.store("extensionStorage.migrationList",JSON.stringify(f),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};w.a=512*1024,w=pe([Y(0,A.IStorageService),Y(1,P.IProductService),Y(2,S.ILogService)],w),e.ExtensionStorageService=w}),define(oe[266],ae([0,1,20,6,3,12,5,36,7,158,15,29,33,211,98,13,57,25,19,22]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p,f,y,v,l,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const d="extensionTips/promptedExecutableTips",h="extensionTips/lastPromptedMediumImpExeTime";let n=class extends p.ExtensionTipsService{constructor(t,o,s,c,a,g,b,R){super(b,R),this.m=t,this.n=o,this.p=s,this.r=c,this.s=a,this.t=g,this.g=new Map,this.h=new Map,this.j=new Map,this.k=new Map,this.l=new Map,R.exeBasedExtensionTips&&Object.entries(R.exeBasedExtensionTips).forEach(([j,U])=>{const z=[],F=[],L=[];Object.entries(U.recommendations).forEach(([M,$])=>{$.important?U.important?z.push({extensionId:M,extensionName:$.name,isExtensionPack:!!$.isExtensionPack}):F.push({extensionId:M,extensionName:$.name,isExtensionPack:!!$.isExtensionPack}):L.push({extensionId:M,extensionName:$.name,isExtensionPack:!!$.isExtensionPack})}),z.length&&this.g.set(j,{exeFriendlyName:U.friendlyName,windowsPath:U.windowsPath,recommendations:z}),F.length&&this.h.set(j,{exeFriendlyName:U.friendlyName,windowsPath:U.windowsPath,recommendations:F}),L.length&&this.j.set(j,{exeFriendlyName:U.friendlyName,windowsPath:U.windowsPath,recommendations:L})}),(0,i.timeout)(3e3).then(async()=>{await this.u(),this.w(),this.y()})}async getImportantExecutableBasedTips(){const t=await this.I(this.g),o=await this.I(this.h);return[...t,...o]}getOtherExecutableBasedTips(){return this.I(this.j)}async u(){const t=await this.I(this.g),o=await this.I(this.h),s=await this.p.getInstalled();this.k=this.v(t,s),this.l=this.v(o,s)}v(t,o){const s=new Map;t.forEach(R=>s.set(R.extensionId.toLowerCase(),R));const{installed:c,uninstalled:a}=this.H([...s.keys()],o);for(const R of c){const j=s.get(R);j&&this.n.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:R,exeName:j.exeName})}for(const R of a){const j=s.get(R);j&&this.n.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:R,exeName:j.exeName})}const g=this.F(),b=new Map;for(const R of a){const j=s.get(R);if(j&&(!g[j.exeName]||!g[j.exeName].includes(j.extensionId))){let U=b.get(j.exeName);U||(U=[],b.set(j.exeName,U)),U.push(j)}}return b}w(){if(this.k.size===0)return;const[t,o]=[...this.k.entries()][0];this.z(o).then(s=>{switch(s){case"reacted":this.G(o[0].exeName,o);break;case"ignored":this.k.delete(t);break;case"incompatibleWindow":{const c=D.Event.once(D.Event.latch(D.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(c(()=>this.w()));break}case"toomany":{const c=this.B((0,i.disposableTimeout)(()=>{c.dispose(),this.w()},36e5));break}}})}y(){if(this.l.size===0)return;const t=this.C(),o=Date.now()-t,s=7*24*60*60*1e3;if(o<s){const g=this.B((0,i.disposableTimeout)(()=>{g.dispose(),this.y()},s-o));return}const[c,a]=[...this.l.entries()][0];this.z(a).then(g=>{switch(g){case"reacted":{this.D(Date.now()),this.l.delete(c),this.G(a[0].exeName,a);const b=this.B((0,i.disposableTimeout)(()=>{b.dispose(),this.y()},s));break}case"ignored":this.l.delete(c),this.y();break;case"incompatibleWindow":{const b=D.Event.once(D.Event.latch(D.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(b(()=>this.y()));break}case"toomany":{const b=this.B((0,i.disposableTimeout)(()=>{b.dispose(),this.y()},36e5));break}}})}async z(t){const o=await this.p.getInstalled(1),s=t.filter(a=>!a.whenNotInstalled||a.whenNotInstalled.every(g=>o.every(b=>!(0,w.areSameExtensions)(b.identifier,{id:g})))).map(({extensionId:a})=>a.toLowerCase()),c=(0,S.localize)(0,null,t[0].exeFriendlyName);return this.t.promptImportantExtensionsInstallNotification(s,c,`@exe:"${t[0].exeName}"`,3)}C(){let t=this.r.getNumber(h,-1);return t||(t=Date.now(),this.D(t)),t}D(t){this.r.store(h,t,-1,1)}F(){return JSON.parse(this.r.get(d,-1,"{}"))}G(t,o){const s=this.F();s[t]=o.map(({extensionId:c})=>c.toLowerCase()),this.r.store(d,JSON.stringify(s),-1,0)}H(t,o){const s=[],c=[],a=o.reduce((g,b)=>(g.add(b.identifier.id.toLowerCase()),g),new Set);return t.forEach(g=>{a.has(g.toLowerCase())?s.push(g):c.push(g)}),{installed:s,uninstalled:c}}async I(t){const o=[],s=new Map;for(const c of t.keys()){const a=t.get(c);if(!a||!(0,k.isNonEmptyArray)(a.recommendations))continue;const g=[];O.isWindows?a.windowsPath&&g.push(a.windowsPath.replace("%USERPROFILE%",()=>P.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>P.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>P.env.ProgramFiles).replace("%APPDATA%",()=>P.env.APPDATA).replace("%WINDIR%",()=>P.env.WINDIR)):(g.push((0,A.join)("/usr/local/bin",c)),g.push((0,A.join)("/usr/bin",c)),g.push((0,A.join)(this.m.userHome.fsPath,c)));for(const b of g){let R=s.get(b);if(R===void 0&&(R=await this.b.exists(I.URI.file(b)),s.set(b,R)),R)for(const{extensionId:j,extensionName:U,isExtensionPack:z,whenNotInstalled:F}of a.recommendations)o.push({extensionId:j,extensionName:U,isExtensionPack:z,exeName:c,exeFriendlyName:a.exeFriendlyName,windowsPath:a.windowsPath,whenNotInstalled:F})}}return o}};n=pe([Y(0,C.INativeEnvironmentService),Y(1,u.ITelemetryService),Y(2,E.IExtensionManagementService),Y(3,m.IStorageService),Y(4,v.INativeHostService),Y(5,f.IExtensionRecommendationNotificationService),Y(6,y.IFileService),Y(7,l.IProductService)],n),e.ExtensionTipsService=n}),define(oe[267],ae([0,1,6,2,21,69,19,76,18]),function(ee,e,k,i,D,A,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class S extends O.AbstractStorageService{constructor(E,w,p,f){super(),this.X=E,this.Y=w,this.Z=p,this.ab=f,this.p=this.Y.defaultProfile,this.s=this.bb(),this.P=this.Y.currentProfile,this.Q=this.B(new i.DisposableStore),this.R=this.cb(this.P),this.S=this.X?.id,this.U=this.B(new i.DisposableStore),this.W=this.db(this.X)}bb(){const E=this.B(new P.ApplicationStorageDatabaseClient(this.Z.getChannel("storage"))),w=this.B(new A.Storage(E));return this.B(w.onDidChangeStorage(p=>this.n(-1,p))),w}cb(E){this.Q.clear(),this.P=E;let w;if((0,O.isProfileUsingDefaultStorage)(E))w=this.s;else{const p=this.Q.add(new P.ProfileStorageDatabaseClient(this.Z.getChannel("storage"),E));w=this.Q.add(new A.Storage(p))}return this.Q.add(w.onDidChangeStorage(p=>this.n(0,p))),w}db(E){this.U.clear(),this.S=E?.id;let w;if(E){const p=this.U.add(new P.WorkspaceStorageDatabaseClient(this.Z.getChannel("storage"),E));w=this.U.add(new A.Storage(p)),this.U.add(w.onDidChangeStorage(f=>this.n(1,f)))}return w}async J(){await k.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(E){switch(E){case-1:return this.s;case 0:return this.R;default:return this.W}}M(E){switch(E){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,D.joinPath)(this.ab.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.r(O.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(E,w){if(!this.H(this.P,E))return;const p=this.R,f=p.items;p!==this.s&&await p.close(),this.R=this.cb(E),await this.R.init(),this.I(f,this.R,0,w)}async O(E,w){const p=this.W,f=p?.items??new Map;await p?.close(),this.W=this.db(E),await this.W.init(),this.I(f,this.W,1,w)}hasScope(E){return(0,I.isUserDataProfile)(E)?this.P.id===E.id:this.S===E.id}}e.NativeStorageService=S}),define(oe[62],ae([0,1,2,69,4,19]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,D.createDecorator)("IUserDataProfileStorageService");let O=class extends k.Disposable{constructor(S){super(),this.a=S}async readStorageData(S){return this.withProfileScopedStorageService(S,async C=>this.b(C))}async updateStorageData(S,C,E){return this.withProfileScopedStorageService(S,async w=>this.c(w,C,E))}async withProfileScopedStorageService(S,C){if(this.a.hasScope(S))return C(this.a);const E=await this.createStorageDatabase(S),w=new P(E);try{await w.initialize();const p=await C(w);return await w.flush(),p}finally{w.dispose(),await this.f(E)}}b(S){const C=new Map,E=w=>{for(const p of S.keys(0,w))C.set(p,{value:S.get(p,0),target:w})};return E(0),E(1),C}c(S,C,E){for(const[w,p]of C)S.store(w,p,0,E)}async f(S){try{await S.close()}finally{(0,k.isDisposable)(S)&&S.dispose()}}};O=pe([Y(0,A.IStorageService)],O),e.AbstractUserDataProfileStorageService=O;class P extends A.AbstractStorageService{constructor(S){super({flushInterval:100}),this.p=this.B(new i.Storage(S))}J(){return this.p.init()}L(S){return S===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(oe[268],ae([0,1,3,2,21,15,56,18]),function(ee,e,k,i,D,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let I=class extends i.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.b}constructor(C,E,w){super(),this.b=[],this.c=this.B(new k.Emitter),this.onDidChangeProfiles=this.c.event,this.f=!0,this.a=E.getChannel("userDataProfiles"),this.profilesHome=(0,D.joinPath)(w.userRoamingDataHome,"profiles"),this.b=C.map(p=>(0,P.reviveProfile)(p,this.profilesHome.scheme)),this.B(this.a.listen("onDidChangeProfiles")(p=>{const f=p.added.map(l=>(0,P.reviveProfile)(l,this.profilesHome.scheme)),y=p.removed.map(l=>(0,P.reviveProfile)(l,this.profilesHome.scheme)),v=p.updated.map(l=>(0,P.reviveProfile)(l,this.profilesHome.scheme));this.b=p.all.map(l=>(0,P.reviveProfile)(l,this.profilesHome.scheme)),this.c.fire({added:f,removed:y,updated:v,all:this.profiles})})),this.onDidResetWorkspaces=this.a.listen("onDidResetWorkspaces")}setEnablement(C){this.f=C}isEnabled(){return this.f}async createNamedProfile(C,E,w){const p=await this.a.call("createNamedProfile",[C,E,w]);return(0,P.reviveProfile)(p,this.profilesHome.scheme)}async createProfile(C,E,w,p){const f=await this.a.call("createProfile",[C,E,w,p]);return(0,P.reviveProfile)(f,this.profilesHome.scheme)}async createTransientProfile(C){const E=await this.a.call("createTransientProfile",[C]);return(0,P.reviveProfile)(E,this.profilesHome.scheme)}async setProfileForWorkspace(C,E){await this.a.call("setProfileForWorkspace",[C,E])}removeProfile(C){return this.a.call("removeProfile",[C])}async updateProfile(C,E){const w=await this.a.call("updateProfile",[C,E]);return(0,P.reviveProfile)(w,this.profilesHome.scheme)}resetWorkspaces(){return this.a.call("resetWorkspaces")}cleanUp(){return this.a.call("cleanUp")}cleanUpTransientProfiles(){return this.a.call("cleanUpTransientProfiles")}};I=pe([Y(1,O.IMainProcessService),Y(2,A.IEnvironmentService)],I),e.UserDataProfilesNativeService=I}),define(oe[269],ae([0,1,3,2,56,8,62,19,76,18,71]),function(ee,e,k,i,D,A,O,P,I,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfileStorageService=void 0;let E=class extends O.AbstractUserDataProfileStorageService{constructor(p,f,y,v){super(y),this.h=p;const l=p.getChannel("profileStorageListener"),m=this.B(new i.MutableDisposable);this.g=this.B(new k.Emitter({onWillAddFirstListener:()=>{m.value=l.listen("onDidChange")(u=>{v.trace("profile storage changes",u),this.g.fire({targetChanges:u.targetChanges.map(d=>(0,S.reviveProfile)(d,f.profilesHome.scheme)),valueChanges:u.valueChanges.map(d=>({...d,profile:(0,S.reviveProfile)(d.profile,f.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>m.value=void 0})),this.onDidChange=this.g.event}async createStorageDatabase(p){const f=this.h.getChannel("storage");return(0,P.isProfileUsingDefaultStorage)(p)?new I.ApplicationStorageDatabaseClient(f):new I.ProfileStorageDatabaseClient(f,p)}};E=pe([Y(0,D.IMainProcessService),Y(1,S.IUserDataProfilesService),Y(2,P.IStorageService),Y(3,A.ILogService)],E),e.UserDataProfileStorageService=E,(0,C.registerSingleton)(O.IUserDataProfileStorageService,E,1)}),define(oe[41],ae([0,1,20,6,17,23,3,35,2,27,14,174,16,15,13,8,45,19,22,30,26,18]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p,f,y,v,l,m,u,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function n(g){return!!(g&&g.ref!==void 0&&typeof g.ref=="string"&&g.ref!==""&&g.syncData!==void 0&&(g.syncData===null||r(g.syncData)))}e.isRemoteUserData=n;function r(g){return!!(g&&g.version!==void 0&&typeof g.version=="number"&&g.content!==void 0&&typeof g.content=="string"&&(Object.keys(g).length===2||Object.keys(g).length===3&&g.machineId!==void 0&&typeof g.machineId=="string"))}e.isSyncData=r;function t(g,b){return`${(0,S.uppercaseFirstLetter)(g)}${b.isDefault?"":` (${b.name})`}`}e.getSyncResourceLogLabel=t;let o=class extends I.Disposable{get status(){return this.k}get conflicts(){return{...this.syncResource,conflicts:this.m}}constructor(b,R,j,U,z,F,L,M,$,G,W,_){super(),this.syncResource=b,this.collection=R,this.C=j,this.D=U,this.F=z,this.G=F,this.H=L,this.I=M,this.J=$,this.L=G,this.M=W,this.c=null,this.k="idle",this.l=this.B(new O.Emitter),this.onDidChangeStatus=this.l.event,this.m=[],this.n=this.B(new O.Emitter),this.onDidChangeConflicts=this.n.event,this.s=new i.ThrottledDelayer(50),this.t=this.B(new O.Emitter),this.onDidChangeLocal=this.t.event,this.v=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.w=!1,this.z={},this.resource=this.syncResource.syncResource,this.y=t(b.syncResource,b.profile),this.h=_.extUri,this.f=this.h.joinPath(U.userDataSyncHome,...(0,d.getPathSegments)(b.profile.isDefault?void 0:b.profile.id,b.syncResource)),this.g=this.h.joinPath(this.f,d.PREVIEW_DIR_NAME),this.u=(0,d.getLastSyncResourceUri)(b.profile.isDefault?void 0:b.profile.id,b.syncResource,U,this.h),this.j=(0,v.getServiceMachineId)(U,j,z)}triggerLocalChange(){this.s.trigger(()=>this.N())}async N(){if(this.status==="hasConflicts"){this.L.info(`${this.y}: In conflicts state and local change detected. Syncing again...`);const b=await this.c;this.c=null;const R=await this.S(b.remoteUserData,b.lastSyncUserData,!0,this.lb());this.O(R)}else{this.L.trace(`${this.y}: Checking for local changes...`);const b=await this.getLastSyncUserData();(b?await this.rb(b):!0)&&this.t.fire()}}O(b){this.k!==b&&(this.k=b,this.l.fire(b))}async sync(b,R={}){await this.P(b,!0,this.lb(),R)}async preview(b,R,j={}){return this.P(b,!1,R,j)}async apply(b,R={}){try{this.z={...R};const j=await this.X(b);return this.O(j),this.c}finally{this.z={}}}async P(b,R,j,U){try{if(this.z={...U},this.status==="hasConflicts")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.L.trace(`${this.y}: Started synchronizing ${this.resource.toLowerCase()}...`),this.O("syncing");let z="idle";try{const F=await this.getLastSyncUserData(),L=await this.R(b,F);return z=await this.S(L,F,R,j),z==="hasConflicts"?this.L.info(`${this.y}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):z==="idle"&&this.L.trace(`${this.y}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.O(z)}}finally{this.z={}}}async replace(b){const R=this.hb(b);if(!R)return!1;await this.stop();try{this.L.trace(`${this.y}: Started resetting ${this.resource.toLowerCase()}...`),this.O("syncing");const j=await this.getLastSyncUserData(),U=await this.R(null,j),z=await this.Q(U),F=await this.nb({ref:U.ref,syncData:R},j,z,this.lb(),A.CancellationToken.None),L=[];for(const M of F){const $=await this.pb(M,M.remoteResource,void 0,A.CancellationToken.None),{remoteChange:G}=await this.pb(M,M.previewResource,M.remoteContent,A.CancellationToken.None);L.push([M,{...$,remoteChange:G!==0?G:2}])}await this.qb(U,j,L,!1),this.L.info(`${this.y}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.O("idle")}return!0}async Q(b){const R=await this.j;return!!b.syncData?.machineId&&b.syncData.machineId===R}async R(b,R){if(R){const j=b?b[this.resource]:void 0;if(R.ref===j||j===void 0&&R.syncData===null)return R}return this.getRemoteUserData(R)}async S(b,R,j,U){if(b.syncData&&b.syncData.version>this.mb)throw this.J.publicLog2("sync/incompatible",{source:this.resource}),new d.UserDataSyncError((0,E.localize)(0,null,this.resource,this.mb,b.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.U(b,R,j,U)}catch(z){if(z instanceof d.UserDataSyncError)switch(z.code){case"LocalPreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize ${this.y} as there is a new local version available. Synchronizing again...`),this.S(b,R,j,U);case"Conflict":case"PreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),b=await this.getRemoteUserData(null),R=await this.getLastSyncUserData(),this.S(b,R,j,U)}throw z}}async U(b,R,j,U){try{const z=await this.Q(b),F=!z&&R===null&&this.db()!==void 0,L=j&&!F;this.c||(this.c=(0,i.createCancelablePromise)($=>this.bb(b,R,z,L,U,$)));let M=await this.c;if(j&&F){this.L.info(`${this.y}: Accepting remote because it was synced before and the last sync data is not available.`);for(const $ of M.resourcePreviews)M=await this.accept($.remoteResource)||M}return this.Z(M.resourcePreviews),M.resourcePreviews.some(({mergeState:$})=>$==="conflict")?"hasConflicts":j?await this.X(!1):"syncing"}catch(z){throw this.c=null,z}}async merge(b){return await this.W(b,async R=>{const j=await this.ob(R,A.CancellationToken.None);await this.C.writeFile(R.previewResource,D.VSBuffer.fromString(j?.content||""));const U=j&&!j.hasConflicts?await this.pb(R,R.previewResource,void 0,A.CancellationToken.None):void 0;return R.acceptResult=U,R.mergeState=j.hasConflicts?"conflict":U?"accepted":"preview",R.localChange=U?U.localChange:j.localChange,R.remoteChange=U?U.remoteChange:j.remoteChange,R}),this.c}async accept(b,R){return await this.W(b,async j=>{const U=await this.pb(j,b,R,A.CancellationToken.None);return j.acceptResult=U,j.mergeState="accepted",j.localChange=U.localChange,j.remoteChange=U.remoteChange,j}),this.c}async discard(b){return await this.W(b,async R=>{const j=await this.ob(R,A.CancellationToken.None);return await this.C.writeFile(R.previewResource,D.VSBuffer.fromString(j.content||"")),R.acceptResult=void 0,R.mergeState="preview",R.localChange=j.localChange,R.remoteChange=j.remoteChange,R}),this.c}async W(b,R){if(!this.c)return;let j=await this.c;const U=j.resourcePreviews.findIndex(({localResource:z,remoteResource:F,previewResource:L})=>this.h.isEqual(z,b)||this.h.isEqual(F,b)||this.h.isEqual(L,b));U!==-1&&(this.c=(0,i.createCancelablePromise)(async z=>{const F=[...j.resourcePreviews];return F[U]=await R(F[U]),{...j,resourcePreviews:F}}),j=await this.c,this.Z(j.resourcePreviews),j.resourcePreviews.some(({mergeState:z})=>z==="conflict")?this.O("hasConflicts"):this.O("syncing"))}async X(b){if(!this.c)return"idle";const R=await this.c;return R.resourcePreviews.some(({mergeState:j})=>j==="conflict")?"hasConflicts":R.resourcePreviews.some(({mergeState:j})=>j!=="accepted")?"syncing":(await this.qb(R.remoteUserData,R.lastSyncUserData,R.resourcePreviews.map(j=>[j,j.acceptResult]),b),this.c=null,await this.Y(),"idle")}async Y(){try{await this.C.del(this.g,{recursive:!0})}catch{}}Z(b){const R=b.filter(({mergeState:j})=>j==="conflict");(0,k.equals)(this.m,R,(j,U)=>this.h.isEqual(j.previewResource,U.previewResource))||(this.m=R,this.n.fire(this.conflicts))}async hasPreviouslySynced(){const b=await this.getLastSyncUserData();return!!b&&b.syncData!==null}async ab(b){const R=this.c?await this.c:null;if(R)for(const j of R.resourcePreviews){if(this.h.isEqual(j.acceptedResource,b))return j.acceptResult?j.acceptResult.content:null;if(this.h.isEqual(j.remoteResource,b))return j.remoteContent;if(this.h.isEqual(j.localResource,b))return j.localContent;if(this.h.isEqual(j.baseResource,b))return j.baseContent}return null}async resetLocal(){this.F.remove(this.v,-1);try{await this.C.del(this.u)}catch(b){(0,f.toFileOperationResult)(b)!==1&&this.L.error(b)}}async bb(b,R,j,U,z,F){const L=await this.nb(b,R,j,z,F),M=[];for(const $ of L){const G=$.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"});if($.localChange===0&&$.remoteChange===0)M.push({...$,acceptedResource:G,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const W=U?await this.ob($,F):void 0;if(F.isCancellationRequested)break;await this.C.writeFile($.previewResource,D.VSBuffer.fromString(W?.content||""));const _=W&&!W.hasConflicts?await this.pb($,$.previewResource,void 0,F):void 0;M.push({...$,acceptResult:_,mergeState:W?.hasConflicts?"conflict":_?"accepted":"preview",localChange:_?_.localChange:W?W.localChange:$.localChange,remoteChange:_?_.remoteChange:W?W.remoteChange:$.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:b,lastSyncUserData:R,resourcePreviews:M,isLastSyncFromCurrentMachine:j}}async getLastSyncUserData(){let b=this.db();if(b||(b=await this.gb()),!b)return this.L.info(`${this.y}: Last sync data state does not exist.`),null;const R=JSON.parse(b),j=this.I.getResourceSyncStateVersion(this.resource);if(this.w=!!R.version&&!!j&&R.version!==j,this.w)return this.L.info(`${this.y}: Reset last sync state because last sync state version ${R.version} is not compatible with current sync state version ${j}.`),await this.resetLocal(),null;let U,z=1;for(;U===void 0&&z++<6;)try{const F=await this.eb();F&&(F.ref===R.ref?U=F.syncData:this.L.info(`${this.y}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof f.FileOperationError&&F.fileOperationResult===1){this.L.info(`${this.y}: Last sync resource does not exist locally.`);break}else{if(F instanceof d.UserDataSyncError)throw F;this.L.error(F,z)}}if(U===void 0)try{const F=await this.G.resolveResourceContent(this.resource,R.ref,this.collection,this.z);U=F===null?null:this.hb(F),await this.fb({ref:R.ref,syncData:U})}catch(F){if(F instanceof d.UserDataSyncError&&F.code==="NotFound")this.L.info(`${this.y}: Last sync resource does not exist remotely.`);else throw F}return U===void 0?null:{...R,syncData:U}}async cb(b,R={}){if(R.ref||R.version)throw new Error("Cannot have core properties as additional");const j=this.I.getResourceSyncStateVersion(this.resource),U={ref:b.ref,version:j,...R};this.F.store(this.v,JSON.stringify(U),-1,1),await this.fb(b)}db(){return this.F.get(this.v,-1)}async eb(){const b=(await this.C.readFile(this.u)).value.toString();try{const R=b?JSON.parse(b):void 0;if(n(R))return R}catch(R){this.L.error(R)}}async fb(b){await this.C.writeFile(this.u,D.VSBuffer.fromString(JSON.stringify(b)))}async gb(){try{const b=await this.C.readFile(this.u),R=JSON.parse(b.value.toString());await this.C.del(this.u),R.ref&&R.content!==void 0&&(this.F.store(this.v,JSON.stringify({...R,content:void 0}),-1,1),await this.fb({ref:R.ref,syncData:R.content===null?null:JSON.parse(R.content)}))}catch(b){b instanceof f.FileOperationError&&b.fileOperationResult===1?this.L.debug(`${this.y}: Migrating last sync user data. Resource does not exist.`):this.L.error(b)}return this.F.get(this.v,-1)}async getRemoteUserData(b){const{ref:R,content:j}=await this.ib(b);let U=null;return j!==null&&(U=this.hb(j)),{ref:R,syncData:U}}hb(b){try{const R=JSON.parse(b);if(r(R))return R}catch(R){this.L.error(R)}throw new d.UserDataSyncError((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async ib(b){const R=b?{ref:b.ref,content:b.syncData?JSON.stringify(b.syncData):null}:null;return this.G.readResource(this.resource,R,this.collection,this.z)}async jb(b,R){const j=await this.j,U={version:this.mb,machineId:j,content:b};try{return R=await this.G.writeResource(this.resource,JSON.stringify(U),R,this.collection,this.z),{ref:R,syncData:U}}catch(z){throw z instanceof d.UserDataSyncError&&z.code==="TooLarge"&&(z=new d.UserDataSyncError(z.message,z.code,this.resource)),z}}async kb(b){const R={version:this.mb,content:b};return this.H.backup(this.syncResource.profile,this.resource,JSON.stringify(R))}async stop(){this.status!=="idle"&&(this.L.trace(`${this.y}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.Z([]),await this.Y(),this.O("idle"),this.L.info(`${this.y}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}lb(){return this.M.getValue(d.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};o=pe([Y(2,f.IFileService),Y(3,p.IEnvironmentService),Y(4,l.IStorageService),Y(5,d.IUserDataSyncStoreService),Y(6,d.IUserDataSyncBackupStoreService),Y(7,d.IUserDataSyncEnablementService),Y(8,m.ITelemetryService),Y(9,d.IUserDataSyncLogService),Y(10,w.IConfigurationService),Y(11,u.IUriIdentityService)],o),e.AbstractSynchroniser=o;let s=class extends o{constructor(b,R,j,U,z,F,L,M,$,G,W,_,K){super(R,j,U,z,F,L,M,$,G,W,_,K),this.i=b,this.B(this.C.watch(this.h.dirname(b))),this.B(this.C.onDidFilesChange(q=>this.tb(q)))}async p(){try{return await this.C.readFile(this.i)}catch{return null}}async r(b,R,j){try{R?await this.C.writeFile(this.i,D.VSBuffer.fromString(b),j?void 0:R):await this.C.createFile(this.i,D.VSBuffer.fromString(b),{overwrite:j})}catch(U){throw U instanceof f.FileOperationError&&U.fileOperationResult===1||U instanceof f.FileOperationError&&U.fileOperationResult===3?new d.UserDataSyncError(U.message,"LocalPreconditionFailed"):U}}async sb(){try{await this.C.del(this.i)}catch(b){if(!(b instanceof f.FileOperationError&&b.fileOperationResult===1))throw b}}tb(b){!b.contains(this.i)||this.triggerLocalChange()}};s=pe([Y(3,f.IFileService),Y(4,p.IEnvironmentService),Y(5,l.IStorageService),Y(6,d.IUserDataSyncStoreService),Y(7,d.IUserDataSyncBackupStoreService),Y(8,d.IUserDataSyncEnablementService),Y(9,m.ITelemetryService),Y(10,d.IUserDataSyncLogService),Y(11,w.IConfigurationService),Y(12,u.IUriIdentityService)],s),e.AbstractFileSynchroniser=s;let c=class extends s{constructor(b,R,j,U,z,F,L,M,$,G,W,_,K,q){super(b,R,j,U,z,F,L,M,$,G,W,K,q),this.ub=_,this.wb=void 0}vb(b,R){const j=[],U=(0,P.parse)(b,j,{allowEmptyContent:!0,allowTrailingComma:!0});return j.length>0||!(0,C.isUndefined)(U)&&R!==Array.isArray(U)}xb(){return this.wb||(this.wb=this.ub.resolveFormattingOptions(this.i)),this.wb}};c=pe([Y(3,f.IFileService),Y(4,p.IEnvironmentService),Y(5,l.IStorageService),Y(6,d.IUserDataSyncStoreService),Y(7,d.IUserDataSyncBackupStoreService),Y(8,d.IUserDataSyncEnablementService),Y(9,m.ITelemetryService),Y(10,d.IUserDataSyncLogService),Y(11,d.IUserDataSyncUtilService),Y(12,w.IConfigurationService),Y(13,u.IUriIdentityService)],c),e.AbstractJsonFileSynchroniser=c;let a=class{constructor(b,R,j,U,z,F,L){this.resource=b,this.g=R,this.h=j,this.j=U,this.k=z,this.l=F,this.d=L.extUri,this.f=(0,d.getLastSyncResourceUri)(void 0,this.resource,j,this.d)}async initialize({ref:b,content:R}){if(!R){this.j.info("Remote content does not exist.",this.resource);return}const j=this.m(R);if(!!j)try{await this.doInitialize({ref:b,syncData:j})}catch(U){this.j.error(U)}}m(b){try{const R=JSON.parse(b);if(r(R))return R}catch(R){this.j.error(R)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(b,R={}){if(R.ref||R.version)throw new Error("Cannot have core properties as additional");const j={ref:b.ref,version:void 0,...R};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(j),-1,1),await this.k.writeFile(this.f,D.VSBuffer.fromString(JSON.stringify(b)))}};a=pe([Y(1,h.IUserDataProfilesService),Y(2,p.IEnvironmentService),Y(3,y.ILogService),Y(4,f.IFileService),Y(5,l.IStorageService),Y(6,u.IUriIdentityService)],a),e.AbstractInitializer=a}),define(oe[117],ae([0,1,6,23,9,3,43,2,27,16,15,116,29,33,80,13,4,72,8,19,22,30,18,41,252,114,26,62]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p,f,y,v,l,m,u,d,h,n,r,t,o,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function a(z,F){const L=JSON.parse(z.content);if(z.version===1||z.version===2){const M=(await F.getInstalled(0)).filter($=>$.isBuiltin);for(const $ of L)z.version===1&&($.enabled===!1&&($.disabled=!0),delete $.enabled),z.version===2&&M.every(G=>!(0,p.areSameExtensions)(G.identifier,$.identifier))&&($.installed=!0)}return L}function g(z){return JSON.parse(z.content)}e.parseExtensions=g;function b(z,F){return z.sort((L,M)=>!L.identifier.uuid&&M.identifier.uuid?-1:L.identifier.uuid&&!M.identifier.uuid?1:(0,I.compare)(L.identifier.id,M.identifier.id)),F?(0,O.toFormattedString)(z,{}):JSON.stringify(z)}e.stringify=b;let R=class extends r.AbstractSynchroniser{constructor(F,L,M,$,G,W,_,K,q,V,Z,ne,J,x,T,N,H){super({syncResource:"extensions",profile:F},L,$,M,G,W,_,ne,J,V,Z,T),this.yb=K,this.zb=q,this.Ab=H,this.mb=5,this.sb=this.h.joinPath(this.g,"extensions.json"),this.tb=this.sb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"base"}),this.ub=this.sb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local"}),this.vb=this.sb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.wb=this.sb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.xb=this.Ab.createInstance(j),this.B(A.Event.any(A.Event.filter(this.yb.onDidInstallExtensions,B=>B.some(({local:Q})=>!!Q)),A.Event.filter(this.yb.onDidUninstallExtension,B=>!B.error),A.Event.filter(N.onDidChange,B=>B.valueChanges.some(({profile:Q,changes:re})=>this.syncResource.profile.id===Q.id&&re.some(X=>X.key===w.DISABLED_EXTENSIONS_STORAGE_PATH))),x.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async nb(F,L){const M=F.syncData?await a(F.syncData,this.yb):null,$=L?.skippedExtensions||[],G=L?.builtinExtensions||[],W=L?.syncData?await a(L.syncData,this.yb):null,{localExtensions:_,ignoredExtensions:K}=await this.xb.getLocalExtensions(this.syncResource.profile);M?this.L.trace(`${this.y}: Merging remote extensions with local extensions...`):this.L.trace(`${this.y}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:q,remote:V}=(0,t.merge)(_,M,W,$,K,G),Z={local:q,remote:V,content:this.Db(_,q.added,q.updated,q.removed),localChange:q.added.length>0||q.removed.length>0||q.updated.length>0?2:0,remoteChange:V!==null?2:0},ne=this.Jb(_,!1);return[{skippedExtensions:$,builtinExtensions:G,baseResource:this.tb,baseContent:W?this.Jb(W,!1):ne,localResource:this.ub,localContent:ne,localExtensions:_,remoteResource:this.vb,remoteExtensions:M,remoteContent:M?this.Jb(M,!1):null,previewResource:this.sb,previewResult:Z,localChange:Z.localChange,remoteChange:Z.remoteChange,acceptedResource:this.wb}]}async rb(F){const L=F.syncData?await a(F.syncData,this.yb):null,{localExtensions:M,ignoredExtensions:$}=await this.xb.getLocalExtensions(this.syncResource.profile),{remote:G}=(0,t.merge)(M,L,L,F.skippedExtensions||[],$,F.builtinExtensions||[]);return G!==null}Db(F,L,M,$){const G=[...L,...M],W=new Set,_=K=>{W.add(K.id.toLowerCase()),K.uuid&&W.add(K.uuid)};G.forEach(({identifier:K})=>_(K)),$.forEach(_);for(const K of F)W.has(K.identifier.id.toLowerCase())||K.identifier.uuid&&W.has(K.identifier.uuid)||G.push(K);return this.Jb(G,!1)}async ob(F,L){return{...F.previewResult,hasConflicts:!1}}async pb(F,L,M,$){if(this.h.isEqual(L,this.ub))return this.Gb(F);if(this.h.isEqual(L,this.vb))return this.Hb(F);if(this.h.isEqual(L,this.sb))return F.previewResult;throw new Error(`Invalid Resource: ${L.toString()}`)}async Gb(F){const L=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),M=this.zb.getIgnoredExtensions(L),$=(0,t.merge)(F.localExtensions,null,null,F.skippedExtensions,M,F.builtinExtensions),{local:G,remote:W}=$;return{content:F.localContent,local:G,remote:W,localChange:G.added.length>0||G.removed.length>0||G.updated.length>0?2:0,remoteChange:W!==null?2:0}}async Hb(F){const L=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),M=this.zb.getIgnoredExtensions(L),$=F.remoteContent?JSON.parse(F.remoteContent):null;if($!==null){const G=(0,t.merge)(F.localExtensions,$,F.localExtensions,[],M,F.builtinExtensions),{local:W,remote:_}=G;return{content:F.remoteContent,local:W,remote:_,localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:_!==null?2:0}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(F,L,M,$){let{skippedExtensions:G,localExtensions:W}=M[0][0];const{local:_,remote:K,localChange:q,remoteChange:V}=M[0][1];if(q===0&&V===0&&this.L.info(`${this.y}: No changes found during synchronizing extensions.`),q!==0&&(await this.kb(JSON.stringify(W)),G=await this.xb.updateLocalExtensions(_.added,_.removed,_.updated,G,this.syncResource.profile)),K){this.L.trace(`${this.y}: Updating remote extensions...`);const Z=JSON.stringify(K.all);F=await this.jb(Z,$?null:F.ref),this.L.info(`${this.y}: Updated remote extensions.${K.added.length?` Added: ${JSON.stringify(K.added.map(ne=>ne.identifier.id))}.`:""}${K.updated.length?` Updated: ${JSON.stringify(K.updated.map(ne=>ne.identifier.id))}.`:""}${K.removed.length?` Removed: ${JSON.stringify(K.removed.map(ne=>ne.identifier.id))}.`:""}`)}if(L?.ref!==F.ref){this.L.trace(`${this.y}: Updating last synchronized extensions...`);const Z=W.filter(ne=>!ne.installed).map(ne=>ne.identifier);await this.cb(F,{skippedExtensions:G,builtinExtensions:Z}),this.L.info(`${this.y}: Updated last synchronized extensions.${G.length?` Skipped: ${JSON.stringify(G.map(ne=>ne.identifier.id))}.`:""}`)}}async resolveContent(F){if(this.h.isEqual(this.vb,F)||this.h.isEqual(this.tb,F)||this.h.isEqual(this.ub,F)||this.h.isEqual(this.wb,F)){const L=await this.ab(F);return L&&this.Jb(JSON.parse(L),!0)}return null}Jb(F,L){return b(F,L)}async hasLocalData(){try{const{localExtensions:F}=await this.xb.getLocalExtensions(this.syncResource.profile);if(F.some(L=>L.installed||L.disabled))return!0}catch{}return!1}};R=pe([Y(2,C.IEnvironmentService),Y(3,y.IFileService),Y(4,u.IStorageService),Y(5,s.IUserDataSyncStoreService),Y(6,s.IUserDataSyncBackupStoreService),Y(7,w.IExtensionManagementService),Y(8,o.IIgnoredExtensionsManagementService),Y(9,s.IUserDataSyncLogService),Y(10,S.IConfigurationService),Y(11,s.IUserDataSyncEnablementService),Y(12,d.ITelemetryService),Y(13,f.IExtensionStorageService),Y(14,h.IUriIdentityService),Y(15,c.IUserDataProfileStorageService),Y(16,v.IInstantiationService)],R),e.ExtensionsSynchroniser=R;let j=class{constructor(F,L,M,$,G,W){this.a=F,this.b=L,this.c=M,this.d=$,this.f=G,this.g=W}async getLocalExtensions(F){const L=await this.a.getInstalled(void 0,F.extensionsResource),M=this.d.getIgnoredExtensions(L);return{localExtensions:await this.j(F,async(G,W)=>{const _=G.getDisabledExtensions();return L.map(K=>{const{identifier:q,isBuiltin:V,manifest:Z,preRelease:ne}=K,J={identifier:q,preRelease:ne,version:Z.version};_.some(x=>(0,p.areSameExtensions)(x,q))&&(J.disabled=!0),V||(J.installed=!0);try{const x=W.getKeysForSync({id:q.id,version:Z.version});if(x){const T=W.getExtensionState(K,!0)||{};J.state=Object.keys(T).reduce((N,H)=>(x.includes(H)&&(N[H]=T[H]),N),{})}}catch(x){this.g.info(`${(0,r.getSyncResourceLogLabel)("extensions",F)}: Error while parsing extension state`,(0,D.getErrorMessage)(x))}return J})}),ignoredExtensions:M}}async updateLocalExtensions(F,L,M,$,G){const W=(0,r.getSyncResourceLogLabel)("extensions",G);return this.j(G,async(_,K)=>{const q=[],V=[],Z=await this.a.getInstalled(void 0,G.extensionsResource);if(L.length){const J=Z.filter(({identifier:x,isBuiltin:T})=>!T&&L.some(N=>(0,p.areSameExtensions)(x,N)));await k.Promises.settled(J.map(async x=>{this.g.trace(`${W}: Uninstalling local extension...`,x.identifier.id),await this.a.uninstall(x,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:G.extensionsResource}),this.g.info(`${W}: Uninstalled local extension.`,x.identifier.id),q.push(x.identifier)}))}(F.length||M.length)&&await k.Promises.settled([...F,...M].map(async J=>{const x=Z.find(N=>(0,p.areSameExtensions)(N.identifier,J.identifier));if(x&&x.isBuiltin){J.state&&x.manifest.version===J.version&&this.h(J.state,x,x.manifest.version,K),_.getDisabledExtensions().some(H=>(0,p.areSameExtensions)(H,J.identifier))!==!!J.disabled&&(J.disabled?(this.g.trace(`${W}: Disabling extension...`,J.identifier.id),await _.disableExtension(J.identifier),this.g.info(`${W}: Disabled extension`,J.identifier.id)):(this.g.trace(`${W}: Enabling extension...`,J.identifier.id),await _.enableExtension(J.identifier),this.g.info(`${W}: Enabled extension`,J.identifier.id))),q.push(J.identifier);return}const T=(await this.c.getExtensions([{...J.identifier,preRelease:J.preRelease}],i.CancellationToken.None))[0];if(J.state&&(x?x.manifest.version===J.version:!!T)&&this.h(J.state,x||T,x?.manifest.version,K),T)try{_.getDisabledExtensions().some(H=>(0,p.areSameExtensions)(H,J.identifier))!==!!J.disabled&&(J.disabled?(this.g.trace(`${W}: Disabling extension...`,J.identifier.id,T.version),await _.disableExtension(T.identifier),this.g.info(`${W}: Disabled extension`,J.identifier.id,T.version)):(this.g.trace(`${W}: Enabling extension...`,J.identifier.id,T.version),await _.enableExtension(T.identifier),this.g.info(`${W}: Enabled extension`,J.identifier.id,T.version))),(!x||x.preRelease!==J.preRelease)&&(await this.a.canInstall(T)?(this.g.trace(`${W}: Installing extension...`,J.identifier.id,T.version),await this.a.installFromGallery(T,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:J.preRelease,profileLocation:G.extensionsResource}),this.g.info(`${W}: Installed extension.`,J.identifier.id,T.version),q.push(T.identifier)):(this.g.info(`${W}: Skipped synchronizing extension because it cannot be installed.`,T.displayName||T.identifier.id),V.push(J)))}catch(N){V.push(J),N instanceof w.ExtensionManagementError&&[w.ExtensionManagementErrorCode.Incompatible,w.ExtensionManagementErrorCode.IncompatiblePreRelease,w.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(N.code)?this.g.info(`${W}: Skipped synchronizing extension because the compatible extension is not found.`,T.displayName||T.identifier.id):(this.g.error(N),this.g.info(`${W}: Skipped synchronizing extension`,T.displayName||T.identifier.id))}else V.push(J),this.g.info(`${W}: Skipped synchronizing extension because the extension is not found.`,J.identifier.id)}));const ne=[];for(const J of $)q.some(x=>(0,p.areSameExtensions)(x,J.identifier))||ne.push(J);for(const J of V)ne.some(x=>(0,p.areSameExtensions)(x.identifier,J.identifier))||ne.push(J);return ne})}h(F,L,M,$){const G=$.getExtensionState(L,!0)||{},W=M?$.getKeysForSync({id:L.identifier.id,version:M}):void 0;W?W.forEach(_=>{G[_]=F[_]}):Object.keys(F).forEach(_=>G[_]=F[_]),$.setExtensionState(L,G,!0)}async j(F,L){return this.b.withProfileScopedStorageService(F,async M=>{const $=new P.DisposableStore,G=this.f.createChild(new l.ServiceCollection([u.IStorageService,M])),W=$.add(G.createInstance(E.GlobalExtensionEnablementService)),_=$.add(G.createInstance(f.ExtensionStorageService));try{return await L(W,_)}finally{$.dispose()}})}};j=pe([Y(0,w.IExtensionManagementService),Y(1,c.IUserDataProfileStorageService),Y(2,w.IExtensionGalleryService),Y(3,o.IIgnoredExtensionsManagementService),Y(4,v.IInstantiationService),Y(5,s.IUserDataSyncLogService)],j),e.LocalExtensionsProvider=j;let U=class extends r.AbstractInitializer{constructor(F,L,M,$,G,W,_,K){super("extensions",$,G,W,M,_,K),this.o=F,this.p=L}async q(F){return F.syncData?await a(F.syncData,this.o):null}t(F,L){const M=[],$=[],G=[];for(const W of F){if(this.p.hasToNeverSyncExtension(W.identifier.id))continue;const _=L.find(K=>(0,p.areSameExtensions)(K.identifier,W.identifier));_?(M.push(_),W.disabled&&G.push(W.identifier)):W.installed&&($.push({...W.identifier,preRelease:!!W.preRelease}),W.disabled&&G.push(W.identifier))}return{installedExtensions:M,newExtensions:$,disabledExtensions:G,remoteExtensions:F}}};U=pe([Y(0,w.IExtensionManagementService),Y(1,o.IIgnoredExtensionsManagementService),Y(2,y.IFileService),Y(3,n.IUserDataProfilesService),Y(4,C.IEnvironmentService),Y(5,m.ILogService),Y(6,u.IStorageService),Y(7,h.IUriIdentityService)],U),e.AbstractExtensionsInitializer=U}),define(oe[118],ae([0,1,17,9,3,35,43,5,31,16,15,13,8,45,19,22,30,41,60,256,26,18,62,4]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p,f,y,v,l,m,u,d,h,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const t="globalState.argv.",o=["locale"];function s(j,U){const z=j.storage?Object.keys(j.storage).sort():[],F={};return z.forEach(L=>F[L]=j.storage[L]),j.storage=F,U?(0,O.toFormattedString)(j,{}):JSON.stringify(j)}e.stringify=s;const c=1;let a=class extends l.AbstractSynchroniser{constructor(U,z,F,L,M,$,G,W,_,K,q,V,Z,ne){super({syncResource:"globalState",profile:U},z,L,W,V,M,$,_,K,G,q,Z),this.wb=F,this.mb=c,this.p=this.h.joinPath(this.g,"globalState.json"),this.r=this.p.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),this.sb=this.p.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.tb=this.p.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.ub=this.p.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.vb=ne.createInstance(g),this.B(L.watch(this.h.dirname(this.D.argvResource))),this.B(D.Event.any(D.Event.filter(L.onDidFilesChange,J=>J.contains(this.D.argvResource)),D.Event.filter(F.onDidChange,J=>!!(J.targetChanges.some(x=>this.syncResource.profile.id===x.id)||J.valueChanges.some(({profile:x,changes:T})=>this.syncResource.profile.id===x.id&&T.some(N=>N.target===0)))))(()=>this.triggerLocalChange()))}async nb(U,z,F){const L=U.syncData?JSON.parse(U.syncData.content):null;z=z===null&&F?U:z;const M=z&&z.syncData?JSON.parse(z.syncData.content):null,$=await this.vb.getLocalGlobalState(this.syncResource.profile);L?this.L.trace(`${this.y}: Merging remote ui state with local ui state...`):this.L.trace(`${this.y}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const G=await this.Eb(M),{local:W,remote:_}=(0,u.merge)($.storage,L?L.storage:null,M?M.storage:null,G,this.L),K={content:null,local:W,remote:_,localChange:Object.keys(W.added).length>0||Object.keys(W.updated).length>0||W.removed.length>0?2:0,remoteChange:_.all!==null?2:0},q=s($,!1);return[{baseResource:this.r,baseContent:M?s(M,!1):q,localResource:this.sb,localContent:q,localUserData:$,remoteResource:this.tb,remoteContent:L?s(L,!1):null,previewResource:this.p,previewResult:K,localChange:K.localChange,remoteChange:K.remoteChange,acceptedResource:this.ub,storageKeys:G}]}async rb(U){const z=U.syncData?JSON.parse(U.syncData.content):null;if(z===null)return!0;const F=await this.vb.getLocalGlobalState(this.syncResource.profile),L=await this.Eb(z),{remote:M}=(0,u.merge)(F.storage,z.storage,z.storage,L,this.L);return M.all!==null}async ob(U,z){return{...U.previewResult,hasConflicts:!1}}async pb(U,z,F,L){if(this.h.isEqual(z,this.sb))return this.Bb(U);if(this.h.isEqual(z,this.tb))return this.Cb(U);if(this.h.isEqual(z,this.p))return U.previewResult;throw new Error(`Invalid Resource: ${z.toString()}`)}async Bb(U){return{content:U.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(U.localUserData.storage),removed:[],updated:[],all:U.localUserData.storage},localChange:0,remoteChange:2}}async Cb(U){if(U.remoteContent!==null){const z=JSON.parse(U.remoteContent),{local:F,remote:L}=(0,u.merge)(U.localUserData.storage,z.storage,null,U.storageKeys,this.L);return{content:U.remoteContent,local:F,remote:L,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:L!==null?2:0}}else return{content:U.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async qb(U,z,F,L){const{localUserData:M}=F[0][0],{local:$,remote:G,localChange:W,remoteChange:_}=F[0][1];if(W===0&&_===0&&this.L.info(`${this.y}: No changes found during synchronizing ui state.`),W!==0&&(this.L.trace(`${this.y}: Updating local ui state...`),await this.kb(JSON.stringify(M)),await this.vb.writeLocalGlobalState($,this.syncResource.profile),this.L.info(`${this.y}: Updated local ui state`)),_!==0){this.L.trace(`${this.y}: Updating remote ui state...`);const K=JSON.stringify({storage:G.all});U=await this.jb(K,L?null:U.ref),this.L.info(`${this.y}: Updated remote ui state.${G.added.length?` Added: ${G.added}.`:""}${G.updated.length?` Updated: ${G.updated}.`:""}${G.removed.length?` Removed: ${G.removed}.`:""}`)}z?.ref!==U.ref&&(this.L.trace(`${this.y}: Updating last synchronized ui state...`),await this.cb(U),this.L.info(`${this.y}: Updated last synchronized ui state`))}async resolveContent(U){if(this.h.isEqual(this.tb,U)||this.h.isEqual(this.r,U)||this.h.isEqual(this.sb,U)||this.h.isEqual(this.ub,U)){const z=await this.ab(U);return z&&s(JSON.parse(z),!0)}return null}async hasLocalData(){try{const{storage:U}=await this.vb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(U).length>1||U[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async Eb(U){const z=await this.wb.readStorageData(this.syncResource.profile),F=[],L=[];for(const[G,W]of z)W.target===0?F.push(G):W.target===1&&L.push(G);const M=[...F,...L],$=U?.storage?Object.keys(U.storage).filter(G=>!G.startsWith(t)&&!M.includes(G)&&z.get(G)!==void 0):[];if(!P.isWeb){const G=[...d.ALL_SYNC_RESOURCES.map(W=>(0,d.getEnablementKey)(W)),d.SYNC_SERVICE_URL_TYPE];$.push(...G),L.push(...G)}return{user:F,machine:L,unregistered:$}}};a=pe([Y(2,n.IUserDataProfileStorageService),Y(3,E.IFileService),Y(4,d.IUserDataSyncStoreService),Y(5,d.IUserDataSyncBackupStoreService),Y(6,d.IUserDataSyncLogService),Y(7,C.IEnvironmentService),Y(8,d.IUserDataSyncEnablementService),Y(9,y.ITelemetryService),Y(10,S.IConfigurationService),Y(11,f.IStorageService),Y(12,v.IUriIdentityService),Y(13,r.IInstantiationService)],a),e.GlobalStateSynchroniser=a;let g=class{constructor(U,z,F,L){this.a=U,this.b=z,this.c=F,this.d=L}async getLocalGlobalState(U){const z={};if(U.isDefault){const L=await this.f(),M=(0,A.parse)(L);for(const $ of o)M[$]!==void 0&&(z[`${t}${$}`]={version:1,value:M[$]})}const F=await this.c.readStorageData(U);for(const[L,M]of F)M.value&&M.target===0&&(z[L]={version:1,value:M.value});return{storage:z}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const U=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),U.value.toString()}catch(U){this.d.debug((0,i.getErrorMessage)(U))}return"{}"}async writeLocalGlobalState({added:U,removed:z,updated:F},L){const M=(0,l.getSyncResourceLogLabel)("globalState",L),$={},G=new Map,W=await this.c.readStorageData(L),_=(K,q)=>{for(const V of K){if(V.startsWith(t)){$[V.substring(t.length)]=q?q[V].value:void 0;continue}if(q){const Z=q[V];Z.value!==W.get(V)?.value&&G.set(V,Z.value)}else W.get(V)!==void 0&&G.set(V,void 0)}};if(_(Object.keys(U),U),_(Object.keys(F),F),_(z),Object.keys($).length){this.d.trace(`${M}: Updating locale...`);const K=await this.f();let q=K;for(const V of Object.keys($))q=(0,m.edit)(q,[V],$[V],{});K!==q&&(this.d.trace(`${M}: Updating locale...`),await this.a.writeFile(this.b.argvResource,k.VSBuffer.fromString(q)),this.d.info(`${M}: Updated locale.`)),this.d.info(`${M}: Updated locale`)}G.size&&(this.d.trace(`${M}: Updating global state...`),await this.c.updateStorageData(L,G,0),this.d.info(`${M}: Updated global state`,[...G.keys()]))}};g=pe([Y(0,E.IFileService),Y(1,C.IEnvironmentService),Y(2,n.IUserDataProfileStorageService),Y(3,d.IUserDataSyncLogService)],g),e.LocalGlobalStateProvider=g;let b=class extends l.AbstractInitializer{constructor(U,z,F,L,M,$){super("globalState",F,L,M,z,U,$)}async doInitialize(U){const z=U.syncData?JSON.parse(U.syncData.content):null;if(!z){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const F={},L={};for(const M of Object.keys(z.storage))M.startsWith(t)?F[M.substring(t.length)]=z.storage[M].value:this.l.get(M,0)===void 0&&(L[M]=z.storage[M].value);if(Object.keys(F).length){let M="{}";try{M=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const $ of Object.keys(F))M=(0,m.edit)(M,[$],F[$],{});await this.k.writeFile(this.h.argvResource,k.VSBuffer.fromString(M))}if(Object.keys(L).length)for(const M of Object.keys(L))this.l.store(M,L[M],0,0)}};b=pe([Y(0,f.IStorageService),Y(1,E.IFileService),Y(2,h.IUserDataProfilesService),Y(3,C.IEnvironmentService),Y(4,d.IUserDataSyncLogService),Y(5,v.IUriIdentityService)],b),e.GlobalStateInitializer=b;let R=class{constructor(U,z,F,L,M){this.a=U,this.b=z,this.c=F,this.d=L,this.f=M}getSyncStoreType(U){return this.h(U)?.storage[d.SYNC_SERVICE_URL_TYPE]?.value}async sync(U){const z=(0,d.createSyncHeaders)((0,I.generateUuid)());try{return await this.g(U,z)}catch(F){if(F instanceof d.UserDataSyncError)switch(F.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(U,z)}throw F}}async g(U,z){const F=await this.a.readResource("globalState",null,void 0,z),L=this.h(F)||{storage:{}};L.storage[d.SYNC_SERVICE_URL_TYPE]={value:U,version:c};const M=await(0,p.getServiceMachineId)(this.c,this.d,this.b),$={version:c,machineId:M,content:s(L,!1)};await this.a.writeResource("globalState",JSON.stringify($),F.ref,void 0,z)}h({content:U}){if(!U)return null;const z=JSON.parse(U);if((0,l.isSyncData)(z))return z?JSON.parse(z.content):null;throw new Error("Invalid remote data")}};R=pe([Y(1,f.IStorageService),Y(2,C.IEnvironmentService),Y(3,E.IFileService),Y(4,w.ILogService)],R),e.UserDataSyncStoreTypeSynchronizer=R}),define(oe[119],ae([0,1,20,17,3,35,5,14,175,16,15,13,19,22,30,18,41,253,26]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p,f,y,v,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function u(n,r,t){try{const o=JSON.parse(n);if(!r)return(0,P.isUndefined)(o.all)?null:o.all;switch(O.OS){case 2:return(0,P.isUndefined)(o.mac)?null:o.mac;case 3:return(0,P.isUndefined)(o.linux)?null:o.linux;case 1:return(0,P.isUndefined)(o.windows)?null:o.windows}}catch(o){return t.error(o),null}}e.getKeybindingsContentFromSyncContent=u;let d=class extends v.AbstractJsonFileSynchroniser{constructor(r,t,o,s,c,a,g,b,R,j,U,z,F){super(r.keybindingsResource,{syncResource:"keybindings",profile:r},t,b,R,j,o,s,g,z,c,U,a,F),this.mb=2,this.zb=this.h.joinPath(this.g,"keybindings.json"),this.Ab=this.zb.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.Bb=this.zb.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.Cb=this.zb.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Db=this.zb.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.B(D.Event.filter(a.onDidChangeConfiguration,L=>L.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async nb(r,t,o,s){const c=r.syncData?u(r.syncData.content,s.keybindingsPerPlatform??this.Lb(),this.L):null;t=t===null&&o?r:t;const a=t?this.Jb(t):null,g=await this.p(),b=await this.xb();let R=null,j=!1,U=!1,z=!1;if(c){let M=g?g.value.toString():"[]";if(M=M||"[]",this.vb(M,!0))throw new m.UserDataSyncError((0,I.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==M||a!==c){this.L.trace(`${this.y}: Merging remote keybindings with local keybindings...`);const $=await(0,l.merge)(M,c,a,b,this.ub);$.hasChanges&&(R=$.mergeContent,z=$.hasConflicts,j=z||$.mergeContent!==M,U=z||$.mergeContent!==c)}}else g&&(this.L.trace(`${this.y}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),R=g.value.toString(),U=!0);const F={content:z?a:R,localChange:j?g?2:1:0,remoteChange:U?2:0,hasConflicts:z},L=g?g.value.toString():null;return[{fileContent:g,baseResource:this.Ab,baseContent:a,localResource:this.Bb,localContent:L,localChange:F.localChange,remoteResource:this.Cb,remoteContent:c,remoteChange:F.remoteChange,previewResource:this.zb,previewResult:F,acceptedResource:this.Db}]}async rb(r){const t=this.Jb(r);if(t===null)return!0;const o=await this.p(),s=o?o.value.toString():"",c=await this.xb(),a=await(0,l.merge)(s||"[]",t,t,c,this.ub);return a.hasConflicts||a.mergeContent!==t}async ob(r,t){return r.previewResult}async pb(r,t,o,s){if(this.h.isEqual(t,this.Bb))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.Cb))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.zb))return o===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:o,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async qb(r,t,o,s){const{fileContent:c}=o[0][0];let{content:a,localChange:g,remoteChange:b}=o[0][1];if(g===0&&b===0&&this.L.info(`${this.y}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.vb(a,!0)))throw new m.UserDataSyncError((0,I.localize)(1,null),"LocalInvalidContent",this.resource);if(g!==0&&(this.L.trace(`${this.y}: Updating local keybindings...`),c&&await this.kb(this.Kb(c.value.toString())),await this.r(a||"[]",c,s),this.L.info(`${this.y}: Updated local keybindings`)),b!==0){this.L.trace(`${this.y}: Updating remote keybindings...`);const R=this.Kb(a||"[]",r.syncData?.content);r=await this.jb(R,s?null:r.ref),this.L.info(`${this.y}: Updated remote keybindings`)}try{await this.C.del(this.zb)}catch{}t?.ref!==r.ref&&(this.L.trace(`${this.y}: Updating last synchronized keybindings...`),await this.cb(r,{platformSpecific:this.Lb()}),this.L.info(`${this.y}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.p();if(r){const t=(0,A.parse)(r.value.toString());if((0,k.isNonEmptyArray)(t))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.Cb,r)||this.h.isEqual(this.Ab,r)||this.h.isEqual(this.Bb,r)||this.h.isEqual(this.Db,r)?this.ab(r):null}Jb(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.Lb()?null:u(r.syncData.content,this.Lb(),this.L)}Kb(r,t){let o={};try{o=JSON.parse(t||"{}")}catch(s){this.L.error(s)}switch(this.Lb()?delete o.all:o.all=r,O.OS){case 2:o.mac=r;break;case 3:o.linux=r;break;case 1:o.windows=r;break}return JSON.stringify(o)}Lb(){return!!this.M.getValue(m.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};d=pe([Y(2,m.IUserDataSyncStoreService),Y(3,m.IUserDataSyncBackupStoreService),Y(4,m.IUserDataSyncLogService),Y(5,S.IConfigurationService),Y(6,m.IUserDataSyncEnablementService),Y(7,E.IFileService),Y(8,C.IEnvironmentService),Y(9,w.IStorageService),Y(10,m.IUserDataSyncUtilService),Y(11,p.ITelemetryService),Y(12,f.IUriIdentityService)],d),e.KeybindingsSynchroniser=d;let h=class extends v.AbstractInitializer{constructor(r,t,o,s,c,a){super("keybindings",t,o,s,r,c,a)}async doInitialize(r){const t=r.syncData?this.i(r.syncData.content):null;if(!t){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,i.VSBuffer.fromString(t)),await this.n(r)}async c(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource),t=(0,A.parse)(r.value.toString());return!(0,k.isNonEmptyArray)(t)}catch(r){return r.fileOperationResult===1}}i(r){try{return u(r,!0,this.j)}catch(t){return this.j.error(t),null}}};h=pe([Y(0,E.IFileService),Y(1,y.IUserDataProfilesService),Y(2,C.IEnvironmentService),Y(3,m.IUserDataSyncLogService),Y(4,w.IStorageService),Y(5,f.IUriIdentityService)],h),e.KeybindingsInitializer=h}),define(oe[120],ae([0,1,17,3,176,16,74,15,29,13,19,22,30,18,41,60,257,26]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p,f,y,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function m(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function u(n){const r=JSON.parse(n);return m(r)?r:{settings:n}}e.parseSettingsSyncContent=u;let d=class extends f.AbstractJsonFileSynchroniser{constructor(r,t,o,s,c,a,g,b,R,j,U,z,F,L){super(r.settingsResource,{syncResource:"settings",profile:r},t,o,s,c,a,g,U,z,b,R,j,L),this.zb=F,this.mb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.Jb=void 0}async getRemoteUserDataSyncConfiguration(r){const t=await this.getLastSyncUserData(),o=await this.R(r,t),s=this.Gb(o),c=new O.ConfigurationModelParser(l.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&c.parse(s.settings),c.configurationModel.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async nb(r,t,o){const s=await this.p(),c=await this.xb(),a=this.Gb(r);t=t===null&&o?r:t;const g=t?this.Gb(t):null,b=await this.Kb();let R=null,j=!1,U=!1,z=!1;if(a){let $=s?s.value.toString().trim():"{}";$=$||"{}",this.Lb($),this.L.trace(`${this.y}: Merging remote settings with local settings...`);const G=(0,v.merge)($,a.settings,g?g.settings:null,b,[],c);R=G.localContent||G.remoteContent,j=G.localContent!==null,U=G.remoteContent!==null,z=G.hasConflicts}else s&&(this.L.trace(`${this.y}: Remote settings does not exist. Synchronizing settings for the first time.`),R=s.value.toString().trim()||"{}",this.Lb(R),U=!0);const F=s?s.value.toString():null,L=g?.settings??null,M={content:z?L:R,localChange:j?2:0,remoteChange:U?2:0,hasConflicts:z};return[{fileContent:s,baseResource:this.baseResource,baseContent:L,localResource:this.localResource,localContent:F,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:a?a.settings:null,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async rb(r){const t=this.Gb(r);if(t===null)return!0;const o=await this.p(),s=o?o.value.toString().trim():"",c=await this.Kb(),a=await this.xb();return(0,v.merge)(s||"{}",t.settings,t.settings,c,[],a).remoteContent!==null}async ob(r,t){const o=await this.xb(),s=await this.Kb();return{...r.previewResult,content:r.previewResult.content?(0,v.updateIgnoredSettings)(r.previewResult.content,"{}",s,o):null}}async pb(r,t,o,s){const c=await this.xb(),a=await this.Kb();if(this.h.isEqual(t,this.localResource))return{content:r.fileContent?(0,v.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",a,c):null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.remoteResource))return{content:r.remoteContent!==null?(0,v.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",a,c):null,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.previewResource))return o===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:o!==null?(0,v.updateIgnoredSettings)(o,r.fileContent?r.fileContent.value.toString():"{}",a,c):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async qb(r,t,o,s){const{fileContent:c}=o[0][0];let{content:a,localChange:g,remoteChange:b}=o[0][1];if(g===0&&b===0&&this.L.info(`${this.y}: No changes found during synchronizing settings.`),a=a?a.trim():"{}",a=a||"{}",this.Lb(a),g!==0&&(this.L.trace(`${this.y}: Updating local settings...`),c&&await this.kb(JSON.stringify(this.Ib(c.value.toString()))),await this.r(a,c,s),await this.M.reloadConfiguration(3),this.L.info(`${this.y}: Updated local settings`)),b!==0){const R=await this.xb(),j=this.Gb(r),U=await this.Kb(a);a=(0,v.updateIgnoredSettings)(a,j?j.settings:"{}",U,R),this.L.trace(`${this.y}: Updating remote settings...`),r=await this.jb(JSON.stringify(this.Ib(a)),s?null:r.ref),this.L.info(`${this.y}: Updated remote settings`)}try{await this.C.del(this.previewResource)}catch{}t?.ref!==r.ref&&(this.L.trace(`${this.y}: Updating last synchronized settings...`),await this.cb(r),this.L.info(`${this.y}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.p();if(r){const t=await this.xb(),o=(0,y.edit)(r.value.toString(),[l.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,v.isEmpty)(o)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.remoteResource,r)||this.h.isEqual(this.localResource,r)||this.h.isEqual(this.acceptedResource,r)||this.h.isEqual(this.baseResource,r)?this.ab(r):null}async ab(r){let t=await super.ab(r);if(t){const o=await this.xb(),s=await this.Kb();t=(0,v.updateIgnoredSettings)(t,"{}",s,o)}return t}Gb(r){return r.syncData?this.Hb(r.syncData.content):null}Hb(r){try{return u(r)}catch(t){this.L.error(t)}return null}Ib(r){return{settings:r}}async Kb(r){if(!this.Jb){this.Jb=this.ub.resolveDefaultIgnoredSettings();const o=i.Event.any(i.Event.filter(this.zb.onDidInstallExtensions,s=>s.some(({local:c})=>!!c)),i.Event.filter(this.zb.onDidUninstallExtension,s=>!s.error))(()=>{o.dispose(),this.Jb=void 0})}const t=await this.Jb;return(0,v.getIgnoredSettings)(t,this.M,r)}Lb(r){if(this.vb(r,!1))throw new l.UserDataSyncError((0,D.localize)(0,null),"LocalInvalidContent",this.resource)}};d=pe([Y(2,S.IFileService),Y(3,P.IEnvironmentService),Y(4,C.IStorageService),Y(5,l.IUserDataSyncStoreService),Y(6,l.IUserDataSyncBackupStoreService),Y(7,l.IUserDataSyncLogService),Y(8,l.IUserDataSyncUtilService),Y(9,A.IConfigurationService),Y(10,l.IUserDataSyncEnablementService),Y(11,E.ITelemetryService),Y(12,I.IExtensionManagementService),Y(13,w.IUriIdentityService)],d),e.SettingsSynchroniser=d;let h=class extends f.AbstractInitializer{constructor(r,t,o,s,c,a){super("settings",t,o,s,r,c,a)}async doInitialize(r){const t=r.syncData?this.i(r.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,k.VSBuffer.fromString(t.settings)),await this.n(r)}async c(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,v.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}i(r){try{return u(r)}catch(t){this.j.error(t)}return null}};h=pe([Y(0,S.IFileService),Y(1,p.IUserDataProfilesService),Y(2,P.IEnvironmentService),Y(3,l.IUserDataSyncLogService),Y(4,C.IStorageService),Y(5,w.IUriIdentityService)],h),e.SettingsInitializer=h}),define(oe[121],ae([0,1,17,3,32,16,15,13,19,22,30,18,41,254,26]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function y(m){return JSON.parse(m.content)}e.parseSnippets=y;let v=class extends w.AbstractSynchroniser{constructor(u,d,h,n,r,t,o,s,c,a,g,b){super({syncResource:"snippets",profile:u},d,n,h,r,t,o,a,g,s,c,b),this.mb=1,this.p=u.snippetsHome,this.B(this.C.watch(h.userRoamingDataHome)),this.B(this.C.watch(this.p)),this.B(i.Event.filter(this.C.onDidFilesChange,R=>R.affects(this.p))(()=>this.triggerLocalChange()))}async nb(u,d,h){const n=await this.Cb(),r=this.Bb(n),t=u.syncData?this.Ab(u.syncData):null;d=d===null&&h?u:d;const o=d&&d.syncData?this.Ab(d.syncData):null;t?this.L.trace(`${this.y}: Merging remote snippets with local snippets...`):this.L.trace(`${this.y}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,p.merge)(r,t,o);return this.wb(s,n,t||{},o||{})}async rb(u){const d=u.syncData?this.Ab(u.syncData):null;if(d===null)return!0;const h=await this.Cb(),n=this.Bb(h),r=(0,p.merge)(n,d,d);return Object.keys(r.remote.added).length>0||Object.keys(r.remote.updated).length>0||r.remote.removed.length>0||r.conflicts.length>0}async ob(u,d){return u.previewResult}async pb(u,d,h,n){if(this.h.isEqualOrParent(d,this.g.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:u.fileContent?u.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(d,this.g.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:u.remoteContent,localChange:u.remoteContent!==null?u.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(d,this.g))return h===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:h,localChange:h===null?u.fileContent!==null?3:0:2,remoteChange:h===null?u.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async qb(u,d,h,n){const r=h.map(([t,o])=>({...t,acceptResult:o}));r.every(({localChange:t,remoteChange:o})=>t===0&&o===0)&&this.L.info(`${this.y}: No changes found during synchronizing snippets.`),r.some(({localChange:t})=>t!==0)&&(await this.xb(r),await this.yb(r,n)),r.some(({remoteChange:t})=>t!==0)&&(u=await this.zb(r,u,n)),d?.ref!==u.ref&&(this.L.trace(`${this.y}: Updating last synchronized snippets...`),await this.cb(u),this.L.info(`${this.y}: Updated last synchronized snippets`));for(const{previewResource:t}of r)try{await this.C.del(t)}catch{}}wb(u,d,h,n){const r=new Map;for(const t of Object.keys(u.local.added)){const o={content:u.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:h[t],previewResource:this.h.joinPath(this.g,t),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(u.local.updated)){const o={content:u.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},s=d[t]?d[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:h[t],previewResource:this.h.joinPath(this.g,t),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of u.local.removed){const o={content:null,hasConflicts:!1,localChange:3,remoteChange:0},s=d[t]?d[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(u.remote.added)){const o={content:u.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},s=d[t]?d[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(u.remote.updated)){const o={content:u.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},s=d[t]?d[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:h[t],previewResource:this.h.joinPath(this.g,t),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of u.remote.removed){const o={content:null,hasConflicts:!1,localChange:0,remoteChange:3};r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:h[t],previewResource:this.h.joinPath(this.g,t),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of u.conflicts){const o={content:n[t]??null,hasConflicts:!0,localChange:d[t]?2:1,remoteChange:h[t]?2:1},s=d[t]?d[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[t]||null,localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:h[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(d))if(!r.has(t)){const o={content:d[t]?d[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},s=d[t]?d[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:d[t]||null,localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:h[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...r.values()]}async resolveContent(u){return this.h.isEqualOrParent(u,this.g.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.h.isEqualOrParent(u,this.g.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.h.isEqualOrParent(u,this.g.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.h.isEqualOrParent(u,this.g.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.ab(u):null}async hasLocalData(){try{const u=await this.Cb();if(Object.keys(u).length)return!0}catch{}return!1}async xb(u){const d={};for(const h of u)h.fileContent&&(d[this.h.basename(h.localResource)]=h.fileContent);await this.kb(JSON.stringify(this.Bb(d)))}async yb(u,d){for(const{fileContent:h,acceptResult:n,localResource:r,remoteResource:t,localChange:o}of u)if(o!==0){const s=t?this.h.basename(t):this.h.basename(r),c=this.h.joinPath(this.p,s);o===3?(this.L.trace(`${this.y}: Deleting snippet...`,this.h.basename(c)),await this.C.del(c),this.L.info(`${this.y}: Deleted snippet`,this.h.basename(c))):o===1?(this.L.trace(`${this.y}: Creating snippet...`,this.h.basename(c)),await this.C.createFile(c,k.VSBuffer.fromString(n.content),{overwrite:d}),this.L.info(`${this.y}: Created snippet`,this.h.basename(c))):(this.L.trace(`${this.y}: Updating snippet...`,this.h.basename(c)),await this.C.writeFile(c,k.VSBuffer.fromString(n.content),d?void 0:h),this.L.info(`${this.y}: Updated snippet`,this.h.basename(c)))}}async zb(u,d,h){const n=d.syncData?this.Ab(d.syncData):{},r=(0,D.deepClone)(n);for(const{acceptResult:t,localResource:o,remoteResource:s,remoteChange:c}of u)if(c!==0){const a=o?this.h.basename(o):this.h.basename(s);c===3?delete r[a]:r[a]=t.content}return(0,p.areSame)(n,r)||(this.L.trace(`${this.y}: Updating remote snippets...`),d=await this.jb(JSON.stringify(r),h?null:d.ref),this.L.info(`${this.y}: Updated remote snippets`)),d}Ab(u){return y(u)}Bb(u){const d={};for(const h of Object.keys(u))d[h]=u[h].value.toString();return d}async Cb(){const u={};let d;try{d=await this.C.resolve(this.p)}catch(h){if(h instanceof P.FileOperationError&&h.fileOperationResult===1)return u;throw h}for(const h of d.children||[]){const n=h.resource,r=this.h.extname(n);if(r===".json"||r===".code-snippets"){const t=this.h.relativePath(this.p,n),o=await this.C.readFile(n);u[t]=o}}return u}};v=pe([Y(2,O.IEnvironmentService),Y(3,P.IFileService),Y(4,I.IStorageService),Y(5,f.IUserDataSyncStoreService),Y(6,f.IUserDataSyncBackupStoreService),Y(7,f.IUserDataSyncLogService),Y(8,A.IConfigurationService),Y(9,f.IUserDataSyncEnablementService),Y(10,S.ITelemetryService),Y(11,C.IUriIdentityService)],v),e.SnippetsSynchroniser=v;let l=class extends w.AbstractInitializer{constructor(u,d,h,n,r,t){super("snippets",d,h,n,u,r,t)}async doInitialize(u){const d=u.syncData?JSON.parse(u.syncData.content):null;if(!d){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const n of Object.keys(d)){const r=d[n];if(r){const t=this.d.joinPath(this.g.defaultProfile.snippetsHome,n);await this.k.createFile(t,k.VSBuffer.fromString(r)),this.j.info("Created snippet",this.d.basename(t))}}await this.n(u)}async c(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(u){return u.fileOperationResult===1}}};l=pe([Y(0,P.IFileService),Y(1,E.IUserDataProfilesService),Y(2,O.IEnvironmentService),Y(3,f.IUserDataSyncLogService),Y(4,I.IStorageService),Y(5,C.IUriIdentityService)],l),e.SnippetsInitializer=l}),define(oe[122],ae([0,1,17,16,15,13,19,22,30,18,41,26]),function(ee,e,k,i,D,A,O,P,I,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function w(v,l){try{return JSON.parse(v).tasks??null}catch(m){return l.error(m),null}}e.getTasksContentFromSyncContent=w;let p=class extends C.AbstractFileSynchroniser{constructor(l,m,u,d,h,n,r,t,o,s,c,a){super(l.tasksResource,{syncResource:"tasks",profile:l},m,t,o,s,u,d,r,c,h,n,a),this.mb=1,this.vb=this.h.joinPath(this.g,"tasks.json"),this.wb=this.vb.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"base"}),this.xb=this.vb.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"}),this.yb=this.vb.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.zb=this.vb.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async nb(l,m,u,d){const h=l.syncData?w(l.syncData.content,this.L):null;m=m===null&&u?l:m;const n=m?.syncData?w(m.syncData.content,this.L):null,r=await this.p();let t=null,o=!1,s=!1,c=!1;if(l.syncData){const b=r?r.value.toString():null;if(!n||n!==b||n!==h){this.L.trace(`${this.y}: Merging remote tasks with local tasks...`);const R=y(b,h,n);t=R.content,c=R.hasConflicts,o=R.hasLocalChanged,s=R.hasRemoteChanged}}else r&&(this.L.trace(`${this.y}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=r.value.toString(),s=!0);const a={content:c?n:t,localChange:o?r?2:1:0,remoteChange:s?2:0,hasConflicts:c},g=r?r.value.toString():null;return[{fileContent:r,baseResource:this.wb,baseContent:n,localResource:this.xb,localContent:g,localChange:a.localChange,remoteResource:this.yb,remoteContent:h,remoteChange:a.remoteChange,previewResource:this.vb,previewResult:a,acceptedResource:this.zb}]}async rb(l){const m=l?.syncData?w(l.syncData.content,this.L):null;if(m===null)return!0;const u=await this.p(),d=u?u.value.toString():null,h=y(d,m,m);return h.hasLocalChanged||h.hasRemoteChanged}async ob(l,m){return l.previewResult}async pb(l,m,u,d){if(this.h.isEqual(m,this.xb))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(m,this.yb))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(m,this.vb))return u===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:u,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${m.toString()}`)}async qb(l,m,u,d){const{fileContent:h}=u[0][0],{content:n,localChange:r,remoteChange:t}=u[0][1];if(r===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing tasks.`),r!==0&&(this.L.trace(`${this.y}: Updating local tasks...`),h&&await this.kb(JSON.stringify(this.Fb(h.value.toString()))),n?await this.r(n,h,d):await this.sb(),this.L.info(`${this.y}: Updated local tasks`)),t!==0){this.L.trace(`${this.y}: Updating remote tasks...`);const o=JSON.stringify(this.Fb(n));l=await this.jb(o,d?null:l.ref),this.L.info(`${this.y}: Updated remote tasks`)}try{await this.C.del(this.vb)}catch{}m?.ref!==l.ref&&(this.L.trace(`${this.y}: Updating last synchronized tasks...`),await this.cb(l),this.L.info(`${this.y}: Updated last synchronized tasks`))}async hasLocalData(){return this.C.exists(this.i)}async resolveContent(l){return this.h.isEqual(this.yb,l)||this.h.isEqual(this.wb,l)||this.h.isEqual(this.xb,l)||this.h.isEqual(this.zb,l)?this.ab(l):null}Fb(l){return l?{tasks:l}:{}}};p=pe([Y(2,E.IUserDataSyncStoreService),Y(3,E.IUserDataSyncBackupStoreService),Y(4,E.IUserDataSyncLogService),Y(5,i.IConfigurationService),Y(6,E.IUserDataSyncEnablementService),Y(7,A.IFileService),Y(8,D.IEnvironmentService),Y(9,O.IStorageService),Y(10,P.ITelemetryService),Y(11,I.IUriIdentityService)],p),e.TasksSynchroniser=p;let f=class extends C.AbstractInitializer{constructor(l,m,u,d,h,n){super("tasks",m,u,d,l,h,n),this.c=this.g.defaultProfile.tasksResource}async doInitialize(l){const m=l.syncData?w(l.syncData.content,this.j):null;if(!m){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,k.VSBuffer.fromString(m)),await this.n(l)}async i(){return this.k.exists(this.c)}};f=pe([Y(0,A.IFileService),Y(1,S.IUserDataProfilesService),Y(2,D.IEnvironmentService),Y(3,E.IUserDataSyncLogService),Y(4,O.IStorageService),Y(5,I.IUriIdentityService)],f),e.TasksInitializer=f;function y(v,l,m){if(v===null&&l===null&&m===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(v===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const u=m!==v,d=m!==l;return!u&&!d?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:u&&!d?{content:v,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:d&&!u?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:v,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[123],ae([0,1,43,16,15,13,19,22,30,18,41,255,26]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let p=class extends C.AbstractSynchroniser{constructor(l,m,u,d,h,n,r,t,o,s,c,a,g){super({syncResource:"profiles",profile:l},m,d,h,n,r,t,c,a,o,s,g),this.r=u,this.mb=1,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?y(l.syncData):null}async getRemoteSyncedProfiles(l){const m=await this.getLastSyncUserData(),u=await this.R(l,m);return u?.syncData?y(u.syncData):null}async nb(l,m,u){if(!this.r.isEnabled())throw new w.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const d=l.syncData?y(l.syncData):null,h=m?.syncData?y(m.syncData):null,n=this.zb(),{local:r,remote:t}=(0,E.merge)(n,d,h,[]),o={local:r,remote:t,content:h?this.Ab(h):null,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?2:0,remoteChange:t!==null?2:0},s=f(n,!1);return[{baseResource:this.baseResource,baseContent:h?this.Ab(h):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:d?this.Ab(d):null,remoteProfiles:d,previewResource:this.previewResource,previewResult:o,localChange:o.localChange,remoteChange:o.remoteChange,acceptedResource:this.acceptedResource}]}async rb(l){const m=l?.syncData?y(l.syncData):null,u=this.zb(),{remote:d}=(0,E.merge)(u,m,m,[]);return!!d?.added.length||!!d?.removed.length||!!d?.updated.length}async ob(l,m){return{...l.previewResult,hasConflicts:!1}}async pb(l,m,u,d){if(this.h.isEqual(m,this.localResource))return this.wb(l);if(this.h.isEqual(m,this.remoteResource))return this.xb(l);if(this.h.isEqual(m,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${m.toString()}`)}async wb(l){const m=this.zb(),u=(0,E.merge)(m,null,null,[]),{local:d,remote:h}=u;return{content:l.localContent,local:d,remote:h,localChange:d.added.length>0||d.removed.length>0||d.updated.length>0?2:0,remoteChange:h!==null?2:0}}async xb(l){const m=l.remoteContent?JSON.parse(l.remoteContent):null,u=[],d=[];for(const h of this.zb()){const n=m?.find(r=>r.id===h.id);n&&(u.push({id:h.id,name:h.name,collection:n.collection}),d.push(h))}if(m!==null){const h=(0,E.merge)(d,m,u,[]),{local:n,remote:r}=h;return{content:l.remoteContent,local:n,remote:r,localChange:n.added.length>0||n.removed.length>0||n.updated.length>0?2:0,remoteChange:r!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(l,m,u,d){const{local:h,remote:n,localChange:r,remoteChange:t}=u[0][1];r===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing profiles.`);const o=u[0][0].remoteProfiles||[];if(o.length+(n?.added.length??0)-(n?.removed.length??0)>20)throw new w.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(r!==0){await this.kb(f(this.zb(),!1));const s=[];for(const c of h.added)s.push((async()=>{this.L.trace(`${this.y}: Creating '${c.name}' profile...`),await this.r.createProfile(c.id,c.name,{shortName:c.shortName}),this.L.info(`${this.y}: Created profile '${c.name}'.`)})());for(const c of h.removed)s.push((async()=>{this.L.trace(`${this.y}: Removing '${c.name}' profile...`),await this.r.removeProfile(c),this.L.info(`${this.y}: Removed profile '${c.name}'.`)})());for(const c of h.updated){const a=this.r.profiles.find(g=>g.id===c.id);a?s.push((async()=>{this.L.trace(`${this.y}: Updating '${c.name}' profile...`),await this.r.updateProfile(a,{name:c.name,shortName:c.shortName}),this.L.info(`${this.y}: Updated profile '${c.name}'.`)})()):this.L.info(`${this.y}: Could not find profile with id '${c.id}' to update.`)}await Promise.all(s)}if(t!==0){this.L.trace(`${this.y}: Updating remote profiles...`);const s=[],c=o.length+(n?.added.length??0)<=20;if(c)for(const a of n?.added||[]){const g=await this.G.createCollection(this.z);s.push(g),o.push({id:a.id,name:a.name,collection:g,shortName:a.shortName})}else this.L.info(`${this.y}: Could not create remote profiles as there are too many profiles.`);for(const a of n?.removed||[])o.splice(o.findIndex(({id:g})=>a.id===g),1);for(const a of n?.updated||[]){const g=o.find(({id:b})=>a.id===b);g&&o.splice(o.indexOf(g),1,{id:a.id,name:a.name,collection:g.collection,shortName:a.shortName})}try{l=await this.updateRemoteProfiles(o,d?null:l.ref),this.L.info(`${this.y}: Updated remote profiles.${c&&n?.added.length?` Added: ${JSON.stringify(n.added.map(a=>a.name))}.`:""}${n?.updated.length?` Updated: ${JSON.stringify(n.updated.map(a=>a.name))}.`:""}${n?.removed.length?` Removed: ${JSON.stringify(n.removed.map(a=>a.name))}.`:""}`)}catch(a){if(s.length){this.L.info(`${this.y}: Failed to update remote profiles. Cleaning up added collections...`);for(const g of s)await this.G.deleteCollection(g,this.z)}throw a}for(const a of n?.removed||[])await this.G.deleteCollection(a.collection,this.z)}m?.ref!==l.ref&&(this.L.trace(`${this.y}: Updating last synchronized profiles...`),await this.cb(l),this.L.info(`${this.y}: Updated last synchronized profiles.`))}async updateRemoteProfiles(l,m){return this.jb(this.Ab(l),m)}async hasLocalData(){return this.zb().length>0}async resolveContent(l){if(this.h.isEqual(this.remoteResource,l)||this.h.isEqual(this.baseResource,l)||this.h.isEqual(this.localResource,l)||this.h.isEqual(this.acceptedResource,l)){const m=await this.ab(l);return m&&(0,k.toFormattedString)(JSON.parse(m),{})}return null}zb(){return this.r.profiles.filter(l=>!l.isDefault&&!l.isTransient)}Ab(l){return JSON.stringify([...l].sort((m,u)=>m.name.localeCompare(u.name)))}};p=pe([Y(2,S.IUserDataProfilesService),Y(3,A.IFileService),Y(4,D.IEnvironmentService),Y(5,O.IStorageService),Y(6,w.IUserDataSyncStoreService),Y(7,w.IUserDataSyncBackupStoreService),Y(8,w.IUserDataSyncLogService),Y(9,i.IConfigurationService),Y(10,w.IUserDataSyncEnablementService),Y(11,P.ITelemetryService),Y(12,I.IUriIdentityService)],p),e.UserDataProfilesManifestSynchroniser=p;function f(v,l){const m=[...v].sort((u,d)=>u.name.localeCompare(d.name)).map(u=>({id:u.id,name:u.name}));return l?(0,k.toFormattedString)(m,{}):JSON.stringify(m)}e.stringifyLocalProfiles=f;function y(v){return JSON.parse(v.content)}e.parseUserDataProfilesManifest=y}),define(oe[270],ae([0,1,6,17,65,2,21,16,15,13,18,26]),function(ee,e,k,i,D,A,O,P,I,S,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let w=class extends A.Disposable{constructor(f,y,v,l,m){super(),this.a=f,this.b=y,this.c=v,this.f=l,this.g=m;for(const u of this.g.profiles)for(const d of E.ALL_SYNC_RESOURCES)this.i(this.h(u,d))}async getAllRefs(f,y){const v=this.h(f,y),l=await this.b.resolve(v);return l.children?l.children.filter(u=>u.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(u.name)).sort().reverse().map(u=>({ref:u.name,created:this.j(u)})):[]}async resolveContent(f,y,v){const l=this.h(f,y),m=(0,O.joinPath)(l,v);try{return(await this.b.readFile(m)).value.toString()}catch(u){return this.f.error(u),null}}async backup(f,y,v){const l=this.h(f,y),m=(0,O.joinPath)(l,`${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(m,i.VSBuffer.fromString(v))}catch(u){this.f.error(u)}try{this.i(l)}catch{}}h(f,y){return(0,O.joinPath)(this.a.userDataSyncHome,...f.isDefault?[y]:[f.id,y])}async i(f){try{try{if(!await this.b.exists(f))return}catch{return}const y=await this.b.resolve(f);if(y.children){const v=y.children.filter(d=>d.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(d.name)).sort(),l=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let m=v.filter(d=>Date.now()-this.j(d)>l);const u=v.length-m.length;u<10&&(m=m.slice(10-u)),await k.Promises.settled(m.map(async d=>{this.f.info("Deleting from backup",d.resource.path),await this.b.del(d.resource)}))}}catch(y){this.f.error(y)}}j(f){return f.ctime||new Date(parseInt(f.name.substring(0,4)),parseInt(f.name.substring(4,6))-1,parseInt(f.name.substring(6,8)),parseInt(f.name.substring(9,11)),parseInt(f.name.substring(11,13)),parseInt(f.name.substring(13,15))).getTime()}};w=pe([Y(0,I.IEnvironmentService),Y(1,S.IFileService),Y(2,P.IConfigurationService),Y(3,E.IUserDataSyncLogService),Y(4,C.IUserDataProfilesService)],w),e.UserDataSyncBackupStoreService=w}),define(oe[271],ae([0,1,3,2,5,15,19,22,26]),function(ee,e,k,i,D,A,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const S="sync.enable";let C=class extends i.Disposable{constructor(w,p,f,y){super(),this.c=w,this.f=p,this.g=f,this.h=y,this.a=new k.Emitter,this.onDidChangeEnablement=this.a.event,this.b=new k.Emitter,this.onDidChangeResourceEnablement=this.b.event,this.B(w.onDidChangeValue(v=>this.j(v)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(S,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(w){w&&!this.canToggleEnablement()||(this.f.publicLog2(S,{enabled:w}),this.c.store(S,w,-1,1))}isResourceEnabled(w){return this.c.getBoolean((0,I.getEnablementKey)(w),-1,!0)}setResourceEnablement(w,p){if(this.isResourceEnabled(w)!==p){const f=(0,I.getEnablementKey)(w);this.i(f,p)}}getResourceSyncStateVersion(w){}i(w,p){this.c.store(w,p,-1,D.isWeb?0:1)}j(w){if(w.scope!==-1)return;if(S===w.key){this.a.fire(this.isEnabled());return}const p=I.ALL_SYNC_RESOURCES.filter(f=>(0,I.getEnablementKey)(f)===w.key)[0];if(p){this.b.fire([p,this.isResourceEnabled(p)]);return}}};C=pe([Y(0,O.IStorageService),Y(1,P.ITelemetryService),Y(2,A.IEnvironmentService),Y(3,I.IUserDataSyncStoreManagementService)],C),e.UserDataSyncEnablementService=C}),define(oe[81],ae([0,1,3,2,5,27,179,15,13,4,25,45,19,26]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,S.createDecorator)("IUserDataSyncMachinesService");const f="sync.currentMachineName",y="Safari",v="Chrome",l="Edge",m="Firefox",u="Android";function d(r){switch(r){case y:case v:case l:case m:case u:case(0,D.PlatformToString)(0):return!0}return!1}e.isWebPlatform=d;function h(){return D.isSafari?y:D.isChrome?v:D.isEdge?l:D.isFirefox?m:D.isAndroid?u:(0,D.PlatformToString)(D.isWeb?0:D.platform)}let n=class rt extends i.Disposable{constructor(t,o,s,c,a,g){super(),this.h=s,this.i=c,this.j=a,this.k=g,this.c=this.B(new k.Emitter),this.onDidChange=this.c.event,this.g=null,this.f=(0,E.getServiceMachineId)(t,o,s)}async getMachines(t){const o=await this.f;return(await this.m(t)).machines.map(c=>({...c,isCurrent:c.id===o}))}async addCurrentMachine(t){const o=await this.f,s=await this.m(t);s.machines.some(({id:c})=>c===o)||(s.machines.push({id:o,name:this.l(s.machines),platform:h()}),await this.n(s))}async removeCurrentMachine(t){const o=await this.f,s=await this.m(t),c=s.machines.filter(({id:a})=>a!==o);c.length!==s.machines.length&&(s.machines=c,await this.n(s))}async renameMachine(t,o,s){const c=await this.m(s),a=c.machines.find(({id:g})=>g===t);if(a){a.name=o,await this.n(c);const g=await this.f;t===g&&this.h.store(f,o,-1,1)}}async setEnablements(t){const o=await this.m();for(const[s,c]of t){const a=o.machines.find(g=>g.id===s);a&&(a.disabled=c?void 0:!0)}await this.n(o)}l(t){const o=this.h.get(f,-1);if(o)return o;const s=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${h()} (${this.k.nameShort})`,c=new RegExp(`${(0,A.escapeRegExpCharacters)(s)}\\s#(\\d+)`);let a=0;for(const g of t){const b=c.exec(g.name),R=b?parseInt(b[1]):0;a=R>a?R:a}return`${s} #${a+1}`}async m(t){this.g=await this.p(t);const o=this.r(this.g);if(o.version!==rt.a)throw new Error((0,O.localize)(0,null,this.k.nameLong));return o}async n(t){const o=JSON.stringify(t),s=await this.i.writeResource(rt.b,o,this.g?.ref||null);this.g={ref:s,content:o},this.c.fire()}async p(t){if(this.g){const o=t&&t.latest?t.latest[rt.b]:void 0;if(this.g.ref===o)return this.g;if(o===void 0&&this.g.content===null)return this.g}return this.i.readResource(rt.b,this.g)}r(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(o){this.j.error(o)}return{version:rt.a,machines:[]}}};n.a=1,n.b="machines",n=pe([Y(0,P.IEnvironmentService),Y(1,I.IFileService),Y(2,w.IStorageService),Y(3,p.IUserDataSyncStoreService),Y(4,p.IUserDataSyncLogService),Y(5,C.IProductService)],n),e.UserDataSyncMachinesService=n}),define(oe[272],ae([0,1,6,65,38,9,3,2,5,21,7,177,25,19,22,26,78,81]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p,f,y,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const m="sync.disableMachineEventually",u="sync.sessionId",d="sync.storeUrl",h="sync.productQuality";let n=class extends P.Disposable{get j(){const o=this.z.get(d,-1);return o?C.URI.parse(o):void 0}set j(o){o?this.z.store(d,o.toString(),-1,1):this.z.remove(d,-1)}get l(){return this.z.get(h,-1)}set l(o){o?this.z.store(h,o,-1,1):this.z.remove(h,-1)}constructor(o,s,c,a,g,b,R,j,U,z){super(),this.n=s,this.p=c,this.r=a,this.s=g,this.u=b,this.v=R,this.w=j,this.y=U,this.z=z,this.a=this.B(new P.MutableDisposable),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new O.Emitter),this.onError=this.h.event,this.N=[],this.f=this.B(new k.ThrottledDelayer(this.O())),this.i=this.j,this.j=s.userDataSyncStore?.url,this.k=this.l,this.l=o.quality,this.j&&(this.u.info("Using settings sync service",this.j.toString()),this.B(s.onDidChangeUserDataSyncStore(()=>{(0,S.isEqual)(this.j,s.userDataSyncStore?.url)||(this.i=this.j,this.j=s.userDataSyncStore?.url,this.j&&this.u.info("Using settings sync service",this.j.toString()))})),this.r.isEnabled()?this.u.info("Auto Sync is enabled."):this.u.info("Auto Sync is disabled."),this.C(),this.L()&&this.J(),this.B(R.onDidChangeAccount(()=>this.C())),this.B(c.onDidChangeDonotMakeRequestsUntil(()=>this.C())),this.B(g.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this.B(O.Event.filter(this.r.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}C(){const{enabled:o,message:s}=this.F();o?this.a.value===void 0&&(this.a.value=new r(this.i,1e3*60*5,this.n,this.p,this.s,this.y,this.u,this.z),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(c=>this.I(c))),this.D()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(s&&this.u.info(s),this.a.clear()):s&&this.r.isEnabled()&&this.u.info(s))}D(){return!0}F(){return this.r.isEnabled()?this.v.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,i.toLocalISOString)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(o,s,c){try{this.v.account&&!c&&await this.y.removeCurrentMachine(),this.G(!1),this.z.remove(u,-1),o?(this.w.publicLog2("sync/turnOffEveryWhere"),await this.s.reset()):await this.s.resetLocal()}catch(a){if(this.u.error(a),s)this.G(!1);else throw a}}G(o){this.r.isEnabled()!==o&&(this.r.setEnablement(o),this.C())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(o){if(!o){this.b=0;return}const s=y.UserDataSyncError.toUserDataSyncError(o);s instanceof y.UserDataAutoSyncError&&this.w.publicLog2("autosync/error",{code:s.code,service:this.n.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"?(this.g=!0,this.u.info("Auto Sync: Suspended sync because of making too many requests to server"),this.C()):s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?I.isWeb&&s.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.u.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.u.error(s),this.b++),this.h.fire(s)}async J(){this.z.store(m,!0,-1,1),await(0,k.timeout)(1e3*60*10),this.L()&&(this.M(),!this.r.isEnabled()&&this.v.account&&await this.y.removeCurrentMachine())}L(){return this.z.getBoolean(m,-1,!1)}M(){this.z.remove(m,-1)}async triggerSync(o,s,c){if(this.a.value===void 0)return this.f.cancel();if(s&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.u.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...o),this.f.trigger(async()=>{this.u.trace("activity sources",...this.N);const a=this.v.account?.authenticationProviderId||"";this.w.publicLog2("sync/triggered",{sources:this.N,providerId:a}),this.N=[],this.a.value&&await this.a.value.sync("Activity",c)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};n=pe([Y(0,w.IProductService),Y(1,y.IUserDataSyncStoreManagementService),Y(2,y.IUserDataSyncStoreService),Y(3,y.IUserDataSyncEnablementService),Y(4,y.IUserDataSyncService),Y(5,y.IUserDataSyncLogService),Y(6,v.IUserDataSyncAccountService),Y(7,f.ITelemetryService),Y(8,l.IUserDataSyncMachinesService),Y(9,p.IStorageService)],n),e.UserDataAutoSyncService=n;class r extends P.Disposable{constructor(o,s,c,a,g,b,R,j){super(),this.j=o,this.k=s,this.l=c,this.m=a,this.n=g,this.p=b,this.r=R,this.s=j,this.b=this.B(new P.MutableDisposable),this.c=this.B(new O.Emitter),this.onDidStartSync=this.c.event,this.f=this.B(new O.Emitter),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.u())),this.B((0,P.toDisposable)(()=>{this.i&&(this.i.cancel(),this.r.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.r.info("Auto Sync: Stopped")})),this.sync(r.a,!1)}u(){this.b.value=(0,k.disposableTimeout)(()=>this.sync(r.a,!1),this.k)}sync(o,s){const c=(0,k.createCancelablePromise)(async a=>{if(this.i)try{this.r.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(g){if((0,A.isCancellationError)(g))return}return this.y(o,s,a)});return this.i=c,this.i.finally(()=>this.i=void 0),this.i}v(){return this.j!==void 0&&!(0,S.isEqual)(this.j,this.l.userDataSyncStore?.url)}async w(){const o=await this.l.getPreviousUserDataSyncStore(),s=this.l.userDataSyncStore;return!!s&&!!o&&(!(0,S.isEqual)(s.defaultUrl,o.defaultUrl)||!(0,S.isEqual)(s.insidersUrl,o.insidersUrl)||!(0,S.isEqual)(s.stableUrl,o.stableUrl))}async y(o,s,c){this.r.info(`Auto Sync: Triggered by ${o}`),this.c.fire();let a;try{await this.z(s,c)}catch(g){if(this.r.error(g),a=g,y.UserDataSyncError.toUserDataSyncError(g).code==="MethodNotFound")try{this.r.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.n.cleanUpRemoteData(),this.r.info("Auto Sync: Retrying sync..."),await this.z(s,c),a=void 0}catch(b){this.r.error(b),a=b}}this.f.fire(a)}async z(o,s){if(this.h=await this.n.createSyncTask(this.g,o),s.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.v()?await this.w()?new y.UserDataAutoSyncError((0,E.localize)(0,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(1,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(2,null),"TurnedOff");const c=this.s.get(u,-1);if(c&&this.g&&c!==this.g.session)throw this.v()?await this.w()?new y.UserDataAutoSyncError((0,E.localize)(3,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(4,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(5,null),"SessionExpired");const a=await this.p.getMachines(this.g||void 0);if(s.isCancellationRequested)return;const g=a.find(b=>b.isCurrent);if(g?.disabled)throw new y.UserDataAutoSyncError((0,E.localize)(6,null),"TurnedOff");if(await this.h.run(),this.g===null)try{this.g=await this.m.manifest(null)}catch(b){throw new y.UserDataAutoSyncError((0,D.toErrorMessage)(b),b instanceof y.UserDataSyncError?b.code:"Unknown")}this.g&&this.g.session!==c&&this.s.store(u,this.g.session,-1,1),!s.isCancellationRequested&&(g||await this.p.addCurrentMachine(this.g||void 0))}register(o){return super.B(o)}}r.a="Interval"}),define(oe[273],ae([0,1,7,180,15,13,45,19,30,26,18,41,121,120,119,16,122,117,118,4,123,43]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p,f,y,v,l,m,u,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=class Ve{constructor(t,o,s,c,a,g,b,R,j,U){this.e=t,this.f=o,this.g=s,this.h=a,this.i=g,this.j=b,this.k=R,this.l=j,this.m=U,this.d=c.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const o=this.K(t.content,"profiles");return(0,d.parseUserDataProfilesManifest)(o)}return[]}async getRemoteSyncResourceHandles(t,o){return(await this.e.getAllResourceRefs(t,o?.collection)).map(({created:c,ref:a})=>({created:c,uri:this.I({remote:!0,syncResource:t,profile:o?.id??this.k.defaultProfile.id,collection:o?.collection,ref:a,node:void 0})}))}async getLocalSyncResourceHandles(t,o){return(await this.f.getAllRefs(o,t)).map(({created:c,ref:a})=>({created:c,uri:this.I({remote:!1,syncResource:t,profile:o.id,collection:void 0,ref:a,node:void 0})}))}resolveUserDataSyncResource({uri:t}){const o=this.J(t),s=o?this.k.profiles.find(c=>c.id===o.profile):void 0;return o&&s?{profile:s,syncResource:o?.syncResource}:void 0}async getAssociatedResources({uri:t}){const o=this.J(t);if(!o)return[];const s=this.k.profiles.find(c=>c.id===o.profile);switch(o.syncResource){case"settings":return this.r(t,s);case"keybindings":return this.t(t,s);case"tasks":return this.v(t,s);case"snippets":return this.x(t,s);case"globalState":return this.C(t,s);case"extensions":return this.z(t,s);case"profiles":return this.F(t,s)}}async getMachineId({uri:t}){const o=this.J(t);if(!!o){if(o.remote){if(o.ref){const{content:s}=await this.L(o.syncResource,o.ref,o.collection);if(s)return this.K(s,o.syncResource)?.machineId}return}return(0,O.getServiceMachineId)(this.h,this.j,this.i)}}async resolveContent(t){const o=this.J(t);if(!o||o.node===Ve.a)return null;if(o.ref){const s=await this.n(o.remote,o.syncResource,o.profile,o.collection,o.ref);return o.node&&s?this.o(o.syncResource,s,o.node):s}return!o.remote&&!o.node?this.q(o.syncResource,o.profile):null}async n(t,o,s,c,a){if(t){const{content:b}=await this.L(o,a,c);return b}const g=this.k.profiles.find(b=>b.id===s);return g?this.f.resolveContent(g,o,a):null}o(t,o,s){const c=this.K(o,t);switch(t){case"settings":return this.s(c,s);case"keybindings":return this.u(c,s);case"tasks":return this.w(c,s);case"snippets":return this.y(c,s);case"globalState":return this.D(c,s);case"extensions":return this.A(c,s);case"profiles":return this.G(c,s)}}async q(t,o){const s=this.k.profiles.find(c=>c.id===o);if(!s)return null;switch(t){case"globalState":return this.E(s);case"extensions":return this.B(s);case"profiles":return this.H(s);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}r(t,o){const s=this.d.joinPath(t,"settings.json"),c=o?o.settingsResource:this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:c}]}s(t,o){switch(o){case"settings.json":return(0,p.parseSettingsSyncContent)(t.content).settings}return null}t(t,o){const s=this.d.joinPath(t,"keybindings.json"),c=o?o.keybindingsResource:this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:c}]}u(t,o){switch(o){case"keybindings.json":return(0,f.getKeybindingsContentFromSyncContent)(t.content,!!this.l.getValue(S.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.g)}return null}v(t,o){const s=this.d.joinPath(t,"tasks.json"),c=o?o.tasksResource:this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:c}]}w(t,o){switch(o){case"tasks.json":return(0,v.getTasksContentFromSyncContent)(t.content,this.g)}return null}async x(t,o){const s=await this.resolveContent(t);if(s){const c=this.K(s,"snippets");if(c){const a=(0,w.parseSnippets)(c),g=[];for(const b of Object.keys(a)){const R=this.d.joinPath(t,b),j=o?this.d.joinPath(o.snippetsHome,b):this.d.joinPath(t,Ve.a);g.push({resource:R,comparableResource:j})}return g}}return[]}y(t,o){return(0,w.parseSnippets)(t)[o]||null}z(t,o){const s=this.d.joinPath(t,"extensions.json"),c=o?this.I({remote:!1,syncResource:"extensions",profile:o.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:c}]}A(t,o){switch(o){case"extensions.json":return(0,l.stringify)((0,l.parseExtensions)(t),!0)}return null}async B(t){const{localExtensions:o}=await this.m.createInstance(l.LocalExtensionsProvider).getLocalExtensions(t);return(0,l.stringify)(o,!0)}C(t,o){const s=this.d.joinPath(t,"globalState.json"),c=o?this.I({remote:!1,syncResource:"globalState",profile:o.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,Ve.a);return[{resource:s,comparableResource:c}]}D(t,o){switch(o){case"globalState.json":return(0,m.stringify)(JSON.parse(t.content),!0)}return null}async E(t){const o=await this.m.createInstance(m.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,m.stringify)(o,!0)}F(t,o){const s=this.d.joinPath(t,"profiles.json"),c=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:s,comparableResource:c}]}G(t,o){switch(o){case"profiles.json":return(0,h.toFormattedString)(JSON.parse(t.content),{})}return null}async H(t){return(0,d.stringifyLocalProfiles)(this.k.profiles.filter(o=>!o.isDefault&&!o.isTransient),!0)}I(t){const o=t.remote?Ve.b:Ve.c,s=[t.syncResource,t.profile];return t.collection&&s.push(`collection:${t.collection}`),t.ref&&s.push(`ref:${t.ref}`),t.node&&s.push(t.node),this.d.joinPath(k.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:o,path:"/"}),...s)}J(t){if(t.scheme!==S.USER_DATA_SYNC_SCHEME||t.authority!==Ve.c&&t.authority!==Ve.b)return;const o=[];for(;t.path!=="/";)o.unshift(this.d.basename(t)),t=this.d.dirname(t);if(o.length<2)return;const s=t.authority===Ve.b,c=o.shift(),a=o.shift();let g,b,R;for(;o.length;){const j=o.shift();j.startsWith("collection:")?g=j.substring(11):j.startsWith("ref:")?b=j.substring(4):R=j}return{remote:s,syncResource:c,profile:a,collection:g,ref:b,node:R}}K(t,o){try{const s=JSON.parse(t);if((0,E.isSyncData)(s))return s}catch(s){this.g.error(s)}throw new S.UserDataSyncError((0,i.localize)(0,null),"IncompatibleRemoteContent",o)}async L(t,o,s){const c=await this.e.resolveResourceContent(t,o,s);return{ref:o,content:c}}};n.a="not-existing-resource",n.b="remote-backup",n.c="local-backup",n=pe([Y(0,S.IUserDataSyncStoreService),Y(1,S.IUserDataSyncBackupStoreService),Y(2,S.IUserDataSyncLogService),Y(3,I.IUriIdentityService),Y(4,D.IEnvironmentService),Y(5,P.IStorageService),Y(6,A.IFileService),Y(7,C.IUserDataProfilesService),Y(8,y.IConfigurationService),Y(9,u.IInstantiationService)],n),e.UserDataSyncResourceProviderService=n}),define(oe[274],ae([0,1,20,6,23,38,3,2,21,14,31,16,29,4,19,22,18,117,118,119,120,121,122,123,26]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p,f,y,v,l,m,u,d,h,n,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const o="sync.lastSyncTime";let s=class extends P.Disposable{get status(){return this.f}get conflicts(){return this.i}get lastSyncTime(){return this.m}constructor(R,j,U,z,F,L,M,$,G){super(),this.v=R,this.w=j,this.y=U,this.z=z,this.C=F,this.D=L,this.F=M,this.G=$,this.H=G,this.f="uninitialized",this.g=this.B(new O.Emitter),this.onDidChangeStatus=this.g.event,this.h=this.B(new O.Emitter),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.B(new O.Emitter),this.onDidChangeConflicts=this.j.event,this.k=[],this.l=this.B(new O.Emitter),this.onSyncErrors=this.l.event,this.m=void 0,this.n=this.B(new O.Emitter),this.onDidChangeLastSyncTime=this.n.event,this.r=this.B(new O.Emitter),this.onDidResetLocal=this.r.event,this.t=this.B(new O.Emitter),this.onDidResetRemote=this.t.event,this.u=new Map,this.f=j.userDataSyncStore?"idle":"uninitialized",this.m=this.D.getNumber(o,-1,void 0),this.B((0,P.toDisposable)(()=>this.W()))}async createSyncTask(R,j){this.X(),this.z.info("Sync started.");const U=new Date().getTime(),z=(0,C.generateUuid)();try{const $=(0,t.createSyncHeaders)(z);j&&($["Cache-Control"]="no-cache"),R=await this.v.manifest(R,$)}catch($){const G=t.UserDataSyncError.toUserDataSyncError($);throw g(G,z,this.w,this.C),G}const F=!1,L=this;let M;return{manifest:R,async run(){if(F)throw new Error("Can run a task only once");M=(0,i.createCancelablePromise)($=>L.I(R,!1,z,$)),await M.finally(()=>M=void 0),L.z.info(`Sync done. Took ${new Date().getTime()-U}ms`),L.S()},stop(){return M?.cancel(),L.N()}}}async createManualSyncTask(){if(this.X(),this.F.isEnabled())throw new t.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.z.info("Sync started.");const R=new Date().getTime(),j=(0,C.generateUuid)(),U=(0,t.createSyncHeaders)(j);let z;try{z=await this.v.manifest(null,U)}catch(M){const $=t.UserDataSyncError.toUserDataSyncError(M);throw g($,j,this.w,this.C),$}await this.resetLocal();const F=this,L=new D.CancellationTokenSource;return{id:j,async merge(){return F.I(z,!0,j,L.token)},async apply(){try{try{await F.L(z,j,L.token)}catch(M){if(t.UserDataSyncError.toUserDataSyncError(M).code==="MethodNotFound")F.z.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.z.info("Applying manual sync again..."),await F.L(z,j,L.token);else throw M}}catch(M){throw F.z.error(M),M}F.z.info(`Sync done. Took ${new Date().getTime()-R}ms`),F.S()},async stop(){L.cancel(),await F.N(),await F.resetLocal()}}}async I(R,j,U,z){this.k=[];try{this.status!=="hasConflicts"&&this.Q("syncing");const F=this.getOrCreateActiveProfileSynchronizer(this.G.defaultProfile,void 0);this.k.push(...await this.M(F,R,j,U,z));const L=F.enabled.find(M=>M.resource==="profiles");if(L){const M=await L.getLastSyncedProfiles()||[];if(z.isCancellationRequested)return;await this.J(M,R,j,U,z)}}finally{this.l.fire(this.k)}}async J(R,j,U,z,F){for(const L of R){if(F.isCancellationRequested)return;const M=this.G.profiles.find(G=>G.id===L.id);if(!M){this.z.error(`Profile with id:${L.id} and name: ${L.name} does not exist locally to sync.`);continue}this.z.info("Syncing profile.",L.name);const $=this.getOrCreateActiveProfileSynchronizer(M,L);this.k.push(...await this.M($,j,U,z,F))}for(const[L,M]of this.u.entries())this.G.profiles.some($=>$.id===M[0].profile.id)||(M[1].dispose(),this.u.delete(L))}async L(R,j,U){const z=this.U();for(const G of z){if(U.isCancellationRequested)return;await G.apply(j,U)}const F=z.find(G=>G.profile.isDefault);if(!F)return;const L=F.enabled.find(G=>G.resource==="profiles");if(!L)return;const $=(await L.getRemoteSyncedProfiles(R?.latest??null)||[]).filter(G=>z.every(W=>W.profile.id!==G.id));$.length&&await this.J($,R,!1,j,U)}async M(R,j,U,z,F){return(await R.sync(j,U,z,F)).map(([M,$])=>({profile:R.profile,syncResource:M,error:$}))}async N(){this.status!=="idle"&&await Promise.allSettled(this.U().map(R=>R.stop()))}async resolveContent(R){const j=await this.H.resolveContent(R);if(j)return j;for(const U of this.U())for(const z of U.enabled){const F=await z.resolveContent(R);if(F)return F}return null}async replace(R){this.X();const j=this.H.resolveUserDataSyncResource(R);if(!j)return;const U=await this.resolveContent(R.uri);!U||await this.O(j.profile,async z=>{if(j.syncResource===z.resource)return await z.replace(U),!0})}async accept(R,j,U,z){this.X(),await this.O(R.profile,async F=>{if(R.syncResource===F.resource)return await F.accept(j,U),z&&await F.apply((0,S.isBoolean)(z)?!1:z.force,(0,t.createSyncHeaders)((0,C.generateUuid)())),!0})}getRemoteProfiles(){return this.H.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(R,j){return this.H.getRemoteSyncResourceHandles(R,j)}async getLocalSyncResourceHandles(R,j){return this.H.getLocalSyncResourceHandles(R,j??this.G.defaultProfile)}async getAssociatedResources(R){return this.H.getAssociatedResources(R)}async getMachineId(R){return this.H.getMachineId(R)}async hasLocalData(){return!!await this.O(this.G.defaultProfile,async j=>{if(j.resource!=="globalState"&&await j.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.O(this.G.defaultProfile,async j=>{if(await j.hasPreviouslySynced())return!0})}async reset(){this.X(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.X();try{await this.v.clear(),this.z.info("Cleared data on server")}catch(R){this.z.error(R)}this.t.fire()}async resetLocal(){this.X(),this.m=void 0,this.D.remove(o,-1);for(const[R]of this.u.values())try{await R.resetLocal()}catch(j){this.z.error(j)}this.W(),this.r.fire(),this.z.info("Did reset the local sync state.")}async cleanUpRemoteData(){const R=await this.H.getRemoteSyncedProfiles(),j=R.map(L=>L.collection),U=await this.v.getAllCollections(),z=U.filter(L=>!j.includes(L));z.length&&(this.z.info(`Deleting ${z.length} redundant collections on server`),await Promise.allSettled(z.map(L=>this.v.deleteCollection(L))),this.z.info("Deleted redundant collections on server"));const F=R.filter(L=>U.includes(L.collection));if(F.length!==R.length){this.z.info("Updating remote profiles with invalid collections on server");const L=this.y.createInstance(r.UserDataProfilesManifestSynchroniser,this.G.defaultProfile,void 0);try{await L.updateRemoteProfiles(F,null),this.z.info("Updated remote profiles on server")}finally{L.dispose()}}}async O(R,j){const U=new P.DisposableStore;try{const z=this.u.get(R.id);if(z){const G=await this.P(z[0],j,U);return(0,S.isUndefined)(G)?null:G}if(R.isDefault){const G=U.add(this.y.createInstance(c,R,void 0)),W=await this.P(G,j,U);return(0,S.isUndefined)(W)?null:W}if(this.G.isEnabled())return null;const F=U.add(this.y.createInstance(r.UserDataProfilesManifestSynchroniser,R,void 0)),L=await this.v.manifest(null),$=(await F.getRemoteSyncedProfiles(L?.latest??null)||[]).find(G=>G.id===R.id);if($){const G=U.add(this.y.createInstance(c,R,$.collection)),W=await this.P(G,j,U);return(0,S.isUndefined)(W)?null:W}return null}finally{U.dispose()}}async P(R,j,U){const z=[...R.enabled,...R.disabled.map(F=>U.add(R.createSynchronizer(F)))];for(const F of z){const L=await j(F);if(!(0,S.isUndefined)(L))return L}}Q(R){const j=this.f;this.f!==R&&(this.f=R,this.g.fire(R),j==="hasConflicts"&&this.S())}R(){const R=this.U().map(j=>j.conflicts).flat();(0,k.equals)(this.i,R,(j,U)=>j.profile.id===U.profile.id&&j.syncResource===U.syncResource&&(0,k.equals)(j.conflicts,U.conflicts,(z,F)=>(0,I.isEqual)(z.previewResource,F.previewResource)))||(this.i=R,this.j.fire(R))}S(){this.status==="idle"&&(this.m=new Date().getTime(),this.D.store(o,this.m,-1,1),this.n.fire(this.m))}getOrCreateActiveProfileSynchronizer(R,j){let U=this.u.get(R.id);if(U&&U[0].collection!==j?.collection&&(this.z.error("Profile synchronizer collection does not match with the remote sync profile collection"),U[1].dispose(),U=void 0,this.u.delete(R.id)),!U){const z=new P.DisposableStore,F=z.add(this.y.createInstance(c,R,j?.collection));z.add(F.onDidChangeStatus(L=>this.Q(L))),z.add(F.onDidChangeConflicts(L=>this.R())),z.add(F.onDidChangeLocal(L=>this.h.fire(L))),this.u.set(R.id,U=[F,z])}return U[0]}U(){const R=[];for(const[j]of this.u.values())R.push(j);return R}W(){this.u.forEach(([,R])=>R.dispose()),this.u.clear()}X(){if(!this.w.userDataSyncStore)throw new Error("Not enabled")}};s=pe([Y(0,t.IUserDataSyncStoreService),Y(1,t.IUserDataSyncStoreManagementService),Y(2,p.IInstantiationService),Y(3,t.IUserDataSyncLogService),Y(4,y.ITelemetryService),Y(5,f.IStorageService),Y(6,t.IUserDataSyncEnablementService),Y(7,v.IUserDataProfilesService),Y(8,t.IUserDataSyncResourceProviderService)],s),e.UserDataSyncService=s;let c=class extends P.Disposable{get enabled(){return this.f.sort((R,j)=>R[1]-j[1]).map(([R])=>R)}get disabled(){return t.ALL_SYNC_RESOURCES.filter(R=>!this.l.isResourceEnabled(R))}get status(){return this.g}get conflicts(){return this.j}constructor(R,j,U,z,F,L,M,$,G,W){super(),this.profile=R,this.collection=j,this.l=U,this.m=z,this.n=F,this.r=L,this.t=M,this.u=$,this.v=G,this.w=W,this.f=[],this.g="idle",this.h=this.B(new O.Emitter),this.onDidChangeStatus=this.h.event,this.i=this.B(new O.Emitter),this.onDidChangeLocal=this.i.event,this.j=[],this.k=this.B(new O.Emitter),this.onDidChangeConflicts=this.k.event,this.B(U.onDidChangeResourceEnablement(([_,K])=>this.y(_,K))),this.B((0,P.toDisposable)(()=>this.f.splice(0,this.f.length).forEach(([,,_])=>_.dispose())));for(const _ of t.ALL_SYNC_RESOURCES)U.isResourceEnabled(_)&&this.z(_)}y(R,j){j?this.z(R):this.C(R)}z(R){if(this.f.some(([F])=>F.resource===R))return;if(R==="extensions"&&!this.n.isEnabled()){this.u.info("Skipping extensions sync because gallery is not configured");return}if(R==="profiles"&&(!this.profile.isDefault||!this.v.isEnabled()))return;const j=new P.DisposableStore,U=j.add(this.createSynchronizer(R));j.add(U.onDidChangeStatus(()=>this.G())),j.add(U.onDidChangeConflicts(()=>this.H())),j.add(U.onDidChangeLocal(()=>this.i.fire(R)));const z=this.I(R);this.f.push([U,z,j])}C(R){const j=this.f.findIndex(([U])=>U.resource===R);if(j!==-1){const[[U,,z]]=this.f.splice(j,1);z.dispose(),this.G(),Promise.allSettled([U.stop(),U.resetLocal()]).then(null,F=>this.u.error(F))}}createSynchronizer(R){switch(R){case"settings":return this.m.createInstance(d.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.m.createInstance(u.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.m.createInstance(h.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.m.createInstance(n.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.m.createInstance(m.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.m.createInstance(l.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.m.createInstance(r.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(R,j,U,z){if(z.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const L=[],M=(0,t.createSyncHeaders)(U),$=(this.collection?R?.collections?.[this.collection]?.latest:R?.latest)??null,G=j?await this.D($):{};for(const W of F){if(z.isCancellationRequested)return[];if(!this.l.isResourceEnabled(W.resource))return[];try{if(j){const _=await W.preview($,G,M);if(_)for(const K of _.resourcePreviews)(K.localChange!==0||K.remoteChange!==0)&&K.mergeState==="preview"&&await W.merge(K.previewResource)}else await W.sync($,M)}catch(_){const K=t.UserDataSyncError.toUserDataSyncError(_);if(g(K,U,this.r,this.t),a(_))throw K;this.u.error(_),this.u.error(`${W.resource}: ${(0,A.toErrorMessage)(_)}`),L.push([W.resource,K])}}return L}finally{this.G()}}async apply(R,j){const U=(0,t.createSyncHeaders)(R);for(const z of this.enabled){if(j.isCancellationRequested)return;try{await z.apply(!1,U)}catch(F){const L=t.UserDataSyncError.toUserDataSyncError(F);if(g(L,R,this.r,this.t),a(F))throw L;this.u.error(F),this.u.error(`${z.resource}: ${(0,A.toErrorMessage)(F)}`)}}}async stop(){for(const R of this.enabled)try{R.status!=="idle"&&await R.stop()}catch(j){this.u.error(j)}}async resetLocal(){for(const R of this.enabled)try{await R.resetLocal()}catch(j){this.u.error(`${R.resource}: ${(0,A.toErrorMessage)(j)}`),this.u.error(j)}}async D(R){if(!this.profile.isDefault)return{};const j=this.w.getValue(t.USER_DATA_SYNC_CONFIGURATION_SCOPE),U=this.enabled.find(z=>z instanceof d.SettingsSynchroniser);if(U){const z=await U.getRemoteUserDataSyncConfiguration(R);return{...j,...z}}return j}F(R){this.g!==R&&(this.g=R,this.h.fire(R))}G(){return this.H(),this.enabled.some(R=>R.status==="hasConflicts")?this.F("hasConflicts"):this.enabled.some(R=>R.status==="syncing")?this.F("syncing"):this.F("idle")}H(){const R=this.enabled.filter(j=>j.status==="hasConflicts").filter(j=>j.conflicts.conflicts.length>0).map(j=>j.conflicts);(0,k.equals)(this.j,R,(j,U)=>j.syncResource===U.syncResource&&(0,k.equals)(j.conflicts,U.conflicts,(z,F)=>(0,I.isEqual)(z.previewResource,F.previewResource)))||(this.j=R,this.k.fire(R))}I(R){switch(R){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6}}};c=pe([Y(2,t.IUserDataSyncEnablementService),Y(3,p.IInstantiationService),Y(4,w.IExtensionGalleryService),Y(5,t.IUserDataSyncStoreManagementService),Y(6,y.ITelemetryService),Y(7,t.IUserDataSyncLogService),Y(8,v.IUserDataProfilesService),Y(9,E.IConfigurationService)],c);function a(b){if(b instanceof t.UserDataSyncError)switch(b.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function g(b,R,j,U){U.publicLog2("sync/error",{code:b.code,serverCode:b instanceof t.UserDataSyncStoreError?String(b.serverCode):void 0,url:b instanceof t.UserDataSyncStoreError?b.url:void 0,resource:b.resource,executionId:R,service:j.userDataSyncStore.url.toString()})}}),define(oe[275],ae([0,1,3,2,7,18,26]),function(ee,e,k,i,D,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function P(w,p){return{...w,profile:(0,A.reviveProfile)(w.profile,p.profilesHome.scheme)}}function I(w){return{created:w.created,uri:D.URI.revive(w.uri)}}class S{constructor(p,f,y){this.c=p,this.d=f,this.f=y,this.a=new Map,this.b=new k.Emitter}listen(p,f){switch(f){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${f}`)}async call(p,f,y){try{return await this.g(p,f,y)}catch(v){throw this.f.error(v),v}}async g(p,f,y){switch(f){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(D.URI.revive(y[0]));case"accept":return this.c.accept(P(y[0],this.d),D.URI.revive(y[1]),y[2],y[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(y[0],(0,A.reviveProfile)(y[1],this.d.profilesHome.scheme));case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(y[0],y[1]);case"replace":return this.c.replace(I(y[0]));case"getAssociatedResources":return this.c.getAssociatedResources(I(y[0]));case"getMachineId":return this.c.getMachineId(I(y[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"createManualSyncTask":return this.i()}if(f.startsWith("manualSync/")){const v=f.substring(11),l=y[0],m=this.h(l);switch(y=y.slice(1),v){case"merge":return m.merge();case"apply":return m.apply().then(()=>this.a.delete(this.j(m.id)));case"stop":return m.stop().finally(()=>this.a.delete(this.j(m.id)))}}throw new Error("Invalid call")}h(p){const f=this.a.get(this.j(p));if(!f)throw new Error(`Manual sync taks not found: ${p}`);return f}async i(){const p=await this.c.createManualSyncTask();return this.a.set(this.j(p.id),p),p.id}j(p){return`manualSyncTask-${p}`}}e.UserDataSyncChannel=S;let C=class extends i.Disposable{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(p,f){super(),this.k=f,this.b="uninitialized",this.c=this.B(new k.Emitter),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new k.Emitter),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.B(new k.Emitter),this.onDidChangeLastSyncTime=this.i.event,this.j=this.B(new k.Emitter),this.onSyncErrors=this.j.event,this.a={call(y,v,l){return p.call(y,v,l).then(null,m=>{throw O.UserDataSyncError.toUserDataSyncError(m)})},listen(y,v){return p.listen(y,v)}},this.a.call("_getInitialData").then(([y,v,l])=>{this.l(y),this.m(v),l&&this.n(l),this.B(this.a.listen("onDidChangeStatus")(m=>this.l(m))),this.B(this.a.listen("onDidChangeLastSyncTime")(m=>this.n(m)))}),this.B(this.a.listen("onDidChangeConflicts")(y=>this.m(y))),this.B(this.a.listen("onSyncErrors")(y=>this.j.fire(y.map(v=>({...v,error:O.UserDataSyncError.toUserDataSyncError(v.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const p=await this.a.call("createManualSyncTask"),f=this;return new E(p,{async call(v,l,m){return f.a.call(`manualSync/${v}`,[p,...Array.isArray(l)?l:[l]],m)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(p,f,y,v){return this.a.call("accept",[p,f,y,v])}resolveContent(p){return this.a.call("resolveContent",[p])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(p,f){return(await this.a.call("getLocalSyncResourceHandles",[p,f])).map(({created:v,uri:l})=>({created:v,uri:D.URI.revive(l)}))}async getRemoteSyncResourceHandles(p,f){return(await this.a.call("getRemoteSyncResourceHandles",[p,f])).map(({created:v,uri:l})=>({created:v,uri:D.URI.revive(l)}))}async getAssociatedResources(p){return(await this.a.call("getAssociatedResources",[p])).map(({resource:y,comparableResource:v})=>({resource:D.URI.revive(y),comparableResource:D.URI.revive(v)}))}getMachineId(p){return this.a.call("getMachineId",[p])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(p){return this.a.call("replace",[p])}async l(p){this.b=p,this.c.fire(p)}async m(p){this.f=p.map(f=>({syncResource:f.syncResource,profile:(0,A.reviveProfile)(f.profile,this.k.profilesHome.scheme),conflicts:f.conflicts.map(y=>({...y,baseResource:D.URI.revive(y.baseResource),localResource:D.URI.revive(y.localResource),remoteResource:D.URI.revive(y.remoteResource),previewResource:D.URI.revive(y.previewResource)}))})),this.g.fire(this.f)}n(p){this.h!==p&&(this.h=p,this.i.fire(p))}};C=pe([Y(1,A.IUserDataProfilesService)],C),e.UserDataSyncChannelClient=C;class E extends i.Disposable{constructor(p,f){super(),this.id=p,this.a=f}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(oe[276],ae([0,1,6,23,9,3,2,138,5,21,14,7,31,16,15,13,25,59,45,19,26]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p,f,y,v,l,m,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const h="sync.previous.store",n="sync.donot-make-requests-until",r="sync.user-session-id",t="sync.machine-session-id",o=100,s=1e3*60*5;let c=class extends O.Disposable{get userDataSyncStore(){return this.b}get c(){return this.h.get(d.SYNC_SERVICE_URL_TYPE,-1)}set c(U){this.h.store(d.SYNC_SERVICE_URL_TYPE,U,-1,I.isWeb?0:1)}constructor(U,z,F){super(),this.f=U,this.g=z,this.h=F,this.a=this.B(new A.Emitter),this.onDidChangeUserDataSyncStore=this.a.event,this.i(),this.B(A.Event.filter(F.onDidChangeValue,L=>L.key===d.SYNC_SERVICE_URL_TYPE&&L.scope===-1&&this.c!==this.userDataSyncStore?.type)(()=>this.i()))}i(){this.b=this.j(this.f[d.CONFIGURATION_SYNC_STORE_KEY],this.g.getValue(d.CONFIGURATION_SYNC_STORE_KEY)),this.a.fire()}j(U,z){U=I.isWeb&&U?.web?{...U,...U.web}:U;const F={...U||{},...z||{}};if(F&&(0,C.isString)(F.url)&&(0,C.isObject)(F.authenticationProviders)&&Object.keys(F.authenticationProviders).every(L=>Array.isArray(F.authenticationProviders[L].scopes))){const L=F,M=!!L.canSwitch&&!z?.url,$=L.url===L.insidersUrl?"insiders":"stable",G=(M?this.c:void 0)||$,W=z?.url||(G==="insiders"?L.insidersUrl:G==="stable"?L.stableUrl:L.url);return{url:E.URI.parse(W),type:G,defaultType:$,defaultUrl:E.URI.parse(L.url),stableUrl:E.URI.parse(L.stableUrl),insidersUrl:E.URI.parse(L.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(L.authenticationProviders).reduce((_,K)=>(_.push({id:K,scopes:L.authenticationProviders[K].scopes}),_),[])}}}};c=pe([Y(0,v.IProductService),Y(1,p.IConfigurationService),Y(2,u.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let a=class extends c{constructor(U,z,F){super(U,z,F);const L=this.h.get(h,-1);L&&(this.k=JSON.parse(L));const M=this.f[d.CONFIGURATION_SYNC_STORE_KEY];M?this.h.store(h,JSON.stringify(M),-1,1):this.h.remove(h,-1)}async switch(U){U!==this.c&&(this.c=U,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};a=pe([Y(0,v.IProductService),Y(1,p.IConfigurationService),Y(2,u.IStorageService)],a),e.UserDataSyncStoreManagementService=a;let g=class extends O.Disposable{get donotMakeRequestsUntil(){return this.i}constructor(U,z,F,L,M,$,G){super(),this.k=F,this.l=L,this.n=G,this.g=this.B(new A.Emitter),this.onTokenFailed=this.g.event,this.h=this.B(new A.Emitter),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.B(new A.Emitter),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.s=void 0,this.p(U),this.c=(0,m.getServiceMachineId)(M,$,G).then(W=>{const _={"X-Client-Name":`${z.applicationName}${I.isWeb?"-web":""}`,"X-Client-Version":z.version};return z.commit&&(_["X-Client-Commit"]=z.commit),_}),this.f=new R(o,s,this.k,this.l),this.r(),this.B((0,O.toDisposable)(()=>{this.s&&(this.s.cancel(),this.s=void 0)}))}setAuthToken(U,z){this.b={token:U,type:z}}p(U){this.a=U?(0,S.joinPath)(U,"v1"):void 0}r(){const U=this.n.getNumber(n,-1);U&&Date.now()<U&&this.t(new Date(U))}t(U){this.i?.getTime()!==U?.getTime()&&(this.i=U,this.s&&(this.s.cancel(),this.s=void 0),this.i?(this.n.store(n,this.i.getTime(),-1,1),this.s=(0,k.createCancelablePromise)(z=>(0,k.timeout)(this.i.getTime()-Date.now(),z).then(()=>this.t(void 0))),this.s.then(null,z=>null)):this.n.remove(n,-1),this.j.fire())}async getAllCollections(U={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=(0,S.joinPath)(this.a,"collection").toString();U={...U},U["Content-Type"]="application/json";const F=await this.w(z,{type:"GET",headers:U},[],i.CancellationToken.None);return(await(0,l.asJson)(F))?.map(({id:L})=>L)||[]}async createCollection(U={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=(0,S.joinPath)(this.a,"collection").toString();U={...U},U["Content-Type"]=P.Mimes.text;const F=await this.w(z,{type:"POST",headers:U},[],i.CancellationToken.None),L=await(0,l.asTextOrError)(F);if(!L)throw new d.UserDataSyncStoreError("Server did not return the collection id",z,"NoCollection",F.res.statusCode,F.res.headers[d.HEADER_OPERATION_ID]);return L}async deleteCollection(U,z={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=U?(0,S.joinPath)(this.a,"collection",U).toString():(0,S.joinPath)(this.a,"collection").toString();z={...z},await this.w(F,{type:"DELETE",headers:z},[],i.CancellationToken.None)}async getAllResourceRefs(U,z){if(!this.a)throw new Error("No settings sync store url configured.");const F=this.u(this.a,z,U),L={},M=await this.w(F.toString(),{type:"GET",headers:L},[],i.CancellationToken.None);return(await(0,l.asJson)(M)||[]).map(({url:G,created:W})=>({ref:(0,S.relativePath)(F,F.with({path:G})),created:W*1e3}))}async resolveResourceContent(U,z,F,L={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,S.joinPath)(this.u(this.a,F,U),z).toString();L={...L},L["Cache-Control"]="no-cache";const $=await this.w(M,{type:"GET",headers:L},[],i.CancellationToken.None);return await(0,l.asTextOrError)($)}async deleteResource(U,z,F){if(!this.a)throw new Error("No settings sync store url configured.");const L=z!==null?(0,S.joinPath)(this.u(this.a,F,U),z).toString():this.u(this.a,F,U).toString(),M={};await this.w(L,{type:"DELETE",headers:M},[],i.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,S.joinPath)(this.a,"resource").toString(),z={"Content-Type":P.Mimes.text};await this.w(U,{type:"DELETE",headers:z},[],i.CancellationToken.None)}async readResource(U,z,F,L={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,S.joinPath)(this.u(this.a,F,U),"latest").toString();L={...L},L["Cache-Control"]="no-cache",z&&(L["If-None-Match"]=z.ref);const $=await this.w(M,{type:"GET",headers:L},[304],i.CancellationToken.None);let G=null;if($.res.statusCode===304&&(G=z),G===null){const W=$.res.headers.etag;if(!W)throw new d.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",$.res.statusCode,$.res.headers[d.HEADER_OPERATION_ID]);const _=await(0,l.asTextOrError)($);if(!_&&$.res.statusCode===304)throw new d.UserDataSyncStoreError("Empty response",M,"EmptyResponse",$.res.statusCode,$.res.headers[d.HEADER_OPERATION_ID]);G={ref:W,content:_}}return G}async writeResource(U,z,F,L,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const $=this.u(this.a,L,U).toString();M={...M},M["Content-Type"]=P.Mimes.text,F&&(M["If-Match"]=F);const G=await this.w($,{type:"POST",data:z,headers:M},[],i.CancellationToken.None),W=G.res.headers.etag;if(!W)throw new d.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",G.res.statusCode,G.res.headers[d.HEADER_OPERATION_ID]);return W}async manifest(U,z={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,S.joinPath)(this.a,"manifest").toString();z={...z},z["Content-Type"]="application/json",U&&(z["If-None-Match"]=U.ref);const L=await this.w(F,{type:"GET",headers:z},[304],i.CancellationToken.None);let M=null;if(L.res.statusCode===304&&(M=U),!M){const G=L.res.headers.etag;if(!G)throw new d.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",L.res.statusCode,L.res.headers[d.HEADER_OPERATION_ID]);const W=await(0,l.asTextOrError)(L);if(!W&&L.res.statusCode===304)throw new d.UserDataSyncStoreError("Empty response",F,"EmptyResponse",L.res.statusCode,L.res.headers[d.HEADER_OPERATION_ID]);W&&(M={...JSON.parse(W),ref:G})}const $=this.n.get(r,-1);return $&&M&&$!==M.session&&this.v(),M===null&&$&&this.v(),M&&this.n.store(r,M.session,-1,1),M}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.v()}u(U,z,F){return z?(0,S.joinPath)(U,"collection",z,"resource",F):(0,S.joinPath)(U,"resource",F)}v(){this.n.remove(r,-1),this.n.remove(t,-1)}async w(U,z,F,L){if(!this.b)throw new d.UserDataSyncStoreError("No Auth Token Available",U,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new d.UserDataSyncStoreError(`${z.type} request '${U}' failed because of too many requests (429).`,U,"TooManyRequestsAndRetryAfter",void 0,void 0);this.t(void 0);const M=await this.c;z.headers={...z.headers||{},...M,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.y(z.headers),this.l.trace("Sending request to server",{url:U,type:z.type,headers:{...z.headers,authorization:void 0}});let $;try{$=await this.f.request(U,z,L)}catch(q){if(!(q instanceof d.UserDataSyncStoreError)){let V="RequestFailed";const Z=(0,D.getErrorMessage)(q).toLowerCase();Z.includes("xhr timeout")?V="RequestTimeout":Z.includes("protocol")&&Z.includes("not supported")?V="RequestProtocolNotSupported":Z.includes("request path contains unescaped characters")?V="RequestPathNotEscaped":Z.includes("headers must be an object")?V="RequestHeadersNotObject":(0,D.isCancellationError)(q)&&(V="RequestCanceled"),q=new d.UserDataSyncStoreError(`Connection refused for the request '${U}'.`,U,V,void 0,void 0)}throw this.l.info("Request failed",U),q}const G=$.res.headers[d.HEADER_OPERATION_ID],W={url:U,status:$.res.statusCode,"execution-id":z.headers[d.HEADER_EXECUTION_ID],"operation-id":G},_=(0,l.isSuccess)($)||$.res.statusCode&&F.indexOf($.res.statusCode)!==-1;let K="";if(_?this.l.trace("Request succeeded",W):(this.l.info("Request failed",W),K=await(0,l.asText)($)||""),$.res.statusCode===401)throw this.b=void 0,this.g.fire(),new d.UserDataSyncStoreError(`Request '${U}' failed because of Unauthorized (401).`,U,"Unauthorized",$.res.statusCode,G);if(this.h.fire(),$.res.statusCode===404)throw new d.UserDataSyncStoreError(`${z.type} request '${U}' failed because the requested resource is not found (404).`,U,"NotFound",$.res.statusCode,G);if($.res.statusCode===405)throw new d.UserDataSyncStoreError(`${z.type} request '${U}' failed because the requested endpoint is not found (405). ${K}`,U,"MethodNotFound",$.res.statusCode,G);if($.res.statusCode===409)throw new d.UserDataSyncStoreError(`${z.type} request '${U}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,U,"Conflict",$.res.statusCode,G);if($.res.statusCode===410)throw new d.UserDataSyncStoreError(`${z.type} request '${U}' failed because the requested resource is not longer available (410).`,U,"Gone",$.res.statusCode,G);if($.res.statusCode===412)throw new d.UserDataSyncStoreError(`${z.type} request '${U}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,U,"PreconditionFailed",$.res.statusCode,G);if($.res.statusCode===413)throw new d.UserDataSyncStoreError(`${z.type} request '${U}' failed because of too large payload (413).`,U,"TooLarge",$.res.statusCode,G);if($.res.statusCode===426)throw new d.UserDataSyncStoreError(`${z.type} request '${U}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,U,"UpgradeRequired",$.res.statusCode,G);if($.res.statusCode===429){const q=$.res.headers["retry-after"];throw q?(this.t(new Date(Date.now()+parseInt(q)*1e3)),new d.UserDataSyncStoreError(`${z.type} request '${U}' failed because of too many requests (429).`,U,"TooManyRequestsAndRetryAfter",$.res.statusCode,G)):new d.UserDataSyncStoreError(`${z.type} request '${U}' failed because of too many requests (429).`,U,"RemoteTooManyRequests",$.res.statusCode,G)}if(!_)throw new d.UserDataSyncStoreError("Server returned "+$.res.statusCode,U,"Unknown",$.res.statusCode,G);return $}y(U){let z=this.n.get(t,-1);z===void 0&&(z=(0,w.generateUuid)(),this.n.store(t,z,-1,1)),U["X-Machine-Session-Id"]=z;const F=this.n.get(r,-1);F!==void 0&&(U["X-User-Session-Id"]=F)}};g=pe([Y(1,v.IProductService),Y(2,l.IRequestService),Y(3,d.IUserDataSyncLogService),Y(4,f.IEnvironmentService),Y(5,y.IFileService),Y(6,u.IStorageService)],g),e.UserDataSyncStoreClient=g;let b=class extends g{constructor(U,z,F,L,M,$,G){super(U.userDataSyncStore?.url,z,F,L,M,$,G),this.B(U.onDidChangeUserDataSyncStore(()=>this.p(U.userDataSyncStore?.url)))}};b=pe([Y(0,d.IUserDataSyncStoreManagementService),Y(1,v.IProductService),Y(2,l.IRequestService),Y(3,d.IUserDataSyncLogService),Y(4,f.IEnvironmentService),Y(5,y.IFileService),Y(6,u.IStorageService)],b),e.UserDataSyncStoreService=b;class R{constructor(U,z,F,L){this.c=U,this.d=z,this.f=F,this.g=L,this.a=[],this.b=void 0}request(U,z,F){if(this.h()&&this.i(),z.url=U,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new d.UserDataSyncStoreError(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,U,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(U),this.f.request(z,F)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.RequestsSession=R}),define(oe[277],ae([0,1,3,57,25,19,22,272,26,78,81]),function(ee,e,k,i,D,A,O,P,I,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let E=class extends P.UserDataAutoSyncService{constructor(p,f,y,v,l,m,u,d,h,n,r){super(p,f,y,v,l,u,d,h,n,r),this.B(k.Event.debounce(k.Event.any(k.Event.map(m.onDidFocusWindow,()=>"windowFocus"),k.Event.map(m.onDidOpenWindow,()=>"windowOpen")),(t,o)=>t?[...t,o]:[o],1e3)(t=>this.triggerSync(t,!0,!1)))}};E=pe([Y(0,D.IProductService),Y(1,I.IUserDataSyncStoreManagementService),Y(2,I.IUserDataSyncStoreService),Y(3,I.IUserDataSyncEnablementService),Y(4,I.IUserDataSyncService),Y(5,i.INativeHostService),Y(6,I.IUserDataSyncLogService),Y(7,S.IUserDataSyncAccountService),Y(8,O.ITelemetryService),Y(9,C.IUserDataSyncMachinesService),Y(10,A.IStorageService)],E),e.UserDataAutoSyncService=E}),define(oe[278],ae([0,1,99,24,5,21]),function(ee,e,k,i,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function O(S){function C(){let E=S.scheme===i.Schemas.file?(0,A.originalFSPath)(S):S.toString();return D.isLinux||(E=E.toLowerCase()),(0,k.createHash)("md5").update(E).digest("hex")}return{id:C(),configPath:S}}e.getWorkspaceIdentifier=O;function P(S,C){function E(){if(S.scheme!==i.Schemas.file)return(0,k.createHash)("md5").update(S.toString()).digest("hex");if(!C)return;let p;return D.isLinux?p=C.ino:D.isMacintosh?p=C.birthtime.getTime():D.isWindows&&(typeof C.birthtimeMs=="number"?p=Math.floor(C.birthtimeMs):p=C.birthtime.getTime()),(0,k.createHash)("md5").update(S.fsPath).update(p?String(p):"").digest("hex")}const w=E();if(typeof w=="string")return{id:w,uri:S}}e.getSingleFolderWorkspaceIdentifier=P;function I(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=I}),define(oe[279],ae([0,1,6,9,2,12,28,15,56,8,57,76,115,278]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let f=class extends D.Disposable{constructor(v,l,m,u){super(),this.a=v,this.b=l,this.c=m,this.f=u,this.B(new k.RunOnceScheduler(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const v=await O.Promises.readdir(this.a.workspaceStorageHome.fsPath),l=new E.StorageClient(this.f.getChannel("storage"));await Promise.all(v.map(async m=>{const u=(0,A.join)(this.a.workspaceStorageHome.fsPath,m);m.length===p.NON_EMPTY_WORKSPACE_ID_LENGTH||m===w.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.c.getWindows()).some(n=>n.workspace?.id===m)||await l.isUsed(u)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${m} as it seems to be an unused empty workspace.`),await O.Promises.rm(u))}))}catch(v){(0,i.onUnexpectedError)(v)}}};f=pe([Y(0,P.INativeEnvironmentService),Y(1,S.ILogService),Y(2,C.INativeHostService),Y(3,I.IMainProcessService)],f),e.UnusedWorkspaceStorageDataCleaner=f}),define(oe[124],ae([0,1,52,6,12,14,28,150,288,289]),function(ee,e,k,i,D,A,O,P,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class C extends Error{constructor(n,r){let t=r.message;switch(n){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=n,this.cause=r}}e.ExtractError=C;function E(h){const n=h.externalFileAttributes>>16||33188;return[448,56,7].map(r=>n&r).reduce((r,t)=>r+t,n&61440)}function w(h){if(h instanceof C)return h;let n;return/end of central directory record signature not found/.test(h.message)&&(n="CorruptZip"),new C(n,h)}function p(h,n,r,t,o,s){const c=D.dirname(n),a=D.join(t,c);if(!a.startsWith(t))return Promise.reject(new Error(P.localize(0,null,n)));const g=D.join(t,n);let b;return s.onCancellationRequested(()=>{b?.destroy()}),Promise.resolve(O.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((R,j)=>{if(!s.isCancellationRequested)try{b=(0,k.createWriteStream)(g,{mode:r}),b.once("close",()=>R()),b.once("error",j),h.once("error",j),h.pipe(b)}catch(U){j(U)}}))}function f(h,n,r,t){let o=(0,i.createCancelablePromise)(()=>Promise.resolve()),s=0;return t.onCancellationRequested(()=>{o.cancel(),h.close()}),new Promise((c,a)=>{const g=new i.Sequencer,b=R=>{R.isCancellationRequested||(s++,h.readEntry())};h.once("error",a),h.once("close",()=>o.then(()=>{t.isCancellationRequested||h.entryCount===s?c():a(new C("Incomplete",new Error(P.localize(1,null,s,h.entryCount))))},a)),h.readEntry(),h.on("entry",R=>{if(t.isCancellationRequested)return;if(!r.sourcePathRegex.test(R.fileName)){b(t);return}const j=R.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(j)){const F=D.join(n,j);o=(0,i.createCancelablePromise)(L=>O.Promises.mkdir(F,{recursive:!0}).then(()=>b(L)).then(void 0,a));return}const U=v(h,R),z=E(R);o=(0,i.createCancelablePromise)(F=>g.queue(()=>U.then(L=>p(L,j,z,n,r,F).then(()=>b(F)))).then(null,a))})})}function y(h,n=!1){return new Promise((r,t)=>{(0,I.open)(h,n?{lazyEntries:!0}:void 0,(o,s)=>{o?t(w(o)):r((0,A.assertIsDefined)(s))})})}function v(h,n){return new Promise((r,t)=>{h.openReadStream(n,(o,s)=>{o?t(w(o)):r((0,A.assertIsDefined)(s))})})}function l(h,n){return new Promise((r,t)=>{const o=new S.ZipFile;n.forEach(c=>{c.contents?o.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&o.addFile(c.localPath,c.path)}),o.end();const s=(0,k.createWriteStream)(h);o.outputStream.pipe(s),o.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>r(h))})}e.zip=l;function m(h,n,r={},t){const o=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let s=y(h,!0);return r.overwrite&&(s=s.then(c=>O.Promises.rm(n).then(()=>c))),s.then(c=>f(c,n,{sourcePathRegex:o},t))}e.extract=m;function u(h,n){return y(h).then(r=>new Promise((t,o)=>{r.on("entry",s=>{s.fileName===n&&v(r,s).then(c=>t(c),c=>o(c))}),r.once("close",()=>o(new Error(P.localize(2,null,n))))}))}function d(h,n){return u(h,n).then(r=>new Promise((t,o)=>{const s=[];r.once("error",o),r.on("data",c=>s.push(c)),r.on("end",()=>t(Buffer.concat(s)))}))}e.buffer=d}),define(oe[280],ae([0,1,124,160]),function(ee,e,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(A){return(0,k.buffer)(A,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,i.localize)(0,null))}})}e.getManifest=D}),define(oe[125],ae([0,1,6,23,38,9,3,2,37,24,12,5,21,53,14,7,31,28,124,159,96,15,262,29,33,61,79,218,263,280,219,220,42,70,13,4,8,25,22,30,18]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p,f,y,v,l,m,u,d,h,n,r,t,o,s,c,a,g,b,R,j,U,z,F,L,M,$,G,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,F.refineServiceDecorator)(r.IExtensionManagementService);let _=class extends n.AbstractExtensionManagementService{constructor(T,N,H,B,Q,re,X,te,se,le,ue,ye){super(T,N,H,le,ye),this.Y=Q,this.Z=re,this.ab=X,this.bb=se,this.cb=ue,this.X=new Map,this.kb=new I.ResourceSet;const Se=this.B(te.createInstance(a.ExtensionsLifecycle));this.S=this.B(te.createInstance(K,Ee=>Se.postUninstall(Ee))),this.U=this.B(new b.ExtensionsManifestCache(B,this)),this.W=this.B(te.createInstance(c.ExtensionsDownloader,this.getTargetPlatform()));const be=this.B(new R.ExtensionsWatcher(this,this.Y,ye,re,ue,se,H));this.B(be.onDidChangeExtensionsByAnotherSource(Ee=>this.jb(Ee))),this.lb()}getTargetPlatform(){return this.db||(this.db=(0,t.computeTargetPlatform)(this.bb,this.v)),this.db}async zip(T){this.v.trace("ExtensionManagementService#zip",T.identifier.id);const N=await this.ib(T),H=await(0,m.zip)((0,w.joinPath)(this.W.extensionsDownloadDir,(0,v.generateUuid)()).fsPath,N);return y.URI.file(H)}async unzip(T){return this.v.trace("ExtensionManagementService#unzip",T.toString()),(await this.install(T)).identifier}async getManifest(T){const{location:N,cleanup:H}=await this.eb(T),B=C.resolve(N.fsPath);try{return await(0,g.getManifest)(B)}finally{await H()}}getInstalled(T,N){return this.S.scanExtensions(T??null,N)}getAllUserInstalled(){return this.S.scanAllUserExtensions(!1)}async install(T,N={}){this.v.trace("ExtensionManagementService#install",T.toString());const{location:H,cleanup:B}=await this.eb(T);try{const Q=await(0,g.getManifest)(C.resolve(H.fsPath));if(Q.engines&&Q.engines.vscode&&!(0,U.isEngineValid)(Q.engines.vscode,this.w.version,this.w.date))throw new Error(u.localize(0,null,(0,t.getGalleryExtensionId)(Q.publisher,Q.name),this.w.version));return await this.z(Q,H,N)}finally{await B()}}async installFromLocation(T,N){this.v.trace("ExtensionManagementService#installFromLocation",T.toString());const H=await this.S.scanUserExtensionAtLocation(T);if(!H)throw new Error(`Cannot find a valid extension from the location ${T.toString()}`);return await this.nb([H],N),this.v.info("Successfully installed extension",H.identifier.id,N.toString()),H}getMetadata(T){return this.Y.scanMetadata(T.location)}async updateMetadata(T,N){this.v.trace("ExtensionManagementService#updateMetadata",T.identifier.id);const H={...N};return N.isPreReleaseVersion&&(H.preRelease=!0),T=await this.S.updateMetadata(T,H),this.U.invalidate(),T}async updateExtensionScope(T,N){return this.v.trace("ExtensionManagementService#updateExtensionScope",T.identifier.id),T=await this.S.updateMetadata(T,{isMachineScoped:N}),this.U.invalidate(),T}async reinstallFromGallery(T){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",T.identifier.id),!this.t.isEnabled())throw new Error(u.localize(1,null));const N=await this.getTargetPlatform(),[H]=await this.t.getExtensions([{...T.identifier,preRelease:T.preRelease}],{targetPlatform:N,compatible:!0},i.CancellationToken.None);if(!H)throw new Error(u.localize(2,null));await this.S.setUninstalled(T);try{await this.S.removeUninstalledExtension(T)}catch(B){throw new Error(u.localize(3,null,(0,D.toErrorMessage)(B)))}await this.installFromGallery(H)}markAsUninstalled(...T){return this.S.setUninstalled(...T)}removeUninstalledExtensions(){return this.S.cleanUp()}async download(T,N){const{location:H}=await this.W.download(T,N);return H}async eb(T){if(T.scheme===S.Schemas.file)return{location:T,async cleanup(){}};this.v.trace("Downloading extension from",T.toString());const N=(0,w.joinPath)(this.W.extensionsDownloadDir,(0,v.generateUuid)());return await this.ab.download(T,N),this.v.info("Downloaded extension to",N.toString()),{location:N,cleanup:async()=>{try{await this.bb.del(N)}catch(B){this.v.error(B)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(T,N,H){let B;if(y.URI.isUri(N))B=new Z(T,N,H,this.t,this.S,this.v);else{const Q=t.ExtensionKey.create(N).toString();B=this.X.get(Q),B||(this.X.set(Q,B=new V(T,N,H,this.W,this.S,this.v)),B.waitUntilTaskIsFinished().then(()=>this.X.delete(Q)))}return new ne(B,H.profileLocation,this.Z)}R(T,N){return new J(T,N.profileLocation,this.Z)}async ib(T){const N=async B=>{let Q=await l.Promises.readdir(B);Q=Q.map(te=>C.join(B,te));const re=await Promise.all(Q.map(te=>l.Promises.stat(te)));let X=Promise.resolve([]);return re.forEach((te,se)=>{const le=Q[se];te.isFile()&&(X=X.then(ue=>[...ue,le])),te.isDirectory()&&(X=X.then(ue=>N(le).then(ye=>[...ue,...ye])))}),X};return(await N(T.location.fsPath)).map(B=>({path:`extension/${C.relative(T.location.fsPath,B)}`,localPath:B}))}async jb({added:T,removed:N}){if(N)for(const H of N.extensions)this.v.info("Extensions removed from another source",H.id,N.profileLocation.toString()),this.p.fire({identifier:H,profileLocation:N.profileLocation});if(T){const B=(await this.S.scanExtensions(1,T.profileLocation)).filter(Q=>T.extensions.some(re=>(0,t.areSameExtensions)(re,Q.identifier)));this.m.fire(B.map(Q=>(this.v.info("Extensions added from another source",Q.identifier.id,T.profileLocation.toString()),{identifier:Q.identifier,local:Q,profileLocation:T.profileLocation,operation:1})))}}async lb(){this.B(this.S.onExtract(N=>this.kb.add(N)));const T=await this.bb.resolve(this.Y.userExtensionsLocation);for(const N of T.children??[])N.isDirectory&&this.kb.add(N.resource);this.B(this.bb.watch(this.Y.userExtensionsLocation)),this.B(this.bb.onDidFilesChange(N=>this.mb(N)))}async mb(T){const N=[];for(const H of T.rawAdded){if(this.kb.has(H)||!this.cb.extUri.isEqual(this.cb.extUri.dirname(H),this.Y.userExtensionsLocation)||this.cb.extUri.isEqual(H,this.cb.extUri.joinPath(this.Y.userExtensionsLocation,".obsolete"))||this.cb.extUri.basename(H).startsWith(".")||!(await this.bb.stat(H)).isDirectory)continue;const B=await this.S.scanUserExtensionAtLocation(H);B&&B.installedTimestamp===void 0&&(this.kb.add(H),N.push(B))}N.length&&(await this.nb(N,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",N.map(H=>H.identifier.id)))}async nb(T,N){await this.Z.addExtensionsToProfile(T.map(H=>[H,void 0]),N),this.m.fire(T.map(H=>({local:H,identifier:H.identifier,operation:1,profileLocation:N})))}};_=pe([Y(0,r.IExtensionGalleryService),Y(1,$.ITelemetryService),Y(2,L.ILogService),Y(3,h.INativeEnvironmentService),Y(4,s.IExtensionsScannerService),Y(5,o.IExtensionsProfileScannerService),Y(6,d.IDownloadService),Y(7,F.IInstantiationService),Y(8,z.IFileService),Y(9,M.IProductService),Y(10,G.IUriIdentityService),Y(11,W.IUserDataProfilesService)],_),e.ExtensionManagementService=_;let K=class extends P.Disposable{constructor(T,N,H,B){super(),this.j=T,this.k=N,this.l=H,this.m=B,this.h=this.B(new O.Emitter),this.onExtract=this.h.event,this.c=(0,w.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new k.Queue}async cleanUp(){await this.v()}async scanExtensions(T,N){await this.l.initializeDefaultProfileExtensions();const H={includeInvalid:!0,profileLocation:N};let B=[];return T===null||T===0?B.push(...await this.l.scanAllExtensions({includeInvalid:!0},H,!1)):T===1&&B.push(...await this.l.scanUserExtensions(H)),B=T!==null?B.filter(Q=>Q.type===T):B,Promise.all(B.map(Q=>this.u(Q)))}async scanAllUserExtensions(T){const N=await this.l.scanUserExtensions({includeAllVersions:!T,includeInvalid:!0});return Promise.all(N.map(H=>this.u(H)))}async scanUserExtensionAtLocation(T){try{const N=await this.l.scanExistingExtension(T,1,{includeInvalid:!0});if(N)return await this.u(N)}catch(N){this.m.error(N)}return null}async extractUserExtension(T,N,H,B){await this.l.initializeDefaultProfileExtensions();const Q=T.toString(),re=C.join(this.l.userExtensionsLocation.fsPath,`.${(0,v.generateUuid)()}`),X=C.join(this.l.userExtensionsLocation.fsPath,Q);try{await l.Promises.rm(X)}catch{throw new r.ExtensionManagementError(u.localize(4,null,X,T.id),r.ExtensionManagementErrorCode.Delete)}await this.p(T,N,re,B),await this.l.updateMetadata(y.URI.file(re),H);try{this.h.fire(y.URI.file(X)),await this.s(T,re,X,Date.now()+2*60*1e3),this.m.info("Renamed to",X)}catch(te){try{await l.Promises.rm(re)}catch{}if(te.code==="ENOTEMPTY")this.m.info("Rename failed because extension was installed by another source. So ignoring renaming.",T.id);else throw this.m.info(`Rename failed because of ${(0,A.getErrorMessage)(te)}. Deleted from extracted location`,re),te}return this.t(y.URI.file(X),1)}async updateMetadata(T,N){return await this.l.updateMetadata(T.location,N),this.t(T.location,T.type)}getUninstalledExtensions(){return this.n()}async setUninstalled(...T){const N=T.map(H=>t.ExtensionKey.create(H));await this.n(H=>N.forEach(B=>{H[B.toString()]=!0,this.m.info("Marked extension as uninstalled",B.toString())}))}async setInstalled(T){await this.n(B=>delete B[T.toString()]);const H=(await this.scanAllUserExtensions(!0)).find(B=>t.ExtensionKey.create(B).equals(T))||null;return H?this.updateMetadata(H,{installedTimestamp:Date.now()}):null}async removeExtension(T,N){this.m.trace(`Deleting ${N} extension from disk`,T.identifier.id,T.location.fsPath),await l.Promises.rm(T.location.fsPath),this.m.info("Deleted from disk",T.identifier.id,T.location.fsPath)}async removeUninstalledExtension(T){await this.removeExtension(T,"uninstalled"),await this.n(N=>delete N[t.ExtensionKey.create(T).toString()])}async n(T){return this.g.queue(async()=>{let N;try{N=await l.Promises.readFile(this.c,"utf8")}catch(B){if(B.code!=="ENOENT")throw B}let H={};if(N)try{H=JSON.parse(N)}catch{}return T&&(T(H),Object.keys(H).length?await l.Promises.writeFile(this.c,JSON.stringify(H)):await l.Promises.rm(this.c)),H})}async p(T,N,H,B){this.m.trace(`Started extracting the extension from ${N} to ${H}`);try{await l.Promises.rm(H)}catch(Q){throw new r.ExtensionManagementError(this.w(Q).message,r.ExtensionManagementErrorCode.Delete)}try{await(0,m.extract)(N,H,{sourcePath:"extension",overwrite:!0},B),this.m.info(`Extracted extension to ${H}:`,T.id)}catch(Q){try{await l.Promises.rm(H)}catch{}let re=r.ExtensionManagementErrorCode.Extract;throw Q instanceof m.ExtractError&&(Q.type==="CorruptZip"?re=r.ExtensionManagementErrorCode.CorruptZip:Q.type==="Incomplete"&&(re=r.ExtensionManagementErrorCode.IncompleteZip)),new r.ExtensionManagementError(Q.message,re)}}async s(T,N,H,B){try{await l.Promises.rename(N,H)}catch(Q){if(E.isWindows&&Q&&Q.code==="EPERM"&&Date.now()<B)return this.m.info(`Failed renaming ${N} to ${H} with 'EPERM' error. Trying again...`,T.id),this.s(T,N,H,B);throw new r.ExtensionManagementError(Q.message||u.localize(5,null,N,H),Q.code||r.ExtensionManagementErrorCode.Rename)}}async t(T,N){const H=await this.l.scanExistingExtension(T,N,{includeInvalid:!0});if(H)return this.u(H);throw new Error(u.localize(6,null,T.path))}async u(T){const N=await this.k.resolve(T.location);let H,B;return N.children&&(H=N.children.find(({name:Q})=>/^readme(\.txt|\.md|)$/i.test(Q))?.resource,B=N.children.find(({name:Q})=>/^changelog(\.txt|\.md|)$/i.test(Q))?.resource),{identifier:T.identifier,type:T.type,isBuiltin:T.isBuiltin||!!T.metadata?.isBuiltin,location:T.location,manifest:T.manifest,targetPlatform:T.targetPlatform,validations:T.validations,isValid:T.isValid,readmeUrl:H,changelogUrl:B,publisherDisplayName:T.metadata?.publisherDisplayName||null,publisherId:T.metadata?.publisherId||null,isApplicationScoped:!!T.metadata?.isApplicationScoped,isMachineScoped:!!T.metadata?.isMachineScoped,isPreReleaseVersion:!!T.metadata?.isPreReleaseVersion,preRelease:!!T.metadata?.preRelease,installedTimestamp:T.metadata?.installedTimestamp,updated:!!T.metadata?.updated}}async v(){const T=await this.getUninstalledExtensions(),N=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),H=new Set;for(const re of N)T[t.ExtensionKey.create(re).toString()]||H.add(re.identifier.id.toLowerCase());const B=(0,t.groupByExtension)(N,re=>re.identifier);await k.Promises.settled(B.map(async re=>{const X=re.sort((te,se)=>p.rcompare(te.manifest.version,se.manifest.version))[0];H.has(X.identifier.id.toLowerCase())||await this.j(await this.u(X))}));const Q=N.filter(re=>re.metadata&&T[t.ExtensionKey.create(re).toString()]);await k.Promises.settled(Q.map(re=>this.removeUninstalledExtension(re)))}w(T){const N=Array.isArray(T)?T:[T];return N.length===1?N[0]instanceof Error?N[0]:new Error(N[0]):N.reduce((H,B)=>new Error(`${H.message}${H.message?",":""}${B instanceof Error?B.message:B}`),new Error(""))}};K=pe([Y(1,z.IFileService),Y(2,s.IExtensionsScannerService),Y(3,L.ILogService)],K),e.ExtensionsScanner=K;class q extends n.AbstractExtensionTask{get operation(){return(0,f.isUndefined)(this.k.operation)?this.j:this.k.operation}constructor(T,N,H,B,Q){super(),this.identifier=T,this.source=N,this.k=H,this.l=B,this.m=Q,this.wasVerified=!1,this.j=2}async n(T,N){try{const H=await this.o(T.key);if(H)return this.l.updateMetadata(H,T.metadata)}catch{throw E.isMacintosh?new r.ExtensionManagementError(u.localize(7,null),r.ExtensionManagementErrorCode.Internal):new r.ExtensionManagementError(u.localize(8,null),r.ExtensionManagementErrorCode.Internal)}return this.q(T,N)}async o(T){if(!await this.p(T))return null;this.m.trace("Removing the extension from uninstalled list:",T.id);const H=await this.l.setInstalled(T);return this.m.info("Removed the extension from uninstalled list:",T.id),H}async p(T){return!!(await this.l.getUninstalledExtensions())[T.toString()]}async q({zipPath:T,key:N,metadata:H},B){const Q=await this.l.extractUserExtension(N,T,H,B);return this.m.info("Extracting completed.",N.id),Q}}class V extends q{constructor(T,N,H,B,Q,re){super(N.identifier,N,H,Q,re),this.s=T,this.t=N,this.u=B}async h(T){const H=(await this.l.scanExtensions(null,void 0)).find(X=>(0,t.areSameExtensions)(X.identifier,this.t.identifier));H&&(this.j=3);const B={id:this.t.identifier.uuid,publisherId:this.t.publisherId,publisherDisplayName:this.t.publisherDisplayName,targetPlatform:this.t.properties.targetPlatform,isApplicationScoped:(0,j.isApplicationScopedExtension)(this.s),isMachineScoped:this.k.isMachineScoped||H?.isMachineScoped,isBuiltin:this.k.isBuiltin||H?.isBuiltin,isSystem:H?.type===0?!0:void 0,updated:!!H,isPreReleaseVersion:this.t.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.t.properties.isPreReleaseVersion||((0,f.isBoolean)(this.k.installPreReleaseVersion)?this.k.installPreReleaseVersion:H?.preRelease)};if(H?.manifest.version===this.t.version)return{local:await this.l.updateMetadata(H,B),metadata:B};const{location:Q,verified:re}=await this.u.download(this.t,this.j);try{return this.wasVerified=!!re,this.w(Q.fsPath),{local:await this.n({zipPath:Q.fsPath,key:t.ExtensionKey.create(this.t),metadata:B},T),metadata:B}}catch(X){try{await this.u.delete(Q)}catch(te){this.m.warn("Error while deleting the downloaded file",Q.toString(),(0,A.getErrorMessage)(te))}throw X}}async w(T){try{await(0,g.getManifest)(T)}catch(N){throw new r.ExtensionManagementError((0,n.joinErrors)(N).message,r.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=V;class Z extends q{constructor(T,N,H,B,Q,re){super({id:(0,t.getGalleryExtensionId)(T.publisher,T.name)},N,H,Q,re),this.s=T,this.t=N,this.u=B}async h(T){const N=new t.ExtensionKey(this.identifier,this.s.version),B=(await this.l.scanExtensions(1,void 0)).find(X=>(0,t.areSameExtensions)(this.identifier,X.identifier)),Q=await this.w(this.identifier.id,this.s.version,T);if(Q.isApplicationScoped=(0,j.isApplicationScopedExtension)(this.s),Q.isMachineScoped=this.k.isMachineScoped||B?.isMachineScoped,Q.isBuiltin=this.k.isBuiltin||B?.isBuiltin,Q.installedTimestamp=Date.now(),B)if(this.j=3,N.equals(new t.ExtensionKey(B.identifier,B.manifest.version)))try{await this.l.removeExtension(B,"existing")}catch{throw new Error(u.localize(9,null,this.s.displayName||this.s.name))}else!this.k.profileLocation&&p.gt(B.manifest.version,this.s.version)&&await this.l.setUninstalled(B);else{const X=await this.o(N);if(X)try{await this.l.removeExtension(X,"existing")}catch{throw new Error(u.localize(10,null,this.s.displayName||this.s.name))}}return{local:await this.n({zipPath:C.resolve(this.t.fsPath),key:N,metadata:Q},T),metadata:Q}}async w(T,N,H){try{let[B]=await this.u.getExtensions([{id:T,version:N}],H);if(B||([B]=await this.u.getExtensions([{id:T}],H)),B)return{id:B.identifier.uuid,publisherDisplayName:B.publisherDisplayName,publisherId:B.publisherId,isPreReleaseVersion:B.properties.isPreReleaseVersion,preRelease:B.properties.isPreReleaseVersion||this.k.installPreReleaseVersion}}catch{}return{}}}class ne{constructor(T,N,H){this.d=T,this.g=N,this.h=H,this.identifier=this.d.identifier,this.source=this.d.source,this.operation=this.d.operation,this.c=this.j()}async j(){const T=await this.d.waitUntilTaskIsFinished();return await this.h.addExtensionsToProfile([[T.local,T.metadata]],this.g),T}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class J extends n.AbstractExtensionTask{constructor(T,N,H){super(),this.extension=T,this.j=N,this.k=H}async h(T){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(oe[281],ae([0,1,2,29,80,217,125,8,19]),function(ee,e,k,i,D,A,O,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let S=class extends k.Disposable{constructor(E,w,p,f,y,v){super(),E.removeUninstalledExtensions(),(0,A.migrateUnsupportedExtensions)(E,w,p,f,v),D.ExtensionStorageService.removeOutdatedExtensionVersions(E,y)}};S=pe([Y(0,O.INativeServerExtensionManagementService),Y(1,i.IExtensionGalleryService),Y(2,D.IExtensionStorageService),Y(3,i.IGlobalExtensionEnablementService),Y(4,I.IStorageService),Y(5,P.ILogService)],S),e.ExtensionsContributions=S}),define(oe[290],ae([0,1,93,34,38,9,2,24,21,7,39,148,209,210,202,203,279,191,194,16,215,95,234,96,226,15,231,116,265,29,97,193,266,125,98,189,13,205,207,54,4,200,72,201,56,73,221,8,102,57,103,25,59,19,267,108,22,109,110,111,50,239,112,241,247,80,114,26,78,270,258,259,81,271,274,275,276,277,269,62,260,107,233,77,249,223,248,106,230,30,250,5,251,195,213,212,79,264,18,61,208,58,268,228,238,261,235,105,101,273,281]),function(ee,e,k,i,D,A,O,P,I,S,C,E,w,p,f,y,v,l,m,u,d,h,n,r,t,o,s,c,a,g,b,R,j,U,z,F,L,M,$,G,W,_,K,q,V,Z,ne,J,x,T,N,H,B,Q,re,X,te,se,le,ue,ye,Se,be,Ee,Ne,Fe,Ye,ze,ce,de,ge,Ce,Pe,Ae,De,je,Oe,Me,Be,ke,Te,ie,he,fe,me,we,Ie,Re,He,$e,Le,qe,Ge,et,ot,wt,At,Lt,vt,St,Ot,bt,Tt,Nt,Ut,Mt,Ft,Et,Ct,jt,$t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class zt extends O.Disposable{constructor(ve){super(),this.f=ve,this.a=this.B(new E.Server),this.b=void 0,this.c=void 0,this.g()}g(){const ve=async()=>{this.c&&(await this.c.fireOnWillShutdown(),this.c.dispose(),this.c=void 0),this.dispose()};process.once("exit",ve),k.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve);const Ue="vscode:electron-main->shared-process=disposeWorker",We=(Je,tt)=>{this.h(tt)};k.ipcRenderer.on(Ue,We),this.B((0,O.toDisposable)(()=>k.ipcRenderer.removeListener(Ue,We)))}h(ve){this.b?.disposeWorker(ve)}async open(){const ve=await this.i();(0,ze.registerConfiguration)(),ve.invokeFunction(Ue=>{const We=Ue.get(J.ILogService);We.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Ue),this.k(We)}),this.B((0,O.combinedDisposable)(ve.createInstance(w.CodeCacheCleaner,this.f.codeCachePath),ve.createInstance(p.LanguagePackCachedDataCleaner),ve.createInstance(v.UnusedWorkspaceStorageDataCleaner),ve.createInstance(y.LogsDataCleaner),ve.createInstance(f.LocalizationsUpdater),ve.createInstance($t.ExtensionsContributions),ve.createInstance(Mt.UserDataProfilesCleaner)))}async i(){const ve=new K.ServiceCollection,Ue={_serviceBrand:void 0,...N.default};ve.set(H.IProductService,Ue);const We=new C.StaticRouter(Qe=>Qe==="main"),Je=new q.MessagePortMainProcessService(this.a,We);ve.set(V.IMainProcessService,Je);const tt=this.f.policiesData?new Ot.PolicyChannelClient(this.f.policiesData,Je.getChannel("policy")):new bt.NullPolicyService;ve.set(bt.IPolicyService,tt);const Ke=new s.SharedProcessEnvironmentService(this.f.args,Ue);ve.set(o.INativeEnvironmentService,Ke);const lt=new x.LogLevelChannelClient(this.a.getChannel("logLevel",We)),it=new x.LoggerChannelClient(this.f.logLevel,lt.onDidChangeLogLevel,Je.getChannel("logger"));ve.set(J.ILoggerService,it);const ht=this.B(new J.MultiplexLogService([this.B(new J.ConsoleLogger(this.f.logLevel)),this.B(it.createLogger((0,I.joinPath)(S.URI.file(Ke.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),xe=this.B(new x.FollowerLogService(lt,ht));ve.set(J.ILogService,xe),this.c=new Ct.SharedProcessLifecycleService(xe),ve.set(Ct.ISharedProcessLifecycleService,this.c),this.b=new He.SharedProcessWorkerService(xe),ve.set(Re.ISharedProcessWorkerService,this.b);const _e=this.B(new M.FileService(xe));ve.set(L.IFileService,_e);const ft=this.B(new $.DiskFileSystemProvider(xe));_e.registerProvider(P.Schemas.file,ft);const dt=this.B(new Ge.FileUserDataProvider(P.Schemas.file,this.B(new et.DiskFileSystemProviderClient(Je.getChannel(et.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:qe.isLinux})),P.Schemas.vscodeUserData,xe));_e.registerProvider(P.Schemas.vscodeUserData,dt);const nt=this.B(new Tt.UserDataProfilesNativeService(this.f.profiles,Je,Ke));ve.set(vt.IUserDataProfilesService,nt);const Xe=this.B(new d.ConfigurationService(nt.defaultProfile.settingsResource,_e,tt,xe));ve.set(u.IConfigurationService,Xe);const at=new re.NativeStorageService(void 0,{defaultProfile:nt.defaultProfile,currentProfile:nt.defaultProfile},Je,Ke);ve.set(Q.IStorageService,at),this.B((0,O.toDisposable)(()=>at.flush())),await Promise.all([Xe.initialize(),at.initialize()]),ve.set($e.IUriIdentityService,new Le.UriIdentityService(_e)),ve.set(B.IRequestService,new Nt.SharedProcessRequestService(Je,Xe,Ue,xe)),ve.set(l.IChecksumService,new G.SyncDescriptor(m.ChecksumService,void 0,!1)),ve.set(wt.IV8InspectProfilingService,new G.SyncDescriptor(ot.InspectProfilingService,void 0,!1));const ut=C.ProxyChannel.toService(Je.getChannel("nativeHost"),{context:this.f.windowId});ve.set(T.INativeHostService,ut),ve.set(r.IDownloadService,new G.SyncDescriptor(t.DownloadService,void 0,!0));const gt=this.B(new Te.ActiveWindowManager(ut)),mt=new C.StaticRouter(Qe=>gt.getActiveClientId().then(pt=>Qe===pt));ve.set(z.IExtensionRecommendationNotificationService,new F.ExtensionRecommendationNotificationServiceChannelClient(this.a.getChannel("extensionRecommendationNotification",mt)));let st;const ct=[],Pt=(0,ye.isInternalTelemetry)(Ue,Xe);if((0,ye.supportsTelemetry)(Ue,Ke)){const Qe=new le.TelemetryLogAppender(it,Ke);ct.push(Qe);const{installSourcePath:pt}=Ke;if(Ue.aiConfig?.ariaKey){const Dt=new Ut.OneDataSystemAppender(Pt,"monacoworkbench",null,Ue.aiConfig.ariaKey);this.B((0,O.toDisposable)(()=>Dt.flush())),ct.push(Dt)}st=new ue.TelemetryService({appenders:ct,commonProperties:(0,X.resolveCommonProperties)(_e,(0,i.release)(),(0,i.hostname)(),process.arch,Ue.commit,Ue.version,this.f.machineId,Pt,pt),sendErrorTelemetry:!0,piiPaths:(0,ye.getPiiPathsFromEnvironment)(Ke)},Xe,Ue)}else{st=ye.NullTelemetryService;const Qe=ye.NullAppender;ct.push(Qe)}this.a.registerChannel("telemetryAppender",new se.TelemetryAppenderChannel(ct)),ve.set(te.ITelemetryService,st);const qt=new Se.CustomEndpointTelemetryService(Xe,st,it,Ke,Ue);ve.set(te.ICustomEndpointTelemetryService,qt),ve.set(St.IExtensionsProfileScannerService,new G.SyncDescriptor(St.ExtensionsProfileScannerService,void 0,!0)),ve.set(At.IExtensionsScannerService,new G.SyncDescriptor(Lt.ExtensionsScannerService,void 0,!0)),ve.set(b.IExtensionSignatureVerificationService,new G.SyncDescriptor(b.ExtensionSignatureVerificationService,void 0,!0)),ve.set(U.INativeServerExtensionManagementService,new G.SyncDescriptor(U.ExtensionManagementService,void 0,!0)),ve.set(g.IExtensionGalleryService,new G.SyncDescriptor(a.ExtensionGalleryService,void 0,!0)),ve.set(g.IExtensionTipsService,new G.SyncDescriptor(j.ExtensionTipsService,void 0,!1)),ve.set(Z.ILanguagePackService,new G.SyncDescriptor(ne.NativeLanguagePackService,void 0,!1)),ve.set(h.IDiagnosticsService,new G.SyncDescriptor(n.DiagnosticsService,void 0,!1)),ve.set(ce.IUserDataSyncAccountService,new G.SyncDescriptor(ce.UserDataSyncAccountService,void 0,!0)),ve.set(ze.IUserDataSyncLogService,new G.SyncDescriptor(Ce.UserDataSyncLogService,void 0,!0)),ve.set(ze.IUserDataSyncUtilService,new ge.UserDataSyncUtilServiceClient(this.a.getChannel("userDataSyncUtil",Qe=>Qe.ctx!=="main"))),ve.set(g.IGlobalExtensionEnablementService,new G.SyncDescriptor(c.GlobalExtensionEnablementService,void 0,!1)),ve.set(Ye.IIgnoredExtensionsManagementService,new G.SyncDescriptor(Ye.IgnoredExtensionsManagementService,void 0,!0)),ve.set(Fe.IExtensionStorageService,new G.SyncDescriptor(Fe.ExtensionStorageService)),ve.set(ze.IUserDataSyncStoreManagementService,new G.SyncDescriptor(Oe.UserDataSyncStoreManagementService,void 0,!0)),ve.set(ze.IUserDataSyncStoreService,new G.SyncDescriptor(Oe.UserDataSyncStoreService,void 0,!0)),ve.set(Pe.IUserDataSyncMachinesService,new G.SyncDescriptor(Pe.UserDataSyncMachinesService,void 0,!0)),ve.set(ze.IUserDataSyncBackupStoreService,new G.SyncDescriptor(de.UserDataSyncBackupStoreService,void 0,!1)),ve.set(ze.IUserDataSyncEnablementService,new G.SyncDescriptor(Ae.UserDataSyncEnablementService,void 0,!0)),ve.set(ze.IUserDataSyncService,new G.SyncDescriptor(De.UserDataSyncService,void 0,!1)),ve.set(ke.IUserDataProfileStorageService,new G.SyncDescriptor(Be.UserDataProfileStorageService,void 0,!0)),ve.set(ze.IUserDataSyncResourceProviderService,new G.SyncDescriptor(jt.UserDataSyncResourceProviderService,void 0,!0));const Rt=new Ne.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Xe.getValue("terminal.integrated.persistentSessionScrollback")??100},Xe,Ke,xe);return Rt.initialize(),ve.set(Ee.ILocalPtyService,this.B(Rt)),ve.set(ie.ISignService,new G.SyncDescriptor(he.SignService,void 0,!1)),ve.set(fe.ISharedTunnelsService,new G.SyncDescriptor(me.SharedTunnelsService)),ve.set(we.ISharedProcessTunnelService,new G.SyncDescriptor(Ie.SharedProcessTunnelService)),ve.set(Et.IRemoteTunnelService,new G.SyncDescriptor(Ft.RemoteTunnelService)),new _.InstantiationService(ve)}j(ve){const Ue=new x.LogLevelChannel(ve.get(J.ILogService),ve.get(J.ILoggerService));this.a.registerChannel("logLevel",Ue);const We=new R.ExtensionManagementChannel(ve.get(g.IExtensionManagementService),()=>null);this.a.registerChannel("extensions",We);const Je=C.ProxyChannel.fromService(ve.get(Z.ILanguagePackService));this.a.registerChannel("languagePacks",Je);const tt=C.ProxyChannel.fromService(ve.get(h.IDiagnosticsService));this.a.registerChannel("diagnostics",tt);const Ke=new R.ExtensionTipsChannel(ve.get(g.IExtensionTipsService));this.a.registerChannel("extensionTipsService",Ke);const lt=C.ProxyChannel.fromService(ve.get(l.IChecksumService));this.a.registerChannel("checksum",lt);const it=C.ProxyChannel.fromService(ve.get(wt.IV8InspectProfilingService));this.a.registerChannel("v8InspectProfiling",it);const ht=new ge.UserDataSyncMachinesServiceChannel(ve.get(Pe.IUserDataSyncMachinesService));this.a.registerChannel("userDataSyncMachines",ht);const xe=C.ProxyChannel.fromService(ve.get(te.ICustomEndpointTelemetryService));this.a.registerChannel("customEndpointTelemetry",xe);const _e=new ge.UserDataSyncAccountServiceChannel(ve.get(ce.IUserDataSyncAccountService));this.a.registerChannel("userDataSyncAccount",_e);const ft=new ge.UserDataSyncStoreManagementServiceChannel(ve.get(ze.IUserDataSyncStoreManagementService));this.a.registerChannel("userDataSyncStoreManagement",ft);const dt=new je.UserDataSyncChannel(ve.get(ze.IUserDataSyncService),ve.get(vt.IUserDataProfilesService),ve.get(J.ILogService));this.a.registerChannel("userDataSync",dt);const nt=this.B(ve.get(W.IInstantiationService).createInstance(Me.UserDataAutoSyncService)),Xe=new ge.UserDataAutoSyncChannel(nt);this.a.registerChannel("userDataAutoSync",Xe);const at=ve.get(Ee.ILocalPtyService),ut=C.ProxyChannel.fromService(at);this.a.registerChannel(be.TerminalIpcChannels.LocalPty,ut);const gt=C.ProxyChannel.fromService(ve.get(we.ISharedProcessTunnelService));this.a.registerChannel(we.ipcSharedProcessTunnelChannelName,gt);const mt=C.ProxyChannel.fromService(ve.get(Re.ISharedProcessWorkerService));this.a.registerChannel(Re.ipcSharedProcessWorkerChannelName,mt);const st=C.ProxyChannel.fromService(ve.get(Et.IRemoteTunnelService));this.a.registerChannel("remoteTunnel",st)}k(ve){window.addEventListener("unhandledrejection",Ue=>{(0,A.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,A.setUnexpectedErrorHandler)(Ue=>{const We=(0,D.toErrorMessage)(Ue,!0);!We||ve.error(`[uncaught exception in sharedProcess]: ${We}`)})}}async function Bt(It){const ve=new zt(It);k.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),k.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Bt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d7b1e2a1c892511a125e4ceb9758ec8ddf907775/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
