/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/errors","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/product/common/productService","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/arrays","os","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/base/common/uuid","vs/base/common/extpath","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/base/common/process","vs/base/common/labels","vs/platform/environment/common/environment","vs/platform/state/electron-main/state","vs/platform/policy/common/policy","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/map","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/json","vs/base/common/objects","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/remote/common/remoteHosts","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensions/common/extensions","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/update/electron-main/abstractUpdateService","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/severity","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/codicons","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetryUtils","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","vs/platform/userDataProfile/electron-main/userDataTransientProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","https","string_decoder","vscode-policy-watcher","zlib","vs/code/electron-main/main"],ie=function(V){for(var e=[],I=0,t=V.length;I<t;I++)e[I]=te[V[I]];return e};define(te[120],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function I(R){return R?R.replace(/\$\((.*?)\)/g,(A,C)=>` ${C} `).trim():""}e.getCodiconAriaLabel=I;class t{constructor(A,C,w){this.id=A,this.definition=C,this.description=w,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.commentDraft=new t("comment-draft",{fontCharacter:"\\ec0e"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var k;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function C(y){if(y instanceof t)return["codicon","codicon-"+y.id];const P=A.exec(y.id);if(!P)return C(t.error);const[,E,h]=P,d=["codicon","codicon-"+E];return h&&d.push("codicon-modifier-"+h.substring(1)),d}R.asClassNameArray=C;function w(y){return C(y).join(" ")}R.asClassName=w;function m(y){return"."+C(y).join(".")}R.asCSSSelector=m})(k=e.CSSIcon||(e.CSSIcon={}))}),define(te[121],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function I(C,w){const m=Math.pow(10,w);return Math.round(C*m)/m}class t{constructor(w,m,y,P=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,w))|0,this.g=Math.min(255,Math.max(0,m))|0,this.b=Math.min(255,Math.max(0,y))|0,this.a=I(Math.max(Math.min(1,P),0),3)}static equals(w,m){return w.r===m.r&&w.g===m.g&&w.b===m.b&&w.a===m.a}}e.RGBA=t;class k{constructor(w,m,y,P){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,w),0)|0,this.s=I(Math.max(Math.min(1,m),0),3),this.l=I(Math.max(Math.min(1,y),0),3),this.a=I(Math.max(Math.min(1,P),0),3)}static equals(w,m){return w.h===m.h&&w.s===m.s&&w.l===m.l&&w.a===m.a}static fromRGBA(w){const m=w.r/255,y=w.g/255,P=w.b/255,E=w.a,h=Math.max(m,y,P),d=Math.min(m,y,P);let v=0,b=0;const u=(d+h)/2,p=h-d;if(p>0){switch(b=Math.min(u<=.5?p/(2*u):p/(2-2*u),1),h){case m:v=(y-P)/p+(y<P?6:0);break;case y:v=(P-m)/p+2;break;case P:v=(m-y)/p+4;break}v*=60,v=Math.round(v)}return new k(v,b,u,E)}static i(w,m,y){return y<0&&(y+=1),y>1&&(y-=1),y<1/6?w+(m-w)*6*y:y<1/2?m:y<2/3?w+(m-w)*(2/3-y)*6:w}static toRGBA(w){const m=w.h/360,{s:y,l:P,a:E}=w;let h,d,v;if(y===0)h=d=v=P;else{const b=P<.5?P*(1+y):P+y-P*y,u=2*P-b;h=k.i(u,b,m+1/3),d=k.i(u,b,m),v=k.i(u,b,m-1/3)}return new t(Math.round(h*255),Math.round(d*255),Math.round(v*255),E)}}e.HSLA=k;class R{constructor(w,m,y,P){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,w),0)|0,this.s=I(Math.max(Math.min(1,m),0),3),this.v=I(Math.max(Math.min(1,y),0),3),this.a=I(Math.max(Math.min(1,P),0),3)}static equals(w,m){return w.h===m.h&&w.s===m.s&&w.v===m.v&&w.a===m.a}static fromRGBA(w){const m=w.r/255,y=w.g/255,P=w.b/255,E=Math.max(m,y,P),h=Math.min(m,y,P),d=E-h,v=E===0?0:d/E;let b;return d===0?b=0:E===m?b=((y-P)/d%6+6)%6:E===y?b=(P-m)/d+2:b=(m-y)/d+4,new R(Math.round(b*60),v,E,w.a)}static toRGBA(w){const{h:m,s:y,v:P,a:E}=w,h=P*y,d=h*(1-Math.abs(m/60%2-1)),v=P-h;let[b,u,p]=[0,0,0];return m<60?(b=h,u=d):m<120?(b=d,u=h):m<180?(u=h,p=d):m<240?(u=d,p=h):m<300?(b=d,p=h):m<=360&&(b=h,p=d),b=Math.round((b+v)*255),u=Math.round((u+v)*255),p=Math.round((p+v)*255),new t(b,u,p,E)}}e.HSVA=R;class A{static fromHex(w){return A.Format.CSS.parseHex(w)||A.red}static equals(w,m){return!w&&!m?!0:!w||!m?!1:w.equals(m)}get hsla(){return this.i?this.i:k.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:R.fromRGBA(this.rgba)}constructor(w){if(w)if(w instanceof t)this.rgba=w;else if(w instanceof k)this.i=w,this.rgba=k.toRGBA(w);else if(w instanceof R)this.j=w,this.rgba=R.toRGBA(w);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(w){return!!w&&t.equals(this.rgba,w.rgba)&&k.equals(this.hsla,w.hsla)&&R.equals(this.hsva,w.hsva)}getRelativeLuminance(){const w=A.k(this.rgba.r),m=A.k(this.rgba.g),y=A.k(this.rgba.b),P=.2126*w+.7152*m+.0722*y;return I(P,4)}static k(w){const m=w/255;return m<=.03928?m/12.92:Math.pow((m+.055)/1.055,2.4)}getContrastRatio(w){const m=this.getRelativeLuminance(),y=w.getRelativeLuminance();return m>y?(m+.05)/(y+.05):(y+.05)/(m+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(w){const m=this.getRelativeLuminance(),y=w.getRelativeLuminance();return m>y}isDarkerThan(w){const m=this.getRelativeLuminance(),y=w.getRelativeLuminance();return m<y}lighten(w){return new A(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*w,this.hsla.a))}darken(w){return new A(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*w,this.hsla.a))}transparent(w){const{r:m,g:y,b:P,a:E}=this.rgba;return new A(new t(m,y,P,E*w))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new A(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(w){const m=w.rgba,y=this.rgba.a,P=m.a,E=y+P*(1-y);if(E<1e-6)return A.transparent;const h=this.rgba.r*y/E+m.r*P*(1-y)/E,d=this.rgba.g*y/E+m.g*P*(1-y)/E,v=this.rgba.b*y/E+m.b*P*(1-y)/E;return new A(new t(h,d,v,E))}makeOpaque(w){if(this.isOpaque()||w.rgba.a!==1)return this;const{r:m,g:y,b:P,a:E}=this.rgba;return new A(new t(w.rgba.r-E*(w.rgba.r-m),w.rgba.g-E*(w.rgba.g-y),w.rgba.b-E*(w.rgba.b-P),1))}flatten(...w){const m=w.reduceRight((y,P)=>A.o(P,y));return A.o(this,m)}static o(w,m){const y=1-w.rgba.a;return new A(new t(y*m.rgba.r+w.rgba.a*w.rgba.r,y*m.rgba.g+w.rgba.a*w.rgba.g,y*m.rgba.b+w.rgba.a*w.rgba.b))}toString(){return this.u||(this.u=A.Format.CSS.format(this)),this.u}static getLighterColor(w,m,y){if(w.isLighterThan(m))return w;y=y||.5;const P=w.getRelativeLuminance(),E=m.getRelativeLuminance();return y=y*(E-P)/E,w.lighten(y)}static getDarkerColor(w,m,y){if(w.isDarkerThan(m))return w;y=y||.5;const P=w.getRelativeLuminance(),E=m.getRelativeLuminance();return y=y*(P-E)/P,w.darken(y)}}e.Color=A,A.white=new A(new t(255,255,255,1)),A.black=new A(new t(0,0,0,1)),A.red=new A(new t(255,0,0,1)),A.blue=new A(new t(0,0,255,1)),A.green=new A(new t(0,255,0,1)),A.cyan=new A(new t(0,255,255,1)),A.lightgrey=new A(new t(211,211,211,1)),A.transparent=new A(new t(0,0,0,0)),function(C){let w;(function(m){let y;(function(P){function E(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:C.Format.CSS.formatRGBA(i)}P.formatRGB=E;function h(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}P.formatRGBA=h;function d(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:C.Format.CSS.formatHSLA(i)}P.formatHSL=d;function v(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}P.formatHSLA=v;function b(i){const s=i.toString(16);return s.length!==2?"0"+s:s}function u(i){return`#${b(i.rgba.r)}${b(i.rgba.g)}${b(i.rgba.b)}`}P.formatHex=u;function p(i,s=!1){return s&&i.rgba.a===1?C.Format.CSS.formatHex(i):`#${b(i.rgba.r)}${b(i.rgba.g)}${b(i.rgba.b)}${b(Math.round(i.rgba.a*255))}`}P.formatHexA=p;function g(i){return i.isOpaque()?C.Format.CSS.formatHex(i):C.Format.CSS.formatRGBA(i)}P.format=g;function f(i){const s=i.length;if(s===0||i.charCodeAt(0)!==35)return null;if(s===7){const n=16*l(i.charCodeAt(1))+l(i.charCodeAt(2)),a=16*l(i.charCodeAt(3))+l(i.charCodeAt(4)),r=16*l(i.charCodeAt(5))+l(i.charCodeAt(6));return new C(new t(n,a,r,1))}if(s===9){const n=16*l(i.charCodeAt(1))+l(i.charCodeAt(2)),a=16*l(i.charCodeAt(3))+l(i.charCodeAt(4)),r=16*l(i.charCodeAt(5))+l(i.charCodeAt(6)),c=16*l(i.charCodeAt(7))+l(i.charCodeAt(8));return new C(new t(n,a,r,c/255))}if(s===4){const n=l(i.charCodeAt(1)),a=l(i.charCodeAt(2)),r=l(i.charCodeAt(3));return new C(new t(16*n+n,16*a+a,16*r+r))}if(s===5){const n=l(i.charCodeAt(1)),a=l(i.charCodeAt(2)),r=l(i.charCodeAt(3)),c=l(i.charCodeAt(4));return new C(new t(16*n+n,16*a+a,16*r+r,(16*c+c)/255))}return null}P.parseHex=f;function l(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(y=m.CSS||(m.CSS={}))})(w=C.Format||(C.Format={}))}(A=e.Color||(e.Color={}))}),define(te[53],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function I(A){return(C,w,m)=>{let y=null,P=null;if(typeof m.value=="function"?(y="value",P=m.value):typeof m.get=="function"&&(y="get",P=m.get),!P)throw new Error("not supported");m[y]=A(P,w)}}function t(A,C,w){let m=null,y=null;if(typeof w.value=="function"?(m="value",y=w.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(m="get",y=w.get),!y)throw new Error("not supported");const P=`$memoize$${C}`;w[m]=function(...E){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,E)}),this[P]}}e.memoize=t;function k(A,C,w){return I((m,y)=>{const P=`$debounce$${y}`,E=`$debounce$result$${y}`;return function(...h){this[E]||(this[E]=w?w():void 0),clearTimeout(this[P]),C&&(this[E]=C(this[E],...h),h=[this[E]]),this[P]=setTimeout(()=>{m.apply(this,h),this[E]=w?w():void 0},A)}})}e.debounce=k;function R(A,C,w){return I((m,y)=>{const P=`$throttle$timer$${y}`,E=`$throttle$result$${y}`,h=`$throttle$lastRun$${y}`,d=`$throttle$pending$${y}`;return function(...v){if(this[E]||(this[E]=w?w():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),C&&(this[E]=C(this[E],...v)),this[d])return;const b=this[h]+A;b<=Date.now()?(this[h]=Date.now(),m.apply(this,[this[E]]),this[E]=w?w():void 0):(this[d]=!0,this[P]=setTimeout(()=>{this[d]=!1,this[h]=Date.now(),m.apply(this,[this[E]]),this[E]=w?w():void 0},b-Date.now()))}})}e.throttle=R}),define(te[14],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class I{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?g.isErrorNoTelemetry(i)?new g(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(s=>{s(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.ErrorHandler=I,e.errorHandler=new I;function t(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=t;function k(l){w(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=k;function R(l){w(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=R;function A(l){if(l instanceof Error){const{name:i,message:s}=l,n=l.stacktrace||l.stack;return{$isError:!0,name:i,message:s,stack:n,noTelemetry:g.isErrorNoTelemetry(l)}}return l}e.transformErrorForSerialization=A;const C="Canceled";function w(l){return l instanceof m?!0:l instanceof Error&&l.name===C&&l.message===C}e.isCancellationError=w;class m extends Error{constructor(){super(C),this.name=this.message}}e.CancellationError=m;function y(){const l=new Error(C);return l.name=l.message,l}e.canceled=y;function P(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=P;function E(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=E;function h(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function d(l){const i=new Error(`${l} has been disposed`);return i.name="DISPOSED",i}e.disposed=d;function v(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=v;class b extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=b;class u extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=u;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=p;class g extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof g)return i;const s=new g;return s.message=i.message,s.stack=i.stack,s}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=g;class f extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype);debugger}}e.BugIndicatingError=f}),define(te[24],ie([0,1,14]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(B,_=0){return B[B.length-(1+_)]}e.tail=t;function k(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}e.tail2=k;function R(B,_,Z=(oe,ge)=>oe===ge){if(B===_)return!0;if(!B||!_||B.length!==_.length)return!1;for(let oe=0,ge=B.length;oe<ge;oe++)if(!Z(B[oe],_[oe]))return!1;return!0}e.equals=R;function A(B,_){const Z=B.length-1;_<Z&&(B[_]=B[Z]),B.pop()}e.removeFastWithoutKeepingOrder=A;function C(B,_,Z){return w(B.length,oe=>Z(B[oe],_))}e.binarySearch=C;function w(B,_){let Z=0,oe=B-1;for(;Z<=oe;){const ge=(Z+oe)/2|0,ke=_(ge);if(ke<0)Z=ge+1;else if(ke>0)oe=ge-1;else return ge}return-(Z+1)}e.binarySearch2=w;function m(B,_){let Z=0,oe=B.length;if(oe===0)return 0;for(;Z<oe;){const ge=Math.floor((Z+oe)/2);_(B[ge])?oe=ge:Z=ge+1}return Z}e.findFirstInSorted=m;function y(B,_,Z){if(B=B|0,B>=_.length)throw new TypeError("invalid index");const oe=_[Math.floor(_.length*Math.random())],ge=[],ke=[],Oe=[];for(const De of _){const Le=Z(De,oe);Le<0?ge.push(De):Le>0?ke.push(De):Oe.push(De)}return B<ge.length?y(B,ge,Z):B<ge.length+Oe.length?Oe[0]:y(B-(ge.length+Oe.length),ke,Z)}e.quickSelect=y;function P(B,_){const Z=[];let oe;for(const ge of B.slice(0).sort(_))!oe||_(oe[0],ge)!==0?(oe=[ge],Z.push(oe)):oe.push(ge);return Z}e.groupBy=P;function E(B,_,Z){const oe=[];function ge(De,Le,be){if(Le===0&&be.length===0)return;const we=oe[oe.length-1];we&&we.start+we.deleteCount===De?(we.deleteCount+=Le,we.toInsert.push(...be)):oe.push({start:De,deleteCount:Le,toInsert:be})}let ke=0,Oe=0;for(;;){if(ke===B.length){ge(ke,0,_.slice(Oe));break}if(Oe===_.length){ge(ke,B.length-ke,[]);break}const De=B[ke],Le=_[Oe],be=Z(De,Le);be===0?(ke+=1,Oe+=1):be<0?(ge(ke,1,[]),ke+=1):be>0&&(ge(ke,0,[Le]),Oe+=1)}return oe}e.sortedDiff=E;function h(B,_,Z){const oe=E(B,_,Z),ge=[],ke=[];for(const Oe of oe)ge.push(...B.slice(Oe.start,Oe.start+Oe.deleteCount)),ke.push(...Oe.toInsert);return{removed:ge,added:ke}}e.delta=h;function d(B,_,Z){if(Z===0)return[];const oe=B.slice(0,Z).sort(_);return b(B,_,oe,Z,B.length),oe}e.top=d;function v(B,_,Z,oe,ge){return Z===0?Promise.resolve([]):new Promise((ke,Oe)=>{(async()=>{const De=B.length,Le=B.slice(0,Z).sort(_);for(let be=Z,we=Math.min(Z+oe,De);be<De;be=we,we=Math.min(we+oe,De)){if(be>Z&&await new Promise(ye=>setTimeout(ye)),ge&&ge.isCancellationRequested)throw new I.CancellationError;b(B,_,Le,be,we)}return Le})().then(ke,Oe)})}e.topAsync=v;function b(B,_,Z,oe,ge){for(const ke=Z.length;oe<ge;oe++){const Oe=B[oe];if(_(Oe,Z[ke-1])<0){Z.pop();const De=m(Z,Le=>_(Oe,Le)<0);Z.splice(De,0,Oe)}}}function u(B){return B.filter(_=>!!_)}e.coalesce=u;function p(B){let _=0;for(let Z=0;Z<B.length;Z++)B[Z]&&(B[_]=B[Z],_+=1);B.length=_}e.coalesceInPlace=p;function g(B,_,Z){B.splice(Z,0,B.splice(_,1)[0])}e.move=g;function f(B){return!Array.isArray(B)||B.length===0}e.isFalsyOrEmpty=f;function l(B){return Array.isArray(B)&&B.length>0}e.isNonEmptyArray=l;function i(B,_=Z=>Z){const Z=new Set;return B.filter(oe=>{const ge=_(oe);return Z.has(ge)?!1:(Z.add(ge),!0)})}e.distinct=i;function s(B){const _=new Set;return Z=>{const oe=B(Z);return _.has(oe)?!1:(_.add(oe),!0)}}e.uniqueFilter=s;function n(B,_){const Z=a(B,_);if(Z!==-1)return B[Z]}e.findLast=n;function a(B,_){for(let Z=B.length-1;Z>=0;Z--){const oe=B[Z];if(_(oe))return Z}return-1}e.lastIndex=a;function r(B,_){return B.length>0?B[0]:_}e.firstOrDefault=r;function c(B,_){return B.length>0?B[B.length-1]:_}e.lastOrDefault=c;function o(B,_,Z=(oe,ge)=>oe===ge){let oe=0;for(let ge=0,ke=Math.min(B.length,_.length);ge<ke&&Z(B[ge],_[ge]);ge++)oe++;return oe}e.commonPrefixLength=o;function S(B){return[].concat(...B)}e.flatten=S;function D(B,_){let Z=typeof _=="number"?B:0;typeof _=="number"?Z=B:(Z=0,_=B);const oe=[];if(Z<=_)for(let ge=Z;ge<_;ge++)oe.push(ge);else for(let ge=Z;ge>_;ge--)oe.push(ge);return oe}e.range=D;function L(B,_,Z){return B.reduce((oe,ge)=>(oe[_(ge)]=Z?Z(ge):ge,oe),Object.create(null))}e.index=L;function N(B,_){return B.push(_),()=>X(B,_)}e.insert=N;function X(B,_){const Z=B.indexOf(_);if(Z>-1)return B.splice(Z,1),_}e.remove=X;function ae(B,_,Z){const oe=B.slice(0,_),ge=B.slice(_);return oe.concat(Z,ge)}e.arrayInsert=ae;function J(B,_){let Z;if(typeof _=="number"){let oe=_;Z=()=>{const ge=Math.sin(oe++)*179426549;return ge-Math.floor(ge)}}else Z=Math.random;for(let oe=B.length-1;oe>0;oe-=1){const ge=Math.floor(Z()*(oe+1)),ke=B[oe];B[oe]=B[ge],B[ge]=ke}}e.shuffle=J;function Y(B,_){const Z=B.indexOf(_);Z>-1&&(B.splice(Z,1),B.unshift(_))}e.pushToStart=Y;function se(B,_){const Z=B.indexOf(_);Z>-1&&(B.splice(Z,1),B.push(_))}e.pushToEnd=se;function re(B,_){for(const Z of _)B.push(Z)}e.pushMany=re;function fe(B,_){return Array.isArray(B)?B.map(_):_(B)}e.mapArrayOrNot=fe;function K(B){return Array.isArray(B)?B:[B]}e.asArray=K;function le(B){return B[Math.floor(Math.random()*B.length)]}e.getRandomElement=le;function $(B,_){for(const Z of B){const oe=_(Z);if(oe!==void 0)return oe}}e.mapFind=$;function W(B,_,Z){const oe=z(B,_),ge=B.length,ke=Z.length;B.length=ge+ke;for(let Oe=ge-1;Oe>=oe;Oe--)B[Oe+ke]=B[Oe];for(let Oe=0;Oe<ke;Oe++)B[Oe+oe]=Z[Oe]}e.insertInto=W;function T(B,_,Z,oe){const ge=z(B,_),ke=B.splice(ge,Z);return W(B,ge,oe),ke}e.splice=T;function z(B,_){return _<0?Math.max(_+B.length,0):Math.min(_,B.length)}var Q;(function(B){function _(ge){return ge<0}B.isLessThan=_;function Z(ge){return ge>0}B.isGreaterThan=Z;function oe(ge){return ge===0}B.isNeitherLessOrGreaterThan=oe,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(Q=e.CompareResult||(e.CompareResult={}));function q(B,_){return(Z,oe)=>_(B(Z),B(oe))}e.compareBy=q;function j(...B){return(_,Z)=>{for(const oe of B){const ge=oe(_,Z);if(!Q.isNeitherLessOrGreaterThan(ge))return ge}return Q.neitherLessOrGreaterThan}}e.tieBreakComparators=j;const M=(B,_)=>B-_;e.numberComparator=M;function O(B,_){if(B.length===0)return;let Z=B[0];for(let oe=1;oe<B.length;oe++){const ge=B[oe];_(ge,Z)>0&&(Z=ge)}return Z}e.findMaxBy=O;function F(B,_){if(B.length===0)return;let Z=B[0];for(let oe=1;oe<B.length;oe++){const ge=B[oe];_(ge,Z)>=0&&(Z=ge)}return Z}e.findLastMaxBy=F;function U(B,_){return O(B,(Z,oe)=>-_(Z,oe))}e.findMinBy=U;class H{constructor(_){this.f=_,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(_){let Z=this.c;for(;Z<this.f.length&&_(this.f[Z]);)Z++;const oe=Z===this.c?null:this.f.slice(this.c,Z);return this.c=Z,oe}takeFromEndWhile(_){let Z=this.d;for(;Z>=0&&_(this.f[Z]);)Z--;const oe=Z===this.d?null:this.f.slice(Z+1,this.d+1);return this.d=Z,oe}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const _=this.f[this.c];return this.c++,_}removeLast(){const _=this.f[this.d];return this.d--,_}takeCount(_){const Z=this.f.slice(this.c,this.c+_);return this.c+=_,Z}}e.ArrayQueue=H;class x{constructor(_){this.iterate=_}forEach(_){this.iterate(Z=>(_(Z),!0))}toArray(){const _=[];return this.iterate(Z=>(_.push(Z),!0)),_}filter(_){return new x(Z=>this.iterate(oe=>_(oe)?Z(oe):!0))}map(_){return new x(Z=>this.iterate(oe=>Z(_(oe))))}some(_){let Z=!1;return this.iterate(oe=>(Z=_(oe),!Z)),Z}findFirst(_){let Z;return this.iterate(oe=>_(oe)?(Z=oe,!1):!0),Z}findLast(_){let Z;return this.iterate(oe=>(_(oe)&&(Z=oe),!0)),Z}findLastMaxBy(_){let Z,oe=!0;return this.iterate(ge=>((oe||Q.isGreaterThan(_(ge,Z)))&&(oe=!1,Z=ge),!0)),Z}}e.CallbackIterable=x,x.empty=new x(B=>{})}),define(te[122],ie([0,1,14]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(w,m){if(!w)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}e.ok=t;function k(w,m="Unreachable"){throw new Error(m)}e.assertNever=k;function R(w){if(!w)throw new I.BugIndicatingError("Assertion Failed")}e.assert=R;function A(w){if(!w()){debugger;w(),(0,I.onUnexpectedError)(new I.BugIndicatingError("Assertion Failed"))}}e.assertFn=A;function C(w,m){let y=0;for(;y<w.length-1;){const P=w[y],E=w[y+1];if(!m(P,E))return!1;y++}return!0}e.checkAdjacentItems=C}),define(te[50],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function I(t){const k=this;let R=!1,A;return function(){return R||(R=!0,A=t.apply(k,arguments)),A}}e.once=I}),define(te[67],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(t){function k(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}t.is=k;const R=Object.freeze([]);function A(){return R}t.empty=A;function*C(f){yield f}t.single=C;function w(f){return k(f)?f:C(f)}t.wrap=w;function m(f){return f||R}t.from=m;function y(f){return!f||f[Symbol.iterator]().next().done===!0}t.isEmpty=y;function P(f){return f[Symbol.iterator]().next().value}t.first=P;function E(f,l){for(const i of f)if(l(i))return!0;return!1}t.some=E;function h(f,l){for(const i of f)if(l(i))return i}t.find=h;function*d(f,l){for(const i of f)l(i)&&(yield i)}t.filter=d;function*v(f,l){let i=0;for(const s of f)yield l(s,i++)}t.map=v;function*b(...f){for(const l of f)for(const i of l)yield i}t.concat=b;function u(f,l,i){let s=i;for(const n of f)s=l(s,n);return s}t.reduce=u;function*p(f,l,i=f.length){for(l<0&&(l+=f.length),i<0?i+=f.length:i>f.length&&(i=f.length);l<i;l++)yield f[l]}t.slice=p;function g(f,l=Number.POSITIVE_INFINITY){const i=[];if(l===0)return[i,f];const s=f[Symbol.iterator]();for(let n=0;n<l;n++){const a=s.next();if(a.done)return[i,t.empty()];i.push(a.value)}return[i,{[Symbol.iterator](){return s}}]}t.consume=g})(I=e.Iterable||(e.Iterable={}))}),define(te[43],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(I=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function A(i,s=!1){let n=0;const a=i.length;let r="",c=0,o=16,S=0;function D(se){let re=0,fe=0;for(;re<se;){const K=i.charCodeAt(n);if(K>=48&&K<=57)fe=fe*16+K-48;else if(K>=65&&K<=70)fe=fe*16+K-65+10;else if(K>=97&&K<=102)fe=fe*16+K-97+10;else break;n++,re++}return re<se&&(fe=-1),fe}function L(se){n=se,r="",c=0,o=16,S=0}function N(){const se=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&m(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&m(i.charCodeAt(n)))for(n++;n<i.length&&m(i.charCodeAt(n));)n++;else return S=3,i.substring(se,n);let re=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&m(i.charCodeAt(n))){for(n++;n<i.length&&m(i.charCodeAt(n));)n++;re=n}else S=3;return i.substring(se,re)}function X(){let se="",re=n;for(;;){if(n>=a){se+=i.substring(re,n),S=2;break}const fe=i.charCodeAt(n);if(fe===34){se+=i.substring(re,n),n++;break}if(fe===92){if(se+=i.substring(re,n),n++,n>=a){S=2;break}switch(i.charCodeAt(n++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:{const le=D(4);le>=0?se+=String.fromCharCode(le):S=4;break}default:S=5}re=n;continue}if(fe>=0&&fe<=31)if(w(fe)){se+=i.substring(re,n),S=2;break}else S=6;n++}return se}function ae(){if(r="",S=0,c=n,n>=a)return c=a,o=17;let se=i.charCodeAt(n);if(C(se)){do n++,r+=String.fromCharCode(se),se=i.charCodeAt(n);while(C(se));return o=15}if(w(se))return n++,r+=String.fromCharCode(se),se===13&&i.charCodeAt(n)===10&&(n++,r+=`
`),o=14;switch(se){case 123:return n++,o=1;case 125:return n++,o=2;case 91:return n++,o=3;case 93:return n++,o=4;case 58:return n++,o=6;case 44:return n++,o=5;case 34:return n++,r=X(),o=10;case 47:{const re=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<a&&!w(i.charCodeAt(n));)n++;return r=i.substring(re,n),o=12}if(i.charCodeAt(n+1)===42){n+=2;const fe=a-1;let K=!1;for(;n<fe;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,K=!0;break}n++}return K||(n++,S=1),r=i.substring(re,n),o=13}return r+=String.fromCharCode(se),n++,o=16}case 45:if(r+=String.fromCharCode(se),n++,n===a||!m(i.charCodeAt(n)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=N(),o=11;default:for(;n<a&&J(se);)n++,se=i.charCodeAt(n);if(c!==n){switch(r=i.substring(c,n),r){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return r+=String.fromCharCode(se),n++,o=16}}function J(se){if(C(se)||w(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Y(){let se;do se=ae();while(se>=12&&se<=15);return se}return{setPosition:L,getPosition:()=>n,scan:s?Y:ae,getToken:()=>o,getTokenValue:()=>r,getTokenOffset:()=>c,getTokenLength:()=>n-c,getTokenError:()=>S}}e.createScanner=A;function C(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function w(i){return i===10||i===13||i===8232||i===8233}function m(i){return i>=48&&i<=57}var y;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(y||(y={}));function P(i,s){const n=[],a=new Object;let r;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function S(D,L,N,X){c.value=D,c.offset=L,c.length=N,c.type=X,c.colonOffset=void 0,r=c}try{g(i,{onObjectBegin:(D,L)=>{if(s<=D)throw a;r=void 0,o=s>D,n.push("")},onObjectProperty:(D,L,N)=>{if(s<L||(S(D,L,N,"property"),n[n.length-1]=D,s<=L+N))throw a},onObjectEnd:(D,L)=>{if(s<=D)throw a;r=void 0,n.pop()},onArrayBegin:(D,L)=>{if(s<=D)throw a;r=void 0,n.push(0)},onArrayEnd:(D,L)=>{if(s<=D)throw a;r=void 0,n.pop()},onLiteralValue:(D,L,N)=>{if(s<L||(S(D,L,N,l(D)),s<=L+N))throw a},onSeparator:(D,L,N)=>{if(s<=L)throw a;if(D===":"&&r&&r.type==="property")r.colonOffset=L,o=!1,r=void 0;else if(D===","){const X=n[n.length-1];typeof X=="number"?n[n.length-1]=X+1:(o=!0,n[n.length-1]=""),r=void 0}}})}catch(D){if(D!==a)throw D}return{path:n,previousNode:r,isAtPropertyKey:o,matches:D=>{let L=0;for(let N=0;L<D.length&&N<n.length;N++)if(D[L]===n[N]||D[L]==="*")L++;else if(D[L]!=="**")return!1;return L===D.length}}}e.getLocation=P;function E(i,s=[],n=R.DEFAULT){let a=null,r=[];const c=[];function o(D){Array.isArray(r)?r.push(D):a!==null&&(r[a]=D)}return g(i,{onObjectBegin:()=>{const D={};o(D),c.push(r),r=D,a=null},onObjectProperty:D=>{a=D},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{const D=[];o(D),c.push(r),r=D,a=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:o,onError:(D,L,N)=>{s.push({error:D,offset:L,length:N})}},n),r[0]}e.parse=E;function h(i,s=[],n=R.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(D){a.type==="property"&&(a.length=D-a.offset,a=a.parent)}function c(D){return a.children.push(D),D}g(i,{onObjectBegin:D=>{a=c({type:"object",offset:D,length:-1,parent:a,children:[]})},onObjectProperty:(D,L,N)=>{a=c({type:"property",offset:L,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:D,offset:L,length:N,parent:a})},onObjectEnd:(D,L)=>{a.length=D+L-a.offset,a=a.parent,r(D+L)},onArrayBegin:(D,L)=>{a=c({type:"array",offset:D,length:-1,parent:a,children:[]})},onArrayEnd:(D,L)=>{a.length=D+L-a.offset,a=a.parent,r(D+L)},onLiteralValue:(D,L,N)=>{c({type:l(D),offset:L,length:N,parent:a,value:D}),r(L+N)},onSeparator:(D,L,N)=>{a.type==="property"&&(D===":"?a.colonOffset=L:D===","&&r(L))},onError:(D,L,N)=>{s.push({error:D,offset:L,length:N})}},n);const S=a.children[0];return S&&delete S.parent,S}e.parseTree=h;function d(i,s){if(!i)return;let n=i;for(const a of s)if(typeof a=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let r=!1;for(const c of n.children)if(Array.isArray(c.children)&&c.children[0].value===a){n=c.children[1],r=!0;break}if(!r)return}else{const r=a;if(n.type!=="array"||r<0||!Array.isArray(n.children)||r>=n.children.length)return;n=n.children[r]}return n}e.findNodeAtLocation=d;function v(i){if(!i.parent||!i.parent.children)return[];const s=v(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;s.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&s.push(n)}return s}e.getNodePath=v;function b(i){switch(i.type){case"array":return i.children.map(b);case"object":{const s=Object.create(null);for(const n of i.children){const a=n.children[1];a&&(s[n.children[0].value]=b(a))}return s}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=b;function u(i,s,n=!1){return s>=i.offset&&s<i.offset+i.length||n&&s===i.offset+i.length}e.contains=u;function p(i,s,n=!1){if(u(i,s,n)){const a=i.children;if(Array.isArray(a))for(let r=0;r<a.length&&a[r].offset<=s;r++){const c=p(a[r],s,n);if(c)return c}return i}}e.findNodeAtOffset=p;function g(i,s,n=R.DEFAULT){const a=A(i,!1);function r(q){return q?()=>q(a.getTokenOffset(),a.getTokenLength()):()=>!0}function c(q){return q?j=>q(j,a.getTokenOffset(),a.getTokenLength()):()=>!0}const o=r(s.onObjectBegin),S=c(s.onObjectProperty),D=r(s.onObjectEnd),L=r(s.onArrayBegin),N=r(s.onArrayEnd),X=c(s.onLiteralValue),ae=c(s.onSeparator),J=r(s.onComment),Y=c(s.onError),se=n&&n.disallowComments,re=n&&n.allowTrailingComma;function fe(){for(;;){const q=a.scan();switch(a.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:se||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(q){case 12:case 13:se?K(10):J();break;case 16:K(1);break;case 15:case 14:break;default:return q}}}function K(q,j=[],M=[]){if(Y(q),j.length+M.length>0){let O=a.getToken();for(;O!==17;){if(j.indexOf(O)!==-1){fe();break}else if(M.indexOf(O)!==-1)break;O=fe()}}}function le(q){const j=a.getTokenValue();return q?X(j):S(j),fe(),!0}function $(){switch(a.getToken()){case 11:{let q=0;try{q=JSON.parse(a.getTokenValue()),typeof q!="number"&&(K(2),q=0)}catch{K(2)}X(q);break}case 7:X(null);break;case 8:X(!0);break;case 9:X(!1);break;default:return!1}return fe(),!0}function W(){return a.getToken()!==10?(K(3,[],[2,5]),!1):(le(!1),a.getToken()===6?(ae(":"),fe(),Q()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function T(){o(),fe();let q=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(q||K(4,[],[]),ae(","),fe(),a.getToken()===2&&re)break}else q&&K(6,[],[]);W()||K(4,[],[2,5]),q=!0}return D(),a.getToken()!==2?K(7,[2],[]):fe(),!0}function z(){L(),fe();let q=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(q||K(4,[],[]),ae(","),fe(),a.getToken()===4&&re)break}else q&&K(6,[],[]);Q()||K(4,[],[4,5]),q=!0}return N(),a.getToken()!==4?K(8,[4],[]):fe(),!0}function Q(){switch(a.getToken()){case 3:return z();case 1:return T();case 10:return le(!0);default:return $()}}return fe(),a.getToken()===17?n.allowEmptyContent?!0:(K(4,[],[]),!1):Q()?(a.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.visit=g;function f(i,s){const n=A(i),a=[];let r,c=0,o;do switch(o=n.getPosition(),r=n.scan(),r){case 12:case 13:case 17:c!==o&&a.push(i.substring(c,o)),s!==void 0&&a.push(n.getTokenValue().replace(/[^\r\n]/g,s)),c=n.getPosition();break}while(r!==17);return a.join("")}e.stripComments=f;function l(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(te[123],ie([0,1,43]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(m,y,P){let E,h,d,v,b;if(y){for(v=y.offset,b=v+y.length,d=v;d>0&&!w(m,d-1);)d--;let o=b;for(;o<m.length&&!w(m,o);)o++;h=m.substring(d,o),E=A(h,P)}else h=m,E=0,d=0,v=0,b=m.length;const u=C(P,m);let p=!1,g=0,f;P.insertSpaces?f=R(" ",P.tabSize||4):f="	";const l=(0,I.createScanner)(h,!1);let i=!1;function s(){return u+R(f,E+g)}function n(){let o=l.scan();for(p=!1;o===15||o===14;)p=p||o===14,o=l.scan();return i=o===16||l.getTokenError()!==0,o}const a=[];function r(o,S,D){!i&&S<b&&D>v&&m.substring(S,D)!==o&&a.push({offset:S,length:D-S,content:o})}let c=n();if(c!==17){const o=l.getTokenOffset()+d,S=R(f,E);r(S,d,o)}for(;c!==17;){let o=l.getTokenOffset()+l.getTokenLength()+d,S=n(),D="";for(;!p&&(S===12||S===13);){const N=l.getTokenOffset()+d;r(" ",o,N),o=l.getTokenOffset()+l.getTokenLength()+d,D=S===12?s():"",S=n()}if(S===2)c!==1&&(g--,D=s());else if(S===4)c!==3&&(g--,D=s());else{switch(c){case 3:case 1:g++,D=s();break;case 5:case 12:D=s();break;case 13:p?D=s():D=" ";break;case 6:D=" ";break;case 10:if(S===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:S===12||S===13?D=" ":S!==5&&S!==17&&(i=!0);break;case 16:i=!0;break}p&&(S===12||S===13)&&(D=s())}const L=l.getTokenOffset()+d;r(D,o,L),c=S}return a}e.format=t;function k(m,y){const P=JSON.stringify(m,void 0,y.insertSpaces?y.tabSize||4:"	");return y.eol!==void 0?P.replace(/\r\n|\r|\n/g,y.eol):P}e.toFormattedString=k;function R(m,y){let P="";for(let E=0;E<y;E++)P+=m;return P}function A(m,y){let P=0,E=0;const h=y.tabSize||4;for(;P<m.length;){const d=m.charAt(P);if(d===" ")E++;else if(d==="	")E+=h;else break;P++}return Math.floor(E/h)}function C(m,y){for(let P=0;P<y.length;P++){const E=y.charAt(P);if(E==="\r")return P+1<y.length&&y.charAt(P+1)===`
`?`\r
`:"\r";if(E===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=C;function w(m,y){return`\r
`.indexOf(m.charAt(y))!==-1}e.isEOL=w}),define(te[124],ie([0,1,43,123]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(m,y,P){return R(m,y,void 0,P)}e.removeProperty=k;function R(m,y,P,E,h){const d=y.slice(),v=[],b=(0,I.parseTree)(m,v);let u,p;for(;d.length>0&&(p=d.pop(),u=(0,I.findNodeAtLocation)(b,d),u===void 0&&P!==void 0);)typeof p=="string"?P={[p]:P}:P=[P];if(u)if(u.type==="object"&&typeof p=="string"&&Array.isArray(u.children)){const g=(0,I.findNodeAtLocation)(u,[p]);if(g!==void 0)if(P===void 0){if(!g.parent)throw new Error("Malformed AST");const f=u.children.indexOf(g.parent);let l,i=g.parent.offset+g.parent.length;if(f>0){const s=u.children[f-1];l=s.offset+s.length}else l=u.offset+1,u.children.length>1&&(i=u.children[1].offset);return A(m,{offset:l,length:i-l,content:""},E)}else return A(m,{offset:g.offset,length:g.length,content:JSON.stringify(P)},E);else{if(P===void 0)return[];const f=`${JSON.stringify(p)}: ${JSON.stringify(P)}`,l=h?h(u.children.map(s=>s.children[0].value)):u.children.length;let i;if(l>0){const s=u.children[l-1];i={offset:s.offset+s.length,length:0,content:","+f}}else u.children.length===0?i={offset:u.offset+1,length:0,content:f}:i={offset:u.offset+1,length:0,content:f+","};return A(m,i,E)}}else if(u.type==="array"&&typeof p=="number"&&Array.isArray(u.children))if(P!==void 0){const g=`${JSON.stringify(P)}`;let f;if(u.children.length===0||p===0)f={offset:u.offset+1,length:0,content:u.children.length===0?g:g+","};else{const l=p===-1||p>u.children.length?u.children.length:p,i=u.children[l-1];f={offset:i.offset+i.length,length:0,content:","+g}}return A(m,f,E)}else{const g=p,f=u.children[g];let l;if(u.children.length===1)l={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===g){const i=u.children[g-1],s=i.offset+i.length,n=u.offset+u.length;l={offset:s,length:n-2-s,content:""}}else l={offset:f.offset,length:u.children[g+1].offset-f.offset,content:""};return A(m,l,E)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${u.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return A(m,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(P)},E)}}e.setProperty=R;function A(m,y,P){let E=C(m,y),h=y.offset,d=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;h>0&&!(0,t.isEOL)(E,h-1);)h--;for(;d<E.length&&!(0,t.isEOL)(E,d);)d++}const v=(0,t.format)(E,{offset:h,length:d-h},P);for(let u=v.length-1;u>=0;u--){const p=v[u];E=C(E,p),h=Math.min(h,p.offset),d=Math.max(d,p.offset+p.length),d+=p.content.length-p.length}const b=m.length-(E.length-d)-h;return[{offset:h,length:b,content:E.substring(h,d)}]}e.withFormatting=A;function C(m,y){return m.substring(0,y.offset)+y.content+m.substring(y.offset+y.length)}e.applyEdit=C;function w(m,y){const P=y.slice(0).sort((h,d)=>{const v=h.offset-d.offset;return v===0?h.length-d.length:v});let E=m.length;for(let h=P.length-1;h>=0;h--){const d=P[h];if(d.offset+d.length<=E)m=C(m,d);else throw new Error("Overlapping edit");E=d.offset}return m}e.applyEdits=w}),define(te[125],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class I{constructor(k){this.d=k,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(k){this.c=k}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(k){return new I(()=>k(this.getValue()))}}e.Lazy=I}),define(te[2],ie([0,1,50,67]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let R=null;function A(c){R=c}if(e.setDisposableTracker=A,k){const c="__is_disposable_tracked__";A(new class{trackDisposable(o){const S=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[c]||console.log(S)},3e3)}setParent(o,S){if(o&&o!==p.None)try{o[c]=!0}catch{}}markAsDisposed(o){if(o&&o!==p.None)try{o[c]=!0}catch{}}markAsSingleton(o){}})}function C(c){return R?.trackDisposable(c),c}function w(c){R?.markAsDisposed(c)}function m(c,o){R?.setParent(c,o)}function y(c,o){if(!!R)for(const S of c)R.setParent(S,o)}function P(c){return R?.markAsSingleton(c),c}e.markAsSingleton=P;function E(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=E;function h(c){if(t.Iterable.is(c)){const o=[];for(const S of c)if(S)try{S.dispose()}catch(D){o.push(D)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=h;function d(c){for(const o of c)E(o)&&o.dispose();return[]}e.disposeIfDisposable=d;function v(...c){const o=b(()=>h(c));return y(c,o),o}e.combinedDisposable=v;function b(c){const o=C({dispose:(0,I.once)(()=>{w(o),c()})});return o}e.toDisposable=b;class u{constructor(){this.c=new Set,this.f=!1,C(this)}dispose(){this.f||(w(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{h(this.c)}finally{this.c.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return m(o,this),this.f?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(o),o}}e.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this.q=new u,C(this),m(this.q,this)}dispose(){w(this),this.q.dispose()}B(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(o)}}e.Disposable=p,p.None=Object.freeze({dispose(){}});class g{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(o){this.b||o===this.a||(this.a?.dispose(),o&&m(o,this),this.a=o)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const o=this.a;return this.a=void 0,o&&m(o,null),o}}e.MutableDisposable=g;class f{constructor(o){this.b=o,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=f;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(o){let S=o;return this.unset=()=>S=void 0,this.isset=()=>S!==void 0,this.dispose=()=>{S&&(S(),S=void 0,w(this))},this}}e.SafeDisposable=l;class i{constructor(){this.a=new Map}acquire(o,...S){let D=this.a.get(o);D||(D={counter:0,object:this.b(o,...S)},this.a.set(o,D));const{object:L}=D,N=(0,I.once)(()=>{--D.counter===0&&(this.c(o,D.object),this.a.delete(o))});return D.counter++,{object:L,dispose:N}}}e.ReferenceCollection=i;class s{constructor(o){this.a=o}async acquire(o,...S){const D=this.a.acquire(o,...S);try{return{object:await D.object,dispose:()=>D.dispose()}}catch(L){throw D.dispose(),L}}}e.AsyncReferenceCollection=s;class n{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=n;function a(c){const o=new u;try{c(o)}finally{o.dispose()}}e.disposeOnReturn=a;class r{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(o){return this.a.has(o)}get(o){return this.a.get(o)}set(o,S,D=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),D||this.a.get(o)?.dispose(),this.a.set(o,S)}deleteAndDispose(o){this.a.get(o)?.dispose(),this.a.delete(o)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=r}),define(te[96],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class I{constructor(R){this.element=R,this.next=I.Undefined,this.prev=I.Undefined}}I.Undefined=new I(void 0);class t{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let R=this.a;for(;R!==I.Undefined;){const A=R.next;R.prev=I.Undefined,R.next=I.Undefined,R=A}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,A){const C=new I(R);if(this.a===I.Undefined)this.a=C,this.b=C;else if(A){const m=this.b;this.b=C,C.prev=m,m.next=C}else{const m=this.a;this.a=C,C.next=m,m.prev=C}this.c+=1;let w=!1;return()=>{w||(w=!0,this.e(C))}}shift(){if(this.a!==I.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==I.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==I.Undefined&&R.next!==I.Undefined){const A=R.prev;A.next=R.next,R.next.prev=A}else R.prev===I.Undefined&&R.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):R.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):R.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==I.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),define(te[39],ie([0,1]),function(V,e){"use strict";var I,t,k;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(d,v,b){let u=d.get(v);return u===void 0&&(u=b,d.set(v,u)),u}e.getOrSet=R;function A(d){const v=[];return d.forEach((b,u)=>{v.push(`${u} => ${b}`)}),`Map(${d.size}) {${v.join(", ")}}`}e.mapToString=A;function C(d){const v=[];return d.forEach(b=>{v.push(b)}),`Set(${d.size}) {${v.join(", ")}}`}e.setToString=C;class w{constructor(v,b){this.uri=v,this.value=b}}class m{constructor(v,b){this[I]="ResourceMap",v instanceof m?(this.b=new Map(v.b),this.c=b??m.a):(this.b=new Map,this.c=v??m.a)}set(v,b){return this.b.set(this.c(v),new w(v,b)),this}get(v){return this.b.get(this.c(v))?.value}has(v){return this.b.has(this.c(v))}get size(){return this.b.size}clear(){this.b.clear()}delete(v){return this.b.delete(this.c(v))}forEach(v,b){typeof b<"u"&&(v=v.bind(b));for(const[u,p]of this.b)v(p.value,p.uri,this)}*values(){for(const v of this.b.values())yield v.value}*keys(){for(const v of this.b.values())yield v.uri}*entries(){for(const v of this.b.values())yield[v.uri,v.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,v]of this.b)yield[v.uri,v.value]}}e.ResourceMap=m,m.a=d=>d.toString();class y{constructor(v,b){this[t]="ResourceSet",!v||typeof v=="function"?this.a=new m(v):(this.a=new m(b),v.forEach(this.add,this))}get size(){return this.a.size}add(v){return this.a.set(v,v),this}clear(){this.a.clear()}delete(v){return this.a.delete(v)}forEach(v,b){this.a.forEach((u,p)=>v.call(b,p,p,this))}has(v){return this.a.has(v)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=y;var P;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(P=e.Touch||(e.Touch={}));class E{constructor(){this[k]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(v){return this.a.has(v)}get(v,b=0){const u=this.a.get(v);if(!!u)return b!==0&&this.j(u,b),u.value}set(v,b,u=0){let p=this.a.get(v);if(p)p.value=b,u!==0&&this.j(p,u);else{switch(p={key:v,value:b,next:void 0,previous:void 0},u){case 0:this.h(p);break;case 1:this.g(p);break;case 2:this.h(p);break;default:this.h(p);break}this.a.set(v,p),this.d++}return this}delete(v){return!!this.remove(v)}remove(v){const b=this.a.get(v);if(!!b)return this.a.delete(v),this.i(b),this.d--,b.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const v=this.b;return this.a.delete(v.key),this.i(v),this.d--,v.value}forEach(v,b){const u=this.e;let p=this.b;for(;p;){if(b?v.bind(b)(p.value,p.key,this):v(p.value,p.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const v=this,b=this.e;let u=this.b;const p={[Symbol.iterator](){return p},next(){if(v.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const g={value:u.key,done:!1};return u=u.next,g}else return{value:void 0,done:!0}}};return p}values(){const v=this,b=this.e;let u=this.b;const p={[Symbol.iterator](){return p},next(){if(v.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const g={value:u.value,done:!1};return u=u.next,g}else return{value:void 0,done:!0}}};return p}entries(){const v=this,b=this.e;let u=this.b;const p={[Symbol.iterator](){return p},next(){if(v.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const g={value:[u.key,u.value],done:!1};return u=u.next,g}else return{value:void 0,done:!0}}};return p}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(v){if(v>=this.size)return;if(v===0){this.clear();return}let b=this.b,u=this.size;for(;b&&u>v;)this.a.delete(b.key),b=b.next,u--;this.b=b,this.d=u,b&&(b.previous=void 0),this.e++}g(v){if(!this.b&&!this.c)this.c=v;else if(this.b)v.next=this.b,this.b.previous=v;else throw new Error("Invalid list");this.b=v,this.e++}h(v){if(!this.b&&!this.c)this.b=v;else if(this.c)v.previous=this.c,this.c.next=v;else throw new Error("Invalid list");this.c=v,this.e++}i(v){if(v===this.b&&v===this.c)this.b=void 0,this.c=void 0;else if(v===this.b){if(!v.next)throw new Error("Invalid list");v.next.previous=void 0,this.b=v.next}else if(v===this.c){if(!v.previous)throw new Error("Invalid list");v.previous.next=void 0,this.c=v.previous}else{const b=v.next,u=v.previous;if(!b||!u)throw new Error("Invalid list");b.previous=u,u.next=b}v.next=void 0,v.previous=void 0,this.e++}j(v,b){if(!this.b||!this.c)throw new Error("Invalid list");if(!(b!==1&&b!==2)){if(b===1){if(v===this.b)return;const u=v.next,p=v.previous;v===this.c?(p.next=void 0,this.c=p):(u.previous=p,p.next=u),v.previous=void 0,v.next=this.b,this.b.previous=v,this.b=v,this.e++}else if(b===2){if(v===this.c)return;const u=v.next,p=v.previous;v===this.b?(u.previous=void 0,this.b=u):(u.previous=p,p.next=u),v.next=void 0,v.previous=this.c,this.c.next=v,this.c=v,this.e++}}}toJSON(){const v=[];return this.forEach((b,u)=>{v.push([u,b])}),v}fromJSON(v){this.clear();for(const[b,u]of v)this.set(b,u)}}e.LinkedMap=E;class h extends E{constructor(v,b=1){super(),this.k=v,this.l=Math.min(Math.max(0,b),1)}get limit(){return this.k}set limit(v){this.k=v,this.m()}get ratio(){return this.l}set ratio(v){this.l=Math.min(Math.max(0,v),1),this.m()}get(v,b=2){return super.get(v,b)}peek(v){return super.get(v,0)}set(v,b){return super.set(v,b,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=h}),define(te[76],ie([0,1,39]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new I.LRUCache(1e4);function k(m){return w(m,"NFC",t)}e.normalizeNFC=k;const R=new I.LRUCache(1e4);function A(m){return w(m,"NFD",R)}e.normalizeNFD=A;const C=/[^\u0000-\u0080]/;function w(m,y,P){if(!m)return m;const E=P.get(m);if(E)return E;let h;return C.test(m)?h=m.normalize(y):h=m,P.set(m,h),h}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(y){return A(y).replace(m,"")}}()}),function(){function V(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function A(w){R.push(w,Date.now())}function C(){const w=[];for(let m=0;m<R.length;m+=2)w.push({name:R[m],startTime:R[m+1]});return w}return{mark:A,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const A of performance.getEntriesByType("mark"))R.push({name:A.name,startTime:Math.round(k+A.startTime)});return R}};if(typeof process=="object"){const k=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function I(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=I(t))}(),function(V,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var t in I)(typeof exports=="object"?exports:V)[t]=I[t]}}(typeof self<"u"?self:this,function(){return function(V){var e={};function I(t){if(e[t])return e[t].exports;var k=e[t]={i:t,l:!1,exports:{}};return V[t].call(k.exports,k,k.exports,I),k.l=!0,k.exports}return I.m=V,I.c=e,I.d=function(t,k,R){I.o(t,k)||Object.defineProperty(t,k,{enumerable:!0,get:R})},I.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},I.t=function(t,k){if(1&k&&(t=I(t)),8&k||4&k&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(I.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&k&&typeof t!="string")for(var A in t)I.d(R,A,function(C){return t[C]}.bind(null,A));return R},I.n=function(t){var k=t&&t.__esModule?function(){return t.default}:function(){return t};return I.d(k,"a",k),k},I.o=function(t,k){return Object.prototype.hasOwnProperty.call(t,k)},I.p="",I(I.s=0)}([function(V,e,I){(function(t){var k;e=V.exports=M,k=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],w=e.src=[],m=0,y=m++;w[y]="0|[1-9]\\d*";var P=m++;w[P]="[0-9]+";var E=m++;w[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=m++;w[h]="("+w[y]+")\\.("+w[y]+")\\.("+w[y]+")";var d=m++;w[d]="("+w[P]+")\\.("+w[P]+")\\.("+w[P]+")";var v=m++;w[v]="(?:"+w[y]+"|"+w[E]+")";var b=m++;w[b]="(?:"+w[P]+"|"+w[E]+")";var u=m++;w[u]="(?:-("+w[v]+"(?:\\."+w[v]+")*))";var p=m++;w[p]="(?:-?("+w[b]+"(?:\\."+w[b]+")*))";var g=m++;w[g]="[0-9A-Za-z-]+";var f=m++;w[f]="(?:\\+("+w[g]+"(?:\\."+w[g]+")*))";var l=m++,i="v?"+w[h]+w[u]+"?"+w[f]+"?";w[l]="^"+i+"$";var s="[v=\\s]*"+w[d]+w[p]+"?"+w[f]+"?",n=m++;w[n]="^"+s+"$";var a=m++;w[a]="((?:<|>)?=?)";var r=m++;w[r]=w[P]+"|x|X|\\*";var c=m++;w[c]=w[y]+"|x|X|\\*";var o=m++;w[o]="[v=\\s]*("+w[c]+")(?:\\.("+w[c]+")(?:\\.("+w[c]+")(?:"+w[u]+")?"+w[f]+"?)?)?";var S=m++;w[S]="[v=\\s]*("+w[r]+")(?:\\.("+w[r]+")(?:\\.("+w[r]+")(?:"+w[p]+")?"+w[f]+"?)?)?";var D=m++;w[D]="^"+w[a]+"\\s*"+w[o]+"$";var L=m++;w[L]="^"+w[a]+"\\s*"+w[S]+"$";var N=m++;w[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var X=m++;w[X]="(?:~>?)";var ae=m++;w[ae]="(\\s*)"+w[X]+"\\s+",C[ae]=new RegExp(w[ae],"g");var J=m++;w[J]="^"+w[X]+w[o]+"$";var Y=m++;w[Y]="^"+w[X]+w[S]+"$";var se=m++;w[se]="(?:\\^)";var re=m++;w[re]="(\\s*)"+w[se]+"\\s+",C[re]=new RegExp(w[re],"g");var fe=m++;w[fe]="^"+w[se]+w[o]+"$";var K=m++;w[K]="^"+w[se]+w[S]+"$";var le=m++;w[le]="^"+w[a]+"\\s*("+s+")$|^$";var $=m++;w[$]="^"+w[a]+"\\s*("+i+")$|^$";var W=m++;w[W]="(\\s*)"+w[a]+"\\s*("+s+"|"+w[o]+")",C[W]=new RegExp(w[W],"g");var T=m++;w[T]="^\\s*("+w[o]+")\\s+-\\s+("+w[o]+")\\s*$";var z=m++;w[z]="^\\s*("+w[S]+")\\s+-\\s+("+w[S]+")\\s*$";var Q=m++;w[Q]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)k(q,w[q]),C[q]||(C[q]=new RegExp(w[q]));function j(ee,he){if(ee instanceof M)return ee;if(typeof ee!="string"||ee.length>R||!(he?C[n]:C[l]).test(ee))return null;try{return new M(ee,he)}catch{return null}}function M(ee,he){if(ee instanceof M){if(ee.loose===he)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof M))return new M(ee,he);k("SemVer",ee,he),this.loose=he;var de=ee.trim().match(he?C[n]:C[l]);if(!de)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(ve){if(/^[0-9]+$/.test(ve)){var Pe=+ve;if(Pe>=0&&Pe<A)return Pe}return ve}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=j,e.valid=function(ee,he){var de=j(ee,he);return de?de.version:null},e.clean=function(ee,he){var de=j(ee.trim().replace(/^[=v]+/,""),he);return de?de.version:null},e.SemVer=M,M.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},M.prototype.toString=function(){return this.version},M.prototype.compare=function(ee){return k("SemVer.compare",this.version,this.loose,ee),ee instanceof M||(ee=new M(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},M.prototype.compareMain=function(ee){return ee instanceof M||(ee=new M(ee,this.loose)),F(this.major,ee.major)||F(this.minor,ee.minor)||F(this.patch,ee.patch)},M.prototype.comparePre=function(ee){if(ee instanceof M||(ee=new M(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var he=0;do{var de=this.prerelease[he],ve=ee.prerelease[he];if(k("prerelease compare",he,de,ve),de===void 0&&ve===void 0)return 0;if(ve===void 0)return 1;if(de===void 0)return-1;if(de!==ve)return F(de,ve)}while(++he)},M.prototype.inc=function(ee,he){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",he);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",he);break;case"prepatch":this.prerelease.length=0,this.inc("patch",he),this.inc("pre",he);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",he),this.inc("pre",he);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}he&&(this.prerelease[0]===he?isNaN(this.prerelease[1])&&(this.prerelease=[he,0]):this.prerelease=[he,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,he,de,ve){typeof de=="string"&&(ve=de,de=void 0);try{return new M(ee,de).inc(he,ve).version}catch{return null}},e.diff=function(ee,he){if(B(ee,he))return null;var de=j(ee),ve=j(he);if(de.prerelease.length||ve.prerelease.length){for(var Pe in de)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&de[Pe]!==ve[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in de)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&de[Pe]!==ve[Pe])return Pe},e.compareIdentifiers=F;var O=/^[0-9]+$/;function F(ee,he){var de=O.test(ee),ve=O.test(he);return de&&ve&&(ee=+ee,he=+he),de&&!ve?-1:ve&&!de?1:ee<he?-1:ee>he?1:0}function U(ee,he,de){return new M(ee,de).compare(new M(he,de))}function H(ee,he,de){return U(ee,he,de)>0}function x(ee,he,de){return U(ee,he,de)<0}function B(ee,he,de){return U(ee,he,de)===0}function _(ee,he,de){return U(ee,he,de)!==0}function Z(ee,he,de){return U(ee,he,de)>=0}function oe(ee,he,de){return U(ee,he,de)<=0}function ge(ee,he,de,ve){var Pe;switch(he){case"===":typeof ee=="object"&&(ee=ee.version),typeof de=="object"&&(de=de.version),Pe=ee===de;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof de=="object"&&(de=de.version),Pe=ee!==de;break;case"":case"=":case"==":Pe=B(ee,de,ve);break;case"!=":Pe=_(ee,de,ve);break;case">":Pe=H(ee,de,ve);break;case">=":Pe=Z(ee,de,ve);break;case"<":Pe=x(ee,de,ve);break;case"<=":Pe=oe(ee,de,ve);break;default:throw new TypeError("Invalid operator: "+he)}return Pe}function ke(ee,he){if(ee instanceof ke){if(ee.loose===he)return ee;ee=ee.value}if(!(this instanceof ke))return new ke(ee,he);k("comparator",ee,he),this.loose=he,this.parse(ee),this.semver===Oe?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(ee,he){return F(he,ee)},e.major=function(ee,he){return new M(ee,he).major},e.minor=function(ee,he){return new M(ee,he).minor},e.patch=function(ee,he){return new M(ee,he).patch},e.compare=U,e.compareLoose=function(ee,he){return U(ee,he,!0)},e.rcompare=function(ee,he,de){return U(he,ee,de)},e.sort=function(ee,he){return ee.sort(function(de,ve){return e.compare(de,ve,he)})},e.rsort=function(ee,he){return ee.sort(function(de,ve){return e.rcompare(de,ve,he)})},e.gt=H,e.lt=x,e.eq=B,e.neq=_,e.gte=Z,e.lte=oe,e.cmp=ge,e.Comparator=ke;var Oe={};function De(ee,he){if(ee instanceof De)return ee.loose===he?ee:new De(ee.raw,he);if(ee instanceof ke)return new De(ee.value,he);if(!(this instanceof De))return new De(ee,he);if(this.loose=he,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Le(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function be(ee,he,de,ve,Pe,We,Te,qe,Ue,je,Je,$e,Ke){return((he=Le(de)?"":Le(ve)?">="+de+".0.0":Le(Pe)?">="+de+"."+ve+".0":">="+he)+" "+(qe=Le(Ue)?"":Le(je)?"<"+(+Ue+1)+".0.0":Le(Je)?"<"+Ue+"."+(+je+1)+".0":$e?"<="+Ue+"."+je+"."+Je+"-"+$e:"<="+qe)).trim()}function we(ee,he){for(var de=0;de<ee.length;de++)if(!ee[de].test(he))return!1;if(he.prerelease.length){for(de=0;de<ee.length;de++)if(k(ee[de].semver),ee[de].semver!==Oe&&ee[de].semver.prerelease.length>0){var ve=ee[de].semver;if(ve.major===he.major&&ve.minor===he.minor&&ve.patch===he.patch)return!0}return!1}return!0}function ye(ee,he,de){try{he=new De(he,de)}catch{return!1}return he.test(ee)}function Me(ee,he,de,ve){var Pe,We,Te,qe,Ue;switch(ee=new M(ee,ve),he=new De(he,ve),de){case">":Pe=H,We=oe,Te=x,qe=">",Ue=">=";break;case"<":Pe=x,We=Z,Te=H,qe="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ye(ee,he,ve))return!1;for(var je=0;je<he.set.length;++je){var Je=he.set[je],$e=null,Ke=null;if(Je.forEach(function(G){G.semver===Oe&&(G=new ke(">=0.0.0")),$e=$e||G,Ke=Ke||G,Pe(G.semver,$e.semver,ve)?$e=G:Te(G.semver,Ke.semver,ve)&&(Ke=G)}),$e.operator===qe||$e.operator===Ue||(!Ke.operator||Ke.operator===qe)&&We(ee,Ke.semver)||Ke.operator===Ue&&Te(ee,Ke.semver))return!1}return!0}ke.prototype.parse=function(ee){var he=this.loose?C[le]:C[$],de=ee.match(he);if(!de)throw new TypeError("Invalid comparator: "+ee);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new M(de[2],this.loose):this.semver=Oe},ke.prototype.toString=function(){return this.value},ke.prototype.test=function(ee){return k("Comparator.test",ee,this.loose),this.semver===Oe||(typeof ee=="string"&&(ee=new M(ee,this.loose)),ge(ee,this.operator,this.semver,this.loose))},ke.prototype.intersects=function(ee,he){if(!(ee instanceof ke))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new De(ee.value,he),ye(this.value,de,he);if(ee.operator==="")return de=new De(this.value,he),ye(ee.semver,de,he);var ve=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),We=this.semver.version===ee.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),qe=ge(this.semver,"<",ee.semver,he)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),Ue=ge(this.semver,">",ee.semver,he)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return ve||Pe||We&&Te||qe||Ue},e.Range=De,De.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},De.prototype.toString=function(){return this.range},De.prototype.parseRange=function(ee){var he=this.loose;ee=ee.trim(),k("range",ee,he);var de=he?C[z]:C[T];ee=ee.replace(de,be),k("hyphen replace",ee),ee=ee.replace(C[W],"$1$2$3"),k("comparator trim",ee,C[W]),ee=(ee=(ee=ee.replace(C[ae],"$1~")).replace(C[re],"$1^")).split(/\s+/).join(" ");var ve=he?C[le]:C[$],Pe=ee.split(" ").map(function(We){return function(Te,qe){return k("comp",Te),Te=function(Ue,je){return Ue.trim().split(/\s+/).map(function(Je){return function($e,Ke){k("caret",$e,Ke);var G=Ke?C[K]:C[fe];return $e.replace(G,function(ce,ue,me,Se,Ae){var Be;return k("caret",$e,ce,ue,me,Se,Ae),Le(ue)?Be="":Le(me)?Be=">="+ue+".0.0 <"+(+ue+1)+".0.0":Le(Se)?Be=ue==="0"?">="+ue+"."+me+".0 <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+".0 <"+(+ue+1)+".0.0":Ae?(k("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Be=ue==="0"?me==="0"?">="+ue+"."+me+"."+Se+Ae+" <"+ue+"."+me+"."+(+Se+1):">="+ue+"."+me+"."+Se+Ae+" <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+"."+Se+Ae+" <"+(+ue+1)+".0.0"):(k("no pr"),Be=ue==="0"?me==="0"?">="+ue+"."+me+"."+Se+" <"+ue+"."+me+"."+(+Se+1):">="+ue+"."+me+"."+Se+" <"+ue+"."+(+me+1)+".0":">="+ue+"."+me+"."+Se+" <"+(+ue+1)+".0.0"),k("caret return",Be),Be})}(Je,je)}).join(" ")}(Te,qe),k("caret",Te),Te=function(Ue,je){return Ue.trim().split(/\s+/).map(function(Je){return function($e,Ke){var G=Ke?C[Y]:C[J];return $e.replace(G,function(ce,ue,me,Se,Ae){var Be;return k("tilde",$e,ce,ue,me,Se,Ae),Le(ue)?Be="":Le(me)?Be=">="+ue+".0.0 <"+(+ue+1)+".0.0":Le(Se)?Be=">="+ue+"."+me+".0 <"+ue+"."+(+me+1)+".0":Ae?(k("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Be=">="+ue+"."+me+"."+Se+Ae+" <"+ue+"."+(+me+1)+".0"):Be=">="+ue+"."+me+"."+Se+" <"+ue+"."+(+me+1)+".0",k("tilde return",Be),Be})}(Je,je)}).join(" ")}(Te,qe),k("tildes",Te),Te=function(Ue,je){return k("replaceXRanges",Ue,je),Ue.split(/\s+/).map(function(Je){return function($e,Ke){$e=$e.trim();var G=Ke?C[L]:C[D];return $e.replace(G,function(ce,ue,me,Se,Ae,Be){k("xRange",$e,ce,ue,me,Se,Ae,Be);var it=Le(me),xe=it||Le(Se),He=xe||Le(Ae);return ue==="="&&He&&(ue=""),it?ce=ue===">"||ue==="<"?"<0.0.0":"*":ue&&He?(xe&&(Se=0),He&&(Ae=0),ue===">"?(ue=">=",xe?(me=+me+1,Se=0,Ae=0):He&&(Se=+Se+1,Ae=0)):ue==="<="&&(ue="<",xe?me=+me+1:Se=+Se+1),ce=ue+me+"."+Se+"."+Ae):xe?ce=">="+me+".0.0 <"+(+me+1)+".0.0":He&&(ce=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0"),k("xRange return",ce),ce})}(Je,je)}).join(" ")}(Te,qe),k("xrange",Te),Te=function(Ue,je){return k("replaceStars",Ue,je),Ue.trim().replace(C[Q],"")}(Te,qe),k("stars",Te),Te}(We,he)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(We){return!!We.match(ve)})),Pe=Pe.map(function(We){return new ke(We,he)})},De.prototype.intersects=function(ee,he){if(!(ee instanceof De))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(ve){return ee.set.some(function(Pe){return Pe.every(function(We){return ve.intersects(We,he)})})})})},e.toComparators=function(ee,he){return new De(ee,he).set.map(function(de){return de.map(function(ve){return ve.value}).join(" ").trim().split(" ")})},De.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new M(ee,this.loose));for(var he=0;he<this.set.length;he++)if(we(this.set[he],ee))return!0;return!1},e.satisfies=ye,e.maxSatisfying=function(ee,he,de){var ve=null,Pe=null;try{var We=new De(he,de)}catch{return null}return ee.forEach(function(Te){We.test(Te)&&(ve&&Pe.compare(Te)!==-1||(Pe=new M(ve=Te,de)))}),ve},e.minSatisfying=function(ee,he,de){var ve=null,Pe=null;try{var We=new De(he,de)}catch{return null}return ee.forEach(function(Te){We.test(Te)&&(ve&&Pe.compare(Te)!==1||(Pe=new M(ve=Te,de)))}),ve},e.validRange=function(ee,he){try{return new De(ee,he).range||"*"}catch{return null}},e.ltr=function(ee,he,de){return Me(ee,he,"<",de)},e.gtr=function(ee,he,de){return Me(ee,he,">",de)},e.outside=Me,e.prerelease=function(ee,he){var de=j(ee,he);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(ee,he,de){return ee=new De(ee,de),he=new De(he,de),ee.intersects(he)},e.coerce=function(ee){if(ee instanceof M)return ee;if(typeof ee!="string")return null;var he=ee.match(C[N]);return he==null?null:j((he[1]||"0")+"."+(he[2]||"0")+"."+(he[3]||"0"))}}).call(this,I(1))},function(V,e){var I,t,k=V.exports={};function R(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function C(b){if(I===setTimeout)return setTimeout(b,0);if((I===R||!I)&&setTimeout)return I=setTimeout,setTimeout(b,0);try{return I(b,0)}catch{try{return I.call(null,b,0)}catch{return I.call(this,b,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:R}catch{I=R}try{t=typeof clearTimeout=="function"?clearTimeout:A}catch{t=A}})();var w,m=[],y=!1,P=-1;function E(){y&&w&&(y=!1,w.length?m=w.concat(m):P=-1,m.length&&h())}function h(){if(!y){var b=C(E);y=!0;for(var u=m.length;u;){for(w=m,m=[];++P<u;)w&&w[P].run();P=-1,u=m.length}w=null,y=!1,function(p){if(t===clearTimeout)return clearTimeout(p);if((t===A||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(p);try{t(p)}catch{try{return t.call(null,p)}catch{return t.call(this,p)}}}(b)}}function d(b,u){this.fun=b,this.array=u}function v(){}k.nextTick=function(b){var u=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)u[p-1]=arguments[p];m.push(new d(b,u)),m.length!==1||y||C(h)},d.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=v,k.addListener=v,k.once=v,k.off=v,k.removeListener=v,k.removeAllListeners=v,k.emit=v,k.prependListener=v,k.prependOnceListener=v,k.listeners=function(b){return[]},k.binding=function(b){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(b){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(te[126],ie([0,1]),function(V,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(C,w,m){this.level=C,this.key=w,this.value=m,this.forward=[]}}const k=void 0;class R{constructor(C,w=2**16){this.comparator=C,this[I]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(w)|0),this.e=new t(this.c,k,k)}get size(){return this.f}clear(){this.e=new t(this.c,k,k)}has(C){return Boolean(R.g(this,C,this.comparator))}get(C){return R.g(this,C,this.comparator)?.value}set(C,w){return R.h(this,C,w,this.comparator)&&(this.f+=1),this}delete(C){const w=R.k(this,C,this.comparator);return w&&(this.f-=1),w}forEach(C,w){let m=this.e.forward[0];for(;m;)C.call(w,m.value,m.key,this),m=m.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this.e.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this.e.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this.e.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",w=this.e.forward[0];for(;w;)C+=`node(${w.key}, ${w.value}, lvl:${w.level})`,w=w.forward[0];return C}static g(C,w,m){let y=C.e;for(let P=C.d-1;P>=0;P--)for(;y.forward[P]&&m(y.forward[P].key,w)<0;)y=y.forward[P];if(y=y.forward[0],y&&m(y.key,w)===0)return y}static h(C,w,m,y){const P=[];let E=C.e;for(let h=C.d-1;h>=0;h--){for(;E.forward[h]&&y(E.forward[h].key,w)<0;)E=E.forward[h];P[h]=E}if(E=E.forward[0],E&&y(E.key,w)===0)return E.value=m,!1;{const h=R.j(C);if(h>C.d){for(let d=C.d;d<h;d++)P[d]=C.e;C.d=h}E=new t(h,w,m);for(let d=0;d<h;d++)E.forward[d]=P[d].forward[d],P[d].forward[d]=E;return!0}}static j(C,w=.5){let m=1;for(;Math.random()<w&&m<C.c;)m+=1;return m}static k(C,w,m){const y=[];let P=C.e;for(let E=C.d-1;E>=0;E--){for(;P.forward[E]&&m(P.forward[E].key,w)<0;)P=P.forward[E];y[E]=P}if(P=P.forward[0],!P||m(P.key,w)!==0)return!1;for(let E=0;E<C.d&&y[E].forward[E]===P;E++)y[E].forward[E]=P.forward[E];for(;C.d>0&&C.e.forward[C.d-1]===k;)C.d-=1;return!0}}e.SkipList=R}),define(te[59],ie([0,1,14,2]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(f){const l=f;return l?typeof l.read=="function":!1}e.isReadable=k;function R(f){const l=f;return l?[l.on,l.pause,l.resume,l.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=R;function A(f){const l=f;return l?R(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=A;function C(f,l){return new w(f,l)}e.newWriteableStream=C;class w{constructor(l,i){this.e=l,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(i=>i(l))}h(l){this.c.error.length===0?(0,I.onUnexpectedError)(l):this.c.error.slice(0).forEach(i=>i(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,i){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(l,i){if(this.a.destroyed)return;let s;switch(l){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const n=s.indexOf(i);n>=0&&s.splice(n,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function m(f,l){const i=[];let s;for(;(s=f.read())!==null;)i.push(s);return l(i)}e.consumeReadable=m;function y(f,l,i){const s=[];let n;for(;(n=f.read())!==null&&s.length<i;)s.push(n);return n===null&&s.length>0?l(s):{read:()=>{if(s.length>0)return s.shift();if(typeof n<"u"){const a=n;return n=void 0,a}return f.read()}}}e.peekReadable=y;function P(f,l){return new Promise((i,s)=>{const n=[];E(f,{onData:a=>{l&&n.push(a)},onError:a=>{l?s(a):i(void 0)},onEnd:()=>{i(l?l(n):void 0)}})})}e.consumeStream=P;function E(f,l){let i=!1;return f.on("error",s=>{i||l.onError(s)}),f.on("end",()=>{i||l.onEnd()}),f.on("data",s=>{i||l.onData(s)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=E;function h(f,l){return new Promise((i,s)=>{const n=new t.DisposableStore,a=[],r=S=>{if(a.push(S),a.length>l)return n.dispose(),f.pause(),i({stream:f,buffer:a,ended:!1})},c=S=>s(S),o=()=>i({stream:f,buffer:a,ended:!0});n.add((0,t.toDisposable)(()=>f.removeListener("error",c))),f.on("error",c),n.add((0,t.toDisposable)(()=>f.removeListener("end",o))),f.on("end",o),n.add((0,t.toDisposable)(()=>f.removeListener("data",r))),f.on("data",r)})}e.peekStream=h;function d(f,l){const i=C(l);return i.end(f),i}e.toStream=d;function v(){const f=C(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=v;function b(f){let l=!1;return{read:()=>l?null:(l=!0,f)}}e.toReadable=b;function u(f,l,i){const s=C(i);return E(f,{onData:n=>s.write(l.data(n)),onError:n=>s.error(l.error?l.error(n):n),onEnd:()=>s.end()}),s}e.transform=u;function p(f,l,i){let s=!1;return{read:()=>{const n=l.read();return s?n:(s=!0,n!==null?i([f,n]):f)}}}e.prefixedReadable=p;function g(f,l,i){let s=!1;const n=C(i);return E(l,{onData:a=>s?n.write(a):(s=!0,n.write(i([f,a]))),onError:a=>n.error(a),onEnd:()=>{s||(s=!0,n.write(f)),n.end()}}),n}e.prefixedStream=g}),define(te[17],ie([0,1,59]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let k,R;class A{static alloc(S){return t?new A(Buffer.allocUnsafe(S)):new A(new Uint8Array(S))}static wrap(S){return t&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new A(S)}static fromString(S,D){return!(D?.dontUseNodeBuffer||!1)&&t?new A(Buffer.from(S)):(k||(k=new TextEncoder),new A(k.encode(S)))}static fromByteArray(S){const D=A.alloc(S.length);for(let L=0,N=S.length;L<N;L++)D.buffer[L]=S[L];return D}static concat(S,D){if(typeof D>"u"){D=0;for(let X=0,ae=S.length;X<ae;X++)D+=S[X].byteLength}const L=A.alloc(D);let N=0;for(let X=0,ae=S.length;X<ae;X++){const J=S[X];L.set(J,N),N+=J.byteLength}return L}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=A.alloc(this.byteLength);return S.set(this),S}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(S,D){return new A(this.buffer.subarray(S,D))}set(S,D){if(S instanceof A)this.buffer.set(S.buffer,D);else if(S instanceof Uint8Array)this.buffer.set(S,D);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),D);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return m(this.buffer,S)}writeUInt32BE(S,D){y(this.buffer,S,D)}readUInt32LE(S){return P(this.buffer,S)}writeUInt32LE(S,D){E(this.buffer,S,D)}readUInt8(S){return h(this.buffer,S)}writeUInt8(S,D){d(this.buffer,S,D)}}e.VSBuffer=A;function C(o,S){return o[S+0]<<0>>>0|o[S+1]<<8>>>0}e.readUInt16LE=C;function w(o,S,D){o[D+0]=S&255,S=S>>>8,o[D+1]=S&255}e.writeUInt16LE=w;function m(o,S){return o[S]*2**24+o[S+1]*2**16+o[S+2]*2**8+o[S+3]}e.readUInt32BE=m;function y(o,S,D){o[D+3]=S,S=S>>>8,o[D+2]=S,S=S>>>8,o[D+1]=S,S=S>>>8,o[D]=S}e.writeUInt32BE=y;function P(o,S){return o[S+0]<<0>>>0|o[S+1]<<8>>>0|o[S+2]<<16>>>0|o[S+3]<<24>>>0}e.readUInt32LE=P;function E(o,S,D){o[D+0]=S&255,S=S>>>8,o[D+1]=S&255,S=S>>>8,o[D+2]=S&255,S=S>>>8,o[D+3]=S&255}e.writeUInt32LE=E;function h(o,S){return o[S]}e.readUInt8=h;function d(o,S,D){o[D]=S}e.writeUInt8=d;function v(o){return I.consumeReadable(o,S=>A.concat(S))}e.readableToBuffer=v;function b(o){return I.toReadable(o)}e.bufferToReadable=b;function u(o){return I.consumeStream(o,S=>A.concat(S))}e.streamToBuffer=u;async function p(o){return o.ended?A.concat(o.buffer):A.concat([...o.buffer,await u(o.stream)])}e.bufferedStreamToBuffer=p;function g(o){return I.toStream(o,S=>A.concat(S))}e.bufferToStream=g;function f(o){return I.transform(o,{data:S=>typeof S=="string"?A.fromString(S):A.wrap(S)},S=>A.concat(S))}e.streamToBufferReadableStream=f;function l(o){return I.newWriteableStream(S=>A.concat(S),o)}e.newWriteableBufferStream=l;function i(o,S){return I.prefixedReadable(o,S,D=>A.concat(D))}e.prefixedBufferReadable=i;function s(o,S){return I.prefixedStream(o,S,D=>A.concat(D))}e.prefixedBufferStream=s;function n(o){let S=0,D=0,L=0;const N=new Uint8Array(Math.floor(o.length/4*3)),X=J=>{switch(D){case 3:N[L++]=S|J,D=0;break;case 2:N[L++]=S|J>>>2,S=J<<6,D=3;break;case 1:N[L++]=S|J>>>4,S=J<<4,D=2;break;default:S=J<<2,D=1}};for(let J=0;J<o.length;J++){const Y=o.charCodeAt(J);if(Y>=65&&Y<=90)X(Y-65);else if(Y>=97&&Y<=122)X(Y-97+26);else if(Y>=48&&Y<=57)X(Y-48+52);else if(Y===43||Y===45)X(62);else if(Y===47||Y===95)X(63);else{if(Y===61)break;throw new SyntaxError(`Unexpected base64 character ${o[J]}`)}}const ae=L;for(;D>0;)X(0);return A.wrap(N).slice(0,ae)}e.decodeBase64=n;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:o},S=!0,D=!1){const L=D?r:a;let N="";const X=o.byteLength%3;let ae=0;for(;ae<o.byteLength-X;ae+=3){const J=o[ae+0],Y=o[ae+1],se=o[ae+2];N+=L[J>>>2],N+=L[(J<<4|Y>>>4)&63],N+=L[(Y<<2|se>>>6)&63],N+=L[se&63]}if(X===1){const J=o[ae+0];N+=L[J>>>2],N+=L[J<<4&63],S&&(N+="==")}else if(X===2){const J=o[ae+0],Y=o[ae+1];N+=L[J>>>2],N+=L[(J<<4|Y>>>4)&63],N+=L[Y<<2&63],S&&(N+="=")}return N}e.encodeBase64=c}),define(te[12],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function I(s){return typeof s=="string"}e.isString=I;function t(s){return Array.isArray(s)&&s.every(n=>I(n))}e.isStringArray=t;function k(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=k;function R(s){const n=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof n}e.isTypedArray=R;function A(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=A;function C(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=C;function w(s){return s===!0||s===!1}e.isBoolean=w;function m(s){return typeof s>"u"}e.isUndefined=m;function y(s){return!P(s)}e.isDefined=y;function P(s){return m(s)||s===null}e.isUndefinedOrNull=P;function E(s,n){if(!s)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=E;function h(s){if(P(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=h;function d(...s){const n=[];for(let a=0;a<s.length;a++){const r=s[a];if(P(r))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);n.push(r)}return n}e.assertAllDefined=d;const v=Object.prototype.hasOwnProperty;function b(s){if(!k(s))return!1;for(const n in s)if(v.call(s,n))return!1;return!0}e.isEmptyObject=b;function u(s){return typeof s=="function"}e.isFunction=u;function p(...s){return s.length>0&&s.every(u)}e.areFunctions=p;function g(s,n){const a=Math.min(s.length,n.length);for(let r=0;r<a;r++)f(s[r],n[r])}e.validateConstraints=g;function f(s,n){if(I(n)){if(typeof s!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(u(n)){try{if(s instanceof n)return}catch{}if(!P(s)&&s.constructor===n||n.length===1&&n.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function l(s){return s===null?void 0:s}e.withNullAsUndefined=l;function i(s){return typeof s>"u"?null:s}e.withUndefinedAsNull=i}),define(te[44],ie([0,1,12]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const p=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([g,f])=>{p[g]=f&&typeof f=="object"?t(f):f}),p}e.deepClone=t;function k(u){if(!u||typeof u!="object")return u;const p=[u];for(;p.length>0;){const g=p.shift();Object.freeze(g);for(const f in g)if(R.call(g,f)){const l=g[f];typeof l=="object"&&!Object.isFrozen(l)&&!(0,I.isTypedArray)(l)&&p.push(l)}}return u}e.deepFreeze=k;const R=Object.prototype.hasOwnProperty;function A(u,p){return C(u,p,new Set)}e.cloneAndChange=A;function C(u,p,g){if((0,I.isUndefinedOrNull)(u))return u;const f=p(u);if(typeof f<"u")return f;if(Array.isArray(u)){const l=[];for(const i of u)l.push(C(i,p,g));return l}if((0,I.isObject)(u)){if(g.has(u))throw new Error("Cannot clone recursive data-structure");g.add(u);const l={};for(const i in u)R.call(u,i)&&(l[i]=C(u[i],p,g));return g.delete(u),l}return u}function w(u,p,g=!0){return(0,I.isObject)(u)?((0,I.isObject)(p)&&Object.keys(p).forEach(f=>{f in u?g&&((0,I.isObject)(u[f])&&(0,I.isObject)(p[f])?w(u[f],p[f],g):u[f]=p[f]):u[f]=p[f]}),u):p}e.mixin=w;function m(u,p){if(u===p)return!0;if(u==null||p===null||p===void 0||typeof u!=typeof p||typeof u!="object"||Array.isArray(u)!==Array.isArray(p))return!1;let g,f;if(Array.isArray(u)){if(u.length!==p.length)return!1;for(g=0;g<u.length;g++)if(!m(u[g],p[g]))return!1}else{const l=[];for(f in u)l.push(f);l.sort();const i=[];for(f in p)i.push(f);if(i.sort(),!m(l,i))return!1;for(g=0;g<l.length;g++)if(!m(u[l[g]],p[l[g]]))return!1}return!0}e.equals=m;function y(u){const p=new Set;return JSON.stringify(u,(g,f)=>{if((0,I.isObject)(f)||Array.isArray(f)){if(p.has(f))return"[Circular]";p.add(f)}return f})}e.safeStringify=y;function P(u,p){const g=Object.create(null);return!u||!p||Object.keys(p).forEach(l=>{const i=u[l],s=p[l];m(i,s)||(g[l]=s)}),g}e.distinct=P;function E(u,p){const g=p.toLowerCase(),f=Object.keys(u).find(l=>l.toLowerCase()===g);return f?u[f]:u[p]}e.getCaseInsensitive=E;function h(u,p){const g=Object.create(null);for(const[f,l]of Object.entries(u))p(f,l)&&(g[f]=l);return g}e.filter=h;function d(u){let p=[],g=Object.getPrototypeOf(u);for(;Object.prototype!==g;)p=p.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return p}e.getAllPropertyNames=d;function v(u){const p=[];for(const g of d(u))typeof u[g]=="function"&&p.push(g);return p}e.getAllMethodNames=v;function b(u,p){const g=l=>function(){const i=Array.prototype.slice.call(arguments,0);return p(l,i)},f={};for(const l of u)f[l]=g(l);return f}e.createProxyObject=b}),define(te[29],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(k){return I.test(k)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(C){for(let w=0;w<C.length;w++)C[w]=Math.floor(Math.random()*256);return C};const R=new Uint8Array(16),A=[];for(let C=0;C<256;C++)A.push(C.toString(16).padStart(2,"0"));return function(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let w=0,m="";return m+=A[R[w++]],m+=A[R[w++]],m+=A[R[w++]],m+=A[R[w++]],m+="-",m+=A[R[w++]],m+=A[R[w++]],m+="-",m+=A[R[w++]],m+=A[R[w++]],m+="-",m+=A[R[w++]],m+=A[R[w++]],m+="-",m+=A[R[w++]],m+=A[R[w++]],m+=A[R[w++]],m+=A[R[w++]],m+=A[R[w++]],m+=A[R[w++]],m}}()}),define(te[127],ie([0,1,77,40,50]),function(V,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(A,C){if(await new Promise((y,P)=>{const E=t.createReadStream(A),h=I.createHash("sha1");E.pipe(h);const d=(0,k.once)((v,b)=>{E.removeAllListeners(),h.removeAllListeners(),v?P(v):y(b)});E.once("error",d),E.once("end",d),h.once("error",d),h.once("data",v=>d(void 0,v.toString("hex")))})!==C)throw new Error("Hash mismatch")}e.checksum=R}),define(te[128],ie([0,1,25]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(A){const C=A.replace(/\-/g,":").toLowerCase();return!t.has(C)}function R(){const A=(0,I.networkInterfaces)();for(const C in A){const w=A[C];if(w){for(const{mac:m}of w)if(k(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(te[97],ie([0,1,78]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(C,w,m,y=1){let P=!1;return new Promise(E=>{const h=setTimeout(()=>{if(!P)return P=!0,E(0)},m);k(C,w,y,d=>{if(!P)return P=!0,clearTimeout(h),E(d)})})}e.findFreePort=t;function k(C,w,m,y){if(w===0)return y(0);const P=new I.Socket;P.once("connect",()=>(A(P),k(C+m,w-1,m,y))),P.once("data",()=>{}),P.once("error",E=>(A(P),E.code!=="ECONNREFUSED"?k(C+m,w-1,m,y):y(C))),P.connect(C,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(C,w,m,y="127.0.0.1"){let P=!1,E,h=1;const d=I.createServer({pauseOnConnect:!0});function v(b,u){P||(P=!0,d.removeAllListeners(),d.close(),E&&clearTimeout(E),u(b))}return new Promise(b=>{E=setTimeout(()=>{v(0,b)},m),d.on("listening",()=>{v(C,b)}),d.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&h<w?(C++,h++,d.listen(C,y)):v(0,b)}),d.on("close",()=>{v(0,b)}),d.listen(C,y)})}e.findFreePortFaster=R;function A(C){try{C.removeAllListeners("connect"),C.removeAllListeners("error"),C.end(),C.destroy(),C.unref()}catch(w){console.error(w)}}}),define(te[129],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(te[130],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class I{constructor(k,R){this.a=k,this.onMessage=R}send(k){try{this.a.send("vscode:message",k.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.Protocol=I}),define(te[41],ie([0,1,13,14]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class k{constructor(){this.a=new WeakMap}on(A,C){const w=(m,...y)=>{this.b(A,m)&&C(m,...y)};return this.a.set(C,w),I.ipcMain.on(A,w),this}once(A,C){return I.ipcMain.once(A,(w,...m)=>{this.b(A,w)&&C(w,...m)}),this}handle(A,C){return I.ipcMain.handle(A,(w,...m)=>this.b(A,w)?C(w,...m):Promise.reject(`Invalid channel '${A}' or sender for ipcMain.handle() usage.`)),this}removeHandler(A){return I.ipcMain.removeHandler(A),this}removeListener(A,C){const w=this.a.get(C);return w&&(I.ipcMain.removeListener(A,w),this.a.delete(C)),this}b(A,C){if(!A||!A.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because the channel is unknown.`),!1;const w=C.senderFrame,m=w.url;if(!m)return!0;let y="unknown";try{y=new URL(m).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because of a malformed URL '${m}'.`),!1}return y!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because of a bad origin of '${y}'.`),!1):w.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${A}' because sender of origin '${y}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new k}),define(te[131],ie([0,1,13,41,12,129]),function(V,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function A(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(w,m,y,P,E)=>{const h=C(w,P,y);h.popup({window:(0,k.withNullAsUndefined)(I.BrowserWindow.fromWebContents(w.sender)),x:E?E.x:void 0,y:E?E.y:void 0,positioningItem:E?E.positioningItem:void 0,callback:()=>{h&&w.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,m)}})})}e.registerContextMenuListener=A;function C(w,m,y){const P=new I.Menu;return y.forEach(E=>{let h;E.type==="separator"?h=new I.MenuItem({type:E.type}):Array.isArray(E.submenu)?h=new I.MenuItem({submenu:C(w,m,E.submenu),label:E.label}):h=new I.MenuItem({label:E.label,type:E.type,accelerator:E.accelerator,checked:E.checked,enabled:E.enabled,visible:E.visible,click:(d,v,b)=>w.sender.send(m,E.id,b)}),P.append(h)}),P}}),define(te[132],ie([11,10]),function(V,e){return V.create("vs/base/common/date",e)}),define(te[133],ie([0,1,132]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,k=t*60,R=k*24,A=R*7,C=R*30,w=R*365;function m(P,E,h){typeof P!="number"&&(P=P.getTime());const d=Math.round((new Date().getTime()-P)/1e3);if(d<-30)return(0,I.localize)(0,null,m(new Date().getTime()+d*1e3,!1));if(d<30)return(0,I.localize)(1,null);let v;return d<t?(v=d,E?v===1?h?(0,I.localize)(2,null,v):(0,I.localize)(3,null,v):h?(0,I.localize)(4,null,v):(0,I.localize)(5,null,v):v===1?h?(0,I.localize)(6,null,v):(0,I.localize)(7,null,v):h?(0,I.localize)(8,null,v):(0,I.localize)(9,null,v)):d<k?(v=Math.floor(d/t),E?v===1?h?(0,I.localize)(10,null,v):(0,I.localize)(11,null,v):h?(0,I.localize)(12,null,v):(0,I.localize)(13,null,v):v===1?h?(0,I.localize)(14,null,v):(0,I.localize)(15,null,v):h?(0,I.localize)(16,null,v):(0,I.localize)(17,null,v)):d<R?(v=Math.floor(d/k),E?v===1?h?(0,I.localize)(18,null,v):(0,I.localize)(19,null,v):h?(0,I.localize)(20,null,v):(0,I.localize)(21,null,v):v===1?h?(0,I.localize)(22,null,v):(0,I.localize)(23,null,v):h?(0,I.localize)(24,null,v):(0,I.localize)(25,null,v)):d<A?(v=Math.floor(d/R),E?v===1?(0,I.localize)(26,null,v):(0,I.localize)(27,null,v):v===1?(0,I.localize)(28,null,v):(0,I.localize)(29,null,v)):d<C?(v=Math.floor(d/A),E?v===1?h?(0,I.localize)(30,null,v):(0,I.localize)(31,null,v):h?(0,I.localize)(32,null,v):(0,I.localize)(33,null,v):v===1?h?(0,I.localize)(34,null,v):(0,I.localize)(35,null,v):h?(0,I.localize)(36,null,v):(0,I.localize)(37,null,v)):d<w?(v=Math.floor(d/C),E?v===1?h?(0,I.localize)(38,null,v):(0,I.localize)(39,null,v):h?(0,I.localize)(40,null,v):(0,I.localize)(41,null,v):v===1?h?(0,I.localize)(42,null,v):(0,I.localize)(43,null,v):h?(0,I.localize)(44,null,v):(0,I.localize)(45,null,v)):(v=Math.floor(d/w),E?v===1?h?(0,I.localize)(46,null,v):(0,I.localize)(47,null,v):h?(0,I.localize)(48,null,v):(0,I.localize)(49,null,v):v===1?h?(0,I.localize)(50,null,v):(0,I.localize)(51,null,v):h?(0,I.localize)(52,null,v):(0,I.localize)(53,null,v))}e.fromNow=m;function y(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=y}),define(te[134],ie([11,10]),function(V,e){return V.create("vs/base/common/errorMessage",e)}),define(te[45],ie([0,1,24,12,134]),function(V,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(P,E){return E&&(P.stack||P.stacktrace)?k.localize(0,null,C(P),A(P.stack)||A(P.stacktrace)):C(P)}function A(P){return Array.isArray(P)?P.join(`
`):P}function C(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?k.localize(1,null,P.message):P.message||k.localize(2,null)}function w(P=null,E=!1){if(!P)return k.localize(3,null);if(Array.isArray(P)){const h=I.coalesce(P),d=w(h[0],E);return h.length>1?k.localize(4,null,d,h.length):d}if(t.isString(P))return P;if(P.detail){const h=P.detail;if(h.error)return R(h.error,E);if(h.exception)return R(h.exception,E)}return P.stack?R(P,E):P.message?P.message:k.localize(5,null)}e.toErrorMessage=w;function m(P){const E=P;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=m;function y(P,E){let h;return typeof P=="string"?h=new Error(P):h=P,h.actions=E,h}e.createErrorWithActions=y}),define(te[135],ie([11,10]),function(V,e){return V.create("vs/base/common/jsonErrorMessages",e)}),define(te[136],ie([0,1,135]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function t(k){switch(k){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}e.getParseErrorMessage=t}),define(te[137],ie([11,10]),function(V,e){return V.create("vs/base/common/platform",e)}),define(te[4],ie([0,1,137]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,k=!1,R=!1,A=!1,C=!1,w=!1,m=!1,y=!1,P=!1,E=!1,h,d=e.LANGUAGE_DEFAULT,v,b;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const p=typeof u?.versions?.electron=="string",g=p&&u?.type==="renderer";if(typeof navigator=="object"&&!g)b=navigator.userAgent,t=b.indexOf("Windows")>=0,k=b.indexOf("Macintosh")>=0,y=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=b.indexOf("Linux")>=0,E=b?.indexOf("Mobi")>=0,w=!0,h=I.getConfiguredDefaultLocale(I.localize(0,null))||e.LANGUAGE_DEFAULT,d=h;else if(typeof u=="object"){t=u.platform==="win32",k=u.platform==="darwin",R=u.platform==="linux",A=R&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,m=p,P=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.LANGUAGE_DEFAULT,d=e.LANGUAGE_DEFAULT;const o=u.env.VSCODE_NLS_CONFIG;if(o)try{const S=JSON.parse(o),D=S.availableLanguages["*"];h=S.locale,d=D||e.LANGUAGE_DEFAULT,v=S._translationsConfigFile}catch{}C=!0}else console.error("Unable to resolve platform.");var f;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function l(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let i=0;k?i=1:t?i=3:R&&(i=2),e.isWindows=t,e.isMacintosh=k,e.isLinux=R,e.isLinuxSnap=A,e.isNative=C,e.isElectron=m,e.isWeb=w,e.isWebWorker=w&&typeof e.globals.importScripts=="function",e.isIOS=y,e.isMobile=E,e.isCI=P,e.platform=i,e.userAgent=b,e.language=d;var s;(function(o){function S(){return e.language}o.value=S;function D(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=D;function L(){return e.language==="en"}o.isDefault=L})(s=e.Language||(e.Language={})),e.locale=h,e.translationsConfigFile=v,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const o=[];e.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let L=0,N=o.length;L<N;L++){const X=o[L];if(X.id===D.data.vscodeScheduleAsyncWork){o.splice(L,1),X.callback();return}}});let S=0;return D=>{const L=++S;o.push({id:L,callback:D}),e.globals.postMessage({vscodeScheduleAsyncWork:L},"*")}}return o=>setTimeout(o)})();var n;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||y?2:t?1:3;let a=!0,r=!1;function c(){if(!r){r=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,a=new Uint16Array(o.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(te[33],ie([0,1,4]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.process<"u"){const k=I.globals.vscode.process;t={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return I.isWindows?"win32":I.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(te[9],ie([0,1,33]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,k=97,R=90,A=122,C=46,w=47,m=92,y=58,P=63;class E extends Error{constructor(f,l,i){let s;typeof l=="string"&&l.indexOf("not ")===0?(s="must not be",l=l.replace(/^not /,"")):s="must be";const n=f.indexOf(".")!==-1?"property":"argument";let a=`The "${f}" ${n} ${s} of type ${l}`;a+=`. Received type ${typeof i}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function h(g,f){if(typeof g!="string")throw new E(f,"string",g)}function d(g){return g===w||g===m}function v(g){return g===w}function b(g){return g>=t&&g<=R||g>=k&&g<=A}function u(g,f,l,i){let s="",n=0,a=-1,r=0,c=0;for(let o=0;o<=g.length;++o){if(o<g.length)c=g.charCodeAt(o);else{if(i(c))break;c=w}if(i(c)){if(!(a===o-1||r===1))if(r===2){if(s.length<2||n!==2||s.charCodeAt(s.length-1)!==C||s.charCodeAt(s.length-2)!==C){if(s.length>2){const S=s.lastIndexOf(l);S===-1?(s="",n=0):(s=s.slice(0,S),n=s.length-1-s.lastIndexOf(l)),a=o,r=0;continue}else if(s.length!==0){s="",n=0,a=o,r=0;continue}}f&&(s+=s.length>0?`${l}..`:"..",n=2)}else s.length>0?s+=`${l}${g.slice(a+1,o)}`:s=g.slice(a+1,o),n=o-a-1;a=o,r=0}else c===C&&r!==-1?++r:r=-1}return s}function p(g,f){if(f===null||typeof f!="object")throw new E("pathObject","Object",f);const l=f.dir||f.root,i=f.base||`${f.name||""}${f.ext||""}`;return l?l===f.root?`${l}${i}`:`${l}${g}${i}`:i}e.win32={resolve(...g){let f="",l="",i=!1;for(let s=g.length-1;s>=-1;s--){let n;if(s>=0){if(n=g[s],h(n,"path"),n.length===0)continue}else f.length===0?n=I.cwd():(n=I.env[`=${f}`]||I.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==f.toLowerCase()&&n.charCodeAt(2)===m)&&(n=`${f}\\`));const a=n.length;let r=0,c="",o=!1;const S=n.charCodeAt(0);if(a===1)d(S)&&(r=1,o=!0);else if(d(S))if(o=!0,d(n.charCodeAt(1))){let D=2,L=D;for(;D<a&&!d(n.charCodeAt(D));)D++;if(D<a&&D!==L){const N=n.slice(L,D);for(L=D;D<a&&d(n.charCodeAt(D));)D++;if(D<a&&D!==L){for(L=D;D<a&&!d(n.charCodeAt(D));)D++;(D===a||D!==L)&&(c=`\\\\${N}\\${n.slice(L,D)}`,r=D)}}}else r=1;else b(S)&&n.charCodeAt(1)===y&&(c=n.slice(0,2),r=2,a>2&&d(n.charCodeAt(2))&&(o=!0,r=3));if(c.length>0)if(f.length>0){if(c.toLowerCase()!==f.toLowerCase())continue}else f=c;if(i){if(f.length>0)break}else if(l=`${n.slice(r)}\\${l}`,i=o,o&&f.length>0)break}return l=u(l,!i,"\\",d),i?`${f}\\${l}`:`${f}${l}`||"."},normalize(g){h(g,"path");const f=g.length;if(f===0)return".";let l=0,i,s=!1;const n=g.charCodeAt(0);if(f===1)return v(n)?"\\":g;if(d(n))if(s=!0,d(g.charCodeAt(1))){let r=2,c=r;for(;r<f&&!d(g.charCodeAt(r));)r++;if(r<f&&r!==c){const o=g.slice(c,r);for(c=r;r<f&&d(g.charCodeAt(r));)r++;if(r<f&&r!==c){for(c=r;r<f&&!d(g.charCodeAt(r));)r++;if(r===f)return`\\\\${o}\\${g.slice(c)}\\`;r!==c&&(i=`\\\\${o}\\${g.slice(c,r)}`,l=r)}}}else l=1;else b(n)&&g.charCodeAt(1)===y&&(i=g.slice(0,2),l=2,f>2&&d(g.charCodeAt(2))&&(s=!0,l=3));let a=l<f?u(g.slice(l),!s,"\\",d):"";return a.length===0&&!s&&(a="."),a.length>0&&d(g.charCodeAt(f-1))&&(a+="\\"),i===void 0?s?`\\${a}`:a:s?`${i}\\${a}`:`${i}${a}`},isAbsolute(g){h(g,"path");const f=g.length;if(f===0)return!1;const l=g.charCodeAt(0);return d(l)||f>2&&b(l)&&g.charCodeAt(1)===y&&d(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let f,l;for(let n=0;n<g.length;++n){const a=g[n];h(a,"path"),a.length>0&&(f===void 0?f=l=a:f+=`\\${a}`)}if(f===void 0)return".";let i=!0,s=0;if(typeof l=="string"&&d(l.charCodeAt(0))){++s;const n=l.length;n>1&&d(l.charCodeAt(1))&&(++s,n>2&&(d(l.charCodeAt(2))?++s:i=!1))}if(i){for(;s<f.length&&d(f.charCodeAt(s));)s++;s>=2&&(f=`\\${f.slice(s)}`)}return e.win32.normalize(f)},relative(g,f){if(h(g,"from"),h(f,"to"),g===f)return"";const l=e.win32.resolve(g),i=e.win32.resolve(f);if(l===i||(g=l.toLowerCase(),f=i.toLowerCase(),g===f))return"";let s=0;for(;s<g.length&&g.charCodeAt(s)===m;)s++;let n=g.length;for(;n-1>s&&g.charCodeAt(n-1)===m;)n--;const a=n-s;let r=0;for(;r<f.length&&f.charCodeAt(r)===m;)r++;let c=f.length;for(;c-1>r&&f.charCodeAt(c-1)===m;)c--;const o=c-r,S=a<o?a:o;let D=-1,L=0;for(;L<S;L++){const X=g.charCodeAt(s+L);if(X!==f.charCodeAt(r+L))break;X===m&&(D=L)}if(L!==S){if(D===-1)return i}else{if(o>S){if(f.charCodeAt(r+L)===m)return i.slice(r+L+1);if(L===2)return i.slice(r+L)}a>S&&(g.charCodeAt(s+L)===m?D=L:L===2&&(D=3)),D===-1&&(D=0)}let N="";for(L=s+D+1;L<=n;++L)(L===n||g.charCodeAt(L)===m)&&(N+=N.length===0?"..":"\\..");return r+=D,N.length>0?`${N}${i.slice(r,c)}`:(i.charCodeAt(r)===m&&++r,i.slice(r,c))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const f=e.win32.resolve(g);if(f.length<=2)return g;if(f.charCodeAt(0)===m){if(f.charCodeAt(1)===m){const l=f.charCodeAt(2);if(l!==P&&l!==C)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(b(f.charCodeAt(0))&&f.charCodeAt(1)===y&&f.charCodeAt(2)===m)return`\\\\?\\${f}`;return g},dirname(g){h(g,"path");const f=g.length;if(f===0)return".";let l=-1,i=0;const s=g.charCodeAt(0);if(f===1)return d(s)?g:".";if(d(s)){if(l=i=1,d(g.charCodeAt(1))){let r=2,c=r;for(;r<f&&!d(g.charCodeAt(r));)r++;if(r<f&&r!==c){for(c=r;r<f&&d(g.charCodeAt(r));)r++;if(r<f&&r!==c){for(c=r;r<f&&!d(g.charCodeAt(r));)r++;if(r===f)return g;r!==c&&(l=i=r+1)}}}}else b(s)&&g.charCodeAt(1)===y&&(l=f>2&&d(g.charCodeAt(2))?3:2,i=l);let n=-1,a=!0;for(let r=f-1;r>=i;--r)if(d(g.charCodeAt(r))){if(!a){n=r;break}}else a=!1;if(n===-1){if(l===-1)return".";n=l}return g.slice(0,n)},basename(g,f){f!==void 0&&h(f,"ext"),h(g,"path");let l=0,i=-1,s=!0,n;if(g.length>=2&&b(g.charCodeAt(0))&&g.charCodeAt(1)===y&&(l=2),f!==void 0&&f.length>0&&f.length<=g.length){if(f===g)return"";let a=f.length-1,r=-1;for(n=g.length-1;n>=l;--n){const c=g.charCodeAt(n);if(d(c)){if(!s){l=n+1;break}}else r===-1&&(s=!1,r=n+1),a>=0&&(c===f.charCodeAt(a)?--a===-1&&(i=n):(a=-1,i=r))}return l===i?i=r:i===-1&&(i=g.length),g.slice(l,i)}for(n=g.length-1;n>=l;--n)if(d(g.charCodeAt(n))){if(!s){l=n+1;break}}else i===-1&&(s=!1,i=n+1);return i===-1?"":g.slice(l,i)},extname(g){h(g,"path");let f=0,l=-1,i=0,s=-1,n=!0,a=0;g.length>=2&&g.charCodeAt(1)===y&&b(g.charCodeAt(0))&&(f=i=2);for(let r=g.length-1;r>=f;--r){const c=g.charCodeAt(r);if(d(c)){if(!n){i=r+1;break}continue}s===-1&&(n=!1,s=r+1),c===C?l===-1?l=r:a!==1&&(a=1):l!==-1&&(a=-1)}return l===-1||s===-1||a===0||a===1&&l===s-1&&l===i+1?"":g.slice(l,s)},format:p.bind(null,"\\"),parse(g){h(g,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return f;const l=g.length;let i=0,s=g.charCodeAt(0);if(l===1)return d(s)?(f.root=f.dir=g,f):(f.base=f.name=g,f);if(d(s)){if(i=1,d(g.charCodeAt(1))){let D=2,L=D;for(;D<l&&!d(g.charCodeAt(D));)D++;if(D<l&&D!==L){for(L=D;D<l&&d(g.charCodeAt(D));)D++;if(D<l&&D!==L){for(L=D;D<l&&!d(g.charCodeAt(D));)D++;D===l?i=D:D!==L&&(i=D+1)}}}}else if(b(s)&&g.charCodeAt(1)===y){if(l<=2)return f.root=f.dir=g,f;if(i=2,d(g.charCodeAt(2))){if(l===3)return f.root=f.dir=g,f;i=3}}i>0&&(f.root=g.slice(0,i));let n=-1,a=i,r=-1,c=!0,o=g.length-1,S=0;for(;o>=i;--o){if(s=g.charCodeAt(o),d(s)){if(!c){a=o+1;break}continue}r===-1&&(c=!1,r=o+1),s===C?n===-1?n=o:S!==1&&(S=1):n!==-1&&(S=-1)}return r!==-1&&(n===-1||S===0||S===1&&n===r-1&&n===a+1?f.base=f.name=g.slice(a,r):(f.name=g.slice(a,n),f.base=g.slice(a,r),f.ext=g.slice(n,r))),a>0&&a!==i?f.dir=g.slice(0,a-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let f="",l=!1;for(let i=g.length-1;i>=-1&&!l;i--){const s=i>=0?g[i]:I.cwd();h(s,"path"),s.length!==0&&(f=`${s}/${f}`,l=s.charCodeAt(0)===w)}return f=u(f,!l,"/",v),l?`/${f}`:f.length>0?f:"."},normalize(g){if(h(g,"path"),g.length===0)return".";const f=g.charCodeAt(0)===w,l=g.charCodeAt(g.length-1)===w;return g=u(g,!f,"/",v),g.length===0?f?"/":l?"./":".":(l&&(g+="/"),f?`/${g}`:g)},isAbsolute(g){return h(g,"path"),g.length>0&&g.charCodeAt(0)===w},join(...g){if(g.length===0)return".";let f;for(let l=0;l<g.length;++l){const i=g[l];h(i,"path"),i.length>0&&(f===void 0?f=i:f+=`/${i}`)}return f===void 0?".":e.posix.normalize(f)},relative(g,f){if(h(g,"from"),h(f,"to"),g===f||(g=e.posix.resolve(g),f=e.posix.resolve(f),g===f))return"";const l=1,i=g.length,s=i-l,n=1,a=f.length-n,r=s<a?s:a;let c=-1,o=0;for(;o<r;o++){const D=g.charCodeAt(l+o);if(D!==f.charCodeAt(n+o))break;D===w&&(c=o)}if(o===r)if(a>r){if(f.charCodeAt(n+o)===w)return f.slice(n+o+1);if(o===0)return f.slice(n+o)}else s>r&&(g.charCodeAt(l+o)===w?c=o:o===0&&(c=0));let S="";for(o=l+c+1;o<=i;++o)(o===i||g.charCodeAt(o)===w)&&(S+=S.length===0?"..":"/..");return`${S}${f.slice(n+c)}`},toNamespacedPath(g){return g},dirname(g){if(h(g,"path"),g.length===0)return".";const f=g.charCodeAt(0)===w;let l=-1,i=!0;for(let s=g.length-1;s>=1;--s)if(g.charCodeAt(s)===w){if(!i){l=s;break}}else i=!1;return l===-1?f?"/":".":f&&l===1?"//":g.slice(0,l)},basename(g,f){f!==void 0&&h(f,"ext"),h(g,"path");let l=0,i=-1,s=!0,n;if(f!==void 0&&f.length>0&&f.length<=g.length){if(f===g)return"";let a=f.length-1,r=-1;for(n=g.length-1;n>=0;--n){const c=g.charCodeAt(n);if(c===w){if(!s){l=n+1;break}}else r===-1&&(s=!1,r=n+1),a>=0&&(c===f.charCodeAt(a)?--a===-1&&(i=n):(a=-1,i=r))}return l===i?i=r:i===-1&&(i=g.length),g.slice(l,i)}for(n=g.length-1;n>=0;--n)if(g.charCodeAt(n)===w){if(!s){l=n+1;break}}else i===-1&&(s=!1,i=n+1);return i===-1?"":g.slice(l,i)},extname(g){h(g,"path");let f=-1,l=0,i=-1,s=!0,n=0;for(let a=g.length-1;a>=0;--a){const r=g.charCodeAt(a);if(r===w){if(!s){l=a+1;break}continue}i===-1&&(s=!1,i=a+1),r===C?f===-1?f=a:n!==1&&(n=1):f!==-1&&(n=-1)}return f===-1||i===-1||n===0||n===1&&f===i-1&&f===l+1?"":g.slice(f,i)},format:p.bind(null,"/"),parse(g){h(g,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return f;const l=g.charCodeAt(0)===w;let i;l?(f.root="/",i=1):i=0;let s=-1,n=0,a=-1,r=!0,c=g.length-1,o=0;for(;c>=i;--c){const S=g.charCodeAt(c);if(S===w){if(!r){n=c+1;break}continue}a===-1&&(r=!1,a=c+1),S===C?s===-1?s=c:o!==1&&(o=1):s!==-1&&(o=-1)}if(a!==-1){const S=n===0&&l?1:n;s===-1||o===0||o===1&&s===a-1&&s===n+1?f.base=f.name=g.slice(S,a):(f.name=g.slice(S,s),f.base=g.slice(S,a),f.ext=g.slice(s,a))}return n>0?f.dir=g.slice(0,n-1):l&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=I.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=I.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=I.platform==="win32"?e.win32.join:e.posix.join,e.resolve=I.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=I.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=I.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=I.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=I.platform==="win32"?e.win32.extname:e.posix.extname,e.format=I.platform==="win32"?e.win32.format:e.posix.format,e.parse=I.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=I.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=I.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=I.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[79],ie([0,1,4]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var k;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(C,...w){const m=w.reduce((E,h)=>(E[h]=!0,E),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(E=>!m[E]).forEach(E=>{for(let h=0;h<y.length;h++)if(E.search(y[h])!==-1){delete C[E];break}})}e.sanitizeProcessEnvironment=R;function A(C){!C||(delete C.DEBUG,I.isMacintosh&&delete C.DYLD_LIBRARY_PATH,I.isLinux&&delete C.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),define(te[80],ie([0,1,4]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=I.globals.performance&&typeof I.globals.performance.now=="function";class k{static create(A=!0){return new k(A)}constructor(A){this.a=t&&A,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?I.globals.performance.now():Date.now()}}e.StopWatch=k}),define(te[3],ie([0,1,14,50,2,96,80]),function(V,e,I,t,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const C=!1,w=!1;var m;(function(c){c.None=()=>k.Disposable.None;function o(U){if(w){const{onDidAddListener:H}=U,x=d.create();let B=0;U.onDidAddListener=()=>{++B===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),x.print()),H?.()}}}function S(U,H){return re(U,()=>{},0,void 0,void 0,H)}c.defer=S;function D(U){return(H,x=null,B)=>{let _=!1,Z;return Z=U(oe=>{if(!_)return Z?Z.dispose():_=!0,H.call(x,oe)},null,B),_&&Z.dispose(),Z}}c.once=D;function L(U,H,x){return se((B,_=null,Z)=>U(oe=>B.call(_,H(oe)),null,Z),x)}c.map=L;function N(U,H,x){return se((B,_=null,Z)=>U(oe=>{H(oe),B.call(_,oe)},null,Z),x)}c.forEach=N;function X(U,H,x){return se((B,_=null,Z)=>U(oe=>H(oe)&&B.call(_,oe),null,Z),x)}c.filter=X;function ae(U){return U}c.signal=ae;function J(...U){return(H,x=null,B)=>(0,k.combinedDisposable)(...U.map(_=>_(Z=>H.call(x,Z),null,B)))}c.any=J;function Y(U,H,x,B){let _=x;return L(U,Z=>(_=H(_,Z),_),B)}c.reduce=Y;function se(U,H){let x;const B={onWillAddFirstListener(){x=U(_.fire,_)},onDidRemoveLastListener(){x?.dispose()}};H||o(B);const _=new b(B);return H?.add(_),_.event}function re(U,H,x=100,B=!1,_,Z){let oe,ge,ke,Oe=0;const De={leakWarningThreshold:_,onWillAddFirstListener(){oe=U(be=>{Oe++,ge=H(ge,be),B&&!ke&&(Le.fire(ge),ge=void 0),clearTimeout(ke),ke=setTimeout(()=>{const we=ge;ge=void 0,ke=void 0,(!B||Oe>1)&&Le.fire(we),Oe=0},x)})},onDidRemoveLastListener(){oe.dispose()}};Z||o(De);const Le=new b(De);return Z?.add(Le),Le.event}c.debounce=re;function fe(U,H=0,x){return c.debounce(U,(B,_)=>B?(B.push(_),B):[_],H,void 0,void 0,x)}c.accumulate=fe;function K(U,H=(B,_)=>B===_,x){let B=!0,_;return X(U,Z=>{const oe=B||!H(Z,_);return B=!1,_=Z,oe},x)}c.latch=K;function le(U,H,x){return[c.filter(U,H,x),c.filter(U,B=>!H(B),x)]}c.split=le;function $(U,H=!1,x=[]){let B=x.slice(),_=U(ge=>{B?B.push(ge):oe.fire(ge)});const Z=()=>{B?.forEach(ge=>oe.fire(ge)),B=null},oe=new b({onWillAddFirstListener(){_||(_=U(ge=>oe.fire(ge)))},onDidAddFirstListener(){B&&(H?setTimeout(Z):Z())},onDidRemoveLastListener(){_&&_.dispose(),_=null}});return oe.event}c.buffer=$;class W{constructor(H){this.event=H,this.c=new k.DisposableStore}map(H){return new W(L(this.event,H,this.c))}forEach(H){return new W(N(this.event,H,this.c))}filter(H){return new W(X(this.event,H,this.c))}reduce(H,x){return new W(Y(this.event,H,x,this.c))}latch(){return new W(K(this.event,void 0,this.c))}debounce(H,x=100,B=!1,_){return new W(re(this.event,H,x,B,_,this.c))}on(H,x,B){return this.event(H,x,B)}once(H,x,B){return D(this.event)(H,x,B)}dispose(){this.c.dispose()}}function T(U){return new W(U)}c.chain=T;function z(U,H,x=B=>B){const B=(...ge)=>oe.fire(x(...ge)),_=()=>U.on(H,B),Z=()=>U.removeListener(H,B),oe=new b({onWillAddFirstListener:_,onDidRemoveLastListener:Z});return oe.event}c.fromNodeEventEmitter=z;function Q(U,H,x=B=>B){const B=(...ge)=>oe.fire(x(...ge)),_=()=>U.addEventListener(H,B),Z=()=>U.removeEventListener(H,B),oe=new b({onWillAddFirstListener:_,onDidRemoveLastListener:Z});return oe.event}c.fromDOMEventEmitter=Q;function q(U){return new Promise(H=>D(U)(H))}c.toPromise=q;function j(U,H){return H(void 0),U(x=>H(x))}c.runAndSubscribe=j;function M(U,H){let x=null;function B(Z){x?.dispose(),x=new k.DisposableStore,H(Z,x)}B(void 0);const _=U(Z=>B(Z));return(0,k.toDisposable)(()=>{_.dispose(),x?.dispose()})}c.runAndSubscribeWithStore=M;class O{constructor(H,x){this.obs=H,this.c=0,this.d=!1;const B={onWillAddFirstListener:()=>{H.addObserver(this)},onDidRemoveLastListener:()=>{H.removeObserver(this)}};x||o(B),this.emitter=new b(B),x&&x.add(this.emitter)}beginUpdate(H){this.c++}handleChange(H,x){this.d=!0}endUpdate(H){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function F(U,H){return new O(U,H).emitter.event}c.fromObservable=F})(m=e.Event||(e.Event={}));class y{constructor(o){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${o}_${y.c++}`,y.all.add(this)}start(o){this.d=new A.StopWatch(!0),this.listenerCount=o}stop(){if(this.d){const o=this.d.elapsed();this.durations.push(o),this.elapsedOverall+=o,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=y,y.all=new Set,y.c=0;let P=-1;function E(c){const o=P;return P=c,{dispose(){P=o}}}e.setGlobalLeakWarningThreshold=E;class h{constructor(o,S=Math.random().toString(18).slice(2,5)){this.threshold=o,this.name=S,this.d=0}dispose(){this.c?.clear()}check(o,S){const D=this.threshold;if(D<=0||S<D)return;this.c||(this.c=new Map);const L=this.c.get(o.value)||0;if(this.c.set(o.value,L+1),this.d-=1,this.d<=0){this.d=D*.5;let N,X=0;for(const[ae,J]of this.c)(!N||X<J)&&(N=ae,X=J);console.warn(`[${this.name}] potential listener LEAK detected, having ${S} listeners already. MOST frequent listener (${X}):`),console.warn(N)}return()=>{const N=this.c.get(o.value)||0;this.c.set(o.value,N-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(o){this.value=o}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v{constructor(o,S,D){this.callback=o,this.callbackThis=S,this.stack=D,this.subscription=new k.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class b{constructor(o){this.j=!1,this.d=o,this.f=P>0||this.d?.leakWarningThreshold?new h(this.d?.leakWarningThreshold??P):void 0,this.g=this.d?._profName?new y(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(C){const o=Array.from(this.q);queueMicrotask(()=>{for(const S of o)S.subscription.isset()&&(S.subscription.unset(),S.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(o,S,D)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),k.Disposable.None;const L=this.q.isEmpty();L&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let N,X;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(X=d.create(),N=this.f.check(X,this.q.size+1)),C&&(X=X??d.create());const ae=new v(o,S,X),J=this.q.push(ae);L&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,o,S);const Y=ae.subscription.set(()=>{N?.(),this.j||(J(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return D instanceof k.DisposableStore?D.add(Y):Array.isArray(D)&&D.push(Y),Y}),this.l}fire(o){if(this.q){this.m||(this.m=new p);for(const S of this.q)this.m.push(this,S,o);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=b;class u{constructor(){this.c=new R.LinkedList}get size(){return this.c.size}push(o,S,D){this.c.push(new g(o,S,D))}clear(o){const S=new R.LinkedList;for(const D of this.c)D.emitter!==o&&S.push(D);this.c=S}deliver(){for(;this.c.size>0;){const o=this.c.shift();try{o.listener.invoke(o.event)}catch(S){(0,I.onUnexpectedError)(S)}}}}e.EventDeliveryQueue=u;class p extends u{clear(o){this.c.clear()}}class g{constructor(o,S,D){this.emitter=o,this.listener=S,this.event=D}}class f extends b{async fireAsync(o,S,D){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const L of this.q)this.c.push([L,o]);for(;this.c.size>0&&!S.isCancellationRequested;){const[L,N]=this.c.shift(),X=[],ae={...N,token:S,waitUntil:J=>{if(Object.isFrozen(X))throw new Error("waitUntil can NOT be called asynchronous");D&&(J=D(J,L.callback)),X.push(J)}};try{L.invoke(ae)}catch(J){(0,I.onUnexpectedError)(J);continue}Object.freeze(X),await Promise.allSettled(X).then(J=>{for(const Y of J)Y.status==="rejected"&&(0,I.onUnexpectedError)(Y.reason)})}}}}e.AsyncEmitter=f;class l extends b{constructor(o){super(o),this.h=0,this.s=new R.LinkedList,this.t=o?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const o=Array.from(this.s);this.s.clear(),super.fire(this.t(o))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(o){this.q&&(this.h!==0?this.s.push(o):super.fire(o))}}e.PauseableEmitter=l;class i extends l{constructor(o){super(o),this.c=o.delay??100}fire(o){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(o)}}e.DebounceEmitter=i;class s extends b{constructor(o){super(o),this.c=[],this.h=o?.merge}fire(o){!this.hasListeners()||(this.c.push(o),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(S=>super.fire(S)),this.c=[]}))}}e.MicrotaskEmitter=s;class n{constructor(){this.d=!1,this.f=[],this.c=new b({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(o){const S={event:o,listener:null};this.f.push(S),this.d&&this.j(S);const D=()=>{this.d&&this.k(S);const L=this.f.indexOf(S);this.f.splice(L,1)};return(0,k.toDisposable)((0,t.once)(D))}g(){this.d=!0,this.f.forEach(o=>this.j(o))}h(){this.d=!1,this.f.forEach(o=>this.k(o))}j(o){o.listener=o.event(S=>this.c.fire(S))}k(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=n;class a{constructor(){this.c=[]}wrapEvent(o){return(S,D,L)=>o(N=>{const X=this.c[this.c.length-1];X?X.push(()=>S.call(D,N)):S.call(D,N)},void 0,L)}bufferEvents(o){const S=[];this.c.push(S);const D=o();return this.c.pop(),S.forEach(L=>L()),D}}e.EventBufferer=a;class r{constructor(){this.c=!1,this.d=m.None,this.f=k.Disposable.None,this.g=new b({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(o){this.d=o,this.c&&(this.f.dispose(),this.f=o(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=r}),define(te[22],ie([0,1,3]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(C,w){const m=setTimeout(C.bind(w),0);return{dispose(){clearTimeout(m)}}});var k;(function(C){function w(m){return m===C.None||m===C.Cancelled||m instanceof R?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}C.isCancellationToken=w,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(k=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new I.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(w){this.a=void 0,this.b=void 0,this.b=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=k.Cancelled}dispose(w=!1){w&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=k.None}}e.CancellationTokenSource=A}),define(te[138],ie([0,1,22]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(C){this.b=C,this.a=null}get(){if(this.a)return this.a;const C=new I.CancellationTokenSource,w=this.b(C.token);return this.a={promise:w,dispose:()=>{this.a=null,C.cancel(),C.dispose()}},this.a}}e.Cache=t;class k{constructor(C){this.c=C,this.a=void 0,this.b=void 0}get(C){const w=JSON.stringify(C);return this.b!==w&&(this.b=w,this.a=this.c(C)),this.a}}e.LRUCachedFunction=k;class R{get cachedValues(){return this.a}constructor(C){this.b=C,this.a=new Map}get(C){if(this.a.has(C))return this.a.get(C);const w=this.b(C);return this.a.set(C,w),w}}e.CachedFunction=R}),define(te[26],ie([0,1,138,125]),function(V,e,I,t){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=R;const A=/{(\d+)}/g;function C(G,...ce){return ce.length===0?G:G.replace(A,function(ue,me){const Se=parseInt(me,10);return isNaN(Se)||Se<0||Se>=ce.length?ue:ce[Se]})}e.format=C;const w=/{([^}]+)}/g;function m(G,ce){return G.replace(w,(ue,me)=>ce[me]??ue)}e.format2=m;function y(G){return G.replace(/[<>&]/g,function(ce){switch(ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ce}})}e.escape=y;function P(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function E(G,ce){let ue=0;const me=ce.charCodeAt(0);for(let Se=G.length-1;Se>=0;Se--)G.charCodeAt(Se)===me&&ue++;return ue}e.count=E;function h(G,ce,ue="\u2026"){return G.length<=ce?G:`${G.substr(0,ce)}${ue}`}e.truncate=h;function d(G,ce=" "){const ue=v(G,ce);return b(ue,ce)}e.trim=d;function v(G,ce){if(!G||!ce)return G;const ue=ce.length;if(ue===0||G.length===0)return G;let me=0;for(;G.indexOf(ce,me)===me;)me=me+ue;return G.substring(me)}e.ltrim=v;function b(G,ce){if(!G||!ce)return G;const ue=ce.length,me=G.length;if(ue===0||me===0)return G;let Se=me,Ae=-1;for(;Ae=G.lastIndexOf(ce,Se-1),!(Ae===-1||Ae+ue!==Se);){if(Ae===0)return"";Se=Ae}return G.substring(0,Se)}e.rtrim=b;function u(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=u;function p(G){return G.replace(/\*/g,"")}e.stripWildcards=p;function g(G,ce,ue={}){if(!G)throw new Error("Cannot create regex from empty string");ce||(G=P(G)),ue.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let me="";return ue.global&&(me+="g"),ue.matchCase||(me+="i"),ue.multiline&&(me+="m"),ue.unicode&&(me+="u"),new RegExp(G,me)}e.createRegExp=g;function f(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function l(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function i(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=i;function s(G){return G.split(/\r\n|\r|\n/)}e.splitLines=s;function n(G){for(let ce=0,ue=G.length;ce<ue;ce++){const me=G.charCodeAt(ce);if(me!==32&&me!==9)return ce}return-1}e.firstNonWhitespaceIndex=n;function a(G,ce=0,ue=G.length){for(let me=ce;me<ue;me++){const Se=G.charCodeAt(me);if(Se!==32&&Se!==9)return G.substring(ce,me)}return G.substring(ce,ue)}e.getLeadingWhitespace=a;function r(G,ce=G.length-1){for(let ue=ce;ue>=0;ue--){const me=G.charCodeAt(ue);if(me!==32&&me!==9)return ue}return-1}e.lastNonWhitespaceIndex=r;function c(G,ce,ue){const me=[];let Se=0;for(const Ae of G.matchAll(ce)){if(me.push(G.slice(Se,Ae.index)),Ae.index===void 0)throw new Error("match.index should be defined");Se=Ae.index+Ae[0].length,me.push(ue(Ae[0],...Ae.slice(1),Ae.index,G,Ae.groups))}return me.push(G.slice(Se)),Promise.all(me).then(Ae=>Ae.join(""))}e.replaceAsync=c;function o(G,ce){return G<ce?-1:G>ce?1:0}e.compare=o;function S(G,ce,ue=0,me=G.length,Se=0,Ae=ce.length){for(;ue<me&&Se<Ae;ue++,Se++){const xe=G.charCodeAt(ue),He=ce.charCodeAt(Se);if(xe<He)return-1;if(xe>He)return 1}const Be=me-ue,it=Ae-Se;return Be<it?-1:Be>it?1:0}e.compareSubstring=S;function D(G,ce){return L(G,ce,0,G.length,0,ce.length)}e.compareIgnoreCase=D;function L(G,ce,ue=0,me=G.length,Se=0,Ae=ce.length){for(;ue<me&&Se<Ae;ue++,Se++){let xe=G.charCodeAt(ue),He=ce.charCodeAt(Se);if(xe===He)continue;if(xe>=128||He>=128)return S(G.toLowerCase(),ce.toLowerCase(),ue,me,Se,Ae);X(xe)&&(xe-=32),X(He)&&(He-=32);const tt=xe-He;if(tt!==0)return tt}const Be=me-ue,it=Ae-Se;return Be<it?-1:Be>it?1:0}e.compareSubstringIgnoreCase=L;function N(G){return G>=48&&G<=57}e.isAsciiDigit=N;function X(G){return G>=97&&G<=122}e.isLowerAsciiLetter=X;function ae(G){return G>=65&&G<=90}e.isUpperAsciiLetter=ae;function J(G,ce){return G.length===ce.length&&L(G,ce)===0}e.equalsIgnoreCase=J;function Y(G,ce){const ue=ce.length;return ce.length>G.length?!1:L(G,ce,0,ue)===0}e.startsWithIgnoreCase=Y;function se(G,ce){const ue=Math.min(G.length,ce.length);let me;for(me=0;me<ue;me++)if(G.charCodeAt(me)!==ce.charCodeAt(me))return me;return ue}e.commonPrefixLength=se;function re(G,ce){const ue=Math.min(G.length,ce.length);let me;const Se=G.length-1,Ae=ce.length-1;for(me=0;me<ue;me++)if(G.charCodeAt(Se-me)!==ce.charCodeAt(Ae-me))return me;return ue}e.commonSuffixLength=re;function fe(G){return 55296<=G&&G<=56319}e.isHighSurrogate=fe;function K(G){return 56320<=G&&G<=57343}e.isLowSurrogate=K;function le(G,ce){return(G-55296<<10)+(ce-56320)+65536}e.computeCodePoint=le;function $(G,ce,ue){const me=G.charCodeAt(ue);if(fe(me)&&ue+1<ce){const Se=G.charCodeAt(ue+1);if(K(Se))return le(me,Se)}return me}e.getNextCodePoint=$;function W(G,ce){const ue=G.charCodeAt(ce-1);if(K(ue)&&ce>1){const me=G.charCodeAt(ce-2);if(fe(me))return le(me,ue)}return ue}class T{get offset(){return this.e}constructor(ce,ue=0){this.c=ce,this.d=ce.length,this.e=ue}setOffset(ce){this.e=ce}prevCodePoint(){const ce=W(this.c,this.e);return this.e-=ce>=65536?2:1,ce}nextCodePoint(){const ce=$(this.c,this.d,this.e);return this.e+=ce>=65536?2:1,ce}eol(){return this.e>=this.d}}e.CodePointIterator=T;class z{get offset(){return this.c.offset}constructor(ce,ue=0){this.c=new T(ce,ue)}nextGraphemeLength(){const ce=We.getInstance(),ue=this.c,me=ue.offset;let Se=ce.getGraphemeBreakType(ue.nextCodePoint());for(;!ue.eol();){const Ae=ue.offset,Be=ce.getGraphemeBreakType(ue.nextCodePoint());if(ve(Se,Be)){ue.setOffset(Ae);break}Se=Be}return ue.offset-me}prevGraphemeLength(){const ce=We.getInstance(),ue=this.c,me=ue.offset;let Se=ce.getGraphemeBreakType(ue.prevCodePoint());for(;ue.offset>0;){const Ae=ue.offset,Be=ce.getGraphemeBreakType(ue.prevCodePoint());if(ve(Be,Se)){ue.setOffset(Ae);break}Se=Be}return me-ue.offset}eol(){return this.c.eol()}}e.GraphemeIterator=z;function Q(G,ce){return new z(G,ce).nextGraphemeLength()}e.nextCharLength=Q;function q(G,ce){return new z(G,ce).prevGraphemeLength()}e.prevCharLength=q;function j(G,ce){ce>0&&K(G.charCodeAt(ce))&&ce--;const ue=ce+Q(G,ce);return[ue-q(G,ue),ue]}e.getCharContainingOffset=j;function M(G){const ce=new z(G);let ue=0;for(;!ce.eol();)ue++,ce.nextGraphemeLength();return ue}e.charCount=M;let O;function F(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(G){return O||(O=F()),O.test(G)}e.containsRTL=U;const H=/^[\t\n\r\x20-\x7E]*$/;function x(G){return H.test(G)}e.isBasicASCII=x,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function B(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=B;function _(G){return G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=_;function Z(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129008||G>=129280&&G<=129535||G>=129648&&G<=129782}e.isEmojiImprecise=Z;function oe(G,ce){if(G.length<ce)return G;const ue=/\b/g;let me=0;for(;ue.test(G)&&!(G.length-ue.lastIndex<ce);)me=ue.lastIndex,ue.lastIndex+=1;return G.substring(me).replace(/^\s/,"")}e.lcut=oe;const ge=/\x1B\x5B[12]?K/g,ke=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function De(G){return G&&(G=G.replace(ge,""),G=G.replace(ke,""),G=G.replace(Oe,"")),G}e.removeAnsiEscapeCodes=De,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Le(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Le;function be(G){return Le(G)?G.substr(1):G}e.stripUTF8BOM=be;function we(G,ce){if(!G||!ce||G.length<ce.length)return!1;const ue=ce.length,me=G.toLowerCase();let Se=0,Ae=-1;for(;Se<ue;){const Be=me.indexOf(ce[Se],Ae+1);if(Be<0)return!1;Ae=Be,Se++}return!0}e.fuzzyContains=we;function ye(G,ce=!1){return G?(ce&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=ye;function Me(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=Me;function ee(G,ce=1){if(ce===0)return"";let ue=-1;do ue=G.indexOf(`
`,ue+1),ce--;while(ce>0&&ue>=0);return ue===-1?G:(G[ue-1]==="\r"&&ue--,G.substr(0,ue))}e.getNLines=ee;function he(G){return G=G%(2*26),G<26?String.fromCharCode(97+G):String.fromCharCode(65+G-26)}e.singleLetterHash=he;function de(G){return We.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=de;function ve(G,ce){return G===0?ce!==5&&ce!==7:G===2&&ce===3?!1:G===4||G===2||G===3||ce===4||ce===2||ce===3?!0:!(G===8&&(ce===8||ce===9||ce===11||ce===12)||(G===11||G===9)&&(ce===9||ce===10)||(G===12||G===10)&&ce===10||ce===5||ce===13||ce===7||G===1||G===13&&ce===14||G===6&&ce===6)}var Pe;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(Pe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class We{static getInstance(){return We.c||(We.c=new We),We.c}constructor(){this.d=Te()}getGraphemeBreakType(ce){if(ce<32)return ce===10?3:ce===13?2:4;if(ce<127)return 0;const ue=this.d,me=ue.length/3;let Se=1;for(;Se<=me;)if(ce<ue[3*Se])Se=2*Se;else if(ce>ue[3*Se+1])Se=2*Se+1;else return ue[3*Se+2];return 0}}We.c=null;function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function qe(G,ce){if(G===0)return 0;const ue=Ue(G,ce);if(ue!==void 0)return ue;const me=new T(ce,G);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=qe;function Ue(G,ce){const ue=new T(ce,G);let me=ue.prevCodePoint();for(;je(me)||me===65039||me===8419;){if(ue.offset===0)return;me=ue.prevCodePoint()}if(!Z(me))return;let Se=ue.offset;return Se>0&&ue.prevCodePoint()===8205&&(Se=ue.offset),Se}function je(G){return 127995<=G&&G<=127999}var Je;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(Je||(Je={})),e.noBreakWhitespace="\xA0";class $e{static getInstance(ce){return $e.d.get(Array.from(ce))}static getLocales(){return $e.e.getValue()}constructor(ce){this.f=ce}isAmbiguous(ce){return this.f.has(ce)}getPrimaryConfusable(ce){return this.f.get(ce)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=$e,k=$e,$e.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),$e.d=new I.LRUCachedFunction(G=>{function ce(He){const tt=new Map;for(let nt=0;nt<He.length;nt+=2)tt.set(He[nt],He[nt+1]);return tt}function ue(He,tt){const nt=new Map(He);for(const[lt,at]of tt)nt.set(lt,at);return nt}function me(He,tt){if(!He)return tt;const nt=new Map;for(const[lt,at]of He)tt.has(lt)&&nt.set(lt,at);return nt}const Se=k.c.getValue();let Ae=G.filter(He=>!He.startsWith("_")&&He in Se);Ae.length===0&&(Ae=["_default"]);let Be;for(const He of Ae){const tt=ce(Se[He]);Be=me(Be,tt)}const it=ce(Se._common),xe=ue(it,Be);return new $e(xe)}),$e.e=new t.Lazy(()=>Object.keys($e.c.getValue()).filter(G=>!G.startsWith("_")));class Ke{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ke.c())),this.d}static isInvisibleCharacter(ce){return Ke.e().has(ce)}static get codePoints(){return Ke.e()}}e.InvisibleCharacters=Ke,Ke.d=void 0}),define(te[30],ie([0,1,9,4,26,12]),function(V,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(r){return r===47||r===92}e.isPathSeparator=A;function C(r){return r.replace(/[\\/]/g,I.posix.sep)}e.toSlashes=C;function w(r){return r.indexOf("/")===-1&&(r=C(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=w;function m(r,c=I.posix.sep){if(!r)return"";const o=r.length,S=r.charCodeAt(0);if(A(S)){if(A(r.charCodeAt(1))&&!A(r.charCodeAt(2))){let L=3;const N=L;for(;L<o&&!A(r.charCodeAt(L));L++);if(N!==L&&!A(r.charCodeAt(L+1))){for(L+=1;L<o;L++)if(A(r.charCodeAt(L)))return r.slice(0,L+1).replace(/[\\/]/g,c)}}return c}else if(u(S)&&r.charCodeAt(1)===58)return A(r.charCodeAt(2))?r.slice(0,2)+c:r.slice(0,2);let D=r.indexOf("://");if(D!==-1){for(D+=3;D<o;D++)if(A(r.charCodeAt(D)))return r.slice(0,D+1)}return""}e.getRoot=m;function y(r){if(!t.isWindows||!r||r.length<5)return!1;let c=r.charCodeAt(0);if(c!==92||(c=r.charCodeAt(1),c!==92))return!1;let o=2;const S=o;for(;o<r.length&&(c=r.charCodeAt(o),c!==92);o++);return!(S===o||(c=r.charCodeAt(o+1),isNaN(c)||c===92))}e.isUNC=y;const P=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,c=t.isWindows){const o=c?P:E;return!(!r||r.length===0||/^\s+$/.test(r)||(o.lastIndex=0,o.test(r))||c&&h.test(r)||r==="."||r===".."||c&&r[r.length-1]==="."||c&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=d;function v(r,c,o){const S=r===c;return!o||S?S:!r||!c?!1:(0,k.equalsIgnoreCase)(r,c)}e.isEqual=v;function b(r,c,o,S=I.sep){if(r===c)return!0;if(!r||!c||c.length>r.length)return!1;if(o){if(!(0,k.startsWithIgnoreCase)(r,c))return!1;if(c.length===r.length)return!0;let L=c.length;return c.charAt(c.length-1)===S&&L--,r.charAt(L)===S}return c.charAt(c.length-1)!==S&&(c+=S),r.indexOf(c)===0}e.isEqualOrParent=b;function u(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=u;function p(r,c){return t.isWindows&&r.endsWith(":")&&(r+=I.sep),(0,I.isAbsolute)(r)||(r=(0,I.join)(c,r)),r=(0,I.normalize)(r),t.isWindows?(r=(0,k.rtrim)(r,I.sep),r.endsWith(":")&&(r+=I.sep)):(r=(0,k.rtrim)(r,I.sep),r||(r=I.sep)),r}e.sanitizeFilePath=p;function g(r){const c=(0,I.normalize)(r);return t.isWindows?r.length>3?!1:f(c)&&(r.length===2||c.charCodeAt(2)===92):c===I.posix.sep}e.isRootOrDriveLetter=g;function f(r,c=t.isWindows){return c?u(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function l(r){return f(r)?r[0]:void 0}e.getDriveLetter=l;function i(r,c,o){return c.length>r.length?-1:r===c?0:(o&&(r=r.toLowerCase(),c=c.toLowerCase()),r.indexOf(c))}e.indexOfPath=i;function s(r){const c=r.split(":");let o,S,D;for(const L of c){const N=Number(L);(0,R.isNumber)(N)?S===void 0?S=N:D===void 0&&(D=N):o=o?[o,L].join(":"):L}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:S!==void 0?S:void 0,column:D!==void 0?D:S!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function a(r,c,o=8){let S="";for(let L=0;L<o;L++)S+=n.charAt(Math.floor(Math.random()*n.length));let D;return c?D=`${c}-${S}`:D=S,r?(0,I.join)(r,D):D}e.randomPath=a}),define(te[68],ie([0,1,26]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(u){return k(u,0)}e.hash=t;function k(u,p){switch(typeof u){case"object":return u===null?R(349,p):Array.isArray(u)?w(u,p):m(u,p);case"string":return C(u,p);case"boolean":return A(u,p);case"number":return R(u,p);case"undefined":return R(937,p);default:return R(617,p)}}e.doHash=k;function R(u,p){return(p<<5)-p+u|0}e.numberHash=R;function A(u,p){return R(u?433:863,p)}function C(u,p){p=R(149417,p);for(let g=0,f=u.length;g<f;g++)p=R(u.charCodeAt(g),p);return p}e.stringHash=C;function w(u,p){return p=R(104579,p),u.reduce((g,f)=>k(f,g),p)}function m(u,p){return p=R(181387,p),Object.keys(u).sort().reduce((g,f)=>(g=C(f,g),k(u[f],g)),p)}class y{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=k(p,this.g),this.g}}e.Hasher=y;var P;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function E(u,p,g=32){const f=g-p,l=~((1<<f)-1);return(u<<p|(l&u)>>>f)>>>0}function h(u,p=0,g=u.byteLength,f=0){for(let l=0;l<g;l++)u[p+l]=f}function d(u,p,g="0"){for(;u.length<p;)u=g+u;return u}function v(u,p=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(g=>g.toString(16).padStart(2,"0")).join(""):d((u>>>0).toString(16),p/4)}e.toHexString=v;class b{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const g=p.length;if(g===0)return;const f=this.p;let l=this.r,i=this.u,s,n;for(i!==0?(s=i,n=-1,i=0):(s=p.charCodeAt(0),n=0);;){let a=s;if(I.isHighSurrogate(s))if(n+1<g){const r=p.charCodeAt(n+1);I.isLowSurrogate(r)?(n++,a=I.computeCodePoint(s,r)):a=65533}else{i=s;break}else I.isLowSurrogate(s)&&(a=65533);if(l=this.w(f,l,a),n++,n<g)s=p.charCodeAt(n);else break}this.r=l,this.u=i}w(p,g,f){return f<128?p[g++]=f:f<2048?(p[g++]=192|(f&1984)>>>6,p[g++]=128|(f&63)>>>0):f<65536?(p[g++]=224|(f&61440)>>>12,p[g++]=128|(f&4032)>>>6,p[g++]=128|(f&63)>>>0):(p[g++]=240|(f&1835008)>>>18,p[g++]=128|(f&258048)>>>12,p[g++]=128|(f&4032)>>>6,p[g++]=128|(f&63)>>>0),g>=64&&(this.y(),g-=64,this.t+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),g}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=b.g,g=this.q;for(let o=0;o<64;o+=4)p.setUint32(o,g.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)p.setUint32(o,E(p.getUint32(o-12,!1)^p.getUint32(o-32,!1)^p.getUint32(o-56,!1)^p.getUint32(o-64,!1),1),!1);let f=this.h,l=this.l,i=this.m,s=this.n,n=this.o,a,r,c;for(let o=0;o<80;o++)o<20?(a=l&i|~l&s,r=1518500249):o<40?(a=l^i^s,r=1859775393):o<60?(a=l&i|l&s|i&s,r=2400959708):(a=l^i^s,r=3395469782),c=E(f,5)+a+n+r+p.getUint32(o*4,!1)&4294967295,n=s,s=i,i=E(l,30),l=f,f=c;this.h=this.h+f&4294967295,this.l=this.l+l&4294967295,this.m=this.m+i&4294967295,this.n=this.n+s&4294967295,this.o=this.o+n&4294967295}}e.StringSHA1=b,b.g=new DataView(new ArrayBuffer(320))}),define(te[98],ie([0,1,26]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(t||(t={})),function(k){const R="error",A="warning",C="warn",w="info",m="ignore";function y(E){return E?I.equalsIgnoreCase(R,E)?k.Error:I.equalsIgnoreCase(A,E)||I.equalsIgnoreCase(C,E)?k.Warning:I.equalsIgnoreCase(w,E)?k.Info:k.Ignore:k.Ignore}k.fromValue=y;function P(E){switch(E){case k.Error:return R;case k.Warning:return A;case k.Info:return w;default:return m}}k.toString=P}(t||(t={})),e.default=t}),define(te[60],ie([0,1,24,26]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class k{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const d=h.charCodeAt(0),v=this.b.charCodeAt(this.c);return d-v}value(){return this.b[this.c]}}e.StringIterator=k;class R{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,t.compareSubstring)(h,this.b,0,h.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class A{constructor(h=!0,d=!0){this.f=h,this.g=d}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let d=h.length-1;d>=0;d--,this.c--){const v=this.b.charCodeAt(d);if(!(v===47||this.f&&v===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,t.compareSubstring)(h,this.b,0,h.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=A;var C;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(C||(C={}));class w{constructor(h,d){this.f=h,this.g=d,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(h,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,t.compare)(h,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=w;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(y||(y={}));class P{static forUris(h=()=>!1,d=()=>!1){return new P(new w(h,d))}static forPaths(h=!1){return new P(new A(void 0,!h))}static forStrings(){return new P(new k)}static forConfigKeys(){return new P(new R)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,d){if(d){const v=d.slice(0);(0,I.shuffle)(v);for(const b of v)this.set(b,h)}else{const v=h.slice(0);(0,I.shuffle)(v);for(const b of v)this.set(b[0],b[1])}}set(h,d){const v=this.b.reset(h);let b;this.c||(this.c=new m,this.c.segment=v.value());const u=[];for(b=this.c;;){const g=v.cmp(b.segment);if(g>0)b.left||(b.left=new m,b.left.segment=v.value()),u.push([-1,b]),b=b.left;else if(g<0)b.right||(b.right=new m,b.right.segment=v.value()),u.push([1,b]),b=b.right;else if(v.hasNext())v.next(),b.mid||(b.mid=new m,b.mid.segment=v.value()),u.push([0,b]),b=b.mid;else break}const p=b.value;b.value=d,b.key=h;for(let g=u.length-1;g>=0;g--){const f=u[g][1];f.updateHeight();const l=f.balanceFactor();if(l<-1||l>1){const i=u[g][0],s=u[g+1][0];if(i===1&&s===1)u[g][1]=f.rotateLeft();else if(i===-1&&s===-1)u[g][1]=f.rotateRight();else if(i===1&&s===-1)f.right=u[g+1][1]=u[g+1][1].rotateRight(),u[g][1]=f.rotateLeft();else if(i===-1&&s===1)f.left=u[g+1][1]=u[g+1][1].rotateLeft(),u[g][1]=f.rotateRight();else throw new Error;if(g>0)switch(u[g-1][0]){case-1:u[g-1][1].left=u[g][1];break;case 1:u[g-1][1].right=u[g][1];break;case 0:u[g-1][1].mid=u[g][1];break}else this.c=u[0][1]}}return p}get(h){return this.d(h)?.value}d(h){const d=this.b.reset(h);let v=this.c;for(;v;){const b=d.cmp(v.segment);if(b>0)v=v.left;else if(b<0)v=v.right;else if(d.hasNext())d.next(),v=v.mid;else break}return v}has(h){const d=this.d(h);return!(d?.value===void 0&&d?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,d){const v=this.b.reset(h),b=[];let u=this.c;for(;u;){const p=v.cmp(u.segment);if(p>0)b.push([-1,u]),u=u.left;else if(p<0)b.push([1,u]),u=u.right;else if(v.hasNext())v.next(),b.push([0,u]),u=u.mid;else break}if(!!u){if(d?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const p=this.f(u.right);if(p.key){const{key:g,value:f,segment:l}=p;this.e(p.key,!1),u.key=g,u.value=f,u.segment=l}}else{const p=u.left??u.right;if(b.length>0){const[g,f]=b[b.length-1];switch(g){case-1:f.left=p;break;case 0:f.mid=p;break;case 1:f.right=p;break}}else this.c=p}for(let p=b.length-1;p>=0;p--){const g=b[p][1];g.updateHeight();const f=g.balanceFactor();if(f>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),b[p][1]=g.rotateLeft()):f<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),b[p][1]=g.rotateRight()),p>0)switch(b[p-1][0]){case-1:b[p-1][1].left=b[p][1];break;case 1:b[p-1][1].right=b[p][1];break;case 0:b[p-1][1].mid=b[p][1];break}else this.c=b[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const d=this.b.reset(h);let v=this.c,b;for(;v;){const u=d.cmp(v.segment);if(u>0)v=v.left;else if(u<0)v=v.right;else if(d.hasNext())d.next(),b=v.value||b,v=v.mid;else break}return v&&v.value||b}findSuperstr(h){const d=this.b.reset(h);let v=this.c;for(;v;){const b=d.cmp(v.segment);if(b>0)v=v.left;else if(b<0)v=v.right;else if(d.hasNext())d.next(),v=v.mid;else return v.mid?this.g(v.mid):void 0}}forEach(h){for(const[d,v]of this)h(v,d)}*[Symbol.iterator](){yield*this.g(this.c)}g(h){const d=[];return this.h(h,d),d[Symbol.iterator]()}h(h,d){!h||(h.left&&this.h(h.left,d),h.value&&d.push([h.key,h.value]),h.mid&&this.h(h.mid,d),h.right&&this.h(h.right,d))}_isBalanced(){const h=d=>{if(!d)return!0;const v=d.balanceFactor();return v<-1||v>1?!1:h(d.left)&&h(d.right)};return h(this.c)}}e.TernarySearchTree=P}),define(te[7],ie([0,1,9,4]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,R=/^\//,A=/^\/\//;function C(n,a){if(!n.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!k.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!R.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(n,a){return!n&&!a?"file":n}function m(n,a){switch(n){case"https":case"http":case"file":a?a[0]!==P&&(a=P+a):a=P;break}return a}const y="",P="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(a){return a instanceof h?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,r,c,o,S,D=!1){typeof a=="object"?(this.scheme=a.scheme||y,this.authority=a.authority||y,this.path=a.path||y,this.query=a.query||y,this.fragment=a.fragment||y):(this.scheme=w(a,D),this.authority=r||y,this.path=m(this.scheme,c||y),this.query=o||y,this.fragment=S||y,C(this,D))}get fsPath(){return g(this,!1)}with(a){if(!a)return this;let{scheme:r,authority:c,path:o,query:S,fragment:D}=a;return r===void 0?r=this.scheme:r===null&&(r=y),c===void 0?c=this.authority:c===null&&(c=y),o===void 0?o=this.path:o===null&&(o=y),S===void 0?S=this.query:S===null&&(S=y),D===void 0?D=this.fragment:D===null&&(D=y),r===this.scheme&&c===this.authority&&o===this.path&&S===this.query&&D===this.fragment?this:new v(r,c,o,S,D)}static parse(a,r=!1){const c=E.exec(a);return c?new v(c[2]||y,s(c[4]||y),s(c[5]||y),s(c[7]||y),s(c[9]||y),r):new v(y,y,y,y,y)}static file(a){let r=y;if(t.isWindows&&(a=a.replace(/\\/g,P)),a[0]===P&&a[1]===P){const c=a.indexOf(P,2);c===-1?(r=a.substring(2),a=P):(r=a.substring(2,c),a=a.substring(c)||P)}return new v("file",r,a,y,y)}static from(a){const r=new v(a.scheme,a.authority,a.path,a.query,a.fragment);return C(r,!0),r}static joinPath(a,...r){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return t.isWindows&&a.scheme==="file"?c=h.file(I.win32.join(g(a,!0),...r)).path:c=I.posix.join(a.path,...r),a.with({path:c})}toString(a=!1){return f(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof h)return a;{const r=new v(a);return r._formatted=a.external,r._fsPath=a._sep===d?a.fsPath:null,r}}else return a}}e.URI=h;const d=t.isWindows?1:void 0;class v extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(a=!1){return a?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=d),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(n,a,r){let c,o=-1;for(let S=0;S<n.length;S++){const D=n.charCodeAt(S);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||a&&D===47||r&&D===91||r&&D===93||r&&D===58)o!==-1&&(c+=encodeURIComponent(n.substring(o,S)),o=-1),c!==void 0&&(c+=n.charAt(S));else{c===void 0&&(c=n.substr(0,S));const L=b[D];L!==void 0?(o!==-1&&(c+=encodeURIComponent(n.substring(o,S)),o=-1),c+=L):o===-1&&(o=S)}}return o!==-1&&(c+=encodeURIComponent(n.substring(o))),c!==void 0?c:n}function p(n){let a;for(let r=0;r<n.length;r++){const c=n.charCodeAt(r);c===35||c===63?(a===void 0&&(a=n.substr(0,r)),a+=b[c]):a!==void 0&&(a+=n[r])}return a!==void 0?a:n}function g(n,a){let r;return n.authority&&n.path.length>1&&n.scheme==="file"?r=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?a?r=n.path.substr(1):r=n.path[1].toLowerCase()+n.path.substr(2):r=n.path,t.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=g;function f(n,a){const r=a?p:u;let c="",{scheme:o,authority:S,path:D,query:L,fragment:N}=n;if(o&&(c+=o,c+=":"),(S||o==="file")&&(c+=P,c+=P),S){let X=S.indexOf("@");if(X!==-1){const ae=S.substr(0,X);S=S.substr(X+1),X=ae.lastIndexOf(":"),X===-1?c+=r(ae,!1,!1):(c+=r(ae.substr(0,X),!1,!1),c+=":",c+=r(ae.substr(X+1),!1,!0)),c+="@"}S=S.toLowerCase(),X=S.lastIndexOf(":"),X===-1?c+=r(S,!1,!0):(c+=r(S.substr(0,X),!1,!0),c+=S.substr(X))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const X=D.charCodeAt(1);X>=65&&X<=90&&(D=`/${String.fromCharCode(X+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const X=D.charCodeAt(0);X>=65&&X<=90&&(D=`${String.fromCharCode(X+32)}:${D.substr(2)}`)}c+=r(D,!0,!1)}return L&&(c+="?",c+=r(L,!1,!1)),N&&(c+="#",c+=a?N:u(N,!1,!1)),c}function l(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+l(n.substr(3)):n}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(n){return n.match(i)?n.replace(i,a=>l(a)):n}}),define(te[139],ie([0,1,7]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(m){const y=m;return y&&typeof y.type=="string"&&typeof y.severity=="string"}e.isRemoteConsoleLog=t;function k(m){const y=[];let P;try{const E=JSON.parse(m.arguments),h=E[E.length-1];h&&h.__$stack&&(E.pop(),P=h.__$stack),y.push(...E)}catch{y.push("Unable to log remote console arguments",m.arguments)}return{args:y,stack:P}}e.parse=k;function R(m){if(typeof m!="string")return R(k(m).stack);const y=m;if(y){const P=A(y),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(E&&E.length===4)return{uri:I.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=R;function A(m){if(!m)return m;const y=m.indexOf(`
`);return y===-1?m:m.substring(0,y)}function C(m,y){const{args:P,stack:E}=k(m),h=typeof P[0]=="string"&&P.length===1;let d=A(E);d&&(d=`(${d.trim()})`);let v=[];if(typeof P[0]=="string"?d&&h?v=[`%c[${y}] %c${P[0]} %c${d}`,w("blue"),w(""),w("grey")]:v=[`%c[${y}] %c${P[0]}`,w("blue"),w(""),...P.slice(1)]:v=[`%c[${y}]%`,w("blue"),...P],d&&!h&&v.push(d),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,v)}e.log=C;function w(m){return`color: ${m}`}}),define(te[69],ie([0,1,17,26,7]),function(V,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(m){return JSON.stringify(m,C)}e.stringify=R;function A(m){let y=JSON.parse(m);return y=w(y),y}e.parse=A;function C(m,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:(0,t.regExpFlags)(y)}:y}function w(m,y=0){if(!m||y>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return k.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 16:return new Date(m.source)}if(m instanceof I.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let P=0;P<m.length;++P)m[P]=w(m[P],y+1);else for(const P in m)Object.hasOwnProperty.call(m,P)&&(m[P]=w(m[P],y+1))}return m}e.revive=w}),define(te[15],ie([0,1,4,7]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebook="vscode-notebook",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractive="vscode-interactive",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(m){this.d=m}setDelegate(m){this.e=m}setServerRootPath(m){this.f=`${m}/${k.vscodeRemoteResource}`}set(m,y,P){this.a[m]=y,this.b[m]=P}setConnectionToken(m,y){this.c[m]=y}getPreferredWebSchema(){return this.d}rewrite(m){if(this.e)return this.e(m);const y=m.authority;let P=this.a[y];P&&P.indexOf(":")!==-1&&P.indexOf("[")===-1&&(P=`[${P}]`);const E=this.b[y],h=this.c[y];let d=`path=${encodeURIComponent(m.path)}`;return typeof h=="string"&&(d+=`&${e.connectionTokenQueryName}=${encodeURIComponent(h)}`),t.URI.from({scheme:I.isWeb?this.d:k.vscodeRemoteResource,authority:`${P}:${E}`,path:this.f,query:d})}}e.RemoteAuthorities=new R,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(m){const y=this.b(m,V);return this.uriToBrowserUri(y)}uriToBrowserUri(m){return m.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(m):m.scheme===k.file&&(I.isNative||I.isWebWorker&&I.globals.origin===`${k.vscodeFileResource}://${A.a}`)?m.with({scheme:k.vscodeFileResource,authority:m.authority||A.a,query:null,fragment:null}):m}asFileUri(m){const y=this.b(m,V);return this.uriToFileUri(y)}uriToFileUri(m){return m.scheme===k.vscodeFileResource?m.with({scheme:k.file,authority:m.authority!==A.a?m.authority:null,query:null,fragment:null}):m}b(m,y){return t.URI.isUri(m)?m:t.URI.parse(y.toUrl(m))}}A.a="vscode-app",e.FileAccess=new A;var C;(function(w){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(m.get("3"));const y="vscode-coi";function P(h){let d;typeof h=="string"?d=new URL(h).searchParams:h instanceof URL?d=h.searchParams:t.URI.isUri(h)&&(d=new URL(h.toString(!0)).searchParams);const v=d?.get(y);if(!!v)return m.get(v)}w.getHeadersFromQuery=P;function E(h,d,v){if(!globalThis.crossOriginIsolated)return;const b=d&&v?"3":v?"2":"1";h instanceof URLSearchParams?h.set(y,b):h[y]=b}w.addSearchParam=E})(C=e.COI||(e.COI={}))}),define(te[20],ie([0,1,30,15,9,4,26,7]),function(V,e,I,t,k,R,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(h){return(0,C.uriToFsPath)(h,!0)}e.originalFSPath=w;class m{constructor(d){this.a=d}compare(d,v,b=!1){return d===v?0:(0,A.compare)(this.getComparisonKey(d,b),this.getComparisonKey(v,b))}isEqual(d,v,b=!1){return d===v?!0:!d||!v?!1:this.getComparisonKey(d,b)===this.getComparisonKey(v,b)}getComparisonKey(d,v=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,v,b=!1){if(d.scheme===v.scheme){if(d.scheme===t.Schemas.file)return I.isEqualOrParent(w(d),w(v),this.a(d))&&d.query===v.query&&(b||d.fragment===v.fragment);if((0,e.isEqualAuthority)(d.authority,v.authority))return I.isEqualOrParent(d.path,v.path,this.a(d),"/")&&d.query===v.query&&(b||d.fragment===v.fragment)}return!1}joinPath(d,...v){return C.URI.joinPath(d,...v)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return k.posix.basename(d.path)}extname(d){return k.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let v;return d.scheme===t.Schemas.file?v=C.URI.file(k.dirname(w(d))).path:(v=k.posix.dirname(d.path),d.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),v="/")),d.with({path:v})}normalizePath(d){if(!d.path.length)return d;let v;return d.scheme===t.Schemas.file?v=C.URI.file(k.normalize(w(d))).path:v=k.posix.normalize(d.path),d.with({path:v})}relativePath(d,v){if(d.scheme!==v.scheme||!(0,e.isEqualAuthority)(d.authority,v.authority))return;if(d.scheme===t.Schemas.file){const p=k.relative(w(d),w(v));return R.isWindows?I.toSlashes(p):p}let b=d.path||"/";const u=v.path||"/";if(this.a(d)){let p=0;for(const g=Math.min(b.length,u.length);p<g&&!(b.charCodeAt(p)!==u.charCodeAt(p)&&b.charAt(p).toLowerCase()!==u.charAt(p).toLowerCase());p++);b=u.substr(0,p)+b.substr(p)}return k.posix.relative(b,u)}resolvePath(d,v){if(d.scheme===t.Schemas.file){const b=C.URI.file(k.resolve(w(d),v));return d.with({authority:b.authority,path:b.path})}return v=I.toPosixPath(v),d.with({path:k.posix.resolve(d.path,v)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,v){return d===v||d!==void 0&&v!==void 0&&(0,A.equalsIgnoreCase)(d,v)}hasTrailingPathSeparator(d,v=k.sep){if(d.scheme===t.Schemas.file){const b=w(d);return b.length>I.getRoot(b).length&&b[b.length-1]===v}else{const b=d.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,v=k.sep){return(0,e.hasTrailingPathSeparator)(d,v)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,v=k.sep){let b=!1;if(d.scheme===t.Schemas.file){const u=w(d);b=u!==void 0&&u.length===I.getRoot(u).length&&u[u.length-1]===v}else{v="/";const u=d.path;b=u.length===1&&u.charCodeAt(u.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(d,v)?d.with({path:d.path+"/"}):d}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(h=>h.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new m(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function y(h,d){const v=[];for(let b=0;b<h.length;b++){const u=d(h[b]);h.some((p,g)=>g===b?!1:(0,e.isEqualOrParent)(u,d(p)))||v.push(h[b])}return v}e.distinctParents=y;var P;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function d(v){const b=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(g=>{const[f,l]=g.split(":");f&&l&&b.set(f,l)});const p=v.path.substring(0,v.path.indexOf(";"));return p&&b.set(h.META_DATA_MIME,p),b}h.parseMetaData=d})(P=e.DataUri||(e.DataUri={}));function E(h,d,v){if(d){let b=h.path;return b&&b[0]!==k.posix.sep&&(b=k.posix.sep+b),h.with({scheme:v,authority:d,path:b})}return h.with({scheme:v})}e.toLocalResource=E}),define(te[8],ie([0,1,22,14,3,2,20,4]),function(V,e,I,t,k,R,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(j){return!!j&&typeof j.then=="function"}e.isThenable=w;function m(j){const M=new I.CancellationTokenSource,O=j(M.token),F=new Promise((U,H)=>{const x=M.token.onCancellationRequested(()=>{x.dispose(),M.dispose(),H(new t.CancellationError)});Promise.resolve(O).then(B=>{x.dispose(),M.dispose(),U(B)},B=>{x.dispose(),M.dispose(),H(B)})});return new class{cancel(){M.cancel()}then(U,H){return F.then(U,H)}catch(U){return this.then(void 0,U)}finally(U){return F.finally(U)}}}e.createCancelablePromise=m;function y(j,M,O){return new Promise((F,U)=>{const H=M.onCancellationRequested(()=>{H.dispose(),F(O)});j.then(F,U).finally(()=>H.dispose())})}e.raceCancellation=y;function P(j,M){return new Promise((O,F)=>{const U=M.onCancellationRequested(()=>{U.dispose(),F(new t.CancellationError)});j.then(O,F).finally(()=>U.dispose())})}e.raceCancellationError=P;async function E(j){let M=-1;const O=j.map((U,H)=>U.then(x=>(M=H,x))),F=await Promise.race(O);return j.forEach((U,H)=>{H!==M&&U.cancel()}),F}e.raceCancellablePromises=E;function h(j,M,O){let F;const U=setTimeout(()=>{F?.(void 0),O?.()},M);return Promise.race([j.finally(()=>clearTimeout(U)),new Promise(H=>F=H)])}e.raceTimeout=h;function d(j){return new Promise((M,O)=>{const F=j();w(F)?F.then(M,O):M(F)})}e.asPromise=d;class v{constructor(){this.a=null,this.b=null,this.d=null}queue(M){if(this.a){if(this.d=M,!this.b){const O=()=>{this.b=null;const F=this.queue(this.d);return this.d=null,F};this.b=new Promise(F=>{this.a.then(O,O).then(F)})}return new Promise((O,F)=>{this.b.then(O,F)})}return this.a=M(),new Promise((O,F)=>{this.a.then(U=>{this.a=null,O(U)},U=>{this.a=null,F(U)})})}}e.Throttler=v;class b{constructor(){this.a=Promise.resolve(null)}queue(M){return this.a=this.a.then(()=>M(),()=>M())}}e.Sequencer=b;class u{constructor(){this.a=new Map}queue(M,O){const U=(this.a.get(M)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.a.get(M)===U&&this.a.delete(M)});return this.a.set(M,U),U}}e.SequencerByKey=u;const p=(j,M)=>{let O=!0;const F=setTimeout(()=>{O=!1,M()},j);return{isTriggered:()=>O,dispose:()=>{clearTimeout(F),O=!1}}},g=j=>{let M=!0;return queueMicrotask(()=>{M&&(M=!1,j())}),{isTriggered:()=>M,dispose:()=>{M=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class f{constructor(M){this.defaultDelay=M,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(M,O=this.defaultDelay){this.g=M,this.h(),this.b||(this.b=new Promise((U,H)=>{this.d=U,this.f=H}).then(()=>{if(this.b=null,this.d=null,this.g){const U=this.g;return this.g=null,U()}}));const F=()=>{this.a=null,this.d?.(null)};return this.a=O===e.MicrotaskDelay?g(F):p(O,F),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=f;class l{constructor(M){this.a=new f(M),this.b=new v}trigger(M,O){return this.a.trigger(()=>this.b.queue(M),O)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=l;class i{constructor(){this.a=!1,this.b=new Promise((M,O)=>{this.d=M})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=i;class s extends i{constructor(M){super(),this.f=setTimeout(()=>this.open(),M)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=s;function n(j,M){return M?new Promise((O,F)=>{const U=setTimeout(()=>{H.dispose(),O()},j),H=M.onCancellationRequested(()=>{clearTimeout(U),H.dispose(),F(new t.CancellationError)})}):m(O=>n(j,O))}e.timeout=n;function a(j,M=0){const O=setTimeout(j,M);return(0,R.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=a;function r(j){const M=[];let O=0;const F=j.length;function U(){return O<F?j[O++]():null}function H(x){x!=null&&M.push(x);const B=U();return B?B.then(H):Promise.resolve(M)}return Promise.resolve(null).then(H)}e.sequence=r;function c(j,M=F=>!!F,O=null){let F=0;const U=j.length,H=()=>{if(F>=U)return Promise.resolve(O);const x=j[F++];return Promise.resolve(x()).then(_=>M(_)?Promise.resolve(_):H())};return H()}e.first=c;function o(j,M=F=>!!F,O=null){if(j.length===0)return Promise.resolve(O);let F=j.length;const U=()=>{F=-1;for(const H of j)H.cancel?.()};return new Promise((H,x)=>{for(const B of j)B.then(_=>{--F>=0&&M(_)?(U(),H(_)):F===0&&H(O)}).catch(_=>{--F>=0&&(U(),x(_))})})}e.firstParallel=o;class S{constructor(M){this.a=0,this.d=M,this.f=[],this.b=0,this.g=new k.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(M){return this.a++,new Promise((O,F)=>{this.f.push({factory:M,c:O,e:F}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const M=this.f.shift();this.b++;const O=M.factory();O.then(M.c,M.e),O.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=S;class D extends S{constructor(){super(1)}}e.Queue=D;class L{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const M=new $;return this.b.add(M),M.p}d(){for(const[,M]of this.a)if(M.size>0)return!1;return!0}queueFor(M,O=A.extUri){const F=O.getComparisonKey(M);let U=this.a.get(F);return U||(U=new D,k.Event.once(U.onDrained)(()=>{U?.dispose(),this.a.delete(F),this.f()}),this.a.set(F,U)),U}f(){!this.d()||this.g()}g(){for(const M of this.b)M.complete();this.b.clear()}dispose(){for(const[,M]of this.a)M.dispose();this.a.clear(),this.g()}}e.ResourceQueue=L;class N{constructor(M,O){this.a=-1,typeof M=="function"&&typeof O=="number"&&this.setIfNotSet(M,O)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(M,O){this.cancel(),this.a=setTimeout(()=>{this.a=-1,M()},O)}setIfNotSet(M,O){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,M()},O))}}e.TimeoutTimer=N;class X{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(M,O){this.cancel(),this.a=setInterval(()=>{M()},O)}}e.IntervalTimer=X;class ae{constructor(M,O){this.b=-1,this.a=M,this.d=O,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(M=this.d){this.cancel(),this.b=setTimeout(this.f,M)}get delay(){return this.d}set delay(M){this.d=M}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=ae;class J{constructor(M,O){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.a=M,this.b=O,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(M=this.b){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(M/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=J;class Y extends ae{constructor(M,O){super(M,O),this.j=[]}work(M){this.j.push(M),this.isScheduled()||this.schedule()}h(){const M=this.j;this.j=[],this.a?.(M)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=Y;class se extends R.Disposable{constructor(M,O){super(),this.g=M,this.h=O,this.a=[],this.b=this.B(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(M){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+M.length>this.g.maxBufferedWork)return!1}else if(this.pending+M.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(...M),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ae(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=se,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=j=>{(0,C.setTimeout0)(()=>{if(M)return;const O=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let M=!1;return{dispose(){M||(M=!0)}}}:e.runWhenIdle=(j,M)=>{const O=requestIdleCallback(j,typeof M=="number"?{timeout:M}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(O))}}}}();class re{constructor(M){this.d=!1,this.a=()=>{try{this.f=M()}catch(O){this.g=O}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=re;async function fe(j,M,O){let F;for(let U=0;U<O;U++)try{return await j()}catch(H){F=H,await n(M)}throw F}e.retry=fe;class K{hasPending(M){return this.a?typeof M=="number"?this.a.taskId===M:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(M,O,F){return this.a={taskId:M,cancel:()=>F?.(),promise:O},O.then(()=>this.d(M),()=>this.d(M)),O}d(M){this.a&&M===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const M=this.b;this.b=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this.b)this.b.run=M;else{let O,F;const U=new Promise((H,x)=>{O=H,F=x});this.b={run:M,promise:U,promiseResolve:O,promiseReject:F}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=K;class le{constructor(M,O=()=>Date.now()){this.d=M,this.f=O,this.a=0,this.b=0}increment(){const M=this.f();return M-this.a>this.d&&(this.a=M,this.b=0),this.b++,this.b}}e.IntervalCounter=le;class ${get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((M,O)=>{this.a=M,this.b=O})}complete(M){return new Promise(O=>{this.a(M),this.f=!0,O()})}error(M){return new Promise(O=>{this.b(M),this.d=!0,O()})}cancel(){new Promise(M=>{this.b(new t.CancellationError),this.d=!0,M()})}}e.DeferredPromise=$;var W;(function(j){async function M(F){let U;const H=await Promise.all(F.map(x=>x.then(B=>B,B=>{U||(U=B)})));if(typeof U<"u")throw U;return H}j.settled=M;function O(F){return new Promise(async(U,H)=>{try{await F(U,H)}catch(x){H(x)}})}j.withAsyncBody=O})(W=e.Promises||(e.Promises={}));var T;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(T||(T={}));class z{static fromArray(M){return new z(O=>{O.emitMany(M)})}static fromPromise(M){return new z(async O=>{O.emitMany(await M)})}static fromPromises(M){return new z(async O=>{await Promise.all(M.map(async F=>O.emitOne(await F)))})}static merge(M){return new z(async O=>{await Promise.all(M.map(async F=>{for await(const U of F)O.emitOne(U)}))})}constructor(M){this.a=0,this.b=[],this.d=null,this.f=new k.Emitter,queueMicrotask(async()=>{const O={emitOne:F=>this.g(F),emitMany:F=>this.h(F),reject:F=>this.k(F)};try{await Promise.resolve(M(O)),this.j()}catch(F){this.k(F)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}[Symbol.asyncIterator](){let M=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(M<this.b.length)return{done:!1,value:this.b[M++]};if(this.a===1)return{done:!0,value:void 0};await k.Event.toPromise(this.f.event)}while(!0)}}}static map(M,O){return new z(async F=>{for await(const U of M)F.emitOne(O(U))})}map(M){return z.map(this,M)}static filter(M,O){return new z(async F=>{for await(const U of M)O(U)&&F.emitOne(U)})}filter(M){return z.filter(this,M)}static coalesce(M){return z.filter(M,O=>!!O)}coalesce(){return z.coalesce(this)}static async toPromise(M){const O=[];for await(const F of M)O.push(F);return O}toPromise(){return z.toPromise(this)}g(M){this.a===0&&(this.b.push(M),this.f.fire())}h(M){this.a===0&&(this.b=this.b.concat(M),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(M){this.a===0&&(this.a=2,this.d=M,this.f.fire())}}e.AsyncIterableObject=z,z.EMPTY=z.fromArray([]);class Q extends z{constructor(M,O){super(O),this.l=M}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=Q;function q(j){const M=new I.CancellationTokenSource,O=j(M.token);return new Q(M,async F=>{const U=M.token.onCancellationRequested(()=>{U.dispose(),M.dispose(),F.reject(new t.CancellationError)});try{for await(const H of O){if(M.token.isCancellationRequested)return;F.emitOne(H)}U.dispose(),M.dispose()}catch(H){U.dispose(),M.dispose(),F.reject(H)}})}e.createCancelableAsyncIterable=q}),define(te[99],ie([0,1,24,8,30,39,9,4,26]),function(V,e,I,t,k,R,A,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const y="[/\\\\]",P="[^/\\\\]",E=/\//g;function h($,W){switch($){case 0:return"";case 1:return`${P}*?`;default:return`(?:${y}|${P}+${y}${W?`|${y}${P}+`:""})*?`}}function d($,W){if(!$)return[];const T=[];let z=!1,Q=!1,q="";for(const j of $){switch(j){case W:if(!z&&!Q){T.push(q),q="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}q+=j}return q&&T.push(q),T}e.splitGlobAware=d;function v($){if(!$)return"";let W="";const T=d($,e.GLOB_SPLIT);if(T.every(z=>z===e.GLOBSTAR))W=".*";else{let z=!1;T.forEach((Q,q)=>{if(Q===e.GLOBSTAR){if(z)return;W+=h(2,q===T.length-1)}else{let j=!1,M="",O=!1,F="";for(const U of Q){if(U!=="}"&&j){M+=U;continue}if(O&&(U!=="]"||!F)){let H;U==="-"?H=U:(U==="^"||U==="!")&&!F?H="^":U===e.GLOB_SPLIT?H="":H=(0,w.escapeRegExpCharacters)(U),F+=H;continue}switch(U){case"{":j=!0;continue;case"[":O=!0;continue;case"}":{W+=`(?:${d(M,",").map(B=>v(B)).join("|")})`,j=!1,M="";break}case"]":{W+="["+F+"]",O=!1,F="";break}case"?":W+=P;continue;case"*":W+=h(1);continue;default:W+=(0,w.escapeRegExpCharacters)(U)}}q<T.length-1&&(T[q+1]!==e.GLOBSTAR||q+2<T.length)&&(W+=y)}z=Q===e.GLOBSTAR})}return W}const b=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.LRUCache(1e4),s=function(){return!1},n=function(){return null};function a($,W){if(!$)return n;let T;typeof $!="string"?T=$.pattern:T=$,T=T.trim();const z=`${T}_${!!W.trimForExclusions}`;let Q=i.get(z);if(Q)return r(Q,$);let q;return b.test(T)?Q=o(T.substr(4),T):(q=u.exec(c(T,W)))?Q=S(q[1],T):(W.trimForExclusions?g:p).test(T)?Q=D(T,W):(q=f.exec(c(T,W)))?Q=L(q[1].substr(1),T,!0):(q=l.exec(c(T,W)))?Q=L(q[1],T,!1):Q=N(T),i.set(z,Q),r(Q,$)}function r($,W){if(typeof W=="string")return $;const T=function(z,Q){return(0,k.isEqualOrParent)(z,W.base,!C.isLinux)?$((0,w.ltrim)(z.substr(W.base.length),A.sep),Q):null};return T.allBasenames=$.allBasenames,T.allPaths=$.allPaths,T.basenames=$.basenames,T.patterns=$.patterns,T}function c($,W){return W.trimForExclusions&&$.endsWith("/**")?$.substr(0,$.length-2):$}function o($,W){return function(T,z){return typeof T=="string"&&T.endsWith($)?W:null}}function S($,W){const T=`/${$}`,z=`\\${$}`,Q=function(j,M){return typeof j!="string"?null:M?M===$?W:null:j===$||j.endsWith(T)||j.endsWith(z)?W:null},q=[$];return Q.basenames=q,Q.patterns=[W],Q.allBasenames=q,Q}function D($,W){const T=K($.slice(1,-1).split(",").map(M=>a(M,W)).filter(M=>M!==n),$),z=T.length;if(!z)return n;if(z===1)return T[0];const Q=function(M,O){for(let F=0,U=T.length;F<U;F++)if(T[F](M,O))return $;return null},q=T.find(M=>!!M.allBasenames);q&&(Q.allBasenames=q.allBasenames);const j=T.reduce((M,O)=>O.allPaths?M.concat(O.allPaths):M,[]);return j.length&&(Q.allPaths=j),Q}function L($,W,T){const z=A.sep===A.posix.sep,Q=z?$:$.replace(E,A.sep),q=A.sep+Q,j=A.posix.sep+$;let M;return T?M=function(O,F){return typeof O=="string"&&(O===Q||O.endsWith(q)||!z&&(O===$||O.endsWith(j)))?W:null}:M=function(O,F){return typeof O=="string"&&(O===Q||!z&&O===$)?W:null},M.allPaths=[(T?"*/":"./")+$],M}function N($){try{const W=new RegExp(`^${v($)}$`);return function(T){return W.lastIndex=0,typeof T=="string"&&W.test(T)?$:null}}catch{return n}}function X($,W,T){return!$||typeof W!="string"?!1:ae($)(W,void 0,T)}e.match=X;function ae($,W={}){if(!$)return s;if(typeof $=="string"||J($)){const T=a($,W);if(T===n)return s;const z=function(Q,q){return!!T(Q,q)};return T.allBasenames&&(z.allBasenames=T.allBasenames),T.allPaths&&(z.allPaths=T.allPaths),z}return re($,W)}e.parse=ae;function J($){const W=$;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}e.isRelativePattern=J;function Y($){return $.allBasenames||[]}e.getBasenameTerms=Y;function se($){return $.allPaths||[]}e.getPathTerms=se;function re($,W){const T=K(Object.getOwnPropertyNames($).map(M=>fe(M,$[M],W)).filter(M=>M!==n)),z=T.length;if(!z)return n;if(!T.some(M=>!!M.requiresSiblings)){if(z===1)return T[0];const M=function(U,H){let x;for(let B=0,_=T.length;B<_;B++){const Z=T[B](U,H);if(typeof Z=="string")return Z;(0,t.isThenable)(Z)&&(x||(x=[]),x.push(Z))}return x?(async()=>{for(const B of x){const _=await B;if(typeof _=="string")return _}return null})():null},O=T.find(U=>!!U.allBasenames);O&&(M.allBasenames=O.allBasenames);const F=T.reduce((U,H)=>H.allPaths?U.concat(H.allPaths):U,[]);return F.length&&(M.allPaths=F),M}const Q=function(M,O,F){let U,H;for(let x=0,B=T.length;x<B;x++){const _=T[x];_.requiresSiblings&&F&&(O||(O=(0,A.basename)(M)),U||(U=O.substr(0,O.length-(0,A.extname)(M).length)));const Z=_(M,O,U,F);if(typeof Z=="string")return Z;(0,t.isThenable)(Z)&&(H||(H=[]),H.push(Z))}return H?(async()=>{for(const x of H){const B=await x;if(typeof B=="string")return B}return null})():null},q=T.find(M=>!!M.allBasenames);q&&(Q.allBasenames=q.allBasenames);const j=T.reduce((M,O)=>O.allPaths?M.concat(O.allPaths):M,[]);return j.length&&(Q.allPaths=j),Q}function fe($,W,T){if(W===!1)return n;const z=a($,T);if(z===n)return n;if(typeof W=="boolean")return z;if(W){const Q=W.when;if(typeof Q=="string"){const q=(j,M,O,F)=>{if(!F||!z(j,M))return null;const U=Q.replace("$(basename)",()=>O),H=F(U);return(0,t.isThenable)(H)?H.then(x=>x?$:null):H?$:null};return q.requiresSiblings=!0,q}}return z}function K($,W){const T=$.filter(M=>!!M.basenames);if(T.length<2)return $;const z=T.reduce((M,O)=>{const F=O.basenames;return F?M.concat(F):M},[]);let Q;if(W){Q=[];for(let M=0,O=z.length;M<O;M++)Q.push(W)}else Q=T.reduce((M,O)=>{const F=O.patterns;return F?M.concat(F):M},[]);const q=function(M,O){if(typeof M!="string")return null;if(!O){let U;for(U=M.length;U>0;U--){const H=M.charCodeAt(U-1);if(H===47||H===92)break}O=M.substr(U)}const F=z.indexOf(O);return F!==-1?Q[F]:null};q.basenames=z,q.patterns=Q,q.allBasenames=z;const j=$.filter(M=>!M.basenames);return j.push(q),j}function le($,W){return(0,I.equals)($,W,(T,z)=>typeof T=="string"&&typeof z=="string"?T===z:typeof T!="string"&&typeof z!="string"?T.base===z.base&&T.pattern===z.pattern:!1)}e.patternsEquals=le}),define(te[34],ie([0,1,24,30,9,4,20,26]),function(V,e,I,t,k,R,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function w(n,a){const{os:r,tildify:c,relative:o}=a;if(o){const L=m(n,o,r);if(typeof L=="string")return L}let S=n.fsPath;if(r===1&&!R.isWindows?S=S.replace(/\//g,"\\"):r!==1&&R.isWindows&&(S=S.replace(/\\/g,"/")),r!==1&&c?.userHome){const L=c.userHome.fsPath;let N;n.scheme!==c.userHome.scheme&&n.path.startsWith(k.posix.sep)?N=c.userHome.with({path:n.path}).fsPath:N=n.fsPath,S=E(N,L,r)}return(r===1?k.win32:k.posix).normalize(y(S,r===1))}e.getPathLabel=w;function m(n,a,r){const c=r===1?k.win32:k.posix,o=r===3?A.extUri:A.extUriIgnorePathCase,S=a.getWorkspace(),D=(0,I.firstOrDefault)(S.folders);if(!D)return;n.scheme!==D.uri.scheme&&n.path.startsWith(k.posix.sep)&&(n=D.uri.with({path:n.path}));const L=a.getWorkspaceFolder(n);if(!L)return;let N;if(o.isEqual(L.uri,n)?N="":N=o.relativePath(L.uri,n)??"",N&&(N=c.normalize(N)),S.folders.length>1&&!a.noPrefix){const X=L.name?L.name:o.basenameOrAuthority(L.uri);N=N?`${X} \u2022 ${N}`:X}return N}function y(n,a=R.isWindows){return(0,t.hasDriveLetter)(n,a)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=y;let P=Object.create(null);function E(n,a,r=R.OS){if(r===1||!n||!a)return n;let c=P.original===a?P.normalized:void 0;c||(c=a,R.isWindows&&(c=(0,t.toSlashes)(c)),c=`${(0,C.rtrim)(c,k.posix.sep)}${k.posix.sep}`,P={original:a,normalized:c});let o=n;return R.isWindows&&(o=(0,t.toSlashes)(o)),(r===3?o.startsWith(c):(0,C.startsWithIgnoreCase)(o,c))?`~/${o.substr(c.length)}`:n}e.tildify=E;function h(n,a){return n.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=h;const d="\u2026",v="\\\\",b="~";function u(n,a=k.sep){const r=new Array(n.length);let c=!1;for(let o=0;o<n.length;o++){const S=n[o];if(S===""){r[o]=`.${a}`;continue}if(!S){r[o]=S;continue}c=!0;let D="",L=S;L.indexOf(v)===0?(D=L.substr(0,L.indexOf(v)+v.length),L=L.substr(L.indexOf(v)+v.length)):L.indexOf(a)===0?(D=L.substr(0,L.indexOf(a)+a.length),L=L.substr(L.indexOf(a)+a.length)):L.indexOf(b)===0&&(D=L.substr(0,L.indexOf(b)+b.length),L=L.substr(L.indexOf(b)+b.length));const N=L.split(a);for(let X=1;c&&X<=N.length;X++)for(let ae=N.length-X;c&&ae>=0;ae--){c=!1;let J=N.slice(ae,ae+X).join(a);for(let Y=0;!c&&Y<n.length;Y++)if(Y!==o&&n[Y]&&n[Y].indexOf(J)>-1){const se=ae+X===N.length,re=ae>0&&n[Y].indexOf(a)>-1?a+J:J,fe=n[Y].endsWith(re);c=!se||fe}if(!c){let Y="";(N[0].endsWith(":")||D!=="")&&(ae===1&&(ae=0,X++,J=N[0]+a+J),ae>0&&(Y=N[0]+a),Y=D+Y),ae>0&&(Y=Y+d+a),Y=Y+J,ae+X<N.length&&(Y=Y+a+d),r[o]=Y}}c&&(r[o]=S)}return r}e.shorten=u;var p;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function g(n,a=Object.create(null)){const r=[];let c=!1,o="";for(const S of n)if(S==="$"||c&&S==="{")o&&r.push({value:o,type:p.TEXT}),o="",c=!0;else if(S==="}"&&c){const D=a[o];if(typeof D=="string")D.length&&r.push({value:D,type:p.VARIABLE});else if(D){const L=r[r.length-1];(!L||L.type!==p.SEPARATOR)&&r.push({value:D.label,type:p.SEPARATOR})}o="",c=!1}else o+=S;return o&&!c&&r.push({value:o,type:p.TEXT}),r.filter((S,D)=>{if(S.type===p.SEPARATOR){const L=r[D-1],N=r[D+1];return[L,N].every(X=>X&&(X.type===p.VARIABLE||X.type===p.TEXT)&&X.value.length>0)}return!0}).map(S=>S.value).join("")}e.template=g;function f(n,a){return R.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):n.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.mnemonicMenuLabel=f;function l(n,a){return R.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,""):R.isWindows?n.replace(/&&|&/g,r=>r==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=l;function i(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=i;function s(n){const a=n.indexOf("/")!==-1?k.posix:k.win32,r=a.basename(n),c=a.dirname(n);return r.length?{name:r,parentPath:c}:{name:c,parentPath:""}}e.splitName=s}),define(te[140],ie([0,1,7]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(y){return y.toJSON()}class k{constructor(P){this.a=P}transformIncoming(P){const E=this.a.transformIncoming(P);return E===P?P:t(I.URI.from(E))}transformOutgoing(P){const E=this.a.transformOutgoing(P);return E===P?P:t(I.URI.from(E))}transformOutgoingURI(P){const E=this.a.transformOutgoing(P);return E===P?P:I.URI.from(E)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function R(y,P,E){if(!y||E>200)return null;if(typeof y=="object"){if(y instanceof I.URI)return P.transformOutgoing(y);for(const h in y)if(Object.hasOwnProperty.call(y,h)){const d=R(y[h],P,E+1);d!==null&&(y[h]=d)}}return null}function A(y,P){const E=R(y,P,0);return E===null?y:E}e.transformOutgoingURIs=A;function C(y,P,E,h){if(!y||h>200)return null;if(typeof y=="object"){if(y.$mid===1)return E?I.URI.revive(P.transformIncoming(y)):P.transformIncoming(y);for(const d in y)if(Object.hasOwnProperty.call(y,d)){const v=C(y[d],P,E,h+1);v!==null&&(y[d]=v)}}return null}function w(y,P){const E=C(y,P,!1,0);return E===null?y:E}e.transformIncomingURIs=w;function m(y,P){const E=C(y,P,!0,0);return E===null?y:E}e.transformAndReviveIncomingURIs=m}),define(te[81],ie([0,1,25,14,60,29,128]),function(V,e,I,t,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(y){return this.a||(this.a=k.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(y)}value(){if(this.b===void 0){let y=0,P=0;const E=(0,I.networkInterfaces)();for(const h in E){const d=E[h];if(d)for(const{mac:v,internal:b}of d)b||(P+=1,this.c(v.toUpperCase())&&(y+=1))}this.b=P>0?y/P:0}return this.b}};let C;async function w(){return C||(C=(async()=>await m()||R.generateUuid())()),C}e.getMachineId=w;async function m(){try{const y=await new Promise((E,h)=>{V(["crypto"],E,h)}),P=(0,A.getMac)();return y.createHash("sha256").update(P,"utf8").digest("hex")}catch(y){t.onUnexpectedError(y);return}}}),define(te[23],ie([0,1,40,25,141,8,30,76,9,4,20,7]),function(V,e,I,t,k,R,A,C,w,m,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(re){re[re.UNLINK=0]="UNLINK",re[re.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function h(re,fe=E.UNLINK){if((0,A.isRootOrDriveLetter)(re))throw new Error("rimraf - will refuse to recursively delete root");return fe===E.UNLINK?v(re):d(re)}async function d(re){try{const fe=(0,A.randomPath)((0,t.tmpdir)());try{await I.promises.rename(re,fe)}catch(K){return K.code==="ENOENT"?void 0:v(re)}v(fe).catch(K=>{})}catch(fe){if(fe.code!=="ENOENT")throw fe}}async function v(re){return(0,k.promisify)(I.rm)(re,{recursive:!0,force:!0,maxRetries:3})}function b(re){if((0,A.isRootOrDriveLetter)(re))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(re,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=b;async function u(re,fe){return f(await(fe?p(re):(0,k.promisify)(I.readdir)(re)))}async function p(re){try{return await(0,k.promisify)(I.readdir)(re,{withFileTypes:!0})}catch(le){console.warn("[node.js fs] readdir with filetypes failed with error: ",le)}const fe=[],K=await u(re);for(const le of K){let $=!1,W=!1,T=!1;try{const z=await e.Promises.lstat((0,w.join)(re,le));$=z.isFile(),W=z.isDirectory(),T=z.isSymbolicLink()}catch(z){console.warn("[node.js fs] unexpected error from lstat after readdir: ",z)}fe.push({name:le,isFile:()=>$,isDirectory:()=>W,isSymbolicLink:()=>T})}return fe}function g(re){return f(I.readdirSync(re))}e.readdirSync=g;function f(re){return re.map(fe=>typeof fe=="string"?m.isMacintosh?(0,C.normalizeNFC)(fe):fe:(fe.name=m.isMacintosh?(0,C.normalizeNFC)(fe.name):fe.name,fe))}async function l(re){const fe=await u(re),K=[];for(const le of fe)await s.existsDirectory((0,w.join)(re,le))&&K.push(le);return K}function i(re,fe=1e3){return new Promise(K=>{let le=!1;const $=setInterval(()=>{le||(le=!0,I.access(re,W=>{le=!1,W&&(clearInterval($),K(void 0))}))},fe)})}e.whenDeleted=i;var s;(function(re){async function fe($){let W;try{if(W=await e.Promises.lstat($),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat($),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(T){if(T.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(m.isWindows&&T.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink($)),symbolicLink:{dangling:!1}}}catch(z){if(z.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw z}throw T}}re.stat=fe;async function K($){try{const{stat:W,symbolicLink:T}=await re.stat($);return W.isFile()&&T?.dangling!==!0}catch{}return!1}re.existsFile=K;async function le($){try{const{stat:W,symbolicLink:T}=await re.stat($);return W.isDirectory()&&T?.dangling!==!0}catch{}return!1}re.existsDirectory=le})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new R.ResourceQueue;function a(re,fe,K){return n.queueFor(P.URI.file(re),y.extUriBiasedIgnorePathCase).queue(()=>{const le=D(K);return new Promise(($,W)=>o(re,fe,le,T=>T?W(T):$()))})}let r=!0;function c(re){r=re}e.configureFlushOnWrite=c;function o(re,fe,K,le){if(!r)return I.writeFile(re,fe,{mode:K.mode,flag:K.flag},le);I.open(re,K.flag,K.mode,($,W)=>{if($)return le($);I.writeFile(W,fe,T=>{if(T)return I.close(W,()=>le(T));I.fdatasync(W,z=>(z&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",z),c(!1)),I.close(W,Q=>le(Q))))})})}function S(re,fe,K){const le=D(K);if(!r)return I.writeFileSync(re,fe,{mode:le.mode,flag:le.flag});const $=I.openSync(re,le.flag,le.mode);try{I.writeFileSync($,fe);try{I.fdatasyncSync($)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),c(!1)}}finally{I.closeSync($)}}e.writeFileSync=S;function D(re){return re?{mode:typeof re.mode=="number"?re.mode:438,flag:typeof re.flag=="string"?re.flag:"w"}:{mode:438,flag:"w"}}async function L(re,fe){if(re!==fe)try{await e.Promises.rename(re,fe)}catch(K){if(re.toLowerCase()!==fe.toLowerCase()&&K.code==="EXDEV"||re.endsWith("."))await N(re,fe,{preserveSymlinks:!1}),await h(re,E.MOVE);else throw K}}async function N(re,fe,K){return ae(re,fe,{root:{source:re,target:fe},options:K,handledSourcePaths:new Set})}const X=511;async function ae(re,fe,K){if(K.handledSourcePaths.has(re))return;K.handledSourcePaths.add(re);const{stat:le,symbolicLink:$}=await s.stat(re);if($){if(K.options.preserveSymlinks)try{return await se(re,fe,K)}catch(W){console.warn("[node.js fs] copy of symlink failed: ",W)}if($.dangling)return}return le.isDirectory()?J(re,fe,le.mode&X,K):Y(re,fe,le.mode&X)}async function J(re,fe,K,le){await e.Promises.mkdir(fe,{recursive:!0,mode:K});const $=await u(re);for(const W of $)await ae((0,w.join)(re,W),(0,w.join)(fe,W),le)}async function Y(re,fe,K){await e.Promises.copyFile(re,fe),await e.Promises.chmod(fe,K)}async function se(re,fe,K){let le=await e.Promises.readlink(re);(0,A.isEqualOrParent)(le,K.root.source,!m.isLinux)&&(le=(0,w.join)(K.root.target,le.substr(K.root.source.length+1))),await e.Promises.symlink(le,fe)}e.Promises=new class{get access(){return(0,k.promisify)(I.access)}get stat(){return(0,k.promisify)(I.stat)}get lstat(){return(0,k.promisify)(I.lstat)}get utimes(){return(0,k.promisify)(I.utimes)}get read(){return(re,fe,K,le,$)=>new Promise((W,T)=>{I.read(re,fe,K,le,$,(z,Q,q)=>z?T(z):W({bytesRead:Q,buffer:q}))})}get readFile(){return(0,k.promisify)(I.readFile)}get write(){return(re,fe,K,le,$)=>new Promise((W,T)=>{I.write(re,fe,K,le,$,(z,Q,q)=>z?T(z):W({bytesWritten:Q,buffer:q}))})}get appendFile(){return(0,k.promisify)(I.appendFile)}get fdatasync(){return(0,k.promisify)(I.fdatasync)}get truncate(){return(0,k.promisify)(I.truncate)}get rename(){return(0,k.promisify)(I.rename)}get copyFile(){return(0,k.promisify)(I.copyFile)}get open(){return(0,k.promisify)(I.open)}get close(){return(0,k.promisify)(I.close)}get symlink(){return(0,k.promisify)(I.symlink)}get readlink(){return(0,k.promisify)(I.readlink)}get chmod(){return(0,k.promisify)(I.chmod)}get mkdir(){return(0,k.promisify)(I.mkdir)}get unlink(){return(0,k.promisify)(I.unlink)}get rmdir(){return(0,k.promisify)(I.rmdir)}get realpath(){return(0,k.promisify)(I.realpath)}async exists(re){try{return await e.Promises.access(re),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return l}get writeFile(){return a}get rm(){return h}get move(){return L}get copy(){return N}}}),define(te[100],ie([0,1,40,9,4,26,23]),function(V,e,I,t,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function C(E){if(k.isLinux)return E;const h=(0,t.dirname)(E);if(E===h)return E;const d=((0,t.basename)(E)||E).toLowerCase();try{const b=(0,A.readdirSync)(h).filter(u=>u.toLowerCase()===d);if(b.length===1){const u=C(h);if(u)return(0,t.join)(u,b[0])}else if(b.length>1){const u=b.indexOf(d);if(u>=0){const p=C(h);if(p)return(0,t.join)(p,b[u])}}}catch{}return null}e.realcaseSync=C;async function w(E){if(k.isLinux)return E;const h=(0,t.dirname)(E);if(E===h)return E;const d=((0,t.basename)(E)||E).toLowerCase();try{const b=(await A.Promises.readdir(h)).filter(u=>u.toLowerCase()===d);if(b.length===1){const u=await w(h);if(u)return(0,t.join)(u,b[0])}else if(b.length>1){const u=b.indexOf(d);if(u>=0){const p=await w(h);if(p)return(0,t.join)(p,b[u])}}}catch{}return null}e.realcase=w;async function m(E){try{return await A.Promises.realpath(E)}catch{const d=P(E);return await A.Promises.access(d,I.constants.R_OK),d}}e.realpath=m;function y(E){try{return I.realpathSync(E)}catch{const d=P(E);return I.accessSync(d,I.constants.R_OK),d}}e.realpathSync=y;function P(E){return(0,R.rtrim)((0,t.normalize)(E),t.sep)}}),define(te[142],ie([0,1,25,9,23]),function(V,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,A=/^Microsoft.PowerShell_.*/,C=/^Microsoft.PowerShellPreview_.*/;var w;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(w||(w={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class P{constructor(l,i,s){this.exePath=l,this.displayName=i,this.a=s}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function E({useAlternateBitness:f=!1}={}){return f?m===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:f=!1,findPreview:l=!1}={}){const i=E({useAlternateBitness:f});if(!i)return null;const s=t.join(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(s))return null;let n=-1,a=null;for(const o of await k.Promises.readdir(s)){let S=-1;if(l){const L=o.indexOf("-");if(L<0)continue;const N=o.substring(0,L);if(!R.test(N)||o.substring(L+1)!=="preview")continue;S=parseInt(N,10)}else{if(!R.test(o))continue;S=parseInt(o,10)}if(S<=n)continue;const D=t.join(s,o,"pwsh.exe");!await k.SymlinkSupport.existsFile(D)||(a=D,n=S)}if(!a)return null;const r=i.includes("x86")?" (x86)":"",c=l?" Preview":"";return new P(a,`PowerShell${c}${r}`,!0)}async function d({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const l=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:i,pwshMsixName:s}=f?{pwshMsixDirRegex:C,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const n of await k.Promises.readdir(l))if(i.test(n)){const a=t.join(l,n,"pwsh.exe");return new P(a,s)}return null}function v(){const f=t.join(I.homedir(),".dotnet","tools","pwsh.exe");return new P(f,".NET Core PowerShell Global Tool")}function b(){const f=t.join(process.env.windir,m===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new P(f,"Windows PowerShell",!0)}async function*u(){let f=await h();f&&(yield f),f=await h({useAlternateBitness:!0}),f&&(yield f),f=await d(),f&&(yield f),f=v(),f&&(yield f),f=await h({findPreview:!0}),f&&(yield f),f=await d({findPreview:!0}),f&&(yield f),f=await h({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=b(),f&&(yield f)}async function*p(){for await(const f of u())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=p;async function g(){for await(const f of p())return f;return null}e.getFirstAvailablePowerShellInstallation=g}),define(te[82],ie([0,1,9,4,33,79,12,23]),function(V,e,I,t,k,R,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function w(P=k.env){return P.comspec||"cmd.exe"}e.getWindowsShell=w;function m(P){let E=[],h=!1;const d=function(v){if(h){E.push(v);return}(!P.send(v,u=>{if(u&&console.error(u),h=!1,E.length>0){const p=E.slice(0);E=[],p.forEach(g=>d(g))}})||t.isWindows)&&(h=!0)};return{send:d}}e.createQueuedSender=m;var y;(function(P){async function E(h,d,v){if(I.isAbsolute(h))return h;if(d===void 0&&(d=k.cwd()),I.dirname(h)!=="."||(v===void 0&&A.isString(k.env.PATH)&&(v=k.env.PATH.split(I.delimiter)),v===void 0||v.length===0))return I.join(d,h);async function u(p){if(await C.Promises.exists(p)){let g;try{g=await C.Promises.stat(p)}catch(f){f.message.startsWith("EACCES")&&(g=await C.Promises.lstat(p))}return g?!g.isDirectory():!1}return!1}for(const p of v){let g;if(I.isAbsolute(p)?g=I.join(p,h):g=I.join(d,p,h),await u(g))return g;let f=g+".com";if(await u(f)||(f=g+".exe",await u(f)))return f}return I.join(d,h)}P.findExecutable=E})(y=e.win32||(e.win32={}))}),define(te[101],ie([0,1,46,15]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(A){return new Promise((C,w)=>{let m;const y=new Map;function P(h,d,v,b,u){const p=y.get(d);if(h===A||p){const g={name:E(v),cmd:v,pid:h,ppid:d,load:b,mem:u};y.set(h,g),h===A&&(m=g),p&&(p.children||(p.children=[]),p.children.push(g),p.children.length>1&&(p.children=p.children.sort((f,l)=>f.pid-l.pid)))}}function E(h){const d=/--vscode-window-kind=shared-process/,v=/--vscode-window-kind=issue-reporter/,b=/--vscode-window-kind=process-explorer/,u=/--utility-sub-type=network/,p=/--utility-sub-type=node.mojom.NodeService/,g=/--crashes-directory/,f=/\\pipe\\winpty-control/,l=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(g.exec(h))return"electron-crash-reporter";if(f.exec(h))return"winpty-process";if(l.exec(h))return"console-window-host (Windows internal process)";let s=i.exec(h);if(s&&s.length===2){if(s[1]==="renderer")return d.exec(h)?"shared-process":v.exec(h)?"issue-reporter":b.exec(h)?"process-explorer":"window";if(s[1]==="utility"){if(u.exec(h))return"utility-network-service";if(p.exec(h))return"extension-host"}return s[1]}const n=/[a-zA-Z-]+\.js/g;let a="";do s=n.exec(h),s&&(a+=s+" ");while(s);return a&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron_node ${a}`:h}if(process.platform==="win32"){const h=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,v)=>{V(["windows-process-tree"],d,v)}).then(d=>{d.getProcessList(A,v=>{if(!v){w(new Error(`Root process ${A} not found`));return}d.getProcessCpuUsage(v,b=>{const u=new Map;b.forEach(p=>{const g=h(p.commandLine||"");u.set(p.pid,{name:E(g),cmd:g,pid:p.pid,ppid:p.ppid,load:p.cpu||0,mem:p.memory||0})}),m=u.get(A),m?(u.forEach(p=>{const g=u.get(p.ppid);g&&(g.children||(g.children=[]),g.children.push(p))}),u.forEach(p=>{p.children&&(p.children=p.children.sort((g,f)=>g.pid-f.pid))}),C(m)):w(new Error(`Root process ${A} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let h=function(){let d=[m];const v=[];for(;d.length;){const u=d.shift();u&&(v.push(u.pid),u.children&&(d=d.concat(u.children)))}let b=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);b+=" "+v.join(" "),(0,I.exec)(b,{},(u,p,g)=>{if(u||g)w(u||new Error(g.toString()));else{const f=p.toString().split(`
`);for(let l=0;l<v.length;l++){const i=y.get(v[l]);i.load=parseFloat(f[l])}if(!m){w(new Error(`Root process ${A} not found`));return}C(m)}})};(0,I.exec)("which ps",{},(d,v,b)=>{if(d||b)if(process.platform!=="linux")w(d||new Error(b.toString()));else{const u=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(u,{},(p,g,f)=>{p||f?w(p||new Error(f.toString())):(R(g,P),h())})}else{const u=v.toString().trim(),p="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,I.exec)(`${u} ${p}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,f,l)=>{g||l&&!l.includes("screen size is bogus")?w(g||new Error(l.toString())):(R(f,P),process.platform==="linux"?h():m?C(m):w(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=k;function R(A,C){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=A.toString().split(`
`);for(const y of m){const P=w.exec(y.trim());P&&P.length===6&&C(parseInt(P[1]),parseInt(P[2]),P[5],parseFloat(P[3]),parseFloat(P[4]))}}}),define(te[143],ie([0,1,25,4,142,82]),function(V,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function A(P,E){return P===1?t.isWindows?y():R.getWindowsShell(E):w(P,E)}e.getSystemShell=A;let C=null;function w(P,E){if(t.isLinux&&P===2||t.isMacintosh&&P===3)return"/bin/bash";if(!C){let h;if(t.isWindows)h="/bin/bash";else{if(h=E.SHELL,!h)try{h=(0,I.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}C=h}return C}let m=null;async function y(){return m||(m=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),m}});var pe=this&&this.__decorate||function(V,e,I,t){var k=arguments.length,R=k<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,I):t,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(V,e,I,t);else for(var C=V.length-1;C>=0;C--)(A=V[C])&&(R=(k<3?A(R):k>3?A(e,I,R):A(e,I))||R);return k>3&&R&&Object.defineProperty(e,I,R),R};define(te[47],ie([0,1,24,8,17,22,53,14,3,2,69,26,12]),function(V,e,I,t,k,R,A,C,w,m,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var h;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(h||(h={}));function d(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(v||(v={}));function b(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(u||(u={}));function p(W){let T=0;for(let z=0;;z+=7){const Q=W.read(1);if(T|=(Q.buffer[0]&127)<<z,!(Q.buffer[0]&128))return T}}const g=n(0);function f(W,T){if(T===0){W.write(g);return}let z=0;for(let q=T;q!==0;q=q>>>7)z++;const Q=k.VSBuffer.alloc(z);for(let q=0;T!==0;q++)Q.buffer[q]=T&127,T=T>>>7,T>0&&(Q.buffer[q]|=128);W.write(Q)}class l{constructor(T){this.b=T,this.a=0}read(T){const z=this.b.slice(this.a,this.a+T);return this.a+=z.byteLength,z}}e.BufferReader=l;class i{constructor(){this.a=[]}get buffer(){return k.VSBuffer.concat(this.a)}write(T){this.a.push(T)}}e.BufferWriter=i;var s;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object",W[W.Int=6]="Int"})(s||(s={}));function n(W){const T=k.VSBuffer.alloc(1);return T.writeUInt8(W,0),T}const a={Undefined:n(s.Undefined),String:n(s.String),Buffer:n(s.Buffer),VSBuffer:n(s.VSBuffer),Array:n(s.Array),Object:n(s.Object),Uint:n(s.Int)},r=typeof Buffer<"u";function c(W,T){if(typeof T>"u")W.write(a.Undefined);else if(typeof T=="string"){const z=k.VSBuffer.fromString(T);W.write(a.String),f(W,z.byteLength),W.write(z)}else if(r&&Buffer.isBuffer(T)){const z=k.VSBuffer.wrap(T);W.write(a.Buffer),f(W,z.byteLength),W.write(z)}else if(T instanceof k.VSBuffer)W.write(a.VSBuffer),f(W,T.byteLength),W.write(T);else if(Array.isArray(T)){W.write(a.Array),f(W,T.length);for(const z of T)c(W,z)}else if(typeof T=="number"&&(T|0)===T)W.write(a.Uint),f(W,T);else{const z=k.VSBuffer.fromString(JSON.stringify(T));W.write(a.Object),f(W,z.byteLength),W.write(z)}}e.serialize=c;function o(W){switch(W.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return W.read(p(W)).toString();case s.Buffer:return W.read(p(W)).buffer;case s.VSBuffer:return W.read(p(W));case s.Array:{const z=p(W),Q=[];for(let q=0;q<z;q++)Q.push(o(W));return Q}case s.Object:return JSON.parse(W.read(p(W)).toString());case s.Int:return p(W)}}e.deserialize=o;class S{constructor(T,z,Q=null,q=1e3){this.h=T,this.j=z,this.k=Q,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(j=>this.q(j)),this.m({type:200})}registerChannel(T,z){this.b.set(T,z),setTimeout(()=>this.w(T),0)}m(T){switch(T.type){case 200:{const z=this.o([T.type]);this.k?.logOutgoing(z,0,1,b(T.type));return}case 201:case 202:case 204:case 203:{const z=this.o([T.type,T.id],T.data);this.k?.logOutgoing(z,T.id,1,b(T.type),T.data);return}}}o(T,z=void 0){const Q=new i;return c(Q,T),c(Q,z),this.p(Q.buffer)}p(T){try{return this.h.send(T),T.byteLength}catch{return 0}}q(T){const z=new l(T),Q=o(z),q=o(z),j=Q[0];switch(j){case 100:return this.k?.logIncoming(T.byteLength,Q[1],1,`${d(j)}: ${Q[2]}.${Q[3]}`,q),this.s({type:j,id:Q[1],channelName:Q[2],name:Q[3],arg:q});case 102:return this.k?.logIncoming(T.byteLength,Q[1],1,`${d(j)}: ${Q[2]}.${Q[3]}`,q),this.t({type:j,id:Q[1],channelName:Q[2],name:Q[3],arg:q});case 101:return this.k?.logIncoming(T.byteLength,Q[1],1,`${d(j)}`),this.u({type:j,id:Q[1]});case 103:return this.k?.logIncoming(T.byteLength,Q[1],1,`${d(j)}`),this.u({type:j,id:Q[1]})}}s(T){const z=this.b.get(T.channelName);if(!z){this.v(T);return}const Q=new R.CancellationTokenSource;let q;try{q=z.call(this.j,T.name,T.arg,Q.token)}catch(O){q=Promise.reject(O)}const j=T.id;q.then(O=>{this.m({id:j,data:O,type:201}),this.d.delete(T.id)},O=>{O instanceof Error?this.m({id:j,data:{message:O.message,name:O.name,stack:O.stack?O.stack.split?O.stack.split(`
`):O.stack:void 0},type:202}):this.m({id:j,data:O,type:203}),this.d.delete(T.id)});const M=(0,m.toDisposable)(()=>Q.cancel());this.d.set(T.id,M)}t(T){const z=this.b.get(T.channelName);if(!z){this.v(T);return}const Q=T.id,j=z.listen(this.j,T.name,T.arg)(M=>this.m({id:Q,data:M,type:204}));this.d.set(T.id,j)}u(T){const z=this.d.get(T.id);z&&(z.dispose(),this.d.delete(T.id))}v(T){let z=this.g.get(T.channelName);z||(z=[],this.g.set(T.channelName,z));const Q=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.m({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);z.push({request:T,timeoutTimer:Q})}w(T){const z=this.g.get(T);if(z){for(const Q of z)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case 100:this.s(Q.request);break;case 102:this.t(Q.request);break}this.g.delete(T)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,m.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=S;var D;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(D=e.RequestInitiator||(e.RequestInitiator={}));class L{constructor(T,z=null){this.l=T,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new w.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Q=>this.s(Q)),this.j=z}getChannel(T){const z=this;return{call(Q,q,j){return z.a?Promise.reject(new C.CancellationError):z.m(T,Q,q,j)},listen(Q,q){return z.a?w.Event.None:z.o(T,Q,q)}}}m(T,z,Q,q=R.CancellationToken.None){const j=this.g++,O={id:j,type:100,channelName:T,name:z,arg:Q};if(q.isCancellationRequested)return Promise.reject(new C.CancellationError);let F;return new Promise((H,x)=>{if(q.isCancellationRequested)return x(new C.CancellationError);const B=()=>{const ge=ke=>{switch(ke.type){case 201:this.f.delete(j),H(ke.data);break;case 202:{this.f.delete(j);const Oe=new Error(ke.data.message);Oe.stack=Array.isArray(ke.data.stack)?ke.data.stack.join(`
`):ke.data.stack,Oe.name=ke.data.name,x(Oe);break}case 203:this.f.delete(j),x(ke.data);break}};this.f.set(j,ge),this.p(O)};let _=null;this.b===u.Idle?B():(_=(0,t.createCancelablePromise)(ge=>this.u()),_.then(()=>{_=null,B()}));const Z=()=>{_?(_.cancel(),_=null):this.p({id:j,type:101}),x(new C.CancellationError)},oe=q.onCancellationRequested(Z);F=(0,m.combinedDisposable)((0,m.toDisposable)(Z),oe),this.d.add(F)}).finally(()=>{this.d.delete(F)})}o(T,z,Q){const q=this.g++,M={id:q,type:102,channelName:T,name:z,arg:Q};let O=null;const F=new w.Emitter({onWillAddFirstListener:()=>{O=(0,t.createCancelablePromise)(H=>this.u()),O.then(()=>{O=null,this.d.add(F),this.p(M)})},onDidRemoveLastListener:()=>{O?(O.cancel(),O=null):(this.d.delete(F),this.p({id:q,type:103}))}}),U=H=>F.fire(H.data);return this.f.set(q,U),F.event}p(T){switch(T.type){case 100:case 102:{const z=this.q([T.type,T.id,T.channelName,T.name],T.arg);this.j?.logOutgoing(z,T.id,0,`${d(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const z=this.q([T.type,T.id]);this.j?.logOutgoing(z,T.id,0,d(T.type));return}}}q(T,z=void 0){const Q=new i;return c(Q,T),c(Q,z),this.r(Q.buffer)}r(T){try{return this.l.send(T),T.byteLength}catch{return 0}}s(T){const z=new l(T),Q=o(z),q=o(z),j=Q[0];switch(j){case 200:return this.j?.logIncoming(T.byteLength,0,0,b(j)),this.t({type:Q[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(T.byteLength,Q[1],0,b(j),q),this.t({type:Q[0],id:Q[1],data:q})}}t(T){if(T.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(T.id)?.(T)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,m.dispose)(this.d.values()),this.d.clear()}}pe([A.memoize],L.prototype,"onDidInitializePromise",null),e.ChannelClient=L;class N{get connections(){const T=[];return this.f.forEach(z=>T.push(z)),T}constructor(T){this.a=new Map,this.f=new Set,this.g=new w.Emitter,this.onDidAddConnection=this.g.event,this.h=new w.Emitter,this.onDidRemoveConnection=this.h.event,T(({protocol:z,onDidClientDisconnect:Q})=>{w.Event.once(z.onMessage)(j=>{const M=new l(j),O=o(M),F=new S(z,O),U=new L(z);this.a.forEach((x,B)=>F.registerChannel(B,x));const H={channelServer:F,channelClient:U,ctx:O};this.f.add(H),this.g.fire(H),Q(()=>{F.dispose(),U.dispose(),this.f.delete(H),this.h.fire(H)})})})}getChannel(T,z){const Q=this;return{call(q,j,M){let O;if((0,E.isFunction)(z)){const U=(0,I.getRandomElement)(Q.connections.filter(z));O=U?Promise.resolve(U):w.Event.toPromise(w.Event.filter(Q.onDidAddConnection,z))}else O=z.routeCall(Q,q,j);const F=O.then(U=>U.channelClient.getChannel(T));return ae(F).call(q,j,M)},listen(q,j){if((0,E.isFunction)(z))return Q.j(T,z,q,j);const M=z.routeEvent(Q,q,j).then(O=>O.channelClient.getChannel(T));return ae(M).listen(q,j)}}}j(T,z,Q,q){const j=this;let M=new m.DisposableStore;const O=new w.Emitter({onWillAddFirstListener:()=>{M=new m.DisposableStore;const F=new w.EventMultiplexer,U=new Map,H=B=>{const Z=B.channelClient.getChannel(T).listen(Q,q),oe=F.add(Z);U.set(B,oe)},x=B=>{const _=U.get(B);!_||(_.dispose(),U.delete(B))};j.connections.filter(z).forEach(H),w.Event.filter(j.onDidAddConnection,z)(H,void 0,M),j.onDidRemoveConnection(x,void 0,M),F.event(O.fire,O,M),M.add(F)},onDidRemoveLastListener:()=>{M.dispose()}});return O.event}registerChannel(T,z){this.a.set(T,z),this.f.forEach(Q=>{Q.channelServer.registerChannel(T,z)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=N;class X{constructor(T,z,Q=null){const q=new i;c(q,z),T.send(q.buffer),this.a=new L(T,Q),this.d=new S(T,z,Q)}getChannel(T){return this.a.getChannel(T)}registerChannel(T,z){this.d.registerChannel(T,z)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=X;function ae(W){return{call(T,z,Q){return W.then(q=>q.call(T,z,Q))},listen(T,z){const Q=new w.Relay;return W.then(q=>Q.input=q.listen(T,z)),Q.event}}}e.getDelayedChannel=ae;function J(W){let T=!1;return{call(z,Q,q){return T?W.call(z,Q,q):(0,t.timeout)(0).then(()=>T=!0).then(()=>W.call(z,Q,q))},listen(z,Q){if(T)return W.listen(z,Q);const q=new w.Relay;return(0,t.timeout)(0).then(()=>T=!0).then(()=>q.input=W.listen(z,Q)),q.event}}}e.getNextTickChannel=J;class Y{constructor(T){this.a=T}routeCall(T){return this.b(T)}routeEvent(T){return this.b(T)}async b(T){for(const z of T.connections)if(await Promise.resolve(this.a(z.ctx)))return Promise.resolve(z);return await w.Event.toPromise(T.onDidAddConnection),await this.b(T)}}e.StaticRouter=Y;var se;(function(W){function T(j,M){const O=j,F=M&&M.disableMarshalling,U=new Map;for(const H in O)Q(H)&&U.set(H,w.Event.buffer(O[H],!0));return new class{listen(H,x,B){const _=U.get(x);if(_)return _;if(q(x)){const Z=O[x];if(typeof Z=="function")return Z.call(O,B)}throw new Error(`Event not found: ${x}`)}call(H,x,B){const _=O[x];if(typeof _=="function"){if(!F&&Array.isArray(B))for(let Z=0;Z<B.length;Z++)B[Z]=(0,y.revive)(B[Z]);return _.apply(O,B)}throw new Error(`Method not found: ${x}`)}}}W.fromService=T;function z(j,M){const O=M&&M.disableMarshalling;return new Proxy({},{get(F,U){if(typeof U=="string")return M?.properties?.has(U)?M.properties.get(U):q(U)?function(H){return j.listen(U,H)}:Q(U)?j.listen(U):async function(...H){let x;M&&!(0,E.isUndefinedOrNull)(M.context)?x=[M.context,...H]:x=H;const B=await j.call(U,x);return O?B:(0,y.revive)(B)};throw new Error(`Property not found: ${String(U)}`)}})}W.toService=z;function Q(j){return j[0]==="o"&&j[1]==="n"&&P.isUpperAsciiLetter(j.charCodeAt(2))}function q(j){return/^onDynamic/.test(j)&&P.isUpperAsciiLetter(j.charCodeAt(9))}})(se=e.ProxyChannel||(e.ProxyChannel={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function fe(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const T=W.toString();if(T!=="[object Object]")return T}return W}function K(W){return Array.isArray(W)?W.map(fe):fe(W)}function le(W,T,z,Q,q,j,M){M=K(M);const O=re[q],F=O[Q%O.length];let U=[`%c[${W}]%c[${String(T).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${j}`,"color: darkgreen","color: grey","color: grey",`color: ${F}`];/\($/.test(j)?(U=U.concat(M),U.push(")")):U.push(M),console.log.apply(console,U)}class ${constructor(T,z){this.d=T,this.f=z,this.a=0,this.b=0}logOutgoing(T,z,Q,q,j){this.b+=T,le(this.d,this.b,T,z,Q,q,j)}logIncoming(T,z,Q,q,j){this.a+=T,le(this.f,this.a,T,z,Q,q,j)}}e.IPCLogger=$}),define(te[144],ie([0,1,17,3,47]),function(V,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(w){this.a=w,this.onMessage=t.Event.fromDOMEventEmitter(this.a,"message",m=>I.VSBuffer.wrap(m.data)),w.start()}send(w){this.a.postMessage(w.buffer)}disconnect(){this.a.close()}}e.Protocol=R;class A extends k.IPCClient{constructor(w,m){const y=new R(w);super(y,m),this.b=y}dispose(){this.b.disconnect()}}e.Client=A}),define(te[102],ie([0,1,17,3,2,47]),function(V,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(a){a.Created="created",a.Read="read",a.Write="write",a.Open="open",a.Error="error",a.Close="close",a.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",a.NodeEndReceived="nodeEndReceived",a.NodeEndSent="nodeEndSent",a.NodeDrainBegin="nodeDrainBegin",a.NodeDrainEnd="nodeDrainEnd",a.zlibInflateError="zlibInflateError",a.zlibInflateData="zlibInflateData",a.zlibInflateInitialWrite="zlibInflateInitialWrite",a.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",a.zlibInflateWrite="zlibInflateWrite",a.zlibInflateFlushFired="zlibInflateFlushFired",a.zlibDeflateError="zlibDeflateError",a.zlibDeflateData="zlibDeflateData",a.zlibDeflateWrite="zlibDeflateWrite",a.zlibDeflateFlushFired="zlibDeflateFlushFired",a.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",a.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",a.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",a.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",a.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",a.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",a.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",a.ProtocolHeaderRead="protocolHeaderRead",a.ProtocolMessageRead="protocolMessageRead",a.ProtocolHeaderWrite="protocolHeaderWrite",a.ProtocolMessageWrite="protocolMessageWrite",a.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var C;(function(a){a.enableDiagnostics=!1,a.records=[];const r=new WeakMap;let c=0;function o(D,L){if(!r.has(D)){const N=String(++c);r.set(D,N)}return r.get(D)}function S(D,L,N,X){if(!a.enableDiagnostics)return;const ae=o(D,L);if(X instanceof I.VSBuffer||X instanceof Uint8Array||X instanceof ArrayBuffer||ArrayBuffer.isView(X)){const J=I.VSBuffer.alloc(X.byteLength);J.set(X),a.records.push({timestamp:Date.now(),id:ae,label:L,type:N,buff:J})}else a.records.push({timestamp:Date.now(),id:ae,label:L,type:N,data:X})}a.traceSocketEvent=S})(C=e.SocketDiagnostics||(e.SocketDiagnostics={}));var w;(function(a){a[a.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",a[a.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let m=null;function y(){return m||(m=I.VSBuffer.alloc(0)),m}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(r){this.a.push(r),this.b+=r.byteLength}read(r){return this.c(r,!0)}peek(r){return this.c(r,!1)}c(r,c){if(r===0)return y();if(r>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===r){const L=this.a[0];return c&&(this.a.shift(),this.b-=r),L}if(this.a[0].byteLength>r){const L=this.a[0].slice(0,r);return c&&(this.a[0]=this.a[0].slice(r),this.b-=r),L}const o=I.VSBuffer.alloc(r);let S=0,D=0;for(;r>0;){const L=this.a[D];if(L.byteLength>r){const N=L.slice(0,r);o.set(N,S),S+=r,c&&(this.a[D]=L.slice(r),this.b-=r),r-=r}else o.set(L,S),S+=L.byteLength,c?(this.a.shift(),this.b-=L.byteLength):D++,r-=L.byteLength}return o}}e.ChunkStream=P;var E;(function(a){a[a.None=0]="None",a[a.Regular=1]="Regular",a[a.Control=2]="Control",a[a.Ack=3]="Ack",a[a.Disconnect=5]="Disconnect",a[a.ReplayRequest=6]="ReplayRequest",a[a.Pause=7]="Pause",a[a.Resume=8]="Resume",a[a.KeepAlive=9]="KeepAlive"})(E||(E={}));function h(a){switch(a){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(a){a[a.HeaderLength=13]="HeaderLength",a[a.AcknowledgeTime=2e3]="AcknowledgeTime",a[a.TimeoutTime=2e4]="TimeoutTime",a[a.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",a[a.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class v{constructor(r,c,o,S){this.type=r,this.id=c,this.ack=o,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends k.Disposable{constructor(r){super(),this.f=this.B(new t.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=r,this.b=!1,this.c=new P,this.B(this.a.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(r);this.c.byteLength>=this.g.readLen;){const c=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=c.readUInt32BE(9),this.g.messageType=c.readUInt8(0),this.g.id=c.readUInt32BE(1),this.g.ack=c.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const o=this.g.messageType,S=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",c),this.f.fire(new v(o,S,D,c)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class u{constructor(r){this.k=null,this.a=!1,this.b=!1,this.c=r,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(r){if(this.a)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=I.VSBuffer.alloc(13);c.writeUInt8(r.type,0),c.writeUInt32BE(r.id,1),c.writeUInt32BE(r.ack,5),c.writeUInt32BE(r.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",r.data),this.j(c,r.data)}g(r,c){const o=this.f===0;return this.d.push(r,c),this.f+=r.byteLength+c.byteLength,o}h(){const r=I.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,r}j(r,c){this.g(r,c)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const r=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this.c.write(r)}}class p extends k.Disposable{constructor(r){super(),this.f=new t.Emitter,this.onMessage=this.f.event,this.g=new t.Emitter,this.onDidDispose=this.g.event,this.a=r,this.b=this.B(new u(this.a)),this.c=this.B(new b(this.a)),this.B(this.c.onMessage(c=>{c.type===1&&this.f.fire(c.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(r){this.b.write(new v(1,0,0,r))}}e.Protocol=p;class g extends R.IPCClient{static fromSocket(r,c){return new g(new p(r),c)}get onDidDispose(){return this.b.onDidDispose}constructor(r,c,o=null){super(r,c,o),this.b=r}dispose(){super.dispose();const r=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),r.end()}}e.Client=g;class f{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new t.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(r){this.b?this.d.length>0?this.d.push(r):this.a.fire(r):this.d.push(r)}flushBuffer(){this.d=[]}}e.BufferedEmitter=f;class l{constructor(r){this.data=r,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let r=0,c=this.a;for(;c;)c=c.next,r++;return r}peek(){return this.a?this.a.data:null}toArray(){const r=[];let c=0,o=this.a;for(;o;)r[c++]=o.data,o=o.next;return r}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(r){const c=new l(r);if(!this.a){this.a=c,this.b=c;return}this.b.next=c,this.b=c}}class s{static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const r=Date.now();for(let c=0;c<s.a;c++)this.c[c]=r-1e3*c;setInterval(()=>{for(let c=s.a;c>=1;c--)this.c[c]=this.c[c-1];this.c[0]=Date.now()},1e3)}d(){const r=Date.now(),c=(1+s.a)*1e3;let o=0;for(let S=0;S<s.a;S++)r-this.c[S]<=c&&o++;return 1-o/s.a}hasHighLoad(){return this.d()>=.5}}s.a=10,s.b=null;class n{get unacknowledgedCount(){return this.c-this.d}constructor(r,c=null,o=s.getInstance()){this.t=new f,this.onControlMessage=this.t.event,this.u=new f,this.onMessage=this.u.event,this.v=new f,this.onDidDispose=this.v.event,this.w=new f,this.onSocketClose=this.w.event,this.x=new f,this.onSocketTimeout=this.x.event,this.s=o,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=[],this.o=r,this.p=new u(this.o),this.r.push(this.p),this.q=new b(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(S=>this.y(S))),this.r.push(this.o.onClose(S=>this.w.fire(S))),c&&this.q.acceptChunk(c),this.l=setInterval(()=>{this.C()},5e3)}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r=(0,k.dispose)(this.r)}drain(){return this.p.drain()}sendDisconnect(){const r=new v(5,0,0,y());this.p.write(r),this.p.flush()}sendPause(){const r=new v(7,0,0,y());this.p.write(r)}sendResume(){const r=new v(8,0,0,y());this.p.write(r)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(r,c){this.a=!0,this.r=(0,k.dispose)(this.r),this.t.flushBuffer(),this.w.flushBuffer(),this.x.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=r,this.p=new u(this.o),this.r.push(this.p),this.q=new b(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(o=>this.y(o))),this.r.push(this.o.onClose(o=>this.w.fire(o))),this.q.acceptChunk(c)}endAcceptReconnection(){this.a=!1,this.h=this.g;const r=new v(3,0,this.h,y());this.p.write(r);const c=this.b.toArray();for(let o=0,S=c.length;o<S;o++)this.p.write(c[o]);this.A()}acceptDisconnect(){this.v.fire()}y(r){if(r.ack>this.d){this.d=r.ack;do{const c=this.b.peek();if(c&&c.id<=r.ack)this.b.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this.g)if(r.id!==this.g+1){const c=Date.now();c-this.m>1e4&&(this.m=c,this.p.write(new v(6,0,0,y())))}else this.g=r.id,this.j=Date.now(),this.z(),this.u.fire(r.data);break}case 2:{this.t.fire(r.data);break}case 3:break;case 5:{this.v.fire();break}case 6:{const c=this.b.toArray();for(let o=0,S=c.length;o<S;o++)this.p.write(c[o]);this.A();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(r){const c=++this.c;this.h=this.g;const o=new v(1,c,this.h,r);this.b.push(o),this.a||(this.p.write(o),this.A())}sendControl(r){const c=new v(2,0,0,r);this.p.write(c)}z(){if(this.g<=this.h||this.k)return;const r=Date.now()-this.j;if(r>=2e3){this.B();return}this.k=setTimeout(()=>{this.k=null,this.z()},2e3-r+5)}A(){if(this.c<=this.d||this.f||this.a)return;const r=this.b.peek(),c=Date.now()-r.writtenTime,o=Date.now()-this.q.lastReadTime,S=Date.now()-this.n;if(c>=2e4&&o>=2e4&&S>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.x.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:o});return}const D=Math.max(2e4-c,2e4-o,2e4-S,500);this.f=setTimeout(()=>{this.f=null,this.A()},D)}B(){if(this.g<=this.h)return;this.h=this.g;const r=new v(3,0,this.h,y());this.p.write(r)}C(){const r=new v(9,0,0,y());this.p.write(r)}}e.PersistentProtocol=n}),define(te[145],ie([0,1,41,17,3,2,47,130]),function(V,e,I,t,k,R,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function w(y,P){const E=k.Event.fromNodeEventEmitter(I.validatedIpcMain,P,(d,v)=>({event:d,message:v})),h=k.Event.filter(E,({event:d})=>d.sender.id===y);return k.Event.map(h,({message:d})=>d&&t.VSBuffer.wrap(d))}class m extends A.IPCServer{static d(){const P=k.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:hello",({sender:E})=>E);return k.Event.map(P,E=>{const h=E.id;m.b.get(h)?.dispose();const v=new k.Emitter;m.b.set(h,(0,R.toDisposable)(()=>v.fire()));const b=w(h,"vscode:message"),u=k.Event.any(k.Event.signal(w(h,"vscode:disconnect")),v.event);return{protocol:new C.Protocol(E,b),onDidClientDisconnect:u}})}constructor(){super(m.d())}}e.Server=m,m.b=new Map}),define(te[103],ie([0,1,41,3,29,144]),function(V,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class A extends R.Client{constructor(m,y){super({addEventListener:(P,E)=>m.addListener(P,E),removeEventListener:(P,E)=>m.removeListener(P,E),postMessage:P=>m.postMessage(P),start:()=>m.start(),close:()=>m.close()},y)}}e.Client=A;async function C(w){if(w.isDestroyed()||w.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const m=(0,k.generateUuid)();w.webContents.send("vscode:createMessageChannel",m);const y=t.Event.fromNodeEventEmitter(I.validatedIpcMain,"vscode:createMessageChannelResult",(E,h)=>({nonce:h,port:E.ports[0]})),{port:P}=await t.Event.toPromise(t.Event.once(t.Event.filter(y,E=>E.nonce===m)));return P}e.connect=C}),define(te[146],ie([0,1,46,8,17,22,139,14,3,2,44,82,79,47]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends h.ChannelServer{constructor(u){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:w.Event.fromNodeEventEmitter(process,"message",p=>k.VSBuffer.wrap(Buffer.from(p,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=d;class v{constructor(u,p){this.i=u,this.j=p,this.c=new Set,this.g=new Map,this.h=new w.Emitter,this.onDidProcessExit=this.h.event;const g=p&&p.timeout?p.timeout:6e4;this.b=new t.Delayer(g),this.d=null,this.f=null}getChannel(u){const p=this;return{call(g,f,l){return p.k(u,g,f,l)},listen(g,f){return p.l(u,g,f)}}}k(u,p,g,f=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(C.canceled());this.b.cancel();const l=this.n(u),i=(0,t.createCancelablePromise)(a=>l.call(p,g,a)),s=f.onCancellationRequested(()=>i.cancel()),n=(0,m.toDisposable)(()=>i.cancel());return this.c.add(n),i.finally(()=>{s.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(u,p,g){if(!this.b)return w.Event.None;this.b.cancel();let f;const l=new w.Emitter({onWillAddFirstListener:()=>{f=this.n(u).listen(p,g)(l.fire,l),this.c.add(f)},onDidRemoveLastListener:()=>{this.c.delete(f),f.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return l.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,y.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,E.removeDangerousEnvVariables)(p.env),this.d=(0,I.fork)(this.i,u,p);const g=new w.Emitter;w.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,A.isRemoteConsoleLog)(r)){(0,A.log)(r,`IPC Library: ${this.j.serverName}`);return}g.fire(k.VSBuffer.wrap(Buffer.from(r,"base64")))});const l=this.j.useQueue?(0,P.createQueuedSender)(this.d):this.d,i=r=>this.d&&this.d.connected&&l.send(r.buffer.toString("base64")),s=g.event,n={send:i,onMessage:s};this.f=new h.ChannelClient(n);const a=()=>this.o();process.once("exit",a),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,c)=>{process.removeListener("exit",a),this.c.forEach(o=>(0,m.dispose)(o)),this.c.clear(),r!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:c})})}return this.f}n(u){let p=this.g.get(u);return p||(p=this.m.getChannel(u),this.g.set(u,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=v}),define(te[83],ie([0,1,17,14,3,2,9,4,29,47,102]),function(V,e,I,t,k,R,A,C,w,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function P(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class E{traceSocketEvent(o,S){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,o,S)}constructor(o,S=""){this.f=!0,this.debugLabel=S,this.socket=o,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,t.onUnexpectedError)(D)}},this.socket.on("error",this.a),this.b=D=>{this.traceSocketEvent("close",{hadError:D}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(o){const S=D=>{this.traceSocketEvent("read",D),o(I.VSBuffer.wrap(D))};return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(o){const S=D=>{o({type:0,hadError:D,error:void 0})};return this.socket.on("close",S),{dispose:()=>this.socket.off("close",S)}}onEnd(o){const S=()=>{o()};return this.socket.on("end",S),{dispose:()=>this.socket.off("end",S)}}write(o){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",o),this.socket.write(o.buffer,S=>{if(S){if(S.code==="EPIPE")return;(0,t.onUnexpectedError)(S)}})}catch(S){if(S.code==="EPIPE")return;(0,t.onUnexpectedError)(S)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((o,S)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),o();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),o()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.NodeSocket=E;var h;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(h||(h={}));var d;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(d||(d={}));class v extends R.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(o,S){this.socket.traceSocketEvent(o,S)}constructor(o,S,D,L){super(),this.f=this.B(new k.Emitter),this.g=this.B(new k.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=o,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:S,inflateBytesLength:D?.byteLength||0,recordInflateBytes:L}),this.a=this.B(new b(this,S,D,L,this.f,(N,X)=>this.k(N,X))),this.B(this.a.onError(N=>{console.error(N),(0,t.onUnexpectedError)(N),this.g.fire({type:0,hadError:!0,error:N})})),this.b=new y.ChunkStream,this.B(this.socket.onData(N=>this.l(N))),this.B(this.socket.onClose(N=>this.g.fire(N)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(o){return this.f.event(o)}onClose(o){return this.g.event(o)}onEnd(o){return this.socket.onEnd(o)}write(o){this.a.writeMessage(o)}k(o,S){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",o);let D=2;o.byteLength<126?D+=0:o.byteLength<2**16?D+=2:D+=8;const L=I.VSBuffer.alloc(D);if(S?L.writeUInt8(194,0):L.writeUInt8(130,0),o.byteLength<126)L.writeUInt8(o.byteLength,1);else if(o.byteLength<2**16){L.writeUInt8(126,1);let N=1;L.writeUInt8(o.byteLength>>>8&255,++N),L.writeUInt8(o.byteLength>>>0&255,++N)}else{L.writeUInt8(127,1);let N=1;L.writeUInt8(0,++N),L.writeUInt8(0,++N),L.writeUInt8(0,++N),L.writeUInt8(0,++N),L.writeUInt8(o.byteLength>>>24&255,++N),L.writeUInt8(o.byteLength>>>16&255,++N),L.writeUInt8(o.byteLength>>>8&255,++N),L.writeUInt8(o.byteLength>>>0&255,++N)}this.socket.write(I.VSBuffer.concat([L,o]))}end(){this.h=!0,this.socket.end()}l(o){if(o.byteLength!==0){for(this.b.acceptChunk(o);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const S=this.b.peek(this.j.readLen),D=S.readUInt8(0),L=(D&128)>>>7,N=(D&64)>>>6,X=S.readUInt8(1),ae=(X&128)>>>7,J=X&127;this.j.state=2,this.j.readLen=2+(ae?4:0)+(J===126?2:0)+(J===127?8:0),this.j.fin=L,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(N)),this.j.firstFrameOfMessage=Boolean(L),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const S=this.b.read(this.j.readLen),D=S.readUInt8(1),L=(D&128)>>>7;let N=D&127,X=1;N===126?N=S.readUInt8(++X)*2**8+S.readUInt8(++X):N===127&&(N=S.readUInt8(++X)*0+S.readUInt8(++X)*0+S.readUInt8(++X)*0+S.readUInt8(++X)*0+S.readUInt8(++X)*2**24+S.readUInt8(++X)*2**16+S.readUInt8(++X)*2**8+S.readUInt8(++X));let ae=0;L&&(ae=S.readUInt8(++X)*2**24+S.readUInt8(++X)*2**16+S.readUInt8(++X)*2**8+S.readUInt8(++X)),this.j.state=3,this.j.readLen=N,this.j.mask=ae,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const S=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",S),g(S,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",S),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(S,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=v;class b extends R.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:I.VSBuffer.alloc(0)}constructor(o,S,D,L,N,X){super(),this.k=o,this.l=N,this.m=X,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,S?(this.b=this.B(new u(this.k,L,D,{windowBits:15})),this.f=this.B(new p(this.k,{windowBits:15})),this.B(this.b.onError(ae=>this.a.fire(ae))),this.B(this.f.onError(ae=>this.a.fire(ae)))):(this.b=null,this.f=null)}writeMessage(o){this.g.push(o),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const o=this.g.shift();if(this.f){const S=await this.r(this.f,o);this.m(S,!0)}else this.m(o,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(o,S){return new Promise((D,L)=>{o.write(S),o.flush(N=>D(N))})}acceptFrame(o,S,D){this.h.push({data:o,isCompressed:S,isLastFrameOfMessage:D}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const o=this.h.shift();if(this.b&&o.isCompressed){const S=await this.u(this.b,o.data,o.isLastFrameOfMessage);this.l.fire(S)}else this.l.fire(o.data)}this.s=!1}}u(o,S,D){return new Promise((L,N)=>{o.write(S),D&&o.write(I.VSBuffer.fromByteArray([0,0,255,255])),o.flush(X=>L(X))})}}class u extends R.Disposable{get recordedInflateBytes(){return this.j?I.VSBuffer.concat(this.f):I.VSBuffer.alloc(0)}constructor(o,S,D,L){super(),this.h=o,this.j=S,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=P().zlib.createInflateRaw(L),this.b.on("error",N=>{this.h.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.h.traceSocketEvent("zlibInflateData",N),this.g.push(I.VSBuffer.wrap(N))}),D&&(this.h.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this.b.write(D.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(o){this.j&&this.f.push(o.clone()),this.h.traceSocketEvent("zlibInflateWrite",o),this.b.write(o.buffer)}flush(o){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const S=I.VSBuffer.concat(this.g);this.g.length=0,o(S)})}}class p extends R.Disposable{constructor(o,S){super(),this.g=o,this.a=this.B(new k.Emitter),this.onError=this.a.event,this.f=[],this.b=P().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",D=>{this.g.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.g.traceSocketEvent("zlibDeflateData",D),this.f.push(I.VSBuffer.wrap(D))})}write(o){this.g.traceSocketEvent("zlibDeflateWrite",o.buffer),this.b.write(o.buffer)}flush(o){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let S=I.VSBuffer.concat(this.f);this.f.length=0,S=S.slice(0,S.byteLength-4),o(S)})}}function g(c,o){if(o===0)return;const S=c.byteLength>>>2;for(let J=0;J<S;J++){const Y=c.readUInt32BE(J*4);c.writeUInt32BE(Y^o,J*4)}const D=S*4,L=c.byteLength-D,N=o>>>24&255,X=o>>>16&255,ae=o>>>8&255;L>=1&&c.writeUInt8(c.readUInt8(D)^N,D),L>=2&&c.writeUInt8(c.readUInt8(D+1)^X,D+1),L>=3&&c.writeUInt8(c.readUInt8(D+2)^ae,D+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const f={[2]:107,[1]:103};function l(){const c=(0,w.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let o;return e.XDG_RUNTIME_DIR?o=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):o=(0,A.join)(P().os.tmpdir(),`vscode-ipc-${c}.sock`),s(o),o}e.createRandomIPCHandle=l;function i(c,o,S){const D=P().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${S}-${o}-sock`;let L;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?L=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${D.substr(0,8)}-${S}-${o}.sock`):L=(0,A.join)(c,`${S}-${o}.sock`),s(L),L}e.createStaticIPCHandle=i;function s(c){const o=f[C.platform];typeof o=="number"&&c.length>=o&&console.warn(`WARNING: IPC handle "${c}" is longer than ${o} chars, try a shorter --user-data-dir`)}class n extends m.IPCServer{static b(o){const S=k.Event.fromNodeEventEmitter(o,"connection");return k.Event.map(S,D=>({protocol:new y.Protocol(new E(D,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(D,"close"))}))}constructor(o){super(n.b(o)),this.d=o}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=n;function a(c){return new Promise((o,S)=>{const D=P().net.createServer();D.on("error",S),D.listen(c,()=>{D.removeListener("error",S),o(new n(D))})})}e.serve=a;function r(c,o){return new Promise((S,D)=>{const L=P().net.createConnection(c,()=>{L.removeListener("error",D),S(y.Client.fromSocket(new E(L,`ipc-client${o}`),o))});L.once("error",D)})}e.connect=r}),define(te[104],ie([0,1,8,3,2,12]),function(V,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(P){P[P.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",P[P.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(A=e.StorageHint||(e.StorageHint={}));function C(P){const E=P;return E?.changed instanceof Map||E?.deleted instanceof Set}e.isStorageItemsChangeEvent=C;var w;(function(P){P[P.None=0]="None",P[P.Initialized=1]="Initialized",P[P.Closed=2]="Closed"})(w=e.StorageState||(e.StorageState={}));class m extends k.Disposable{constructor(E,h=Object.create(null)){super(),this.m=E,this.n=h,this.b=this.B(new t.Emitter),this.onDidChangeStorage=this.b.event,this.c=w.None,this.f=new Map,this.g=new I.ThrottledDelayer(m.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(E=>this.r(E)))}r(E){E.changed?.forEach((h,d)=>this.s(d,h)),E.deleted?.forEach(h=>this.s(h,void 0))}s(E,h){if(this.c===w.Closed)return;let d=!1;(0,R.isUndefinedOrNull)(h)?d=this.f.delete(E):this.f.get(E)!==h&&(this.f.set(E,h),d=!0),d&&this.b.fire(E)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===w.None&&(this.c=w.Initialized,this.n.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(E,h){const d=this.f.get(E);return(0,R.isUndefinedOrNull)(d)?h:d}getBoolean(E,h){const d=this.get(E);return(0,R.isUndefinedOrNull)(d)?h:d==="true"}getNumber(E,h){const d=this.get(E);return(0,R.isUndefinedOrNull)(d)?h:parseInt(d,10)}async set(E,h){if(this.c===w.Closed)return;if((0,R.isUndefinedOrNull)(h))return this.delete(E);const d=String(h);if(this.f.get(E)!==d)return this.f.set(E,d),this.j.set(E,d),this.h.delete(E),this.b.fire(E),this.w()}async delete(E){if(!(this.c===w.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire(E),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=w.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(E).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(E){if(!!this.u)return this.w(E)}async w(E){return this.g.trigger(()=>this.v(),E)}async whenFlushed(){if(!!this.u)return new Promise(E=>this.l.push(E))}isInMemory(){return this.n.hint===A.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=m,m.a=100;class y{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((h,d)=>this.a.set(d,h)),E.delete?.forEach(h=>this.a.delete(h))}async close(){}}e.InMemoryStorageDatabase=y}),define(te[147],ie([0,1,8,3,39,9,23]),function(V,e,I,t,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class C{get onDidChangeItemsExternal(){return t.Event.None}constructor(y,P=Object.create(null)){this.g=y,this.h=P,this.c=(0,R.basename)(this.g),this.d=new w(this.h.logging),this.f=this.n(this.g)}async getItems(){const y=await this.f,P=new Map;return(await this.s(y,"SELECT * FROM ItemTable")).forEach(h=>P.set(h.key,h.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${P.size} rows`),P}async updateItems(y){const P=await this.f;return this.j(P,y)}j(y,P){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${P.insert?(0,k.mapToString)(P.insert):"0"}), delete(${P.delete?(0,k.setToString)(P.delete):"0"})`),this.t(y,()=>{const E=P.insert,h=P.delete;if(E&&E.size>0){const d=[];d.push([]);let v=0;E.forEach((b,u)=>{let p=d[v];p.length>C.b&&(v++,p=[],d.push(p)),p.push(u,b)}),d.forEach(b=>{this.u(y,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,u=>u.run(b),()=>{const u=[];let p=0;return E.forEach((g,f)=>{u.push(f),p+=g.length}),`Keys: ${u.join(", ")} Length: ${p}`})})}if(h&&h.size){const d=[];d.push([]);let v=0;h.forEach(b=>{let u=d[v];u.length>C.b&&(v++,u=[],d.push(u)),u.push(b)}),d.forEach(b=>{this.u(y,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,u=>u.run(b),()=>{const u=[];return h.forEach(p=>{u.push(p)}),`Keys: ${u.join(", ")}`})})}})}async close(y){this.d.trace(`[storage ${this.c}] close()`);const P=await this.f;return this.k(P,y)}k(y,P){return new Promise((E,h)=>{y.db.close(d=>(d&&this.o(y,`[storage ${this.c}] close(): ${d}`),this.g===C.IN_MEMORY_PATH?E():!y.isErroneous&&!y.isInMemory?this.l().then(E,v=>(this.d.error(`[storage ${this.c}] backup(): ${v}`),E())):typeof P=="function"?A.Promises.unlink(this.g).then(()=>this.p(this.g).then(v=>{const b=()=>this.k(v,void 0);return this.j(v,{insert:P()}).then(()=>b(),u=>(b(),Promise.reject(u)))})).then(E,h):h(d||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const y=this.m(this.g);return A.Promises.copy(this.g,y,{preserveSymlinks:!1})}m(y){return`${y}.backup`}async checkIntegrity(y){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${y})`);const P=await this.f,E=await this.r(P,y?"PRAGMA integrity_check":"PRAGMA quick_check"),h=y?E.integrity_check:E.quick_check;return P.isErroneous?`${h} (last error: ${P.lastError})`:P.isInMemory?`${h} (in-memory!)`:h}async n(y,P=!0){this.d.trace(`[storage ${this.c}] open(${y}, retryOnBusy: ${P})`);try{return await this.p(y)}catch(E){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${E}`),E.code==="SQLITE_BUSY"&&P)return await(0,I.timeout)(C.a),this.n(y,!1);try{await A.Promises.unlink(y);try{await A.Promises.rename(this.m(y),y)}catch{}return await this.p(y)}catch(h){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${h}`),this.p(C.IN_MEMORY_PATH)}}}o(y,P){y.isErroneous=!0,y.lastError=P,this.d.error(P)}p(y){return new Promise((P,E)=>{new Promise((h,d)=>{V(["@vscode/sqlite3"],h,d)}).then(h=>{const d={db:new(this.d.isTracing?h.verbose().Database:h.Database)(y,v=>v?d.db&&v.code!=="SQLITE_CANTOPEN"?d.db.close(()=>E(v)):E(v):this.q(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>P(d),b=>d.db.close(()=>E(b)))),isInMemory:y===C.IN_MEMORY_PATH};d.db.on("error",v=>this.o(d,`[storage ${this.c}] Error (event): ${v}`)),this.d.isTracing&&d.db.on("trace",v=>this.d.trace(`[storage ${this.c}] Trace (event): ${v}`))},E)})}q(y,P){return new Promise((E,h)=>{y.db.exec(P,d=>d?(this.o(y,`[storage ${this.c}] exec(): ${d}`),h(d)):E())})}r(y,P){return new Promise((E,h)=>{y.db.get(P,(d,v)=>d?(this.o(y,`[storage ${this.c}] get(): ${d}`),h(d)):E(v))})}s(y,P){return new Promise((E,h)=>{y.db.all(P,(d,v)=>d?(this.o(y,`[storage ${this.c}] all(): ${d}`),h(d)):E(v))})}t(y,P){return new Promise((E,h)=>{y.db.serialize(()=>{y.db.run("BEGIN TRANSACTION"),P(),y.db.run("END TRANSACTION",d=>d?(this.o(y,`[storage ${this.c}] transaction(): ${d}`),h(d)):E())})})}u(y,P,E,h){const d=y.db.prepare(P),v=b=>{this.o(y,`[storage ${this.c}] prepare(): ${b} (${P}). Details: ${h()}`)};d.on("error",v),E(d),d.finalize(b=>{b&&v(b),d.removeListener("error",v)})}}e.SQLiteStorageDatabase=C,C.IN_MEMORY_PATH=":memory:",C.a=2e3,C.b=256;class w{constructor(y){y&&typeof y.logTrace=="function"&&process.env[w.VSCODE_TRACE_STORAGE]&&(this.a=y.logTrace),y&&typeof y.logError=="function"&&(this.b=y.logError)}get isTracing(){return!!this.a}trace(y){this.a?.(y)}error(y){this.b?.(y)}}w.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(te[148],ie([11,10]),function(V,e){return V.create("vs/code/electron-main/app",e)}),define(te[149],ie([11,10]),function(V,e){return V.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[150],ie([11,10]),function(V,e){return V.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(te[151],ie([11,10]),function(V,e){return V.create("vs/platform/environment/node/argv",e)}),define(te[152],ie([11,10]),function(V,e){return V.create("vs/platform/environment/node/argvHelper",e)}),define(te[153],ie([11,10]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[154],ie([11,10]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[155],ie([11,10]),function(V,e){return V.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[156],ie([11,10]),function(V,e){return V.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[157],ie([11,10]),function(V,e){return V.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(te[158],ie([11,10]),function(V,e){return V.create("vs/platform/files/common/fileService",e)}),define(te[159],ie([11,10]),function(V,e){return V.create("vs/platform/files/common/files",e)}),define(te[160],ie([11,10]),function(V,e){return V.create("vs/platform/files/common/io",e)}),define(te[161],ie([11,10]),function(V,e){return V.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(te[162],ie([11,10]),function(V,e){return V.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[163],ie([11,10]),function(V,e){return V.create("vs/platform/issue/electron-main/issueMainService",e)}),define(te[164],ie([11,10]),function(V,e){return V.create("vs/platform/menubar/electron-main/menubar",e)}),define(te[165],ie([11,10]),function(V,e){return V.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(te[166],ie([11,10]),function(V,e){return V.create("vs/platform/request/common/request",e)}),define(te[167],ie([11,10]),function(V,e){return V.create("vs/platform/shell/node/shellEnv",e)}),define(te[168],ie([11,10]),function(V,e){return V.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[169],ie([11,10]),function(V,e){return V.create("vs/platform/update/common/update.config.contribution",e)}),define(te[170],ie([11,10]),function(V,e){return V.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[171],ie([11,10]),function(V,e){return V.create("vs/platform/windows/electron-main/windowImpl",e)}),define(te[172],ie([11,10]),function(V,e){return V.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(te[173],ie([11,10]),function(V,e){return V.create("vs/platform/workspace/common/workspace",e)}),define(te[174],ie([11,10]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(te[175],ie([11,10]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(te[176],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function I(k){return k&&k.hasOwnProperty("folderUri")}e.isFolderBackupInfo=I;function t(k){return k&&k.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(te[177],ie([0,1,7]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function t(A){return typeof A?.backupFolder=="string"}e.isEmptyWindowBackupInfo=t;function k(A){let C=[];try{Array.isArray(A.workspaces)&&(C=A.workspaces.map(w=>({workspace:{id:w.id,configPath:I.URI.parse(w.configURIPath)},remoteAuthority:w.remoteAuthority})))}catch{}return C}e.deserializeWorkspaceInfos=k;function R(A){let C=[];try{Array.isArray(A.folders)&&(C=A.folders.map(w=>({folderUri:I.URI.parse(w.folderUri),remoteAuthority:w.remoteAuthority})))}catch{}return C}e.deserializeFolderInfos=R}),define(te[178],ie([0,1,3,2]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class k{constructor(){this.a=new I.Emitter,this.b=new I.Emitter,this.c=new I.Emitter,this.d=new I.Emitter}call(C,w,m){switch(w){case"close":return Promise.resolve(this.a.fire({sessionId:m[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:m[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:m[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:m[0],port:m[1],subId:m[2]}))}throw new Error("Method not implemented.")}listen(C,w,m){switch(w){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=k,k.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(C){super(),this.b=C}reload(C){this.b.call("reload",[C])}get onReload(){return this.b.listen("reload")}close(C){this.b.call("close",[C])}get onClose(){return this.b.listen("close")}attachSession(C,w,m){this.b.call("attach",[C,w,m])}get onAttachSession(){return this.b.listen("attach")}terminateSession(C,w){this.b.call("terminate",[C,w])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(C,w){return this.b.call("openExtensionDevelopmentHostWindow",[C,w])}}e.ExtensionHostDebugChannelClient=R}),define(te[179],ie([0,1,133,53,15,9,33,20,7]),function(V,e,I,t,k,R,A,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class m{get appRoot(){return(0,R.dirname)(k.FileAccess.asFileUri("").fsPath)}get userHome(){return w.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return w.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.b.tmpDir)}get cacheHome(){return w.URI.file(this.userDataPath)}get stateResource(){return(0,C.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,C.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return w.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return w.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.joinPath)(w.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,C.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,C.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=A.env.VSCODE_PORTABLE;return d?w.URI.file((0,R.join)(d,"argv.json")):(0,C.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,R.resolve)(d):(0,R.normalize)((0,R.join)(k.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?w.URI.file((0,R.resolve)(d)):w.URI.file((0,R.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,R.resolve)(d);const v=A.env.VSCODE_EXTENSIONS;if(v)return v;const b=A.env.VSCODE_PORTABLE;return b?(0,R.join)(b,"extensions"):(0,C.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(v=>/^[^:/?#]+?:\/\//.test(v)?w.URI.parse(v):w.URI.file((0,R.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?w.URI.parse(d):w.URI.file((0,R.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(d))}get extensionLogLevel(){const d=[];for(const v of this.args.log||[]){const b=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(v);b&&b[1]&&b[2]&&d.push([b[1],b[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,C.joinPath)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return w.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=A.env.VSCODE_PORTABLE;return d?w.URI.file((0,R.join)(d,"policy.json")):(0,C.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,v,b){this.a=d,this.b=v,this.c=b,this.editSessionId=this.args.editSessionId}}pe([t.memoize],m.prototype,"appRoot",null),pe([t.memoize],m.prototype,"userHome",null),pe([t.memoize],m.prototype,"userDataPath",null),pe([t.memoize],m.prototype,"appSettingsHome",null),pe([t.memoize],m.prototype,"tmpDir",null),pe([t.memoize],m.prototype,"cacheHome",null),pe([t.memoize],m.prototype,"stateResource",null),pe([t.memoize],m.prototype,"userRoamingDataHome",null),pe([t.memoize],m.prototype,"userDataSyncHome",null),pe([t.memoize],m.prototype,"userDataSyncLogResource",null),pe([t.memoize],m.prototype,"editSessionsLogResource",null),pe([t.memoize],m.prototype,"sync",null),pe([t.memoize],m.prototype,"machineSettingsResource",null),pe([t.memoize],m.prototype,"workspaceStorageHome",null),pe([t.memoize],m.prototype,"localHistoryHome",null),pe([t.memoize],m.prototype,"keyboardLayoutResource",null),pe([t.memoize],m.prototype,"argvResource",null),pe([t.memoize],m.prototype,"isExtensionDevelopment",null),pe([t.memoize],m.prototype,"untitledWorkspacesHome",null),pe([t.memoize],m.prototype,"installSourcePath",null),pe([t.memoize],m.prototype,"builtinExtensionsPath",null),pe([t.memoize],m.prototype,"extensionsPath",null),pe([t.memoize],m.prototype,"extensionDevelopmentLocationURI",null),pe([t.memoize],m.prototype,"extensionDevelopmentKind",null),pe([t.memoize],m.prototype,"extensionTestsLocationURI",null),pe([t.memoize],m.prototype,"debugExtensionHost",null),pe([t.memoize],m.prototype,"logLevel",null),pe([t.memoize],m.prototype,"extensionLogLevel",null),pe([t.memoize],m.prototype,"serviceMachineIdResource",null),pe([t.memoize],m.prototype,"telemetryLogResource",null),pe([t.memoize],m.prototype,"disableWorkspaceTrust",null),pe([t.memoize],m.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=m;function y(h,d){return E(h["inspect-extensions"],h["inspect-brk-extensions"],5870,d,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=y;function P(h,d){return E(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,d,h.extensionEnvironment)}e.parsePtyHostPort=P;function E(h,d,v,b,u,p){const f=Number(d||h)||(b?null:v),l=f?Boolean(!!d):!1;let i;if(p)try{i=JSON.parse(p)}catch{}return{port:f,break:l,debugId:u,env:i}}}),define(te[105],ie([0,1,279,4,151]),function(V,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,k.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,k.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(17,null)},category:{type:"string",cat:"e",description:(0,k.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,k.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,k.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function C(v,b,u=A){const p=v.find(c=>c.length>0&&c[0]!=="-"),g={},f=["_"],l=[],i={};let s;for(const c in b){const o=b[c];o.type==="subcommand"?c===p&&(s=o):(o.alias&&(g[c]=o.alias),o.type==="string"||o.type==="string[]"?(f.push(c),o.deprecates&&f.push(...o.deprecates)):o.type==="boolean"&&(l.push(c),o.deprecates&&l.push(...o.deprecates)),o.global&&(i[c]=o))}if(s&&p){const c=i;for(const L in s.options)c[L]=s.options[L];const o=v.filter(L=>L!==p),S=u.getSubcommandReporter?u.getSubcommandReporter(p):void 0,D=C(o,c,S);return{[p]:D,_:[]}}const n=I(v,{string:f,boolean:l,alias:g}),a={},r=n;a._=n._.map(c=>String(c)).filter(c=>c.length>0),delete r._;for(const c in b){const o=b[c];if(o.type==="subcommand")continue;o.alias&&delete r[o.alias];let S=r[c];if(o.deprecates)for(const D of o.deprecates)r.hasOwnProperty(D)&&(S||(S=r[D],S&&u.onDeprecatedOption(D,o.deprecationMessage||(0,k.localize)(36,null,c))),delete r[D]);if(typeof S<"u"){if(o.type==="string[]"){if(Array.isArray(S)||(S=[S]),!o.allowEmptyValue){const D=S.filter(L=>L.length>0);D.length!==S.length&&(u.onEmptyValue(c),S=D.length>0?D:void 0)}}else o.type==="string"&&(Array.isArray(S)?(S=S.pop(),u.onMultipleValues(c,S)):!S&&!o.allowEmptyValue&&(u.onEmptyValue(c),S=void 0));a[c]=S,o.deprecationMessage&&u.onDeprecatedOption(c,o.deprecationMessage)}delete r[c]}for(const c in r)u.onUnknownOption(c);return a}e.parseArgs=C;function w(v,b){let u="";return b.args&&(Array.isArray(b.args)?u=` <${b.args.join("> <")}>`:u=` <${b.args}>`),b.alias?`-${b.alias} --${v}${u}`:`--${v}${u}`}function m(v,b){const u=[];for(const p in v){const g=v[p],f=w(p,g);u.push([f,g.description])}return y(u,b)}e.formatOptions=m;function y(v,b){const p=v.reduce((l,i)=>Math.max(l,i[0].length),12)+2+1;if(b-p<25)return v.reduce((l,i)=>l.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const g=b-p-1,f=[];for(const l of v){const i=l[0],s=E(l[1],g),n=P(p-i.length-2);f.push("  "+i+n+s[0]);for(let a=1;a<s.length;a++)f.push(P(p)+s[a])}return f}function P(v){return" ".repeat(v)}function E(v,b){const u=[];for(;v.length;){const p=v.length<b?v.length:v.lastIndexOf(" ",b),g=v.slice(0,p).trim();v=v.slice(p),u.push(g)}return u}function h(v,b,u,p,g){const f=process.stdout.isTTY&&process.stdout.columns||80,l=g?.noInputFiles!==!0?`[${(0,k.localize)(37,null)}...]`:"",i=[`${v} ${u}`];i.push(""),i.push(`${(0,k.localize)(38,null)}: ${b} [${(0,k.localize)(39,null)}]${l}`),i.push(""),g?.noPipe!==!0&&(t.isWindows?i.push((0,k.localize)(40,null,b)):i.push((0,k.localize)(41,null,b)),i.push(""));const s={},n=[];for(const a in p){const r=p[a];if(r.type==="subcommand")r.description&&n.push({command:a,description:r.description});else if(r.description&&r.cat){let c=s[r.cat];c||(s[r.cat]=c={}),c[a]=r}}for(const a in s){const r=a,c=s[r];c&&(i.push(R[r]),i.push(...m(c,f)),i.push(""))}return n.length&&(i.push((0,k.localize)(42,null)),i.push(...y(n.map(a=>[a.command,a.description]),f)),i.push("")),i.join(`
`)}e.buildHelpMessage=h;function d(v,b){return`${v||(0,k.localize)(43,null)}
${b||(0,k.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=d}),define(te[180],ie([0,1,78,178,105]),function(V,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(C){super(),this.f=C}call(C,w,m){return w==="openExtensionDevelopmentHostWindow"?this.g(m[0],m[1]):super.call(C,w,m)}async g(C,w){const m=(0,k.parseArgs)(C,k.OPTIONS);m.debugRenderer=w;const y=m.extensionDevelopmentPath;if(!y)return{success:!1};const[P]=await this.f.openExtensionDevelopmentHostWindow(y,{context:5,cli:m,forceProfile:m.profile,forceTempProfile:m["profile-temp"]});if(!w)return{success:!0};const E=P.win;if(!E)return{success:!0};const h=E.webContents.debugger;let d=h.isAttached()?1/0:0;const v=(0,I.createServer)(b=>{d++===0&&h.attach();let u=!1;const p=l=>{u||b.write(JSON.stringify(l)+"\0")},g=(l,i,s,n)=>p({method:i,params:s,sessionId:n});E.on("close",()=>{h.removeListener("message",g),b.end(),u=!0}),h.addListener("message",g);let f=Buffer.alloc(0);b.on("data",l=>{f=Buffer.concat([f,l]);for(let i=f.indexOf(0);i!==-1;i=f.indexOf(0)){let s;try{const n=f.slice(0,i).toString("utf8");f=f.slice(i+1),s=JSON.parse(n)}catch(n){console.error("error reading cdp line",n)}h.sendCommand(s.method,s.params,s.sessionId).then(n=>p({id:s.id,sessionId:s.sessionId,result:n})).catch(n=>p({id:s.id,sessionId:s.sessionId,error:{code:0,message:n.message}}))}}),b.on("error",l=>{console.error("error on cdp pipe:",l)}),b.on("close",()=>{u=!0,--d===0&&h.detach()})});return await new Promise(b=>v.listen(0,b)),E.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(te[61],ie([0,1,280,152,105]),function(V,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function A(E,h){const d=(f,l)=>{console.warn((0,t.localize)(0,null,f,l))},v=f=>{console.warn((0,t.localize)(1,null,f))},b=(f,l)=>{console.warn((0,t.localize)(2,null,f,l))},u=f=>({onUnknownOption:l=>{f!=="tunnel"&&console.warn((0,t.localize)(3,null,l,f))},onMultipleValues:d,onEmptyValue:v,onDeprecatedOption:b,getSubcommandReporter:f!=="tunnel"?u:void 0}),p={onUnknownOption:f=>{console.warn((0,t.localize)(4,null,f))},onMultipleValues:d,onEmptyValue:v,onDeprecatedOption:b,getSubcommandReporter:u},g=(0,k.parseArgs)(E,k.OPTIONS,h?p:void 0);return g.goto&&g._.forEach(f=>I(/^(\w:)?[^:]+(:\d*){0,2}$/.test(f),(0,t.localize)(5,null))),g["max-memory"]&&I(parseInt(g["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),g}function C(E){const h=E.findIndex(d=>!/^-/.test(d));if(h>-1)return[...E.slice(0,h),...E.slice(h+1)]}function w(E){let[,...h]=E;process.env.VSCODE_DEV&&(h=C(h)||[]);const d=!P(process.env);return A(h,d)}e.parseMainProcessArgv=w;function m(E){let[,,...h]=E;return process.env.VSCODE_DEV&&(h=C(h)||[]),A(h,!0)}e.parseCLIProcessArgv=m;function y(E,...h){const d=E.indexOf("--");return d===-1?E.push(...h):E.splice(d,0,...h),E}e.addArg=y;function P(E){return E.VSCODE_CLI==="1"}e.isLaunchedFromCli=P}),function(){"use strict";function V(e,I,t){function k(A,C){const w=R(A,C),m=[w];return e.isAbsolute(w)||m.unshift(t),e.resolve(...m)}function R(A,C){process.env.VSCODE_DEV&&(C="code-oss-dev");const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,C);const y=A["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const P=process.env.USERPROFILE;if(typeof P!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(P,"AppData","Roaming")}break;case"darwin":m=e.join(I.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,C)}return{getUserDataPath:k}}if(typeof define=="function")define(te[181],ie([182,25,33]),function(e,I,t){return V(e,I,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=V(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[183],ie([0,1,25,179,181]),function(V,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(C,w){super(C,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,k.getUserDataPath)(C,w.nameShort)},w)}}e.NativeEnvironmentService=R}),define(te[184],ie([0,1,40,25,30]),function(V,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function R(A){const C=(0,k.randomPath)((0,t.tmpdir)());try{return(0,I.writeFileSync)(C,""),A&&console.log(`Marker file for --wait created: ${C}`),C}catch(w){A&&console.error(`Failed to create marker file for --wait: ${w}`);return}}e.createWaitMarkerFileSync=R}),define(te[185],ie([0,1,12,154]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(A,C,w){try{R(A,C,w)}catch(m){console.error(m?.message??m)}return A}e.localizeManifest=k;function R(A,C,w){const m=(y,P,E)=>{const h=y[P];if((0,I.isString)(h)){const d=h,v=d.length;if(v>1&&d[0]==="%"&&d[v-1]==="%"){const b=d.substr(1,v-2);let u=C[b];u===void 0&&w&&(u=w[b]);const p=typeof u=="string"?u:u?.message,g=w?.[b],f=typeof g=="string"?g:g?.message;if(!p){f||console.warn(`[${A.name}]: ${(0,t.localize)(0,null,b)}`);return}if(E&&(P==="title"||P==="category")&&f&&f!==p){const l={value:p,original:f};y[P]=l}else y[P]=p}}else if((0,I.isObject)(h))for(const d in h)h.hasOwnProperty(d)&&(d==="commands"?m(h,d,!0):m(h,d,E));else if(Array.isArray(h))for(let d=0;d<h.length;d++)m(h,d,E)};for(const y in A)A.hasOwnProperty(y)&&m(A,y)}}),define(te[186],ie([0,1,14]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(R,A){this.a.set(R,A)}updateManifest(R){if(!(typeof R.main>"u"&&typeof R.browser>"u")&&(R.activationEvents===void 0&&Object.assign(R,{activationEvents:[]}),!(!Array.isArray(R.activationEvents)||!R.contributes)))for(const A in R.contributes){const C=this.a.get(A);if(!C)continue;const w=R.contributes[A],m=Array.isArray(w)?w:[w];try{C(m,R.activationEvents)}catch(y){(0,I.onUnexpectedError)(y)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(te[187],ie([0,1,20,98,156,188]),function(V,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function w(u){return u=u.trim(),u==="*"||A.test(u)}e.isValidVersionStr=w;function m(u){if(!w(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=u.match(A);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=m;function y(u){if(!u)return null;const p=u.majorBase,g=u.majorMustEqual,f=u.minorBase;let l=u.minorMustEqual;const i=u.patchBase;let s=u.patchMustEqual;u.hasCaret&&(p===0||(l=!1),s=!1);let n=0;if(u.preRelease){const a=C.exec(u.preRelease);if(a){const[,r,c,o]=a;n=Date.UTC(Number(r),Number(c)-1,Number(o))}}return{majorBase:p,majorMustEqual:g,minorBase:f,minorMustEqual:l,patchBase:i,patchMustEqual:s,isMinimum:u.hasGreaterEquals,notBefore:n}}e.normalizeVersion=y;function P(u,p,g){let f;typeof u=="string"?f=y(m(u)):f=u;let l;p instanceof Date?l=p.getTime():typeof p=="string"&&(l=new Date(p).getTime());let i;if(typeof g=="string"?i=y(m(g)):i=g,!f||!i)return!1;const s=f.majorBase,n=f.minorBase,a=f.patchBase;let r=i.majorBase,c=i.minorBase,o=i.patchBase;const S=i.notBefore;let D=i.majorMustEqual,L=i.minorMustEqual,N=i.patchMustEqual;return i.isMinimum?s>r?!0:s<r?!1:n>c?!0:n<c||l&&l<S?!1:a>=o:(s===1&&r===0&&(!D||!L||!N)&&(r=1,c=0,o=0,D=!0,L=!1,N=!1),s<r?!1:s>r?!D:n<c?!1:n>c?!L:a<o?!1:a>o?!N:!(l&&l<S))}e.isValidVersion=P;function E(u,p,g,f,l){const i=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return i.push([t.default.Error,k.localize(0,null)]),i;if(typeof f.name!="string")return i.push([t.default.Error,k.localize(1,null,"name")]),i;if(typeof f.version!="string")return i.push([t.default.Error,k.localize(2,null,"version")]),i;if(!f.engines)return i.push([t.default.Error,k.localize(3,null,"engines")]),i;if(typeof f.engines.vscode!="string")return i.push([t.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof f.extensionDependencies<"u"&&!b(f.extensionDependencies))return i.push([t.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof f.activationEvents<"u"){if(!b(f.activationEvents))return i.push([t.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof f.main>"u"&&typeof f.browser>"u")return i.push([t.default.Error,k.localize(7,null,"activationEvents","main")]),i}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&i.push([t.default.Warning,k.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return i.push([t.default.Error,k.localize(9,null,"main")]),i;{const a=(0,I.joinPath)(g,f.main);(0,I.isEqualOrParent)(a,g)||i.push([t.default.Warning,k.localize(10,null,a.path,g.path)])}if(typeof f.activationEvents>"u")return i.push([t.default.Error,k.localize(11,null,"activationEvents","main")]),i}if(typeof f.browser<"u"){if(typeof f.browser!="string")return i.push([t.default.Error,k.localize(12,null,"browser")]),i;{const a=(0,I.joinPath)(g,f.browser);(0,I.isEqualOrParent)(a,g)||i.push([t.default.Warning,k.localize(13,null,a.path,g.path)])}if(typeof f.activationEvents>"u")return i.push([t.default.Error,k.localize(14,null,"activationEvents","browser")]),i}if(!R.valid(f.version))return i.push([t.default.Error,k.localize(15,null)]),i;const s=[];if(!h(u,p,f,l,s))for(const a of s)i.push([t.default.Error,a]);return i}e.validateExtensionManifest=E;function h(u,p,g,f,l){return f||typeof g.main>"u"&&typeof g.browser>"u"?!0:v(u,p,g.engines.vscode,l)}e.isValidExtensionVersion=h;function d(u,p,g){return u==="*"||v(p,g,u)}e.isEngineValid=d;function v(u,p,g,f=[]){const l=y(m(g));if(!l)return f.push(k.localize(16,null,g)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return f.push(k.localize(17,null,g)),!1}else if(!l.majorMustEqual)return f.push(k.localize(18,null,g)),!1;return P(u,p,l)?!0:(f.push(k.localize(19,null,u,g)),!1)}function b(u){if(!Array.isArray(u))return!1;for(let p=0,g=u.length;p<g;p++)if(typeof u[p]!="string")return!1;return!0}}),define(te[189],ie([0,1,17,29]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(R,A,C){let w=C&&C.get("storage.serviceMachineId",-1)||null;if(w)return w;try{const y=(await A.readFile(R.serviceMachineIdResource)).value.toString();w=(0,t.isUUID)(y)?y:null}catch{w=null}if(!w){w=(0,t.generateUuid)();try{await A.writeFile(R.serviceMachineIdResource,I.VSBuffer.fromString(w))}catch{}}return C?.store("storage.serviceMachineId",w,-1,1),w}e.getServiceMachineId=k}),define(te[70],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class I{constructor(k,R=[],A=!1){this.ctor=k,this.staticArguments=R,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=I}),define(te[190],ie([0,1,70]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var k;(function(C){C[C.Eager=0]="Eager",C[C.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function R(C,w,m){w instanceof I.SyncDescriptor||(w=new I.SyncDescriptor(w,[],Boolean(m))),t.push([C,w])}e.registerSingleton=R;function A(){return t}e.getSingletonServiceDescriptors=A}),define(te[191],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class I{constructor(R,A){this.key=R,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.Node=I;class t{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const A of this.a.values())A.outgoing.size===0&&R.push(A);return R}insertEdge(R,A){const C=this.lookupOrInsertNode(R),w=this.lookupOrInsertNode(A);C.outgoing.set(w.key,w),w.incoming.set(C.key,C)}removeNode(R){const A=this.b(R);this.a.delete(A);for(const C of this.a.values())C.outgoing.delete(A),C.incoming.delete(A)}lookupOrInsertNode(R){const A=this.b(R);let C=this.a.get(A);return C||(C=new I(A,R),this.a.set(A,C)),C}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[A,C]of this.a)R.push(`${A}
	(-> incoming)[${[...C.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...C.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,A]of this.a){const C=new Set([R]),w=this.c(A,C);if(w)return w}}c(R,A){for(const[C,w]of R.outgoing){if(A.has(C))return[...A,C].join(" -> ");A.add(C);const m=this.c(w,A);if(m)return m;A.delete(C)}}}e.Graph=t}),define(te[5],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var I;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function C(w){return w[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=C})(I=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function t(A,C,w){C[I.DI_TARGET]===C?C[I.DI_DEPENDENCIES].push({id:A,index:w}):(C[I.DI_DEPENDENCIES]=[{id:A,index:w}],C[I.DI_TARGET]=C)}function k(A){if(I.serviceIds.has(A))return I.serviceIds.get(A);const C=function(w,m,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(C,w,y)};return C.toString=()=>A,I.serviceIds.set(A,C),C}e.createDecorator=k;function R(A){return A}e.refineServiceDecorator=R}),define(te[62],ie([0,1,5]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,I.createDecorator)("backupMainService")}),define(te[18],ie([0,1,12,7,5]),function(V,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function R(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof t.URI)}e.isConfigurationOverrides=R;function A(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=A;var C;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function w(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=w;function m(u,p){const g=Object.create(null);for(const f in u)y(g,f,u[f],p);return g}e.toValuesTree=m;function y(u,p,g,f){const l=p.split("."),i=l.pop();let s=u;for(let n=0;n<l.length;n++){const a=l[n];let r=s[a];switch(typeof r){case"undefined":r=s[a]=Object.create(null);break;case"object":break;default:f(`Ignoring ${p} as ${l.slice(0,n+1).join(".")} is ${JSON.stringify(r)}`);return}s=r}if(typeof s=="object"&&s!==null)try{s[i]=g}catch{f(`Ignoring ${p} as ${l.join(".")} is ${JSON.stringify(s)}`)}else f(`Ignoring ${p} as ${l.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=y;function P(u,p){const g=p.split(".");E(u,g)}e.removeFromValueTree=P;function E(u,p){const g=p.shift();if(p.length===0){delete u[g];return}if(Object.keys(u).indexOf(g)!==-1){const f=u[g];typeof f=="object"&&!Array.isArray(f)&&(E(f,p),Object.keys(f).length===0&&delete u[g])}}function h(u,p,g){function f(s,n){let a=s;for(const r of n){if(typeof a!="object"||a===null)return;a=a[r]}return a}const l=p.split("."),i=f(u,l);return typeof i>"u"?g:i}e.getConfigurationValue=h;function d(u,p,g){Object.keys(p).forEach(f=>{f!=="__proto__"&&(f in u?I.isObject(u[f])&&I.isObject(p[f])?d(u[f],p[f],g):g&&(u[f]=p[f]):u[f]=p[f])})}e.merge=d;function v(u,p,g){const f=u.inspect(p),l=u.inspect(g);return typeof f.userValue<"u"||typeof f.workspaceValue<"u"||typeof f.workspaceFolderValue<"u"?f.value:typeof l.userValue<"u"||typeof l.workspaceValue<"u"||typeof l.workspaceFolderValue<"u"?l.value:f.defaultValue}e.getMigratedSettingValue=v;function b(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=b}),define(te[71],ie([0,1,5]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,I.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,I.createDecorator)("credentialsMainService");class t{constructor(){this.a={}}async getPassword(R,A){return this.a[R]?.[A]??null}async setPassword(R,A,C){this.a[R]=this.a[R]??{},this.a[R][A]=C}async deletePassword(R,A){return this.a[R]?.[A]?(delete this.a[R][A],Object.keys(this.a[R]).length===0&&delete this.a[R],!0):!1}async findPassword(R){return JSON.stringify(this.a[R])??null}async findCredentials(R){const A=[];for(const C of Object.keys(this.a[R]||{}))A.push({account:C,password:this.a[R][C]});return A}async clear(){this.a={}}}e.InMemoryCredentialsProvider=t}),define(te[84],ie([0,1,5]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,I.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class k{async getPerformanceInfo(A,C){return{}}async getSystemInfo(A,C){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,C){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=k}),define(te[106],ie([0,1,5]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,I.createDecorator)("encryptionMainService")}),define(te[35],ie([0,1,5]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,I.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,I.refineServiceDecorator)(e.IEnvironmentService)}),define(te[27],ie([0,1,53,9,83,35,183,5]),function(V,e,I,t,k,R,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,C.refineServiceDecorator)(R.IEnvironmentService);class w extends A.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,k.createStaticIPCHandle)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}pe([I.memoize],w.prototype,"cachedLanguagesPath",null),pe([I.memoize],w.prototype,"backupHome",null),pe([I.memoize],w.prototype,"mainIPCHandle",null),pe([I.memoize],w.prototype,"mainLockfile",null),pe([I.memoize],w.prototype,"disableUpdates",null),pe([I.memoize],w.prototype,"disableKeytar",null),pe([I.memoize],w.prototype,"crossOriginIsolated",null),pe([I.memoize],w.prototype,"codeCachePath",null),pe([I.memoize],w.prototype,"useCodeCache",null),e.EnvironmentMainService=w}),define(te[192],ie([0,1,153,5]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function R(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function A(u,p){switch(u){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function C(u,p){return p==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=C;function w(u,p,g){return C(p,g)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===g?!0:m(g).includes(u)}e.isTargetPlatformCompatible=w;function m(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=m;function y(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=y;var P;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var E;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(E=e.SortOrder||(e.SortOrder={}));var h;(function(u){u.Install="install",u.Uninstall="uninstall"})(h=e.StatisticType||(e.StatisticType={}));var d;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var v;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(v=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class b extends Error{constructor(p,g){super(p),this.code=g,this.name=g}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,I.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,I.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(te[193],ie([0,1,5]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,I.createDecorator)("extensionUrlTrustService")}),define(te[194],ie([0,1,5]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,I.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[107],ie([0,1,5]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,I.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,I.createDecorator)("externalTerminal")}),define(te[195],ie([0,1,46,15,9,4,79,23,82,157,107]),function(V,e,I,t,k,R,A,C,w,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=m.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:h.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class h extends E{openTerminal(f,l){return this.spawnTerminal(I,f,w.getWindowsShell(),l)}spawnTerminal(f,l,i,s){const n=l.windowsExec||h.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const a=k.basename(n).toLowerCase();if(a==="cmder"||a==="cmder.exe")return f.spawn(n,s?[s]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return n.indexOf(" ")>=0&&r.push('""'),r.push(n),(a==="wt"||a==="wt.exe")&&r.push("-d ."),new Promise((c,o)=>{const S=b(process),D=f.spawn(i,r,{cwd:s,env:S});D.on("error",o),D.on("exit",()=>c())})}runInTerminal(f,l,i,s,n){const a="windowsExec"in n&&n.windowsExec?n.windowsExec:h.getDefaultTerminalWindows();return new Promise((r,c)=>{const o=`"${l} - ${P}"`,S=`""${i.join('" "')}" & pause"`,D=["/c","start",o,"/wait",a,"/c",S],L=Object.assign({},b(process),s);Object.keys(L).filter(ae=>L[ae]===null).forEach(ae=>delete L[ae]);const N={cwd:l,env:L,windowsVerbatimArguments:!0};I.spawn(h.b,D,N).on("error",ae=>{c(u(ae))}),r(void 0)})}static getDefaultTerminalWindows(){if(!h.d){const f=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");h.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${f?"Sysnative":"System32"}\\cmd.exe`}return h.d}}e.WindowsExternalTerminalService=h,h.b="cmd.exe";class d extends E{openTerminal(f,l){return this.spawnTerminal(I,f,l)}runInTerminal(f,l,i,s,n){const a=n.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((r,c)=>{if(a===y.DEFAULT_TERMINAL_OSX||a==="iTerm.app"){const o=a===y.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",D=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${o}.scpt`).fsPath,"-t",f||P,"-w",l];for(const X of i)D.push("-a"),D.push(X);if(s){const X=Object.assign({},b(process),s);for(const ae in X){const J=X[ae];J===null?(D.push("-u"),D.push(ae)):(D.push("-e"),D.push(`${ae}=${J}`))}}let L="";const N=I.spawn(d.b,D);N.on("error",X=>{c(u(X))}),N.stderr.on("data",X=>{L+=X.toString()}),N.on("exit",X=>{if(X===0)r(void 0);else if(L){const ae=L.split(`
`,1);c(new Error(ae[0]))}else c(new Error(m.localize(1,null,o,X)))})}else c(new Error(m.localize(2,null,a)))})}spawnTerminal(f,l,i){const s=l.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((n,a)=>{const r=["-a",s];i&&r.push(i);const c=b(process),o=f.spawn("/usr/bin/open",r,{cwd:i,env:c});o.on("error",a),o.on("exit",()=>n())})}}e.MacExternalTerminalService=d,d.b="/usr/bin/osascript";class v extends E{openTerminal(f,l){return this.spawnTerminal(I,f,l)}runInTerminal(f,l,i,s,n){const a=n.linuxExec?Promise.resolve(n.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((r,c)=>{const o=[];a.then(S=>{S.indexOf("gnome-terminal")>=0?o.push("-x"):o.push("-e"),o.push("bash"),o.push("-c");const D=`${p(i)}; echo; read -p "${v.b}" -n1;`;o.push(`''${D}''`);const L=Object.assign({},b(process),s);Object.keys(L).filter(J=>L[J]===null).forEach(J=>delete L[J]);const N={cwd:l,env:L};let X="";const ae=I.spawn(S,o,N);ae.on("error",J=>{c(u(J))}),ae.stderr.on("data",J=>{X+=J.toString()}),ae.on("exit",J=>{if(J===0)r(void 0);else if(X){const Y=X.split(`
`,1);c(new Error(Y[0]))}else c(new Error(m.localize(4,null,S,J)))})})})}static async getDefaultTerminalLinuxReady(){if(!v.d)if(!R.isLinux)v.d=Promise.resolve("xterm");else{const f=await C.Promises.exists("/etc/debian_version");v.d=new Promise(l=>{f?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm")})}return v.d}spawnTerminal(f,l,i){const s=l.linuxExec?Promise.resolve(l.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((n,a)=>{s.then(r=>{const c=b(process),o=f.spawn(r,[],{cwd:i,env:c});o.on("error",a),o.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=v,v.b=m.localize(3,null);function b(g){const f={...g.env};return(0,A.sanitizeProcessEnvironment)(f),f}function u(g){return"errno"in g&&g.errno==="ENOENT"&&"path"in g&&typeof g.path=="string"?new Error(m.localize(5,null,g.path)):g}function p(g){let f="";for(const l of g)l.indexOf(" ")>=0?f+='"'+l+'"':f+=l,f+=" ";return f}}),define(te[16],ie([0,1,60,9,26,12,7,159,5]),function(V,e,I,t,k,R,A,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function m(K){return K.create===!0}e.isFileOpenForWriteOptions=m;var y;(function(K){K[K.Unknown=0]="Unknown",K[K.File=1]="File",K[K.Directory=2]="Directory",K[K.SymbolicLink=64]="SymbolicLink"})(y=e.FileType||(e.FileType={}));var P;(function(K){K[K.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var E;(function(K){K[K.None=0]="None",K[K.FileReadWrite=2]="FileReadWrite",K[K.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",K[K.FileReadStream=16]="FileReadStream",K[K.FileFolderCopy=8]="FileFolderCopy",K[K.PathCaseSensitive=1024]="PathCaseSensitive",K[K.Readonly=2048]="Readonly",K[K.Trash=4096]="Trash",K[K.FileWriteUnlock=8192]="FileWriteUnlock",K[K.FileAtomicRead=16384]="FileAtomicRead",K[K.FileClone=32768]="FileClone"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(K){return!!(K.capabilities&2)}e.hasReadWriteCapability=h;function d(K){return!!(K.capabilities&8)}e.hasFileFolderCopyCapability=d;function v(K){return!!(K.capabilities&32768)}e.hasFileCloneCapability=v;function b(K){return!!(K.capabilities&4)}e.hasOpenReadWriteCloseCapability=b;function u(K){return!!(K.capabilities&16)}e.hasFileReadStreamCapability=u;function p(K){return h(K)?!!(K.capabilities&16384):!1}e.hasFileAtomicReadCapability=p;var g;(function(K){K.FileExists="EntryExists",K.FileNotFound="EntryNotFound",K.FileNotADirectory="EntryNotADirectory",K.FileIsADirectory="EntryIsADirectory",K.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",K.FileTooLarge="EntryTooLarge",K.FileWriteLocked="EntryWriteLocked",K.NoPermissions="NoPermissions",K.Unavailable="Unavailable",K.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class f extends Error{constructor(le,$){super(le),this.code=$}}e.FileSystemProviderError=f;function l(K,le){const $=new f(K.toString(),le);return s($,le),$}e.createFileSystemProviderError=l;function i(K){return K||l((0,C.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=i;function s(K,le){return K.name=le?`${le} (FileSystemError)`:"FileSystemError",K}e.markAsFileSystemProviderError=s;function n(K){if(!K)return g.Unknown;if(K instanceof f)return K.code;const le=/^(.+) \(FileSystemError\)$/.exec(K.name);if(!le)return g.Unknown;switch(le[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=n;function a(K){if(K instanceof L)return K.fileOperationResult;switch(n(K)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var r;(function(K){K[K.CREATE=0]="CREATE",K[K.DELETE=1]="DELETE",K[K.MOVE=2]="MOVE",K[K.COPY=3]="COPY",K[K.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class c{constructor(le,$,W){this.resource=le,this.operation=$,this.target=W}isOperation(le){return this.operation===le}}e.FileOperationEvent=c;var o;(function(K){K[K.UPDATED=0]="UPDATED",K[K.ADDED=1]="ADDED",K[K.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class S{constructor(le,$){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=le;const W=new Map;for(const T of le){const z=W.get(T.type);switch(z?z.push([T.resource,T]):W.set(T.type,[[T.resource,T]]),T.type){case 1:this.rawAdded.push(T.resource);break;case 0:this.rawUpdated.push(T.resource);break;case 2:this.rawDeleted.push(T.resource);break}}for(const[T,z]of W)switch(T){case 1:this.a=I.TernarySearchTree.forUris(()=>$),this.a.fill(z);break;case 0:this.b=I.TernarySearchTree.forUris(()=>$),this.b.fill(z);break;case 2:this.c=I.TernarySearchTree.forUris(()=>$),this.c.fill(z);break}}contains(le,...$){return this.d(le,{includeChildren:!1},...$)}affects(le,...$){return this.d(le,{includeChildren:!0},...$)}d(le,$,...W){if(!le)return!1;const T=W.length>0;return!!((!T||W.includes(1))&&(this.a?.get(le)||$.includeChildren&&this.a?.findSuperstr(le))||(!T||W.includes(0))&&(this.b?.get(le)||$.includeChildren&&this.b?.findSuperstr(le))||(!T||W.includes(2))&&(this.c?.findSubstr(le)||$.includeChildren&&this.c?.findSuperstr(le)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=S;function D(K,le,$){return!K||!le||K===le||le.length>K.length?!1:(le.charAt(le.length-1)!==t.sep&&(le+=t.sep),$?(0,k.startsWithIgnoreCase)(K,le):K.indexOf(le)===0)}e.isParent=D;class L extends Error{constructor(le,$,W){super(le),this.fileOperationResult=$,this.options=W}}e.FileOperationError=L;class N extends L{constructor(le,$,W){super(le,2,W),this.stat=$}}e.NotModifiedSinceFileOperationError=N;var X;(function(K){K[K.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",K[K.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",K[K.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",K[K.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",K[K.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",K[K.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",K[K.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",K[K.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",K[K.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",K[K.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",K[K.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",K[K.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(X=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var ae;(function(K){K[K.FILE=0]="FILE",K[K.FOLDER=1]="FOLDER",K[K.ROOT_FOLDER=2]="ROOT_FOLDER"})(ae=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function J(K){if(!(typeof K.size!="number"||typeof K.mtime!="number"))return K.mtime.toString(29)+K.size.toString(31)}e.etag=J;async function Y(K,le){if(!le.hasProvider(A.URI.from({scheme:K.scheme})))return new Promise($=>{const W=le.onDidChangeFileSystemProviderRegistrations(T=>{T.scheme===K.scheme&&T.added&&(W.dispose(),$())})})}e.whenProviderRegistered=Y,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class se{static formatSize(le){return(0,R.isNumber)(le)||(le=0),le<se.KB?(0,C.localize)(1,null,le.toFixed(0)):le<se.MB?(0,C.localize)(2,null,(le/se.KB).toFixed(2)):le<se.GB?(0,C.localize)(3,null,(le/se.MB).toFixed(2)):le<se.TB?(0,C.localize)(4,null,(le/se.GB).toFixed(2)):(0,C.localize)(5,null,(le/se.TB).toFixed(2))}}e.ByteSize=se,se.KB=1024,se.MB=se.KB*se.KB,se.GB=se.MB*se.KB,se.TB=se.GB*se.KB;var re;(function(K){K[K.IA32=0]="IA32",K[K.OTHER=1]="OTHER"})(re=e.Arch||(e.Arch={}));function fe(K){return{maxFileSize:K===0?300*se.MB:16*se.GB,maxHeapSize:K===0?700*se.MB:2*700*se.MB}}e.getPlatformLimits=fe}),define(te[196],ie([0,1,17,45,14,3,2,59,7,29,16]),function(V,e,I,t,k,R,A,C,w,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class P extends A.Disposable{constructor(h,d){super(),this.a=h,this.b=d,this.onDidChangeCapabilities=R.Event.None,this.f=this.B(new R.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new R.Emitter),this.onDidWatchError=this.g.event,this.h=(0,m.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,d){const{buffer:v}=await this.a.call("readFile",[h,d]);return v}readFileStream(h,d,v){const b=(0,C.newWriteableStream)(p=>I.VSBuffer.concat(p.map(g=>I.VSBuffer.wrap(g))).buffer),u=this.a.listen("readFileStream",[h,d])(p=>{if(p instanceof I.VSBuffer)b.write(p.buffer);else{if(p==="end")b.end();else{let g=p;g instanceof Error||(g=(0,y.createFileSystemProviderError)((0,t.toErrorMessage)(g),y.FileSystemProviderErrorCode.Unknown)),b.error(g),b.end()}u.dispose()}});return v.onCancellationRequested(()=>{b.error((0,k.canceled)()),b.end(),u.dispose()}),b}writeFile(h,d,v){return this.a.call("writeFile",[h,I.VSBuffer.wrap(d),v])}open(h,d){return this.a.call("open",[h,d])}close(h){return this.a.call("close",[h])}async read(h,d,v,b,u){const[p,g]=await this.a.call("read",[h,d,u]);return v.set(p.buffer.slice(0,g),b),g}write(h,d,v,b,u){return this.a.call("write",[h,d,I.VSBuffer.wrap(v),b,u])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,d){return this.a.call("delete",[h,d])}rename(h,d,v){return this.a.call("rename",[h,d,v])}copy(h,d,v){return this.a.call("copy",[h,d,v])}cloneFile(h,d){return this.a.call("cloneFile",[h,d])}i(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const d=h;this.f.fire(d.map(v=>({resource:w.URI.revive(v.resource),type:v.type})))}else{const d=h;this.g.fire(d)}}))}watch(h,d){const v=(0,m.generateUuid)();return this.a.call("watch",[this.h,v,h,d]),(0,A.toDisposable)(()=>this.a.call("unwatch",[this.h,v]))}}e.DiskFileSystemProviderClient=P}),define(te[108],ie([0,1,17,14,160,16]),function(V,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(y,P,E,h,d,v){let b;try{await C(y,P,E,h,d,v)}catch(u){b=u}finally{b&&d.errorTransformer&&(b=d.errorTransformer(b)),typeof b<"u"&&E.error(b),E.end()}}e.readFileIntoStream=A;async function C(y,P,E,h,d,v){w(v);const b=await y.open(P,{create:!1});try{w(v);let u=0,p=0,g=d&&typeof d.length=="number"?d.length:void 0,f=I.VSBuffer.alloc(Math.min(d.bufferSize,typeof g=="number"?g:d.bufferSize)),l=d&&typeof d.position=="number"?d.position:0,i=0;do p=await y.read(b,l,f.buffer,i,f.byteLength-i),l+=p,i+=p,u+=p,typeof g=="number"&&(g-=p),i===f.byteLength&&(await E.write(h(f)),f=I.VSBuffer.alloc(Math.min(d.bufferSize,typeof g=="number"?g:d.bufferSize)),i=0);while(p>0&&(typeof g!="number"||g>0)&&w(v)&&m(u,d));if(i>0){let s=i;typeof g=="number"&&(s=Math.min(i,g)),E.write(h(f.slice(0,s)))}}catch(u){throw(0,R.ensureFileSystemProviderError)(u)}finally{await y.close(b)}}function w(y){if(y.isCancellationRequested)throw(0,t.canceled)();return!0}function m(y,P){if(P?.limits){if(typeof P.limits.memory=="number"&&y>P.limits.memory)throw(0,R.createFileSystemProviderError)((0,k.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof P.limits.size=="number"&&y>P.limits.size)throw(0,R.createFileSystemProviderError)((0,k.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[72],ie([0,1,99,2,9,4,7,16]),function(V,e,I,t,k,R,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function w(u){return u.recursive===!0}e.isRecursiveWatchRequest=w;class m extends t.Disposable{constructor(p,g,f,l){super(),this.h=p,this.i=g,this.j=f,this.k=l,this.c=this.B(new t.MutableDisposable),this.f=void 0,this.g=0}m(){const p=new t.DisposableStore;this.c.value=p,this.b=this.l(p),this.b.setVerboseLogging(this.j),p.add(this.b.onDidChangeFile(g=>this.h(g))),p.add(this.b.onDidLogMessage(g=>this.i(g))),p.add(this.b.onDidError(g=>this.n(g)))}n(p){this.k.restartOnError?this.g<m.a&&this.f?(this.r(`restarting watcher after error: ${p}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${p}`):this.r(p)}p(p){this.g++,this.m(),this.watch(p)}async watch(p){this.f=p,await this.b?.watch(p)}async setVerboseLogging(p){this.j=p,await this.b?.setVerboseLogging(p)}r(p){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${p}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=m,m.a=5;class y extends m{constructor(p,g,f){super(p,g,f,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=y;class P extends m{constructor(p,g,f){super(p,g,f,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=P;function E(u){return u.map(p=>({type:p.type,resource:A.URI.file(p.path)}))}e.toFileChanges=E;function h(u){const p=new b;for(const g of u)p.processEvent(g);return p.coalesce()}e.coalesceEvents=h;function d(u,p){return typeof p=="string"&&!p.startsWith(I.GLOBSTAR)&&!(0,k.isAbsolute)(p)?{base:u,pattern:p}:p}e.normalizeWatcherPattern=d;function v(u,p){const g=[];for(const f of p)g.push((0,I.parse)(d(u,f)));return g}e.parseWatcherPatterns=v;class b{constructor(){this.a=new Set,this.b=new Map}c(p){return R.isLinux?p.path:p.path.toLowerCase()}processEvent(p){const g=this.b.get(this.c(p));let f=!1;if(g){const l=g.type,i=p.type;g.path!==p.path&&(p.type===2||p.type===1)?f=!0:l===1&&i===2?(this.b.delete(this.c(p)),this.a.delete(g)):l===2&&i===1?g.type=0:l===1&&i===0||(g.type=i)}else f=!0;f&&(this.a.add(p),this.b.set(this.c(p),p))}coalesce(){const p=[],g=[];return Array.from(this.a).filter(f=>f.type!==2?(p.push(f),!1):!0).sort((f,l)=>f.path.length-l.path.length).filter(f=>g.some(l=>(0,C.isParent)(f.path,l,!R.isLinux))?!1:(g.push(f.path),!0)).concat(p)}}}),define(te[197],ie([0,1,40,8,22,30,2,76,9,4,100,23,72]),function(V,e,I,t,k,R,A,C,w,m,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class h extends A.Disposable{constructor(b,u,p,g){super(),this.k=b,this.l=u,this.m=p,this.n=g,this.c=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},f=>this.l(f)),this.f=this.B(new t.ThrottledDelayer(h.b)),this.g=[],this.h=(0,E.parseWatcherPatterns)(this.k.path,this.k.excludes),this.i=this.k.includes?(0,E.parseWatcherPatterns)(this.k.path,this.k.includes):void 0,this.j=new k.CancellationTokenSource,this.ready=this.r()}async r(){try{const b=await this.s(this.k);if(this.j.token.isCancellationRequested)return;const u=await P.Promises.stat(b);this.B(await this.t(b,u.isDirectory()))}catch(b){b.code!=="ENOENT"?this.w(b):this.z(b)}}async s(b){let u=b.path;try{u=await P.Promises.realpath(b.path),b.path===u&&(u=await(0,y.realcase)(b.path)??b.path),b.path!==u&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${b.path}, real: ${u})`)}catch{}return u}async t(b,u){if(m.isMacintosh&&(0,R.isEqualOrParent)(b,"/Volumes/",!0))return this.w(`Refusing to watch ${b} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.Disposable.None;const p=new k.CancellationTokenSource(this.j.token),g=new A.DisposableStore;try{const f=(0,w.basename)(b),l=(0,I.watch)(b);g.add((0,A.toDisposable)(()=>{l.removeAllListeners(),l.close()})),this.z(`Started watching: '${b}'`);const i=new Set;if(u)try{for(const n of await P.Promises.readdir(b))i.add(n)}catch(n){this.w(n)}const s=new Map;g.add((0,A.toDisposable)(()=>{for(const[,n]of s)n.dispose();s.clear()})),l.on("error",(n,a)=>{this.w(`Failed to watch ${b} for changes using fs.watch() (${n}, ${a})`),this.dispose()}),l.on("change",(n,a)=>{if(p.token.isCancellationRequested)return;this.z(`[raw] ["${n}"] ${a}`);let r="";if(a&&(r=a.toString(),m.isMacintosh&&(r=(0,C.normalizeNFC)(r))),!(!r||n!=="change"&&n!=="rename"))if(u)if(n==="rename"){s.get(r)?.dispose();const c=setTimeout(async()=>{if(s.delete(r),r===f&&!await P.Promises.exists(b)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const o=await this.v((0,w.join)(b,r));if(p.token.isCancellationRequested)return;let S;o?i.has(r)?S=0:(S=1,i.add(r)):(i.delete(r),S=2),this.u({path:(0,w.join)(this.k.path,r),type:S})},h.a);s.set(r,(0,A.toDisposable)(()=>clearTimeout(c)))}else{let c;i.has(r)?c=0:(c=1,i.add(r)),this.u({path:(0,w.join)(this.k.path,r),type:c})}else if(n==="rename"||r!==f){const c=setTimeout(async()=>{const o=await P.Promises.exists(b);p.token.isCancellationRequested||(o?(this.u({path:this.k.path,type:0},!0),g.add(await this.t(b,!1))):(await this.u({path:this.k.path,type:2},!0),this.dispose()))},h.a);g.clear(),g.add((0,A.toDisposable)(()=>clearTimeout(c)))}else this.u({path:this.k.path,type:0},!0)})}catch(f){await P.Promises.exists(b)&&!p.token.isCancellationRequested&&this.w(`Failed to watch ${b} for changes using fs.watch() (${f.toString()})`)}return(0,A.toDisposable)(()=>{p.dispose(!0),g.dispose()})}async u(b,u=!1){if(!this.j.token.isCancellationRequested){this.n&&this.z(`${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`),!u&&this.h.some(p=>p(b.path))?this.n&&this.z(` >> ignored (excluded) ${b.path}`):!u&&this.i&&this.i.length>0&&!this.i.some(p=>p(b.path))?this.n&&this.z(` >> ignored (not included) ${b.path}`):this.g.push(b);try{await this.f.trigger(async()=>{const p=this.g;this.g=[];const g=(0,E.coalesceEvents)(p);if(g.length>0){if(this.n)for(const l of g)this.z(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);this.c.work(g)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async v(b){if(m.isLinux)return P.Promises.exists(b);try{const u=(0,w.basename)(b);return(await P.Promises.readdir((0,w.dirname)(b))).some(g=>g===u)}catch(u){return this.z(u),!1}}setVerboseLogging(b){this.n=b}w(b){this.j.token.isCancellationRequested||this.m?.({type:"error",message:`[File Watcher (node.js)] ${b}`})}y(b){this.j.token.isCancellationRequested||this.m?.({type:"warn",message:`[File Watcher (node.js)] ${b}`})}z(b){!this.j.token.isCancellationRequested&&this.n&&this.m?.({type:"trace",message:`[File Watcher (node.js)] ${b}`})}dispose(){this.z(`stopping file watcher on ${this.k.path}`),this.j.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=h,h.a=100,h.b=50;async function d(v,b,u,p,g=512){const f=await P.Promises.open(v,"r"),l=Buffer.allocUnsafe(g),i=new k.CancellationTokenSource(p);let s,n=!1;const a={path:v,excludes:[],recursive:!1},r=new h(a,c=>{(async()=>{for(const{type:o}of c)if(o===0){if(n)return;n=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:S}=await P.Promises.read(f,l,0,g,null);if(!S||i.token.isCancellationRequested)break;b(l.slice(0,S))}}catch(S){s=new Error(S),i.dispose(!0)}finally{n=!1}}})()});return await r.ready,u(),new Promise((c,o)=>{i.token.onCancellationRequested(async()=>{r.dispose();try{await P.Promises.close(f)}catch(S){s=new Error(S)}s?o(s):c()})})}e.watchFileContents=d}),define(te[198],ie([0,1,3,99,2,4,197]),function(V,e,I,t,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class C extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new I.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new I.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=I.Event.None,this.c=new Map,this.f=!1}async watch(m){const y=this.i(m),P=y.filter(h=>{const d=this.c.get(h.path);return d?!(0,t.patternsEquals)(d.request.excludes,h.excludes)||!(0,t.patternsEquals)(d.request.includes,h.includes):!0}),E=Array.from(this.c.values()).filter(({request:h})=>!y.find(d=>d.path===h.path&&(0,t.patternsEquals)(d.excludes,h.excludes)&&(0,t.patternsEquals)(d.includes,h.includes))).map(({request:h})=>h.path);P.length&&this.j(`Request to start watching: ${P.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"})`).join(",")}`),E.length&&this.j(`Request to stop watching: ${E.join(",")}`);for(const h of E)this.h(h);for(const h of P)this.g(h)}g(m){const y=new A.NodeJSFileWatcherLibrary(m,E=>this.a.fire(E),E=>this.b.fire(E),this.f),P={request:m,instance:y};this.c.set(m.path,P)}async stop(){for(const[m]of this.c)this.h(m);this.c.clear()}h(m){const y=this.c.get(m);y&&(this.c.delete(m),y.instance.dispose())}i(m){const y=new Map;for(const P of m){const E=R.isLinux?P.path:P.path.toLowerCase();y.set(E,P)}return Array.from(y.values())}async setVerboseLogging(m){this.f=m;for(const[,y]of this.c)y.instance.setVerboseLogging(m)}j(m){this.f&&this.b.fire({type:"trace",message:this.k(m)})}k(m,y){return y?`[File Watcher (node.js)] ${m} (path: ${y.request.path})`:`[File Watcher (node.js)] ${m}`}}e.NodeJSWatcher=C}),define(te[199],ie([0,1,72,198]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends I.AbstractNonRecursiveWatcherClient{constructor(A,C,w){super(A,C,w),this.m()}l(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(te[200],ie([0,1,15,47,146,72]),function(V,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends R.AbstractUniversalWatcherClient{constructor(w,m,y){super(w,m,y),this.m()}l(w){const m=w.add(new k.Client(I.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(m.onDidProcessExit(({code:y,signal:P})=>this.n(`terminated by itself with code ${y}, signal: ${P}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(m.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(te[85],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class I{constructor(...k){this.a=new Map;for(const[R,A]of k)this.set(R,A)}set(k,R){const A=this.a.get(k);return this.a.set(k,R),A}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.ServiceCollection=I}),define(te[201],ie([0,1,8,14,2,70,191,5,85,96]),function(V,e,I,t,k,R,A,C,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const y=!1;class P extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class E{constructor(b=new w.ServiceCollection,u=!1,p,g=y){this.f=b,this.g=u,this.h=p,this.i=g,this.o=new Set,this.f.set(C.IInstantiationService,this),this._globalGraph=g?p?._globalGraph??new A.Graph(f=>f):void 0}createChild(b){return new E(b,this.g,this,this.i)}invokeFunction(b,...u){const p=d.traceInvocation(this.i,b);let g=!1;try{return b({get:l=>{if(g)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(l,p);if(!i)throw new Error(`[invokeFunction] unknown service '${l}'`);return i}},...u)}finally{g=!0,p.stop()}}createInstance(b,...u){let p,g;return b instanceof R.SyncDescriptor?(p=d.traceCreation(this.i,b.ctor),g=this.j(b.ctor,b.staticArguments.concat(u),p)):(p=d.traceCreation(this.i,b),g=this.j(b,u,p)),p.stop(),g}j(b,u=[],p){const g=C._util.getServiceDependencies(b).sort((i,s)=>i.index-s.index),f=[];for(const i of g){const s=this.m(i.id,p);s||this.u(`[createInstance] ${b.name} depends on UNKNOWN service ${i.id}.`,!1),f.push(s)}const l=g.length>0?g[0].index:u.length;if(u.length!==l){console.trace(`[createInstance] First service dependency of ${b.name} at position ${l+1} conflicts with ${u.length} static arguments`);const i=l-u.length;i>0?u=u.concat(new Array(i)):u=u.slice(0,l)}return Reflect.construct(b,u.concat(f))}k(b,u){if(this.f.get(b)instanceof R.SyncDescriptor)this.f.set(b,u);else if(this.h)this.h.k(b,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(b){const u=this.f.get(b);return!u&&this.h?this.h.l(b):u}m(b,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const p=this.l(b);return p instanceof R.SyncDescriptor?this.q(b,p,u.branch(b,!0)):(u.branch(b,!1),p)}q(b,u,p){if(this.o.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.o.add(b);try{return this.r(b,u,p)}finally{this.o.delete(b)}}r(b,u,p){const g=new A.Graph(i=>i.id.toString());let f=0;const l=[{id:b,desc:u,_trace:p}];for(;l.length;){const i=l.pop();if(g.lookupOrInsertNode(i),f++>1e3)throw new P(g);for(const s of C._util.getServiceDependencies(i.desc.ctor)){const n=this.l(s.id);if(n||this.u(`[createInstance] ${b} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),n instanceof R.SyncDescriptor){const a={id:s.id,desc:n,_trace:i._trace.branch(s.id,!0)};g.insertEdge(i,a),l.push(a)}}}for(;;){const i=g.roots();if(i.length===0){if(!g.isEmpty())throw new P(g);break}for(const{data:s}of i){if(this.l(s.id)instanceof R.SyncDescriptor){const a=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,a)}g.removeNode(s)}}return this.l(b)}s(b,u,p=[],g,f){if(this.f.get(b)instanceof R.SyncDescriptor)return this.t(b,u,p,g,f);if(this.h)return this.h.s(b,u,p,g,f);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(b,u,p=[],g,f){if(g){const l=new E(void 0,this.g,this,this.i);l.c=String(b);const i=new Map,s=new I.IdleValue(()=>{const n=l.j(u,p,f);for(const[a,r]of i){const c=n[a];if(typeof c=="function")for(const o of r)c.apply(n,o)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,a){if(!s.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let o=i.get(a);return o||(o=new m.LinkedList,i.set(a,o)),(D,L,N)=>{const X=o.push([D,L,N]);return(0,k.toDisposable)(X)}}if(a in n)return n[a];const r=s.value;let c=r[a];return typeof c!="function"||(c=c.bind(r),n[a]=c),c},set(n,a,r){return s.value[a]=r,!0},getPrototypeOf(n){return u.prototype}})}else return this.j(u,p,f)}u(b,u){if(u&&console.warn(b),this.g)throw new Error(b)}}e.InstantiationService=E;var h;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(h||(h={}));class d{static traceInvocation(b,u){return b?new d(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(b,u){return b?new d(1,u.name):d.c}constructor(b,u){this.type=b,this.name=u,this.g=Date.now(),this.h=[]}branch(b,u){const p=new d(3,b.toString());return this.h.push([b,u,p]),p}stop(){const b=Date.now()-this.g;d.f+=b;let u=!1;function p(f,l){const i=[],s=new Array(f+1).join("	");for(const[n,a,r]of l.h)if(a&&r){u=!0,i.push(`${s}CREATES -> ${n}`);const c=p(f+1,r);c&&i.push(c)}else i.push(`${s}uses -> ${n}`);return i.join(`
`)}const g=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(b>2||u)&&d.all.add(g.join(`
`))}}e.Trace=d,d.all=new Set,d.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}},d.f=0}),define(te[6],ie([0,1,45,3,2,39,4,7,5]),function(V,e,I,t,k,R,A,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function m(){return new Date().toISOString()}var y;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;function P(c,o,S){switch(o){case y.Trace:c.trace(S);break;case y.Debug:c.debug(S);break;case y.Info:c.info(S);break;case y.Warning:c.warn(S);break;case y.Error:c.error(S);break;case y.Off:break;default:throw new Error(`Invalid log level ${o}`)}}e.log=P;function E(c){let o="";for(let S=0;S<c.length;S++){let D=c[S];if(typeof D=="object")try{D=JSON.stringify(D)}catch{}o+=(S>0?" ":"")+D}return o}e.format=E;class h extends k.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(o){this.b!==o&&(this.b=o,this.c.fire(this.b))}getLevel(){return this.b}f(o){return this.b!==y.Off&&this.b<=o}}e.AbstractLogger=h;class d extends h{constructor(o){super(),this.h=o}f(o){return this.h||super.f(o)}trace(o,...S){this.f(y.Trace)&&this.g(y.Trace,E([o,...S]))}debug(o,...S){this.f(y.Debug)&&this.g(y.Debug,E([o,...S]))}info(o,...S){this.f(y.Info)&&this.g(y.Info,E([o,...S]))}warn(o,...S){this.f(y.Warning)&&this.g(y.Warning,E([o,...S]))}error(o,...S){if(this.f(y.Error))if(o instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=o.stack,this.g(y.Error,E(D))}else this.g(y.Error,E([o,...S]))}flush(){}}e.AbstractMessageLogger=d;class v extends h{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o),this.g=!A.isWindows}trace(o,...S){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,o,...S):console.log(`[main ${m()}]`,o,...S))}debug(o,...S){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,o,...S):console.log(`[main ${m()}]`,o,...S))}info(o,...S){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,o,...S):console.log(`[main ${m()}]`,o,...S))}warn(o,...S){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,o,...S):console.warn(`[main ${m()}]`,o,...S))}error(o,...S){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,o,...S):console.error(`[main ${m()}]`,o,...S))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class b extends h{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o)}trace(o,...S){this.f(y.Trace)&&console.log("%cTRACE","color: #888",o,...S)}debug(o,...S){this.f(y.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",o,...S)}info(o,...S){this.f(y.Info)&&console.log("%c INFO","color: #33f",o,...S)}warn(o,...S){this.f(y.Warning)&&console.log("%c WARN","color: #993",o,...S)}error(o,...S){this.f(y.Error)&&console.log("%c  ERR","color: #f33",o,...S)}dispose(){}flush(){}}e.ConsoleLogger=b;class u extends h{constructor(o,S=e.DEFAULT_LOG_LEVEL){super(),this.g=o,this.setLevel(S)}trace(o,...S){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(o),...S])}debug(o,...S){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(o),...S])}info(o,...S){this.f(y.Info)&&this.g.log(y.Info,[this.h(o),...S])}warn(o,...S){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(o),...S])}error(o,...S){this.f(y.Error)&&this.g.log(y.Error,[this.h(o),...S])}h(o){return typeof o=="string"?o:(0,I.toErrorMessage)(o,this.f(y.Trace))}dispose(){}flush(){}}e.AdapterLogger=u;class p extends h{constructor(o){super(),this.g=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const S of this.g)S.setLevel(o);super.setLevel(o)}trace(o,...S){for(const D of this.g)D.trace(o,...S)}debug(o,...S){for(const D of this.g)D.debug(o,...S)}info(o,...S){for(const D of this.g)D.info(o,...S)}warn(o,...S){for(const D of this.g)D.warn(o,...S)}error(o,...S){for(const D of this.g)D.error(o,...S)}flush(){for(const o of this.g)o.flush()}dispose(){for(const o of this.g)o.dispose()}}e.MultiplexLogService=p;class g extends k.Disposable{constructor(o){super(),this.b=o,this.B(o)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(o){this.b.setLevel(o)}getLevel(){return this.b.getLevel()}trace(o,...S){this.b.trace(o,...S)}debug(o,...S){this.b.debug(o,...S)}info(o,...S){this.b.info(o,...S)}warn(o,...S){this.b.warn(o,...S)}error(o,...S){this.b.error(o,...S)}flush(){this.b.flush()}}e.LogService=g;class f extends k.Disposable{constructor(o,S){super(),this.c=o,this.b=new R.ResourceMap,this.B(S(D=>this.setLevel(D)))}getLoggers(){return[...this.b.values()].map(({logger:o})=>o)}getLogger(o){return this.b.get(o)?.logger}createLogger(o,S,D){let L=this.b.get(o)?.logger;return L||(D=S?.always?y.Trace:D,L=this.f(o,D??this.c,S),this.b.set(o,{logger:L,logLevel:D})),L}setLevel(o,S){const D=C.URI.isUri(o)?o:void 0,L=D?S:o;if(D){const N=this.b.get(D);N&&N.logLevel!==L&&(N.logLevel=L,N.logger.setLevel(L))}else this.c=L,this.b.forEach(({logLevel:N,logger:X})=>{N===void 0&&X.setLevel(this.c)})}getLogLevel(o){return this.b.get(o)?.logLevel}dispose(){this.b.forEach(({logger:o})=>o.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=f;class l{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(o){}getLevel(){return y.Info}trace(o,...S){}debug(o,...S){}info(o,...S){}warn(o,...S){}error(o,...S){}critical(o,...S){}dispose(){}flush(){}}e.NullLogger=l;class i extends l{}e.NullLogService=i;class s extends f{constructor(){super(y.Info,t.Event.None)}f(o,S,D){return new l}}e.NullLoggerService=s;function n(c){if(c.verbose)return y.Trace;if(typeof c.logLevel=="string"){const o=r(c.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function a(c){switch(c){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.LogLevelToString=a;function r(c){switch(c){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.parseLogLevel=r});var ne=this&&this.__param||function(V,e){return function(I,t){e(I,t,V)}};define(te[202],ie([0,1,71,3,2,6,4,8]),function(V,e,I,t,k,R,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let w=class Et extends k.Disposable{constructor(y){super(),this.g=y,this.c=this.B(new t.Emitter),this.onDidChangePassword=this.c.event}async getPassword(y,P){this.g.trace("Getting password from keytar:",y,P);let E;try{E=await this.h()}catch{return null}const h=await(0,C.retry)(()=>E.getPassword(y,P),50,3);if(!h)return this.g.trace("Did not get a password from keytar for account:",P),h;let d,v;try{const b=JSON.parse(h);d=b.content,v=b.hasNextChunk}catch{}if(!d||!v)return this.g.trace("Got password from keytar for account:",P),h;try{let b=1;for(;v;){const u=await(0,C.retry)(()=>E.getPassword(y,`${P}-${b}`),50,3),p=JSON.parse(u);d+=p.content,v=p.hasNextChunk,b++}return this.g.trace(`Got ${b}-chunked password from keytar for account:`,P),d}catch(b){return this.g.error(b),h}}async setPassword(y,P,E){this.g.trace("Setting password using keytar:",y,P);let h;try{h=await this.h()}catch(d){throw this.i?.(d),d}if(A.isWindows&&E.length>Et.a){let d=0,v=0,b=!0;for(;b;){const u=E.substring(d,d+Et.b);d+=Et.b,b=E.length-d>0;const p={content:u,hasNextChunk:b};await(0,C.retry)(()=>h.setPassword(y,v?`${P}-${v}`:P,JSON.stringify(p)),50,3),v++}this.g.trace(`Got${v?` ${v}-chunked`:""} password from keytar for account:`,P)}else await(0,C.retry)(()=>h.setPassword(y,P,E),50,3),this.g.trace("Got password from keytar for account:",P);this.c.fire({service:y,account:P})}async deletePassword(y,P){this.g.trace("Deleting password using keytar:",y,P);let E;try{E=await this.h()}catch(u){throw this.i?.(u),u}const h=await E.getPassword(y,P);if(!h)return this.g.trace("Did not get a password to delete from keytar for account:",P),!1;let d,v;try{const u=JSON.parse(h);d=u.content,v=u.hasNextChunk}catch{}let b=0;if(d&&v)try{for(b++;v;){const u=`${P}-${b}`,p=await E.getPassword(y,u);await E.deletePassword(y,u),v=JSON.parse(p).hasNextChunk,b++}}catch(u){this.g.error(u)}return await E.deletePassword(y,P)?(this.c.fire({service:y,account:P}),this.g.trace(`Deleted${b?` ${b}-chunked`:""} password from keytar for account:`,P),!0):(this.g.trace(`Keytar failed to delete${b?` ${b}-chunked`:""} password for account:`,P),!1)}async findPassword(y){let P;try{P=await this.h()}catch{return null}return await P.findPassword(y)}async findCredentials(y){let P;try{P=await this.h()}catch{return[]}return await P.findCredentials(y)}clear(){return this.f instanceof I.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};w.a=2500,w.b=w.a-100,w=pe([ne(0,R.ILogService)],w),e.BaseCredentialsMainService=w}),define(te[203],ie([0,1,6]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let t=class{constructor(R,A){this.a=R,this.b=A}c(){return new Promise((R,A)=>V(["vscode-encrypt"],R,A))}async encrypt(R){let A;try{A=await this.c()}catch{return R}try{return A.encrypt(this.a,R)}catch(C){return this.b.error(C),R}}async decrypt(R){let A;try{A=await this.c()}catch{return R}try{return A.decrypt(this.a,R)}catch(C){return this.b.error(C),R}}};t=pe([ne(1,I.ILogService)],t),e.EncryptionMainService=t}),define(te[204],ie([0,1,24,8,14,3,2,9,72,6]),function(V,e,I,t,k,R,A,C,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class y extends A.Disposable{constructor(E,h){super(),this.a=E,this.b=h,this.c=this.B(new R.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new R.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new t.ThrottledDelayer(0)),this.s=[],this.t=this.B(new t.ThrottledDelayer(0))}watch(E,h){return h.recursive||this.b?.watcher?.forceUniversal?this.l(E,h):this.u(E,h)}l(E,h){const d={path:this.C(E),excludes:h.excludes,includes:h.includes,recursive:h.recursive},v=(0,I.insert)(this.j,d);return this.m(),(0,A.toDisposable)(()=>{v(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(E=>(0,k.onUnexpectedError)(E))}n(){this.h||(this.h=this.B(this.p(h=>this.c.fire((0,w.toFileChanges)(h)),h=>this.z(h),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)})));const E=this.b?.watcher?.recursive?.usePolling;if(E===!0)for(const h of this.j)(0,w.isRecursiveWatchRequest)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(E))for(const h of this.j)(0,w.isRecursiveWatchRequest)(h)&&E.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(E,h){const d={path:this.C(E),excludes:h.excludes,includes:h.includes,recursive:!1},v=(0,I.insert)(this.s,d);return this.v(),(0,A.toDisposable)(()=>{v(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(E=>(0,k.onUnexpectedError)(E))}w(){return this.r||(this.r=this.B(this.y(E=>this.c.fire((0,w.toFileChanges)(E)),E=>this.z(E),this.a.getLevel()===m.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===m.LogLevel.Trace)}))),this.r.watch(this.s)}z(E){E.type==="error"&&this.g.fire(E.message),this.a[E.type](E.message)}C(E){return(0,C.normalize)(E.fsPath)}}e.AbstractDiskFileSystemProvider=y}),define(te[205],ie([0,1,24,8,17,22,3,68,67,2,60,15,73,20,59,158,16,108,6]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h,d,v,b,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let g=class extends m.Disposable{constructor(l){super(),this.b=l,this.a=256*1024,this.c=this.B(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new A.Emitter),this.onDidRunOperation=this.m.event,this.Q=this.B(new A.Emitter),this.onDidFilesChange=this.Q.event,this.R=this.B(new A.Emitter),this.onDidWatchError=this.R.event,this.S=new Map,this.W=this.B(new t.ResourceQueue)}registerProvider(l,i){if(this.h.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${l}`);const s=new m.DisposableStore;return this.h.set(l,i),this.c.fire({added:!0,scheme:l,provider:i}),s.add(i.onDidChangeFile(n=>this.Q.fire(new b.FileChangesEvent(n,!this.N(i))))),typeof i.onDidWatchError=="function"&&s.add(i.onDidWatchError(n=>this.R.fire(new Error(n)))),s.add(i.onDidChangeCapabilities(()=>this.g.fire({provider:i,scheme:l}))),(0,m.toDisposable)(()=>{this.c.fire({added:!1,scheme:l,provider:i}),this.h.delete(l),(0,m.dispose)(s)})}getProvider(l){return this.h.get(l)}async activateProvider(l){const i=[];this.f.fire({scheme:l,join(s){i.push(s)}}),!this.h.has(l)&&await t.Promises.settled(i)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.h.has(l.scheme)}hasCapability(l,i){const s=this.h.get(l.scheme);return!!(s&&s.capabilities&i)}listCapabilities(){return w.Iterable.map(this.h,([l,i])=>({scheme:l,capabilities:i.capabilities}))}async j(l){if(!(0,h.isAbsolutePath)(l))throw new b.FileOperationError((0,v.localize)(0,null,this.mb(l)),8);await this.activateProvider(l.scheme);const i=this.h.get(l.scheme);if(!i){const s=new Error;throw s.name="ENOPRO",s.message=(0,v.localize)(1,null,l.toString()),s}return i}async k(l){const i=await this.j(l);if((0,b.hasOpenReadWriteCloseCapability)(i)||(0,b.hasReadWriteCapability)(i)||(0,b.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(l){const i=await this.j(l);if((0,b.hasOpenReadWriteCloseCapability)(i)||(0,b.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,i){try{return await this.n(l,i)}catch(s){throw(0,b.toFileSystemProviderErrorCode)(s)===b.FileSystemProviderErrorCode.FileNotFound?new b.FileOperationError((0,v.localize)(2,null,this.mb(l)),1):(0,b.ensureFileSystemProviderError)(s)}}async n(l,i){const s=await this.j(l),n=this.N(s),a=i?.resolveTo,r=i?.resolveSingleChildDescendants,c=i?.resolveMetadata,o=await s.stat(l);let S;return this.p(s,l,o,void 0,!!c,(D,L)=>(S||(S=y.TernarySearchTree.forUris(()=>!n),S.set(l,!0),a&&S.fill(!0,a)),S.get(D.resource)||S.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&r?L===1:!1))}async p(l,i,s,n,a,r){const{providerExtUri:c}=this.M(l),o={resource:i,name:c.basename(i),isFile:(s.type&b.FileType.File)!==0,isDirectory:(s.type&b.FileType.Directory)!==0,isSymbolicLink:(s.type&b.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:Boolean((s.permissions??0)&b.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,b.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(o.isDirectory&&r(o,n)){try{const S=await l.readdir(i),D=await t.Promises.settled(S.map(async([L,N])=>{try{const X=c.joinPath(i,L),ae=a?await l.stat(X):{type:N};return await this.p(l,X,ae,S.length,a,r)}catch(X){return this.b.trace(X),null}}));o.children=(0,I.coalesce)(D)}catch(S){this.b.trace(S),o.children=[]}return o}return o}async resolveAll(l){return t.Promises.settled(l.map(async i=>{try{return{stat:await this.n(i.resource,i.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(l){const i=await this.j(l),s=await i.stat(l);return this.p(i,l,s,void 0,!0,()=>!1)}async exists(l){const i=await this.j(l);try{return!!await i.stat(l)}catch{return!1}}async canCreateFile(l,i){try{await this.r(l,i)}catch(s){return s}return!0}async r(l,i){if(!i?.overwrite&&await this.exists(l))throw new b.FileOperationError((0,v.localize)(3,null,this.mb(l)),3,i)}async createFile(l,i=k.VSBuffer.fromString(""),s){await this.r(l,s);const n=await this.writeFile(l,i);return this.m.fire(new b.FileOperationEvent(l,0,n)),n}async writeFile(l,i,s){const n=this.kb(await this.l(l),l),{providerExtUri:a}=this.M(n);try{await this.s(n,l,s)||await this.O(n,a.dirname(l));let c;if((0,b.hasReadWriteCapability)(n)&&!(i instanceof k.VSBuffer))if((0,d.isReadableStream)(i)){const o=await(0,d.peekStream)(i,3);o.ended?c=k.VSBuffer.concat(o.buffer):c=o}else c=(0,d.peekReadable)(i,o=>k.VSBuffer.concat(o),3);else c=i;!(0,b.hasOpenReadWriteCloseCapability)(n)||(0,b.hasReadWriteCapability)(n)&&c instanceof k.VSBuffer?await this.bb(n,l,s,c):await this.X(n,l,s,c instanceof k.VSBuffer?(0,k.bufferToReadable)(c):c),this.m.fire(new b.FileOperationEvent(l,4))}catch(r){throw new b.FileOperationError((0,v.localize)(4,null,this.mb(l),(0,b.ensureFileSystemProviderError)(r).toString()),(0,b.toFileOperationResult)(r),s)}return this.resolve(l,{resolveMetadata:!0})}async s(l,i,s){if(!!s?.unlock&&!(l.capabilities&8192))throw new Error((0,v.localize)(5,null,this.mb(i)));let a;try{a=await l.stat(i)}catch{return}if((a.type&b.FileType.Directory)!==0)throw new b.FileOperationError((0,v.localize)(6,null,this.mb(i)),0,s);if(this.lb(i,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==b.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,b.etag)({mtime:s.mtime,size:a.size}))throw new b.FileOperationError((0,v.localize)(7,null),3,s);return a}async readFile(l,i,s){const n=await this.k(l);return i?.atomic?this.t(n,l,i,s):this.u(n,l,i,s)}async t(l,i,s,n){return new Promise((a,r)=>{this.W.queueFor(i,this.M(l).providerExtUri).queue(async()=>{try{const c=await this.u(l,i,s,n);a(c)}catch(c){r(c)}})})}async u(l,i,s,n){const a=await this.v(l,i,{...s,preferUnbuffered:!0},n);return{...a,value:await(0,k.streamToBuffer)(a.value)}}async readFileStream(l,i,s){const n=await this.k(l);return this.v(n,l,i,s)}async v(l,i,s,n){const a=new R.CancellationTokenSource(n),r=this.D(i,s).then(o=>o,o=>{throw a.cancel(),o});let c;try{return typeof s?.etag=="string"&&s.etag!==b.ETAG_DISABLED&&await r,s?.atomic&&(0,b.hasFileAtomicReadCapability)(l)||!((0,b.hasOpenReadWriteCloseCapability)(l)||(0,b.hasFileReadStreamCapability)(l))||(0,b.hasReadWriteCapability)(l)&&s?.preferUnbuffered?c=this.C(l,i,s):(0,b.hasFileReadStreamCapability)(l)?c=this.w(l,i,a.token,s):c=this.z(l,i,a.token,s),{...await r,value:c}}catch(o){c&&await(0,d.consumeStream)(c);const S=(0,v.localize)(8,null,this.mb(i),(0,b.ensureFileSystemProviderError)(o).toString());throw o instanceof b.NotModifiedSinceFileOperationError?new b.NotModifiedSinceFileOperationError(S,o.stat,s):new b.FileOperationError(S,(0,b.toFileOperationResult)(o),s)}}w(l,i,s,n=Object.create(null)){const a=l.readFileStream(i,n,s);return(0,d.transform)(a,{data:r=>r instanceof k.VSBuffer?r:k.VSBuffer.wrap(r),error:r=>new b.FileOperationError((0,v.localize)(9,null,this.mb(i),(0,b.ensureFileSystemProviderError)(r).toString()),(0,b.toFileOperationResult)(r),n)},r=>k.VSBuffer.concat(r))}z(l,i,s,n=Object.create(null)){const a=(0,k.newWriteableBufferStream)();return(0,u.readFileIntoStream)(l,i,a,r=>r,{...n,bufferSize:this.a,errorTransformer:r=>new b.FileOperationError((0,v.localize)(10,null,this.mb(i),(0,b.ensureFileSystemProviderError)(r).toString()),(0,b.toFileOperationResult)(r),n)},s),a}C(l,i,s){const n=(0,d.newWriteableStream)(a=>k.VSBuffer.concat(a));return(async()=>{try{let a;s?.atomic&&(0,b.hasFileAtomicReadCapability)(l)?a=await l.readFile(i,{atomic:!0}):a=await l.readFile(i),typeof s?.position=="number"&&(a=a.slice(s.position)),typeof s?.length=="number"&&(a=a.slice(0,s.length)),this.F(i,a.byteLength,s),n.end(k.VSBuffer.wrap(a))}catch(a){n.error(a),n.end()}})(),n}async D(l,i){const s=await this.resolve(l,{resolveMetadata:!0});if(s.isDirectory)throw new b.FileOperationError((0,v.localize)(11,null,this.mb(l)),0,i);if(typeof i?.etag=="string"&&i.etag!==b.ETAG_DISABLED&&i.etag===s.etag)throw new b.NotModifiedSinceFileOperationError((0,v.localize)(12,null),s,i);return this.F(l,s.size,i),s}F(l,i,s){if(s?.limits){let n;if(typeof s.limits.memory=="number"&&i>s.limits.memory&&(n=9),typeof s.limits.size=="number"&&i>s.limits.size&&(n=7),typeof n=="number")throw new b.FileOperationError((0,v.localize)(13,null,this.mb(l)),n)}}async canMove(l,i,s){return this.G(l,i,"move",s)}async canCopy(l,i,s){return this.G(l,i,"copy",s)}async G(l,i,s,n){if(l.toString()!==i.toString())try{const a=s==="move"?this.kb(await this.l(l),l):await this.k(l),r=this.kb(await this.l(i),i);await this.L(a,l,r,i,s,n)}catch(a){return a}return!0}async move(l,i,s){const n=this.kb(await this.l(l),l),a=this.kb(await this.l(i),i),r=await this.H(n,l,a,i,"move",!!s),c=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new b.FileOperationEvent(l,r==="move"?2:3,c)),c}async copy(l,i,s){const n=await this.k(l),a=this.kb(await this.l(i),i),r=await this.H(n,l,a,i,"copy",!!s),c=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new b.FileOperationEvent(l,r==="copy"?3:2,c)),c}async H(l,i,s,n,a,r){if(i.toString()===n.toString())return a;const{exists:c,isSameResourceWithDifferentPathCase:o}=await this.L(l,i,s,n,a,r);if(c&&!o&&r&&await this.del(n,{recursive:!0}),await this.O(s,this.M(s).providerExtUri.dirname(n)),a==="copy"){if(l===s&&(0,b.hasFileFolderCopyCapability)(l))await l.copy(i,n,{overwrite:r});else{const S=await this.resolve(i);S.isDirectory?await this.J(l,S,s,n):await this.I(l,i,s,n)}return a}else return l===s?(await l.rename(i,n,{overwrite:r}),a):(await this.H(l,i,s,n,"copy",r),await this.del(i,{recursive:!0}),"copy")}async I(l,i,s,n){if((0,b.hasOpenReadWriteCloseCapability)(l)&&(0,b.hasOpenReadWriteCloseCapability)(s))return this.db(l,i,s,n);if((0,b.hasOpenReadWriteCloseCapability)(l)&&(0,b.hasReadWriteCapability)(s))return this.jb(l,i,s,n);if((0,b.hasReadWriteCapability)(l)&&(0,b.hasOpenReadWriteCloseCapability)(s))return this.hb(l,i,s,n);if((0,b.hasReadWriteCapability)(l)&&(0,b.hasReadWriteCapability)(s))return this.fb(l,i,s,n)}async J(l,i,s,n){await s.mkdir(n),Array.isArray(i.children)&&await t.Promises.settled(i.children.map(async a=>{const r=this.M(s).providerExtUri.joinPath(n,a.name);return a.isDirectory?this.J(l,await this.resolve(a.resource),s,r):this.I(l,a.resource,s,r)}))}async L(l,i,s,n,a,r){let c=!1;if(l===s){const{providerExtUri:S,isPathCaseSensitive:D}=this.M(l);if(D||(c=S.isEqual(i,n)),c&&a==="copy")throw new Error((0,v.localize)(14,null,this.mb(i),this.mb(n)));if(!c&&S.isEqualOrParent(n,i))throw new Error((0,v.localize)(15,null,this.mb(i),this.mb(n)))}const o=await this.exists(n);if(o&&!c){if(!r)throw new b.FileOperationError((0,v.localize)(16,null,this.mb(i),this.mb(n)),4);if(l===s){const{providerExtUri:S}=this.M(l);if(S.isEqualOrParent(i,n))throw new Error((0,v.localize)(17,null,this.mb(i),this.mb(n)))}}return{exists:o,isSameResourceWithDifferentPathCase:c}}M(l){const i=this.N(l);return{providerExtUri:i?h.extUri:h.extUriIgnorePathCase,isPathCaseSensitive:i}}N(l){return!!(l.capabilities&1024)}async createFolder(l){const i=this.kb(await this.j(l),l);await this.O(i,l);const s=await this.resolve(l,{resolveMetadata:!0});return this.m.fire(new b.FileOperationEvent(l,0,s)),s}async O(l,i){const s=[],{providerExtUri:n}=this.M(l);for(;!n.isEqual(i,n.dirname(i));)try{if(((await l.stat(i)).type&b.FileType.Directory)===0)throw new Error((0,v.localize)(18,null,this.mb(i)));break}catch(a){if((0,b.toFileSystemProviderErrorCode)(a)!==b.FileSystemProviderErrorCode.FileNotFound)throw a;s.push(n.basename(i)),i=n.dirname(i)}for(let a=s.length-1;a>=0;a--){i=n.joinPath(i,s[a]);try{await l.mkdir(i)}catch(r){if((0,b.toFileSystemProviderErrorCode)(r)!==b.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(l,i){try{await this.P(l,i)}catch(s){return s}return!0}async P(l,i){const s=this.kb(await this.j(l),l);if(!!i?.useTrash&&!(s.capabilities&4096))throw new Error((0,v.localize)(19,null,this.mb(l)));let a;try{a=await s.stat(l)}catch{}if(a)this.lb(l,a);else throw new b.FileOperationError((0,v.localize)(20,null,this.mb(l)),1);if(!!!i?.recursive){const c=await this.resolve(l);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,v.localize)(21,null,this.mb(l)))}return s}async del(l,i){const s=await this.P(l,i),n=!!i?.useTrash,a=!!i?.recursive;await s.delete(l,{recursive:a,useTrash:n}),this.m.fire(new b.FileOperationEvent(l,1))}async cloneFile(l,i){const s=await this.j(l),n=this.kb(await this.l(i),i);if(s===n&&this.M(s).providerExtUri.isEqual(l,i))return;if(s===n&&(0,b.hasFileCloneCapability)(s))return s.cloneFile(l,i);await this.O(n,this.M(n).providerExtUri.dirname(i));const a=this.W.queueFor(l,this.M(s).providerExtUri);return s===n&&(0,b.hasFileFolderCopyCapability)(s)?a.queue(()=>s.copy(l,i,{overwrite:!0})):a.queue(()=>this.I(s,l,n,i))}watch(l,i={recursive:!1,excludes:[]}){const s=new m.DisposableStore;let n=!1,a=()=>{n=!0};return s.add((0,m.toDisposable)(()=>a())),(async()=>{try{const r=await this.U(l,i);n?(0,m.dispose)(r):a=()=>(0,m.dispose)(r)}catch(r){this.b.error(r)}})(),s}async U(l,i){const s=await this.j(l),n=(0,C.hash)([this.M(s).providerExtUri.getComparisonKey(l),i]);let a=this.S.get(n);return a||(a={count:0,disposable:s.watch(l,i)},this.S.set(n,a)),a.count+=1,(0,m.toDisposable)(()=>{a&&(a.count--,a.count===0&&((0,m.dispose)(a.disposable),this.S.delete(n)))})}dispose(){super.dispose();for(const[,l]of this.S)(0,m.dispose)(l.disposable);this.S.clear()}async X(l,i,s,n){return this.W.queueFor(i,this.M(l).providerExtUri).queue(async()=>{const a=await l.open(i,{create:!0,unlock:s?.unlock??!1});try{(0,d.isReadableStream)(n)||(0,d.isReadableBufferedStream)(n)?await this.Y(l,a,n):await this.Z(l,a,n)}catch(r){throw(0,b.ensureFileSystemProviderError)(r)}finally{await l.close(a)}})}async Y(l,i,s){let n=0,a;if((0,d.isReadableBufferedStream)(s)){if(s.buffer.length>0){const r=k.VSBuffer.concat(s.buffer);await this.ab(l,i,r,r.byteLength,n,0),n+=r.byteLength}if(s.ended)return;a=s.stream}else a=s;return new Promise((r,c)=>{(0,d.listenStream)(a,{onData:async o=>{a.pause();try{await this.ab(l,i,o,o.byteLength,n,0)}catch(S){return c(S)}n+=o.byteLength,setTimeout(()=>a.resume())},onError:o=>c(o),onEnd:()=>r()})})}async Z(l,i,s){let n=0,a;for(;(a=s.read())!==null;)await this.ab(l,i,a,a.byteLength,n,0),n+=a.byteLength}async ab(l,i,s,n,a,r){let c=0;for(;c<n;)c+=await l.write(i,a+c,s.buffer,r+c,n-c)}async bb(l,i,s,n){return this.W.queueFor(i,this.M(l).providerExtUri).queue(()=>this.cb(l,i,s,n))}async cb(l,i,s,n){let a;n instanceof k.VSBuffer?a=n:(0,d.isReadableStream)(n)?a=await(0,k.streamToBuffer)(n):(0,d.isReadableBufferedStream)(n)?a=await(0,k.bufferedStreamToBuffer)(n):a=(0,k.readableToBuffer)(n),await l.writeFile(i,a.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1})}async db(l,i,s,n){return this.W.queueFor(n,this.M(s).providerExtUri).queue(()=>this.eb(l,i,s,n))}async eb(l,i,s,n){let a,r;try{a=await l.open(i,{create:!1}),r=await s.open(n,{create:!0,unlock:!1});const c=k.VSBuffer.alloc(this.a);let o=0,S=0,D=0;do D=await l.read(a,o,c.buffer,S,c.byteLength-S),await this.ab(s,r,c,D,o,S),o+=D,S+=D,S===c.byteLength&&(S=0);while(D>0)}catch(c){throw(0,b.ensureFileSystemProviderError)(c)}finally{await t.Promises.settled([typeof a=="number"?l.close(a):Promise.resolve(),typeof r=="number"?s.close(r):Promise.resolve()])}}async fb(l,i,s,n){return this.W.queueFor(n,this.M(s).providerExtUri).queue(()=>this.gb(l,i,s,n))}async gb(l,i,s,n){return s.writeFile(n,await l.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async hb(l,i,s,n){return this.W.queueFor(n,this.M(s).providerExtUri).queue(()=>this.ib(l,i,s,n))}async ib(l,i,s,n){const a=await s.open(n,{create:!0,unlock:!1});try{const r=await l.readFile(i);await this.ab(s,a,k.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,b.ensureFileSystemProviderError)(r)}finally{await s.close(a)}}async jb(l,i,s,n){const a=await(0,k.streamToBuffer)(this.z(l,i,R.CancellationToken.None));await this.bb(s,n,void 0,a)}kb(l,i){if(l.capabilities&2048)throw new b.FileOperationError((0,v.localize)(22,null,this.mb(i)),6);return l}lb(l,i){if((i.permissions??0)&b.FilePermission.Readonly)throw new b.FileOperationError((0,v.localize)(23,null,this.mb(l)),6)}mb(l){return l.scheme===P.Schemas.file?l.fsPath:l.toString(!0)}};g=pe([ne(0,p.ILogService)],g),e.FileService=g}),define(te[86],ie([0,1,40,281,8,39,17,3,30,2,9,4,20,59,23,162,16,108,204,45,200,199]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h,d,v,b,u,p,g,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(I)}catch(s){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(s)}`)}})();class i extends p.AbstractDiskFileSystemProvider{constructor(n,a){super(n,a),this.onDidChangeCapabilities=C.Event.None,this.H=new R.ResourceMap(r=>E.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,P.isLinux&&(this.F|=1024)),this.F}async stat(n){try{const{stat:a,symbolicLink:r}=await d.SymlinkSupport.stat(this.C(n));return{type:this.G(a,r),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.Y(a)}}async readdir(n){try{const a=await d.Promises.readdir(this.C(n),{withFileTypes:!0}),r=[];return await Promise.all(a.map(async c=>{try{let o;c.isSymbolicLink()?o=(await this.stat((0,E.joinPath)(n,c.name))).type:o=this.G(c),r.push([c.name,o])}catch(o){this.a.trace(o)}})),r}catch(a){throw this.Y(a)}}G(n,a){let r;return a?.dangling?r=b.FileType.Unknown:n.isFile()?r=b.FileType.File:n.isDirectory()?r=b.FileType.Directory:r=b.FileType.Unknown,a&&(r|=b.FileType.SymbolicLink),r}async I(n){const a=this.C(n);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${a})`);let r;for(;r=this.H.get(n);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${a})`),await r.wait();const c=new k.Barrier;return this.H.set(n,c),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${a})`),(0,m.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${a})`),this.H.get(n)===c&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${a})`),this.H.delete(n)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${a})`),c.open()})}async readFile(n,a){let r;try{a?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(n)})`),r=await this.I(n));const c=this.C(n);return await d.Promises.readFile(c)}catch(c){throw this.Y(c)}finally{r?.dispose()}}J(n){i.D&&this.a.trace(n)}readFileStream(n,a,r){const c=(0,h.newWriteableStream)(o=>A.VSBuffer.concat(o.map(S=>A.VSBuffer.wrap(S))).buffer);return(0,u.readFileIntoStream)(this,n,c,o=>o.buffer,{...a,bufferSize:256*1024},r),c}async writeFile(n,a,r){let c;try{const o=this.C(n);if(!r.create||!r.overwrite){if(await d.Promises.exists(o)){if(!r.overwrite)throw(0,b.createFileSystemProviderError)((0,v.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,b.createFileSystemProviderError)((0,v.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(n,{create:!0,unlock:r.unlock}),await this.write(c,0,a,0,a.byteLength)}catch(o){throw await this.Z(n,o)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(n){i.O=n}async open(n,a){const r=this.C(n);let c;(0,b.isFileOpenForWriteOptions)(a)&&(c=await this.I(n));let o;try{if((0,b.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:D}=await d.SymlinkSupport.stat(r);D.mode&128||await d.Promises.chmod(r,D.mode|128)}catch(D){this.a.trace(D)}let S;if((0,b.isFileOpenForWriteOptions)(a)){if(P.isWindows)try{await d.Promises.truncate(r,0),S="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}S||(S="w")}else S="r";o=await d.Promises.open(r,S)}catch(S){throw c?.dispose(),(0,b.isFileOpenForWriteOptions)(a)?await this.Z(n,S):this.Y(S)}if(this.L.set(o,0),(0,b.isFileOpenForWriteOptions)(a)&&this.N.set(o,n),c){const S=this.M.get(o);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${r})`),this.M.set(o,c),S&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${r})`),S.dispose())}return o}async close(n){const a=this.M.get(n);try{if(this.L.delete(n),this.N.delete(n)&&i.O)try{await d.Promises.fdatasync(n)}catch(r){i.configureFlushOnWrite(!1),this.a.error(r)}return await d.Promises.close(n)}catch(r){throw this.Y(r)}finally{a&&(this.M.get(n)===a&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.M.delete(n)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),a.dispose())}}async read(n,a,r,c,o){const S=this.P(n,a);let D=null;try{D=(await d.Promises.read(n,r,c,o,S)).bytesRead}catch(L){throw this.Y(L)}finally{this.Q(n,S,D)}return D}P(n,a){return a===this.L.get(n)?null:a}Q(n,a,r){const c=this.L.get(n);typeof c=="number"&&(typeof a=="number"||(typeof r=="number"?this.L.set(n,c+r):this.L.delete(n)))}async write(n,a,r,c,o){return(0,k.retry)(()=>this.R(n,a,r,c,o),100,3)}async R(n,a,r,c,o){const S=this.P(n,a);let D=null;try{D=(await d.Promises.write(n,r,c,o,S)).bytesWritten}catch(L){throw await this.Z(this.N.get(n),L)}finally{this.Q(n,S,D)}return D}async mkdir(n){try{await d.Promises.mkdir(this.C(n))}catch(a){throw this.Y(a)}}async delete(n,a){try{const r=this.C(n);a.recursive?await d.Promises.rm(r,d.RimRafMode.MOVE):await d.Promises.unlink(r)}catch(r){throw this.Y(r)}}async rename(n,a,r){const c=this.C(n),o=this.C(a);if(c!==o)try{await this.S(n,a,"move",r.overwrite),await d.Promises.move(c,o)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,v.localize)(2,null,(0,y.basename)(c),(0,y.basename)((0,y.dirname)(o)),S.toString()))),this.Y(S)}}async copy(n,a,r){const c=this.C(n),o=this.C(a);if(c!==o)try{await this.S(n,a,"copy",r.overwrite),await d.Promises.copy(c,o,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,v.localize)(3,null,(0,y.basename)(c),(0,y.basename)((0,y.dirname)(o)),S.toString()))),this.Y(S)}}async S(n,a,r,c){const o=this.C(n),S=this.C(a);let D=!1;if(!!(this.capabilities&1024)||(D=(0,w.isEqual)(o,S,!0)),D&&r==="copy")throw(0,b.createFileSystemProviderError)((0,v.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(!D&&await d.Promises.exists(S)){if(!c)throw(0,b.createFileSystemProviderError)((0,v.localize)(5,null),b.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}async cloneFile(n,a){return this.U(n,a,!1)}async U(n,a,r){const c=this.C(n),o=this.C(a),S=!!(this.capabilities&1024);if((0,w.isEqual)(c,o,!S))return;const D=new m.DisposableStore;try{const[L,N]=await Promise.all([this.I(n),this.I(a)]);D.add(L),D.add(N),r&&await d.Promises.mkdir((0,y.dirname)(o),{recursive:!0}),await d.Promises.copyFile(c,o)}catch(L){if(L.code==="ENOENT"&&!r)return this.U(n,a,!0);throw this.Y(L)}finally{D.dispose()}}p(n,a,r){return new f.UniversalWatcherClient(c=>n(c),c=>a(c),r)}y(n,a,r){return new l.NodeJSWatcherClient(c=>n(c),c=>a(c),r)}Y(n){if(n instanceof b.FileSystemProviderError)return n;let a;switch(n.code){case"ENOENT":a=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=b.FileSystemProviderErrorCode.NoPermissions;break;default:a=b.FileSystemProviderErrorCode.Unknown}return(0,b.createFileSystemProviderError)(n,a)}async Z(n,a){let r=this.Y(a);if(n&&r.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await d.SymlinkSupport.stat(this.C(n));c.mode&128||(r=(0,b.createFileSystemProviderError)(a,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return r}}e.DiskFileSystemProvider=i,i.D=!1,i.O=!0}),define(te[206],ie([0,1,3,86,2,17,59,22]),function(V,e,I,t,k,R,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class w extends k.Disposable{constructor(P,E){super(),this.a=P,this.b=E,this.w=new Map,this.y=new Map}call(P,E,h){const d=this.c(P);switch(E){case"stat":return this.g(d,h[0]);case"readdir":return this.h(d,h[0]);case"open":return this.l(d,h[0],h[1]);case"close":return this.m(h[0]);case"read":return this.n(h[0],h[1],h[2]);case"readFile":return this.i(d,h[0],h[1]);case"write":return this.p(h[0],h[1],h[2],h[3],h[4]);case"writeFile":return this.k(d,h[0],h[1],h[2]);case"rename":return this.t(d,h[0],h[1],h[2]);case"copy":return this.u(d,h[0],h[1],h[2]);case"cloneFile":return this.v(d,h[0],h[1]);case"mkdir":return this.r(d,h[0]);case"delete":return this.s(d,h[0],h[1]);case"watch":return this.C(d,h[0],h[1],h[2],h[3]);case"unwatch":return this.D(h[0],h[1])}throw new Error(`IPC Command ${E} not found`)}listen(P,E,h){const d=this.c(P);switch(E){case"fileChange":return this.z(d,h[0]);case"readFileStream":return this.j(d,h[0],h[1])}throw new Error(`Unknown event ${E}`)}g(P,E){const h=this.f(P,E,!0);return this.a.stat(h)}h(P,E){const h=this.f(P,E);return this.a.readdir(h)}async i(P,E,h){const d=this.f(P,E,!0),v=await this.a.readFile(d,h);return R.VSBuffer.wrap(v)}j(P,E,h){const d=this.f(P,E,!0),v=new C.CancellationTokenSource,b=new I.Emitter({onDidRemoveLastListener:()=>{v.cancel()}}),u=this.a.readFileStream(d,h,v.token);return(0,A.listenStream)(u,{onData:p=>b.fire(R.VSBuffer.wrap(p)),onError:p=>b.fire(p),onEnd:()=>{b.fire("end"),b.dispose(),v.dispose()}}),b.event}k(P,E,h,d){const v=this.f(P,E);return this.a.writeFile(v,h.buffer,d)}l(P,E,h){const d=this.f(P,E,!0);return this.a.open(d,h)}m(P){return this.a.close(P)}async n(P,E,h){const d=R.VSBuffer.alloc(h),v=0,b=await this.a.read(P,E,d.buffer,v,h);return[d,b]}p(P,E,h,d,v){return this.a.write(P,E,h.buffer,d,v)}r(P,E){const h=this.f(P,E);return this.a.mkdir(h)}s(P,E,h){const d=this.f(P,E);return this.a.delete(d,h)}t(P,E,h,d){const v=this.f(P,E),b=this.f(P,h);return this.a.rename(v,b,d)}u(P,E,h,d){const v=this.f(P,E),b=this.f(P,h);return this.a.copy(v,b,d)}v(P,E,h){const d=this.f(P,E),v=this.f(P,h);return this.a.cloneFile(d,v)}z(P,E){const h=new I.Emitter({onWillAddFirstListener:()=>{this.w.set(E,this.F(P,h))},onDidRemoveLastListener:()=>{(0,k.dispose)(this.w.get(E)),this.w.delete(E)}});return h.event}async C(P,E,h,d,v){const b=this.w.get(E);if(b){const u=this.f(P,d),p=b.watch(h,u,v);this.y.set(E+h,p)}}async D(P,E){const h=P+E,d=this.y.get(h);d&&((0,k.dispose)(d),this.y.delete(h))}dispose(){super.dispose();for(const[,P]of this.y)P.dispose();this.y.clear();for(const[,P]of this.w)P.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=w;class m extends k.Disposable{constructor(P,E,h,d){super(),this.c=P,this.f=h,this.g=d,this.a=new Map,this.b=this.B(new t.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(E)}h(P){const E=this.B(new I.Emitter);this.B(E.event(h=>{P.fire(h.map(d=>({resource:this.c.transformOutgoingURI(d.resource),type:d.type})))})),this.B(this.b.onDidChangeFile(h=>E.fire(h))),this.B(this.b.onDidWatchError(h=>P.fire(h)))}i(P){}j(P){}watch(P,E,h){const d=this.j(this.g);return Array.isArray(d)&&(h.excludes=[...h.excludes,...d]),this.a.set(P,this.b.watch(E,h)),(0,k.toDisposable)(()=>{(0,k.dispose)(this.a.get(P)),this.a.delete(P)})}dispose(){super.dispose();for(const[,P]of this.a)P.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=m}),define(te[207],ie([0,1,13,161,4,7,16,9,206,140]),function(V,e,I,t,k,R,A,C,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class y extends w.AbstractDiskFileSystemProviderChannel{constructor(h,d,v){super(h,d),this.G=v}c(h){return m.DefaultURITransformer}f(h,d){return R.URI.revive(d)}async s(h,d,v){if(!v.useTrash)return super.s(h,d,v);const b=this.f(h,d),u=(0,C.normalize)(b.fsPath);try{await I.shell.trashItem(u)}catch{throw(0,A.createFileSystemProviderError)(k.isWindows?(0,t.localize)(0,null,(0,C.basename)(u)):(0,t.localize)(1,null,(0,C.basename)(u)),A.FileSystemProviderErrorCode.Unknown)}}F(h,d){return new P(h,d,this.b,this.G)}}e.DiskFileSystemProviderChannel=y;class P extends w.AbstractSessionFileWatcher{watch(h,d,v){if(v.recursive)throw(0,A.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",A.FileSystemProviderErrorCode.Unavailable);return super.watch(h,d,v)}}}),define(te[208],ie([0,1,6]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;class t extends I.AbstractMessageLogger{constructor(R=I.DEFAULT_LOG_LEVEL){super(),this.k=[],this.l=void 0,this.setLevel(R),this.B(this.onDidChangeLogLevel(A=>{this.l?.setLevel(A)}))}set logger(R){this.l=R;for(const{level:A,message:C}of this.k)(0,I.log)(R,A,C);this.k=[]}g(R,A){this.l?(0,I.log)(this.l,R,A):this.getLevel()<=R&&this.k.push({level:R,message:A})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.BufferLogService=t}),define(te[209],ie([0,1,3,7,6]),function(V,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(E,h){this.a=E,this.b=h,this.onDidChangeLogLevel=I.Event.buffer(E.onDidChangeLogLevel,!0)}listen(E,h){switch(h){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${h}`)}async call(E,h,d){switch(h){case"setLevel":return d[1]?this.b.setLevel(t.URI.revive(d[1]),d[0]):this.a.setLevel(d[0])}throw new Error(`Call not found: ${h}`)}}e.LogLevelChannel=R;class A{constructor(E){this.a=E}get onDidChangeLogLevel(){return this.a.listen("onDidChangeLogLevel")}setLevel(E,h){A.setLevel(this.a,E,h)}static setLevel(E,h,d){return E.call("setLevel",[h,d])}}e.LogLevelChannelClient=A;class C{constructor(E){this.b=E,this.a=new Map}listen(E,h){throw new Error(`Event not found: ${h}`)}async call(E,h,d){switch(h){case"createLogger":this.c(t.URI.revive(d[0]),d[1]);return;case"log":return this.e(t.URI.revive(d[0]),d[1]);case"consoleLog":return this.d(d[0],d[1])}throw new Error(`Call not found: ${h}`)}c(E,h){this.a.set(E.toString(),this.b.createLogger(E,h))}d(E,h){let d=console.log;switch(E){case k.LogLevel.Error:d=console.error;break;case k.LogLevel.Warning:d=console.warn;break;case k.LogLevel.Info:d=console.info;break}d.call(console,...h)}e(E,h){const d=this.a.get(E.toString());if(!d)throw new Error("Create the logger before logging");for(const[v,b]of h)(0,k.log)(d,v,b)}}e.LoggerChannel=C;class w extends k.AbstractLoggerService{constructor(E,h,d){super(E,h),this.g=d}createConsoleMainLogger(){return new k.AdapterLogger({log:(E,h)=>{this.g.call("consoleLog",[E,h])}})}f(E,h,d){return new m(this.g,E,h,d)}}e.LoggerChannelClient=w;class m extends k.AbstractMessageLogger{constructor(E,h,d,v){super(v?.always),this.m=E,this.n=h,this.k=!1,this.l=[],this.setLevel(d),this.m.call("createLogger",[h,v]).then(()=>{this.r(this.l),this.k=!0})}g(E,h){const d=[[E,h]];this.k?this.r(d):this.l.push(...d)}r(E){this.m.call("log",[this.n,E])}}class y extends k.LogService{constructor(E,h){super(h),this.c=E,this.B(E.onDidChangeLogLevel(d=>h.setLevel(d)))}setLevel(E){super.setLevel(E),this.c.setLevel(E)}}e.FollowerLogService=y}),define(te[210],ie([0,1,16,6]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(m){m[m.Trace=0]="Trace",m[m.Debug=1]="Debug",m[m.Info=2]="Info",m[m.Warning=3]="Warning",m[m.Error=4]="Error",m[m.Critical=5]="Critical",m[m.Off=6]="Off"})(k||(k={}));async function R(m,y,P,E,h){try{const d=await new Promise((b,u)=>{V(["spdlog"],b,u)});d.setFlushOn(k.Trace);const v=await d.createAsyncRotatingLogger(m,y,P,E);return h?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(d){console.error(d)}return null}function A(m,y,P){switch(y){case t.LogLevel.Trace:m.trace(P);break;case t.LogLevel.Debug:m.debug(P);break;case t.LogLevel.Info:m.info(P);break;case t.LogLevel.Warning:m.warn(P);break;case t.LogLevel.Error:m.error(P);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function C(m,y){switch(y){case t.LogLevel.Trace:m.setLevel(k.Trace);break;case t.LogLevel.Debug:m.setLevel(k.Debug);break;case t.LogLevel.Info:m.setLevel(k.Info);break;case t.LogLevel.Warning:m.setLevel(k.Warning);break;case t.LogLevel.Error:m.setLevel(k.Error);break;case t.LogLevel.Off:m.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class w extends t.AbstractMessageLogger{constructor(y,P,E,h,d){super(),this.k=[],this.setLevel(d),this.l=this.n(y,P,E,h),this.B(this.onDidChangeLogLevel(v=>{this.m&&C(this.m,v)}))}async n(y,P,E,h){const d=E?6:1,v=30/d*I.ByteSize.MB,b=await R(y,P,v,d,h);if(b){this.m=b,C(this.m,this.getLevel());for(const{level:u,message:p}of this.k)A(this.m,u,p);this.k=[]}}g(y,P){this.m?A(this.m,y,P):this.getLevel()<=y&&this.k.push({level:y,message:P})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=w}),define(te[211],ie([0,1,29,6,210]),function(V,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let R=class extends t.AbstractLoggerService{constructor(C){super(C.getLevel(),C.onDidChangeLogLevel)}f(C,w,m){return new k.SpdLogLogger(m?.name||(0,I.generateUuid)(),C.fsPath,!m?.donotRotate,!!m?.donotUseFormatters,w)}};R=pe([ne(0,t.ILogService)],R),e.LoggerService=R}),define(te[212],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function I(A){return A.submenu!==void 0}e.isMenubarMenuItemSubmenu=I;function t(A){return A.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function k(A){return A.uri!==void 0}e.isMenubarMenuItemRecentAction=k;function R(A){return!I(A)&&!t(A)&&!k(A)}e.isMenubarMenuItemAction=R}),define(te[37],ie([0,1,3,67,2,5]),function(V,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class A extends k.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new I.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(m){const y=Object.keys(this.f).length;return this.f={...m,...this.f},y!==Object.keys(this.f).length&&await this.i(m),t.Iterable.reduce(this.g.entries(),(P,[E,h])=>({...P,[E]:h}),{})}getPolicyValue(m){return this.g.get(m)}serialize(){return t.Iterable.reduce(Object.entries(this.f),(m,[y,P])=>({...m,[y]:{definition:P,value:this.g.get(y)}}),{})}}e.AbstractPolicyService=A;class C{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=C}),define(te[213],ie([0,1,8,3,67,12,16,6,37]),function(V,e,I,t,k,R,A,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function m(P,E){const h=[];for(const d of new Set(k.Iterable.concat(P.keys(),E.keys())))P.get(d)!==E.get(d)&&h.push(d);return h}let y=class extends w.AbstractPolicyService{constructor(E,h,d){super(),this.j=E,this.k=h,this.l=d,this.c=this.B(new I.ThrottledDelayer(500));const v=t.Event.filter(h.onDidFilesChange,b=>b.affects(E));this.B(h.watch(E)),this.B(v(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const E=new Map;try{const h=await this.k.readFile(this.j),d=JSON.parse(h.value.toString());if(!(0,R.isObject)(d))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(d))this.f[v]&&E.set(v,d[v])}catch(h){h.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",h)}return E}async p(){const E=await this.n(),h=m(this.g,E);this.g=E,h.length>0&&this.h.fire(h)}};y=pe([ne(1,A.IFileService),ne(2,C.ILogService)],y),e.FilePolicyService=y}),define(te[214],ie([0,1,3,2,37]),function(V,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(w){this.b=w,this.a=new t.DisposableStore}listen(w,m){switch(m){case"onDidChange":return I.Event.map(this.b.onDidChange,y=>y.reduce((P,E)=>({...P,[E]:this.b.getPolicyValue(E)??null}),{}),this.a)}throw new Error(`Event not found: ${m}`)}call(w,m,y){switch(m){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(y)}throw new Error(`Call not found: ${m}`)}dispose(){this.a.dispose()}}e.PolicyChannel=R;class A extends k.AbstractPolicyService{constructor(w,m){super(),this.a=m;for(const y in w){const{definition:P,value:E}=w[y];this.f[y]=P,E!==void 0&&this.g.set(y,E)}this.a.listen("onDidChange")(y=>{for(const P in y){const E=y[P];E===null?this.g.delete(P):this.g.set(P,E)}this.h.fire(Object.keys(y))})}async i(w){const m=await this.a.call("updatePolicyDefinitions",w);for(const y in m)this.g.set(y,m[y])}}e.PolicyChannelClient=A}),define(te[63],ie([0,1,4,33]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof I.globals.vscode<"u"&&typeof I.globals.vscode.context<"u"){const R=I.globals.vscode.context.configuration();if(R)k=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(k=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`,serverDataFolderName:k.serverDataFolderName?`${k.serverDataFolderName}-dev`:void 0}),!k.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(k,{version:R.version})}}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=k}),define(te[19],ie([0,1,5]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,I.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(te[215],ie([0,1,77,6,19]),function(V,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(C,w){this.b=C,this.c=w,this.a=new Map}async isExtensionUrlTrusted(C,w){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const m=/^(.*)#([^#]+)$/.exec(w);if(!m)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",w),!1;const[,y,P]=m;let E=this.a.get(C);if(!E){if(E=this.b.trustedExtensionUrlPublicKeys[C],!E||E.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",C),!1;this.a.set(C,[...E])}const h=Buffer.from(decodeURIComponent(P),"base64");if(h.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",w),!1;const d=h.slice(0,6),v=h.readUIntBE(0,6),b=Date.now()-v;if(b<0||b>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",w),!1;const u=h.slice(6),p=I.createVerify("SHA256");p.write(d),p.write(Buffer.from(y)),p.end();for(let g=0;g<E.length;g++){let f=E[g];if(f!==null){if(typeof f=="string")try{f=I.createPublicKey({key:Buffer.from(f,"base64"),format:"der",type:"spki"}),E[g]=f}catch(l){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${g+1} for ${C}:`,l),E[g]=null;continue}if(p.verify(f,u))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",w),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",w),!1}};R=pe([ne(0,k.IProductService),ne(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(te[216],ie([0,1,8,6]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let k=class{constructor(A,C,w){this.a=A,this.b=C,this.c=w}async inspect(A){await this.d();const C=this.a.webContents.debugger;await C.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,I.timeout)(A);const w=await C.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),w.profile}async d(){const A=this.a.webContents.debugger;A.attach(),await A.sendCommand("Profiler.enable")}async e(){const A=this.a.webContents.debugger;await A.sendCommand("Profiler.disable"),A.detach()}};k=pe([ne(2,t.ILogService)],k),e.WindowProfiler=k}),define(te[64],ie([0,1,5]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,I.createDecorator)("protocolMainService")}),define(te[48],ie([0,1,122,12]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.a=new Map}add(A,C){I.ok(t.isString(A)),I.ok(t.isObject(C)),I.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,C)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.Registry=new k}),define(te[217],ie([0,1,3,48]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class R{constructor(){this.b=new I.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(w,m){this.a[k(w)]=m,this.b.fire(w)}notifySchemaChanged(w){this.b.fire(w)}getSchemaContributions(){return{schemas:this.a}}}const A=new R;t.Registry.add(e.Extensions.JSONContribution,A)}),define(te[65],ie([0,1,24,3,12,149,18,217,48]),function(V,e,I,t,k,R,A,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(m=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=w.Registry.as(C.Extensions.JSONContribution);class E{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const n=this.k(i,s);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const s=this.l(i);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:i,remove:s}){const n=[];n.push(...this.l(s)),n.push(...this.k(i,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,I.distinct)(n)})}registerDefaultConfigurations(i){const s=[],n=[];for(const{overrides:a,source:r}of i)for(const c in a)if(s.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const o=this.a.get(c),S=o?.valuesSources??new Map;if(r)for(const X of Object.keys(a[c]))S.set(X,r);const D={...o?.value||{},...a[c]};this.a.set(c,{source:r,value:D,valuesSources:S});const L=(0,A.getLanguageTagSettingPlainKey)(c),N={type:"object",default:D,description:R.localize(1,null,L),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:D,source:k.isString(r)?void 0:r,defaultValueSource:r};n.push(...v(c)),this.d[c]=N,this.b.properties[c]=N}else{this.a.set(c,{value:a[c],source:r});const o=this.d[c];o&&(this.s(c,o),this.o(c,o))}this.registerOverrideIdentifiers(n),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const s=[];for(const{overrides:n,source:a}of i)for(const r in n){const c=this.a.get(r),o=k.isString(a)?a:a?.id,S=k.isString(c?.source)?c?.source:c?.source?.id;if(o===S)if(s.push(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const D=this.d[r];D&&(this.s(r,D),this.o(r,D))}}this.q(),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){for(const s of i)this.h.add(s);this.q()}k(i,s){const n=[];return i.forEach(a=>{n.push(...this.m(a,s,a.extensionInfo,a.restrictedProperties)),this.c.push(a),this.n(a)}),n}l(i){const s=[],n=a=>{if(a.properties)for(const r in a.properties){s.push(r);const c=this.d[r];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[r],this.p(r,a.properties[r])}a.allOf?.forEach(r=>n(r))};for(const a of i){n(a);const r=this.c.indexOf(a);r!==-1&&this.c.splice(r,1)}return s}m(i,s=!0,n,a,r=3){r=k.isUndefinedOrNull(i.scope)?r:i.scope;const c=[],o=i.properties;if(o)for(const D in o){const L=o[D];if(s&&g(D,L)){delete o[D];continue}if(L.source=n,L.defaultDefaultValue=o[D].default,this.s(D,L),e.OVERRIDE_PROPERTY_REGEX.test(D)?L.scope=void 0:(L.scope=k.isUndefinedOrNull(L.scope)?r:L.scope,L.restricted=k.isUndefinedOrNull(L.restricted)?!!a?.includes(D):L.restricted),o[D].hasOwnProperty("included")&&!o[D].included){this.f[D]=o[D],delete o[D];continue}else this.d[D]=o[D],o[D].policy?.name&&this.e.set(o[D].policy.name,D);!o[D].deprecationMessage&&o[D].markdownDeprecationMessage&&(o[D].deprecationMessage=o[D].markdownDeprecationMessage),c.push(D)}const S=i.allOf;if(S)for(const D of S)c.push(...this.m(D,s,n,a,r));return c}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(i){const s=n=>{const a=n.properties;if(a)for(const c in a)this.o(c,a[c]);n.allOf?.forEach(s)};s(i)}o(i,s){switch(e.allSettings.properties[i]=s,s.scope){case 1:e.applicationSettings.properties[i]=s;break;case 2:e.machineSettings.properties[i]=s;break;case 6:e.machineOverridableSettings.properties[i]=s;break;case 3:e.windowSettings.properties[i]=s;break;case 4:e.resourceSettings.properties[i]=s;break;case 5:e.resourceSettings.properties[i]=s,this.g.properties[i]=s;break}}p(i,s){switch(delete e.allSettings.properties[i],s.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}q(){for(const i of this.h.values()){const s=`[${i}]`,n={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(s,n),e.allSettings.properties[s]=n,e.applicationSettings.properties[s]=n,e.machineSettings.properties[s]=n,e.machineOverridableSettings.properties[s]=n,e.windowSettings.properties[s]=n,e.resourceSettings.properties[s]=n}this.i.fire()}r(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}s(i,s){const n=this.a.get(i);let a=n?.value,r=n?.source;k.isUndefined(a)&&(a=s.defaultDefaultValue,r=void 0),k.isUndefined(a)&&(a=u(s.type)),s.default=a,s.defaultValueSource=r}}const h="\\[([^\\]]+)\\]",d=new RegExp(h,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${h})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function v(l){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(l)){let s=d.exec(l);for(;s?.length;){const n=s[1].trim();n&&i.push(n),s=d.exec(l)}}return(0,I.distinct)(i)}e.overrideIdentifiersFromKey=v;function b(l){return l.reduce((i,s)=>`${i}[${s}]`,"")}e.keyFromOverrideIdentifiers=b;function u(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const p=new E;w.Registry.add(e.Extensions.Configuration,p);function g(l,i){return l.trim()?e.OVERRIDE_PROPERTY_REGEX.test(l)?R.localize(7,null,l):p.getConfigurationProperties()[l]!==void 0?R.localize(8,null,l):i.policy?.name&&p.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,l,i.policy?.name,p.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}e.validateProperty=g;function f(){const l=[],i=p.getConfigurationProperties();for(const s of Object.keys(i))l.push([s,i[s].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.getScopes=f}),define(te[109],ie([0,1,24,3,43,2,39,44,12,7,18,65,48]),function(V,e,I,t,k,R,A,C,w,m,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class h{constructor(s={},n=[],a=[],r){this.c=s,this.d=n,this.f=a,this.raw=r,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(n=>{if(n instanceof h)return n;const a=new d("");return a.parseRaw(n),a.configurationModel});this.g=s.reduce((n,a)=>a===n?a:n.merge(a),s[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(s){return s?(0,y.getConfigurationValue)(this.contents,s):this.contents}inspect(s,n){const a=this.rawConfiguration.getValue(s),r=n?this.rawConfiguration.getOverrideValue(s,n):void 0,c=n?this.rawConfiguration.override(n).getValue(s):a;return{value:a,override:r,merged:c}}getOverrideValue(s,n){const a=this.l(n);return a?s?(0,y.getConfigurationValue)(a,s):a:void 0}getKeysForOverrideIdentifier(s){const n=[];for(const a of this.overrides)a.identifiers.includes(s)&&n.push(...a.keys);return I.distinct(n)}getAllOverrideIdentifiers(){const s=[];for(const n of this.overrides)s.push(...n.identifiers);return I.distinct(s)}override(s){let n=this.b.get(s);return n||(n=this.h(s),this.b.set(s,n)),n}merge(...s){const n=C.deepClone(this.contents),a=C.deepClone(this.overrides),r=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const o of s)if(c.push(...o.raw?.length?o.raw:[o]),!o.isEmpty()){this.j(n,o.contents);for(const S of o.overrides){const[D]=a.filter(L=>I.equals(L.identifiers,S.identifiers));D?(this.j(D.contents,S.contents),D.keys.push(...S.keys),D.keys=I.distinct(D.keys)):a.push(C.deepClone(S))}for(const S of o.keys)r.indexOf(S)===-1&&r.push(S)}return new h(n,r,a,c.every(o=>o instanceof h)?void 0:c)}freeze(){return this.a=!0,this}clone(){return new h(C.deepClone(this.contents),[...this.keys],C.deepClone(this.overrides))}h(s){const n=this.l(s);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const a={};for(const r of I.distinct([...Object.keys(this.contents),...Object.keys(n)])){let c=this.contents[r];const o=n[r];o&&(typeof c=="object"&&typeof o=="object"?(c=C.deepClone(c),this.j(c,o)):c=o),a[r]=c}return new h(a,this.keys,this.overrides)}j(s,n){for(const a of Object.keys(n)){if(a in s&&w.isObject(s[a])&&w.isObject(n[a])){this.j(s[a],n[a]);continue}s[a]=C.deepClone(n[a])}}k(s){return this.a&&!Object.isFrozen(s)?C.deepFreeze(s):s}l(s){let n=null,a=null;const r=c=>{c&&(a?this.j(a,c):a=C.deepClone(c))};for(const c of this.overrides)I.equals(c.identifiers,[s])?n=c.contents:c.identifiers.includes(s)&&r(c.contents);return r(n),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,n){this.m(s),(0,y.addToValueTree)(this.contents,s,n,a=>{throw new Error(a)})}removeValue(s){this.n(s)&&(0,y.removeFromValueTree)(this.contents,s)}m(s){let n=this.keys.length;for(let a=0;a<n;a++)s.indexOf(this.keys[a])===0&&(n=a);this.keys.splice(n,1,s)}n(s){const n=this.keys.indexOf(s);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=h;class d{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new h}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,n){if(!w.isUndefinedOrNull(s)){const a=this.g(s);this.parseRaw(a,n)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,n){this.a=s;const{contents:a,keys:r,overrides:c,restricted:o,hasExcludedProperties:S}=this.h(s,n);this.b=new h(a,r,c,S?[s]:void 0),this.c=o||[]}g(s){let n={},a=null,r=[];const c=[],o=[];function S(L){Array.isArray(r)?r.push(L):a!==null&&(r[a]=L)}const D={onObjectBegin:()=>{const L={};S(L),c.push(r),r=L,a=null},onObjectProperty:L=>{a=L},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{const L=[];S(L),c.push(r),r=L,a=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:S,onError:(L,N,X)=>{o.push({error:L,offset:N,length:X})}};if(s)try{k.visit(s,D),n=r[0]||{}}catch(L){console.error(`Error while parsing settings file ${this.f}: ${L}`),this.d=[L]}return n}h(s,n){const a=E.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),r=this.j(s,a,!0,n);s=r.raw;const c=(0,y.toValuesTree)(s,D=>console.error(`Conflict in settings file ${this.f}: ${D}`)),o=Object.keys(s),S=this.l(s,D=>console.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:c,keys:o,overrides:S,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}j(s,n,a,r){let c=!1;if(!r?.scopes&&!r?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:c};const o={},S=[];for(const D in s)if(P.OVERRIDE_PROPERTY_REGEX.test(D)&&a){const L=this.j(s[D],n,!1,r);o[D]=L.raw,c=c||L.hasExcludedProperties,S.push(...L.restricted)}else{const L=n[D],N=L?typeof L.scope<"u"?L.scope:3:void 0;L?.restricted&&S.push(D),(N===void 0||r.scopes===void 0||r.scopes.includes(N))&&!(r.skipRestricted&&L?.restricted)?o[D]=s[D]:c=!0}return{raw:o,restricted:S,hasExcludedProperties:c}}l(s,n){const a=[];for(const r of Object.keys(s))if(P.OVERRIDE_PROPERTY_REGEX.test(r)){const c={};for(const o in s[r])c[o]=s[r][o];a.push({identifiers:(0,P.overrideIdentifiersFromKey)(r),keys:Object.keys(c),contents:(0,y.toValuesTree)(c,n)})}return a}}e.ConfigurationModelParser=d;class v extends R.Disposable{constructor(s,n,a,r){super(),this.f=s,this.g=n,this.h=r,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new d(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(a.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&a.isEqual(c.resource,s)))(()=>this.c.fire()))}async loadConfiguration(){try{const s=await this.h.readFile(this.f);return this.a.parse(s.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new h}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=v;class b{constructor(s,n,a,r,c,o,S,D,L,N,X,ae,J){this.a=s,this.b=n,this.value=a,this.overrideIdentifiers=r,this.c=c,this.d=o,this.f=S,this.g=D,this.h=L,this.j=N,this.k=X,this.l=ae,this.m=J}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class u{constructor(s,n,a,r,c=new h,o=new h,S=new A.ResourceMap,D=new h,L=new A.ResourceMap,N=!0){this.c=s,this.d=n,this.f=a,this.g=r,this.h=c,this.j=o,this.l=S,this.m=D,this.n=L,this.p=N,this.a=null,this.b=new A.ResourceMap,this.q=null}getValue(s,n,a){return this.s(s,n,a).getValue(s)}updateValue(s,n,a={}){let r;a.resource?(r=this.n.get(a.resource),r||(r=new h,this.n.set(a.resource,r))):r=this.m,n===void 0?r.removeValue(s):r.setValue(s,n),a.resource||(this.a=null)}inspect(s,n,a){const r=this.s(s,n,a),c=I.distinct(r.overrides.map(D=>D.identifiers).flat()).filter(D=>r.getOverrideValue(s,D)!==void 0),o=this.w(n.resource,a),S=n.resource?this.n.get(n.resource)||this.m:this.m;return new b(s,n,r.getValue(s),c.length?c:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),a?this.j.freeze():void 0,o?o.freeze():void 0,S.inspect(s,n.overrideIdentifier))}keys(s){const n=this.w(void 0,s);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.j=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,n){this.l.set(s,n),this.b.delete(s)}deleteFolderConfiguration(s){this.r.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,n){const a=[];if(!n){const{added:r,updated:c,removed:o}=f(this.c,s);n=[...r,...c,...o]}for(const r of n)for(const c of(0,P.overrideIdentifiersFromKey)(r)){const o=this.c.getKeysForOverrideIdentifier(c),S=s.getKeysForOverrideIdentifier(c),D=[...S.filter(L=>o.indexOf(L)===-1),...o.filter(L=>S.indexOf(L)===-1),...o.filter(L=>!C.equals(this.c.override(c).getValue(L),s.override(c).getValue(L)))];a.push([c,D])}return this.updateDefaultConfiguration(s),{keys:n,overrides:a}}compareAndUpdatePolicyConfiguration(s){const{added:n,updated:a,removed:r}=f(this.d,s),c=[...n,...a,...r];return c.length&&this.updatePolicyConfiguration(s),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:n,updated:a,removed:r,overrides:c}=f(this.applicationConfiguration,s),o=[...n,...a,...r];return o.length&&this.updateApplicationConfiguration(s),{keys:o,overrides:c}}compareAndUpdateLocalUserConfiguration(s){const{added:n,updated:a,removed:r,overrides:c}=f(this.localUserConfiguration,s),o=[...n,...a,...r];return o.length&&this.updateLocalUserConfiguration(s),{keys:o,overrides:c}}compareAndUpdateRemoteUserConfiguration(s){const{added:n,updated:a,removed:r,overrides:c}=f(this.remoteUserConfiguration,s),o=[...n,...a,...r];return o.length&&this.updateRemoteUserConfiguration(s),{keys:o,overrides:c}}compareAndUpdateWorkspaceConfiguration(s){const{added:n,updated:a,removed:r,overrides:c}=f(this.workspaceConfiguration,s),o=[...n,...a,...r];return o.length&&this.updateWorkspaceConfiguration(s),{keys:o,overrides:c}}compareAndUpdateFolderConfiguration(s,n){const a=this.r.get(s),{added:r,updated:c,removed:o,overrides:S}=f(a,n),D=[...r,...c,...o];return(D.length||!a)&&this.updateFolderConfiguration(s,n),{keys:D,overrides:S}}compareAndDeleteFolderConfiguration(s){const n=this.r.get(s);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:a,updated:r,removed:c,overrides:o}=f(n,void 0);return{keys:[...a,...r,...c],overrides:o}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(s,n,a){let r=this.t(n,a);return n.overrideIdentifier&&(r=r.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(r=r.merge(this.d)),r}t({resource:s},n){let a=this.u();if(n&&s){const r=n.getFolder(s);r&&(a=this.v(r.uri)||a);const c=this.n.get(s);c&&(a=a.merge(c))}return a}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(s){let n=this.b.get(s);if(!n){const a=this.u(),r=this.l.get(s);r?(n=a.merge(r),this.p&&(n=n.freeze()),this.b.set(s,n)):n=a}return n}w(s,n){if(n&&s){const a=n.getFolder(s);if(a)return this.l.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((s,n)=>{const{contents:a,overrides:r,keys:c}=this.l.get(n);return s.push([n,{contents:a,overrides:r,keys:c}]),s},[])}}allKeys(){const s=new Set;return this.c.freeze().keys.forEach(n=>s.add(n)),this.userConfiguration.freeze().keys.forEach(n=>s.add(n)),this.j.freeze().keys.forEach(n=>s.add(n)),this.l.forEach(n=>n.freeze().keys.forEach(a=>s.add(a))),[...s.values()]}x(){const s=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.j.freeze().getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.l.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(a=>s.add(a))),[...s.values()]}y(s){const n=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(a=>n.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(a=>n.add(a)),this.j.getKeysForOverrideIdentifier(s).forEach(a=>n.add(a)),this.l.forEach(a=>a.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r))),[...n.values()]}static parse(s){const n=this.z(s.defaults),a=this.z(s.policy),r=this.z(s.application),c=this.z(s.user),o=this.z(s.workspace),S=s.folders.reduce((D,L)=>(D.set(m.URI.revive(L[0]),this.z(L[1])),D),new A.ResourceMap);return new u(n,a,r,c,new h,o,S,new h,new A.ResourceMap,!1)}static z(s){return new h(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=u;function p(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const s=new Set,n=new Map;for(const r of i)r.keys.forEach(c=>s.add(c)),r.overrides.forEach(([c,o])=>{const S=(0,A.getOrSet)(n,c,new Set);o.forEach(D=>S.add(D))});const a=[];return n.forEach((r,c)=>a.push([c,[...r.values()]])),{keys:[...s.values()],overrides:a}}e.mergeChanges=p;class g{constructor(s,n,a,r){this.change=s,this.b=n,this.c=a,this.d=r,this.f=void 0;const c=new Set;s.keys.forEach(S=>c.add(S)),s.overrides.forEach(([,S])=>S.forEach(D=>c.add(D))),this.affectedKeys=[...c.values()];const o=new h;this.affectedKeys.forEach(S=>o.setValue(S,{})),this.a=o.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=u.parse(this.b.data)),this.f}affectsConfiguration(s,n){if(this.g(this.a,s)){if(n){const a=this.previousConfiguration?this.previousConfiguration.getValue(s,n,this.b?.workspace):void 0,r=this.c.getValue(s,n,this.d);return!C.equals(a,r)}return!0}return!1}g(s,n){let a=(0,y.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof a=="object"&&(r=Object.keys(a)[0]);){if(s=s[r],!s)return!1;a=a[r]}return!0}}e.ConfigurationChangeEvent=g;function f(i,s){const{added:n,removed:a,updated:r}=l(s?.rawConfiguration,i?.rawConfiguration),c=[],o=i?.getAllOverrideIdentifiers()||[],S=s?.getAllOverrideIdentifiers()||[];if(s){const D=S.filter(L=>!o.includes(L));for(const L of D)c.push([L,s.getKeysForOverrideIdentifier(L)])}if(i){const D=o.filter(L=>!S.includes(L));for(const L of D)c.push([L,i.getKeysForOverrideIdentifier(L)])}if(s&&i){for(const D of o)if(S.includes(D)){const L=l({contents:i.getOverrideValue(void 0,D)||{},keys:i.getKeysForOverrideIdentifier(D)},{contents:s.getOverrideValue(void 0,D)||{},keys:s.getKeysForOverrideIdentifier(D)});c.push([D,[...L.added,...L.removed,...L.updated]])}}return{added:n,removed:a,updated:r,overrides:c}}function l(i,s){const n=i?s?i.keys.filter(c=>s.keys.indexOf(c)===-1):[...i.keys]:[],a=s?i?s.keys.filter(c=>i.keys.indexOf(c)===-1):[...s.keys]:[],r=[];if(i&&s){for(const c of s.keys)if(i.keys.indexOf(c)!==-1){const o=(0,y.getConfigurationValue)(s.contents,c),S=(0,y.getConfigurationValue)(i.contents,c);C.equals(o,S)||r.push(c)}}return{added:n,removed:a,updated:r}}}),define(te[218],ie([0,1,24,3,2,44,12,18,109,65,6,37,48]),function(V,e,I,t,k,R,A,C,w,m,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class h extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new d(this.f())),this.b}async initialize(){return this.b=void 0,this.B(E.Registry.as(m.Extensions.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:g})=>this.c(p,g))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(p,g){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:p})}f(){return{}}}e.DefaultConfiguration=h;class d extends w.ConfigurationModel{constructor(p={}){const g=E.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(g),l=Object.create(null),i=[];for(const s in g){const n=p[s],a=n!==void 0?n:g[s].default;(0,C.addToValueTree)(l,s,a,r=>console.error(`Conflict in default settings: ${r}`))}for(const s of Object.keys(l))m.OVERRIDE_PROPERTY_REGEX.test(s)&&i.push({identifiers:(0,m.overrideIdentifiersFromKey)(s),keys:Object.keys(l[s]),contents:(0,C.toValuesTree)(l[s],n=>console.error(`Conflict in default settings file: ${n}`))});super(l,f,i)}}e.DefaultConfigurationModel=d;class v{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new w.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=v;let b=class extends k.Disposable{get configurationModel(){return this.b}constructor(p,g,f){super(),this.c=p,this.f=g,this.g=f,this.a=this.B(new t.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new w.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(p=>this.i(p))),this.B(this.c.onDidChangeConfiguration(async({properties:p})=>this.j(await this.h(p),!0))),this.b}async h(p){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",p);const g={},f=[],l=E.Registry.as(m.Extensions.Configuration).getConfigurationProperties();for(const i of p){const s=l[i];if(!s){f.push(i);continue}if(s.policy){if(s.type!=="string"&&s.type!=="number"){this.g.warn(`Policy ${s.policy.name} has unsupported type ${s.type}`);continue}f.push(i),g[s.policy.name]={type:s.type}}}return(0,A.isEmptyObject)(g)||await this.f.updatePolicyDefinitions(g),f}i(p){this.g.trace("PolicyConfiguration#onDidChangePolicies",p);const g=E.Registry.as(m.Extensions.Configuration).getPolicyConfigurations(),f=(0,I.coalesce)(p.map(l=>g.get(l)));this.j(f,!0)}j(p,g){this.g.trace("PolicyConfiguration#update",p);const f=E.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),l=[],i=this.b.isEmpty();for(const s of p){const n=f[s]?.policy?.name;if(n){const a=this.f.getPolicyValue(n);(i?a!==void 0:!(0,R.equals)(this.b.getValue(s),a))&&l.push([s,a])}else this.b.getValue(s)!==void 0&&l.push([s,void 0])}if(l.length){this.g.trace("PolicyConfiguration#changed",l);const s=this.b;this.b=new w.ConfigurationModel;for(const n of s.keys)this.b.setValue(n,s.getValue(n));for(const[n,a]of l)a===void 0?this.b.removeValue(n):this.b.setValue(n,a);g&&this.a.fire(this.b)}}};b=pe([ne(1,P.IPolicyService),ne(2,y.ILogService)],b),e.PolicyConfiguration=b}),define(te[219],ie([0,1,8,3,2,20,18,109,218,37]),function(V,e,I,t,k,R,A,C,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class y extends k.Disposable{constructor(E,h,d,v){super(),this.i=E,this.h=this.B(new t.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new w.DefaultConfiguration),this.c=d instanceof m.NullPolicyService?new w.NullPolicyConfiguration:this.B(new w.PolicyConfiguration(this.b,d,v)),this.f=this.B(new C.UserSettings(this.i,void 0,R.extUriBiasedIgnorePathCase,h)),this.a=new C.Configuration(this.b.configurationModel,this.c.configurationModel,new C.ConfigurationModel,new C.ConfigurationModel),this.g=this.B(new I.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:b,properties:u})=>this.k(b,u))),this.B(this.c.onDidChangeConfiguration(b=>this.l(b))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[E,h,d]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new C.Configuration(E,h,new C.ConfigurationModel,d)}getConfigurationData(){return this.a.toData()}getValue(E,h){const d=typeof E=="string"?E:void 0,v=(0,A.isConfigurationOverrides)(E)?E:(0,A.isConfigurationOverrides)(h)?h:{};return this.a.getValue(d,v,void 0)}updateValue(E,h,d,v){return Promise.reject(new Error("not supported"))}inspect(E){return this.a.inspect(E,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const E=await this.f.loadConfiguration();this.j(E)}j(E){const h=this.a.toData(),d=this.a.compareAndUpdateLocalUserConfiguration(E);this.m(d,h,2)}k(E,h){const d=this.a.toData(),v=this.a.compareAndUpdateDefaultConfiguration(E,h);this.m(v,d,7)}l(E){const h=this.a.toData(),d=this.a.compareAndUpdatePolicyConfiguration(E);this.m(d,h,7)}m(E,h,d){const v=new C.ConfigurationChangeEvent(E,{data:h},this.a);v.source=d,v.sourceConfig=this.n(d),this.h.fire(v)}n(E){switch(E){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=y}),define(te[220],ie([0,1,14,5]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var k;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends I.ErrorNoTelemetry{static isNotAvailable(C){return C instanceof R&&C._code===k.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof R&&C._code===k.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof R&&C._code===k.NoResolverFound}static isHandled(C){return C instanceof R&&C.isHandled}constructor(C,w=k.Unknown,m){super(C),this._message=C,this._code=w,this._detail=m,this.isHandled=w===k.NotAvailable&&m===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R}),define(te[54],ie([0,1,15]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(m){return m.scheme===I.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=t;function k(m){if(!m)return;const y=m.indexOf("+");return y<0?m:m.substr(0,y)}e.getRemoteName=k;function R(m){return`/${m.quality??"oss"}-${m.commit??"dev"}`}e.getRemoteServerRootPath=R;function A(m){const{host:y,port:P}=w(m);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:y,port:P}}e.parseAuthorityWithPort=A;function C(m,y){let{host:P,port:E}=w(m);return typeof E>"u"&&(E=y),{host:P,port:E}}e.parseAuthorityWithOptionalPort=C;function w(m){const y=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(y)return{host:y[1],port:parseInt(y[2],10)};const P=m.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const E=m.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:m,port:void 0}}}),define(te[87],ie([0,1,26,5,54]),function(V,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=R;function A(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(C=e.ExtensionType||(e.ExtensionType={}));var w;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(w=e.TargetPlatform||(e.TargetPlatform={}));class m{constructor(v){this.value=v,this.c=v.toLowerCase()}static equals(v,b){if(typeof v>"u"||v===null)return typeof b>"u"||b===null;if(typeof b>"u"||b===null)return!1;if(typeof v=="string"||typeof b=="string"){const u=typeof v=="string"?v:v.value,p=typeof b=="string"?b:b.value;return I.equalsIgnoreCase(u,p)}return v.c===b.c}static toKey(v){return typeof v=="string"?v.toLowerCase():v.c}}e.ExtensionIdentifier=m;function y(d){return P(d)}e.isApplicationScopedExtension=y;function P(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function E(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function h(d,v){if(v){const b=`onResolveRemoteAuthority:${(0,k.getRemoteName)(v)}`;return d.activationEvents?.indexOf(b)!==-1}return!1}e.isResolverExtension=h,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[110],ie([0,1,26,192,87,4,7,14,33]),function(V,e,I,t,k,R,A,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function m(s,n){return s.uuid&&n.uuid?s.uuid===n.uuid:s.id===n.id?!0:(0,I.compareIgnoreCase)(s.id,n.id)===0}e.areSameExtensions=m;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class P{static create(n){const a=n.manifest?n.manifest.version:n.version,r=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new P(n.identifier,a,r)}static parse(n){const a=y.exec(n);return a&&a[1]&&a[2]?new P({id:a[1]},a[2],a[4]||void 0):null}constructor(n,a,r="undefined"){this.version=a,this.targetPlatform=r,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof P?m(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=P;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function h(s){const n=E.exec(s);return n&&n[1]?[v(n[1]),n[2]]:[v(s),void 0]}e.getIdAndVersion=h;function d(s,n){return`${s}.${n}`}e.getExtensionId=d;function v(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=v;function b(s,n){return v(d(s,n))}e.getGalleryExtensionId=b;function u(s,n){const a=[],r=c=>{for(const o of a)if(o.some(S=>m(n(S),n(c))))return o;return null};for(const c of s){const o=r(c);o?o.push(c):a.push([c])}return a}e.groupByExtension=u;function p(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function g(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=g,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function f(s,n){const a=[],r=n.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const c=r.shift();if(c&&a.every(o=>!m(o.identifier,{id:c}))){const o=s.filter(S=>m(S.identifier,{id:c}));o.length===1&&(a.push(o[0]),r.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.getExtensionDependencies=f;async function l(s,n){if(!R.isLinux)return!1;let a;try{a=(await s.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await s.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){n.debug("Error while getting the os-release file.",(0,C.getErrorMessage)(c))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=l;async function i(s,n){const a=await l(s,n),r=(0,t.getTargetPlatform)(a?"alpine":R.platform,w.arch);return n.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=i}),define(te[221],ie([0,1,8,17,22,14,3,2,29,102,220,54]),function(V,e,I,t,k,R,A,C,w,m,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var h;(function(q){q[q.Management=1]="Management",q[q.ExtensionHost=2]="ExtensionHost",q[q.Tunnel=3]="Tunnel"})(h=e.ConnectionType||(e.ConnectionType={}));function d(q){switch(q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function v(q){const j=new k.CancellationTokenSource;return setTimeout(()=>j.cancel(),q),j.token}function b(q,j){if(q.isCancellationRequested||j.isCancellationRequested)return k.CancellationToken.Cancelled;const M=new k.CancellationTokenSource;return q.onCancellationRequested(()=>M.cancel()),j.onCancellationRequested(()=>M.cancel()),M.token}class u{get didTimeout(){return this.c==="timedout"}constructor(j){this.c="pending",this.d=new C.DisposableStore,this.promise=new Promise((M,O)=>{this.f=M,this.g=O}),j.isCancellationRequested?this.h():this.d.add(j.onCancellationRequested(()=>this.h()))}registerDisposable(j){this.c==="pending"?this.d.add(j):j.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const j=new Error("Time limit reached");return j.code="ETIMEDOUT",j.syscall="connect",j}resolve(j){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(j))}reject(j){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(j))}}function p(q,j){const M=new u(j);return M.registerDisposable(q.onControlMessage(O=>{const F=JSON.parse(O.toString()),U=$(F);U?M.reject(U):M.resolve(F)})),M.promise}function g(q,j,M,O,F,U,H,x){const B=new u(x);return j.connect(M,O,F,U,H,(_,Z)=>{B.didTimeout?(_&&q.error(_),Z?.dispose()):_||!Z?B.reject(_):B.resolve(Z)}),B.promise}function f(q,j){const M=new u(j);return q.then(O=>{M.didTimeout||M.resolve(O)},O=>{M.didTimeout||M.reject(O)}),M.promise}async function l(q,j,M,O){const F=z(q,j);q.logService.trace(`${F} 1/6. invoking socketFactory.connect().`);let U;try{U=await g(q.logService,q.socketFactory,q.host,q.port,(0,P.getRemoteServerRootPath)(q),`reconnectionToken=${q.reconnectionToken}&reconnection=${q.reconnectionProtocol?"true":"false"}`,`renderer-${d(j)}-${q.reconnectionToken}`,O)}catch(Z){throw q.logService.error(`${F} socketFactory.connect() failed or timed out. Error:`),q.logService.error(Z),Z}q.logService.trace(`${F} 2/6. socketFactory.connect() was successful.`);let H,x;q.reconnectionProtocol?(q.reconnectionProtocol.beginAcceptReconnection(U,null),H=q.reconnectionProtocol,x=!1):(H=new m.PersistentProtocol(U,null),x=!0),q.logService.trace(`${F} 3/6. sending AuthRequest control message.`);const B=await f(q.signService.createNewMessage((0,w.generateUuid)()),O),_={type:"auth",auth:q.connectionToken||"00000000000000000000",data:B.data};H.sendControl(t.VSBuffer.fromString(JSON.stringify(_)));try{const Z=await p(H,b(O,v(1e4)));if(Z.type!=="sign"||typeof Z.data!="string"){const Oe=new Error("Unexpected handshake message");throw Oe.code="VSCODE_CONNECTION_ERROR",Oe}if(q.logService.trace(`${F} 4/6. received SignRequest control message.`),!await f(q.signService.validate(B,Z.signedData),O)){const Oe=new Error("Refused to connect to unsupported server");throw Oe.code="VSCODE_CONNECTION_ERROR",Oe}const ge=await f(q.signService.sign(Z.data),O),ke={type:"connectionType",commit:q.commit,signedData:ge,desiredConnectionType:j};return M&&(ke.args=M),q.logService.trace(`${F} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(t.VSBuffer.fromString(JSON.stringify(ke))),{protocol:H,ownsProtocol:x}}catch(Z){throw Z&&Z.code==="ETIMEDOUT"&&(q.logService.error(`${F} the handshake timed out. Error:`),q.logService.error(Z)),Z&&Z.code==="VSCODE_CONNECTION_ERROR"&&(q.logService.error(`${F} received error control message when negotiating connection. Error:`),q.logService.error(Z)),x&&le(H),Z}}async function i(q,j,M,O){const F=Date.now(),U=z(q,j),{protocol:H,ownsProtocol:x}=await l(q,j,M,O),B=new u(O);return B.registerDisposable(H.onControlMessage(_=>{const Z=JSON.parse(_.toString()),oe=$(Z);oe?(q.logService.error(`${U} received error control message when negotiating connection. Error:`),q.logService.error(oe),x&&le(H),B.reject(oe)):(q.reconnectionProtocol?.endAcceptReconnection(),q.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${Q(F)}!`),B.resolve({protocol:H,firstMessage:Z}))})),B.promise}async function s(q,j){const{protocol:M}=await i(q,1,void 0,j);return{protocol:M}}async function n(q,j,M){const{protocol:O,firstMessage:F}=await i(q,2,j,M),U=F&&F.debugPort;return{protocol:O,debugPort:U}}async function a(q,j,M){const O=Date.now(),F=z(q,3),{protocol:U}=await l(q,3,j,M);return q.logService.trace(`${F} 6/6. handshake finished, connection is up and running after ${Q(O)}!`),U}async function r(q,j,M){const{host:O,port:F,connectionToken:U}=await q.addressProvider.getAddress();return{commit:q.commit,quality:q.quality,host:O,port:F,connectionToken:U,reconnectionToken:j,reconnectionProtocol:M,socketFactory:q.socketFactory,signService:q.signService,logService:q.logService}}async function c(q,j,M){return S(q,async O=>{const{protocol:F}=await s(O,k.CancellationToken.None);return new fe(q,j,M,O.reconnectionToken,F)})}e.connectRemoteAgentManagement=c;async function o(q,j){return S(q,async M=>{const{protocol:O,debugPort:F}=await n(M,j,k.CancellationToken.None);return new K(q,j,M.reconnectionToken,O,F)})}e.connectRemoteAgentExtensionHost=o;async function S(q,j){for(let O=1;;O++)try{const F=(0,w.generateUuid)(),U=await r(q,F,null);return await j(U)}catch(F){if(O<5)q.logService.error(`[remote-connection][attempt ${O}] An error occurred in initial connection! Will retry... Error:`),q.logService.error(F);else throw q.logService.error(`[remote-connection][attempt ${O}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),q.logService.error(F),re.triggerPermanentFailure(0,0,y.RemoteAuthorityResolverError.isHandled(F)),F}}async function D(q,j,M){const O=await r(q,(0,w.generateUuid)(),null);return await a(O,{host:j,port:M},k.CancellationToken.None)}e.connectRemoteAgentTunnel=D;function L(q){return(0,I.createCancelablePromise)(j=>new Promise((M,O)=>{const F=setTimeout(M,q*1e3);j.onCancellationRequested(()=>{clearTimeout(F),M()})}))}var N;(function(q){q[q.ConnectionLost=0]="ConnectionLost",q[q.ReconnectionWait=1]="ReconnectionWait",q[q.ReconnectionRunning=2]="ReconnectionRunning",q[q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",q[q.ConnectionGain=4]="ConnectionGain"})(N=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class X{constructor(j,M){this.reconnectionToken=j,this.millisSinceLastIncomingData=M,this.type=0}}e.ConnectionLostEvent=X;class ae{constructor(j,M,O,F){this.reconnectionToken=j,this.millisSinceLastIncomingData=M,this.durationSeconds=O,this.c=F,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=ae;class J{constructor(j,M,O){this.reconnectionToken=j,this.millisSinceLastIncomingData=M,this.attempt=O,this.type=2}}e.ReconnectionRunningEvent=J;class Y{constructor(j,M,O){this.reconnectionToken=j,this.millisSinceLastIncomingData=M,this.attempt=O,this.type=4}}e.ConnectionGainEvent=Y;class se{constructor(j,M,O,F){this.reconnectionToken=j,this.millisSinceLastIncomingData=M,this.attempt=O,this.handled=F,this.type=3}}e.ReconnectionPermanentFailureEvent=se;class re extends C.Disposable{static triggerPermanentFailure(j,M,O){this._permanentFailure=!0,this.f=j,this.g=M,this.h=O,this.i.forEach(F=>F.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(j=>j.r())}static debugPauseSocketWriting(){this.i.forEach(j=>j.v())}get k(){return this.c||re._permanentFailure}constructor(j,M,O,F,U){super(),this.m=j,this.n=M,this.reconnectionToken=O,this.protocol=F,this.p=U,this.j=this.B(new A.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new Y(this.reconnectionToken,0,0)),this.B(F.onSocketClose(H=>{const x=T(this.m,this.reconnectionToken,!0);H?H.type===0?(this.n.logService.info(`${x} received socket close event (hadError: ${H.hadError}).`),H.error&&this.n.logService.error(H.error)):(this.n.logService.info(`${x} received socket close event (wasClean: ${H.wasClean}, code: ${H.code}, reason: ${H.reason}).`),H.event&&this.n.logService.error(H.event)):this.n.logService.info(`${x} received socket close event.`),this.r()})),this.B(F.onSocketTimeout(H=>{const x=T(this.m,this.reconnectionToken,!0);this.n.logService.info(`${x} received socket timeout event (unacknowledgedMsgCount: ${H.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${H.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${H.timeSinceLastReceivedSomeData}).`),this.r()})),re.i.push(this),this.B((0,C.toDisposable)(()=>{const H=re.i.indexOf(this);H>=0&&re.i.splice(H,1)})),this.k&&this.u(re.f,re.g,re.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const j=T(this.m,this.reconnectionToken,!0);this.n.logService.info(`${j} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const M=[0,5,5,10,10,10,10,10,30];let O=-1;do{O++;const F=O<M.length?M[O]:M[M.length-1];try{if(F>0){const H=L(F);this.j.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F,H)),this.n.logService.info(`${j} waiting for ${F} seconds before reconnecting...`);try{await H}catch{}}if(this.k){this.n.logService.error(`${j} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1)),this.n.logService.info(`${j} resolving connection...`);const U=await r(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${j} connecting to ${U.host}:${U.port}...`),await this.w(U,v(E)),this.n.logService.info(`${j} reconnected!`),this.j.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),O+1));break}catch(U){if(U.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${j} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(U),this.t(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(O>360){this.n.logService.error(`${j} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(U),this.t(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}if(y.RemoteAuthorityResolverError.isTemporarilyNotAvailable(U)){this.n.logService.info(`${j} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(U);continue}if((U.code==="ETIMEDOUT"||U.code==="ENETUNREACH"||U.code==="ECONNREFUSED"||U.code==="ECONNRESET")&&U.syscall==="connect"){this.n.logService.info(`${j} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(U);continue}if((0,R.isCancellationError)(U)){this.n.logService.info(`${j} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(U);continue}if(U instanceof y.RemoteAuthorityResolverError){this.n.logService.error(`${j} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(U),this.t(this.protocol.getMillisSinceLastIncomingData(),O+1,y.RemoteAuthorityResolverError.isHandled(U));break}this.n.logService.error(`${j} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(U),this.t(this.protocol.getMillisSinceLastIncomingData(),O+1,!1);break}}while(!this.k)}t(j,M,O){this.p?re.triggerPermanentFailure(j,M,O):this.u(j,M,O)}u(j,M,O){this.j.fire(new se(this.reconnectionToken,j,M,O)),le(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=re,re._permanentFailure=!1,re.f=0,re.g=0,re.h=!1,re.i=[];class fe extends re{constructor(j,M,O,F,U){super(1,j,F,U,!0),this.client=this.B(new m.Client(U,{remoteAuthority:M,clientId:O},j.ipcLogger))}async w(j,M){await s(j,M)}}e.ManagementPersistentConnection=fe;class K extends re{constructor(j,M,O,F,U){super(2,j,O,F,!1),this.y=M,this.debugPort=U}async w(j,M){await n(j,this.y,M)}}e.ExtensionHostPersistentConnection=K;function le(q){try{q.acceptDisconnect();const j=q.getSocket();q.dispose(),j.dispose()}catch(j){(0,R.onUnexpectedError)(j)}}function $(q){if(q&&q.type==="error"){const j=new Error(`Connection error: ${q.reason}`);return j.code="VSCODE_CONNECTION_ERROR",j}return null}function W(q,j){for(;q.length<j;)q+=" ";return q}function T(q,j,M){return`[remote-connection][${W(d(q),13)}][${j.substr(0,5)}\u2026][${M?"reconnect":"initial"}]`}function z(q,j){return`${T(j,q.reconnectionToken,!!q.reconnectionProtocol)}[${q.host}:${q.port}]`}function Q(q){return`${Date.now()-q} ms`}}),define(te[222],ie([0,1,78,83]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,R,A,C,w,m){const y=E=>m(E,void 0),P=I.createConnection({host:k,port:R},()=>{P.removeListener("error",y);const E=Buffer.alloc(16);for(let b=0;b<16;b++)E[b]=Math.round(Math.random()*256);const h=E.toString("base64"),d=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${R}${A}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${h}`];P.write(d.join(`\r
`)+`\r
\r
`);const v=b=>{b.toString().indexOf(`\r
\r
`)>=0&&(P.off("data",v),m(void 0,new t.NodeSocket(P,w)))};P.on("data",v)});P.setNoDelay(!0),P.once("error",y)}}}),define(te[223],ie([0,1,25,46,40,182]),function(V,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let A;async function C(h=!1){return(A===void 0||h)&&(A=w()),A}e.hasWSLFeatureInstalled=C;async function w(){const h=m();if(h===void 0)return!1;if(h>=22e3){const d=P();if(d)return new Promise(v=>{t.execFile(d,["--status"],b=>v(!b))})}else{const d=E();if(d)try{if((await k.promises.stat(d)).isFile())return!0}catch{}}return!1}function m(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(I.release());if(h)return parseInt(h[3])}function y(h){const d=process.env.SystemRoot;if(d){const v=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(d,v?"Sysnative":"System32",h)}}function P(){return y("wsl.exe")}function E(){return y("lxss\\LxssManager.dll")}}),define(te[55],ie([0,1,17,166,65,5,48]),function(V,e,I,t,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function C(v){return v.res.statusCode&&v.res.statusCode>=200&&v.res.statusCode<300||v.res.statusCode===1223}e.isSuccess=C;function w(v){return v.res.statusCode===204}async function m(v){return w(v)?null:(await(0,I.streamToBuffer)(v.stream)).toString()}e.asText=m;async function y(v){if(!C(v))throw new Error("Server returned "+v.res.statusCode);return m(v)}e.asTextOrError=y;async function P(v){if(!C(v))throw new Error("Server returned "+v.res.statusCode);if(w(v))return null;const u=(await(0,I.streamToBuffer)(v.stream)).toString();try{return JSON.parse(u)}catch(p){throw p.message+=`:
`+u,p}}e.asJson=P;function E(v){d(v)}e.updateProxyConfigurationsScope=E;let h;function d(v){const b=A.Registry.as(k.Extensions.Configuration),u=h;h={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:v,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},b.updateConfigurations({add:[h],remove:u?[u]:[]})}d(2)}),define(te[224],ie([0,1,17,22]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(C){this.a=C}listen(C,w){throw new Error("Invalid listen")}call(C,w,m,y=t.CancellationToken.None){switch(w){case"request":return this.a.request(m[0],y).then(async({res:P,stream:E})=>{const h=await(0,I.streamToBuffer)(E);return[{statusCode:P.statusCode,headers:P.headers},h]});case"resolveProxy":return this.a.resolveProxy(m[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class R{constructor(C){this.a=C}async request(C,w){const[m,y]=await this.a.call("request",[C],w);return{res:m,stream:(0,I.bufferToStream)(y)}}async resolveProxy(C){return this.a.call("resolveProxy",[C])}}e.RequestChannelClient=R}),define(te[225],ie([0,1,226,12]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(A,C){return A.protocol==="http:"?C.HTTP_PROXY||C.http_proxy||null:A.protocol==="https:"&&(C.HTTPS_PROXY||C.https_proxy||C.HTTP_PROXY||C.http_proxy)||null}async function R(A,C,w={}){const m=(0,I.parse)(A),y=w.proxyUrl||k(m,C);if(!y)return null;const P=(0,I.parse)(y);if(!/^https?:$/.test(P.protocol||""))return null;const E={host:P.hostname||"",port:P.port||(P.protocol==="https"?"443":"80"),auth:P.auth,rejectUnauthorized:(0,t.isBoolean)(w.strictSSL)?w.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((h,d)=>{V(["http-proxy-agent"],h,d)}))(E):new(await new Promise((h,d)=>{V(["https-proxy-agent"],h,d)}))(E)}e.getProxyAgent=R}),define(te[111],ie([0,1,46,9,167,22,45,14,4,29,143,61,8]),function(V,e,I,t,k,R,A,C,w,m,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const h=1e4;let d;async function v(u,p,g){return p["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,P.isLaunchedFromCli)(g)&&!p["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,P.isLaunchedFromCli)(g)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=E.Promises.withAsyncBody(async(f,l)=>{const i=new R.CancellationTokenSource,s=setTimeout(()=>{i.dispose(!0),l(new Error((0,k.localize)(0,null)))},h);try{f(await b(u,i.token))}catch(n){!(0,C.isCancellationError)(n)&&!i.token.isCancellationRequested?l(new Error((0,k.localize)(1,null,(0,A.toErrorMessage)(n)))):f({})}finally{clearTimeout(s),i.dispose()}})),d)}e.getResolvedShellEnv=v;async function b(u,p){const g=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",g);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",f);const l=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(l+"({.*})"+l),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",s);const n=await(0,y.getSystemShell)(w.OS,s);return u.trace("getUnixShellEnvironment#shell",n),new Promise((a,r)=>{if(p.isCancellationRequested)return r((0,C.canceled)());const c=(0,t.basename)(n);let o,S;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(o=`& '${process.execPath}' ${D} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,S=["-Login","-Command"]):(o=`'${process.execPath}' ${D} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,c==="tcsh"?S=["-ic"]:S=["-ilc"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(S),o);const L=(0,I.spawn)(n,[...S,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});p.onCancellationRequested(()=>(L.kill(),r((0,C.canceled)()))),L.on("error",ae=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(ae)),r(ae)});const N=[];L.stdout.on("data",ae=>N.push(ae));const X=[];L.stderr.on("data",ae=>X.push(ae)),L.on("close",(ae,J)=>{const Y=Buffer.concat(N).toString("utf8");u.trace("getUnixShellEnvironment#raw",Y);const se=Buffer.concat(X).toString("utf8");if(se.trim()&&u.trace("getUnixShellEnvironment#stderr",se),ae||J)return r(new Error((0,k.localize)(2,null,ae,J)));const re=i.exec(Y),fe=re?re[1]:"{}";try{const K=JSON.parse(fe);g?K.ELECTRON_RUN_AS_NODE=g:delete K.ELECTRON_RUN_AS_NODE,f?K.ELECTRON_NO_ATTACH_CONSOLE=f:delete K.ELECTRON_NO_ATTACH_CONSOLE,delete K.VSCODE_RESOLVING_ENVIRONMENT,delete K.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",K),a(K)}catch(K){u.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(K)),r(K)}})})}}),define(te[88],ie([0,1,5]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,I.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[227],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class I{constructor(){this.b=new Map}c(){return new Promise((k,R)=>V(["vsda"],k,R))}async createNewMessage(k){try{const R=await this.c(),A=new R.validator;if(A){const C=String(I.a++);return this.b.set(C,A),{id:C,data:A.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,R){if(!k.id)return!0;const A=this.b.get(k.id);if(!A)return!1;this.b.delete(k.id);try{return A.validate(R)==="ok"}catch{return!1}}async sign(k){try{const R=await this.c(),A=new R.signer;if(A)return A.sign(k)}catch{}return k}}e.SignService=I,I.a=1}),define(te[36],ie([0,1,5]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,I.createDecorator)("stateMainService")}),define(te[21],ie([0,1,13,41,8,3,2,4,33,12,5,6,36,27]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,y.createDecorator)("lifecycleMainService");var d;(function(u){u[u.QUIT=1]="QUIT",u[u.KILL=2]="KILL"})(d=e.ShutdownReason||(e.ShutdownReason={}));var v;(function(u){u[u.Starting=1]="Starting",u[u.Ready=2]="Ready",u[u.AfterWindowOpen=3]="AfterWindowOpen",u[u.Eventually=4]="Eventually"})(v=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let b=class It extends A.Disposable{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(p,g,f){super(),this.v=p,this.w=g,this.y=f,this.c=this.B(new R.Emitter),this.onBeforeShutdown=this.c.event,this.f=this.B(new R.Emitter),this.onWillShutdown=this.f.event,this.g=this.B(new R.Emitter),this.onWillLoadWindow=this.g.event,this.h=this.B(new R.Emitter),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.z(),this.when(2).then(()=>this.C())}z(){this.j=!!this.w.getItem(It.b),this.j&&this.w.removeItem(It.b)}C(){const p=()=>{this.i||(this.L("Lifecycle#app.on(before-quit)"),this.i=!0,this.L("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),C.isMacintosh&&this.n===0&&this.D(1))};I.app.addListener("before-quit",p);const g=()=>{this.L("Lifecycle#app.on(window-all-closed)"),(this.i||!C.isMacintosh)&&I.app.quit()};I.app.addListener("window-all-closed",g),I.app.once("will-quit",f=>{this.L("Lifecycle#app.on(will-quit)"),f.preventDefault(),this.D(1).finally(()=>{this.H(!1),I.app.removeListener("before-quit",p),I.app.removeListener("window-all-closed",g),I.app.quit()})})}D(p){if(this.s)return this.s;this.L("Lifecycle#onWillShutdown.fire()");const g=[];return this.f.fire({reason:p,join(f){g.push(f)}}),this.s=(async()=>{try{await k.Promises.settled(g)}catch(f){this.v.error(f)}try{await this.w.close()}catch(f){this.v.error(f)}})(),this.s}set phase(p){if(p<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===p)return;this.L(`lifecycle (main): phase changed (value: ${p})`),this.k=p;const g=this.u.get(this.k);g&&(g.open(),this.u.delete(this.k))}async when(p){if(p<=this.k)return;let g=this.u.get(p);g||(g=new k.Barrier,this.u.set(p,g)),await g.wait()}registerWindow(p){const g=new A.DisposableStore;this.n++,g.add(p.onWillLoad(l=>this.g.fire({window:p,workspace:l.workspace,reason:l.reason})));const f=(0,m.assertIsDefined)(p.win);f.on("close",l=>{const i=p.id;if(this.l.has(i)){this.l.delete(i);return}this.L(`Lifecycle#window.on('close') - window ID ${p.id}`),l.preventDefault(),this.unload(p,1).then(s=>{if(s){this.l.delete(i);return}this.l.add(i),this.L(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${i}`),this.h.fire(p),p.close()})}),f.on("closed",()=>{this.L(`Lifecycle#window.on('closed') - window ID ${p.id}`),this.n--,g.dispose(),this.n===0&&(!C.isMacintosh||this.i)&&this.D(1)})}async reload(p,g){await this.unload(p,3)||p.reload(g)}unload(p,g){const f=this.t.get(p.id);if(f)return f;const l=this.F(p,g).finally(()=>{this.t.delete(p.id)});return this.t.set(p.id,l),l}async F(p,g){if(!p.isReady)return!1;this.L(`Lifecycle#unload() - window ID ${p.id}`);const f=this.i?2:g,l=await this.I(p,f);return l?(this.L(`Lifecycle#unload() - veto in renderer (window ID ${p.id})`),this.G(l)):(await this.J(p,f),!1)}G(p){return p?(this.H(!0),this.i=!1,!0):!1}H(p){this.r&&(this.r(p),this.r=void 0,this.p=void 0)}I(p,g){return new Promise(f=>{const l=this.m++,i=`vscode:ok${l}`,s=`vscode:cancel${l}`;t.validatedIpcMain.once(i,()=>{f(!1)}),t.validatedIpcMain.once(s,()=>{f(!0)}),p.send("vscode:onBeforeUnload",{okChannel:i,cancelChannel:s,reason:g})})}J(p,g){return new Promise(f=>{const i=`vscode:reply${this.m++}`;t.validatedIpcMain.once(i,()=>f()),p.send("vscode:onWillUnload",{replyChannel:i,reason:g})})}quit(p){return this.L(`Lifecycle#quit() - begin (willRestart: ${p})`),this.p?(this.L("Lifecycle#quit() - returning pending quit promise"),this.p):(p&&this.w.setItem(It.b,!0),this.p=new Promise(g=>{this.r=g,this.L("Lifecycle#quit() - calling app.quit()"),I.app.quit()}),this.p)}L(p){this.y.args["enable-smoke-test-driver"]?this.v.info(p):this.v.trace(p)}async relaunch(p){this.L("Lifecycle#relaunch()");const g=process.argv.slice(1);if(p?.addArgs&&g.push(...p.addArgs),p?.removeArgs)for(const i of p.removeArgs){const s=g.indexOf(i);s>=0&&g.splice(s,1)}const f=()=>{try{if(C.isWindows){const i=(0,w.cwd)();i!==process.cwd()&&process.chdir(i)}}catch(i){this.v.error(i)}this.L("Lifecycle#relaunch() - calling app.relaunch()"),I.app.relaunch({args:g})};I.app.once("quit",f),await this.quit(!0)&&I.app.removeListener("quit",f)}async kill(p){this.L("Lifecycle#kill()"),await this.D(2),await Promise.race([(0,k.timeout)(1e3),(async()=>{for(const g of I.BrowserWindow.getAllWindows())if(g&&!g.isDestroyed()){let f;g.webContents&&!g.webContents.isDestroyed()?f=new Promise(l=>g.once("closed",l)):f=Promise.resolve(),g.destroy(),await f}})()]),I.app.exit(p)}};b.b="lifecycle.quitAndRestart",b=pe([ne(0,P.ILogService),ne(1,E.IStateMainService),ne(2,h.IEnvironmentMainService)],b),e.LifecycleMainService=b}),define(te[228],ie([0,1,4,3,2,5,21]),function(V,e,I,t,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let C=class extends k.Disposable{constructor(y){super(),this.a=this.B(new t.Emitter),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,y.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const y=await new Promise((P,E)=>{V(["native-keymap"],P,E)});this.c=w(y),I.isCI||y.onDidChangeKeyboardLayout(()=>{this.c=w(y),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};C=pe([ne(0,A.ILifecycleMainService)],C),e.KeyboardLayoutMainService=C;function w(m){const y=m.getKeyMap(),P=m.getCurrentKeyboardLayout();return{keyboardMapping:y,keyboardLayoutInfo:P}}}),define(te[229],ie([0,1,5]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,I.createDecorator)("stateService")}),define(te[230],ie([0,1,8,17,12,35,16,6]),function(V,e,I,t,k,R,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class w{constructor(P,E,h){this.f=P,this.g=E,this.h=h,this.a=Object.create(null),this.b="",this.c=new I.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(P){P.fileOperationResult!==1&&this.g.error(P)}}getItem(P,E){const h=this.a[P];return(0,k.isUndefinedOrNull)(h)?E:h}setItem(P,E){this.setItems([{key:P,data:E}])}setItems(P){let E=!1;for(const{key:h,data:d}of P)this.a[h]!==d&&((0,k.isUndefinedOrNull)(d)?(0,k.isUndefined)(this.a[h])||(this.a[h]=void 0,E=!0):(this.a[h]=d,E=!0));E&&this.j()}removeItem(P){(0,k.isUndefined)(this.a[P])||(this.a[P]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const P=JSON.stringify(this.a,null,4);if(P!==this.b)try{await this.h.writeFile(this.f,t.VSBuffer.fromString(P)),this.b=P}catch(E){this.g.error(E)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=w;let m=class{constructor(P,E,h){this.a=new w(P.stateResource,E,h)}async init(){await this.a.init()}getItem(P,E){return this.a.getItem(P,E)}};m=pe([ne(0,R.IEnvironmentService),ne(1,C.ILogService),ne(2,A.IFileService)],m),e.StateService=m}),define(te[231],ie([0,1,230]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends I.StateService{setItem(R,A){this.a.setItem(R,A)}setItems(R){this.a.setItems(R)}removeItem(R){this.a.removeItem(R)}close(){return this.a.close()}}e.StateMainService=t}),define(te[89],ie([0,1,4,33,7,29]),function(V,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(m){if(I.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function C(m,y,P,E,h,d,v,b,u,p){const g=Object.create(null);g["common.machineId"]=v,g.sessionID=(0,R.generateUuid)()+Date.now(),g.commitHash=h,g.version=d,g["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,I.PlatformToString)(I.platform),g["common.nodePlatform"]=t.platform,g["common.nodeArch"]=E,g["common.product"]=p||"desktop",b&&(g["common.msftInternal"]=b);let f=0;const l=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),I.isLinuxSnap&&(g["common.snap"]="true");const i=A(P);i&&(g["common.platformDetail"]=i);try{const s=await m.readFile(k.URI.file(u));g["common.source"]=s.value.toString().slice(0,30)}catch{}return g}e.resolveCommonProperties=C;function w(m){const y=t.env.USERDNSDOMAIN;if(!y)return!1;const P=y.toLowerCase();return m.some(E=>P===E)}e.verifyMicrosoftInternalDomain=w}),define(te[31],ie([0,1,5]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,I.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,I.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[232],ie([0,1,25,8,43,15,9,4,7,81,23,101,84,16,19,31]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const b=new Map;async function u(i,s){const n=`${i}::${s.join(":")}`,a=b.get(n);if(a)return a;const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,o=new Map,S=2e4;function D(N,X,ae,J){const Y=X.substring(N.length+1);return t.Promises.withAsyncBody(async se=>{let re;try{re=await y.Promises.readdir(X,{withFileTypes:!0})}catch{se();return}if(J.count>=S){J.count+=re.length,J.maxReached=!0,se();return}let fe=re.length;if(fe===0){se();return}let K=re;J.count+re.length>S&&(J.maxReached=!0,fe=S-J.count,K=re.slice(0,fe)),J.count+=re.length;for(const le of K)if(le.isDirectory()){if(ae.includes(le.name)||await D(N,(0,A.join)(X,le.name),ae,J),--fe===0){se();return}}else{const $=le.name.lastIndexOf(".");if($>=0){const W=le.name.substring($+1);W&&c.set(W,(c.get(W)??0)+1)}for(const W of r)W.relativePathPattern?.test(Y)!==!1&&W.filePattern.test(le.name)&&o.set(W.tag,(o.get(W.tag)??0)+1);if(--fe===0){se();return}}})}const L=t.Promises.withAsyncBody(async N=>{const X={count:0,maxReached:!1};await D(i,i,s,X);const ae=await f(i);N({configFiles:p(o),fileTypes:p(c),fileCount:X.count,maxFilesReached:X.maxReached,launchConfigFiles:ae})});return b.set(n,L),L}e.collectWorkspaceStats=u;function p(i){return Array.from(i.entries(),([s,n])=>({name:s,count:n})).sort((s,n)=>n.count-s.count)}function g(){const i={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(m.virtualMachineHint.value()*100)}%`},s=I.cpus();return s&&s.length>0&&(i.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),i}e.getMachineInfo=g;async function f(i){try{const s=new Map,n=(0,A.join)(i,".vscode","launch.json"),a=await y.Promises.readFile(n),r=[],c=(0,k.parse)(a.toString(),r);if(r.length)return console.log(`Unable to parse ${n}`),[];if((0,k.getNodeType)(c)==="object"&&c.configurations)for(const o of c.configurations){const S=o.type;S&&(s.has(S)?s.set(S,s.get(S)+1):s.set(S,1))}return p(s)}catch{return[]}}e.collectLaunchConfigs=f;let l=class{constructor(s,n){this.c=s,this.d=n}f(s){const n=[];return n.push(`OS Version:       ${s.os}`),n.push(`CPUs:             ${s.cpus}`),n.push(`Memory (System):  ${s.memory}`),n.push(`VM:               ${s.vmHint}`),n.join(`
`)}g(s){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const a=I.cpus();return a&&a.length>0&&n.push(`CPUs:             ${a[0].model} (${a.length} x ${a[0].speed})`),n.push(`Memory (System):  ${(I.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(I.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),C.isWindows||n.push(`Load (avg):       ${I.loadavg().map(r=>Math.round(r)).join(", ")}`),n.push(`VM:               ${Math.round(m.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${s.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(s.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(s,n){return Promise.all([(0,P.listProcesses)(s.mainPID),this.k(s)]).then(async a=>{let[r,c]=a,o=this.m(s,r);return n.forEach(S=>{if((0,E.isRemoteDiagnosticError)(S))o+=`
${S.errorMessage}`,c+=`
${S.errorMessage}`;else if(o+=`

Remote: ${S.hostName}`,S.processes&&(o+=`
${this.m(s,S.processes)}`),S.workspaceMetadata){c+=`
|  Remote: ${S.hostName}`;for(const D of Object.keys(S.workspaceMetadata)){const L=S.workspaceMetadata[D];let N=`${L.fileCount} files`;L.maxFilesReached&&(N=`more than ${N}`),c+=`|    Folder (${D}): ${N}`,c+=this.h(L)}}}),{processInfo:o,workspaceInfo:c}})}async getSystemInfo(s,n){const{memory:a,vmHint:r,os:c,cpus:o}=g(),S={os:c,memory:a,cpus:o,vmHint:r,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:n};return C.isWindows||(S.load=`${I.loadavg().map(D=>Math.round(D)).join(", ")}`),C.isLinux&&(S.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(S)}async getDiagnostics(s,n){const a=[];return(0,P.listProcesses)(s.mainPID).then(async r=>(a.push(""),a.push(this.g(s)),a.push(""),a.push(this.m(s,r)),s.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(a.push(""),a.push("Workspace Stats: "),a.push(await this.k(s))),n.forEach(c=>{if((0,E.isRemoteDiagnosticError)(c))a.push(`
${c.errorMessage}`);else if(a.push(`

`),a.push(`Remote:           ${c.hostName}`),a.push(this.f(c.machineInfo)),c.processes&&a.push(this.m(s,c.processes)),c.workspaceMetadata)for(const o of Object.keys(c.workspaceMetadata)){const S=c.workspaceMetadata[o];let D=`${S.fileCount} files`;S.maxFilesReached&&(D=`more than ${D}`),a.push(`Folder (${o}): ${D}`),a.push(this.h(S))}}),a.push(""),a.push(""),a.join(`
`)))}h(s){const n=[];let r=0;const c=(L,N)=>{const X=` ${L}(${N})`;r+X.length>60?(n.push(o),o="|                 ",r=o.length):r+=X.length,o+=X};let o="|      File types:";const S=10,D=s.fileTypes.length>S?S:s.fileTypes.length;for(let L=0;L<D;L++){const N=s.fileTypes[L];c(N.name,N.count)}if(n.push(o),s.configFiles.length>=0&&(o="|      Conf files:",r=0,s.configFiles.forEach(L=>{c(L.name,L.count)}),n.push(o)),s.launchConfigFiles.length>0){let L="|      Launch Configs:";s.launchConfigFiles.forEach(N=>{L+=N.count>1?` ${N.name}(${N.count})`:` ${N.name}`}),n.push(L)}return n.join(`
`)}j(s){const n=Math.max(...Object.keys(s).map(a=>a.length));return Object.keys(s).map(a=>`${a}:  ${" ".repeat(n-a.length)}  ${s[a]}`).join(`
                  `)}k(s){const n=[],a=[];return s.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(n.push(`|  Window (${r.title})`),r.folderURIs.forEach(c=>{const o=w.URI.revive(c);if(o.scheme===R.Schemas.file){const S=o.fsPath;a.push(u(S,["node_modules",".git"]).then(D=>{let L=`${D.fileCount} files`;D.maxFilesReached&&(L=`more than ${L}`),n.push(`|    Folder (${(0,A.basename)(S)}): ${L}`),n.push(this.h(D))}).catch(D=>{n.push(`|      Error: Unable to collect workspace stats for folder ${S} (${D.toString()})`)}))}else n.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(a).then(r=>n.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}m(s,n){const a=new Map;s.windows.forEach(c=>a.set(c.pid,c.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),n&&this.n(s.mainPID,a,r,n,0),r.join(`
`)}n(s,n,a,r,c){const o=c===0;let S;o?S=r.pid===s?`${this.d.applicationName} main`:"remote agent":(S=`${"  ".repeat(c)} ${r.name}`,r.name==="window"&&(S=`${S} (${n.get(r.pid)})`));const D=process.platform==="win32"?r.mem:I.totalmem()*(r.mem/100);a.push(`${r.load.toFixed(0).padStart(5," ")}	${(D/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${S}`),Array.isArray(r.children)&&r.children.forEach(L=>this.n(s,n,a,L,c+1))}async getWorkspaceFileExtensions(s){const n=new Set;for(const{uri:a}of s.folders){const r=w.URI.revive(a);if(r.scheme!==R.Schemas.file)continue;const c=r.fsPath;try{(await u(c,["node_modules",".git"])).fileTypes.forEach(S=>n.add(S.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(s){for(const{uri:n}of s.folders){const a=w.URI.revive(n);if(a.scheme!==R.Schemas.file)continue;const r=a.fsPath;try{const c=await u(r,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),c.fileTypes.forEach(o=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:o.name,count:o.count})}),c.launchConfigFiles.forEach(o=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:o.name,count:o.count})}),c.configFiles.forEach(o=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};l=pe([ne(0,v.ITelemetryService),ne(1,d.IProductService)],l),e.DiagnosticsService=l}),define(te[233],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class I{constructor(R){this.b=R}listen(R,A){throw new Error(`Event not found: ${A}`)}call(R,A,{eventName:C,data:w}){return this.b.forEach(m=>m.log(C,w)),Promise.resolve(null)}}e.TelemetryAppenderChannel=I;class t{constructor(R){this.b=R}log(R,A){return this.b.call("log",{eventName:R,data:A}).then(void 0,C=>`Failed to log telemetry: ${console.warn(C)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(te[56],ie([0,1,44,12,18,54,89,31]),function(V,e,I,t,k,R,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class w{constructor(c){this.value=c}}e.TrustedTelemetryValue=w;class m{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(c,o){return Promise.resolve(void 0)}publicLog2(c,o){return this.publicLog(c,o)}publicLogError(c,o){return Promise.resolve(void 0)}publicLogError2(c,o){return this.publicLogError(c,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=m,e.NullTelemetryService=new m;class y{async publicLog(c,o,S){}async publicLogError(c,o,S){}}e.NullEndpointTelemetryService=y,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function P(r,c){return c.onDidChangeConfiguration(o=>{o.source!==7&&r.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(o.source),configurationKeys:g(o.sourceConfig)})})}e.configurationTelemetry=P;function E(r,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!r.enableTelemetry||c.extensionTestsLocationURI)}e.supportsTelemetry=E;function h(r,c){return!(c.isBuilt||c.disableTelemetry||r.enableTelemetry&&r.aiConfig?.ariaKey)}e.isLoggingOnly=h;function d(r){const c=r.getValue(C.TELEMETRY_SETTING_ID),o=r.getValue("telemetry.enableCrashReporter");if(r.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=d;function v(r){const c={},o={},S={};p(r,S);for(let D in S){D=D.length>150?D.substr(D.length-149):D;const L=S[D];typeof L=="number"?o[D]=L:typeof L=="boolean"?o[D]=L?1:0:typeof L=="string"?(L.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${L.length}`),c[D]=L.substring(0,8191)):typeof L<"u"&&L!==null&&(c[D]=L)}return{properties:c,measurements:o}}e.validateTelemetryData=v;const b=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function u(r){if(!r)return"none";const c=(0,R.getRemoteName)(r);return b.has(c)?c:"other"}e.cleanRemoteAuthority=u;function p(r,c,o=0,S){if(!!r)for(const D of Object.getOwnPropertyNames(r)){const L=r[D],N=S?S+D:D;Array.isArray(L)?c[N]=(0,I.safeStringify)(L):L instanceof Date?c[N]=L.toISOString():(0,t.isObject)(L)?o<2?p(L,c,o+1,N+"."):c[N]=(0,I.safeStringify)(L):c[N]=L}}function g(r){if(!r)return[];const c=[];return f(c,"",r),c}function f(r,c,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(S=>f(r,c?`${c}.${S}`:S,o[S])):r.push(c)}function l(r,c){const o=r.msftInternalDomains||[],S=c.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(o)||S}e.isInternalTelemetry=l;function i(r){return[r.appRoot,r.extensionsPath,r.userHome.fsPath,r.tmpDir.fsPath,r.userDataPath]}e.getPiiPathsFromEnvironment=i;function s(r,c){if(!r||!r.includes("/")&&!r.includes("\\"))return r;let o=r;const S=[];for(const X of c)for(;;){const ae=X.exec(r);if(!ae)break;S.push([ae.index,X.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,L=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let N=0;for(o="";;){const X=L.exec(r);if(!X)break;const ae=S.some(([J,Y])=>X.index<Y&&J<L.lastIndex);!D.test(X[0])&&!ae&&(o+=r.substring(N,X.index)+"<REDACTED: user-file-path>",N=L.lastIndex)}return N<r.length&&(o+=r.substr(N)),o}function n(r){if(!r)return r;const c=r.toLowerCase(),o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const S of o)if(S.regex.test(c))return`<REDACTED: ${S.label}>`;return r}function a(r,c){return(0,I.cloneAndChange)(r,o=>{if(o instanceof w)return o.value;if(typeof o=="string"){let S=o.replaceAll("%20"," ");S=s(S,c);for(const D of c)S=S.replace(D,"");return S=n(S),S}})}e.cleanData=a}),define(te[234],ie([0,1,189,56]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(R,A,C,w,m,y,P){const E={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${A.nameShort})`};if((0,t.supportsTelemetry)(A,C)&&(0,t.getTelemetryLevel)(w)===3){const h=await(0,I.getServiceMachineId)(C,m,y),{machineId:d}=await P.getTelemetryInfo();E["X-Market-User-Id"]=h,E["VSCode-SessionId"]=d||h}return E}e.resolveMarketplaceHeaders=k}),define(te[235],ie([0,1,14,44,56]),function(V,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const R="https://mobile.events.data.microsoft.com/OneCollector/1.0",A="https://mobile.events.data.microsoft.com/ping";async function C(m,y,P){const E=await new Promise((u,p)=>{V(["@microsoft/1ds-core-js"],u,p)}),h=await new Promise((u,p)=>{V(["@microsoft/1ds-post-js"],u,p)}),d=new E.AppInsightsCore,v=new h.PostChannel,b={instrumentationKey:m,endpointUrl:R,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[v]]};if(P){b.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:P};b.extensionConfig[v.identifier]=u}return d.initialize(b,[]),d.addTelemetryInitializer(u=>{y&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),d}class w{constructor(y,P,E,h,d){this.e=y,this.f=P,this.g=E,this.h=d,this.c=R,this.d=A,this.g||(this.g={}),typeof h=="function"?this.a=h():this.a=h,this.b=null}i(y){if(!!this.a){if(typeof this.a!="string"){y(this.a);return}this.b||(this.b=C(this.a,this.e,this.h)),this.b.then(P=>{y(P)},P=>{(0,I.onUnexpectedError)(P),console.error(P)})}}log(y,P){if(!this.a)return;P=(0,t.mixin)(P,this.g),P=(0,k.validateTelemetryData)(P);const E=this.f+"/"+y;try{this.i(h=>{h.pluginVersionString=P?.properties.version??"Unknown",h.track({name:E,baseData:{name:E,properties:P?.properties,measurements:P?.measurements}})})}catch{}}flush(){return this.a?new Promise(y=>{this.i(P=>{P.unload(!0,()=>{this.a=void 0,y(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=w}),define(te[112],ie([0,1,2,44,4,26,168,18,65,63,19,48,31,56]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let d=class{constructor(u,p,g){this.k=p,this.l=g,this.d={},this.i=new I.DisposableStore,this.j=[],this.b=u.appenders,this.c=u.commonProperties||Promise.resolve({}),this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const f of this.f)this.j.push(new RegExp((0,R.escapeRegExpCharacters)(f),"gi")),f.indexOf("\\")>=0&&this.j.push(new RegExp((0,R.escapeRegExpCharacters)(f.replace(/\\/g,"/")),"gi"));this.m(),this.k.onDidChangeConfiguration(this.m,this,this.i)}setExperimentProperty(u,p){this.d[u]=p}m(){let u=(0,h.getTelemetryLevel)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const g=p.usage?3:p.error?2:0;u=Math.min(u,g)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const u=await this.c,p=u.sessionID,g=u["common.machineId"],f=u["common.firstSessionDate"],l=u["common.msftInternal"];return{sessionId:p,machineId:g,firstSessionDate:f,msftInternal:l}}dispose(){this.i.dispose()}n(u,p,g){return this.g<p?Promise.resolve(void 0):this.c.then(f=>{g=(0,t.mixin)(g,this.d),g=(0,h.cleanData)(g,this.j),g=(0,t.mixin)(g,f),this.b.forEach(l=>l.log(u,g))},f=>{console.error(f)})}publicLog(u,p){return this.n(u,3,p)}publicLog2(u,p){return this.publicLog(u,p)}publicLogError(u,p){return this.h?this.n(u,2,p):Promise.resolve(void 0)}publicLogError2(u,p){return this.publicLogError(u,p)}};d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",d=pe([ne(1,C.IConfigurationService),ne(2,y.IProductService)],d),e.TelemetryService=d;function v(){const b=(0,A.localize)(0,null,m.default.nameLong),u=m.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",m.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=k.isWeb?"":(0,A.localize)(3,null),g=(0,A.localize)(4,null),f=(0,A.localize)(5,null),l=(0,A.localize)(6,null),i=(0,A.localize)(7,null),s=`
|       | ${g} | ${f} | ${l} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,A.localize)(8,null);return`
${b} ${u} ${p}

&nbsp;

${i}
${s}

&nbsp;

${n}
`}P.Registry.as(w.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),P.Registry.as(w.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,A.localize)(16,null,m.default.nameLong,m.default.privacyStatementUrl):(0,A.localize)(15,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[236],ie([0,1,282,235]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class k extends t.AbstractOneDataSystemAppender{constructor(A,C,w,m){const y={sendPOST:(P,E)=>{const h={method:"POST",headers:{...P.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(P.data)}};try{const d=I.request(P.urlString,h,v=>{v.on("data",function(b){E(v.statusCode??200,v.headers,b.toString())}),v.on("error",function(b){E(0,{})})});d.write(P.data),d.end()}catch{E(0,{})}}};super(A,C,w,m,y)}}e.OneDataSystemAppender=k}),define(te[237],ie([0,1,4,81,31]),function(V,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function R(A){let C=A.getItem(k.machineIdKey);return(typeof C!="string"||I.isMacintosh&&C==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(C=await(0,t.getMachineId)()),C}e.resolveMachineId=R}),define(te[113],ie([0,1,31,237]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function k(R){const A=await(0,t.resolveMachineId)(R);return R.setItem(I.machineIdKey,A),A}e.resolveMachineId=k}),define(te[238],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var I;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(I=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===I.HIGH_CONTRAST_DARK||R===I.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function k(R){return R===I.DARK||R===I.HIGH_CONTRAST_DARK}e.isDark=k}),define(te[239],ie([0,1,120,3,2,5,48,238]),function(V,e,I,t,k,R,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var w;(function(b){function u(p){return p&&typeof p=="object"&&typeof p.id=="string"}b.isThemeColor=u})(w=e.ThemeColor||(e.ThemeColor={}));function m(b){return{id:b}}e.themeColorFromId=m;var y;(function(b){function u(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||w.isThemeColor(a.color))}b.isThemeIcon=u;const p=new RegExp(`^\\$\\((${I.CSSIcon.iconNameExpression}(?:${I.CSSIcon.iconModifierExpression})?)\\)$`);function g(a){const r=p.exec(a);if(!r)return;const[,c]=r;return{id:c}}b.fromString=g;function f(a){return{id:a}}b.fromId=f;function l(a,r){let c=a.id;const o=c.lastIndexOf("~");return o!==-1&&(c=c.substring(0,o)),r&&(c=`${c}~${r}`),{id:c}}b.modify=l;function i(a){const r=a.id.lastIndexOf("~");if(r!==-1)return a.id.substring(r+1)}b.getModifier=i;function s(a,r){return a.id===r.id&&a.color?.id===r.color?.id}b.isEqual=s;function n(a,r){return{id:a.id,color:r?m(r):void 0}}b.asThemeIcon=n,b.asClassNameArray=I.CSSIcon.asClassNameArray,b.asClassName=I.CSSIcon.asClassName,b.asCSSSelector=I.CSSIcon.asCSSSelector})(y=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=I.Codicon.file,e.FolderThemeIcon=I.Codicon.folder;function P(b){switch(b){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case C.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(u){return this.a.push(u),this.b.fire(u),(0,k.toDisposable)(()=>{const p=this.a.indexOf(u);this.a.splice(p,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const h=new E;A.Registry.add(e.Extensions.ThemingContribution,h);function d(b){return h.onColorThemeChange(b)}e.registerThemingParticipant=d;class v extends k.Disposable{constructor(u){super(),this.k=u,this.h=u.getColorTheme(),this.B(this.k.onDidColorThemeChange(p=>this.n(p)))}n(u){this.h=u,this.updateStyles()}updateStyles(){}w(u,p){let g=this.h.getColor(u);return g&&p&&(g=p(g,this.h)),g?g.toString():null}}e.Themable=v}),define(te[66],ie([0,1,13,3,2,4,18,5,36]),function(V,e,I,t,k,R,A,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const m="#FFFFFF",y="#1E1E1E",P="#000000",E="#FFFFFF",h="theme",d="themeBackground",v="windowSplash";e.IThemeMainService=(0,C.createDecorator)("themeMainService");let b=class extends k.Disposable{constructor(p,g){super(),this.b=p,this.c=g,this.a=this.B(new t.Emitter),this.onDidChangeColorScheme=this.a.event,I.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(I.nativeTheme.shouldUseInvertedColorScheme||I.nativeTheme.shouldUseHighContrastColors)return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&I.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:I.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const p=this.getColorScheme();if(p.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return p.dark?P:E;let g=this.b.getItem(d,null);if(!g)switch(this.b.getItem(h,"vs-dark").split(" ")[0]){case"vs":g=m;break;case"hc-black":g=P;break;case"hc-light":g=E;break;default:g=y}return R.isMacintosh&&g.toUpperCase()===y&&(g="#171717"),g}saveWindowSplash(p,g){this.b.setItems([{key:h,data:g.baseTheme},{key:d,data:g.colorInfo.background},{key:v,data:g}]),typeof p=="number"&&this.f(p,g)}f(p,g){for(const f of I.BrowserWindow.getAllWindows())if(f.id===p){f.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(v)}};b=pe([ne(0,w.IStateMainService),ne(1,A.IConfigurationService)],b),e.ThemeMainService=b}),define(te[114],ie([0,1,3,18,5,6]),function(V,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var A;(function(v){v.Http="http",v.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var C;(function(v){v.ConstantPrivate="constantPrivate",v.Private="private",v.Public="public"})(C=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function m(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const b=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(!!b)return{address:b[1],port:+b[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=y,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=P;function E(v,b,u,p){if(u===1)return!1;if(u===2&&P(b)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(p);if(g?.length===4&&parseInt(g[1])>=18)return!1}return v<1024}e.isPortPrivileged=E;class h{constructor(b,u,p){this.remoteAddress=b,this.localAddress=u,this.b=p,this.a=new I.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=h;let d=class{constructor(b,u){this.i=b,this.j=u,this.a=new I.Emitter,this.onTunnelOpened=this.a.event,this.b=new I.Emitter,this.onTunnelClosed=this.b.event,this.c=new I.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const b=this.j.getValue("remote.localPortHost");return!b||b==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(b){return this.e=b,b?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(b){this.f=b.elevation,this.g=b.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const b=[],u=Array.from(this.d.values());for(const p of u){const g=Array.from(p.values());for(const f of g){const l=await f.value;l&&b.push(l)}}return b}async dispose(){for(const b of this.d.values()){for(const{value:u}of b.values())await u.then(p=>p?.dispose());b.clear()}this.d.clear()}setEnvironmentTunnel(b,u,p,g,f){this.o(b,u,Promise.resolve({tunnelRemoteHost:b,tunnelRemotePort:u,localAddress:p,privacy:g,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(b,u){(P(b)||y(b))&&(b=e.LOCALHOST_ADDRESSES[0]);const p=this.q(b,u);if(p)return++p.refcount,p.value}openTunnel(b,u,p,g,f=!1,l,i){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${p} on local port ${g}.`),!b)return;if(u||(u="localhost"),this.e&&this.h.has(p)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.r(b,u,p,g,f,l,i);return s?s.then(n=>{if(!n){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,p);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.m(n);return(n.tunnelRemoteHost!==u||n.tunnelRemotePort!==p)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(a),a}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}m(b){return{tunnelRemotePort:b.tunnelRemotePort,tunnelRemoteHost:b.tunnelRemoteHost,tunnelLocalPort:b.tunnelLocalPort,localAddress:b.localAddress,privacy:b.privacy,protocol:b.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${b.tunnelRemoteHost}:${b.tunnelRemotePort} `);const u=this.d.get(b.tunnelRemoteHost);if(u){const p=u.get(b.tunnelRemotePort);p&&(p.refcount--,await this.n(b.tunnelRemoteHost,b.tunnelRemotePort,p))}}}}async n(b,u,p){if(p.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${b}:${u}.`);const g=p.value.then(async f=>{f&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.d.has(b)&&this.d.get(b).delete(u),g}}async closeTunnel(b,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${b}:${u} `);const p=this.d.get(b);if(p&&p.has(u)){const g=p.get(u);g.refcount=0,await this.n(b,u,g)}}o(b,u,p){this.d.has(b)||this.d.set(b,new Map),this.d.get(b).set(u,{refcount:1,value:p})}async p(b,u){const p=this.d.get(b);p&&(await p.get(u)||p.delete(u),p.size===0&&this.d.delete(b))}q(b,u){const p=[b];y(b)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):P(b)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const g=p.map(f=>this.d.get(f));for(const f of g){const l=f?.get(u);if(l)return l}}canTunnel(b){return!!m(b)}s(b,u,p,g,f,l,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${p} on local port ${g}.`);const s=p;this.h.add(s);const n=g===void 0?p:g,a={elevationRequired:f?this.isPortPrivileged(n):!1},r={remoteAddress:{host:u,port:p},localAddressPort:g,privacy:l,public:l?l!==C.Private:void 0,protocol:i},c=b.forwardPort(r,a);return c?(this.o(u,p,c),c.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(s)})):this.h.delete(s),c}};d=pe([ne(0,R.ILogService),ne(1,t.IConfigurationService)],d),e.AbstractTunnelService=d}),define(te[240],ie([0,1,78,25,97,222,8,2,18,6,19,221,114,88,4]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function v(f,l,i,s,n){let a;for(let r=3;r&&(a?.dispose(),a=await new b(f,l,i,s,n).waitForReady(),!(n&&k.BROWSER_RESTRICTED_PORTS[n]||!k.BROWSER_RESTRICTED_PORTS[a.tunnelLocalPort]));r--);return a}class b extends C.Disposable{constructor(l,i,s,n,a){super(),this.j=i,this.k=a,this.privacy=E.TunnelPrivacyId.Private,this.i=new Map,this.a=l,this.b=I.createServer(),this.c=new A.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=r=>this.l(r),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(i=>{i()})}async waitForReady(){const l=this.k??this.tunnelRemotePort,i=(0,E.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let s=await(0,k.findFreePortFaster)(l,2,1e3,i),n=null;return this.b.listen(s,this.j),await this.c.wait(),n=this.b.address(),n||(s=0,this.b.listen(s,this.j),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async l(l){l.pause();const i=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,P.connectRemoteAgentTunnel)(this.a,i,this.tunnelRemotePort),n=s.getSocket().socket,a=s.readEntireBuffer();s.dispose(),a.byteLength>0&&l.write(a.buffer),l.on("end",()=>{l.localAddress&&this.i.delete(l.localAddress),n.end()}),l.on("close",()=>n.end()),l.on("error",()=>{l.localAddress&&this.i.delete(l.localAddress),n.destroy()}),n.on("end",()=>l.end()),n.on("close",()=>l.end()),n.on("error",()=>{l.destroy()}),l.pipe(n),n.pipe(l),l.localAddress&&this.i.set(l.localAddress,()=>{l.end(),n.end()})}}let u=class extends E.AbstractTunnelService{constructor(l,i,s,n,a){super(i,a),this.t=l,this.u=s,this.v=n}isPortPrivileged(l){return(0,E.isPortPrivileged)(l,this.k,d.OS,t.release())}r(l,i,s,n,a,r,c){const o=this.q(i,s);if(o)return++o.refcount,o.value;if(this.e)return this.s(this.e,i,s,n,a,r,c);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${i}:${s} on local port ${n}.`);const S={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:l,signService:this.u,logService:this.i,ipcLogger:null},D=v(S,this.k,i,s,n);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(i,s,D),D}}};u=pe([ne(1,m.ILogService),ne(2,h.ISignService),ne(3,y.IProductService),ne(4,w.IConfigurationService)],u),e.BaseTunnelService=u;let p=class extends u{constructor(l,i,s,n){super(R.nodeSocketFactory,l,i,s,n)}};p=pe([ne(0,m.ILogService),ne(1,h.ISignService),ne(2,y.IProductService),ne(3,w.IConfigurationService)],p),e.TunnelService=p;let g=class extends C.Disposable{constructor(l,i,s,n){super(),this.b=l,this.c=i,this.f=s,this.g=n,this.a=new Map}async openTunnel(l,i,s,n,a,r,c,o){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${n} on local port ${a}.`),!this.a.has(l)){const S=new p(this.b,this.f,this.c,this.g);this.B(S),this.a.set(l,S),S.onTunnelClosed(async()=>{(await S.tunnels).length===0&&(S.dispose(),this.a.delete(l))})}return this.a.get(l).openTunnel(i,s,n,a,r,c,o)}};g=pe([ne(0,m.ILogService),ne(1,y.IProductService),ne(2,h.ISignService),ne(3,w.IConfigurationService)],g),e.SharedTunnelsService=g}),define(te[49],ie([0,1,5]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var k;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(k=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,A)=>({type:"idle",updateType:R,error:A}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,I.createDecorator)("updateService")}),define(te[241],ie([0,1,4,169,65,48]),function(V,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(k.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:I.isWindows&&!I.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(te[242],ie([0,1,3,49]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class k{constructor(C){this.a=C}listen(C,w){switch(w){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${w}`)}call(C,w,m){switch(w){case"checkForUpdates":return this.a.checkForUpdates(m);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(m)}throw new Error(`Call not found: ${w}`)}}e.UpdateChannel=k;class R{get state(){return this.b}set state(C){this.b=C,this.a.fire(C)}constructor(C){this.c=C,this.a=new I.Emitter,this.onStateChange=this.a.event,this.b=t.State.Uninitialized,this.c.listen("onStateChange")(w=>this.state=w),this.c.call("_getInitialState").then(w=>this.state=w)}checkForUpdates(C){return this.c.call("checkForUpdates",C)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(C){return this.c.call("_applySpecificUpdate",C)}}e.UpdateChannelClient=R}),define(te[90],ie([0,1,8,22,3,18,27,21,6,19,55,49]),function(V,e,I,t,k,R,A,C,w,m,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function E(d,v,b){return`${b.updateUrl}/api/update/${d}/${v}/${b.commit}`}e.createUpdateURL=E;let h=class{get state(){return this.b}d(v){this.j.info("update#setState",v.type),this.b=v,this.c.fire(v)}constructor(v,b,u,p,g,f){this.f=v,this.g=b,this.h=u,this.i=p,this.j=g,this.k=f,this.b=P.State.Uninitialized,this.c=new k.Emitter,this.onStateChange=this.c.event}async initialize(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const v=this.l(),b=this.m(v);if(!b){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(b),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(P.State.Idle(this.q())),v==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}v==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,u=>this.j.error(u))}l(){return(0,R.getMigratedSettingValue)(this.g,"update.mode","update.channel")}m(v){return v==="none"?void 0:this.k.quality}n(v=60*60*1e3){return(0,I.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(v){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(v)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(v){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){return this.a?await this.l()==="none"?!1:(await this.i.request({url:this.a},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(v){}q(){return 1}r(){}};h=pe([ne(0,C.ILifecycleMainService),ne(1,R.IConfigurationService),ne(2,A.IEnvironmentMainService),ne(3,y.IRequestService),ne(4,w.ILogService),ne(5,m.IProductService)],h),e.AbstractUpdateService=h}),define(te[243],ie([0,1,13,53,3,2,18,27,21,6,19,55,31,49,90]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let v=class extends d.AbstractUpdateService{get v(){return k.Event.fromNodeEventEmitter(I.autoUpdater,"error",(u,p)=>p)}get w(){return k.Event.fromNodeEventEmitter(I.autoUpdater,"update-not-available")}get x(){return k.Event.fromNodeEventEmitter(I.autoUpdater,"update-available",(u,p,g)=>({url:p,version:g,productVersion:g}))}get y(){return k.Event.fromNodeEventEmitter(I.autoUpdater,"update-downloaded",(u,p,g,f)=>({releaseNotes:p,version:g,productVersion:g,date:f}))}constructor(u,p,g,f,l,i,s){super(u,p,f,l,i,s),this.z=g,this.u=new R.DisposableStore}async initialize(){await super.initialize(),this.v(this.A,this,this.u),this.x(this.D,this,this.u),this.y(this.E,this,this.u),this.w(this.F,this,this.u)}A(u){this.j.error("UpdateService error:",u);const g=(this.state.type==="checking for updates"?this.state.explicit:!0)?u:void 0;this.d(h.State.Idle(1,g))}s(u){let p;this.k.darwinUniversalAssetId?p=this.k.darwinUniversalAssetId:p=process.arch==="x64"?"darwin":"darwin-arm64";const g=(0,d.createUpdateURL)(p,u,this.k);try{I.autoUpdater.setFeedURL({url:g})}catch(f){this.j.error("Failed to set update feed URL",f);return}return g}t(u){this.d(h.State.CheckingForUpdates(u)),I.autoUpdater.checkForUpdates()}D(u){this.state.type==="checking for updates"&&this.d(h.State.Downloading(u))}E(u){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:u.version}),this.d(h.State.Ready(u)))}F(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(h.State.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),I.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};pe([t.memoize],v.prototype,"v",null),pe([t.memoize],v.prototype,"w",null),pe([t.memoize],v.prototype,"x",null),pe([t.memoize],v.prototype,"y",null),v=pe([ne(0,w.ILifecycleMainService),ne(1,A.IConfigurationService),ne(2,E.ITelemetryService),ne(3,C.IEnvironmentMainService),ne(4,P.IRequestService),ne(5,m.ILogService),ne(6,y.IProductService)],v),e.DarwinUpdateService=v}),define(te[244],ie([0,1,46,40,8,3,9,27,21,6,31,49]),function(V,e,I,t,k,R,A,C,w,m,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let E=class{get state(){return this.a}d(v){this.g.info("update#setState",v.type),this.a=v,this.b.fire(v)}constructor(v,b,u){if(this.f=v,this.g=u,this.a=P.State.Uninitialized,this.b=new R.Emitter,this.onStateChange=this.b.event,b.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(P.State.Idle(this.k())),this.h(30*1e3).then(void 0,p=>this.g.error(p))}h(v=60*60*1e3){return(0,k.timeout)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(v){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(v)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(v){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(v){}};E=pe([ne(0,w.ILifecycleMainService),ne(1,C.IEnvironmentMainService),ne(2,m.ILogService)],E);let h=class extends E{constructor(v,b,u,p,g,f){super(u,p,g),this.o=v,this.p=b,this.q=f;const l=(0,t.watch)(A.dirname(this.o)),i=R.Event.fromNodeEventEmitter(l,"change",(r,c)=>c),s=R.Event.filter(i,r=>r==="current"),a=R.Event.debounce(s,(r,c)=>c,2e3)(()=>this.checkForUpdates(!1));u.onWillShutdown(()=>{a.dispose(),l.close()})}m(){this.d(P.State.CheckingForUpdates(!1)),this.u().then(v=>{v?this.d(P.State.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(P.State.Idle(2)))},v=>{this.g.error(v),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(P.State.Idle(2,v.message||v))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,I.spawn)("sleep 3 && "+A.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const v=await new Promise((u,p)=>(0,t.realpath)(`${A.dirname(this.o)}/current`,(g,f)=>g?p(g):u(f))),b=A.basename(v);return this.p!==b}isLatestVersion(){return this.u().then(void 0,v=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};h=pe([ne(2,w.ILifecycleMainService),ne(3,C.IEnvironmentMainService),ne(4,m.ILogService),ne(5,y.ITelemetryService)],h),e.SnapUpdateService=h}),define(te[42],ie([0,1,5]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,I.createDecorator)("IUriIdentityService")}),define(te[245],ie([0,1,42,190,16,20,126,3,2]),function(V,e,I,t,k,R,A,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class m{constructor(E){this.uri=E,this.time=m._clock++}touch(){return this.time=m._clock++,this}}m._clock=0;let y=class{constructor(E){this.g=E,this.c=new w.DisposableStore,this.f=2**16;const h=new Map,d=v=>{let b=h.get(v.scheme);return b===void 0&&(b=E.hasProvider(v)&&!this.g.hasCapability(v,1024),h.set(v.scheme,b)),b};this.c.add(C.Event.any(E.onDidChangeFileSystemProviderRegistrations,E.onDidChangeFileSystemProviderCapabilities)(v=>{h.delete(v.scheme)})),this.extUri=new R.ExtUri(d),this.d=new A.SkipList((v,b)=>this.extUri.compare(v,b,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(E){this.g.hasProvider(E)&&(E=(0,R.normalizePath)(E));const h=this.d.get(E);return h?h.touch().uri.with({fragment:E.fragment}):(this.d.set(E,new m(E)),this.h(),E)}h(){if(this.d.size<this.f)return;const E=[...this.d.entries()].sort((d,v)=>d[1].touch<v[1].touch?1:d[1].touch>v[1].touch?-1:0);m._clock=0,this.d.clear();const h=this.f*.5;for(let d=0;d<h;d++)this.d.set(E[d][0],E[d][1].touch())}};y=pe([ne(0,k.IFileService)],y),e.UriIdentityService=y,(0,t.registerSingleton)(I.IUriIdentityService,y,1)}),define(te[115],ie([0,1,5]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,I.createDecorator)("urlService")}),define(te[246],ie([0,1,7]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(C){this.a=C}listen(C,w){throw new Error(`Event not found: ${w}`)}call(C,w,m){switch(w){case"handleURL":return this.a.handleURL(I.URI.revive(m[0]),m[1])}throw new Error(`Call not found: ${w}`)}}e.URLHandlerChannel=t;class k{constructor(C){this.a=C}handleURL(C,w){return this.a.call("handleURL",[C.toJSON(),w])}}e.URLHandlerChannelClient=k;class R{constructor(C){this.a=C}async routeCall(C,w,m,y){if(w!=="handleURL")throw new Error(`Call not found: ${w}`);if(m){const P=I.URI.revive(m);if(P&&P.query){const E=/\bwindowId=(\d+)/.exec(P.query);if(E){const h=E[1],d=new RegExp(`window:${h}`),v=C.connections.find(b=>d.test(b.ctx));if(v)return v}}}return this.a.routeCall(C,w,m,y)}routeEvent(C,w){throw new Error(`Event not found: ${w}`)}}e.URLHandlerRouter=R}),define(te[247],ie([0,1,8,2,7,19]),function(V,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class A extends t.Disposable{constructor(){super(...arguments),this.a=new Set}open(m,y){const P=[...this.a.values()];return(0,I.first)(P.map(E=>()=>E.handleURL(m,y)),void 0,!1).then(E=>E||!1)}registerHandler(m){return this.a.add(m),(0,t.toDisposable)(()=>this.a.delete(m))}}e.AbstractURLService=A;let C=class extends A{constructor(m){super(),this.b=m}create(m){let{authority:y,path:P,query:E,fragment:h}=m||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return y&&P&&P.indexOf("/")!==0&&(P=`/${P}`),k.URI.from({scheme:this.b.urlProtocol,authority:y,path:P,query:E,fragment:h})}};C=pe([ne(0,R.IProductService)],C),e.NativeURLService=C}),define(te[248],ie([0,1,13,8,3,2,4,7]),function(V,e,I,t,k,R,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function w(y){try{return C.URI.parse(y)}catch{return null}}class m{constructor(P,E,h,d,v){if(this.f=E,this.a=[],this.b=0,this.c=R.Disposable.None,this.d=new R.DisposableStore,this.a=P,A.isWindows){const p=d.isBuilt?[]:[`"${d.appRoot}"`];p.push("--open-url","--"),I.app.setAsDefaultProtocolClient(v.urlProtocol,process.execPath,p)}const b=k.Event.map(k.Event.fromNodeEventEmitter(I.app,"open-url",(p,g)=>({event:p,url:g})),({event:p,url:g})=>(p.preventDefault(),g));this.d.add(b(p=>{const g=w(p);!g||this.f.open(g,{originalUrl:p})})),h.getWindows().filter(p=>p.isReady).length>0?this.g():k.Event.once(h.onDidSignalReadyWindow)(this.g,this,this.d)}async g(){if(this.b++>10)return;const P=[];for(const E of this.a)await this.f.open(E.uri,{originalUrl:E.url})||P.push(E);P.length!==0&&(this.a=P,this.c=(0,t.disposableTimeout)(()=>this.g(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.ElectronURLListener=m}),define(te[249],ie([0,1,5]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,I.createDecorator)("webviewManagerService")}),define(te[250],ie([0,1,13,2,15,7]),function(V,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class A extends t.Disposable{constructor(){super();const w=this.b.bind(this);I.protocol.registerFileProtocol(k.Schemas.vscodeWebview,w)}b(w,m){try{const y=R.URI.parse(w.url),P=A.a.get(y.path);if(typeof P=="string"){const E=`vs/workbench/contrib/webview/browser/pre/${P}`,h=k.FileAccess.asFileUri(E);return m({path:decodeURIComponent(h.fsPath),headers:{...k.COI.getHeadersFromQuery(w.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return m({error:-10})}catch{}return m({error:-2})}}e.WebviewProtocolProvider=A,A.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(te[74],ie([0,1,4]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(y){return!!y.workspaceUri}e.isWorkspaceToOpen=t;function k(y){return!!y.folderUri}e.isFolderToOpen=k;function R(y){return!!y.fileUri}e.isFileToOpen=R;function A(y){const P=C(y),E=y.getValue("window.menuBarVisibility");return E==="default"||P==="native"&&E==="compact"||I.isMacintosh&&I.isNative?"classic":E}e.getMenuBarVisibility=A;function C(y){if(I.isWeb)return"custom";const P=y.getValue("window");if(P){if(I.isMacintosh&&P.nativeTabs===!0||I.isMacintosh&&P.nativeFullScreen===!1)return"native";const d=P.titleBarStyle;if(d==="native"||d==="custom")return d}return I.isLinux?"native":"custom"}e.getTitleBarStyle=C;function w(y){if(!I.isWindows||I.isWeb||C(y)==="native")return!1;const P=y.getValue("window.experimental.windowControlsOverlay.enabled");return typeof P=="boolean"?P:!0}e.useWindowControlsOverlay=w;function m(y=0){return Math.pow(1.2,y)}e.zoomLevelToZoomFactor=m}),define(te[116],ie([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var I;(function(C){C[C.INITIAL=1]="INITIAL",C[C.LOAD=2]="LOAD",C[C.RELOAD=3]="RELOAD"})(I=e.LoadReason||(e.LoadReason={}));var t;(function(C){C[C.CLOSE=1]="CLOSE",C[C.QUIT=2]="QUIT",C[C.RELOAD=3]="RELOAD",C[C.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const k=function(C=1){return{width:1024,height:768,mode:C}};e.defaultWindowState=k;var R;(function(C){C[C.Maximized=0]="Maximized",C[C.Normal=1]="Normal",C[C.Minimized=2]="Minimized",C[C.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var A;(function(C){C[C.UNRESPONSIVE=1]="UNRESPONSIVE",C[C.PROCESS_GONE=2]="PROCESS_GONE",C[C.LOAD=3]="LOAD"})(A=e.WindowError||(e.WindowError={}))}),define(te[32],ie([0,1,5]),function(V,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,I.createDecorator)("windowsMainService");var t;(function(k){k[k.CLI=0]="CLI",k[k.DOCK=1]="DOCK",k[k.MENU=2]="MENU",k[k.DIALOG=3]="DIALOG",k[k.DESKTOP=4]="DESKTOP",k[k.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(te[251],ie([0,1,13,22,3,68,2,29,71,106,6,19,32]),function(V,e,I,t,k,R,A,C,w,m,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var h;(function(v){v[v.Initial=1]="Initial",v[v.StoredCredentialsUsed=2]="StoredCredentialsUsed",v[v.LoginDialogShown=3]="LoginDialogShown"})(h||(h={}));let d=class extends A.Disposable{constructor(b,u,p,g,f){super(),this.g=b,this.h=u,this.i=p,this.j=g,this.k=f,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=h.Initial,this.f=void 0,this.l()}l(){const b=k.Event.fromNodeEventEmitter(I.app,"login",(u,p,g,f,l)=>({event:u,webContents:p,req:g,authInfo:f,callback:l}));this.B(b(this.m,this))}async m({event:b,authInfo:u,req:p,callback:g}){if(!u.isProxy)return;if(!this.b&&this.c===h.LoginDialogShown&&p.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let f;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),f=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(u);try{f=await this.b}finally{this.b=void 0}}g(f?.username,f?.password)}async n(b){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const u=await this.p(b);if(u)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),u;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(b){this.g.trace("auth#doResolveProxyCredentials - enter",b);const u=String((0,R.hash)({scheme:b.scheme,host:b.host,port:b.port}));let p,g;try{const s=await this.i.getPassword(this.a,u);if(s){const n=JSON.parse(await this.j.decrypt(s));p=n.username,g=n.password}}catch(s){this.g.error(s)}if(this.c!==h.StoredCredentialsUsed&&typeof p=="string"&&typeof g=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=h.StoredCredentialsUsed,{username:p,password:g};const f=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!f){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${f.id} to handle proxy login`);const l={authInfo:b,username:this.f?.username??p,password:this.f?.password??g,replyChannel:`vscode:proxyAuthResponse:${(0,C.generateUuid)()}`};f.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,l),this.c=h.LoginDialogShown;const i=await new Promise(s=>{const n=async(a,r,c)=>{if(r===l.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${f.id}`),f.win?.webContents.off("ipc-message",n),c){const o={username:c.username,password:c.password};try{if(c.remember){const S=await this.j.encrypt(JSON.stringify(o));await this.i.setPassword(this.a,u,S)}else await this.i.deletePassword(this.a,u)}catch(S){this.g.error(S)}s({username:o.username,password:o.password})}else s(void 0)};f.win?.webContents.on("ipc-message",n)});return this.f=i,i}};d=pe([ne(0,y.ILogService),ne(1,E.IWindowsMainService),ne(2,w.ICredentialsMainService),ne(3,m.IEncryptionMainService),ne(4,P.IProductService)],d),e.ProxyAuthHandler=d}),define(te[252],ie([0,1,71,6,35,19,32,202]),function(V,e,I,t,k,R,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let w=class extends C.BaseCredentialsMainService{constructor(y,P,E,h){super(y),this.j=P,this.k=E,this.l=h,this.i=d=>{this.l.sendToFocused("vscode:showCredentialsError",d.message??d)}}async getSecretStoragePrefix(){return Promise.resolve(this.k.urlProtocol)}async h(){if(this.f)return this.f;if(this.j.disableKeytar)return this.g.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new I.InMemoryCredentialsProvider,this.f;const y=await new Promise((P,E)=>{V(["keytar"],P,E)});return await y.findCredentials("test-keytar-loads"),this.f=y,this.f}};w=pe([ne(0,t.ILogService),ne(1,k.INativeEnvironmentService),ne(2,R.IProductService),ne(3,A.IWindowsMainService)],w),e.CredentialsNativeMainService=w}),define(te[253],ie([0,1,14,2,3,6,21,80,46,283,8,15,44,4,33,13,32]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h,d,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const u=v.utilityProcess,p=typeof u<"u";let g=class Nt{constructor(s,n,a){this.d=s,this.f=a,this.c=!1,this.b=new Map,n.onWillShutdown(r=>{this.c=!0,r.join(this._waitForAllExit(6e3))})}dispose(){}g(s){const n=this.b.get(s);if(!n)throw new Error("Unknown extension host!");return n}onDynamicStdout(s){return this.g(s).onStdout}onDynamicStderr(s){return this.g(s).onStderr}onDynamicMessage(s){return this.g(s).onMessage}onDynamicError(s){return this.g(s).onError}onDynamicExit(s){return this.g(s).onExit}async canUseUtilityProcess(){return p}async createExtensionHost(s){if(this.c)throw(0,I.canceled)();const n=String(++Nt.a);let a;if(s){if(!p)throw new Error("Cannot use UtilityProcess!");a=new l(n,this.d,this.f)}else a=new f(n,this.d);return this.b.set(n,a),a.onExit(({pid:r,code:c,signal:o})=>{this.d.info(`Extension host with pid ${r} exited with code: ${c}, signal: ${o}.`),setTimeout(()=>{a.dispose(),this.b.delete(n)})}),{id:n}}async start(s,n){if(this.c)throw(0,I.canceled)();return this.g(s).start(n)}async enableInspectPort(s){if(this.c)throw(0,I.canceled)();const n=this.b.get(s);return n?n.enableInspectPort():!1}async kill(s){if(this.c)throw(0,I.canceled)();const n=this.b.get(s);!n||n.kill()}async _killAllNow(){for(const[,s]of this.b)s.kill()}async _waitForAllExit(s){const n=[];for(const[,a]of this.b)n.push(a.waitForExit(s));return y.Promises.settled(n).then(()=>{})}};g.a=0,g=pe([ne(0,R.ILogService),ne(1,A.ILifecycleMainService),ne(2,b.IWindowsMainService)],g),e.ExtensionHostStarter=g;let f=class extends t.Disposable{constructor(s,n){super(),this.id=s,this.c=n,this._onStdout=this.B(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new k.Emitter),this.onMessage=this._onMessage.event,this._onError=this.B(new k.Emitter),this.onError=this._onError.event,this._onExit=this.B(new k.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(s){h.isCI&&this.c.info("Calling fork to start extension host...");const n=C.StopWatch.create(!1);this.a=(0,w.fork)(P.FileAccess.asFileUri("bootstrap-fork").fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,E.mixin)({cwd:(0,d.cwd)()},s));const a=n.elapsed(),r=this.a.pid;this.c.info(`Starting extension host with pid ${r} (fork() took ${a} ms).`);const c=new m.StringDecoder("utf-8");this.a.stdout?.on("data",S=>{const D=typeof S=="string"?S:c.write(S);this._onStdout.fire(D)});const o=new m.StringDecoder("utf-8");this.a.stderr?.on("data",S=>{const D=typeof S=="string"?S:o.write(S);this._onStderr.fire(D)}),this.a.on("message",S=>{this._onMessage.fire(S)}),this.a.on("error",S=>{this._onError.fire({error:(0,I.transformErrorForSerialization)(S)})}),this.a.on("exit",(S,D)=>{this.b=!0,this._onExit.fire({pid:r,code:S,signal:D})})}enableInspectPort(){return this.a?(this.c.info(`Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):h.isWindows?!1:(this.a.kill("SIGUSR1"),!0)):!1}kill(){!this.a||(this.c.info(`Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(s){if(!this.a)return;const n=this.a.pid;this.c.info(`Waiting for extension host with pid ${n} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,y.timeout)(s)]),this.b||(this.c.info(`Extension host with pid ${n} did not exit within ${s}ms.`),this.a.kill())}};f=pe([ne(1,R.ILogService)],f);let l=class extends t.Disposable{constructor(s,n,a){super(),this.id=s,this.c=n,this.f=a,this.onError=k.Event.None,this._onStdout=this.B(new k.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new k.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new k.Emitter),this.onMessage=this._onMessage.event,this._onExit=this.B(new k.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(s){const n=this.f.getWindowById(s.responseWindowId);if(!n){this.c.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const a=n.win;if(!a||a.isDestroyed()||a.webContents.isDestroyed()){this.c.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const r=`extensionHost${this.id}`,c=P.FileAccess.asFileUri("bootstrap-fork.js").fsPath,o=["--type=extensionHost","--skipWorkspaceStorageLock"],S=s.execArgv||[],D={...s.env},L=!0,N="pipe";for(const re of Object.keys(D))D[re]=String(D[re]);this.c.info(`UtilityProcess<${this.id}>: Creating new...`),this.a=u.fork(c,o,{serviceName:r,env:D,execArgv:S,allowLoadingUnsignedLibraries:L,stdio:N});const X=new m.StringDecoder("utf-8");this.a.stdout?.on("data",re=>{const fe=typeof re=="string"?re:X.write(re);this._onStdout.fire(fe)});const ae=new m.StringDecoder("utf-8");this.a.stderr?.on("data",re=>{const fe=typeof re=="string"?re:ae.write(re);this._onStderr.fire(fe)}),this.a.on("message",re=>{this._onMessage.fire(re)}),this.B(k.Event.fromNodeEventEmitter(this.a,"spawn")(()=>{this.c.info(`UtilityProcess<${this.id}>: received spawn event.`)}));const J=k.Event.fromNodeEventEmitter(this.a,"exit",re=>re);this.B(J(re=>{this.c.info(`UtilityProcess<${this.id}>: received exit event with code ${re}.`),this.b=!0,this._onExit.fire({pid:this.a.pid,code:re,signal:""})}));const{port1:Y,port2:se}=new v.MessageChannelMain;this.a.postMessage("null",[se]),a.webContents.postMessage(s.responseChannel,s.responseNonce,[Y])}enableInspectPort(){return this.a?(this.c.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):!1):!1}kill(){!this.a||(this.c.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(s){if(!this.a)return;const n=this.a.pid;this.c.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${n} to exit.`),await Promise.race([k.Event.toPromise(this.onExit),(0,y.timeout)(s)]),this.b||(this.c.info(`UtilityProcess<${this.id}>: Extension host with pid ${n} did not exit within ${s}ms, will kill it now.`),this.a.kill())}};l=pe([ne(1,R.ILogService),ne(2,b.IWindowsMainService)],l)}),define(te[254],ie([0,1,13,24,4,7,23,18,61,5,6,115,32]),function(V,e,I,t,k,R,A,C,w,m,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,m.createDecorator)(e.ID);let h=class{constructor(v,b,u,p){this.a=v,this.b=b,this.c=u,this.d=p}async start(v,b){this.a.trace("Received data from other instance: ",v,b),k.isMacintosh&&I.app.focus({steal:!0});const u=this.e(v);if(u.length){let p=Promise.resolve();if(this.b.getWindowCount()===0){const g=(0,t.firstOrDefault)(await this.b.openEmptyWindow({context:4}));g&&(p=g.ready())}p.then(()=>{for(const{uri:g,url:f}of u)this.c.open(g,{originalUrl:f})})}else return this.f(v,b)}e(v){return v["open-url"]&&v._urls&&v._urls.length>0?(0,t.coalesce)(v._urls.map(b=>{try{return{uri:R.URI.parse(b),url:b}}catch{return null}})):[]}async f(v,b){const u=(0,w.isLaunchedFromCli)(b)?0:4;let p=[];const g=v.wait&&v.waitMarkerFilePath?R.URI.file(v.waitMarkerFilePath):void 0,f=v.remote||void 0,l={context:u,cli:v,userEnv:b,waitMarkerFileURI:g,remoteAuthority:f,forceProfile:v.profile,forceTempProfile:v["profile-temp"]};if(v.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(v.extensionDevelopmentPath,l);else if(!v._.length&&!v["folder-uri"]&&!v["file-uri"]){let i=!1;if(v["new-window"]||v["unity-launch"]||l.forceProfile||l.forceTempProfile)i=!0;else if(v["reuse-window"])i=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!k.isMacintosh}if(i)p=await this.b.open({...l,forceNewWindow:!0,forceEmpty:!0});else{const s=this.b.getLastActiveWindow();s?(this.b.openExistingWindow(s,l),p=[s]):p=await this.b.open({...l,forceEmpty:!0})}}else p=await this.b.open({...l,forceNewWindow:v["new-window"],preferNewWindow:!v["reuse-window"]&&!v.wait,forceReuseWindow:v["reuse-window"],diffMode:v.diff,mergeMode:v.merge,addMode:v.add,noRecentEntry:!!v["skip-add-to-recently-opened"],gotoLineMode:v.goto});if(g&&p.length===1&&p[0])return Promise.race([p[0].whenClosedOrLoaded,(0,A.whenDeleted)(g.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};h=pe([ne(0,y.ILogService),ne(1,E.IWindowsMainService),ne(2,P.IURLService),ne(3,C.IConfigurationService)],h),e.LaunchMainService=h}),define(te[255],ie([0,1,13,3,2,250,32]),function(V,e,I,t,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let C=class extends k.Disposable{constructor(m){super(),this.b=m,this.a=this.B(new t.Emitter),this.onFoundInFrame=this.a.event,this.B(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(m,y){let P;if(typeof m.windowId=="number"){const{windowId:E}=m,h=this.b.getWindowById(E);if(!h?.win)throw new Error(`Invalid windowId: ${E}`);P=h.win.webContents}else{const{webContentsId:E}=m;if(P=I.webContents.fromId(E),!P)throw new Error(`Invalid webContentsId: ${E}`)}P.isDestroyed()||P.setIgnoreMenuShortcuts(y)}async findInFrame(m,y,P,E){const d=this.c(m,y);if(typeof d.findInFrame=="function"){d.findInFrame(P,{findNext:E.findNext,forward:E.forward});const v=(b,u)=>{u.finalUpdate&&(this.a.fire(u),d.removeListener("found-in-frame",v))};d.on("found-in-frame",v)}}async stopFindInFrame(m,y,P){const h=this.c(m,y);typeof h.stopFindInFrame=="function"&&h.stopFindInFrame(P.keepSelection?"keepSelection":"clearSelection")}c(m,y){const P=this.b.getWindowById(m.windowId);if(!P?.win)throw new Error(`Invalid windowId: ${m}`);const E=P.win.webContents.mainFrame.framesInSubtree.find(h=>h.name===y);if(!E)throw new Error(`Unknown frame: ${y}`);return E}};C=pe([ne(0,A.IWindowsMainService)],C),e.WebviewMainService=C}),define(te[256],ie([0,1,8,3,2]),function(V,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends k.Disposable{constructor({onDidOpenWindow:C,onDidFocusWindow:w,getActiveWindowId:m}){super(),this.a=this.B(new k.DisposableStore),t.Event.latch(t.Event.any(C,w))(this.f,this,this.a),this.b=(0,I.createCancelablePromise)(()=>m()),(async()=>{try{const P=await this.b;this.c=typeof this.c=="number"?this.c:P}catch{}finally{this.b=void 0}})()}f(C){this.b&&(this.b.cancel(),this.b=void 0),this.c=C}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=R}),define(te[28],ie([0,1,173,9,60,20,7,5,15]),function(V,e,I,t,k,R,A,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");function m(s){const n=s;return typeof n?.id=="string"&&A.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=m,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function y(s,n){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,t.basename)(s)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const a=s;if(a.configuration)return{id:a.id,configPath:a.configuration};if(a.folders.length===1)return{id:a.id,uri:a.folders[0].uri}}e.toWorkspaceIdentifier=y;function P(s){const n=s;return typeof n?.id=="string"&&A.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=P;function E(s){const n=s;if(n?.uri)return{id:n.id,uri:A.URI.revive(n.uri)};const a=s;if(a?.configPath)return{id:a.id,configPath:A.URI.revive(a.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=E;var h;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(h=e.WorkbenchState||(e.WorkbenchState={}));function d(s){const n=s;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=d;function v(s){const n=s;return!!(n&&typeof n=="object"&&A.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=v;class b{constructor(n,a,r,c,o){this.h=n,this.j=r,this.k=c,this.l=o,this.c=k.TernarySearchTree.forUris(this.l,()=>!0),this.folders=a}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=k.TernarySearchTree.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=b;class u{constructor(n,a){this.raw=a,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,R.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function p(s){return new u({uri:s,index:0,name:(0,R.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function g(s,n){return R.extUriBiasedIgnorePathCase.isEqualOrParent(s,n.untitledWorkspacesHome)}e.isUntitledWorkspace=g;function f(s){let n;return A.URI.isUri(s)?n=s:n=s.configuration,n?.scheme===w.Schemas.tmp}e.isTemporaryWorkspace=f;function l(s,n){return!g(s,n)&&!f(s)}e.isSavedWorkspace=l;function i(s){return(typeof s=="string"?(0,t.extname)(s):(0,R.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(te[57],ie([0,1,13,8,68,34,2,76,4,12,23,150,5,6,28]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,E.createDecorator)("dialogMainService");let v=class{constructor(u){this.d=u,this.a=new Map,this.b=new Map,this.c=new t.Queue}pickFileFolder(u,p){return this.e({...u,pickFolders:!0,pickFiles:!0,title:(0,P.localize)(0,null)},p)}pickFolder(u,p){return this.e({...u,pickFolders:!0,title:(0,P.localize)(1,null)},p)}pickFile(u,p){return this.e({...u,pickFiles:!0,title:(0,P.localize)(2,null)},p)}pickWorkspace(u,p){const g=(0,P.localize)(3,null),f=(0,R.mnemonicButtonLabel)((0,P.localize)(4,null)),l=d.WORKSPACE_FILTER;return this.e({...u,pickFiles:!0,title:g,filters:l,buttonLabel:f},p)}async e(u,p){const g={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters,defaultPath:u.defaultPath};(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(g.properties=void 0,u.pickFiles&&u.pickFolders&&(g.properties=["multiSelections","openDirectory","openFile","createDirectory"])),g.properties||(g.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),w.isMacintosh&&g.properties.push("treatPackageAsDirectory");const f=await this.showOpenDialog(g,(0,m.withNullAsUndefined)(p||I.BrowserWindow.getFocusedWindow()));if(f&&f.filePaths&&f.filePaths.length>0)return f.filePaths}f(u){if(u){let p=this.b.get(u.id);return p||(p=new t.Queue,this.b.set(u.id,p)),p}else return this.c}showMessageBox(u,p){return this.f(p).queue(async()=>p?I.dialog.showMessageBox(p,u):I.dialog.showMessageBox(u))}async showSaveDialog(u,p){const g=this.i(u,p);if(!g)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.f(p).queue(async()=>{let f;return p?f=await I.dialog.showSaveDialog(p,u):f=await I.dialog.showSaveDialog(u),f.filePath=this.g(f.filePath),f})}finally{(0,A.dispose)(g)}}g(u){return u&&w.isMacintosh&&(u=(0,C.normalizeNFC)(u)),u}h(u){return u.map(p=>this.g(p))}async showOpenDialog(u,p){u.defaultPath&&(await y.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const g=this.i(u,p);if(!g)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.f(p).queue(async()=>{let f;return p?f=await I.dialog.showOpenDialog(p,u):f=await I.dialog.showOpenDialog(u),f.filePaths=this.h(f.filePaths),f})}finally{(0,A.dispose)(g)}}i(u,p){if(!p)return A.Disposable.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",u);let g=this.a.get(p.id);g||(g=new Set,this.a.set(p.id,g));const f=(0,k.hash)(u);if(!g.has(f))return this.d.trace("[DialogMainService]: new file dialog lock created",u),g.add(f),(0,A.toDisposable)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",u),g?.delete(f),g?.size===0&&this.a.delete(p.id)})}};v=pe([ne(0,h.ILogService)],v),e.DialogMainService=v}),define(te[257],ie([0,1,3,2,69,28]),function(V,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class A extends t.Disposable{constructor(w,m){super(),this.f=w,this.g=m,this.b=this.B(new I.Emitter),this.c=new Map,this.h(m.applicationStorage,this.b)}h(w,m){this.B(I.Event.debounce(w.onDidChangeStorage,(y,P)=>(y?y.push(P):y=[P],y),A.a)(y=>{y.length&&m.fire(this.i(y,w))}))}i(w,m){const y=new Map,P=new Set;return w.forEach(E=>{const h=m.get(E.key);typeof h=="string"?y.set(E.key,h):P.add(E.key)}),{changed:Array.from(y.entries()),deleted:Array.from(P.values())}}listen(w,m,y){switch(m){case"onDidChangeStorage":{const P=y.profile?(0,k.revive)(y.profile):void 0;if(!P)return this.b.event;let E=this.c.get(P.id);return E||(E=this.B(new I.Emitter),this.h(this.g.profileStorage(P),E),this.c.set(P.id,E)),E.event}}throw new Error(`Event not found: ${m}`)}async call(w,m,y){const P=y.profile?(0,k.revive)(y.profile):void 0,E=(0,R.reviveIdentifier)(y.workspace),h=await this.j(P,E);switch(m){case"getItems":return Array.from(h.items.entries());case"updateItems":{const d=y;if(d.insert)for(const[v,b]of d.insert)h.set(v,b);d.delete?.forEach(v=>h.delete(v));break}case"isUsed":{const d=y.payload;if(typeof d=="string")return this.g.isUsed(d)}default:throw new Error(`Call not found: ${m}`)}}async j(w,m){let y;m?y=this.g.workspaceStorage(m):w?y=this.g.profileStorage(w):y=this.g.applicationStorage;try{await y.init()}catch(P){this.f.error(`StorageIPC#init: Unable to init ${m?"workspace":w?"profile":"application"} storage due to ${P}`)}return y}}e.StorageDatabaseChannel=A,A.a=100}),define(te[38],ie([0,1,68,3,2,20,7,170,35,16,5,6,28,39,42,8,29,26,12]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h,d,v,b,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function g(n){const a=n;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&A.URI.isUri(a.location)&&A.URI.isUri(a.globalStorageHome)&&A.URI.isUri(a.settingsResource)&&A.URI.isUri(a.keybindingsResource)&&A.URI.isUri(a.tasksResource)&&A.URI.isUri(a.snippetsHome)&&A.URI.isUri(a.extensionsResource))}e.isUserDataProfile=g,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,y.createDecorator)("IUserDataProfilesService");function f(n,a){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:A.URI.revive(n.location).with({scheme:a}),globalStorageHome:A.URI.revive(n.globalStorageHome).with({scheme:a}),settingsResource:A.URI.revive(n.settingsResource).with({scheme:a}),keybindingsResource:A.URI.revive(n.keybindingsResource).with({scheme:a}),tasksResource:A.URI.revive(n.tasksResource).with({scheme:a}),snippetsHome:A.URI.revive(n.snippetsHome).with({scheme:a}),extensionsResource:A.URI.revive(n.extensionsResource)?.with({scheme:a}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=f;function l(n,a,r,c){return{id:n,name:a,location:r,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,R.joinPath)(r,"globalStorage"),settingsResource:(0,R.joinPath)(r,"settings.json"),keybindingsResource:(0,R.joinPath)(r,"keybindings.json"),tasksResource:(0,R.joinPath)(r,"tasks.json"),snippetsHome:(0,R.joinPath)(r,"snippets"),extensionsResource:(0,R.joinPath)(r,"extensions.json"),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=l;let i=class extends k.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(a,r,c,o){super(),this.m=a,this.n=r,this.r=c,this.s=o,this.f=!1,this.g=this.B(new t.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new t.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new t.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new t.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new h.ResourceMap},this.profilesHome=(0,R.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(a){this.f!==a&&(this.t=void 0,this.f=a)}isEnabled(){return this.f}get u(){if(!this.t){const a=[];if(this.f)for(const S of this.H()){if(!S.name||!(0,p.isString)(S.name)||!S.location){this.s.warn("Skipping the invalid stored profile",S.location||S.name);continue}a.push(l((0,R.basename)(S.location),S.name,S.location,{shortName:S.shortName,useDefaultFlags:S.useDefaultFlags}))}let r;const c=new h.ResourceMap,o=l((0,I.hash)(this.m.userRoamingDataHome.path).toString(16),(0,C.localize)(0,null),this.m.userRoamingDataHome);if(a.unshift({...o,extensionsResource:this.M()??o.extensionsResource,isDefault:!0}),a.length){const S=this.J();if(S.workspaces)for(const[D,L]of Object.entries(S.workspaces)){const N=A.URI.parse(D),X=A.URI.parse(L),ae=a.find(J=>this.r.extUri.isEqual(J.location,X));ae&&c.set(N,ae)}if(S.emptyWindow){const D=A.URI.parse(S.emptyWindow);r=a.find(L=>this.r.extUri.isEqual(L.location,D))}}this.t={profiles:a,workspaces:c,emptyWindow:r}}return this.t}async createTransientProfile(a){const r="Temp",c=new RegExp(`${(0,u.escapeRegExpCharacters)(r)}\\s(\\d+)`);let o=0;for(const D of this.profiles){const L=c.exec(D.name),N=L?parseInt(L[1]):0;o=N>o?N:o}const S=`${r} ${o+1}`;return this.createProfile((0,I.hash)((0,b.generateUuid)()).toString(16),S,{transient:!0},a)}async createNamedProfile(a,r,c){return this.createProfile((0,I.hash)((0,b.generateUuid)()).toString(16),a,r,c)}async createProfile(a,r,c,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const S=await this.v(a,r,c);return o&&await this.setProfileForWorkspace(o,S),S}async v(a,r,c){if(!(0,p.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let o=this.k.get(r);return o||(o=(async()=>{try{const S=this.profiles.find(N=>N.name===r||N.id===a);if(S)return S;const D=l(a,r,(0,R.joinPath)(this.profilesHome,a),c);await this.n.createFolder(D.location);const L=[];return this.h.fire({profile:D,join(N){L.push(N)}}),await v.Promises.settled(L),this.C([D],[],[]),D}finally{this.k.delete(r)}})(),this.k.set(r,o)),o}async updateProfile(a,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let c=this.profiles.find(o=>o.id===a.id);if(!c)throw new Error(`Profile '${a.name}' does not exist`);return c=l(c.id,r.name??c.name,c.location,{shortName:r.shortName??c.shortName,transient:r.transient??c.isTransient,useDefaultFlags:r.useDefaultFlags??c.useDefaultFlags}),this.C([],[],[c]),c}async removeProfile(a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(a.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(o=>o.id===a.id);if(!r)throw new Error(`Profile '${a.name}' does not exist`);const c=[];this.i.fire({profile:r,join(o){c.push(o)}});try{await Promise.allSettled(c)}catch(o){this.s.error(o)}r.id===this.u.emptyWindow?.id&&(this.u.emptyWindow=void 0);for(const o of[...this.u.workspaces.keys()])r.id===this.u.workspaces.get(o)?.id&&this.u.workspaces.delete(o);this.G(),this.C([],[r],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(r.location,{recursive:!0})}catch(o){this.s.error(o)}}getOrSetProfileForWorkspace(a,r=this.defaultProfile){if(!this.f)return this.defaultProfile;let c=this.w(a);return c||(c=r,this.profiles.length>1&&this.setProfileForWorkspaceSync(a,c)),c}async setProfileForWorkspace(a,r){this.setProfileForWorkspaceSync(a,r)}setProfileForWorkspaceSync(a,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=this.profiles.find(o=>o.id===r.id);if(!c)throw new Error(`Profile '${r.name}' does not exist`);this.F(a,c)}unsetWorkspace(a,r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.F(a,void 0,r)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindow=void 0,this.u.workspaces.clear(),this.u.emptyWindow=void 0,this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const a=await this.n.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(r=>r.isDirectory&&this.profiles.every(c=>!this.r.extUri.isEqual(c.location,r.resource))).map(r=>this.n.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const a=this.l.profiles.filter(r=>!this.z(r));await Promise.allSettled(a.map(r=>this.removeProfile(r)))}w(a){const r=this.y(a);return A.URI.isUri(r)?this.l.workspaces.get(r)??this.u.workspaces.get(r):this.l.emptyWindow??this.u.emptyWindow}y(a){return(0,E.isSingleFolderWorkspaceIdentifier)(a)?a.uri:(0,E.isWorkspaceIdentifier)(a)?a.configPath:"empty-window"}z(a){return!!(this.r.extUri.isEqual(this.l.emptyWindow?.location,a.location)||[...this.l.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,a.location))||this.r.extUri.isEqual(this.u.emptyWindow?.location,a.location)||[...this.u.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,a.location)))}C(a,r,c){const o=[...this.profiles,...a],S=[];this.l.profiles=[];for(let D of o)D.isDefault||r.some(L=>D.id===L.id)||(D=c.find(L=>D.id===L.id)??D,D.isTransient?this.l.profiles.push(D):S.push({location:D.location,name:D.name,shortName:D.shortName,useDefaultFlags:D.useDefaultFlags}));this.I(S),this.t=void 0,this.D(a,r,c)}D(a,r,c){this.g.fire({added:a,removed:r,updated:c,all:this.profiles})}F(a,r,c){c=r?.isTransient?!0:c,c||this.F(a,void 0,!0);const o=this.y(a),S=c?this.l:this.u;A.URI.isUri(o)?(S.workspaces.delete(o),r&&S.workspaces.set(o,r)):S.emptyWindow=r,c||this.G()}G(){const a={};for(const[c,o]of this.u.workspaces.entries())a[c.toString()]=o.location.toString();const r=this.u.emptyWindow?.location.toString();this.L({workspaces:a,emptyWindow:r}),this.t=void 0}H(){return[]}I(a){throw new Error("not implemented")}J(){return{}}L(a){throw new Error("not implemented")}M(){}};i.b="userDataProfiles",i.c="profileAssociations",i=pe([ne(0,w.IEnvironmentService),ne(1,m.IFileService),ne(2,d.IUriIdentityService),ne(3,P.ILogService)],i),e.UserDataProfilesService=i;class s extends i{constructor(){super(...arguments),this.a=[],this.P={}}H(){return this.a}I(a){this.a=a}J(){return this.P}L(a){this.P=a}}e.InMemoryUserDataProfilesService=s}),define(te[91],ie([0,1,8,17,2,3,39,7,110,87,16,5,6,38,42]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,P.createDecorator)("IExtensionsProfileScannerService");let v=class extends k.Disposable{constructor(p,g,f,l){super(),this.h=p,this.i=g,this.j=f,this.k=l,this.a=this.B(new R.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new R.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new R.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new R.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new A.ResourceMap}scanProfileExtensions(p){return this.l(p)}async addExtensionsToProfile(p,g){const f=[],l=[];try{return await this.l(g,i=>{const s=[];for(const n of i)p.some(([a])=>(0,w.areSameExtensions)(a.identifier,n.identifier)&&a.manifest.version!==n.version)?f.push(n):s.push(n);for(const[n,a]of p)if(!s.some(r=>(0,w.areSameExtensions)(r.identifier,n.identifier)&&r.version===n.manifest.version)){const r={identifier:n.identifier,version:n.manifest.version,location:n.location,metadata:a};l.push(r),s.push(r)}return l.length&&this.a.fire({extensions:l,profileLocation:g}),f.length&&this.c.fire({extensions:f,profileLocation:g}),s}),l.length&&this.b.fire({extensions:l,profileLocation:g}),f.length&&this.f.fire({extensions:f,profileLocation:g}),l}catch(i){throw l.length&&this.b.fire({extensions:l,error:i,profileLocation:g}),f.length&&this.f.fire({extensions:f,error:i,profileLocation:g}),i}}async removeExtensionFromProfile(p,g){const f=[];this.c.fire({extensions:f,profileLocation:g});try{await this.l(g,l=>{const i=[];for(const s of l)(0,w.areSameExtensions)(s.identifier,p.identifier)?f.push(s):i.push(s);return f.length&&this.c.fire({extensions:f,profileLocation:g}),i}),f.length&&this.f.fire({extensions:f,profileLocation:g})}catch(l){throw f.length&&this.f.fire({extensions:f,error:l,profileLocation:g}),l}}async l(p,g){return this.p(p).queue(async()=>{let f=[],l;try{const i=await this.h.readFile(p);l=JSON.parse(i.value.toString())}catch(i){if((0,y.toFileOperationResult)(i)!==1)throw i;this.j.extUri.isEqual(p,this.i.defaultProfile.extensionsResource)&&(l=await this.n())}if(l)for(const i of l){if(!i.identifier){this.k.info("Ignoring invalid extension while scanning. Identifier does not exist.",i);continue}if(!i.location){this.k.info("Ignoring invalid extension while scanning. Location does not exist.",i);continue}if(!i.version){this.k.info("Ignoring invalid extension while scanning. Version does not exist.",i);continue}f.push({identifier:i.identifier,location:C.URI.revive(i.location),version:i.version,metadata:i.metadata})}if(g){f=g(f);const i=f.map(s=>({identifier:s.identifier,version:s.version,location:s.location.toJSON(),metadata:s.metadata}));await this.h.writeFile(p,t.VSBuffer.fromString(JSON.stringify(i)))}return f})}async n(){return this.m||(this.m=(async()=>{const p=this.j.extUri.joinPath(this.i.defaultProfile.location,"extensions.json");let g;try{g=(await this.h.readFile(p)).value.toString()}catch(l){if((0,y.toFileOperationResult)(l)===1)return;throw l}this.k.info("Migrating extensions from old default profile location",p.toString());let f;try{const l=JSON.parse(g);Array.isArray(l)&&l.every(i=>!!(i&&typeof i=="object"&&(0,m.isIExtensionIdentifier)(i.identifier)&&b(i.location)&&i.version&&typeof i.version=="string"))?f=l:this.k.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.k.error(l)}if(f)try{await this.h.createFile(this.i.defaultProfile.extensionsResource,t.VSBuffer.fromString(JSON.stringify(f)),{overwrite:!1}),this.k.info("Migrated extensions from old default profile location to new location",p.toString(),this.i.defaultProfile.extensionsResource.toString())}catch(l){if((0,y.toFileOperationResult)(l)===3)this.k.info("Migration from old default profile location to new location is done by another window",p.toString(),this.i.defaultProfile.extensionsResource.toString());else throw l}try{await this.h.del(p)}catch(l){(0,y.toFileOperationResult)(l)!==1&&this.k.error(l)}return f})()),this.m}p(p){let g=this.g.get(p);return g||(g=new I.Queue,this.g.set(p,g)),g}};v=pe([ne(0,y.IFileService),ne(1,h.IUserDataProfilesService),ne(2,d.IUriIdentityService),ne(3,E.ILogService)],v),e.ExtensionsProfileScannerService=v;function b(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}}),define(te[117],ie([0,1,24,8,44,17,14,43,136,2,15,9,4,20,188,98,12,7,155,35,110,87,187,16,5,6,19,3,69,91,38,42,185,186]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h,d,v,b,u,p,g,f,l,i,s,n,a,r,c,o,S,D,L,N,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var ae;(function(le){function $(W,T){if(W===T)return!0;const z=Object.keys(W),Q=new Set;for(const q of Object.keys(T))Q.add(q);if(z.length!==Q.size)return!1;for(const q of z){if(W[q]!==T[q])return!1;Q.delete(q)}return Q.size===0}le.equals=$})(ae=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let J=class extends m.Disposable{constructor($,W,T,z,Q,q,j,M,O,F,U,H){super(),this.systemExtensionsLocation=$,this.userExtensionsLocation=W,this.l=T,this.m=z,this.n=Q,this.p=q,this.r=j,this.s=M,this.t=O,this.u=F,this.v=U,this.w=H,this.g=this.B(new c.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,h.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(re,(0,h.joinPath)(this.m,l.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(re,(0,h.joinPath)(this.m,l.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(se,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,f.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions($,W,T){const[z,Q]=await Promise.all([this.scanSystemExtensions($),this.scanUserExtensions(W)]),q=T?await this.scanExtensionsUnderDevelopment($,[...z,...Q]):[];return this.D(z,Q,q,await this.getTargetPlatform(),!0)}async scanSystemExtensions($){const W=[];W.push(this.F(!!$.useCache,$.language)),W.push(this.G($.language,!!$.checkControlFile));const[T,z]=await Promise.all(W);return this.C([...T,...z],0,$,!1)}async scanUserExtensions($){const W=$.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",W);const T=await this.I(W,!!$.profileLocation,1,!$.includeUninstalled,$.language);let Q=await($.useCache&&!T.devMode&&T.excludeObsolete?this.j:this.k).scanExtensions(T);return Q=await this.C(Q,1,$,!0),this.s.trace("Scanned user extensions:",Q.length),Q}async scanExtensionsUnderDevelopment($,W){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const T=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(z=>z.scheme===y.Schemas.file).map(async z=>{const Q=await this.I(z,!1,1,!0,$.language,!1);return(await this.k.scanOneOrMultipleExtensions(Q)).map(j=>(j.type=W.find(M=>(0,f.areSameExtensions)(M.identifier,j.identifier))?.type??j.type,this.k.validate(j,Q)))}))).flat();return this.C(T,"development",$,!0)}return[]}async scanExistingExtension($,W,T){const z=await this.I($,!1,W,!0,T.language),Q=await this.k.scanExtension(z);return!Q||!T.includeInvalid&&!Q.isValid?null:Q}async scanOneOrMultipleExtensions($,W,T){const z=await this.I($,!1,W,!0,T.language),Q=await this.k.scanOneOrMultipleExtensions(z);return this.C(Q,W,T,!0)}async scanMetadata($){const W=(0,h.joinPath)($,"package.json"),T=(await this.r.readFile(W)).value.toString();return JSON.parse(T).__metadata}async updateMetadata($,W){const T=(0,h.joinPath)($,"package.json"),z=(await this.r.readFile(T)).value.toString(),Q=JSON.parse(z);W.isMachineScoped=W.isMachineScoped||void 0,W.isBuiltin=W.isBuiltin||void 0,W.installedTimestamp=W.installedTimestamp||void 0,Q.__metadata={...Q.__metadata,...W},await this.r.writeFile((0,h.joinPath)($,"package.json"),R.VSBuffer.fromString(JSON.stringify(Q,null,"	")))}initializeDefaultProfileExtensions(){return this.z||(this.z=(async()=>{try{const $=this.v.extUri.joinPath(this.userExtensionsLocation,".init-default-profile-extensions");if(await this.r.exists($))return;if(!await this.r.exists(this.n.defaultProfile.extensionsResource)&&!await this.r.exists(this.v.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"))){this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const W=await this.scanUserExtensions({includeInvalid:!0});await this.p.addExtensionsToProfile(W.map(T=>[T,T.metadata]),this.n.defaultProfile.extensionsResource),this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}try{await this.r.createFile($,R.VSBuffer.fromString(""))}catch(W){(0,s.toFileOperationResult)(W)!==1&&this.s.warn("Failed to create default profile extensions initialize marker in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.getErrorMessage)(W))}}catch($){throw this.s.error($),$}})()),this.z}async C($,W,T,z){return T.includeAllVersions||($=this.D(W===0?$:void 0,W===1?$:void 0,W==="development"?$:void 0,await this.getTargetPlatform(),z)),T.includeInvalid||($=$.filter(Q=>Q.isValid)),$.sort((Q,q)=>{const j=P.basename(Q.location.fsPath),M=P.basename(q.location.fsPath);return j<M?-1:j>M?1:0})}D($,W,T,z,Q){const q=(M,O,F)=>{if(M.isValid&&!O.isValid)return!1;if(M.isValid===O.isValid){if(Q&&d.gt(M.manifest.version,O.manifest.version))return this.s.debug(`Skipping extension ${O.location.path} with lower version ${O.manifest.version} in favour of ${M.location.path} with version ${M.manifest.version}`),!1;if(d.eq(M.manifest.version,O.manifest.version)){if(M.type===0)return this.s.debug(`Skipping extension ${O.location.path} in favour of system extension ${M.location.path} with same version`),!1;if(M.targetPlatform===z)return this.s.debug(`Skipping extension ${O.location.path} from different target platform ${O.targetPlatform}`),!1}}return F?this.s.warn(`Overwriting user extension ${M.location.path} with ${O.location.path}.`):this.s.debug(`Overwriting user extension ${M.location.path} with ${O.location.path}.`),!0},j=new Map;return $?.forEach(M=>{const O=l.ExtensionIdentifier.toKey(M.identifier.id),F=j.get(O);(!F||q(F,M,!1))&&j.set(O,M)}),W?.forEach(M=>{const O=l.ExtensionIdentifier.toKey(M.identifier.id),F=j.get(O);if(!F&&$&&M.type===0){this.s.debug(`Skipping obsolete system extension ${M.location.path}.`);return}(!F||q(F,M,!1))&&j.set(O,M)}),T?.forEach(M=>{const O=l.ExtensionIdentifier.toKey(M.identifier.id),F=j.get(O);(!F||q(F,M,!0))&&j.set(O,M),j.set(O,M)}),[...j.values()]}async F($,W){this.s.trace("Started scanning system extensions");const T=await this.I(this.systemExtensionsLocation,!1,0,!0,W),Q=await($&&!T.devMode?this.i:this.k).scanExtensions(T);return this.s.trace("Scanned system extensions:",Q.length),Q}async G($,W){const T=this.t.isBuilt?[]:this.u.builtInExtensions;if(!T?.length)return[];this.s.trace("Started scanning dev system extensions");const z=W?await this.H():{},Q=[],q=u.URI.file(P.normalize(P.join(y.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const M of T){const O=z[M.name]||"marketplace";switch(O){case"disabled":break;case"marketplace":Q.push((0,h.joinPath)(q,M.name));break;default:Q.push(u.URI.file(O));break}}const j=await Promise.all(Q.map(async M=>this.k.scanExtension(await this.I(M,!1,0,!0,$))));return this.s.trace("Scanned dev system extensions:",j.length),(0,I.coalesce)(j)}async H(){try{const $=await this.r.readFile(this.l);return JSON.parse($.value.toString())}catch{return{}}}async I($,W,T,z,Q,q=!0){const j=await this.f(Q??E.language),M=await this.J($),O=W&&!this.v.extUri.isEqual($,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,F=O?await this.J(O):void 0;return new Y($,M,O,F,W,T,z,q,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,Q,j)}async J($){try{const W=await this.r.stat($);if(typeof W.mtime=="number")return W.mtime}catch{}}};J=pe([ne(4,D.IUserDataProfilesService),ne(5,S.IExtensionsProfileScannerService),ne(6,s.IFileService),ne(7,a.ILogService),ne(8,g.IEnvironmentService),ne(9,r.IProductService),ne(10,L.IUriIdentityService),ne(11,n.IInstantiationService)],J),e.AbstractExtensionsScannerService=J;class Y{constructor($,W,T,z,Q,q,j,M,O,F,U,H,x,B){this.location=$,this.mtime=W,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=z,this.profile=Q,this.type=q,this.excludeObsolete=j,this.validate=M,this.productVersion=O,this.productDate=F,this.productCommit=U,this.devMode=H,this.language=x,this.translations=B}static createNlsConfiguration($){return{language:$.language,pseudo:$.language==="pseudo",devMode:$.devMode,translations:$.translations}}static equals($,W){return(0,h.isEqual)($.location,W.location)&&$.mtime===W.mtime&&(0,h.isEqual)($.applicationExtensionslocation,W.applicationExtensionslocation)&&$.applicationExtensionslocationMtime===W.applicationExtensionslocationMtime&&$.profile===W.profile&&$.type===W.type&&$.excludeObsolete===W.excludeObsolete&&$.validate===W.validate&&$.productVersion===W.productVersion&&$.productDate===W.productDate&&$.productCommit===W.productCommit&&$.devMode===W.devMode&&$.language===W.language&&ae.equals($.translations,W.translations)}}let se=class extends m.Disposable{constructor($,W,T,z,Q){super(),this.f=$,this.g=W,this.h=T,this.i=z,this.j=Q}async scanExtensions($){const W=$.profile?await this.l($):await this.k($);let T={};if($.excludeObsolete&&$.type===1)try{const z=(await this.i.readFile(this.f)).value.toString();T=JSON.parse(z)}catch{}return(0,b.isEmptyObject)(T)?W:W.filter(z=>!T[f.ExtensionKey.create(z).toString()])}async k($){const W=await this.i.resolve($.location);if(!W.children?.length)return[];const T=await Promise.all(W.children.map(async z=>{if(!z.isDirectory||$.type===1&&(0,h.basename)(z.resource).indexOf(".")===0)return null;const Q=new Y(z.resource,$.mtime,$.applicationExtensionslocation,$.applicationExtensionslocationMtime,$.profile,$.type,$.excludeObsolete,$.validate,$.productVersion,$.productDate,$.productCommit,$.devMode,$.language,$.translations);return this.scanExtension(Q)}));return(0,I.coalesce)(T).sort((z,Q)=>z.location.path<Q.location.path?-1:1)}async l($){let W=await this.m($.location,()=>!0,$);if($.applicationExtensionslocation&&!this.h.extUri.isEqual($.location,$.applicationExtensionslocation)){W=W.filter(z=>!z.metadata?.isApplicationScoped);const T=await this.m($.applicationExtensionslocation,z=>!!z.metadata?.isApplicationScoped,$);W.push(...T)}return W}async m($,W,T){const z=await this.g.scanProfileExtensions($);if(!z.length)return[];const Q=await Promise.all(z.map(async q=>{if(W(q)){const j=new Y(q.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(j,q.metadata)}return null}));return(0,I.coalesce)(Q)}async scanOneOrMultipleExtensions($){try{if(await this.i.exists((0,h.joinPath)($.location,"package.json"))){const W=await this.scanExtension($);return W?[W]:[]}else return await this.scanExtensions($)}catch(W){return this.j.error(`Error scanning extensions at ${$.location.path}:`,(0,A.getErrorMessage)(W)),[]}}async scanExtension($,W){try{let T=await this.scanExtensionManifest($.location);if(T){T.publisher||(T.publisher=l.UNDEFINED_PUBLISHER),W=W??T.__metadata,delete T.__metadata;const z=(0,f.getGalleryExtensionId)(T.publisher,T.name),Q=W?.id?{id:z,uuid:W.id}:{id:z},q=W?.isSystem?0:$.type,j=q===0||!!W?.isBuiltin;X.ImplicitActivationEvents.updateManifest(T),T=await this.n($.location,T,Y.createNlsConfiguration($));const M={type:q,identifier:Q,manifest:T,location:$.location,isBuiltin:j,targetPlatform:W?.targetPlatform??"undefined",metadata:W,isValid:!0,validations:[]};return $.validate?this.validate(M,$):M}}catch(T){$.type!==0&&this.j.error(T)}return null}validate($,W){let T=!0;const z=(0,i.validateExtensionManifest)(W.productVersion,W.productDate,W.location,$.manifest,$.isBuiltin);for(const[Q,q]of z)Q===v.default.Error&&(T=!1,this.j.error(this.t(W.location,q)));return $.isValid=T,$.validations=z,$}async scanExtensionManifest($){const W=(0,h.joinPath)($,"package.json");let T;try{T=(await this.i.readFile(W)).value.toString()}catch(Q){return(0,s.toFileOperationResult)(Q)!==1&&this.j.error(this.t($,(0,p.localize)(0,null,W.path,Q.message))),null}let z;try{z=JSON.parse(T)}catch{const q=[];(0,C.parse)(T,q);for(const j of q)this.j.error(this.t($,(0,p.localize)(1,null,W.path,j.offset,j.length,(0,w.getParseErrorMessage)(j.error))));return null}return(0,C.getNodeType)(z)!=="object"?(this.j.error(this.t($,(0,p.localize)(2,null,W.path))),null):z}async n($,W,T){const z=await this.p($,W,T);if(z)try{const Q=[],q=await this.r(z.default,Q);if(Q.length>0)return Q.forEach(M=>{this.j.error(this.t($,(0,p.localize)(3,null,z.default?.path,(0,w.getParseErrorMessage)(M.error))))}),W;if((0,C.getNodeType)(z)!=="object")return this.j.error(this.t($,(0,p.localize)(4,null,z.default?.path))),W;const j=z.values||Object.create(null);return(0,N.localizeManifest)(W,j,q)}catch{}return W}async p($,W,T){const z=(0,h.joinPath)($,"package.nls.json"),Q=(O,F)=>{F.forEach(U=>{this.j.error(this.t($,(0,p.localize)(5,null,O?.path,(0,w.getParseErrorMessage)(U.error))))})},q=O=>{this.j.error(this.t($,(0,p.localize)(6,null,O?.path)))},j=`${W.publisher}.${W.name}`,M=T.translations[j];if(M)try{const O=u.URI.file(M),F=(await this.i.readFile(O)).value.toString(),U=[],H=(0,C.parse)(F,U);return U.length>0?(Q(O,U),{values:void 0,default:z}):(0,C.getNodeType)(H)!=="object"?(q(O),{values:void 0,default:z}):{values:H.contents?H.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.i.exists(z))return;let F;try{F=await this.s($,T)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const U=(await this.i.readFile(F.localized)).value.toString(),H=[],x=(0,C.parse)(U,H);return H.length>0?(Q(F.localized,H),{values:void 0,default:F.original}):(0,C.getNodeType)(x)!=="object"?(q(F.localized),{values:void 0,default:F.original}):{values:x,default:F.original}}catch{return{values:void 0,default:F.original}}}}async r($,W){if($)try{const T=(await this.i.readFile($)).value.toString();return(0,C.parse)(T,W)}catch{}}s($,W){return new Promise((T,z)=>{const Q=q=>{const j=(0,h.joinPath)($,`package.nls.${q}.json`);this.i.exists(j).then(M=>{M&&T({localized:j,original:(0,h.joinPath)($,"package.nls.json")});const O=q.lastIndexOf("-");O===-1?T({localized:(0,h.joinPath)($,"package.nls.json"),original:null}):(q=q.substring(0,O),Q(q))})};if(W.devMode||W.pseudo||!W.language)return T({localized:(0,h.joinPath)($,"package.nls.json"),original:null});Q(W.language)})}t($,W){return`[${$.path}]: ${W}`}};se=pe([ne(1,S.IExtensionsProfileScannerService),ne(2,L.IUriIdentityService),ne(3,s.IFileService),ne(4,a.ILogService)],se);let re=class extends se{constructor($,W,T,z,Q,q){super(W,T,z,Q,q),this.y=$,this.v=this.B(new t.ThrottledDelayer(3e3)),this.w=this.B(new c.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions($){const W=await this.z();if(this.u=$,W&&W.input&&Y.equals(W.input,this.u))return this.v.trigger(()=>this.D()),W.result.map(z=>(z.location=u.URI.revive(z.location),z));const T=await super.scanExtensions($);return await this.C({input:$,result:T}),T}async z(){try{const $=await this.i.readFile(this.y),W=JSON.parse($.value.toString());return{result:W.result,input:(0,o.revive)(W.input)}}catch($){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,A.getErrorMessage)($))}return null}async C($){try{await this.i.writeFile(this.y,R.VSBuffer.fromString(JSON.stringify($)))}catch(W){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,A.getErrorMessage)(W))}}async D(){if(!this.u)return;const $=await this.z();if(!$)return;const W=$.result,T=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!k.equals(T,W))try{await this.i.del(this.y),this.w.fire()}catch(z){this.j.error(z)}}};re=pe([ne(2,S.IExtensionsProfileScannerService),ne(3,L.IUriIdentityService),ne(4,s.IFileService),ne(5,a.ILogService)],re);function fe(le,$){const W=(0,f.getExtensionId)(le.manifest.publisher,le.manifest.name);return{id:W,identifier:new l.ExtensionIdentifier(W),isBuiltin:le.type===0,isUserBuiltin:le.type===1&&le.isBuiltin,isUnderDevelopment:$,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,...le.manifest}}e.toExtensionDescription=fe;class K extends J{constructor($,W,T,z,Q,q,j,M,O,F,U,H){super($,W,(0,h.joinPath)(T,".vscode-oss-dev","extensions","control.json"),(0,h.joinPath)(z,l.MANIFEST_CACHE_FOLDER),Q,q,j,M,O,F,U,H),this.L=(async()=>{if(E.translationsConfigFile)try{const x=await this.r.readFile(u.URI.file(E.translationsConfigFile));return JSON.parse(x.value.toString())}catch{}return Object.create(null)})()}f($){return this.L}}e.NativeExtensionsScannerService=K}),define(te[258],ie([0,1,7,35,91,117,16,5,6,19,42,38]),function(V,e,I,t,k,R,A,C,w,m,y,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let E=class extends R.NativeExtensionsScannerService{constructor(d,v,b,u,p,g,f,l){super(I.URI.file(p.builtinExtensionsPath),I.URI.file(p.extensionsPath),p.userHome,I.URI.file(p.userDataPath),d,v,b,u,p,g,f,l)}};E=pe([ne(0,P.IUserDataProfilesService),ne(1,k.IExtensionsProfileScannerService),ne(2,A.IFileService),ne(3,w.ILogService),ne(4,t.INativeEnvironmentService),ne(5,m.IProductService),ne(6,y.IUriIdentityService),ne(7,C.IInstantiationService)],E),e.ExtensionsScannerService=E}),define(te[259],ie([0,1,13,2,15,9,4,60,7,29,41,35,6,38]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let d=class extends t.Disposable{constructor(b,u,p){super(),this.c=b,this.f=p,this.a=C.TernarySearchTree.forPaths(!A.isLinux),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(b.appRoot),this.addValidFileRoot(b.extensionsPath),this.addValidFileRoot(u.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(b.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:b}=I.session;b.protocol.registerFileProtocol(k.Schemas.vscodeFileResource,(u,p)=>this.i(u,p)),b.protocol.interceptFileProtocol(k.Schemas.file,(u,p)=>this.h(u,p)),this.B((0,t.toDisposable)(()=>{b.protocol.unregisterProtocol(k.Schemas.vscodeFileResource),b.protocol.uninterceptProtocol(k.Schemas.file)}))}addValidFileRoot(b){const u=(0,R.normalize)(b);return this.a.get(u)?t.Disposable.None:(this.a.set(u,!0),(0,t.toDisposable)(()=>this.a.delete(u)))}h(b,u){const p=w.URI.parse(b.url);return this.f.error(`Refused to load resource ${p.fsPath} from ${k.Schemas.file}: protocol (original URL: ${b.url})`),u({error:-3})}i(b,u){const p=this.j(b);let g;return this.c.crossOriginIsolated&&((0,R.basename)(p)==="workbench.html"||(0,R.basename)(p)==="workbench-dev.html"?g=k.COI.CoopAndCoep:g=k.COI.getHeadersFromQuery(b.url)),this.a.findSubstr(p)?u({path:p,headers:g}):this.b.has((0,R.extname)(p).toLowerCase())?u({path:p}):(this.f.error(`${k.Schemas.vscodeFileResource}: Refused to load resource ${p} from ${k.Schemas.vscodeFileResource}: protocol (original URL: ${b.url})`),u({error:-3}))}j(b){const u=w.URI.parse(b.url),p=k.FileAccess.uriToFileUri(u);return(0,R.normalize)(p.fsPath)}createIPCObjectUrl(){let b;const u=w.URI.from({scheme:"vscode",path:(0,m.generateUuid)()}),p=u.toString(),g=async()=>b;return y.validatedIpcMain.handle(p,g),this.f.trace(`IPC Object URL: Registered new channel ${p}.`),{resource:u,update:f=>b=f,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${p}.`),y.validatedIpcMain.removeHandler(p)}}}};d=pe([ne(0,P.INativeEnvironmentService),ne(1,h.IUserDataProfilesService),ne(2,E.ILogService)],d),e.ProtocolMainService=d}),define(te[260],ie([0,1,13,41,8,3,2,15,12,103,27,21,6,63,64,66,45,38,37]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h,d,v,b,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let g=class extends A.Disposable{constructor(l,i,s,n,a,r,c,o,S){super(),this.g=l,this.h=i,this.i=s,this.j=n,this.k=a,this.l=r,this.m=c,this.n=o,this.p=S,this.a=new k.Barrier,this.b=void 0,this.c=void 0,this.f=this.B(new R.Emitter),this.onDidError=R.Event.buffer(this.f.event),this.w=void 0,this.y=void 0,this.r()}r(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(l,i)=>this.s(l,i)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(l,i)=>this.t(l,i)),this.B(this.k.onWillShutdown(()=>this.u()))}async s(l,i){this.l.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.a.isOpen()||this.a.open(),await this.whenReady();const s=await this.connect();if(l.sender.isDestroyed())return s.close();l.sender.postMessage("vscode:createSharedProcessMessageChannelResult",i,[s])}t(l,i){this.l.trace("SharedProcess: onWorkerConnection",i);const s=new A.DisposableStore,n=r=>{!this.F()||(this.l.trace(`SharedProcess: disposing worker (reason: '${r}')`,i),s.dispose(),this.v("vscode:electron-main->shared-process=disposeWorker",i))},a=I.BrowserWindow.fromId(i.reply.windowId);if(!a||a.isDestroyed()||a.webContents.isDestroyed()||!i.reply.channel){n("unavailable");return}s.add(R.Event.filter(this.k.onWillLoadWindow,r=>r.window.win===a)(()=>n("load"))),s.add(R.Event.fromNodeEventEmitter(a,"closed")(()=>n("closed"))),a.webContents.postMessage(i.reply.channel,i.reply.nonce,l.ports)}u(){const l=this.b;!l||(this.v("vscode:electron-main->shared-process=exit"),this.c&&(l.removeListener("close",this.c),this.c=void 0),setTimeout(()=>{try{l.close()}catch{}this.b=void 0},0))}v(l,...i){if(!this.F()){this.l.warn(`Sending IPC message to channel '${l}' for shared process window that is destroyed`);return}try{this.b?.webContents.send(l,...i)}catch(s){this.l.warn(`Error sending IPC message to channel '${l}' of shared process: ${(0,b.toErrorMessage)(s)}`)}}whenReady(){return this.w||(this.w=new Promise(l=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.l.trace("SharedProcess: Overall ready"),l()}))),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C(),this.D(),await new Promise(l=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.l.trace("SharedProcess: IPC ready"),l()}))})()),this.y}C(){const l=this.B(this.p.createIPCObjectUrl());this.b=new I.BrowserWindow({show:!1,backgroundColor:this.n.getBackgroundColor(),webPreferences:{preload:C.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${l.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.i.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),l.update({machineId:this.g,windowId:this.b.id,appRoot:this.i.appRoot,codeCachePath:this.i.codeCachePath,profiles:this.j.profiles,userEnv:this.h,args:this.i.args,logLevel:this.l.getLevel(),product:h.default,policiesData:this.m.serialize()}),this.b.loadURL(C.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.i.isBuilt?"":"-dev"}.html`).toString(!0))}D(){!this.b||(this.c=l=>{this.l.trace("SharedProcess#close prevented"),l.preventDefault(),this.b?.isVisible()&&this.b.hide()},this.b.on("close",this.c),this.b.webContents.on("render-process-gone",(l,i)=>this.f.fire({type:2,details:i})),this.b.on("unresponsive",()=>this.f.fire({type:1})),this.b.webContents.on("did-fail-load",(l,i,s)=>this.f.fire({type:3,details:{reason:s,exitCode:i}})))}async connect(){await this.z;const l=(0,w.assertIsDefined)(this.b);return(0,m.connect)(l)}async toggle(){await this.z,this.b&&(this.b.isVisible()?(this.b.webContents.closeDevTools(),this.b.hide()):(this.b.show(),this.b.webContents.openDevTools()))}isVisible(){return this.b?.isVisible()??!1}F(){const l=this.b;return l?!l.isDestroyed()&&!l.webContents.isDestroyed():!1}};g=pe([ne(2,y.IEnvironmentMainService),ne(3,u.IUserDataProfilesService),ne(4,P.ILifecycleMainService),ne(5,E.ILogService),ne(6,p.IPolicyService),ne(7,v.IThemeMainService),ne(8,d.IProtocolMainService)],g),e.SharedProcess=g}),define(te[92],ie([0,1,8,3,2,73,12,104,5,38]),function(V,e,I,t,k,R,A,C,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,w.createDecorator)("storageService");var y;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(y=e.WillSaveStateReason||(e.WillSaveStateReason={}));var P;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(P=e.StorageScope||(e.StorageScope={}));var E;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(E=e.StorageTarget||(e.StorageTarget={}));function h(p){const g=p.get(e.TARGET_KEY);if(g)try{return JSON.parse(g)}catch{}return Object.create(null)}e.loadKeyTargets=h;class d extends k.Disposable{constructor(g={flushInterval:d.a}){super(),this.j=g,this.b=this.B(new t.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new t.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new t.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new I.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new k.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,I.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,k.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.J()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(g,f){if(f===e.TARGET_KEY){switch(g){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:g})}else this.b.fire({scope:g,key:f,target:this.F(g)[f]})}r(g){this.f.fire({reason:g})}get(g,f,l){return this.L(f)?.get(g,l)}getBoolean(g,f,l){return this.L(f)?.getBoolean(g,l)}getNumber(g,f,l){return this.L(f)?.getNumber(g,l)}store(g,f,l,i){if((0,A.isUndefinedOrNull)(f)){this.remove(g,l);return}this.t(()=>{this.u(g,l,i),this.L(l)?.set(g,f)})}remove(g,f){this.t(()=>{this.u(g,f,void 0),this.L(f)?.delete(g)})}t(g){this.b.pause(),this.c.pause();try{g()}finally{this.b.resume(),this.c.resume()}}keys(g,f){const l=[],i=this.F(g);for(const s of Object.keys(i))i[s]===f&&l.push(s);return l}u(g,f,l){const i=this.F(f);typeof l=="number"?i[g]!==l&&(i[g]=l,this.L(f)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[g]=="number"&&(delete i[g],this.L(f)?.set(e.TARGET_KEY,JSON.stringify(i)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(g){switch(g){case-1:return this.D;case 0:return this.z;default:return this.w}}G(g){const f=this.L(g);return f?h(f):Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=y.NONE){this.f.fire({reason:g});const f=this.L(-1),l=this.L(0),i=this.L(1);switch(g){case y.NONE:await I.Promises.settled([f?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await I.Promises.settled([f?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.L(-1)?.items??new Map,f=this.L(0)?.items??new Map,l=this.L(1)?.items??new Map;return u(g,f,l,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(g,f){return this.r(y.NONE),(0,m.isUserDataProfile)(g)?this.N(g,f):this.O(g,f)}H(g,f){return!(g.id===f.id||v(f)&&v(g))}I(g,f,l,i){this.t(()=>{if(i)for(const[s,n]of g)f.set(s,n);else{const s=new Set;for(const[n,a]of g)s.add(n),f.get(n)!==a&&this.n(l,n);for(const[n]of f.items)s.has(n)||this.n(l,n)}})}}e.AbstractStorageService=d,d.a=60*1e3;function v(p){return p.isDefault||!!p.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=v;class b extends d{constructor(){super(),this.p=this.B(new C.Storage(new C.InMemoryStorageDatabase,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new C.Storage(new C.InMemoryStorageDatabase,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new C.Storage(new C.InMemoryStorageDatabase,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(g=>this.n(1,g))),this.B(this.P.onDidChangeStorage(g=>this.n(0,g))),this.B(this.p.onDidChangeStorage(g=>this.n(-1,g)))}L(g){switch(g){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(g){return!1}}e.InMemoryStorageService=b;async function u(p,g,f,l,i,s){const n=X=>{try{return JSON.parse(X)}catch{return X}},a=new Map,r=new Map;p.forEach((X,ae)=>{a.set(ae,X),r.set(ae,n(X))});const c=new Map,o=new Map;g.forEach((X,ae)=>{c.set(ae,X),o.set(ae,n(X))});const S=new Map,D=new Map;f.forEach((X,ae)=>{S.set(ae,X),D.set(ae,n(X))}),console.group(l!==i?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const L=[];if(a.forEach((X,ae)=>{L.push({key:ae,value:X})}),console.table(L),console.groupEnd(),console.log(r),l!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const X=[];c.forEach((ae,J)=>{X.push({key:J,value:ae})}),console.table(X),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${s})`);const N=[];S.forEach((X,ae)=>{N.push({key:ae,value:X})}),console.table(N),console.groupEnd(),console.log(D)}e.logStorage=u}),define(te[261],ie([0,1,24,8,3,2,9,80,7,23,104,147,6,92,31,28]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class b extends R.Disposable{get storage(){return this.f}constructor(s,n){super(),this.j=s,this.k=n,this.b=this.B(new k.Emitter),this.onDidChangeStorage=this.b.event,this.c=this.B(new k.Emitter),this.onDidCloseStorage=this.c.event,this.f=new y.Storage(new y.InMemoryStorageDatabase,{hint:y.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new t.DeferredPromise,this.whenInit=this.h.p,this.i=y.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===y.StorageState.None)try{const s=await this.n();this.f.dispose(),this.f=s,this.B(s.onDidChangeStorage(a=>this.b.fire({key:a}))),await this.m(s);const n=s.getBoolean(h.IS_NEW_KEY);n===void 0?s.set(h.IS_NEW_KEY,!0):n&&s.set(h.IS_NEW_KEY,!1)}catch(s){this.j.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.i=y.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===E.LogLevel.Trace?s=>this.j.trace(s):void 0,logError:s=>this.j.error(s)}}m(s){return s.init()}get items(){return this.f.items}get(s,n){return this.f.get(s,n)}set(s,n){return this.f.set(s,n)}delete(s){return this.f.delete(s)}async close(){const s=new C.StopWatch(!1);await this.s(),s.stop(),s.elapsed()>b.a&&await this.r(s),this.c.fire()}async r(s){if(!!this.path)try{const n=(0,I.top)(Array.from(this.f.items.entries()).map(([r,c])=>({key:r,length:c.length})),(r,c)=>c.length-r.length,5).map(r=>`${r.key}:${r.length}`).join(", "),a=(await this.k.stat(w.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${a}b, Large Keys: ${n}`)}catch(n){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",n)}}async s(){this.g&&await this.g,this.i=y.StorageState.Closed,await this.f.close()}}b.a=2e3;class u extends b{get path(){if(!this.v.useInMemoryStorage)return(0,A.join)(this.u.globalStorageHome.fsPath,u.t)}constructor(s,n,a,r){super(a,r),this.u=s,this.v=n}async n(){return new y.Storage(new P.SQLiteStorageDatabase(this.path??P.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:y.StorageHint.STORAGE_IN_MEMORY})}}u.t="state.vscdb";class p extends u{constructor(s,n,a,r){super(s,n,a,r)}}e.ProfileStorageMain=p;class g extends u{constructor(s,n,a,r){super(n.defaultProfile,s,a,r)}async m(s){await super.m(s),this.z(s)}z(s){s.get(d.firstSessionDateStorageKey,void 0)===void 0&&s.set(d.firstSessionDateStorageKey,new Date().toUTCString());const a=s.get(d.currentSessionDateStorageKey,void 0),r=new Date().toUTCString();s.set(d.lastSessionDateStorageKey,typeof a>"u"?null:a),s.set(d.currentSessionDateStorageKey,r)}}e.ApplicationStorageMain=g;class f extends b{get path(){if(!this.w.useInMemoryStorage)return(0,A.join)(this.y.workspaceStorageHome.fsPath,this.v.id,f.t)}constructor(s,n,a,r,c){super(a,c),this.v=s,this.w=n,this.y=r}async n(){const{storageFilePath:s,wasCreated:n}=await this.C();return new y.Storage(new P.SQLiteStorageDatabase(s,{logging:this.l()}),{hint:this.w.useInMemoryStorage?y.StorageHint.STORAGE_IN_MEMORY:n?y.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:P.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const s=(0,A.join)(this.y.workspaceStorageHome.fsPath,this.v.id),n=(0,A.join)(s,f.t);return await m.Promises.exists(s)?{storageFilePath:n,wasCreated:!1}:(await m.Promises.mkdir(s,{recursive:!0}),this.D(s),{storageFilePath:n,wasCreated:!0})}async D(s){let n;if((0,v.isSingleFolderWorkspaceIdentifier)(this.v)?n={folder:this.v.uri.toString()}:(0,v.isWorkspaceIdentifier)(this.v)&&(n={workspace:this.v.configPath.toString()}),n)try{const a=(0,A.join)(s,f.u);await m.Promises.exists(a)||await m.Promises.writeFile(a,JSON.stringify(n,void 0,2))}catch(a){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${a}`)}}}e.WorkspaceStorageMain=f,f.t="state.vscdb",f.u="workspace.json";class l extends b{get path(){}async n(){return new y.Storage(new y.InMemoryStorageDatabase,{hint:y.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=l}),define(te[262],ie([0,1,3,2,92]),function(V,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class R extends t.Disposable{constructor(C,w,m){super(),this.b=C,this.c=w,this.f=m;const y=this.B(new t.MutableDisposable);this.a=this.B(new I.Emitter({onWillAddFirstListener:()=>y.value=this.g(),onDidRemoveLastListener:()=>y.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const C=new t.DisposableStore;return C.add(I.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(w,m)=>(w?w.push(m.key):w=[m.key],w),100)(w=>this.h(w))),C.add(I.Event.debounce(this.b.onDidChangeProfileStorage,(w,m)=>{w||(w=new Map);let y=w.get(m.profile.id);return y||w.set(m.profile.id,y={profile:m.profile,keys:[],storage:m.storage}),y.keys.push(m.key),w},100)(w=>this.i(w))),C}h(C){const w=C.includes(k.TARGET_KEY)?[this.c.defaultProfile]:[],m=[];if(C=C.filter(y=>y!==k.TARGET_KEY),C.length){const y=(0,k.loadKeyTargets)(this.b.applicationStorage.storage);m.push({profile:this.c.defaultProfile,changes:C.map(P=>({key:P,scope:0,target:y[P]}))})}this.j(w,m)}i(C){const w=[],m=new Map;for(const[y,P]of C.entries()){P.keys.includes(k.TARGET_KEY)&&w.push(P.profile);const E=P.keys.filter(h=>h!==k.TARGET_KEY);if(E.length){const h=(0,k.loadKeyTargets)(P.storage.storage);m.set(y,{profile:P.profile,changes:E.map(d=>({key:d,scope:0,target:h[d]}))})}}this.j(w,[...m.values()])}j(C,w){(C.length||w.length)&&this.a.fire({valueChanges:w,targetChanges:C})}listen(C,w,m){switch(w){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${w}`)}async call(C,w){throw new Error(`Call not found: ${w}`)}}e.ProfileStorageChangesListenerChannel=R}),define(te[263],ie([0,1,69,7,35,16,6,229,42,38]),function(V,e,I,t,k,R,A,C,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let y=class Lt extends m.UserDataProfilesService{constructor(E,h,d,v,b){super(d,v,h,b),this.a=E,this.N=d}H(){return(0,I.revive)(this.a.getItem(Lt.b,[]))}J(){return(0,I.revive)(this.a.getItem(Lt.c,{}))}M(){return this.r.extUri.joinPath(t.URI.file(this.N.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};y=pe([ne(0,C.IStateService),ne(1,w.IUriIdentityService),ne(2,k.INativeEnvironmentService),ne(3,R.IFileService),ne(4,A.ILogService)],y),e.UserDataProfilesService=y}),define(te[51],ie([0,1,7,35,16,5,6,36,42,38,263]),function(V,e,I,t,k,R,A,C,w,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(m.IUserDataProfilesService);let P=class dt extends y.UserDataProfilesService{constructor(h,d,v,b,u){super(h,d,v,b,u),this.R=h}setEnablement(h){super.setEnablement(h),this.f||(this.I([]),this.L({}))}I(h){h.length?this.R.setItem(dt.b,h):this.R.removeItem(dt.b)}L(h){h.emptyWindow||h.workspaces?this.R.setItem(dt.c,h):this.R.removeItem(dt.c)}J(){const h="workspaceAndProfileInfo",d=this.R.getItem(h,void 0);if(d){this.R.removeItem(h);const v=d.reduce((b,{workspace:u,profile:p})=>(b[I.URI.revive(u).toString()]=I.URI.revive(p).toString(),b),{});this.R.setItem(dt.c,{workspaces:v})}return super.J()}};P=pe([ne(0,C.IStateMainService),ne(1,w.IUriIdentityService),ne(2,t.INativeEnvironmentService),ne(3,k.IFileService),ne(4,A.ILogService)],P),e.UserDataProfilesMainService=P}),define(te[93],ie([0,1,7,50,3,2,35,16,5,21,6,92,261,38,51,42]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,w.createDecorator)("storageMainService");let b=class extends R.Disposable{constructor(g,f,l,i,s,n){super(),this.c=g,this.f=f,this.g=l,this.h=i,this.i=s,this.j=n,this.a=void 0,this.b=this.B(new k.Emitter),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(g=>{g.window.profile&&this.profileStorage(g.window.profile).init(),g.workspace&&this.workspaceStorage(g.workspace).init()})),this.B(this.h.onWillShutdown(g=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=g.reason,g.join(this.applicationStorage.close());for(const[,f]of this.n)g.join(f.close());for(const[,f]of this.r)g.join(f.close())})),this.B(this.g.onWillCreateProfile(g=>{g.join((async()=>{await this.i.exists(g.profile.globalStorageHome)||await this.i.createFolder(g.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(g=>{const f=this.n.get(g.profile.id);f&&g.join(f.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const g=new E.ApplicationStorageMain(this.k(),this.g,this.c,this.i);return(0,t.once)(g.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),g}profileStorage(g){if((0,P.isProfileUsingDefaultStorage)(g))return this.applicationStorage;let f=this.n.get(g.id);if(!f){this.c.trace(`StorageMainService: creating profile storage (${g.name})`),f=this.p(g),this.n.set(g.id,f);const l=this.B(f.onDidChangeStorage(i=>this.b.fire({...i,storage:f,profile:g})));(0,t.once)(f.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${g.name})`),this.n.delete(g.id),l.dispose()})}return f}p(g){return this.a===2?new E.InMemoryStorageMain(this.c,this.i):new E.ProfileStorageMain(g,this.k(),this.c,this.i)}workspaceStorage(g){let f=this.r.get(g.id);return f||(this.c.trace(`StorageMainService: creating workspace storage (${g.id})`),f=this.s(g),this.r.set(g.id,f),(0,t.once)(f.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${g.id})`),this.r.delete(g.id)})),f}s(g){return this.a===2?new E.InMemoryStorageMain(this.c,this.i):new E.WorkspaceStorageMain(g,this.k(),this.c,this.f,this.i)}isUsed(g){const f=I.URI.file(g);for(const l of[this.applicationStorage,...this.n.values(),...this.r.values()])if(!!l.path&&this.j.extUri.isEqualOrParent(I.URI.file(l.path),f))return!0;return!1}};b=pe([ne(0,y.ILogService),ne(1,A.IEnvironmentService),ne(2,d.IUserDataProfilesMainService),ne(3,m.ILifecycleMainService),ne(4,C.IFileService),ne(5,v.IUriIdentityService)],b),e.StorageMainService=b,e.IApplicationStorageMainService=(0,w.createDecorator)("applicationStorageMainService");let u=class extends P.AbstractStorageService{constructor(g,f){super(),this.p=g,this.s=f,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(g){if(g===-1)return this.s.applicationStorage.storage}M(g){if(g===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};u=pe([ne(0,h.IUserDataProfilesService),ne(1,e.IStorageMainService)],u),e.ApplicationStorageMainService=u}),define(te[264],ie([0,1,2,21,51]),function(V,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataTransientProfilesHandler=void 0;let R=class extends I.Disposable{constructor(C,w){super(),this.a=w,this.B(C.onWillLoadWindow(m=>{m.reason===2&&this.b(m.window.openedWorkspace??"empty-window")})),this.B(C.onBeforeCloseWindow(m=>this.b(m.openedWorkspace??"empty-window")))}async b(C){this.a.getOrSetProfileForWorkspace(C).isTransient&&(this.a.unsetWorkspace(C,!0),await this.a.cleanUpTransientProfiles())}};R=pe([ne(0,t.ILifecycleMainService),ne(1,k.IUserDataProfilesMainService)],R),e.UserDataTransientProfilesHandler=R}),define(te[118],ie([0,1,20,7,28]),function(V,e,I,t,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function R(w,m,y){for(const E of w){const h=E.openedWorkspace;if((0,k.isWorkspaceIdentifier)(h)){const d=await y(h);if(d){if(d.folders.some(v=>I.extUriBiasedIgnorePathCase.isEqualOrParent(m,v.uri)))return E}else if(I.extUriBiasedIgnorePathCase.isEqualOrParent(m,h.configPath))return E}}const P=w.filter(E=>(0,k.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqualOrParent(m,E.openedWorkspace.uri));if(P.length)return P.sort((E,h)=>-(E.openedWorkspace.uri.path.length-h.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function A(w,m){for(const y of w)if((0,k.isWorkspaceIdentifier)(y.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.configPath,m)||(0,k.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.uri,m))return y}e.findWindowOnWorkspaceOrFolder=A;function C(w,m){const y=P=>m.some(E=>I.extUriBiasedIgnorePathCase.isEqual(t.URI.file(E),t.URI.file(P)));for(const P of w)if(P.config?.extensionDevelopmentPath?.some(E=>y(E)))return P}e.findWindowOnExtensionDevelopmentPath=C}),define(te[265],ie([0,1,13,2,4,20,7,18,21,6,36,32,116,28]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let d=class Ot extends t.Disposable{get state(){return this.b}constructor(f,l,i,s,n){super(),this.g=f,this.h=l,this.i=i,this.j=s,this.k=n,this.b=v(this.h.getItem(Ot.a)),this.c=void 0,this.f=!1,this.l()}l(){I.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(f=>this.p(f)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(f=>{f.newCount-f.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(f=>this.p(f))}m(){this.f=!0,this.n()}n(){const f=new Set,l={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!l.lastActiveWindow){let n=this.g.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.g.getWindows().find(a=>!a.isExtensionDevelopmentHost)),n&&(l.lastActiveWindow=this.r(n),l.lastActiveWindow.uiState.mode===3&&f.add(l.lastActiveWindow.uiState.display))}const i=this.g.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);i&&(l.lastPluginDevelopmentHostWindow=this.r(i),l.lastPluginDevelopmentHostWindow.uiState.mode===3&&(f.has(l.lastPluginDevelopmentHostWindow.uiState.display)?k.isMacintosh&&!i.win?.isSimpleFullScreen()&&(l.lastPluginDevelopmentHostWindow.uiState.mode=1):f.add(l.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(l.openedWindows=this.g.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>{const a=this.r(n);return a.uiState.mode===3&&(f.has(a.uiState.display)?k.isMacintosh&&a.windowId!==l.lastActiveWindow?.windowId&&!n.win?.isSimpleFullScreen()&&(a.uiState.mode=1):f.add(a.uiState.display)),a}));const s=u(l);this.h.setItem(Ot.a,s),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",s)}p(f){if(this.i.quitRequested)return;const l=this.r(f);f.isExtensionDevelopmentHost&&!f.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=l:!f.isExtensionDevelopmentHost&&f.openedWorkspace&&this.b.openedWindows.forEach(i=>{const s=(0,h.isWorkspaceIdentifier)(f.openedWorkspace)&&i.workspace?.id===f.openedWorkspace.id,n=(0,h.isSingleFolderWorkspaceIdentifier)(f.openedWorkspace)&&i.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(i.folderUri,f.openedWorkspace.uri);(s||n)&&(i.uiState=l.uiState)}),this.g.getWindowCount()===1&&(this.c=l)}r(f){return{windowId:f.id,workspace:(0,h.isWorkspaceIdentifier)(f.openedWorkspace)?f.openedWorkspace:void 0,folderUri:(0,h.isSingleFolderWorkspaceIdentifier)(f.openedWorkspace)?f.openedWorkspace.uri:void 0,backupPath:f.backupPath,remoteAuthority:f.remoteAuthority,uiState:f.serializeWindowState()}}getNewWindowState(f){const l=this.s(f),i=this.k.getValue("window");if(l.mode===3){let s;l.hasDefaultState?s=!!(i?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(i.newWindowDimensions)>=0):s=!!(this.i.wasRestarted||i?.restoreFullscreen),s||(l.mode=1)}return l}s(f){const l=this.g.getLastActiveWindow();if(!f.extensionTestsPath){if(!!f.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const c=f.workspace;if((0,h.isWorkspaceIdentifier)(c)){const S=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===c.id).map(D=>D.uiState);if(S.length)return S[0]}if((0,h.isSingleFolderWorkspaceIdentifier)(c)){const S=this.state.openedWindows.filter(D=>D.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(D.folderUri,c.uri)).map(D=>D.uiState);if(S.length)return S[0]}else if(f.backupPath){const S=this.state.openedWindows.filter(D=>D.backupPath===f.backupPath).map(D=>D.uiState);if(S.length)return S[0]}const o=this.c||this.state.lastActiveWindow;if(!l&&o)return o.uiState}let i;const s=I.screen.getAllDisplays();if(s.length===1)i=s[0];else{if(k.isMacintosh){const c=I.screen.getCursorScreenPoint();i=I.screen.getDisplayNearestPoint(c)}!i&&l&&(i=I.screen.getDisplayMatching(l.getBounds())),i||(i=I.screen.getPrimaryDisplay()||s[0])}let n=(0,E.defaultWindowState)();n.x=Math.round(i.bounds.x+i.bounds.width/2-n.width/2),n.y=Math.round(i.bounds.y+i.bounds.height/2-n.height/2);const a=this.k.getValue("window");let r=!0;if(a?.newWindowDimensions){if(a.newWindowDimensions==="maximized")n.mode=0,r=!1;else if(a.newWindowDimensions==="fullscreen")n.mode=3,r=!1;else if((a.newWindowDimensions==="inherit"||a.newWindowDimensions==="offset")&&l){const c=l.serializeWindowState();c.mode===3?n.mode=3:n=c,r=n.mode!==3&&a.newWindowDimensions==="offset"}}return r&&(n=this.t(n)),n.hasDefaultState=!0,n}t(f){if(this.g.getWindows().length===0)return f;f.x=typeof f.x=="number"?f.x:0,f.y=typeof f.y=="number"?f.y:0;const l=this.g.getWindows().map(i=>i.getBounds());for(;l.some(i=>i.x===f.x||i.y===f.y);)f.x+=30,f.y+=30;return f}};d.a="windowsState",d=pe([ne(0,P.IWindowsMainService),ne(1,y.IStateMainService),ne(2,w.ILifecycleMainService),ne(3,m.ILogService),ne(4,C.IConfigurationService)],d),e.WindowsStateHandler=d;function v(g){const f={openedWindows:[]},l=g||{openedWindows:[]};return l.lastActiveWindow&&(f.lastActiveWindow=b(l.lastActiveWindow)),l.lastPluginDevelopmentHostWindow&&(f.lastPluginDevelopmentHostWindow=b(l.lastPluginDevelopmentHostWindow)),Array.isArray(l.openedWindows)&&(f.openedWindows=l.openedWindows.map(i=>b(i))),f}e.restoreWindowsState=v;function b(g){const f={uiState:g.uiState};return g.backupPath&&(f.backupPath=g.backupPath),g.remoteAuthority&&(f.remoteAuthority=g.remoteAuthority),g.folder&&(f.folderUri=A.URI.parse(g.folder)),g.workspaceIdentifier&&(f.workspace={id:g.workspaceIdentifier.id,configPath:A.URI.parse(g.workspaceIdentifier.configURIPath)}),f}function u(g){return{lastActiveWindow:g.lastActiveWindow&&p(g.lastActiveWindow),lastPluginDevelopmentHostWindow:g.lastPluginDevelopmentHostWindow&&p(g.lastPluginDevelopmentHostWindow),openedWindows:g.openedWindows.map(f=>p(f))}}e.getWindowsStateStoreData=u;function p(g){return{workspaceIdentifier:g.workspace&&{id:g.workspace.id,configURIPath:g.workspace.configPath.toString()},folder:g.folderUri&&g.folderUri.toString(),backupPath:g.backupPath,remoteAuthority:g.remoteAuthority,uiState:g.uiState}}}),define(te[94],ie([0,1,30,43,124,34,15,9,4,20,7,5,54,28]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,P.createDecorator)("workspacesService");function d(D){return D.hasOwnProperty("workspace")}e.isRecentWorkspace=d;function v(D){return D.hasOwnProperty("folderUri")}e.isRecentFolder=v;function b(D){return D.hasOwnProperty("fileUri")}e.isRecentFile=b;function u(D){return p(D)||g(D)}e.isStoredWorkspaceFolder=u;function p(D){const L=D;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function g(D){const L=D;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function f(D,L,N,X,ae){if(D.scheme!==X.scheme)return{name:N,uri:D.toString(!0)};let J=L?void 0:ae.relativePath(X,D);if(J!==void 0)J.length===0?J=".":w.isWindows&&(J=l(J));else if(D.scheme===A.Schemas.file)J=D.fsPath,w.isWindows&&(J=l(J));else if(ae.isEqualAuthority(D.authority,X.authority))J=D.path;else return{name:N,uri:D.toString(!0)};return{name:N,path:J}}e.getStoredWorkspaceFolder=f;function l(D){return D=(0,R.normalizeDriveLetter)(D),(0,I.isUNC)(D)||(D=(0,I.toSlashes)(D)),D}function i(D,L,N){const X=[],ae=new Set,J=N.dirname(L);for(const Y of D){let se;if(p(Y))Y.path&&(se=N.resolvePath(J,Y.path));else if(g(Y))try{se=y.URI.parse(Y.uri),se.path[0]!==C.posix.sep&&(se=se.with({path:C.posix.sep+se.path}))}catch(re){console.warn(re)}if(se){const re=N.getComparisonKey(se);if(!ae.has(re)){ae.add(re);const fe=Y.name||N.basenameOrAuthority(se);X.push(new h.WorkspaceFolder({uri:se,name:fe,index:X.length},Y))}}}return X}e.toWorkspaceFolders=i;function s(D,L,N,X,ae){const J=n(L,D),Y=ae.dirname(L),se=ae.dirname(X),re=[];for(const $ of J.folders){const W=p($)?ae.resolvePath(Y,$.path):y.URI.parse($.uri);let T;N?T=!1:T=!p($)||(0,C.isAbsolute)($.path),re.push(f(W,T,$.name,se,ae))}const fe={insertSpaces:!1,tabSize:4,eol:w.isLinux||w.isMacintosh?`
`:`\r
`},K=k.setProperty(D,["folders"],re,fe);let le=k.applyEdits(D,K);return(0,m.isEqualAuthority)(J.remoteAuthority,(0,E.getRemoteAuthority)(X))&&(le=k.applyEdits(le,k.removeProperty(le,["remoteAuthority"],fe))),le}e.rewriteWorkspaceFileForNewLocation=s;function n(D,L){const N=t.parse(L);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(X=>u(X));else throw new Error(`${D} looks like an invalid workspace file.`);return N}function a(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function r(D){return typeof D.folderUri=="string"}function c(D){return typeof D.fileUri=="string"}function o(D,L){const N={workspaces:[],files:[]};if(D){const X=function(J,Y){for(let se=0;se<J.length;se++)try{Y(J[se],se)}catch(re){L.warn(`Error restoring recent entry ${JSON.stringify(J[se])}: ${re.toString()}. Skip entry.`)}},ae=D;Array.isArray(ae.entries)&&X(ae.entries,J=>{const Y=J.label,se=J.remoteAuthority;a(J)?N.workspaces.push({label:Y,remoteAuthority:se,workspace:{id:J.workspace.id,configPath:y.URI.parse(J.workspace.configPath)}}):r(J)?N.workspaces.push({label:Y,remoteAuthority:se,folderUri:y.URI.parse(J.folderUri)}):c(J)&&N.files.push({label:Y,remoteAuthority:se,fileUri:y.URI.parse(J.fileUri)})})}return N}e.restoreRecentlyOpened=o;function S(D){const L={entries:[]};for(const N of D.workspaces)v(N)?L.entries.push({folderUri:N.folderUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority}):L.entries.push({workspace:{id:N.workspace.id,configPath:N.workspace.configPath.toString()},label:N.label,remoteAuthority:N.remoteAuthority});for(const N of D.files)L.entries.push({fileUri:N.fileUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority});return L}e.toStoreData=S}),define(te[95],ie([0,1,77,15,4,20]),function(V,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function A(m){function y(){let P=m.scheme===t.Schemas.file?(0,R.originalFSPath)(m):m.toString();return k.isLinux||(P=P.toLowerCase()),(0,I.createHash)("md5").update(P).digest("hex")}return{id:y(),configPath:m}}e.getWorkspaceIdentifier=A;function C(m,y){function P(){if(m.scheme!==t.Schemas.file)return(0,I.createHash)("md5").update(m.toString()).digest("hex");if(!y)return;let h;return k.isLinux?h=y.ino:k.isMacintosh?h=y.birthtime.getTime():k.isWindows&&(typeof y.birthtimeMs=="number"?h=Math.floor(y.birthtimeMs):h=y.birthtime.getTime()),(0,I.createHash)("md5").update(m.fsPath).update(h?String(h):"").digest("hex")}const E=P();if(typeof E=="string")return{id:E,uri:m}}e.getSingleFolderWorkspaceIdentifier=C;function w(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=w}),define(te[266],ie([0,1,77,30,15,9,4,20,23,177,18,27,36,16,6,176,28,95]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h,d,v,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let p=class Tt{constructor(f,l,i,s){this.j=f,this.k=l,this.l=i,this.m=s,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=C.extUriBiasedIgnorePathCase,this.i={isEqual:(n,a)=>(0,t.isEqual)(n,a,!A.isLinux)}}async initialize(){const f=this.m.getItem(Tt.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(f.emptyWindows),this.d=await this.u((0,m.deserializeWorkspaceInfos)(f)),this.e=await this.v((0,m.deserializeFolderInfos)(f)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==h.HotExitConfiguration.OFF}q(){return this.s()===h.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||h.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(f,l){this.d.some(s=>f.workspace.id===s.workspace.id)||(this.d.push(f),this.C());const i=(0,R.join)(this.c,f.workspace.id);return l?this.t(i,l).then(()=>i):i}async t(f,l){if(await w.Promises.exists(f)&&await this.z(f),await w.Promises.exists(l))try{await w.Promises.rename(l,f)}catch(i){this.l.error(`Backup: Could not move backup folder to new location: ${i.toString()}`)}}registerFolderBackup(f){return this.e.some(l=>this.h.isEqual(f.folderUri,l.folderUri))||(this.e.push(f),this.C()),(0,R.join)(this.c,this.D(f))}registerEmptyWindowBackup(f){return this.g.some(l=>!!l.backupFolder&&this.i.isEqual(l.backupFolder,f.backupFolder))||(this.g.push(f),this.C()),(0,R.join)(this.c,f.backupFolder)}async u(f){if(!Array.isArray(f))return[];const l=new Set,i=[];for(const s of f){const n=s.workspace;if(!(0,b.isWorkspaceIdentifier)(n))return[];if(!l.has(n.id)){l.add(n.id);const a=(0,R.join)(this.c,n.id);await this.B(a)?n.configPath.scheme!==k.Schemas.file||await w.Promises.exists(n.configPath.fsPath)?i.push(s):await this.z(a):await this.x(a)}}return i}async v(f){if(!Array.isArray(f))return[];const l=[],i=new Set;for(const s of f){const n=s.folderUri,a=this.h.getComparisonKey(n);if(!i.has(a)){i.add(a);const r=(0,R.join)(this.c,this.D(s));await this.B(r)?n.scheme!==k.Schemas.file||await w.Promises.exists(n.fsPath)?l.push(s):await this.z(r):await this.x(r)}}return l}async w(f){if(!Array.isArray(f))return[];const l=[],i=new Set;for(const s of f){const n=s.backupFolder;if(typeof n!="string")return[];if(!i.has(n)){i.add(n);const a=(0,R.join)(this.c,n);await this.B(a)?l.push(s):await this.x(a)}}return l}async x(f){try{await w.Promises.rm(f,w.RimRafMode.MOVE)}catch(l){this.l.error(`Backup: Could not delete stale backup: ${l.toString()}`)}}y(){let f=(0,u.createEmptyWorkspaceIdentifier)();for(;this.g.some(l=>!!l.backupFolder&&this.i.isEqual(l.backupFolder,f.id));)f=(0,u.createEmptyWorkspaceIdentifier)();return{backupFolder:f.id}}async z(f){const l=this.y(),i=(0,R.join)(this.c,l.backupFolder);try{await w.Promises.rename(f,i)}catch(s){return this.l.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.g.push(l),!0}async getDirtyWorkspaces(){const f=[];for(const l of this.d)await this.A(l)&&f.push(l);for(const l of this.e)await this.A(l)&&f.push(l);return f}A(f){let l;return(0,m.isEmptyWindowBackupInfo)(f)?l=(0,R.join)(this.c,f.backupFolder):(0,v.isFolderBackupInfo)(f)?l=(0,R.join)(this.c,this.D(f)):l=(0,R.join)(this.c,f.workspace.id),this.B(l)}async B(f){try{const l=await w.Promises.readdir(f);for(const i of l)try{if((await w.Promises.readdir((0,R.join)(f,i))).length>0)return!0}catch{}}catch{}return!1}C(){const f={workspaces:this.d.map(({workspace:l,remoteAuthority:i})=>{const s={id:l.id,configURIPath:l.configPath.toString()};return i&&(s.remoteAuthority=i),s}),folders:this.e.map(({folderUri:l,remoteAuthority:i})=>{const s={folderUri:l.toString()};return i&&(s.remoteAuthority=i),s}),emptyWindows:this.g.map(({backupFolder:l,remoteAuthority:i})=>{const s={backupFolder:l};return i&&(s.remoteAuthority=i),s})};this.m.setItem(Tt.a,f)}D(f){const l=f.folderUri;let i;return l.scheme===k.Schemas.file?i=A.isLinux?l.fsPath:l.fsPath.toLowerCase():i=l.toString().toLowerCase(),(0,I.createHash)("md5").update(i).digest("hex")}};p.a="backupWorkspaces",p=pe([ne(0,P.IEnvironmentMainService),ne(1,y.IConfigurationService),ne(2,d.ILogService),ne(3,E.IStateMainService)],p),e.BackupMainService=p}),define(te[52],ie([0,1,13,3,43,34,2,15,9,20,12,23,175,62,57,27,5,6,19,51,118,28,94,95]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h,d,v,b,u,p,g,f,l,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,b.createDecorator)("workspacesManagementMainService");let n=class extends A.Disposable{constructor(r,c,o,S,D,L){super(),this.g=r,this.h=c,this.i=o,this.j=S,this.k=D,this.l=L,this.a=this.B(new t.Emitter),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new t.Emitter),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const r=(await P.Promises.readdir(this.c.fsPath)).map(c=>(0,m.joinPath)(this.c,c,l.UNTITLED_WORKSPACE_NAME));for(const c of r){const o=(0,s.getWorkspaceIdentifier)(c),S=await this.resolveLocalWorkspace(c);S?this.f.push({workspace:o,remoteAuthority:S.remoteAuthority}):await this.deleteUntitledWorkspace(o)}}catch(r){r.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${r}).`)}}resolveLocalWorkspace(r){return this.m(r,c=>P.Promises.readFile(c,"utf8"))}m(r,c){if(!!this.n(r)&&r.scheme===C.Schemas.file)try{const o=c(r.fsPath);return o instanceof Promise?o.then(S=>this.p(r,S),S=>{}):this.p(r,o)}catch{return}}n(r){return(0,l.isUntitledWorkspace)(r,this.g)||(0,l.hasWorkspaceFileExtension)(r)}p(r,c){try{const o=this.r(r,c),S=(0,s.getWorkspaceIdentifier)(r);return{id:S.id,configPath:S.configPath,folders:(0,i.toWorkspaceFolders)(o.folders,S.configPath,m.extUriBiasedIgnorePathCase),remoteAuthority:o.remoteAuthority,transient:o.transient}}catch(o){this.h.warn(o.toString())}}r(r,c){const o=(0,k.parse)(c);if(o&&Array.isArray(o.folders))o.folders=o.folders.filter(S=>(0,i.isStoredWorkspaceFolder)(S));else throw new Error(`${r.toString(!0)} looks like an invalid workspace file.`);return o}async createUntitledWorkspace(r,c){const{workspace:o,storedWorkspace:S}=this.s(r,c),D=o.configPath.fsPath;return await P.Promises.mkdir((0,w.dirname)(D),{recursive:!0}),await P.Promises.writeFile(D,JSON.stringify(S,null,"	")),this.f.push({workspace:o,remoteAuthority:c}),o}s(r=[],c){const o=(Date.now()+Math.round(Math.random()*1e3)).toString(),S=(0,m.joinPath)(this.c,o),D=(0,m.joinPath)(S,l.UNTITLED_WORKSPACE_NAME),L=[];for(const N of r)L.push((0,i.getStoredWorkspaceFolder)(N.uri,!0,N.name,S,m.extUriBiasedIgnorePathCase));return{workspace:(0,s.getWorkspaceIdentifier)(D),storedWorkspace:{folders:L,remoteAuthority:c}}}async getWorkspaceIdentifier(r){return(0,s.getWorkspaceIdentifier)(r)}isUntitledWorkspace(r){return(0,l.isUntitledWorkspace)(r.configPath,this.g)}async deleteUntitledWorkspace(r){!this.isUntitledWorkspace(r)||(await this.t(r),this.i.isEnabled()&&this.i.unsetWorkspace(r),this.a.fire(r))}async t(r){const c=(0,m.originalFSPath)(r.configPath);try{await P.Promises.rm((0,w.dirname)(c));const o=(0,w.join)(this.g.workspaceStorageHome.fsPath,r.id);await P.Promises.exists(o)&&await P.Promises.writeFile((0,w.join)(o,"obsolete"),""),this.f=this.f.filter(S=>S.workspace.id!==r.id)}catch(o){this.h.warn(`Unable to delete untitled workspace ${c} (${o}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(r,c,o){if(!r||!r.win||!r.isReady||!await this.u(r,c,o))return;const D=await this.v(r,(0,s.getWorkspaceIdentifier)(o));if(!!D)return this.b.fire({window:r,workspace:D.workspace}),D}async u(r,c,o){if(!o)return!0;if((0,l.isWorkspaceIdentifier)(r.openedWorkspace)&&m.extUriBiasedIgnorePathCase.isEqual(r.openedWorkspace.configPath,o))return!1;if((0,f.findWindowOnWorkspaceOrFolder)(c,o)){const S={title:this.l.nameLong,type:"info",buttons:[(0,R.mnemonicButtonLabel)((0,E.localize)(0,null))],message:(0,E.localize)(1,null,(0,m.basename)(o)),detail:(0,E.localize)(2,null),noLink:!0,defaultId:0};return await this.k.showMessageBox(S,(0,y.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow())),!1}return!0}async v(r,c){if(!r.config)return;r.focus();let o;return r.config.extensionDevelopmentPath||(r.config.backupPath?o=await this.j.registerWorkspaceBackup({workspace:c,remoteAuthority:r.remoteAuthority},r.config.backupPath):o=this.j.registerWorkspaceBackup({workspace:c,remoteAuthority:r.remoteAuthority})),(0,l.isWorkspaceIdentifier)(r.openedWorkspace)&&this.isUntitledWorkspace(r.openedWorkspace)&&await this.deleteUntitledWorkspace(r.openedWorkspace),r.config.workspace=c,r.config.backupPath=o,{workspace:c,backupPath:o}}};n=pe([ne(0,v.IEnvironmentMainService),ne(1,u.ILogService),ne(2,g.IUserDataProfilesMainService),ne(3,h.IBackupMainService),ne(4,d.IDialogMainService),ne(5,p.IProductService)],n),e.WorkspacesManagementMainService=n}),define(te[119],ie([0,1,13,41,22,5,32,28,52,12,6]),function(V,e,I,t,k,R,A,C,w,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let P=class{constructor(h,d,v){this.a=h,this.b=d,this.c=v}async getRemoteDiagnostics(h){const d=this.a.getWindows();return(await Promise.all(d.map(async b=>{const u=b.remoteAuthority;if(!u)return;const p=`vscode:getDiagnosticInfoResponse${b.id}`,g={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?await this.f(b):void 0};return new Promise(f=>{b.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:p,args:g}),t.validatedIpcMain.once(p,(l,i)=>{i||f({hostName:u,errorMessage:`Unable to resolve connection to '${u}'.`}),f(i)}),setTimeout(()=>{f({hostName:u,errorMessage:`Connection to '${u}' could not be established`})},5e3)})}))).filter(b=>!!b)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const h=[];for(const d of I.BrowserWindow.getAllWindows()){const v=this.a.getWindowById(d.id);v?h.push(await this.d(v)):h.push(this.e(d))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,screenReader:!!I.app.accessibilitySupportEnabled,gpuFeatureStatus:I.app.getGPUFeatureStatus()}}async d(h){const d=await this.f(h),v=(0,m.assertIsDefined)(h.win);return this.e(v,d,h.remoteAuthority)}e(h,d=[],v){return{pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:d,remoteAuthority:v}}async f(h){const d=[],v=h.openedWorkspace;if((0,C.isSingleFolderWorkspaceIdentifier)(v))d.push(v.uri);else if((0,C.isWorkspaceIdentifier)(v)){const b=await this.b.resolveLocalWorkspace(v.configPath);b&&b.folders.forEach(p=>{d.push(p.uri)})}return d}};P=pe([ne(0,A.IWindowsMainService),ne(1,w.IWorkspacesManagementMainService),ne(2,y.ILogService)],P),e.DiagnosticsMainService=P}),define(te[58],ie([0,1,46,13,25,141,53,3,34,2,15,9,4,7,100,81,23,97,165,57,27,5,21,6,19,66,32,28,52,17,223,216,36]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h,d,v,b,u,p,g,f,l,i,s,n,a,r,c,o,S,D,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,l.createDecorator)("nativeHostMainService");let X=class extends m.Disposable{constructor(J,Y,se,re,fe,K,le,$,W,T){super(),this.a=J,this.b=Y,this.c=se,this.f=re,this.g=fe,this.h=K,this.i=le,this.j=$,this.k=W,this.l=T,this.onDidOpenWindow=C.Event.map(this.b.onDidOpenWindow,z=>z.id),this.onDidTriggerSystemContextMenu=C.Event.filter(C.Event.map(this.b.onDidTriggerSystemContextMenu,({window:z,x:Q,y:q})=>({windowId:z.id,x:Q,y:q})),({windowId:z})=>!!this.b.getWindowById(z)),this.onDidMaximizeWindow=C.Event.filter(C.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(z,Q)=>Q.id),z=>!!this.b.getWindowById(z)),this.onDidUnmaximizeWindow=C.Event.filter(C.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(z,Q)=>Q.id),z=>!!this.b.getWindowById(z)),this.onDidBlurWindow=C.Event.filter(C.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(z,Q)=>Q.id),z=>!!this.b.getWindowById(z)),this.onDidFocusWindow=C.Event.any(C.Event.map(C.Event.filter(C.Event.map(this.b.onDidChangeWindowsCount,()=>this.b.getLastActiveWindow()),z=>!!z),z=>z.id),C.Event.filter(C.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(z,Q)=>Q.id),z=>!!this.b.getWindowById(z))),this.onDidResumeOS=C.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.m=this.B(new C.Emitter),this.onDidChangePassword=this.m.event,this.onDidChangeDisplay=C.Event.debounce(C.Event.any(C.Event.filter(C.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(z,Q,q)=>q),z=>!(Array.isArray(z)&&z.length===1&&z[0]==="workArea")),C.Event.fromNodeEventEmitter(t.screen,"display-added"),C.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.b.getWindows().map(Y=>({id:Y.id,workspace:Y.openedWorkspace??(0,c.toWorkspaceIdentifier)(Y.backupPath,Y.isExtensionDevelopmentHost),title:Y.win?.getTitle()??"",filename:Y.getRepresentedFilename(),dirty:Y.isDocumentEdited()}))}async getWindowCount(J){return this.b.getWindowCount()}async getActiveWindowId(J){const Y=t.BrowserWindow.getFocusedWindow()||this.b.getLastActiveWindow();if(Y)return Y.id}openWindow(J,Y,se){return Array.isArray(Y)?this.n(J,Y,se):this.p(J,Y)}async n(J,Y,se=Object.create(null)){Y.length>0&&await this.b.open({context:5,contextWindowId:J,urisToOpen:Y,cli:this.g.args,forceNewWindow:se.forceNewWindow,forceReuseWindow:se.forceReuseWindow,preferNewWindow:se.preferNewWindow,diffMode:se.diffMode,mergeMode:se.mergeMode,addMode:se.addMode,gotoLineMode:se.gotoLineMode,noRecentEntry:se.noRecentEntry,waitMarkerFileURI:se.waitMarkerFileURI,remoteAuthority:se.remoteAuthority||void 0})}async p(J,Y){await this.b.openEmptyWindow({context:5,contextWindowId:J},Y)}async toggleFullScreen(J){this.w(J)?.toggleFullScreen()}async handleTitleDoubleClick(J){this.w(J)?.handleTitleDoubleClick()}async isMaximized(J){const Y=this.w(J);return Y?.win?Y.win.isMaximized():!1}async maximizeWindow(J){const Y=this.w(J);Y?.win&&Y.win.maximize()}async unmaximizeWindow(J){const Y=this.w(J);Y?.win&&Y.win.unmaximize()}async minimizeWindow(J){const Y=this.w(J);Y?.win&&Y.win.minimize()}async updateWindowControls(J,Y){const se=this.w(J);se&&se.updateWindowControls(Y)}async focusWindow(J,Y){Y&&typeof Y.windowId=="number"&&(J=Y.windowId),this.w(J)?.focus({force:Y?.force??!1})}async setMinimumSize(J,Y,se){const re=this.w(J);if(re?.win){const[fe,K]=re.win.getSize(),[le,$]=re.win.getMinimumSize(),[W,T]=[Y??le,se??$],[z,Q]=[Math.max(fe,W),Math.max(K,T)];(le!==W||$!==T)&&re.win.setMinimumSize(W,T),(fe!==z||K!==Q)&&re.win.setSize(z,Q)}}async saveWindowSplash(J,Y){this.j.saveWindowSplash(J,Y)}async installShellCommand(J){const{source:Y,target:se}=await this.r();try{const{symbolicLink:re}=await b.SymlinkSupport.stat(Y);if(re&&!re.dangling){const fe=await(0,d.realpath)(Y);if(se===fe)return}await b.Promises.unlink(Y)}catch(re){if(re.code!=="ENOENT")throw re}try{await b.Promises.symlink(se,Y)}catch(re){if(re.code!=="EACCES"&&re.code!=="ENOENT")throw re;const{response:fe}=await this.showMessageBox(J,{title:this.i.nameLong,type:"info",message:(0,p.localize)(0,null,this.i.nameShort),buttons:[(0,w.mnemonicButtonLabel)((0,p.localize)(1,null)),(0,w.mnemonicButtonLabel)((0,p.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(fe===0)try{const K=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${se}' '${Y}'\\" with administrator privileges"`;await(0,R.promisify)(I.exec)(K)}catch{throw new Error((0,p.localize)(3,null,Y))}}}async uninstallShellCommand(J){const{source:Y}=await this.r();try{await b.Promises.unlink(Y)}catch(se){switch(se.code){case"EACCES":{const{response:re}=await this.showMessageBox(J,{title:this.i.nameLong,type:"info",message:(0,p.localize)(4,null,this.i.nameShort),buttons:[(0,w.mnemonicButtonLabel)((0,p.localize)(5,null)),(0,w.mnemonicButtonLabel)((0,p.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(re===0)try{const fe=`osascript -e "do shell script \\"rm '${Y}'\\" with administrator privileges"`;await(0,R.promisify)(I.exec)(fe)}catch{throw new Error((0,p.localize)(7,null,Y))}break}case"ENOENT":break;default:throw se}}}async r(){const J=(0,P.resolve)(this.g.appRoot,"bin","code"),Y=`/usr/local/bin/${this.i.applicationName}`;if(!await b.Promises.exists(J))throw new Error((0,p.localize)(8,null,J));return{source:Y,target:J}}async showMessageBox(J,Y){return this.c.showMessageBox(Y,this.s(J))}async showSaveDialog(J,Y){return this.c.showSaveDialog(Y,this.s(J))}async showOpenDialog(J,Y){return this.c.showOpenDialog(Y,this.s(J))}s(J){const Y=this.w(J);if(Y?.win)return Y.win}async pickFileFolderAndOpen(J,Y){const se=await this.c.pickFileFolder(Y);se&&await this.t(await Promise.all(se.map(async re=>await b.SymlinkSupport.existsDirectory(re)?{folderUri:h.URI.file(re)}:{fileUri:h.URI.file(re)})),Y,J)}async pickFolderAndOpen(J,Y){const se=await this.c.pickFolder(Y);se&&await this.t(se.map(re=>({folderUri:h.URI.file(re)})),Y,J)}async pickFileAndOpen(J,Y){const se=await this.c.pickFile(Y);se&&await this.t(se.map(re=>({fileUri:h.URI.file(re)})),Y,J)}async pickWorkspaceAndOpen(J,Y){const se=await this.c.pickWorkspace(Y);se&&await this.t(se.map(re=>({workspaceUri:h.URI.file(re)})),Y,J)}async t(J,Y,se){await this.b.open({context:3,contextWindowId:se,cli:this.g.args,urisToOpen:J,forceNewWindow:Y.forceNewWindow})}async showItemInFolder(J,Y){t.shell.showItemInFolder(Y)}async setRepresentedFilename(J,Y){this.w(J)?.setRepresentedFilename(Y)}async setDocumentEdited(J,Y){this.w(J)?.setDocumentEdited(Y)}async openExternal(J,Y){return E.isLinuxSnap?this.u(Y):t.shell.openExternal(Y),!0}u(J){const Y=process.env.GDK_PIXBUF_MODULE_FILE,se=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(J),process.env.GDK_PIXBUF_MODULE_FILE=Y,process.env.GDK_PIXBUF_MODULEDIR=se}moveItemToTrash(J,Y){return t.shell.trashItem(Y)}async isAdmin(){let J;return E.isWindows?J=(await new Promise((Y,se)=>{V(["native-is-elevated"],Y,se)}))():J=process.getuid()===0,J}async writeElevated(J,Y,se,re){const fe=await new Promise((K,le)=>{V(["@vscode/sudo-prompt"],K,le)});return new Promise((K,le)=>{const $=[`"${this.v}"`];re?.unlock&&$.push("--file-chmod"),$.push("--file-write",`"${Y.fsPath}"`,`"${se.fsPath}"`);const W={name:this.i.nameLong.replace("-",""),icns:E.isMacintosh&&this.g.isBuilt?(0,P.join)((0,P.dirname)(this.g.appRoot),`${this.i.nameShort}.icns`):void 0};fe.exec($.join(" "),W,(T,z,Q)=>{z&&this.h.trace(`[sudo-prompt] received stdout: ${z}`),Q&&this.h.trace(`[sudo-prompt] received stderr: ${Q}`),T?le(T):K(void 0)})})}get v(){return E.isWindows?this.g.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.i.applicationName}.cmd`):(0,P.join)(this.g.appRoot,"scripts","code-cli.bat"):E.isLinux?this.g.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.i.applicationName}`):(0,P.join)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,P.join)(this.g.appRoot,"bin","code"):(0,P.join)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return v.virtualMachineHint.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return E.isWindows&&(0,D.hasWSLFeatureInstalled)()}async killProcess(J,Y,se){process.kill(Y,se)}async readClipboardText(J,Y){return t.clipboard.readText(Y)}async writeClipboardText(J,Y,se){return t.clipboard.writeText(Y,se)}async readClipboardFindText(J){return t.clipboard.readFindText()}async writeClipboardFindText(J,Y){return t.clipboard.writeFindText(Y)}async writeClipboardBuffer(J,Y,se,re){return t.clipboard.writeBuffer(Y,Buffer.from(se.buffer),re)}async readClipboardBuffer(J,Y){return S.VSBuffer.wrap(t.clipboard.readBuffer(Y))}async hasClipboard(J,Y,se){return t.clipboard.has(Y,se)}async newWindowTab(){await this.b.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(J,Y){this.w(J)?.updateTouchBar(Y)}async notifyReady(J){this.w(J)?.setReady()}async relaunch(J,Y){return this.f.relaunch(Y)}async reload(J,Y){const se=this.w(J);if(se){if((0,c.isWorkspaceIdentifier)(se.openedWorkspace)){const re=se.openedWorkspace.configPath;if(re.scheme===y.Schemas.file&&(await this.l.resolveLocalWorkspace(re))?.transient)return this.openWindow(se.id,{forceReuseWindow:!0})}return this.f.reload(se,Y?.disableExtensions!==void 0?{_:[],"disable-extensions":Y.disableExtensions}:void 0)}}async closeWindow(J){this.closeWindowById(J,J)}async closeWindowById(J,Y){const se=this.w(Y);if(se?.win)return se.win.close()}async quit(J){const Y=this.b.getLastActiveWindow();Y?.isExtensionDevelopmentHost&&this.b.getWindowCount()>1&&Y.win?Y.win.close():this.f.quit()}async exit(J,Y){await this.f.kill(Y)}async resolveProxy(J,Y){const re=this.w(J)?.win?.webContents?.session;if(re)return re.resolveProxy(Y)}findFreePort(J,Y,se,re,fe=1){return(0,u.findFreePort)(Y,se,re,fe)}async openDevTools(J,Y){const se=this.w(J);se?.win&&se.win.webContents.openDevTools(Y)}async toggleDevTools(J){const Y=this.w(J);Y?.win&&Y.win.webContents.toggleDevTools()}async sendInputEvent(J,Y){const se=this.w(J);se?.win&&(Y.type==="mouseDown"||Y.type==="mouseUp")&&se.win.webContents.sendInputEvent(Y)}async enableSandbox(J,Y){Y?this.k.setItem("window.experimental.useSandbox",!0):this.k.removeItem("window.experimental.useSandbox")}async toggleSharedProcessWindow(){return this.a.toggle()}async profileRenderer(J,Y,se){const re=this.w(J);if(!re||!re.win)throw new Error;return await new L.WindowProfiler(re.win,Y,this.h).inspect(se)}async windowsGetStringRegKey(J,Y,se,re){if(!E.isWindows)return;const fe=await new Promise((K,le)=>{V(["@vscode/windows-registry"],K,le)});try{return fe.GetStringRegKey(Y,se,re)}catch{return}}w(J){if(typeof J=="number")return this.b.getWindowById(J)}};pe([A.memoize],X.prototype,"v",null),X=pe([ne(1,r.IWindowsMainService),ne(2,g.IDialogMainService),ne(3,i.ILifecycleMainService),ne(4,f.IEnvironmentMainService),ne(5,s.ILogService),ne(6,n.IProductService),ne(7,a.IThemeMainService),ne(8,N.IStateMainService),ne(9,o.IWorkspacesManagementMainService)],X),e.NativeHostMainService=X}),define(te[267],ie([0,1,13,41,25,34,2,15,4,101,163,84,119,57,27,5,6,58,63,19,64,74,30,12]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h,d,v,b,u,p,g,f,l,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,v.createDecorator)("issueMainService");let n=class jt{constructor(r,c,o,S,D,L,N,X,ae){this.g=r,this.h=c,this.i=o,this.j=S,this.k=D,this.l=L,this.m=N,this.n=X,this.o=ae,this.b=null,this.c=null,this.d=null,this.f=null,this.p()}p(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async r=>{const[c,o]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),S=await this.j.getSystemInfo(c,o);this.q(r,"vscode:issueSystemInfoResponse",S)}),t.validatedIpcMain.on("vscode:listProcesses",async r=>{const c=[];try{c.push({name:(0,y.localize)(0,null),rootProcess:await(0,m.listProcesses)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(S=>{(0,P.isRemoteDiagnosticError)(S)?c.push({name:S.hostName,rootProcess:S}):S.processes&&c.push({name:S.hostName,rootProcess:S.processes})})}catch(o){this.i.error(`Listing processes failed: ${o}`)}this.q(r,"vscode:listProcessesResponse",c)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async r=>{const c={title:this.o.nameLong,message:(0,y.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,y.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,y.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.b){const o=await this.l.showMessageBox(c,this.b);this.q(r,"vscode:issueReporterClipboardResponse",o.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async r=>{const c=await this.u();this.q(r,"vscode:issuePerformanceInfoResponse",c)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const r={title:this.o.nameLong,message:(0,y.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,y.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,y.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.b&&(await this.l.showMessageBox(r,this.b)).response===0&&this.b&&(this.b.destroy(),this.b=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(r,c)=>{const{id:o,from:S,args:D}=c;let L;switch(S){case"issueReporter":L=this.c;break;case"processExplorer":L=this.f;break;default:throw new Error(`Unexpected command source: ${S}`)}L?.webContents.send("vscode:runAction",{id:o,from:S,args:D})}),t.validatedIpcMain.on("vscode:openExternal",(r,c)=>{this.m.openExternal(void 0,c)}),t.validatedIpcMain.on("vscode:closeIssueReporter",r=>{this.b?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",r=>{this.d?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async r=>{const c=await this.k.getMainDiagnostics();this.q(r,"vscode:windowsInfoResponse",c.windows)})}q(r,c,...o){r.sender.isDestroyed()||r.sender.send(c,...o)}async openReporter(r){if(!this.b&&(this.c=I.BrowserWindow.getFocusedWindow(),this.c)){const c=new A.DisposableStore,o=c.add(this.n.createIPCObjectUrl()),S=this.t(this.c,700,800);this.b=this.s(S,o,{backgroundColor:r.styles.backgroundColor,title:(0,y.localize)(7,null),zoomLevel:r.zoomLevel,alwaysOnTop:!1},"issue-reporter"),o.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:r,disableExtensions:!!this.h.disableExtensions,os:{type:(0,k.type)(),arch:(0,k.arch)(),release:(0,k.release)()},product:p.default}),this.b.loadURL(C.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,c.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,c.dispose())})}this.b&&this.r(this.b)}async openProcessExplorer(r){if(!this.d&&(this.f=I.BrowserWindow.getFocusedWindow(),this.f)){const c=new A.DisposableStore,o=c.add(this.n.createIPCObjectUrl()),S=this.t(this.f,800,500);this.d=this.s(S,o,{backgroundColor:r.styles.backgroundColor,title:(0,y.localize)(8,null),zoomLevel:r.zoomLevel,alwaysOnTop:!0},"process-explorer"),o.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:r,product:p.default}),this.d.loadURL(C.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,c.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,c.dispose())})}this.d&&this.r(this.d)}r(r){r.isMinimized()&&r.restore(),r.focus()}s(r,c,o,S){const D=new I.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:r.width,height:r.height,minWidth:300,minHeight:200,x:r.x,y:r.y,title:o.title,backgroundColor:o.backgroundColor||jt.a,webPreferences:{preload:C.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${c.resource.toString()}`,`--vscode-window-kind=${S}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,l.zoomLevelToZoomFactor)(o.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:o.alwaysOnTop,experimentalDarkMode:!0});return D.setMenuBarVisibility(!1),D}async getSystemStatus(){const[r,c]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(r,c)}t(r,c,o){let S;const D=I.screen.getAllDisplays();if(D.length===1)S=D[0];else{if(w.isMacintosh){const X=I.screen.getCursorScreenPoint();S=I.screen.getDisplayNearestPoint(X)}!S&&r&&(S=I.screen.getDisplayMatching(r.getBounds())),S||(S=I.screen.getPrimaryDisplay()||D[0])}const L={width:c,height:o},N=S.bounds;return L.x=N.x+N.width/2-L.width/2,L.y=N.y+N.height/2-L.height/2,N.width>0&&N.height>0&&(L.x<N.x&&(L.x=N.x),L.y<N.y&&(L.y=N.y),L.x>N.x+N.width&&(L.x=N.x),L.y>N.y+N.height&&(L.y=N.y),L.width>N.width&&(L.width=N.width),L.height>N.height&&(L.height=N.height)),L}async u(){try{const[r,c]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(r,c)}catch(r){throw this.i.warn("issueService#getPerformanceInfo ",r.message),r}}async stopTracing(){if(!this.h.args.trace)return;const r=await I.contentTracing.stopRecording(`${(0,i.randomPath)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({title:this.o.nameLong,type:"info",message:(0,y.localize)(9,null),detail:(0,y.localize)(10,null,r),buttons:[(0,R.mnemonicButtonLabel)((0,y.localize)(11,null))],defaultId:0,noLink:!0},(0,s.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,r)}};n.a="#1E1E1E",n=pe([ne(1,d.IEnvironmentMainService),ne(2,b.ILogService),ne(3,P.IDiagnosticsService),ne(4,E.IDiagnosticsMainService),ne(5,h.IDialogMainService),ne(6,u.INativeHostMainService),ne(7,f.IProtocolMainService),ne(8,g.IProductService)],n),e.IssueMainService=n}),define(te[268],ie([0,1,22,18,27,21,6,58,19,55,31,49,90]),function(V,e,I,t,k,R,A,C,w,m,y,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let h=class extends E.AbstractUpdateService{constructor(v,b,u,p,g,f,l,i){super(v,b,p,g,f,i),this.e=u,this.u=l}s(v){return(0,E.createUpdateURL)(`linux-${process.arch}`,v,this.k)}t(v){!this.a||(this.d(P.State.CheckingForUpdates(v)),this.i.request({url:this.a},I.CancellationToken.None).then(m.asJson).then(b=>{!b||!b.url||!b.version||!b.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!v}),this.d(P.State.Idle(1))):this.d(P.State.AvailableForDownload(b))}).then(void 0,b=>{this.j.error(b),this.e.publicLog2("update:notAvailable",{explicit:!!v});const u=v?b.message||b:void 0;this.d(P.State.Idle(1,u))}))}async o(v){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):v.update.url&&this.u.openExternal(void 0,v.update.url),this.d(P.State.Idle(1))}};h=pe([ne(0,R.ILifecycleMainService),ne(1,t.IConfigurationService),ne(2,y.ITelemetryService),ne(3,k.IEnvironmentMainService),ne(4,m.IRequestService),ne(5,A.ILogService),ne(6,C.INativeHostMainService),ne(7,w.IProductService)],h),e.LinuxUpdateService=h}),define(te[269],ie([0,1,46,40,25,8,22,53,9,7,127,23,18,27,16,21,6,58,19,55,31,49,90]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h,d,v,b,u,p,g,f,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function s(c,o=1e3){for(;!c();)await(0,R.timeout)(o)}let n;function a(){return typeof n>"u"&&(n=t.existsSync(w.join(w.dirname(process.execPath),"unins000.exe"))?0:1),n}let r=class extends i.AbstractUpdateService{get cachePath(){const o=w.join((0,k.tmpdir)(),`vscode-update-${this.k.target}-${process.arch}`);return P.Promises.mkdir(o,{recursive:!0}).then(()=>o)}constructor(o,S,D,L,N,X,ae,J,Y){super(o,S,L,N,X,Y),this.u=D,this.v=ae,this.w=J}async initialize(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}s(o){let S="win32";return process.arch!=="ia32"&&(S+=`-${process.arch}`),a()===1?S+="-archive":this.k.target==="user"&&(S+="-user"),(0,i.createUpdateURL)(S,o,this.k)}t(o){!this.a||(this.d(l.State.CheckingForUpdates(o)),this.i.request({url:this.a},A.CancellationToken.None).then(g.asJson).then(S=>{const D=a();return!S||!S.url||!S.version||!S.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!o}),this.d(l.State.Idle(D)),Promise.resolve(null)):D===1?(this.d(l.State.AvailableForDownload(S)),Promise.resolve(null)):(this.d(l.State.Downloading(S)),this.B(S.version).then(()=>this.A(S.version).then(L=>P.Promises.exists(L).then(N=>{if(N)return Promise.resolve(L);const X=S.url,ae=S.hash,J=`${L}.tmp`;return this.i.request({url:X},A.CancellationToken.None).then(Y=>this.v.writeFile(m.URI.file(J),Y.stream)).then(ae?()=>(0,y.checksum)(J,S.hash):()=>{}).then(()=>P.Promises.rename(J,L)).then(()=>L)})).then(L=>{const N=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:L},N&&S.supportsFastUpdate?this.k.target==="user"?this.p():this.d(l.State.Downloaded(S)):this.d(l.State.Ready(S))})))}).then(void 0,S=>{this.j.error(S),this.u.publicLog2("update:notAvailable",{explicit:!!o});const D=o?S.message||S:void 0;this.d(l.State.Idle(a(),D))}))}async o(o){o.update.url&&this.w.openExternal(void 0,o.update.url),this.d(l.State.Idle(a()))}async A(o){const S=await this.cachePath;return w.join(S,`CodeSetup-${this.k.quality}-${o}.exe`)}async B(o=null){const S=o?X=>!new RegExp(`${this.k.quality}-${o}\\.exe$`).test(X):()=>!0,D=await this.cachePath,N=(await P.Promises.readdir(D)).filter(S).map(async X=>{try{await P.Promises.unlink(w.join(D,X))}catch{}});await Promise.all(N)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const o=this.state.update;this.d(l.State.Updating(o));const S=await this.cachePath;this.e.updateFilePath=w.join(S,`CodeSetup-${this.k.quality}-${o.version}.flag`),await P.Promises.writeFile(this.e.updateFilePath,"flag"),(0,I.spawn)(this.e.packagePath,["/verysilent",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(l.State.Idle(a()))});const L=`${this.k.win32MutexName}-ready`,N=await new Promise((X,ae)=>{V(["windows-mutex"],X,ae)});s(()=>N.isActive(L)).then(()=>this.d(l.State.Ready(o)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?t.unlinkSync(this.e.updateFilePath):(0,I.spawn)(this.e.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return a()}async _applySpecificUpdate(o){if(this.state.type!=="idle")return;const S=this.g.getValue("update.enableWindowsBackgroundUpdates"),D={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!S};this.d(l.State.Downloading(D)),this.e={packagePath:o},S?this.k.target==="user"?this.p():this.d(l.State.Downloaded(D)):this.d(l.State.Ready(D))}};pe([C.memoize],r.prototype,"cachePath",null),r=pe([ne(0,v.ILifecycleMainService),ne(1,E.IConfigurationService),ne(2,f.ITelemetryService),ne(3,h.IEnvironmentMainService),ne(4,g.IRequestService),ne(5,b.ILogService),ne(6,d.IFileService),ne(7,u.INativeHostMainService),ne(8,p.IProductService)],r),e.Win32UpdateService=r}),define(te[270],ie([0,1,13,8,22,45,3,34,2,15,9,73,4,7,171,62,18,57,27,61,16,21,6,19,64,234,93,31,239,66,74,32,28,52,116,121,37,36,51,58,236,112,56,89,25,113]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h,d,v,b,u,p,g,f,l,i,s,n,a,r,c,o,S,D,L,N,X,ae,J,Y,se,re,fe,K,le,$,W,T,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Q;(function(j){j[j.NONE=0]="NONE",j[j.NAVIGATING=1]="NAVIGATING",j[j.READY=2]="READY"})(Q||(Q={}));let q=class gt extends w.Disposable{get id(){return this.k}get win(){return this.l}get lastFocusTime(){return this.m}get backupPath(){return this.n?.backupPath}get openedWorkspace(){return this.n?.workspace}get profile(){if(!this.config)return;const M=this.O.profiles.find(O=>O.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&M?M:this.O.getOrSetProfileForWorkspace(this.config.workspace??"empty-window",M??this.O.defaultProfile)}get remoteAuthority(){return this.n?.remoteAuthority}get config(){return this.n}get isExtensionDevelopmentHost(){return!!this.n?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.n?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.n?.debugId}constructor(M,O,F,U,H,x,B,_,Z,oe,ge,ke,Oe,De,Le,be,we,ye,Me,ee){super(),this.L=O,this.M=F,this.N=U,this.O=H,this.P=x,this.Q=B,this.R=_,this.S=Z,this.U=oe,this.W=ge,this.X=ke,this.Y=Oe,this.Z=De,this.ab=Le,this.bb=be,this.db=we,this.eb=ye,this.fb=Me,this.gb=ee,this.c=this.B(new A.Emitter),this.onWillLoad=this.c.event,this.f=this.B(new A.Emitter),this.onDidSignalReady=this.f.event,this.g=this.B(new A.Emitter),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.B(new A.Emitter),this.onDidClose=this.h.event,this.j=this.B(new A.Emitter),this.onDidDestroy=this.j.event,this.m=-1,this.t=void 0,this.u=void 0,this.z=!1,this.C=[],this.D=[],this.F=void 0,this.G=void 0,this.H=this.B(this.db.createIPCObjectUrl()),this.J=!1,this.hb=0;{const[he,de]=this.sb(M.state);this.r=he,this.L.trace("window#ctor: using window state",he);const ve=this.r.mode===0||this.r.mode===3;typeof gt.b>"u"&&(gt.b=this.fb.getItem("window.experimental.useSandbox",!1));const Pe=this.S.getValue("window");let We=!1;typeof Pe?.experimental?.useSandbox=="boolean"?We=Pe.experimental.useSandbox:this.bb.quality==="stable"&&gt.b?We=!0:We=typeof this.bb.quality=="string"&&this.bb.quality!=="stable";const Te={width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y,backgroundColor:this.U.getBackgroundColor(),minWidth:D.WindowMinimumSize.WIDTH,minHeight:D.WindowMinimumSize.HEIGHT,show:!ve,title:this.bb.nameLong,webPreferences:{preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.H.resource.toString()}`],v8CacheOptions:this.M.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,D.zoomLevelToZoomFactor)(Pe?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...We?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};E.isLinux?Te.icon=(0,y.join)(this.M.appRoot,"resources/linux/code.png"):E.isWindows&&!this.M.isBuilt&&(Te.icon=(0,y.join)(this.M.appRoot,"resources/win32/code_150x150.png")),E.isMacintosh&&!this.zb()&&(Te.fullscreenable=!1),E.isMacintosh&&(Te.acceptFirstMouse=!0,Pe?.clickThroughInactive===!1&&(Te.acceptFirstMouse=!1));const qe=E.isMacintosh&&Pe?.nativeTabs===!0;qe&&(Te.tabbingIdentifier=this.bb.nameShort);const Ue=(0,D.getTitleBarStyle)(this.S)==="custom";if(Ue&&(Te.titleBarStyle="hidden",E.isMacintosh||(Te.frame=!1),(0,D.useWindowControlsOverlay)(this.S))){const je=this.U.getWindowSplash()?.colorInfo.titleBarBackground??this.U.getBackgroundColor(),Je=J.Color.fromHex(je).isDarker()?"#FFFFFF":"#000000";Te.titleBarOverlay={height:29,color:je,symbolColor:Je},this.z=!0}if((0,P.mark)("code/willCreateCodeBrowserWindow"),this.l=new I.BrowserWindow(Te),(0,P.mark)("code/didCreateCodeBrowserWindow"),this.k=this.l.id,E.isMacintosh&&Ue&&this.l.setSheetOffset(22),Ue&&(E.isWindows&&(0,D.useWindowControlsOverlay)(this.S)||E.isMacintosh)){const je=this.fb.getItem(gt.a);je&&this.updateWindowControls({height:je})}E.isWindows&&Ue&&this.l.hookWindowMessage(278,()=>{const[Je,$e]=this.l.getPosition(),Ke=I.screen.getCursorScreenPoint(),G=Ke.x-Je,ce=Ke.y-$e;return(()=>!(G>30&&ce>=0&&ce<=Math.max(this.l.getBounds().height*.15,35)))()||(this.l.setEnabled(!1),this.l.setEnabled(!0),this.g.fire({x:G,y:ce})),0}),(E.isMacintosh||E.isWindows)&&de&&(!qe||I.BrowserWindow.getAllWindows().length===1)&&[this.r.width,this.r.height,this.r.x,this.r.y].every(je=>typeof je=="number")&&this.l.setBounds({width:this.r.width,height:this.r.height,x:this.r.x,y:this.r.y}),ve&&((0,P.mark)("code/willMaximizeCodeWindow"),this.l.maximize(),this.r.mode===3&&this.vb(!0),this.l.show(),(0,P.mark)("code/didMaximizeCodeWindow")),this.m=Date.now()}this.M.args["open-devtools"]===!0&&this.l.webContents.openDevTools(),this.pb(),this.Db(),this.ib()}setRepresentedFilename(M){E.isMacintosh?this.l.setRepresentedFilename(M):this.v=M}getRepresentedFilename(){return E.isMacintosh?this.l.getRepresentedFilename():this.v}setDocumentEdited(M){E.isMacintosh&&this.l.setDocumentEdited(M),this.w=M}isDocumentEdited(){return E.isMacintosh?this.l.isDocumentEdited():!!this.w}focus(M){E.isMacintosh&&M?.force&&I.app.focus({steal:!0}),this.l&&(this.l.isMinimized()&&this.l.restore(),this.l.focus())}setReady(){for(this.L.trace(`window#load: window reported ready (id: ${this.k})`),this.hb=2;this.C.length;)this.C.pop()(this);this.f.fire()}ready(){return new Promise(M=>{if(this.isReady)return M(this);this.C.push(M)})}get isReady(){return this.hb===2}get whenClosedOrLoaded(){return new Promise(M=>{function O(){F.dispose(),U.dispose(),M()}const F=this.onDidClose(()=>O()),U=this.onWillLoad(()=>O())})}ib(){this.l.on("unresponsive",()=>this.lb(1)),this.l.webContents.on("render-process-gone",(O,F)=>this.lb(2,F)),this.l.webContents.on("did-fail-load",(O,F,U)=>this.lb(3,{reason:U,exitCode:F})),this.l.webContents.on("will-prevent-unload",O=>{O.preventDefault()}),this.l.on("closed",()=>{this.h.fire(),this.dispose()}),this.l.webContents.on("did-finish-load",()=>{this.I&&(this.n=this.I,this.I=void 0)}),this.l.on("focus",()=>{this.m=Date.now()}),this.l.on("maximize",O=>{this.n&&(this.n.maximized=!0),I.app.emit("browser-window-maximize",O,this.l)}),this.l.on("unmaximize",O=>{this.n&&(this.n.maximized=!1),I.app.emit("browser-window-unmaximize",O,this.l)}),this.l.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.l.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None),this.u?.complete(),this.u=void 0}),this.B(this.S.onDidChangeConfiguration(O=>this.pb(O))),this.B(this.W.onDidDeleteUntitledWorkspace(O=>this.ob(O)));const M=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.l.webContents.session.webRequest.onBeforeSendHeaders({urls:M},async(O,F)=>{const U=await this.kb();F({cancel:!1,requestHeaders:Object.assign(O.requestHeaders,U)})})}kb(){return this.jb||(this.jb=(0,a.resolveMarketplaceHeaders)(this.bb.version,this.bb,this.M,this.S,this.P,this.Q,this.Y)),this.jb}async lb(M,O){switch(M){case 2:this.L.error(`CodeWindow: renderer process gone (reason: ${O?.reason||"<unknown>"}, code: ${O?.exitCode||"<unknown>"})`);break;case 1:this.L.error("CodeWindow: detected unresponsive");break;case 3:this.L.error(`CodeWindow: failed to load (reason: ${O?.reason||"<unknown>"}, code: ${O?.exitCode||"<unknown>"})`);break}switch(this.Y.publicLog2("windowerror",{type:M,reason:O?.reason,code:O?.exitCode}),M){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.ab.kill(1);return}if(this.M.args["enable-smoke-test-driver"]){await this.nb(!1,!1),this.ab.quit();return}if(M===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.l&&this.l.webContents&&this.l.webContents.isDevToolsOpened())return;const F=await this.Z.showMessageBox({title:this.bb.nameLong,type:"warning",buttons:[(0,C.mnemonicButtonLabel)((0,d.localize)(0,null)),(0,C.mnemonicButtonLabel)((0,d.localize)(1,null)),(0,C.mnemonicButtonLabel)((0,d.localize)(2,null))],message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this.n?.workspace?(0,d.localize)(5,null):void 0},this.l);if(F.response!==1){const U=F.response===0;await this.nb(U,F.checkboxChecked)}}else if(M===2)if(E.isWindows&&O?.reason==="launch-failed"&&O.exitCode===18&&await this.gb.isAdmin(void 0))await this.mb(O);else{let F;O?F=(0,d.localize)(7,null,O.reason,O.exitCode??"<unknown>"):F=(0,d.localize)(6,null);const U=await this.Z.showMessageBox({title:this.bb.nameLong,type:"warning",buttons:[(0,C.mnemonicButtonLabel)((0,d.localize)(8,null)),(0,C.mnemonicButtonLabel)((0,d.localize)(9,null))],message:F,detail:(0,d.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this.n?.workspace?(0,d.localize)(11,null):void 0},this.l),H=U.response===0;await this.nb(H,U.checkboxChecked)}break}}async mb(M){const O=[],F=(0,$.isInternalTelemetry)(this.bb,this.S);if((0,$.supportsTelemetry)(this.bb,this.M)){this.bb.aiConfig&&this.bb.aiConfig.ariaKey&&O.push(new K.OneDataSystemAppender(F,"monacoworkbench",null,this.bb.aiConfig.ariaKey));const{installSourcePath:U}=this.M,H=await(0,z.resolveMachineId)(this.fb),x={appenders:O,sendErrorTelemetry:!1,commonProperties:(0,W.resolveCommonProperties)(this.P,(0,T.release)(),(0,T.hostname)(),process.arch,this.bb.commit,this.bb.version,H,F,U),piiPaths:(0,$.getPiiPathsFromEnvironment)(this.M)};await new le.TelemetryService(x,this.S,this.bb).publicLog2("windowadminerror",{reason:M.reason,code:M.exitCode})}await this.Z.showMessageBox({title:this.bb.nameLong,type:"error",buttons:[(0,C.mnemonicButtonLabel)((0,d.localize)(12,null))],message:(0,d.localize)(13,null),detail:(0,d.localize)(14,null,this.bb.nameLong),noLink:!0,defaultId:0},this.l),await Promise.all(O.map(U=>U.flush())),await this.nb(!1,!1)}async nb(M,O){const F=this.n?.workspace;if(O&&F)try{const U=this.R.workspaceStorage(F);await U.init(),U.delete("memento/workbench.parts.editor"),await U.close()}catch(U){this.L.error(U)}if(this.j.fire(),this.l?.destroy(),M&&this.n){let U,H;(0,N.isSingleFolderWorkspaceIdentifier)(F)?U={folderUri:F.uri}:(0,N.isWorkspaceIdentifier)(F)?U={workspaceUri:F.configPath}:H=!0;const[x]=await this.eb.open({context:5,userEnv:this.n.userEnv,cli:{...this.M.args,_:[]},urisToOpen:U?[U]:void 0,forceEmpty:H,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});x.focus()}}ob(M){this.n?.workspace?.id===M.id&&(this.n.workspace=void 0)}pb(M){const O=this.Ab();O!==this.s&&(this.s=O,this.Bb(O));let F=(this.S.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;F?.endsWith("/")&&(F=F.substr(0,F.length-1));const U=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((F||"").indexOf("@")===-1&&(F!==this.F||U!==this.G)){this.F=F,this.G=U;const H=F||"",x=U?`${U},<local>`:"<local>";this.L.trace(`Setting proxy to '${H}', bypassing '${x}'`),this.l.webContents.session.setProxy({proxyRules:H,proxyBypassRules:x,pacScript:""})}}addTabbedWindow(M){E.isMacintosh&&M.win&&this.l.addTabbedWindow(M.win)}load(M,O=Object.create(null)){this.L.trace(`window#load: attempt to load window (id: ${this.k})`),this.isDocumentEdited()&&(!O.isReload||!this.X.isHotExitEnabled())&&this.setDocumentEdited(!1),O.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.l.setTitle(this.bb.nameLong)),this.qb(M,O),this.hb===0?this.n=M:this.I=M,this.hb=1,this.l.loadURL(m.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.M.isBuilt?"":"-dev"}.html`).toString(!0));const F=this.J;this.J=!0,!this.M.isBuilt&&!this.M.extensionTestsLocationURI&&this.B(new t.RunOnceScheduler(()=>{this.l&&!this.l.isVisible()&&!this.l.isMinimized()&&(this.l.show(),this.focus({force:!0}),this.l.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:M.workspace,reason:O.isReload?3:F?2:1})}qb(M,O){const F=(this.n??this.I)?.userEnv;if(F){const U=(0,g.isLaunchedFromCli)(F)&&!(0,g.isLaunchedFromCli)(M.userEnv),H=this.isExtensionDevelopmentHost;(U||H)&&(M.userEnv={...F,...M.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(M.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),O.disableExtensions!==void 0&&(M["disable-extensions"]=O.disableExtensions),M.fullscreen=this.isFullScreen,M.maximized=this.l.isMaximized(),M.partsSplash=this.U.getWindowSplash(),(0,P.mark)("code/willOpenNewWindow"),M.perfMarks=(0,P.getMarks)(),this.H.update(M)}async reload(M){const O=Object.assign({},this.n);O.workspace=await this.rb(O),delete O.filesToOpenOrCreate,delete O.filesToDiff,delete O.filesToMerge,delete O.filesToWait,this.isExtensionDevelopmentHost&&M&&(O.verbose=M.verbose,O.debugId=M.debugId,O.extensionEnvironment=M.extensionEnvironment,O["inspect-extensions"]=M["inspect-extensions"],O["inspect-brk-extensions"]=M["inspect-brk-extensions"],O["extensions-dir"]=M["extensions-dir"]),O.isInitialStartup=!1,O.policiesData=this.N.serialize(),O.continueOn=this.M.continueOn,O.profiles={all:this.O.profiles,profile:this.profile||this.O.defaultProfile},O.logLevel=this.L.getLevel(),this.load(O,{isReload:!0,disableExtensions:M?.["disable-extensions"]})}async rb(M){if((0,N.isWorkspaceIdentifier)(M.workspace)){const O=M.workspace.configPath;if(O.scheme===m.Schemas.file&&!await this.P.exists(O))return}else if((0,N.isSingleFolderWorkspaceIdentifier)(M.workspace)){const O=M.workspace.uri;if(O.scheme===m.Schemas.file&&!await this.P.exists(O))return}return M.workspace}serializeWindowState(){if(!this.l)return(0,ae.defaultWindowState)();if(this.isFullScreen){let F;try{F=I.screen.getDisplayMatching(this.getBounds())}catch{}const U=(0,ae.defaultWindowState)();return{mode:3,display:F?F.id:void 0,width:this.r.width||U.width,height:this.r.height||U.height,x:this.r.x||0,y:this.r.y||0}}const M=Object.create(null);let O;if(!E.isMacintosh&&this.l.isMaximized()?O=0:O=1,O===0?M.mode=0:M.mode=1,O===1||O===0){let F;O===1?F=this.getBounds():F=this.l.getNormalBounds(),M.x=F.x,M.y=F.y,M.width=F.width,M.height=F.height}return M}updateWindowControls(M){if(M.height&&this.fb.setItem(gt.a,M.height),E.isWindows&&this.z)this.l.setTitleBarOverlay({color:M.backgroundColor?.trim()===""?void 0:M.backgroundColor,symbolColor:M.foregroundColor?.trim()===""?void 0:M.foregroundColor,height:M.height?M.height-1:void 0});else if(E.isMacintosh&&M.height!==void 0){const O=(M.height-15)/2;this.l.setTrafficLightPosition({x:O,y:O})}}sb(M){(0,P.mark)("code/willRestoreCodeWindowState");let O=!1;if(M)try{const F=I.screen.getAllDisplays();O=F.length>1,M=this.tb(M,F)}catch(F){this.L.warn(`Unexpected error validating window state: ${F}
${F.stack}`)}return(0,P.mark)("code/didRestoreCodeWindowState"),[M||(0,ae.defaultWindowState)(),O]}tb(M,O){if(this.L.trace(`window#validateWindowState: validating window state on ${O.length} display(s)`,M),typeof M.x!="number"||typeof M.y!="number"||typeof M.width!="number"||typeof M.height!="number"){this.L.trace("window#validateWindowState: unexpected type of state values");return}if(M.width<=0||M.height<=0){this.L.trace("window#validateWindowState: unexpected negative values");return}if(O.length===1){const H=this.ub(O[0]);if(H){let x=function(){!M||typeof M.x!="number"||typeof M.y!="number"||!H||(M.x<H.x&&(M.x=H.x),M.y<H.y&&(M.y=H.y))};this.L.trace("window#validateWindowState: 1 monitor working area",H),x(),M.width>H.width&&(M.width=H.width),M.height>H.height&&(M.height=H.height),M.x>H.x+H.width-128&&(M.x=H.x+H.width-M.width),M.y>H.y+H.height-128&&(M.y=H.y+H.height-M.height),x()}return M}if(M.display&&M.mode===3){const H=O.find(x=>x.id===M.display);if(H&&typeof H.bounds?.x=="number"&&typeof H.bounds?.y=="number"){this.L.trace("window#validateWindowState: restoring fullscreen to previous display");const x=(0,ae.defaultWindowState)(3);return x.x=H.bounds.x,x.y=H.bounds.y,x}}let F,U;try{F=I.screen.getDisplayMatching({x:M.x,y:M.y,width:M.width,height:M.height}),U=this.ub(F)}catch{}if(F&&U&&M.x+M.width>U.x&&M.y+M.height>U.y&&M.x<U.x+U.width&&M.y<U.y+U.height)return this.L.trace("window#validateWindowState: multi-monitor working area",U),M}ub(M){if(M.workArea.width>0&&M.workArea.height>0)return M.workArea;if(M.bounds.width>0&&M.bounds.height>0)return M.bounds}getBounds(){const[M,O]=this.l.getPosition(),[F,U]=this.l.getSize();return{x:M,y:O,width:F,height:U}}toggleFullScreen(){this.vb(!this.isFullScreen)}vb(M){this.zb()?this.wb(M):this.yb(M),this.sendWhenReady(M?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.s&&this.Bb(this.s,!1)}get isFullScreen(){return E.isMacintosh&&typeof this.t=="boolean"?this.t:this.l.isFullScreen()||this.l.isSimpleFullScreen()}wb(M){this.l.isSimpleFullScreen()&&this.l.setSimpleFullScreen(!1),this.xb(M)}xb(M){E.isMacintosh&&(this.t=M,this.u=new t.DeferredPromise,Promise.race([this.u.p,(0,t.timeout)(1e3)]).finally(()=>this.t=void 0)),this.l.setFullScreen(M)}yb(M){this.l.isFullScreen()&&this.xb(!1),this.l.setSimpleFullScreen(M),this.l.webContents.focus()}zb(){const M=this.S.getValue("window");return!M||typeof M.nativeFullScreen!="boolean"||M.nativeTabs?!0:M.nativeFullScreen!==!1}isMinimized(){return this.l.isMinimized()}Ab(){let M=(0,D.getMenuBarVisibility)(this.S);return["visible","toggle","hidden"].indexOf(M)<0&&(M="classic"),M}Bb(M,O=!0){E.isMacintosh||(M==="toggle"&&O&&this.send("vscode:showInfoMessage",(0,d.localize)(15,null)),M==="hidden"?setTimeout(()=>{this.Cb(M)}):this.Cb(M))}Cb(M){const O=this.isFullScreen;switch(M){case"classic":this.l.setMenuBarVisibility(!O),this.l.autoHideMenuBar=O;break;case"visible":this.l.setMenuBarVisibility(!0),this.l.autoHideMenuBar=!1;break;case"toggle":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!0;break;case"hidden":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(E.isMacintosh)switch(I.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.l.minimize();break;case"None":break;case"Maximize":default:this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}else this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}close(){this.l?.close()}sendWhenReady(M,O,...F){this.isReady?this.send(M,...F):this.ready().then(()=>{O.isCancellationRequested||this.send(M,...F)})}send(M,...O){if(this.l){if(this.l.isDestroyed()||this.l.webContents.isDestroyed()){this.L.warn(`Sending IPC message to channel '${M}' for window that is destroyed`);return}try{this.l.webContents.send(M,...O)}catch(F){this.L.warn(`Error sending IPC message to channel '${M}' of window ${this.k}: ${(0,R.toErrorMessage)(F)}`)}}}updateTouchBar(M){!E.isMacintosh||this.D.forEach((O,F)=>{const U=M[F];O.segments=this.Fb(U)})}Db(){if(!!E.isMacintosh){for(let M=0;M<10;M++){const O=this.Eb();this.D.push(O)}this.l.setTouchBar(new I.TouchBar({items:this.D}))}}Eb(M=[]){const O=this.Fb(M),F=new I.TouchBar.TouchBarSegmentedControl({segments:O,mode:"buttons",segmentStyle:"automatic",change:U=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:F.segments[U].id,from:"touchbar"})}});return F}Fb(M=[]){return M.map(F=>{let U;F.icon&&!o.ThemeIcon.isThemeIcon(F.icon)&&F.icon?.dark?.scheme===m.Schemas.file&&(U=I.nativeImage.createFromPath(h.URI.revive(F.icon.dark).fsPath),U.isEmpty()&&(U=void 0));let H;return typeof F.title=="string"?H=F.title:H=F.title.value,{id:F.id,label:U?void 0:H,icon:U}})}dispose(){super.dispose(),this.l=null}};q.a="windowControlHeight",q.b=void 0,q=pe([ne(1,i.ILogService),ne(2,p.IEnvironmentMainService),ne(3,Y.IPolicyService),ne(4,re.IUserDataProfilesMainService),ne(5,f.IFileService),ne(6,r.IApplicationStorageMainService),ne(7,r.IStorageMainService),ne(8,b.IConfigurationService),ne(9,S.IThemeMainService),ne(10,X.IWorkspacesManagementMainService),ne(11,v.IBackupMainService),ne(12,c.ITelemetryService),ne(13,u.IDialogMainService),ne(14,l.ILifecycleMainService),ne(15,s.IProductService),ne(16,n.IProtocolMainService),ne(17,L.IWindowsMainService),ne(18,se.IStateMainService),ne(19,fe.INativeHostMainService)],q),e.CodeWindow=q}),define(te[75],ie([0,1,13,24,8,3,34,2,15,4,20,7,23,174,5,21,6,93,94,28,52,39]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h,d,v,b,u,p,g,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let i=class rt extends C.Disposable{constructor(n,a,r,c){super(),this.f=n,this.g=a,this.h=r,this.j=c,this.c=this.B(new R.Emitter),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new k.ThrottledDelayer(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let a=[],r=[];for(const o of n)if((0,p.isRecentWorkspace)(o))!this.g.isUntitledWorkspace(o.workspace)&&!this.r(a,o.workspace)&&a.push(o);else if((0,p.isRecentFolder)(o))this.s(a,o.folderUri)||a.push(o);else{const S=this.t(r,o.fileUri),D=o.fileUri.scheme===w.Schemas.file&&rt.y.indexOf((0,y.basename)(o.fileUri))>=0;!S&&!D&&(r.push(o),m.isWindows&&o.fileUri.scheme===w.Schemas.file&&I.app.addRecentDocument(o.fileUri.fsPath))}const c=await this.l({workspaces:a,files:r});a=c.workspaces,r=c.files,a.length>rt.a&&(a.length=rt.a),r.length>rt.a&&(r.length=rt.a),await this.n({workspaces:a,files:r}),this.c.fire(),m.isMacintosh&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(n){const a=S=>{const D=this.p(S);for(const L of n)if(y.extUriBiasedIgnorePathCase.isEqual(L,D))return!1;return!0},r=await this.getRecentlyOpened(),c=r.workspaces.filter(a),o=r.files.filter(a);(c.length!==r.workspaces.length||o.length!==r.files.length)&&(await this.n({files:o,workspaces:c}),this.c.fire(),m.isMacintosh&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),I.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(n){const a=new l.ResourceMap(o=>y.extUriBiasedIgnorePathCase.getComparisonKey(o));if(n?.workspaces)for(const o of n.workspaces)a.set(this.p(o),o);const r=new l.ResourceMap(o=>y.extUriBiasedIgnorePathCase.getComparisonKey(o));if(n?.files)for(const o of n.files)r.set(this.p(o),o);const c=await this.m();for(const o of c.workspaces){const S=a.get(this.p(o));S?S.label=S.label??o.label:a.set(this.p(o),o)}for(const o of c.files){const S=r.get(this.p(o));S?S.label=S.label??o.label:r.set(this.p(o),o)}return{workspaces:[...a.values()],files:[...r.values()]}}async m(){await this.j.whenReady;let n;const a=this.j.get(rt.b,-1);if(typeof a=="string")try{n=JSON.parse(a)}catch(r){this.f.error("Unexpected error parsing opened paths list",r)}return(0,p.restoreRecentlyOpened)(n,this.f)}async n(n){await this.j.whenReady,this.j.store(rt.b,JSON.stringify((0,p.toStoreData)(n)),-1,1)}p(n){return(0,p.isRecentFolder)(n)?n.folderUri:(0,p.isRecentFile)(n)?n.fileUri:n.workspace.configPath}r(n,a){return!!n.find(r=>(0,p.isRecentWorkspace)(r)&&r.workspace.id===a.id)}s(n,a){return!!n.find(r=>(0,p.isRecentFolder)(r)&&y.extUriBiasedIgnorePathCase.isEqual(r.folderUri,a))}t(n,a){return!!n.find(r=>y.extUriBiasedIgnorePathCase.isEqual(r.fileUri,a))}async C(){!m.isWindows||(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!m.isWindows)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,h.localize)(0,null),description:(0,h.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const a=[];for(const o of I.app.getJumpListSettings().removedItems){const S=o.args;if(S){const D=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(S);D&&a.push(P.URI.parse(D[2]))}}await this.removeRecentlyOpened(a);let r=!1;const c=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,rt.w).map(o=>{const S=(0,p.isRecentWorkspace)(o)?o.workspace:o.folderUri,{title:D,description:L}=this.F(S,o.label);let N;return P.URI.isUri(S)?N=`--folder-uri "${S.toString()}"`:(r=!0,N=`--file-uri "${S.configPath.toString()}"`),{type:"task",title:D.substr(0,255),description:L.substr(0,255),program:process.execPath,args:N,iconPath:"explorer.exe",iconIndex:0}}));c.length>0&&n.push({type:"custom",name:r?(0,h.localize)(2,null):(0,h.localize)(3,null),items:c})}n.push({type:"recent"});try{const a=I.app.setJumpList(n);a&&a!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${a}`)}catch(a){this.f.warn("updateWindowsJumpList#setJumpList",a)}}F(n,a){if(a)return{title:(0,A.splitName)(a).name,description:a};if(P.URI.isUri(n))return{title:(0,y.basename)(n),description:this.G(n)};if(this.g.isUntitledWorkspace(n))return{title:(0,h.localize)(4,null),description:""};let r=(0,y.basename)(n.configPath);return r.endsWith(g.WORKSPACE_EXTENSION)&&(r=r.substr(0,r.length-g.WORKSPACE_EXTENSION.length-1)),{title:(0,h.localize)(5,null,r),description:this.G(n.configPath)}}G(n){return n.scheme==="file"?(0,A.normalizeDriveLetter)(n.fsPath):n.toString()}async H(){if(!m.isMacintosh)return;I.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),a=[];let r=0;for(let o=0;o<n.workspaces.length&&r<rt.u;o++){const S=this.p(n.workspaces[o]);if(S.scheme===w.Schemas.file){const D=(0,y.originalFSPath)(S);await E.Promises.exists(D)&&(a.push(D),r++)}}const c=[];for(let o=0;o<n.files.length&&r<rt.v;o++){const S=this.p(n.files[o]);if(S.scheme===w.Schemas.file){const D=(0,y.originalFSPath)(S);if(rt.y.includes((0,y.basename)(S))||a.includes(D))continue;await E.Promises.exists(D)&&(c.push(D),r++)}}c.reverse().forEach(o=>I.app.addRecentDocument(o)),a.reverse().forEach(o=>I.app.addRecentDocument(o))}};i.a=500,i.b="history.recentlyOpenedPathsList",i.u=7,i.v=10,i.w=7,i.y=["COMMIT_EDITMSG","MERGE_MSG"],i=pe([ne(0,b.ILogService),ne(1,f.IWorkspacesManagementMainService),ne(2,v.ILifecycleMainService),ne(3,u.IApplicationStorageMainService)],i),e.WorkspacesHistoryMainService=i}),define(te[271],ie([0,1,13,8,22,34,4,7,164,18,27,21,6,212,58,19,36,31,49,74,32,75]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h,d,v,b,u,p,g,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const i="menu";let s=class Ft{constructor(r,c,o,S,D,L,N,X,ae,J,Y){this.n=r,this.o=c,this.p=o,this.q=S,this.r=D,this.s=L,this.t=N,this.u=X,this.v=ae,this.w=J,this.x=Y,this.m=Object.create(null),this.g=new t.RunOnceScheduler(()=>this.E(),0),this.h=new t.RunOnceScheduler(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(A.isMacintosh||(0,g.getTitleBarStyle)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const r=this.t.getItem(Ft.a);r&&(r.menus&&(this.k=r.menus),r.keybindings&&(this.l=r.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(L,N,X)=>this.p.openEmptyWindow({context:2,contextWindowId:N?.id}),this.m["workbench.action.newWindow"]=(L,N,X)=>this.p.openEmptyWindow({context:2,contextWindowId:N?.id}),this.m["workbench.action.files.openFileFolder"]=(L,N,X)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(X),telemetryExtraData:{from:i}}),this.m["workbench.action.files.openFolder"]=(L,N,X)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(X),telemetryExtraData:{from:i}}),this.m["workbench.action.openWorkspace"]=(L,N,X)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(X),telemetryExtraData:{from:i}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const r=this.x.twitterUrl;r&&(this.m["workbench.action.openTwitterUrl"]=()=>this.Z(r,"openTwitterUrl"));const c=this.x.requestFeatureUrl;c&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(c,"openUserVoiceUrl"));const o=this.x.reportIssueUrl;o&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(o,"openReportIssues"));const S=this.x.licenseUrl;S&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(A.language){const L=S.indexOf("?")>0?"&":"?";this.Z(`${S}${L}lang=${A.language}`,"openLicenseUrl")}else this.Z(S,"openLicenseUrl")});const D=this.x.privacyStatementUrl;D&&S&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(D,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(r=>this.F(r)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const r=this.o.getValue("window.enableMenuBarMnemonics");return typeof r!="boolean"?!0:r}get C(){if(!A.isMacintosh)return!1;const r=this.o.getValue("window.nativeTabs");return typeof r!="boolean"?!1:r}updateMenu(r,c){this.k=r.menus,this.l=r.keybindings,this.t.setItem(Ft.a,r),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(r){!A.isMacintosh||(r.oldCount===0&&r.newCount>0||r.oldCount>0&&r.newCount===0)&&(this.d=r.newCount===0,this.D())}G(){!A.isMacintosh||(this.f=!I.BrowserWindow.getFocusedWindow(),this.D())}H(){const r=I.Menu.getApplicationMenu();if(r&&this.j.push(r),Object.keys(this.k).length===0){I.Menu.setApplicationMenu(A.isMacintosh?new I.Menu:null);return}const c=new I.Menu;let o;if(A.isMacintosh){const D=new I.Menu;o=new I.MenuItem({label:this.x.nameShort,submenu:D}),this.I(D),c.append(o)}if(A.isMacintosh&&!this.c){this.c=!0;const D=new I.Menu;D.append(new I.MenuItem({label:this.bb(w.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),I.app.dock.setMenu(D)}if(this.K("File")){const D=new I.Menu,L=new I.MenuItem({label:this.bb(w.localize(1,null)),submenu:D});this.M(D,"File"),c.append(L)}if(this.K("Edit")){const D=new I.Menu,L=new I.MenuItem({label:this.bb(w.localize(2,null)),submenu:D});this.M(D,"Edit"),c.append(L)}if(this.K("Selection")){const D=new I.Menu,L=new I.MenuItem({label:this.bb(w.localize(3,null)),submenu:D});this.M(D,"Selection"),c.append(L)}if(this.K("View")){const D=new I.Menu,L=new I.MenuItem({label:this.bb(w.localize(4,null)),submenu:D});this.M(D,"View"),c.append(L)}if(this.K("Go")){const D=new I.Menu,L=new I.MenuItem({label:this.bb(w.localize(5,null)),submenu:D});this.M(D,"Go"),c.append(L)}if(this.K("Run")){const D=new I.Menu,L=new I.MenuItem({label:this.bb(w.localize(6,null)),submenu:D});this.M(D,"Run"),c.append(L)}if(this.K("Terminal")){const D=new I.Menu,L=new I.MenuItem({label:this.bb(w.localize(7,null)),submenu:D});this.M(D,"Terminal"),c.append(L)}let S;if(this.K("Window")){const D=new I.Menu;S=new I.MenuItem({label:this.bb(w.localize(8,null)),submenu:D,role:"window"}),this.S(D)}if(S&&c.append(S),this.K("Help")){const D=new I.Menu,L=new I.MenuItem({label:this.bb(w.localize(9,null)),submenu:D,role:"help"});this.M(D,"Help"),c.append(L)}c.items&&c.items.length>0?I.Menu.setApplicationMenu(c):I.Menu.setApplicationMenu(null),this.h.schedule()}I(r){const c=this.U(w.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),o=this.T();let S;if(this.K("Preferences")){const se=new I.Menu;this.M(se,"Preferences"),S=new I.MenuItem({label:this.bb(w.localize(11,null)),submenu:se})}const D=new I.Menu,L=new I.MenuItem({label:w.localize(12,null),role:"services",submenu:D}),N=new I.MenuItem({label:w.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),X=new I.MenuItem({label:w.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ae=new I.MenuItem({label:w.localize(15,null),role:"unhide"}),J=new I.MenuItem(this.Y("workbench.action.quit",{label:w.localize(16,null,this.x.nameLong),click:async(se,re,fe)=>{const K=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||!!I.BrowserWindow.getFocusedWindow()||K?.isMinimized())&&await this.J(fe)&&this.w.quit(void 0)}})),Y=[c];Y.push(...o),S&&Y.push(n(),S),Y.push(n(),L,n(),N,X,ae,n(),J),Y.forEach(se=>r.append(se))}async J(r){if(this.p.getWindowCount()===0)return!0;const c=this.o.getValue("window.confirmBeforeClose");if(c==="always"||c==="keyboardOnly"&&this.Q(r)){const o={title:this.x.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(w.localize(17,null)),(0,R.mnemonicButtonLabel)(w.localize(18,null))],message:w.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:S}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,o);return S===0}return!0}K(r){if(!A.isMacintosh&&(0,g.getTitleBarStyle)(this.o)==="custom")return!1;switch(r){case"File":case"Help":if(A.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[r];case"Window":if(A.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[r]}}L(r,c){c.forEach(o=>{if((0,h.isMenubarMenuItemSeparator)(o))r.append(n());else if((0,h.isMenubarMenuItemSubmenu)(o)){const S=new I.Menu,D=new I.MenuItem({label:this.bb(o.label),submenu:S});this.L(S,o.submenu.items),r.append(D)}else(0,h.isMenubarMenuItemRecentAction)(o)?r.append(this.O(o)):(0,h.isMenubarMenuItemAction)(o)&&(o.id==="workbench.action.showAboutDialog"&&this.N(r),A.isMacintosh?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[o.id]?r.append(new I.MenuItem(this.Y(o.id,{label:this.bb(o.label),click:this.m[o.id]}))):r.append(this.U(o.label,o.id,!1,o.checked)):r.append(this.U(o.label,o.id,o.enabled!==!1,!!o.checked)):r.append(this.U(o.label,o.id,o.enabled!==!1,!!o.checked)))})}M(r,c){this.k&&this.k[c]&&this.L(r,this.k[c].items)}N(r){const c=this.T();c.length&&(c.forEach(o=>r.append(o)),r.append(n()))}O(r){const c=C.URI.revive(r.uri),o=r.id,S=o==="openRecentFile"?{fileUri:c}:o==="openRecentWorkspace"?{workspaceUri:c}:{folderUri:c};return new I.MenuItem(this.Y(o,{label:r.label,click:async(D,L,N)=>{const X=this.P(N);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[S],forceNewWindow:X,gotoLineMode:!1,remoteAuthority:r.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([c])}},!1))}P(r){return!!(r&&(!A.isMacintosh&&(r.ctrlKey||r.shiftKey)||A.isMacintosh&&(r.metaKey||r.altKey)))}Q(r){return!!(r.triggeredByAccelerator||r.altKey||r.ctrlKey||r.metaKey||r.shiftKey)}R(r,c,o){const S={label:this.bb(r),role:o,enabled:!0};return new I.MenuItem(this.X(c,S))}S(r){const c=new I.MenuItem({label:w.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),o=new I.MenuItem({label:w.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),S=new I.MenuItem({label:w.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),D=this.U(w.localize(23,null),"workbench.action.switchWindow"),L=[];this.C&&(L.push(n()),L.push(this.U(w.localize(24,null),"workbench.action.newWindowTab")),L.push(this.R(w.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),L.push(this.R(w.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),L.push(this.R(w.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),L.push(this.R(w.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[c,o,n(),D,...L,n(),S].forEach(N=>r.append(N))}T(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new I.MenuItem({label:this.bb(w.localize(29,null)),click:()=>setTimeout(()=>{this.ab("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new I.MenuItem({label:w.localize(30,null),enabled:!1})];case"available for download":return[new I.MenuItem({label:this.bb(w.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new I.MenuItem({label:w.localize(32,null),enabled:!1})];case"downloaded":return[new I.MenuItem({label:this.bb(w.localize(33,null)),click:()=>{this.ab("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new I.MenuItem({label:w.localize(34,null),enabled:!1})];case"ready":return[new I.MenuItem({label:this.bb(w.localize(35,null)),click:()=>{this.ab("RestartToUpdate"),this.n.quitAndInstall()}})]}}U(r,c,o,S){const D=this.bb(r),L=typeof c=="function"?c:(Y,se,re)=>{const fe=Y?Y.userSettingsLabel:null;let K=c;Array.isArray(c)&&(K=this.P(re)?c[1]:c[0]),fe&&re.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:fe}):this.W({type:"commandId",commandId:K})},N=typeof o=="boolean"?o:this.p.getWindowCount()>0,X=typeof S=="boolean"?S:!1,ae={label:D,click:L,enabled:N};X&&(ae.type="checkbox",ae.checked=X);let J;return typeof c=="string"?J=c:Array.isArray(c)&&(J=c[0]),A.isMacintosh&&(J==="editor.action.clipboardCutAction"?ae.role="cut":J==="editor.action.clipboardCopyAction"?ae.role="copy":J==="editor.action.clipboardPasteAction"&&(ae.role="paste"),J==="undo"?ae.click=this.V(L,{inDevTools:Y=>Y.undo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("undo:")}):J==="redo"?ae.click=this.V(L,{inDevTools:Y=>Y.redo(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("redo:")}):J==="editor.action.selectAll"&&(ae.click=this.V(L,{inDevTools:Y=>Y.selectAll(),inNoWindow:()=>I.Menu.sendActionToFirstResponder("selectAll:")}))),new I.MenuItem(this.X(J,ae))}V(r,c){return(o,S,D)=>{const L=I.BrowserWindow.getFocusedWindow();if(!L)return c.inNoWindow();if(L.webContents.isDevToolsFocused()&&L.webContents.devToolsWebContents)return c.inDevTools(L.webContents.devToolsWebContents);r(o,S||L,D)}}W(r){let c=I.BrowserWindow.getFocusedWindow();if(!c){const S=this.p.getLastActiveWindow();S?.isMinimized()&&(c=S.win)}const o=c?this.p.getWindowById(c.id):void 0;if(o){if(this.v.trace("menubar#runActionInRenderer",r),A.isMacintosh&&!this.q.isBuilt&&!o.isReady&&(r.type==="commandId"&&r.commandId==="workbench.action.toggleDevTools"||r.type!=="commandId"&&r.userSettingsLabel==="alt+cmd+i"))return;if(r.type==="commandId"){const S={id:r.commandId,from:"menu"};o.sendWhenReady("vscode:runAction",k.CancellationToken.None,S)}else{const S={userSettingsLabel:r.userSettingsLabel};o.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,S)}}else this.v.trace("menubar#runActionInRenderer: no active window found",r)}X(r,c){const o=typeof r=="string"?this.l[r]:void 0;if(o?.label){if(o.isNative!==!1)c.accelerator=o.label,c.userSettingsLabel=o.userSettingsLabel;else if(typeof c.label=="string"){const S=c.label.indexOf("[");S>=0?c.label=`${c.label.substr(0,S)} [${o.label}]`:c.label=`${c.label} [${o.label}]`}}else c.accelerator=void 0;return c}Y(r,c,o=!c.accelerator){o&&(c=this.X(r,c));const S=c.click;return c.click=(D,L,N)=>{this.ab(r),S?.(D,L,N)},c}Z(r,c){this.w.openExternal(void 0,r),this.ab(c)}ab(r){this.r.publicLog2("workbenchActionExecuted",{id:r,from:i})}bb(r){return(0,R.mnemonicMenuLabel)(r,!this.B)}};s.a="lastKnownMenubarData",s=pe([ne(0,p.IUpdateService),ne(1,m.IConfigurationService),ne(2,f.IWindowsMainService),ne(3,y.IEnvironmentMainService),ne(4,u.ITelemetryService),ne(5,l.IWorkspacesHistoryMainService),ne(6,b.IStateMainService),ne(7,P.ILifecycleMainService),ne(8,E.ILogService),ne(9,d.INativeHostMainService),ne(10,v.IProductService)],s),e.Menubar=s;function n(){return new I.MenuItem({type:"separator"})}}),define(te[272],ie([0,1,5,21,6,271]),function(V,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,I.createDecorator)("menubarMainService");let A=class{constructor(w,m,y){this.b=w,this.c=m,this.d=y,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(R.Menubar)}async updateMenubar(w,m){this.d.trace("menubarService#updateMenubar",w),(await this.a).updateMenu(m,w)}};A=pe([ne(0,I.IInstantiationService),ne(1,t.ILifecycleMainService),ne(2,k.ILogService)],A),e.MenubarMainService=A}),define(te[273],ie([0,1,13,23,25,24,22,3,30,50,34,2,15,9,73,4,33,20,12,7,172,62,18,57,27,16,5,21,6,63,19,64,54,36,74,270,118,265,28,95,75,52,66,37,51]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h,d,v,b,u,p,g,f,l,i,s,n,a,r,c,o,S,D,L,N,X,ae,J,Y,se,re,fe,K,le,$,W,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function z(j){return(0,re.isWorkspaceIdentifier)(j?.workspace)}function Q(j){return(0,re.isSingleFolderWorkspaceIdentifier)(j?.workspace)}let q=class mt extends P.Disposable{constructor(M,O,F,U,H,x,B,_,Z,oe,ge,ke,Oe,De,Le,be,we,ye){super(),this.k=M,this.l=O,this.m=F,this.n=U,this.r=H,this.s=x,this.t=B,this.u=_,this.v=Z,this.w=oe,this.z=ge,this.C=ke,this.D=Oe,this.F=De,this.G=Le,this.H=be,this.I=we,this.J=ye,this.b=this.B(new C.Emitter),this.onDidOpenWindow=this.b.event,this.c=this.B(new C.Emitter),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new C.Emitter),this.onDidDestroyWindow=this.f.event,this.g=this.B(new C.Emitter),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new C.Emitter),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new se.WindowsStateHandler(this,this.n,this.u,this.m,this.w)),this.L()}L(){this.B(this.C.onDidEnterWorkspace(M=>this.c.fire(M.window))),this.B(this.onDidSignalReadyWindow(M=>{if(M.config?.extensionDevelopmentPath||M.config?.extensionTestsPath){const O=new P.DisposableStore;if(O.add(C.Event.any(M.onDidClose,M.onDidDestroy)(()=>O.dispose())),M.config.extensionDevelopmentPath)for(const F of M.config.extensionDevelopmentPath)O.add(this.I.addValidFileRoot(F));M.config.extensionTestsPath&&O.add(this.I.addValidFileRoot(M.config.extensionTestsPath))}}))}openEmptyWindow(M,O){const F=this.s.args,U=O?.remoteAuthority||void 0,H=!0,x=O?.forceReuseWindow,B=!x;return this.open({...M,cli:F,forceEmpty:H,forceNewWindow:B,forceReuseWindow:x,remoteAuthority:U})}openExistingWindow(M,O){M.focus(),this.M(O,[M])}async open(M){this.m.trace("windowsManager#open"),M.addMode&&(M.initialStartup||!this.getLastActiveWindow())&&(M.addMode=!1);const O=[],F=[],U=[],H=[],x=[];let B,_=0;const Z=await this.S(M);this.m.trace("windowsManager#open pathsToOpen",Z);for(const De of Z)Q(De)?M.addMode?O.push(De):F.push(De):z(De)?U.push(De):De.fileUri?(B||(B={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:De.remoteAuthority}),B.filesToOpenOrCreate.push(De)):De.backupPath?x.push({backupFolder:(0,h.basename)(De.backupPath),remoteAuthority:De.remoteAuthority}):_++;M.diffMode&&B&&B.filesToOpenOrCreate.length>=2&&(B.filesToDiff=B.filesToOpenOrCreate.slice(0,2),B.filesToOpenOrCreate=[]),M.mergeMode&&B&&B.filesToOpenOrCreate.length===4&&(B.filesToMerge=B.filesToOpenOrCreate.slice(0,4),B.filesToOpenOrCreate=[],B.filesToDiff=[]),B&&M.waitMarkerFileURI&&(B.filesToWait={paths:(0,R.coalesce)([...B.filesToDiff,B.filesToMerge[3],...B.filesToOpenOrCreate]),waitMarkerFileUri:M.waitMarkerFileURI}),M.initialStartup?(H.push(...this.C.getUntitledWorkspaces()),U.push(...H),x.push(...this.v.getEmptyWindowBackups())):x.length=0;const{windows:oe,filesOpenedInWindow:ge}=await this.N(M,U,F,x,_,B,O);if(this.m.trace(`windowsManager#open used window count ${oe.length} (workspacesToOpen: ${U.length}, foldersToOpen: ${F.length}, emptyToRestore: ${x.length}, emptyToOpen: ${_})`),oe.length>1)if(ge)ge.focus();else{const De=this.j.state.lastActiveWindow&&!M.forceEmpty&&!M.cli._.length&&!M.cli["file-uri"]&&!M.cli["folder-uri"]&&!(M.urisToOpen&&M.urisToOpen.length);let Le=!0,be=!0;if(De){const we=oe.filter(ye=>this.j.state.lastActiveWindow&&ye.backupPath===this.j.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),Le=!1,be=!1)}if(Le)for(let we=oe.length-1;we>=0;we--){const ye=oe[we];if(!(ye.openedWorkspace&&H.some(Me=>ye.openedWorkspace&&Me.workspace.id===ye.openedWorkspace.id)||ye.backupPath&&x.some(Me=>ye.backupPath&&Me.backupFolder===(0,h.basename)(ye.backupPath)))){ye.focus(),be=!1;break}}be&&oe[oe.length-1].focus()}const ke=B&&B.filesToDiff.length>0,Oe=B&&B.filesToMerge.length>0;if(!oe.some(De=>De.isExtensionDevelopmentHost)&&!ke&&!Oe&&!M.noRecentEntry){const De=[];for(const Le of Z)z(Le)&&!Le.transient?De.push({label:Le.label,workspace:Le.workspace,remoteAuthority:Le.remoteAuthority}):Q(Le)?De.push({label:Le.label,folderUri:Le.workspace.uri,remoteAuthority:Le.remoteAuthority}):Le.fileUri&&De.push({label:Le.label,fileUri:Le.fileUri,remoteAuthority:Le.remoteAuthority});this.z.addRecentlyOpened(De)}return this.M(M,oe),oe}M(M,O){const F=M.waitMarkerFileURI;M.context===0&&F&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.G.del(F)}catch{}})()}async N(M,O,F,U,H,x,B){const _=[];let Z;function oe(we,ye){_.push(we),ye&&(Z=we,x=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:ke}=this.fb(M);if(!M.initialStartup&&B.length>0){const we=B[0].remoteAuthority,ye=this.kb(we);ye&&oe(this.P(ye,B.map(Me=>Me.workspace.uri)))}const Oe=F.length+O.length+U.length;if(x&&Oe===0){const we=x.filesToOpenOrCreate[0]||x.filesToDiff[0]||x.filesToMerge[3],ye=this.getWindows().filter(ee=>x&&(0,u.isEqualAuthority)(ee.remoteAuthority,x.remoteAuthority));let Me;we?.fileUri&&!ke&&((M.context===4||M.context===0||M.context===1)&&(Me=await(0,Y.findWindowOnFile)(ye,we.fileUri,async ee=>ee.configPath.scheme===E.Schemas.file?this.C.resolveLocalWorkspace(ee.configPath):void 0)),Me||(Me=this.lb(ye))),Me?(0,re.isWorkspaceIdentifier)(Me.openedWorkspace)?O.push({workspace:Me.openedWorkspace,remoteAuthority:Me.remoteAuthority}):(0,re.isSingleFolderWorkspaceIdentifier)(Me.openedWorkspace)?F.push({workspace:Me.openedWorkspace,remoteAuthority:Me.remoteAuthority}):oe(this.O(M,Me,x),!0):oe(await this.gb({userEnv:M.userEnv,cli:M.cli,initialStartup:M.initialStartup,filesToOpen:x,forceNewWindow:!0,remoteAuthority:x.remoteAuthority,forceNewTabbedWindow:M.forceNewTabbedWindow,forceProfile:M.forceProfile,forceTempProfile:M.forceTempProfile}),!0)}const De=(0,R.distinct)(O,we=>we.workspace.id);if(De.length>0){const we=(0,R.coalesce)(De.map(ye=>(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye.workspace.configPath)));if(we.length>0){const ye=we[0],Me=(0,u.isEqualAuthority)(x?.remoteAuthority,ye.remoteAuthority)?x:void 0;oe(this.O(M,ye,Me),!!Me),ge=!0}for(const ye of De){if(we.some(he=>he.openedWorkspace&&he.openedWorkspace.id===ye.workspace.id))continue;const Me=ye.remoteAuthority,ee=(0,u.isEqualAuthority)(x?.remoteAuthority,Me)?x:void 0;oe(await this.R(M,ye,ge,ee),!!ee),ge=!0}}const Le=(0,R.distinct)(F,we=>u.extUriBiasedIgnorePathCase.getComparisonKey(we.workspace.uri));if(Le.length>0){const we=(0,R.coalesce)(Le.map(ye=>(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),ye.workspace.uri)));if(we.length>0){const ye=we[0],Me=(0,u.isEqualAuthority)(x?.remoteAuthority,ye.remoteAuthority)?x:void 0;oe(this.O(M,ye,Me),!!Me),ge=!0}for(const ye of Le){if(we.some(he=>(0,re.isSingleFolderWorkspaceIdentifier)(he.openedWorkspace)&&u.extUriBiasedIgnorePathCase.isEqual(he.openedWorkspace.uri,ye.workspace.uri)))continue;const Me=ye.remoteAuthority,ee=(0,u.isEqualAuthority)(x?.remoteAuthority,Me)?x:void 0;oe(await this.R(M,ye,ge,ee),!!ee),ge=!0}}const be=(0,R.distinct)(U,we=>we.backupFolder);if(be.length>0)for(const we of be){const ye=we.remoteAuthority,Me=(0,u.isEqualAuthority)(x?.remoteAuthority,ye)?x:void 0;oe(await this.Q(M,!0,ye,Me,we),!!Me),ge=!0}if(_.length===0||x){x&&!H&&H++;const we=x?x.remoteAuthority:M.remoteAuthority;for(let ye=0;ye<H;ye++)oe(await this.Q(M,ge,we,x),!!x),ge=!0}return{windows:(0,R.distinct)(_),filesOpenedInWindow:Z}}O(M,O,F){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:F}),O.focus();const U={filesToOpenOrCreate:F?.filesToOpenOrCreate,filesToDiff:F?.filesToDiff,filesToMerge:F?.filesToMerge,filesToWait:F?.filesToWait,termProgram:M?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",A.CancellationToken.None,U),O}P(M,O){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:O}),M.focus();const F={foldersToAdd:O};return M.sendWhenReady("vscode:addFolders",A.CancellationToken.None,F),M}Q(M,O,F,U,H){this.m.trace("windowsManager#doOpenEmpty",{restore:!!H,remoteAuthority:F,filesToOpen:U,forceNewWindow:O});let x;return!O&&typeof M.contextWindowId=="number"&&(x=this.getWindowById(M.contextWindowId)),this.gb({userEnv:M.userEnv,cli:M.cli,initialStartup:M.initialStartup,remoteAuthority:F,forceNewWindow:O,forceNewTabbedWindow:M.forceNewTabbedWindow,filesToOpen:U,windowToUse:x,emptyWindowBackupInfo:H,forceProfile:M.forceProfile,forceTempProfile:M.forceTempProfile})}R(M,O,F,U,H){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:O,filesToOpen:U}),!F&&!H&&typeof M.contextWindowId=="number"&&(H=this.getWindowById(M.contextWindowId)),this.gb({workspace:O.workspace,userEnv:M.userEnv,cli:M.cli,initialStartup:M.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:F,forceNewTabbedWindow:M.forceNewTabbedWindow,filesToOpen:U,windowToUse:H,forceProfile:M.forceProfile,forceTempProfile:M.forceTempProfile})}async S(M){let O,F=!1,U=!1;if(M.urisToOpen&&M.urisToOpen.length>0?(O=await this.U(M),F=!0):M.forceEmpty?O=[Object.create(null)]:M.cli._.length||M.cli["folder-uri"]||M.cli["file-uri"]?(O=await this.W(M.cli),O.length===0&&O.push(Object.create(null)),F=!0):(O=await this.Y(),O.length===0&&O.push(Object.create(null)),U=!0),!M.addMode&&F){const H=O.filter(x=>Q(x));if(H.length>1){const x=H[0].remoteAuthority;if(H.every(B=>(0,u.isEqualAuthority)(B.remoteAuthority,x))){const B=await this.C.createUntitledWorkspace(H.map(_=>({uri:_.workspace.uri})));O.push({workspace:B,remoteAuthority:x}),O=O.filter(_=>!Q(_))}}}if(M.initialStartup&&!U&&this.w.getValue("window")?.restoreWindows==="preserve"){const H=await this.Y();O.unshift(...H.filter(x=>z(x)||Q(x)||x.backupPath))}return O}async U(M){const O={gotoLineMode:M.gotoLineMode,remoteAuthority:M.remoteAuthority},F=await Promise.all((0,R.coalesce)(M.urisToOpen||[]).map(async U=>{const H=await this.ab(U,O);if(H)return H.label=U.label,H;const x=this.cb(U),B={title:this.H.nameLong,type:"info",buttons:[(0,y.mnemonicButtonLabel)((0,f.localize)(0,null))],defaultId:0,message:x.scheme===E.Schemas.file?(0,f.localize)(1,null):(0,f.localize)(2,null),detail:x.scheme===E.Schemas.file?(0,f.localize)(3,null,(0,y.getPathLabel)(x,{os:v.OS,tildify:this.s})):(0,f.localize)(4,null,x.toString(!0)),noLink:!0};this.F.showMessageBox(B,(0,p.withNullAsUndefined)(I.BrowserWindow.getFocusedWindow()))}));return(0,R.coalesce)(F)}async W(M){const O=[],F={ignoreFileNotFound:!0,gotoLineMode:M.goto,remoteAuthority:M.remote||void 0,forceOpenWorkspaceAsFile:M.diff&&M._.length===2||M.merge&&M._.length===4},U=M["folder-uri"];if(U){const B=await Promise.all(U.map(_=>{const Z=this.X(_);if(!!Z)return this.ab({folderUri:Z},F)}));O.push(...(0,R.coalesce)(B))}const H=M["file-uri"];if(H){const B=await Promise.all(H.map(_=>{const Z=this.X(_);if(!!Z)return this.ab((0,re.hasWorkspaceFileExtension)(_)?{workspaceUri:Z}:{fileUri:Z},F)}));O.push(...(0,R.coalesce)(B))}const x=await Promise.all(M._.map(B=>F.remoteAuthority?this.eb(B,F):this.db(B,F)));return O.push(...(0,R.coalesce)(x)),O}X(M){try{const O=g.URI.parse(M);if(!O.scheme){this.m.error(`Invalid URI input string, scheme missing: ${M}`);return}return O}catch(O){this.m.error(`Invalid URI input string: ${M}, ${O.message}`)}}async Y(){const M=this.Z();switch(M){case"none":return[];case"one":case"all":case"preserve":case"folders":{const O=[];M!=="one"&&O.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&O.push(this.j.state.lastActiveWindow);const F=await Promise.all(O.map(async U=>{if(U.workspace){const H=await this.ab({workspaceUri:U.workspace.configPath},{remoteAuthority:U.remoteAuthority,rejectTransientWorkspaces:!0});if(z(H))return H}else if(U.folderUri){const H=await this.ab({folderUri:U.folderUri},{remoteAuthority:U.remoteAuthority});if(Q(H))return H}else if(M!=="folders"&&U.backupPath)return{backupPath:U.backupPath,remoteAuthority:U.remoteAuthority}}));return(0,R.coalesce)(F)}}}Z(){let M;return this.u.wasRestarted?M="all":(M=this.w.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(M)||(M="all")),M}async ab(M,O=Object.create(null)){const F=this.cb(M);return F.scheme===E.Schemas.file?((0,ae.isFileToOpen)(M)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.db(F.fsPath,O)):this.bb(M,O)}bb(M,O){let F=this.cb(M);const U=(0,N.getRemoteAuthority)(F)||O.remoteAuthority;if(F=(0,u.removeTrailingPathSeparator)((0,u.normalizePath)(F)),(0,ae.isFileToOpen)(M)){if(O.gotoLineMode){const{path:H,line:x,column:B}=(0,w.parseLineAndColumnAware)(F.path);return{fileUri:F.with({path:H}),options:{selection:x?{startLineNumber:x,startColumn:B||1}:void 0},remoteAuthority:U}}return{fileUri:F,remoteAuthority:U}}else if((0,ae.isWorkspaceToOpen)(M))return{workspace:(0,fe.getWorkspaceIdentifier)(F),remoteAuthority:U};return{workspace:(0,fe.getSingleFolderWorkspaceIdentifier)(F),remoteAuthority:U}}cb(M){return(0,ae.isWorkspaceToOpen)(M)?M.workspaceUri:(0,ae.isFolderToOpen)(M)?M.folderUri:M.fileUri}async db(M,O){let F,U;O.gotoLineMode&&({path:M,line:F,column:U}=(0,w.parseLineAndColumnAware)(M)),M=(0,w.sanitizeFilePath)((0,h.normalize)(M),(0,b.cwd)());try{const H=await t.Promises.stat(M);if(H.isFile()){if(!O.forceOpenWorkspaceAsFile){const x=await this.C.resolveLocalWorkspace(g.URI.file(M));if(x)return x.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:x.id,configPath:x.configPath},type:a.FileType.File,exists:!0,remoteAuthority:x.remoteAuthority,transient:x.transient}}return{fileUri:g.URI.file(M),type:a.FileType.File,exists:!0,options:{selection:F?{startLineNumber:F,startColumn:U||1}:void 0}}}else{if(H.isDirectory())return{workspace:(0,fe.getSingleFolderWorkspaceIdentifier)(g.URI.file(M),H),type:a.FileType.Directory,exists:!0};if(!v.isWindows&&M==="/dev/null")return{fileUri:g.URI.file(M),type:a.FileType.File,exists:!0}}}catch{const x=g.URI.file(M);if(this.z.removeRecentlyOpened([x]),O.ignoreFileNotFound)return{fileUri:x,type:a.FileType.File,exists:!1}}}eb(M,O){const F=M.charCodeAt(0),U=O.remoteAuthority;let H,x;O.gotoLineMode&&({path:M,line:H,column:x}=(0,w.parseLineAndColumnAware)(M)),F!==47&&((0,w.isWindowsDriveLetter)(F)&&M.charCodeAt(M.charCodeAt(1))===58&&(M=(0,w.toSlashes)(M)),M=`/${M}`);const B=g.URI.from({scheme:E.Schemas.vscodeRemote,authority:U,path:M});if(M.charCodeAt(M.length-1)!==47){if((0,re.hasWorkspaceFileExtension)(M))return O.forceOpenWorkspaceAsFile?{fileUri:B,options:{selection:H?{startLineNumber:H,startColumn:x||1}:void 0},remoteAuthority:O.remoteAuthority}:{workspace:(0,fe.getWorkspaceIdentifier)(B),remoteAuthority:U};if(O.gotoLineMode||h.posix.basename(M).indexOf(".")!==-1)return{fileUri:B,options:{selection:H?{startLineNumber:H,startColumn:x||1}:void 0},remoteAuthority:U}}return{workspace:(0,fe.getSingleFolderWorkspaceIdentifier)(B),remoteAuthority:U}}fb(M){const O=this.w.getValue("window"),F=O?.openFoldersInNewWindow||"default",U=O?.openFilesInNewWindow||"off";let H=(M.preferNewWindow||M.forceNewWindow)&&!M.forceReuseWindow;!M.forceNewWindow&&!M.forceReuseWindow&&(F==="on"||F==="off")&&(H=F==="on");let x=!1;return M.forceNewWindow||M.forceReuseWindow?x=!!M.forceNewWindow&&!M.forceReuseWindow:(v.isMacintosh?M.context===1&&(x=!0):M.context!==3&&M.context!==2&&!(M.userEnv&&M.userEnv.TERM_PROGRAM==="vscode")&&(x=!0),!M.cli.extensionDevelopmentPath&&(U==="on"||U==="off")&&(x=U==="on")),{openFolderInNewWindow:!!H,openFilesInNewWindow:x}}async openExtensionDevelopmentHostWindow(M,O){const F=(0,Y.findWindowOnExtensionDevelopmentPath)(this.getWindows(),M);if(F)return this.u.reload(F,O.cli),F.focus(),[F];let U=O.cli["folder-uri"]||[],H=O.cli["file-uri"]||[],x=O.cli._;if(!x.length&&!U.length&&!H.length&&!O.cli.extensionTestsPath){const Z=this.j.state.lastPluginDevelopmentHostWindow,oe=Z?.workspace??Z?.folderUri;oe&&(g.URI.isUri(oe)?oe.scheme===E.Schemas.file?x=[oe.fsPath]:U=[oe.toString()]:oe.configPath.scheme===E.Schemas.file?x=[(0,u.originalFSPath)(oe.configPath)]:H=[oe.configPath.toString()])}let B=O.remoteAuthority;for(const Z of M)if(Z.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const oe=g.URI.parse(Z),ge=(0,N.getRemoteAuthority)(oe);ge&&(B?(0,u.isEqualAuthority)(ge,B)||this.m.error("more than one extension development path authority"):B=ge)}x=x.filter(Z=>{const oe=g.URI.file(Z);return(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),oe)?!1:(0,u.isEqualAuthority)((0,N.getRemoteAuthority)(oe),B)}),U=U.filter(Z=>{const oe=this.X(Z);return oe&&!!(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),oe)?!1:oe?(0,u.isEqualAuthority)((0,N.getRemoteAuthority)(oe),B):!1}),H=H.filter(Z=>{const oe=this.X(Z);return oe&&!!(0,Y.findWindowOnWorkspaceOrFolder)(this.getWindows(),oe)?!1:oe?(0,u.isEqualAuthority)((0,N.getRemoteAuthority)(oe),B):!1}),O.cli._=x,O.cli["folder-uri"]=U,O.cli["file-uri"]=H;const _={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:!x.length&&!U.length&&!H.length,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:B,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile};return this.open(_)}async gb(M){const O=this.w.getValue("window");let F;!M.forceNewWindow&&!M.forceNewTabbedWindow&&(F=M.windowToUse||this.getLastActiveWindow(),F&&F.focus());const U={...this.s.args,...M.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.s.appRoot,execPath:process.execPath,codeCachePath:this.s.codeCachePath,backupPath:M.emptyWindowBackupInfo?(0,h.join)(this.s.backupHome,M.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.t.profiles,profile:F?.isExtensionDevelopmentHost&&F?.profile?F.profile:await this.ib(M)},homeDir:this.s.userHome.fsPath,tmpDir:this.s.tmpDir.fsPath,userDataDir:this.s.userDataPath,remoteAuthority:M.remoteAuthority,workspace:M.workspace,userEnv:{...this.l,...M.userEnv},filesToOpenOrCreate:M.filesToOpen?.filesToOpenOrCreate,filesToDiff:M.filesToOpen?.filesToDiff,filesToMerge:M.filesToOpen?.filesToMerge,filesToWait:M.filesToOpen?.filesToWait,logLevel:this.m.getLevel(),logsPath:this.s.logsPath,product:S.default,isInitialStartup:M.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,k.release)(),hostname:(0,k.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,autoDetectHighContrast:O?.autoDetectHighContrast??!0,autoDetectColorScheme:O?.autoDetectColorScheme??!1,accessibilitySupport:I.app.accessibilitySupportEnabled,colorScheme:this.J.getColorScheme(),policiesData:this.r.serialize(),continueOn:this.s.continueOn};if(F){const H=F.config;!U.extensionDevelopmentPath&&H?.extensionDevelopmentPath&&(U.extensionDevelopmentPath=H.extensionDevelopmentPath,U.extensionDevelopmentKind=H.extensionDevelopmentKind,U["enable-proposed-api"]=H["enable-proposed-api"],U.verbose=H.verbose,U["inspect-extensions"]=H["inspect-extensions"],U["inspect-brk-extensions"]=H["inspect-brk-extensions"],U.debugId=H.debugId,U.extensionEnvironment=H.extensionEnvironment,U["extensions-dir"]=H["extensions-dir"],U["disable-extensions"]=H["disable-extensions"])}else{const H=this.j.getNewWindowState(U);(0,d.mark)("code/willCreateCodeWindow");const x=F=this.D.createInstance(J.CodeWindow,{state:H,extensionDevelopmentPath:U.extensionDevelopmentPath,isExtensionTestHost:!!U.extensionTestsPath});(0,d.mark)("code/didCreateCodeWindow"),M.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(x),mt.a.push(x),this.b.fire(x),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,m.once)(x.onDidSignalReady)(()=>this.c.fire(x)),(0,m.once)(x.onDidClose)(()=>this.jb(x)),(0,m.once)(x.onDidDestroy)(()=>this.f.fire(x)),x.onDidTriggerSystemContextMenu(({x:_,y:Z})=>this.h.fire({window:x,x:_,y:Z}));const B=(0,p.assertIsDefined)(x.win?.webContents);B.removeAllListeners("devtools-reload-page"),B.on("devtools-reload-page",()=>this.u.reload(x)),this.u.registerWindow(x)}return U.windowId=F.id,F.isReady?this.u.unload(F,4).then(H=>{H||this.hb(F,U,M)}):this.hb(F,U,M),F}hb(M,O,F){O.extensionDevelopmentPath||((0,re.isWorkspaceIdentifier)(O.workspace)?O.backupPath=this.v.registerWorkspaceBackup({workspace:O.workspace,remoteAuthority:O.remoteAuthority}):(0,re.isSingleFolderWorkspaceIdentifier)(O.workspace)?O.backupPath=this.v.registerFolderBackup({folderUri:O.workspace.uri,remoteAuthority:O.remoteAuthority}):O.backupPath=this.v.registerEmptyWindowBackup({backupFolder:F.emptyWindowBackupInfo?.backupFolder??(0,fe.createEmptyWorkspaceIdentifier)().id,remoteAuthority:O.remoteAuthority})),M.load(O)}async ib(M){let O;return this.t.isEnabled()&&(M.forceProfile?O=this.t.profiles.find(F=>F.name===M.forceProfile)??await this.t.createNamedProfile(M.forceProfile):M.forceTempProfile&&(O=await this.t.createTransientProfile())),O?M.cli?.extensionDevelopmentPath||this.t.setProfileForWorkspaceSync(M.workspace??"empty-window",O):O=this.t.getOrSetProfileForWorkspace(M.workspace??"empty-window",(M.windowToUse??this.getLastActiveWindow())?.profile??this.t.defaultProfile),O}jb(M){const O=mt.a.indexOf(M);mt.a.splice(O,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const M=I.BrowserWindow.getFocusedWindow();if(M)return this.getWindowById(M.id)}getLastActiveWindow(){return this.lb(this.getWindows())}kb(M){return this.lb(this.getWindows().filter(O=>(0,u.isEqualAuthority)(O.remoteAuthority,M)))}lb(M){const O=Math.max.apply(Math,M.map(F=>F.lastFocusTime));return M.find(F=>F.lastFocusTime===O)}sendToFocused(M,...O){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(M,A.CancellationToken.None,...O)}sendToAll(M,O,F){for(const U of this.getWindows())F&&F.indexOf(U.id)>=0||U.sendWhenReady(M,A.CancellationToken.None,O)}getWindows(){return mt.a}getWindowCount(){return mt.a.length}getWindowById(M){const O=this.getWindows().filter(F=>F.id===M);return(0,R.firstOrDefault)(O)}getWindowByWebContents(M){const O=I.BrowserWindow.fromWebContents(M);if(!!O)return this.getWindowById(O.id)}};q.a=[],q=pe([ne(2,o.ILogService),ne(3,X.IStateMainService),ne(4,W.IPolicyService),ne(5,n.IEnvironmentMainService),ne(6,T.IUserDataProfilesMainService),ne(7,c.ILifecycleMainService),ne(8,l.IBackupMainService),ne(9,i.IConfigurationService),ne(10,K.IWorkspacesHistoryMainService),ne(11,le.IWorkspacesManagementMainService),ne(12,r.IInstantiationService),ne(13,s.IDialogMainService),ne(14,a.IFileService),ne(15,D.IProductService),ne(16,L.IProtocolMainService),ne(17,$.IThemeMainService)],q),e.WindowsMainService=q}),define(te[274],ie([0,1,62,32,75,52]),function(V,e,I,t,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let A=class{constructor(w,m,y,P){this.a=w,this.b=m,this.c=y,this.d=P,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(w,m){const y=this.b.getWindowById(w);if(y)return this.a.enterWorkspace(y,this.b.getWindows(),m)}createUntitledWorkspace(w,m,y){return this.a.createUntitledWorkspace(m,y)}deleteUntitledWorkspace(w,m){return this.a.deleteUntitledWorkspace(m)}getWorkspaceIdentifier(w,m){return this.a.getWorkspaceIdentifier(m)}getRecentlyOpened(w){return this.c.getRecentlyOpened()}addRecentlyOpened(w,m){return this.c.addRecentlyOpened(m)}removeRecentlyOpened(w,m){return this.c.removeRecentlyOpened(m)}clearRecentlyOpened(w){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};A=pe([ne(0,R.IWorkspacesManagementMainService),ne(1,t.IWindowsMainService),ne(2,k.IWorkspacesHistoryMainService),ne(3,I.IBackupMainService)],A),e.WorkspacesMainService=A}),define(te[275],ie([0,1,13,41,25,17,45,14,30,50,43,34,2,15,9,4,12,7,29,131,47,145,103,251,148,62,266,18,71,180,84,119,57,106,203,27,61,111,193,215,194,253,107,195,196,16,207,86,70,5,85,267,228,254,21,6,209,272,58,19,54,260,88,36,257,93,89,31,233,112,56,49,242,243,268,244,269,115,246,247,248,249,255,32,273,256,28,94,75,274,52,252,37,214,51,224,55,91,117,258,264,262,8,113]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h,d,v,b,u,p,g,f,l,i,s,n,a,r,c,o,S,D,L,N,X,ae,J,Y,se,re,fe,K,le,$,W,T,z,Q,q,j,M,O,F,U,H,x,B,_,Z,oe,ge,ke,Oe,De,Le,be,we,ye,Me,ee,he,de,ve,Pe,We,Te,qe,Ue,je,Je,$e,Ke,G,ce,ue,me,Se,Ae,Be,it,xe,He,tt,nt,lt,at,Bt,$t,Wt,zt,qt,Ht,Vt,Pt,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ct=class extends E.Disposable{constructor(Ee,Ce,Re,Ie,Fe,ze,_e,et,Ne,Ge,Xe){super(),this.c=Ee,this.f=Ce,this.g=Re,this.h=Ie,this.i=Fe,this.j=ze,this.k=_e,this.l=et,this.m=Ne,this.n=Ge,this.p=Xe,this.r(),this.s()}r(){const Ee=Ne=>Ne?.startsWith(`${h.Schemas.vscodeWebview}://`),Ce=new Set(["clipboard-read","clipboard-sanitized-write"]);I.session.defaultSession.setPermissionRequestHandler((Ne,Ge,Xe,Ze)=>Ee(Ze.requestingUrl)?Xe(Ce.has(Ge)):Xe(!1)),I.session.defaultSession.setPermissionCheckHandler((Ne,Ge,Xe,Ze)=>Ee(Ze.requestingUrl)?Ce.has(Ge):!1);const Re=new Set([h.Schemas.file,h.Schemas.vscodeFileResource,h.Schemas.vscodeRemoteResource,"devtools"]),Ie=Ne=>{for(let Ge=Ne;Ge;Ge=Ge.parent)if(Ge.url.startsWith(`${h.Schemas.vscodeWebview}://`))return!0;return!1},Fe=Ne=>Ne.resourceType==="xhr"||Ie(Ne.frame),ze=Ne=>{const Ge=Ne.frame;if(!Ge||!this.a)return!1;const Xe=I.BrowserWindow.getAllWindows();for(const Ze of Xe)if(Ge.processId===Ze.webContents.mainFrame.processId)return!0;return!1},_e=(Ne,Ge)=>{if(Ne.path!=="/index.html")return!0;const Xe=Ge.frame;if(!Xe||!this.a)return!1;for(const Ze of this.a.getWindows())if(Ze.win&&Xe.processId===Ze.win.webContents.mainFrame.processId)return!0;return!1};I.session.defaultSession.webRequest.onBeforeRequest((Ne,Ge)=>{const Xe=u.URI.parse(Ne.url);return Xe.scheme===h.Schemas.vscodeWebview&&!_e(Xe,Ne)?(this.h.error("Blocked vscode-webview request",Ne.url),Ge({cancel:!0})):Xe.scheme===h.Schemas.vscodeFileResource&&!ze(Ne)?(this.h.error("Blocked vscode-file request",Ne.url),Ge({cancel:!0})):Xe.path.endsWith(".svg")&&!Re.has(Xe.scheme)?Ge({cancel:!Fe(Ne)}):Ge({cancel:!1})}),I.session.defaultSession.webRequest.onHeadersReceived((Ne,Ge)=>{const Xe=Ne.responseHeaders,Ze=Xe["content-type"]||Xe["Content-Type"];if(Ze&&Array.isArray(Ze)){const st=u.URI.parse(Ne.url);if(st.path.endsWith(".svg")&&Re.has(st.scheme))return Xe["Content-Type"]=["image/svg+xml"],Ge({cancel:!1,responseHeaders:Xe});if(!st.path.endsWith(h.Schemas.vscodeRemoteResource)&&Ze.some(ct=>ct.toLowerCase().includes("image/svg")))return Ge({cancel:!Fe(Ne)})}return Ge({cancel:!1})});const et=I.session.defaultSession;typeof et.setCodeCachePath=="function"&&this.i.codeCachePath&&et.setCodeCachePath((0,d.join)(this.i.codeCachePath,"chrome"))}s(){(0,C.setUnexpectedErrorHandler)(Re=>this.u(Re)),process.on("uncaughtException",Re=>(0,C.onUnexpectedError)(Re)),process.on("unhandledRejection",Re=>(0,C.onUnexpectedError)(Re)),this.j.onWillShutdown(()=>this.dispose()),(0,g.registerContextMenuListener)(),I.app.on("accessibility-support-changed",(Re,Ie)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Ie)}),I.app.on("activate",async(Re,Ie)=>{this.h.trace("app#activate"),Ie||await this.a?.openEmptyWindow({context:1})}),I.app.on("web-contents-created",(Re,Ie)=>{Ie.on("will-navigate",Fe=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),Fe.preventDefault()}),Ie.setWindowOpenHandler(({url:Fe})=>(this.b?.openExternal(void 0,Fe),{action:"deny"}))});let Ee=[],Ce;I.app.on("open-file",(Re,Ie)=>{this.h.trace("app#open-file: ",Ie),Re.preventDefault(),Ee.push((0,Ae.hasWorkspaceFileExtension)(Ie)?{workspaceUri:u.URI.file(Ie)}:{fileUri:u.URI.file(Ie)}),Ce!==void 0&&(clearTimeout(Ce),Ce=void 0),Ce=setTimeout(async()=>{await this.a?.open({context:1,cli:this.i.args,urisToOpen:Ee,gotoLineMode:!1,preferNewWindow:!0}),Ee=[],Ce=void 0},100)}),I.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",Re=>{const Ie=this.a?.getWindowByWebContents(Re.sender);let Fe,ze;return Ie?.config?(Fe=Ie.config,ze={...process.env,...Ie.config.userEnv}):(Fe=this.i.args,ze=process.env),this.J(Fe,ze,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(Re,Ie,Fe)=>{const ze=this.t([Ie]);if(!ze||typeof Fe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.m.writeFile(ze,R.VSBuffer.fromString(Fe))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(Re,...Ie)=>{const Fe=this.t(Ie);if(!Fe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.m.readFile(Fe)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",Re=>Re.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",Re=>Re.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",Re=>Re.sender.reload())}t(Ee){let Ce;for(const Re of Ee)typeof Re=="string"&&(typeof Ce!="string"?Ce=Re:Ce=(0,d.join)(Ce,Re));if(!(typeof Ce!="string"||!(0,d.isAbsolute)(Ce)||!(0,w.isEqualOrParent)(Ce,this.i.cachedLanguagesPath,!v.isLinux)))return u.URI.file(Ce)}u(Ee){if(Ee){const Ce={message:`[uncaught exception in main]: ${Ee.message}`,stack:Ee.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Ce))}this.h.error(`[uncaught exception in main]: ${Ee}`),Ee.stack&&this.h.error(Ee.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.i.appRoot}`),this.h.debug("args:",this.i.args);const Ee=this.n.win32AppUserModelId;v.isWindows&&Ee&&I.app.setAppUserModelId(Ee);try{v.isMacintosh&&this.k.getValue("window.nativeTabs")===!0&&!I.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&I.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.h.error(Ne)}const Ce=new l.Server;this.j.onWillShutdown(Ne=>{Ne.reason===2&&Ce.dispose()}),this.h.trace("Resolving machine identifier...");const Re=await(0,Gt.resolveMachineId)(this.l);this.h.trace(`Resolved machine identifier: ${Re}`);const{sharedProcess:Ie,sharedProcessReady:Fe,sharedProcessClient:ze}=this.w(Re),_e=await this.y(Re,Ie,Fe);this.v(_e),_e.invokeFunction(Ne=>this.z(Ne,Ce,ze)),await _e.invokeFunction(Ne=>this.C(Ne,Ce)),_e.invokeFunction(Ne=>this.G(Ne,Ie)),this.B(new Pt.RunOnceScheduler(()=>{this.B((0,Pt.runWhenIdle)(()=>this.j.phase=4,2500))},2500)).schedule()}v(Ee){this.B(Ee.createInstance(s.ProxyAuthHandler)),this.B(Ee.createInstance(Ht.UserDataTransientProfilesHandler))}w(Ee){const Ce=this.B(this.g.createInstance(Oe.SharedProcess,Ee,this.f)),Re=(async()=>{this.h.trace("Main->SharedProcess#connect");const Fe=await Ce.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new i.Client(Fe,"main")})(),Ie=(async()=>(await Ce.whenReady(),Re))();return{sharedProcess:Ce,sharedProcessReady:Ie,sharedProcessClient:Re}}async y(Ee,Ce,Re){const Ie=new O.ServiceCollection;switch(process.platform){case"win32":Ie.set(ve.IUpdateService,new j.SyncDescriptor(Ue.Win32UpdateService));break;case"linux":v.isLinuxSnap?Ie.set(ve.IUpdateService,new j.SyncDescriptor(qe.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Ie.set(ve.IUpdateService,new j.SyncDescriptor(Te.LinuxUpdateService));break;case"darwin":Ie.set(ve.IUpdateService,new j.SyncDescriptor(We.DarwinUpdateService));break}Ie.set(ue.IWindowsMainService,new j.SyncDescriptor(me.WindowsMainService,[Ee,this.f],!1));const Fe=new N.DialogMainService(this.h);Ie.set(N.IDialogMainService,Fe),Ie.set(H.ILaunchMainService,new j.SyncDescriptor(H.LaunchMainService,void 0,!1)),Ie.set(L.IDiagnosticsMainService,new j.SyncDescriptor(L.DiagnosticsMainService,void 0,!1)),Ie.set(D.IDiagnosticsService,f.ProxyChannel.toService((0,f.getDelayedChannel)(Re.then(et=>et.getChannel("diagnostics"))))),Ie.set(F.IIssueMainService,new j.SyncDescriptor(F.IssueMainService,[this.f])),Ie.set(X.IEncryptionMainService,new j.SyncDescriptor(ae.EncryptionMainService,[Ee])),Ie.set(U.IKeyboardLayoutMainService,new j.SyncDescriptor(U.KeyboardLayoutMainService)),Ie.set(oe.INativeHostMainService,new j.SyncDescriptor(oe.NativeHostMainService,[Ce],!1)),Ie.set(o.ICredentialsMainService,new j.SyncDescriptor(tt.CredentialsNativeMainService)),Ie.set(G.IWebviewManagerService,new j.SyncDescriptor(ce.WebviewMainService)),Ie.set(Z.IMenubarMainService,new j.SyncDescriptor(Z.MenubarMainService)),Ie.set(re.IExtensionUrlTrustService,new j.SyncDescriptor(fe.ExtensionUrlTrustService)),Ie.set(K.IExtensionHostStarter,new j.SyncDescriptor(le.ExtensionHostStarter)),Ie.set(we.IStorageMainService,new j.SyncDescriptor(we.StorageMainService)),Ie.set(we.IApplicationStorageMainService,new j.SyncDescriptor(we.ApplicationStorageMainService)),v.isWindows?Ie.set($.IExternalTerminalMainService,new j.SyncDescriptor(W.WindowsExternalTerminalService)):v.isMacintosh?Ie.set($.IExternalTerminalMainService,new j.SyncDescriptor(W.MacExternalTerminalService)):v.isLinux&&Ie.set($.IExternalTerminalMainService,new j.SyncDescriptor(W.LinuxExternalTerminalService));const ze=new r.BackupMainService(this.i,this.k,this.h,this.l);Ie.set(a.IBackupMainService,ze);const _e=new He.WorkspacesManagementMainService(this.i,this.h,this.p,ze,Fe,this.n);if(Ie.set(He.IWorkspacesManagementMainService,_e),Ie.set(Be.IWorkspacesService,new j.SyncDescriptor(xe.WorkspacesMainService,void 0,!1)),Ie.set(it.IWorkspacesHistoryMainService,new j.SyncDescriptor(it.WorkspacesHistoryMainService,void 0,!1)),Ie.set(je.IURLService,new j.SyncDescriptor($e.NativeURLService,void 0,!1)),(0,de.supportsTelemetry)(this.n,this.i)){const et=(0,de.isInternalTelemetry)(this.n,this.k),Ne=(0,f.getDelayedChannel)(Re.then(ct=>ct.getChannel("telemetryAppender"))),Ge=new ee.TelemetryAppenderClient(Ne),Xe=(0,ye.resolveCommonProperties)(this.m,(0,k.release)(),(0,k.hostname)(),process.arch,this.n.commit,this.n.version,Ee,et,this.i.installSourcePath),Ze=(0,de.getPiiPathsFromEnvironment)(this.i),st={appenders:[Ge],commonProperties:Xe,piiPaths:Ze,sendErrorTelemetry:!0};Ie.set(Me.ITelemetryService,new j.SyncDescriptor(he.TelemetryService,[st],!1))}else Ie.set(Me.ITelemetryService,de.NullTelemetryService);return Ie.set(Wt.IExtensionsProfileScannerService,new j.SyncDescriptor(Wt.ExtensionsProfileScannerService,void 0,!0)),Ie.set(zt.IExtensionsScannerService,new j.SyncDescriptor(qt.ExtensionsScannerService,void 0,!0)),await Pt.Promises.settled([ze.initialize(),_e.initialize()]),this.g.createChild(Ie)}z(Ee,Ce,Re){const Ie=f.ProxyChannel.fromService(Ee.get(H.ILaunchMainService),{disableMarshalling:!0});this.c.registerChannel("launch",Ie);const Fe=f.ProxyChannel.fromService(Ee.get(L.IDiagnosticsMainService),{disableMarshalling:!0});this.c.registerChannel("diagnostics",Fe);const ze=new lt.PolicyChannel(Ee.get(nt.IPolicyService));Ce.registerChannel("policy",ze),Re.then(Ye=>Ye.registerChannel("policy",ze));const _e=this.m.getProvider(h.Schemas.file);(0,b.assertType)(_e instanceof q.DiskFileSystemProvider);const et=new Q.DiskFileSystemProviderChannel(_e,this.h,this.i);Ce.registerChannel(T.LOCAL_FILE_SYSTEM_CHANNEL_NAME,et),Re.then(Ye=>Ye.registerChannel(T.LOCAL_FILE_SYSTEM_CHANNEL_NAME,et));const Ne=f.ProxyChannel.fromService(Ee.get(at.IUserDataProfilesMainService));Ce.registerChannel("userDataProfiles",Ne),Re.then(Ye=>Ye.registerChannel("userDataProfiles",Ne));const Ge=new Bt.RequestChannel(Ee.get($t.IRequestService));Re.then(Ye=>Ye.registerChannel("request",Ge));const Xe=new Pe.UpdateChannel(Ee.get(ve.IUpdateService));Ce.registerChannel("update",Xe);const Ze=f.ProxyChannel.fromService(Ee.get(F.IIssueMainService));Ce.registerChannel("issue",Ze);const st=f.ProxyChannel.fromService(Ee.get(X.IEncryptionMainService));Ce.registerChannel("encryption",st);const ct=f.ProxyChannel.fromService(Ee.get(o.ICredentialsMainService));Ce.registerChannel("credentials",ct);const kt=f.ProxyChannel.fromService(Ee.get(De.ISignService));Ce.registerChannel("sign",kt);const Qe=f.ProxyChannel.fromService(Ee.get(U.IKeyboardLayoutMainService));Ce.registerChannel("keyboardLayout",Qe),this.b=Ee.get(oe.INativeHostMainService);const wt=f.ProxyChannel.fromService(this.b);Ce.registerChannel("nativeHost",wt),Re.then(Ye=>Ye.registerChannel("nativeHost",wt));const pt=f.ProxyChannel.fromService(Ee.get(Be.IWorkspacesService));Ce.registerChannel("workspaces",pt);const yt=f.ProxyChannel.fromService(Ee.get(Z.IMenubarMainService));Ce.registerChannel("menubar",yt);const Dt=f.ProxyChannel.fromService(Ee.get(je.IURLService));Ce.registerChannel("url",Dt);const Mt=f.ProxyChannel.fromService(Ee.get(re.IExtensionUrlTrustService));Ce.registerChannel("extensionUrlTrust",Mt);const bt=f.ProxyChannel.fromService(Ee.get(G.IWebviewManagerService));Ce.registerChannel("webview",bt);const ut=this.B(new be.StorageDatabaseChannel(this.h,Ee.get(we.IStorageMainService)));Ce.registerChannel("storage",ut),Re.then(Ye=>Ye.registerChannel("storage",ut));const St=this.B(new Vt.ProfileStorageChangesListenerChannel(Ee.get(we.IStorageMainService),Ee.get(at.IUserDataProfilesMainService),this.h));Re.then(Ye=>Ye.registerChannel("profileStorageListener",St));const vt=f.ProxyChannel.fromService(Ee.get($.IExternalTerminalMainService));Ce.registerChannel("externalTerminal",vt);const ht=new _.LogLevelChannel(Ee.get(B.ILogService),Ee.get(B.ILoggerService));Ce.registerChannel("logLevel",ht),Re.then(Ye=>Ye.registerChannel("logLevel",ht));const Ve=new _.LoggerChannel(Ee.get(B.ILoggerService));Ce.registerChannel("logger",Ve),Re.then(Ye=>Ye.registerChannel("logger",Ve));const ot=new S.ElectronExtensionHostDebugBroadcastChannel(Ee.get(ue.IWindowsMainService));Ce.registerChannel("extensionhostdebugservice",ot);const ft=f.ProxyChannel.fromService(Ee.get(K.IExtensionHostStarter));Ce.registerChannel(K.ipcExtensionHostStarterChannelName,ft)}async C(Ee,Ce){const Re=this.a=Ee.get(ue.IWindowsMainService),Ie=Ee.get(je.IURLService),Fe=Ee.get(oe.INativeHostMainService);this.j.phase=2;const ze=[],_e=[...this.i.args["open-url"]?this.i.args._urls||[]:[],...global.getOpenUrls()||[]].map(Ve=>{try{return{uri:u.URI.parse(Ve),url:Ve}}catch{return}}).filter(Ve=>{if(!Ve||this.D(Ve.uri))return!1;const ot=this.F(Ve.uri);return ot?(ze.push(ot),!1):!0}),et=this,Ne=this.i,Ge=this.n,Xe=this.h;Ie.registerHandler({async handleURL(Ve,ot){if(Xe.trace("app#handleURL: ",Ve.toString(!0),ot),Ve.scheme===Ge.urlProtocol&&Ve.path==="workspace"&&(Ve=Ve.with({authority:"file",path:u.URI.parse(Ve.query).path,query:""})),et.D(Ve))return!0;let ft=!1;const Ye=new URLSearchParams(Ve.query);Ye.get("windowId")==="_blank"&&(Ye.delete("windowId"),Ve=Ve.with({query:Ye.toString()}),ft=!0),ft||=v.isMacintosh&&Re.getWindowCount()===0;const Ut=Ye.get("continueOn");Ut!==null&&(Ne.continueOn=Ut??void 0,Ye.delete("continueOn"),Ve=Ve.with({query:Ye.toString()}));const Rt=et.F(Ve);if(Xe.trace("app#handleURL: windowOpenableFromProtocolLink = ",Rt),Rt){const[At]=await Re.open({context:5,cli:{...Ne.args},urisToOpen:[Rt],forceNewWindow:ft,gotoLineMode:!0});return At.focus(),!0}if(ft){const[At]=await Re.open({context:5,cli:{...Ne.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ke.getRemoteAuthority)(Ve)});return await At.ready(),Ie.open(Ve,ot)}return!1}});const Ze=this.B(new Se.ActiveWindowManager({onDidOpenWindow:Fe.onDidOpenWindow,onDidFocusWindow:Fe.onDidFocusWindow,getActiveWindowId:()=>Fe.getActiveWindowId(-1)})),st=new f.StaticRouter(Ve=>Ze.getActiveClientId().then(ot=>Ve===ot)),ct=new Je.URLHandlerRouter(st),kt=Ce.getChannel("urlHandler",ct);Ie.registerHandler(new Je.URLHandlerChannelClient(kt)),this.B(new Ke.ElectronURLListener(_e,Ie,Re,this.i,this.n));const Qe=this.i.args,wt=global.macOpenFiles,pt=(0,Y.isLaunchedFromCli)(process.env)?0:4,yt=Qe._.length,Dt=!!Qe["folder-uri"],Mt=!!Qe["file-uri"],bt=Qe["skip-add-to-recently-opened"]===!0,ut=Qe.wait&&Qe.waitMarkerFilePath?u.URI.file(Qe.waitMarkerFilePath):void 0,St=Qe.remote||void 0,vt=Qe.profile,ht=Qe["profile-temp"];if(ze.length>0)return Re.open({context:pt,cli:Qe,urisToOpen:ze,gotoLineMode:!0,initialStartup:!0});if(!yt&&!Dt&&!Mt){if(Qe["new-window"]||vt||ht)return Re.open({context:pt,cli:Qe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:bt,waitMarkerFileURI:ut,initialStartup:!0,remoteAuthority:St,forceProfile:vt,forceTempProfile:ht});if(wt.length)return Re.open({context:1,cli:Qe,urisToOpen:wt.map(Ve=>(0,Ae.hasWorkspaceFileExtension)(Ve)?{workspaceUri:u.URI.file(Ve)}:{fileUri:u.URI.file(Ve)}),noRecentEntry:bt,waitMarkerFileURI:ut,initialStartup:!0})}return Re.open({context:pt,cli:Qe,forceNewWindow:Qe["new-window"]||!yt&&Qe["unity-launch"],diffMode:Qe.diff,mergeMode:Qe.merge,noRecentEntry:bt,waitMarkerFileURI:ut,gotoLineMode:Qe.goto,initialStartup:!0,remoteAuthority:St,forceProfile:vt,forceTempProfile:ht})}D(Ee){return!!(Ee.authority===h.Schemas.file&&v.isWindows&&I.dialog.showMessageBoxSync({title:this.n.nameLong,type:"question",buttons:[(0,P.mnemonicButtonLabel)((0,n.localize)(0,null)),(0,P.mnemonicButtonLabel)((0,n.localize)(1,null))],defaultId:0,cancelId:1,message:(0,n.localize)(2,null,(0,P.getPathLabel)(Ee,{os:v.OS,tildify:this.i}),this.n.nameShort),detail:(0,n.localize)(3,null),noLink:!0})===1)}F(Ee){if(!!Ee.path){if(Ee.authority===h.Schemas.file){const Ce=u.URI.file(Ee.fsPath);return(0,Ae.hasWorkspaceFileExtension)(Ce)?{workspaceUri:Ce}:{fileUri:Ce}}else if(Ee.authority===h.Schemas.vscodeRemote){const Ce=Ee.path.indexOf(d.posix.sep,1);if(Ce!==-1){const Re=Ee.path.substring(1,Ce),Ie=Ee.path.substring(Ce),Fe=u.URI.from({scheme:h.Schemas.vscodeRemote,authority:Re,path:Ie,query:Ee.query,fragment:Ee.fragment});return(0,Ae.hasWorkspaceFileExtension)(Ie)?{workspaceUri:Fe}:/:[\d]+$/.test(Ie)?{fileUri:Fe}:{folderUri:Fe}}}}}G(Ee,Ce){const Re=Ee.get(Me.ITelemetryService),Ie=Ee.get(ve.IUpdateService);this.j.phase=3,this.I(Re,Ce),this.H(),I.protocol.registerHttpProtocol(h.Schemas.vscodeRemoteResource,(Fe,ze)=>{ze({url:Fe.url.replace(/^vscode-remote-resource:/,"http:"),method:Fe.method})}),(Ie instanceof Ue.Win32UpdateService||Ie instanceof Te.LinuxUpdateService||Ie instanceof We.DarwinUpdateService)&&Ie.initialize(),this.J(this.i.args,process.env,!0),this.L()}async H(){const Ee=this.n.win32MutexName;if(v.isWindows&&Ee)try{const Ce=await new Promise((Ie,Fe)=>{V(["windows-mutex"],Ie,Fe)}),Re=new Ce.Mutex(Ee);(0,m.once)(this.j.onWillShutdown)(()=>Re.release())}catch(Ce){this.h.error(Ce)}}I(Ee,Ce){let Re=!1;(0,m.once)(this.j.onWillShutdown)(()=>Re=!0),this.B(Ce.onDidError(({type:Ie,details:Fe})=>{let ze;switch(Ie){case 1:ze="SharedProcess: detected unresponsive window";break;case 2:ze=`SharedProcess: renderer process gone (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break;case 3:ze=`SharedProcess: failed to load (detail: ${Fe?.reason??"<unknown>"}, code: ${Fe?.exitCode??"<unknown>"})`;break}(0,C.onUnexpectedError)(new Error(ze)),Ee.publicLog2("sharedprocesserror",{type:Ie,reason:Fe?.reason,code:Fe?.exitCode,visible:Ce.isVisible(),shuttingdown:Re})}))}async J(Ee,Ce,Re){try{return await(0,se.getResolvedShellEnv)(this.h,Ee,Ce)}catch(Ie){const Fe=(0,A.toErrorMessage)(Ie);Re?this.a?.sendToFocused("vscode:showResolveShellEnvError",Fe):this.h.error(Fe)}return{}}async L(){try{const Ce=(await this.m.readFile(this.i.argvResource)).value.toString(),Re=JSON.parse((0,y.stripComments)(Ce)),Fe=(0,de.getTelemetryLevel)(this.k)>=1;if(Re["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Fe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,p.generateUuid)()}"`,"}"],_e=Ce.substring(0,Ce.length-2).concat(`,
`,ze.join(`
`));await this.m.writeFile(this.i.argvResource,R.VSBuffer.fromString(_e))}else{const ze=Ce.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Fe},`);ze!==Ce&&await this.m.writeFile(this.i.argvResource,R.VSBuffer.fromString(ze))}}catch(Ee){this.h.error(Ee)}}};Ct=pe([ne(2,M.IInstantiationService),ne(3,B.ILogService),ne(4,J.IEnvironmentMainService),ne(5,x.ILifecycleMainService),ne(6,c.IConfigurationService),ne(7,Le.IStateMainService),ne(8,z.IFileService),ne(9,ge.IProductService),ne(10,at.IUserDataProfilesMainService)],Ct),e.CodeApplication=Ct}),define(te[276],ie([0,1,37,8,284,2,6]),function(V,e,I,t,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let C=class extends I.AbstractPolicyService{constructor(m,y){super(),this.j=m,this.k=y,this.a=new t.Throttler,this.b=this.B(new R.MutableDisposable)}async i(m){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(m).length} policy definitions`),await this.a.queue(()=>new Promise((y,P)=>{try{this.b.value=(0,k.createWatcher)(this.k,m,E=>{this.m(E),y()})}catch(E){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",E),P(E)}}))}m(m){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(m)}`);for(const y in m){const P=m[y];P===void 0?this.g.delete(y):this.g.set(y,P)}this.h.fire(Object.keys(m))}};C=pe([ne(0,A.ILogService)],C),e.NativePolicyService=C}),define(te[277],ie([0,1,226,8,17,14,2,12,18,35,111,6,225,285]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let d=class extends A.Disposable{constructor(b,u,p){super(),this.h=u,this.i=p,this.j(b.getValue()),this.B(b.onDidChangeConfiguration(()=>this.j(b.getValue()),this))}j(b){this.a=b.http&&b.http.proxy,this.b=!!(b.http&&b.http.proxyStrictSSL),this.f=b.http&&b.http.proxyAuthorization}async request(b,u){this.i.trace("RequestService#request (node) - begin",b.url);const{a:p,b:g}=this;let f;try{f=await(0,y.getResolvedShellEnv)(this.i,this.h.args,process.env)}catch(s){this.g||(this.g=!0,this.i.error("RequestService#request (node) resolving shell environment failed",s))}const l={...process.env,...f},i=b.agent?b.agent:await(0,E.getProxyAgent)(b.url||"",l,{proxyUrl:p,strictSSL:g});b.agent=i,b.strictSSL=g,this.f&&(b.headers={...b.headers||{},"Proxy-Authorization":this.f});try{const s=await this.l(b,u);return this.i.trace("RequestService#request (node) - success",b.url),s}catch(s){throw this.i.trace("RequestService#request (node) - error",b.url,s),s}}async k(b){return((0,I.parse)(b.url).protocol==="https:"?await new Promise((g,f)=>{V(["https"],g,f)}):await new Promise((g,f)=>{V(["http"],g,f)})).request}l(b,u){return t.Promises.withAsyncBody(async(p,g)=>{const f=(0,I.parse)(b.url),l=b.getRawRequest?b.getRawRequest(b):await this.k(b),i={hostname:f.hostname,port:f.port?parseInt(f.port):f.protocol==="https:"?443:80,protocol:f.protocol,path:f.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,C.isBoolean)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(i.auth=b.user+":"+b.password);const s=l(i,n=>{const a=(0,C.isNumber)(b.followRedirects)?b.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&a>0&&n.headers.location)this.l({...b,url:n.headers.location,followRedirects:a-1},u).then(p,g);else{let r=n;!b.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(r=n.pipe((0,h.createGunzip)())),p({res:n,stream:(0,k.streamToBufferReadableStream)(r)})}});s.on("error",g),b.timeout&&s.setTimeout(b.timeout),b.isChromiumNetwork&&s.removeHeader("Content-Length"),b.data&&typeof b.data=="string"&&s.write(b.data),s.end(),u.onCancellationRequested(()=>{s.abort(),g(new R.CancellationError)})})}async resolveProxy(b){}};d=pe([ne(0,w.IConfigurationService),ne(1,m.INativeEnvironmentService),ne(2,P.ILogService)],d),e.RequestService=d}),define(te[278],ie([0,1,13,277]),function(V,e,I,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function k(A){return I.net.request}class R extends t.RequestService{request(C,w){return super.request({...C||{},getRawRequest:k,isChromiumNetwork:!0},w)}}e.RequestMainService=R}),define(te[286],ie([0,1,13,40,7,24,8,45,14,30,50,34,15,9,73,4,33,26,23,47,83,275,10,18,219,232,27,61,184,16,205,86,70,201,85,21,208,6,211,63,19,64,259,114,240,55,278,88,227,36,231,56,66,51,37,276,213,2,42,245,38,241]),function(V,e,I,t,k,R,A,C,w,m,y,P,E,h,d,v,b,u,p,g,f,l,i,s,n,a,r,c,o,S,D,L,N,X,ae,J,Y,se,re,fe,K,le,$,W,T,z,Q,q,j,M,O,F,U,H,x,B,_,Z,oe,ge,ke){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Oe{main(){try{this.a()}catch(be){console.error(be.message),I.app.exit(1)}}async a(){(0,w.setUnexpectedErrorHandler)(Pe=>console.error(Pe));const[be,we,ye,Me,ee,he,de,ve]=this.b();try{try{await this.d(ye,ve,Me,ee,de)}catch(Pe){throw this.f(ye,de.nameLong,Pe),Pe}await be.invokeFunction(async Pe=>{const We=Pe.get(se.ILogService),Te=Pe.get(J.ILifecycleMainService),qe=Pe.get(S.IFileService),Ue=Pe.get(se.ILoggerService),je=await this.e(We,ye,Te,be,de,!0);return p.Promises.writeFile(ye.mainLockfile,String(process.pid)).catch(Je=>{We.warn(`Error writing main lockfile: ${Je.stack}`)}),he.logger=Ue.createLogger(k.URI.file((0,h.join)(ye.logsPath,"main.log")),{name:"main"}),(0,y.once)(Te.onWillShutdown)(Je=>{qe.dispose(),Me.dispose(),Je.join(p.Promises.unlink(ye.mainLockfile).catch(()=>{}))}),be.createInstance(l.CodeApplication,je,we).startup()})}catch(Pe){be.invokeFunction(this.i,Pe)}}b(){const be=new ae.ServiceCollection,we=new Z.DisposableStore;process.once("exit",()=>we.dispose());const ye={_serviceBrand:void 0,...fe.default};be.set(K.IProductService,ye);const Me=new r.EnvironmentMainService(this.j(),ye),ee=this.c(Me);be.set(r.IEnvironmentMainService,Me);const he=new Y.BufferLogService,de=we.add(new se.MultiplexLogService([new se.ConsoleMainLogger((0,se.getLogLevel)(Me)),he]));be.set(se.ILogService,de);const ve=new D.FileService(de);be.set(S.IFileService,ve);const Pe=new L.DiskFileSystemProvider(de);ve.registerProvider(E.Schemas.file,Pe);const We=new ge.UriIdentityService(ve);be.set(oe.IUriIdentityService,We),be.set(se.ILoggerService,new re.LoggerService(de));const Te=new O.StateMainService(Me,de,ve);be.set(M.IStateMainService,Te);const qe=new H.UserDataProfilesMainService(Te,We,Me,ve,de);be.set(H.IUserDataProfilesMainService,qe);const Ue=v.isWindows&&ye.win32RegValueName?we.add(new B.NativePolicyService(de,ye.win32RegValueName)):Me.policyFile?we.add(new _.FilePolicyService(Me.policyFile,ve,de)):new x.NullPolicyService;be.set(x.IPolicyService,Ue);const je=new n.ConfigurationService(qe.defaultProfile.settingsResource,ve,Ue,de);return be.set(s.IConfigurationService,je),be.set(J.ILifecycleMainService,new N.SyncDescriptor(J.LifecycleMainService,void 0,!1)),be.set(z.IRequestService,new N.SyncDescriptor(Q.RequestMainService,void 0,!0)),be.set(U.IThemeMainService,new N.SyncDescriptor(U.ThemeMainService)),be.set(q.ISignService,new N.SyncDescriptor(j.SignService,void 0,!1)),be.set(W.ITunnelService,new N.SyncDescriptor(T.TunnelService)),be.set(le.IProtocolMainService,new $.ProtocolMainService(Me,qe,de)),[new X.InstantiationService(be,!0),ee,Me,je,Te,he,ye,qe]}c(be){const we={VSCODE_IPC_HOOK:be.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ye=>{const Me=process.env[ye];typeof Me=="string"&&(we[ye]=Me)}),Object.assign(process.env,we),we}async d(be,we,ye,Me,ee){await A.Promises.settled([Promise.all([be.extensionsPath,be.codeCachePath,be.logsPath,we.defaultProfile.globalStorageHome.fsPath,be.workspaceStorageHome.fsPath,be.localHistoryHome.fsPath,be.backupHome].map(he=>he?p.Promises.mkdir(he,{recursive:!0}):void 0)),Me.init(),ye.initialize()]),we.setEnablement(ee.quality!=="stable"||ye.getValue(ke.PROFILES_ENABLEMENT_CONFIG))}async e(be,we,ye,Me,ee,he){let de;try{(0,d.mark)("code/willStartMainServer"),de=await(0,f.serve)(we.mainIPCHandle),(0,d.mark)("code/didStartMainServer"),(0,y.once)(ye.onWillShutdown)(()=>de.dispose())}catch(ve){if(ve.code!=="EADDRINUSE")throw this.f(we,ee.nameLong,ve),ve;let Pe;try{Pe=await(0,f.connect)(we.mainIPCHandle,"main")}catch(Ue){if(!he||v.isWindows||Ue.code!=="ECONNREFUSED")throw Ue.code==="EPERM"&&this.g((0,i.localize)(0,null,ee.nameShort),(0,i.localize)(1,null),ee.nameLong),Ue;try{(0,t.unlinkSync)(we.mainIPCHandle)}catch(je){throw be.warn("Could not delete obsolete instance handle",je),je}return this.e(be,we,ye,Me,ee,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const Ue=`Running extension tests from the command line is currently only supported if no other instance of ${ee.nameShort} is running.`;throw be.error(Ue),Pe.dispose(),new Error(Ue)}let We;!we.args.wait&&!we.args.status&&(We=setTimeout(()=>{this.g((0,i.localize)(2,null,ee.nameShort),(0,i.localize)(3,null),ee.nameLong)},1e4));const Te=g.ProxyChannel.toService(Pe.getChannel("launch"),{disableMarshalling:!0}),qe=g.ProxyChannel.toService(Pe.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return Me.invokeFunction(async()=>{const Ue=new a.DiagnosticsService(F.NullTelemetryService,ee),je=await qe.getMainDiagnostics(),Je=await qe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),$e=await Ue.getDiagnostics(je,Je);throw console.log($e),new w.ExpectedError});throw v.isWindows&&await this.h(Te,be),be.trace("Sending env to running instance..."),await Te.start(we.args,process.env),Pe.dispose(),We&&clearTimeout(We),new w.ExpectedError("Sent env to running instance. Terminating...")}if(we.args.status)throw be.warn(`Warning: The --status argument can only be used if ${ee.nameShort} is already running. Please run it again after {0} has started.`),new w.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),de}f(be,we,ye){if(ye.code==="EACCES"||ye.code==="EPERM"){const Me=(0,R.coalesce)([be.userDataPath,be.extensionsPath,f.XDG_RUNTIME_DIR]).map(ee=>(0,P.getPathLabel)(k.URI.file(ee),{os:v.OS,tildify:be}));this.g((0,i.localize)(4,null),(0,i.localize)(5,null,(0,C.toErrorMessage)(ye),Me.join(`
`)),we)}}g(be,we,ye){I.dialog.showMessageBoxSync({title:ye,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,i.localize)(6,null))],message:be,detail:we,defaultId:0,noLink:!0})}async h(be,we){if(v.isWindows){const ye=await be.getMainProcessId();we.trace("Sending some foreground love to the running instance:",ye);try{(await new Promise((Me,ee)=>{V(["windows-foreground-love"],Me,ee)})).allowSetForegroundWindow(ye)}catch(Me){we.error(Me)}}}i(be,we){const ye=be.get(se.ILogService),Me=be.get(J.ILifecycleMainService);let ee=0;we&&(we.isExpected?we.message&&ye.trace(we.message):(ee=1,we.stack?ye.error(we.stack):ye.error(`Startup error: ${we.toString()}`))),Me.kill(ee)}j(){const be=this.k((0,c.parseMainProcessArgv)(process.argv));if(be.wait&&!be.waitMarkerFilePath){const we=(0,o.createWaitMarkerFileSync)(be.verbose);we&&((0,c.addArg)(process.argv,"--waitMarkerFilePath",we),be.waitMarkerFilePath=we)}return be}k(be){if(be["open-url"]&&(be._urls=be._,be._=[]),!be.remote){const we=this.l(be._,be.goto);be._=we}return be}l(be,we){const ye=(0,b.cwd)(),Me=be.map(de=>{let ve=String(de),Pe;we&&(Pe=(0,m.parseLineAndColumnAware)(ve),ve=Pe.path),ve&&(ve=this.m(ye,ve));const We=(0,m.sanitizeFilePath)(ve,ye),Te=(0,h.basename)(We);return Te&&!(0,m.isValidBasename)(Te)?null:we&&Pe?(Pe.path=We,this.n(Pe)):We}),ee=v.isWindows||v.isMacintosh,he=(0,R.distinct)(Me,de=>de&&ee?de.toLowerCase():de||"");return(0,R.coalesce)(he)}m(be,we){return v.isWindows&&(we=(0,u.rtrim)(we,'"')),we=(0,u.trim)((0,u.trim)(we," "),"	"),v.isWindows&&(we=(0,h.resolve)(be,we),we=(0,u.rtrim)(we,".")),we}n(be){const we=[be.path];return typeof be.line=="number"&&we.push(String(be.line)),typeof be.column=="number"&&we.push(String(be.column)),we.join(":")}}new Oe().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d7b1e2a1c892511a125e4ceb9758ec8ddf907775/core/vs/code/electron-main/main.js.map
