/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/errors","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/strings","vs/base/common/codicons","vs/nls","vs/base/common/arrays","vs/base/common/uri","vs/base/browser/browser","vs/base/browser/keyboardEvent","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/browser/mouseEvent","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/platform/instantiation/common/instantiation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/network","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/color","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/scrollable","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/list/listWidget","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/platform/instantiation/common/descriptors","vs/platform/theme/common/themeService","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/collections","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/map","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stream","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/mime","vs/base/common/stopwatch","vs/base/browser/canIUse","vs/base/common/cache","vs/base/common/extpath","vs/base/common/hash","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],be=function(Z){for(var t=[],v=0,i=Z.length;v<i;v++)t[v]=me[Z[v]];return t};/*! @license DOMPurify 2.3.1 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/2.3.1/LICENSE */function $t(Z){if(Array.isArray(Z)){for(var t=0,v=Array(Z.length);t<Z.length;t++)v[t]=Z[t];return v}else return Array.from(Z)}var jt=Object.hasOwnProperty,Nt=Object.setPrototypeOf,Kt=Object.isFrozen,Vt=Object.getPrototypeOf,qt=Object.getOwnPropertyDescriptor,et=Object.freeze,ot=Object.seal,Gt=Object.create,It=typeof Reflect<"u"&&Reflect,vt=It.apply,Ct=It.construct;vt||(vt=function(t,v,i){return t.apply(v,i)}),et||(et=function(t){return t}),ot||(ot=function(t){return t}),Ct||(Ct=function(t,v){return new(Function.prototype.bind.apply(t,[null].concat($t(v))))});var Yt=nt(Array.prototype.forEach),Mt=nt(Array.prototype.pop),mt=nt(Array.prototype.push),ut=nt(String.prototype.toLowerCase),Pt=nt(String.prototype.match),lt=nt(String.prototype.replace),Xt=nt(String.prototype.indexOf),Zt=nt(String.prototype.trim),at=nt(RegExp.prototype.test),Rt=Qt(TypeError);function nt(Z){return function(t){for(var v=arguments.length,i=Array(v>1?v-1:0),z=1;z<v;z++)i[z-1]=arguments[z];return vt(Z,t,i)}}function Qt(Z){return function(){for(var t=arguments.length,v=Array(t),i=0;i<t;i++)v[i]=arguments[i];return Ct(Z,v)}}function He(Z,t){Nt&&Nt(Z,null);for(var v=t.length;v--;){var i=t[v];if(typeof i=="string"){var z=ut(i);z!==i&&(Kt(t)||(t[v]=z),i=z)}Z[i]=!0}return Z}function ct(Z){var t=Gt(null),v=void 0;for(v in Z)vt(jt,Z,[v])&&(t[v]=Z[v]);return t}function Dt(Z,t){for(;Z!==null;){var v=qt(Z,t);if(v){if(v.get)return nt(v.get);if(typeof v.value=="function")return nt(v.value)}Z=Vt(Z)}function i(z){return console.warn("fallback value for",z),null}return i}var Ot=et(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),At=et(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),St=et(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),Jt=et(["animate","color-profile","cursor","discard","fedropshadow","feimage","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),kt=et(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover"]),xt=et(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Bt=et(["#text"]),Ht=et(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Ft=et(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Ut=et(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),yt=et(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),ei=ot(/\{\{[\s\S]*|[\s\S]*\}\}/gm),ti=ot(/<%[\s\S]*|[\s\S]*%>/gm),ii=ot(/^data-[\-\w.\u00B7-\uFFFF]/),ni=ot(/^aria-[\-\w]+$/),si=ot(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),ri=ot(/^(?:\w+script|data):/i),oi=ot(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),bt=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?function(Z){return typeof Z}:function(Z){return Z&&typeof Symbol=="function"&&Z.constructor===Symbol&&Z!==Symbol.prototype?"symbol":typeof Z};function rt(Z){if(Array.isArray(Z)){for(var t=0,v=Array(Z.length);t<Z.length;t++)v[t]=Z[t];return v}else return Array.from(Z)}var ai=function(){return typeof window>"u"?null:window},li=function(t,v){if((typeof t>"u"?"undefined":bt(t))!=="object"||typeof t.createPolicy!="function")return null;var i=null,z="data-tt-policy-suffix";v.currentScript&&v.currentScript.hasAttribute(z)&&(i=v.currentScript.getAttribute(z));var H="dompurify"+(i?"#"+i:"");try{return t.createPolicy(H,{createHTML:function(w){return w}})}catch{return console.warn("TrustedTypes policy "+H+" could not be created."),null}};function zt(){var Z=arguments.length>0&&arguments[0]!==void 0?arguments[0]:ai(),t=function(re){return zt(re)};if(t.version="2.3.1",t.removed=[],!Z||!Z.document||Z.document.nodeType!==9)return t.isSupported=!1,t;var v=Z.document,i=Z.document,z=Z.DocumentFragment,H=Z.HTMLTemplateElement,D=Z.Node,w=Z.Element,d=Z.NodeFilter,m=Z.NamedNodeMap,g=m===void 0?Z.NamedNodeMap||Z.MozNamedAttrMap:m,I=Z.Text,o=Z.Comment,n=Z.DOMParser,e=Z.trustedTypes,s=w.prototype,a=Dt(s,"cloneNode"),l=Dt(s,"nextSibling"),h=Dt(s,"childNodes"),r=Dt(s,"parentNode");if(typeof H=="function"){var c=i.createElement("template");c.content&&c.content.ownerDocument&&(i=c.content.ownerDocument)}var b=li(e,v),S=b&&Y?b.createHTML(""):"",N=i,L=N.implementation,T=N.createNodeIterator,f=N.createDocumentFragment,C=N.getElementsByTagName,p=v.importNode,y={};try{y=ct(i).documentMode?i.documentMode:{}}catch{}var _={};t.isSupported=typeof r=="function"&&L&&typeof L.createHTMLDocument<"u"&&y!==9;var V=ei,ge=ti,Q=ii,ie=ni,te=ri,ue=oi,ae=si,de=null,Ae=He({},[].concat(rt(Ot),rt(At),rt(St),rt(kt),rt(Bt))),x=null,ve=He({},[].concat(rt(Ht),rt(Ft),rt(Ut),rt(yt))),Ne=null,oe=null,X=!0,se=!0,ne=!1,ee=!1,A=!1,E=!1,u=!1,B=!1,W=!1,$=!0,Y=!1,F=!0,O=!0,U=!1,k={},M=null,P=He({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]),R=null,j=He({},["audio","video","img","source","image","track"]),J=null,he=He({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),ce="http://www.w3.org/1998/Math/MathML",De="http://www.w3.org/2000/svg",ye="http://www.w3.org/1999/xhtml",Ie=ye,Se=!1,we=null,Re=i.createElement("form"),Pe=function(re){we&&we===re||((!re||(typeof re>"u"?"undefined":bt(re))!=="object")&&(re={}),re=ct(re),de="ALLOWED_TAGS"in re?He({},re.ALLOWED_TAGS):Ae,x="ALLOWED_ATTR"in re?He({},re.ALLOWED_ATTR):ve,J="ADD_URI_SAFE_ATTR"in re?He(ct(he),re.ADD_URI_SAFE_ATTR):he,R="ADD_DATA_URI_TAGS"in re?He(ct(j),re.ADD_DATA_URI_TAGS):j,M="FORBID_CONTENTS"in re?He({},re.FORBID_CONTENTS):P,Ne="FORBID_TAGS"in re?He({},re.FORBID_TAGS):{},oe="FORBID_ATTR"in re?He({},re.FORBID_ATTR):{},k="USE_PROFILES"in re?re.USE_PROFILES:!1,X=re.ALLOW_ARIA_ATTR!==!1,se=re.ALLOW_DATA_ATTR!==!1,ne=re.ALLOW_UNKNOWN_PROTOCOLS||!1,ee=re.SAFE_FOR_TEMPLATES||!1,A=re.WHOLE_DOCUMENT||!1,B=re.RETURN_DOM||!1,W=re.RETURN_DOM_FRAGMENT||!1,$=re.RETURN_DOM_IMPORT!==!1,Y=re.RETURN_TRUSTED_TYPE||!1,u=re.FORCE_BODY||!1,F=re.SANITIZE_DOM!==!1,O=re.KEEP_CONTENT!==!1,U=re.IN_PLACE||!1,ae=re.ALLOWED_URI_REGEXP||ae,Ie=re.NAMESPACE||ye,ee&&(se=!1),W&&(B=!0),k&&(de=He({},[].concat(rt(Bt))),x=[],k.html===!0&&(He(de,Ot),He(x,Ht)),k.svg===!0&&(He(de,At),He(x,Ft),He(x,yt)),k.svgFilters===!0&&(He(de,St),He(x,Ft),He(x,yt)),k.mathMl===!0&&(He(de,kt),He(x,Ut),He(x,yt))),re.ADD_TAGS&&(de===Ae&&(de=ct(de)),He(de,re.ADD_TAGS)),re.ADD_ATTR&&(x===ve&&(x=ct(x)),He(x,re.ADD_ATTR)),re.ADD_URI_SAFE_ATTR&&He(J,re.ADD_URI_SAFE_ATTR),re.FORBID_CONTENTS&&(M===P&&(M=ct(M)),He(M,re.FORBID_CONTENTS)),O&&(de["#text"]=!0),A&&He(de,["html","head","body"]),de.table&&(He(de,["tbody"]),delete Ne.tbody),et&&et(re),we=re)},Ke=He({},["mi","mo","mn","ms","mtext"]),Ue=He({},["foreignobject","desc","title","annotation-xml"]),We=He({},At);He(We,St),He(We,Jt);var xe=He({},kt);He(xe,xt);var it=function(re){var Ce=r(re);(!Ce||!Ce.tagName)&&(Ce={namespaceURI:ye,tagName:"template"});var Le=ut(re.tagName),ze=ut(Ce.tagName);if(re.namespaceURI===De)return Ce.namespaceURI===ye?Le==="svg":Ce.namespaceURI===ce?Le==="svg"&&(ze==="annotation-xml"||Ke[ze]):Boolean(We[Le]);if(re.namespaceURI===ce)return Ce.namespaceURI===ye?Le==="math":Ce.namespaceURI===De?Le==="math"&&Ue[ze]:Boolean(xe[Le]);if(re.namespaceURI===ye){if(Ce.namespaceURI===De&&!Ue[ze]||Ce.namespaceURI===ce&&!Ke[ze])return!1;var Ge=He({},["title","style","font","a","script"]);return!xe[Le]&&(Ge[Le]||!We[Le])}return!1},Be=function(re){mt(t.removed,{element:re});try{re.parentNode.removeChild(re)}catch{try{re.outerHTML=S}catch{re.remove()}}},je=function(re,Ce){try{mt(t.removed,{attribute:Ce.getAttributeNode(re),from:Ce})}catch{mt(t.removed,{attribute:null,from:Ce})}if(Ce.removeAttribute(re),re==="is"&&!x[re])if(B||W)try{Be(Ce)}catch{}else try{Ce.setAttribute(re,"")}catch{}},Ye=function(re){var Ce=void 0,Le=void 0;if(u)re="<remove></remove>"+re;else{var ze=Pt(re,/^[\r\n\t ]+/);Le=ze&&ze[0]}var Ge=b?b.createHTML(re):re;if(Ie===ye)try{Ce=new n().parseFromString(Ge,"text/html")}catch{}if(!Ce||!Ce.documentElement){Ce=L.createDocument(Ie,"template",null);try{Ce.documentElement.innerHTML=Se?"":Ge}catch{}}var Ze=Ce.body||Ce.documentElement;return re&&Le&&Ze.insertBefore(i.createTextNode(Le),Ze.childNodes[0]||null),Ie===ye?C.call(Ce,A?"html":"body")[0]:A?Ce.documentElement:Ze},K=function(re){return T.call(re.ownerDocument||re,re,d.SHOW_ELEMENT|d.SHOW_COMMENT|d.SHOW_TEXT,null,!1)},le=function(re){return re instanceof I||re instanceof o?!1:typeof re.nodeName!="string"||typeof re.textContent!="string"||typeof re.removeChild!="function"||!(re.attributes instanceof g)||typeof re.removeAttribute!="function"||typeof re.setAttribute!="function"||typeof re.namespaceURI!="string"||typeof re.insertBefore!="function"},pe=function(re){return(typeof D>"u"?"undefined":bt(D))==="object"?re instanceof D:re&&(typeof re>"u"?"undefined":bt(re))==="object"&&typeof re.nodeType=="number"&&typeof re.nodeName=="string"},Ee=function(re,Ce,Le){!_[re]||Yt(_[re],function(ze){ze.call(t,Ce,Le,we)})},Fe=function(re){var Ce=void 0;if(Ee("beforeSanitizeElements",re,null),le(re)||Pt(re.nodeName,/[\u0080-\uFFFF]/))return Be(re),!0;var Le=ut(re.nodeName);if(Ee("uponSanitizeElement",re,{tagName:Le,allowedTags:de}),!pe(re.firstElementChild)&&(!pe(re.content)||!pe(re.content.firstElementChild))&&at(/<[/\w]/g,re.innerHTML)&&at(/<[/\w]/g,re.textContent)||Le==="select"&&at(/<template/i,re.innerHTML))return Be(re),!0;if(!de[Le]||Ne[Le]){if(O&&!M[Le]){var ze=r(re)||re.parentNode,Ge=h(re)||re.childNodes;if(Ge&&ze)for(var Ze=Ge.length,Qe=Ze-1;Qe>=0;--Qe)ze.insertBefore(a(Ge[Qe],!0),l(re))}return Be(re),!0}return re instanceof w&&!it(re)||(Le==="noscript"||Le==="noembed")&&at(/<\/no(script|embed)/i,re.innerHTML)?(Be(re),!0):(ee&&re.nodeType===3&&(Ce=re.textContent,Ce=lt(Ce,V," "),Ce=lt(Ce,ge," "),re.textContent!==Ce&&(mt(t.removed,{element:re.cloneNode()}),re.textContent=Ce)),Ee("afterSanitizeElements",re,null),!1)},Oe=function(re,Ce,Le){if(F&&(Ce==="id"||Ce==="name")&&(Le in i||Le in Re))return!1;if(!(se&&!oe[Ce]&&at(Q,Ce))){if(!(X&&at(ie,Ce))){if(!x[Ce]||oe[Ce])return!1;if(!J[Ce]){if(!at(ae,lt(Le,ue,""))){if(!((Ce==="src"||Ce==="xlink:href"||Ce==="href")&&re!=="script"&&Xt(Le,"data:")===0&&R[re])){if(!(ne&&!at(te,lt(Le,ue,"")))){if(Le)return!1}}}}}}return!0},$e=function(re){var Ce=void 0,Le=void 0,ze=void 0,Ge=void 0;Ee("beforeSanitizeAttributes",re,null);var Ze=re.attributes;if(!!Ze){var Qe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:x};for(Ge=Ze.length;Ge--;){Ce=Ze[Ge];var st=Ce,ht=st.name,Et=st.namespaceURI;if(Le=Zt(Ce.value),ze=ut(ht),Qe.attrName=ze,Qe.attrValue=Le,Qe.keepAttr=!0,Qe.forceKeepAttr=void 0,Ee("uponSanitizeAttribute",re,Qe),Le=Qe.attrValue,!Qe.forceKeepAttr&&(je(ht,re),!!Qe.keepAttr)){if(at(/\/>/i,Le)){je(ht,re);continue}ee&&(Le=lt(Le,V," "),Le=lt(Le,ge," "));var Tt=re.nodeName.toLowerCase();if(!!Oe(Tt,ze,Le))try{Et?re.setAttributeNS(Et,ht,Le):re.setAttribute(ht,Le),Mt(t.removed)}catch{}}}Ee("afterSanitizeAttributes",re,null)}},tt=function Me(re){var Ce=void 0,Le=K(re);for(Ee("beforeSanitizeShadowDOM",re,null);Ce=Le.nextNode();)Ee("uponSanitizeShadowNode",Ce,null),!Fe(Ce)&&(Ce.content instanceof z&&Me(Ce.content),$e(Ce));Ee("afterSanitizeShadowDOM",re,null)};return t.sanitize=function(Me,re){var Ce=void 0,Le=void 0,ze=void 0,Ge=void 0,Ze=void 0;if(Se=!Me,Se&&(Me="<!-->"),typeof Me!="string"&&!pe(Me)){if(typeof Me.toString!="function")throw Rt("toString is not a function");if(Me=Me.toString(),typeof Me!="string")throw Rt("dirty is not a string, aborting")}if(!t.isSupported){if(bt(Z.toStaticHTML)==="object"||typeof Z.toStaticHTML=="function"){if(typeof Me=="string")return Z.toStaticHTML(Me);if(pe(Me))return Z.toStaticHTML(Me.outerHTML)}return Me}if(E||Pe(re),t.removed=[],typeof Me=="string"&&(U=!1),!U)if(Me instanceof D)Ce=Ye("<!---->"),Le=Ce.ownerDocument.importNode(Me,!0),Le.nodeType===1&&Le.nodeName==="BODY"||Le.nodeName==="HTML"?Ce=Le:Ce.appendChild(Le);else{if(!B&&!ee&&!A&&Me.indexOf("<")===-1)return b&&Y?b.createHTML(Me):Me;if(Ce=Ye(Me),!Ce)return B?null:S}Ce&&u&&Be(Ce.firstChild);for(var Qe=K(U?Me:Ce);ze=Qe.nextNode();)ze.nodeType===3&&ze===Ge||Fe(ze)||(ze.content instanceof z&&tt(ze.content),$e(ze),Ge=ze);if(Ge=null,U)return Me;if(B){if(W)for(Ze=f.call(Ce.ownerDocument);Ce.firstChild;)Ze.appendChild(Ce.firstChild);else Ze=Ce;return $&&(Ze=p.call(v,Ze,!0)),Ze}var st=A?Ce.outerHTML:Ce.innerHTML;return ee&&(st=lt(st,V," "),st=lt(st,ge," ")),b&&Y?b.createHTML(st):st},t.setConfig=function(Me){Pe(Me),E=!0},t.clearConfig=function(){we=null,E=!1},t.isValidAttribute=function(Me,re,Ce){we||Pe({});var Le=ut(Me),ze=ut(re);return Oe(Le,ze,Ce)},t.addHook=function(Me,re){typeof re=="function"&&(_[Me]=_[Me]||[],mt(_[Me],re))},t.removeHook=function(Me){_[Me]&&Mt(_[Me])},t.removeHooks=function(Me){_[Me]&&(_[Me]=[])},t.removeAllHooks=function(){_={}},t}var hi=zt();define("vs/base/browser/dompurify/dompurify",function(){return hi}),define(me[39],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createFastDomNode=t.FastDomNode=void 0;class v{constructor(D){this.domNode=D,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(D){const w=i(D);this.a!==w&&(this.a=w,this.domNode.style.maxWidth=this.a)}setWidth(D){const w=i(D);this.b!==w&&(this.b=w,this.domNode.style.width=this.b)}setHeight(D){const w=i(D);this.c!==w&&(this.c=w,this.domNode.style.height=this.c)}setTop(D){const w=i(D);this.d!==w&&(this.d=w,this.domNode.style.top=this.d)}setLeft(D){const w=i(D);this.e!==w&&(this.e=w,this.domNode.style.left=this.e)}setBottom(D){const w=i(D);this.f!==w&&(this.f=w,this.domNode.style.bottom=this.f)}setRight(D){const w=i(D);this.g!==w&&(this.g=w,this.domNode.style.right=this.g)}setPaddingTop(D){const w=i(D);this.h!==w&&(this.h=w,this.domNode.style.paddingTop=this.h)}setPaddingLeft(D){const w=i(D);this.i!==w&&(this.i=w,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(D){const w=i(D);this.j!==w&&(this.j=w,this.domNode.style.paddingBottom=this.j)}setPaddingRight(D){const w=i(D);this.k!==w&&(this.k=w,this.domNode.style.paddingRight=this.k)}setFontFamily(D){this.l!==D&&(this.l=D,this.domNode.style.fontFamily=this.l)}setFontWeight(D){this.m!==D&&(this.m=D,this.domNode.style.fontWeight=this.m)}setFontSize(D){const w=i(D);this.n!==w&&(this.n=w,this.domNode.style.fontSize=this.n)}setFontStyle(D){this.o!==D&&(this.o=D,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(D){this.p!==D&&(this.p=D,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(D){this.q!==D&&(this.q=D,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(D){this.r!==D&&(this.r=D,this.domNode.style.textDecoration=this.r)}setLineHeight(D){const w=i(D);this.s!==w&&(this.s=w,this.domNode.style.lineHeight=this.s)}setLetterSpacing(D){const w=i(D);this.t!==w&&(this.t=w,this.domNode.style.letterSpacing=this.t)}setClassName(D){this.u!==D&&(this.u=D,this.domNode.className=this.u)}toggleClassName(D,w){this.domNode.classList.toggle(D,w),this.u=this.domNode.className}setDisplay(D){this.v!==D&&(this.v=D,this.domNode.style.display=this.v)}setPosition(D){this.w!==D&&(this.w=D,this.domNode.style.position=this.w)}setVisibility(D){this.x!==D&&(this.x=D,this.domNode.style.visibility=this.x)}setColor(D){this.y!==D&&(this.y=D,this.domNode.style.color=this.y)}setBackgroundColor(D){this.z!==D&&(this.z=D,this.domNode.style.backgroundColor=this.z)}setLayerHinting(D){this.A!==D&&(this.A=D,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(D){this.C!==D&&(this.C=D,this.domNode.style.boxShadow=D)}setContain(D){this.B!==D&&(this.B=D,this.domNode.style.contain=this.B)}setAttribute(D,w){this.domNode.setAttribute(D,w)}removeAttribute(D){this.domNode.removeAttribute(D)}appendChild(D){this.domNode.appendChild(D.domNode)}removeChild(D){this.domNode.removeChild(D.domNode)}}t.FastDomNode=v;function i(H){return typeof H=="number"?`${H}px`:H}function z(H){return new v(H)}t.createFastDomNode=z}),define(me[67],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0;let v=!1,i=null;function z(D){if(!D.parent||D.parent===D)return null;try{const w=D.location,d=D.parent.location;if(w.origin!=="null"&&d.origin!=="null"&&w.origin!==d.origin)return v=!0,null}catch{return v=!0,null}return D.parent}class H{static getSameOriginWindowChain(){if(!i){i=[];let w=window,d;do d=z(w),d?i.push({window:w,iframeElement:w.frameElement||null}):i.push({window:w,iframeElement:null}),w=d;while(w)}return i.slice(0)}static hasDifferentOriginAncestor(){return i||this.getSameOriginWindowChain(),v}static getPositionOfChildWindowRelativeToAncestorWindow(w,d){if(!d||w===d)return{top:0,left:0};let m=0,g=0;const I=this.getSameOriginWindowChain();for(const o of I){if(m+=o.window.scrollY,g+=o.window.scrollX,o.window===d||!o.iframeElement)break;const n=o.iframeElement.getBoundingClientRect();m+=n.top,g+=n.left}return{top:m,left:g}}}t.IframeUtils=H}),define(me[68],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffect=void 0;var v;(function(H){H[H.Copy=0]="Copy",H[H.Move=1]="Move"})(v=t.ListDragOverEffect||(t.ListDragOverEffect={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class i extends Error{constructor(D,w){super(`ListError [${D}] ${w}`)}}t.ListError=i;class z{constructor(){this.c=new WeakMap}getHeight(D){return this.c.get(D)??this.d(D)}setDynamicHeight(D,w){w>0&&this.c.set(D,w)}}t.CachedListVirtualDelegate=z}),define(me[69],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class v{constructor(z){this.a=z}splice(z,H,D){this.a.forEach(w=>w.splice(z,H,D))}}t.CombinedSpliceable=v}),define(me[40],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const v=20;class i{constructor(H,D,w,d,m,g){this.a=Math.round(D),this.b=Math.round(w),this.c=Math.round(H),this.d=d,this.e=m,this.f=g,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new i(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(H){const D=Math.round(H);return this.d!==D?(this.d=D,this.m(),!0):!1}setScrollSize(H){const D=Math.round(H);return this.e!==D?(this.e=D,this.m(),!0):!1}setScrollPosition(H){const D=Math.round(H);return this.f!==D?(this.f=D,this.m(),!0):!1}setScrollbarSize(H){this.a=Math.round(H)}setOppositeScrollbarSize(H){this.b=Math.round(H)}static l(H,D,w,d,m){const g=Math.max(0,w-H),I=Math.max(0,g-2*D),o=d>0&&d>w;if(!o)return{computedAvailableSize:Math.round(g),computedIsNeeded:o,computedSliderSize:Math.round(I),computedSliderRatio:0,computedSliderPosition:0};const n=Math.round(Math.max(v,Math.floor(w*I/d))),e=(I-n)/(d-w),s=m*e;return{computedAvailableSize:Math.round(g),computedIsNeeded:o,computedSliderSize:Math.round(n),computedSliderRatio:e,computedSliderPosition:Math.round(s)}}m(){const H=i.l(this.b,this.c,this.d,this.e,this.f);this.g=H.computedAvailableSize,this.h=H.computedIsNeeded,this.i=H.computedSliderSize,this.j=H.computedSliderRatio,this.k=H.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(H){if(!this.h)return 0;const D=H-this.c-this.i/2;return Math.round(D/this.j)}getDesiredScrollPositionFromOffsetPaged(H){if(!this.h)return 0;const D=H-this.c;let w=this.f;return D<this.k?w-=this.d:w+=this.d,w}getDesiredScrollPositionFromDelta(H){if(!this.h)return 0;const D=this.k+H;return Math.round(D/this.j)}}t.ScrollbarState=i}),define(me[23],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.TreeVisibility=void 0;var v;(function(w){w[w.Hidden=0]="Hidden",w[w.Visible=1]="Visible",w[w.Recurse=2]="Recurse"})(v=t.TreeVisibility||(t.TreeVisibility={}));var i;(function(w){w[w.Unknown=0]="Unknown",w[w.Twistie=1]="Twistie",w[w.Element=2]="Element",w[w.Filter=3]="Filter"})(i=t.TreeMouseEventTarget||(t.TreeMouseEventTarget={}));var z;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})(z=t.TreeDragOverBubble||(t.TreeDragOverBubble={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(w=!1){return{accept:!0,bubble:0,autoExpand:w}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(w=!1){return{accept:!0,bubble:0,effect:0,autoExpand:w}}};class H extends Error{constructor(d,m){super(`TreeError [${d}] ${m}`)}}t.TreeError=H;class D{constructor(d){this.a=d,this.b=new WeakMap}map(d){let m=this.b.get(d);return m||(m=this.a(d),this.b.set(d,m)),m}}t.WeakMapper=D}),define(me[12],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CSSIcon=t.Codicon=t.getCodiconAriaLabel=void 0;function v(H){return H?H.replace(/\$\((.*?)\)/g,(D,w)=>` ${w} `).trim():""}t.getCodiconAriaLabel=v;class i{constructor(D,w,d){this.id=D,this.definition=w,this.description=d,i.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i.a}}t.Codicon=i,i.a=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",i.circleFilled.definition),i.closeDirty=new i("close-dirty",i.circleFilled.definition),i.debugBreakpoint=new i("debug-breakpoint",i.circleFilled.definition),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",i.circleFilled.definition),i.debugHint=new i("debug-hint",i.circleFilled.definition),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circle=new i("circle",{fontCharacter:"\\eabc"}),i.circleOutline=new i("circle-outline",i.circle.definition),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",i.circle.definition),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.circleSmallFilled=new i("circle-small-filled",{fontCharacter:"\\eb8a"}),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.definition),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLarge=new i("circle-large",{fontCharacter:"\\ebb5"}),i.circleLargeOutline=new i("circle-large-outline",i.circleLarge.definition),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.heartFilled=new i("heart-filled",{fontCharacter:"\\ec04"}),i.map=new i("map",{fontCharacter:"\\ec05"}),i.mapFilled=new i("map-filled",{fontCharacter:"\\ec06"}),i.circleSmall=new i("circle-small",{fontCharacter:"\\ec07"}),i.bellSlash=new i("bell-slash",{fontCharacter:"\\ec08"}),i.bellSlashDot=new i("bell-slash-dot",{fontCharacter:"\\ec09"}),i.commentUnresolved=new i("comment-unresolved",{fontCharacter:"\\ec0a"}),i.gitPullRequestGoToChanges=new i("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),i.gitPullRequestNewChanges=new i("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),i.searchFuzzy=new i("search-fuzzy",{fontCharacter:"\\ec0d"}),i.commentDraft=new i("comment-draft",{fontCharacter:"\\ec0e"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);var z;(function(H){H.iconNameSegment="[A-Za-z0-9]+",H.iconNameExpression="[A-Za-z0-9-]+",H.iconModifierExpression="~[A-Za-z]+",H.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${H.iconNameExpression})(${H.iconModifierExpression})?$`);function w(g){if(g instanceof i)return["codicon","codicon-"+g.id];const I=D.exec(g.id);if(!I)return w(i.error);const[,o,n]=I,e=["codicon","codicon-"+o];return n&&e.push("codicon-modifier-"+n.substring(1)),e}H.asClassNameArray=w;function d(g){return w(g).join(" ")}H.asClassName=d;function m(g){return"."+w(g).join(".")}H.asCSSSelector=m})(z=t.CSSIcon||(t.CSSIcon={}))}),define(me[70],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.diffMaps=t.diffSets=t.groupBy=void 0;function v(D,w){const d=Object.create(null);for(const m of D){const g=w(m);let I=d[g];I||(I=d[g]=[]),I.push(m)}return d}t.groupBy=v;function i(D,w){const d=[],m=[];for(const g of D)w.has(g)||d.push(g);for(const g of w)D.has(g)||m.push(g);return{removed:d,added:m}}t.diffSets=i;function z(D,w){const d=[],m=[];for(const[g,I]of D)w.has(g)||d.push(I);for(const[g,I]of w)D.has(g)||m.push(I);return{removed:d,added:m}}t.diffMaps=z;class H{constructor(){this.a=new Map}add(w,d){let m=this.a.get(w);m||(m=new Set,this.a.set(w,m)),m.add(d)}delete(w,d){const m=this.a.get(w);!m||(m.delete(d),m.size===0&&this.a.delete(w))}forEach(w,d){const m=this.a.get(w);!m||m.forEach(d)}}t.SetMap=H}),define(me[41],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function v(w,d){const m=Math.pow(10,d);return Math.round(w*m)/m}class i{constructor(d,m,g,I=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,d))|0,this.g=Math.min(255,Math.max(0,m))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=v(Math.max(Math.min(1,I),0),3)}static equals(d,m){return d.r===m.r&&d.g===m.g&&d.b===m.b&&d.a===m.a}}t.RGBA=i;class z{constructor(d,m,g,I){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=v(Math.max(Math.min(1,m),0),3),this.l=v(Math.max(Math.min(1,g),0),3),this.a=v(Math.max(Math.min(1,I),0),3)}static equals(d,m){return d.h===m.h&&d.s===m.s&&d.l===m.l&&d.a===m.a}static fromRGBA(d){const m=d.r/255,g=d.g/255,I=d.b/255,o=d.a,n=Math.max(m,g,I),e=Math.min(m,g,I);let s=0,a=0;const l=(e+n)/2,h=n-e;if(h>0){switch(a=Math.min(l<=.5?h/(2*l):h/(2-2*l),1),n){case m:s=(g-I)/h+(g<I?6:0);break;case g:s=(I-m)/h+2;break;case I:s=(m-g)/h+4;break}s*=60,s=Math.round(s)}return new z(s,a,l,o)}static i(d,m,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?d+(m-d)*6*g:g<1/2?m:g<2/3?d+(m-d)*(2/3-g)*6:d}static toRGBA(d){const m=d.h/360,{s:g,l:I,a:o}=d;let n,e,s;if(g===0)n=e=s=I;else{const a=I<.5?I*(1+g):I+g-I*g,l=2*I-a;n=z.i(l,a,m+1/3),e=z.i(l,a,m),s=z.i(l,a,m-1/3)}return new i(Math.round(n*255),Math.round(e*255),Math.round(s*255),o)}}t.HSLA=z;class H{constructor(d,m,g,I){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=v(Math.max(Math.min(1,m),0),3),this.v=v(Math.max(Math.min(1,g),0),3),this.a=v(Math.max(Math.min(1,I),0),3)}static equals(d,m){return d.h===m.h&&d.s===m.s&&d.v===m.v&&d.a===m.a}static fromRGBA(d){const m=d.r/255,g=d.g/255,I=d.b/255,o=Math.max(m,g,I),n=Math.min(m,g,I),e=o-n,s=o===0?0:e/o;let a;return e===0?a=0:o===m?a=((g-I)/e%6+6)%6:o===g?a=(I-m)/e+2:a=(m-g)/e+4,new H(Math.round(a*60),s,o,d.a)}static toRGBA(d){const{h:m,s:g,v:I,a:o}=d,n=I*g,e=n*(1-Math.abs(m/60%2-1)),s=I-n;let[a,l,h]=[0,0,0];return m<60?(a=n,l=e):m<120?(a=e,l=n):m<180?(l=n,h=e):m<240?(l=e,h=n):m<300?(a=e,h=n):m<=360&&(a=n,h=e),a=Math.round((a+s)*255),l=Math.round((l+s)*255),h=Math.round((h+s)*255),new i(a,l,h,o)}}t.HSVA=H;class D{static fromHex(d){return D.Format.CSS.parseHex(d)||D.red}static equals(d,m){return!d&&!m?!0:!d||!m?!1:d.equals(m)}get hsla(){return this.i?this.i:z.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:H.fromRGBA(this.rgba)}constructor(d){if(d)if(d instanceof i)this.rgba=d;else if(d instanceof z)this.i=d,this.rgba=z.toRGBA(d);else if(d instanceof H)this.j=d,this.rgba=H.toRGBA(d);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(d){return!!d&&i.equals(this.rgba,d.rgba)&&z.equals(this.hsla,d.hsla)&&H.equals(this.hsva,d.hsva)}getRelativeLuminance(){const d=D.k(this.rgba.r),m=D.k(this.rgba.g),g=D.k(this.rgba.b),I=.2126*d+.7152*m+.0722*g;return v(I,4)}static k(d){const m=d/255;return m<=.03928?m/12.92:Math.pow((m+.055)/1.055,2.4)}getContrastRatio(d){const m=this.getRelativeLuminance(),g=d.getRelativeLuminance();return m>g?(m+.05)/(g+.05):(g+.05)/(m+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(d){const m=this.getRelativeLuminance(),g=d.getRelativeLuminance();return m>g}isDarkerThan(d){const m=this.getRelativeLuminance(),g=d.getRelativeLuminance();return m<g}lighten(d){return new D(new z(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*d,this.hsla.a))}darken(d){return new D(new z(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*d,this.hsla.a))}transparent(d){const{r:m,g,b:I,a:o}=this.rgba;return new D(new i(m,g,I,o*d))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new i(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(d){const m=d.rgba,g=this.rgba.a,I=m.a,o=g+I*(1-g);if(o<1e-6)return D.transparent;const n=this.rgba.r*g/o+m.r*I*(1-g)/o,e=this.rgba.g*g/o+m.g*I*(1-g)/o,s=this.rgba.b*g/o+m.b*I*(1-g)/o;return new D(new i(n,e,s,o))}makeOpaque(d){if(this.isOpaque()||d.rgba.a!==1)return this;const{r:m,g,b:I,a:o}=this.rgba;return new D(new i(d.rgba.r-o*(d.rgba.r-m),d.rgba.g-o*(d.rgba.g-g),d.rgba.b-o*(d.rgba.b-I),1))}flatten(...d){const m=d.reduceRight((g,I)=>D.o(I,g));return D.o(this,m)}static o(d,m){const g=1-d.rgba.a;return new D(new i(g*m.rgba.r+d.rgba.a*d.rgba.r,g*m.rgba.g+d.rgba.a*d.rgba.g,g*m.rgba.b+d.rgba.a*d.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(d,m,g){if(d.isLighterThan(m))return d;g=g||.5;const I=d.getRelativeLuminance(),o=m.getRelativeLuminance();return g=g*(o-I)/o,d.lighten(g)}static getDarkerColor(d,m,g){if(d.isDarkerThan(m))return d;g=g||.5;const I=d.getRelativeLuminance(),o=m.getRelativeLuminance();return g=g*(I-o)/I,d.darken(g)}}t.Color=D,D.white=new D(new i(255,255,255,1)),D.black=new D(new i(0,0,0,1)),D.red=new D(new i(255,0,0,1)),D.blue=new D(new i(0,0,255,1)),D.green=new D(new i(0,255,0,1)),D.cyan=new D(new i(0,255,255,1)),D.lightgrey=new D(new i(211,211,211,1)),D.transparent=new D(new i(0,0,0,0)),function(w){let d;(function(m){let g;(function(I){function o(S){return S.rgba.a===1?`rgb(${S.rgba.r}, ${S.rgba.g}, ${S.rgba.b})`:w.Format.CSS.formatRGBA(S)}I.formatRGB=o;function n(S){return`rgba(${S.rgba.r}, ${S.rgba.g}, ${S.rgba.b}, ${+S.rgba.a.toFixed(2)})`}I.formatRGBA=n;function e(S){return S.hsla.a===1?`hsl(${S.hsla.h}, ${(S.hsla.s*100).toFixed(2)}%, ${(S.hsla.l*100).toFixed(2)}%)`:w.Format.CSS.formatHSLA(S)}I.formatHSL=e;function s(S){return`hsla(${S.hsla.h}, ${(S.hsla.s*100).toFixed(2)}%, ${(S.hsla.l*100).toFixed(2)}%, ${S.hsla.a.toFixed(2)})`}I.formatHSLA=s;function a(S){const N=S.toString(16);return N.length!==2?"0"+N:N}function l(S){return`#${a(S.rgba.r)}${a(S.rgba.g)}${a(S.rgba.b)}`}I.formatHex=l;function h(S,N=!1){return N&&S.rgba.a===1?w.Format.CSS.formatHex(S):`#${a(S.rgba.r)}${a(S.rgba.g)}${a(S.rgba.b)}${a(Math.round(S.rgba.a*255))}`}I.formatHexA=h;function r(S){return S.isOpaque()?w.Format.CSS.formatHex(S):w.Format.CSS.formatRGBA(S)}I.format=r;function c(S){const N=S.length;if(N===0||S.charCodeAt(0)!==35)return null;if(N===7){const L=16*b(S.charCodeAt(1))+b(S.charCodeAt(2)),T=16*b(S.charCodeAt(3))+b(S.charCodeAt(4)),f=16*b(S.charCodeAt(5))+b(S.charCodeAt(6));return new w(new i(L,T,f,1))}if(N===9){const L=16*b(S.charCodeAt(1))+b(S.charCodeAt(2)),T=16*b(S.charCodeAt(3))+b(S.charCodeAt(4)),f=16*b(S.charCodeAt(5))+b(S.charCodeAt(6)),C=16*b(S.charCodeAt(7))+b(S.charCodeAt(8));return new w(new i(L,T,f,C/255))}if(N===4){const L=b(S.charCodeAt(1)),T=b(S.charCodeAt(2)),f=b(S.charCodeAt(3));return new w(new i(16*L+L,16*T+T,16*f+f))}if(N===5){const L=b(S.charCodeAt(1)),T=b(S.charCodeAt(2)),f=b(S.charCodeAt(3)),C=b(S.charCodeAt(4));return new w(new i(16*L+L,16*T+T,16*f+f,(16*C+C)/255))}return null}I.parseHex=c;function b(S){switch(S){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=m.CSS||(m.CSS={}))})(d=w.Format||(w.Format={}))}(D=t.Color||(t.Color={}))}),define(me[24],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=void 0;function v(D){return(w,d,m)=>{let g=null,I=null;if(typeof m.value=="function"?(g="value",I=m.value):typeof m.get=="function"&&(g="get",I=m.get),!I)throw new Error("not supported");m[g]=D(I,d)}}function i(D,w,d){let m=null,g=null;if(typeof d.value=="function"?(m="value",g=d.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(m="get",g=d.get),!g)throw new Error("not supported");const I=`$memoize$${w}`;d[m]=function(...o){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:g.apply(this,o)}),this[I]}}t.memoize=i;function z(D,w,d){return v((m,g)=>{const I=`$debounce$${g}`,o=`$debounce$result$${g}`;return function(...n){this[o]||(this[o]=d?d():void 0),clearTimeout(this[I]),w&&(this[o]=w(this[o],...n),n=[this[o]]),this[I]=setTimeout(()=>{m.apply(this,n),this[o]=d?d():void 0},D)}})}t.debounce=z;function H(D,w,d){return v((m,g)=>{const I=`$throttle$timer$${g}`,o=`$throttle$result$${g}`,n=`$throttle$lastRun$${g}`,e=`$throttle$pending$${g}`;return function(...s){if(this[o]||(this[o]=d?d():void 0),(this[n]===null||this[n]===void 0)&&(this[n]=-Number.MAX_VALUE),w&&(this[o]=w(this[o],...s)),this[e])return;const a=this[n]+D;a<=Date.now()?(this[n]=Date.now(),m.apply(this,[this[o]]),this[o]=d?d():void 0):(this[e]=!0,this[I]=setTimeout(()=>{this[e]=!1,this[n]=Date.now(),m.apply(this,[this[o]]),this[o]=d?d():void 0},a-Date.now()))}})}t.throttle=H}),define(me[71],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class v{constructor(z,H,D,w){this.originalStart=z,this.originalLength=H,this.modifiedStart=D,this.modifiedLength=w}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=v}),define(me[9],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class v{constructor(){this.b=[],this.a=function(S){setTimeout(()=>{throw S.stack?r.isErrorNoTelemetry(S)?new r(S.message+`

`+S.stack):new Error(S.message+`

`+S.stack):S},0)}}addListener(S){return this.b.push(S),()=>{this.d(S)}}c(S){this.b.forEach(N=>{N(S)})}d(S){this.b.splice(this.b.indexOf(S),1)}setUnexpectedErrorHandler(S){this.a=S}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(S){this.a(S),this.c(S)}onUnexpectedExternalError(S){this.a(S)}}t.ErrorHandler=v,t.errorHandler=new v;function i(b){t.errorHandler.setUnexpectedErrorHandler(b)}t.setUnexpectedErrorHandler=i;function z(b){d(b)||t.errorHandler.onUnexpectedError(b)}t.onUnexpectedError=z;function H(b){d(b)||t.errorHandler.onUnexpectedExternalError(b)}t.onUnexpectedExternalError=H;function D(b){if(b instanceof Error){const{name:S,message:N}=b,L=b.stacktrace||b.stack;return{$isError:!0,name:S,message:N,stack:L,noTelemetry:r.isErrorNoTelemetry(b)}}return b}t.transformErrorForSerialization=D;const w="Canceled";function d(b){return b instanceof m?!0:b instanceof Error&&b.name===w&&b.message===w}t.isCancellationError=d;class m extends Error{constructor(){super(w),this.name=this.message}}t.CancellationError=m;function g(){const b=new Error(w);return b.name=b.message,b}t.canceled=g;function I(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}t.illegalArgument=I;function o(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}t.illegalState=o;function n(b){return b?new Error(`readonly property '${b} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=n;function e(b){const S=new Error(`${b} has been disposed`);return S.name="DISPOSED",S}t.disposed=e;function s(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}t.getErrorMessage=s;class a extends Error{constructor(S){super("NotImplemented"),S&&(this.message=S)}}t.NotImplementedError=a;class l extends Error{constructor(S){super("NotSupported"),S&&(this.message=S)}}t.NotSupportedError=l;class h extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=h;class r extends Error{constructor(S){super(S),this.name="CodeExpectedError"}static fromError(S){if(S instanceof r)return S;const N=new r;return N.message=S.message,N.stack=S.stack,N}static isErrorNoTelemetry(S){return S.name==="CodeExpectedError"}}t.ErrorNoTelemetry=r;class c extends Error{constructor(S){super(S||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype);debugger}}t.BugIndicatingError=c}),define(me[14],be([1,0,9]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function i(F,O=0){return F[F.length-(1+O)]}t.tail=i;function z(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}t.tail2=z;function H(F,O,U=(k,M)=>k===M){if(F===O)return!0;if(!F||!O||F.length!==O.length)return!1;for(let k=0,M=F.length;k<M;k++)if(!U(F[k],O[k]))return!1;return!0}t.equals=H;function D(F,O){const U=F.length-1;O<U&&(F[O]=F[U]),F.pop()}t.removeFastWithoutKeepingOrder=D;function w(F,O,U){return d(F.length,k=>U(F[k],O))}t.binarySearch=w;function d(F,O){let U=0,k=F-1;for(;U<=k;){const M=(U+k)/2|0,P=O(M);if(P<0)U=M+1;else if(P>0)k=M-1;else return M}return-(U+1)}t.binarySearch2=d;function m(F,O){let U=0,k=F.length;if(k===0)return 0;for(;U<k;){const M=Math.floor((U+k)/2);O(F[M])?k=M:U=M+1}return U}t.findFirstInSorted=m;function g(F,O,U){if(F=F|0,F>=O.length)throw new TypeError("invalid index");const k=O[Math.floor(O.length*Math.random())],M=[],P=[],R=[];for(const j of O){const J=U(j,k);J<0?M.push(j):J>0?P.push(j):R.push(j)}return F<M.length?g(F,M,U):F<M.length+R.length?R[0]:g(F-(M.length+R.length),P,U)}t.quickSelect=g;function I(F,O){const U=[];let k;for(const M of F.slice(0).sort(O))!k||O(k[0],M)!==0?(k=[M],U.push(k)):k.push(M);return U}t.groupBy=I;function o(F,O,U){const k=[];function M(j,J,he){if(J===0&&he.length===0)return;const ce=k[k.length-1];ce&&ce.start+ce.deleteCount===j?(ce.deleteCount+=J,ce.toInsert.push(...he)):k.push({start:j,deleteCount:J,toInsert:he})}let P=0,R=0;for(;;){if(P===F.length){M(P,0,O.slice(R));break}if(R===O.length){M(P,F.length-P,[]);break}const j=F[P],J=O[R],he=U(j,J);he===0?(P+=1,R+=1):he<0?(M(P,1,[]),P+=1):he>0&&(M(P,0,[J]),R+=1)}return k}t.sortedDiff=o;function n(F,O,U){const k=o(F,O,U),M=[],P=[];for(const R of k)M.push(...F.slice(R.start,R.start+R.deleteCount)),P.push(...R.toInsert);return{removed:M,added:P}}t.delta=n;function e(F,O,U){if(U===0)return[];const k=F.slice(0,U).sort(O);return a(F,O,k,U,F.length),k}t.top=e;function s(F,O,U,k,M){return U===0?Promise.resolve([]):new Promise((P,R)=>{(async()=>{const j=F.length,J=F.slice(0,U).sort(O);for(let he=U,ce=Math.min(U+k,j);he<j;he=ce,ce=Math.min(ce+k,j)){if(he>U&&await new Promise(De=>setTimeout(De)),M&&M.isCancellationRequested)throw new v.CancellationError;a(F,O,J,he,ce)}return J})().then(P,R)})}t.topAsync=s;function a(F,O,U,k,M){for(const P=U.length;k<M;k++){const R=F[k];if(O(R,U[P-1])<0){U.pop();const j=m(U,J=>O(R,J)<0);U.splice(j,0,R)}}}function l(F){return F.filter(O=>!!O)}t.coalesce=l;function h(F){let O=0;for(let U=0;U<F.length;U++)F[U]&&(F[O]=F[U],O+=1);F.length=O}t.coalesceInPlace=h;function r(F,O,U){F.splice(U,0,F.splice(O,1)[0])}t.move=r;function c(F){return!Array.isArray(F)||F.length===0}t.isFalsyOrEmpty=c;function b(F){return Array.isArray(F)&&F.length>0}t.isNonEmptyArray=b;function S(F,O=U=>U){const U=new Set;return F.filter(k=>{const M=O(k);return U.has(M)?!1:(U.add(M),!0)})}t.distinct=S;function N(F){const O=new Set;return U=>{const k=F(U);return O.has(k)?!1:(O.add(k),!0)}}t.uniqueFilter=N;function L(F,O){const U=T(F,O);if(U!==-1)return F[U]}t.findLast=L;function T(F,O){for(let U=F.length-1;U>=0;U--){const k=F[U];if(O(k))return U}return-1}t.lastIndex=T;function f(F,O){return F.length>0?F[0]:O}t.firstOrDefault=f;function C(F,O){return F.length>0?F[F.length-1]:O}t.lastOrDefault=C;function p(F,O,U=(k,M)=>k===M){let k=0;for(let M=0,P=Math.min(F.length,O.length);M<P&&U(F[M],O[M]);M++)k++;return k}t.commonPrefixLength=p;function y(F){return[].concat(...F)}t.flatten=y;function _(F,O){let U=typeof O=="number"?F:0;typeof O=="number"?U=F:(U=0,O=F);const k=[];if(U<=O)for(let M=U;M<O;M++)k.push(M);else for(let M=U;M>O;M--)k.push(M);return k}t.range=_;function V(F,O,U){return F.reduce((k,M)=>(k[O(M)]=U?U(M):M,k),Object.create(null))}t.index=V;function ge(F,O){return F.push(O),()=>Q(F,O)}t.insert=ge;function Q(F,O){const U=F.indexOf(O);if(U>-1)return F.splice(U,1),O}t.remove=Q;function ie(F,O,U){const k=F.slice(0,O),M=F.slice(O);return k.concat(U,M)}t.arrayInsert=ie;function te(F,O){let U;if(typeof O=="number"){let k=O;U=()=>{const M=Math.sin(k++)*179426549;return M-Math.floor(M)}}else U=Math.random;for(let k=F.length-1;k>0;k-=1){const M=Math.floor(U()*(k+1)),P=F[k];F[k]=F[M],F[M]=P}}t.shuffle=te;function ue(F,O){const U=F.indexOf(O);U>-1&&(F.splice(U,1),F.unshift(O))}t.pushToStart=ue;function ae(F,O){const U=F.indexOf(O);U>-1&&(F.splice(U,1),F.push(O))}t.pushToEnd=ae;function de(F,O){for(const U of O)F.push(U)}t.pushMany=de;function Ae(F,O){return Array.isArray(F)?F.map(O):O(F)}t.mapArrayOrNot=Ae;function x(F){return Array.isArray(F)?F:[F]}t.asArray=x;function ve(F){return F[Math.floor(Math.random()*F.length)]}t.getRandomElement=ve;function Ne(F,O){for(const U of F){const k=O(U);if(k!==void 0)return k}}t.mapFind=Ne;function oe(F,O,U){const k=se(F,O),M=F.length,P=U.length;F.length=M+P;for(let R=M-1;R>=k;R--)F[R+P]=F[R];for(let R=0;R<P;R++)F[R+k]=U[R]}t.insertInto=oe;function X(F,O,U,k){const M=se(F,O),P=F.splice(M,U);return oe(F,M,k),P}t.splice=X;function se(F,O){return O<0?Math.max(O+F.length,0):Math.min(O,F.length)}var ne;(function(F){function O(M){return M<0}F.isLessThan=O;function U(M){return M>0}F.isGreaterThan=U;function k(M){return M===0}F.isNeitherLessOrGreaterThan=k,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(ne=t.CompareResult||(t.CompareResult={}));function ee(F,O){return(U,k)=>O(F(U),F(k))}t.compareBy=ee;function A(...F){return(O,U)=>{for(const k of F){const M=k(O,U);if(!ne.isNeitherLessOrGreaterThan(M))return M}return ne.neitherLessOrGreaterThan}}t.tieBreakComparators=A;const E=(F,O)=>F-O;t.numberComparator=E;function u(F,O){if(F.length===0)return;let U=F[0];for(let k=1;k<F.length;k++){const M=F[k];O(M,U)>0&&(U=M)}return U}t.findMaxBy=u;function B(F,O){if(F.length===0)return;let U=F[0];for(let k=1;k<F.length;k++){const M=F[k];O(M,U)>=0&&(U=M)}return U}t.findLastMaxBy=B;function W(F,O){return u(F,(U,k)=>-O(U,k))}t.findMinBy=W;class ${constructor(O){this.f=O,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(O){let U=this.c;for(;U<this.f.length&&O(this.f[U]);)U++;const k=U===this.c?null:this.f.slice(this.c,U);return this.c=U,k}takeFromEndWhile(O){let U=this.d;for(;U>=0&&O(this.f[U]);)U--;const k=U===this.d?null:this.f.slice(U+1,this.d+1);return this.d=U,k}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const O=this.f[this.c];return this.c++,O}removeLast(){const O=this.f[this.d];return this.d--,O}takeCount(O){const U=this.f.slice(this.c,this.c+O);return this.c+=O,U}}t.ArrayQueue=$;class Y{constructor(O){this.iterate=O}forEach(O){this.iterate(U=>(O(U),!0))}toArray(){const O=[];return this.iterate(U=>(O.push(U),!0)),O}filter(O){return new Y(U=>this.iterate(k=>O(k)?U(k):!0))}map(O){return new Y(U=>this.iterate(k=>U(O(k))))}some(O){let U=!1;return this.iterate(k=>(U=O(k),!U)),U}findFirst(O){let U;return this.iterate(k=>O(k)?(U=k,!1):!0),U}findLast(O){let U;return this.iterate(k=>(O(k)&&(U=k),!0)),U}findLastMaxBy(O){let U,k=!0;return this.iterate(M=>((k||ne.isGreaterThan(O(M,U)))&&(k=!1,U=M),!0)),U}}t.CallbackIterable=Y,Y.empty=new Y(F=>{})}),define(me[72],be([1,0,9]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function i(d,m){if(!d)throw new Error(m?`Assertion failed (${m})`:"Assertion Failed")}t.ok=i;function z(d,m="Unreachable"){throw new Error(m)}t.assertNever=z;function H(d){if(!d)throw new v.BugIndicatingError("Assertion Failed")}t.assert=H;function D(d){if(!d()){debugger;d(),(0,v.onUnexpectedError)(new v.BugIndicatingError("Assertion Failed"))}}t.assertFn=D;function w(d,m){let g=0;for(;g<d.length-1;){const I=d[g],o=d[g+1];if(!m(I,o))return!1;g++}return!0}t.checkAdjacentItems=w}),define(me[42],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function v(i){const z=this;let H=!1,D;return function(){return H||(H=!0,D=i.apply(z,arguments)),D}}t.once=v}),define(me[73],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class v{constructor(z){this.a=z,this.b=0}nextId(){return this.a+ ++this.b}}t.IdGenerator=v,t.defaultGenerator=new v("id#")}),define(me[25],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var v;(function(i){function z(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}i.is=z;const H=Object.freeze([]);function D(){return H}i.empty=D;function*w(c){yield c}i.single=w;function d(c){return z(c)?c:w(c)}i.wrap=d;function m(c){return c||H}i.from=m;function g(c){return!c||c[Symbol.iterator]().next().done===!0}i.isEmpty=g;function I(c){return c[Symbol.iterator]().next().value}i.first=I;function o(c,b){for(const S of c)if(b(S))return!0;return!1}i.some=o;function n(c,b){for(const S of c)if(b(S))return S}i.find=n;function*e(c,b){for(const S of c)b(S)&&(yield S)}i.filter=e;function*s(c,b){let S=0;for(const N of c)yield b(N,S++)}i.map=s;function*a(...c){for(const b of c)for(const S of b)yield S}i.concat=a;function l(c,b,S){let N=S;for(const L of c)N=b(N,L);return N}i.reduce=l;function*h(c,b,S=c.length){for(b<0&&(b+=c.length),S<0?S+=c.length:S>c.length&&(S=c.length);b<S;b++)yield c[b]}i.slice=h;function r(c,b=Number.POSITIVE_INFINITY){const S=[];if(b===0)return[S,c];const N=c[Symbol.iterator]();for(let L=0;L<b;L++){const T=N.next();if(T.done)return[S,i.empty()];S.push(T.value)}return[S,{[Symbol.iterator](){return N}}]}i.consume=r})(v=t.Iterable||(t.Iterable={}))}),define(me[43],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var v;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(v=t.KeyCode||(t.KeyCode={}));var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(i=t.ScanCode||(t.ScanCode={}));class z{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,a){this._keyCodeToStr[s]=a,this._strToKeyCode[a.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||0}}const H=new z,D=new z,w=new z;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const d=[],m=Object.create(null),g=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>g[e]||0,toEnum:e=>m[e]||0,toString:e=>d[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",s=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],a=[],l=[];for(const h of s){const[r,c,b,S,N,L,T,f,C,p]=h;if(l[b]||(l[b]=!0,d[b]=S,m[S]=b,g[S.toLowerCase()]=b,c&&(t.IMMUTABLE_CODE_TO_KEY_CODE[b]=N,N!==0&&N!==3&&N!==5&&N!==4&&N!==6&&N!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[N]=b))),!a[N]){if(a[N]=!0,!L)throw new Error(`String representation missing for key code ${N} around scan code ${S}`);H.define(N,L),D.define(N,C||L),w.define(N,p||C||L)}T&&(t.EVENT_KEY_CODE_MAP[T]=N),f&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[f]=N)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var I;(function(e){function s(b){return H.keyCodeToStr(b)}e.toString=s;function a(b){return H.strToKeyCode(b)}e.fromString=a;function l(b){return D.keyCodeToStr(b)}e.toUserSettingsUS=l;function h(b){return w.keyCodeToStr(b)}e.toUserSettingsGeneral=h;function r(b){return D.strToKeyCode(b)||w.strToKeyCode(b)}e.fromUserSettings=r;function c(b){if(b>=93&&b<=108)return null;switch(b){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return H.keyCodeToStr(b)}e.toElectronAccelerator=c})(I=t.KeyCodeUtils||(t.KeyCodeUtils={}));var o;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(o=t.KeyMod||(t.KeyMod={}));function n(e,s){const a=(s&65535)<<16>>>0;return(e|a)>>>0}t.KeyChord=n}),define(me[74],be([1,0,9]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ScanCodeBinding=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=void 0;var i;(function(I){I[I.CtrlCmd=2048]="CtrlCmd",I[I.Shift=1024]="Shift",I[I.Alt=512]="Alt",I[I.WinCtrl=256]="WinCtrl",I[I.KeyCode=255]="KeyCode"})(i||(i={}));function z(I,o){if(I===0)return null;const n=(I&65535)>>>0,e=(I&4294901760)>>>16;return e!==0?new w([H(n,o),H(e,o)]):new w([H(n,o)])}t.createKeybinding=z;function H(I,o){const n=!!(I&2048),e=!!(I&256),s=o===2?e:n,a=!!(I&1024),l=!!(I&512),h=o===2?n:e,r=I&255;return new D(s,a,l,h,r)}t.createSimpleKeybinding=H;class D{constructor(o,n,e,s,a){this.ctrlKey=o,this.shiftKey=n,this.altKey=e,this.metaKey=s,this.keyCode=a}equals(o){return this.ctrlKey===o.ctrlKey&&this.shiftKey===o.shiftKey&&this.altKey===o.altKey&&this.metaKey===o.metaKey&&this.keyCode===o.keyCode}getHashCode(){const o=this.ctrlKey?"1":"0",n=this.shiftKey?"1":"0",e=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`${o}${n}${e}${s}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new w([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.SimpleKeybinding=D;class w{constructor(o){if(o.length===0)throw(0,v.illegalArgument)("parts");this.parts=o}getHashCode(){let o="";for(let n=0,e=this.parts.length;n<e;n++)n!==0&&(o+=";"),o+=this.parts[n].getHashCode();return o}equals(o){if(o===null||this.parts.length!==o.parts.length)return!1;for(let n=0;n<this.parts.length;n++)if(!this.parts[n].equals(o.parts[n]))return!1;return!0}}t.ChordKeybinding=w;class d{constructor(o,n,e,s,a){this.ctrlKey=o,this.shiftKey=n,this.altKey=e,this.metaKey=s,this.scanCode=a}equals(o){return this.ctrlKey===o.ctrlKey&&this.shiftKey===o.shiftKey&&this.altKey===o.altKey&&this.metaKey===o.metaKey&&this.scanCode===o.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.ScanCodeBinding=d;class m{constructor(o,n,e,s,a,l){this.ctrlKey=o,this.shiftKey=n,this.altKey=e,this.metaKey=s,this.keyLabel=a,this.keyAriaLabel=l}}t.ResolvedKeybindingPart=m;class g{}t.ResolvedKeybinding=g}),define(me[44],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class v{constructor(z){this.d=z,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(z){this.c=z}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(z){return new v(()=>z(this.getValue()))}}t.Lazy=v}),define(me[2],be([1,0,42,25]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const z=!1;let H=null;function D(C){H=C}if(t.setDisposableTracker=D,z){const C="__is_disposable_tracked__";D(new class{trackDisposable(p){const y=new Error("Potentially leaked disposable").stack;setTimeout(()=>{p[C]||console.log(y)},3e3)}setParent(p,y){if(p&&p!==h.None)try{p[C]=!0}catch{}}markAsDisposed(p){if(p&&p!==h.None)try{p[C]=!0}catch{}}markAsSingleton(p){}})}function w(C){return H?.trackDisposable(C),C}function d(C){H?.markAsDisposed(C)}function m(C,p){H?.setParent(C,p)}function g(C,p){if(!!H)for(const y of C)H.setParent(y,p)}function I(C){return H?.markAsSingleton(C),C}t.markAsSingleton=I;function o(C){return typeof C.dispose=="function"&&C.dispose.length===0}t.isDisposable=o;function n(C){if(i.Iterable.is(C)){const p=[];for(const y of C)if(y)try{y.dispose()}catch(_){p.push(_)}if(p.length===1)throw p[0];if(p.length>1)throw new AggregateError(p,"Encountered errors while disposing of store");return Array.isArray(C)?[]:C}else if(C)return C.dispose(),C}t.dispose=n;function e(C){for(const p of C)o(p)&&p.dispose();return[]}t.disposeIfDisposable=e;function s(...C){const p=a(()=>n(C));return g(C,p),p}t.combinedDisposable=s;function a(C){const p=w({dispose:(0,v.once)(()=>{d(p),C()})});return p}t.toDisposable=a;class l{constructor(){this.c=new Set,this.f=!1,w(this)}dispose(){this.f||(d(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{n(this.c)}finally{this.c.clear()}}add(p){if(!p)return p;if(p===this)throw new Error("Cannot register a disposable on itself!");return m(p,this),this.f?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(p),p}}t.DisposableStore=l,l.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){this.q=new l,w(this),m(this.q,this)}dispose(){d(this),this.q.dispose()}B(p){if(p===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(p)}}t.Disposable=h,h.None=Object.freeze({dispose(){}});class r{constructor(){this.b=!1,w(this)}get value(){return this.b?void 0:this.a}set value(p){this.b||p===this.a||(this.a?.dispose(),p&&m(p,this),this.a=p)}clear(){this.value=void 0}dispose(){this.b=!0,d(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const p=this.a;return this.a=void 0,p&&m(p,null),p}}t.MutableDisposable=r;class c{constructor(p){this.b=p,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.RefCountedDisposable=c;class b{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(p){let y=p;return this.unset=()=>y=void 0,this.isset=()=>y!==void 0,this.dispose=()=>{y&&(y(),y=void 0,d(this))},this}}t.SafeDisposable=b;class S{constructor(){this.a=new Map}acquire(p,...y){let _=this.a.get(p);_||(_={counter:0,object:this.b(p,...y)},this.a.set(p,_));const{object:V}=_,ge=(0,v.once)(()=>{--_.counter===0&&(this.c(p,_.object),this.a.delete(p))});return _.counter++,{object:V,dispose:ge}}}t.ReferenceCollection=S;class N{constructor(p){this.a=p}async acquire(p,...y){const _=this.a.acquire(p,...y);try{return{object:await _.object,dispose:()=>_.dispose()}}catch(V){throw _.dispose(),V}}}t.AsyncReferenceCollection=N;class L{constructor(p){this.object=p}dispose(){}}t.ImmortalReference=L;function T(C){const p=new l;try{C(p)}finally{p.dispose()}}t.disposeOnReturn=T;class f{constructor(){this.a=new Map,this.b=!1,w(this)}dispose(){d(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{n(this.a.values())}finally{this.a.clear()}}has(p){return this.a.has(p)}get(p){return this.a.get(p)}set(p,y,_=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),_||this.a.get(p)?.dispose(),this.a.set(p,y)}deleteAndDispose(p){this.a.get(p)?.dispose(),this.a.delete(p)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.DisposableMap=f}),define(me[45],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class v{constructor(H){this.element=H,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class i{constructor(){this.a=v.Undefined,this.b=v.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===v.Undefined}clear(){let H=this.a;for(;H!==v.Undefined;){const D=H.next;H.prev=v.Undefined,H.next=v.Undefined,H=D}this.a=v.Undefined,this.b=v.Undefined,this.c=0}unshift(H){return this.d(H,!1)}push(H){return this.d(H,!0)}d(H,D){const w=new v(H);if(this.a===v.Undefined)this.a=w,this.b=w;else if(D){const m=this.b;this.b=w,w.prev=m,m.next=w}else{const m=this.a;this.a=w,w.next=m,m.prev=w}this.c+=1;let d=!1;return()=>{d||(d=!0,this.e(w))}}shift(){if(this.a!==v.Undefined){const H=this.a.element;return this.e(this.a),H}}pop(){if(this.b!==v.Undefined){const H=this.b.element;return this.e(this.b),H}}e(H){if(H.prev!==v.Undefined&&H.next!==v.Undefined){const D=H.prev;D.next=H.next,H.next.prev=D}else H.prev===v.Undefined&&H.next===v.Undefined?(this.a=v.Undefined,this.b=v.Undefined):H.next===v.Undefined?(this.b=this.b.prev,this.b.next=v.Undefined):H.prev===v.Undefined&&(this.a=this.a.next,this.a.prev=v.Undefined);this.c-=1}*[Symbol.iterator](){let H=this.a;for(;H!==v.Undefined;)yield H.element,H=H.next}}t.LinkedList=i}),define(me[75],be([1,0]),function(Z,t){"use strict";var v,i,z;Object.defineProperty(t,"__esModule",{value:!0}),t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.setToString=t.mapToString=t.getOrSet=void 0;function H(e,s,a){let l=e.get(s);return l===void 0&&(l=a,e.set(s,l)),l}t.getOrSet=H;function D(e){const s=[];return e.forEach((a,l)=>{s.push(`${l} => ${a}`)}),`Map(${e.size}) {${s.join(", ")}}`}t.mapToString=D;function w(e){const s=[];return e.forEach(a=>{s.push(a)}),`Set(${e.size}) {${s.join(", ")}}`}t.setToString=w;class d{constructor(s,a){this.uri=s,this.value=a}}class m{constructor(s,a){this[v]="ResourceMap",s instanceof m?(this.b=new Map(s.b),this.c=a??m.a):(this.b=new Map,this.c=s??m.a)}set(s,a){return this.b.set(this.c(s),new d(s,a)),this}get(s){return this.b.get(this.c(s))?.value}has(s){return this.b.has(this.c(s))}get size(){return this.b.size}clear(){this.b.clear()}delete(s){return this.b.delete(this.c(s))}forEach(s,a){typeof a<"u"&&(s=s.bind(a));for(const[l,h]of this.b)s(h.value,h.uri,this)}*values(){for(const s of this.b.values())yield s.value}*keys(){for(const s of this.b.values())yield s.uri}*entries(){for(const s of this.b.values())yield[s.uri,s.value]}*[(v=Symbol.toStringTag,Symbol.iterator)](){for(const[,s]of this.b)yield[s.uri,s.value]}}t.ResourceMap=m,m.a=e=>e.toString();class g{constructor(s,a){this[i]="ResourceSet",!s||typeof s=="function"?this.a=new m(s):(this.a=new m(a),s.forEach(this.add,this))}get size(){return this.a.size}add(s){return this.a.set(s,s),this}clear(){this.a.clear()}delete(s){return this.a.delete(s)}forEach(s,a){this.a.forEach((l,h)=>s.call(a,h,h,this))}has(s){return this.a.has(s)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=g;var I;(function(e){e[e.None=0]="None",e[e.AsOld=1]="AsOld",e[e.AsNew=2]="AsNew"})(I=t.Touch||(t.Touch={}));class o{constructor(){this[z]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(s){return this.a.has(s)}get(s,a=0){const l=this.a.get(s);if(!!l)return a!==0&&this.j(l,a),l.value}set(s,a,l=0){let h=this.a.get(s);if(h)h.value=a,l!==0&&this.j(h,l);else{switch(h={key:s,value:a,next:void 0,previous:void 0},l){case 0:this.h(h);break;case 1:this.g(h);break;case 2:this.h(h);break;default:this.h(h);break}this.a.set(s,h),this.d++}return this}delete(s){return!!this.remove(s)}remove(s){const a=this.a.get(s);if(!!a)return this.a.delete(s),this.i(a),this.d--,a.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const s=this.b;return this.a.delete(s.key),this.i(s),this.d--,s.value}forEach(s,a){const l=this.e;let h=this.b;for(;h;){if(a?s.bind(a)(h.value,h.key,this):s(h.value,h.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const s=this,a=this.e;let l=this.b;const h={[Symbol.iterator](){return h},next(){if(s.e!==a)throw new Error("LinkedMap got modified during iteration.");if(l){const r={value:l.key,done:!1};return l=l.next,r}else return{value:void 0,done:!0}}};return h}values(){const s=this,a=this.e;let l=this.b;const h={[Symbol.iterator](){return h},next(){if(s.e!==a)throw new Error("LinkedMap got modified during iteration.");if(l){const r={value:l.value,done:!1};return l=l.next,r}else return{value:void 0,done:!0}}};return h}entries(){const s=this,a=this.e;let l=this.b;const h={[Symbol.iterator](){return h},next(){if(s.e!==a)throw new Error("LinkedMap got modified during iteration.");if(l){const r={value:[l.key,l.value],done:!1};return l=l.next,r}else return{value:void 0,done:!0}}};return h}[(z=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(s){if(s>=this.size)return;if(s===0){this.clear();return}let a=this.b,l=this.size;for(;a&&l>s;)this.a.delete(a.key),a=a.next,l--;this.b=a,this.d=l,a&&(a.previous=void 0),this.e++}g(s){if(!this.b&&!this.c)this.c=s;else if(this.b)s.next=this.b,this.b.previous=s;else throw new Error("Invalid list");this.b=s,this.e++}h(s){if(!this.b&&!this.c)this.b=s;else if(this.c)s.previous=this.c,this.c.next=s;else throw new Error("Invalid list");this.c=s,this.e++}i(s){if(s===this.b&&s===this.c)this.b=void 0,this.c=void 0;else if(s===this.b){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this.b=s.next}else if(s===this.c){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this.c=s.previous}else{const a=s.next,l=s.previous;if(!a||!l)throw new Error("Invalid list");a.previous=l,l.next=a}s.next=void 0,s.previous=void 0,this.e++}j(s,a){if(!this.b||!this.c)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(s===this.b)return;const l=s.next,h=s.previous;s===this.c?(h.next=void 0,this.c=h):(l.previous=h,h.next=l),s.previous=void 0,s.next=this.b,this.b.previous=s,this.b=s,this.e++}else if(a===2){if(s===this.c)return;const l=s.next,h=s.previous;s===this.b?(l.previous=void 0,this.b=l):(l.previous=h,h.next=l),s.next=void 0,s.previous=this.c,this.c.next=s,this.c=s,this.e++}}}toJSON(){const s=[];return this.forEach((a,l)=>{s.push([l,a])}),s}fromJSON(s){this.clear();for(const[a,l]of s)this.set(a,l)}}t.LinkedMap=o;class n extends o{constructor(s,a=1){super(),this.k=s,this.l=Math.min(Math.max(0,a),1)}get limit(){return this.k}set limit(s){this.k=s,this.m()}get ratio(){return this.l}set ratio(s){this.l=Math.min(Math.max(0,s),1),this.m()}get(s,a=2){return super.get(s,a)}peek(s){return super.get(s,0)}set(s,a){return super.set(s,a,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.LRUCache=n}),function(Z,t){typeof exports=="object"&&typeof module<"u"?t(exports):typeof define=="function"&&define.amd?define(me[76],be([0]),t):(Z=typeof globalThis<"u"?globalThis:Z||self,t(Z.marked={}))}(this,function(Z){"use strict";function t(F,O){for(var U=0;U<O.length;U++){var k=O[U];k.enumerable=k.enumerable||!1,k.configurable=!0,"value"in k&&(k.writable=!0),Object.defineProperty(F,k.key,k)}}function v(F,O,U){return O&&t(F.prototype,O),U&&t(F,U),Object.defineProperty(F,"prototype",{writable:!1}),F}function i(F,O){if(!!F){if(typeof F=="string")return z(F,O);var U=Object.prototype.toString.call(F).slice(8,-1);if(U==="Object"&&F.constructor&&(U=F.constructor.name),U==="Map"||U==="Set")return Array.from(F);if(U==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(U))return z(F,O)}}function z(F,O){(O==null||O>F.length)&&(O=F.length);for(var U=0,k=new Array(O);U<O;U++)k[U]=F[U];return k}function H(F,O){var U=typeof Symbol<"u"&&F[Symbol.iterator]||F["@@iterator"];if(U)return(U=U.call(F)).next.bind(U);if(Array.isArray(F)||(U=i(F))||O&&F&&typeof F.length=="number"){U&&(F=U);var k=0;return function(){return k>=F.length?{done:!0}:{done:!1,value:F[k++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Z.defaults=D();function w(F){Z.defaults=F}var d=/[&<>"']/,m=/[&<>"']/g,g=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,o={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},n=function(O){return o[O]};function e(F,O){if(O){if(d.test(F))return F.replace(m,n)}else if(g.test(F))return F.replace(I,n);return F}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(F){return F.replace(s,function(O,U){return U=U.toLowerCase(),U==="colon"?":":U.charAt(0)==="#"?U.charAt(1)==="x"?String.fromCharCode(parseInt(U.substring(2),16)):String.fromCharCode(+U.substring(1)):""})}var l=/(^|[^\[])\^/g;function h(F,O){F=typeof F=="string"?F:F.source,O=O||"";var U={replace:function(M,P){return P=P.source||P,P=P.replace(l,"$1"),F=F.replace(M,P),U},getRegex:function(){return new RegExp(F,O)}};return U}var r=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(F,O,U){if(F){var k;try{k=decodeURIComponent(a(U)).replace(r,"").toLowerCase()}catch{return null}if(k.indexOf("javascript:")===0||k.indexOf("vbscript:")===0||k.indexOf("data:")===0)return null}O&&!c.test(U)&&(U=f(O,U));try{U=encodeURI(U).replace(/%25/g,"%")}catch{return null}return U}var S={},N=/^[^:]+:\/*[^/]*$/,L=/^([^:]+:)[\s\S]*$/,T=/^([^:]+:\/*[^/]*)[\s\S]*$/;function f(F,O){S[" "+F]||(N.test(F)?S[" "+F]=F+"/":S[" "+F]=_(F,"/",!0)),F=S[" "+F];var U=F.indexOf(":")===-1;return O.substring(0,2)==="//"?U?O:F.replace(L,"$1")+O:O.charAt(0)==="/"?U?O:F.replace(T,"$1")+O:F+O}var C={exec:function(){}};function p(F){for(var O=1,U,k;O<arguments.length;O++){U=arguments[O];for(k in U)Object.prototype.hasOwnProperty.call(U,k)&&(F[k]=U[k])}return F}function y(F,O){var U=F.replace(/\|/g,function(P,R,j){for(var J=!1,he=R;--he>=0&&j[he]==="\\";)J=!J;return J?"|":" |"}),k=U.split(/ \|/),M=0;if(k[0].trim()||k.shift(),k.length>0&&!k[k.length-1].trim()&&k.pop(),k.length>O)k.splice(O);else for(;k.length<O;)k.push("");for(;M<k.length;M++)k[M]=k[M].trim().replace(/\\\|/g,"|");return k}function _(F,O,U){var k=F.length;if(k===0)return"";for(var M=0;M<k;){var P=F.charAt(k-M-1);if(P===O&&!U)M++;else if(P!==O&&U)M++;else break}return F.slice(0,k-M)}function V(F,O){if(F.indexOf(O[1])===-1)return-1;for(var U=F.length,k=0,M=0;M<U;M++)if(F[M]==="\\")M++;else if(F[M]===O[0])k++;else if(F[M]===O[1]&&(k--,k<0))return M;return-1}function ge(F){F&&F.sanitize&&!F.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function Q(F,O){if(O<1)return"";for(var U="";O>1;)O&1&&(U+=F),O>>=1,F+=F;return U+F}function ie(F,O,U,k){var M=O.href,P=O.title?e(O.title):null,R=F[1].replace(/\\([\[\]])/g,"$1");if(F[0].charAt(0)!=="!"){k.state.inLink=!0;var j={type:"link",raw:U,href:M,title:P,text:R,tokens:k.inlineTokens(R)};return k.state.inLink=!1,j}return{type:"image",raw:U,href:M,title:P,text:e(R)}}function te(F,O){var U=F.match(/^(\s+)(?:```)/);if(U===null)return O;var k=U[1];return O.split(`
`).map(function(M){var P=M.match(/^\s+/);if(P===null)return M;var R=P[0];return R.length>=k.length?M.slice(k.length):M}).join(`
`)}var ue=function(){function F(U){this.options=U||Z.defaults}var O=F.prototype;return O.space=function(k){var M=this.rules.block.newline.exec(k);if(M&&M[0].length>0)return{type:"space",raw:M[0]}},O.code=function(k){var M=this.rules.block.code.exec(k);if(M){var P=M[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:M[0],codeBlockStyle:"indented",text:this.options.pedantic?P:_(P,`
`)}}},O.fences=function(k){var M=this.rules.block.fences.exec(k);if(M){var P=M[0],R=te(P,M[3]||"");return{type:"code",raw:P,lang:M[2]?M[2].trim():M[2],text:R}}},O.heading=function(k){var M=this.rules.block.heading.exec(k);if(M){var P=M[2].trim();if(/#$/.test(P)){var R=_(P,"#");(this.options.pedantic||!R||/ $/.test(R))&&(P=R.trim())}return{type:"heading",raw:M[0],depth:M[1].length,text:P,tokens:this.lexer.inline(P)}}},O.hr=function(k){var M=this.rules.block.hr.exec(k);if(M)return{type:"hr",raw:M[0]}},O.blockquote=function(k){var M=this.rules.block.blockquote.exec(k);if(M){var P=M[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:M[0],tokens:this.lexer.blockTokens(P,[]),text:P}}},O.list=function(k){var M=this.rules.block.list.exec(k);if(M){var P,R,j,J,he,ce,De,ye,Ie,Se,we,Re,Pe=M[1].trim(),Ke=Pe.length>1,Ue={type:"list",raw:"",ordered:Ke,start:Ke?+Pe.slice(0,-1):"",loose:!1,items:[]};Pe=Ke?"\\d{1,9}\\"+Pe.slice(-1):"\\"+Pe,this.options.pedantic&&(Pe=Ke?Pe:"[*+-]");for(var We=new RegExp("^( {0,3}"+Pe+")((?:[	 ][^\\n]*)?(?:\\n|$))");k&&(Re=!1,!(!(M=We.exec(k))||this.rules.block.hr.test(k)));){if(P=M[0],k=k.substring(P.length),ye=M[2].split(`
`,1)[0],Ie=k.split(`
`,1)[0],this.options.pedantic?(J=2,we=ye.trimLeft()):(J=M[2].search(/[^ ]/),J=J>4?1:J,we=ye.slice(J),J+=M[1].length),ce=!1,!ye&&/^ *$/.test(Ie)&&(P+=Ie+`
`,k=k.substring(Ie.length+1),Re=!0),!Re)for(var xe=new RegExp("^ {0,"+Math.min(3,J-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,J-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Be=new RegExp("^ {0,"+Math.min(3,J-1)+"}(?:```|~~~)"),je=new RegExp("^ {0,"+Math.min(3,J-1)+"}#");k&&(Se=k.split(`
`,1)[0],ye=Se,this.options.pedantic&&(ye=ye.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Be.test(ye)||je.test(ye)||xe.test(ye)||it.test(k)));){if(ye.search(/[^ ]/)>=J||!ye.trim())we+=`
`+ye.slice(J);else if(!ce)we+=`
`+ye;else break;!ce&&!ye.trim()&&(ce=!0),P+=Se+`
`,k=k.substring(Se.length+1)}Ue.loose||(De?Ue.loose=!0:/\n *\n *$/.test(P)&&(De=!0)),this.options.gfm&&(R=/^\[[ xX]\] /.exec(we),R&&(j=R[0]!=="[ ] ",we=we.replace(/^\[[ xX]\] +/,""))),Ue.items.push({type:"list_item",raw:P,task:!!R,checked:j,loose:!1,text:we}),Ue.raw+=P}Ue.items[Ue.items.length-1].raw=P.trimRight(),Ue.items[Ue.items.length-1].text=we.trimRight(),Ue.raw=Ue.raw.trimRight();var Ye=Ue.items.length;for(he=0;he<Ye;he++){this.lexer.state.top=!1,Ue.items[he].tokens=this.lexer.blockTokens(Ue.items[he].text,[]);var K=Ue.items[he].tokens.filter(function(pe){return pe.type==="space"}),le=K.every(function(pe){for(var Ee=pe.raw.split(""),Fe=0,Oe=H(Ee),$e;!($e=Oe()).done;){var tt=$e.value;if(tt===`
`&&(Fe+=1),Fe>1)return!0}return!1});!Ue.loose&&K.length&&le&&(Ue.loose=!0,Ue.items[he].loose=!0)}return Ue}},O.html=function(k){var M=this.rules.block.html.exec(k);if(M){var P={type:"html",raw:M[0],pre:!this.options.sanitizer&&(M[1]==="pre"||M[1]==="script"||M[1]==="style"),text:M[0]};if(this.options.sanitize){var R=this.options.sanitizer?this.options.sanitizer(M[0]):e(M[0]);P.type="paragraph",P.text=R,P.tokens=this.lexer.inline(R)}return P}},O.def=function(k){var M=this.rules.block.def.exec(k);if(M){M[3]&&(M[3]=M[3].substring(1,M[3].length-1));var P=M[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:P,raw:M[0],href:M[2],title:M[3]}}},O.table=function(k){var M=this.rules.block.table.exec(k);if(M){var P={type:"table",header:y(M[1]).map(function(De){return{text:De}}),align:M[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:M[3]&&M[3].trim()?M[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(P.header.length===P.align.length){P.raw=M[0];var R=P.align.length,j,J,he,ce;for(j=0;j<R;j++)/^ *-+: *$/.test(P.align[j])?P.align[j]="right":/^ *:-+: *$/.test(P.align[j])?P.align[j]="center":/^ *:-+ *$/.test(P.align[j])?P.align[j]="left":P.align[j]=null;for(R=P.rows.length,j=0;j<R;j++)P.rows[j]=y(P.rows[j],P.header.length).map(function(De){return{text:De}});for(R=P.header.length,J=0;J<R;J++)P.header[J].tokens=this.lexer.inline(P.header[J].text);for(R=P.rows.length,J=0;J<R;J++)for(ce=P.rows[J],he=0;he<ce.length;he++)ce[he].tokens=this.lexer.inline(ce[he].text);return P}}},O.lheading=function(k){var M=this.rules.block.lheading.exec(k);if(M)return{type:"heading",raw:M[0],depth:M[2].charAt(0)==="="?1:2,text:M[1],tokens:this.lexer.inline(M[1])}},O.paragraph=function(k){var M=this.rules.block.paragraph.exec(k);if(M){var P=M[1].charAt(M[1].length-1)===`
`?M[1].slice(0,-1):M[1];return{type:"paragraph",raw:M[0],text:P,tokens:this.lexer.inline(P)}}},O.text=function(k){var M=this.rules.block.text.exec(k);if(M)return{type:"text",raw:M[0],text:M[0],tokens:this.lexer.inline(M[0])}},O.escape=function(k){var M=this.rules.inline.escape.exec(k);if(M)return{type:"escape",raw:M[0],text:e(M[1])}},O.tag=function(k){var M=this.rules.inline.tag.exec(k);if(M)return!this.lexer.state.inLink&&/^<a /i.test(M[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(M[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(M[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(M[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:M[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(M[0]):e(M[0]):M[0]}},O.link=function(k){var M=this.rules.inline.link.exec(k);if(M){var P=M[2].trim();if(!this.options.pedantic&&/^</.test(P)){if(!/>$/.test(P))return;var R=_(P.slice(0,-1),"\\");if((P.length-R.length)%2===0)return}else{var j=V(M[2],"()");if(j>-1){var J=M[0].indexOf("!")===0?5:4,he=J+M[1].length+j;M[2]=M[2].substring(0,j),M[0]=M[0].substring(0,he).trim(),M[3]=""}}var ce=M[2],De="";if(this.options.pedantic){var ye=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ce);ye&&(ce=ye[1],De=ye[3])}else De=M[3]?M[3].slice(1,-1):"";return ce=ce.trim(),/^</.test(ce)&&(this.options.pedantic&&!/>$/.test(P)?ce=ce.slice(1):ce=ce.slice(1,-1)),ie(M,{href:ce&&ce.replace(this.rules.inline._escapes,"$1"),title:De&&De.replace(this.rules.inline._escapes,"$1")},M[0],this.lexer)}},O.reflink=function(k,M){var P;if((P=this.rules.inline.reflink.exec(k))||(P=this.rules.inline.nolink.exec(k))){var R=(P[2]||P[1]).replace(/\s+/g," ");if(R=M[R.toLowerCase()],!R||!R.href){var j=P[0].charAt(0);return{type:"text",raw:j,text:j}}return ie(P,R,P[0],this.lexer)}},O.emStrong=function(k,M,P){P===void 0&&(P="");var R=this.rules.inline.emStrong.lDelim.exec(k);if(!!R&&!(R[3]&&P.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var j=R[1]||R[2]||"";if(!j||j&&(P===""||this.rules.inline.punctuation.exec(P))){var J=R[0].length-1,he,ce,De=J,ye=0,Ie=R[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ie.lastIndex=0,M=M.slice(-1*k.length+J);(R=Ie.exec(M))!=null;)if(he=R[1]||R[2]||R[3]||R[4]||R[5]||R[6],!!he){if(ce=he.length,R[3]||R[4]){De+=ce;continue}else if((R[5]||R[6])&&J%3&&!((J+ce)%3)){ye+=ce;continue}if(De-=ce,!(De>0)){if(ce=Math.min(ce,ce+De+ye),Math.min(J,ce)%2){var Se=k.slice(1,J+R.index+ce);return{type:"em",raw:k.slice(0,J+R.index+ce+1),text:Se,tokens:this.lexer.inlineTokens(Se)}}var we=k.slice(2,J+R.index+ce-1);return{type:"strong",raw:k.slice(0,J+R.index+ce+1),text:we,tokens:this.lexer.inlineTokens(we)}}}}}},O.codespan=function(k){var M=this.rules.inline.code.exec(k);if(M){var P=M[2].replace(/\n/g," "),R=/[^ ]/.test(P),j=/^ /.test(P)&&/ $/.test(P);return R&&j&&(P=P.substring(1,P.length-1)),P=e(P,!0),{type:"codespan",raw:M[0],text:P}}},O.br=function(k){var M=this.rules.inline.br.exec(k);if(M)return{type:"br",raw:M[0]}},O.del=function(k){var M=this.rules.inline.del.exec(k);if(M)return{type:"del",raw:M[0],text:M[2],tokens:this.lexer.inlineTokens(M[2])}},O.autolink=function(k,M){var P=this.rules.inline.autolink.exec(k);if(P){var R,j;return P[2]==="@"?(R=e(this.options.mangle?M(P[1]):P[1]),j="mailto:"+R):(R=e(P[1]),j=R),{type:"link",raw:P[0],text:R,href:j,tokens:[{type:"text",raw:R,text:R}]}}},O.url=function(k,M){var P;if(P=this.rules.inline.url.exec(k)){var R,j;if(P[2]==="@")R=e(this.options.mangle?M(P[0]):P[0]),j="mailto:"+R;else{var J;do J=P[0],P[0]=this.rules.inline._backpedal.exec(P[0])[0];while(J!==P[0]);R=e(P[0]),P[1]==="www."?j="http://"+R:j=R}return{type:"link",raw:P[0],text:R,href:j,tokens:[{type:"text",raw:R,text:R}]}}},O.inlineText=function(k,M){var P=this.rules.inline.text.exec(k);if(P){var R;return this.lexer.state.inRawBlock?R=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(P[0]):e(P[0]):P[0]:R=e(this.options.smartypants?M(P[0]):P[0]),{type:"text",raw:P[0],text:R}}},F}(),ae={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:C,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ae._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ae._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ae.def=h(ae.def).replace("label",ae._label).replace("title",ae._title).getRegex(),ae.bullet=/(?:[*+-]|\d{1,9}[.)])/,ae.listItemStart=h(/^( *)(bull) */).replace("bull",ae.bullet).getRegex(),ae.list=h(ae.list).replace(/bull/g,ae.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ae.def.source+")").getRegex(),ae._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ae._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ae.html=h(ae.html,"i").replace("comment",ae._comment).replace("tag",ae._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ae.paragraph=h(ae._paragraph).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.blockquote=h(ae.blockquote).replace("paragraph",ae.paragraph).getRegex(),ae.normal=p({},ae),ae.gfm=p({},ae.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ae.gfm.table=h(ae.gfm.table).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.gfm.paragraph=h(ae._paragraph).replace("hr",ae.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ae.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ae._tag).getRegex(),ae.pedantic=p({},ae.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ae._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:C,paragraph:h(ae.normal._paragraph).replace("hr",ae.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ae.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var de={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:C,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:C,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};de._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",de.punctuation=h(de.punctuation).replace(/punctuation/g,de._punctuation).getRegex(),de.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,de.escapedEmSt=/\\\*|\\_/g,de._comment=h(ae._comment).replace("(?:-->|$)","-->").getRegex(),de.emStrong.lDelim=h(de.emStrong.lDelim).replace(/punct/g,de._punctuation).getRegex(),de.emStrong.rDelimAst=h(de.emStrong.rDelimAst,"g").replace(/punct/g,de._punctuation).getRegex(),de.emStrong.rDelimUnd=h(de.emStrong.rDelimUnd,"g").replace(/punct/g,de._punctuation).getRegex(),de._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,de._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,de._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,de.autolink=h(de.autolink).replace("scheme",de._scheme).replace("email",de._email).getRegex(),de._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,de.tag=h(de.tag).replace("comment",de._comment).replace("attribute",de._attribute).getRegex(),de._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,de._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,de._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,de.link=h(de.link).replace("label",de._label).replace("href",de._href).replace("title",de._title).getRegex(),de.reflink=h(de.reflink).replace("label",de._label).replace("ref",ae._label).getRegex(),de.nolink=h(de.nolink).replace("ref",ae._label).getRegex(),de.reflinkSearch=h(de.reflinkSearch,"g").replace("reflink",de.reflink).replace("nolink",de.nolink).getRegex(),de.normal=p({},de),de.pedantic=p({},de.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",de._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",de._label).getRegex()}),de.gfm=p({},de.normal,{escape:h(de.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),de.gfm.url=h(de.gfm.url,"i").replace("email",de.gfm._extended_email).getRegex(),de.breaks=p({},de.gfm,{br:h(de.br).replace("{2,}","*").getRegex(),text:h(de.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function Ae(F){return F.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function x(F){var O="",U,k,M=F.length;for(U=0;U<M;U++)k=F.charCodeAt(U),Math.random()>.5&&(k="x"+k.toString(16)),O+="&#"+k+";";return O}var ve=function(){function F(U){this.tokens=[],this.tokens.links=Object.create(null),this.options=U||Z.defaults,this.options.tokenizer=this.options.tokenizer||new ue,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var k={block:ae.normal,inline:de.normal};this.options.pedantic?(k.block=ae.pedantic,k.inline=de.pedantic):this.options.gfm&&(k.block=ae.gfm,this.options.breaks?k.inline=de.breaks:k.inline=de.gfm),this.tokenizer.rules=k}F.lex=function(k,M){var P=new F(M);return P.lex(k)},F.lexInline=function(k,M){var P=new F(M);return P.inlineTokens(k)};var O=F.prototype;return O.lex=function(k){k=k.replace(/\r\n|\r/g,`
`),this.blockTokens(k,this.tokens);for(var M;M=this.inlineQueue.shift();)this.inlineTokens(M.src,M.tokens);return this.tokens},O.blockTokens=function(k,M){var P=this;M===void 0&&(M=[]),this.options.pedantic?k=k.replace(/\t/g,"    ").replace(/^ +$/gm,""):k=k.replace(/^( *)(\t+)/gm,function(De,ye,Ie){return ye+"    ".repeat(Ie.length)});for(var R,j,J,he;k;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(De){return(R=De.call({lexer:P},k,M))?(k=k.substring(R.raw.length),M.push(R),!0):!1}))){if(R=this.tokenizer.space(k)){k=k.substring(R.raw.length),R.raw.length===1&&M.length>0?M[M.length-1].raw+=`
`:M.push(R);continue}if(R=this.tokenizer.code(k)){k=k.substring(R.raw.length),j=M[M.length-1],j&&(j.type==="paragraph"||j.type==="text")?(j.raw+=`
`+R.raw,j.text+=`
`+R.text,this.inlineQueue[this.inlineQueue.length-1].src=j.text):M.push(R);continue}if(R=this.tokenizer.fences(k)){k=k.substring(R.raw.length),M.push(R);continue}if(R=this.tokenizer.heading(k)){k=k.substring(R.raw.length),M.push(R);continue}if(R=this.tokenizer.hr(k)){k=k.substring(R.raw.length),M.push(R);continue}if(R=this.tokenizer.blockquote(k)){k=k.substring(R.raw.length),M.push(R);continue}if(R=this.tokenizer.list(k)){k=k.substring(R.raw.length),M.push(R);continue}if(R=this.tokenizer.html(k)){k=k.substring(R.raw.length),M.push(R);continue}if(R=this.tokenizer.def(k)){k=k.substring(R.raw.length),j=M[M.length-1],j&&(j.type==="paragraph"||j.type==="text")?(j.raw+=`
`+R.raw,j.text+=`
`+R.raw,this.inlineQueue[this.inlineQueue.length-1].src=j.text):this.tokens.links[R.tag]||(this.tokens.links[R.tag]={href:R.href,title:R.title});continue}if(R=this.tokenizer.table(k)){k=k.substring(R.raw.length),M.push(R);continue}if(R=this.tokenizer.lheading(k)){k=k.substring(R.raw.length),M.push(R);continue}if(J=k,this.options.extensions&&this.options.extensions.startBlock&&function(){var De=1/0,ye=k.slice(1),Ie=void 0;P.options.extensions.startBlock.forEach(function(Se){Ie=Se.call({lexer:this},ye),typeof Ie=="number"&&Ie>=0&&(De=Math.min(De,Ie))}),De<1/0&&De>=0&&(J=k.substring(0,De+1))}(),this.state.top&&(R=this.tokenizer.paragraph(J))){j=M[M.length-1],he&&j.type==="paragraph"?(j.raw+=`
`+R.raw,j.text+=`
`+R.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=j.text):M.push(R),he=J.length!==k.length,k=k.substring(R.raw.length);continue}if(R=this.tokenizer.text(k)){k=k.substring(R.raw.length),j=M[M.length-1],j&&j.type==="text"?(j.raw+=`
`+R.raw,j.text+=`
`+R.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=j.text):M.push(R);continue}if(k){var ce="Infinite loop on byte: "+k.charCodeAt(0);if(this.options.silent){console.error(ce);break}else throw new Error(ce)}}return this.state.top=!0,M},O.inline=function(k,M){return M===void 0&&(M=[]),this.inlineQueue.push({src:k,tokens:M}),M},O.inlineTokens=function(k,M){var P=this;M===void 0&&(M=[]);var R,j,J,he=k,ce,De,ye;if(this.tokens.links){var Ie=Object.keys(this.tokens.links);if(Ie.length>0)for(;(ce=this.tokenizer.rules.inline.reflinkSearch.exec(he))!=null;)Ie.includes(ce[0].slice(ce[0].lastIndexOf("[")+1,-1))&&(he=he.slice(0,ce.index)+"["+Q("a",ce[0].length-2)+"]"+he.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ce=this.tokenizer.rules.inline.blockSkip.exec(he))!=null;)he=he.slice(0,ce.index)+"["+Q("a",ce[0].length-2)+"]"+he.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ce=this.tokenizer.rules.inline.escapedEmSt.exec(he))!=null;)he=he.slice(0,ce.index)+"++"+he.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;k;)if(De||(ye=""),De=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(we){return(R=we.call({lexer:P},k,M))?(k=k.substring(R.raw.length),M.push(R),!0):!1}))){if(R=this.tokenizer.escape(k)){k=k.substring(R.raw.length),M.push(R);continue}if(R=this.tokenizer.tag(k)){k=k.substring(R.raw.length),j=M[M.length-1],j&&R.type==="text"&&j.type==="text"?(j.raw+=R.raw,j.text+=R.text):M.push(R);continue}if(R=this.tokenizer.link(k)){k=k.substring(R.raw.length),M.push(R);continue}if(R=this.tokenizer.reflink(k,this.tokens.links)){k=k.substring(R.raw.length),j=M[M.length-1],j&&R.type==="text"&&j.type==="text"?(j.raw+=R.raw,j.text+=R.text):M.push(R);continue}if(R=this.tokenizer.emStrong(k,he,ye)){k=k.substring(R.raw.length),M.push(R);continue}if(R=this.tokenizer.codespan(k)){k=k.substring(R.raw.length),M.push(R);continue}if(R=this.tokenizer.br(k)){k=k.substring(R.raw.length),M.push(R);continue}if(R=this.tokenizer.del(k)){k=k.substring(R.raw.length),M.push(R);continue}if(R=this.tokenizer.autolink(k,x)){k=k.substring(R.raw.length),M.push(R);continue}if(!this.state.inLink&&(R=this.tokenizer.url(k,x))){k=k.substring(R.raw.length),M.push(R);continue}if(J=k,this.options.extensions&&this.options.extensions.startInline&&function(){var we=1/0,Re=k.slice(1),Pe=void 0;P.options.extensions.startInline.forEach(function(Ke){Pe=Ke.call({lexer:this},Re),typeof Pe=="number"&&Pe>=0&&(we=Math.min(we,Pe))}),we<1/0&&we>=0&&(J=k.substring(0,we+1))}(),R=this.tokenizer.inlineText(J,Ae)){k=k.substring(R.raw.length),R.raw.slice(-1)!=="_"&&(ye=R.raw.slice(-1)),De=!0,j=M[M.length-1],j&&j.type==="text"?(j.raw+=R.raw,j.text+=R.text):M.push(R);continue}if(k){var Se="Infinite loop on byte: "+k.charCodeAt(0);if(this.options.silent){console.error(Se);break}else throw new Error(Se)}}return M},v(F,null,[{key:"rules",get:function(){return{block:ae,inline:de}}}]),F}(),Ne=function(){function F(U){this.options=U||Z.defaults}var O=F.prototype;return O.code=function(k,M,P){var R=(M||"").match(/\S*/)[0];if(this.options.highlight){var j=this.options.highlight(k,R);j!=null&&j!==k&&(P=!0,k=j)}return k=k.replace(/\n$/,"")+`
`,R?'<pre><code class="'+this.options.langPrefix+e(R,!0)+'">'+(P?k:e(k,!0))+`</code></pre>
`:"<pre><code>"+(P?k:e(k,!0))+`</code></pre>
`},O.blockquote=function(k){return`<blockquote>
`+k+`</blockquote>
`},O.html=function(k){return k},O.heading=function(k,M,P,R){if(this.options.headerIds){var j=this.options.headerPrefix+R.slug(P);return"<h"+M+' id="'+j+'">'+k+"</h"+M+`>
`}return"<h"+M+">"+k+"</h"+M+`>
`},O.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},O.list=function(k,M,P){var R=M?"ol":"ul",j=M&&P!==1?' start="'+P+'"':"";return"<"+R+j+`>
`+k+"</"+R+`>
`},O.listitem=function(k){return"<li>"+k+`</li>
`},O.checkbox=function(k){return"<input "+(k?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},O.paragraph=function(k){return"<p>"+k+`</p>
`},O.table=function(k,M){return M&&(M="<tbody>"+M+"</tbody>"),`<table>
<thead>
`+k+`</thead>
`+M+`</table>
`},O.tablerow=function(k){return`<tr>
`+k+`</tr>
`},O.tablecell=function(k,M){var P=M.header?"th":"td",R=M.align?"<"+P+' align="'+M.align+'">':"<"+P+">";return R+k+("</"+P+`>
`)},O.strong=function(k){return"<strong>"+k+"</strong>"},O.em=function(k){return"<em>"+k+"</em>"},O.codespan=function(k){return"<code>"+k+"</code>"},O.br=function(){return this.options.xhtml?"<br/>":"<br>"},O.del=function(k){return"<del>"+k+"</del>"},O.link=function(k,M,P){if(k=b(this.options.sanitize,this.options.baseUrl,k),k===null)return P;var R='<a href="'+e(k)+'"';return M&&(R+=' title="'+M+'"'),R+=">"+P+"</a>",R},O.image=function(k,M,P){if(k=b(this.options.sanitize,this.options.baseUrl,k),k===null)return P;var R='<img src="'+k+'" alt="'+P+'"';return M&&(R+=' title="'+M+'"'),R+=this.options.xhtml?"/>":">",R},O.text=function(k){return k},F}(),oe=function(){function F(){}var O=F.prototype;return O.strong=function(k){return k},O.em=function(k){return k},O.codespan=function(k){return k},O.del=function(k){return k},O.html=function(k){return k},O.text=function(k){return k},O.link=function(k,M,P){return""+P},O.image=function(k,M,P){return""+P},O.br=function(){return""},F}(),X=function(){function F(){this.seen={}}var O=F.prototype;return O.serialize=function(k){return k.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},O.getNextSafeSlug=function(k,M){var P=k,R=0;if(this.seen.hasOwnProperty(P)){R=this.seen[k];do R++,P=k+"-"+R;while(this.seen.hasOwnProperty(P))}return M||(this.seen[k]=R,this.seen[P]=0),P},O.slug=function(k,M){M===void 0&&(M={});var P=this.serialize(k);return this.getNextSafeSlug(P,M.dryrun)},F}(),se=function(){function F(U){this.options=U||Z.defaults,this.options.renderer=this.options.renderer||new Ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new oe,this.slugger=new X}F.parse=function(k,M){var P=new F(M);return P.parse(k)},F.parseInline=function(k,M){var P=new F(M);return P.parseInline(k)};var O=F.prototype;return O.parse=function(k,M){M===void 0&&(M=!0);var P="",R,j,J,he,ce,De,ye,Ie,Se,we,Re,Pe,Ke,Ue,We,xe,it,Be,je,Ye=k.length;for(R=0;R<Ye;R++){if(we=k[R],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[we.type]&&(je=this.options.extensions.renderers[we.type].call({parser:this},we),je!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(we.type))){P+=je||"";continue}switch(we.type){case"space":continue;case"hr":{P+=this.renderer.hr();continue}case"heading":{P+=this.renderer.heading(this.parseInline(we.tokens),we.depth,a(this.parseInline(we.tokens,this.textRenderer)),this.slugger);continue}case"code":{P+=this.renderer.code(we.text,we.lang,we.escaped);continue}case"table":{for(Ie="",ye="",he=we.header.length,j=0;j<he;j++)ye+=this.renderer.tablecell(this.parseInline(we.header[j].tokens),{header:!0,align:we.align[j]});for(Ie+=this.renderer.tablerow(ye),Se="",he=we.rows.length,j=0;j<he;j++){for(De=we.rows[j],ye="",ce=De.length,J=0;J<ce;J++)ye+=this.renderer.tablecell(this.parseInline(De[J].tokens),{header:!1,align:we.align[J]});Se+=this.renderer.tablerow(ye)}P+=this.renderer.table(Ie,Se);continue}case"blockquote":{Se=this.parse(we.tokens),P+=this.renderer.blockquote(Se);continue}case"list":{for(Re=we.ordered,Pe=we.start,Ke=we.loose,he=we.items.length,Se="",j=0;j<he;j++)We=we.items[j],xe=We.checked,it=We.task,Ue="",We.task&&(Be=this.renderer.checkbox(xe),Ke?We.tokens.length>0&&We.tokens[0].type==="paragraph"?(We.tokens[0].text=Be+" "+We.tokens[0].text,We.tokens[0].tokens&&We.tokens[0].tokens.length>0&&We.tokens[0].tokens[0].type==="text"&&(We.tokens[0].tokens[0].text=Be+" "+We.tokens[0].tokens[0].text)):We.tokens.unshift({type:"text",text:Be}):Ue+=Be),Ue+=this.parse(We.tokens,Ke),Se+=this.renderer.listitem(Ue,it,xe);P+=this.renderer.list(Se,Re,Pe);continue}case"html":{P+=this.renderer.html(we.text);continue}case"paragraph":{P+=this.renderer.paragraph(this.parseInline(we.tokens));continue}case"text":{for(Se=we.tokens?this.parseInline(we.tokens):we.text;R+1<Ye&&k[R+1].type==="text";)we=k[++R],Se+=`
`+(we.tokens?this.parseInline(we.tokens):we.text);P+=M?this.renderer.paragraph(Se):Se;continue}default:{var K='Token with "'+we.type+'" type was not found.';if(this.options.silent){console.error(K);return}else throw new Error(K)}}}return P},O.parseInline=function(k,M){M=M||this.renderer;var P="",R,j,J,he=k.length;for(R=0;R<he;R++){if(j=k[R],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[j.type]&&(J=this.options.extensions.renderers[j.type].call({parser:this},j),J!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(j.type))){P+=J||"";continue}switch(j.type){case"escape":{P+=M.text(j.text);break}case"html":{P+=M.html(j.text);break}case"link":{P+=M.link(j.href,j.title,this.parseInline(j.tokens,M));break}case"image":{P+=M.image(j.href,j.title,j.text);break}case"strong":{P+=M.strong(this.parseInline(j.tokens,M));break}case"em":{P+=M.em(this.parseInline(j.tokens,M));break}case"codespan":{P+=M.codespan(j.text);break}case"br":{P+=M.br();break}case"del":{P+=M.del(this.parseInline(j.tokens,M));break}case"text":{P+=M.text(j.text);break}default:{var ce='Token with "'+j.type+'" type was not found.';if(this.options.silent){console.error(ce);return}else throw new Error(ce)}}}return P},F}();function ne(F,O,U){if(typeof F>"u"||F===null)throw new Error("marked(): input parameter is undefined or null");if(typeof F!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(F)+", string expected");if(typeof O=="function"&&(U=O,O=null),O=p({},ne.defaults,O||{}),ge(O),U){var k=O.highlight,M;try{M=ve.lex(F,O)}catch(he){return U(he)}var P=function(ce){var De;if(!ce)try{O.walkTokens&&ne.walkTokens(M,O.walkTokens),De=se.parse(M,O)}catch(ye){ce=ye}return O.highlight=k,ce?U(ce):U(null,De)};if(!k||k.length<3||(delete O.highlight,!M.length))return P();var R=0;ne.walkTokens(M,function(he){he.type==="code"&&(R++,setTimeout(function(){k(he.text,he.lang,function(ce,De){if(ce)return P(ce);De!=null&&De!==he.text&&(he.text=De,he.escaped=!0),R--,R===0&&P()})},0))}),R===0&&P();return}function j(he){if(he.message+=`
Please report this to https://github.com/markedjs/marked.`,O.silent)return"<p>An error occurred:</p><pre>"+e(he.message+"",!0)+"</pre>";throw he}try{var J=ve.lex(F,O);if(O.walkTokens){if(O.async)return Promise.all(ne.walkTokens(J,O.walkTokens)).then(function(){return se.parse(J,O)}).catch(j);ne.walkTokens(J,O.walkTokens)}return se.parse(J,O)}catch(he){j(he)}}ne.options=ne.setOptions=function(F){return p(ne.defaults,F),w(ne.defaults),ne},ne.getDefaults=D,ne.defaults=Z.defaults,ne.use=function(){for(var F=arguments.length,O=new Array(F),U=0;U<F;U++)O[U]=arguments[U];var k=p.apply(void 0,[{}].concat(O)),M=ne.defaults.extensions||{renderers:{},childTokens:{}},P;O.forEach(function(R){if(R.extensions&&(P=!0,R.extensions.forEach(function(J){if(!J.name)throw new Error("extension name required");if(J.renderer){var he=M.renderers?M.renderers[J.name]:null;he?M.renderers[J.name]=function(){for(var ce=arguments.length,De=new Array(ce),ye=0;ye<ce;ye++)De[ye]=arguments[ye];var Ie=J.renderer.apply(this,De);return Ie===!1&&(Ie=he.apply(this,De)),Ie}:M.renderers[J.name]=J.renderer}if(J.tokenizer){if(!J.level||J.level!=="block"&&J.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");M[J.level]?M[J.level].unshift(J.tokenizer):M[J.level]=[J.tokenizer],J.start&&(J.level==="block"?M.startBlock?M.startBlock.push(J.start):M.startBlock=[J.start]:J.level==="inline"&&(M.startInline?M.startInline.push(J.start):M.startInline=[J.start]))}J.childTokens&&(M.childTokens[J.name]=J.childTokens)})),R.renderer&&function(){var J=ne.defaults.renderer||new Ne,he=function(ye){var Ie=J[ye];J[ye]=function(){for(var Se=arguments.length,we=new Array(Se),Re=0;Re<Se;Re++)we[Re]=arguments[Re];var Pe=R.renderer[ye].apply(J,we);return Pe===!1&&(Pe=Ie.apply(J,we)),Pe}};for(var ce in R.renderer)he(ce);k.renderer=J}(),R.tokenizer&&function(){var J=ne.defaults.tokenizer||new ue,he=function(ye){var Ie=J[ye];J[ye]=function(){for(var Se=arguments.length,we=new Array(Se),Re=0;Re<Se;Re++)we[Re]=arguments[Re];var Pe=R.tokenizer[ye].apply(J,we);return Pe===!1&&(Pe=Ie.apply(J,we)),Pe}};for(var ce in R.tokenizer)he(ce);k.tokenizer=J}(),R.walkTokens){var j=ne.defaults.walkTokens;k.walkTokens=function(J){var he=[];return he.push(R.walkTokens.call(this,J)),j&&(he=he.concat(j.call(this,J))),he}}P&&(k.extensions=M),ne.setOptions(k)})},ne.walkTokens=function(F,O){for(var U=[],k=function(){var j=P.value;switch(U=U.concat(O.call(ne,j)),j.type){case"table":{for(var J=H(j.header),he;!(he=J()).done;){var ce=he.value;U=U.concat(ne.walkTokens(ce.tokens,O))}for(var De=H(j.rows),ye;!(ye=De()).done;)for(var Ie=ye.value,Se=H(Ie),we;!(we=Se()).done;){var Re=we.value;U=U.concat(ne.walkTokens(Re.tokens,O))}break}case"list":{U=U.concat(ne.walkTokens(j.items,O));break}default:ne.defaults.extensions&&ne.defaults.extensions.childTokens&&ne.defaults.extensions.childTokens[j.type]?ne.defaults.extensions.childTokens[j.type].forEach(function(Pe){U=U.concat(ne.walkTokens(j[Pe],O))}):j.tokens&&(U=U.concat(ne.walkTokens(j.tokens,O)))}},M=H(F),P;!(P=M()).done;)k();return U},ne.parseInline=function(F,O){if(typeof F>"u"||F===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof F!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(F)+", string expected");O=p({},ne.defaults,O||{}),ge(O);try{var U=ve.lexInline(F,O);return O.walkTokens&&ne.walkTokens(U,O.walkTokens),se.parseInline(U,O)}catch(k){if(k.message+=`
Please report this to https://github.com/markedjs/marked.`,O.silent)return"<p>An error occurred:</p><pre>"+e(k.message+"",!0)+"</pre>";throw k}},ne.Parser=se,ne.parser=se.parse,ne.Renderer=Ne,ne.TextRenderer=oe,ne.Lexer=ve,ne.lexer=ve.lex,ne.Tokenizer=ue,ne.Slugger=X,ne.parse=ne;var ee=ne.options,A=ne.setOptions,E=ne.use,u=ne.walkTokens,B=ne.parseInline,W=ne,$=se.parse,Y=ve.lex;Z.Lexer=ve,Z.Parser=se,Z.Renderer=Ne,Z.Slugger=X,Z.TextRenderer=oe,Z.Tokenizer=ue,Z.getDefaults=D,Z.lexer=Y,Z.marked=ne,Z.options=ee,Z.parse=W,Z.parseInline=B,Z.parser=$,Z.setOptions=A,Z.use=E,Z.walkTokens=u,Object.defineProperty(Z,"__esModule",{value:!0})}),define(me[77],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class v{constructor(z,H=0,D=z.length,w=H-1){this.a=z,this.b=H,this.c=D,this.d=w}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.ArrayNavigator=v}),define(me[78],be([1,0,77]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class i{constructor(D=[],w=10){this.h(D),this.b=w,this.d()}getHistory(){return this.j}add(D){this.a.delete(D),this.a.add(D),this.d()}next(){return this.g()!==this.j.length-1?this.c.next():null}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}has(D){return this.a.has(D)}clear(){this.h([]),this.d()}d(){this.f();const D=this.j;this.c=new v.ArrayNavigator(D,0,D.length,D.length)}f(){const D=this.j;D.length>this.b&&this.h(D.slice(D.length-this.b))}g(){const D=this.c.current();return D?this.j.indexOf(D):-1}h(D){this.a=new Set;for(const w of D)this.a.add(w)}get j(){const D=[];return this.a.forEach(w=>D.push(w)),D}}t.HistoryNavigator=i;class z{constructor(D,w=10){if(this.f=w,D.length<1)throw new Error("not supported");this.d=1,this.a=this.b=this.c={value:D[0],previous:void 0,next:void 0};for(let d=1;d<D.length;d++)this.add(D[d])}add(D){const w={value:D,previous:this.b,next:void 0};for(this.b.next=w,this.b=w,this.c=this.b,this.d++;this.d>this.f;)this.a=this.a.next,this.a.previous=void 0,this.d--}replaceLast(D){const w=this.b.value;return this.b.value=D,w}isAtEnd(){return this.c===this.b}current(){return this.c.value}previous(){return this.c.previous&&(this.c=this.c.previous),this.c.value}next(){return this.c.next&&(this.c=this.c.next),this.c.value}has(D){let w=this.a;for(;w;){if(w.value===D)return!0;w=w.next}return!1}resetCursor(){return this.c=this.b,this.c.value}*[Symbol.iterator](){let D=this.a;for(;D;)yield D.value,D=D.next}}t.HistoryNavigator2=z}),define(me[46],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=t.rot=t.clamp=void 0;function v(w,d,m){return Math.min(Math.max(w,d),m)}t.clamp=v;function i(w,d){return(d+w%d)%d}t.rot=i;class z{constructor(){this.a=0}getNext(){return this.a++}}t.Counter=z;class H{constructor(){this.a=1,this.b=0}update(d){return this.b=this.b+(d-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.MovingAverage=H;class D{constructor(d){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(d),this.c.fill(0,0,d)}update(d){const m=this.c[this.d];return this.c[this.d]=d,this.d=(this.d+1)%this.c.length,this.e-=m,this.e+=d,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.SlidingWindowAverage=D}),define(me[47],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var v;(function(i){function z(d,m){if(d.start>=m.end||m.start>=d.end)return{start:0,end:0};const g=Math.max(d.start,m.start),I=Math.min(d.end,m.end);return I-g<=0?{start:0,end:0}:{start:g,end:I}}i.intersect=z;function H(d){return d.end-d.start<=0}i.isEmpty=H;function D(d,m){return!H(z(d,m))}i.intersects=D;function w(d,m){const g=[],I={start:d.start,end:Math.min(m.start,d.end)},o={start:Math.max(m.end,d.start),end:d.end};return H(I)||g.push(I),H(o)||g.push(o),g}i.relativeComplement=w})(v=t.Range||(t.Range={}))}),define(me[79],be([1,0,47]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=t.consolidate=t.shift=t.groupIntersect=void 0;function i(d,m){const g=[];for(const I of m){if(d.start>=I.range.end)continue;if(d.end<I.range.start)break;const o=v.Range.intersect(d,I.range);v.Range.isEmpty(o)||g.push({range:o,size:I.size})}return g}t.groupIntersect=i;function z({start:d,end:m},g){return{start:d+g,end:m+g}}t.shift=z;function H(d){const m=[];let g=null;for(const I of d){const o=I.range.start,n=I.range.end,e=I.size;if(g&&e===g.size){g.range.end=n;continue}g={range:{start:o,end:n},size:e},m.push(g)}return m}t.consolidate=H;function D(...d){return H(d.reduce((m,g)=>m.concat(g),[]))}class w{constructor(){this.a=[],this.b=0}splice(m,g,I=[]){const o=I.length-g,n=i({start:0,end:m},this.a),e=i({start:m+g,end:Number.POSITIVE_INFINITY},this.a).map(a=>({range:z(a.range,o),size:a.size})),s=I.map((a,l)=>({range:{start:m+l,end:m+l+1},size:a.size}));this.a=D(n,s,e),this.b=this.a.reduce((a,l)=>a+l.size*(l.range.end-l.range.start),0)}get count(){const m=this.a.length;return m?this.a[m-1].range.end:0}get size(){return this.b}indexAt(m){if(m<0)return-1;let g=0,I=0;for(const o of this.a){const n=o.range.end-o.range.start,e=I+n*o.size;if(m<e)return g+Math.floor((m-I)/o.size);g+=n,I=e}return g}indexAfter(m){return Math.min(this.indexAt(m)+1,this.count)}positionAt(m){if(m<0)return-1;let g=0,I=0;for(const o of this.a){const n=o.range.end-o.range.start,e=I+n;if(m<e)return g+(m-I)*o.size;g+=n*o.size,I=e}return-1}}t.RangeMap=w}),define(me[80],be([1,0,9,2]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function z(c){const b=c;return b?typeof b.read=="function":!1}t.isReadable=z;function H(c){const b=c;return b?[b.on,b.pause,b.resume,b.destroy].every(S=>typeof S=="function"):!1}t.isReadableStream=H;function D(c){const b=c;return b?H(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}t.isReadableBufferedStream=D;function w(c,b){return new d(c,b)}t.newWriteableStream=w;class d{constructor(b,S){this.e=b,this.f=S,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(S=>this.d.push(S))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(S=>S(b))}h(b){this.c.error.length===0?(0,v.onUnexpectedError)(b):this.c.error.slice(0).forEach(S=>S(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,S){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(S),this.resume();break;case"end":this.c.end.push(S),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(S),this.a.flowing&&this.k();break}}removeListener(b,S){if(this.a.destroyed)return;let N;switch(b){case"data":N=this.c.data;break;case"end":N=this.c.end;break;case"error":N=this.c.error;break}if(N){const L=N.indexOf(S);L>=0&&N.splice(L,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const S=[...this.d];this.d.length=0,S.forEach(N=>N())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function m(c,b){const S=[];let N;for(;(N=c.read())!==null;)S.push(N);return b(S)}t.consumeReadable=m;function g(c,b,S){const N=[];let L;for(;(L=c.read())!==null&&N.length<S;)N.push(L);return L===null&&N.length>0?b(N):{read:()=>{if(N.length>0)return N.shift();if(typeof L<"u"){const T=L;return L=void 0,T}return c.read()}}}t.peekReadable=g;function I(c,b){return new Promise((S,N)=>{const L=[];o(c,{onData:T=>{b&&L.push(T)},onError:T=>{b?N(T):S(void 0)},onEnd:()=>{S(b?b(L):void 0)}})})}t.consumeStream=I;function o(c,b){let S=!1;return c.on("error",N=>{S||b.onError(N)}),c.on("end",()=>{S||b.onEnd()}),c.on("data",N=>{S||b.onData(N)}),(0,i.toDisposable)(()=>S=!0)}t.listenStream=o;function n(c,b){return new Promise((S,N)=>{const L=new i.DisposableStore,T=[],f=y=>{if(T.push(y),T.length>b)return L.dispose(),c.pause(),S({stream:c,buffer:T,ended:!1})},C=y=>N(y),p=()=>S({stream:c,buffer:T,ended:!0});L.add((0,i.toDisposable)(()=>c.removeListener("error",C))),c.on("error",C),L.add((0,i.toDisposable)(()=>c.removeListener("end",p))),c.on("end",p),L.add((0,i.toDisposable)(()=>c.removeListener("data",f))),c.on("data",f)})}t.peekStream=n;function e(c,b){const S=w(b);return S.end(c),S}t.toStream=e;function s(){const c=w(()=>{throw new Error("not supported")});return c.end(),c}t.emptyStream=s;function a(c){let b=!1;return{read:()=>b?null:(b=!0,c)}}t.toReadable=a;function l(c,b,S){const N=w(S);return o(c,{onData:L=>N.write(b.data(L)),onError:L=>N.error(b.error?b.error(L):L),onEnd:()=>N.end()}),N}t.transform=l;function h(c,b,S){let N=!1;return{read:()=>{const L=b.read();return N?L:(N=!0,L!==null?S([c,L]):c)}}}t.prefixedReadable=h;function r(c,b,S){let N=!1;const L=w(S);return o(b,{onData:T=>N?L.write(T):(N=!0,L.write(S([c,T]))),onError:T=>L.error(T),onEnd:()=>{N||(N=!0,L.write(c)),L.end()}}),L}t.prefixedStream=r}),define(me[29],be([1,0,80]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const i=typeof Buffer<"u";let z,H;class D{static alloc(y){return i?new D(Buffer.allocUnsafe(y)):new D(new Uint8Array(y))}static wrap(y){return i&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new D(y)}static fromString(y,_){return!(_?.dontUseNodeBuffer||!1)&&i?new D(Buffer.from(y)):(z||(z=new TextEncoder),new D(z.encode(y)))}static fromByteArray(y){const _=D.alloc(y.length);for(let V=0,ge=y.length;V<ge;V++)_.buffer[V]=y[V];return _}static concat(y,_){if(typeof _>"u"){_=0;for(let Q=0,ie=y.length;Q<ie;Q++)_+=y[Q].byteLength}const V=D.alloc(_);let ge=0;for(let Q=0,ie=y.length;Q<ie;Q++){const te=y[Q];V.set(te,ge),ge+=te.byteLength}return V}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=D.alloc(this.byteLength);return y.set(this),y}toString(){return i?this.buffer.toString():(H||(H=new TextDecoder),H.decode(this.buffer))}slice(y,_){return new D(this.buffer.subarray(y,_))}set(y,_){if(y instanceof D)this.buffer.set(y.buffer,_);else if(y instanceof Uint8Array)this.buffer.set(y,_);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),_);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),_);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return m(this.buffer,y)}writeUInt32BE(y,_){g(this.buffer,y,_)}readUInt32LE(y){return I(this.buffer,y)}writeUInt32LE(y,_){o(this.buffer,y,_)}readUInt8(y){return n(this.buffer,y)}writeUInt8(y,_){e(this.buffer,y,_)}}t.VSBuffer=D;function w(p,y){return p[y+0]<<0>>>0|p[y+1]<<8>>>0}t.readUInt16LE=w;function d(p,y,_){p[_+0]=y&255,y=y>>>8,p[_+1]=y&255}t.writeUInt16LE=d;function m(p,y){return p[y]*2**24+p[y+1]*2**16+p[y+2]*2**8+p[y+3]}t.readUInt32BE=m;function g(p,y,_){p[_+3]=y,y=y>>>8,p[_+2]=y,y=y>>>8,p[_+1]=y,y=y>>>8,p[_]=y}t.writeUInt32BE=g;function I(p,y){return p[y+0]<<0>>>0|p[y+1]<<8>>>0|p[y+2]<<16>>>0|p[y+3]<<24>>>0}t.readUInt32LE=I;function o(p,y,_){p[_+0]=y&255,y=y>>>8,p[_+1]=y&255,y=y>>>8,p[_+2]=y&255,y=y>>>8,p[_+3]=y&255}t.writeUInt32LE=o;function n(p,y){return p[y]}t.readUInt8=n;function e(p,y,_){p[_]=y}t.writeUInt8=e;function s(p){return v.consumeReadable(p,y=>D.concat(y))}t.readableToBuffer=s;function a(p){return v.toReadable(p)}t.bufferToReadable=a;function l(p){return v.consumeStream(p,y=>D.concat(y))}t.streamToBuffer=l;async function h(p){return p.ended?D.concat(p.buffer):D.concat([...p.buffer,await l(p.stream)])}t.bufferedStreamToBuffer=h;function r(p){return v.toStream(p,y=>D.concat(y))}t.bufferToStream=r;function c(p){return v.transform(p,{data:y=>typeof y=="string"?D.fromString(y):D.wrap(y)},y=>D.concat(y))}t.streamToBufferReadableStream=c;function b(p){return v.newWriteableStream(y=>D.concat(y),p)}t.newWriteableBufferStream=b;function S(p,y){return v.prefixedReadable(p,y,_=>D.concat(_))}t.prefixedBufferReadable=S;function N(p,y){return v.prefixedStream(p,y,_=>D.concat(_))}t.prefixedBufferStream=N;function L(p){let y=0,_=0,V=0;const ge=new Uint8Array(Math.floor(p.length/4*3)),Q=te=>{switch(_){case 3:ge[V++]=y|te,_=0;break;case 2:ge[V++]=y|te>>>2,y=te<<6,_=3;break;case 1:ge[V++]=y|te>>>4,y=te<<4,_=2;break;default:y=te<<2,_=1}};for(let te=0;te<p.length;te++){const ue=p.charCodeAt(te);if(ue>=65&&ue<=90)Q(ue-65);else if(ue>=97&&ue<=122)Q(ue-97+26);else if(ue>=48&&ue<=57)Q(ue-48+52);else if(ue===43||ue===45)Q(62);else if(ue===47||ue===95)Q(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${p[te]}`)}}const ie=V;for(;_>0;)Q(0);return D.wrap(ge).slice(0,ie)}t.decodeBase64=L;const T="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:p},y=!0,_=!1){const V=_?f:T;let ge="";const Q=p.byteLength%3;let ie=0;for(;ie<p.byteLength-Q;ie+=3){const te=p[ie+0],ue=p[ie+1],ae=p[ie+2];ge+=V[te>>>2],ge+=V[(te<<4|ue>>>4)&63],ge+=V[(ue<<2|ae>>>6)&63],ge+=V[ae&63]}if(Q===1){const te=p[ie+0];ge+=V[te>>>2],ge+=V[te<<4&63],y&&(ge+="==")}else if(Q===2){const te=p[ie+0],ue=p[ie+1];ge+=V[te>>>2],ge+=V[(te<<4|ue>>>4)&63],ge+=V[ue<<2&63],y&&(ge+="=")}return ge}t.encodeBase64=C}),define(me[6],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function v(N){return typeof N=="string"}t.isString=v;function i(N){return Array.isArray(N)&&N.every(L=>v(L))}t.isStringArray=i;function z(N){return typeof N=="object"&&N!==null&&!Array.isArray(N)&&!(N instanceof RegExp)&&!(N instanceof Date)}t.isObject=z;function H(N){const L=Object.getPrototypeOf(Uint8Array);return typeof N=="object"&&N instanceof L}t.isTypedArray=H;function D(N){return typeof N=="number"&&!isNaN(N)}t.isNumber=D;function w(N){return!!N&&typeof N[Symbol.iterator]=="function"}t.isIterable=w;function d(N){return N===!0||N===!1}t.isBoolean=d;function m(N){return typeof N>"u"}t.isUndefined=m;function g(N){return!I(N)}t.isDefined=g;function I(N){return m(N)||N===null}t.isUndefinedOrNull=I;function o(N,L){if(!N)throw new Error(L?`Unexpected type, expected '${L}'`:"Unexpected type")}t.assertType=o;function n(N){if(I(N))throw new Error("Assertion Failed: argument is undefined or null");return N}t.assertIsDefined=n;function e(...N){const L=[];for(let T=0;T<N.length;T++){const f=N[T];if(I(f))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);L.push(f)}return L}t.assertAllDefined=e;const s=Object.prototype.hasOwnProperty;function a(N){if(!z(N))return!1;for(const L in N)if(s.call(N,L))return!1;return!0}t.isEmptyObject=a;function l(N){return typeof N=="function"}t.isFunction=l;function h(...N){return N.length>0&&N.every(l)}t.areFunctions=h;function r(N,L){const T=Math.min(N.length,L.length);for(let f=0;f<T;f++)c(N[f],L[f])}t.validateConstraints=r;function c(N,L){if(v(L)){if(typeof N!==L)throw new Error(`argument does not match constraint: typeof ${L}`)}else if(l(L)){try{if(N instanceof L)return}catch{}if(!I(N)&&N.constructor===L||L.length===1&&L.call(void 0,N)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=c;function b(N){return N===null?void 0:N}t.withNullAsUndefined=b;function S(N){return typeof N>"u"?null:N}t.withUndefinedAsNull=S}),define(me[30],be([1,0,6]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function i(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const h=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([r,c])=>{h[r]=c&&typeof c=="object"?i(c):c}),h}t.deepClone=i;function z(l){if(!l||typeof l!="object")return l;const h=[l];for(;h.length>0;){const r=h.shift();Object.freeze(r);for(const c in r)if(H.call(r,c)){const b=r[c];typeof b=="object"&&!Object.isFrozen(b)&&!(0,v.isTypedArray)(b)&&h.push(b)}}return l}t.deepFreeze=z;const H=Object.prototype.hasOwnProperty;function D(l,h){return w(l,h,new Set)}t.cloneAndChange=D;function w(l,h,r){if((0,v.isUndefinedOrNull)(l))return l;const c=h(l);if(typeof c<"u")return c;if(Array.isArray(l)){const b=[];for(const S of l)b.push(w(S,h,r));return b}if((0,v.isObject)(l)){if(r.has(l))throw new Error("Cannot clone recursive data-structure");r.add(l);const b={};for(const S in l)H.call(l,S)&&(b[S]=w(l[S],h,r));return r.delete(l),b}return l}function d(l,h,r=!0){return(0,v.isObject)(l)?((0,v.isObject)(h)&&Object.keys(h).forEach(c=>{c in l?r&&((0,v.isObject)(l[c])&&(0,v.isObject)(h[c])?d(l[c],h[c],r):l[c]=h[c]):l[c]=h[c]}),l):h}t.mixin=d;function m(l,h){if(l===h)return!0;if(l==null||h===null||h===void 0||typeof l!=typeof h||typeof l!="object"||Array.isArray(l)!==Array.isArray(h))return!1;let r,c;if(Array.isArray(l)){if(l.length!==h.length)return!1;for(r=0;r<l.length;r++)if(!m(l[r],h[r]))return!1}else{const b=[];for(c in l)b.push(c);b.sort();const S=[];for(c in h)S.push(c);if(S.sort(),!m(b,S))return!1;for(r=0;r<b.length;r++)if(!m(l[b[r]],h[b[r]]))return!1}return!0}t.equals=m;function g(l){const h=new Set;return JSON.stringify(l,(r,c)=>{if((0,v.isObject)(c)||Array.isArray(c)){if(h.has(c))return"[Circular]";h.add(c)}return c})}t.safeStringify=g;function I(l,h){const r=Object.create(null);return!l||!h||Object.keys(h).forEach(b=>{const S=l[b],N=h[b];m(S,N)||(r[b]=N)}),r}t.distinct=I;function o(l,h){const r=h.toLowerCase(),c=Object.keys(l).find(b=>b.toLowerCase()===r);return c?l[c]:l[h]}t.getCaseInsensitive=o;function n(l,h){const r=Object.create(null);for(const[c,b]of Object.entries(l))h(c,b)&&(r[c]=b);return r}t.filter=n;function e(l){let h=[],r=Object.getPrototypeOf(l);for(;Object.prototype!==r;)h=h.concat(Object.getOwnPropertyNames(r)),r=Object.getPrototypeOf(r);return h}t.getAllPropertyNames=e;function s(l){const h=[];for(const r of e(l))typeof l[r]=="function"&&h.push(r);return h}t.getAllMethodNames=s;function a(l,h){const r=b=>function(){const S=Array.prototype.slice.call(arguments,0);return h(b,S)},c={};for(const b of l)c[b]=r(b);return c}t.createProxyObject=a}),define(me[81],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(me[82],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class v{constructor(z,H){this.a=z,this.onMessage=H}send(z){try{this.a.send("vscode:message",z.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.Protocol=v}),define(me[48],be([7]),{}),define(me[83],be([7]),{}),define(me[84],be([7]),{}),define(me[85],be([7]),{}),define(me[86],be([1,0,12,84,85]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.formatRule=void 0;function i(z){let H=z.definition;for(;H instanceof v.Codicon;)H=H.definition;return`.codicon-${z.id}:before { content: '${H.fontCharacter}'; }`}t.formatRule=i}),define(me[87],be([7]),{}),define(me[88],be([7]),{}),define(me[89],be([7]),{}),define(me[90],be([7]),{}),define(me[91],be([7]),{}),define(me[92],be([7]),{}),define(me[93],be([7]),{}),define(me[94],be([7]),{}),define(me[95],be([7]),{}),define(me[96],be([13,10]),function(Z,t){return Z.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(me[97],be([13,10]),function(Z,t){return Z.create("vs/base/browser/ui/findinput/findInput",t)}),define(me[98],be([13,10]),function(Z,t){return Z.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(me[99],be([13,10]),function(Z,t){return Z.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(me[100],be([13,10]),function(Z,t){return Z.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(me[101],be([13,10]),function(Z,t){return Z.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(me[102],be([13,10]),function(Z,t){return Z.create("vs/base/browser/ui/tree/abstractTree",t)}),define(me[103],be([13,10]),function(Z,t){return Z.create("vs/base/common/actions",t)}),define(me[104],be([13,10]),function(Z,t){return Z.create("vs/base/common/platform",t)}),define(me[5],be([1,0,104]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let i=!1,z=!1,H=!1,D=!1,w=!1,d=!1,m=!1,g=!1,I=!1,o=!1,n,e=t.LANGUAGE_DEFAULT,s,a;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?l=t.globals.vscode.process:typeof process<"u"&&(l=process);const h=typeof l?.versions?.electron=="string",r=h&&l?.type==="renderer";if(typeof navigator=="object"&&!r)a=navigator.userAgent,i=a.indexOf("Windows")>=0,z=a.indexOf("Macintosh")>=0,g=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,H=a.indexOf("Linux")>=0,o=a?.indexOf("Mobi")>=0,d=!0,n=v.getConfiguredDefaultLocale(v.localize(0,null))||t.LANGUAGE_DEFAULT,e=n;else if(typeof l=="object"){i=l.platform==="win32",z=l.platform==="darwin",H=l.platform==="linux",D=H&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,m=h,I=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,n=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const p=l.env.VSCODE_NLS_CONFIG;if(p)try{const y=JSON.parse(p),_=y.availableLanguages["*"];n=y.locale,e=_||t.LANGUAGE_DEFAULT,s=y._translationsConfigFile}catch{}w=!0}else console.error("Unable to resolve platform.");var c;(function(p){p[p.Web=0]="Web",p[p.Mac=1]="Mac",p[p.Linux=2]="Linux",p[p.Windows=3]="Windows"})(c=t.Platform||(t.Platform={}));function b(p){switch(p){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=b;let S=0;z?S=1:i?S=3:H&&(S=2),t.isWindows=i,t.isMacintosh=z,t.isLinux=H,t.isLinuxSnap=D,t.isNative=w,t.isElectron=m,t.isWeb=d,t.isWebWorker=d&&typeof t.globals.importScripts=="function",t.isIOS=g,t.isMobile=o,t.isCI=I,t.platform=S,t.userAgent=a,t.language=e;var N;(function(p){function y(){return t.language}p.value=y;function _(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}p.isDefaultVariant=_;function V(){return t.language==="en"}p.isDefault=V})(N=t.Language||(t.Language={})),t.locale=n,t.translationsConfigFile=s,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const p=[];t.globals.addEventListener("message",_=>{if(_.data&&_.data.vscodeScheduleAsyncWork)for(let V=0,ge=p.length;V<ge;V++){const Q=p[V];if(Q.id===_.data.vscodeScheduleAsyncWork){p.splice(V,1),Q.callback();return}}});let y=0;return _=>{const V=++y;p.push({id:V,callback:_}),t.globals.postMessage({vscodeScheduleAsyncWork:V},"*")}}return p=>setTimeout(p)})();var L;(function(p){p[p.Windows=1]="Windows",p[p.Macintosh=2]="Macintosh",p[p.Linux=3]="Linux"})(L=t.OperatingSystem||(t.OperatingSystem={})),t.OS=z||g?2:i?1:3;let T=!0,f=!1;function C(){if(!f){f=!0;const p=new Uint8Array(2);p[0]=1,p[1]=2,T=new Uint16Array(p.buffer)[0]===(2<<8)+1}return T}t.isLittleEndian=C,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),define(me[105],be([1,0,5]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let i;if(typeof v.globals.vscode<"u"&&typeof v.globals.vscode.process<"u"){const z=v.globals.vscode.process;i={get platform(){return z.platform},get arch(){return z.arch},get env(){return z.env},cwd(){return z.cwd()}}}else typeof process<"u"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=i.cwd,t.env=i.env,t.platform=i.platform,t.arch=i.arch}),define(me[21],be([1,0,105]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const i=65,z=97,H=90,D=122,w=46,d=47,m=92,g=58,I=63;class o extends Error{constructor(c,b,S){let N;typeof b=="string"&&b.indexOf("not ")===0?(N="must not be",b=b.replace(/^not /,"")):N="must be";const L=c.indexOf(".")!==-1?"property":"argument";let T=`The "${c}" ${L} ${N} of type ${b}`;T+=`. Received type ${typeof S}`,super(T),this.code="ERR_INVALID_ARG_TYPE"}}function n(r,c){if(typeof r!="string")throw new o(c,"string",r)}function e(r){return r===d||r===m}function s(r){return r===d}function a(r){return r>=i&&r<=H||r>=z&&r<=D}function l(r,c,b,S){let N="",L=0,T=-1,f=0,C=0;for(let p=0;p<=r.length;++p){if(p<r.length)C=r.charCodeAt(p);else{if(S(C))break;C=d}if(S(C)){if(!(T===p-1||f===1))if(f===2){if(N.length<2||L!==2||N.charCodeAt(N.length-1)!==w||N.charCodeAt(N.length-2)!==w){if(N.length>2){const y=N.lastIndexOf(b);y===-1?(N="",L=0):(N=N.slice(0,y),L=N.length-1-N.lastIndexOf(b)),T=p,f=0;continue}else if(N.length!==0){N="",L=0,T=p,f=0;continue}}c&&(N+=N.length>0?`${b}..`:"..",L=2)}else N.length>0?N+=`${b}${r.slice(T+1,p)}`:N=r.slice(T+1,p),L=p-T-1;T=p,f=0}else C===w&&f!==-1?++f:f=-1}return N}function h(r,c){if(c===null||typeof c!="object")throw new o("pathObject","Object",c);const b=c.dir||c.root,S=c.base||`${c.name||""}${c.ext||""}`;return b?b===c.root?`${b}${S}`:`${b}${r}${S}`:S}t.win32={resolve(...r){let c="",b="",S=!1;for(let N=r.length-1;N>=-1;N--){let L;if(N>=0){if(L=r[N],n(L,"path"),L.length===0)continue}else c.length===0?L=v.cwd():(L=v.env[`=${c}`]||v.cwd(),(L===void 0||L.slice(0,2).toLowerCase()!==c.toLowerCase()&&L.charCodeAt(2)===m)&&(L=`${c}\\`));const T=L.length;let f=0,C="",p=!1;const y=L.charCodeAt(0);if(T===1)e(y)&&(f=1,p=!0);else if(e(y))if(p=!0,e(L.charCodeAt(1))){let _=2,V=_;for(;_<T&&!e(L.charCodeAt(_));)_++;if(_<T&&_!==V){const ge=L.slice(V,_);for(V=_;_<T&&e(L.charCodeAt(_));)_++;if(_<T&&_!==V){for(V=_;_<T&&!e(L.charCodeAt(_));)_++;(_===T||_!==V)&&(C=`\\\\${ge}\\${L.slice(V,_)}`,f=_)}}}else f=1;else a(y)&&L.charCodeAt(1)===g&&(C=L.slice(0,2),f=2,T>2&&e(L.charCodeAt(2))&&(p=!0,f=3));if(C.length>0)if(c.length>0){if(C.toLowerCase()!==c.toLowerCase())continue}else c=C;if(S){if(c.length>0)break}else if(b=`${L.slice(f)}\\${b}`,S=p,p&&c.length>0)break}return b=l(b,!S,"\\",e),S?`${c}\\${b}`:`${c}${b}`||"."},normalize(r){n(r,"path");const c=r.length;if(c===0)return".";let b=0,S,N=!1;const L=r.charCodeAt(0);if(c===1)return s(L)?"\\":r;if(e(L))if(N=!0,e(r.charCodeAt(1))){let f=2,C=f;for(;f<c&&!e(r.charCodeAt(f));)f++;if(f<c&&f!==C){const p=r.slice(C,f);for(C=f;f<c&&e(r.charCodeAt(f));)f++;if(f<c&&f!==C){for(C=f;f<c&&!e(r.charCodeAt(f));)f++;if(f===c)return`\\\\${p}\\${r.slice(C)}\\`;f!==C&&(S=`\\\\${p}\\${r.slice(C,f)}`,b=f)}}}else b=1;else a(L)&&r.charCodeAt(1)===g&&(S=r.slice(0,2),b=2,c>2&&e(r.charCodeAt(2))&&(N=!0,b=3));let T=b<c?l(r.slice(b),!N,"\\",e):"";return T.length===0&&!N&&(T="."),T.length>0&&e(r.charCodeAt(c-1))&&(T+="\\"),S===void 0?N?`\\${T}`:T:N?`${S}\\${T}`:`${S}${T}`},isAbsolute(r){n(r,"path");const c=r.length;if(c===0)return!1;const b=r.charCodeAt(0);return e(b)||c>2&&a(b)&&r.charCodeAt(1)===g&&e(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let c,b;for(let L=0;L<r.length;++L){const T=r[L];n(T,"path"),T.length>0&&(c===void 0?c=b=T:c+=`\\${T}`)}if(c===void 0)return".";let S=!0,N=0;if(typeof b=="string"&&e(b.charCodeAt(0))){++N;const L=b.length;L>1&&e(b.charCodeAt(1))&&(++N,L>2&&(e(b.charCodeAt(2))?++N:S=!1))}if(S){for(;N<c.length&&e(c.charCodeAt(N));)N++;N>=2&&(c=`\\${c.slice(N)}`)}return t.win32.normalize(c)},relative(r,c){if(n(r,"from"),n(c,"to"),r===c)return"";const b=t.win32.resolve(r),S=t.win32.resolve(c);if(b===S||(r=b.toLowerCase(),c=S.toLowerCase(),r===c))return"";let N=0;for(;N<r.length&&r.charCodeAt(N)===m;)N++;let L=r.length;for(;L-1>N&&r.charCodeAt(L-1)===m;)L--;const T=L-N;let f=0;for(;f<c.length&&c.charCodeAt(f)===m;)f++;let C=c.length;for(;C-1>f&&c.charCodeAt(C-1)===m;)C--;const p=C-f,y=T<p?T:p;let _=-1,V=0;for(;V<y;V++){const Q=r.charCodeAt(N+V);if(Q!==c.charCodeAt(f+V))break;Q===m&&(_=V)}if(V!==y){if(_===-1)return S}else{if(p>y){if(c.charCodeAt(f+V)===m)return S.slice(f+V+1);if(V===2)return S.slice(f+V)}T>y&&(r.charCodeAt(N+V)===m?_=V:V===2&&(_=3)),_===-1&&(_=0)}let ge="";for(V=N+_+1;V<=L;++V)(V===L||r.charCodeAt(V)===m)&&(ge+=ge.length===0?"..":"\\..");return f+=_,ge.length>0?`${ge}${S.slice(f,C)}`:(S.charCodeAt(f)===m&&++f,S.slice(f,C))},toNamespacedPath(r){if(typeof r!="string")return r;if(r.length===0)return"";const c=t.win32.resolve(r);if(c.length<=2)return r;if(c.charCodeAt(0)===m){if(c.charCodeAt(1)===m){const b=c.charCodeAt(2);if(b!==I&&b!==w)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(a(c.charCodeAt(0))&&c.charCodeAt(1)===g&&c.charCodeAt(2)===m)return`\\\\?\\${c}`;return r},dirname(r){n(r,"path");const c=r.length;if(c===0)return".";let b=-1,S=0;const N=r.charCodeAt(0);if(c===1)return e(N)?r:".";if(e(N)){if(b=S=1,e(r.charCodeAt(1))){let f=2,C=f;for(;f<c&&!e(r.charCodeAt(f));)f++;if(f<c&&f!==C){for(C=f;f<c&&e(r.charCodeAt(f));)f++;if(f<c&&f!==C){for(C=f;f<c&&!e(r.charCodeAt(f));)f++;if(f===c)return r;f!==C&&(b=S=f+1)}}}}else a(N)&&r.charCodeAt(1)===g&&(b=c>2&&e(r.charCodeAt(2))?3:2,S=b);let L=-1,T=!0;for(let f=c-1;f>=S;--f)if(e(r.charCodeAt(f))){if(!T){L=f;break}}else T=!1;if(L===-1){if(b===-1)return".";L=b}return r.slice(0,L)},basename(r,c){c!==void 0&&n(c,"ext"),n(r,"path");let b=0,S=-1,N=!0,L;if(r.length>=2&&a(r.charCodeAt(0))&&r.charCodeAt(1)===g&&(b=2),c!==void 0&&c.length>0&&c.length<=r.length){if(c===r)return"";let T=c.length-1,f=-1;for(L=r.length-1;L>=b;--L){const C=r.charCodeAt(L);if(e(C)){if(!N){b=L+1;break}}else f===-1&&(N=!1,f=L+1),T>=0&&(C===c.charCodeAt(T)?--T===-1&&(S=L):(T=-1,S=f))}return b===S?S=f:S===-1&&(S=r.length),r.slice(b,S)}for(L=r.length-1;L>=b;--L)if(e(r.charCodeAt(L))){if(!N){b=L+1;break}}else S===-1&&(N=!1,S=L+1);return S===-1?"":r.slice(b,S)},extname(r){n(r,"path");let c=0,b=-1,S=0,N=-1,L=!0,T=0;r.length>=2&&r.charCodeAt(1)===g&&a(r.charCodeAt(0))&&(c=S=2);for(let f=r.length-1;f>=c;--f){const C=r.charCodeAt(f);if(e(C)){if(!L){S=f+1;break}continue}N===-1&&(L=!1,N=f+1),C===w?b===-1?b=f:T!==1&&(T=1):b!==-1&&(T=-1)}return b===-1||N===-1||T===0||T===1&&b===N-1&&b===S+1?"":r.slice(b,N)},format:h.bind(null,"\\"),parse(r){n(r,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return c;const b=r.length;let S=0,N=r.charCodeAt(0);if(b===1)return e(N)?(c.root=c.dir=r,c):(c.base=c.name=r,c);if(e(N)){if(S=1,e(r.charCodeAt(1))){let _=2,V=_;for(;_<b&&!e(r.charCodeAt(_));)_++;if(_<b&&_!==V){for(V=_;_<b&&e(r.charCodeAt(_));)_++;if(_<b&&_!==V){for(V=_;_<b&&!e(r.charCodeAt(_));)_++;_===b?S=_:_!==V&&(S=_+1)}}}}else if(a(N)&&r.charCodeAt(1)===g){if(b<=2)return c.root=c.dir=r,c;if(S=2,e(r.charCodeAt(2))){if(b===3)return c.root=c.dir=r,c;S=3}}S>0&&(c.root=r.slice(0,S));let L=-1,T=S,f=-1,C=!0,p=r.length-1,y=0;for(;p>=S;--p){if(N=r.charCodeAt(p),e(N)){if(!C){T=p+1;break}continue}f===-1&&(C=!1,f=p+1),N===w?L===-1?L=p:y!==1&&(y=1):L!==-1&&(y=-1)}return f!==-1&&(L===-1||y===0||y===1&&L===f-1&&L===T+1?c.base=c.name=r.slice(T,f):(c.name=r.slice(T,L),c.base=r.slice(T,f),c.ext=r.slice(L,f))),T>0&&T!==S?c.dir=r.slice(0,T-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...r){let c="",b=!1;for(let S=r.length-1;S>=-1&&!b;S--){const N=S>=0?r[S]:v.cwd();n(N,"path"),N.length!==0&&(c=`${N}/${c}`,b=N.charCodeAt(0)===d)}return c=l(c,!b,"/",s),b?`/${c}`:c.length>0?c:"."},normalize(r){if(n(r,"path"),r.length===0)return".";const c=r.charCodeAt(0)===d,b=r.charCodeAt(r.length-1)===d;return r=l(r,!c,"/",s),r.length===0?c?"/":b?"./":".":(b&&(r+="/"),c?`/${r}`:r)},isAbsolute(r){return n(r,"path"),r.length>0&&r.charCodeAt(0)===d},join(...r){if(r.length===0)return".";let c;for(let b=0;b<r.length;++b){const S=r[b];n(S,"path"),S.length>0&&(c===void 0?c=S:c+=`/${S}`)}return c===void 0?".":t.posix.normalize(c)},relative(r,c){if(n(r,"from"),n(c,"to"),r===c||(r=t.posix.resolve(r),c=t.posix.resolve(c),r===c))return"";const b=1,S=r.length,N=S-b,L=1,T=c.length-L,f=N<T?N:T;let C=-1,p=0;for(;p<f;p++){const _=r.charCodeAt(b+p);if(_!==c.charCodeAt(L+p))break;_===d&&(C=p)}if(p===f)if(T>f){if(c.charCodeAt(L+p)===d)return c.slice(L+p+1);if(p===0)return c.slice(L+p)}else N>f&&(r.charCodeAt(b+p)===d?C=p:p===0&&(C=0));let y="";for(p=b+C+1;p<=S;++p)(p===S||r.charCodeAt(p)===d)&&(y+=y.length===0?"..":"/..");return`${y}${c.slice(L+C)}`},toNamespacedPath(r){return r},dirname(r){if(n(r,"path"),r.length===0)return".";const c=r.charCodeAt(0)===d;let b=-1,S=!0;for(let N=r.length-1;N>=1;--N)if(r.charCodeAt(N)===d){if(!S){b=N;break}}else S=!1;return b===-1?c?"/":".":c&&b===1?"//":r.slice(0,b)},basename(r,c){c!==void 0&&n(c,"ext"),n(r,"path");let b=0,S=-1,N=!0,L;if(c!==void 0&&c.length>0&&c.length<=r.length){if(c===r)return"";let T=c.length-1,f=-1;for(L=r.length-1;L>=0;--L){const C=r.charCodeAt(L);if(C===d){if(!N){b=L+1;break}}else f===-1&&(N=!1,f=L+1),T>=0&&(C===c.charCodeAt(T)?--T===-1&&(S=L):(T=-1,S=f))}return b===S?S=f:S===-1&&(S=r.length),r.slice(b,S)}for(L=r.length-1;L>=0;--L)if(r.charCodeAt(L)===d){if(!N){b=L+1;break}}else S===-1&&(N=!1,S=L+1);return S===-1?"":r.slice(b,S)},extname(r){n(r,"path");let c=-1,b=0,S=-1,N=!0,L=0;for(let T=r.length-1;T>=0;--T){const f=r.charCodeAt(T);if(f===d){if(!N){b=T+1;break}continue}S===-1&&(N=!1,S=T+1),f===w?c===-1?c=T:L!==1&&(L=1):c!==-1&&(L=-1)}return c===-1||S===-1||L===0||L===1&&c===S-1&&c===b+1?"":r.slice(c,S)},format:h.bind(null,"/"),parse(r){n(r,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return c;const b=r.charCodeAt(0)===d;let S;b?(c.root="/",S=1):S=0;let N=-1,L=0,T=-1,f=!0,C=r.length-1,p=0;for(;C>=S;--C){const y=r.charCodeAt(C);if(y===d){if(!f){L=C+1;break}continue}T===-1&&(f=!1,T=C+1),y===w?N===-1?N=C:p!==1&&(p=1):N!==-1&&(p=-1)}if(T!==-1){const y=L===0&&b?1:L;N===-1||p===0||p===1&&N===T-1&&N===L+1?c.base=c.name=r.slice(y,T):(c.name=r.slice(y,N),c.base=r.slice(y,T),c.ext=r.slice(N,T))}return L>0?c.dir=r.slice(0,L-1):b&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=v.platform==="win32"?t.win32.normalize:t.posix.normalize,t.isAbsolute=v.platform==="win32"?t.win32.isAbsolute:t.posix.isAbsolute,t.join=v.platform==="win32"?t.win32.join:t.posix.join,t.resolve=v.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=v.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=v.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=v.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=v.platform==="win32"?t.win32.extname:t.posix.extname,t.format=v.platform==="win32"?t.win32.format:t.posix.format,t.parse=v.platform==="win32"?t.win32.parse:t.posix.parse,t.toNamespacedPath=v.platform==="win32"?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=v.platform==="win32"?t.win32.sep:t.posix.sep,t.delimiter=v.platform==="win32"?t.win32.delimiter:t.posix.delimiter}),define(me[106],be([1,0,21]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeMimeType=t.getExtensionForMimeType=t.getMediaMime=t.getMediaOrTextMime=t.Mimes=void 0,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},z={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function H(g){const I=(0,v.extname)(g),o=i[I.toLowerCase()];return o!==void 0?o:D(g)}t.getMediaOrTextMime=H;function D(g){const I=(0,v.extname)(g);return z[I.toLowerCase()]}t.getMediaMime=D;function w(g){for(const I in z)if(z[I]===g)return I}t.getExtensionForMimeType=w;const d=/^(.+)\/(.+?)(;.+)?$/;function m(g,I){const o=d.exec(g);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:I?void 0:g}t.normalizeMimeType=m}),define(me[107],be([1,0,5]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const i=v.globals.performance&&typeof v.globals.performance.now=="function";class z{static create(D=!0){return new z(D)}constructor(D){this.a=i&&D,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?v.globals.performance.now():Date.now()}}t.StopWatch=z}),define(me[3],be([1,0,9,42,2,45,107]),function(Z,t,v,i,z,H,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const w=!1,d=!1;var m;(function(C){C.None=()=>z.Disposable.None;function p(W){if(d){const{onDidAddListener:$}=W,Y=e.create();let F=0;W.onDidAddListener=()=>{++F===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),$?.()}}}function y(W,$){return de(W,()=>{},0,void 0,void 0,$)}C.defer=y;function _(W){return($,Y=null,F)=>{let O=!1,U;return U=W(k=>{if(!O)return U?U.dispose():O=!0,$.call(Y,k)},null,F),O&&U.dispose(),U}}C.once=_;function V(W,$,Y){return ae((F,O=null,U)=>W(k=>F.call(O,$(k)),null,U),Y)}C.map=V;function ge(W,$,Y){return ae((F,O=null,U)=>W(k=>{$(k),F.call(O,k)},null,U),Y)}C.forEach=ge;function Q(W,$,Y){return ae((F,O=null,U)=>W(k=>$(k)&&F.call(O,k),null,U),Y)}C.filter=Q;function ie(W){return W}C.signal=ie;function te(...W){return($,Y=null,F)=>(0,z.combinedDisposable)(...W.map(O=>O(U=>$.call(Y,U),null,F)))}C.any=te;function ue(W,$,Y,F){let O=Y;return V(W,U=>(O=$(O,U),O),F)}C.reduce=ue;function ae(W,$){let Y;const F={onWillAddFirstListener(){Y=W(O.fire,O)},onDidRemoveLastListener(){Y?.dispose()}};$||p(F);const O=new a(F);return $?.add(O),O.event}function de(W,$,Y=100,F=!1,O,U){let k,M,P,R=0;const j={leakWarningThreshold:O,onWillAddFirstListener(){k=W(he=>{R++,M=$(M,he),F&&!P&&(J.fire(M),M=void 0),clearTimeout(P),P=setTimeout(()=>{const ce=M;M=void 0,P=void 0,(!F||R>1)&&J.fire(ce),R=0},Y)})},onDidRemoveLastListener(){k.dispose()}};U||p(j);const J=new a(j);return U?.add(J),J.event}C.debounce=de;function Ae(W,$=0,Y){return C.debounce(W,(F,O)=>F?(F.push(O),F):[O],$,void 0,void 0,Y)}C.accumulate=Ae;function x(W,$=(F,O)=>F===O,Y){let F=!0,O;return Q(W,U=>{const k=F||!$(U,O);return F=!1,O=U,k},Y)}C.latch=x;function ve(W,$,Y){return[C.filter(W,$,Y),C.filter(W,F=>!$(F),Y)]}C.split=ve;function Ne(W,$=!1,Y=[]){let F=Y.slice(),O=W(M=>{F?F.push(M):k.fire(M)});const U=()=>{F?.forEach(M=>k.fire(M)),F=null},k=new a({onWillAddFirstListener(){O||(O=W(M=>k.fire(M)))},onDidAddFirstListener(){F&&($?setTimeout(U):U())},onDidRemoveLastListener(){O&&O.dispose(),O=null}});return k.event}C.buffer=Ne;class oe{constructor($){this.event=$,this.c=new z.DisposableStore}map($){return new oe(V(this.event,$,this.c))}forEach($){return new oe(ge(this.event,$,this.c))}filter($){return new oe(Q(this.event,$,this.c))}reduce($,Y){return new oe(ue(this.event,$,Y,this.c))}latch(){return new oe(x(this.event,void 0,this.c))}debounce($,Y=100,F=!1,O){return new oe(de(this.event,$,Y,F,O,this.c))}on($,Y,F){return this.event($,Y,F)}once($,Y,F){return _(this.event)($,Y,F)}dispose(){this.c.dispose()}}function X(W){return new oe(W)}C.chain=X;function se(W,$,Y=F=>F){const F=(...M)=>k.fire(Y(...M)),O=()=>W.on($,F),U=()=>W.removeListener($,F),k=new a({onWillAddFirstListener:O,onDidRemoveLastListener:U});return k.event}C.fromNodeEventEmitter=se;function ne(W,$,Y=F=>F){const F=(...M)=>k.fire(Y(...M)),O=()=>W.addEventListener($,F),U=()=>W.removeEventListener($,F),k=new a({onWillAddFirstListener:O,onDidRemoveLastListener:U});return k.event}C.fromDOMEventEmitter=ne;function ee(W){return new Promise($=>_(W)($))}C.toPromise=ee;function A(W,$){return $(void 0),W(Y=>$(Y))}C.runAndSubscribe=A;function E(W,$){let Y=null;function F(U){Y?.dispose(),Y=new z.DisposableStore,$(U,Y)}F(void 0);const O=W(U=>F(U));return(0,z.toDisposable)(()=>{O.dispose(),Y?.dispose()})}C.runAndSubscribeWithStore=E;class u{constructor($,Y){this.obs=$,this.c=0,this.d=!1;const F={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};Y||p(F),this.emitter=new a(F),Y&&Y.add(this.emitter)}beginUpdate($){this.c++}handleChange($,Y){this.d=!0}endUpdate($){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function B(W,$){return new u(W,$).emitter.event}C.fromObservable=B})(m=t.Event||(t.Event={}));class g{constructor(p){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${p}_${g.c++}`,g.all.add(this)}start(p){this.d=new D.StopWatch(!0),this.listenerCount=p}stop(){if(this.d){const p=this.d.elapsed();this.durations.push(p),this.elapsedOverall+=p,this.invocationCount+=1,this.d=void 0}}}t.EventProfiling=g,g.all=new Set,g.c=0;let I=-1;function o(C){const p=I;return I=C,{dispose(){I=p}}}t.setGlobalLeakWarningThreshold=o;class n{constructor(p,y=Math.random().toString(18).slice(2,5)){this.threshold=p,this.name=y,this.d=0}dispose(){this.c?.clear()}check(p,y){const _=this.threshold;if(_<=0||y<_)return;this.c||(this.c=new Map);const V=this.c.get(p.value)||0;if(this.c.set(p.value,V+1),this.d-=1,this.d<=0){this.d=_*.5;let ge,Q=0;for(const[ie,te]of this.c)(!ge||Q<te)&&(ge=ie,Q=te);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${Q}):`),console.warn(ge)}return()=>{const ge=this.c.get(p.value)||0;this.c.set(p.value,ge-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(p){this.value=p}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class s{constructor(p,y,_){this.callback=p,this.callbackThis=y,this.stack=_,this.subscription=new z.SafeDisposable}invoke(p){this.callback.call(this.callbackThis,p)}}class a{constructor(p){this.j=!1,this.d=p,this.f=I>0||this.d?.leakWarningThreshold?new n(this.d?.leakWarningThreshold??I):void 0,this.g=this.d?._profName?new g(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(w){const p=Array.from(this.q);queueMicrotask(()=>{for(const y of p)y.subscription.isset()&&(y.subscription.unset(),y.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(p,y,_)=>{if(this.q||(this.q=new H.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),z.Disposable.None;const V=this.q.isEmpty();V&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let ge,Q;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(Q=e.create(),ge=this.f.check(Q,this.q.size+1)),w&&(Q=Q??e.create());const ie=new s(p,y,Q),te=this.q.push(ie);V&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,p,y);const ue=ie.subscription.set(()=>{ge?.(),this.j||(te(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return _ instanceof z.DisposableStore?_.add(ue):Array.isArray(_)&&_.push(ue),ue}),this.l}fire(p){if(this.q){this.m||(this.m=new h);for(const y of this.q)this.m.push(this,y,p);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}t.Emitter=a;class l{constructor(){this.c=new H.LinkedList}get size(){return this.c.size}push(p,y,_){this.c.push(new r(p,y,_))}clear(p){const y=new H.LinkedList;for(const _ of this.c)_.emitter!==p&&y.push(_);this.c=y}deliver(){for(;this.c.size>0;){const p=this.c.shift();try{p.listener.invoke(p.event)}catch(y){(0,v.onUnexpectedError)(y)}}}}t.EventDeliveryQueue=l;class h extends l{clear(p){this.c.clear()}}class r{constructor(p,y,_){this.emitter=p,this.listener=y,this.event=_}}class c extends a{async fireAsync(p,y,_){if(!!this.q){this.c||(this.c=new H.LinkedList);for(const V of this.q)this.c.push([V,p]);for(;this.c.size>0&&!y.isCancellationRequested;){const[V,ge]=this.c.shift(),Q=[],ie={...ge,token:y,waitUntil:te=>{if(Object.isFrozen(Q))throw new Error("waitUntil can NOT be called asynchronous");_&&(te=_(te,V.callback)),Q.push(te)}};try{V.invoke(ie)}catch(te){(0,v.onUnexpectedError)(te);continue}Object.freeze(Q),await Promise.allSettled(Q).then(te=>{for(const ue of te)ue.status==="rejected"&&(0,v.onUnexpectedError)(ue.reason)})}}}}t.AsyncEmitter=c;class b extends a{constructor(p){super(p),this.h=0,this.s=new H.LinkedList,this.t=p?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const p=Array.from(this.s);this.s.clear(),super.fire(this.t(p))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(p){this.q&&(this.h!==0?this.s.push(p):super.fire(p))}}t.PauseableEmitter=b;class S extends b{constructor(p){super(p),this.c=p.delay??100}fire(p){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(p)}}t.DebounceEmitter=S;class N extends a{constructor(p){super(p),this.c=[],this.h=p?.merge}fire(p){!this.hasListeners()||(this.c.push(p),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(y=>super.fire(y)),this.c=[]}))}}t.MicrotaskEmitter=N;class L{constructor(){this.d=!1,this.f=[],this.c=new a({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(p){const y={event:p,listener:null};this.f.push(y),this.d&&this.j(y);const _=()=>{this.d&&this.k(y);const V=this.f.indexOf(y);this.f.splice(V,1)};return(0,z.toDisposable)((0,i.once)(_))}g(){this.d=!0,this.f.forEach(p=>this.j(p))}h(){this.d=!1,this.f.forEach(p=>this.k(p))}j(p){p.listener=p.event(y=>this.c.fire(y))}k(p){p.listener&&p.listener.dispose(),p.listener=null}dispose(){this.c.dispose()}}t.EventMultiplexer=L;class T{constructor(){this.c=[]}wrapEvent(p){return(y,_,V)=>p(ge=>{const Q=this.c[this.c.length-1];Q?Q.push(()=>y.call(_,ge)):y.call(_,ge)},void 0,V)}bufferEvents(p){const y=[];this.c.push(y);const _=p();return this.c.pop(),y.forEach(V=>V()),_}}t.EventBufferer=T;class f{constructor(){this.c=!1,this.d=m.None,this.f=z.Disposable.None,this.g=new a({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(p){this.d=p,this.c&&(this.f.dispose(),this.f=p(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}t.Relay=f}),define(me[16],be([1,0,3,2]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isWCOEnabled=t.isStandalone=t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.isFullscreen=t.setFullscreen=t.setZoomFactor=t.getZoomFactor=t.getZoomLevel=t.setZoomLevel=t.PixelRatio=t.addMatchMediaChangeListener=void 0;class z{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new v.Emitter,this.onDidChangeFullscreen=this.d.event}getZoomLevel(){return this.a}setZoomLevel(c,b){this.a!==c&&(this.a=c)}getZoomFactor(){return this.b}setZoomFactor(c){this.b=c}setFullscreen(c){this.c!==c&&(this.c=c,this.d.fire())}isFullscreen(){return this.c}}z.INSTANCE=new z;class H extends i.Disposable{constructor(){super(),this.a=this.B(new v.Emitter),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(c){this.c?.removeEventListener("change",this.b),this.c=matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),c&&this.a.fire()}}class D extends i.Disposable{get value(){return this.b}constructor(){super(),this.a=this.B(new v.Emitter),this.onDidChange=this.a.event,this.b=this.c();const c=this.B(new H);this.B(c.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const c=document.createElement("canvas").getContext("2d"),b=window.devicePixelRatio||1,S=c.webkitBackingStorePixelRatio||c.mozBackingStorePixelRatio||c.msBackingStorePixelRatio||c.oBackingStorePixelRatio||c.backingStorePixelRatio||1;return b/S}}class w{constructor(){this.a=null}b(){return this.a||(this.a=(0,i.markAsSingleton)(new D)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function d(r,c){typeof r=="string"&&(r=window.matchMedia(r)),r.addEventListener("change",c)}t.addMatchMediaChangeListener=d,t.PixelRatio=new w;function m(r,c){z.INSTANCE.setZoomLevel(r,c)}t.setZoomLevel=m;function g(){return z.INSTANCE.getZoomLevel()}t.getZoomLevel=g;function I(){return z.INSTANCE.getZoomFactor()}t.getZoomFactor=I;function o(r){z.INSTANCE.setZoomFactor(r)}t.setZoomFactor=o;function n(r){z.INSTANCE.setFullscreen(r)}t.setFullscreen=n;function e(){return z.INSTANCE.isFullscreen()}t.isFullscreen=e,t.onDidChangeFullscreen=z.INSTANCE.onDidChangeFullscreen;const s=navigator.userAgent;t.isFirefox=s.indexOf("Firefox")>=0,t.isWebKit=s.indexOf("AppleWebKit")>=0,t.isChrome=s.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&s.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=s.indexOf("Electron/")>=0,t.isAndroid=s.indexOf("Android")>=0;let a=!1;if(window.matchMedia){const r=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),c=window.matchMedia("(display-mode: fullscreen)");a=r.matches,d(r,({matches:b})=>{a&&c.matches||(a=b)})}function l(){return a}t.isStandalone=l;function h(){return navigator?.windowControlsOverlay?.visible}t.isWCOEnabled=h}),define(me[108],be([1,0,16,5]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var z;(function(H){H[H.Always=0]="Always",H[H.FullScreen=1]="FullScreen",H[H.None=2]="None"})(z=t.KeyboardSupport||(t.KeyboardSupport={})),t.BrowserFeatures={clipboard:{writeText:i.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:i.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>i.isNative||v.isStandalone()?0:navigator.keyboard||v.isSafari?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(me[19],be([1,0,3]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomEmitter=void 0;class i{get event(){return this.a.event}constructor(H,D,w){const d=m=>this.a.fire(m);this.a=new v.Emitter({onWillAddFirstListener:()=>H.addEventListener(D,d,w),onDidRemoveLastListener:()=>H.removeEventListener(D,d,w)})}dispose(){this.a.dispose()}}t.DomEmitter=i}),define(me[17],be([1,0,16,43,74,5]),function(Z,t,v,i,z,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=t.printStandardKeyboardEvent=t.printKeyboardEvent=void 0;function D(e){if(e.charCode){const a=String.fromCharCode(e.charCode).toUpperCase();return i.KeyCodeUtils.fromString(a)}const s=e.keyCode;if(s===3)return 7;if(v.isFirefox){if(s===59)return 80;if(s===107)return 81;if(s===109)return 83;if(H.isMacintosh&&s===224)return 57}else if(v.isWebKit){if(s===91)return 57;if(H.isMacintosh&&s===93)return 57;if(!H.isMacintosh&&s===92)return 57}return i.EVENT_KEY_CODE_MAP[s]||0}const w=H.isMacintosh?256:2048,d=512,m=1024,g=H.isMacintosh?2048:256;function I(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.printKeyboardEvent=I;function o(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${i.KeyCodeUtils.toString(e.keyCode)}')`}t.printStandardKeyboardEvent=o;class n{constructor(s){this._standardKeyboardEventBrand=!0;const a=s;this.browserEvent=a,this.target=a.target,this.ctrlKey=a.ctrlKey,this.shiftKey=a.shiftKey,this.altKey=a.altKey,this.metaKey=a.metaKey,this.altGraphKey=a.getModifierState("AltGraph"),this.keyCode=D(a),this.code=a.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeybinding(){return this.b}equals(s){return this.a===s}c(){let s=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode);let a=0;return this.ctrlKey&&(a|=w),this.altKey&&(a|=d),this.shiftKey&&(a|=m),this.metaKey&&(a|=g),a|=s,a}d(){let s=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode),new z.SimpleKeybinding(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}t.StandardKeyboardEvent=n}),define(me[20],be([1,0,16,67,5]),function(Z,t,v,i,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class H{constructor(m){this.timestamp=Date.now(),this.browserEvent=m,this.leftButton=m.button===0,this.middleButton=m.button===1,this.rightButton=m.button===2,this.buttons=m.buttons,this.target=m.target,this.detail=m.detail||1,m.type==="dblclick"&&(this.detail=2),this.ctrlKey=m.ctrlKey,this.shiftKey=m.shiftKey,this.altKey=m.altKey,this.metaKey=m.metaKey,typeof m.pageX=="number"?(this.posx=m.pageX,this.posy=m.pageY):(this.posx=m.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=m.clientY+document.body.scrollTop+document.documentElement.scrollTop);const g=i.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(self,m.view);this.posx-=g.left,this.posy-=g.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=H;class D extends H{constructor(m){super(m),this.dataTransfer=m.dataTransfer}}t.DragMouseEvent=D;class w{constructor(m,g=0,I=0){if(this.browserEvent=m||null,this.target=m?m.target||m.targetNode||m.srcElement:null,this.deltaY=I,this.deltaX=g,m){const o=m,n=m;if(typeof o.wheelDeltaY<"u")this.deltaY=o.wheelDeltaY/120;else if(typeof n.VERTICAL_AXIS<"u"&&n.axis===n.VERTICAL_AXIS)this.deltaY=-n.detail/3;else if(m.type==="wheel"){const e=m;e.deltaMode===e.DOM_DELTA_LINE?v.isFirefox&&!z.isMacintosh?this.deltaY=-m.deltaY/3:this.deltaY=-m.deltaY:this.deltaY=-m.deltaY/40}if(typeof o.wheelDeltaX<"u")v.isSafari&&z.isWindows?this.deltaX=-(o.wheelDeltaX/120):this.deltaX=o.wheelDeltaX/120;else if(typeof n.HORIZONTAL_AXIS<"u"&&n.axis===n.HORIZONTAL_AXIS)this.deltaX=-m.detail/3;else if(m.type==="wheel"){const e=m;e.deltaMode===e.DOM_DELTA_LINE?v.isFirefox&&!z.isMacintosh?this.deltaX=-m.deltaX/3:this.deltaX=-m.deltaX:this.deltaX=-m.deltaX/40}this.deltaY===0&&this.deltaX===0&&m.wheelDelta&&(this.deltaY=m.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=w}),define(me[31],be([1,0,3,2,103]),function(Z,t,v,i,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toAction=t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0;class H extends i.Disposable{constructor(o,n="",e="",s=!0,a){super(),this.h=this.B(new v.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=o,this.m=n,this.u=e,this.w=s,this.C=a}get id(){return this.j}get label(){return this.m}set label(o){this.D(o)}D(o){this.m!==o&&(this.m=o,this.h.fire({label:o}))}get tooltip(){return this.n||""}set tooltip(o){this.F(o)}F(o){this.n!==o&&(this.n=o,this.h.fire({tooltip:o}))}get class(){return this.u}set class(o){this.G(o)}G(o){this.u!==o&&(this.u=o,this.h.fire({class:o}))}get enabled(){return this.w}set enabled(o){this.H(o)}H(o){this.w!==o&&(this.w=o,this.h.fire({enabled:o}))}get checked(){return this.z}set checked(o){this.I(o)}I(o){this.z!==o&&(this.z=o,this.h.fire({checked:o}))}async run(o,n){this.C&&await this.C(o)}}t.Action=H;class D extends i.Disposable{constructor(){super(...arguments),this.f=this.B(new v.Emitter),this.onWillRun=this.f.event,this.h=this.B(new v.Emitter),this.onDidRun=this.h.event}async run(o,n){if(!o.enabled)return;this.f.fire({action:o});let e;try{await this.runAction(o,n)}catch(s){e=s}this.h.fire({action:o,error:e})}async runAction(o,n){await o.run(n)}}t.ActionRunner=D;class w{constructor(){this.id=w.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...o){let n=[];for(const e of o)e.length&&(n.length?n=[...n,new w,...e]:n=e);return n}async run(){}}t.Separator=w,w.ID="vs.actions.separator";class d{get actions(){return this.a}constructor(o,n,e,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=o,this.label=n,this.class=s,this.a=e}async run(){}}t.SubmenuAction=d;class m extends H{constructor(){super(m.ID,z.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=m,m.ID="vs.actions.empty";function g(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async()=>I.run(),tooltip:I.label}}t.toAction=g}),define(me[26],be([1,0,3]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const i=Object.freeze(function(w,d){const m=setTimeout(w.bind(d),0);return{dispose(){clearTimeout(m)}}});var z;(function(w){function d(m){return m===w.None||m===w.Cancelled||m instanceof H?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}w.isCancellationToken=d,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(z=t.CancellationToken||(t.CancellationToken={}));class H{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?i:(this.b||(this.b=new v.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(d){this.a=void 0,this.b=void 0,this.b=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new H),this.a}cancel(){this.a?this.a instanceof H&&this.a.cancel():this.a=z.Cancelled}dispose(d=!1){d&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof H&&this.a.dispose():this.a=z.None}}t.CancellationTokenSource=D}),define(me[109],be([1,0,26]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class i{constructor(w){this.b=w,this.a=null}get(){if(this.a)return this.a;const w=new v.CancellationTokenSource,d=this.b(w.token);return this.a={promise:d,dispose:()=>{this.a=null,w.cancel(),w.dispose()}},this.a}}t.Cache=i;class z{constructor(w){this.c=w,this.a=void 0,this.b=void 0}get(w){const d=JSON.stringify(w);return this.b!==d&&(this.b=d,this.a=this.c(w)),this.a}}t.LRUCachedFunction=z;class H{get cachedValues(){return this.a}constructor(w){this.b=w,this.a=new Map}get(w){if(this.a.has(w))return this.a.get(w);const d=this.b(w);return this.a.set(w,d),d}}t.CachedFunction=H}),define(me[49],be([1,0,3,2]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var z;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(z=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));class H{constructor(e,s,a,l,h,r,c){this.c=e,this._scrollStateBrand=void 0,this.c&&(s=s|0,a=a|0,l=l|0,h=h|0,r=r|0,c=c|0),this.rawScrollLeft=l,this.rawScrollTop=c,s<0&&(s=0),l+s>a&&(l=a-s),l<0&&(l=0),h<0&&(h=0),c+h>r&&(c=r-h),c<0&&(c=0),this.width=s,this.scrollWidth=a,this.scrollLeft=l,this.height=h,this.scrollHeight=r,this.scrollTop=c}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,s){return new H(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new H(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,s){const a=this.width!==e.width,l=this.scrollWidth!==e.scrollWidth,h=this.scrollLeft!==e.scrollLeft,r=this.height!==e.height,c=this.scrollHeight!==e.scrollHeight,b=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:s,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:a,scrollWidthChanged:l,scrollLeftChanged:h,heightChanged:r,scrollHeightChanged:c,scrollTopChanged:b}}}t.ScrollState=H;class D extends i.Disposable{constructor(e){super(),this._scrollableBrand=void 0,this.i=this.B(new v.Emitter),this.onScroll=this.i.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new H(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,s){const a=this.g.withScrollDimensions(e,s);this.k(a,Boolean(this.h)),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const s=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.k(s,!1)}setScrollPositionSmooth(e,s){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const a=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===a.scrollLeft&&this.h.to.scrollTop===a.scrollTop)return;let l;s?l=new g(this.h.from,a,this.h.startTime,this.h.duration):l=this.h.combine(this.g,a,this.c),this.h.dispose(),this.h=l}else{const a=this.g.withScrollPosition(e);this.h=g.start(this.g,a,this.c)}this.h.animationFrameDisposable=this.f(()=>{!this.h||(this.h.animationFrameDisposable=null,this.j())})}j(){if(!this.h)return;const e=this.h.tick(),s=this.g.withScrollPosition(e);if(this.k(s,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{!this.h||(this.h.animationFrameDisposable=null,this.j())})}}k(e,s){const a=this.g;a.equals(e)||(this.g=e,this.i.fire(this.g.createScrollEvent(a,s)))}}t.Scrollable=D;class w{constructor(e,s,a){this.scrollLeft=e,this.scrollTop=s,this.isDone=a}}t.SmoothScrollingUpdate=w;function d(n,e){const s=e-n;return function(a){return n+s*o(a)}}function m(n,e,s){return function(a){return a<s?n(a/s):e((a-s)/(1-s))}}class g{constructor(e,s,a,l){this.from=e,this.to=s,this.duration=l,this.startTime=a,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,s,a){if(Math.abs(e-s)>2.5*a){let h,r;return e<s?(h=e+.75*a,r=s-.75*a):(h=e-.75*a,r=s+.75*a),m(d(e,h),d(r,s),.33)}return d(e,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const s=(e-this.startTime)/this.duration;if(s<1){const a=this.c(s),l=this.d(s);return new w(a,l,!1)}return new w(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,s,a){return g.start(e,s,a)}static start(e,s,a){a=a+10;const l=Date.now()-10;return new g(e,s,l,a)}}t.SmoothScrollingOperation=g;function I(n){return Math.pow(n,3)}function o(n){return 1-I(1-n)}}),define(me[11],be([1,0,109,44]),function(Z,t,v,i){"use strict";var z;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function H(K){return!K||typeof K!="string"?!0:K.trim().length===0}t.isFalsyOrWhitespace=H;const D=/{(\d+)}/g;function w(K,...le){return le.length===0?K:K.replace(D,function(pe,Ee){const Fe=parseInt(Ee,10);return isNaN(Fe)||Fe<0||Fe>=le.length?pe:le[Fe]})}t.format=w;const d=/{([^}]+)}/g;function m(K,le){return K.replace(d,(pe,Ee)=>le[Ee]??pe)}t.format2=m;function g(K){return K.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}t.escape=g;function I(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=I;function o(K,le){let pe=0;const Ee=le.charCodeAt(0);for(let Fe=K.length-1;Fe>=0;Fe--)K.charCodeAt(Fe)===Ee&&pe++;return pe}t.count=o;function n(K,le,pe="\u2026"){return K.length<=le?K:`${K.substr(0,le)}${pe}`}t.truncate=n;function e(K,le=" "){const pe=s(K,le);return a(pe,le)}t.trim=e;function s(K,le){if(!K||!le)return K;const pe=le.length;if(pe===0||K.length===0)return K;let Ee=0;for(;K.indexOf(le,Ee)===Ee;)Ee=Ee+pe;return K.substring(Ee)}t.ltrim=s;function a(K,le){if(!K||!le)return K;const pe=le.length,Ee=K.length;if(pe===0||Ee===0)return K;let Fe=Ee,Oe=-1;for(;Oe=K.lastIndexOf(le,Fe-1),!(Oe===-1||Oe+pe!==Fe);){if(Oe===0)return"";Fe=Oe}return K.substring(0,Fe)}t.rtrim=a;function l(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=l;function h(K){return K.replace(/\*/g,"")}t.stripWildcards=h;function r(K,le,pe={}){if(!K)throw new Error("Cannot create regex from empty string");le||(K=I(K)),pe.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let Ee="";return pe.global&&(Ee+="g"),pe.matchCase||(Ee+="i"),pe.multiline&&(Ee+="m"),pe.unicode&&(Ee+="u"),new RegExp(K,Ee)}t.createRegExp=r;function c(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}t.regExpLeadsToEndlessLoop=c;function b(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=b;function S(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}t.regExpFlags=S;function N(K){return K.split(/\r\n|\r|\n/)}t.splitLines=N;function L(K){for(let le=0,pe=K.length;le<pe;le++){const Ee=K.charCodeAt(le);if(Ee!==32&&Ee!==9)return le}return-1}t.firstNonWhitespaceIndex=L;function T(K,le=0,pe=K.length){for(let Ee=le;Ee<pe;Ee++){const Fe=K.charCodeAt(Ee);if(Fe!==32&&Fe!==9)return K.substring(le,Ee)}return K.substring(le,pe)}t.getLeadingWhitespace=T;function f(K,le=K.length-1){for(let pe=le;pe>=0;pe--){const Ee=K.charCodeAt(pe);if(Ee!==32&&Ee!==9)return pe}return-1}t.lastNonWhitespaceIndex=f;function C(K,le,pe){const Ee=[];let Fe=0;for(const Oe of K.matchAll(le)){if(Ee.push(K.slice(Fe,Oe.index)),Oe.index===void 0)throw new Error("match.index should be defined");Fe=Oe.index+Oe[0].length,Ee.push(pe(Oe[0],...Oe.slice(1),Oe.index,K,Oe.groups))}return Ee.push(K.slice(Fe)),Promise.all(Ee).then(Oe=>Oe.join(""))}t.replaceAsync=C;function p(K,le){return K<le?-1:K>le?1:0}t.compare=p;function y(K,le,pe=0,Ee=K.length,Fe=0,Oe=le.length){for(;pe<Ee&&Fe<Oe;pe++,Fe++){const Me=K.charCodeAt(pe),re=le.charCodeAt(Fe);if(Me<re)return-1;if(Me>re)return 1}const $e=Ee-pe,tt=Oe-Fe;return $e<tt?-1:$e>tt?1:0}t.compareSubstring=y;function _(K,le){return V(K,le,0,K.length,0,le.length)}t.compareIgnoreCase=_;function V(K,le,pe=0,Ee=K.length,Fe=0,Oe=le.length){for(;pe<Ee&&Fe<Oe;pe++,Fe++){let Me=K.charCodeAt(pe),re=le.charCodeAt(Fe);if(Me===re)continue;if(Me>=128||re>=128)return y(K.toLowerCase(),le.toLowerCase(),pe,Ee,Fe,Oe);Q(Me)&&(Me-=32),Q(re)&&(re-=32);const Ce=Me-re;if(Ce!==0)return Ce}const $e=Ee-pe,tt=Oe-Fe;return $e<tt?-1:$e>tt?1:0}t.compareSubstringIgnoreCase=V;function ge(K){return K>=48&&K<=57}t.isAsciiDigit=ge;function Q(K){return K>=97&&K<=122}t.isLowerAsciiLetter=Q;function ie(K){return K>=65&&K<=90}t.isUpperAsciiLetter=ie;function te(K,le){return K.length===le.length&&V(K,le)===0}t.equalsIgnoreCase=te;function ue(K,le){const pe=le.length;return le.length>K.length?!1:V(K,le,0,pe)===0}t.startsWithIgnoreCase=ue;function ae(K,le){const pe=Math.min(K.length,le.length);let Ee;for(Ee=0;Ee<pe;Ee++)if(K.charCodeAt(Ee)!==le.charCodeAt(Ee))return Ee;return pe}t.commonPrefixLength=ae;function de(K,le){const pe=Math.min(K.length,le.length);let Ee;const Fe=K.length-1,Oe=le.length-1;for(Ee=0;Ee<pe;Ee++)if(K.charCodeAt(Fe-Ee)!==le.charCodeAt(Oe-Ee))return Ee;return pe}t.commonSuffixLength=de;function Ae(K){return 55296<=K&&K<=56319}t.isHighSurrogate=Ae;function x(K){return 56320<=K&&K<=57343}t.isLowSurrogate=x;function ve(K,le){return(K-55296<<10)+(le-56320)+65536}t.computeCodePoint=ve;function Ne(K,le,pe){const Ee=K.charCodeAt(pe);if(Ae(Ee)&&pe+1<le){const Fe=K.charCodeAt(pe+1);if(x(Fe))return ve(Ee,Fe)}return Ee}t.getNextCodePoint=Ne;function oe(K,le){const pe=K.charCodeAt(le-1);if(x(pe)&&le>1){const Ee=K.charCodeAt(le-2);if(Ae(Ee))return ve(Ee,pe)}return pe}class X{get offset(){return this.e}constructor(le,pe=0){this.c=le,this.d=le.length,this.e=pe}setOffset(le){this.e=le}prevCodePoint(){const le=oe(this.c,this.e);return this.e-=le>=65536?2:1,le}nextCodePoint(){const le=Ne(this.c,this.d,this.e);return this.e+=le>=65536?2:1,le}eol(){return this.e>=this.d}}t.CodePointIterator=X;class se{get offset(){return this.c.offset}constructor(le,pe=0){this.c=new X(le,pe)}nextGraphemeLength(){const le=Ke.getInstance(),pe=this.c,Ee=pe.offset;let Fe=le.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Oe=pe.offset,$e=le.getGraphemeBreakType(pe.nextCodePoint());if(Re(Fe,$e)){pe.setOffset(Oe);break}Fe=$e}return pe.offset-Ee}prevGraphemeLength(){const le=Ke.getInstance(),pe=this.c,Ee=pe.offset;let Fe=le.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Oe=pe.offset,$e=le.getGraphemeBreakType(pe.prevCodePoint());if(Re($e,Fe)){pe.setOffset(Oe);break}Fe=$e}return Ee-pe.offset}eol(){return this.c.eol()}}t.GraphemeIterator=se;function ne(K,le){return new se(K,le).nextGraphemeLength()}t.nextCharLength=ne;function ee(K,le){return new se(K,le).prevGraphemeLength()}t.prevCharLength=ee;function A(K,le){le>0&&x(K.charCodeAt(le))&&le--;const pe=le+ne(K,le);return[pe-ee(K,pe),pe]}t.getCharContainingOffset=A;function E(K){const le=new se(K);let pe=0;for(;!le.eol();)pe++,le.nextGraphemeLength();return pe}t.charCount=E;let u;function B(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(K){return u||(u=B()),u.test(K)}t.containsRTL=W;const $=/^[\t\n\r\x20-\x7E]*$/;function Y(K){return $.test(K)}t.isBasicASCII=Y,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function F(K){return t.UNUSUAL_LINE_TERMINATORS.test(K)}t.containsUnusualLineTerminators=F;function O(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}t.isFullWidthCharacter=O;function U(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}t.isEmojiImprecise=U;function k(K,le){if(K.length<le)return K;const pe=/\b/g;let Ee=0;for(;pe.test(K)&&!(K.length-pe.lastIndex<le);)Ee=pe.lastIndex,pe.lastIndex+=1;return K.substring(Ee).replace(/^\s/,"")}t.lcut=k;const M=/\x1B\x5B[12]?K/g,P=/\x1b\[\d+m/g,R=/\x1b\[0?m/g;function j(K){return K&&(K=K.replace(M,""),K=K.replace(P,""),K=K.replace(R,"")),K}t.removeAnsiEscapeCodes=j,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function J(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}t.startsWithUTF8BOM=J;function he(K){return J(K)?K.substr(1):K}t.stripUTF8BOM=he;function ce(K,le){if(!K||!le||K.length<le.length)return!1;const pe=le.length,Ee=K.toLowerCase();let Fe=0,Oe=-1;for(;Fe<pe;){const $e=Ee.indexOf(le[Fe],Oe+1);if($e<0)return!1;Oe=$e,Fe++}return!0}t.fuzzyContains=ce;function De(K,le=!1){return K?(le&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}t.containsUppercaseCharacter=De;function ye(K){return K.charAt(0).toUpperCase()+K.slice(1)}t.uppercaseFirstLetter=ye;function Ie(K,le=1){if(le===0)return"";let pe=-1;do pe=K.indexOf(`
`,pe+1),le--;while(le>0&&pe>=0);return pe===-1?K:(K[pe-1]==="\r"&&pe--,K.substr(0,pe))}t.getNLines=Ie;function Se(K){return K=K%(2*26),K<26?String.fromCharCode(97+K):String.fromCharCode(65+K-26)}t.singleLetterHash=Se;function we(K){return Ke.getInstance().getGraphemeBreakType(K)}t.getGraphemeBreakType=we;function Re(K,le){return K===0?le!==5&&le!==7:K===2&&le===3?!1:K===4||K===2||K===3||le===4||le===2||le===3?!0:!(K===8&&(le===8||le===9||le===11||le===12)||(K===11||K===9)&&(le===9||le===10)||(K===12||K===10)&&le===10||le===5||le===13||le===7||K===1||K===13&&le===14||K===6&&le===6)}var Pe;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Pe=t.GraphemeBreakType||(t.GraphemeBreakType={}));class Ke{static getInstance(){return Ke.c||(Ke.c=new Ke),Ke.c}constructor(){this.d=Ue()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const pe=this.d,Ee=pe.length/3;let Fe=1;for(;Fe<=Ee;)if(le<pe[3*Fe])Fe=2*Fe;else if(le>pe[3*Fe+1])Fe=2*Fe+1;else return pe[3*Fe+2];return 0}}Ke.c=null;function Ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(K,le){if(K===0)return 0;const pe=xe(K,le);if(pe!==void 0)return pe;const Ee=new X(le,K);return Ee.prevCodePoint(),Ee.offset}t.getLeftDeleteOffset=We;function xe(K,le){const pe=new X(le,K);let Ee=pe.prevCodePoint();for(;it(Ee)||Ee===65039||Ee===8419;){if(pe.offset===0)return;Ee=pe.prevCodePoint()}if(!U(Ee))return;let Fe=pe.offset;return Fe>0&&pe.prevCodePoint()===8205&&(Fe=pe.offset),Fe}function it(K){return 127995<=K&&K<=127999}var Be;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),t.noBreakWhitespace="\xA0";class je{static getInstance(le){return je.d.get(Array.from(le))}static getLocales(){return je.e.getValue()}constructor(le){this.f=le}isAmbiguous(le){return this.f.has(le)}getPrimaryConfusable(le){return this.f.get(le)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.AmbiguousCharacters=je,z=je,je.c=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),je.d=new v.LRUCachedFunction(K=>{function le(re){const Ce=new Map;for(let Le=0;Le<re.length;Le+=2)Ce.set(re[Le],re[Le+1]);return Ce}function pe(re,Ce){const Le=new Map(re);for(const[ze,Ge]of Ce)Le.set(ze,Ge);return Le}function Ee(re,Ce){if(!re)return Ce;const Le=new Map;for(const[ze,Ge]of re)Ce.has(ze)&&Le.set(ze,Ge);return Le}const Fe=z.c.getValue();let Oe=K.filter(re=>!re.startsWith("_")&&re in Fe);Oe.length===0&&(Oe=["_default"]);let $e;for(const re of Oe){const Ce=le(Fe[re]);$e=Ee($e,Ce)}const tt=le(Fe._common),Me=pe(tt,$e);return new je(Me)}),je.e=new i.Lazy(()=>Object.keys(je.c.getValue()).filter(K=>!K.startsWith("_")));class Ye{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ye.c())),this.d}static isInvisibleCharacter(le){return Ye.e().has(le)}static get codePoints(){return Ye.e()}}t.InvisibleCharacters=Ye,Ye.d=void 0}),define(me[110],be([1,0,21,5,11,6]),function(Z,t,v,i,z,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.randomPath=t.parseLineAndColumnAware=t.indexOfPath=t.getDriveLetter=t.hasDriveLetter=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toPosixPath=t.toSlashes=t.isPathSeparator=void 0;function D(f){return f===47||f===92}t.isPathSeparator=D;function w(f){return f.replace(/[\\/]/g,v.posix.sep)}t.toSlashes=w;function d(f){return f.indexOf("/")===-1&&(f=w(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}t.toPosixPath=d;function m(f,C=v.posix.sep){if(!f)return"";const p=f.length,y=f.charCodeAt(0);if(D(y)){if(D(f.charCodeAt(1))&&!D(f.charCodeAt(2))){let V=3;const ge=V;for(;V<p&&!D(f.charCodeAt(V));V++);if(ge!==V&&!D(f.charCodeAt(V+1))){for(V+=1;V<p;V++)if(D(f.charCodeAt(V)))return f.slice(0,V+1).replace(/[\\/]/g,C)}}return C}else if(l(y)&&f.charCodeAt(1)===58)return D(f.charCodeAt(2))?f.slice(0,2)+C:f.slice(0,2);let _=f.indexOf("://");if(_!==-1){for(_+=3;_<p;_++)if(D(f.charCodeAt(_)))return f.slice(0,_+1)}return""}t.getRoot=m;function g(f){if(!i.isWindows||!f||f.length<5)return!1;let C=f.charCodeAt(0);if(C!==92||(C=f.charCodeAt(1),C!==92))return!1;let p=2;const y=p;for(;p<f.length&&(C=f.charCodeAt(p),C!==92);p++);return!(y===p||(C=f.charCodeAt(p+1),isNaN(C)||C===92))}t.isUNC=g;const I=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,n=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(f,C=i.isWindows){const p=C?I:o;return!(!f||f.length===0||/^\s+$/.test(f)||(p.lastIndex=0,p.test(f))||C&&n.test(f)||f==="."||f===".."||C&&f[f.length-1]==="."||C&&f.length!==f.trim().length||f.length>255)}t.isValidBasename=e;function s(f,C,p){const y=f===C;return!p||y?y:!f||!C?!1:(0,z.equalsIgnoreCase)(f,C)}t.isEqual=s;function a(f,C,p,y=v.sep){if(f===C)return!0;if(!f||!C||C.length>f.length)return!1;if(p){if(!(0,z.startsWithIgnoreCase)(f,C))return!1;if(C.length===f.length)return!0;let V=C.length;return C.charAt(C.length-1)===y&&V--,f.charAt(V)===y}return C.charAt(C.length-1)!==y&&(C+=y),f.indexOf(C)===0}t.isEqualOrParent=a;function l(f){return f>=65&&f<=90||f>=97&&f<=122}t.isWindowsDriveLetter=l;function h(f,C){return i.isWindows&&f.endsWith(":")&&(f+=v.sep),(0,v.isAbsolute)(f)||(f=(0,v.join)(C,f)),f=(0,v.normalize)(f),i.isWindows?(f=(0,z.rtrim)(f,v.sep),f.endsWith(":")&&(f+=v.sep)):(f=(0,z.rtrim)(f,v.sep),f||(f=v.sep)),f}t.sanitizeFilePath=h;function r(f){const C=(0,v.normalize)(f);return i.isWindows?f.length>3?!1:c(C)&&(f.length===2||C.charCodeAt(2)===92):C===v.posix.sep}t.isRootOrDriveLetter=r;function c(f,C=i.isWindows){return C?l(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}t.hasDriveLetter=c;function b(f){return c(f)?f[0]:void 0}t.getDriveLetter=b;function S(f,C,p){return C.length>f.length?-1:f===C?0:(p&&(f=f.toLowerCase(),C=C.toLowerCase()),f.indexOf(C))}t.indexOfPath=S;function N(f){const C=f.split(":");let p,y,_;for(const V of C){const ge=Number(V);(0,H.isNumber)(ge)?y===void 0?y=ge:_===void 0&&(_=ge):p=p?[p,V].join(":"):V}if(!p)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:p,line:y!==void 0?y:void 0,column:_!==void 0?_:y!==void 0?1:void 0}}t.parseLineAndColumnAware=N;const L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function T(f,C,p=8){let y="";for(let V=0;V<p;V++)y+=L.charAt(Math.floor(Math.random()*L.length));let _;return C?_=`${C}-${y}`:_=y,f?(0,v.join)(f,_):_}t.randomPath=T}),define(me[32],be([1,0,75,11]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fuzzyScoreGraceful=t.fuzzyScoreGracefulAggressive=t.fuzzyScore=t.FuzzyScoreOptions=t.FuzzyScore=t.isPatternInWord=t.createMatches=t.anyScore=t.matchesFuzzy2=t.matchesFuzzy=t.matchesWords=t.matchesCamelCase=t.isUpper=t.matchesSubString=t.matchesContiguousSubString=t.matchesPrefix=t.matchesStrictPrefix=t.or=void 0;function z(...P){return function(R,j){for(let J=0,he=P.length;J<he;J++){const ce=P[J](R,j);if(ce)return ce}return null}}t.or=z,t.matchesStrictPrefix=H.bind(void 0,!1),t.matchesPrefix=H.bind(void 0,!0);function H(P,R,j){if(!j||j.length<R.length)return null;let J;return P?J=i.startsWithIgnoreCase(j,R):J=j.indexOf(R)===0,J?R.length>0?[{start:0,end:R.length}]:[]:null}function D(P,R){const j=R.toLowerCase().indexOf(P.toLowerCase());return j===-1?null:[{start:j,end:j+P.length}]}t.matchesContiguousSubString=D;function w(P,R){return d(P.toLowerCase(),R.toLowerCase(),0,0)}t.matchesSubString=w;function d(P,R,j,J){if(j===P.length)return[];if(J===R.length)return null;if(P[j]===R[J]){let he=null;return(he=d(P,R,j+1,J+1))?l({start:J,end:J+1},he):null}return d(P,R,j,J+1)}function m(P){return 97<=P&&P<=122}function g(P){return 65<=P&&P<=90}t.isUpper=g;function I(P){return 48<=P&&P<=57}function o(P){return P===32||P===9||P===10||P===13}const n=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(P=>n.add(P.charCodeAt(0)));function e(P){return o(P)||n.has(P)}function s(P,R){return P===R||e(P)&&e(R)}function a(P){return m(P)||g(P)||I(P)}function l(P,R){return R.length===0?R=[P]:P.end===R[0].start?R[0].start=P.start:R.unshift(P),R}function h(P,R){for(let j=R;j<P.length;j++){const J=P.charCodeAt(j);if(g(J)||I(J)||j>0&&!a(P.charCodeAt(j-1)))return j}return P.length}function r(P,R,j,J){if(j===P.length)return[];if(J===R.length)return null;if(P[j]!==R[J].toLowerCase())return null;{let he=null,ce=J+1;for(he=r(P,R,j+1,J+1);!he&&(ce=h(R,ce))<R.length;)he=r(P,R,j+1,ce),ce++;return he===null?null:l({start:J,end:J+1},he)}}function c(P){let R=0,j=0,J=0,he=0,ce=0;for(let we=0;we<P.length;we++)ce=P.charCodeAt(we),g(ce)&&R++,m(ce)&&j++,a(ce)&&J++,I(ce)&&he++;const De=R/P.length,ye=j/P.length,Ie=J/P.length,Se=he/P.length;return{upperPercent:De,lowerPercent:ye,alphaPercent:Ie,numericPercent:Se}}function b(P){const{upperPercent:R,lowerPercent:j}=P;return j===0&&R>.6}function S(P){const{upperPercent:R,lowerPercent:j,alphaPercent:J,numericPercent:he}=P;return j>.2&&R<.8&&J>.6&&he<.2}function N(P){let R=0,j=0,J=0,he=0;for(let ce=0;ce<P.length;ce++)J=P.charCodeAt(ce),g(J)&&R++,m(J)&&j++,o(J)&&he++;return(R===0||j===0)&&he===0?P.length<=30:R<=5}function L(P,R){if(!R||(R=R.trim(),R.length===0)||!N(P)||R.length>60)return null;const j=c(R);if(!S(j)){if(!b(j))return null;R=R.toLowerCase()}let J=null,he=0;for(P=P.toLowerCase();he<R.length&&(J=r(P,R,0,he))===null;)he=h(R,he+1);return J}t.matchesCamelCase=L;function T(P,R,j=!1){if(!R||R.length===0)return null;let J=null,he=0;for(P=P.toLowerCase(),R=R.toLowerCase();he<R.length&&(J=f(P,R,0,he,j))===null;)he=C(R,he+1);return J}t.matchesWords=T;function f(P,R,j,J,he){if(j===P.length)return[];if(J===R.length)return null;if(s(P.charCodeAt(j),R.charCodeAt(J))){let ce=null,De=J+1;if(ce=f(P,R,j+1,J+1,he),!he)for(;!ce&&(De=C(R,De))<R.length;)ce=f(P,R,j+1,De,he),De++;return ce?P.charCodeAt(j)!==R.charCodeAt(J)?ce:l({start:J,end:J+1},ce):null}else return null}function C(P,R){for(let j=R;j<P.length;j++)if(e(P.charCodeAt(j))||j>0&&e(P.charCodeAt(j-1)))return j;return P.length}const p=z(t.matchesPrefix,L,D),y=z(t.matchesPrefix,L,w),_=new v.LRUCache(1e4);function V(P,R,j=!1){if(typeof P!="string"||typeof R!="string")return null;let J=_.get(P);J||(J=new RegExp(i.convertSimple2RegExpPattern(P),"i"),_.set(P,J));const he=J.exec(R);return he?[{start:he.index,end:he.index+he[0].length}]:j?y(P,R):p(P,R)}t.matchesFuzzy=V;function ge(P,R){const j=$(P,P.toLowerCase(),0,R,R.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return j?ie(j):null}t.matchesFuzzy2=ge;function Q(P,R,j,J,he,ce){const De=Math.min(13,P.length);for(;j<De;j++){const ye=$(P,R,j,J,he,ce,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ye)return ye}return[0,ce]}t.anyScore=Q;function ie(P){if(typeof P>"u")return[];const R=[],j=P[1];for(let J=P.length-1;J>1;J--){const he=P[J]+j,ce=R[R.length-1];ce&&ce.end===he?ce.end=he+1:R.push({start:he,end:he+1})}return R}t.createMatches=ie;const te=128;function ue(){const P=[],R=[];for(let j=0;j<=te;j++)R[j]=0;for(let j=0;j<=te;j++)P.push(R.slice(0));return P}function ae(P){const R=[];for(let j=0;j<=P;j++)R[j]=0;return R}const de=ae(2*te),Ae=ae(2*te),x=ue(),ve=ue(),Ne=ue(),oe=!1;function X(P,R,j,J,he){function ce(ye,Ie,Se=" "){for(;ye.length<Ie;)ye=Se+ye;return ye}let De=` |   |${J.split("").map(ye=>ce(ye,3)).join("|")}
`;for(let ye=0;ye<=j;ye++)ye===0?De+=" |":De+=`${R[ye-1]}|`,De+=P[ye].slice(0,he+1).map(Ie=>ce(Ie.toString(),3)).join("|")+`
`;return De}function se(P,R,j,J){P=P.substr(R),j=j.substr(J),console.log(X(ve,P,P.length,j,j.length)),console.log(X(Ne,P,P.length,j,j.length)),console.log(X(x,P,P.length,j,j.length))}function ne(P,R){if(R<0||R>=P.length)return!1;const j=P.codePointAt(R);switch(j){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!i.isEmojiImprecise(j)}}function ee(P,R){if(R<0||R>=P.length)return!1;switch(P.charCodeAt(R)){case 32:case 9:return!0;default:return!1}}function A(P,R,j){return R[P]!==j[P]}function E(P,R,j,J,he,ce,De=!1){for(;R<j&&he<ce;)P[R]===J[he]&&(De&&(de[R]=he),R+=1),he+=1;return R===j}t.isPatternInWord=E;var u;(function(P){P[P.Diag=1]="Diag",P[P.Left=2]="Left",P[P.LeftLeft=3]="LeftLeft"})(u||(u={}));var B;(function(P){P.Default=[-100,0];function R(j){return!j||j.length===2&&j[0]===-100&&j[1]===0}P.isDefault=R})(B=t.FuzzyScore||(t.FuzzyScore={}));class W{constructor(R,j){this.firstMatchCanBeWeak=R,this.boostFullMatch=j}}t.FuzzyScoreOptions=W,W.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function $(P,R,j,J,he,ce,De=W.default){const ye=P.length>te?te:P.length,Ie=J.length>te?te:J.length;if(j>=ye||ce>=Ie||ye-j>Ie-ce||!E(R,j,ye,he,ce,Ie,!0))return;Y(ye,Ie,j,ce,R,he);let Se=1,we=1,Re=j,Pe=ce;const Ke=[!1];for(Se=1,Re=j;Re<ye;Se++,Re++){const Be=de[Re],je=Ae[Re],Ye=Re+1<ye?Ae[Re+1]:Ie;for(we=Be-ce+1,Pe=Be;Pe<Ye;we++,Pe++){let K=Number.MIN_SAFE_INTEGER,le=!1;Pe<=je&&(K=F(P,R,Re,j,J,he,Pe,Ie,ce,x[Se-1][we-1]===0,Ke));let pe=0;K!==Number.MAX_SAFE_INTEGER&&(le=!0,pe=K+ve[Se-1][we-1]);const Ee=Pe>Be,Fe=Ee?ve[Se][we-1]+(x[Se][we-1]>0?-5:0):0,Oe=Pe>Be+1&&x[Se][we-1]>0,$e=Oe?ve[Se][we-2]+(x[Se][we-2]>0?-5:0):0;if(Oe&&(!Ee||$e>=Fe)&&(!le||$e>=pe))ve[Se][we]=$e,Ne[Se][we]=3,x[Se][we]=0;else if(Ee&&(!le||Fe>=pe))ve[Se][we]=Fe,Ne[Se][we]=2,x[Se][we]=0;else if(le)ve[Se][we]=pe,Ne[Se][we]=1,x[Se][we]=x[Se-1][we-1]+1;else throw new Error("not possible")}}if(oe&&se(P,j,J,ce),!Ke[0]&&!De.firstMatchCanBeWeak)return;Se--,we--;const Ue=[ve[Se][we],ce];let We=0,xe=0;for(;Se>=1;){let Be=we;do{const je=Ne[Se][Be];if(je===3)Be=Be-2;else if(je===2)Be=Be-1;else break}while(Be>=1);We>1&&R[j+Se-1]===he[ce+we-1]&&!A(Be+ce-1,J,he)&&We+1>x[Se][Be]&&(Be=we),Be===we?We++:We=1,xe||(xe=Be),Se--,we=Be-1,Ue.push(we)}Ie===ye&&De.boostFullMatch&&(Ue[0]+=2);const it=xe-ye;return Ue[0]-=it,Ue}t.fuzzyScore=$;function Y(P,R,j,J,he,ce){let De=P-1,ye=R-1;for(;De>=j&&ye>=J;)he[De]===ce[ye]&&(Ae[De]=ye,De--),ye--}function F(P,R,j,J,he,ce,De,ye,Ie,Se,we){if(R[j]!==ce[De])return Number.MIN_SAFE_INTEGER;let Re=1,Pe=!1;return De===j-J?Re=P[j]===he[De]?7:5:A(De,he,ce)&&(De===0||!A(De-1,he,ce))?(Re=P[j]===he[De]?7:5,Pe=!0):ne(ce,De)&&(De===0||!ne(ce,De-1))?Re=5:(ne(ce,De-1)||ee(ce,De-1))&&(Re=5,Pe=!0),Re>1&&j===J&&(we[0]=!0),Pe||(Pe=A(De,he,ce)||ne(ce,De-1)||ee(ce,De-1)),j===J?De>Ie&&(Re-=Pe?3:5):Se?Re+=Pe?2:0:Re+=Pe?0:1,De+1===ye&&(Re-=Pe?3:5),Re}function O(P,R,j,J,he,ce,De){return k(P,R,j,J,he,ce,!0,De)}t.fuzzyScoreGracefulAggressive=O;function U(P,R,j,J,he,ce,De){return k(P,R,j,J,he,ce,!1,De)}t.fuzzyScoreGraceful=U;function k(P,R,j,J,he,ce,De,ye){let Ie=$(P,R,j,J,he,ce,ye);if(Ie&&!De)return Ie;if(P.length>=3){const Se=Math.min(7,P.length-1);for(let we=j+1;we<Se;we++){const Re=M(P,we);if(Re){const Pe=$(Re,Re.toLowerCase(),j,J,he,ce,ye);Pe&&(Pe[0]-=3,(!Ie||Pe[0]>Ie[0])&&(Ie=Pe))}}}return Ie}function M(P,R){if(R+1>=P.length)return;const j=P[R],J=P[R+1];if(j!==J)return P.slice(0,R)+J+j+P.slice(R+2)}}),define(me[111],be([1,0,11]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function i(l){return z(l,0)}t.hash=i;function z(l,h){switch(typeof l){case"object":return l===null?H(349,h):Array.isArray(l)?d(l,h):m(l,h);case"string":return w(l,h);case"boolean":return D(l,h);case"number":return H(l,h);case"undefined":return H(937,h);default:return H(617,h)}}t.doHash=z;function H(l,h){return(h<<5)-h+l|0}t.numberHash=H;function D(l,h){return H(l?433:863,h)}function w(l,h){h=H(149417,h);for(let r=0,c=l.length;r<c;r++)h=H(l.charCodeAt(r),h);return h}t.stringHash=w;function d(l,h){return h=H(104579,h),l.reduce((r,c)=>z(c,r),h)}function m(l,h){return h=H(181387,h),Object.keys(l).sort().reduce((r,c)=>(r=w(c,r),z(l[c],r)),h)}class g{constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=z(h,this.g),this.g}}t.Hasher=g;var I;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function o(l,h,r=32){const c=r-h,b=~((1<<c)-1);return(l<<h|(b&l)>>>c)>>>0}function n(l,h=0,r=l.byteLength,c=0){for(let b=0;b<r;b++)l[h+b]=c}function e(l,h,r="0"){for(;l.length<h;)l=r+l;return l}function s(l,h=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(r=>r.toString(16).padStart(2,"0")).join(""):e((l>>>0).toString(16),h/4)}t.toHexString=s;class a{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const r=h.length;if(r===0)return;const c=this.p;let b=this.r,S=this.u,N,L;for(S!==0?(N=S,L=-1,S=0):(N=h.charCodeAt(0),L=0);;){let T=N;if(v.isHighSurrogate(N))if(L+1<r){const f=h.charCodeAt(L+1);v.isLowSurrogate(f)?(L++,T=v.computeCodePoint(N,f)):T=65533}else{S=N;break}else v.isLowSurrogate(N)&&(T=65533);if(b=this.w(c,b,T),L++,L<r)N=h.charCodeAt(L);else break}this.r=b,this.u=S}w(h,r,c){return c<128?h[r++]=c:c<2048?(h[r++]=192|(c&1984)>>>6,h[r++]=128|(c&63)>>>0):c<65536?(h[r++]=224|(c&61440)>>>12,h[r++]=128|(c&4032)>>>6,h[r++]=128|(c&63)>>>0):(h[r++]=240|(c&1835008)>>>18,h[r++]=128|(c&258048)>>>12,h[r++]=128|(c&4032)>>>6,h[r++]=128|(c&63)>>>0),r>=64&&(this.y(),r-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),r}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),s(this.h)+s(this.l)+s(this.m)+s(this.n)+s(this.o)}x(){this.p[this.r++]=128,n(this.p,this.r),this.r>56&&(this.y(),n(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=a.g,r=this.q;for(let p=0;p<64;p+=4)h.setUint32(p,r.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)h.setUint32(p,o(h.getUint32(p-12,!1)^h.getUint32(p-32,!1)^h.getUint32(p-56,!1)^h.getUint32(p-64,!1),1),!1);let c=this.h,b=this.l,S=this.m,N=this.n,L=this.o,T,f,C;for(let p=0;p<80;p++)p<20?(T=b&S|~b&N,f=1518500249):p<40?(T=b^S^N,f=1859775393):p<60?(T=b&S|b&N|S&N,f=2400959708):(T=b^S^N,f=3395469782),C=o(c,5)+T+L+f+h.getUint32(p*4,!1)&4294967295,L=N,N=S,S=o(b,30),b=c,c=C;this.h=this.h+c&4294967295,this.l=this.l+b&4294967295,this.m=this.m+S&4294967295,this.n=this.n+N&4294967295,this.o=this.o+L&4294967295}}t.StringSHA1=a,a.g=new DataView(new ArrayBuffer(320))}),define(me[112],be([1,0,71,111]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class z{constructor(o){this.a=o}getElements(){const o=this.a,n=new Int32Array(o.length);for(let e=0,s=o.length;e<s;e++)n[e]=o.charCodeAt(e);return n}}t.StringDiffSequence=z;function H(I,o,n){return new g(new z(I),new z(o)).ComputeDiff(n).changes}t.stringDiff=H;class D{static Assert(o,n){if(!o)throw new Error(n)}}class w{static Copy(o,n,e,s,a){for(let l=0;l<a;l++)e[s+l]=o[n+l]}static Copy2(o,n,e,s,a){for(let l=0;l<a;l++)e[s+l]=o[n+l]}}var d;(function(I){I[I.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(d||(d={}));class m{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new v.DiffChange(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(o,n){this.b=Math.min(this.b,o),this.c=Math.min(this.c,n),this.d++}AddModifiedElement(o,n){this.b=Math.min(this.b,o),this.c=Math.min(this.c,n),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class g{constructor(o,n,e=null){this.a=e,this.b=o,this.c=n;const[s,a,l]=g.o(o),[h,r,c]=g.o(n);this.d=l&&c,this.e=s,this.f=a,this.g=h,this.h=r,this.k=[],this.m=[]}static n(o){return o.length>0&&typeof o[0]=="string"}static o(o){const n=o.getElements();if(g.n(n)){const e=new Int32Array(n.length);for(let s=0,a=n.length;s<a;s++)e[s]=(0,i.stringHash)(n[s],0);return[n,e,!0]}return n instanceof Int32Array?[[],n,!1]:[[],new Int32Array(n),!1]}p(o,n){return this.f[o]!==this.h[n]?!1:this.d?this.e[o]===this.g[n]:!0}q(o,n){if(!this.p(o,n))return!1;const e=g.r(this.b,o),s=g.r(this.c,n);return e===s}static r(o,n){return typeof o.getStrictElement=="function"?o.getStrictElement(n):null}s(o,n){return this.f[o]!==this.f[n]?!1:this.d?this.e[o]===this.e[n]:!0}u(o,n){return this.h[o]!==this.h[n]?!1:this.d?this.g[o]===this.g[n]:!0}ComputeDiff(o){return this.v(0,this.f.length-1,0,this.h.length-1,o)}v(o,n,e,s,a){const l=[!1];let h=this.w(o,n,e,s,l);return a&&(h=this.z(h)),{quitEarly:l[0],changes:h}}w(o,n,e,s,a){for(a[0]=!1;o<=n&&e<=s&&this.p(o,e);)o++,e++;for(;n>=o&&s>=e&&this.p(n,s);)n--,s--;if(o>n||e>s){let S;return e<=s?(D.Assert(o===n+1,"originalStart should only be one more than originalEnd"),S=[new v.DiffChange(o,0,e,s-e+1)]):o<=n?(D.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),S=[new v.DiffChange(o,n-o+1,e,0)]):(D.Assert(o===n+1,"originalStart should only be one more than originalEnd"),D.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),S=[]),S}const l=[0],h=[0],r=this.y(o,n,e,s,l,h,a),c=l[0],b=h[0];if(r!==null)return r;if(!a[0]){const S=this.w(o,c,e,b,a);let N=[];return a[0]?N=[new v.DiffChange(c+1,n-(c+1)+1,b+1,s-(b+1)+1)]:N=this.w(c+1,n,b+1,s,a),this.H(S,N)}return[new v.DiffChange(o,n-o+1,e,s-e+1)]}x(o,n,e,s,a,l,h,r,c,b,S,N,L,T,f,C,p,y){let _=null,V=null,ge=new m,Q=n,ie=e,te=L[0]-C[0]-s,ue=-1073741824,ae=this.k.length-1;do{const de=te+o;de===Q||de<ie&&c[de-1]<c[de+1]?(S=c[de+1],T=S-te-s,S<ue&&ge.MarkNextChange(),ue=S,ge.AddModifiedElement(S+1,T),te=de+1-o):(S=c[de-1]+1,T=S-te-s,S<ue&&ge.MarkNextChange(),ue=S-1,ge.AddOriginalElement(S,T+1),te=de-1-o),ae>=0&&(c=this.k[ae],o=c[0],Q=1,ie=c.length-1)}while(--ae>=-1);if(_=ge.getReverseChanges(),y[0]){let de=L[0]+1,Ae=C[0]+1;if(_!==null&&_.length>0){const x=_[_.length-1];de=Math.max(de,x.getOriginalEnd()),Ae=Math.max(Ae,x.getModifiedEnd())}V=[new v.DiffChange(de,N-de+1,Ae,f-Ae+1)]}else{ge=new m,Q=l,ie=h,te=L[0]-C[0]-r,ue=1073741824,ae=p?this.m.length-1:this.m.length-2;do{const de=te+a;de===Q||de<ie&&b[de-1]>=b[de+1]?(S=b[de+1]-1,T=S-te-r,S>ue&&ge.MarkNextChange(),ue=S+1,ge.AddOriginalElement(S+1,T+1),te=de+1-a):(S=b[de-1],T=S-te-r,S>ue&&ge.MarkNextChange(),ue=S,ge.AddModifiedElement(S+1,T+1),te=de-1-a),ae>=0&&(b=this.m[ae],a=b[0],Q=1,ie=b.length-1)}while(--ae>=-1);V=ge.getChanges()}return this.H(_,V)}y(o,n,e,s,a,l,h){let r=0,c=0,b=0,S=0,N=0,L=0;o--,e--,a[0]=0,l[0]=0,this.k=[],this.m=[];const T=n-o+(s-e),f=T+1,C=new Int32Array(f),p=new Int32Array(f),y=s-e,_=n-o,V=o-e,ge=n-s,ie=(_-y)%2===0;C[y]=o,p[_]=n,h[0]=!1;for(let te=1;te<=T/2+1;te++){let ue=0,ae=0;b=this.J(y-te,te,y,f),S=this.J(y+te,te,y,f);for(let Ae=b;Ae<=S;Ae+=2){Ae===b||Ae<S&&C[Ae-1]<C[Ae+1]?r=C[Ae+1]:r=C[Ae-1]+1,c=r-(Ae-y)-V;const x=r;for(;r<n&&c<s&&this.p(r+1,c+1);)r++,c++;if(C[Ae]=r,r+c>ue+ae&&(ue=r,ae=c),!ie&&Math.abs(Ae-_)<=te-1&&r>=p[Ae])return a[0]=r,l[0]=c,x<=p[Ae]&&1447>0&&te<=1447+1?this.x(y,b,S,V,_,N,L,ge,C,p,r,n,a,c,s,l,ie,h):null}const de=(ue-o+(ae-e)-te)/2;if(this.a!==null&&!this.a(ue,de))return h[0]=!0,a[0]=ue,l[0]=ae,de>0&&1447>0&&te<=1447+1?this.x(y,b,S,V,_,N,L,ge,C,p,r,n,a,c,s,l,ie,h):(o++,e++,[new v.DiffChange(o,n-o+1,e,s-e+1)]);N=this.J(_-te,te,_,f),L=this.J(_+te,te,_,f);for(let Ae=N;Ae<=L;Ae+=2){Ae===N||Ae<L&&p[Ae-1]>=p[Ae+1]?r=p[Ae+1]-1:r=p[Ae-1],c=r-(Ae-_)-ge;const x=r;for(;r>o&&c>e&&this.p(r,c);)r--,c--;if(p[Ae]=r,ie&&Math.abs(Ae-y)<=te&&r<=C[Ae])return a[0]=r,l[0]=c,x>=C[Ae]&&1447>0&&te<=1447+1?this.x(y,b,S,V,_,N,L,ge,C,p,r,n,a,c,s,l,ie,h):null}if(te<=1447){let Ae=new Int32Array(S-b+2);Ae[0]=y-b+1,w.Copy2(C,b,Ae,1,S-b+1),this.k.push(Ae),Ae=new Int32Array(L-N+2),Ae[0]=_-N+1,w.Copy2(p,N,Ae,1,L-N+1),this.m.push(Ae)}}return this.x(y,b,S,V,_,N,L,ge,C,p,r,n,a,c,s,l,ie,h)}z(o){for(let n=0;n<o.length;n++){const e=o[n],s=n<o.length-1?o[n+1].originalStart:this.f.length,a=n<o.length-1?o[n+1].modifiedStart:this.h.length,l=e.originalLength>0,h=e.modifiedLength>0;for(;e.originalStart+e.originalLength<s&&e.modifiedStart+e.modifiedLength<a&&(!l||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!h||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const c=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!c)break;e.originalStart++,e.modifiedStart++}const r=[null];if(n<o.length-1&&this.I(o[n],o[n+1],r)){o[n]=r[0],o.splice(n+1,1),n--;continue}}for(let n=o.length-1;n>=0;n--){const e=o[n];let s=0,a=0;if(n>0){const S=o[n-1];s=S.originalStart+S.originalLength,a=S.modifiedStart+S.modifiedLength}const l=e.originalLength>0,h=e.modifiedLength>0;let r=0,c=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let S=1;;S++){const N=e.originalStart-S,L=e.modifiedStart-S;if(N<s||L<a||l&&!this.s(N,N+e.originalLength)||h&&!this.u(L,L+e.modifiedLength))break;const f=(N===s&&L===a?5:0)+this.G(N,e.originalLength,L,e.modifiedLength);f>c&&(c=f,r=S)}e.originalStart-=r,e.modifiedStart-=r;const b=[null];if(n>0&&this.I(o[n-1],o[n],b)){o[n-1]=b[0],o.splice(n,1),n++;continue}}if(this.d)for(let n=1,e=o.length;n<e;n++){const s=o[n-1],a=o[n],l=a.originalStart-s.originalStart-s.originalLength,h=s.originalStart,r=a.originalStart+a.originalLength,c=r-h,b=s.modifiedStart,S=a.modifiedStart+a.modifiedLength,N=S-b;if(l<5&&c<20&&N<20){const L=this.A(h,c,b,N,l);if(L){const[T,f]=L;(T!==s.originalStart+s.originalLength||f!==s.modifiedStart+s.modifiedLength)&&(s.originalLength=T-s.originalStart,s.modifiedLength=f-s.modifiedStart,a.originalStart=T+l,a.modifiedStart=f+l,a.originalLength=r-a.originalStart,a.modifiedLength=S-a.modifiedStart)}}}return o}A(o,n,e,s,a){if(n<a||s<a)return null;const l=o+n-a+1,h=e+s-a+1;let r=0,c=0,b=0;for(let S=o;S<l;S++)for(let N=e;N<h;N++){const L=this.B(S,N,a);L>0&&L>r&&(r=L,c=S,b=N)}return r>0?[c,b]:null}B(o,n,e){let s=0;for(let a=0;a<e;a++){if(!this.p(o+a,n+a))return 0;s+=this.e[o+a].length}return s}C(o){return o<=0||o>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[o])}D(o,n){if(this.C(o)||this.C(o-1))return!0;if(n>0){const e=o+n;if(this.C(e-1)||this.C(e))return!0}return!1}E(o){return o<=0||o>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[o])}F(o,n){if(this.E(o)||this.E(o-1))return!0;if(n>0){const e=o+n;if(this.E(e-1)||this.E(e))return!0}return!1}G(o,n,e,s){const a=this.D(o,n)?1:0,l=this.F(e,s)?1:0;return a+l}H(o,n){const e=[];if(o.length===0||n.length===0)return n.length>0?n:o;if(this.I(o[o.length-1],n[0],e)){const s=new Array(o.length+n.length-1);return w.Copy(o,0,s,0,o.length-1),s[o.length-1]=e[0],w.Copy(n,1,s,o.length,n.length-1),s}else{const s=new Array(o.length+n.length);return w.Copy(o,0,s,0,o.length),w.Copy(n,0,s,o.length,n.length),s}}I(o,n,e){if(D.Assert(o.originalStart<=n.originalStart,"Left change is not less than or equal to right change"),D.Assert(o.modifiedStart<=n.modifiedStart,"Left change is not less than or equal to right change"),o.originalStart+o.originalLength>=n.originalStart||o.modifiedStart+o.modifiedLength>=n.modifiedStart){const s=o.originalStart;let a=o.originalLength;const l=o.modifiedStart;let h=o.modifiedLength;return o.originalStart+o.originalLength>=n.originalStart&&(a=n.originalStart+n.originalLength-o.originalStart),o.modifiedStart+o.modifiedLength>=n.modifiedStart&&(h=n.modifiedStart+n.modifiedLength-o.modifiedStart),e[0]=new v.DiffChange(s,a,l,h),!0}else return e[0]=null,!1}J(o,n,e,s){if(o>=0&&o<s)return o;const a=e,l=s-e-1,h=n%2===0;if(o<0){const r=a%2===0;return h===r?0:1}else{const r=l%2===0;return h===r?s-1:s-2}}}t.LcsDiff=g}),define(me[33],be([1,0,12,32,11]),function(Z,t,v,i,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.matchesFuzzyIconAware=t.parseLabelWithIcons=t.stripIcons=t.markdownEscapeEscapedIcons=t.escapeIcons=void 0;const H="$(",D=new RegExp(`\\$\\(${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?\\)`,"g"),w=new RegExp(`(\\\\)?${D.source}`,"g");function d(a){return a.replace(w,(l,h)=>h?l:`\\${l}`)}t.escapeIcons=d;const m=new RegExp(`\\\\${D.source}`,"g");function g(a){return a.replace(m,l=>`\\${l}`)}t.markdownEscapeEscapedIcons=g;const I=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function o(a){return a.indexOf(H)===-1?a:a.replace(I,(l,h,r,c)=>r?l:h||c||"")}t.stripIcons=o;const n=new RegExp(`\\$\\(${v.CSSIcon.iconNameCharacter}+\\)`,"g");function e(a){n.lastIndex=0;let l="";const h=[];let r=0;for(;;){const c=n.lastIndex,b=n.exec(a),S=a.substring(c,b?.index);if(S.length>0){l+=S;for(let N=0;N<S.length;N++)h.push(r)}if(!b)break;r+=b[0].length}return{text:l,iconOffsets:h}}t.parseLabelWithIcons=e;function s(a,l,h=!1){const{text:r,iconOffsets:c}=l;if(!c||c.length===0)return(0,i.matchesFuzzy)(a,r,h);const b=(0,z.ltrim)(r," "),S=r.length-b.length,N=(0,i.matchesFuzzy)(a,b,h);if(N)for(const L of N){const T=c[L.start+S]+S;L.start+=T,L.end+=T}return N}t.matchesFuzzyIconAware=s}),define(me[113],be([1,0,14,11]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=void 0;class z{constructor(){this.b="",this.c=0}reset(n){return this.b=n,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(n){const e=n.charCodeAt(0),s=this.b.charCodeAt(this.c);return e-s}value(){return this.b[this.c]}}t.StringIterator=z;class H{constructor(n=!0){this.e=n}reset(n){return this.b=n,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let n=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(n)this.c++;else break;else n=!1;return this}cmp(n){return this.e?(0,i.compareSubstring)(n,this.b,0,n.length,this.c,this.d):(0,i.compareSubstringIgnoreCase)(n,this.b,0,n.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.ConfigKeysIterator=H;class D{constructor(n=!0,e=!0){this.f=n,this.g=e}reset(n){this.d=0,this.e=0,this.b=n,this.c=n.length;for(let e=n.length-1;e>=0;e--,this.c--){const s=this.b.charCodeAt(e);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let n=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(n)this.d++;else break;else n=!1}return this}cmp(n){return this.g?(0,i.compareSubstring)(n,this.b,0,n.length,this.d,this.e):(0,i.compareSubstringIgnoreCase)(n,this.b,0,n.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.PathIterator=D;var w;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(w||(w={}));class d{constructor(n,e){this.f=n,this.g=e,this.d=[],this.e=0}reset(n){return this.c=n,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(n)),this.b.reset(n.path),this.b.value()&&this.d.push(3)),this.g(n)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(n){if(this.d[this.e]===1)return(0,i.compareIgnoreCase)(n,this.c.scheme);if(this.d[this.e]===2)return(0,i.compareIgnoreCase)(n,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(n);if(this.d[this.e]===4)return(0,i.compare)(n,this.c.query);if(this.d[this.e]===5)return(0,i.compare)(n,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.UriIterator=d;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(g||(g={}));class I{static forUris(n=()=>!1,e=()=>!1){return new I(new d(n,e))}static forPaths(n=!1){return new I(new D(void 0,!n))}static forStrings(){return new I(new z)}static forConfigKeys(){return new I(new H)}constructor(n){this.b=n}clear(){this.c=void 0}fill(n,e){if(e){const s=e.slice(0);(0,v.shuffle)(s);for(const a of s)this.set(a,n)}else{const s=n.slice(0);(0,v.shuffle)(s);for(const a of s)this.set(a[0],a[1])}}set(n,e){const s=this.b.reset(n);let a;this.c||(this.c=new m,this.c.segment=s.value());const l=[];for(a=this.c;;){const r=s.cmp(a.segment);if(r>0)a.left||(a.left=new m,a.left.segment=s.value()),l.push([-1,a]),a=a.left;else if(r<0)a.right||(a.right=new m,a.right.segment=s.value()),l.push([1,a]),a=a.right;else if(s.hasNext())s.next(),a.mid||(a.mid=new m,a.mid.segment=s.value()),l.push([0,a]),a=a.mid;else break}const h=a.value;a.value=e,a.key=n;for(let r=l.length-1;r>=0;r--){const c=l[r][1];c.updateHeight();const b=c.balanceFactor();if(b<-1||b>1){const S=l[r][0],N=l[r+1][0];if(S===1&&N===1)l[r][1]=c.rotateLeft();else if(S===-1&&N===-1)l[r][1]=c.rotateRight();else if(S===1&&N===-1)c.right=l[r+1][1]=l[r+1][1].rotateRight(),l[r][1]=c.rotateLeft();else if(S===-1&&N===1)c.left=l[r+1][1]=l[r+1][1].rotateLeft(),l[r][1]=c.rotateRight();else throw new Error;if(r>0)switch(l[r-1][0]){case-1:l[r-1][1].left=l[r][1];break;case 1:l[r-1][1].right=l[r][1];break;case 0:l[r-1][1].mid=l[r][1];break}else this.c=l[0][1]}}return h}get(n){return this.d(n)?.value}d(n){const e=this.b.reset(n);let s=this.c;for(;s;){const a=e.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(e.hasNext())e.next(),s=s.mid;else break}return s}has(n){const e=this.d(n);return!(e?.value===void 0&&e?.mid===void 0)}delete(n){return this.e(n,!1)}deleteSuperstr(n){return this.e(n,!0)}e(n,e){const s=this.b.reset(n),a=[];let l=this.c;for(;l;){const h=s.cmp(l.segment);if(h>0)a.push([-1,l]),l=l.left;else if(h<0)a.push([1,l]),l=l.right;else if(s.hasNext())s.next(),a.push([0,l]),l=l.mid;else break}if(!!l){if(e?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const h=this.f(l.right);if(h.key){const{key:r,value:c,segment:b}=h;this.e(h.key,!1),l.key=r,l.value=c,l.segment=b}}else{const h=l.left??l.right;if(a.length>0){const[r,c]=a[a.length-1];switch(r){case-1:c.left=h;break;case 0:c.mid=h;break;case 1:c.right=h;break}}else this.c=h}for(let h=a.length-1;h>=0;h--){const r=a[h][1];r.updateHeight();const c=r.balanceFactor();if(c>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),a[h][1]=r.rotateLeft()):c<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),a[h][1]=r.rotateRight()),h>0)switch(a[h-1][0]){case-1:a[h-1][1].left=a[h][1];break;case 1:a[h-1][1].right=a[h][1];break;case 0:a[h-1][1].mid=a[h][1];break}else this.c=a[0][1]}}}f(n){for(;n.left;)n=n.left;return n}findSubstr(n){const e=this.b.reset(n);let s=this.c,a;for(;s;){const l=e.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(e.hasNext())e.next(),a=s.value||a,s=s.mid;else break}return s&&s.value||a}findSuperstr(n){const e=this.b.reset(n);let s=this.c;for(;s;){const a=e.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(e.hasNext())e.next(),s=s.mid;else return s.mid?this.g(s.mid):void 0}}forEach(n){for(const[e,s]of this)n(s,e)}*[Symbol.iterator](){yield*this.g(this.c)}g(n){const e=[];return this.h(n,e),e[Symbol.iterator]()}h(n,e){!n||(n.left&&this.h(n.left,e),n.value&&e.push([n.key,n.value]),n.mid&&this.h(n.mid,e),n.right&&this.h(n.right,e))}_isBalanced(){const n=e=>{if(!e)return!0;const s=e.balanceFactor();return s<-1||s>1?!1:n(e.left)&&n(e.right)};return n(this.c)}}t.TernarySearchTree=I}),define(me[15],be([1,0,21,5]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const z=/^\w[\w\d+.-]*$/,H=/^\//,D=/^\/\//;function w(L,T){if(!L.scheme&&T)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${L.authority}", path: "${L.path}", query: "${L.query}", fragment: "${L.fragment}"}`);if(L.scheme&&!z.test(L.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(L.path){if(L.authority){if(!H.test(L.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(L.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(L,T){return!L&&!T?"file":L}function m(L,T){switch(L){case"https":case"http":case"file":T?T[0]!==I&&(T=I+T):T=I;break}return T}const g="",I="/",o=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class n{static isUri(T){return T instanceof n?!0:T?typeof T.authority=="string"&&typeof T.fragment=="string"&&typeof T.path=="string"&&typeof T.query=="string"&&typeof T.scheme=="string"&&typeof T.fsPath=="string"&&typeof T.with=="function"&&typeof T.toString=="function":!1}constructor(T,f,C,p,y,_=!1){typeof T=="object"?(this.scheme=T.scheme||g,this.authority=T.authority||g,this.path=T.path||g,this.query=T.query||g,this.fragment=T.fragment||g):(this.scheme=d(T,_),this.authority=f||g,this.path=m(this.scheme,C||g),this.query=p||g,this.fragment=y||g,w(this,_))}get fsPath(){return r(this,!1)}with(T){if(!T)return this;let{scheme:f,authority:C,path:p,query:y,fragment:_}=T;return f===void 0?f=this.scheme:f===null&&(f=g),C===void 0?C=this.authority:C===null&&(C=g),p===void 0?p=this.path:p===null&&(p=g),y===void 0?y=this.query:y===null&&(y=g),_===void 0?_=this.fragment:_===null&&(_=g),f===this.scheme&&C===this.authority&&p===this.path&&y===this.query&&_===this.fragment?this:new s(f,C,p,y,_)}static parse(T,f=!1){const C=o.exec(T);return C?new s(C[2]||g,N(C[4]||g),N(C[5]||g),N(C[7]||g),N(C[9]||g),f):new s(g,g,g,g,g)}static file(T){let f=g;if(i.isWindows&&(T=T.replace(/\\/g,I)),T[0]===I&&T[1]===I){const C=T.indexOf(I,2);C===-1?(f=T.substring(2),T=I):(f=T.substring(2,C),T=T.substring(C)||I)}return new s("file",f,T,g,g)}static from(T){const f=new s(T.scheme,T.authority,T.path,T.query,T.fragment);return w(f,!0),f}static joinPath(T,...f){if(!T.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let C;return i.isWindows&&T.scheme==="file"?C=n.file(v.win32.join(r(T,!0),...f)).path:C=v.posix.join(T.path,...f),T.with({path:C})}toString(T=!1){return c(this,T)}toJSON(){return this}static revive(T){if(T){if(T instanceof n)return T;{const f=new s(T);return f._formatted=T.external,f._fsPath=T._sep===e?T.fsPath:null,f}}else return T}}t.URI=n;const e=i.isWindows?1:void 0;class s extends n{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(T=!1){return T?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const T={$mid:1};return this._fsPath&&(T.fsPath=this._fsPath,T._sep=e),this._formatted&&(T.external=this._formatted),this.path&&(T.path=this.path),this.scheme&&(T.scheme=this.scheme),this.authority&&(T.authority=this.authority),this.query&&(T.query=this.query),this.fragment&&(T.fragment=this.fragment),T}}const a={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function l(L,T,f){let C,p=-1;for(let y=0;y<L.length;y++){const _=L.charCodeAt(y);if(_>=97&&_<=122||_>=65&&_<=90||_>=48&&_<=57||_===45||_===46||_===95||_===126||T&&_===47||f&&_===91||f&&_===93||f&&_===58)p!==-1&&(C+=encodeURIComponent(L.substring(p,y)),p=-1),C!==void 0&&(C+=L.charAt(y));else{C===void 0&&(C=L.substr(0,y));const V=a[_];V!==void 0?(p!==-1&&(C+=encodeURIComponent(L.substring(p,y)),p=-1),C+=V):p===-1&&(p=y)}}return p!==-1&&(C+=encodeURIComponent(L.substring(p))),C!==void 0?C:L}function h(L){let T;for(let f=0;f<L.length;f++){const C=L.charCodeAt(f);C===35||C===63?(T===void 0&&(T=L.substr(0,f)),T+=a[C]):T!==void 0&&(T+=L[f])}return T!==void 0?T:L}function r(L,T){let f;return L.authority&&L.path.length>1&&L.scheme==="file"?f=`//${L.authority}${L.path}`:L.path.charCodeAt(0)===47&&(L.path.charCodeAt(1)>=65&&L.path.charCodeAt(1)<=90||L.path.charCodeAt(1)>=97&&L.path.charCodeAt(1)<=122)&&L.path.charCodeAt(2)===58?T?f=L.path.substr(1):f=L.path[1].toLowerCase()+L.path.substr(2):f=L.path,i.isWindows&&(f=f.replace(/\//g,"\\")),f}t.uriToFsPath=r;function c(L,T){const f=T?h:l;let C="",{scheme:p,authority:y,path:_,query:V,fragment:ge}=L;if(p&&(C+=p,C+=":"),(y||p==="file")&&(C+=I,C+=I),y){let Q=y.indexOf("@");if(Q!==-1){const ie=y.substr(0,Q);y=y.substr(Q+1),Q=ie.lastIndexOf(":"),Q===-1?C+=f(ie,!1,!1):(C+=f(ie.substr(0,Q),!1,!1),C+=":",C+=f(ie.substr(Q+1),!1,!0)),C+="@"}y=y.toLowerCase(),Q=y.lastIndexOf(":"),Q===-1?C+=f(y,!1,!0):(C+=f(y.substr(0,Q),!1,!0),C+=y.substr(Q))}if(_){if(_.length>=3&&_.charCodeAt(0)===47&&_.charCodeAt(2)===58){const Q=_.charCodeAt(1);Q>=65&&Q<=90&&(_=`/${String.fromCharCode(Q+32)}:${_.substr(3)}`)}else if(_.length>=2&&_.charCodeAt(1)===58){const Q=_.charCodeAt(0);Q>=65&&Q<=90&&(_=`${String.fromCharCode(Q+32)}:${_.substr(2)}`)}C+=f(_,!0,!1)}return V&&(C+="?",C+=f(V,!1,!1)),ge&&(C+="#",C+=T?ge:l(ge,!1,!1)),C}function b(L){try{return decodeURIComponent(L)}catch{return L.length>3?L.substr(0,3)+b(L.substr(3)):L}}const S=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function N(L){return L.match(S)?L.replace(S,T=>b(T)):L}}),define(me[50],be([1,0,29,11,15]),function(Z,t,v,i,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function H(m){return JSON.stringify(m,w)}t.stringify=H;function D(m){let g=JSON.parse(m);return g=d(g),g}t.parse=D;function w(m,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:(0,i.regExpFlags)(g)}:g}function d(m,g=0){if(!m||g>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return z.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 16:return new Date(m.source)}if(m instanceof v.VSBuffer||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let I=0;I<m.length;++I)m[I]=d(m[I],g+1);else for(const I in m)Object.hasOwnProperty.call(m,I)&&(m[I]=d(m[I],g+1))}return m}t.revive=d}),define(me[34],be([1,0,5,15]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.FileAccess=t.nodeModulesAsarUnpackedPath=t.nodeModulesAsarPath=t.nodeModulesPath=t.builtinExtensionsPath=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0;var z;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebook="vscode-notebook",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractive="vscode-interactive",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm"})(z=t.Schemas||(t.Schemas={})),t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class H{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${z.vscodeRemoteResource}`}setPreferredWebSchema(m){this.d=m}setDelegate(m){this.e=m}setServerRootPath(m){this.f=`${m}/${z.vscodeRemoteResource}`}set(m,g,I){this.a[m]=g,this.b[m]=I}setConnectionToken(m,g){this.c[m]=g}getPreferredWebSchema(){return this.d}rewrite(m){if(this.e)return this.e(m);const g=m.authority;let I=this.a[g];I&&I.indexOf(":")!==-1&&I.indexOf("[")===-1&&(I=`[${I}]`);const o=this.b[g],n=this.c[g];let e=`path=${encodeURIComponent(m.path)}`;return typeof n=="string"&&(e+=`&${t.connectionTokenQueryName}=${encodeURIComponent(n)}`),i.URI.from({scheme:v.isWeb?this.d:z.vscodeRemoteResource,authority:`${I}:${o}`,path:this.f,query:e})}}t.RemoteAuthorities=new H,t.builtinExtensionsPath="vs/../../extensions",t.nodeModulesPath="vs/../../node_modules",t.nodeModulesAsarPath="vs/../../node_modules.asar",t.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class D{asBrowserUri(m){const g=this.b(m,Z);return this.uriToBrowserUri(g)}uriToBrowserUri(m){return m.scheme===z.vscodeRemote?t.RemoteAuthorities.rewrite(m):m.scheme===z.file&&(v.isNative||v.isWebWorker&&v.globals.origin===`${z.vscodeFileResource}://${D.a}`)?m.with({scheme:z.vscodeFileResource,authority:m.authority||D.a,query:null,fragment:null}):m}asFileUri(m){const g=this.b(m,Z);return this.uriToFileUri(g)}uriToFileUri(m){return m.scheme===z.vscodeFileResource?m.with({scheme:z.file,authority:m.authority!==D.a?m.authority:null,query:null,fragment:null}):m}b(m,g){return i.URI.isUri(m)?m:i.URI.parse(g.toUrl(m))}}D.a="vscode-app",t.FileAccess=new D;var w;(function(d){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(m.get("3"));const g="vscode-coi";function I(n){let e;typeof n=="string"?e=new URL(n).searchParams:n instanceof URL?e=n.searchParams:i.URI.isUri(n)&&(e=new URL(n.toString(!0)).searchParams);const s=e?.get(g);if(!!s)return m.get(s)}d.getHeadersFromQuery=I;function o(n,e,s){if(!globalThis.crossOriginIsolated)return;const a=e&&s?"3":s?"2":"1";n instanceof URLSearchParams?n.set(g,a):n[g]=a}d.addSearchParam=o})(w=t.COI||(t.COI={}))}),define(me[35],be([1,0,110,34,21,5,11,15]),function(Z,t,v,i,z,H,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0;function d(n){return(0,w.uriToFsPath)(n,!0)}t.originalFSPath=d;class m{constructor(e){this.a=e}compare(e,s,a=!1){return e===s?0:(0,D.compare)(this.getComparisonKey(e,a),this.getComparisonKey(s,a))}isEqual(e,s,a=!1){return e===s?!0:!e||!s?!1:this.getComparisonKey(e,a)===this.getComparisonKey(s,a)}getComparisonKey(e,s=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,s,a=!1){if(e.scheme===s.scheme){if(e.scheme===i.Schemas.file)return v.isEqualOrParent(d(e),d(s),this.a(e))&&e.query===s.query&&(a||e.fragment===s.fragment);if((0,t.isEqualAuthority)(e.authority,s.authority))return v.isEqualOrParent(e.path,s.path,this.a(e),"/")&&e.query===s.query&&(a||e.fragment===s.fragment)}return!1}joinPath(e,...s){return w.URI.joinPath(e,...s)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return z.posix.basename(e.path)}extname(e){return z.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let s;return e.scheme===i.Schemas.file?s=w.URI.file(z.dirname(d(e))).path:(s=z.posix.dirname(e.path),e.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),s="/")),e.with({path:s})}normalizePath(e){if(!e.path.length)return e;let s;return e.scheme===i.Schemas.file?s=w.URI.file(z.normalize(d(e))).path:s=z.posix.normalize(e.path),e.with({path:s})}relativePath(e,s){if(e.scheme!==s.scheme||!(0,t.isEqualAuthority)(e.authority,s.authority))return;if(e.scheme===i.Schemas.file){const h=z.relative(d(e),d(s));return H.isWindows?v.toSlashes(h):h}let a=e.path||"/";const l=s.path||"/";if(this.a(e)){let h=0;for(const r=Math.min(a.length,l.length);h<r&&!(a.charCodeAt(h)!==l.charCodeAt(h)&&a.charAt(h).toLowerCase()!==l.charAt(h).toLowerCase());h++);a=l.substr(0,h)+a.substr(h)}return z.posix.relative(a,l)}resolvePath(e,s){if(e.scheme===i.Schemas.file){const a=w.URI.file(z.resolve(d(e),s));return e.with({authority:a.authority,path:a.path})}return s=v.toPosixPath(s),e.with({path:z.posix.resolve(e.path,s)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,s){return e===s||e!==void 0&&s!==void 0&&(0,D.equalsIgnoreCase)(e,s)}hasTrailingPathSeparator(e,s=z.sep){if(e.scheme===i.Schemas.file){const a=d(e);return a.length>v.getRoot(a).length&&a[a.length-1]===s}else{const a=e.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,s=z.sep){return(0,t.hasTrailingPathSeparator)(e,s)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,s=z.sep){let a=!1;if(e.scheme===i.Schemas.file){const l=d(e);a=l!==void 0&&l.length===v.getRoot(l).length&&l[l.length-1]===s}else{s="/";const l=e.path;a=l.length===1&&l.charCodeAt(l.length-1)===47}return!a&&!(0,t.hasTrailingPathSeparator)(e,s)?e.with({path:e.path+"/"}):e}}t.ExtUri=m,t.extUri=new m(()=>!1),t.extUriBiasedIgnorePathCase=new m(n=>n.scheme===i.Schemas.file?!H.isLinux:!0),t.extUriIgnorePathCase=new m(n=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function g(n,e){const s=[];for(let a=0;a<n.length;a++){const l=e(n[a]);n.some((h,r)=>r===a?!1:(0,t.isEqualOrParent)(l,e(h)))||s.push(n[a])}return s}t.distinctParents=g;var I;(function(n){n.META_DATA_LABEL="label",n.META_DATA_DESCRIPTION="description",n.META_DATA_SIZE="size",n.META_DATA_MIME="mime";function e(s){const a=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(r=>{const[c,b]=r.split(":");c&&b&&a.set(c,b)});const h=s.path.substring(0,s.path.indexOf(";"));return h&&a.set(n.META_DATA_MIME,h),a}n.parseMetaData=e})(I=t.DataUri||(t.DataUri={}));function o(n,e,s){if(e){let a=n.path;return a&&a[0]!==z.posix.sep&&(a=z.posix.sep+a),n.with({scheme:s,authority:e,path:a})}return n.with({scheme:s})}t.toLocalResource=o}),define(me[8],be([1,0,26,9,3,2,35,5]),function(Z,t,v,i,z,H,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createCancelableAsyncIterable=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.firstParallel=t.first=t.sequence=t.disposableTimeout=t.timeout=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.MicrotaskDelay=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellationError=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0;function d(A){return!!A&&typeof A.then=="function"}t.isThenable=d;function m(A){const E=new v.CancellationTokenSource,u=A(E.token),B=new Promise((W,$)=>{const Y=E.token.onCancellationRequested(()=>{Y.dispose(),E.dispose(),$(new i.CancellationError)});Promise.resolve(u).then(F=>{Y.dispose(),E.dispose(),W(F)},F=>{Y.dispose(),E.dispose(),$(F)})});return new class{cancel(){E.cancel()}then(W,$){return B.then(W,$)}catch(W){return this.then(void 0,W)}finally(W){return B.finally(W)}}}t.createCancelablePromise=m;function g(A,E,u){return new Promise((B,W)=>{const $=E.onCancellationRequested(()=>{$.dispose(),B(u)});A.then(B,W).finally(()=>$.dispose())})}t.raceCancellation=g;function I(A,E){return new Promise((u,B)=>{const W=E.onCancellationRequested(()=>{W.dispose(),B(new i.CancellationError)});A.then(u,B).finally(()=>W.dispose())})}t.raceCancellationError=I;async function o(A){let E=-1;const u=A.map((W,$)=>W.then(Y=>(E=$,Y))),B=await Promise.race(u);return A.forEach((W,$)=>{$!==E&&W.cancel()}),B}t.raceCancellablePromises=o;function n(A,E,u){let B;const W=setTimeout(()=>{B?.(void 0),u?.()},E);return Promise.race([A.finally(()=>clearTimeout(W)),new Promise($=>B=$)])}t.raceTimeout=n;function e(A){return new Promise((E,u)=>{const B=A();d(B)?B.then(E,u):E(B)})}t.asPromise=e;class s{constructor(){this.a=null,this.b=null,this.d=null}queue(E){if(this.a){if(this.d=E,!this.b){const u=()=>{this.b=null;const B=this.queue(this.d);return this.d=null,B};this.b=new Promise(B=>{this.a.then(u,u).then(B)})}return new Promise((u,B)=>{this.b.then(u,B)})}return this.a=E(),new Promise((u,B)=>{this.a.then(W=>{this.a=null,u(W)},W=>{this.a=null,B(W)})})}}t.Throttler=s;class a{constructor(){this.a=Promise.resolve(null)}queue(E){return this.a=this.a.then(()=>E(),()=>E())}}t.Sequencer=a;class l{constructor(){this.a=new Map}queue(E,u){const W=(this.a.get(E)??Promise.resolve()).catch(()=>{}).then(u).finally(()=>{this.a.get(E)===W&&this.a.delete(E)});return this.a.set(E,W),W}}t.SequencerByKey=l;const h=(A,E)=>{let u=!0;const B=setTimeout(()=>{u=!1,E()},A);return{isTriggered:()=>u,dispose:()=>{clearTimeout(B),u=!1}}},r=A=>{let E=!0;return queueMicrotask(()=>{E&&(E=!1,A())}),{isTriggered:()=>E,dispose:()=>{E=!1}}};t.MicrotaskDelay=Symbol("MicrotaskDelay");class c{constructor(E){this.defaultDelay=E,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(E,u=this.defaultDelay){this.g=E,this.h(),this.b||(this.b=new Promise((W,$)=>{this.d=W,this.f=$}).then(()=>{if(this.b=null,this.d=null,this.g){const W=this.g;return this.g=null,W()}}));const B=()=>{this.a=null,this.d?.(null)};return this.a=u===t.MicrotaskDelay?r(B):h(u,B),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new i.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.Delayer=c;class b{constructor(E){this.a=new c(E),this.b=new s}trigger(E,u){return this.a.trigger(()=>this.b.queue(E),u)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}t.ThrottledDelayer=b;class S{constructor(){this.a=!1,this.b=new Promise((E,u)=>{this.d=E})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.Barrier=S;class N extends S{constructor(E){super(),this.f=setTimeout(()=>this.open(),E)}open(){clearTimeout(this.f),super.open()}}t.AutoOpenBarrier=N;function L(A,E){return E?new Promise((u,B)=>{const W=setTimeout(()=>{$.dispose(),u()},A),$=E.onCancellationRequested(()=>{clearTimeout(W),$.dispose(),B(new i.CancellationError)})}):m(u=>L(A,u))}t.timeout=L;function T(A,E=0){const u=setTimeout(A,E);return(0,H.toDisposable)(()=>clearTimeout(u))}t.disposableTimeout=T;function f(A){const E=[];let u=0;const B=A.length;function W(){return u<B?A[u++]():null}function $(Y){Y!=null&&E.push(Y);const F=W();return F?F.then($):Promise.resolve(E)}return Promise.resolve(null).then($)}t.sequence=f;function C(A,E=B=>!!B,u=null){let B=0;const W=A.length,$=()=>{if(B>=W)return Promise.resolve(u);const Y=A[B++];return Promise.resolve(Y()).then(O=>E(O)?Promise.resolve(O):$())};return $()}t.first=C;function p(A,E=B=>!!B,u=null){if(A.length===0)return Promise.resolve(u);let B=A.length;const W=()=>{B=-1;for(const $ of A)$.cancel?.()};return new Promise(($,Y)=>{for(const F of A)F.then(O=>{--B>=0&&E(O)?(W(),$(O)):B===0&&$(u)}).catch(O=>{--B>=0&&(W(),Y(O))})})}t.firstParallel=p;class y{constructor(E){this.a=0,this.d=E,this.f=[],this.b=0,this.g=new z.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(E){return this.a++,new Promise((u,B)=>{this.f.push({factory:E,c:u,e:B}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const E=this.f.shift();this.b++;const u=E.factory();u.then(E.c,E.e),u.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.Limiter=y;class _ extends y{constructor(){super(1)}}t.Queue=_;class V{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const E=new Ne;return this.b.add(E),E.p}d(){for(const[,E]of this.a)if(E.size>0)return!1;return!0}queueFor(E,u=D.extUri){const B=u.getComparisonKey(E);let W=this.a.get(B);return W||(W=new _,z.Event.once(W.onDrained)(()=>{W?.dispose(),this.a.delete(B),this.f()}),this.a.set(B,W)),W}f(){!this.d()||this.g()}g(){for(const E of this.b)E.complete();this.b.clear()}dispose(){for(const[,E]of this.a)E.dispose();this.a.clear(),this.g()}}t.ResourceQueue=V;class ge{constructor(E,u){this.a=-1,typeof E=="function"&&typeof u=="number"&&this.setIfNotSet(E,u)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(E,u){this.cancel(),this.a=setTimeout(()=>{this.a=-1,E()},u)}setIfNotSet(E,u){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,E()},u))}}t.TimeoutTimer=ge;class Q{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(E,u){this.cancel(),this.a=setInterval(()=>{E()},u)}}t.IntervalTimer=Q;class ie{constructor(E,u){this.b=-1,this.a=E,this.d=u,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(E=this.d){this.cancel(),this.b=setTimeout(this.f,E)}get delay(){return this.d}set delay(E){this.d=E}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.RunOnceScheduler=ie;class te{constructor(E,u){u%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${u}ms is not a multiple of 1000ms.`),this.a=E,this.b=u,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(E=this.b){E%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${E}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(E/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.ProcessTimeRunOnceScheduler=te;class ue extends ie{constructor(E,u){super(E,u),this.j=[]}work(E){this.j.push(E),this.isScheduled()||this.schedule()}h(){const E=this.j;this.j=[],this.a?.(E)}dispose(){this.j=[],super.dispose()}}t.RunOnceWorker=ue;class ae extends H.Disposable{constructor(E,u){super(),this.g=E,this.h=u,this.a=[],this.b=this.B(new H.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(E){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+E.length>this.g.maxBufferedWork)return!1}else if(this.pending+E.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(...E),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ie(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.ThrottledWorker=ae,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.runWhenIdle=A=>{(0,w.setTimeout0)(()=>{if(E)return;const u=Date.now()+15;A(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,u-Date.now())}}))});let E=!1;return{dispose(){E||(E=!0)}}}:t.runWhenIdle=(A,E)=>{const u=requestIdleCallback(A,typeof E=="number"?{timeout:E}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(u))}}}}();class de{constructor(E){this.d=!1,this.a=()=>{try{this.f=E()}catch(u){this.g=u}finally{this.d=!0}},this.b=(0,t.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}t.IdleValue=de;async function Ae(A,E,u){let B;for(let W=0;W<u;W++)try{return await A()}catch($){B=$,await L(E)}throw B}t.retry=Ae;class x{hasPending(E){return this.a?typeof E=="number"?this.a.taskId===E:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(E,u,B){return this.a={taskId:E,cancel:()=>B?.(),promise:u},u.then(()=>this.d(E),()=>this.d(E)),u}d(E){this.a&&E===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const E=this.b;this.b=void 0,E.run().then(E.promiseResolve,E.promiseReject)}}setNext(E){if(this.b)this.b.run=E;else{let u,B;const W=new Promise(($,Y)=>{u=$,B=Y});this.b={run:E,promise:W,promiseResolve:u,promiseReject:B}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.TaskSequentializer=x;class ve{constructor(E,u=()=>Date.now()){this.d=E,this.f=u,this.a=0,this.b=0}increment(){const E=this.f();return E-this.a>this.d&&(this.a=E,this.b=0),this.b++,this.b}}t.IntervalCounter=ve;class Ne{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((E,u)=>{this.a=E,this.b=u})}complete(E){return new Promise(u=>{this.a(E),this.f=!0,u()})}error(E){return new Promise(u=>{this.b(E),this.d=!0,u()})}cancel(){new Promise(E=>{this.b(new i.CancellationError),this.d=!0,E()})}}t.DeferredPromise=Ne;var oe;(function(A){async function E(B){let W;const $=await Promise.all(B.map(Y=>Y.then(F=>F,F=>{W||(W=F)})));if(typeof W<"u")throw W;return $}A.settled=E;function u(B){return new Promise(async(W,$)=>{try{await B(W,$)}catch(Y){$(Y)}})}A.withAsyncBody=u})(oe=t.Promises||(t.Promises={}));var X;(function(A){A[A.Initial=0]="Initial",A[A.DoneOK=1]="DoneOK",A[A.DoneError=2]="DoneError"})(X||(X={}));class se{static fromArray(E){return new se(u=>{u.emitMany(E)})}static fromPromise(E){return new se(async u=>{u.emitMany(await E)})}static fromPromises(E){return new se(async u=>{await Promise.all(E.map(async B=>u.emitOne(await B)))})}static merge(E){return new se(async u=>{await Promise.all(E.map(async B=>{for await(const W of B)u.emitOne(W)}))})}constructor(E){this.a=0,this.b=[],this.d=null,this.f=new z.Emitter,queueMicrotask(async()=>{const u={emitOne:B=>this.g(B),emitMany:B=>this.h(B),reject:B=>this.k(B)};try{await Promise.resolve(E(u)),this.j()}catch(B){this.k(B)}finally{u.emitOne=void 0,u.emitMany=void 0,u.reject=void 0}})}[Symbol.asyncIterator](){let E=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(E<this.b.length)return{done:!1,value:this.b[E++]};if(this.a===1)return{done:!0,value:void 0};await z.Event.toPromise(this.f.event)}while(!0)}}}static map(E,u){return new se(async B=>{for await(const W of E)B.emitOne(u(W))})}map(E){return se.map(this,E)}static filter(E,u){return new se(async B=>{for await(const W of E)u(W)&&B.emitOne(W)})}filter(E){return se.filter(this,E)}static coalesce(E){return se.filter(E,u=>!!u)}coalesce(){return se.coalesce(this)}static async toPromise(E){const u=[];for await(const B of E)u.push(B);return u}toPromise(){return se.toPromise(this)}g(E){this.a===0&&(this.b.push(E),this.f.fire())}h(E){this.a===0&&(this.b=this.b.concat(E),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(E){this.a===0&&(this.a=2,this.d=E,this.f.fire())}}t.AsyncIterableObject=se,se.EMPTY=se.fromArray([]);class ne extends se{constructor(E,u){super(u),this.l=E}cancel(){this.l.cancel()}}t.CancelableAsyncIterableObject=ne;function ee(A){const E=new v.CancellationTokenSource,u=A(E.token);return new ne(E,async B=>{const W=E.token.onCancellationRequested(()=>{W.dispose(),E.dispose(),B.reject(new i.CancellationError)});try{for await(const $ of u){if(E.token.isCancellationRequested)return;B.emitOne($)}W.dispose(),E.dispose()}catch($){W.dispose(),E.dispose(),B.reject($)}})}t.createCancelableAsyncIterable=ee}),define(me[4],be([1,0,16,108,17,20,8,9,3,114,2,34,5,6,15]),function(Z,t,v,i,z,H,D,w,d,m,g,I,o,n,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.DragAndDropObserver=t.getCookieValue=t.ModifierKeyEmitter=t.multibyteAwareBtoa=t.safeInnerHtml=t.basicMarkupHtmlTags=t.hookDomPurifyHrefAndSrcSanitizer=t.detectFullscreen=t.DetectedFullscreenMode=t.triggerUpload=t.triggerDownload=t.asCssValueWithDefault=t.asCSSPropertyValue=t.asCSSUrl=t.animate=t.windowOpenWithSuccess=t.windowOpenPopup=t.windowOpenNoOpener=t.computeScreenAwareSize=t.domContentLoaded=t.finalHandler=t.removeTabIndexAndUpdateFocus=t.hide=t.show=t.join=t.$=t.Namespace=t.reset=t.prepend=t.append=t.after=t.trackFocus=t.restoreParentsScrollTop=t.saveParentsScrollTop=t.EventHelper=t.isEventLike=t.EventType=t.isHTMLElement=t.removeCSSRulesContainingSelector=t.createCSSRule=t.createMetaElement=t.createStyleSheet=t.getActiveElement=t.getShadowRoot=t.isInShadowDOM=t.isShadowRoot=t.hasParentWithClass=t.findParentWithClass=t.isAncestorUsingFlowTo=t.setParentFlowTo=t.isAncestor=t.getLargestChildWidth=t.getTotalHeight=t.getContentHeight=t.getTotalScrollWidth=t.getContentWidth=t.getTotalWidth=t.getDomNodeZoomLevel=t.getDomNodePagePosition=t.position=t.size=t.getTopLeftOffset=t.Dimension=t.getClientArea=t.getComputedStyle=t.addDisposableThrottledListener=t.modify=t.measure=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.addDisposableGenericMouseUpListener=t.addDisposableGenericMouseMoveListener=t.addDisposableGenericMouseDownListener=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.addDisposableListener=t.isInDOM=t.clearNode=void 0;function s(G){for(;G.firstChild;)G.firstChild.remove()}t.clearNode=s;function a(G){return G?.isConnected??!1}t.isInDOM=a;class l{constructor(q,fe,ke,Te){this.f=q,this.g=fe,this.d=ke,this.j=Te||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){!this.d||(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function h(G,q,fe,ke){return new l(G,q,fe,ke)}t.addDisposableListener=h;function r(G){return function(q){return G(new H.StandardMouseEvent(q))}}function c(G){return function(q){return G(new z.StandardKeyboardEvent(q))}}const b=function(q,fe,ke,Te){let Ve=ke;return fe==="click"||fe==="mousedown"?Ve=r(ke):(fe==="keydown"||fe==="keypress"||fe==="keyup")&&(Ve=c(ke)),h(q,fe,Ve,Te)};t.addStandardDisposableListener=b;const S=function(q,fe,ke){const Te=r(fe);return L(q,Te,ke)};t.addStandardDisposableGenericMouseDownListener=S;const N=function(q,fe,ke){const Te=r(fe);return f(q,Te,ke)};t.addStandardDisposableGenericMouseUpListener=N;function L(G,q,fe){return h(G,o.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,q,fe)}t.addDisposableGenericMouseDownListener=L;function T(G,q,fe){return h(G,o.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,q,fe)}t.addDisposableGenericMouseMoveListener=T;function f(G,q,fe){return h(G,o.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,q,fe)}t.addDisposableGenericMouseUpListener=f;class C{constructor(q,fe=0){this.d=q,this.priority=fe,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(q){(0,w.onUnexpectedError)(q)}}static sort(q,fe){return fe.priority-q.priority}}(function(){let G=[],q=null,fe=!1,ke=!1;const Te=()=>{for(fe=!1,q=G,G=[],ke=!0;q.length>0;)q.sort(C.sort),q.shift().execute();ke=!1};t.scheduleAtNextAnimationFrame=(Ve,_e=0)=>{const Xe=new C(Ve,_e);return G.push(Xe),fe||(fe=!0,requestAnimationFrame(Te)),Xe},t.runAtThisOrScheduleAtNextAnimationFrame=(Ve,_e)=>{if(ke){const Xe=new C(Ve,_e);return q.push(Xe),Xe}else return(0,t.scheduleAtNextAnimationFrame)(Ve,_e)}})();function p(G){return(0,t.scheduleAtNextAnimationFrame)(G,1e4)}t.measure=p;function y(G){return(0,t.scheduleAtNextAnimationFrame)(G,-1e4)}t.modify=y;const _=8,V=function(G,q){return q};class ge extends g.Disposable{constructor(q,fe,ke,Te=V,Ve=_){super();let _e=null,Xe=0;const Je=this.B(new D.TimeoutTimer),ft=()=>{Xe=new Date().getTime(),ke(_e),_e=null};this.B(h(q,fe,Lt=>{_e=Te(_e,Lt);const gt=new Date().getTime()-Xe;gt>=Ve?(Je.cancel(),ft()):Je.setIfNotSet(ft,Ve-gt)}))}}function Q(G,q,fe,ke,Te){return new ge(G,q,fe,ke,Te)}t.addDisposableThrottledListener=Q;function ie(G){return document.defaultView.getComputedStyle(G,null)}t.getComputedStyle=ie;function te(G){if(G!==document.body)return new ae(G.clientWidth,G.clientHeight);if(o.isIOS&&window.visualViewport)return new ae(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new ae(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new ae(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new ae(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.getClientArea=te;class ue{static d(q,fe){return parseFloat(fe)||0}static f(q,fe,ke){const Te=ie(q),Ve=Te?Te.getPropertyValue(fe):"0";return ue.d(q,Ve)}static getBorderLeftWidth(q){return ue.f(q,"border-left-width","borderLeftWidth")}static getBorderRightWidth(q){return ue.f(q,"border-right-width","borderRightWidth")}static getBorderTopWidth(q){return ue.f(q,"border-top-width","borderTopWidth")}static getBorderBottomWidth(q){return ue.f(q,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(q){return ue.f(q,"padding-left","paddingLeft")}static getPaddingRight(q){return ue.f(q,"padding-right","paddingRight")}static getPaddingTop(q){return ue.f(q,"padding-top","paddingTop")}static getPaddingBottom(q){return ue.f(q,"padding-bottom","paddingBottom")}static getMarginLeft(q){return ue.f(q,"margin-left","marginLeft")}static getMarginTop(q){return ue.f(q,"margin-top","marginTop")}static getMarginRight(q){return ue.f(q,"margin-right","marginRight")}static getMarginBottom(q){return ue.f(q,"margin-bottom","marginBottom")}}class ae{constructor(q,fe){this.width=q,this.height=fe}with(q=this.width,fe=this.height){return q!==this.width||fe!==this.height?new ae(q,fe):this}static is(q){return typeof q=="object"&&typeof q.height=="number"&&typeof q.width=="number"}static lift(q){return q instanceof ae?q:new ae(q.width,q.height)}static equals(q,fe){return q===fe?!0:!q||!fe?!1:q.width===fe.width&&q.height===fe.height}}t.Dimension=ae,ae.None=new ae(0,0);function de(G){let q=G.offsetParent,fe=G.offsetTop,ke=G.offsetLeft;for(;(G=G.parentNode)!==null&&G!==document.body&&G!==document.documentElement;){fe-=G.scrollTop;const Te=U(G)?null:ie(G);Te&&(ke-=Te.direction!=="rtl"?G.scrollLeft:-G.scrollLeft),G===q&&(ke+=ue.getBorderLeftWidth(G),fe+=ue.getBorderTopWidth(G),fe+=G.offsetTop,ke+=G.offsetLeft,q=G.offsetParent)}return{left:ke,top:fe}}t.getTopLeftOffset=de;function Ae(G,q,fe){typeof q=="number"&&(G.style.width=`${q}px`),typeof fe=="number"&&(G.style.height=`${fe}px`)}t.size=Ae;function x(G,q,fe,ke,Te,Ve="absolute"){typeof q=="number"&&(G.style.top=`${q}px`),typeof fe=="number"&&(G.style.right=`${fe}px`),typeof ke=="number"&&(G.style.bottom=`${ke}px`),typeof Te=="number"&&(G.style.left=`${Te}px`),G.style.position=Ve}t.position=x;function ve(G){const q=G.getBoundingClientRect();return{left:q.left+window.scrollX,top:q.top+window.scrollY,width:q.width,height:q.height}}t.getDomNodePagePosition=ve;function Ne(G){let q=G,fe=1;do{const ke=ie(q).zoom;ke!=null&&ke!=="1"&&(fe*=ke),q=q.parentElement}while(q!==null&&q!==document.documentElement);return fe}t.getDomNodeZoomLevel=Ne;function oe(G){const q=ue.getMarginLeft(G)+ue.getMarginRight(G);return G.offsetWidth+q}t.getTotalWidth=oe;function X(G){const q=ue.getBorderLeftWidth(G)+ue.getBorderRightWidth(G),fe=ue.getPaddingLeft(G)+ue.getPaddingRight(G);return G.offsetWidth-q-fe}t.getContentWidth=X;function se(G){const q=ue.getMarginLeft(G)+ue.getMarginRight(G);return G.scrollWidth+q}t.getTotalScrollWidth=se;function ne(G){const q=ue.getBorderTopWidth(G)+ue.getBorderBottomWidth(G),fe=ue.getPaddingTop(G)+ue.getPaddingBottom(G);return G.offsetHeight-q-fe}t.getContentHeight=ne;function ee(G){const q=ue.getMarginTop(G)+ue.getMarginBottom(G);return G.offsetHeight+q}t.getTotalHeight=ee;function A(G,q){if(G===null)return 0;const fe=de(G),ke=de(q);return fe.left-ke.left}function E(G,q){const fe=q.map(Te=>Math.max(se(Te),oe(Te))+A(Te,G)||0);return Math.max(...fe)}t.getLargestChildWidth=E;function u(G,q){for(;G;){if(G===q)return!0;G=G.parentNode}return!1}t.isAncestor=u;const B="parentFlowToElementId";function W(G,q){G.dataset[B]=q.id}t.setParentFlowTo=W;function $(G){const q=G.dataset[B];return typeof q=="string"?document.getElementById(q):null}function Y(G,q){let fe=G;for(;fe;){if(fe===q)return!0;if(fe instanceof HTMLElement){const ke=$(fe);if(ke){fe=ke;continue}}fe=fe.parentNode}return!1}t.isAncestorUsingFlowTo=Y;function F(G,q,fe){for(;G&&G.nodeType===G.ELEMENT_NODE;){if(G.classList.contains(q))return G;if(fe){if(typeof fe=="string"){if(G.classList.contains(fe))return null}else if(G===fe)return null}G=G.parentNode}return null}t.findParentWithClass=F;function O(G,q,fe){return!!F(G,q,fe)}t.hasParentWithClass=O;function U(G){return G&&!!G.host&&!!G.mode}t.isShadowRoot=U;function k(G){return!!M(G)}t.isInShadowDOM=k;function M(G){for(;G.parentNode;){if(G===document.body)return null;G=G.parentNode}return U(G)?G:null}t.getShadowRoot=M;function P(){let G=document.activeElement;for(;G?.shadowRoot;)G=G.shadowRoot.activeElement;return G}t.getActiveElement=P;function R(G=document.getElementsByTagName("head")[0]){const q=document.createElement("style");return q.type="text/css",q.media="screen",G.appendChild(q),q}t.createStyleSheet=R;function j(G=document.getElementsByTagName("head")[0]){const q=document.createElement("meta");return G.appendChild(q),q}t.createMetaElement=j;let J=null;function he(){return J||(J=R()),J}function ce(G){return G?.sheet?.rules?G.sheet.rules:G?.sheet?.cssRules?G.sheet.cssRules:[]}function De(G,q,fe=he()){!fe||!q||fe.sheet.insertRule(G+"{"+q+"}",0)}t.createCSSRule=De;function ye(G,q=he()){if(!q)return;const fe=ce(q),ke=[];for(let Te=0;Te<fe.length;Te++)fe[Te].selectorText.indexOf(G)!==-1&&ke.push(Te);for(let Te=ke.length-1;Te>=0;Te--)q.sheet.deleteRule(ke[Te])}t.removeCSSRulesContainingSelector=ye;function Ie(G){return typeof HTMLElement=="object"?G instanceof HTMLElement:G&&typeof G=="object"&&G.nodeType===1&&typeof G.nodeName=="string"}t.isHTMLElement=Ie,t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:v.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:v.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:v.isWebKit?"webkitAnimationIteration":"animationiteration"};function Se(G){const q=G;return!!(q&&typeof q.preventDefault=="function"&&typeof q.stopPropagation=="function")}t.isEventLike=Se,t.EventHelper={stop:(G,q)=>(G.preventDefault(),q&&G.stopPropagation(),G)};function we(G){const q=[];for(let fe=0;G&&G.nodeType===G.ELEMENT_NODE;fe++)q[fe]=G.scrollTop,G=G.parentNode;return q}t.saveParentsScrollTop=we;function Re(G,q){for(let fe=0;G&&G.nodeType===G.ELEMENT_NODE;fe++)G.scrollTop!==q[fe]&&(G.scrollTop=q[fe]),G=G.parentNode}t.restoreParentsScrollTop=Re;class Pe extends g.Disposable{static l(q){const fe=M(q),ke=fe?fe.activeElement:document.activeElement;return u(ke,q)}constructor(q){super(),this.f=this.B(new d.Emitter),this.onDidFocus=this.f.event,this.g=this.B(new d.Emitter),this.onDidBlur=this.g.event;let fe=Pe.l(q),ke=!1;const Te=()=>{ke=!1,fe||(fe=!0,this.f.fire())},Ve=()=>{fe&&(ke=!0,window.setTimeout(()=>{ke&&(ke=!1,fe=!1,this.g.fire())},0))};this.j=()=>{Pe.l(q)!==fe&&(fe?Ve():Te())},this.B(h(q,t.EventType.FOCUS,Te,!0)),this.B(h(q,t.EventType.BLUR,Ve,!0)),this.B(h(q,t.EventType.FOCUS_IN,()=>this.j())),this.B(h(q,t.EventType.FOCUS_OUT,()=>this.j()))}refreshState(){this.j()}}function Ke(G){return new Pe(G)}t.trackFocus=Ke;function Ue(G,q){return G.after(q),q}t.after=Ue;function We(G,...q){if(G.append(...q),q.length===1&&typeof q[0]!="string")return q[0]}t.append=We;function xe(G,q){return G.insertBefore(q,G.firstChild),q}t.prepend=xe;function it(G,...q){G.innerText="",We(G,...q)}t.reset=it;const Be=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var je;(function(G){G.HTML="http://www.w3.org/1999/xhtml",G.SVG="http://www.w3.org/2000/svg"})(je=t.Namespace||(t.Namespace={}));function Ye(G,q,fe,...ke){const Te=Be.exec(q);if(!Te)throw new Error("Bad use of emmet");const Ve=Te[1]||"div";let _e;return G!==je.HTML?_e=document.createElementNS(G,Ve):_e=document.createElement(Ve),Te[3]&&(_e.id=Te[3]),Te[4]&&(_e.className=Te[4].replace(/\./g," ").trim()),fe&&Object.entries(fe).forEach(([Xe,Je])=>{typeof Je>"u"||(/^on\w+$/.test(Xe)?_e[Xe]=Je:Xe==="selected"?Je&&_e.setAttribute(Xe,"true"):_e.setAttribute(Xe,Je))}),_e.append(...ke),_e}function K(G,q,...fe){return Ye(je.HTML,G,q,...fe)}t.$=K,K.SVG=function(G,q,...fe){return Ye(je.SVG,G,q,...fe)};function le(G,q){const fe=[];return G.forEach((ke,Te)=>{Te>0&&(q instanceof Node?fe.push(q.cloneNode()):fe.push(document.createTextNode(q))),fe.push(ke)}),fe}t.join=le;function pe(...G){for(const q of G)q.style.display="",q.removeAttribute("aria-hidden")}t.show=pe;function Ee(...G){for(const q of G)q.style.display="none",q.setAttribute("aria-hidden","true")}t.hide=Ee;function Fe(G,q){for(;G&&G.nodeType===G.ELEMENT_NODE;){if(G instanceof HTMLElement&&G.hasAttribute(q))return G;G=G.parentNode}return null}function Oe(G){!G||!G.hasAttribute("tabIndex")||(document.activeElement===G&&Fe(G.parentElement,"tabIndex")?.focus(),G.removeAttribute("tabindex"))}t.removeTabIndexAndUpdateFocus=Oe;function $e(G){return q=>{q.preventDefault(),q.stopPropagation(),G(q)}}t.finalHandler=$e;function tt(){return new Promise(G=>{document.readyState==="complete"||document&&document.body!==null?G(void 0):window.addEventListener("DOMContentLoaded",G,!1)})}t.domContentLoaded=tt;function Me(G){const q=window.devicePixelRatio*G;return Math.max(1,Math.floor(q))/window.devicePixelRatio}t.computeScreenAwareSize=Me;function re(G){window.open(G,"_blank","noopener")}t.windowOpenNoOpener=re;const Ce=780,Le=640;function ze(G){const q=Math.floor(window.screenLeft+window.innerWidth/2-Ce/2),fe=Math.floor(window.screenTop+window.innerHeight/2-Le/2);window.open(G,"_blank",`width=${Ce},height=${Le},top=${fe},left=${q}`)}t.windowOpenPopup=ze;function Ge(G,q=!0){const fe=window.open();return fe?(q&&(fe.opener=null),fe.location.href=G,!0):!1}t.windowOpenWithSuccess=Ge;function Ze(G){const q=()=>{G(),fe=(0,t.scheduleAtNextAnimationFrame)(q)};let fe=(0,t.scheduleAtNextAnimationFrame)(q);return(0,g.toDisposable)(()=>fe.dispose())}t.animate=Ze,I.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function Qe(G){return G?`url('${I.FileAccess.uriToBrowserUri(G).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.asCSSUrl=Qe;function st(G){return`'${G.replace(/'/g,"%27")}'`}t.asCSSPropertyValue=st;function ht(G,q){if(G!==void 0){const fe=G.match(/^\s*var\((.+)\)$/);if(fe){const ke=fe[1].split(",",2);return ke.length===2&&(q=ht(ke[1].trim(),q)),`var(${ke[0]}, ${q})`}return G}return q}t.asCssValueWithDefault=ht;function Et(G,q){let fe;if(e.URI.isUri(G))fe=G.toString(!0);else{const Te=new Blob([G]);fe=URL.createObjectURL(Te),setTimeout(()=>URL.revokeObjectURL(fe))}const ke=document.createElement("a");document.body.appendChild(ke),ke.download=q,ke.href=fe,ke.click(),setTimeout(()=>document.body.removeChild(ke))}t.triggerDownload=Et;function Tt(){return new Promise(G=>{const q=document.createElement("input");document.body.appendChild(q),q.type="file",q.multiple=!0,d.Event.once(d.Event.fromDOMEventEmitter(q,"input"))(()=>{G((0,n.withNullAsUndefined)(q.files))}),q.click(),setTimeout(()=>document.body.removeChild(q))})}t.triggerUpload=Tt;var wt;(function(G){G[G.DOCUMENT=1]="DOCUMENT",G[G.BROWSER=2]="BROWSER"})(wt=t.DetectedFullscreenMode||(t.DetectedFullscreenMode={}));function ui(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:wt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:wt.BROWSER,guess:!1}:(o.isMacintosh||o.isLinux)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:wt.BROWSER,guess:!0}:null}t.detectFullscreen=ui;function Wt(G,q=!1){const fe=document.createElement("a");return m.addHook("afterSanitizeAttributes",ke=>{for(const Te of["href","src"])if(ke.hasAttribute(Te)){const Ve=ke.getAttribute(Te);if(Te==="href"&&Ve.startsWith("#"))continue;if(fe.href=Ve,!G.includes(fe.protocol.replace(/:$/,""))){if(q&&Te==="src"&&fe.href.startsWith("data:"))continue;ke.removeAttribute(Te)}}}),(0,g.toDisposable)(()=>{m.removeHook("afterSanitizeAttributes")})}t.hookDomPurifyHrefAndSrcSanitizer=Wt;const ci=[I.Schemas.http,I.Schemas.https,I.Schemas.command];t.basicMarkupHtmlTags=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const di=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function fi(G,q){const fe=Wt(ci);try{const ke=m.sanitize(q,di);G.innerHTML=ke}finally{fe.dispose()}}t.safeInnerHtml=fi;function gi(G){const q=new Uint16Array(G.length);for(let Te=0;Te<q.length;Te++)q[Te]=G.charCodeAt(Te);let fe="";const ke=new Uint8Array(q.buffer);for(let Te=0;Te<ke.length;Te++)fe+=String.fromCharCode(ke[Te]);return fe}function mi(G){return btoa(gi(G))}t.multibyteAwareBtoa=mi;class dt extends d.Emitter{constructor(){super(),this.s=new g.DisposableStore,this.t={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.s.add(h(window,"keydown",q=>{if(q.defaultPrevented)return;const fe=new z.StandardKeyboardEvent(q);if(!(fe.keyCode===6&&q.repeat)){if(q.altKey&&!this.t.altKey)this.t.lastKeyPressed="alt";else if(q.ctrlKey&&!this.t.ctrlKey)this.t.lastKeyPressed="ctrl";else if(q.metaKey&&!this.t.metaKey)this.t.lastKeyPressed="meta";else if(q.shiftKey&&!this.t.shiftKey)this.t.lastKeyPressed="shift";else if(fe.keyCode!==6)this.t.lastKeyPressed=void 0;else return;this.t.altKey=q.altKey,this.t.ctrlKey=q.ctrlKey,this.t.metaKey=q.metaKey,this.t.shiftKey=q.shiftKey,this.t.lastKeyPressed&&(this.t.event=q,this.fire(this.t))}},!0)),this.s.add(h(window,"keyup",q=>{q.defaultPrevented||(!q.altKey&&this.t.altKey?this.t.lastKeyReleased="alt":!q.ctrlKey&&this.t.ctrlKey?this.t.lastKeyReleased="ctrl":!q.metaKey&&this.t.metaKey?this.t.lastKeyReleased="meta":!q.shiftKey&&this.t.shiftKey?this.t.lastKeyReleased="shift":this.t.lastKeyReleased=void 0,this.t.lastKeyPressed!==this.t.lastKeyReleased&&(this.t.lastKeyPressed=void 0),this.t.altKey=q.altKey,this.t.ctrlKey=q.ctrlKey,this.t.metaKey=q.metaKey,this.t.shiftKey=q.shiftKey,this.t.lastKeyReleased&&(this.t.event=q,this.fire(this.t)))},!0)),this.s.add(h(document.body,"mousedown",()=>{this.t.lastKeyPressed=void 0},!0)),this.s.add(h(document.body,"mouseup",()=>{this.t.lastKeyPressed=void 0},!0)),this.s.add(h(document.body,"mousemove",q=>{q.buttons&&(this.t.lastKeyPressed=void 0)},!0)),this.s.add(h(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.t}get isModifierPressed(){return this.t.altKey||this.t.ctrlKey||this.t.metaKey||this.t.shiftKey}resetKeyStatus(){this.v(),this.fire(this.t)}v(){this.t={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return dt.u||(dt.u=new dt),dt.u}dispose(){super.dispose(),this.s.dispose()}}t.ModifierKeyEmitter=dt;function bi(G){const q=document.cookie.match("(^|[^;]+)\\s*"+G+"\\s*=\\s*([^;]+)");return q?q.pop():void 0}t.getCookieValue=bi;class pi extends g.Disposable{constructor(q,fe){super(),this.j=q,this.l=fe,this.f=0,this.g=0,this.m()}m(){this.B(h(this.j,t.EventType.DRAG_ENTER,q=>{this.f++,this.g=q.timeStamp,this.l.onDragEnter(q)})),this.B(h(this.j,t.EventType.DRAG_OVER,q=>{q.preventDefault(),this.l.onDragOver?.(q,q.timeStamp-this.g)})),this.B(h(this.j,t.EventType.DRAG_LEAVE,q=>{this.f--,this.f===0&&(this.g=0,this.l.onDragLeave(q))})),this.B(h(this.j,t.EventType.DRAG_END,q=>{this.f=0,this.g=0,this.l.onDragEnd(q)})),this.B(h(this.j,t.EventType.DROP,q=>{this.f=0,this.g=0,this.l.onDrop(q)}))}}t.DragAndDropObserver=pi;const wi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function vi(G,...q){let fe,ke;Array.isArray(q[0])?(fe={},ke=q[0]):(fe=q[0]||{},ke=q[1]);const Te=wi.exec(G);if(!Te||!Te.groups)throw new Error("Bad use of h");const Ve=Te.groups.tag||"div",_e=document.createElement(Ve);Te.groups.id&&(_e.id=Te.groups.id),Te.groups.class&&(_e.className=Te.groups.class.replace(/\./g," ").trim());const Xe={};if(Te.groups.name&&(Xe[Te.groups.name]=_e),ke)for(const Je of ke)Je instanceof HTMLElement?_e.appendChild(Je):typeof Je=="string"?_e.append(Je):(Object.assign(Xe,Je),_e.appendChild(Je.root));for(const[Je,ft]of Object.entries(fe))if(Je==="style")for(const[Lt,gt]of Object.entries(ft))_e.style.setProperty(_t(Lt),typeof gt=="number"?gt+"px":""+gt);else Je==="tabIndex"?_e.tabIndex=ft:_e.setAttribute(_t(Je),ft.toString());return Xe.root=_e,Xe}t.h=vi;function _t(G){return G.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(me[51],be([1,0,4,2,106]),function(Z,t,v,i,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.applyDragImage=t.DataTransfers=t.DelayedDragHandler=void 0;class H extends i.Disposable{constructor(d,m){super(),this.B((0,v.addDisposableListener)(d,"dragover",g=>{g.preventDefault(),this.a||(this.a=setTimeout(()=>{m(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(g=>{this.B((0,v.addDisposableListener)(d,g,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.DelayedDragHandler=H,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:z.Mimes.text};function D(w,d,m){const g=document.createElement("div");g.className=m,g.textContent=d,w.dataTransfer&&(document.body.appendChild(g),w.dataTransfer.setDragImage(g,-10,-10),setTimeout(()=>document.body.removeChild(g),0))}t.applyDragImage=D}),define(me[52],be([1,0,4]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createElement=t.renderFormattedText=t.renderText=void 0;function i(o,n={}){const e=H(n);return e.textContent=o,e}t.renderText=i;function z(o,n={}){const e=H(n);return d(e,m(o,!!n.renderCodeSegments),n.actionHandler,n.renderCodeSegments),e}t.renderFormattedText=z;function H(o){const n=o.inline?"span":"div",e=document.createElement(n);return o.className&&(e.className=o.className),e}t.createElement=H;class D{constructor(n){this.b=n,this.c=0}eos(){return this.c>=this.b.length}next(){const n=this.peek();return this.advance(),n}peek(){return this.b[this.c]}advance(){this.c++}}var w;(function(o){o[o.Invalid=0]="Invalid",o[o.Root=1]="Root",o[o.Text=2]="Text",o[o.Bold=3]="Bold",o[o.Italics=4]="Italics",o[o.Action=5]="Action",o[o.ActionClose=6]="ActionClose",o[o.Code=7]="Code",o[o.NewLine=8]="NewLine"})(w||(w={}));function d(o,n,e,s){let a;if(n.type===2)a=document.createTextNode(n.content||"");else if(n.type===3)a=document.createElement("b");else if(n.type===4)a=document.createElement("i");else if(n.type===7&&s)a=document.createElement("code");else if(n.type===5&&e){const l=document.createElement("a");e.disposables.add(v.addStandardDisposableListener(l,"click",h=>{e.callback(String(n.index),h)})),a=l}else n.type===8?a=document.createElement("br"):n.type===1&&(a=o);a&&o!==a&&o.appendChild(a),a&&Array.isArray(n.children)&&n.children.forEach(l=>{d(a,l,e,s)})}function m(o,n){const e={type:1,children:[]};let s=0,a=e;const l=[],h=new D(o);for(;!h.eos();){let r=h.next();const c=r==="\\"&&I(h.peek(),n)!==0;if(c&&(r=h.next()),!c&&g(r,n)&&r===h.peek()){h.advance(),a.type===2&&(a=l.pop());const b=I(r,n);if(a.type===b||a.type===5&&b===6)a=l.pop();else{const S={type:b,children:[]};b===5&&(S.index=s,s++),a.children.push(S),l.push(a),a=S}}else if(r===`
`)a.type===2&&(a=l.pop()),a.children.push({type:8});else if(a.type!==2){const b={type:2,content:r};a.children.push(b),l.push(a),a=b}else a.content+=r}return a.type===2&&(a=l.pop()),l.length,e}function g(o,n){return I(o,n)!==0}function I(o,n){switch(o){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return n?7:0;default:return 0}}}),define(me[53],be([1,0,4,2]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class z{constructor(){this.a=new i.DisposableStore,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(D,w){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const d=this.c;this.c=null,D&&d&&d(w)}isMonitoring(){return!!this.b}startMonitoring(D,w,d,m,g){this.isMonitoring()&&this.stopMonitoring(!1),this.b=m,this.c=g;let I=D;try{D.setPointerCapture(w),this.a.add((0,i.toDisposable)(()=>{try{D.releasePointerCapture(w)}catch{}}))}catch{I=window}this.a.add(v.addDisposableListener(I,v.EventType.POINTER_MOVE,o=>{if(o.buttons!==d){this.stopMonitoring(!0);return}o.preventDefault(),this.b(o)})),this.a.add(v.addDisposableListener(I,v.EventType.POINTER_UP,o=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=z});var qe=this&&this.__decorate||function(Z,t,v,i){var z=arguments.length,H=z<3?t:i===null?i=Object.getOwnPropertyDescriptor(t,v):i,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")H=Reflect.decorate(Z,t,v,i);else for(var w=Z.length-1;w>=0;w--)(D=Z[w])&&(H=(z<3?D(H):z>3?D(t,v,H):D(t,v))||H);return z>3&&H&&Object.defineProperty(t,v,H),H};define(me[22],be([1,0,4,14,24,2,45]),function(Z,t,v,i,z,H,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var w;(function(m){m.Tap="-monaco-gesturetap",m.Change="-monaco-gesturechange",m.Start="-monaco-gesturestart",m.End="-monaco-gesturesend",m.Contextmenu="-monaco-gesturecontextmenu"})(w=t.EventType||(t.EventType={}));class d extends H.Disposable{constructor(){super(),this.f=!1,this.g=new D.LinkedList,this.h=new D.LinkedList,this.k={},this.j=null,this.l=0,this.B(v.addDisposableListener(document,"touchstart",g=>this.n(g),{passive:!1})),this.B(v.addDisposableListener(document,"touchend",g=>this.p(g))),this.B(v.addDisposableListener(document,"touchmove",g=>this.v(g),{passive:!1}))}static addTarget(g){if(!d.isTouchDevice())return H.Disposable.None;d.b||(d.b=new d);const I=d.b.g.push(g);return(0,H.toDisposable)(I)}static ignoreTarget(g){if(!d.isTouchDevice())return H.Disposable.None;d.b||(d.b=new d);const I=d.b.h.push(g);return(0,H.toDisposable)(I)}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}n(g){const I=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let o=0,n=g.targetTouches.length;o<n;o++){const e=g.targetTouches.item(o);this.k[e.identifier]={id:e.identifier,initialTarget:e.target,initialTimeStamp:I,initialPageX:e.pageX,initialPageY:e.pageY,rollingTimestamps:[I],rollingPageX:[e.pageX],rollingPageY:[e.pageY]};const s=this.r(w.Start,e.target);s.pageX=e.pageX,s.pageY=e.pageY,this.s(s)}this.f&&(g.preventDefault(),g.stopPropagation(),this.f=!1)}p(g){const I=Date.now(),o=Object.keys(this.k).length;for(let n=0,e=g.changedTouches.length;n<e;n++){const s=g.changedTouches.item(n);if(!this.k.hasOwnProperty(String(s.identifier))){console.warn("move of an UNKNOWN touch",s);continue}const a=this.k[s.identifier],l=Date.now()-a.initialTimeStamp;if(l<d.c&&Math.abs(a.initialPageX-i.tail(a.rollingPageX))<30&&Math.abs(a.initialPageY-i.tail(a.rollingPageY))<30){const h=this.r(w.Tap,a.initialTarget);h.pageX=i.tail(a.rollingPageX),h.pageY=i.tail(a.rollingPageY),this.s(h)}else if(l>=d.c&&Math.abs(a.initialPageX-i.tail(a.rollingPageX))<30&&Math.abs(a.initialPageY-i.tail(a.rollingPageY))<30){const h=this.r(w.Contextmenu,a.initialTarget);h.pageX=i.tail(a.rollingPageX),h.pageY=i.tail(a.rollingPageY),this.s(h)}else if(o===1){const h=i.tail(a.rollingPageX),r=i.tail(a.rollingPageY),c=i.tail(a.rollingTimestamps)-a.rollingTimestamps[0],b=h-a.rollingPageX[0],S=r-a.rollingPageY[0],N=[...this.g].filter(L=>a.initialTarget instanceof Node&&L.contains(a.initialTarget));this.u(N,I,Math.abs(b)/c,b>0?1:-1,h,Math.abs(S)/c,S>0?1:-1,r)}this.s(this.r(w.End,a.initialTarget)),delete this.k[s.identifier]}this.f&&(g.preventDefault(),g.stopPropagation(),this.f=!1)}r(g,I){const o=document.createEvent("CustomEvent");return o.initEvent(g,!1,!0),o.initialTarget=I,o.tapCount=0,o}s(g){if(g.type===w.Tap){const I=new Date().getTime();let o=0;I-this.l>d.m?o=1:o=2,this.l=I,g.tapCount=o}else(g.type===w.Change||g.type===w.Contextmenu)&&(this.l=0);if(g.initialTarget instanceof Node){for(const I of this.h)if(I.contains(g.initialTarget))return;for(const I of this.g)I.contains(g.initialTarget)&&(I.dispatchEvent(g),this.f=!0)}}u(g,I,o,n,e,s,a,l){this.j=v.scheduleAtNextAnimationFrame(()=>{const h=Date.now(),r=h-I;let c=0,b=0,S=!0;o+=d.a*r,s+=d.a*r,o>0&&(S=!1,c=n*o*r),s>0&&(S=!1,b=a*s*r);const N=this.r(w.Change);N.translationX=c,N.translationY=b,g.forEach(L=>L.dispatchEvent(N)),S||this.u(g,h,o,n,e+c,s,a,l+b)})}v(g){const I=Date.now();for(let o=0,n=g.changedTouches.length;o<n;o++){const e=g.changedTouches.item(o);if(!this.k.hasOwnProperty(String(e.identifier))){console.warn("end of an UNKNOWN touch",e);continue}const s=this.k[e.identifier],a=this.r(w.Change,s.initialTarget);a.translationX=e.pageX-i.tail(s.rollingPageX),a.translationY=e.pageY-i.tail(s.rollingPageY),a.pageX=e.pageX,a.pageY=e.pageY,this.s(a),s.rollingPageX.length>3&&(s.rollingPageX.shift(),s.rollingPageY.shift(),s.rollingTimestamps.shift()),s.rollingPageX.push(e.pageX),s.rollingPageY.push(e.pageY),s.rollingTimestamps.push(I)}this.f&&(g.preventDefault(),g.stopPropagation(),this.f=!1)}}d.a=-.005,d.c=700,d.m=400,qe([z.memoize],d,"isTouchDevice",null),t.Gesture=d}),define(me[54],be([1,0,4,5,83]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.status=t.alert=t.setARIAContainer=void 0;const z=2e4;let H,D,w,d,m;function g(e){H=document.createElement("div"),H.className="monaco-aria-container";const s=()=>{const l=document.createElement("div");return l.className="monaco-alert",l.setAttribute("role","alert"),l.setAttribute("aria-atomic","true"),H.appendChild(l),l};D=s(),w=s();const a=()=>{const l=document.createElement("div");return l.className="monaco-status",l.setAttribute("role","complementary"),l.setAttribute("aria-live","polite"),l.setAttribute("aria-atomic","true"),H.appendChild(l),l};d=a(),m=a(),e.appendChild(H)}t.setARIAContainer=g;function I(e){!H||(D.textContent!==e?(v.clearNode(w),n(D,e)):(v.clearNode(D),n(w,e)))}t.alert=I;function o(e){!H||(i.isMacintosh?I(e):d.textContent!==e?(v.clearNode(m),n(d,e)):(v.clearNode(d),n(m,e)))}t.status=o;function n(e,s){v.clearNode(e),s.length>z&&(s=s.substr(0,z)),e.textContent=s,e.style.visibility="hidden",e.style.visibility="visible"}}),define(me[115],be([1,0,4,12]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderIcon=t.renderLabelWithIcons=void 0;const z=new RegExp(`(\\\\)?\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)`,"g");function H(w){const d=new Array;let m,g=0,I=0;for(;(m=z.exec(w))!==null;){I=m.index||0,g<I&&d.push(w.substring(g,I)),g=(m.index||0)+m[0].length;const[,o,n]=m;d.push(o?`$(${n})`:D({id:n}))}return g<w.length&&d.push(w.substring(g)),d}t.renderLabelWithIcons=H;function D(w){const d=v.$("span");return d.classList.add(...i.CSSIcon.asClassNameArray(w)),d}t.renderIcon=D}),define(me[116],be([1,0,4]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function i(H){try{H.parentElement?.removeChild(H)}catch{}}class z{constructor(D){this.d=D,this.a=new Map,this.b=new Set,this.c=!1}alloc(D){let w=this.h(D).pop(),d=!1;if(w)d=this.b.has(w.domNode),d&&this.b.delete(w.domNode);else{const m=(0,v.$)(".monaco-list-row"),I=this.i(D).renderTemplate(m);w={domNode:m,templateId:D,templateData:I}}return{row:w,isReusingConnectedDomNode:d}}release(D){!D||this.f(D)}transact(D){if(this.c)throw new Error("Already in transaction");this.c=!0;try{D()}finally{for(const w of this.b)this.g(w);this.b.clear(),this.c=!1}}f(D){const{domNode:w,templateId:d}=D;w&&(this.c?this.b.add(w):this.g(w)),this.h(d).push(D)}g(D){D.classList.remove("scrolling"),i(D)}h(D){let w=this.a.get(D);return w||(w=[],this.a.set(D,w)),w}dispose(){this.a.forEach((D,w)=>{for(const d of D)this.i(w).disposeTemplate(d.templateData),d.templateData=null}),this.a.clear(),this.b.clear()}i(D){const w=this.d.get(D);if(!w)throw new Error(`No renderer found for ${D}`);return w}}t.RowCache=z}),define(me[117],be([1,0,8,2]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class z extends i.Disposable{constructor(D,w,d){super(),this.a=D,this.b=w,this.c=d,this.f=null,this.j=!1,this.i=!1,this.g=!1,this.h=!1,this.k=this.B(new v.TimeoutTimer)}setVisibility(D){this.a!==D&&(this.a=D,this.m())}setShouldBeVisible(D){this.g=D,this.m()}l(){return this.a===2?!1:this.a===3?!0:this.g}m(){const D=this.l();this.h!==D&&(this.h=D,this.ensureVisibility())}setIsNeeded(D){this.i!==D&&(this.i=D,this.ensureVisibility())}setDomNode(D){this.f=D,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.i){this.p(!1);return}this.h?this.n():this.p(!0)}n(){this.j||(this.j=!0,this.k.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}p(D){this.k.cancel(),this.j&&(this.j=!1,this.f?.setClassName(this.c+(D?" fade":"")))}}t.ScrollbarVisibilityController=z}),define(me[118],be([1,0,4,22,14,3,2,5]),function(Z,t,v,i,z,H,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class d extends D.Disposable{constructor(g,I,o,n){super(),this.f=0,this.b=n||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new H.Emitter),this.h=o,this.i(),this.setOptions(g,I)}i(){this.B(i.Gesture.addTarget(this.a)),[i.EventType.Tap].forEach(g=>{this.B(v.addDisposableListener(this.a,g,I=>{this.a.focus()}))}),this.B(v.addStandardDisposableListener(this.a,"click",g=>{v.EventHelper.stop(g,!0)})),this.B(v.addStandardDisposableListener(this.a,"change",g=>{this.a.title=g.target.value,this.g.fire({index:g.target.selectedIndex,selected:g.target.value})})),this.B(v.addStandardDisposableListener(this.a,"keydown",g=>{let I=!1;w.isMacintosh?(g.keyCode===18||g.keyCode===16||g.keyCode===10)&&(I=!0):(g.keyCode===18&&g.altKey||g.keyCode===10||g.keyCode===3)&&(I=!0),I&&g.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(g,I){(!this.c||!z.equals(this.c,g))&&(this.c=g,this.a.options.length=0,this.c.forEach((o,n)=>{this.a.add(this.j(o.text,n,o.isDisabled))})),I!==void 0&&this.select(I)}select(g){this.c.length===0?this.f=0:g>=0&&g<this.c.length?this.f=g:g>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(g){this.b.ariaLabel=g,this.a.setAttribute("aria-label",g)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(g){this.a.tabIndex=g?0:-1}render(g){g.classList.add("select-container"),g.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(g){this.h=g,this.applyStyles()}applyStyles(){if(this.a){const g=this.h.selectBackground?this.h.selectBackground.toString():"",I=this.h.selectForeground?this.h.selectForeground.toString():"",o=this.h.selectBorder?this.h.selectBorder.toString():"";this.a.style.backgroundColor=g,this.a.style.color=I,this.a.style.borderColor=o}}j(g,I,o){const n=document.createElement("option");return n.value=g,n.text=g,n.disabled=!!o,n}}t.SelectBoxNative=d}),define(me[55],be([1,0,23,14,8,112,3,25]),function(Z,t,v,i,z,H,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=t.getVisibleState=t.isFilterResult=void 0;function d(o){return typeof o=="object"&&"visibility"in o&&"data"in o}t.isFilterResult=d;function m(o){switch(o){case!0:return 1;case!1:return 0;default:return o}}t.getVisibleState=m;function g(o){return typeof o.collapsible=="boolean"}class I{constructor(n,e,s,a={}){this.o=n,this.p=e,this.rootRef=[],this.d=new D.EventBufferer,this.f=new D.Emitter,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new D.Emitter,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new D.Emitter,this.onDidSplice=this.l.event,this.m=new z.Delayer(z.MicrotaskDelay),this.h=typeof a.collapseByDefault>"u"?!1:a.collapseByDefault,this.j=a.filter,this.k=typeof a.autoExpandSingleChildren>"u"?!1:a.autoExpandSingleChildren,this.c={parent:void 0,element:s,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(n,e,s=w.Iterable.empty(),a={}){if(n.length===0)throw new v.TreeError(this.o,"Invalid tree location");a.diffIdentityProvider?this.q(a.diffIdentityProvider,n,e,s,a):this.s(n,e,s,a)}q(n,e,s,a=w.Iterable.empty(),l,h=l.diffDepth??0){const{parentNode:r}=this.G(e);if(!r.lastDiffIds)return this.s(e,s,a,l);const c=[...a],b=e[e.length-1],S=new H.LcsDiff({getElements:()=>r.lastDiffIds},{getElements:()=>[...r.children.slice(0,b),...c,...r.children.slice(b+s)].map(C=>n.getId(C.element).toString())}).ComputeDiff(!1);if(S.quitEarly)return r.lastDiffIds=void 0,this.s(e,s,c,l);const N=e.slice(0,-1),L=(C,p,y)=>{if(h>0)for(let _=0;_<y;_++)C--,p--,this.q(n,[...N,C,0],Number.MAX_SAFE_INTEGER,c[p].children,l,h-1)};let T=Math.min(r.children.length,b+s),f=c.length;for(const C of S.changes.sort((p,y)=>y.originalStart-p.originalStart))L(T,f,T-(C.originalStart+C.originalLength)),T=C.originalStart,f=C.modifiedStart-b,this.s([...N,T],C.originalLength,w.Iterable.slice(c,f,f+C.modifiedLength),l);L(T,f,T)}s(n,e,s=w.Iterable.empty(),{onDidCreateNode:a,onDidDeleteNode:l,diffIdentityProvider:h}){const{parentNode:r,listIndex:c,revealed:b,visible:S}=this.G(n),N=[],L=w.Iterable.map(s,te=>this.w(te,r,r.visible?1:0,b,N,a)),T=n[n.length-1],f=r.children.length>0;let C=0;for(let te=T;te>=0&&te<r.children.length;te--){const ue=r.children[te];if(ue.visible){C=ue.visibleChildIndex;break}}const p=[];let y=0,_=0;for(const te of L)p.push(te),_+=te.renderNodeCount,te.visible&&(te.visibleChildIndex=C+y++);const V=(0,i.splice)(r.children,T,e,p);h?r.lastDiffIds?(0,i.splice)(r.lastDiffIds,T,e,p.map(te=>h.getId(te.element).toString())):r.lastDiffIds=r.children.map(te=>h.getId(te.element).toString()):r.lastDiffIds=void 0;let ge=0;for(const te of V)te.visible&&ge++;if(ge!==0)for(let te=T+p.length;te<r.children.length;te++){const ue=r.children[te];ue.visible&&(ue.visibleChildIndex-=ge)}if(r.visibleChildrenCount+=y-ge,b&&S){const te=V.reduce((ue,ae)=>ue+(ae.visible?ae.renderNodeCount:0),0);this.B(r,_-te),this.p.splice(c,te,N)}if(V.length>0&&l){const te=ue=>{l(ue),ue.children.forEach(te)};V.forEach(te)}this.l.fire({insertedNodes:p,deletedNodes:V});const Q=r.children.length>0;f!==Q&&this.setCollapsible(n.slice(0,-1),Q);let ie=r;for(;ie;){if(ie.visibility===2){this.m.trigger(()=>this.refilter());break}ie=ie.parent}}rerender(n){if(n.length===0)throw new v.TreeError(this.o,"Invalid tree location");const{node:e,listIndex:s,revealed:a}=this.F(n);e.visible&&a&&this.p.splice(s,1,[e])}updateElementHeight(n,e){if(n.length===0)throw new v.TreeError(this.o,"Invalid tree location");const{listIndex:s}=this.F(n);this.p.updateElementHeight(s,e)}has(n){return this.D(n)}getListIndex(n){const{listIndex:e,visible:s,revealed:a}=this.F(n);return s&&a?e:-1}getListRenderCount(n){return this.E(n).renderNodeCount}isCollapsible(n){return this.E(n).collapsible}setCollapsible(n,e){const s=this.E(n);typeof e>"u"&&(e=!s.collapsible);const a={collapsible:e};return this.d.bufferEvents(()=>this.t(n,a))}isCollapsed(n){return this.E(n).collapsed}setCollapsed(n,e,s){const a=this.E(n);typeof e>"u"&&(e=!a.collapsed);const l={collapsed:e,recursive:s||!1};return this.d.bufferEvents(()=>this.t(n,l))}t(n,e){const{node:s,listIndex:a,revealed:l}=this.F(n),h=this.u(s,a,l,e);if(s!==this.c&&this.k&&h&&!g(e)&&s.collapsible&&!s.collapsed&&!e.recursive){let r=-1;for(let c=0;c<s.children.length;c++)if(s.children[c].visible)if(r>-1){r=-1;break}else r=c;r>-1&&this.t([...n,r],e)}return h}u(n,e,s,a){const l=this.v(n,a,!1);if(!s||!n.visible||!l)return l;const h=n.renderNodeCount,r=this.x(n),c=h-(e===-1?0:1);return this.p.splice(e+1,c,r.slice(1)),l}v(n,e,s){let a;if(n===this.c?a=!1:(g(e)?(a=n.collapsible!==e.collapsible,n.collapsible=e.collapsible):n.collapsible?(a=n.collapsed!==e.collapsed,n.collapsed=e.collapsed):a=!1,a&&this.f.fire({node:n,deep:s})),!g(e)&&e.recursive)for(const l of n.children)a=this.v(l,e,!0)||a;return a}expandTo(n){this.d.bufferEvents(()=>{let e=this.E(n);for(;e.parent;)e=e.parent,n=n.slice(0,n.length-1),e.collapsed&&this.t(n,{collapsed:!1,recursive:!1})})}refilter(){const n=this.c.renderNodeCount,e=this.z(this.c);this.p.splice(0,n,e),this.m.cancel()}w(n,e,s,a,l,h){const r={parent:e,element:n.element,children:[],depth:e.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof n.collapsible=="boolean"?n.collapsible:typeof n.collapsed<"u",collapsed:typeof n.collapsed>"u"?this.h:n.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},c=this.C(r,s);r.visibility=c,a&&l.push(r);const b=n.children||w.Iterable.empty(),S=a&&c!==0&&!r.collapsed;let N=0,L=1;for(const T of b){const f=this.w(T,r,c,S,l,h);r.children.push(f),L+=f.renderNodeCount,f.visible&&(f.visibleChildIndex=N++)}return r.collapsible=r.collapsible||r.children.length>0,r.visibleChildrenCount=N,r.visible=c===2?N>0:c===1,r.visible?r.collapsed||(r.renderNodeCount=L):(r.renderNodeCount=0,a&&l.pop()),h?.(r),r}x(n){const e=n.renderNodeCount,s=[];return this.y(n,s),this.B(n.parent,s.length-e),s}y(n,e){if(n.visible===!1)return 0;if(e.push(n),n.renderNodeCount=1,!n.collapsed)for(const s of n.children)n.renderNodeCount+=this.y(s,e);return this.g.fire(n),n.renderNodeCount}z(n){const e=n.renderNodeCount,s=[];return this.A(n,n.visible?1:0,s),this.B(n.parent,s.length-e),s}A(n,e,s,a=!0){let l;if(n!==this.c){if(l=this.C(n,e),l===0)return n.visible=!1,n.renderNodeCount=0,!1;a&&s.push(n)}const h=s.length;n.renderNodeCount=n===this.c?0:1;let r=!1;if(!n.collapsed||l!==0){let c=0;for(const b of n.children)r=this.A(b,l,s,a&&!n.collapsed)||r,b.visible&&(b.visibleChildIndex=c++);n.visibleChildrenCount=c}else n.visibleChildrenCount=0;return n!==this.c&&(n.visible=l===2?r:l===1,n.visibility=l),n.visible?n.collapsed||(n.renderNodeCount+=s.length-h):(n.renderNodeCount=0,a&&s.pop()),this.g.fire(n),n.visible}B(n,e){if(e!==0)for(;n;)n.renderNodeCount+=e,this.g.fire(n),n=n.parent}C(n,e){const s=this.j?this.j.filter(n.element,e):1;return typeof s=="boolean"?(n.filterData=void 0,s?1:0):d(s)?(n.filterData=s.data,m(s.visibility)):(n.filterData=void 0,m(s))}D(n,e=this.c){if(!n||n.length===0)return!0;const[s,...a]=n;return s<0||s>e.children.length?!1:this.D(a,e.children[s])}E(n,e=this.c){if(!n||n.length===0)return e;const[s,...a]=n;if(s<0||s>e.children.length)throw new v.TreeError(this.o,"Invalid tree location");return this.E(a,e.children[s])}F(n){if(n.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:e,listIndex:s,revealed:a,visible:l}=this.G(n),h=n[n.length-1];if(h<0||h>e.children.length)throw new v.TreeError(this.o,"Invalid tree location");const r=e.children[h];return{node:r,listIndex:s,revealed:a,visible:l&&r.visible}}G(n,e=this.c,s=0,a=!0,l=!0){const[h,...r]=n;if(h<0||h>e.children.length)throw new v.TreeError(this.o,"Invalid tree location");for(let c=0;c<h;c++)s+=e.children[c].renderNodeCount;return a=a&&!e.collapsed,l=l&&e.visible,r.length===0?{parentNode:e,listIndex:s,revealed:a,visible:l}:this.G(r,e.children[h],s+1,a,l)}getNode(n=[]){return this.E(n)}getNodeLocation(n){const e=[];let s=n;for(;s.parent;)e.push(s.parent.children.indexOf(s)),s=s.parent;return e.reverse()}getParentNodeLocation(n){if(n.length!==0)return n.length===1?[]:(0,i.tail2)(n)[0]}getFirstElementChild(n){const e=this.E(n);if(e.children.length!==0)return e.children[0].element}getLastElementAncestor(n=[]){const e=this.E(n);if(e.children.length!==0)return this.H(e)}H(n){return n.children.length===0?n.element:this.H(n.children[n.children.length-1])}}t.IndexTreeModel=I}),define(me[119],be([1,0,55,23,25]),function(Z,t,v,i,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class H{get size(){return this.d.size}constructor(w,d,m={}){this.k=w,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new v.IndexTreeModel(w,d,null,m),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,m.sorter&&(this.j={compare(g,I){return m.sorter.compare(g.element,I.element)}}),this.h=m.identityProvider}setChildren(w,d=z.Iterable.empty(),m={}){const g=this.o(w);this.l(g,this.m(d),m)}l(w,d=z.Iterable.empty(),m){const g=new Set,I=new Set,o=e=>{if(e.element===null)return;const s=e;if(g.add(s.element),this.d.set(s.element,s),this.h){const a=this.h.getId(s.element).toString();I.add(a),this.f.set(a,s)}m.onDidCreateNode?.(s)},n=e=>{if(e.element===null)return;const s=e;if(g.has(s.element)||this.d.delete(s.element),this.h){const a=this.h.getId(s.element).toString();I.has(a)||this.f.delete(a)}m.onDidDeleteNode?.(s)};this.c.splice([...w,0],Number.MAX_VALUE,d,{...m,onDidCreateNode:o,onDidDeleteNode:n})}m(w=z.Iterable.empty()){return this.j&&(w=[...w].sort(this.j.compare.bind(this.j))),z.Iterable.map(w,d=>{let m=this.d.get(d.element);if(!m&&this.h){const o=this.h.getId(d.element).toString();m=this.f.get(o)}if(!m)return{...d,children:this.m(d.children)};const g=typeof d.collapsible=="boolean"?d.collapsible:m.collapsible,I=typeof d.collapsed<"u"?d.collapsed:m.collapsed;return{...d,collapsible:g,collapsed:I,children:this.m(d.children)}})}rerender(w){const d=this.o(w);this.c.rerender(d)}updateElementHeight(w,d){const m=this.o(w);this.c.updateElementHeight(m,d)}resort(w=null,d=!0){if(!this.j)return;const m=this.o(w),g=this.c.getNode(m);this.l(m,this.n(g,d),{})}n(w,d,m=!0){let g=[...w.children];return(d||m)&&(g=g.sort(this.j.compare.bind(this.j))),z.Iterable.map(g,I=>({element:I.element,collapsible:I.collapsible,collapsed:I.collapsed,children:this.n(I,d,!1)}))}getFirstElementChild(w=null){const d=this.o(w);return this.c.getFirstElementChild(d)}getLastElementAncestor(w=null){const d=this.o(w);return this.c.getLastElementAncestor(d)}has(w){return this.d.has(w)}getListIndex(w){const d=this.o(w);return this.c.getListIndex(d)}getListRenderCount(w){const d=this.o(w);return this.c.getListRenderCount(d)}isCollapsible(w){const d=this.o(w);return this.c.isCollapsible(d)}setCollapsible(w,d){const m=this.o(w);return this.c.setCollapsible(m,d)}isCollapsed(w){const d=this.o(w);return this.c.isCollapsed(d)}setCollapsed(w,d,m){const g=this.o(w);return this.c.setCollapsed(g,d,m)}expandTo(w){const d=this.o(w);this.c.expandTo(d)}refilter(){this.c.refilter()}getNode(w=null){if(w===null)return this.c.getNode(this.c.rootRef);const d=this.d.get(w);if(!d)throw new i.TreeError(this.k,`Tree element not found: ${w}`);return d}getNodeLocation(w){return w.element}getParentNodeLocation(w){if(w===null)throw new i.TreeError(this.k,"Invalid getParentNodeLocation call");const d=this.d.get(w);if(!d)throw new i.TreeError(this.k,`Tree element not found: ${w}`);const m=this.c.getNodeLocation(d),g=this.c.getParentNodeLocation(m);return this.c.getNode(g).element}o(w){if(w===null)return[];const d=this.d.get(w);if(!d)throw new i.TreeError(this.k,`Tree element not found: ${w}`);return this.c.getNodeLocation(d)}}t.ObjectTreeModel=H}),define(me[18],be([1,0,4,17,20,22,2]),function(Z,t,v,i,z,H,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class w extends D.Disposable{f(m,g){this.B(v.addDisposableListener(m,v.EventType.CLICK,I=>g(new z.StandardMouseEvent(I))))}j(m,g){this.B(v.addDisposableListener(m,v.EventType.MOUSE_DOWN,I=>g(new z.StandardMouseEvent(I))))}k(m,g){this.B(v.addDisposableListener(m,v.EventType.MOUSE_OVER,I=>g(new z.StandardMouseEvent(I))))}m(m,g){this.B(v.addDisposableListener(m,v.EventType.MOUSE_LEAVE,I=>g(new z.StandardMouseEvent(I))))}p(m,g){this.B(v.addDisposableListener(m,v.EventType.KEY_DOWN,I=>g(new i.StandardKeyboardEvent(I))))}u(m,g){this.B(v.addDisposableListener(m,v.EventType.KEY_UP,I=>g(new i.StandardKeyboardEvent(I))))}z(m,g){this.B(v.addDisposableListener(m,v.EventType.INPUT,g))}C(m,g){this.B(v.addDisposableListener(m,v.EventType.BLUR,g))}D(m,g){this.B(v.addDisposableListener(m,v.EventType.FOCUS,g))}F(m,g){this.B(v.addDisposableListener(m,v.EventType.CHANGE,g))}G(m){return H.Gesture.ignoreTarget(m)}}t.Widget=w}),define(me[36],be([1,0,53,18,8,4]),function(Z,t,v,i,z,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class D extends i.Widget{constructor(d){super(),this.a=d.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=d.bgWidth+"px",this.bgDomNode.style.height=d.bgHeight+"px",typeof d.top<"u"&&(this.bgDomNode.style.top="0px"),typeof d.left<"u"&&(this.bgDomNode.style.left="0px"),typeof d.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof d.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=d.className,this.domNode.classList.add(...d.icon.classNamesArray),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof d.top<"u"&&(this.domNode.style.top=d.top+"px"),typeof d.left<"u"&&(this.domNode.style.left=d.left+"px"),typeof d.bottom<"u"&&(this.domNode.style.bottom=d.bottom+"px"),typeof d.right<"u"&&(this.domNode.style.right=d.right+"px"),this.g=this.B(new v.GlobalPointerMoveMonitor),this.B(H.addStandardDisposableListener(this.bgDomNode,H.EventType.POINTER_DOWN,m=>this.h(m))),this.B(H.addStandardDisposableListener(this.domNode,H.EventType.POINTER_DOWN,m=>this.h(m))),this.b=this.B(new z.IntervalTimer),this.c=this.B(new z.TimeoutTimer)}h(d){if(!d.target||!(d.target instanceof Element))return;const m=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24)};this.a(),this.b.cancel(),this.c.cancelAndSet(m,200),this.g.startMonitoring(d.target,d.pointerId,d.buttons,g=>{},()=>{this.b.cancel(),this.c.cancel()}),d.preventDefault()}}t.ScrollbarArrow=D}),define(me[56],be([1,0,4,39,53,36,117,18,5]),function(Z,t,v,i,z,H,D,w,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const m=140;class g extends w.Widget{constructor(o){super(),this.g=o.lazyRender,this.a=o.host,this.b=o.scrollable,this.c=o.scrollByPage,this.h=o.scrollbarState,this.i=this.B(new D.ScrollbarVisibilityController(o.visibility,"visible scrollbar "+o.extraScrollbarClassName,"invisible scrollbar "+o.extraScrollbarClassName)),this.i.setIsNeeded(this.h.isNeeded()),this.l=this.B(new z.GlobalPointerMoveMonitor),this.n=!0,this.domNode=(0,i.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.i.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(v.addDisposableListener(this.domNode.domNode,v.EventType.POINTER_DOWN,n=>this.y(n)))}r(o){const n=this.B(new H.ScrollbarArrow(o));this.domNode.domNode.appendChild(n.bgDomNode),this.domNode.domNode.appendChild(n.domNode)}s(o,n,e,s){this.slider=(0,i.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(o),this.slider.setLeft(n),typeof e=="number"&&this.slider.setWidth(e),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(v.addDisposableListener(this.slider.domNode,v.EventType.POINTER_DOWN,a=>{a.button===0&&(a.preventDefault(),this.I(a))})),this.f(this.slider.domNode,a=>{a.leftButton&&a.stopPropagation()})}t(o){return this.h.setVisibleSize(o)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}v(o){return this.h.setScrollSize(o)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}w(o){return this.h.setScrollPosition(o)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}beginReveal(){this.i.setShouldBeVisible(!0)}beginHide(){this.i.setShouldBeVisible(!1)}render(){!this.n||(this.n=!1,this.L(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.M(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}y(o){o.target===this.domNode.domNode&&this.H(o)}delegatePointerDown(o){const n=this.domNode.domNode.getClientRects()[0].top,e=n+this.h.getSliderPosition(),s=n+this.h.getSliderPosition()+this.h.getSliderSize(),a=this.O(o);e<=a&&a<=s?o.button===0&&(o.preventDefault(),this.I(o)):this.H(o)}H(o){let n,e;if(o.target===this.domNode.domNode&&typeof o.offsetX=="number"&&typeof o.offsetY=="number")n=o.offsetX,e=o.offsetY;else{const a=v.getDomNodePagePosition(this.domNode.domNode);n=o.pageX-a.left,e=o.pageY-a.top}const s=this.N(n,e);this.J(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(s):this.h.getDesiredScrollPositionFromOffset(s)),o.button===0&&(o.preventDefault(),this.I(o))}I(o){if(!o.target||!(o.target instanceof Element))return;const n=this.O(o),e=this.P(o),s=this.h.clone();this.slider.toggleClassName("active",!0),this.l.startMonitoring(o.target,o.pointerId,o.buttons,a=>{const l=this.P(a),h=Math.abs(l-e);if(d.isWindows&&h>m){this.J(s.getScrollPosition());return}const c=this.O(a)-n;this.J(s.getDesiredScrollPositionFromDelta(c))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}J(o){const n={};this.writeScrollPosition(n,o),this.b.setScrollPositionNow(n)}updateScrollbarSize(o){this.Q(o),this.h.setScrollbarSize(o),this.n=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.AbstractScrollbar=g}),define(me[120],be([1,0,20,56,36,40,12]),function(Z,t,v,i,z,H,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class w extends i.AbstractScrollbar{constructor(m,g,I){const o=m.getScrollDimensions(),n=m.getCurrentScrollPosition();if(super({lazyRender:g.lazyRender,host:I,scrollbarState:new H.ScrollbarState(g.horizontalHasArrows?g.arrowSize:0,g.horizontal===2?0:g.horizontalScrollbarSize,g.vertical===2?0:g.verticalScrollbarSize,o.width,o.scrollWidth,n.scrollLeft),visibility:g.horizontal,extraScrollbarClassName:"horizontal",scrollable:m,scrollByPage:g.scrollByPage}),g.horizontalHasArrows){const e=(g.arrowSize-z.ARROW_IMG_SIZE)/2,s=(g.horizontalScrollbarSize-z.ARROW_IMG_SIZE)/2;this.r({className:"scra",icon:D.Codicon.scrollbarButtonLeft,top:s,left:e,bottom:void 0,right:void 0,bgWidth:g.arrowSize,bgHeight:g.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new v.StandardWheelEvent(null,1,0))}),this.r({className:"scra",icon:D.Codicon.scrollbarButtonRight,top:s,left:void 0,bottom:void 0,right:e,bgWidth:g.arrowSize,bgHeight:g.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new v.StandardWheelEvent(null,-1,0))})}this.s(Math.floor((g.horizontalScrollbarSize-g.horizontalSliderSize)/2),0,void 0,g.horizontalSliderSize)}M(m,g){this.slider.setWidth(m),this.slider.setLeft(g)}L(m,g){this.domNode.setWidth(m),this.domNode.setHeight(g),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(m){return this.n=this.v(m.scrollWidth)||this.n,this.n=this.w(m.scrollLeft)||this.n,this.n=this.t(m.width)||this.n,this.n}N(m,g){return m}O(m){return m.pageX}P(m){return m.pageY}Q(m){this.slider.setHeight(m)}writeScrollPosition(m,g){m.scrollLeft=g}updateOptions(m){this.updateScrollbarSize(m.horizontal===2?0:m.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(m.vertical===2?0:m.verticalScrollbarSize),this.i.setVisibility(m.horizontal),this.c=m.scrollByPage}}t.HorizontalScrollbar=w}),define(me[121],be([1,0,20,56,36,40,12]),function(Z,t,v,i,z,H,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class w extends i.AbstractScrollbar{constructor(m,g,I){const o=m.getScrollDimensions(),n=m.getCurrentScrollPosition();if(super({lazyRender:g.lazyRender,host:I,scrollbarState:new H.ScrollbarState(g.verticalHasArrows?g.arrowSize:0,g.vertical===2?0:g.verticalScrollbarSize,0,o.height,o.scrollHeight,n.scrollTop),visibility:g.vertical,extraScrollbarClassName:"vertical",scrollable:m,scrollByPage:g.scrollByPage}),g.verticalHasArrows){const e=(g.arrowSize-z.ARROW_IMG_SIZE)/2,s=(g.verticalScrollbarSize-z.ARROW_IMG_SIZE)/2;this.r({className:"scra",icon:D.Codicon.scrollbarButtonUp,top:e,left:s,bottom:void 0,right:void 0,bgWidth:g.verticalScrollbarSize,bgHeight:g.arrowSize,onActivate:()=>this.a.onMouseWheel(new v.StandardWheelEvent(null,0,1))}),this.r({className:"scra",icon:D.Codicon.scrollbarButtonDown,top:void 0,left:s,bottom:e,right:void 0,bgWidth:g.verticalScrollbarSize,bgHeight:g.arrowSize,onActivate:()=>this.a.onMouseWheel(new v.StandardWheelEvent(null,0,-1))})}this.s(0,Math.floor((g.verticalScrollbarSize-g.verticalSliderSize)/2),g.verticalSliderSize,void 0)}M(m,g){this.slider.setHeight(m),this.slider.setTop(g)}L(m,g){this.domNode.setWidth(g),this.domNode.setHeight(m),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(m){return this.n=this.v(m.scrollHeight)||this.n,this.n=this.w(m.scrollTop)||this.n,this.n=this.t(m.height)||this.n,this.n}N(m,g){return g}O(m){return m.pageY}P(m){return m.pageX}Q(m){this.slider.setWidth(m)}writeScrollPosition(m,g){m.scrollTop=g}updateOptions(m){this.updateScrollbarSize(m.vertical===2?0:m.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.i.setVisibility(m.vertical),this.c=m.scrollByPage}}t.VerticalScrollbar=w}),define(me[57],be([1,0,16,4,39,20,120,121,18,8,3,2,5,49,90]),function(Z,t,v,i,z,H,D,w,d,m,g,I,o,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,s=50,a=!0;class l{constructor(T,f,C){this.timestamp=T,this.deltaX=f,this.deltaY=C,this.score=0}}class h{constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let T=1,f=0,C=1,p=this.d;do{const y=p===this.c?T:Math.pow(2,-C);if(T-=y,f+=this.b[p].score*y,p===this.c)break;p=(this.a+p-1)%this.a,C++}while(!0);return f<=.5}acceptStandardWheelEvent(T){const f=window.devicePixelRatio/(0,v.getZoomFactor)();o.isWindows||o.isLinux?this.accept(Date.now(),T.deltaX/f,T.deltaY/f):this.accept(Date.now(),T.deltaX,T.deltaY)}accept(T,f,C){const p=new l(T,f,C);p.score=this.f(p),this.c===-1&&this.d===-1?(this.b[0]=p,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=p)}f(T){if(Math.abs(T.deltaX)>0&&Math.abs(T.deltaY)>0)return 1;let f=.5;const C=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(T.deltaX)||!this.g(T.deltaY))&&(f+=.25),Math.min(Math.max(f,0),1)}g(T){return Math.abs(Math.round(T)-T)<.01}}t.MouseWheelClassifier=h,h.INSTANCE=new h;class r extends d.Widget{get options(){return this.a}constructor(T,f,C){super(),this.I=this.B(new g.Emitter),this.onScroll=this.I.event,this.J=this.B(new g.Emitter),this.onWillScroll=this.J.event,T.style.overflow="hidden",this.a=N(f),this.b=C,this.B(this.b.onScroll(y=>{this.J.fire(y),this.N(y),this.I.fire(y)}));const p={onMouseWheel:y=>this.M(y),onDragStart:()=>this.P(),onDragEnd:()=>this.Q()};this.c=this.B(new w.VerticalScrollbar(this.b,this.a,p)),this.g=this.B(new D.HorizontalScrollbar(this.b,this.a,p)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(T),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.i=(0,z.createFastDomNode)(document.createElement("div")),this.i.setClassName("shadow"),this.h.appendChild(this.i.domNode),this.l=(0,z.createFastDomNode)(document.createElement("div")),this.l.setClassName("shadow"),this.h.appendChild(this.l.domNode),this.n=(0,z.createFastDomNode)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode)):(this.i=null,this.l=null,this.n=null),this.r=this.a.listenOnDomNode||this.h,this.s=[],this.L(this.a.handleMouseWheel),this.k(this.r,y=>this.S(y)),this.m(this.r,y=>this.R(y)),this.w=this.B(new m.TimeoutTimer),this.t=!1,this.v=!1,this.y=!0,this.H=!0}dispose(){this.s=(0,I.dispose)(this.s),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(T){this.c.delegatePointerDown(T)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(T){this.b.setScrollDimensions(T,!1)}updateClassName(T){this.a.className=T,o.isMacintosh&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(T){typeof T.handleMouseWheel<"u"&&(this.a.handleMouseWheel=T.handleMouseWheel,this.L(this.a.handleMouseWheel)),typeof T.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=T.mouseWheelScrollSensitivity),typeof T.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=T.fastScrollSensitivity),typeof T.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=T.scrollPredominantAxis),typeof T.horizontal<"u"&&(this.a.horizontal=T.horizontal),typeof T.vertical<"u"&&(this.a.vertical=T.vertical),typeof T.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=T.horizontalScrollbarSize),typeof T.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=T.verticalScrollbarSize),typeof T.scrollByPage<"u"&&(this.a.scrollByPage=T.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.O()}setRevealOnScroll(T){this.H=T}delegateScrollFromMouseWheelEvent(T){this.M(new H.StandardWheelEvent(T))}L(T){if(this.s.length>0!==T&&(this.s=(0,I.dispose)(this.s),T)){const C=p=>{this.M(new H.StandardWheelEvent(p))};this.s.push(i.addDisposableListener(this.r,i.EventType.MOUSE_WHEEL,C,{passive:!1}))}}M(T){const f=h.INSTANCE;a&&f.acceptStandardWheelEvent(T);let C=!1;if(T.deltaY||T.deltaX){let y=T.deltaY*this.a.mouseWheelScrollSensitivity,_=T.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(Math.abs(y)>=Math.abs(_)?_=0:y=0),this.a.flipAxes&&([y,_]=[_,y]);const V=!o.isMacintosh&&T.browserEvent&&T.browserEvent.shiftKey;(this.a.scrollYToX||V)&&!_&&(_=y,y=0),T.browserEvent&&T.browserEvent.altKey&&(_=_*this.a.fastScrollSensitivity,y=y*this.a.fastScrollSensitivity);const ge=this.b.getFutureScrollPosition();let Q={};if(y){const ie=s*y,te=ge.scrollTop-(ie<0?Math.floor(ie):Math.ceil(ie));this.c.writeScrollPosition(Q,te)}if(_){const ie=s*_,te=ge.scrollLeft-(ie<0?Math.floor(ie):Math.ceil(ie));this.g.writeScrollPosition(Q,te)}Q=this.b.validateScrollPosition(Q),(ge.scrollLeft!==Q.scrollLeft||ge.scrollTop!==Q.scrollTop)&&(a&&this.a.mouseWheelSmoothScroll&&f.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(Q):this.b.setScrollPositionNow(Q),C=!0)}let p=C;!p&&this.a.alwaysConsumeMouseWheel&&(p=!0),!p&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(p=!0),p&&(T.preventDefault(),T.stopPropagation())}N(T){this.y=this.g.onDidScroll(T)||this.y,this.y=this.c.onDidScroll(T)||this.y,this.a.useShadows&&(this.y=!0),this.H&&this.U(),this.a.lazyRender||this.O()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.O()}O(){if(!!this.y&&(this.y=!1,this.g.render(),this.c.render(),this.a.useShadows)){const T=this.b.getCurrentScrollPosition(),f=T.scrollTop>0,C=T.scrollLeft>0,p=C?" left":"",y=f?" top":"",_=C||f?" top-left-corner":"";this.i.setClassName(`shadow${p}`),this.l.setClassName(`shadow${y}`),this.n.setClassName(`shadow${_}${y}${p}`)}}P(){this.t=!0,this.U()}Q(){this.t=!1,this.W()}R(T){this.v=!1,this.W()}S(T){this.v=!0,this.U()}U(){this.c.beginReveal(),this.g.beginReveal(),this.X()}W(){!this.v&&!this.t&&(this.c.beginHide(),this.g.beginHide())}X(){!this.v&&!this.t&&this.w.cancelAndSet(()=>this.W(),e)}}t.AbstractScrollableElement=r;class c extends r{constructor(T,f){f=f||{},f.mouseWheelSmoothScroll=!1;const C=new n.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:p=>i.scheduleAtNextAnimationFrame(p)});super(T,f,C),this.B(C)}setScrollPosition(T){this.b.setScrollPositionNow(T)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.ScrollableElement=c;class b extends r{constructor(T,f,C){super(T,f,C)}setScrollPosition(T){T.reuseAnimation?this.b.setScrollPositionSmooth(T,T.reuseAnimation):this.b.setScrollPositionNow(T)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.SmoothScrollableElement=b;class S extends r{constructor(T,f){f=f||{},f.mouseWheelSmoothScroll=!1;const C=new n.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:p=>i.scheduleAtNextAnimationFrame(p)});super(T,f,C),this.B(C),this.Y=T,this.onScroll(p=>{p.scrollTopChanged&&(this.Y.scrollTop=p.scrollTop),p.scrollLeftChanged&&(this.Y.scrollLeft=p.scrollLeft)}),this.scanDomNode()}setScrollPosition(T){this.b.setScrollPositionNow(T)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.Y.clientWidth,scrollWidth:this.Y.scrollWidth,height:this.Y.clientHeight,scrollHeight:this.Y.scrollHeight}),this.setScrollPosition({scrollLeft:this.Y.scrollLeft,scrollTop:this.Y.scrollTop})}}t.DomScrollableElement=S;function N(L){const T={lazyRender:typeof L.lazyRender<"u"?L.lazyRender:!1,className:typeof L.className<"u"?L.className:"",useShadows:typeof L.useShadows<"u"?L.useShadows:!0,handleMouseWheel:typeof L.handleMouseWheel<"u"?L.handleMouseWheel:!0,flipAxes:typeof L.flipAxes<"u"?L.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof L.consumeMouseWheelIfScrollbarIsNeeded<"u"?L.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof L.alwaysConsumeMouseWheel<"u"?L.alwaysConsumeMouseWheel:!1,scrollYToX:typeof L.scrollYToX<"u"?L.scrollYToX:!1,mouseWheelScrollSensitivity:typeof L.mouseWheelScrollSensitivity<"u"?L.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof L.fastScrollSensitivity<"u"?L.fastScrollSensitivity:5,scrollPredominantAxis:typeof L.scrollPredominantAxis<"u"?L.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof L.mouseWheelSmoothScroll<"u"?L.mouseWheelSmoothScroll:!0,arrowSize:typeof L.arrowSize<"u"?L.arrowSize:11,listenOnDomNode:typeof L.listenOnDomNode<"u"?L.listenOnDomNode:null,horizontal:typeof L.horizontal<"u"?L.horizontal:1,horizontalScrollbarSize:typeof L.horizontalScrollbarSize<"u"?L.horizontalScrollbarSize:10,horizontalSliderSize:typeof L.horizontalSliderSize<"u"?L.horizontalSliderSize:0,horizontalHasArrows:typeof L.horizontalHasArrows<"u"?L.horizontalHasArrows:!1,vertical:typeof L.vertical<"u"?L.vertical:1,verticalScrollbarSize:typeof L.verticalScrollbarSize<"u"?L.verticalScrollbarSize:10,verticalHasArrows:typeof L.verticalHasArrows<"u"?L.verticalHasArrows:!1,verticalSliderSize:typeof L.verticalSliderSize<"u"?L.verticalSliderSize:0,scrollByPage:typeof L.scrollByPage<"u"?L.scrollByPage:!1};return T.horizontalSliderSize=typeof L.horizontalSliderSize<"u"?L.horizontalSliderSize:T.horizontalScrollbarSize,T.verticalSliderSize=typeof L.verticalSliderSize<"u"?L.verticalSliderSize:T.verticalScrollbarSize,o.isMacintosh&&(T.className+=" mac"),T}}),define(me[58],be([1,0,51,4,19,22,57,14,8,24,3,2,47,49,79,116,9]),function(Z,t,v,i,z,H,D,w,d,m,g,I,o,n,e,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=void 0;const l={CurrentDragAndDropData:void 0},h={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(T){return[T]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class r{get context(){return this.d}set context(f){this.d=f}constructor(f){this.elements=f}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=r;class c{constructor(f){this.elements=f}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=c;class b{constructor(){this.types=[],this.files=[]}update(f){if(f.types&&this.types.splice(0,this.types.length,...f.types),f.files){this.files.splice(0,this.files.length);for(let C=0;C<f.files.length;C++){const p=f.files.item(C);p&&(p.size||p.type)&&this.files.push(p)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=b;function S(T,f){return Array.isArray(T)&&Array.isArray(f)?(0,w.equals)(T,f):T===f}class N{constructor(f){f?.getSetSize?this.getSetSize=f.getSetSize.bind(f):this.getSetSize=(C,p,y)=>y,f?.getPosInSet?this.getPosInSet=f.getPosInSet.bind(f):this.getPosInSet=(C,p)=>p+1,f?.getRole?this.getRole=f.getRole.bind(f):this.getRole=C=>"listitem",f?.isChecked?this.isChecked=f.isChecked.bind(f):this.isChecked=C=>{}}}class L{get contentHeight(){return this.g.size}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get O(){return this.N}set O(f){if(f!==this.N){if(f&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.N=f,this.domNode.classList.toggle("horizontal-scrolling",this.N),this.N){for(const C of this.d)this.X(C);this.U(),this.q.setScrollDimensions({width:(0,i.getContentWidth)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(f,C,p,y=h){if(this.P=C,this.domId=`list_id_${++L.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new d.Delayer(50),this.v=!1,this.x=I.Disposable.None,this.y=0,this.G=!1,this.J=I.Disposable.None,this.K=I.Disposable.None,this.L=new I.DisposableStore,this.M=new g.Emitter,this.onDidChangeContentHeight=g.Event.latch(this.M.event,void 0,this.L),this.N=!1,y.horizontalScrolling&&y.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.RangeMap;for(const V of p)this.j.set(V.templateId,V);this.h=this.L.add(new s.RowCache(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof y.mouseSupport=="boolean"?y.mouseSupport:!0),this.N=y.horizontalScrolling??h.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.N),this.C=typeof y.additionalScrollHeight>"u"?0:y.additionalScrollHeight,this.D=new N(y.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(y.transformOptimization??h.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(H.Gesture.addTarget(this.o)),this.p=new n.Scrollable({forceIntegerValues:!0,smoothScrollDuration:y.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:V=>(0,i.scheduleAtNextAnimationFrame)(V)}),this.q=this.L.add(new D.SmoothScrollableElement(this.o,{alwaysConsumeMouseWheel:y.alwaysConsumeMouseWheel??h.alwaysConsumeMouseWheel,horizontal:1,vertical:y.verticalScrollMode??h.verticalScrollMode,useShadows:y.useShadows??h.useShadows,mouseWheelScrollSensitivity:y.mouseWheelScrollSensitivity,fastScrollSensitivity:y.fastScrollSensitivity},this.p)),this.domNode.appendChild(this.q.getDomNode()),f.appendChild(this.domNode),this.q.onScroll(this.fb,this,this.L),this.L.add((0,i.addDisposableListener)(this.o,H.EventType.Change,V=>this.gb(V))),this.L.add((0,i.addDisposableListener)(this.q.getDomNode(),"scroll",V=>V.target.scrollTop=0)),this.L.add((0,i.addDisposableListener)(this.domNode,"dragover",V=>this.ib(this.eb(V)))),this.L.add((0,i.addDisposableListener)(this.domNode,"drop",V=>this.kb(this.eb(V)))),this.L.add((0,i.addDisposableListener)(this.domNode,"dragleave",V=>this.jb(this.eb(V)))),this.L.add((0,i.addDisposableListener)(this.domNode,"dragend",V=>this.lb(V))),this.z=y.setRowLineHeight??h.setRowLineHeight,this.A=y.setRowHeight??h.setRowHeight,this.B=y.supportDynamicHeights??h.supportDynamicHeights,this.F=y.dnd??h.dnd,this.layout(y.initialSize?.height,y.initialSize?.width)}updateOptions(f){f.additionalScrollHeight!==void 0&&(this.C=f.additionalScrollHeight,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),f.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(f.smoothScrolling?125:0),f.horizontalScrolling!==void 0&&(this.O=f.horizontalScrolling),f.mouseWheelScrollSensitivity!==void 0&&this.q.updateOptions({mouseWheelScrollSensitivity:f.mouseWheelScrollSensitivity}),f.fastScrollSensitivity!==void 0&&this.q.updateOptions({fastScrollSensitivity:f.fastScrollSensitivity})}delegateScrollFromMouseWheelEvent(f){this.q.delegateScrollFromMouseWheelEvent(f)}delegateVerticalScrollbarPointerDown(f){this.q.delegateVerticalScrollbarPointerDown(f)}updateElementHeight(f,C,p){if(f<0||f>=this.d.length)return;const y=this.d[f].size;if(typeof C>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[f].lastDynamicHeightWidth=void 0,C=y+this.tb(f)}if(y===C)return;const _=this.rb(this.k,this.m);let V=0;f<_.start||p!==null&&p>f&&p<=_.end?V=C-y:V=0,this.g.splice(f,1,[{size:C}]),this.d[f].size=C,this.V(_,Math.max(0,this.k+V),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.R(),this.B&&this.sb(this.k,this.m)}splice(f,C,p=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.Q(f,C,p)}finally{this.v=!1,this.M.fire(this.contentHeight)}}Q(f,C,p=[]){const y=this.rb(this.k,this.m),_={start:f,end:f+C},V=o.Range.intersect(y,_),ge=new Map;for(let ee=V.end-1;ee>=V.start;ee--){const A=this.d[ee];if(A.dragStartDisposable.dispose(),A.checkedDisposable.dispose(),A.row){let E=ge.get(A.templateId);E||(E=[],ge.set(A.templateId,E));const u=this.j.get(A.templateId);u&&u.disposeElement&&u.disposeElement(A.element,ee,A.row.templateData,A.size),E.push(A.row)}A.row=null}const Q={start:f+C,end:this.d.length},ie=o.Range.intersect(Q,y),te=o.Range.relativeComplement(Q,y),ue=p.map(ee=>({id:String(this.f++),element:ee,templateId:this.P.getTemplateId(ee),size:this.P.getHeight(ee),width:void 0,hasDynamicHeight:!!this.P.hasDynamicHeight&&this.P.hasDynamicHeight(ee),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:I.Disposable.None,checkedDisposable:I.Disposable.None}));let ae;f===0&&C>=this.d.length?(this.g=new e.RangeMap,this.g.splice(0,0,ue),ae=this.d,this.d=ue):(this.g.splice(f,C,ue),ae=this.d.splice(f,C,...ue));const de=p.length-C,Ae=this.rb(this.k,this.m),x=(0,e.shift)(ie,de),ve=o.Range.intersect(Ae,x);for(let ee=ve.start;ee<ve.end;ee++)this.Y(this.d[ee],ee);const Ne=o.Range.relativeComplement(x,Ae);for(const ee of Ne)for(let A=ee.start;A<ee.end;A++)this.Z(A);const oe=te.map(ee=>(0,e.shift)(ee,de)),se=[{start:f,end:f+p.length},...oe].map(ee=>o.Range.intersect(Ae,ee)),ne=this.ub(se);for(const ee of se)for(let A=ee.start;A<ee.end;A++){const E=this.d[A],B=ge.get(E.templateId)?.pop();this.W(A,ne,B)}for(const ee of ge.values())for(const A of ee)this.h.release(A);return this.R(),this.B&&this.sb(this.scrollTop,this.renderHeight),ae.map(ee=>ee.element)}R(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,i.scheduleAtNextAnimationFrame)(()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.U(),this.t=null}))}S(){if(!this.O){this.u.cancel();return}this.u.trigger(()=>this.U())}U(){if(!this.O)return;let f=0;for(const C of this.d)typeof C.width<"u"&&(f=Math.max(f,C.width));this.E=f,this.q.setScrollDimensions({scrollWidth:f===0?0:f+10})}updateWidth(f){if(!this.O||typeof this.E>"u")return;const C=this.d[f];this.X(C),typeof C.width<"u"&&C.width>this.E&&(this.E=C.width,this.q.setScrollDimensions({scrollWidth:this.E+10}))}rerender(){if(!!this.B){for(const f of this.d)f.lastDynamicHeightWidth=void 0;this.sb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const f=this.rb(this.k,this.m),C=this.g.positionAt(f.start),p=this.g.positionAt(f.start+1);return p!==-1&&(p-C)/2+C<this.scrollTop?f.start+1:f.start}get lastVisibleIndex(){return this.rb(this.k,this.m).end-1}element(f){return this.d[f].element}indexOf(f){return this.d.findIndex(C=>C.element===f)}domElement(f){const C=this.d[f].row;return C&&C.domNode}elementHeight(f){return this.d[f].size}elementTop(f){return this.g.positionAt(f)}indexAt(f){return this.g.indexAt(f)}indexAfter(f){return this.g.indexAfter(f)}layout(f,C){const p={height:typeof f=="number"?f:(0,i.getContentHeight)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,p.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(p),typeof C<"u"&&(this.n=C,this.B&&this.sb(this.scrollTop,this.renderHeight)),this.O&&this.q.setScrollDimensions({width:typeof C=="number"?C:(0,i.getContentWidth)(this.domNode)})}V(f,C,p,y,_,V=!1){const ge=this.rb(C,p),Q=o.Range.relativeComplement(ge,f),ie=o.Range.relativeComplement(f,ge),te=this.ub(Q);if(V){const ue=o.Range.intersect(f,ge);for(let ae=ue.start;ae<ue.end;ae++)this.Y(this.d[ae],ae)}this.h.transact(()=>{for(const ue of ie)for(let ae=ue.start;ae<ue.end;ae++)this.Z(ae);for(const ue of Q)for(let ae=ue.start;ae<ue.end;ae++)this.W(ae,te)}),y!==void 0&&(this.o.style.left=`-${y}px`),this.o.style.top=`-${C}px`,this.O&&_!==void 0&&(this.o.style.width=`${Math.max(_,this.n)}px`),this.k=C,this.m=p}W(f,C,p){const y=this.d[f];let _=!1;if(!y.row)if(p)y.row=p;else{const te=this.h.alloc(y.templateId);y.row=te.row,_=te.isReusingConnectedDomNode}const V=this.D.getRole(y.element)||"listitem";y.row.domNode.setAttribute("role",V);const ge=this.D.isChecked(y.element);if(typeof ge=="boolean")y.row.domNode.setAttribute("aria-checked",String(!!ge));else if(ge){const te=ue=>y.row.domNode.setAttribute("aria-checked",String(!!ue));te(ge.value),y.checkedDisposable=ge.onDidChange(te)}(_||!y.row.domNode.parentElement)&&(C?this.o.insertBefore(y.row.domNode,C):this.o.appendChild(y.row.domNode)),this.Y(y,f);const Q=this.j.get(y.templateId);if(!Q)throw new Error(`No renderer found for template id ${y.templateId}`);Q?.renderElement(y.element,f,y.row.templateData,y.size);const ie=this.F.getDragURI(y.element);y.dragStartDisposable.dispose(),y.row.domNode.draggable=!!ie,ie&&(y.dragStartDisposable=(0,i.addDisposableListener)(y.row.domNode,"dragstart",te=>this.hb(y.element,ie,te))),this.O&&(this.X(y),this.S())}X(f){if(!f.row||!f.row.domNode)return;f.row.domNode.style.width="fit-content",f.width=(0,i.getContentWidth)(f.row.domNode);const C=window.getComputedStyle(f.row.domNode);C.paddingLeft&&(f.width+=parseFloat(C.paddingLeft)),C.paddingRight&&(f.width+=parseFloat(C.paddingRight)),f.row.domNode.style.width=""}Y(f,C){f.row.domNode.style.top=`${this.elementTop(C)}px`,this.A&&(f.row.domNode.style.height=`${f.size}px`),this.z&&(f.row.domNode.style.lineHeight=`${f.size}px`),f.row.domNode.setAttribute("data-index",`${C}`),f.row.domNode.setAttribute("data-last-element",C===this.length-1?"true":"false"),f.row.domNode.setAttribute("data-parity",C%2===0?"even":"odd"),f.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(f.element,C,this.length))),f.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(f.element,C))),f.row.domNode.setAttribute("id",this.getElementDomId(C)),f.row.domNode.classList.toggle("drop-target",f.dropTarget)}Z(f){const C=this.d[f];if(C.dragStartDisposable.dispose(),C.checkedDisposable.dispose(),C.row){const p=this.j.get(C.templateId);p&&p.disposeElement&&p.disposeElement(C.element,f,C.row.templateData,C.size),this.h.release(C.row),C.row=null}this.O&&this.S()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(f,C){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:f,reuseAnimation:C})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(f){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:f})}get scrollTop(){return this.getScrollTop()}set scrollTop(f){this.setScrollTop(f)}get scrollHeight(){return this.s+(this.O?10:0)+this.C}get onMouseClick(){return g.Event.map(this.L.add(new z.DomEmitter(this.domNode,"click")).event,f=>this.ab(f),this.L)}get onMouseDblClick(){return g.Event.map(this.L.add(new z.DomEmitter(this.domNode,"dblclick")).event,f=>this.ab(f),this.L)}get onMouseMiddleClick(){return g.Event.filter(g.Event.map(this.L.add(new z.DomEmitter(this.domNode,"auxclick")).event,f=>this.ab(f),this.L),f=>f.browserEvent.button===1,this.L)}get onMouseUp(){return g.Event.map(this.L.add(new z.DomEmitter(this.domNode,"mouseup")).event,f=>this.ab(f),this.L)}get onMouseDown(){return g.Event.map(this.L.add(new z.DomEmitter(this.domNode,"mousedown")).event,f=>this.ab(f),this.L)}get onMouseOver(){return g.Event.map(this.L.add(new z.DomEmitter(this.domNode,"mouseover")).event,f=>this.ab(f),this.L)}get onMouseMove(){return g.Event.map(this.L.add(new z.DomEmitter(this.domNode,"mousemove")).event,f=>this.ab(f),this.L)}get onMouseOut(){return g.Event.map(this.L.add(new z.DomEmitter(this.domNode,"mouseout")).event,f=>this.ab(f),this.L)}get onContextMenu(){return g.Event.any(g.Event.map(this.L.add(new z.DomEmitter(this.domNode,"contextmenu")).event,f=>this.ab(f),this.L),g.Event.map(this.L.add(new z.DomEmitter(this.domNode,H.EventType.Contextmenu)).event,f=>this.db(f),this.L))}get onTouchStart(){return g.Event.map(this.L.add(new z.DomEmitter(this.domNode,"touchstart")).event,f=>this.bb(f),this.L)}get onTap(){return g.Event.map(this.L.add(new z.DomEmitter(this.o,H.EventType.Tap)).event,f=>this.db(f),this.L)}ab(f){const C=this.qb(f.target||null),p=typeof C>"u"?void 0:this.d[C],y=p&&p.element;return{browserEvent:f,index:C,element:y}}bb(f){const C=this.qb(f.target||null),p=typeof C>"u"?void 0:this.d[C],y=p&&p.element;return{browserEvent:f,index:C,element:y}}db(f){const C=this.qb(f.initialTarget||null),p=typeof C>"u"?void 0:this.d[C],y=p&&p.element;return{browserEvent:f,index:C,element:y}}eb(f){const C=this.qb(f.target||null),p=typeof C>"u"?void 0:this.d[C],y=p&&p.element;return{browserEvent:f,index:C,element:y}}fb(f){try{const C=this.rb(this.k,this.m);this.V(C,f.scrollTop,f.height,f.scrollLeft,f.scrollWidth),this.B&&this.sb(f.scrollTop,f.height,f.inSmoothScrolling)}catch(C){throw console.error("Got bad scroll event:",f),C}}gb(f){f.preventDefault(),f.stopPropagation(),this.scrollTop-=f.translationY}hb(f,C,p){if(!p.dataTransfer)return;const y=this.F.getDragElements(f);if(p.dataTransfer.effectAllowed="copyMove",p.dataTransfer.setData(v.DataTransfers.TEXT,C),p.dataTransfer.setDragImage){let _;this.F.getDragLabel&&(_=this.F.getDragLabel(y,p)),typeof _>"u"&&(_=String(y.length));const V=(0,i.$)(".monaco-drag-image");V.textContent=_,document.body.appendChild(V),p.dataTransfer.setDragImage(V,-10,-10),setTimeout(()=>document.body.removeChild(V),0)}this.domNode.classList.add("dragging"),this.H=new r(y),l.CurrentDragAndDropData=new c(y),this.F.onDragStart?.(this.H,p)}ib(f){if(f.browserEvent.preventDefault(),this.K.dispose(),l.CurrentDragAndDropData&&l.CurrentDragAndDropData.getData()==="vscode-ui"||(this.nb(f.browserEvent),!f.browserEvent.dataTransfer))return!1;if(!this.H)if(l.CurrentDragAndDropData)this.H=l.CurrentDragAndDropData;else{if(!f.browserEvent.dataTransfer.types)return!1;this.H=new b}const C=this.F.onDragOver(this.H,f.element,f.index,f.browserEvent);if(this.G=typeof C=="boolean"?C:C.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;f.browserEvent.dataTransfer.dropEffect=typeof C!="boolean"&&C.effect===0?"copy":"move";let p;if(typeof C!="boolean"&&C.feedback?p=C.feedback:typeof f.index>"u"?p=[-1]:p=[f.index],p=(0,w.distinct)(p).filter(y=>y>=-1&&y<this.length).sort((y,_)=>y-_),p=p[0]===-1?[-1]:p,S(this.I,p))return!0;if(this.I=p,this.J.dispose(),p[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,I.toDisposable)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const y of p){const _=this.d[y];_.dropTarget=!0,_.row?.domNode.classList.add("drop-target")}this.J=(0,I.toDisposable)(()=>{for(const y of p){const _=this.d[y];_.dropTarget=!1,_.row?.domNode.classList.remove("drop-target")}})}return!0}jb(f){this.K.dispose(),this.K=(0,d.disposableTimeout)(()=>this.mb(),100),this.H&&this.F.onDragLeave?.(this.H,f.element,f.index,f.browserEvent)}kb(f){if(!this.G)return;const C=this.H;this.pb(),this.mb(),this.domNode.classList.remove("dragging"),this.H=void 0,l.CurrentDragAndDropData=void 0,!(!C||!f.browserEvent.dataTransfer)&&(f.browserEvent.preventDefault(),C.update(f.browserEvent.dataTransfer),this.F.drop(C,f.element,f.index,f.browserEvent))}lb(f){this.G=!1,this.pb(),this.mb(),this.domNode.classList.remove("dragging"),this.H=void 0,l.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(f)}mb(){this.I=void 0,this.J.dispose(),this.J=I.Disposable.None}nb(f){if(!this.w){const C=(0,i.getTopLeftOffset)(this.domNode).top;this.w=(0,i.animate)(this.ob.bind(this,C))}this.x.dispose(),this.x=(0,d.disposableTimeout)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3),this.y=f.pageY}ob(f){if(this.y===void 0)return;const C=this.y-f,p=this.renderHeight-35;C<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(C-35))):C>p&&(this.scrollTop+=Math.min(14,Math.floor(.3*(C-p))))}pb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}qb(f){const C=this.q.getDomNode();let p=f;for(;p instanceof HTMLElement&&p!==this.o&&C.contains(p);){const y=p.getAttribute("data-index");if(y){const _=Number(y);if(!isNaN(_))return _}p=p.parentElement}}rb(f,C){return{start:this.g.indexAt(f),end:this.g.indexAfter(f+C-1)}}sb(f,C,p){const y=this.rb(f,C);let _,V;f===this.elementTop(y.start)?(_=y.start,V=0):y.end-y.start>1&&(_=y.start+1,V=this.elementTop(_)-f);let ge=0;for(;;){const Q=this.rb(f,C);let ie=!1;for(let te=Q.start;te<Q.end;te++){const ue=this.tb(te);ue!==0&&this.g.splice(te,1,[this.d[te]]),ge+=ue,ie=ie||ue!==0}if(!ie){ge!==0&&this.R();const te=o.Range.relativeComplement(y,Q);for(const ae of te)for(let de=ae.start;de<ae.end;de++)this.d[de].row&&this.Z(de);const ue=o.Range.relativeComplement(Q,y);for(const ae of ue)for(let de=ae.start;de<ae.end;de++){const Ae=de+1,x=Ae<this.d.length?this.d[Ae].row:null,ve=x?x.domNode:null;this.W(de,ve)}for(let ae=Q.start;ae<Q.end;ae++)this.d[ae].row&&this.Y(this.d[ae],ae);if(typeof _=="number"){const ae=this.p.getFutureScrollPosition().scrollTop-f,de=this.elementTop(_)-V+ae;this.setScrollTop(de,p)}this.M.fire(this.contentHeight);return}}}tb(f){const C=this.d[f];if(this.P.getDynamicHeight){const V=this.P.getDynamicHeight(C.element);if(V!==null){const ge=C.size;return C.size=V,C.lastDynamicHeightWidth=this.n,V-ge}}if(!C.hasDynamicHeight||C.lastDynamicHeightWidth===this.n||!!this.P.hasDynamicHeight&&!this.P.hasDynamicHeight(C.element))return 0;const p=C.size;if(C.row)return C.row.domNode.style.height="",C.size=C.row.domNode.offsetHeight,C.lastDynamicHeightWidth=this.n,C.size-p;const{row:y}=this.h.alloc(C.templateId);y.domNode.style.height="",this.o.appendChild(y.domNode);const _=this.j.get(C.templateId);if(!_)throw new a.BugIndicatingError("Missing renderer for templateId: "+C.templateId);return _.renderElement(C.element,f,y.templateData,void 0),C.size=y.domNode.offsetHeight,_.disposeElement?.(C.element,f,y.templateData,void 0),this.P.setDynamicHeight?.(C.element,C.size),C.lastDynamicHeightWidth=this.n,this.o.removeChild(y.domNode),this.h.release(y),C.size-p}ub(f){const C=f[f.length-1];if(!C)return null;const p=this.d[C.end];return!p||!p.row?null:p.row.domNode}getElementDomId(f){return`${this.domId}_${f}`}dispose(){if(this.d){for(const f of this.d)if(f.row){const C=this.j.get(f.row.templateId);C&&(C.disposeElement?.(f.element,-1,f.row.templateData,void 0),C.disposeTemplate(f.row.templateData))}this.d=[]}this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,I.dispose)(this.L)}}L.c=0,qe([m.memoize],L.prototype,"onMouseClick",null),qe([m.memoize],L.prototype,"onMouseDblClick",null),qe([m.memoize],L.prototype,"onMouseMiddleClick",null),qe([m.memoize],L.prototype,"onMouseUp",null),qe([m.memoize],L.prototype,"onMouseDown",null),qe([m.memoize],L.prototype,"onMouseOver",null),qe([m.memoize],L.prototype,"onMouseMove",null),qe([m.memoize],L.prototype,"onMouseOut",null),qe([m.memoize],L.prototype,"onContextMenu",null),qe([m.memoize],L.prototype,"onTouchStart",null),qe([m.memoize],L.prototype,"onTap",null),t.ListView=L}),define(me[59],be([1,0,4,19,17,22,54,69,14,8,41,24,3,32,2,46,30,5,6,68,58,89]),function(Z,t,v,i,z,H,D,w,d,m,g,I,o,n,e,s,a,l,h,r,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.DefaultStyleController=t.MouseController=t.isSelectionRangeChangeEvent=t.isSelectionSingleChangeEvent=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=t.isButton=t.isMonacoEditor=t.isInputElement=void 0;class b{constructor(u){this.d=u,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(u){return u}renderElement(u,B,W){const $=this.c.findIndex(Y=>Y.templateData===W);if($>=0){const Y=this.c[$];this.d.unrender(W),Y.index=B}else{const Y={index:B,templateData:W};this.c.push(Y)}this.d.renderIndex(B,W)}splice(u,B,W){const $=[];for(const Y of this.c)Y.index<u?$.push(Y):Y.index>=u+B&&$.push({index:Y.index+W-B,templateData:Y.templateData});this.c=$}renderIndexes(u){for(const{index:B,templateData:W}of this.c)u.indexOf(B)>-1&&this.d.renderIndex(B,W)}disposeTemplate(u){const B=this.c.findIndex(W=>W.templateData===u);B<0||this.c.splice(B,1)}}class S{get name(){return this.h}get renderer(){return new b(this)}constructor(u){this.h=u,this.c=0,this.d=[],this.f=[],this.g=new o.Emitter,this.onChange=this.g.event}splice(u,B,W){B=Math.max(0,Math.min(B,this.c-u));const $=W.length-B,Y=u+B,F=[...this.f.filter(U=>U<u),...W.map((U,k)=>U?k+u:-1).filter(U=>U!==-1),...this.f.filter(U=>U>=Y).map(U=>U+$)],O=this.c+$;if(this.f.length>0&&F.length===0&&O>0){const U=this.f.find(k=>k>=u)??O-1;F.push(Math.min(U,O-1))}this.renderer.splice(u,B,W.length),this.k(F,F),this.c=O}renderIndex(u,B){B.classList.toggle(this.h,this.contains(u))}unrender(u){u.classList.remove(this.h)}set(u,B){return this.k(u,[...u].sort(X),B)}k(u,B,W){const $=this.d,Y=this.f;this.d=u,this.f=B;const F=Ne(Y,u);return this.renderer.renderIndexes(F),this.g.fire({indexes:u,browserEvent:W}),$}get(){return this.d}contains(u){return(0,d.binarySearch)(this.f,u,X)>=0}dispose(){(0,e.dispose)(this.g)}}qe([I.memoize],S.prototype,"renderer",null);class N extends S{constructor(u){super("selected"),this.l=u}renderIndex(u,B){super.renderIndex(u,B),this.l&&(this.contains(u)?B.setAttribute("aria-selected","true"):B.setAttribute("aria-selected","false"))}}class L{constructor(u,B,W){this.c=u,this.d=B,this.f=W}splice(u,B,W){if(!this.f)return this.c.splice(u,B,W.map(()=>!1));const $=this.c.get().map(F=>this.f.getId(this.d.element(F)).toString()),Y=W.map(F=>$.indexOf(this.f.getId(F).toString())>-1);this.c.splice(u,B,Y)}}function T(E){return E.tagName==="INPUT"||E.tagName==="TEXTAREA"}t.isInputElement=T;function f(E){return E.classList.contains("monaco-editor")?!0:E.classList.contains("monaco-list")||!E.parentElement?!1:f(E.parentElement)}t.isMonacoEditor=f;function C(E){return E.tagName==="A"&&E.classList.contains("monaco-button")||E.tagName==="DIV"&&E.classList.contains("monaco-button-dropdown")?!0:E.classList.contains("monaco-list")||!E.parentElement?!1:C(E.parentElement)}t.isButton=C;class p{get f(){return this.c.add(o.Event.chain(this.c.add(new i.DomEmitter(this.h.domNode,"keydown")).event).filter(u=>!T(u.target)).map(u=>new z.StandardKeyboardEvent(u)))}constructor(u,B,W){this.g=u,this.h=B,this.c=new e.DisposableStore,this.d=new e.DisposableStore,this.f.filter($=>$.keyCode===3).on(this.k,this,this.c),this.f.filter($=>$.keyCode===16).on(this.l,this,this.c),this.f.filter($=>$.keyCode===18).on(this.o,this,this.c),this.f.filter($=>$.keyCode===11).on(this.p,this,this.c),this.f.filter($=>$.keyCode===12).on(this.q,this,this.c),this.f.filter($=>$.keyCode===9).on(this.t,this,this.c),W.multipleSelectionSupport!==!1&&this.f.filter($=>(l.isMacintosh?$.metaKey:$.ctrlKey)&&$.keyCode===31).on(this.s,this,this.d)}updateOptions(u){u.multipleSelectionSupport!==void 0&&(this.d.clear(),u.multipleSelectionSupport&&this.f.filter(B=>(l.isMacintosh?B.metaKey:B.ctrlKey)&&B.keyCode===31).on(this.s,this,this.d))}k(u){u.preventDefault(),u.stopPropagation(),this.g.setSelection(this.g.getFocus(),u.browserEvent)}l(u){u.preventDefault(),u.stopPropagation(),this.g.focusPrevious(1,!1,u.browserEvent);const B=this.g.getFocus()[0];this.g.setAnchor(B),this.g.reveal(B),this.h.domNode.focus()}o(u){u.preventDefault(),u.stopPropagation(),this.g.focusNext(1,!1,u.browserEvent);const B=this.g.getFocus()[0];this.g.setAnchor(B),this.g.reveal(B),this.h.domNode.focus()}p(u){u.preventDefault(),u.stopPropagation(),this.g.focusPreviousPage(u.browserEvent);const B=this.g.getFocus()[0];this.g.setAnchor(B),this.g.reveal(B),this.h.domNode.focus()}q(u){u.preventDefault(),u.stopPropagation(),this.g.focusNextPage(u.browserEvent);const B=this.g.getFocus()[0];this.g.setAnchor(B),this.g.reveal(B),this.h.domNode.focus()}s(u){u.preventDefault(),u.stopPropagation(),this.g.setSelection((0,d.range)(this.g.length),u.browserEvent),this.g.setAnchor(void 0),this.h.domNode.focus()}t(u){this.g.getSelection().length&&(u.preventDefault(),u.stopPropagation(),this.g.setSelection([],u.browserEvent),this.g.setAnchor(void 0),this.h.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}qe([I.memoize],p.prototype,"f",null);var y;(function(E){E[E.Automatic=0]="Automatic",E[E.Trigger=1]="Trigger"})(y=t.TypeNavigationMode||(t.TypeNavigationMode={}));var _;(function(E){E[E.Idle=0]="Idle",E[E.Typing=1]="Typing"})(_||(_={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(E){return E.ctrlKey||E.metaKey||E.altKey?!1:E.keyCode>=31&&E.keyCode<=56||E.keyCode>=21&&E.keyCode<=30||E.keyCode>=93&&E.keyCode<=102||E.keyCode>=80&&E.keyCode<=90}};class V{constructor(u,B,W,$,Y){this.o=u,this.p=B,this.q=W,this.s=$,this.t=Y,this.c=!1,this.d=_.Idle,this.f=y.Automatic,this.g=!1,this.h=-1,this.k=new e.DisposableStore,this.l=new e.DisposableStore,this.updateOptions(u.options)}updateOptions(u){u.typeNavigationEnabled??!0?this.u():this.v(),this.f=u.typeNavigationMode??y.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let u=!1;const B=this.k.add(o.Event.chain(this.k.add(new i.DomEmitter(this.p.domNode,"keydown")).event)).filter(Y=>!T(Y.target)).filter(()=>this.f===y.Automatic||this.g).map(Y=>new z.StandardKeyboardEvent(Y)).filter(Y=>u||this.s(Y)).filter(Y=>this.t.mightProducePrintableCharacter(Y)).forEach(Y=>v.EventHelper.stop(Y,!0)).map(Y=>Y.browserEvent.key).event,W=o.Event.debounce(B,()=>null,800,void 0,void 0,this.k);o.Event.reduce(o.Event.any(B,W),(Y,F)=>F===null?null:(Y||"")+F,void 0,this.k)(this.z,this,this.k),W(this.w,this,this.k),B(()=>u=!0,void 0,this.k),W(()=>u=!1,void 0,this.k),this.c=!0,this.g=!1}v(){!this.c||(this.k.clear(),this.c=!1,this.g=!1)}w(){const u=this.o.getFocus();if(u.length>0&&u[0]===this.h){const B=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(u[0]));B&&(0,D.alert)(B)}this.h=-1}z(u){if(!u){this.d=_.Idle,this.g=!1;return}const B=this.o.getFocus(),W=B.length>0?B[0]:0,$=this.d===_.Idle?1:0;this.d=_.Typing;for(let Y=0;Y<this.o.length;Y++){const F=(W+Y+$)%this.o.length,O=this.q.getKeyboardNavigationLabel(this.p.element(F)),U=O&&O.toString();if(typeof U>"u"||(0,n.matchesPrefix)(u,U)){this.h=W,this.o.setFocus([F]),this.o.reveal(F);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class ge{constructor(u,B){this.d=u,this.f=B,this.c=new e.DisposableStore,this.c.add(o.Event.chain(this.c.add(new i.DomEmitter(B.domNode,"keydown")).event)).filter($=>!T($.target)).map($=>new z.StandardKeyboardEvent($)).filter($=>$.keyCode===2&&!$.ctrlKey&&!$.metaKey&&!$.shiftKey&&!$.altKey).on(this.g,this,this.c)}g(u){if(u.target!==this.f.domNode)return;const B=this.d.getFocus();if(B.length===0)return;const W=this.f.domElement(B[0]);if(!W)return;const $=W.querySelector("[tabIndex]");if(!$||!($ instanceof HTMLElement)||$.tabIndex===-1)return;const Y=window.getComputedStyle($);Y.visibility==="hidden"||Y.display==="none"||(u.preventDefault(),u.stopPropagation(),$.focus())}dispose(){this.c.dispose()}}function Q(E){return l.isMacintosh?E.browserEvent.metaKey:E.browserEvent.ctrlKey}t.isSelectionSingleChangeEvent=Q;function ie(E){return E.browserEvent.shiftKey}t.isSelectionRangeChangeEvent=ie;function te(E){return E instanceof MouseEvent&&E.button===2}const ue={isSelectionSingleChangeEvent:Q,isSelectionRangeChangeEvent:ie};class ae{constructor(u){this.k=u,this.f=new e.DisposableStore,this.g=new o.Emitter,this.onPointer=this.g.event,u.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||ue),this.d=typeof u.options.mouseSupport>"u"||!!u.options.mouseSupport,this.d&&(u.onMouseDown(this.s,this,this.f),u.onContextMenu(this.t,this,this.f),u.onMouseDblClick(this.v,this,this.f),u.onTouchStart(this.s,this,this.f),this.f.add(H.Gesture.addTarget(u.getHTMLElement()))),o.Event.any(u.onMouseClick,u.onMouseMiddleClick,u.onTap)(this.u,this,this.f)}updateOptions(u){u.multipleSelectionSupport!==void 0&&(this.c=void 0,u.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||ue))}o(u){return this.c?this.c.isSelectionSingleChangeEvent(u):!1}p(u){return this.c?this.c.isSelectionRangeChangeEvent(u):!1}q(u){return this.o(u)||this.p(u)}s(u){f(u.browserEvent.target)||document.activeElement!==u.browserEvent.target&&this.k.domFocus()}t(u){if(f(u.browserEvent.target))return;const B=typeof u.index>"u"?[]:[u.index];this.k.setFocus(B,u.browserEvent)}u(u){if(!this.d||T(u.browserEvent.target)||f(u.browserEvent.target))return;const B=u.index;if(typeof B>"u"){this.k.setFocus([],u.browserEvent),this.k.setSelection([],u.browserEvent),this.k.setAnchor(void 0);return}if(this.p(u))return this.w(u);if(this.q(u))return this.w(u);this.k.setFocus([B],u.browserEvent),this.k.setAnchor(B),te(u.browserEvent)||this.k.setSelection([B],u.browserEvent),this.g.fire(u)}v(u){if(T(u.browserEvent.target)||f(u.browserEvent.target)||this.q(u))return;const B=this.k.getFocus();this.k.setSelection(B,u.browserEvent)}w(u){const B=u.index;let W=this.k.getAnchor();if(this.p(u)){typeof W>"u"&&(W=this.k.getFocus()[0]??B,this.k.setAnchor(W));const $=Math.min(W,B),Y=Math.max(W,B),F=(0,d.range)($,Y+1),O=this.k.getSelection(),U=ve(Ne(O,[W]),W);if(U.length===0)return;const k=Ne(F,oe(O,U));this.k.setSelection(k,u.browserEvent),this.k.setFocus([B],u.browserEvent)}else if(this.o(u)){const $=this.k.getSelection(),Y=$.filter(F=>F!==B);this.k.setFocus([B]),this.k.setAnchor(B),$.length===Y.length?this.k.setSelection([...Y,B],u.browserEvent):this.k.setSelection(Y,u.browserEvent)}}dispose(){this.f.dispose()}}t.MouseController=ae;class de{constructor(u,B){this.c=u,this.d=B}style(u){const B=this.d&&`.${this.d}`,W=[];u.listBackground&&(u.listBackground.isOpaque()?W.push(`.monaco-list${B} .monaco-list-rows { background: ${u.listBackground}; }`):l.isMacintosh||console.warn(`List with id '${this.d}' was styled with a non-opaque background color. This will break sub-pixel antialiasing.`)),u.listFocusBackground&&(W.push(`.monaco-list${B}:focus .monaco-list-row.focused { background-color: ${u.listFocusBackground}; }`),W.push(`.monaco-list${B}:focus .monaco-list-row.focused:hover { background-color: ${u.listFocusBackground}; }`)),u.listFocusForeground&&W.push(`.monaco-list${B}:focus .monaco-list-row.focused { color: ${u.listFocusForeground}; }`),u.listActiveSelectionBackground&&(W.push(`.monaco-list${B}:focus .monaco-list-row.selected { background-color: ${u.listActiveSelectionBackground}; }`),W.push(`.monaco-list${B}:focus .monaco-list-row.selected:hover { background-color: ${u.listActiveSelectionBackground}; }`)),u.listActiveSelectionForeground&&W.push(`.monaco-list${B}:focus .monaco-list-row.selected { color: ${u.listActiveSelectionForeground}; }`),u.listActiveSelectionIconForeground&&W.push(`.monaco-list${B}:focus .monaco-list-row.selected .codicon { color: ${u.listActiveSelectionIconForeground}; }`),u.listFocusAndSelectionOutline&&W.push(`.monaco-list${B}:focus .monaco-list-row.selected { outline-color: ${u.listFocusAndSelectionOutline} !important; }`),u.listFocusAndSelectionBackground&&W.push(`
				.monaco-drag-image,
				.monaco-list${B}:focus .monaco-list-row.selected.focused { background-color: ${u.listFocusAndSelectionBackground}; }
			`),u.listFocusAndSelectionForeground&&W.push(`
				.monaco-drag-image,
				.monaco-list${B}:focus .monaco-list-row.selected.focused { color: ${u.listFocusAndSelectionForeground}; }
			`),u.listInactiveFocusForeground&&(W.push(`.monaco-list${B} .monaco-list-row.focused { color:  ${u.listInactiveFocusForeground}; }`),W.push(`.monaco-list${B} .monaco-list-row.focused:hover { color:  ${u.listInactiveFocusForeground}; }`)),u.listInactiveSelectionIconForeground&&W.push(`.monaco-list${B} .monaco-list-row.focused .codicon { color:  ${u.listInactiveSelectionIconForeground}; }`),u.listInactiveFocusBackground&&(W.push(`.monaco-list${B} .monaco-list-row.focused { background-color:  ${u.listInactiveFocusBackground}; }`),W.push(`.monaco-list${B} .monaco-list-row.focused:hover { background-color:  ${u.listInactiveFocusBackground}; }`)),u.listInactiveSelectionBackground&&(W.push(`.monaco-list${B} .monaco-list-row.selected { background-color:  ${u.listInactiveSelectionBackground}; }`),W.push(`.monaco-list${B} .monaco-list-row.selected:hover { background-color:  ${u.listInactiveSelectionBackground}; }`)),u.listInactiveSelectionForeground&&W.push(`.monaco-list${B} .monaco-list-row.selected { color: ${u.listInactiveSelectionForeground}; }`),u.listHoverBackground&&W.push(`.monaco-list${B}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${u.listHoverBackground}; }`),u.listHoverForeground&&W.push(`.monaco-list${B}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${u.listHoverForeground}; }`),u.listSelectionOutline&&W.push(`.monaco-list${B} .monaco-list-row.selected { outline: 1px dotted ${u.listSelectionOutline}; outline-offset: -1px; }`),u.listFocusOutline&&W.push(`
				.monaco-drag-image,
				.monaco-list${B}:focus .monaco-list-row.focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${B}.last-focused .monaco-list-row.focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }
			`),u.listInactiveFocusOutline&&W.push(`.monaco-list${B} .monaco-list-row.focused { outline: 1px dotted ${u.listInactiveFocusOutline}; outline-offset: -1px; }`),u.listHoverOutline&&W.push(`.monaco-list${B} .monaco-list-row:hover { outline: 1px dashed ${u.listHoverOutline}; outline-offset: -1px; }`),u.listDropBackground&&W.push(`
				.monaco-list${B}.drop-target,
				.monaco-list${B} .monaco-list-rows.drop-target,
				.monaco-list${B} .monaco-list-row.drop-target { background-color: ${u.listDropBackground} !important; color: inherit !important; }
			`),u.tableColumnsBorder&&W.push(`
				.monaco-table:hover > .monaco-split-view2,
				.monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${u.tableColumnsBorder};
			}`),u.tableOddRowsBackgroundColor&&W.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${u.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=W.join(`
`)}}t.DefaultStyleController=de;const Ae={listFocusBackground:g.Color.fromHex("#7FB0D0"),listActiveSelectionBackground:g.Color.fromHex("#0E639C"),listActiveSelectionForeground:g.Color.fromHex("#FFFFFF"),listActiveSelectionIconForeground:g.Color.fromHex("#FFFFFF"),listFocusAndSelectionOutline:g.Color.fromHex("#90C2F9"),listFocusAndSelectionBackground:g.Color.fromHex("#094771"),listFocusAndSelectionForeground:g.Color.fromHex("#FFFFFF"),listInactiveSelectionBackground:g.Color.fromHex("#3F3F46"),listInactiveSelectionIconForeground:g.Color.fromHex("#FFFFFF"),listHoverBackground:g.Color.fromHex("#2A2D2E"),listDropBackground:g.Color.fromHex("#383B3D"),treeIndentGuidesStroke:g.Color.fromHex("#a9a9a9"),tableColumnsBorder:g.Color.fromHex("#cccccc").transparent(.2),tableOddRowsBackgroundColor:g.Color.fromHex("#cccccc").transparent(.04)},x={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function ve(E,u){const B=E.indexOf(u);if(B===-1)return[];const W=[];let $=B-1;for(;$>=0&&E[$]===u-(B-$);)W.push(E[$--]);for(W.reverse(),$=B;$<E.length&&E[$]===u+($-B);)W.push(E[$++]);return W}function Ne(E,u){const B=[];let W=0,$=0;for(;W<E.length||$<u.length;)if(W>=E.length)B.push(u[$++]);else if($>=u.length)B.push(E[W++]);else if(E[W]===u[$]){B.push(E[W]),W++,$++;continue}else E[W]<u[$]?B.push(E[W++]):B.push(u[$++]);return B}function oe(E,u){const B=[];let W=0,$=0;for(;W<E.length||$<u.length;)if(W>=E.length)B.push(u[$++]);else if($>=u.length)B.push(E[W++]);else if(E[W]===u[$]){W++,$++;continue}else E[W]<u[$]?B.push(E[W++]):$++;return B}const X=(E,u)=>E-u;class se{constructor(u,B){this.c=u,this.d=B}get templateId(){return this.c}renderTemplate(u){return this.d.map(B=>B.renderTemplate(u))}renderElement(u,B,W,$){let Y=0;for(const F of this.d)F.renderElement(u,B,W[Y++],$)}disposeElement(u,B,W,$){let Y=0;for(const F of this.d)F.disposeElement?.(u,B,W[Y],$),Y+=1}disposeTemplate(u){let B=0;for(const W of this.d)W.disposeTemplate(u[B++])}}class ne{constructor(u){this.c=u,this.templateId="a18n"}renderTemplate(u){return u}renderElement(u,B,W){const $=this.c.getAriaLabel(u);$?W.setAttribute("aria-label",$):W.removeAttribute("aria-label");const Y=this.c.getAriaLevel&&this.c.getAriaLevel(u);typeof Y=="number"?W.setAttribute("aria-level",`${Y}`):W.removeAttribute("aria-level")}disposeTemplate(u){}}class ee{constructor(u,B){this.c=u,this.d=B}getDragElements(u){const B=this.c.getSelectedElements();return B.indexOf(u)>-1?B:[u]}getDragURI(u){return this.d.getDragURI(u)}getDragLabel(u,B){if(this.d.getDragLabel)return this.d.getDragLabel(u,B)}onDragStart(u,B){this.d.onDragStart?.(u,B)}onDragOver(u,B,W,$){return this.d.onDragOver(u,B,W,$)}onDragLeave(u,B,W,$){this.d.onDragLeave?.(u,B,W,$)}onDragEnd(u){this.d.onDragEnd?.(u)}drop(u,B,W,$){this.d.drop(u,B,W,$)}}class A{get onDidChangeFocus(){return o.Event.map(this.g.wrapEvent(this.c.onChange),u=>this.H(u),this.A)}get onDidChangeSelection(){return o.Event.map(this.g.wrapEvent(this.d.onChange),u=>this.H(u),this.A)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let u=!1;const B=this.A.add(o.Event.chain(this.A.add(new i.DomEmitter(this.k.domNode,"keydown")).event)).map(Y=>new z.StandardKeyboardEvent(Y)).filter(Y=>u=Y.keyCode===58||Y.shiftKey&&Y.keyCode===68).map(Y=>v.EventHelper.stop(Y,!0)).filter(()=>!1).event,W=this.A.add(o.Event.chain(this.A.add(new i.DomEmitter(this.k.domNode,"keyup")).event)).forEach(()=>u=!1).map(Y=>new z.StandardKeyboardEvent(Y)).filter(Y=>Y.keyCode===58||Y.shiftKey&&Y.keyCode===68).map(Y=>v.EventHelper.stop(Y,!0)).map(({browserEvent:Y})=>{const F=this.getFocus(),O=F.length?F[0]:void 0,U=typeof O<"u"?this.k.element(O):void 0,k=typeof O<"u"?this.k.domElement(O):this.k.domNode;return{index:O,element:U,anchor:k,browserEvent:Y}}).event,$=this.A.add(o.Event.chain(this.k.onContextMenu)).filter(Y=>!u).map(({element:Y,index:F,browserEvent:O})=>({element:Y,index:F,anchor:{x:O.pageX+1,y:O.pageY},browserEvent:O})).event;return o.Event.any(B,W,$)}get onKeyDown(){return this.A.add(new i.DomEmitter(this.k.domNode,"keydown")).event}get onKeyUp(){return this.A.add(new i.DomEmitter(this.k.domNode,"keyup")).event}get onKeyPress(){return this.A.add(new i.DomEmitter(this.k.domNode,"keypress")).event}get onDidFocus(){return o.Event.signal(this.A.add(new i.DomEmitter(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return o.Event.signal(this.A.add(new i.DomEmitter(this.k.domNode,"blur",!0)).event)}constructor(u,B,W,$,Y=x){this.C=u,this.D=Y,this.c=new S("focused"),this.f=new S("anchor"),this.g=new o.EventBufferer,this.z="",this.A=new e.DisposableStore,this.B=new o.Emitter,this.onDidDispose=this.B.event;const F=this.D.accessibilityProvider&&this.D.accessibilityProvider.getWidgetRole?this.D.accessibilityProvider?.getWidgetRole():"list";this.d=new N(F!=="listbox"),(0,a.mixin)(Y,Ae,!1);const O=[this.c.renderer,this.d.renderer];this.u=Y.accessibilityProvider,this.u&&(O.push(new ne(this.u)),this.u.onDidChangeActiveDescendant?.(this.J,this,this.A)),$=$.map(k=>new se(k.templateId,[...O,k]));const U={...Y,dnd:Y.dnd&&new ee(this,Y.dnd)};if(this.k=new c.ListView(B,W,$,U),this.k.domNode.setAttribute("role",F),Y.styleController)this.q=Y.styleController(this.k.domId);else{const k=(0,v.createStyleSheet)(this.k.domNode);this.q=new de(k,this.k.domId)}if(this.o=new w.CombinedSpliceable([new L(this.c,this.k,Y.identityProvider),new L(this.d,this.k,Y.identityProvider),new L(this.f,this.k,Y.identityProvider),this.k]),this.A.add(this.c),this.A.add(this.d),this.A.add(this.f),this.A.add(this.k),this.A.add(this.B),this.A.add(new ge(this,this.k)),(typeof Y.keyboardSupport!="boolean"||Y.keyboardSupport)&&(this.v=new p(this,this.k,Y),this.A.add(this.v)),Y.keyboardNavigationLabelProvider){const k=Y.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.t=new V(this,this.k,Y.keyboardNavigationLabelProvider,Y.keyboardNavigationEventFilter??(()=>!0),k),this.A.add(this.t)}this.w=this.E(Y),this.A.add(this.w),this.onDidChangeFocus(this.I,this,this.A),this.onDidChangeSelection(this.K,this,this.A),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.D.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}E(u){return new ae(this)}updateOptions(u={}){this.D={...this.D,...u},this.t?.updateOptions(this.D),this.D.multipleSelectionController!==void 0&&(this.D.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(u),this.v?.updateOptions(u),this.k.updateOptions(u)}get options(){return this.D}splice(u,B,W=[]){if(u<0||u>this.k.length)throw new r.ListError(this.C,`Invalid start index: ${u}`);if(B<0)throw new r.ListError(this.C,`Invalid delete count: ${B}`);B===0&&W.length===0||this.g.bufferEvents(()=>this.o.splice(u,B,W))}updateWidth(u){this.k.updateWidth(u)}updateElementHeight(u,B){this.k.updateElementHeight(u,B,null)}rerender(){this.k.rerender()}element(u){return this.k.element(u)}indexOf(u){return this.k.indexOf(u)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get scrollTop(){return this.k.getScrollTop()}set scrollTop(u){this.k.setScrollTop(u)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(u){this.k.setScrollLeft(u)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.z}set ariaLabel(u){this.z=u,this.k.domNode.setAttribute("aria-label",u)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(u,B){this.k.layout(u,B)}triggerTypeNavigation(){this.t?.trigger()}setSelection(u,B){for(const W of u)if(W<0||W>=this.length)throw new r.ListError(this.C,`Invalid index ${W}`);this.d.set(u,B)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(u=>this.k.element(u))}setAnchor(u){if(typeof u>"u"){this.f.set([]);return}if(u<0||u>=this.length)throw new r.ListError(this.C,`Invalid index ${u}`);this.f.set([u])}getAnchor(){return(0,d.firstOrDefault)(this.f.get(),void 0)}getAnchorElement(){const u=this.getAnchor();return typeof u>"u"?void 0:this.element(u)}setFocus(u,B){for(const W of u)if(W<0||W>=this.length)throw new r.ListError(this.C,`Invalid index ${W}`);this.c.set(u,B)}focusNext(u=1,B=!1,W,$){if(this.length===0)return;const Y=this.c.get(),F=this.F(Y.length>0?Y[0]+u:0,B,$);F>-1&&this.setFocus([F],W)}focusPrevious(u=1,B=!1,W,$){if(this.length===0)return;const Y=this.c.get(),F=this.G(Y.length>0?Y[0]-u:0,B,$);F>-1&&this.setFocus([F],W)}async focusNextPage(u,B){let W=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);W=W===0?0:W-1;const $=this.getFocus()[0];if($!==W&&($===void 0||W>$)){const Y=this.G(W,!1,B);Y>-1&&$!==Y?this.setFocus([Y],u):this.setFocus([W],u)}else{const Y=this.k.getScrollTop();let F=Y+this.k.renderHeight;W>$&&(F-=this.k.elementHeight(W)),this.k.setScrollTop(F),this.k.getScrollTop()!==Y&&(this.setFocus([]),await(0,m.timeout)(0),await this.focusNextPage(u,B))}}async focusPreviousPage(u,B){let W;const $=this.k.getScrollTop();$===0?W=this.k.indexAt($):W=this.k.indexAfter($-1);const Y=this.getFocus()[0];if(Y!==W&&(Y===void 0||Y>=W)){const F=this.F(W,!1,B);F>-1&&Y!==F?this.setFocus([F],u):this.setFocus([W],u)}else{const F=$;this.k.setScrollTop($-this.k.renderHeight),this.k.getScrollTop()!==F&&(this.setFocus([]),await(0,m.timeout)(0),await this.focusPreviousPage(u,B))}}focusLast(u,B){if(this.length===0)return;const W=this.G(this.length-1,!1,B);W>-1&&this.setFocus([W],u)}focusFirst(u,B){this.focusNth(0,u,B)}focusNth(u,B,W){if(this.length===0)return;const $=this.F(u,!1,W);$>-1&&this.setFocus([$],B)}F(u,B=!1,W){for(let $=0;$<this.length;$++){if(u>=this.length&&!B)return-1;if(u=u%this.length,!W||W(this.element(u)))return u;u++}return-1}G(u,B=!1,W){for(let $=0;$<this.length;$++){if(u<0&&!B)return-1;if(u=(this.length+u%this.length)%this.length,!W||W(this.element(u)))return u;u--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(u=>this.k.element(u))}reveal(u,B){if(u<0||u>=this.length)throw new r.ListError(this.C,`Invalid index ${u}`);const W=this.k.getScrollTop(),$=this.k.elementTop(u),Y=this.k.elementHeight(u);if((0,h.isNumber)(B)){const F=Y-this.k.renderHeight;this.k.setScrollTop(F*(0,s.clamp)(B,0,1)+$)}else{const F=$+Y,O=W+this.k.renderHeight;$<W&&F>=O||($<W||F>=O&&Y>=this.k.renderHeight?this.k.setScrollTop($):F>=O&&this.k.setScrollTop(F-this.k.renderHeight))}}getRelativeTop(u){if(u<0||u>=this.length)throw new r.ListError(this.C,`Invalid index ${u}`);const B=this.k.getScrollTop(),W=this.k.elementTop(u),$=this.k.elementHeight(u);if(W<B||W+$>B+this.k.renderHeight)return null;const Y=$-this.k.renderHeight;return Math.abs((B-W)/Y)}isDOMFocused(){return this.k.domNode===document.activeElement}getHTMLElement(){return this.k.domNode}getElementID(u){return this.k.getElementDomId(u)}style(u){this.q.style(u)}H({indexes:u,browserEvent:B}){return{indexes:u,elements:u.map(W=>this.k.element(W)),browserEvent:B}}I(){const u=this.c.get();this.k.domNode.classList.toggle("element-focused",u.length>0),this.J()}J(){const u=this.c.get();if(u.length>0){let B;this.u?.getActiveDescendantId&&(B=this.u.getActiveDescendantId(this.k.element(u[0]))),this.k.domNode.setAttribute("aria-activedescendant",B||this.k.getElementDomId(u[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}K(){const u=this.d.get();this.k.domNode.classList.toggle("selection-none",u.length===0),this.k.domNode.classList.toggle("selection-single",u.length===1),this.k.domNode.classList.toggle("selection-multiple",u.length>1)}dispose(){this.B.fire(),this.A.dispose(),this.B.dispose()}}qe([I.memoize],A.prototype,"onDidChangeFocus",null),qe([I.memoize],A.prototype,"onDidChangeSelection",null),qe([I.memoize],A.prototype,"onContextMenu",null),qe([I.memoize],A.prototype,"onKeyDown",null),qe([I.memoize],A.prototype,"onKeyUp",null),qe([I.memoize],A.prototype,"onKeyPress",null),qe([I.memoize],A.prototype,"onDidFocus",null),qe([I.memoize],A.prototype,"onDidBlur",null),t.List=A}),define(me[60],be([1,0,9,33,35,11,15]),function(Z,t,v,i,z,H,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseHrefAndDimensions=t.removeMarkdownEscapes=t.escapeDoubleQuotes=t.escapeMarkdownSyntaxTokens=t.markdownStringEqual=t.isMarkdownString=t.isEmptyMarkdownString=t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0;var w;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(w=t.MarkdownStringTextNewlineStyle||(t.MarkdownStringTextNewlineStyle={}));class d{constructor(l="",h=!1){if(this.value=l,typeof this.value!="string")throw(0,v.illegalArgument)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(l,h=0){return this.value+=o(this.supportThemeIcons?(0,i.escapeIcons)(l):l).replace(/([ \t]+)/g,(r,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,h){return this.value+="\n```",this.value+=l,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}appendLink(l,h,r){return this.value+="[",this.value+=this.c(h,"]"),this.value+="](",this.value+=this.c(String(l),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(l,h){const r=new RegExp((0,H.escapeRegExpCharacters)(h),"g");return l.replace(r,(c,b)=>l.charAt(b-1)!=="\\"?`\\${c}`:c)}}t.MarkdownString=d;function m(a){return g(a)?!a.value:Array.isArray(a)?a.every(m):!0}t.isEmptyMarkdownString=m;function g(a){return a instanceof d?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}t.isMarkdownString=g;function I(a,l){return a===l?!0:!a||!l?!1:a.value===l.value&&a.isTrusted===l.isTrusted&&a.supportThemeIcons===l.supportThemeIcons&&a.supportHtml===l.supportHtml&&(a.baseUri===l.baseUri||!!a.baseUri&&!!l.baseUri&&(0,z.isEqual)(D.URI.from(a.baseUri),D.URI.from(l.baseUri)))}t.markdownStringEqual=I;function o(a){return a.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}t.escapeMarkdownSyntaxTokens=o;function n(a){return a.replace(/"/g,"&quot;")}t.escapeDoubleQuotes=n;function e(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}t.removeMarkdownEscapes=e;function s(a){const l=[],h=a.split("|").map(c=>c.trim());a=h[0];const r=h[1];if(r){const c=/height=(\d+)/.exec(r),b=/width=(\d+)/.exec(r),S=c?c[1]:"",N=b?b[1]:"",L=isFinite(parseInt(N)),T=isFinite(parseInt(S));L&&l.push(`width="${N}"`),T&&l.push(`height="${S}"`)}return{href:a,dimensions:l}}t.parseHrefAndDimensions=s}),define(me[122],be([1,0,4,114,19,52,17,20,115,9,3,60,33,73,44,2,76,50,34,30,35,11,15]),function(Z,t,v,i,z,H,D,w,d,m,g,I,o,n,e,s,a,l,h,r,c,b,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderMarkdownAsPlaintext=t.renderStringAsPlaintext=t.allowedMarkdownAttr=t.renderMarkdown=void 0;const N=Object.freeze({image:(Q,ie,te)=>{let ue=[],ae=[];return Q&&({href:Q,dimensions:ue}=(0,I.parseHrefAndDimensions)(Q),ae.push(`src="${(0,I.escapeDoubleQuotes)(Q)}"`)),te&&ae.push(`alt="${(0,I.escapeDoubleQuotes)(te)}"`),ie&&ae.push(`title="${(0,I.escapeDoubleQuotes)(ie)}"`),ue.length&&(ae=ae.concat(ue)),"<img "+ae.join(" ")+">"},paragraph:Q=>`<p>${Q}</p>`,link:(Q,ie,te)=>typeof Q!="string"?"":(Q===te&&(te=(0,I.removeMarkdownEscapes)(te)),ie=typeof ie=="string"?(0,I.escapeDoubleQuotes)((0,I.removeMarkdownEscapes)(ie)):"",Q=(0,I.removeMarkdownEscapes)(Q),Q=Q.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${Q}" title="${ie||Q}">${te}</a>`)});function L(Q,ie={},te={}){const ue=new s.DisposableStore;let ae=!1;const de=(0,H.createElement)(ie),Ae=function(ee){let A;try{A=(0,l.parse)(decodeURIComponent(ee))}catch{}return A?(A=(0,r.cloneAndChange)(A,E=>{if(Q.uris&&Q.uris[E])return S.URI.revive(Q.uris[E])}),encodeURIComponent(JSON.stringify(A))):ee},x=function(ee,A){const E=Q.uris&&Q.uris[ee];let u=S.URI.revive(E);return A?ee.startsWith(h.Schemas.data+":")?ee:(u||(u=S.URI.parse(ee)),h.FileAccess.uriToBrowserUri(u).toString(!0)):!u||S.URI.parse(ee).toString()===u.toString()?ee:(u.query&&(u=u.with({query:Ae(u.query)})),u.toString())},ve=new a.marked.Renderer;ve.image=N.image,ve.link=N.link,ve.paragraph=N.paragraph;const Ne=[];if(ie.codeBlockRenderer&&(ve.code=(ee,A)=>{const E=n.defaultGenerator.nextId(),u=ie.codeBlockRenderer(T(A),ee);return Ne.push(u.then(B=>[E,B])),`<div class="code" data-code="${E}">${(0,b.escape)(ee)}</div>`}),ie.actionHandler){const ee=function(u){let B=u.target;if(!(B.tagName!=="A"&&(B=B.parentElement,!B||B.tagName!=="A")))try{let W=B.dataset.href;W&&(Q.baseUri&&(W=f(S.URI.from(Q.baseUri),W)),ie.actionHandler.callback(W,u))}catch(W){(0,m.onUnexpectedError)(W)}finally{u.preventDefault()}},A=ie.actionHandler.disposables.add(new z.DomEmitter(de,"click")),E=ie.actionHandler.disposables.add(new z.DomEmitter(de,"auxclick"));ie.actionHandler.disposables.add(g.Event.any(A.event,E.event)(u=>{const B=new w.StandardMouseEvent(u);!B.leftButton&&!B.middleButton||ee(B)})),ie.actionHandler.disposables.add(v.addDisposableListener(de,"keydown",u=>{const B=new D.StandardKeyboardEvent(u);!B.equals(10)&&!B.equals(3)||ee(B)}))}Q.supportHtml||(te.sanitizer=ee=>(Q.isTrusted?ee.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?ee:"",te.sanitize=!0,te.silent=!0),te.renderer=ve;let oe=Q.value??"";oe.length>1e5&&(oe=`${oe.substr(0,1e5)}\u2026`),Q.supportThemeIcons&&(oe=(0,o.markdownEscapeEscapedIcons)(oe));let X=a.marked.parse(oe,te);Q.supportThemeIcons&&(X=(0,d.renderLabelWithIcons)(X).map(A=>typeof A=="string"?A:A.outerHTML).join(""));const ne=new DOMParser().parseFromString(C(Q,X),"text/html");if(ne.body.querySelectorAll("img").forEach(ee=>{const A=ee.getAttribute("src");if(A){let E=A;try{Q.baseUri&&(E=f(S.URI.from(Q.baseUri),E))}catch{}ee.src=x(E,!0)}}),ne.body.querySelectorAll("a").forEach(ee=>{const A=ee.getAttribute("href");if(ee.removeAttribute("href"),!A||/^data:|javascript:/i.test(A)||/^command:/i.test(A)&&!Q.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(A))ee.replaceWith(...ee.childNodes);else{let E=x(A,!1);Q.baseUri&&(E=f(S.URI.from(Q.baseUri),A)),ee.dataset.href=E}}),de.innerHTML=C(Q,ne.body.innerHTML),Ne.length>0&&Promise.all(Ne).then(ee=>{if(ae)return;const A=new Map(ee),E=de.querySelectorAll("div[data-code]");for(const u of E){const B=A.get(u.dataset.code??"");B&&v.reset(u,B)}ie.asyncRenderCallback?.()}),ie.asyncRenderCallback)for(const ee of de.getElementsByTagName("img")){const A=ue.add(v.addDisposableListener(ee,"load",()=>{A.dispose(),ie.asyncRenderCallback()}))}return{element:de,dispose:()=>{ae=!0,ue.dispose()}}}t.renderMarkdown=L;function T(Q){if(!Q)return"";const ie=Q.split(/[\s+|:|,|\{|\?]/,1);return ie.length?ie[0]:Q}function f(Q,ie){return/^\w[\w\d+.-]*:/.test(ie)?ie:Q.path.endsWith("/")?(0,c.resolvePath)(Q,ie).toString():(0,c.resolvePath)((0,c.dirname)(Q),ie).toString()}function C(Q,ie){const{config:te,allowedSchemes:ue}=p(Q);i.addHook("uponSanitizeAttribute",(de,Ae)=>{if(Ae.attrName==="style"||Ae.attrName==="class"){if(de.tagName==="SPAN"){if(Ae.attrName==="style"){Ae.keepAttr=/^(color\:#[0-9a-fA-F]+;)?(background-color\:#[0-9a-fA-F]+;)?$/.test(Ae.attrValue);return}else if(Ae.attrName==="class"){Ae.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(Ae.attrValue);return}}Ae.keepAttr=!1;return}});const ae=v.hookDomPurifyHrefAndSrcSanitizer(ue);try{return i.sanitize(ie,{...te,RETURN_TRUSTED_TYPE:!0})}finally{i.removeHook("uponSanitizeAttribute"),ae.dispose()}}t.allowedMarkdownAttr=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width"];function p(Q){const ie=[h.Schemas.http,h.Schemas.https,h.Schemas.mailto,h.Schemas.data,h.Schemas.file,h.Schemas.vscodeFileResource,h.Schemas.vscodeRemote,h.Schemas.vscodeRemoteResource];return Q.isTrusted&&ie.push(h.Schemas.command),{config:{ALLOWED_TAGS:[...v.basicMarkupHtmlTags],ALLOWED_ATTR:t.allowedMarkdownAttr,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:ie}}function y(Q){return typeof Q=="string"?Q:_(Q)}t.renderStringAsPlaintext=y;function _(Q){let ie=Q.value??"";ie.length>1e5&&(ie=`${ie.substr(0,1e5)}\u2026`);const te=a.marked.parse(ie,{renderer:ge.getValue()}).replace(/&(#\d+|[a-zA-Z]+);/g,ue=>V.get(ue)??ue);return C({isTrusted:!1},te).toString()}t.renderMarkdownAsPlaintext=_;const V=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),ge=new e.Lazy(()=>{const Q=new a.marked.Renderer;return Q.code=ie=>ie,Q.blockquote=ie=>ie,Q.html=ie=>"",Q.heading=(ie,te,ue)=>ie+`
`,Q.hr=()=>"",Q.list=(ie,te)=>ie,Q.listitem=ie=>ie+`
`,Q.paragraph=ie=>ie+`
`,Q.table=(ie,te)=>ie+te+`
`,Q.tablerow=ie=>ie,Q.tablecell=(ie,te)=>ie+" ",Q.strong=ie=>ie,Q.em=ie=>ie,Q.codespan=ie=>ie,Q.br=()=>`
`,Q.del=ie=>ie,Q.image=(ie,te,ue)=>"",Q.text=ie=>ie,Q.link=(ie,te,ue)=>ue,Q})}),define(me[123],be([1,0,4,8,26,60,33,2,6,99]),function(Z,t,v,i,z,H,D,w,d,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setupCustomHover=t.setupNativeHover=void 0;function g(n,e){(0,d.isString)(e)?n.title=(0,D.stripIcons)(e):e?.markdownNotSupportedFallback?n.title=e.markdownNotSupportedFallback:n.removeAttribute("title")}t.setupNativeHover=g;class I{constructor(e,s,a){this.c=e,this.d=s,this.f=a}async update(e,s,a){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let l;if(e===void 0||(0,d.isString)(e)||e instanceof HTMLElement)l=e;else if(!(0,d.isFunction)(e.markdown))l=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,m.localize)(0,null),s),this.b=new z.CancellationTokenSource;const h=this.b.token;if(l=await e.markdown(h),l===void 0&&(l=e.markdownNotSupportedFallback),this.isDisposed||h.isCancellationRequested)return}this.g(l,s,a)}g(e,s,a){const l=this.a;if(this.h(e)){const h={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!l,...a};this.a=this.c.showHover(h,s)}l?.dispose()}h(e){return e?(0,H.isMarkdownString)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function o(n,e,s,a){let l,h;const r=(L,T)=>{L&&(h?.dispose(),h=void 0),T&&(l?.dispose(),l=void 0),n.onDidHideHover?.()},c=(L,T,f)=>new i.TimeoutTimer(async()=>{(!h||h.isDisposed)&&(h=new I(n,f||e,L>0),await h.update(s,T,a))},L),b=()=>{if(l)return;const L=new w.DisposableStore,T=p=>r(!1,p.fromElement===e);L.add(v.addDisposableListener(e,v.EventType.MOUSE_LEAVE,T,!0));const f=()=>r(!0,!0);L.add(v.addDisposableListener(e,v.EventType.MOUSE_DOWN,f,!0));const C={targetElements:[e],dispose:()=>{}};if(n.placement===void 0||n.placement==="mouse"){const p=y=>{C.x=y.x+10,y.target instanceof HTMLElement&&y.target.classList.contains("action-label")&&r(!0,!0)};L.add(v.addDisposableListener(e,v.EventType.MOUSE_MOVE,p,!0))}L.add(c(n.delay,!1,C)),l=L},S=v.addDisposableListener(e,v.EventType.MOUSE_OVER,b,!0);return{show:L=>{r(!1,!0),c(0,L)},hide:()=>{r(!0,!0)},update:async(L,T)=>{s=L,await h?.update(s,void 0,T)},dispose:()=>{S.dispose(),r(!0,!0)}}}t.setupCustomHover=o}),define(me[124],be([1,0,4,19,17,122,59,14,3,43,2,5,101,92]),function(Z,t,v,i,z,H,D,w,d,m,g,I,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const n=v.$,e="selectOption.entry.template";class s{get templateId(){return e}renderTemplate(h){const r=Object.create(null);return r.root=h,r.text=v.append(h,n(".option-text")),r.detail=v.append(h,n(".option-detail")),r.decoratorRight=v.append(h,n(".option-decorator-right")),r}renderElement(h,r,c){const b=c,S=h.text,N=h.detail,L=h.decoratorRight,T=h.isDisabled;b.text.textContent=S,b.detail.textContent=N||"",b.decoratorRight.innerText=L||"",T?b.root.classList.add("option-disabled"):b.root.classList.remove("option-disabled")}disposeTemplate(h){}}class a extends g.Disposable{constructor(h,r,c,b,S){super(),this.k=[],this.y=0,this.C=!1,this.F=!1,this.G=!1,this.f=!1,this.g=S||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=a.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.m=new d.Emitter,this.B(this.m),this.n=b,this.I(),this.H(c),this.l=r||0,h&&this.setOptions(h,r)}getHeight(){return 18}getTemplateId(){return e}H(h){this.r=h,this.s=v.$(".monaco-select-box-dropdown-container"),this.s.classList.add("monaco-select-box-dropdown-padding"),this.D=v.append(this.s,n(".select-box-details-pane"));const r=v.append(this.s,n(".select-box-dropdown-container-width-control")),c=v.append(r,n(".width-control-div"));this.w=document.createElement("span"),this.w.className="option-text-width-control",v.append(c,this.w),this.z=0,this.t=v.createStyleSheet(this.s),this.s.setAttribute("draggable","true"),this.B(v.addDisposableListener(this.s,v.EventType.DRAG_START,b=>{v.EventHelper.stop(b,!0)}))}I(){this.B(v.addStandardDisposableListener(this.h,"change",r=>{this.l=r.target.selectedIndex,this.m.fire({index:r.target.selectedIndex,selected:r.target.value}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)})),this.B(v.addDisposableListener(this.h,v.EventType.CLICK,r=>{v.EventHelper.stop(r),this.f?this.O(!0):this.N()})),this.B(v.addDisposableListener(this.h,v.EventType.MOUSE_DOWN,r=>{v.EventHelper.stop(r)}));let h;this.B(v.addDisposableListener(this.h,"touchstart",r=>{h=this.f})),this.B(v.addDisposableListener(this.h,"touchend",r=>{v.EventHelper.stop(r),h?this.O(!0):this.N()})),this.B(v.addDisposableListener(this.h,v.EventType.KEY_DOWN,r=>{const c=new z.StandardKeyboardEvent(r);let b=!1;I.isMacintosh?(c.keyCode===18||c.keyCode===16||c.keyCode===10||c.keyCode===3)&&(b=!0):(c.keyCode===18&&c.altKey||c.keyCode===16&&c.altKey||c.keyCode===10||c.keyCode===3)&&(b=!0),b&&(this.N(),v.EventHelper.stop(r,!0))}))}get onDidSelect(){return this.m.event}setOptions(h,r){w.equals(this.k,h)||(this.k=h,this.h.options.length=0,this.C=!1,this.k.forEach((c,b)=>{this.h.add(this.M(c.text,b,c.isDisabled)),typeof c.description=="string"&&(this.C=!0)})),r!==void 0&&(this.select(r),this.y=this.l)}J(){this.u?.splice(0,this.u.length,this.k)}select(h){h>=0&&h<this.k.length?this.l=h:h>this.k.length-1?this.select(this.k.length-1):this.l<0&&(this.l=0),this.h.selectedIndex=this.l,!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)}setAriaLabel(h){this.g.ariaLabel=h,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(h){this.h.tabIndex=h?0:-1}render(h){this.j=h,h.classList.add("select-container"),h.appendChild(this.h),this.applyStyles()}style(h){const r=[];this.n=h,this.n.listFocusBackground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.n.listFocusBackground} !important; }`),this.n.listFocusForeground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.n.listFocusForeground} !important; }`),this.n.decoratorRightForeground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.n.decoratorRightForeground}; }`),this.n.selectBackground&&this.n.selectBorder&&!this.n.selectBorder.equals(this.n.selectBackground)?(r.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.n.selectBorder} } `),r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.n.selectBorder} } `),r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.n.selectBorder} } `)):this.n.selectListBorder&&(r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.n.selectListBorder} } `),r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.n.selectListBorder} } `)),this.n.listHoverForeground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.n.listHoverForeground} !important; }`),this.n.listHoverBackground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.n.listHoverBackground} !important; }`),this.n.listFocusOutline&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.n.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.n.listHoverOutline&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.n.listHoverOutline} !important; outline-offset: -1.6px !important; }`),r.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),r.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.t.textContent=r.join(`
`),this.applyStyles()}applyStyles(){if(this.h){const h=this.n.selectBackground?this.n.selectBackground.toString():"",r=this.n.selectForeground?this.n.selectForeground.toString():"",c=this.n.selectBorder?this.n.selectBorder.toString():"";this.h.style.backgroundColor=h,this.h.style.color=r,this.h.style.borderColor=c}this.u&&this.L()}L(){if(this.u){const h=this.n.selectBackground?this.n.selectBackground.toString():"";this.u.style({});const r=this.n.selectListBackground?this.n.selectListBackground.toString():h;this.v.style.backgroundColor=r,this.D.style.backgroundColor=r;const c=this.n.focusBorder?this.n.focusBorder.toString():"";this.s.style.outlineColor=c,this.s.style.outlineOffset="-1px"}}M(h,r,c){const b=document.createElement("option");return b.value=h,b.text=h,b.disabled=!!c,b}N(){this.D.innerText="",!(!this.r||this.f)&&(this.U(this.s),this.J(),this.r.showContextView({getAnchor:()=>this.h,render:h=>this.P(h,!0),layout:()=>{this.R()},onHide:()=>{this.s.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.z},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.O(!1),this.r.showContextView({getAnchor:()=>this.h,render:h=>this.P(h),layout:()=>this.R(),onHide:()=>{this.s.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.z},this.g.optionsAsChildren?this.j:void 0),this.y=this.l,this.f=!0,this.h.setAttribute("aria-expanded","true"))}O(h){!this.r||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),h&&this.h.focus(),this.r.hideContextView())}P(h,r){return h.appendChild(this.s),this.R(r),{dispose:()=>{try{h.removeChild(this.s)}catch{}}}}Q(){let h=0;return this.k.forEach((r,c)=>{this.ab(c),this.D.offsetHeight>h&&(h=this.D.offsetHeight)}),h}R(h){if(this.F)return!1;if(this.u){this.s.classList.add("visible");const r=v.getDomNodePagePosition(this.h),c=getComputedStyle(this.h),b=parseFloat(c.getPropertyValue("--dropdown-padding-top"))+parseFloat(c.getPropertyValue("--dropdown-padding-bottom")),S=window.innerHeight-r.top-r.height-(this.g.minBottomMargin||0),N=r.top-a.b,L=this.h.offsetWidth,T=this.S(this.w),f=Math.max(T,Math.round(L)).toString()+"px";this.s.style.width=f,this.u.getHTMLElement().style.height="",this.u.layout();let C=this.u.contentHeight;const p=this.C?this.Q():0,y=C+b+p,_=Math.floor((S-b-p)/this.getHeight()),V=Math.floor((N-b-p)/this.getHeight());if(h)return r.top+r.height>window.innerHeight-22||r.top<a.b||_<1&&V<1?!1:(_<a.c&&V>_&&this.k.length>_?(this.z=1,this.s.removeChild(this.v),this.s.removeChild(this.D),this.s.appendChild(this.D),this.s.appendChild(this.v),this.D.classList.remove("border-top"),this.D.classList.add("border-bottom")):(this.z=0,this.s.removeChild(this.v),this.s.removeChild(this.D),this.s.appendChild(this.v),this.s.appendChild(this.D),this.D.classList.remove("border-bottom"),this.D.classList.add("border-top")),!0);if(r.top+r.height>window.innerHeight-22||r.top<a.b||this.z===0&&_<1||this.z===1&&V<1)return this.O(!0),!1;if(this.z===0){if(this.f&&_+V<1)return this.O(!0),!1;y>S&&(C=_*this.getHeight())}else y>N&&(C=V*this.getHeight());return this.u.layout(C),this.u.domFocus(),this.u.length>0&&(this.u.setFocus([this.l||0]),this.u.reveal(this.u.getFocus()[0]||0)),this.C?(this.u.getHTMLElement().style.height=C+b+"px",this.s.style.height=""):this.s.style.height=C+b+"px",this.ab(this.l),this.s.style.width=f,this.v.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.s.classList.add("synthetic-focus"),!0}else return!1}S(h){let r=0;if(h){let c=0,b=0;this.k.forEach((S,N)=>{const L=S.detail?S.detail.length:0,T=S.decoratorRight?S.decoratorRight.length:0,f=S.text.length+L+T;f>b&&(c=N,b=f)}),h.textContent=this.k[c].text+(this.k[c].decoratorRight?this.k[c].decoratorRight+" ":""),r=v.getTotalWidth(h)}return r}U(h){if(this.u)return;this.v=v.append(h,n(".select-box-dropdown-list-container")),this.p=new s,this.u=new D.List("SelectBoxCustom",this.v,this,[this.p],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:b=>{let S=b.text;return b.detail&&(S+=`. ${b.detail}`),b.decoratorRight&&(S+=`. ${b.decoratorRight}`),b.description&&(S+=`. ${b.description}`),S},getWidgetAriaLabel:()=>(0,o.localize)(0,null),getRole:()=>"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.u.ariaLabel=this.g.ariaLabel);const r=this.B(new i.DomEmitter(this.v,"keydown")),c=d.Event.chain(r.event).filter(()=>this.u.length>0).map(b=>new z.StandardKeyboardEvent(b));this.B(c.filter(b=>b.keyCode===3).on(b=>this.cb(b),this)),this.B(c.filter(b=>b.keyCode===2).on(b=>this.cb(b),this)),this.B(c.filter(b=>b.keyCode===9).on(b=>this.bb(b),this)),this.B(c.filter(b=>b.keyCode===16).on(b=>this.eb(b),this)),this.B(c.filter(b=>b.keyCode===18).on(b=>this.db(b),this)),this.B(c.filter(b=>b.keyCode===12).on(this.gb,this)),this.B(c.filter(b=>b.keyCode===11).on(this.fb,this)),this.B(c.filter(b=>b.keyCode===14).on(this.hb,this)),this.B(c.filter(b=>b.keyCode===13).on(this.ib,this)),this.B(c.filter(b=>b.keyCode>=21&&b.keyCode<=56||b.keyCode>=80&&b.keyCode<=108).on(this.jb,this)),this.B(v.addDisposableListener(this.u.getHTMLElement(),v.EventType.POINTER_UP,b=>this.W(b))),this.B(this.u.onMouseOver(b=>typeof b.index<"u"&&this.u.setFocus([b.index]))),this.B(this.u.onDidChangeFocus(b=>this.Z(b))),this.B(v.addDisposableListener(this.s,v.EventType.FOCUS_OUT,b=>{!this.f||v.isAncestor(b.relatedTarget,this.s)||this.X()})),this.u.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.u.getHTMLElement().setAttribute("aria-expanded","true"),this.L()}W(h){if(!this.u.length)return;v.EventHelper.stop(h);const r=h.target;if(!r||r.classList.contains("slider"))return;const c=r.closest(".monaco-list-row");if(!c)return;const b=Number(c.getAttribute("data-index")),S=c.classList.contains("option-disabled");b>=0&&b<this.k.length&&!S&&(this.l=b,this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0]),this.l!==this.y&&(this.y=this.l,this.m.fire({index:this.h.selectedIndex,selected:this.k[this.l].text}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)),this.O(!0))}X(){this.G||(this.l!==this.y&&this.select(this.y),this.O(!1))}Y(h,r){const c=S=>{for(let N=0;N<S.childNodes.length;N++){const L=S.childNodes.item(N);(L.tagName&&L.tagName.toLowerCase())==="img"?S.removeChild(L):c(L)}},b=(0,H.renderMarkdown)({value:h,supportThemeIcons:!0},{actionHandler:r});return b.element.classList.add("select-box-description-markdown"),c(b.element),b.element}Z(h){!this.f||!this.C||this.ab(h.indexes[0])}ab(h){this.D.innerText="";const r=this.k[h],c=r?.description??"",b=r?.descriptionIsMarkdown??!1;if(c){if(b){const S=r.descriptionMarkdownActionHandler;this.D.appendChild(this.Y(c,S))}else this.D.innerText=c;this.D.style.display="block"}else this.D.style.display="none";this.F=!0,this.r.layout(),this.F=!1}bb(h){v.EventHelper.stop(h),this.select(this.y),this.O(!0)}cb(h){v.EventHelper.stop(h),this.l!==this.y&&(this.y=this.l,this.m.fire({index:this.h.selectedIndex,selected:this.k[this.l].text}),!!this.k[this.l]&&!!this.k[this.l].text&&(this.h.title=this.k[this.l].text)),this.O(!0)}db(h){if(this.l<this.k.length-1){v.EventHelper.stop(h,!0);const r=this.k[this.l+1].isDisabled;if(r&&this.k.length>this.l+2)this.l+=2;else{if(r)return;this.l++}this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0])}}eb(h){this.l>0&&(v.EventHelper.stop(h,!0),this.k[this.l-1].isDisabled&&this.l>1?this.l-=2:this.l--,this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0]))}fb(h){v.EventHelper.stop(h),this.u.focusPreviousPage(),setTimeout(()=>{this.l=this.u.getFocus()[0],this.k[this.l].isDisabled&&this.l<this.k.length-1&&(this.l++,this.u.setFocus([this.l])),this.u.reveal(this.l),this.select(this.l)},1)}gb(h){v.EventHelper.stop(h),this.u.focusNextPage(),setTimeout(()=>{this.l=this.u.getFocus()[0],this.k[this.l].isDisabled&&this.l>0&&(this.l--,this.u.setFocus([this.l])),this.u.reveal(this.l),this.select(this.l)},1)}hb(h){v.EventHelper.stop(h),!(this.k.length<2)&&(this.l=0,this.k[this.l].isDisabled&&this.l>1&&this.l++,this.u.setFocus([this.l]),this.u.reveal(this.l),this.select(this.l))}ib(h){v.EventHelper.stop(h),!(this.k.length<2)&&(this.l=this.k.length-1,this.k[this.l].isDisabled&&this.l>1&&this.l--,this.u.setFocus([this.l]),this.u.reveal(this.l),this.select(this.l))}jb(h){const r=m.KeyCodeUtils.toString(h.keyCode);let c=-1;for(let b=0;b<this.k.length-1;b++)if(c=(b+this.l+1)%this.k.length,this.k[c].text.charAt(0).toUpperCase()===r&&!this.k[c].isDisabled){this.select(c),this.u.setFocus([c]),this.u.reveal(this.u.getFocus()[0]),v.EventHelper.stop(h);break}}dispose(){this.O(!1),super.dispose()}}t.SelectBoxList=a,a.a=32,a.b=2,a.c=3}),define(me[125],be([1,0,124,118,18,41,30,5,91]),function(Z,t,v,i,z,H,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.defaultStyles=void 0,t.defaultStyles={selectBackground:H.Color.fromHex("#3C3C3C"),selectForeground:H.Color.fromHex("#F0F0F0"),selectBorder:H.Color.fromHex("#3C3C3C")};class d extends z.Widget{constructor(g,I,o,n=(0,D.deepClone)(t.defaultStyles),e){super(),w.isMacintosh&&!e?.useCustomDrawn?this.a=new i.SelectBoxNative(g,I,n,e):this.a=new v.SelectBoxList(g,I,o,n,e),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(g,I){this.a.setOptions(g,I)}select(g){this.a.select(g)}setAriaLabel(g){this.a.setAriaLabel(g)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(g){this.a.setFocusable(g)}render(g){this.a.render(g)}style(g){this.a.style(g)}applyStyles(){this.a.applyStyles()}}t.SelectBox=d}),define(me[61],be([1,0,16,51,4,22,123,125,31,2,5,6,96,48]),function(Z,t,v,i,z,H,D,w,d,m,g,I,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class n extends m.Disposable{get action(){return this._action}constructor(l,h,r={}){super(),this.k=r,this._context=l||this,this._action=h,h instanceof d.Action&&this.B(h.onDidChange(c=>{!this.element||this.m(c)}))}m(l){l.enabled!==void 0&&this.t(),l.checked!==void 0&&this.updateChecked(),l.class!==void 0&&this.updateClass(),l.label!==void 0&&(this.updateLabel(),this.w()),l.tooltip!==void 0&&this.w()}get actionRunner(){return this.j||(this.j=this.B(new d.ActionRunner)),this.j}set actionRunner(l){this.j=l}isEnabled(){return this._action.enabled}setActionContext(l){this._context=l}render(l){const h=this.element=l;this.B(H.Gesture.addTarget(l));const r=this.k&&this.k.draggable;r&&(l.draggable=!0,v.isFirefox&&this.B((0,z.addDisposableListener)(l,z.EventType.DRAG_START,c=>c.dataTransfer?.setData(i.DataTransfers.TEXT,this._action.label)))),this.B((0,z.addDisposableListener)(h,H.EventType.Tap,c=>this.onClick(c,!0))),this.B((0,z.addDisposableListener)(h,z.EventType.MOUSE_DOWN,c=>{r||z.EventHelper.stop(c,!0),this._action.enabled&&c.button===0&&h.classList.add("active")})),g.isMacintosh&&this.B((0,z.addDisposableListener)(h,z.EventType.CONTEXT_MENU,c=>{c.button===0&&c.ctrlKey===!0&&this.onClick(c)})),this.B((0,z.addDisposableListener)(h,z.EventType.CLICK,c=>{z.EventHelper.stop(c,!0),this.k&&this.k.isMenu||this.onClick(c)})),this.B((0,z.addDisposableListener)(h,z.EventType.DBLCLICK,c=>{z.EventHelper.stop(c,!0)})),[z.EventType.MOUSE_UP,z.EventType.MOUSE_OUT].forEach(c=>{this.B((0,z.addDisposableListener)(h,c,b=>{z.EventHelper.stop(b),h.classList.remove("active")}))})}onClick(l,h=!1){z.EventHelper.stop(l,!0);const r=I.isUndefinedOrNull(this._context)?this.k?.useEventAsContext?l:{preserveFocus:h}:this._context;this.actionRunner.run(this._action,r)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(l){this.element&&(this.element.tabIndex=l?0:-1)}get trapsArrowNavigation(){return!1}t(){}updateLabel(){}u(){return this.action.tooltip}w(){if(!this.element)return;const l=this.u()??"";this.z(),this.k.hoverDelegate?(this.element.title="",this.f?this.f.update(l):(this.f=(0,D.setupCustomHover)(this.k.hoverDelegate,this.element,l),this.q.add(this.f))):this.element.title=l}z(){if(this.element){const l=this.u()??"";this.element.setAttribute("aria-label",l)}}updateClass(){}updateChecked(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.BaseActionViewItem=n;class e extends n{constructor(l,h,r){super(l,h,r),this.k=r,this.k.icon=r.icon!==void 0?r.icon:!1,this.k.label=r.label!==void 0?r.label:!0,this.C=""}render(l){super.render(l),this.element&&(this.g=(0,z.append)(this.element,(0,z.$)("a.action-label"))),this.g&&(this._action.id===d.Separator.ID?this.g.setAttribute("role","presentation"):this.k.isMenu?this.g.setAttribute("role","menuitem"):this.g.setAttribute("role","button")),this.k.label&&this.k.keybinding&&this.element&&((0,z.append)(this.element,(0,z.$)("span.keybinding")).textContent=this.k.keybinding),this.updateClass(),this.updateLabel(),this.w(),this.t(),this.updateChecked()}focus(){this.g&&(this.g.tabIndex=0,this.g.focus())}isFocused(){return!!this.g&&this.g?.tabIndex===0}blur(){this.g&&(this.g.tabIndex=-1)}setFocusable(l){this.g&&(this.g.tabIndex=l?0:-1)}updateLabel(){this.k.label&&this.g&&(this.g.textContent=this.action.label)}u(){let l=null;return this.action.tooltip?l=this.action.tooltip:!this.k.label&&this.action.label&&this.k.icon&&(l=this.action.label,this.k.keybinding&&(l=o.localize(0,null,l,this.k.keybinding))),l??void 0}updateClass(){this.C&&this.g&&this.g.classList.remove(...this.C.split(" ")),this.k.icon?(this.C=this.action.class,this.g&&(this.g.classList.add("codicon"),this.C&&this.g.classList.add(...this.C.split(" "))),this.t()):this.g?.classList.remove("codicon")}t(){this.action.enabled?(this.g&&(this.g.removeAttribute("aria-disabled"),this.g.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.g&&(this.g.setAttribute("aria-disabled","true"),this.g.classList.add("disabled")),this.element?.classList.add("disabled"))}z(){if(this.g){const l=this.u()??"";this.g.setAttribute("aria-label",l)}}updateChecked(){this.g&&(this.action.checked?this.g.classList.add("checked"):this.g.classList.remove("checked"))}}t.ActionViewItem=e;class s extends n{constructor(l,h,r,c,b,S){super(l,h),this.b=new w.SelectBox(r,c,b,void 0,S),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(l,h){this.b.setOptions(l,h)}select(l){this.b.select(l)}g(){this.B(this.b.onDidSelect(l=>this.n(l.selected,l.index)))}n(l,h){this.actionRunner.run(this._action,this.r(l,h))}r(l,h){return l}setFocusable(l){this.b.setFocusable(l)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(l){this.b.render(l)}}t.SelectActionViewItem=s}),define(me[62],be([1,0,4,17,61,31,3,2,6,48]),function(Z,t,v,i,z,H,D,w,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prepareActions=t.ActionBar=t.ActionsOrientation=void 0;var m;(function(o){o[o.HORIZONTAL=0]="HORIZONTAL",o[o.VERTICAL=1]="VERTICAL"})(m=t.ActionsOrientation||(t.ActionsOrientation={}));class g extends w.Disposable{constructor(n,e={}){super(),this.f=this.B(new w.DisposableStore),this.m=this.B(new w.DisposableMap),this.s=!1,this.t=!0,this.v=this.B(new D.Emitter),this.onDidBlur=this.v.event,this.w=this.B(new D.Emitter({onWillAddFirstListener:()=>this.y=!0})),this.onDidCancel=this.w.event,this.y=!1,this.z=this.B(new D.Emitter),this.onDidRun=this.z.event,this.C=this.B(new D.Emitter),this.onWillRun=this.C.event,this.b=e,this.g=e.context??null,this.j=this.b.orientation??0,this.l={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.c=this.b.actionRunner:(this.c=new H.ActionRunner,this.f.add(this.c)),this.f.add(this.c.onDidRun(l=>this.z.fire(l))),this.f.add(this.c.onWillRun(l=>this.C.fire(l))),this.viewItems=[],this.p=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let s,a;switch(this.j){case 0:s=[15],a=[17];break;case 1:s=[16],a=[18],this.domNode.className+=" vertical";break}this.B(v.addDisposableListener(this.domNode,v.EventType.KEY_DOWN,l=>{const h=new i.StandardKeyboardEvent(l);let r=!0;const c=typeof this.p=="number"?this.viewItems[this.p]:void 0;s&&(h.equals(s[0])||h.equals(s[1]))?r=this.L():a&&(h.equals(a[0])||h.equals(a[1]))?r=this.J():h.equals(9)&&this.y?this.w.fire():h.equals(14)?r=this.H():h.equals(13)?r=this.I():h.equals(2)&&c instanceof z.BaseActionViewItem&&c.trapsArrowNavigation?r=this.J():this.F(h)?this.l.keyDown?this.N(h):this.s=!0:r=!1,r&&(h.preventDefault(),h.stopPropagation())})),this.B(v.addDisposableListener(this.domNode,v.EventType.KEY_UP,l=>{const h=new i.StandardKeyboardEvent(l);this.F(h)?(!this.l.keyDown&&this.s&&(this.s=!1,this.N(h)),h.preventDefault(),h.stopPropagation()):(h.equals(2)||h.equals(1026))&&this.G()})),this.r=this.B(v.trackFocus(this.domNode)),this.B(this.r.onDidBlur(()=>{(v.getActiveElement()===this.domNode||!v.isAncestor(v.getActiveElement(),this.domNode))&&(this.v.fire(),this.p=void 0,this.n=void 0,this.s=!1)})),this.B(this.r.onDidFocus(()=>this.G())),this.u=document.createElement("ul"),this.u.className="actions-container",this.u.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.u.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.u),n.appendChild(this.domNode)}D(){this.length()>=2?this.u.setAttribute("role",this.b.ariaRole||"toolbar"):this.u.setAttribute("role","presentation")}setAriaLabel(n){n?this.u.setAttribute("aria-label",n):this.u.removeAttribute("aria-label")}setFocusable(n){if(this.t=n,this.t){const e=this.viewItems.find(s=>s instanceof z.BaseActionViewItem&&s.isEnabled());e instanceof z.BaseActionViewItem&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof z.BaseActionViewItem&&e.setFocusable(!1)})}F(n){let e=!1;return this.l.keys.forEach(s=>{e=e||n.equals(s)}),e}G(){for(let n=0;n<this.u.children.length;n++){const e=this.u.children[n];if(v.isAncestor(v.getActiveElement(),e)){this.p=n;break}}}get context(){return this.g}set context(n){this.g=n,this.viewItems.forEach(e=>e.setActionContext(n))}get actionRunner(){return this.c}set actionRunner(n){this.c=n,this.f.clear(),this.f.add(this.c.onDidRun(e=>this.z.fire(e))),this.f.add(this.c.onWillRun(e=>this.C.fire(e))),this.viewItems.forEach(e=>e.actionRunner=n)}getContainer(){return this.domNode}hasAction(n){return this.viewItems.findIndex(e=>e.action.id===n.id)!==-1}getAction(n){if(typeof n=="number")return this.viewItems[n]?.action;if(n instanceof HTMLElement){for(;n.parentElement!==this.u;){if(!n.parentElement)return;n=n.parentElement}for(let e=0;e<this.u.childNodes.length;e++)if(this.u.childNodes[e]===n)return this.viewItems[e].action}}push(n,e={}){const s=Array.isArray(n)?n:[n];let a=d.isNumber(e.index)?e.index:null;s.forEach(l=>{const h=document.createElement("li");h.className="action-item",h.setAttribute("role","presentation");let r;this.b.actionViewItemProvider&&(r=this.b.actionViewItemProvider(l)),r||(r=new z.ActionViewItem(this.context,l,{hoverDelegate:this.b.hoverDelegate,...e})),this.b.allowContextMenu||this.m.set(r,v.addDisposableListener(h,v.EventType.CONTEXT_MENU,c=>{v.EventHelper.stop(c,!0)})),r.actionRunner=this.c,r.setActionContext(this.context),r.render(h),this.t&&r instanceof z.BaseActionViewItem&&this.viewItems.length===0&&r.setFocusable(!0),a===null||a<0||a>=this.u.children.length?(this.u.appendChild(h),this.viewItems.push(r)):(this.u.insertBefore(h,this.u.children[a]),this.viewItems.splice(a,0,r),a++)}),typeof this.p=="number"&&this.focus(this.p),this.D()}getWidth(n){if(n>=0&&n<this.u.children.length){const e=this.u.children.item(n);if(e)return e.clientWidth}return 0}getHeight(n){if(n>=0&&n<this.u.children.length){const e=this.u.children.item(n);if(e)return e.clientHeight}return 0}pull(n){n>=0&&n<this.viewItems.length&&(this.u.removeChild(this.u.childNodes[n]),this.m.deleteAndDispose(this.viewItems[n]),(0,w.dispose)(this.viewItems.splice(n,1)),this.D())}clear(){this.isEmpty()||(this.viewItems=(0,w.dispose)(this.viewItems),this.m.clearAndDisposeAll(),v.clearNode(this.u),this.D())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(n){let e=!1,s;if(n===void 0?e=!0:typeof n=="number"?s=n:typeof n=="boolean"&&(e=n),e&&typeof this.p>"u"){const a=this.viewItems.findIndex(l=>l.isEnabled());this.p=a===-1?void 0:a,this.M(void 0,void 0,!0)}else s!==void 0&&(this.p=s),this.M(void 0,void 0,!0)}H(){return this.p=this.length()-1,this.J(!0)}I(){return this.p=0,this.L(!0)}J(n){if(typeof this.p>"u")this.p=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.p;let s;do{if(!n&&this.b.preventLoopNavigation&&this.p+1>=this.viewItems.length)return this.p=e,!1;this.p=(this.p+1)%this.viewItems.length,s=this.viewItems[this.p]}while(this.p!==e&&(this.b.focusOnlyEnabledItems&&!s.isEnabled()||s.action.id===H.Separator.ID));return this.M(),!0}L(n){if(typeof this.p>"u")this.p=0;else if(this.viewItems.length<=1)return!1;const e=this.p;let s;do{if(this.p=this.p-1,this.p<0){if(!n&&this.b.preventLoopNavigation)return this.p=e,!1;this.p=this.viewItems.length-1}s=this.viewItems[this.p]}while(this.p!==e&&(this.b.focusOnlyEnabledItems&&!s.isEnabled()||s.action.id===H.Separator.ID));return this.M(!0),!0}M(n,e,s=!1){typeof this.p>"u"&&this.u.focus({preventScroll:e}),this.n!==void 0&&this.n!==this.p&&this.viewItems[this.n]?.blur();const a=this.p!==void 0&&this.viewItems[this.p];if(a){let l=!0;d.isFunction(a.focus)||(l=!1),this.b.focusOnlyEnabledItems&&d.isFunction(a.isEnabled)&&!a.isEnabled()&&(l=!1),a.action.id===H.Separator.ID&&(l=!1),l?(s||this.n!==this.p)&&(a.focus(n),this.n=this.p):(this.u.focus({preventScroll:e}),this.n=void 0)}}N(n){if(typeof this.p>"u")return;const e=this.viewItems[this.p];if(e instanceof z.BaseActionViewItem){const s=e._context===null||e._context===void 0?n:e._context;this.run(e._action,s)}}async run(n,e){await this.c.run(n,e)}dispose(){this.g=void 0,this.viewItems=(0,w.dispose)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.ActionBar=g;function I(o){if(!o.length)return o;let n=-1;for(let s=0;s<o.length;s++)if(o[s].id!==H.Separator.ID){n=s;break}if(n===-1)return[];o=o.slice(n);for(let s=o.length-1;s>=0&&o[s].id===H.Separator.ID;s--)o.splice(s,1);let e=!1;for(let s=o.length-1;s>=0;s--){const a=o[s].id===H.Separator.ID;a&&!e?o.splice(s,1):a?a&&(e=!1):e=!0}return o}t.prepareActions=I}),define(me[63],be([1,0,4,19,52,62,54,57,18,3,78,100,88]),function(Z,t,v,i,z,H,D,w,d,m,g,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.unthemedInboxStyles=t.MessageType=void 0;const o=v.$;var n;(function(a){a[a.INFO=1]="INFO",a[a.WARNING=2]="WARNING",a[a.ERROR=3]="ERROR"})(n=t.MessageType||(t.MessageType={})),t.unthemedInboxStyles={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class e extends d.Widget{constructor(l,h,r){super(),this.s="idle",this.y=Number.POSITIVE_INFINITY,this.I=this.B(new m.Emitter),this.onDidChange=this.I.event,this.J=this.B(new m.Emitter),this.onDidHeightChange=this.J.event,this.a=h,this.g=r,this.h=null,this.i=this.g.placeholder||"",this.l=this.g.tooltip??(this.i||""),this.n=this.g.ariaLabel||"",this.g.validationOptions&&(this.r=this.g.validationOptions.validation),this.element=v.append(l,o(".monaco-inputbox.idle"));const c=this.g.flexibleHeight?"textarea":"input",b=v.append(this.element,o(".ibwrapper"));if(this.b=v.append(b,o(c+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.D(this.b,()=>this.element.classList.add("synthetic-focus")),this.C(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.y=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.t=v.append(b,o("div.mirror")),this.t.innerText="\xA0",this.H=new w.ScrollableElement(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.t.style.whiteSpace="pre",this.t.style.wordWrap="initial"),v.append(l,this.H.getDomNode()),this.B(this.H),this.B(this.H.onScroll(L=>this.b.scrollTop=L.scrollTop));const S=this.B(new i.DomEmitter(document,"selectionchange")),N=m.Event.filter(S.event,()=>document.getSelection()?.anchorNode===b);this.B(N(this.N,this)),this.B(this.onDidHeightChange(this.N,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.n&&this.b.setAttribute("aria-label",this.n),this.i&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.i),this.l&&this.setTooltip(this.l),this.z(this.b,()=>this.R()),this.C(this.b,()=>this.L()),this.D(this.b,()=>this.M()),this.B(this.G(this.b)),setTimeout(()=>this.S(),0),this.g.actions&&(this.c=this.B(new H.ActionBar(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.U()}L(){this.Q(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}M(){this.P(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.i||"")}setPlaceHolder(l){this.i=l,this.b.setAttribute("placeholder",l)}setTooltip(l){this.l=l,this.b.title=l}setAriaLabel(l){this.n=l,l?this.b.setAttribute("aria-label",this.n):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.n}get mirrorElement(){return this.t}get inputElement(){return this.b}get value(){return this.b.value}set value(l){this.b.value!==l&&(this.b.value=l,this.R())}get step(){return this.b.step}set step(l){this.b.step=l}get height(){return typeof this.v=="number"?this.v:v.getTotalHeight(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return document.activeElement===this.b}select(l=null){this.b.select(),l&&(this.b.setSelectionRange(l.start,l.end),l.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Q()}setEnabled(l){l?this.enable():this.disable()}get width(){return v.getTotalWidth(this.b)}set width(l){if(this.g.flexibleHeight&&this.g.flexibleWidth){let h=0;if(this.t){const r=parseFloat(this.t.style.paddingLeft||"")||0,c=parseFloat(this.t.style.paddingRight||"")||0;h=r+c}this.b.style.width=l-h+"px"}else this.b.style.width=l+"px";this.t&&(this.t.style.width=l+"px")}set paddingRight(l){this.b.style.width=`calc(100% - ${l}px)`,this.t&&(this.t.style.paddingRight=l+"px")}N(){if(typeof this.w!="number"||typeof this.v!="number"||!this.H)return;const l=this.w,h=this.v,r=this.b.scrollTop;this.H.setScrollDimensions({scrollHeight:l,height:h}),this.H.setScrollPosition({scrollTop:r})}showMessage(l,h){this.h=l,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.O(l.type));const r=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${v.asCssValueWithDefault(r.border,"transparent")}`,this.h.content&&(this.hasFocus()||h)&&this.P()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Q(),this.U()}isInputValid(){return!!this.r&&!this.r(this.value)}validate(){let l=null;return this.r&&(l=this.r(this.value),l?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(l)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),l?.type}stylesForType(l){const h=this.g.inputBoxStyles;switch(l){case 1:return{border:h.inputValidationInfoBorder,background:h.inputValidationInfoBackground,foreground:h.inputValidationInfoForeground};case 2:return{border:h.inputValidationWarningBorder,background:h.inputValidationWarningBackground,foreground:h.inputValidationWarningForeground};default:return{border:h.inputValidationErrorBorder,background:h.inputValidationErrorBackground,foreground:h.inputValidationErrorForeground}}}O(l){switch(l){case 1:return"info";case 2:return"warning";default:return"error"}}P(){if(!this.a||!this.h)return;let l;const h=()=>l.style.width=v.getTotalWidth(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:c=>{if(!this.h)return null;l=v.append(c,o(".monaco-inputbox-container")),h();const b={inline:!0,className:"monaco-inputbox-message"},S=this.h.formatContent?(0,z.renderFormattedText)(this.h.content,b):(0,z.renderText)(this.h.content,b);S.classList.add(this.O(this.h.type));const N=this.stylesForType(this.h.type);return S.style.backgroundColor=N.background?N.background.toString():"",S.style.color=N.foreground?N.foreground.toString():"",S.style.border=N.border?`1px solid ${N.border}`:"",v.append(l,S),null},onHide:()=>{this.s="closed"},layout:h});let r;this.h.type===3?r=I.localize(0,null,this.h.content):this.h.type===2?r=I.localize(1,null,this.h.content):r=I.localize(2,null,this.h.content),D.alert(r),this.s="open"}Q(){!this.a||(this.s==="open"&&this.a.hideContextView(),this.s="idle")}R(){this.I.fire(this.value),this.validate(),this.S(),this.b.classList.toggle("empty",!this.value),this.s==="open"&&this.a&&this.a.layout()}S(){if(!this.t)return;const l=this.value,r=l.charCodeAt(l.length-1)===10?" ":"";(l+r).replace(/\u000c/g,"")?this.t.textContent=l+r:this.t.innerText="\xA0",this.layout()}U(){const l=this.g.inputBoxStyles,h=l.inputBackground??"",r=l.inputForeground??"",c=l.inputBorder??"";this.element.style.backgroundColor=h,this.element.style.color=r,this.b.style.backgroundColor="inherit",this.b.style.color=r,this.element.style.border=`1px solid ${v.asCssValueWithDefault(c,"transparent")}`}layout(){if(!this.t)return;const l=this.w;this.w=v.getTotalHeight(this.t),l!==this.w&&(this.v=Math.min(this.w,this.y),this.b.style.height=this.v+"px",this.J.fire(this.w))}insertAtCursor(l){const h=this.inputElement,r=h.selectionStart,c=h.selectionEnd,b=h.value;r!==null&&c!==null&&(this.value=b.substr(0,r)+l+b.substr(c),h.setSelectionRange(r+1,r+1),this.layout())}dispose(){this.Q(),this.h=null,this.c?.dispose(),super.dispose()}}t.InputBox=e;class s extends e{constructor(l,h,r){const c=I.localize(3,null),b=` or \u21C5 ${c}`,S=` (\u21C5 ${c})`;super(l,h,r),this.Y=this.B(new m.Emitter),this.onDidFocus=this.Y.event,this.Z=this.B(new m.Emitter),this.onDidBlur=this.Z.event,this.W=new g.HistoryNavigator(r.history,100);const N=()=>{if(r.showHistoryHint&&r.showHistoryHint()&&!this.i.endsWith(b)&&!this.i.endsWith(S)&&this.W.getHistory().length){const L=this.i.endsWith(")")?b:S,T=this.i+L;r.showPlaceholderOnFocus&&document.activeElement!==this.b?this.i=T:this.setPlaceHolder(T)}};this.X=new MutationObserver((L,T)=>{L.forEach(f=>{f.target.textContent||N()})}),this.X.observe(this.b,{attributeFilter:["class"]}),this.D(this.b,()=>N()),this.C(this.b,()=>{const L=T=>{if(this.i.endsWith(T)){const f=this.i.slice(0,this.i.length-T.length);return r.showPlaceholderOnFocus?this.i=f:this.setPlaceHolder(f),!0}else return!1};L(S)||L(b)})}dispose(){super.dispose(),this.X&&(this.X.disconnect(),this.X=void 0)}addToHistory(){this.value&&this.value!==this.cb()&&this.W.add(this.value)}getHistory(){return this.W.getHistory()}showNextValue(){this.W.has(this.value)||this.addToHistory();let l=this.eb();l&&(l=l===this.value?this.eb():l),l&&(this.value=l,D.status(this.value))}showPreviousValue(){this.W.has(this.value)||this.addToHistory();let l=this.db();l&&(l=l===this.value?this.db():l),l&&(this.value=l,D.status(this.value))}clearHistory(){this.W.clear()}L(){super.L(),this.Z.fire()}M(){super.M(),this.Y.fire()}cb(){let l=this.W.current();return l||(l=this.W.last(),this.W.next()),l}db(){return this.W.previous()||this.W.first()}eb(){return this.W.next()||this.W.last()}}t.HistoryInputBox=s}),define(me[64],be([1,0,61,18,12,3,93]),function(Z,t,v,i,z,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Checkbox=t.Toggle=t.ToggleActionViewItem=t.unthemedToggleStyles=void 0,t.unthemedToggleStyles={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class D extends v.BaseActionViewItem{constructor(g,I,o){super(g,I,o),this.a=this.B(new w({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.k.keybinding?`${this._action.label} (${this.k.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:o.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:o.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:o.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(g){this.element=g,this.element.appendChild(this.a.domNode)}t(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}updateChecked(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(g){this.a.domNode.tabIndex=g?0:-1}}t.ToggleActionViewItem=D;class w extends i.Widget{constructor(g){super(),this.a=this.B(new H.Emitter),this.onChange=this.a.event,this.b=this.B(new H.Emitter),this.onKeyDown=this.b.event,this.c=g,this.s=this.c.isChecked;const I=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,I.push(...z.CSSIcon.asClassNameArray(this.g))),this.c.actionClassName&&I.push(...this.c.actionClassName.split(" ")),this.s&&I.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...I),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,o=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),o.preventDefault())}),this.B(this.G(this.domNode)),this.p(this.domNode,o=>{if(o.keyCode===10||o.keyCode===3){this.checked=!this.s,this.a.fire(!0),o.preventDefault(),o.stopPropagation();return}this.b.fire(o)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(g){this.s=g,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(g){this.g&&this.domNode.classList.remove(...z.CSSIcon.asClassNameArray(this.g)),this.g=g,this.g&&this.domNode.classList.add(...z.CSSIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(g){this.domNode.title=g,this.domNode.setAttribute("aria-label",g)}}t.Toggle=w;class d extends i.Widget{constructor(g,I,o){super(),this.c=g,this.g=I,this.a=new w({title:this.c,isChecked:this.g,icon:z.Codicon.check,actionClassName:"monaco-checkbox",...t.unthemedToggleStyles}),this.domNode=this.a.domNode,this.b=o,this.h()}get checked(){return this.a.checked}set checked(g){this.a.checked=g}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}h(){this.domNode.style.color=this.b.checkboxForeground||"",this.domNode.style.backgroundColor=this.b.checkboxBackground||"",this.domNode.style.borderColor=this.b.checkboxBorder||""}}t.Checkbox=d}),define(me[126],be([1,0,64,12,98]),function(Z,t,v,i,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const H=z.localize(0,null),D=z.localize(1,null),w=z.localize(2,null);class d extends v.Toggle{constructor(o){super({icon:i.Codicon.caseSensitive,title:H+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.CaseSensitiveToggle=d;class m extends v.Toggle{constructor(o){super({icon:i.Codicon.wholeWord,title:D+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.WholeWordsToggle=m;class g extends v.Toggle{constructor(o){super({icon:i.Codicon.regex,title:w+o.appendTitle,isChecked:o.isChecked,inputActiveOptionBorder:o.inputActiveOptionBorder,inputActiveOptionForeground:o.inputActiveOptionForeground,inputActiveOptionBackground:o.inputActiveOptionBackground})}}t.RegexToggle=g}),define(me[127],be([1,0,4,126,63,18,3,97,2,87]),function(Z,t,v,i,z,H,D,w,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const m=w.localize(0,null);class g extends H.Widget{constructor(o,n,e){super(),this.i=!0,this.l=!1,this.n=new d.DisposableStore,this.H=[],this.I=this.B(new D.Emitter),this.onDidOptionChange=this.I.event,this.J=this.B(new D.Emitter),this.onKeyDown=this.J.event,this.L=this.B(new D.Emitter),this.onMouseDown=this.L.event,this.M=this.B(new D.Emitter),this.onInput=this.M.event,this.N=this.B(new D.Emitter),this.onKeyUp=this.N.event,this.O=this.B(new D.Emitter),this.onCaseSensitiveKeyDown=this.O.event,this.P=this.B(new D.Emitter),this.onRegexKeyDown=this.P.event,this.Q=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||m,this.h=!!e.showCommonFindToggles;const s=e.appendCaseSensitiveLabel||"",a=e.appendWholeWordsLabel||"",l=e.appendRegexLabel||"",h=e.history||[],r=!!e.flexibleHeight,c=!!e.flexibleWidth,b=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new z.HistoryInputBox(this.domNode,n,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:h,showHistoryHint:e.showHistoryHint,flexibleHeight:r,flexibleWidth:c,flexibleMaxHeight:b,inputBoxStyles:e.inputBoxStyles})),this.h){this.v=this.B(new i.RegexToggle({appendTitle:l,isChecked:!1,...e.toggleStyles})),this.B(this.v.onChange(N=>{this.I.fire(N),!N&&this.i&&this.inputBox.focus(),this.validate()})),this.B(this.v.onKeyDown(N=>{this.P.fire(N)})),this.w=this.B(new i.WholeWordsToggle({appendTitle:a,isChecked:!1,...e.toggleStyles})),this.B(this.w.onChange(N=>{this.I.fire(N),!N&&this.i&&this.inputBox.focus(),this.validate()})),this.y=this.B(new i.CaseSensitiveToggle({appendTitle:s,isChecked:!1,...e.toggleStyles})),this.B(this.y.onChange(N=>{this.I.fire(N),!N&&this.i&&this.inputBox.focus(),this.validate()})),this.B(this.y.onKeyDown(N=>{this.O.fire(N)}));const S=[this.y.domNode,this.w.domNode,this.v.domNode];this.p(this.domNode,N=>{if(N.equals(15)||N.equals(17)||N.equals(9)){const L=S.indexOf(document.activeElement);if(L>=0){let T=-1;N.equals(17)?T=(L+1)%S.length:N.equals(15)&&(L===0?T=S.length-1:T=L-1),N.equals(9)?(S[L].blur(),this.inputBox.focus()):T>=0&&S[T].focus(),v.EventHelper.stop(N,!0)}}})}this.s=document.createElement("div"),this.s.className="controls",this.s.style.display=this.h?"block":"none",this.y&&this.s.append(this.y.domNode),this.w&&this.s.appendChild(this.w.domNode),this.v&&this.s.appendChild(this.v.domNode),this.setAdditionalToggles(e?.additionalToggles),this.s&&this.domNode.appendChild(this.s),o?.appendChild(this.domNode),this.B(v.addDisposableListener(this.inputBox.inputElement,"compositionstart",S=>{this.l=!0})),this.B(v.addDisposableListener(this.inputBox.inputElement,"compositionend",S=>{this.l=!1,this.M.fire()})),this.p(this.inputBox.inputElement,S=>this.J.fire(S)),this.u(this.inputBox.inputElement,S=>this.N.fire(S)),this.z(this.inputBox.inputElement,S=>this.M.fire()),this.j(this.inputBox.inputElement,S=>this.L.fire(S))}get isImeSessionInProgress(){return this.l}get onDidChange(){return this.inputBox.onDidChange}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.v?.enable(),this.w?.enable(),this.y?.enable();for(const o of this.H)o.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.v?.disable(),this.w?.disable(),this.y?.disable();for(const o of this.H)o.disable()}setFocusInputOnOptionClick(o){this.i=o}setEnabled(o){o?this.enable():this.disable()}setAdditionalToggles(o){for(const n of this.H)n.domNode.remove();this.H=[],this.n.dispose(),this.n=new d.DisposableStore;for(const n of o??[])this.n.add(n),this.s.appendChild(n.domNode),this.n.add(n.onChange(e=>{this.I.fire(e),!e&&this.i&&this.inputBox.focus()})),this.H.push(n);this.H.length>0&&(this.s.style.display="block"),this.inputBox.paddingRight=(this.y?.width()??0)+(this.w?.width()??0)+(this.v?.width()??0)+this.H.reduce((n,e)=>n+e.width(),0)}clear(){this.R(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(o){this.inputBox.value!==o&&(this.inputBox.value=o)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.y?.checked??!1}setCaseSensitive(o){this.y&&(this.y.checked=o)}getWholeWords(){return this.w?.checked??!1}setWholeWords(o){this.w&&(this.w.checked=o)}getRegex(){return this.v?.checked??!1}setRegex(o){this.v&&(this.v.checked=o,this.validate())}focusOnCaseSensitive(){this.y?.focus()}focusOnRegex(){this.v?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Q),this.Q=1-this.Q,this.domNode.classList.add("highlight-"+this.Q)}validate(){this.inputBox.validate()}showMessage(o){this.inputBox.showMessage(o)}clearMessage(){this.inputBox.hideMessage()}R(){this.inputBox.hideMessage()}}t.FindInput=g,g.OPTION_CHANGE="optionChange"}),define(me[128],be([1,0,4,19,17,62,127,63,58,59,64,55,23,31,14,8,12,70,3,32,2,46,6,102,94]),function(Z,t,v,i,z,H,D,w,d,m,g,I,o,n,e,s,a,l,h,r,c,b,S,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.TreeFindMode=t.ModeToggle=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class L extends d.ElementsDragAndDropData{set context(A){this.c.context=A}get context(){return this.c.context}constructor(A){super(A.elements.map(E=>E.element)),this.c=A}}function T(ee){return ee instanceof d.ElementsDragAndDropData?new L(ee):ee}class f{constructor(A,E){this.c=A,this.d=E,this.b=c.Disposable.None}getDragURI(A){return this.d.getDragURI(A.element)}getDragLabel(A,E){if(this.d.getDragLabel)return this.d.getDragLabel(A.map(u=>u.element),E)}onDragStart(A,E){this.d.onDragStart?.(T(A),E)}onDragOver(A,E,u,B,W=!0){const $=this.d.onDragOver(T(A),E&&E.element,u,B),Y=this.a!==E;if(Y&&(this.b.dispose(),this.a=E),typeof E>"u")return $;if(Y&&typeof $!="boolean"&&$.autoExpand&&(this.b=(0,s.disposableTimeout)(()=>{const M=this.c(),P=M.getNodeLocation(E);M.isCollapsed(P)&&M.setCollapsed(P,!1),this.a=void 0},500)),typeof $=="boolean"||!$.accept||typeof $.bubble>"u"||$.feedback){if(!W){const M=typeof $=="boolean"?$:$.accept,P=typeof $=="boolean"?void 0:$.effect;return{accept:M,effect:P,feedback:[u]}}return $}if($.bubble===1){const M=this.c(),P=M.getNodeLocation(E),R=M.getParentNodeLocation(P),j=M.getNode(R),J=R&&M.getListIndex(R);return this.onDragOver(A,j,J,B,!1)}const F=this.c(),O=F.getNodeLocation(E),U=F.getListIndex(O),k=F.getListRenderCount(O);return{...$,feedback:(0,e.range)(U,U+k)}}drop(A,E,u,B){this.b.dispose(),this.a=void 0,this.d.drop(T(A),E&&E.element,u,B)}onDragEnd(A){this.d.onDragEnd?.(A)}}function C(ee,A){return A&&{...A,identityProvider:A.identityProvider&&{getId(E){return A.identityProvider.getId(E.element)}},dnd:A.dnd&&new f(ee,A.dnd),multipleSelectionController:A.multipleSelectionController&&{isSelectionSingleChangeEvent(E){return A.multipleSelectionController.isSelectionSingleChangeEvent({...E,element:E.element})},isSelectionRangeChangeEvent(E){return A.multipleSelectionController.isSelectionRangeChangeEvent({...E,element:E.element})}},accessibilityProvider:A.accessibilityProvider&&{...A.accessibilityProvider,getSetSize(E){const u=ee(),B=u.getNodeLocation(E),W=u.getParentNodeLocation(B);return u.getNode(W).visibleChildrenCount},getPosInSet(E){return E.visibleChildIndex+1},isChecked:A.accessibilityProvider&&A.accessibilityProvider.isChecked?E=>A.accessibilityProvider.isChecked(E.element):void 0,getRole:A.accessibilityProvider&&A.accessibilityProvider.getRole?E=>A.accessibilityProvider.getRole(E.element):()=>"treeitem",getAriaLabel(E){return A.accessibilityProvider.getAriaLabel(E.element)},getWidgetAriaLabel(){return A.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:A.accessibilityProvider&&A.accessibilityProvider.getWidgetRole?()=>A.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:A.accessibilityProvider&&A.accessibilityProvider.getAriaLevel?E=>A.accessibilityProvider.getAriaLevel(E.element):E=>E.depth,getActiveDescendantId:A.accessibilityProvider.getActiveDescendantId&&(E=>A.accessibilityProvider.getActiveDescendantId(E.element))},keyboardNavigationLabelProvider:A.keyboardNavigationLabelProvider&&{...A.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(E){return A.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(E.element)}}}}class p{constructor(A){this.a=A}getHeight(A){return this.a.getHeight(A.element)}getTemplateId(A){return this.a.getTemplateId(A.element)}hasDynamicHeight(A){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(A.element)}setDynamicHeight(A,E){this.a.setDynamicHeight?.(A.element,E)}}t.ComposedTreeDelegate=p;class y{static lift(A){return A instanceof y?A:new y(A)}static empty(A=0){return new y({focus:[],selection:[],expanded:Object.create(null),scrollTop:A})}constructor(A){if(this.focus=new Set(A.focus),this.selection=new Set(A.selection),A.expanded instanceof Array){this.expanded=Object.create(null);for(const E of A.expanded)this.expanded[E]=1}else this.expanded=A.expanded;this.expanded=A.expanded,this.scrollTop=A.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=y;var _;(function(ee){ee.None="none",ee.OnHover="onHover",ee.Always="always"})(_=t.RenderIndentGuides||(t.RenderIndentGuides={}));class V{get elements(){return this.b}constructor(A,E=[]){this.b=E,this.a=new c.DisposableStore,this.onDidChange=h.Event.forEach(A,u=>this.b=u,this.a)}dispose(){this.a.dispose()}}class ge{constructor(A,E,u,B,W,$={}){this.o=A,this.p=E,this.q=B,this.s=W,this.b=new Map,this.c=new Map,this.d=ge.a,this.f=!1,this.g=!1,this.j=new Set,this.k=c.Disposable.None,this.m=new c.DisposableStore,this.templateId=A.templateId,this.updateOptions($),h.Event.map(u,Y=>Y.node)(this.u,this,this.m),A.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(A={}){if(typeof A.indent<"u"){const E=(0,b.clamp)(A.indent,0,40);if(E!==this.d){this.d=E;for(const[u,B]of this.c)this.v(u,B)}}if(typeof A.renderIndentGuides<"u"){const E=A.renderIndentGuides!==_.None;if(E!==this.g&&(this.g=E,this.k.dispose(),E)){const u=new c.DisposableStore;this.q.onDidChange(this.w,this,u),this.k=u,this.w(this.q.elements)}}typeof A.hideTwistiesOfChildlessElements<"u"&&(this.f=A.hideTwistiesOfChildlessElements)}renderTemplate(A){const E=(0,v.append)(A,(0,v.$)(".monaco-tl-row")),u=(0,v.append)(E,(0,v.$)(".monaco-tl-indent")),B=(0,v.append)(E,(0,v.$)(".monaco-tl-twistie")),W=(0,v.append)(E,(0,v.$)(".monaco-tl-contents")),$=this.o.renderTemplate(W);return{container:A,indent:u,twistie:B,indentGuidesDisposable:c.Disposable.None,templateData:$}}renderElement(A,E,u,B){this.c.set(A,u),this.b.set(A.element,A),this.v(A,u),this.o.renderElement(A,E,u.templateData,B)}disposeElement(A,E,u,B){u.indentGuidesDisposable.dispose(),this.o.disposeElement?.(A,E,u.templateData,B),typeof B=="number"&&(this.c.delete(A),this.b.delete(A.element))}disposeTemplate(A){this.o.disposeTemplate(A.templateData)}t(A){const E=this.b.get(A);!E||this.u(E)}u(A){const E=this.c.get(A);!E||(this.w(this.q.elements),this.v(A,E))}v(A,E){const u=ge.a+(A.depth-1)*this.d;E.twistie.style.paddingLeft=`${u}px`,E.indent.style.width=`${u+this.d-16}px`,A.collapsible?E.container.setAttribute("aria-expanded",String(!A.collapsed)):E.container.removeAttribute("aria-expanded"),E.twistie.classList.remove(...a.Codicon.treeItemExpanded.classNamesArray);let B=!1;if(this.o.renderTwistie&&(B=this.o.renderTwistie(A.element,E.twistie)),A.collapsible&&(!this.f||A.visibleChildrenCount>0)?(B||E.twistie.classList.add(...a.Codicon.treeItemExpanded.classNamesArray),E.twistie.classList.add("collapsible"),E.twistie.classList.toggle("collapsed",A.collapsed)):E.twistie.classList.remove("collapsible","collapsed"),(0,v.clearNode)(E.indent),E.indentGuidesDisposable.dispose(),!this.g)return;const W=new c.DisposableStore,$=this.p();for(;;){const Y=$.getNodeLocation(A),F=$.getParentNodeLocation(Y);if(!F)break;const O=$.getNode(F),U=(0,v.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(O)&&U.classList.add("active"),E.indent.childElementCount===0?E.indent.appendChild(U):E.indent.insertBefore(U,E.indent.firstElementChild),this.s.add(O,U),W.add((0,c.toDisposable)(()=>this.s.delete(O,U))),A=O}E.indentGuidesDisposable=W}w(A){if(!this.g)return;const E=new Set,u=this.p();A.forEach(B=>{const W=u.getNodeLocation(B);try{const $=u.getParentNodeLocation(W);B.collapsible&&B.children.length>0&&!B.collapsed?E.add(B):$&&E.add(u.getNode($))}catch{}}),this.j.forEach(B=>{E.has(B)||this.s.forEach(B,W=>W.classList.remove("active"))}),E.forEach(B=>{this.j.has(B)||this.s.forEach(B,W=>W.classList.add("active"))}),this.j=E}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,c.dispose)(this.m)}}ge.a=8;class Q{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(A){this.c=A,this.d=A.toLowerCase()}constructor(A,E,u){this.g=A,this.j=E,this.k=u,this.a=0,this.b=0,this.c="",this.d="",this.f=new c.DisposableStore,A.onWillRefilter(this.m,this,this.f)}filter(A,E){let u=1;if(this.k){const $=this.k.filter(A,E);if(typeof $=="boolean"?u=$?1:0:(0,I.isFilterResult)($)?u=(0,I.getVisibleState)($.visibility):u=$,u===0)return!1}if(this.a++,!this.c)return this.b++,{data:r.FuzzyScore.Default,visibility:u};const B=this.j.getKeyboardNavigationLabel(A),W=Array.isArray(B)?B:[B];for(const $ of W){const Y=$&&$.toString();if(typeof Y>"u")return{data:r.FuzzyScore.Default,visibility:u};const F=(0,r.fuzzyScore)(this.c,this.d,0,Y,Y.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(F)return this.b++,W.length===1?{data:F,visibility:u}:{data:{label:Y,score:F},visibility:u}}return this.g.findMode===ue.Filter?2:{data:r.FuzzyScore.Default,visibility:u}}m(){this.a=0,this.b=0}dispose(){(0,c.dispose)(this.f)}}class ie extends g.Toggle{constructor(A){super({icon:a.Codicon.listFilter,title:(0,N.localize)(0,null),isChecked:A.isChecked??!1,inputActiveOptionBorder:A.inputActiveOptionBorder,inputActiveOptionForeground:A.inputActiveOptionForeground,inputActiveOptionBackground:A.inputActiveOptionBackground})}}t.ModeToggle=ie;const te={inputBoxStyles:w.unthemedInboxStyles,toggleStyles:g.unthemedToggleStyles,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var ue;(function(ee){ee[ee.Highlight=0]="Highlight",ee[ee.Filter=1]="Filter"})(ue=t.TreeFindMode||(t.TreeFindMode={}));class ae extends c.Disposable{set mode(A){this.b.checked=A===ue.Filter,this.c.inputBox.setPlaceHolder(A===ue.Filter?(0,N.localize)(1,null):(0,N.localize)(2,null))}get value(){return this.c.inputBox.value}set value(A){this.c.inputBox.value=A}constructor(A,E,u,B,W){super(),this.m=E,this.a=(0,v.h)(".monaco-tree-type-filter",[(0,v.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,v.h)(".monaco-tree-type-filter-input@findInput"),(0,v.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.g=0,this.j=0,this.k=0,this._onDidDisable=new h.Emitter,this.onDidDisable=this._onDidDisable.event,A.appendChild(this.a.root),this.B((0,c.toDisposable)(()=>A.removeChild(this.a.root)));const $=W?.styles??te;$.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=$.listFilterWidgetBackground),$.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${$.listFilterWidgetShadow}`),this.b=this.B(new ie({...$.toggleStyles,isChecked:B===ue.Filter})),this.onDidChangeMode=h.Event.map(this.b.onChange,()=>this.b.checked?ue.Filter:ue.Highlight,this.q),this.c=this.B(new D.FindInput(this.a.findInput,u,{label:(0,N.localize)(3,null),additionalToggles:[this.b],showCommonFindToggles:!1,inputBoxStyles:$.inputBoxStyles,toggleStyles:$.toggleStyles})),this.f=this.B(new H.ActionBar(this.a.actionbar)),this.mode=B;const Y=this.B(new i.DomEmitter(this.c.inputBox.inputElement,"keydown")),F=this.B(h.Event.chain(Y.event)).map(M=>new z.StandardKeyboardEvent(M)).event;this.B(F(M=>{switch(M.keyCode){case 18:M.preventDefault(),M.stopPropagation(),this.m.domFocus();return}}));const O=this.B(new n.Action("close",(0,N.localize)(4,null),"codicon codicon-close",!0,()=>this.dispose()));this.f.push(O,{icon:!0,label:!1});const U=this.B(new i.DomEmitter(this.a.grab,"mousedown"));this.B(U.event(M=>{const P=new c.DisposableStore,R=P.add(new i.DomEmitter(window,"mousemove")),j=P.add(new i.DomEmitter(window,"mouseup")),J=this.j,he=M.pageX,ce=this.k,De=M.pageY;this.a.grab.classList.add("grabbing");const ye=this.a.root.style.transition;this.a.root.style.transition="unset";const Ie=Se=>{const we=Se.pageX-he;this.j=J-we;const Re=Se.pageY-De;this.k=ce+Re,this.layout()};P.add(R.event(Ie)),P.add(j.event(Se=>{Ie(Se),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=ye,P.dispose()}))}));const k=this.B(h.Event.chain(this.B(new i.DomEmitter(this.a.grab,"keydown")).event)).map(M=>new z.StandardKeyboardEvent(M)).event;this.B(k(M=>{let P,R;if(M.keyCode===15?P=Number.POSITIVE_INFINITY:M.keyCode===17?P=0:M.keyCode===10&&(P=this.j===0?Number.POSITIVE_INFINITY:0),M.keyCode===16?R=0:M.keyCode===18&&(R=Number.POSITIVE_INFINITY),P!==void 0&&(M.preventDefault(),M.stopPropagation(),this.j=P,this.layout()),R!==void 0){M.preventDefault(),M.stopPropagation(),this.k=R;const j=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=j},0)}})),this.onDidChangeValue=this.c.onDidChange}focus(){this.c.focus()}select(){this.c.select()}layout(A=this.g){this.g=A,this.j=(0,b.clamp)(this.j,0,Math.max(0,A-212)),this.a.root.style.right=`${this.j}px`,this.k=(0,b.clamp)(this.k,0,24),this.a.root.style.top=`${this.k}px`}showMessage(A){this.c.showMessage(A)}clearMessage(){this.c.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,s.timeout)(300),super.dispose()}}class de{get pattern(){return this.a}get mode(){return this.c}set mode(A){A!==this.c&&(this.c=A,this.d&&(this.d.mode=this.c),this.p.refilter(),this.x(),this.g.fire(A))}constructor(A,E,u,B,W,$={}){this.p=A,this.q=u,this.s=B,this.t=W,this.u=$,this.a="",this.b="",this.f=0,this.g=new h.Emitter,this.onDidChangeMode=this.g.event,this.j=new h.Emitter,this.onDidChangePattern=this.j.event,this.k=new h.Emitter,this.onDidChangeOpenState=this.k.event,this.m=new c.DisposableStore,this.o=new c.DisposableStore,this.c=A.options.defaultFindMode??ue.Highlight,E.onDidSplice(this.w,this,this.o)}open(){if(this.d){this.d.focus(),this.d.select();return}this.mode=this.p.options.defaultFindMode??ue.Highlight,this.d=new ae(this.q.getHTMLElement(),this.p,this.t,this.mode,this.u),this.m.add(this.d),this.d.onDidChangeValue(this.v,this,this.m),this.d.onDidChangeMode(A=>this.mode=A,void 0,this.m),this.d.onDidDisable(this.close,this,this.m),this.d.layout(this.f),this.d.focus(),this.d.value=this.b,this.d.select(),this.k.fire(!0)}close(){!this.d||(this.d=void 0,this.m.dispose(),this.m=new c.DisposableStore,this.b=this.pattern,this.v(""),this.p.domFocus(),this.k.fire(!1))}v(A){this.a=A,this.j.fire(A),this.s.pattern=A,this.p.refilter(),A&&this.p.focusNext(0,!0,void 0,u=>!r.FuzzyScore.isDefault(u.filterData));const E=this.p.getFocus();if(E.length>0){const u=E[0];this.p.getRelativeTop(u)===null&&this.p.reveal(u,.5)}this.x()}w(){!this.d||this.pattern.length===0||(this.p.refilter(),this.x())}x(){const A=this.s.totalCount>0&&this.s.matchCount===0;this.pattern&&A?this.p.options.showNotFoundMessage??!0?this.d?.showMessage({type:2,content:(0,N.localize)(5,null)}):this.d?.showMessage({type:2}):this.d?.clearMessage()}shouldAllowFocus(A){return!this.d||!this.pattern||this.c===ue.Filter||this.s.totalCount>0&&this.s.matchCount<=1?!0:!r.FuzzyScore.isDefault(A.filterData)}layout(A){this.f=A,this.d?.layout(A)}dispose(){this.j.dispose(),this.m.dispose(),this.o.dispose()}}function Ae(ee){let A=o.TreeMouseEventTarget.Unknown;return(0,v.hasParentWithClass)(ee.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?A=o.TreeMouseEventTarget.Twistie:(0,v.hasParentWithClass)(ee.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?A=o.TreeMouseEventTarget.Element:(0,v.hasParentWithClass)(ee.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(A=o.TreeMouseEventTarget.Filter),{browserEvent:ee.browserEvent,element:ee.element?ee.element.element:null,target:A}}function x(ee){return{element:ee.element?ee.element.element:null,browserEvent:ee.browserEvent,anchor:ee.anchor}}function ve(ee,A){A(ee),ee.children.forEach(E=>ve(E,A))}class Ne{get f(){return this.d||(this.d=this.m()),this.d}constructor(A,E){this.g=A,this.j=E,this.a=[],this.c=new h.Emitter,this.onDidChange=this.c.event}set(A,E){!E?.__forceEvent&&(0,e.equals)(this.a,A)||this.k(A,!1,E)}k(A,E,u){if(this.a=[...A],this.b=void 0,this.d=void 0,!E){const B=this;this.c.fire({get elements(){return B.get()},browserEvent:u})}}get(){return this.b||(this.b=this.a.map(A=>A.element)),[...this.b]}getNodes(){return this.a}has(A){return this.f.has(A)}onDidModelSplice({insertedNodes:A,deletedNodes:E}){if(!this.j){const F=this.m(),O=U=>F.delete(U);E.forEach(U=>ve(U,O)),this.set([...F.values()]);return}const u=new Set,B=F=>u.add(this.j.getId(F.element).toString());E.forEach(F=>ve(F,B));const W=new Map,$=F=>W.set(this.j.getId(F.element).toString(),F);A.forEach(F=>ve(F,$));const Y=[];for(const F of this.a){const O=this.j.getId(F.element).toString();if(!u.has(O))Y.push(F);else{const k=W.get(O);k&&Y.push(k)}}if(this.a.length>0&&Y.length===0){const F=this.g();F&&Y.push(F)}this.k(Y,!0)}m(){const A=new Set;for(const E of this.a)A.add(E);return A}}class oe extends m.MouseController{constructor(A,E){super(A),this.z=E}u(A){if((0,m.isButton)(A.browserEvent.target)||(0,m.isInputElement)(A.browserEvent.target)||(0,m.isMonacoEditor)(A.browserEvent.target))return;const E=A.element;if(!E)return super.u(A);if(this.p(A)||this.o(A))return super.u(A);const u=A.browserEvent.target,B=u.classList.contains("monaco-tl-twistie")||u.classList.contains("monaco-icon-label")&&u.classList.contains("folder-icon")&&A.browserEvent.offsetX<16;let W=!1;if(typeof this.z.expandOnlyOnTwistieClick=="function"?W=this.z.expandOnlyOnTwistieClick(E.element):W=!!this.z.expandOnlyOnTwistieClick,W&&!B&&A.browserEvent.detail!==2)return super.u(A);if(!this.z.expandOnDoubleClick&&A.browserEvent.detail===2)return super.u(A);if(E.collapsible){const $=this.z.getNodeLocation(E),Y=A.browserEvent.altKey;if(this.z.setFocus([$]),this.z.toggleCollapsed($,Y),W&&B)return}super.u(A)}v(A){A.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.z.expandOnDoubleClick||super.v(A)}}class X extends m.List{constructor(A,E,u,B,W,$,Y,F){super(A,E,u,B,F),this.p=W,this.s=$,this.L=Y}E(A){return new oe(this,A.tree)}splice(A,E,u=[]){if(super.splice(A,E,u),u.length===0)return;const B=[],W=[];let $;u.forEach((Y,F)=>{this.p.has(Y)&&B.push(A+F),this.s.has(Y)&&W.push(A+F),this.L.has(Y)&&($=A+F)}),B.length>0&&super.setFocus((0,e.distinct)([...super.getFocus(),...B])),W.length>0&&super.setSelection((0,e.distinct)([...super.getSelection(),...W])),typeof $=="number"&&super.setAnchor($)}setFocus(A,E,u=!1){super.setFocus(A,E),u||this.p.set(A.map(B=>this.element(B)),E)}setSelection(A,E,u=!1){super.setSelection(A,E),u||this.s.set(A.map(B=>this.element(B)),E)}setAnchor(A,E=!1){super.setAnchor(A),E||(typeof A>"u"?this.L.set([]):this.L.set([this.element(A)]))}}class se{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.w.wrapEvent(this.p.onDidChange)}get onDidChangeSelection(){return this.w.wrapEvent(this.q.onDidChange)}get onMouseClick(){return h.Event.map(this.j.onMouseClick,Ae)}get onMouseDblClick(){return h.Event.filter(h.Event.map(this.j.onMouseDblClick,Ae),A=>A.target!==o.TreeMouseEventTarget.Filter)}get onContextMenu(){return h.Event.map(this.j.onContextMenu,x)}get onTap(){return h.Event.map(this.j.onTap,Ae)}get onPointer(){return h.Event.map(this.j.onPointer,Ae)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return h.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.x?.mode??ue.Highlight}set findMode(A){this.x&&(this.x.mode=A)}get onDidChangeFindPattern(){return this.x?this.x.onDidChangePattern:h.Event.None}get expandOnDoubleClick(){return typeof this.E.expandOnDoubleClick>"u"?!0:this.E.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.E.expandOnlyOnTwistieClick>"u"?!0:this.E.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(A,E,u,B,W={}){this.D=A,this.E=W,this.w=new h.EventBufferer,this.onDidChangeFindOpenState=h.Event.None,this.A=new c.DisposableStore,this.B=new h.Emitter,this.onWillRefilter=this.B.event,this.C=new h.Emitter,this.onDidUpdateOptions=this.C.event;const $=new p(u),Y=new h.Relay,F=new h.Relay,O=this.A.add(new V(F.event)),U=new l.SetMap;this.k=B.map(P=>new ge(P,()=>this.o,Y.event,O,U,W));for(const P of this.k)this.A.add(P);let k;W.keyboardNavigationLabelProvider&&(k=new Q(this,W.keyboardNavigationLabelProvider,W.filter),W={...W,filter:k},this.A.add(k)),this.p=new Ne(()=>this.j.getFocusedElements()[0],W.identityProvider),this.q=new Ne(()=>this.j.getSelectedElements()[0],W.identityProvider),this.u=new Ne(()=>this.j.getAnchorElement(),W.identityProvider),this.j=new X(A,E,$,this.k,this.p,this.q,this.u,{...C(()=>this.o,W),tree:this}),this.o=this.I(A,this.j,W),Y.input=this.o.onDidChangeCollapseState;const M=h.Event.forEach(this.o.onDidSplice,P=>{this.w.bufferEvents(()=>{this.p.onDidModelSplice(P),this.q.onDidModelSplice(P)})},this.A);if(M(()=>null,null,this.A),F.input=h.Event.chain(h.Event.any(M,this.p.onDidChange,this.q.onDidChange)).debounce(()=>null,0).map(()=>{const P=new Set;for(const R of this.p.getNodes())P.add(R);for(const R of this.q.getNodes())P.add(R);return[...P.values()]}).event,W.keyboardSupport!==!1){const P=h.Event.chain(this.j.onKeyDown).filter(R=>!(0,m.isInputElement)(R.target)).map(R=>new z.StandardKeyboardEvent(R));P.filter(R=>R.keyCode===15).on(this.F,this,this.A),P.filter(R=>R.keyCode===17).on(this.G,this,this.A),P.filter(R=>R.keyCode===10).on(this.H,this,this.A)}if((W.findWidgetEnabled??!0)&&W.keyboardNavigationLabelProvider&&W.contextViewProvider){const P=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.x=new de(this,this.o,this.j,k,W.contextViewProvider,P),this.y=R=>this.x.shouldAllowFocus(R),this.onDidChangeFindOpenState=this.x.onDidChangeOpenState,this.A.add(this.x),this.onDidChangeFindMode=this.x.onDidChangeMode}else this.onDidChangeFindMode=h.Event.None;this.z=(0,v.createStyleSheet)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===_.Always)}updateOptions(A={}){this.E={...this.E,...A};for(const E of this.k)E.updateOptions(A);this.j.updateOptions(this.E),this.C.fire(this.E),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===_.Always)}get options(){return this.E}updateWidth(A){const E=this.o.getListIndex(A);E!==-1&&this.j.updateWidth(E)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get scrollTop(){return this.j.scrollTop}set scrollTop(A){this.j.scrollTop=A}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(A){this.j.scrollLeft=A}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const A=this.j.firstVisibleIndex;return A<0||A>=this.j.length?void 0:this.j.element(A).element}get lastVisibleElement(){const A=this.j.lastVisibleIndex;return this.j.element(A).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(A){this.j.ariaLabel=A}domFocus(){this.j.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(A,E){this.j.layout(A,E),(0,S.isNumber)(E)&&this.x?.layout(E)}style(A){const E=`.${this.j.domId}`,u=[];A.treeIndentGuidesStroke&&(u.push(`.monaco-list${E}:hover .monaco-tl-indent > .indent-guide, .monaco-list${E}.always .monaco-tl-indent > .indent-guide  { border-color: ${A.treeIndentGuidesStroke.transparent(.4)}; }`),u.push(`.monaco-list${E} .monaco-tl-indent > .indent-guide.active { border-color: ${A.treeIndentGuidesStroke}; }`)),this.z.textContent=u.join(`
`),this.j.style(A)}getParentElement(A){const E=this.o.getParentNodeLocation(A);return this.o.getNode(E).element}getFirstElementChild(A){return this.o.getFirstElementChild(A)}getNode(A){return this.o.getNode(A)}getNodeLocation(A){return this.o.getNodeLocation(A)}collapse(A,E=!1){return this.o.setCollapsed(A,!0,E)}expand(A,E=!1){return this.o.setCollapsed(A,!1,E)}toggleCollapsed(A,E=!1){return this.o.setCollapsed(A,void 0,E)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(A){return this.o.isCollapsible(A)}setCollapsible(A,E){return this.o.setCollapsible(A,E)}isCollapsed(A){return this.o.isCollapsed(A)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.x?.open()}closeFind(){this.x?.close()}refilter(){this.B.fire(void 0),this.o.refilter()}setAnchor(A){if(typeof A>"u")return this.j.setAnchor(void 0);const E=this.o.getNode(A);this.u.set([E]);const u=this.o.getListIndex(A);u>-1&&this.j.setAnchor(u,!0)}getAnchor(){return(0,e.firstOrDefault)(this.u.get(),void 0)}setSelection(A,E){const u=A.map(W=>this.o.getNode(W));this.q.set(u,E);const B=A.map(W=>this.o.getListIndex(W)).filter(W=>W>-1);this.j.setSelection(B,E,!0)}getSelection(){return this.q.get()}setFocus(A,E){const u=A.map(W=>this.o.getNode(W));this.p.set(u,E);const B=A.map(W=>this.o.getListIndex(W)).filter(W=>W>-1);this.j.setFocus(B,E,!0)}focusNext(A=1,E=!1,u,B=this.y){this.j.focusNext(A,E,u,B)}focusPrevious(A=1,E=!1,u,B=this.y){this.j.focusPrevious(A,E,u,B)}focusNextPage(A,E=this.y){return this.j.focusNextPage(A,E)}focusPreviousPage(A,E=this.y){return this.j.focusPreviousPage(A,E)}focusLast(A,E=this.y){this.j.focusLast(A,E)}focusFirst(A,E=this.y){this.j.focusFirst(A,E)}getFocus(){return this.p.get()}reveal(A,E){this.o.expandTo(A);const u=this.o.getListIndex(A);u!==-1&&this.j.reveal(u,E)}getRelativeTop(A){const E=this.o.getListIndex(A);return E===-1?null:this.j.getRelativeTop(E)}getViewState(A=this.options.identityProvider){if(!A)throw new o.TreeError(this.D,"Can't get tree view state without an identity provider");const E=$=>A.getId($).toString(),u=y.empty(this.scrollTop);for(const $ of this.getFocus())u.focus.add(E($));for(const $ of this.getSelection())u.selection.add(E($));const B=this.o.getNode(),W=[B];for(;W.length>0;){const $=W.shift();$!==B&&$.collapsible&&(u.expanded[E($.element)]=$.collapsed?0:1),W.push(...$.children)}return u}F(A){A.preventDefault(),A.stopPropagation();const E=this.j.getFocusedElements();if(E.length===0)return;const u=E[0],B=this.o.getNodeLocation(u);if(!this.o.setCollapsed(B,!0)){const $=this.o.getParentNodeLocation(B);if(!$)return;const Y=this.o.getListIndex($);this.j.reveal(Y),this.j.setFocus([Y])}}G(A){A.preventDefault(),A.stopPropagation();const E=this.j.getFocusedElements();if(E.length===0)return;const u=E[0],B=this.o.getNodeLocation(u);if(!this.o.setCollapsed(B,!1)){if(!u.children.some(F=>F.visible))return;const[$]=this.j.getFocus(),Y=$+1;this.j.reveal(Y),this.j.setFocus([Y])}}H(A){A.preventDefault(),A.stopPropagation();const E=this.j.getFocusedElements();if(E.length===0)return;const u=E[0],B=this.o.getNodeLocation(u),W=A.browserEvent.altKey;this.o.setCollapsed(B,void 0,W)}navigate(A){return new ne(this.j,this.o,A)}dispose(){(0,c.dispose)(this.A),this.j.dispose()}}t.AbstractTree=se;class ne{constructor(A,E,u){this.b=A,this.c=E,u?this.a=this.c.getListIndex(u):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(me[129],be([1,0,128,119,23,25]),function(Z,t,v,i,z,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class D extends v.AbstractTree{constructor(d,m,g,I,o,n={}){super(d,m,g,I,n),this.f=d,this.g=o,this.d=new Map,this.c=n.identityProvider}getInput(){return this.b}setInput(d,m){if(m&&!this.c)throw new z.TreeError(this.f,"Can't restore tree view state without an identity provider");if(this.b=d,!d){this.d.clear(),this.o.setChildren(null,H.Iterable.empty());return}if(!m){this.m(d);return}const g=[],I=[],o=e=>{const s=this.c.getId(e).toString();return!m.expanded[s]},n=e=>{const s=this.c.getId(e.element).toString();m.focus.has(s)&&g.push(e.element),m.selection.has(s)&&I.push(e.element)};this.m(d,o,n),this.setFocus(g),this.setSelection(I),m&&typeof m.scrollTop=="number"&&(this.scrollTop=m.scrollTop)}updateChildren(d=this.b){if(typeof this.b>"u")throw new z.TreeError(this.f,"Tree input not set");let m;this.c&&(m=g=>{const I=this.c.getId(g).toString(),o=this.d.get(I);if(!!o)return o.collapsed}),this.m(d,m)}resort(d=this.b,m=!0){this.o.resort(d===this.b?null:d,m)}refresh(d){if(d===void 0){this.j.rerender();return}this.o.rerender(d)}m(d,m,g){let I;if(this.c){const o=new Set,n=g;g=e=>{const s=this.c.getId(e.element).toString();o.add(s),this.d.set(s,e),n?.(e)},I=e=>{const s=this.c.getId(e.element).toString();o.has(s)||this.d.delete(s)}}this.o.setChildren(d===this.b?null:d,this.s(d,m).elements,{onDidCreateNode:g,onDidDeleteNode:I})}s(d,m){const g=[...this.g.getChildren(d)];return{elements:H.Iterable.map(g,o=>{const{elements:n,size:e}=this.s(o,m),s=this.g.hasChildren?this.g.hasChildren(o):void 0,a=e===0?void 0:m&&m(o);return{element:o,children:n,collapsible:s,collapsed:a}}),size:g.length}}I(d,m,g){return new i.ObjectTreeModel(d,m,g)}}t.DataTree=D}),define(me[37],be([1,0,14,8,29,26,24,9,3,2,50,11,6]),function(Z,t,v,i,z,H,D,w,d,m,g,I,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.deserialize=t.serialize=t.BufferWriter=t.BufferReader=void 0;var n;(function(oe){oe[oe.Promise=100]="Promise",oe[oe.PromiseCancel=101]="PromiseCancel",oe[oe.EventListen=102]="EventListen",oe[oe.EventDispose=103]="EventDispose"})(n||(n={}));function e(oe){switch(oe){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var s;(function(oe){oe[oe.Initialize=200]="Initialize",oe[oe.PromiseSuccess=201]="PromiseSuccess",oe[oe.PromiseError=202]="PromiseError",oe[oe.PromiseErrorObj=203]="PromiseErrorObj",oe[oe.EventFire=204]="EventFire"})(s||(s={}));function a(oe){switch(oe){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(oe){oe[oe.Uninitialized=0]="Uninitialized",oe[oe.Idle=1]="Idle"})(l||(l={}));function h(oe){let X=0;for(let se=0;;se+=7){const ne=oe.read(1);if(X|=(ne.buffer[0]&127)<<se,!(ne.buffer[0]&128))return X}}const r=L(0);function c(oe,X){if(X===0){oe.write(r);return}let se=0;for(let ee=X;ee!==0;ee=ee>>>7)se++;const ne=z.VSBuffer.alloc(se);for(let ee=0;X!==0;ee++)ne.buffer[ee]=X&127,X=X>>>7,X>0&&(ne.buffer[ee]|=128);oe.write(ne)}class b{constructor(X){this.b=X,this.a=0}read(X){const se=this.b.slice(this.a,this.a+X);return this.a+=se.byteLength,se}}t.BufferReader=b;class S{constructor(){this.a=[]}get buffer(){return z.VSBuffer.concat(this.a)}write(X){this.a.push(X)}}t.BufferWriter=S;var N;(function(oe){oe[oe.Undefined=0]="Undefined",oe[oe.String=1]="String",oe[oe.Buffer=2]="Buffer",oe[oe.VSBuffer=3]="VSBuffer",oe[oe.Array=4]="Array",oe[oe.Object=5]="Object",oe[oe.Int=6]="Int"})(N||(N={}));function L(oe){const X=z.VSBuffer.alloc(1);return X.writeUInt8(oe,0),X}const T={Undefined:L(N.Undefined),String:L(N.String),Buffer:L(N.Buffer),VSBuffer:L(N.VSBuffer),Array:L(N.Array),Object:L(N.Object),Uint:L(N.Int)},f=typeof Buffer<"u";function C(oe,X){if(typeof X>"u")oe.write(T.Undefined);else if(typeof X=="string"){const se=z.VSBuffer.fromString(X);oe.write(T.String),c(oe,se.byteLength),oe.write(se)}else if(f&&Buffer.isBuffer(X)){const se=z.VSBuffer.wrap(X);oe.write(T.Buffer),c(oe,se.byteLength),oe.write(se)}else if(X instanceof z.VSBuffer)oe.write(T.VSBuffer),c(oe,X.byteLength),oe.write(X);else if(Array.isArray(X)){oe.write(T.Array),c(oe,X.length);for(const se of X)C(oe,se)}else if(typeof X=="number"&&(X|0)===X)oe.write(T.Uint),c(oe,X);else{const se=z.VSBuffer.fromString(JSON.stringify(X));oe.write(T.Object),c(oe,se.byteLength),oe.write(se)}}t.serialize=C;function p(oe){switch(oe.read(1).readUInt8(0)){case N.Undefined:return;case N.String:return oe.read(h(oe)).toString();case N.Buffer:return oe.read(h(oe)).buffer;case N.VSBuffer:return oe.read(h(oe));case N.Array:{const se=h(oe),ne=[];for(let ee=0;ee<se;ee++)ne.push(p(oe));return ne}case N.Object:return JSON.parse(oe.read(h(oe)).toString());case N.Int:return h(oe)}}t.deserialize=p;class y{constructor(X,se,ne=null,ee=1e3){this.h=X,this.j=se,this.k=ne,this.l=ee,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(A=>this.q(A)),this.m({type:200})}registerChannel(X,se){this.b.set(X,se),setTimeout(()=>this.w(X),0)}m(X){switch(X.type){case 200:{const se=this.o([X.type]);this.k?.logOutgoing(se,0,1,a(X.type));return}case 201:case 202:case 204:case 203:{const se=this.o([X.type,X.id],X.data);this.k?.logOutgoing(se,X.id,1,a(X.type),X.data);return}}}o(X,se=void 0){const ne=new S;return C(ne,X),C(ne,se),this.p(ne.buffer)}p(X){try{return this.h.send(X),X.byteLength}catch{return 0}}q(X){const se=new b(X),ne=p(se),ee=p(se),A=ne[0];switch(A){case 100:return this.k?.logIncoming(X.byteLength,ne[1],1,`${e(A)}: ${ne[2]}.${ne[3]}`,ee),this.s({type:A,id:ne[1],channelName:ne[2],name:ne[3],arg:ee});case 102:return this.k?.logIncoming(X.byteLength,ne[1],1,`${e(A)}: ${ne[2]}.${ne[3]}`,ee),this.t({type:A,id:ne[1],channelName:ne[2],name:ne[3],arg:ee});case 101:return this.k?.logIncoming(X.byteLength,ne[1],1,`${e(A)}`),this.u({type:A,id:ne[1]});case 103:return this.k?.logIncoming(X.byteLength,ne[1],1,`${e(A)}`),this.u({type:A,id:ne[1]})}}s(X){const se=this.b.get(X.channelName);if(!se){this.v(X);return}const ne=new H.CancellationTokenSource;let ee;try{ee=se.call(this.j,X.name,X.arg,ne.token)}catch(u){ee=Promise.reject(u)}const A=X.id;ee.then(u=>{this.m({id:A,data:u,type:201}),this.d.delete(X.id)},u=>{u instanceof Error?this.m({id:A,data:{message:u.message,name:u.name,stack:u.stack?u.stack.split?u.stack.split(`
`):u.stack:void 0},type:202}):this.m({id:A,data:u,type:203}),this.d.delete(X.id)});const E=(0,m.toDisposable)(()=>ne.cancel());this.d.set(X.id,E)}t(X){const se=this.b.get(X.channelName);if(!se){this.v(X);return}const ne=X.id,A=se.listen(this.j,X.name,X.arg)(E=>this.m({id:ne,data:E,type:204}));this.d.set(X.id,A)}u(X){const se=this.d.get(X.id);se&&(se.dispose(),this.d.delete(X.id))}v(X){let se=this.g.get(X.channelName);se||(se=[],this.g.set(X.channelName,se));const ne=setTimeout(()=>{console.error(`Unknown channel: ${X.channelName}`),X.type===100&&this.m({id:X.id,data:{name:"Unknown channel",message:`Channel name '${X.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);se.push({request:X,timeoutTimer:ne})}w(X){const se=this.g.get(X);if(se){for(const ne of se)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(X)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,m.dispose)(this.d.values()),this.d.clear()}}t.ChannelServer=y;var _;(function(oe){oe[oe.LocalSide=0]="LocalSide",oe[oe.OtherSide=1]="OtherSide"})(_=t.RequestInitiator||(t.RequestInitiator={}));class V{constructor(X,se=null){this.l=X,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new d.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=se}getChannel(X){const se=this;return{call(ne,ee,A){return se.a?Promise.reject(new w.CancellationError):se.m(X,ne,ee,A)},listen(ne,ee){return se.a?d.Event.None:se.o(X,ne,ee)}}}m(X,se,ne,ee=H.CancellationToken.None){const A=this.g++,u={id:A,type:100,channelName:X,name:se,arg:ne};if(ee.isCancellationRequested)return Promise.reject(new w.CancellationError);let B;return new Promise(($,Y)=>{if(ee.isCancellationRequested)return Y(new w.CancellationError);const F=()=>{const M=P=>{switch(P.type){case 201:this.f.delete(A),$(P.data);break;case 202:{this.f.delete(A);const R=new Error(P.data.message);R.stack=Array.isArray(P.data.stack)?P.data.stack.join(`
`):P.data.stack,R.name=P.data.name,Y(R);break}case 203:this.f.delete(A),Y(P.data);break}};this.f.set(A,M),this.p(u)};let O=null;this.b===l.Idle?F():(O=(0,i.createCancelablePromise)(M=>this.u()),O.then(()=>{O=null,F()}));const U=()=>{O?(O.cancel(),O=null):this.p({id:A,type:101}),Y(new w.CancellationError)},k=ee.onCancellationRequested(U);B=(0,m.combinedDisposable)((0,m.toDisposable)(U),k),this.d.add(B)}).finally(()=>{this.d.delete(B)})}o(X,se,ne){const ee=this.g++,E={id:ee,type:102,channelName:X,name:se,arg:ne};let u=null;const B=new d.Emitter({onWillAddFirstListener:()=>{u=(0,i.createCancelablePromise)($=>this.u()),u.then(()=>{u=null,this.d.add(B),this.p(E)})},onDidRemoveLastListener:()=>{u?(u.cancel(),u=null):(this.d.delete(B),this.p({id:ee,type:103}))}}),W=$=>B.fire($.data);return this.f.set(ee,W),B.event}p(X){switch(X.type){case 100:case 102:{const se=this.q([X.type,X.id,X.channelName,X.name],X.arg);this.j?.logOutgoing(se,X.id,0,`${e(X.type)}: ${X.channelName}.${X.name}`,X.arg);return}case 101:case 103:{const se=this.q([X.type,X.id]);this.j?.logOutgoing(se,X.id,0,e(X.type));return}}}q(X,se=void 0){const ne=new S;return C(ne,X),C(ne,se),this.r(ne.buffer)}r(X){try{return this.l.send(X),X.byteLength}catch{return 0}}s(X){const se=new b(X),ne=p(se),ee=p(se),A=ne[0];switch(A){case 200:return this.j?.logIncoming(X.byteLength,0,0,a(A)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(X.byteLength,ne[1],0,a(A),ee),this.t({type:ne[0],id:ne[1],data:ee})}}t(X){if(X.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(X.id)?.(X)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,m.dispose)(this.d.values()),this.d.clear()}}qe([D.memoize],V.prototype,"onDidInitializePromise",null),t.ChannelClient=V;class ge{get connections(){const X=[];return this.f.forEach(se=>X.push(se)),X}constructor(X){this.a=new Map,this.f=new Set,this.g=new d.Emitter,this.onDidAddConnection=this.g.event,this.h=new d.Emitter,this.onDidRemoveConnection=this.h.event,X(({protocol:se,onDidClientDisconnect:ne})=>{d.Event.once(se.onMessage)(A=>{const E=new b(A),u=p(E),B=new y(se,u),W=new V(se);this.a.forEach((Y,F)=>B.registerChannel(F,Y));const $={channelServer:B,channelClient:W,ctx:u};this.f.add($),this.g.fire($),ne(()=>{B.dispose(),W.dispose(),this.f.delete($),this.h.fire($)})})})}getChannel(X,se){const ne=this;return{call(ee,A,E){let u;if((0,o.isFunction)(se)){const W=(0,v.getRandomElement)(ne.connections.filter(se));u=W?Promise.resolve(W):d.Event.toPromise(d.Event.filter(ne.onDidAddConnection,se))}else u=se.routeCall(ne,ee,A);const B=u.then(W=>W.channelClient.getChannel(X));return ie(B).call(ee,A,E)},listen(ee,A){if((0,o.isFunction)(se))return ne.j(X,se,ee,A);const E=se.routeEvent(ne,ee,A).then(u=>u.channelClient.getChannel(X));return ie(E).listen(ee,A)}}}j(X,se,ne,ee){const A=this;let E=new m.DisposableStore;const u=new d.Emitter({onWillAddFirstListener:()=>{E=new m.DisposableStore;const B=new d.EventMultiplexer,W=new Map,$=F=>{const U=F.channelClient.getChannel(X).listen(ne,ee),k=B.add(U);W.set(F,k)},Y=F=>{const O=W.get(F);!O||(O.dispose(),W.delete(F))};A.connections.filter(se).forEach($),d.Event.filter(A.onDidAddConnection,se)($,void 0,E),A.onDidRemoveConnection(Y,void 0,E),B.event(u.fire,u,E),E.add(B)},onDidRemoveLastListener:()=>{E.dispose()}});return u.event}registerChannel(X,se){this.a.set(X,se),this.f.forEach(ne=>{ne.channelServer.registerChannel(X,se)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}t.IPCServer=ge;class Q{constructor(X,se,ne=null){const ee=new S;C(ee,se),X.send(ee.buffer),this.a=new V(X,ne),this.d=new y(X,se,ne)}getChannel(X){return this.a.getChannel(X)}registerChannel(X,se){this.d.registerChannel(X,se)}dispose(){this.a.dispose(),this.d.dispose()}}t.IPCClient=Q;function ie(oe){return{call(X,se,ne){return oe.then(ee=>ee.call(X,se,ne))},listen(X,se){const ne=new d.Relay;return oe.then(ee=>ne.input=ee.listen(X,se)),ne.event}}}t.getDelayedChannel=ie;function te(oe){let X=!1;return{call(se,ne,ee){return X?oe.call(se,ne,ee):(0,i.timeout)(0).then(()=>X=!0).then(()=>oe.call(se,ne,ee))},listen(se,ne){if(X)return oe.listen(se,ne);const ee=new d.Relay;return(0,i.timeout)(0).then(()=>X=!0).then(()=>ee.input=oe.listen(se,ne)),ee.event}}}t.getNextTickChannel=te;class ue{constructor(X){this.a=X}routeCall(X){return this.b(X)}routeEvent(X){return this.b(X)}async b(X){for(const se of X.connections)if(await Promise.resolve(this.a(se.ctx)))return Promise.resolve(se);return await d.Event.toPromise(X.onDidAddConnection),await this.b(X)}}t.StaticRouter=ue;var ae;(function(oe){function X(A,E){const u=A,B=E&&E.disableMarshalling,W=new Map;for(const $ in u)ne($)&&W.set($,d.Event.buffer(u[$],!0));return new class{listen($,Y,F){const O=W.get(Y);if(O)return O;if(ee(Y)){const U=u[Y];if(typeof U=="function")return U.call(u,F)}throw new Error(`Event not found: ${Y}`)}call($,Y,F){const O=u[Y];if(typeof O=="function"){if(!B&&Array.isArray(F))for(let U=0;U<F.length;U++)F[U]=(0,g.revive)(F[U]);return O.apply(u,F)}throw new Error(`Method not found: ${Y}`)}}}oe.fromService=X;function se(A,E){const u=E&&E.disableMarshalling;return new Proxy({},{get(B,W){if(typeof W=="string")return E?.properties?.has(W)?E.properties.get(W):ee(W)?function($){return A.listen(W,$)}:ne(W)?A.listen(W):async function(...$){let Y;E&&!(0,o.isUndefinedOrNull)(E.context)?Y=[E.context,...$]:Y=$;const F=await A.call(W,Y);return u?F:(0,g.revive)(F)};throw new Error(`Property not found: ${String(W)}`)}})}oe.toService=se;function ne(A){return A[0]==="o"&&A[1]==="n"&&I.isUpperAsciiLetter(A.charCodeAt(2))}function ee(A){return/^onDynamic/.test(A)&&I.isUpperAsciiLetter(A.charCodeAt(9))}})(ae=t.ProxyChannel||(t.ProxyChannel={}));const de=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Ae(oe){if(Array.isArray(oe))return oe;if(oe&&typeof oe=="object"&&typeof oe.toString=="function"){const X=oe.toString();if(X!=="[object Object]")return X}return oe}function x(oe){return Array.isArray(oe)?oe.map(Ae):Ae(oe)}function ve(oe,X,se,ne,ee,A,E){E=x(E);const u=de[ee],B=u[ne%u.length];let W=[`%c[${oe}]%c[${String(X).padStart(7," ")}]%c[len: ${String(se).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${A}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(A)?(W=W.concat(E),W.push(")")):W.push(E),console.log.apply(console,W)}class Ne{constructor(X,se){this.d=X,this.f=se,this.a=0,this.b=0}logOutgoing(X,se,ne,ee,A){this.b+=X,ve(this.d,this.b,X,se,ne,ee,A)}logIncoming(X,se,ne,ee,A){this.a+=X,ve(this.f,this.a,X,se,ne,ee,A)}}t.IPCLogger=Ne}),define(me[27],be([1,0,5]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0,t.ipcRenderer=v.globals.vscode.ipcRenderer,t.ipcMessagePort=v.globals.vscode.ipcMessagePort,t.webFrame=v.globals.vscode.webFrame,t.process=v.globals.vscode.process,t.context=v.globals.vscode.context}),define(me[130],be([1,0,81,27]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=void 0;let z=0;function H(w,d,m){const g=[],I=z++,o=`vscode:onContextMenu${I}`,n=(e,s,a)=>{g[s].click?.(a)};i.ipcRenderer.once(o,n),i.ipcRenderer.once(v.CONTEXT_MENU_CLOSE_CHANNEL,(e,s)=>{s===I&&(i.ipcRenderer.removeListener(o,n),m?.())}),i.ipcRenderer.send(v.CONTEXT_MENU_CHANNEL,I,w.map(e=>D(e,g)),o,d)}t.popup=H;function D(w,d){const m={id:d.length,label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:typeof w.enabled=="boolean"?w.enabled:!0,visible:typeof w.visible=="boolean"?w.visible:!0};return d.push(w),Array.isArray(w.submenu)&&(m.submenu=w.submenu.map(g=>D(g,d))),m}}),define(me[131],be([1,0,29,3,37,82,27]),function(Z,t,v,i,z,H,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class w extends z.IPCClient{static f(){const m=i.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:message",(g,I)=>v.VSBuffer.wrap(I));return D.ipcRenderer.send("vscode:hello"),new H.Protocol(D.ipcRenderer,m)}constructor(m){const g=w.f();super(g,m),this.b=g}dispose(){this.b.disconnect()}}t.Client=w}),define(me[132],be([13,10]),function(Z,t){return Z.create("vs/platform/files/common/files",t)}),define(me[133],be([13,10]),function(Z,t){return Z.create("vs/platform/theme/common/iconRegistry",t)}),define(me[65],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class v{constructor(z,H=[],D=!1){this.ctor=z,this.staticArguments=H,this.supportsDelayedInstantiation=D}}t.SyncDescriptor=v}),define(me[134],be([1,0,65]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=t.InstantiationType=void 0;const i=[];var z;(function(w){w[w.Eager=0]="Eager",w[w.Delayed=1]="Delayed"})(z=t.InstantiationType||(t.InstantiationType={}));function H(w,d,m){d instanceof v.SyncDescriptor||(d=new v.SyncDescriptor(d,[],Boolean(m))),i.push([w,d])}t.registerSingleton=H;function D(){return i}t.getSingletonServiceDescriptors=D}),define(me[28],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.refineServiceDecorator=t.createDecorator=t.IInstantiationService=t._util=void 0;var v;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function w(d){return d[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=w})(v=t._util||(t._util={})),t.IInstantiationService=z("instantiationService");function i(D,w,d){w[v.DI_TARGET]===w?w[v.DI_DEPENDENCIES].push({id:D,index:d}):(w[v.DI_DEPENDENCIES]=[{id:D,index:d}],w[v.DI_TARGET]=w)}function z(D){if(v.serviceIds.has(D))return v.serviceIds.get(D);const w=function(d,m,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(w,d,g)};return w.toString=()=>D,v.serviceIds.set(D,w),w}t.createDecorator=z;function H(D){return D}t.refineServiceDecorator=H}),define(me[135],be([1,0,28]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.isRemoteDiagnosticError=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=(0,v.createDecorator)(t.ID);function i(H){return!!H.hostName&&!!H.errorMessage}t.isRemoteDiagnosticError=i;class z{async getPerformanceInfo(D,w){return{}}async getSystemInfo(D,w){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,w){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}t.NullDiagnosticsService=z}),define(me[136],be([1,0,113,21,11,6,15,132,28]),function(Z,t,v,i,z,H,D,w,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPlatformLimits=t.Arch=t.ByteSize=t.FALLBACK_MAX_MEMORY_SIZE_MB=t.MIN_MAX_MEMORY_SIZE_MB=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileAtomicReadCapability=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileCloneCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.isFileOpenForWriteOptions=t.IFileService=void 0,t.IFileService=(0,d.createDecorator)("fileService");function m(x){return x.create===!0}t.isFileOpenForWriteOptions=m;var g;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(g=t.FileType||(t.FileType={}));var I;(function(x){x[x.Readonly=1]="Readonly"})(I=t.FilePermission||(t.FilePermission={}));var o;(function(x){x[x.None=0]="None",x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead",x[x.FileClone=32768]="FileClone"})(o=t.FileSystemProviderCapabilities||(t.FileSystemProviderCapabilities={}));function n(x){return!!(x.capabilities&2)}t.hasReadWriteCapability=n;function e(x){return!!(x.capabilities&8)}t.hasFileFolderCopyCapability=e;function s(x){return!!(x.capabilities&32768)}t.hasFileCloneCapability=s;function a(x){return!!(x.capabilities&4)}t.hasOpenReadWriteCloseCapability=a;function l(x){return!!(x.capabilities&16)}t.hasFileReadStreamCapability=l;function h(x){return n(x)?!!(x.capabilities&16384):!1}t.hasFileAtomicReadCapability=h;var r;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(r=t.FileSystemProviderErrorCode||(t.FileSystemProviderErrorCode={}));class c extends Error{constructor(ve,Ne){super(ve),this.code=Ne}}t.FileSystemProviderError=c;function b(x,ve){const Ne=new c(x.toString(),ve);return N(Ne,ve),Ne}t.createFileSystemProviderError=b;function S(x){return x||b((0,w.localize)(0,null),r.Unknown)}t.ensureFileSystemProviderError=S;function N(x,ve){return x.name=ve?`${ve} (FileSystemError)`:"FileSystemError",x}t.markAsFileSystemProviderError=N;function L(x){if(!x)return r.Unknown;if(x instanceof c)return x.code;const ve=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!ve)return r.Unknown;switch(ve[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileExceedsMemoryLimit:return r.FileExceedsMemoryLimit;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}t.toFileSystemProviderErrorCode=L;function T(x){if(x instanceof V)return x.fileOperationResult;switch(L(x)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 10;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileExceedsMemoryLimit:return 9;case r.FileTooLarge:return 7;default:return 11}}t.toFileOperationResult=T;var f;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY",x[x.WRITE=4]="WRITE"})(f=t.FileOperation||(t.FileOperation={}));class C{constructor(ve,Ne,oe){this.resource=ve,this.operation=Ne,this.target=oe}isOperation(ve){return this.operation===ve}}t.FileOperationEvent=C;var p;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(p=t.FileChangeType||(t.FileChangeType={}));class y{constructor(ve,Ne){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=ve;const oe=new Map;for(const X of ve){const se=oe.get(X.type);switch(se?se.push([X.resource,X]):oe.set(X.type,[[X.resource,X]]),X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}}for(const[X,se]of oe)switch(X){case 1:this.a=v.TernarySearchTree.forUris(()=>Ne),this.a.fill(se);break;case 0:this.b=v.TernarySearchTree.forUris(()=>Ne),this.b.fill(se);break;case 2:this.c=v.TernarySearchTree.forUris(()=>Ne),this.c.fill(se);break}}contains(ve,...Ne){return this.d(ve,{includeChildren:!1},...Ne)}affects(ve,...Ne){return this.d(ve,{includeChildren:!0},...Ne)}d(ve,Ne,...oe){if(!ve)return!1;const X=oe.length>0;return!!((!X||oe.includes(1))&&(this.a?.get(ve)||Ne.includeChildren&&this.a?.findSuperstr(ve))||(!X||oe.includes(0))&&(this.b?.get(ve)||Ne.includeChildren&&this.b?.findSuperstr(ve))||(!X||oe.includes(2))&&(this.c?.findSubstr(ve)||Ne.includeChildren&&this.c?.findSuperstr(ve)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}t.FileChangesEvent=y;function _(x,ve,Ne){return!x||!ve||x===ve||ve.length>x.length?!1:(ve.charAt(ve.length-1)!==i.sep&&(ve+=i.sep),Ne?(0,z.startsWithIgnoreCase)(x,ve):x.indexOf(ve)===0)}t.isParent=_;class V extends Error{constructor(ve,Ne,oe){super(ve),this.fileOperationResult=Ne,this.options=oe}}t.FileOperationError=V;class ge extends V{constructor(ve,Ne,oe){super(ve,2,oe),this.stat=Ne}}t.NotModifiedSinceFileOperationError=ge;var Q;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",x[x.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(Q=t.FileOperationResult||(t.FileOperationResult={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude";var ie;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(ie=t.FileKind||(t.FileKind={})),t.ETAG_DISABLED="";function te(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}t.etag=te;async function ue(x,ve){if(!ve.hasProvider(D.URI.from({scheme:x.scheme})))return new Promise(Ne=>{const oe=ve.onDidChangeFileSystemProviderRegistrations(X=>{X.scheme===x.scheme&&X.added&&(oe.dispose(),Ne())})})}t.whenProviderRegistered=ue,t.MIN_MAX_MEMORY_SIZE_MB=2048,t.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ae{static formatSize(ve){return(0,H.isNumber)(ve)||(ve=0),ve<ae.KB?(0,w.localize)(1,null,ve.toFixed(0)):ve<ae.MB?(0,w.localize)(2,null,(ve/ae.KB).toFixed(2)):ve<ae.GB?(0,w.localize)(3,null,(ve/ae.MB).toFixed(2)):ve<ae.TB?(0,w.localize)(4,null,(ve/ae.GB).toFixed(2)):(0,w.localize)(5,null,(ve/ae.TB).toFixed(2))}}t.ByteSize=ae,ae.KB=1024,ae.MB=ae.KB*ae.KB,ae.GB=ae.MB*ae.KB,ae.TB=ae.GB*ae.KB;var de;(function(x){x[x.IA32=0]="IA32",x[x.OTHER=1]="OTHER"})(de=t.Arch||(t.Arch={}));function Ae(x){return{maxFileSize:x===0?300*ae.MB:16*ae.GB,maxHeapSize:x===0?700*ae.MB:2*700*ae.MB}}t.getPlatformLimits=Ae}),define(me[137],be([1,0,2,131]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class z extends v.Disposable{constructor(D){super(),this.a=this.B(new i.Client(`window:${D}`))}getChannel(D){return this.a.getChannel(D)}registerChannel(D,w){this.a.registerChannel(D,w)}}t.ElectronIPCMainProcessService=z});var pt=this&&this.__param||function(Z,t){return function(v,i){t(v,i,Z)}};define(me[138],be([1,0,37,65,134,28]),function(Z,t,v,i,z,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.registerSharedProcessRemoteService=t.ISharedProcessService=t.registerMainProcessRemoteService=t.IMainProcessService=void 0;class D{constructor(n,e,s,a){const l=s.getChannel(n);return w(e)?a.createInstance(new i.SyncDescriptor(e.channelClientCtor,[l])):v.ProxyChannel.toService(l,e?.proxyOptions)}}function w(o){return!!o?.channelClientCtor}t.IMainProcessService=(0,H.createDecorator)("mainProcessService");let d=class extends D{constructor(n,e,s,a){super(n,e,s,a)}};d=qe([pt(2,t.IMainProcessService),pt(3,H.IInstantiationService)],d);function m(o,n,e){(0,z.registerSingleton)(o,new i.SyncDescriptor(d,[n,e],!0))}t.registerMainProcessRemoteService=m,t.ISharedProcessService=(0,H.createDecorator)("sharedProcessService");let g=class extends D{constructor(n,e,s,a){super(n,e,s,a)}};g=qe([pt(2,t.ISharedProcessService),pt(3,H.IInstantiationService)],g);function I(o,n,e){(0,z.registerSingleton)(o,new i.SyncDescriptor(g,[n,e],!0))}t.registerSharedProcessRemoteService=I}),define(me[139],be([1,0,37,138]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let z=class{constructor(D,w){return this.windowId=D,v.ProxyChannel.toService(w.getChannel("nativeHost"),{context:D,properties:(()=>{const d=new Map;return d.set("windowId",D),d})()})}};z=qe([pt(1,i.IMainProcessService)],z),t.NativeHostService=z}),define(me[38],be([1,0,72,6]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class z{constructor(){this.a=new Map}add(D,w){v.ok(i.isString(D)),v.ok(i.isObject(w)),v.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,w)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}t.Registry=new z}),define(me[140],be([1,0,3,38]),function(Z,t,v,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function z(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class H{constructor(){this.b=new v.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,m){this.a[z(d)]=m,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const D=new H;i.Registry.add(t.Extensions.JSONContribution,D)}),define(me[141],be([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isDark=t.isHighContrast=t.ColorScheme=void 0;var v;(function(H){H.DARK="dark",H.LIGHT="light",H.HIGH_CONTRAST_DARK="hcDark",H.HIGH_CONTRAST_LIGHT="hcLight"})(v=t.ColorScheme||(t.ColorScheme={}));function i(H){return H===v.HIGH_CONTRAST_DARK||H===v.HIGH_CONTRAST_LIGHT}t.isHighContrast=i;function z(H){return H===v.DARK||H===v.HIGH_CONTRAST_DARK}t.isDark=z}),define(me[66],be([1,0,12,3,2,28,38,141]),function(Z,t,v,i,z,H,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Themable=t.registerThemingParticipant=t.Extensions=t.getThemeTypeSelector=t.FolderThemeIcon=t.FileThemeIcon=t.ThemeIcon=t.themeColorFromId=t.ThemeColor=t.IThemeService=void 0,t.IThemeService=(0,H.createDecorator)("themeService");var d;(function(a){function l(h){return h&&typeof h=="object"&&typeof h.id=="string"}a.isThemeColor=l})(d=t.ThemeColor||(t.ThemeColor={}));function m(a){return{id:a}}t.themeColorFromId=m;var g;(function(a){function l(T){return T&&typeof T=="object"&&typeof T.id=="string"&&(typeof T.color>"u"||d.isThemeColor(T.color))}a.isThemeIcon=l;const h=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function r(T){const f=h.exec(T);if(!f)return;const[,C]=f;return{id:C}}a.fromString=r;function c(T){return{id:T}}a.fromId=c;function b(T,f){let C=T.id;const p=C.lastIndexOf("~");return p!==-1&&(C=C.substring(0,p)),f&&(C=`${C}~${f}`),{id:C}}a.modify=b;function S(T){const f=T.id.lastIndexOf("~");if(f!==-1)return T.id.substring(f+1)}a.getModifier=S;function N(T,f){return T.id===f.id&&T.color?.id===f.color?.id}a.isEqual=N;function L(T,f){return{id:T.id,color:f?m(f):void 0}}a.asThemeIcon=L,a.asClassNameArray=v.CSSIcon.asClassNameArray,a.asClassName=v.CSSIcon.asClassName,a.asCSSSelector=v.CSSIcon.asCSSSelector})(g=t.ThemeIcon||(t.ThemeIcon={})),t.FileThemeIcon=v.Codicon.file,t.FolderThemeIcon=v.Codicon.folder;function I(a){switch(a){case w.ColorScheme.DARK:return"vs-dark";case w.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case w.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}t.getThemeTypeSelector=I,t.Extensions={ThemingContribution:"base.contributions.theming"};class o{constructor(){this.a=[],this.a=[],this.b=new i.Emitter}onColorThemeChange(l){return this.a.push(l),this.b.fire(l),(0,z.toDisposable)(()=>{const h=this.a.indexOf(l);this.a.splice(h,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const n=new o;D.Registry.add(t.Extensions.ThemingContribution,n);function e(a){return n.onColorThemeChange(a)}t.registerThemingParticipant=e;class s extends z.Disposable{constructor(l){super(),this.k=l,this.h=l.getColorTheme(),this.B(this.k.onDidColorThemeChange(h=>this.n(h)))}n(l){this.h=l,this.updateStyles()}updateStyles(){}w(l,h){let r=this.h.getColor(l);return r&&h&&(r=h(r,this.h)),r?r.toString():null}}t.Themable=s}),define(me[142],be([1,0,8,12,3,6,15,133,140,38,66]),function(Z,t,v,i,z,H,D,w,d,m,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.getIconRegistry=t.registerIcon=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.Extensions={IconContribution:"base.contributions.icons"};var I;(function(c){function b(S,N){let L=S.defaults;for(;g.ThemeIcon.isThemeIcon(L);){const T=e.getIcon(L.id);if(!T)return;L=T.defaults}return L}c.getDefinition=b})(I=t.IconContribution||(t.IconContribution={}));var o;(function(c){function b(N){return{weight:N.weight,style:N.style,src:N.src.map(L=>({format:L.format,location:L.location.toString()}))}}c.toJSONObject=b;function S(N){const L=T=>(0,H.isString)(T)?T:void 0;if(N&&Array.isArray(N.src)&&N.src.every(T=>(0,H.isString)(T.format)&&(0,H.isString)(T.location)))return{weight:L(N.weight),style:L(N.style),src:N.src.map(T=>({format:T.format,location:D.URI.parse(T.location)}))}}c.fromJSONObject=S})(o=t.IconFontDefinition||(t.IconFontDefinition={}));class n{constructor(){this.a=new z.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,w.localize)(0,null)},fontCharacter:{type:"string",description:(0,w.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${i.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(b,S,N,L){const T=this.b[b];if(T){if(N&&!T.description){T.description=N,this.d.properties[b].markdownDescription=`${N} $(${b})`;const p=this.e.enum.indexOf(b);p!==-1&&(this.e.enumDescriptions[p]=N),this.a.fire()}return T}const f={id:b,description:N,defaults:S,deprecationMessage:L};this.b[b]=f;const C={$ref:"#/definitions/icons"};return L&&(C.deprecationMessage=L),N&&(C.markdownDescription=`${N}: $(${b})`),this.d.properties[b]=C,this.e.enum.push(b),this.e.enumDescriptions.push(N||""),this.a.fire(),{id:b}}deregisterIcon(b){delete this.b[b],delete this.d.properties[b];const S=this.e.enum.indexOf(b);S!==-1&&(this.e.enum.splice(S,1),this.e.enumDescriptions.splice(S,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(b=>this.b[b])}getIcon(b){return this.b[b]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(b,S){const N=this.f[b];return N||(this.f[b]=S,this.a.fire(),S)}deregisterIconFont(b){delete this.f[b]}getIconFont(b){return this.f[b]}toString(){const b=(T,f)=>T.id.localeCompare(f.id),S=T=>{for(;g.ThemeIcon.isThemeIcon(T.defaults);)T=this.b[T.defaults.id];return`codicon codicon-${T?T.id:""}`},N=[];N.push("| preview     | identifier                        | default codicon ID                | description"),N.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const L=Object.keys(this.b).map(T=>this.b[T]);for(const T of L.filter(f=>!!f.description).sort(b))N.push(`|<i class="${S(T)}"></i>|${T.id}|${g.ThemeIcon.isThemeIcon(T.defaults)?T.defaults.id:T.id}|${T.description||""}|`);N.push("| preview     | identifier                        "),N.push("| ----------- | --------------------------------- |");for(const T of L.filter(f=>!g.ThemeIcon.isThemeIcon(f.defaults)).sort(b))N.push(`|<i class="${S(T)}"></i>|${T.id}|`);return N.join(`
`)}}const e=new n;m.Registry.add(t.Extensions.IconContribution,e);function s(c,b,S,N){return e.registerIcon(c,b,S,N)}t.registerIcon=s;function a(){return e}t.getIconRegistry=a;function l(){for(const c of i.Codicon.getAll())e.registerIcon(c.id,c.definition,c.description)}l(),t.iconsSchemaId="vscode://schemas/icons";const h=m.Registry.as(d.Extensions.JSONContribution);h.registerSchema(t.iconsSchemaId,e.getIconSchema());const r=new v.RunOnceScheduler(()=>h.notifySchemaChanged(t.iconsSchemaId),200);e.onDidChange(()=>{r.isScheduled()||r.schedule()}),t.widgetClose=s("widget-close",i.Codicon.close,(0,w.localize)(2,null)),t.gotoPreviousLocation=s("goto-previous-location",i.Codicon.arrowUp,(0,w.localize)(3,null)),t.gotoNextLocation=s("goto-next-location",i.Codicon.arrowDown,(0,w.localize)(4,null)),t.syncing=g.ThemeIcon.modify(i.Codicon.sync,"spin"),t.spinningLoading=g.ThemeIcon.modify(i.Codicon.loading,"spin")}),define(me[143],be([1,0,4,3,142,66]),function(Z,t,v,i,z,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=t.getIconsStyleSheet=void 0;function D(d){const m=new i.Emitter,g=(0,z.getIconRegistry)();return g.onDidChange(()=>m.fire()),d?.onDidProductIconThemeChange(()=>m.fire()),{onDidChange:m.event,getCSS(){const I=d?d.getProductIconTheme():new w,o={},n=s=>{const a=I.getIcon(s);if(!a)return;const l=a.font;return l?(o[l.id]=l.definition,`.codicon-${s.id}:before { content: '${a.fontCharacter}'; font-family: ${(0,v.asCSSPropertyValue)(l.id)}; }`):`.codicon-${s.id}:before { content: '${a.fontCharacter}'; }`},e=[];for(const s of g.getIcons()){const a=n(s);a&&e.push(a)}for(const s in o){const a=o[s],l=a.weight?`font-weight: ${a.weight};`:"",h=a.style?`font-style: ${a.style};`:"",r=a.src.map(c=>`${(0,v.asCSSUrl)(c.location)} format('${c.format}')`).join(", ");e.push(`@font-face { src: ${r}; font-family: ${(0,v.asCSSPropertyValue)(s)};${l}${h} font-display: block; }`)}return e.join(`
`)}}}t.getIconsStyleSheet=D;class w{getIcon(m){const g=(0,z.getIconRegistry)();let I=m.defaults;for(;H.ThemeIcon.isThemeIcon(I);){const o=g.getIcon(I.id);if(!o)return;I=o.defaults}return I}}t.UnthemedProductIconTheme=w}),define(me[144],be([1,0,5]),function(Z,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomLevelToZoomFactor=t.useWindowControlsOverlay=t.getTitleBarStyle=t.getMenuBarVisibility=t.isFileToOpen=t.isFolderToOpen=t.isWorkspaceToOpen=t.WindowMinimumSize=void 0,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function i(g){return!!g.workspaceUri}t.isWorkspaceToOpen=i;function z(g){return!!g.folderUri}t.isFolderToOpen=z;function H(g){return!!g.fileUri}t.isFileToOpen=H;function D(g){const I=w(g),o=g.getValue("window.menuBarVisibility");return o==="default"||I==="native"&&o==="compact"||v.isMacintosh&&v.isNative?"classic":o}t.getMenuBarVisibility=D;function w(g){if(v.isWeb)return"custom";const I=g.getValue("window");if(I){if(v.isMacintosh&&I.nativeTabs===!0||v.isMacintosh&&I.nativeFullScreen===!1)return"native";const e=I.titleBarStyle;if(e==="native"||e==="custom")return e}return v.isLinux?"native":"custom"}t.getTitleBarStyle=w;function d(g){if(!v.isWindows||v.isWeb||w(g)==="native")return!1;const I=g.getValue("window.experimental.windowControlsOverlay.enabled");return typeof I=="boolean"?I:!0}t.useWindowControlsOverlay=d;function m(g=0){return Math.pow(1.2,g)}t.zoomLevelToZoomFactor=m}),define(me[145],be([1,0,16,27,144]),function(Z,t,v,i,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomOut=t.zoomIn=t.applyZoom=void 0;function H(d){i.webFrame.setZoomLevel(d),(0,v.setZoomFactor)((0,z.zoomLevelToZoomFactor)(d)),(0,v.setZoomLevel)(d,!1)}t.applyZoom=H;function D(){H((0,v.getZoomLevel)()+1)}t.zoomIn=D;function w(){H((0,v.getZoomLevel)()-1)}t.zoomOut=w}),define(me[146],be([1,0,10,4,129,8,130,27,135,136,137,139,143,145,95,86]),function(Z,t,v,i,z,H,D,w,d,m,g,I,o,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const e=/\s--(inspect|debug)(-brk|port)?=(\d+)?/,s=/\s--(inspect|debug)-port=(\d+)/;class a{getHeight(y){return 22}getTemplateId(y){return L(y)?"process":S(y)?"machine":(0,d.isRemoteDiagnosticError)(y)?"error":N(y)?"header":""}}class l{hasChildren(y){return(0,d.isRemoteDiagnosticError)(y)?!1:L(y)?!!y.children?.length:!0}getChildren(y){return L(y)?y.children?y.children:[]:(0,d.isRemoteDiagnosticError)(y)?[]:N(y)?y.processRoots.length>1?y.processRoots:[y.processRoots[0].rootProcess]:S(y)?[y.rootProcess]:[y.processes]}}class h{constructor(){this.templateId="header"}renderTemplate(y){const _=Object.create(null),V=(0,i.append)(y,(0,i.$)(".row"));return _.name=(0,i.append)(V,(0,i.$)(".nameLabel")),_.CPU=(0,i.append)(V,(0,i.$)(".cpu")),_.memory=(0,i.append)(V,(0,i.$)(".memory")),_.PID=(0,i.append)(V,(0,i.$)(".pid")),_}renderElement(y,_,V,ge){V.name.textContent=(0,v.localize)(0,null),V.CPU.textContent=(0,v.localize)(1,null),V.PID.textContent=(0,v.localize)(2,null),V.memory.textContent=(0,v.localize)(3,null)}disposeTemplate(y){}}class r{constructor(){this.templateId="machine"}renderTemplate(y){const _=Object.create(null),V=(0,i.append)(y,(0,i.$)(".row"));return _.name=(0,i.append)(V,(0,i.$)(".nameLabel")),_}renderElement(y,_,V,ge){V.name.textContent=y.element.name}disposeTemplate(y){}}class c{constructor(){this.templateId="error"}renderTemplate(y){const _=Object.create(null),V=(0,i.append)(y,(0,i.$)(".row"));return _.name=(0,i.append)(V,(0,i.$)(".nameLabel")),_}renderElement(y,_,V,ge){V.name.textContent=y.element.errorMessage}disposeTemplate(y){}}class b{constructor(y,_,V){this.a=y,this.b=_,this.c=V,this.templateId="process"}renderTemplate(y){const _=Object.create(null),V=(0,i.append)(y,(0,i.$)(".row"));return _.name=(0,i.append)(V,(0,i.$)(".nameLabel")),_.CPU=(0,i.append)(V,(0,i.$)(".cpu")),_.memory=(0,i.append)(V,(0,i.$)(".memory")),_.PID=(0,i.append)(V,(0,i.$)(".pid")),_}renderElement(y,_,V,ge){const{element:Q}=y;let ie=Q.name;ie==="window"&&(ie=this.c.get(Q.pid)!==void 0?`${ie} (${this.c.get(Q.pid)})`:ie);const te=Q.pid.toFixed(0);V.name.textContent=ie,V.name.title=Q.cmd,V.CPU.textContent=Q.load.toFixed(0),V.PID.textContent=te,V.PID.parentElement.id=`pid-${te}`;const ue=this.a==="win32"?Q.mem:this.b*(Q.mem/100);V.memory.textContent=(ue/m.ByteSize.MB).toFixed(0)}disposeTemplate(y){}}function S(p){return!!p.name&&!!p.rootProcess}function N(p){return!!p.processRoots}function L(p){return!!p.pid}class T{constructor(y,_){this.f=_,this.b=new Map;const V=new g.ElectronIPCMainProcessService(y);this.c=new I.NativeHostService(y,V),this.k(_.styles),this.g(_),w.ipcRenderer.on("vscode:windowsInfoResponse",(ge,Q)=>{this.b=new Map,Q.forEach(ie=>this.b.set(ie.pid,ie.title))}),w.ipcRenderer.on("vscode:listProcessesResponse",async(ge,Q)=>{Q.forEach((ie,te)=>{L(ie.rootProcess)&&(ie.rootProcess.name=te===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:Q}}),this.d.layout(window.innerHeight,window.innerWidth)):await this.h(Q),this.m(0)}),this.a=Date.now(),w.ipcRenderer.send("vscode:windowsInfoRequest"),w.ipcRenderer.send("vscode:listProcesses")}g(y){document.onkeydown=_=>{const V=y.platform==="darwin"?_.metaKey:_.ctrlKey;V&&_.keyCode===87&&(_.stopPropagation(),_.preventDefault(),w.ipcRenderer.send("vscode:closeProcessExplorer")),V&&_.keyCode===187&&(0,n.zoomIn)(),V&&_.keyCode===189&&(0,n.zoomOut)()}}async h(y){const _=document.getElementById("process-list");if(!_)return;const{totalmem:V}=await this.c.getOSStatistics(),ge=[new b(this.f.platform,V,this.b),new h,new r,new c];this.d=new z.DataTree("processExplorer",_,new a,ge,new l,{identityProvider:{getId:Q=>L(Q)?Q.pid.toString():(0,d.isRemoteDiagnosticError)(Q)?Q.hostName:N(Q)?"processes":S(Q)?Q.name:"header"}}),this.d.setInput({processes:{processRoots:y}}),this.d.layout(window.innerHeight,window.innerWidth),this.d.onContextMenu(Q=>{L(Q.element)&&this.l(Q.element,!0)}),_.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{_.style.height=`${window.innerHeight}px`,this.d?.layout(window.innerHeight,window.innerWidth)})}i(y){const _=e.exec(y);return _&&_.length>=2||y.indexOf("node ")>=0||y.indexOf("node.exe")>=0}j(y){const _={type:"node",request:"attach",name:`process ${y.pid}`};let V=e.exec(y.cmd);V&&V.length>=2?(V.length===4&&V[3]&&(_.port=parseInt(V[3])),_.protocol=V[1]==="debug"?"legacy":"inspector"):_.processId=String(y.pid),V=s.exec(y.cmd),V&&V.length===3&&(_.port=parseInt(V[2])),w.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[_]})}k(y){const _=(0,i.createStyleSheet)(),V=[];y.listFocusBackground&&(V.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${y.listFocusBackground}; }`),V.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${y.listFocusBackground}; }`)),y.listFocusForeground&&V.push(`.monaco-list:focus .monaco-list-row.focused { color: ${y.listFocusForeground}; }`),y.listActiveSelectionBackground&&(V.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${y.listActiveSelectionBackground}; }`),V.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${y.listActiveSelectionBackground}; }`)),y.listActiveSelectionForeground&&V.push(`.monaco-list:focus .monaco-list-row.selected { color: ${y.listActiveSelectionForeground}; }`),y.listHoverBackground&&V.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${y.listHoverBackground}; }`),y.listHoverForeground&&V.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${y.listHoverForeground}; }`),y.listFocusOutline&&V.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${y.listFocusOutline}; outline-offset: -1px; }`),y.listHoverOutline&&V.push(`.monaco-list-row:hover { outline: 1px dashed ${y.listHoverOutline}; outline-offset: -1px; }`),y.scrollbarShadowColor&&V.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${y.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${y.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${y.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),y.scrollbarSliderBackgroundColor&&V.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${y.scrollbarSliderBackgroundColor};
				}
			`),y.scrollbarSliderHoverBackgroundColor&&V.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${y.scrollbarSliderHoverBackgroundColor};
				}
			`),y.scrollbarSliderActiveBackgroundColor&&V.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${y.scrollbarSliderActiveBackgroundColor};
				}
			`),_.textContent=V.join(`
`),y.color&&(document.body.style.color=y.color)}l(y,_){const V=[],ge=Number(y.pid);_&&(V.push({label:(0,v.localize)(4,null),click:()=>{this.c.killProcess(ge,"SIGTERM")}}),V.push({label:(0,v.localize)(5,null),click:()=>{this.c.killProcess(ge,"SIGKILL")}}),V.push({type:"separator"})),V.push({label:(0,v.localize)(6,null),click:()=>{const Q=this.d?.getSelection()?.map(te=>{if(!(!te||!("pid"in te)))return te.pid}).filter(te=>!!te);Q?.includes(ge)||(Q.length=0,Q.push(ge));const ie=Q?.map(te=>document.getElementById(`pid-${te}`)).filter(te=>!!te);if(ie){const te=ie.map(ue=>ue.innerText).filter(ue=>!!ue);this.c.writeClipboardText(te.join(`
`))}}}),V.push({label:(0,v.localize)(7,null),click:()=>{const Q=document.getElementById("process-list");Q&&this.c.writeClipboardText(Q.innerText)}}),y&&_&&this.i(y.cmd)&&(V.push({type:"separator"}),V.push({label:(0,v.localize)(8,null),click:()=>{this.j(y)}})),(0,D.popup)(V)}m(y){setTimeout(()=>{const _=Date.now(),V=y+_-this.a;this.a=_,V>1e3?(w.ipcRenderer.send("vscode:windowsInfoRequest"),w.ipcRenderer.send("vscode:listProcesses")):this.m(V)},200)}}function f(){const p=(0,i.createStyleSheet)();p.id="codiconStyles";const y=(0,o.getIconsStyleSheet)(void 0);function _(){p.textContent=y.getCSS()}const V=new H.RunOnceScheduler(_,0);y.onDidChange(()=>V.schedule()),V.schedule()}function C(p){const y=p.data.platform==="win32"?"windows":p.data.platform==="linux"?"linux":"mac";document.body.classList.add(y),f(),(0,n.applyZoom)(p.data.zoomLevel),new T(p.windowId,p.data)}t.startup=C})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d7b1e2a1c892511a125e4ceb9758ec8ddf907775/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
