/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/event","vs/base/common/types","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/path","vs/base/common/buffer","vs/base/common/network","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/userDataProfile/common/userDataProfile","vs/platform/product/common/productService","vs/platform/extensions/common/extensions","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/common/uuid","vs/base/common/strings","vs/platform/telemetry/common/telemetry","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/policy/common/policy","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/stream","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/hash","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","crypto","vs/platform/environment/node/argvHelper","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Q=function(W){for(var e=[],T=0,D=W.length;T<D;T++)e[T]=Z[W[T]];return e};define(Z[49],Q([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function T(N){return(S,g,u)=>{let y=null,v=null;if(typeof u.value=="function"?(y="value",v=u.value):typeof u.get=="function"&&(y="get",v=u.get),!v)throw new Error("not supported");u[y]=N(v,g)}}function D(N,S,g){let u=null,y=null;if(typeof g.value=="function"?(u="value",y=g.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(u="get",y=g.get),!y)throw new Error("not supported");const v=`$memoize$${S}`;g[u]=function(...m){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,m)}),this[v]}}e.memoize=D;function k(N,S,g){return T((u,y)=>{const v=`$debounce$${y}`,m=`$debounce$result$${y}`;return function(...b){this[m]||(this[m]=g?g():void 0),clearTimeout(this[v]),S&&(this[m]=S(this[m],...b),b=[this[m]]),this[v]=setTimeout(()=>{u.apply(this,b),this[m]=g?g():void 0},N)}})}e.debounce=k;function L(N,S,g){return T((u,y)=>{const v=`$throttle$timer$${y}`,m=`$throttle$result$${y}`,b=`$throttle$lastRun$${y}`,p=`$throttle$pending$${y}`;return function(...O){if(this[m]||(this[m]=g?g():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),S&&(this[m]=S(this[m],...O)),this[p])return;const E=this[b]+N;E<=Date.now()?(this[b]=Date.now(),u.apply(this,[this[m]]),this[m]=g?g():void 0):(this[p]=!0,this[v]=setTimeout(()=>{this[p]=!1,this[b]=Date.now(),u.apply(this,[this[m]]),this[m]=g?g():void 0},E-Date.now()))}})}e.throttle=L}),define(Z[70],Q([0,1,10]),function(W,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function D(g,u){if(!g)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}e.ok=D;function k(g,u="Unreachable"){throw new Error(u)}e.assertNever=k;function L(g){if(!g)throw new T.BugIndicatingError("Assertion Failed")}e.assert=L;function N(g){if(!g()){debugger;g(),(0,T.onUnexpectedError)(new T.BugIndicatingError("Assertion Failed"))}}e.assertFn=N;function S(g,u){let y=0;for(;y<g.length-1;){const v=g[y],m=g[y+1];if(!u(v,m))return!1;y++}return!0}e.checkAdjacentItems=S}),define(Z[50],Q([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var T;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(T=e.ScanError||(e.ScanError={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function N(t,n=!1){let i=0;const r=t.length;let o="",c=0,a=16,h=0;function R(_){let pe=0,le=0;for(;pe<_;){const ae=t.charCodeAt(i);if(ae>=48&&ae<=57)le=le*16+ae-48;else if(ae>=65&&ae<=70)le=le*16+ae-65+10;else if(ae>=97&&ae<=102)le=le*16+ae-97+10;else break;i++,pe++}return pe<_&&(le=-1),le}function C(_){i=_,o="",c=0,a=16,h=0}function x(){const _=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&u(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&u(t.charCodeAt(i)))for(i++;i<t.length&&u(t.charCodeAt(i));)i++;else return h=3,t.substring(_,i);let pe=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&u(t.charCodeAt(i))){for(i++;i<t.length&&u(t.charCodeAt(i));)i++;pe=i}else h=3;return t.substring(_,pe)}function Y(){let _="",pe=i;for(;;){if(i>=r){_+=t.substring(pe,i),h=2;break}const le=t.charCodeAt(i);if(le===34){_+=t.substring(pe,i),i++;break}if(le===92){if(_+=t.substring(pe,i),i++,i>=r){h=2;break}switch(t.charCodeAt(i++)){case 34:_+='"';break;case 92:_+="\\";break;case 47:_+="/";break;case 98:_+="\b";break;case 102:_+="\f";break;case 110:_+=`
`;break;case 114:_+="\r";break;case 116:_+="	";break;case 117:{const he=R(4);he>=0?_+=String.fromCharCode(he):h=4;break}default:h=5}pe=i;continue}if(le>=0&&le<=31)if(g(le)){_+=t.substring(pe,i),h=2;break}else h=6;i++}return _}function X(){if(o="",h=0,c=i,i>=r)return c=r,a=17;let _=t.charCodeAt(i);if(S(_)){do i++,o+=String.fromCharCode(_),_=t.charCodeAt(i);while(S(_));return a=15}if(g(_))return i++,o+=String.fromCharCode(_),_===13&&t.charCodeAt(i)===10&&(i++,o+=`
`),a=14;switch(_){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,o=Y(),a=10;case 47:{const pe=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<r&&!g(t.charCodeAt(i));)i++;return o=t.substring(pe,i),a=12}if(t.charCodeAt(i+1)===42){i+=2;const le=r-1;let ae=!1;for(;i<le;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,ae=!0;break}i++}return ae||(i++,h=1),o=t.substring(pe,i),a=13}return o+=String.fromCharCode(_),i++,a=16}case 45:if(o+=String.fromCharCode(_),i++,i===r||!u(t.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=x(),a=11;default:for(;i<r&&ie(_);)i++,_=t.charCodeAt(i);if(c!==i){switch(o=t.substring(c,i),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode(_),i++,a=16}}function ie(_){if(S(_)||g(_))return!1;switch(_){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let _;do _=X();while(_>=12&&_<=15);return _}return{setPosition:C,getPosition:()=>i,scan:n?re:X,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>c,getTokenLength:()=>i-c,getTokenError:()=>h}}e.createScanner=N;function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function u(t){return t>=48&&t<=57}var y;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(y||(y={}));function v(t,n){const i=[],r=new Object;let o;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function h(R,C,x,Y){c.value=R,c.offset=C,c.length=x,c.type=Y,c.colonOffset=void 0,o=c}try{w(t,{onObjectBegin:(R,C)=>{if(n<=R)throw r;o=void 0,a=n>R,i.push("")},onObjectProperty:(R,C,x)=>{if(n<C||(h(R,C,x,"property"),i[i.length-1]=R,n<=C+x))throw r},onObjectEnd:(R,C)=>{if(n<=R)throw r;o=void 0,i.pop()},onArrayBegin:(R,C)=>{if(n<=R)throw r;o=void 0,i.push(0)},onArrayEnd:(R,C)=>{if(n<=R)throw r;o=void 0,i.pop()},onLiteralValue:(R,C,x)=>{if(n<C||(h(R,C,x,s(R)),n<=C+x))throw r},onSeparator:(R,C,x)=>{if(n<=C)throw r;if(R===":"&&o&&o.type==="property")o.colonOffset=C,a=!1,o=void 0;else if(R===","){const Y=i[i.length-1];typeof Y=="number"?i[i.length-1]=Y+1:(a=!0,i[i.length-1]=""),o=void 0}}})}catch(R){if(R!==r)throw R}return{path:i,previousNode:o,isAtPropertyKey:a,matches:R=>{let C=0;for(let x=0;C<R.length&&x<i.length;x++)if(R[C]===i[x]||R[C]==="*")C++;else if(R[C]!=="**")return!1;return C===R.length}}}e.getLocation=v;function m(t,n=[],i=L.DEFAULT){let r=null,o=[];const c=[];function a(R){Array.isArray(o)?o.push(R):r!==null&&(o[r]=R)}return w(t,{onObjectBegin:()=>{const R={};a(R),c.push(o),o=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const R=[];a(R),c.push(o),o=R,r=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:a,onError:(R,C,x)=>{n.push({error:R,offset:C,length:x})}},i),o[0]}e.parse=m;function b(t,n=[],i=L.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(R){r.type==="property"&&(r.length=R-r.offset,r=r.parent)}function c(R){return r.children.push(R),R}w(t,{onObjectBegin:R=>{r=c({type:"object",offset:R,length:-1,parent:r,children:[]})},onObjectProperty:(R,C,x)=>{r=c({type:"property",offset:C,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:R,offset:C,length:x,parent:r})},onObjectEnd:(R,C)=>{r.length=R+C-r.offset,r=r.parent,o(R+C)},onArrayBegin:(R,C)=>{r=c({type:"array",offset:R,length:-1,parent:r,children:[]})},onArrayEnd:(R,C)=>{r.length=R+C-r.offset,r=r.parent,o(R+C)},onLiteralValue:(R,C,x)=>{c({type:s(R),offset:C,length:x,parent:r,value:R}),o(C+x)},onSeparator:(R,C,x)=>{r.type==="property"&&(R===":"?r.colonOffset=C:R===","&&o(C))},onError:(R,C,x)=>{n.push({error:R,offset:C,length:x})}},i);const h=r.children[0];return h&&delete h.parent,h}e.parseTree=b;function p(t,n){if(!t)return;let i=t;for(const r of n)if(typeof r=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const c of i.children)if(Array.isArray(c.children)&&c.children[0].value===r){i=c.children[1],o=!0;break}if(!o)return}else{const o=r;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=p;function O(t){if(!t.parent||!t.parent.children)return[];const n=O(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;n.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&n.push(i)}return n}e.getNodePath=O;function E(t){switch(t.type){case"array":return t.children.map(E);case"object":{const n=Object.create(null);for(const i of t.children){const r=i.children[1];r&&(n[i.children[0].value]=E(r))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=E;function l(t,n,i=!1){return n>=t.offset&&n<t.offset+t.length||i&&n===t.offset+t.length}e.contains=l;function d(t,n,i=!1){if(l(t,n,i)){const r=t.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const c=d(r[o],n,i);if(c)return c}return t}}e.findNodeAtOffset=d;function w(t,n,i=L.DEFAULT){const r=N(t,!1);function o(q){return q?()=>q(r.getTokenOffset(),r.getTokenLength()):()=>!0}function c(q){return q?K=>q(K,r.getTokenOffset(),r.getTokenLength()):()=>!0}const a=o(n.onObjectBegin),h=c(n.onObjectProperty),R=o(n.onObjectEnd),C=o(n.onArrayBegin),x=o(n.onArrayEnd),Y=c(n.onLiteralValue),X=c(n.onSeparator),ie=o(n.onComment),re=c(n.onError),_=i&&i.disallowComments,pe=i&&i.allowTrailingComma;function le(){for(;;){const q=r.scan();switch(r.getTokenError()){case 4:ae(14);break;case 5:ae(15);break;case 3:ae(13);break;case 1:_||ae(11);break;case 2:ae(12);break;case 6:ae(16);break}switch(q){case 12:case 13:_?ae(10):ie();break;case 16:ae(1);break;case 15:case 14:break;default:return q}}}function ae(q,K=[],I=[]){if(re(q),K.length+I.length>0){let P=r.getToken();for(;P!==17;){if(K.indexOf(P)!==-1){le();break}else if(I.indexOf(P)!==-1)break;P=le()}}}function he(q){const K=r.getTokenValue();return q?Y(K):h(K),le(),!0}function B(){switch(r.getToken()){case 11:{let q=0;try{q=JSON.parse(r.getTokenValue()),typeof q!="number"&&(ae(2),q=0)}catch{ae(2)}Y(q);break}case 7:Y(null);break;case 8:Y(!0);break;case 9:Y(!1);break;default:return!1}return le(),!0}function j(){return r.getToken()!==10?(ae(3,[],[2,5]),!1):(he(!1),r.getToken()===6?(X(":"),le(),$()||ae(4,[],[2,5])):ae(5,[],[2,5]),!0)}function A(){a(),le();let q=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(q||ae(4,[],[]),X(","),le(),r.getToken()===2&&pe)break}else q&&ae(6,[],[]);j()||ae(4,[],[2,5]),q=!0}return R(),r.getToken()!==2?ae(7,[2],[]):le(),!0}function z(){C(),le();let q=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(q||ae(4,[],[]),X(","),le(),r.getToken()===4&&pe)break}else q&&ae(6,[],[]);$()||ae(4,[],[4,5]),q=!0}return x(),r.getToken()!==4?ae(8,[4],[]):le(),!0}function $(){switch(r.getToken()){case 3:return z();case 1:return A();case 10:return he(!0);default:return B()}}return le(),r.getToken()===17?i.allowEmptyContent?!0:(ae(4,[],[]),!1):$()?(r.getToken()!==17&&ae(9,[],[]),!0):(ae(4,[],[]),!1)}e.visit=w;function f(t,n){const i=N(t),r=[];let o,c=0,a;do switch(a=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:c!==a&&r.push(t.substring(c,a)),n!==void 0&&r.push(i.getTokenValue().replace(/[^\r\n]/g,n)),c=i.getPosition();break}while(o!==17);return r.join("")}e.stripComments=f;function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),function(){function W(k){const L=[];typeof k=="number"&&L.push("code/timeOrigin",k);function N(g){L.push(g,Date.now())}function S(){const g=[];for(let u=0;u<L.length;u+=2)g.push({name:L[u],startTime:L[u+1]});return g}return{mark:N,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?W():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const N of performance.getEntriesByType("mark"))L.push({name:N.name,startTime:Math.round(k+N.startTime)});return L}};if(typeof process=="object"){const k=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return W(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),W()}function T(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=T(D))}(),function(W,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var T=e();for(var D in T)(typeof exports=="object"?exports:W)[D]=T[D]}}(typeof self<"u"?self:this,function(){return function(W){var e={};function T(D){if(e[D])return e[D].exports;var k=e[D]={i:D,l:!1,exports:{}};return W[D].call(k.exports,k,k.exports,T),k.l=!0,k.exports}return T.m=W,T.c=e,T.d=function(D,k,L){T.o(D,k)||Object.defineProperty(D,k,{enumerable:!0,get:L})},T.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},T.t=function(D,k){if(1&k&&(D=T(D)),8&k||4&k&&typeof D=="object"&&D&&D.__esModule)return D;var L=Object.create(null);if(T.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:D}),2&k&&typeof D!="string")for(var N in D)T.d(L,N,function(S){return D[S]}.bind(null,N));return L},T.n=function(D){var k=D&&D.__esModule?function(){return D.default}:function(){return D};return T.d(k,"a",k),k},T.o=function(D,k){return Object.prototype.hasOwnProperty.call(D,k)},T.p="",T(T.s=0)}([function(W,e,T){(function(D){var k;e=W.exports=I,k=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var U=Array.prototype.slice.call(arguments,0);U.unshift("SEMVER"),console.log.apply(console,U)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],g=e.src=[],u=0,y=u++;g[y]="0|[1-9]\\d*";var v=u++;g[v]="[0-9]+";var m=u++;g[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=u++;g[b]="("+g[y]+")\\.("+g[y]+")\\.("+g[y]+")";var p=u++;g[p]="("+g[v]+")\\.("+g[v]+")\\.("+g[v]+")";var O=u++;g[O]="(?:"+g[y]+"|"+g[m]+")";var E=u++;g[E]="(?:"+g[v]+"|"+g[m]+")";var l=u++;g[l]="(?:-("+g[O]+"(?:\\."+g[O]+")*))";var d=u++;g[d]="(?:-?("+g[E]+"(?:\\."+g[E]+")*))";var w=u++;g[w]="[0-9A-Za-z-]+";var f=u++;g[f]="(?:\\+("+g[w]+"(?:\\."+g[w]+")*))";var s=u++,t="v?"+g[b]+g[l]+"?"+g[f]+"?";g[s]="^"+t+"$";var n="[v=\\s]*"+g[p]+g[d]+"?"+g[f]+"?",i=u++;g[i]="^"+n+"$";var r=u++;g[r]="((?:<|>)?=?)";var o=u++;g[o]=g[v]+"|x|X|\\*";var c=u++;g[c]=g[y]+"|x|X|\\*";var a=u++;g[a]="[v=\\s]*("+g[c]+")(?:\\.("+g[c]+")(?:\\.("+g[c]+")(?:"+g[l]+")?"+g[f]+"?)?)?";var h=u++;g[h]="[v=\\s]*("+g[o]+")(?:\\.("+g[o]+")(?:\\.("+g[o]+")(?:"+g[d]+")?"+g[f]+"?)?)?";var R=u++;g[R]="^"+g[r]+"\\s*"+g[a]+"$";var C=u++;g[C]="^"+g[r]+"\\s*"+g[h]+"$";var x=u++;g[x]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Y=u++;g[Y]="(?:~>?)";var X=u++;g[X]="(\\s*)"+g[Y]+"\\s+",S[X]=new RegExp(g[X],"g");var ie=u++;g[ie]="^"+g[Y]+g[a]+"$";var re=u++;g[re]="^"+g[Y]+g[h]+"$";var _=u++;g[_]="(?:\\^)";var pe=u++;g[pe]="(\\s*)"+g[_]+"\\s+",S[pe]=new RegExp(g[pe],"g");var le=u++;g[le]="^"+g[_]+g[a]+"$";var ae=u++;g[ae]="^"+g[_]+g[h]+"$";var he=u++;g[he]="^"+g[r]+"\\s*("+n+")$|^$";var B=u++;g[B]="^"+g[r]+"\\s*("+t+")$|^$";var j=u++;g[j]="(\\s*)"+g[r]+"\\s*("+n+"|"+g[a]+")",S[j]=new RegExp(g[j],"g");var A=u++;g[A]="^\\s*("+g[a]+")\\s+-\\s+("+g[a]+")\\s*$";var z=u++;g[z]="^\\s*("+g[h]+")\\s+-\\s+("+g[h]+")\\s*$";var $=u++;g[$]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)k(q,g[q]),S[q]||(S[q]=new RegExp(g[q]));function K(U,H){if(U instanceof I)return U;if(typeof U!="string"||U.length>L||!(H?S[i]:S[s]).test(U))return null;try{return new I(U,H)}catch{return null}}function I(U,H){if(U instanceof I){if(U.loose===H)return U;U=U.version}else if(typeof U!="string")throw new TypeError("Invalid Version: "+U);if(U.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof I))return new I(U,H);k("SemVer",U,H),this.loose=H;var J=U.trim().match(H?S[i]:S[s]);if(!J)throw new TypeError("Invalid Version: "+U);if(this.raw=U,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(de){if(/^[0-9]+$/.test(de)){var ve=+de;if(ve>=0&&ve<N)return ve}return de}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}e.parse=K,e.valid=function(U,H){var J=K(U,H);return J?J.version:null},e.clean=function(U,H){var J=K(U.trim().replace(/^[=v]+/,""),H);return J?J.version:null},e.SemVer=I,I.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},I.prototype.toString=function(){return this.version},I.prototype.compare=function(U){return k("SemVer.compare",this.version,this.loose,U),U instanceof I||(U=new I(U,this.loose)),this.compareMain(U)||this.comparePre(U)},I.prototype.compareMain=function(U){return U instanceof I||(U=new I(U,this.loose)),M(this.major,U.major)||M(this.minor,U.minor)||M(this.patch,U.patch)},I.prototype.comparePre=function(U){if(U instanceof I||(U=new I(U,this.loose)),this.prerelease.length&&!U.prerelease.length)return-1;if(!this.prerelease.length&&U.prerelease.length)return 1;if(!this.prerelease.length&&!U.prerelease.length)return 0;var H=0;do{var J=this.prerelease[H],de=U.prerelease[H];if(k("prerelease compare",H,J,de),J===void 0&&de===void 0)return 0;if(de===void 0)return 1;if(J===void 0)return-1;if(J!==de)return M(J,de)}while(++H)},I.prototype.inc=function(U,H){switch(U){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+U)}return this.format(),this.raw=this.version,this},e.inc=function(U,H,J,de){typeof J=="string"&&(de=J,J=void 0);try{return new I(U,J).inc(H,de).version}catch{return null}},e.diff=function(U,H){if(te(U,H))return null;var J=K(U),de=K(H);if(J.prerelease.length||de.prerelease.length){for(var ve in J)if((ve==="major"||ve==="minor"||ve==="patch")&&J[ve]!==de[ve])return"pre"+ve;return"prerelease"}for(var ve in J)if((ve==="major"||ve==="minor"||ve==="patch")&&J[ve]!==de[ve])return ve},e.compareIdentifiers=M;var P=/^[0-9]+$/;function M(U,H){var J=P.test(U),de=P.test(H);return J&&de&&(U=+U,H=+H),J&&!de?-1:de&&!J?1:U<H?-1:U>H?1:0}function F(U,H,J){return new I(U,J).compare(new I(H,J))}function V(U,H,J){return F(U,H,J)>0}function G(U,H,J){return F(U,H,J)<0}function te(U,H,J){return F(U,H,J)===0}function ne(U,H,J){return F(U,H,J)!==0}function ge(U,H,J){return F(U,H,J)>=0}function ye(U,H,J){return F(U,H,J)<=0}function ue(U,H,J,de){var ve;switch(H){case"===":typeof U=="object"&&(U=U.version),typeof J=="object"&&(J=J.version),ve=U===J;break;case"!==":typeof U=="object"&&(U=U.version),typeof J=="object"&&(J=J.version),ve=U!==J;break;case"":case"=":case"==":ve=te(U,J,de);break;case"!=":ve=ne(U,J,de);break;case">":ve=V(U,J,de);break;case">=":ve=ge(U,J,de);break;case"<":ve=G(U,J,de);break;case"<=":ve=ye(U,J,de);break;default:throw new TypeError("Invalid operator: "+H)}return ve}function ce(U,H){if(U instanceof ce){if(U.loose===H)return U;U=U.value}if(!(this instanceof ce))return new ce(U,H);k("comparator",U,H),this.loose=H,this.parse(U),this.semver===oe?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(U,H){return M(H,U)},e.major=function(U,H){return new I(U,H).major},e.minor=function(U,H){return new I(U,H).minor},e.patch=function(U,H){return new I(U,H).patch},e.compare=F,e.compareLoose=function(U,H){return F(U,H,!0)},e.rcompare=function(U,H,J){return F(H,U,J)},e.sort=function(U,H){return U.sort(function(J,de){return e.compare(J,de,H)})},e.rsort=function(U,H){return U.sort(function(J,de){return e.rcompare(J,de,H)})},e.gt=V,e.lt=G,e.eq=te,e.neq=ne,e.gte=ge,e.lte=ye,e.cmp=ue,e.Comparator=ce;var oe={};function se(U,H){if(U instanceof se)return U.loose===H?U:new se(U.raw,H);if(U instanceof ce)return new se(U.value,H);if(!(this instanceof se))return new se(U,H);if(this.loose=H,this.raw=U,this.set=U.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+U);this.format()}function fe(U){return!U||U.toLowerCase()==="x"||U==="*"}function Te(U,H,J,de,ve,Re,Se,Le,Pe,Oe,je,Ie,Ne){return((H=fe(J)?"":fe(de)?">="+J+".0.0":fe(ve)?">="+J+"."+de+".0":">="+H)+" "+(Le=fe(Pe)?"":fe(Oe)?"<"+(+Pe+1)+".0.0":fe(je)?"<"+Pe+"."+(+Oe+1)+".0":Ie?"<="+Pe+"."+Oe+"."+je+"-"+Ie:"<="+Le)).trim()}function Fe(U,H){for(var J=0;J<U.length;J++)if(!U[J].test(H))return!1;if(H.prerelease.length){for(J=0;J<U.length;J++)if(k(U[J].semver),U[J].semver!==oe&&U[J].semver.prerelease.length>0){var de=U[J].semver;if(de.major===H.major&&de.minor===H.minor&&de.patch===H.patch)return!0}return!1}return!0}function De(U,H,J){try{H=new se(H,J)}catch{return!1}return H.test(U)}function Me(U,H,J,de){var ve,Re,Se,Le,Pe;switch(U=new I(U,de),H=new se(H,de),J){case">":ve=V,Re=ye,Se=G,Le=">",Pe=">=";break;case"<":ve=G,Re=ge,Se=V,Le="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(De(U,H,de))return!1;for(var Oe=0;Oe<H.set.length;++Oe){var je=H.set[Oe],Ie=null,Ne=null;if(je.forEach(function(Ce){Ce.semver===oe&&(Ce=new ce(">=0.0.0")),Ie=Ie||Ce,Ne=Ne||Ce,ve(Ce.semver,Ie.semver,de)?Ie=Ce:Se(Ce.semver,Ne.semver,de)&&(Ne=Ce)}),Ie.operator===Le||Ie.operator===Pe||(!Ne.operator||Ne.operator===Le)&&Re(U,Ne.semver)||Ne.operator===Pe&&Se(U,Ne.semver))return!1}return!0}ce.prototype.parse=function(U){var H=this.loose?S[he]:S[B],J=U.match(H);if(!J)throw new TypeError("Invalid comparator: "+U);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new I(J[2],this.loose):this.semver=oe},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(U){return k("Comparator.test",U,this.loose),this.semver===oe||(typeof U=="string"&&(U=new I(U,this.loose)),ue(U,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(U,H){if(!(U instanceof ce))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new se(U.value,H),De(this.value,J,H);if(U.operator==="")return J=new se(this.value,H),De(U.semver,J,H);var de=!(this.operator!==">="&&this.operator!==">"||U.operator!==">="&&U.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||U.operator!=="<="&&U.operator!=="<"),Re=this.semver.version===U.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||U.operator!==">="&&U.operator!=="<="),Le=ue(this.semver,"<",U.semver,H)&&(this.operator===">="||this.operator===">")&&(U.operator==="<="||U.operator==="<"),Pe=ue(this.semver,">",U.semver,H)&&(this.operator==="<="||this.operator==="<")&&(U.operator===">="||U.operator===">");return de||ve||Re&&Se||Le||Pe},e.Range=se,se.prototype.format=function(){return this.range=this.set.map(function(U){return U.join(" ").trim()}).join("||").trim(),this.range},se.prototype.toString=function(){return this.range},se.prototype.parseRange=function(U){var H=this.loose;U=U.trim(),k("range",U,H);var J=H?S[z]:S[A];U=U.replace(J,Te),k("hyphen replace",U),U=U.replace(S[j],"$1$2$3"),k("comparator trim",U,S[j]),U=(U=(U=U.replace(S[X],"$1~")).replace(S[pe],"$1^")).split(/\s+/).join(" ");var de=H?S[he]:S[B],ve=U.split(" ").map(function(Re){return function(Se,Le){return k("comp",Se),Se=function(Pe,Oe){return Pe.trim().split(/\s+/).map(function(je){return function(Ie,Ne){k("caret",Ie,Ne);var Ce=Ne?S[ae]:S[le];return Ie.replace(Ce,function(Ue,we,Ee,be,ke){var Ae;return k("caret",Ie,Ue,we,Ee,be,ke),fe(we)?Ae="":fe(Ee)?Ae=">="+we+".0.0 <"+(+we+1)+".0.0":fe(be)?Ae=we==="0"?">="+we+"."+Ee+".0 <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+".0 <"+(+we+1)+".0.0":ke?(k("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Ae=we==="0"?Ee==="0"?">="+we+"."+Ee+"."+be+ke+" <"+we+"."+Ee+"."+(+be+1):">="+we+"."+Ee+"."+be+ke+" <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+"."+be+ke+" <"+(+we+1)+".0.0"):(k("no pr"),Ae=we==="0"?Ee==="0"?">="+we+"."+Ee+"."+be+" <"+we+"."+Ee+"."+(+be+1):">="+we+"."+Ee+"."+be+" <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+"."+be+" <"+(+we+1)+".0.0"),k("caret return",Ae),Ae})}(je,Oe)}).join(" ")}(Se,Le),k("caret",Se),Se=function(Pe,Oe){return Pe.trim().split(/\s+/).map(function(je){return function(Ie,Ne){var Ce=Ne?S[re]:S[ie];return Ie.replace(Ce,function(Ue,we,Ee,be,ke){var Ae;return k("tilde",Ie,Ue,we,Ee,be,ke),fe(we)?Ae="":fe(Ee)?Ae=">="+we+".0.0 <"+(+we+1)+".0.0":fe(be)?Ae=">="+we+"."+Ee+".0 <"+we+"."+(+Ee+1)+".0":ke?(k("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Ae=">="+we+"."+Ee+"."+be+ke+" <"+we+"."+(+Ee+1)+".0"):Ae=">="+we+"."+Ee+"."+be+" <"+we+"."+(+Ee+1)+".0",k("tilde return",Ae),Ae})}(je,Oe)}).join(" ")}(Se,Le),k("tildes",Se),Se=function(Pe,Oe){return k("replaceXRanges",Pe,Oe),Pe.split(/\s+/).map(function(je){return function(Ie,Ne){Ie=Ie.trim();var Ce=Ne?S[C]:S[R];return Ie.replace(Ce,function(Ue,we,Ee,be,ke,Ae){k("xRange",Ie,Ue,we,Ee,be,ke,Ae);var We=fe(Ee),ze=We||fe(be),Be=ze||fe(ke);return we==="="&&Be&&(we=""),We?Ue=we===">"||we==="<"?"<0.0.0":"*":we&&Be?(ze&&(be=0),Be&&(ke=0),we===">"?(we=">=",ze?(Ee=+Ee+1,be=0,ke=0):Be&&(be=+be+1,ke=0)):we==="<="&&(we="<",ze?Ee=+Ee+1:be=+be+1),Ue=we+Ee+"."+be+"."+ke):ze?Ue=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Be&&(Ue=">="+Ee+"."+be+".0 <"+Ee+"."+(+be+1)+".0"),k("xRange return",Ue),Ue})}(je,Oe)}).join(" ")}(Se,Le),k("xrange",Se),Se=function(Pe,Oe){return k("replaceStars",Pe,Oe),Pe.trim().replace(S[$],"")}(Se,Le),k("stars",Se),Se}(Re,H)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(Re){return!!Re.match(de)})),ve=ve.map(function(Re){return new ce(Re,H)})},se.prototype.intersects=function(U,H){if(!(U instanceof se))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(de){return U.set.some(function(ve){return ve.every(function(Re){return de.intersects(Re,H)})})})})},e.toComparators=function(U,H){return new se(U,H).set.map(function(J){return J.map(function(de){return de.value}).join(" ").trim().split(" ")})},se.prototype.test=function(U){if(!U)return!1;typeof U=="string"&&(U=new I(U,this.loose));for(var H=0;H<this.set.length;H++)if(Fe(this.set[H],U))return!0;return!1},e.satisfies=De,e.maxSatisfying=function(U,H,J){var de=null,ve=null;try{var Re=new se(H,J)}catch{return null}return U.forEach(function(Se){Re.test(Se)&&(de&&ve.compare(Se)!==-1||(ve=new I(de=Se,J)))}),de},e.minSatisfying=function(U,H,J){var de=null,ve=null;try{var Re=new se(H,J)}catch{return null}return U.forEach(function(Se){Re.test(Se)&&(de&&ve.compare(Se)!==1||(ve=new I(de=Se,J)))}),de},e.validRange=function(U,H){try{return new se(U,H).range||"*"}catch{return null}},e.ltr=function(U,H,J){return Me(U,H,"<",J)},e.gtr=function(U,H,J){return Me(U,H,">",J)},e.outside=Me,e.prerelease=function(U,H){var J=K(U,H);return J&&J.prerelease.length?J.prerelease:null},e.intersects=function(U,H,J){return U=new se(U,J),H=new se(H,J),U.intersects(H)},e.coerce=function(U){if(U instanceof I)return U;if(typeof U!="string")return null;var H=U.match(S[x]);return H==null?null:K((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,T(1))},function(W,e){var T,D,k=W.exports={};function L(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function S(E){if(T===setTimeout)return setTimeout(E,0);if((T===L||!T)&&setTimeout)return T=setTimeout,setTimeout(E,0);try{return T(E,0)}catch{try{return T.call(null,E,0)}catch{return T.call(this,E,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:L}catch{T=L}try{D=typeof clearTimeout=="function"?clearTimeout:N}catch{D=N}})();var g,u=[],y=!1,v=-1;function m(){y&&g&&(y=!1,g.length?u=g.concat(u):v=-1,u.length&&b())}function b(){if(!y){var E=S(m);y=!0;for(var l=u.length;l;){for(g=u,u=[];++v<l;)g&&g[v].run();v=-1,l=u.length}g=null,y=!1,function(d){if(D===clearTimeout)return clearTimeout(d);if((D===N||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(d);try{D(d)}catch{try{return D.call(null,d)}catch{return D.call(this,d)}}}(E)}}function p(E,l){this.fun=E,this.array=l}function O(){}k.nextTick=function(E){var l=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)l[d-1]=arguments[d];u.push(new p(E,l)),u.length!==1||y||S(b)},p.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=O,k.addListener=O,k.once=O,k.off=O,k.removeListener=O,k.removeAllListeners=O,k.emit=O,k.prependListener=O,k.prependOnceListener=O,k.listeners=function(E){return[]},k.binding=function(E){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(E){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Z[71],Q([0,1]),function(W,e){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class D{constructor(S,g,u){this.level=S,this.key=g,this.value=u,this.forward=[]}}const k=void 0;class L{constructor(S,g=2**16){this.comparator=S,this[T]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(g)|0),this.e=new D(this.c,k,k)}get size(){return this.f}clear(){this.e=new D(this.c,k,k)}has(S){return Boolean(L.g(this,S,this.comparator))}get(S){return L.g(this,S,this.comparator)?.value}set(S,g){return L.h(this,S,g,this.comparator)&&(this.f+=1),this}delete(S){const g=L.k(this,S,this.comparator);return g&&(this.f-=1),g}forEach(S,g){let u=this.e.forward[0];for(;u;)S.call(g,u.value,u.key,this),u=u.forward[0]}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",g=this.e.forward[0];for(;g;)S+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return S}static g(S,g,u){let y=S.e;for(let v=S.d-1;v>=0;v--)for(;y.forward[v]&&u(y.forward[v].key,g)<0;)y=y.forward[v];if(y=y.forward[0],y&&u(y.key,g)===0)return y}static h(S,g,u,y){const v=[];let m=S.e;for(let b=S.d-1;b>=0;b--){for(;m.forward[b]&&y(m.forward[b].key,g)<0;)m=m.forward[b];v[b]=m}if(m=m.forward[0],m&&y(m.key,g)===0)return m.value=u,!1;{const b=L.j(S);if(b>S.d){for(let p=S.d;p<b;p++)v[p]=S.e;S.d=b}m=new D(b,g,u);for(let p=0;p<b;p++)m.forward[p]=v[p].forward[p],v[p].forward[p]=m;return!0}}static j(S,g=.5){let u=1;for(;Math.random()<g&&u<S.c;)u+=1;return u}static k(S,g,u){const y=[];let v=S.e;for(let m=S.d-1;m>=0;m--){for(;v.forward[m]&&u(v.forward[m].key,g)<0;)v=v.forward[m];y[m]=v}if(v=v.forward[0],!v||u(v.key,g)!==0)return!1;for(let m=0;m<S.d&&y[m].forward[m]===v;m++)y[m].forward[m]=v.forward[m];for(;S.d>0&&S.e.forward[S.d-1]===k;)S.d-=1;return!0}}e.SkipList=L}),define(Z[43],Q([0,1,10,2]),function(W,e,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(f){const s=f;return s?typeof s.read=="function":!1}e.isReadable=k;function L(f){const s=f;return s?[s.on,s.pause,s.resume,s.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=L;function N(f){const s=f;return s?L(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=N;function S(f,s){return new g(f,s)}e.newWriteableStream=S;class g{constructor(s,t){this.e=s,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(t=>t(s))}h(s){this.c.error.length===0?(0,T.onUnexpectedError)(s):this.c.error.slice(0).forEach(t=>t(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,t){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(s,t){if(this.a.destroyed)return;let n;switch(s){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const i=n.indexOf(t);i>=0&&n.splice(i,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u(f,s){const t=[];let n;for(;(n=f.read())!==null;)t.push(n);return s(t)}e.consumeReadable=u;function y(f,s,t){const n=[];let i;for(;(i=f.read())!==null&&n.length<t;)n.push(i);return i===null&&n.length>0?s(n):{read:()=>{if(n.length>0)return n.shift();if(typeof i<"u"){const r=i;return i=void 0,r}return f.read()}}}e.peekReadable=y;function v(f,s){return new Promise((t,n)=>{const i=[];m(f,{onData:r=>{s&&i.push(r)},onError:r=>{s?n(r):t(void 0)},onEnd:()=>{t(s?s(i):void 0)}})})}e.consumeStream=v;function m(f,s){let t=!1;return f.on("error",n=>{t||s.onError(n)}),f.on("end",()=>{t||s.onEnd()}),f.on("data",n=>{t||s.onData(n)}),(0,D.toDisposable)(()=>t=!0)}e.listenStream=m;function b(f,s){return new Promise((t,n)=>{const i=new D.DisposableStore,r=[],o=h=>{if(r.push(h),r.length>s)return i.dispose(),f.pause(),t({stream:f,buffer:r,ended:!1})},c=h=>n(h),a=()=>t({stream:f,buffer:r,ended:!0});i.add((0,D.toDisposable)(()=>f.removeListener("error",c))),f.on("error",c),i.add((0,D.toDisposable)(()=>f.removeListener("end",a))),f.on("end",a),i.add((0,D.toDisposable)(()=>f.removeListener("data",o))),f.on("data",o)})}e.peekStream=b;function p(f,s){const t=S(s);return t.end(f),t}e.toStream=p;function O(){const f=S(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=O;function E(f){let s=!1;return{read:()=>s?null:(s=!0,f)}}e.toReadable=E;function l(f,s,t){const n=S(t);return m(f,{onData:i=>n.write(s.data(i)),onError:i=>n.error(s.error?s.error(i):i),onEnd:()=>n.end()}),n}e.transform=l;function d(f,s,t){let n=!1;return{read:()=>{const i=s.read();return n?i:(n=!0,i!==null?t([f,i]):f)}}}e.prefixedReadable=d;function w(f,s,t){let n=!1;const i=S(t);return m(s,{onData:r=>n?i.write(r):(n=!0,i.write(t([f,r]))),onError:r=>i.error(r),onEnd:()=>{n||(n=!0,i.write(f)),i.end()}}),i}e.prefixedStream=w}),define(Z[15],Q([0,1,43]),function(W,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer<"u";let k,L;class N{static alloc(h){return D?new N(Buffer.allocUnsafe(h)):new N(new Uint8Array(h))}static wrap(h){return D&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new N(h)}static fromString(h,R){return!(R?.dontUseNodeBuffer||!1)&&D?new N(Buffer.from(h)):(k||(k=new TextEncoder),new N(k.encode(h)))}static fromByteArray(h){const R=N.alloc(h.length);for(let C=0,x=h.length;C<x;C++)R.buffer[C]=h[C];return R}static concat(h,R){if(typeof R>"u"){R=0;for(let Y=0,X=h.length;Y<X;Y++)R+=h[Y].byteLength}const C=N.alloc(R);let x=0;for(let Y=0,X=h.length;Y<X;Y++){const ie=h[Y];C.set(ie,x),x+=ie.byteLength}return C}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=N.alloc(this.byteLength);return h.set(this),h}toString(){return D?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(h,R){return new N(this.buffer.subarray(h,R))}set(h,R){if(h instanceof N)this.buffer.set(h.buffer,R);else if(h instanceof Uint8Array)this.buffer.set(h,R);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),R);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return u(this.buffer,h)}writeUInt32BE(h,R){y(this.buffer,h,R)}readUInt32LE(h){return v(this.buffer,h)}writeUInt32LE(h,R){m(this.buffer,h,R)}readUInt8(h){return b(this.buffer,h)}writeUInt8(h,R){p(this.buffer,h,R)}}e.VSBuffer=N;function S(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0}e.readUInt16LE=S;function g(a,h,R){a[R+0]=h&255,h=h>>>8,a[R+1]=h&255}e.writeUInt16LE=g;function u(a,h){return a[h]*2**24+a[h+1]*2**16+a[h+2]*2**8+a[h+3]}e.readUInt32BE=u;function y(a,h,R){a[R+3]=h,h=h>>>8,a[R+2]=h,h=h>>>8,a[R+1]=h,h=h>>>8,a[R]=h}e.writeUInt32BE=y;function v(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0|a[h+2]<<16>>>0|a[h+3]<<24>>>0}e.readUInt32LE=v;function m(a,h,R){a[R+0]=h&255,h=h>>>8,a[R+1]=h&255,h=h>>>8,a[R+2]=h&255,h=h>>>8,a[R+3]=h&255}e.writeUInt32LE=m;function b(a,h){return a[h]}e.readUInt8=b;function p(a,h,R){a[R]=h}e.writeUInt8=p;function O(a){return T.consumeReadable(a,h=>N.concat(h))}e.readableToBuffer=O;function E(a){return T.toReadable(a)}e.bufferToReadable=E;function l(a){return T.consumeStream(a,h=>N.concat(h))}e.streamToBuffer=l;async function d(a){return a.ended?N.concat(a.buffer):N.concat([...a.buffer,await l(a.stream)])}e.bufferedStreamToBuffer=d;function w(a){return T.toStream(a,h=>N.concat(h))}e.bufferToStream=w;function f(a){return T.transform(a,{data:h=>typeof h=="string"?N.fromString(h):N.wrap(h)},h=>N.concat(h))}e.streamToBufferReadableStream=f;function s(a){return T.newWriteableStream(h=>N.concat(h),a)}e.newWriteableBufferStream=s;function t(a,h){return T.prefixedReadable(a,h,R=>N.concat(R))}e.prefixedBufferReadable=t;function n(a,h){return T.prefixedStream(a,h,R=>N.concat(R))}e.prefixedBufferStream=n;function i(a){let h=0,R=0,C=0;const x=new Uint8Array(Math.floor(a.length/4*3)),Y=ie=>{switch(R){case 3:x[C++]=h|ie,R=0;break;case 2:x[C++]=h|ie>>>2,h=ie<<6,R=3;break;case 1:x[C++]=h|ie>>>4,h=ie<<4,R=2;break;default:h=ie<<2,R=1}};for(let ie=0;ie<a.length;ie++){const re=a.charCodeAt(ie);if(re>=65&&re<=90)Y(re-65);else if(re>=97&&re<=122)Y(re-97+26);else if(re>=48&&re<=57)Y(re-48+52);else if(re===43||re===45)Y(62);else if(re===47||re===95)Y(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${a[ie]}`)}}const X=C;for(;R>0;)Y(0);return N.wrap(x).slice(0,X)}e.decodeBase64=i;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:a},h=!0,R=!1){const C=R?o:r;let x="";const Y=a.byteLength%3;let X=0;for(;X<a.byteLength-Y;X+=3){const ie=a[X+0],re=a[X+1],_=a[X+2];x+=C[ie>>>2],x+=C[(ie<<4|re>>>4)&63],x+=C[(re<<2|_>>>6)&63],x+=C[_&63]}if(Y===1){const ie=a[X+0];x+=C[ie>>>2],x+=C[ie<<4&63],h&&(x+="==")}else if(Y===2){const ie=a[X+0],re=a[X+1];x+=C[ie>>>2],x+=C[(ie<<4|re>>>4)&63],x+=C[re<<2&63],h&&(x+="=")}return x}e.encodeBase64=c}),define(Z[29],Q([0,1,5]),function(W,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function D(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const d=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([w,f])=>{d[w]=f&&typeof f=="object"?D(f):f}),d}e.deepClone=D;function k(l){if(!l||typeof l!="object")return l;const d=[l];for(;d.length>0;){const w=d.shift();Object.freeze(w);for(const f in w)if(L.call(w,f)){const s=w[f];typeof s=="object"&&!Object.isFrozen(s)&&!(0,T.isTypedArray)(s)&&d.push(s)}}return l}e.deepFreeze=k;const L=Object.prototype.hasOwnProperty;function N(l,d){return S(l,d,new Set)}e.cloneAndChange=N;function S(l,d,w){if((0,T.isUndefinedOrNull)(l))return l;const f=d(l);if(typeof f<"u")return f;if(Array.isArray(l)){const s=[];for(const t of l)s.push(S(t,d,w));return s}if((0,T.isObject)(l)){if(w.has(l))throw new Error("Cannot clone recursive data-structure");w.add(l);const s={};for(const t in l)L.call(l,t)&&(s[t]=S(l[t],d,w));return w.delete(l),s}return l}function g(l,d,w=!0){return(0,T.isObject)(l)?((0,T.isObject)(d)&&Object.keys(d).forEach(f=>{f in l?w&&((0,T.isObject)(l[f])&&(0,T.isObject)(d[f])?g(l[f],d[f],w):l[f]=d[f]):l[f]=d[f]}),l):d}e.mixin=g;function u(l,d){if(l===d)return!0;if(l==null||d===null||d===void 0||typeof l!=typeof d||typeof l!="object"||Array.isArray(l)!==Array.isArray(d))return!1;let w,f;if(Array.isArray(l)){if(l.length!==d.length)return!1;for(w=0;w<l.length;w++)if(!u(l[w],d[w]))return!1}else{const s=[];for(f in l)s.push(f);s.sort();const t=[];for(f in d)t.push(f);if(t.sort(),!u(s,t))return!1;for(w=0;w<s.length;w++)if(!u(l[s[w]],d[s[w]]))return!1}return!0}e.equals=u;function y(l){const d=new Set;return JSON.stringify(l,(w,f)=>{if((0,T.isObject)(f)||Array.isArray(f)){if(d.has(f))return"[Circular]";d.add(f)}return f})}e.safeStringify=y;function v(l,d){const w=Object.create(null);return!l||!d||Object.keys(d).forEach(s=>{const t=l[s],n=d[s];u(t,n)||(w[s]=n)}),w}e.distinct=v;function m(l,d){const w=d.toLowerCase(),f=Object.keys(l).find(s=>s.toLowerCase()===w);return f?l[f]:l[d]}e.getCaseInsensitive=m;function b(l,d){const w=Object.create(null);for(const[f,s]of Object.entries(l))d(f,s)&&(w[f]=s);return w}e.filter=b;function p(l){let d=[],w=Object.getPrototypeOf(l);for(;Object.prototype!==w;)d=d.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return d}e.getAllPropertyNames=p;function O(l){const d=[];for(const w of p(l))typeof l[w]=="function"&&d.push(w);return d}e.getAllMethodNames=O;function E(l,d){const w=s=>function(){const t=Array.prototype.slice.call(arguments,0);return d(s,t)},f={};for(const s of l)f[s]=w(s);return f}e.createProxyObject=E}),define(Z[30],Q([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const T=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(k){return T.test(k)}e.isUUID=D,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(S){for(let g=0;g<S.length;g++)S[g]=Math.floor(Math.random()*256);return S};const L=new Uint8Array(16),N=[];for(let S=0;S<256;S++)N.push(S.toString(16).padStart(2,"0"));return function(){k(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let g=0,u="";return u+=N[L[g++]],u+=N[L[g++]],u+=N[L[g++]],u+=N[L[g++]],u+="-",u+=N[L[g++]],u+=N[L[g++]],u+="-",u+=N[L[g++]],u+=N[L[g++]],u+="-",u+=N[L[g++]],u+=N[L[g++]],u+="-",u+=N[L[g++]],u+=N[L[g++]],u+=N[L[g++]],u+=N[L[g++]],u+=N[L[g++]],u+=N[L[g++]],u}}()}),define(Z[72],Q([0,1,33]),function(W,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(N){const S=N.replace(/\-/g,":").toLowerCase();return!D.has(S)}function L(){const N=(0,T.networkInterfaces)();for(const S in N){const g=N[S];if(g){for(const{mac:u}of g)if(k(u))return u}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(Z[73],Q([6,7]),function(W,e){return W.create("vs/base/common/date",e)}),define(Z[74],Q([0,1,73]),function(W,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const D=60,k=D*60,L=k*24,N=L*7,S=L*30,g=L*365;function u(v,m,b){typeof v!="number"&&(v=v.getTime());const p=Math.round((new Date().getTime()-v)/1e3);if(p<-30)return(0,T.localize)(0,null,u(new Date().getTime()+p*1e3,!1));if(p<30)return(0,T.localize)(1,null);let O;return p<D?(O=p,m?O===1?b?(0,T.localize)(2,null,O):(0,T.localize)(3,null,O):b?(0,T.localize)(4,null,O):(0,T.localize)(5,null,O):O===1?b?(0,T.localize)(6,null,O):(0,T.localize)(7,null,O):b?(0,T.localize)(8,null,O):(0,T.localize)(9,null,O)):p<k?(O=Math.floor(p/D),m?O===1?b?(0,T.localize)(10,null,O):(0,T.localize)(11,null,O):b?(0,T.localize)(12,null,O):(0,T.localize)(13,null,O):O===1?b?(0,T.localize)(14,null,O):(0,T.localize)(15,null,O):b?(0,T.localize)(16,null,O):(0,T.localize)(17,null,O)):p<L?(O=Math.floor(p/k),m?O===1?b?(0,T.localize)(18,null,O):(0,T.localize)(19,null,O):b?(0,T.localize)(20,null,O):(0,T.localize)(21,null,O):O===1?b?(0,T.localize)(22,null,O):(0,T.localize)(23,null,O):b?(0,T.localize)(24,null,O):(0,T.localize)(25,null,O)):p<N?(O=Math.floor(p/L),m?O===1?(0,T.localize)(26,null,O):(0,T.localize)(27,null,O):O===1?(0,T.localize)(28,null,O):(0,T.localize)(29,null,O)):p<S?(O=Math.floor(p/N),m?O===1?b?(0,T.localize)(30,null,O):(0,T.localize)(31,null,O):b?(0,T.localize)(32,null,O):(0,T.localize)(33,null,O):O===1?b?(0,T.localize)(34,null,O):(0,T.localize)(35,null,O):b?(0,T.localize)(36,null,O):(0,T.localize)(37,null,O)):p<g?(O=Math.floor(p/S),m?O===1?b?(0,T.localize)(38,null,O):(0,T.localize)(39,null,O):b?(0,T.localize)(40,null,O):(0,T.localize)(41,null,O):O===1?b?(0,T.localize)(42,null,O):(0,T.localize)(43,null,O):b?(0,T.localize)(44,null,O):(0,T.localize)(45,null,O)):(O=Math.floor(p/g),m?O===1?b?(0,T.localize)(46,null,O):(0,T.localize)(47,null,O):b?(0,T.localize)(48,null,O):(0,T.localize)(49,null,O):O===1?b?(0,T.localize)(50,null,O):(0,T.localize)(51,null,O):b?(0,T.localize)(52,null,O):(0,T.localize)(53,null,O))}e.fromNow=u;function y(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=y}),define(Z[75],Q([6,7]),function(W,e){return W.create("vs/base/common/errorMessage",e)}),define(Z[34],Q([0,1,19,5,75]),function(W,e,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(v,m){return m&&(v.stack||v.stacktrace)?k.localize(0,null,S(v),N(v.stack)||N(v.stacktrace)):S(v)}function N(v){return Array.isArray(v)?v.join(`
`):v}function S(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?k.localize(1,null,v.message):v.message||k.localize(2,null)}function g(v=null,m=!1){if(!v)return k.localize(3,null);if(Array.isArray(v)){const b=T.coalesce(v),p=g(b[0],m);return b.length>1?k.localize(4,null,p,b.length):p}if(D.isString(v))return v;if(v.detail){const b=v.detail;if(b.error)return L(b.error,m);if(b.exception)return L(b.exception,m)}return v.stack?L(v,m):v.message?v.message:k.localize(5,null)}e.toErrorMessage=g;function u(v){const m=v;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=u;function y(v,m){let b;return typeof v=="string"?b=new Error(v):b=v,b.actions=m,b}e.createErrorWithActions=y}),define(Z[76],Q([6,7]),function(W,e){return W.create("vs/base/common/jsonErrorMessages",e)}),define(Z[77],Q([0,1,76]),function(W,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function D(k){switch(k){case 1:return(0,T.localize)(0,null);case 2:return(0,T.localize)(1,null);case 3:return(0,T.localize)(2,null);case 4:return(0,T.localize)(3,null);case 5:return(0,T.localize)(4,null);case 6:return(0,T.localize)(5,null);case 7:return(0,T.localize)(6,null);case 8:return(0,T.localize)(7,null);case 9:return(0,T.localize)(8,null);default:return""}}e.getParseErrorMessage=D}),define(Z[51],Q([0,1,12]),function(W,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var D;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(D=e.Source||(e.Source={}));var k;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(S,...g){const u=g.reduce((m,b)=>(m[b]=!0,m),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(m=>!u[m]).forEach(m=>{for(let b=0;b<y.length;b++)if(m.search(y[b])!==-1){delete S[m];break}})}e.sanitizeProcessEnvironment=L;function N(S){!S||(delete S.DEBUG,T.isMacintosh&&delete S.DYLD_LIBRARY_PATH,T.isLinux&&delete S.LD_PRELOAD)}e.removeDangerousEnvVariables=N}),define(Z[52],Q([0,1,31]),function(W,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function D(l){return k(l,0)}e.hash=D;function k(l,d){switch(typeof l){case"object":return l===null?L(349,d):Array.isArray(l)?g(l,d):u(l,d);case"string":return S(l,d);case"boolean":return N(l,d);case"number":return L(l,d);case"undefined":return L(937,d);default:return L(617,d)}}e.doHash=k;function L(l,d){return(d<<5)-d+l|0}e.numberHash=L;function N(l,d){return L(l?433:863,d)}function S(l,d){d=L(149417,d);for(let w=0,f=l.length;w<f;w++)d=L(l.charCodeAt(w),d);return d}e.stringHash=S;function g(l,d){return d=L(104579,d),l.reduce((w,f)=>k(f,w),d)}function u(l,d){return d=L(181387,d),Object.keys(l).sort().reduce((w,f)=>(w=S(f,w),k(l[f],w)),d)}class y{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=k(d,this.g),this.g}}e.Hasher=y;var v;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function m(l,d,w=32){const f=w-d,s=~((1<<f)-1);return(l<<d|(s&l)>>>f)>>>0}function b(l,d=0,w=l.byteLength,f=0){for(let s=0;s<w;s++)l[d+s]=f}function p(l,d,w="0"){for(;l.length<d;)l=w+l;return l}function O(l,d=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(w=>w.toString(16).padStart(2,"0")).join(""):p((l>>>0).toString(16),d/4)}e.toHexString=O;class E{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const w=d.length;if(w===0)return;const f=this.p;let s=this.r,t=this.u,n,i;for(t!==0?(n=t,i=-1,t=0):(n=d.charCodeAt(0),i=0);;){let r=n;if(T.isHighSurrogate(n))if(i+1<w){const o=d.charCodeAt(i+1);T.isLowSurrogate(o)?(i++,r=T.computeCodePoint(n,o)):r=65533}else{t=n;break}else T.isLowSurrogate(n)&&(r=65533);if(s=this.w(f,s,r),i++,i<w)n=d.charCodeAt(i);else break}this.r=s,this.u=t}w(d,w,f){return f<128?d[w++]=f:f<2048?(d[w++]=192|(f&1984)>>>6,d[w++]=128|(f&63)>>>0):f<65536?(d[w++]=224|(f&61440)>>>12,d[w++]=128|(f&4032)>>>6,d[w++]=128|(f&63)>>>0):(d[w++]=240|(f&1835008)>>>18,d[w++]=128|(f&258048)>>>12,d[w++]=128|(f&4032)>>>6,d[w++]=128|(f&63)>>>0),w>=64&&(this.y(),w-=64,this.t+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),w}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),O(this.h)+O(this.l)+O(this.m)+O(this.n)+O(this.o)}x(){this.p[this.r++]=128,b(this.p,this.r),this.r>56&&(this.y(),b(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=E.g,w=this.q;for(let a=0;a<64;a+=4)d.setUint32(a,w.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)d.setUint32(a,m(d.getUint32(a-12,!1)^d.getUint32(a-32,!1)^d.getUint32(a-56,!1)^d.getUint32(a-64,!1),1),!1);let f=this.h,s=this.l,t=this.m,n=this.n,i=this.o,r,o,c;for(let a=0;a<80;a++)a<20?(r=s&t|~s&n,o=1518500249):a<40?(r=s^t^n,o=1859775393):a<60?(r=s&t|s&n|t&n,o=2400959708):(r=s^t^n,o=3395469782),c=m(f,5)+r+i+o+d.getUint32(a*4,!1)&4294967295,i=n,n=t,t=m(s,30),s=f,f=c;this.h=this.h+f&4294967295,this.l=this.l+s&4294967295,this.m=this.m+t&4294967295,this.n=this.n+n&4294967295,this.o=this.o+i&4294967295}}e.StringSHA1=E,E.g=new DataView(new ArrayBuffer(320))}),define(Z[53],Q([0,1,31]),function(W,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(D||(D={})),function(k){const L="error",N="warning",S="warn",g="info",u="ignore";function y(m){return m?T.equalsIgnoreCase(L,m)?k.Error:T.equalsIgnoreCase(N,m)||T.equalsIgnoreCase(S,m)?k.Warning:T.equalsIgnoreCase(g,m)?k.Info:k.Ignore:k.Ignore}k.fromValue=y;function v(m){switch(m){case k.Error:return L;case k.Warning:return N;case k.Info:return g;default:return u}}k.toString=v}(D||(D={})),e.default=D}),define(Z[78],Q([0,1,11]),function(W,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function D(u){const y=u;return y&&typeof y.type=="string"&&typeof y.severity=="string"}e.isRemoteConsoleLog=D;function k(u){const y=[];let v;try{const m=JSON.parse(u.arguments),b=m[m.length-1];b&&b.__$stack&&(m.pop(),v=b.__$stack),y.push(...m)}catch{y.push("Unable to log remote console arguments",u.arguments)}return{args:y,stack:v}}e.parse=k;function L(u){if(typeof u!="string")return L(k(u).stack);const y=u;if(y){const v=N(y),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(m&&m.length===4)return{uri:T.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=L;function N(u){if(!u)return u;const y=u.indexOf(`
`);return y===-1?u:u.substring(0,y)}function S(u,y){const{args:v,stack:m}=k(u),b=typeof v[0]=="string"&&v.length===1;let p=N(m);p&&(p=`(${p.trim()})`);let O=[];if(typeof v[0]=="string"?p&&b?O=[`%c[${y}] %c${v[0]} %c${p}`,g("blue"),g(""),g("grey")]:O=[`%c[${y}] %c${v[0]}`,g("blue"),g(""),...v.slice(1)]:O=[`%c[${y}]%`,g("blue"),...v],p&&!b&&O.push(p),typeof console[u.severity]!="function")throw new Error("Unknown console method");console[u.severity].apply(console,O)}e.log=S;function g(u){return`color: ${u}`}}),define(Z[44],Q([0,1,15,31,11]),function(W,e,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(u){return JSON.stringify(u,S)}e.stringify=L;function N(u){let y=JSON.parse(u);return y=g(y),y}e.parse=N;function S(u,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:(0,D.regExpFlags)(y)}:y}function g(u,y=0){if(!u||y>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return k.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 16:return new Date(u.source)}if(u instanceof T.VSBuffer||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let v=0;v<u.length;++v)u[v]=g(u[v],y+1);else for(const v in u)Object.hasOwnProperty.call(u,v)&&(u[v]=g(u[v],y+1))}return u}e.revive=g}),define(Z[79],Q([0,1,33,10,54,30,72]),function(W,e,T,D,k,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(y){return this.a||(this.a=k.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(y)}value(){if(this.b===void 0){let y=0,v=0;const m=(0,T.networkInterfaces)();for(const b in m){const p=m[b];if(p)for(const{mac:O,internal:E}of p)E||(v+=1,this.c(O.toUpperCase())&&(y+=1))}this.b=v>0?y/v:0}return this.b}};let S;async function g(){return S||(S=(async()=>await u()||L.generateUuid())()),S}e.getMachineId=g;async function u(){try{const y=await new Promise((m,b)=>{W(["crypto"],m,b)}),v=(0,N.getMac)();return y.createHash("sha256").update(v,"utf8").digest("hex")}catch(y){D.onUnexpectedError(y);return}}}),define(Z[80],Q([0,1,33,14,20]),function(W,e,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,N=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var g;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(g||(g={}));let u;switch(process.arch){case"ia32":case"x32":u=1;break;case"arm":case"arm64":u=2;break;default:u=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class v{constructor(s,t,n){this.exePath=s,this.displayName=t,this.a=n}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:f=!1}={}){return f?u===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function b({useAlternateBitness:f=!1,findPreview:s=!1}={}){const t=m({useAlternateBitness:f});if(!t)return null;const n=D.join(t,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(n))return null;let i=-1,r=null;for(const a of await k.Promises.readdir(n)){let h=-1;if(s){const C=a.indexOf("-");if(C<0)continue;const x=a.substring(0,C);if(!L.test(x)||a.substring(C+1)!=="preview")continue;h=parseInt(x,10)}else{if(!L.test(a))continue;h=parseInt(a,10)}if(h<=i)continue;const R=D.join(n,a,"pwsh.exe");!await k.SymlinkSupport.existsFile(R)||(r=R,i=h)}if(!r)return null;const o=t.includes("x86")?" (x86)":"",c=s?" Preview":"";return new v(r,`PowerShell${c}${o}`,!0)}async function p({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const s=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=f?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:N,pwshMsixName:"PowerShell (Store)"};for(const i of await k.Promises.readdir(s))if(t.test(i)){const r=D.join(s,i,"pwsh.exe");return new v(r,n)}return null}function O(){const f=D.join(T.homedir(),".dotnet","tools","pwsh.exe");return new v(f,".NET Core PowerShell Global Tool")}function E(){const f=D.join(process.env.windir,u===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(f,"Windows PowerShell",!0)}async function*l(){let f=await b();f&&(yield f),f=await b({useAlternateBitness:!0}),f&&(yield f),f=await p(),f&&(yield f),f=O(),f&&(yield f),f=await b({findPreview:!0}),f&&(yield f),f=await p({findPreview:!0}),f&&(yield f),f=await b({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=E(),f&&(yield f)}async function*d(){for await(const f of l())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=d;async function w(){for await(const f of d())return f;return null}e.getFirstAvailablePowerShellInstallation=w}),define(Z[55],Q([0,1,14,12,35,51,5,20]),function(W,e,T,D,k,L,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function g(v=k.env){return v.comspec||"cmd.exe"}e.getWindowsShell=g;function u(v){let m=[],b=!1;const p=function(O){if(b){m.push(O);return}(!v.send(O,l=>{if(l&&console.error(l),b=!1,m.length>0){const d=m.slice(0);m=[],d.forEach(w=>p(w))}})||D.isWindows)&&(b=!0)};return{send:p}}e.createQueuedSender=u;var y;(function(v){async function m(b,p,O){if(T.isAbsolute(b))return b;if(p===void 0&&(p=k.cwd()),T.dirname(b)!=="."||(O===void 0&&N.isString(k.env.PATH)&&(O=k.env.PATH.split(T.delimiter)),O===void 0||O.length===0))return T.join(p,b);async function l(d){if(await S.Promises.exists(d)){let w;try{w=await S.Promises.stat(d)}catch(f){f.message.startsWith("EACCES")&&(w=await S.Promises.lstat(d))}return w?!w.isDirectory():!1}return!1}for(const d of O){let w;if(T.isAbsolute(d)?w=T.join(d,b):w=T.join(p,d,b),await l(w))return w;let f=w+".com";if(await l(f)||(f=w+".exe",await l(f)))return f}return T.join(p,b)}v.findExecutable=m})(y=e.win32||(e.win32={}))}),define(Z[81],Q([0,1,33,12,80,55]),function(W,e,T,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function N(v,m){return v===1?D.isWindows?y():L.getWindowsShell(m):g(v,m)}e.getSystemShell=N;let S=null;function g(v,m){if(D.isLinux&&v===2||D.isMacintosh&&v===3)return"/bin/bash";if(!S){let b;if(D.isWindows)b="/bin/bash";else{if(b=m.SHELL,!b)try{b=(0,T.userInfo)().shell}catch{}b||(b="sh"),b==="/bin/false"&&(b="/bin/bash")}S=b}return S}let u=null;async function y(){return u||(u=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),u}});var me=this&&this.__decorate||function(W,e,T,D){var k=arguments.length,L=k<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,T):D,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(W,e,T,D);else for(var S=W.length-1;S>=0;S--)(N=W[S])&&(L=(k<3?N(L):k>3?N(e,T,L):N(e,T))||L);return k>3&&L&&Object.defineProperty(e,T,L),L};define(Z[56],Q([0,1,19,3,15,22,49,10,4,2,44,31,5]),function(W,e,T,D,k,L,N,S,g,u,y,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var b;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(b||(b={}));function p(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var O;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(O||(O={}));function E(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(l||(l={}));function d(j){let A=0;for(let z=0;;z+=7){const $=j.read(1);if(A|=($.buffer[0]&127)<<z,!($.buffer[0]&128))return A}}const w=i(0);function f(j,A){if(A===0){j.write(w);return}let z=0;for(let q=A;q!==0;q=q>>>7)z++;const $=k.VSBuffer.alloc(z);for(let q=0;A!==0;q++)$.buffer[q]=A&127,A=A>>>7,A>0&&($.buffer[q]|=128);j.write($)}class s{constructor(A){this.b=A,this.a=0}read(A){const z=this.b.slice(this.a,this.a+A);return this.a+=z.byteLength,z}}e.BufferReader=s;class t{constructor(){this.a=[]}get buffer(){return k.VSBuffer.concat(this.a)}write(A){this.a.push(A)}}e.BufferWriter=t;var n;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object",j[j.Int=6]="Int"})(n||(n={}));function i(j){const A=k.VSBuffer.alloc(1);return A.writeUInt8(j,0),A}const r={Undefined:i(n.Undefined),String:i(n.String),Buffer:i(n.Buffer),VSBuffer:i(n.VSBuffer),Array:i(n.Array),Object:i(n.Object),Uint:i(n.Int)},o=typeof Buffer<"u";function c(j,A){if(typeof A>"u")j.write(r.Undefined);else if(typeof A=="string"){const z=k.VSBuffer.fromString(A);j.write(r.String),f(j,z.byteLength),j.write(z)}else if(o&&Buffer.isBuffer(A)){const z=k.VSBuffer.wrap(A);j.write(r.Buffer),f(j,z.byteLength),j.write(z)}else if(A instanceof k.VSBuffer)j.write(r.VSBuffer),f(j,A.byteLength),j.write(A);else if(Array.isArray(A)){j.write(r.Array),f(j,A.length);for(const z of A)c(j,z)}else if(typeof A=="number"&&(A|0)===A)j.write(r.Uint),f(j,A);else{const z=k.VSBuffer.fromString(JSON.stringify(A));j.write(r.Object),f(j,z.byteLength),j.write(z)}}e.serialize=c;function a(j){switch(j.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return j.read(d(j)).toString();case n.Buffer:return j.read(d(j)).buffer;case n.VSBuffer:return j.read(d(j));case n.Array:{const z=d(j),$=[];for(let q=0;q<z;q++)$.push(a(j));return $}case n.Object:return JSON.parse(j.read(d(j)).toString());case n.Int:return d(j)}}e.deserialize=a;class h{constructor(A,z,$=null,q=1e3){this.h=A,this.j=z,this.k=$,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(K=>this.q(K)),this.m({type:200})}registerChannel(A,z){this.b.set(A,z),setTimeout(()=>this.w(A),0)}m(A){switch(A.type){case 200:{const z=this.o([A.type]);this.k?.logOutgoing(z,0,1,E(A.type));return}case 201:case 202:case 204:case 203:{const z=this.o([A.type,A.id],A.data);this.k?.logOutgoing(z,A.id,1,E(A.type),A.data);return}}}o(A,z=void 0){const $=new t;return c($,A),c($,z),this.p($.buffer)}p(A){try{return this.h.send(A),A.byteLength}catch{return 0}}q(A){const z=new s(A),$=a(z),q=a(z),K=$[0];switch(K){case 100:return this.k?.logIncoming(A.byteLength,$[1],1,`${p(K)}: ${$[2]}.${$[3]}`,q),this.s({type:K,id:$[1],channelName:$[2],name:$[3],arg:q});case 102:return this.k?.logIncoming(A.byteLength,$[1],1,`${p(K)}: ${$[2]}.${$[3]}`,q),this.t({type:K,id:$[1],channelName:$[2],name:$[3],arg:q});case 101:return this.k?.logIncoming(A.byteLength,$[1],1,`${p(K)}`),this.u({type:K,id:$[1]});case 103:return this.k?.logIncoming(A.byteLength,$[1],1,`${p(K)}`),this.u({type:K,id:$[1]})}}s(A){const z=this.b.get(A.channelName);if(!z){this.v(A);return}const $=new L.CancellationTokenSource;let q;try{q=z.call(this.j,A.name,A.arg,$.token)}catch(P){q=Promise.reject(P)}const K=A.id;q.then(P=>{this.m({id:K,data:P,type:201}),this.d.delete(A.id)},P=>{P instanceof Error?this.m({id:K,data:{message:P.message,name:P.name,stack:P.stack?P.stack.split?P.stack.split(`
`):P.stack:void 0},type:202}):this.m({id:K,data:P,type:203}),this.d.delete(A.id)});const I=(0,u.toDisposable)(()=>$.cancel());this.d.set(A.id,I)}t(A){const z=this.b.get(A.channelName);if(!z){this.v(A);return}const $=A.id,K=z.listen(this.j,A.name,A.arg)(I=>this.m({id:$,data:I,type:204}));this.d.set(A.id,K)}u(A){const z=this.d.get(A.id);z&&(z.dispose(),this.d.delete(A.id))}v(A){let z=this.g.get(A.channelName);z||(z=[],this.g.set(A.channelName,z));const $=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.m({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);z.push({request:A,timeoutTimer:$})}w(A){const z=this.g.get(A);if(z){for(const $ of z)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.s($.request);break;case 102:this.t($.request);break}this.g.delete(A)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,u.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=h;var R;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(R=e.RequestInitiator||(e.RequestInitiator={}));class C{constructor(A,z=null){this.l=A,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new g.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage($=>this.s($)),this.j=z}getChannel(A){const z=this;return{call($,q,K){return z.a?Promise.reject(new S.CancellationError):z.m(A,$,q,K)},listen($,q){return z.a?g.Event.None:z.o(A,$,q)}}}m(A,z,$,q=L.CancellationToken.None){const K=this.g++,P={id:K,type:100,channelName:A,name:z,arg:$};if(q.isCancellationRequested)return Promise.reject(new S.CancellationError);let M;return new Promise((V,G)=>{if(q.isCancellationRequested)return G(new S.CancellationError);const te=()=>{const ue=ce=>{switch(ce.type){case 201:this.f.delete(K),V(ce.data);break;case 202:{this.f.delete(K);const oe=new Error(ce.data.message);oe.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,oe.name=ce.data.name,G(oe);break}case 203:this.f.delete(K),G(ce.data);break}};this.f.set(K,ue),this.p(P)};let ne=null;this.b===l.Idle?te():(ne=(0,D.createCancelablePromise)(ue=>this.u()),ne.then(()=>{ne=null,te()}));const ge=()=>{ne?(ne.cancel(),ne=null):this.p({id:K,type:101}),G(new S.CancellationError)},ye=q.onCancellationRequested(ge);M=(0,u.combinedDisposable)((0,u.toDisposable)(ge),ye),this.d.add(M)}).finally(()=>{this.d.delete(M)})}o(A,z,$){const q=this.g++,I={id:q,type:102,channelName:A,name:z,arg:$};let P=null;const M=new g.Emitter({onWillAddFirstListener:()=>{P=(0,D.createCancelablePromise)(V=>this.u()),P.then(()=>{P=null,this.d.add(M),this.p(I)})},onDidRemoveLastListener:()=>{P?(P.cancel(),P=null):(this.d.delete(M),this.p({id:q,type:103}))}}),F=V=>M.fire(V.data);return this.f.set(q,F),M.event}p(A){switch(A.type){case 100:case 102:{const z=this.q([A.type,A.id,A.channelName,A.name],A.arg);this.j?.logOutgoing(z,A.id,0,`${p(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const z=this.q([A.type,A.id]);this.j?.logOutgoing(z,A.id,0,p(A.type));return}}}q(A,z=void 0){const $=new t;return c($,A),c($,z),this.r($.buffer)}r(A){try{return this.l.send(A),A.byteLength}catch{return 0}}s(A){const z=new s(A),$=a(z),q=a(z),K=$[0];switch(K){case 200:return this.j?.logIncoming(A.byteLength,0,0,E(K)),this.t({type:$[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(A.byteLength,$[1],0,E(K),q),this.t({type:$[0],id:$[1],data:q})}}t(A){if(A.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(A.id)?.(A)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,u.dispose)(this.d.values()),this.d.clear()}}me([N.memoize],C.prototype,"onDidInitializePromise",null),e.ChannelClient=C;class x{get connections(){const A=[];return this.f.forEach(z=>A.push(z)),A}constructor(A){this.a=new Map,this.f=new Set,this.g=new g.Emitter,this.onDidAddConnection=this.g.event,this.h=new g.Emitter,this.onDidRemoveConnection=this.h.event,A(({protocol:z,onDidClientDisconnect:$})=>{g.Event.once(z.onMessage)(K=>{const I=new s(K),P=a(I),M=new h(z,P),F=new C(z);this.a.forEach((G,te)=>M.registerChannel(te,G));const V={channelServer:M,channelClient:F,ctx:P};this.f.add(V),this.g.fire(V),$(()=>{M.dispose(),F.dispose(),this.f.delete(V),this.h.fire(V)})})})}getChannel(A,z){const $=this;return{call(q,K,I){let P;if((0,m.isFunction)(z)){const F=(0,T.getRandomElement)($.connections.filter(z));P=F?Promise.resolve(F):g.Event.toPromise(g.Event.filter($.onDidAddConnection,z))}else P=z.routeCall($,q,K);const M=P.then(F=>F.channelClient.getChannel(A));return X(M).call(q,K,I)},listen(q,K){if((0,m.isFunction)(z))return $.j(A,z,q,K);const I=z.routeEvent($,q,K).then(P=>P.channelClient.getChannel(A));return X(I).listen(q,K)}}}j(A,z,$,q){const K=this;let I=new u.DisposableStore;const P=new g.Emitter({onWillAddFirstListener:()=>{I=new u.DisposableStore;const M=new g.EventMultiplexer,F=new Map,V=te=>{const ge=te.channelClient.getChannel(A).listen($,q),ye=M.add(ge);F.set(te,ye)},G=te=>{const ne=F.get(te);!ne||(ne.dispose(),F.delete(te))};K.connections.filter(z).forEach(V),g.Event.filter(K.onDidAddConnection,z)(V,void 0,I),K.onDidRemoveConnection(G,void 0,I),M.event(P.fire,P,I),I.add(M)},onDidRemoveLastListener:()=>{I.dispose()}});return P.event}registerChannel(A,z){this.a.set(A,z),this.f.forEach($=>{$.channelServer.registerChannel(A,z)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=x;class Y{constructor(A,z,$=null){const q=new t;c(q,z),A.send(q.buffer),this.a=new C(A,$),this.d=new h(A,z,$)}getChannel(A){return this.a.getChannel(A)}registerChannel(A,z){this.d.registerChannel(A,z)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=Y;function X(j){return{call(A,z,$){return j.then(q=>q.call(A,z,$))},listen(A,z){const $=new g.Relay;return j.then(q=>$.input=q.listen(A,z)),$.event}}}e.getDelayedChannel=X;function ie(j){let A=!1;return{call(z,$,q){return A?j.call(z,$,q):(0,D.timeout)(0).then(()=>A=!0).then(()=>j.call(z,$,q))},listen(z,$){if(A)return j.listen(z,$);const q=new g.Relay;return(0,D.timeout)(0).then(()=>A=!0).then(()=>q.input=j.listen(z,$)),q.event}}}e.getNextTickChannel=ie;class re{constructor(A){this.a=A}routeCall(A){return this.b(A)}routeEvent(A){return this.b(A)}async b(A){for(const z of A.connections)if(await Promise.resolve(this.a(z.ctx)))return Promise.resolve(z);return await g.Event.toPromise(A.onDidAddConnection),await this.b(A)}}e.StaticRouter=re;var _;(function(j){function A(K,I){const P=K,M=I&&I.disableMarshalling,F=new Map;for(const V in P)$(V)&&F.set(V,g.Event.buffer(P[V],!0));return new class{listen(V,G,te){const ne=F.get(G);if(ne)return ne;if(q(G)){const ge=P[G];if(typeof ge=="function")return ge.call(P,te)}throw new Error(`Event not found: ${G}`)}call(V,G,te){const ne=P[G];if(typeof ne=="function"){if(!M&&Array.isArray(te))for(let ge=0;ge<te.length;ge++)te[ge]=(0,y.revive)(te[ge]);return ne.apply(P,te)}throw new Error(`Method not found: ${G}`)}}}j.fromService=A;function z(K,I){const P=I&&I.disableMarshalling;return new Proxy({},{get(M,F){if(typeof F=="string")return I?.properties?.has(F)?I.properties.get(F):q(F)?function(V){return K.listen(F,V)}:$(F)?K.listen(F):async function(...V){let G;I&&!(0,m.isUndefinedOrNull)(I.context)?G=[I.context,...V]:G=V;const te=await K.call(F,G);return P?te:(0,y.revive)(te)};throw new Error(`Property not found: ${String(F)}`)}})}j.toService=z;function $(K){return K[0]==="o"&&K[1]==="n"&&v.isUpperAsciiLetter(K.charCodeAt(2))}function q(K){return/^onDynamic/.test(K)&&v.isUpperAsciiLetter(K.charCodeAt(9))}})(_=e.ProxyChannel||(e.ProxyChannel={}));const pe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function le(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){const A=j.toString();if(A!=="[object Object]")return A}return j}function ae(j){return Array.isArray(j)?j.map(le):le(j)}function he(j,A,z,$,q,K,I){I=ae(I);const P=pe[q],M=P[$%P.length];let F=[`%c[${j}]%c[${String(A).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String($).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(K)?(F=F.concat(I),F.push(")")):F.push(I),console.log.apply(console,F)}class B{constructor(A,z){this.d=A,this.f=z,this.a=0,this.b=0}logOutgoing(A,z,$,q,K){this.b+=A,he(this.d,this.b,A,z,$,q,K)}logIncoming(A,z,$,q,K){this.a+=A,he(this.f,this.a,A,z,$,q,K)}}e.IPCLogger=B}),define(Z[82],Q([0,1,57,3,15,22,78,10,4,2,29,55,51,56]),function(W,e,T,D,k,L,N,S,g,u,y,v,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends b.ChannelServer{constructor(l){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",d=>k.VSBuffer.wrap(Buffer.from(d,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.Server=p;class O{constructor(l,d){this.i=l,this.j=d,this.c=new Set,this.g=new Map,this.h=new g.Emitter,this.onDidProcessExit=this.h.event;const w=d&&d.timeout?d.timeout:6e4;this.b=new D.Delayer(w),this.d=null,this.f=null}getChannel(l){const d=this;return{call(w,f,s){return d.k(l,w,f,s)},listen(w,f){return d.l(l,w,f)}}}k(l,d,w,f=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(S.canceled());this.b.cancel();const s=this.n(l),t=(0,D.createCancelablePromise)(r=>s.call(d,w,r)),n=f.onCancellationRequested(()=>t.cancel()),i=(0,u.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{n.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(l,d,w){if(!this.b)return g.Event.None;this.b.cancel();let f;const s=new g.Emitter({onWillAddFirstListener:()=>{f=this.n(l).listen(d,w)(s.fire,s),this.c.add(f)},onDidRemoveLastListener:()=>{this.c.delete(f),f.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,y.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,m.removeDangerousEnvVariables)(d.env),this.d=(0,T.fork)(this.i,l,d);const w=new g.Emitter;g.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,N.isRemoteConsoleLog)(o)){(0,N.log)(o,`IPC Library: ${this.j.serverName}`);return}w.fire(k.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.j.useQueue?(0,v.createQueuedSender)(this.d):this.d,t=o=>this.d&&this.d.connected&&s.send(o.buffer.toString("base64")),n=w.event,i={send:t,onMessage:n};this.f=new b.ChannelClient(i);const r=()=>this.o();process.once("exit",r),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,c)=>{process.removeListener("exit",r),this.c.forEach(a=>(0,u.dispose)(a)),this.c.clear(),o!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:c})})}return this.f}n(l){let d=this.g.get(l);return d||(d=this.m.getChannel(l),this.g.set(l,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=O}),define(Z[83],Q([0,1,3,4,2,5]),function(W,e,T,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var N;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(N=e.StorageHint||(e.StorageHint={}));function S(v){const m=v;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=S;var g;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(g=e.StorageState||(e.StorageState={}));class u extends k.Disposable{constructor(m,b=Object.create(null)){super(),this.m=m,this.n=b,this.b=this.B(new D.Emitter),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=new T.ThrottledDelayer(u.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(m=>this.r(m)))}r(m){m.changed?.forEach((b,p)=>this.s(p,b)),m.deleted?.forEach(b=>this.s(b,void 0))}s(m,b){if(this.c===g.Closed)return;let p=!1;(0,L.isUndefinedOrNull)(b)?p=this.f.delete(m):this.f.get(m)!==b&&(this.f.set(m,b),p=!0),p&&this.b.fire(m)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.n.hint!==N.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(m,b){const p=this.f.get(m);return(0,L.isUndefinedOrNull)(p)?b:p}getBoolean(m,b){const p=this.get(m);return(0,L.isUndefinedOrNull)(p)?b:p==="true"}getNumber(m,b){const p=this.get(m);return(0,L.isUndefinedOrNull)(p)?b:parseInt(p,10)}async set(m,b){if(this.c===g.Closed)return;if((0,L.isUndefinedOrNull)(b))return this.delete(m);const p=String(b);if(this.f.get(m)!==p)return this.f.set(m,p),this.j.set(m,p),this.h.delete(m),this.b.fire(m),this.w()}async delete(m){if(!(this.c===g.Closed||!this.f.delete(m)))return this.h.has(m)||this.h.add(m),this.j.delete(m),this.b.fire(m),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=g.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const m={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(m).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(m){if(!!this.u)return this.w(m)}async w(m){return this.g.trigger(()=>this.v(),m)}async whenFlushed(){if(!!this.u)return new Promise(m=>this.l.push(m))}isInMemory(){return this.n.hint===N.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=u,u.a=100;class y{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(m){m.insert?.forEach((b,p)=>this.a.set(p,b)),m.delete?.forEach(b=>this.a.delete(b))}async close(){}}e.InMemoryStorageDatabase=y}),define(Z[84],Q([6,7]),function(W,e){return W.create("vs/base/node/zip",e)}),define(Z[85],Q([6,7]),function(W,e){return W.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[86],Q([6,7]),function(W,e){return W.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Z[87],Q([6,7]),function(W,e){return W.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[88],Q([6,7]),function(W,e){return W.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Z[89],Q([6,7]),function(W,e){return W.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Z[90],Q([6,7]),function(W,e){return W.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Z[91],Q([6,7]),function(W,e){return W.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[92],Q([6,7]),function(W,e){return W.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[93],Q([6,7]),function(W,e){return W.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[94],Q([6,7]),function(W,e){return W.create("vs/platform/files/common/fileService",e)}),define(Z[95],Q([6,7]),function(W,e){return W.create("vs/platform/files/common/io",e)}),define(Z[96],Q([6,7]),function(W,e){return W.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[97],Q([6,7]),function(W,e){return W.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Z[98],Q([6,7]),function(W,e){return W.create("vs/platform/request/common/request",e)}),define(Z[99],Q([6,7]),function(W,e){return W.create("vs/platform/shell/node/shellEnv",e)}),define(Z[100],Q([6,7]),function(W,e){return W.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[101],Q([6,7]),function(W,e){return W.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Z[102],Q([6,7]),function(W,e){return W.create("vs/platform/workspace/common/workspace",e)}),define(Z[103],Q([0,1,74,49,16,14,35,17,11]),function(W,e,T,D,k,L,N,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class u{get appRoot(){return(0,L.dirname)(k.FileAccess.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return g.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.b.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,S.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,S.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const p=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",p)}return this.args.logsPath}get userDataSyncLogResource(){return g.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return g.URI.file((0,L.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.joinPath)(g.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=N.env.VSCODE_PORTABLE;return p?g.URI.file((0,L.join)(p,"argv.json")):(0,S.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,L.resolve)(p):(0,L.normalize)((0,L.join)(k.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const p=this.args["extensions-download-dir"];return p?g.URI.file((0,L.resolve)(p)):g.URI.file((0,L.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,L.resolve)(p);const O=N.env.VSCODE_EXTENSIONS;if(O)return O;const E=N.env.VSCODE_PORTABLE;return E?(0,L.join)(E,"extensions"):(0,S.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(O=>/^[^:/?#]+?:\/\//.test(O)?g.URI.parse(O):g.URI.file((0,L.normalize)(O)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?g.URI.parse(p):g.URI.file((0,L.normalize)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(p=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(p))}get extensionLogLevel(){const p=[];for(const O of this.args.log||[]){const E=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(O);E&&E[1]&&E[2]&&p.push([E[1],E[2]])}return p.length?p:void 0}get serviceMachineIdResource(){return(0,S.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return g.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const p=N.env.VSCODE_PORTABLE;return p?g.URI.file((0,L.join)(p,"policy.json")):(0,S.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(p){this.args.continueOn=p}get args(){return this.a}constructor(p,O,E){this.a=p,this.b=O,this.c=E,this.editSessionId=this.args.editSessionId}}me([D.memoize],u.prototype,"appRoot",null),me([D.memoize],u.prototype,"userHome",null),me([D.memoize],u.prototype,"userDataPath",null),me([D.memoize],u.prototype,"appSettingsHome",null),me([D.memoize],u.prototype,"tmpDir",null),me([D.memoize],u.prototype,"cacheHome",null),me([D.memoize],u.prototype,"stateResource",null),me([D.memoize],u.prototype,"userRoamingDataHome",null),me([D.memoize],u.prototype,"userDataSyncHome",null),me([D.memoize],u.prototype,"userDataSyncLogResource",null),me([D.memoize],u.prototype,"editSessionsLogResource",null),me([D.memoize],u.prototype,"sync",null),me([D.memoize],u.prototype,"machineSettingsResource",null),me([D.memoize],u.prototype,"workspaceStorageHome",null),me([D.memoize],u.prototype,"localHistoryHome",null),me([D.memoize],u.prototype,"keyboardLayoutResource",null),me([D.memoize],u.prototype,"argvResource",null),me([D.memoize],u.prototype,"isExtensionDevelopment",null),me([D.memoize],u.prototype,"untitledWorkspacesHome",null),me([D.memoize],u.prototype,"installSourcePath",null),me([D.memoize],u.prototype,"builtinExtensionsPath",null),me([D.memoize],u.prototype,"extensionsPath",null),me([D.memoize],u.prototype,"extensionDevelopmentLocationURI",null),me([D.memoize],u.prototype,"extensionDevelopmentKind",null),me([D.memoize],u.prototype,"extensionTestsLocationURI",null),me([D.memoize],u.prototype,"debugExtensionHost",null),me([D.memoize],u.prototype,"logLevel",null),me([D.memoize],u.prototype,"extensionLogLevel",null),me([D.memoize],u.prototype,"serviceMachineIdResource",null),me([D.memoize],u.prototype,"telemetryLogResource",null),me([D.memoize],u.prototype,"disableWorkspaceTrust",null),me([D.memoize],u.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=u;function y(b,p){return m(b["inspect-extensions"],b["inspect-brk-extensions"],5870,p,b.debugId,b.extensionEnvironment)}e.parseExtensionHostPort=y;function v(b,p){return m(b["inspect-ptyhost"],b["inspect-brk-ptyhost"],5877,p,b.extensionEnvironment)}e.parsePtyHostPort=v;function m(b,p,O,E,l,d){const f=Number(p||b)||(E?null:O),s=f?Boolean(!!p):!1;let t;if(d)try{t=JSON.parse(d)}catch{}return{port:f,break:s,debugId:l,env:t}}}),function(){"use strict";function W(e,T,D){function k(N,S){const g=L(N,S),u=[g];return e.isAbsolute(g)||u.unshift(D),e.resolve(...u)}function L(N,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let u=process.env.VSCODE_APPDATA;if(u)return e.join(u,S);const y=N["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(u=process.env.APPDATA,!u){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");u=e.join(v,"AppData","Roaming")}break;case"darwin":u=e.join(T.homedir(),"Library","Application Support");break;case"linux":u=process.env.XDG_CONFIG_HOME||e.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(u,S)}return{getUserDataPath:k}}if(typeof define=="function")define(Z[104],Q([154,33,35]),function(e,T,D){return W(e,T,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),T=require("os");module.exports=W(e,T,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[105],Q([0,1,33,103,104]),function(W,e,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends D.AbstractNativeEnvironmentService{constructor(S,g){super(S,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,k.getUserDataPath)(S,g.nameShort)},g)}}e.NativeEnvironmentService=L}),define(Z[106],Q([0,1,5,89]),function(W,e,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(N,S,g){try{L(N,S,g)}catch(u){console.error(u?.message??u)}return N}e.localizeManifest=k;function L(N,S,g){const u=(y,v,m)=>{const b=y[v];if((0,T.isString)(b)){const p=b,O=p.length;if(O>1&&p[0]==="%"&&p[O-1]==="%"){const E=p.substr(1,O-2);let l=S[E];l===void 0&&g&&(l=g[E]);const d=typeof l=="string"?l:l?.message,w=g?.[E],f=typeof w=="string"?w:w?.message;if(!d){f||console.warn(`[${N.name}]: ${(0,D.localize)(0,null,E)}`);return}if(m&&(v==="title"||v==="category")&&f&&f!==d){const s={value:d,original:f};y[v]=s}else y[v]=d}}else if((0,T.isObject)(b))for(const p in b)b.hasOwnProperty(p)&&(p==="commands"?u(b,p,!0):u(b,p,m));else if(Array.isArray(b))for(let p=0;p<b.length;p++)u(b,p,m)};for(const y in N)N.hasOwnProperty(y)&&u(N,y)}}),define(Z[107],Q([0,1,10]),function(W,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class D{constructor(){this.a=new Map}register(L,N){this.a.set(L,N)}updateManifest(L){if(!(typeof L.main>"u"&&typeof L.browser>"u")&&(L.activationEvents===void 0&&Object.assign(L,{activationEvents:[]}),!(!Array.isArray(L.activationEvents)||!L.contributes)))for(const N in L.contributes){const S=this.a.get(N);if(!S)continue;const g=L.contributes[N],u=Array.isArray(g)?g:[g];try{S(u,L.activationEvents)}catch(y){(0,T.onUnexpectedError)(y)}}}}e.ImplicitActivationEventsImpl=D,e.ImplicitActivationEvents=new D}),define(Z[45],Q([0,1,17,53,93,39]),function(W,e,T,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function g(l){return l=l.trim(),l==="*"||N.test(l)}e.isValidVersionStr=g;function u(l){if(!g(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=l.match(N);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=u;function y(l){if(!l)return null;const d=l.majorBase,w=l.majorMustEqual,f=l.minorBase;let s=l.minorMustEqual;const t=l.patchBase;let n=l.patchMustEqual;l.hasCaret&&(d===0||(s=!1),n=!1);let i=0;if(l.preRelease){const r=S.exec(l.preRelease);if(r){const[,o,c,a]=r;i=Date.UTC(Number(o),Number(c)-1,Number(a))}}return{majorBase:d,majorMustEqual:w,minorBase:f,minorMustEqual:s,patchBase:t,patchMustEqual:n,isMinimum:l.hasGreaterEquals,notBefore:i}}e.normalizeVersion=y;function v(l,d,w){let f;typeof l=="string"?f=y(u(l)):f=l;let s;d instanceof Date?s=d.getTime():typeof d=="string"&&(s=new Date(d).getTime());let t;if(typeof w=="string"?t=y(u(w)):t=w,!f||!t)return!1;const n=f.majorBase,i=f.minorBase,r=f.patchBase;let o=t.majorBase,c=t.minorBase,a=t.patchBase;const h=t.notBefore;let R=t.majorMustEqual,C=t.minorMustEqual,x=t.patchMustEqual;return t.isMinimum?n>o?!0:n<o?!1:i>c?!0:i<c||s&&s<h?!1:r>=a:(n===1&&o===0&&(!R||!C||!x)&&(o=1,c=0,a=0,R=!0,C=!1,x=!1),n<o?!1:n>o?!R:i<c?!1:i>c?!C:r<a?!1:r>a?!x:!(s&&s<h))}e.isValidVersion=v;function m(l,d,w,f,s){const t=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return t.push([D.default.Error,k.localize(0,null)]),t;if(typeof f.name!="string")return t.push([D.default.Error,k.localize(1,null,"name")]),t;if(typeof f.version!="string")return t.push([D.default.Error,k.localize(2,null,"version")]),t;if(!f.engines)return t.push([D.default.Error,k.localize(3,null,"engines")]),t;if(typeof f.engines.vscode!="string")return t.push([D.default.Error,k.localize(4,null,"engines.vscode")]),t;if(typeof f.extensionDependencies<"u"&&!E(f.extensionDependencies))return t.push([D.default.Error,k.localize(5,null,"extensionDependencies")]),t;if(typeof f.activationEvents<"u"){if(!E(f.activationEvents))return t.push([D.default.Error,k.localize(6,null,"activationEvents")]),t;if(typeof f.main>"u"&&typeof f.browser>"u")return t.push([D.default.Error,k.localize(7,null,"activationEvents","main")]),t}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&t.push([D.default.Warning,k.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return t.push([D.default.Error,k.localize(9,null,"main")]),t;{const r=(0,T.joinPath)(w,f.main);(0,T.isEqualOrParent)(r,w)||t.push([D.default.Warning,k.localize(10,null,r.path,w.path)])}if(typeof f.activationEvents>"u")return t.push([D.default.Error,k.localize(11,null,"activationEvents","main")]),t}if(typeof f.browser<"u"){if(typeof f.browser!="string")return t.push([D.default.Error,k.localize(12,null,"browser")]),t;{const r=(0,T.joinPath)(w,f.browser);(0,T.isEqualOrParent)(r,w)||t.push([D.default.Warning,k.localize(13,null,r.path,w.path)])}if(typeof f.activationEvents>"u")return t.push([D.default.Error,k.localize(14,null,"activationEvents","browser")]),t}if(!L.valid(f.version))return t.push([D.default.Error,k.localize(15,null)]),t;const n=[];if(!b(l,d,f,s,n))for(const r of n)t.push([D.default.Error,r]);return t}e.validateExtensionManifest=m;function b(l,d,w,f,s){return f||typeof w.main>"u"&&typeof w.browser>"u"?!0:O(l,d,w.engines.vscode,s)}e.isValidExtensionVersion=b;function p(l,d,w){return l==="*"||O(d,w,l)}e.isEngineValid=p;function O(l,d,w,f=[]){const s=y(u(w));if(!s)return f.push(k.localize(16,null,w)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return f.push(k.localize(17,null,w)),!1}else if(!s.majorMustEqual)return f.push(k.localize(18,null,w)),!1;return v(l,d,s)?!0:(f.push(k.localize(19,null,l,w)),!1)}function E(l){if(!Array.isArray(l))return!1;for(let d=0,w=l.length;d<w;d++)if(typeof l[d]!="string")return!1;return!0}}),define(Z[108],Q([0,1,15,30]),function(W,e,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(L,N,S){let g=S&&S.get("storage.serviceMachineId",-1)||null;if(g)return g;try{const y=(await N.readFile(L.serviceMachineIdResource)).value.toString();g=(0,D.isUUID)(y)?y:null}catch{g=null}if(!g){g=(0,D.generateUuid)();try{await N.writeFile(L.serviceMachineIdResource,T.VSBuffer.fromString(g))}catch{}}return S?.store("storage.serviceMachineId",g,-1,1),g}e.getServiceMachineId=k}),define(Z[46],Q([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class T{constructor(k,L=[],N=!1){this.ctor=k,this.staticArguments=L,this.supportsDelayedInstantiation=N}}e.SyncDescriptor=T}),define(Z[109],Q([0,1,46]),function(W,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const D=[];var k;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function L(S,g,u){g instanceof T.SyncDescriptor||(g=new T.SyncDescriptor(g,[],Boolean(u))),D.push([S,g])}e.registerSingleton=L;function N(){return D}e.getSingletonServiceDescriptors=N}),define(Z[110],Q([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class T{constructor(L,N){this.key=L,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.Node=T;class D{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const N of this.a.values())N.outgoing.size===0&&L.push(N);return L}insertEdge(L,N){const S=this.lookupOrInsertNode(L),g=this.lookupOrInsertNode(N);S.outgoing.set(g.key,g),g.incoming.set(S.key,S)}removeNode(L){const N=this.b(L);this.a.delete(N);for(const S of this.a.values())S.outgoing.delete(N),S.incoming.delete(N)}lookupOrInsertNode(L){const N=this.b(L);let S=this.a.get(N);return S||(S=new T(N,L),this.a.set(N,S)),S}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[N,S]of this.a)L.push(`${N}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,N]of this.a){const S=new Set([L]),g=this.c(N,S);if(g)return g}}c(L,N){for(const[S,g]of L.outgoing){if(N.has(S))return[...N,S].join(" -> ");N.add(S);const u=this.c(g,N);if(u)return u;N.delete(S)}}}e.Graph=D}),define(Z[21],Q([0,1,5,11,8]),function(W,e,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function L(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof D.URI)}e.isConfigurationOverrides=L;function N(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof D.URI)}e.isConfigurationUpdateOverrides=N;var S;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(S=e.ConfigurationTarget||(e.ConfigurationTarget={}));function g(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=g;function u(l,d){const w=Object.create(null);for(const f in l)y(w,f,l[f],d);return w}e.toValuesTree=u;function y(l,d,w,f){const s=d.split("."),t=s.pop();let n=l;for(let i=0;i<s.length;i++){const r=s[i];let o=n[r];switch(typeof o){case"undefined":o=n[r]=Object.create(null);break;case"object":break;default:f(`Ignoring ${d} as ${s.slice(0,i+1).join(".")} is ${JSON.stringify(o)}`);return}n=o}if(typeof n=="object"&&n!==null)try{n[t]=w}catch{f(`Ignoring ${d} as ${s.join(".")} is ${JSON.stringify(n)}`)}else f(`Ignoring ${d} as ${s.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=y;function v(l,d){const w=d.split(".");m(l,w)}e.removeFromValueTree=v;function m(l,d){const w=d.shift();if(d.length===0){delete l[w];return}if(Object.keys(l).indexOf(w)!==-1){const f=l[w];typeof f=="object"&&!Array.isArray(f)&&(m(f,d),Object.keys(f).length===0&&delete l[w])}}function b(l,d,w){function f(n,i){let r=n;for(const o of i){if(typeof r!="object"||r===null)return;r=r[o]}return r}const s=d.split("."),t=f(l,s);return typeof t>"u"?w:t}e.getConfigurationValue=b;function p(l,d,w){Object.keys(d).forEach(f=>{f!=="__proto__"&&(f in l?T.isObject(l[f])&&T.isObject(d[f])?p(l[f],d[f],w):w&&(l[f]=d[f]):l[f]=d[f])})}e.merge=p;function O(l,d,w){const f=l.inspect(d),s=l.inspect(w);return typeof f.userValue<"u"||typeof f.workspaceValue<"u"||typeof f.workspaceFolderValue<"u"?f.value:typeof s.userValue<"u"||typeof s.workspaceValue<"u"||typeof s.workspaceFolderValue<"u"?s.value:f.defaultValue}e.getMigratedSettingValue=O;function E(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=E}),define(Z[58],Q([0,1,8]),function(W,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,T.createDecorator)("downloadService")}),define(Z[18],Q([0,1,8]),function(W,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,T.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,T.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[23],Q([0,1,87,8]),function(W,e,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function L(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function N(l,d){switch(l){case 3:return d==="x64"?"win32-x64":d==="ia32"?"win32-ia32":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=N;function S(l,d){return d==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=S;function g(l,d,w){return S(d,w)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===w?!0:u(w).includes(l)}e.isTargetPlatformCompatible=g;function u(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=u;function y(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=y;var v;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(v=e.SortBy||(e.SortBy={}));var m;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var b;(function(l){l.Install="install",l.Uninstall="uninstall"})(b=e.StatisticType||(e.StatisticType={}));var p;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var O;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(O=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class E extends Error{constructor(d,w){super(d),this.code=w,this.name=w}}e.ExtensionManagementError=E,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,T.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,T.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Z[59],Q([0,1,8]),function(W,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,T.createDecorator)("IExtensionSignatureVerificationService");class D{b(){return this.a||(this.a=new Promise((L,N)=>W(["node-vsce-sign"],async S=>L(S),N))),this.a}async verify(L,N){let S;try{S=await this.b()}catch{return!1}return S.verify(L,N)}}e.ExtensionSignatureVerificationService=D}),define(Z[60],Q([0,1,15,10,95,13]),function(W,e,T,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function N(y,v,m,b,p,O){let E;try{await S(y,v,m,b,p,O)}catch(l){E=l}finally{E&&p.errorTransformer&&(E=p.errorTransformer(E)),typeof E<"u"&&m.error(E),m.end()}}e.readFileIntoStream=N;async function S(y,v,m,b,p,O){g(O);const E=await y.open(v,{create:!1});try{g(O);let l=0,d=0,w=p&&typeof p.length=="number"?p.length:void 0,f=T.VSBuffer.alloc(Math.min(p.bufferSize,typeof w=="number"?w:p.bufferSize)),s=p&&typeof p.position=="number"?p.position:0,t=0;do d=await y.read(E,s,f.buffer,t,f.byteLength-t),s+=d,t+=d,l+=d,typeof w=="number"&&(w-=d),t===f.byteLength&&(await m.write(b(f)),f=T.VSBuffer.alloc(Math.min(p.bufferSize,typeof w=="number"?w:p.bufferSize)),t=0);while(d>0&&(typeof w!="number"||w>0)&&g(O)&&u(l,p));if(t>0){let n=t;typeof w=="number"&&(n=Math.min(t,w)),m.write(b(f.slice(0,n)))}}catch(l){throw(0,L.ensureFileSystemProviderError)(l)}finally{await y.close(E)}}function g(y){if(y.isCancellationRequested)throw(0,D.canceled)();return!0}function u(y,v){if(v?.limits){if(typeof v.limits.memory=="number"&&y>v.limits.memory)throw(0,L.createFileSystemProviderError)((0,k.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof v.limits.size=="number"&&y>v.limits.size)throw(0,L.createFileSystemProviderError)((0,k.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[111],Q([0,1,4,155,2,12,156]),function(W,e,T,D,k,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class S extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new T.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new T.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=T.Event.None,this.c=new Map,this.f=!1}async watch(u){const y=this.i(u),v=y.filter(b=>{const p=this.c.get(b.path);return p?!(0,D.patternsEquals)(p.request.excludes,b.excludes)||!(0,D.patternsEquals)(p.request.includes,b.includes):!0}),m=Array.from(this.c.values()).filter(({request:b})=>!y.find(p=>p.path===b.path&&(0,D.patternsEquals)(p.excludes,b.excludes)&&(0,D.patternsEquals)(p.includes,b.includes))).map(({request:b})=>b.path);v.length&&this.j(`Request to start watching: ${v.map(b=>`${b.path} (excludes: ${b.excludes.length>0?b.excludes:"<none>"}, includes: ${b.includes&&b.includes.length>0?JSON.stringify(b.includes):"<all>"})`).join(",")}`),m.length&&this.j(`Request to stop watching: ${m.join(",")}`);for(const b of m)this.h(b);for(const b of v)this.g(b)}g(u){const y=new N.NodeJSFileWatcherLibrary(u,m=>this.a.fire(m),m=>this.b.fire(m),this.f),v={request:u,instance:y};this.c.set(u.path,v)}async stop(){for(const[u]of this.c)this.h(u);this.c.clear()}h(u){const y=this.c.get(u);y&&(this.c.delete(u),y.instance.dispose())}i(u){const y=new Map;for(const v of u){const m=L.isLinux?v.path:v.path.toLowerCase();y.set(m,v)}return Array.from(y.values())}async setVerboseLogging(u){this.f=u;for(const[,y]of this.c)y.instance.setVerboseLogging(u)}j(u){this.f&&this.b.fire({type:"trace",message:this.k(u)})}k(u,y){return y?`[File Watcher (node.js)] ${u} (path: ${y.request.path})`:`[File Watcher (node.js)] ${u}`}}e.NodeJSWatcher=S}),define(Z[112],Q([0,1,61,111]),function(W,e,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends T.AbstractNonRecursiveWatcherClient{constructor(N,S,g){super(N,S,g),this.m()}l(){return new D.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(Z[113],Q([0,1,16,56,82,61]),function(W,e,T,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class N extends L.AbstractUniversalWatcherClient{constructor(g,u,y){super(g,u,y),this.m()}l(g){const u=g.add(new k.Client(T.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(u.onDidProcessExit(({code:y,signal:v})=>this.n(`terminated by itself with code ${y}, signal: ${v}`))),D.ProxyChannel.toService((0,D.getNextTickChannel)(u.getChannel("watcher")))}}e.UniversalWatcherClient=N}),define(Z[62],Q([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class T{constructor(...k){this.a=new Map;for(const[L,N]of k)this.set(L,N)}set(k,L){const N=this.a.get(k);return this.a.set(k,L),N}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.ServiceCollection=T}),define(Z[114],Q([0,1,3,10,2,46,110,8,62,157]),function(W,e,T,D,k,L,N,S,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const y=!1;class v extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class m{constructor(E=new g.ServiceCollection,l=!1,d,w=y){this.f=E,this.g=l,this.h=d,this.i=w,this.o=new Set,this.f.set(S.IInstantiationService,this),this._globalGraph=w?d?._globalGraph??new N.Graph(f=>f):void 0}createChild(E){return new m(E,this.g,this,this.i)}invokeFunction(E,...l){const d=p.traceInvocation(this.i,E);let w=!1;try{return E({get:s=>{if(w)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(s,d);if(!t)throw new Error(`[invokeFunction] unknown service '${s}'`);return t}},...l)}finally{w=!0,d.stop()}}createInstance(E,...l){let d,w;return E instanceof L.SyncDescriptor?(d=p.traceCreation(this.i,E.ctor),w=this.j(E.ctor,E.staticArguments.concat(l),d)):(d=p.traceCreation(this.i,E),w=this.j(E,l,d)),d.stop(),w}j(E,l=[],d){const w=S._util.getServiceDependencies(E).sort((t,n)=>t.index-n.index),f=[];for(const t of w){const n=this.m(t.id,d);n||this.u(`[createInstance] ${E.name} depends on UNKNOWN service ${t.id}.`,!1),f.push(n)}const s=w.length>0?w[0].index:l.length;if(l.length!==s){console.trace(`[createInstance] First service dependency of ${E.name} at position ${s+1} conflicts with ${l.length} static arguments`);const t=s-l.length;t>0?l=l.concat(new Array(t)):l=l.slice(0,s)}return Reflect.construct(E,l.concat(f))}k(E,l){if(this.f.get(E)instanceof L.SyncDescriptor)this.f.set(E,l);else if(this.h)this.h.k(E,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(E){const l=this.f.get(E);return!l&&this.h?this.h.l(E):l}m(E,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(E));const d=this.l(E);return d instanceof L.SyncDescriptor?this.q(E,d,l.branch(E,!0)):(l.branch(E,!1),d)}q(E,l,d){if(this.o.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this.o.add(E);try{return this.r(E,l,d)}finally{this.o.delete(E)}}r(E,l,d){const w=new N.Graph(t=>t.id.toString());let f=0;const s=[{id:E,desc:l,_trace:d}];for(;s.length;){const t=s.pop();if(w.lookupOrInsertNode(t),f++>1e3)throw new v(w);for(const n of S._util.getServiceDependencies(t.desc.ctor)){const i=this.l(n.id);if(i||this.u(`[createInstance] ${E} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(n.id)),i instanceof L.SyncDescriptor){const r={id:n.id,desc:i,_trace:t._trace.branch(n.id,!0)};w.insertEdge(t,r),s.push(r)}}}for(;;){const t=w.roots();if(t.length===0){if(!w.isEmpty())throw new v(w);break}for(const{data:n}of t){if(this.l(n.id)instanceof L.SyncDescriptor){const r=this.s(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this.k(n.id,r)}w.removeNode(n)}}return this.l(E)}s(E,l,d=[],w,f){if(this.f.get(E)instanceof L.SyncDescriptor)return this.t(E,l,d,w,f);if(this.h)return this.h.s(E,l,d,w,f);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(E,l,d=[],w,f){if(w){const s=new m(void 0,this.g,this,this.i);s.c=String(E);const t=new Map,n=new T.IdleValue(()=>{const i=s.j(l,d,f);for(const[r,o]of t){const c=i[r];if(typeof c=="function")for(const a of o)c.apply(i,a)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,r){if(!n.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let a=t.get(r);return a||(a=new u.LinkedList,t.set(r,a)),(R,C,x)=>{const Y=a.push([R,C,x]);return(0,k.toDisposable)(Y)}}if(r in i)return i[r];const o=n.value;let c=o[r];return typeof c!="function"||(c=c.bind(o),i[r]=c),c},set(i,r,o){return n.value[r]=o,!0},getPrototypeOf(i){return l.prototype}})}else return this.j(l,d,f)}u(E,l){if(l&&console.warn(E),this.g)throw new Error(E)}}e.InstantiationService=m;var b;(function(O){O[O.None=0]="None",O[O.Creation=1]="Creation",O[O.Invocation=2]="Invocation",O[O.Branch=3]="Branch"})(b||(b={}));class p{static traceInvocation(E,l){return E?new p(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(E,l){return E?new p(1,l.name):p.c}constructor(E,l){this.type=E,this.name=l,this.g=Date.now(),this.h=[]}branch(E,l){const d=new p(3,E.toString());return this.h.push([E,l,d]),d}stop(){const E=Date.now()-this.g;p.f+=E;let l=!1;function d(f,s){const t=[],n=new Array(f+1).join("	");for(const[i,r,o]of s.h)if(r&&o){l=!0,t.push(`${n}CREATES -> ${i}`);const c=d(f+1,o);c&&t.push(c)}else t.push(`${n}uses -> ${i}`);return t.join(`
`)}const w=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(E>2||l)&&p.all.add(w.join(`
`))}}e.Trace=p,p.all=new Set,p.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}},p.f=0});var ee=this&&this.__param||function(W,e){return function(T,D){e(T,D,W)}};define(Z[63],Q([0,1,22,2,12,97,23,8]),function(W,e,T,D,k,L,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function g(y){return y.tags.find(v=>v.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=g,e.ILanguagePackService=(0,S.createDecorator)("languagePackService");let u=class extends D.Disposable{constructor(v){super(),this.c=v}async getAvailableLanguages(){const v=new T.CancellationTokenSource;setTimeout(()=>v.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},v.token)}catch{return[]}const p=m.firstPage.filter(O=>O.properties.localizedLanguages?.length&&O.tags.some(E=>E.startsWith("lp-"))).map(O=>{const E=O.properties.localizedLanguages?.[0],l=g(O);return{...this.f(l,E,O),extensionId:O.identifier.id,galleryExtension:O}});return p.push({...this.f("en","English"),extensionId:"default"}),p}f(v,m,b){const p=m??v;let O;if(p!==v&&(O=`(${v})`),v.toLowerCase()===k.language.toLowerCase()&&(O??="",O+=(0,L.localize)(0,null)),b?.installCount){O??="";const E=b.installCount;let l;E>1e6?l=`${Math.floor(E/1e5)/10}M`:E>1e3?l=`${Math.floor(E/1e3)}K`:l=String(E),O+=` $(cloud-download) ${l}`}return{id:v,label:p,description:O}}};u=me([ee(0,N.IExtensionGalleryService)],u),e.LanguagePackBaseService=u}),define(Z[9],Q([0,1,34,4,2,36,12,11,8]),function(W,e,T,D,k,L,N,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,g.createDecorator)("logService"),e.ILoggerService=(0,g.createDecorator)("loggerService");function u(){return new Date().toISOString()}var y;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;function v(c,a,h){switch(a){case y.Trace:c.trace(h);break;case y.Debug:c.debug(h);break;case y.Info:c.info(h);break;case y.Warning:c.warn(h);break;case y.Error:c.error(h);break;case y.Off:break;default:throw new Error(`Invalid log level ${a}`)}}e.log=v;function m(c){let a="";for(let h=0;h<c.length;h++){let R=c[h];if(typeof R=="object")try{R=JSON.stringify(R)}catch{}a+=(h>0?" ":"")+R}return a}e.format=m;class b extends k.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new D.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(a){this.b!==a&&(this.b=a,this.c.fire(this.b))}getLevel(){return this.b}f(a){return this.b!==y.Off&&this.b<=a}}e.AbstractLogger=b;class p extends b{constructor(a){super(),this.h=a}f(a){return this.h||super.f(a)}trace(a,...h){this.f(y.Trace)&&this.g(y.Trace,m([a,...h]))}debug(a,...h){this.f(y.Debug)&&this.g(y.Debug,m([a,...h]))}info(a,...h){this.f(y.Info)&&this.g(y.Info,m([a,...h]))}warn(a,...h){this.f(y.Warning)&&this.g(y.Warning,m([a,...h]))}error(a,...h){if(this.f(y.Error))if(a instanceof Error){const R=Array.prototype.slice.call(arguments);R[0]=a.stack,this.g(y.Error,m(R))}else this.g(y.Error,m([a,...h]))}flush(){}}e.AbstractMessageLogger=p;class O extends b{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.g=!N.isWindows}trace(a,...h){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,a,...h):console.log(`[main ${u()}]`,a,...h))}debug(a,...h){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,a,...h):console.log(`[main ${u()}]`,a,...h))}info(a,...h){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,a,...h):console.log(`[main ${u()}]`,a,...h))}warn(a,...h){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,a,...h):console.warn(`[main ${u()}]`,a,...h))}error(a,...h){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,a,...h):console.error(`[main ${u()}]`,a,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=O;class E extends b{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...h){this.f(y.Trace)&&console.log("%cTRACE","color: #888",a,...h)}debug(a,...h){this.f(y.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",a,...h)}info(a,...h){this.f(y.Info)&&console.log("%c INFO","color: #33f",a,...h)}warn(a,...h){this.f(y.Warning)&&console.log("%c WARN","color: #993",a,...h)}error(a,...h){this.f(y.Error)&&console.log("%c  ERR","color: #f33",a,...h)}dispose(){}flush(){}}e.ConsoleLogger=E;class l extends b{constructor(a,h=e.DEFAULT_LOG_LEVEL){super(),this.g=a,this.setLevel(h)}trace(a,...h){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(a),...h])}debug(a,...h){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(a),...h])}info(a,...h){this.f(y.Info)&&this.g.log(y.Info,[this.h(a),...h])}warn(a,...h){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(a),...h])}error(a,...h){this.f(y.Error)&&this.g.log(y.Error,[this.h(a),...h])}h(a){return typeof a=="string"?a:(0,T.toErrorMessage)(a,this.f(y.Trace))}dispose(){}flush(){}}e.AdapterLogger=l;class d extends b{constructor(a){super(),this.g=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const h of this.g)h.setLevel(a);super.setLevel(a)}trace(a,...h){for(const R of this.g)R.trace(a,...h)}debug(a,...h){for(const R of this.g)R.debug(a,...h)}info(a,...h){for(const R of this.g)R.info(a,...h)}warn(a,...h){for(const R of this.g)R.warn(a,...h)}error(a,...h){for(const R of this.g)R.error(a,...h)}flush(){for(const a of this.g)a.flush()}dispose(){for(const a of this.g)a.dispose()}}e.MultiplexLogService=d;class w extends k.Disposable{constructor(a){super(),this.b=a,this.B(a)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(a){this.b.setLevel(a)}getLevel(){return this.b.getLevel()}trace(a,...h){this.b.trace(a,...h)}debug(a,...h){this.b.debug(a,...h)}info(a,...h){this.b.info(a,...h)}warn(a,...h){this.b.warn(a,...h)}error(a,...h){this.b.error(a,...h)}flush(){this.b.flush()}}e.LogService=w;class f extends k.Disposable{constructor(a,h){super(),this.c=a,this.b=new L.ResourceMap,this.B(h(R=>this.setLevel(R)))}getLoggers(){return[...this.b.values()].map(({logger:a})=>a)}getLogger(a){return this.b.get(a)?.logger}createLogger(a,h,R){let C=this.b.get(a)?.logger;return C||(R=h?.always?y.Trace:R,C=this.f(a,R??this.c,h),this.b.set(a,{logger:C,logLevel:R})),C}setLevel(a,h){const R=S.URI.isUri(a)?a:void 0,C=R?h:a;if(R){const x=this.b.get(R);x&&x.logLevel!==C&&(x.logLevel=C,x.logger.setLevel(C))}else this.c=C,this.b.forEach(({logLevel:x,logger:Y})=>{x===void 0&&Y.setLevel(this.c)})}getLogLevel(a){return this.b.get(a)?.logLevel}dispose(){this.b.forEach(({logger:a})=>a.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=f;class s{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(a){}getLevel(){return y.Info}trace(a,...h){}debug(a,...h){}info(a,...h){}warn(a,...h){}error(a,...h){}critical(a,...h){}dispose(){}flush(){}}e.NullLogger=s;class t extends s{}e.NullLogService=t;class n extends f{constructor(){super(y.Info,D.Event.None)}f(a,h,R){return new s}}e.NullLoggerService=n;function i(c){if(c.verbose)return y.Trace;if(typeof c.logLevel=="string"){const a=o(c.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=i;function r(c){switch(c){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.LogLevelToString=r;function o(c){switch(c){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.parseLogLevel=o}),define(Z[115],Q([0,1,19,3,10,4,2,14,61,9]),function(W,e,T,D,k,L,N,S,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class y extends N.Disposable{constructor(m,b){super(),this.a=m,this.b=b,this.c=this.B(new L.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new L.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new D.ThrottledDelayer(0)),this.s=[],this.t=this.B(new D.ThrottledDelayer(0))}watch(m,b){return b.recursive||this.b?.watcher?.forceUniversal?this.l(m,b):this.u(m,b)}l(m,b){const p={path:this.C(m),excludes:b.excludes,includes:b.includes,recursive:b.recursive},O=(0,T.insert)(this.j,p);return this.m(),(0,N.toDisposable)(()=>{O(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(m=>(0,k.onUnexpectedError)(m))}n(){this.h||(this.h=this.B(this.p(b=>this.c.fire((0,g.toFileChanges)(b)),b=>this.z(b),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const b of this.j)(0,g.isRecursiveWatchRequest)(b)&&(b.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const b of this.j)(0,g.isRecursiveWatchRequest)(b)&&m.includes(b.path)&&(b.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(m,b){const p={path:this.C(m),excludes:b.excludes,includes:b.includes,recursive:!1},O=(0,T.insert)(this.s,p);return this.v(),(0,N.toDisposable)(()=>{O(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(m=>(0,k.onUnexpectedError)(m))}w(){return this.r||(this.r=this.B(this.y(m=>this.c.fire((0,g.toFileChanges)(m)),m=>this.z(m),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)}))),this.r.watch(this.s)}z(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}C(m){return(0,S.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=y}),define(Z[116],Q([0,1,19,3,15,22,4,52,64,2,54,16,117,17,43,94,13,60,9]),function(W,e,T,D,k,L,N,S,g,u,y,v,m,b,p,O,E,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class extends u.Disposable{constructor(s){super(),this.b=s,this.a=256*1024,this.c=this.B(new N.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new N.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new N.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new N.Emitter),this.onDidRunOperation=this.m.event,this.Q=this.B(new N.Emitter),this.onDidFilesChange=this.Q.event,this.R=this.B(new N.Emitter),this.onDidWatchError=this.R.event,this.S=new Map,this.W=this.B(new D.ResourceQueue)}registerProvider(s,t){if(this.h.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${s}`);const n=new u.DisposableStore;return this.h.set(s,t),this.c.fire({added:!0,scheme:s,provider:t}),n.add(t.onDidChangeFile(i=>this.Q.fire(new E.FileChangesEvent(i,!this.N(t))))),typeof t.onDidWatchError=="function"&&n.add(t.onDidWatchError(i=>this.R.fire(new Error(i)))),n.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:s}))),(0,u.toDisposable)(()=>{this.c.fire({added:!1,scheme:s,provider:t}),this.h.delete(s),(0,u.dispose)(n)})}getProvider(s){return this.h.get(s)}async activateProvider(s){const t=[];this.f.fire({scheme:s,join(n){t.push(n)}}),!this.h.has(s)&&await D.Promises.settled(t)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.h.has(s.scheme)}hasCapability(s,t){const n=this.h.get(s.scheme);return!!(n&&n.capabilities&t)}listCapabilities(){return g.Iterable.map(this.h,([s,t])=>({scheme:s,capabilities:t.capabilities}))}async j(s){if(!(0,b.isAbsolutePath)(s))throw new E.FileOperationError((0,O.localize)(0,null,this.mb(s)),8);await this.activateProvider(s.scheme);const t=this.h.get(s.scheme);if(!t){const n=new Error;throw n.name="ENOPRO",n.message=(0,O.localize)(1,null,s.toString()),n}return t}async k(s){const t=await this.j(s);if((0,E.hasOpenReadWriteCloseCapability)(t)||(0,E.hasReadWriteCapability)(t)||(0,E.hasFileReadStreamCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(s){const t=await this.j(s);if((0,E.hasOpenReadWriteCloseCapability)(t)||(0,E.hasReadWriteCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,t){try{return await this.n(s,t)}catch(n){throw(0,E.toFileSystemProviderErrorCode)(n)===E.FileSystemProviderErrorCode.FileNotFound?new E.FileOperationError((0,O.localize)(2,null,this.mb(s)),1):(0,E.ensureFileSystemProviderError)(n)}}async n(s,t){const n=await this.j(s),i=this.N(n),r=t?.resolveTo,o=t?.resolveSingleChildDescendants,c=t?.resolveMetadata,a=await n.stat(s);let h;return this.p(n,s,a,void 0,!!c,(R,C)=>(h||(h=y.TernarySearchTree.forUris(()=>!i),h.set(s,!0),r&&h.fill(!0,r)),h.get(R.resource)||h.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&o?C===1:!1))}async p(s,t,n,i,r,o){const{providerExtUri:c}=this.M(s),a={resource:t,name:c.basename(t),isFile:(n.type&E.FileType.File)!==0,isDirectory:(n.type&E.FileType.Directory)!==0,isSymbolicLink:(n.type&E.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&E.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,E.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(a.isDirectory&&o(a,i)){try{const h=await s.readdir(t),R=await D.Promises.settled(h.map(async([C,x])=>{try{const Y=c.joinPath(t,C),X=r?await s.stat(Y):{type:x};return await this.p(s,Y,X,h.length,r,o)}catch(Y){return this.b.trace(Y),null}}));a.children=(0,T.coalesce)(R)}catch(h){this.b.trace(h),a.children=[]}return a}return a}async resolveAll(s){return D.Promises.settled(s.map(async t=>{try{return{stat:await this.n(t.resource,t.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(s){const t=await this.j(s),n=await t.stat(s);return this.p(t,s,n,void 0,!0,()=>!1)}async exists(s){const t=await this.j(s);try{return!!await t.stat(s)}catch{return!1}}async canCreateFile(s,t){try{await this.r(s,t)}catch(n){return n}return!0}async r(s,t){if(!t?.overwrite&&await this.exists(s))throw new E.FileOperationError((0,O.localize)(3,null,this.mb(s)),3,t)}async createFile(s,t=k.VSBuffer.fromString(""),n){await this.r(s,n);const i=await this.writeFile(s,t);return this.m.fire(new E.FileOperationEvent(s,0,i)),i}async writeFile(s,t,n){const i=this.kb(await this.l(s),s),{providerExtUri:r}=this.M(i);try{await this.s(i,s,n)||await this.O(i,r.dirname(s));let c;if((0,E.hasReadWriteCapability)(i)&&!(t instanceof k.VSBuffer))if((0,p.isReadableStream)(t)){const a=await(0,p.peekStream)(t,3);a.ended?c=k.VSBuffer.concat(a.buffer):c=a}else c=(0,p.peekReadable)(t,a=>k.VSBuffer.concat(a),3);else c=t;!(0,E.hasOpenReadWriteCloseCapability)(i)||(0,E.hasReadWriteCapability)(i)&&c instanceof k.VSBuffer?await this.bb(i,s,n,c):await this.X(i,s,n,c instanceof k.VSBuffer?(0,k.bufferToReadable)(c):c),this.m.fire(new E.FileOperationEvent(s,4))}catch(o){throw new E.FileOperationError((0,O.localize)(4,null,this.mb(s),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),n)}return this.resolve(s,{resolveMetadata:!0})}async s(s,t,n){if(!!n?.unlock&&!(s.capabilities&8192))throw new Error((0,O.localize)(5,null,this.mb(t)));let r;try{r=await s.stat(t)}catch{return}if((r.type&E.FileType.Directory)!==0)throw new E.FileOperationError((0,O.localize)(6,null,this.mb(t)),0,n);if(this.lb(t,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==E.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,E.etag)({mtime:n.mtime,size:r.size}))throw new E.FileOperationError((0,O.localize)(7,null),3,n);return r}async readFile(s,t,n){const i=await this.k(s);return t?.atomic?this.t(i,s,t,n):this.u(i,s,t,n)}async t(s,t,n,i){return new Promise((r,o)=>{this.W.queueFor(t,this.M(s).providerExtUri).queue(async()=>{try{const c=await this.u(s,t,n,i);r(c)}catch(c){o(c)}})})}async u(s,t,n,i){const r=await this.v(s,t,{...n,preferUnbuffered:!0},i);return{...r,value:await(0,k.streamToBuffer)(r.value)}}async readFileStream(s,t,n){const i=await this.k(s);return this.v(i,s,t,n)}async v(s,t,n,i){const r=new L.CancellationTokenSource(i),o=this.D(t,n).then(a=>a,a=>{throw r.cancel(),a});let c;try{return typeof n?.etag=="string"&&n.etag!==E.ETAG_DISABLED&&await o,n?.atomic&&(0,E.hasFileAtomicReadCapability)(s)||!((0,E.hasOpenReadWriteCloseCapability)(s)||(0,E.hasFileReadStreamCapability)(s))||(0,E.hasReadWriteCapability)(s)&&n?.preferUnbuffered?c=this.C(s,t,n):(0,E.hasFileReadStreamCapability)(s)?c=this.w(s,t,r.token,n):c=this.z(s,t,r.token,n),{...await o,value:c}}catch(a){c&&await(0,p.consumeStream)(c);const h=(0,O.localize)(8,null,this.mb(t),(0,E.ensureFileSystemProviderError)(a).toString());throw a instanceof E.NotModifiedSinceFileOperationError?new E.NotModifiedSinceFileOperationError(h,a.stat,n):new E.FileOperationError(h,(0,E.toFileOperationResult)(a),n)}}w(s,t,n,i=Object.create(null)){const r=s.readFileStream(t,i,n);return(0,p.transform)(r,{data:o=>o instanceof k.VSBuffer?o:k.VSBuffer.wrap(o),error:o=>new E.FileOperationError((0,O.localize)(9,null,this.mb(t),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),i)},o=>k.VSBuffer.concat(o))}z(s,t,n,i=Object.create(null)){const r=(0,k.newWriteableBufferStream)();return(0,l.readFileIntoStream)(s,t,r,o=>o,{...i,bufferSize:this.a,errorTransformer:o=>new E.FileOperationError((0,O.localize)(10,null,this.mb(t),(0,E.ensureFileSystemProviderError)(o).toString()),(0,E.toFileOperationResult)(o),i)},n),r}C(s,t,n){const i=(0,p.newWriteableStream)(r=>k.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,E.hasFileAtomicReadCapability)(s)?r=await s.readFile(t,{atomic:!0}):r=await s.readFile(t),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.F(t,r.byteLength,n),i.end(k.VSBuffer.wrap(r))}catch(r){i.error(r),i.end()}})(),i}async D(s,t){const n=await this.resolve(s,{resolveMetadata:!0});if(n.isDirectory)throw new E.FileOperationError((0,O.localize)(11,null,this.mb(s)),0,t);if(typeof t?.etag=="string"&&t.etag!==E.ETAG_DISABLED&&t.etag===n.etag)throw new E.NotModifiedSinceFileOperationError((0,O.localize)(12,null),n,t);return this.F(s,n.size,t),n}F(s,t,n){if(n?.limits){let i;if(typeof n.limits.memory=="number"&&t>n.limits.memory&&(i=9),typeof n.limits.size=="number"&&t>n.limits.size&&(i=7),typeof i=="number")throw new E.FileOperationError((0,O.localize)(13,null,this.mb(s)),i)}}async canMove(s,t,n){return this.G(s,t,"move",n)}async canCopy(s,t,n){return this.G(s,t,"copy",n)}async G(s,t,n,i){if(s.toString()!==t.toString())try{const r=n==="move"?this.kb(await this.l(s),s):await this.k(s),o=this.kb(await this.l(t),t);await this.L(r,s,o,t,n,i)}catch(r){return r}return!0}async move(s,t,n){const i=this.kb(await this.l(s),s),r=this.kb(await this.l(t),t),o=await this.H(i,s,r,t,"move",!!n),c=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new E.FileOperationEvent(s,o==="move"?2:3,c)),c}async copy(s,t,n){const i=await this.k(s),r=this.kb(await this.l(t),t),o=await this.H(i,s,r,t,"copy",!!n),c=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new E.FileOperationEvent(s,o==="copy"?3:2,c)),c}async H(s,t,n,i,r,o){if(t.toString()===i.toString())return r;const{exists:c,isSameResourceWithDifferentPathCase:a}=await this.L(s,t,n,i,r,o);if(c&&!a&&o&&await this.del(i,{recursive:!0}),await this.O(n,this.M(n).providerExtUri.dirname(i)),r==="copy"){if(s===n&&(0,E.hasFileFolderCopyCapability)(s))await s.copy(t,i,{overwrite:o});else{const h=await this.resolve(t);h.isDirectory?await this.J(s,h,n,i):await this.I(s,t,n,i)}return r}else return s===n?(await s.rename(t,i,{overwrite:o}),r):(await this.H(s,t,n,i,"copy",o),await this.del(t,{recursive:!0}),"copy")}async I(s,t,n,i){if((0,E.hasOpenReadWriteCloseCapability)(s)&&(0,E.hasOpenReadWriteCloseCapability)(n))return this.db(s,t,n,i);if((0,E.hasOpenReadWriteCloseCapability)(s)&&(0,E.hasReadWriteCapability)(n))return this.jb(s,t,n,i);if((0,E.hasReadWriteCapability)(s)&&(0,E.hasOpenReadWriteCloseCapability)(n))return this.hb(s,t,n,i);if((0,E.hasReadWriteCapability)(s)&&(0,E.hasReadWriteCapability)(n))return this.fb(s,t,n,i)}async J(s,t,n,i){await n.mkdir(i),Array.isArray(t.children)&&await D.Promises.settled(t.children.map(async r=>{const o=this.M(n).providerExtUri.joinPath(i,r.name);return r.isDirectory?this.J(s,await this.resolve(r.resource),n,o):this.I(s,r.resource,n,o)}))}async L(s,t,n,i,r,o){let c=!1;if(s===n){const{providerExtUri:h,isPathCaseSensitive:R}=this.M(s);if(R||(c=h.isEqual(t,i)),c&&r==="copy")throw new Error((0,O.localize)(14,null,this.mb(t),this.mb(i)));if(!c&&h.isEqualOrParent(i,t))throw new Error((0,O.localize)(15,null,this.mb(t),this.mb(i)))}const a=await this.exists(i);if(a&&!c){if(!o)throw new E.FileOperationError((0,O.localize)(16,null,this.mb(t),this.mb(i)),4);if(s===n){const{providerExtUri:h}=this.M(s);if(h.isEqualOrParent(t,i))throw new Error((0,O.localize)(17,null,this.mb(t),this.mb(i)))}}return{exists:a,isSameResourceWithDifferentPathCase:c}}M(s){const t=this.N(s);return{providerExtUri:t?b.extUri:b.extUriIgnorePathCase,isPathCaseSensitive:t}}N(s){return!!(s.capabilities&1024)}async createFolder(s){const t=this.kb(await this.j(s),s);await this.O(t,s);const n=await this.resolve(s,{resolveMetadata:!0});return this.m.fire(new E.FileOperationEvent(s,0,n)),n}async O(s,t){const n=[],{providerExtUri:i}=this.M(s);for(;!i.isEqual(t,i.dirname(t));)try{if(((await s.stat(t)).type&E.FileType.Directory)===0)throw new Error((0,O.localize)(18,null,this.mb(t)));break}catch(r){if((0,E.toFileSystemProviderErrorCode)(r)!==E.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(i.basename(t)),t=i.dirname(t)}for(let r=n.length-1;r>=0;r--){t=i.joinPath(t,n[r]);try{await s.mkdir(t)}catch(o){if((0,E.toFileSystemProviderErrorCode)(o)!==E.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,t){try{await this.P(s,t)}catch(n){return n}return!0}async P(s,t){const n=this.kb(await this.j(s),s);if(!!t?.useTrash&&!(n.capabilities&4096))throw new Error((0,O.localize)(19,null,this.mb(s)));let r;try{r=await n.stat(s)}catch{}if(r)this.lb(s,r);else throw new E.FileOperationError((0,O.localize)(20,null,this.mb(s)),1);if(!!!t?.recursive){const c=await this.resolve(s);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,O.localize)(21,null,this.mb(s)))}return n}async del(s,t){const n=await this.P(s,t),i=!!t?.useTrash,r=!!t?.recursive;await n.delete(s,{recursive:r,useTrash:i}),this.m.fire(new E.FileOperationEvent(s,1))}async cloneFile(s,t){const n=await this.j(s),i=this.kb(await this.l(t),t);if(n===i&&this.M(n).providerExtUri.isEqual(s,t))return;if(n===i&&(0,E.hasFileCloneCapability)(n))return n.cloneFile(s,t);await this.O(i,this.M(i).providerExtUri.dirname(t));const r=this.W.queueFor(s,this.M(n).providerExtUri);return n===i&&(0,E.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(s,t,{overwrite:!0})):r.queue(()=>this.I(n,s,i,t))}watch(s,t={recursive:!1,excludes:[]}){const n=new u.DisposableStore;let i=!1,r=()=>{i=!0};return n.add((0,u.toDisposable)(()=>r())),(async()=>{try{const o=await this.U(s,t);i?(0,u.dispose)(o):r=()=>(0,u.dispose)(o)}catch(o){this.b.error(o)}})(),n}async U(s,t){const n=await this.j(s),i=(0,S.hash)([this.M(n).providerExtUri.getComparisonKey(s),t]);let r=this.S.get(i);return r||(r={count:0,disposable:n.watch(s,t)},this.S.set(i,r)),r.count+=1,(0,u.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,u.dispose)(r.disposable),this.S.delete(i)))})}dispose(){super.dispose();for(const[,s]of this.S)(0,u.dispose)(s.disposable);this.S.clear()}async X(s,t,n,i){return this.W.queueFor(t,this.M(s).providerExtUri).queue(async()=>{const r=await s.open(t,{create:!0,unlock:n?.unlock??!1});try{(0,p.isReadableStream)(i)||(0,p.isReadableBufferedStream)(i)?await this.Y(s,r,i):await this.Z(s,r,i)}catch(o){throw(0,E.ensureFileSystemProviderError)(o)}finally{await s.close(r)}})}async Y(s,t,n){let i=0,r;if((0,p.isReadableBufferedStream)(n)){if(n.buffer.length>0){const o=k.VSBuffer.concat(n.buffer);await this.ab(s,t,o,o.byteLength,i,0),i+=o.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((o,c)=>{(0,p.listenStream)(r,{onData:async a=>{r.pause();try{await this.ab(s,t,a,a.byteLength,i,0)}catch(h){return c(h)}i+=a.byteLength,setTimeout(()=>r.resume())},onError:a=>c(a),onEnd:()=>o()})})}async Z(s,t,n){let i=0,r;for(;(r=n.read())!==null;)await this.ab(s,t,r,r.byteLength,i,0),i+=r.byteLength}async ab(s,t,n,i,r,o){let c=0;for(;c<i;)c+=await s.write(t,r+c,n.buffer,o+c,i-c)}async bb(s,t,n,i){return this.W.queueFor(t,this.M(s).providerExtUri).queue(()=>this.cb(s,t,n,i))}async cb(s,t,n,i){let r;i instanceof k.VSBuffer?r=i:(0,p.isReadableStream)(i)?r=await(0,k.streamToBuffer)(i):(0,p.isReadableBufferedStream)(i)?r=await(0,k.bufferedStreamToBuffer)(i):r=(0,k.readableToBuffer)(i),await s.writeFile(t,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async db(s,t,n,i){return this.W.queueFor(i,this.M(n).providerExtUri).queue(()=>this.eb(s,t,n,i))}async eb(s,t,n,i){let r,o;try{r=await s.open(t,{create:!1}),o=await n.open(i,{create:!0,unlock:!1});const c=k.VSBuffer.alloc(this.a);let a=0,h=0,R=0;do R=await s.read(r,a,c.buffer,h,c.byteLength-h),await this.ab(n,o,c,R,a,h),a+=R,h+=R,h===c.byteLength&&(h=0);while(R>0)}catch(c){throw(0,E.ensureFileSystemProviderError)(c)}finally{await D.Promises.settled([typeof r=="number"?s.close(r):Promise.resolve(),typeof o=="number"?n.close(o):Promise.resolve()])}}async fb(s,t,n,i){return this.W.queueFor(i,this.M(n).providerExtUri).queue(()=>this.gb(s,t,n,i))}async gb(s,t,n,i){return n.writeFile(i,await s.readFile(t),{create:!0,overwrite:!0,unlock:!1})}async hb(s,t,n,i){return this.W.queueFor(i,this.M(n).providerExtUri).queue(()=>this.ib(s,t,n,i))}async ib(s,t,n,i){const r=await n.open(i,{create:!0,unlock:!1});try{const o=await s.readFile(t);await this.ab(n,r,k.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,E.ensureFileSystemProviderError)(o)}finally{await n.close(r)}}async jb(s,t,n,i){const r=await(0,k.streamToBuffer)(this.z(s,t,L.CancellationToken.None));await this.bb(n,i,void 0,r)}kb(s,t){if(s.capabilities&2048)throw new E.FileOperationError((0,O.localize)(22,null,this.mb(t)),6);return s}lb(s,t){if((t.permissions??0)&E.FilePermission.Readonly)throw new E.FileOperationError((0,O.localize)(23,null,this.mb(s)),6)}mb(s){return s.scheme===v.Schemas.file?s.fsPath:s.toString(!0)}};w=me([ee(0,d.ILogService)],w),e.FileService=w}),define(Z[118],Q([0,1,119,158,3,36,15,4,159,2,14,12,17,43,20,96,13,60,115,34,113,112]),function(W,e,T,D,k,L,N,S,g,u,y,v,m,b,p,O,E,l,d,w,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,D.gracefulify)(T)}catch(n){console.error(`Error enabling graceful-fs: ${(0,w.toErrorMessage)(n)}`)}})();class t extends d.AbstractDiskFileSystemProvider{constructor(i,r){super(i,r),this.onDidChangeCapabilities=S.Event.None,this.H=new L.ResourceMap(o=>m.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,v.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:r,symbolicLink:o}=await p.SymlinkSupport.stat(this.C(i));return{type:this.G(r,o),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.Y(r)}}async readdir(i){try{const r=await p.Promises.readdir(this.C(i),{withFileTypes:!0}),o=[];return await Promise.all(r.map(async c=>{try{let a;c.isSymbolicLink()?a=(await this.stat((0,m.joinPath)(i,c.name))).type:a=this.G(c),o.push([c.name,a])}catch(a){this.a.trace(a)}})),o}catch(r){throw this.Y(r)}}G(i,r){let o;return r?.dangling?o=E.FileType.Unknown:i.isFile()?o=E.FileType.File:i.isDirectory()?o=E.FileType.Directory:o=E.FileType.Unknown,r&&(o|=E.FileType.SymbolicLink),o}async I(i){const r=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let o;for(;o=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await o.wait();const c=new k.Barrier;return this.H.set(i,c),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,u.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.H.get(i)===c&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),c.open()})}async readFile(i,r){let o;try{r?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),o=await this.I(i));const c=this.C(i);return await p.Promises.readFile(c)}catch(c){throw this.Y(c)}finally{o?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,r,o){const c=(0,b.newWriteableStream)(a=>N.VSBuffer.concat(a.map(h=>N.VSBuffer.wrap(h))).buffer);return(0,l.readFileIntoStream)(this,i,c,a=>a.buffer,{...r,bufferSize:256*1024},o),c}async writeFile(i,r,o){let c;try{const a=this.C(i);if(!o.create||!o.overwrite){if(await p.Promises.exists(a)){if(!o.overwrite)throw(0,E.createFileSystemProviderError)((0,O.localize)(0,null),E.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,E.createFileSystemProviderError)((0,O.localize)(1,null),E.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(c,0,r,0,r.byteLength)}catch(a){throw await this.Z(i,a)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(i){t.O=i}async open(i,r){const o=this.C(i);let c;(0,E.isFileOpenForWriteOptions)(r)&&(c=await this.I(i));let a;try{if((0,E.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:R}=await p.SymlinkSupport.stat(o);R.mode&128||await p.Promises.chmod(o,R.mode|128)}catch(R){this.a.trace(R)}let h;if((0,E.isFileOpenForWriteOptions)(r)){if(v.isWindows)try{await p.Promises.truncate(o,0),h="r+"}catch(R){R.code!=="ENOENT"&&this.a.trace(R)}h||(h="w")}else h="r";a=await p.Promises.open(o,h)}catch(h){throw c?.dispose(),(0,E.isFileOpenForWriteOptions)(r)?await this.Z(i,h):this.Y(h)}if(this.L.set(a,0),(0,E.isFileOpenForWriteOptions)(r)&&this.N.set(a,i),c){const h=this.M.get(a);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${o})`),this.M.set(a,c),h&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${o})`),h.dispose())}return a}async close(i){const r=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await p.Promises.fdatasync(i)}catch(o){t.configureFlushOnWrite(!1),this.a.error(o)}return await p.Promises.close(i)}catch(o){throw this.Y(o)}finally{r&&(this.M.get(i)===r&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),r.dispose())}}async read(i,r,o,c,a){const h=this.P(i,r);let R=null;try{R=(await p.Promises.read(i,o,c,a,h)).bytesRead}catch(C){throw this.Y(C)}finally{this.Q(i,h,R)}return R}P(i,r){return r===this.L.get(i)?null:r}Q(i,r,o){const c=this.L.get(i);typeof c=="number"&&(typeof r=="number"||(typeof o=="number"?this.L.set(i,c+o):this.L.delete(i)))}async write(i,r,o,c,a){return(0,k.retry)(()=>this.R(i,r,o,c,a),100,3)}async R(i,r,o,c,a){const h=this.P(i,r);let R=null;try{R=(await p.Promises.write(i,o,c,a,h)).bytesWritten}catch(C){throw await this.Z(this.N.get(i),C)}finally{this.Q(i,h,R)}return R}async mkdir(i){try{await p.Promises.mkdir(this.C(i))}catch(r){throw this.Y(r)}}async delete(i,r){try{const o=this.C(i);r.recursive?await p.Promises.rm(o,p.RimRafMode.MOVE):await p.Promises.unlink(o)}catch(o){throw this.Y(o)}}async rename(i,r,o){const c=this.C(i),a=this.C(r);if(c!==a)try{await this.S(i,r,"move",o.overwrite),await p.Promises.move(c,a)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,O.localize)(2,null,(0,y.basename)(c),(0,y.basename)((0,y.dirname)(a)),h.toString()))),this.Y(h)}}async copy(i,r,o){const c=this.C(i),a=this.C(r);if(c!==a)try{await this.S(i,r,"copy",o.overwrite),await p.Promises.copy(c,a,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,O.localize)(3,null,(0,y.basename)(c),(0,y.basename)((0,y.dirname)(a)),h.toString()))),this.Y(h)}}async S(i,r,o,c){const a=this.C(i),h=this.C(r);let R=!1;if(!!(this.capabilities&1024)||(R=(0,g.isEqual)(a,h,!0)),R&&o==="copy")throw(0,E.createFileSystemProviderError)((0,O.localize)(4,null),E.FileSystemProviderErrorCode.FileExists);if(!R&&await p.Promises.exists(h)){if(!c)throw(0,E.createFileSystemProviderError)((0,O.localize)(5,null),E.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(i,r){return this.U(i,r,!1)}async U(i,r,o){const c=this.C(i),a=this.C(r),h=!!(this.capabilities&1024);if((0,g.isEqual)(c,a,!h))return;const R=new u.DisposableStore;try{const[C,x]=await Promise.all([this.I(i),this.I(r)]);R.add(C),R.add(x),o&&await p.Promises.mkdir((0,y.dirname)(a),{recursive:!0}),await p.Promises.copyFile(c,a)}catch(C){if(C.code==="ENOENT"&&!o)return this.U(i,r,!0);throw this.Y(C)}finally{R.dispose()}}p(i,r,o){return new f.UniversalWatcherClient(c=>i(c),c=>r(c),o)}y(i,r,o){return new s.NodeJSWatcherClient(c=>i(c),c=>r(c),o)}Y(i){if(i instanceof E.FileSystemProviderError)return i;let r;switch(i.code){case"ENOENT":r=E.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=E.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=E.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=E.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=E.FileSystemProviderErrorCode.NoPermissions;break;default:r=E.FileSystemProviderErrorCode.Unknown}return(0,E.createFileSystemProviderError)(i,r)}async Z(i,r){let o=this.Y(r);if(i&&o.code===E.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await p.SymlinkSupport.stat(this.C(i));c.mode&128||(o=(0,E.createFileSystemProviderError)(r,E.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return o}}e.DiskFileSystemProvider=t,t.D=!1,t.O=!0}),define(Z[120],Q([0,1,13,9]),function(W,e,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(k||(k={}));async function L(u,y,v,m,b){try{const p=await new Promise((E,l)=>{W(["spdlog"],E,l)});p.setFlushOn(k.Trace);const O=await p.createAsyncRotatingLogger(u,y,v,m);return b?O.clearFormatters():O.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),O}catch(p){console.error(p)}return null}function N(u,y,v){switch(y){case D.LogLevel.Trace:u.trace(v);break;case D.LogLevel.Debug:u.debug(v);break;case D.LogLevel.Info:u.info(v);break;case D.LogLevel.Warning:u.warn(v);break;case D.LogLevel.Error:u.error(v);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function S(u,y){switch(y){case D.LogLevel.Trace:u.setLevel(k.Trace);break;case D.LogLevel.Debug:u.setLevel(k.Debug);break;case D.LogLevel.Info:u.setLevel(k.Info);break;case D.LogLevel.Warning:u.setLevel(k.Warning);break;case D.LogLevel.Error:u.setLevel(k.Error);break;case D.LogLevel.Off:u.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class g extends D.AbstractMessageLogger{constructor(y,v,m,b,p){super(),this.k=[],this.setLevel(p),this.l=this.n(y,v,m,b),this.B(this.onDidChangeLogLevel(O=>{this.m&&S(this.m,O)}))}async n(y,v,m,b){const p=m?6:1,O=30/p*T.ByteSize.MB,E=await L(y,v,O,p,b);if(E){this.m=E,S(this.m,this.getLevel());for(const{level:l,message:d}of this.k)N(this.m,l,d);this.k=[]}}g(y,v){this.m?N(this.m,y,v):this.getLevel()<=y&&this.k.push({level:y,message:v})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=g}),define(Z[38],Q([0,1,4,64,2,8]),function(W,e,T,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,L.createDecorator)("policy");class N extends k.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new T.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(u){const y=Object.keys(this.f).length;return this.f={...u,...this.f},y!==Object.keys(this.f).length&&await this.i(u),D.Iterable.reduce(this.g.entries(),(v,[m,b])=>({...v,[m]:b}),{})}getPolicyValue(u){return this.g.get(u)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(u,[y,v])=>({...u,[y]:{definition:v,value:this.g.get(y)}}),{})}}e.AbstractPolicyService=N;class S{constructor(){this.onDidChange=T.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=S}),define(Z[121],Q([0,1,3,4,64,5,13,9,38]),function(W,e,T,D,k,L,N,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function u(v,m){const b=[];for(const p of new Set(k.Iterable.concat(v.keys(),m.keys())))v.get(p)!==m.get(p)&&b.push(p);return b}let y=class extends g.AbstractPolicyService{constructor(m,b,p){super(),this.j=m,this.k=b,this.l=p,this.c=this.B(new T.ThrottledDelayer(500));const O=D.Event.filter(b.onDidFilesChange,E=>E.affects(m));this.B(b.watch(m)),this.B(O(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const m=new Map;try{const b=await this.k.readFile(this.j),p=JSON.parse(b.value.toString());if(!(0,L.isObject)(p))throw new Error("Policy file isn't a JSON object");for(const O of Object.keys(p))this.f[O]&&m.set(O,p[O])}catch(b){b.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",b)}return m}async p(){const m=await this.n(),b=u(this.g,m);this.g=m,b.length>0&&this.h.fire(b)}};y=me([ee(1,N.IFileService),ee(2,S.ILogService)],y),e.FilePolicyService=y}),define(Z[26],Q([0,1,8]),function(W,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,T.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Z[37],Q([0,1,70,5]),function(W,e,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.a=new Map}add(N,S){T.ok(D.isString(N)),T.ok(D.isObject(S)),T.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,S)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.Registry=new k}),define(Z[122],Q([0,1,4,37]),function(W,e,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class L{constructor(){this.b=new T.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,u){this.a[k(g)]=u,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const N=new L;D.Registry.add(e.Extensions.JSONContribution,N)}),define(Z[40],Q([0,1,19,4,5,85,21,122,37]),function(W,e,T,D,k,L,N,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var u;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(u=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const v=g.Registry.as(S.Extensions.JSONContribution);class m{constructor(){this.h=new Set,this.i=new D.Emitter,this.onDidSchemaChange=this.i.event,this.j=new D.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(t,n=!0){this.registerConfigurations([t],n)}registerConfigurations(t,n=!0){const i=this.k(t,n);v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const n=this.l(t);v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}updateConfigurations({add:t,remove:n}){const i=[];i.push(...this.l(n)),i.push(...this.k(t,!1)),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,T.distinct)(i)})}registerDefaultConfigurations(t){const n=[],i=[];for(const{overrides:r,source:o}of t)for(const c in r)if(n.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const a=this.a.get(c),h=a?.valuesSources??new Map;if(o)for(const Y of Object.keys(r[c]))h.set(Y,o);const R={...a?.value||{},...r[c]};this.a.set(c,{source:o,value:R,valuesSources:h});const C=(0,N.getLanguageTagSettingPlainKey)(c),x={type:"object",default:R,description:L.localize(1,null,C),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:R,source:k.isString(o)?void 0:o,defaultValueSource:o};i.push(...O(c)),this.d[c]=x,this.b.properties[c]=x}else{this.a.set(c,{value:r[c],source:o});const a=this.d[c];a&&(this.s(c,a),this.o(c,a))}this.registerOverrideIdentifiers(i),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(t){const n=[];for(const{overrides:i,source:r}of t)for(const o in i){const c=this.a.get(o),a=k.isString(r)?r:r?.id,h=k.isString(c?.source)?c?.source:c?.source?.id;if(a===h)if(n.push(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const R=this.d[o];R&&(this.s(o,R),this.o(o,R))}}this.q(),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){for(const n of t)this.h.add(n);this.q()}k(t,n){const i=[];return t.forEach(r=>{i.push(...this.m(r,n,r.extensionInfo,r.restrictedProperties)),this.c.push(r),this.n(r)}),i}l(t){const n=[],i=r=>{if(r.properties)for(const o in r.properties){n.push(o);const c=this.d[o];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[o],this.p(o,r.properties[o])}r.allOf?.forEach(o=>i(o))};for(const r of t){i(r);const o=this.c.indexOf(r);o!==-1&&this.c.splice(o,1)}return n}m(t,n=!0,i,r,o=3){o=k.isUndefinedOrNull(t.scope)?o:t.scope;const c=[],a=t.properties;if(a)for(const R in a){const C=a[R];if(n&&w(R,C)){delete a[R];continue}if(C.source=i,C.defaultDefaultValue=a[R].default,this.s(R,C),e.OVERRIDE_PROPERTY_REGEX.test(R)?C.scope=void 0:(C.scope=k.isUndefinedOrNull(C.scope)?o:C.scope,C.restricted=k.isUndefinedOrNull(C.restricted)?!!r?.includes(R):C.restricted),a[R].hasOwnProperty("included")&&!a[R].included){this.f[R]=a[R],delete a[R];continue}else this.d[R]=a[R],a[R].policy?.name&&this.e.set(a[R].policy.name,R);!a[R].deprecationMessage&&a[R].markdownDeprecationMessage&&(a[R].deprecationMessage=a[R].markdownDeprecationMessage),c.push(R)}const h=t.allOf;if(h)for(const R of h)c.push(...this.m(R,n,i,r,o));return c}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(t){const n=i=>{const r=i.properties;if(r)for(const c in r)this.o(c,r[c]);i.allOf?.forEach(n)};n(t)}o(t,n){switch(e.allSettings.properties[t]=n,n.scope){case 1:e.applicationSettings.properties[t]=n;break;case 2:e.machineSettings.properties[t]=n;break;case 6:e.machineOverridableSettings.properties[t]=n;break;case 3:e.windowSettings.properties[t]=n;break;case 4:e.resourceSettings.properties[t]=n;break;case 5:e.resourceSettings.properties[t]=n,this.g.properties[t]=n;break}}p(t,n){switch(delete e.allSettings.properties[t],n.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}q(){for(const t of this.h.values()){const n=`[${t}]`,i={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(n,i),e.allSettings.properties[n]=i,e.applicationSettings.properties[n]=i,e.machineSettings.properties[n]=i,e.machineOverridableSettings.properties[n]=i,e.windowSettings.properties[n]=i,e.resourceSettings.properties[n]=i}this.i.fire()}r(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}s(t,n){const i=this.a.get(t);let r=i?.value,o=i?.source;k.isUndefined(r)&&(r=n.defaultDefaultValue,o=void 0),k.isUndefined(r)&&(r=l(n.type)),n.default=r,n.defaultValueSource=o}}const b="\\[([^\\]]+)\\]",p=new RegExp(b,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${b})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function O(s){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(s)){let n=p.exec(s);for(;n?.length;){const i=n[1].trim();i&&t.push(i),n=p.exec(s)}}return(0,T.distinct)(t)}e.overrideIdentifiersFromKey=O;function E(s){return s.reduce((t,n)=>`${t}[${n}]`,"")}e.keyFromOverrideIdentifiers=E;function l(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const d=new m;g.Registry.add(e.Extensions.Configuration,d);function w(s,t){return s.trim()?e.OVERRIDE_PROPERTY_REGEX.test(s)?L.localize(7,null,s):d.getConfigurationProperties()[s]!==void 0?L.localize(8,null,s):t.policy?.name&&d.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,s,t.policy?.name,d.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.validateProperty=w;function f(){const s=[],t=d.getConfigurationProperties();for(const n of Object.keys(t))s.push([n,t[n].scope]);return s.push(["launch",4]),s.push(["task",4]),s}e.getScopes=f}),define(Z[65],Q([0,1,19,4,50,2,36,29,5,11,21,40,37]),function(W,e,T,D,k,L,N,S,g,u,y,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class b{constructor(n={},i=[],r=[],o){this.c=n,this.d=i,this.f=r,this.raw=o,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof b)return i;const r=new p("");return r.parseRaw(i),r.configurationModel});this.g=n.reduce((i,r)=>r===i?r:i.merge(r),n[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(n){return n?(0,y.getConfigurationValue)(this.contents,n):this.contents}inspect(n,i){const r=this.rawConfiguration.getValue(n),o=i?this.rawConfiguration.getOverrideValue(n,i):void 0,c=i?this.rawConfiguration.override(i).getValue(n):r;return{value:r,override:o,merged:c}}getOverrideValue(n,i){const r=this.l(i);return r?n?(0,y.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const r of this.overrides)r.identifiers.includes(n)&&i.push(...r.keys);return T.distinct(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return T.distinct(n)}override(n){let i=this.b.get(n);return i||(i=this.h(n),this.b.set(n,i)),i}merge(...n){const i=S.deepClone(this.contents),r=S.deepClone(this.overrides),o=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const a of n)if(c.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.j(i,a.contents);for(const h of a.overrides){const[R]=r.filter(C=>T.equals(C.identifiers,h.identifiers));R?(this.j(R.contents,h.contents),R.keys.push(...h.keys),R.keys=T.distinct(R.keys)):r.push(S.deepClone(h))}for(const h of a.keys)o.indexOf(h)===-1&&o.push(h)}return new b(i,o,r,c.every(a=>a instanceof b)?void 0:c)}freeze(){return this.a=!0,this}clone(){return new b(S.deepClone(this.contents),[...this.keys],S.deepClone(this.overrides))}h(n){const i=this.l(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const r={};for(const o of T.distinct([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[o];const a=i[o];a&&(typeof c=="object"&&typeof a=="object"?(c=S.deepClone(c),this.j(c,a)):c=a),r[o]=c}return new b(r,this.keys,this.overrides)}j(n,i){for(const r of Object.keys(i)){if(r in n&&g.isObject(n[r])&&g.isObject(i[r])){this.j(n[r],i[r]);continue}n[r]=S.deepClone(i[r])}}k(n){return this.a&&!Object.isFrozen(n)?S.deepFreeze(n):n}l(n){let i=null,r=null;const o=c=>{c&&(r?this.j(r,c):r=S.deepClone(c))};for(const c of this.overrides)T.equals(c.identifiers,[n])?i=c.contents:c.identifiers.includes(n)&&o(c.contents);return o(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,i){this.m(n),(0,y.addToValueTree)(this.contents,n,i,r=>{throw new Error(r)})}removeValue(n){this.n(n)&&(0,y.removeFromValueTree)(this.contents,n)}m(n){let i=this.keys.length;for(let r=0;r<i;r++)n.indexOf(this.keys[r])===0&&(i=r);this.keys.splice(i,1,n)}n(n){const i=this.keys.indexOf(n);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=b;class p{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new b}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,i){if(!g.isUndefinedOrNull(n)){const r=this.g(n);this.parseRaw(r,i)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,i){this.a=n;const{contents:r,keys:o,overrides:c,restricted:a,hasExcludedProperties:h}=this.h(n,i);this.b=new b(r,o,c,h?[n]:void 0),this.c=a||[]}g(n){let i={},r=null,o=[];const c=[],a=[];function h(C){Array.isArray(o)?o.push(C):r!==null&&(o[r]=C)}const R={onObjectBegin:()=>{const C={};h(C),c.push(o),o=C,r=null},onObjectProperty:C=>{r=C},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const C=[];h(C),c.push(o),o=C,r=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:h,onError:(C,x,Y)=>{a.push({error:C,offset:x,length:Y})}};if(n)try{k.visit(n,R),i=o[0]||{}}catch(C){console.error(`Error while parsing settings file ${this.f}: ${C}`),this.d=[C]}return i}h(n,i){const r=m.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),o=this.j(n,r,!0,i);n=o.raw;const c=(0,y.toValuesTree)(n,R=>console.error(`Conflict in settings file ${this.f}: ${R}`)),a=Object.keys(n),h=this.l(n,R=>console.error(`Conflict in settings file ${this.f}: ${R}`));return{contents:c,keys:a,overrides:h,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(n,i,r,o){let c=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:c};const a={},h=[];for(const R in n)if(v.OVERRIDE_PROPERTY_REGEX.test(R)&&r){const C=this.j(n[R],i,!1,o);a[R]=C.raw,c=c||C.hasExcludedProperties,h.push(...C.restricted)}else{const C=i[R],x=C?typeof C.scope<"u"?C.scope:3:void 0;C?.restricted&&h.push(R),(x===void 0||o.scopes===void 0||o.scopes.includes(x))&&!(o.skipRestricted&&C?.restricted)?a[R]=n[R]:c=!0}return{raw:a,restricted:h,hasExcludedProperties:c}}l(n,i){const r=[];for(const o of Object.keys(n))if(v.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const a in n[o])c[a]=n[o][a];r.push({identifiers:(0,v.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,y.toValuesTree)(c,i)})}return r}}e.ConfigurationModelParser=p;class O extends L.Disposable{constructor(n,i,r,o){super(),this.f=n,this.g=i,this.h=o,this.c=this.B(new D.Emitter),this.onDidChange=this.c.event,this.a=new p(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(D.Event.any(D.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),D.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&r.isEqual(c.resource,n)))(()=>this.c.fire()))}async loadConfiguration(){try{const n=await this.h.readFile(this.f);return this.a.parse(n.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new b}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=O;class E{constructor(n,i,r,o,c,a,h,R,C,x,Y,X,ie){this.a=n,this.b=i,this.value=r,this.overrideIdentifiers=o,this.c=c,this.d=a,this.f=h,this.g=R,this.h=C,this.j=x,this.k=Y,this.l=X,this.m=ie}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class l{constructor(n,i,r,o,c=new b,a=new b,h=new N.ResourceMap,R=new b,C=new N.ResourceMap,x=!0){this.c=n,this.d=i,this.f=r,this.g=o,this.h=c,this.j=a,this.l=h,this.m=R,this.n=C,this.p=x,this.a=null,this.b=new N.ResourceMap,this.q=null}getValue(n,i,r){return this.s(n,i,r).getValue(n)}updateValue(n,i,r={}){let o;r.resource?(o=this.n.get(r.resource),o||(o=new b,this.n.set(r.resource,o))):o=this.m,i===void 0?o.removeValue(n):o.setValue(n,i),r.resource||(this.a=null)}inspect(n,i,r){const o=this.s(n,i,r),c=T.distinct(o.overrides.map(R=>R.identifiers).flat()).filter(R=>o.getOverrideValue(n,R)!==void 0),a=this.w(i.resource,r),h=i.resource?this.n.get(i.resource)||this.m:this.m;return new E(n,i,o.getValue(n),c.length?c:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),r?this.j.freeze():void 0,a?a.freeze():void 0,h.inspect(n,i.overrideIdentifier))}keys(n){const i=this.w(void 0,n);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.j=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,i){this.l.set(n,i),this.b.delete(n)}deleteFolderConfiguration(n){this.r.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const r=[];if(!i){const{added:o,updated:c,removed:a}=f(this.c,n);i=[...o,...c,...a]}for(const o of i)for(const c of(0,v.overrideIdentifiersFromKey)(o)){const a=this.c.getKeysForOverrideIdentifier(c),h=n.getKeysForOverrideIdentifier(c),R=[...h.filter(C=>a.indexOf(C)===-1),...a.filter(C=>h.indexOf(C)===-1),...a.filter(C=>!S.equals(this.c.override(c).getValue(C),n.override(c).getValue(C)))];r.push([c,R])}return this.updateDefaultConfiguration(n),{keys:i,overrides:r}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:r,removed:o}=f(this.d,n),c=[...i,...r,...o];return c.length&&this.updatePolicyConfiguration(n),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:r,removed:o,overrides:c}=f(this.applicationConfiguration,n),a=[...i,...r,...o];return a.length&&this.updateApplicationConfiguration(n),{keys:a,overrides:c}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:r,removed:o,overrides:c}=f(this.localUserConfiguration,n),a=[...i,...r,...o];return a.length&&this.updateLocalUserConfiguration(n),{keys:a,overrides:c}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:r,removed:o,overrides:c}=f(this.remoteUserConfiguration,n),a=[...i,...r,...o];return a.length&&this.updateRemoteUserConfiguration(n),{keys:a,overrides:c}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:r,removed:o,overrides:c}=f(this.workspaceConfiguration,n),a=[...i,...r,...o];return a.length&&this.updateWorkspaceConfiguration(n),{keys:a,overrides:c}}compareAndUpdateFolderConfiguration(n,i){const r=this.r.get(n),{added:o,updated:c,removed:a,overrides:h}=f(r,i),R=[...o,...c,...a];return(R.length||!r)&&this.updateFolderConfiguration(n,i),{keys:R,overrides:h}}compareAndDeleteFolderConfiguration(n){const i=this.r.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:o,removed:c,overrides:a}=f(i,void 0);return{keys:[...r,...o,...c],overrides:a}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(n,i,r){let o=this.t(i,r);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(o=o.merge(this.d)),o}t({resource:n},i){let r=this.u();if(i&&n){const o=i.getFolder(n);o&&(r=this.v(o.uri)||r);const c=this.n.get(n);c&&(r=r.merge(c))}return r}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(n){let i=this.b.get(n);if(!i){const r=this.u(),o=this.l.get(n);o?(i=r.merge(o),this.p&&(i=i.freeze()),this.b.set(n,i)):i=r}return i}w(n,i){if(i&&n){const r=i.getFolder(n);if(r)return this.l.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((n,i)=>{const{contents:r,overrides:o,keys:c}=this.l.get(i);return n.push([i,{contents:r,overrides:o,keys:c}]),n},[])}}allKeys(){const n=new Set;return this.c.freeze().keys.forEach(i=>n.add(i)),this.userConfiguration.freeze().keys.forEach(i=>n.add(i)),this.j.freeze().keys.forEach(i=>n.add(i)),this.l.forEach(i=>i.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}x(){const n=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.j.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.l.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}y(n){const i=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this.j.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this.l.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(o=>i.add(o))),[...i.values()]}static parse(n){const i=this.z(n.defaults),r=this.z(n.policy),o=this.z(n.application),c=this.z(n.user),a=this.z(n.workspace),h=n.folders.reduce((R,C)=>(R.set(u.URI.revive(C[0]),this.z(C[1])),R),new N.ResourceMap);return new l(i,r,o,c,new b,a,h,new b,new N.ResourceMap,!1)}static z(n){return new b(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=l;function d(...t){if(t.length===0)return{keys:[],overrides:[]};if(t.length===1)return t[0];const n=new Set,i=new Map;for(const o of t)o.keys.forEach(c=>n.add(c)),o.overrides.forEach(([c,a])=>{const h=(0,N.getOrSet)(i,c,new Set);a.forEach(R=>h.add(R))});const r=[];return i.forEach((o,c)=>r.push([c,[...o.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=d;class w{constructor(n,i,r,o){this.change=n,this.b=i,this.c=r,this.d=o,this.f=void 0;const c=new Set;n.keys.forEach(h=>c.add(h)),n.overrides.forEach(([,h])=>h.forEach(R=>c.add(R))),this.affectedKeys=[...c.values()];const a=new b;this.affectedKeys.forEach(h=>a.setValue(h,{})),this.a=a.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=l.parse(this.b.data)),this.f}affectsConfiguration(n,i){if(this.g(this.a,n)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.b?.workspace):void 0,o=this.c.getValue(n,i,this.d);return!S.equals(r,o)}return!0}return!1}g(n,i){let r=(0,y.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(n=n[o],!n)return!1;r=r[o]}return!0}}e.ConfigurationChangeEvent=w;function f(t,n){const{added:i,removed:r,updated:o}=s(n?.rawConfiguration,t?.rawConfiguration),c=[],a=t?.getAllOverrideIdentifiers()||[],h=n?.getAllOverrideIdentifiers()||[];if(n){const R=h.filter(C=>!a.includes(C));for(const C of R)c.push([C,n.getKeysForOverrideIdentifier(C)])}if(t){const R=a.filter(C=>!h.includes(C));for(const C of R)c.push([C,t.getKeysForOverrideIdentifier(C)])}if(n&&t){for(const R of a)if(h.includes(R)){const C=s({contents:t.getOverrideValue(void 0,R)||{},keys:t.getKeysForOverrideIdentifier(R)},{contents:n.getOverrideValue(void 0,R)||{},keys:n.getKeysForOverrideIdentifier(R)});c.push([R,[...C.added,...C.removed,...C.updated]])}}return{added:i,removed:r,updated:o,overrides:c}}function s(t,n){const i=t?n?t.keys.filter(c=>n.keys.indexOf(c)===-1):[...t.keys]:[],r=n?t?n.keys.filter(c=>t.keys.indexOf(c)===-1):[...n.keys]:[],o=[];if(t&&n){for(const c of n.keys)if(t.keys.indexOf(c)!==-1){const a=(0,y.getConfigurationValue)(n.contents,c),h=(0,y.getConfigurationValue)(t.contents,c);S.equals(a,h)||o.push(c)}}return{added:i,removed:r,updated:o}}}),define(Z[123],Q([0,1,19,4,2,29,5,21,65,40,9,38,37]),function(W,e,T,D,k,L,N,S,g,u,y,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class b extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new D.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new p(this.f())),this.b}async initialize(){return this.b=void 0,this.B(m.Registry.as(u.Extensions.Configuration).onDidUpdateConfiguration(({properties:d,defaultsOverrides:w})=>this.c(d,w))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(d,w){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:d})}f(){return{}}}e.DefaultConfiguration=b;class p extends g.ConfigurationModel{constructor(d={}){const w=m.Registry.as(u.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(w),s=Object.create(null),t=[];for(const n in w){const i=d[n],r=i!==void 0?i:w[n].default;(0,S.addToValueTree)(s,n,r,o=>console.error(`Conflict in default settings: ${o}`))}for(const n of Object.keys(s))u.OVERRIDE_PROPERTY_REGEX.test(n)&&t.push({identifiers:(0,u.overrideIdentifiersFromKey)(n),keys:Object.keys(s[n]),contents:(0,S.toValuesTree)(s[n],i=>console.error(`Conflict in default settings file: ${i}`))});super(s,f,t)}}e.DefaultConfigurationModel=p;class O{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new g.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=O;let E=class extends k.Disposable{get configurationModel(){return this.b}constructor(d,w,f){super(),this.c=d,this.f=w,this.g=f,this.a=this.B(new D.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new g.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(d=>this.i(d))),this.B(this.c.onDidChangeConfiguration(async({properties:d})=>this.j(await this.h(d),!0))),this.b}async h(d){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",d);const w={},f=[],s=m.Registry.as(u.Extensions.Configuration).getConfigurationProperties();for(const t of d){const n=s[t];if(!n){f.push(t);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.g.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}f.push(t),w[n.policy.name]={type:n.type}}}return(0,N.isEmptyObject)(w)||await this.f.updatePolicyDefinitions(w),f}i(d){this.g.trace("PolicyConfiguration#onDidChangePolicies",d);const w=m.Registry.as(u.Extensions.Configuration).getPolicyConfigurations(),f=(0,T.coalesce)(d.map(s=>w.get(s)));this.j(f,!0)}j(d,w){this.g.trace("PolicyConfiguration#update",d);const f=m.Registry.as(u.Extensions.Configuration).getConfigurationProperties(),s=[],t=this.b.isEmpty();for(const n of d){const i=f[n]?.policy?.name;if(i){const r=this.f.getPolicyValue(i);(t?r!==void 0:!(0,L.equals)(this.b.getValue(n),r))&&s.push([n,r])}else this.b.getValue(n)!==void 0&&s.push([n,void 0])}if(s.length){this.g.trace("PolicyConfiguration#changed",s);const n=this.b;this.b=new g.ConfigurationModel;for(const i of n.keys)this.b.setValue(i,n.getValue(i));for(const[i,r]of s)r===void 0?this.b.removeValue(i):this.b.setValue(i,r);w&&this.a.fire(this.b)}}};E=me([ee(1,v.IPolicyService),ee(2,y.ILogService)],E),e.PolicyConfiguration=E}),define(Z[124],Q([0,1,3,4,2,17,21,65,123,38]),function(W,e,T,D,k,L,N,S,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class y extends k.Disposable{constructor(m,b,p,O){super(),this.i=m,this.h=this.B(new D.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new g.DefaultConfiguration),this.c=p instanceof u.NullPolicyService?new g.NullPolicyConfiguration:this.B(new g.PolicyConfiguration(this.b,p,O)),this.f=this.B(new S.UserSettings(this.i,void 0,L.extUriBiasedIgnorePathCase,b)),this.a=new S.Configuration(this.b.configurationModel,this.c.configurationModel,new S.ConfigurationModel,new S.ConfigurationModel),this.g=this.B(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:E,properties:l})=>this.k(E,l))),this.B(this.c.onDidChangeConfiguration(E=>this.l(E))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[m,b,p]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new S.Configuration(m,b,new S.ConfigurationModel,p)}getConfigurationData(){return this.a.toData()}getValue(m,b){const p=typeof m=="string"?m:void 0,O=(0,N.isConfigurationOverrides)(m)?m:(0,N.isConfigurationOverrides)(b)?b:{};return this.a.getValue(p,O,void 0)}updateValue(m,b,p,O){return Promise.reject(new Error("not supported"))}inspect(m){return this.a.inspect(m,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const m=await this.f.loadConfiguration();this.j(m)}j(m){const b=this.a.toData(),p=this.a.compareAndUpdateLocalUserConfiguration(m);this.m(p,b,2)}k(m,b){const p=this.a.toData(),O=this.a.compareAndUpdateDefaultConfiguration(m,b);this.m(O,p,7)}l(m){const b=this.a.toData(),p=this.a.compareAndUpdatePolicyConfiguration(m);this.m(p,b,7)}m(m,b,p){const O=new S.ConfigurationChangeEvent(m,{data:b},this.a);O.source=p,O.sourceConfig=this.n(p),this.h.fire(O)}n(m){switch(m){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=y}),define(Z[66],Q([0,1,16]),function(W,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function D(u){return u.scheme===T.Schemas.vscodeRemote?u.authority:void 0}e.getRemoteAuthority=D;function k(u){if(!u)return;const y=u.indexOf("+");return y<0?u:u.substr(0,y)}e.getRemoteName=k;function L(u){return`/${u.quality??"oss"}-${u.commit??"dev"}`}e.getRemoteServerRootPath=L;function N(u){const{host:y,port:v}=g(u);if(typeof v>"u")throw new Error("Remote authority doesn't contain a port!");return{host:y,port:v}}e.parseAuthorityWithPort=N;function S(u,y){let{host:v,port:m}=g(u);return typeof m>"u"&&(m=y),{host:v,port:m}}e.parseAuthorityWithOptionalPort=S;function g(u){const y=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(y)return{host:y[1],port:parseInt(y[2],10)};const v=u.match(/^(\[[0-9a-z:]+\])$/);if(v)return{host:v[1],port:void 0};const m=u.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:u,port:void 0}}}),define(Z[27],Q([0,1,31,8,66]),function(W,e,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.getWorkspaceSupportTypeMessage=L;function N(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=N,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var S;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(S=e.ExtensionType||(e.ExtensionType={}));var g;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(g=e.TargetPlatform||(e.TargetPlatform={}));class u{constructor(O){this.value=O,this.c=O.toLowerCase()}static equals(O,E){if(typeof O>"u"||O===null)return typeof E>"u"||E===null;if(typeof E>"u"||E===null)return!1;if(typeof O=="string"||typeof E=="string"){const l=typeof O=="string"?O:O.value,d=typeof E=="string"?E:E.value;return T.equalsIgnoreCase(l,d)}return O.c===E.c}static toKey(O){return typeof O=="string"?O.toLowerCase():O.c}}e.ExtensionIdentifier=u;function y(p){return v(p)}e.isApplicationScopedExtension=y;function v(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=v;function m(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function b(p,O){if(O){const E=`onResolveRemoteAuthority:${(0,k.getRemoteName)(O)}`;return p.activationEvents?.indexOf(E)!==-1}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[24],Q([0,1,31,23,27,12,11,10,35]),function(W,e,T,D,k,L,N,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function u(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,T.compareIgnoreCase)(n.id,i.id)===0}e.areSameExtensions=u;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(i){const r=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new v(i.identifier,r,o)}static parse(i){const r=y.exec(i);return r&&r[1]&&r[2]?new v({id:r[1]},r[2],r[4]||void 0):null}constructor(i,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof v?u(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=v;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(n){const i=m.exec(n);return i&&i[1]?[O(i[1]),i[2]]:[O(n),void 0]}e.getIdAndVersion=b;function p(n,i){return`${n}.${i}`}e.getExtensionId=p;function O(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=O;function E(n,i){return O(p(n,i))}e.getGalleryExtensionId=E;function l(n,i){const r=[],o=c=>{for(const a of r)if(a.some(h=>u(i(h),i(c))))return a;return null};for(const c of n){const a=o(c);a?a.push(c):r.push([c])}return r}e.groupByExtension=l;function d(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=d;function w(n){return{id:n.identifier.id,name:n.name,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function f(n,i){const r=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const c=o.shift();if(c&&r.every(a=>!u(a.identifier,{id:c}))){const a=n.filter(h=>u(h.identifier,{id:c}));a.length===1&&(r.push(a[0]),o.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=f;async function s(n,i){if(!L.isLinux)return!1;let r;try{r=(await n.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await n.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){i.debug("Error while getting the os-release file.",(0,S.getErrorMessage)(c))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=s;async function t(n,i){const r=await s(n,i),o=(0,D.getTargetPlatform)(r?"alpine":L.platform,g.arch);return i.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=t}),define(Z[125],Q([0,1,22,10,16,17,39,11,88,23,24,27]),function(W,e,T,D,k,L,N,S,g,u,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const m=E=>(0,g.localize)(0,null,E),b=(0,g.localize)(1,null,"ms-dotnettools.csharp");function p(E,l){return l?`${E.publisher}.${E.name}@${E.version}`:`${E.publisher}.${E.name}`}let O=class{constructor(l,d){this.a=l,this.b=d}get d(){}async listExtensions(l,d,w,f=console){let s=await this.a.getInstalled(1,w);const t=v.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(d&&d!==""){if(t.indexOf(d.toLowerCase())<0){f.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}s=s.filter(i=>i.manifest.categories?i.manifest.categories.map(o=>o.toLowerCase()).indexOf(d.toLowerCase())>-1:!1)}else if(d===""){f.log("Possible Categories: "),t.forEach(i=>{f.log(i)});return}this.d&&f.log((0,g.localize)(2,null,this.d)),s=s.sort((i,r)=>i.identifier.id.localeCompare(r.identifier.id));let n;for(const i of s)n!==i.identifier.id&&(n=i.identifier.id,f.log(p(i.manifest,l)))}async installExtensions(l,d,w,f,s=console){const t=[],n=[];l.length&&s.log(this.d?(0,g.localize)(3,null,this.d):(0,g.localize)(4,null));const i=await this.a.getInstalled(1,w.profileLocation),r=(h,R)=>{const C=i.find(x=>(0,y.areSameExtensions)(x.identifier,{id:h}));if(C){if(!f&&(!R||R==="prerelease"&&C.preRelease))return s.log((0,g.localize)(5,null,h,C.manifest.version,h)),!1;if(R&&C.manifest.version===R)return s.log((0,g.localize)(6,null,`${h}@${R}`)),!1}return!0},o=(h,R,C)=>{a.push({id:h,version:R!=="prerelease"?R:void 0,installOptions:{...w,isBuiltin:C,installPreReleaseVersion:R==="prerelease"||w.installPreReleaseVersion}})},c=[],a=[];for(const h of l)if(h instanceof S.URI)c.push(h);else{const[R,C]=(0,y.getIdAndVersion)(h);r(R,C)&&o(R,C,!1)}for(const h of d){const[R,C]=(0,y.getIdAndVersion)(h);r(R,C)&&o(R,C,!0)}if(c.length&&await Promise.all(c.map(async h=>{try{const R=await this.f(h,{...w,isBuiltin:!1},f,s);R&&n.push(R)}catch(R){s.error(R.message||R.stack||R),t.push(h.toString())}})),a.length){const h=await this.g(a);await Promise.all(a.map(async R=>{const C=h.get(R.id.toLowerCase());if(C)try{const x=await this.h(R,C,i,f,s);x&&n.push(x)}catch(x){s.error(x.message||x.stack||x),t.push(R.id)}else s.error(`${m(R.version?`${R.id}@${R.version}`:R.id)}
${b}`),t.push(R.id)}))}if(t.length)throw new Error((0,g.localize)(7,null,t.join(", ")))}async f(l,d,w,f){const s=await this.a.getManifest(l);if(!s)throw new Error("Invalid vsix");if(await this.k(s,w,d.profileLocation,f))try{return await this.a.install(l,d),f.log((0,g.localize)(8,null,(0,L.basename)(l))),s}catch(n){if((0,D.isCancellationError)(n))return f.log((0,g.localize)(9,null,(0,L.basename)(l))),null;throw n}return null}async g(l){const d=new Map,w=l.some(s=>s.installOptions.installPreReleaseVersion),f=await this.b.getExtensions(l.map(s=>({...s,preRelease:w})),T.CancellationToken.None);for(const s of f)d.set(s.identifier.id.toLowerCase(),s);return d}async h({id:l,version:d,installOptions:w},f,s,t,n){const i=await this.b.getManifest(f,T.CancellationToken.None);if(i&&!this.j(i,n))return null;const r=s.find(o=>(0,y.areSameExtensions)(o.identifier,f.identifier));if(r){if(f.version===r.manifest.version)return n.log((0,g.localize)(10,null,d?`${l}@${d}`:l)),null;n.log((0,g.localize)(11,null,l,f.version))}try{w.isBuiltin?n.log(d?(0,g.localize)(12,null,l,d):(0,g.localize)(13,null,l)):n.log(d?(0,g.localize)(14,null,l,d):(0,g.localize)(15,null,l));const o=await this.a.installFromGallery(f,{...w,installGivenVersion:!!d});return n.log((0,g.localize)(16,null,l,o.manifest.version)),i}catch(o){if((0,D.isCancellationError)(o))return n.log((0,g.localize)(17,null,l)),null;throw o}}j(l,d){return!0}async k(l,d,w,f){const s={id:(0,y.getGalleryExtensionId)(l.publisher,l.name)},n=(await this.a.getInstalled(1,w)).find(i=>(0,y.areSameExtensions)(s,i.identifier)&&(0,N.gt)(i.manifest.version,l.version));return n&&!d?(f.log((0,g.localize)(18,null,n.identifier.id,n.manifest.version,l.version)),!1):this.j(l,f)}async uninstallExtensions(l,d,w,f=console){const s=async n=>{if(n instanceof S.URI){const i=await this.a.getManifest(n);return p(i)}return n},t=[];for(const n of l){const i=await s(n),o=(await this.a.getInstalled(void 0,w)).filter(c=>(0,y.areSameExtensions)(c.identifier,{id:i}));if(!o.length)throw new Error(`${this.l(i)}
${b}`);if(o.some(c=>c.type===0)){f.log((0,g.localize)(19,null,i));return}if(!d&&o.some(c=>c.isBuiltin)){f.log((0,g.localize)(20,null,i));return}f.log((0,g.localize)(21,null,i));for(const c of o)await this.a.uninstall(c,{profileLocation:w}),t.push(c);this.d?f.log((0,g.localize)(22,null,i,this.d)):f.log((0,g.localize)(23,null,i))}}async locateExtension(l,d=console){const w=await this.a.getInstalled();l.forEach(f=>{w.forEach(s=>{if(s.identifier.id===f&&s.location.scheme===k.Schemas.file){d.log(s.location.fsPath);return}})})}l(l){return this.d?(0,g.localize)(24,null,l,this.d):(0,g.localize)(25,null,l)}};O=me([ee(0,u.IExtensionManagementService),ee(1,u.IExtensionGalleryService)],O),e.ExtensionManagementCLI=O}),define(Z[126],Q([0,1,3,10,2,16,12,17,39,5,30,20,21,18,23,24,59,13,9,26]),function(W,e,T,D,k,L,N,S,g,u,y,v,m,b,p,O,E,l,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let f=class Ve extends k.Disposable{constructor(t,n,i,r,o,c,a,h){super(),this.h=t,this.i=i,this.j=r,this.k=o,this.l=c,this.m=a,this.n=h,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.f=20,this.g=this.w()}async download(t,n){await this.g;const i=(0,S.joinPath)(this.extensionsDownloadDir,this.y(t));try{await this.u(t,i,o=>this.j.download(t,o,n))}catch(o){throw new p.ExtensionManagementError(o.message,p.ExtensionManagementErrorCode.Download)}let r=!1;if(await this.r(t)){const o=await this.t(t);try{r=await this.m.verify(i.fsPath,o.fsPath),this.n.info(`Verified extension: ${t.identifier.id}`,r)}catch(c){throw await this.delete(o),await this.delete(i),new p.ExtensionManagementError(c.code,p.ExtensionManagementErrorCode.Signature)}}return{location:i,verified:r}}async r(t){if(!t.isSigned||await this.h==="linux-armhf")return!1;const i=this.k.getValue("extensions.verifySignature");return(0,u.isBoolean)(i)?i:this.l.quality!=="stable"}async t(t){await this.g;const n=(0,S.joinPath)(this.extensionsDownloadDir,`${this.y(t)}${Ve.c}`);return await this.u(t,n,i=>this.j.downloadSignatureArchive(t,i)),n}async u(t,n,i){if(await this.i.exists(n))return;if(n.scheme!==L.Schemas.file){await i(n);return}const r=(0,S.joinPath)(this.extensionsDownloadDir,`.${(0,y.generateUuid)()}`);await this.i.exists(r)||await i(r);try{await this.v(r,n,Date.now()+2*60*1e3)}catch(o){try{await this.i.del(r)}catch{}if(o.code==="ENOTEMPTY")this.n.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,n.path);else throw this.n.info(`Rename failed because of ${(0,D.getErrorMessage)(o)}. Deleted the file from downloaded location`,r.path),o}}async delete(t){await this.g,await this.i.del(t)}async v(t,n,i){try{await v.Promises.rename(t.fsPath,n.fsPath)}catch(r){if(N.isWindows&&r&&r.code==="EPERM"&&Date.now()<i)return this.n.info(`Failed renaming ${t} to ${n} with 'EPERM' error. Trying again...`),this.v(t,n,i);throw r}}async w(){try{if(!await this.i.exists(this.extensionsDownloadDir)){this.n.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.i.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const n=[],i=[],r=[];for(const a of t.children)if(a.name.endsWith(Ve.c))r.push(a.resource);else{const h=O.ExtensionKey.parse(a.name);h&&i.push([h,a])}const o=(0,O.groupByExtension)(i,([a])=>a),c=[];for(const a of o)a.sort((h,R)=>g.rcompare(h[0].version,R[0].version)),n.push(...a.slice(1).map(h=>h[1].resource)),c.push(a[0][1]);c.sort((a,h)=>a.mtime-h.mtime),n.push(...c.slice(0,Math.max(0,c.length-this.f)).map(a=>a.resource)),n.push(...r),await T.Promises.settled(n.map(a=>(this.n.trace("Deleting from cache",a.path),this.i.del(a))))}}catch(t){this.n.error(t)}}y(t){return this.f?O.ExtensionKey.create(t).toString().toLowerCase():(0,y.generateUuid)()}};f.c=".sigzip",f=me([ee(1,b.INativeEnvironmentService),ee(2,l.IFileService),ee(3,p.IExtensionGalleryService),ee(4,m.IConfigurationService),ee(5,w.IProductService),ee(6,E.IExtensionSignatureVerificationService),ee(7,d.ILogService)],f),e.ExtensionsDownloader=f}),define(Z[127],Q([0,1,2,14,20,27]),function(W,e,T,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class N extends T.Disposable{constructor(g,u){super(),this.b=g,this.a=(0,D.join)(this.b.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this.B(u.onDidInstallExtensions(y=>this.c(y))),this.B(u.onDidUninstallExtension(y=>this.f(y)))}c(g){g.some(u=>!!u.local)&&this.invalidate()}f(g){g.error||this.invalidate()}invalidate(){k.Promises.rm(this.a,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=N}),define(Z[128],Q([0,1,4,2,36,24,27]),function(W,e,T,D,k,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class S extends D.Disposable{constructor(u,y,v,m,b,p,O){super(),this.f=u,this.g=y,this.h=v,this.i=m,this.j=b,this.k=p,this.l=O,this.a=this.B(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.DisposableMap),this.m().then(null,E=>O.error(E))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(u=>this.p(u.added,u.removed))),this.B(this.i.onAddExtensions(u=>this.r(u))),this.B(this.i.onDidAddExtensions(u=>this.s(u))),this.B(this.i.onRemoveExtensions(u=>this.t(u))),this.B(this.i.onDidRemoveExtensions(u=>this.u(u))),this.B(this.k.onDidFilesChange(u=>this.v(u)))}async p(u,y){try{await Promise.all(y.map(v=>(this.c.deleteAndDispose(v.id),this.z(v.extensionsResource)))),u.length&&await Promise.all(u.map(v=>(this.c.set(v.id,(0,D.combinedDisposable)(this.k.watch(this.j.extUri.dirname(v.extensionsResource)),this.k.watch(v.extensionsResource))),this.y(v.extensionsResource))))}catch(v){throw this.l.error(v),v}}async r(u){for(const y of u.extensions)this.D(this.G(y.identifier,y.version),u.profileLocation)}async s(u){for(const y of u.extensions){const v=this.G(y.identifier,y.version);u.error?this.F(v,u.profileLocation):this.D(v,u.profileLocation)}}async t(u){for(const y of u.extensions)this.F(this.G(y.identifier,y.version),u.profileLocation)}async u(u){let y=!1;for(const v of u.extensions){const m=this.G(v.identifier,v.version);u.error?this.D(m,u.profileLocation):(this.F(m,u.profileLocation),y=y||!this.b.has(m))}y&&await this.C()}v(u){for(const y of this.h.profiles)u.contains(y.extensionsResource,0,1)&&this.w(y.extensionsResource)}async w(u){const y=[],v=[],m=await this.i.scanProfileExtensions(u),b=new Set,p=new Set;for(const[O,E]of this.b)E.has(u)&&p.add(O);for(const O of m){const E=this.G(O.identifier,O.version);b.add(E),p.has(E)||(y.push(O.identifier),this.D(E,u))}for(const O of p)if(!b.has(O)){const E=this.H(O);E&&(v.push(E.identifier),this.F(O,u))}(y.length||v.length)&&this.a.fire({added:y.length?{extensions:y,profileLocation:u}:void 0,removed:v.length?{extensions:v,profileLocation:u}:void 0})}async y(u){const y=await this.i.scanProfileExtensions(u);for(const v of y)this.D(this.G(v.identifier,v.version),u)}async z(u){for(const y of[...this.b.keys()])this.F(y,u);await this.C()}async C(){const y=(await this.f.getAllUserInstalled()).filter(v=>v.installedTimestamp&&!this.b.has(this.G(v.identifier,v.manifest.version)));y.length&&await this.f.markAsUninstalled(...y)}D(u,y){let v=this.b.get(u);v||this.b.set(u,v=new k.ResourceSet(m=>this.j.extUri.getComparisonKey(m))),v.add(y)}F(u,y){const v=this.b.get(u);v&&v.delete(y),v?.size||this.b.delete(u)}G(u,y){return`${N.ExtensionIdentifier.toKey(u.id)}@${y}`}H(u){const[y,v]=(0,L.getIdAndVersion)(u);return v?{identifier:{id:y},version:v}:void 0}}e.ExtensionsWatcher=S}),define(Z[129],Q([0,1,160,19,3,2,16,14,20,18,23,24,9,63,12,11]),function(W,e,T,D,k,L,N,S,g,u,y,v,m,b,p,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let E=class extends b.LanguagePackBaseService{constructor(f,s,t,n){super(t),this.h=f,this.i=n,this.g=this.B(new l(s,n)),this.h.registerParticipant({postInstall:async i=>this.j(i),postUninstall:async i=>this.k(i)})}async getBuiltInExtensionTranslationsUri(f){const t=(await this.g.getLanguagePacks())[p.Language.value()];if(!t){this.i.warn(`No language pack found for ${p.Language.value()}`);return}const n=t.translations[f];return n?O.URI.file(n):void 0}async getInstalledLanguages(){const f=await this.g.getLanguagePacks(),s=Object.keys(f).map(t=>{const n=f[t];return{...this.f(t,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return s.push({...this.f("en","English"),extensionId:"default"}),s.sort((t,n)=>t.label.localeCompare(n.label)),s}async j(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",f.identifier.id),await this.update())}async k(f){const s=await this.g.getLanguagePacks();Object.keys(s).some(t=>s[t]&&s[t].extensions.some(n=>(0,v.areSameExtensions)(n.extensionIdentifier,f.identifier)))&&(this.i.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,s]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),t=await this.g.update(s);return!(0,D.equals)(Object.keys(f),Object.keys(t))}};E=me([ee(0,y.IExtensionManagementService),ee(1,u.INativeEnvironmentService),ee(2,y.IExtensionGalleryService),ee(3,m.ILogService)],E),e.NativeLanguagePackService=E;let l=class extends L.Disposable{constructor(f,s){super(),this.i=s,this.c={},this.f=(0,S.join)(f.userDataPath,"languagepacks.json"),this.g=new k.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(f){return this.m(s=>{Object.keys(s).forEach(t=>delete s[t]),this.j(s,...f)}).then(()=>this.c)}j(f,...s){for(const t of s)t&&t.manifest&&t.manifest.contributes&&t.manifest.contributes.localizations&&t.manifest.contributes.localizations.length&&this.k(f,t);Object.keys(f).forEach(t=>this.l(f[t]))}k(f,s){const t=s.identifier,n=s.manifest.contributes&&s.manifest.contributes.localizations?s.manifest.contributes.localizations:[];for(const i of n)if(s.location.scheme===N.Schemas.file&&d(i)){let r=f[i.languageId];r||(r={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},f[i.languageId]=r);const o=r.extensions.filter(c=>(0,v.areSameExtensions)(c.extensionIdentifier,t))[0];o?o.version=s.manifest.version:r.extensions.push({extensionIdentifier:t,version:s.manifest.version});for(const c of i.translations)r.translations[c.id]=(0,S.join)(s.location.fsPath,c.path)}}l(f){if(f){const s=(0,T.createHash)("md5");for(const t of f.extensions)s.update(t.extensionIdentifier.uuid||t.extensionIdentifier.id).update(t.version);f.hash=s.digest("hex")}}m(f=()=>null){return this.g.queue(()=>{let s=null;return g.Promises.readFile(this.f,"utf8").then(void 0,t=>t.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(t)).then(t=>{try{return JSON.parse(t)}catch{return{}}}).then(t=>(s=f(t),t)).then(t=>{for(const i of Object.keys(t))t[i]||delete t[i];this.c=t,this.h=!0;const n=JSON.stringify(this.c);return this.i.debug("Writing language packs",n),g.Promises.writeFile(this.f,n)}).then(()=>s,t=>this.i.error(t))})}};l=me([ee(0,u.INativeEnvironmentService),ee(1,m.ILogService)],l);function d(w){if(typeof w.languageId!="string"||!Array.isArray(w.translations)||w.translations.length===0)return!1;for(const f of w.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(w.languageName&&typeof w.languageName!="string"||w.localizedLanguageName&&typeof w.localizedLanguageName!="string")}}),define(Z[47],Q([0,1,15,98,40,8,37]),function(W,e,T,D,k,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function S(O){return O.res.statusCode&&O.res.statusCode>=200&&O.res.statusCode<300||O.res.statusCode===1223}e.isSuccess=S;function g(O){return O.res.statusCode===204}async function u(O){return g(O)?null:(await(0,T.streamToBuffer)(O.stream)).toString()}e.asText=u;async function y(O){if(!S(O))throw new Error("Server returned "+O.res.statusCode);return u(O)}e.asTextOrError=y;async function v(O){if(!S(O))throw new Error("Server returned "+O.res.statusCode);if(g(O))return null;const l=(await(0,T.streamToBuffer)(O.stream)).toString();try{return JSON.parse(l)}catch(d){throw d.message+=`:
`+l,d}}e.asJson=v;function m(O){p(O)}e.updateProxyConfigurationsScope=m;let b;function p(O){const E=N.Registry.as(k.Extensions.Configuration),l=b;b={id:"http",order:15,title:(0,D.localize)(0,null),type:"object",scope:O,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(4,null),(0,D.localize)(5,null),(0,D.localize)(6,null),(0,D.localize)(7,null)],default:"override",description:(0,D.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(9,null),restricted:!0}}},E.updateConfigurations({add:[b],remove:l?[l]:[]})}p(2)}),define(Z[130],Q([0,1,22,16,13,47]),function(W,e,T,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let N=class{constructor(g,u){this.a=g,this.b=u}async download(g,u,y=T.CancellationToken.None){if(g.scheme===D.Schemas.file||g.scheme===D.Schemas.vscodeRemote){await this.b.copy(g,u);return}const v={type:"GET",url:g.toString(!0)},m=await this.a.request(v,y);if(m.res.statusCode===200)await this.b.writeFile(u,m.stream);else{const b=await(0,L.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${b}`)}}};N=me([ee(0,L.IRequestService),ee(1,k.IFileService)],N),e.DownloadService=N}),define(Z[131],Q([0,1,132,5]),function(W,e,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(N,S){return N.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:N.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function L(N,S,g={}){const u=(0,T.parse)(N),y=g.proxyUrl||k(u,S);if(!y)return null;const v=(0,T.parse)(y);if(!/^https?:$/.test(v.protocol||""))return null;const m={host:v.hostname||"",port:v.port||(v.protocol==="https"?"443":"80"),auth:v.auth,rejectUnauthorized:(0,D.isBoolean)(g.strictSSL)?g.strictSSL:!0};return u.protocol==="http:"?new(await new Promise((b,p)=>{W(["http-proxy-agent"],b,p)}))(m):new(await new Promise((b,p)=>{W(["https-proxy-agent"],b,p)}))(m)}e.getProxyAgent=L}),define(Z[133],Q([0,1,57,14,99,22,34,10,12,30,81,161,3]),function(W,e,T,D,k,L,N,S,g,u,y,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const b=1e4;let p;async function O(l,d,w){return d["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.isLaunchedFromCli)(w)&&!d["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.isLaunchedFromCli)(w)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=m.Promises.withAsyncBody(async(f,s)=>{const t=new L.CancellationTokenSource,n=setTimeout(()=>{t.dispose(!0),s(new Error((0,k.localize)(0,null)))},b);try{f(await E(l,t.token))}catch(i){!(0,S.isCancellationError)(i)&&!t.token.isCancellationRequested?s(new Error((0,k.localize)(1,null,(0,N.toErrorMessage)(i)))):f({})}finally{clearTimeout(n),t.dispose()}})),p)}e.getResolvedShellEnv=O;async function E(l,d){const w=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",w);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",f);const s=(0,u.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(s+"({.*})"+s),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};l.trace("getUnixShellEnvironment#env",n);const i=await(0,y.getSystemShell)(g.OS,n);return l.trace("getUnixShellEnvironment#shell",i),new Promise((r,o)=>{if(d.isCancellationRequested)return o((0,S.canceled)());const c=(0,D.basename)(i);let a,h;const R=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(a=`& '${process.execPath}' ${R} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,h=["-Login","-Command"]):(a=`'${process.execPath}' ${R} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,c==="tcsh"?h=["-ic"]:h=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),a);const C=(0,T.spawn)(i,[...h,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});d.onCancellationRequested(()=>(C.kill(),o((0,S.canceled)()))),C.on("error",X=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,N.toErrorMessage)(X)),o(X)});const x=[];C.stdout.on("data",X=>x.push(X));const Y=[];C.stderr.on("data",X=>Y.push(X)),C.on("close",(X,ie)=>{const re=Buffer.concat(x).toString("utf8");l.trace("getUnixShellEnvironment#raw",re);const _=Buffer.concat(Y).toString("utf8");if(_.trim()&&l.trace("getUnixShellEnvironment#stderr",_),X||ie)return o(new Error((0,k.localize)(2,null,X,ie)));const pe=t.exec(re),le=pe?pe[1]:"{}";try{const ae=JSON.parse(le);w?ae.ELECTRON_RUN_AS_NODE=w:delete ae.ELECTRON_RUN_AS_NODE,f?ae.ELECTRON_NO_ATTACH_CONSOLE=f:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.VSCODE_RESOLVING_ENVIRONMENT,delete ae.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",ae),r(ae)}catch(ae){l.error("getUnixShellEnvironment#errorCaught",(0,N.toErrorMessage)(ae)),o(ae)}})})}}),define(Z[67],Q([0,1,8]),function(W,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,T.createDecorator)("stateService")}),define(Z[134],Q([0,1,3,15,5,18,13,9]),function(W,e,T,D,k,L,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class g{constructor(v,m,b){this.f=v,this.g=m,this.h=b,this.a=Object.create(null),this.b="",this.c=new T.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(v){v.fileOperationResult!==1&&this.g.error(v)}}getItem(v,m){const b=this.a[v];return(0,k.isUndefinedOrNull)(b)?m:b}setItem(v,m){this.setItems([{key:v,data:m}])}setItems(v){let m=!1;for(const{key:b,data:p}of v)this.a[b]!==p&&((0,k.isUndefinedOrNull)(p)?(0,k.isUndefined)(this.a[b])||(this.a[b]=void 0,m=!0):(this.a[b]=p,m=!0));m&&this.j()}removeItem(v){(0,k.isUndefined)(this.a[v])||(this.a[v]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const v=JSON.stringify(this.a,null,4);if(v!==this.b)try{await this.h.writeFile(this.f,D.VSBuffer.fromString(v)),this.b=v}catch(m){this.g.error(m)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=g;let u=class{constructor(v,m,b){this.a=new g(v.stateResource,m,b)}async init(){await this.a.init()}getItem(v,m){return this.a.getItem(v,m)}};u=me([ee(0,L.IEnvironmentService),ee(1,S.ILogService),ee(2,N.IFileService)],u),e.StateService=u}),define(Z[68],Q([0,1,12,35,11,30]),function(W,e,T,D,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function N(u){if(T.platform===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}async function S(u,y,v,m,b,p,O,E,l,d){const w=Object.create(null);w["common.machineId"]=O,w.sessionID=(0,L.generateUuid)()+Date.now(),w.commitHash=b,w.version=p,w["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,T.PlatformToString)(T.platform),w["common.nodePlatform"]=D.platform,w["common.nodeArch"]=m,w["common.product"]=d||"desktop",E&&(w["common.msftInternal"]=E);let f=0;const s=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),T.isLinuxSnap&&(w["common.snap"]="true");const t=N(v);t&&(w["common.platformDetail"]=t);try{const n=await u.readFile(k.URI.file(l));w["common.source"]=n.value.toString().slice(0,30)}catch{}return w}e.resolveCommonProperties=S;function g(u){const y=D.env.USERDNSDOMAIN;if(!y)return!1;const v=y.toLowerCase();return u.some(m=>v===m)}e.verifyMicrosoftInternalDomain=g}),define(Z[32],Q([0,1,8]),function(W,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,T.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var D;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(D=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[41],Q([0,1,29,5,21,66,68,32]),function(W,e,T,D,k,L,N,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class g{constructor(c){this.value=c}}e.TrustedTelemetryValue=g;class u{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(c,a){return Promise.resolve(void 0)}publicLog2(c,a){return this.publicLog(c,a)}publicLogError(c,a){return Promise.resolve(void 0)}publicLogError2(c,a){return this.publicLogError(c,a)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=u,e.NullTelemetryService=new u;class y{async publicLog(c,a,h){}async publicLogError(c,a,h){}}e.NullEndpointTelemetryService=y,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(o,c){return c.onDidChangeConfiguration(a=>{a.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(a.source),configurationKeys:w(a.sourceConfig)})})}e.configurationTelemetry=v;function m(o,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!o.enableTelemetry||c.extensionTestsLocationURI)}e.supportsTelemetry=m;function b(o,c){return!(c.isBuilt||c.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.isLoggingOnly=b;function p(o){const c=o.getValue(S.TELEMETRY_SETTING_ID),a=o.getValue("telemetry.enableCrashReporter");if(o.getValue(S.TELEMETRY_OLD_SETTING_ID)===!1||a===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function O(o){const c={},a={},h={};d(o,h);for(let R in h){R=R.length>150?R.substr(R.length-149):R;const C=h[R];typeof C=="number"?a[R]=C:typeof C=="boolean"?a[R]=C?1:0:typeof C=="string"?(C.length>8192&&console.warn(`Telemetry property: ${R} has been trimmed to 8192, the original length is ${C.length}`),c[R]=C.substring(0,8191)):typeof C<"u"&&C!==null&&(c[R]=C)}return{properties:c,measurements:a}}e.validateTelemetryData=O;const E=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function l(o){if(!o)return"none";const c=(0,L.getRemoteName)(o);return E.has(c)?c:"other"}e.cleanRemoteAuthority=l;function d(o,c,a=0,h){if(!!o)for(const R of Object.getOwnPropertyNames(o)){const C=o[R],x=h?h+R:R;Array.isArray(C)?c[x]=(0,T.safeStringify)(C):C instanceof Date?c[x]=C.toISOString():(0,D.isObject)(C)?a<2?d(C,c,a+1,x+"."):c[x]=(0,T.safeStringify)(C):c[x]=C}}function w(o){if(!o)return[];const c=[];return f(c,"",o),c}function f(o,c,a){a&&typeof a=="object"&&!Array.isArray(a)?Object.keys(a).forEach(h=>f(o,c?`${c}.${h}`:h,a[h])):o.push(c)}function s(o,c){const a=o.msftInternalDomains||[],h=c.getValue("telemetry.internalTesting");return(0,N.verifyMicrosoftInternalDomain)(a)||h}e.isInternalTelemetry=s;function t(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=t;function n(o,c){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let a=o;const h=[];for(const Y of c)for(;;){const X=Y.exec(o);if(!X)break;h.push([X.index,Y.lastIndex])}const R=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,C=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let x=0;for(a="";;){const Y=C.exec(o);if(!Y)break;const X=h.some(([ie,re])=>Y.index<re&&ie<C.lastIndex);!R.test(Y[0])&&!X&&(a+=o.substring(x,Y.index)+"<REDACTED: user-file-path>",x=C.lastIndex)}return x<o.length&&(a+=o.substr(x)),a}function i(o){if(!o)return o;const c=o.toLowerCase(),a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of a)if(h.regex.test(c))return`<REDACTED: ${h.label}>`;return o}function r(o,c){return(0,T.cloneAndChange)(o,a=>{if(a instanceof g)return a.value;if(typeof a=="string"){let h=a.replaceAll("%20"," ");h=n(h,c);for(const R of c)h=h.replace(R,"");return h=i(h),h}})}e.cleanData=r}),define(Z[135],Q([0,1,108,41]),function(W,e,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(L,N,S,g,u,y,v){const m={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${N.nameShort})`};if((0,D.supportsTelemetry)(N,S)&&(0,D.getTelemetryLevel)(g)===3){const b=await(0,T.getServiceMachineId)(S,u,y),{machineId:p}=await v.getTelemetryInfo();m["X-Market-User-Id"]=b,m["VSCode-SessionId"]=p||b}return m}e.resolveMarketplaceHeaders=k}),define(Z[136],Q([0,1,10,29,41]),function(W,e,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0",N="https://mobile.events.data.microsoft.com/ping";async function S(u,y,v){const m=await new Promise((l,d)=>{W(["@microsoft/1ds-core-js"],l,d)}),b=await new Promise((l,d)=>{W(["@microsoft/1ds-post-js"],l,d)}),p=new m.AppInsightsCore,O=new b.PostChannel,E={instrumentationKey:u,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[O]]};if(v){E.extensionConfig={};const l={alwaysUseXhrOverride:!0,httpXHROverride:v};E.extensionConfig[O.identifier]=l}return p.initialize(E,[]),p.addTelemetryInitializer(l=>{y&&(l.ext=l.ext??{},l.ext.utc=l.ext.utc??{},l.ext.utc.flags=8462029)}),p}class g{constructor(y,v,m,b,p){this.e=y,this.f=v,this.g=m,this.h=p,this.c=L,this.d=N,this.g||(this.g={}),typeof b=="function"?this.a=b():this.a=b,this.b=null}i(y){if(!!this.a){if(typeof this.a!="string"){y(this.a);return}this.b||(this.b=S(this.a,this.e,this.h)),this.b.then(v=>{y(v)},v=>{(0,T.onUnexpectedError)(v),console.error(v)})}}log(y,v){if(!this.a)return;v=(0,D.mixin)(v,this.g),v=(0,k.validateTelemetryData)(v);const m=this.f+"/"+y;try{this.i(b=>{b.pluginVersionString=v?.properties.version??"Unknown",b.track({name:m,baseData:{name:m,properties:v?.properties,measurements:v?.measurements}})})}catch{}}flush(){return this.a?new Promise(y=>{this.i(v=>{v.unload(!0,()=>{this.a=void 0,y(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=g}),define(Z[137],Q([0,1,2,29,12,31,100,21,40,138,26,37,32,41]),function(W,e,T,D,k,L,N,S,g,u,y,v,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(l,d,w){this.k=d,this.l=w,this.d={},this.i=new T.DisposableStore,this.j=[],this.b=l.appenders,this.c=l.commonProperties||Promise.resolve({}),this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const f of this.f)this.j.push(new RegExp((0,L.escapeRegExpCharacters)(f),"gi")),f.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.escapeRegExpCharacters)(f.replace(/\\/g,"/")),"gi"));this.m(),this.k.onDidChangeConfiguration(this.m,this,this.i)}setExperimentProperty(l,d){this.d[l]=d}m(){let l=(0,b.getTelemetryLevel)(this.k);const d=this.l.enabledTelemetryLevels;if(d){this.h=this.sendErrorTelemetry?d.error:!1;const w=d.usage?3:d.error?2:0;l=Math.min(l,w)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const l=await this.c,d=l.sessionID,w=l["common.machineId"],f=l["common.firstSessionDate"],s=l["common.msftInternal"];return{sessionId:d,machineId:w,firstSessionDate:f,msftInternal:s}}dispose(){this.i.dispose()}n(l,d,w){return this.g<d?Promise.resolve(void 0):this.c.then(f=>{w=(0,D.mixin)(w,this.d),w=(0,b.cleanData)(w,this.j),w=(0,D.mixin)(w,f),this.b.forEach(s=>s.log(l,w))},f=>{console.error(f)})}publicLog(l,d){return this.n(l,3,d)}publicLog2(l,d){return this.publicLog(l,d)}publicLogError(l,d){return this.h?this.n(l,2,d):Promise.resolve(void 0)}publicLogError2(l,d){return this.publicLogError(l,d)}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=me([ee(1,S.IConfigurationService),ee(2,y.IProductService)],p),e.TelemetryService=p;function O(){const E=(0,N.localize)(0,null,u.default.nameLong),l=u.default.privacyStatementUrl?(0,N.localize)(2,null,"https://aka.ms/vscode-telemetry",u.default.privacyStatementUrl):(0,N.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=k.isWeb?"":(0,N.localize)(3,null),w=(0,N.localize)(4,null),f=(0,N.localize)(5,null),s=(0,N.localize)(6,null),t=(0,N.localize)(7,null),n=`
|       | ${w} | ${f} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,N.localize)(8,null);return`
${E} ${l} ${d}

&nbsp;

${t}
${n}

&nbsp;

${i}
`}v.Registry.as(g.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,N.localize)(9,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,N.localize)(10,null),(0,N.localize)(11,null),(0,N.localize)(12,null),(0,N.localize)(13,null)],markdownDescription:O(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.Registry.as(g.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,N.localize)(14,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:u.default.privacyStatementUrl?(0,N.localize)(16,null,u.default.nameLong,u.default.privacyStatementUrl):(0,N.localize)(15,null,u.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(17,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[139],Q([0,1,162,136]),function(W,e,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class k extends D.AbstractOneDataSystemAppender{constructor(N,S,g,u){const y={sendPOST:(v,m)=>{const b={method:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data)}};try{const p=T.request(v.urlString,b,O=>{O.on("data",function(E){m(O.statusCode??200,O.headers,E.toString())}),O.on("error",function(E){m(0,{})})});p.write(v.data),p.end()}catch{m(0,{})}}};super(N,S,g,u,y)}}e.OneDataSystemAppender=k}),define(Z[140],Q([0,1,14,20]),function(W,e,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function k(L,N){const S=Object.create(null),g=(y,v)=>{const m=JSON.parse(y);S[v]=m};if(N){const y=[],v=await D.Promises.readdir(N);for(const b of v)try{(await D.Promises.stat((0,T.join)(N,b))).isDirectory()&&y.push(b)}catch{}const m=[];for(const b of y)(await D.Promises.readdir((0,T.join)(N,b))).filter(O=>O==="telemetry.json").length===1&&m.push(b);for(const b of m){const p=(await D.Promises.readFile((0,T.join)(N,b,"telemetry.json"))).toString();g(p,b)}}let u=(await D.Promises.readFile((0,T.join)(L,"telemetry-core.json"))).toString();return g(u,"vscode-core"),u=(await D.Promises.readFile((0,T.join)(L,"telemetry-extensions.json"))).toString(),g(u,"vscode-extensions"),JSON.stringify(S,null,4)}e.buildTelemetryMessage=k}),define(Z[141],Q([0,1,12,79,32]),function(W,e,T,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function L(N){let S=N.getItem(k.machineIdKey);return(typeof S!="string"||T.isMacintosh&&S==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(S=await(0,D.getMachineId)()),S}e.resolveMachineId=L}),define(Z[28],Q([0,1,8]),function(W,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,T.createDecorator)("IUriIdentityService")}),define(Z[142],Q([0,1,28,109,13,17,71,4,2]),function(W,e,T,D,k,L,N,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class u{constructor(m){this.uri=m,this.time=u._clock++}touch(){return this.time=u._clock++,this}}u._clock=0;let y=class{constructor(m){this.g=m,this.c=new g.DisposableStore,this.f=2**16;const b=new Map,p=O=>{let E=b.get(O.scheme);return E===void 0&&(E=m.hasProvider(O)&&!this.g.hasCapability(O,1024),b.set(O.scheme,E)),E};this.c.add(S.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(O=>{b.delete(O.scheme)})),this.extUri=new L.ExtUri(p),this.d=new N.SkipList((O,E)=>this.extUri.compare(O,E,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,L.normalizePath)(m));const b=this.d.get(m);return b?b.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new u(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((p,O)=>p[1].touch<O[1].touch?1:p[1].touch>O[1].touch?-1:0);u._clock=0,this.d.clear();const b=this.f*.5;for(let p=0;p<b;p++)this.d.set(m[p][0],m[p][1].touch())}};y=me([ee(0,k.IFileService)],y),e.UriIdentityService=y,(0,D.registerSingleton)(T.IUriIdentityService,y,1)}),define(Z[143],Q([0,1,102,14,54,17,11,8,16]),function(W,e,T,D,k,L,N,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,S.createDecorator)("contextService");function u(n){const i=n;return typeof i?.id=="string"&&N.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=u,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function y(n,i){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,D.basename)(n)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const r=n;if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=y;function v(n){const i=n;return typeof i?.id=="string"&&N.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=v;function m(n){const i=n;if(i?.uri)return{id:i.id,uri:N.URI.revive(i.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:N.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=m;var b;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(b=e.WorkbenchState||(e.WorkbenchState={}));function p(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=p;function O(n){const i=n;return!!(i&&typeof i=="object"&&N.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=O;class E{constructor(i,r,o,c,a){this.h=i,this.j=o,this.k=c,this.l=a,this.c=k.TernarySearchTree.forUris(this.l,()=>!0),this.folders=r}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=k.TernarySearchTree.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=E;class l{constructor(i,r){this.raw=r,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,L.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=l;function d(n){return new l({uri:n,index:0,name:(0,L.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=d,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,T.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function w(n,i){return L.extUriBiasedIgnorePathCase.isEqualOrParent(n,i.untitledWorkspacesHome)}e.isUntitledWorkspace=w;function f(n){let i;return N.URI.isUri(n)?i=n:i=n.configuration,i?.scheme===g.Schemas.tmp}e.isTemporaryWorkspace=f;function s(n,i){return!w(n,i)&&!f(n)}e.isSavedWorkspace=s;function t(n){return(typeof n=="string"?(0,D.extname)(n):(0,L.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=t}),define(Z[25],Q([0,1,52,4,2,17,11,101,18,13,8,9,143,36,28,3,30,31,5]),function(W,e,T,D,k,L,N,S,g,u,y,v,m,b,p,O,E,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function w(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&N.URI.isUri(r.location)&&N.URI.isUri(r.globalStorageHome)&&N.URI.isUri(r.settingsResource)&&N.URI.isUri(r.keybindingsResource)&&N.URI.isUri(r.tasksResource)&&N.URI.isUri(r.snippetsHome)&&N.URI.isUri(r.extensionsResource))}e.isUserDataProfile=w,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,y.createDecorator)("IUserDataProfilesService");function f(i,r){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:N.URI.revive(i.location).with({scheme:r}),globalStorageHome:N.URI.revive(i.globalStorageHome).with({scheme:r}),settingsResource:N.URI.revive(i.settingsResource).with({scheme:r}),keybindingsResource:N.URI.revive(i.keybindingsResource).with({scheme:r}),tasksResource:N.URI.revive(i.tasksResource).with({scheme:r}),snippetsHome:N.URI.revive(i.snippetsHome).with({scheme:r}),extensionsResource:N.URI.revive(i.extensionsResource)?.with({scheme:r}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=f;function s(i,r,o,c){return{id:i,name:r,location:o,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,L.joinPath)(o,"globalStorage"),settingsResource:(0,L.joinPath)(o,"settings.json"),keybindingsResource:(0,L.joinPath)(o,"keybindings.json"),tasksResource:(0,L.joinPath)(o,"tasks.json"),snippetsHome:(0,L.joinPath)(o,"snippets"),extensionsResource:(0,L.joinPath)(o,"extensions.json"),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=s;let t=class extends k.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(r,o,c,a){super(),this.m=r,this.n=o,this.r=c,this.s=a,this.f=!1,this.g=this.B(new D.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new D.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new D.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new D.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new b.ResourceMap},this.profilesHome=(0,L.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(r){this.f!==r&&(this.t=void 0,this.f=r)}isEnabled(){return this.f}get u(){if(!this.t){const r=[];if(this.f)for(const h of this.H()){if(!h.name||!(0,d.isString)(h.name)||!h.location){this.s.warn("Skipping the invalid stored profile",h.location||h.name);continue}r.push(s((0,L.basename)(h.location),h.name,h.location,{shortName:h.shortName,useDefaultFlags:h.useDefaultFlags}))}let o;const c=new b.ResourceMap,a=s((0,T.hash)(this.m.userRoamingDataHome.path).toString(16),(0,S.localize)(0,null),this.m.userRoamingDataHome);if(r.unshift({...a,extensionsResource:this.M()??a.extensionsResource,isDefault:!0}),r.length){const h=this.J();if(h.workspaces)for(const[R,C]of Object.entries(h.workspaces)){const x=N.URI.parse(R),Y=N.URI.parse(C),X=r.find(ie=>this.r.extUri.isEqual(ie.location,Y));X&&c.set(x,X)}if(h.emptyWindow){const R=N.URI.parse(h.emptyWindow);o=r.find(C=>this.r.extUri.isEqual(C.location,R))}}this.t={profiles:r,workspaces:c,emptyWindow:o}}return this.t}async createTransientProfile(r){const o="Temp",c=new RegExp(`${(0,l.escapeRegExpCharacters)(o)}\\s(\\d+)`);let a=0;for(const R of this.profiles){const C=c.exec(R.name),x=C?parseInt(C[1]):0;a=x>a?x:a}const h=`${o} ${a+1}`;return this.createProfile((0,T.hash)((0,E.generateUuid)()).toString(16),h,{transient:!0},r)}async createNamedProfile(r,o,c){return this.createProfile((0,T.hash)((0,E.generateUuid)()).toString(16),r,o,c)}async createProfile(r,o,c,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const h=await this.v(r,o,c);return a&&await this.setProfileForWorkspace(a,h),h}async v(r,o,c){if(!(0,d.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let a=this.k.get(o);return a||(a=(async()=>{try{const h=this.profiles.find(x=>x.name===o||x.id===r);if(h)return h;const R=s(r,o,(0,L.joinPath)(this.profilesHome,r),c);await this.n.createFolder(R.location);const C=[];return this.h.fire({profile:R,join(x){C.push(x)}}),await O.Promises.settled(C),this.C([R],[],[]),R}finally{this.k.delete(o)}})(),this.k.set(o,a)),a}async updateProfile(r,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let c=this.profiles.find(a=>a.id===r.id);if(!c)throw new Error(`Profile '${r.name}' does not exist`);return c=s(c.id,o.name??c.name,c.location,{shortName:o.shortName??c.shortName,transient:o.transient??c.isTransient,useDefaultFlags:o.useDefaultFlags??c.useDefaultFlags}),this.C([],[],[c]),c}async removeProfile(r){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(r.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(a=>a.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);const c=[];this.i.fire({profile:o,join(a){c.push(a)}});try{await Promise.allSettled(c)}catch(a){this.s.error(a)}o.id===this.u.emptyWindow?.id&&(this.u.emptyWindow=void 0);for(const a of[...this.u.workspaces.keys()])o.id===this.u.workspaces.get(a)?.id&&this.u.workspaces.delete(a);this.G(),this.C([],[o],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(o.location,{recursive:!0})}catch(a){this.s.error(a)}}getOrSetProfileForWorkspace(r,o=this.defaultProfile){if(!this.f)return this.defaultProfile;let c=this.w(r);return c||(c=o,this.profiles.length>1&&this.setProfileForWorkspaceSync(r,c)),c}async setProfileForWorkspace(r,o){this.setProfileForWorkspaceSync(r,o)}setProfileForWorkspaceSync(r,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=this.profiles.find(a=>a.id===o.id);if(!c)throw new Error(`Profile '${o.name}' does not exist`);this.F(r,c)}unsetWorkspace(r,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.F(r,void 0,o)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindow=void 0,this.u.workspaces.clear(),this.u.emptyWindow=void 0,this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const r=await this.n.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(o=>o.isDirectory&&this.profiles.every(c=>!this.r.extUri.isEqual(c.location,o.resource))).map(o=>this.n.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const r=this.l.profiles.filter(o=>!this.z(o));await Promise.allSettled(r.map(o=>this.removeProfile(o)))}w(r){const o=this.y(r);return N.URI.isUri(o)?this.l.workspaces.get(o)??this.u.workspaces.get(o):this.l.emptyWindow??this.u.emptyWindow}y(r){return(0,m.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,m.isWorkspaceIdentifier)(r)?r.configPath:"empty-window"}z(r){return!!(this.r.extUri.isEqual(this.l.emptyWindow?.location,r.location)||[...this.l.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,r.location))||this.r.extUri.isEqual(this.u.emptyWindow?.location,r.location)||[...this.u.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,r.location)))}C(r,o,c){const a=[...this.profiles,...r],h=[];this.l.profiles=[];for(let R of a)R.isDefault||o.some(C=>R.id===C.id)||(R=c.find(C=>R.id===C.id)??R,R.isTransient?this.l.profiles.push(R):h.push({location:R.location,name:R.name,shortName:R.shortName,useDefaultFlags:R.useDefaultFlags}));this.I(h),this.t=void 0,this.D(r,o,c)}D(r,o,c){this.g.fire({added:r,removed:o,updated:c,all:this.profiles})}F(r,o,c){c=o?.isTransient?!0:c,c||this.F(r,void 0,!0);const a=this.y(r),h=c?this.l:this.u;N.URI.isUri(a)?(h.workspaces.delete(a),o&&h.workspaces.set(a,o)):h.emptyWindow=o,c||this.G()}G(){const r={};for(const[c,a]of this.u.workspaces.entries())r[c.toString()]=a.location.toString();const o=this.u.emptyWindow?.location.toString();this.L({workspaces:r,emptyWindow:o}),this.t=void 0}H(){return[]}I(r){throw new Error("not implemented")}J(){return{}}L(r){throw new Error("not implemented")}M(){}};t.b="userDataProfiles",t.c="profileAssociations",t=me([ee(0,g.IEnvironmentService),ee(1,u.IFileService),ee(2,p.IUriIdentityService),ee(3,v.ILogService)],t),e.UserDataProfilesService=t;class n extends t{constructor(){super(...arguments),this.a=[],this.P={}}H(){return this.a}I(r){this.a=r}J(){return this.P}L(r){this.P=r}}e.InMemoryUserDataProfilesService=n}),define(Z[144],Q([0,1,19,3,22,10,4,2,12,11,86,23,24,27,9,26,32,25]),function(W,e,T,D,k,L,N,S,g,u,y,v,m,b,p,O,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let d=class extends S.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(i,r,o,c,a){super(),this.t=i,this.u=r,this.v=o,this.w=c,this.y=a,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new N.Emitter),this.m=this.B(new N.Emitter),this.n=this.B(new N.Emitter),this.p=this.B(new N.Emitter),this.s=[],this.B((0,S.toDisposable)(()=>{this.j.forEach(({task:h})=>h.cancel()),this.k.forEach(h=>h.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(i){const r=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,v.isTargetPlatformCompatible)(o,i.allTargetPlatforms,r))}async installFromGallery(i,r={}){try{if(!this.t.isEnabled())throw new v.ExtensionManagementError(y.localize(0,null),v.ExtensionManagementErrorCode.Internal);const o=await this.G(i,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.z(o.manifest,o.extension,r)}catch(o){throw s(this.u,"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(i),error:o}),this.v.error("Failed to install extension.",i.identifier.id),this.v.error(o),f(o)}}async uninstall(i,r={}){return this.v.trace("ExtensionManagementService#uninstall",i.identifier.id),this.I(i,r)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.O(),this.h=i),this.g}registerParticipant(i){this.s.push(i)}async z(i,r,o){const c={...o,installOnlyNewlyAddedFromExtensionPack:u.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,b.isApplicationScopedExtension)(i)?this.y.defaultProfile.extensionsResource:o.profileLocation??this.P()},a=X=>`${m.ExtensionKey.create(X).toString()}${c.profileLocation?`-${c.profileLocation.toString()}`:""}`;if(!u.URI.isUri(r)){const X=this.j.get(a(r));if(X){this.v.info("Extensions is already requested to install",r.identifier.id);const{local:ie}=await X.task.waitUntilTaskIsFinished();return ie}}const h=[],R=[],C=[],x=this.Q(i,r,c);u.URI.isUri(r)||this.j.set(a(r),{task:x,waitingTasks:[]}),this.l.fire({identifier:x.identifier,source:r,profileLocation:c.profileLocation}),this.v.info("Installing extension:",x.identifier.id),h.push({task:x,manifest:i});let Y=!1;try{if(c.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",x.identifier.id);else try{const ie=await this.F(x.identifier,i,!!c.installOnlyNewlyAddedFromExtensionPack,!!c.installPreReleaseVersion,c.profileLocation),re=await this.getInstalled(void 0,c.profileLocation);for(const{gallery:_,manifest:pe}of(0,T.distinct)(ie,({gallery:le})=>le.identifier.id)){Y=Y||!!pe.extensionDependencies?.some(he=>(0,m.areSameExtensions)({id:he},x.identifier));const le=a(_),ae=this.j.get(le);if(ae){if(this.C(x,ae.task)){const he=ae.task.identifier;this.v.info("Waiting for already requested installing extension",he.id,x.identifier.id),ae.waitingTasks.push(x),R.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,B=>B.some(j=>(0,m.areSameExtensions)(j.identifier,he)))).then(B=>{if(this.v.info("Finished waiting for already requested installing extension",he.id,x.identifier.id),!B.find(A=>(0,m.areSameExtensions)(A.identifier,he))?.local)throw new Error(`Extension ${he.id} is not installed`)}))}}else if(!re.some(({identifier:he})=>(0,m.areSameExtensions)(he,_.identifier))){const he=this.Q(pe,_,{...c,donotIncludePackAndDependencies:!0});this.j.set(le,{task:he,waitingTasks:[x]}),this.l.fire({identifier:he.identifier,source:_,profileLocation:c.profileLocation}),this.v.info("Installing extension:",he.identifier.id,x.identifier.id),h.push({task:he,manifest:pe})}}}catch(ie){if(u.URI.isUri(x.source))(0,T.isNonEmptyArray)(i.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",x.identifier.id,ie.message),(0,T.isNonEmptyArray)(i.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",x.identifier.id,ie.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",x.identifier.id),ie}const X=h.reduce((ie,{task:re,manifest:_})=>(ie.set(re.identifier.id.toLowerCase(),{task:re,manifest:_}),ie),new Map);for(;X.size;){let ie;const re=[...X.values()].filter(({manifest:_})=>!_.extensionDependencies?.some(pe=>X.has(pe.toLowerCase())));re.length?ie=X.size===1?re:re.filter(({task:_})=>!(_===x&&!Y)):(this.v.info("Found extensions with circular dependencies",re.map(({task:_})=>_.identifier.id)),ie=[...X.values()]),await this.D(ie.map(async({task:_})=>{const pe=new Date().getTime();try{const{local:le}=await _.run();if(await this.D(this.s.map(ae=>ae.postInstall(le,_.source,c,k.CancellationToken.None))),!u.URI.isUri(_.source)){const ae=_.operation===3,he=ae?void 0:(new Date().getTime()-_.source.lastUpdated)/1e3;if(s(this.u,ae?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(_.source),wasVerified:_.wasVerified,duration:new Date().getTime()-pe,durationSinceUpdate:he}),g.isWeb&&_.operation!==3)try{await this.t.reportStatistic(le.manifest.publisher,le.manifest.name,le.manifest.version,"install")}catch{}}C.push({local:le,identifier:_.identifier,operation:_.operation,source:_.source,context:c.context,profileLocation:c.profileLocation,applicationScoped:le.isApplicationScoped})}catch(le){throw u.URI.isUri(_.source)||s(this.u,_.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(_.source),wasVerified:_.wasVerified,duration:new Date().getTime()-pe,error:le}),this.v.error("Error while installing the extension:",_.identifier.id),le}finally{X.delete(_.identifier.id.toLowerCase())}}))}return R.length&&await this.D(R),C.forEach(({identifier:ie})=>this.v.info("Extension installed successfully:",ie.id)),this.m.fire(C),C.filter(({identifier:ie})=>(0,m.areSameExtensions)(ie,x.identifier))[0].local}catch(X){if(h.forEach(({task:ie})=>ie.cancel()),C.length)try{const ie=await Promise.allSettled(C.map(({local:re})=>this.R(re,{versionOnly:!0,profileLocation:c.profileLocation}).run()));for(let re=0;re<ie.length;re++){const _=ie[re],{identifier:pe}=C[re];_.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",pe.id):this.v.warn("Rollback: Error while uninstalling extension",pe.id,(0,L.getErrorMessage)(_.reason))}}catch(ie){this.v.warn("Error while rolling back extensions",(0,L.getErrorMessage)(ie),C.map(({identifier:re})=>re.id))}throw this.m.fire(h.map(({task:ie})=>({identifier:ie.identifier,operation:2,source:ie.source,context:c.context,profileLocation:c.profileLocation}))),X}finally{for(const{task:X}of h)X.source&&!u.URI.isUri(X.source)&&this.j.delete(a(X.source))}}C(i,r){for(const[,{task:o,waitingTasks:c}]of this.j.entries())if(o===i&&(c.includes(r)||c.some(a=>this.C(a,r)))||o===r&&c[0]&&!this.C(i,c[0]))return!1;return!0}async D(i){const r=[],o=[],c=await Promise.allSettled(i);for(const a of c)a.status==="fulfilled"?r.push(a.value):o.push(a.reason);if(o.length)throw w(o);return r}async F(i,r,o,c,a){if(!this.t.isEnabled())return[];const h=await this.getInstalled(void 0,a),R=[],C=[],x=async(Y,X)=>{R.push(Y);const ie=X.extensionDependencies||[],re=[...ie];if(X.extensionPack){const _=o?h.find(pe=>(0,m.areSameExtensions)(pe.identifier,Y)):void 0;for(const pe of X.extensionPack)_&&_.manifest.extensionPack&&_.manifest.extensionPack.some(le=>(0,m.areSameExtensions)({id:le},{id:pe}))||re.every(le=>!(0,m.areSameExtensions)({id:le},{id:pe}))&&re.push(pe)}if(re.length){const _=re.filter(pe=>R.every(le=>!(0,m.areSameExtensions)(le,{id:pe})));if(_.length){const pe=await this.t.getExtensions(_.map(le=>({id:le,preRelease:c})),k.CancellationToken.None);for(const le of pe){if(R.find(B=>(0,m.areSameExtensions)(B,le.identifier)))continue;const ae=ie.some(B=>(0,m.areSameExtensions)({id:B},le.identifier));let he;try{he=await this.G(le,!1,c)}catch(B){if(B instanceof v.ExtensionManagementError&&B.code===v.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!ae){this.v.info("Skipping the packed extension as it cannot be installed",le.identifier.id);continue}else throw B}C.push({gallery:he.extension,manifest:he.manifest}),await x(he.extension.identifier,he.manifest)}}}};return await x(i,r),C}async G(i,r,o){if((await this.getExtensionsControlManifest()).malicious.some(R=>(0,m.areSameExtensions)(i.identifier,R)))throw new v.ExtensionManagementError(y.localize(1,null,i.identifier.id),v.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const R=await this.getTargetPlatform();throw new v.ExtensionManagementError(y.localize(2,null,i.identifier.id,this.w.nameLong,(0,v.TargetPlatformToString)(R)),v.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.H(i,r,o);if(a){if(o&&!r&&i.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new v.ExtensionManagementError(y.localize(3,null,i.identifier.id,this.w.nameLong,this.w.version),v.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&i.properties.isPreReleaseVersion&&(await this.t.getExtensions([i.identifier],k.CancellationToken.None))[0]?new v.ExtensionManagementError(y.localize(4,null,i.identifier.id),v.ExtensionManagementErrorCode.ReleaseVersionNotFound):new v.ExtensionManagementError(y.localize(5,null,i.identifier.id,this.w.nameLong,this.w.version),v.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",a.identifier.id);const h=await this.t.getManifest(a,k.CancellationToken.None);if(h===null)throw new v.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,v.ExtensionManagementErrorCode.Invalid);if(h.version!==a.version)throw new v.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,v.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:h}}async H(i,r,o){const c=await this.getTargetPlatform();let a=null;return!r&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(a=(await this.t.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:c,compatible:!0},k.CancellationToken.None))[0]||null),!a&&await this.t.isExtensionCompatible(i,o,c)&&(a=i),a||(r?a=(await this.t.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:c,compatible:!0},k.CancellationToken.None))[0]||null:a=await this.t.getCompatibleExtension(i,o,c)),a}async I(i,r){const o={...r,profileLocation:i.isApplicationScoped?this.y.defaultProfile.extensionsResource:r.profileLocation??this.P()},c=Y=>`${Y.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,a=this.k.get(c(i.identifier));if(a)return this.v.info("Extensions is already requested to uninstall",i.identifier.id),a.waitUntilTaskIsFinished();const h=Y=>{const X=this.R(Y,o);return this.k.set(c(X.extension.identifier),X),o.profileLocation?this.v.info("Uninstalling extension from the profile:",`${Y.identifier.id}@${Y.manifest.version}`,o.profileLocation.toString()):this.v.info("Uninstalling extension:",`${Y.identifier.id}@${Y.manifest.version}`),this.n.fire({identifier:Y.identifier,profileLocation:o.profileLocation,applicationScoped:Y.isApplicationScoped}),X},R=(Y,X)=>{X?o.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${Y.identifier.id}@${Y.manifest.version}`,o.profileLocation.toString(),X.message):this.v.error("Failed to uninstall extension:",`${Y.identifier.id}@${Y.manifest.version}`,X.message):o.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${Y.identifier.id}@${Y.manifest.version}`,o.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${Y.identifier.id}@${Y.manifest.version}`),s(this.u,"extensionGallery:uninstall",{extensionData:(0,m.getLocalExtensionTelemetryData)(Y),error:X}),this.p.fire({identifier:Y.identifier,error:X?.code,profileLocation:o.profileLocation,applicationScoped:Y.isApplicationScoped})},C=[],x=[];try{C.push(h(i));const Y=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const X=this.M(i,Y);for(const ie of X)this.k.has(c(ie.identifier))?this.v.info("Extensions is already requested to uninstall",ie.identifier.id):C.push(h(ie))}o.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.J(C.map(X=>X.extension),Y,i),await this.D(C.map(async X=>{try{if(await X.run(),await this.D(this.s.map(ie=>ie.postUninstall(X.extension,o,k.CancellationToken.None))),X.extension.identifier.uuid)try{await this.t.reportStatistic(X.extension.manifest.publisher,X.extension.manifest.name,X.extension.manifest.version,"uninstall")}catch{}R(X.extension)}catch(ie){const re=ie instanceof v.ExtensionManagementError?ie:new v.ExtensionManagementError((0,L.getErrorMessage)(ie),v.ExtensionManagementErrorCode.Internal);throw R(X.extension,re),re}finally{x.push(X)}}))}catch(Y){const X=Y instanceof v.ExtensionManagementError?Y:new v.ExtensionManagementError((0,L.getErrorMessage)(Y),v.ExtensionManagementErrorCode.Internal);for(const ie of C){try{ie.cancel()}catch{}x.includes(ie)||R(ie.extension,X)}throw X}finally{for(const Y of C)this.k.delete(c(Y.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",Y.extension.identifier.id)}}J(i,r,o){for(const c of i){const a=this.N(c,r);if(a.length){const h=a.filter(R=>!i.some(C=>(0,m.areSameExtensions)(C.identifier,R.identifier)));if(h.length)throw new Error(this.L(c,h,o))}}}L(i,r,o){return o===i?r.length===1?y.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?y.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):y.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?y.localize(9,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?y.localize(10,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):y.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}M(i,r,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const c=i.manifest.extensionPack?i.manifest.extensionPack:[];if(c.length){const a=r.filter(R=>!R.isBuiltin&&c.some(C=>(0,m.areSameExtensions)({id:C},R.identifier))),h=[];for(const R of a)h.push(...this.M(R,r,o));return[...a,...h]}return[]}N(i,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(c=>(0,m.areSameExtensions)({id:c},i.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const i=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};d=me([ee(0,v.IExtensionGalleryService),ee(1,E.ITelemetryService),ee(2,p.ILogService),ee(3,O.IProductService),ee(4,l.IUserDataProfilesService)],d),e.AbstractExtensionManagementService=d;function w(n){const i=Array.isArray(n)?n:[n];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=w;function f(n){if(n instanceof v.ExtensionManagementError)return n;const i=new v.ExtensionManagementError(n.message,v.ExtensionManagementErrorCode.Internal);return i.stack=n.stack,i}function s(n,i,{extensionData:r,wasVerified:o,duration:c,error:a,durationSinceUpdate:h}){let R,C;a&&(a instanceof v.ExtensionManagementError?(R=a.code,a.code===v.ExtensionManagementErrorCode.Signature&&(C=a.message)):R=v.ExtensionManagementErrorCode.Internal),n.publicLog(i,{...r,wasVerified:o,success:!a,duration:c,errorcode:R,errorcodeDetail:C,durationSinceUpdate:h})}e.reportTelemetry=s;class t{constructor(){this.d=new D.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,D.createCancelablePromise)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.createCancelablePromise)(i=>new Promise((r,o)=>{const c=i.onCancellationRequested(()=>{c.dispose(),o(new L.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=t}),define(Z[42],Q([0,1,3,15,2,4,36,11,24,27,13,8,9,25,28]),function(W,e,T,D,k,L,N,S,g,u,y,v,m,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,v.createDecorator)("IExtensionsProfileScannerService");let O=class extends k.Disposable{constructor(d,w,f,s){super(),this.h=d,this.i=w,this.j=f,this.k=s,this.a=this.B(new L.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new L.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new L.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new L.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new N.ResourceMap}scanProfileExtensions(d){return this.l(d)}async addExtensionsToProfile(d,w){const f=[],s=[];try{return await this.l(w,t=>{const n=[];for(const i of t)d.some(([r])=>(0,g.areSameExtensions)(r.identifier,i.identifier)&&r.manifest.version!==i.version)?f.push(i):n.push(i);for(const[i,r]of d)if(!n.some(o=>(0,g.areSameExtensions)(o.identifier,i.identifier)&&o.version===i.manifest.version)){const o={identifier:i.identifier,version:i.manifest.version,location:i.location,metadata:r};s.push(o),n.push(o)}return s.length&&this.a.fire({extensions:s,profileLocation:w}),f.length&&this.c.fire({extensions:f,profileLocation:w}),n}),s.length&&this.b.fire({extensions:s,profileLocation:w}),f.length&&this.f.fire({extensions:f,profileLocation:w}),s}catch(t){throw s.length&&this.b.fire({extensions:s,error:t,profileLocation:w}),f.length&&this.f.fire({extensions:f,error:t,profileLocation:w}),t}}async removeExtensionFromProfile(d,w){const f=[];this.c.fire({extensions:f,profileLocation:w});try{await this.l(w,s=>{const t=[];for(const n of s)(0,g.areSameExtensions)(n.identifier,d.identifier)?f.push(n):t.push(n);return f.length&&this.c.fire({extensions:f,profileLocation:w}),t}),f.length&&this.f.fire({extensions:f,profileLocation:w})}catch(s){throw f.length&&this.f.fire({extensions:f,error:s,profileLocation:w}),s}}async l(d,w){return this.p(d).queue(async()=>{let f=[],s;try{const t=await this.h.readFile(d);s=JSON.parse(t.value.toString())}catch(t){if((0,y.toFileOperationResult)(t)!==1)throw t;this.j.extUri.isEqual(d,this.i.defaultProfile.extensionsResource)&&(s=await this.n())}if(s)for(const t of s){if(!t.identifier){this.k.info("Ignoring invalid extension while scanning. Identifier does not exist.",t);continue}if(!t.location){this.k.info("Ignoring invalid extension while scanning. Location does not exist.",t);continue}if(!t.version){this.k.info("Ignoring invalid extension while scanning. Version does not exist.",t);continue}f.push({identifier:t.identifier,location:S.URI.revive(t.location),version:t.version,metadata:t.metadata})}if(w){f=w(f);const t=f.map(n=>({identifier:n.identifier,version:n.version,location:n.location.toJSON(),metadata:n.metadata}));await this.h.writeFile(d,D.VSBuffer.fromString(JSON.stringify(t)))}return f})}async n(){return this.m||(this.m=(async()=>{const d=this.j.extUri.joinPath(this.i.defaultProfile.location,"extensions.json");let w;try{w=(await this.h.readFile(d)).value.toString()}catch(s){if((0,y.toFileOperationResult)(s)===1)return;throw s}this.k.info("Migrating extensions from old default profile location",d.toString());let f;try{const s=JSON.parse(w);Array.isArray(s)&&s.every(t=>!!(t&&typeof t=="object"&&(0,u.isIExtensionIdentifier)(t.identifier)&&E(t.location)&&t.version&&typeof t.version=="string"))?f=s:this.k.warn("Skipping migrating from old default profile locaiton: Found invalid data",s)}catch(s){this.k.error(s)}if(f)try{await this.h.createFile(this.i.defaultProfile.extensionsResource,D.VSBuffer.fromString(JSON.stringify(f)),{overwrite:!1}),this.k.info("Migrated extensions from old default profile location to new location",d.toString(),this.i.defaultProfile.extensionsResource.toString())}catch(s){if((0,y.toFileOperationResult)(s)===3)this.k.info("Migration from old default profile location to new location is done by another window",d.toString(),this.i.defaultProfile.extensionsResource.toString());else throw s}try{await this.h.del(d)}catch(s){(0,y.toFileOperationResult)(s)!==1&&this.k.error(s)}return f})()),this.m}p(d){let w=this.g.get(d);return w||(w=new T.Queue,this.g.set(d,w)),w}};O=me([ee(0,y.IFileService),ee(1,b.IUserDataProfilesService),ee(2,p.IUriIdentityService),ee(3,m.ILogService)],O),e.ExtensionsProfileScannerService=O;function E(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}}),define(Z[48],Q([0,1,19,3,29,15,10,50,77,2,16,14,12,17,39,53,5,11,90,18,24,27,45,13,8,9,26,4,44,42,25,28,106,107]),function(W,e,T,D,k,L,N,S,g,u,y,v,m,b,p,O,E,l,d,w,f,s,t,n,i,r,o,c,a,h,R,C,x,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var X;(function(he){function B(j,A){if(j===A)return!0;const z=Object.keys(j),$=new Set;for(const q of Object.keys(A))$.add(q);if(z.length!==$.size)return!1;for(const q of z){if(j[q]!==A[q])return!1;$.delete(q)}return $.size===0}he.equals=B})(X=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let ie=class extends u.Disposable{constructor(B,j,A,z,$,q,K,I,P,M,F,V){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=j,this.l=A,this.m=z,this.n=$,this.p=q,this.r=K,this.s=I,this.t=P,this.u=M,this.v=F,this.w=V,this.g=this.B(new c.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,b.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(pe,(0,b.joinPath)(this.m,s.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(pe,(0,b.joinPath)(this.m,s.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(_,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,f.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(B,j,A){const[z,$]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(j)]),q=A?await this.scanExtensionsUnderDevelopment(B,[...z,...$]):[];return this.D(z,$,q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const j=[];j.push(this.F(!!B.useCache,B.language)),j.push(this.G(B.language,!!B.checkControlFile));const[A,z]=await Promise.all(j);return this.C([...A,...z],0,B,!1)}async scanUserExtensions(B){const j=B.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",j);const A=await this.I(j,!!B.profileLocation,1,!B.includeUninstalled,B.language);let $=await(B.useCache&&!A.devMode&&A.excludeObsolete?this.j:this.k).scanExtensions(A);return $=await this.C($,1,B,!0),this.s.trace("Scanned user extensions:",$.length),$}async scanExtensionsUnderDevelopment(B,j){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const A=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(z=>z.scheme===y.Schemas.file).map(async z=>{const $=await this.I(z,!1,1,!0,B.language,!1);return(await this.k.scanOneOrMultipleExtensions($)).map(K=>(K.type=j.find(I=>(0,f.areSameExtensions)(I.identifier,K.identifier))?.type??K.type,this.k.validate(K,$)))}))).flat();return this.C(A,"development",B,!0)}return[]}async scanExistingExtension(B,j,A){const z=await this.I(B,!1,j,!0,A.language),$=await this.k.scanExtension(z);return!$||!A.includeInvalid&&!$.isValid?null:$}async scanOneOrMultipleExtensions(B,j,A){const z=await this.I(B,!1,j,!0,A.language),$=await this.k.scanOneOrMultipleExtensions(z);return this.C($,j,A,!0)}async scanMetadata(B){const j=(0,b.joinPath)(B,"package.json"),A=(await this.r.readFile(j)).value.toString();return JSON.parse(A).__metadata}async updateMetadata(B,j){const A=(0,b.joinPath)(B,"package.json"),z=(await this.r.readFile(A)).value.toString(),$=JSON.parse(z);j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,j.installedTimestamp=j.installedTimestamp||void 0,$.__metadata={...$.__metadata,...j},await this.r.writeFile((0,b.joinPath)(B,"package.json"),L.VSBuffer.fromString(JSON.stringify($,null,"	")))}initializeDefaultProfileExtensions(){return this.z||(this.z=(async()=>{try{const B=this.v.extUri.joinPath(this.userExtensionsLocation,".init-default-profile-extensions");if(await this.r.exists(B))return;if(!await this.r.exists(this.n.defaultProfile.extensionsResource)&&!await this.r.exists(this.v.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"))){this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const j=await this.scanUserExtensions({includeInvalid:!0});await this.p.addExtensionsToProfile(j.map(A=>[A,A.metadata]),this.n.defaultProfile.extensionsResource),this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}try{await this.r.createFile(B,L.VSBuffer.fromString(""))}catch(j){(0,n.toFileOperationResult)(j)!==1&&this.s.warn("Failed to create default profile extensions initialize marker in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.getErrorMessage)(j))}}catch(B){throw this.s.error(B),B}})()),this.z}async C(B,j,A,z){return A.includeAllVersions||(B=this.D(j===0?B:void 0,j===1?B:void 0,j==="development"?B:void 0,await this.getTargetPlatform(),z)),A.includeInvalid||(B=B.filter($=>$.isValid)),B.sort(($,q)=>{const K=v.basename($.location.fsPath),I=v.basename(q.location.fsPath);return K<I?-1:K>I?1:0})}D(B,j,A,z,$){const q=(I,P,M)=>{if(I.isValid&&!P.isValid)return!1;if(I.isValid===P.isValid){if($&&p.gt(I.manifest.version,P.manifest.version))return this.s.debug(`Skipping extension ${P.location.path} with lower version ${P.manifest.version} in favour of ${I.location.path} with version ${I.manifest.version}`),!1;if(p.eq(I.manifest.version,P.manifest.version)){if(I.type===0)return this.s.debug(`Skipping extension ${P.location.path} in favour of system extension ${I.location.path} with same version`),!1;if(I.targetPlatform===z)return this.s.debug(`Skipping extension ${P.location.path} from different target platform ${P.targetPlatform}`),!1}}return M?this.s.warn(`Overwriting user extension ${I.location.path} with ${P.location.path}.`):this.s.debug(`Overwriting user extension ${I.location.path} with ${P.location.path}.`),!0},K=new Map;return B?.forEach(I=>{const P=s.ExtensionIdentifier.toKey(I.identifier.id),M=K.get(P);(!M||q(M,I,!1))&&K.set(P,I)}),j?.forEach(I=>{const P=s.ExtensionIdentifier.toKey(I.identifier.id),M=K.get(P);if(!M&&B&&I.type===0){this.s.debug(`Skipping obsolete system extension ${I.location.path}.`);return}(!M||q(M,I,!1))&&K.set(P,I)}),A?.forEach(I=>{const P=s.ExtensionIdentifier.toKey(I.identifier.id),M=K.get(P);(!M||q(M,I,!0))&&K.set(P,I),K.set(P,I)}),[...K.values()]}async F(B,j){this.s.trace("Started scanning system extensions");const A=await this.I(this.systemExtensionsLocation,!1,0,!0,j),$=await(B&&!A.devMode?this.i:this.k).scanExtensions(A);return this.s.trace("Scanned system extensions:",$.length),$}async G(B,j){const A=this.t.isBuilt?[]:this.u.builtInExtensions;if(!A?.length)return[];this.s.trace("Started scanning dev system extensions");const z=j?await this.H():{},$=[],q=l.URI.file(v.normalize(v.join(y.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const I of A){const P=z[I.name]||"marketplace";switch(P){case"disabled":break;case"marketplace":$.push((0,b.joinPath)(q,I.name));break;default:$.push(l.URI.file(P));break}}const K=await Promise.all($.map(async I=>this.k.scanExtension(await this.I(I,!1,0,!0,B))));return this.s.trace("Scanned dev system extensions:",K.length),(0,T.coalesce)(K)}async H(){try{const B=await this.r.readFile(this.l);return JSON.parse(B.value.toString())}catch{return{}}}async I(B,j,A,z,$,q=!0){const K=await this.f($??m.language),I=await this.J(B),P=j&&!this.v.extUri.isEqual(B,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,M=P?await this.J(P):void 0;return new re(B,I,P,M,j,A,z,q,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,$,K)}async J(B){try{const j=await this.r.stat(B);if(typeof j.mtime=="number")return j.mtime}catch{}}};ie=me([ee(4,R.IUserDataProfilesService),ee(5,h.IExtensionsProfileScannerService),ee(6,n.IFileService),ee(7,r.ILogService),ee(8,w.IEnvironmentService),ee(9,o.IProductService),ee(10,C.IUriIdentityService),ee(11,i.IInstantiationService)],ie),e.AbstractExtensionsScannerService=ie;class re{constructor(B,j,A,z,$,q,K,I,P,M,F,V,G,te){this.location=B,this.mtime=j,this.applicationExtensionslocation=A,this.applicationExtensionslocationMtime=z,this.profile=$,this.type=q,this.excludeObsolete=K,this.validate=I,this.productVersion=P,this.productDate=M,this.productCommit=F,this.devMode=V,this.language=G,this.translations=te}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,j){return(0,b.isEqual)(B.location,j.location)&&B.mtime===j.mtime&&(0,b.isEqual)(B.applicationExtensionslocation,j.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===j.applicationExtensionslocationMtime&&B.profile===j.profile&&B.type===j.type&&B.excludeObsolete===j.excludeObsolete&&B.validate===j.validate&&B.productVersion===j.productVersion&&B.productDate===j.productDate&&B.productCommit===j.productCommit&&B.devMode===j.devMode&&B.language===j.language&&X.equals(B.translations,j.translations)}}let _=class extends u.Disposable{constructor(B,j,A,z,$){super(),this.f=B,this.g=j,this.h=A,this.i=z,this.j=$}async scanExtensions(B){const j=B.profile?await this.l(B):await this.k(B);let A={};if(B.excludeObsolete&&B.type===1)try{const z=(await this.i.readFile(this.f)).value.toString();A=JSON.parse(z)}catch{}return(0,E.isEmptyObject)(A)?j:j.filter(z=>!A[f.ExtensionKey.create(z).toString()])}async k(B){const j=await this.i.resolve(B.location);if(!j.children?.length)return[];const A=await Promise.all(j.children.map(async z=>{if(!z.isDirectory||B.type===1&&(0,b.basename)(z.resource).indexOf(".")===0)return null;const $=new re(z.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension($)}));return(0,T.coalesce)(A).sort((z,$)=>z.location.path<$.location.path?-1:1)}async l(B){let j=await this.m(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.h.extUri.isEqual(B.location,B.applicationExtensionslocation)){j=j.filter(z=>!z.metadata?.isApplicationScoped);const A=await this.m(B.applicationExtensionslocation,z=>!!z.metadata?.isApplicationScoped,B);j.push(...A)}return j}async m(B,j,A){const z=await this.g.scanProfileExtensions(B);if(!z.length)return[];const $=await Promise.all(z.map(async q=>{if(j(q)){const K=new re(q.location,A.mtime,A.applicationExtensionslocation,A.applicationExtensionslocationMtime,A.profile,A.type,A.excludeObsolete,A.validate,A.productVersion,A.productDate,A.productCommit,A.devMode,A.language,A.translations);return this.scanExtension(K,q.metadata)}return null}));return(0,T.coalesce)($)}async scanOneOrMultipleExtensions(B){try{if(await this.i.exists((0,b.joinPath)(B.location,"package.json"))){const j=await this.scanExtension(B);return j?[j]:[]}else return await this.scanExtensions(B)}catch(j){return this.j.error(`Error scanning extensions at ${B.location.path}:`,(0,N.getErrorMessage)(j)),[]}}async scanExtension(B,j){try{let A=await this.scanExtensionManifest(B.location);if(A){A.publisher||(A.publisher=s.UNDEFINED_PUBLISHER),j=j??A.__metadata,delete A.__metadata;const z=(0,f.getGalleryExtensionId)(A.publisher,A.name),$=j?.id?{id:z,uuid:j.id}:{id:z},q=j?.isSystem?0:B.type,K=q===0||!!j?.isBuiltin;Y.ImplicitActivationEvents.updateManifest(A),A=await this.n(B.location,A,re.createNlsConfiguration(B));const I={type:q,identifier:$,manifest:A,location:B.location,isBuiltin:K,targetPlatform:j?.targetPlatform??"undefined",metadata:j,isValid:!0,validations:[]};return B.validate?this.validate(I,B):I}}catch(A){B.type!==0&&this.j.error(A)}return null}validate(B,j){let A=!0;const z=(0,t.validateExtensionManifest)(j.productVersion,j.productDate,j.location,B.manifest,B.isBuiltin);for(const[$,q]of z)$===O.default.Error&&(A=!1,this.j.error(this.t(j.location,q)));return B.isValid=A,B.validations=z,B}async scanExtensionManifest(B){const j=(0,b.joinPath)(B,"package.json");let A;try{A=(await this.i.readFile(j)).value.toString()}catch($){return(0,n.toFileOperationResult)($)!==1&&this.j.error(this.t(B,(0,d.localize)(0,null,j.path,$.message))),null}let z;try{z=JSON.parse(A)}catch{const q=[];(0,S.parse)(A,q);for(const K of q)this.j.error(this.t(B,(0,d.localize)(1,null,j.path,K.offset,K.length,(0,g.getParseErrorMessage)(K.error))));return null}return(0,S.getNodeType)(z)!=="object"?(this.j.error(this.t(B,(0,d.localize)(2,null,j.path))),null):z}async n(B,j,A){const z=await this.p(B,j,A);if(z)try{const $=[],q=await this.r(z.default,$);if($.length>0)return $.forEach(I=>{this.j.error(this.t(B,(0,d.localize)(3,null,z.default?.path,(0,g.getParseErrorMessage)(I.error))))}),j;if((0,S.getNodeType)(z)!=="object")return this.j.error(this.t(B,(0,d.localize)(4,null,z.default?.path))),j;const K=z.values||Object.create(null);return(0,x.localizeManifest)(j,K,q)}catch{}return j}async p(B,j,A){const z=(0,b.joinPath)(B,"package.nls.json"),$=(P,M)=>{M.forEach(F=>{this.j.error(this.t(B,(0,d.localize)(5,null,P?.path,(0,g.getParseErrorMessage)(F.error))))})},q=P=>{this.j.error(this.t(B,(0,d.localize)(6,null,P?.path)))},K=`${j.publisher}.${j.name}`,I=A.translations[K];if(I)try{const P=l.URI.file(I),M=(await this.i.readFile(P)).value.toString(),F=[],V=(0,S.parse)(M,F);return F.length>0?($(P,F),{values:void 0,default:z}):(0,S.getNodeType)(V)!=="object"?(q(P),{values:void 0,default:z}):{values:V.contents?V.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.i.exists(z))return;let M;try{M=await this.s(B,A)}catch{return}if(!M.localized)return{values:void 0,default:M.original};try{const F=(await this.i.readFile(M.localized)).value.toString(),V=[],G=(0,S.parse)(F,V);return V.length>0?($(M.localized,V),{values:void 0,default:M.original}):(0,S.getNodeType)(G)!=="object"?(q(M.localized),{values:void 0,default:M.original}):{values:G,default:M.original}}catch{return{values:void 0,default:M.original}}}}async r(B,j){if(B)try{const A=(await this.i.readFile(B)).value.toString();return(0,S.parse)(A,j)}catch{}}s(B,j){return new Promise((A,z)=>{const $=q=>{const K=(0,b.joinPath)(B,`package.nls.${q}.json`);this.i.exists(K).then(I=>{I&&A({localized:K,original:(0,b.joinPath)(B,"package.nls.json")});const P=q.lastIndexOf("-");P===-1?A({localized:(0,b.joinPath)(B,"package.nls.json"),original:null}):(q=q.substring(0,P),$(q))})};if(j.devMode||j.pseudo||!j.language)return A({localized:(0,b.joinPath)(B,"package.nls.json"),original:null});$(j.language)})}t(B,j){return`[${B.path}]: ${j}`}};_=me([ee(1,h.IExtensionsProfileScannerService),ee(2,C.IUriIdentityService),ee(3,n.IFileService),ee(4,r.ILogService)],_);let pe=class extends _{constructor(B,j,A,z,$,q){super(j,A,z,$,q),this.y=B,this.v=this.B(new D.ThrottledDelayer(3e3)),this.w=this.B(new c.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(B){const j=await this.z();if(this.u=B,j&&j.input&&re.equals(j.input,this.u))return this.v.trigger(()=>this.D()),j.result.map(z=>(z.location=l.URI.revive(z.location),z));const A=await super.scanExtensions(B);return await this.C({input:B,result:A}),A}async z(){try{const B=await this.i.readFile(this.y),j=JSON.parse(B.value.toString());return{result:j.result,input:(0,a.revive)(j.input)}}catch(B){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,N.getErrorMessage)(B))}return null}async C(B){try{await this.i.writeFile(this.y,L.VSBuffer.fromString(JSON.stringify(B)))}catch(j){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,N.getErrorMessage)(j))}}async D(){if(!this.u)return;const B=await this.z();if(!B)return;const j=B.result,A=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!k.equals(A,j))try{await this.i.del(this.y),this.w.fire()}catch(z){this.j.error(z)}}};pe=me([ee(2,h.IExtensionsProfileScannerService),ee(3,C.IUriIdentityService),ee(4,n.IFileService),ee(5,r.ILogService)],pe);function le(he,B){const j=(0,f.getExtensionId)(he.manifest.publisher,he.manifest.name);return{id:j,identifier:new s.ExtensionIdentifier(j),isBuiltin:he.type===0,isUserBuiltin:he.type===1&&he.isBuiltin,isUnderDevelopment:B,extensionLocation:he.location,uuid:he.identifier.uuid,targetPlatform:he.targetPlatform,...he.manifest}}e.toExtensionDescription=le;class ae extends ie{constructor(B,j,A,z,$,q,K,I,P,M,F,V){super(B,j,(0,b.joinPath)(A,".vscode-oss-dev","extensions","control.json"),(0,b.joinPath)(z,s.MANIFEST_CACHE_FOLDER),$,q,K,I,P,M,F,V),this.L=(async()=>{if(m.translationsConfigFile)try{const G=await this.r.readFile(l.URI.file(m.translationsConfigFile));return JSON.parse(G.value.toString())}catch{}return Object.create(null)})()}f(B){return this.L}}e.NativeExtensionsScannerService=ae}),define(Z[145],Q([0,1,57,3,34,4,2,16,14,20,9,25]),function(W,e,T,D,k,L,N,S,g,u,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends N.Disposable{constructor(p,O){super(),this.b=p,this.f=O,this.a=new D.Limiter(5)}async postUninstall(p){const O=this.g(p,"uninstall");return O&&(this.f.info(p.identifier.id,p.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(O.script,"uninstall",O.args,!0,p).then(()=>this.f.info(p.identifier.id,p.manifest.version,"Finished running post uninstall script"),E=>this.f.error(p.identifier.id,p.manifest.version,`Failed to run post uninstall script: ${E}`)))),u.Promises.rm(this.j(p)).then(void 0,E=>this.f.error("Error while removing extension storage path",E))}g(p,O){const E=`vscode:${O}`;if(p.location.scheme===S.Schemas.file&&p.manifest&&p.manifest.scripts&&typeof p.manifest.scripts[E]=="string"){const l=p.manifest.scripts[E].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(p.identifier.id,p.manifest.version,`${E} should be a node script`),null):{script:(0,g.join)(p.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(p,O,E,l,d){return new Promise((w,f)=>{const s=this.i(p,O,E,d);let t;const n=i=>{t&&(clearTimeout(t),t=null),i?f(i):w(void 0)};s.on("error",i=>{n((0,k.toErrorMessage)(i)||"Unknown")}),s.on("exit",(i,r)=>{n(i?`post-${O} process exited with code ${i}`:void 0)}),l&&(t=setTimeout(()=>{t=null,s.kill(),f("timed out")},5e3))})}i(p,O,E,l){const d={silent:!0,execArgv:void 0},w=(0,T.fork)(p,[`--type=extension-post-${O}`,...E],d);w.stdout.setEncoding("utf8"),w.stderr.setEncoding("utf8");const f=L.Event.fromNodeEventEmitter(w.stdout,"data"),s=L.Event.fromNodeEventEmitter(w.stderr,"data");f(i=>this.f.info(l.identifier.id,l.manifest.version,`post-${O}`,i)),s(i=>this.f.error(l.identifier.id,l.manifest.version,`post-${O}`,i));const t=L.Event.any(L.Event.map(f,i=>({data:`%c${i}`,format:[""]})),L.Event.map(s,i=>({data:`%c${i}`,format:["color: red"]})));return L.Event.debounce(t,(i,r)=>i?{data:i.data+r.data,format:[...i.format,...r.format]}:{data:r.data,format:r.format},100)(i=>{console.group(l.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),w}j(p){return(0,g.join)(this.b.defaultProfile.globalStorageHome.fsPath,p.identifier.id.toLowerCase())}};m=me([ee(0,v.IUserDataProfilesService),ee(1,y.ILogService)],m),e.ExtensionsLifecycle=m}),define(Z[146],Q([0,1,11,18,42,48,13,8,9,26,28,25]),function(W,e,T,D,k,L,N,S,g,u,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let m=class extends L.NativeExtensionsScannerService{constructor(p,O,E,l,d,w,f,s){super(T.URI.file(d.builtinExtensionsPath),T.URI.file(d.extensionsPath),d.userHome,T.URI.file(d.userDataPath),p,O,E,l,d,w,f,s)}};m=me([ee(0,v.IUserDataProfilesService),ee(1,k.IExtensionsProfileScannerService),ee(2,N.IFileService),ee(3,g.ILogService),ee(4,D.INativeEnvironmentService),ee(5,u.IProductService),ee(6,y.IUriIdentityService),ee(7,S.IInstantiationService)],m),e.ExtensionsScannerService=m}),define(Z[147],Q([0,1,3,4,2,117,5,83,8,25]),function(W,e,T,D,k,L,N,S,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,g.createDecorator)("storageService");var y;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(y=e.WillSaveStateReason||(e.WillSaveStateReason={}));var v;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(v=e.StorageScope||(e.StorageScope={}));var m;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));function b(d){const w=d.get(e.TARGET_KEY);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}e.loadKeyTargets=b;class p extends k.Disposable{constructor(w={flushInterval:p.a}){super(),this.j=w,this.b=this.B(new D.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new D.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new T.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new k.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,T.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,k.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.J()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(w,f){if(f===e.TARGET_KEY){switch(w){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:w})}else this.b.fire({scope:w,key:f,target:this.F(w)[f]})}r(w){this.f.fire({reason:w})}get(w,f,s){return this.L(f)?.get(w,s)}getBoolean(w,f,s){return this.L(f)?.getBoolean(w,s)}getNumber(w,f,s){return this.L(f)?.getNumber(w,s)}store(w,f,s,t){if((0,N.isUndefinedOrNull)(f)){this.remove(w,s);return}this.t(()=>{this.u(w,s,t),this.L(s)?.set(w,f)})}remove(w,f){this.t(()=>{this.u(w,f,void 0),this.L(f)?.delete(w)})}t(w){this.b.pause(),this.c.pause();try{w()}finally{this.b.resume(),this.c.resume()}}keys(w,f){const s=[],t=this.F(w);for(const n of Object.keys(t))t[n]===f&&s.push(n);return s}u(w,f,s){const t=this.F(f);typeof s=="number"?t[w]!==s&&(t[w]=s,this.L(f)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[w]=="number"&&(delete t[w],this.L(f)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(w){switch(w){case-1:return this.D;case 0:return this.z;default:return this.w}}G(w){const f=this.L(w);return f?b(f):Object.create(null)}isNew(w){return this.getBoolean(e.IS_NEW_KEY,w)===!0}async flush(w=y.NONE){this.f.fire({reason:w});const f=this.L(-1),s=this.L(0),t=this.L(1);switch(w){case y.NONE:await T.Promises.settled([f?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await T.Promises.settled([f?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const w=this.L(-1)?.items??new Map,f=this.L(0)?.items??new Map,s=this.L(1)?.items??new Map;return l(w,f,s,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(w,f){return this.r(y.NONE),(0,u.isUserDataProfile)(w)?this.N(w,f):this.O(w,f)}H(w,f){return!(w.id===f.id||O(f)&&O(w))}I(w,f,s,t){this.t(()=>{if(t)for(const[n,i]of w)f.set(n,i);else{const n=new Set;for(const[i,r]of w)n.add(i),f.get(i)!==r&&this.n(s,i);for(const[i]of f.items)n.has(i)||this.n(s,i)}})}}e.AbstractStorageService=p,p.a=60*1e3;function O(d){return d.isDefault||!!d.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=O;class E extends p{constructor(){super(),this.p=this.B(new S.Storage(new S.InMemoryStorageDatabase,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new S.Storage(new S.InMemoryStorageDatabase,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new S.Storage(new S.InMemoryStorageDatabase,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(w=>this.n(1,w))),this.B(this.P.onDidChangeStorage(w=>this.n(0,w))),this.B(this.p.onDidChangeStorage(w=>this.n(-1,w)))}L(w){switch(w){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(w){switch(w){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(w){return!1}}e.InMemoryStorageService=E;async function l(d,w,f,s,t,n){const i=Y=>{try{return JSON.parse(Y)}catch{return Y}},r=new Map,o=new Map;d.forEach((Y,X)=>{r.set(X,Y),o.set(X,i(Y))});const c=new Map,a=new Map;w.forEach((Y,X)=>{c.set(X,Y),a.set(X,i(Y))});const h=new Map,R=new Map;f.forEach((Y,X)=>{h.set(X,Y),R.set(X,i(Y))}),console.group(s!==t?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const C=[];if(r.forEach((Y,X)=>{C.push({key:X,value:Y})}),console.table(C),console.groupEnd(),console.log(o),s!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const Y=[];c.forEach((X,ie)=>{Y.push({key:ie,value:X})}),console.table(Y),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${n})`);const x=[];h.forEach((Y,X)=>{x.push({key:X,value:Y})}),console.table(x),console.groupEnd(),console.log(R)}e.logStorage=l}),define(Z[148],Q([0,1,19,22,10,12,35,5,11,21,18,23,24,45,13,9,26,47,135,147,32]),function(W,e,T,D,k,L,N,S,g,u,y,v,m,b,p,O,E,l,d,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const s=L.isWeb?"web":(0,v.getTargetPlatform)(L.platform,N.arch);var t;(function(I){I[I.None=0]="None",I[I.IncludeVersions=1]="IncludeVersions",I[I.IncludeFiles=2]="IncludeFiles",I[I.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",I[I.IncludeSharedAccounts=8]="IncludeSharedAccounts",I[I.IncludeVersionProperties=16]="IncludeVersionProperties",I[I.ExcludeNonValidated=32]="ExcludeNonValidated",I[I.IncludeInstallationTargets=64]="IncludeInstallationTargets",I[I.IncludeAssetUri=128]="IncludeAssetUri",I[I.IncludeStatistics=256]="IncludeStatistics",I[I.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",I[I.Unpublished=4096]="Unpublished",I[I.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...I){return String(I.reduce((P,M)=>P|M,0))}var i;(function(I){I[I.Tag=1]="Tag",I[I.ExtensionId=4]="ExtensionId",I[I.Category=5]="Category",I[I.ExtensionName=7]="ExtensionName",I[I.Target=8]="Target",I[I.Featured=9]="Featured",I[I.SearchText=10]="SearchText",I[I.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class h{constructor(P=a){this.d=P}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(P,M=this.d.pageSize){return new h({...this.d,pageNumber:P,pageSize:M})}withFilter(P,...M){const F=[...this.d.criteria,...M.length?M.map(V=>({filterType:P,value:V})):[{filterType:P}]];return new h({...this.d,criteria:F})}withSortBy(P){return new h({...this.d,sortBy:P})}withSortOrder(P){return new h({...this.d,sortOrder:P})}withFlags(...P){return new h({...this.d,flags:P.reduce((M,F)=>M|F,0)})}withAssetTypes(...P){return new h({...this.d,assetTypes:P})}withSource(P){return new h({...this.d,source:P})}get raw(){const{criteria:P,pageNumber:M,pageSize:F,sortBy:V,sortOrder:G,flags:te,assetTypes:ne}=this.d;return{filters:[{criteria:P,pageNumber:M,pageSize:F,sortBy:V,sortOrder:G}],assetTypes:ne,flags:te}}get searchText(){const P=this.d.criteria.filter(M=>M.filterType===i.SearchText)[0];return P&&P.value?P.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(P=>String(P.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function R(I,P){const M=(I||[]).filter(F=>F.statisticName===P)[0];return M?M.value:0}function C(I){const P="Microsoft.VisualStudio.Code.Translation.";return I.files.filter(F=>F.assetType.indexOf(P)===0).reduce((F,V)=>{const G=X(I,V.assetType);return G&&F.push([V.assetType.substring(P.length),G]),F},[])}function x(I){if(I.properties){const P=I.properties.filter(V=>V.key===r.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=P.filter(V=>M.test(V.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return X(I,r.Repository)}function Y(I){return{uri:`${I.fallbackAssetUri}/${r.VSIX}?redirect=true${I.targetPlatform?`&targetPlatform=${I.targetPlatform}`:""}`,fallbackUri:`${I.fallbackAssetUri}/${r.VSIX}${I.targetPlatform?`?targetPlatform=${I.targetPlatform}`:""}`}}function X(I,P){return I.files.filter(F=>F.assetType===P)[0]?{uri:`${I.assetUri}/${P}${I.targetPlatform?`?targetPlatform=${I.targetPlatform}`:""}`,fallbackUri:`${I.fallbackAssetUri}/${P}${I.targetPlatform?`?targetPlatform=${I.targetPlatform}`:""}`}:null}function ie(I,P){const M=I.properties?I.properties.filter(V=>V.key===P):[],F=M.length>0&&M[0].value;return F?F.split(",").map(V=>(0,m.adoptToGalleryExtensionId)(V)):[]}function re(I){const P=I.properties?I.properties.filter(M=>M.key===o.Engine):[];return P.length>0&&P[0].value||""}function _(I){const P=I.properties?I.properties.filter(M=>M.key===o.PreRelease):[];return P.length>0&&P[0].value==="true"}function pe(I){const P=I.properties?I.properties.filter(F=>F.key===o.LocalizedLanguages):[],M=P.length>0&&P[0].value||"";return M?M.split(","):[]}function le(I){return I.properties?.find(P=>P.key===o.SponsorLink)?.value}function ae(I){return I.indexOf("preview")!==-1}function he(I){return I.targetPlatform?(0,v.toTargetPlatform)(I.targetPlatform):"undefined"}function B(I){const P=(0,T.distinct)(I.versions.map(he)),M=!!I.tags?.includes(v.WEB_EXTENSION_TAG),F=P.indexOf("web");return M?F===-1&&P.push("web"):F!==-1&&P.splice(F,1),P}function j(I,P){const M=(0,v.getFallbackTargetPlarforms)(P);for(let F=0;F<I.length;F++){const V=I[F];if(V.version===I[F-1]?.version){let G=F;const te=he(V);if(te===P)for(;G>0&&I[G-1].version===V.version;)G--;else if(M.includes(te))for(;G>0&&I[G-1].version===V.version&&he(I[G-1])!==P;)G--;G!==F&&(I.splice(F,1),I.splice(G,0,V))}}return I}e.sortExtensionVersions=j;function A(I,P,M){I.telemetryData={index:P,querySource:M}}function z(I,P,M){const F=I.versions[0],V={manifest:X(P,r.Manifest),readme:X(P,r.Details),changelog:X(P,r.Changelog),license:X(P,r.License),repository:x(P),download:Y(P),icon:X(P,r.Icon),signature:X(P,r.Signature),coreTranslations:C(P)};return{identifier:{id:(0,m.getGalleryExtensionId)(I.publisher.publisherName,I.extensionName),uuid:I.extensionId},name:I.extensionName,version:P.version,displayName:I.displayName,publisherId:I.publisher.publisherId,publisher:I.publisher.publisherName,publisherDisplayName:I.publisher.displayName,publisherDomain:I.publisher.domain?{link:I.publisher.domain,verified:!!I.publisher.isDomainVerified}:void 0,publisherSponsorLink:le(F),description:I.shortDescription||"",installCount:R(I.statistics,"install"),rating:R(I.statistics,"averagerating"),ratingCount:R(I.statistics,"ratingcount"),categories:I.categories||[],tags:I.tags||[],releaseDate:Date.parse(I.releaseDate),lastUpdated:Date.parse(I.lastUpdated),allTargetPlatforms:M,assets:V,properties:{dependencies:ie(P,o.Dependency),extensionPack:ie(P,o.ExtensionPack),engine:re(P),localizedLanguages:pe(P),targetPlatform:he(P),isPreReleaseVersion:_(P)},hasPreReleaseVersion:_(F),hasReleaseVersion:!0,preview:ae(I.flags),isSigned:!!V.signature}}let $=class{constructor(P,M,F,V,G,te,ne,ge){this.k=M,this.l=F,this.n=V,this.o=G,this.q=te,this.u=ne,this.w=ge;const ye=ne.extensionsGallery,ue=ye?.servicePPEUrl&&ge.getValue("_extensionsGallery.enablePPE");this.d=ue?ye.servicePPEUrl:ye?.serviceUrl,this.g=ue?void 0:ye?.searchUrl,this.h=ye?.controlUrl,this.j=(0,d.resolveMarketplaceHeaders)(ne.version,ne,this.n,this.w,this.q,P,this.o)}x(P=""){return`${this.d}${P}`}isEnabled(){return!!this.d}async getExtensions(P,M,F){const V=D.CancellationToken.isCancellationToken(M)?{}:M,G=D.CancellationToken.isCancellationToken(M)?M:F,te=[],ne=[],ge=[],ye=[];let ue=!0;for(const se of P){se.uuid?ne.push(se.uuid):te.push(se.id);const fe=!!(se.version||se.preRelease);ge.push({id:se.id,uuid:se.uuid,includePreRelease:fe}),se.version&&ye.push({id:se.id,uuid:se.uuid,version:se.version}),ue=ue&&!!se.hasPreRelease&&!fe}if(!ne.length&&!te.length)return[];let ce=new h().withPage(1,P.length);ne.length&&(ce=ce.withFilter(i.ExtensionId,...ne)),te.length&&(ce=ce.withFilter(i.ExtensionName,...te)),(V.queryAllVersions||ue)&&(ce=ce.withFlags(ce.flags,t.IncludeVersions)),V.source&&(ce=ce.withSource(V.source));const{extensions:oe}=await this.z(ce,{targetPlatform:V.targetPlatform??s,includePreRelease:ge,versions:ye,compatible:!!V.compatible},G);return V.source&&oe.forEach((se,fe)=>A(se,fe,V.source)),oe}async getCompatibleExtension(P,M,F){if((0,v.isNotWebExtensionInWebTargetPlatform)(P.allTargetPlatforms,F))return null;if(await this.isExtensionCompatible(P,M,F))return P;const V=new h().withFlags(t.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,P.identifier.uuid),{extensions:G}=await this.z(V,{targetPlatform:F,compatible:!0,includePreRelease:M},D.CancellationToken.None);return G[0]||null}async isExtensionCompatible(P,M,F){if(!(0,v.isTargetPlatformCompatible)(P.properties.targetPlatform,P.allTargetPlatforms,F)||!M&&P.properties.isPreReleaseVersion)return!1;let V=P.properties.engine;if(!V){const G=await this.getManifest(P,D.CancellationToken.None);if(!G)throw new Error("Manifest was not found");V=G.engines.vscode}return(0,b.isEngineValid)(V,this.u.version,this.u.date)}async y(P,M,F,V,G){if(!(0,v.isTargetPlatformCompatible)(he(P),V,G)||M!=="any"&&_(P)!==(M==="prerelease"))return!1;if(F)try{const te=await this.E(P);if(!(0,b.isEngineValid)(te,this.u.version,this.u.date))return!1}catch(te){return this.l.error(`Error while getting the engine for the version ${P.version}.`,(0,k.getErrorMessage)(te)),!1}return!0}async query(P,M){let F=P.text||"";const V=P.pageSize??50;let G=new h().withPage(1,V);F?(F=F.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ce,oe)=>(G=G.withFilter(i.Category,oe||ce),"")),F=F.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,ce,oe)=>(G=G.withFilter(i.Tag,oe||ce),"")),F=F.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(i.Featured),"")),F=F.trim(),F&&(F=F.length<200?F:F.substring(0,200),G=G.withFilter(i.SearchText,F)),G=G.withSortBy(0)):P.ids?G=G.withFilter(i.ExtensionId,...P.ids):P.names?G=G.withFilter(i.ExtensionName,...P.names):G=G.withSortBy(4),typeof P.sortBy=="number"&&(G=G.withSortBy(P.sortBy)),typeof P.sortOrder=="number"&&(G=G.withSortOrder(P.sortOrder)),P.source&&(G=G.withSource(P.source));const te=async(ue,ce)=>{const{extensions:oe,total:se}=await this.z(ue,{targetPlatform:s,compatible:!1,includePreRelease:!!P.includePreRelease},ce);return oe.forEach((fe,Te)=>A(fe,(ue.pageNumber-1)*ue.pageSize+Te,P.source)),{extensions:oe,total:se}},{extensions:ne,total:ge}=await te(G,M),ye=async(ue,ce)=>{if(ce.isCancellationRequested)throw new k.CancellationError;const{extensions:oe}=await te(G.withPage(ue+1),ce);return oe};return{firstPage:ne,total:ge,pageSize:G.pageSize,getPage:ye}}async z(P,M,F){const V=P.flags;!!(P.flags&t.IncludeLatestVersionOnly)&&!!(P.flags&t.IncludeVersions)&&(P=P.withFlags(P.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(P.flags&t.IncludeLatestVersionOnly)&&!(P.flags&t.IncludeVersions)&&(P=P.withFlags(P.flags,t.IncludeLatestVersionOnly)),M.versions?.length&&(P=P.withFlags(P.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),P=P.withFlags(P.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:G,total:te}=await this.B(P,F);if(!(P.flags&t.IncludeLatestVersionOnly)){const ue=[];for(const ce of G){const oe=await this.A(ce,M);oe&&ue.push(oe)}return{extensions:ue,total:te}}const ge=[],ye=new Map;for(let ue=0;ue<G.length;ue++){const ce=G[ue],oe={id:(0,m.getGalleryExtensionId)(ce.publisher.publisherName,ce.extensionName),uuid:ce.extensionId},se=(0,S.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(Te=>(0,m.areSameExtensions)(Te,oe))?.includePreRelease;if(M.compatible&&(0,v.isNotWebExtensionInWebTargetPlatform)(B(ce),M.targetPlatform))continue;const fe=await this.A(ce,M);!fe||fe.properties.isPreReleaseVersion&&(!se||!fe.hasReleaseVersion)||!fe.properties.isPreReleaseVersion&&fe.properties.targetPlatform!==M.targetPlatform&&fe.hasPreReleaseVersion?ye.set(ce.extensionId,ue):ge.push([ue,fe])}if(ye.size){const ue=new Date().getTime(),ce=new h().withFlags(V&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ye.size).withFilter(i.ExtensionId,...ye.keys()),{extensions:oe}=await this.z(ce,M,F);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ue,count:ye.size});for(const se of oe){const fe=ye.get(se.identifier.uuid);ge.push([fe,se])}}return{extensions:ge.sort((ue,ce)=>ue[0]-ce[0]).map(([,ue])=>ue),total:te}}async A(P,M){const F={id:(0,m.getGalleryExtensionId)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},V=M.versions?.find(ge=>(0,m.areSameExtensions)(ge,F))?.version,G=(0,S.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(ge=>(0,m.areSameExtensions)(ge,F))?.includePreRelease,te=B(P),ne=j(P.versions,M.targetPlatform);if(M.compatible&&(0,v.isNotWebExtensionInWebTargetPlatform)(te,M.targetPlatform))return null;for(let ge=0;ge<ne.length;ge++){const ye=ne[ge];if(!(V&&ye.version!==V)){if(await this.y(ye,G?"any":"release",M.compatible,te,M.targetPlatform))return z(P,ye,te);if(V&&ye.version===V)return null}}return V||M.compatible?null:z(P,P.versions[0],te)}async B(P,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");P=P.withFlags(P.flags,t.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,n(t.Unpublished));const F=await this.j,V=JSON.stringify(P.raw),G={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(V.length)},te=new Date().getTime();let ne,ge,ye=0;try{if(ne=await this.k.request({type:"POST",url:this.g&&P.criteria.some(ce=>ce.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:V,headers:G},M),ne.res.statusCode&&ne.res.statusCode>=400&&ne.res.statusCode<500)return{galleryExtensions:[],total:ye};const ue=await(0,l.asJson)(ne);if(ue){const ce=ue.results[0],oe=ce.extensions,se=ce.resultMetadata&&ce.resultMetadata.filter(fe=>fe.metadataType==="ResultCount")[0];return ye=se&&se.metadataItems.filter(fe=>fe.name==="TotalCount")[0].count||0,{galleryExtensions:oe,total:ye}}return{galleryExtensions:[],total:ye}}catch(ue){throw ge=ue,ue}finally{this.o.publicLog2("galleryService:query",{...P.telemetryData,requestBodySize:String(V.length),duration:new Date().getTime()-te,success:!!ne&&(0,l.isSuccess)(ne),responseBodySize:ne?.res.headers["Content-Length"],statusCode:ne?String(ne.res.statusCode):void 0,errorCode:ge?(0,k.isCancellationError)(ge)?"canceled":(0,k.getErrorMessage)(ge).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ye)})}}async reportStatistic(P,M,F,V){if(!this.isEnabled())return;const G=L.isWeb?this.x(`/itemName/${P}.${M}/version/${F}/statType/${V==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${P}/extensions/${M}/${F}/stats?statType=${V}`),te=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.j,Accept:te};try{await this.k.request({type:"POST",url:G,headers:ge},D.CancellationToken.None)}catch{}}async download(P,M,F){this.l.trace("ExtensionGalleryService#download",P.identifier.id);const V=(0,m.getGalleryExtensionTelemetryData)(P),G=new Date().getTime(),te=ue=>this.o.publicLog("galleryService:downloadVSIX",{...V,duration:ue}),ne=F===2?"install":F===3?"update":"",ge=ne?{uri:`${P.assets.download.uri}${g.URI.parse(P.assets.download.uri).query?"&":"?"}${ne}=true`,fallbackUri:`${P.assets.download.fallbackUri}${g.URI.parse(P.assets.download.fallbackUri).query?"&":"?"}${ne}=true`}:P.assets.download,ye=await this.D(ge);await this.q.writeFile(M,ye.stream),te(new Date().getTime()-G)}async downloadSignatureArchive(P,M){if(!P.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",P.identifier.id);const F=await this.D(P.assets.signature);await this.q.writeFile(M,F.stream)}async getReadme(P,M){if(P.assets.readme){const F=await this.D(P.assets.readme,{},M);return await(0,l.asTextOrError)(F)||""}return""}async getManifest(P,M){if(P.assets.manifest){const F=await this.D(P.assets.manifest,{},M),V=await(0,l.asTextOrError)(F);return V?JSON.parse(V):null}return null}async C(P,M){const F=X(P,r.Manifest);if(!F)throw new Error("Manifest was not found");const V={"Accept-Encoding":"gzip"},G=await this.D(F,{headers:V});return await(0,l.asJson)(G)}async getCoreTranslation(P,M){const F=P.assets.coreTranslations.filter(V=>V[0]===M.toUpperCase())[0];if(F){const V=await this.D(F[1]),G=await(0,l.asTextOrError)(V);return G?JSON.parse(G):null}return null}async getChangelog(P,M){if(P.assets.changelog){const F=await this.D(P.assets.changelog,{},M);return await(0,l.asTextOrError)(F)||""}return""}async getAllCompatibleVersions(P,M,F){let V=new h().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);P.identifier.uuid?V=V.withFilter(i.ExtensionId,P.identifier.uuid):V=V.withFilter(i.ExtensionName,P.identifier.id);const{galleryExtensions:G}=await this.B(V,D.CancellationToken.None);if(!G.length)return[];const te=B(G[0]);if((0,v.isNotWebExtensionInWebTargetPlatform)(te,F))return[];const ne=[];await Promise.all(G[0].versions.map(async ue=>{try{await this.y(ue,M?"any":"release",!0,te,F)&&ne.push(ue)}catch{}}));const ge=[],ye=new Set;for(const ue of j(ne,F))ye.has(ue.version)||(ye.add(ue.version),ge.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:_(ue)}));return ge}async D(P,M={},F=D.CancellationToken.None){const V=await this.j,G={type:"GET"},te={...V,...M.headers||{}};M={...M,...G,headers:te};const ne=P.uri,ge=P.fallbackUri,ye={...M,url:ne};try{const ue=await this.k.request(ye,F);if(ue.res.statusCode===200)return ue;const ce=await(0,l.asTextOrError)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${ce}`)}catch(ue){if((0,k.isCancellationError)(ue))throw ue;const ce=(0,k.getErrorMessage)(ue);this.o.publicLog2("galleryService:cdnFallback",{url:ne,message:ce});const oe={...M,url:ge};return this.k.request(oe,F)}}async E(P){let M=re(P);if(!M){const F=await this.C(P,D.CancellationToken.None);if(!F)throw new Error("Manifest was not found");M=F.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const P=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if(P.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,l.asJson)(P),F=[],V={};if(M){for(const G of M.malicious)F.push({id:G});if(M.migrateToPreRelease)for(const[G,te]of Object.entries(M.migrateToPreRelease))(!te.engine||(0,b.isEngineValid)(te.engine,this.u.version,this.u.date))&&(V[G.toLowerCase()]={disallowInstall:!0,extension:{id:te.id,displayName:te.displayName,autoMigrate:{storage:!!te.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[G,te]of Object.entries(M.deprecated))te&&(V[G.toLowerCase()]=(0,S.isBoolean)(te)?{}:te)}return{malicious:F,deprecated:V}}};$=me([ee(1,l.IRequestService),ee(2,O.ILogService),ee(3,y.IEnvironmentService),ee(4,f.ITelemetryService),ee(5,p.IFileService),ee(6,E.IProductService),ee(7,u.IConfigurationService)],$);let q=class extends ${constructor(P,M,F,V,G,te,ne,ge){super(P,M,F,V,G,te,ne,ge)}};q=me([ee(0,w.IStorageService),ee(1,l.IRequestService),ee(2,O.ILogService),ee(3,y.IEnvironmentService),ee(4,f.ITelemetryService),ee(5,p.IFileService),ee(6,E.IProductService),ee(7,u.IConfigurationService)],q),e.ExtensionGalleryService=q;let K=class extends ${constructor(P,M,F,V,G,te,ne){super(void 0,P,M,F,V,G,te,ne)}};K=me([ee(0,l.IRequestService),ee(1,O.ILogService),ee(2,y.IEnvironmentService),ee(3,f.ITelemetryService),ee(4,p.IFileService),ee(5,E.IProductService),ee(6,u.IConfigurationService)],K),e.ExtensionGalleryServiceWithNoStorageService=K}),define(Z[149],Q([0,1,44,11,18,13,9,67,28,25]),function(W,e,T,D,k,L,N,S,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let y=class $e extends u.UserDataProfilesService{constructor(m,b,p,O,E){super(p,O,b,E),this.a=m,this.N=p}H(){return(0,T.revive)(this.a.getItem($e.b,[]))}J(){return(0,T.revive)(this.a.getItem($e.c,{}))}M(){return this.r.extUri.joinPath(D.URI.file(this.N.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};y=me([ee(0,S.IStateService),ee(1,g.IUriIdentityService),ee(2,k.INativeEnvironmentService),ee(3,L.IFileService),ee(4,N.ILogService)],y),e.UserDataProfilesService=y}),define(Z[150],Q([0,1,38,3,163,2,9]),function(W,e,T,D,k,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let S=class extends T.AbstractPolicyService{constructor(u,y){super(),this.j=u,this.k=y,this.a=new D.Throttler,this.b=this.B(new L.MutableDisposable)}async i(u){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`),await this.a.queue(()=>new Promise((y,v)=>{try{this.b.value=(0,k.createWatcher)(this.k,u,m=>{this.m(m),y()})}catch(m){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",m),v(m)}}))}m(u){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const y in u){const v=u[y];v===void 0?this.g.delete(y):this.g.set(y,v)}this.h.fire(Object.keys(u))}};S=me([ee(0,N.ILogService)],S),e.NativePolicyService=S}),define(Z[69],Q([0,1,119,3,14,5,20,84,164,165]),function(W,e,T,D,k,L,N,S,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class y extends Error{constructor(t,n){let i=n.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=t,this.cause=n}}e.ExtractError=y;function v(s){const t=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>t&n).reduce((n,i)=>n+i,t&61440)}function m(s){if(s instanceof y)return s;let t;return/end of central directory record signature not found/.test(s.message)&&(t="CorruptZip"),new y(t,s)}function b(s,t,n,i,r,o){const c=k.dirname(t),a=k.join(i,c);if(!a.startsWith(i))return Promise.reject(new Error(S.localize(0,null,t)));const h=k.join(i,t);let R;return o.onCancellationRequested(()=>{R?.destroy()}),Promise.resolve(N.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((C,x)=>{if(!o.isCancellationRequested)try{R=(0,T.createWriteStream)(h,{mode:n}),R.once("close",()=>C()),R.once("error",x),s.once("error",x),s.pipe(R)}catch(Y){x(Y)}}))}function p(s,t,n,i){let r=(0,D.createCancelablePromise)(()=>Promise.resolve()),o=0;return i.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((c,a)=>{const h=new D.Sequencer,R=C=>{C.isCancellationRequested||(o++,s.readEntry())};s.once("error",a),s.once("close",()=>r.then(()=>{i.isCancellationRequested||s.entryCount===o?c():a(new y("Incomplete",new Error(S.localize(1,null,o,s.entryCount))))},a)),s.readEntry(),s.on("entry",C=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(C.fileName)){R(i);return}const x=C.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(x)){const ie=k.join(t,x);r=(0,D.createCancelablePromise)(re=>N.Promises.mkdir(ie,{recursive:!0}).then(()=>R(re)).then(void 0,a));return}const Y=E(s,C),X=v(C);r=(0,D.createCancelablePromise)(ie=>h.queue(()=>Y.then(re=>b(re,x,X,t,n,ie).then(()=>R(ie)))).then(null,a))})})}function O(s,t=!1){return new Promise((n,i)=>{(0,g.open)(s,t?{lazyEntries:!0}:void 0,(r,o)=>{r?i(m(r)):n((0,L.assertIsDefined)(o))})})}function E(s,t){return new Promise((n,i)=>{s.openReadStream(t,(r,o)=>{r?i(m(r)):n((0,L.assertIsDefined)(o))})})}function l(s,t){return new Promise((n,i)=>{const r=new u.ZipFile;t.forEach(c=>{c.contents?r.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&r.addFile(c.localPath,c.path)}),r.end();const o=(0,T.createWriteStream)(s);r.outputStream.pipe(o),r.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>n(s))})}e.zip=l;function d(s,t,n={},i){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let o=O(s,!0);return n.overwrite&&(o=o.then(c=>N.Promises.rm(t).then(()=>c))),o.then(c=>p(c,t,{sourcePathRegex:r},i))}e.extract=d;function w(s,t){return O(s).then(n=>new Promise((i,r)=>{n.on("entry",o=>{o.fileName===t&&E(n,o).then(c=>i(c),c=>r(c))}),n.once("close",()=>r(new Error(S.localize(2,null,t))))}))}function f(s,t){return w(s,t).then(n=>new Promise((i,r)=>{const o=[];n.once("error",r),n.on("data",c=>o.push(c)),n.on("end",()=>i(Buffer.concat(o)))}))}e.buffer=f}),define(Z[151],Q([0,1,69,92]),function(W,e,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(L){return(0,T.buffer)(L,"extension/package.json").then(N=>{try{return JSON.parse(N.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.getManifest=k}),define(Z[152],Q([0,1,3,22,34,10,4,2,36,16,14,12,17,39,5,11,30,20,69,91,58,18,144,23,24,42,48,126,145,151,127,128,27,45,13,8,9,26,32,28,25]),function(W,e,T,D,k,L,N,S,g,u,y,v,m,b,p,O,E,l,d,w,f,s,t,n,i,r,o,c,a,h,R,C,x,Y,X,ie,re,_,pe,le,ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ie.refineServiceDecorator)(n.IExtensionManagementService);let he=class extends t.AbstractExtensionManagementService{constructor(I,P,M,F,V,G,te,ne,ge,ye,ue,ce){super(I,P,M,ye,ce),this.Y=V,this.Z=G,this.ab=te,this.bb=ge,this.cb=ue,this.X=new Map,this.kb=new g.ResourceSet;const oe=this.B(ne.createInstance(a.ExtensionsLifecycle));this.S=this.B(ne.createInstance(B,fe=>oe.postUninstall(fe))),this.U=this.B(new R.ExtensionsManifestCache(F,this)),this.W=this.B(ne.createInstance(c.ExtensionsDownloader,this.getTargetPlatform()));const se=this.B(new C.ExtensionsWatcher(this,this.Y,ce,G,ue,ge,M));this.B(se.onDidChangeExtensionsByAnotherSource(fe=>this.jb(fe))),this.lb()}getTargetPlatform(){return this.db||(this.db=(0,i.computeTargetPlatform)(this.bb,this.v)),this.db}async zip(I){this.v.trace("ExtensionManagementService#zip",I.identifier.id);const P=await this.ib(I),M=await(0,d.zip)((0,m.joinPath)(this.W.extensionsDownloadDir,(0,E.generateUuid)()).fsPath,P);return O.URI.file(M)}async unzip(I){return this.v.trace("ExtensionManagementService#unzip",I.toString()),(await this.install(I)).identifier}async getManifest(I){const{location:P,cleanup:M}=await this.eb(I),F=y.resolve(P.fsPath);try{return await(0,h.getManifest)(F)}finally{await M()}}getInstalled(I,P){return this.S.scanExtensions(I??null,P)}getAllUserInstalled(){return this.S.scanAllUserExtensions(!1)}async install(I,P={}){this.v.trace("ExtensionManagementService#install",I.toString());const{location:M,cleanup:F}=await this.eb(I);try{const V=await(0,h.getManifest)(y.resolve(M.fsPath));if(V.engines&&V.engines.vscode&&!(0,Y.isEngineValid)(V.engines.vscode,this.w.version,this.w.date))throw new Error(w.localize(0,null,(0,i.getGalleryExtensionId)(V.publisher,V.name),this.w.version));return await this.z(V,M,P)}finally{await F()}}async installFromLocation(I,P){this.v.trace("ExtensionManagementService#installFromLocation",I.toString());const M=await this.S.scanUserExtensionAtLocation(I);if(!M)throw new Error(`Cannot find a valid extension from the location ${I.toString()}`);return await this.nb([M],P),this.v.info("Successfully installed extension",M.identifier.id,P.toString()),M}getMetadata(I){return this.Y.scanMetadata(I.location)}async updateMetadata(I,P){this.v.trace("ExtensionManagementService#updateMetadata",I.identifier.id);const M={...P};return P.isPreReleaseVersion&&(M.preRelease=!0),I=await this.S.updateMetadata(I,M),this.U.invalidate(),I}async updateExtensionScope(I,P){return this.v.trace("ExtensionManagementService#updateExtensionScope",I.identifier.id),I=await this.S.updateMetadata(I,{isMachineScoped:P}),this.U.invalidate(),I}async reinstallFromGallery(I){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",I.identifier.id),!this.t.isEnabled())throw new Error(w.localize(1,null));const P=await this.getTargetPlatform(),[M]=await this.t.getExtensions([{...I.identifier,preRelease:I.preRelease}],{targetPlatform:P,compatible:!0},D.CancellationToken.None);if(!M)throw new Error(w.localize(2,null));await this.S.setUninstalled(I);try{await this.S.removeUninstalledExtension(I)}catch(F){throw new Error(w.localize(3,null,(0,k.toErrorMessage)(F)))}await this.installFromGallery(M)}markAsUninstalled(...I){return this.S.setUninstalled(...I)}removeUninstalledExtensions(){return this.S.cleanUp()}async download(I,P){const{location:M}=await this.W.download(I,P);return M}async eb(I){if(I.scheme===u.Schemas.file)return{location:I,async cleanup(){}};this.v.trace("Downloading extension from",I.toString());const P=(0,m.joinPath)(this.W.extensionsDownloadDir,(0,E.generateUuid)());return await this.ab.download(I,P),this.v.info("Downloaded extension to",P.toString()),{location:P,cleanup:async()=>{try{await this.bb.del(P)}catch(F){this.v.error(F)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(I,P,M){let F;if(O.URI.isUri(P))F=new z(I,P,M,this.t,this.S,this.v);else{const V=i.ExtensionKey.create(P).toString();F=this.X.get(V),F||(this.X.set(V,F=new A(I,P,M,this.W,this.S,this.v)),F.waitUntilTaskIsFinished().then(()=>this.X.delete(V)))}return new $(F,M.profileLocation,this.Z)}R(I,P){return new q(I,P.profileLocation,this.Z)}async ib(I){const P=async F=>{let V=await l.Promises.readdir(F);V=V.map(ne=>y.join(F,ne));const G=await Promise.all(V.map(ne=>l.Promises.stat(ne)));let te=Promise.resolve([]);return G.forEach((ne,ge)=>{const ye=V[ge];ne.isFile()&&(te=te.then(ue=>[...ue,ye])),ne.isDirectory()&&(te=te.then(ue=>P(ye).then(ce=>[...ue,...ce])))}),te};return(await P(I.location.fsPath)).map(F=>({path:`extension/${y.relative(I.location.fsPath,F)}`,localPath:F}))}async jb({added:I,removed:P}){if(P)for(const M of P.extensions)this.v.info("Extensions removed from another source",M.id,P.profileLocation.toString()),this.p.fire({identifier:M,profileLocation:P.profileLocation});if(I){const F=(await this.S.scanExtensions(1,I.profileLocation)).filter(V=>I.extensions.some(G=>(0,i.areSameExtensions)(G,V.identifier)));this.m.fire(F.map(V=>(this.v.info("Extensions added from another source",V.identifier.id,I.profileLocation.toString()),{identifier:V.identifier,local:V,profileLocation:I.profileLocation,operation:1})))}}async lb(){this.B(this.S.onExtract(P=>this.kb.add(P)));const I=await this.bb.resolve(this.Y.userExtensionsLocation);for(const P of I.children??[])P.isDirectory&&this.kb.add(P.resource);this.B(this.bb.watch(this.Y.userExtensionsLocation)),this.B(this.bb.onDidFilesChange(P=>this.mb(P)))}async mb(I){const P=[];for(const M of I.rawAdded){if(this.kb.has(M)||!this.cb.extUri.isEqual(this.cb.extUri.dirname(M),this.Y.userExtensionsLocation)||this.cb.extUri.isEqual(M,this.cb.extUri.joinPath(this.Y.userExtensionsLocation,".obsolete"))||this.cb.extUri.basename(M).startsWith(".")||!(await this.bb.stat(M)).isDirectory)continue;const F=await this.S.scanUserExtensionAtLocation(M);F&&F.installedTimestamp===void 0&&(this.kb.add(M),P.push(F))}P.length&&(await this.nb(P,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",P.map(M=>M.identifier.id)))}async nb(I,P){await this.Z.addExtensionsToProfile(I.map(M=>[M,void 0]),P),this.m.fire(I.map(M=>({local:M,identifier:M.identifier,operation:1,profileLocation:P})))}};he=me([ee(0,n.IExtensionGalleryService),ee(1,pe.ITelemetryService),ee(2,re.ILogService),ee(3,s.INativeEnvironmentService),ee(4,o.IExtensionsScannerService),ee(5,r.IExtensionsProfileScannerService),ee(6,f.IDownloadService),ee(7,ie.IInstantiationService),ee(8,X.IFileService),ee(9,_.IProductService),ee(10,le.IUriIdentityService),ee(11,ae.IUserDataProfilesService)],he),e.ExtensionManagementService=he;let B=class extends S.Disposable{constructor(I,P,M,F){super(),this.j=I,this.k=P,this.l=M,this.m=F,this.h=this.B(new N.Emitter),this.onExtract=this.h.event,this.c=(0,m.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new T.Queue}async cleanUp(){await this.v()}async scanExtensions(I,P){await this.l.initializeDefaultProfileExtensions();const M={includeInvalid:!0,profileLocation:P};let F=[];return I===null||I===0?F.push(...await this.l.scanAllExtensions({includeInvalid:!0},M,!1)):I===1&&F.push(...await this.l.scanUserExtensions(M)),F=I!==null?F.filter(V=>V.type===I):F,Promise.all(F.map(V=>this.u(V)))}async scanAllUserExtensions(I){const P=await this.l.scanUserExtensions({includeAllVersions:!I,includeInvalid:!0});return Promise.all(P.map(M=>this.u(M)))}async scanUserExtensionAtLocation(I){try{const P=await this.l.scanExistingExtension(I,1,{includeInvalid:!0});if(P)return await this.u(P)}catch(P){this.m.error(P)}return null}async extractUserExtension(I,P,M,F){await this.l.initializeDefaultProfileExtensions();const V=I.toString(),G=y.join(this.l.userExtensionsLocation.fsPath,`.${(0,E.generateUuid)()}`),te=y.join(this.l.userExtensionsLocation.fsPath,V);try{await l.Promises.rm(te)}catch{throw new n.ExtensionManagementError(w.localize(4,null,te,I.id),n.ExtensionManagementErrorCode.Delete)}await this.p(I,P,G,F),await this.l.updateMetadata(O.URI.file(G),M);try{this.h.fire(O.URI.file(te)),await this.s(I,G,te,Date.now()+2*60*1e3),this.m.info("Renamed to",te)}catch(ne){try{await l.Promises.rm(G)}catch{}if(ne.code==="ENOTEMPTY")this.m.info("Rename failed because extension was installed by another source. So ignoring renaming.",I.id);else throw this.m.info(`Rename failed because of ${(0,L.getErrorMessage)(ne)}. Deleted from extracted location`,G),ne}return this.t(O.URI.file(te),1)}async updateMetadata(I,P){return await this.l.updateMetadata(I.location,P),this.t(I.location,I.type)}getUninstalledExtensions(){return this.n()}async setUninstalled(...I){const P=I.map(M=>i.ExtensionKey.create(M));await this.n(M=>P.forEach(F=>{M[F.toString()]=!0,this.m.info("Marked extension as uninstalled",F.toString())}))}async setInstalled(I){await this.n(F=>delete F[I.toString()]);const M=(await this.scanAllUserExtensions(!0)).find(F=>i.ExtensionKey.create(F).equals(I))||null;return M?this.updateMetadata(M,{installedTimestamp:Date.now()}):null}async removeExtension(I,P){this.m.trace(`Deleting ${P} extension from disk`,I.identifier.id,I.location.fsPath),await l.Promises.rm(I.location.fsPath),this.m.info("Deleted from disk",I.identifier.id,I.location.fsPath)}async removeUninstalledExtension(I){await this.removeExtension(I,"uninstalled"),await this.n(P=>delete P[i.ExtensionKey.create(I).toString()])}async n(I){return this.g.queue(async()=>{let P;try{P=await l.Promises.readFile(this.c,"utf8")}catch(F){if(F.code!=="ENOENT")throw F}let M={};if(P)try{M=JSON.parse(P)}catch{}return I&&(I(M),Object.keys(M).length?await l.Promises.writeFile(this.c,JSON.stringify(M)):await l.Promises.rm(this.c)),M})}async p(I,P,M,F){this.m.trace(`Started extracting the extension from ${P} to ${M}`);try{await l.Promises.rm(M)}catch(V){throw new n.ExtensionManagementError(this.w(V).message,n.ExtensionManagementErrorCode.Delete)}try{await(0,d.extract)(P,M,{sourcePath:"extension",overwrite:!0},F),this.m.info(`Extracted extension to ${M}:`,I.id)}catch(V){try{await l.Promises.rm(M)}catch{}let G=n.ExtensionManagementErrorCode.Extract;throw V instanceof d.ExtractError&&(V.type==="CorruptZip"?G=n.ExtensionManagementErrorCode.CorruptZip:V.type==="Incomplete"&&(G=n.ExtensionManagementErrorCode.IncompleteZip)),new n.ExtensionManagementError(V.message,G)}}async s(I,P,M,F){try{await l.Promises.rename(P,M)}catch(V){if(v.isWindows&&V&&V.code==="EPERM"&&Date.now()<F)return this.m.info(`Failed renaming ${P} to ${M} with 'EPERM' error. Trying again...`,I.id),this.s(I,P,M,F);throw new n.ExtensionManagementError(V.message||w.localize(5,null,P,M),V.code||n.ExtensionManagementErrorCode.Rename)}}async t(I,P){const M=await this.l.scanExistingExtension(I,P,{includeInvalid:!0});if(M)return this.u(M);throw new Error(w.localize(6,null,I.path))}async u(I){const P=await this.k.resolve(I.location);let M,F;return P.children&&(M=P.children.find(({name:V})=>/^readme(\.txt|\.md|)$/i.test(V))?.resource,F=P.children.find(({name:V})=>/^changelog(\.txt|\.md|)$/i.test(V))?.resource),{identifier:I.identifier,type:I.type,isBuiltin:I.isBuiltin||!!I.metadata?.isBuiltin,location:I.location,manifest:I.manifest,targetPlatform:I.targetPlatform,validations:I.validations,isValid:I.isValid,readmeUrl:M,changelogUrl:F,publisherDisplayName:I.metadata?.publisherDisplayName||null,publisherId:I.metadata?.publisherId||null,isApplicationScoped:!!I.metadata?.isApplicationScoped,isMachineScoped:!!I.metadata?.isMachineScoped,isPreReleaseVersion:!!I.metadata?.isPreReleaseVersion,preRelease:!!I.metadata?.preRelease,installedTimestamp:I.metadata?.installedTimestamp,updated:!!I.metadata?.updated}}async v(){const I=await this.getUninstalledExtensions(),P=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),M=new Set;for(const G of P)I[i.ExtensionKey.create(G).toString()]||M.add(G.identifier.id.toLowerCase());const F=(0,i.groupByExtension)(P,G=>G.identifier);await T.Promises.settled(F.map(async G=>{const te=G.sort((ne,ge)=>b.rcompare(ne.manifest.version,ge.manifest.version))[0];M.has(te.identifier.id.toLowerCase())||await this.j(await this.u(te))}));const V=P.filter(G=>G.metadata&&I[i.ExtensionKey.create(G).toString()]);await T.Promises.settled(V.map(G=>this.removeUninstalledExtension(G)))}w(I){const P=Array.isArray(I)?I:[I];return P.length===1?P[0]instanceof Error?P[0]:new Error(P[0]):P.reduce((M,F)=>new Error(`${M.message}${M.message?",":""}${F instanceof Error?F.message:F}`),new Error(""))}};B=me([ee(1,X.IFileService),ee(2,o.IExtensionsScannerService),ee(3,re.ILogService)],B),e.ExtensionsScanner=B;class j extends t.AbstractExtensionTask{get operation(){return(0,p.isUndefined)(this.k.operation)?this.j:this.k.operation}constructor(I,P,M,F,V){super(),this.identifier=I,this.source=P,this.k=M,this.l=F,this.m=V,this.wasVerified=!1,this.j=2}async n(I,P){try{const M=await this.o(I.key);if(M)return this.l.updateMetadata(M,I.metadata)}catch{throw v.isMacintosh?new n.ExtensionManagementError(w.localize(7,null),n.ExtensionManagementErrorCode.Internal):new n.ExtensionManagementError(w.localize(8,null),n.ExtensionManagementErrorCode.Internal)}return this.q(I,P)}async o(I){if(!await this.p(I))return null;this.m.trace("Removing the extension from uninstalled list:",I.id);const M=await this.l.setInstalled(I);return this.m.info("Removed the extension from uninstalled list:",I.id),M}async p(I){return!!(await this.l.getUninstalledExtensions())[I.toString()]}async q({zipPath:I,key:P,metadata:M},F){const V=await this.l.extractUserExtension(P,I,M,F);return this.m.info("Extracting completed.",P.id),V}}class A extends j{constructor(I,P,M,F,V,G){super(P.identifier,P,M,V,G),this.s=I,this.t=P,this.u=F}async h(I){const M=(await this.l.scanExtensions(null,void 0)).find(te=>(0,i.areSameExtensions)(te.identifier,this.t.identifier));M&&(this.j=3);const F={id:this.t.identifier.uuid,publisherId:this.t.publisherId,publisherDisplayName:this.t.publisherDisplayName,targetPlatform:this.t.properties.targetPlatform,isApplicationScoped:(0,x.isApplicationScopedExtension)(this.s),isMachineScoped:this.k.isMachineScoped||M?.isMachineScoped,isBuiltin:this.k.isBuiltin||M?.isBuiltin,isSystem:M?.type===0?!0:void 0,updated:!!M,isPreReleaseVersion:this.t.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.t.properties.isPreReleaseVersion||((0,p.isBoolean)(this.k.installPreReleaseVersion)?this.k.installPreReleaseVersion:M?.preRelease)};if(M?.manifest.version===this.t.version)return{local:await this.l.updateMetadata(M,F),metadata:F};const{location:V,verified:G}=await this.u.download(this.t,this.j);try{return this.wasVerified=!!G,this.w(V.fsPath),{local:await this.n({zipPath:V.fsPath,key:i.ExtensionKey.create(this.t),metadata:F},I),metadata:F}}catch(te){try{await this.u.delete(V)}catch(ne){this.m.warn("Error while deleting the downloaded file",V.toString(),(0,L.getErrorMessage)(ne))}throw te}}async w(I){try{await(0,h.getManifest)(I)}catch(P){throw new n.ExtensionManagementError((0,t.joinErrors)(P).message,n.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=A;class z extends j{constructor(I,P,M,F,V,G){super({id:(0,i.getGalleryExtensionId)(I.publisher,I.name)},P,M,V,G),this.s=I,this.t=P,this.u=F}async h(I){const P=new i.ExtensionKey(this.identifier,this.s.version),F=(await this.l.scanExtensions(1,void 0)).find(te=>(0,i.areSameExtensions)(this.identifier,te.identifier)),V=await this.w(this.identifier.id,this.s.version,I);if(V.isApplicationScoped=(0,x.isApplicationScopedExtension)(this.s),V.isMachineScoped=this.k.isMachineScoped||F?.isMachineScoped,V.isBuiltin=this.k.isBuiltin||F?.isBuiltin,V.installedTimestamp=Date.now(),F)if(this.j=3,P.equals(new i.ExtensionKey(F.identifier,F.manifest.version)))try{await this.l.removeExtension(F,"existing")}catch{throw new Error(w.localize(9,null,this.s.displayName||this.s.name))}else!this.k.profileLocation&&b.gt(F.manifest.version,this.s.version)&&await this.l.setUninstalled(F);else{const te=await this.o(P);if(te)try{await this.l.removeExtension(te,"existing")}catch{throw new Error(w.localize(10,null,this.s.displayName||this.s.name))}}return{local:await this.n({zipPath:y.resolve(this.t.fsPath),key:P,metadata:V},I),metadata:V}}async w(I,P,M){try{let[F]=await this.u.getExtensions([{id:I,version:P}],M);if(F||([F]=await this.u.getExtensions([{id:I}],M)),F)return{id:F.identifier.uuid,publisherDisplayName:F.publisherDisplayName,publisherId:F.publisherId,isPreReleaseVersion:F.properties.isPreReleaseVersion,preRelease:F.properties.isPreReleaseVersion||this.k.installPreReleaseVersion}}catch{}return{}}}class ${constructor(I,P,M){this.d=I,this.g=P,this.h=M,this.identifier=this.d.identifier,this.source=this.d.source,this.operation=this.d.operation,this.c=this.j()}async j(){const I=await this.d.waitUntilTaskIsFinished();return await this.h.addExtensionsToProfile([[I.local,I.metadata]],this.g),I}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class q extends t.AbstractExtensionTask{constructor(I,P,M){super(),this.extension=I,this.j=P,this.k=M}async h(I){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(Z[153],Q([0,1,132,3,15,10,2,5,21,18,133,9,131,166]),function(W,e,T,D,k,L,N,S,g,u,y,v,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let p=class extends N.Disposable{constructor(E,l,d){super(),this.h=l,this.i=d,this.j(E.getValue()),this.B(E.onDidChangeConfiguration(()=>this.j(E.getValue()),this))}j(E){this.a=E.http&&E.http.proxy,this.b=!!(E.http&&E.http.proxyStrictSSL),this.f=E.http&&E.http.proxyAuthorization}async request(E,l){this.i.trace("RequestService#request (node) - begin",E.url);const{a:d,b:w}=this;let f;try{f=await(0,y.getResolvedShellEnv)(this.i,this.h.args,process.env)}catch(n){this.g||(this.g=!0,this.i.error("RequestService#request (node) resolving shell environment failed",n))}const s={...process.env,...f},t=E.agent?E.agent:await(0,m.getProxyAgent)(E.url||"",s,{proxyUrl:d,strictSSL:w});E.agent=t,E.strictSSL=w,this.f&&(E.headers={...E.headers||{},"Proxy-Authorization":this.f});try{const n=await this.l(E,l);return this.i.trace("RequestService#request (node) - success",E.url),n}catch(n){throw this.i.trace("RequestService#request (node) - error",E.url,n),n}}async k(E){return((0,T.parse)(E.url).protocol==="https:"?await new Promise((w,f)=>{W(["https"],w,f)}):await new Promise((w,f)=>{W(["http"],w,f)})).request}l(E,l){return D.Promises.withAsyncBody(async(d,w)=>{const f=(0,T.parse)(E.url),s=E.getRawRequest?E.getRawRequest(E):await this.k(E),t={hostname:f.hostname,port:f.port?parseInt(f.port):f.protocol==="https:"?443:80,protocol:f.protocol,path:f.path,method:E.type||"GET",headers:E.headers,agent:E.agent,rejectUnauthorized:(0,S.isBoolean)(E.strictSSL)?E.strictSSL:!0};E.user&&E.password&&(t.auth=E.user+":"+E.password);const n=s(t,i=>{const r=(0,S.isNumber)(E.followRedirects)?E.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&r>0&&i.headers.location)this.l({...E,url:i.headers.location,followRedirects:r-1},l).then(d,w);else{let o=i;!E.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,b.createGunzip)())),d({res:i,stream:(0,k.streamToBufferReadableStream)(o)})}});n.on("error",w),E.timeout&&n.setTimeout(E.timeout),E.isChromiumNetwork&&n.removeHeader("Content-Length"),E.data&&typeof E.data=="string"&&n.write(E.data),n.end(),l.onCancellationRequested(()=>{n.abort(),w(new L.CancellationError)})})}async resolveProxy(E){}};p=me([ee(0,g.IConfigurationService),ee(1,u.INativeEnvironmentService),ee(2,v.ILogService)],p),e.RequestService=p}),define(Z[167],Q([0,1,33,3,15,34,10,2,16,14,12,35,11,20,21,124,58,130,18,105,148,23,59,125,42,48,152,146,13,116,118,46,114,62,63,129,9,120,121,38,150,138,26,47,153,67,134,68,32,137,41,139,140,28,142,25,149,141]),function(W,e,T,D,k,L,N,S,g,u,y,v,m,b,p,O,E,l,d,w,f,s,t,n,i,r,o,c,a,h,R,C,x,Y,X,ie,re,_,pe,le,ae,he,B,j,A,z,$,q,K,I,P,M,F,V,G,te,ne,ge){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ye extends S.Disposable{constructor(oe){super(),this.b=oe,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[oe,se]=await this.f();return oe.invokeFunction(async fe=>{const Te=fe.get(re.ILogService),Fe=fe.get(a.IFileService),De=fe.get(d.INativeEnvironmentService),Me=fe.get(te.IUserDataProfilesService);Te.info("CLI main",this.b),this.g(Te),await this.h(De,Fe,Me,oe),await Promise.all(se.map(U=>{(0,D.raceTimeout)(U.flush(),1e3)}))})}async f(){const oe=new Y.ServiceCollection,se={_serviceBrand:void 0,...he.default};oe.set(B.IProductService,se);const fe=new w.NativeEnvironmentService(this.b,se);oe.set(d.INativeEnvironmentService,fe),await Promise.all([fe.appSettingsHome.fsPath,fe.extensionsPath].map(Pe=>Pe?b.Promises.mkdir(Pe,{recursive:!0}):void 0));const Te=(0,re.getLogLevel)(fe),Fe=[];Fe.push(new _.SpdLogLogger("cli",(0,u.join)(fe.logsPath,"cli.log"),!0,!1,Te)),Te===re.LogLevel.Trace&&Fe.push(new re.ConsoleLogger(Te));const De=this.B(new re.MultiplexLogService(Fe));oe.set(re.ILogService,De);const Me=this.B(new h.FileService(De));oe.set(a.IFileService,Me);const U=this.B(new R.DiskFileSystemProvider(De));Me.registerProvider(g.Schemas.file,U);const H=new $.StateService(fe,De,Me);oe.set(z.IStateService,H);const J=new G.UriIdentityService(Me);oe.set(V.IUriIdentityService,J);const de=new ne.UserDataProfilesService(H,J,fe,Me,De);oe.set(te.IUserDataProfilesService,de);const ve=y.isWindows&&se.win32RegValueName?this.B(new ae.NativePolicyService(De,se.win32RegValueName)):fe.policyFile?this.B(new pe.FilePolicyService(fe.policyFile,Me,De)):new le.NullPolicyService;oe.set(le.IPolicyService,ve);const Re=this.B(new O.ConfigurationService(de.defaultProfile.settingsResource,Me,ve,De));oe.set(p.IConfigurationService,Re),await Promise.all([H.init(),Re.initialize()]),de.setEnablement(se.quality!=="stable"||Re.getValue(te.PROFILES_ENABLEMENT_CONFIG)),oe.set(V.IUriIdentityService,new G.UriIdentityService(Me)),oe.set(j.IRequestService,new C.SyncDescriptor(A.RequestService,void 0,!0)),oe.set(E.IDownloadService,new C.SyncDescriptor(l.DownloadService,void 0,!0)),oe.set(i.IExtensionsProfileScannerService,new C.SyncDescriptor(i.ExtensionsProfileScannerService,void 0,!0)),oe.set(r.IExtensionsScannerService,new C.SyncDescriptor(c.ExtensionsScannerService,void 0,!0)),oe.set(t.IExtensionSignatureVerificationService,new C.SyncDescriptor(t.ExtensionSignatureVerificationService,void 0,!0)),oe.set(o.INativeServerExtensionManagementService,new C.SyncDescriptor(o.ExtensionManagementService,void 0,!0)),oe.set(s.IExtensionGalleryService,new C.SyncDescriptor(f.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),oe.set(X.ILanguagePackService,new C.SyncDescriptor(ie.NativeLanguagePackService,void 0,!1));const Se=[],Le=(0,P.isInternalTelemetry)(se,Re);if((0,P.supportsTelemetry)(se,fe)){se.aiConfig&&se.aiConfig.ariaKey&&Se.push(new M.OneDataSystemAppender(Le,"monacoworkbench",null,se.aiConfig.ariaKey));const{installSourcePath:Pe}=fe,Oe={appenders:Se,sendErrorTelemetry:!1,commonProperties:(async()=>{let je;try{je=await(0,ge.resolveMachineId)(H)}catch(Ie){Ie.code!=="ENOENT"&&De.error(Ie)}return(0,q.resolveCommonProperties)(Me,(0,T.release)(),(0,T.hostname)(),process.arch,se.commit,se.version,je,Le,Pe)})(),piiPaths:(0,P.getPiiPathsFromEnvironment)(fe)};oe.set(K.ITelemetryService,new C.SyncDescriptor(I.TelemetryService,[Oe],!1))}else oe.set(K.ITelemetryService,P.NullTelemetryService);return[new x.InstantiationService(oe),Se]}g(oe){(0,N.setUnexpectedErrorHandler)(se=>{const fe=(0,L.toErrorMessage)(se,!0);!fe||oe.error(`[uncaught exception in CLI]: ${fe}`)}),process.on("uncaughtException",se=>(0,N.onUnexpectedError)(se)),process.on("unhandledRejection",se=>(0,N.onUnexpectedError)(se))}async h(oe,se,fe,Te){const Fe=(oe.args.profile?fe.profiles.find(De=>De.name===oe.args.profile)??fe.defaultProfile:fe.defaultProfile).extensionsResource;if(this.b["install-source"])return this.j(oe,se,this.b["install-source"]);if(this.b["list-extensions"])return Te.createInstance(n.ExtensionManagementCLI).listExtensions(!!this.b["show-versions"],this.b.category,Fe);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const De={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:Fe};return Te.createInstance(n.ExtensionManagementCLI).installExtensions(this.i(this.b["install-extension"]||[]),this.b["install-builtin-extension"]||[],De,!!this.b.force)}else{if(this.b["uninstall-extension"])return Te.createInstance(n.ExtensionManagementCLI).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,Fe);if(this.b["locate-extension"])return Te.createInstance(n.ExtensionManagementCLI).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,F.buildTelemetryMessage)(oe.appRoot,oe.extensionsPath))}}i(oe){return oe.map(se=>/\.vsix$/i.test(se)?m.URI.file((0,u.isAbsolute)(se)?se:(0,u.join)((0,v.cwd)(),se)):se)}async j(oe,se,fe){await se.writeFile(m.URI.file(oe.installSourcePath),k.VSBuffer.fromString(fe.slice(0,30)))}}async function ue(ce){const oe=new ye(ce);try{await oe.run()}finally{oe.dispose()}}e.main=ue})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d7b1e2a1c892511a125e4ceb9758ec8ddf907775/core/vs/code/node/cliProcessMain.js.map
