/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/editor/common/core/range","vs/base/common/process","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/platform/registry/common/platform","vs/base/common/stopwatch","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/ternarySearchTree","fs","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/normalization","vs/base/common/mime","vs/base/common/hash","vs/base/common/marshalling","os","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],ye=function(ne){for(var e=[],a=0,t=ne.length;a<t;a++)e[a]=Se[ne[a]];return e};define(Se[79],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function a(A){return A?A.replace(/\$\((.*?)\)/g,(D,k)=>` ${k} `).trim():""}e.getCodiconAriaLabel=a;class t{constructor(D,k,S){this.id=D,this.definition=k,this.description=S,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.commentDraft=new t("comment-draft",{fontCharacter:"\\ec0e"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var I;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function k(R){if(R instanceof t)return["codicon","codicon-"+R.id];const T=D.exec(R.id);if(!T)return k(t.error);const[,E,y]=T,v=["codicon","codicon-"+E];return y&&v.push("codicon-modifier-"+y.substring(1)),v}A.asClassNameArray=k;function S(R){return k(R).join(" ")}A.asClassName=S;function C(R){return"."+k(R).join(".")}A.asCSSSelector=C})(I=e.CSSIcon||(e.CSSIcon={}))}),define(Se[80],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function a(D,k){const S=Object.create(null);for(const C of D){const R=k(C);let T=S[R];T||(T=S[R]=[]),T.push(C)}return S}e.groupBy=a;function t(D,k){const S=[],C=[];for(const R of D)k.has(R)||S.push(R);for(const R of k)D.has(R)||C.push(R);return{removed:S,added:C}}e.diffSets=t;function I(D,k){const S=[],C=[];for(const[R,T]of D)k.has(R)||S.push(T);for(const[R,T]of k)D.has(R)||C.push(T);return{removed:S,added:C}}e.diffMaps=I;class A{constructor(){this.a=new Map}add(k,S){let C=this.a.get(k);C||(C=new Set,this.a.set(k,C)),C.add(S)}delete(k,S){const C=this.a.get(k);!C||(C.delete(S),C.size===0&&this.a.delete(k))}forEach(k,S){const C=this.a.get(k);!C||C.forEach(S)}}e.SetMap=A}),define(Se[60],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function a(D){return(k,S,C)=>{let R=null,T=null;if(typeof C.value=="function"?(R="value",T=C.value):typeof C.get=="function"&&(R="get",T=C.get),!T)throw new Error("not supported");C[R]=D(T,S)}}function t(D,k,S){let C=null,R=null;if(typeof S.value=="function"?(C="value",R=S.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(C="get",R=S.get),!R)throw new Error("not supported");const T=`$memoize$${k}`;S[C]=function(...E){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,E)}),this[T]}}e.memoize=t;function I(D,k,S){return a((C,R)=>{const T=`$debounce$${R}`,E=`$debounce$result$${R}`;return function(...y){this[E]||(this[E]=S?S():void 0),clearTimeout(this[T]),k&&(this[E]=k(this[E],...y),y=[this[E]]),this[T]=setTimeout(()=>{C.apply(this,y),this[E]=S?S():void 0},D)}})}e.debounce=I;function A(D,k,S){return a((C,R)=>{const T=`$throttle$timer$${R}`,E=`$throttle$result$${R}`,y=`$throttle$lastRun$${R}`,v=`$throttle$pending$${R}`;return function(...d){if(this[E]||(this[E]=S?S():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),k&&(this[E]=k(this[E],...d)),this[v])return;const b=this[y]+D;b<=Date.now()?(this[y]=Date.now(),C.apply(this,[this[E]]),this[E]=S?S():void 0):(this[v]=!0,this[T]=setTimeout(()=>{this[v]=!1,this[y]=Date.now(),C.apply(this,[this[E]]),this[E]=S?S():void 0},b-Date.now()))}})}e.throttle=A}),define(Se[10],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class a{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?h.isErrorNoTelemetry(o)?new h(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(i=>{i(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}e.ErrorHandler=a,e.errorHandler=new a;function t(p){e.errorHandler.setUnexpectedErrorHandler(p)}e.setUnexpectedErrorHandler=t;function I(p){S(p)||e.errorHandler.onUnexpectedError(p)}e.onUnexpectedError=I;function A(p){S(p)||e.errorHandler.onUnexpectedExternalError(p)}e.onUnexpectedExternalError=A;function D(p){if(p instanceof Error){const{name:o,message:i}=p,l=p.stacktrace||p.stack;return{$isError:!0,name:o,message:i,stack:l,noTelemetry:h.isErrorNoTelemetry(p)}}return p}e.transformErrorForSerialization=D;const k="Canceled";function S(p){return p instanceof C?!0:p instanceof Error&&p.name===k&&p.message===k}e.isCancellationError=S;class C extends Error{constructor(){super(k),this.name=this.message}}e.CancellationError=C;function R(){const p=new Error(k);return p.name=p.message,p}e.canceled=R;function T(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}e.illegalArgument=T;function E(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}e.illegalState=E;function y(p){return p?new Error(`readonly property '${p} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function v(p){const o=new Error(`${p} has been disposed`);return o.name="DISPOSED",o}e.disposed=v;function d(p){return p?p.message?p.message:p.stack?p.stack.split(`
`)[0]:String(p):"Error"}e.getErrorMessage=d;class b extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.NotImplementedError=b;class f extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.NotSupportedError=f;class w extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=w;class h extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof h)return o;const i=new h;return i.message=o.message,i.stack=o.stack,i}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.ErrorNoTelemetry=h;class m extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype);debugger}}e.BugIndicatingError=m}),define(Se[17],ye([1,0,10]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(se,ue=0){return se[se.length-(1+ue)]}e.tail=t;function I(se){if(se.length===0)throw new Error("Invalid tail call");return[se.slice(0,se.length-1),se[se.length-1]]}e.tail2=I;function A(se,ue,he=(ee,oe)=>ee===oe){if(se===ue)return!0;if(!se||!ue||se.length!==ue.length)return!1;for(let ee=0,oe=se.length;ee<oe;ee++)if(!he(se[ee],ue[ee]))return!1;return!0}e.equals=A;function D(se,ue){const he=se.length-1;ue<he&&(se[ue]=se[he]),se.pop()}e.removeFastWithoutKeepingOrder=D;function k(se,ue,he){return S(se.length,ee=>he(se[ee],ue))}e.binarySearch=k;function S(se,ue){let he=0,ee=se-1;for(;he<=ee;){const oe=(he+ee)/2|0,ie=ue(oe);if(ie<0)he=oe+1;else if(ie>0)ee=oe-1;else return oe}return-(he+1)}e.binarySearch2=S;function C(se,ue){let he=0,ee=se.length;if(ee===0)return 0;for(;he<ee;){const oe=Math.floor((he+ee)/2);ue(se[oe])?ee=oe:he=oe+1}return he}e.findFirstInSorted=C;function R(se,ue,he){if(se=se|0,se>=ue.length)throw new TypeError("invalid index");const ee=ue[Math.floor(ue.length*Math.random())],oe=[],ie=[],O=[];for(const H of ue){const q=he(H,ee);q<0?oe.push(H):q>0?ie.push(H):O.push(H)}return se<oe.length?R(se,oe,he):se<oe.length+O.length?O[0]:R(se-(oe.length+O.length),ie,he)}e.quickSelect=R;function T(se,ue){const he=[];let ee;for(const oe of se.slice(0).sort(ue))!ee||ue(ee[0],oe)!==0?(ee=[oe],he.push(ee)):ee.push(oe);return he}e.groupBy=T;function E(se,ue,he){const ee=[];function oe(H,q,Y){if(q===0&&Y.length===0)return;const de=ee[ee.length-1];de&&de.start+de.deleteCount===H?(de.deleteCount+=q,de.toInsert.push(...Y)):ee.push({start:H,deleteCount:q,toInsert:Y})}let ie=0,O=0;for(;;){if(ie===se.length){oe(ie,0,ue.slice(O));break}if(O===ue.length){oe(ie,se.length-ie,[]);break}const H=se[ie],q=ue[O],Y=he(H,q);Y===0?(ie+=1,O+=1):Y<0?(oe(ie,1,[]),ie+=1):Y>0&&(oe(ie,0,[q]),O+=1)}return ee}e.sortedDiff=E;function y(se,ue,he){const ee=E(se,ue,he),oe=[],ie=[];for(const O of ee)oe.push(...se.slice(O.start,O.start+O.deleteCount)),ie.push(...O.toInsert);return{removed:oe,added:ie}}e.delta=y;function v(se,ue,he){if(he===0)return[];const ee=se.slice(0,he).sort(ue);return b(se,ue,ee,he,se.length),ee}e.top=v;function d(se,ue,he,ee,oe){return he===0?Promise.resolve([]):new Promise((ie,O)=>{(async()=>{const H=se.length,q=se.slice(0,he).sort(ue);for(let Y=he,de=Math.min(he+ee,H);Y<H;Y=de,de=Math.min(de+ee,H)){if(Y>he&&await new Promise(be=>setTimeout(be)),oe&&oe.isCancellationRequested)throw new a.CancellationError;b(se,ue,q,Y,de)}return q})().then(ie,O)})}e.topAsync=d;function b(se,ue,he,ee,oe){for(const ie=he.length;ee<oe;ee++){const O=se[ee];if(ue(O,he[ie-1])<0){he.pop();const H=C(he,q=>ue(O,q)<0);he.splice(H,0,O)}}}function f(se){return se.filter(ue=>!!ue)}e.coalesce=f;function w(se){let ue=0;for(let he=0;he<se.length;he++)se[he]&&(se[ue]=se[he],ue+=1);se.length=ue}e.coalesceInPlace=w;function h(se,ue,he){se.splice(he,0,se.splice(ue,1)[0])}e.move=h;function m(se){return!Array.isArray(se)||se.length===0}e.isFalsyOrEmpty=m;function p(se){return Array.isArray(se)&&se.length>0}e.isNonEmptyArray=p;function o(se,ue=he=>he){const he=new Set;return se.filter(ee=>{const oe=ue(ee);return he.has(oe)?!1:(he.add(oe),!0)})}e.distinct=o;function i(se){const ue=new Set;return he=>{const ee=se(he);return ue.has(ee)?!1:(ue.add(ee),!0)}}e.uniqueFilter=i;function l(se,ue){const he=u(se,ue);if(he!==-1)return se[he]}e.findLast=l;function u(se,ue){for(let he=se.length-1;he>=0;he--){const ee=se[he];if(ue(ee))return he}return-1}e.lastIndex=u;function s(se,ue){return se.length>0?se[0]:ue}e.firstOrDefault=s;function c(se,ue){return se.length>0?se[se.length-1]:ue}e.lastOrDefault=c;function n(se,ue,he=(ee,oe)=>ee===oe){let ee=0;for(let oe=0,ie=Math.min(se.length,ue.length);oe<ie&&he(se[oe],ue[oe]);oe++)ee++;return ee}e.commonPrefixLength=n;function r(se){return[].concat(...se)}e.flatten=r;function g(se,ue){let he=typeof ue=="number"?se:0;typeof ue=="number"?he=se:(he=0,ue=se);const ee=[];if(he<=ue)for(let oe=he;oe<ue;oe++)ee.push(oe);else for(let oe=he;oe>ue;oe--)ee.push(oe);return ee}e.range=g;function P(se,ue,he){return se.reduce((ee,oe)=>(ee[ue(oe)]=he?he(oe):oe,ee),Object.create(null))}e.index=P;function L(se,ue){return se.push(ue),()=>z(se,ue)}e.insert=L;function z(se,ue){const he=se.indexOf(ue);if(he>-1)return se.splice(he,1),ue}e.remove=z;function _(se,ue,he){const ee=se.slice(0,ue),oe=se.slice(ue);return ee.concat(he,oe)}e.arrayInsert=_;function K(se,ue){let he;if(typeof ue=="number"){let ee=ue;he=()=>{const oe=Math.sin(ee++)*179426549;return oe-Math.floor(oe)}}else he=Math.random;for(let ee=se.length-1;ee>0;ee-=1){const oe=Math.floor(he()*(ee+1)),ie=se[ee];se[ee]=se[oe],se[oe]=ie}}e.shuffle=K;function F(se,ue){const he=se.indexOf(ue);he>-1&&(se.splice(he,1),se.unshift(ue))}e.pushToStart=F;function M(se,ue){const he=se.indexOf(ue);he>-1&&(se.splice(he,1),se.push(ue))}e.pushToEnd=M;function N(se,ue){for(const he of ue)se.push(he)}e.pushMany=N;function B(se,ue){return Array.isArray(se)?se.map(ue):ue(se)}e.mapArrayOrNot=B;function U(se){return Array.isArray(se)?se:[se]}e.asArray=U;function W(se){return se[Math.floor(Math.random()*se.length)]}e.getRandomElement=W;function x(se,ue){for(const he of se){const ee=ue(he);if(ee!==void 0)return ee}}e.mapFind=x;function V(se,ue,he){const ee=Q(se,ue),oe=se.length,ie=he.length;se.length=oe+ie;for(let O=oe-1;O>=ee;O--)se[O+ie]=se[O];for(let O=0;O<ie;O++)se[O+ee]=he[O]}e.insertInto=V;function X(se,ue,he,ee){const oe=Q(se,ue),ie=se.splice(oe,he);return V(se,oe,ee),ie}e.splice=X;function Q(se,ue){return ue<0?Math.max(ue+se.length,0):Math.min(ue,se.length)}var J;(function(se){function ue(oe){return oe<0}se.isLessThan=ue;function he(oe){return oe>0}se.isGreaterThan=he;function ee(oe){return oe===0}se.isNeitherLessOrGreaterThan=ee,se.greaterThan=1,se.lessThan=-1,se.neitherLessOrGreaterThan=0})(J=e.CompareResult||(e.CompareResult={}));function te(se,ue){return(he,ee)=>ue(se(he),se(ee))}e.compareBy=te;function le(...se){return(ue,he)=>{for(const ee of se){const oe=ee(ue,he);if(!J.isNeitherLessOrGreaterThan(oe))return oe}return J.neitherLessOrGreaterThan}}e.tieBreakComparators=le;const Z=(se,ue)=>se-ue;e.numberComparator=Z;function ge(se,ue){if(se.length===0)return;let he=se[0];for(let ee=1;ee<se.length;ee++){const oe=se[ee];ue(oe,he)>0&&(he=oe)}return he}e.findMaxBy=ge;function ve(se,ue){if(se.length===0)return;let he=se[0];for(let ee=1;ee<se.length;ee++){const oe=se[ee];ue(oe,he)>=0&&(he=oe)}return he}e.findLastMaxBy=ve;function De(se,ue){return ge(se,(he,ee)=>-ue(he,ee))}e.findMinBy=De;class Re{constructor(ue){this.f=ue,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(ue){let he=this.c;for(;he<this.f.length&&ue(this.f[he]);)he++;const ee=he===this.c?null:this.f.slice(this.c,he);return this.c=he,ee}takeFromEndWhile(ue){let he=this.d;for(;he>=0&&ue(this.f[he]);)he--;const ee=he===this.d?null:this.f.slice(he+1,this.d+1);return this.d=he,ee}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const ue=this.f[this.c];return this.c++,ue}removeLast(){const ue=this.f[this.d];return this.d--,ue}takeCount(ue){const he=this.f.slice(this.c,this.c+ue);return this.c+=ue,he}}e.ArrayQueue=Re;class ze{constructor(ue){this.iterate=ue}forEach(ue){this.iterate(he=>(ue(he),!0))}toArray(){const ue=[];return this.iterate(he=>(ue.push(he),!0)),ue}filter(ue){return new ze(he=>this.iterate(ee=>ue(ee)?he(ee):!0))}map(ue){return new ze(he=>this.iterate(ee=>he(ue(ee))))}some(ue){let he=!1;return this.iterate(ee=>(he=ue(ee),!he)),he}findFirst(ue){let he;return this.iterate(ee=>ue(ee)?(he=ee,!1):!0),he}findLast(ue){let he;return this.iterate(ee=>(ue(ee)&&(he=ee),!0)),he}findLastMaxBy(ue){let he,ee=!0;return this.iterate(oe=>((ee||J.isGreaterThan(ue(oe,he)))&&(ee=!1,he=oe),!0)),he}}e.CallbackIterable=ze,ze.empty=new ze(se=>{})}),define(Se[49],ye([1,0,10]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(S,C){if(!S)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=t;function I(S,C="Unreachable"){throw new Error(C)}e.assertNever=I;function A(S){if(!S)throw new a.BugIndicatingError("Assertion Failed")}e.assert=A;function D(S){if(!S()){debugger;S(),(0,a.onUnexpectedError)(new a.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function k(S,C){let R=0;for(;R<S.length-1;){const T=S[R],E=S[R+1];if(!C(T,E))return!1;R++}return!0}e.checkAdjacentItems=k}),define(Se[61],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function a(t){const I=this;let A=!1,D;return function(){return A||(A=!0,D=t.apply(I,arguments)),D}}e.once=a}),define(Se[99],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class a{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=a,e.defaultGenerator=new a("id#")}),define(Se[62],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var a;(function(t){function I(m){return m&&typeof m=="object"&&typeof m[Symbol.iterator]=="function"}t.is=I;const A=Object.freeze([]);function D(){return A}t.empty=D;function*k(m){yield m}t.single=k;function S(m){return I(m)?m:k(m)}t.wrap=S;function C(m){return m||A}t.from=C;function R(m){return!m||m[Symbol.iterator]().next().done===!0}t.isEmpty=R;function T(m){return m[Symbol.iterator]().next().value}t.first=T;function E(m,p){for(const o of m)if(p(o))return!0;return!1}t.some=E;function y(m,p){for(const o of m)if(p(o))return o}t.find=y;function*v(m,p){for(const o of m)p(o)&&(yield o)}t.filter=v;function*d(m,p){let o=0;for(const i of m)yield p(i,o++)}t.map=d;function*b(...m){for(const p of m)for(const o of p)yield o}t.concat=b;function f(m,p,o){let i=o;for(const l of m)i=p(i,l);return i}t.reduce=f;function*w(m,p,o=m.length){for(p<0&&(p+=m.length),o<0?o+=m.length:o>m.length&&(o=m.length);p<o;p++)yield m[p]}t.slice=w;function h(m,p=Number.POSITIVE_INFINITY){const o=[];if(p===0)return[o,m];const i=m[Symbol.iterator]();for(let l=0;l<p;l++){const u=i.next();if(u.done)return[o,t.empty()];o.push(u.value)}return[o,{[Symbol.iterator](){return i}}]}t.consume=h})(a=e.Iterable||(e.Iterable={}))}),define(Se[146],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var a;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(a=e.ScanError||(e.ScanError={}));var t;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(o){o.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function D(o,i=!1){let l=0;const u=o.length;let s="",c=0,n=16,r=0;function g(M){let N=0,B=0;for(;N<M;){const U=o.charCodeAt(l);if(U>=48&&U<=57)B=B*16+U-48;else if(U>=65&&U<=70)B=B*16+U-65+10;else if(U>=97&&U<=102)B=B*16+U-97+10;else break;l++,N++}return N<M&&(B=-1),B}function P(M){l=M,s="",c=0,n=16,r=0}function L(){const M=l;if(o.charCodeAt(l)===48)l++;else for(l++;l<o.length&&C(o.charCodeAt(l));)l++;if(l<o.length&&o.charCodeAt(l)===46)if(l++,l<o.length&&C(o.charCodeAt(l)))for(l++;l<o.length&&C(o.charCodeAt(l));)l++;else return r=3,o.substring(M,l);let N=l;if(l<o.length&&(o.charCodeAt(l)===69||o.charCodeAt(l)===101))if(l++,(l<o.length&&o.charCodeAt(l)===43||o.charCodeAt(l)===45)&&l++,l<o.length&&C(o.charCodeAt(l))){for(l++;l<o.length&&C(o.charCodeAt(l));)l++;N=l}else r=3;return o.substring(M,N)}function z(){let M="",N=l;for(;;){if(l>=u){M+=o.substring(N,l),r=2;break}const B=o.charCodeAt(l);if(B===34){M+=o.substring(N,l),l++;break}if(B===92){if(M+=o.substring(N,l),l++,l>=u){r=2;break}switch(o.charCodeAt(l++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const W=g(4);W>=0?M+=String.fromCharCode(W):r=4;break}default:r=5}N=l;continue}if(B>=0&&B<=31)if(S(B)){M+=o.substring(N,l),r=2;break}else r=6;l++}return M}function _(){if(s="",r=0,c=l,l>=u)return c=u,n=17;let M=o.charCodeAt(l);if(k(M)){do l++,s+=String.fromCharCode(M),M=o.charCodeAt(l);while(k(M));return n=15}if(S(M))return l++,s+=String.fromCharCode(M),M===13&&o.charCodeAt(l)===10&&(l++,s+=`
`),n=14;switch(M){case 123:return l++,n=1;case 125:return l++,n=2;case 91:return l++,n=3;case 93:return l++,n=4;case 58:return l++,n=6;case 44:return l++,n=5;case 34:return l++,s=z(),n=10;case 47:{const N=l-1;if(o.charCodeAt(l+1)===47){for(l+=2;l<u&&!S(o.charCodeAt(l));)l++;return s=o.substring(N,l),n=12}if(o.charCodeAt(l+1)===42){l+=2;const B=u-1;let U=!1;for(;l<B;){if(o.charCodeAt(l)===42&&o.charCodeAt(l+1)===47){l+=2,U=!0;break}l++}return U||(l++,r=1),s=o.substring(N,l),n=13}return s+=String.fromCharCode(M),l++,n=16}case 45:if(s+=String.fromCharCode(M),l++,l===u||!C(o.charCodeAt(l)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=L(),n=11;default:for(;l<u&&K(M);)l++,M=o.charCodeAt(l);if(c!==l){switch(s=o.substring(c,l),s){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return s+=String.fromCharCode(M),l++,n=16}}function K(M){if(k(M)||S(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let M;do M=_();while(M>=12&&M<=15);return M}return{setPosition:P,getPosition:()=>l,scan:i?F:_,getToken:()=>n,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>l-c,getTokenError:()=>r}}e.createScanner=D;function k(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function S(o){return o===10||o===13||o===8232||o===8233}function C(o){return o>=48&&o<=57}var R;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(R||(R={}));function T(o,i){const l=[],u=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function r(g,P,L,z){c.value=g,c.offset=P,c.length=L,c.type=z,c.colonOffset=void 0,s=c}try{h(o,{onObjectBegin:(g,P)=>{if(i<=g)throw u;s=void 0,n=i>g,l.push("")},onObjectProperty:(g,P,L)=>{if(i<P||(r(g,P,L,"property"),l[l.length-1]=g,i<=P+L))throw u},onObjectEnd:(g,P)=>{if(i<=g)throw u;s=void 0,l.pop()},onArrayBegin:(g,P)=>{if(i<=g)throw u;s=void 0,l.push(0)},onArrayEnd:(g,P)=>{if(i<=g)throw u;s=void 0,l.pop()},onLiteralValue:(g,P,L)=>{if(i<P||(r(g,P,L,p(g)),i<=P+L))throw u},onSeparator:(g,P,L)=>{if(i<=P)throw u;if(g===":"&&s&&s.type==="property")s.colonOffset=P,n=!1,s=void 0;else if(g===","){const z=l[l.length-1];typeof z=="number"?l[l.length-1]=z+1:(n=!0,l[l.length-1]=""),s=void 0}}})}catch(g){if(g!==u)throw g}return{path:l,previousNode:s,isAtPropertyKey:n,matches:g=>{let P=0;for(let L=0;P<g.length&&L<l.length;L++)if(g[P]===l[L]||g[P]==="*")P++;else if(g[P]!=="**")return!1;return P===g.length}}}e.getLocation=T;function E(o,i=[],l=A.DEFAULT){let u=null,s=[];const c=[];function n(g){Array.isArray(s)?s.push(g):u!==null&&(s[u]=g)}return h(o,{onObjectBegin:()=>{const g={};n(g),c.push(s),s=g,u=null},onObjectProperty:g=>{u=g},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const g=[];n(g),c.push(s),s=g,u=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:n,onError:(g,P,L)=>{i.push({error:g,offset:P,length:L})}},l),s[0]}e.parse=E;function y(o,i=[],l=A.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(g){u.type==="property"&&(u.length=g-u.offset,u=u.parent)}function c(g){return u.children.push(g),g}h(o,{onObjectBegin:g=>{u=c({type:"object",offset:g,length:-1,parent:u,children:[]})},onObjectProperty:(g,P,L)=>{u=c({type:"property",offset:P,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:g,offset:P,length:L,parent:u})},onObjectEnd:(g,P)=>{u.length=g+P-u.offset,u=u.parent,s(g+P)},onArrayBegin:(g,P)=>{u=c({type:"array",offset:g,length:-1,parent:u,children:[]})},onArrayEnd:(g,P)=>{u.length=g+P-u.offset,u=u.parent,s(g+P)},onLiteralValue:(g,P,L)=>{c({type:p(g),offset:P,length:L,parent:u,value:g}),s(P+L)},onSeparator:(g,P,L)=>{u.type==="property"&&(g===":"?u.colonOffset=P:g===","&&s(P))},onError:(g,P,L)=>{i.push({error:g,offset:P,length:L})}},l);const r=u.children[0];return r&&delete r.parent,r}e.parseTree=y;function v(o,i){if(!o)return;let l=o;for(const u of i)if(typeof u=="string"){if(l.type!=="object"||!Array.isArray(l.children))return;let s=!1;for(const c of l.children)if(Array.isArray(c.children)&&c.children[0].value===u){l=c.children[1],s=!0;break}if(!s)return}else{const s=u;if(l.type!=="array"||s<0||!Array.isArray(l.children)||s>=l.children.length)return;l=l.children[s]}return l}e.findNodeAtLocation=v;function d(o){if(!o.parent||!o.parent.children)return[];const i=d(o.parent);if(o.parent.type==="property"){const l=o.parent.children[0].value;i.push(l)}else if(o.parent.type==="array"){const l=o.parent.children.indexOf(o);l!==-1&&i.push(l)}return i}e.getNodePath=d;function b(o){switch(o.type){case"array":return o.children.map(b);case"object":{const i=Object.create(null);for(const l of o.children){const u=l.children[1];u&&(i[l.children[0].value]=b(u))}return i}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=b;function f(o,i,l=!1){return i>=o.offset&&i<o.offset+o.length||l&&i===o.offset+o.length}e.contains=f;function w(o,i,l=!1){if(f(o,i,l)){const u=o.children;if(Array.isArray(u))for(let s=0;s<u.length&&u[s].offset<=i;s++){const c=w(u[s],i,l);if(c)return c}return o}}e.findNodeAtOffset=w;function h(o,i,l=A.DEFAULT){const u=D(o,!1);function s(te){return te?()=>te(u.getTokenOffset(),u.getTokenLength()):()=>!0}function c(te){return te?le=>te(le,u.getTokenOffset(),u.getTokenLength()):()=>!0}const n=s(i.onObjectBegin),r=c(i.onObjectProperty),g=s(i.onObjectEnd),P=s(i.onArrayBegin),L=s(i.onArrayEnd),z=c(i.onLiteralValue),_=c(i.onSeparator),K=s(i.onComment),F=c(i.onError),M=l&&l.disallowComments,N=l&&l.allowTrailingComma;function B(){for(;;){const te=u.scan();switch(u.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:M||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(te){case 12:case 13:M?U(10):K();break;case 16:U(1);break;case 15:case 14:break;default:return te}}}function U(te,le=[],Z=[]){if(F(te),le.length+Z.length>0){let ge=u.getToken();for(;ge!==17;){if(le.indexOf(ge)!==-1){B();break}else if(Z.indexOf(ge)!==-1)break;ge=B()}}}function W(te){const le=u.getTokenValue();return te?z(le):r(le),B(),!0}function x(){switch(u.getToken()){case 11:{let te=0;try{te=JSON.parse(u.getTokenValue()),typeof te!="number"&&(U(2),te=0)}catch{U(2)}z(te);break}case 7:z(null);break;case 8:z(!0);break;case 9:z(!1);break;default:return!1}return B(),!0}function V(){return u.getToken()!==10?(U(3,[],[2,5]),!1):(W(!1),u.getToken()===6?(_(":"),B(),J()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function X(){n(),B();let te=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(te||U(4,[],[]),_(","),B(),u.getToken()===2&&N)break}else te&&U(6,[],[]);V()||U(4,[],[2,5]),te=!0}return g(),u.getToken()!==2?U(7,[2],[]):B(),!0}function Q(){P(),B();let te=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(te||U(4,[],[]),_(","),B(),u.getToken()===4&&N)break}else te&&U(6,[],[]);J()||U(4,[],[4,5]),te=!0}return L(),u.getToken()!==4?U(8,[4],[]):B(),!0}function J(){switch(u.getToken()){case 3:return Q();case 1:return X();case 10:return W(!0);default:return x()}}return B(),u.getToken()===17?l.allowEmptyContent?!0:(U(4,[],[]),!1):J()?(u.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=h;function m(o,i){const l=D(o),u=[];let s,c=0,n;do switch(n=l.getPosition(),s=l.scan(),s){case 12:case 13:case 17:c!==n&&u.push(o.substring(c,n)),i!==void 0&&u.push(l.getTokenValue().replace(/[^\r\n]/g,i)),c=l.getPosition();break}while(s!==17);return u.join("")}e.stripComments=m;function p(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(Se[81],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class a{constructor(I){this.d=I,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(I){this.c=I}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(I){return new a(()=>I(this.getValue()))}}e.Lazy=a}),define(Se[6],ye([1,0,61,62]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const I=!1;let A=null;function D(c){A=c}if(e.setDisposableTracker=D,I){const c="__is_disposable_tracked__";D(new class{trackDisposable(n){const r=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[c]||console.log(r)},3e3)}setParent(n,r){if(n&&n!==w.None)try{n[c]=!0}catch{}}markAsDisposed(n){if(n&&n!==w.None)try{n[c]=!0}catch{}}markAsSingleton(n){}})}function k(c){return A?.trackDisposable(c),c}function S(c){A?.markAsDisposed(c)}function C(c,n){A?.setParent(c,n)}function R(c,n){if(!!A)for(const r of c)A.setParent(r,n)}function T(c){return A?.markAsSingleton(c),c}e.markAsSingleton=T;function E(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=E;function y(c){if(t.Iterable.is(c)){const n=[];for(const r of c)if(r)try{r.dispose()}catch(g){n.push(g)}if(n.length===1)throw n[0];if(n.length>1)throw new AggregateError(n,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=y;function v(c){for(const n of c)E(n)&&n.dispose();return[]}e.disposeIfDisposable=v;function d(...c){const n=b(()=>y(c));return R(c,n),n}e.combinedDisposable=d;function b(c){const n=k({dispose:(0,a.once)(()=>{S(n),c()})});return n}e.toDisposable=b;class f{constructor(){this.c=new Set,this.f=!1,k(this)}dispose(){this.f||(S(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{y(this.c)}finally{this.c.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return C(n,this),this.f?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(n),n}}e.DisposableStore=f,f.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this.q=new f,k(this),C(this.q,this)}dispose(){S(this),this.q.dispose()}B(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(n)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class h{constructor(){this.b=!1,k(this)}get value(){return this.b?void 0:this.a}set value(n){this.b||n===this.a||(this.a?.dispose(),n&&C(n,this),this.a=n)}clear(){this.value=void 0}dispose(){this.b=!0,S(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const n=this.a;return this.a=void 0,n&&C(n,null),n}}e.MutableDisposable=h;class m{constructor(n){this.b=n,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=m;class p{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(n){let r=n;return this.unset=()=>r=void 0,this.isset=()=>r!==void 0,this.dispose=()=>{r&&(r(),r=void 0,S(this))},this}}e.SafeDisposable=p;class o{constructor(){this.a=new Map}acquire(n,...r){let g=this.a.get(n);g||(g={counter:0,object:this.b(n,...r)},this.a.set(n,g));const{object:P}=g,L=(0,a.once)(()=>{--g.counter===0&&(this.c(n,g.object),this.a.delete(n))});return g.counter++,{object:P,dispose:L}}}e.ReferenceCollection=o;class i{constructor(n){this.a=n}async acquire(n,...r){const g=this.a.acquire(n,...r);try{return{object:await g.object,dispose:()=>g.dispose()}}catch(P){throw g.dispose(),P}}}e.AsyncReferenceCollection=i;class l{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=l;function u(c){const n=new f;try{c(n)}finally{n.dispose()}}e.disposeOnReturn=u;class s{constructor(){this.a=new Map,this.b=!1,k(this)}dispose(){S(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{y(this.a.values())}finally{this.a.clear()}}has(n){return this.a.has(n)}get(n){return this.a.get(n)}set(n,r,g=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),g||this.a.get(n)?.dispose(),this.a.set(n,r)}deleteAndDispose(n){this.a.get(n)?.dispose(),this.a.delete(n)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=s}),define(Se[63],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class a{constructor(A){this.element=A,this.next=a.Undefined,this.prev=a.Undefined}}a.Undefined=new a(void 0);class t{constructor(){this.a=a.Undefined,this.b=a.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===a.Undefined}clear(){let A=this.a;for(;A!==a.Undefined;){const D=A.next;A.prev=a.Undefined,A.next=a.Undefined,A=D}this.a=a.Undefined,this.b=a.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,D){const k=new a(A);if(this.a===a.Undefined)this.a=k,this.b=k;else if(D){const C=this.b;this.b=k,k.prev=C,C.next=k}else{const C=this.a;this.a=k,k.next=C,C.prev=k}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(k))}}shift(){if(this.a!==a.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==a.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==a.Undefined&&A.next!==a.Undefined){const D=A.prev;D.next=A.next,A.next.prev=D}else A.prev===a.Undefined&&A.next===a.Undefined?(this.a=a.Undefined,this.b=a.Undefined):A.next===a.Undefined?(this.b=this.b.prev,this.b.next=a.Undefined):A.prev===a.Undefined&&(this.a=this.a.next,this.a.prev=a.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==a.Undefined;)yield A.element,A=A.next}}e.LinkedList=t}),define(Se[28],ye([1,0]),function(ne,e){"use strict";var a,t,I;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function A(v,d,b){let f=v.get(d);return f===void 0&&(f=b,v.set(d,f)),f}e.getOrSet=A;function D(v){const d=[];return v.forEach((b,f)=>{d.push(`${f} => ${b}`)}),`Map(${v.size}) {${d.join(", ")}}`}e.mapToString=D;function k(v){const d=[];return v.forEach(b=>{d.push(b)}),`Set(${v.size}) {${d.join(", ")}}`}e.setToString=k;class S{constructor(d,b){this.uri=d,this.value=b}}class C{constructor(d,b){this[a]="ResourceMap",d instanceof C?(this.b=new Map(d.b),this.c=b??C.a):(this.b=new Map,this.c=d??C.a)}set(d,b){return this.b.set(this.c(d),new S(d,b)),this}get(d){return this.b.get(this.c(d))?.value}has(d){return this.b.has(this.c(d))}get size(){return this.b.size}clear(){this.b.clear()}delete(d){return this.b.delete(this.c(d))}forEach(d,b){typeof b<"u"&&(d=d.bind(b));for(const[f,w]of this.b)d(w.value,w.uri,this)}*values(){for(const d of this.b.values())yield d.value}*keys(){for(const d of this.b.values())yield d.uri}*entries(){for(const d of this.b.values())yield[d.uri,d.value]}*[(a=Symbol.toStringTag,Symbol.iterator)](){for(const[,d]of this.b)yield[d.uri,d.value]}}e.ResourceMap=C,C.a=v=>v.toString();class R{constructor(d,b){this[t]="ResourceSet",!d||typeof d=="function"?this.a=new C(d):(this.a=new C(b),d.forEach(this.add,this))}get size(){return this.a.size}add(d){return this.a.set(d,d),this}clear(){this.a.clear()}delete(d){return this.a.delete(d)}forEach(d,b){this.a.forEach((f,w)=>d.call(b,w,w,this))}has(d){return this.a.has(d)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=R;var T;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(T=e.Touch||(e.Touch={}));class E{constructor(){this[I]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(d){return this.a.has(d)}get(d,b=0){const f=this.a.get(d);if(!!f)return b!==0&&this.j(f,b),f.value}set(d,b,f=0){let w=this.a.get(d);if(w)w.value=b,f!==0&&this.j(w,f);else{switch(w={key:d,value:b,next:void 0,previous:void 0},f){case 0:this.h(w);break;case 1:this.g(w);break;case 2:this.h(w);break;default:this.h(w);break}this.a.set(d,w),this.d++}return this}delete(d){return!!this.remove(d)}remove(d){const b=this.a.get(d);if(!!b)return this.a.delete(d),this.i(b),this.d--,b.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const d=this.b;return this.a.delete(d.key),this.i(d),this.d--,d.value}forEach(d,b){const f=this.e;let w=this.b;for(;w;){if(b?d.bind(b)(w.value,w.key,this):d(w.value,w.key,this),this.e!==f)throw new Error("LinkedMap got modified during iteration.");w=w.next}}keys(){const d=this,b=this.e;let f=this.b;const w={[Symbol.iterator](){return w},next(){if(d.e!==b)throw new Error("LinkedMap got modified during iteration.");if(f){const h={value:f.key,done:!1};return f=f.next,h}else return{value:void 0,done:!0}}};return w}values(){const d=this,b=this.e;let f=this.b;const w={[Symbol.iterator](){return w},next(){if(d.e!==b)throw new Error("LinkedMap got modified during iteration.");if(f){const h={value:f.value,done:!1};return f=f.next,h}else return{value:void 0,done:!0}}};return w}entries(){const d=this,b=this.e;let f=this.b;const w={[Symbol.iterator](){return w},next(){if(d.e!==b)throw new Error("LinkedMap got modified during iteration.");if(f){const h={value:[f.key,f.value],done:!1};return f=f.next,h}else return{value:void 0,done:!0}}};return w}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(d){if(d>=this.size)return;if(d===0){this.clear();return}let b=this.b,f=this.size;for(;b&&f>d;)this.a.delete(b.key),b=b.next,f--;this.b=b,this.d=f,b&&(b.previous=void 0),this.e++}g(d){if(!this.b&&!this.c)this.c=d;else if(this.b)d.next=this.b,this.b.previous=d;else throw new Error("Invalid list");this.b=d,this.e++}h(d){if(!this.b&&!this.c)this.b=d;else if(this.c)d.previous=this.c,this.c.next=d;else throw new Error("Invalid list");this.c=d,this.e++}i(d){if(d===this.b&&d===this.c)this.b=void 0,this.c=void 0;else if(d===this.b){if(!d.next)throw new Error("Invalid list");d.next.previous=void 0,this.b=d.next}else if(d===this.c){if(!d.previous)throw new Error("Invalid list");d.previous.next=void 0,this.c=d.previous}else{const b=d.next,f=d.previous;if(!b||!f)throw new Error("Invalid list");b.previous=f,f.next=b}d.next=void 0,d.previous=void 0,this.e++}j(d,b){if(!this.b||!this.c)throw new Error("Invalid list");if(!(b!==1&&b!==2)){if(b===1){if(d===this.b)return;const f=d.next,w=d.previous;d===this.c?(w.next=void 0,this.c=w):(f.previous=w,w.next=f),d.previous=void 0,d.next=this.b,this.b.previous=d,this.b=d,this.e++}else if(b===2){if(d===this.c)return;const f=d.next,w=d.previous;d===this.b?(f.previous=void 0,this.b=f):(f.previous=w,w.next=f),d.next=void 0,d.previous=this.c,this.c.next=d,this.c=d,this.e++}}}toJSON(){const d=[];return this.forEach((b,f)=>{d.push([f,b])}),d}fromJSON(d){this.clear();for(const[b,f]of d)this.set(b,f)}}e.LinkedMap=E;class y extends E{constructor(d,b=1){super(),this.k=d,this.l=Math.min(Math.max(0,b),1)}get limit(){return this.k}set limit(d){this.k=d,this.m()}get ratio(){return this.l}set ratio(d){this.l=Math.min(Math.max(0,d),1),this.m()}get(d,b=2){return super.get(d,b)}peek(d){return super.get(d,0)}set(d,b){return super.set(d,b,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=y}),function(ne,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Se[147],ye([0]),e):(ne=typeof globalThis<"u"?globalThis:ne||self,e(ne.marked={}))}(this,function(ne){"use strict";function e(se,ue){for(var he=0;he<ue.length;he++){var ee=ue[he];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(se,ee.key,ee)}}function a(se,ue,he){return ue&&e(se.prototype,ue),he&&e(se,he),Object.defineProperty(se,"prototype",{writable:!1}),se}function t(se,ue){if(!!se){if(typeof se=="string")return I(se,ue);var he=Object.prototype.toString.call(se).slice(8,-1);if(he==="Object"&&se.constructor&&(he=se.constructor.name),he==="Map"||he==="Set")return Array.from(se);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return I(se,ue)}}function I(se,ue){(ue==null||ue>se.length)&&(ue=se.length);for(var he=0,ee=new Array(ue);he<ue;he++)ee[he]=se[he];return ee}function A(se,ue){var he=typeof Symbol<"u"&&se[Symbol.iterator]||se["@@iterator"];if(he)return(he=he.call(se)).next.bind(he);if(Array.isArray(se)||(he=t(se))||ue&&se&&typeof se.length=="number"){he&&(se=he);var ee=0;return function(){return ee>=se.length?{done:!0}:{done:!1,value:se[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=D();function k(se){ne.defaults=se}var S=/[&<>"']/,C=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,E={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(ue){return E[ue]};function v(se,ue){if(ue){if(S.test(se))return se.replace(C,y)}else if(R.test(se))return se.replace(T,y);return se}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function b(se){return se.replace(d,function(ue,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var f=/(^|[^\[])\^/g;function w(se,ue){se=typeof se=="string"?se:se.source,ue=ue||"";var he={replace:function(oe,ie){return ie=ie.source||ie,ie=ie.replace(f,"$1"),se=se.replace(oe,ie),he},getRegex:function(){return new RegExp(se,ue)}};return he}var h=/[^\w:]/g,m=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(se,ue,he){if(se){var ee;try{ee=decodeURIComponent(b(he)).replace(h,"").toLowerCase()}catch{return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}ue&&!m.test(he)&&(he=s(ue,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch{return null}return he}var o={},i=/^[^:]+:\/*[^/]*$/,l=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(se,ue){o[" "+se]||(i.test(se)?o[" "+se]=se+"/":o[" "+se]=g(se,"/",!0)),se=o[" "+se];var he=se.indexOf(":")===-1;return ue.substring(0,2)==="//"?he?ue:se.replace(l,"$1")+ue:ue.charAt(0)==="/"?he?ue:se.replace(u,"$1")+ue:se+ue}var c={exec:function(){}};function n(se){for(var ue=1,he,ee;ue<arguments.length;ue++){he=arguments[ue];for(ee in he)Object.prototype.hasOwnProperty.call(he,ee)&&(se[ee]=he[ee])}return se}function r(se,ue){var he=se.replace(/\|/g,function(ie,O,H){for(var q=!1,Y=O;--Y>=0&&H[Y]==="\\";)q=!q;return q?"|":" |"}),ee=he.split(/ \|/),oe=0;if(ee[0].trim()||ee.shift(),ee.length>0&&!ee[ee.length-1].trim()&&ee.pop(),ee.length>ue)ee.splice(ue);else for(;ee.length<ue;)ee.push("");for(;oe<ee.length;oe++)ee[oe]=ee[oe].trim().replace(/\\\|/g,"|");return ee}function g(se,ue,he){var ee=se.length;if(ee===0)return"";for(var oe=0;oe<ee;){var ie=se.charAt(ee-oe-1);if(ie===ue&&!he)oe++;else if(ie!==ue&&he)oe++;else break}return se.slice(0,ee-oe)}function P(se,ue){if(se.indexOf(ue[1])===-1)return-1;for(var he=se.length,ee=0,oe=0;oe<he;oe++)if(se[oe]==="\\")oe++;else if(se[oe]===ue[0])ee++;else if(se[oe]===ue[1]&&(ee--,ee<0))return oe;return-1}function L(se){se&&se.sanitize&&!se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function z(se,ue){if(ue<1)return"";for(var he="";ue>1;)ue&1&&(he+=se),ue>>=1,se+=se;return he+se}function _(se,ue,he,ee){var oe=ue.href,ie=ue.title?v(ue.title):null,O=se[1].replace(/\\([\[\]])/g,"$1");if(se[0].charAt(0)!=="!"){ee.state.inLink=!0;var H={type:"link",raw:he,href:oe,title:ie,text:O,tokens:ee.inlineTokens(O)};return ee.state.inLink=!1,H}return{type:"image",raw:he,href:oe,title:ie,text:v(O)}}function K(se,ue){var he=se.match(/^(\s+)(?:```)/);if(he===null)return ue;var ee=he[1];return ue.split(`
`).map(function(oe){var ie=oe.match(/^\s+/);if(ie===null)return oe;var O=ie[0];return O.length>=ee.length?oe.slice(ee.length):oe}).join(`
`)}var F=function(){function se(he){this.options=he||ne.defaults}var ue=se.prototype;return ue.space=function(ee){var oe=this.rules.block.newline.exec(ee);if(oe&&oe[0].length>0)return{type:"space",raw:oe[0]}},ue.code=function(ee){var oe=this.rules.block.code.exec(ee);if(oe){var ie=oe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:oe[0],codeBlockStyle:"indented",text:this.options.pedantic?ie:g(ie,`
`)}}},ue.fences=function(ee){var oe=this.rules.block.fences.exec(ee);if(oe){var ie=oe[0],O=K(ie,oe[3]||"");return{type:"code",raw:ie,lang:oe[2]?oe[2].trim():oe[2],text:O}}},ue.heading=function(ee){var oe=this.rules.block.heading.exec(ee);if(oe){var ie=oe[2].trim();if(/#$/.test(ie)){var O=g(ie,"#");(this.options.pedantic||!O||/ $/.test(O))&&(ie=O.trim())}return{type:"heading",raw:oe[0],depth:oe[1].length,text:ie,tokens:this.lexer.inline(ie)}}},ue.hr=function(ee){var oe=this.rules.block.hr.exec(ee);if(oe)return{type:"hr",raw:oe[0]}},ue.blockquote=function(ee){var oe=this.rules.block.blockquote.exec(ee);if(oe){var ie=oe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:oe[0],tokens:this.lexer.blockTokens(ie,[]),text:ie}}},ue.list=function(ee){var oe=this.rules.block.list.exec(ee);if(oe){var ie,O,H,q,Y,de,be,Pe,pe,Ce,ke,je,Ge=oe[1].trim(),et=Ge.length>1,_e={type:"list",raw:"",ordered:et,start:et?+Ge.slice(0,-1):"",loose:!1,items:[]};Ge=et?"\\d{1,9}\\"+Ge.slice(-1):"\\"+Ge,this.options.pedantic&&(Ge=et?Ge:"[*+-]");for(var nt=new RegExp("^( {0,3}"+Ge+")((?:[	 ][^\\n]*)?(?:\\n|$))");ee&&(je=!1,!(!(oe=nt.exec(ee))||this.rules.block.hr.test(ee)));){if(ie=oe[0],ee=ee.substring(ie.length),Pe=oe[2].split(`
`,1)[0],pe=ee.split(`
`,1)[0],this.options.pedantic?(q=2,ke=Pe.trimLeft()):(q=oe[2].search(/[^ ]/),q=q>4?1:q,ke=Pe.slice(q),q+=oe[1].length),de=!1,!Pe&&/^ *$/.test(pe)&&(ie+=pe+`
`,ee=ee.substring(pe.length+1),je=!0),!je)for(var st=new RegExp("^ {0,"+Math.min(3,q-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ht=new RegExp("^ {0,"+Math.min(3,q-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Fe=new RegExp("^ {0,"+Math.min(3,q-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,q-1)+"}#");ee&&(Ce=ee.split(`
`,1)[0],Pe=Ce,this.options.pedantic&&(Pe=Pe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Fe.test(Pe)||it.test(Pe)||st.test(Pe)||ht.test(ee)));){if(Pe.search(/[^ ]/)>=q||!Pe.trim())ke+=`
`+Pe.slice(q);else if(!de)ke+=`
`+Pe;else break;!de&&!Pe.trim()&&(de=!0),ie+=Ce+`
`,ee=ee.substring(Ce.length+1)}_e.loose||(be?_e.loose=!0:/\n *\n *$/.test(ie)&&(be=!0)),this.options.gfm&&(O=/^\[[ xX]\] /.exec(ke),O&&(H=O[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),_e.items.push({type:"list_item",raw:ie,task:!!O,checked:H,loose:!1,text:ke}),_e.raw+=ie}_e.items[_e.items.length-1].raw=ie.trimRight(),_e.items[_e.items.length-1].text=ke.trimRight(),_e.raw=_e.raw.trimRight();var ae=_e.items.length;for(Y=0;Y<ae;Y++){this.lexer.state.top=!1,_e.items[Y].tokens=this.lexer.blockTokens(_e.items[Y].text,[]);var $=_e.items[Y].tokens.filter(function(Ie){return Ie.type==="space"}),ce=$.every(function(Ie){for(var Le=Ie.raw.split(""),Be=0,xe=A(Le),Ze;!(Ze=xe()).done;){var mt=Ze.value;if(mt===`
`&&(Be+=1),Be>1)return!0}return!1});!_e.loose&&$.length&&ce&&(_e.loose=!0,_e.items[Y].loose=!0)}return _e}},ue.html=function(ee){var oe=this.rules.block.html.exec(ee);if(oe){var ie={type:"html",raw:oe[0],pre:!this.options.sanitizer&&(oe[1]==="pre"||oe[1]==="script"||oe[1]==="style"),text:oe[0]};if(this.options.sanitize){var O=this.options.sanitizer?this.options.sanitizer(oe[0]):v(oe[0]);ie.type="paragraph",ie.text=O,ie.tokens=this.lexer.inline(O)}return ie}},ue.def=function(ee){var oe=this.rules.block.def.exec(ee);if(oe){oe[3]&&(oe[3]=oe[3].substring(1,oe[3].length-1));var ie=oe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ie,raw:oe[0],href:oe[2],title:oe[3]}}},ue.table=function(ee){var oe=this.rules.block.table.exec(ee);if(oe){var ie={type:"table",header:r(oe[1]).map(function(be){return{text:be}}),align:oe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:oe[3]&&oe[3].trim()?oe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ie.header.length===ie.align.length){ie.raw=oe[0];var O=ie.align.length,H,q,Y,de;for(H=0;H<O;H++)/^ *-+: *$/.test(ie.align[H])?ie.align[H]="right":/^ *:-+: *$/.test(ie.align[H])?ie.align[H]="center":/^ *:-+ *$/.test(ie.align[H])?ie.align[H]="left":ie.align[H]=null;for(O=ie.rows.length,H=0;H<O;H++)ie.rows[H]=r(ie.rows[H],ie.header.length).map(function(be){return{text:be}});for(O=ie.header.length,q=0;q<O;q++)ie.header[q].tokens=this.lexer.inline(ie.header[q].text);for(O=ie.rows.length,q=0;q<O;q++)for(de=ie.rows[q],Y=0;Y<de.length;Y++)de[Y].tokens=this.lexer.inline(de[Y].text);return ie}}},ue.lheading=function(ee){var oe=this.rules.block.lheading.exec(ee);if(oe)return{type:"heading",raw:oe[0],depth:oe[2].charAt(0)==="="?1:2,text:oe[1],tokens:this.lexer.inline(oe[1])}},ue.paragraph=function(ee){var oe=this.rules.block.paragraph.exec(ee);if(oe){var ie=oe[1].charAt(oe[1].length-1)===`
`?oe[1].slice(0,-1):oe[1];return{type:"paragraph",raw:oe[0],text:ie,tokens:this.lexer.inline(ie)}}},ue.text=function(ee){var oe=this.rules.block.text.exec(ee);if(oe)return{type:"text",raw:oe[0],text:oe[0],tokens:this.lexer.inline(oe[0])}},ue.escape=function(ee){var oe=this.rules.inline.escape.exec(ee);if(oe)return{type:"escape",raw:oe[0],text:v(oe[1])}},ue.tag=function(ee){var oe=this.rules.inline.tag.exec(ee);if(oe)return!this.lexer.state.inLink&&/^<a /i.test(oe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(oe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(oe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(oe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:oe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):v(oe[0]):oe[0]}},ue.link=function(ee){var oe=this.rules.inline.link.exec(ee);if(oe){var ie=oe[2].trim();if(!this.options.pedantic&&/^</.test(ie)){if(!/>$/.test(ie))return;var O=g(ie.slice(0,-1),"\\");if((ie.length-O.length)%2===0)return}else{var H=P(oe[2],"()");if(H>-1){var q=oe[0].indexOf("!")===0?5:4,Y=q+oe[1].length+H;oe[2]=oe[2].substring(0,H),oe[0]=oe[0].substring(0,Y).trim(),oe[3]=""}}var de=oe[2],be="";if(this.options.pedantic){var Pe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(de);Pe&&(de=Pe[1],be=Pe[3])}else be=oe[3]?oe[3].slice(1,-1):"";return de=de.trim(),/^</.test(de)&&(this.options.pedantic&&!/>$/.test(ie)?de=de.slice(1):de=de.slice(1,-1)),_(oe,{href:de&&de.replace(this.rules.inline._escapes,"$1"),title:be&&be.replace(this.rules.inline._escapes,"$1")},oe[0],this.lexer)}},ue.reflink=function(ee,oe){var ie;if((ie=this.rules.inline.reflink.exec(ee))||(ie=this.rules.inline.nolink.exec(ee))){var O=(ie[2]||ie[1]).replace(/\s+/g," ");if(O=oe[O.toLowerCase()],!O||!O.href){var H=ie[0].charAt(0);return{type:"text",raw:H,text:H}}return _(ie,O,ie[0],this.lexer)}},ue.emStrong=function(ee,oe,ie){ie===void 0&&(ie="");var O=this.rules.inline.emStrong.lDelim.exec(ee);if(!!O&&!(O[3]&&ie.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var H=O[1]||O[2]||"";if(!H||H&&(ie===""||this.rules.inline.punctuation.exec(ie))){var q=O[0].length-1,Y,de,be=q,Pe=0,pe=O[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(pe.lastIndex=0,oe=oe.slice(-1*ee.length+q);(O=pe.exec(oe))!=null;)if(Y=O[1]||O[2]||O[3]||O[4]||O[5]||O[6],!!Y){if(de=Y.length,O[3]||O[4]){be+=de;continue}else if((O[5]||O[6])&&q%3&&!((q+de)%3)){Pe+=de;continue}if(be-=de,!(be>0)){if(de=Math.min(de,de+be+Pe),Math.min(q,de)%2){var Ce=ee.slice(1,q+O.index+de);return{type:"em",raw:ee.slice(0,q+O.index+de+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var ke=ee.slice(2,q+O.index+de-1);return{type:"strong",raw:ee.slice(0,q+O.index+de+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}}}}},ue.codespan=function(ee){var oe=this.rules.inline.code.exec(ee);if(oe){var ie=oe[2].replace(/\n/g," "),O=/[^ ]/.test(ie),H=/^ /.test(ie)&&/ $/.test(ie);return O&&H&&(ie=ie.substring(1,ie.length-1)),ie=v(ie,!0),{type:"codespan",raw:oe[0],text:ie}}},ue.br=function(ee){var oe=this.rules.inline.br.exec(ee);if(oe)return{type:"br",raw:oe[0]}},ue.del=function(ee){var oe=this.rules.inline.del.exec(ee);if(oe)return{type:"del",raw:oe[0],text:oe[2],tokens:this.lexer.inlineTokens(oe[2])}},ue.autolink=function(ee,oe){var ie=this.rules.inline.autolink.exec(ee);if(ie){var O,H;return ie[2]==="@"?(O=v(this.options.mangle?oe(ie[1]):ie[1]),H="mailto:"+O):(O=v(ie[1]),H=O),{type:"link",raw:ie[0],text:O,href:H,tokens:[{type:"text",raw:O,text:O}]}}},ue.url=function(ee,oe){var ie;if(ie=this.rules.inline.url.exec(ee)){var O,H;if(ie[2]==="@")O=v(this.options.mangle?oe(ie[0]):ie[0]),H="mailto:"+O;else{var q;do q=ie[0],ie[0]=this.rules.inline._backpedal.exec(ie[0])[0];while(q!==ie[0]);O=v(ie[0]),ie[1]==="www."?H="http://"+O:H=O}return{type:"link",raw:ie[0],text:O,href:H,tokens:[{type:"text",raw:O,text:O}]}}},ue.inlineText=function(ee,oe){var ie=this.rules.inline.text.exec(ee);if(ie){var O;return this.lexer.state.inRawBlock?O=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):v(ie[0]):ie[0]:O=v(this.options.smartypants?oe(ie[0]):ie[0]),{type:"text",raw:ie[0],text:O}}},se}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:c,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=w(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=w(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=w(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=w(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=w(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=w(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=n({},M),M.gfm=n({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=w(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=w(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=n({},M.normal,{html:w(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:c,paragraph:w(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:c,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:c,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=w(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=w(M._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=w(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=w(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=w(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=w(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=w(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=w(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=w(N.reflink).replace("label",N._label).replace("ref",M._label).getRegex(),N.nolink=w(N.nolink).replace("ref",M._label).getRegex(),N.reflinkSearch=w(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=n({},N),N.pedantic=n({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:w(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:w(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=n({},N.normal,{escape:w(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=w(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=n({},N.gfm,{br:w(N.br).replace("{2,}","*").getRegex(),text:w(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function B(se){return se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(se){var ue="",he,ee,oe=se.length;for(he=0;he<oe;he++)ee=se.charCodeAt(he),Math.random()>.5&&(ee="x"+ee.toString(16)),ue+="&#"+ee+";";return ue}var W=function(){function se(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||ne.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:M.normal,inline:N.normal};this.options.pedantic?(ee.block=M.pedantic,ee.inline=N.pedantic):this.options.gfm&&(ee.block=M.gfm,this.options.breaks?ee.inline=N.breaks:ee.inline=N.gfm),this.tokenizer.rules=ee}se.lex=function(ee,oe){var ie=new se(oe);return ie.lex(ee)},se.lexInline=function(ee,oe){var ie=new se(oe);return ie.inlineTokens(ee)};var ue=se.prototype;return ue.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`),this.blockTokens(ee,this.tokens);for(var oe;oe=this.inlineQueue.shift();)this.inlineTokens(oe.src,oe.tokens);return this.tokens},ue.blockTokens=function(ee,oe){var ie=this;oe===void 0&&(oe=[]),this.options.pedantic?ee=ee.replace(/\t/g,"    ").replace(/^ +$/gm,""):ee=ee.replace(/^( *)(\t+)/gm,function(be,Pe,pe){return Pe+"    ".repeat(pe.length)});for(var O,H,q,Y;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(be){return(O=be.call({lexer:ie},ee,oe))?(ee=ee.substring(O.raw.length),oe.push(O),!0):!1}))){if(O=this.tokenizer.space(ee)){ee=ee.substring(O.raw.length),O.raw.length===1&&oe.length>0?oe[oe.length-1].raw+=`
`:oe.push(O);continue}if(O=this.tokenizer.code(ee)){ee=ee.substring(O.raw.length),H=oe[oe.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+O.raw,H.text+=`
`+O.text,this.inlineQueue[this.inlineQueue.length-1].src=H.text):oe.push(O);continue}if(O=this.tokenizer.fences(ee)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(O=this.tokenizer.heading(ee)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(O=this.tokenizer.hr(ee)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(O=this.tokenizer.blockquote(ee)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(O=this.tokenizer.list(ee)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(O=this.tokenizer.html(ee)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(O=this.tokenizer.def(ee)){ee=ee.substring(O.raw.length),H=oe[oe.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+O.raw,H.text+=`
`+O.raw,this.inlineQueue[this.inlineQueue.length-1].src=H.text):this.tokens.links[O.tag]||(this.tokens.links[O.tag]={href:O.href,title:O.title});continue}if(O=this.tokenizer.table(ee)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(O=this.tokenizer.lheading(ee)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(q=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var be=1/0,Pe=ee.slice(1),pe=void 0;ie.options.extensions.startBlock.forEach(function(Ce){pe=Ce.call({lexer:this},Pe),typeof pe=="number"&&pe>=0&&(be=Math.min(be,pe))}),be<1/0&&be>=0&&(q=ee.substring(0,be+1))}(),this.state.top&&(O=this.tokenizer.paragraph(q))){H=oe[oe.length-1],Y&&H.type==="paragraph"?(H.raw+=`
`+O.raw,H.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):oe.push(O),Y=q.length!==ee.length,ee=ee.substring(O.raw.length);continue}if(O=this.tokenizer.text(ee)){ee=ee.substring(O.raw.length),H=oe[oe.length-1],H&&H.type==="text"?(H.raw+=`
`+O.raw,H.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):oe.push(O);continue}if(ee){var de="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(de);break}else throw new Error(de)}}return this.state.top=!0,oe},ue.inline=function(ee,oe){return oe===void 0&&(oe=[]),this.inlineQueue.push({src:ee,tokens:oe}),oe},ue.inlineTokens=function(ee,oe){var ie=this;oe===void 0&&(oe=[]);var O,H,q,Y=ee,de,be,Pe;if(this.tokens.links){var pe=Object.keys(this.tokens.links);if(pe.length>0)for(;(de=this.tokenizer.rules.inline.reflinkSearch.exec(Y))!=null;)pe.includes(de[0].slice(de[0].lastIndexOf("[")+1,-1))&&(Y=Y.slice(0,de.index)+"["+z("a",de[0].length-2)+"]"+Y.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(de=this.tokenizer.rules.inline.blockSkip.exec(Y))!=null;)Y=Y.slice(0,de.index)+"["+z("a",de[0].length-2)+"]"+Y.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(de=this.tokenizer.rules.inline.escapedEmSt.exec(Y))!=null;)Y=Y.slice(0,de.index)+"++"+Y.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(be||(Pe=""),be=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ke){return(O=ke.call({lexer:ie},ee,oe))?(ee=ee.substring(O.raw.length),oe.push(O),!0):!1}))){if(O=this.tokenizer.escape(ee)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(O=this.tokenizer.tag(ee)){ee=ee.substring(O.raw.length),H=oe[oe.length-1],H&&O.type==="text"&&H.type==="text"?(H.raw+=O.raw,H.text+=O.text):oe.push(O);continue}if(O=this.tokenizer.link(ee)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(O=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(O.raw.length),H=oe[oe.length-1],H&&O.type==="text"&&H.type==="text"?(H.raw+=O.raw,H.text+=O.text):oe.push(O);continue}if(O=this.tokenizer.emStrong(ee,Y,Pe)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(O=this.tokenizer.codespan(ee)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(O=this.tokenizer.br(ee)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(O=this.tokenizer.del(ee)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(O=this.tokenizer.autolink(ee,U)){ee=ee.substring(O.raw.length),oe.push(O);continue}if(!this.state.inLink&&(O=this.tokenizer.url(ee,U))){ee=ee.substring(O.raw.length),oe.push(O);continue}if(q=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var ke=1/0,je=ee.slice(1),Ge=void 0;ie.options.extensions.startInline.forEach(function(et){Ge=et.call({lexer:this},je),typeof Ge=="number"&&Ge>=0&&(ke=Math.min(ke,Ge))}),ke<1/0&&ke>=0&&(q=ee.substring(0,ke+1))}(),O=this.tokenizer.inlineText(q,B)){ee=ee.substring(O.raw.length),O.raw.slice(-1)!=="_"&&(Pe=O.raw.slice(-1)),be=!0,H=oe[oe.length-1],H&&H.type==="text"?(H.raw+=O.raw,H.text+=O.text):oe.push(O);continue}if(ee){var Ce="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return oe},a(se,null,[{key:"rules",get:function(){return{block:M,inline:N}}}]),se}(),x=function(){function se(he){this.options=he||ne.defaults}var ue=se.prototype;return ue.code=function(ee,oe,ie){var O=(oe||"").match(/\S*/)[0];if(this.options.highlight){var H=this.options.highlight(ee,O);H!=null&&H!==ee&&(ie=!0,ee=H)}return ee=ee.replace(/\n$/,"")+`
`,O?'<pre><code class="'+this.options.langPrefix+v(O,!0)+'">'+(ie?ee:v(ee,!0))+`</code></pre>
`:"<pre><code>"+(ie?ee:v(ee,!0))+`</code></pre>
`},ue.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},ue.html=function(ee){return ee},ue.heading=function(ee,oe,ie,O){if(this.options.headerIds){var H=this.options.headerPrefix+O.slug(ie);return"<h"+oe+' id="'+H+'">'+ee+"</h"+oe+`>
`}return"<h"+oe+">"+ee+"</h"+oe+`>
`},ue.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ue.list=function(ee,oe,ie){var O=oe?"ol":"ul",H=oe&&ie!==1?' start="'+ie+'"':"";return"<"+O+H+`>
`+ee+"</"+O+`>
`},ue.listitem=function(ee){return"<li>"+ee+`</li>
`},ue.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ue.paragraph=function(ee){return"<p>"+ee+`</p>
`},ue.table=function(ee,oe){return oe&&(oe="<tbody>"+oe+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+oe+`</table>
`},ue.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},ue.tablecell=function(ee,oe){var ie=oe.header?"th":"td",O=oe.align?"<"+ie+' align="'+oe.align+'">':"<"+ie+">";return O+ee+("</"+ie+`>
`)},ue.strong=function(ee){return"<strong>"+ee+"</strong>"},ue.em=function(ee){return"<em>"+ee+"</em>"},ue.codespan=function(ee){return"<code>"+ee+"</code>"},ue.br=function(){return this.options.xhtml?"<br/>":"<br>"},ue.del=function(ee){return"<del>"+ee+"</del>"},ue.link=function(ee,oe,ie){if(ee=p(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ie;var O='<a href="'+v(ee)+'"';return oe&&(O+=' title="'+oe+'"'),O+=">"+ie+"</a>",O},ue.image=function(ee,oe,ie){if(ee=p(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ie;var O='<img src="'+ee+'" alt="'+ie+'"';return oe&&(O+=' title="'+oe+'"'),O+=this.options.xhtml?"/>":">",O},ue.text=function(ee){return ee},se}(),V=function(){function se(){}var ue=se.prototype;return ue.strong=function(ee){return ee},ue.em=function(ee){return ee},ue.codespan=function(ee){return ee},ue.del=function(ee){return ee},ue.html=function(ee){return ee},ue.text=function(ee){return ee},ue.link=function(ee,oe,ie){return""+ie},ue.image=function(ee,oe,ie){return""+ie},ue.br=function(){return""},se}(),X=function(){function se(){this.seen={}}var ue=se.prototype;return ue.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ue.getNextSafeSlug=function(ee,oe){var ie=ee,O=0;if(this.seen.hasOwnProperty(ie)){O=this.seen[ee];do O++,ie=ee+"-"+O;while(this.seen.hasOwnProperty(ie))}return oe||(this.seen[ee]=O,this.seen[ie]=0),ie},ue.slug=function(ee,oe){oe===void 0&&(oe={});var ie=this.serialize(ee);return this.getNextSafeSlug(ie,oe.dryrun)},se}(),Q=function(){function se(he){this.options=he||ne.defaults,this.options.renderer=this.options.renderer||new x,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new V,this.slugger=new X}se.parse=function(ee,oe){var ie=new se(oe);return ie.parse(ee)},se.parseInline=function(ee,oe){var ie=new se(oe);return ie.parseInline(ee)};var ue=se.prototype;return ue.parse=function(ee,oe){oe===void 0&&(oe=!0);var ie="",O,H,q,Y,de,be,Pe,pe,Ce,ke,je,Ge,et,_e,nt,st,ht,Fe,it,ae=ee.length;for(O=0;O<ae;O++){if(ke=ee[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(it=this.options.extensions.renderers[ke.type].call({parser:this},ke),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ke.type))){ie+=it||"";continue}switch(ke.type){case"space":continue;case"hr":{ie+=this.renderer.hr();continue}case"heading":{ie+=this.renderer.heading(this.parseInline(ke.tokens),ke.depth,b(this.parseInline(ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{ie+=this.renderer.code(ke.text,ke.lang,ke.escaped);continue}case"table":{for(pe="",Pe="",Y=ke.header.length,H=0;H<Y;H++)Pe+=this.renderer.tablecell(this.parseInline(ke.header[H].tokens),{header:!0,align:ke.align[H]});for(pe+=this.renderer.tablerow(Pe),Ce="",Y=ke.rows.length,H=0;H<Y;H++){for(be=ke.rows[H],Pe="",de=be.length,q=0;q<de;q++)Pe+=this.renderer.tablecell(this.parseInline(be[q].tokens),{header:!1,align:ke.align[q]});Ce+=this.renderer.tablerow(Pe)}ie+=this.renderer.table(pe,Ce);continue}case"blockquote":{Ce=this.parse(ke.tokens),ie+=this.renderer.blockquote(Ce);continue}case"list":{for(je=ke.ordered,Ge=ke.start,et=ke.loose,Y=ke.items.length,Ce="",H=0;H<Y;H++)nt=ke.items[H],st=nt.checked,ht=nt.task,_e="",nt.task&&(Fe=this.renderer.checkbox(st),et?nt.tokens.length>0&&nt.tokens[0].type==="paragraph"?(nt.tokens[0].text=Fe+" "+nt.tokens[0].text,nt.tokens[0].tokens&&nt.tokens[0].tokens.length>0&&nt.tokens[0].tokens[0].type==="text"&&(nt.tokens[0].tokens[0].text=Fe+" "+nt.tokens[0].tokens[0].text)):nt.tokens.unshift({type:"text",text:Fe}):_e+=Fe),_e+=this.parse(nt.tokens,et),Ce+=this.renderer.listitem(_e,ht,st);ie+=this.renderer.list(Ce,je,Ge);continue}case"html":{ie+=this.renderer.html(ke.text);continue}case"paragraph":{ie+=this.renderer.paragraph(this.parseInline(ke.tokens));continue}case"text":{for(Ce=ke.tokens?this.parseInline(ke.tokens):ke.text;O+1<ae&&ee[O+1].type==="text";)ke=ee[++O],Ce+=`
`+(ke.tokens?this.parseInline(ke.tokens):ke.text);ie+=oe?this.renderer.paragraph(Ce):Ce;continue}default:{var $='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error($);return}else throw new Error($)}}}return ie},ue.parseInline=function(ee,oe){oe=oe||this.renderer;var ie="",O,H,q,Y=ee.length;for(O=0;O<Y;O++){if(H=ee[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(q=this.options.extensions.renderers[H.type].call({parser:this},H),q!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(H.type))){ie+=q||"";continue}switch(H.type){case"escape":{ie+=oe.text(H.text);break}case"html":{ie+=oe.html(H.text);break}case"link":{ie+=oe.link(H.href,H.title,this.parseInline(H.tokens,oe));break}case"image":{ie+=oe.image(H.href,H.title,H.text);break}case"strong":{ie+=oe.strong(this.parseInline(H.tokens,oe));break}case"em":{ie+=oe.em(this.parseInline(H.tokens,oe));break}case"codespan":{ie+=oe.codespan(H.text);break}case"br":{ie+=oe.br();break}case"del":{ie+=oe.del(this.parseInline(H.tokens,oe));break}case"text":{ie+=oe.text(H.text);break}default:{var de='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(de);return}else throw new Error(de)}}}return ie},se}();function J(se,ue,he){if(typeof se>"u"||se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");if(typeof ue=="function"&&(he=ue,ue=null),ue=n({},J.defaults,ue||{}),L(ue),he){var ee=ue.highlight,oe;try{oe=W.lex(se,ue)}catch(Y){return he(Y)}var ie=function(de){var be;if(!de)try{ue.walkTokens&&J.walkTokens(oe,ue.walkTokens),be=Q.parse(oe,ue)}catch(Pe){de=Pe}return ue.highlight=ee,de?he(de):he(null,be)};if(!ee||ee.length<3||(delete ue.highlight,!oe.length))return ie();var O=0;J.walkTokens(oe,function(Y){Y.type==="code"&&(O++,setTimeout(function(){ee(Y.text,Y.lang,function(de,be){if(de)return ie(de);be!=null&&be!==Y.text&&(Y.text=be,Y.escaped=!0),O--,O===0&&ie()})},0))}),O===0&&ie();return}function H(Y){if(Y.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+v(Y.message+"",!0)+"</pre>";throw Y}try{var q=W.lex(se,ue);if(ue.walkTokens){if(ue.async)return Promise.all(J.walkTokens(q,ue.walkTokens)).then(function(){return Q.parse(q,ue)}).catch(H);J.walkTokens(q,ue.walkTokens)}return Q.parse(q,ue)}catch(Y){H(Y)}}J.options=J.setOptions=function(se){return n(J.defaults,se),k(J.defaults),J},J.getDefaults=D,J.defaults=ne.defaults,J.use=function(){for(var se=arguments.length,ue=new Array(se),he=0;he<se;he++)ue[he]=arguments[he];var ee=n.apply(void 0,[{}].concat(ue)),oe=J.defaults.extensions||{renderers:{},childTokens:{}},ie;ue.forEach(function(O){if(O.extensions&&(ie=!0,O.extensions.forEach(function(q){if(!q.name)throw new Error("extension name required");if(q.renderer){var Y=oe.renderers?oe.renderers[q.name]:null;Y?oe.renderers[q.name]=function(){for(var de=arguments.length,be=new Array(de),Pe=0;Pe<de;Pe++)be[Pe]=arguments[Pe];var pe=q.renderer.apply(this,be);return pe===!1&&(pe=Y.apply(this,be)),pe}:oe.renderers[q.name]=q.renderer}if(q.tokenizer){if(!q.level||q.level!=="block"&&q.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");oe[q.level]?oe[q.level].unshift(q.tokenizer):oe[q.level]=[q.tokenizer],q.start&&(q.level==="block"?oe.startBlock?oe.startBlock.push(q.start):oe.startBlock=[q.start]:q.level==="inline"&&(oe.startInline?oe.startInline.push(q.start):oe.startInline=[q.start]))}q.childTokens&&(oe.childTokens[q.name]=q.childTokens)})),O.renderer&&function(){var q=J.defaults.renderer||new x,Y=function(Pe){var pe=q[Pe];q[Pe]=function(){for(var Ce=arguments.length,ke=new Array(Ce),je=0;je<Ce;je++)ke[je]=arguments[je];var Ge=O.renderer[Pe].apply(q,ke);return Ge===!1&&(Ge=pe.apply(q,ke)),Ge}};for(var de in O.renderer)Y(de);ee.renderer=q}(),O.tokenizer&&function(){var q=J.defaults.tokenizer||new F,Y=function(Pe){var pe=q[Pe];q[Pe]=function(){for(var Ce=arguments.length,ke=new Array(Ce),je=0;je<Ce;je++)ke[je]=arguments[je];var Ge=O.tokenizer[Pe].apply(q,ke);return Ge===!1&&(Ge=pe.apply(q,ke)),Ge}};for(var de in O.tokenizer)Y(de);ee.tokenizer=q}(),O.walkTokens){var H=J.defaults.walkTokens;ee.walkTokens=function(q){var Y=[];return Y.push(O.walkTokens.call(this,q)),H&&(Y=Y.concat(H.call(this,q))),Y}}ie&&(ee.extensions=oe),J.setOptions(ee)})},J.walkTokens=function(se,ue){for(var he=[],ee=function(){var H=ie.value;switch(he=he.concat(ue.call(J,H)),H.type){case"table":{for(var q=A(H.header),Y;!(Y=q()).done;){var de=Y.value;he=he.concat(J.walkTokens(de.tokens,ue))}for(var be=A(H.rows),Pe;!(Pe=be()).done;)for(var pe=Pe.value,Ce=A(pe),ke;!(ke=Ce()).done;){var je=ke.value;he=he.concat(J.walkTokens(je.tokens,ue))}break}case"list":{he=he.concat(J.walkTokens(H.items,ue));break}default:J.defaults.extensions&&J.defaults.extensions.childTokens&&J.defaults.extensions.childTokens[H.type]?J.defaults.extensions.childTokens[H.type].forEach(function(Ge){he=he.concat(J.walkTokens(H[Ge],ue))}):H.tokens&&(he=he.concat(J.walkTokens(H.tokens,ue)))}},oe=A(se),ie;!(ie=oe()).done;)ee();return he},J.parseInline=function(se,ue){if(typeof se>"u"||se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(se)+", string expected");ue=n({},J.defaults,ue||{}),L(ue);try{var he=W.lexInline(se,ue);return ue.walkTokens&&J.walkTokens(he,ue.walkTokens),Q.parseInline(he,ue)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+v(ee.message+"",!0)+"</pre>";throw ee}},J.Parser=Q,J.parser=Q.parse,J.Renderer=x,J.TextRenderer=V,J.Lexer=W,J.lexer=W.lex,J.Tokenizer=F,J.Slugger=X,J.parse=J;var te=J.options,le=J.setOptions,Z=J.use,ge=J.walkTokens,ve=J.parseInline,De=J,Re=Q.parse,ze=W.lex;ne.Lexer=W,ne.Parser=Q,ne.Renderer=x,ne.Slugger=X,ne.TextRenderer=V,ne.Tokenizer=F,ne.getDefaults=D,ne.lexer=ze,ne.marked=J,ne.options=te,ne.parse=De,ne.parseInline=ve,ne.parser=Re,ne.setOptions=le,ne.use=Z,ne.walkTokens=ge,Object.defineProperty(ne,"__esModule",{value:!0})}),define(Se[82],ye([1,0,28]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new a.LRUCache(1e4);function I(C){return S(C,"NFC",t)}e.normalizeNFC=I;const A=new a.LRUCache(1e4);function D(C){return S(C,"NFD",A)}e.normalizeNFD=D;const k=/[^\u0000-\u0080]/;function S(C,R,T){if(!C)return C;const E=T.get(C);if(E)return E;let y;return k.test(C)?y=C.normalize(R):y=C,T.set(C,y),y}e.removeAccents=function(){const C=/[\u0300-\u036f]/g;return function(R){return D(R).replace(C,"")}}()}),define(Se[100],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function a(k,S,C){return Math.min(Math.max(k,S),C)}e.clamp=a;function t(k,S){return(S+k%S)%S}e.rot=t;class I{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=I;class A{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=A;class D{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const C=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=C,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=D}),function(){function ne(I){const A=[];typeof I=="number"&&A.push("code/timeOrigin",I);function D(S){A.push(S,Date.now())}function k(){const S=[];for(let C=0;C<A.length;C+=2)S.push({name:A[C],startTime:A[C+1]});return S}return{mark:D,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const D of performance.getEntriesByType("mark"))A.push({name:D.name,startTime:Math.round(I+D.startTime)});return A}};if(typeof process=="object"){const I=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function a(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=a(t))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var a=e();for(var t in a)(typeof exports=="object"?exports:ne)[t]=a[t]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function a(t){if(e[t])return e[t].exports;var I=e[t]={i:t,l:!1,exports:{}};return ne[t].call(I.exports,I,I.exports,a),I.l=!0,I.exports}return a.m=ne,a.c=e,a.d=function(t,I,A){a.o(t,I)||Object.defineProperty(t,I,{enumerable:!0,get:A})},a.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},a.t=function(t,I){if(1&I&&(t=a(t)),8&I||4&I&&typeof t=="object"&&t&&t.__esModule)return t;var A=Object.create(null);if(a.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:t}),2&I&&typeof t!="string")for(var D in t)a.d(A,D,function(k){return t[k]}.bind(null,D));return A},a.n=function(t){var I=t&&t.__esModule?function(){return t.default}:function(){return t};return a.d(I,"a",I),I},a.o=function(t,I){return Object.prototype.hasOwnProperty.call(t,I)},a.p="",a(a.s=0)}([function(ne,e,a){(function(t){var I;e=ne.exports=Z,I=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var pe=Array.prototype.slice.call(arguments,0);pe.unshift("SEMVER"),console.log.apply(console,pe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],S=e.src=[],C=0,R=C++;S[R]="0|[1-9]\\d*";var T=C++;S[T]="[0-9]+";var E=C++;S[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=C++;S[y]="("+S[R]+")\\.("+S[R]+")\\.("+S[R]+")";var v=C++;S[v]="("+S[T]+")\\.("+S[T]+")\\.("+S[T]+")";var d=C++;S[d]="(?:"+S[R]+"|"+S[E]+")";var b=C++;S[b]="(?:"+S[T]+"|"+S[E]+")";var f=C++;S[f]="(?:-("+S[d]+"(?:\\."+S[d]+")*))";var w=C++;S[w]="(?:-?("+S[b]+"(?:\\."+S[b]+")*))";var h=C++;S[h]="[0-9A-Za-z-]+";var m=C++;S[m]="(?:\\+("+S[h]+"(?:\\."+S[h]+")*))";var p=C++,o="v?"+S[y]+S[f]+"?"+S[m]+"?";S[p]="^"+o+"$";var i="[v=\\s]*"+S[v]+S[w]+"?"+S[m]+"?",l=C++;S[l]="^"+i+"$";var u=C++;S[u]="((?:<|>)?=?)";var s=C++;S[s]=S[T]+"|x|X|\\*";var c=C++;S[c]=S[R]+"|x|X|\\*";var n=C++;S[n]="[v=\\s]*("+S[c]+")(?:\\.("+S[c]+")(?:\\.("+S[c]+")(?:"+S[f]+")?"+S[m]+"?)?)?";var r=C++;S[r]="[v=\\s]*("+S[s]+")(?:\\.("+S[s]+")(?:\\.("+S[s]+")(?:"+S[w]+")?"+S[m]+"?)?)?";var g=C++;S[g]="^"+S[u]+"\\s*"+S[n]+"$";var P=C++;S[P]="^"+S[u]+"\\s*"+S[r]+"$";var L=C++;S[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var z=C++;S[z]="(?:~>?)";var _=C++;S[_]="(\\s*)"+S[z]+"\\s+",k[_]=new RegExp(S[_],"g");var K=C++;S[K]="^"+S[z]+S[n]+"$";var F=C++;S[F]="^"+S[z]+S[r]+"$";var M=C++;S[M]="(?:\\^)";var N=C++;S[N]="(\\s*)"+S[M]+"\\s+",k[N]=new RegExp(S[N],"g");var B=C++;S[B]="^"+S[M]+S[n]+"$";var U=C++;S[U]="^"+S[M]+S[r]+"$";var W=C++;S[W]="^"+S[u]+"\\s*("+i+")$|^$";var x=C++;S[x]="^"+S[u]+"\\s*("+o+")$|^$";var V=C++;S[V]="(\\s*)"+S[u]+"\\s*("+i+"|"+S[n]+")",k[V]=new RegExp(S[V],"g");var X=C++;S[X]="^\\s*("+S[n]+")\\s+-\\s+("+S[n]+")\\s*$";var Q=C++;S[Q]="^\\s*("+S[r]+")\\s+-\\s+("+S[r]+")\\s*$";var J=C++;S[J]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)I(te,S[te]),k[te]||(k[te]=new RegExp(S[te]));function le(pe,Ce){if(pe instanceof Z)return pe;if(typeof pe!="string"||pe.length>A||!(Ce?k[l]:k[p]).test(pe))return null;try{return new Z(pe,Ce)}catch{return null}}function Z(pe,Ce){if(pe instanceof Z){if(pe.loose===Ce)return pe;pe=pe.version}else if(typeof pe!="string")throw new TypeError("Invalid Version: "+pe);if(pe.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof Z))return new Z(pe,Ce);I("SemVer",pe,Ce),this.loose=Ce;var ke=pe.trim().match(Ce?k[l]:k[p]);if(!ke)throw new TypeError("Invalid Version: "+pe);if(this.raw=pe,this.major=+ke[1],this.minor=+ke[2],this.patch=+ke[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");ke[4]?this.prerelease=ke[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var Ge=+je;if(Ge>=0&&Ge<D)return Ge}return je}):this.prerelease=[],this.build=ke[5]?ke[5].split("."):[],this.format()}e.parse=le,e.valid=function(pe,Ce){var ke=le(pe,Ce);return ke?ke.version:null},e.clean=function(pe,Ce){var ke=le(pe.trim().replace(/^[=v]+/,""),Ce);return ke?ke.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(pe){return I("SemVer.compare",this.version,this.loose,pe),pe instanceof Z||(pe=new Z(pe,this.loose)),this.compareMain(pe)||this.comparePre(pe)},Z.prototype.compareMain=function(pe){return pe instanceof Z||(pe=new Z(pe,this.loose)),ve(this.major,pe.major)||ve(this.minor,pe.minor)||ve(this.patch,pe.patch)},Z.prototype.comparePre=function(pe){if(pe instanceof Z||(pe=new Z(pe,this.loose)),this.prerelease.length&&!pe.prerelease.length)return-1;if(!this.prerelease.length&&pe.prerelease.length)return 1;if(!this.prerelease.length&&!pe.prerelease.length)return 0;var Ce=0;do{var ke=this.prerelease[Ce],je=pe.prerelease[Ce];if(I("prerelease compare",Ce,ke,je),ke===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ke===void 0)return-1;if(ke!==je)return ve(ke,je)}while(++Ce)},Z.prototype.inc=function(pe,Ce){switch(pe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ce),this.inc("pre",Ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ce),this.inc("pre",Ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ke=this.prerelease.length;--ke>=0;)typeof this.prerelease[ke]=="number"&&(this.prerelease[ke]++,ke=-2);ke===-1&&this.prerelease.push(0)}Ce&&(this.prerelease[0]===Ce?isNaN(this.prerelease[1])&&(this.prerelease=[Ce,0]):this.prerelease=[Ce,0]);break;default:throw new Error("invalid increment argument: "+pe)}return this.format(),this.raw=this.version,this},e.inc=function(pe,Ce,ke,je){typeof ke=="string"&&(je=ke,ke=void 0);try{return new Z(pe,ke).inc(Ce,je).version}catch{return null}},e.diff=function(pe,Ce){if(se(pe,Ce))return null;var ke=le(pe),je=le(Ce);if(ke.prerelease.length||je.prerelease.length){for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==je[Ge])return"pre"+Ge;return"prerelease"}for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==je[Ge])return Ge},e.compareIdentifiers=ve;var ge=/^[0-9]+$/;function ve(pe,Ce){var ke=ge.test(pe),je=ge.test(Ce);return ke&&je&&(pe=+pe,Ce=+Ce),ke&&!je?-1:je&&!ke?1:pe<Ce?-1:pe>Ce?1:0}function De(pe,Ce,ke){return new Z(pe,ke).compare(new Z(Ce,ke))}function Re(pe,Ce,ke){return De(pe,Ce,ke)>0}function ze(pe,Ce,ke){return De(pe,Ce,ke)<0}function se(pe,Ce,ke){return De(pe,Ce,ke)===0}function ue(pe,Ce,ke){return De(pe,Ce,ke)!==0}function he(pe,Ce,ke){return De(pe,Ce,ke)>=0}function ee(pe,Ce,ke){return De(pe,Ce,ke)<=0}function oe(pe,Ce,ke,je){var Ge;switch(Ce){case"===":typeof pe=="object"&&(pe=pe.version),typeof ke=="object"&&(ke=ke.version),Ge=pe===ke;break;case"!==":typeof pe=="object"&&(pe=pe.version),typeof ke=="object"&&(ke=ke.version),Ge=pe!==ke;break;case"":case"=":case"==":Ge=se(pe,ke,je);break;case"!=":Ge=ue(pe,ke,je);break;case">":Ge=Re(pe,ke,je);break;case">=":Ge=he(pe,ke,je);break;case"<":Ge=ze(pe,ke,je);break;case"<=":Ge=ee(pe,ke,je);break;default:throw new TypeError("Invalid operator: "+Ce)}return Ge}function ie(pe,Ce){if(pe instanceof ie){if(pe.loose===Ce)return pe;pe=pe.value}if(!(this instanceof ie))return new ie(pe,Ce);I("comparator",pe,Ce),this.loose=Ce,this.parse(pe),this.semver===O?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(pe,Ce){return ve(Ce,pe)},e.major=function(pe,Ce){return new Z(pe,Ce).major},e.minor=function(pe,Ce){return new Z(pe,Ce).minor},e.patch=function(pe,Ce){return new Z(pe,Ce).patch},e.compare=De,e.compareLoose=function(pe,Ce){return De(pe,Ce,!0)},e.rcompare=function(pe,Ce,ke){return De(Ce,pe,ke)},e.sort=function(pe,Ce){return pe.sort(function(ke,je){return e.compare(ke,je,Ce)})},e.rsort=function(pe,Ce){return pe.sort(function(ke,je){return e.rcompare(ke,je,Ce)})},e.gt=Re,e.lt=ze,e.eq=se,e.neq=ue,e.gte=he,e.lte=ee,e.cmp=oe,e.Comparator=ie;var O={};function H(pe,Ce){if(pe instanceof H)return pe.loose===Ce?pe:new H(pe.raw,Ce);if(pe instanceof ie)return new H(pe.value,Ce);if(!(this instanceof H))return new H(pe,Ce);if(this.loose=Ce,this.raw=pe,this.set=pe.split(/\s*\|\|\s*/).map(function(ke){return this.parseRange(ke.trim())},this).filter(function(ke){return ke.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+pe);this.format()}function q(pe){return!pe||pe.toLowerCase()==="x"||pe==="*"}function Y(pe,Ce,ke,je,Ge,et,_e,nt,st,ht,Fe,it,ae){return((Ce=q(ke)?"":q(je)?">="+ke+".0.0":q(Ge)?">="+ke+"."+je+".0":">="+Ce)+" "+(nt=q(st)?"":q(ht)?"<"+(+st+1)+".0.0":q(Fe)?"<"+st+"."+(+ht+1)+".0":it?"<="+st+"."+ht+"."+Fe+"-"+it:"<="+nt)).trim()}function de(pe,Ce){for(var ke=0;ke<pe.length;ke++)if(!pe[ke].test(Ce))return!1;if(Ce.prerelease.length){for(ke=0;ke<pe.length;ke++)if(I(pe[ke].semver),pe[ke].semver!==O&&pe[ke].semver.prerelease.length>0){var je=pe[ke].semver;if(je.major===Ce.major&&je.minor===Ce.minor&&je.patch===Ce.patch)return!0}return!1}return!0}function be(pe,Ce,ke){try{Ce=new H(Ce,ke)}catch{return!1}return Ce.test(pe)}function Pe(pe,Ce,ke,je){var Ge,et,_e,nt,st;switch(pe=new Z(pe,je),Ce=new H(Ce,je),ke){case">":Ge=Re,et=ee,_e=ze,nt=">",st=">=";break;case"<":Ge=ze,et=he,_e=Re,nt="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(be(pe,Ce,je))return!1;for(var ht=0;ht<Ce.set.length;++ht){var Fe=Ce.set[ht],it=null,ae=null;if(Fe.forEach(function($){$.semver===O&&($=new ie(">=0.0.0")),it=it||$,ae=ae||$,Ge($.semver,it.semver,je)?it=$:_e($.semver,ae.semver,je)&&(ae=$)}),it.operator===nt||it.operator===st||(!ae.operator||ae.operator===nt)&&et(pe,ae.semver)||ae.operator===st&&_e(pe,ae.semver))return!1}return!0}ie.prototype.parse=function(pe){var Ce=this.loose?k[W]:k[x],ke=pe.match(Ce);if(!ke)throw new TypeError("Invalid comparator: "+pe);this.operator=ke[1],this.operator==="="&&(this.operator=""),ke[2]?this.semver=new Z(ke[2],this.loose):this.semver=O},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(pe){return I("Comparator.test",pe,this.loose),this.semver===O||(typeof pe=="string"&&(pe=new Z(pe,this.loose)),oe(pe,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(pe,Ce){if(!(pe instanceof ie))throw new TypeError("a Comparator is required");var ke;if(this.operator==="")return ke=new H(pe.value,Ce),be(this.value,ke,Ce);if(pe.operator==="")return ke=new H(this.value,Ce),be(pe.semver,ke,Ce);var je=!(this.operator!==">="&&this.operator!==">"||pe.operator!==">="&&pe.operator!==">"),Ge=!(this.operator!=="<="&&this.operator!=="<"||pe.operator!=="<="&&pe.operator!=="<"),et=this.semver.version===pe.semver.version,_e=!(this.operator!==">="&&this.operator!=="<="||pe.operator!==">="&&pe.operator!=="<="),nt=oe(this.semver,"<",pe.semver,Ce)&&(this.operator===">="||this.operator===">")&&(pe.operator==="<="||pe.operator==="<"),st=oe(this.semver,">",pe.semver,Ce)&&(this.operator==="<="||this.operator==="<")&&(pe.operator===">="||pe.operator===">");return je||Ge||et&&_e||nt||st},e.Range=H,H.prototype.format=function(){return this.range=this.set.map(function(pe){return pe.join(" ").trim()}).join("||").trim(),this.range},H.prototype.toString=function(){return this.range},H.prototype.parseRange=function(pe){var Ce=this.loose;pe=pe.trim(),I("range",pe,Ce);var ke=Ce?k[Q]:k[X];pe=pe.replace(ke,Y),I("hyphen replace",pe),pe=pe.replace(k[V],"$1$2$3"),I("comparator trim",pe,k[V]),pe=(pe=(pe=pe.replace(k[_],"$1~")).replace(k[N],"$1^")).split(/\s+/).join(" ");var je=Ce?k[W]:k[x],Ge=pe.split(" ").map(function(et){return function(_e,nt){return I("comp",_e),_e=function(st,ht){return st.trim().split(/\s+/).map(function(Fe){return function(it,ae){I("caret",it,ae);var $=ae?k[U]:k[B];return it.replace($,function(ce,Ie,Le,Be,xe){var Ze;return I("caret",it,ce,Ie,Le,Be,xe),q(Ie)?Ze="":q(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":q(Be)?Ze=Ie==="0"?">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+".0 <"+(+Ie+1)+".0.0":xe?(I("replaceCaret pr",xe),xe.charAt(0)!=="-"&&(xe="-"+xe),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+Be+xe+" <"+Ie+"."+Le+"."+(+Be+1):">="+Ie+"."+Le+"."+Be+xe+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+Be+xe+" <"+(+Ie+1)+".0.0"):(I("no pr"),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+Le+"."+(+Be+1):">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+Be+" <"+(+Ie+1)+".0.0"),I("caret return",Ze),Ze})}(Fe,ht)}).join(" ")}(_e,nt),I("caret",_e),_e=function(st,ht){return st.trim().split(/\s+/).map(function(Fe){return function(it,ae){var $=ae?k[F]:k[K];return it.replace($,function(ce,Ie,Le,Be,xe){var Ze;return I("tilde",it,ce,Ie,Le,Be,xe),q(Ie)?Ze="":q(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":q(Be)?Ze=">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":xe?(I("replaceTilde pr",xe),xe.charAt(0)!=="-"&&(xe="-"+xe),Ze=">="+Ie+"."+Le+"."+Be+xe+" <"+Ie+"."+(+Le+1)+".0"):Ze=">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+(+Le+1)+".0",I("tilde return",Ze),Ze})}(Fe,ht)}).join(" ")}(_e,nt),I("tildes",_e),_e=function(st,ht){return I("replaceXRanges",st,ht),st.split(/\s+/).map(function(Fe){return function(it,ae){it=it.trim();var $=ae?k[P]:k[g];return it.replace($,function(ce,Ie,Le,Be,xe,Ze){I("xRange",it,ce,Ie,Le,Be,xe,Ze);var mt=q(Le),ft=mt||q(Be),lt=ft||q(xe);return Ie==="="&&lt&&(Ie=""),mt?ce=Ie===">"||Ie==="<"?"<0.0.0":"*":Ie&&lt?(ft&&(Be=0),lt&&(xe=0),Ie===">"?(Ie=">=",ft?(Le=+Le+1,Be=0,xe=0):lt&&(Be=+Be+1,xe=0)):Ie==="<="&&(Ie="<",ft?Le=+Le+1:Be=+Be+1),ce=Ie+Le+"."+Be+"."+xe):ft?ce=">="+Le+".0.0 <"+(+Le+1)+".0.0":lt&&(ce=">="+Le+"."+Be+".0 <"+Le+"."+(+Be+1)+".0"),I("xRange return",ce),ce})}(Fe,ht)}).join(" ")}(_e,nt),I("xrange",_e),_e=function(st,ht){return I("replaceStars",st,ht),st.trim().replace(k[J],"")}(_e,nt),I("stars",_e),_e}(et,Ce)}).join(" ").split(/\s+/);return this.loose&&(Ge=Ge.filter(function(et){return!!et.match(je)})),Ge=Ge.map(function(et){return new ie(et,Ce)})},H.prototype.intersects=function(pe,Ce){if(!(pe instanceof H))throw new TypeError("a Range is required");return this.set.some(function(ke){return ke.every(function(je){return pe.set.some(function(Ge){return Ge.every(function(et){return je.intersects(et,Ce)})})})})},e.toComparators=function(pe,Ce){return new H(pe,Ce).set.map(function(ke){return ke.map(function(je){return je.value}).join(" ").trim().split(" ")})},H.prototype.test=function(pe){if(!pe)return!1;typeof pe=="string"&&(pe=new Z(pe,this.loose));for(var Ce=0;Ce<this.set.length;Ce++)if(de(this.set[Ce],pe))return!0;return!1},e.satisfies=be,e.maxSatisfying=function(pe,Ce,ke){var je=null,Ge=null;try{var et=new H(Ce,ke)}catch{return null}return pe.forEach(function(_e){et.test(_e)&&(je&&Ge.compare(_e)!==-1||(Ge=new Z(je=_e,ke)))}),je},e.minSatisfying=function(pe,Ce,ke){var je=null,Ge=null;try{var et=new H(Ce,ke)}catch{return null}return pe.forEach(function(_e){et.test(_e)&&(je&&Ge.compare(_e)!==1||(Ge=new Z(je=_e,ke)))}),je},e.validRange=function(pe,Ce){try{return new H(pe,Ce).range||"*"}catch{return null}},e.ltr=function(pe,Ce,ke){return Pe(pe,Ce,"<",ke)},e.gtr=function(pe,Ce,ke){return Pe(pe,Ce,">",ke)},e.outside=Pe,e.prerelease=function(pe,Ce){var ke=le(pe,Ce);return ke&&ke.prerelease.length?ke.prerelease:null},e.intersects=function(pe,Ce,ke){return pe=new H(pe,ke),Ce=new H(Ce,ke),pe.intersects(Ce)},e.coerce=function(pe){if(pe instanceof Z)return pe;if(typeof pe!="string")return null;var Ce=pe.match(k[L]);return Ce==null?null:le((Ce[1]||"0")+"."+(Ce[2]||"0")+"."+(Ce[3]||"0"))}}).call(this,a(1))},function(ne,e){var a,t,I=ne.exports={};function A(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function k(b){if(a===setTimeout)return setTimeout(b,0);if((a===A||!a)&&setTimeout)return a=setTimeout,setTimeout(b,0);try{return a(b,0)}catch{try{return a.call(null,b,0)}catch{return a.call(this,b,0)}}}(function(){try{a=typeof setTimeout=="function"?setTimeout:A}catch{a=A}try{t=typeof clearTimeout=="function"?clearTimeout:D}catch{t=D}})();var S,C=[],R=!1,T=-1;function E(){R&&S&&(R=!1,S.length?C=S.concat(C):T=-1,C.length&&y())}function y(){if(!R){var b=k(E);R=!0;for(var f=C.length;f;){for(S=C,C=[];++T<f;)S&&S[T].run();T=-1,f=C.length}S=null,R=!1,function(w){if(t===clearTimeout)return clearTimeout(w);if((t===D||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(w);try{t(w)}catch{try{return t.call(null,w)}catch{return t.call(this,w)}}}(b)}}function v(b,f){this.fun=b,this.array=f}function d(){}I.nextTick=function(b){var f=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)f[w-1]=arguments[w];C.push(new v(b,f)),C.length!==1||R||k(y)},v.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=d,I.addListener=d,I.once=d,I.off=d,I.removeListener=d,I.removeAllListeners=d,I.emit=d,I.prependListener=d,I.prependOnceListener=d,I.listeners=function(b){return[]},I.binding=function(b){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(b){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Se[101],ye([1,0,10,6]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function I(m){const p=m;return p?typeof p.read=="function":!1}e.isReadable=I;function A(m){const p=m;return p?[p.on,p.pause,p.resume,p.destroy].every(o=>typeof o=="function"):!1}e.isReadableStream=A;function D(m){const p=m;return p?A(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=D;function k(m,p){return new S(m,p)}e.newWriteableStream=k;class S{constructor(p,o){this.e=p,this.f=o,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(p){if(!this.a.destroyed){if(this.a.flowing)this.g(p);else if(this.b.data.push(p),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(o=>this.d.push(o))}}error(p){this.a.destroyed||(this.a.flowing?this.h(p):this.b.error.push(p))}end(p){this.a.destroyed||(typeof p<"u"&&this.write(p),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(p){this.c.data.slice(0).forEach(o=>o(p))}h(p){this.c.error.length===0?(0,a.onUnexpectedError)(p):this.c.error.slice(0).forEach(o=>o(p))}i(){this.c.end.slice(0).forEach(p=>p())}on(p,o){if(!this.a.destroyed)switch(p){case"data":this.c.data.push(o),this.resume();break;case"end":this.c.end.push(o),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(o),this.a.flowing&&this.k();break}}removeListener(p,o){if(this.a.destroyed)return;let i;switch(p){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const l=i.indexOf(o);l>=0&&i.splice(l,1)}}j(){if(this.b.data.length>0){const p=this.e(this.b.data);this.g(p),this.b.data.length=0;const o=[...this.d];this.d.length=0,o.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const p of this.b.error)this.h(p);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function C(m,p){const o=[];let i;for(;(i=m.read())!==null;)o.push(i);return p(o)}e.consumeReadable=C;function R(m,p,o){const i=[];let l;for(;(l=m.read())!==null&&i.length<o;)i.push(l);return l===null&&i.length>0?p(i):{read:()=>{if(i.length>0)return i.shift();if(typeof l<"u"){const u=l;return l=void 0,u}return m.read()}}}e.peekReadable=R;function T(m,p){return new Promise((o,i)=>{const l=[];E(m,{onData:u=>{p&&l.push(u)},onError:u=>{p?i(u):o(void 0)},onEnd:()=>{o(p?p(l):void 0)}})})}e.consumeStream=T;function E(m,p){let o=!1;return m.on("error",i=>{o||p.onError(i)}),m.on("end",()=>{o||p.onEnd()}),m.on("data",i=>{o||p.onData(i)}),(0,t.toDisposable)(()=>o=!0)}e.listenStream=E;function y(m,p){return new Promise((o,i)=>{const l=new t.DisposableStore,u=[],s=r=>{if(u.push(r),u.length>p)return l.dispose(),m.pause(),o({stream:m,buffer:u,ended:!1})},c=r=>i(r),n=()=>o({stream:m,buffer:u,ended:!0});l.add((0,t.toDisposable)(()=>m.removeListener("error",c))),m.on("error",c),l.add((0,t.toDisposable)(()=>m.removeListener("end",n))),m.on("end",n),l.add((0,t.toDisposable)(()=>m.removeListener("data",s))),m.on("data",s)})}e.peekStream=y;function v(m,p){const o=k(p);return o.end(m),o}e.toStream=v;function d(){const m=k(()=>{throw new Error("not supported")});return m.end(),m}e.emptyStream=d;function b(m){let p=!1;return{read:()=>p?null:(p=!0,m)}}e.toReadable=b;function f(m,p,o){const i=k(o);return E(m,{onData:l=>i.write(p.data(l)),onError:l=>i.error(p.error?p.error(l):l),onEnd:()=>i.end()}),i}e.transform=f;function w(m,p,o){let i=!1;return{read:()=>{const l=p.read();return i?l:(i=!0,l!==null?o([m,l]):m)}}}e.prefixedReadable=w;function h(m,p,o){let i=!1;const l=k(o);return E(p,{onData:u=>i?l.write(u):(i=!0,l.write(o([m,u]))),onError:u=>l.error(u),onEnd:()=>{i||(i=!0,l.write(m)),l.end()}}),l}e.prefixedStream=h}),define(Se[22],ye([1,0,101]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let I,A;class D{static alloc(r){return t?new D(Buffer.allocUnsafe(r)):new D(new Uint8Array(r))}static wrap(r){return t&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new D(r)}static fromString(r,g){return!(g?.dontUseNodeBuffer||!1)&&t?new D(Buffer.from(r)):(I||(I=new TextEncoder),new D(I.encode(r)))}static fromByteArray(r){const g=D.alloc(r.length);for(let P=0,L=r.length;P<L;P++)g.buffer[P]=r[P];return g}static concat(r,g){if(typeof g>"u"){g=0;for(let z=0,_=r.length;z<_;z++)g+=r[z].byteLength}const P=D.alloc(g);let L=0;for(let z=0,_=r.length;z<_;z++){const K=r[z];P.set(K,L),L+=K.byteLength}return P}constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}clone(){const r=D.alloc(this.byteLength);return r.set(this),r}toString(){return t?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(r,g){return new D(this.buffer.subarray(r,g))}set(r,g){if(r instanceof D)this.buffer.set(r.buffer,g);else if(r instanceof Uint8Array)this.buffer.set(r,g);else if(r instanceof ArrayBuffer)this.buffer.set(new Uint8Array(r),g);else if(ArrayBuffer.isView(r))this.buffer.set(new Uint8Array(r.buffer,r.byteOffset,r.byteLength),g);else throw new Error("Unknown argument 'array'")}readUInt32BE(r){return C(this.buffer,r)}writeUInt32BE(r,g){R(this.buffer,r,g)}readUInt32LE(r){return T(this.buffer,r)}writeUInt32LE(r,g){E(this.buffer,r,g)}readUInt8(r){return y(this.buffer,r)}writeUInt8(r,g){v(this.buffer,r,g)}}e.VSBuffer=D;function k(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0}e.readUInt16LE=k;function S(n,r,g){n[g+0]=r&255,r=r>>>8,n[g+1]=r&255}e.writeUInt16LE=S;function C(n,r){return n[r]*2**24+n[r+1]*2**16+n[r+2]*2**8+n[r+3]}e.readUInt32BE=C;function R(n,r,g){n[g+3]=r,r=r>>>8,n[g+2]=r,r=r>>>8,n[g+1]=r,r=r>>>8,n[g]=r}e.writeUInt32BE=R;function T(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0|n[r+2]<<16>>>0|n[r+3]<<24>>>0}e.readUInt32LE=T;function E(n,r,g){n[g+0]=r&255,r=r>>>8,n[g+1]=r&255,r=r>>>8,n[g+2]=r&255,r=r>>>8,n[g+3]=r&255}e.writeUInt32LE=E;function y(n,r){return n[r]}e.readUInt8=y;function v(n,r,g){n[g]=r}e.writeUInt8=v;function d(n){return a.consumeReadable(n,r=>D.concat(r))}e.readableToBuffer=d;function b(n){return a.toReadable(n)}e.bufferToReadable=b;function f(n){return a.consumeStream(n,r=>D.concat(r))}e.streamToBuffer=f;async function w(n){return n.ended?D.concat(n.buffer):D.concat([...n.buffer,await f(n.stream)])}e.bufferedStreamToBuffer=w;function h(n){return a.toStream(n,r=>D.concat(r))}e.bufferToStream=h;function m(n){return a.transform(n,{data:r=>typeof r=="string"?D.fromString(r):D.wrap(r)},r=>D.concat(r))}e.streamToBufferReadableStream=m;function p(n){return a.newWriteableStream(r=>D.concat(r),n)}e.newWriteableBufferStream=p;function o(n,r){return a.prefixedReadable(n,r,g=>D.concat(g))}e.prefixedBufferReadable=o;function i(n,r){return a.prefixedStream(n,r,g=>D.concat(g))}e.prefixedBufferStream=i;function l(n){let r=0,g=0,P=0;const L=new Uint8Array(Math.floor(n.length/4*3)),z=K=>{switch(g){case 3:L[P++]=r|K,g=0;break;case 2:L[P++]=r|K>>>2,r=K<<6,g=3;break;case 1:L[P++]=r|K>>>4,r=K<<4,g=2;break;default:r=K<<2,g=1}};for(let K=0;K<n.length;K++){const F=n.charCodeAt(K);if(F>=65&&F<=90)z(F-65);else if(F>=97&&F<=122)z(F-97+26);else if(F>=48&&F<=57)z(F-48+52);else if(F===43||F===45)z(62);else if(F===47||F===95)z(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${n[K]}`)}}const _=P;for(;g>0;)z(0);return D.wrap(L).slice(0,_)}e.decodeBase64=l;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:n},r=!0,g=!1){const P=g?s:u;let L="";const z=n.byteLength%3;let _=0;for(;_<n.byteLength-z;_+=3){const K=n[_+0],F=n[_+1],M=n[_+2];L+=P[K>>>2],L+=P[(K<<4|F>>>4)&63],L+=P[(F<<2|M>>>6)&63],L+=P[M&63]}if(z===1){const K=n[_+0];L+=P[K>>>2],L+=P[K<<4&63],r&&(L+="==")}else if(z===2){const K=n[_+0],F=n[_+1];L+=P[K>>>2],L+=P[(K<<4|F>>>4)&63],L+=P[F<<2&63],r&&(L+="=")}return L}e.encodeBase64=c}),define(Se[11],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function a(i){return typeof i=="string"}e.isString=a;function t(i){return Array.isArray(i)&&i.every(l=>a(l))}e.isStringArray=t;function I(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}e.isObject=I;function A(i){const l=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof l}e.isTypedArray=A;function D(i){return typeof i=="number"&&!isNaN(i)}e.isNumber=D;function k(i){return!!i&&typeof i[Symbol.iterator]=="function"}e.isIterable=k;function S(i){return i===!0||i===!1}e.isBoolean=S;function C(i){return typeof i>"u"}e.isUndefined=C;function R(i){return!T(i)}e.isDefined=R;function T(i){return C(i)||i===null}e.isUndefinedOrNull=T;function E(i,l){if(!i)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=E;function y(i){if(T(i))throw new Error("Assertion Failed: argument is undefined or null");return i}e.assertIsDefined=y;function v(...i){const l=[];for(let u=0;u<i.length;u++){const s=i[u];if(T(s))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);l.push(s)}return l}e.assertAllDefined=v;const d=Object.prototype.hasOwnProperty;function b(i){if(!I(i))return!1;for(const l in i)if(d.call(i,l))return!1;return!0}e.isEmptyObject=b;function f(i){return typeof i=="function"}e.isFunction=f;function w(...i){return i.length>0&&i.every(f)}e.areFunctions=w;function h(i,l){const u=Math.min(i.length,l.length);for(let s=0;s<u;s++)m(i[s],l[s])}e.validateConstraints=h;function m(i,l){if(a(l)){if(typeof i!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(f(l)){try{if(i instanceof l)return}catch{}if(!T(i)&&i.constructor===l||l.length===1&&l.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=m;function p(i){return i===null?void 0:i}e.withNullAsUndefined=p;function o(i){return typeof i>"u"?null:i}e.withUndefinedAsNull=o}),define(Se[23],ye([1,0,11]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const w=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([h,m])=>{w[h]=m&&typeof m=="object"?t(m):m}),w}e.deepClone=t;function I(f){if(!f||typeof f!="object")return f;const w=[f];for(;w.length>0;){const h=w.shift();Object.freeze(h);for(const m in h)if(A.call(h,m)){const p=h[m];typeof p=="object"&&!Object.isFrozen(p)&&!(0,a.isTypedArray)(p)&&w.push(p)}}return f}e.deepFreeze=I;const A=Object.prototype.hasOwnProperty;function D(f,w){return k(f,w,new Set)}e.cloneAndChange=D;function k(f,w,h){if((0,a.isUndefinedOrNull)(f))return f;const m=w(f);if(typeof m<"u")return m;if(Array.isArray(f)){const p=[];for(const o of f)p.push(k(o,w,h));return p}if((0,a.isObject)(f)){if(h.has(f))throw new Error("Cannot clone recursive data-structure");h.add(f);const p={};for(const o in f)A.call(f,o)&&(p[o]=k(f[o],w,h));return h.delete(f),p}return f}function S(f,w,h=!0){return(0,a.isObject)(f)?((0,a.isObject)(w)&&Object.keys(w).forEach(m=>{m in f?h&&((0,a.isObject)(f[m])&&(0,a.isObject)(w[m])?S(f[m],w[m],h):f[m]=w[m]):f[m]=w[m]}),f):w}e.mixin=S;function C(f,w){if(f===w)return!0;if(f==null||w===null||w===void 0||typeof f!=typeof w||typeof f!="object"||Array.isArray(f)!==Array.isArray(w))return!1;let h,m;if(Array.isArray(f)){if(f.length!==w.length)return!1;for(h=0;h<f.length;h++)if(!C(f[h],w[h]))return!1}else{const p=[];for(m in f)p.push(m);p.sort();const o=[];for(m in w)o.push(m);if(o.sort(),!C(p,o))return!1;for(h=0;h<p.length;h++)if(!C(f[p[h]],w[p[h]]))return!1}return!0}e.equals=C;function R(f){const w=new Set;return JSON.stringify(f,(h,m)=>{if((0,a.isObject)(m)||Array.isArray(m)){if(w.has(m))return"[Circular]";w.add(m)}return m})}e.safeStringify=R;function T(f,w){const h=Object.create(null);return!f||!w||Object.keys(w).forEach(p=>{const o=f[p],i=w[p];C(o,i)||(h[p]=i)}),h}e.distinct=T;function E(f,w){const h=w.toLowerCase(),m=Object.keys(f).find(p=>p.toLowerCase()===h);return m?f[m]:f[w]}e.getCaseInsensitive=E;function y(f,w){const h=Object.create(null);for(const[m,p]of Object.entries(f))w(m,p)&&(h[m]=p);return h}e.filter=y;function v(f){let w=[],h=Object.getPrototypeOf(f);for(;Object.prototype!==h;)w=w.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return w}e.getAllPropertyNames=v;function d(f){const w=[];for(const h of v(f))typeof f[h]=="function"&&w.push(h);return w}e.getAllMethodNames=d;function b(f,w){const h=p=>function(){const o=Array.prototype.slice.call(arguments,0);return w(p,o)},m={};for(const p of f)m[p]=h(p);return m}e.createProxyObject=b}),define(Se[102],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var a;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(a=e.Constants||(e.Constants={}));function t(A){return A<0?0:A>255?255:A|0}e.toUint8=t;function I(A){return A<0?0:A>4294967295?4294967295:A|0}e.toUint32=I}),define(Se[30],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(I){return a.test(I)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(k){for(let S=0;S<k.length;S++)k[S]=Math.floor(Math.random()*256);return k};const A=new Uint8Array(16),D=[];for(let k=0;k<256;k++)D.push(k.toString(16).padStart(2,"0"));return function(){I(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let S=0,C="";return C+=D[A[S++]],C+=D[A[S++]],C+=D[A[S++]],C+=D[A[S++]],C+="-",C+=D[A[S++]],C+=D[A[S++]],C+="-",C+=D[A[S++]],C+=D[A[S++]],C+="-",C+=D[A[S++]],C+=D[A[S++]],C+="-",C+=D[A[S++]],C+=D[A[S++]],C+=D[A[S++]],C+=D[A[S++]],C+=D[A[S++]],C+=D[A[S++]],C}}()}),define(Se[148],ye([1,0,17,30]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function I(k){return{id:(0,t.generateUuid)(),asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.createStringDataTransferItem=I;function A(k,S,C){return{id:(0,t.generateUuid)(),asString:async()=>"",asFile:()=>({name:k,uri:S,data:C}),value:void 0}}e.createFileDataTransferItem=A;class D{constructor(){this.a=new Map}get size(){return this.a.size}has(S){return this.a.has(this.b(S))}get(S){return this.a.get(this.b(S))?.[0]}append(S,C){const R=this.a.get(S);R?R.push(C):this.a.set(this.b(S),[C])}replace(S,C){this.a.set(this.b(S),[C])}delete(S){this.a.delete(this.b(S))}*entries(){for(const[S,C]of this.a.entries())for(const R of C)yield[S,R]}values(){return Array.from(this.a.values()).flat()}forEach(S){for(const[C,R]of this.entries())S(R,C)}b(S){return S.toLowerCase()}}e.VSDataTransfer=D,e.UriList=Object.freeze({create:k=>(0,a.distinct)(k.map(S=>S.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.UriList.split(k).filter(S=>!S.startsWith("#"))})}),define(Se[103],ye([1,0,102]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(k){const S=(0,a.toUint8)(k);this.c=S,this.a=t.d(S),this.b=new Map}static d(k){const S=new Uint8Array(256);return S.fill(k),S}set(k,S){const C=(0,a.toUint8)(S);k>=0&&k<256?this.a[k]=C:this.b.set(k,C)}get(k){return k>=0&&k<256?this.a[k]:this.b.get(k)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=t;var I;(function(D){D[D.False=0]="False",D[D.True=1]="True"})(I||(I={}));class A{constructor(){this.a=new t(0)}add(k){this.a.set(k,1)}has(k){return this.a.get(k)===1}clear(){return this.a.clear()}}e.CharacterSet=A}),define(Se[50],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class a{constructor(I,A){this.lineNumber=I,this.column=A}with(I=this.lineNumber,A=this.column){return I===this.lineNumber&&A===this.column?this:new a(I,A)}delta(I=0,A=0){return this.with(this.lineNumber+I,this.column+A)}equals(I){return a.equals(this,I)}static equals(I,A){return!I&&!A?!0:!!I&&!!A&&I.lineNumber===A.lineNumber&&I.column===A.column}isBefore(I){return a.isBefore(this,I)}static isBefore(I,A){return I.lineNumber<A.lineNumber?!0:A.lineNumber<I.lineNumber?!1:I.column<A.column}isBeforeOrEqual(I){return a.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,A){return I.lineNumber<A.lineNumber?!0:A.lineNumber<I.lineNumber?!1:I.column<=A.column}static compare(I,A){const D=I.lineNumber|0,k=A.lineNumber|0;if(D===k){const S=I.column|0,C=A.column|0;return S-C}return D-k}clone(){return new a(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new a(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=a}),define(Se[35],ye([1,0,50]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(A,D,k,S){A>k||A===k&&D>S?(this.startLineNumber=k,this.startColumn=S,this.endLineNumber=A,this.endColumn=D):(this.startLineNumber=A,this.startColumn=D,this.endLineNumber=k,this.endColumn=S)}isEmpty(){return t.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return t.containsPosition(this,A)}static containsPosition(A,D){return!(D.lineNumber<A.startLineNumber||D.lineNumber>A.endLineNumber||D.lineNumber===A.startLineNumber&&D.column<A.startColumn||D.lineNumber===A.endLineNumber&&D.column>A.endColumn)}static strictContainsPosition(A,D){return!(D.lineNumber<A.startLineNumber||D.lineNumber>A.endLineNumber||D.lineNumber===A.startLineNumber&&D.column<=A.startColumn||D.lineNumber===A.endLineNumber&&D.column>=A.endColumn)}containsRange(A){return t.containsRange(this,A)}static containsRange(A,D){return!(D.startLineNumber<A.startLineNumber||D.endLineNumber<A.startLineNumber||D.startLineNumber>A.endLineNumber||D.endLineNumber>A.endLineNumber||D.startLineNumber===A.startLineNumber&&D.startColumn<A.startColumn||D.endLineNumber===A.endLineNumber&&D.endColumn>A.endColumn)}strictContainsRange(A){return t.strictContainsRange(this,A)}static strictContainsRange(A,D){return!(D.startLineNumber<A.startLineNumber||D.endLineNumber<A.startLineNumber||D.startLineNumber>A.endLineNumber||D.endLineNumber>A.endLineNumber||D.startLineNumber===A.startLineNumber&&D.startColumn<=A.startColumn||D.endLineNumber===A.endLineNumber&&D.endColumn>=A.endColumn)}plusRange(A){return t.plusRange(this,A)}static plusRange(A,D){let k,S,C,R;return D.startLineNumber<A.startLineNumber?(k=D.startLineNumber,S=D.startColumn):D.startLineNumber===A.startLineNumber?(k=D.startLineNumber,S=Math.min(D.startColumn,A.startColumn)):(k=A.startLineNumber,S=A.startColumn),D.endLineNumber>A.endLineNumber?(C=D.endLineNumber,R=D.endColumn):D.endLineNumber===A.endLineNumber?(C=D.endLineNumber,R=Math.max(D.endColumn,A.endColumn)):(C=A.endLineNumber,R=A.endColumn),new t(k,S,C,R)}intersectRanges(A){return t.intersectRanges(this,A)}static intersectRanges(A,D){let k=A.startLineNumber,S=A.startColumn,C=A.endLineNumber,R=A.endColumn;const T=D.startLineNumber,E=D.startColumn,y=D.endLineNumber,v=D.endColumn;return k<T?(k=T,S=E):k===T&&(S=Math.max(S,E)),C>y?(C=y,R=v):C===y&&(R=Math.min(R,v)),k>C||k===C&&S>R?null:new t(k,S,C,R)}equalsRange(A){return t.equalsRange(this,A)}static equalsRange(A,D){return!A&&!D?!0:!!A&&!!D&&A.startLineNumber===D.startLineNumber&&A.startColumn===D.startColumn&&A.endLineNumber===D.endLineNumber&&A.endColumn===D.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(A){return new a.Position(A.endLineNumber,A.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(A){return new a.Position(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,D){return new t(this.startLineNumber,this.startColumn,A,D)}setStartPosition(A,D){return new t(A,D,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(A){return new t(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return t.collapseToEnd(this)}static collapseToEnd(A){return new t(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new t(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,D=A){return new t(A.lineNumber,A.column,D.lineNumber,D.column)}static lift(A){return A?new t(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,D){return!(A.endLineNumber<D.startLineNumber||A.endLineNumber===D.startLineNumber&&A.endColumn<D.startColumn||D.endLineNumber<A.startLineNumber||D.endLineNumber===A.startLineNumber&&D.endColumn<A.startColumn)}static areIntersecting(A,D){return!(A.endLineNumber<D.startLineNumber||A.endLineNumber===D.startLineNumber&&A.endColumn<=D.startColumn||D.endLineNumber<A.startLineNumber||D.endLineNumber===A.startLineNumber&&D.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,D){if(A&&D){const C=A.startLineNumber|0,R=D.startLineNumber|0;if(C===R){const T=A.startColumn|0,E=D.startColumn|0;if(T===E){const y=A.endLineNumber|0,v=D.endLineNumber|0;if(y===v){const d=A.endColumn|0,b=D.endColumn|0;return d-b}return y-v}return T-E}return C-R}return(A?1:0)-(D?1:0)}static compareRangesUsingEnds(A,D){return A.endLineNumber===D.endLineNumber?A.endColumn===D.endColumn?A.startLineNumber===D.startLineNumber?A.startColumn-D.startColumn:A.startLineNumber-D.startLineNumber:A.endColumn-D.endColumn:A.endLineNumber-D.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.Range=t}),define(Se[149],ye([1,0,50,35]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(D){D[D.LTR=0]="LTR",D[D.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class A extends t.Range{constructor(k,S,C,R){super(k,S,C,R),this.selectionStartLineNumber=k,this.selectionStartColumn=S,this.positionLineNumber=C,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return A.selectionsEqual(this,k)}static selectionsEqual(k,S){return k.selectionStartLineNumber===S.selectionStartLineNumber&&k.selectionStartColumn===S.selectionStartColumn&&k.positionLineNumber===S.positionLineNumber&&k.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,S){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,k,S):new A(k,S,this.startLineNumber,this.startColumn)}getPosition(){return new a.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new a.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,S){return this.getDirection()===0?new A(k,S,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,k,S)}static fromPositions(k,S=k){return new A(k.lineNumber,k.column,S.lineNumber,S.column)}static fromRange(k,S){return S===0?new A(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new A(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new A(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,S){if(k&&!S||!k&&S)return!1;if(!k&&!S)return!0;if(k.length!==S.length)return!1;for(let C=0,R=k.length;C<R;C++)if(!this.selectionsEqual(k[C],S[C]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,S,C,R,T){return T===0?new A(k,S,C,R):new A(C,R,k,S)}}e.Selection=A}),define(Se[150],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[151],ye([1,0,103]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(D){D[D.Regular=0]="Regular",D[D.Whitespace=1]="Whitespace",D[D.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends a.CharacterClassifier{constructor(k){super(0);for(let S=0,C=k.length;S<C;S++)this.set(k.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function A(D){const k={};return S=>(k.hasOwnProperty(S)||(k[S]=D(S)),k[S])}e.getMapForWordSeparators=A(D=>new I(D))}),define(Se[104],ye([1,0,62,6,63]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(T=""){let E="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.USUAL_WORD_SEPARATORS)T.indexOf(y)>=0||(E+="\\"+y);return E+="\\s]+)",new RegExp(E,"g")}e.DEFAULT_WORD_REGEXP=A();function D(T){let E=e.DEFAULT_WORD_REGEXP;if(T&&T instanceof RegExp)if(T.global)E=T;else{let y="g";T.ignoreCase&&(y+="i"),T.multiline&&(y+="m"),T.unicode&&(y+="u"),E=new RegExp(T.source,y)}return E.lastIndex=0,E}e.ensureValidWordDefinition=D;const k=new I.LinkedList;k.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function S(T){const E=k.unshift(T);return(0,t.toDisposable)(E)}e.setDefaultGetWordAtTextConfig=S;function C(T,E,y,v,d){if(d||(d=a.Iterable.first(k)),y.length>d.maxLen){let m=T-d.maxLen/2;return m<0?m=0:v+=m,y=y.substring(m,T+d.maxLen/2),C(T,E,y,v,d)}const b=Date.now(),f=T-1-v;let w=-1,h=null;for(let m=1;!(Date.now()-b>=d.timeBudget);m++){const p=f-d.windowSize*m;E.lastIndex=Math.max(0,p);const o=R(E,y,f,w);if(!o&&h||(h=o,p<=0))break;w=p}if(h){const m={word:h[0],startColumn:v+1+h.index,endColumn:v+1+h.index+h[0].length};return E.lastIndex=0,m}return null}e.getWordAtText=C;function R(T,E,y,v){let d;for(;d=T.exec(E);){const b=d.index||0;if(b<=y&&T.lastIndex>=y)return d;if(v>0&&b>v)return null}return null}}),define(Se[152],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var a;(function(D){D[D.None=0]="None",D[D.Indent=1]="Indent",D[D.IndentOutdent=2]="IndentOutdent",D[D.Outdent=3]="Outdent"})(a=e.IndentAction||(e.IndentAction={}));class t{constructor(k){if(this.e=null,this.f=!1,this.open=k.open,this.close=k.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(k.notIn))for(let S=0,C=k.notIn.length;S<C;S++)switch(k.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(k){switch(k){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(k,S){if(k.getTokenCount()===0)return!0;const C=k.findTokenIndexAtOffset(S-2),R=k.getStandardTokenType(C);return this.isOK(R)}g(k,S){for(let C=k;C<=S;C++){const R=String.fromCharCode(C);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=t;class I{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of k)A(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),A(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),A(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),A(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&A(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=I;function A(D,k,S){D.has(k)?D.get(k).push(S):D.set(k,[S])}}),define(Se[153],ye([1,0,103]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var t;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class I{constructor(v,d,b){const f=new Uint8Array(v*d);for(let w=0,h=v*d;w<h;w++)f[w]=b;this.a=f,this.rows=v,this.cols=d}get(v,d){return this.a[v*this.cols+d]}set(v,d,b){this.a[v*this.cols+d]=b}}class A{constructor(v){let d=0,b=0;for(let w=0,h=v.length;w<h;w++){const[m,p,o]=v[w];p>d&&(d=p),m>b&&(b=m),o>b&&(b=o)}d++,b++;const f=new I(b,d,0);for(let w=0,h=v.length;w<h;w++){const[m,p,o]=v[w];f.set(m,p,o)}this.a=f,this.b=d}nextState(v,d){return d<0||d>=this.b?0:this.a.get(v,d)}}e.StateMachine=A;let D=null;function k(){return D===null&&(D=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),D}var S;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let C=null;function R(){if(C===null){C=new a.CharacterClassifier(0);const y=`, 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<y.length;d++)C.set(y.charCodeAt(d),1);const v=".;:";for(let d=0;d<v.length;d++)C.set(v.charCodeAt(d),2)}return C}class T{static a(v,d,b,f,w){let h=w-1;do{const m=d.charCodeAt(h);if(v.get(m)!==2)break;h--}while(h>f);if(f>0){const m=d.charCodeAt(f-1),p=d.charCodeAt(h);(m===40&&p===41||m===91&&p===93||m===123&&p===125)&&h--}return{range:{startLineNumber:b,startColumn:f+1,endLineNumber:b,endColumn:h+2},url:d.substring(f,h+1)}}static computeLinks(v,d=k()){const b=R(),f=[];for(let w=1,h=v.getLineCount();w<=h;w++){const m=v.getLineContent(w),p=m.length;let o=0,i=0,l=0,u=1,s=!1,c=!1,n=!1,r=!1;for(;o<p;){let g=!1;const P=m.charCodeAt(o);if(u===13){let L;switch(P){case 40:s=!0,L=0;break;case 41:L=s?0:1;break;case 91:n=!0,c=!0,L=0;break;case 93:n=!1,L=c?0:1;break;case 123:r=!0,L=0;break;case 125:L=r?0:1;break;case 39:case 34:case 96:l===P?L=1:l===39||l===34||l===96?L=0:L=1;break;case 42:L=l===42?1:0;break;case 124:L=l===124?1:0;break;case 32:L=n?0:1;break;default:L=b.get(P)}L===1&&(f.push(T.a(b,m,w,i,o)),g=!0)}else if(u===12){let L;P===91?(c=!0,L=0):L=b.get(P),L===1?g=!0:u=13}else u=d.nextState(u,P),u===0&&(g=!0);g&&(u=1,s=!1,c=!1,r=!1,i=o+1,l=P),o++}u===13&&f.push(T.a(b,m,w,i,p))}return f}}e.LinkComputer=T;function E(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:T.computeLinks(y)}e.computeLinks=E}),define(Se[105],ye([1,0,23]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(h){h[h.Both=0]="Both",h[h.Right=1]="Right",h[h.Left=2]="Left",h[h.None=3]="None"})(A=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var D;(function(h){h[h.TextDefined=0]="TextDefined",h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(D=e.EndOfLinePreference||(e.EndOfLinePreference={}));var k;(function(h){h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(k=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(h){h[h.LF=0]="LF",h[h.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(m){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,m.tabSize|0),this.indentSize=Math.max(1,m.indentSize|0),this.insertSpaces=Boolean(m.insertSpaces),this.defaultEOL=m.defaultEOL|0,this.trimAutoWhitespace=Boolean(m.trimAutoWhitespace),this.bracketPairColorizationOptions=m.bracketPairColorizationOptions}equals(m){return this.tabSize===m.tabSize&&this.indentSize===m.indentSize&&this.insertSpaces===m.insertSpaces&&this.defaultEOL===m.defaultEOL&&this.trimAutoWhitespace===m.trimAutoWhitespace&&(0,a.equals)(this.bracketPairColorizationOptions,m.bracketPairColorizationOptions)}createChangeEvent(m){return{tabSize:this.tabSize!==m.tabSize,indentSize:this.indentSize!==m.indentSize,insertSpaces:this.insertSpaces!==m.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==m.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class R{constructor(m,p){this._findMatchBrand=void 0,this.range=m,this.matches=p}}e.FindMatch=R;var T;(function(h){h[h.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",h[h.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",h[h.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",h[h.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(T=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function E(h){return h&&typeof h.read=="function"}e.isITextSnapshot=E;var y;(function(h){h[h.Left=0]="Left",h[h.Right=1]="Right",h[h.None=2]="None",h[h.LeftOfInjectedText=3]="LeftOfInjectedText",h[h.RightOfInjectedText=4]="RightOfInjectedText"})(y=e.PositionAffinity||(e.PositionAffinity={}));var v;(function(h){h[h.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v=e.ModelConstants||(e.ModelConstants={}));class d{constructor(m,p,o,i,l,u){this.identifier=m,this.range=p,this.text=o,this.forceMoveMarkers=i,this.isAutoWhitespaceEdit=l,this._isTracked=u}}e.ValidAnnotatedEditOperation=d;class b{constructor(m,p,o){this.regex=m,this.wordSeparators=p,this.simpleSearch=o}}e.SearchData=b;class f{constructor(m,p,o){this.reverseEdits=m,this.changes=p,this.trimAutoWhitespaceLineNumbers=o}}e.ApplyEditsResult=f;function w(h){return!h.isTooLargeForSyncing()&&!h.isForSimpleWidget}e.shouldSynchronizeModel=w}),define(Se[154],ye([1,0,17,102]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class I{constructor(S){this.a=S,this.b=new Uint32Array(S.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(S,C){S=(0,t.toUint32)(S);const R=this.a,T=this.b,E=C.length;return E===0?!1:(this.a=new Uint32Array(R.length+E),this.a.set(R.subarray(0,S),0),this.a.set(R.subarray(S),S+E),this.a.set(C,S),S-1<this.c[0]&&(this.c[0]=S-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(T.subarray(0,this.c[0]+1)),!0)}setValue(S,C){return S=(0,t.toUint32)(S),C=(0,t.toUint32)(C),this.a[S]===C?!1:(this.a[S]=C,S-1<this.c[0]&&(this.c[0]=S-1),!0)}removeValues(S,C){S=(0,t.toUint32)(S),C=(0,t.toUint32)(C);const R=this.a,T=this.b;if(S>=R.length)return!1;const E=R.length-S;return C>=E&&(C=E),C===0?!1:(this.a=new Uint32Array(R.length-C),this.a.set(R.subarray(0,S),0),this.a.set(R.subarray(S+C),S),this.b=new Uint32Array(this.a.length),S-1<this.c[0]&&(this.c[0]=S-1),this.c[0]>=0&&this.b.set(T.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(S){return S<0?0:(S=(0,t.toUint32)(S),this.d(S))}d(S){if(S<=this.c[0])return this.b[S];let C=this.c[0]+1;C===0&&(this.b[0]=this.a[0],C++),S>=this.a.length&&(S=this.a.length-1);for(let R=C;R<=S;R++)this.b[R]=this.b[R-1]+this.a[R];return this.c[0]=Math.max(this.c[0],S),this.b[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let C=0,R=this.a.length-1,T=0,E=0,y=0;for(;C<=R;)if(T=C+(R-C)/2|0,E=this.b[T],y=E-this.a[T],S<y)R=T-1;else if(S>=E)C=T+1;else break;return new D(T,S-y)}}e.PrefixSumComputer=I;class A{constructor(S){this.a=S,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(S){return this.g(),S===0?0:this.d[S-1]}getIndexOf(S){this.g();const C=this.e[S],R=C>0?this.d[C-1]:0;return new D(C,S-R)}removeValues(S,C){this.a.splice(S,C),this.f(S)}insertValues(S,C){this.a=(0,a.arrayInsert)(this.a,S,C),this.f(S)}f(S){this.b=!1,this.c=Math.min(this.c,S-1)}g(){if(!this.b){for(let S=this.c+1,C=this.a.length;S<C;S++){const R=this.a[S],T=S>0?this.d[S-1]:0;this.d[S]=T+R;for(let E=0;E<R;E++)this.e[T+E]=S}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(S,C){this.a[S]!==C&&(this.a[S]=C,this.f(S))}}e.ConstantTimePrefixSumComputer=A;class D{constructor(S,C){this.index=S,this.remainder=C,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=C}}e.PrefixSumIndexOfResult=D}),define(Se[155],ye([19,20]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(Se[156],ye([1,0,155]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,I=t*60,A=I*24,D=A*7,k=A*30,S=A*365;function C(T,E,y){typeof T!="number"&&(T=T.getTime());const v=Math.round((new Date().getTime()-T)/1e3);if(v<-30)return(0,a.localize)(0,null,C(new Date().getTime()+v*1e3,!1));if(v<30)return(0,a.localize)(1,null);let d;return v<t?(d=v,E?d===1?y?(0,a.localize)(2,null,d):(0,a.localize)(3,null,d):y?(0,a.localize)(4,null,d):(0,a.localize)(5,null,d):d===1?y?(0,a.localize)(6,null,d):(0,a.localize)(7,null,d):y?(0,a.localize)(8,null,d):(0,a.localize)(9,null,d)):v<I?(d=Math.floor(v/t),E?d===1?y?(0,a.localize)(10,null,d):(0,a.localize)(11,null,d):y?(0,a.localize)(12,null,d):(0,a.localize)(13,null,d):d===1?y?(0,a.localize)(14,null,d):(0,a.localize)(15,null,d):y?(0,a.localize)(16,null,d):(0,a.localize)(17,null,d)):v<A?(d=Math.floor(v/I),E?d===1?y?(0,a.localize)(18,null,d):(0,a.localize)(19,null,d):y?(0,a.localize)(20,null,d):(0,a.localize)(21,null,d):d===1?y?(0,a.localize)(22,null,d):(0,a.localize)(23,null,d):y?(0,a.localize)(24,null,d):(0,a.localize)(25,null,d)):v<D?(d=Math.floor(v/A),E?d===1?(0,a.localize)(26,null,d):(0,a.localize)(27,null,d):d===1?(0,a.localize)(28,null,d):(0,a.localize)(29,null,d)):v<k?(d=Math.floor(v/D),E?d===1?y?(0,a.localize)(30,null,d):(0,a.localize)(31,null,d):y?(0,a.localize)(32,null,d):(0,a.localize)(33,null,d):d===1?y?(0,a.localize)(34,null,d):(0,a.localize)(35,null,d):y?(0,a.localize)(36,null,d):(0,a.localize)(37,null,d)):v<S?(d=Math.floor(v/k),E?d===1?y?(0,a.localize)(38,null,d):(0,a.localize)(39,null,d):y?(0,a.localize)(40,null,d):(0,a.localize)(41,null,d):d===1?y?(0,a.localize)(42,null,d):(0,a.localize)(43,null,d):y?(0,a.localize)(44,null,d):(0,a.localize)(45,null,d)):(d=Math.floor(v/S),E?d===1?y?(0,a.localize)(46,null,d):(0,a.localize)(47,null,d):y?(0,a.localize)(48,null,d):(0,a.localize)(49,null,d):d===1?y?(0,a.localize)(50,null,d):(0,a.localize)(51,null,d):y?(0,a.localize)(52,null,d):(0,a.localize)(53,null,d))}e.fromNow=C;function R(T){return T.getFullYear()+"-"+String(T.getMonth()+1).padStart(2,"0")+"-"+String(T.getDate()).padStart(2,"0")+"T"+String(T.getHours()).padStart(2,"0")+":"+String(T.getMinutes()).padStart(2,"0")+":"+String(T.getSeconds()).padStart(2,"0")+"."+(T.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Se[157],ye([19,20]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(Se[51],ye([1,0,17,11,157]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function A(T,E){return E&&(T.stack||T.stacktrace)?I.localize(0,null,k(T),D(T.stack)||D(T.stacktrace)):k(T)}function D(T){return Array.isArray(T)?T.join(`
`):T}function k(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?I.localize(1,null,T.message):T.message||I.localize(2,null)}function S(T=null,E=!1){if(!T)return I.localize(3,null);if(Array.isArray(T)){const y=a.coalesce(T),v=S(y[0],E);return y.length>1?I.localize(4,null,v,y.length):v}if(t.isString(T))return T;if(T.detail){const y=T.detail;if(y.error)return A(y.error,E);if(y.exception)return A(y.exception,E)}return T.stack?A(T,E):T.message?T.message:I.localize(5,null)}e.toErrorMessage=S;function C(T){const E=T;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=C;function R(T,E){let y;return typeof T=="string"?y=new Error(T):y=T,y.actions=E,y}e.createErrorWithActions=R}),define(Se[158],ye([19,20]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(Se[12],ye([1,0,158]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,I=!1,A=!1,D=!1,k=!1,S=!1,C=!1,R=!1,T=!1,E=!1,y,v=e.LANGUAGE_DEFAULT,d,b;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?f=e.globals.vscode.process:typeof process<"u"&&(f=process);const w=typeof f?.versions?.electron=="string",h=w&&f?.type==="renderer";if(typeof navigator=="object"&&!h)b=navigator.userAgent,t=b.indexOf("Windows")>=0,I=b.indexOf("Macintosh")>=0,R=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=b.indexOf("Linux")>=0,E=b?.indexOf("Mobi")>=0,S=!0,y=a.getConfiguredDefaultLocale(a.localize(0,null))||e.LANGUAGE_DEFAULT,v=y;else if(typeof f=="object"){t=f.platform==="win32",I=f.platform==="darwin",A=f.platform==="linux",D=A&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,C=w,T=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.LANGUAGE_DEFAULT,v=e.LANGUAGE_DEFAULT;const n=f.env.VSCODE_NLS_CONFIG;if(n)try{const r=JSON.parse(n),g=r.availableLanguages["*"];y=r.locale,v=g||e.LANGUAGE_DEFAULT,d=r._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var m;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(m=e.Platform||(e.Platform={}));function p(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=p;let o=0;I?o=1:t?o=3:A&&(o=2),e.isWindows=t,e.isMacintosh=I,e.isLinux=A,e.isLinuxSnap=D,e.isNative=k,e.isElectron=C,e.isWeb=S,e.isWebWorker=S&&typeof e.globals.importScripts=="function",e.isIOS=R,e.isMobile=E,e.isCI=T,e.platform=o,e.userAgent=b,e.language=v;var i;(function(n){function r(){return e.language}n.value=r;function g(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=g;function P(){return e.language==="en"}n.isDefault=P})(i=e.Language||(e.Language={})),e.locale=y,e.translationsConfigFile=d,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const n=[];e.globals.addEventListener("message",g=>{if(g.data&&g.data.vscodeScheduleAsyncWork)for(let P=0,L=n.length;P<L;P++){const z=n[P];if(z.id===g.data.vscodeScheduleAsyncWork){n.splice(P,1),z.callback();return}}});let r=0;return g=>{const P=++r;n.push({id:P,callback:g}),e.globals.postMessage({vscodeScheduleAsyncWork:P},"*")}}return n=>setTimeout(n)})();var l;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||R?2:t?1:3;let u=!0,s=!1;function c(){if(!s){s=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,u=new Uint16Array(n.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Se[36],ye([1,0,12]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof a.globals.vscode<"u"&&typeof a.globals.vscode.process<"u"){const I=a.globals.vscode.process;t={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return a.isWindows?"win32":a.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(Se[9],ye([1,0,36]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,I=97,A=90,D=122,k=46,S=47,C=92,R=58,T=63;class E extends Error{constructor(m,p,o){let i;typeof p=="string"&&p.indexOf("not ")===0?(i="must not be",p=p.replace(/^not /,"")):i="must be";const l=m.indexOf(".")!==-1?"property":"argument";let u=`The "${m}" ${l} ${i} of type ${p}`;u+=`. Received type ${typeof o}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function y(h,m){if(typeof h!="string")throw new E(m,"string",h)}function v(h){return h===S||h===C}function d(h){return h===S}function b(h){return h>=t&&h<=A||h>=I&&h<=D}function f(h,m,p,o){let i="",l=0,u=-1,s=0,c=0;for(let n=0;n<=h.length;++n){if(n<h.length)c=h.charCodeAt(n);else{if(o(c))break;c=S}if(o(c)){if(!(u===n-1||s===1))if(s===2){if(i.length<2||l!==2||i.charCodeAt(i.length-1)!==k||i.charCodeAt(i.length-2)!==k){if(i.length>2){const r=i.lastIndexOf(p);r===-1?(i="",l=0):(i=i.slice(0,r),l=i.length-1-i.lastIndexOf(p)),u=n,s=0;continue}else if(i.length!==0){i="",l=0,u=n,s=0;continue}}m&&(i+=i.length>0?`${p}..`:"..",l=2)}else i.length>0?i+=`${p}${h.slice(u+1,n)}`:i=h.slice(u+1,n),l=n-u-1;u=n,s=0}else c===k&&s!==-1?++s:s=-1}return i}function w(h,m){if(m===null||typeof m!="object")throw new E("pathObject","Object",m);const p=m.dir||m.root,o=m.base||`${m.name||""}${m.ext||""}`;return p?p===m.root?`${p}${o}`:`${p}${h}${o}`:o}e.win32={resolve(...h){let m="",p="",o=!1;for(let i=h.length-1;i>=-1;i--){let l;if(i>=0){if(l=h[i],y(l,"path"),l.length===0)continue}else m.length===0?l=a.cwd():(l=a.env[`=${m}`]||a.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==m.toLowerCase()&&l.charCodeAt(2)===C)&&(l=`${m}\\`));const u=l.length;let s=0,c="",n=!1;const r=l.charCodeAt(0);if(u===1)v(r)&&(s=1,n=!0);else if(v(r))if(n=!0,v(l.charCodeAt(1))){let g=2,P=g;for(;g<u&&!v(l.charCodeAt(g));)g++;if(g<u&&g!==P){const L=l.slice(P,g);for(P=g;g<u&&v(l.charCodeAt(g));)g++;if(g<u&&g!==P){for(P=g;g<u&&!v(l.charCodeAt(g));)g++;(g===u||g!==P)&&(c=`\\\\${L}\\${l.slice(P,g)}`,s=g)}}}else s=1;else b(r)&&l.charCodeAt(1)===R&&(c=l.slice(0,2),s=2,u>2&&v(l.charCodeAt(2))&&(n=!0,s=3));if(c.length>0)if(m.length>0){if(c.toLowerCase()!==m.toLowerCase())continue}else m=c;if(o){if(m.length>0)break}else if(p=`${l.slice(s)}\\${p}`,o=n,n&&m.length>0)break}return p=f(p,!o,"\\",v),o?`${m}\\${p}`:`${m}${p}`||"."},normalize(h){y(h,"path");const m=h.length;if(m===0)return".";let p=0,o,i=!1;const l=h.charCodeAt(0);if(m===1)return d(l)?"\\":h;if(v(l))if(i=!0,v(h.charCodeAt(1))){let s=2,c=s;for(;s<m&&!v(h.charCodeAt(s));)s++;if(s<m&&s!==c){const n=h.slice(c,s);for(c=s;s<m&&v(h.charCodeAt(s));)s++;if(s<m&&s!==c){for(c=s;s<m&&!v(h.charCodeAt(s));)s++;if(s===m)return`\\\\${n}\\${h.slice(c)}\\`;s!==c&&(o=`\\\\${n}\\${h.slice(c,s)}`,p=s)}}}else p=1;else b(l)&&h.charCodeAt(1)===R&&(o=h.slice(0,2),p=2,m>2&&v(h.charCodeAt(2))&&(i=!0,p=3));let u=p<m?f(h.slice(p),!i,"\\",v):"";return u.length===0&&!i&&(u="."),u.length>0&&v(h.charCodeAt(m-1))&&(u+="\\"),o===void 0?i?`\\${u}`:u:i?`${o}\\${u}`:`${o}${u}`},isAbsolute(h){y(h,"path");const m=h.length;if(m===0)return!1;const p=h.charCodeAt(0);return v(p)||m>2&&b(p)&&h.charCodeAt(1)===R&&v(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let m,p;for(let l=0;l<h.length;++l){const u=h[l];y(u,"path"),u.length>0&&(m===void 0?m=p=u:m+=`\\${u}`)}if(m===void 0)return".";let o=!0,i=0;if(typeof p=="string"&&v(p.charCodeAt(0))){++i;const l=p.length;l>1&&v(p.charCodeAt(1))&&(++i,l>2&&(v(p.charCodeAt(2))?++i:o=!1))}if(o){for(;i<m.length&&v(m.charCodeAt(i));)i++;i>=2&&(m=`\\${m.slice(i)}`)}return e.win32.normalize(m)},relative(h,m){if(y(h,"from"),y(m,"to"),h===m)return"";const p=e.win32.resolve(h),o=e.win32.resolve(m);if(p===o||(h=p.toLowerCase(),m=o.toLowerCase(),h===m))return"";let i=0;for(;i<h.length&&h.charCodeAt(i)===C;)i++;let l=h.length;for(;l-1>i&&h.charCodeAt(l-1)===C;)l--;const u=l-i;let s=0;for(;s<m.length&&m.charCodeAt(s)===C;)s++;let c=m.length;for(;c-1>s&&m.charCodeAt(c-1)===C;)c--;const n=c-s,r=u<n?u:n;let g=-1,P=0;for(;P<r;P++){const z=h.charCodeAt(i+P);if(z!==m.charCodeAt(s+P))break;z===C&&(g=P)}if(P!==r){if(g===-1)return o}else{if(n>r){if(m.charCodeAt(s+P)===C)return o.slice(s+P+1);if(P===2)return o.slice(s+P)}u>r&&(h.charCodeAt(i+P)===C?g=P:P===2&&(g=3)),g===-1&&(g=0)}let L="";for(P=i+g+1;P<=l;++P)(P===l||h.charCodeAt(P)===C)&&(L+=L.length===0?"..":"\\..");return s+=g,L.length>0?`${L}${o.slice(s,c)}`:(o.charCodeAt(s)===C&&++s,o.slice(s,c))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const m=e.win32.resolve(h);if(m.length<=2)return h;if(m.charCodeAt(0)===C){if(m.charCodeAt(1)===C){const p=m.charCodeAt(2);if(p!==T&&p!==k)return`\\\\?\\UNC\\${m.slice(2)}`}}else if(b(m.charCodeAt(0))&&m.charCodeAt(1)===R&&m.charCodeAt(2)===C)return`\\\\?\\${m}`;return h},dirname(h){y(h,"path");const m=h.length;if(m===0)return".";let p=-1,o=0;const i=h.charCodeAt(0);if(m===1)return v(i)?h:".";if(v(i)){if(p=o=1,v(h.charCodeAt(1))){let s=2,c=s;for(;s<m&&!v(h.charCodeAt(s));)s++;if(s<m&&s!==c){for(c=s;s<m&&v(h.charCodeAt(s));)s++;if(s<m&&s!==c){for(c=s;s<m&&!v(h.charCodeAt(s));)s++;if(s===m)return h;s!==c&&(p=o=s+1)}}}}else b(i)&&h.charCodeAt(1)===R&&(p=m>2&&v(h.charCodeAt(2))?3:2,o=p);let l=-1,u=!0;for(let s=m-1;s>=o;--s)if(v(h.charCodeAt(s))){if(!u){l=s;break}}else u=!1;if(l===-1){if(p===-1)return".";l=p}return h.slice(0,l)},basename(h,m){m!==void 0&&y(m,"ext"),y(h,"path");let p=0,o=-1,i=!0,l;if(h.length>=2&&b(h.charCodeAt(0))&&h.charCodeAt(1)===R&&(p=2),m!==void 0&&m.length>0&&m.length<=h.length){if(m===h)return"";let u=m.length-1,s=-1;for(l=h.length-1;l>=p;--l){const c=h.charCodeAt(l);if(v(c)){if(!i){p=l+1;break}}else s===-1&&(i=!1,s=l+1),u>=0&&(c===m.charCodeAt(u)?--u===-1&&(o=l):(u=-1,o=s))}return p===o?o=s:o===-1&&(o=h.length),h.slice(p,o)}for(l=h.length-1;l>=p;--l)if(v(h.charCodeAt(l))){if(!i){p=l+1;break}}else o===-1&&(i=!1,o=l+1);return o===-1?"":h.slice(p,o)},extname(h){y(h,"path");let m=0,p=-1,o=0,i=-1,l=!0,u=0;h.length>=2&&h.charCodeAt(1)===R&&b(h.charCodeAt(0))&&(m=o=2);for(let s=h.length-1;s>=m;--s){const c=h.charCodeAt(s);if(v(c)){if(!l){o=s+1;break}continue}i===-1&&(l=!1,i=s+1),c===k?p===-1?p=s:u!==1&&(u=1):p!==-1&&(u=-1)}return p===-1||i===-1||u===0||u===1&&p===i-1&&p===o+1?"":h.slice(p,i)},format:w.bind(null,"\\"),parse(h){y(h,"path");const m={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return m;const p=h.length;let o=0,i=h.charCodeAt(0);if(p===1)return v(i)?(m.root=m.dir=h,m):(m.base=m.name=h,m);if(v(i)){if(o=1,v(h.charCodeAt(1))){let g=2,P=g;for(;g<p&&!v(h.charCodeAt(g));)g++;if(g<p&&g!==P){for(P=g;g<p&&v(h.charCodeAt(g));)g++;if(g<p&&g!==P){for(P=g;g<p&&!v(h.charCodeAt(g));)g++;g===p?o=g:g!==P&&(o=g+1)}}}}else if(b(i)&&h.charCodeAt(1)===R){if(p<=2)return m.root=m.dir=h,m;if(o=2,v(h.charCodeAt(2))){if(p===3)return m.root=m.dir=h,m;o=3}}o>0&&(m.root=h.slice(0,o));let l=-1,u=o,s=-1,c=!0,n=h.length-1,r=0;for(;n>=o;--n){if(i=h.charCodeAt(n),v(i)){if(!c){u=n+1;break}continue}s===-1&&(c=!1,s=n+1),i===k?l===-1?l=n:r!==1&&(r=1):l!==-1&&(r=-1)}return s!==-1&&(l===-1||r===0||r===1&&l===s-1&&l===u+1?m.base=m.name=h.slice(u,s):(m.name=h.slice(u,l),m.base=h.slice(u,s),m.ext=h.slice(l,s))),u>0&&u!==o?m.dir=h.slice(0,u-1):m.dir=m.root,m},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let m="",p=!1;for(let o=h.length-1;o>=-1&&!p;o--){const i=o>=0?h[o]:a.cwd();y(i,"path"),i.length!==0&&(m=`${i}/${m}`,p=i.charCodeAt(0)===S)}return m=f(m,!p,"/",d),p?`/${m}`:m.length>0?m:"."},normalize(h){if(y(h,"path"),h.length===0)return".";const m=h.charCodeAt(0)===S,p=h.charCodeAt(h.length-1)===S;return h=f(h,!m,"/",d),h.length===0?m?"/":p?"./":".":(p&&(h+="/"),m?`/${h}`:h)},isAbsolute(h){return y(h,"path"),h.length>0&&h.charCodeAt(0)===S},join(...h){if(h.length===0)return".";let m;for(let p=0;p<h.length;++p){const o=h[p];y(o,"path"),o.length>0&&(m===void 0?m=o:m+=`/${o}`)}return m===void 0?".":e.posix.normalize(m)},relative(h,m){if(y(h,"from"),y(m,"to"),h===m||(h=e.posix.resolve(h),m=e.posix.resolve(m),h===m))return"";const p=1,o=h.length,i=o-p,l=1,u=m.length-l,s=i<u?i:u;let c=-1,n=0;for(;n<s;n++){const g=h.charCodeAt(p+n);if(g!==m.charCodeAt(l+n))break;g===S&&(c=n)}if(n===s)if(u>s){if(m.charCodeAt(l+n)===S)return m.slice(l+n+1);if(n===0)return m.slice(l+n)}else i>s&&(h.charCodeAt(p+n)===S?c=n:n===0&&(c=0));let r="";for(n=p+c+1;n<=o;++n)(n===o||h.charCodeAt(n)===S)&&(r+=r.length===0?"..":"/..");return`${r}${m.slice(l+c)}`},toNamespacedPath(h){return h},dirname(h){if(y(h,"path"),h.length===0)return".";const m=h.charCodeAt(0)===S;let p=-1,o=!0;for(let i=h.length-1;i>=1;--i)if(h.charCodeAt(i)===S){if(!o){p=i;break}}else o=!1;return p===-1?m?"/":".":m&&p===1?"//":h.slice(0,p)},basename(h,m){m!==void 0&&y(m,"ext"),y(h,"path");let p=0,o=-1,i=!0,l;if(m!==void 0&&m.length>0&&m.length<=h.length){if(m===h)return"";let u=m.length-1,s=-1;for(l=h.length-1;l>=0;--l){const c=h.charCodeAt(l);if(c===S){if(!i){p=l+1;break}}else s===-1&&(i=!1,s=l+1),u>=0&&(c===m.charCodeAt(u)?--u===-1&&(o=l):(u=-1,o=s))}return p===o?o=s:o===-1&&(o=h.length),h.slice(p,o)}for(l=h.length-1;l>=0;--l)if(h.charCodeAt(l)===S){if(!i){p=l+1;break}}else o===-1&&(i=!1,o=l+1);return o===-1?"":h.slice(p,o)},extname(h){y(h,"path");let m=-1,p=0,o=-1,i=!0,l=0;for(let u=h.length-1;u>=0;--u){const s=h.charCodeAt(u);if(s===S){if(!i){p=u+1;break}continue}o===-1&&(i=!1,o=u+1),s===k?m===-1?m=u:l!==1&&(l=1):m!==-1&&(l=-1)}return m===-1||o===-1||l===0||l===1&&m===o-1&&m===p+1?"":h.slice(m,o)},format:w.bind(null,"/"),parse(h){y(h,"path");const m={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return m;const p=h.charCodeAt(0)===S;let o;p?(m.root="/",o=1):o=0;let i=-1,l=0,u=-1,s=!0,c=h.length-1,n=0;for(;c>=o;--c){const r=h.charCodeAt(c);if(r===S){if(!s){l=c+1;break}continue}u===-1&&(s=!1,u=c+1),r===k?i===-1?i=c:n!==1&&(n=1):i!==-1&&(n=-1)}if(u!==-1){const r=l===0&&p?1:l;i===-1||n===0||n===1&&i===u-1&&i===l+1?m.base=m.name=h.slice(r,u):(m.name=h.slice(r,i),m.base=h.slice(r,u),m.ext=h.slice(i,u))}return l>0?m.dir=h.slice(0,l-1):p&&(m.dir="/"),m},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=a.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=a.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=a.platform==="win32"?e.win32.join:e.posix.join,e.resolve=a.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=a.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=a.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=a.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=a.platform==="win32"?e.win32.extname:e.posix.extname,e.format=a.platform==="win32"?e.win32.format:e.posix.format,e.parse=a.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=a.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=a.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=a.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Se[83],ye([1,0,9]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(R){const T=(0,a.extname)(R),E=t[T.toLowerCase()];return E!==void 0?E:D(R)}e.getMediaOrTextMime=A;function D(R){const T=(0,a.extname)(R);return I[T.toLowerCase()]}e.getMediaMime=D;function k(R){for(const T in I)if(I[T]===R)return T}e.getExtensionForMimeType=k;const S=/^(.+)\/(.+?)(;.+)?$/;function C(R,T){const E=S.exec(R);return E?`${E[1].toLowerCase()}/${E[2].toLowerCase()}${E[3]??""}`:T?void 0:R}e.normalizeMimeType=C}),define(Se[106],ye([1,0,12]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var I;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(I=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(k,...S){const C=S.reduce((E,y)=>(E[y]=!0,E),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(E=>!C[E]).forEach(E=>{for(let y=0;y<R.length;y++)if(E.search(R[y])!==-1){delete k[E];break}})}e.sanitizeProcessEnvironment=A;function D(k){!k||(delete k.DEBUG,a.isMacintosh&&delete k.DYLD_LIBRARY_PATH,a.isLinux&&delete k.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(Se[44],ye([1,0,12]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=a.globals.performance&&typeof a.globals.performance.now=="function";class I{static create(D=!0){return new I(D)}constructor(D){this.a=t&&D,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?a.globals.performance.now():Date.now()}}e.StopWatch=I}),define(Se[4],ye([1,0,10,61,6,63,44]),function(ne,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const k=!1,S=!1;var C;(function(c){c.None=()=>I.Disposable.None;function n(De){if(S){const{onDidAddListener:Re}=De,ze=v.create();let se=0;De.onDidAddListener=()=>{++se===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ze.print()),Re?.()}}}function r(De,Re){return N(De,()=>{},0,void 0,void 0,Re)}c.defer=r;function g(De){return(Re,ze=null,se)=>{let ue=!1,he;return he=De(ee=>{if(!ue)return he?he.dispose():ue=!0,Re.call(ze,ee)},null,se),ue&&he.dispose(),he}}c.once=g;function P(De,Re,ze){return M((se,ue=null,he)=>De(ee=>se.call(ue,Re(ee)),null,he),ze)}c.map=P;function L(De,Re,ze){return M((se,ue=null,he)=>De(ee=>{Re(ee),se.call(ue,ee)},null,he),ze)}c.forEach=L;function z(De,Re,ze){return M((se,ue=null,he)=>De(ee=>Re(ee)&&se.call(ue,ee),null,he),ze)}c.filter=z;function _(De){return De}c.signal=_;function K(...De){return(Re,ze=null,se)=>(0,I.combinedDisposable)(...De.map(ue=>ue(he=>Re.call(ze,he),null,se)))}c.any=K;function F(De,Re,ze,se){let ue=ze;return P(De,he=>(ue=Re(ue,he),ue),se)}c.reduce=F;function M(De,Re){let ze;const se={onWillAddFirstListener(){ze=De(ue.fire,ue)},onDidRemoveLastListener(){ze?.dispose()}};Re||n(se);const ue=new b(se);return Re?.add(ue),ue.event}function N(De,Re,ze=100,se=!1,ue,he){let ee,oe,ie,O=0;const H={leakWarningThreshold:ue,onWillAddFirstListener(){ee=De(Y=>{O++,oe=Re(oe,Y),se&&!ie&&(q.fire(oe),oe=void 0),clearTimeout(ie),ie=setTimeout(()=>{const de=oe;oe=void 0,ie=void 0,(!se||O>1)&&q.fire(de),O=0},ze)})},onDidRemoveLastListener(){ee.dispose()}};he||n(H);const q=new b(H);return he?.add(q),q.event}c.debounce=N;function B(De,Re=0,ze){return c.debounce(De,(se,ue)=>se?(se.push(ue),se):[ue],Re,void 0,void 0,ze)}c.accumulate=B;function U(De,Re=(se,ue)=>se===ue,ze){let se=!0,ue;return z(De,he=>{const ee=se||!Re(he,ue);return se=!1,ue=he,ee},ze)}c.latch=U;function W(De,Re,ze){return[c.filter(De,Re,ze),c.filter(De,se=>!Re(se),ze)]}c.split=W;function x(De,Re=!1,ze=[]){let se=ze.slice(),ue=De(oe=>{se?se.push(oe):ee.fire(oe)});const he=()=>{se?.forEach(oe=>ee.fire(oe)),se=null},ee=new b({onWillAddFirstListener(){ue||(ue=De(oe=>ee.fire(oe)))},onDidAddFirstListener(){se&&(Re?setTimeout(he):he())},onDidRemoveLastListener(){ue&&ue.dispose(),ue=null}});return ee.event}c.buffer=x;class V{constructor(Re){this.event=Re,this.c=new I.DisposableStore}map(Re){return new V(P(this.event,Re,this.c))}forEach(Re){return new V(L(this.event,Re,this.c))}filter(Re){return new V(z(this.event,Re,this.c))}reduce(Re,ze){return new V(F(this.event,Re,ze,this.c))}latch(){return new V(U(this.event,void 0,this.c))}debounce(Re,ze=100,se=!1,ue){return new V(N(this.event,Re,ze,se,ue,this.c))}on(Re,ze,se){return this.event(Re,ze,se)}once(Re,ze,se){return g(this.event)(Re,ze,se)}dispose(){this.c.dispose()}}function X(De){return new V(De)}c.chain=X;function Q(De,Re,ze=se=>se){const se=(...oe)=>ee.fire(ze(...oe)),ue=()=>De.on(Re,se),he=()=>De.removeListener(Re,se),ee=new b({onWillAddFirstListener:ue,onDidRemoveLastListener:he});return ee.event}c.fromNodeEventEmitter=Q;function J(De,Re,ze=se=>se){const se=(...oe)=>ee.fire(ze(...oe)),ue=()=>De.addEventListener(Re,se),he=()=>De.removeEventListener(Re,se),ee=new b({onWillAddFirstListener:ue,onDidRemoveLastListener:he});return ee.event}c.fromDOMEventEmitter=J;function te(De){return new Promise(Re=>g(De)(Re))}c.toPromise=te;function le(De,Re){return Re(void 0),De(ze=>Re(ze))}c.runAndSubscribe=le;function Z(De,Re){let ze=null;function se(he){ze?.dispose(),ze=new I.DisposableStore,Re(he,ze)}se(void 0);const ue=De(he=>se(he));return(0,I.toDisposable)(()=>{ue.dispose(),ze?.dispose()})}c.runAndSubscribeWithStore=Z;class ge{constructor(Re,ze){this.obs=Re,this.c=0,this.d=!1;const se={onWillAddFirstListener:()=>{Re.addObserver(this)},onDidRemoveLastListener:()=>{Re.removeObserver(this)}};ze||n(se),this.emitter=new b(se),ze&&ze.add(this.emitter)}beginUpdate(Re){this.c++}handleChange(Re,ze){this.d=!0}endUpdate(Re){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function ve(De,Re){return new ge(De,Re).emitter.event}c.fromObservable=ve})(C=e.Event||(e.Event={}));class R{constructor(n){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${n}_${R.c++}`,R.all.add(this)}start(n){this.d=new D.StopWatch(!0),this.listenerCount=n}stop(){if(this.d){const n=this.d.elapsed();this.durations.push(n),this.elapsedOverall+=n,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=R,R.all=new Set,R.c=0;let T=-1;function E(c){const n=T;return T=c,{dispose(){T=n}}}e.setGlobalLeakWarningThreshold=E;class y{constructor(n,r=Math.random().toString(18).slice(2,5)){this.threshold=n,this.name=r,this.d=0}dispose(){this.c?.clear()}check(n,r){const g=this.threshold;if(g<=0||r<g)return;this.c||(this.c=new Map);const P=this.c.get(n.value)||0;if(this.c.set(n.value,P+1),this.d-=1,this.d<=0){this.d=g*.5;let L,z=0;for(const[_,K]of this.c)(!L||z<K)&&(L=_,z=K);console.warn(`[${this.name}] potential listener LEAK detected, having ${r} listeners already. MOST frequent listener (${z}):`),console.warn(L)}return()=>{const L=this.c.get(n.value)||0;this.c.set(n.value,L-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(n){this.value=n}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d{constructor(n,r,g){this.callback=n,this.callbackThis=r,this.stack=g,this.subscription=new I.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class b{constructor(n){this.j=!1,this.d=n,this.f=T>0||this.d?.leakWarningThreshold?new y(this.d?.leakWarningThreshold??T):void 0,this.g=this.d?._profName?new R(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(k){const n=Array.from(this.q);queueMicrotask(()=>{for(const r of n)r.subscription.isset()&&(r.subscription.unset(),r.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(n,r,g)=>{if(this.q||(this.q=new A.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),I.Disposable.None;const P=this.q.isEmpty();P&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let L,z;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(z=v.create(),L=this.f.check(z,this.q.size+1)),k&&(z=z??v.create());const _=new d(n,r,z),K=this.q.push(_);P&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,n,r);const F=_.subscription.set(()=>{L?.(),this.j||(K(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return g instanceof I.DisposableStore?g.add(F):Array.isArray(g)&&g.push(F),F}),this.l}fire(n){if(this.q){this.m||(this.m=new w);for(const r of this.q)this.m.push(this,r,n);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=b;class f{constructor(){this.c=new A.LinkedList}get size(){return this.c.size}push(n,r,g){this.c.push(new h(n,r,g))}clear(n){const r=new A.LinkedList;for(const g of this.c)g.emitter!==n&&r.push(g);this.c=r}deliver(){for(;this.c.size>0;){const n=this.c.shift();try{n.listener.invoke(n.event)}catch(r){(0,a.onUnexpectedError)(r)}}}}e.EventDeliveryQueue=f;class w extends f{clear(n){this.c.clear()}}class h{constructor(n,r,g){this.emitter=n,this.listener=r,this.event=g}}class m extends b{async fireAsync(n,r,g){if(!!this.q){this.c||(this.c=new A.LinkedList);for(const P of this.q)this.c.push([P,n]);for(;this.c.size>0&&!r.isCancellationRequested;){const[P,L]=this.c.shift(),z=[],_={...L,token:r,waitUntil:K=>{if(Object.isFrozen(z))throw new Error("waitUntil can NOT be called asynchronous");g&&(K=g(K,P.callback)),z.push(K)}};try{P.invoke(_)}catch(K){(0,a.onUnexpectedError)(K);continue}Object.freeze(z),await Promise.allSettled(z).then(K=>{for(const F of K)F.status==="rejected"&&(0,a.onUnexpectedError)(F.reason)})}}}}e.AsyncEmitter=m;class p extends b{constructor(n){super(n),this.h=0,this.s=new A.LinkedList,this.t=n?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const n=Array.from(this.s);this.s.clear(),super.fire(this.t(n))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(n){this.q&&(this.h!==0?this.s.push(n):super.fire(n))}}e.PauseableEmitter=p;class o extends p{constructor(n){super(n),this.c=n.delay??100}fire(n){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(n)}}e.DebounceEmitter=o;class i extends b{constructor(n){super(n),this.c=[],this.h=n?.merge}fire(n){!this.hasListeners()||(this.c.push(n),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(r=>super.fire(r)),this.c=[]}))}}e.MicrotaskEmitter=i;class l{constructor(){this.d=!1,this.f=[],this.c=new b({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(n){const r={event:n,listener:null};this.f.push(r),this.d&&this.j(r);const g=()=>{this.d&&this.k(r);const P=this.f.indexOf(r);this.f.splice(P,1)};return(0,I.toDisposable)((0,t.once)(g))}g(){this.d=!0,this.f.forEach(n=>this.j(n))}h(){this.d=!1,this.f.forEach(n=>this.k(n))}j(n){n.listener=n.event(r=>this.c.fire(r))}k(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=l;class u{constructor(){this.c=[]}wrapEvent(n){return(r,g,P)=>n(L=>{const z=this.c[this.c.length-1];z?z.push(()=>r.call(g,L)):r.call(g,L)},void 0,P)}bufferEvents(n){const r=[];this.c.push(r);const g=n();return this.c.pop(),r.forEach(P=>P()),g}}e.EventBufferer=u;class s{constructor(){this.c=!1,this.d=C.None,this.f=I.Disposable.None,this.g=new b({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(n){this.d=n,this.c&&(this.f.dispose(),this.f=n(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=s}),define(Se[21],ye([1,0,4]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(k,S){const C=setTimeout(k.bind(S),0);return{dispose(){clearTimeout(C)}}});var I;(function(k){function S(C){return C===k.None||C===k.Cancelled||C instanceof A?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}k.isCancellationToken=S,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:a.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(I=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new a.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(S){this.a=void 0,this.b=void 0,this.b=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new A),this.a}cancel(){this.a?this.a instanceof A&&this.a.cancel():this.a=I.Cancelled}dispose(S=!1){S&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof A&&this.a.dispose():this.a=I.None}}e.CancellationTokenSource=D}),define(Se[159],ye([1,0,21]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new a.CancellationTokenSource,S=this.b(k.token);return this.a={promise:S,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}e.Cache=t;class I{constructor(k){this.c=k,this.a=void 0,this.b=void 0}get(k){const S=JSON.stringify(k);return this.b!==S&&(this.b=S,this.a=this.c(k)),this.a}}e.LRUCachedFunction=I;class A{get cachedValues(){return this.a}constructor(k){this.b=k,this.a=new Map}get(k){if(this.a.has(k))return this.a.get(k);const S=this.b(k);return this.a.set(k,S),S}}e.CachedFunction=A}),define(Se[8],ye([1,0,159,81]),function(ne,e,a,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A($){return!$||typeof $!="string"?!0:$.trim().length===0}e.isFalsyOrWhitespace=A;const D=/{(\d+)}/g;function k($,...ce){return ce.length===0?$:$.replace(D,function(Ie,Le){const Be=parseInt(Le,10);return isNaN(Be)||Be<0||Be>=ce.length?Ie:ce[Be]})}e.format=k;const S=/{([^}]+)}/g;function C($,ce){return $.replace(S,(Ie,Le)=>ce[Le]??Ie)}e.format2=C;function R($){return $.replace(/[<>&]/g,function(ce){switch(ce){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ce}})}e.escape=R;function T($){return $.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=T;function E($,ce){let Ie=0;const Le=ce.charCodeAt(0);for(let Be=$.length-1;Be>=0;Be--)$.charCodeAt(Be)===Le&&Ie++;return Ie}e.count=E;function y($,ce,Ie="\u2026"){return $.length<=ce?$:`${$.substr(0,ce)}${Ie}`}e.truncate=y;function v($,ce=" "){const Ie=d($,ce);return b(Ie,ce)}e.trim=v;function d($,ce){if(!$||!ce)return $;const Ie=ce.length;if(Ie===0||$.length===0)return $;let Le=0;for(;$.indexOf(ce,Le)===Le;)Le=Le+Ie;return $.substring(Le)}e.ltrim=d;function b($,ce){if(!$||!ce)return $;const Ie=ce.length,Le=$.length;if(Ie===0||Le===0)return $;let Be=Le,xe=-1;for(;xe=$.lastIndexOf(ce,Be-1),!(xe===-1||xe+Ie!==Be);){if(xe===0)return"";Be=xe}return $.substring(0,Be)}e.rtrim=b;function f($){return $.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function w($){return $.replace(/\*/g,"")}e.stripWildcards=w;function h($,ce,Ie={}){if(!$)throw new Error("Cannot create regex from empty string");ce||($=T($)),Ie.wholeWord&&(/\B/.test($.charAt(0))||($="\\b"+$),/\B/.test($.charAt($.length-1))||($=$+"\\b"));let Le="";return Ie.global&&(Le+="g"),Ie.matchCase||(Le+="i"),Ie.multiline&&(Le+="m"),Ie.unicode&&(Le+="u"),new RegExp($,Le)}e.createRegExp=h;function m($){return $.source==="^"||$.source==="^$"||$.source==="$"||$.source==="^\\s*$"?!1:!!($.exec("")&&$.lastIndex===0)}e.regExpLeadsToEndlessLoop=m;function p($){return!!$.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function o($){return($.global?"g":"")+($.ignoreCase?"i":"")+($.multiline?"m":"")+($.unicode?"u":"")}e.regExpFlags=o;function i($){return $.split(/\r\n|\r|\n/)}e.splitLines=i;function l($){for(let ce=0,Ie=$.length;ce<Ie;ce++){const Le=$.charCodeAt(ce);if(Le!==32&&Le!==9)return ce}return-1}e.firstNonWhitespaceIndex=l;function u($,ce=0,Ie=$.length){for(let Le=ce;Le<Ie;Le++){const Be=$.charCodeAt(Le);if(Be!==32&&Be!==9)return $.substring(ce,Le)}return $.substring(ce,Ie)}e.getLeadingWhitespace=u;function s($,ce=$.length-1){for(let Ie=ce;Ie>=0;Ie--){const Le=$.charCodeAt(Ie);if(Le!==32&&Le!==9)return Ie}return-1}e.lastNonWhitespaceIndex=s;function c($,ce,Ie){const Le=[];let Be=0;for(const xe of $.matchAll(ce)){if(Le.push($.slice(Be,xe.index)),xe.index===void 0)throw new Error("match.index should be defined");Be=xe.index+xe[0].length,Le.push(Ie(xe[0],...xe.slice(1),xe.index,$,xe.groups))}return Le.push($.slice(Be)),Promise.all(Le).then(xe=>xe.join(""))}e.replaceAsync=c;function n($,ce){return $<ce?-1:$>ce?1:0}e.compare=n;function r($,ce,Ie=0,Le=$.length,Be=0,xe=ce.length){for(;Ie<Le&&Be<xe;Ie++,Be++){const ft=$.charCodeAt(Ie),lt=ce.charCodeAt(Be);if(ft<lt)return-1;if(ft>lt)return 1}const Ze=Le-Ie,mt=xe-Be;return Ze<mt?-1:Ze>mt?1:0}e.compareSubstring=r;function g($,ce){return P($,ce,0,$.length,0,ce.length)}e.compareIgnoreCase=g;function P($,ce,Ie=0,Le=$.length,Be=0,xe=ce.length){for(;Ie<Le&&Be<xe;Ie++,Be++){let ft=$.charCodeAt(Ie),lt=ce.charCodeAt(Be);if(ft===lt)continue;if(ft>=128||lt>=128)return r($.toLowerCase(),ce.toLowerCase(),Ie,Le,Be,xe);z(ft)&&(ft-=32),z(lt)&&(lt-=32);const ot=ft-lt;if(ot!==0)return ot}const Ze=Le-Ie,mt=xe-Be;return Ze<mt?-1:Ze>mt?1:0}e.compareSubstringIgnoreCase=P;function L($){return $>=48&&$<=57}e.isAsciiDigit=L;function z($){return $>=97&&$<=122}e.isLowerAsciiLetter=z;function _($){return $>=65&&$<=90}e.isUpperAsciiLetter=_;function K($,ce){return $.length===ce.length&&P($,ce)===0}e.equalsIgnoreCase=K;function F($,ce){const Ie=ce.length;return ce.length>$.length?!1:P($,ce,0,Ie)===0}e.startsWithIgnoreCase=F;function M($,ce){const Ie=Math.min($.length,ce.length);let Le;for(Le=0;Le<Ie;Le++)if($.charCodeAt(Le)!==ce.charCodeAt(Le))return Le;return Ie}e.commonPrefixLength=M;function N($,ce){const Ie=Math.min($.length,ce.length);let Le;const Be=$.length-1,xe=ce.length-1;for(Le=0;Le<Ie;Le++)if($.charCodeAt(Be-Le)!==ce.charCodeAt(xe-Le))return Le;return Ie}e.commonSuffixLength=N;function B($){return 55296<=$&&$<=56319}e.isHighSurrogate=B;function U($){return 56320<=$&&$<=57343}e.isLowSurrogate=U;function W($,ce){return($-55296<<10)+(ce-56320)+65536}e.computeCodePoint=W;function x($,ce,Ie){const Le=$.charCodeAt(Ie);if(B(Le)&&Ie+1<ce){const Be=$.charCodeAt(Ie+1);if(U(Be))return W(Le,Be)}return Le}e.getNextCodePoint=x;function V($,ce){const Ie=$.charCodeAt(ce-1);if(U(Ie)&&ce>1){const Le=$.charCodeAt(ce-2);if(B(Le))return W(Le,Ie)}return Ie}class X{get offset(){return this.e}constructor(ce,Ie=0){this.c=ce,this.d=ce.length,this.e=Ie}setOffset(ce){this.e=ce}prevCodePoint(){const ce=V(this.c,this.e);return this.e-=ce>=65536?2:1,ce}nextCodePoint(){const ce=x(this.c,this.d,this.e);return this.e+=ce>=65536?2:1,ce}eol(){return this.e>=this.d}}e.CodePointIterator=X;class Q{get offset(){return this.c.offset}constructor(ce,Ie=0){this.c=new X(ce,Ie)}nextGraphemeLength(){const ce=et.getInstance(),Ie=this.c,Le=Ie.offset;let Be=ce.getGraphemeBreakType(Ie.nextCodePoint());for(;!Ie.eol();){const xe=Ie.offset,Ze=ce.getGraphemeBreakType(Ie.nextCodePoint());if(je(Be,Ze)){Ie.setOffset(xe);break}Be=Ze}return Ie.offset-Le}prevGraphemeLength(){const ce=et.getInstance(),Ie=this.c,Le=Ie.offset;let Be=ce.getGraphemeBreakType(Ie.prevCodePoint());for(;Ie.offset>0;){const xe=Ie.offset,Ze=ce.getGraphemeBreakType(Ie.prevCodePoint());if(je(Ze,Be)){Ie.setOffset(xe);break}Be=Ze}return Le-Ie.offset}eol(){return this.c.eol()}}e.GraphemeIterator=Q;function J($,ce){return new Q($,ce).nextGraphemeLength()}e.nextCharLength=J;function te($,ce){return new Q($,ce).prevGraphemeLength()}e.prevCharLength=te;function le($,ce){ce>0&&U($.charCodeAt(ce))&&ce--;const Ie=ce+J($,ce);return[Ie-te($,Ie),Ie]}e.getCharContainingOffset=le;function Z($){const ce=new Q($);let Ie=0;for(;!ce.eol();)Ie++,ce.nextGraphemeLength();return Ie}e.charCount=Z;let ge;function ve(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function De($){return ge||(ge=ve()),ge.test($)}e.containsRTL=De;const Re=/^[\t\n\r\x20-\x7E]*$/;function ze($){return Re.test($)}e.isBasicASCII=ze,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function se($){return e.UNUSUAL_LINE_TERMINATORS.test($)}e.containsUnusualLineTerminators=se;function ue($){return $>=11904&&$<=55215||$>=63744&&$<=64255||$>=65281&&$<=65374}e.isFullWidthCharacter=ue;function he($){return $>=127462&&$<=127487||$===8986||$===8987||$===9200||$===9203||$>=9728&&$<=10175||$===11088||$===11093||$>=127744&&$<=128591||$>=128640&&$<=128764||$>=128992&&$<=129008||$>=129280&&$<=129535||$>=129648&&$<=129782}e.isEmojiImprecise=he;function ee($,ce){if($.length<ce)return $;const Ie=/\b/g;let Le=0;for(;Ie.test($)&&!($.length-Ie.lastIndex<ce);)Le=Ie.lastIndex,Ie.lastIndex+=1;return $.substring(Le).replace(/^\s/,"")}e.lcut=ee;const oe=/\x1B\x5B[12]?K/g,ie=/\x1b\[\d+m/g,O=/\x1b\[0?m/g;function H($){return $&&($=$.replace(oe,""),$=$.replace(ie,""),$=$.replace(O,"")),$}e.removeAnsiEscapeCodes=H,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function q($){return!!($&&$.length>0&&$.charCodeAt(0)===65279)}e.startsWithUTF8BOM=q;function Y($){return q($)?$.substr(1):$}e.stripUTF8BOM=Y;function de($,ce){if(!$||!ce||$.length<ce.length)return!1;const Ie=ce.length,Le=$.toLowerCase();let Be=0,xe=-1;for(;Be<Ie;){const Ze=Le.indexOf(ce[Be],xe+1);if(Ze<0)return!1;xe=Ze,Be++}return!0}e.fuzzyContains=de;function be($,ce=!1){return $?(ce&&($=$.replace(/\\./g,"")),$.toLowerCase()!==$):!1}e.containsUppercaseCharacter=be;function Pe($){return $.charAt(0).toUpperCase()+$.slice(1)}e.uppercaseFirstLetter=Pe;function pe($,ce=1){if(ce===0)return"";let Ie=-1;do Ie=$.indexOf(`
`,Ie+1),ce--;while(ce>0&&Ie>=0);return Ie===-1?$:($[Ie-1]==="\r"&&Ie--,$.substr(0,Ie))}e.getNLines=pe;function Ce($){return $=$%(2*26),$<26?String.fromCharCode(97+$):String.fromCharCode(65+$-26)}e.singleLetterHash=Ce;function ke($){return et.getInstance().getGraphemeBreakType($)}e.getGraphemeBreakType=ke;function je($,ce){return $===0?ce!==5&&ce!==7:$===2&&ce===3?!1:$===4||$===2||$===3||ce===4||ce===2||ce===3?!0:!($===8&&(ce===8||ce===9||ce===11||ce===12)||($===11||$===9)&&(ce===9||ce===10)||($===12||$===10)&&ce===10||ce===5||ce===13||ce===7||$===1||$===13&&ce===14||$===6&&ce===6)}var Ge;(function($){$[$.Other=0]="Other",$[$.Prepend=1]="Prepend",$[$.CR=2]="CR",$[$.LF=3]="LF",$[$.Control=4]="Control",$[$.Extend=5]="Extend",$[$.Regional_Indicator=6]="Regional_Indicator",$[$.SpacingMark=7]="SpacingMark",$[$.L=8]="L",$[$.V=9]="V",$[$.T=10]="T",$[$.LV=11]="LV",$[$.LVT=12]="LVT",$[$.ZWJ=13]="ZWJ",$[$.Extended_Pictographic=14]="Extended_Pictographic"})(Ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class et{static getInstance(){return et.c||(et.c=new et),et.c}constructor(){this.d=_e()}getGraphemeBreakType(ce){if(ce<32)return ce===10?3:ce===13?2:4;if(ce<127)return 0;const Ie=this.d,Le=Ie.length/3;let Be=1;for(;Be<=Le;)if(ce<Ie[3*Be])Be=2*Be;else if(ce>Ie[3*Be+1])Be=2*Be+1;else return Ie[3*Be+2];return 0}}et.c=null;function _e(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function nt($,ce){if($===0)return 0;const Ie=st($,ce);if(Ie!==void 0)return Ie;const Le=new X(ce,$);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=nt;function st($,ce){const Ie=new X(ce,$);let Le=Ie.prevCodePoint();for(;ht(Le)||Le===65039||Le===8419;){if(Ie.offset===0)return;Le=Ie.prevCodePoint()}if(!he(Le))return;let Be=Ie.offset;return Be>0&&Ie.prevCodePoint()===8205&&(Be=Ie.offset),Be}function ht($){return 127995<=$&&$<=127999}var Fe;(function($){$[$.zwj=8205]="zwj",$[$.emojiVariantSelector=65039]="emojiVariantSelector",$[$.enclosingKeyCap=8419]="enclosingKeyCap"})(Fe||(Fe={})),e.noBreakWhitespace="\xA0";class it{static getInstance(ce){return it.d.get(Array.from(ce))}static getLocales(){return it.e.getValue()}constructor(ce){this.f=ce}isAmbiguous(ce){return this.f.has(ce)}getPrimaryConfusable(ce){return this.f.get(ce)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=it,I=it,it.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),it.d=new a.LRUCachedFunction($=>{function ce(lt){const ot=new Map;for(let rt=0;rt<lt.length;rt+=2)ot.set(lt[rt],lt[rt+1]);return ot}function Ie(lt,ot){const rt=new Map(lt);for(const[At,Rt]of ot)rt.set(At,Rt);return rt}function Le(lt,ot){if(!lt)return ot;const rt=new Map;for(const[At,Rt]of lt)ot.has(At)&&rt.set(At,Rt);return rt}const Be=I.c.getValue();let xe=$.filter(lt=>!lt.startsWith("_")&&lt in Be);xe.length===0&&(xe=["_default"]);let Ze;for(const lt of xe){const ot=ce(Be[lt]);Ze=Le(Ze,ot)}const mt=ce(Be._common),ft=Ie(mt,Ze);return new it(ft)}),it.e=new t.Lazy(()=>Object.keys(it.c.getValue()).filter($=>!$.startsWith("_")));class ae{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(ae.c())),this.d}static isInvisibleCharacter(ce){return ae.e().has(ce)}static get codePoints(){return ae.e()}}e.InvisibleCharacters=ae,ae.d=void 0}),define(Se[32],ye([1,0,9,12,8,11]),function(ne,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(s){return s===47||s===92}e.isPathSeparator=D;function k(s){return s.replace(/[\\/]/g,a.posix.sep)}e.toSlashes=k;function S(s){return s.indexOf("/")===-1&&(s=k(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=S;function C(s,c=a.posix.sep){if(!s)return"";const n=s.length,r=s.charCodeAt(0);if(D(r)){if(D(s.charCodeAt(1))&&!D(s.charCodeAt(2))){let P=3;const L=P;for(;P<n&&!D(s.charCodeAt(P));P++);if(L!==P&&!D(s.charCodeAt(P+1))){for(P+=1;P<n;P++)if(D(s.charCodeAt(P)))return s.slice(0,P+1).replace(/[\\/]/g,c)}}return c}else if(f(r)&&s.charCodeAt(1)===58)return D(s.charCodeAt(2))?s.slice(0,2)+c:s.slice(0,2);let g=s.indexOf("://");if(g!==-1){for(g+=3;g<n;g++)if(D(s.charCodeAt(g)))return s.slice(0,g+1)}return""}e.getRoot=C;function R(s){if(!t.isWindows||!s||s.length<5)return!1;let c=s.charCodeAt(0);if(c!==92||(c=s.charCodeAt(1),c!==92))return!1;let n=2;const r=n;for(;n<s.length&&(c=s.charCodeAt(n),c!==92);n++);return!(r===n||(c=s.charCodeAt(n+1),isNaN(c)||c===92))}e.isUNC=R;const T=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(s,c=t.isWindows){const n=c?T:E;return!(!s||s.length===0||/^\s+$/.test(s)||(n.lastIndex=0,n.test(s))||c&&y.test(s)||s==="."||s===".."||c&&s[s.length-1]==="."||c&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=v;function d(s,c,n){const r=s===c;return!n||r?r:!s||!c?!1:(0,I.equalsIgnoreCase)(s,c)}e.isEqual=d;function b(s,c,n,r=a.sep){if(s===c)return!0;if(!s||!c||c.length>s.length)return!1;if(n){if(!(0,I.startsWithIgnoreCase)(s,c))return!1;if(c.length===s.length)return!0;let P=c.length;return c.charAt(c.length-1)===r&&P--,s.charAt(P)===r}return c.charAt(c.length-1)!==r&&(c+=r),s.indexOf(c)===0}e.isEqualOrParent=b;function f(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=f;function w(s,c){return t.isWindows&&s.endsWith(":")&&(s+=a.sep),(0,a.isAbsolute)(s)||(s=(0,a.join)(c,s)),s=(0,a.normalize)(s),t.isWindows?(s=(0,I.rtrim)(s,a.sep),s.endsWith(":")&&(s+=a.sep)):(s=(0,I.rtrim)(s,a.sep),s||(s=a.sep)),s}e.sanitizeFilePath=w;function h(s){const c=(0,a.normalize)(s);return t.isWindows?s.length>3?!1:m(c)&&(s.length===2||c.charCodeAt(2)===92):c===a.posix.sep}e.isRootOrDriveLetter=h;function m(s,c=t.isWindows){return c?f(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=m;function p(s){return m(s)?s[0]:void 0}e.getDriveLetter=p;function o(s,c,n){return c.length>s.length?-1:s===c?0:(n&&(s=s.toLowerCase(),c=c.toLowerCase()),s.indexOf(c))}e.indexOfPath=o;function i(s){const c=s.split(":");let n,r,g;for(const P of c){const L=Number(P);(0,A.isNumber)(L)?r===void 0?r=L:g===void 0&&(g=L):n=n?[n,P].join(":"):P}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:r!==void 0?r:void 0,column:g!==void 0?g:r!==void 0?1:void 0}}e.parseLineAndColumnAware=i;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function u(s,c,n=8){let r="";for(let P=0;P<n;P++)r+=l.charAt(Math.floor(Math.random()*l.length));let g;return c?g=`${c}-${r}`:g=r,s?(0,a.join)(s,g):g}e.randomPath=u}),define(Se[107],ye([1,0,28,8]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...ie){return function(O,H){for(let q=0,Y=ie.length;q<Y;q++){const de=ie[q](O,H);if(de)return de}return null}}e.or=I,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(ie,O,H){if(!H||H.length<O.length)return null;let q;return ie?q=t.startsWithIgnoreCase(H,O):q=H.indexOf(O)===0,q?O.length>0?[{start:0,end:O.length}]:[]:null}function D(ie,O){const H=O.toLowerCase().indexOf(ie.toLowerCase());return H===-1?null:[{start:H,end:H+ie.length}]}e.matchesContiguousSubString=D;function k(ie,O){return S(ie.toLowerCase(),O.toLowerCase(),0,0)}e.matchesSubString=k;function S(ie,O,H,q){if(H===ie.length)return[];if(q===O.length)return null;if(ie[H]===O[q]){let Y=null;return(Y=S(ie,O,H+1,q+1))?f({start:q,end:q+1},Y):null}return S(ie,O,H,q+1)}function C(ie){return 97<=ie&&ie<=122}function R(ie){return 65<=ie&&ie<=90}e.isUpper=R;function T(ie){return 48<=ie&&ie<=57}function E(ie){return ie===32||ie===9||ie===10||ie===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ie=>y.add(ie.charCodeAt(0)));function v(ie){return E(ie)||y.has(ie)}function d(ie,O){return ie===O||v(ie)&&v(O)}function b(ie){return C(ie)||R(ie)||T(ie)}function f(ie,O){return O.length===0?O=[ie]:ie.end===O[0].start?O[0].start=ie.start:O.unshift(ie),O}function w(ie,O){for(let H=O;H<ie.length;H++){const q=ie.charCodeAt(H);if(R(q)||T(q)||H>0&&!b(ie.charCodeAt(H-1)))return H}return ie.length}function h(ie,O,H,q){if(H===ie.length)return[];if(q===O.length)return null;if(ie[H]!==O[q].toLowerCase())return null;{let Y=null,de=q+1;for(Y=h(ie,O,H+1,q+1);!Y&&(de=w(O,de))<O.length;)Y=h(ie,O,H+1,de),de++;return Y===null?null:f({start:q,end:q+1},Y)}}function m(ie){let O=0,H=0,q=0,Y=0,de=0;for(let ke=0;ke<ie.length;ke++)de=ie.charCodeAt(ke),R(de)&&O++,C(de)&&H++,b(de)&&q++,T(de)&&Y++;const be=O/ie.length,Pe=H/ie.length,pe=q/ie.length,Ce=Y/ie.length;return{upperPercent:be,lowerPercent:Pe,alphaPercent:pe,numericPercent:Ce}}function p(ie){const{upperPercent:O,lowerPercent:H}=ie;return H===0&&O>.6}function o(ie){const{upperPercent:O,lowerPercent:H,alphaPercent:q,numericPercent:Y}=ie;return H>.2&&O<.8&&q>.6&&Y<.2}function i(ie){let O=0,H=0,q=0,Y=0;for(let de=0;de<ie.length;de++)q=ie.charCodeAt(de),R(q)&&O++,C(q)&&H++,E(q)&&Y++;return(O===0||H===0)&&Y===0?ie.length<=30:O<=5}function l(ie,O){if(!O||(O=O.trim(),O.length===0)||!i(ie)||O.length>60)return null;const H=m(O);if(!o(H)){if(!p(H))return null;O=O.toLowerCase()}let q=null,Y=0;for(ie=ie.toLowerCase();Y<O.length&&(q=h(ie,O,0,Y))===null;)Y=w(O,Y+1);return q}e.matchesCamelCase=l;function u(ie,O,H=!1){if(!O||O.length===0)return null;let q=null,Y=0;for(ie=ie.toLowerCase(),O=O.toLowerCase();Y<O.length&&(q=s(ie,O,0,Y,H))===null;)Y=c(O,Y+1);return q}e.matchesWords=u;function s(ie,O,H,q,Y){if(H===ie.length)return[];if(q===O.length)return null;if(d(ie.charCodeAt(H),O.charCodeAt(q))){let de=null,be=q+1;if(de=s(ie,O,H+1,q+1,Y),!Y)for(;!de&&(be=c(O,be))<O.length;)de=s(ie,O,H+1,be,Y),be++;return de?ie.charCodeAt(H)!==O.charCodeAt(q)?de:f({start:q,end:q+1},de):null}else return null}function c(ie,O){for(let H=O;H<ie.length;H++)if(v(ie.charCodeAt(H))||H>0&&v(ie.charCodeAt(H-1)))return H;return ie.length}const n=I(e.matchesPrefix,l,D),r=I(e.matchesPrefix,l,k),g=new a.LRUCache(1e4);function P(ie,O,H=!1){if(typeof ie!="string"||typeof O!="string")return null;let q=g.get(ie);q||(q=new RegExp(t.convertSimple2RegExpPattern(ie),"i"),g.set(ie,q));const Y=q.exec(O);return Y?[{start:Y.index,end:Y.index+Y[0].length}]:H?r(ie,O):n(ie,O)}e.matchesFuzzy=P;function L(ie,O){const H=Re(ie,ie.toLowerCase(),0,O,O.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return H?_(H):null}e.matchesFuzzy2=L;function z(ie,O,H,q,Y,de){const be=Math.min(13,ie.length);for(;H<be;H++){const Pe=Re(ie,O,H,q,Y,de,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Pe)return Pe}return[0,de]}e.anyScore=z;function _(ie){if(typeof ie>"u")return[];const O=[],H=ie[1];for(let q=ie.length-1;q>1;q--){const Y=ie[q]+H,de=O[O.length-1];de&&de.end===Y?de.end=Y+1:O.push({start:Y,end:Y+1})}return O}e.createMatches=_;const K=128;function F(){const ie=[],O=[];for(let H=0;H<=K;H++)O[H]=0;for(let H=0;H<=K;H++)ie.push(O.slice(0));return ie}function M(ie){const O=[];for(let H=0;H<=ie;H++)O[H]=0;return O}const N=M(2*K),B=M(2*K),U=F(),W=F(),x=F(),V=!1;function X(ie,O,H,q,Y){function de(Pe,pe,Ce=" "){for(;Pe.length<pe;)Pe=Ce+Pe;return Pe}let be=` |   |${q.split("").map(Pe=>de(Pe,3)).join("|")}
`;for(let Pe=0;Pe<=H;Pe++)Pe===0?be+=" |":be+=`${O[Pe-1]}|`,be+=ie[Pe].slice(0,Y+1).map(pe=>de(pe.toString(),3)).join("|")+`
`;return be}function Q(ie,O,H,q){ie=ie.substr(O),H=H.substr(q),console.log(X(W,ie,ie.length,H,H.length)),console.log(X(x,ie,ie.length,H,H.length)),console.log(X(U,ie,ie.length,H,H.length))}function J(ie,O){if(O<0||O>=ie.length)return!1;const H=ie.codePointAt(O);switch(H){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(H)}}function te(ie,O){if(O<0||O>=ie.length)return!1;switch(ie.charCodeAt(O)){case 32:case 9:return!0;default:return!1}}function le(ie,O,H){return O[ie]!==H[ie]}function Z(ie,O,H,q,Y,de,be=!1){for(;O<H&&Y<de;)ie[O]===q[Y]&&(be&&(N[O]=Y),O+=1),Y+=1;return O===H}e.isPatternInWord=Z;var ge;(function(ie){ie[ie.Diag=1]="Diag",ie[ie.Left=2]="Left",ie[ie.LeftLeft=3]="LeftLeft"})(ge||(ge={}));var ve;(function(ie){ie.Default=[-100,0];function O(H){return!H||H.length===2&&H[0]===-100&&H[1]===0}ie.isDefault=O})(ve=e.FuzzyScore||(e.FuzzyScore={}));class De{constructor(O,H){this.firstMatchCanBeWeak=O,this.boostFullMatch=H}}e.FuzzyScoreOptions=De,De.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Re(ie,O,H,q,Y,de,be=De.default){const Pe=ie.length>K?K:ie.length,pe=q.length>K?K:q.length;if(H>=Pe||de>=pe||Pe-H>pe-de||!Z(O,H,Pe,Y,de,pe,!0))return;ze(Pe,pe,H,de,O,Y);let Ce=1,ke=1,je=H,Ge=de;const et=[!1];for(Ce=1,je=H;je<Pe;Ce++,je++){const Fe=N[je],it=B[je],ae=je+1<Pe?B[je+1]:pe;for(ke=Fe-de+1,Ge=Fe;Ge<ae;ke++,Ge++){let $=Number.MIN_SAFE_INTEGER,ce=!1;Ge<=it&&($=se(ie,O,je,H,q,Y,Ge,pe,de,U[Ce-1][ke-1]===0,et));let Ie=0;$!==Number.MAX_SAFE_INTEGER&&(ce=!0,Ie=$+W[Ce-1][ke-1]);const Le=Ge>Fe,Be=Le?W[Ce][ke-1]+(U[Ce][ke-1]>0?-5:0):0,xe=Ge>Fe+1&&U[Ce][ke-1]>0,Ze=xe?W[Ce][ke-2]+(U[Ce][ke-2]>0?-5:0):0;if(xe&&(!Le||Ze>=Be)&&(!ce||Ze>=Ie))W[Ce][ke]=Ze,x[Ce][ke]=3,U[Ce][ke]=0;else if(Le&&(!ce||Be>=Ie))W[Ce][ke]=Be,x[Ce][ke]=2,U[Ce][ke]=0;else if(ce)W[Ce][ke]=Ie,x[Ce][ke]=1,U[Ce][ke]=U[Ce-1][ke-1]+1;else throw new Error("not possible")}}if(V&&Q(ie,H,q,de),!et[0]&&!be.firstMatchCanBeWeak)return;Ce--,ke--;const _e=[W[Ce][ke],de];let nt=0,st=0;for(;Ce>=1;){let Fe=ke;do{const it=x[Ce][Fe];if(it===3)Fe=Fe-2;else if(it===2)Fe=Fe-1;else break}while(Fe>=1);nt>1&&O[H+Ce-1]===Y[de+ke-1]&&!le(Fe+de-1,q,Y)&&nt+1>U[Ce][Fe]&&(Fe=ke),Fe===ke?nt++:nt=1,st||(st=Fe),Ce--,ke=Fe-1,_e.push(ke)}pe===Pe&&be.boostFullMatch&&(_e[0]+=2);const ht=st-Pe;return _e[0]-=ht,_e}e.fuzzyScore=Re;function ze(ie,O,H,q,Y,de){let be=ie-1,Pe=O-1;for(;be>=H&&Pe>=q;)Y[be]===de[Pe]&&(B[be]=Pe,be--),Pe--}function se(ie,O,H,q,Y,de,be,Pe,pe,Ce,ke){if(O[H]!==de[be])return Number.MIN_SAFE_INTEGER;let je=1,Ge=!1;return be===H-q?je=ie[H]===Y[be]?7:5:le(be,Y,de)&&(be===0||!le(be-1,Y,de))?(je=ie[H]===Y[be]?7:5,Ge=!0):J(de,be)&&(be===0||!J(de,be-1))?je=5:(J(de,be-1)||te(de,be-1))&&(je=5,Ge=!0),je>1&&H===q&&(ke[0]=!0),Ge||(Ge=le(be,Y,de)||J(de,be-1)||te(de,be-1)),H===q?be>pe&&(je-=Ge?3:5):Ce?je+=Ge?2:0:je+=Ge?0:1,be+1===Pe&&(je-=Ge?3:5),je}function ue(ie,O,H,q,Y,de,be){return ee(ie,O,H,q,Y,de,!0,be)}e.fuzzyScoreGracefulAggressive=ue;function he(ie,O,H,q,Y,de,be){return ee(ie,O,H,q,Y,de,!1,be)}e.fuzzyScoreGraceful=he;function ee(ie,O,H,q,Y,de,be,Pe){let pe=Re(ie,O,H,q,Y,de,Pe);if(pe&&!be)return pe;if(ie.length>=3){const Ce=Math.min(7,ie.length-1);for(let ke=H+1;ke<Ce;ke++){const je=oe(ie,ke);if(je){const Ge=Re(je,je.toLowerCase(),H,q,Y,de,Pe);Ge&&(Ge[0]-=3,(!pe||Ge[0]>pe[0])&&(pe=Ge))}}}return pe}function oe(ie,O){if(O+1>=ie.length)return;const H=ie[O],q=ie[O+1];if(H!==q)return ie.slice(0,O)+q+H+ie.slice(O+2)}}),define(Se[84],ye([1,0,8]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(f){return I(f,0)}e.hash=t;function I(f,w){switch(typeof f){case"object":return f===null?A(349,w):Array.isArray(f)?S(f,w):C(f,w);case"string":return k(f,w);case"boolean":return D(f,w);case"number":return A(f,w);case"undefined":return A(937,w);default:return A(617,w)}}e.doHash=I;function A(f,w){return(w<<5)-w+f|0}e.numberHash=A;function D(f,w){return A(f?433:863,w)}function k(f,w){w=A(149417,w);for(let h=0,m=f.length;h<m;h++)w=A(f.charCodeAt(h),w);return w}e.stringHash=k;function S(f,w){return w=A(104579,w),f.reduce((h,m)=>I(m,h),w)}function C(f,w){return w=A(181387,w),Object.keys(f).sort().reduce((h,m)=>(h=k(m,h),I(f[m],h)),w)}class R{constructor(){this.g=0}get value(){return this.g}hash(w){return this.g=I(w,this.g),this.g}}e.Hasher=R;var T;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function E(f,w,h=32){const m=h-w,p=~((1<<m)-1);return(f<<w|(p&f)>>>m)>>>0}function y(f,w=0,h=f.byteLength,m=0){for(let p=0;p<h;p++)f[w+p]=m}function v(f,w,h="0"){for(;f.length<w;)f=h+f;return f}function d(f,w=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(h=>h.toString(16).padStart(2,"0")).join(""):v((f>>>0).toString(16),w/4)}e.toHexString=d;class b{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(w){const h=w.length;if(h===0)return;const m=this.p;let p=this.r,o=this.u,i,l;for(o!==0?(i=o,l=-1,o=0):(i=w.charCodeAt(0),l=0);;){let u=i;if(a.isHighSurrogate(i))if(l+1<h){const s=w.charCodeAt(l+1);a.isLowSurrogate(s)?(l++,u=a.computeCodePoint(i,s)):u=65533}else{o=i;break}else a.isLowSurrogate(i)&&(u=65533);if(p=this.w(m,p,u),l++,l<h)i=w.charCodeAt(l);else break}this.r=p,this.u=o}w(w,h,m){return m<128?w[h++]=m:m<2048?(w[h++]=192|(m&1984)>>>6,w[h++]=128|(m&63)>>>0):m<65536?(w[h++]=224|(m&61440)>>>12,w[h++]=128|(m&4032)>>>6,w[h++]=128|(m&63)>>>0):(w[h++]=240|(m&1835008)>>>18,w[h++]=128|(m&258048)>>>12,w[h++]=128|(m&4032)>>>6,w[h++]=128|(m&63)>>>0),h>=64&&(this.y(),h-=64,this.t+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),h}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),d(this.h)+d(this.l)+d(this.m)+d(this.n)+d(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const w=8*this.t;this.q.setUint32(56,Math.floor(w/4294967296),!1),this.q.setUint32(60,w%4294967296,!1),this.y()}y(){const w=b.g,h=this.q;for(let n=0;n<64;n+=4)w.setUint32(n,h.getUint32(n,!1),!1);for(let n=64;n<320;n+=4)w.setUint32(n,E(w.getUint32(n-12,!1)^w.getUint32(n-32,!1)^w.getUint32(n-56,!1)^w.getUint32(n-64,!1),1),!1);let m=this.h,p=this.l,o=this.m,i=this.n,l=this.o,u,s,c;for(let n=0;n<80;n++)n<20?(u=p&o|~p&i,s=1518500249):n<40?(u=p^o^i,s=1859775393):n<60?(u=p&o|p&i|o&i,s=2400959708):(u=p^o^i,s=3395469782),c=E(m,5)+u+l+s+w.getUint32(n*4,!1)&4294967295,l=i,i=o,o=E(p,30),p=m,m=c;this.h=this.h+m&4294967295,this.l=this.l+p&4294967295,this.m=this.m+o&4294967295,this.n=this.n+i&4294967295,this.o=this.o+l&4294967295}}e.StringSHA1=b,b.g=new DataView(new ArrayBuffer(320))}),define(Se[160],ye([1,0,79,107,8]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const A="$(",D=new RegExp(`\\$\\(${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(`(\\\\)?${D.source}`,"g");function S(b){return b.replace(k,(f,w)=>w?f:`\\${f}`)}e.escapeIcons=S;const C=new RegExp(`\\\\${D.source}`,"g");function R(b){return b.replace(C,f=>`\\${f}`)}e.markdownEscapeEscapedIcons=R;const T=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function E(b){return b.indexOf(A)===-1?b:b.replace(T,(f,w,h,m)=>h?f:w||m||"")}e.stripIcons=E;const y=new RegExp(`\\$\\(${a.CSSIcon.iconNameCharacter}+\\)`,"g");function v(b){y.lastIndex=0;let f="";const w=[];let h=0;for(;;){const m=y.lastIndex,p=y.exec(b),o=b.substring(m,p?.index);if(o.length>0){f+=o;for(let i=0;i<o.length;i++)w.push(h)}if(!p)break;h+=p[0].length}return{text:f,iconOffsets:w}}e.parseLabelWithIcons=v;function d(b,f,w=!1){const{text:h,iconOffsets:m}=f;if(!m||m.length===0)return(0,t.matchesFuzzy)(b,h,w);const p=(0,I.ltrim)(h," "),o=h.length-p.length,i=(0,t.matchesFuzzy)(b,p,w);if(i)for(const l of i){const u=m[l.start+o]+o;l.start+=u,l.end+=u}return i}e.matchesFuzzyIconAware=d}),define(Se[42],ye([1,0,8]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(t||(t={})),function(I){const A="error",D="warning",k="warn",S="info",C="ignore";function R(E){return E?a.equalsIgnoreCase(A,E)?I.Error:a.equalsIgnoreCase(D,E)||a.equalsIgnoreCase(k,E)?I.Warning:a.equalsIgnoreCase(S,E)?I.Info:I.Ignore:I.Ignore}I.fromValue=R;function T(E){switch(E){case I.Error:return A;case I.Warning:return D;case I.Info:return S;default:return C}}I.toString=T}(t||(t={})),e.default=t}),define(Se[64],ye([1,0,17,8]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class I{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const v=y.charCodeAt(0),d=this.b.charCodeAt(this.c);return v-d}value(){return this.b[this.c]}}e.StringIterator=I;class A{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,t.compareSubstring)(y,this.b,0,y.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=A;class D{constructor(y=!0,v=!0){this.f=y,this.g=v}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let v=y.length-1;v>=0;v--,this.c--){const d=this.b.charCodeAt(v);if(!(d===47||this.f&&d===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,t.compareSubstring)(y,this.b,0,y.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=D;var k;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(k||(k={}));class S{constructor(y,v){this.f=y,this.g=v,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(y,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,t.compare)(y,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=S;class C{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(R||(R={}));class T{static forUris(y=()=>!1,v=()=>!1){return new T(new S(y,v))}static forPaths(y=!1){return new T(new D(void 0,!y))}static forStrings(){return new T(new I)}static forConfigKeys(){return new T(new A)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,v){if(v){const d=v.slice(0);(0,a.shuffle)(d);for(const b of d)this.set(b,y)}else{const d=y.slice(0);(0,a.shuffle)(d);for(const b of d)this.set(b[0],b[1])}}set(y,v){const d=this.b.reset(y);let b;this.c||(this.c=new C,this.c.segment=d.value());const f=[];for(b=this.c;;){const h=d.cmp(b.segment);if(h>0)b.left||(b.left=new C,b.left.segment=d.value()),f.push([-1,b]),b=b.left;else if(h<0)b.right||(b.right=new C,b.right.segment=d.value()),f.push([1,b]),b=b.right;else if(d.hasNext())d.next(),b.mid||(b.mid=new C,b.mid.segment=d.value()),f.push([0,b]),b=b.mid;else break}const w=b.value;b.value=v,b.key=y;for(let h=f.length-1;h>=0;h--){const m=f[h][1];m.updateHeight();const p=m.balanceFactor();if(p<-1||p>1){const o=f[h][0],i=f[h+1][0];if(o===1&&i===1)f[h][1]=m.rotateLeft();else if(o===-1&&i===-1)f[h][1]=m.rotateRight();else if(o===1&&i===-1)m.right=f[h+1][1]=f[h+1][1].rotateRight(),f[h][1]=m.rotateLeft();else if(o===-1&&i===1)m.left=f[h+1][1]=f[h+1][1].rotateLeft(),f[h][1]=m.rotateRight();else throw new Error;if(h>0)switch(f[h-1][0]){case-1:f[h-1][1].left=f[h][1];break;case 1:f[h-1][1].right=f[h][1];break;case 0:f[h-1][1].mid=f[h][1];break}else this.c=f[0][1]}}return w}get(y){return this.d(y)?.value}d(y){const v=this.b.reset(y);let d=this.c;for(;d;){const b=v.cmp(d.segment);if(b>0)d=d.left;else if(b<0)d=d.right;else if(v.hasNext())v.next(),d=d.mid;else break}return d}has(y){const v=this.d(y);return!(v?.value===void 0&&v?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,v){const d=this.b.reset(y),b=[];let f=this.c;for(;f;){const w=d.cmp(f.segment);if(w>0)b.push([-1,f]),f=f.left;else if(w<0)b.push([1,f]),f=f.right;else if(d.hasNext())d.next(),b.push([0,f]),f=f.mid;else break}if(!!f){if(v?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const w=this.f(f.right);if(w.key){const{key:h,value:m,segment:p}=w;this.e(w.key,!1),f.key=h,f.value=m,f.segment=p}}else{const w=f.left??f.right;if(b.length>0){const[h,m]=b[b.length-1];switch(h){case-1:m.left=w;break;case 0:m.mid=w;break;case 1:m.right=w;break}}else this.c=w}for(let w=b.length-1;w>=0;w--){const h=b[w][1];h.updateHeight();const m=h.balanceFactor();if(m>1?(h.right.balanceFactor()>=0||(h.right=h.right.rotateRight()),b[w][1]=h.rotateLeft()):m<-1&&(h.left.balanceFactor()<=0||(h.left=h.left.rotateLeft()),b[w][1]=h.rotateRight()),w>0)switch(b[w-1][0]){case-1:b[w-1][1].left=b[w][1];break;case 1:b[w-1][1].right=b[w][1];break;case 0:b[w-1][1].mid=b[w][1];break}else this.c=b[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const v=this.b.reset(y);let d=this.c,b;for(;d;){const f=v.cmp(d.segment);if(f>0)d=d.left;else if(f<0)d=d.right;else if(v.hasNext())v.next(),b=d.value||b,d=d.mid;else break}return d&&d.value||b}findSuperstr(y){const v=this.b.reset(y);let d=this.c;for(;d;){const b=v.cmp(d.segment);if(b>0)d=d.left;else if(b<0)d=d.right;else if(v.hasNext())v.next(),d=d.mid;else return d.mid?this.g(d.mid):void 0}}forEach(y){for(const[v,d]of this)y(d,v)}*[Symbol.iterator](){yield*this.g(this.c)}g(y){const v=[];return this.h(y,v),v[Symbol.iterator]()}h(y,v){!y||(y.left&&this.h(y.left,v),y.value&&v.push([y.key,y.value]),y.mid&&this.h(y.mid,v),y.right&&this.h(y.right,v))}_isBalanced(){const y=v=>{if(!v)return!0;const d=v.balanceFactor();return d<-1||d>1?!1:y(v.left)&&y(v.right)};return y(this.c)}}e.TernarySearchTree=T}),define(Se[2],ye([1,0,9,12]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,A=/^\//,D=/^\/\//;function k(l,u){if(!l.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!I.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!A.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(l,u){return!l&&!u?"file":l}function C(l,u){switch(l){case"https":case"http":case"file":u?u[0]!==T&&(u=T+u):u=T;break}return u}const R="",T="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(u){return u instanceof y?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}constructor(u,s,c,n,r,g=!1){typeof u=="object"?(this.scheme=u.scheme||R,this.authority=u.authority||R,this.path=u.path||R,this.query=u.query||R,this.fragment=u.fragment||R):(this.scheme=S(u,g),this.authority=s||R,this.path=C(this.scheme,c||R),this.query=n||R,this.fragment=r||R,k(this,g))}get fsPath(){return h(this,!1)}with(u){if(!u)return this;let{scheme:s,authority:c,path:n,query:r,fragment:g}=u;return s===void 0?s=this.scheme:s===null&&(s=R),c===void 0?c=this.authority:c===null&&(c=R),n===void 0?n=this.path:n===null&&(n=R),r===void 0?r=this.query:r===null&&(r=R),g===void 0?g=this.fragment:g===null&&(g=R),s===this.scheme&&c===this.authority&&n===this.path&&r===this.query&&g===this.fragment?this:new d(s,c,n,r,g)}static parse(u,s=!1){const c=E.exec(u);return c?new d(c[2]||R,i(c[4]||R),i(c[5]||R),i(c[7]||R),i(c[9]||R),s):new d(R,R,R,R,R)}static file(u){let s=R;if(t.isWindows&&(u=u.replace(/\\/g,T)),u[0]===T&&u[1]===T){const c=u.indexOf(T,2);c===-1?(s=u.substring(2),u=T):(s=u.substring(2,c),u=u.substring(c)||T)}return new d("file",s,u,R,R)}static from(u){const s=new d(u.scheme,u.authority,u.path,u.query,u.fragment);return k(s,!0),s}static joinPath(u,...s){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return t.isWindows&&u.scheme==="file"?c=y.file(a.win32.join(h(u,!0),...s)).path:c=a.posix.join(u.path,...s),u.with({path:c})}toString(u=!1){return m(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof y)return u;{const s=new d(u);return s._formatted=u.external,s._fsPath=u._sep===v?u.fsPath:null,s}}else return u}}e.URI=y;const v=t.isWindows?1:void 0;class d extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(u=!1){return u?m(this,!0):(this._formatted||(this._formatted=m(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=v),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(l,u,s){let c,n=-1;for(let r=0;r<l.length;r++){const g=l.charCodeAt(r);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||u&&g===47||s&&g===91||s&&g===93||s&&g===58)n!==-1&&(c+=encodeURIComponent(l.substring(n,r)),n=-1),c!==void 0&&(c+=l.charAt(r));else{c===void 0&&(c=l.substr(0,r));const P=b[g];P!==void 0?(n!==-1&&(c+=encodeURIComponent(l.substring(n,r)),n=-1),c+=P):n===-1&&(n=r)}}return n!==-1&&(c+=encodeURIComponent(l.substring(n))),c!==void 0?c:l}function w(l){let u;for(let s=0;s<l.length;s++){const c=l.charCodeAt(s);c===35||c===63?(u===void 0&&(u=l.substr(0,s)),u+=b[c]):u!==void 0&&(u+=l[s])}return u!==void 0?u:l}function h(l,u){let s;return l.authority&&l.path.length>1&&l.scheme==="file"?s=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?u?s=l.path.substr(1):s=l.path[1].toLowerCase()+l.path.substr(2):s=l.path,t.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=h;function m(l,u){const s=u?w:f;let c="",{scheme:n,authority:r,path:g,query:P,fragment:L}=l;if(n&&(c+=n,c+=":"),(r||n==="file")&&(c+=T,c+=T),r){let z=r.indexOf("@");if(z!==-1){const _=r.substr(0,z);r=r.substr(z+1),z=_.lastIndexOf(":"),z===-1?c+=s(_,!1,!1):(c+=s(_.substr(0,z),!1,!1),c+=":",c+=s(_.substr(z+1),!1,!0)),c+="@"}r=r.toLowerCase(),z=r.lastIndexOf(":"),z===-1?c+=s(r,!1,!0):(c+=s(r.substr(0,z),!1,!0),c+=r.substr(z))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const z=g.charCodeAt(1);z>=65&&z<=90&&(g=`/${String.fromCharCode(z+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const z=g.charCodeAt(0);z>=65&&z<=90&&(g=`${String.fromCharCode(z+32)}:${g.substr(2)}`)}c+=s(g,!0,!1)}return P&&(c+="?",c+=s(P,!1,!1)),L&&(c+="#",c+=u?L:f(L,!1,!1)),c}function p(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+p(l.substr(3)):l}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(l){return l.match(o)?l.replace(o,u=>p(u)):l}}),define(Se[85],ye([1,0,22,8,2]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function A(C){return JSON.stringify(C,k)}e.stringify=A;function D(C){let R=JSON.parse(C);return R=S(R),R}e.parse=D;function k(C,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,t.regExpFlags)(R)}:R}function S(C,R=0){if(!C||R>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return I.URI.revive(C);case 2:return new RegExp(C.source,C.flags);case 16:return new Date(C.source)}if(C instanceof a.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let T=0;T<C.length;++T)C[T]=S(C[T],R+1);else for(const T in C)Object.hasOwnProperty.call(C,T)&&(C[T]=S(C[T],R+1))}return C}e.revive=S}),define(Se[15],ye([1,0,12,2]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var I;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(I=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${I.vscodeRemoteResource}`}setPreferredWebSchema(C){this.d=C}setDelegate(C){this.e=C}setServerRootPath(C){this.f=`${C}/${I.vscodeRemoteResource}`}set(C,R,T){this.a[C]=R,this.b[C]=T}setConnectionToken(C,R){this.c[C]=R}getPreferredWebSchema(){return this.d}rewrite(C){if(this.e)return this.e(C);const R=C.authority;let T=this.a[R];T&&T.indexOf(":")!==-1&&T.indexOf("[")===-1&&(T=`[${T}]`);const E=this.b[R],y=this.c[R];let v=`path=${encodeURIComponent(C.path)}`;return typeof y=="string"&&(v+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),t.URI.from({scheme:a.isWeb?this.d:I.vscodeRemoteResource,authority:`${T}:${E}`,path:this.f,query:v})}}e.RemoteAuthorities=new A,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class D{asBrowserUri(C){const R=this.b(C,ne);return this.uriToBrowserUri(R)}uriToBrowserUri(C){return C.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(C):C.scheme===I.file&&(a.isNative||a.isWebWorker&&a.globals.origin===`${I.vscodeFileResource}://${D.a}`)?C.with({scheme:I.vscodeFileResource,authority:C.authority||D.a,query:null,fragment:null}):C}asFileUri(C){const R=this.b(C,ne);return this.uriToFileUri(R)}uriToFileUri(C){return C.scheme===I.vscodeFileResource?C.with({scheme:I.file,authority:C.authority!==D.a?C.authority:null,query:null,fragment:null}):C}b(C,R){return t.URI.isUri(C)?C:t.URI.parse(R.toUrl(C))}}D.a="vscode-app",e.FileAccess=new D;var k;(function(S){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(C.get("3"));const R="vscode-coi";function T(y){let v;typeof y=="string"?v=new URL(y).searchParams:y instanceof URL?v=y.searchParams:t.URI.isUri(y)&&(v=new URL(y.toString(!0)).searchParams);const d=v?.get(R);if(!!d)return C.get(d)}S.getHeadersFromQuery=T;function E(y,v,d){if(!globalThis.crossOriginIsolated)return;const b=v&&d?"3":d?"2":"1";y instanceof URLSearchParams?y.set(R,b):y[R]=b}S.addSearchParam=E})(k=e.COI||(e.COI={}))}),define(Se[24],ye([1,0,32,15,9,12,8,2]),function(ne,e,a,t,I,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(y){return(0,k.uriToFsPath)(y,!0)}e.originalFSPath=S;class C{constructor(v){this.a=v}compare(v,d,b=!1){return v===d?0:(0,D.compare)(this.getComparisonKey(v,b),this.getComparisonKey(d,b))}isEqual(v,d,b=!1){return v===d?!0:!v||!d?!1:this.getComparisonKey(v,b)===this.getComparisonKey(d,b)}getComparisonKey(v,d=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,d,b=!1){if(v.scheme===d.scheme){if(v.scheme===t.Schemas.file)return a.isEqualOrParent(S(v),S(d),this.a(v))&&v.query===d.query&&(b||v.fragment===d.fragment);if((0,e.isEqualAuthority)(v.authority,d.authority))return a.isEqualOrParent(v.path,d.path,this.a(v),"/")&&v.query===d.query&&(b||v.fragment===d.fragment)}return!1}joinPath(v,...d){return k.URI.joinPath(v,...d)}basenameOrAuthority(v){return(0,e.basename)(v)||v.authority}basename(v){return I.posix.basename(v.path)}extname(v){return I.posix.extname(v.path)}dirname(v){if(v.path.length===0)return v;let d;return v.scheme===t.Schemas.file?d=k.URI.file(I.dirname(S(v))).path:(d=I.posix.dirname(v.path),v.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),d="/")),v.with({path:d})}normalizePath(v){if(!v.path.length)return v;let d;return v.scheme===t.Schemas.file?d=k.URI.file(I.normalize(S(v))).path:d=I.posix.normalize(v.path),v.with({path:d})}relativePath(v,d){if(v.scheme!==d.scheme||!(0,e.isEqualAuthority)(v.authority,d.authority))return;if(v.scheme===t.Schemas.file){const w=I.relative(S(v),S(d));return A.isWindows?a.toSlashes(w):w}let b=v.path||"/";const f=d.path||"/";if(this.a(v)){let w=0;for(const h=Math.min(b.length,f.length);w<h&&!(b.charCodeAt(w)!==f.charCodeAt(w)&&b.charAt(w).toLowerCase()!==f.charAt(w).toLowerCase());w++);b=f.substr(0,w)+b.substr(w)}return I.posix.relative(b,f)}resolvePath(v,d){if(v.scheme===t.Schemas.file){const b=k.URI.file(I.resolve(S(v),d));return v.with({authority:b.authority,path:b.path})}return d=a.toPosixPath(d),v.with({path:I.posix.resolve(v.path,d)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,d){return v===d||v!==void 0&&d!==void 0&&(0,D.equalsIgnoreCase)(v,d)}hasTrailingPathSeparator(v,d=I.sep){if(v.scheme===t.Schemas.file){const b=S(v);return b.length>a.getRoot(b).length&&b[b.length-1]===d}else{const b=v.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,d=I.sep){return(0,e.hasTrailingPathSeparator)(v,d)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,d=I.sep){let b=!1;if(v.scheme===t.Schemas.file){const f=S(v);b=f!==void 0&&f.length===a.getRoot(f).length&&f[f.length-1]===d}else{d="/";const f=v.path;b=f.length===1&&f.charCodeAt(f.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(v,d)?v.with({path:v.path+"/"}):v}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(y=>y.scheme===t.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new C(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(y,v){const d=[];for(let b=0;b<y.length;b++){const f=v(y[b]);y.some((w,h)=>h===b?!1:(0,e.isEqualOrParent)(f,v(w)))||d.push(y[b])}return d}e.distinctParents=R;var T;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function v(d){const b=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(h=>{const[m,p]=h.split(":");m&&p&&b.set(m,p)});const w=d.path.substring(0,d.path.indexOf(";"));return w&&b.set(y.META_DATA_MIME,w),b}y.parseMetaData=v})(T=e.DataUri||(e.DataUri={}));function E(y,v,d){if(v){let b=y.path;return b&&b[0]!==I.posix.sep&&(b=I.posix.sep+b),y.with({scheme:d,authority:v,path:b})}return y.with({scheme:d})}e.toLocalResource=E}),define(Se[18],ye([1,0,21,10,4,6,24,12]),function(ne,e,a,t,I,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(le){return!!le&&typeof le.then=="function"}e.isThenable=S;function C(le){const Z=new a.CancellationTokenSource,ge=le(Z.token),ve=new Promise((De,Re)=>{const ze=Z.token.onCancellationRequested(()=>{ze.dispose(),Z.dispose(),Re(new t.CancellationError)});Promise.resolve(ge).then(se=>{ze.dispose(),Z.dispose(),De(se)},se=>{ze.dispose(),Z.dispose(),Re(se)})});return new class{cancel(){Z.cancel()}then(De,Re){return ve.then(De,Re)}catch(De){return this.then(void 0,De)}finally(De){return ve.finally(De)}}}e.createCancelablePromise=C;function R(le,Z,ge){return new Promise((ve,De)=>{const Re=Z.onCancellationRequested(()=>{Re.dispose(),ve(ge)});le.then(ve,De).finally(()=>Re.dispose())})}e.raceCancellation=R;function T(le,Z){return new Promise((ge,ve)=>{const De=Z.onCancellationRequested(()=>{De.dispose(),ve(new t.CancellationError)});le.then(ge,ve).finally(()=>De.dispose())})}e.raceCancellationError=T;async function E(le){let Z=-1;const ge=le.map((De,Re)=>De.then(ze=>(Z=Re,ze))),ve=await Promise.race(ge);return le.forEach((De,Re)=>{Re!==Z&&De.cancel()}),ve}e.raceCancellablePromises=E;function y(le,Z,ge){let ve;const De=setTimeout(()=>{ve?.(void 0),ge?.()},Z);return Promise.race([le.finally(()=>clearTimeout(De)),new Promise(Re=>ve=Re)])}e.raceTimeout=y;function v(le){return new Promise((Z,ge)=>{const ve=le();S(ve)?ve.then(Z,ge):Z(ve)})}e.asPromise=v;class d{constructor(){this.a=null,this.b=null,this.d=null}queue(Z){if(this.a){if(this.d=Z,!this.b){const ge=()=>{this.b=null;const ve=this.queue(this.d);return this.d=null,ve};this.b=new Promise(ve=>{this.a.then(ge,ge).then(ve)})}return new Promise((ge,ve)=>{this.b.then(ge,ve)})}return this.a=Z(),new Promise((ge,ve)=>{this.a.then(De=>{this.a=null,ge(De)},De=>{this.a=null,ve(De)})})}}e.Throttler=d;class b{constructor(){this.a=Promise.resolve(null)}queue(Z){return this.a=this.a.then(()=>Z(),()=>Z())}}e.Sequencer=b;class f{constructor(){this.a=new Map}queue(Z,ge){const De=(this.a.get(Z)??Promise.resolve()).catch(()=>{}).then(ge).finally(()=>{this.a.get(Z)===De&&this.a.delete(Z)});return this.a.set(Z,De),De}}e.SequencerByKey=f;const w=(le,Z)=>{let ge=!0;const ve=setTimeout(()=>{ge=!1,Z()},le);return{isTriggered:()=>ge,dispose:()=>{clearTimeout(ve),ge=!1}}},h=le=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,le())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class m{constructor(Z){this.defaultDelay=Z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Z,ge=this.defaultDelay){this.g=Z,this.h(),this.b||(this.b=new Promise((De,Re)=>{this.d=De,this.f=Re}).then(()=>{if(this.b=null,this.d=null,this.g){const De=this.g;return this.g=null,De()}}));const ve=()=>{this.a=null,this.d?.(null)};return this.a=ge===e.MicrotaskDelay?h(ve):w(ge,ve),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=m;class p{constructor(Z){this.a=new m(Z),this.b=new d}trigger(Z,ge){return this.a.trigger(()=>this.b.queue(Z),ge)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=p;class o{constructor(){this.a=!1,this.b=new Promise((Z,ge)=>{this.d=Z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=o;class i extends o{constructor(Z){super(),this.f=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=i;function l(le,Z){return Z?new Promise((ge,ve)=>{const De=setTimeout(()=>{Re.dispose(),ge()},le),Re=Z.onCancellationRequested(()=>{clearTimeout(De),Re.dispose(),ve(new t.CancellationError)})}):C(ge=>l(le,ge))}e.timeout=l;function u(le,Z=0){const ge=setTimeout(le,Z);return(0,A.toDisposable)(()=>clearTimeout(ge))}e.disposableTimeout=u;function s(le){const Z=[];let ge=0;const ve=le.length;function De(){return ge<ve?le[ge++]():null}function Re(ze){ze!=null&&Z.push(ze);const se=De();return se?se.then(Re):Promise.resolve(Z)}return Promise.resolve(null).then(Re)}e.sequence=s;function c(le,Z=ve=>!!ve,ge=null){let ve=0;const De=le.length,Re=()=>{if(ve>=De)return Promise.resolve(ge);const ze=le[ve++];return Promise.resolve(ze()).then(ue=>Z(ue)?Promise.resolve(ue):Re())};return Re()}e.first=c;function n(le,Z=ve=>!!ve,ge=null){if(le.length===0)return Promise.resolve(ge);let ve=le.length;const De=()=>{ve=-1;for(const Re of le)Re.cancel?.()};return new Promise((Re,ze)=>{for(const se of le)se.then(ue=>{--ve>=0&&Z(ue)?(De(),Re(ue)):ve===0&&Re(ge)}).catch(ue=>{--ve>=0&&(De(),ze(ue))})})}e.firstParallel=n;class r{constructor(Z){this.a=0,this.d=Z,this.f=[],this.b=0,this.g=new I.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(Z){return this.a++,new Promise((ge,ve)=>{this.f.push({factory:Z,c:ge,e:ve}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const Z=this.f.shift();this.b++;const ge=Z.factory();ge.then(Z.c,Z.e),ge.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=r;class g extends r{constructor(){super(1)}}e.Queue=g;class P{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const Z=new x;return this.b.add(Z),Z.p}d(){for(const[,Z]of this.a)if(Z.size>0)return!1;return!0}queueFor(Z,ge=D.extUri){const ve=ge.getComparisonKey(Z);let De=this.a.get(ve);return De||(De=new g,I.Event.once(De.onDrained)(()=>{De?.dispose(),this.a.delete(ve),this.f()}),this.a.set(ve,De)),De}f(){!this.d()||this.g()}g(){for(const Z of this.b)Z.complete();this.b.clear()}dispose(){for(const[,Z]of this.a)Z.dispose();this.a.clear(),this.g()}}e.ResourceQueue=P;class L{constructor(Z,ge){this.a=-1,typeof Z=="function"&&typeof ge=="number"&&this.setIfNotSet(Z,ge)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Z,ge){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Z()},ge)}setIfNotSet(Z,ge){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Z()},ge))}}e.TimeoutTimer=L;class z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(Z,ge){this.cancel(),this.a=setInterval(()=>{Z()},ge)}}e.IntervalTimer=z;class _{constructor(Z,ge){this.b=-1,this.a=Z,this.d=ge,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Z=this.d){this.cancel(),this.b=setTimeout(this.f,Z)}get delay(){return this.d}set delay(Z){this.d=Z}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=_;class K{constructor(Z,ge){ge%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ge}ms is not a multiple of 1000ms.`),this.a=Z,this.b=ge,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Z=this.b){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=K;class F extends _{constructor(Z,ge){super(Z,ge),this.j=[]}work(Z){this.j.push(Z),this.isScheduled()||this.schedule()}h(){const Z=this.j;this.j=[],this.a?.(Z)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=F;class M extends A.Disposable{constructor(Z,ge){super(),this.g=Z,this.h=ge,this.a=[],this.b=this.B(new A.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(Z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Z.length>this.g.maxBufferedWork)return!1}else if(this.pending+Z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(...Z),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new _(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=le=>{(0,k.setTimeout0)(()=>{if(Z)return;const ge=Date.now()+15;le(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ge-Date.now())}}))});let Z=!1;return{dispose(){Z||(Z=!0)}}}:e.runWhenIdle=(le,Z)=>{const ge=requestIdleCallback(le,typeof Z=="number"?{timeout:Z}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,cancelIdleCallback(ge))}}}}();class N{constructor(Z){this.d=!1,this.a=()=>{try{this.f=Z()}catch(ge){this.g=ge}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=N;async function B(le,Z,ge){let ve;for(let De=0;De<ge;De++)try{return await le()}catch(Re){ve=Re,await l(Z)}throw ve}e.retry=B;class U{hasPending(Z){return this.a?typeof Z=="number"?this.a.taskId===Z:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(Z,ge,ve){return this.a={taskId:Z,cancel:()=>ve?.(),promise:ge},ge.then(()=>this.d(Z),()=>this.d(Z)),ge}d(Z){this.a&&Z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Z=this.b;this.b=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}setNext(Z){if(this.b)this.b.run=Z;else{let ge,ve;const De=new Promise((Re,ze)=>{ge=Re,ve=ze});this.b={run:Z,promise:De,promiseResolve:ge,promiseReject:ve}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=U;class W{constructor(Z,ge=()=>Date.now()){this.d=Z,this.f=ge,this.a=0,this.b=0}increment(){const Z=this.f();return Z-this.a>this.d&&(this.a=Z,this.b=0),this.b++,this.b}}e.IntervalCounter=W;class x{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((Z,ge)=>{this.a=Z,this.b=ge})}complete(Z){return new Promise(ge=>{this.a(Z),this.f=!0,ge()})}error(Z){return new Promise(ge=>{this.b(Z),this.d=!0,ge()})}cancel(){new Promise(Z=>{this.b(new t.CancellationError),this.d=!0,Z()})}}e.DeferredPromise=x;var V;(function(le){async function Z(ve){let De;const Re=await Promise.all(ve.map(ze=>ze.then(se=>se,se=>{De||(De=se)})));if(typeof De<"u")throw De;return Re}le.settled=Z;function ge(ve){return new Promise(async(De,Re)=>{try{await ve(De,Re)}catch(ze){Re(ze)}})}le.withAsyncBody=ge})(V=e.Promises||(e.Promises={}));var X;(function(le){le[le.Initial=0]="Initial",le[le.DoneOK=1]="DoneOK",le[le.DoneError=2]="DoneError"})(X||(X={}));class Q{static fromArray(Z){return new Q(ge=>{ge.emitMany(Z)})}static fromPromise(Z){return new Q(async ge=>{ge.emitMany(await Z)})}static fromPromises(Z){return new Q(async ge=>{await Promise.all(Z.map(async ve=>ge.emitOne(await ve)))})}static merge(Z){return new Q(async ge=>{await Promise.all(Z.map(async ve=>{for await(const De of ve)ge.emitOne(De)}))})}constructor(Z){this.a=0,this.b=[],this.d=null,this.f=new I.Emitter,queueMicrotask(async()=>{const ge={emitOne:ve=>this.g(ve),emitMany:ve=>this.h(ve),reject:ve=>this.k(ve)};try{await Promise.resolve(Z(ge)),this.j()}catch(ve){this.k(ve)}finally{ge.emitOne=void 0,ge.emitMany=void 0,ge.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Z<this.b.length)return{done:!1,value:this.b[Z++]};if(this.a===1)return{done:!0,value:void 0};await I.Event.toPromise(this.f.event)}while(!0)}}}static map(Z,ge){return new Q(async ve=>{for await(const De of Z)ve.emitOne(ge(De))})}map(Z){return Q.map(this,Z)}static filter(Z,ge){return new Q(async ve=>{for await(const De of Z)ge(De)&&ve.emitOne(De)})}filter(Z){return Q.filter(this,Z)}static coalesce(Z){return Q.filter(Z,ge=>!!ge)}coalesce(){return Q.coalesce(this)}static async toPromise(Z){const ge=[];for await(const ve of Z)ge.push(ve);return ge}toPromise(){return Q.toPromise(this)}g(Z){this.a===0&&(this.b.push(Z),this.f.fire())}h(Z){this.a===0&&(this.b=this.b.concat(Z),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(Z){this.a===0&&(this.a=2,this.d=Z,this.f.fire())}}e.AsyncIterableObject=Q,Q.EMPTY=Q.fromArray([]);class J extends Q{constructor(Z,ge){super(ge),this.l=Z}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=J;function te(le){const Z=new a.CancellationTokenSource,ge=le(Z.token);return new J(Z,async ve=>{const De=Z.token.onCancellationRequested(()=>{De.dispose(),Z.dispose(),ve.reject(new t.CancellationError)});try{for await(const Re of ge){if(Z.token.isCancellationRequested)return;ve.emitOne(Re)}De.dispose(),Z.dispose()}catch(Re){De.dispose(),Z.dispose(),ve.reject(Re)}})}e.createCancelableAsyncIterable=te}),define(Se[108],ye([1,0,18,9]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new a.IdleValue(()=>{const r=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:r,collatorIsNumeric:r.resolvedOptions().numeric}}),A=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),D=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(r,g,P=!1){const L=r||"",z=g||"",_=I.value.collator.compare(L,z);return I.value.collatorIsNumeric&&_===0&&L!==z?L<z?-1:1:_}e.compareFileNames=k;function S(r,g){const P=A.value.collator;return r=r||"",g=g||"",m(P,r,g)}e.compareFileNamesDefault=S;function C(r,g){const P=A.value.collator;return r=r||"",g=g||"",l(r,g)||m(P,r,g)}e.compareFileNamesUpper=C;function R(r,g){const P=A.value.collator;return r=r||"",g=g||"",i(r,g)||m(P,r,g)}e.compareFileNamesLower=R;function T(r,g){return r=r||"",g=g||"",r===g?0:r<g?-1:1}e.compareFileNamesUnicode=T;function E(r,g){const[P,L]=w(r),[z,_]=w(g);let K=I.value.collator.compare(L,_);if(K===0){if(I.value.collatorIsNumeric&&L!==_)return L<_?-1:1;if(K=I.value.collator.compare(P,z),I.value.collatorIsNumeric&&K===0&&P!==z)return P<z?-1:1}return K}e.compareFileExtensions=E;function y(r,g){r=r||"",g=g||"";const P=h(r),L=h(g),z=A.value.collator,_=D.value.collator;return m(_,P,L)||m(z,r,g)}e.compareFileExtensionsDefault=y;function v(r,g){r=r||"",g=g||"";const P=h(r),L=h(g),z=A.value.collator,_=D.value.collator;return m(_,P,L)||l(r,g)||m(z,r,g)}e.compareFileExtensionsUpper=v;function d(r,g){r=r||"",g=g||"";const P=h(r),L=h(g),z=A.value.collator,_=D.value.collator;return m(_,P,L)||i(r,g)||m(z,r,g)}e.compareFileExtensionsLower=d;function b(r,g){r=r||"",g=g||"";const P=h(r).toLowerCase(),L=h(g).toLowerCase();return P!==L?P<L?-1:1:r!==g?r<g?-1:1:0}e.compareFileExtensionsUnicode=b;const f=/^(.*?)(\.([^.]*))?$/;function w(r,g=!1){const P=r?f.exec(r):[];let L=[P&&P[1]||"",P&&P[3]||""];return g&&(!L[0]&&L[1]||L[0]&&L[0].charAt(0)===".")&&(L=[L[0]+"."+L[1],""]),L}function h(r){const g=r?f.exec(r):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function m(r,g,P){const L=r.compare(g,P);return L!==0?L:g.length!==P.length?g.length<P.length?-1:1:0}function p(r){const g=r.charAt(0);return g.toLocaleUpperCase()!==g}function o(r){const g=r.charAt(0);return g.toLocaleLowerCase()!==g}function i(r,g){return p(r)&&o(g)?-1:o(r)&&p(g)?1:0}function l(r,g){return o(r)&&p(g)?-1:p(r)&&o(g)?1:0}function u(r,g,P=!1){return P||(r=r&&r.toLowerCase(),g=g&&g.toLowerCase()),r===g?0:r<g?-1:1}function s(r,g,P=!1){const L=r.split(t.sep),z=g.split(t.sep),_=L.length-1,K=z.length-1;let F,M;for(let N=0;;N++){if(F=_===N,M=K===N,F&&M)return k(L[N],z[N],P);if(F)return-1;if(M)return 1;const B=u(L[N],z[N],P);if(B!==0)return B}}e.comparePaths=s;function c(r,g,P){const L=r.toLowerCase(),z=g.toLowerCase(),_=n(r,g,P);if(_)return _;const K=L.endsWith(P),F=z.endsWith(P);if(K!==F)return K?-1:1;const M=k(L,z);return M!==0?M:L.localeCompare(z)}e.compareAnything=c;function n(r,g,P){const L=r.toLowerCase(),z=g.toLowerCase(),_=L.startsWith(P),K=z.startsWith(P);if(_!==K)return _?-1:1;if(_&&K){if(L.length<z.length)return-1;if(L.length>z.length)return 1}return 0}e.compareByPrefix=n}),define(Se[109],ye([1,0,108,107,84,9,12,8]),function(ne,e,a,t,I,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,C=[S,[]];function R(U,W,x,V){if(!U||!W)return C;const X=U.length,Q=W.length;if(X<Q)return C;const J=U.toLowerCase();return T(W,x,Q,U,J,X,V)}e.scoreFuzzy=R;function T(U,W,x,V,X,Q,J){const te=[],le=[];for(let De=0;De<x;De++){const Re=De*Q,ze=Re-Q,se=De>0,ue=U[De],he=W[De];for(let ee=0;ee<Q;ee++){const oe=ee>0,ie=Re+ee,O=ie-1,H=ze+ee-1,q=oe?te[O]:0,Y=se&&oe?te[H]:0,de=se&&oe?le[H]:0;let be;!Y&&se?be=0:be=E(ue,he,V,X,ee,de),be&&Y+be>=q&&(J||se||X.startsWith(W,ee))?(le[ie]=de+1,te[ie]=Y+be):(le[ie]=S,te[ie]=q)}}const Z=[];let ge=x-1,ve=Q-1;for(;ge>=0&&ve>=0;){const De=ge*Q+ve;le[De]===S||(Z.push(ve),ge--),ve--}return[te[x*Q-1],Z.reverse()]}function E(U,W,x,V,X,Q){let J=0;if(!y(W,V[X]))return J;if(J+=1,Q>0&&(J+=Q*5),U===x[X]&&(J+=1),X===0)J+=8;else{const te=v(x.charCodeAt(X-1));te?J+=te:(0,t.isUpper)(x.charCodeAt(X))&&Q===0&&(J+=2)}return J}function y(U,W){return U===W?!0:U==="/"||U==="\\"?W==="/"||W==="\\":!1}function v(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const d=[void 0,[]];function b(U,W,x=0,V=0){const X=W;return X.values&&X.values.length>1?f(U,X.values,x,V):w(U,W,x,V)}e.scoreFuzzy2=b;function f(U,W,x,V){let X=0;const Q=[];for(const J of W){const[te,le]=w(U,J,x,V);if(typeof te!="number")return d;X+=te,Q.push(...le)}return[X,r(Q)]}function w(U,W,x,V){const X=(0,t.fuzzyScore)(W.original,W.originalLowercase,x,U,U.toLowerCase(),V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return X?[X[0],(0,t.createMatches)(X)]:d}const h=Object.freeze({score:0}),m=1<<18,p=1<<17,o=1<<16;function i(U,W,x,V){const X=V.values?V.values:[V];return(0,I.hash)({[V.normalized]:{values:X.map(J=>({value:J.normalized,expectContiguousMatch:J.expectContiguousMatch})),label:U,description:W,allowNonContiguousMatches:x}})}function l(U,W,x,V,X){if(!U||!W.normalized)return h;const Q=V.getItemLabel(U);if(!Q)return h;const J=V.getItemDescription(U),te=i(Q,J,x,W),le=X[te];if(le)return le;const Z=u(Q,J,V.getItemPath(U),W,x);return X[te]=Z,Z}e.scoreItemFuzzy=l;function u(U,W,x,V,X){const Q=!x||!V.containsPathSeparator;return x&&(D.isLinux?V.pathNormalized===x:(0,k.equalsIgnoreCase)(V.pathNormalized,x))?{score:m,labelMatch:[{start:0,end:U.length}],descriptionMatch:W?[{start:0,end:W.length}]:void 0}:V.values&&V.values.length>1?s(U,W,x,V.values,Q,X):c(U,W,x,V,Q,X)}function s(U,W,x,V,X,Q){let J=0;const te=[],le=[];for(const Z of V){const{score:ge,labelMatch:ve,descriptionMatch:De}=c(U,W,x,Z,X,Q);if(ge===S)return h;J+=ge,ve&&te.push(...ve),De&&le.push(...De)}return{score:J,labelMatch:r(te),descriptionMatch:r(le)}}function c(U,W,x,V,X,Q){if(X||!W){const[J,te]=R(U,V.normalized,V.normalizedLowercase,Q&&!V.expectContiguousMatch);if(J){const le=(0,t.matchesPrefix)(V.normalized,U);let Z;return le?(Z=p,Z+=Math.round(V.normalized.length/U.length*100)):Z=o,{score:Z+J,labelMatch:le||n(te)}}}if(W){let J=W;x&&(J=`${W}${A.sep}`);const te=J.length,le=`${J}${U}`,[Z,ge]=R(le,V.normalized,V.normalizedLowercase,Q&&!V.expectContiguousMatch);if(Z){const ve=n(ge),De=[],Re=[];return ve.forEach(ze=>{ze.start<te&&ze.end>te?(De.push({start:0,end:ze.end-te}),Re.push({start:ze.start,end:te})):ze.start>=te?De.push({start:ze.start-te,end:ze.end-te}):Re.push(ze)}),{score:Z,labelMatch:De,descriptionMatch:Re}}}return h}function n(U){const W=[];if(!U)return W;let x;for(const V of U)x&&x.end===V?x.end+=1:(x={start:V,end:V+1},W.push(x));return W}function r(U){const W=U.sort((X,Q)=>X.start-Q.start),x=[];let V;for(const X of W)!V||!g(V,X)?(V=X,x.push(X)):(V.start=Math.min(V.start,X.start),V.end=Math.max(V.end,X.end));return x}function g(U,W){return!(U.end<W.start||W.end<U.start)}function P(U,W,x,V,X,Q){const J=l(U,x,V,X,Q),te=l(W,x,V,X,Q),le=J.score,Z=te.score;if((le===m||Z===m)&&le!==Z)return le===m?-1:1;if(le>o||Z>o){if(le!==Z)return le>Z?-1:1;if(le<p&&Z<p){const ue=z(J.labelMatch,te.labelMatch);if(ue!==0)return ue}const ze=X.getItemLabel(U)||"",se=X.getItemLabel(W)||"";if(ze.length!==se.length)return ze.length-se.length}if(le!==Z)return le>Z?-1:1;const ge=Array.isArray(J.labelMatch)&&J.labelMatch.length>0,ve=Array.isArray(te.labelMatch)&&te.labelMatch.length>0;if(ge&&!ve)return-1;if(ve&&!ge)return 1;const De=L(U,J,X),Re=L(W,te,X);return De&&Re&&De!==Re?Re>De?-1:1:_(U,W,x,X)}e.compareItemsByFuzzyScore=P;function L(U,W,x){let V=-1,X=-1;if(W.descriptionMatch&&W.descriptionMatch.length?V=W.descriptionMatch[0].start:W.labelMatch&&W.labelMatch.length&&(V=W.labelMatch[0].start),W.labelMatch&&W.labelMatch.length){if(X=W.labelMatch[W.labelMatch.length-1].end,W.descriptionMatch&&W.descriptionMatch.length){const Q=x.getItemDescription(U);Q&&(X+=Q.length)}}else W.descriptionMatch&&W.descriptionMatch.length&&(X=W.descriptionMatch[W.descriptionMatch.length-1].end);return X-V}function z(U,W){if(!U&&!W||(!U||!U.length)&&(!W||!W.length))return 0;if(!W||!W.length)return-1;if(!U||!U.length)return 1;const x=U[0].start,X=U[U.length-1].end-x,Q=W[0].start,te=W[W.length-1].end-Q;return X===te?0:te<X?1:-1}function _(U,W,x,V){const X=V.getItemLabel(U)||"",Q=V.getItemLabel(W)||"",J=V.getItemDescription(U),te=V.getItemDescription(W),le=X.length+(J?J.length:0),Z=Q.length+(te?te.length:0);if(le!==Z)return le-Z;const ge=V.getItemPath(U),ve=V.getItemPath(W);return ge&&ve&&ge.length!==ve.length?ge.length-ve.length:X!==Q?(0,a.compareAnything)(X,Q,x.normalized):J&&te&&J!==te?(0,a.compareAnything)(J,te,x.normalized):ge&&ve&&ge!==ve?(0,a.compareAnything)(ge,ve,x.normalized):0}function K(U){return U.startsWith('"')&&U.endsWith('"')}const F=" ";function M(U){typeof U!="string"&&(U="");const W=U.toLowerCase(),{pathNormalized:x,normalized:V,normalizedLowercase:X}=N(U),Q=x.indexOf(A.sep)>=0,J=K(U);let te;const le=U.split(F);if(le.length>1)for(const Z of le){const ge=K(Z),{pathNormalized:ve,normalized:De,normalizedLowercase:Re}=N(Z);De&&(te||(te=[]),te.push({original:Z,originalLowercase:Z.toLowerCase(),pathNormalized:ve,normalized:De,normalizedLowercase:Re,expectContiguousMatch:ge}))}return{original:U,originalLowercase:W,pathNormalized:x,normalized:V,normalizedLowercase:X,values:te,containsPathSeparator:Q,expectContiguousMatch:J}}e.prepareQuery=M;function N(U){let W;D.isWindows?W=U.replace(/\//g,A.sep):W=U.replace(/\\/g,A.sep);const x=(0,k.stripWildcards)(W).replace(/\s|"/g,"");return{pathNormalized:W,normalized:x,normalizedLowercase:x.toLowerCase()}}function B(U){return Array.isArray(U)?M(U.map(W=>W.original).join(F)):M(U.original)}e.pieceToQuery=B}),define(Se[37],ye([1,0,17,18,32,28,9,12,8]),function(ne,e,a,t,I,A,D,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",T="[^/\\\\]",E=/\//g;function y(x,V){switch(x){case 0:return"";case 1:return`${T}*?`;default:return`(?:${R}|${T}+${R}${V?`|${R}${T}+`:""})*?`}}function v(x,V){if(!x)return[];const X=[];let Q=!1,J=!1,te="";for(const le of x){switch(le){case V:if(!Q&&!J){X.push(te),te="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":J=!0;break;case"]":J=!1;break}te+=le}return te&&X.push(te),X}e.splitGlobAware=v;function d(x){if(!x)return"";let V="";const X=v(x,e.GLOB_SPLIT);if(X.every(Q=>Q===e.GLOBSTAR))V=".*";else{let Q=!1;X.forEach((J,te)=>{if(J===e.GLOBSTAR){if(Q)return;V+=y(2,te===X.length-1)}else{let le=!1,Z="",ge=!1,ve="";for(const De of J){if(De!=="}"&&le){Z+=De;continue}if(ge&&(De!=="]"||!ve)){let Re;De==="-"?Re=De:(De==="^"||De==="!")&&!ve?Re="^":De===e.GLOB_SPLIT?Re="":Re=(0,S.escapeRegExpCharacters)(De),ve+=Re;continue}switch(De){case"{":le=!0;continue;case"[":ge=!0;continue;case"}":{V+=`(?:${v(Z,",").map(se=>d(se)).join("|")})`,le=!1,Z="";break}case"]":{V+="["+ve+"]",ge=!1,ve="";break}case"?":V+=T;continue;case"*":V+=y(1);continue;default:V+=(0,S.escapeRegExpCharacters)(De)}}te<X.length-1&&(X[te+1]!==e.GLOBSTAR||te+2<X.length)&&(V+=R)}Q=J===e.GLOBSTAR})}return V}const b=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,o=new A.LRUCache(1e4),i=function(){return!1},l=function(){return null};function u(x,V){if(!x)return l;let X;typeof x!="string"?X=x.pattern:X=x,X=X.trim();const Q=`${X}_${!!V.trimForExclusions}`;let J=o.get(Q);if(J)return s(J,x);let te;return b.test(X)?J=n(X.substr(4),X):(te=f.exec(c(X,V)))?J=r(te[1],X):(V.trimForExclusions?h:w).test(X)?J=g(X,V):(te=m.exec(c(X,V)))?J=P(te[1].substr(1),X,!0):(te=p.exec(c(X,V)))?J=P(te[1],X,!1):J=L(X),o.set(Q,J),s(J,x)}function s(x,V){if(typeof V=="string")return x;const X=function(Q,J){return(0,I.isEqualOrParent)(Q,V.base,!k.isLinux)?x((0,S.ltrim)(Q.substr(V.base.length),D.sep),J):null};return X.allBasenames=x.allBasenames,X.allPaths=x.allPaths,X.basenames=x.basenames,X.patterns=x.patterns,X}function c(x,V){return V.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function n(x,V){return function(X,Q){return typeof X=="string"&&X.endsWith(x)?V:null}}function r(x,V){const X=`/${x}`,Q=`\\${x}`,J=function(le,Z){return typeof le!="string"?null:Z?Z===x?V:null:le===x||le.endsWith(X)||le.endsWith(Q)?V:null},te=[x];return J.basenames=te,J.patterns=[V],J.allBasenames=te,J}function g(x,V){const X=U(x.slice(1,-1).split(",").map(Z=>u(Z,V)).filter(Z=>Z!==l),x),Q=X.length;if(!Q)return l;if(Q===1)return X[0];const J=function(Z,ge){for(let ve=0,De=X.length;ve<De;ve++)if(X[ve](Z,ge))return x;return null},te=X.find(Z=>!!Z.allBasenames);te&&(J.allBasenames=te.allBasenames);const le=X.reduce((Z,ge)=>ge.allPaths?Z.concat(ge.allPaths):Z,[]);return le.length&&(J.allPaths=le),J}function P(x,V,X){const Q=D.sep===D.posix.sep,J=Q?x:x.replace(E,D.sep),te=D.sep+J,le=D.posix.sep+x;let Z;return X?Z=function(ge,ve){return typeof ge=="string"&&(ge===J||ge.endsWith(te)||!Q&&(ge===x||ge.endsWith(le)))?V:null}:Z=function(ge,ve){return typeof ge=="string"&&(ge===J||!Q&&ge===x)?V:null},Z.allPaths=[(X?"*/":"./")+x],Z}function L(x){try{const V=new RegExp(`^${d(x)}$`);return function(X){return V.lastIndex=0,typeof X=="string"&&V.test(X)?x:null}}catch{return l}}function z(x,V,X){return!x||typeof V!="string"?!1:_(x)(V,void 0,X)}e.match=z;function _(x,V={}){if(!x)return i;if(typeof x=="string"||K(x)){const X=u(x,V);if(X===l)return i;const Q=function(J,te){return!!X(J,te)};return X.allBasenames&&(Q.allBasenames=X.allBasenames),X.allPaths&&(Q.allPaths=X.allPaths),Q}return N(x,V)}e.parse=_;function K(x){const V=x;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.isRelativePattern=K;function F(x){return x.allBasenames||[]}e.getBasenameTerms=F;function M(x){return x.allPaths||[]}e.getPathTerms=M;function N(x,V){const X=U(Object.getOwnPropertyNames(x).map(Z=>B(Z,x[Z],V)).filter(Z=>Z!==l)),Q=X.length;if(!Q)return l;if(!X.some(Z=>!!Z.requiresSiblings)){if(Q===1)return X[0];const Z=function(De,Re){let ze;for(let se=0,ue=X.length;se<ue;se++){const he=X[se](De,Re);if(typeof he=="string")return he;(0,t.isThenable)(he)&&(ze||(ze=[]),ze.push(he))}return ze?(async()=>{for(const se of ze){const ue=await se;if(typeof ue=="string")return ue}return null})():null},ge=X.find(De=>!!De.allBasenames);ge&&(Z.allBasenames=ge.allBasenames);const ve=X.reduce((De,Re)=>Re.allPaths?De.concat(Re.allPaths):De,[]);return ve.length&&(Z.allPaths=ve),Z}const J=function(Z,ge,ve){let De,Re;for(let ze=0,se=X.length;ze<se;ze++){const ue=X[ze];ue.requiresSiblings&&ve&&(ge||(ge=(0,D.basename)(Z)),De||(De=ge.substr(0,ge.length-(0,D.extname)(Z).length)));const he=ue(Z,ge,De,ve);if(typeof he=="string")return he;(0,t.isThenable)(he)&&(Re||(Re=[]),Re.push(he))}return Re?(async()=>{for(const ze of Re){const se=await ze;if(typeof se=="string")return se}return null})():null},te=X.find(Z=>!!Z.allBasenames);te&&(J.allBasenames=te.allBasenames);const le=X.reduce((Z,ge)=>ge.allPaths?Z.concat(ge.allPaths):Z,[]);return le.length&&(J.allPaths=le),J}function B(x,V,X){if(V===!1)return l;const Q=u(x,X);if(Q===l)return l;if(typeof V=="boolean")return Q;if(V){const J=V.when;if(typeof J=="string"){const te=(le,Z,ge,ve)=>{if(!ve||!Q(le,Z))return null;const De=J.replace("$(basename)",()=>ge),Re=ve(De);return(0,t.isThenable)(Re)?Re.then(ze=>ze?x:null):Re?x:null};return te.requiresSiblings=!0,te}}return Q}function U(x,V){const X=x.filter(Z=>!!Z.basenames);if(X.length<2)return x;const Q=X.reduce((Z,ge)=>{const ve=ge.basenames;return ve?Z.concat(ve):Z},[]);let J;if(V){J=[];for(let Z=0,ge=Q.length;Z<ge;Z++)J.push(V)}else J=X.reduce((Z,ge)=>{const ve=ge.patterns;return ve?Z.concat(ve):Z},[]);const te=function(Z,ge){if(typeof Z!="string")return null;if(!ge){let De;for(De=Z.length;De>0;De--){const Re=Z.charCodeAt(De-1);if(Re===47||Re===92)break}ge=Z.substr(De)}const ve=Q.indexOf(ge);return ve!==-1?J[ve]:null};te.basenames=Q,te.patterns=J,te.allBasenames=Q;const le=x.filter(Z=>!Z.basenames);return le.push(te),le}function W(x,V){return(0,a.equals)(x,V,(X,Q)=>typeof X=="string"&&typeof Q=="string"?X===Q:typeof X!="string"&&typeof Q!="string"?X.base===Q.base&&X.pattern===Q.pattern:!1)}e.patternsEquals=W}),define(Se[110],ye([1,0,10,160,24,8,2]),function(ne,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(b){b[b.Paragraph=0]="Paragraph",b[b.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(f="",w=!1){if(this.value=f,typeof this.value!="string")throw(0,a.illegalArgument)("value");typeof w=="boolean"?(this.isTrusted=w,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=w.isTrusted??void 0,this.supportThemeIcons=w.supportThemeIcons??!1,this.supportHtml=w.supportHtml??!1)}appendText(f,w=0){return this.value+=E(this.supportThemeIcons?(0,t.escapeIcons)(f):f).replace(/([ \t]+)/g,(h,m)=>"&nbsp;".repeat(m.length)).replace(/\>/gm,"\\>").replace(/\n/g,w===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,w){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=w,this.value+="\n```\n",this}appendLink(f,w,h){return this.value+="[",this.value+=this.c(w,"]"),this.value+="](",this.value+=this.c(String(f),")"),h&&(this.value+=` "${this.c(this.c(h,'"'),")")}"`),this.value+=")",this}c(f,w){const h=new RegExp((0,A.escapeRegExpCharacters)(w),"g");return f.replace(h,(m,p)=>f.charAt(p-1)!=="\\"?`\\${m}`:m)}}e.MarkdownString=S;function C(b){return R(b)?!b.value:Array.isArray(b)?b.every(C):!0}e.isEmptyMarkdownString=C;function R(b){return b instanceof S?!0:b&&typeof b=="object"?typeof b.value=="string"&&(typeof b.isTrusted=="boolean"||b.isTrusted===void 0)&&(typeof b.supportThemeIcons=="boolean"||b.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function T(b,f){return b===f?!0:!b||!f?!1:b.value===f.value&&b.isTrusted===f.isTrusted&&b.supportThemeIcons===f.supportThemeIcons&&b.supportHtml===f.supportHtml&&(b.baseUri===f.baseUri||!!b.baseUri&&!!f.baseUri&&(0,I.isEqual)(D.URI.from(b.baseUri),D.URI.from(f.baseUri)))}e.markdownStringEqual=T;function E(b){return b.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=E;function y(b){return b.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=y;function v(b){return b&&b.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=v;function d(b){const f=[],w=b.split("|").map(m=>m.trim());b=w[0];const h=w[1];if(h){const m=/height=(\d+)/.exec(h),p=/width=(\d+)/.exec(h),o=m?m[1]:"",i=p?p[1]:"",l=isFinite(parseInt(i)),u=isFinite(parseInt(o));l&&f.push(`width="${i}"`),u&&f.push(`height="${o}"`)}return{href:b,dimensions:f}}e.parseHrefAndDimensions=d}),define(Se[111],ye([1,0,17,32,9,12,24,8]),function(ne,e,a,t,I,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(l,u){const{os:s,tildify:c,relative:n}=u;if(n){const P=C(l,n,s);if(typeof P=="string")return P}let r=l.fsPath;if(s===1&&!A.isWindows?r=r.replace(/\//g,"\\"):s!==1&&A.isWindows&&(r=r.replace(/\\/g,"/")),s!==1&&c?.userHome){const P=c.userHome.fsPath;let L;l.scheme!==c.userHome.scheme&&l.path.startsWith(I.posix.sep)?L=c.userHome.with({path:l.path}).fsPath:L=l.fsPath,r=E(L,P,s)}return(s===1?I.win32:I.posix).normalize(R(r,s===1))}e.getPathLabel=S;function C(l,u,s){const c=s===1?I.win32:I.posix,n=s===3?D.extUri:D.extUriIgnorePathCase,r=u.getWorkspace(),g=(0,a.firstOrDefault)(r.folders);if(!g)return;l.scheme!==g.uri.scheme&&l.path.startsWith(I.posix.sep)&&(l=g.uri.with({path:l.path}));const P=u.getWorkspaceFolder(l);if(!P)return;let L;if(n.isEqual(P.uri,l)?L="":L=n.relativePath(P.uri,l)??"",L&&(L=c.normalize(L)),r.folders.length>1&&!u.noPrefix){const z=P.name?P.name:n.basenameOrAuthority(P.uri);L=L?`${z} \u2022 ${L}`:z}return L}function R(l,u=A.isWindows){return(0,t.hasDriveLetter)(l,u)?l.charAt(0).toUpperCase()+l.slice(1):l}e.normalizeDriveLetter=R;let T=Object.create(null);function E(l,u,s=A.OS){if(s===1||!l||!u)return l;let c=T.original===u?T.normalized:void 0;c||(c=u,A.isWindows&&(c=(0,t.toSlashes)(c)),c=`${(0,k.rtrim)(c,I.posix.sep)}${I.posix.sep}`,T={original:u,normalized:c});let n=l;return A.isWindows&&(n=(0,t.toSlashes)(n)),(s===3?n.startsWith(c):(0,k.startsWithIgnoreCase)(n,c))?`~/${n.substr(c.length)}`:l}e.tildify=E;function y(l,u){return l.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=y;const v="\u2026",d="\\\\",b="~";function f(l,u=I.sep){const s=new Array(l.length);let c=!1;for(let n=0;n<l.length;n++){const r=l[n];if(r===""){s[n]=`.${u}`;continue}if(!r){s[n]=r;continue}c=!0;let g="",P=r;P.indexOf(d)===0?(g=P.substr(0,P.indexOf(d)+d.length),P=P.substr(P.indexOf(d)+d.length)):P.indexOf(u)===0?(g=P.substr(0,P.indexOf(u)+u.length),P=P.substr(P.indexOf(u)+u.length)):P.indexOf(b)===0&&(g=P.substr(0,P.indexOf(b)+b.length),P=P.substr(P.indexOf(b)+b.length));const L=P.split(u);for(let z=1;c&&z<=L.length;z++)for(let _=L.length-z;c&&_>=0;_--){c=!1;let K=L.slice(_,_+z).join(u);for(let F=0;!c&&F<l.length;F++)if(F!==n&&l[F]&&l[F].indexOf(K)>-1){const M=_+z===L.length,N=_>0&&l[F].indexOf(u)>-1?u+K:K,B=l[F].endsWith(N);c=!M||B}if(!c){let F="";(L[0].endsWith(":")||g!=="")&&(_===1&&(_=0,z++,K=L[0]+u+K),_>0&&(F=L[0]+u),F=g+F),_>0&&(F=F+v+u),F=F+K,_+z<L.length&&(F=F+u+v),s[n]=F}}c&&(s[n]=r)}return s}e.shorten=f;var w;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(w||(w={}));function h(l,u=Object.create(null)){const s=[];let c=!1,n="";for(const r of l)if(r==="$"||c&&r==="{")n&&s.push({value:n,type:w.TEXT}),n="",c=!0;else if(r==="}"&&c){const g=u[n];if(typeof g=="string")g.length&&s.push({value:g,type:w.VARIABLE});else if(g){const P=s[s.length-1];(!P||P.type!==w.SEPARATOR)&&s.push({value:g.label,type:w.SEPARATOR})}n="",c=!1}else n+=r;return n&&!c&&s.push({value:n,type:w.TEXT}),s.filter((r,g)=>{if(r.type===w.SEPARATOR){const P=s[g-1],L=s[g+1];return[P,L].every(z=>z&&(z.type===w.VARIABLE||z.type===w.TEXT)&&z.value.length>0)}return!0}).map(r=>r.value).join("")}e.template=h;function m(l,u){return A.isMacintosh||u?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):l.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=m;function p(l,u){return A.isMacintosh||u?l.replace(/\(&&\w\)|&&/g,""):A.isWindows?l.replace(/&&|&/g,s=>s==="&"?"&&":"&"):l.replace(/&&/g,"_")}e.mnemonicButtonLabel=p;function o(l){return l.replace(/&/g,"&&")}e.unmnemonicLabel=o;function i(l){const u=l.indexOf("/")!==-1?I.posix:I.win32,s=u.basename(l),c=u.dirname(l);return s.length?{name:s,parentPath:c}:{name:c,parentPath:""}}e.splitName=i}),define(Se[112],ye([1,0,2]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(R){return R.toJSON()}class I{constructor(T){this.a=T}transformIncoming(T){const E=this.a.transformIncoming(T);return E===T?T:t(a.URI.from(E))}transformOutgoing(T){const E=this.a.transformOutgoing(T);return E===T?T:t(a.URI.from(E))}transformOutgoingURI(T){const E=this.a.transformOutgoing(T);return E===T?T:a.URI.from(E)}transformOutgoingScheme(T){return this.a.transformOutgoingScheme(T)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function A(R,T,E){if(!R||E>200)return null;if(typeof R=="object"){if(R instanceof a.URI)return T.transformOutgoing(R);for(const y in R)if(Object.hasOwnProperty.call(R,y)){const v=A(R[y],T,E+1);v!==null&&(R[y]=v)}}return null}function D(R,T){const E=A(R,T,0);return E===null?R:E}e.transformOutgoingURIs=D;function k(R,T,E,y){if(!R||y>200)return null;if(typeof R=="object"){if(R.$mid===1)return E?a.URI.revive(T.transformIncoming(R)):T.transformIncoming(R);for(const v in R)if(Object.hasOwnProperty.call(R,v)){const d=k(R[v],T,E,y+1);d!==null&&(R[v]=d)}}return null}function S(R,T){const E=k(R,T,!1,0);return E===null?R:E}e.transformIncomingURIs=S;function C(R,T){const E=k(R,T,!0,0);return E===null?R:E}e.transformAndReviveIncomingURIs=C}),define(Se[29],ye([1,0,65,86,309,18,32,82,9,12,24,2]),function(ne,e,a,t,I,A,D,k,S,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function y(N,B=E.UNLINK){if((0,D.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return B===E.UNLINK?d(N):v(N)}async function v(N){try{const B=(0,D.randomPath)((0,t.tmpdir)());try{await a.promises.rename(N,B)}catch(U){return U.code==="ENOENT"?void 0:d(N)}d(B).catch(U=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function d(N){return(0,I.promisify)(a.rm)(N,{recursive:!0,force:!0,maxRetries:3})}function b(N){if((0,D.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");a.rmSync(N,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=b;async function f(N,B){return m(await(B?w(N):(0,I.promisify)(a.readdir)(N)))}async function w(N){try{return await(0,I.promisify)(a.readdir)(N,{withFileTypes:!0})}catch(W){console.warn("[node.js fs] readdir with filetypes failed with error: ",W)}const B=[],U=await f(N);for(const W of U){let x=!1,V=!1,X=!1;try{const Q=await e.Promises.lstat((0,S.join)(N,W));x=Q.isFile(),V=Q.isDirectory(),X=Q.isSymbolicLink()}catch(Q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Q)}B.push({name:W,isFile:()=>x,isDirectory:()=>V,isSymbolicLink:()=>X})}return B}function h(N){return m(a.readdirSync(N))}e.readdirSync=h;function m(N){return N.map(B=>typeof B=="string"?C.isMacintosh?(0,k.normalizeNFC)(B):B:(B.name=C.isMacintosh?(0,k.normalizeNFC)(B.name):B.name,B))}async function p(N){const B=await f(N),U=[];for(const W of B)await i.existsDirectory((0,S.join)(N,W))&&U.push(W);return U}function o(N,B=1e3){return new Promise(U=>{let W=!1;const x=setInterval(()=>{W||(W=!0,a.access(N,V=>{W=!1,V&&(clearInterval(x),U(void 0))}))},B)})}e.whenDeleted=o;var i;(function(N){async function B(x){let V;try{if(V=await e.Promises.lstat(x),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(C.isWindows&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(Q){if(Q.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw Q}throw X}}N.stat=B;async function U(x){try{const{stat:V,symbolicLink:X}=await N.stat(x);return V.isFile()&&X?.dangling!==!0}catch{}return!1}N.existsFile=U;async function W(x){try{const{stat:V,symbolicLink:X}=await N.stat(x);return V.isDirectory()&&X?.dangling!==!0}catch{}return!1}N.existsDirectory=W})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const l=new A.ResourceQueue;function u(N,B,U){return l.queueFor(T.URI.file(N),R.extUriBiasedIgnorePathCase).queue(()=>{const W=g(U);return new Promise((x,V)=>n(N,B,W,X=>X?V(X):x()))})}let s=!0;function c(N){s=N}e.configureFlushOnWrite=c;function n(N,B,U,W){if(!s)return a.writeFile(N,B,{mode:U.mode,flag:U.flag},W);a.open(N,U.flag,U.mode,(x,V)=>{if(x)return W(x);a.writeFile(V,B,X=>{if(X)return a.close(V,()=>W(X));a.fdatasync(V,Q=>(Q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Q),c(!1)),a.close(V,J=>W(J))))})})}function r(N,B,U){const W=g(U);if(!s)return a.writeFileSync(N,B,{mode:W.mode,flag:W.flag});const x=a.openSync(N,W.flag,W.mode);try{a.writeFileSync(x,B);try{a.fdatasyncSync(x)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),c(!1)}}finally{a.closeSync(x)}}e.writeFileSync=r;function g(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function P(N,B){if(N!==B)try{await e.Promises.rename(N,B)}catch(U){if(N.toLowerCase()!==B.toLowerCase()&&U.code==="EXDEV"||N.endsWith("."))await L(N,B,{preserveSymlinks:!1}),await y(N,E.MOVE);else throw U}}async function L(N,B,U){return _(N,B,{root:{source:N,target:B},options:U,handledSourcePaths:new Set})}const z=511;async function _(N,B,U){if(U.handledSourcePaths.has(N))return;U.handledSourcePaths.add(N);const{stat:W,symbolicLink:x}=await i.stat(N);if(x){if(U.options.preserveSymlinks)try{return await M(N,B,U)}catch(V){console.warn("[node.js fs] copy of symlink failed: ",V)}if(x.dangling)return}return W.isDirectory()?K(N,B,W.mode&z,U):F(N,B,W.mode&z)}async function K(N,B,U,W){await e.Promises.mkdir(B,{recursive:!0,mode:U});const x=await f(N);for(const V of x)await _((0,S.join)(N,V),(0,S.join)(B,V),W)}async function F(N,B,U){await e.Promises.copyFile(N,B),await e.Promises.chmod(B,U)}async function M(N,B,U){let W=await e.Promises.readlink(N);(0,D.isEqualOrParent)(W,U.root.source,!C.isLinux)&&(W=(0,S.join)(U.root.target,W.substr(U.root.source.length+1))),await e.Promises.symlink(W,B)}e.Promises=new class{get access(){return(0,I.promisify)(a.access)}get stat(){return(0,I.promisify)(a.stat)}get lstat(){return(0,I.promisify)(a.lstat)}get utimes(){return(0,I.promisify)(a.utimes)}get read(){return(N,B,U,W,x)=>new Promise((V,X)=>{a.read(N,B,U,W,x,(Q,J,te)=>Q?X(Q):V({bytesRead:J,buffer:te}))})}get readFile(){return(0,I.promisify)(a.readFile)}get write(){return(N,B,U,W,x)=>new Promise((V,X)=>{a.write(N,B,U,W,x,(Q,J,te)=>Q?X(Q):V({bytesWritten:J,buffer:te}))})}get appendFile(){return(0,I.promisify)(a.appendFile)}get fdatasync(){return(0,I.promisify)(a.fdatasync)}get truncate(){return(0,I.promisify)(a.truncate)}get rename(){return(0,I.promisify)(a.rename)}get copyFile(){return(0,I.promisify)(a.copyFile)}get open(){return(0,I.promisify)(a.open)}get close(){return(0,I.promisify)(a.close)}get symlink(){return(0,I.promisify)(a.symlink)}get readlink(){return(0,I.promisify)(a.readlink)}get chmod(){return(0,I.promisify)(a.chmod)}get mkdir(){return(0,I.promisify)(a.mkdir)}get unlink(){return(0,I.promisify)(a.unlink)}get rmdir(){return(0,I.promisify)(a.rmdir)}get realpath(){return(0,I.promisify)(a.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return p}get writeFile(){return u}get rm(){return y}get move(){return P}get copy(){return L}}}),define(Se[113],ye([1,0,65,9,12,8,29]),function(ne,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(E){if(I.isLinux)return E;const y=(0,t.dirname)(E);if(E===y)return E;const v=((0,t.basename)(E)||E).toLowerCase();try{const b=(0,D.readdirSync)(y).filter(f=>f.toLowerCase()===v);if(b.length===1){const f=k(y);if(f)return(0,t.join)(f,b[0])}else if(b.length>1){const f=b.indexOf(v);if(f>=0){const w=k(y);if(w)return(0,t.join)(w,b[f])}}}catch{}return null}e.realcaseSync=k;async function S(E){if(I.isLinux)return E;const y=(0,t.dirname)(E);if(E===y)return E;const v=((0,t.basename)(E)||E).toLowerCase();try{const b=(await D.Promises.readdir(y)).filter(f=>f.toLowerCase()===v);if(b.length===1){const f=await S(y);if(f)return(0,t.join)(f,b[0])}else if(b.length>1){const f=b.indexOf(v);if(f>=0){const w=await S(y);if(w)return(0,t.join)(w,b[f])}}}catch{}return null}e.realcase=S;async function C(E){try{return await D.Promises.realpath(E)}catch{const v=T(E);return await D.Promises.access(v,a.constants.R_OK),v}}e.realpath=C;function R(E){try{return a.realpathSync(E)}catch{const v=T(E);return a.accessSync(v,a.constants.R_OK),v}}e.realpathSync=R;function T(E){return(0,A.rtrim)((0,t.normalize)(E),t.sep)}}),define(Se[114],ye([1,0,9,12,36,106,11,29]),function(ne,e,a,t,I,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function S(T=I.env){return T.comspec||"cmd.exe"}e.getWindowsShell=S;function C(T){let E=[],y=!1;const v=function(d){if(y){E.push(d);return}(!T.send(d,f=>{if(f&&console.error(f),y=!1,E.length>0){const w=E.slice(0);E=[],w.forEach(h=>v(h))}})||t.isWindows)&&(y=!0)};return{send:v}}e.createQueuedSender=C;var R;(function(T){async function E(y,v,d){if(a.isAbsolute(y))return y;if(v===void 0&&(v=I.cwd()),a.dirname(y)!=="."||(d===void 0&&D.isString(I.env.PATH)&&(d=I.env.PATH.split(a.delimiter)),d===void 0||d.length===0))return a.join(v,y);async function f(w){if(await k.Promises.exists(w)){let h;try{h=await k.Promises.stat(w)}catch(m){m.message.startsWith("EACCES")&&(h=await k.Promises.lstat(w))}return h?!h.isDirectory():!1}return!1}for(const w of d){let h;if(a.isAbsolute(w)?h=a.join(w,y):h=a.join(v,w,y),await f(h))return h;let m=h+".com";if(await f(m)||(m=h+".exe",await f(m)))return m}return a.join(v,y)}T.findExecutable=E})(R=e.win32||(e.win32={}))});var qe=this&&this.__decorate||function(ne,e,a,t){var I=arguments.length,A=I<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,a):t,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ne,e,a,t);else for(var k=ne.length-1;k>=0;k--)(D=ne[k])&&(A=(I<3?D(A):I>3?D(e,a,A):D(e,a))||A);return I>3&&A&&Object.defineProperty(e,a,A),A};define(Se[115],ye([1,0,17,18,22,21,60,10,4,6,85,8,11]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var y;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(y||(y={}));function v(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(d||(d={}));function b(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(f||(f={}));function w(V){let X=0;for(let Q=0;;Q+=7){const J=V.read(1);if(X|=(J.buffer[0]&127)<<Q,!(J.buffer[0]&128))return X}}const h=l(0);function m(V,X){if(X===0){V.write(h);return}let Q=0;for(let te=X;te!==0;te=te>>>7)Q++;const J=I.VSBuffer.alloc(Q);for(let te=0;X!==0;te++)J.buffer[te]=X&127,X=X>>>7,X>0&&(J.buffer[te]|=128);V.write(J)}class p{constructor(X){this.b=X,this.a=0}read(X){const Q=this.b.slice(this.a,this.a+X);return this.a+=Q.byteLength,Q}}e.BufferReader=p;class o{constructor(){this.a=[]}get buffer(){return I.VSBuffer.concat(this.a)}write(X){this.a.push(X)}}e.BufferWriter=o;var i;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(i||(i={}));function l(V){const X=I.VSBuffer.alloc(1);return X.writeUInt8(V,0),X}const u={Undefined:l(i.Undefined),String:l(i.String),Buffer:l(i.Buffer),VSBuffer:l(i.VSBuffer),Array:l(i.Array),Object:l(i.Object),Uint:l(i.Int)},s=typeof Buffer<"u";function c(V,X){if(typeof X>"u")V.write(u.Undefined);else if(typeof X=="string"){const Q=I.VSBuffer.fromString(X);V.write(u.String),m(V,Q.byteLength),V.write(Q)}else if(s&&Buffer.isBuffer(X)){const Q=I.VSBuffer.wrap(X);V.write(u.Buffer),m(V,Q.byteLength),V.write(Q)}else if(X instanceof I.VSBuffer)V.write(u.VSBuffer),m(V,X.byteLength),V.write(X);else if(Array.isArray(X)){V.write(u.Array),m(V,X.length);for(const Q of X)c(V,Q)}else if(typeof X=="number"&&(X|0)===X)V.write(u.Uint),m(V,X);else{const Q=I.VSBuffer.fromString(JSON.stringify(X));V.write(u.Object),m(V,Q.byteLength),V.write(Q)}}e.serialize=c;function n(V){switch(V.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return V.read(w(V)).toString();case i.Buffer:return V.read(w(V)).buffer;case i.VSBuffer:return V.read(w(V));case i.Array:{const Q=w(V),J=[];for(let te=0;te<Q;te++)J.push(n(V));return J}case i.Object:return JSON.parse(V.read(w(V)).toString());case i.Int:return w(V)}}e.deserialize=n;class r{constructor(X,Q,J=null,te=1e3){this.h=X,this.j=Q,this.k=J,this.l=te,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(le=>this.q(le)),this.m({type:200})}registerChannel(X,Q){this.b.set(X,Q),setTimeout(()=>this.w(X),0)}m(X){switch(X.type){case 200:{const Q=this.o([X.type]);this.k?.logOutgoing(Q,0,1,b(X.type));return}case 201:case 202:case 204:case 203:{const Q=this.o([X.type,X.id],X.data);this.k?.logOutgoing(Q,X.id,1,b(X.type),X.data);return}}}o(X,Q=void 0){const J=new o;return c(J,X),c(J,Q),this.p(J.buffer)}p(X){try{return this.h.send(X),X.byteLength}catch{return 0}}q(X){const Q=new p(X),J=n(Q),te=n(Q),le=J[0];switch(le){case 100:return this.k?.logIncoming(X.byteLength,J[1],1,`${v(le)}: ${J[2]}.${J[3]}`,te),this.s({type:le,id:J[1],channelName:J[2],name:J[3],arg:te});case 102:return this.k?.logIncoming(X.byteLength,J[1],1,`${v(le)}: ${J[2]}.${J[3]}`,te),this.t({type:le,id:J[1],channelName:J[2],name:J[3],arg:te});case 101:return this.k?.logIncoming(X.byteLength,J[1],1,`${v(le)}`),this.u({type:le,id:J[1]});case 103:return this.k?.logIncoming(X.byteLength,J[1],1,`${v(le)}`),this.u({type:le,id:J[1]})}}s(X){const Q=this.b.get(X.channelName);if(!Q){this.v(X);return}const J=new A.CancellationTokenSource;let te;try{te=Q.call(this.j,X.name,X.arg,J.token)}catch(ge){te=Promise.reject(ge)}const le=X.id;te.then(ge=>{this.m({id:le,data:ge,type:201}),this.d.delete(X.id)},ge=>{ge instanceof Error?this.m({id:le,data:{message:ge.message,name:ge.name,stack:ge.stack?ge.stack.split?ge.stack.split(`
`):ge.stack:void 0},type:202}):this.m({id:le,data:ge,type:203}),this.d.delete(X.id)});const Z=(0,C.toDisposable)(()=>J.cancel());this.d.set(X.id,Z)}t(X){const Q=this.b.get(X.channelName);if(!Q){this.v(X);return}const J=X.id,le=Q.listen(this.j,X.name,X.arg)(Z=>this.m({id:J,data:Z,type:204}));this.d.set(X.id,le)}u(X){const Q=this.d.get(X.id);Q&&(Q.dispose(),this.d.delete(X.id))}v(X){let Q=this.g.get(X.channelName);Q||(Q=[],this.g.set(X.channelName,Q));const J=setTimeout(()=>{console.error(`Unknown channel: ${X.channelName}`),X.type===100&&this.m({id:X.id,data:{name:"Unknown channel",message:`Channel name '${X.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Q.push({request:X,timeoutTimer:J})}w(X){const Q=this.g.get(X);if(Q){for(const J of Q)switch(clearTimeout(J.timeoutTimer),J.request.type){case 100:this.s(J.request);break;case 102:this.t(J.request);break}this.g.delete(X)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,C.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=r;var g;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class P{constructor(X,Q=null){this.l=X,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(J=>this.s(J)),this.j=Q}getChannel(X){const Q=this;return{call(J,te,le){return Q.a?Promise.reject(new k.CancellationError):Q.m(X,J,te,le)},listen(J,te){return Q.a?S.Event.None:Q.o(X,J,te)}}}m(X,Q,J,te=A.CancellationToken.None){const le=this.g++,ge={id:le,type:100,channelName:X,name:Q,arg:J};if(te.isCancellationRequested)return Promise.reject(new k.CancellationError);let ve;return new Promise((Re,ze)=>{if(te.isCancellationRequested)return ze(new k.CancellationError);const se=()=>{const oe=ie=>{switch(ie.type){case 201:this.f.delete(le),Re(ie.data);break;case 202:{this.f.delete(le);const O=new Error(ie.data.message);O.stack=Array.isArray(ie.data.stack)?ie.data.stack.join(`
`):ie.data.stack,O.name=ie.data.name,ze(O);break}case 203:this.f.delete(le),ze(ie.data);break}};this.f.set(le,oe),this.p(ge)};let ue=null;this.b===f.Idle?se():(ue=(0,t.createCancelablePromise)(oe=>this.u()),ue.then(()=>{ue=null,se()}));const he=()=>{ue?(ue.cancel(),ue=null):this.p({id:le,type:101}),ze(new k.CancellationError)},ee=te.onCancellationRequested(he);ve=(0,C.combinedDisposable)((0,C.toDisposable)(he),ee),this.d.add(ve)}).finally(()=>{this.d.delete(ve)})}o(X,Q,J){const te=this.g++,Z={id:te,type:102,channelName:X,name:Q,arg:J};let ge=null;const ve=new S.Emitter({onWillAddFirstListener:()=>{ge=(0,t.createCancelablePromise)(Re=>this.u()),ge.then(()=>{ge=null,this.d.add(ve),this.p(Z)})},onDidRemoveLastListener:()=>{ge?(ge.cancel(),ge=null):(this.d.delete(ve),this.p({id:te,type:103}))}}),De=Re=>ve.fire(Re.data);return this.f.set(te,De),ve.event}p(X){switch(X.type){case 100:case 102:{const Q=this.q([X.type,X.id,X.channelName,X.name],X.arg);this.j?.logOutgoing(Q,X.id,0,`${v(X.type)}: ${X.channelName}.${X.name}`,X.arg);return}case 101:case 103:{const Q=this.q([X.type,X.id]);this.j?.logOutgoing(Q,X.id,0,v(X.type));return}}}q(X,Q=void 0){const J=new o;return c(J,X),c(J,Q),this.r(J.buffer)}r(X){try{return this.l.send(X),X.byteLength}catch{return 0}}s(X){const Q=new p(X),J=n(Q),te=n(Q),le=J[0];switch(le){case 200:return this.j?.logIncoming(X.byteLength,0,0,b(le)),this.t({type:J[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(X.byteLength,J[1],0,b(le),te),this.t({type:J[0],id:J[1],data:te})}}t(X){if(X.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(X.id)?.(X)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,C.dispose)(this.d.values()),this.d.clear()}}qe([D.memoize],P.prototype,"onDidInitializePromise",null),e.ChannelClient=P;class L{get connections(){const X=[];return this.f.forEach(Q=>X.push(Q)),X}constructor(X){this.a=new Map,this.f=new Set,this.g=new S.Emitter,this.onDidAddConnection=this.g.event,this.h=new S.Emitter,this.onDidRemoveConnection=this.h.event,X(({protocol:Q,onDidClientDisconnect:J})=>{S.Event.once(Q.onMessage)(le=>{const Z=new p(le),ge=n(Z),ve=new r(Q,ge),De=new P(Q);this.a.forEach((ze,se)=>ve.registerChannel(se,ze));const Re={channelServer:ve,channelClient:De,ctx:ge};this.f.add(Re),this.g.fire(Re),J(()=>{ve.dispose(),De.dispose(),this.f.delete(Re),this.h.fire(Re)})})})}getChannel(X,Q){const J=this;return{call(te,le,Z){let ge;if((0,E.isFunction)(Q)){const De=(0,a.getRandomElement)(J.connections.filter(Q));ge=De?Promise.resolve(De):S.Event.toPromise(S.Event.filter(J.onDidAddConnection,Q))}else ge=Q.routeCall(J,te,le);const ve=ge.then(De=>De.channelClient.getChannel(X));return _(ve).call(te,le,Z)},listen(te,le){if((0,E.isFunction)(Q))return J.j(X,Q,te,le);const Z=Q.routeEvent(J,te,le).then(ge=>ge.channelClient.getChannel(X));return _(Z).listen(te,le)}}}j(X,Q,J,te){const le=this;let Z=new C.DisposableStore;const ge=new S.Emitter({onWillAddFirstListener:()=>{Z=new C.DisposableStore;const ve=new S.EventMultiplexer,De=new Map,Re=se=>{const he=se.channelClient.getChannel(X).listen(J,te),ee=ve.add(he);De.set(se,ee)},ze=se=>{const ue=De.get(se);!ue||(ue.dispose(),De.delete(se))};le.connections.filter(Q).forEach(Re),S.Event.filter(le.onDidAddConnection,Q)(Re,void 0,Z),le.onDidRemoveConnection(ze,void 0,Z),ve.event(ge.fire,ge,Z),Z.add(ve)},onDidRemoveLastListener:()=>{Z.dispose()}});return ge.event}registerChannel(X,Q){this.a.set(X,Q),this.f.forEach(J=>{J.channelServer.registerChannel(X,Q)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=L;class z{constructor(X,Q,J=null){const te=new o;c(te,Q),X.send(te.buffer),this.a=new P(X,J),this.d=new r(X,Q,J)}getChannel(X){return this.a.getChannel(X)}registerChannel(X,Q){this.d.registerChannel(X,Q)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=z;function _(V){return{call(X,Q,J){return V.then(te=>te.call(X,Q,J))},listen(X,Q){const J=new S.Relay;return V.then(te=>J.input=te.listen(X,Q)),J.event}}}e.getDelayedChannel=_;function K(V){let X=!1;return{call(Q,J,te){return X?V.call(Q,J,te):(0,t.timeout)(0).then(()=>X=!0).then(()=>V.call(Q,J,te))},listen(Q,J){if(X)return V.listen(Q,J);const te=new S.Relay;return(0,t.timeout)(0).then(()=>X=!0).then(()=>te.input=V.listen(Q,J)),te.event}}}e.getNextTickChannel=K;class F{constructor(X){this.a=X}routeCall(X){return this.b(X)}routeEvent(X){return this.b(X)}async b(X){for(const Q of X.connections)if(await Promise.resolve(this.a(Q.ctx)))return Promise.resolve(Q);return await S.Event.toPromise(X.onDidAddConnection),await this.b(X)}}e.StaticRouter=F;var M;(function(V){function X(le,Z){const ge=le,ve=Z&&Z.disableMarshalling,De=new Map;for(const Re in ge)J(Re)&&De.set(Re,S.Event.buffer(ge[Re],!0));return new class{listen(Re,ze,se){const ue=De.get(ze);if(ue)return ue;if(te(ze)){const he=ge[ze];if(typeof he=="function")return he.call(ge,se)}throw new Error(`Event not found: ${ze}`)}call(Re,ze,se){const ue=ge[ze];if(typeof ue=="function"){if(!ve&&Array.isArray(se))for(let he=0;he<se.length;he++)se[he]=(0,R.revive)(se[he]);return ue.apply(ge,se)}throw new Error(`Method not found: ${ze}`)}}}V.fromService=X;function Q(le,Z){const ge=Z&&Z.disableMarshalling;return new Proxy({},{get(ve,De){if(typeof De=="string")return Z?.properties?.has(De)?Z.properties.get(De):te(De)?function(Re){return le.listen(De,Re)}:J(De)?le.listen(De):async function(...Re){let ze;Z&&!(0,E.isUndefinedOrNull)(Z.context)?ze=[Z.context,...Re]:ze=Re;const se=await le.call(De,ze);return ge?se:(0,R.revive)(se)};throw new Error(`Property not found: ${String(De)}`)}})}V.toService=Q;function J(le){return le[0]==="o"&&le[1]==="n"&&T.isUpperAsciiLetter(le.charCodeAt(2))}function te(le){return/^onDynamic/.test(le)&&T.isUpperAsciiLetter(le.charCodeAt(9))}})(M=e.ProxyChannel||(e.ProxyChannel={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const X=V.toString();if(X!=="[object Object]")return X}return V}function U(V){return Array.isArray(V)?V.map(B):B(V)}function W(V,X,Q,J,te,le,Z){Z=U(Z);const ge=N[te],ve=ge[J%ge.length];let De=[`%c[${V}]%c[${String(X).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${le}`,"color: darkgreen","color: grey","color: grey",`color: ${ve}`];/\($/.test(le)?(De=De.concat(Z),De.push(")")):De.push(Z),console.log.apply(console,De)}class x{constructor(X,Q){this.d=X,this.f=Q,this.a=0,this.b=0}logOutgoing(X,Q,J,te,le){this.b+=X,W(this.d,this.b,X,Q,J,te,le)}logIncoming(X,Q,J,te,le){this.a+=X,W(this.f,this.a,X,Q,J,te,le)}}e.IPCLogger=x}),define(Se[116],ye([1,0,22,4,6,115]),function(ne,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(u){u.Created="created",u.Read="read",u.Write="write",u.Open="open",u.Error="error",u.Close="close",u.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",u.NodeEndReceived="nodeEndReceived",u.NodeEndSent="nodeEndSent",u.NodeDrainBegin="nodeDrainBegin",u.NodeDrainEnd="nodeDrainEnd",u.zlibInflateError="zlibInflateError",u.zlibInflateData="zlibInflateData",u.zlibInflateInitialWrite="zlibInflateInitialWrite",u.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",u.zlibInflateWrite="zlibInflateWrite",u.zlibInflateFlushFired="zlibInflateFlushFired",u.zlibDeflateError="zlibDeflateError",u.zlibDeflateData="zlibDeflateData",u.zlibDeflateWrite="zlibDeflateWrite",u.zlibDeflateFlushFired="zlibDeflateFlushFired",u.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",u.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",u.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",u.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",u.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",u.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",u.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",u.ProtocolHeaderRead="protocolHeaderRead",u.ProtocolMessageRead="protocolMessageRead",u.ProtocolHeaderWrite="protocolHeaderWrite",u.ProtocolMessageWrite="protocolMessageWrite",u.ProtocolWrite="protocolWrite"})(D=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var k;(function(u){u.enableDiagnostics=!1,u.records=[];const s=new WeakMap;let c=0;function n(g,P){if(!s.has(g)){const L=String(++c);s.set(g,L)}return s.get(g)}function r(g,P,L,z){if(!u.enableDiagnostics)return;const _=n(g,P);if(z instanceof a.VSBuffer||z instanceof Uint8Array||z instanceof ArrayBuffer||ArrayBuffer.isView(z)){const K=a.VSBuffer.alloc(z.byteLength);K.set(z),u.records.push({timestamp:Date.now(),id:_,label:P,type:L,buff:K})}else u.records.push({timestamp:Date.now(),id:_,label:P,type:L,data:z})}u.traceSocketEvent=r})(k=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(u){u[u.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",u[u.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function R(){return C||(C=a.VSBuffer.alloc(0)),C}class T{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,c){if(s===0)return R();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const P=this.a[0];return c&&(this.a.shift(),this.b-=s),P}if(this.a[0].byteLength>s){const P=this.a[0].slice(0,s);return c&&(this.a[0]=this.a[0].slice(s),this.b-=s),P}const n=a.VSBuffer.alloc(s);let r=0,g=0;for(;s>0;){const P=this.a[g];if(P.byteLength>s){const L=P.slice(0,s);n.set(L,r),r+=s,c&&(this.a[g]=P.slice(s),this.b-=s),s-=s}else n.set(P,r),r+=P.byteLength,c?(this.a.shift(),this.b-=P.byteLength):g++,s-=P.byteLength}return n}}e.ChunkStream=T;var E;(function(u){u[u.None=0]="None",u[u.Regular=1]="Regular",u[u.Control=2]="Control",u[u.Ack=3]="Ack",u[u.Disconnect=5]="Disconnect",u[u.ReplayRequest=6]="ReplayRequest",u[u.Pause=7]="Pause",u[u.Resume=8]="Resume",u[u.KeepAlive=9]="KeepAlive"})(E||(E={}));function y(u){switch(u){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(u){u[u.HeaderLength=13]="HeaderLength",u[u.AcknowledgeTime=2e3]="AcknowledgeTime",u[u.TimeoutTime=2e4]="TimeoutTime",u[u.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",u[u.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(s,c,n,r){this.type=s,this.id=c,this.ack=n,this.data=r,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends I.Disposable{constructor(s){super(),this.f=this.B(new t.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=s,this.b=!1,this.c=new T,this.B(this.a.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const c=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=c.readUInt32BE(9),this.g.messageType=c.readUInt8(0),this.g.id=c.readUInt32BE(1),this.g.ack=c.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const n=this.g.messageType,r=this.g.id,g=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",c),this.f.fire(new d(n,r,g,c)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=a.VSBuffer.alloc(13);c.writeUInt8(s.type,0),c.writeUInt32BE(s.id,1),c.writeUInt32BE(s.ack,5),c.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",s.data),this.j(c,s.data)}g(s,c){const n=this.f===0;return this.d.push(s,c),this.f+=s.byteLength+c.byteLength,n}h(){const s=a.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,c){this.g(s,c)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this.c.write(s)}}class w extends I.Disposable{constructor(s){super(),this.f=new t.Emitter,this.onMessage=this.f.event,this.g=new t.Emitter,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new f(this.a)),this.c=this.B(new b(this.a)),this.B(this.c.onMessage(c=>{c.type===1&&this.f.fire(c.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new d(1,0,0,s))}}e.Protocol=w;class h extends A.IPCClient{static fromSocket(s,c){return new h(new w(s),c)}get onDidDispose(){return this.b.onDidDispose}constructor(s,c,n=null){super(s,c,n),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.Client=h;class m{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new t.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.BufferedEmitter=m;class p{constructor(s){this.data=s,this.next=null}}class o{constructor(){this.a=null,this.b=null}length(){let s=0,c=this.a;for(;c;)c=c.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let c=0,n=this.a;for(;n;)s[c++]=n.data,n=n.next;return s}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const c=new p(s);if(!this.a){this.a=c,this.b=c;return}this.b.next=c,this.b=c}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const s=Date.now();for(let c=0;c<i.a;c++)this.c[c]=s-1e3*c;setInterval(()=>{for(let c=i.a;c>=1;c--)this.c[c]=this.c[c-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),c=(1+i.a)*1e3;let n=0;for(let r=0;r<i.a;r++)s-this.c[r]<=c&&n++;return 1-n/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;class l{get unacknowledgedCount(){return this.c-this.d}constructor(s,c=null,n=i.getInstance()){this.t=new m,this.onControlMessage=this.t.event,this.u=new m,this.onMessage=this.u.event,this.v=new m,this.onDidDispose=this.v.event,this.w=new m,this.onSocketClose=this.w.event,this.x=new m,this.onSocketTimeout=this.x.event,this.s=n,this.a=!1,this.b=new o,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=[],this.o=s,this.p=new f(this.o),this.r.push(this.p),this.q=new b(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(r=>this.y(r))),this.r.push(this.o.onClose(r=>this.w.fire(r))),c&&this.q.acceptChunk(c),this.l=setInterval(()=>{this.C()},5e3)}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r=(0,I.dispose)(this.r)}drain(){return this.p.drain()}sendDisconnect(){const s=new d(5,0,0,R());this.p.write(s),this.p.flush()}sendPause(){const s=new d(7,0,0,R());this.p.write(s)}sendResume(){const s=new d(8,0,0,R());this.p.write(s)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(s,c){this.a=!0,this.r=(0,I.dispose)(this.r),this.t.flushBuffer(),this.w.flushBuffer(),this.x.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=s,this.p=new f(this.o),this.r.push(this.p),this.q=new b(this.o),this.r.push(this.q),this.r.push(this.q.onMessage(n=>this.y(n))),this.r.push(this.o.onClose(n=>this.w.fire(n))),this.q.acceptChunk(c)}endAcceptReconnection(){this.a=!1,this.h=this.g;const s=new d(3,0,this.h,R());this.p.write(s);const c=this.b.toArray();for(let n=0,r=c.length;n<r;n++)this.p.write(c[n]);this.A()}acceptDisconnect(){this.v.fire()}y(s){if(s.ack>this.d){this.d=s.ack;do{const c=this.b.peek();if(c&&c.id<=s.ack)this.b.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this.g)if(s.id!==this.g+1){const c=Date.now();c-this.m>1e4&&(this.m=c,this.p.write(new d(6,0,0,R())))}else this.g=s.id,this.j=Date.now(),this.z(),this.u.fire(s.data);break}case 2:{this.t.fire(s.data);break}case 3:break;case 5:{this.v.fire();break}case 6:{const c=this.b.toArray();for(let n=0,r=c.length;n<r;n++)this.p.write(c[n]);this.A();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(s){const c=++this.c;this.h=this.g;const n=new d(1,c,this.h,s);this.b.push(n),this.a||(this.p.write(n),this.A())}sendControl(s){const c=new d(2,0,0,s);this.p.write(c)}z(){if(this.g<=this.h||this.k)return;const s=Date.now()-this.j;if(s>=2e3){this.B();return}this.k=setTimeout(()=>{this.k=null,this.z()},2e3-s+5)}A(){if(this.c<=this.d||this.f||this.a)return;const s=this.b.peek(),c=Date.now()-s.writtenTime,n=Date.now()-this.q.lastReadTime,r=Date.now()-this.n;if(c>=2e4&&n>=2e4&&r>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.x.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:n});return}const g=Math.max(2e4-c,2e4-n,2e4-r,500);this.f=setTimeout(()=>{this.f=null,this.A()},g)}B(){if(this.g<=this.h)return;this.h=this.g;const s=new d(3,0,this.h,R());this.p.write(s)}C(){const s=new d(9,0,0,R());this.p.write(s)}}e.PersistentProtocol=l}),define(Se[117],ye([1,0,22,10,4,6,9,12,30,115,116]),function(ne,e,a,t,I,A,D,k,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function T(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class E{traceSocketEvent(n,r){R.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,n,r)}constructor(n,r=""){this.f=!0,this.debugLabel=r,this.socket=n,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=g=>{if(this.traceSocketEvent("error",{code:g?.code,message:g?.message}),g){if(g.code==="EPIPE")return;(0,t.onUnexpectedError)(g)}},this.socket.on("error",this.a),this.b=g=>{this.traceSocketEvent("close",{hadError:g}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(n){const r=g=>{this.traceSocketEvent("read",g),n(a.VSBuffer.wrap(g))};return this.socket.on("data",r),{dispose:()=>this.socket.off("data",r)}}onClose(n){const r=g=>{n({type:0,hadError:g,error:void 0})};return this.socket.on("close",r),{dispose:()=>this.socket.off("close",r)}}onEnd(n){const r=()=>{n()};return this.socket.on("end",r),{dispose:()=>this.socket.off("end",r)}}write(n){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",n),this.socket.write(n.buffer,r=>{if(r){if(r.code==="EPIPE")return;(0,t.onUnexpectedError)(r)}})}catch(r){if(r.code==="EPIPE")return;(0,t.onUnexpectedError)(r)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((n,r)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),n();return}const g=()=>{this.socket.off("close",g),this.socket.off("end",g),this.socket.off("error",g),this.socket.off("timeout",g),this.socket.off("drain",g),this.traceSocketEvent("nodeDrainEnd"),n()};this.socket.on("close",g),this.socket.on("end",g),this.socket.on("error",g),this.socket.on("timeout",g),this.socket.on("drain",g)})}}e.NodeSocket=E;var y;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var v;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(v||(v={}));class d extends A.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(n,r){this.socket.traceSocketEvent(n,r)}constructor(n,r,g,P){super(),this.f=this.B(new I.Emitter),this.g=this.B(new I.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=n,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:r,inflateBytesLength:g?.byteLength||0,recordInflateBytes:P}),this.a=this.B(new b(this,r,g,P,this.f,(L,z)=>this.k(L,z))),this.B(this.a.onError(L=>{console.error(L),(0,t.onUnexpectedError)(L),this.g.fire({type:0,hadError:!0,error:L})})),this.b=new R.ChunkStream,this.B(this.socket.onData(L=>this.l(L))),this.B(this.socket.onClose(L=>this.g.fire(L)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(n){return this.f.event(n)}onClose(n){return this.g.event(n)}onEnd(n){return this.socket.onEnd(n)}write(n){this.a.writeMessage(n)}k(n,r){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",n);let g=2;n.byteLength<126?g+=0:n.byteLength<2**16?g+=2:g+=8;const P=a.VSBuffer.alloc(g);if(r?P.writeUInt8(194,0):P.writeUInt8(130,0),n.byteLength<126)P.writeUInt8(n.byteLength,1);else if(n.byteLength<2**16){P.writeUInt8(126,1);let L=1;P.writeUInt8(n.byteLength>>>8&255,++L),P.writeUInt8(n.byteLength>>>0&255,++L)}else{P.writeUInt8(127,1);let L=1;P.writeUInt8(0,++L),P.writeUInt8(0,++L),P.writeUInt8(0,++L),P.writeUInt8(0,++L),P.writeUInt8(n.byteLength>>>24&255,++L),P.writeUInt8(n.byteLength>>>16&255,++L),P.writeUInt8(n.byteLength>>>8&255,++L),P.writeUInt8(n.byteLength>>>0&255,++L)}this.socket.write(a.VSBuffer.concat([P,n]))}end(){this.h=!0,this.socket.end()}l(n){if(n.byteLength!==0){for(this.b.acceptChunk(n);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const r=this.b.peek(this.j.readLen),g=r.readUInt8(0),P=(g&128)>>>7,L=(g&64)>>>6,z=r.readUInt8(1),_=(z&128)>>>7,K=z&127;this.j.state=2,this.j.readLen=2+(_?4:0)+(K===126?2:0)+(K===127?8:0),this.j.fin=P,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(L)),this.j.firstFrameOfMessage=Boolean(P),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const r=this.b.read(this.j.readLen),g=r.readUInt8(1),P=(g&128)>>>7;let L=g&127,z=1;L===126?L=r.readUInt8(++z)*2**8+r.readUInt8(++z):L===127&&(L=r.readUInt8(++z)*0+r.readUInt8(++z)*0+r.readUInt8(++z)*0+r.readUInt8(++z)*0+r.readUInt8(++z)*2**24+r.readUInt8(++z)*2**16+r.readUInt8(++z)*2**8+r.readUInt8(++z));let _=0;P&&(_=r.readUInt8(++z)*2**24+r.readUInt8(++z)*2**16+r.readUInt8(++z)*2**8+r.readUInt8(++z)),this.j.state=3,this.j.readLen=L,this.j.mask=_,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const r=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",r),h(r,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",r),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(r,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await I.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=d;class b extends A.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:a.VSBuffer.alloc(0)}constructor(n,r,g,P,L,z){super(),this.k=n,this.l=L,this.m=z,this.a=this.B(new I.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new I.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,r?(this.b=this.B(new f(this.k,P,g,{windowBits:15})),this.f=this.B(new w(this.k,{windowBits:15})),this.B(this.b.onError(_=>this.a.fire(_))),this.B(this.f.onError(_=>this.a.fire(_)))):(this.b=null,this.f=null)}writeMessage(n){this.g.push(n),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const n=this.g.shift();if(this.f){const r=await this.r(this.f,n);this.m(r,!0)}else this.m(n,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(n,r){return new Promise((g,P)=>{n.write(r),n.flush(L=>g(L))})}acceptFrame(n,r,g){this.h.push({data:n,isCompressed:r,isLastFrameOfMessage:g}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const n=this.h.shift();if(this.b&&n.isCompressed){const r=await this.u(this.b,n.data,n.isLastFrameOfMessage);this.l.fire(r)}else this.l.fire(n.data)}this.s=!1}}u(n,r,g){return new Promise((P,L)=>{n.write(r),g&&n.write(a.VSBuffer.fromByteArray([0,0,255,255])),n.flush(z=>P(z))})}}class f extends A.Disposable{get recordedInflateBytes(){return this.j?a.VSBuffer.concat(this.f):a.VSBuffer.alloc(0)}constructor(n,r,g,P){super(),this.h=n,this.j=r,this.a=this.B(new I.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=T().zlib.createInflateRaw(P),this.b.on("error",L=>{this.h.traceSocketEvent("zlibInflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.h.traceSocketEvent("zlibInflateData",L),this.g.push(a.VSBuffer.wrap(L))}),g&&(this.h.traceSocketEvent("zlibInflateInitialWrite",g.buffer),this.b.write(g.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(n){this.j&&this.f.push(n.clone()),this.h.traceSocketEvent("zlibInflateWrite",n),this.b.write(n.buffer)}flush(n){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const r=a.VSBuffer.concat(this.g);this.g.length=0,n(r)})}}class w extends A.Disposable{constructor(n,r){super(),this.g=n,this.a=this.B(new I.Emitter),this.onError=this.a.event,this.f=[],this.b=T().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",g=>{this.g.traceSocketEvent("zlibDeflateError",{message:g?.message,code:g?.code}),this.a.fire(g)}),this.b.on("data",g=>{this.g.traceSocketEvent("zlibDeflateData",g),this.f.push(a.VSBuffer.wrap(g))})}write(n){this.g.traceSocketEvent("zlibDeflateWrite",n.buffer),this.b.write(n.buffer)}flush(n){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let r=a.VSBuffer.concat(this.f);this.f.length=0,r=r.slice(0,r.byteLength-4),n(r)})}}function h(c,n){if(n===0)return;const r=c.byteLength>>>2;for(let K=0;K<r;K++){const F=c.readUInt32BE(K*4);c.writeUInt32BE(F^n,K*4)}const g=r*4,P=c.byteLength-g,L=n>>>24&255,z=n>>>16&255,_=n>>>8&255;P>=1&&c.writeUInt8(c.readUInt8(g)^L,g),P>=2&&c.writeUInt8(c.readUInt8(g+1)^z,g+1),P>=3&&c.writeUInt8(c.readUInt8(g+2)^_,g+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const m={[2]:107,[1]:103};function p(){const c=(0,S.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let n;return e.XDG_RUNTIME_DIR?n=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):n=(0,D.join)(T().os.tmpdir(),`vscode-ipc-${c}.sock`),i(n),n}e.createRandomIPCHandle=p;function o(c,n,r){const g=T().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${g}-${r}-${n}-sock`;let P;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?P=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${g.substr(0,8)}-${r}-${n}.sock`):P=(0,D.join)(c,`${r}-${n}.sock`),i(P),P}e.createStaticIPCHandle=o;function i(c){const n=m[k.platform];typeof n=="number"&&c.length>=n&&console.warn(`WARNING: IPC handle "${c}" is longer than ${n} chars, try a shorter --user-data-dir`)}class l extends C.IPCServer{static b(n){const r=I.Event.fromNodeEventEmitter(n,"connection");return I.Event.map(r,g=>({protocol:new R.Protocol(new E(g,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(g,"close"))}))}constructor(n){super(l.b(n)),this.d=n}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=l;function u(c){return new Promise((n,r)=>{const g=T().net.createServer();g.on("error",r),g.listen(c,()=>{g.removeListener("error",r),n(new l(g))})})}e.serve=u;function s(c,n){return new Promise((r,g)=>{const P=T().net.createConnection(c,()=>{P.removeListener("error",g),r(R.Client.fromSocket(new E(P,`ipc-client${n}`),n))});P.once("error",g)})}e.connect=s}),define(Se[161],ye([1,0,37,9]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(A,D,k,S,C,R){if(Array.isArray(A)){let T=0;for(const E of A){const y=I(E,D,k,S,C,R);if(y===10)return y;y>T&&(T=y)}return T}else{if(typeof A=="string")return S?A==="*"?5:A===k?10:0:0;if(A){const{language:T,pattern:E,scheme:y,hasAccessToAllModels:v,notebookType:d}=A;if(!S&&!v)return 0;d&&C&&(D=C);let b=0;if(y)if(y===D.scheme)b=10;else if(y==="*")b=5;else return 0;if(T)if(T===k)b=10;else if(T==="*")b=Math.max(b,5);else return 0;if(d)if(d===R)b=10;else if(d==="*"&&R!==void 0)b=Math.max(b,5);else return 0;if(E){let f;if(typeof E=="string"?f=E:f={...E,base:(0,t.normalize)(E.base)},f===D.fsPath||(0,a.match)(f,D.fsPath))b=10;else return 0}return b}else return 0}}e.score=I}),define(Se[162],ye([1,0,8,50,154]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class A{constructor(k,S,C,R){this.c=k,this.d=S,this.f=C,this.g=R,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(k){k.eol&&k.eol!==this.f&&(this.f=k.eol,this.h=null);const S=k.changes;for(const C of S)this.n(C.range),this.o(new t.Position(C.range.startLineNumber,C.range.startColumn),C.text);this.g=k.versionId,this.j=null}k(){if(!this.h){const k=this.f.length,S=this.d.length,C=new Uint32Array(S);for(let R=0;R<S;R++)C[R]=this.d[R].length+k;this.h=new I.PrefixSumComputer(C)}}l(k,S){this.d[k]=S,this.h&&this.h.setValue(k,this.d[k].length+this.f.length)}n(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this.l(k.startLineNumber-1,this.d[k.startLineNumber-1].substring(0,k.startColumn-1)+this.d[k.startLineNumber-1].substring(k.endColumn-1));return}this.l(k.startLineNumber-1,this.d[k.startLineNumber-1].substring(0,k.startColumn-1)+this.d[k.endLineNumber-1].substring(k.endColumn-1)),this.d.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this.h&&this.h.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}o(k,S){if(S.length===0)return;const C=(0,a.splitLines)(S);if(C.length===1){this.l(k.lineNumber-1,this.d[k.lineNumber-1].substring(0,k.column-1)+C[0]+this.d[k.lineNumber-1].substring(k.column-1));return}C[C.length-1]+=this.d[k.lineNumber-1].substring(k.column-1),this.l(k.lineNumber-1,this.d[k.lineNumber-1].substring(0,k.column-1)+C[0]);const R=new Uint32Array(C.length-1);for(let T=1;T<C.length;T++)this.d.splice(k.lineNumber+T-1,0,C[T]),R[T-1]=C[T].length+this.f.length;this.h&&this.h.insertValues(k.lineNumber,R)}}e.MirrorTextModel=A}),define(Se[163],ye([1,0,8,151,50,35,105]),function(ne,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class S{constructor(w,h,m,p){this.searchString=w,this.isRegex=h,this.matchCase=m,this.wordSeparators=p}parseSearchRequest(){if(this.searchString==="")return null;let w;this.isRegex?w=C(this.searchString):w=this.searchString.indexOf(`
`)>=0;let h=null;try{h=a.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:w,global:!0,unicode:!0})}catch{return null}if(!h)return null;let m=!this.isRegex&&!w;return m&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(m=this.matchCase),new D.SearchData(h,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,m?this.searchString:null)}}e.SearchParams=S;function C(f){if(!f||f.length===0)return!1;for(let w=0,h=f.length;w<h;w++){const m=f.charCodeAt(w);if(m===10)return!0;if(m===92){if(w++,w>=h)break;const p=f.charCodeAt(w);if(p===110||p===114||p===87)return!0}}return!1}e.isMultilineRegexSource=C;function R(f,w,h){if(!h)return new D.FindMatch(f,null);const m=[];for(let p=0,o=w.length;p<o;p++)m[p]=w[p];return new D.FindMatch(f,m)}e.createFindMatch=R;class T{constructor(w){const h=[];let m=0;for(let p=0,o=w.length;p<o;p++)w.charCodeAt(p)===10&&(h[m++]=p);this.a=h}findLineFeedCountBeforeOffset(w){const h=this.a;let m=0,p=h.length-1;if(p===-1||w<=h[0])return 0;for(;m<p;){const o=m+((p-m)/2>>0);h[o]>=w?p=o-1:h[o+1]>=w?(m=o,p=o):m=o+1}return m+1}}class E{static findMatches(w,h,m,p,o){const i=h.parseSearchRequest();return i?i.regex.multiline?this.b(w,m,new b(i.wordSeparators,i.regex),p,o):this.c(w,m,i,p,o):[]}static a(w,h,m,p,o,i){let l,u=0;p?(u=p.findLineFeedCountBeforeOffset(o),l=h+o+u):l=h+o;let s;if(p){const g=p.findLineFeedCountBeforeOffset(o+i.length)-u;s=l+i.length+g}else s=l+i.length;const c=w.getPositionAt(l),n=w.getPositionAt(s);return new A.Range(c.lineNumber,c.column,n.lineNumber,n.column)}static b(w,h,m,p,o){const i=w.getOffsetAt(h.getStartPosition()),l=w.getValueInRange(h,1),u=w.getEOL()===`\r
`?new T(l):null,s=[];let c=0,n;for(m.reset(0);n=m.next(l);)if(s[c++]=R(this.a(w,i,l,u,n.index,n[0]),n,p),c>=o)return s;return s}static c(w,h,m,p,o){const i=[];let l=0;if(h.startLineNumber===h.endLineNumber){const s=w.getLineContent(h.startLineNumber).substring(h.startColumn-1,h.endColumn-1);return l=this.d(m,s,h.startLineNumber,h.startColumn-1,l,i,p,o),i}const u=w.getLineContent(h.startLineNumber).substring(h.startColumn-1);l=this.d(m,u,h.startLineNumber,h.startColumn-1,l,i,p,o);for(let s=h.startLineNumber+1;s<h.endLineNumber&&l<o;s++)l=this.d(m,w.getLineContent(s),s,0,l,i,p,o);if(l<o){const s=w.getLineContent(h.endLineNumber).substring(0,h.endColumn-1);l=this.d(m,s,h.endLineNumber,0,l,i,p,o)}return i}static d(w,h,m,p,o,i,l,u){const s=w.wordSeparators;if(!l&&w.simpleSearch){const r=w.simpleSearch,g=r.length,P=h.length;let L=-g;for(;(L=h.indexOf(r,L+g))!==-1;)if((!s||d(s,h,P,L,g))&&(i[o++]=new D.FindMatch(new A.Range(m,L+1+p,m,L+1+g+p),null),o>=u))return o;return o}const c=new b(w.wordSeparators,w.regex);let n;c.reset(0);do if(n=c.next(h),n&&(i[o++]=R(new A.Range(m,n.index+1+p,m,n.index+1+n[0].length+p),n,l),o>=u))return o;while(n);return o}static findNextMatch(w,h,m,p){const o=h.parseSearchRequest();if(!o)return null;const i=new b(o.wordSeparators,o.regex);return o.regex.multiline?this.e(w,m,i,p):this.f(w,m,i,p)}static e(w,h,m,p){const o=new I.Position(h.lineNumber,1),i=w.getOffsetAt(o),l=w.getLineCount(),u=w.getValueInRange(new A.Range(o.lineNumber,o.column,l,w.getLineMaxColumn(l)),1),s=w.getEOL()===`\r
`?new T(u):null;m.reset(h.column-1);const c=m.next(u);return c?R(this.a(w,i,u,s,c.index,c[0]),c,p):h.lineNumber!==1||h.column!==1?this.e(w,new I.Position(1,1),m,p):null}static f(w,h,m,p){const o=w.getLineCount(),i=h.lineNumber,l=w.getLineContent(i),u=this.g(m,l,i,h.column,p);if(u)return u;for(let s=1;s<=o;s++){const c=(i+s-1)%o,n=w.getLineContent(c+1),r=this.g(m,n,c+1,1,p);if(r)return r}return null}static g(w,h,m,p,o){w.reset(p-1);const i=w.next(h);return i?R(new A.Range(m,i.index+1,m,i.index+1+i[0].length),i,o):null}static findPreviousMatch(w,h,m,p){const o=h.parseSearchRequest();if(!o)return null;const i=new b(o.wordSeparators,o.regex);return o.regex.multiline?this.h(w,m,i,p):this.j(w,m,i,p)}static h(w,h,m,p){const o=this.b(w,new A.Range(1,1,h.lineNumber,h.column),m,p,10*k);if(o.length>0)return o[o.length-1];const i=w.getLineCount();return h.lineNumber!==i||h.column!==w.getLineMaxColumn(i)?this.h(w,new I.Position(i,w.getLineMaxColumn(i)),m,p):null}static j(w,h,m,p){const o=w.getLineCount(),i=h.lineNumber,l=w.getLineContent(i).substring(0,h.column-1),u=this.k(m,l,i,p);if(u)return u;for(let s=1;s<=o;s++){const c=(o+i-s-1)%o,n=w.getLineContent(c+1),r=this.k(m,n,c+1,p);if(r)return r}return null}static k(w,h,m,p){let o=null,i;for(w.reset(0);i=w.next(h);)o=R(new A.Range(m,i.index+1,m,i.index+1+i[0].length),i,p);return o}}e.TextModelSearch=E;function y(f,w,h,m,p){if(m===0)return!0;const o=w.charCodeAt(m-1);if(f.get(o)!==0||o===13||o===10)return!0;if(p>0){const i=w.charCodeAt(m);if(f.get(i)!==0)return!0}return!1}function v(f,w,h,m,p){if(m+p===h)return!0;const o=w.charCodeAt(m+p);if(f.get(o)!==0||o===13||o===10)return!0;if(p>0){const i=w.charCodeAt(m+p-1);if(f.get(i)!==0)return!0}return!1}function d(f,w,h,m,p){return y(f,w,h,m,p)&&v(f,w,h,m,p)}e.isValidMatch=d;class b{constructor(w,h){this._wordSeparators=w,this.a=h,this.b=-1,this.c=0}reset(w){this.a.lastIndex=w,this.b=-1,this.c=0}next(w){const h=w.length;let m;do{if(this.b+this.c===h||(m=this.a.exec(w),!m))return null;const p=m.index,o=m[0].length;if(p===this.b&&o===this.c){if(o===0){a.getNextCodePoint(w,h,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=p,this.c=o,!this._wordSeparators||d(this._wordSeparators,w,h,p,o))return m}while(m);return null}}e.Searcher=b}),define(Se[118],ye([1,0,22,12]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(T){T[T.Full=1]="Full",T[T.Delta=2]="Delta"})(I||(I={}));function A(T){for(let E=0,y=T.length;E<y;E+=4){const v=T[E+0],d=T[E+1],b=T[E+2],f=T[E+3];T[E+0]=f,T[E+1]=b,T[E+2]=d,T[E+3]=v}}function D(T){const E=new Uint8Array(T.buffer,T.byteOffset,T.length*4);return t.isLittleEndian()||A(E),a.VSBuffer.wrap(E)}function k(T){const E=T.buffer;if(t.isLittleEndian()||A(E),E.byteOffset%4===0)return new Uint32Array(E.buffer,E.byteOffset,E.length/4);{const y=new Uint8Array(E.byteLength);return y.set(E),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function S(T){const E=new Uint32Array(C(T));let y=0;if(E[y++]=T.id,T.type==="full")E[y++]=1,E[y++]=T.data.length,E.set(T.data,y),y+=T.data.length;else{E[y++]=2,E[y++]=T.deltas.length;for(const v of T.deltas)E[y++]=v.start,E[y++]=v.deleteCount,v.data?(E[y++]=v.data.length,E.set(v.data,y),y+=v.data.length):E[y++]=0}return D(E)}e.encodeSemanticTokensDto=S;function C(T){let E=0;if(E+=1+1,T.type==="full")E+=1+T.data.length;else{E+=1,E+=(1+1+1)*T.deltas.length;for(const y of T.deltas)y.data&&(E+=y.data.length)}return E}function R(T){const E=k(T);let y=0;const v=E[y++];if(E[y++]===1){const w=E[y++],h=E.subarray(y,y+w);return y+=w,{id:v,type:"full",data:h}}const b=E[y++],f=[];for(let w=0;w<b;w++){const h=E[y++],m=E[y++],p=E[y++];let o;p>0&&(o=E.subarray(y,y+p),y+=p),f[w]={start:h,deleteCount:m,data:o}}return{id:v,type:"delta",deltas:f}}e.decodeSemanticTokensDto=R}),define(Se[164],ye([1,0,4,6]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class I{constructor(){this.a=new Map,this.b=new Map,this.c=new a.Emitter,this.onDidChange=this.c.event,this.d=null}fire(k){this.c.fire({changedLanguages:k,changedColorMap:!1})}register(k,S){return this.a.set(k,S),this.fire([k]),(0,t.toDisposable)(()=>{this.a.get(k)===S&&(this.a.delete(k),this.fire([k]))})}registerFactory(k,S){this.b.get(k)?.dispose();const C=new A(this,k,S);return this.b.set(k,C),(0,t.toDisposable)(()=>{const R=this.b.get(k);!R||R!==C||(this.b.delete(k),R.dispose())})}async getOrCreate(k){const S=this.get(k);if(S)return S;const C=this.b.get(k);return!C||C.isResolved?null:(await C.resolve(),this.get(k))}get(k){return this.a.get(k)||null}isResolved(k){if(this.get(k))return!0;const C=this.b.get(k);return!!(!C||C.isResolved)}setColorMap(k){this.d=k,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=I;class A extends t.Disposable{get isResolved(){return this.c}constructor(k,S,C){super(),this.f=k,this.g=S,this.h=C,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const k=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,k&&!this.a&&this.B(this.f.register(this.g,k))}}}),define(Se[66],ye([1,0,79,2,35,164]),function(ne,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class D{constructor(g,P,L){this._tokenBrand=void 0,this.offset=g,this.type=P,this.language=L}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=D;class k{constructor(g,P){this._tokenizationResultBrand=void 0,this.tokens=g,this.endState=P}}e.TokenizationResult=k;class S{constructor(g,P){this._encodedTokenizationResultBrand=void 0,this.tokens=g,this.endState=P}}e.EncodedTokenizationResult=S;var C;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(C=e.CompletionItemKind||(e.CompletionItemKind={}));var R;(function(r){const g=new Map;g.set(0,a.Codicon.symbolMethod),g.set(1,a.Codicon.symbolFunction),g.set(2,a.Codicon.symbolConstructor),g.set(3,a.Codicon.symbolField),g.set(4,a.Codicon.symbolVariable),g.set(5,a.Codicon.symbolClass),g.set(6,a.Codicon.symbolStruct),g.set(7,a.Codicon.symbolInterface),g.set(8,a.Codicon.symbolModule),g.set(9,a.Codicon.symbolProperty),g.set(10,a.Codicon.symbolEvent),g.set(11,a.Codicon.symbolOperator),g.set(12,a.Codicon.symbolUnit),g.set(13,a.Codicon.symbolValue),g.set(15,a.Codicon.symbolEnum),g.set(14,a.Codicon.symbolConstant),g.set(15,a.Codicon.symbolEnum),g.set(16,a.Codicon.symbolEnumMember),g.set(17,a.Codicon.symbolKeyword),g.set(27,a.Codicon.symbolSnippet),g.set(18,a.Codicon.symbolText),g.set(19,a.Codicon.symbolColor),g.set(20,a.Codicon.symbolFile),g.set(21,a.Codicon.symbolReference),g.set(22,a.Codicon.symbolCustomColor),g.set(23,a.Codicon.symbolFolder),g.set(24,a.Codicon.symbolTypeParameter),g.set(25,a.Codicon.account),g.set(26,a.Codicon.issues);function P(_){let K=g.get(_);return K||(console.info("No codicon found for CompletionItemKind "+_),K=a.Codicon.symbolProperty),K}r.toIcon=P;const L=new Map;L.set("method",0),L.set("function",1),L.set("constructor",2),L.set("field",3),L.set("variable",4),L.set("class",5),L.set("struct",6),L.set("interface",7),L.set("module",8),L.set("property",9),L.set("event",10),L.set("operator",11),L.set("unit",12),L.set("value",13),L.set("constant",14),L.set("enum",15),L.set("enum-member",16),L.set("enumMember",16),L.set("keyword",17),L.set("snippet",27),L.set("text",18),L.set("color",19),L.set("file",20),L.set("reference",21),L.set("customcolor",22),L.set("folder",23),L.set("type-parameter",24),L.set("typeParameter",24),L.set("account",25),L.set("issue",26);function z(_,K){let F=L.get(_);return typeof F>"u"&&!K&&(F=9),F}r.fromString=z})(R=e.CompletionItemKinds||(e.CompletionItemKinds={}));var T;(function(r){r[r.Deprecated=1]="Deprecated"})(T=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var y;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(y=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var v;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(v=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var d;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(d=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var b;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(b=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var f;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(f=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function w(r){return r&&t.URI.isUri(r.uri)&&I.Range.isIRange(r.range)&&(I.Range.isIRange(r.originSelectionRange)||I.Range.isIRange(r.targetSelectionRange))}e.isLocationLink=w;var h;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(h=e.SymbolKind||(e.SymbolKind={}));var m;(function(r){r[r.Deprecated=1]="Deprecated"})(m=e.SymbolTag||(e.SymbolTag={}));var p;(function(r){const g=new Map;g.set(0,a.Codicon.symbolFile),g.set(1,a.Codicon.symbolModule),g.set(2,a.Codicon.symbolNamespace),g.set(3,a.Codicon.symbolPackage),g.set(4,a.Codicon.symbolClass),g.set(5,a.Codicon.symbolMethod),g.set(6,a.Codicon.symbolProperty),g.set(7,a.Codicon.symbolField),g.set(8,a.Codicon.symbolConstructor),g.set(9,a.Codicon.symbolEnum),g.set(10,a.Codicon.symbolInterface),g.set(11,a.Codicon.symbolFunction),g.set(12,a.Codicon.symbolVariable),g.set(13,a.Codicon.symbolConstant),g.set(14,a.Codicon.symbolString),g.set(15,a.Codicon.symbolNumber),g.set(16,a.Codicon.symbolBoolean),g.set(17,a.Codicon.symbolArray),g.set(18,a.Codicon.symbolObject),g.set(19,a.Codicon.symbolKey),g.set(20,a.Codicon.symbolNull),g.set(21,a.Codicon.symbolEnumMember),g.set(22,a.Codicon.symbolStruct),g.set(23,a.Codicon.symbolEvent),g.set(24,a.Codicon.symbolOperator),g.set(25,a.Codicon.symbolTypeParameter);function P(L){let z=g.get(L);return z||(console.info("No codicon found for SymbolKind "+L),z=a.Codicon.symbolProperty),z}r.toIcon=P})(p=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(g){this.value=g}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var i;(function(r){function g(P){return!P||typeof P!="object"?!1:typeof P.id=="string"&&typeof P.title=="string"}r.is=g})(i=e.Command||(e.Command={}));var l;(function(r){r[r.Collapsed=0]="Collapsed",r[r.Expanded=1]="Expanded"})(l=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var u;(function(r){r[r.Unresolved=0]="Unresolved",r[r.Resolved=1]="Resolved"})(u=e.CommentThreadState||(e.CommentThreadState={}));var s;(function(r){r[r.Editing=0]="Editing",r[r.Preview=1]="Preview"})(s=e.CommentMode||(e.CommentMode={}));var c;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(c=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new A.TokenizationRegistry;var n;(function(r){r[r.None=0]="None",r[r.Option=1]="Option",r[r.Default=2]="Default",r[r.Preferred=3]="Preferred"})(n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Se[165],ye([19,20]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(Se[119],ye([1,0,165,12,104,17,23,150]),function(ne,e,a,t,I,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(ae){ae[ae.None=0]="None",ae[ae.Keep=1]="Keep",ae[ae.Brackets=2]="Brackets",ae[ae.Advanced=3]="Advanced",ae[ae.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class C{constructor($){this.c=$}hasChanged($){return this.c[$]}}e.ConfigurationChangedEvent=C;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class T{constructor($,ce,Ie,Le){this.id=$,this.name=ce,this.defaultValue=Ie,this.schema=Le}applyUpdate($,ce){return y($,ce)}compute($,ce,Ie){return Ie}}class E{constructor($,ce){this.newValue=$,this.didChange=ce}}e.ApplyUpdateResult=E;function y(ae,$){if(typeof ae!="object"||typeof $!="object"||!ae||!$)return new E($,ae!==$);if(Array.isArray(ae)||Array.isArray($)){const Ie=Array.isArray(ae)&&Array.isArray($)&&A.equals(ae,$);return new E($,!Ie)}let ce=!1;for(const Ie in $)if($.hasOwnProperty(Ie)){const Le=y(ae[Ie],$[Ie]);Le.didChange&&(ae[Ie]=Le.newValue,ce=!0)}return new E(ae,ce)}class v{constructor($){this.schema=void 0,this.id=$,this.name="_never_",this.defaultValue=void 0}applyUpdate($,ce){return y($,ce)}validate($){return this.defaultValue}}class d{constructor($,ce,Ie,Le){this.id=$,this.name=ce,this.defaultValue=Ie,this.schema=Le}applyUpdate($,ce){return y($,ce)}validate($){return typeof $>"u"?this.defaultValue:$}compute($,ce,Ie){return Ie}}function b(ae,$){return typeof ae>"u"?$:ae==="false"?!1:Boolean(ae)}e.boolean=b;class f extends d{constructor($,ce,Ie,Le=void 0){typeof Le<"u"&&(Le.type="boolean",Le.default=Ie),super($,ce,Ie,Le)}validate($){return b($,this.defaultValue)}}function w(ae,$,ce,Ie){if(typeof ae>"u")return $;let Le=parseInt(ae,10);return isNaN(Le)?$:(Le=Math.max(ce,Le),Le=Math.min(Ie,Le),Le|0)}e.clampedInt=w;class h extends d{static clampedInt($,ce,Ie,Le){return w($,ce,Ie,Le)}constructor($,ce,Ie,Le,Be,xe=void 0){typeof xe<"u"&&(xe.type="integer",xe.default=Ie,xe.minimum=Le,xe.maximum=Be),super($,ce,Ie,xe),this.minimum=Le,this.maximum=Be}validate($){return h.clampedInt($,this.defaultValue,this.minimum,this.maximum)}}class m extends d{static clamp($,ce,Ie){return $<ce?ce:$>Ie?Ie:$}static float($,ce){if(typeof $=="number")return $;if(typeof $>"u")return ce;const Ie=parseFloat($);return isNaN(Ie)?ce:Ie}constructor($,ce,Ie,Le,Be){typeof Be<"u"&&(Be.type="number",Be.default=Ie),super($,ce,Ie,Be),this.validationFn=Le}validate($){return this.validationFn(m.float($,this.defaultValue))}}class p extends d{static string($,ce){return typeof $!="string"?ce:$}constructor($,ce,Ie,Le=void 0){typeof Le<"u"&&(Le.type="string",Le.default=Ie),super($,ce,Ie,Le)}validate($){return p.string($,this.defaultValue)}}function o(ae,$,ce){return typeof ae!="string"||ce.indexOf(ae)===-1?$:ae}e.stringSet=o;class i extends d{constructor($,ce,Ie,Le,Be=void 0){typeof Be<"u"&&(Be.type="string",Be.enum=Le,Be.default=Ie),super($,ce,Ie,Be),this.c=Le}validate($){return o($,this.defaultValue,this.c)}}class l extends T{constructor($,ce,Ie,Le,Be,xe,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Be,Ze.default=Le),super($,ce,Ie,Ze),this.c=Be,this.d=xe}validate($){return typeof $!="string"?this.defaultValue:this.c.indexOf($)===-1?this.defaultValue:this.d($)}}function u(ae){switch(ae){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class s extends T{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",tags:["accessibility"],description:a.localize(3,null)})}validate($){switch($){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute($,ce,Ie){return Ie===0?$.accessibilitySupport:Ie}}class c extends T{constructor(){const $={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",$,{"editor.comments.insertSpace":{type:"boolean",default:$.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:$.ignoreEmptyLines,description:a.localize(5,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{insertSpace:b(ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:b(ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(ae){ae[ae.Hidden=0]="Hidden",ae[ae.Blink=1]="Blink",ae[ae.Smooth=2]="Smooth",ae[ae.Phase=3]="Phase",ae[ae.Expand=4]="Expand",ae[ae.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(ae){switch(ae){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(ae){ae[ae.Line=1]="Line",ae[ae.Block=2]="Block",ae[ae.Underline=3]="Underline",ae[ae.LineThin=4]="LineThin",ae[ae.BlockOutline=5]="BlockOutline",ae[ae.UnderlineThin=6]="UnderlineThin"})(g=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function P(ae){switch(ae){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=P;function L(ae){switch(ae){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class z extends v{constructor(){super(134)}compute($,ce,Ie){const Le=["monaco-editor"];return ce.get(35)&&Le.push(ce.get(35)),$.extraEditorClassName&&Le.push($.extraEditorClassName),ce.get(69)==="default"?Le.push("mouse-default"):ce.get(69)==="copy"&&Le.push("mouse-copy"),ce.get(104)&&Le.push("showUnused"),ce.get(132)&&Le.push("showDeprecated"),Le.join(" ")}}class _ extends f{constructor(){super(33,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute($,ce,Ie){return Ie&&$.emptySelectionClipboard}}class K extends T{constructor(){const $={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(37,"find",$,{"editor.find.cursorMoveOnType":{type:"boolean",default:$.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:$.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:$.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:$.globalFindClipboard,description:a.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:$.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:$.loop,description:a.localize(18,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{cursorMoveOnType:b(ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof $.seedSearchStringFromSelection=="boolean"?$.seedSearchStringFromSelection?"always":"never":o(ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof $.autoFindInSelection=="boolean"?$.autoFindInSelection?"always":"never":o(ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:b(ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:b(ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:b(ce.loop,this.defaultValue.loop)}}}class F extends T{constructor(){super(47,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate($){return typeof $>"u"?this.defaultValue:typeof $=="string"?$==="false"?F.OFF:$==="true"?F.ON:$:Boolean($)?F.ON:F.OFF}}e.EditorFontLigatures=F,F.OFF='"liga" off, "calt" off',F.ON='"liga" on, "calt" on';class M extends T{constructor(){super(50,"fontVariations",M.OFF,{anyOf:[{type:"boolean",description:a.localize(22,null)},{type:"string",description:a.localize(23,null)}],description:a.localize(24,null),default:!1})}validate($){return typeof $>"u"?this.defaultValue:typeof $=="string"?$==="false"?M.OFF:$==="true"?M.TRANSLATE:$:Boolean($)?M.TRANSLATE:M.OFF}compute($,ce,Ie){return $.fontInfo.fontVariationSettings}}e.EditorFontVariations=M,M.OFF="normal",M.TRANSLATE="translate";class N extends v{constructor(){super(46)}compute($,ce,Ie){return $.fontInfo}}class B extends d{constructor(){super(48,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(25,null)})}validate($){const ce=m.float($,this.defaultValue);return ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:m.clamp(ce,6,100)}compute($,ce,Ie){return $.fontInfo.fontSize}}class U extends T{constructor(){super(49,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:U.d,maximum:U.e,errorMessage:a.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:U.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(27,null)})}validate($){return $==="normal"||$==="bold"?$:String(h.clampedInt($,e.EDITOR_FONT_DEFAULTS.fontWeight,U.d,U.e))}}U.c=["normal","bold","100","200","300","400","500","600","700","800","900"],U.d=1,U.e=1e3;class W extends T{constructor(){const $={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:$.multiple,enumDescriptions:[a.localize(28,null),a.localize(29,null),a.localize(30,null)]},Ie=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(54,"gotoLocation",$,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(32,null),...ce},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(33,null),...ce},"editor.gotoLocation.multipleDeclarations":{description:a.localize(34,null),...ce},"editor.gotoLocation.multipleImplementations":{description:a.localize(35,null),...ce},"editor.gotoLocation.multipleReferences":{description:a.localize(36,null),...ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:$.alternativeDefinitionCommand,enum:Ie,description:a.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:$.alternativeTypeDefinitionCommand,enum:Ie,description:a.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:$.alternativeDeclarationCommand,enum:Ie,description:a.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:$.alternativeImplementationCommand,enum:Ie,description:a.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:$.alternativeReferenceCommand,enum:Ie,description:a.localize(41,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{multiple:o(ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ce.multipleDefinitions??o(ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ce.multipleTypeDefinitions??o(ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ce.multipleDeclarations??o(ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ce.multipleImplementations??o(ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ce.multipleReferences??o(ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends T{constructor(){const $={enabled:!0,delay:300,sticky:!0,above:!0};super(56,"hover",$,{"editor.hover.enabled":{type:"boolean",default:$.enabled,description:a.localize(42,null)},"editor.hover.delay":{type:"number",default:$.delay,minimum:0,maximum:1e4,description:a.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:$.sticky,description:a.localize(44,null)},"editor.hover.above":{type:"boolean",default:$.above,description:a.localize(45,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:b(ce.enabled,this.defaultValue.enabled),delay:h.clampedInt(ce.delay,this.defaultValue.delay,0,1e4),sticky:b(ce.sticky,this.defaultValue.sticky),above:b(ce.above,this.defaultValue.above)}}}var V;(function(ae){ae[ae.None=0]="None",ae[ae.Text=1]="Text",ae[ae.Blocks=2]="Blocks"})(V=e.RenderMinimap||(e.RenderMinimap={}));class X extends v{constructor(){super(137)}compute($,ce,Ie){return X.computeLayout(ce,{memory:$.memory,outerWidth:$.outerWidth,outerHeight:$.outerHeight,isDominatedByLongLines:$.isDominatedByLongLines,lineHeight:$.fontInfo.lineHeight,viewLineCount:$.viewLineCount,lineNumbersDigitCount:$.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:$.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:$.fontInfo.maxDigitWidth,pixelRatio:$.pixelRatio})}static computeContainedMinimapLineCount($){const ce=$.height/$.lineHeight,Ie=$.scrollBeyondLastLine?ce-1:0,Le=($.viewLineCount+Ie)/($.pixelRatio*$.height),Be=Math.floor($.viewLineCount/Le);return{typicalViewportLineCount:ce,extraLinesBeyondLastLine:Ie,desiredRatio:Le,minimapLineCount:Be}}static c($,ce){const Ie=$.outerWidth,Le=$.outerHeight,Be=$.pixelRatio;if(!$.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Be*Le),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Le};const xe=ce.stableMinimapLayoutInput,Ze=xe&&$.outerHeight===xe.outerHeight&&$.lineHeight===xe.lineHeight&&$.typicalHalfwidthCharacterWidth===xe.typicalHalfwidthCharacterWidth&&$.pixelRatio===xe.pixelRatio&&$.scrollBeyondLastLine===xe.scrollBeyondLastLine&&$.minimap.enabled===xe.minimap.enabled&&$.minimap.side===xe.minimap.side&&$.minimap.size===xe.minimap.size&&$.minimap.showSlider===xe.minimap.showSlider&&$.minimap.renderCharacters===xe.minimap.renderCharacters&&$.minimap.maxColumn===xe.minimap.maxColumn&&$.minimap.scale===xe.minimap.scale&&$.verticalScrollbarWidth===xe.verticalScrollbarWidth&&$.isViewportWrapping===xe.isViewportWrapping,mt=$.lineHeight,ft=$.typicalHalfwidthCharacterWidth,lt=$.scrollBeyondLastLine,ot=$.minimap.renderCharacters;let rt=Be>=2?Math.round($.minimap.scale*2):$.minimap.scale;const At=$.minimap.maxColumn,Rt=$.minimap.size,Ft=$.minimap.side,pt=$.verticalScrollbarWidth,kt=$.viewLineCount,Bt=$.remainingWidth,Mt=$.isViewportWrapping,Xe=ot?2:3;let Ot=Math.floor(Be*Le);const Ut=Ot/Be;let Ht=!1,bt=!1,Lt=Xe*rt,Ae=rt/Be,Oe=1;if(Rt==="fill"||Rt==="fit"){const{typicalViewportLineCount:tt,extraLinesBeyondLastLine:It,desiredRatio:Et,minimapLineCount:Tt}=X.computeContainedMinimapLineCount({viewLineCount:kt,scrollBeyondLastLine:lt,height:Le,lineHeight:mt,pixelRatio:Be});if(kt/Tt>1)Ht=!0,bt=!0,rt=1,Lt=1,Ae=rt/Be;else{let vt=!1,yt=rt+1;if(Rt==="fit"){const zt=Math.ceil((kt+It)*Lt);Mt&&Ze&&Bt<=ce.stableFitRemainingWidth?(vt=!0,yt=ce.stableFitMaxMinimapScale):vt=zt>Ot}if(Rt==="fill"||vt){Ht=!0;const zt=rt;Lt=Math.min(mt*Be,Math.max(1,Math.floor(1/Et))),Mt&&Ze&&Bt<=ce.stableFitRemainingWidth&&(yt=ce.stableFitMaxMinimapScale),rt=Math.min(yt,Math.max(1,Math.floor(Lt/Xe))),rt>zt&&(Oe=Math.min(2,rt/zt)),Ae=rt/Be/Oe,Ot=Math.ceil(Math.max(tt,kt+It)*Lt),Mt?(ce.stableMinimapLayoutInput=$,ce.stableFitRemainingWidth=Bt,ce.stableFitMaxMinimapScale=rt):(ce.stableMinimapLayoutInput=null,ce.stableFitRemainingWidth=0)}}}const Ee=Math.floor(At*Ae),re=Math.min(Ee,Math.max(0,Math.floor((Bt-pt-2)*Ae/(ft+Ae)))+e.MINIMAP_GUTTER_WIDTH);let Ne=Math.floor(Be*re);const $e=Ne/Be;Ne=Math.floor(Ne*Oe);const Qe=ot?1:2,Ve=Ft==="left"?0:Ie-re-pt;return{renderMinimap:Qe,minimapLeft:Ve,minimapWidth:re,minimapHeightIsEditorHeight:Ht,minimapIsSampling:bt,minimapScale:rt,minimapLineHeight:Lt,minimapCanvasInnerWidth:Ne,minimapCanvasInnerHeight:Ot,minimapCanvasOuterWidth:$e,minimapCanvasOuterHeight:Ut}}static computeLayout($,ce){const Ie=ce.outerWidth|0,Le=ce.outerHeight|0,Be=ce.lineHeight|0,xe=ce.lineNumbersDigitCount|0,Ze=ce.typicalHalfwidthCharacterWidth,mt=ce.maxDigitWidth,ft=ce.pixelRatio,lt=ce.viewLineCount,ot=$.get(129),rt=ot==="inherit"?$.get(128):ot,At=rt==="inherit"?$.get(124):rt,Rt=$.get(127),Ft=ce.isDominatedByLongLines,pt=$.get(53),kt=$.get(63).renderType!==0,Bt=$.get(64),Mt=$.get(98),Xe=$.get(68),Ot=$.get(96),Ut=Ot.verticalScrollbarSize,Ht=Ot.verticalHasArrows,bt=Ot.arrowSize,Lt=Ot.horizontalScrollbarSize,Ae=$.get(39),Oe=$.get(103)!=="never";let Ee=$.get(61);Ae&&Oe&&(Ee+=16);let re=0;if(kt){const St=Math.max(xe,Bt);re=Math.round(St*mt)}let Ne=0;pt&&(Ne=Be);let $e=0,Qe=$e+Ne,Ve=Qe+re,tt=Ve+Ee;const It=Ie-Ne-re-Ee;let Et=!1,Tt=!1,wt=-1;rt==="inherit"&&Ft?(Et=!0,Tt=!0):At==="on"||At==="bounded"?Tt=!0:At==="wordWrapColumn"&&(wt=Rt);const vt=X.c({outerWidth:Ie,outerHeight:Le,lineHeight:Be,typicalHalfwidthCharacterWidth:Ze,pixelRatio:ft,scrollBeyondLastLine:Mt,minimap:Xe,verticalScrollbarWidth:Ut,viewLineCount:lt,remainingWidth:It,isViewportWrapping:Tt},ce.memory||new R);vt.renderMinimap!==0&&vt.minimapLeft===0&&($e+=vt.minimapWidth,Qe+=vt.minimapWidth,Ve+=vt.minimapWidth,tt+=vt.minimapWidth);const yt=It-vt.minimapWidth,zt=Math.max(1,Math.floor((yt-Ut-2)/Ze)),Xt=Ht?bt:0;return Tt&&(wt=Math.max(1,zt),At==="bounded"&&(wt=Math.min(wt,Rt))),{width:Ie,height:Le,glyphMarginLeft:$e,glyphMarginWidth:Ne,lineNumbersLeft:Qe,lineNumbersWidth:re,decorationsLeft:Ve,decorationsWidth:Ee,contentLeft:tt,contentWidth:yt,minimap:vt,viewportColumn:zt,isWordWrapMinified:Et,isViewportWrapping:Tt,wrappingColumn:wt,verticalScrollbarWidth:Ut,horizontalScrollbarHeight:Lt,overviewRuler:{top:Xt,width:Ut,height:Le-2*Xt,right:0}}}}e.EditorLayoutInfoComputer=X;class Q extends T{constructor(){super(131,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[a.localize(46,null),a.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:a.localize(48,null)}})}validate($){return o($,"simple",["simple","advanced"])}compute($,ce,Ie){return ce.get(2)===2?"advanced":Ie}}class J extends T{constructor(){const $={enabled:!0};super(60,"lightbulb",$,{"editor.lightbulb.enabled":{type:"boolean",default:$.enabled,description:a.localize(49,null)}})}validate($){return!$||typeof $!="object"?this.defaultValue:{enabled:b($.enabled,this.defaultValue.enabled)}}}class te extends T{constructor(){const $={enabled:!1,maxLineCount:5};super(108,"stickyScroll",$,{"editor.stickyScroll.enabled":{type:"boolean",default:$.enabled,description:a.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:$.maxLineCount,minimum:1,maximum:10,description:a.localize(51,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:b(ce.enabled,this.defaultValue.enabled),maxLineCount:h.clampedInt(ce.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class le extends T{constructor(){const $={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(133,"inlayHints",$,{"editor.inlayHints.enabled":{type:"string",default:$.enabled,description:a.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(53,null),a.localize(54,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(55,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:$.fontSize,markdownDescription:a.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:$.fontFamily,markdownDescription:a.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:$.padding,description:a.localize(59,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return typeof ce.enabled=="boolean"&&(ce.enabled=ce.enabled?"on":"off"),{enabled:o(ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:h.clampedInt(ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(ce.fontFamily,this.defaultValue.fontFamily),padding:b(ce.padding,this.defaultValue.padding)}}}class Z extends T{constructor(){super(61,"lineDecorationsWidth",10)}validate($){return typeof $=="string"&&/^\d+(\.\d+)?ch$/.test($)?-parseFloat($.substring(0,$.length-2)):h.clampedInt($,this.defaultValue,0,1e3)}compute($,ce,Ie){return Ie<0?h.clampedInt(-Ie*$.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ie}}class ge extends m{constructor(){super(62,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,$=>m.clamp($,0,150),{markdownDescription:a.localize(60,null)})}compute($,ce,Ie){return $.fontInfo.lineHeight}}class ve extends T{constructor(){const $={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(68,"minimap",$,{"editor.minimap.enabled":{type:"boolean",default:$.enabled,description:a.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:$.autohide,description:a.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(63,null),a.localize(64,null),a.localize(65,null)],default:$.size,description:a.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:$.side,description:a.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:$.showSlider,description:a.localize(68,null)},"editor.minimap.scale":{type:"number",default:$.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:$.renderCharacters,description:a.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:$.maxColumn,description:a.localize(71,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:b(ce.enabled,this.defaultValue.enabled),autohide:b(ce.autohide,this.defaultValue.autohide),size:o(ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:o(ce.side,this.defaultValue.side,["right","left"]),showSlider:o(ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:b(ce.renderCharacters,this.defaultValue.renderCharacters),scale:h.clampedInt(ce.scale,1,1,3),maxColumn:h.clampedInt(ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function De(ae){return ae==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Re extends T{constructor(){super(79,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(73,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{top:h.clampedInt(ce.top,0,0,1e3),bottom:h.clampedInt(ce.bottom,0,0,1e3)}}}class ze extends T{constructor(){const $={enabled:!0,cycle:!1};super(80,"parameterHints",$,{"editor.parameterHints.enabled":{type:"boolean",default:$.enabled,description:a.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:$.cycle,description:a.localize(75,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:b(ce.enabled,this.defaultValue.enabled),cycle:b(ce.cycle,this.defaultValue.cycle)}}}class se extends v{constructor(){super(135)}compute($,ce,Ie){return $.pixelRatio}}class ue extends T{constructor(){const $={other:"on",comments:"off",strings:"off"},ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(76,null),a.localize(77,null),a.localize(78,null)]}];super(83,"quickSuggestions",$,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ce,default:$.strings,description:a.localize(79,null)},comments:{anyOf:ce,default:$.comments,description:a.localize(80,null)},other:{anyOf:ce,default:$.other,description:a.localize(81,null)}},default:$,markdownDescription:a.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=$}validate($){if(typeof $=="boolean"){const ft=$?"on":"off";return{comments:ft,strings:ft,other:ft}}if(!$||typeof $!="object")return this.defaultValue;const{other:ce,comments:Ie,strings:Le}=$,Be=["on","inline","off"];let xe,Ze,mt;return typeof ce=="boolean"?xe=ce?"on":"off":xe=o(ce,this.defaultValue.other,Be),typeof Ie=="boolean"?Ze=Ie?"on":"off":Ze=o(Ie,this.defaultValue.comments,Be),typeof Le=="boolean"?mt=Le?"on":"off":mt=o(Le,this.defaultValue.strings,Be),{other:xe,comments:Ze,strings:mt}}}var he;(function(ae){ae[ae.Off=0]="Off",ae[ae.On=1]="On",ae[ae.Relative=2]="Relative",ae[ae.Interval=3]="Interval",ae[ae.Custom=4]="Custom"})(he=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ee extends T{constructor(){super(63,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(83,null),a.localize(84,null),a.localize(85,null),a.localize(86,null)],default:"on",description:a.localize(87,null)})}validate($){let ce=this.defaultValue.renderType,Ie=this.defaultValue.renderFn;return typeof $<"u"&&(typeof $=="function"?(ce=4,Ie=$):$==="interval"?ce=3:$==="relative"?ce=2:$==="on"?ce=1:ce=0),{renderType:ce,renderFn:Ie}}}function oe(ae){const $=ae.get(91);return $==="editable"?ae.get(85):$!=="on"}e.filterValidationDecorations=oe;class ie extends T{constructor(){const $=[],ce={type:"number",description:a.localize(88,null)};super(95,"rulers",$,{type:"array",items:{anyOf:[ce,{type:["object"],properties:{column:ce,color:{type:"string",description:a.localize(89,null),format:"color-hex"}}}]},default:$,description:a.localize(90,null)})}validate($){if(Array.isArray($)){const ce=[];for(const Ie of $)if(typeof Ie=="number")ce.push({column:h.clampedInt(Ie,0,0,1e4),color:null});else if(Ie&&typeof Ie=="object"){const Le=Ie;ce.push({column:h.clampedInt(Le.column,0,0,1e4),color:Le.color})}return ce.sort((Ie,Le)=>Ie.column-Le.column),ce}return this.defaultValue}}function O(ae,$){if(typeof ae!="string")return $;switch(ae){case"hidden":return 2;case"visible":return 3;default:return 1}}class H extends T{constructor(){const $={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(96,"scrollbar",$,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(91,null),a.localize(92,null),a.localize(93,null)],default:"auto",description:a.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(95,null),a.localize(96,null),a.localize(97,null)],default:"auto",description:a.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:$.verticalScrollbarSize,description:a.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:$.horizontalScrollbarSize,description:a.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:$.scrollByPage,description:a.localize(101,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$,Ie=h.clampedInt(ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Le=h.clampedInt(ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:h.clampedInt(ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:O(ce.vertical,this.defaultValue.vertical),horizontal:O(ce.horizontal,this.defaultValue.horizontal),useShadows:b(ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:b(ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:b(ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:b(ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:b(ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ie,horizontalSliderSize:h.clampedInt(ce.horizontalSliderSize,Ie,0,1e3),verticalScrollbarSize:Le,verticalSliderSize:h.clampedInt(ce.verticalSliderSize,Le,0,1e3),scrollByPage:b(ce.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class q extends T{constructor(){const $={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(118,"unicodeHighlight",$,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.nonBasicASCII,description:a.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:$.invisibleCharacters,description:a.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:$.ambiguousCharacters,description:a.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.includeComments,description:a.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.includeStrings,description:a.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:$.allowedCharacters,description:a.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:$.allowedLocales,description:a.localize(108,null)}})}applyUpdate($,ce){let Ie=!1;ce.allowedCharacters&&$&&(D.equals($.allowedCharacters,ce.allowedCharacters)||($={...$,allowedCharacters:ce.allowedCharacters},Ie=!0)),ce.allowedLocales&&$&&(D.equals($.allowedLocales,ce.allowedLocales)||($={...$,allowedLocales:ce.allowedLocales},Ie=!0));const Le=super.applyUpdate($,ce);return Ie?new E(Le.newValue,!0):Le}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{nonBasicASCII:Pe(ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:b(ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:b(ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Pe(ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Pe(ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c($.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c($.allowedLocales,this.defaultValue.allowedLocales)}}c($,ce){if(typeof $!="object"||!$)return ce;const Ie={};for(const[Le,Be]of Object.entries($))Be===!0&&(Ie[Le]=!0);return Ie}}class Y extends T{constructor(){const $={enabled:!0,mode:"subwordSmart"};super(58,"inlineSuggest",$,{"editor.inlineSuggest.enabled":{type:"boolean",default:$.enabled,description:a.localize(109,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:b(ce.enabled,this.defaultValue.enabled),mode:o(ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class de extends T{constructor(){const $={enabled:k.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:k.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",$,{"editor.bracketPairColorization.enabled":{type:"boolean",default:$.enabled,markdownDescription:a.localize(110,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:$.independentColorPoolPerBracketType,description:a.localize(111,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{enabled:b(ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:b(ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class be extends T{constructor(){const $={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",$,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(112,null),a.localize(113,null),a.localize(114,null)],default:$.bracketPairs,description:a.localize(115,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(116,null),a.localize(117,null),a.localize(118,null)],default:$.bracketPairsHorizontal,description:a.localize(119,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:$.highlightActiveBracketPair,description:a.localize(120,null)},"editor.guides.indentation":{type:"boolean",default:$.indentation,description:a.localize(121,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(122,null),a.localize(123,null),a.localize(124,null)],default:$.highlightActiveIndentation,description:a.localize(125,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{bracketPairs:Pe(ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Pe(ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:b(ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:b(ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:Pe(ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Pe(ae,$,ce){const Ie=ce.indexOf(ae);return Ie===-1?$:ce[Ie]}class pe extends T{constructor(){const $={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectQuickSuggestions:!0,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(111,"suggest",$,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(126,null),a.localize(127,null)],default:$.insertMode,description:a.localize(128,null)},"editor.suggest.filterGraceful":{type:"boolean",default:$.filterGraceful,description:a.localize(129,null)},"editor.suggest.localityBonus":{type:"boolean",default:$.localityBonus,description:a.localize(130,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:$.shareSuggestSelections,markdownDescription:a.localize(131,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:$.snippetsPreventQuickSuggestions,description:a.localize(132,null)},"editor.suggest.showIcons":{type:"boolean",default:$.showIcons,description:a.localize(133,null)},"editor.suggest.showStatusBar":{type:"boolean",default:$.showStatusBar,description:a.localize(134,null)},"editor.suggest.preview":{type:"boolean",default:$.preview,description:a.localize(135,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:$.showInlineDetails,description:a.localize(136,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(137,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(138,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(139,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(140,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(141,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(142,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(143,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(144,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(145,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(146,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(147,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(148,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(149,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(150,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(151,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(152,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(153,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(154,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(155,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(156,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(157,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(158,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(159,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(160,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(161,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(162,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(163,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(164,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(165,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(166,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(167,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(168,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ce=$;return{insertMode:o(ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:b(ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:b(ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:b(ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:b(ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectQuickSuggestions:b(ce.selectQuickSuggestions,this.defaultValue.selectQuickSuggestions),showIcons:b(ce.showIcons,this.defaultValue.showIcons),showStatusBar:b(ce.showStatusBar,this.defaultValue.showStatusBar),preview:b(ce.preview,this.defaultValue.preview),previewMode:o(ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:b(ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:b(ce.showMethods,this.defaultValue.showMethods),showFunctions:b(ce.showFunctions,this.defaultValue.showFunctions),showConstructors:b(ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:b(ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:b(ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:b(ce.showFields,this.defaultValue.showFields),showVariables:b(ce.showVariables,this.defaultValue.showVariables),showClasses:b(ce.showClasses,this.defaultValue.showClasses),showStructs:b(ce.showStructs,this.defaultValue.showStructs),showInterfaces:b(ce.showInterfaces,this.defaultValue.showInterfaces),showModules:b(ce.showModules,this.defaultValue.showModules),showProperties:b(ce.showProperties,this.defaultValue.showProperties),showEvents:b(ce.showEvents,this.defaultValue.showEvents),showOperators:b(ce.showOperators,this.defaultValue.showOperators),showUnits:b(ce.showUnits,this.defaultValue.showUnits),showValues:b(ce.showValues,this.defaultValue.showValues),showConstants:b(ce.showConstants,this.defaultValue.showConstants),showEnums:b(ce.showEnums,this.defaultValue.showEnums),showEnumMembers:b(ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:b(ce.showKeywords,this.defaultValue.showKeywords),showWords:b(ce.showWords,this.defaultValue.showWords),showColors:b(ce.showColors,this.defaultValue.showColors),showFiles:b(ce.showFiles,this.defaultValue.showFiles),showReferences:b(ce.showReferences,this.defaultValue.showReferences),showFolders:b(ce.showFolders,this.defaultValue.showFolders),showTypeParameters:b(ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:b(ce.showSnippets,this.defaultValue.showSnippets),showUsers:b(ce.showUsers,this.defaultValue.showUsers),showIssues:b(ce.showIssues,this.defaultValue.showIssues)}}}class Ce extends T{constructor(){super(106,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(169,null),default:!0,type:"boolean"}})}validate($){return!$||typeof $!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:b($.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ke extends v{constructor(){super(136)}compute($,ce,Ie){return ce.get(85)?!0:$.tabFocusMode}}var je;(function(ae){ae[ae.None=0]="None",ae[ae.Same=1]="Same",ae[ae.Indent=2]="Indent",ae[ae.DeepIndent=3]="DeepIndent"})(je=e.WrappingIndent||(e.WrappingIndent={}));class Ge extends T{constructor(){super(130,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[a.localize(170,null),a.localize(171,null),a.localize(172,null),a.localize(173,null)],description:a.localize(174,null),default:"same"}})}validate($){switch($){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute($,ce,Ie){return ce.get(2)===2?0:Ie}}class et extends v{constructor(){super(138)}compute($,ce,Ie){const Le=ce.get(137);return{isDominatedByLongLines:$.isDominatedByLongLines,isWordWrapMinified:Le.isWordWrapMinified,isViewportWrapping:Le.isViewportWrapping,wrappingColumn:Le.wrappingColumn}}}class _e extends T{constructor(){const $={enabled:!0};super(32,"dropIntoEditor",$,{"editor.dropIntoEditor.enabled":{type:"boolean",default:$.enabled,markdownDescription:a.localize(175,null)}})}validate($){return!$||typeof $!="object"?this.defaultValue:{enabled:b($.enabled,this.defaultValue.enabled)}}}const nt="Consolas, 'Courier New', monospace",st="Menlo, Monaco, 'Courier New', monospace",ht="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?st:t.isLinux?ht:nt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(ae){return e.editorOptionsRegistry[ae.id]=ae,ae}var it;(function(ae){ae[ae.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ae[ae.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ae[ae.accessibilitySupport=2]="accessibilitySupport",ae[ae.accessibilityPageSize=3]="accessibilityPageSize",ae[ae.ariaLabel=4]="ariaLabel",ae[ae.autoClosingBrackets=5]="autoClosingBrackets",ae[ae.autoClosingDelete=6]="autoClosingDelete",ae[ae.autoClosingOvertype=7]="autoClosingOvertype",ae[ae.autoClosingQuotes=8]="autoClosingQuotes",ae[ae.autoIndent=9]="autoIndent",ae[ae.automaticLayout=10]="automaticLayout",ae[ae.autoSurround=11]="autoSurround",ae[ae.bracketPairColorization=12]="bracketPairColorization",ae[ae.guides=13]="guides",ae[ae.codeLens=14]="codeLens",ae[ae.codeLensFontFamily=15]="codeLensFontFamily",ae[ae.codeLensFontSize=16]="codeLensFontSize",ae[ae.colorDecorators=17]="colorDecorators",ae[ae.columnSelection=18]="columnSelection",ae[ae.comments=19]="comments",ae[ae.contextmenu=20]="contextmenu",ae[ae.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",ae[ae.cursorBlinking=22]="cursorBlinking",ae[ae.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",ae[ae.cursorStyle=24]="cursorStyle",ae[ae.cursorSurroundingLines=25]="cursorSurroundingLines",ae[ae.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",ae[ae.cursorWidth=27]="cursorWidth",ae[ae.disableLayerHinting=28]="disableLayerHinting",ae[ae.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",ae[ae.domReadOnly=30]="domReadOnly",ae[ae.dragAndDrop=31]="dragAndDrop",ae[ae.dropIntoEditor=32]="dropIntoEditor",ae[ae.emptySelectionClipboard=33]="emptySelectionClipboard",ae[ae.experimentalWhitespaceRendering=34]="experimentalWhitespaceRendering",ae[ae.extraEditorClassName=35]="extraEditorClassName",ae[ae.fastScrollSensitivity=36]="fastScrollSensitivity",ae[ae.find=37]="find",ae[ae.fixedOverflowWidgets=38]="fixedOverflowWidgets",ae[ae.folding=39]="folding",ae[ae.foldingStrategy=40]="foldingStrategy",ae[ae.foldingHighlight=41]="foldingHighlight",ae[ae.foldingImportsByDefault=42]="foldingImportsByDefault",ae[ae.foldingMaximumRegions=43]="foldingMaximumRegions",ae[ae.unfoldOnClickAfterEndOfLine=44]="unfoldOnClickAfterEndOfLine",ae[ae.fontFamily=45]="fontFamily",ae[ae.fontInfo=46]="fontInfo",ae[ae.fontLigatures=47]="fontLigatures",ae[ae.fontSize=48]="fontSize",ae[ae.fontWeight=49]="fontWeight",ae[ae.fontVariations=50]="fontVariations",ae[ae.formatOnPaste=51]="formatOnPaste",ae[ae.formatOnType=52]="formatOnType",ae[ae.glyphMargin=53]="glyphMargin",ae[ae.gotoLocation=54]="gotoLocation",ae[ae.hideCursorInOverviewRuler=55]="hideCursorInOverviewRuler",ae[ae.hover=56]="hover",ae[ae.inDiffEditor=57]="inDiffEditor",ae[ae.inlineSuggest=58]="inlineSuggest",ae[ae.letterSpacing=59]="letterSpacing",ae[ae.lightbulb=60]="lightbulb",ae[ae.lineDecorationsWidth=61]="lineDecorationsWidth",ae[ae.lineHeight=62]="lineHeight",ae[ae.lineNumbers=63]="lineNumbers",ae[ae.lineNumbersMinChars=64]="lineNumbersMinChars",ae[ae.linkedEditing=65]="linkedEditing",ae[ae.links=66]="links",ae[ae.matchBrackets=67]="matchBrackets",ae[ae.minimap=68]="minimap",ae[ae.mouseStyle=69]="mouseStyle",ae[ae.mouseWheelScrollSensitivity=70]="mouseWheelScrollSensitivity",ae[ae.mouseWheelZoom=71]="mouseWheelZoom",ae[ae.multiCursorMergeOverlapping=72]="multiCursorMergeOverlapping",ae[ae.multiCursorModifier=73]="multiCursorModifier",ae[ae.multiCursorPaste=74]="multiCursorPaste",ae[ae.multiCursorLimit=75]="multiCursorLimit",ae[ae.occurrencesHighlight=76]="occurrencesHighlight",ae[ae.overviewRulerBorder=77]="overviewRulerBorder",ae[ae.overviewRulerLanes=78]="overviewRulerLanes",ae[ae.padding=79]="padding",ae[ae.parameterHints=80]="parameterHints",ae[ae.peekWidgetDefaultFocus=81]="peekWidgetDefaultFocus",ae[ae.definitionLinkOpensInPeek=82]="definitionLinkOpensInPeek",ae[ae.quickSuggestions=83]="quickSuggestions",ae[ae.quickSuggestionsDelay=84]="quickSuggestionsDelay",ae[ae.readOnly=85]="readOnly",ae[ae.renameOnType=86]="renameOnType",ae[ae.renderControlCharacters=87]="renderControlCharacters",ae[ae.renderFinalNewline=88]="renderFinalNewline",ae[ae.renderLineHighlight=89]="renderLineHighlight",ae[ae.renderLineHighlightOnlyWhenFocus=90]="renderLineHighlightOnlyWhenFocus",ae[ae.renderValidationDecorations=91]="renderValidationDecorations",ae[ae.renderWhitespace=92]="renderWhitespace",ae[ae.revealHorizontalRightPadding=93]="revealHorizontalRightPadding",ae[ae.roundedSelection=94]="roundedSelection",ae[ae.rulers=95]="rulers",ae[ae.scrollbar=96]="scrollbar",ae[ae.scrollBeyondLastColumn=97]="scrollBeyondLastColumn",ae[ae.scrollBeyondLastLine=98]="scrollBeyondLastLine",ae[ae.scrollPredominantAxis=99]="scrollPredominantAxis",ae[ae.selectionClipboard=100]="selectionClipboard",ae[ae.selectionHighlight=101]="selectionHighlight",ae[ae.selectOnLineNumbers=102]="selectOnLineNumbers",ae[ae.showFoldingControls=103]="showFoldingControls",ae[ae.showUnused=104]="showUnused",ae[ae.snippetSuggestions=105]="snippetSuggestions",ae[ae.smartSelect=106]="smartSelect",ae[ae.smoothScrolling=107]="smoothScrolling",ae[ae.stickyScroll=108]="stickyScroll",ae[ae.stickyTabStops=109]="stickyTabStops",ae[ae.stopRenderingLineAfter=110]="stopRenderingLineAfter",ae[ae.suggest=111]="suggest",ae[ae.suggestFontSize=112]="suggestFontSize",ae[ae.suggestLineHeight=113]="suggestLineHeight",ae[ae.suggestOnTriggerCharacters=114]="suggestOnTriggerCharacters",ae[ae.suggestSelection=115]="suggestSelection",ae[ae.tabCompletion=116]="tabCompletion",ae[ae.tabIndex=117]="tabIndex",ae[ae.unicodeHighlighting=118]="unicodeHighlighting",ae[ae.unusualLineTerminators=119]="unusualLineTerminators",ae[ae.useShadowDOM=120]="useShadowDOM",ae[ae.useTabStops=121]="useTabStops",ae[ae.wordBreak=122]="wordBreak",ae[ae.wordSeparators=123]="wordSeparators",ae[ae.wordWrap=124]="wordWrap",ae[ae.wordWrapBreakAfterCharacters=125]="wordWrapBreakAfterCharacters",ae[ae.wordWrapBreakBeforeCharacters=126]="wordWrapBreakBeforeCharacters",ae[ae.wordWrapColumn=127]="wordWrapColumn",ae[ae.wordWrapOverride1=128]="wordWrapOverride1",ae[ae.wordWrapOverride2=129]="wordWrapOverride2",ae[ae.wrappingIndent=130]="wrappingIndent",ae[ae.wrappingStrategy=131]="wrappingStrategy",ae[ae.showDeprecated=132]="showDeprecated",ae[ae.inlayHints=133]="inlayHints",ae[ae.editorClassName=134]="editorClassName",ae[ae.pixelRatio=135]="pixelRatio",ae[ae.tabFocusMode=136]="tabFocusMode",ae[ae.layoutInfo=137]="layoutInfo",ae[ae.wrappingInfo=138]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(176,null)})),acceptSuggestionOnEnter:Fe(new i(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(177,null),""],markdownDescription:a.localize(178,null)})),accessibilitySupport:Fe(new s),accessibilityPageSize:Fe(new h(3,"accessibilityPageSize",10,1,1073741824,{description:a.localize(179,null),tags:["accessibility"]})),ariaLabel:Fe(new p(4,"ariaLabel",a.localize(180,null))),autoClosingBrackets:Fe(new i(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(181,null),a.localize(182,null),""],description:a.localize(183,null)})),autoClosingDelete:Fe(new i(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(184,null),""],description:a.localize(185,null)})),autoClosingOvertype:Fe(new i(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(186,null),""],description:a.localize(187,null)})),autoClosingQuotes:Fe(new i(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(188,null),a.localize(189,null),""],description:a.localize(190,null)})),autoIndent:Fe(new l(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[a.localize(191,null),a.localize(192,null),a.localize(193,null),a.localize(194,null),a.localize(195,null)],description:a.localize(196,null)})),automaticLayout:Fe(new f(10,"automaticLayout",!1)),autoSurround:Fe(new i(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(197,null),a.localize(198,null),a.localize(199,null),""],description:a.localize(200,null)})),bracketPairColorization:Fe(new de),bracketPairGuides:Fe(new be),stickyTabStops:Fe(new f(109,"stickyTabStops",!1,{description:a.localize(201,null)})),codeLens:Fe(new f(14,"codeLens",!0,{description:a.localize(202,null)})),codeLensFontFamily:Fe(new p(15,"codeLensFontFamily","",{description:a.localize(203,null)})),codeLensFontSize:Fe(new h(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(204,null)})),colorDecorators:Fe(new f(17,"colorDecorators",!0,{description:a.localize(205,null)})),columnSelection:Fe(new f(18,"columnSelection",!1,{description:a.localize(206,null)})),comments:Fe(new c),contextmenu:Fe(new f(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new f(21,"copyWithSyntaxHighlighting",!0,{description:a.localize(207,null)})),cursorBlinking:Fe(new l(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:a.localize(208,null)})),cursorSmoothCaretAnimation:Fe(new f(23,"cursorSmoothCaretAnimation",!1,{description:a.localize(209,null)})),cursorStyle:Fe(new l(24,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:a.localize(210,null)})),cursorSurroundingLines:Fe(new h(25,"cursorSurroundingLines",0,0,1073741824,{description:a.localize(211,null)})),cursorSurroundingLinesStyle:Fe(new i(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(212,null),a.localize(213,null)],description:a.localize(214,null)})),cursorWidth:Fe(new h(27,"cursorWidth",0,0,1073741824,{markdownDescription:a.localize(215,null)})),disableLayerHinting:Fe(new f(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new f(29,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new f(30,"domReadOnly",!1)),dragAndDrop:Fe(new f(31,"dragAndDrop",!0,{description:a.localize(216,null)})),emptySelectionClipboard:Fe(new _),dropIntoEditor:Fe(new _e),stickyScroll:Fe(new te),experimentalWhitespaceRendering:Fe(new i(34,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[a.localize(217,null),a.localize(218,null),a.localize(219,null)],description:a.localize(220,null)})),extraEditorClassName:Fe(new p(35,"extraEditorClassName","")),fastScrollSensitivity:Fe(new m(36,"fastScrollSensitivity",5,ae=>ae<=0?5:ae,{markdownDescription:a.localize(221,null)})),find:Fe(new K),fixedOverflowWidgets:Fe(new f(38,"fixedOverflowWidgets",!1)),folding:Fe(new f(39,"folding",!0,{description:a.localize(222,null)})),foldingStrategy:Fe(new i(40,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(223,null),a.localize(224,null)],description:a.localize(225,null)})),foldingHighlight:Fe(new f(41,"foldingHighlight",!0,{description:a.localize(226,null)})),foldingImportsByDefault:Fe(new f(42,"foldingImportsByDefault",!1,{description:a.localize(227,null)})),foldingMaximumRegions:Fe(new h(43,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(228,null)})),unfoldOnClickAfterEndOfLine:Fe(new f(44,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(229,null)})),fontFamily:Fe(new p(45,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(230,null)})),fontInfo:Fe(new N),fontLigatures2:Fe(new F),fontSize:Fe(new B),fontWeight:Fe(new U),fontVariations:Fe(new M),formatOnPaste:Fe(new f(51,"formatOnPaste",!1,{description:a.localize(231,null)})),formatOnType:Fe(new f(52,"formatOnType",!1,{description:a.localize(232,null)})),glyphMargin:Fe(new f(53,"glyphMargin",!0,{description:a.localize(233,null)})),gotoLocation:Fe(new W),hideCursorInOverviewRuler:Fe(new f(55,"hideCursorInOverviewRuler",!1,{description:a.localize(234,null)})),hover:Fe(new x),inDiffEditor:Fe(new f(57,"inDiffEditor",!1)),letterSpacing:Fe(new m(59,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ae=>m.clamp(ae,-5,20),{description:a.localize(235,null)})),lightbulb:Fe(new J),lineDecorationsWidth:Fe(new Z),lineHeight:Fe(new ge),lineNumbers:Fe(new ee),lineNumbersMinChars:Fe(new h(64,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new f(65,"linkedEditing",!1,{description:a.localize(236,null)})),links:Fe(new f(66,"links",!0,{description:a.localize(237,null)})),matchBrackets:Fe(new i(67,"matchBrackets","always",["always","near","never"],{description:a.localize(238,null)})),minimap:Fe(new ve),mouseStyle:Fe(new i(69,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new m(70,"mouseWheelScrollSensitivity",1,ae=>ae===0?1:ae,{markdownDescription:a.localize(239,null)})),mouseWheelZoom:Fe(new f(71,"mouseWheelZoom",!1,{markdownDescription:a.localize(240,null)})),multiCursorMergeOverlapping:Fe(new f(72,"multiCursorMergeOverlapping",!0,{description:a.localize(241,null)})),multiCursorModifier:Fe(new l(73,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],De,{markdownEnumDescriptions:[a.localize(242,null),a.localize(243,null)],markdownDescription:a.localize(244,null)})),multiCursorPaste:Fe(new i(74,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(245,null),a.localize(246,null)],markdownDescription:a.localize(247,null)})),multiCursorLimit:Fe(new h(75,"multiCursorLimit",1e4,1,1e5,{markdownDescription:a.localize(248,null)})),occurrencesHighlight:Fe(new f(76,"occurrencesHighlight",!0,{description:a.localize(249,null)})),overviewRulerBorder:Fe(new f(77,"overviewRulerBorder",!0,{description:a.localize(250,null)})),overviewRulerLanes:Fe(new h(78,"overviewRulerLanes",3,0,3)),padding:Fe(new Re),parameterHints:Fe(new ze),peekWidgetDefaultFocus:Fe(new i(81,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(251,null),a.localize(252,null)],description:a.localize(253,null)})),definitionLinkOpensInPeek:Fe(new f(82,"definitionLinkOpensInPeek",!1,{description:a.localize(254,null)})),quickSuggestions:Fe(new ue),quickSuggestionsDelay:Fe(new h(84,"quickSuggestionsDelay",10,0,1073741824,{description:a.localize(255,null)})),readOnly:Fe(new f(85,"readOnly",!1)),renameOnType:Fe(new f(86,"renameOnType",!1,{description:a.localize(256,null),markdownDeprecationMessage:a.localize(257,null)})),renderControlCharacters:Fe(new f(87,"renderControlCharacters",!0,{description:a.localize(258,null),restricted:!0})),renderFinalNewline:Fe(new i(88,"renderFinalNewline",t.isLinux?"dimmed":"on",["off","on","dimmed"],{description:a.localize(259,null)})),renderLineHighlight:Fe(new i(89,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(260,null)],description:a.localize(261,null)})),renderLineHighlightOnlyWhenFocus:Fe(new f(90,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(262,null)})),renderValidationDecorations:Fe(new i(91,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new i(92,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(263,null),a.localize(264,null),a.localize(265,null),""],description:a.localize(266,null)})),revealHorizontalRightPadding:Fe(new h(93,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new f(94,"roundedSelection",!0,{description:a.localize(267,null)})),rulers:Fe(new ie),scrollbar:Fe(new H),scrollBeyondLastColumn:Fe(new h(97,"scrollBeyondLastColumn",4,0,1073741824,{description:a.localize(268,null)})),scrollBeyondLastLine:Fe(new f(98,"scrollBeyondLastLine",!0,{description:a.localize(269,null)})),scrollPredominantAxis:Fe(new f(99,"scrollPredominantAxis",!0,{description:a.localize(270,null)})),selectionClipboard:Fe(new f(100,"selectionClipboard",!0,{description:a.localize(271,null),included:t.isLinux})),selectionHighlight:Fe(new f(101,"selectionHighlight",!0,{description:a.localize(272,null)})),selectOnLineNumbers:Fe(new f(102,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new i(103,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(273,null),a.localize(274,null),a.localize(275,null)],description:a.localize(276,null)})),showUnused:Fe(new f(104,"showUnused",!0,{description:a.localize(277,null)})),showDeprecated:Fe(new f(132,"showDeprecated",!0,{description:a.localize(278,null)})),inlayHints:Fe(new le),snippetSuggestions:Fe(new i(105,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(279,null),a.localize(280,null),a.localize(281,null),a.localize(282,null)],description:a.localize(283,null)})),smartSelect:Fe(new Ce),smoothScrolling:Fe(new f(107,"smoothScrolling",!1,{description:a.localize(284,null)})),stopRenderingLineAfter:Fe(new h(110,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new pe),inlineSuggest:Fe(new Y),suggestFontSize:Fe(new h(112,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(285,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new h(113,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(286,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new f(114,"suggestOnTriggerCharacters",!0,{description:a.localize(287,null)})),suggestSelection:Fe(new i(115,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(288,null),a.localize(289,null),a.localize(290,null)],description:a.localize(291,null)})),tabCompletion:Fe(new i(116,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(292,null),a.localize(293,null),a.localize(294,null)],description:a.localize(295,null)})),tabIndex:Fe(new h(117,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new q),unusualLineTerminators:Fe(new i(119,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(296,null),a.localize(297,null),a.localize(298,null)],description:a.localize(299,null)})),useShadowDOM:Fe(new f(120,"useShadowDOM",!0)),useTabStops:Fe(new f(121,"useTabStops",!0,{description:a.localize(300,null)})),wordBreak:Fe(new i(122,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[a.localize(301,null),a.localize(302,null)],description:a.localize(303,null)})),wordSeparators:Fe(new p(123,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:a.localize(304,null)})),wordWrap:Fe(new i(124,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(305,null),a.localize(306,null),a.localize(307,null),a.localize(308,null)],description:a.localize(309,null)})),wordWrapBreakAfterCharacters:Fe(new p(125,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new p(126,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new h(127,"wordWrapColumn",80,1,1073741824,{markdownDescription:a.localize(310,null)})),wordWrapOverride1:Fe(new i(128,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new i(129,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new z),pixelRatio:Fe(new se),tabFocusMode:Fe(new ke),layoutInfo:Fe(new X),wrappingInfo:Fe(new et),wrappingIndent:Fe(new Ge),wrappingStrategy:Fe(new Q)}}),define(Se[166],ye([19,20]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[167],ye([19,20]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[168],ye([19,20]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[169],ye([19,20]),function(ne,e){return ne.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[170],ye([19,20]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(Se[171],ye([19,20]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(Se[172],ye([19,20]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(Se[173],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[174],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[175],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(Se[176],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[177],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[178],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[179],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[180],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[181],ye([19,20]),function(ne,e){return ne.create("vs/workbench/api/node/extHostTunnelService",e)}),define(Se[182],ye([19,20]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(Se[183],ye([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[184],ye([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[185],ye([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[186],ye([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[187],ye([19,20]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[188],ye([19,20]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[189],ye([19,20]),function(ne,e){return ne.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[190],ye([19,20]),function(ne,e){return ne.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[191],ye([1,0,10]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(A,D){this.a.set(A,D)}updateManifest(A){if(!(typeof A.main>"u"&&typeof A.browser>"u")&&(A.activationEvents===void 0&&Object.assign(A,{activationEvents:[]}),!(!Array.isArray(A.activationEvents)||!A.contributes)))for(const D in A.contributes){const k=this.a.get(D);if(!k)continue;const S=A.contributes[D],C=Array.isArray(S)?S:[S];try{k(C,A.activationEvents)}catch(R){(0,a.onUnexpectedError)(R)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(Se[192],ye([1,0,24,42,168,310]),function(ne,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function S(f){return f=f.trim(),f==="*"||D.test(f)}e.isValidVersionStr=S;function C(f){if(!S(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const w=f.match(D);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}e.parseVersion=C;function R(f){if(!f)return null;const w=f.majorBase,h=f.majorMustEqual,m=f.minorBase;let p=f.minorMustEqual;const o=f.patchBase;let i=f.patchMustEqual;f.hasCaret&&(w===0||(p=!1),i=!1);let l=0;if(f.preRelease){const u=k.exec(f.preRelease);if(u){const[,s,c,n]=u;l=Date.UTC(Number(s),Number(c)-1,Number(n))}}return{majorBase:w,majorMustEqual:h,minorBase:m,minorMustEqual:p,patchBase:o,patchMustEqual:i,isMinimum:f.hasGreaterEquals,notBefore:l}}e.normalizeVersion=R;function T(f,w,h){let m;typeof f=="string"?m=R(C(f)):m=f;let p;w instanceof Date?p=w.getTime():typeof w=="string"&&(p=new Date(w).getTime());let o;if(typeof h=="string"?o=R(C(h)):o=h,!m||!o)return!1;const i=m.majorBase,l=m.minorBase,u=m.patchBase;let s=o.majorBase,c=o.minorBase,n=o.patchBase;const r=o.notBefore;let g=o.majorMustEqual,P=o.minorMustEqual,L=o.patchMustEqual;return o.isMinimum?i>s?!0:i<s?!1:l>c?!0:l<c||p&&p<r?!1:u>=n:(i===1&&s===0&&(!g||!P||!L)&&(s=1,c=0,n=0,g=!0,P=!1,L=!1),i<s?!1:i>s?!g:l<c?!1:l>c?!P:u<n?!1:u>n?!L:!(p&&p<r))}e.isValidVersion=T;function E(f,w,h,m,p){const o=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return o.push([t.default.Error,I.localize(0,null)]),o;if(typeof m.name!="string")return o.push([t.default.Error,I.localize(1,null,"name")]),o;if(typeof m.version!="string")return o.push([t.default.Error,I.localize(2,null,"version")]),o;if(!m.engines)return o.push([t.default.Error,I.localize(3,null,"engines")]),o;if(typeof m.engines.vscode!="string")return o.push([t.default.Error,I.localize(4,null,"engines.vscode")]),o;if(typeof m.extensionDependencies<"u"&&!b(m.extensionDependencies))return o.push([t.default.Error,I.localize(5,null,"extensionDependencies")]),o;if(typeof m.activationEvents<"u"){if(!b(m.activationEvents))return o.push([t.default.Error,I.localize(6,null,"activationEvents")]),o;if(typeof m.main>"u"&&typeof m.browser>"u")return o.push([t.default.Error,I.localize(7,null,"activationEvents","main")]),o}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&o.push([t.default.Warning,I.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return o.push([t.default.Error,I.localize(9,null,"main")]),o;{const u=(0,a.joinPath)(h,m.main);(0,a.isEqualOrParent)(u,h)||o.push([t.default.Warning,I.localize(10,null,u.path,h.path)])}if(typeof m.activationEvents>"u")return o.push([t.default.Error,I.localize(11,null,"activationEvents","main")]),o}if(typeof m.browser<"u"){if(typeof m.browser!="string")return o.push([t.default.Error,I.localize(12,null,"browser")]),o;{const u=(0,a.joinPath)(h,m.browser);(0,a.isEqualOrParent)(u,h)||o.push([t.default.Warning,I.localize(13,null,u.path,h.path)])}if(typeof m.activationEvents>"u")return o.push([t.default.Error,I.localize(14,null,"activationEvents","browser")]),o}if(!A.valid(m.version))return o.push([t.default.Error,I.localize(15,null)]),o;const i=[];if(!y(f,w,m,p,i))for(const u of i)o.push([t.default.Error,u]);return o}e.validateExtensionManifest=E;function y(f,w,h,m,p){return m||typeof h.main>"u"&&typeof h.browser>"u"?!0:d(f,w,h.engines.vscode,p)}e.isValidExtensionVersion=y;function v(f,w,h){return f==="*"||d(w,h,f)}e.isEngineValid=v;function d(f,w,h,m=[]){const p=R(C(h));if(!p)return m.push(I.localize(16,null,h)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return m.push(I.localize(17,null,h)),!1}else if(!p.majorMustEqual)return m.push(I.localize(18,null,h)),!1;return T(f,w,p)?!0:(m.push(I.localize(19,null,f,h)),!1)}function b(f){if(!Array.isArray(f))return!1;for(let w=0,h=f.length;w<h;w++)if(typeof f[w]!="string")return!1;return!0}}),define(Se[120],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class a{constructor(I,A=[],D=!1){this.ctor=I,this.staticArguments=A,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=a}),define(Se[87],ye([1,0,120]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var I;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(I=e.InstantiationType||(e.InstantiationType={}));function A(k,S,C){S instanceof a.SyncDescriptor||(S=new a.SyncDescriptor(S,[],Boolean(C))),t.push([k,S])}e.registerSingleton=A;function D(){return t}e.getSingletonServiceDescriptors=D}),define(Se[193],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class a{constructor(A,D){this.key=A,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=a;class t{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const D of this.a.values())D.outgoing.size===0&&A.push(D);return A}insertEdge(A,D){const k=this.lookupOrInsertNode(A),S=this.lookupOrInsertNode(D);k.outgoing.set(S.key,S),S.incoming.set(k.key,k)}removeNode(A){const D=this.b(A);this.a.delete(D);for(const k of this.a.values())k.outgoing.delete(D),k.incoming.delete(D)}lookupOrInsertNode(A){const D=this.b(A);let k=this.a.get(D);return k||(k=new a(D,A),this.a.set(D,k)),k}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[D,k]of this.a)A.push(`${D}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,D]of this.a){const k=new Set([A]),S=this.c(D,k);if(S)return S}}c(A,D){for(const[k,S]of A.outgoing){if(D.has(k))return[...D,k].join(" -> ");D.add(k);const C=this.c(S,D);if(C)return C;D.delete(k)}}}e.Graph=t}),define(Se[3],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var a;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function k(S){return S[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=k})(a=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function t(D,k,S){k[a.DI_TARGET]===k?k[a.DI_DEPENDENCIES].push({id:D,index:S}):(k[a.DI_DEPENDENCIES]=[{id:D,index:S}],k[a.DI_TARGET]=k)}function I(D){if(a.serviceIds.has(D))return a.serviceIds.get(D);const k=function(S,C,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(k,S,R)};return k.toString=()=>D,a.serviceIds.set(D,k),k}e.createDecorator=I;function A(D){return D}e.refineServiceDecorator=A}),define(Se[52],ye([1,0,11,2,3]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function A(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof t.URI)}e.isConfigurationOverrides=A;function D(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=D;var k;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function C(f,w){const h=Object.create(null);for(const m in f)R(h,m,f[m],w);return h}e.toValuesTree=C;function R(f,w,h,m){const p=w.split("."),o=p.pop();let i=f;for(let l=0;l<p.length;l++){const u=p[l];let s=i[u];switch(typeof s){case"undefined":s=i[u]=Object.create(null);break;case"object":break;default:m(`Ignoring ${w} as ${p.slice(0,l+1).join(".")} is ${JSON.stringify(s)}`);return}i=s}if(typeof i=="object"&&i!==null)try{i[o]=h}catch{m(`Ignoring ${w} as ${p.join(".")} is ${JSON.stringify(i)}`)}else m(`Ignoring ${w} as ${p.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=R;function T(f,w){const h=w.split(".");E(f,h)}e.removeFromValueTree=T;function E(f,w){const h=w.shift();if(w.length===0){delete f[h];return}if(Object.keys(f).indexOf(h)!==-1){const m=f[h];typeof m=="object"&&!Array.isArray(m)&&(E(m,w),Object.keys(m).length===0&&delete f[h])}}function y(f,w,h){function m(i,l){let u=i;for(const s of l){if(typeof u!="object"||u===null)return;u=u[s]}return u}const p=w.split("."),o=m(f,p);return typeof o>"u"?h:o}e.getConfigurationValue=y;function v(f,w,h){Object.keys(w).forEach(m=>{m!=="__proto__"&&(m in f?a.isObject(f[m])&&a.isObject(w[m])?v(f[m],w[m],h):h&&(f[m]=w[m]):f[m]=w[m])})}e.merge=v;function d(f,w,h){const m=f.inspect(w),p=f.inspect(h);return typeof m.userValue<"u"||typeof m.workspaceValue<"u"||typeof m.workspaceFolderValue<"u"?m.value:typeof p.userValue<"u"||typeof p.workspaceValue<"u"||typeof p.workspaceFolderValue<"u"?p.value:m.defaultValue}e.getMigratedSettingValue=d;function b(f){return f.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=b}),define(Se[53],ye([1,0,12,8,3]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",a.isMacintosh),A.set("isLinux",a.isLinux),A.set("isWindows",a.isWindows),A.set("isWeb",a.isWeb),A.set("isMacNative",a.isMacintosh&&!a.isWeb),A.set("isEdge",a.isEdge),A.set("isFirefox",a.isFirefox),A.set("isChrome",a.isChrome),A.set("isSafari",a.isSafari);const D=Object.prototype.hasOwnProperty;var k;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(k=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return T.INSTANCE}static true(){return E.INSTANCE}static has(F){return y.create(F)}static equals(F,M){return v.create(F,M)}static notEquals(F,M){return f.create(F,M)}static regex(F,M){return l.create(F,M)}static in(F,M){return d.create(F,M)}static notIn(F,M){return b.create(F,M)}static not(F){return w.create(F)}static and(...F){return c.create(F,null,!0)}static or(...F){return n.create(F,null,!0)}static greater(F,M){return m.create(F,M)}static greaterEquals(F,M){return p.create(F,M)}static smaller(F,M){return o.create(F,M)}static smallerEquals(F,M){return i.create(F,M)}static deserialize(F,M=!1){if(!!F)return this.c(F,M)}static c(F,M){const N=F.split("||");return n.create(N.map(B=>this.d(B,M)),null,!0)}static d(F,M){const N=F.split("&&");return c.create(N.map(B=>this.f(B,M)),null,!0)}static f(F,M){if(F=F.trim(),F.indexOf("!=")>=0){const N=F.split("!=");return f.create(N[0].trim(),this.g(N[1],M))}if(F.indexOf("==")>=0){const N=F.split("==");return v.create(N[0].trim(),this.g(N[1],M))}if(F.indexOf("=~")>=0){const N=F.split("=~");return l.create(N[0].trim(),this.h(N[1],M))}if(F.indexOf(" not in ")>=0){const N=F.split(" not in ");return b.create(N[0].trim(),this.g(N[1],M))}if(F.indexOf(" in ")>=0){const N=F.split(" in ");return d.create(N[0].trim(),this.g(N[1],M))}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const N=F.split(">=");return p.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const N=F.split(">");return m.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const N=F.split("<=");return i.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const N=F.split("<");return o.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(F)?w.create(F.substr(1).trim()):y.create(F)}static g(F,M){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;const N=/^'([^']*)'$/.exec(F);return N?N[1].trim():F}static h(F,M){if((0,t.isFalsyOrWhitespace)(F)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const N=F.indexOf("/"),B=F.lastIndexOf("/");if(N===B||N<0){if(M)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}const U=F.slice(N+1,B),W=F[B+1]==="i"?"i":"";try{return new RegExp(U,W)}catch(x){if(M)throw new Error(`bad regexp-value '${F}', parse error: ${x}`);return console.warn(`bad regexp-value '${F}', parse error: ${x}`),null}}}e.ContextKeyExpr=S;function C(K,F){const M=K?K.substituteConstants():void 0,N=F?F.substituteConstants():void 0;return!M&&!N?!0:!M||!N?!1:M.equals(N)}e.expressionsAreEqualWithConstantSubstitution=C;function R(K,F){return K.cmp(F)}class T{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=T,T.INSTANCE=new T;class E{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return T.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class y{static create(F,M=null){const N=A.get(F);return typeof N=="boolean"?N?E.INSTANCE:T.INSTANCE:new y(F,M)}constructor(F,M){this.key=F,this.c=M,this.type=2}cmp(F){return F.type!==this.type?this.type-F.type:g(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=A.get(this.key);return typeof F=="boolean"?F?E.INSTANCE:T.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.c||(this.c=w.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=y;class v{static create(F,M,N=null){if(typeof M=="boolean")return M?y.create(F,N):w.create(F,N);const B=A.get(F);return typeof B=="boolean"?M===(B?"true":"false")?E.INSTANCE:T.INSTANCE:new v(F,M,N)}constructor(F,M,N){this.c=F,this.d=M,this.f=N,this.type=4}cmp(F){return F.type!==this.type?this.type-F.type:P(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=A.get(this.c);if(typeof F=="boolean"){const M=F?"true":"false";return this.d===M?E.INSTANCE:T.INSTANCE}return this}evaluate(F){return F.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(F){return F.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=v;class d{static create(F,M){return new d(F,M)}constructor(F,M){this.d=F,this.f=M,this.type=10,this.c=null}cmp(F){return F.type!==this.type?this.type-F.type:P(this.d,this.f,F.d,F.f)}equals(F){return F.type===this.type?this.d===F.d&&this.f===F.f:!1}substituteConstants(){return this}evaluate(F){const M=F.getValue(this.f),N=F.getValue(this.d);return Array.isArray(M)?M.includes(N):typeof N=="string"&&typeof M=="object"&&M!==null?D.call(M,N):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(F){return F.mapIn(this.d,this.f)}negate(){return this.c||(this.c=b.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=d;class b{static create(F,M){return new b(F,M)}constructor(F,M){this.d=F,this.f=M,this.type=11,this.c=d.create(F,M)}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(F){return F.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=b;class f{static create(F,M,N=null){if(typeof M=="boolean")return M?w.create(F,N):y.create(F,N);const B=A.get(F);return typeof B=="boolean"?M===(B?"true":"false")?T.INSTANCE:E.INSTANCE:new f(F,M,N)}constructor(F,M,N){this.c=F,this.d=M,this.f=N,this.type=5}cmp(F){return F.type!==this.type?this.type-F.type:P(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=A.get(this.c);if(typeof F=="boolean"){const M=F?"true":"false";return this.d===M?T.INSTANCE:E.INSTANCE}return this}evaluate(F){return F.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(F){return F.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=f;class w{static create(F,M=null){const N=A.get(F);return typeof N=="boolean"?N?T.INSTANCE:E.INSTANCE:new w(F,M)}constructor(F,M){this.c=F,this.d=M,this.type=3}cmp(F){return F.type!==this.type?this.type-F.type:g(this.c,F.c)}equals(F){return F.type===this.type?this.c===F.c:!1}substituteConstants(){const F=A.get(this.c);return typeof F=="boolean"?F?T.INSTANCE:E.INSTANCE:this}evaluate(F){return!F.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(F){return F.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.ContextKeyNotExpr=w;function h(K,F){if(typeof K=="string"){const M=parseFloat(K);isNaN(M)||(K=M)}return typeof K=="string"||typeof K=="number"?F(K):T.INSTANCE}class m{static create(F,M,N=null){return h(M,B=>new m(F,B,N))}constructor(F,M,N){this.c=F,this.d=M,this.f=N,this.type=12}cmp(F){return F.type!==this.type?this.type-F.type:P(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=m;class p{static create(F,M,N=null){return h(M,B=>new p(F,B,N))}constructor(F,M,N){this.c=F,this.d=M,this.f=N,this.type=13}cmp(F){return F.type!==this.type?this.type-F.type:P(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=o.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=p;class o{static create(F,M,N=null){return h(M,B=>new o(F,B,N))}constructor(F,M,N){this.c=F,this.d=M,this.f=N,this.type=14}cmp(F){return F.type!==this.type?this.type-F.type:P(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=o;class i{static create(F,M,N=null){return h(M,B=>new i(F,B,N))}constructor(F,M,N){this.c=F,this.d=M,this.f=N,this.type=15}cmp(F){return F.type!==this.type?this.type-F.type:P(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=m.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=i;class l{static create(F,M){return new l(F,M)}constructor(F,M){this.d=F,this.f=M,this.type=7,this.c=null}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.d<F.d)return-1;if(this.d>F.d)return 1;const M=this.f?this.f.source:"",N=F.f?F.f.source:"";return M<N?-1:M>N?1:0}equals(F){if(F.type===this.type){const M=this.f?this.f.source:"",N=F.f?F.f.source:"";return this.d===F.d&&M===N}return!1}substituteConstants(){return this}evaluate(F){const M=F.getValue(this.d);return this.f?this.f.test(M):!1}serialize(){const F=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${F}`}keys(){return[this.d]}map(F){return F.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=u.create(this)),this.c}}e.ContextKeyRegexExpr=l;class u{static create(F){return new u(F)}constructor(F){this.c=F,this.type=8}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(F){return new u(this.c.map(F))}negate(){return this.c}}e.ContextKeyNotRegexExpr=u;function s(K){let F=null;for(let M=0,N=K.length;M<N;M++){const B=K[M].substituteConstants();if(K[M]!==B&&F===null){F=[];for(let U=0;U<M;U++)F[U]=K[U]}F!==null&&(F[M]=B)}return F===null?K:F}class c{static create(F,M,N){return c.d(F,M,N)}constructor(F,M){this.expr=F,this.c=M,this.type=6}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let M=0,N=this.expr.length;M<N;M++){const B=R(this.expr[M],F.expr[M]);if(B!==0)return B}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let M=0,N=this.expr.length;M<N;M++)if(!this.expr[M].equals(F.expr[M]))return!1;return!0}return!1}substituteConstants(){const F=s(this.expr);return F===this.expr?this:c.create(F,this.c,!1)}evaluate(F){for(let M=0,N=this.expr.length;M<N;M++)if(!this.expr[M].evaluate(F))return!1;return!0}static d(F,M,N){const B=[];let U=!1;for(const W of F)if(!!W){if(W.type===1){U=!0;continue}if(W.type===0)return T.INSTANCE;if(W.type===6){B.push(...W.expr);continue}B.push(W)}if(B.length===0&&U)return E.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(R);for(let W=1;W<B.length;W++)B[W-1].equals(B[W])&&(B.splice(W,1),W--);if(B.length===1)return B[0];for(;B.length>1;){const W=B[B.length-1];if(W.type!==9)break;B.pop();const x=B.pop(),V=B.length===0,X=n.create(W.expr.map(Q=>c.create([Q,x],null,N)),null,V);X&&(B.push(X),B.sort(R))}if(B.length===1)return B[0];if(N){for(let W=0;W<B.length;W++)for(let x=W+1;x<B.length;x++)if(B[W].negate().equals(B[x]))return T.INSTANCE;if(B.length===1)return B[0]}return new c(B,M)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const M of this.expr)F.push(...M.keys());return F}map(F){return new c(this.expr.map(M=>M.map(F)),null)}negate(){if(!this.c){const F=[];for(const M of this.expr)F.push(M.negate());this.c=n.create(F,this,!0)}return this.c}}class n{static create(F,M,N){return n.d(F,M,N)}constructor(F,M){this.expr=F,this.c=M,this.type=9}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let M=0,N=this.expr.length;M<N;M++){const B=R(this.expr[M],F.expr[M]);if(B!==0)return B}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let M=0,N=this.expr.length;M<N;M++)if(!this.expr[M].equals(F.expr[M]))return!1;return!0}return!1}substituteConstants(){const F=s(this.expr);return F===this.expr?this:n.create(F,this.c,!1)}evaluate(F){for(let M=0,N=this.expr.length;M<N;M++)if(this.expr[M].evaluate(F))return!0;return!1}static d(F,M,N){let B=[],U=!1;if(F){for(let W=0,x=F.length;W<x;W++){const V=F[W];if(!!V){if(V.type===0){U=!0;continue}if(V.type===1)return E.INSTANCE;if(V.type===9){B=B.concat(V.expr);continue}B.push(V)}}if(B.length===0&&U)return T.INSTANCE;B.sort(R)}if(B.length!==0){if(B.length===1)return B[0];for(let W=1;W<B.length;W++)B[W-1].equals(B[W])&&(B.splice(W,1),W--);if(B.length===1)return B[0];if(N){for(let W=0;W<B.length;W++)for(let x=W+1;x<B.length;x++)if(B[W].negate().equals(B[x]))return E.INSTANCE;if(B.length===1)return B[0]}return new n(B,M)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const M of this.expr)F.push(...M.keys());return F}map(F){return new n(this.expr.map(M=>M.map(F)),null)}negate(){if(!this.c){const F=[];for(const M of this.expr)F.push(M.negate());for(;F.length>1;){const M=F.shift(),N=F.shift(),B=[];for(const U of _(M))for(const W of _(N))B.push(c.create([U,W],null,!1));F.unshift(n.create(B,null,!1))}this.c=n.create(F,this,!0)}return this.c}}class r extends y{static all(){return r.d.values()}constructor(F,M,N){super(F,null),this.f=M,typeof N=="object"?r.d.push({...N,key:F}):N!==!0&&r.d.push({key:F,description:N,type:M!=null?typeof M:void 0})}bindTo(F){return F.createKey(this.key,this.f)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return v.create(this.key,F)}notEqualsTo(F){return f.create(this.key,F)}}e.RawContextKey=r,r.d=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService");function g(K,F){return K<F?-1:K>F?1:0}function P(K,F,M,N){return K<M?-1:K>M?1:F<N?-1:F>N?1:0}function L(K,F){if(K.type===0||F.type===1)return!0;if(K.type===9)return F.type===9?z(K.expr,F.expr):!1;if(F.type===9){for(const M of F.expr)if(L(K,M))return!0;return!1}if(K.type===6){if(F.type===6)return z(F.expr,K.expr);for(const M of K.expr)if(L(M,F))return!0;return!1}return K.equals(F)}e.implies=L;function z(K,F){let M=0,N=0;for(;M<K.length&&N<F.length;){const B=K[M].cmp(F[N]);if(B<0)return!1;B===0&&M++,N++}return M===K.length}function _(K){return K.type===9?K.expr:[K]}}),define(Se[194],ye([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,a.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,a.refineServiceDecorator)(e.IEnvironmentService)}),define(Se[121],ye([1,0,167,3]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function I(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=I;function A(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=A;function D(f,w){switch(f){case 3:return w==="x64"?"win32-x64":w==="ia32"?"win32-ia32":w==="arm64"?"win32-arm64":"unknown";case 2:return w==="x64"?"linux-x64":w==="arm64"?"linux-arm64":w==="arm"?"linux-armhf":"unknown";case"alpine":return w==="x64"?"alpine-x64":w==="arm64"?"alpine-arm64":"unknown";case 1:return w==="x64"?"darwin-x64":w==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function k(f,w){return w==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function S(f,w,h){return k(w,h)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===h?!0:C(h).includes(f)}e.isTargetPlatformCompatible=S;function C(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function R(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=R;var T;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(T=e.SortBy||(e.SortBy={}));var E;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(E=e.SortOrder||(e.SortOrder={}));var y;(function(f){f.Install="install",f.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var v;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var d;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal",f.Signature="Signature"})(d=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class b extends Error{constructor(w,h){super(w),this.code=h,this.name=h}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,a.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,a.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Se[195],ye([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,a.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,a.createDecorator)("externalTerminal")}),define(Se[196],ye([1,0,45,15,9,12,106,29,114,169,195]),function(ne,e,a,t,I,A,D,k,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const T=C.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await d.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends E{openTerminal(m,p){return this.spawnTerminal(a,m,S.getWindowsShell(),p)}spawnTerminal(m,p,o,i){const l=p.windowsExec||y.getDefaultTerminalWindows();i&&i[1]===":"&&(i=i[0].toUpperCase()+i.substr(1));const u=I.basename(l).toLowerCase();if(u==="cmder"||u==="cmder.exe")return m.spawn(l,i?[i]:void 0),Promise.resolve(void 0);const s=["/c","start","/wait"];return l.indexOf(" ")>=0&&s.push('""'),s.push(l),(u==="wt"||u==="wt.exe")&&s.push("-d ."),new Promise((c,n)=>{const r=b(process),g=m.spawn(o,s,{cwd:i,env:r});g.on("error",n),g.on("exit",()=>c())})}runInTerminal(m,p,o,i,l){const u="windowsExec"in l&&l.windowsExec?l.windowsExec:y.getDefaultTerminalWindows();return new Promise((s,c)=>{const n=`"${p} - ${T}"`,r=`""${o.join('" "')}" & pause"`,g=["/c","start",n,"/wait",u,"/c",r],P=Object.assign({},b(process),i);Object.keys(P).filter(_=>P[_]===null).forEach(_=>delete P[_]);const L={cwd:p,env:P,windowsVerbatimArguments:!0};a.spawn(y.b,g,L).on("error",_=>{c(f(_))}),s(void 0)})}static getDefaultTerminalWindows(){if(!y.d){const m=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${m?"Sysnative":"System32"}\\cmd.exe`}return y.d}}e.WindowsExternalTerminalService=y,y.b="cmd.exe";class v extends E{openTerminal(m,p){return this.spawnTerminal(a,m,p)}runInTerminal(m,p,o,i,l){const u=l.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((s,c)=>{if(u===R.DEFAULT_TERMINAL_OSX||u==="iTerm.app"){const n=u===R.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",g=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${n}.scpt`).fsPath,"-t",m||T,"-w",p];for(const z of o)g.push("-a"),g.push(z);if(i){const z=Object.assign({},b(process),i);for(const _ in z){const K=z[_];K===null?(g.push("-u"),g.push(_)):(g.push("-e"),g.push(`${_}=${K}`))}}let P="";const L=a.spawn(v.b,g);L.on("error",z=>{c(f(z))}),L.stderr.on("data",z=>{P+=z.toString()}),L.on("exit",z=>{if(z===0)s(void 0);else if(P){const _=P.split(`
`,1);c(new Error(_[0]))}else c(new Error(C.localize(1,null,n,z)))})}else c(new Error(C.localize(2,null,u)))})}spawnTerminal(m,p,o){const i=p.osxExec||R.DEFAULT_TERMINAL_OSX;return new Promise((l,u)=>{const s=["-a",i];o&&s.push(o);const c=b(process),n=m.spawn("/usr/bin/open",s,{cwd:o,env:c});n.on("error",u),n.on("exit",()=>l())})}}e.MacExternalTerminalService=v,v.b="/usr/bin/osascript";class d extends E{openTerminal(m,p){return this.spawnTerminal(a,m,p)}runInTerminal(m,p,o,i,l){const u=l.linuxExec?Promise.resolve(l.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((s,c)=>{const n=[];u.then(r=>{r.indexOf("gnome-terminal")>=0?n.push("-x"):n.push("-e"),n.push("bash"),n.push("-c");const g=`${w(o)}; echo; read -p "${d.b}" -n1;`;n.push(`''${g}''`);const P=Object.assign({},b(process),i);Object.keys(P).filter(K=>P[K]===null).forEach(K=>delete P[K]);const L={cwd:p,env:P};let z="";const _=a.spawn(r,n,L);_.on("error",K=>{c(f(K))}),_.stderr.on("data",K=>{z+=K.toString()}),_.on("exit",K=>{if(K===0)s(void 0);else if(z){const F=z.split(`
`,1);c(new Error(F[0]))}else c(new Error(C.localize(4,null,r,K)))})})})}static async getDefaultTerminalLinuxReady(){if(!d.d)if(!A.isLinux)d.d=Promise.resolve("xterm");else{const m=await k.Promises.exists("/etc/debian_version");d.d=new Promise(p=>{m?p("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?p("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?p("konsole"):process.env.COLORTERM?p(process.env.COLORTERM):process.env.TERM?p(process.env.TERM):p("xterm")})}return d.d}spawnTerminal(m,p,o){const i=p.linuxExec?Promise.resolve(p.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((l,u)=>{i.then(s=>{const c=b(process),n=m.spawn(s,[],{cwd:o,env:c});n.on("error",u),n.on("exit",()=>l())})})}}e.LinuxExternalTerminalService=d,d.b=C.localize(3,null);function b(h){const m={...h.env};return(0,D.sanitizeProcessEnvironment)(m),m}function f(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(C.localize(5,null,h.path)):h}function w(h){let m="";for(const p of h)p.indexOf(" ")>=0?m+='"'+p+'"':m+=p,m+=" ";return m}}),define(Se[38],ye([1,0,64,9,8,11,2,170,3]),function(ne,e,a,t,I,A,D,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function C(U){return U.create===!0}e.isFileOpenForWriteOptions=C;var R;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var T;(function(U){U[U.Readonly=1]="Readonly"})(T=e.FilePermission||(e.FilePermission={}));var E;(function(U){U[U.None=0]="None",U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead",U[U.FileClone=32768]="FileClone"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=y;function v(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=v;function d(U){return!!(U.capabilities&32768)}e.hasFileCloneCapability=d;function b(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=b;function f(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=f;function w(U){return y(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=w;var h;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(h=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class m extends Error{constructor(W,x){super(W),this.code=x}}e.FileSystemProviderError=m;function p(U,W){const x=new m(U.toString(),W);return i(x,W),x}e.createFileSystemProviderError=p;function o(U){return U||p((0,k.localize)(0,null),h.Unknown)}e.ensureFileSystemProviderError=o;function i(U,W){return U.name=W?`${W} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=i;function l(U){if(!U)return h.Unknown;if(U instanceof m)return U.code;const W=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!W)return h.Unknown;switch(W[1]){case h.FileExists:return h.FileExists;case h.FileIsADirectory:return h.FileIsADirectory;case h.FileNotADirectory:return h.FileNotADirectory;case h.FileNotFound:return h.FileNotFound;case h.FileExceedsMemoryLimit:return h.FileExceedsMemoryLimit;case h.FileTooLarge:return h.FileTooLarge;case h.FileWriteLocked:return h.FileWriteLocked;case h.NoPermissions:return h.NoPermissions;case h.Unavailable:return h.Unavailable}return h.Unknown}e.toFileSystemProviderErrorCode=l;function u(U){if(U instanceof P)return U.fileOperationResult;switch(l(U)){case h.FileNotFound:return 1;case h.FileIsADirectory:return 0;case h.FileNotADirectory:return 10;case h.FileWriteLocked:return 5;case h.NoPermissions:return 6;case h.FileExists:return 4;case h.FileExceedsMemoryLimit:return 9;case h.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=u;var s;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY",U[U.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class c{constructor(W,x,V){this.resource=W,this.operation=x,this.target=V}isOperation(W){return this.operation===W}}e.FileOperationEvent=c;var n;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class r{constructor(W,x){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=W;const V=new Map;for(const X of W){const Q=V.get(X.type);switch(Q?Q.push([X.resource,X]):V.set(X.type,[[X.resource,X]]),X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}}for(const[X,Q]of V)switch(X){case 1:this.a=a.TernarySearchTree.forUris(()=>x),this.a.fill(Q);break;case 0:this.b=a.TernarySearchTree.forUris(()=>x),this.b.fill(Q);break;case 2:this.c=a.TernarySearchTree.forUris(()=>x),this.c.fill(Q);break}}contains(W,...x){return this.d(W,{includeChildren:!1},...x)}affects(W,...x){return this.d(W,{includeChildren:!0},...x)}d(W,x,...V){if(!W)return!1;const X=V.length>0;return!!((!X||V.includes(1))&&(this.a?.get(W)||x.includeChildren&&this.a?.findSuperstr(W))||(!X||V.includes(0))&&(this.b?.get(W)||x.includeChildren&&this.b?.findSuperstr(W))||(!X||V.includes(2))&&(this.c?.findSubstr(W)||x.includeChildren&&this.c?.findSuperstr(W)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=r;function g(U,W,x){return!U||!W||U===W||W.length>U.length?!1:(W.charAt(W.length-1)!==t.sep&&(W+=t.sep),x?(0,I.startsWithIgnoreCase)(U,W):U.indexOf(W)===0)}e.isParent=g;class P extends Error{constructor(W,x,V){super(W),this.fileOperationResult=x,this.options=V}}e.FileOperationError=P;class L extends P{constructor(W,x,V){super(W,2,V),this.stat=x}}e.NotModifiedSinceFileOperationError=L;var z;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(z=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var _;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(_=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function K(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=K;async function F(U,W){if(!W.hasProvider(D.URI.from({scheme:U.scheme})))return new Promise(x=>{const V=W.onDidChangeFileSystemProviderRegistrations(X=>{X.scheme===U.scheme&&X.added&&(V.dispose(),x())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class M{static formatSize(W){return(0,A.isNumber)(W)||(W=0),W<M.KB?(0,k.localize)(1,null,W.toFixed(0)):W<M.MB?(0,k.localize)(2,null,(W/M.KB).toFixed(2)):W<M.GB?(0,k.localize)(3,null,(W/M.MB).toFixed(2)):W<M.TB?(0,k.localize)(4,null,(W/M.GB).toFixed(2)):(0,k.localize)(5,null,(W/M.TB).toFixed(2))}}e.ByteSize=M,M.KB=1024,M.MB=M.KB*M.KB,M.GB=M.MB*M.KB,M.TB=M.GB*M.KB;var N;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(N=e.Arch||(e.Arch={}));function B(U){return{maxFileSize:U===0?300*M.MB:16*M.GB,maxHeapSize:U===0?700*M.MB:2*700*M.MB}}e.getPlatformLimits=B}),define(Se[88],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class a{constructor(...I){this.a=new Map;for(const[A,D]of I)this.set(A,D)}set(I,A){const D=this.a.get(I);return this.a.set(I,A),D}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.ServiceCollection=a}),define(Se[197],ye([1,0,18,10,6,120,193,3,88,63]),function(ne,e,a,t,I,A,D,k,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const R=!1;class T extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class E{constructor(b=new S.ServiceCollection,f=!1,w,h=R){this.f=b,this.g=f,this.h=w,this.i=h,this.o=new Set,this.f.set(k.IInstantiationService,this),this._globalGraph=h?w?._globalGraph??new D.Graph(m=>m):void 0}createChild(b){return new E(b,this.g,this,this.i)}invokeFunction(b,...f){const w=v.traceInvocation(this.i,b);let h=!1;try{return b({get:p=>{if(h)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const o=this.m(p,w);if(!o)throw new Error(`[invokeFunction] unknown service '${p}'`);return o}},...f)}finally{h=!0,w.stop()}}createInstance(b,...f){let w,h;return b instanceof A.SyncDescriptor?(w=v.traceCreation(this.i,b.ctor),h=this.j(b.ctor,b.staticArguments.concat(f),w)):(w=v.traceCreation(this.i,b),h=this.j(b,f,w)),w.stop(),h}j(b,f=[],w){const h=k._util.getServiceDependencies(b).sort((o,i)=>o.index-i.index),m=[];for(const o of h){const i=this.m(o.id,w);i||this.u(`[createInstance] ${b.name} depends on UNKNOWN service ${o.id}.`,!1),m.push(i)}const p=h.length>0?h[0].index:f.length;if(f.length!==p){console.trace(`[createInstance] First service dependency of ${b.name} at position ${p+1} conflicts with ${f.length} static arguments`);const o=p-f.length;o>0?f=f.concat(new Array(o)):f=f.slice(0,p)}return Reflect.construct(b,f.concat(m))}k(b,f){if(this.f.get(b)instanceof A.SyncDescriptor)this.f.set(b,f);else if(this.h)this.h.k(b,f);else throw new Error("illegalState - setting UNKNOWN service instance")}l(b){const f=this.f.get(b);return!f&&this.h?this.h.l(b):f}m(b,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const w=this.l(b);return w instanceof A.SyncDescriptor?this.q(b,w,f.branch(b,!0)):(f.branch(b,!1),w)}q(b,f,w){if(this.o.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.o.add(b);try{return this.r(b,f,w)}finally{this.o.delete(b)}}r(b,f,w){const h=new D.Graph(o=>o.id.toString());let m=0;const p=[{id:b,desc:f,_trace:w}];for(;p.length;){const o=p.pop();if(h.lookupOrInsertNode(o),m++>1e3)throw new T(h);for(const i of k._util.getServiceDependencies(o.desc.ctor)){const l=this.l(i.id);if(l||this.u(`[createInstance] ${b} depends on ${i.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(o.id),String(i.id)),l instanceof A.SyncDescriptor){const u={id:i.id,desc:l,_trace:o._trace.branch(i.id,!0)};h.insertEdge(o,u),p.push(u)}}}for(;;){const o=h.roots();if(o.length===0){if(!h.isEmpty())throw new T(h);break}for(const{data:i}of o){if(this.l(i.id)instanceof A.SyncDescriptor){const u=this.s(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this.k(i.id,u)}h.removeNode(i)}}return this.l(b)}s(b,f,w=[],h,m){if(this.f.get(b)instanceof A.SyncDescriptor)return this.t(b,f,w,h,m);if(this.h)return this.h.s(b,f,w,h,m);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}t(b,f,w=[],h,m){if(h){const p=new E(void 0,this.g,this,this.i);p.c=String(b);const o=new Map,i=new a.IdleValue(()=>{const l=p.j(f,w,m);for(const[u,s]of o){const c=l[u];if(typeof c=="function")for(const n of s)c.apply(l,n)}return o.clear(),l});return new Proxy(Object.create(null),{get(l,u){if(!i.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let n=o.get(u);return n||(n=new C.LinkedList,o.set(u,n)),(g,P,L)=>{const z=n.push([g,P,L]);return(0,I.toDisposable)(z)}}if(u in l)return l[u];const s=i.value;let c=s[u];return typeof c!="function"||(c=c.bind(s),l[u]=c),c},set(l,u,s){return i.value[u]=s,!0},getPrototypeOf(l){return f.prototype}})}else return this.j(f,w,m)}u(b,f){if(f&&console.warn(b),this.g)throw new Error(b)}}e.InstantiationService=E;var y;(function(d){d[d.None=0]="None",d[d.Creation=1]="Creation",d[d.Invocation=2]="Invocation",d[d.Branch=3]="Branch"})(y||(y={}));class v{static traceInvocation(b,f){return b?new v(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(b,f){return b?new v(1,f.name):v.c}constructor(b,f){this.type=b,this.name=f,this.g=Date.now(),this.h=[]}branch(b,f){const w=new v(3,b.toString());return this.h.push([b,f,w]),w}stop(){const b=Date.now()-this.g;v.f+=b;let f=!1;function w(m,p){const o=[],i=new Array(m+1).join("	");for(const[l,u,s]of p.h)if(u&&s){f=!0,o.push(`${i}CREATES -> ${l}`);const c=w(m+1,s);c&&o.push(c)}else o.push(`${i}uses -> ${l}`);return o.join(`
`)}const h=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(b>2||f)&&v.all.add(h.join(`
`))}}e.Trace=v,v.all=new Set,v.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}},v.f=0}),define(Se[13],ye([1,0,51,4,6,28,12,2,3]),function(ne,e,a,t,I,A,D,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function C(){return new Date().toISOString()}var R;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(R=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=R.Info;function T(c,n,r){switch(n){case R.Trace:c.trace(r);break;case R.Debug:c.debug(r);break;case R.Info:c.info(r);break;case R.Warning:c.warn(r);break;case R.Error:c.error(r);break;case R.Off:break;default:throw new Error(`Invalid log level ${n}`)}}e.log=T;function E(c){let n="";for(let r=0;r<c.length;r++){let g=c[r];if(typeof g=="object")try{g=JSON.stringify(g)}catch{}n+=(r>0?" ":"")+g}return n}e.format=E;class y extends I.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(n){this.b!==n&&(this.b=n,this.c.fire(this.b))}getLevel(){return this.b}f(n){return this.b!==R.Off&&this.b<=n}}e.AbstractLogger=y;class v extends y{constructor(n){super(),this.h=n}f(n){return this.h||super.f(n)}trace(n,...r){this.f(R.Trace)&&this.g(R.Trace,E([n,...r]))}debug(n,...r){this.f(R.Debug)&&this.g(R.Debug,E([n,...r]))}info(n,...r){this.f(R.Info)&&this.g(R.Info,E([n,...r]))}warn(n,...r){this.f(R.Warning)&&this.g(R.Warning,E([n,...r]))}error(n,...r){if(this.f(R.Error))if(n instanceof Error){const g=Array.prototype.slice.call(arguments);g[0]=n.stack,this.g(R.Error,E(g))}else this.g(R.Error,E([n,...r]))}flush(){}}e.AbstractMessageLogger=v;class d extends y{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.g=!D.isWindows}trace(n,...r){this.f(R.Trace)&&(this.g?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,n,...r):console.log(`[main ${C()}]`,n,...r))}debug(n,...r){this.f(R.Debug)&&(this.g?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,n,...r):console.log(`[main ${C()}]`,n,...r))}info(n,...r){this.f(R.Info)&&(this.g?console.log(`\x1B[90m[main ${C()}]\x1B[0m`,n,...r):console.log(`[main ${C()}]`,n,...r))}warn(n,...r){this.f(R.Warning)&&(this.g?console.warn(`\x1B[93m[main ${C()}]\x1B[0m`,n,...r):console.warn(`[main ${C()}]`,n,...r))}error(n,...r){this.f(R.Error)&&(this.g?console.error(`\x1B[91m[main ${C()}]\x1B[0m`,n,...r):console.error(`[main ${C()}]`,n,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=d;class b extends y{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...r){this.f(R.Trace)&&console.log("%cTRACE","color: #888",n,...r)}debug(n,...r){this.f(R.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",n,...r)}info(n,...r){this.f(R.Info)&&console.log("%c INFO","color: #33f",n,...r)}warn(n,...r){this.f(R.Warning)&&console.log("%c WARN","color: #993",n,...r)}error(n,...r){this.f(R.Error)&&console.log("%c  ERR","color: #f33",n,...r)}dispose(){}flush(){}}e.ConsoleLogger=b;class f extends y{constructor(n,r=e.DEFAULT_LOG_LEVEL){super(),this.g=n,this.setLevel(r)}trace(n,...r){this.f(R.Trace)&&this.g.log(R.Trace,[this.h(n),...r])}debug(n,...r){this.f(R.Debug)&&this.g.log(R.Debug,[this.h(n),...r])}info(n,...r){this.f(R.Info)&&this.g.log(R.Info,[this.h(n),...r])}warn(n,...r){this.f(R.Warning)&&this.g.log(R.Warning,[this.h(n),...r])}error(n,...r){this.f(R.Error)&&this.g.log(R.Error,[this.h(n),...r])}h(n){return typeof n=="string"?n:(0,a.toErrorMessage)(n,this.f(R.Trace))}dispose(){}flush(){}}e.AdapterLogger=f;class w extends y{constructor(n){super(),this.g=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const r of this.g)r.setLevel(n);super.setLevel(n)}trace(n,...r){for(const g of this.g)g.trace(n,...r)}debug(n,...r){for(const g of this.g)g.debug(n,...r)}info(n,...r){for(const g of this.g)g.info(n,...r)}warn(n,...r){for(const g of this.g)g.warn(n,...r)}error(n,...r){for(const g of this.g)g.error(n,...r)}flush(){for(const n of this.g)n.flush()}dispose(){for(const n of this.g)n.dispose()}}e.MultiplexLogService=w;class h extends I.Disposable{constructor(n){super(),this.b=n,this.B(n)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(n){this.b.setLevel(n)}getLevel(){return this.b.getLevel()}trace(n,...r){this.b.trace(n,...r)}debug(n,...r){this.b.debug(n,...r)}info(n,...r){this.b.info(n,...r)}warn(n,...r){this.b.warn(n,...r)}error(n,...r){this.b.error(n,...r)}flush(){this.b.flush()}}e.LogService=h;class m extends I.Disposable{constructor(n,r){super(),this.c=n,this.b=new A.ResourceMap,this.B(r(g=>this.setLevel(g)))}getLoggers(){return[...this.b.values()].map(({logger:n})=>n)}getLogger(n){return this.b.get(n)?.logger}createLogger(n,r,g){let P=this.b.get(n)?.logger;return P||(g=r?.always?R.Trace:g,P=this.f(n,g??this.c,r),this.b.set(n,{logger:P,logLevel:g})),P}setLevel(n,r){const g=k.URI.isUri(n)?n:void 0,P=g?r:n;if(g){const L=this.b.get(g);L&&L.logLevel!==P&&(L.logLevel=P,L.logger.setLevel(P))}else this.c=P,this.b.forEach(({logLevel:L,logger:z})=>{L===void 0&&z.setLevel(this.c)})}getLogLevel(n){return this.b.get(n)?.logLevel}dispose(){this.b.forEach(({logger:n})=>n.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=m;class p{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(n){}getLevel(){return R.Info}trace(n,...r){}debug(n,...r){}info(n,...r){}warn(n,...r){}error(n,...r){}critical(n,...r){}dispose(){}flush(){}}e.NullLogger=p;class o extends p{}e.NullLogService=o;class i extends m{constructor(){super(R.Info,t.Event.None)}f(n,r,g){return new p}}e.NullLoggerService=i;function l(c){if(c.verbose)return R.Trace;if(typeof c.logLevel=="string"){const n=s(c.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function u(c){switch(c){case R.Trace:return"trace";case R.Debug:return"debug";case R.Info:return"info";case R.Warning:return"warn";case R.Error:return"error";case R.Off:return"off"}}e.LogLevelToString=u;function s(c){switch(c){case"trace":return R.Trace;case"debug":return R.Debug;case"info":return R.Info;case"warn":return R.Warning;case"error":return R.Error;case"critical":return R.Error;case"off":return R.Off}}e.parseLogLevel=s}),define(Se[198],ye([1,0,38,13]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var I;(function(C){C[C.Trace=0]="Trace",C[C.Debug=1]="Debug",C[C.Info=2]="Info",C[C.Warning=3]="Warning",C[C.Error=4]="Error",C[C.Critical=5]="Critical",C[C.Off=6]="Off"})(I||(I={}));async function A(C,R,T,E,y){try{const v=await new Promise((b,f)=>{ne(["spdlog"],b,f)});v.setFlushOn(I.Trace);const d=await v.createAsyncRotatingLogger(C,R,T,E);return y?d.clearFormatters():d.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),d}catch(v){console.error(v)}return null}function D(C,R,T){switch(R){case t.LogLevel.Trace:C.trace(T);break;case t.LogLevel.Debug:C.debug(T);break;case t.LogLevel.Info:C.info(T);break;case t.LogLevel.Warning:C.warn(T);break;case t.LogLevel.Error:C.error(T);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function k(C,R){switch(R){case t.LogLevel.Trace:C.setLevel(I.Trace);break;case t.LogLevel.Debug:C.setLevel(I.Debug);break;case t.LogLevel.Info:C.setLevel(I.Info);break;case t.LogLevel.Warning:C.setLevel(I.Warning);break;case t.LogLevel.Error:C.setLevel(I.Error);break;case t.LogLevel.Off:C.setLevel(I.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class S extends t.AbstractMessageLogger{constructor(R,T,E,y,v){super(),this.k=[],this.setLevel(v),this.l=this.n(R,T,E,y),this.B(this.onDidChangeLogLevel(d=>{this.m&&k(this.m,d)}))}async n(R,T,E,y){const v=E?6:1,d=30/v*a.ByteSize.MB,b=await A(R,T,d,v,y);if(b){this.m=b,k(this.m,this.getLevel());for(const{level:f,message:w}of this.k)D(this.m,f,w);this.k=[]}}g(R,T){this.m?D(this.m,R,T):this.getLevel()<=R&&this.k.push({level:R,message:T})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=S}),define(Se[122],ye([1,0,42,171,3]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var D;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function C(v,d){return d-v}S.compare=C;const R=Object.create(null);R[S.Error]=(0,t.localize)(0,null),R[S.Warning]=(0,t.localize)(1,null),R[S.Info]=(0,t.localize)(2,null);function T(v){return R[v]||""}S.toString=T;function E(v){switch(v){case a.default.Error:return S.Error;case a.default.Warning:return S.Warning;case a.default.Info:return S.Info;case a.default.Ignore:return S.Hint}}S.fromSeverity=E;function y(v){switch(v){case S.Error:return a.default.Error;case S.Warning:return a.default.Warning;case S.Info:return a.default.Info;case S.Hint:return a.default.Ignore}}S.toSeverity=y}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(S){const C="";function R(E){return T(E,!0)}S.makeKey=R;function T(E,y){const v=[C];return E.source?v.push(E.source.replace("\xA6","\\\xA6")):v.push(C),E.code?typeof E.code=="string"?v.push(E.code.replace("\xA6","\\\xA6")):v.push(E.code.value.replace("\xA6","\\\xA6")):v.push(C),E.severity!==void 0&&E.severity!==null?v.push(D.toString(E.severity)):v.push(C),E.message&&y?v.push(E.message.replace("\xA6","\\\xA6")):v.push(C),E.startLineNumber!==void 0&&E.startLineNumber!==null?v.push(E.startLineNumber.toString()):v.push(C),E.startColumn!==void 0&&E.startColumn!==null?v.push(E.startColumn.toString()):v.push(C),E.endLineNumber!==void 0&&E.endLineNumber!==null?v.push(E.endLineNumber.toString()):v.push(C),E.endColumn!==void 0&&E.endColumn!==null?v.push(E.endColumn.toString()):v.push(C),v.push(C),v.join("\xA6")}S.makeKeyOptionalMessage=T})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(Se[199],ye([1,0,4,42,3]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,I.createDecorator)("notificationService");var A;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var D;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(D=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new S,this.onDidClose=a.Event.None,this.onDidChangeVisibility=a.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=k;class S{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=S}),define(Se[123],ye([1,0,8,2,3]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,I.createDecorator)("openerService");function A(C,R){return t.URI.isUri(C)?(0,a.equalsIgnoreCase)(C.scheme,R):(0,a.startsWithIgnoreCase)(C,R+":")}e.matchesScheme=A;function D(C,...R){return R.some(T=>A(C,T))}e.matchesSomeScheme=D;function k(C,R){return C.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.withSelection=k;function S(C){let R;const T=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(C.fragment);return T&&(R={startLineNumber:parseInt(T[1]),startColumn:T[2]?parseInt(T[2]):1,endLineNumber:T[4]?parseInt(T[4]):void 0,endColumn:T[4]?T[5]?parseInt(T[5]):1:void 0},C=C.with({fragment:""})),{selection:R,uri:C}}e.extractSelection=S}),define(Se[200],ye([1,0,12,36]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let I;if(typeof a.globals.vscode<"u"&&typeof a.globals.vscode.context<"u"){const A=a.globals.vscode.context.configuration();if(A)I=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(I=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(I,{nameShort:`${I.nameShort} Dev`,nameLong:`${I.nameLong} Dev`,dataFolderName:`${I.dataFolderName}-dev`,serverDataFolderName:I.serverDataFolderName?`${I.serverDataFolderName}-dev`:void 0}),!I.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(I,{version:A.version})}}else I={},Object.keys(I).length===0&&Object.assign(I,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=I}),define(Se[201],ye([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,a.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var We=this&&this.__param||function(ne,e){return function(a,t){e(a,t,ne)}};define(Se[124],ye([1,0,18,21,6,3]),function(ne,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var D;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(D=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{get value(){return this.a}constructor(T){this.b=T}report(T){this.a=T,this.b(this.a)}}e.Progress=k,k.None=Object.freeze({report(){}});let S=class extends I.Disposable{constructor(T,E){super(),this.a=new a.DeferredPromise,E.withProgress(T,y=>(this.b=y,this.c&&y.report(this.c),this.a.p)),this.B((0,I.toDisposable)(()=>this.a.complete()))}report(T){this.b?this.b.report(T):this.c=T}};S=qe([We(1,e.IProgressService)],S),e.UnmanagedProgress=S;class C extends I.Disposable{constructor(T){super(),this.g=T,this.a=0,this.b=this.B(new I.DisposableStore)}start(T){this.stop();const E=++this.a,y=new t.CancellationTokenSource;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},T),this.b.add((0,I.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,I.toDisposable)(()=>y.cancel())),this.b.add((0,I.toDisposable)(()=>this.c?this.c.done():void 0)),{id:E,token:y.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(T){this.a===T&&this.b.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(Se[43],ye([1,0,49,11]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.a=new Map}add(D,k){a.ok(t.isString(D)),a.ok(t.isObject(k)),a.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,k)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.Registry=new I}),define(Se[125],ye([1,0,4,43]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class A{constructor(){this.b=new a.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,C){this.a[I(S)]=C,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const D=new A;t.Registry.add(e.Extensions.JSONContribution,D)}),define(Se[126],ye([1,0,17,4,11,166,52,125,43]),function(ne,e,a,t,I,A,D,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const T=S.Registry.as(k.Extensions.JSONContribution);class E{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(o,i=!0){this.registerConfigurations([o],i)}registerConfigurations(o,i=!0){const l=this.k(o,i);T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:l})}deregisterConfigurations(o){const i=this.l(o);T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}updateConfigurations({add:o,remove:i}){const l=[];l.push(...this.l(i)),l.push(...this.k(o,!1)),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,a.distinct)(l)})}registerDefaultConfigurations(o){const i=[],l=[];for(const{overrides:u,source:s}of o)for(const c in u)if(i.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const n=this.a.get(c),r=n?.valuesSources??new Map;if(s)for(const z of Object.keys(u[c]))r.set(z,s);const g={...n?.value||{},...u[c]};this.a.set(c,{source:s,value:g,valuesSources:r});const P=(0,D.getLanguageTagSettingPlainKey)(c),L={type:"object",default:g,description:A.localize(1,null,P),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:g,source:I.isString(s)?void 0:s,defaultValueSource:s};l.push(...d(c)),this.d[c]=L,this.b.properties[c]=L}else{this.a.set(c,{value:u[c],source:s});const n=this.d[c];n&&(this.s(c,n),this.o(c,n))}this.registerOverrideIdentifiers(l),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}deregisterDefaultConfigurations(o){const i=[];for(const{overrides:l,source:u}of o)for(const s in l){const c=this.a.get(s),n=I.isString(u)?u:u?.id,r=I.isString(c?.source)?c?.source:c?.source?.id;if(n===r)if(i.push(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const g=this.d[s];g&&(this.s(s,g),this.o(s,g))}}this.q(),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...o){this.i.fire()}registerOverrideIdentifiers(o){for(const i of o)this.h.add(i);this.q()}k(o,i){const l=[];return o.forEach(u=>{l.push(...this.m(u,i,u.extensionInfo,u.restrictedProperties)),this.c.push(u),this.n(u)}),l}l(o){const i=[],l=u=>{if(u.properties)for(const s in u.properties){i.push(s);const c=this.d[s];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[s],this.p(s,u.properties[s])}u.allOf?.forEach(s=>l(s))};for(const u of o){l(u);const s=this.c.indexOf(u);s!==-1&&this.c.splice(s,1)}return i}m(o,i=!0,l,u,s=3){s=I.isUndefinedOrNull(o.scope)?s:o.scope;const c=[],n=o.properties;if(n)for(const g in n){const P=n[g];if(i&&h(g,P)){delete n[g];continue}if(P.source=l,P.defaultDefaultValue=n[g].default,this.s(g,P),e.OVERRIDE_PROPERTY_REGEX.test(g)?P.scope=void 0:(P.scope=I.isUndefinedOrNull(P.scope)?s:P.scope,P.restricted=I.isUndefinedOrNull(P.restricted)?!!u?.includes(g):P.restricted),n[g].hasOwnProperty("included")&&!n[g].included){this.f[g]=n[g],delete n[g];continue}else this.d[g]=n[g],n[g].policy?.name&&this.e.set(n[g].policy.name,g);!n[g].deprecationMessage&&n[g].markdownDeprecationMessage&&(n[g].deprecationMessage=n[g].markdownDeprecationMessage),c.push(g)}const r=o.allOf;if(r)for(const g of r)c.push(...this.m(g,i,l,u,s));return c}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(o){const i=l=>{const u=l.properties;if(u)for(const c in u)this.o(c,u[c]);l.allOf?.forEach(i)};i(o)}o(o,i){switch(e.allSettings.properties[o]=i,i.scope){case 1:e.applicationSettings.properties[o]=i;break;case 2:e.machineSettings.properties[o]=i;break;case 6:e.machineOverridableSettings.properties[o]=i;break;case 3:e.windowSettings.properties[o]=i;break;case 4:e.resourceSettings.properties[o]=i;break;case 5:e.resourceSettings.properties[o]=i,this.g.properties[o]=i;break}}p(o,i){switch(delete e.allSettings.properties[o],i.scope){case 1:delete e.applicationSettings.properties[o];break;case 2:delete e.machineSettings.properties[o];break;case 6:delete e.machineOverridableSettings.properties[o];break;case 3:delete e.windowSettings.properties[o];break;case 4:case 5:delete e.resourceSettings.properties[o],delete this.g.properties[o];break}}q(){for(const o of this.h.values()){const i=`[${o}]`,l={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(i,l),e.allSettings.properties[i]=l,e.applicationSettings.properties[i]=l,e.machineSettings.properties[i]=l,e.machineOverridableSettings.properties[i]=l,e.windowSettings.properties[i]=l,e.resourceSettings.properties[i]=l}this.i.fire()}r(){const o={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=o,this.i.fire()}s(o,i){const l=this.a.get(o);let u=l?.value,s=l?.source;I.isUndefined(u)&&(u=i.defaultDefaultValue,s=void 0),I.isUndefined(u)&&(u=f(i.type)),i.default=u,i.defaultValueSource=s}}const y="\\[([^\\]]+)\\]",v=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function d(p){const o=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let i=v.exec(p);for(;i?.length;){const l=i[1].trim();l&&o.push(l),i=v.exec(p)}}return(0,a.distinct)(o)}e.overrideIdentifiersFromKey=d;function b(p){return p.reduce((o,i)=>`${o}[${i}]`,"")}e.keyFromOverrideIdentifiers=b;function f(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const w=new E;S.Registry.add(e.Extensions.Configuration,w);function h(p,o){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?A.localize(7,null,p):w.getConfigurationProperties()[p]!==void 0?A.localize(8,null,p):o.policy?.name&&w.getPolicyConfigurations().get(o.policy?.name)!==void 0?A.localize(9,null,p,o.policy?.name,w.getPolicyConfigurations().get(o.policy?.name)):null:A.localize(6,null)}e.validateProperty=h;function m(){const p=[],o=w.getConfigurationProperties();for(const i of Object.keys(o))p.push([i,o[i].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=m}),define(Se[202],ye([1,0,17,4,146,6,28,23,11,2,52,126,43]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class y{constructor(i={},l=[],u=[],s){this.c=i,this.d=l,this.f=u,this.raw=s,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const i=this.raw.map(l=>{if(l instanceof y)return l;const u=new v("");return u.parseRaw(l),u.configurationModel});this.g=i.reduce((l,u)=>u===l?u:l.merge(u),i[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(i){return i?(0,R.getConfigurationValue)(this.contents,i):this.contents}inspect(i,l){const u=this.rawConfiguration.getValue(i),s=l?this.rawConfiguration.getOverrideValue(i,l):void 0,c=l?this.rawConfiguration.override(l).getValue(i):u;return{value:u,override:s,merged:c}}getOverrideValue(i,l){const u=this.l(l);return u?i?(0,R.getConfigurationValue)(u,i):u:void 0}getKeysForOverrideIdentifier(i){const l=[];for(const u of this.overrides)u.identifiers.includes(i)&&l.push(...u.keys);return a.distinct(l)}getAllOverrideIdentifiers(){const i=[];for(const l of this.overrides)i.push(...l.identifiers);return a.distinct(i)}override(i){let l=this.b.get(i);return l||(l=this.h(i),this.b.set(i,l)),l}merge(...i){const l=k.deepClone(this.contents),u=k.deepClone(this.overrides),s=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const n of i)if(c.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.j(l,n.contents);for(const r of n.overrides){const[g]=u.filter(P=>a.equals(P.identifiers,r.identifiers));g?(this.j(g.contents,r.contents),g.keys.push(...r.keys),g.keys=a.distinct(g.keys)):u.push(k.deepClone(r))}for(const r of n.keys)s.indexOf(r)===-1&&s.push(r)}return new y(l,s,u,c.every(n=>n instanceof y)?void 0:c)}freeze(){return this.a=!0,this}clone(){return new y(k.deepClone(this.contents),[...this.keys],k.deepClone(this.overrides))}h(i){const l=this.l(i);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const u={};for(const s of a.distinct([...Object.keys(this.contents),...Object.keys(l)])){let c=this.contents[s];const n=l[s];n&&(typeof c=="object"&&typeof n=="object"?(c=k.deepClone(c),this.j(c,n)):c=n),u[s]=c}return new y(u,this.keys,this.overrides)}j(i,l){for(const u of Object.keys(l)){if(u in i&&S.isObject(i[u])&&S.isObject(l[u])){this.j(i[u],l[u]);continue}i[u]=k.deepClone(l[u])}}k(i){return this.a&&!Object.isFrozen(i)?k.deepFreeze(i):i}l(i){let l=null,u=null;const s=c=>{c&&(u?this.j(u,c):u=k.deepClone(c))};for(const c of this.overrides)a.equals(c.identifiers,[i])?l=c.contents:c.identifiers.includes(i)&&s(c.contents);return s(l),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,l){this.m(i),(0,R.addToValueTree)(this.contents,i,l,u=>{throw new Error(u)})}removeValue(i){this.n(i)&&(0,R.removeFromValueTree)(this.contents,i)}m(i){let l=this.keys.length;for(let u=0;u<l;u++)i.indexOf(this.keys[u])===0&&(l=u);this.keys.splice(l,1,i)}n(i){const l=this.keys.indexOf(i);return l!==-1?(this.keys.splice(l,1),!0):!1}}e.ConfigurationModel=y;class v{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,l){if(!S.isUndefinedOrNull(i)){const u=this.g(i);this.parseRaw(u,l)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,l){this.a=i;const{contents:u,keys:s,overrides:c,restricted:n,hasExcludedProperties:r}=this.h(i,l);this.b=new y(u,s,c,r?[i]:void 0),this.c=n||[]}g(i){let l={},u=null,s=[];const c=[],n=[];function r(P){Array.isArray(s)?s.push(P):u!==null&&(s[u]=P)}const g={onObjectBegin:()=>{const P={};r(P),c.push(s),s=P,u=null},onObjectProperty:P=>{u=P},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const P=[];r(P),c.push(s),s=P,u=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:r,onError:(P,L,z)=>{n.push({error:P,offset:L,length:z})}};if(i)try{I.visit(i,g),l=s[0]||{}}catch(P){console.error(`Error while parsing settings file ${this.f}: ${P}`),this.d=[P]}return l}h(i,l){const u=E.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),s=this.j(i,u,!0,l);i=s.raw;const c=(0,R.toValuesTree)(i,g=>console.error(`Conflict in settings file ${this.f}: ${g}`)),n=Object.keys(i),r=this.l(i,g=>console.error(`Conflict in settings file ${this.f}: ${g}`));return{contents:c,keys:n,overrides:r,restricted:s.restricted,hasExcludedProperties:s.hasExcludedProperties}}j(i,l,u,s){let c=!1;if(!s?.scopes&&!s?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:c};const n={},r=[];for(const g in i)if(T.OVERRIDE_PROPERTY_REGEX.test(g)&&u){const P=this.j(i[g],l,!1,s);n[g]=P.raw,c=c||P.hasExcludedProperties,r.push(...P.restricted)}else{const P=l[g],L=P?typeof P.scope<"u"?P.scope:3:void 0;P?.restricted&&r.push(g),(L===void 0||s.scopes===void 0||s.scopes.includes(L))&&!(s.skipRestricted&&P?.restricted)?n[g]=i[g]:c=!0}return{raw:n,restricted:r,hasExcludedProperties:c}}l(i,l){const u=[];for(const s of Object.keys(i))if(T.OVERRIDE_PROPERTY_REGEX.test(s)){const c={};for(const n in i[s])c[n]=i[s][n];u.push({identifiers:(0,T.overrideIdentifiersFromKey)(s),keys:Object.keys(c),contents:(0,R.toValuesTree)(c,l)})}return u}}e.ConfigurationModelParser=v;class d extends A.Disposable{constructor(i,l,u,s){super(),this.f=i,this.g=l,this.h=s,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new v(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(u.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&u.isEqual(c.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new y}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=d;class b{constructor(i,l,u,s,c,n,r,g,P,L,z,_,K){this.a=i,this.b=l,this.value=u,this.overrideIdentifiers=s,this.c=c,this.d=n,this.f=r,this.g=g,this.h=P,this.j=L,this.k=z,this.l=_,this.m=K}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class f{constructor(i,l,u,s,c=new y,n=new y,r=new D.ResourceMap,g=new y,P=new D.ResourceMap,L=!0){this.c=i,this.d=l,this.f=u,this.g=s,this.h=c,this.j=n,this.l=r,this.m=g,this.n=P,this.p=L,this.a=null,this.b=new D.ResourceMap,this.q=null}getValue(i,l,u){return this.s(i,l,u).getValue(i)}updateValue(i,l,u={}){let s;u.resource?(s=this.n.get(u.resource),s||(s=new y,this.n.set(u.resource,s))):s=this.m,l===void 0?s.removeValue(i):s.setValue(i,l),u.resource||(this.a=null)}inspect(i,l,u){const s=this.s(i,l,u),c=a.distinct(s.overrides.map(g=>g.identifiers).flat()).filter(g=>s.getOverrideValue(i,g)!==void 0),n=this.w(l.resource,u),r=l.resource?this.n.get(l.resource)||this.m:this.m;return new b(i,l,s.getValue(i),c.length?c:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),u?this.j.freeze():void 0,n?n.freeze():void 0,r.inspect(i,l.overrideIdentifier))}keys(i){const l=this.w(void 0,i);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:l?l.freeze().keys:[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.j=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,l){this.l.set(i,l),this.b.delete(i)}deleteFolderConfiguration(i){this.r.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,l){const u=[];if(!l){const{added:s,updated:c,removed:n}=m(this.c,i);l=[...s,...c,...n]}for(const s of l)for(const c of(0,T.overrideIdentifiersFromKey)(s)){const n=this.c.getKeysForOverrideIdentifier(c),r=i.getKeysForOverrideIdentifier(c),g=[...r.filter(P=>n.indexOf(P)===-1),...n.filter(P=>r.indexOf(P)===-1),...n.filter(P=>!k.equals(this.c.override(c).getValue(P),i.override(c).getValue(P)))];u.push([c,g])}return this.updateDefaultConfiguration(i),{keys:l,overrides:u}}compareAndUpdatePolicyConfiguration(i){const{added:l,updated:u,removed:s}=m(this.d,i),c=[...l,...u,...s];return c.length&&this.updatePolicyConfiguration(i),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:l,updated:u,removed:s,overrides:c}=m(this.applicationConfiguration,i),n=[...l,...u,...s];return n.length&&this.updateApplicationConfiguration(i),{keys:n,overrides:c}}compareAndUpdateLocalUserConfiguration(i){const{added:l,updated:u,removed:s,overrides:c}=m(this.localUserConfiguration,i),n=[...l,...u,...s];return n.length&&this.updateLocalUserConfiguration(i),{keys:n,overrides:c}}compareAndUpdateRemoteUserConfiguration(i){const{added:l,updated:u,removed:s,overrides:c}=m(this.remoteUserConfiguration,i),n=[...l,...u,...s];return n.length&&this.updateRemoteUserConfiguration(i),{keys:n,overrides:c}}compareAndUpdateWorkspaceConfiguration(i){const{added:l,updated:u,removed:s,overrides:c}=m(this.workspaceConfiguration,i),n=[...l,...u,...s];return n.length&&this.updateWorkspaceConfiguration(i),{keys:n,overrides:c}}compareAndUpdateFolderConfiguration(i,l){const u=this.r.get(i),{added:s,updated:c,removed:n,overrides:r}=m(u,l),g=[...s,...c,...n];return(g.length||!u)&&this.updateFolderConfiguration(i,l),{keys:g,overrides:r}}compareAndDeleteFolderConfiguration(i){const l=this.r.get(i);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:u,updated:s,removed:c,overrides:n}=m(l,void 0);return{keys:[...u,...s,...c],overrides:n}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(i,l,u){let s=this.t(l,u);return l.overrideIdentifier&&(s=s.override(l.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(s=s.merge(this.d)),s}t({resource:i},l){let u=this.u();if(l&&i){const s=l.getFolder(i);s&&(u=this.v(s.uri)||u);const c=this.n.get(i);c&&(u=u.merge(c))}return u}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(i){let l=this.b.get(i);if(!l){const u=this.u(),s=this.l.get(i);s?(l=u.merge(s),this.p&&(l=l.freeze()),this.b.set(i,l)):l=u}return l}w(i,l){if(l&&i){const u=l.getFolder(i);if(u)return this.l.get(u.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((i,l)=>{const{contents:u,overrides:s,keys:c}=this.l.get(l);return i.push([l,{contents:u,overrides:s,keys:c}]),i},[])}}allKeys(){const i=new Set;return this.c.freeze().keys.forEach(l=>i.add(l)),this.userConfiguration.freeze().keys.forEach(l=>i.add(l)),this.j.freeze().keys.forEach(l=>i.add(l)),this.l.forEach(l=>l.freeze().keys.forEach(u=>i.add(u))),[...i.values()]}x(){const i=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(l=>i.add(l)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(l=>i.add(l)),this.j.freeze().getAllOverrideIdentifiers().forEach(l=>i.add(l)),this.l.forEach(l=>l.freeze().getAllOverrideIdentifiers().forEach(u=>i.add(u))),[...i.values()]}y(i){const l=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(u=>l.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(u=>l.add(u)),this.j.getKeysForOverrideIdentifier(i).forEach(u=>l.add(u)),this.l.forEach(u=>u.getKeysForOverrideIdentifier(i).forEach(s=>l.add(s))),[...l.values()]}static parse(i){const l=this.z(i.defaults),u=this.z(i.policy),s=this.z(i.application),c=this.z(i.user),n=this.z(i.workspace),r=i.folders.reduce((g,P)=>(g.set(C.URI.revive(P[0]),this.z(P[1])),g),new D.ResourceMap);return new f(l,u,s,c,new y,n,r,new y,new D.ResourceMap,!1)}static z(i){return new y(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=f;function w(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const i=new Set,l=new Map;for(const s of o)s.keys.forEach(c=>i.add(c)),s.overrides.forEach(([c,n])=>{const r=(0,D.getOrSet)(l,c,new Set);n.forEach(g=>r.add(g))});const u=[];return l.forEach((s,c)=>u.push([c,[...s.values()]])),{keys:[...i.values()],overrides:u}}e.mergeChanges=w;class h{constructor(i,l,u,s){this.change=i,this.b=l,this.c=u,this.d=s,this.f=void 0;const c=new Set;i.keys.forEach(r=>c.add(r)),i.overrides.forEach(([,r])=>r.forEach(g=>c.add(g))),this.affectedKeys=[...c.values()];const n=new y;this.affectedKeys.forEach(r=>n.setValue(r,{})),this.a=n.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=f.parse(this.b.data)),this.f}affectsConfiguration(i,l){if(this.g(this.a,i)){if(l){const u=this.previousConfiguration?this.previousConfiguration.getValue(i,l,this.b?.workspace):void 0,s=this.c.getValue(i,l,this.d);return!k.equals(u,s)}return!0}return!1}g(i,l){let u=(0,R.toValuesTree)({[l]:!0},()=>{}),s;for(;typeof u=="object"&&(s=Object.keys(u)[0]);){if(i=i[s],!i)return!1;u=u[s]}return!0}}e.ConfigurationChangeEvent=h;function m(o,i){const{added:l,removed:u,updated:s}=p(i?.rawConfiguration,o?.rawConfiguration),c=[],n=o?.getAllOverrideIdentifiers()||[],r=i?.getAllOverrideIdentifiers()||[];if(i){const g=r.filter(P=>!n.includes(P));for(const P of g)c.push([P,i.getKeysForOverrideIdentifier(P)])}if(o){const g=n.filter(P=>!r.includes(P));for(const P of g)c.push([P,o.getKeysForOverrideIdentifier(P)])}if(i&&o){for(const g of n)if(r.includes(g)){const P=p({contents:o.getOverrideValue(void 0,g)||{},keys:o.getKeysForOverrideIdentifier(g)},{contents:i.getOverrideValue(void 0,g)||{},keys:i.getKeysForOverrideIdentifier(g)});c.push([g,[...P.added,...P.removed,...P.updated]])}}return{added:l,removed:u,updated:s,overrides:c}}function p(o,i){const l=o?i?o.keys.filter(c=>i.keys.indexOf(c)===-1):[...o.keys]:[],u=i?o?i.keys.filter(c=>o.keys.indexOf(c)===-1):[...i.keys]:[],s=[];if(o&&i){for(const c of i.keys)if(o.keys.indexOf(c)!==-1){const n=(0,R.getConfigurationValue)(i.contents,c),r=(0,R.getConfigurationValue)(o.contents,c);k.equals(n,r)||s.push(c)}}return{added:l,removed:u,updated:s}}}),define(Se[127],ye([1,0,10,3]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var I;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(I=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends a.ErrorNoTelemetry{static isNotAvailable(k){return k instanceof A&&k._code===I.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof A&&k._code===I.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof A&&k._code===I.NoResolverFound}static isHandled(k){return k instanceof A&&k.isHandled}constructor(k,S=I.Unknown,C){super(k),this._message=k,this._code=S,this._detail=C,this.isHandled=S===I.NotAvailable&&C===!0,Object.setPrototypeOf(this,A.prototype)}}e.RemoteAuthorityResolverError=A}),define(Se[67],ye([1,0,15]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(C){return C.scheme===a.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=t;function I(C){if(!C)return;const R=C.indexOf("+");return R<0?C:C.substr(0,R)}e.getRemoteName=I;function A(C){return`/${C.quality??"oss"}-${C.commit??"dev"}`}e.getRemoteServerRootPath=A;function D(C){const{host:R,port:T}=S(C);if(typeof T>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:T}}e.parseAuthorityWithPort=D;function k(C,R){let{host:T,port:E}=S(C);return typeof E>"u"&&(E=R),{host:T,port:E}}e.parseAuthorityWithOptionalPort=k;function S(C){const R=C.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const T=C.match(/^(\[[0-9a-z:]+\])$/);if(T)return{host:T[1],port:void 0};const E=C.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:C,port:void 0}}}),define(Se[27],ye([1,0,8,3,67]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=A;function D(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(!v.uuid||typeof v.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));var S;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class C{constructor(d){this.value=d,this.c=d.toLowerCase()}static equals(d,b){if(typeof d>"u"||d===null)return typeof b>"u"||b===null;if(typeof b>"u"||b===null)return!1;if(typeof d=="string"||typeof b=="string"){const f=typeof d=="string"?d:d.value,w=typeof b=="string"?b:b.value;return a.equalsIgnoreCase(f,w)}return d.c===b.c}static toKey(d){return typeof d=="string"?d.toLowerCase():d.c}}e.ExtensionIdentifier=C;function R(v){return T(v)}e.isApplicationScopedExtension=R;function T(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=T;function E(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function y(v,d){if(d){const b=`onResolveRemoteAuthority:${(0,I.getRemoteName)(d)}`;return v.activationEvents?.indexOf(b)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(Se[203],ye([1,0,8,121,27,12,2,10,36]),function(ne,e,a,t,I,A,D,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function C(i,l){return i.uuid&&l.uuid?i.uuid===l.uuid:i.id===l.id?!0:(0,a.compareIgnoreCase)(i.id,l.id)===0}e.areSameExtensions=C;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class T{static create(l){const u=l.manifest?l.manifest.version:l.version,s=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new T(l.identifier,u,s)}static parse(l){const u=R.exec(l);return u&&u[1]&&u[2]?new T({id:u[1]},u[2],u[4]||void 0):null}constructor(l,u,s="undefined"){this.version=u,this.targetPlatform=s,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof T?C(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.ExtensionKey=T;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(i){const l=E.exec(i);return l&&l[1]?[d(l[1]),l[2]]:[d(i),void 0]}e.getIdAndVersion=y;function v(i,l){return`${i}.${l}`}e.getExtensionId=v;function d(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=d;function b(i,l){return d(v(i,l))}e.getGalleryExtensionId=b;function f(i,l){const u=[],s=c=>{for(const n of u)if(n.some(r=>C(l(r),l(c))))return n;return null};for(const c of i){const n=s(c);n?n.push(c):u.push([c])}return u}e.groupByExtension=f;function w(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=w;function h(i){return{id:i.identifier.id,name:i.name,galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=h,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function m(i,l){const u=[],s=l.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const c=s.shift();if(c&&u.every(n=>!C(n.identifier,{id:c}))){const n=i.filter(r=>C(r.identifier,{id:c}));n.length===1&&(u.push(n[0]),s.push(...n[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}e.getExtensionDependencies=m;async function p(i,l){if(!A.isLinux)return!1;let u;try{u=(await i.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{u=(await i.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){l.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(c))}}return!!u&&(u.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=p;async function o(i,l){const u=await p(i,l),s=(0,t.getTargetPlatform)(u?"alpine":A.platform,S.arch);return l.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=o}),define(Se[204],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class a{constructor(){this.b=new Map}c(){return new Promise((I,A)=>ne(["vsda"],I,A))}async createNewMessage(I){try{const A=await this.c(),D=new A.validator;if(D){const k=String(a.a++);return this.b.set(k,D),{id:k,data:D.createNewMessage(I)}}}catch{}return{id:"",data:I}}async validate(I,A){if(!I.id)return!0;const D=this.b.get(I.id);if(!D)return!1;this.b.delete(I.id);try{return D.validate(A)==="ok"}catch{return!1}}async sign(I){try{const A=await this.c(),D=new A.signer;if(D)return D.sign(I)}catch{}return I}}e.SignService=a,a.a=1}),define(Se[205],ye([1,0,12,36,2,30]),function(ne,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(C){if(a.platform===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}async function k(C,R,T,E,y,v,d,b,f,w){const h=Object.create(null);h["common.machineId"]=d,h.sessionID=(0,A.generateUuid)()+Date.now(),h.commitHash=y,h.version=v,h["common.platformVersion"]=(R||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,a.PlatformToString)(a.platform),h["common.nodePlatform"]=t.platform,h["common.nodeArch"]=E,h["common.product"]=w||"desktop",b&&(h["common.msftInternal"]=b);let m=0;const p=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>m++,enumerable:!0}}),a.isLinuxSnap&&(h["common.snap"]="true");const o=D(T);o&&(h["common.platformDetail"]=o);try{const i=await C.readFile(I.URI.file(f));h["common.source"]=i.value.toString().slice(0,30)}catch{}return h}e.resolveCommonProperties=k;function S(C){const R=t.env.USERDNSDOMAIN;if(!R)return!1;const T=R.toLowerCase();return C.some(E=>T===E)}e.verifyMicrosoftInternalDomain=S}),define(Se[206],ye([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,a.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,a.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var I;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(I=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Se[128],ye([1,0,23,11,52,67,205,206]),function(ne,e,a,t,I,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class S{constructor(c){this.value=c}}e.TrustedTelemetryValue=S;class C{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(c,n){return Promise.resolve(void 0)}publicLog2(c,n){return this.publicLog(c,n)}publicLogError(c,n){return Promise.resolve(void 0)}publicLogError2(c,n){return this.publicLogError(c,n)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=C,e.NullTelemetryService=new C;class R{async publicLog(c,n,r){}async publicLogError(c,n,r){}}e.NullEndpointTelemetryService=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function T(s,c){return c.onDidChangeConfiguration(n=>{n.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,I.ConfigurationTargetToString)(n.source),configurationKeys:h(n.sourceConfig)})})}e.configurationTelemetry=T;function E(s,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!s.enableTelemetry||c.extensionTestsLocationURI)}e.supportsTelemetry=E;function y(s,c){return!(c.isBuilt||c.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.isLoggingOnly=y;function v(s){const c=s.getValue(k.TELEMETRY_SETTING_ID),n=s.getValue("telemetry.enableCrashReporter");if(s.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function d(s){const c={},n={},r={};w(s,r);for(let g in r){g=g.length>150?g.substr(g.length-149):g;const P=r[g];typeof P=="number"?n[g]=P:typeof P=="boolean"?n[g]=P?1:0:typeof P=="string"?(P.length>8192&&console.warn(`Telemetry property: ${g} has been trimmed to 8192, the original length is ${P.length}`),c[g]=P.substring(0,8191)):typeof P<"u"&&P!==null&&(c[g]=P)}return{properties:c,measurements:n}}e.validateTelemetryData=d;const b=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function f(s){if(!s)return"none";const c=(0,A.getRemoteName)(s);return b.has(c)?c:"other"}e.cleanRemoteAuthority=f;function w(s,c,n=0,r){if(!!s)for(const g of Object.getOwnPropertyNames(s)){const P=s[g],L=r?r+g:g;Array.isArray(P)?c[L]=(0,a.safeStringify)(P):P instanceof Date?c[L]=P.toISOString():(0,t.isObject)(P)?n<2?w(P,c,n+1,L+"."):c[L]=(0,a.safeStringify)(P):c[L]=P}}function h(s){if(!s)return[];const c=[];return m(c,"",s),c}function m(s,c,n){n&&typeof n=="object"&&!Array.isArray(n)?Object.keys(n).forEach(r=>m(s,c?`${c}.${r}`:r,n[r])):s.push(c)}function p(s,c){const n=s.msftInternalDomains||[],r=c.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(n)||r}e.isInternalTelemetry=p;function o(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.getPiiPathsFromEnvironment=o;function i(s,c){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let n=s;const r=[];for(const z of c)for(;;){const _=z.exec(s);if(!_)break;r.push([_.index,z.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,P=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let L=0;for(n="";;){const z=P.exec(s);if(!z)break;const _=r.some(([K,F])=>z.index<F&&K<P.lastIndex);!g.test(z[0])&&!_&&(n+=s.substring(L,z.index)+"<REDACTED: user-file-path>",L=P.lastIndex)}return L<s.length&&(n+=s.substr(L)),n}function l(s){if(!s)return s;const c=s.toLowerCase(),n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(c))return`<REDACTED: ${r.label}>`;return s}function u(s,c){return(0,a.cloneAndChange)(s,n=>{if(n instanceof S)return n.value;if(typeof n=="string"){let r=n.replaceAll("%20"," ");r=i(r,c);for(const g of c)r=r.replace(g,"");return r=l(r),r}})}e.cleanData=u}),define(Se[207],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class a{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,A,D=5){const k=A(S=>{const C=typeof S=="string"?S:S.data;let R=this.a.get(I);if(R){R.data.push(C);return}const T=setTimeout(()=>this.flushBuffer(I),D);R={data:[C],timeoutId:T,dispose:()=>{clearTimeout(T),this.flushBuffer(I),k.dispose()}},this.a.set(I,R)});return k}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const A=this.a.get(I);A&&(this.a.delete(I),this.b(I,A.data.join("")))}}e.TerminalDataBufferer=a}),define(Se[208],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var a;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST_DARK="hcDark",A.HIGH_CONTRAST_LIGHT="hcLight"})(a=e.ColorScheme||(e.ColorScheme={}));function t(A){return A===a.HIGH_CONTRAST_DARK||A===a.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function I(A){return A===a.DARK||A===a.HIGH_CONTRAST_DARK}e.isDark=I}),define(Se[89],ye([1,0,79,4,6,3,43,208]),function(ne,e,a,t,I,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var S;(function(b){function f(w){return w&&typeof w=="object"&&typeof w.id=="string"}b.isThemeColor=f})(S=e.ThemeColor||(e.ThemeColor={}));function C(b){return{id:b}}e.themeColorFromId=C;var R;(function(b){function f(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||S.isThemeColor(u.color))}b.isThemeIcon=f;const w=new RegExp(`^\\$\\((${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?)\\)$`);function h(u){const s=w.exec(u);if(!s)return;const[,c]=s;return{id:c}}b.fromString=h;function m(u){return{id:u}}b.fromId=m;function p(u,s){let c=u.id;const n=c.lastIndexOf("~");return n!==-1&&(c=c.substring(0,n)),s&&(c=`${c}~${s}`),{id:c}}b.modify=p;function o(u){const s=u.id.lastIndexOf("~");if(s!==-1)return u.id.substring(s+1)}b.getModifier=o;function i(u,s){return u.id===s.id&&u.color?.id===s.color?.id}b.isEqual=i;function l(u,s){return{id:u.id,color:s?C(s):void 0}}b.asThemeIcon=l,b.asClassNameArray=a.CSSIcon.asClassNameArray,b.asClassName=a.CSSIcon.asClassName,b.asCSSSelector=a.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=a.Codicon.file,e.FolderThemeIcon=a.Codicon.folder;function T(b){switch(b){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case k.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=T,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(f){return this.a.push(f),this.b.fire(f),(0,I.toDisposable)(()=>{const w=this.a.indexOf(f);this.a.splice(w,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const y=new E;D.Registry.add(e.Extensions.ThemingContribution,y);function v(b){return y.onColorThemeChange(b)}e.registerThemingParticipant=v;class d extends I.Disposable{constructor(f){super(),this.k=f,this.h=f.getColorTheme(),this.B(this.k.onDidColorThemeChange(w=>this.n(w)))}n(f){this.h=f,this.updateStyles()}updateStyles(){}w(f,w){let h=this.h.getColor(f);return h&&w&&(h=w(h,this.h)),h?h.toString():null}}e.Themable=d}),define(Se[129],ye([1,0,4,52,3,13]),function(ne,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,I.createDecorator)("sharedTunnelsService");var D;(function(d){d.Http="http",d.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function C(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const b=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!b)return{address:b[1],port:+b[2]}}e.extractLocalHostUriMetaDataForPortMapping=C,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function T(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=T;function E(d,b,f,w){if(f===1)return!1;if(f===2&&T(b)){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(w);if(h?.length===4&&parseInt(h[1])>=18)return!1}return d<1024}e.isPortPrivileged=E;class y{constructor(b,f,w){this.remoteAddress=b,this.localAddress=f,this.b=w,this.a=new a.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=y;let v=class{constructor(b,f){this.i=b,this.j=f,this.a=new a.Emitter,this.onTunnelOpened=this.a.event,this.b=new a.Emitter,this.onTunnelClosed=this.b.event,this.c=new a.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const b=this.j.getValue("remote.localPortHost");return!b||b==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(b){return this.e=b,b?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(b){this.f=b.elevation,this.g=b.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const b=[],f=Array.from(this.d.values());for(const w of f){const h=Array.from(w.values());for(const m of h){const p=await m.value;p&&b.push(p)}}return b}async dispose(){for(const b of this.d.values()){for(const{value:f}of b.values())await f.then(w=>w?.dispose());b.clear()}this.d.clear()}setEnvironmentTunnel(b,f,w,h,m){this.o(b,f,Promise.resolve({tunnelRemoteHost:b,tunnelRemotePort:f,localAddress:w,privacy:h,protocol:m,dispose:()=>Promise.resolve()}))}async getExistingTunnel(b,f){(T(b)||R(b))&&(b=e.LOCALHOST_ADDRESSES[0]);const w=this.q(b,f);if(w)return++w.refcount,w.value}openTunnel(b,f,w,h,m=!1,p,o){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${w} on local port ${h}.`),!b)return;if(f||(f="localhost"),this.e&&this.h.has(w)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(b,f,w,h,m,p,o);return i?i.then(l=>{if(!l){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(f,w);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const u=this.m(l);return(l.tunnelRemoteHost!==f||l.tunnelRemotePort!==w)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(u),u}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(b){return{tunnelRemotePort:b.tunnelRemotePort,tunnelRemoteHost:b.tunnelRemoteHost,tunnelLocalPort:b.tunnelLocalPort,localAddress:b.localAddress,privacy:b.privacy,protocol:b.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${b.tunnelRemoteHost}:${b.tunnelRemotePort} `);const f=this.d.get(b.tunnelRemoteHost);if(f){const w=f.get(b.tunnelRemotePort);w&&(w.refcount--,await this.n(b.tunnelRemoteHost,b.tunnelRemotePort,w))}}}}async n(b,f,w){if(w.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${b}:${f}.`);const h=w.value.then(async m=>{m&&(await m.dispose(!0),this.b.fire({host:m.tunnelRemoteHost,port:m.tunnelRemotePort}))});return this.d.has(b)&&this.d.get(b).delete(f),h}}async closeTunnel(b,f){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${b}:${f} `);const w=this.d.get(b);if(w&&w.has(f)){const h=w.get(f);h.refcount=0,await this.n(b,f,h)}}o(b,f,w){this.d.has(b)||this.d.set(b,new Map),this.d.get(b).set(f,{refcount:1,value:w})}async p(b,f){const w=this.d.get(b);w&&(await w.get(f)||w.delete(f),w.size===0&&this.d.delete(b))}q(b,f){const w=[b];R(b)?(w.push(...e.LOCALHOST_ADDRESSES),w.push(...e.ALL_INTERFACES_ADDRESSES)):T(b)&&w.push(...e.ALL_INTERFACES_ADDRESSES);const h=w.map(m=>this.d.get(m));for(const m of h){const p=m?.get(f);if(p)return p}}canTunnel(b){return!!C(b)}s(b,f,w,h,m,p,o){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${w} on local port ${h}.`);const i=w;this.h.add(i);const l=h===void 0?w:h,u={elevationRequired:m?this.isPortPrivileged(l):!1},s={remoteAddress:{host:f,port:w},localAddressPort:h,privacy:p,public:p?p!==k.Private:void 0,protocol:o},c=b.forwardPort(s,u);return c?(this.o(f,w,c),c.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(i)})):this.h.delete(i),c}};v=qe([We(0,A.ILogService),We(1,t.IConfigurationService)],v),e.AbstractTunnelService=v}),define(Se[209],ye([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,a.createDecorator)("editSessionIdentityService");var t;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(t=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Se[210],ye([1,0,15]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(S){return S.scheme!==a.Schemas.file&&S.scheme!==a.Schemas.vscodeRemote}e.isVirtualResource=t;function I(S){if(S.folders.length)return S.folders.every(C=>t(C.uri))?S.folders[0].uri:void 0;if(S.configuration&&t(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=I;function A(S){return I(S)?.scheme}e.getVirtualWorkspaceScheme=A;function D(S){return I(S)?.authority}e.getVirtualWorkspaceAuthority=D;function k(S){return I(S)!==void 0}e.isVirtualWorkspace=k}),define(Se[46],ye([1,0,172,9,64,24,2,3,15]),function(ne,e,a,t,I,A,D,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function C(i){const l=i;return typeof l?.id=="string"&&D.URI.isUri(l.uri)}e.isSingleFolderWorkspaceIdentifier=C,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function R(i,l){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,t.basename)(i)}:l?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const u=i;if(u.configuration)return{id:u.id,configPath:u.configuration};if(u.folders.length===1)return{id:u.id,uri:u.folders[0].uri}}e.toWorkspaceIdentifier=R;function T(i){const l=i;return typeof l?.id=="string"&&D.URI.isUri(l.configPath)}e.isWorkspaceIdentifier=T;function E(i){const l=i;if(l?.uri)return{id:l.id,uri:D.URI.revive(l.uri)};const u=i;if(u?.configPath)return{id:u.id,configPath:D.URI.revive(u.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=E;var y;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function v(i){const l=i;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.isWorkspace=v;function d(i){const l=i;return!!(l&&typeof l=="object"&&D.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.isWorkspaceFolder=d;class b{constructor(l,u,s,c,n){this.h=l,this.j=s,this.k=c,this.l=n,this.c=I.TernarySearchTree.forUris(this.l,()=>!0),this.folders=u}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=I.TernarySearchTree.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=b;class f{constructor(l,u){this.raw=u,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,A.joinPath)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=f;function w(i){return new f({uri:i,index:0,name:(0,A.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=w,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,a.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function h(i,l){return A.extUriBiasedIgnorePathCase.isEqualOrParent(i,l.untitledWorkspacesHome)}e.isUntitledWorkspace=h;function m(i){let l;return D.URI.isUri(i)?l=i:l=i.configuration,l?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=m;function p(i,l){return!h(i,l)&&!m(i)}e.isSavedWorkspace=p;function o(i){return(typeof i=="string"?(0,t.extname)(i):(0,A.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=o}),define(Se[68],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class a{constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const A=this.c++;return this.b.set(A,I),this.e(),A}get(I,A){return this.b.has(I)?this.b.get(I)[A]:void 0}delete(I){this.b.delete(I),this.e()}e(){!a.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=a,a.a=!1}),define(Se[47],ye([1,0,15,24,3]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this.a=new Set(Object.keys(a.Schemas)),this.b=new Map,this.extUri=new t.ExtUri(k=>{const S=this.b.get(k.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(k,S){S===null?this.b.delete(k.scheme):this.b.set(k.scheme,S)}isFreeScheme(k){return!this.b.has(k)&&!this.a.has(k)}getCapabilities(k){return this.b.get(k)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(Se[25],ye([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,a.createDecorator)("IExtHostInitDataService")}),define(Se[211],ye([1,0,18]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(D,k,S){this.h=new Map,this.a=D,this.b=k,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(C=>(this.f=C,this)),this.g=this.c.onDidChangeStorage(C=>{C.shared===this.b&&C.key===this.a&&(this.f=C.value)}),this.i=new a.RunOnceScheduler(()=>{const C=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of C.values())R.complete()}catch(R){for(const T of C.values())T.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,D])=>D!==void 0).map(([D])=>D)}get whenReady(){return this.d}get(D,k){let S=this.f[D];return typeof S>"u"&&(S=k),S}update(D,k){this.f[D]=k;const S=this.h.get(D);if(S!==void 0)return S.p;const C=new a.DeferredPromise;return this.h.set(D,C),this.i.isScheduled()||this.i.schedule(),C.p}dispose(){this.g.dispose()}}e.ExtensionMemento=t;class I extends t{setKeysForSync(D){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},D)}constructor(D,k){super(D.identifier.value,!0,k),this.j=D}}e.ExtensionGlobalMemento=I}),define(Se[212],ye([1,0,4,2]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class I{constructor(D){this.c=D,this.a=new a.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new a.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(D,k,S,C){const T=this.c.getNotebookDocument(t.URI.revive(D)).acceptModelChanged(k.value,S,C);this.b.fire(T)}$acceptDirtyStateChanged(D,k){this.c.getNotebookDocument(t.URI.revive(D)).acceptDirty(k)}$acceptModelSaved(D){const k=this.c.getNotebookDocument(t.URI.revive(D));this.a.fire(k.apiNotebook)}}e.ExtHostNotebookDocuments=I}),define(Se[16],ye([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,a.createDecorator)("IExtHostRpcService");class t{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=t});var Je=this&&this.__classPrivateFieldSet||function(ne,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ne,a):I?I.value=a:e.set(ne,a),a},Me=this&&this.__classPrivateFieldGet||function(ne,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[213],ye([1,0,27,4]),function(ne,e,a,t){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(k,S){I.set(this,void 0),this.b=new t.Emitter,this.onDidChange=this.b.event,this.a=a.ExtensionIdentifier.toKey(k.identifier),Je(this,I,S,"f"),Me(this,I,"f").onDidChangePassword(C=>{C.extensionId===this.a&&this.b.fire({key:C.key})})}get(k){return Me(this,I,"f").get(this.a,k)}store(k,S){return Me(this,I,"f").store(this.a,k,S)}delete(k){return Me(this,I,"f").delete(this.a,k)}}e.ExtensionSecrets=A,I=new WeakMap}),define(Se[54],ye([1,0,3,129,4,16]),function(ne,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var D;(function(S){function C(T){return{remoteAddress:T.remoteAddress,localAddress:T.localAddress,public:!!T.public,privacy:T.privacy??(T.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:T.protocol}}S.fromApiTunnel=C;function R(T){return{remoteAddress:{host:T.tunnelRemoteHost,port:T.tunnelRemotePort},localAddress:T.localAddress,public:T.privacy!==t.TunnelPrivacyId.ConstantPrivate&&T.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:T.privacy,protocol:T.protocol}}S.fromServiceTunnel=R})(D=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,a.createDecorator)("IExtHostTunnelService");let k=class{constructor(C){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(C){return C}async openTunnel(C,R){}async getTunnels(){return[]}async setTunnelFactory(C){return{dispose:()=>{}}}registerPortsAttributesProvider(C,R){return{dispose:()=>{}}}async $providePortAttributes(C,R,T,E,y){return[]}async $forwardPort(C,R){}async $closeTunnel(C){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=qe([We(0,A.IExtHostRpcService)],k),e.ExtHostTunnelService=k}),define(Se[55],ye([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,a.createDecorator)("IURITransformerService");class t{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=D=>D,this.transformOutgoing=D=>D,this.transformOutgoingURI=D=>D,this.transformOutgoingScheme=D=>D)}}e.URITransformerService=t}),define(Se[214],ye([1,0,22]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(S){let C=this.buffers.indexOf(S);return C<0&&(C=this.buffers.length,this.buffers.push(S)),C}}function I(k,S){if(S.serializeBuffersForPostMessage){const C=new t,R=(y,v)=>{if(v instanceof ArrayBuffer){const d=C.add(v);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(v)){const d=A(v);if(d){const b=C.add(v.buffer);return{$$vscode_array_buffer_reference$$:!0,index:b,view:{type:d,byteLength:v.byteLength,byteOffset:v.byteOffset}}}}return v},T=JSON.stringify(k,R),E=C.buffers.map(y=>{const v=new Uint8Array(y);return a.VSBuffer.wrap(v)});return{message:T,buffers:E}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=I;function A(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function D(k,S){const C=S.map(E=>{const y=new ArrayBuffer(E.byteLength);return new Uint8Array(y).set(E.buffer),y}),R=S.length?(E,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const v=y,{index:d}=v,b=C[d];if(v.view)switch(v.view.type){case 1:return new Int8Array(b,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(b,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(b,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(b,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(b,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(b,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(b,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(b,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(b,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(b,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(b,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return b}return y}:void 0;return{message:JSON.parse(k,R),arrayBuffers:C}}e.deserializeWebviewMessage=D}),define(Se[215],ye([1,0,112]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(A){return{transformIncoming:D=>D.scheme==="vscode-remote"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="file"?{scheme:"vscode-local",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoing:D=>D.scheme==="file"?{scheme:"vscode-remote",authority:A,path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="vscode-local"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoingScheme:D=>D==="file"?"vscode-remote":D==="vscode-local"?"file":D}}function I(A){return new a.URITransformer(t(A))}e.createURITransformer=I}),define(Se[130],ye([1,0,182,11,2,6,3,43,38,15]),function(ne,e,a,t,I,A,D,k,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,a.localize)(0,null),providerDisplayName:(0,a.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var R;(function(x){x[x.PROGRAMMATIC=1]="PROGRAMMATIC",x[x.USER=2]="USER",x[x.EDIT=3]="EDIT",x[x.NAVIGATION=4]="NAVIGATION",x[x.JUMP=5]="JUMP"})(R=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var T;(function(x){x[x.IDENTICAL=1]="IDENTICAL",x[x.SIMILAR=2]="SIMILAR",x[x.DIFFERENT=3]="DIFFERENT"})(T=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function E(x){const V=x;return!!V&&typeof V.getSelection=="function"&&!!V.onDidChangeSelection}e.isEditorPaneWithSelection=E;function y(x,V,X){for(const Q of X.visibleEditorPanes)if(Q.group.id===V&&x.matches(Q.input))return Q.getViewState()}e.findViewStateForEditor=y;function v(x){if(s(x))return!1;const V=x;return I.URI.isUri(V?.resource)}e.isResourceEditorInput=v;function d(x){if(s(x))return!1;const V=x;return V?.original!==void 0&&V.modified!==void 0}e.isResourceDiffEditorInput=d;function b(x){if(s(x)||d(x))return!1;const V=x;return V?.primary!==void 0&&V.secondary!==void 0}e.isResourceSideBySideEditorInput=b;function f(x){if(s(x))return!1;const V=x;return V?V.resource===void 0||V.resource.scheme===C.Schemas.untitled||V.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=f;const w=/Untitled-\d+/;function h(x){return x.scheme===C.Schemas.untitled&&x.path.length>1&&!w.test(x.path)}e.isUntitledWithAssociatedResource=h;function m(x){if(s(x))return!1;const V=x;return I.URI.isUri(V?.base?.resource)&&I.URI.isUri(V?.input1?.resource)&&I.URI.isUri(V?.input2?.resource)&&I.URI.isUri(V?.result?.resource)}e.isResourceMergeEditorInput=m;var p;(function(x){x[x.SHORT=0]="SHORT",x[x.MEDIUM=1]="MEDIUM",x[x.LONG=2]="LONG"})(p=e.Verbosity||(e.Verbosity={}));var o;(function(x){x[x.EXPLICIT=1]="EXPLICIT",x[x.AUTO=2]="AUTO",x[x.FOCUS_CHANGE=3]="FOCUS_CHANGE",x[x.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(o=e.SaveReason||(e.SaveReason={}));class i{constructor(){this.a=new Map}registerSource(V,X){let Q=this.a.get(V);return Q||(Q={source:V,label:X},this.a.set(V,Q)),Q.source}getSourceLabel(V){return this.a.get(V)?.label??V}}e.SaveSourceRegistry=new i;var l;(function(x){x[x.None=0]="None",x[x.Readonly=2]="Readonly",x[x.Untitled=4]="Untitled",x[x.Singleton=8]="Singleton",x[x.RequiresTrust=16]="RequiresTrust",x[x.CanSplitInGroup=32]="CanSplitInGroup",x[x.ForceDescription=64]="ForceDescription",x[x.CanDropIntoEditor=128]="CanDropIntoEditor",x[x.MultipleEditors=256]="MultipleEditors"})(l=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class u extends A.Disposable{}e.AbstractEditorInput=u;function s(x){return x instanceof u}e.isEditorInput=s;function c(x){const V=x;return I.URI.isUri(V?.preferredResource)}function n(x){const V=x;return s(V?.primary)&&s(V?.secondary)}e.isSideBySideEditorInput=n;function r(x){const V=x;return s(V?.modified)&&s(V?.original)}e.isDiffEditorInput=r;function g(x){return s(x?.editor)}e.isEditorInputWithOptions=g;function P(x){const V=x;return g(x)&&V?.group!==void 0}e.isEditorInputWithOptionsAndGroup=P;function L(x){const V=x;return typeof V?.groupId=="number"&&s(V.editor)}e.isEditorIdentifier=L;var z;(function(x){x[x.UNKNOWN=0]="UNKNOWN",x[x.REPLACE=1]="REPLACE",x[x.MOVE=2]="MOVE",x[x.UNPIN=3]="UNPIN"})(z=e.EditorCloseContext||(e.EditorCloseContext={}));var _;(function(x){x[x.GROUP_ACTIVE=0]="GROUP_ACTIVE",x[x.GROUP_INDEX=1]="GROUP_INDEX",x[x.GROUP_LOCKED=2]="GROUP_LOCKED",x[x.EDITOR_OPEN=3]="EDITOR_OPEN",x[x.EDITOR_CLOSE=4]="EDITOR_CLOSE",x[x.EDITOR_MOVE=5]="EDITOR_MOVE",x[x.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",x[x.EDITOR_LABEL=7]="EDITOR_LABEL",x[x.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",x[x.EDITOR_PIN=9]="EDITOR_PIN",x[x.EDITOR_STICKY=10]="EDITOR_STICKY",x[x.EDITOR_DIRTY=11]="EDITOR_DIRTY",x[x.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(_=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var K;(function(x){x[x.PRIMARY=1]="PRIMARY",x[x.SECONDARY=2]="SECONDARY",x[x.BOTH=3]="BOTH",x[x.ANY=4]="ANY"})(K=e.SideBySideEditor||(e.SideBySideEditor={}));class F{getOriginalUri(V,X){if(!V)return;if(m(V))return e.EditorResourceAccessor.getOriginalUri(V.result,X);if(X?.supportSideBySide){const{primary:J,secondary:te}=this.a(V);if(J&&te){if(X?.supportSideBySide===K.BOTH)return{primary:this.getOriginalUri(J,{filterByScheme:X.filterByScheme}),secondary:this.getOriginalUri(te,{filterByScheme:X.filterByScheme})};if(X?.supportSideBySide===K.ANY)return this.getOriginalUri(J,{filterByScheme:X.filterByScheme})??this.getOriginalUri(te,{filterByScheme:X.filterByScheme});V=X.supportSideBySide===K.PRIMARY?J:te}}if(d(V)||b(V)||m(V))return;const Q=c(V)?V.preferredResource:V.resource;return!Q||!X||!X.filterByScheme?Q:this.b(Q,X.filterByScheme)}a(V){return n(V)||b(V)?{primary:V.primary,secondary:V.secondary}:r(V)||d(V)?{primary:V.modified,secondary:V.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(V,X){if(!V)return;if(m(V))return e.EditorResourceAccessor.getCanonicalUri(V.result,X);if(X?.supportSideBySide){const{primary:J,secondary:te}=this.a(V);if(J&&te){if(X?.supportSideBySide===K.BOTH)return{primary:this.getCanonicalUri(J,{filterByScheme:X.filterByScheme}),secondary:this.getCanonicalUri(te,{filterByScheme:X.filterByScheme})};if(X?.supportSideBySide===K.ANY)return this.getCanonicalUri(J,{filterByScheme:X.filterByScheme})??this.getCanonicalUri(te,{filterByScheme:X.filterByScheme});V=X.supportSideBySide===K.PRIMARY?J:te}}if(d(V)||b(V)||m(V))return;const Q=V.resource;return!Q||!X||!X.filterByScheme?Q:this.b(Q,X.filterByScheme)}b(V,X){if(Array.isArray(X)){if(X.some(Q=>V.scheme===Q))return V}else if(X===V.scheme)return V}}e.EditorResourceAccessor=new F;var M;(function(x){x[x.LEFT=0]="LEFT",x[x.RIGHT=1]="RIGHT"})(M=e.CloseDirection||(e.CloseDirection={}));class N{constructor(){this.c=new Map,this.d=new Map}start(V){const X=this.a=V.get(D.IInstantiationService);for(const[Q,J]of this.c)this.e(Q,J,X);this.c.clear()}e(V,X,Q){const J=Q.createInstance(X);this.d.set(V,J)}registerFileEditorFactory(V){if(this.b)throw new Error("Can only register one file editor factory.");this.b=V}getFileEditorFactory(){return(0,t.assertIsDefined)(this.b)}registerEditorSerializer(V,X){if(this.c.has(V)||this.d.has(V))throw new Error(`A editor serializer with type ID '${V}' was already registered.`);return this.a?this.e(V,X,this.a):this.c.set(V,X),(0,A.toDisposable)(()=>{this.c.delete(V),this.d.delete(V)})}getEditorSerializer(V){return this.d.get(typeof V=="string"?V:V.typeId)}}k.Registry.add(e.EditorExtensions.EditorFactory,new N);async function B(x,V,X){return!x||!x.length?[]:await Promise.all(x.map(async Q=>{const J=I.URI.revive(Q.fileUri);if(!J){X.info("Cannot resolve the path because it is not valid.",Q);return}if(!await V.canHandleResource(J)){X.info("Cannot resolve the path because it cannot be handled",Q);return}let le=Q.exists,Z=Q.type;if(typeof le!="boolean"||typeof Z!="number")try{Z=(await V.stat(J)).isDirectory?S.FileType.Directory:S.FileType.Unknown,le=!0}catch(ve){X.error(ve),le=!1}if(!le&&Q.openOnlyIfExists){X.info("Cannot resolve the path because it does not exist",Q);return}if(Z===S.FileType.Directory){X.info("Cannot resolve the path because it is a directory",Q);return}const ge={...Q.options,pinned:!0};return le?{resource:J,options:ge}:{resource:J,options:ge,forceUntitled:!0}}))}e.pathsToEditors=B;var U;(function(x){x[x.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",x[x.SEQUENTIAL=1]="SEQUENTIAL"})(U=e.EditorsOrder||(e.EditorsOrder={}));function W(x){const V=x;if(!V)return!1;const X=V;if(X.modified)return W(X.modified);const Q=V;return!!(Q.contributionsState&&Q.viewState&&Array.isArray(Q.cursorState))}e.isTextEditorViewState=W}),define(Se[131],ye([1,0,4,18,183]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.f=new Map,this.k=[],this.m=new a.Emitter,this.n=new a.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(k){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=k}onEvent(k){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=k}onRequest(k){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=k}sendResponse(k){k.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.s("response",k)}sendRequest(k,S,C,R){const T={command:k};if(S&&Object.keys(S).length>0&&(T.arguments=S),this.s("request",T),typeof R=="number"){const E=setTimeout(()=>{clearTimeout(E);const y=this.f.get(T.seq);if(y){this.f.delete(T.seq);const v={type:"response",seq:0,request_seq:T.seq,success:!1,command:k,message:(0,I.localize)(0,null,R,k)};y(v)}},R)}return C&&this.f.set(T.seq,C),T.seq}acceptMessage(k){this.j?this.j(k):(this.k.push(k),this.k.length===1&&this.q())}o(k,S){return k.type!=="event"||S.type!=="event"}async q(){let k;for(;this.k.length;){if((!k||this.o(this.k[0],k))&&await(0,t.timeout)(0),k=this.k.shift(),!k)return;switch(k.type){case"event":this.i?.(k);break;case"request":this.g?.(k);break;case"response":{const S=k,C=this.f.get(S.request_seq);C&&(this.f.delete(S.request_seq),C(S));break}}}}s(k,S){S.type=k,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const k=new Map;this.f.forEach((S,C)=>k.set(C,S)),await(0,t.timeout)(500),k.forEach((S,C)=>{S({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.f.delete(C)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=A}),define(Se[216],ye([1,0,184,53,3]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:a.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:a.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:a.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:a.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:a.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:a.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:a.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:a.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:a.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:a.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:a.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:a.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:a.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:a.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:a.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:a.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:a.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:a.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:a.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:a.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:a.localize(20,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:a.localize(21,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:a.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:a.localize(23,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:a.localize(24,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:a.localize(25,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:a.localize(26,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:a.localize(27,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:a.localize(28,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:a.localize(29,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:a.localize(30,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:a.localize(31,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:a.localize(32,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:a.localize(33,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:a.localize(34,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:a.localize(35,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:a.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:a.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:a.localize(38,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:a.localize(39,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:a.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:a.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:a.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:a.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:a.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:a.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:a.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:a.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:a.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:a.localize(49,null)});const A=E=>a.localize(50,null,E);e.debuggerDisabledMessage=A,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:a.localize(51,null)};var D;(function(E){E[E.Inactive=0]="Inactive",E[E.Initializing=1]="Initializing",E[E.Stopped=2]="Stopped",E[E.Running=3]="Running"})(D=e.State||(e.State={}));function k(E){switch(E){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=k;var S;(function(E){E[E.Valid=0]="Valid",E[E.Unreadable=1]="Unreadable",E[E.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var C;(function(E){E[E.Initial=1]="Initial",E[E.Dynamic=2]="Dynamic"})(C=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var R;(function(E){E.UnverifiedBreakpoints="unverifiedBreakpoints"})(R=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,I.createDecorator)("debugService");var T;(function(E){E[E.CONDITION=0]="CONDITION",E[E.HIT_COUNT=1]="HIT_COUNT",E[E.LOG_MESSAGE=2]="LOG_MESSAGE"})(T=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Se[217],ye([1,0,8,2,9,23,15]),function(ne,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function S(l,u,s){return l.replace(k,function(c,n){return u&&n.length>0&&n[0]!=="_"?c:s&&s.hasOwnProperty(n)?s[n]:c})}e.formatPII=S;function C(l){const u={};for(const s of Object.keys(l))s.startsWith("!")||(u[s]=l[s]);return u}e.filterExceptionsFromTelemetry=C;function R(l){return l.configuration.request==="attach"&&!T(l)&&(!l.parentSession||R(l.parentSession))}e.isSessionAttach=R;function T(l){let u=l.configuration.type;if(!!u)return u==="vslsShare"&&(u=l.configuration.adapterProxy.configuration.type),(0,a.equalsIgnoreCase)(u,"extensionhost")||(0,a.equalsIgnoreCase)(u,"pwa-extensionhost")?l:l.parentSession?T(l.parentSession):void 0}e.getExtensionHostDebugSession=T;function E(l){return l.type&&(l.label||l.program||l.runtime)}e.isDebuggerMainContribution=E;function y(l,u,s){let c,n=0;const r=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let g=null;for(;g=r.exec(l);){const P=g.index+1,L=P+g[0].length;if(P<=u&&L>=s){c=g[0],n=P;break}}if(c){const P=/\w+/g;let L=null;for(;(L=P.exec(c))&&!(L.index+1+n+L[0].length>=s););L&&(c=c.substring(0,P.lastIndex))}return c?{start:n,end:n+c.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=y;const v=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(l){return!!(l&&l.match(v))}e.isUri=d;function b(l){if(typeof l.path=="string"&&!(typeof l.sourceReference=="number"&&l.sourceReference>0)){if(d(l.path))return t.URI.parse(l.path);if((0,I.isAbsolute)(l.path))return t.URI.file(l.path)}return l.path}function f(l){if(typeof l.path=="object"){const u=t.URI.revive(l.path);if(u)return u.scheme===D.Schemas.file?u.fsPath:u.toString()}return l.path}function w(l,u){const s=u?b:f,c=(0,A.deepClone)(l);return m(c,(n,r)=>{n&&r&&(r.path=s(r))}),c}e.convertToDAPaths=w;function h(l,u){const s=u?b:f,c=(0,A.deepClone)(l);return m(c,(n,r)=>{!n&&r&&(r.path=s(r))}),c}e.convertToVSCPaths=h;function m(l,u){switch(l.type){case"event":{const s=l;switch(s.event){case"output":u(!1,s.body.source);break;case"loadedSource":u(!1,s.body.source);break;case"breakpoint":u(!1,s.body.breakpoint.source);break;default:break}break}case"request":{const s=l;switch(s.command){case"setBreakpoints":u(!0,s.arguments.source);break;case"breakpointLocations":u(!0,s.arguments.source);break;case"source":u(!0,s.arguments.source);break;case"gotoTargets":u(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(c=>u(!1,c));break;default:break}break}case"response":{const s=l;if(s.success&&s.body)switch(s.command){case"stackTrace":s.body.stackFrames.forEach(c=>u(!1,c.source));break;case"loadedSources":s.body.sources.forEach(c=>u(!1,c));break;case"scopes":s.body.scopes.forEach(c=>u(!1,c.source));break;case"setFunctionBreakpoints":s.body.breakpoints.forEach(c=>u(!1,c.source));break;case"setBreakpoints":s.body.breakpoints.forEach(c=>u(!1,c.source));break;case"disassemble":s.body?.instructions.forEach(n=>u(!1,n.location));break;default:break}break}}}function p(l){return l.filter(u=>!u.presentation?.hidden).sort((u,s)=>u.presentation?s.presentation?u.presentation.group?s.presentation.group?u.presentation.group!==s.presentation.group?u.presentation.group.localeCompare(s.presentation.group):o(u.presentation.order,s.presentation.order):-1:s.presentation.group?1:o(u.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=p;function o(l,u){return typeof l!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:l-u}async function i(l,u){const s=l.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(s!=="none"&&(await u.saveAll(),s==="allEditorsInActiveGroup")){const c=u.activeEditorPane;c&&c.input.resource?.scheme===D.Schemas.untitled&&await u.save({editor:c.input,groupId:c.group.id})}await l.reloadConfiguration()}e.saveAllBeforeDebugStart=i}),define(Se[218],ye([1,0,45,219,23,9,12,8,29,185,131]),function(ne,e,a,t,I,A,D,k,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class T extends R.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(f,w){this.p=w,this.r=Buffer.allocUnsafe(0),this.t=-1,f.on("data",h=>this.w(h))}sendMessage(f){if(this.p){const w=JSON.stringify(f);this.p.write(`Content-Length: ${Buffer.byteLength(w,"utf8")}${T.a}${w}`,"utf8")}}w(f){for(this.r=Buffer.concat([this.r,f]);;){if(this.t>=0){if(this.r.length>=this.t){const w=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,w.length>0)try{this.acceptMessage(JSON.parse(w))}catch(h){this.m.fire(new Error((h.message||h)+`
`+w))}continue}}else{const w=this.r.indexOf(T.a);if(w!==-1){const m=this.r.toString("utf8",0,w).split(T.b);for(const p of m){const o=p.split(T.l);o[0]==="Content-Length"&&(this.t=Number(o[1]))}this.r=this.r.slice(w+T.a.length);continue}}break}}}e.StreamDebugAdapter=T,T.a=`\r
\r
`,T.b=/\r?\n/,T.l=/: */;class E extends T{startSession(){return new Promise((f,w)=>{let h=!1;this.x=this.y(()=>{this.v(this.x,this.x),f(),h=!0}),this.x.on("close",()=>{h?this.m.fire(new Error("connection closed")):w(new Error("connection closed"))}),this.x.on("error",m=>{h?this.m.fire(m):w(m)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=E;class y extends E{constructor(f){super(),this.z=f}y(f){return t.createConnection(this.z.port,this.z.host||"127.0.0.1",f)}}e.SocketDebugAdapter=y;class v extends E{constructor(f){super(),this.z=f}y(f){return t.createConnection(this.z.path,f)}}e.NamedPipeDebugAdapter=v;class d extends T{constructor(f,w){super(),this.y=f,this.z=w}async startSession(){const f=this.y.command,w=this.y.args,h=this.y.options||{};try{if(f)if(A.isAbsolute(f)){if(!await S.Promises.exists(f))throw new Error(C.localize(0,null,f))}else f.indexOf("/")<0&&f.indexOf("\\")<0;else throw new Error(C.localize(1,null,this.z));let m=process.env;if(h.env&&Object.keys(h.env).length>0&&(m=I.mixin(I.deepClone(process.env),h.env)),f==="node")if(Array.isArray(w)&&w.length>0){const p=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,o={env:m,execArgv:p?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};h.cwd&&(o.cwd=h.cwd);const i=a.fork(w[0],w.slice(1),o);if(!i.pid)throw new Error(C.localize(2,null,w[0]));this.x=i}else throw new Error(C.localize(3,null));else{const p={env:m};h.cwd&&(p.cwd=h.cwd),this.x=a.spawn(f,w,p)}this.x.on("error",p=>{this.m.fire(p)}),this.x.on("exit",(p,o)=>{this.n.fire(p)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",p=>{this.m.fire(p)}),this.x.stdin.on("error",p=>{this.m.fire(p)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(m){this.m.fire(m)}}async stopSession(){return this.x?(await this.u(),D.isWindows?new Promise((f,w)=>{const h=a.exec(`taskkill /F /T /PID ${this.x.pid}`,function(m,p,o){if(m)return w(m)});h.on("exit",f),h.on("error",w)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(f,w){if(!f)return;const h=Object.create(null);f.runtime&&(f.runtime.indexOf("./")===0?h.runtime=A.join(w,f.runtime):h.runtime=f.runtime),f.runtimeArgs&&(h.runtimeArgs=f.runtimeArgs),f.program&&(A.isAbsolute(f.program)?h.program=f.program:h.program=A.join(w,f.program)),f.args&&(h.args=f.args);const m=f;return m.win&&(h.win=d.A(m.win,w)),m.winx86&&(h.winx86=d.A(m.winx86,w)),m.windows&&(h.windows=d.A(m.windows,w)),m.osx&&(h.osx=d.A(m.osx,w)),m.linux&&(h.linux=d.A(m.linux,w)),h}static platformAdapterExecutable(f,w){let h=Object.create(null);w=w.toLowerCase();for(const u of f)if(u.contributes){const s=u.contributes.debuggers;s&&s.length>0&&s.filter(c=>typeof c.type=="string"&&k.equalsIgnoreCase(c.type,w)).forEach(c=>{const n=d.A(c,u.extensionLocation.fsPath);h=I.mixin(h,n,u.isBuiltin)})}let m;D.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=h.winx86||h.win||h.windows:D.isWindows?m=h.win||h.windows:D.isMacintosh?m=h.osx:D.isLinux&&(m=h.linux),m=m||h;const p=m.program||h.program,o=m.args||h.args,i=m.runtime||h.runtime,l=m.runtimeArgs||h.runtimeArgs;if(i)return{type:"executable",command:i,args:(l||[]).concat(typeof p=="string"?[p]:[]).concat(o||[])};if(p)return{type:"executable",command:p,args:o||[]}}}e.ExecutableDebugAdapter=d}),define(Se[220],ye([1,0,45,32,12]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function A(C,R){return new Promise((T,E)=>{let y="";const v=a.spawn(C,R);v.pid&&v.stdout.on("data",d=>{y+=d.toString()}),v.on("error",d=>{E(d)}),v.on("close",d=>{T(y)})})}async function D(C){if(C)if(I.isWindows){const R=await new Promise((T,E)=>{ne(["windows-process-tree"],T,E)});return new Promise(T=>{R.getProcessTree(C,E=>{T(!!E&&E.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(C)]).then(R=>{const T=R.trim();return!(T.length===0||T.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.hasChildProcesses=D;var k;(function(C){C[C.cmd=0]="cmd",C[C.powershell=1]="powershell",C[C.bash=2]="bash"})(k||(k={}));function S(C,R,T,E,y){C=C.trim().toLowerCase();let v;C.indexOf("powershell")>=0||C.indexOf("pwsh")>=0?v=1:C.indexOf("cmd.exe")>=0?v=0:C.indexOf("bash")>=0?v=2:I.isWindows?v=0:v=2;let d,b=" ";switch(v){case 1:if(d=f=>(f=f.replace(/\'/g,"''"),f.length>0&&f.charAt(f.length-1)==="\\"?`'${f}\\'`:`'${f}'`),E){const f=(0,t.getDriveLetter)(E);f&&(b+=`${f}:; `),b+=`cd ${d(E)}; `}if(y)for(const f in y){const w=y[f];w===null?b+=`Remove-Item env:${f}; `:b+=`\${env:${f}}='${w}'; `}if(R.length>0){const f=R.shift(),w=T?f:d(f);b+=w[0]==="'"?`& ${w} `:`${w} `;for(const h of R)b+=h==="<"||h===">"||T?h:d(h),b+=" "}break;case 0:if(d=f=>(f=f.replace(/\"/g,'""'),f=f.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(w=>f.includes(w))||f.length===0?`"${f}"`:f),E){const f=(0,t.getDriveLetter)(E);f&&(b+=`${f}: && `),b+=`cd ${d(E)} && `}if(y){b+='cmd /C "';for(const f in y){let w=y[f];w===null?b+=`set "${f}=" && `:(w=w.replace(/[&^|<>]/g,h=>`^${h}`),b+=`set "${f}=${w}" && `)}}for(const f of R)b+=f==="<"||f===">"||T?f:d(f),b+=" ";y&&(b+='"');break;case 2:{d=w=>(w=w.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),w.length===0?'""':w);const f=w=>/[^\w@%\/+=,.:^-]/.test(w)?`'${w.replace(/'/g,"'\\''")}'`:w;if(E&&(b+=`cd ${d(E)} ; `),y){b+="/usr/bin/env";for(const w in y){const h=y[w];h===null?b+=` -u ${f(w)}`:b+=` ${f(`${w}=${h}`)}`}b+=" "}for(const w of R)b+=w==="<"||w===">"||T?w:d(w),b+=" ";break}}return b}e.prepareCommand=S}),define(Se[90],ye([1,0,22,37,62,83,15,9,12,53]),function(ne,e,a,t,I,A,D,k,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var R;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",A.Mimes.latex,A.Mimes.markdown,"image/png","image/jpeg",A.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[A.Mimes.latex,A.Mimes.markdown,"application/json",A.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var E;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(E=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var y;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(y=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var v;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(v=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var d;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(d=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var b;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(b=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));var w;(function(B){B.scheme=D.Schemas.vscodeNotebookCell;const U=["W","X","Y","Z","a","b","c","d","e","f"],W=new RegExp(`^[${U.join("")}]+`),x=7;function V(Z,ge){const ve=ge.toString(x),Re=`${ve.length<U.length?U[ve.length-1]:"z"}${ve}s${(0,a.encodeBase64)(a.VSBuffer.fromString(Z.scheme),!0,!0)}`;return Z.with({scheme:B.scheme,fragment:Re})}B.generate=V;function X(Z){if(Z.scheme!==B.scheme)return;const ge=Z.fragment.indexOf("s");if(ge<0)return;const ve=parseInt(Z.fragment.substring(0,ge).replace(W,""),x),De=(0,a.decodeBase64)(Z.fragment.substring(ge+1)).toString();if(!isNaN(ve))return{handle:ve,notebook:Z.with({scheme:De,fragment:null})}}B.parse=X;function Q(Z,ge){return Z.with({scheme:D.Schemas.vscodeNotebookCellOutput,fragment:`op${ge??""},${Z.scheme!==D.Schemas.file?Z.scheme:""}`})}B.generateCellOutputUri=Q;function J(Z){if(Z.scheme!==D.Schemas.vscodeNotebookCellOutput)return;const ge=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Z.fragment);if(!ge)return;const ve=ge[1]&&ge[1]!==""?ge[1]:void 0,De=ge[2];return{outputId:ve,notebook:Z.with({scheme:De||D.Schemas.file,fragment:null})}}B.parseCellOutputUri=J;function te(Z,ge,ve){return B.generate(Z,ge).with({scheme:ve})}B.generateCellPropertyUri=te;function le(Z,ge){if(Z.scheme===ge)return B.parse(Z.with({scheme:B.scheme}))}B.parseCellPropertyUri=le})(w=e.CellUri||(e.CellUri={}));const h=B=>S.isWindows?B.replace(/\//g,"\\"):B;class m{constructor(U=[],W=e.NOTEBOOK_DISPLAY_ORDER){this.e=W,this.d=[...new Set(U)].map(x=>({pattern:x,matches:t.parse(h(x))}))}sort(U){const W=new Map(I.Iterable.map(U,V=>[V,h(V)]));let x=[];for(const{matches:V}of this.d)for(const[X,Q]of W)if(V(Q)){x.push(X),W.delete(X);break}return W.size&&(x=x.concat([...W.keys()].sort((V,X)=>this.e.indexOf(V)-this.e.indexOf(X)))),x}prioritize(U,W){const x=this.f(U);if(x===-1){this.d.unshift({pattern:U,matches:t.parse(h(U))});return}const V=new Set(W.map(Q=>this.f(Q,x)));V.delete(-1);const X=Array.from(V).sort();this.d.splice(x+1,0,...X.map(Q=>this.d[Q]));for(let Q=X.length-1;Q>=0;Q--)this.d.splice(X[Q],1)}toArray(){return this.d.map(U=>U.pattern)}f(U,W=this.d.length){const x=h(U);for(let V=0;V<W;V++)if(this.d[V].matches(x))return V;return-1}}e.MimeTypeDisplayOrder=m;function p(B,U,W,x=(V,X)=>V===X){const V=[];function X(te,le,Z){if(le===0&&Z.length===0)return;const ge=V[V.length-1];ge&&ge.start+ge.deleteCount===te?(ge.deleteCount+=le,ge.toInsert.push(...Z)):V.push({start:te,deleteCount:le,toInsert:Z})}let Q=0,J=0;for(;;){if(Q===B.length){X(Q,0,U.slice(J));break}if(J===U.length){X(Q,B.length-Q,[]);break}const te=B[Q],le=U[J];if(x(te,le)){Q+=1,J+=1;continue}W(le)?(X(Q,1,[]),Q+=1):(X(Q,0,[le]),J+=1)}return V}e.diff=p,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var o;(function(B){B.default="default",B.option="option"})(o=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function i(B){const U=B;return!!((typeof U.include=="string"||t.isRelativePattern(U.include))&&(typeof U.exclude=="string"||t.isRelativePattern(U.exclude)))}e.isDocumentExcludePattern=i;function l(B,U,W){if(Array.isArray(B.viewType)&&B.viewType.indexOf(U)>=0||B.viewType===U)return!0;if(B.filenamePattern){const x=i(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,V=i(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(t.match(x,(0,k.basename)(W.fsPath).toLowerCase()))return!(V&&t.match(V,(0,k.basename)(W.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var u;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(u=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(U){return`${s.d}${U}`}static parse(U){if(U.startsWith(s.d))return U.substring(s.d.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s.d="notebook/";function c(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}e.isTextStreamMime=c;const n=new TextDecoder;function r(B){const U=[];let W=!1;for(const x of B)(U.length===0||W)&&(U.push(x),W=!0);return z(U),N(a.VSBuffer.concat(U.map(x=>a.VSBuffer.wrap(x))))}e.compressOutputItemStreams=r;const g=`${String.fromCharCode(27)}[A`,P=g.split("").map(B=>B.charCodeAt(0)),L=10;function z(B){B.forEach((U,W)=>{if(W===0||U.length<g.length)return;const x=B[W-1],V=U.subarray(0,g.length);if(V[0]===P[0]&&V[1]===P[1]&&V[2]===P[2]){const X=x.lastIndexOf(L);if(X===-1)return;B[W-1]=x.subarray(0,X),B[W]=U.subarray(g.length)}})}function _(B){let U=B;do B=U,U=B.replace(/[^\n]\x08/gm,"");while(U.length<B.length);return B}function K(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const U=B.match(/^(.*)\r+/m)[1];let W=B.match(/\r+(.*)$/m)[1];W=W+U.slice(W.length,U.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,W)}return B}const F="\b".charCodeAt(0),M="\r".charCodeAt(0);function N(B){return!B.buffer.includes(F)&&!B.buffer.includes(M)?B:a.VSBuffer.fromString(K(_(n.decode(B.buffer))))}}),define(Se[221],ye([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,a.createDecorator)("INotebookExecutionService")}),define(Se[222],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function a(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=a;function t(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=t;function I(D){return Array.from(D.entries()).map(k=>[k[0],a(k[1].map)])}e.serializeEnvironmentVariableCollections=I;function A(D){return new Map(D.map(k=>[k[0],{map:t(k[1])}]))}e.deserializeEnvironmentVariableCollections=A}),define(Se[56],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var a;(function(A){A.Delimiter="\0"})(a=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class I{static fromExtHostTestItem(D,k,S=D.parent){if(D._isRoot)return new I([k]);const C=[D.id];for(let R=S;R&&R.id!==k;R=R.parent)C.push(R.id);return C.push(k),new I(C.reverse())}static isRoot(D){return!D.includes("\0")}static root(D){const k=D.indexOf("\0");return k===-1?D:D.slice(0,k)}static fromString(D){return new I(D.split("\0"))}static join(D,k){return new I([...D.path,k])}static joinToString(D,k){return D.toString()+"\0"+k}static parentId(D){const k=D.lastIndexOf("\0");return k===-1?void 0:D.slice(0,k)}static compare(D,k){return D===k?0:k.startsWith(D+"\0")?2:D.startsWith(k+"\0")?3:1}constructor(D,k=D.length){if(this.path=D,this.d=k,D.length===0||k<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let D=1;D<=this.d;D++)yield new I(this.path,D)}*idsToRoot(){for(let D=this.d;D>0;D--)yield new I(this.path,D)}compare(D){if(typeof D=="string")return I.compare(this.toString(),D);for(let k=0;k<D.d&&k<this.d;k++)if(D.path[k]!==this.path[k])return 1;return D.d>this.d?2:D.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let D=1;D<this.d;D++)this.c+="\0",this.c+=this.path[D]}return this.c}}e.TestId=I}),define(Se[69],ye([1,0,2,35,56]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var A;(function(c){c[c.Unset=0]="Unset",c[c.Queued=1]="Queued",c[c.Running=2]="Running",c[c.Passed=3]="Passed",c[c.Failed=4]="Failed",c[c.Skipped=5]="Skipped",c[c.Errored=6]="Errored"})(A=e.TestResultState||(e.TestResultState={}));var D;(function(c){c[c.Run=2]="Run",c[c.Debug=4]="Debug",c[c.Coverage=8]="Coverage",c[c.HasNonDefaultProfile=16]="HasNonDefaultProfile",c[c.HasConfigurable=32]="HasConfigurable"})(D=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var k;(function(c){c.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),c.deserialize=n=>({range:t.Range.lift(n.range),uri:a.URI.revive(n.uri)})})(k=e.IRichLocation||(e.IRichLocation={}));var S;(function(c){c[c.Error=0]="Error",c[c.Output=1]="Output"})(S=e.TestMessageType||(e.TestMessageType={}));var C;(function(c){c.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&k.serialize(n.location)}),c.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&k.deserialize(n.location)})})(C=e.ITestErrorMessage||(e.ITestErrorMessage={}));const R=(c,n)=>`${n?"s":"e"}${c}`;e.getMarkId=R;var T;(function(c){c.serialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&k.serialize(n.location)}),c.deserialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&k.deserialize(n.location)})})(T=e.ITestOutputMessage||(e.ITestOutputMessage={}));var E;(function(c){c.serialize=n=>n.type===0?C.serialize(n):T.serialize(n),c.deserialize=n=>n.type===0?C.deserialize(n):T.deserialize(n)})(E=e.ITestMessage||(e.ITestMessage={}));var y;(function(c){c.serializeWithoutMessages=n=>({state:n.state,duration:n.duration,messages:[]}),c.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(E.serialize)}),c.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(E.deserialize)})})(y=e.ITestTaskState||(e.ITestTaskState={}));const v="\0",d=(c,n)=>c+v+n;e.namespaceTestTag=d;const b=c=>{const n=c.indexOf(v);return{ctrlId:c.slice(0,n),tagId:c.slice(n+1)}};e.denamespaceTestTag=b;var f;(function(c){c.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),c.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?a.URI.revive(n.uri):void 0,range:n.range?t.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(f=e.ITestItem||(e.ITestItem={}));var w;(function(c){c[c.NotExpandable=0]="NotExpandable",c[c.Expandable=1]="Expandable",c[c.BusyExpanding=2]="BusyExpanding",c[c.Expanded=3]="Expanded"})(w=e.TestItemExpandState||(e.TestItemExpandState={}));var h;(function(c){c.serialize=n=>({expand:n.expand,item:f.serialize(n.item)}),c.deserialize=n=>({controllerId:I.TestId.root(n.item.extId),expand:n.expand,item:f.deserialize(n.item)})})(h=e.InternalTestItem||(e.InternalTestItem={}));var m;(function(c){c.serialize=n=>{let r;return n.item&&(r={},n.item.label!==void 0&&(r.label=n.item.label),n.item.tags!==void 0&&(r.tags=n.item.tags),n.item.busy!==void 0&&(r.busy=n.item.busy),n.item.uri!==void 0&&(r.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(r.range=n.item.range?.toJSON()),n.item.description!==void 0&&(r.description=n.item.description),n.item.error!==void 0&&(r.error=n.item.error),n.item.sortText!==void 0&&(r.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:r}},c.deserialize=n=>{let r;return n.item&&(r={},n.item.label!==void 0&&(r.label=n.item.label),n.item.tags!==void 0&&(r.tags=n.item.tags),n.item.busy!==void 0&&(r.busy=n.item.busy),n.item.range!==void 0&&(r.range=n.item.range?t.Range.lift(n.item.range):null),n.item.description!==void 0&&(r.description=n.item.description),n.item.error!==void 0&&(r.error=n.item.error),n.item.sortText!==void 0&&(r.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:r}}})(m=e.ITestItemUpdate||(e.ITestItemUpdate={}));const p=(c,n)=>{n.expand!==void 0&&(c.expand=n.expand),n.item!==void 0&&(c.item=c.item?Object.assign(c.item,n.item):n.item)};e.applyTestItemUpdate=p;var o;(function(c){c.serializeWithoutMessages=n=>({...h.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(y.serializeWithoutMessages),retired:n.retired}),c.serialize=n=>({...h.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(y.serialize),retired:n.retired}),c.deserialize=n=>({...h.deserialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(y.deserialize),retired:!0})})(o=e.TestResultItem||(e.TestResultItem={}));var i;(function(c){c[c.Function=0]="Function",c[c.Statement=1]="Statement"})(i=e.DetailType||(e.DetailType={}));var l;(function(c){c[c.Add=0]="Add",c[c.Update=1]="Update",c[c.DocumentSynced=2]="DocumentSynced",c[c.Remove=3]="Remove",c[c.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",c[c.Retire=5]="Retire",c[c.AddTag=6]="AddTag",c[c.RemoveTag=7]="RemoveTag"})(l=e.TestDiffOpType||(e.TestDiffOpType={}));var u;(function(c){c.deserialize=n=>n.op===0?{op:n.op,item:h.deserialize(n.item)}:n.op===1?{op:n.op,item:m.deserialize(n.item)}:n.op===2?{op:n.op,uri:a.URI.revive(n.uri),docv:n.docv}:n,c.serialize=n=>n.op===0?{op:n.op,item:h.serialize(n.item)}:n.op===1?{op:n.op,item:m.serialize(n.item)}:n})(u=e.TestsDiffOp||(e.TestsDiffOp={}));class s{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(n){const r=this.o();for(const g of n)switch(g.op){case 0:this.j(h.deserialize(g.item),r);break;case 1:this.k(m.deserialize(g.item),r);break;case 3:this.l(g.itemId,r);break;case 5:this.m(g.itemId);break;case 4:this.updatePendingRoots(g.amount);break;case 6:this.c.set(g.tag.id,g.tag);break;case 7:this.c.delete(g.id);break}r.complete?.()}j(n,r){const g=I.TestId.parentId(n.item.extId)?.toString();let P;if(!g)P=this.p(n),this.f.add(P),this.d.set(n.item.extId,P);else if(this.d.has(g)){const L=this.d.get(g);L.children.add(n.item.extId),P=this.p(n,L),this.d.set(n.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(n)}`);return}return r.add?.(P),n.expand===2&&this.g++,P}k(n,r){const g=this.d.get(n.extId);if(!!g)return n.expand!==void 0&&(g.expand===2&&this.g--,n.expand===2&&this.g++),(0,e.applyTestItemUpdate)(g,n),r.update?.(g),g}l(n,r){const g=this.d.get(n);if(!g)return;const P=I.TestId.parentId(g.item.extId)?.toString();P?this.d.get(P).children.delete(g.item.extId):this.f.delete(g);const L=[[n]];for(;L.length;)for(const z of L.pop()){const _=this.d.get(z);_&&(L.push(_.children),this.d.delete(z),r.remove?.(_,_!==g),_.expand===2&&this.g--)}}m(n){}updatePendingRoots(n){this.h+=n}o(){return{}}}e.AbstractIncrementalTestCollection=s}),define(Se[91],ye([1,0,18,4,6,49,69,56]),function(ne,e,a,t,I,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(w){w[w.Upsert=0]="Upsert",w[w.SetTags=1]="SetTags",w[w.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",w[w.RemoveChild=3]="RemoveChild",w[w.SetProp=4]="SetProp",w[w.Bulk=5]="Bulk",w[w.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const C=(w,h)=>w===h,T=Object.entries({range:(w,h)=>w===h?!0:!w||!h?!1:w.equalsRange(h),busy:C,label:C,description:C,error:C,sortText:C,tags:(w,h)=>!(w.length!==h.length||w.some(m=>!h.includes(m)))}),E=(w,h)=>{let m;for(const[p,o]of T)o(w[p],h[p])||(m?m[p]=h[p]:m={[p]:h[p]});return m};class y extends I.Disposable{get root(){return this.m.root}constructor(h){super(),this.m=h,this.f=this.B(new a.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new t.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(h){this.h=h;for(const m of this.tree.values())this.G(m)}collectDiff(){const h=this.k;return this.k=[],h}pushDiff(h){switch(h.op){case 2:{for(const m of this.k)if(m.op===2&&m.uri===h.uri){m.docv=h.docv;return}break}case 1:{const m=this.k[this.k.length-1];if(m){if(m.op===1&&m.item.extId===h.item.extId){(0,D.applyTestItemUpdate)(m.item,h.item);return}if(m.op===0&&m.item.item.extId===h.item.extId){(0,D.applyTestItemUpdate)(m.item,h.item);return}}break}}this.k.push(h),this.f.isScheduled()||this.f.schedule()}expand(h,m){const p=this.tree.get(h);if(!!p){if((p.expandLevels===void 0||m>p.expandLevels)&&(p.expandLevels=m),p.expand===1){const o=this.I(p);return o.isOpen()?this.H(p,m-1):o.wait().then(()=>this.H(p,m-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.H(p,m-1)):this.H(p,m-1)}}dispose(){for(const h of this.tree.values())this.m.getApiFor(h.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(h,m){switch(m.op){case 3:this.L(k.TestId.joinToString(h.fullId,m.id));break;case 0:this.u(m.item,h);break;case 5:for(const p of m.ops)this.p(h,p);break;case 1:this.w(m.new,m.old,h.fullId.toString());break;case 2:this.G(h);break;case 4:this.pushDiff({op:1,item:{extId:h.fullId.toString(),item:m.update}});break;case 6:this.s(h.actual.uri);break;default:(0,A.assertNever)(m)}}s(h){h&&this.pushDiff({op:2,uri:h,docv:this.m.getDocumentVersion(h)})}u(h,m){const p=k.TestId.fromExtHostTestItem(h,this.root.id,m?.actual),o=this.m.getApiFor(h);o.parent&&o.parent!==m?.actual&&this.m.getChildren(o.parent).delete(h.id);let i=this.tree.get(p.toString());if(!i){i={fullId:p,actual:h,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},h.tags.forEach(this.y,this),this.tree.set(i.fullId.toString(),i),this.C(h,m),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:i.expand,item:this.m.toITestItem(h)}}),this.F(h,i,m);return}if(i.actual===h){this.D(h,i,m);return}if(i.actual.uri?.toString()!==h.uri?.toString())return this.L(p.toString()),this.u(h,m);const l=this.m.getChildren(i.actual),u=i.actual,s=E(this.m.toITestItem(u),this.m.toITestItem(h));this.m.getApiFor(u).listener=void 0,i.actual=h,i.expand=0,s&&(s.hasOwnProperty("tags")&&(this.w(h.tags,u.tags,p.toString()),delete s.tags),this.p(i,{op:4,update:s})),this.F(h,i,m);for(const[c,n]of l)this.m.getChildren(h).get(n.id)||this.L(k.TestId.joinToString(p,n.id));this.s(i.actual.uri)}w(h,m,p){const o=new Set(m.map(i=>i.id));for(const i of h)o.delete(i.id)||this.y(i);this.pushDiff({op:1,item:{extId:p,item:{tags:h.map(i=>(0,D.namespaceTestTag)(this.m.controllerId,i.id))}}}),o.forEach(this.z,this)}y(h){const m=this.j.get(h.id);m?m.refCount++:(this.j.set(h.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,D.namespaceTestTag)(this.m.controllerId,h.id)}}))}z(h){const m=this.j.get(h);m&&!--m.refCount&&(this.j.delete(h),this.pushDiff({op:7,id:(0,D.namespaceTestTag)(this.m.controllerId,h)}))}C(h,m){this.m.getApiFor(h).parent=m&&m.actual!==this.root?m.actual:void 0}D(h,m,p){this.C(h,p);const o=this.m.getApiFor(h);o.parent=p?.actual,o.listener=i=>this.p(m,i),this.G(m)}F(h,m,p){this.D(h,m,p);for(const[o,i]of this.m.getChildren(h))this.u(i,m)}G(h){let m;this.h?h.resolveBarrier?m=h.resolveBarrier.isOpen()?3:2:m=h.actual.canResolveChildren?1:0:m=0,m!==h.expand&&(h.expand=m,this.pushDiff({op:1,item:{extId:h.fullId.toString(),expand:m}}),m===1&&h.expandLevels!==void 0&&this.I(h))}H(h,m){if(m<0)return;const p=[];for(const[o,i]of this.m.getChildren(h.actual)){const l=this.expand(k.TestId.joinToString(h.fullId,i.id),m);(0,a.isThenable)(l)&&p.push(l)}if(p.length)return Promise.all(p).then(()=>{})}I(h){if(h.resolveBarrier)return h.resolveBarrier;if(!this.h){const i=new a.Barrier;return i.open(),i}h.expand=2,this.J(h);const m=h.resolveBarrier=new a.Barrier,p=i=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,i)};let o;try{o=this.h(h.actual===this.root?void 0:h.actual)}catch(i){p(i)}return(0,a.isThenable)(o)?o.catch(p).then(()=>{m.open(),this.G(h)}):(m.open(),this.G(h)),h.resolveBarrier}J(h){this.pushDiff({op:1,item:{extId:h.fullId.toString(),expand:h.expand}})}L(h){const m=this.tree.get(h);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:h});const p=[m];for(;p.length;){const o=p.pop();if(!!o){this.m.getApiFor(o.actual).listener=void 0;for(const i of o.actual.tags)this.z(i.id);this.tree.delete(o.fullId.toString());for(const[i,l]of this.m.getChildren(o.actual))p.push(this.tree.get(k.TestId.joinToString(o.fullId,l.id)))}}}flushDiff(){const h=this.collectDiff();h.length&&this.g.fire(h)}}e.TestItemCollection=y;class v extends Error{constructor(h){super(`Attempted to insert a duplicate test item ID ${h}`)}}e.DuplicateTestItemError=v;class d extends Error{constructor(h){super(`TestItem with ID "${h}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class b extends Error{constructor(h,m,p){super(`TestItem with ID "${h}" is from controller "${m}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=b;const f=(w,h,m)=>{let p=new Map;return{get size(){return p.size},forEach(o,i){for(const l of p.values())o.call(i,l,this)},[Symbol.iterator](){return p.entries()},replace(o){const i=new Map,l=new Set(p.keys()),u={op:5,ops:[]};for(const s of o){if(!(s instanceof m))throw new d(s.id);const c=h(s).controllerId;if(c!==w.controllerId)throw new b(s.id,c,w.controllerId);if(i.has(s.id))throw new v(s.id);i.set(s.id,s),l.delete(s.id),u.ops.push({op:0,item:s})}for(const s of l.keys())u.ops.push({op:3,id:s});w.listener?.(u),p=i},add(o){if(!(o instanceof m))throw new d(o.id);p.set(o.id,o),w.listener?.({op:0,item:o})},delete(o){p.delete(o)&&w.listener?.({op:3,id:o})},get(o){return p.get(o)},toJSON(){return Array.from(p.values())}}};e.createTestItemChildren=f}),define(Se[132],ye([1,0,91]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,I=(D,k)=>{const S={controllerId:k};return t.set(D,S),S};e.createPrivateApiFor=I;const A=D=>{const k=t.get(D);if(!k)throw new a.InvalidTestItemError(D?.id||"<unknown>");return k};e.getPrivateApiFor=A}),define(Se[92],ye([1,0,15,2]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function I(k,S){return k.scheme===a.Schemas.http||k.scheme===a.Schemas.https?k:(S&&S.authority&&S.isRemote&&k.scheme===a.Schemas.file&&(k=t.URI.from({scheme:a.Schemas.vscodeRemote,authority:S.authority,path:k.path})),t.URI.from({scheme:a.Schemas.https,authority:`${k.scheme}+${A(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=I;function A(k){return k.replace(/./g,S=>{const C=S.charCodeAt(0);return C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57?S:"-"+C.toString(16).padStart(4,"0")})}function D(k){return k.replace(/-([0-9a-f]{4})/g,(S,C)=>String.fromCharCode(parseInt(C,16)))}e.decodeAuthority=D}),define(Se[223],ye([1,0,4,6,92]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(k,S,C){this.d=k,this.e=S,this.f=C,this.a=0,this.b=new t.DisposableStore,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const R=S.getVisibleTextEditors();for(const T of this.c.values())R.indexOf(T.editor)<0&&T.inset.dispose()}))}dispose(){this.c.forEach(k=>k.inset.dispose()),this.b.dispose()}createWebviewEditorInset(k,S,C,R,T){let E;for(const h of this.e.getVisibleTextEditors(!0))if(h.value===k){E=h;break}if(!E)throw new Error("not a visible editor");const y=this,v=this.a++,d=new a.Emitter,b=new a.Emitter,f=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(h){return(0,I.asWebviewUri)(h,y.f)}get cspSource(){return I.webviewGenericCspSource}set options(h){this.b=h,y.d.$setOptions(v,h)}get options(){return this.b}set html(h){this.a=h,y.d.$setHtml(v,h)}get html(){return this.a}get onDidReceiveMessage(){return d.event}postMessage(h){return y.d.$postMessage(v,h)}},w=new class{constructor(){this.editor=k,this.line=S,this.height=C,this.webview=f,this.onDidDispose=b.event}dispose(){y.c.has(v)&&(y.c.delete(v),y.d.$disposeEditorInset(v),b.fire(),b.dispose(),d.dispose())}};return this.d.$createEditorInset(v,E.id,E.value.document.uri,S+1,C,R||{},T.identifier,T.extensionLocation),this.c.set(v,{editor:k,inset:w,onDidReceiveMessage:d}),w}$onDidDispose(k){const S=this.c.get(k);S&&S.inset.dispose()}$onDidReceiveMessage(k,S){this.c.get(k)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=A}),define(Se[224],ye([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,a.createDecorator)("configurationResolverService");var t;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class I extends Error{constructor(D,k){super(k),this.variable=D}}e.VariableError=I}),define(Se[225],ye([1,0,9,36,11,23,12,111,188,224,8]),function(ne,e,a,t,I,A,D,k,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(y,v,d,b){this.g=new Map,this.a=y,this.b=v,this.d=d,b&&(this.c=b.then(f=>this.h(f)))}h(y){if(D.isWindows){const v=Object.create(null);return Object.keys(y).forEach(d=>{v[d.toLowerCase()]=y[d]}),v}return y}resolveWithEnvironment(y,v,d){return this.j({env:this.h(y),userHome:void 0},v?v.uri:void 0,d)}async resolveAsync(y,v){const d={env:await this.c,userHome:await this.d};return this.j(d,y?y.uri:void 0,v)}async i(y,v,d,b){const f=A.deepClone(v);D.isWindows&&f.windows?Object.keys(f.windows).forEach(h=>f[h]=f.windows[h]):D.isMacintosh&&f.osx?Object.keys(f.osx).forEach(h=>f[h]=f.osx[h]):D.isLinux&&f.linux&&Object.keys(f.linux).forEach(h=>f[h]=f.linux[h]),delete f.windows,delete f.osx,delete f.linux;const w={env:await this.c,userHome:await this.d};return this.j(w,y?y.uri:void 0,f,d,b)}async resolveAnyAsync(y,v,d){return this.i(y,v,d)}async resolveAnyMap(y,v,d){const b=new Map;return{newConfig:await this.i(y,v,d,b),resolvedVariables:b}}resolveWithInteractionReplace(y,v,d,b){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,v,d,b){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,v){if(this.g.has(y))throw new Error("Variable "+y+" is contributed twice.");this.g.set(y,v)}async j(y,v,d,b,f){if(I.isString(d))return this.l(y,v,d,b,f);if(Array.isArray(d))return Promise.all(d.map(w=>this.j(y,v,w,b,f)));if(I.isObject(d)){const w=Object.create(null),h=await Promise.all(Object.keys(d).map(async m=>[await this.l(y,v,m,b,f),await this.j(y,v,d[m],b,f)]));for(const[m,p]of h)w[m]=p;return w}return d}l(y,v,d,b,f){return(0,R.replaceAsync)(d,T.VARIABLE_REGEXP,async(w,h)=>{if(h.includes(T.VARIABLE_LHS))return w;let m=await this.n(y,w,h,v,b);return f?.set(h,m),m!==w&&I.isString(m)&&m.match(T.VARIABLE_REGEXP)&&(m=await this.l(y,v,m,b,f)),m})}m(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async n(y,v,d,b,f){let w;const h=d.split(":");h.length>1&&(d=h[0],w=h[1]);const m=i=>{const l=this.a.getFilePath();if(l)return(0,k.normalizeDriveLetter)(l);throw new C.VariableError(i,(0,S.localize)(0,null,v))},p=i=>{const l=m(i);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return(0,k.normalizeDriveLetter)(u)}throw new C.VariableError(i,(0,S.localize)(1,null,v,a.basename(l)))},o=i=>{if(w){const l=this.a.getFolderUri(w);if(l)return l;throw new C.VariableError(i,(0,S.localize)(2,null,v,w))}if(b)return b;throw this.a.getWorkspaceFolderCount()>1?new C.VariableError(i,(0,S.localize)(3,null,v)):new C.VariableError(i,(0,S.localize)(4,null,v))};switch(d){case"env":if(w){if(y.env){const i=y.env[D.isWindows?w.toLowerCase():w];if(I.isString(i))return i}return""}throw new C.VariableError(C.VariableKind.Env,(0,S.localize)(5,null,v));case"config":if(w){const i=this.a.getConfigurationValue(b,w);if(I.isUndefinedOrNull(i))throw new C.VariableError(C.VariableKind.Config,(0,S.localize)(6,null,v,w));if(I.isObject(i))throw new C.VariableError(C.VariableKind.Config,(0,S.localize)(7,null,v,w));return i}throw new C.VariableError(C.VariableKind.Config,(0,S.localize)(8,null,v));case"command":return this.o(C.VariableKind.Command,v,w,f,"command");case"input":return this.o(C.VariableKind.Input,v,w,f,"input");case"extensionInstallFolder":if(w){const i=await this.a.getExtension(w);if(!i)throw new C.VariableError(C.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,v,w));return this.m(i.extensionLocation)}throw new C.VariableError(C.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,v));default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.m(o(C.VariableKind.WorkspaceFolder)));case"cwd":return b||w?(0,k.normalizeDriveLetter)(this.m(o(C.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,k.normalizeDriveLetter)(a.basename(this.m(o(C.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new C.VariableError(C.VariableKind.UserHome,(0,S.localize)(11,null,v))}case"lineNumber":{const i=this.a.getLineNumber();if(i)return i;throw new C.VariableError(C.VariableKind.LineNumber,(0,S.localize)(12,null,v))}case"selectedText":{const i=this.a.getSelectedText();if(i)return i;throw new C.VariableError(C.VariableKind.SelectedText,(0,S.localize)(13,null,v))}case"file":return m(C.VariableKind.File);case"fileWorkspaceFolder":return p(C.VariableKind.FileWorkspaceFolder);case"relativeFile":return b||w?a.relative(this.m(o(C.VariableKind.RelativeFile)),m(C.VariableKind.RelativeFile)):m(C.VariableKind.RelativeFile);case"relativeFileDirname":{const i=a.dirname(m(C.VariableKind.RelativeFileDirname));if(b||w){const l=a.relative(this.m(o(C.VariableKind.RelativeFileDirname)),i);return l.length===0?".":l}return i}case"fileDirname":return a.dirname(m(C.VariableKind.FileDirname));case"fileExtname":return a.extname(m(C.VariableKind.FileExtname));case"fileBasename":return a.basename(m(C.VariableKind.FileBasename));case"fileBasenameNoExtension":{const i=a.basename(m(C.VariableKind.FileBasenameNoExtension));return i.slice(0,i.length-a.extname(i).length)}case"fileDirnameBasename":return a.basename(a.dirname(m(C.VariableKind.FileDirnameBasename)));case"execPath":{const i=this.a.getExecPath();return i||v}case"execInstallFolder":{const i=this.a.getAppRoot();return i||v}case"pathSeparator":return a.sep;default:try{const i=w?`${d}:${w}`:d;return this.o(C.VariableKind.Unknown,v,i,f,void 0)}catch{return v}}}}o(y,v,d,b,f){if(d&&b){const w=f===void 0?b[d]:b[f+":"+d];if(typeof w=="string")return w;throw new C.VariableError(y,(0,S.localize)(14,null,v))}return v}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Se[133],ye([1,0,3,130]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,a.createDecorator)("editorGroupsService");var I;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var A;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var D;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(D=e.GroupLocation||(e.GroupLocation={}));var k;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EVEN=1]="EVEN",v[v.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function C(v){const d=v;return(0,t.isEditorInput)(d?.editor)&&(0,t.isEditorInput)(d?.replacement)}e.isEditorReplacement=C;var R;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var T;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(T=e.OpenEditorContext||(e.OpenEditorContext={}));function E(v){const d=v;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.isEditorGroup=E;function y(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=y}),define(Se[226],ye([1,0,3,133]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,a.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(A){const D=A;return typeof A=="number"||(0,t.isEditorGroup)(D)}e.isPreferredGroup=I}),define(Se[227],ye([1,0,3,194]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,a.refineServiceDecorator)(t.IEnvironmentService)}),define(Se[134],ye([1,0,27,4,9]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(T){this.removedDueToLooping=T}}e.DeltaExtensionsResult=A;class D{static isHostExtension(T,E,y){if(E.getExtensionDescription(T))return!1;const v=y.getExtensionDescription(T);return v?!!((v.main||v.browser)&&v.api==="none"):!1}constructor(T){this.c=new t.Emitter,this.onDidChange=this.c.event,this.d=T,this.h()}h(){this.d.sort(S),this.e=new Map,this.f=[],this.g=new Map;for(const T of this.d){if(this.e.has(a.ExtensionIdentifier.toKey(T.identifier))){console.error("Extension `"+T.identifier.value+"` is already registered");continue}if(this.e.set(a.ExtensionIdentifier.toKey(T.identifier),T),this.f.push(T),Array.isArray(T.activationEvents))for(let E of T.activationEvents)E==="onUri"&&(E=`onUri:${a.ExtensionIdentifier.toKey(T.identifier)}`),this.g.has(E)||this.g.set(E,[]),this.g.get(E).push(T)}}set(T){this.d=T,this.h(),this.c.fire(void 0)}deltaExtensions(T,E){this.d=C(this.d,E),this.d=this.d.concat(T);const y=D.j(this.d);return this.d=C(this.d,y.map(v=>v.identifier)),this.h(),this.c.fire(void 0),new A(y)}static j(T){const E=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(f){this.d.has(f)||(this.d.add(f),this.e.push(f))}addArc(f,w){this.addNode(f),this.addNode(w),this.c.has(f)?this.c.get(f).push(w):this.c.set(f,[w])}getArcs(f){return this.c.has(f)?this.c.get(f):[]}hasOnlyGoodArcs(f,w){const h=E.getArcs(f);for(let m=0;m<h.length;m++)if(!w.has(h[m]))return!1;return!0}getNodes(){return this.e}},y=new Map;for(const f of T){const w=a.ExtensionIdentifier.toKey(f.identifier);if(y.set(w,f),f.extensionDependencies)for(const h of f.extensionDependencies){const m=a.ExtensionIdentifier.toKey(h);E.addArc(w,m)}}const v=new Set;E.getNodes().filter(f=>E.getArcs(f).length===0).forEach(f=>v.add(f));const d=E.getNodes().filter(f=>!v.has(f));let b;do{b=!1;for(let f=0;f<d.length;f++){const w=d[f];E.hasOnlyGoodArcs(w,v)&&(d.splice(f,1),f--,v.add(w),b=!0)}}while(b);return d.map(f=>y.get(f))}containsActivationEvent(T){return this.g.has(T)}containsExtension(T){return this.e.has(a.ExtensionIdentifier.toKey(T))}getExtensionDescriptionsForActivationEvent(T){const E=this.g.get(T);return E?E.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(T){const E=this.e.get(a.ExtensionIdentifier.toKey(T));return E||void 0}getExtensionDescriptionByUUID(T){for(const E of this.f)if(E.uuid===T)return E}getExtensionDescriptionByIdOrUUID(T,E){return this.getExtensionDescription(T)??(E?this.getExtensionDescriptionByUUID(E):void 0)}}e.ExtensionDescriptionRegistry=D;var k;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(k||(k={}));function S(R,T){const E=R.isBuiltin?0:R.isUnderDevelopment?2:1,y=T.isBuiltin?0:T.isUnderDevelopment?2:1;if(E!==y)return E-y;const v=I.posix.basename(R.extensionLocation.path),d=I.posix.basename(T.extensionLocation.path);return v<d?-1:v>d?1:0}function C(R,T){const E=new Set;return T.forEach(y=>E.add(a.ExtensionIdentifier.toKey(y))),R.filter(y=>!E.has(a.ExtensionIdentifier.toKey(y.identifier)))}}),define(Se[228],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var a;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(a=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(T){this.pipeName=T,this.type=1}serialize(T){T[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class I{constructor(){this.type=2}serialize(T){T[I.ENV_KEY]="1"}}e.SocketExtHostConnection=I,I.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class A{constructor(){this.type=3}serialize(T){T[A.ENV_KEY]="1"}}e.MessagePortExtHostConnection=A,A.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function D(R){delete R[t.ENV_KEY],delete R[I.ENV_KEY],delete R[A.ENV_KEY]}function k(R,T){D(T),R.serialize(T)}e.writeExtHostConnection=k;function S(R){if(R[t.ENV_KEY])return C(R,new t(R[t.ENV_KEY]));if(R[I.ENV_KEY])return C(R,new I);if(R[A.ENV_KEY])return C(R,new A);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=S;function C(R,T){return D(R),T}}),define(Se[93],ye([1,0,22]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(C){C[C.Desktop=1]="Desktop",C[C.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var I;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function D(C){const R=a.VSBuffer.alloc(1);switch(C){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=D;function k(C,R){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=k;var S;(function(C){C.Start="START_NATIVE_LOG",C.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Se[94],ye([1,0,3,4,13,25,93,67,128,23,2]),function(ne,e,a,t,I,A,D,k,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let T=class{constructor(d,b){this.i=d,this.a=new t.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new t.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=b.createLogger(R.URI.revive(this.i.environment.extensionTelemetryLogResource)),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(d,b){const f=this.getTelemetryDetails(),w=new E(b,d,this.g,this.f,this.getBuiltInCommonProperties(d),{isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled});return this.h.set(d.identifier.value,w),w.apiTelemetryLogger}$initializeTelemetryLevel(d,b,f){this.d=d,this.f=b,this.c=f??{usage:!0,error:!0}}getBuiltInCommonProperties(d){const b={};switch(b["common.extname"]=d.name,b["common.extversion"]=d.version,b["common.vscodemachineid"]=this.i.telemetryInfo.machineId,b["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,b["common.vscodeversion"]=this.i.version,b["common.isnewappinstall"]=y(this.i.telemetryInfo.firstSessionDate),b["common.product"]=this.i.environment.appHost,this.i.uiKind){case D.UIKind.Web:b["common.uikind"]="web";break;case D.UIKind.Desktop:b["common.uikind"]="desktop";break;default:b["common.uikind"]="unknown"}return b["common.remotename"]=(0,k.getRemoteName)((0,S.cleanRemoteAuthority)(this.i.remote.authority)),b}$onDidChangeTelemetryLevel(d){this.e=this.getTelemetryConfiguration(),this.d=d;const b=this.getTelemetryDetails();this.h.forEach(f=>{f.updateTelemetryEnablements(b.isUsageEnabled,b.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(d,b){const f=this.h.get(d.value);return f?(f.logError(b),!0):!1}};T=qe([We(0,A.IExtHostInitDataService),We(1,I.ILoggerService)],T),e.ExtHostTelemetry=T;class E{constructor(d,b,f,w,h,m){this.e=b,this.f=f,this.g=w,this.h=h,this.b=new t.Emitter,this.a=d,this.c={isUsageEnabled:m.isUsageEnabled,isErrorsEnabled:m.isErrorsEnabled}}updateTelemetryEnablements(d,b){this.d&&(this.c={isUsageEnabled:d,isErrorsEnabled:b},this.b.fire(this.d))}mixInCommonPropsAndCleanData(d){let b=d.properties??d;return b=(0,S.cleanData)(b,[]),this.a.additionalCommonProperties&&(b=(0,C.mixin)(b,this.a.additionalCommonProperties)),this.a.ignoreBuiltInCommonProperties||(b=(0,C.mixin)(b,this.h)),d.properties?d.properties=b:d=b,d}i(d,b){this.e.publisher==="vscode"?d=this.e.name+"/"+d:d=this.e.identifier.value+"/"+d,b=this.mixInCommonPropsAndCleanData(b||{}),this.g||this.a.logEvent(d,b),this.f.trace(d,b)}logUsage(d,b){!this.c.isUsageEnabled||this.i(d,b)}logError(d,b){!this.c.isErrorsEnabled||(typeof d=="string"?this.i(d,b):this.a.logException(d,b))}get apiTelemetryLogger(){if(!this.d){const d=this,b={logUsage:d.logUsage.bind(d),get isUsageEnabled(){return d.c.isUsageEnabled},get isErrorsEnabled(){return d.c.isErrorsEnabled},logError:d.logError.bind(d),dispose:d.dispose.bind(d),onDidChangeEnableStates:d.b.event.bind(d)};this.d=Object.freeze(b)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=E;function y(v){const d=Date.now()-new Date(v).getTime();return isNaN(d)?!1:d<1e3*60*60*24}e.isNewAppInstall=y,e.IExtHostTelemetry=(0,a.createDecorator)("IExtHostTelemetry")}),define(Se[26],ye([1,0,4,2,3,27,203]),function(ne,e,a,t,I,A,D){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");class S{constructor(c){this.affinity=c,this.kind=1}equals(c){return this.kind===c.kind&&this.affinity===c.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class C{constructor(c){this.affinity=c,this.kind=2}equals(c){return this.kind===c.kind&&this.affinity===c.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=C;class R{constructor(){this.kind=3,this.affinity=0}equals(c){return this.kind===c.kind}asString(){return"Remote"}}e.RemoteRunningLocation=R;class T{constructor(c){this.dependency=c}}e.MissingExtensionDependency=T;var E;(function(s){s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(E=e.ExtensionHostKind||(e.ExtensionHostKind={}));function y(s){if(s===null)return"None";switch(s){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=y;class v{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(c,n){const r=[],g=[],P=[],L=[],z=f(this.c),_=f(c),K=(B,U)=>B.extensionLocation.toString()===U.extensionLocation.toString()||B.isBuiltin===U.isBuiltin||B.isUserBuiltin===U.isUserBuiltin||B.isUnderDevelopment===U.isUnderDevelopment;for(const B of this.c){const U=_.get(A.ExtensionIdentifier.toKey(B.identifier));if(!U){r.push(B.identifier),z.delete(A.ExtensionIdentifier.toKey(B.identifier));continue}if(!K(B,U)){r.push(B.identifier),z.delete(A.ExtensionIdentifier.toKey(B.identifier));continue}}for(const B of c){const U=z.get(A.ExtensionIdentifier.toKey(B.identifier));if(!U){g.push(B);continue}if(!K(U,B)){r.push(U.identifier),z.delete(A.ExtensionIdentifier.toKey(U.identifier));continue}}const F=b(this.d),M=b(n);for(const B of this.d)M.has(A.ExtensionIdentifier.toKey(B))||P.push(B);for(const B of n)F.has(A.ExtensionIdentifier.toKey(B))||L.push(B);const N={toRemove:r,toAdd:g,myToRemove:P,myToAdd:L};return this.delta(N),N}delta(c){const{toRemove:n,toAdd:r,myToRemove:g,myToAdd:P}=c,L=b(n),z=b(g);for(let _=0;_<this.c.length;_++)L.has(A.ExtensionIdentifier.toKey(this.c[_].identifier))&&(this.c.splice(_,1),_--);for(let _=0;_<this.d.length;_++)z.has(A.ExtensionIdentifier.toKey(this.d[_]))&&(this.d.splice(_,1),_--);for(const _ of r)this.c.push(_);for(const _ of P)this.d.push(_)}containsExtension(c){for(const n of this.d)if(A.ExtensionIdentifier.equals(n,c))return!0;return!1}}e.ExtensionHostExtensions=v;class d{constructor(c){if(this[k]="ExtensionIdentifierSet",this.c=new Map,this.d=A.ExtensionIdentifier.toKey,c)for(const n of c)this.add(n)}get size(){return this.c.size}add(c){return this.c.set(this.d(c),c),this}clear(){this.c.clear()}delete(c){return this.c.delete(this.d(c))}has(c){return this.c.has(this.d(c))}forEach(c,n){this.c.forEach(r=>c.call(n,r,r,this))}*entries(){for(const[c,n]of this.c)yield[n,n]}keys(){return this.c.values()}values(){return this.c.values()}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=d;function b(s){const c=new Set;for(const n of s)c.add(A.ExtensionIdentifier.toKey(n));return c}e.extensionIdentifiersArrayToSet=b;function f(s){const c=new Map;for(const n of s)c.set(A.ExtensionIdentifier.toKey(n.identifier),n);return c}function w(s,c){return s.enabledApiProposals?s.enabledApiProposals.includes(c):!1}e.isProposedApiEnabled=w;function h(s,c){if(!w(s,c))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${c}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${c}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.checkProposedApiEnabled=h;class m{constructor(c,n,r,g){this.codeLoadingTime=c,this.activateCallTime=n,this.activateResolvedTime=r,this.activationReason=g}}e.ActivationTimes=m;class p{constructor(c,n){this.description=c,this.value=n}}e.ExtensionPointContribution=p,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var o;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(o=e.ActivationKind||(e.ActivationKind={}));function i(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}e.toExtension=i;function l(s,c){return{identifier:new A.ExtensionIdentifier((0,D.getExtensionId)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!c,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,browserNlsBundleUris:s.browserNlsBundleUris}}e.toExtensionDescription=l;class u{constructor(){this.onDidRegisterExtensions=a.Event.None,this.onDidChangeExtensionsStatus=a.Event.None,this.onDidChangeExtensions=a.Event.None,this.onWillActivateByEvent=a.Event.None,this.onDidChangeResponsiveChange=a.Event.None,this.extensions=[]}activateByEvent(c){return Promise.resolve(void 0)}activationEventIsDone(c){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(c){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(c,n){return Promise.resolve(0)}getInspectPorts(c,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(c){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=u}),define(Se[229],ye([1,0,10,134,27,26,13,18]),function(ne,e,a,t,I,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class S{constructor(f,w,h,m){this.startup=f,this.codeLoadingTime=w,this.activateCallTime=h,this.activateResolvedTime=m}}e.ExtensionActivationTimes=S,S.NONE=new S(!1,-1,-1,-1);class C{constructor(f){this.a=f,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(f,w){return f===-1||w===-1?-1:w-f}build(){return new S(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=C;class R{constructor(f,w,h,m,p,o){this.activationFailed=f,this.activationFailedError=w,this.activationTimes=h,this.module=m,this.exports=p,this.subscriptions=o}}e.ActivatedExtension=R;class T extends R{constructor(f){super(!1,null,f,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class E extends R{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=E;class y extends R{constructor(f){super(!0,f,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(f,w,h,m){this.g=m,this.a=f,this.b=w,this.c=h,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[f,w]of this.d)w.dispose()}isActivated(f){const w=this.d.get(I.ExtensionIdentifier.toKey(f));return Boolean(w&&w.value)}getActivatedExtension(f){const w=this.d.get(I.ExtensionIdentifier.toKey(f));if(!w||!w.value)throw new Error(`Extension '${f.value}' is not known or not activated`);return w.value}async activateByEvent(f,w){if(this.f[f])return;const h=this.a.getExtensionDescriptionsForActivationEvent(f);await this.h(h.map(m=>({id:m.identifier,reason:{startup:w,extensionId:m.identifier,activationEvent:f}}))),this.f[f]=!0}activateById(f,w){const h=this.a.getExtensionDescription(f);if(!h)throw new Error(`Extension '${f}' is not known`);return this.h([{id:h.identifier,reason:w}])}async h(f){const w=f.filter(h=>!this.isActivated(h.id)).map(h=>this.j(h));await Promise.all(w.map(h=>h.wait()))}j(f){if(this.d.has(I.ExtensionIdentifier.toKey(f.id)))return this.d.get(I.ExtensionIdentifier.toKey(f.id));if(this.l(f.id))return this.k(f,null,[],null);const w=this.a.getExtensionDescription(f.id);if(!w){const p=new Error(`Cannot activate unknown extension '${f.id.value}'`),o=this.k(f,null,[],new y(p));return this.c.onExtensionActivationError(f.id,p,new A.MissingExtensionDependency(f.id.value)),o}const h=[],m=typeof w.extensionDependencies>"u"?[]:w.extensionDependencies;for(const p of m){if(this.m(p))continue;const o=this.d.get(I.ExtensionIdentifier.toKey(p));if(o){h.push(o);continue}if(this.l(p)){h.push(this.j({id:this.b.getExtensionDescription(p).identifier,reason:f.reason}));continue}const i=this.a.getExtensionDescription(p);if(i){if(!i.main&&!i.browser)continue;h.push(this.j({id:i.identifier,reason:f.reason}));continue}const l=w.displayName||w.identifier.value,u=new Error(`Cannot activate the '${l}' extension because it depends on unknown extension '${p}'`),s=this.k(f,w.displayName,[],new y(u));return this.c.onExtensionActivationError(w.identifier,u,new A.MissingExtensionDependency(p)),s}return this.k(f,w.displayName,h,null)}k(f,w,h,m){const p=new d(f.id,w,f.reason,h,m,this.c,this.g);return this.d.set(I.ExtensionIdentifier.toKey(f.id),p),p}l(f){return t.ExtensionDescriptionRegistry.isHostExtension(f,this.a,this.b)}m(f){const w=this.b.getExtensionDescription(f);return w?!w.main&&!w.browser:!1}};v=qe([We(3,D.ILogService)],v),e.ExtensionsActivator=v;let d=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(f,w,h,m,p,o,i){this.c=f,this.d=w,this.f=h,this.g=m,this.h=p,this.j=o,this.k=i,this.a=new k.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let f=0;f<this.g.length;f++){const w=this.g[f];if(w.value&&!w.value.activationFailed){this.g.splice(f,1),f--;continue}if(w.value&&w.value.activationFailed){const h=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${w.friendlyName}' failed to activate`);h.detail=w.value.activationFailedError,this.h=new y(h),this.j.onExtensionActivationError(this.c,h,null);return}}this.g.length>0&&await Promise.race(this.g.map(f=>f.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(f){const w=new Error;if(f&&f.name&&(w.name=f.name),f&&f.message?w.message=`Activating extension '${this.c.value}' failed: ${f.message}.`:w.message=`Activating extension '${this.c.value}' failed: ${f}.`,f&&f.stack&&(w.stack=f.stack),this.h=new y(w),this.b&&a.isCancellationError(f))return;this.j.onExtensionActivationError(this.c,w,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(f)}}};d=qe([We(6,D.ILogService)],d)}),define(Se[230],ye([1,0,13,25,26]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends a.LogService{constructor(k,S){super(k.createLogger(S.logFile,{name:I.ExtensionHostLogFileName}))}};A=qe([We(0,a.ILoggerService),We(1,t.IExtHostInitDataService)],A),e.ExtHostLogService=A});var Je=this&&this.__classPrivateFieldSet||function(ne,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ne,a):I?I.value=a:e.set(ne,a),a},Me=this&&this.__classPrivateFieldGet||function(ne,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[7],ye([1,0,17,10,110,28,83,8,11,2,30,38,127,90,26]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v){"use strict";var d,b,f,w,h,m,p,o,i,l,u,s,c,n,r,g,P,L,z,_,K,F,M;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function N(G){return Object.assign(G,{apply:function(){const fe=arguments.length===1?[]:arguments[1];return Reflect.construct(G,fe,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(G,[]);{const[fe,...Te]=arguments;return Reflect.construct(G,Te,fe.constructor)}}})}var B;(function(G){G.top="top",G.bottom="bottom"})(B=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var U;(function(G){G.command="command",G.opener="opener"})(U=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let W=m=class{static from(...j){let fe=j;return new m(function(){if(fe){for(const Te of fe)Te&&typeof Te.dispose=="function"&&Te.dispose();fe=void 0}})}constructor(j){d.set(this,void 0),Je(this,d,j,"f")}dispose(){typeof Me(this,d,"f")=="function"&&(Me(this,d,"f").call(this),Je(this,d,void 0,"f"))}};d=new WeakMap,W=m=qe([N],W),e.Disposable=W;let x=p=class{static Min(...j){if(j.length===0)throw new TypeError;let fe=j[0];for(let Te=1;Te<j.length;Te++){const Ke=j[Te];Ke.isBefore(fe)&&(fe=Ke)}return fe}static Max(...j){if(j.length===0)throw new TypeError;let fe=j[0];for(let Te=1;Te<j.length;Te++){const Ke=j[Te];Ke.isAfter(fe)&&(fe=Ke)}return fe}static isPosition(j){if(!j)return!1;if(j instanceof p)return!0;const{line:fe,character:Te}=j;return typeof fe=="number"&&typeof Te=="number"}static of(j){if(j instanceof p)return j;if(this.isPosition(j))return new p(j.line,j.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(j,fe){if(j<0)throw(0,t.illegalArgument)("line must be non-negative");if(fe<0)throw(0,t.illegalArgument)("character must be non-negative");this.c=j,this.e=fe}isBefore(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<j.e}isBeforeOrEqual(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<=j.e}isAfter(j){return!this.isBeforeOrEqual(j)}isAfterOrEqual(j){return!this.isBefore(j)}isEqual(j){return this.c===j.c&&this.e===j.e}compareTo(j){return this.c<j.c?-1:this.c>j.line?1:this.e<j.e?-1:this.e>j.e?1:0}translate(j,fe=0){if(j===null||fe===null)throw(0,t.illegalArgument)();let Te;return typeof j>"u"?Te=0:typeof j=="number"?Te=j:(Te=typeof j.lineDelta=="number"?j.lineDelta:0,fe=typeof j.characterDelta=="number"?j.characterDelta:0),Te===0&&fe===0?this:new p(this.line+Te,this.character+fe)}with(j,fe=this.character){if(j===null||fe===null)throw(0,t.illegalArgument)();let Te;return typeof j>"u"?Te=this.line:typeof j=="number"?Te=j:(Te=typeof j.line=="number"?j.line:this.line,fe=typeof j.character=="number"?j.character:this.character),Te===this.line&&fe===this.character?this:new p(Te,fe)}toJSON(){return{line:this.line,character:this.character}}};x=p=qe([N],x),e.Position=x;let V=o=class{static isRange(j){return j instanceof o?!0:j?x.isPosition(j.start)&&x.isPosition(j.end):!1}static of(j){if(j instanceof o)return j;if(this.isRange(j))return new o(j.start,j.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(j,fe,Te,Ke){let Ye,ct;if(typeof j=="number"&&typeof fe=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Ye=new x(j,fe),ct=new x(Te,Ke)):x.isPosition(j)&&x.isPosition(fe)&&(Ye=x.of(j),ct=x.of(fe)),!Ye||!ct)throw new Error("Invalid arguments");Ye.isBefore(ct)?(this.c=Ye,this.e=ct):(this.c=ct,this.e=Ye)}contains(j){return o.isRange(j)?this.contains(j.start)&&this.contains(j.end):x.isPosition(j)?!(x.of(j).isBefore(this.c)||this.e.isBefore(j)):!1}isEqual(j){return this.c.isEqual(j.c)&&this.e.isEqual(j.e)}intersection(j){const fe=x.Max(j.start,this.c),Te=x.Min(j.end,this.e);if(!fe.isAfter(Te))return new o(fe,Te)}union(j){if(this.contains(j))return this;if(j.contains(this))return j;const fe=x.Min(j.start,this.c),Te=x.Max(j.end,this.end);return new o(fe,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(j,fe=this.end){if(j===null||fe===null)throw(0,t.illegalArgument)();let Te;return j?x.isPosition(j)?Te=j:(Te=j.start||this.start,fe=j.end||this.end):Te=this.start,Te.isEqual(this.c)&&fe.isEqual(this.end)?this:new o(Te,fe)}toJSON(){return[this.start,this.end]}};V=o=qe([N],V),e.Range=V;let X=i=class extends V{static isSelection(j){return j instanceof i?!0:j?V.isRange(j)&&x.isPosition(j.anchor)&&x.isPosition(j.active)&&typeof j.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(j,fe,Te,Ke){let Ye,ct;if(typeof j=="number"&&typeof fe=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Ye=new x(j,fe),ct=new x(Te,Ke)):x.isPosition(j)&&x.isPosition(fe)&&(Ye=x.of(j),ct=x.of(fe)),!Ye||!ct)throw new Error("Invalid arguments");super(Ye,ct),this.f=Ye,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};X=i=qe([N],X),e.Selection=X;class Q{constructor(j,fe,Te){if(typeof j!="string"||j.length===0)throw(0,t.illegalArgument)("host");if(typeof fe!="number"||fe===0||Math.round(fe)!==fe)throw(0,t.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z_\-]+$/.test(Te)))throw(0,t.illegalArgument)("connectionToken");this.host=j,this.port=Math.round(fe),this.connectionToken=Te}}e.ResolvedAuthority=Q;class J extends Error{static NotAvailable(j,fe){return new J(j,E.RemoteAuthorityResolverErrorCode.NotAvailable,fe)}static TemporarilyNotAvailable(j){return new J(j,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(j,fe=E.RemoteAuthorityResolverErrorCode.Unknown,Te){super(j),this._message=j,this._code=fe,this._detail=Te,Object.setPrototypeOf(this,J.prototype)}}e.RemoteAuthorityResolverError=J;var te;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(te=e.EndOfLine||(e.EndOfLine={}));var le;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(le=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let Z=l=class{static isTextEdit(j){return j instanceof l?!0:j?V.isRange(j)&&typeof j.newText=="string":!1}static replace(j,fe){return new l(j,fe)}static insert(j,fe){return l.replace(new V(j,j),fe)}static delete(j){return l.replace(j,"")}static setEndOfLine(j){const fe=new l(new V(new x(0,0),new x(0,0)),"");return fe.newEol=j,fe}get range(){return this.c}set range(j){if(j&&!V.isRange(j))throw(0,t.illegalArgument)("range");this.c=j}get newText(){return this.e||""}set newText(j){if(j&&typeof j!="string")throw(0,t.illegalArgument)("newText");this.e=j}get newEol(){return this.f}set newEol(j){if(j&&typeof j!="number")throw(0,t.illegalArgument)("newEol");this.f=j}constructor(j,fe){this.c=j,this.e=fe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};Z=l=qe([N],Z),e.TextEdit=Z;let ge=u=class{static isNotebookCellEdit(j){return j instanceof u?!0:j?Kt.isNotebookRange(j)&&Array.isArray(j.newCells):!1}static replaceCells(j,fe){return new u(j,fe)}static insertCells(j,fe){return new u(new Kt(j,j),fe)}static deleteCells(j){return new u(j,[])}static updateCellMetadata(j,fe){const Te=new u(new Kt(j,j),[]);return Te.newCellMetadata=fe,Te}static updateNotebookMetadata(j){const fe=new u(new Kt(0,0),[]);return fe.newNotebookMetadata=j,fe}constructor(j,fe){this.range=j,this.newCells=fe}};ge=u=qe([N],ge),e.NotebookEdit=ge;class ve{static isSnippetTextEdit(j){return j instanceof ve?!0:j?V.isRange(j.range)&&ze.isSnippetString(j.snippet):!1}static replace(j,fe){return new ve(j,fe)}static insert(j,fe){return ve.replace(new V(j,j),fe)}constructor(j,fe){this.range=j,this.snippet=fe}}e.SnippetTextEdit=ve;var De;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(De=e.FileEditType||(e.FileEditType={}));let Re=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(j,fe,Te,Ke){this.c.push({_type:1,from:j,to:fe,options:Te,metadata:Ke})}createFile(j,fe,Te){this.c.push({_type:1,from:void 0,to:j,options:fe,metadata:Te})}deleteFile(j,fe,Te){this.c.push({_type:1,from:j,to:void 0,options:fe,metadata:Te})}e(j,fe,Te){this.c.push({_type:3,metadata:Te,uri:j,edit:{editType:5,metadata:fe},notebookMetadata:fe})}f(j,fe,Te,Ke){const Ye=fe.start,ct=fe.end;(Ye!==ct||Te.length>0)&&this.c.push({_type:5,uri:j,index:Ye,count:ct-Ye,cells:Te,metadata:Ke})}g(j,fe,Te,Ke){this.c.push({_type:3,metadata:Ke,uri:j,edit:{editType:8,index:fe,metadata:Te}})}replace(j,fe,Te,Ke){this.c.push({_type:2,uri:j,edit:new Z(fe,Te),metadata:Ke})}insert(j,fe,Te,Ke){this.replace(j,new V(fe,fe),Te,Ke)}delete(j,fe,Te){this.replace(j,fe,"",Te)}has(j){return this.c.some(fe=>fe._type===2&&fe.uri.toString()===j.toString())}set(j,fe){if(fe)for(const Te of fe){if(!Te)continue;let Ke,Ye;Array.isArray(Te)?(Ke=Te[0],Ye=Te[1]):Ke=Te,ge.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(j,Ke.range.start,Ke.newCellMetadata,Ye):Ke.newNotebookMetadata?this.e(j,Ke.newNotebookMetadata,Ye):this.f(j,Ke.range,Ke.newCells,Ye):ve.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:j,range:Ke.range,edit:Ke.snippet,metadata:Ye}):this.c.push({_type:2,uri:j,edit:Ke,metadata:Ye})}else{for(let Te=0;Te<this.c.length;Te++){const Ke=this.c[Te];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===j.toString()&&(this.c[Te]=void 0);break}}(0,a.coalesceInPlace)(this.c)}}get(j){const fe=[];for(const Te of this.c)Te._type===2&&Te.uri.toString()===j.toString()&&fe.push(Te.edit);return fe}entries(){const j=new A.ResourceMap;for(const fe of this.c)if(fe._type===2){let Te=j.get(fe.uri);Te||(Te=[fe.uri,[]],j.set(fe.uri,Te)),Te[1].push(fe.edit)}return[...j.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Re=qe([N],Re),e.WorkspaceEdit=Re;let ze=s=class{static isSnippetString(j){return j instanceof s?!0:j?typeof j.value=="string":!1}static c(j){return j.replace(/\$|}|\\/g,"\\$&")}constructor(j){this.e=1,this.value=j||""}appendText(j){return this.value+=s.c(j),this}appendTabstop(j=this.e++){return this.value+="$",this.value+=j,this}appendPlaceholder(j,fe=this.e++){if(typeof j=="function"){const Te=new s;Te.e=this.e,j(Te),this.e=Te.e,j=Te.value}else j=s.c(j);return this.value+="${",this.value+=fe,this.value+=":",this.value+=j,this.value+="}",this}appendChoice(j,fe=this.e++){const Te=j.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=fe,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(j,fe){if(typeof fe=="function"){const Te=new s;Te.e=this.e,fe(Te),this.e=Te.e,fe=Te.value}else typeof fe=="string"&&(fe=fe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=j,fe&&(this.value+=":",this.value+=fe),this.value+="}",this}};ze=s=qe([N],ze),e.SnippetString=ze;var se;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(se=e.DiagnosticTag||(e.DiagnosticTag={}));var ue;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(ue=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let he=c=class{static isLocation(j){return j instanceof c?!0:j?V.isRange(j.range)&&C.URI.isUri(j.uri):!1}constructor(j,fe){if(this.uri=j,fe)if(V.isRange(fe))this.range=V.of(fe);else if(x.isPosition(fe))this.range=new V(fe,fe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};he=c=qe([N],he),e.Location=he;let ee=class{static is(j){return j?typeof j.message=="string"&&j.location&&V.isRange(j.location.range)&&C.URI.isUri(j.location.uri):!1}constructor(j,fe){this.location=j,this.message=fe}static isEqual(j,fe){return j===fe?!0:!j||!fe?!1:j.message===fe.message&&j.location.range.isEqual(fe.location.range)&&j.location.uri.toString()===fe.location.uri.toString()}};ee=qe([N],ee),e.DiagnosticRelatedInformation=ee;let oe=class{constructor(j,fe,Te=ue.Error){if(!V.isRange(j))throw new TypeError("range must be set");if(!fe)throw new TypeError("message must be set");this.range=j,this.message=fe,this.severity=Te}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(j,fe){return j===fe?!0:!j||!fe?!1:j.message===fe.message&&j.severity===fe.severity&&j.code===fe.code&&j.severity===fe.severity&&j.source===fe.source&&j.range.isEqual(fe.range)&&(0,a.equals)(j.tags,fe.tags)&&(0,a.equals)(j.relatedInformation,fe.relatedInformation,ee.isEqual)}};oe=qe([N],oe),e.Diagnostic=oe;let ie=class{constructor(j,fe){if(!j)throw new Error("Illegal argument, contents must be defined");Array.isArray(j)?this.contents=j:this.contents=[j],this.range=fe}};ie=qe([N],ie),e.Hover=ie;var O;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(O=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let H=class{constructor(j,fe=O.Text){this.range=j,this.kind=fe}toJSON(){return{range:this.range,kind:O[this.kind]}}};H=qe([N],H),e.DocumentHighlight=H;var q;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(q=e.SymbolKind||(e.SymbolKind={}));var Y;(function(G){G[G.Deprecated=1]="Deprecated"})(Y=e.SymbolTag||(e.SymbolTag={}));let de=n=class{static validate(j){if(!j.name)throw new Error("name must not be falsy")}constructor(j,fe,Te,Ke,Ye){this.name=j,this.kind=fe,this.containerName=Ye,typeof Te=="string"&&(this.containerName=Te),Ke instanceof he?this.location=Ke:Te instanceof V&&(this.location=new he(Ke,Te)),n.validate(this)}toJSON(){return{name:this.name,kind:q[this.kind],location:this.location,containerName:this.containerName}}};de=n=qe([N],de),e.SymbolInformation=de;let be=r=class{static validate(j){if(!j.name)throw new Error("name must not be falsy");if(!j.range.contains(j.selectionRange))throw new Error("selectionRange must be contained in fullRange");j.children?.forEach(r.validate)}constructor(j,fe,Te,Ke,Ye){this.name=j,this.detail=fe,this.kind=Te,this.range=Ke,this.selectionRange=Ye,this.children=[],r.validate(this)}};be=r=qe([N],be),e.DocumentSymbol=be;var Pe;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(Pe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let pe=class{constructor(j,fe){this.title=j,this.kind=fe}};pe=qe([N],pe),e.CodeAction=pe;let Ce=g=class{constructor(j){this.value=j}append(j){return new g(this.value?this.value+g.c+j:j)}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+g.c)}};Ce.c=".",Ce=g=qe([N],Ce),e.CodeActionKind=Ce,Ce.Empty=new Ce(""),Ce.QuickFix=Ce.Empty.append("quickfix"),Ce.Refactor=Ce.Empty.append("refactor"),Ce.RefactorExtract=Ce.Refactor.append("extract"),Ce.RefactorInline=Ce.Refactor.append("inline"),Ce.RefactorMove=Ce.Refactor.append("move"),Ce.RefactorRewrite=Ce.Refactor.append("rewrite"),Ce.Source=Ce.Empty.append("source"),Ce.SourceOrganizeImports=Ce.Source.append("organizeImports"),Ce.SourceFixAll=Ce.Source.append("fixAll");let ke=class{constructor(j,fe){if(this.range=j,this.parent=fe,fe&&!fe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ke=qe([N],ke),e.SelectionRange=ke;class je{constructor(j,fe,Te,Ke,Ye,ct){this.kind=j,this.name=fe,this.detail=Te,this.uri=Ke,this.range=Ye,this.selectionRange=ct}}e.CallHierarchyItem=je;class Ge{constructor(j,fe){this.fromRanges=fe,this.from=j}}e.CallHierarchyIncomingCall=Ge;class et{constructor(j,fe){this.fromRanges=fe,this.to=j}}e.CallHierarchyOutgoingCall=et;var _e;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(_e=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let nt=class{constructor(j,fe){this.range=j,this.command=fe}get isResolved(){return!!this.command}};nt=qe([N],nt),e.CodeLens=nt;let st=P=class{static isMarkdownString(j){return j instanceof P?!0:j&&j.appendCodeblock&&j.appendMarkdown&&j.appendText&&j.value!==void 0}constructor(j,fe=!1){b.set(this,void 0),Je(this,b,new I.MarkdownString(j,{supportThemeIcons:fe}),"f")}get value(){return Me(this,b,"f").value}set value(j){Me(this,b,"f").value=j}get isTrusted(){return Me(this,b,"f").isTrusted}set isTrusted(j){Me(this,b,"f").isTrusted=j}get supportThemeIcons(){return Me(this,b,"f").supportThemeIcons}set supportThemeIcons(j){Me(this,b,"f").supportThemeIcons=j}get supportHtml(){return Me(this,b,"f").supportHtml}set supportHtml(j){Me(this,b,"f").supportHtml=j}get baseUri(){return Me(this,b,"f").baseUri}set baseUri(j){Me(this,b,"f").baseUri=j}appendText(j){return Me(this,b,"f").appendText(j),this}appendMarkdown(j){return Me(this,b,"f").appendMarkdown(j),this}appendCodeblock(j,fe){return Me(this,b,"f").appendCodeblock(fe??"",j),this}};b=new WeakMap,st=P=qe([N],st),e.MarkdownString=st;let ht=class{constructor(j,fe){this.label=j,this.documentation=fe}};ht=qe([N],ht),e.ParameterInformation=ht;let Fe=class{constructor(j,fe){this.label=j,this.documentation=fe,this.parameters=[]}};Fe=qe([N],Fe),e.SignatureInformation=Fe;let it=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};it=qe([N],it),e.SignatureHelp=it;var ae;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(ae=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var $;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})($=e.InlayHintKind||(e.InlayHintKind={}));let ce=class{constructor(j){this.value=j}};ce=qe([N],ce),e.InlayHintLabelPart=ce;let Ie=class{constructor(j,fe,Te){this.position=j,this.label=fe,this.kind=Te}};Ie=qe([N],Ie),e.InlayHint=Ie;var Le;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Le=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Be;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(Be=e.CompletionItemKind||(e.CompletionItemKind={}));var xe;(function(G){G[G.Deprecated=1]="Deprecated"})(xe=e.CompletionItemTag||(e.CompletionItemTag={}));let Ze=class{constructor(j,fe){this.label=j,this.kind=fe}toJSON(){return{label:this.label,kind:this.kind&&Be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ze=qe([N],Ze),e.CompletionItem=Ze;let mt=class{constructor(j=[],fe=!1){this.items=j,this.isIncomplete=fe}};mt=qe([N],mt),e.CompletionList=mt;let ft=class{constructor(j,fe,Te){this.insertText=j,this.range=fe,this.command=Te}};ft=qe([N],ft),e.InlineSuggestion=ft;let lt=class{constructor(j){this.commands=void 0,this.items=j}};lt=qe([N],lt),e.InlineSuggestionList=lt;var ot;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(ot=e.ViewColumn||(e.ViewColumn={}));var rt;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(rt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var At;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative"})(At=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Rt;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(Rt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ft;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Ft=e.TextEditorRevealType||(e.TextEditorRevealType={}));var pt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var kt;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(kt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Bt;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(Bt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(G){function j(fe){switch(fe){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=j}(pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Mt=class{constructor(j,fe){if(fe&&!C.URI.isUri(fe))throw(0,t.illegalArgument)("target");if(!V.isRange(j)||j.isEmpty)throw(0,t.illegalArgument)("range");this.range=j,this.target=fe}};Mt=qe([N],Mt),e.DocumentLink=Mt;let Xe=class{constructor(j,fe,Te,Ke){this.red=j,this.green=fe,this.blue=Te,this.alpha=Ke}};Xe=qe([N],Xe),e.Color=Xe;let Ot=class{constructor(j,fe){if(fe&&!(fe instanceof Xe))throw(0,t.illegalArgument)("color");if(!V.isRange(j)||j.isEmpty)throw(0,t.illegalArgument)("range");this.range=j,this.color=fe}};Ot=qe([N],Ot),e.ColorInformation=Ot;let Ut=class{constructor(j){if(!j||typeof j!="string")throw(0,t.illegalArgument)("label");this.label=j}};Ut=qe([N],Ut),e.ColorPresentation=Ut;var Ht;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(Ht=e.ColorFormat||(e.ColorFormat={}));var bt;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(bt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Lt;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(Lt=e.TerminalExitReason||(e.TerminalExitReason={}));class Ae{constructor(j,fe,Te){if(this.startIndex=j,this.length=fe,this.tooltip=Te,typeof j!="number"||j<0)throw(0,t.illegalArgument)("startIndex");if(typeof fe!="number"||fe<1)throw(0,t.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Ae;var Oe;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(Oe=e.TerminalLocation||(e.TerminalLocation={}));class Ee{constructor(j){if(this.options=j,typeof j!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=Ee;var re;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(re=e.TaskRevealKind||(e.TaskRevealKind={}));var Ne;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(Ne=e.TaskPanelKind||(e.TaskPanelKind={}));let $e=L=class{static from(j){switch(j){case"clean":return L.Clean;case"build":return L.Build;case"rebuild":return L.Rebuild;case"test":return L.Test;default:return}}constructor(j,fe){if(this.label=fe,typeof j!="string"||typeof fe!="string")throw(0,t.illegalArgument)("name");this.c=j}get id(){return this.c}};$e.Clean=new L("clean","Clean"),$e.Build=new L("build","Build"),$e.Rebuild=new L("rebuild","Rebuild"),$e.Test=new L("test","Test"),$e=L=qe([N],$e),e.TaskGroup=$e;function Qe(G){let j="";for(let fe=0;fe<G.length;fe++)j+=G[fe].replace(/,/g,",,")+",";return j}let Ve=class{constructor(j,fe,Te){if(typeof j!="string")throw(0,t.illegalArgument)("process");this.e=[],this.c=j,fe!==void 0&&(Array.isArray(fe)?(this.e=fe,this.f=Te):this.f=fe)}get process(){return this.c}set process(j){if(typeof j!="string")throw(0,t.illegalArgument)("process");this.c=j}get args(){return this.e}set args(j){Array.isArray(j)||(j=[]),this.e=j}get options(){return this.f}set options(j){this.f=j}computeId(){const j=[];if(j.push("process"),this.c!==void 0&&j.push(this.c),this.e&&this.e.length>0)for(const fe of this.e)j.push(fe);return Qe(j)}};Ve=qe([N],Ve),e.ProcessExecution=Ve;let tt=class{constructor(j,fe,Te){if(this.f=[],Array.isArray(fe)){if(!j)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof j!="string"&&typeof j.value!="string")throw(0,t.illegalArgument)("command");this.e=j,this.f=fe,this.g=Te}else{if(typeof j!="string")throw(0,t.illegalArgument)("commandLine");this.c=j,this.g=fe}}get commandLine(){return this.c}set commandLine(j){if(typeof j!="string")throw(0,t.illegalArgument)("commandLine");this.c=j}get command(){return this.e?this.e:""}set command(j){if(typeof j!="string"&&typeof j.value!="string")throw(0,t.illegalArgument)("command");this.e=j}get args(){return this.f}set args(j){this.f=j||[]}get options(){return this.g}set options(j){this.g=j}computeId(){const j=[];if(j.push("shell"),this.c!==void 0&&j.push(this.c),this.e!==void 0&&j.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const fe of this.f)j.push(typeof fe=="string"?fe:fe.value);return Qe(j)}};tt=qe([N],tt),e.ShellExecution=tt;var It;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(It=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class Tt{constructor(j){this.c=j}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(j){this.c=j}get callback(){return this.c}}e.CustomExecution=Tt;let wt=z=class{constructor(j,fe,Te,Ke,Ye,ct){this.j=!1,this.k=this.definition=j;let dt;typeof fe=="string"?(this.m=this.name=fe,this.t=this.source=Te,this.execution=Ke,dt=Ye,this.j=!0):fe===Et.Global||fe===Et.Workspace?(this.target=fe,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Ye,dt=ct):(this.target=fe,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Ye,dt=ct),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(j){this.h=j}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof Ve?this.k={type:z.e,id:this.n.computeId()}:this.n instanceof tt?this.k={type:z.f,id:this.n.computeId()}:this.n instanceof Tt?this.k={type:z.c,id:this.n.computeId()}:this.k={type:z.g,id:(0,R.generateUuid)()}}get definition(){return this.k}set definition(j){if(j==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=j}get scope(){return this.l}set target(j){this.y(),this.l=j}get name(){return this.m}set name(j){if(typeof j!="string")throw(0,t.illegalArgument)("name");this.y(),this.m=j}get execution(){return this.n}set execution(j){j===null&&(j=void 0),this.y(),this.n=j;const fe=this.k.type;(z.g===fe||z.e===fe||z.f===fe||z.c===fe)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(j){if(Array.isArray(j))this.y(),this.o=j,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(j){j!==!0&&j!==!1&&(j=!1),this.y(),this.r=j}get source(){return this.t}set source(j){if(typeof j!="string"||j.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.y(),this.t=j}get group(){return this.u}set group(j){j===null&&(j=void 0),this.y(),this.u=j}get detail(){return this.x}set detail(j){j===null&&(j=void 0),this.x=j}get presentationOptions(){return this.v}set presentationOptions(j){j==null&&(j=Object.create(null)),this.y(),this.v=j}get runOptions(){return this.w}set runOptions(j){j==null&&(j=Object.create(null)),this.y(),this.w=j}};wt.c="customExecution",wt.e="process",wt.f="shell",wt.g="$empty",wt=z=qe([N],wt),e.Task=wt;var vt;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(vt=e.ProgressLocation||(e.ProgressLocation={}));var yt;(function(G){function j(fe){const Te=fe;return(0,S.isNumber)(Te.value)?Te.tooltip&&!(0,S.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}G.isViewBadge=j})(yt=e.ViewBadge||(e.ViewBadge={}));let zt=_=class{static isTreeItem(j,fe){if(j instanceof _)return!0;const Te=j;if(Te.label!==void 0&&!(0,S.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,S.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,S.isString)(Te.iconPath)&&!C.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,S.isString)(Te.iconPath.id))){const Ke=Te.iconPath;if(!Ke||!(0,S.isString)(Ke.light)&&!C.URI.isUri(Ke.light)&&!(0,S.isString)(Ke.dark)&&!C.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}if(Te.description!==void 0&&!(0,S.isString)(Te.description)&&typeof Te.description!="boolean")return console.log("INVALID tree item, invalid description",Te.description),!1;if(Te.resourceUri!==void 0&&!C.URI.isUri(Te.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1;if(Te.tooltip!==void 0&&!(0,S.isString)(Te.tooltip)&&!(Te.tooltip instanceof st))return console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1;if(Te.command!==void 0&&!Te.command.command)return console.log("INVALID tree item, invalid command",Te.command),!1;if(Te.collapsibleState!==void 0&&Te.collapsibleState<Xt.None&&Te.collapsibleState>Xt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1;if(Te.contextValue!==void 0&&!(0,S.isString)(Te.contextValue))return console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1;if(Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1;if(Te.checkboxState!==void 0){(0,v.checkProposedApiEnabled)(fe,"treeItemCheckbox");const Ke=(0,S.isNumber)(Te.checkboxState)?Te.checkboxState:(0,S.isObject)(Te.checkboxState)&&(0,S.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,Ye=!(0,S.isNumber)(Te.checkboxState)&&(0,S.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==St.Checked&&Ke!==St.Unchecked||Ye!==void 0&&!(0,S.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}return!0}constructor(j,fe=Xt.None){this.collapsibleState=fe,C.URI.isUri(j)?this.resourceUri=j:this.label=j}};zt=_=qe([N],zt),e.TreeItem=zt;var Xt;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(Xt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var St;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(St=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let on=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(j,fe){this.value=j,this.id=fe??(0,R.generateUuid)()}};on=qe([N],on),e.DataTransferItem=on;let an=class{constructor(j){f.set(this,new Map);for(const[fe,Te]of j??[]){const Ke=Me(this,f,"f").get(fe);Ke?Ke.push(Te):Me(this,f,"f").set(fe,[Te])}}get(j){return Me(this,f,"f").get(j)?.[0]}set(j,fe){Me(this,f,"f").set(j,[fe])}forEach(j,fe){for(const[Te,Ke]of Me(this,f,"f"))for(const Ye of Ke)j.call(fe,Ye,Te,this)}*[(f=new WeakMap,Symbol.iterator)](){for(const[j,fe]of Me(this,f,"f"))for(const Te of fe)yield[j,Te]}};an=qe([N],an),e.DataTransfer=an;let Zt=class{constructor(j){this.insertText=j}};Zt=qe([N],Zt),e.DocumentDropEdit=Zt;let bn=class{constructor(j){this.insertText=j}};bn=qe([N],bn),e.DocumentPasteEdit=bn;let Ct=class{constructor(j,fe){this.id=j,this.color=fe}static isThemeIcon(j){return typeof j.id!="string"?(console.log("INVALID ThemeIcon, invalid id",j.id),!1):!0}};Ct=qe([N],Ct),e.ThemeIcon=Ct,Ct.File=new Ct("file"),Ct.Folder=new Ct("folder");let cn=class{constructor(j){this.id=j}};cn=qe([N],cn),e.ThemeColor=cn;var On;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(On=e.ConfigurationTarget||(e.ConfigurationTarget={}));let en=class{get base(){return this.c}set base(j){this.c=j,this.e=C.URI.file(j)}get baseUri(){return this.e}set baseUri(j){this.e=j,this.c=j.fsPath}constructor(j,fe){if(typeof j!="string"&&(!j||!C.URI.isUri(j)&&!C.URI.isUri(j.uri)))throw(0,t.illegalArgument)("base");if(typeof fe!="string")throw(0,t.illegalArgument)("pattern");typeof j=="string"?this.baseUri=C.URI.file(j):C.URI.isUri(j)?this.baseUri=j:this.baseUri=j.uri,this.pattern=fe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};en=qe([N],en),e.RelativePattern=en;let jt=class{constructor(j,fe,Te,Ke){this.enabled=typeof j=="boolean"?j:!0,typeof fe=="string"&&(this.condition=fe),typeof Te=="string"&&(this.hitCondition=Te),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=(0,R.generateUuid)()),this.c}};jt=qe([N],jt),e.Breakpoint=jt;let ut=class extends jt{constructor(j,fe,Te,Ke,Ye){if(super(fe,Te,Ke,Ye),j===null)throw(0,t.illegalArgument)("location");this.location=j}};ut=qe([N],ut),e.SourceBreakpoint=ut;let wn=class extends jt{constructor(j,fe,Te,Ke,Ye){super(fe,Te,Ke,Ye),this.functionName=j}};wn=qe([N],wn),e.FunctionBreakpoint=wn;let Vt=class extends jt{constructor(j,fe,Te,Ke,Ye,ct,dt){if(super(Ke,Ye,ct,dt),!fe)throw(0,t.illegalArgument)("dataId");this.label=j,this.dataId=fe,this.canPersist=Te}};Vt=qe([N],Vt),e.DataBreakpoint=Vt;let _t=class{constructor(j,fe,Te){this.command=j,this.args=fe||[],this.options=Te}};_t=qe([N],_t),e.DebugAdapterExecutable=_t;let ln=class{constructor(j,fe){this.port=j,this.host=fe}};ln=qe([N],ln),e.DebugAdapterServer=ln;let vn=class{constructor(j){this.path=j}};vn=qe([N],vn),e.DebugAdapterNamedPipeServer=vn;let un=class{constructor(j){this.implementation=j}};un=qe([N],un),e.DebugAdapterInlineImplementation=un;let En=class{constructor(j,fe){this.range=j,this.expression=fe}};En=qe([N],En),e.EvaluatableExpression=En;var kn;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(kn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let tn=class{constructor(j,fe){this.range=j,this.text=fe}};tn=qe([N],tn),e.InlineValueText=tn;let Sn=class{constructor(j,fe,Te=!0){this.range=j,this.variableName=fe,this.caseSensitiveLookup=Te}};Sn=qe([N],Sn),e.InlineValueVariableLookup=Sn;let rn=class{constructor(j,fe){this.range=j,this.expression=fe}};rn=qe([N],rn),e.InlineValueEvaluatableExpression=rn;let sn=class{constructor(j,fe){this.frameId=j,this.stoppedLocation=fe}};sn=qe([N],sn),e.InlineValueContext=sn;var Nn;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(Nn=e.FileChangeType||(e.FileChangeType={}));let yn=K=class extends Error{static FileExists(j){return new K(j,T.FileSystemProviderErrorCode.FileExists,K.FileExists)}static FileNotFound(j){return new K(j,T.FileSystemProviderErrorCode.FileNotFound,K.FileNotFound)}static FileNotADirectory(j){return new K(j,T.FileSystemProviderErrorCode.FileNotADirectory,K.FileNotADirectory)}static FileIsADirectory(j){return new K(j,T.FileSystemProviderErrorCode.FileIsADirectory,K.FileIsADirectory)}static NoPermissions(j){return new K(j,T.FileSystemProviderErrorCode.NoPermissions,K.NoPermissions)}static Unavailable(j){return new K(j,T.FileSystemProviderErrorCode.Unavailable,K.Unavailable)}constructor(j,fe=T.FileSystemProviderErrorCode.Unknown,Te){super(C.URI.isUri(j)?j.toString(!0):j),this.code=Te?.name??"Unknown",(0,T.markAsFileSystemProviderError)(this,fe),Object.setPrototypeOf(this,K.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};yn=K=qe([N],yn),e.FileSystemError=yn;let Qt=class{constructor(j,fe,Te){this.start=j,this.end=fe,this.kind=Te}};Qt=qe([N],Qt),e.FoldingRange=Qt;var Fn;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(Fn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Mn;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Mn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Un;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(Un=e.CommentMode||(e.CommentMode={}));var Bn;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(Bn=e.CommentThreadState||(e.CommentThreadState={}));class zn{constructor(j,fe=[]){this.tokenTypes=j,this.tokenModifiers=fe}}e.SemanticTokensLegend=zn;function Cn(G){return typeof G>"u"||(0,S.isStringArray)(G)}class dn{constructor(j){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,j){this.l=!0;for(let fe=0,Te=j.tokenTypes.length;fe<Te;fe++)this.j.set(j.tokenTypes[fe],fe);for(let fe=0,Te=j.tokenModifiers.length;fe<Te;fe++)this.k.set(j.tokenModifiers[fe],fe)}}push(j,fe,Te,Ke,Ye){if(typeof j=="number"&&typeof fe=="number"&&typeof Te=="number"&&typeof Ke=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(j,fe,Te,Ke,Ye);if(V.isRange(j)&&typeof fe=="string"&&Cn(Te))return this.m(j,fe,Te);throw(0,t.illegalArgument)()}m(j,fe,Te){if(!this.l)throw new Error("Legend must be provided in constructor");if(j.start.line!==j.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(fe))throw new Error("`tokenType` is not in the provided legend");const Ke=j.start.line,Ye=j.start.character,ct=j.end.character-j.start.character,dt=this.j.get(fe);let Nt=0;if(Te)for(const Wt of Te){if(!this.k.has(Wt))throw new Error("`tokenModifier` is not in the provided legend");const qt=this.k.get(Wt);Nt|=1<<qt>>>0}this.n(Ke,Ye,ct,dt,Nt)}n(j,fe,Te,Ke,Ye){if(this.f&&(j<this.c||j===this.c&&fe<this.e)){this.f=!1;const Nt=this.g.length/5|0;let Wt=0,qt=0;for(let xt=0;xt<Nt;xt++){let Yt=this.g[5*xt],Dn=this.g[5*xt+1];Yt===0?(Yt=Wt,Dn+=qt):Yt+=Wt,this.g[5*xt]=Yt,this.g[5*xt+1]=Dn,Wt=Yt,qt=Dn}}let ct=j,dt=fe;this.f&&this.h>0&&(ct-=this.c,ct===0&&(dt-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=dt,this.g[this.h++]=Te,this.g[this.h++]=Ke,this.g[this.h++]=Ye,this.c=j,this.e=fe}static o(j){const fe=[],Te=j.length/5|0;for(let dt=0;dt<Te;dt++)fe[dt]=dt;fe.sort((dt,Nt)=>{const Wt=j[5*dt],qt=j[5*Nt];if(Wt===qt){const xt=j[5*dt+1],Yt=j[5*Nt+1];return xt-Yt}return Wt-qt});const Ke=new Uint32Array(j.length);let Ye=0,ct=0;for(let dt=0;dt<Te;dt++){const Nt=5*fe[dt],Wt=j[Nt+0],qt=j[Nt+1],xt=j[Nt+2],Yt=j[Nt+3],Dn=j[Nt+4],ti=Wt-Ye,Ii=ti===0?qt-ct:qt,In=5*dt;Ke[In+0]=ti,Ke[In+1]=Ii,Ke[In+2]=xt,Ke[In+3]=Yt,Ke[In+4]=Dn,Ye=Wt,ct=qt}return Ke}build(j){return this.f?new hn(new Uint32Array(this.g),j):new hn(dn.o(this.g),j)}}e.SemanticTokensBuilder=dn;class hn{constructor(j,fe){this.resultId=fe,this.data=j}}e.SemanticTokens=hn;class He{constructor(j,fe,Te){this.start=j,this.deleteCount=fe,this.data=Te}}e.SemanticTokensEdit=He;class Gt{constructor(j,fe){this.resultId=fe,this.edits=j}}e.SemanticTokensEdits=Gt;var Tn;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(Tn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let gt=class{constructor(){}};gt.Back={iconPath:new Ct("arrow-left")},gt=qe([N],gt),e.QuickInputButtons=gt;var $n;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})($n=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Wn;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(Wn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Pn;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(Pn=e.ExtensionKind||(e.ExtensionKind={}));class Hn{static validate(j){if(typeof j.badge=="string"){let fe=(0,k.nextCharLength)(j.badge,0);if(fe<j.badge.length&&(fe+=(0,k.nextCharLength)(j.badge,fe)),j.badge.length>fe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(j.badge&&!Ct.isThemeIcon(j.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!j.color&&!j.badge&&!j.tooltip)throw new Error("The decoration is empty");return!0}constructor(j,fe,Te){this.badge=j,this.tooltip=fe,this.color=Te}}e.FileDecoration=Hn;let nn=class{constructor(j){this.kind=j}};nn=qe([N],nn),e.ColorTheme=nn;var jn;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(jn=e.ColorThemeKind||(e.ColorThemeKind={}));class Kt{static isNotebookRange(j){return j instanceof Kt?!0:j?typeof j.start=="number"&&typeof j.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(j,fe){if(j<0)throw(0,t.illegalArgument)("start must be positive");if(fe<0)throw(0,t.illegalArgument)("end must be positive");j<=fe?(this.c=j,this.e=fe):(this.c=fe,this.e=j)}with(j){let fe=this.c,Te=this.e;return j.start!==void 0&&(fe=j.start),j.end!==void 0&&(Te=j.end),fe===this.c&&Te===this.e?this:new Kt(fe,Te)}}e.NotebookRange=Kt;class fn{static validate(j){if(typeof j.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof j.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof j.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(j){return Array.isArray(j)&&j.every(fe=>fn.isNotebookCellData(fe))}static isNotebookCellData(j){return!0}constructor(j,fe,Te,Ke,Ye,ct,dt){this.kind=j,this.value=fe,this.languageId=Te,this.mime=Ke,this.outputs=Ye??[],this.metadata=ct,this.executionSummary=dt,fn.validate(this)}}e.NotebookCellData=fn;class An{constructor(j){this.cells=j}}e.NotebookData=An;class $t{static isNotebookCellOutputItem(j){return j instanceof $t?!0:j?typeof j.mime=="string"&&j.data instanceof Uint8Array:!1}static error(j){const fe={name:j.name,message:j.message,stack:j.stack};return $t.json(fe,"application/vnd.code.notebook.error")}static stdout(j){return $t.text(j,"application/vnd.code.notebook.stdout")}static stderr(j){return $t.text(j,"application/vnd.code.notebook.stderr")}static bytes(j,fe="application/octet-stream"){return new $t(j,fe)}static text(j,fe=D.Mimes.text){const Te=Me($t,w,"f",h).encode(String(j));return new $t(Te,fe)}static json(j,fe="text/x-json"){const Te=JSON.stringify(j,void 0,"	");return $t.text(Te,fe)}constructor(j,fe){this.data=j,this.mime=fe;const Te=(0,D.normalizeMimeType)(fe,!0);if(!Te)throw new Error(`INVALID mime type: ${fe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.NotebookCellOutputItem=$t,w=$t,h={value:new TextEncoder};class mn{static isNotebookCellOutput(j){return j instanceof mn?!0:!j||typeof j!="object"?!1:typeof j.id=="string"&&Array.isArray(j.items)}static ensureUniqueMimeTypes(j,fe=!1){const Te=new Set,Ke=new Set;for(let Ye=0;Ye<j.length;Ye++){const ct=j[Ye],dt=(0,D.normalizeMimeType)(ct.mime);if(!Te.has(dt)||(0,y.isTextStreamMime)(dt)){Te.add(dt);continue}Ke.add(Ye),fe&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ke.size===0?j:j.filter((Ye,ct)=>!Ke.has(ct))}constructor(j,fe,Te){this.items=mn.ensureUniqueMimeTypes(j,!0),typeof fe=="string"?(this.id=fe,this.metadata=Te):(this.id=(0,R.generateUuid)(),this.metadata=fe??Te)}}e.NotebookCellOutput=mn;var Vn;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(Vn=e.NotebookCellKind||(e.NotebookCellKind={}));var qn;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(qn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Gn;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(Gn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Kn;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Kn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class me{constructor(j,fe){this.text=j,this.alignment=fe}}e.NotebookCellStatusBarItem=me;var we;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(we=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Ue;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(Ue=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class at{constructor(j,fe=[]){this.uri=j,this.provides=(0,a.asArray)(fe)}}e.NotebookRendererScript=at;class Dt{constructor(j){this.label=j}}e.NotebookKernelSourceAction=Dt;let Pt=class{constructor(j,fe){this.label=j,this.timestamp=fe}};Pt=qe([N],Pt),e.TimelineItem=Pt;var si;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(si=e.ExtensionMode||(e.ExtensionMode={}));var oi;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(oi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ai;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(ai=e.StandardTokenType||(e.StandardTokenType={}));class ci{constructor(j,fe){this.ranges=j,this.wordPattern=fe}}e.LinkedEditingRanges=ci;class li{constructor(j,fe){this.c=j,this.e=fe}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=li;var ui;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(ui=e.TestResultState||(e.TestResultState={}));var di;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(di=e.TestRunProfileKind||(e.TestRunProfileKind={}));let xn=class{constructor(j=void 0,fe=void 0,Te=void 0){this.include=j,this.exclude=fe,this.profile=Te}};xn=qe([N],xn),e.TestRunRequest=xn;let Xn=F=class{static diff(j,fe,Te){const Ke=new F(j);return Ke.expectedOutput=fe,Ke.actualOutput=Te,Ke}constructor(j){this.message=j}};Xn=F=qe([N],Xn),e.TestMessage=Xn;let _n=class{constructor(j){this.id=j}};_n=qe([N],_n),e.TestTag=_n;let gn=class{constructor(j,fe){this.covered=j,this.total=fe}};gn=qe([N],gn),e.CoveredCount=gn;let Qn=M=class{static fromDetails(j,fe){const Te=new gn(0,0),Ke=new gn(0,0),Ye=new gn(0,0);for(const dt of fe)if("branches"in dt){Te.total+=1,Te.covered+=dt.executionCount>0?1:0;for(const Nt of dt.branches)Ke.total+=1,Ke.covered+=Nt.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=dt.executionCount>0?1:0;const ct=new M(j,Te,Ke.total>0?Ke:void 0,Ye.total>0?Ye:void 0);return ct.detailedCoverage=fe,ct}constructor(j,fe,Te,Ke){this.uri=j,this.statementCoverage=fe,this.branchCoverage=Te,this.functionCoverage=Ke}};Qn=M=qe([N],Qn),e.FileCoverage=Qn;let Yn=class{constructor(j,fe,Te=[]){this.executionCount=j,this.location=fe,this.branches=Te}};Yn=qe([N],Yn),e.StatementCoverage=Yn;let Jn=class{constructor(j,fe){this.executionCount=j,this.location=fe}};Jn=qe([N],Jn),e.BranchCoverage=Jn;let Zn=class{constructor(j,fe){this.executionCount=j,this.location=fe}};Zn=qe([N],Zn),e.FunctionCoverage=Zn;var hi;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var fi;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(fi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var mi;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(mi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class gi{constructor(j,fe,Te,Ke,Ye,ct){this.kind=j,this.name=fe,this.detail=Te,this.uri=Ke,this.range=Ye,this.selectionRange=ct}}e.TypeHierarchyItem=gi;class pi{constructor(j){this.uri=j}}e.TextTabInput=pi;class bi{constructor(j,fe){this.original=j,this.modified=fe}}e.TextDiffTabInput=bi;class wi{constructor(j,fe,Te,Ke){this.base=j,this.input1=fe,this.input2=Te,this.result=Ke}}e.TextMergeTabInput=wi;class vi{constructor(j,fe){this.uri=j,this.viewType=fe}}e.CustomEditorTabInput=vi;class Ei{constructor(j){this.viewType=j}}e.WebviewEditorTabInput=Ei;class Si{constructor(j,fe){this.uri=j,this.notebookType=fe}}e.NotebookEditorTabInput=Si;class yi{constructor(j,fe,Te){this.original=j,this.modified=fe,this.notebookType=Te}}e.NotebookDiffEditorTabInput=yi;class Ci{constructor(){}}e.TerminalEditorTabInput=Ci;class Di{constructor(j,fe){this.uri=j,this.inputBoxUri=fe}}e.InteractiveWindowInput=Di}),define(Se[135],ye([1,0,49,15,8,162,104,7,17]),function(ne,e,a,t,I,A,D,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const C=new Map;function R(v,d){d?C.set(v,d):C.delete(v)}e.setWordDefinitionFor=R;function T(v){return C.get(v)}class E extends A.MirrorTextModel{constructor(d,b,f,w,h,m,p,o){super(b,f,w,h),this.m=d,this.p=m,this.q=p,this.notebook=o,this.b=!1}dispose(){(0,a.ok)(!this.b),this.b=!0,this.q=!1}equalLines(d){return(0,S.equals)(this.d,d)}get document(){if(!this.a){const d=this;this.a={get uri(){return d.c},get fileName(){return d.c.fsPath},get isUntitled(){return d.c.scheme===t.Schemas.untitled},get languageId(){return d.p},get version(){return d.g},get isClosed(){return d.b},get isDirty(){return d.q},save(){return d.r()},getText(b){return b?d.s(b):d.getText()},get eol(){return d.f===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return d.d.length},lineAt(b){return d.t(b)},offsetAt(b){return d.u(b)},positionAt(b){return d.v(b)},validateRange(b){return d.w(b)},validatePosition(b){return d.x(b)},getWordRangeAtPosition(b,f){return d.y(b,f)}}}return Object.freeze(this.a)}_acceptLanguageId(d){(0,a.ok)(!this.b),this.p=d}_acceptIsDirty(d){(0,a.ok)(!this.b),this.q=d}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(d){const b=this.w(d);if(b.isEmpty)return"";if(b.isSingleLine)return this.d[b.start.line].substring(b.start.character,b.end.character);const f=this.f,w=b.start.line,h=b.end.line,m=[];m.push(this.d[w].substring(b.start.character));for(let p=w+1;p<h;p++)m.push(this.d[p]);return m.push(this.d[h].substring(0,b.end.character)),m.join(f)}t(d){let b;if(d instanceof k.Position?b=d.line:typeof d=="number"&&(b=d),typeof b!="number"||b<0||b>=this.d.length||Math.floor(b)!==b)throw new Error("Illegal value for `line`");return new y(b,this.d[b],b===this.d.length-1)}u(d){return d=this.x(d),this.k(),this.h.getPrefixSum(d.line-1)+d.character}v(d){d=Math.floor(d),d=Math.max(0,d),this.k();const b=this.h.getIndexOf(d),f=this.d[b.index].length;return new k.Position(b.index,Math.min(b.remainder,f))}w(d){if(!(d instanceof k.Range))throw new Error("Invalid argument");const b=this.x(d.start),f=this.x(d.end);return b===d.start&&f===d.end?d:new k.Range(b.line,b.character,f.line,f.character)}x(d){if(!(d instanceof k.Position))throw new Error("Invalid argument");if(this.d.length===0)return d.with(0,0);let{line:b,character:f}=d,w=!1;if(b<0)b=0,f=0,w=!0;else if(b>=this.d.length)b=this.d.length-1,f=this.d[b].length,w=!0;else{const h=this.d[b].length;f<0?(f=0,w=!0):f>h&&(f=h,w=!0)}return w?new k.Position(b,f):d}y(d,b){const f=this.x(d);if(!b)b=T(this.p);else if((0,I.regExpLeadsToEndlessLoop)(b))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${b.source}' because it matches the empty string.`);const w=(0,D.getWordAtText)(f.character+1,(0,D.ensureValidWordDefinition)(b),this.d[f.line],0);if(w)return new k.Range(f.line,w.startColumn-1,f.line,w.endColumn-1)}}e.ExtHostDocumentData=E;class y{constructor(d,b,f){this.a=d,this.b=b,this.c=f}get lineNumber(){return this.a}get text(){return this.b}get range(){return new k.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new k.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=y}),define(Se[231],ye([1,0,7,16,4]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(k){this.a=new a.ColorTheme(a.ColorThemeKind.Dark),this.b=new I.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(k){let S;switch(k){case"light":S=a.ColorThemeKind.Light;break;case"hcDark":S=a.ColorThemeKind.HighContrast;break;case"hcLight":S=a.ColorThemeKind.HighContrastLight;break;default:S=a.ColorThemeKind.Dark}this.a=new a.ColorTheme(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};A=qe([We(0,t.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(Se[14],ye([1,0,17,22,148,61,110,28,147,85,83,23,11,2,35,66,122,132,130,90,56,69,226,7]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v,d,b,f,w,h,m,p,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var l;(function(Ae){function Oe(re){const{selectionStartLineNumber:Ne,selectionStartColumn:$e,positionLineNumber:Qe,positionColumn:Ve}=re,tt=new i.Position(Ne-1,$e-1),It=new i.Position(Qe-1,Ve-1);return new i.Selection(tt,It)}Ae.to=Oe;function Ee(re){const{anchor:Ne,active:$e}=re;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:$e.line+1,positionColumn:$e.character+1}}Ae.from=Ee})(l=e.Selection||(e.Selection={}));var u;(function(Ae){function Oe(re){if(!re)return;const{start:Ne,end:$e}=re;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:$e.line+1,endColumn:$e.character+1}}Ae.from=Oe;function Ee(re){if(!re)return;const{startLineNumber:Ne,startColumn:$e,endLineNumber:Qe,endColumn:Ve}=re;return new i.Range(Ne-1,$e-1,Qe-1,Ve-1)}Ae.to=Ee})(u=e.Range||(e.Range={}));var s;(function(Ae){function Oe(Ee){switch(Ee){case 1:return i.StandardTokenType.Comment;case 0:return i.StandardTokenType.Other;case 3:return i.StandardTokenType.RegEx;case 2:return i.StandardTokenType.String}}Ae.to=Oe})(s=e.TokenType||(e.TokenType={}));var c;(function(Ae){function Oe(re){return new i.Position(re.lineNumber-1,re.column-1)}Ae.to=Oe;function Ee(re){return{lineNumber:re.line+1,column:re.character+1}}Ae.from=Ee})(c=e.Position||(e.Position={}));var n;(function(Ae){function Oe(Ne,$e){return(0,a.coalesce)((0,a.asArray)(Ne).map(Qe=>Ee(Qe,$e)))}Ae.from=Oe;function Ee(Ne,$e){if(typeof Ne=="string")return{$serialized:!0,language:Ne};if(Ne)return{$serialized:!0,language:Ne.language,scheme:re(Ne.scheme,$e),pattern:$.from(Ne.pattern)??void 0,exclusive:Ne.exclusive,notebookType:Ne.notebookType}}function re(Ne,$e){return $e&&typeof Ne=="string"?$e.transformOutgoingScheme(Ne):Ne}})(n=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(Ae){function Oe(re){switch(re){case i.DiagnosticTag.Unnecessary:return 1;case i.DiagnosticTag.Deprecated:return 2}}Ae.from=Oe;function Ee(re){switch(re){case 1:return i.DiagnosticTag.Unnecessary;case 2:return i.DiagnosticTag.Deprecated;default:return}}Ae.to=Ee})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var g;(function(Ae){function Oe(re){let Ne;return re.code&&((0,E.isString)(re.code)||(0,E.isNumber)(re.code)?Ne=String(re.code):Ne={value:String(re.code.value),target:re.code.target}),{...u.from(re.range),message:re.message,source:re.source,code:Ne,severity:L.from(re.severity),relatedInformation:re.relatedInformation&&re.relatedInformation.map(P.from),tags:Array.isArray(re.tags)?(0,a.coalesce)(re.tags.map(r.from)):void 0}}Ae.from=Oe;function Ee(re){const Ne=new i.Diagnostic(u.to(re),re.message,L.to(re.severity));return Ne.source=re.source,Ne.code=(0,E.isString)(re.code)?re.code:re.code?.value,Ne.relatedInformation=re.relatedInformation&&re.relatedInformation.map(P.to),Ne.tags=re.tags&&(0,a.coalesce)(re.tags.map(r.to)),Ne}Ae.to=Ee})(g=e.Diagnostic||(e.Diagnostic={}));var P;(function(Ae){function Oe(re){return{...u.from(re.location.range),message:re.message,resource:re.location.uri}}Ae.from=Oe;function Ee(re){return new i.DiagnosticRelatedInformation(new i.Location(re.resource,u.to(re)),re.message)}Ae.to=Ee})(P=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var L;(function(Ae){function Oe(re){switch(re){case i.DiagnosticSeverity.Error:return b.MarkerSeverity.Error;case i.DiagnosticSeverity.Warning:return b.MarkerSeverity.Warning;case i.DiagnosticSeverity.Information:return b.MarkerSeverity.Info;case i.DiagnosticSeverity.Hint:return b.MarkerSeverity.Hint}return b.MarkerSeverity.Error}Ae.from=Oe;function Ee(re){switch(re){case b.MarkerSeverity.Info:return i.DiagnosticSeverity.Information;case b.MarkerSeverity.Warning:return i.DiagnosticSeverity.Warning;case b.MarkerSeverity.Error:return i.DiagnosticSeverity.Error;case b.MarkerSeverity.Hint:return i.DiagnosticSeverity.Hint;default:return i.DiagnosticSeverity.Error}}Ae.to=Ee})(L=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var z;(function(Ae){function Oe(re){return typeof re=="number"&&re>=i.ViewColumn.One?re-1:re===i.ViewColumn.Beside?o.SIDE_GROUP:o.ACTIVE_GROUP}Ae.from=Oe;function Ee(re){if(typeof re=="number"&&re>=0)return re+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=Ee})(z=e.ViewColumn||(e.ViewColumn={}));function _(Ae){return typeof Ae.range<"u"}function K(Ae){return Ae.length===0?!0:!!_(Ae[0])}e.isDecorationOptionsArr=K;var F;(function(Ae){function Oe(Ve){return Ve.map(Ae.from)}Ae.fromMany=Oe;function Ee(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function re(Ve){let tt;if(Ee(Ve)){const{language:wt,value:vt}=Ve;tt={value:"```"+wt+`
`+vt+"\n```\n"}}else i.MarkdownString.isMarkdownString(Ve)?tt={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?tt={value:Ve}:tt={value:""};const It=Object.create(null);tt.uris=It;const Et=wt=>{try{let vt=y.URI.parse(wt,!0);vt=vt.with({query:Ne(vt.query,It)}),It[wt]=vt}catch{}return""},Tt=new S.marked.Renderer;return Tt.link=Et,Tt.image=wt=>typeof wt=="string"?Et(D.parseHrefAndDimensions(wt).href):"",(0,S.marked)(tt.value,{renderer:Tt}),tt}Ae.from=re;function Ne(Ve,tt){if(!Ve)return Ve;let It;try{It=(0,C.parse)(Ve)}catch{}if(!It)return Ve;let Et=!1;return It=(0,T.cloneAndChange)(It,Tt=>{if(y.URI.isUri(Tt)){const wt=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[wt]=Tt,Et=!0,wt}else return}),Et?JSON.stringify(It):Ve}function $e(Ve){const tt=new i.MarkdownString(Ve.value,Ve.supportThemeIcons);return tt.isTrusted=Ve.isTrusted,tt.supportHtml=Ve.supportHtml,tt.baseUri=Ve.baseUri?y.URI.from(Ve.baseUri):void 0,tt}Ae.to=$e;function Qe(Ve){if(!!Ve)return typeof Ve=="string"?Ve:Ae.from(Ve)}Ae.fromStrict=Qe})(F=e.MarkdownString||(e.MarkdownString={}));function M(Ae){return K(Ae)?Ae.map(Oe=>({range:u.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?F.fromMany(Oe.hoverMessage):Oe.hoverMessage?F.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Ae.map(Oe=>({range:u.from(Oe)}))}e.fromRangeOrRangeWithMessage=M;function N(Ae){return typeof Ae>"u"?Ae:typeof Ae=="string"?y.URI.file(Ae):Ae}e.pathOrURIToURI=N;var B;(function(Ae){function Oe(Ee){return typeof Ee>"u"?Ee:{contentText:Ee.contentText,contentIconPath:Ee.contentIconPath?N(Ee.contentIconPath):void 0,border:Ee.border,borderColor:Ee.borderColor,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,color:Ee.color,backgroundColor:Ee.backgroundColor,margin:Ee.margin,width:Ee.width,height:Ee.height}}Ae.from=Oe})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var U;(function(Ae){function Oe(Ee){return typeof Ee>"u"?Ee:{backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?N(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?B.from(Ee.before):void 0,after:Ee.after?B.from(Ee.after):void 0}}Ae.from=Oe})(U=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var W;(function(Ae){function Oe(Ee){if(typeof Ee>"u")return Ee;switch(Ee){case i.DecorationRangeBehavior.OpenOpen:return 0;case i.DecorationRangeBehavior.ClosedClosed:return 1;case i.DecorationRangeBehavior.OpenClosed:return 2;case i.DecorationRangeBehavior.ClosedOpen:return 3}}Ae.from=Oe})(W=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var x;(function(Ae){function Oe(Ee){return{isWholeLine:Ee.isWholeLine,rangeBehavior:Ee.rangeBehavior?W.from(Ee.rangeBehavior):void 0,overviewRulerLane:Ee.overviewRulerLane,light:Ee.light?U.from(Ee.light):void 0,dark:Ee.dark?U.from(Ee.dark):void 0,backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?N(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?B.from(Ee.before):void 0,after:Ee.after?B.from(Ee.after):void 0}}Ae.from=Oe})(x=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var V;(function(Ae){function Oe(re){return{text:re.newText,eol:re.newEol&&st.from(re.newEol),range:u.from(re.range)}}Ae.from=Oe;function Ee(re){const Ne=new i.TextEdit(u.to(re.range),re.text);return Ne.newEol=typeof re.eol>"u"?void 0:st.to(re.eol),Ne}Ae.to=Ee})(V=e.TextEdit||(e.TextEdit={}));var X;(function(Ae){function Oe(re,Ne){const $e={edits:[]};if(re instanceof i.WorkspaceEdit){const Qe=new k.ResourceSet;for(const Ve of re._allEntries())Ve._type===1&&y.URI.isUri(Ve.to)&&Ve.from===void 0&&Qe.add(Ve.to);for(const Ve of re._allEntries())Ve._type===1?$e.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contentsBase64:Ve.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(Ve.options.contents))},metadata:Ve.metadata}):Ve._type===2?$e.edits.push({resource:Ve.uri,textEdit:V.from(Ve.edit),versionId:Qe.has(Ve.uri)?void 0:Ne?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?$e.edits.push({resource:Ve.uri,textEdit:{range:u.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Qe.has(Ve.uri)?void 0:Ne?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?$e.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Ne?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&$e.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Ne?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(mt.from)}})}return $e}Ae.from=Oe;function Ee(re){const Ne=new i.WorkspaceEdit;for(const $e of re.edits)$e.textEdit?Ne.replace(y.URI.revive($e.resource),u.to($e.textEdit.range),$e.textEdit.text):Ne.renameFile(y.URI.revive($e.oldResource),y.URI.revive($e.newResource),$e.options);return Ne}Ae.to=Ee})(X=e.WorkspaceEdit||(e.WorkspaceEdit={}));var Q;(function(Ae){const Oe=Object.create(null);Oe[i.SymbolKind.File]=0,Oe[i.SymbolKind.Module]=1,Oe[i.SymbolKind.Namespace]=2,Oe[i.SymbolKind.Package]=3,Oe[i.SymbolKind.Class]=4,Oe[i.SymbolKind.Method]=5,Oe[i.SymbolKind.Property]=6,Oe[i.SymbolKind.Field]=7,Oe[i.SymbolKind.Constructor]=8,Oe[i.SymbolKind.Enum]=9,Oe[i.SymbolKind.Interface]=10,Oe[i.SymbolKind.Function]=11,Oe[i.SymbolKind.Variable]=12,Oe[i.SymbolKind.Constant]=13,Oe[i.SymbolKind.String]=14,Oe[i.SymbolKind.Number]=15,Oe[i.SymbolKind.Boolean]=16,Oe[i.SymbolKind.Array]=17,Oe[i.SymbolKind.Object]=18,Oe[i.SymbolKind.Key]=19,Oe[i.SymbolKind.Null]=20,Oe[i.SymbolKind.EnumMember]=21,Oe[i.SymbolKind.Struct]=22,Oe[i.SymbolKind.Event]=23,Oe[i.SymbolKind.Operator]=24,Oe[i.SymbolKind.TypeParameter]=25;function Ee(Ne){return typeof Oe[Ne]=="number"?Oe[Ne]:6}Ae.from=Ee;function re(Ne){for(const $e in Oe)if(Oe[$e]===Ne)return Number($e);return i.SymbolKind.Property}Ae.to=re})(Q=e.SymbolKind||(e.SymbolKind={}));var J;(function(Ae){function Oe(re){switch(re){case i.SymbolTag.Deprecated:return 1}}Ae.from=Oe;function Ee(re){switch(re){case 1:return i.SymbolTag.Deprecated}}Ae.to=Ee})(J=e.SymbolTag||(e.SymbolTag={}));var te;(function(Ae){function Oe(re){return{name:re.name,kind:Q.from(re.kind),tags:re.tags&&re.tags.map(J.from),containerName:re.containerName,location:De.from(re.location)}}Ae.from=Oe;function Ee(re){const Ne=new i.SymbolInformation(re.name,Q.to(re.kind),re.containerName,De.to(re.location));return Ne.tags=re.tags&&re.tags.map(J.to),Ne}Ae.to=Ee})(te=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var le;(function(Ae){function Oe(re){const Ne={name:re.name||"!!MISSING: name!!",detail:re.detail,range:u.from(re.range),selectionRange:u.from(re.selectionRange),kind:Q.from(re.kind),tags:re.tags?.map(J.from)??[]};return re.children&&(Ne.children=re.children.map(Oe)),Ne}Ae.from=Oe;function Ee(re){const Ne=new i.DocumentSymbol(re.name,re.detail,Q.to(re.kind),u.to(re.range),u.to(re.selectionRange));return(0,a.isNonEmptyArray)(re.tags)&&(Ne.tags=re.tags.map(J.to)),re.children&&(Ne.children=re.children.map(Ee)),Ne}Ae.to=Ee})(le=e.DocumentSymbol||(e.DocumentSymbol={}));var Z;(function(Ae){function Oe(re){const Ne=new i.CallHierarchyItem(Q.to(re.kind),re.name,re.detail||"",y.URI.revive(re.uri),u.to(re.range),u.to(re.selectionRange));return Ne._sessionId=re._sessionId,Ne._itemId=re._itemId,Ne}Ae.to=Oe;function Ee(re,Ne,$e){if(Ne=Ne??re._sessionId,$e=$e??re._itemId,Ne===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:$e,name:re.name,detail:re.detail,kind:Q.from(re.kind),uri:re.uri,range:u.from(re.range),selectionRange:u.from(re.selectionRange),tags:re.tags?.map(J.from)}}Ae.from=Ee})(Z=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ge;(function(Ae){function Oe(Ee){return new i.CallHierarchyIncomingCall(Z.to(Ee.from),Ee.fromRanges.map(re=>u.to(re)))}Ae.to=Oe})(ge=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ve;(function(Ae){function Oe(Ee){return new i.CallHierarchyOutgoingCall(Z.to(Ee.to),Ee.fromRanges.map(re=>u.to(re)))}Ae.to=Oe})(ve=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var De;(function(Ae){function Oe(re){return{range:re.range&&u.from(re.range),uri:re.uri}}Ae.from=Oe;function Ee(re){return new i.Location(y.URI.revive(re.uri),u.to(re.range))}Ae.to=Ee})(De=e.location||(e.location={}));var Re;(function(Ae){function Oe(re){const Ne=re,$e=re;return{originSelectionRange:Ne.originSelectionRange?u.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:$e.uri,range:u.from(Ne.targetRange?Ne.targetRange:$e.range),targetSelectionRange:Ne.targetSelectionRange?u.from(Ne.targetSelectionRange):void 0}}Ae.from=Oe;function Ee(re){return{targetUri:y.URI.revive(re.uri),targetRange:u.to(re.range),targetSelectionRange:re.targetSelectionRange?u.to(re.targetSelectionRange):void 0,originSelectionRange:re.originSelectionRange?u.to(re.originSelectionRange):void 0}}Ae.to=Ee})(Re=e.DefinitionLink||(e.DefinitionLink={}));var ze;(function(Ae){function Oe(re){return{range:u.from(re.range),contents:F.fromMany(re.contents)}}Ae.from=Oe;function Ee(re){return new i.Hover(re.contents.map(F.to),u.to(re.range))}Ae.to=Ee})(ze=e.Hover||(e.Hover={}));var se;(function(Ae){function Oe(re){return{range:u.from(re.range),expression:re.expression}}Ae.from=Oe;function Ee(re){return new i.EvaluatableExpression(u.to(re.range),re.expression)}Ae.to=Ee})(se=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ue;(function(Ae){function Oe(re){if(re instanceof i.InlineValueText)return{type:"text",range:u.from(re.range),text:re.text};if(re instanceof i.InlineValueVariableLookup)return{type:"variable",range:u.from(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};if(re instanceof i.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(re.range),expression:re.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=Oe;function Ee(re){switch(re.type){case"text":return{range:u.to(re.range),text:re.text};case"variable":return{range:u.to(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};case"expression":return{range:u.to(re.range),expression:re.expression}}}Ae.to=Ee})(ue=e.InlineValue||(e.InlineValue={}));var he;(function(Ae){function Oe(re){return{frameId:re.frameId,stoppedLocation:u.from(re.stoppedLocation)}}Ae.from=Oe;function Ee(re){return new i.InlineValueContext(re.frameId,u.to(re.stoppedLocation))}Ae.to=Ee})(he=e.InlineValueContext||(e.InlineValueContext={}));var ee;(function(Ae){function Oe(re){return{range:u.from(re.range),kind:re.kind}}Ae.from=Oe;function Ee(re){return new i.DocumentHighlight(u.to(re.range),re.kind)}Ae.to=Ee})(ee=e.DocumentHighlight||(e.DocumentHighlight={}));var oe;(function(Ae){function Oe(Ee){switch(Ee){case 1:return i.CompletionTriggerKind.TriggerCharacter;case 2:return i.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return i.CompletionTriggerKind.Invoke}}Ae.to=Oe})(oe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ie;(function(Ae){function Oe(Ee){return{triggerKind:oe.to(Ee.triggerKind),triggerCharacter:Ee.triggerCharacter}}Ae.to=Oe})(ie=e.CompletionContext||(e.CompletionContext={}));var O;(function(Ae){function Oe(re){switch(re){case i.CompletionItemTag.Deprecated:return 1}}Ae.from=Oe;function Ee(re){switch(re){case 1:return i.CompletionItemTag.Deprecated}}Ae.to=Ee})(O=e.CompletionItemTag||(e.CompletionItemTag={}));var H;(function(Ae){const Oe=new Map([[i.CompletionItemKind.Method,0],[i.CompletionItemKind.Function,1],[i.CompletionItemKind.Constructor,2],[i.CompletionItemKind.Field,3],[i.CompletionItemKind.Variable,4],[i.CompletionItemKind.Class,5],[i.CompletionItemKind.Interface,7],[i.CompletionItemKind.Struct,6],[i.CompletionItemKind.Module,8],[i.CompletionItemKind.Property,9],[i.CompletionItemKind.Unit,12],[i.CompletionItemKind.Value,13],[i.CompletionItemKind.Constant,14],[i.CompletionItemKind.Enum,15],[i.CompletionItemKind.EnumMember,16],[i.CompletionItemKind.Keyword,17],[i.CompletionItemKind.Snippet,27],[i.CompletionItemKind.Text,18],[i.CompletionItemKind.Color,19],[i.CompletionItemKind.File,20],[i.CompletionItemKind.Reference,21],[i.CompletionItemKind.Folder,23],[i.CompletionItemKind.Event,10],[i.CompletionItemKind.Operator,11],[i.CompletionItemKind.TypeParameter,24],[i.CompletionItemKind.Issue,26],[i.CompletionItemKind.User,25]]);function Ee($e){return Oe.get($e)??9}Ae.from=Ee;const re=new Map([[0,i.CompletionItemKind.Method],[1,i.CompletionItemKind.Function],[2,i.CompletionItemKind.Constructor],[3,i.CompletionItemKind.Field],[4,i.CompletionItemKind.Variable],[5,i.CompletionItemKind.Class],[7,i.CompletionItemKind.Interface],[6,i.CompletionItemKind.Struct],[8,i.CompletionItemKind.Module],[9,i.CompletionItemKind.Property],[12,i.CompletionItemKind.Unit],[13,i.CompletionItemKind.Value],[14,i.CompletionItemKind.Constant],[15,i.CompletionItemKind.Enum],[16,i.CompletionItemKind.EnumMember],[17,i.CompletionItemKind.Keyword],[27,i.CompletionItemKind.Snippet],[18,i.CompletionItemKind.Text],[19,i.CompletionItemKind.Color],[20,i.CompletionItemKind.File],[21,i.CompletionItemKind.Reference],[23,i.CompletionItemKind.Folder],[10,i.CompletionItemKind.Event],[11,i.CompletionItemKind.Operator],[24,i.CompletionItemKind.TypeParameter],[25,i.CompletionItemKind.User],[26,i.CompletionItemKind.Issue]]);function Ne($e){return re.get($e)??i.CompletionItemKind.Property}Ae.to=Ne})(H=e.CompletionItemKind||(e.CompletionItemKind={}));var q;(function(Ae){function Oe(Ee,re){const Ne=new i.CompletionItem(Ee.label);return Ne.insertText=Ee.insertText,Ne.kind=H.to(Ee.kind),Ne.tags=Ee.tags?.map(O.to),Ne.detail=Ee.detail,Ne.documentation=D.isMarkdownString(Ee.documentation)?F.to(Ee.documentation):Ee.documentation,Ne.sortText=Ee.sortText,Ne.filterText=Ee.filterText,Ne.preselect=Ee.preselect,Ne.commitCharacters=Ee.commitCharacters,v.Range.isIRange(Ee.range)?Ne.range=u.to(Ee.range):typeof Ee.range=="object"&&(Ne.range={inserting:u.to(Ee.range.insert),replacing:u.to(Ee.range.replace)}),Ne.keepWhitespace=typeof Ee.insertTextRules>"u"?!1:Boolean(Ee.insertTextRules&1),typeof Ee.insertTextRules<"u"&&Ee.insertTextRules&4?Ne.insertText=new i.SnippetString(Ee.insertText):(Ne.insertText=Ee.insertText,Ne.textEdit=Ne.range instanceof i.Range?new i.TextEdit(Ne.range,Ne.insertText):void 0),Ee.additionalTextEdits&&Ee.additionalTextEdits.length>0&&(Ne.additionalTextEdits=Ee.additionalTextEdits.map($e=>V.to($e))),Ne.command=re&&Ee.command?re.fromInternal(Ee.command):void 0,Ne}Ae.to=Oe})(q=e.CompletionItem||(e.CompletionItem={}));var Y;(function(Ae){function Oe(re){if(typeof re.label!="string"&&!Array.isArray(re.label))throw new TypeError("Invalid label");return{label:re.label,documentation:F.fromStrict(re.documentation)}}Ae.from=Oe;function Ee(re){return{label:re.label,documentation:D.isMarkdownString(re.documentation)?F.to(re.documentation):re.documentation}}Ae.to=Ee})(Y=e.ParameterInformation||(e.ParameterInformation={}));var de;(function(Ae){function Oe(re){return{label:re.label,documentation:F.fromStrict(re.documentation),parameters:Array.isArray(re.parameters)?re.parameters.map(Y.from):[],activeParameter:re.activeParameter}}Ae.from=Oe;function Ee(re){return{label:re.label,documentation:D.isMarkdownString(re.documentation)?F.to(re.documentation):re.documentation,parameters:Array.isArray(re.parameters)?re.parameters.map(Y.to):[],activeParameter:re.activeParameter}}Ae.to=Ee})(de=e.SignatureInformation||(e.SignatureInformation={}));var be;(function(Ae){function Oe(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(de.from):[]}}Ae.from=Oe;function Ee(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(de.to):[]}}Ae.to=Ee})(be=e.SignatureHelp||(e.SignatureHelp={}));var Pe;(function(Ae){function Oe(Ee,re){const Ne=new i.InlayHint(c.to(re.position),typeof re.label=="string"?re.label:re.label.map(pe.to.bind(void 0,Ee)),re.kind&&Ce.to(re.kind));return Ne.textEdits=re.textEdits&&re.textEdits.map(V.to),Ne.tooltip=D.isMarkdownString(re.tooltip)?F.to(re.tooltip):re.tooltip,Ne.paddingLeft=re.paddingLeft,Ne.paddingRight=re.paddingRight,Ne}Ae.to=Oe})(Pe=e.InlayHint||(e.InlayHint={}));var pe;(function(Ae){function Oe(Ee,re){const Ne=new i.InlayHintLabelPart(re.label);return Ne.tooltip=D.isMarkdownString(re.tooltip)?F.to(re.tooltip):re.tooltip,d.Command.is(re.command)&&(Ne.command=Ee.fromInternal(re.command)),re.location&&(Ne.location=De.to(re.location)),Ne}Ae.to=Oe})(pe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ce;(function(Ae){function Oe(re){return re}Ae.from=Oe;function Ee(re){return re}Ae.to=Ee})(Ce=e.InlayHintKind||(e.InlayHintKind={}));var ke;(function(Ae){function Oe(re){return{range:u.from(re.range),url:re.target,tooltip:re.tooltip}}Ae.from=Oe;function Ee(re){let Ne;if(re.url)try{Ne=typeof re.url=="string"?y.URI.parse(re.url,!0):y.URI.revive(re.url)}catch{}return new i.DocumentLink(u.to(re.range),Ne)}Ae.to=Ee})(ke=e.DocumentLink||(e.DocumentLink={}));var je;(function(Ae){function Oe(re){const Ne=new i.ColorPresentation(re.label);return re.textEdit&&(Ne.textEdit=V.to(re.textEdit)),re.additionalTextEdits&&(Ne.additionalTextEdits=re.additionalTextEdits.map($e=>V.to($e))),Ne}Ae.to=Oe;function Ee(re){return{label:re.label,textEdit:re.textEdit?V.from(re.textEdit):void 0,additionalTextEdits:re.additionalTextEdits?re.additionalTextEdits.map(Ne=>V.from(Ne)):void 0}}Ae.from=Ee})(je=e.ColorPresentation||(e.ColorPresentation={}));var Ge;(function(Ae){function Oe(re){return new i.Color(re[0],re[1],re[2],re[3])}Ae.to=Oe;function Ee(re){return[re.red,re.green,re.blue,re.alpha]}Ae.from=Ee})(Ge=e.Color||(e.Color={}));var et;(function(Ae){function Oe(re){return{range:u.from(re.range)}}Ae.from=Oe;function Ee(re){return new i.SelectionRange(u.to(re.range))}Ae.to=Ee})(et=e.SelectionRange||(e.SelectionRange={}));var _e;(function(Ae){function Oe(Ee){switch(Ee){case 2:return i.TextDocumentSaveReason.AfterDelay;case 1:return i.TextDocumentSaveReason.Manual;case 3:case 4:return i.TextDocumentSaveReason.FocusOut}}Ae.to=Oe})(_e=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(Ae){function Oe(re){switch(re){case i.TextEditorLineNumbersStyle.Off:return 0;case i.TextEditorLineNumbersStyle.Relative:return 2;case i.TextEditorLineNumbersStyle.On:default:return 1}}Ae.from=Oe;function Ee(re){switch(re){case 0:return i.TextEditorLineNumbersStyle.Off;case 2:return i.TextEditorLineNumbersStyle.Relative;case 1:default:return i.TextEditorLineNumbersStyle.On}}Ae.to=Ee})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var st;(function(Ae){function Oe(re){if(re===i.EndOfLine.CRLF)return 1;if(re===i.EndOfLine.LF)return 0}Ae.from=Oe;function Ee(re){if(re===1)return i.EndOfLine.CRLF;if(re===0)return i.EndOfLine.LF}Ae.to=Ee})(st=e.EndOfLine||(e.EndOfLine={}));var ht;(function(Ae){function Oe(Ee){if(typeof Ee=="object")return Ee.viewId;switch(Ee){case i.ProgressLocation.SourceControl:return 3;case i.ProgressLocation.Window:return 10;case i.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ae.from=Oe})(ht=e.ProgressLocation||(e.ProgressLocation={}));var Fe;(function(Ae){function Oe(Ee){const re={start:Ee.start+1,end:Ee.end+1};return Ee.kind&&(re.kind=it.from(Ee.kind)),re}Ae.from=Oe})(Fe=e.FoldingRange||(e.FoldingRange={}));var it;(function(Ae){function Oe(Ee){if(Ee)switch(Ee){case i.FoldingRangeKind.Comment:return d.FoldingRangeKind.Comment;case i.FoldingRangeKind.Imports:return d.FoldingRangeKind.Imports;case i.FoldingRangeKind.Region:return d.FoldingRangeKind.Region}}Ae.from=Oe})(it=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ae;(function(Ae){function Oe(Ee){if(Ee)return{pinned:typeof Ee.preview=="boolean"?!Ee.preview:void 0,inactive:Ee.background,preserveFocus:Ee.preserveFocus,selection:typeof Ee.selection=="object"?u.from(Ee.selection):void 0,override:typeof Ee.override=="boolean"?w.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Ae.from=Oe})(ae=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var $;(function(Ae){function Oe($e){return $e instanceof i.RelativePattern?$e.toJSON():typeof $e=="string"?$e:Ee($e)||re($e)?new i.RelativePattern($e.baseUri??$e.base,$e.pattern).toJSON():$e}Ae.from=Oe;function Ee($e){const Qe=$e;return Qe?y.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function re($e){const Qe=$e;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Ne($e){return typeof $e=="string"?$e:new i.RelativePattern(y.URI.revive($e.baseUri),$e.pattern)}Ae.to=Ne})($=e.GlobPattern||(e.GlobPattern={}));var ce;(function(Ae){function Oe(Ee){if(Ee){if(Array.isArray(Ee))return Ee.map(Oe);if(typeof Ee=="string")return Ee;{const re=Ee;return{language:re.language,scheme:re.scheme,pattern:$.from(re.pattern),exclusive:re.exclusive,notebookType:re.notebookType}}}else return}Ae.from=Oe})(ce=e.LanguageSelector||(e.LanguageSelector={}));var Ie;(function(Ae){function Oe(re){return{start:re.start,end:re.end}}Ae.from=Oe;function Ee(re){return new i.NotebookRange(re.start,re.end)}Ae.to=Ee})(Ie=e.NotebookRange||(e.NotebookRange={}));var Le;(function(Ae){function Oe(re){return{timing:typeof re.runStartTime=="number"&&typeof re.runEndTime=="number"?{startTime:re.runStartTime,endTime:re.runEndTime}:void 0,executionOrder:re.executionOrder,success:re.lastRunSuccess}}Ae.to=Oe;function Ee(re){return{lastRunSuccess:re.success,runStartTime:re.timing?.startTime,runEndTime:re.timing?.endTime,executionOrder:re.executionOrder}}Ae.from=Ee})(Le=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Be;(function(Ae){function Oe(Ee){if(Ee===h.NotebookCellExecutionState.Unconfirmed)return i.NotebookCellExecutionState.Pending;if(Ee===h.NotebookCellExecutionState.Pending)return;if(Ee===h.NotebookCellExecutionState.Executing)return i.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ee}`)}Ae.to=Oe})(Be=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var xe;(function(Ae){function Oe(re){switch(re){case i.NotebookCellKind.Markup:return h.CellKind.Markup;case i.NotebookCellKind.Code:default:return h.CellKind.Code}}Ae.from=Oe;function Ee(re){switch(re){case h.CellKind.Markup:return i.NotebookCellKind.Markup;case h.CellKind.Code:default:return i.NotebookCellKind.Code}}Ae.to=Ee})(xe=e.NotebookCellKind||(e.NotebookCellKind={}));var Ze;(function(Ae){function Oe(re){const Ne={metadata:re.metadata??Object.create(null),cells:[]};for(const $e of re.cells)i.NotebookCellData.validate($e),Ne.cells.push(mt.from($e));return Ne}Ae.from=Oe;function Ee(re){const Ne=new i.NotebookData(re.cells.map(mt.to));return(0,E.isEmptyObject)(re.metadata)||(Ne.metadata=re.metadata),Ne}Ae.to=Ee})(Ze=e.NotebookData||(e.NotebookData={}));var mt;(function(Ae){function Oe(re){return{cellKind:xe.from(re.kind),language:re.languageId,mime:re.mime,source:re.value,metadata:re.metadata,internalMetadata:Le.from(re.executionSummary??{}),outputs:re.outputs?re.outputs.map(lt.from):[]}}Ae.from=Oe;function Ee(re){return new i.NotebookCellData(xe.to(re.cellKind),re.source,re.language,re.mime,re.outputs?re.outputs.map(lt.to):void 0,re.metadata,re.internalMetadata?Le.to(re.internalMetadata):void 0)}Ae.to=Ee})(mt=e.NotebookCellData||(e.NotebookCellData={}));var ft;(function(Ae){function Oe(re){return{mime:re.mime,valueBytes:t.VSBuffer.wrap(re.data)}}Ae.from=Oe;function Ee(re){return new i.NotebookCellOutputItem(re.valueBytes.buffer,re.mime)}Ae.to=Ee})(ft=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var lt;(function(Ae){function Oe(re){return{outputId:re.id,items:re.items.map(ft.from),metadata:re.metadata}}Ae.from=Oe;function Ee(re){const Ne=re.items.map(ft.to);return new i.NotebookCellOutput(Ne,re.outputId,re.metadata)}Ae.to=Ee})(lt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ot;(function(Ae){function Oe(Ne){return re(Ne)?{include:(0,E.withNullAsUndefined)($.from(Ne.include)),exclude:(0,E.withNullAsUndefined)($.from(Ne.exclude))}:(0,E.withNullAsUndefined)($.from(Ne))}Ae.from=Oe;function Ee(Ne){return re(Ne)?{include:$.to(Ne.include),exclude:$.to(Ne.exclude)}:$.to(Ne)}Ae.to=Ee;function re(Ne){const $e=Ne;return $e?!(0,E.isUndefinedOrNull)($e.include)&&!(0,E.isUndefinedOrNull)($e.exclude):!1}})(ot=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var rt;(function(Ae){function Oe(Ee,re,Ne){const $e=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{alignment:Ee.alignment===i.NotebookCellStatusBarAlignment.Left?1:2,command:re.toInternal($e,Ne),text:Ee.text,tooltip:Ee.tooltip,accessibilityInformation:Ee.accessibilityInformation,priority:Ee.priority}}Ae.from=Oe})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var At;(function(Ae){function Oe(Ee,re,Ne){const $e=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{command:re.toInternal($e,Ne),label:Ee.label,description:Ee.description,detail:Ee.detail}}Ae.from=Oe})(At=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Rt;(function(Ae){function Oe(Ee){return{transientOutputs:Ee?.transientOutputs??!1,transientCellMetadata:Ee?.transientCellMetadata??{},transientDocumentMetadata:Ee?.transientDocumentMetadata??{},cellContentMetadata:Ee?.cellContentMetadata??{}}}Ae.from=Oe})(Rt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ft;(function(Ae){function Oe(re){return{uri:re.uri,provides:re.provides}}Ae.from=Oe;function Ee(re){return new i.NotebookRendererScript(y.URI.revive(re.uri),re.provides)}Ae.to=Ee})(Ft=e.NotebookRendererScript||(e.NotebookRendererScript={}));var pt;(function(Ae){function Oe(re){return{message:F.fromStrict(re.message)||"",type:0,expected:re.expectedOutput,actual:re.actualOutput,location:re.location&&{range:u.from(re.location.range),uri:re.location.uri}}}Ae.from=Oe;function Ee(re){const Ne=new i.TestMessage(typeof re.message=="string"?re.message:F.to(re.message));return Ne.actualOutput=re.actual,Ne.expectedOutput=re.expected,Ne.location=re.location?De.to(re.location):void 0,Ne}Ae.to=Ee})(pt=e.TestMessage||(e.TestMessage={}));var kt;(function(Ae){Ae.namespace=p.namespaceTestTag,Ae.denamespace=p.denamespaceTestTag})(kt=e.TestTag||(e.TestTag={}));var Bt;(function(Ae){function Oe(re){const Ne=(0,f.getPrivateApiFor)(re).controllerId;return{extId:m.TestId.fromExtHostTestItem(re,Ne).toString(),label:re.label,uri:y.URI.revive(re.uri),busy:re.busy,tags:re.tags.map($e=>kt.namespace(Ne,$e.id)),range:v.Range.lift(u.from(re.range)),description:re.description||null,sortText:re.sortText||null,error:re.error&&F.fromStrict(re.error)||null}}Ae.from=Oe;function Ee(re){return{parent:void 0,error:void 0,id:m.TestId.fromString(re.extId).localId,label:re.label,uri:y.URI.revive(re.uri),tags:(re.tags||[]).map(Ne=>{const{tagId:$e}=kt.denamespace(Ne);return new i.TestTag($e)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(re.range||void 0),canResolveChildren:!1,busy:re.busy,description:re.description||void 0,sortText:re.sortText||void 0}}Ae.toPlain=Ee})(Bt=e.TestItem||(e.TestItem={})),function(Ae){function Oe(re){return{id:re.id}}Ae.from=Oe;function Ee(re){return new i.TestTag(re.id)}Ae.to=Ee}(kt=e.TestTag||(e.TestTag={}));var Mt;(function(Ae){const Oe=(re,Ne)=>{const $e=[];for(const[Ve,tt]of Ne)m.TestId.compare(tt.item.extId,Ve)===2&&(Ne.delete(Ve),$e.push(tt));const Qe={...Bt.toPlain(re.item),parent:void 0,taskStates:re.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(tt=>tt.type===0).map(pt.to)})),children:$e.map(Ve=>Oe(Ve,Ne))};for(const Ve of Qe.children)Ve.parent=Qe;return Qe};function Ee(re){const Ne=[],$e=new Map;for(const Qe of re.items){$e.set(Qe.item.extId,Qe);const Ve=m.TestId.root(Qe.item.extId);re.request.targets.some(tt=>tt.controllerId===Ve&&tt.testIds.includes(Qe.item.extId))&&Ne.push(Qe)}return{completedAt:re.completedAt,results:Ne.map(Qe=>Oe(Qe,$e))}}Ae.to=Ee})(Mt=e.TestResults||(e.TestResults={}));var Xe;(function(Ae){function Oe($e){return{covered:$e.covered,total:$e.covered}}function Ee($e){return"line"in $e?c.from($e):u.from($e)}function re($e){return"branches"in $e?{count:$e.executionCount,location:Ee($e.location),type:1,branches:$e.branches.length?$e.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&Ee(Qe.location)})):void 0}:{type:0,count:$e.executionCount,location:Ee($e.location)}}Ae.fromDetailed=re;function Ne($e){return{uri:$e.uri,statement:Oe($e.statementCoverage),branch:$e.branchCoverage&&Oe($e.branchCoverage),function:$e.functionCoverage&&Oe($e.functionCoverage),details:$e.detailedCoverage?.map(re)}}Ae.fromFile=Ne})(Xe=e.TestCoverage||(e.TestCoverage={}));var Ot;(function(Ae){function Oe(Ee){switch(Ee){case 1:return i.CodeActionTriggerKind.Invoke;case 2:return i.CodeActionTriggerKind.Automatic}}Ae.to=Oe})(Ot=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ut;(function(Ae){function Oe(re){const Ne=new i.TypeHierarchyItem(Q.to(re.kind),re.name,re.detail||"",y.URI.revive(re.uri),u.to(re.range),u.to(re.selectionRange));return Ne._sessionId=re._sessionId,Ne._itemId=re._itemId,Ne}Ae.to=Oe;function Ee(re,Ne,$e){if(Ne=Ne??re._sessionId,$e=$e??re._itemId,Ne===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:$e,kind:Q.from(re.kind),name:re.name,detail:re.detail??"",uri:re.uri,range:u.from(re.range),selectionRange:u.from(re.selectionRange),tags:re.tags?.map(J.from)}}Ae.from=Ee})(Ut=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ht;(function(Ae){function Oe(Ee){if(!!Ee)return{value:Ee.value,tooltip:Ee.tooltip}}Ae.from=Oe})(Ht=e.ViewBadge||(e.ViewBadge={}));var bt;(function(Ae){function Oe($e,Qe,Ve){const tt=Qe.fileData;return tt?new class extends i.DataTransferItem{asFile(){return{name:tt.name,uri:y.URI.revive(tt.uri),data:(0,A.once)(()=>Ve())}}}("",Qe.id):$e===R.Mimes.uriList&&Qe.uriListData?new i.DataTransferItem(Ne(Qe.uriListData)):new i.DataTransferItem(Qe.asString)}Ae.to=Oe;async function Ee($e,Qe){const Ve=await Qe.asString();if($e===R.Mimes.uriList)return{id:Qe.id,asString:"",fileData:void 0,uriListData:re(Ve)};const tt=Qe.asFile();return{id:Qe.id,asString:Ve,fileData:tt?{name:tt.name,uri:tt.uri}:void 0}}Ae.from=Ee;function re($e){return I.UriList.split($e).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return y.URI.parse(Qe)}catch{}return Qe})}function Ne($e){return I.UriList.create($e.map(Qe=>typeof Qe=="string"?Qe:y.URI.revive(Qe)))}})(bt=e.DataTransferItem||(e.DataTransferItem={}));var Lt;(function(Ae){function Oe(re,Ne){const $e=re.items.map(([Qe,Ve])=>[Qe,bt.to(Qe,Ve,()=>Ne(Ve.id))]);return new i.DataTransfer($e)}Ae.toDataTransfer=Oe;async function Ee(re){const Ne={items:[]},$e=[];return re.forEach((Qe,Ve)=>{$e.push((async()=>{Ne.items.push([Ve,await bt.from(Ve,Qe)])})())}),await Promise.all($e),Ne}Ae.toDataTransferDTO=Ee})(Lt=e.DataTransfer||(e.DataTransfer={}))}),define(Se[232],ye([1,0,2,10,7,14,63]),function(ne,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(C,R,T,E={timeout:1500,errors:3}){this.c=C,this.d=R,this.f=T,this.g=E,this.a=new D.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(C){return(R,T,E)=>{const v={dispose:this.a.push([R,T,C])};return Array.isArray(E)&&E.push(v),v}}async $participateInSave(C,R){const T=a.URI.revive(C);let E=!1;const y=setTimeout(()=>E=!0,this.g.timeout),v=[];try{for(const d of[...this.a]){if(E)break;const b=this.d.getDocument(T),f=await this.h(d,{document:b,reason:A.TextDocumentSaveReason.to(R)});v.push(f)}}finally{clearTimeout(y)}return v}h([C,R,T],E){const y=this.b.get(C);return typeof y=="number"&&y>this.g.errors?Promise.resolve(!1):this.i(T,C,R,E).then(()=>!0,v=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' threw ERROR`),this.c.error(v),!(v instanceof Error)||v.message!=="concurrent_edits"){const d=this.b.get(C);this.b.set(C,d?d+1:1),typeof d=="number"&&d>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(C,R,T,E){const y=[],v=Date.now(),{document:d,reason:b}=E,{version:f}=d,w=Object.freeze({document:d,reason:b,waitUntil(h){if(Object.isFrozen(y))throw(0,t.illegalState)("waitUntil can not be called async");y.push(Promise.resolve(h))}});try{R.apply(T,[w])}catch(h){return Promise.reject(h)}return Object.freeze(y),new Promise((h,m)=>{const p=setTimeout(()=>m(new Error("timeout")),this.g.timeout);return Promise.all(y).then(o=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-v}ms`),clearTimeout(p),h(o)}).catch(o=>{clearTimeout(p),m(o)})}).then(h=>{const m={edits:[]};for(const p of h)if(Array.isArray(p)&&p.every(o=>o instanceof I.TextEdit))for(const{newText:o,newEol:i,range:l}of p)m.edits.push({resource:d.uri,versionId:void 0,textEdit:{range:l&&A.Range.from(l),text:o,eol:i&&A.EndOfLine.from(i)}});if(m.edits.length!==0)return f===d.version?this.f.$tryApplyWorkspaceEdit(m):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(Se[233],ye([1,0,15,2,14,7,90]),function(ne,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class k{constructor(T,E,y,v){this.start=T,this.deletedCount=E,this.deletedItems=y,this.items=v}asApiEvent(){return{range:new A.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(T=>T.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(T,E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1,notebook:T}}constructor(T,E,y){this.notebook=T,this.h=E,this.j=y,this.handle=y.handle,this.uri=t.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(I.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const T=this,E=this.h.getDocument(this.uri);if(!E)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return T.notebook.getCellIndex(T)},notebook:T.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:E.document,get mime(){return T.g},set mime(v){T.g=v},get outputs(){return T.a.slice(0)},get metadata(){return T.b},get executionSummary(){return T.d}};this.f=Object.freeze(y)}return this.f}setOutputs(T){this.a=T.map(I.NotebookCellOutput.to)}setOutputItems(T,E,y){const v=y.map(I.NotebookCellOutputItem.to),d=this.a.find(b=>b.id===T);if(d&&(E||(d.items.length=0),d.items.push(...v),d.items.length>1&&d.items.every(b=>D.isTextStreamMime(b.mime)))){const b=new Map,f=[];d.items.forEach(w=>{let h;b.has(w.mime)?h=b.get(w.mime):(h=[],b.set(w.mime,h),f.push(w.mime)),h.push(w.data)}),d.items.length=0,f.forEach(w=>{const h=D.compressOutputItemStreams(b.get(w));d.items.push({mime:w,data:h.buffer})})}}setMetadata(T){this.b=Object.freeze(T)}setInternalMetadata(T){this.e=T,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(T))}setMime(T){}}e.ExtHostCell=S;class C{constructor(T,E,y,v,d){this.k=T,this.l=E,this.m=y,this.uri=v,this.handle=C.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=d.viewType,this.f=Object.freeze(d.metadata??Object.create(null)),this.r([[0,0,d.cells]],!0,void 0),this.g=d.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const T=this,E={get uri(){return T.uri},get version(){return T.g},get notebookType(){return T.d},get isDirty(){return T.h},get isUntitled(){return T.uri.scheme===a.Schemas.untitled},get isClosed(){return T.j},get metadata(){return T.f},get cellCount(){return T.b.length},cellAt(y){return y=T.n(y),T.b[y].apiCell},getCells(y){return(y?T.p(y):T.b).map(d=>d.apiCell)},save(){return T.q()}};this.e=Object.freeze(E)}return this.e}acceptDocumentPropertiesChanged(T){T.metadata&&(this.f=Object.freeze({...this.f,...T.metadata}))}acceptDirty(T){this.h=T}acceptModelChanged(T,E,y){this.g=T.versionId,this.h=E,this.acceptDocumentPropertiesChanged({metadata:y});const v={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},d=[];for(const f of T.rawEvents)f.kind===D.NotebookCellsChangeType.ModelChange?this.r(f.changes,!1,v.contentChanges):f.kind===D.NotebookCellsChangeType.Move?this.s(f.index,f.length,f.newIdx,v.contentChanges):f.kind===D.NotebookCellsChangeType.Output?(this.t(f.index,f.outputs),d.push({cell:this.b[f.index].apiCell,outputs:this.b[f.index].apiCell.outputs})):f.kind===D.NotebookCellsChangeType.OutputItem?(this.u(f.index,f.outputId,f.append,f.outputItems),d.push({cell:this.b[f.index].apiCell,outputs:this.b[f.index].apiCell.outputs})):f.kind===D.NotebookCellsChangeType.ChangeCellLanguage?(this.v(f.index,f.language),d.push({cell:this.b[f.index].apiCell,document:this.b[f.index].apiCell.document})):f.kind===D.NotebookCellsChangeType.ChangeCellContent?d.push({cell:this.b[f.index].apiCell,document:this.b[f.index].apiCell.document}):f.kind===D.NotebookCellsChangeType.ChangeCellMime?this.w(f.index,f.mime):f.kind===D.NotebookCellsChangeType.ChangeCellMetadata?(this.x(f.index,f.metadata),d.push({cell:this.b[f.index].apiCell,metadata:this.b[f.index].apiCell.metadata})):f.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(f.index,f.internalMetadata),d.push({cell:this.b[f.index].apiCell,executionSummary:this.b[f.index].apiCell.executionSummary}));const b=new Map;for(let f=0;f<d.length;f++){const w=d[f],h=b.get(w.cell);if(h===void 0){const m=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...w});b.set(w.cell,m-1)}else v.cellChanges[h]={...v.cellChanges[h],...w}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(T){return T=T|0,T<0?0:T>=this.b.length?this.b.length-1:T}o(T){let E=T.start|0,y=T.end|0;return E<0&&(E=0),y>this.b.length&&(y=this.b.length),T.with({start:E,end:y})}p(T){T=this.o(T);const E=[];for(let y=T.start;y<T.end;y++)E.push(this.b[y]);return E}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(T,E,y){if(this.j)return;const v=[],d=[],b=[];if(T.reverse().forEach(f=>{const h=f[2].map(o=>{const i=new S(this,this.l,o);return E||d.push(S.asModelAddData(this.apiNotebook,o)),i}),m=new k(f[0],f[1],[],h),p=this.b.splice(f[0],f[1],...h);for(const o of p)b.push(o.uri),m.deletedItems.push(o.apiCell);v.push(m)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:b}),y)for(const f of v)y.push(f.asApiEvent())}s(T,E,y,v){const d=this.b.splice(T,E);this.b.splice(y,0,...d);const b=[new k(T,E,d.map(f=>f.apiCell),[]),new k(y,0,[],d)];for(const f of b)v.push(f.asApiEvent())}t(T,E){this.b[T].setOutputs(E)}u(T,E,y,v){this.b[T].setOutputItems(E,y,v)}v(T,E){const y=this.b[T];y.apiCell.document.languageId!==E&&this.m.$acceptModelLanguageChanged(y.uri,E)}w(T,E){const y=this.b[T];y.apiCell.mime=E}x(T,E){this.b[T].setMetadata(E)}y(T,E){this.b[T].setInternalMetadata(E)}getCellFromApiCell(T){return this.b.find(E=>E.apiCell===T)}getCellFromIndex(T){return this.b[T]}getCell(T){return this.b.find(E=>E.handle===T)}getCellIndex(T){return this.b.indexOf(T)}}e.ExtHostNotebookDocument=C,C.a=0}),define(Se[136],ye([1,0,10,14,7]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(k,S,C,R,T,E){this.id=k,this.f=S,this.notebookData=C,this.a=[],this.b=[],this.d=!1,this.a=T,this.b=R,this.c=E}get apiEditor(){if(!this.e){const k=this;this.e={get notebook(){return k.notebookData.apiNotebook},get selection(){return k.a[0]},set selection(S){this.selections=[S]},get selections(){return k.a},set selections(S){if(!Array.isArray(S)||!S.every(I.NotebookRange.isNotebookRange))throw(0,a.illegalArgument)("selections");k.a=S,k.g(S)},get visibleRanges(){return k.b},revealRange(S,C){k.f.$tryRevealRange(k.id,t.NotebookRange.from(S),C??I.NotebookEditorRevealType.Default)},get viewColumn(){return k.c}},A.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(k){this.d=k}_acceptVisibleRanges(k){this.b=k}_acceptSelections(k){this.a=k}g(k){this.f.$trySetSelections(this.id,k.map(t.NotebookRange.from))}_acceptViewColumn(k){this.c=k}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(Se[234],ye([1,0,4,13,14]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let A=class{constructor(k,S){this.c=k,this.d=S,this.a=new a.Emitter,this.b=new a.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(k,S){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",k,S);const C=this.d.getEditorById(k);S.visibleRanges&&C._acceptVisibleRanges(S.visibleRanges.ranges.map(I.NotebookRange.to)),S.selections&&C._acceptSelections(S.selections.selections.map(I.NotebookRange.to)),S.visibleRanges&&this.b.fire({notebookEditor:C.apiEditor,visibleRanges:C.apiEditor.visibleRanges}),S.selections&&this.a.fire(Object.freeze({notebookEditor:C.apiEditor,selections:C.apiEditor.selections}))}$acceptEditorViewColumns(k){for(const S in k)this.d.getEditorById(S)._acceptViewColumn(I.ViewColumn.to(k[S]))}};A=qe([We(0,t.ILogService)],A),e.ExtHostNotebookEditors=A}),define(Se[235],ye([1,0,14,124,175,21,60,10]),function(ne,e,a,t,I,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(E){this.b=0,this.c=new Map,this.a=E}async withProgress(E,y,v){const d=this.b++,{title:b,location:f,cancellable:w}=y,h={label:(0,I.localize)(0,null,E.displayName||E.name),id:E.identifier.value};return this.a.$startProgress(d,{location:a.ProgressLocation.from(f),title:b,source:h,cancellable:w},E.isUnderDevelopment?void 0:E.identifier.value).catch(k.onUnexpectedExternalError),this.d(d,v,!!w)}d(E,y,v){let d;v&&(d=new A.CancellationTokenSource,this.c.set(E,d));const b=w=>{this.a.$progressEnd(w),this.c.delete(w),d?.dispose()};let f;try{f=y(new R(this.a,E),v&&d?d.token:A.CancellationToken.None)}catch(w){throw b(E),w}return f.then(w=>b(E),w=>b(E)),f}$acceptProgressCanceled(E){const y=this.c.get(E);y&&(y.cancel(),this.c.delete(E))}}e.ExtHostProgress=S;function C(T,E){return T.message=E.message,typeof E.increment=="number"&&(typeof T.increment=="number"?T.increment+=E.increment:T.increment=E.increment),T}class R extends t.Progress{constructor(E,y){super(v=>this.throttledReport(v)),this.c=E,this.d=y}throttledReport(E){this.c.$progressReport(this.d,E)}}qe([(0,D.throttle)(100,(T,E)=>C(T,E),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Se[137],ye([1,0,35,132,56,91,69,14,2]),function(ne,e,a,t,I,A,D,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const C=(h,m,p,o)=>{let i=m;return{enumerable:!0,configurable:!1,get(){return i},set(l){if(!p(i,l)){const u=i;i=l,h.listener?.(o(l,u))}}}},R=(h,m)=>h===m,T={range:(h,m)=>h===m?!0:!h||!m?!1:h.isEqual(m),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(h,m)=>!(h.length!==m.length||h.some(p=>!m.find(o=>p.id===o.id)))},E=h=>m=>({op:4,update:h(m)}),y=(h,m)=>({range:(()=>{let p;const o=E(i=>({range:a.Range.lift(k.Range.from(i))}));return{enumerable:!0,configurable:!1,get(){return p},set(i){h.listener?.({op:6}),T.range(p,i)||(p=i,h.listener?.(o(i)))}}})(),label:C(h,m,T.label,E(p=>({label:p}))),description:C(h,void 0,T.description,E(p=>({description:p}))),sortText:C(h,void 0,T.sortText,E(p=>({sortText:p}))),canResolveChildren:C(h,!1,T.canResolveChildren,p=>({op:2,state:p})),busy:C(h,!1,T.busy,E(p=>({busy:p}))),error:C(h,void 0,T.error,E(p=>({error:k.MarkdownString.fromStrict(p)||null}))),tags:C(h,[],T.tags,(p,o)=>({op:1,new:p.map(k.TestTag.from),old:o.map(k.TestTag.from)}))}),v=h=>{const m=I.TestId.fromString(h.extId),p=new b(m.controllerId,m.localId,h.label,S.URI.revive(h.uri)||void 0);return p.range=k.Range.to(h.range||void 0),p.description=h.description||void 0,p.sortText=h.sortText||void 0,p.tags=h.tags.map(o=>k.TestTag.to({id:(0,D.denamespaceTestTag)(o).tagId})),p},d=h=>{let m;for(const p of h.tests){const o=v(p.item);(0,t.getPrivateApiFor)(o).parent=m,m=o}return m};e.toItemFromContext=d;class b{constructor(m,p,o,i){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const l=(0,t.createPrivateApiFor)(this,m);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return l.parent instanceof f?void 0:l.parent}},children:{value:(0,A.createTestItemChildren)(l,t.getPrivateApiFor,b),enumerable:!0,writable:!1},...y(l,o)})}}e.TestItemImpl=b;class f extends b{constructor(m,p){super(m,m,p,void 0),this._isRoot=!0}}e.TestItemRootImpl=f;class w extends A.TestItemCollection{constructor(m,p,o){super({controllerId:m,getDocumentVersion:i=>i&&o.getDocument(i)?.version,getApiFor:t.getPrivateApiFor,getChildren:i=>i.children,root:new f(m,p),toITestItem:k.TestItem.from})}}e.ExtHostTestItemCollection=w}),define(Se[138],ye([1,0,49,10,99,14,7]),function(ne,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class k{constructor(E,y,v){const d=k.c.nextId();E.$registerTextEditorDecorationType(y.identifier,d,A.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:d,dispose(){E.$removeTextEditorDecorationType(d)}})}}e.TextEditorDecorationType=k,k.c=new I.IdGenerator("TextEditorDecorationType");class S{constructor(E,y){this.g=[],this.h=void 0,this.j=!1,this.c=E,this.d=E.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(E,y){this.k();let v=null;if(E instanceof D.Position)v=new D.Range(E,E);else if(E instanceof D.Range)v=E;else throw new Error("Unrecognized location");this.l(v,y,!1)}insert(E,y){this.k(),this.l(new D.Range(E,E),y,!0)}delete(E){this.k();let y=null;if(E instanceof D.Range)y=E;else throw new Error("Unrecognized location");this.l(y,null,!0)}l(E,y,v){const d=this.c.validateRange(E);this.g.push({range:d,text:y,forceMoveMarkers:v})}setEndOfLine(E){if(this.k(),E!==D.EndOfLine.LF&&E!==D.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this.h=E}}class C{constructor(E,y,v,d){this.c=E,this.d=y,this._accept(v),this.e=d;const b=this;this.value={get tabSize(){return b.f},set tabSize(f){b.m(f)},get indentSize(){return b.g},set indentSize(f){b.o(f)},get insertSpaces(){return b.h},set insertSpaces(f){b.q(f)},get cursorStyle(){return b.j},set cursorStyle(f){b.s(f)},get lineNumbers(){return b.k},set lineNumbers(f){b.t(f)}}}_accept(E){this.f=E.tabSize,this.g=E.indentSize,this.h=E.insertSpaces,this.j=E.cursorStyle,this.k=A.TextEditorLineNumbersStyle.to(E.lineNumbers)}l(E){if(E==="auto")return"auto";if(typeof E=="number"){const y=Math.floor(E);return y>0?y:null}if(typeof E=="string"){const y=parseInt(E,10);return isNaN(y)?null:y>0?y:null}return null}m(E){const y=this.l(E);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}n(E){if(E==="tabSize")return"tabSize";if(typeof E=="number"){const y=Math.floor(E);return y>0?y:null}if(typeof E=="string"){const y=parseInt(E,10);return isNaN(y)?null:y>0?y:null}return null}o(E){const y=this.n(E);if(y!==null){if(typeof y=="number"){if(this.g===y)return;this.g=y}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}p(E){return E==="auto"?"auto":E==="false"?!1:Boolean(E)}q(E){const y=this.p(E);if(typeof y=="boolean"){if(this.h===y)return;this.h=y}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}s(E){this.j!==E&&(this.j=E,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:E})))}t(E){this.k!==E&&(this.k=E,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:A.TextEditorLineNumbersStyle.from(E)})))}assign(E){const y={};let v=!1;if(typeof E.tabSize<"u"){const d=this.l(E.tabSize);d==="auto"?(v=!0,y.tabSize=d):typeof d=="number"&&this.f!==d&&(this.f=d,v=!0,y.tabSize=d)}if(typeof E.indentSize<"u"){const d=this.n(E.indentSize);d==="tabSize"?(v=!0,y.indentSize=d):typeof d=="number"&&this.g!==d&&(this.g=d,v=!0,y.indentSize=d)}if(typeof E.insertSpaces<"u"){const d=this.p(E.insertSpaces);d==="auto"?(v=!0,y.insertSpaces=d):this.h!==d&&(this.h=d,v=!0,y.insertSpaces=d)}typeof E.cursorStyle<"u"&&this.j!==E.cursorStyle&&(this.j=E.cursorStyle,v=!0,y.cursorStyle=E.cursorStyle),typeof E.lineNumbers<"u"&&this.k!==E.lineNumbers&&(this.k=E.lineNumbers,v=!0,y.lineNumbers=A.TextEditorLineNumbersStyle.from(E.lineNumbers)),v&&this.u("setOptions",this.c.$trySetOptions(this.d,y))}u(E,y){y.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${E}' failed:'`),this.e.warn(v)})}}e.ExtHostTextEditorOptions=C;class R{constructor(E,y,v,d,b,f,w,h){this.id=E,this.j=y,this.k=v,this.g=!1,this.h=new Set,this.c=b,this.d=new C(this.j,this.id,f,v),this.e=w,this.f=h;const m=this;this.value=Object.freeze({get document(){return d.getValue()},set document(p){throw(0,t.readonly)("document")},get selection(){return m.c&&m.c[0]},set selection(p){if(!(p instanceof D.Selection))throw(0,t.illegalArgument)("selection");m.c=[p],m.l()},get selections(){return m.c},set selections(p){if(!Array.isArray(p)||p.some(o=>!(o instanceof D.Selection)))throw(0,t.illegalArgument)("selections");m.c=p,m.l()},get visibleRanges(){return m.e},set visibleRanges(p){throw(0,t.readonly)("visibleRanges")},get options(){return m.d.value},set options(p){m.g||m.d.assign(p)},get viewColumn(){return m.f},set viewColumn(p){throw(0,t.readonly)("viewColumn")},edit(p,o={undoStopBefore:!0,undoStopAfter:!0}){if(m.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new S(d.getValue(),o);return p(i),m.m(i)},insertSnippet(p,o,i={undoStopBefore:!0,undoStopAfter:!0}){if(m.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let l;if(!o||Array.isArray(o)&&o.length===0)l=m.c.map(u=>A.Range.from(u));else if(o instanceof D.Position){const{lineNumber:u,column:s}=A.Position.from(o);l=[{startLineNumber:u,startColumn:s,endLineNumber:u,endColumn:s}]}else if(o instanceof D.Range)l=[A.Range.from(o)];else{l=[];for(const u of o)if(u instanceof D.Range)l.push(A.Range.from(u));else{const{lineNumber:s,column:c}=A.Position.from(u);l.push({startLineNumber:s,startColumn:c,endLineNumber:s,endColumn:c})}}return y.$tryInsertSnippet(E,d.getValue().version,p.value,l,i)},setDecorations(p,o){const i=o.length===0;i&&!m.h.has(p.key)||(i?m.h.delete(p.key):m.h.add(p.key),m.n(()=>{if(A.isDecorationOptionsArr(o))return y.$trySetDecorations(E,p.key,A.fromRangeOrRangeWithMessage(o));{const l=new Array(4*o.length);for(let u=0,s=o.length;u<s;u++){const c=o[u];l[4*u]=c.start.line+1,l[4*u+1]=c.start.character+1,l[4*u+2]=c.end.line+1,l[4*u+3]=c.end.character+1}return y.$trySetDecorationsFast(E,p.key,l)}}))},revealRange(p,o){m.n(()=>y.$tryRevealRange(E,A.Range.from(p),o||D.TextEditorRevealType.Default))},show(p){y.$tryShowEditor(E,A.ViewColumn.from(p))},hide(){y.$tryHideEditor(E)}})}dispose(){(0,a.ok)(!this.g),this.g=!0}_acceptOptions(E){(0,a.ok)(!this.g),this.d._accept(E)}_acceptVisibleRanges(E){(0,a.ok)(!this.g),this.e=E}_acceptViewColumn(E){(0,a.ok)(!this.g),this.f=E}_acceptSelections(E){(0,a.ok)(!this.g),this.c=E}async l(){const E=this.c.map(A.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,E)),this.value}m(E){const y=E.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const v=y.edits.map(b=>b.range);v.sort((b,f)=>b.end.line===f.end.line?b.end.character===f.end.character?b.start.line===f.start.line?b.start.character-f.start.character:b.start.line-f.start.line:b.end.character-f.end.character:b.end.line-f.end.line);for(let b=0,f=v.length-1;b<f;b++){const w=v[b].end;if(v[b+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=y.edits.map(b=>({range:A.Range.from(b.range),text:b.text,forceMoveMarkers:b.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,d,{setEndOfLine:typeof y.setEndOfLine=="number"?A.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n(E){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):E().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.ExtHostTextEditor=R}),define(Se[236],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[237],ye([1,0,189,10,42,121,125,43,27,236,201,191]),function(ne,e,a,t,I,A,D,k,S,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const E=k.Registry.as(D.Extensions.JSONContribution);class y{constructor(p,o,i){this.a=p,this.b=o,this.c=i}d(p,o){this.a({type:p,message:o,extensionId:this.b.identifier,extensionPointId:this.c})}error(p){this.d(I.default.Error,p)}warn(p){this.d(I.default.Warning,p)}info(p){this.d(I.default.Info,p)}}e.ExtensionMessageCollector=y;class v{static a(p){const o=new Set;for(let i=0,l=p.length;i<l;i++)o.add(S.ExtensionIdentifier.toKey(p[i].description.identifier));return o}static compute(p,o){if(!p||!p.length)return new v(o,[]);if(!o||!o.length)return new v([],p);const i=this.a(p),l=this.a(o),u=o.filter(c=>!i.has(S.ExtensionIdentifier.toKey(c.description.identifier))),s=p.filter(c=>!l.has(S.ExtensionIdentifier.toKey(c.description.identifier)));return new v(u,s)}constructor(p,o){this.added=p,this.removed=o}}e.ExtensionPointUserDelta=v;class d{constructor(p,o){this.name=p,this.defaultExtensionKind=o,this.a=null,this.b=null,this.c=null}setHandler(p){if(this.a!==null)throw new Error("Handler already set!");this.a=p,this.d()}acceptUsers(p){this.c=v.compute(this.b,p),this.b=p,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(p){(0,t.onUnexpectedError)(p)}}}e.ExtensionPoint=d;const b={type:"string",enum:["ui","workspace"],enumDescriptions:[a.localize(0,null),a.localize(1,null)]},f="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:a.localize(2,null),properties:{vscode:{type:"string",description:a.localize(3,null),default:"^1.22.0"}}},publisher:{description:a.localize(4,null),type:"string"},displayName:{description:a.localize(5,null),type:"string"},categories:{description:a.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:a.localize(7,null)}]}},galleryBanner:{type:"object",description:a.localize(8,null),properties:{color:{description:a.localize(9,null),type:"string"},theme:{description:a.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:a.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:a.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:a.localize(13,null)},enabledApiProposals:{markdownDescription:a.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(C.allApiProposals),markdownEnumDescriptions:Object.values(C.allApiProposals)}},api:{markdownDescription:a.localize(15,null),type:"string",enum:["none"],enumDescriptions:[a.localize(16,null)]},activationEvents:{description:a.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:a.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:a.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:a.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:a.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:a.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:a.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:a.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:a.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:a.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:a.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:a.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:a.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:a.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:a.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:a.localize(32,null)},{label:"onUri",body:"onUri",description:a.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:a.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:a.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:a.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:a.localize(37,null)},{label:"onRenderer",description:a.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:a.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:a.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:a.localize(41,null)},{label:"*",description:a.localize(42,null),body:"*"}]}},badges:{type:"array",description:a.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:a.localize(44,null)},href:{type:"string",description:a.localize(45,null)},description:{type:"string",description:a.localize(46,null)}}}},markdown:{type:"string",description:a.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:a.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:a.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:a.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:a.localize(51,null),type:"array",items:b,default:["workspace"],defaultSnippets:[{body:["ui"],description:a.localize(52,null)},{body:["workspace"],description:a.localize(53,null)},{body:["ui","workspace"],description:a.localize(54,null)},{body:["workspace","ui"],description:a.localize(55,null)},{body:[],description:a.localize(56,null)}]},capabilities:{description:a.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:a.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:a.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(60,null),a.localize(61,null),a.localize(62,null)]},description:{type:"string",markdownDescription:a.localize(63,null)}}},untrustedWorkspaces:{description:a.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:a.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(66,null),a.localize(67,null),a.localize(68,null)]},restrictedConfigurations:{description:a.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:a.localize(70,null)}}}}},sponsor:{description:a.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:a.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:a.localize(73,null),type:"string"},"vscode:uninstall":{description:a.localize(74,null),type:"string"}}},icon:{type:"string",description:a.localize(75,null)},l10n:{type:"string",description:a.localize(76,null)}}};class w{constructor(){this.a=new Map}registerExtensionPoint(p){if(this.a.has(p.extensionPoint))throw new Error("Duplicate extension point: "+p.extensionPoint);const o=new d(p.extensionPoint,p.defaultExtensionKind);return this.a.set(p.extensionPoint,o),p.activationEventsGenerator&&T.ImplicitActivationEvents.register(p.extensionPoint,p.activationEventsGenerator),e.schema.properties.contributes.properties[p.extensionPoint]=p.jsonSchema,E.registerSchema(f,e.schema),o}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=w;const h={ExtensionsRegistry:"ExtensionsRegistry"};k.Registry.add(h.ExtensionsRegistry,new w),e.ExtensionsRegistry=k.Registry.as(h.ExtensionsRegistry),E.registerSchema(f,e.schema),E.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:a.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(C.allApiProposals),markdownEnumDescriptions:Object.values(C.allApiProposals)}}]}}}})}),define(Se[238],ye([1,0,186,11,23,237,53,4]),function(ne,e,a,t,I,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:a.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:a.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:a.localize(2,null),default:""}}};var C;(function(E){function y(v,d,b){if(!v)return;const f=t.isString(v.type)?v.type:void 0;if(!f||f.length===0){b.error(a.localize(3,null));return}const w=[];if(Array.isArray(v.required))for(const h of v.required)t.isString(h)&&w.push(h);return{extensionId:d.value,taskType:f,required:w,properties:v.properties?I.deepClone(v.properties):{},when:v.when?D.ContextKeyExpr.deserialize(v.when):void 0}}E.from=y})(C||(C={}));const R=A.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:a.localize(4,null),type:"array",items:S}});class T{constructor(){this.d=new k.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,v)=>{R.setHandler((d,b)=>{this.c=void 0;try{for(const f of b.removed){const w=f.value;for(const h of w)this.a&&h.type&&this.a[h.type]&&delete this.a[h.type]}for(const f of b.added){const w=f.value;for(const h of w){const m=C.from(h,f.description.identifier,f.collector);m&&(this.a[m.taskType]=m)}}(b.removed.length>0||b.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const v of this.all()){const d={type:"object",additionalProperties:!1};v.required.length>0&&(d.required=v.required.slice(0)),v.properties!==void 0?d.properties=I.deepClone(v.properties):d.properties=Object.create(null),d.properties.type={type:"string",enum:[v.taskType]},y.push(d)}this.c={oneOf:y}}return this.c}}e.TaskDefinitionRegistry=new T}),define(Se[239],ye([1,0,187,11,24,23,53,238]),function(ne,e,a,t,I,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new D.RawContextKey("taskRunning",!1,a.localize(0,null)),e.TASKS_CATEGORY={value:a.localize(1,null),original:"Tasks"};var S;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(N){function B(U){if(!U)return N.Strong;switch(U.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=B}(S=e.ShellQuoting||(e.ShellQuoting={}));var C;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(C=e.CommandOptions||(e.CommandOptions={}));var R;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(R=e.RevealKind||(e.RevealKind={})),function(N){function B(U){switch(U.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=B}(R=e.RevealKind||(e.RevealKind={}));var T;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(T=e.RevealProblemKind||(e.RevealProblemKind={})),function(N){function B(U){switch(U.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=B}(T=e.RevealProblemKind||(e.RevealProblemKind={}));var E;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(E=e.PanelKind||(e.PanelKind={})),function(N){function B(U){switch(U.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=B}(E=e.PanelKind||(e.PanelKind={}));var y;(function(N){N.defaults={echo:!0,reveal:R.Always,revealProblems:T.Never,focus:!1,panel:E.Shared,showReuseMessage:!0,clear:!1}})(y=e.PresentationOptions||(e.PresentationOptions={}));var v;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(v=e.RuntimeType||(e.RuntimeType={})),function(N){function B(W){switch(W.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=B;function U(W){switch(W){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=U}(v=e.RuntimeType||(e.RuntimeType={}));var d;(function(N){function B(U){return t.isString(U)?U:U.value}N.value=B})(d=e.CommandString||(e.CommandString={}));var b;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function B(W){return W===N.Clean._id||W===N.Build._id||W===N.Rebuild._id||W===N.Test._id}N.is=B;function U(W){if(W!==void 0)return t.isString(W)?B(W)?{_id:W,isDefault:!1}:void 0:W}N.from=U})(b=e.TaskGroup||(e.TaskGroup={}));var f;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(f=e.TaskScope||(e.TaskScope={}));var w;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function B(U){switch(U){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=B})(w=e.TaskSourceKind||(e.TaskSourceKind={}));var h;(function(N){N.parallel="parallel",N.sequence="sequence"})(h=e.DependsOrder||(e.DependsOrder={}));var m;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(m=e.RunOnOptions||(e.RunOnOptions={}));var p;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:m.default,instanceLimit:1}})(p=e.RunOptions||(e.RunOptions={}));class o{constructor(B,U,W,x,V,X){this._label="",this._id=B,U&&(this._label=U),W&&(this.type=W),this.runOptions=x,this.configurationProperties=V,this._source=X}getDefinition(B){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const B={folder:this.d(),id:this._id};return JSON.stringify(B)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(B,U=!1){if(B===void 0)return!1;if(t.isString(B))return B===this._label||B===this.configurationProperties.identifier||U&&B===this._id;const W=this.getDefinition(!0);return W!==void 0&&W._key===B._key}getQualifiedLabel(){const B=this.getWorkspaceFolder();return B?`${this._label} (${B.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(B){this.c===void 0&&(this.c=[]),B&&(this.c=this.c.concat(B))}get taskLoadMessages(){return this.c}}e.CommonTask=o;class i extends o{constructor(B,U,W,x,V,X,Q,J){super(B,W,void 0,Q,J,U),this.command={},this._source=U,this.hasDefinedMatchers=X,V&&(this.command=V)}clone(){return new i(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(B=!1){if(B&&this._source.customizes!==void 0)return this._source.customizes;{let U;switch(this.command?this.command.runtime:void 0){case v.Shell:U="shell";break;case v.Process:U="process";break;case v.CustomExecution:U="customExecution";break;case void 0:U="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:U,_key:this._id,id:this._id}}}static is(B){return B instanceof i}getMapKey(){const B=this._source.config.workspaceFolder;return B?`${B.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===w.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const B=this.d();if(!B)return;let U=this.configurationProperties.identifier;this._source.kind!==w.Workspace&&(U+=this._source.kind);const W={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:U};return JSON.stringify(W)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(B){return new i(B._id,B._source,B._label,B.type,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.CustomTask=i;class l extends o{constructor(B,U,W,x,V,X,Q){super(B,W,x,X,Q,U),this._source=U,this.configures=V}static is(B){return B instanceof l}f(B){return B}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===w.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const B=this.d();if(!B)return;let U=this.configurationProperties.identifier;this._source.kind!==w.Workspace&&(U+=this._source.kind);const W={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:U};return JSON.stringify(W)}}e.ConfiguringTask=l;class u extends o{constructor(B,U,W,x,V,X,Q,J,te){super(B,W,x,J,te,U),this.defines=V,this.hasDefinedMatchers=Q,this.command=X,this.icon=te.icon,this.hide=te.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(B){return B instanceof u}getMapKey(){const B=this._source.workspaceFolder;return B?`${this._source.scope.toString()}|${B.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const B={type:"contributed",scope:this._source.scope,id:this._id};return B.folder=this.d(),JSON.stringify(B)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(B){return new u(B._id,B._source,B._label,B.type,B.defines,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.ContributedTask=u;class s extends o{constructor(B,U,W,x,V,X){super(B,W,x,V,X,U),this._source=U}clone(){return new s(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(B){return B instanceof s}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(B){return new s(B._id,B._source,B._label,B.type,B.runOptions,B.configurationProperties)}}e.InMemoryTask=s;var c;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(c=e.ExecutionEngine||(e.ExecutionEngine={})),function(N){N._default=N.Terminal}(c=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class r{constructor(B){this.c=new Map;for(let U=0;U<B.length;U++)this.c.set(B[U].uri.toString(),U)}compare(B,U){const W=B.getWorkspaceFolder(),x=U.getWorkspaceFolder();if(W&&x){let V=this.c.get(W.uri.toString());V=V===void 0?0:V+1;let X=this.c.get(x.uri.toString());return X=X===void 0?0:X+1,V===X?B._label.localeCompare(U._label):V-X}else return!W&&x?-1:W&&!x?1:0}}e.TaskSorter=r;var g;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(g=e.TaskEventKind||(e.TaskEventKind={}));var P;(function(N){N.SingleRun="singleRun",N.Background="background"})(P=e.TaskRunType||(e.TaskRunType={}));var L;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(L=e.TaskRunSource||(e.TaskRunSource={}));var z;(function(N){function B(U,W,x,V){if(W){const X={kind:U,taskId:W._id,taskName:W.configurationProperties.name,runType:W.configurationProperties.isBackground?"background":"singleRun",group:W.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:x,__task:W};return U==="start"?X.resolvedVariables=V:U==="processStarted"?X.processId=V:U==="processEnded"&&(X.exitCode=V),Object.freeze(X)}else return Object.freeze({kind:"changed"})}N.create=B})(z=e.TaskEvent||(e.TaskEvent={}));var _;(function(N){function B(W){const x=Object.keys(W).sort();let V="";for(const X of x){let Q=W[X];Q instanceof Object?Q=B(Q):typeof Q=="string"&&(Q=Q.replace(/,/g,",,")),V+=X+","+Q+","}return V}function U(W){const V={_key:B(W),type:W.taskType};return Object.assign(V,W),V}N.create=U})(_=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var K;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection"})(K=e.TaskSettingId||(e.TaskSettingId={}));var F;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(F=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var M;(function(N){function B(U,W){const x=k.TaskDefinitionRegistry.get(U.type);if(x===void 0){const J=A.deepClone(U);return delete J._key,_.create(J)}const V=Object.create(null);V.type=x.taskType;const X=new Set;x.required.forEach(J=>X.add(J));const Q=x.properties;for(const J of Object.keys(Q)){const te=U[J];if(te!=null)V[J]=te;else if(X.has(J)){const le=Q[J];if(le.default!==void 0)V[J]=A.deepClone(le.default);else switch(le.type){case"boolean":V[J]=!1;break;case"number":case"integer":V[J]=0;break;case"string":V[J]="";break;default:W.error(a.localize(2,null,JSON.stringify(U,void 0,0),J));return}}}return _.create(V)}N.createTaskIdentifier=B})(M=e.TaskDefinition||(e.TaskDefinition={}))}),define(Se[240],ye([1,0,10]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((D,k)=>{this.b=D,this.d=k,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(D){this.f||this.h||(this.f=!0,this.g=D,this.a&&this.b(D))}resolveErr(D){this.f||this.h||(this.h=!0,this.i=D,this.a?this.d(D):(0,a.onUnexpectedError)(D))}then(D,k){return this.j().then(D,k)}catch(D){return this.j().then(void 0,D)}finally(D){return this.j().finally(D)}}e.LazyPromise=t;class I extends t{constructor(){super(),this.h=!0,this.i=new a.CancellationError}}e.CanceledLazyPromise=I}),define(Se[57],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class a{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++a.count}}e.ProxyIdentifier=a,a.count=0;const t=[];function I(k){const S=new a(k);return t[S.nid]=S,S}e.createProxyIdentifier=I;function A(k){return t[k].sid}e.getStringIdentifierForProxy=A;class D{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=D}),define(Se[5],ye([1,0,57]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(d){d[d.UnknownInput=0]="UnknownInput",d[d.TextInput=1]="TextInput",d[d.TextDiffInput=2]="TextDiffInput",d[d.TextMergeInput=3]="TextMergeInput",d[d.NotebookInput=4]="NotebookInput",d[d.NotebookDiffInput=5]="NotebookDiffInput",d[d.CustomEditorInput=6]="CustomEditorInput",d[d.WebviewEditorInput=7]="WebviewEditorInput",d[d.TerminalEditorInput=8]="TerminalEditorInput",d[d.InteractiveEditorInput=9]="InteractiveEditorInput"})(I=e.TabInputKind||(e.TabInputKind={}));var A;(function(d){d[d.TAB_OPEN=0]="TAB_OPEN",d[d.TAB_CLOSE=1]="TAB_CLOSE",d[d.TAB_UPDATE=2]="TAB_UPDATE",d[d.TAB_MOVE=3]="TAB_MOVE"})(A=e.TabModelOperationKind||(e.TabModelOperationKind={}));var D;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var k;(function(d){d[d.Int8Array=1]="Int8Array",d[d.Uint8Array=2]="Uint8Array",d[d.Uint8ClampedArray=3]="Uint8ClampedArray",d[d.Int16Array=4]="Int16Array",d[d.Uint16Array=5]="Uint16Array",d[d.Int32Array=6]="Int32Array",d[d.Uint32Array=7]="Uint32Array",d[d.Float32Array=8]="Float32Array",d[d.Float64Array=9]="Float64Array",d[d.BigInt64Array=10]="BigInt64Array",d[d.BigUint64Array=11]="BigUint64Array"})(k=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var R;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(R=e.CandidatePortSource||(e.CandidatePortSource={}));class T{static mixin(b){return b._id=T.a++,b}}e.IdObject=T,T.a=0;var E;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.kindModifier="m",d.commandIdent="n",d.commandId="o",d.commandArguments="p"})(E=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var y;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(y=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,a.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,a.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,a.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,a.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,a.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,a.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,a.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,a.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,a.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,a.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,a.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,a.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,a.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,a.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,a.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,a.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,a.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,a.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,a.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,a.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,a.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,a.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,a.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,a.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,a.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,a.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,a.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,a.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,a.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,a.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,a.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,a.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,a.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,a.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,a.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,a.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,a.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,a.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,a.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,a.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,a.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,a.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,a.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,a.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,a.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,a.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,a.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,a.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,a.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,a.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,a.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,a.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,a.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,a.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,a.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,a.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,a.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,a.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,a.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,a.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,a.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,a.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,a.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,a.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,a.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,a.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,a.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,a.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,a.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,a.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,a.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,a.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,a.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,a.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,a.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,a.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,a.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,a.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,a.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,a.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,a.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,a.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,a.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,a.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,a.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,a.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,a.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,a.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,a.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,a.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,a.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,a.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,a.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,a.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,a.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,a.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,a.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,a.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,a.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,a.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,a.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,a.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,a.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,a.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,a.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,a.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,a.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,a.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,a.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,a.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,a.createProxyIdentifier)("ExtHostLocalization")}}),define(Se[70],ye([1,0,3,13,5,16]),function(ne,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,a.createDecorator)("IExtHostApiDeprecationService");let D=class{constructor(S,C){this.c=C,this.a=new Set,this.b=S.getProxy(I.MainContext.MainThreadTelemetry)}report(S,C,R){const T=this.d(S,C);this.a.has(T)||(this.a.add(T),C.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:S}))}d(S,C){return`${S}-${C.identifier.value}`}};D=qe([We(0,A.IExtHostRpcService),We(1,t.ILogService)],D),e.ExtHostApiDeprecationService=D,e.NullApiDeprecationService=Object.freeze(new class{report(k,S,C){}})}),define(Se[241],ye([1,0,4,5,7,27]),function(ne,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class D{constructor(S){this.b=new Map,this.c=[],this.d=new a.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=S.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(S){return this.c=S,Promise.resolve()}async getSession(S,C,R,T={}){const E=A.ExtensionIdentifier.toKey(S.identifier),y=this.f.get(E)||[],v=[...R].sort().join(" ");let d=y.find(b=>b.providerId===C&&b.scopes===v);if(d)return d.result;{const b=this.g(S,E,C,R,T);d={providerId:C,scopes:v,result:b},y.push(d),this.f.set(E,y);try{await b}finally{const f=y.findIndex(w=>w.providerId===C&&w.scopes===v);f>-1&&(y.splice(f),this.f.set(E,y))}return b}}async g(S,C,R,T,E={}){await this.a.$ensureProvider(R);const y=S.displayName||S.name;return this.a.$getSession(R,T,C,y,E)}async removeSession(S,C){const R=this.b.get(S);return R?R.provider.removeSession(C):this.a.$removeSession(S,C)}registerAuthenticationProvider(S,C,R,T){if(this.b.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this.b.set(S,{label:C,provider:R,options:T??{supportsMultipleAccounts:!1}}),this.c.find(y=>y.id===S)||this.c.push({id:S,label:C});const E=R.onDidChangeSessions(y=>{this.a.$sendDidChangeSessions(S,{added:y.added??[],changed:y.changed??[],removed:y.removed??[]})});return this.a.$registerAuthenticationProvider(S,C,T?.supportsMultipleAccounts??!1),new I.Disposable(()=>{E.dispose(),this.b.delete(S);const y=this.c.findIndex(v=>v.id===S);y>-1&&this.c.splice(y),this.a.$unregisterAuthenticationProvider(S)})}$createSession(S,C){const R=this.b.get(S);if(R)return Promise.resolve(R.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,C){const R=this.b.get(S);if(R)return Promise.resolve(R.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,C){const R=this.b.get(S);if(R)return Promise.resolve(R.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,C){return this.d.fire({provider:{id:S,label:C}}),Promise.resolve()}}e.ExtHostAuthentication=D}),define(Se[242],ye([1,0,5,16,14]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(k,S){this.a=k.getProxy(a.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:C=>S.getDocument(C)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(k,S,C){const R=I.WorkspaceEdit.from(k,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,C?.isRefactoring??!1)}};A=qe([We(0,t.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(Se[243],ye([1,0,5]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(A){const D=A.getProxy(a.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return D.$readText()},writeText(k){return D.$writeText(k)}})}}e.ExtHostClipboard=t});var Je=this&&this.__classPrivateFieldSet||function(ne,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ne,a):I?I.value=a:e.set(ne,a),a},Me=this&&this.__classPrivateFieldGet||function(ne,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[39],ye([1,0,11,7,14,23,5,17,13,85,35,50,2,6,3,16,137,22,57,51,44]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v,d,b,f,w,h,m){"use strict";var p,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let i=class{constructor(r,g){p.set(this,void 0),this.b=new Map,this.c=new Map,o.set(this,void 0),Je(this,p,r.getProxy(D.MainContext.MainThreadCommands),"f"),this.d=g,Je(this,o,r.getProxy(D.MainContext.MainThreadTelemetry),"f"),this.converter=new l(this,P=>{const L=this.c.get(P);return L?.result===s.Void?L:void 0},g),this.f=[{processArgument(P){return(0,C.revive)(P)}},{processArgument(P){return(0,A.cloneAndChange)(P,function(L){if(R.Range.isIRange(L))return I.Range.to(L);if(T.Position.isIPosition(L))return I.Position.to(L);if(R.Range.isIRange(L.range)&&E.URI.isUri(L.uri))return I.location.to(L);if(L instanceof f.VSBuffer)return L.buffer.buffer;if(!Array.isArray(L))return L})}}]}registerArgumentProcessor(r){this.f.push(r)}registerApiCommand(r){const g=this.registerCommand(!1,r.id,async(...P)=>{const L=r.args.map((_,K)=>{if(!_.validate(P[K]))throw new Error(`Invalid argument '${_.name}' when running '${r.id}', received: ${P[K]}`);return _.convert(P[K])}),z=await this.executeCommand(r.internalId,...L);return r.result.convert(z,P,this.converter)},void 0,{description:r.description,args:r.args,returns:r.result.description});return this.c.set(r.id,r),new t.Disposable(()=>{g.dispose(),this.c.delete(r.id)})}registerCommand(r,g,P,L,z,_){if(this.d.trace("ExtHostCommands#registerCommand",g),!g.trim().length)throw new Error("invalid id");if(this.b.has(g))throw new Error(`command '${g}' already exists`);return this.b.set(g,{callback:P,thisArg:L,description:z,extension:_}),r&&Me(this,p,"f").$registerCommand(g),new t.Disposable(()=>{this.b.delete(g)&&r&&Me(this,p,"f").$unregisterCommand(g)})}executeCommand(r,...g){return this.d.trace("ExtHostCommands#executeCommand",r),this.g(r,g,!0)}async g(r,g,P){if(this.b.has(r))return Me(this,p,"f").$fireCommandActivationEvent(r),this.h(r,g,!1);{let L=!1;const z=(0,A.cloneAndChange)(g,function(_){if(_ instanceof t.Position)return I.Position.from(_);if(_ instanceof t.Range)return I.Range.from(_);if(_ instanceof t.Location)return I.location.from(_);if(t.NotebookRange.isNotebookRange(_))return I.NotebookRange.from(_);if(_ instanceof ArrayBuffer)return L=!0,f.VSBuffer.wrap(new Uint8Array(_));if(_ instanceof Uint8Array)return L=!0,f.VSBuffer.wrap(_);if(_ instanceof f.VSBuffer)return L=!0,_;if(!Array.isArray(_))return _});try{const _=await Me(this,p,"f").$executeCommand(r,L?new w.SerializableObjectWithBuffers(z):z,P);return(0,C.revive)(_)}catch(_){if(_ instanceof Error&&_.message==="$executeCommand:retry")return this.g(r,g,!1);throw _}}}async h(r,g,P){const L=this.b.get(r);if(!L)throw new Error("Unknown command");const{callback:z,thisArg:_,description:K}=L;if(K)for(let M=0;M<K.args.length;M++)try{(0,a.validateConstraint)(g[M],K.args[M].constraint)}catch{throw new Error(`Running the contributed command: '${r}' failed. Illegal argument '${K.args[M].name}' - ${K.args[M].description}`)}const F=m.StopWatch.create();try{return await z.apply(_,g)}catch(M){if(r===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...g);N&&(r=N.command)}throw this.d.error(M,r,L.extension?.identifier),P?new class extends Error{constructor(){super((0,h.toErrorMessage)(M)),this.id=r,this.source=L.extension?.displayName??L.extension?.name}}:M}finally{this.j(L,r,F.elapsed())}}j(r,g,P){!r.extension||r.extension.isBuiltin||Me(this,o,"f").$publicLog2("Extension:ActionExecuted",{extensionId:r.extension.identifier.value,id:g,duration:P})}$executeContributedCommand(r,...g){return this.d.trace("ExtHostCommands#$executeContributedCommand",r),this.b.has(r)?(g=g.map(P=>this.f.reduce((L,z)=>z.processArgument(L),P)),this.h(r,g,!0)):Promise.reject(new Error(`Contributed command '${r}' does not exist.`))}getCommands(r=!1){return this.d.trace("ExtHostCommands#getCommands",r),Me(this,p,"f").$getCommands().then(g=>(r&&(g=g.filter(P=>P[0]!=="_")),g))}$getContributedCommandHandlerDescriptions(){const r=Object.create(null);for(const[g,P]of this.b){const{description:L}=P;L&&(r[g]=L)}return Promise.resolve(r)}};p=new WeakMap,o=new WeakMap,i=qe([We(0,d.IExtHostRpcService),We(1,S.ILogService)],i),e.ExtHostCommands=i,e.IExtHostCommands=(0,v.createDecorator)("IExtHostCommands");class l{constructor(r,g,P){this.d=r,this.f=g,this.g=P,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(r,g){if(!r)return;const P={$ident:void 0,id:r.command,title:r.title,tooltip:r.tooltip};if(!r.command)return P;const L=this.f(r.command);if(L)P.id=L.internalId,P.arguments=L.args.map((z,_)=>z.convert(r.arguments&&r.arguments[_]));else if((0,k.isNonEmptyArray)(r.arguments)){const z=`${r.command}/${++this.c}`;this.b.set(z,r),g.add((0,y.toDisposable)(()=>{this.b.delete(z),this.g.trace("CommandsConverter#DISPOSE",z)})),P.$ident=z,P.id=this.delegatingCommandId,P.arguments=[z],this.g.trace("CommandsConverter#CREATE",r.command,z)}return P}fromInternal(r){return typeof r.$ident=="string"?this.b.get(r.$ident):{command:r.id,title:r.title,arguments:r.arguments}}getActualCommand(...r){return this.b.get(r[0])}h(...r){const g=this.getActualCommand(...r);return this.g.trace("CommandsConverter#EXECUTE",r[0],g?g.command:"MISSING"),g?this.d.executeCommand(g.command,...g.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${r[0]}`)}}e.CommandsConverter=l;class u{constructor(r,g,P,L){this.name=r,this.description=g,this.validate=P,this.convert=L}optional(){return new u(this.name,`(optional) ${this.description}`,r=>r==null||this.validate(r),r=>r===void 0?void 0:r===null?null:this.convert(r))}with(r,g){return new u(r??this.name,g??this.description,this.validate,this.convert)}}e.ApiCommandArgument=u,u.Uri=new u("uri","Uri of a text document",n=>E.URI.isUri(n),n=>n),u.Position=new u("position","A position in a text document",n=>t.Position.isPosition(n),I.Position.from),u.Range=new u("range","A range in a text document",n=>t.Range.isRange(n),I.Range.from),u.Selection=new u("selection","A selection in a text document",n=>t.Selection.isSelection(n),I.Selection.from),u.Number=new u("number","",n=>typeof n=="number",n=>n),u.String=new u("string","",n=>typeof n=="string",n=>n),u.CallHierarchyItem=new u("item","A call hierarchy item",n=>n instanceof t.CallHierarchyItem,I.CallHierarchyItem.from),u.TypeHierarchyItem=new u("item","A type hierarchy item",n=>n instanceof t.TypeHierarchyItem,I.TypeHierarchyItem.from),u.TestItem=new u("testItem","A VS Code TestItem",n=>n instanceof b.TestItemImpl,I.TestItem.from);class s{constructor(r,g){this.description=r,this.convert=g}}e.ApiCommandResult=s,s.Void=new s("no result",n=>n);class c{constructor(r,g,P,L,z){this.id=r,this.internalId=g,this.description=P,this.args=L,this.result=z}}e.ApiCommand=c}),define(Se[244],ye([1,0,2,14,7,66,39,17,118,123,15]),function(ne,e,a,t,I,A,D,k,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const T=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",y(t.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(d,b)=>{if((0,k.isFalsyOrEmpty)(d))return;class f extends I.SymbolInformation{static to(h){const m=new f(h.name,t.SymbolKind.to(h.kind),h.containerName||"",new I.Location(b[0],t.Range.to(h.range)));return m.detail=h.detail,m.range=m.location.range,m.selectionRange=t.Range.to(h.selectionRange),m.children=h.children?h.children.map(f.to):[],m}}return d.map(f.to)})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",y(t.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",y(t.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",d=>typeof d=="string",d=>d),new D.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",y(t.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",y(t.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",y(t.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",d=>Array.isArray(d)&&d.every(b=>I.Position.isPosition(b)),d=>d.map(t.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",d=>d.map(b=>{let f;for(const w of b.reverse())f=new I.SelectionRange(t.Range.to(w),f);return f}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",d=>d.map(t.WorkspaceSymbol.to))),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",d=>d.map(t.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",d=>d.map(t.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",d=>d.map(t.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to a range and placeholder text.",d=>{if(!!d)return{range:t.Range.to(d.range),placeholder:d.text}})),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",d=>{if(!!d){if(d.rejectReason)throw new Error(d.rejectReason);return t.WorkspaceEdit.to(d)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",d=>d.map(t.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new I.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const b=(0,S.decodeSemanticTokensDto)(d);if(b.type==="full")return new I.SemanticTokens(b.data,void 0)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range.optional()],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new I.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const b=(0,S.decodeSemanticTokensDto)(d);if(b.type==="full")return new I.SemanticTokens(b.data,void 0)})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(d,b,f)=>{if(!d)return new I.CompletionList([]);const w=d.suggestions.map(h=>t.CompletionItem.to(h,f));return new I.CompletionList(w,d.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",d=>{if(d)return t.SignatureHelp.to(d)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(d,b,f)=>y(w=>new I.CodeLens(t.Range.to(w.range),w.command&&f.fromInternal(w.command)))(d))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",d=>I.Range.isRange(d),d=>I.Selection.isSelection(d)?t.Selection.from(d):t.Range.from(d)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(d,b,f)=>y(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(w.command)}else{const h=new I.CodeAction(w.title,w.kind?new I.CodeActionKind(w.kind):void 0);return w.edit&&(h.edit=t.WorkspaceEdit.to(w.edit)),w.command&&(h.command=f.fromInternal(w.command)),h.isPreferred=w.isPreferred,h}})(d))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",d=>d?d.map(b=>new I.ColorInformation(t.Range.to(b.range),t.Color.to(b.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",d=>d instanceof I.Color,t.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",d=>!0,d=>({uri:d.uri,range:t.Range.from(d.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",d=>d?d.map(t.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of Inlay objects",(d,b,f)=>d.map(t.InlayHint.to.bind(void 0,f)))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",y(d=>({viewType:d.viewType,displayName:d.displayName,options:{transientOutputs:d.options.transientOutputs,transientCellMetadata:d.options.transientCellMetadata,transientDocumentMetadata:d.options.transientDocumentMetadata},filenamePattern:d.filenamePattern.map(b=>t.NotebookExclusiveDocumentPattern.to(b))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",d=>d.map(t.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new D.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",d=>a.URI.isUri(d)||typeof d=="string"&&(0,C.matchesSomeScheme)(d,R.Schemas.http,R.Schemas.https),d=>d),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[t.ViewColumn.from(d),void 0]:[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[t.ViewColumn.from(d),void 0]:[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="object",d=>d&&[t.ViewColumn.from(d.viewColumn),t.TextEditorOpenOptions.from(d)]).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(t.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(t.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",d=>d.map(t.TypeHierarchyItem.to))),new D.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[D.ApiCommandArgument.TestItem],D.ApiCommandResult.Void),new D.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[D.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],D.ApiCommandResult.Void),new D.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[D.ApiCommandArgument.String.with("name","The context key name"),new D.ApiCommandArgument("value","The context key value",()=>!0,d=>d)],D.ApiCommandResult.Void)];class E{static register(b){T.forEach(b.registerApiCommand,b)}}e.ExtHostApiCommands=E;function y(d){return b=>{if(Array.isArray(b))return b.map(d)}}function v(d){if(!Array.isArray(d))return;const b=[];for(const f of d)A.isLocationLink(f)?b.push(t.DefinitionLink.to(f)):b.push(t.location.to(f));return b}}),define(Se[245],ye([1,0,18,60,4,6,2,66,27,14,7,26,5]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function y(v,d,b){const f=v.getProxy(E.MainContext.MainThreadComments);class w{constructor(){this.b=new Map,this.c=new Map,d.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===6){const n=this.b.get(c.handle);return n?n.value:c}else if(c&&c.$mid===7){const n=this.b.get(c.commentControlHandle);if(!n)return c;const r=n.getCommentThread(c.commentThreadHandle);return r?r.value:c}else if(c&&(c.$mid===9||c.$mid===8)){const n=this.b.get(c.thread.commentControlHandle);if(!n)return c;const r=n.getCommentThread(c.thread.commentThreadHandle);return r?c.$mid===8?r.value:{thread:r.value,text:c.text}:c}else if(c&&c.$mid===10){const n=this.b.get(c.thread.commentControlHandle);if(!n)return c;const r=n.getCommentThread(c.thread.commentThreadHandle);if(!r)return c;const g=c.commentUniqueId,P=r.getCommentByUniqueId(g);return P||c}else if(c&&c.$mid===11){const n=this.b.get(c.thread.commentControlHandle);if(!n)return c;const r=n.getCommentThread(c.thread.commentThreadHandle);if(!r)return c;const g=c.text,P=c.commentUniqueId,L=r.getCommentByUniqueId(P);return L?(typeof L.body=="string"?L.body=g:L.body=new R.MarkdownString(g),L):c}return c}})}createCommentController(c,n,r){const g=w.a++,P=new m(c,g,n,r);this.b.set(P.handle,P);const L=this.c.get(S.ExtensionIdentifier.toKey(c.identifier))||[];return L.push(P),this.c.set(S.ExtensionIdentifier.toKey(c.identifier),L),P.value}$createCommentThreadTemplate(c,n,r){const g=this.b.get(c);!g||g.$createCommentThreadTemplate(n,r)}async $updateCommentThreadTemplate(c,n,r){const g=this.b.get(c);!g||g.$updateCommentThreadTemplate(n,r)}$deleteCommentThread(c,n){this.b.get(c)?.$deleteCommentThread(n)}$provideCommentingRanges(c,n,r){const g=this.b.get(c);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const P=b.getDocument(D.URI.revive(n));return(0,a.asPromise)(()=>g.commentingRangeProvider.provideCommentingRanges(P,r)).then(L=>L?L.map(z=>C.Range.from(z)):void 0)}$toggleReaction(c,n,r,g,P){const L=this.b.get(c);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,a.asPromise)(()=>{const z=L.getCommentThread(n);if(z){const _=z.getCommentByUniqueId(g.uniqueIdInThread);if(L!==void 0&&_&&L.reactionHandler)return L.reactionHandler(_,i(P))}return Promise.resolve(void 0)})}dispose(){}}w.a=0;class h{set threadId(c){this.n=c}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(c){c.isEqual(this.p)||(this.p=c,this.b.range=c,this.c.fire())}get range(){return this.p}set canReply(c){this.d!==c&&(this.d=c,this.b.canReply=c,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(c){this.e=c,this.b.label=c,this.c.fire()}get contextValue(){return this.f}set contextValue(c){this.f=c,this.b.contextValue=c,this.c.fire()}get comments(){return this.q}set comments(c){this.q=c,this.b.comments=c,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(c){this.g=c,this.b.collapsibleState=c,this.c.fire()}get state(){return(0,T.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h}set state(c){(0,T.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h=c,this.b.state=c,this.c.fire()}get isDisposed(){return this.j}constructor(c,n,r,g,P,L,z,_){this.m=n,this.n=r,this.o=g,this.p=P,this.q=L,this.extensionDescription=z,this.r=_,this.handle=h.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new A.MutableDisposable,this.l.value=new A.DisposableStore,this.n===void 0&&(this.n=`${c}.${this.handle}`),f.$createCommentThread(n,this.handle,this.n,this.o,C.Range.from(this.p),z.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this.i.push({dispose:()=>{f.$deleteCommentThread(n,this.handle)}});const K=this;this.value={get uri(){return K.uri},get range(){return K.range},set range(F){K.range=F},get comments(){return K.comments},set comments(F){K.comments=F},get collapsibleState(){return K.collapsibleState},set collapsibleState(F){K.collapsibleState=F},get canReply(){return K.canReply},set canReply(F){K.canReply=F},get contextValue(){return K.contextValue},set contextValue(F){K.contextValue=F},get label(){return K.label},set label(F){K.label=F},get state(){return K.state},set state(F){K.state=F},dispose:()=>{K.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new A.DisposableStore);const c=r=>Object.prototype.hasOwnProperty.call(this.b,r),n={};c("range")&&(n.range=C.Range.from(this.p)),c("label")&&(n.label=this.label),c("contextValue")&&(n.contextValue=this.contextValue??null),c("comments")&&(n.comments=this.q.map(r=>p(this,r,this.k))),c("collapsibleState")&&(n.collapseState=l(this.g)),c("canReply")&&(n.canReply=this.canReply),c("state")&&(n.state=u(this.h)),c("isTemplate")&&(n.isTemplate=this.r),this.b={},f.$updateCommentThread(this.m,this.handle,this.n,this.o,n)}getCommentByUniqueId(c){for(const n of this.k){const r=n[0],g=n[1];if(c===g)return r}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(c=>c.dispose())}}h.a=0,qe([(0,t.debounce)(100)],h.prototype,"eventuallyUpdateCommentThread",null);class m{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(c){this.b=c,f.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(c){this.c=c,f.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this.d}set options(c){this.d=c,f.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(c,n,r,g){this.f=c,this.g=n,this.h=r,this.i=g,this.a=new Map,f.$registerCommentController(this.handle,r,g);const P=this;this.value=Object.freeze({id:P.id,label:P.label,get options(){return P.options},set options(L){P.options=L},get commentingRangeProvider(){return P.commentingRangeProvider},set commentingRangeProvider(L){P.commentingRangeProvider=L},get reactionHandler(){return P.reactionHandler},set reactionHandler(L){P.reactionHandler=L},createCommentThread(L,z,_){return P.createCommentThread(L,z,_).value},dispose:()=>{P.dispose()}}),this.e=[],this.e.push({dispose:()=>{f.$unregisterCommentController(this.handle)}})}createCommentThread(c,n,r,g){if(typeof c=="string"){const P=new h(this.id,this.handle,c,n,r,g,this.f,!1);return this.a.set(P.handle,P),P}else{const P=new h(this.id,this.handle,void 0,c,n,r,this.f,!1);return this.a.set(P.handle,P),P}}$createCommentThreadTemplate(c,n){const r=new h(this.id,this.handle,void 0,D.URI.revive(c),C.Range.to(n),[],this.f,!0);return r.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this.a.set(r.handle,r),r}$updateCommentThreadTemplate(c,n){const r=this.a.get(c);r&&(r.range=C.Range.to(n))}$deleteCommentThread(c){this.a.get(c)?.dispose(),this.a.delete(c)}getCommentThread(c){return this.a.get(c)}dispose(){this.a.forEach(c=>{c.dispose()}),this.e.forEach(c=>c.dispose())}}function p(s,c,n){let r=n.get(c);r||(r=++s.commentHandle,n.set(c,r));const g=c.author&&c.author.iconPath?c.author.iconPath.toString():void 0;return{mode:c.mode,contextValue:c.contextValue,uniqueIdInThread:r,body:typeof c.body=="string"?c.body:C.MarkdownString.from(c.body),userName:c.author.name,userIconPath:g,label:c.label,commentReactions:c.reactions?c.reactions.map(P=>o(P)):void 0,timestamp:c.timestamp?.toJSON()}}function o(s){return{label:s.label,iconPath:s.iconPath?C.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function i(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?D.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function l(s){if(s!==void 0)switch(s){case R.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}function u(s){if(s!==void 0)switch(s){case R.CommentThreadState.Unresolved:return k.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return k.CommentThreadState.Resolved}return k.CommentThreadState.Unresolved}return new w}e.createExtHostComments=y}),define(Se[246],ye([1,0,23,5,25,16]),function(ne,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let D=class{constructor(R,T){this.a=R.getProxy(t.MainContext.MainThreadConsole),this.b=T.consoleForward.includeStack,this.c=T.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(R,T){const E=this,y=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){E.e(R,T,y,arguments)}})}e(R,T,E,y){this.a.$logExtensionHostMessage({type:"__$console",severity:T,arguments:S(y,this.b)}),this.c&&this.f(R,E,y)}};D=qe([We(0,A.IExtHostRpcService),We(1,I.IExtHostInitDataService)],D),e.AbstractExtHostConsoleForwarder=D;const k=1e5;function S(C,R){const T=[];if(C.length)for(let E=0;E<C.length;E++){let y=C[E];if(typeof y>"u")y="undefined";else if(y instanceof Error){const v=y;v.stack?y=v.stack:y=v.toString()}T.push(y)}if(R){const E=new Error().stack;E&&T.push({__$stack:E.split(`
`).slice(3).join(`
`)})}try{const E=(0,a.safeStringify)(T);return E.length>k?"Output omitted for a large object that exceeds the limits":E}catch(E){return`Output omitted for an object that cannot be inspected ('${E.toString()}')`}}}),define(Se[139],ye([1,0,2,5,7,3,16,13,17,8,9,26]),function(ne,e,a,t,I,A,D,k,S,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let E=class Rn{constructor(v,d){this.h=d,this.f=new Map,this.g=v.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(v,d){const b=Rn.c++;this.f.set(b,{provider:v,extensionDescription:d}),this.g.$registerDecorationProvider(b,d.identifier.value);const f=v.onDidChangeFileDecorations&&v.onDidChangeFileDecorations(w=>{if(!w){this.g.$onDidChange(b,null);return}const h=(0,S.asArray)(w);if(h.length<=Rn.d){this.g.$onDidChange(b,h);return}this.h.warn("[Decorations] CAPPING events from decorations provider",d.identifier.value,h.length);const m=h.map(i=>({uri:i,rank:(0,C.count)(i.path,"/")})),p=(0,S.groupBy)(m,(i,l)=>i.rank-l.rank||(0,C.compare)(i.uri.path,l.uri.path)),o=[];e:for(const i of p){let l;for(const u of i){const s=(0,R.dirname)(u.uri.path);if(l!==s&&(l=s,o.push(u.uri)>=Rn.d))break e}}this.g.$onDidChange(b,o)});return new I.Disposable(()=>{f?.dispose(),this.g.$unregisterDecorationProvider(b),this.f.delete(b)})}async $provideDecorations(v,d,b){if(!this.f.has(v))return Object.create(null);const f=Object.create(null),{provider:w,extensionDescription:h}=this.f.get(v);return await Promise.all(d.map(async m=>{try{const{uri:p,id:o}=m,i=await Promise.resolve(w.provideFileDecoration(a.URI.revive(p),b));if(!i)return;try{I.FileDecoration.validate(i),i.badge&&typeof i.badge!="string"&&(0,T.checkProposedApiEnabled)(h,"codiconDecoration"),f[o]=[i.propagate,i.tooltip,i.badge,i.color]}catch(l){this.h.warn(`INVALID decoration from extension '${h}': ${l}`)}}catch(p){this.h.error(p)}})),f}};E.c=0,E.d=250,E=qe([We(0,D.IExtHostRpcService),We(1,k.ILogService)],E),e.ExtHostDecorations=E,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ne,a):I?I.value=a:e.set(ne,a),a},Me=this&&this.__classPrivateFieldGet||function(ne,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[247],ye([1,0,173,122,2,5,7,14,4,13,28,47]),function(ne,e,a,t,I,A,D,k,S,C,R,T){"use strict";var E,y,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class d{constructor(w,h,m,p,o,i,l){this.d=w,this.e=h,this.f=m,this.g=p,E.set(this,void 0),y.set(this,void 0),v.set(this,void 0),this.c=!1,Je(this,v,new R.ResourceMap(u=>o.getComparisonKey(u)),"f"),Je(this,E,i,"f"),Je(this,y,l,"f")}dispose(){this.c||(Me(this,y,"f").fire([...Me(this,v,"f").keys()]),Me(this,E,"f")?.$clear(this.e),Me(this,v,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(w,h){if(!w){this.clear();return}this.h();let m=[];if(I.URI.isUri(w)){if(!h){this.delete(w);return}Me(this,v,"f").set(w,h.slice()),m=[w]}else if(Array.isArray(w)){m=[];let o;w=[...w].sort(d.j);for(const i of w){const[l,u]=i;if((!o||l.toString()!==o.toString())&&(o&&Me(this,v,"f").get(o).length===0&&Me(this,v,"f").delete(o),o=l,m.push(l),Me(this,v,"f").set(l,[])),u)Me(this,v,"f").get(l)?.push(...u);else{const s=Me(this,v,"f").get(l);s&&(s.length=0)}}}if(Me(this,y,"f").fire(m),!Me(this,E,"f"))return;const p=[];for(const o of m){let i=[];const l=Me(this,v,"f").get(o);if(l)if(l.length>this.f){i=[];const u=[D.DiagnosticSeverity.Error,D.DiagnosticSeverity.Warning,D.DiagnosticSeverity.Information,D.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(const c of l)if(c.severity===u[s]&&i.push({...k.Diagnostic.from(c),modelVersionId:this.g(o)})===this.f)break e;i.push({severity:t.MarkerSeverity.Info,message:(0,a.localize)(0,null,l.length-this.f),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=l.map(u=>({...k.Diagnostic.from(u),modelVersionId:this.g(o)}));p.push([o,i])}Me(this,E,"f").$changeMany(this.e,p)}delete(w){this.h(),Me(this,y,"f").fire([w]),Me(this,v,"f").delete(w),Me(this,E,"f")?.$changeMany(this.e,[[w,void 0]])}clear(){this.h(),Me(this,y,"f").fire([...Me(this,v,"f").keys()]),Me(this,v,"f").clear(),Me(this,E,"f")?.$clear(this.e)}forEach(w,h){this.h();for(const[m,p]of this)w.call(h,m,p,this)}*[(E=new WeakMap,y=new WeakMap,v=new WeakMap,Symbol.iterator)](){this.h();for(const w of Me(this,v,"f").keys())yield[w,this.get(w)]}get(w){this.h();const h=Me(this,v,"f").get(w);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(w){return this.h(),Array.isArray(Me(this,v,"f").get(w))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(w,h){return w[0].toString()<h[0].toString()?-1:w[0].toString()>h[0].toString()?1:0}}e.DiagnosticCollection=d;let b=class pn{static _mapper(w){const h=new R.ResourceMap;for(const m of w)h.set(m,m);return{uris:Object.freeze(Array.from(h.values()))}}constructor(w,h,m,p){this.h=h,this.j=m,this.k=p,this.f=new Map,this.g=new S.DebounceEmitter({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.g.event,pn._mapper),this.e=w.getProxy(A.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(w,h){const{f:m,e:p,g:o,h:i,j:l,k:u}=this,s=new class{$changeMany(r,g){p.$changeMany(r,g),i.trace("[DiagnosticCollection] change many (extension, owner, uris)",w.value,r,g.length===0?"CLEARING":g)}$clear(r){p.$clear(r),i.trace("[DiagnosticCollection] remove all (extension, owner)",w.value,r)}dispose(){p.dispose()}};let c;if(!h)h="_generated_diagnostic_collection_name_#"+pn.c++,c=h;else if(!m.has(h))c=h;else{this.h.warn(`DiagnosticCollection with name '${h}' does already exist.`);do c=h+pn.c++;while(m.has(c))}return new class extends d{constructor(){super(h,c,pn.d,r=>u.getDocument(r)?.version,l.extUri,s,o),m.set(c,this)}dispose(){super.dispose(),m.delete(c)}}}getDiagnostics(w){if(w)return this.l(w);{const h=new Map,m=[];for(const p of this.f.values())p.forEach((o,i)=>{let l=h.get(o.toString());typeof l>"u"&&(l=m.length,h.set(o.toString(),l),m.push([o,[]])),m[l][1]=m[l][1].concat(...i)});return m}}l(w){let h=[];for(const m of this.f.values())m.has(w)&&(h=h.concat(m.get(w)));return h}$acceptMarkersChange(w){if(!this.m){const h="_generated_mirror",m=new d(h,h,pn.d,p=>{},this.j.extUri,void 0,this.g);this.f.set(h,m),this.m=m}for(const[h,m]of w)this.m.set(I.URI.revive(h),m.map(k.Diagnostic.to))}};b.c=0,b.d=1e3,b=qe([We(1,C.ILogService),We(2,T.IExtHostFileSystemInfo)],b),e.ExtHostDiagnostics=b}),define(Se[248],ye([1,0,2,5]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(D){this.a=D.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(D){return this.a.$showOpenDialog(D).then(k=>k?k.map(S=>a.URI.revive(S)):void 0)}showSaveDialog(D){return this.a.$showSaveDialog(D).then(k=>k?a.URI.revive(k):void 0)}}e.ExtHostDialogs=I}),define(Se[249],ye([1,0,10,2,7,5,15,21,8]),function(ne,e,a,t,I,A,D,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(T,E,y){this.d=E,this.e=y,this.b=new Map,this.c=T.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(T,E){if(Object.keys(D.Schemas).indexOf(T)>=0)throw new Error(`scheme '${T}' already registered`);const y=C.a++;this.b.set(y,E),this.c.$registerTextContentProvider(y,T);let v;return typeof E.onDidChange=="function"&&(v=E.onDidChange(d=>{if(d.scheme!==T){this.e.warn(`Provider for scheme '${T}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this.d.getDocument(d)&&this.$provideTextDocumentContent(y,d).then(b=>{if(!b&&typeof b!="string")return;const f=this.d.getDocument(d);if(!f)return;const w=(0,S.splitLines)(b);if(!f.equalLines(w))return this.c.$onVirtualDocumentChange(d,b)},a.onUnexpectedError)})),new I.Disposable(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(T,E){const y=this.b.get(T);return y?Promise.resolve(y.provideTextDocumentContent(t.URI.revive(E),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${E.scheme}`))}}e.ExtHostDocumentContentProvider=C,C.a=0}),define(Se[250],ye([1,0,4,6,2,5,135,14,11,23,7]),function(ne,e,a,t,I,A,D,k,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class T{constructor(y,v){this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter,this.d=new a.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new t.DisposableStore,this.h=new Map,this.f=y.getProxy(A.MainContext.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(d=>{for(const b of d)this.b.fire(b.document)},void 0,this.e),this.g.onDidAddDocuments(d=>{for(const b of d)this.a.fire(b.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(y){if(!y)return;const v=this.g.getDocument(y);if(v)return v}getDocument(y){const v=this.getDocumentData(y);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${y}'`);return v.document}ensureDocumentData(y){const v=this.g.getDocument(y);if(v)return Promise.resolve(v);let d=this.h.get(y.toString());return d||(d=this.f.$tryOpenDocument(y).then(b=>{this.h.delete(y.toString());const f=I.URI.revive(b);return(0,S.assertIsDefined)(this.g.getDocument(f))},b=>(this.h.delete(y.toString()),Promise.reject(b))),this.h.set(y.toString(),d)),d}createDocumentData(y){return this.f.$tryCreateDocument(y).then(v=>I.URI.revive(v))}$acceptModelLanguageChanged(y,v){const d=I.URI.revive(y),b=this.g.getDocument(d);if(!b)throw new Error("unknown document");this.b.fire(b.document),b._acceptLanguageId(v),this.a.fire(b.document)}$acceptModelSaved(y){const v=I.URI.revive(y),d=this.g.getDocument(v);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(y,!1),this.d.fire(d.document)}$acceptDirtyStateChanged(y,v){const d=I.URI.revive(y),b=this.g.getDocument(d);if(!b)throw new Error("unknown document");b._acceptIsDirty(v),this.c.fire({document:b.document,contentChanges:[],reason:void 0})}$acceptModelChanged(y,v,d){const b=I.URI.revive(y),f=this.g.getDocument(b);if(!f)throw new Error("unknown document");f._acceptIsDirty(d),f.onEvents(v);let w;v.isUndoing?w=R.TextDocumentChangeReason.Undo:v.isRedoing&&(w=R.TextDocumentChangeReason.Redo),this.c.fire((0,C.deepFreeze)({document:f.document,contentChanges:v.changes.map(h=>({range:k.Range.to(h.range),rangeOffset:h.rangeOffset,rangeLength:h.rangeLength,text:h.text})),reason:w}))}setWordDefinitionFor(y,v){(0,D.setWordDefinitionFor)(y,v)}}e.ExtHostDocuments=T}),define(Se[58],ye([1,0,49,4,6,2,3,5,135,16,138,14,13,28,15,62,81]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class f{constructor(m){this.value=m,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let w=class{constructor(m,p){this.h=m,this.i=p,this.a=null,this.b=new Map,this.c=new y.ResourceMap,this.d=new t.Emitter,this.e=new t.Emitter,this.f=new t.Emitter,this.g=new t.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(m){this.acceptDocumentsAndEditorsDelta(m)}acceptDocumentsAndEditorsDelta(m){const p=[],o=[],i=[];if(m.removedDocuments)for(const l of m.removedDocuments){const u=A.URI.revive(l),s=this.c.get(u);s?.unref()&&(this.c.delete(u),p.push(s.value))}if(m.addedDocuments)for(const l of m.addedDocuments){const u=A.URI.revive(l.uri);let s=this.c.get(u);if(s&&u.scheme!==v.Schemas.vscodeNotebookCell&&u.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);s||(s=new f(new S.ExtHostDocumentData(this.h.getProxy(k.MainContext.MainThreadDocuments),u,l.lines,l.EOL,l.versionId,l.languageId,l.isDirty,l.notebook)),this.c.set(u,s),o.push(s.value)),s.ref()}if(m.removedEditors)for(const l of m.removedEditors){const u=this.b.get(l);this.b.delete(l),u&&i.push(u)}if(m.addedEditors)for(const l of m.addedEditors){const u=A.URI.revive(l.documentUri);a.ok(this.c.has(u),`document '${u}' does not exist`),a.ok(!this.b.has(l.id),`editor '${l.id}' already exists!`);const s=this.c.get(u).value,c=new R.ExtHostTextEditor(l.id,this.h.getProxy(k.MainContext.MainThreadTextEditors),this.i,new b.Lazy(()=>s.document),l.selections.map(T.Selection.to),l.options,l.visibleRanges.map(n=>T.Range.to(n)),typeof l.editorPosition=="number"?T.ViewColumn.to(l.editorPosition):void 0);this.b.set(l.id,c)}m.newActiveEditor!==void 0&&(a.ok(m.newActiveEditor===null||this.b.has(m.newActiveEditor),`active editor '${m.newActiveEditor}' does not exist`),this.a=m.newActiveEditor),(0,I.dispose)(p),(0,I.dispose)(i),m.removedDocuments&&this.e.fire(p),m.addedDocuments&&this.d.fire(o),(m.removedEditors||m.addedEditors)&&this.f.fire(this.allEditors().map(l=>l.value)),m.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(m){return this.c.get(m)?.value}allDocuments(){return d.Iterable.map(this.c.values(),m=>m.value)}getEditor(m){return this.b.get(m)}activeEditor(m){if(!this.a)return;const p=this.b.get(this.a);return m?p:p?.value}allEditors(){return[...this.b.values()]}};w=qe([We(0,C.IExtHostRpcService),We(1,E.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=(0,D.createDecorator)("IExtHostDocumentsAndEditors")}),define(Se[59],ye([1,0,14,5,2,4,3,7,16,11,80]),function(ne,e,a,t,I,A,D,k,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,D.createDecorator)("IExtHostEditorTabs");class T{constructor(b,f,w){this.e=w,this.d=f,this.acceptDtoUpdate(b)}get apiObject(){if(!this.a){const b=this,f={get isActive(){return b.b.id===b.e()},get label(){return b.b.label},get input(){return b.c},get isDirty(){return b.b.isDirty},get isPinned(){return b.b.isPinned},get isPreview(){return b.b.isPreview},get group(){return b.d.apiObject}};this.a=Object.freeze(f)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(b){this.b=b,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new k.TextTabInput(I.URI.revive(this.b.input.uri));case 2:return new k.TextDiffTabInput(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified));case 3:return new k.TextMergeTabInput(I.URI.revive(this.b.input.base),I.URI.revive(this.b.input.input1),I.URI.revive(this.b.input.input2),I.URI.revive(this.b.input.result));case 6:return new k.CustomEditorTabInput(I.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new k.WebviewEditorTabInput(this.b.input.viewType);case 4:return new k.NotebookEditorTabInput(I.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new k.NotebookDiffEditorTabInput(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new k.TerminalEditorTabInput;case 9:return new k.InteractiveWindowInput(I.URI.revive(this.b.input.uri),I.URI.revive(this.b.input.inputBoxUri));default:return}}}class E{constructor(b,f){this.c=[],this.d="",this.b=b,this.e=f;for(const w of b.tabs)w.isActive&&(this.d=w.id),this.c.push(new T(w,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const b=this,f={get isActive(){return b.b.groupId===b.e()},get viewColumn(){return a.ViewColumn.to(b.b.viewColumn)},get activeTab(){return b.c.find(w=>w.tabId===b.d)?.apiObject},get tabs(){return Object.freeze(b.c.map(w=>w.apiObject))}};this.a=Object.freeze(f)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(b){this.b=b}acceptTabOperation(b){if(b.kind===0){const w=new T(b.tabDto,this,()=>this.activeTabId());return this.c.splice(b.index,0,w),b.tabDto.isActive&&(this.d=w.tabId),w}else if(b.kind===1){const w=this.c.splice(b.index,1)[0];if(!w)throw new Error(`Tab close updated received for index ${b.index} which does not exist`);return w.tabId===this.d&&(this.d=""),w}else if(b.kind===3){if(b.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const w=this.c.splice(b.oldIndex,1)[0];if(!w)throw new Error(`Tab move updated received for index ${b.oldIndex} which does not exist`);return this.c.splice(b.index,0,w),w}const f=this.c.find(w=>w.tabId===b.tabDto.id);if(!f)throw new Error("INVALID tab");return b.tabDto.isActive?this.d=b.tabDto.id:this.d===b.tabDto.id&&!b.tabDto.isActive&&(this.d=""),f.acceptDtoUpdate(b.tabDto),f}activeTabId(){return this.d}}let y=class{constructor(b){this.b=new A.Emitter,this.c=new A.Emitter,this.e=[],this.a=b.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const b=this,f={onDidChangeTabGroups:b.c.event,onDidChangeTabs:b.b.event,get all(){return Object.freeze(b.e.map(w=>w.apiObject))},get activeTabGroup(){const w=b.d;return(0,C.assertIsDefined)(b.e.find(m=>m.groupId===w)?.apiObject)},close:async(w,h)=>{const m=Array.isArray(w)?w:[w];return m.length?v(m[0])?this.j(m,h):this.i(m,h):!0}};this.f=Object.freeze(f)}return this.f}$acceptEditorTabModel(b){const f=new Set(this.e.map(l=>l.groupId)),w=new Set(b.map(l=>l.groupId)),h=(0,R.diffSets)(f,w),m=this.e.filter(l=>h.removed.includes(l.groupId)).map(l=>l.apiObject),p=[],o=[];this.e=b.map(l=>{const u=new E(l,()=>this.d);return h.added.includes(u.groupId)?p.push(u.apiObject):o.push(u.apiObject),u});const i=(0,C.assertIsDefined)(b.find(l=>l.isActive===!0)?.groupId);i!==void 0&&this.d!==i&&(this.d=i),this.c.fire(Object.freeze({opened:p,closed:m,changed:o}))}$acceptTabGroupUpdate(b){const f=this.e.find(w=>w.groupId===b.groupId);if(!f)throw new Error("Update Group IPC call received before group creation.");f.acceptGroupDtoUpdate(b),b.isActive&&(this.d=b.groupId),this.c.fire(Object.freeze({changed:[f.apiObject],opened:[],closed:[]}))}$acceptTabOperation(b){const f=this.e.find(h=>h.groupId===b.groupId);if(!f)throw new Error("Update Tabs IPC call received before group creation.");const w=f.acceptTabOperation(b);switch(b.kind){case 0:this.b.fire(Object.freeze({opened:[w.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[w.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[w.apiObject]}));return}}g(b){for(const f of this.e)for(const w of f.tabs)if(w.apiObject===b)return w}h(b){return this.e.find(f=>f.apiObject===b)}async i(b,f){const w=[];for(const h of b){const m=this.g(h);if(!m)throw new Error("Tab close: Invalid tab not found!");w.push(m.tabId)}return this.a.$closeTab(w,f)}async j(b,f){const w=[];for(const h of b){const m=this.h(h);if(!m)throw new Error("Group close: Invalid group not found!");w.push(m.groupId)}return this.a.$closeGroup(w,f)}};y=qe([We(0,S.IExtHostRpcService)],y),e.ExtHostEditorTabs=y;function v(d){return d.tabs!==void 0}}),define(Se[251],ye([1,0,2,5,6,7,14,153,8,22,26]),function(ne,e,a,t,I,A,D,k,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class T{constructor(){this.a=[]}add(v){this.b=void 0,this.a.push(v)}delete(v){const d=this.a.indexOf(v);d>=0&&(this.a.splice(d,1),this.b=void 0)}c(){if(!this.b){const v=this.a.sort(),d=[];let b,f,w=14,h=14;for(const m of v){let p=b?(0,S.commonPrefixLength)(b,m):0;for(p===0?f=1:f=h;p<m.length;p++)p+1===m.length?(w=h,h=9):h+=1,d.push([f,m.toUpperCase().charCodeAt(p),h]),d.push([f,m.toLowerCase().charCodeAt(p),h]),f=h;b=m,h=w}d.push([9,58,10]),d.push([10,47,12]),this.b=new k.StateMachine(d)}}provideDocumentLinks(v){this.c();const d=[],b=k.LinkComputer.computeLinks({getLineContent(f){return v.lineAt(f-1).text},getLineCount(){return v.lineCount}},this.b);for(const f of b){const w=D.DocumentLink.to(f);w.target&&d.push(w)}return d}}class E{constructor(v,d){this.i=d,this.b=new T,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=v.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(v,d,b,f={}){if(this.d.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(v,"*",this.b));const w=this.h++;this.b.add(d),this.d.add(d),this.c.set(w,b);let h=2;f.isCaseSensitive&&(h+=1024),f.isReadonly&&(h+=2048),typeof b.copy=="function"&&(h+=8),typeof b.open=="function"&&typeof b.close=="function"&&typeof b.read=="function"&&typeof b.write=="function"&&((0,R.checkProposedApiEnabled)(v,"fsChunks"),h+=4),this.a.$registerFileSystemProvider(w,d,h).catch(p=>{console.error(`FAILED to register filesystem provider of ${v.identifier.value}-extension for the scheme ${d}`),console.error(p)});const m=b.onDidChangeFile(p=>{const o=[];for(const i of p){const{uri:l,type:u}=i;if(l.scheme!==d)continue;let s;switch(u){case A.FileChangeType.Changed:s=0;break;case A.FileChangeType.Created:s=1;break;case A.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:l,type:s})}this.a.$onFileSystemChange(w,o)});return(0,I.toDisposable)(()=>{m.dispose(),this.b.delete(d),this.d.delete(d),this.c.delete(w),this.a.$unregisterProvider(w)})}static j(v){const{type:d,ctime:b,mtime:f,size:w,permissions:h}=v;return{type:d,ctime:b,mtime:f,size:w,permissions:h}}$stat(v,d){return Promise.resolve(this.k(v).stat(a.URI.revive(d))).then(b=>E.j(b))}$readdir(v,d){return Promise.resolve(this.k(v).readDirectory(a.URI.revive(d)))}$readFile(v,d){return Promise.resolve(this.k(v).readFile(a.URI.revive(d))).then(b=>C.VSBuffer.wrap(b))}$writeFile(v,d,b,f){return Promise.resolve(this.k(v).writeFile(a.URI.revive(d),b.buffer,f))}$delete(v,d,b){return Promise.resolve(this.k(v).delete(a.URI.revive(d),b))}$rename(v,d,b,f){return Promise.resolve(this.k(v).rename(a.URI.revive(d),a.URI.revive(b),f))}$copy(v,d,b,f){const w=this.k(v);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(a.URI.revive(d),a.URI.revive(b),f))}$mkdir(v,d){return Promise.resolve(this.k(v).createDirectory(a.URI.revive(d)))}$watch(v,d,b,f){const w=this.k(v).watch(a.URI.revive(b),f);this.f.set(d,w)}$unwatch(v,d){const b=this.f.get(d);b&&(b.dispose(),this.f.delete(d))}$open(v,d,b){const f=this.k(v);if(!f.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(f.open(a.URI.revive(d),b))}$close(v,d){const b=this.k(v);if(!b.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(b.close(d))}$read(v,d,b,f){const w=this.k(v);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const h=C.VSBuffer.alloc(f);return Promise.resolve(w.read(d,b,h.buffer,0,f)).then(m=>h.slice(0,m))}$write(v,d,b,f){const w=this.k(v);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(d,b,f.buffer,0,f.byteLength))}k(v){const d=this.c.get(v);if(!d){const b=new Error;throw b.name="ENOPRO",b.message="no provider",b}return d}}e.ExtHostFileSystem=E}),define(Se[71],ye([1,0,5,38,7,22,3,16,47,6]),function(ne,e,a,t,I,A,D,k,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Jt{constructor(E,y){this.b=new Map,this.a=E.getProxy(a.MainContext.MainThreadFileSystem);const v=this;this.value=Object.freeze({async stat(d){try{const b=v.b.get(d.scheme);if(!b)return await v.a.$stat(d);await v.a.$ensureActivation(d.scheme);const f=await b.stat(d);return{type:f.type,ctime:f.ctime,mtime:f.mtime,size:f.size,permissions:f.permissions}}catch(b){Jt.c(b)}},async readDirectory(d){try{const b=v.b.get(d.scheme);return b?(await v.a.$ensureActivation(d.scheme),(await b.readDirectory(d)).slice()):await v.a.$readdir(d)}catch(b){return Jt.c(b)}},async createDirectory(d){try{return await v.a.$mkdir(d)}catch(b){return Jt.c(b)}},async readFile(d){try{const b=v.b.get(d.scheme);return b?(await v.a.$ensureActivation(d.scheme),(await b.readFile(d)).slice()):(await v.a.$readFile(d)).buffer}catch(b){return Jt.c(b)}},async writeFile(d,b){try{return await v.a.$writeFile(d,A.VSBuffer.wrap(b))}catch(f){return Jt.c(f)}},async delete(d,b){try{const f=v.b.get(d.scheme);return f?(await v.a.$ensureActivation(d.scheme),await f.delete(d,{recursive:!1,...b})):await v.a.$delete(d,{recursive:!1,useTrash:!1,...b})}catch(f){return Jt.c(f)}},async rename(d,b,f){try{return await v.a.$rename(d,b,{overwrite:!1,...f})}catch(w){return Jt.c(w)}},async copy(d,b,f){try{return await v.a.$copy(d,b,{overwrite:!1,...f})}catch(w){return Jt.c(w)}},isWritableFileSystem(d){const b=y.getCapabilities(d);if(typeof b=="number")return!(b&2048)}})}static c(E){if(E instanceof I.FileSystemError)throw E;if(!(E instanceof Error))throw new I.FileSystemError(String(E));if(E.name==="ENOPRO")throw I.FileSystemError.Unavailable(E.message);switch(E.name){case t.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(E.message);case t.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(E.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(E.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(E.message);case t.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(E.message);case t.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(E.message);default:throw new I.FileSystemError(E.message,E.name)}}addFileSystemProvider(E,y){return this.b.set(E,y),(0,C.toDisposable)(()=>this.b.delete(E))}};R=qe([We(0,k.IExtHostRpcService),We(1,S.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,D.createDecorator)("IExtHostConsumerFileSystem")}),define(Se[252],ye([1,0,4,37,2,5,14,7]),function(ne,e,a,t,I,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(T,E,y,v,d,b,f,w){this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter;const h=this.h(T,y,d);this.g=0,b&&(this.g+=1),f&&(this.g+=2),w&&(this.g+=4);const m=(0,t.parse)(d),p=typeof d=="string",o=v(i=>{if(!b)for(const l of i.created){const u=I.URI.revive(l);m(u.fsPath)&&(!p||E.getWorkspaceFolder(u))&&this.a.fire(u)}if(!f)for(const l of i.changed){const u=I.URI.revive(l);m(u.fsPath)&&(!p||E.getWorkspaceFolder(u))&&this.b.fire(u)}if(!w)for(const l of i.deleted){const u=I.URI.revive(l);m(u.fsPath)&&(!p||E.getWorkspaceFolder(u))&&this.c.fire(u)}});this.d=k.Disposable.from(h,this.a,this.b,this.c,o)}h(T,E,y){const v=k.Disposable.from();if(typeof y=="string")return v;const d=T.getProxy(A.MainContext.MainThreadFileSystem);let b=!1;(y.pattern.includes(t.GLOBSTAR)||y.pattern.includes(t.GLOB_SPLIT))&&(b=!0);const f=Math.random();return d.$watch(E.identifier.value,f,y.baseUri,{recursive:b,excludes:[]}),k.Disposable.from({dispose:()=>d.$unwatch(f)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class C{constructor(T,E,y){this.j=T,this.k=E,this.l=y,this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter,this.d=new a.Emitter,this.g=new a.AsyncEmitter,this.h=new a.AsyncEmitter,this.i=new a.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(T,E,y,v,d,b){return new S(this.j,T,E,this.a.event,D.GlobPattern.from(y),v,d,b)}$onFileEvent(T){this.a.fire(T)}$onDidRunFileOperation(T,E){switch(T){case 2:this.b.fire(Object.freeze({files:E.map(y=>({oldUri:I.URI.revive(y.source),newUri:I.URI.revive(y.target)}))}));break;case 1:this.d.fire(Object.freeze({files:E.map(y=>I.URI.revive(y.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:E.map(y=>I.URI.revive(y.target))}));break;default:}}getOnWillRenameFileEvent(T){return this.m(T,this.g)}getOnWillCreateFileEvent(T){return this.m(T,this.h)}getOnWillDeleteFileEvent(T){return this.m(T,this.i)}m(T,E){return(y,v,d)=>{const b=function(w){y.call(v,w)};return b.extension=T,E.event(b,void 0,d)}}async $onWillRunFileOperation(T,E,y,v){switch(T){case 2:return await this.n(this.g,{files:E.map(d=>({oldUri:I.URI.revive(d.source),newUri:I.URI.revive(d.target)}))},y,v);case 1:return await this.n(this.i,{files:E.map(d=>I.URI.revive(d.target))},y,v);case 0:case 3:return await this.n(this.h,{files:E.map(d=>I.URI.revive(d.target))},y,v)}}async n(T,E,y,v){const d=new Set,b=[];if(await T.fireAsync(E,v,async(w,h)=>{const m=Date.now(),p=await Promise.resolve(w);p instanceof k.WorkspaceEdit&&(b.push([h.extension,p]),d.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-m>y&&this.k.warn("SLOW file-participant",h.extension.identifier)}),v.isCancellationRequested||b.length===0)return;const f={edits:[]};for(const[,w]of b){const{edits:h}=D.WorkspaceEdit.from(w,{getTextDocumentVersion:m=>this.l.getDocument(m)?.version,getNotebookDocumentVersion:()=>{}});f.edits=f.edits.concat(h)}return{edit:f,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=C}),define(Se[253],ye([1,0,2,39]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(D,k,S,C,R){this.a=k,this.b=S,this.c=C;const T=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",E=>!0,E=>E),new t.ApiCommandArgument("resource","Interactive resource Uri",E=>!0,E=>E),new t.ApiCommandArgument("controllerId","Notebook controller Id",E=>!0,E=>E),new t.ApiCommandArgument("title","Interactive editor title",E=>!0,E=>E)],new t.ApiCommandResult("Notebook and input URI",E=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",E.notebookEditorId),E.notebookEditorId!==void 0){const y=this.a.getEditorById(E.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:a.URI.revive(E.notebookUri),inputUri:a.URI.revive(E.inputUri),notebookEditor:y.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",E.notebookUri,E.inputUri),{notebookUri:a.URI.revive(E.notebookUri),inputUri:a.URI.revive(E.inputUri)}}));this.c.registerApiCommand(T)}$willAddInteractiveDocument(D,k,S,C){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:S,uri:D,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(a.URI.revive(C))?.apiNotebook}]})}$willRemoveInteractiveDocument(D,k){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[D]})}}e.ExtHostInteractive=I}),define(Se[254],ye([1,0,6,5]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(D){this.b=0,this.a=D.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(D){const k=this.b++;return this.a.$registerResourceLabelFormatter(k,D),(0,a.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=I}),define(Se[255],ye([1,0,2,23,14,7,66,5,8,35,17,11,149,21,6,118,99,68,44,10,18,26]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v,d,b,f,w,h,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class o{constructor(O,H){this.d=O,this.e=H}async provideDocumentSymbols(O,H){const q=this.d.getDocument(O),Y=await this.e.provideDocumentSymbols(q,H);if(!(0,R.isFalsyOrEmpty)(Y))return Y[0]instanceof A.DocumentSymbol?Y.map(I.DocumentSymbol.from):o.f(Y)}static f(O){O=O.slice(0).sort((Y,de)=>{let be=Y.location.range.start.compareTo(de.location.range.start);return be===0&&(be=de.location.range.end.compareTo(Y.location.range.end)),be});const H=[],q=[];for(const Y of O){const de={name:Y.name||"!!MISSING: name!!",kind:I.SymbolKind.from(Y.kind),tags:Y.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:Y.containerName,range:I.Range.from(Y.location.range),selectionRange:I.Range.from(Y.location.range),children:[]};for(;;){if(q.length===0){q.push(de),H.push(de);break}const be=q[q.length-1];if(C.Range.containsRange(be.range,de.range)&&!C.Range.equalsRange(be.range,de.range)){be.children?.push(de),q.push(de);break}q.pop()}}return H}}class i{constructor(O,H,q){this.g=O,this.h=H,this.j=q,this.e=new f.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(O,H){const q=this.g.getDocument(O),Y=await this.j.provideCodeLenses(q,H);if(!Y||H.isCancellationRequested)return;const de=this.e.add(Y),be=new v.DisposableStore;this.f.set(de,be);const Pe={cacheId:de,lenses:[]};for(let pe=0;pe<Y.length;pe++)Pe.lenses.push({cacheId:[de,pe],range:I.Range.from(Y[pe].range),command:this.h.toInternal(Y[pe].command,be)});return Pe}async resolveCodeLens(O,H){const q=O.cacheId&&this.e.get(...O.cacheId);if(!q)return;let Y;if(typeof this.j.resolveCodeLens!="function"||q.isResolved?Y=q:Y=await this.j.resolveCodeLens(q,H),Y||(Y=q),H.isCancellationRequested)return;const de=O.cacheId&&this.f.get(O.cacheId[0]);if(!!de)return O.command=this.h.toInternal(Y.command??i.d,de),O}releaseCodeLenses(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}}i.d={command:"missing",title:"!!MISSING: command!!"};function l(ie){return Array.isArray(ie)?ie.map(I.DefinitionLink.from):ie?[I.DefinitionLink.from(ie)]:[]}class u{constructor(O,H){this.d=O,this.e=H}async provideDefinition(O,H,q){const Y=this.d.getDocument(O),de=I.Position.to(H),be=await this.e.provideDefinition(Y,de,q);return l(be)}}class s{constructor(O,H){this.d=O,this.e=H}async provideDeclaration(O,H,q){const Y=this.d.getDocument(O),de=I.Position.to(H),be=await this.e.provideDeclaration(Y,de,q);return l(be)}}class c{constructor(O,H){this.d=O,this.e=H}async provideImplementation(O,H,q){const Y=this.d.getDocument(O),de=I.Position.to(H),be=await this.e.provideImplementation(Y,de,q);return l(be)}}class n{constructor(O,H){this.d=O,this.e=H}async provideTypeDefinition(O,H,q){const Y=this.d.getDocument(O),de=I.Position.to(H),be=await this.e.provideTypeDefinition(Y,de,q);return l(be)}}class r{constructor(O,H){this.d=O,this.e=H}async provideHover(O,H,q){const Y=this.d.getDocument(O),de=I.Position.to(H),be=await this.e.provideHover(Y,de,q);if(!(!be||(0,R.isFalsyOrEmpty)(be.contents)))return be.range||(be.range=Y.getWordRangeAtPosition(de)),be.range||(be.range=new A.Range(de,de)),I.Hover.from(be)}}class g{constructor(O,H){this.d=O,this.e=H}async provideEvaluatableExpression(O,H,q){const Y=this.d.getDocument(O),de=I.Position.to(H),be=await this.e.provideEvaluatableExpression(Y,de,q);if(be)return I.EvaluatableExpression.from(be)}}class P{constructor(O,H){this.d=O,this.e=H}async provideInlineValues(O,H,q,Y){const de=this.d.getDocument(O),be=await this.e.provideInlineValues(de,I.Range.to(H),I.InlineValueContext.to(q),Y);if(Array.isArray(be))return be.map(Pe=>I.InlineValue.from(Pe))}}class L{constructor(O,H){this.d=O,this.e=H}async provideDocumentHighlights(O,H,q){const Y=this.d.getDocument(O),de=I.Position.to(H),be=await this.e.provideDocumentHighlights(Y,de,q);if(Array.isArray(be))return be.map(I.DocumentHighlight.from)}}class z{constructor(O,H){this.d=O,this.e=H}async provideLinkedEditingRanges(O,H,q){const Y=this.d.getDocument(O),de=I.Position.to(H),be=await this.e.provideLinkedEditingRanges(Y,de,q);if(be&&Array.isArray(be.ranges))return{ranges:(0,R.coalesce)(be.ranges.map(I.Range.from)),wordPattern:be.wordPattern}}}class _{constructor(O,H){this.d=O,this.e=H}async provideReferences(O,H,q,Y){const de=this.d.getDocument(O),be=I.Position.to(H),Pe=await this.e.provideReferences(de,be,q,Y);if(Array.isArray(Pe))return Pe.map(I.location.from)}}class K{constructor(O,H,q,Y,de,be,Pe){this.g=O,this.h=H,this.j=q,this.k=Y,this.l=de,this.m=be,this.n=Pe,this.e=new f.Cache("CodeAction"),this.f=new Map}async provideCodeActions(O,H,q,Y){const de=this.g.getDocument(O),be=E.Selection.isISelection(H)?I.Selection.to(H):I.Range.to(H),Pe=[];for(const et of this.j.getDiagnostics(O))if(be.intersection(et.range)&&Pe.push(et)>K.d)break;const pe={diagnostics:Pe,only:q.only?new A.CodeActionKind(q.only):void 0,triggerKind:I.CodeActionTriggerKind.to(q.trigger)},Ce=await this.k.provideCodeActions(de,be,pe,Y);if(!(0,R.isNonEmptyArray)(Ce)||Y.isCancellationRequested)return;const ke=this.e.add(Ce),je=new v.DisposableStore;this.f.set(ke,je);const Ge=[];for(let et=0;et<Ce.length;et++){const _e=Ce[et];!_e||(K.o(_e)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),Ge.push({_isSynthetic:!0,title:_e.title,command:this.h.toInternal(_e,je)})):(pe.only&&(_e.kind?pe.only.contains(_e.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${_e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ge.push({cacheId:[ke,et],title:_e.title,command:_e.command&&this.h.toInternal(_e.command,je),diagnostics:_e.diagnostics&&_e.diagnostics.map(I.Diagnostic.from),edit:_e.edit&&I.WorkspaceEdit.from(_e.edit,void 0),kind:_e.kind&&_e.kind.value,isPreferred:_e.isPreferred,disabled:_e.disabled?.reason})))}return{cacheId:ke,actions:Ge}}async resolveCodeAction(O,H){const[q,Y]=O,de=this.e.get(q,Y);if(!de||K.o(de)||!this.k.resolveCodeAction)return;const be=await this.k.resolveCodeAction(de,H)??de;return be?.edit?I.WorkspaceEdit.from(be.edit,void 0):void 0}releaseCodeActions(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}static o(O){return typeof O.command=="string"&&typeof O.title=="string"}}K.d=1e3;class F{constructor(O,H,q,Y){this.d=O,this.e=H,this.f=q,this.g=Y}async prepareDocumentPaste(O,H,q,Y){if(!this.f.prepareDocumentPaste)return;const de=this.e.getDocument(O),be=H.map(pe=>I.Range.to(pe)),Pe=I.DataTransfer.toDataTransfer(q,()=>{throw new h.NotImplementedError});return await this.f.prepareDocumentPaste(de,be,Pe,Y),I.DataTransfer.toDataTransferDTO(Pe)}async providePasteEdits(O,H,q,Y,de){const be=this.e.getDocument(H),Pe=q.map(ke=>I.Range.to(ke)),pe=I.DataTransfer.toDataTransfer(Y,async ke=>(await this.d.$resolvePasteFileData(this.g,O,ke)).buffer),Ce=await this.f.provideDocumentPasteEdits(be,Pe,pe,de);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?I.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class M{constructor(O,H){this.d=O,this.e=H}async provideDocumentFormattingEdits(O,H,q){const Y=this.d.getDocument(O),de=await this.e.provideDocumentFormattingEdits(Y,H,q);if(Array.isArray(de))return de.map(I.TextEdit.from)}}class N{constructor(O,H){this.d=O,this.e=H}async provideDocumentRangeFormattingEdits(O,H,q,Y){const de=this.d.getDocument(O),be=I.Range.to(H),Pe=await this.e.provideDocumentRangeFormattingEdits(de,be,q,Y);if(Array.isArray(Pe))return Pe.map(I.TextEdit.from)}}class B{constructor(O,H){this.d=O,this.e=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,H,q,Y,de){const be=this.d.getDocument(O),Pe=I.Position.to(H),pe=await this.e.provideOnTypeFormattingEdits(be,Pe,q,Y,de);if(Array.isArray(pe))return pe.map(I.TextEdit.from)}}class U{constructor(O,H){this.e=O,this.f=H,this.d=new f.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(O,H){const q=await this.e.provideWorkspaceSymbols(O,H);if(!(0,R.isNonEmptyArray)(q))return{symbols:[]};const Y=this.d.add(q),de={cacheId:Y,symbols:[]};for(let be=0;be<q.length;be++){const Pe=q[be];if(!Pe||!Pe.name){this.f.warn("INVALID SymbolInformation",Pe);continue}de.symbols.push({...I.WorkspaceSymbol.from(Pe),cacheId:[Y,be]})}return de}async resolveWorkspaceSymbol(O,H){if(typeof this.e.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const q=this.d.get(...O.cacheId);if(q){const Y=await this.e.resolveWorkspaceSymbol(q,H);return Y&&(0,t.mixin)(O,I.WorkspaceSymbol.from(Y),!0)}}releaseWorkspaceSymbols(O){this.d.delete(O)}}class W{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,H,q){this.d=O,this.e=H,this.f=q}async provideRenameEdits(O,H,q,Y){const de=this.d.getDocument(O),be=I.Position.to(H);try{const Pe=await this.e.provideRenameEdits(de,be,q,Y);return Pe?I.WorkspaceEdit.from(Pe):void 0}catch(Pe){const pe=W.g(Pe);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(Pe)}}async resolveRenameLocation(O,H,q){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Y=this.d.getDocument(O),de=I.Position.to(H);try{const be=await this.e.prepareRename(Y,de,q);let Pe,pe;if(A.Range.isRange(be)?(Pe=be,pe=Y.getText(be)):(0,T.isObject)(be)&&(Pe=be.range,pe=be.placeholder),!Pe||!pe)return;if(Pe.start.line>de.line||Pe.end.line<de.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(Pe),text:pe}}catch(be){const Pe=W.g(be);return Pe?{rejectReason:Pe,range:void 0,text:void 0}:Promise.reject(be)}}static g(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class x{constructor(O,H){this.resultId=O,this.tokens=H}}class V{constructor(O,H){this.f=O,this.g=H,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(O,H,q){const Y=this.f.getDocument(O),de=H!==0?this.d.get(H):null;let be=typeof de?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Y,de.resultId,q):await this.g.provideDocumentSemanticTokens(Y,q);return de&&this.d.delete(H),be?(be=V.h(be),this.o(V.n(de,be),be)):null}async releaseDocumentSemanticColoring(O){this.d.delete(O)}static h(O){return V.j(O)?V.k(O)?O:new A.SemanticTokens(new Uint32Array(O.data),O.resultId):V.l(O)?V.m(O)?O:new A.SemanticTokensEdits(O.edits.map(H=>new A.SemanticTokensEdit(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),O.resultId):O}static j(O){return O&&!!O.data}static k(O){return O.data instanceof Uint32Array}static l(O){return O&&Array.isArray(O.edits)}static m(O){for(const H of O.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static n(O,H){if(!V.j(H)||!O||!O.tokens)return H;const q=O.tokens,Y=q.length,de=H.data,be=de.length;let Pe=0;const pe=Math.min(Y,be);for(;Pe<pe&&q[Pe]===de[Pe];)Pe++;if(Pe===Y&&Pe===be)return new A.SemanticTokensEdits([],H.resultId);let Ce=0;const ke=pe-Pe;for(;Ce<ke&&q[Y-Ce-1]===de[be-Ce-1];)Ce++;return new A.SemanticTokensEdits([{start:Pe,deleteCount:Y-Pe-Ce,data:de.subarray(Pe,be-Ce)}],H.resultId)}o(O,H){if(V.j(O)){const q=this.e++;return this.d.set(q,new x(O.resultId,O.data)),(0,d.encodeSemanticTokensDto)({id:q,type:"full",data:O.data})}if(V.l(O)){const q=this.e++;return V.j(H)?this.d.set(q,new x(H.resultId,H.data)):this.d.set(q,new x(O.resultId)),(0,d.encodeSemanticTokensDto)({id:q,type:"delta",deltas:(O.edits||[]).map(Y=>({start:Y.start,deleteCount:Y.deleteCount,data:Y.data}))})}return null}}class X{constructor(O,H){this.d=O,this.e=H}async provideDocumentRangeSemanticTokens(O,H,q){const Y=this.d.getDocument(O),de=await this.e.provideDocumentRangeSemanticTokens(Y,I.Range.to(H),q);return de?this.f(de):null}f(O){return(0,d.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}class Q{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,H,q,Y,de){this.f=O,this.g=H,this.h=q,this.j=Y,this.k=de,this.d=new f.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(O,H,q,Y){const de=this.f.getDocument(O),be=I.Position.to(H),Pe=de.getWordRangeAtPosition(be)||new A.Range(be,be),pe=Pe.with({end:be}),Ce=new w.StopWatch(!0),ke=await this.h.provideCompletionItems(de,be,Y,I.CompletionContext.to(q));if(!ke||Y.isCancellationRequested)return;const je=Array.isArray(ke)?new A.CompletionList(ke):ke,Ge=Q.supportsResolving(this.h)?this.d.add(je.items):this.d.add([]),et=new v.DisposableStore;this.e.set(Ge,et);const _e=[],nt={x:Ge,b:_e,a:{replace:I.Range.from(Pe),insert:I.Range.from(pe)},c:je.isIncomplete||void 0,d:Ce.elapsed()};for(let st=0;st<je.items.length;st++){const ht=je.items[st],Fe=this.l(ht,[Ge,st],pe,Pe);_e.push(Fe)}return nt}async resolveCompletionItem(O,H){if(typeof this.h.resolveCompletionItem!="function")return;const q=this.d.get(...O);if(!q)return;const Y=await this.h.resolveCompletionItem(q,H);if(!!Y)return this.l(Y,O)}releaseCompletionItems(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,H,q,Y){const de=this.e.get(H[0]);if(!de)throw Error("DisposableStore is missing...");const be=this.g.toInternal(O.command,de),Pe={x:H,a:O.label,b:O.kind!==void 0?I.CompletionItemKind.from(O.kind):void 0,m:O.tags&&O.tags.map(I.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:I.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters?.join(""),l:O.additionalTextEdits&&O.additionalTextEdits.map(I.TextEdit.from),n:be?.$ident,o:be?.id,p:be?.$ident?void 0:be?.arguments};O.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Pe.h=O.textEdit.newText):typeof O.insertText=="string"?Pe.h=O.insertText:O.insertText instanceof A.SnippetString&&(Pe.h=O.insertText.value,Pe.i|=4);let pe;return O.textEdit?pe=O.textEdit.range:O.range&&(pe=O.range),A.Range.isRange(pe)?Pe.j=I.Range.from(pe):pe&&(!q?.isEqual(pe.inserting)||!Y?.isEqual(pe.replacing))&&(Pe.j={insert:I.Range.from(pe.inserting),replace:I.Range.from(pe.replacing)}),Pe}}class J{async provideInlineCompletions(O,H,q,Y){}disposeCompletions(O){}handleDidShowCompletionItem(O,H){}}class te extends J{constructor(O,H,q,Y){super(),this.f=O,this.g=H,this.h=q,this.j=Y,this.d=new le,this.e=(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[D.InlineCompletionTriggerKind.Automatic]:A.InlineCompletionTriggerKind.Automatic,[D.InlineCompletionTriggerKind.Explicit]:A.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(O,H,q,Y){const de=this.g.getDocument(O),be=I.Position.to(H),Pe=await this.h.provideInlineCompletionItems(de,be,{selectedCompletionInfo:q.selectedSuggestionInfo?{range:I.Range.to(q.selectedSuggestionInfo.range),text:q.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[q.triggerKind]},Y);if(!Pe||Y.isCancellationRequested)return;const pe=Array.isArray(Pe)?Pe:Pe.items,Ce=this.e?Array.isArray(Pe)?[]:Pe.commands||[]:[];let ke;return{pid:this.d.createReferenceId({dispose(){ke?.dispose()},items:pe}),items:pe.map((Ge,et)=>{let _e;Ge.command&&(ke||(ke=new v.DisposableStore),_e=this.j.toInternal(Ge.command,ke));const nt=Ge.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Ge.filterText,range:Ge.range?I.Range.from(Ge.range):void 0,command:_e,idx:et,completeBracketPairs:this.e?Ge.completeBracketPairs:!1}}),commands:Ce.map(Ge=>(ke||(ke=new v.DisposableStore),this.j.toInternal(Ge,ke)))}}disposeCompletions(O){this.d.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,H){const q=this.d.get(O)?.items[H];q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(q)}}class le{constructor(){this.d=new Map,this.e=1}createReferenceId(O){const H=this.e++;return this.d.set(H,O),H}disposeReferenceId(O){const H=this.d.get(O);return this.d.delete(O),H}get(O){return this.d.get(O)}}class Z{constructor(O,H){this.e=O,this.f=H,this.d=new f.Cache("SignatureHelp")}async provideSignatureHelp(O,H,q,Y){const de=this.e.getDocument(O),be=I.Position.to(H),Pe=this.g(q),pe=await this.f.provideSignatureHelp(de,be,Y,Pe);if(pe){const Ce=this.d.add([pe]);return{...I.SignatureHelp.from(pe),id:Ce}}}g(O){let H;if(O.activeSignatureHelp){const q=I.SignatureHelp.to(O.activeSignatureHelp),Y=this.d.get(O.activeSignatureHelp.id,0);Y?(H=Y,H.activeSignature=q.activeSignature,H.activeParameter=q.activeParameter):H=q}return{...O,activeSignatureHelp:H}}releaseSignatureHelp(O){this.d.delete(O)}}class ge{constructor(O,H,q,Y,de){this.f=O,this.g=H,this.h=q,this.j=Y,this.k=de,this.d=new f.Cache("InlayHints"),this.e=new Map}async provideInlayHints(O,H,q){const Y=this.f.getDocument(O),de=I.Range.to(H),be=await this.h.provideInlayHints(Y,de,q);if(!Array.isArray(be)||be.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${H}`);return}if(q.isCancellationRequested)return;const Pe=this.d.add(be);this.e.set(Pe,new v.DisposableStore);const pe={hints:[],cacheId:Pe};for(let Ce=0;Ce<be.length;Ce++)this.l(be[Ce],de)&&pe.hints.push(this.m(be[Ce],[Pe,Ce]));return this.j.trace(`[InlayHints] ${pe.hints.length} inlay hints from '${this.k.identifier.value}' for ${H}`),pe}async resolveInlayHint(O,H){if(typeof this.h.resolveInlayHint!="function")return;const q=this.d.get(...O);if(!q)return;const Y=await this.h.resolveInlayHint(q,H);if(!!Y&&!!this.l(Y))return this.m(Y,O)}releaseHints(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,H){return O.label.length===0||Array.isArray(O.label)&&O.label.every(q=>q.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(H&&!H.contains(O.position))}m(O,H){const q=this.e.get(H[0]);if(!q)throw Error("DisposableStore is missing...");const Y={label:"",cacheId:H,tooltip:I.MarkdownString.fromStrict(O.tooltip),position:I.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(I.TextEdit.from),kind:O.kind&&I.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?Y.label=O.label:Y.label=O.label.map(de=>{const be={label:de.value};return be.tooltip=I.MarkdownString.fromStrict(de.tooltip),A.Location.isLocation(de.location)&&(be.location=I.location.from(de.location)),de.command&&(be.command=this.g.toInternal(de.command,q)),be}),Y}}class ve{constructor(O,H){this.e=O,this.f=H,this.d=new f.Cache("DocumentLink")}async provideLinks(O,H){const q=this.e.getDocument(O),Y=await this.f.provideDocumentLinks(q,H);if(!(!Array.isArray(Y)||Y.length===0)&&!H.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Y.filter(ve.g).map(I.DocumentLink.from)};{const de=this.d.add(Y),be={links:[],cacheId:de};for(let Pe=0;Pe<Y.length;Pe++){if(!ve.g(Y[Pe]))continue;const pe=I.DocumentLink.from(Y[Pe]);pe.cacheId=[de,Pe],be.links.push(pe)}return be}}}static g(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,H){if(typeof this.f.resolveDocumentLink!="function")return;const q=this.d.get(...O);if(!q)return;const Y=await this.f.resolveDocumentLink(q,H);if(!(!Y||!ve.g(Y)))return I.DocumentLink.from(Y)}releaseLinks(O){this.d.delete(O)}}class De{constructor(O,H){this.d=O,this.e=H}async provideColors(O,H){const q=this.d.getDocument(O),Y=await this.e.provideDocumentColors(q,H);return Array.isArray(Y)?Y.map(be=>({color:I.Color.from(be.color),range:I.Range.from(be.range)})):[]}async provideColorPresentations(O,H,q){const Y=this.d.getDocument(O),de=I.Range.to(H.range),be=I.Color.to(H.color),Pe=await this.e.provideColorPresentations(be,{document:Y,range:de},q);if(!!Array.isArray(Pe))return Pe.map(I.ColorPresentation.from)}}class Re{constructor(O,H){this.d=O,this.e=H}async provideFoldingRanges(O,H,q){const Y=this.d.getDocument(O),de=await this.e.provideFoldingRanges(Y,H,q);if(!!Array.isArray(de))return de.map(I.FoldingRange.from)}}class ze{constructor(O,H,q){this.d=O,this.e=H,this.f=q}async provideSelectionRanges(O,H,q){const Y=this.d.getDocument(O),de=H.map(I.Position.to),be=await this.e.provideSelectionRanges(Y,de,q);if(!(0,R.isNonEmptyArray)(be))return[];if(be.length!==de.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Pe=[];for(let pe=0;pe<de.length;pe++){const Ce=[];Pe.push(Ce);let ke=de[pe],je=be[pe];for(;;){if(!je.range.contains(ke))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(I.SelectionRange.from(je)),!je.parent)break;ke=je.range,je=je.parent}}return Pe}}class se{constructor(O,H){this.f=O,this.g=H,this.d=new b.IdGenerator(""),this.e=new Map}async prepareSession(O,H,q){const Y=this.f.getDocument(O),de=I.Position.to(H),be=await this.g.prepareCallHierarchy(Y,de,q);if(!be)return;const Pe=this.d.nextId();return this.e.set(Pe,new Map),Array.isArray(be)?be.map(pe=>this.h(Pe,pe)):[this.h(Pe,be)]}async provideCallsTo(O,H,q){const Y=this.j(O,H);if(!Y)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyIncomingCalls(Y,q);if(!!de)return de.map(be=>({from:this.h(O,be.from),fromRanges:be.fromRanges.map(Pe=>I.Range.from(Pe))}))}async provideCallsFrom(O,H,q){const Y=this.j(O,H);if(!Y)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyOutgoingCalls(Y,q);if(!!de)return de.map(be=>({to:this.h(O,be.to),fromRanges:be.fromRanges.map(Pe=>I.Range.from(Pe))}))}releaseSession(O){this.e.delete(O)}h(O,H){const q=this.e.get(O),Y=I.CallHierarchyItem.from(H,O,q.size.toString(36));return q.set(Y._itemId,H),Y}j(O,H){return this.e.get(O)?.get(H)}}class ue{constructor(O,H){this.f=O,this.g=H,this.d=new b.IdGenerator(""),this.e=new Map}async prepareSession(O,H,q){const Y=this.f.getDocument(O),de=I.Position.to(H),be=await this.g.prepareTypeHierarchy(Y,de,q);if(!be)return;const Pe=this.d.nextId();return this.e.set(Pe,new Map),Array.isArray(be)?be.map(pe=>this.h(Pe,pe)):[this.h(Pe,be)]}async provideSupertypes(O,H,q){const Y=this.j(O,H);if(!Y)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySupertypes(Y,q);if(!!de)return de.map(be=>this.h(O,be))}async provideSubtypes(O,H,q){const Y=this.j(O,H);if(!Y)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySubtypes(Y,q);if(!!de)return de.map(be=>this.h(O,be))}releaseSession(O){this.e.delete(O)}h(O,H){const q=this.e.get(O),Y=I.TypeHierarchyItem.from(H,O,q.size.toString(36));return q.set(Y._itemId,H),Y}j(O,H){return this.e.get(O)?.get(H)}}class he{constructor(O,H,q,Y){this.d=O,this.e=H,this.f=q,this.g=Y}async provideDocumentOnDropEdits(O,H,q,Y,de){const be=this.e.getDocument(H),Pe=I.Position.to(q),pe=I.DataTransfer.toDataTransfer(Y,async ke=>(await this.d.$resolveDocumentOnDropFileData(this.g,O,ke)).buffer),Ce=await this.f.provideDocumentDropEdits(be,Pe,pe,de);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?I.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class ee{constructor(O,H){this.adapter=O,this.extension=H}}class oe{constructor(O,H,q,Y,de,be,Pe,pe){this.g=H,this.h=q,this.j=Y,this.k=de,this.l=be,this.m=Pe,this.n=pe,this.f=new Map,this.e=O.getProxy(k.MainContext.MainThreadLanguageFeatures)}o(O){return I.DocumentSelector.from(O,this.g)}p(O){return new A.Disposable(()=>{this.f.delete(O),this.e.$unregister(O)})}q(){return oe.d++}async s(O,H,q,Y,de,be=!1){const Pe=this.f.get(O);if(!Pe||!(Pe.adapter instanceof H))return Y;const pe=Date.now();be||this.l.trace(`[${Pe.extension.identifier.value}] INVOKE provider '${q.toString().replace(/[\r\n]/g,"")}'`);const Ce=q(Pe.adapter,Pe.extension);return Promise.resolve(Ce).catch(ke=>{(0,h.isCancellationError)(ke)||(this.l.error(`[${Pe.extension.identifier.value}] provider FAILED`),this.l.error(ke),this.n.onExtensionError(Pe.extension.identifier,ke))}).finally(()=>{be||this.l.trace(`[${Pe.extension.identifier.value}] provider DONE after ${Date.now()-pe}ms`)}),y.CancellationToken.isCancellationToken(de)?(0,m.raceCancellationError)(Ce,de):Ce}t(O,H){const q=this.q();return this.f.set(q,new ee(O,H)),q}static u(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,H,q,Y){const de=this.t(new o(this.h,q),O),be=Y&&Y.label||oe.u(O);return this.e.$registerDocumentSymbolProvider(de,this.o(H),be),this.p(de)}$provideDocumentSymbols(O,H,q){return this.s(O,o,Y=>Y.provideDocumentSymbols(a.URI.revive(H),q),void 0,q)}registerCodeLensProvider(O,H,q){const Y=this.q(),de=typeof q.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Y,new ee(new i(this.h,this.j.converter,q),O)),this.e.$registerCodeLensSupport(Y,this.o(H),de);let be=this.p(Y);if(de!==void 0){const Pe=q.onDidChangeCodeLenses(pe=>this.e.$emitCodeLensEvent(de));be=A.Disposable.from(be,Pe)}return be}$provideCodeLenses(O,H,q){return this.s(O,i,Y=>Y.provideCodeLenses(a.URI.revive(H),q),void 0,q)}$resolveCodeLens(O,H,q){return this.s(O,i,Y=>Y.resolveCodeLens(H,q),void 0,void 0)}$releaseCodeLenses(O,H){this.s(O,i,q=>Promise.resolve(q.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(O,H,q){const Y=this.t(new u(this.h,q),O);return this.e.$registerDefinitionSupport(Y,this.o(H)),this.p(Y)}$provideDefinition(O,H,q,Y){return this.s(O,u,de=>de.provideDefinition(a.URI.revive(H),q,Y),[],Y)}registerDeclarationProvider(O,H,q){const Y=this.t(new s(this.h,q),O);return this.e.$registerDeclarationSupport(Y,this.o(H)),this.p(Y)}$provideDeclaration(O,H,q,Y){return this.s(O,s,de=>de.provideDeclaration(a.URI.revive(H),q,Y),[],Y)}registerImplementationProvider(O,H,q){const Y=this.t(new c(this.h,q),O);return this.e.$registerImplementationSupport(Y,this.o(H)),this.p(Y)}$provideImplementation(O,H,q,Y){return this.s(O,c,de=>de.provideImplementation(a.URI.revive(H),q,Y),[],Y)}registerTypeDefinitionProvider(O,H,q){const Y=this.t(new n(this.h,q),O);return this.e.$registerTypeDefinitionSupport(Y,this.o(H)),this.p(Y)}$provideTypeDefinition(O,H,q,Y){return this.s(O,n,de=>de.provideTypeDefinition(a.URI.revive(H),q,Y),[],Y)}registerHoverProvider(O,H,q,Y){const de=this.t(new r(this.h,q),O);return this.e.$registerHoverProvider(de,this.o(H)),this.p(de)}$provideHover(O,H,q,Y){return this.s(O,r,de=>de.provideHover(a.URI.revive(H),q,Y),void 0,Y)}registerEvaluatableExpressionProvider(O,H,q,Y){const de=this.t(new g(this.h,q),O);return this.e.$registerEvaluatableExpressionProvider(de,this.o(H)),this.p(de)}$provideEvaluatableExpression(O,H,q,Y){return this.s(O,g,de=>de.provideEvaluatableExpression(a.URI.revive(H),q,Y),void 0,Y)}registerInlineValuesProvider(O,H,q,Y){const de=typeof q.onDidChangeInlineValues=="function"?this.q():void 0,be=this.t(new P(this.h,q),O);this.e.$registerInlineValuesProvider(be,this.o(H),de);let Pe=this.p(be);if(de!==void 0){const pe=q.onDidChangeInlineValues(Ce=>this.e.$emitInlineValuesEvent(de));Pe=A.Disposable.from(Pe,pe)}return Pe}$provideInlineValues(O,H,q,Y,de){return this.s(O,P,be=>be.provideInlineValues(a.URI.revive(H),q,Y,de),void 0,de)}registerDocumentHighlightProvider(O,H,q){const Y=this.t(new L(this.h,q),O);return this.e.$registerDocumentHighlightProvider(Y,this.o(H)),this.p(Y)}$provideDocumentHighlights(O,H,q,Y){return this.s(O,L,de=>de.provideDocumentHighlights(a.URI.revive(H),q,Y),void 0,Y)}registerLinkedEditingRangeProvider(O,H,q){const Y=this.t(new z(this.h,q),O);return this.e.$registerLinkedEditingRangeProvider(Y,this.o(H)),this.p(Y)}$provideLinkedEditingRanges(O,H,q,Y){return this.s(O,z,async de=>{const be=await de.provideLinkedEditingRanges(a.URI.revive(H),q,Y);if(be)return{ranges:be.ranges,wordPattern:be.wordPattern?oe.w(be.wordPattern):void 0}},void 0,Y)}registerReferenceProvider(O,H,q){const Y=this.t(new _(this.h,q),O);return this.e.$registerReferenceSupport(Y,this.o(H)),this.p(Y)}$provideReferences(O,H,q,Y,de){return this.s(O,_,be=>be.provideReferences(a.URI.revive(H),q,Y,de),void 0,de)}registerCodeActionProvider(O,H,q,Y){const de=new v.DisposableStore,be=this.t(new K(this.h,this.j.converter,this.k,q,this.l,O,this.m),O);return this.e.$registerQuickFixSupport(be,this.o(H),{providedKinds:Y?.providedCodeActionKinds?.map(Pe=>Pe.value),documentation:Y?.documentation?.map(Pe=>({kind:Pe.kind.value,command:this.j.converter.toInternal(Pe.command,de)}))},oe.u(O),Boolean(q.resolveCodeAction)),de.add(this.p(be)),de}$provideCodeActions(O,H,q,Y,de){return this.s(O,K,be=>be.provideCodeActions(a.URI.revive(H),q,Y,de),void 0,de)}$resolveCodeAction(O,H,q){return this.s(O,K,Y=>Y.resolveCodeAction(H,q),void 0,void 0)}$releaseCodeActions(O,H){this.s(O,K,q=>Promise.resolve(q.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(O,H,q){const Y=this.t(new M(this.h,q),O);return this.e.$registerDocumentFormattingSupport(Y,this.o(H),O.identifier,O.displayName||O.name),this.p(Y)}$provideDocumentFormattingEdits(O,H,q,Y){return this.s(O,M,de=>de.provideDocumentFormattingEdits(a.URI.revive(H),q,Y),void 0,Y)}registerDocumentRangeFormattingEditProvider(O,H,q){const Y=this.t(new N(this.h,q),O);return this.e.$registerRangeFormattingSupport(Y,this.o(H),O.identifier,O.displayName||O.name),this.p(Y)}$provideDocumentRangeFormattingEdits(O,H,q,Y,de){return this.s(O,N,be=>be.provideDocumentRangeFormattingEdits(a.URI.revive(H),q,Y,de),void 0,de)}registerOnTypeFormattingEditProvider(O,H,q,Y){const de=this.t(new B(this.h,q),O);return this.e.$registerOnTypeFormattingSupport(de,this.o(H),Y,O.identifier),this.p(de)}$provideOnTypeFormattingEdits(O,H,q,Y,de,be){return this.s(O,B,Pe=>Pe.provideOnTypeFormattingEdits(a.URI.revive(H),q,Y,de,be),void 0,be)}registerWorkspaceSymbolProvider(O,H){const q=this.t(new U(H,this.l),O);return this.e.$registerNavigateTypeSupport(q,typeof H.resolveWorkspaceSymbol=="function"),this.p(q)}$provideWorkspaceSymbols(O,H,q){return this.s(O,U,Y=>Y.provideWorkspaceSymbols(H,q),{symbols:[]},q)}$resolveWorkspaceSymbol(O,H,q){return this.s(O,U,Y=>Y.resolveWorkspaceSymbol(H,q),void 0,void 0)}$releaseWorkspaceSymbols(O,H){this.s(O,U,q=>q.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(O,H,q){const Y=this.t(new W(this.h,q,this.l),O);return this.e.$registerRenameSupport(Y,this.o(H),W.supportsResolving(q)),this.p(Y)}$provideRenameEdits(O,H,q,Y,de){return this.s(O,W,be=>be.provideRenameEdits(a.URI.revive(H),q,Y,de),void 0,de)}$resolveRenameLocation(O,H,q,Y){return this.s(O,W,de=>de.resolveRenameLocation(a.URI.revive(H),q,Y),void 0,Y)}registerDocumentSemanticTokensProvider(O,H,q,Y){const de=this.t(new V(this.h,q),O),be=typeof q.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(de,this.o(H),Y,be);let Pe=this.p(de);if(be){const pe=q.onDidChangeSemanticTokens(Ce=>this.e.$emitDocumentSemanticTokensEvent(be));Pe=A.Disposable.from(Pe,pe)}return Pe}$provideDocumentSemanticTokens(O,H,q,Y){return this.s(O,V,de=>de.provideDocumentSemanticTokens(a.URI.revive(H),q,Y),null,Y)}$releaseDocumentSemanticTokens(O,H){this.s(O,V,q=>q.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,H,q,Y){const de=this.t(new X(this.h,q),O);return this.e.$registerDocumentRangeSemanticTokensProvider(de,this.o(H),Y),this.p(de)}$provideDocumentRangeSemanticTokens(O,H,q,Y){return this.s(O,X,de=>de.provideDocumentRangeSemanticTokens(a.URI.revive(H),q,Y),null,Y)}registerCompletionItemProvider(O,H,q,Y){const de=this.t(new Q(this.h,this.j.converter,q,this.m,O),O);return this.e.$registerCompletionsProvider(de,this.o(H),Y,Q.supportsResolving(q),`${O.identifier.value}(${Y.join("")})`),this.p(de)}$provideCompletionItems(O,H,q,Y,de){return this.s(O,Q,be=>be.provideCompletionItems(a.URI.revive(H),q,Y,de),void 0,de)}$resolveCompletionItem(O,H,q){return this.s(O,Q,Y=>Y.resolveCompletionItem(H,q),void 0,q)}$releaseCompletionItems(O,H){this.s(O,Q,q=>q.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(O,H,q){const Y=new te(O,this.h,q,this.j.converter),de=this.t(Y,O);return this.e.$registerInlineCompletionsSupport(de,this.o(H),Y.supportsHandleDidShowCompletionItem),this.p(de)}$provideInlineCompletions(O,H,q,Y,de){return this.s(O,J,be=>be.provideInlineCompletions(a.URI.revive(H),q,Y,de),void 0,de)}$handleInlineCompletionDidShow(O,H,q){this.s(O,J,async Y=>{Y.handleDidShowCompletionItem(H,q)},void 0,void 0)}$freeInlineCompletionsList(O,H){this.s(O,J,async q=>{q.disposeCompletions(H)},void 0,void 0)}registerSignatureHelpProvider(O,H,q,Y){const de=Array.isArray(Y)?{triggerCharacters:Y,retriggerCharacters:[]}:Y,be=this.t(new Z(this.h,q),O);return this.e.$registerSignatureHelpProvider(be,this.o(H),de),this.p(be)}$provideSignatureHelp(O,H,q,Y,de){return this.s(O,Z,be=>be.provideSignatureHelp(a.URI.revive(H),q,Y,de),void 0,de)}$releaseSignatureHelp(O,H){this.s(O,Z,q=>q.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(O,H,q){const Y=typeof q.onDidChangeInlayHints=="function"?this.q():void 0,de=this.t(new ge(this.h,this.j.converter,q,this.l,O),O);this.e.$registerInlayHintsProvider(de,this.o(H),typeof q.resolveInlayHint=="function",Y,oe.u(O));let be=this.p(de);if(Y!==void 0){const Pe=q.onDidChangeInlayHints(pe=>this.e.$emitInlayHintsEvent(Y));be=A.Disposable.from(be,Pe)}return be}$provideInlayHints(O,H,q,Y){return this.s(O,ge,de=>de.provideInlayHints(a.URI.revive(H),q,Y),void 0,Y)}$resolveInlayHint(O,H,q){return this.s(O,ge,Y=>Y.resolveInlayHint(H,q),void 0,q)}$releaseInlayHints(O,H){this.s(O,ge,q=>q.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(O,H,q){const Y=this.t(new ve(this.h,q),O);return this.e.$registerDocumentLinkProvider(Y,this.o(H),typeof q.resolveDocumentLink=="function"),this.p(Y)}$provideDocumentLinks(O,H,q){return this.s(O,ve,Y=>Y.provideLinks(a.URI.revive(H),q),void 0,q,H.scheme==="output")}$resolveDocumentLink(O,H,q){return this.s(O,ve,Y=>Y.resolveLink(H,q),void 0,void 0,!0)}$releaseDocumentLinks(O,H){this.s(O,ve,q=>q.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(O,H,q){const Y=this.t(new De(this.h,q),O);return this.e.$registerDocumentColorProvider(Y,this.o(H)),this.p(Y)}$provideDocumentColors(O,H,q){return this.s(O,De,Y=>Y.provideColors(a.URI.revive(H),q),[],q)}$provideColorPresentations(O,H,q,Y){return this.s(O,De,de=>de.provideColorPresentations(a.URI.revive(H),q,Y),void 0,Y)}registerFoldingRangeProvider(O,H,q){const Y=this.q(),de=typeof q.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Y,new ee(new Re(this.h,q),O)),this.e.$registerFoldingRangeProvider(Y,this.o(H),O.identifier,de);let be=this.p(Y);if(de!==void 0){const Pe=q.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(de));be=A.Disposable.from(be,Pe)}return be}$provideFoldingRanges(O,H,q,Y){return this.s(O,Re,de=>de.provideFoldingRanges(a.URI.revive(H),q,Y),void 0,Y)}registerSelectionRangeProvider(O,H,q){const Y=this.t(new ze(this.h,q,this.l),O);return this.e.$registerSelectionRangeProvider(Y,this.o(H)),this.p(Y)}$provideSelectionRanges(O,H,q,Y){return this.s(O,ze,de=>de.provideSelectionRanges(a.URI.revive(H),q,Y),[],Y)}registerCallHierarchyProvider(O,H,q){const Y=this.t(new se(this.h,q),O);return this.e.$registerCallHierarchyProvider(Y,this.o(H)),this.p(Y)}$prepareCallHierarchy(O,H,q,Y){return this.s(O,se,de=>Promise.resolve(de.prepareSession(a.URI.revive(H),q,Y)),void 0,Y)}$provideCallHierarchyIncomingCalls(O,H,q,Y){return this.s(O,se,de=>de.provideCallsTo(H,q,Y),void 0,Y)}$provideCallHierarchyOutgoingCalls(O,H,q,Y){return this.s(O,se,de=>de.provideCallsFrom(H,q,Y),void 0,Y)}$releaseCallHierarchy(O,H){this.s(O,se,q=>Promise.resolve(q.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(O,H,q){const Y=this.t(new ue(this.h,q),O);return this.e.$registerTypeHierarchyProvider(Y,this.o(H)),this.p(Y)}$prepareTypeHierarchy(O,H,q,Y){return this.s(O,ue,de=>Promise.resolve(de.prepareSession(a.URI.revive(H),q,Y)),void 0,Y)}$provideTypeHierarchySupertypes(O,H,q,Y){return this.s(O,ue,de=>de.provideSupertypes(H,q,Y),void 0,Y)}$provideTypeHierarchySubtypes(O,H,q,Y){return this.s(O,ue,de=>de.provideSubtypes(H,q,Y),void 0,Y)}$releaseTypeHierarchy(O,H){this.s(O,ue,q=>Promise.resolve(q.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(O,H,q){const Y=this.q();return this.f.set(Y,new ee(new he(this.e,this.h,q,Y),O)),this.e.$registerDocumentOnDropEditProvider(Y,this.o(H)),this.p(Y)}$provideDocumentOnDropEdits(O,H,q,Y,de,be){return this.s(O,he,Pe=>Promise.resolve(Pe.provideDocumentOnDropEdits(H,a.URI.revive(q),Y,de,be)),void 0,void 0)}registerDocumentPasteEditProvider(O,H,q,Y){const de=this.q();return this.f.set(de,new ee(new F(this.e,this.h,q,de),O)),this.e.$registerPasteEditProvider(de,this.o(H),!!q.prepareDocumentPaste,Y.pasteMimeTypes),this.p(de)}$prepareDocumentPaste(O,H,q,Y,de){return this.s(O,F,be=>be.prepareDocumentPaste(a.URI.revive(H),q,Y,de),void 0,de)}$providePasteEdits(O,H,q,Y,de,be){return this.s(O,F,Pe=>Pe.providePasteEdits(H,a.URI.revive(q),Y,de,be),void 0,be)}static w(O){return{pattern:O.source,flags:(0,S.regExpFlags)(O)}}static y(O){return{decreaseIndentPattern:oe.w(O.decreaseIndentPattern),increaseIndentPattern:oe.w(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?oe.w(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?oe.w(O.unIndentedLinePattern):void 0}}static z(O){return{beforeText:oe.w(O.beforeText),afterText:O.afterText?oe.w(O.afterText):void 0,previousLineText:O.previousLineText?oe.w(O.previousLineText):void 0,action:O.action}}static B(O){return O.map(oe.z)}setLanguageConfiguration(O,H,q){const{wordPattern:Y}=q;if(Y&&(0,S.regExpLeadsToEndlessLoop)(Y))throw new Error(`Invalid language configuration: wordPattern '${Y}' is not allowed to match the empty string.`);Y?this.h.setWordDefinitionFor(H,Y):this.h.setWordDefinitionFor(H,void 0),q.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),q.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const de=this.q(),be={comments:q.comments,brackets:q.brackets,wordPattern:q.wordPattern?oe.w(q.wordPattern):void 0,indentationRules:q.indentationRules?oe.y(q.indentationRules):void 0,onEnterRules:q.onEnterRules?oe.B(q.onEnterRules):void 0,__electricCharacterSupport:q.__electricCharacterSupport,__characterPairSupport:q.__characterPairSupport};return this.e.$setLanguageConfiguration(de,H,be),this.p(de)}$setWordDefinitions(O){for(const H of O)this.h.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}e.ExtHostLanguageFeatures=oe,oe.d=0}),define(Se[256],ye([1,0,5,14,7,42,18,6]),function(ne,e,a,t,I,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(R,T,E,y){this.c=T,this.d=E,this.e=y,this.b=[],this.f=0,this.g=new Set,this.a=R.getProxy(a.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this.b=R}async getLanguages(){return this.b.slice(0)}async changeLanguage(R,T){await this.a.$changeLanguage(R,T);const E=this.c.getDocumentData(R);if(!E)throw new Error(`document '${R.toString()}' NOT found`);return E.document}async tokenAtPosition(R,T){const E=R.version,y=t.Position.from(T),v=await this.a.$tokensAtPosition(R.uri,y),d={type:I.StandardTokenType.Other,range:R.getWordRangeAtPosition(T)??new I.Range(T.line,T.character,T.line,T.character)};if(!v)return d;const b={range:t.Range.to(v.range),type:t.TokenType.to(v.type)};return!b.range.contains(T)||E!==R.version?d:b}createLanguageStatusItem(R,T,E){const y=this.f++,v=this.a,d=this.g,b=`${R.identifier.value}/${T}`;if(d.has(b))throw new Error(`LanguageStatusItem with id '${T}' ALREADY exists`);d.add(b);const f={selector:E,id:T,name:R.displayName??R.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let w;const h=new k.DisposableStore,m=()=>{w?.dispose(),w=(0,D.disposableTimeout)(()=>{h.clear(),this.a.$setLanguageStatus(y,{id:b,name:f.name??R.displayName??R.name,source:R.displayName??R.name,selector:t.DocumentSelector.from(f.selector,this.e),label:f.text,detail:f.detail??"",severity:f.severity===I.LanguageStatusSeverity.Error?A.default.Error:f.severity===I.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:f.command&&this.d.toInternal(f.command,h),accessibilityInfo:f.accessibilityInformation,busy:f.busy})},0)},p={dispose(){h.dispose(),w?.dispose(),v.$removeLanguageStatus(y),d.delete(b)},get id(){return f.id},get name(){return f.name},set name(o){f.name=o,m()},get selector(){return f.selector},set selector(o){f.selector=o,m()},get text(){return f.text},set text(o){f.text=o,m()},get detail(){return f.detail},set detail(o){f.detail=o,m()},get severity(){return f.severity},set severity(o){f.severity=o,m()},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(o){f.accessibilityInformation=o,m()},get command(){return f.command},set command(o){f.command=o,m()},get busy(){return f.busy},set busy(o){f.busy=o,m()}};return m(),p}}e.ExtHostLanguages=S}),define(Se[95],ye([1,0,12,8,2,3,13,5,25,16]),function(ne,e,a,t,I,A,D,k,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let R=class{constructor(E,y,v){this.f=v,this.d=new Map,this.a=y.getProxy(k.MainContext.MainThreadLocalization),this.b=E.environment.appLanguage,this.c=this.b===a.LANGUAGE_DEFAULT}getMessage(E,y){const{message:v,args:d,comment:b}=y;if(this.c)return(0,t.format2)(v,d??{});let f=v;b&&b.length>0&&(f+=`/${Array.isArray(b)?b.join():b}`);const w=this.d.get(E)?.contents[f];return w||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${f}`),(0,t.format2)(w??v,d??{})}getBundle(E){return this.d.get(E)?.contents}getBundleUri(E){return this.d.get(E)?.uri}async initializeLocalizedMessages(E){if(this.c||!E.l10n&&!E.isBuiltin||this.d.has(E.identifier.value))return;let y;const v=await this.g(E);if(!v){this.f.error(`No bundle location found for extension ${E.identifier.value}`);return}try{const d=await this.a.$fetchBundleContents(v),b=JSON.parse(d);y=E.isBuiltin?b.contents?.bundle:b}catch(d){this.f.error(`Failed to load translations for ${E.identifier.value} from ${v}: ${d.message}`);return}y&&this.d.set(E.identifier.value,{contents:y,uri:v})}async g(E){if(E.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri(E.identifier.value);return I.URI.revive(y)}return E.l10n?I.URI.joinPath(E.extensionLocation,E.l10n,`bundle.l10n.${this.b}.json`):void 0}};R=qe([We(0,S.IExtHostInitDataService),We(1,C.IExtHostRpcService),We(2,D.ILogService)],R),e.ExtHostLocalizationService=R,e.IExtHostLocalizationService=(0,A.createDecorator)("IExtHostLocalizationService")}),define(Se[140],ye([1,0,13,5,25,16,2,4,11]),function(ne,e,a,t,I,A,D,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let C=class extends a.AbstractLoggerService{constructor(E,y){super(y.logLevel,k.Event.None),this.g=E.getProxy(t.MainContext.MainThreadLogger)}$setLevel(E,y){y?this.setLevel(D.URI.revive(y),E):(0,S.isUndefined)(E)||this.setLevel(E)}f(E,y,v){return new R(this.g,E,y,v)}};C=qe([We(0,A.IExtHostRpcService),We(1,I.IExtHostInitDataService)],C),e.ExtHostLoggerService=C;class R extends a.AbstractMessageLogger{constructor(E,y,v,d){super(d?.always),this.m=E,this.n=y,this.k=!1,this.l=[],this.setLevel(v),this.m.$createLogger(y,d).then(()=>{this.r(this.l),this.k=!0})}g(E,y){const v=[[E,y]];this.k?this.r(v):this.l.push(...v)}r(E){this.m.$log(this.n,E)}}}),define(Se[257],ye([1,0,5,13,26]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(k){return k&&k.title}let D=class{constructor(S,C){this.b=C,this.a=S.getProxy(a.MainContext.MainThreadMessageService)}showMessage(S,C,R,T,E){const y={source:{identifier:S.identifier,label:S.displayName||S.name}};let v;typeof T=="string"||A(T)?v=[T,...E]:(y.modal=T?.modal,y.useCustom=T?.useCustom,y.detail=T?.detail,v=E),y.useCustom&&(0,I.checkProposedApiEnabled)(S,"resolvers");const d=[];for(let b=0;b<v.length;b++){const f=v[b];if(typeof f=="string")d.push({title:f,handle:b,isCloseAffordance:!1});else if(typeof f=="object"){const{title:w,isCloseAffordance:h}=f;d.push({title:w,isCloseAffordance:!!h,handle:b})}else this.b.warn("Invalid message item:",f)}return this.a.$showMessage(C,R,y,d).then(b=>{if(typeof b=="number")return v[b]})}};D=qe([We(1,t.ILogService)],D),e.ExtHostMessageService=D}),define(Se[258],ye([1,0,22,4,6,28,8,11,2,68,5,39,14,7,57,233,136]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class f{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(h=>h.apiEditor)}constructor(h,m,p,o){this.q=p,this.r=o,this.f=new Map,this.g=new A.ResourceMap,this.h=new Map,this.j=new t.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new t.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new t.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=h.getProxy(R.MainContext.MainThreadNotebook),this.c=h.getProxy(R.MainContext.MainThreadNotebookDocuments),this.d=h.getProxy(R.MainContext.MainThreadNotebookEditors),this.i=m.converter,m.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===13){const l=i.notebookEditor?.notebookUri,u=i.cell.handle,c=this.g.get(l)?.getCell(u);if(c)return c.apiCell}if(i&&i.$mid===14){const l=i.uri,u=this.g.get(l);if(u)return u.apiNotebook}return i}}),f.x(m)}getEditorById(h){const m=this.h.get(h);if(!m)throw new Error(`unknown text editor: ${h}. known editors: ${[...this.h.keys()]} `);return m}getIdByEditor(h){for(const[m,p]of this.h)if(p.apiEditor===h)return m}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(h,m){const p=this.g.get(h);if(!p&&!m)throw new Error(`NO notebook document for '${h}'`);return p}static s(h,m){if(!m)return;const p=m.filenamePattern.map(o=>E.NotebookExclusiveDocumentPattern.from(o)).filter(o=>o!==void 0);if(m.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${m.filenamePattern}`);return}return{extension:h.identifier,providerDisplayName:h.displayName||h.name,displayName:m.displayName,filenamePattern:p,exclusive:m.exclusive||!1}}registerNotebookCellStatusBarItemProvider(h,m,p){const o=f.a++,i=typeof p.onDidChangeCellStatusBarItems=="function"?f.a++:void 0;this.f.set(o,p),this.b.$registerNotebookCellStatusBarItemProvider(o,i,m);let l;return i!==void 0&&(l=p.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(i))),new y.Disposable(()=>{this.f.delete(o),this.b.$unregisterNotebookCellStatusBarItemProvider(o,i),l?.dispose()})}async createNotebookDocument(h){const m=await this.c.$tryCreateNotebook({viewType:h.viewType,content:h.content&&E.NotebookData.from(h.content)});return S.URI.revive(m)}async openNotebookDocument(h){const m=this.g.get(h);if(m)return m.apiNotebook;const p=await this.c.$tryOpenNotebook(h),o=this.g.get(S.URI.revive(p));return(0,k.assertIsDefined)(o?.apiNotebook)}async showNotebookDocument(h,m){S.URI.isUri(h)&&(h=await this.openNotebookDocument(h));let p;typeof m=="object"?p={position:E.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus,selections:m.selections&&m.selections.map(E.NotebookRange.from),pinned:typeof m.preview=="boolean"?!m.preview:void 0}:p={preserveFocus:!1};const o=await this.d.$tryShowNotebookDocument(h.uri,h.notebookType,p),i=o&&this.h.get(o)?.apiEditor;if(i)return i;throw o?new Error(`Could NOT open editor for "${h.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${h.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(h,m,p,o){const i=this.f.get(h),l=S.URI.revive(m),u=this.g.get(l);if(!u||!i)return;const s=u.getCellFromIndex(p);if(!s)return;const c=await i.provideCellStatusBarItems(s.apiCell,o);if(!c)return;const n=new I.DisposableStore,r=this.p.add([n]),P=(Array.isArray(c)?c:[c]).map(L=>E.NotebookStatusBarItem.from(L,this.i,n));return{cacheId:r,items:P}}$releaseNotebookCellStatusBarItems(h){this.p.delete(h)}registerNotebookSerializer(h,m,p,o,i){if((0,D.isFalsyOrWhitespace)(m))throw new Error("viewType cannot be empty or just whitespace");const l=this.t++;return this.u.set(l,p),this.b.$registerNotebookSerializer(l,{id:h.identifier,location:h.extensionLocation},m,E.NotebookDocumentContentOptions.from(o),f.s(h,i)),(0,I.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(l)})}async $dataToNotebook(h,m,p){const o=this.u.get(h);if(!o)throw new Error("NO serializer found");const i=await o.deserializeNotebook(m.buffer,p);return new v.SerializableObjectWithBuffers(E.NotebookData.from(i))}async $notebookToData(h,m,p){const o=this.u.get(h);if(!o)throw new Error("NO serializer found");const i=await o.serializeNotebook(E.NotebookData.to(m.value),p);return a.VSBuffer.wrap(i)}w(h,m,p){if(this.h.has(m))throw new Error(`editor with id ALREADY EXSIST: ${m}`);const o=new b.ExtHostNotebookEditor(m,this.d,h,p.visibleRanges.map(E.NotebookRange.to),p.selections.map(E.NotebookRange.to),typeof p.viewColumn=="number"?E.ViewColumn.to(p.viewColumn):void 0);this.h.set(m,o)}$acceptDocumentAndEditorsDelta(h){if(h.value.removedDocuments)for(const p of h.value.removedDocuments){const o=S.URI.revive(p),i=this.g.get(o);i&&(i.dispose(),this.g.delete(o),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:i.apiNotebook.getCells().map(l=>l.document.uri)}),this.n.fire(i.apiNotebook));for(const l of this.h.values())l.notebookData.uri.toString()===o.toString()&&this.h.delete(l.id)}if(h.value.addedDocuments){const p=[];for(const o of h.value.addedDocuments){const i=S.URI.revive(o.uri);if(this.g.has(i))throw new Error(`adding EXISTING notebook ${i} `);const l=new d.ExtHostNotebookDocument(this.c,this.q,this.r,i,o);p.push(...o.cells.map(u=>d.ExtHostCell.asModelAddData(l.apiNotebook,u))),this.g.get(i)?.dispose(),this.g.set(i,l),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this.m.fire(l.apiNotebook)}}if(h.value.addedEditors)for(const p of h.value.addedEditors){if(this.h.has(p.id))return;const o=S.URI.revive(p.documentUri),i=this.g.get(o);i&&this.w(i,p.id,p)}const m=[];if(h.value.removedEditors)for(const p of h.value.removedEditors){const o=this.h.get(p);o&&(this.h.delete(p),this.k?.id===o.id&&(this.k=void 0),m.push(o))}if(h.value.visibleEditors){this.l=h.value.visibleEditors.map(o=>this.h.get(o)).filter(o=>!!o);const p=new Set;this.l.forEach(o=>p.add(o.id));for(const o of this.h.values()){const i=p.has(o.id);o._acceptVisibility(i)}this.l=[...this.h.values()].map(o=>o).filter(o=>o.visible),this.o.fire(this.visibleNotebookEditors)}h.value.newActiveEditor===null?this.k=void 0:h.value.newActiveEditor&&(this.k=this.h.get(h.value.newActiveEditor)),h.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(h){const m=T.ApiCommandArgument.String.with("notebookType","A notebook type"),p=new T.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[m,new T.ApiCommandArgument("data","Bytes to convert to data",i=>i instanceof Uint8Array,i=>a.VSBuffer.wrap(i))],new T.ApiCommandResult("Notebook Data",i=>E.NotebookData.to(i.value))),o=new T.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[m,new T.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",i=>!0,i=>new v.SerializableObjectWithBuffers(E.NotebookData.from(i)))],new T.ApiCommandResult("Bytes",i=>i.buffer));h.registerApiCommand(p),h.registerApiCommand(o)}}e.ExtHostNotebookController=f,f.a=0}),define(Se[259],ye([1,0,17,18,21,4,6,28,2,27,13,68,5,39,14,7,92,221,26,57]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v,d,b,f,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let m=class{constructor(s,c,n,r,g){this.k=c,this.l=n,this.m=r,this.n=g,this.b=new k.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new T.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=s.getProxy(E.MainContext.MainThreadNotebookKernels);const P=new y.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new y.ApiCommandArgument("options","Select kernel options",L=>!0,L=>{if(L&&"notebookEditor"in L&&"id"in L){const z=this.l.getIdByEditor(L.notebookEditor);return{id:L.id,extension:L.extension,notebookEditorId:z}}else if(L&&"notebookEditor"in L){const z=this.l.getIdByEditor(L.notebookEditor);if(z===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${L.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:z}}return L})],y.ApiCommandResult.Void);this.m.registerApiCommand(P)}createNotebookController(s,c,n,r,g,P){for(const J of this.h.values())if(J.controller.id===c&&C.ExtensionIdentifier.equals(s.identifier,J.extensionId))throw new Error(`notebook controller with id '${c}' ALREADY exist`);const L=this.i++,z=this;this.n.trace(`NotebookController[${L}], CREATED by ${s.identifier.value}, ${c}`);const _=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${s.identifier}'`);let K=!1;const F=new D.DisposableStore,M=new A.Emitter,N=new A.Emitter,B={id:l(s.identifier,c),notebookType:n,extensionId:s.identifier,extensionLocation:s.extensionLocation,label:r||s.identifier.value,preloads:P?P.map(v.NotebookRendererScript.from):[]};let U=g??_,W;this.a.$addKernel(L,B).catch(J=>{console.log(J),K=!0});let x=0;const V=()=>{if(K)return;const J=++x;Promise.resolve().then(()=>{J===x&&this.a.$updateKernel(L,B)})},X=new k.ResourceMap,Q={get id(){return c},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return B.label},set label(J){B.label=J??s.displayName??s.name,V()},get detail(){return B.detail??""},set detail(J){B.detail=J,V()},get description(){return B.description??""},set description(J){B.description=J,V()},get kind(){return(0,w.checkProposedApiEnabled)(s,"notebookControllerKind"),B.kind??""},set kind(J){(0,w.checkProposedApiEnabled)(s,"notebookControllerKind"),B.kind=J,V()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(J){B.supportedLanguages=J,V()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(J){B.supportsExecutionOrder=J,V()},get rendererScripts(){return B.preloads?B.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return U},set executeHandler(J){U=J??_},get interruptHandler(){return W},set interruptHandler(J){W=J,B.supportsInterrupt=Boolean(J),V()},createNotebookCellExecution(J){if(K)throw new Error("notebook controller is DISPOSED");if(!X.has(J.notebook.uri))throw z.n.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(te=>te.toString())),new Error(`notebook controller is NOT associated to notebook: ${J.notebook.uri.toString()}`);return z._createNotebookCellExecution(J,l(s.identifier,this.id))},dispose:()=>{K||(this.n.trace(`NotebookController[${L}], DISPOSED`),K=!0,this.h.delete(L),F.dispose(),M.dispose(),N.dispose(),this.a.$removeKernel(L))},updateNotebookAffinity(J,te){te===d.NotebookControllerAffinity2.Hidden&&(0,w.checkProposedApiEnabled)(s,"notebookControllerAffinityHidden"),z.a.$updateNotebookPriority(L,J.uri,te)},onDidReceiveMessage:N.event,postMessage(J,te){return(0,w.checkProposedApiEnabled)(s,"notebookMessaging"),z.a.$postMessage(L,te&&z.l.getIdByEditor(te),J)},asWebviewUri(J){return(0,w.checkProposedApiEnabled)(s,"notebookMessaging"),(0,b.asWebviewUri)(J,z.k.remote)}};return this.h.set(L,{extensionId:s.identifier,controller:Q,onDidReceiveMessage:N,onDidChangeSelection:M,associatedNotebooks:X}),Q}getIdByController(s){for(const[c,n]of this.h)if(n.controller===s)return l(n.extensionId,s.id);return null}createNotebookControllerDetectionTask(s,c){const n=this.d++,r=this;this.n.trace(`NotebookControllerDetectionTask[${n}], CREATED by ${s.identifier.value}`),this.a.$addKernelDetectionTask(n,c);const g={dispose:()=>{this.c.delete(n),r.a.$removeKernelDetectionTask(n)}};return this.c.set(n,g),g}registerKernelSourceActionProvider(s,c,n){const r=this.f++,g=this;return this.e.set(r,n),this.n.trace(`NotebookKernelSourceActionProvider[${r}], CREATED by ${s.identifier.value}`),this.a.$addKernelSourceActionProvider(r,c),{dispose:()=>{this.e.delete(r),g.a.$removeKernelSourceActionProvider(r)}}}async $provideKernelSourceActions(s,c){const n=this.e.get(s);if(n){const r=new D.DisposableStore;return this.g.add([r]),(await n.provideNotebookKernelSourceActions(c)??[]).map(P=>v.NotebookKernelSourceAction.from(P,this.m.converter,r))}return[]}$acceptNotebookAssociation(s,c,n){const r=this.h.get(s);if(r){const g=this.l.getNotebookDocument(S.URI.revive(c));n?r.associatedNotebooks.set(g.uri,!0):r.associatedNotebooks.delete(g.uri),this.n.trace(`NotebookController[${s}] ASSOCIATE notebook`,g.uri.toString(),n),r.onDidChangeSelection.fire({selected:n,notebook:g.apiNotebook})}}async $executeCells(s,c,n){const r=this.h.get(s);if(!r)return;const g=this.l.getNotebookDocument(S.URI.revive(c)),P=[];for(const L of n){const z=g.getCell(L);z&&P.push(z.apiCell)}try{this.n.trace(`NotebookController[${s}] EXECUTE cells`,g.uri.toString(),P.length),await r.controller.executeHandler.call(r.controller,P,g.apiNotebook,r.controller)}catch(L){this.n.error(`NotebookController[${s}] execute cells FAILED`,L),console.error(L)}}async $cancelCells(s,c,n){const r=this.h.get(s);if(!r)return;const g=this.l.getNotebookDocument(S.URI.revive(c));if(r.controller.interruptHandler)await r.controller.interruptHandler.call(r.controller,g.apiNotebook);else for(const P of n){const L=g.getCell(P);L&&this.b.get(L.uri)?.cancel()}}$acceptKernelMessageFromRenderer(s,c,n){const r=this.h.get(s);if(!r)return;const g=this.l.getEditorById(c);r.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:n}))}$cellExecutionChanged(s,c,n){const g=this.l.getNotebookDocument(S.URI.revive(s)).getCell(c);if(g){const P=n?v.NotebookCellExecutionState.to(n):d.NotebookCellExecutionState.Idle;P!==void 0&&this.j.fire({cell:g.apiCell,state:P})}}_createNotebookCellExecution(s,c){if(s.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const r=this.l.getNotebookDocument(s.notebook.uri).getCellFromApiCell(s);if(!r)throw new Error("invalid cell");if(this.b.has(r.uri))throw new Error(`duplicate execution for ${r.uri}`);const g=new o(c,r,this.a);this.b.set(r.uri,g);const P=g.onDidChangeState(()=>{g.state===p.Resolved&&(g.dispose(),P.dispose(),this.b.delete(r.uri))});return g.asApiObject()}};m=qe([We(4,R.ILogService)],m),e.ExtHostNotebookKernels=m;var p;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(p||(p={}));class o extends D.Disposable{get state(){return this.f}constructor(s,c,n){super(),this.j=c,this.k=n,this.b=o.a++,this.c=new A.Emitter,this.onDidChangeState=this.c.event,this.f=p.Init,this.g=this.B(new I.CancellationTokenSource),this.h=new i(10,r=>this.m(r)),this.i=c.internalMetadata.executionOrder,this.k.$createExecution(this.b,s,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(s){await this.h.addItem(s)}async m(s){const c=Array.isArray(s)?s:[s];return this.k.$updateExecution(this.b,new h.SerializableObjectWithBuffers(c))}n(){if(this.f===p.Init)throw new Error("Must call start before modifying cell output");if(this.f===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(s){let c=this.j;if(s&&(c=this.j.notebook.getCellFromApiCell(s)),!c)throw new Error("INVALID cell");return c.handle}s(s){return s.map(c=>{const n=d.NotebookCellOutput.ensureUniqueMimeTypes(c.items,!0);return n===c.items?v.NotebookCellOutput.from(c):v.NotebookCellOutput.from({items:n,id:c.id,metadata:c.metadata})})}async t(s,c,n){const r=this.r(c),g=this.s((0,a.asArray)(s));return this.l({editType:f.CellExecutionUpdateType.Output,cellHandle:r,append:n,outputs:g})}async w(s,c,n){return s=d.NotebookCellOutput.ensureUniqueMimeTypes((0,a.asArray)(s),!0),this.l({editType:f.CellExecutionUpdateType.OutputItems,items:s.map(v.NotebookCellOutputItem.from),outputId:c.id,append:n})}asApiObject(){const s=this;return Object.freeze({get token(){return s.g.token},get cell(){return s.j.apiCell},get executionOrder(){return s.i},set executionOrder(n){s.i=n,s.m([{editType:f.CellExecutionUpdateType.ExecutionState,executionOrder:s.i}])},start(n){if(s.f===p.Resolved||s.f===p.Started)throw new Error("Cannot call start again");s.f=p.Started,s.c.fire(),s.m({editType:f.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,r){if(s.f===p.Resolved)throw new Error("Cannot call resolve twice");s.f=p.Resolved,s.c.fire(),s.h.flush(),s.k.$completeExecution(s.b,new h.SerializableObjectWithBuffers({runEndTime:r,lastRunSuccess:n}))},clearOutput(n){return s.n(),s.t([],n,!1)},appendOutput(n,r){return s.n(),s.t(n,r,!0)},replaceOutput(n,r){return s.n(),s.t(n,r,!1)},appendOutputItems(n,r){return s.n(),s.w(n,r,!0)},replaceOutputItems(n,r){return s.n(),s.w(n,r,!1)}})}}o.a=0;class i{constructor(s,c){this.d=s,this.e=c,this.a=[],this.b=Date.now()}addItem(s){return this.a.push(s),this.c||(this.c=new t.DeferredPromise,this.b=Date.now(),(0,t.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const s=this.c;this.c=void 0;const c=this.a;return this.a=[],this.e(c).finally(()=>s.complete())}}function l(u,s){return`${u.value}/${s}`}e.createKernelId=l}),define(Se[260],ye([1,0,4,5,136]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(k,S){this.c=S,this.a=new Map,this.b=k.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(k,S,C){const R=this.c.getEditorById(k);this.a.get(S)?.fire({editor:R.apiEditor,message:C})}createRendererMessaging(k,S){if(!k.contributes?.notebookRenderer?.some(R=>R.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(R,T,E)=>this.d(S).event(R,T,E),postMessage:(R,T)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,T]=[T,R]);const E=T&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(T);return this.b.$postMessage(E?.id,S,R)}}}d(k){let S=this.a.get(k);return S||(S=new a.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(k)}}),this.a.set(k,S),S)}}e.ExtHostNotebookRenderers=A}),define(Se[261],ye([1,0,6,2,26,5]),function(ne,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class D{constructor(S){this.b=new Map,this.a=S.getProxy(A.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(S,C,R){if((0,I.checkProposedApiEnabled)(S,"profileContentHandlers"),this.b.has(C))throw new Error(`Handler with id '${C}' already registered`);return this.b.set(C,R),this.a.$registerProfileContentHandler(C,R.name,S.identifier.value),(0,a.toDisposable)(()=>{this.b.delete(C),this.a.$unregisterProfileContentHandler(C)})}async $saveProfile(S,C,R,T){const E=this.b.get(S);if(!E)throw new Error(`Unknown handler with id: ${S}`);return E.saveProfile(C,R,T)}async $readProfile(S,C,R){const T=this.b.get(S);if(!T)throw new Error(`Unknown handler with id: ${S}`);return T.readProfile(t.URI.revive(C),R)}}e.ExtHostProfileContentHandlers=D}),define(Se[262],ye([1,0,21,4,6,5,2,7,10,17,42,89]),function(ne,e,a,t,I,A,D,k,S,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function E(y,v,d){const b=y.getProxy(A.MainContext.MainThreadQuickOpen);class f{constructor(s,c){this.e=new Map,this.f=0,this.a=s,this.b=c}showQuickPick(s,c,n=a.CancellationToken.None){this.c=void 0;const r=Promise.resolve(s),g=++this.f,P=b.$show(g,{title:c?.title,placeHolder:c?.placeHolder,matchOnDescription:c?.matchOnDescription,matchOnDetail:c?.matchOnDetail,ignoreFocusLost:c?.ignoreFocusOut,canPickMany:c?.canPickMany},n),L={},z=P.then(()=>L);return Promise.race([z,r]).then(_=>{if(_!==L)return r.then(K=>{const F=[];for(let M=0;M<K.length;M++){const N=K[M];typeof N=="string"?F.push({label:N,handle:M}):N.kind===k.QuickPickItemKind.Separator?F.push({type:"separator",label:N.label}):F.push({label:N.label,description:N.description,detail:N.detail,picked:N.picked,alwaysShow:N.alwaysShow,handle:M})}return c&&typeof c.onDidSelectItem=="function"&&(this.c=M=>{c.onDidSelectItem(K[M])}),b.$setItems(g,F),P.then(M=>{if(typeof M=="number")return K[M];if(Array.isArray(M))return M.map(N=>K[N])})})}).then(void 0,_=>{if(!(0,S.isCancellationError)(_))return b.$setError(g,_),Promise.reject(_)})}$onItemSelected(s){this.c?.(s)}showInput(s,c=a.CancellationToken.None){return this.d=s?.validateInput,b.$input(s,typeof this.d=="function",c).then(void 0,n=>{if(!(0,S.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(s){if(!this.d)return;const c=await this.d(s);if(!c||typeof c=="string")return c;let n;switch(c.severity){case k.InputBoxValidationSeverity.Info:n=R.default.Info;break;case k.InputBoxValidationSeverity.Warning:n=R.default.Warning;break;case k.InputBoxValidationSeverity.Error:n=R.default.Error;break;default:n=c.message?R.default.Error:R.default.Ignore;break}return{content:c.message,severity:n}}async showWorkspaceFolderPick(s,c=a.CancellationToken.None){const n=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!n)return;const r=await this.a.getWorkspaceFolders2();if(!!r)return r.find(g=>g.uri.toString()===n.uri.toString())}createQuickPick(s){const c=new i(s,()=>this.e.delete(c._id));return this.e.set(c._id,c),c}createInputBox(s){const c=new l(s,()=>this.e.delete(c._id));return this.e.set(c._id,c),c}$onDidChangeValue(s,c){this.e.get(s)?._fireDidChangeValue(c)}$onDidAccept(s){this.e.get(s)?._fireDidAccept()}$onDidChangeActive(s,c){const n=this.e.get(s);n instanceof i&&n._fireDidChangeActive(c)}$onDidChangeSelection(s,c){const n=this.e.get(s);n instanceof i&&n._fireDidChangeSelection(c)}$onDidTriggerButton(s,c){this.e.get(s)?._fireDidTriggerButton(c)}$onDidTriggerItemButton(s,c,n){const r=this.e.get(s);r instanceof i&&r._fireDidTriggerItemButton(c,n)}$onDidHide(s){this.e.get(s)?._fireDidHide()}}class w{constructor(s,c){this.x=s,this.y=c,this._id=i.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new t.Emitter,this.q=new t.Emitter,this.r=new t.Emitter,this.s=new t.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(s){this.b=s,this.z({title:s})}get step(){return this.c}set step(s){this.c=s,this.z({step:s})}get totalSteps(){return this.d}set totalSteps(s){this.d=s,this.z({totalSteps:s})}get enabled(){return this.g}set enabled(s){this.g=s,this.z({enabled:s})}get busy(){return this.j}set busy(s){this.j=s,this.z({busy:s})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(s){this.k=s,this.z({ignoreFocusOut:s})}get value(){return this.l}set value(s){this.l=s,this.z({value:s})}get placeholder(){return this.m}set placeholder(s){this.m=s,this.z({placeholder:s})}get buttons(){return this.n}set buttons(s){this.n=s.slice(),this.o.clear(),s.forEach((c,n)=>{const r=c===k.QuickInputButtons.Back?-1:n;this.o.set(r,c)}),this.z({buttons:s.map((c,n)=>({...o(c),tooltip:c.tooltip,handle:c===k.QuickInputButtons.Back?-1:n}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(s){this.l=s,this.q.fire(s)}_fireDidTriggerButton(s){const c=this.o.get(s);c&&this.r.fire(c)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),b.$dispose(this._id))}z(s){if(!this.v){for(const c of Object.keys(s)){const n=s[c];this.u[c]=n===void 0?null:n}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){b.$createOrUpdate(this.u),this.u={id:this._id}}}w.a=1;function h(u){if(u instanceof k.ThemeIcon)return{id:u.id};const s=p(u),c=m(u);return{dark:typeof s=="string"?D.URI.file(s):s,light:typeof c=="string"?D.URI.file(c):c}}function m(u){return typeof u=="object"&&"light"in u?u.light:u}function p(u){return typeof u=="object"&&"dark"in u?u.dark:u}function o(u){const s=h(u.iconPath);let c,n;return"id"in s?n=T.ThemeIcon.asClassName(s):c=s,{iconPath:c,iconClass:n}}class i extends w{constructor(s,c){super(s.identifier,c),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new t.Emitter,this.L=[],this.M=new t.Emitter,this.N=new t.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(s){this.B=s.slice(),this.C.clear(),this.D.clear(),s.forEach((n,r)=>{this.C.set(r,n),this.D.set(n,r)});const c=[];for(let n=0;n<s.length;n++){const r=s[n];r.kind===k.QuickPickItemKind.Separator?c.push({type:"separator",label:r.label}):c.push({handle:n,label:r.label,description:r.description,detail:r.detail,picked:r.picked,alwaysShow:r.alwaysShow,buttons:r.buttons?.map((g,P)=>({...o(g),tooltip:g.tooltip,handle:P}))})}this.z({items:c})}get canSelectMany(){return this.E}set canSelectMany(s){this.E=s,this.z({canSelectMany:s})}get matchOnDescription(){return this.F}set matchOnDescription(s){this.F=s,this.z({matchOnDescription:s})}get matchOnDetail(){return this.G}set matchOnDetail(s){this.G=s,this.z({matchOnDetail:s})}get sortByLabel(){return this.H}set sortByLabel(s){this.H=s,this.z({sortByLabel:s})}get keepScrollPosition(){return this.I}set keepScrollPosition(s){this.I=s,this.z({keepScrollPosition:s})}get activeItems(){return this.J}set activeItems(s){this.J=s.filter(c=>this.D.has(c)),this.z({activeItems:this.J.map(c=>this.D.get(c))})}get selectedItems(){return this.L}set selectedItems(s){this.L=s.filter(c=>this.D.has(c)),this.z({selectedItems:this.L.map(c=>this.D.get(c))})}_fireDidChangeActive(s){const c=(0,C.coalesce)(s.map(n=>this.C.get(n)));this.J=c,this.K.fire(c)}_fireDidChangeSelection(s){const c=(0,C.coalesce)(s.map(n=>this.C.get(n)));this.L=c,this.M.fire(c)}_fireDidTriggerItemButton(s,c){const n=this.C.get(s);if(!n||!n.buttons||!n.buttons.length)return;const r=n.buttons[c];r&&this.N.fire({button:r,item:n})}}class l extends w{constructor(s,c){super(s.identifier,c),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(s){this.B=s,this.z({password:s})}get prompt(){return this.C}set prompt(s){this.C=s,this.z({prompt:s})}get valueSelection(){return this.D}set valueSelection(s){this.D=s,this.z({valueSelection:s})}get validationMessage(){return this.E}set validationMessage(s){this.E=s,s?typeof s=="string"?this.z({validationMessage:s,severity:R.default.Error}):this.z({validationMessage:s.message,severity:s.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new f(v,d)}e.createExtHostQuickOpen=E});var Me=this&&this.__classPrivateFieldGet||function(ne,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ne):t?t.value:e.get(ne)},Je=this&&this.__classPrivateFieldSet||function(ne,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ne,a):I?I.value=a:e.set(ne,a),a};define(Se[263],ye([1,0,2,4,60,6,18,5,17,108,13,27,89,14,26]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v){"use strict";var d,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(r){if(r)return typeof r.iconPath=="string"?a.URI.file(r.iconPath):a.URI.isUri(r.iconPath)||E.ThemeIcon.isThemeIcon(r.iconPath)?r.iconPath:void 0}function w(r,g){if(!r.iconPath&&!g.iconPath)return 0;if(r.iconPath){if(!g.iconPath)return 1}else return-1;const P=typeof r.iconPath=="string"?r.iconPath:a.URI.isUri(r.iconPath)?r.iconPath.fsPath:r.iconPath.id,L=typeof g.iconPath=="string"?g.iconPath:a.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id;return(0,C.comparePaths)(P,L)}function h(r,g){let P=0;if(r.strikeThrough!==g.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==g.faded)return r.faded?1:-1;if(r.tooltip!==g.tooltip)return(r.tooltip||"").localeCompare(g.tooltip||"");if(P=w(r,g),P!==0)return P;if(r.light&&g.light)P=w(r.light,g.light);else{if(r.light)return 1;if(g.light)return-1}if(P!==0)return P;if(r.dark&&g.dark)P=w(r.dark,g.dark);else{if(r.dark)return 1;if(g.dark)return-1}return P}function m(r,g){if(r.command!==g.command)return r.command<g.command?-1:1;if(r.title!==g.title)return r.title<g.title?-1:1;if(r.tooltip!==g.tooltip){if(r.tooltip!==void 0&&g.tooltip!==void 0)return r.tooltip<g.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(g.tooltip!==void 0)return-1}if(r.arguments===g.arguments)return 0;if(r.arguments)if(g.arguments){if(r.arguments.length!==g.arguments.length)return r.arguments.length-g.arguments.length}else return 1;else return-1;for(let P=0;P<r.arguments.length;P++){const L=r.arguments[P],z=g.arguments[P];if(L!==z)return L<z?-1:1}return 0}function p(r,g){let P=(0,C.comparePaths)(r.resourceUri.fsPath,g.resourceUri.fsPath,!0);if(P!==0)return P;if(r.command&&g.command)P=m(r.command,g.command);else{if(r.command)return 1;if(g.command)return-1}if(P!==0)return P;if(r.decorations&&g.decorations)P=h(r.decorations,g.decorations);else{if(r.decorations)return 1;if(g.decorations)return-1}return P}function o(r,g){for(let P=0;P<r.length;P++)if(r[P]!==g[P])return!1;return!0}function i(r,g){return r.command===g.command&&r.title===g.title&&r.tooltip===g.tooltip&&(r.arguments&&g.arguments?o(r.arguments,g.arguments):r.arguments===g.arguments)}function l(r,g){return(0,S.equals)(r,g,i)}class u{get value(){return this.d}set value(g){g=g??"",Me(this,d,"f").$setInputBoxValue(this.l,g),this.m(g)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(g){Me(this,d,"f").$setInputBoxPlaceholder(this.l,g),this.f=g}get validateInput(){return(0,v.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(g){if((0,v.checkProposedApiEnabled)(this.k,"scmValidation"),g&&typeof g!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=g,Me(this,d,"f").$setValidationProviderIsEnabled(this.l,!!g)}get enabled(){return this.h}set enabled(g){g=!!g,this.h!==g&&(this.h=g,Me(this,d,"f").$setInputBoxEnablement(this.l,g))}get visible(){return this.j}set visible(g){g=!!g,this.j!==g&&(this.j=g,Me(this,d,"f").$setInputBoxVisibility(this.l,g))}constructor(g,P,L){this.k=g,this.l=L,d.set(this,void 0),this.d="",this.e=new t.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,d,P,"f")}showValidationMessage(g,P){(0,v.checkProposedApiEnabled)(this.k,"scmValidation"),Me(this,d,"f").$showValidationMessage(this.l,g,P)}$onInputBoxValueChange(g){this.m(g)}m(g){this.d=g,this.e.fire(g)}}e.ExtHostSCMInputBox=u,d=new WeakMap;class s{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(g){this.v=g,this.q.$updateGroupLabel(this.t,this.handle,g)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(g){this.p=g,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(g){this.f=[...g],this.k.fire()}constructor(g,P,L,z,_){this.q=g,this.s=P,this.t=L,this.u=z,this.v=_,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new t.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new t.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=s.d++}getResourceState(g){return this.g.get(g)}$executeResourceCommand(g,P){const L=this.h.get(g);return L?(0,D.asPromise)(()=>this.s.executeCommand(L.command,...L.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const g=[...this.f].sort(p),L=(0,S.sortedDiff)(this.o,g,p).map(K=>{const F=K.toInsert.map(M=>{const N=this.e++;this.g.set(N,M);const B=M.resourceUri;let U;if(M.command)if(M.command.command==="vscode.open"||M.command.command==="vscode.diff"){const ge=new A.DisposableStore;U=this.s.converter.toInternal(M.command,ge),this.j.set(N,ge)}else this.h.set(N,M.command);const W=f(M.decorations),x=M.decorations&&f(M.decorations.light)||W,V=M.decorations&&f(M.decorations.dark)||W,X=[x,V],Q=M.decorations&&M.decorations.tooltip||"",J=M.decorations&&!!M.decorations.strikeThrough,te=M.decorations&&!!M.decorations.faded,le=M.contextValue||"";return{rawResource:[N,B,X,Q,J,te,le,U],handle:N}});return{start:K.start,deleteCount:K.deleteCount,toInsert:F}}),z=L.map(({start:K,deleteCount:F,toInsert:M})=>[K,F,M.map(N=>N.rawResource)]),_=L.reverse();for(const{start:K,deleteCount:F,toInsert:M}of _){const N=M.map(U=>U.handle),B=this.n.splice(K,F,...N);for(const U of B)this.g.delete(U),this.h.delete(U),this.j.get(U)?.dispose(),this.j.delete(U)}return this.o=g,z}dispose(){this.l=!0,this.m.fire()}}s.d=0;class c{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(g){this.g!==g&&(this.g=g,Me(this,b,"f").$updateSourceControl(this.t,{count:g}))}get quickDiffProvider(){return this.h}set quickDiffProvider(g){this.h=g,Me(this,b,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!g})}get commitTemplate(){return this.j}set commitTemplate(g){g!==this.j&&(this.j=g,Me(this,b,"f").$updateSourceControl(this.t,{commitTemplate:g}))}get acceptInputCommand(){return this.l}set acceptInputCommand(g){this.k.value=new A.DisposableStore,this.l=g;const P=this.v.converter.toInternal(g,this.k.value);Me(this,b,"f").$updateSourceControl(this.t,{acceptInputCommand:P})}get actionButton(){return(0,v.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(g){(0,v.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new A.DisposableStore,this.n=g;const P=g!==void 0?{command:this.v.converter.toInternal(g.command,this.m.value),secondaryCommands:g.secondaryCommands?.map(L=>L.map(z=>this.v.converter.toInternal(z,this.m.value))),description:g.description,enabled:g.enabled}:void 0;Me(this,b,"f").$updateSourceControl(this.t,{actionButton:P??null})}get statusBarCommands(){return this.p}set statusBarCommands(g){if(this.p&&g&&l(this.p,g))return;this.o.value=new A.DisposableStore,this.p=g;const P=(g||[]).map(L=>this.v.converter.toInternal(L,this.o.value));Me(this,b,"f").$updateSourceControl(this.t,{statusBarCommands:P})}get selected(){return this.q}constructor(g,P,L,z,_,K){this.u=g,this.v=L,this.w=z,this.x=_,this.y=K,b.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new A.MutableDisposable,this.l=void 0,this.m=new A.MutableDisposable,this.o=new A.MutableDisposable,this.p=void 0,this.q=!1,this.s=new t.Emitter,this.onDidChangeSelection=this.s.event,this.t=c.d++,this.z=new Map,this.A=new Set,Je(this,b,P,"f"),this.f=new u(g,Me(this,b,"f"),this.t),Me(this,b,"f").$registerSourceControl(this.t,z,_,K)}createResourceGroup(g,P){const L=new s(Me(this,b,"f"),this.v,this.t,g,P),z=t.Event.once(L.onDidDispose)(()=>this.z.delete(L));return this.z.set(L,z),this.eventuallyAddResourceGroups(),L}eventuallyAddResourceGroups(){const g=[],P=[];for(const[L,z]of this.z){z.dispose();const _=L.onDidUpdateResourceStates(()=>{this.A.add(L),this.eventuallyUpdateResourceStates()});t.Event.once(L.onDidDispose)(()=>{this.A.delete(L),_.dispose(),this.e.delete(L.handle),Me(this,b,"f").$unregisterGroup(this.t,L.handle)}),g.push([L.handle,L.id,L.label,L.features]);const K=L._takeResourceStateSnapshot();K.length>0&&P.push([L.handle,K]),this.e.set(L.handle,L)}Me(this,b,"f").$registerGroups(this.t,g,P),this.z.clear()}eventuallyUpdateResourceStates(){const g=[];this.A.forEach(P=>{const L=P._takeResourceStateSnapshot();L.length!==0&&g.push([P.handle,L])}),g.length>0&&Me(this,b,"f").$spliceResourceStates(this.t,g),this.A.clear()}getResourceGroup(g){return this.e.get(g)}setSelectionState(g){this.q=g,this.s.fire(g)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(g=>g.dispose()),Me(this,b,"f").$unregisterSourceControl(this.t)}}b=new WeakMap,c.d=0,qe([(0,I.debounce)(100)],c.prototype,"eventuallyAddResourceGroups",null),qe([(0,I.debounce)(100)],c.prototype,"eventuallyUpdateResourceStates",null);let n=class ni{get onDidChangeActiveProvider(){return this.j.event}constructor(g,P,L){this.l=P,this.m=L,this.g=new Map,this.h=new Map,this.j=new t.Emitter,this.e=g.getProxy(k.MainContext.MainThreadSCM),this.f=g.getProxy(k.MainContext.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:z=>{if(z&&z.$mid===3){const _=this.g.get(z.sourceControlHandle);if(!_)return z;const K=_.getResourceGroup(z.groupHandle);return K?K.getResourceState(z.handle):z}else if(z&&z.$mid===4){const _=this.g.get(z.sourceControlHandle);return _?_.getResourceGroup(z.groupHandle):z}else if(z&&z.$mid===5){const _=this.g.get(z.handle);return _||z}return z}})}createSourceControl(g,P,L,z){this.m.trace("ExtHostSCM#createSourceControl",g.identifier.value,P,L,z),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:g.identifier.value});const _=ni.d++,K=new c(g,this.e,this.l,P,L,z);this.g.set(_,K);const F=this.h.get(T.ExtensionIdentifier.toKey(g.identifier))||[];return F.push(K),this.h.set(T.ExtensionIdentifier.toKey(g.identifier),F),K}getLastInputBox(g){this.m.trace("ExtHostSCM#getLastInputBox",g.identifier.value);const P=this.h.get(T.ExtensionIdentifier.toKey(g.identifier)),L=P&&P[P.length-1];return L&&L.inputBox}$provideOriginalResource(g,P,L){const z=a.URI.revive(P);this.m.trace("ExtHostSCM#$provideOriginalResource",g,z.toString());const _=this.g.get(g);return!_||!_.quickDiffProvider||!_.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,D.asPromise)(()=>_.quickDiffProvider.provideOriginalResource(z,L)).then(K=>K||null)}$onInputBoxValueChange(g,P){this.m.trace("ExtHostSCM#$onInputBoxValueChange",g);const L=this.g.get(g);return L&&L.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(g,P,L,z){this.m.trace("ExtHostSCM#$executeResourceCommand",g,P,L);const _=this.g.get(g);if(!_)return Promise.resolve(void 0);const K=_.getResourceGroup(P);return K?K.$executeResourceCommand(L,z):Promise.resolve(void 0)}$validateInput(g,P,L){this.m.trace("ExtHostSCM#$validateInput",g);const z=this.g.get(g);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,D.asPromise)(()=>z.inputBox.validateInput(P,L)).then(_=>{if(!_)return Promise.resolve(void 0);const K=y.MarkdownString.fromStrict(_.message);return K?Promise.resolve([K,_.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(g){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",g),g!==void 0&&this.g.get(g)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=g,Promise.resolve(void 0)}};n.d=0,n=qe([We(2,R.ILogService)],n),e.ExtHostSCM=n}),define(Se[96],ye([1,0,5,4,3]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(k){this.b=new t.Emitter,this.onDidChangePassword=this.b.event,this.a=k.getProxy(a.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this.b.fire(k)}get(k,S){return this.a.$getPassword(k,S)}store(k,S,C){return this.a.$setPassword(k,S,C)}delete(k,S){return this.a.$deletePassword(k,S)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ne,a):I?I.value=a:e.set(ne,a),a},Me=this&&this.__classPrivateFieldGet||function(ne,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[264],ye([1,0,7,5,176,6,14,11]),function(ne,e,a,t,I,A,D,k){"use strict";var S,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(v,d,b,f,w=a.StatusBarAlignment.Left,h){S.set(this,void 0),C.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.p=new A.DisposableStore,Je(this,S,v,"f"),Je(this,C,d,"f"),this.c=R.a++,this.e=b,this.f=f,this.g=w,this.h=this.t(h)}t(v){if(!!(0,k.isNumber)(v))return v===Number.POSITIVE_INFINITY?Number.MAX_VALUE:v===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:v}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.q?.fromApi}get accessibilityInformation(){return this.s}set text(v){this.k=v,this.u()}set name(v){this.m=v,this.u()}set tooltip(v){this.l=v,this.u()}set color(v){this.n=v,this.u()}set backgroundColor(v){v&&!R.b.has(v.id)&&(v=void 0),this.o=v,this.u()}set command(v){this.q?.fromApi!==v&&(this.p.clear(),typeof v=="string"?this.q={fromApi:v,internal:Me(this,C,"f").toInternal({title:"",command:v},this.p)}:v?this.q={fromApi:v,internal:Me(this,C,"f").toInternal(v,this.p)}:this.q=void 0,this.u())}set accessibilityInformation(v){this.s=v,this.u()}show(){this.j=!0,this.u()}hide(){clearTimeout(this.r),this.j=!1,Me(this,S,"f").$dispose(this.c)}u(){this.i||!this.j||(clearTimeout(this.r),this.r=setTimeout(()=>{this.r=void 0;let v;this.e?this.f?v=`${this.e.identifier.value}.${this.f}`:v=this.e.identifier.value:v=this.f;let d;this.m?d=this.m:d=(0,I.localize)(0,null,this.e.displayName||this.e.name);let b=this.n;this.o&&(b=R.b.get(this.o.id));const f=D.MarkdownString.fromStrict(this.l);Me(this,S,"f").$setEntry(this.c,v,d,this.k,f,this.q?.internal,b,this.o,this.g===a.StatusBarAlignment.Left,this.h,this.s)},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=R,S=new WeakMap,C=new WeakMap,R.a=0,R.b=new Map([["statusBarItem.errorBackground",new a.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new a.ThemeColor("statusBarItem.warningForeground")]]);class T{constructor(v){this.b=[],this.a=v.createStatusBarEntry(void 0,"status.extensionMessage",a.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(v){const d={message:v};return this.b.unshift(d),this.c(),new a.Disposable(()=>{const b=this.b.indexOf(d);b>=0&&(this.b.splice(b,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class E{constructor(v,d){this.a=v.getProxy(t.MainContext.MainThreadStatusBar),this.b=d,this.c=new T(this)}createStatusBarEntry(v,d,b,f){return new R(this.a,this.b,v,d,b,f)}setStatusBarMessage(v,d){const b=this.c.setMessage(v);let f;return typeof d=="number"?f=setTimeout(()=>b.dispose(),d):typeof d<"u"&&d.then(()=>b.dispose(),()=>b.dispose()),new a.Disposable(()=>{b.dispose(),clearTimeout(f)})}}e.ExtHostStatusBar=E}),define(Se[97],ye([1,0,5,4,3]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(k,S){this.c=S,this.b=new t.Emitter,this.onDidChangeStorage=this.b.event,this.a=k.getProxy(a.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,S){this.a.$registerExtensionStorageKeysToSync(k,S)}async initializeExtensionStorage(k,S,C){const R=await this.a.$initializeExtensionStorage(k,S);let T;return R&&(T=this.d(k,S,R)),T||C}setValue(k,S,C){return this.a.$setValue(k,S,C)}$acceptValue(k,S,C){const R=this.d(k,S,C);R&&this.b.fire({shared:k,key:S,value:R})}d(k,S,C){try{return JSON.parse(C)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${k}): ${R}`)}}}e.ExtHostStorage=A,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(Se[72],ye([1,0,3,25,13,71,2]),function(ne,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,a.createDecorator)("IExtensionStoragePaths");let k=class{constructor(C,R,T){this.d=R,this.f=T,this.a=C.workspace??void 0,this.b=C.environment,this.whenReady=this.h().then(E=>this.c=E)}async g(C){return D.URI.joinPath(this.b.workspaceStorageHome,C)}async h(){if(!this.a)return Promise.resolve(void 0);const C=this.a.id,R=await this.g(C);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(D.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:D.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(T){this.d.error("[ExtHostStorage]",T);return}}workspaceValue(C){if(this.c)return D.URI.joinPath(this.c,C.identifier.value)}globalValue(C){return D.URI.joinPath(this.b.globalStorageHome,C.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=qe([We(0,t.IExtHostInitDataService),We(1,I.ILogService),We(2,A.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(Se[40],ye([1,0,4,5,3,2,16,6,7,177,10,222,21,30,207,89,11,18,14]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v,d,b,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class h{constructor(n,r,g,P){this.k=n,this._id=r,this.l=g,this.m=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(z=>this.f=z);const L=this;this.value={get name(){return L.m||""},get processId(){return L.b},get creationOptions(){return L.l},get exitStatus(){return L.h},get state(){return L.j},sendText(z,_=!0){L.o(),L.k.$sendText(L._id,z,_)},show(z){L.o(),L.k.$show(L._id,z)},hide(){L.o(),L.k.$hide(L._id)},dispose(){L.a||(L.a=!0,L.k.$dispose(L._id))},get dimensions(){if(!(L.d===void 0||L.g===void 0))return{columns:L.d,rows:L.g}}}}async create(n,r){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:n.name,shellPath:(0,b.withNullAsUndefined)(n.shellPath),shellArgs:(0,b.withNullAsUndefined)(n.shellArgs),cwd:(0,b.withNullAsUndefined)(n.cwd),env:(0,b.withNullAsUndefined)(n.env),icon:(0,b.withNullAsUndefined)(u(n.iconPath)),color:d.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,b.withNullAsUndefined)(n.message),strictEnv:(0,b.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,b.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,b.withNullAsUndefined)(r?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,b.withNullAsUndefined)(r?.useShellEnvironment),location:r?.location||this.n(n.location,r?.resolvedExtHostIdentifier),isTransient:(0,b.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,r,g,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:g,color:d.ThemeColor.isThemeColor(P)?P.id:void 0,location:this.n(n,r),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(n,r){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&r?{parentTerminal:r}:"viewColumn"in n?{viewColumn:w.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(n){this.m=n}setExitStatus(n,r){this.h=Object.freeze({code:n,reason:r})}setDimensions(n,r){return n===this.d&&r===this.g||n===0||r===0?!1:(this.d=n,this.g=r,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(n){this.f?(this.f(n),this.f=void 0):this.b.then(r=>{r!==n&&(this.b=Promise.resolve(n))})}}e.ExtHostTerminal=h;class m{get onProcessReady(){return this.b.event}constructor(n){this.g=n,this.id=0,this.shouldPersist=!1,this.a=new a.Emitter,this.onProcessData=this.a.event,this.b=new a.Emitter,this.d=new a.Emitter,this.onDidChangeProperty=this.d.event,this.f=new a.Emitter,this.onProcessExit=this.f.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,r){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${r}`)}async start(){}shutdown(){this.g.close()}input(n){this.g.handleInput?.(n)}resize(n,r){this.g.setDimensions?.({columns:n,rows:r})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this.g.onDidWrite(r=>this.a.fire(r)),this.g.onDidClose?.((r=void 0)=>{this.f.fire(r===void 0?void 0:r)}),this.g.onDidOverrideDimensions?.(r=>{r&&this.d.fire({type:"overrideDimensions",value:{cols:r.columns,rows:r.rows}})}),this.g.onDidChangeName?.(r=>{this.d.fire({type:"title",value:r})}),this.g.open(n||void 0),n&&this.g.setDimensions?.(n),this.b.fire({pid:-1,cwd:""})}}let p=1,o=class extends k.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(n=>n.value)}get onDidWriteTerminalData(){return this.I.event}constructor(n,r){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new a.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new a.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new a.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new a.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new a.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new a.Emitter,this.onDidChangeShell=this.J.event,this.a=r.getProxy(t.MainContext.MainThreadTerminalService),this.s=new v.TerminalDataBufferer(this.a.$sendProcessData),this.I=new a.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(n),this.B({dispose:()=>{for(const[g,P]of this.g)P.shutdown(!0)}})}getDefaultShell(n){return(n?this.n:this.m)?.path||""}getDefaultShellArgs(n){return(n?this.n:this.m)?.args||[]}createExtensionTerminal(n,r){const g=new h(this.a,(0,y.generateUuid)(),n,n.name),P=new m(n.pty);return g.createExtensionTerminal(n.location,this.L(n,r).resolvedExtHostIdentifier,u(n.iconPath),s(n.color)).then(L=>{const z=this.M(L,P);this.h[L]=z}),this.f.push(g),g.value}L(n,r){if(r=r||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const g=n.location.parentTerminal;if(g){const P=this.f.find(L=>L.value===g);P&&(r.resolvedExtHostIdentifier=P._id)}}else n.location&&typeof n.location!="object"?r.location=n.location:r.location&&typeof r.location=="object"&&"splitActiveTerminal"in r.location&&(r.location={splitActiveTerminal:!0});return r}attachPtyToTerminal(n,r){if(!this.O(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const P=new m(r),L=this.M(n,P);this.h[n]=L}async $acceptActiveTerminalChanged(n){const r=this.b;if(n===null){this.b=void 0,r!==this.b&&this.F.fire(this.b);return}const g=this.O(n);g&&(this.b=g,r!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(n,r){const g=this.O(n);g&&this.I.fire({terminal:g.value,data:r})}async $acceptTerminalDimensions(n,r,g){const P=this.O(n);P&&P.setDimensions(r,g)&&this.G.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptTerminalMaximumDimensions(n,r,g){this.g.get(n)?.resize(r,g)}async $acceptTerminalTitleChange(n,r){const g=this.O(n);g&&(g.name=r)}async $acceptTerminalClosed(n,r,g){const P=this.Q(this.f,n);if(P!==null){const L=this.f.splice(P,1)[0];L.setExitStatus(r,g),this.C.fire(L.value)}}$acceptTerminalOpened(n,r,g,P){if(r){const _=this.Q(this.f,r);if(_!==null){this.f[_]._id=n,this.D.fire(this.terminals[_]),this.f[_].isOpen=!0;return}}const L={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:A.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},z=new h(this.a,n,L,g);this.f.push(z),this.D.fire(z.value),z.isOpen=!0}async $acceptTerminalProcessId(n,r){this.O(n)?._setProcessId(r)}async $startExtensionTerminal(n,r){const g=this.O(n);if(!g)return{message:(0,C.localize)(0,null,n)};g.isOpen||await new Promise(L=>{const z=this.onDidOpenTerminal(async _=>{_===g.value&&(z.dispose(),L())})});const P=this.g.get(n);P?P.startSendingEvents(r):this.j[n]={initialDimensions:r}}M(n,r){const g=new k.DisposableStore;g.add(r.onProcessReady(L=>this.a.$sendProcessReady(n,L.pid,L.cwd))),g.add(r.onDidChangeProperty(L=>this.a.$sendProcessProperty(n,L))),this.s.startBuffering(n,r.onProcessData),g.add(r.onProcessExit(L=>this.N(n,L))),this.g.set(n,r);const P=this.j[n];return P&&r instanceof m&&(r.startSendingEvents(P.initialDimensions),delete this.j[n]),g}$acceptProcessAckDataEvent(n,r){this.g.get(n)?.acknowledgeDataEvent(r)}$acceptProcessInput(n,r){this.g.get(n)?.input(r)}$acceptTerminalInteraction(n){const r=this.O(n);r?.setInteractedWith()&&this.H.fire(r.value)}$acceptProcessResize(n,r,g){try{this.g.get(n)?.resize(r,g)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(n,r){this.g.get(n)?.shutdown(r)}$acceptProcessRequestInitialCwd(n){this.g.get(n)?.getInitialCwd().then(r=>this.a.$sendProcessProperty(n,{type:"initialCwd",value:r}))}$acceptProcessRequestCwd(n){this.g.get(n)?.getCwd().then(r=>this.a.$sendProcessProperty(n,{type:"cwd",value:r}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this.u.add(n),this.u.size===1&&this.a.$startLinkProvider(),new S.Disposable(()=>{this.u.delete(n),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(n,r,g){if(this.v.has(r))throw new Error(`Terminal profile provider "${r}" already registered`);return this.v.set(r,g),this.a.$registerProfileProvider(r,n.identifier.value),new S.Disposable(()=>{this.v.delete(r),this.a.$unregisterProfileProvider(r)})}registerTerminalQuickFixProvider(n,r,g){if(this.w.has(n))throw new Error(`Terminal quick fix provider "${n}" is already registered`);return this.w.set(n,g),this.a.$registerQuickFixProvider(n,r),new S.Disposable(()=>{this.w.delete(n),this.a.$unregisterQuickFixProvider(n)})}async $provideTerminalQuickFixes(n,r){const g=new E.CancellationTokenSource().token;if(g.isCancellationRequested)return;const P=this.w.get(n);if(!!P)return P.provideTerminalQuickFixes(r,g)}async $createContributedProfileTerminal(n,r){const g=new E.CancellationTokenSource().token;let P=await this.v.get(n)?.provideTerminalProfile(g);if(!g.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,r);return}this.createTerminalFromOptions(P.options,r)}}async $provideLinks(n,r){const g=this.O(n);if(!g)return[];this.y.delete(n),this.z.get(n)?.dispose(!0);const L=new E.CancellationTokenSource;this.z.set(n,L);const z=[],_={terminal:g.value,line:r},K=[];for(const N of this.u)K.push(f.Promises.withAsyncBody(async B=>{L.token.onCancellationRequested(()=>B({provider:N,links:[]}));const U=await N.provideTerminalLinks(_,L.token)||[];L.token.isCancellationRequested||B({provider:N,links:U})}));const F=await Promise.all(K);if(L.token.isCancellationRequested)return[];const M=new Map;for(const N of F)N&&N.links.length>0&&z.push(...N.links.map(B=>{const U={id:p++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return M.set(U.id,{provider:N.provider,link:B}),U}));return this.y.set(n,M),z}$activateLink(n,r){const g=this.y.get(n)?.get(r);!g||g.provider.handleTerminalLink(g.link)}N(n,r){this.s.stopBuffering(n),this.g.delete(n),delete this.j[n];const g=this.h[n];g&&(g.dispose(),delete this.h[n]),this.a.$sendProcessExit(n,r)}O(n){return this.P(this.f,n)}P(n,r){const g=this.Q(n,r);return g!==null?n[g]:null}Q(n,r){let g=null;return n.some((P,L)=>P._id===r?(g=L,!0):!1),g}getEnvironmentVariableCollection(n){let r=this.l.get(n.identifier.value);return r||(r=new i,this.S(n.identifier.value,r)),r}R(n,r){const g=(0,T.serializeEnvironmentVariableCollection)(r.map);this.a.$setEnvironmentVariableCollection(n,r.persistent,g.length===0?void 0:g)}$initEnvironmentVariableCollections(n){n.forEach(r=>{const g=r[0],P=new i(r[1]);this.S(g,P)})}$acceptDefaultProfile(n,r){const g=this.m;this.m=n,this.n=r,g?.path!==n.path&&this.J.fire(n.path)}S(n,r){this.l.set(n,r),r.onDidChangeCollection(()=>{this.R(n,r)})}};o=qe([We(1,D.IExtHostRpcService)],o),e.BaseExtHostTerminalService=o;class i{get persistent(){return this.a}set persistent(n){this.a=n,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(n){this.map=new Map,this.a=!0,this.b=new a.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,r){this.d(n,{value:r,type:S.EnvironmentVariableMutatorType.Replace})}append(n,r){this.d(n,{value:r,type:S.EnvironmentVariableMutatorType.Append})}prepend(n,r){this.d(n,{value:r,type:S.EnvironmentVariableMutatorType.Prepend})}d(n,r){const g=this.map.get(n);(!g||g.value!==r.value||g.type!==r.type)&&(this.map.set(n,r),this.b.fire())}get(n){return this.map.get(n)}forEach(n,r){this.map.forEach((g,P)=>n.call(r,P,g,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let l=class extends o{constructor(n){super(!1,n)}createTerminal(n,r,g){throw new R.NotSupportedError}createTerminalFromOptions(n,r){throw new R.NotSupportedError}};l=qe([We(0,D.IExtHostRpcService)],l),e.WorkerExtHostTerminalService=l;function u(c){if(!(!c||typeof c=="string"))return"id"in c?{id:c.id,color:c.color}:c}function s(c){return d.ThemeColor.isThemeColor(c)?c:void 0}});var Me=this&&this.__classPrivateFieldGet||function(ne,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ne):t?t.value:e.get(ne)},Je=this&&this.__classPrivateFieldSet||function(ne,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ne,a):I?I.value=a:e.set(ne,a),a};define(Se[265],ye([1,0,17,18,22,21,4,61,84,6,23,11,30,5,16,137,14,7,56,91,69]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v,d,b,f,w,h,m){"use strict";var p,o;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let i=class{constructor(M,N,B){this.j=B,this.c=new D.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=M.getProxy(y.MainContext.MainThreadTesting),this.h=new z(this.f),this.g=new c(this.f),N.registerArgumentProcessor({processArgument:U=>{if(U?.$mid!==15)return U;const W=U,x=W.tests[W.tests.length-1].item.extId;return this.d.get(w.TestId.root(x))?.collection.tree.get(x)?.actual??(0,d.toItemFromContext)(U)}})}createTestController(M,N,B){if(this.d.has(M))throw new Error(`Attempt to insert a duplicate controller with ID "${M}"`);const U=new C.DisposableStore,W=U.add(new d.ExtHostTestItemCollection(M,N,this.j));W.root.label=N;const x=new Map,V=this.f,X={items:W.root.children,get label(){return N},set label(J){N=J,W.root.label=J,V.$updateController(M,{label:N})},get refreshHandler(){return B},set refreshHandler(J){B=J,V.$updateController(M,{canRefresh:!!J})},get id(){return M},createRunProfile:(J,te,le,Z,ge)=>{let ve=(0,S.hash)(J);for(;x.has(ve);)ve++;return new _(this.f,x,M,ve,J,te,le,Z,ge)},createTestItem(J,te,le){return new d.TestItemImpl(M,J,te,le)},createTestRun:(J,te,le=!0)=>this.g.createTestRun(M,W,J,te,le),set resolveHandler(J){W.resolveHandler=J},get resolveHandler(){return W.resolveHandler},dispose:()=>{U.dispose()}};V.$registerTestController(M,N,!!B),U.add((0,C.toDisposable)(()=>V.$unregisterTestController(M)));const Q={controller:X,collection:W,profiles:x};return this.d.set(M,Q),U.add((0,C.toDisposable)(()=>this.d.delete(M))),U.add(W.onDidGenerateDiff(J=>V.$publishDiff(M,J.map(m.TestsDiffOp.serialize)))),X}createTestObserver(){return this.h.checkout()}async runTests(M,N=A.CancellationToken.None){const B=n(M);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.d.get(B.controllerId);if(!U)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(W=>w.TestId.fromExtHostTestItem(W,U.collection.root.id).toString())??[U.collection.root.id],profileGroup:K[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:M.exclude?.map(W=>W.id)},N)}$syncTests(){for(const{collection:M}of this.d.values())M.flushDiff();return Promise.resolve()}$provideFileCoverage(M,N,B){return(0,a.mapFind)(this.g.trackers,W=>W.id===M?W.getCoverage(N):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(M,N,B,U){return(0,a.mapFind)(this.g.trackers,x=>x.id===M?x.getCoverage(N):void 0)?.resolveFileCoverage(B,U)??Promise.resolve([])}$configureRunProfile(M,N){this.d.get(M)?.profiles.get(N)?.configureHandler?.()}async $refreshTests(M,N){await this.d.get(M)?.controller.refreshHandler?.(N)}$publishTestResults(M){this.results=Object.freeze(M.map(N=>(0,R.deepFreeze)(b.TestResults.to(N))).concat(this.results).sort((N,B)=>B.completedAt-N.completedAt).slice(0,32)),this.c.fire()}async $expandTest(M,N){const B=this.d.get(w.TestId.fromString(M).controllerId)?.collection;B&&(await B.expand(M,N<0?1/0:N),B.flushDiff())}$acceptDiff(M){this.h.applyDiff(M.map(m.TestsDiffOp.deserialize))}async $runControllerTests(M,N){return Promise.all(M.map(B=>this.runControllerTestRequest(B,N)))}async runControllerTestRequest(M,N){const B=this.d.get(M.controllerId);if(!B)return{};const{collection:U,profiles:W}=B,x=W.get(M.profileId);if(!x)return{};const V=M.testIds.map(te=>U.tree.get(te)).filter(T.isDefined),X=M.excludeExtIds.map(te=>B.collection.tree.get(te)).filter(T.isDefined).filter(te=>V.some(le=>le.fullId.compare(te.fullId)===2));if(!V.length)return{};const Q=new f.TestRunRequest(V.some(te=>te.actual instanceof d.TestItemRootImpl)?void 0:V.map(te=>te.actual),X.map(te=>te.actual),x),J=this.g.prepareForMainThreadTestRun(Q,r.fromInternal(M,B.collection),N);try{return await x.runHandler(Q,N),{}}catch(te){return{error:String(te)}}finally{J.hasRunningTasks&&!N.isCancellationRequested&&await D.Event.toPromise(J.onEnd),J.dispose()}}$cancelExtensionTestRun(M){M===void 0?this.g.cancelAllRuns():this.g.cancelRunById(M)}};i=qe([We(0,v.IExtHostRpcService)],i),e.ExtHostTesting=i;const l=1e4;var u;(function(F){F[F.Running=0]="Running",F[F.Cancelling=1]="Cancelling",F[F.Ended=2]="Ended"})(u||(u={}));class s extends C.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(M,N,B){super(),this.k=M,this.l=N,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new D.Emitter),this.onEnd=this.j.event,this.h=this.B(new A.CancellationTokenSource(B));const U=this.B(new t.RunOnceScheduler(()=>this.m(),l));this.B(this.h.token.onCancellationRequested(()=>U.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(M){return this.f.get(M)?.coverage}createRun(M){const N=this.k.id,B=this.k.controllerId,U=(0,E.generateUuid)(),W=new g(this.l,N,U),x=J=>(te,...le)=>{if(X){console.warn(`Setting the state of test "${te.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(te)||(this.s(te),J(te,...le))},V=(J,te)=>{const le=te instanceof Array?te.map(b.TestMessage.from):[b.TestMessage.from(te)];if(J.uri&&J.range){const Z={range:b.Range.from(J.range),uri:J.uri};for(const ge of le)ge.location=ge.location||Z}this.l.$appendTestMessagesInRun(N,U,w.TestId.fromExtHostTestItem(J,B).toString(),le)};let X=!1;const Q={isPersisted:this.k.isPersisted,token:this.h.token,name:M,get coverageProvider(){return W.coverageProvider},set coverageProvider(J){W.coverageProvider=J},enqueued:x(J=>{this.l.$updateTestStateInRun(N,U,w.TestId.fromExtHostTestItem(J,B).toString(),1)}),skipped:x(J=>{this.l.$updateTestStateInRun(N,U,w.TestId.fromExtHostTestItem(J,B).toString(),5)}),started:x(J=>{this.l.$updateTestStateInRun(N,U,w.TestId.fromExtHostTestItem(J,B).toString(),2)}),errored:x((J,te,le)=>{V(J,te),this.l.$updateTestStateInRun(N,U,w.TestId.fromExtHostTestItem(J,B).toString(),6,le)}),failed:x((J,te,le)=>{V(J,te),this.l.$updateTestStateInRun(N,U,w.TestId.fromExtHostTestItem(J,B).toString(),4,le)}),passed:x((J,te)=>{this.l.$updateTestStateInRun(N,U,w.TestId.fromExtHostTestItem(J,this.k.controllerId).toString(),3,te)}),appendOutput:(J,te,le)=>{X||(le&&(this.k.isIncluded(le)?this.s(le):le=void 0),this.l.$appendOutputToRun(N,U,I.VSBuffer.fromString(J),te&&b.location.from(te),le&&w.TestId.fromExtHostTestItem(le,B).toString()))},end:()=>{X||(X=!0,this.l.$finishedTestRunTask(N,U),this.f.delete(U),this.f.size||this.p())}};return this.f.set(U,{run:Q,coverage:W}),this.l.$startedTestRunTask(N,{id:U,name:M,running:!0}),Q}m(){for(const{run:M}of this.f.values())M.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(M){if(!(M instanceof d.TestItemImpl))throw new h.InvalidTestItemError(M.id);if(this.g.has(w.TestId.fromExtHostTestItem(M,this.k.controllerId).toString()))return;const N=[],B=this.k.colllection.root;for(;;){const U=b.TestItem.from(M);if(N.unshift(U),this.g.has(U.extId)||(this.g.add(U.extId),M===B))break;M=M.parent||B}this.l.$addTestsToRun(this.k.controllerId,this.k.id,N)}}class c{get trackers(){return this.c.values()}constructor(M){this.d=M,this.c=new Map}prepareForMainThreadTestRun(M,N,B){return this.f(M,N,B)}cancelRunById(M){for(const N of this.c.values())if(N.id===M){N.cancel();return}}cancelAllRuns(){for(const M of this.c.values())M.cancel()}createTestRun(M,N,B,U,W){const x=this.c.get(B);if(x)return x.createRun(U);const V=r.fromPublic(M,N,B,W),X=n(B);this.d.$startedExtensionTestRun({controllerId:M,profile:X&&{group:K[X.kind],id:X.profileId},exclude:B.exclude?.map(J=>w.TestId.fromExtHostTestItem(J,N.root.id).toString())??[],id:V.id,include:B.include?.map(J=>w.TestId.fromExtHostTestItem(J,N.root.id).toString())??[N.root.id],persist:W});const Q=this.f(B,V);return Q.onEnd(()=>{this.d.$finishedExtensionTestRun(V.id),Q.dispose()}),Q.createRun(U)}f(M,N,B){const U=new s(N,this.d,B);return this.c.set(M,U),U.onEnd(()=>this.c.delete(M)),U}}e.TestRunCoordinator=c;const n=F=>{if(!!F.profile){if(!(F.profile instanceof _))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return F.profile}};class r{static fromPublic(M,N,B,U){return new r(M,(0,E.generateUuid)(),B.include?.map(W=>w.TestId.fromExtHostTestItem(W,M).toString())??[M],B.exclude?.map(W=>w.TestId.fromExtHostTestItem(W,M).toString())??[],U,N)}static fromInternal(M,N){return new r(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,N)}constructor(M,N,B,U,W,x){this.controllerId=M,this.id=N,this.isPersisted=W,this.colllection=x,this.c=B.map(V=>V+"\0"),this.d=U.map(V=>V+"\0")}isIncluded(M){const N=w.TestId.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const B of this.d)if(N===B||N.startsWith(B))return!1;for(const B of this.c)if(N===B||N.startsWith(B))return!0;return!1}}e.TestRunDto=r;class g{set coverageProvider(M){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!M||(this.c=M,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(M,N,B){this.f=M,this.g=N,this.h=B}async provideFileCoverage(M){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(M))());try{return(await this.d)?.map(b.TestCoverage.fromFile)??[]}catch(N){throw this.d=void 0,N}}async resolveFileCoverage(M,N){const B=await this.d;let U=B?.[M];return!this.c||!B||!U?[]:(U.detailedCoverage||(U=B[M]=await this.c.resolveFileCoverage?.(U,N)??U),U.detailedCoverage?.map(b.TestCoverage.fromDetailed)??[])}}class P{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(M){this.h=M,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(M){this.c.add(M)}update(M){Object.assign(M.revived,b.TestItem.toPlain(M.item)),this.c.has(M)||this.d.add(M)}remove(M){if(this.c.has(M)){this.c.delete(M);return}this.d.delete(M);const N=w.TestId.parentId(M.item.extId);if(N&&this.g.has(N.toString())){this.g.add(M.item.extId);return}this.f.add(M)}getChangeEvent(){const{c:M,d:N,f:B}=this;return{get added(){return[...M].map(U=>U.revived)},get updated(){return[...N].map(U=>U.revived)},get removed(){return[...B].map(U=>U.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class L extends m.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new D.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(M){return this.d.get(M)}getMirroredTestDataByReference(M){return this.d.get(M.id)}p(M,N){return{...M,revived:b.TestItem.toPlain(M.item),depth:N?N.depth+1:0,children:new Set}}o(){return new P(this.q)}}e.MirroredTestCollection=L;class z{constructor(M){this.d=M}checkout(){this.c||(this.c=this.f());const M=this.c;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(N=>N.revived)},dispose:(0,k.once)(()=>{--M.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(M){return this.c?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.c?.tests.apply(M)}f(){const M=new L;return this.d.$subscribeToDiffs(),{observers:0,tests:M}}}class _{get label(){return this.d}set label(M){M!==this.d&&(this.d=M,Me(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get isDefault(){return this.f}set isDefault(M){M!==this.f&&(this.f=M,Me(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,Me(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?b.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this.c}set configureHandler(M){M!==this.c&&(this.c=M,Me(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}constructor(M,N,B,U,W,x,V,X=!1,Q=void 0){this.controllerId=B,this.profileId=U,this.d=W,this.kind=x,this.runHandler=V,this.f=X,this._tag=Q,p.set(this,void 0),o.set(this,void 0),Je(this,p,M,"f"),Je(this,o,N,"f"),N.set(U,this);const J=K[x];if(typeof J!="number")throw new Error(`Unknown TestRunProfile.group ${x}`);Me(this,p,"f").$publishTestRunProfile({profileId:U,controllerId:B,tag:Q?b.TestTag.namespace(this.controllerId,Q.id):null,label:W,group:J,isDefault:X,hasConfigurationHandler:!1})}dispose(){Me(this,o,"f")?.delete(this.profileId)&&(Je(this,o,void 0,"f"),Me(this,p,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=_,p=new WeakMap,o=new WeakMap;const K={[f.TestRunProfileKind.Coverage]:8,[f.TestRunProfileKind.Debug]:4,[f.TestRunProfileKind.Run]:2}}),define(Se[266],ye([1,0,17,4,5,138,14,7]),function(ne,e,a,t,I,A,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(R,T){this.i=T,this.a=new t.Emitter,this.b=new t.Emitter,this.c=new t.Emitter,this.d=new t.Emitter,this.f=new t.Emitter,this.g=new t.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=R.getProxy(I.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(E=>this.g.fire(E)),this.i.onDidChangeActiveTextEditor(E=>this.f.fire(E))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(R){const T=this.i.allEditors();return R?T:T.map(E=>E.value)}async showTextDocument(R,T,E){let y;typeof T=="number"?y={position:D.ViewColumn.from(T),preserveFocus:E}:typeof T=="object"?y={position:D.ViewColumn.from(T.viewColumn),preserveFocus:T.preserveFocus,selection:typeof T.selection=="object"?D.Range.from(T.selection):void 0,pinned:typeof T.preview=="boolean"?!T.preview:void 0}:y={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(R.uri,y),d=v&&this.i.getEditor(v);if(d)return d.value;throw v?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,T){return new A.TextEditorDecorationType(this.h,R,T).value}$acceptEditorPropertiesChanged(R,T){const E=this.i.getEditor(R);if(!E)throw new Error("unknown text editor");if(T.options&&E._acceptOptions(T.options),T.selections){const y=T.selections.selections.map(D.Selection.to);E._acceptSelections(y)}if(T.visibleRanges){const y=a.coalesce(T.visibleRanges.map(D.Range.to));E._acceptVisibleRanges(y)}if(T.options&&this.b.fire({textEditor:E.value,options:{...T.options,lineNumbers:D.TextEditorLineNumbersStyle.to(T.options.lineNumbers)}}),T.selections){const y=k.TextEditorSelectionChangeKind.fromValue(T.selections.source),v=T.selections.selections.map(D.Selection.to);this.a.fire({textEditor:E.value,selections:v,kind:y})}if(T.visibleRanges){const y=a.coalesce(T.visibleRanges.map(D.Range.to));this.c.fire({textEditor:E.value,visibleRanges:y})}}$acceptEditorPositionData(R){for(const T in R){const E=this.i.getEditor(T);if(!E)throw new Error("Unknown text editor");const y=D.ViewColumn.to(R[T]);E.value.viewColumn!==y&&(E._acceptViewColumn(y),this.d.fire({textEditor:E.value,viewColumn:y}))}}getDiffInformation(R){return Promise.resolve(this.h.$getDiffInformation(R))}}e.ExtHostEditors=S}),define(Se[267],ye([1,0,2,3,5,6,7,14,11]),function(ne,e,a,t,I,A,D,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class C{constructor(E,y){this.b=new Map,this.c=new Map,this.a=E.getProxy(I.MainContext.MainThreadTimeline),y.registerArgumentProcessor({processArgument:v=>{if(v&&v.$mid===12){const d=v.uri===void 0?void 0:a.URI.revive(v.uri);return this.c.get(v.source)?.get(R(d))?.get(v.handle)}return v}})}async $getTimeline(E,y,v,d){return this.b.get(E)?.provideTimeline(a.URI.revive(y),v,d)}registerTimelineProvider(E,y,v,d){const b=new A.DisposableStore,f=this.d(y.id,d,b).bind(this);let w;y.onDidChange&&(w=y.onDidChange(m=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...m,id:y.id}),this));const h=this.c;return this.f({...y,scheme:E,onDidChange:void 0,async provideTimeline(m,p,o){p?.resetCache&&(b.clear(),h.get(y.id)?.clear());const i=await y.provideTimeline(m,p,o);if(i==null)return;const l=f(m,p);return{...i,source:y.id,items:i.items.map(l)}},dispose(){for(const m of h.values())m.get(y.id)?.clear();w?.dispose(),b.dispose()}})}d(E,y,v){return(d,b)=>{let f;if(b?.cacheResults){let w=this.c.get(E);w===void 0&&(w=new Map,this.c.set(E,w));const h=R(d);f=w.get(h),f===void 0&&(f=new Map,w.set(h,f))}return w=>{const{iconPath:h,...m}=w,p=`${E}|${w.id??w.timestamp}`;f?.set(p,w);let o,i,l;w.iconPath&&(h instanceof D.ThemeIcon?l={id:h.id,color:h.color}:a.URI.isUri(h)?(o=h,i=h):{light:o,dark:i}=h);let u;return D.MarkdownString.isMarkdownString(m.tooltip)?u=k.MarkdownString.from(m.tooltip):(0,S.isString)(m.tooltip)?u=m.tooltip:D.MarkdownString.isMarkdownString(m.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=k.MarkdownString.from(m.detail)):(0,S.isString)(m.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=m.detail),{...m,id:m.id??void 0,handle:p,source:E,command:w.command?y.toInternal(w.command,v):void 0,icon:o,iconDark:i,themeIcon:l,tooltip:u,accessibilityInformation:w.accessibilityInformation}}}}f(E){if(this.b.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this.a.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this.b.set(E.id,E),(0,A.toDisposable)(()=>{for(const v of this.c.values())v.get(E.id)?.clear();this.b.delete(E.id),this.a.$unregisterTimelineProvider(E.id),E.dispose()})}}e.ExtHostTimeline=C;function R(T){return T?.toString()}}),define(Se[268],ye([1,0,6,15,2,5]),function(ne,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class D{constructor(S){this.c=new Map,this.b=S.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,C,R,T){if(this.c.has(C))throw new Error(`Opener with id '${C}' already registered`);const E=T.schemes.find(y=>!D.a.has(y));if(E)throw new Error(`Scheme '${E}' is not supported. Only http and https are currently supported.`);return this.c.set(C,R),this.b.$registerUriOpener(C,T.schemes,S,T.label),(0,a.toDisposable)(()=>{this.c.delete(C),this.b.$unregisterUriOpener(C)})}async $canOpenUri(S,C,R){const T=this.c.get(S);if(!T)throw new Error(`Unknown opener with id: ${S}`);const E=I.URI.revive(C);return T.canOpenExternalUri(E,R)}async $openUri(S,C,R){const T=this.c.get(S);if(!T)throw new Error(`Unknown opener id: '${S}'`);return T.openExternalUri(I.URI.revive(C.resolvedUri),{sourceUri:I.URI.revive(C.sourceUri)},R)}}e.ExtHostUriOpeners=D,D.a=new Set([t.Schemas.http,t.Schemas.https])}),define(Se[269],ye([1,0,5,2,6,10,27]),function(ne,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(C){this.c=new Set,this.d=new Map,this.b=C.getProxy(a.MainContext.MainThreadUrls)}registerUriHandler(C,R){if(this.c.has(D.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const T=k.a++;return this.c.add(D.ExtensionIdentifier.toKey(C)),this.d.set(T,R),this.b.$registerUriHandler(T,C),(0,I.toDisposable)(()=>{this.c.delete(D.ExtensionIdentifier.toKey(C)),this.d.delete(T),this.b.$unregisterUriHandler(T)})}$handleExternalUri(C,R){const T=this.d.get(C);if(!T)return Promise.resolve(void 0);try{T.handleUri(t.URI.revive(R))}catch(E){(0,A.onUnexpectedError)(E)}return Promise.resolve(void 0)}async createAppUri(C){return t.URI.revive(await this.b.$createAppUri(C))}}e.ExtHostUrls=k,k.a=0});var Je=this&&this.__classPrivateFieldSet||function(ne,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ne,a):I?I.value=a:e.set(ne,a),a},Me=this&&this.__classPrivateFieldGet||function(ne,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[73],ye([1,0,4,15,23,2,192,214,92,5]),function(ne,e,a,t,I,A,D,k,S,C){"use strict";var R,T,E,y,v,d,b,f,w,h,m,p,o;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class i{constructor(L,z,_,K,F,M,N){R.set(this,void 0),T.set(this,void 0),E.set(this,void 0),y.set(this,void 0),v.set(this,void 0),d.set(this,void 0),b.set(this,""),f.set(this,void 0),w.set(this,!1),h.set(this,!1),m.set(this,void 0),p.set(this,void 0),this._onMessageEmitter=new a.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,o.set(this,new a.Emitter),this._onDidDispose=Me(this,o,"f").event,Je(this,R,L,"f"),Je(this,T,z,"f"),Je(this,f,_,"f"),Je(this,y,K,"f"),Je(this,v,F,"f"),Je(this,d,M,"f"),Je(this,m,l(M),"f"),Je(this,p,u(M),"f"),Je(this,E,N,"f")}dispose(){Je(this,w,!0,"f"),Me(this,o,"f").fire(),Me(this,o,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(L){return Je(this,h,!0,"f"),(0,S.asWebviewUri)(L,Me(this,y,"f"))}get cspSource(){const L=Me(this,d,"f").extensionLocation;if(L.scheme===t.Schemas.https||L.scheme===t.Schemas.http){let z=L.toString();return z.endsWith("/")||(z+="/"),z+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.a(),Me(this,b,"f")}set html(L){this.a(),Me(this,b,"f")!==L&&(Je(this,b,L,"f"),Me(this,p,"f")&&!Me(this,h,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(L)&&(Je(this,h,!0,"f"),Me(this,E,"f").report("Webview vscode-resource: uris",Me(this,d,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Me(this,T,"f").$setHtml(Me(this,R,"f"),this.b(L)))}get options(){return this.a(),Me(this,f,"f")}set options(L){this.a(),I.equals(Me(this,f,"f"),L)||Me(this,T,"f").$setOptions(Me(this,R,"f"),n(Me(this,d,"f"),Me(this,v,"f"),L)),Je(this,f,L,"f")}async postMessage(L){if(Me(this,w,"f"))return!1;const z=(0,k.serializeWebviewMessage)(L,{serializeBuffersForPostMessage:Me(this,m,"f")});return Me(this,T,"f").$postMessage(Me(this,R,"f"),z.message,...z.buffers)}a(){if(Me(this,w,"f"))throw new Error("Webview is disposed")}b(L){if(!Me(this,p,"f"))return L;const z=Me(this,d,"f").extensionLocation?.scheme===t.Schemas.vscodeRemote,_=Me(this,d,"f").extensionLocation.scheme===t.Schemas.vscodeRemote?Me(this,d,"f").extensionLocation.authority:void 0;return L.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(K,F,M,N,B,U)=>{const W=A.URI.from({scheme:N||"file",path:decodeURIComponent(B)}),x=(0,S.asWebviewUri)(W,{isRemote:z,authority:_}).toString();return`${F}${x}${U}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(K,F,M,N,B,U)=>{const W=A.URI.from({scheme:N||"file",path:decodeURIComponent(B)}),x=(0,S.asWebviewUri)(W,{isRemote:z,authority:_}).toString();return`${F}${x}${U}`})}}e.ExtHostWebview=i,R=new WeakMap,T=new WeakMap,E=new WeakMap,y=new WeakMap,v=new WeakMap,d=new WeakMap,b=new WeakMap,f=new WeakMap,w=new WeakMap,h=new WeakMap,m=new WeakMap,p=new WeakMap,o=new WeakMap;function l(P){try{const L=(0,D.normalizeVersion)((0,D.parseVersion)(P.engines.vscode));return!!L&&L.majorBase>=1&&L.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=l;function u(P){try{const L=(0,D.normalizeVersion)((0,D.parseVersion)(P.engines.vscode));return L?L.majorBase<1||L.majorBase===1&&L.minorBase<60:!1}catch{return!1}}class s{constructor(L,z,_,K,F){this.c=z,this.d=_,this.e=K,this.f=F,this.b=new Map,this.a=L.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(L,z,_){const K=this.g(L);if(K){const{message:F}=(0,k.deserializeWebviewMessage)(z,_.value);K._onMessageEmitter.fire(F)}}$onMissingCsp(L,z){this.e.warn(`${z} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(L,z,_){const K=new i(L,this.a,r(z),this.c,this.d,_,this.f);return this.b.set(L,K),K._onDidDispose(()=>{this.b.delete(L)}),K}deleteWebview(L){this.b.delete(L)}g(L){return this.b.get(L)}}e.ExtHostWebviews=s;function c(P){return{id:P.identifier,location:P.extensionLocation}}e.toExtensionData=c;function n(P,L,z){return{enableCommandUris:z.enableCommandUris,enableScripts:z.enableScripts,enableForms:z.enableForms,portMapping:z.portMapping,localResourceRoots:z.localResourceRoots||g(P,L)}}e.serializeWebviewOptions=n;function r(P){return{enableCommandUris:P.enableCommandUris,enableScripts:P.enableScripts,enableForms:P.enableForms,portMapping:P.portMapping,localResourceRoots:P.localResourceRoots?.map(L=>A.URI.from(L))}}function g(P,L){return[...(L?.getWorkspaceFolders()||[]).map(z=>z.uri),P.extensionLocation]}}),define(Se[270],ye([1,0,21,84,6,15,24,2,14,73,68,5,7]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class y{constructor(i,l){this.document=i,this.b=l,this.a=1,this.c=new R.Cache("custom documents")}addEdit(i){return this.c.add([i])}async undo(i,l){await this.f(i).undo(),l||this.disposeBackup()}async redo(i,l){await this.f(i).redo(),l||this.disposeBackup()}disposeEdits(i){for(const l of i)this.c.delete(l)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const i=p(this.document.uri)+this.a++;return(0,D.joinPath)(this.b,i)}updateBackup(i){this.d?.delete(),this.d=i}disposeBackup(){this.d?.delete(),this.d=void 0}f(i){const l=this.c.get(i,0);if(!l)throw new Error("No edit found");return l}}class v{constructor(){this.a=new Map}get(i,l){return this.a.get(this.b(i,l))}add(i,l,u){const s=this.b(i,l.uri);if(this.a.has(s))throw new Error(`Document already exists for viewType:${i} resource:${l.uri}`);const c=new y(l,u);return this.a.set(s,c),c}delete(i,l){const u=this.b(i,l.uri);this.a.delete(u)}b(i,l){return`${i}@@@${l}`}}var d;(function(o){o[o.Text=0]="Text",o[o.Custom=1]="Custom"})(d||(d={}));class b{constructor(){this.a=new Map}addTextProvider(i,l,u){return this.b(0,i,l,u)}addCustomProvider(i,l,u){return this.b(1,i,l,u)}get(i){return this.a.get(i)}b(i,l,u,s){if(this.a.has(l))throw new Error(`Provider for viewType:${l} already registered`);return this.a.set(l,{type:i,extension:u,provider:s}),new E.Disposable(()=>this.a.delete(l))}}class f{constructor(i,l,u,s,c){this.d=l,this.f=u,this.g=s,this.h=c,this.b=new b,this.c=new v,this.a=i.getProxy(T.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,l,u,s){const c=new I.DisposableStore;return h(u)?(c.add(this.b.addTextProvider(l,i,u)),this.a.$registerTextEditorProvider((0,C.toExtensionData)(i),l,s.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,C.shouldSerializeBuffersForPostMessage)(i))):(c.add(this.b.addCustomProvider(l,i,u)),w(u)&&c.add(u.onDidChangeCustomDocument(n=>{const r=this.i(l,n.document.uri);if(m(n)){const g=r.addEdit(n);this.a.$onDidEdit(n.document.uri,l,g,n.label)}else this.a.$onContentChange(n.document.uri,l)})),this.a.$registerCustomEditorProvider((0,C.toExtensionData)(i),l,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,C.shouldSerializeBuffersForPostMessage)(i))),E.Disposable.from(c,new E.Disposable(()=>{this.a.$unregisterEditorProvider(l)}))}async $createCustomDocument(i,l,u,s,c){const n=this.b.get(l);if(!n)throw new Error(`No provider found for '${l}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${l}'`);const r=k.URI.revive(i),g=await n.provider.openCustomDocument(r,{backupId:u,untitledDocumentData:s?.buffer},c);let P;return w(n.provider)&&this.f&&(P=this.f.workspaceValue(n.extension)??this.f.globalValue(n.extension)),this.c.add(l,g,P),{editable:w(n.provider)}}async $disposeCustomDocument(i,l){const u=this.b.get(l);if(!u)throw new Error(`No provider found for '${l}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${l}'`);const s=k.URI.revive(i),{document:c}=this.i(l,s);this.c.delete(l,c),c.dispose()}async $resolveWebviewEditor(i,l,u,s,c,n){const r=this.b.get(u);if(!r)throw new Error(`No provider found for '${u}'`);const g=S.ViewColumn.to(c),P=this.g.createNewWebview(l,s.contentOptions,r.extension),L=this.h.createNewWebviewPanel(l,u,s.title,g,s.options,P,!0),z=k.URI.revive(i);switch(r.type){case 1:{const{document:_}=this.i(u,z);return r.provider.resolveCustomEditor(_,L,n)}case 0:{const _=this.d.getDocument(z);return r.provider.resolveCustomTextEditor(_,L,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,l,u){this.i(l,i).disposeEdits(u)}async $onMoveCustomEditor(i,l,u){const s=this.b.get(u);if(!s)throw new Error(`No provider found for '${u}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const c=this.h.getWebviewPanel(i);if(!c)throw new Error("No webview found");const n=k.URI.revive(l),r=this.d.getDocument(n);await s.provider.moveCustomTextEditor(r,c,a.CancellationToken.None)}async $undo(i,l,u,s){return this.i(l,i).undo(u,s)}async $redo(i,l,u,s){return this.i(l,i).redo(u,s)}async $revert(i,l,u){const s=this.i(l,i);await this.j(l).revertCustomDocument(s.document,u),s.disposeBackup()}async $onSave(i,l,u){const s=this.i(l,i);await this.j(l).saveCustomDocument(s.document,u),s.disposeBackup()}async $onSaveAs(i,l,u,s){const c=this.i(l,i);return this.j(l).saveCustomDocumentAs(c.document,k.URI.revive(u),s)}async $backup(i,l,u){const s=this.i(l,i),n=await this.j(l).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},u);return s.updateBackup(n),n.id}i(i,l){const u=this.c.get(i,k.URI.revive(l));if(!u)throw new Error("No custom document found");return u}j(i){const u=this.b.get(i)?.provider;if(!u||!w(u))throw new Error("Custom document is not editable");return u}}e.ExtHostCustomEditors=f;function w(o){return!!o.onDidChangeCustomDocument}function h(o){return typeof o.resolveCustomTextEditor=="function"}function m(o){return typeof o.undo=="function"&&typeof o.redo=="function"}function p(o){const i=o.scheme===A.Schemas.file||o.scheme===A.Schemas.untitled?o.fsPath:o.toString();return(0,t.hash)(i)+""}});var Je=this&&this.__classPrivateFieldSet||function(ne,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ne,a):I?I.value=a:e.set(ne,a),a},Me=this&&this.__classPrivateFieldGet||function(ne,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[271],ye([1,0,4,6,2,30,14,73,5,7]),function(ne,e,a,t,I,A,D,k,S,C){"use strict";var R,T,E,y,v,d,b,f,w,h,m,p,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class i extends t.Disposable{constructor(c,n,r,g){super(),R.set(this,void 0),T.set(this,void 0),E.set(this,void 0),y.set(this,void 0),v.set(this,void 0),d.set(this,void 0),b.set(this,void 0),f.set(this,void 0),w.set(this,!0),h.set(this,void 0),m.set(this,!1),p.set(this,this.B(new a.Emitter)),this.onDidDispose=Me(this,p,"f").event,o.set(this,this.B(new a.Emitter)),this.onDidChangeViewState=Me(this,o,"f").event,Je(this,R,c,"f"),Je(this,T,n,"f"),Je(this,y,r,"f"),Je(this,E,g.viewType,"f"),Je(this,v,g.panelOptions,"f"),Je(this,f,g.viewColumn,"f"),Je(this,d,g.title,"f"),Je(this,h,g.active,"f")}dispose(){Me(this,m,"f")||(Je(this,m,!0,"f"),Me(this,p,"f").fire(),Me(this,T,"f").$disposeWebview(Me(this,R,"f")),Me(this,y,"f").dispose(),super.dispose())}get webview(){return this.c(),Me(this,y,"f")}get viewType(){return this.c(),Me(this,E,"f")}get title(){return this.c(),Me(this,d,"f")}set title(c){this.c(),Me(this,d,"f")!==c&&(Je(this,d,c,"f"),Me(this,T,"f").$setTitle(Me(this,R,"f"),c))}get iconPath(){return this.c(),Me(this,b,"f")}set iconPath(c){this.c(),Me(this,b,"f")!==c&&(Je(this,b,c,"f"),Me(this,T,"f").$setIconPath(Me(this,R,"f"),I.URI.isUri(c)?{light:c,dark:c}:c))}get options(){return Me(this,v,"f")}get viewColumn(){if(this.c(),!(typeof Me(this,f,"f")=="number"&&Me(this,f,"f")<0))return Me(this,f,"f")}get active(){return this.c(),Me(this,h,"f")}get visible(){return this.c(),Me(this,w,"f")}_updateViewState(c){Me(this,m,"f")||(this.active!==c.active||this.visible!==c.visible||this.viewColumn!==c.viewColumn)&&(Je(this,h,c.active,"f"),Je(this,w,c.visible,"f"),Je(this,f,c.viewColumn,"f"),Me(this,o,"f").fire({webviewPanel:this}))}reveal(c,n){this.c(),Me(this,T,"f").$reveal(Me(this,R,"f"),{viewColumn:typeof c>"u"?void 0:D.ViewColumn.from(c),preserveFocus:!!n})}c(){if(Me(this,m,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,T=new WeakMap,E=new WeakMap,y=new WeakMap,v=new WeakMap,d=new WeakMap,b=new WeakMap,f=new WeakMap,w=new WeakMap,h=new WeakMap,m=new WeakMap,p=new WeakMap,o=new WeakMap;class l{static c(){return(0,A.generateUuid)()}constructor(c,n,r){this.g=n,this.h=r,this.e=new Map,this.f=new Map,this.d=c.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(c,n,r,g,P={}){const L=typeof g=="object"?g.viewColumn:g,z={viewColumn:D.ViewColumn.from(L),preserveFocus:typeof g=="object"&&!!g.preserveFocus},_=(0,k.shouldSerializeBuffersForPostMessage)(c),K=l.c();this.d.$createWebviewPanel((0,k.toExtensionData)(c),K,n,{title:r,panelOptions:u(P),webviewOptions:(0,k.serializeWebviewOptions)(c,this.h,P),serializeBuffersForPostMessage:_},z);const F=this.g.createNewWebview(K,P,c);return this.createNewWebviewPanel(K,n,r,L,P,F,!0)}$onDidChangeWebviewPanelViewStates(c){const n=Object.keys(c);n.sort((r,g)=>{const P=c[r],L=c[g];return P.active?1:L.active?-1:+P.visible-+L.visible});for(const r of n){const g=this.getWebviewPanel(r);if(!g)continue;const P=c[r];g._updateViewState({active:P.active,visible:P.visible,viewColumn:D.ViewColumn.to(P.position)})}}async $onDidDisposeWebviewPanel(c){this.getWebviewPanel(c)?.dispose(),this.e.delete(c),this.g.deleteWebview(c)}registerWebviewPanelSerializer(c,n,r){if(this.f.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.f.set(n,{serializer:r,extension:c}),this.d.$registerSerializer(n,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(c)}),new C.Disposable(()=>{this.f.delete(n),this.d.$unregisterSerializer(n)})}async $deserializeWebviewPanel(c,n,r,g){const P=this.f.get(n);if(!P)throw new Error(`No serializer found for '${n}'`);const{serializer:L,extension:z}=P,_=this.g.createNewWebview(c,r.webviewOptions,z),K=this.createNewWebviewPanel(c,n,r.title,g,r.panelOptions,_,r.active);await L.deserializeWebviewPanel(K,r.state)}createNewWebviewPanel(c,n,r,g,P,L,z){const _=new i(c,this.d,L,{viewType:n,title:r,viewColumn:g,panelOptions:P,active:z});return this.e.set(c,_),_}getWebviewPanel(c){return this.e.get(c)}}e.ExtHostWebviewPanels=l;function u(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ne,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ne,a):I?I.value=a:e.set(ne,a),a},Me=this&&this.__classPrivateFieldGet||function(ne,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[272],ye([1,0,4,6,73,14,5,7]),function(ne,e,a,t,I,A,D,k){"use strict";var S,C,R,T,E,y,v,d,b,f,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class h extends t.Disposable{constructor(o,i,l,u,s,c){super(),S.set(this,void 0),C.set(this,void 0),R.set(this,void 0),T.set(this,void 0),E.set(this,!1),y.set(this,void 0),v.set(this,void 0),d.set(this,void 0),b.set(this,void 0),f.set(this,this.B(new a.Emitter)),this.onDidChangeVisibility=Me(this,f,"f").event,w.set(this,this.B(new a.Emitter)),this.onDidDispose=Me(this,w,"f").event,Je(this,R,l,"f"),Je(this,v,u,"f"),Je(this,S,o,"f"),Je(this,C,i,"f"),Je(this,T,s,"f"),Je(this,y,c,"f")}dispose(){Me(this,E,"f")||(Je(this,E,!0,"f"),Me(this,w,"f").fire(),Me(this,T,"f").dispose(),super.dispose())}get title(){return this.a(),Me(this,v,"f")}set title(o){this.a(),Me(this,v,"f")!==o&&(Je(this,v,o,"f"),Me(this,C,"f").$setWebviewViewTitle(Me(this,S,"f"),o))}get description(){return this.a(),Me(this,d,"f")}set description(o){this.a(),Me(this,d,"f")!==o&&(Je(this,d,o,"f"),Me(this,C,"f").$setWebviewViewDescription(Me(this,S,"f"),o))}get visible(){return Me(this,y,"f")}get webview(){return Me(this,T,"f")}get viewType(){return Me(this,R,"f")}_setVisible(o){o===Me(this,y,"f")||Me(this,E,"f")||(Je(this,y,o,"f"),Me(this,f,"f").fire())}get badge(){return this.a(),Me(this,b,"f")}set badge(o){this.a(),!(o?.value===Me(this,b,"f")?.value&&o?.tooltip===Me(this,b,"f")?.tooltip)&&(Je(this,b,A.ViewBadge.from(o),"f"),Me(this,C,"f").$setWebviewViewBadge(Me(this,S,"f"),o))}show(o){this.a(),Me(this,C,"f").$show(Me(this,S,"f"),!!o)}a(){if(Me(this,E,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,C=new WeakMap,R=new WeakMap,T=new WeakMap,E=new WeakMap,y=new WeakMap,v=new WeakMap,d=new WeakMap,b=new WeakMap,f=new WeakMap,w=new WeakMap;class m{constructor(o,i){this.d=i,this.b=new Map,this.c=new Map,this.a=o.getProxy(D.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(o,i,l,u){if(this.b.has(i))throw new Error(`View provider for '${i}' already registered`);return this.b.set(i,{provider:l,extension:o}),this.a.$registerWebviewViewProvider((0,I.toExtensionData)(o),i,{retainContextWhenHidden:u?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(o)}),new k.Disposable(()=>{this.b.delete(i),this.a.$unregisterWebviewViewProvider(i)})}async $resolveWebviewView(o,i,l,u,s){const c=this.b.get(i);if(!c)throw new Error(`No view provider found for '${i}'`);const{provider:n,extension:r}=c,g=this.d.createNewWebview(o,{},r),P=new h(o,this.a,i,l,g,!0);this.c.set(o,P),await n.resolveWebviewView(P,{state:u},s)}async $onDidChangeWebviewViewVisibility(o,i){this.e(o)._setVisible(i)}async $disposeWebviewView(o){const i=this.e(o);this.c.delete(o),i.dispose(),this.d.deleteWebview(o)}e(o){const i=this.c.get(o);if(!i)throw new Error("No webview found");return i}}e.ExtHostWebviewViews=m}),define(Se[141],ye([1,0,4,5,2,15,8,3,16]),function(ne,e,a,t,I,A,D,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class ii{get state(){return this.d}constructor(T){this.c=new a.Emitter,this.onDidChangeWindowState=this.c.event,this.d=ii.a,this.b=T.getProxy(t.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(E=>this.$onDidChangeWindowFocus(E))}$onDidChangeWindowFocus(T){T!==this.d.focused&&(this.d={...this.d,focused:T},this.c.fire(this.d))}openUri(T,E){let y;if(typeof T=="string"){y=T;try{T=I.URI.parse(T)}catch{return Promise.reject(`Invalid uri - '${T}'`)}}return(0,D.isFalsyOrWhitespace)(T.scheme)?Promise.reject("Invalid scheme - cannot be empty"):T.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${T.scheme}'`):this.b.$openUri(T,y,E)}async asExternalUri(T,E){if((0,D.isFalsyOrWhitespace)(T.scheme))return Promise.reject("Invalid scheme - cannot be empty");const y=await this.b.$asExternalUri(T,E);return I.URI.from(y)}};C.a={focused:!0},C=qe([We(0,S.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(Se[273],ye([1,0,117,274,65,39,2,13,46]),function(ne,e,a,t,I,A,D,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class C{constructor(E,y,v){this.b=E,this.c=y,this.f=v,this.a=t.createServer((d,b)=>this.h(d,b)),this.g().catch(d=>(y.error(d),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",E=>this.c.error(E))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(E,y){const v=(b,f)=>{y.writeHead(b,{"content-type":"application/json"}),y.end(JSON.stringify(f||null),w=>w&&this.c.error(w))},d=[];E.setEncoding("utf8"),E.on("data",b=>d.push(b)),E.on("end",async()=>{try{const b=JSON.parse(d.join(""));let f;switch(b.type){case"open":f=await this.i(b);break;case"openExternal":f=await this.j(b);break;case"status":f=await this.l(b);break;case"extensionManagement":f=await this.k(b);break;default:v(404,`Unknown message type: ${b.type}`);break}v(200,f)}catch(b){const f=b instanceof Error?b.message:JSON.stringify(b);v(500,f),this.c.error("Error while processing pipe request",b)}})}async i(E){const{fileURIs:y,folderURIs:v,forceNewWindow:d,diffMode:b,mergeMode:f,addMode:w,forceReuseWindow:h,gotoLineMode:m,waitMarkerFilePath:p,remoteAuthority:o}=E,i=[];if(Array.isArray(v))for(const c of v)try{i.push({folderUri:D.URI.parse(c)})}catch{}if(Array.isArray(y))for(const c of y)try{(0,S.hasWorkspaceFileExtension)(c)?i.push({workspaceUri:D.URI.parse(c)}):i.push({fileUri:D.URI.parse(c)})}catch{}const l=p?D.URI.file(p):void 0,s={forceNewWindow:d,diffMode:b,mergeMode:f,addMode:w,gotoLineMode:m,forceReuseWindow:h,preferNewWindow:!h&&!l&&!w,waitMarkerFileURI:l,remoteAuthority:o};return this.b.executeCommand("_remoteCLI.windowOpen",i,s),""}async j(E){for(const y of E.uris){const v=D.URI.parse(y),d=v.scheme==="file"?v:y;await this.b.executeCommand("_remoteCLI.openExternal",d)}}async k(E){const y=d=>d?.map(b=>/\.vsix$/i.test(b)?D.URI.parse(b):b),v={list:E.list,install:y(E.install),uninstall:y(E.uninstall),force:E.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",v)}async l(E){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&I.existsSync(this.f)&&I.unlinkSync(this.f)}}e.CLIServerBase=C;let R=class extends C{constructor(E,y){super(E,y,(0,a.createRandomIPCHandle)())}};R=qe([We(0,A.IExtHostCommands),We(1,k.ILogService)],R),e.CLIServer=R}),define(Se[275],ye([1,0,246,25,16]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const A=1024*1024;let D=class extends a.AbstractExtHostConsoleForwarder{constructor(S,C){super(S,C),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(S,C,R){const T=S==="error"||S==="warn"?process.stderr:process.stdout;this.g=!0,T.write(`
START_NATIVE_LOG
`),C.apply(console,R),T.write(`
END_NATIVE_LOG
`),this.g=!1}j(S,C){const R=process[S],T=R.write;let E="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(y,v,d)=>{if(!this.g){E+=y.toString(v);const b=E.length>A?E.length:E.lastIndexOf(`
`);b!==-1&&(console[C](E.slice(0,b)),E=E.slice(b+1))}T.call(R,y,v,d)}})}};D=qe([We(0,I.IExtHostRpcService),We(1,t.IExtHostInitDataService)],D),e.ExtHostConsoleForwarder=D}),define(Se[276],ye([1,0,9,86,30,39,6,5,2,16]),function(ne,e,a,t,I,A,D,k,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let R=class extends D.Disposable{constructor(E,y){super();const v=E.getProxy(k.MainContext.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async d=>{const b=S.URI.file((0,a.join)((0,t.tmpdir)(),(0,I.generateUuid)()));return await v.$download(d,b),b})}};R=qe([We(0,C.IExtHostRpcService),We(1,A.IExtHostCommands)],R),e.ExtHostDownloadService=R}),define(Se[277],ye([1,0,140,15,198,30]),function(ne,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class D extends a.ExtHostLoggerService{f(S,C,R){return S.scheme===t.Schemas.file?new I.SpdLogLogger(R?.name||(0,A.generateUuid)(),S.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,C):super.f(S,C,R)}}e.ExtHostLoggerService=D}),define(Se[278],ye([1,0,65,9,2,72,6,15,18,29]),function(ne,e,a,t,I,A,D,k,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class R extends A.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(o){const i=await super.g(o);if(i.scheme!==k.Schemas.file)return i;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${i.fsPath}.`),i;const l=i.fsPath;let u=0;do{let s;u===0?s=l:s=/[/\\]$/.test(l)?`${l.substr(0,l.length-1)}-${u}`:`${l}-${u}`,await T(s);const c=t.join(s,"vscode.lock"),n=await d(this.d,c,!1);if(n)return this.i=n,process.on("exit",()=>{n.dispose()}),I.URI.file(s);u++}while(u<10);return i}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=R;async function T(p){try{await C.Promises.stat(p);return}catch{}try{await C.Promises.mkdir(p,{recursive:!0})}catch{}}const E=1e3,y=10*60*1e3;class v extends D.Disposable{constructor(o,i){super(),this.b=o,this.c=i,this.a=this.B(new S.IntervalTimer),this.a.cancelAndSet(async()=>{const l=await b(o,i);(!l||l.pid!==process.pid)&&(o.info(`Lock '${i}': The lock was lost unexpectedly.`),this.a.cancel());try{await C.Promises.utimes(i,new Date,new Date)}catch(u){o.error(u),o.info(`Lock '${i}': Could not update mtime.`)}},E)}dispose(){super.dispose();try{a.unlinkSync(this.c)}catch{}}async setWillRelease(o){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${o} ms.`);try{const i={pid:process.pid,willReleaseAt:Date.now()+o};await C.Promises.writeFile(this.c,JSON.stringify(i),{flag:"w"})}catch(i){this.b.error(i)}}}async function d(p,o,i){try{const u={pid:process.pid,willReleaseAt:0};await C.Promises.writeFile(o,JSON.stringify(u),{flag:"wx"})}catch(u){p.error(u)}const l=await b(p,o);return!l||l.pid!==process.pid?i?(p.info(`Lock '${o}': Could not acquire lock, giving up.`),null):(p.info(`Lock '${o}': Could not acquire lock, checking if the file is stale.`),h(p,o)):(p.info(`Lock '${o}': Lock acquired.`),new v(p,o))}async function b(p,o){let i;try{i=await C.Promises.readFile(o)}catch(l){return p.error(l),null}try{return JSON.parse(String(i))}catch(l){return p.error(l),null}}async function f(p,o){let i;try{i=await C.Promises.stat(o)}catch(l){return p.error(l),0}return i.mtime.getTime()}function w(p){try{return process.kill(p,0),!0}catch{return!1}}async function h(p,o){const i=await b(p,o);if(!i)return p.info(`Lock '${o}': Could not read pid of lock holder.`),m(p,o);if(i.willReleaseAt){let n=i.willReleaseAt-Date.now();if(n<5e3){for(n>0?p.info(`Lock '${o}': The lockfile is scheduled to be released in ${n} ms.`):p.info(`Lock '${o}': The lockfile is scheduled to have been released.`);n>0;){if(await(0,S.timeout)(Math.min(100,n)),await f(p,o)===0)return m(p,o);n=i.willReleaseAt-Date.now()}return m(p,o)}}if(!w(i.pid))return p.info(`Lock '${o}': The pid ${i.pid} appears to be gone.`),m(p,o);const l=await f(p,o),u=Date.now()-l;if(u<=y)return p.info(`Lock '${o}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null;p.info(`Lock '${o}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const s=await f(p,o),c=Date.now()-s;return c<=y?(p.info(`Lock '${o}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null):(p.info(`Lock '${o}': The lock looks stale even after waiting for 2s.`),m(p,o))}async function m(p,o){p.info(`Lock '${o}': Deleting a stale lock.`);try{await C.Promises.unlink(o)}catch{}return d(p,o,!0)}}),define(Se[279],ye([1,0,30,16,40]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let A=class extends I.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,S,C){return this.createTerminalFromOptions({name:k,shellPath:S,shellArgs:C})}createTerminalFromOptions(k,S){const C=new I.ExtHostTerminal(this.a,(0,a.generateUuid)(),k,k.name);return this.f.push(C),C.create(k,this.L(k,S)),C.value}};A=qe([We(0,t.IExtHostRpcService)],A),e.ExtHostTerminalService=A}),define(Se[280],ye([1,0,5,16,181,6,25,2,45,24,29,7,12,54,4,129,100,13]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v,d,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class w extends d.DisposableTunnel{}function h(n){const r=n.trim().split(`
`),g=[];return r.forEach(L=>{const z=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(L);z&&z.length>=3&&g.push({pid:parseInt(z[1],10),socket:parseInt(z[2],10)})}),g.reduce((L,z)=>(L[z.socket]=z,L),{})}e.getSockets=h;function m(...n){const r=[].concat(...n.map(o));return[...new Map(r.filter(g=>g.st==="0A").map(g=>{const P=g.local_address.split(":");return{socket:parseInt(g.inode,10),ip:p(P[0]),port:parseInt(P[1],16)}}).map(g=>[g.ip+":"+g.port,g])).values()]}e.loadListeningPorts=m;function p(n){let r="";if(n.length===8)for(let g=n.length-2;g>=0;g-=2)r+=parseInt(n.substr(g,2),16),g!==0&&(r+=".");else for(let g=n.length-4;g>=0;g-=4)r+=parseInt(n.substr(g,4),16).toString(16),g!==0&&(r+=":");return r}function o(n){const r=n.trim().split(`
`),g=r.shift().trim().split(/\s+/).filter(L=>L!=="rx_queue"&&L!=="tm->when");return r.map(L=>L.trim().split(/\s+/).reduce((z,_,K)=>(z[g[K]||K]=_,z),{}))}e.loadConnectionTable=o;function i(n){return!!n.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||n.indexOf("out/server-main.js")!==-1||n.indexOf("_productName=VSCode")!==-1}function l(n){const r=n.trim().split(`
`),g=[];return r.forEach(P=>{const L=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(P);L&&L.length>=4&&g.push({pid:parseInt(L[1],10),ppid:parseInt(L[2]),cmd:L[3]})}),g}e.getRootProcesses=l;async function u(n,r,g){const P=g.reduce((z,_)=>(z[_.pid]=_,z),{}),L=[];return n.forEach(({socket:z,ip:_,port:K})=>{const F=r[z]?r[z].pid:void 0,M=F?P[F]?.cmd:void 0;F&&M&&!i(M)&&L.push({host:_,port:K,detail:M,pid:F})}),L}e.findPorts=u;function s(n,r,g){const P=new Map,L=l(r);for(const z of n){const _=g.get(z.port);if(_){P.set(z.port,_);continue}const K=L.find(F=>F.cmd.includes(`${z.port}`));if(K){let F=K,M;do M=L.find(N=>N.ppid===F.pid),M&&(F=M);while(M);P.set(z.port,{host:z.ip,port:z.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else P.set(z.port,{host:z.ip,port:z.port,ppid:Number.MAX_VALUE})}return P}e.tryFindRootPorts=s;let c=class extends A.Disposable{constructor(r,g,P){super(),this.n=P,this.c=()=>Promise.resolve(!0),this.f=new Map,this.g=new v.Emitter,this.onDidChangeTunnels=this.g.event,this.h=!1,this.j=new Map,this.k=0,this.l=new Map,this.a=r.getProxy(a.MainContext.MainThreadTunnelService),E.isLinux&&g.remote.isRemote&&g.remote.authority&&this.a.$setRemoteTunnelService(process.pid)}async openTunnel(r,g){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${r.identifier.value} called openTunnel API for ${g.remoteAddress.host}:${g.remoteAddress.port}.`);const P=await this.a.$openTunnel(g,r.displayName);if(P){const L=new w(P.remoteAddress,P.localAddress,()=>this.a.$closeTunnel(P.remoteAddress));return this.B(L),L}}async getTunnels(){return this.a.$getTunnels()}p(r){return Math.max(r*20,2e3)}r(){return this.k++}registerPortsAttributesProvider(r,g){const P=this.r();return this.l.set(P,{selector:r,provider:g}),this.a.$registerPortsAttributesProvider(r,P),new T.Disposable(()=>{this.l.delete(P),this.a.$unregisterPortsAttributesProvider(P)})}async $providePortAttributes(r,g,P,L,z){const _=[];for(const F of r){const M=this.l.get(F);if(!M)return[];_.push(...await Promise.all(g.map(async N=>M.provider.providePortAttributes(N,P,L,z))))}const K=_.filter(F=>!!F);return K.length>0?K.map(F=>({autoForwardAction:F.autoForwardAction,port:F.port})):[]}async $registerCandidateFinder(r){if(r&&this.h)return;this.h=r;const g=new b.MovingAverage;let P;for(;this.h;){const L=new Date().getTime(),z=(await this.findCandidatePorts()).filter(K=>(0,d.isLocalhost)(K.host)||(0,d.isAllInterfaces)(K.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${z.map(K=>K.port).join(", ")}`);const _=new Date().getTime()-L;g.update(_),(!P||JSON.stringify(P)!==JSON.stringify(z))&&(P=z,await this.a.$onFoundNewCandidates(P)),await new Promise(K=>setTimeout(()=>K(),this.p(g.value)))}}async setTunnelFactory(r){if(r){if(r.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(r.candidatePortSource),r.showCandidatePort&&(this.c=r.showCandidatePort,this.a.$setCandidateFilter()),r.tunnelFactory){this.b=r.tunnelFactory;let g=r.tunnelFeatures?.privacyOptions??[];r.tunnelFeatures?.public&&g.length===0&&(g=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const P=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,public:!!r.tunnelFeatures?.public,privacyOptions:g}:void 0;this.a.$setTunnelProvider(P)}}else this.b=void 0;return(0,A.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(r,g){if(this.f.has(r.host)){const P=this.f.get(r.host);P.has(r.port)&&(g&&P.get(r.port).disposeListener.dispose(),await P.get(r.port).tunnel.dispose(),P.delete(r.port))}}async $onDidTunnelsChange(){this.g.fire()}async $forwardPort(r,g){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const P=this.b(r,g);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),P!==void 0){const L=await P;this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.f.has(r.remoteAddress.host)||this.f.set(r.remoteAddress.host,new Map);const z=this.B(L.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(L.remoteAddress))));return this.f.get(r.remoteAddress.host).set(r.remoteAddress.port,{tunnel:L,disposeListener:z}),y.TunnelDtoConverter.fromApiTunnel(L)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(r){const g=await Promise.all(r.map(L=>this.c(L.host,L.port,L.detail??""))),P=r.filter((L,z)=>g[z]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${r.map(L=>L.port).join(", ")} to ${P.map(L=>L.port).join(", ")}`),P}async findCandidatePorts(){let r="",g="";try{r=await R.Promises.readFile("/proc/net/tcp","utf8"),g=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const P=m(r,g),L=await new Promise(U=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(W,x,V)=>{U(x)})}),z=h(L),_=await R.Promises.readdir("/proc"),K=[];for(const U of _)try{const W=Number(U),x=C.joinPath(k.URI.file("/proc"),U);if((await R.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(W)){const X=await R.Promises.readlink(C.joinPath(x,"cwd").fsPath),Q=await R.Promises.readFile(C.joinPath(x,"cmdline").fsPath,"utf8");K.push({pid:W,cwd:X,cmd:Q})}}catch{}const F=[],M=P.filter(U=>{const W=z[U.socket];return W||F.push(U),W}),N=u(M,z,K);let B;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const U=await new Promise(W=>{(0,S.exec)("ps -F -A -l | grep root",(x,V,X)=>{W(V)})});this.j=s(F,U,this.j),B=Array.from(this.j.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${B.map(W=>W.port).join(", ")}`)}return N.then(U=>B?U.concat(B):U)}};c=qe([We(0,t.IExtHostRpcService),We(1,D.IExtHostInitDataService),We(2,f.ILogService)],c),e.ExtHostTunnelService=c}),define(Se[281],ye([1,0,18,22,21,10,4,6,112,240,57]),function(ne,e,a,t,I,A,D,k,S,C,R){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function E(P,L){try{return JSON.stringify(P,L)}catch{return"null"}}const y="$$ref$$",v={[y]:-1};class d{constructor(L,z){this.jsonString=L,this.referencedBuffers=z}}function b(P,L=null,z=!1){const _=[];return{jsonString:(z?E:JSON.stringify)(P,(F,M)=>{if(typeof M>"u")return v;if(typeof M=="object"){if(M instanceof t.VSBuffer){const N=_.push(M)-1;return{[y]:N}}if(L)return L(F,M)}return M}),referencedBuffers:_}}e.stringifyJsonWithBufferRefs=b;function f(P,L,z){return JSON.parse(P,(_,K)=>{if(K){const F=K[y];if(typeof F=="number")return L[F];if(z&&K.$mid===1)return z.transformIncoming(K)}return K})}e.parseJsonAndRestoreBufferRefs=f;function w(P,L){return JSON.stringify(P,L)}function h(P){return P?(L,z)=>z&&z.$mid===1?P.transformOutgoing(z):z:null}var m;(function(P){P[P.LocalSide=0]="LocalSide",P[P.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(P){P[P.Responsive=0]="Responsive",P[P.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const o=()=>{},i=Symbol.for("rpcProtocol"),l=Symbol.for("rpcProxy");class u extends k.Disposable{constructor(L,z=null,_=null){super(),this[T]=!0,this.b=this.B(new D.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=L,this.f=z,this.g=_,this.h=h(this.g),this.j=!1,this.k=[],this.l=[];for(let K=0,F=R.ProxyIdentifier.count;K<F;K++)this.k[K]=null,this.l[K]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new a.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(K=>this.G(K))}dispose(){this.j=!0,Object.keys(this.s).forEach(L=>{this.s[L].resolveErr(A.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(L){this.u===0&&(this.v=Date.now()+u.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(L){this.v=Date.now()+u.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(L){this.t!==L&&(this.t=L,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(L){return this.g?(0,S.transformIncomingURIs)(L,this.g):L}getProxy(L){const{nid:z,sid:_}=L;return this.l[z]||(this.l[z]=this.F(z,_)),this.l[z]}F(L,z){const _={get:(K,F)=>(typeof F=="string"&&!K[F]&&F.charCodeAt(0)===36&&(K[F]=(...M)=>this.O(L,F,M)),F===l?z:K[F])};return new Proxy(Object.create(null),_)}set(L,z){return this.k[L.nid]=z,z}assertRegistered(L){for(let z=0,_=L.length;z<_;z++){const K=L[z];if(!this.k[K.nid])throw new Error(`Missing proxy instance ${K.sid}`)}}G(L){if(this.j)return;const z=L.byteLength,_=s.read(L,0),K=_.readUInt8(),F=_.readUInt32();switch(K){case 1:case 2:{let{rpcId:M,method:N,args:B}=n.deserializeRequestJSONArgs(_);this.g&&(B=(0,S.transformIncomingURIs)(B,this.g)),this.H(z,F,M,N,B,K===2);break}case 3:case 4:{let{rpcId:M,method:N,args:B}=n.deserializeRequestMixedArgs(_);this.g&&(B=(0,S.transformIncomingURIs)(B,this.g)),this.H(z,F,M,N,B,K===4);break}case 5:{this.f?.logIncoming(z,F,0,"ack"),this.z(F);break}case 6:{this.I(z,F);break}case 7:{this.J(z,F,void 0);break}case 9:{let M=n.deserializeReplyOKJSON(_);this.g&&(M=(0,S.transformIncomingURIs)(M,this.g)),this.J(z,F,M);break}case 10:{const M=n.deserializeReplyOKJSONWithBuffers(_,this.g);this.J(z,F,M);break}case 8:{const M=n.deserializeReplyOKVSBuffer(_);this.J(z,F,M);break}case 11:{let M=n.deserializeReplyErrError(_);this.g&&(M=(0,S.transformIncomingURIs)(M,this.g)),this.L(z,F,M);break}case 12:{this.L(z,F,void 0);break}default:console.error("received unexpected message"),console.error(L)}}H(L,z,_,K,F,M){this.f?.logIncoming(L,z,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(_)}.${K}(`,F);const N=String(z);let B,U;if(M){const x=new I.CancellationTokenSource;F.push(x.token),B=this.M(_,K,F),U=()=>x.cancel()}else B=this.M(_,K,F),U=o;this.p[N]=U;const W=n.serializeAcknowledged(z);this.f?.logOutgoing(W.byteLength,z,1,"ack"),this.c.send(W),B.then(x=>{delete this.p[N];const V=n.serializeReplyOK(z,x,this.h);this.f?.logOutgoing(V.byteLength,z,1,"reply:",x),this.c.send(V)},x=>{delete this.p[N];const V=n.serializeReplyErr(z,x);this.f?.logOutgoing(V.byteLength,z,1,"replyErr:",x),this.c.send(V)})}I(L,z){this.f?.logIncoming(L,z,1,"receiveCancel");const _=String(z);this.p[_]?.()}J(L,z,_){this.f?.logIncoming(L,z,0,"receiveReply:",_);const K=String(z);if(!this.s.hasOwnProperty(K))return;const F=this.s[K];delete this.s[K],F.resolveOk(_)}L(L,z,_){this.f?.logIncoming(L,z,0,"receiveReplyErr:",_);const K=String(z);if(!this.s.hasOwnProperty(K))return;const F=this.s[K];delete this.s[K];let M;_&&(_.$isError?(M=new Error,M.name=_.name,M.message=_.message,M.stack=_.stack):M=_),F.resolveErr(M)}M(L,z,_){try{return Promise.resolve(this.N(L,z,_))}catch(K){return Promise.reject(K)}}N(L,z,_){const K=this.k[L];if(!K)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(L));const F=K[z];if(typeof F!="function")throw new Error("Unknown method "+z+" on actor "+(0,R.getStringIdentifierForProxy)(L));return F.apply(K,_)}O(L,z,_){if(this.j)return new C.CanceledLazyPromise;let K=null;if(_.length>0&&I.CancellationToken.isCancellationToken(_[_.length-1])&&(K=_.pop()),K&&K.isCancellationRequested)return Promise.reject(A.canceled());const F=n.serializeRequestArguments(_,this.h),M=++this.m,N=String(M),B=new C.LazyPromise;K&&K.onCancellationRequested(()=>{const W=n.serializeCancel(M);this.f?.logOutgoing(W.byteLength,M,0,"cancel"),this.c.send(n.serializeCancel(M))}),this.s[N]=B,this.y(M);const U=n.serializeRequest(M,L,z,F,!!K);return this.f?.logOutgoing(U.byteLength,M,0,`request: ${(0,R.getStringIdentifierForProxy)(L)}.${z}(`,_),this.c.send(U),B}}e.RPCProtocol=u,T=i,u.a=3*1e3;class s{static alloc(L,z,_){const K=new s(t.VSBuffer.alloc(_+1+4),0);return K.writeUInt8(L),K.writeUInt32(z),K}static read(L,z){return new s(L,z)}get buffer(){return this.a}constructor(L,z){this.a=L,this.b=z}static sizeUInt8(){return 1}writeUInt8(L){this.a.writeUInt8(L,this.b),this.b+=1}readUInt8(){const L=this.a.readUInt8(this.b);return this.b+=1,L}writeUInt32(L){this.a.writeUInt32BE(L,this.b),this.b+=4}readUInt32(){const L=this.a.readUInt32BE(this.b);return this.b+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this.a.writeUInt8(L.byteLength,this.b),this.b+=1,this.a.set(L,this.b),this.b+=L.byteLength}readShortString(){const L=this.a.readUInt8(this.b);this.b+=1;const _=this.a.slice(this.b,this.b+L).toString();return this.b+=L,_}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readLongString(){const L=this.a.readUInt32BE(this.b);this.b+=4;const _=this.a.slice(this.b,this.b+L).toString();return this.b+=L,_}writeBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readVSBuffer(){const L=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+L);return this.b+=L,z}static sizeMixedArray(L){let z=0;z+=1;for(let _=0,K=L.length;_<K;_++){const F=L[_];switch(z+=1,F.type){case 1:z+=this.sizeLongString(F.value);break;case 2:z+=this.sizeVSBuffer(F.value);break;case 3:z+=this.sizeUInt32,z+=this.sizeLongString(F.value);for(let M=0;M<F.buffers.length;++M)z+=this.sizeVSBuffer(F.buffers[M]);break;case 4:break}}return z}writeMixedArray(L){this.a.writeUInt8(L.length,this.b),this.b+=1;for(let z=0,_=L.length;z<_;z++){const K=L[z];switch(K.type){case 1:this.writeUInt8(1),this.writeLongString(K.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(K.value);break;case 3:this.writeUInt8(3),this.writeUInt32(K.buffers.length),this.writeLongString(K.value);for(let F=0;F<K.buffers.length;++F)this.writeBuffer(K.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this.a.readUInt8(this.b);this.b+=1;const z=new Array(L);for(let _=0;_<L;_++)switch(this.readUInt8()){case 1:z[_]=this.readLongString();break;case 2:z[_]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),M=this.readLongString(),N=[];for(let B=0;B<F;++B)N.push(this.readVSBuffer());z[_]=new R.SerializableObjectWithBuffers(f(M,N,null));break}case 4:z[_]=void 0;break}return z}}s.sizeUInt32=4;var c;(function(P){P[P.Simple=0]="Simple",P[P.Mixed=1]="Mixed"})(c||(c={}));class n{static a(L){for(let z=0,_=L.length;z<_;z++)if(L[z]instanceof t.VSBuffer||L[z]instanceof R.SerializableObjectWithBuffers||typeof L[z]>"u")return!0;return!1}static serializeRequestArguments(L,z){if(this.a(L)){const _=[];for(let K=0,F=L.length;K<F;K++){const M=L[K];if(M instanceof t.VSBuffer)_[K]={type:2,value:M};else if(typeof M>"u")_[K]={type:4};else if(M instanceof R.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:B}=b(M.value,z);_[K]={type:3,value:t.VSBuffer.fromString(N),buffers:B}}else _[K]={type:1,value:t.VSBuffer.fromString(w(M,z))}}return{type:1,args:_}}return{type:0,args:w(L,z)}}static serializeRequest(L,z,_,K,F){switch(K.type){case 0:return this.b(L,z,_,K.args,F);case 1:return this.c(L,z,_,K.args,F)}}static b(L,z,_,K,F){const M=t.VSBuffer.fromString(_),N=t.VSBuffer.fromString(K);let B=0;B+=s.sizeUInt8(),B+=s.sizeShortString(M),B+=s.sizeLongString(N);const U=s.alloc(F?2:1,L,B);return U.writeUInt8(z),U.writeShortString(M),U.writeLongString(N),U.buffer}static deserializeRequestJSONArgs(L){const z=L.readUInt8(),_=L.readShortString(),K=L.readLongString();return{rpcId:z,method:_,args:JSON.parse(K)}}static c(L,z,_,K,F){const M=t.VSBuffer.fromString(_);let N=0;N+=s.sizeUInt8(),N+=s.sizeShortString(M),N+=s.sizeMixedArray(K);const B=s.alloc(F?4:3,L,N);return B.writeUInt8(z),B.writeShortString(M),B.writeMixedArray(K),B.buffer}static deserializeRequestMixedArgs(L){const z=L.readUInt8(),_=L.readShortString(),K=L.readMixedArray(),F=new Array(K.length);for(let M=0,N=K.length;M<N;M++){const B=K[M];typeof B=="string"?F[M]=JSON.parse(B):F[M]=B}return{rpcId:z,method:_,args:F}}static serializeAcknowledged(L){return s.alloc(5,L,0).buffer}static serializeCancel(L){return s.alloc(6,L,0).buffer}static serializeReplyOK(L,z,_){if(typeof z>"u")return this.d(L);if(z instanceof t.VSBuffer)return this.e(L,z);if(z instanceof R.SerializableObjectWithBuffers){const{jsonString:K,referencedBuffers:F}=b(z.value,_,!0);return this.g(L,K,F)}else return this.f(L,E(z,_))}static d(L){return s.alloc(7,L,0).buffer}static e(L,z){let _=0;_+=s.sizeVSBuffer(z);const K=s.alloc(8,L,_);return K.writeVSBuffer(z),K.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static f(L,z){const _=t.VSBuffer.fromString(z);let K=0;K+=s.sizeLongString(_);const F=s.alloc(9,L,K);return F.writeLongString(_),F.buffer}static g(L,z,_){const K=t.VSBuffer.fromString(z);let F=0;F+=s.sizeUInt32,F+=s.sizeLongString(K);for(const N of _)F+=s.sizeVSBuffer(N);const M=s.alloc(10,L,F);M.writeUInt32(_.length),M.writeLongString(K);for(const N of _)M.writeBuffer(N);return M.buffer}static deserializeReplyOKJSON(L){const z=L.readLongString();return JSON.parse(z)}static deserializeReplyOKJSONWithBuffers(L,z){const _=L.readUInt32(),K=L.readLongString(),F=[];for(let M=0;M<_;++M)F.push(L.readVSBuffer());return new R.SerializableObjectWithBuffers(f(K,F,z))}static serializeReplyErr(L,z){const _=z?E(A.transformErrorForSerialization(z),null):void 0;if(typeof _!="string")return this.h(L);const K=t.VSBuffer.fromString(_);let F=0;F+=s.sizeLongString(K);const M=s.alloc(11,L,F);return M.writeLongString(K),M.buffer}static deserializeReplyErrError(L){const z=L.readLongString();return JSON.parse(z)}static h(L){return s.alloc(12,L,0).buffer}}var r;(function(P){P[P.RequestJSONArgs=1]="RequestJSONArgs",P[P.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",P[P.RequestMixedArgs=3]="RequestMixedArgs",P[P.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",P[P.Acknowledged=5]="Acknowledged",P[P.Cancel=6]="Cancel",P[P.ReplyOKEmpty=7]="ReplyOKEmpty",P[P.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",P[P.ReplyOKJSON=9]="ReplyOKJSON",P[P.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",P[P.ReplyErrError=11]="ReplyErrError",P[P.ReplyErrEmpty=12]="ReplyErrEmpty"})(r||(r={}));var g;(function(P){P[P.String=1]="String",P[P.VSBuffer=2]="VSBuffer",P[P.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",P[P.Undefined=4]="Undefined"})(g||(g={}))}),define(Se[282],ye([1,0,4,43,53,3,38,10,18]),function(ne,e,a,t,I,A,D,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new I.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new I.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new I.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,A.createDecorator)(e.OUTPUT_SERVICE_ID);var C;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(C=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.a=new Map,this.b=new a.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new a.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(v){this.a.has(v.id)||(this.a.set(v.id,v),this.b.fire(v.id))}getChannels(){const v=[];return this.a.forEach(d=>v.push(d)),v}getChannel(v){return this.a.get(v)}removeChannel(v){this.a.delete(v),this.c.fire(v)}}t.Registry.add(e.Extensions.OutputChannels,new R);function T(y,v,d,b,f){return(0,S.createCancelablePromise)(async w=>{await(0,D.whenProviderRegistered)(d,b);const h=t.Registry.as(e.Extensions.OutputChannels);try{await E(d,1,b,f,w),h.registerChannel({id:y,label:v,file:d,log:!0})}catch(m){(0,k.isCancellationError)(m)||f.error("Error while registering log channel",d.toString(),(0,k.getErrorMessage)(m))}})}e.registerLogChannel=T;async function E(y,v,d,b,f){if(!await d.exists(y)){if(f.isCancellationRequested)throw new k.CancellationError;if(v>10)throw new Error("Timed out while waiting for file to be created");b.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",y.toString()),await(0,S.timeout)(1e3,f),await E(y,v+1,d,b,f)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new I.RawContextKey("activeOutputChannel","")}),define(Se[142],ye([1,0,5,3,16,27,13,282,71,25,47,156,22,11,38,4,6]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class f extends D.AbstractMessageLogger{get disposed(){return this.l}constructor(p,o,i,l,u){super(),this.id=p,this.name=o,this.m=i,this.n=l,this.extension=u,this.k=0,this.l=!1,this.visible=!1,this.setLevel(i.getLevel()),this.B(i.onDidChangeLogLevel(s=>this.setLevel(s)))}get logLevel(){return this.getLevel()}appendLine(p){this.append(p+`
`)}append(p){this.info(p)}clear(){const p=this.k;this.m.flush(),this.n.$update(this.id,k.OutputChannelUpdateMode.Clear,p)}replace(p){const o=this.k;this.info(p),this.n.$update(this.id,k.OutputChannelUpdateMode.Replace,o),this.visible&&this.m.flush()}show(p,o){this.m.flush(),this.n.$reveal(this.id,!!(typeof p=="boolean"?p:o))}hide(){this.n.$close(this.id)}g(p,o){this.k+=E.VSBuffer.fromString(o).byteLength,(0,D.log)(this.m,p,o),this.visible&&(this.m.flush(),this.n.$update(this.id,k.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class w extends f{appendLine(p){this.append(p)}}let h=class{constructor(p,o,i,l,u,s){this.i=o,this.j=i,this.k=l,this.l=u,this.m=s,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=p.getProxy(a.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(o.logsLocation,`output_logging_${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.h=p;for(const[o,i]of this.g)i.visible=o===this.h}createOutputChannel(p,o,i){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const l=typeof o=="object"&&o.log,u=(0,y.isString)(o)?o:void 0;if((0,y.isString)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let s;const c=this.i.environment.extensionLogLevel?.find(([r])=>A.ExtensionIdentifier.equals(i.identifier,r))?.[1];c&&(s=(0,D.parseLogLevel)(c));const n=l?this.o(p,s,i):this.n(p,u,i);return n.then(r=>{this.g.set(r.id,r),r.visible=r.id===this.h}),l?this.r(p,s??this.m.getLevel(),n):this.q(p,n)}async n(p,o,i){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const l=await this.c,u=this.k.extUri.joinPath(l,`${this.f++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.l.createLogger(u,{always:!0,donotRotate:!0,donotUseFormatters:!0}),c=await this.a.$register(p,u,!1,o,i.identifier.value);return new f(c,p,s,this.a,i)}async o(p,o,i){const l=await this.p(i),u=this.k.extUri.joinPath(l,`${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.l.createLogger(u,{name:p},o),c=await this.a.$register(p,u,!0,void 0,i.identifier.value);return new w(c,p,s,this.a,i)}p(p){let o=this.d.get(p.identifier.value);if(!o){const i=this.k.extUri.joinPath(this.i.logsLocation,p.identifier.value);this.d.set(p.identifier.value,o=(async()=>{try{await this.j.value.createDirectory(i)}catch(l){if((0,v.toFileSystemProviderErrorCode)(l)!==v.FileSystemProviderErrorCode.FileExists)throw l}return i})())}return o}q(p,o){let i=!1;const l=()=>{if(i)throw new Error("Channel has been closed")};return{get name(){return p},append(u){l(),o.then(s=>s.append(u))},appendLine(u){l(),o.then(s=>s.appendLine(u))},clear(){l(),o.then(u=>u.clear())},replace(u){l(),o.then(s=>s.replace(u))},show(u,s){l(),o.then(c=>c.show(u,s))},hide(){l(),o.then(u=>u.hide())},dispose(){i=!0,o.then(u=>u.dispose())}}}r(p,o,i){const l=new b.DisposableStore,u=()=>{if(l.isDisposed)throw new Error("Channel has been closed")},s=l.add(new d.Emitter);return i.then(c=>{l.add(c),l.add(c.onDidChangeLogLevel(n=>{o=n,s.fire(n)}))}),{...this.q(p,i),get logLevel(){return o},onDidChangeLogLevel:s.event,trace(c,...n){u(),i.then(r=>r.trace(c,...n))},debug(c,...n){u(),i.then(r=>r.debug(c,...n))},info(c,...n){u(),i.then(r=>r.info(c,...n))},warn(c,...n){u(),i.then(r=>r.warn(c,...n))},error(c,...n){u(),i.then(r=>r.error(c,...n))},dispose(){l.dispose()}}}};h=qe([We(0,I.IExtHostRpcService),We(1,C.IExtHostInitDataService),We(2,S.IExtHostConsumerFileSystem),We(3,R.IExtHostFileSystemInfo),We(4,D.ILoggerService),We(5,D.ILogService)],h),e.ExtHostOutputService=h,e.IExtHostOutputService=(0,t.createDecorator)("IExtHostOutputService")}),define(Se[283],ye([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,a.createDecorator)("remoteAgentService")}),define(Se[284],ye([1,0,32,15,9,12,24,2,3,210,46,227,283]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let y=class ri{constructor(d,b,f,w){this.d=d,this.e=b,this.f=f,this.g=w,this.a=(async()=>(await this.e.getEnvironment())?.os||A.OS)(),this.b=(async()=>{const h=await this.e.getEnvironment();return this.c=h?.userHome??d})()}hasValidBasename(d,b,f){return typeof b=="string"||typeof b>"u"?this.a.then(w=>this.h(d,w,b)):this.h(d,b,f)}h(d,b,f){return d.scheme===t.Schemas.file||d.scheme===t.Schemas.vscodeRemote?(0,a.isValidBasename)(f??(0,D.basename)(d),b===1):!0}get defaultUriScheme(){return ri.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(d,b){if(d.remoteAuthority)return t.Schemas.vscodeRemote;const f=(0,C.getVirtualWorkspaceScheme)(b.getWorkspace());if(f)return f;const w=b.getWorkspace().folders[0];if(w)return w.uri.scheme;const h=b.getWorkspace().configuration;return h?h.scheme:t.Schemas.file}userHome(d){return d?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(d=>d===1?I.win32:I.posix)}async fileURI(d){let b="";if(await this.a===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const w=d.indexOf("/",2);w===-1?(b=d.substring(2),d="/"):(b=d.substring(2,w),d=d.substring(w)||"/")}return k.URI.from({scheme:t.Schemas.file,authority:b,path:d,query:"",fragment:""})}};y=qe([We(1,E.IRemoteAgentService),We(2,T.IWorkbenchEnvironmentService),We(3,R.IWorkspaceContextService)],y),e.AbstractPathService=y}),define(Se[74],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class a{constructor(D,k){this.line=D,this.character=k}isBefore(D){return!1}isBeforeOrEqual(D){return!1}isAfter(D){return!1}isAfterOrEqual(D){return!1}isEqual(D){return!1}compareTo(D){return 0}translate(D,k){return new a(0,0)}with(D){return new a(0,0)}}e.Position=a;class t{constructor(D,k,S,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new a(D,k),this.end=new a(S,C)}contains(D){return!1}isEqual(D){return!1}intersection(D){}union(D){return new t(0,0,0,0)}with(D){return new t(0,0,0,0)}}e.Range=t;var I;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Se[31],ye([1,0,17,37,23,32,8,3,9,10,74,18]),function(ne,e,a,t,I,A,D,k,S,C,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const E="\u27EA ",y=" characters skipped \u27EB",v=(E.length+y.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var d;(function(Q){Q[Q.file=0]="file",Q[Q.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var b;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text"})(b=e.QueryType||(e.QueryType={}));function f(Q){return!!Q.preview}e.resultIsMatch=f;function w(Q){return!!Q.resource}e.isFileMatch=w;function h(Q){return!!Q.message}e.isProgressMessage=h;var m;(function(Q){Q[Q.Normal=0]="Normal",Q[Q.NewSearchStarted=1]="NewSearchStarted"})(m=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(J){this.resource=J,this.results=[]}}e.FileMatch=p;class o{constructor(J,te,le){this.ranges=te;const Z=Array.isArray(te)?te:[te];if(le&&le.matchLines===1&&i(Z)){J=(0,D.getNLines)(J,le.matchLines);let ge="",ve=0,De=0;const Re=Math.floor(le.charsPerLine/5),ze=[];for(const se of Z){const ue=Math.max(se.startColumn-Re,0),he=se.startColumn+le.charsPerLine;if(ue>De+Re+v){const ee=E+(ue-De)+y;ge+=ee+J.slice(ue,he),ve+=ue-(De+ee.length)}else ge+=J.slice(De,he);ze.push(new u(0,se.startColumn-ve,se.endColumn-ve)),De=he}this.preview={text:ge,matches:Array.isArray(this.ranges)?ze:ze[0]}}else{const ge=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:J,matches:(0,a.mapArrayOrNot)(te,ve=>new l(ve.startLineNumber-ge,ve.startColumn,ve.endLineNumber-ge,ve.endColumn))}}}}e.TextSearchMatch=o;function i(Q){const J=Q[0].startLineNumber;for(const te of Q)if(te.startLineNumber!==J||te.endLineNumber!==J)return!1;return!0}class l{constructor(J,te,le,Z){this.startLineNumber=J,this.startColumn=te,this.endLineNumber=le,this.endColumn=Z}}e.SearchRange=l;class u extends l{constructor(J,te,le){super(J,te,J,le)}}e.OneLineRange=u;var s;(function(Q){Q.List="list",Q.Tree="tree"})(s=e.ViewMode||(e.ViewMode={}));var c;(function(Q){Q.Default="default",Q.FileNames="fileNames",Q.Type="type",Q.Modified="modified",Q.CountDescending="countDescending",Q.CountAscending="countAscending"})(c=e.SearchSortOrder||(e.SearchSortOrder={}));function n(Q,J=!0){const te=Q&&Q.files&&Q.files.exclude,le=J&&Q&&Q.search&&Q.search.exclude;if(!te&&!le)return;if(!te||!le)return te||le;let Z=Object.create(null);return Z=I.mixin(Z,I.deepClone(te)),Z=I.mixin(Z,I.deepClone(le),!0),Z}e.getExcludes=n;function r(Q,J){return Q.excludePattern&&t.match(Q.excludePattern,J)?!1:Q.includePattern||Q.usingSearchPaths?Q.includePattern&&t.match(Q.includePattern,J)?!0:Q.usingSearchPaths?!!Q.folderQueries&&Q.folderQueries.some(te=>{const le=te.folder.fsPath;if(A.isEqualOrParent(J,le)){const Z=S.relative(le,J);return!te.includePattern||!!t.match(te.includePattern,Z)}else return!1}):!1:!0}e.pathIncludedInQuery=r;var g;(function(Q){Q[Q.unknownEncoding=1]="unknownEncoding",Q[Q.regexParseError=2]="regexParseError",Q[Q.globParseError=3]="globParseError",Q[Q.invalidLiteral=4]="invalidLiteral",Q[Q.rgProcessError=5]="rgProcessError",Q[Q.other=6]="other",Q[Q.canceled=7]="canceled"})(g=e.SearchErrorCode||(e.SearchErrorCode={}));class P extends Error{constructor(J,te){super(J),this.code=te}}e.SearchError=P;function L(Q){const J=Q.message;if((0,C.isCancellationError)(Q))return new P(J,g.canceled);try{const te=JSON.parse(J);return new P(te.message,te.code)}catch{return new P(J,g.other)}}e.deserializeSearchError=L;function z(Q){const J={message:Q.message,code:Q.code};return new Error(JSON.stringify(J))}e.serializeSearchError=z;function _(Q){return Q.type==="error"?!0:Q.type==="success"}e.isSerializedSearchComplete=_;function K(Q){return Q.type==="success"}e.isSerializedSearchSuccess=K;function F(Q){return!!Q.path}e.isSerializedFileMatch=F;function M(Q,J){const te=Q.searchPath?Q.searchPath:Q.relativePath;return(0,D.fuzzyContains)(te,J)}e.isFilePatternMatch=M;class N{constructor(J){this.path=J,this.results=[]}addMatch(J){this.results.push(J)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=N;function B(Q,J){const te={...Q||{},...J||{}};return Object.keys(te).filter(le=>{const Z=te[le];return typeof Z=="boolean"&&Z})}e.resolvePatternsForProvider=B;class U{constructor(J,te){this.c=null,this.a={...J.excludePattern||{},...te.excludePattern||{}},this.b=t.parse(this.a);let le=J.includePattern;te.includePattern&&(le?le={...le,...te.includePattern}:le=te.includePattern),le&&(this.c=t.parse(le))}matchesExcludesSync(J,te,le){return!!(this.b&&this.b(J,te,le))}includedInQuerySync(J,te,le){return!(this.b&&this.b(J,te,le)||this.c&&!this.c(J,te,le))}includedInQuery(J,te,le){const Z=this.b(J,te,le),ge=()=>this.c?!!this.c(J,te,le):!0;return(0,T.isThenable)(Z)?Z.then(ve=>ve?!1:ge()):ge()}hasSiblingExcludeClauses(){return W(this.a)}}e.QueryGlobTester=U;function W(Q){for(const J in Q)if(typeof Q[J]!="boolean")return!0;return!1}function x(Q){if(!Q)return;let J;return te=>(J||(J=(Q()||Promise.resolve([])).then(le=>le?X(le):{})),J.then(le=>!!le[te]))}e.hasSiblingPromiseFn=x;function V(Q){if(!Q)return;let J;return te=>{if(!J){const le=Q();J=le?X(le):{}}return!!J[te]}}e.hasSiblingFn=V;function X(Q){const J={};for(const te of Q)J[te]=!0;return J}}),define(Se[33],ye([1,0,17,18,21,4,6,64,15,100,24,8,11,2,179,3,13,199,46,47,25,16,14,7,55,31,5]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v,d,b,f,w,h,m,p,o,i,l,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function c(K,F,M){return new R.ExtUri(N=>P(N,M)).isEqual(K,F)}function n(K,F,M){return c(K.uri,F.uri,M)?0:(0,T.compare)(K.uri.toString(),F.uri.toString())}function r(K,F,M){return K.index!==F.index?K.index<F.index?-1:1:c(K.uri,F.uri,M)?(0,T.compare)(K.name,F.name):(0,T.compare)(K.uri.toString(),F.uri.toString())}function g(K,F,M,N){const B=K.slice(0).sort((W,x)=>M(W,x,N)),U=F.slice(0).sort((W,x)=>M(W,x,N));return(0,a.delta)(B,U,(W,x)=>M(W,x,N))}function P(K,F){const M=F.getCapabilities(K.scheme);return!(M&&M&1024)}class L extends w.Workspace{static toExtHostWorkspace(F,M,N,B){if(!F)return{workspace:null,added:[],removed:[]};const{id:U,name:W,folders:x,configuration:V,transient:X,isUntitled:Q}=F,J=[],te=M;M?x.forEach((ve,De)=>{const Re=y.URI.revive(ve.uri),ze=L.e(N||M,Re,B);ze?(ze.name=ve.name,ze.index=ve.index,J.push(ze)):J.push({uri:Re,name:ve.name,index:De})}):J.push(...x.map(({uri:ve,name:De,index:Re})=>({uri:y.URI.revive(ve),name:De,index:Re}))),J.sort((ve,De)=>ve.index<De.index?-1:1);const le=new L(U,W,J,!!X,V?y.URI.revive(V):null,!!Q,ve=>P(ve,B)),{added:Z,removed:ge}=g(te?te.workspaceFolders:[],le.workspaceFolders,n,B);return{workspace:le,added:Z,removed:ge}}static e(F,M,N){for(let B=0;B<F.folders.length;B++){const U=F.workspaceFolders[B];if(c(U.uri,M,N))return U}}constructor(F,M,N,B,U,W,x){super(F,N.map(V=>new w.WorkspaceFolder(V)),B,U,x),this.s=M,this.t=W,this.o=[],this.q=k.TernarySearchTree.forUris(x),N.forEach(V=>{this.o.push(V),this.q.set(V.uri,V)})}get name(){return this.s}get isUntitled(){return this.t}get workspaceFolders(){return this.o.slice(0)}getWorkspaceFolder(F,M){return M&&this.q.get(F)&&(F=(0,R.dirname)(F)),this.q.findSubstr(F)}resolveWorkspaceFolder(F){return this.q.get(F)}}let z=class{constructor(F,M,N,B,U){this.c=new A.Emitter,this.onDidChangeWorkspace=this.c.event,this.e=new A.Emitter,this.onDidGrantWorkspaceTrust=this.e.event,this.t=[],this.u=!1,this.v=new Map,this.y=0,this.g=B,this.q=N,this.s=U,this.h=new C.Counter,this.j=new t.Barrier,this.n=F.getProxy(s.MainContext.MainThreadWorkspace),this.o=F.getProxy(s.MainContext.MainThreadMessageService);const W=M.workspace;this.k=W?new L(W.id,W.name,[],!!W.transient,W.configuration?y.URI.revive(W.configuration):null,!!W.isUntitled,x=>P(x,N)):void 0}$initializeWorkspace(F,M){this.u=M,this.$acceptWorkspaceData(F),this.j.open()}waitForInitializeCall(){return this.j.wait()}get workspace(){return this.w}get name(){return this.w?this.w.name:void 0}get workspaceFile(){if(this.w&&this.w.configuration)return this.w.isUntitled?y.URI.from({scheme:S.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this.w.configuration))}):this.w.configuration}get w(){return this.l||this.k}getWorkspaceFolders(){if(!!this.w)return this.w.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.j.wait(),!!this.w)return this.w.workspaceFolders.slice(0)}updateWorkspaceFolders(F,M,N,...B){const U=[];if(Array.isArray(B)&&B.forEach(Q=>{y.URI.isUri(Q.uri)&&!U.some(J=>c(J.uri,Q.uri,this.q))&&U.push({uri:Q.uri,name:Q.name||(0,R.basenameOrAuthority)(Q.uri)})}),this.l||[M,N].some(Q=>typeof Q!="number"||Q<0)||N===0&&U.length===0)return!1;const W=this.w?this.w.workspaceFolders:[];if(M+N>W.length)return!1;const x=W.slice(0);x.splice(M,N,...U.map(Q=>({uri:Q.uri,name:Q.name||(0,R.basenameOrAuthority)(Q.uri),index:void 0})));for(let Q=0;Q<x.length;Q++){const J=x[Q];if(x.some((te,le)=>le!==Q&&c(J.uri,te.uri,this.q)))return!1}x.forEach((Q,J)=>Q.index=J);const{added:V,removed:X}=g(W,x,r,this.q);if(V.length===0&&X.length===0)return!1;if(this.n){const Q=F.displayName||F.name;this.n.$updateWorkspaceFolders(Q,M,N,U).then(void 0,J=>{this.l=void 0;const te={source:{identifier:F.identifier,label:F.displayName||F.name}};this.o.$showMessage(f.Severity.Error,(0,v.localize)(0,null,Q,J.toString()),te,[])})}return this.x(x),!0}getWorkspaceFolder(F,M){if(!!this.w)return this.w.getWorkspaceFolder(F,M)}async getWorkspaceFolder2(F,M){if(await this.j.wait(),!!this.w)return this.w.getWorkspaceFolder(F,M)}async resolveWorkspaceFolder(F){if(await this.j.wait(),!!this.w)return this.w.resolveWorkspaceFolder(F)}getPath(){if(!this.w)return;const{folders:F}=this.w;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,M){let N,B="";if(typeof F=="string"?(N=y.URI.file(F),B=F):typeof F<"u"&&(N=F,B=F.fsPath),!N)return B;const U=this.getWorkspaceFolder(N,!0);if(!U)return B;typeof M>"u"&&this.w&&(M=this.w.folders.length>1);let W=(0,R.relativePath)(U.uri,N);return M&&U.name&&(W=`${U.name}/${W}`),W}x(F){this.w&&(this.l=L.toExtHostWorkspace({id:this.w.id,name:this.w.name,configuration:this.w.configuration,folders:F,isUntitled:this.w.isUntitled},this.w,void 0,this.q).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:M,added:N,removed:B}=L.toExtHostWorkspace(F,this.k,this.l,this.q);this.k=M||void 0,this.l=void 0,this.c.fire(Object.freeze({added:N,removed:B}))}findFiles(F,M,N,B,U=I.CancellationToken.None){this.g.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let W;if(M===null?W=!1:M&&(typeof M=="string"?W=M:W=M.pattern),U&&U.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:V}=_(o.GlobPattern.from(F));return this.n.$startFileSearch((0,E.withUndefinedAsNull)(x),(0,E.withUndefinedAsNull)(V),(0,E.withUndefinedAsNull)(W),(0,E.withUndefinedAsNull)(N),U).then(X=>Array.isArray(X)?X.map(Q=>y.URI.revive(Q)):[])}async findTextInFiles(F,M,N,B,U=I.CancellationToken.None){this.g.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const W=this.h.getNext(),x=typeof M.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:V,folder:X}=_(o.GlobPattern.from(M.include)),Q=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,J={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:x,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:V,excludePattern:Q},te=!1;if(this.t[W]=le=>{if(te)return;const Z=y.URI.revive(le.resource);le.results.forEach(ge=>{(0,u.resultIsMatch)(ge)?N({uri:Z,preview:{text:ge.preview.text,matches:(0,a.mapArrayOrNot)(ge.preview.matches,ve=>new i.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,a.mapArrayOrNot)(ge.ranges,ve=>new i.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):N({uri:Z,text:ge.text,lineNumber:ge.lineNumber})})},U.isCancellationRequested)return{};try{const le=await this.n.$startTextSearch(F,(0,E.withUndefinedAsNull)(X),J,W,U);return delete this.t[W],le||{}}catch(le){throw delete this.t[W],le}}$handleTextSearchResult(F,M){this.t[M]?.(F)}saveAll(F){return this.n.$saveAll(F)}resolveProxy(F){return this.n.$resolveProxy(F)}get trusted(){return this.u}requestWorkspaceTrust(F){return this.n.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this.u||(this.u=!0,this.e.fire())}registerEditSessionIdentityProvider(F,M){if(this.v.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.v.set(F,M);const N=this.s.transformOutgoingScheme(F),B=this.y++;return this.n.$registerEditSessionIdentityProvider(B,N),(0,D.toDisposable)(()=>{this.v.delete(F),this.n.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(F,M){this.g.info("Getting edit session identifier for workspaceFolder",F);const N=await this.resolveWorkspaceFolder(y.URI.revive(F));if(!N){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const B=this.v.get(N.uri.scheme);if(this.g.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!B),!B)return;const U=await B.provideEditSessionIdentity(N,M);if(this.g.info("Provider returned edit session identifier: ",U),!!U)return U}async $provideEditSessionIdentityMatch(F,M,N,B){this.g.info("Getting edit session identifier for workspaceFolder",F);const U=await this.resolveWorkspaceFolder(y.URI.revive(F));if(!U){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const W=this.v.get(U.uri.scheme);if(this.g.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!W),!W)return;const x=await W.provideEditSessionIdentityMatch?.(M,N,B);if(this.g.info("Provider returned edit session identifier match result: ",x),!!x)return x}};z=qe([We(0,p.IExtHostRpcService),We(1,m.IExtHostInitDataService),We(2,h.IExtHostFileSystemInfo),We(3,b.ILogService),We(4,l.IURITransformerService)],z),e.ExtHostWorkspace=z,e.IExtHostWorkspace=(0,d.createDecorator)("IExtHostWorkspace");function _(K){let F,M;return K&&(typeof K=="string"?F=K:(F=K.pattern,M=y.URI.revive(K.baseUri))),{includePattern:F,folder:M}}}),define(Se[34],ye([1,0,23,4,33,5,7,202,126,11,18,3,16,13,2]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(i,l){if(l){const u=l.split(".");let s=i;for(let c=0;s&&c<u.length;c++)s=s[u[c]];return s}}function b(i){return i instanceof v.URI}function f(i){return i&&i.uri instanceof v.URI&&i.languageId&&typeof i.languageId=="string"}function w(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function h(i){return i&&i.uri instanceof v.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function m(i){if(b(i))return{resource:i};if(f(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(w(i))return{overrideIdentifier:i.languageId};if(h(i))return{resource:i.uri};if(i===null)return{resource:null}}let p=class{constructor(l,u,s){this.a=l.getProxy(A.MainContext.MainThreadConfiguration),this.c=u,this.b=s,this.d=new R.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(l=>this.e)}$initializeConfiguration(l){this.e=new o(this.a,this.c,l,this.b),this.d.open()}$acceptConfigurationChanged(l,u){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(l,u))}};p=qe([We(0,E.IExtHostRpcService),We(1,I.IExtHostWorkspace),We(2,y.ILogService)],p),e.ExtHostConfiguration=p;class o{constructor(l,u,s,c){this.a=new t.Emitter,this.b=l,this.f=c,this.c=u,this.e=k.Configuration.parse(s),this.d=this.k(s.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(l,u){const s={data:this.e.toData(),workspace:this.c.workspace};this.e=k.Configuration.parse(l),this.d=this.k(l.configurationScopes),this.a.fire(this.j(u,s))}getConfiguration(l,u,s){const c=m(u)||{},n=this.g(l?d(this.e.getValue(void 0,c,this.c.workspace),l):this.e.getValue(void 0,c,this.c.workspace));l&&this.h(l,c,s?.identifier);function r(P){if(P==null)return null;if(typeof P=="boolean")return P?2:5;switch(P){case D.ConfigurationTarget.Global:return 2;case D.ConfigurationTarget.Workspace:return 5;case D.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(P){return typeof d(n,P)<"u"},get:(P,L)=>{this.h(l?`${l}.${P}`:P,c,s?.identifier);let z=d(n,P);if(typeof z>"u")z=L;else{let _;const K=(F,M)=>{let N;const B=()=>{_=_||(0,a.deepClone)(n),N=N||d(_,M)};return(0,C.isObject)(F)?new Proxy(F,{get:(U,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return B(),()=>N;if(_)return N=N||d(_,M),N[W];const x=U[W];return typeof W=="string"?K(x,`${M}.${W}`):x},set:(U,W,x)=>(B(),N&&(N[W]=x),!0),deleteProperty:(U,W)=>(B(),N&&delete N[W],!0),defineProperty:(U,W,x)=>(B(),N&&Object.defineProperty(N,W,x),!0)}):F};z=K(z,P)}return z},update:(P,L,z,_)=>{P=l?`${l}.${P}`:P;const K=r(z);return L!==void 0?this.b.$updateConfigurationOption(K,P,L,c,_):this.b.$removeConfigurationOption(K,P,c,_)},inspect:P=>{P=l?`${l}.${P}`:P;const L=this.e.inspect(P,c,this.c.workspace);if(L)return{key:P,defaultValue:(0,a.deepClone)(L.policy?.value??L.default?.value),globalValue:(0,a.deepClone)(L.user?.value??L.application?.value),workspaceValue:(0,a.deepClone)(L.workspace?.value),workspaceFolderValue:(0,a.deepClone)(L.workspaceFolder?.value),defaultLanguageValue:(0,a.deepClone)(L.default?.override),globalLanguageValue:(0,a.deepClone)(L.user?.override??L.application?.override),workspaceLanguageValue:(0,a.deepClone)(L.workspace?.override),workspaceFolderLanguageValue:(0,a.deepClone)(L.workspaceFolder?.override),languageIds:(0,a.deepClone)(L.overrideIdentifiers)}}};return typeof n=="object"&&(0,a.mixin)(g,n,!1),Object.freeze(g)}g(l){const u=s=>(0,C.isObject)(s)?new Proxy(s,{get:(c,n)=>u(c[n]),set:(c,n,r)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(c,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(c,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:c=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return u(l)}h(l,u,s){const c=S.OVERRIDE_PROPERTY_REGEX.test(l)?4:this.d.get(l),n=s?`[${s.value}] `:"";if(c===4){typeof u?.resource>"u"&&this.f.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(c===3){u?.resource&&this.f.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(l,u){const s=new k.ConfigurationChangeEvent(l,u,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(c,n)=>s.affectsConfiguration(c,m(n))})}k(l){return l.reduce((u,s)=>(u.set(s[0],s[1]),u),new Map)}}e.ExtHostConfigProvider=o,e.IExtHostConfiguration=(0,T.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ne,a):I?I.value=a:e.set(ne,a),a},Me=this&&this.__classPrivateFieldGet||function(ne,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[75],ye([1,0,2,18,4,5,7,33,58,34,21,40,16,25,3,15,12,13,70,239,10]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v,d,b,f,w,h,m){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var o;(function(F){function M(B){if(B!=null)return B}F.from=M;function N(B){if(B!=null)return B}F.to=N})(o||(o={}));var i;(function(F){function M(B){if(B!=null)return B}F.from=M;function N(B){if(B!=null)return B}F.to=N})(i||(i={}));var l;(function(F){function M(B){if(B!=null)return B}F.from=M;function N(B){if(B!=null)return B}F.to=N})(l||(l={}));var u;(function(F){function M(U){if(U){const W=U;return W&&!!W.process}else return!1}F.is=M;function N(U){if(U==null)return;const W={process:U.process,args:U.args};return U.options&&(W.options=l.from(U.options)),W}F.from=N;function B(U){if(U!=null)return new D.ProcessExecution(U.process,U.args,U.options)}F.to=B})(u||(u={}));var s;(function(F){function M(B){if(B!=null)return B}F.from=M;function N(B){if(B!=null)return B}F.to=N})(s||(s={}));var c;(function(F){function M(U){if(U){const W=U;return W&&(!!W.commandLine||!!W.command)}else return!1}F.is=M;function N(U){if(U==null)return;const W={};return U.commandLine!==void 0?W.commandLine=U.commandLine:(W.command=U.command,W.args=U.args),U.options&&(W.options=s.from(U.options)),W}F.from=N;function B(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new D.ShellExecution(U.commandLine,U.options):new D.ShellExecution(U.command,U.args?U.args:[],U.options)}F.to=B})(c||(c={}));var n;(function(F){function M(U){if(U){const W=U;return W&&W.customExecution==="customExecution"}else return!1}F.is=M;function N(U){return{customExecution:"customExecution"}}F.from=N;function B(U,W){return W.get(U)}F.to=B})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var r;(function(F){function M(N,B){let U;return N.scope!==void 0&&typeof N.scope!="number"?U=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===D.TaskScope.Workspace&&B&&B.workspaceFile?U=B.workspaceFile:U=h.USER_TASKS_GROUP_KEY),{id:N._id,workspaceFolder:U}}F.from=M})(r=e.TaskHandleDTO||(e.TaskHandleDTO={}));var g;(function(F){function M(N){if(N!=null)return{_id:N.id,isDefault:N.isDefault}}F.from=M})(g||(g={}));var P;(function(F){function M(U,W){if(U==null)return[];const x=[];for(const V of U){const X=N(V,W);X&&x.push(X)}return x}F.fromMany=M;function N(U,W){if(U==null)return;let x;U.execution instanceof D.ProcessExecution?x=u.from(U.execution):U.execution instanceof D.ShellExecution?x=c.from(U.execution):U.execution&&U.execution instanceof D.CustomExecution&&(x=n.from(U.execution));const V=o.from(U.definition);let X;return U.scope?typeof U.scope=="number"?X=U.scope:X=U.scope.uri:X=D.TaskScope.Workspace,!V||!X?void 0:{_id:U._id,definition:V,name:U.name,source:{extensionId:W.identifier.value,label:U.source,scope:X},execution:x,isBackground:U.isBackground,group:g.from(U.group),presentationOptions:i.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}F.from=N;async function B(U,W,x){if(U==null)return;let V;u.is(U.execution)?V=u.to(U.execution):c.is(U.execution)?V=c.to(U.execution):n.is(U.execution)&&(V=n.to(U._id,x));const X=o.to(U.definition);let Q;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?Q=U.source.scope:Q=await W.resolveWorkspaceFolder(a.URI.revive(U.source.scope)):Q=D.TaskScope.Workspace),!X||!Q)return;const J=new D.Task(X,Q,U.name,U.source.label,V,U.problemMatchers);return U.isBackground!==void 0&&(J.isBackground=U.isBackground),U.group!==void 0&&(J.group=D.TaskGroup.from(U.group._id),J.group&&U.group.isDefault&&(J.group=new D.TaskGroup(J.group.id,J.group.label),U.group.isDefault===!0&&(J.group.isDefault=U.group.isDefault))),U.presentationOptions&&(J.presentationOptions=i.to(U.presentationOptions)),U._id&&(J._id=U._id),U.detail&&(J.detail=U.detail),J}F.to=B})(P=e.TaskDTO||(e.TaskDTO={}));var L;(function(F){function M(B){return B}F.from=M;function N(B){if(!!B)return Object.assign(Object.create(null),B)}F.to=N})(L||(L={}));class z{constructor(M,N,B){this._id=N,this.a=B,p.set(this,void 0),Je(this,p,M,"f")}get task(){return this.a}terminate(){Me(this,p,"f").terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}p=new WeakMap;let _=class{constructor(M,N,B,U,W,x,V,X){this.q=new I.Emitter,this.r=new I.Emitter,this.s=new I.Emitter,this.t=new I.Emitter,this.a=M.getProxy(A.MainContext.MainThreadTask),this.b=B,this.c=U,this.d=W,this.e=x,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=V,this.g=X,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,N,B){if(!B)return new D.Disposable(()=>{});const U=this.w();return this.j.set(U,{type:N,provider:B,extension:M}),this.a.$registerTaskProvider(U,N),new D.Disposable(()=>{this.j.delete(U),this.a.$unregisterTaskProvider(U)})}registerTaskSystem(M,N){this.a.$registerTaskSystem(M,N)}fetchTasks(M){return this.a.$fetchTasks(L.from(M)).then(async N=>{const B=[];for(const U of N){const W=await P.to(U,this.b,this.m);W&&B.push(W)}return B})}get taskExecutions(){const M=[];return this.k.forEach(N=>M.push(N)),M}terminateTask(M){if(!(M instanceof z))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,N,B){const U=this.m.get(M.id);U&&(this.o.set(M.id,U),this.e.attachPtyToTerminal(N,await U.callback(B))),this.p=M.id,this.q.fire({execution:await this.y(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){const N=await this.y(M);this.l.delete(M.id),this.k.delete(M.id),this.A(M),this.r.fire({execution:N})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const N=await this.y(M.id);this.s.fire({execution:N,processId:M.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(M){const N=await this.y(M.id);this.t.fire({execution:N,exitCode:M.exitCode})}$provideTasks(M,N){const B=this.j.get(M);if(!B)return Promise.reject(new Error("no handler found"));const U=[],W=(0,t.asPromise)(()=>B.provider.provideTasks(R.CancellationToken.None)).then(x=>this.u(N,U,B,x));return new Promise(x=>{W.then(V=>{Promise.all(U).then(()=>{x(V)})})})}async $resolveTask(M,N){const B=this.j.get(M);if(!B)return Promise.reject(new Error("no handler found"));if(N.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${B.type}].`);const U=await P.to(N,this.b,this.m);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const W=await B.provider.resolveTask(U,R.CancellationToken.None);if(!W)return;this.z(W,B);const x=P.from(W,B.extension);if(!x)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(x.execution)&&await this.x(x,W,!0),await this.v(x)}w(){return this.h++}async x(M,N,B){const U=await this.a.$createTaskId(M);!B&&!this.m.has(U)&&(this.n.add(U),this.o.set(U,N.execution)),this.m.set(U,N.execution)}async y(M,N){if(typeof M=="string"){const W=this.l.get(M);if(!W)throw new m.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return W}const B=this.l.get(M.id);if(B)return B;const U=new Promise((W,x)=>{function V(X,Q,J){J?W(new z(X,Q.id,J)):x("Unexpected: Task does not exist.")}N?V(this,M,N):P.to(M.task,this.b,this.m).then(X=>V(this,M,X))});return this.l.set(M.id,U),U.then(W=>(this.k.set(M.id,W),W),W=>Promise.reject(W))}z(M,N){M._deprecated&&this.g.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}A(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const B=this.n.values();let U=B.next();for(;!U.done;)!this.o.has(U.value)&&this.p!==U.value&&(this.m.delete(U.value),this.n.delete(U.value)),U=B.next()}};_=qe([We(0,E.IExtHostRpcService),We(1,y.IExtHostInitDataService),We(2,k.IExtHostWorkspace),We(3,S.IExtHostDocumentsAndEditors),We(4,C.IExtHostConfiguration),We(5,T.IExtHostTerminalService),We(6,f.ILogService),We(7,w.IExtHostApiDeprecationService)],_),e.ExtHostTaskBase=_;let K=class extends _{constructor(M,N,B,U,W,x,V,X){super(M,N,B,U,W,x,V,X),this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:b.PlatformToString(0)})}async executeTask(M,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const B=P.from(N,M);if(B===void 0)throw new Error("Task is not valid");if(n.is(B.execution))await this.x(B,N,!1);else throw new m.NotSupportedError;const U=await this.y(await this.a.$getTaskExecution(B),N);return this.a.$executeTask(B).catch(W=>{throw new Error(W)}),U}u(M,N,B,U){const W=[];if(U)for(const x of U){this.z(x,B),(!x.definition||!M[x.definition.type])&&this.f.warn(`The task [${x.source}, ${x.name}] uses an undefined task type. The task will be ignored in the future.`);const V=P.from(x,B.extension);V&&n.is(V.execution)?(W.push(V),N.push(this.x(V,x,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:B.extension}}async v(M){if(n.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,N,B){}};K=qe([We(0,E.IExtHostRpcService),We(1,y.IExtHostInitDataService),We(2,k.IExtHostWorkspace),We(3,S.IExtHostDocumentsAndEditors),We(4,C.IExtHostConfiguration),We(5,T.IExtHostTerminalService),We(6,f.ILogService),We(7,w.IExtHostApiDeprecationService)],K),e.WorkerExtHostTask=K,e.IExtHostTask=(0,v.createDecorator)("IExtHostTask")}),define(Se[285],ye([1,0,9,21,51,37,24,44,31]),function(ne,e,a,t,I,A,D,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(E,y,v){this.k=E,this.l=y,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=E.filePattern,this.b=E.includePattern&&A.parse(E.includePattern),this.c=E.maxResults||void 0,this.d=E.exists,this.h=new Set,this.j=E.excludePattern&&A.parse(E.excludePattern)}cancel(){this.g=!0,this.h.forEach(E=>E.cancel()),this.h=new Set}search(E){const y=this.k.folderQueries||[];return new Promise((v,d)=>{const b=f=>{this.f++,E(f)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(f=>{const w=f.toString(),h=a.basename(w);this.j&&this.j(w,h)||this.v(b,{base:f,basename:h})}),Promise.all(y.map(f=>this.p(f,b))).then(f=>{v({limitHit:this.e,stats:f[0]||void 0})},f=>{d(new Error((0,I.toErrorMessage)(f)))})})}async p(E,y){const v=new t.CancellationTokenSource,d=this.q(E),b=this.r(),f=new S.QueryGlobTester(this.k,E),w=!f.hasSiblingExcludeClauses();let h;try{this.h.add(v),h=k.StopWatch.create();const m=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},d,v.token),p=h.elapsed(),o=k.StopWatch.create();return this.g&&!this.e||(m&&m.forEach(i=>{const l=a.posix.relative(E.folder.path,i.path);if(w){const u=a.basename(i.path);this.v(y,{base:E.folder,relativePath:l,basename:u});return}this.s(b,E.folder,l,y)}),this.g&&!this.e)?null:(this.u(b,f,y),{providerTime:p,postProcessTime:o.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(E){const y=(0,S.resolvePatternsForProvider)(this.k.includePattern,E.includePattern),v=(0,S.resolvePatternsForProvider)(this.k.excludePattern,E.excludePattern);return{folder:E.folder,excludes:v,includes:y,useIgnoreFiles:!E.disregardIgnoreFiles,useGlobalIgnoreFiles:!E.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!E.disregardParentIgnoreFiles,followSymlinks:!E.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const E={rootEntries:[],pathToEntries:Object.create(null)};return E.pathToEntries["."]=E.rootEntries,E}s({pathToEntries:E},y,v,d){if(v===this.a){const f=a.basename(this.a);this.v(d,{base:y,relativePath:this.a,basename:f})}function b(f){const w=a.basename(f),h=a.dirname(f);let m=E[h];m||(m=E[h]=[],b(h)),m.push({base:y,relativePath:f,basename:w})}b(v)}u({rootEntries:E,pathToEntries:y},v,d){const b=this,f=this.a;function w(h){const m=(0,S.hasSiblingFn)(()=>h.map(p=>p.basename));for(let p=0,o=h.length;p<o;p++){const i=h[p],{relativePath:l,basename:u}=i;if(v.matchesExcludesSync(l,u,f!==u?m:void 0))continue;const s=y[l];if(s)w(s);else{if(l===f)continue;b.v(d,i)}if(b.e)break}}w(E)}v(E,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||E(y))}}class R{constructor(){this.b=new Map}fileSearch(E,y,v,d){const b=this.c(E.cacheKey),f=new C(E,y,b&&b.token);let w=0;const h=m=>{w+=m.length,v(m.map(p=>this.d(p)))};return this.e(f,R.a,h,d).then(m=>({limitHit:m.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:w,detailStats:m.stats}}))}clearCache(E){this.c(E)?.cancel()}c(E){if(!!E)return this.b.has(E)||this.b.set(E,new t.CancellationTokenSource),this.b.get(E)}d(E){return E.relativePath?{resource:D.joinPath(E.base,E.relativePath)}:{resource:E.base}}e(E,y,v,d){d.onCancellationRequested(()=>{E.cancel()});const b=w=>{w&&(f.push(w),y>0&&f.length>=y&&(v(f),f=[]))};let f=[];return E.search(b).then(w=>(f.length&&v(f),w),w=>(f.length&&v(f),Promise.reject(w)))}}e.FileSearchManager=R,R.a=512}),define(Se[286],ye([1,0,17,80,37,111,28,15,9,24,8,11,2,163,190,52,13,46,133,284,31]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v,d,b,f,w,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(g,P,L,z,_){this.a=g,this.b=P,this.c=L,this.d=z,this.e=_}text(g,P,L={}){g=this.f(g,L);const z=this.a.getValue(),_=P&&P.some(F=>!this.a.getValue({resource:F}).search.useRipgrep);return{...this.h(P?.map(f.toWorkspaceFolder),L),type:2,contentPattern:g,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:z.search.usePCRE2||_||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}f(g,P){const L=this.a.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const z={...g,wordSeparators:L.editor.wordSeparators};return this.j(g,P)&&(z.isCaseSensitive=!0),this.k(g)&&(z.isMultiline=!0),z}file(g,P={}){return{...this.h(g,P),type:1,filePattern:P.filePattern?P.filePattern.trim():P.filePattern,exists:P.exists,sortByScore:P.sortByScore,cacheKey:P.cacheKey}}g(g,P){return g?(g=Array.isArray(g)?g.map(s):s(g),P?this.parseSearchPaths(g):{pattern:i(...Array.isArray(g)?g:[g])}):{}}h(g=[],P={}){const L=this.g(P.includePattern,P.expandPatterns),z=this.g(P.excludePattern,P.expandPatterns),_=g.length>1,K=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(N=>this.q(N,P,z)):g.map(N=>this.r(N,P,z,_))).filter(N=>!!N),F={_reason:P._reason,folderQueries:K,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:P.extraFileResources,excludePattern:z.pattern,includePattern:L.pattern,onlyOpenEditors:P.onlyOpenEditors,maxResults:P.maxResults};if(P.onlyOpenEditors){const N=a.coalesce(a.flatten(this.c.groups.map(W=>W.editors.map(x=>x.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const B=N.filter(W=>(0,m.pathIncludedInQuery)(F,W.fsPath)),U=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(U)),{...F,...U}}const M=P.extraFileResources&&P.extraFileResources.filter(N=>(0,m.pathIncludedInQuery)(F,N.fsPath));return F.extraFileResources=M&&M.length?M:void 0,F}i(g){const P=[],L=new D.ResourceMap,z={};let _=!1;return g.forEach(K=>{if(K.scheme===k.Schemas.walkThrough)return;if((0,C.isAbsolutePath)(K)){const M=this.b.getWorkspaceFolder(K)?.uri??K.with({path:S.dirname(K.fsPath)});let N=L.get(M);N||(_=!0,N={folder:M,includePattern:{}},P.push(N),L.set(M,N));const B=S.relative(M.fsPath,K.fsPath);(0,T.assertIsDefined)(N.includePattern)[B.replace(/\\/g,"/")]=!0}else K.fsPath&&(_=!0,z[K.fsPath]=!0)}),{folderQueries:P,includePattern:z,usingSearchPaths:!0,excludePattern:_?void 0:{"**/*":!0}}}j(g,P){if(P.isSmartCase){if(g.isRegExp){if(R.containsUppercaseCharacter(g.pattern,!0))return!0}else if(R.containsUppercaseCharacter(g.pattern))return!0}return!!g.isCaseSensitive}k(g){return g.isMultiline||g.isRegExp&&(0,y.isMultilineRegexSource)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const P=U=>S.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),z=(Array.isArray(g)?g:l(g)).map(U=>{const W=this.e.resolvedUserHome;return W?(0,A.untildify)(U,W.scheme===k.Schemas.file?W.fsPath:W.path):U}),_=t.groupBy(z,U=>P(U)?"searchPaths":"exprSegments"),K=(_.exprSegments||[]).map(U=>R.rtrim(U,"/")).map(U=>R.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),u(U))),F={},M=this.m(_.searchPaths||[]);M&&M.length&&(F.searchPaths=M);const N=a.flatten(K),B=i(...N);return B&&(F.pattern=B),F}l(g,P){return P.disregardExcludeSettings?void 0:(0,m.getExcludes)(g,!P.disregardSearchExcludeSettings)}m(g){if(!g||!g.length)return[];const P=a.flatten(g.map(z=>{let{pathPortion:_,globPortion:K}=o(z);K&&(K=c(K));const F=this.n(_);return a.flatten(F.map(M=>this.o(M,K)))})),L=new Map;return P.forEach(z=>{const _=z.searchPath.toString(),K=L.get(_);K?z.pattern&&(K.pattern=K.pattern||{},K.pattern[z.pattern]=!0):L.set(_,{searchPath:z.searchPath,pattern:z.pattern?i(z.pattern):void 0})}),Array.from(L.values())}n(g){if(S.isAbsolute(g)){const P=this.b.getWorkspace().folders;return P[0]&&P[0].uri.scheme!==k.Schemas.file?[{searchPath:P[0].uri.with({path:g})}]:[{searchPath:E.URI.file(S.normalize(g))}]}if(this.b.getWorkbenchState()===2){const P=this.b.getWorkspace().folders[0].uri;if(g=s(g),g.startsWith("../")||g===".."){const z=S.posix.resolve(P.path,g);return[{searchPath:P.with({path:z})}]}const L=c(g);return[{searchPath:P,pattern:L}]}else{if(g==="./"||g===".\\")return[];{const P=g.replace(/^\.[\/\\]/,""),z=this.b.getWorkspace().folders.map(_=>{const K=P.match(new RegExp(`^${R.escapeRegExpCharacters(_.name)}(?:/(.*)|$)`));return K?{match:K,folder:_}:null}).filter(T.isDefined);if(z.length)return z.map(_=>{const K=_.match[1];return{searchPath:_.folder.uri,pattern:K&&c(K)}});{const _=g.match(/\.[\/\\](.+)[\/\\]?/),K=_?_[1]:g,F=v.localize(0,null,K);throw new Error(F)}}}}o(g,P){const L=g.pattern&&P?`${g.pattern}/${P}`:g.pattern||P,z=[{searchPath:g.searchPath,pattern:L}];return L&&!L.endsWith("**")&&z.push({searchPath:g.searchPath,pattern:L+"/**"}),z}q(g,P,L){const z=this.r((0,f.toWorkspaceFolder)(g.searchPath),P,L,!1);return z?{...z,includePattern:g.pattern}:null}r(g,P,L,z){let _;const K=E.URI.isUri(g)?g:g.uri;if(L.searchPaths){const U=L.searchPaths.filter(W=>(0,C.isEqual)(W.searchPath,K))[0];if(U&&!U.pattern)return null;U&&(_=U.pattern)}const F=this.a.getValue({resource:K}),N={...this.l(F,P)||{},..._||{}},B=E.URI.isUri(g)?(0,C.basename)(g):g.name;return{folder:K,folderName:z?B:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:F.files&&F.files.encoding,disregardIgnoreFiles:typeof P.disregardIgnoreFiles=="boolean"?P.disregardIgnoreFiles:!F.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof P.disregardGlobalIgnoreFiles=="boolean"?P.disregardGlobalIgnoreFiles:!F.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof P.disregardParentIgnoreFiles=="boolean"?P.disregardParentIgnoreFiles:!F.search.useParentIgnoreFiles,ignoreSymlinks:typeof P.ignoreSymlinks=="boolean"?P.ignoreSymlinks:!F.search.followSymlinks}}};p=qe([We(0,d.IConfigurationService),We(1,f.IWorkspaceContextService),We(2,w.IEditorGroupsService),We(3,b.ILogService),We(4,h.IPathService)],p),e.QueryBuilder=p;function o(r){const g=r.match(/[\*\{\}\(\)\[\]\?]/);if(g){const P=g.index,L=r.substr(0,P).match(/[/|\\][^/\\]*$/);if(L){let z=r.substr(0,L.index);return z.match(/[/\\]/)||(z+="/"),{pathPortion:z,globPortion:r.substr((L.index||0)+1)}}}return{pathPortion:r}}function i(...r){return r.length?r.reduce((g,P)=>(g[P]=!0,g),Object.create(null)):void 0}function l(r){return I.splitGlobAware(r,",").map(g=>g.trim()).filter(g=>!!g.length)}function u(r){return[`**/${r}/**`,`**/${r}`].map(P=>P.replace(/\*\*\/\*\*/g,"**"))}function s(r){return r.replace(/\\/g,"/")}function c(r){return s(r).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(r,g){r=a.distinct(r,z=>z.toString());const P=[],L=g.getWorkspace();return r&&r.forEach(z=>{let _;if(g.getWorkbenchState()===2)_=(0,C.relativePath)(L.folders[0].uri,z),_&&_!=="."&&(_="./"+_);else{const K=g.getWorkspaceFolder(z);if(K){const F=K.name;if(L.folders.filter(N=>N.name===F).length===1){const N=(0,C.relativePath)(K.uri,z);N===""?_=`./${K.name}`:_=`./${K.name}/${N}`}else _=z.fsPath}}_&&P.push(_)}),P}e.resolveResourcesForSearchIncludes=n}),define(Se[287],ye([1,0,24,2,21,10,3,286,31,46]),function(ne,e,a,t,I,A,D,k,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function T(d,b){const f=b.activationEvents;if(!f)return Promise.resolve(void 0);const w=[],h=[];for(const u of f)if(/^workspaceContains:/.test(u)){const s=u.substr(18);s.indexOf("*")>=0||s.indexOf("?")>=0||d.forceUsingSearch?h.push(s):w.push(s)}if(w.length===0&&h.length===0)return Promise.resolve(void 0);let m;const p=new Promise((u,s)=>{m=u}),o=u=>m({activationEvent:u}),i=Promise.all(w.map(u=>E(d,u,o))).then(()=>{}),l=y(d,b.identifier,h,o);return Promise.all([i,l]).then(()=>{m(void 0)}),p}e.checkActivateWorkspaceContainsExtension=T;async function E(d,b,f){for(const w of d.folders)if(await d.exists(a.joinPath(t.URI.revive(w),b))){f(`workspaceContains:${b}`);return}}async function y(d,b,f,w){if(f.length===0)return Promise.resolve(void 0);const h=new I.CancellationTokenSource,m=d.checkExists(d.folders,f,h.token),p=setTimeout(async()=>{h.cancel(),d.logService.info(`Not activating extension '${b.value}': Timed out while searching for 'workspaceContains' pattern ${f.join(",")}`)},R);let o=!1;try{o=await m}catch(i){A.isCancellationError(i)||A.onUnexpectedError(i)}h.dispose(),clearTimeout(p),o&&w(`workspaceContains:${f.join(",")}`)}function v(d,b,f,w){const h=d.get(D.IInstantiationService),m=d.get(S.ISearchService),o=h.createInstance(k.QueryBuilder).file(b.map(i=>(0,C.toWorkspaceFolder)(t.URI.revive(i))),{_reason:"checkExists",includePattern:f,exists:!0});return m.fileSearch(o,w).then(i=>!!i.limitHit,i=>A.isCancellationError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=v});var Je=this&&this.__classPrivateFieldSet||function(ne,e,a,t,I){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!I:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?I.call(ne,a):I?I.value=a:e.set(ne,a),a},Me=this&&this.__classPrivateFieldGet||function(ne,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!t:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(ne):t?t.value:e.get(ne)};define(Se[41],ye([1,0,174,9,76,24,18,6,64,2,13,5,34,229,97,33,26,134,10,27,22,211,7,127,3,25,72,16,88,54,40,4,287,96,213,15,95]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v,d,b,f,w,h,m,p,o,i,l,u,s,c,n,r,g,P,L,z,_,K,F){"use strict";var M,N,B;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,l.createDecorator)("IHostUtils");let U=class Ln extends k.Disposable{constructor(te,le,Z,ge,ve,De,Re,ze,se,ue,he){super(),this.a=this.B(new P.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=le,this.g=Z,this.f=Re,this.j=ge,this.k=ve,this.l=De,this.m=se,this.p=ue,this.s=he,this.t=this.g.getProxy(T.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(T.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(T.MainContext.MainThreadExtensionService),this.w=new D.Barrier,this.y=new D.Barrier,this.z=new D.Barrier,this.C=new D.Barrier,this.F=new f.ExtensionDescriptionRegistry(this.f.allExtensions);const ee=(0,b.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new f.ExtensionDescriptionRegistry(V(this.F,ee)),this.G=new v.ExtHostStorage(this.g,this.l),this.H=new z.ExtHostSecretState(this.g),this.I=ze,this.h=te.createChild(new n.ServiceCollection([v.IExtHostStorage,this.G],[z.IExtHostSecretState,this.H])),this.J=this.B(new y.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(oe,ie,O)=>{this.v.$onExtensionActivationError(oe,w.transformErrorForSerialization(ie),O)},actualActivateExtension:async(oe,ie)=>{if(f.ExtensionDescriptionRegistry.isHostExtension(oe,this.D,this.F))return await this.v.$activateExtension(oe,ie),new y.HostExtension;const O=this.D.getExtensionDescription(oe);return this.Y(O,ie)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(te){w.onUnexpectedError(te)}}async Q(){this.I.onWillDeactivateAll();let te=[];try{te=this.D.getAllExtensionDescriptions().map(ve=>ve.identifier).filter(ve=>this.isActivated(ve)).map(ve=>this.X(ve))}catch{}await Promise.all(te)}terminate(te,le=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${te}`),this.l.flush(),this.p.dispose(),this.J.dispose(),w.setUnexpectedErrorHandler(ge=>{this.l.error(ge)}),this.g.dispose();const Z=this.Q();Promise.race([(0,D.timeout)(5e3),Z]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${le}`):this.l.info(`Extension host exiting with code ${le}`),this.l.flush(),this.l.dispose(),this.c.exit(le)})}isActivated(te){return this.z.isOpen()?this.J.isActivated(te):!1}async getExtension(te){const le=await this.v.$getExtension(te);let Z;if(le?.browserNlsBundleUris){Z={};for(const ge of Object.keys(le.browserNlsBundleUris))Z[ge]=C.URI.revive(le.browserNlsBundleUris[ge])}return le&&{...le,identifier:new h.ExtensionIdentifier(le.identifier.value),extensionLocation:C.URI.revive(le.extensionLocation),browserNlsBundleUris:Z}}R(te,le){return this.J.activateByEvent(te,le)}S(te,le){return this.J.activateById(te,le)}activateByIdWithErrors(te,le){return this.S(te,le).then(()=>{const Z=this.J.getActivatedExtension(te);if(Z.activationFailed)return Promise.reject(Z.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(te=>this.D)}getExtensionExports(te){return this.z.isOpen()?this.J.getActivatedExtension(te).exports:null}async U(te){if(te.scheme!==K.Schemas.file)return te;const le=await this.c.realpath(te.fsPath);return C.URI.file(le)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(te=>new Q(te))),this.L}async W(te){const le=S.TernarySearchTree.forUris(Z=>A.extUriBiasedIgnorePathCase.ignorePathCasing(Z));return await Promise.all(te.map(async Z=>{if(this.ob(Z)){const ge=await this.U(Z.extensionLocation);le.set(ge,Z)}})),le}X(te){let le=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(te))return le;const Z=this.J.getActivatedExtension(te);if(!Z)return le;try{typeof Z.module.deactivate=="function"&&(le=Promise.resolve(Z.module.deactivate()).then(void 0,ge=>(this.l.error(ge),Promise.resolve(void 0))))}catch(ge){this.l.error(`An error occurred when deactivating the extension '${te.value}':`),this.l.error(ge)}try{(0,k.dispose)(Z.subscriptions)}catch(ge){this.l.error(`An error occurred when deactivating the subscriptions for extension '${te.value}':`),this.l.error(ge)}return le}async Y(te,le){return this.f.remote.isRemote?this.v.$onWillActivateExtension(te.identifier):await this.v.$onWillActivateExtension(te.identifier),this.ab(te,le).then(Z=>{const ge=Z.activationTimes;return this.v.$onDidActivateExtension(te.identifier,ge.codeLoadingTime,ge.activateCallTime,ge.activateResolvedTime,le),this.Z(te,le,"success",ge),Z},Z=>{throw this.Z(te,le,"failure"),Z})}Z(te,le,Z,ge){const ve=W(te,le);this.u.$publicLog2("extensionActivationTimes",{...ve,...ge||{},outcome:Z})}ab(te,le){const Z=W(te,le);this.u.$publicLog2("activatePlugin",Z);const ge=this.ob(te);if(!ge)return Promise.resolve(new y.EmptyExtension(y.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${te.identifier.value}, startup: ${le.startup}, activationEvent: '${le.activationEvent}'${te.identifier.value!==le.extensionId.value?`, root cause: ${le.extensionId.value}`:""}`),this.l.flush();const ve=new y.ExtensionActivationTimesBuilder(le.startup);return Promise.all([this.pb(te,(0,A.joinPath)(te.extensionLocation,ge),ve),this.bb(te)]).then(De=>(I.mark(`code/extHost/willActivateExtension/${te.identifier.value}`),Ln.cb(this.l,te.identifier,De[0],De[1],ve))).then(De=>(I.mark(`code/extHost/didActivateExtension/${te.identifier.value}`),De))}bb(te){const le=new p.ExtensionGlobalMemento(te,this.G),Z=new p.ExtensionMemento(te.identifier.value,!1,this.G),ge=new _.ExtensionSecrets(te,this.H),ve=te.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?o.ExtensionMode.Test:o.ExtensionMode.Development:o.ExtensionMode.Production,De=this.f.remote.isRemote?o.ExtensionKind.Workspace:o.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${te.identifier.value}`),Promise.all([le.whenReady,Z.whenReady,this.I.whenReady]).then(()=>{const Re=this;let ze,se;const ue=(0,b.isProposedApiEnabled)(te,"ipc")?this.f.messagePorts?.get(h.ExtensionIdentifier.toKey(te.identifier)):void 0;return Object.freeze({globalState:le,workspaceState:Z,secrets:ge,subscriptions:[],get extensionUri(){return te.extensionLocation},get extensionPath(){return te.extensionLocation.fsPath},asAbsolutePath(he){return t.join(te.extensionLocation.fsPath,he)},get storagePath(){return Re.I.workspaceValue(te)?.fsPath},get globalStoragePath(){return Re.I.globalValue(te).fsPath},get logPath(){return t.join(Re.f.logsLocation.fsPath,te.identifier.value)},get logUri(){return C.URI.joinPath(Re.f.logsLocation,te.identifier.value)},get storageUri(){return Re.I.workspaceValue(te)},get globalStorageUri(){return Re.I.globalValue(te)},get extensionMode(){return ve},get extension(){return ze===void 0&&(ze=new x(Re,te.identifier,te,De,!1)),ze},get extensionRuntime(){return(0,b.checkProposedApiEnabled)(te,"extensionRuntime"),Re.extensionRuntime},get environmentVariableCollection(){return Re.p.getEnvironmentVariableCollection(te)},get messagePassingProtocol(){if(!se){if(!ue)return;const he=P.Event.buffer(P.Event.fromDOMEventEmitter(ue,"message",ee=>ee.data));ue.start(),se={onDidReceiveMessage:he,postMessage:ue.postMessage.bind(ue)}}return se}})})}static cb(te,le,Z,ge,ve){return Z=Z||{activate:void 0,deactivate:void 0},this.db(te,le,Z,ge,ve).then(De=>new y.ActivatedExtension(!1,null,ve.build(),Z,De,ge.subscriptions))}static db(te,le,Z,ge,ve){if(typeof Z.activate=="function")try{ve.activateCallStart(),te.trace(`ExtensionService#_callActivateOptional ${le.value}`);const De=typeof global=="object"?global:self,Re=Z.activate.apply(De,[ge]);return ve.activateCallStop(),ve.activateResolveStart(),Promise.resolve(Re).then(ze=>(ve.activateResolveStop(),ze))}catch(De){return Promise.reject(De)}else return Promise.resolve(Z)}eb(te,le){this.S(te.identifier,{startup:!1,extensionId:te.identifier,activationEvent:le}).then(void 0,Z=>{this.l.error(Z)})}fb(){this.v.$setPerformanceMarks(I.getMarks());for(const te of this.D.getAllExtensionDescriptions())if(te.activationEvents)for(const le of te.activationEvents)le==="onStartupFinished"&&this.eb(te,le)}gb(){const te=this.R("*",!0).then(void 0,ve=>{this.l.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.hb(ve.added)));const le=this.j.workspace?this.j.workspace.folders:[],Z=this.hb(le),ge=Promise.all([te,Z]).then(()=>{});return Promise.race([ge,(0,D.timeout)(1e4)]).then(()=>{this.fb()}),ge}hb(te){return te.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(le=>this.ib(te,le))).then(()=>{})}async ib(te,le){if(this.isActivated(le.identifier))return;const Z=!this.f.remote.isRemote&&!!this.f.remote.authority,ge={logService:this.l,folders:te.map(De=>De.uri),forceUsingSearch:Z,exists:De=>this.c.exists(De.fsPath),checkExists:(De,Re,ze)=>this.t.$checkExists(De,Re,ze)},ve=await(0,L.checkActivateWorkspaceContainsExtension)(ge,le);if(!!ve)return this.S(le.identifier,{startup:!0,extensionId:le.identifier,activationEvent:ve.activationEvent}).then(void 0,De=>this.l.error(De))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(te){throw console.error(te),te}}async jb(){const{extensionDevelopmentLocationURI:te,extensionTestsLocationURI:le}=this.f.environment;if(!te||!le)throw new Error(a.localize(0,null));const Z=await this.pb(null,le,new y.ExtensionActivationTimesBuilder(!1));if(!Z||typeof Z.run!="function")throw new Error(a.localize(1,null,le.toString()));return new Promise((ge,ve)=>{const De=(se,ue)=>{se?ve(se):ge(typeof ue=="number"&&ue>0?1:0)},Re=(0,A.originalFSPath)(le),ze=Z.run(Re,De);ze&&ze.then&&ze.then(()=>{ge(0)}).catch(se=>{ve(se instanceof Error&&se.stack?se.stack:String(se))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(te,le){return this.M[te]=le,(0,k.toDisposable)(()=>{delete this.M[te]})}async lb(te){const le=te.indexOf("+");if(le===-1)throw new Error("Not an authority that can be resolved!");const Z=te.substr(0,le);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${Z}`,!1),{authorityPrefix:Z,resolver:this.M[Z]}}async $resolveAuthority(te,le){this.l.info(`$resolveAuthority invoked for authority (${X(te)})`);const{authorityPrefix:Z,resolver:ge}=await this.lb(te);if(!ge)return{type:"error",error:{code:i.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Z}.`,detail:void 0}};try{this.B(await this.m.setTunnelFactory(ge)),I.mark(`code/extHost/willResolveAuthority/${Z}`);const ve=await ge.resolve(te,{resolveAttempt:le});I.mark(`code/extHost/didResolveAuthorityOK/${Z}`);const De={authority:te,host:ve.host,port:ve.port,connectionToken:ve.connectionToken},Re={extensionHostEnv:ve.extensionHostEnv,isTrusted:ve.isTrusted,authenticationSession:ve.authenticationSessionForInitializingExtensions?{id:ve.authenticationSessionForInitializingExtensions.id,providerId:ve.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:De,options:Re,tunnelInformation:{environmentTunnels:ve.environmentTunnels,features:ve.tunnelFeatures}}}}catch(ve){if(I.mark(`code/extHost/didResolveAuthorityError/${Z}`),ve instanceof o.RemoteAuthorityResolverError)return{type:"error",error:{code:ve._code,message:ve._message,detail:ve._detail}};throw ve}}async $getCanonicalURI(te,le){this.l.info(`$getCanonicalURI invoked for authority (${X(te)})`);const{resolver:Z}=await this.lb(te);if(!Z)return null;const ge=C.URI.revive(le);if(typeof Z.getCanonicalURI>"u")return ge;const ve=await(0,D.asPromise)(()=>Z.getCanonicalURI(ge));return ve||ge}static mb(te,le,Z){const ge=new f.ExtensionDescriptionRegistry(te.getAllExtensionDescriptions());ge.deltaExtensions(Z.toAdd,Z.toRemove);const ve=(0,b.extensionIdentifiersArrayToSet)(le.getAllExtensionDescriptions().map(Re=>Re.identifier));for(const Re of Z.myToRemove)ve.delete(h.ExtensionIdentifier.toKey(Re));for(const Re of Z.myToAdd)ve.add(h.ExtensionIdentifier.toKey(Re));const De=V(ge,ve);return{globalRegistry:ge,myExtensions:De}}$startExtensionHost(te){te.toAdd.forEach(ge=>ge.extensionLocation=C.URI.revive(ge.extensionLocation));const{globalRegistry:le,myExtensions:Z}=Ln.mb(this.F,this.D,te);return this.F.set(le.getAllExtensionDescriptions()),this.D.set(Z),this.kb()}$activateByEvent(te,le){return le===1?this.R(te,!1):this.z.wait().then(Z=>this.R(te,!1))}async $activate(te,le){return await this.z.wait(),this.D.getExtensionDescription(te)?(await this.S(te,le),!0):!1}async $deltaExtensions(te){te.toAdd.forEach(De=>De.extensionLocation=C.URI.revive(De.extensionLocation));const{globalRegistry:le,myExtensions:Z}=Ln.mb(this.F,this.D,te),ge=await this.W(Z);return(await this.getExtensionPathIndex()).setSearchTree(ge),this.F.set(le.getAllExtensionDescriptions()),this.D.set(Z),Promise.resolve(void 0)}async $test_latency(te){return te}async $test_up(te){return te.byteLength}async $test_down(te){const le=m.VSBuffer.alloc(te),Z=Math.random()%256;for(let ge=0;ge<te;ge++)le.writeUInt8(Z,ge);return le}async $updateRemoteConnectionData(te){this.P=te,this.a.fire()}};U=qe([We(0,l.IInstantiationService),We(1,e.IHostUtils),We(2,c.IExtHostRpcService),We(3,d.IExtHostWorkspace),We(4,E.IExtHostConfiguration),We(5,R.ILogService),We(6,u.IExtHostInitDataService),We(7,s.IExtensionStoragePaths),We(8,r.IExtHostTunnelService),We(9,g.IExtHostTerminalService),We(10,F.IExtHostLocalizationService)],U),e.AbstractExtHostExtensionService=U;function W(J,te){return{id:J.identifier.value,name:J.name,extensionVersion:J.version,publisherDisplayName:J.publisher,activationEvents:J.activationEvents?J.activationEvents.join(","):null,isBuiltin:J.isBuiltin,reason:te.activationEvent,reasonId:te.extensionId.value}}e.IExtHostExtensionService=(0,l.createDecorator)("IExtHostExtensionService");class x{constructor(te,le,Z,ge,ve){M.set(this,void 0),N.set(this,void 0),B.set(this,void 0),Je(this,M,te,"f"),Je(this,N,le,"f"),Je(this,B,Z.identifier,"f"),this.id=Z.identifier.value,this.extensionUri=Z.extensionLocation,this.extensionPath=t.normalize((0,A.originalFSPath)(Z.extensionLocation)),this.packageJSON=Z,this.extensionKind=ge,this.isFromDifferentExtensionHost=ve}get isActive(){return Me(this,M,"f").isActivated(Me(this,B,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Me(this,M,"f").getExtensionExports(Me(this,B,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Me(this,M,"f").activateByIdWithErrors(Me(this,B,"f"),{startup:!1,extensionId:Me(this,N,"f"),activationEvent:"api"}),this.exports}}e.Extension=x,M=new WeakMap,N=new WeakMap,B=new WeakMap;function V(J,te){return J.getAllExtensionDescriptions().filter(le=>te.has(h.ExtensionIdentifier.toKey(le.identifier)))}function X(J){const te=J.indexOf("+");return te===-1?J:J.substring(0,te)}class Q{constructor(te){this.a=te}setSearchTree(te){this.a=te}findSubstr(te){return this.a.findSubstr(te)}forEach(te){return this.a.forEach(te)}}e.ExtensionPaths=Q}),define(Se[288],ye([1,0,76,2,5,34,26,27,16,25,3,41,36,13,8]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(p,o,i,l,u,s,c){this.c=p,this.d=o,this.e=i,this.f=l,this.g=u,this.h=s,this.i=c,this.a=new Map,this.b=[]}async install(){this.j(),a.mark("code/extHost/willWaitForConfig");const p=await this.f.getConfigProvider();a.mark("code/extHost/didWaitForConfig");const o=await this.g.getExtensionPathIndex();this.register(new f(this.c,o,this.d,p,this.i)),this.register(this.e.createInstance(w,o)),this.register(this.e.createInstance(b)),this.h.remote.isRemote&&this.register(this.e.createInstance(h,o,this.h.environment.appUriScheme))}register(p){if("nodeModuleName"in p)if(Array.isArray(p.nodeModuleName))for(const o of p.nodeModuleName)this.a.set(o,p);else this.a.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this.b.push(o=>p.alternativeModuleName(o))}};d=qe([We(2,R.IInstantiationService),We(3,A.IExtHostConfiguration),We(4,T.IExtHostExtensionService),We(5,C.IExtHostInitDataService),We(6,y.ILogService)],d),e.RequireInterceptor=d;let b=class ei{constructor(p){if(p.environment.appRoot&&ei.a.size){const o=(0,v.escapeRegExpCharacters)(this.c(p.environment.appRoot.fsPath)),i="[a-z0-9_.-]",l=`@${i}+\\/${i}+|${i}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${o}/${u}\\/)(${l})(.*)$`,"i")}}alternativeModuleName(p){if(!this.b)return;const o=this.b.exec(this.c(p));if(!o)return;const[,i,l,u]=o,s=ei.a.get(l);if(s!==void 0)return console.warn(`${l} as been renamed to ${s}, please update your imports`),i+s+u}c(p){return p.replace(/\\/g,"/")}};b.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),b=qe([We(0,C.IExtHostInitDataService)],b);class f{constructor(p,o,i,l,u){this.c=p,this.d=o,this.e=i,this.f=l,this.g=u,this.nodeModuleName="vscode",this.a=new Map}load(p,o){const i=this.d.findSubstr(o);if(i){let l=this.a.get(k.ExtensionIdentifier.toKey(i.identifier));return l||(l=this.c(i,this.e,this.f),this.a.set(k.ExtensionIdentifier.toKey(i.identifier),l)),l}if(!this.b){let l="";this.d.forEach((u,s)=>l+=`	${s} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${o}. These are the extension path mappings: 
${l}`),this.b=this.c(D.nullExtensionDescription,this.e,this.f)}return this.b}}let w=class{constructor(p,o,i){this.d=p,this.nodeModuleName="keytar",this.a=o.getProxy(I.MainContext.MainThreadTelemetry);const{environment:l}=i,u=o.getProxy(I.MainContext.MainThreadKeytar);if(l.appRoot){let s=l.appRoot.fsPath;E.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.b=new Set,this.b.add(`${s}/node_modules.asar/keytar`),this.b.add(`${s}/node_modules/keytar`)}this.c={getPassword:(s,c)=>u.$getPassword(s,c),setPassword:(s,c,n)=>u.$setPassword(s,c,n),deletePassword:(s,c)=>u.$deletePassword(s,c),findPassword:s=>u.$findPassword(s),findCredentials(s){return u.$findCredentials(s)}}}load(p,o){const i=this.d.findSubstr(o);return this.a.$publicLog2("shimming.keytar",{extension:i?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(p){const o=p.length;if(o<=7||!this.b)return;const i=o-7;if((p.charAt(i)==="/"||p.charAt(i)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.b.has(p)))return"keytar"}};w=qe([We(1,S.IExtHostRpcService),We(2,C.IExtHostInitDataService)],w);let h=class{constructor(p,o,i){this.e=p,this.f=o,this.nodeModuleName=["open","opn"],this.d=i.getProxy(I.MainContext.MainThreadTelemetry);const l=i.getProxy(I.MainContext.MainThreadWindow);this.c=(u,s)=>{const c=t.URI.parse(u);return s?this.g(u,s):c.scheme==="http"||c.scheme==="https"?l.$openUri(c,u,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this.f?l.$openUri(c,u,{}):this.g(u,s)}}load(p,o,i){const l=this.e.findSubstr(o);return l&&(this.a=l.identifier.value,this.h()),this.b=i(p),this.c}g(p,o){return this.i(),this.b(p,o)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};h=qe([We(2,S.IExtHostRpcService)],h)}),define(Se[48],ye([1,0,81,6,9,36,3,58,59,41,7,33,225,34]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,D.createDecorator)("IExtHostVariableResolverProvider");class v extends E.AbstractVariableResolverService{constructor(f,w,h,m,p,o,i){function l(){if(h){const u=h.activeEditor();if(u)return u.document.uri;const s=m.tabGroups.all.find(c=>c.isActive)?.activeTab;if(s!==void 0){if(s.input instanceof R.TextDiffTabInput||s.input instanceof R.NotebookDiffEditorTabInput)return s.input.modified;if(s.input instanceof R.TextTabInput||s.input instanceof R.NotebookEditorTabInput||s.input instanceof R.CustomEditorTabInput)return s.input.uri}}}super({getFolderUri:u=>{const s=o.folders.filter(c=>c.name===u);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>o.folders.length,getConfigurationValue:(u,s)=>p.getConfiguration(void 0,u).get(s),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=l();if(u)return I.normalize(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(w){const u=l();if(u){const s=w.getWorkspaceFolder(u);if(s)return I.normalize(s.uri.fsPath)}}},getSelectedText:()=>{if(h){const u=h.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(h){const u=h.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>f.getExtension(u)},void 0,i?Promise.resolve(i):void 0,Promise.resolve(A.env))}}let d=class extends t.Disposable{constructor(f,w,h,m,p){super(),this.b=f,this.c=w,this.g=h,this.h=m,this.i=p,this.a=new a.Lazy(async()=>{const o=await this.h.getConfigProvider(),l={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{l.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.i,o,l,this.j())})}getResolver(){return this.a.getValue()}j(){}};d=qe([We(0,C.IExtHostExtensionService),We(1,T.IExtHostWorkspace),We(2,k.IExtHostDocumentsAndEditors),We(3,y.IExtHostConfiguration),We(4,S.IExtHostEditorTabs)],d),e.ExtHostVariableResolverProviderService=d}),define(Se[77],ye([1,0,18,4,11,2,3,5,59,41,16,7,33,131,217,34,48]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,D.createDecorator)("IExtHostDebugService");let f=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(l,u,s,c,n,r){this.D=u,this.E=s,this.F=c,this.G=n,this.H=r,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new t.Emitter,this.n=new t.Emitter,this.o=new t.Emitter,this.u=new t.Emitter,this.k=l.getProxy(k.MainContext.MainThreadDebugService),this.z=new t.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new h(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(g=>{g.onDidChange(P=>{this.I(g)}),this.I(g)})}asDebugSourceUri(l,u){const s=l;if(typeof s.sourceReference=="number"&&s.sourceReference>0){let c=`debug:${encodeURIComponent(s.path||"")}`,n="?";return u&&(c+=`${n}session=${encodeURIComponent(u.id)}`,n="&"),c+=`${n}ref=${s.sourceReference}`,A.URI.parse(c)}else{if(s.path)return A.URI.file(s.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(l){const u=[];for(const s of l.getAllExtensionDescriptions())if(s.contributes){const c=s.contributes.debuggers;if(c&&c.length>0)for(const n of c)(0,v.isDebuggerMainContribution)(n)&&u.push(n.type)}this.k.$registerDebugTypes(u)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const l=[];return this.w.forEach(u=>l.push(u)),l}addBreakpoints(l){this.T();const u=l.filter(n=>{const r=n.id;return this.w.has(r)?!1:(this.w.set(r,n),!0)});this.U(u,[],[]);const s=[],c=new Map;for(const n of u)if(n instanceof T.SourceBreakpoint){let r=c.get(n.location.uri.toString());r||(r={type:"sourceMulti",uri:n.location.uri,lines:[]},c.set(n.location.uri.toString(),r),s.push(r)),r.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof T.FunctionBreakpoint&&s.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this.k.$registerBreakpoints(s)}removeBreakpoints(l){this.T();const u=l.filter(r=>this.w.delete(r.id));this.U([],u,[]);const s=u.filter(r=>r instanceof T.SourceBreakpoint).map(r=>r.id),c=u.filter(r=>r instanceof T.FunctionBreakpoint).map(r=>r.id),n=u.filter(r=>r instanceof T.DataBreakpoint).map(r=>r.id);return this.k.$unregisterBreakpoints(s,c,n)}startDebugging(l,u,s){return this.k.$startDebugging(l?l.uri:void 0,u,{parentSessionID:s.parentSession?s.parentSession.id:void 0,lifecycleManagedByParent:s.lifecycleManagedByParent,repl:s.consoleMode===T.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:s.noDebug,compact:s.compact,suppressSaveBeforeStart:s.suppressSaveBeforeStart,suppressDebugStatusbar:s.suppressDebugStatusbar??s.debugUI?.simple,suppressDebugToolbar:s.suppressDebugToolbar??s.debugUI?.simple,suppressDebugView:s.suppressDebugView??s.debugUI?.simple})}stopDebugging(l){return this.k.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,u,s){if(!u)return new T.Disposable(()=>{});const c=this.d++;return this.f.push({type:l,handle:c,provider:u}),this.k.$registerDebugConfigurationProvider(l,s,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,c),new T.Disposable(()=>{this.f=this.f.filter(n=>n.provider!==u),this.k.$unregisterDebugConfigurationProvider(c)})}registerDebugAdapterDescriptorFactory(l,u,s){if(!s)return new T.Disposable(()=>{});if(!this.P(l,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.M(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const c=this.g++;return this.h.push({type:u,handle:c,factory:s}),this.k.$registerDebugAdapterDescriptorFactory(u,c),new T.Disposable(()=>{this.h=this.h.filter(n=>n.factory!==s),this.k.$unregisterDebugAdapterDescriptorFactory(c)})}registerDebugAdapterTrackerFactory(l,u){if(!u)return new T.Disposable(()=>{});const s=this.i++;return this.j.push({type:l,handle:s,factory:u}),new T.Disposable(()=>{this.j=this.j.filter(c=>c.factory!==u)})}async $runInTerminal(l,u){return Promise.resolve(void 0)}async $substituteVariables(l,u){let s;const c=await this.W(l);return c&&(s={uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(s,u)}J(l,u){if(l.type==="implementation")return new p(l.implementation)}K(){}async $startDASession(l,u){const s=this,c=await this.V(u);return this.R(this.M(c.type),c).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}' (extension might have failed to activate)`);const r=this.L(n),g=this.J(r,c);if(!g)throw new Error(`Couldn't create a debug adapter for type '${c.type}'.`);const P=g;return this.A.set(l,P),this.Q(c).then(L=>(L&&this.B.set(l,L),P.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const _=z,K={type:"response",seq:0,command:_.command,request_seq:_.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const F=await this.C.sign(_.arguments.value);K.body={signature:F},P.sendResponse(K)}else throw new Error("no signer")}catch(F){K.success=!1,K.message=F.message,P.sendResponse(K)}}else L&&L.onDidSendMessage&&L.onDidSendMessage(z),z=(0,v.convertToVSCPaths)(z,!0),s.k.$acceptDAMessage(l,z)}),P.onError(z=>{L&&L.onError&&L.onError(z),this.k.$acceptDAError(l,z.name,z.message,z.stack)}),P.onExit(z=>{L&&L.onExit&&L.onExit((0,I.withNullAsUndefined)(z),void 0),this.k.$acceptDAExit(l,(0,I.withNullAsUndefined)(z),void 0)}),L&&L.onWillStartSession&&L.onWillStartSession(),P.startSession()))})}$sendDAMessage(l,u){u=(0,v.convertToDAPaths)(u,!1);const s=this.B.get(l);s&&s.onWillReceiveMessage&&s.onWillReceiveMessage(u),this.A.get(l)?.sendMessage(u)}$stopDASession(l){const u=this.B.get(l);this.B.delete(l),u&&u.onWillStopSession&&u.onWillStopSession();const s=this.A.get(l);return this.A.delete(l),s?s.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const u=[],s=[],c=[];if(l.added)for(const n of l.added){const r=n.id;if(r&&!this.w.has(r)){let g;if(n.type==="function")g=new T.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")g=new T.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const P=A.URI.revive(n.uri);g=new T.SourceBreakpoint(new T.Location(P,new T.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}g._id=r,this.w.set(r,g),u.push(g)}}if(l.removed)for(const n of l.removed){const r=this.w.get(n);r&&(this.w.delete(n),s.push(r))}if(l.changed){for(const n of l.changed)if(n.id){const r=this.w.get(n.id);if(r){if(r instanceof T.FunctionBreakpoint&&n.type==="function"){const g=r;g.enabled=n.enabled,g.condition=n.condition,g.hitCondition=n.hitCondition,g.logMessage=n.logMessage,g.functionName=n.functionName}else if(r instanceof T.SourceBreakpoint&&n.type==="source"){const g=r;g.enabled=n.enabled,g.condition=n.condition,g.hitCondition=n.hitCondition,g.logMessage=n.logMessage,g.location=new T.Location(A.URI.revive(n.uri),new T.Position(n.line,n.character))}c.push(r)}}}this.U(u,s,c)}$provideDebugConfigurations(l,u,s){return(0,a.asPromise)(async()=>{const c=this.O(l);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.W(u);return c.provideDebugConfigurations(n,s)}).then(c=>{if(!c)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return c})}$resolveDebugConfiguration(l,u,s,c){return(0,a.asPromise)(async()=>{const n=this.O(l);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const r=await this.W(u);return n.resolveDebugConfiguration(r,s,c)})}$resolveDebugConfigurationWithSubstitutedVariables(l,u,s,c){return(0,a.asPromise)(async()=>{const n=this.O(l);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const r=await this.W(u);return n.resolveDebugConfigurationWithSubstitutedVariables(r,s,c)})}async $provideDebugAdapter(l,u){const s=this.N(l);if(!s)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const c=await this.V(u);return this.R(s,c).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}'`);return this.L(n)})}async $acceptDebugSessionStarted(l){const u=await this.V(l);this.m.fire(u)}async $acceptDebugSessionTerminated(l){const u=await this.V(l);u&&(this.n.fire(u),this.l.delete(u.id))}async $acceptDebugSessionActiveChanged(l){this.q=l?await this.V(l):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(l,u){(await this.V(l))?._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(l,u){const c={session:await this.V(l),event:u.event,body:u.body};this.u.fire(c)}L(l){if(l instanceof T.DebugAdapterExecutable)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof T.DebugAdapterServer)return{type:"server",port:l.port,host:l.host};if(l instanceof T.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:l.path};if(l instanceof T.DebugAdapterInlineImplementation)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}M(l){const u=this.h.filter(s=>s.type===l);if(u.length>0)return u[0].factory}N(l){const u=this.h.filter(s=>s.handle===l);if(u.length>0)return u[0].factory}O(l){const u=this.f.filter(s=>s.handle===l);if(u.length>0)return u[0].provider}P(l,u){if(l.contributes){const s=l.contributes.debuggers;if(s&&s.length>0){for(const c of s)if(c.label&&c.type&&c.type===u)return!0}}return!1}Q(l){const s=l.configuration.type,c=this.j.filter(n=>n.type===s||n.type==="*").map(n=>(0,a.asPromise)(()=>n.factory.createDebugAdapterTracker(l)).then(r=>r,r=>null));return Promise.race([Promise.all(c).then(n=>{const r=n.filter(g=>!!g);if(r.length>0)return new m(r)}),new Promise(n=>setTimeout(()=>n(void 0),1e3))]).catch(n=>{})}async R(l,u){const s=u.configuration.debugServer;if(typeof s=="number")return Promise.resolve(new T.DebugAdapterServer(s));if(l){const n=await this.E.getExtensionRegistry();return(0,a.asPromise)(()=>l.createDebugAdapterDescriptor(u,this.S(u,n))).then(r=>{if(r)return r})}const c=await this.E.getExtensionRegistry();return Promise.resolve(this.S(u,c))}S(l,u){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(l,u,s){(l.length>0||u.length>0||s.length>0)&&this.z.fire(Object.freeze({added:l,removed:u,changed:s}))}async V(l){if(l)if(typeof l=="string"){const u=this.l.get(l);if(u)return u}else{let u=this.l.get(l.id);if(!u){const s=await this.W(l.folderUri),c=l.parent?this.l.get(l.parent):void 0;u=new w(this.k,l.id,l.type,l.name,s,l.configuration,c),this.l.set(u.id,u),this.k.$sessionCached(u.id)}return u}throw new Error("cannot find session")}W(l){if(l){const u=A.URI.revive(l);return this.D.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};f=qe([We(0,R.IExtHostRpcService),We(1,E.IExtHostWorkspace),We(2,C.IExtHostExtensionService),We(3,d.IExtHostConfiguration),We(4,S.IExtHostEditorTabs),We(5,b.IExtHostVariableResolverProvider)],f),e.ExtHostDebugServiceBase=f;class w{constructor(l,u,s,c,n,r,g){this.d=l,this.f=u,this.g=s,this.h=c,this.i=n,this.j=r,this.k=g}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(l){this.h=l,this.d.$setDebugSessionName(this.f,l)}get parentSession(){return this.k}_acceptNameChanged(l){this.h=l}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(l,u){return this.d.$customDebugAdapterRequest(this.f,l,u)}getDebugProtocolBreakpoint(l){return this.d.$getDebugProtocolBreakpoint(this.f,l.id)}}e.ExtHostDebugSession=w;class h{constructor(l){this.value=Object.freeze({append(u){l.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.ExtHostDebugConsole=h;class m{constructor(l){this.d=l}onWillStartSession(){this.d.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.d.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.d.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(l):void 0)}onWillStopSession(){this.d.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.d.forEach(u=>u.onError?u.onError(l):void 0)}onExit(l,u){this.d.forEach(s=>s.onExit?s.onExit(l,u):void 0)}}class p extends y.AbstractDebugAdapter{constructor(l){super(),this.h=l,l.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.h.handleMessage(l)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let o=class extends f{constructor(l,u,s,c,n,r){super(l,u,s,c,n,r)}};o=qe([We(0,R.IExtHostRpcService),We(1,E.IExtHostWorkspace),We(2,C.IExtHostExtensionService),We(3,d.IExtHostConfiguration),We(4,S.IExtHostEditorTabs),We(5,b.IExtHostVariableResolverProvider)],o),e.WorkerExtHostDebugService=o}),define(Se[289],ye([1,0,10,76,2,5,281,13,87,88,25,197,16,55,41,94]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{static async installEarlyHandler(h){const m=h.get(k.ILogService),o=h.get(E.IExtHostRpcService).getProxy(A.MainContext.MainThreadErrors);a.setUnexpectedErrorHandler(i=>{m.error(i);const l=a.transformErrorForSerialization(i);o.$onUnexpectedError(l)})}static async installFullHandler(h){const m=h.get(k.ILogService),p=h.get(E.IExtHostRpcService),o=h.get(v.IExtHostExtensionService),i=h.get(d.IExtHostTelemetry),l=p.getProxy(A.MainContext.MainThreadExtensionService),u=p.getProxy(A.MainContext.MainThreadErrors),s=await o.getExtensionPathIndex(),c=new WeakMap;Error.prepareStackTrace=(n,r)=>{let g="",P,L;for(const z of r)g+=`
	at ${z.toString()}`,L=z.getFileName(),!P&&L&&(P=s.findSubstr(I.URI.file(L)));return c.set(n,P?.identifier),`${n.name||"Error"}: ${n.message||""}${g}`},a.setUnexpectedErrorHandler(n=>{m.error(n);const r=a.transformErrorForSerialization(n),g=c.get(n);if(!g){u.$onUnexpectedError(r);return}l.$onExtensionRuntimeError(g,r);const P=i.onExtensionError(g,n);m.trace("forwarded error to extension?",P,g)})}}Error.stackTraceLimit=100;class f{constructor(h,m,p,o,i){this.a=p,this.b=new D.RPCProtocol(h,null,o),m=f.e(m,this.b);const l=new C.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());l.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...m,messagePorts:i}),l.set(E.IExtHostRpcService,new E.ExtHostRpcService(this.b)),l.set(y.IURITransformerService,new y.URITransformerService(o)),l.set(v.IHostUtils,p);const u=new T.InstantiationService(l,!0);u.invokeFunction(b.installEarlyHandler),this.d=u.invokeFunction(s=>s.get(k.ILogService)),t.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",m),this.c=u.invokeFunction(s=>s.get(v.IExtHostExtensionService)),this.c.initialize(),u.invokeFunction(b.installFullHandler)}async asBrowserUri(h){const m=this.b.getProxy(A.MainContext.MainThreadExtensionService);return I.URI.revive(await m.$asBrowserUri(h))}terminate(h){this.c.terminate(h)}static e(h,m){h.allExtensions.forEach(o=>{o.extensionLocation=I.URI.revive(m.transformIncomingURIs(o.extensionLocation));const i={};o.browserNlsBundleUris&&(Object.keys(o.browserNlsBundleUris).forEach(l=>i[l]=I.URI.revive(m.transformIncomingURIs(o.browserNlsBundleUris[l]))),o.browserNlsBundleUris=i)}),h.environment.appRoot=I.URI.revive(m.transformIncomingURIs(h.environment.appRoot));const p=h.environment.extensionDevelopmentLocationURI;return p&&(h.environment.extensionDevelopmentLocationURI=p.map(o=>I.URI.revive(m.transformIncomingURIs(o)))),h.environment.extensionTestsLocationURI=I.URI.revive(m.transformIncomingURIs(h.environment.extensionTestsLocationURI)),h.environment.globalStorageHome=I.URI.revive(m.transformIncomingURIs(h.environment.globalStorageHome)),h.environment.workspaceStorageHome=I.URI.revive(m.transformIncomingURIs(h.environment.workspaceStorageHome)),h.environment.extensionTelemetryLogResource=I.URI.revive(m.transformIncomingURIs(h.environment.extensionTelemetryLogResource)),h.nlsBaseUrl=I.URI.revive(m.transformIncomingURIs(h.nlsBaseUrl)),h.logsLocation=I.URI.revive(m.transformIncomingURIs(h.logsLocation)),h.logFile=I.URI.revive(m.transformIncomingURIs(h.logFile)),h.workspace=m.transformIncomingURIs(h.workspace),h}}e.ExtensionHostMain=f}),define(Se[290],ye([1,0,18,12,180,196,204,77,59,41,16,40,7,48,33,218,220,34]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v,d,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let w=class extends k.ExtHostDebugServiceBase{constructor(i,l,u,s,c,n,r){super(i,l,u,s,n,r),this.Z=c,this.X=new p}J(i,l){switch(i.type){case"server":return new d.SocketDebugAdapter(i);case"pipeServer":return new d.NamedPipeDebugAdapter(i);case"executable":return new d.ExecutableDebugAdapter(i,l.type)}return super.J(i,l)}S(i,l){const u=d.ExecutableDebugAdapter.platformAdapterExecutable(l.getAllExtensionDescriptions(),i.type);if(u)return new E.DebugAdapterExecutable(u.command,u.args,u.options)}K(){return new D.SignService}async $runInTerminal(i,l){if(i.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(F=>{this.X.onTerminalClosed(F)}));const u=await this.F.getConfigProvider(),s=this.Z.getDefaultShell(!0),c=this.Z.getDefaultShellArgs(!0),n=i.title||I.localize(0,null),r=JSON.stringify({shell:s,shellArgs:c});let g=await this.X.checkout(r,n),P,L=!1;if(g)P=i.cwd;else{const F={shellPath:s,shellArgs:c,cwd:i.cwd,name:n,iconPath:new E.ThemeIcon("debug")};L=!0,g=this.Z.createTerminalFromOptions(F,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(g,r)}g.show(!0);const z=await g.processId;L?await new Promise(F=>setTimeout(F,1e3)):u.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(s.indexOf("powershell")>=0||s.indexOf("pwsh")>=0||s.indexOf("cmd.exe")>=0?g.sendText("cls"):s.indexOf("bash")>=0?g.sendText("clear"):t.isWindows?g.sendText("cls"):g.sendText("clear"));const _=(0,b.prepareCommand)(s,i.args,!!i.argsCanBeInterpretedByShell,P,i.env);g.sendText(_);const K=this.onDidTerminateDebugSession(F=>{F.id===l&&(this.X.free(g),K.dispose())});return z}else if(i.kind==="external")return m(i,await this.F.getConfigProvider());return super.$runInTerminal(i,l)}};w=qe([We(0,R.IExtHostRpcService),We(1,v.IExtHostWorkspace),We(2,C.IExtHostExtensionService),We(3,f.IExtHostConfiguration),We(4,T.IExtHostTerminalService),We(5,S.IExtHostEditorTabs),We(6,y.IExtHostVariableResolverProvider)],w),e.ExtHostDebugService=w;let h;function m(o,i){if(!h)if(t.isWindows)h=new A.WindowsExternalTerminalService;else if(t.isMacintosh)h=new A.MacExternalTerminalService;else if(t.isLinux)h=new A.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const l=i.getConfiguration("terminal");return h.runInTerminal(o.title,o.cwd,o.args,o.env||{},l.external||{})}class p{constructor(){this.b=new Map}async checkout(i,l){const s=[...this.b.entries()].map(([c,n])=>(0,a.createCancelablePromise)(async r=>{if(c.name!==l||n.lastUsedAt!==-1&&await(0,b.hasChildProcesses)(await c.processId))return null;const g=Date.now();return n.lastUsedAt+p.a>g||r.isCancellationRequested||n.config!==i?null:(n.lastUsedAt=g,c)}));return await(0,a.firstParallel)(s,c=>!!c)}insert(i,l){this.b.set(i,{lastUsedAt:Date.now(),config:l})}free(i){const l=this.b.get(i);l&&(l.lastUsedAt=-1)}onTerminalClosed(i){this.b.delete(i)}}p.a=1e3}),define(Se[291],ye([1,0,9,2,114,33,58,34,46,40,16,25,75,15,13,70,24,86,48]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v,d,b,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let h=class extends E.ExtHostTaskBase{constructor(p,o,i,l,u,s,c,n,r){super(p,o,i,l,u,s,c,n),this.B=i,this.C=r,o.remote.isRemote&&o.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:o.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(p,o){const i=o;if(!o.execution&&i._id===void 0)throw new Error("Tasks to execute must include an execution");if(i._id!==void 0){const l=E.TaskHandleDTO.from(i,this.B),u=await this.a.$getTaskExecution(l);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.y(u,o);return this.a.$executeTask(l).catch(()=>{}),s}else{const l=E.TaskDTO.from(o,p);if(l===void 0)return Promise.reject(new Error("Task is not valid"));E.CustomExecutionDTO.is(l.execution)&&await this.x(l,o,!1);const u=await this.y(await this.a.$getTaskExecution(l),o);return this.a.$executeTask(l).catch(()=>{}),u}}u(p,o,i,l){const u=[];if(l)for(const s of l){this.z(s,i),(!s.definition||!p[s.definition.type])&&this.f.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const c=E.TaskDTO.from(s,i.extension);c&&(u.push(c),E.CustomExecutionDTO.is(c.execution)&&o.push(this.x(c,s,!0)))}return{tasks:u,extension:i.extension}}async v(p){return p}async F(p){let o=p&&p.length>0?p[0]:void 0;if(!o){const i=t.URI.file((0,f.homedir)());o=new S.WorkspaceFolder({uri:i,name:b.basename(i),index:0})}return{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(p,o){const i=t.URI.revive(p),l={process:void 0,variables:Object.create(null)},u=await this.b.resolveWorkspaceFolder(i),s=await this.b.getWorkspaceFolders2()??[],c=await this.C.getResolver(),n=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(s);for(const r of o.variables)l.variables[r]=await c.resolveAsync(n,r);if(o.process!==void 0){let r;if(o.process.path!==void 0){r=o.process.path.split(a.delimiter);for(let g=0;g<r.length;g++)r[g]=await c.resolveAsync(n,r[g])}l.process=await I.win32.findExecutable(await c.resolveAsync(n,o.process.name),o.process.cwd!==void 0?await c.resolveAsync(n,o.process.cwd):void 0,r)}return l}async $jsonTasksSupported(){return!0}async $findExecutable(p,o,i){return I.win32.findExecutable(p,o,i)}};h=qe([We(0,R.IExtHostRpcService),We(1,T.IExtHostInitDataService),We(2,A.IExtHostWorkspace),We(3,D.IExtHostDocumentsAndEditors),We(4,k.IExtHostConfiguration),We(5,C.IExtHostTerminalService),We(6,v.ILogService),We(7,d.IExtHostApiDeprecationService),We(8,w.IExtHostVariableResolverProvider)],h),e.ExtHostTask=h}),define(Se[292],ye([1,0,86,48]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class I extends t.ExtHostVariableResolverProviderService{j(){return(0,a.homedir)()}}e.NodeExtHostVariableResolverProviderService=I}),define(Se[143],ye([1,0,17,18,21,51,15,9,24,2,31]),function(ne,e,a,t,I,A,D,k,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class T{constructor(w,h,m,p){this.d=w,this.e=h,this.f=m,this.g=p,this.a=null,this.b=!1,this.c=0}search(w,h){const m=this.d.folderQueries||[],p=new I.CancellationTokenSource;return h.onCancellationRequested(()=>p.cancel()),new Promise((o,i)=>{this.a=new y(w);let l=!1;const u=(s,c)=>{if(!l&&!this.b){const n=this.h(s);d(s)&&typeof this.d.maxResults=="number"&&this.c+n>this.d.maxResults&&(this.b=!0,l=!0,p.cancel(),s=this.j(s,this.d.maxResults-this.c));const r=this.h(s);this.c+=r,(r>0||!d(s))&&this.a.add(s,c)}};Promise.all(m.map((s,c)=>this.k(s,n=>u(n,c),p.token))).then(s=>{p.dispose(),this.a.flush();const c=s.some(n=>!!n&&!!n.limitHit);o({limitHit:this.b||c,messages:(0,a.flatten)(s.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.g}})},s=>{p.dispose();const c=(0,A.toErrorMessage)(s);i(new Error(c))})})}h(w){return d(w)?Array.isArray(w.ranges)?w.ranges.length:1:0}j(w,h){const m=Array.isArray(w.ranges)?w.ranges:[w.ranges],p=Array.isArray(w.preview.matches)?w.preview.matches:[w.preview.matches];return{ranges:m.slice(0,h),preview:{matches:p.slice(0,h),text:w.preview.text},uri:w.uri}}async k(w,h,m){const p=new R.QueryGlobTester(this.d,w),o=[],i={report:s=>{if(!this.l(s))return;const c=w.folder.scheme===D.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.f.readdir(S.dirname(s.uri))):void 0,n=S.relativePath(w.folder,s.uri);if(n){const r=p.includedInQuery(n,k.basename(n),c);(0,t.isThenable)(r)?o.push(r.then(g=>{g&&h(s)})):r&&h(s)}}},l=this.n(w),u=await this.e.provideTextSearchResults(E(this.d.contentPattern),l,i,m);return o.length&&await Promise.all(o),u}l(w){if(d(w)){if(Array.isArray(w.ranges)){if(!Array.isArray(w.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(w.preview.matches.length!==w.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(w.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(w){const h=(0,R.resolvePatternsForProvider)(this.d.includePattern,w.includePattern),m=(0,R.resolvePatternsForProvider)(this.d.excludePattern,w.excludePattern),p={folder:C.URI.from(w.folder),excludes:m,includes:h,useIgnoreFiles:!w.disregardIgnoreFiles,useGlobalIgnoreFiles:!w.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!w.disregardParentIgnoreFiles,followSymlinks:!w.ignoreSymlinks,encoding:w.fileEncoding&&this.f.toCanonicalName(w.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return p.usePCRE2=this.d.usePCRE2,p}}e.TextSearchManager=T;function E(f){return{isCaseSensitive:f.isCaseSensitive||!1,isRegExp:f.isRegExp||!1,isWordMatch:f.isWordMatch||!1,isMultiline:f.isMultiline||!1,pattern:f.pattern}}class y{constructor(w){this.e=w,this.b=-1,this.d=null,this.a=new b(512,h=>this.g(h))}add(w,h){this.d&&(this.b!==h||!S.isEqual(this.c,w.uri))&&(this.f(),this.d=null),this.d||(this.b=h,this.d={resource:w.uri,results:[]}),this.d.results.push(v(w))}f(){const w=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,w)}flush(){this.f(),this.a.flush()}g(w){this.e(w)}}e.TextSearchResultsCollector=y;function v(f){return d(f)?{preview:{matches:(0,a.mapArrayOrNot)(f.preview.matches,w=>({startLineNumber:w.start.line,startColumn:w.start.character,endLineNumber:w.end.line,endColumn:w.end.character})),text:f.preview.text},ranges:(0,a.mapArrayOrNot)(f.ranges,w=>({startLineNumber:w.start.line,startColumn:w.start.character,endLineNumber:w.end.line,endColumn:w.end.character}))}:{text:f.text,lineNumber:f.lineNumber}}function d(f){return!!f.preview}e.extensionResultIsMatch=d;class b{constructor(w,h){this.g=w,this.h=h,this.c=0,this.d=[],this.e=0}addItem(w,h){!w||this.j(w,h)}addItems(w,h){!w||this.k(w,h)}j(w,h){this.d.push(w),this.e+=h,this.l()}k(w,h){this.d=this.d.concat(w),this.e+=h,this.l()}l(){this.c<b.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},b.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=b,b.a=4e3,b.b=50}),define(Se[78],ye([1,0,6,5,3,285,16,55,13,2,143]),function(ne,e,a,t,I,A,D,k,S,C,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let T=class{constructor(d,b,f){this.k=d,this.l=b,this.n=f,this.c=this.k.getProxy(t.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new A.FileSearchManager}o(d){return this.l.transformOutgoingScheme(d)}registerTextSearchProvider(d,b){if(this.g.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this.g.add(d);const f=this.d++;return this.e.set(f,b),this.c.$registerTextSearchProvider(f,this.o(d)),(0,a.toDisposable)(()=>{this.g.delete(d),this.e.delete(f),this.c.$unregisterProvider(f)})}registerFileSearchProvider(d,b){if(this.i.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this.i.add(d);const f=this.d++;return this.h.set(f,b),this.c.$registerFileSearchProvider(f,this.o(d)),(0,a.toDisposable)(()=>{this.i.delete(d),this.h.delete(f),this.c.$unregisterProvider(f)})}$provideFileSearchResults(d,b,f,w){const h=E(f),m=this.h.get(d);if(m)return this.j.fileSearch(h,m,p=>{this.c.$handleFileMatch(d,b,p.map(o=>o.resource))},w);throw new Error("unknown provider: "+d)}$clearCache(d){return this.j.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,b,f,w){const h=this.e.get(d);if(!h||!h.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const m=E(f);return this.q(m,h).search(o=>this.c.$handleTextMatch(d,b,o),w)}$enableExtensionHostSearch(){}q(d,b){return new R.TextSearchManager(d,b,{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f},"textSearchProvider")}};T=qe([We(0,D.IExtHostRpcService),We(1,k.IURITransformerService),We(2,S.ILogService)],T),e.ExtHostSearch=T;function E(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(y),extraFileResources:v.extraFileResources&&v.extraFileResources.map(d=>C.URI.revive(d))}}e.reviveQuery=E;function y(v){return{...v,folder:C.URI.revive(v.folder)}}}),define(Se[293],ye([1,0,87,142,33,139,34,39,58,40,75,77,78,97,54,70,141,71,47,96,94,59,140,13,230,48,95]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v,d,b,f,w,h,m,p,o,i,l,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(s.IExtHostLocalizationService,s.ExtHostLocalizationService,1),(0,a.registerSingleton)(i.ILoggerService,o.ExtHostLoggerService,1),(0,a.registerSingleton)(i.ILogService,l.ExtHostLogService,1),(0,a.registerSingleton)(d.IExtHostApiDeprecationService,d.ExtHostApiDeprecationService,1),(0,a.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands,0),(0,a.registerSingleton)(D.IExtHostConfiguration,D.ExtHostConfiguration,0),(0,a.registerSingleton)(f.IExtHostConsumerFileSystem,f.ExtHostConsumerFileSystem,0),(0,a.registerSingleton)(T.IExtHostDebugService,T.WorkerExtHostDebugService,0),(0,a.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations,0),(0,a.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,a.registerSingleton)(w.IExtHostFileSystemInfo,w.ExtHostFileSystemInfo,0),(0,a.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService,1),(0,a.registerSingleton)(E.IExtHostSearch,E.ExtHostSearch,0),(0,a.registerSingleton)(y.IExtHostStorage,y.ExtHostStorage,0),(0,a.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask,0),(0,a.registerSingleton)(C.IExtHostTerminalService,C.WorkerExtHostTerminalService,0),(0,a.registerSingleton)(v.IExtHostTunnelService,v.ExtHostTunnelService,0),(0,a.registerSingleton)(b.IExtHostWindow,b.ExtHostWindow,0),(0,a.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace,0),(0,a.registerSingleton)(h.IExtHostSecretState,h.ExtHostSecretState,0),(0,a.registerSingleton)(m.IExtHostTelemetry,m.ExtHostTelemetry,0),(0,a.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs,0),(0,a.registerSingleton)(u.IExtHostVariableResolverProvider,u.ExtHostVariableResolverProviderService,0)}),define(Se[98],ye([1,0,17,13,31,74]),function(ne,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function D(T){return T.startsWith("**")||T.startsWith("/")?T:`/${T}`}e.anchorGlob=D;function k(T,E,y,v){const d=(0,a.mapArrayOrNot)(y,S),b=new I.TextSearchMatch(E,d,v),f=b.preview.matches;return{ranges:(0,a.mapArrayOrNot)(d,C),uri:T,preview:{text:b.preview.text,matches:(0,a.mapArrayOrNot)(f,C)}}}e.createTextSearchResult=k;function S(T){return new I.SearchRange(T.start.line,T.start.character,T.end.line,T.end.character)}function C(T){return new A.Range(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn)}let R=class{constructor(E,y){this.a=E,this.b=y}appendLine(E){this.b.debug(`${this.a}#search`,E)}};R=qe([We(1,t.ILogService)],R),e.OutputChannel=R}),define(Se[294],ye([1,0,45,9,82,32,12,8,98,295]),function(ne,e,a,t,I,A,D,k,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const R=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function T(h,m,p,o){const i=E(h,m,p,o),l=m.folder.fsPath;return{cmd:a.spawn(R,i.args,{cwd:l}),rgDiskPath:R,siblingClauses:i.siblingClauses,rgArgs:i,cwd:l}}e.spawnRipgrepCmd=T;function E(h,m,p,o){const i=["--files","--hidden","--case-sensitive"];v([m],p,!1).forEach(u=>{const s=(0,S.anchorGlob)(u);if(i.push("-g",s),D.isMacintosh){const c=(0,I.normalizeNFD)(s);c!==s&&i.push("-g",c)}});const l=y([m],o,void 0,!1);return l.globArgs.forEach(u=>{const s=`!${(0,S.anchorGlob)(u)}`;if(i.push("-g",s),D.isMacintosh){const c=(0,I.normalizeNFD)(s);c!==s&&i.push("-g",c)}}),m.disregardIgnoreFiles!==!1?i.push("--no-ignore"):m.disregardParentIgnoreFiles!==!1&&i.push("--no-ignore-parent"),m.ignoreSymlinks||i.push("--follow"),h.exists&&i.push("--quiet"),i.push("--no-config"),m.disregardGlobalIgnoreFiles&&i.push("--no-ignore-global"),{args:i,siblingClauses:l.siblingClauses}}function y(h,m,p,o=!0){const i=[];let l={};return h.forEach(u=>{const s=Object.assign({},u.excludePattern||{},m||{}),c=d(s,o?u.folder.fsPath:void 0,p);i.push(...c.globArgs),c.siblingClauses&&(l=Object.assign(l,c.siblingClauses))}),{globArgs:i,siblingClauses:l}}e.foldersToRgExcludeGlobs=y;function v(h,m,p=!0){const o=[];return h.forEach(i=>{const l=Object.assign({},m||{},i.includePattern||{}),u=d(l,p?i.folder.fsPath:void 0);o.push(...u.globArgs)}),o}e.foldersToIncludeGlobs=v;function d(h,m,p){const o=[],i={};return Object.keys(h).forEach(l=>{if(p&&p.has(l)||!l)return;const u=h[l];l=f(m?b(m,l):l),l.startsWith("\\\\")?l="\\\\"+l.substr(2).replace(/\\/g,"/"):l=l.replace(/\\/g,"/"),typeof u=="boolean"&&u?(l.startsWith("\\\\")&&(l+="**"),o.push(w(l))):u&&u.when&&(i[l]=u)}),{globArgs:o,siblingClauses:i}}function b(h,m){return t.isAbsolute(m)?m:t.join(h,m)}e.getAbsoluteGlob=b;function f(h){return h=k.rtrim(h,"\\"),k.rtrim(h,"/")}function w(h){return A.getRoot(h).toLowerCase()==="c:/"?h.replace(/^c:[/\\]/i,"/"):h}e.fixDriveC=w}),define(Se[296],ye([1,0,45,65,9,297,17,51,37,82,32,12,44,8,11,29,31,294,109]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v,d,b,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const h=new Set;process.on("exit",()=>{h.forEach(l=>l())});class m{constructor(u){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=u,this.b=u.filePattern||"",this.d=u.includePattern&&S.parse(u.includePattern),this.f=u.maxResults||null,this.g=!!u.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,w.prepareQuery)(this.b).normalizedLowercase),this.u=u.excludePattern&&S.parse(u.excludePattern),this.t=new Map,u.folderQueries.forEach(s=>{const c=Object.assign({},s.excludePattern||{},this.a.excludePattern||{}),n=s.folder.fsPath;u.folderQueries.map(r=>r.folder.fsPath).filter(r=>r!==n).forEach(r=>{(0,R.isEqualOrParent)(r,n)&&(c[I.relative(n,r)]=!0)}),this.t.set(n,new o(c,n))})}cancel(){this.l=!0,h.forEach(u=>u())}walk(u,s,c,n,r){if(this.m=E.StopWatch.create(!1),this.l)return r(null,this.j);s.forEach(g=>{const P=I.basename(g.fsPath);this.u&&this.u(g.fsPath,P)||this.J(c,{relativePath:g.fsPath,searchPath:void 0})}),this.r=E.StopWatch.create(!1),this.w(u,(g,P)=>{this.x(this.y,this,g,c,n,L=>{if(L){const z=(0,k.toErrorMessage)(L);console.error(z),this.q.push(z),P(L,void 0)}else P(null,void 0)})},(g,P)=>{this.m.stop();const L=g?D.coalesce(g)[0]:null;r(L,this.j)})}w(u,s,c){const n=new Array(u.length),r=new Array(u.length);let g=!1,P=0;if(u.length===0)return c(null,[]);u.forEach((L,z)=>{s(L,(_,K)=>{if(_?(g=!0,n[z]=null,r[z]=_):(n[z]=K,r[z]=null),++P===u.length)return c(g?r:null,n)})})}x(u,s,...c){try{u.apply(s,c)}catch(n){c[c.length-1](n)}}y(u,s,c,n){const r=u.folder.fsPath,g=T.isMacintosh,P=()=>F&&F.kill();h.add(P);let L=U=>{h.delete(P),L=()=>{},n(U)},z="";const _=this.D(),K=(0,f.spawnRipgrepCmd)(this.a,u,this.a.includePattern,this.t.get(u.folder.fsPath).expression),F=K.cmd,M=!Object.keys(K.siblingClauses).length,N=K.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let B=`${K.rgDiskPath} ${N}
 - cwd: ${K.cwd}`;K.rgArgs.siblingClauses&&(B+=`
 - Sibling clauses: ${JSON.stringify(K.rgArgs.siblingClauses)}`),c({message:B}),this.s=0,this.z(F,"utf8",c,(U,W,x)=>{if(U){L(U);return}if(this.j){L();return}const X=(z+(g?C.normalizeNFC(W||""):W)).split(`
`);if(x){const Q=X.length;X[Q-1]=X[Q-1].trim(),X[Q-1]||X.pop()}else z=X.pop()||"";if(X.length&&X[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.s+=X.length,M){for(const Q of X)if(this.J(s,{base:r,relativePath:Q,searchPath:this.N(u,Q)}),this.j){P();break}(x||this.j)&&L();return}this.G(u,_,r,X,s),x&&(this.H(_,r,s),L())})}spawnFindCmd(u){const s=this.t.get(u.folder.fsPath),c=s.getBasenameTerms(),n=s.getPathTerms(),r=["-L","."];if(c.length||n.length){r.push("-not","(","(");for(const g of c)r.push("-name",g),r.push("-o");for(const g of n)r.push("-path",g),r.push("-o");r.pop(),r.push(")","-prune",")")}return r.push("-type","f"),a.spawn("find",r,{cwd:u.folder.fsPath})}readStdout(u,s,c){let n="";this.z(u,s,()=>{},(r,g,P)=>{if(r){c(r);return}n+=g,P&&c(null,n)})}z(u,s,c,n){let r=(L,z,_)=>{(L||_)&&(r=()=>{},this.r?.stop()),n(L,z,_)},g=!1;u.stdout?(this.A(u.stdout,s,r),u.stdout.once("data",()=>g=!0)):c({message:"stdout is null"});let P;u.stderr?P=this.B(u.stderr):c({message:"stderr is null"}),u.on("error",L=>{r(L)}),u.on("close",L=>{let z;!g&&(z=this.C(P,s))&&i(z)?r(new Error(`command failed with error code ${L}: ${this.C(P,s)}`)):(this.g&&L===0&&(this.j=!0),r(null,"",!0))})}A(u,s,c){const n=new A.StringDecoder(s);return u.on("data",r=>{c(null,n.write(r))}),n}B(u){const s=[];return u.on("data",c=>{s.push(c)}),s}C(u,s){const c=new A.StringDecoder(s);return u.map(n=>c.write(n)).join("")}D(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}G(u,{pathToEntries:s},c,n,r){n.indexOf(this.b)!==-1&&this.J(r,{base:c,relativePath:this.b,searchPath:this.N(u,this.b)});const g=P=>{const L=I.basename(P),z=I.dirname(P);let _=s[z];_||(_=s[z]=[],g(z)),_.push({base:c,relativePath:P,basename:L,searchPath:this.N(u,P)})};n.forEach(g)}H({rootEntries:u,pathToEntries:s},c,n){const r=this,g=this.t.get(c),P=this.b;function L(z){r.o++;const _=(0,b.hasSiblingFn)(()=>z.map(K=>K.basename));for(let K=0,F=z.length;K<F;K++){const M=z[K],{relativePath:N,basename:B}=M;if(g.test(N,B,P!==B?_:void 0))continue;const U=s[N];if(U)L(U);else{if(r.p++,N===P)continue;r.J(n,M)}if(r.j)break}}L(u)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(u,s,c,n,r){const g=u.folder,P=(0,b.hasSiblingFn)(()=>c);this.w(c,(L,z)=>{if(this.l||this.j)return z(null);const _=s?[s,L].join(I.sep):L;if(this.t.get(u.folder.fsPath).test(_,L,this.a.filePattern!==L?P:void 0))return z(null);const K=[g.fsPath,_].join(I.sep);t.lstat(K,(F,M)=>{if(F||this.l||this.j)return z(null);this.L(K,M,(N,B)=>N||this.l||this.j?z(null):B.isDirectory()?(this.o++,this.M(K,M,(U,W)=>U||this.l||this.j||(W=W||"",this.v[W])?z(null):(this.v[W]=!0,d.Promises.readdir(K).then(x=>{if(this.l||this.j)return z(null);this.I(u,_,x,n,V=>z(V||null))},x=>{z(null)})))):(this.p++,_===this.b||this.h&&v.isNumber(B.size)&&B.size>this.h||this.J(n,{base:g.fsPath,relativePath:_,searchPath:this.N(u,_)}),z(null,void 0)))})},L=>{const z=L&&D.coalesce(L);return r(z&&z.length>0?z[0]:void 0)})}J(u,s){this.K(s)&&(!this.d||this.d(s.relativePath,I.basename(s.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||u(s))}K(u){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,b.isFilePatternMatch)(u,this.c)}return!0}L(u,s,c){return s.isSymbolicLink()?t.stat(u,c):c(null,s)}M(u,s,c){return s.isSymbolicLink()?t.realpath(u,(n,r)=>n?c(n):c(null,r)):c(null,u)}N(u,s){return u.folderName?I.join(u.folderName,s):s}}e.FileWalker=m;class p{constructor(u){this.a=u.folderQueries,this.b=u.extraFileResources||[],this.c=new m(u)}search(u,s,c){this.c.walk(this.a,this.b,u,s,(n,r)=>{c(n,{limitHit:r,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=p;class o{constructor(u,s){this.expression=u,this.c=s,this.d(u)}d(u){let s,c;Object.keys(u).filter(n=>u[n]).forEach(n=>{I.isAbsolute(n)?(s=s||S.getEmptyExpression(),s[n]=u[n]):(c=c||S.getEmptyExpression(),c[n]=u[n])}),this.a=s&&S.parse(s,{trimForExclusions:!0}),this.b=c&&S.parse(c,{trimForExclusions:!0})}test(u,s,c){return this.b&&this.b(u,s,c)||this.a&&this.a(I.join(this.c,u),s,c)}getBasenameTerms(){const u=[];return this.a&&u.push(...S.getBasenameTerms(this.a)),this.b&&u.push(...S.getBasenameTerms(this.b)),u}getPathTerms(){const u=[];return this.a&&u.push(...S.getPathTerms(this.a)),this.b&&u.push(...S.getPathTerms(this.b)),u}}function i(l){const u=l.trim().split(`
`),s=u[0].trim();if(s.startsWith("Error parsing regex"))return s;if(s.startsWith("regex parse error"))return y.uppercaseFirstLetter(u[u.length-1].trim());if(s.startsWith("error parsing glob")||s.startsWith("unsupported encoding"))return s.charAt(0).toUpperCase()+s.substr(1);if(s==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(s.startsWith("Literal "))return s}e.rgErrorMsgForDisplay=i}),define(Se[298],ye([1,0,101,22]),function(ne,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(l){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(u=>u===l)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const A=512,D=512,k=512*8,S=512*128;var C;(function(l){l[l.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class R extends Error{constructor(u,s){super(u),this.decodeStreamErrorKind=s}}e.DecodeStreamError=R;class T{static async create(u){let s;if(u!==e.UTF8)s=(await new Promise((n,r)=>{ne(["@vscode/iconv-lite-umd"],n,r)})).getDecoder(d(u));else{const c=new TextDecoder;s={write(n){return c.decode(n,{stream:!0})},end(){return c.decode()}}}return new T(s)}constructor(u){this.a=u}write(u){return this.a.write(u)}end(){return this.a.end()}}function E(l,u){const s=u.minBytesRequiredForDetection??u.guessEncoding?k:D;return new Promise((c,n)=>{const r=(0,a.newWriteableStream)(K=>K.join("")),g=[];let P=0,L,z;const _=async()=>{try{const K=await i({buffer:t.VSBuffer.concat(g),bytesRead:P},u.guessEncoding);if(K.seemsBinary&&u.acceptTextOnly)throw new R("Stream is binary but only text is accepted for decoding",1);K.encoding=await u.overwriteEncoding(K.encoding),L=await T.create(K.encoding);const F=L.write(t.VSBuffer.concat(g).buffer);r.write(F),g.length=0,P=0,c({stream:r,detected:K})}catch(K){z?.dispose(),r.destroy(),n(K)}};z=(0,a.listenStream)(l,{onData:async K=>{L?r.write(L.write(K.buffer)):(g.push(K),P+=K.byteLength,P>=s&&(l.pause(),await _(),setTimeout(()=>l.resume())))},onError:K=>r.error(K),onEnd:async()=>{L||await _(),r.end(L?.end())}})})}e.toDecodeStream=E;async function y(l,u,s){const n=(await new Promise((P,L)=>{ne(["@vscode/iconv-lite-umd"],P,L)})).getEncoder(d(u),s);let r=!1,g=!1;return{read(){if(g)return null;const P=l.read();if(typeof P!="string"){if(g=!0,!r&&s?.addBOM)switch(u){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const L=n.end();return L&&L.length>0?(r=!0,t.VSBuffer.wrap(L)):null}return r=!0,t.VSBuffer.wrap(n.write(P))}}}e.toEncodeReadable=y;async function v(l){return(await new Promise((s,c)=>{ne(["@vscode/iconv-lite-umd"],s,c)})).encodingExists(d(l))}e.encodingExists=v;function d(l){return l===e.UTF8_with_bom||l===null?e.UTF8:l}e.toNodeEncoding=d;function b(l,u){if(!l||u<e.UTF16be_BOM.length)return null;const s=l.readUInt8(0),c=l.readUInt8(1);if(s===e.UTF16be_BOM[0]&&c===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&c===e.UTF16le_BOM[1])return e.UTF16le;if(u<e.UTF8_BOM.length)return null;const n=l.readUInt8(2);return s===e.UTF8_BOM[0]&&c===e.UTF8_BOM[1]&&n===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=b;const f=["ascii","utf-16","utf-32"];async function w(l){const u=await new Promise((g,P)=>{ne(["jschardet"],g,P)}),s=l.slice(0,S),c=p(s.buffer),n=u.detect(c);if(!n||!n.encoding)return null;const r=n.encoding.toLowerCase();return 0<=f.indexOf(r)?null:m(n.encoding)}const h={ibm866:"cp866",big5:"cp950"};function m(l){const u=l.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return h[u]||u}function p(l){let u="";for(let s=0;s<l.length;s++)u+=String.fromCharCode(l[s]);return u}function o(l){switch(l){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const u=l.match(/windows(\d+)/);return u?"windows-"+u[1]:l}}}e.toCanonicalName=o;function i({buffer:l,bytesRead:u},s){let c=b(l,u),n=!1;if(c!==e.UTF16be&&c!==e.UTF16le&&l){let r=!0,g=!0,P=!1;for(let L=0;L<u&&L<A;L++){const z=L%2===1,_=l.readUInt8(L)===0;if(_&&(P=!0),r&&(z&&!_||!z&&_)&&(r=!1),g&&(z&&_||!z&&!_)&&(g=!1),_&&!r&&!g)break}P&&(r?c=e.UTF16le:g?c=e.UTF16be:n=!0)}return s&&!n&&!c&&l?w(l.slice(0,u)).then(r=>({seemsBinary:!1,encoding:r})):{seemsBinary:n,encoding:c}}e.detectEncodingFromBuffer=i,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[144],ye([1,0,298,29,143]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class A extends I.TextSearchManager{constructor(k,S,C=t,R="searchProcess"){super(k,S,{readdir:T=>C.Promises.readdir(T.fsPath),toCanonicalName:T=>(0,a.toCanonicalName)(T)},R)}}e.NativeTextSearchManager=A}),define(Se[299],ye([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class a{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(I){if(I&&this.a.has(I)){const A=this.a.get(I);return this.a.delete(I),A}}addDragOperationTransfer(I,A){this.a.set(I,A)}getRenderedTreeElement(I){if(this.b.has(I))return this.b.get(I)}addRenderedTreeItemElement(I,A){this.b.set(I,A)}removeRenderedTreeItemElement(I){this.b.has(I)&&this.b.delete(I)}}e.TreeviewsService=a}),define(Se[300],ye([1,0,178,7,24,2,4,6,18,7,11,17,14,21,299,26]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function b(h,m){if((0,R.isString)(h))return{label:h};if(h&&typeof h=="object"&&typeof h.label=="string"){let p;return Array.isArray(h.highlights)&&(p=h.highlights.filter(o=>o.length===2&&typeof o[0]=="number"&&typeof o[1]=="number"),p=p.length?p:void 0),{label:h.label,highlights:p}}}class f{constructor(m,p,o){this.d=m,this.e=p,this.f=o,this.a=new Map,this.b=new v.TreeviewsService;function i(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}p.registerArgumentProcessor({processArgument:l=>i(l)?this.i(l):Array.isArray(l)&&l.length>0?l.map(u=>i(u)?this.i(u):u):l})}registerTreeDataProvider(m,p,o){const i=this.createTreeView(m,{treeDataProvider:p},o);return{dispose:()=>i.dispose()}}createTreeView(m,p,o){if(!p||!p.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=p.dragAndDropController?.dropMimeTypes??[],l=p.dragAndDropController?.dragMimeTypes??[],u=!!p.dragAndDropController?.handleDrag,s=!!p.dragAndDropController?.handleDrop,c=this.h(m,p,o),n=this.d.$registerTreeViewDataProvider(m,{showCollapseAll:!!p.showCollapseAll,canSelectMany:!!p.canSelectMany,dropMimeTypes:i,dragMimeTypes:l,hasHandleDrag:u,hasHandleDrop:s});return{get onDidCollapseElement(){return c.onDidCollapseElement},get onDidExpandElement(){return c.onDidExpandElement},get selection(){return c.selectedElements},get onDidChangeSelection(){return c.onDidChangeSelection},get visible(){return c.visible},get onDidChangeVisibility(){return c.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,d.checkProposedApiEnabled)(o,"treeItemCheckbox"),c.onDidChangeCheckboxState},get message(){return c.message},set message(r){c.message=r},get title(){return c.title},set title(r){c.title=r},get description(){return c.description},set description(r){c.description=r},get badge(){return c.badge},set badge(r){r!==void 0&&C.ViewBadge.isViewBadge(r)?c.badge={value:Math.floor(Math.abs(r.value)),tooltip:r.tooltip}:r===void 0&&(c.badge=void 0)},reveal:(r,g)=>c.reveal(r,g),dispose:async()=>{await n,this.a.delete(m),c.dispose()}}}$getChildren(m,p){const o=this.a.get(m);return o?o.getChildren(p):Promise.reject(new Error((0,a.localize)(0,null,m)))}async $handleDrop(m,p,o,i,l,u,s,c){const n=this.a.get(m);if(!n)return Promise.reject(new Error((0,a.localize)(1,null,m)));const r=E.DataTransfer.toDataTransfer(o,async g=>(await this.d.$resolveDropFileData(m,p,g)).buffer);return s===m&&c&&await this.g(r,n,c,l,u),n.onDrop(r,i,l)}async g(m,p,o,i,l){const u=this.b.removeDragOperationTransfer(l);if(u)(await u)?.forEach((s,c)=>{s&&m.set(c,s)});else if(l&&p.handleDrag){const s=p.handleDrag(o,m,i);this.b.addDragOperationTransfer(l,s),await s}return m}async $handleDrag(m,p,o,i){const l=this.a.get(m);if(!l)return Promise.reject(new Error((0,a.localize)(2,null,m)));const u=await this.g(new t.DataTransfer,l,p,i,o);if(!!u)return E.DataTransfer.toDataTransferDTO(u)}async $hasResolve(m){const p=this.a.get(m);if(!p)throw new Error((0,a.localize)(3,null,m));return p.hasResolve}$resolve(m,p,o){const i=this.a.get(m);if(!i)throw new Error((0,a.localize)(4,null,m));return i.resolveTreeItem(p,o)}$setExpanded(m,p,o){const i=this.a.get(m);if(!i)throw new Error((0,a.localize)(5,null,m));i.setExpanded(p,o)}$setSelection(m,p){const o=this.a.get(m);if(!o)throw new Error((0,a.localize)(6,null,m));o.setSelection(p)}$setFocus(m,p){const o=this.a.get(m);if(!o)throw new Error((0,a.localize)(7,null,m));o.setFocus(p)}$setVisible(m,p){const o=this.a.get(m);if(!o)throw new Error((0,a.localize)(8,null,m));o.setVisible(p)}$changeCheckboxState(m,p){const o=this.a.get(m);if(!o)throw new Error((0,a.localize)(9,null,m));o.setCheckboxState(p)}h(m,p,o){const i=new w(m,p,this.d,this.e.converter,this.f,o);return this.a.set(m,i),i}i(m){const p=this.a.get(m.$treeViewId);return p&&"$treeItemHandle"in m?p.getExtensionElement(m.$treeItemHandle):p&&"$focusedTreeItem"in m&&m.$focusedTreeItem?p.focusedElement:null}}e.ExtHostTreeViews=f;class w extends k.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(m=>this.getExtensionElement(m)).filter(m=>!(0,R.isUndefinedOrNull)(m))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(m,p,o,i,l,u){if(super(),this.C=m,this.D=o,this.F=i,this.G=l,this.H=u,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new D.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new D.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new D.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new D.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new D.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new D.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new y.CancellationTokenSource,u.contributes&&u.contributes.views)for(const n in u.contributes.views)for(const r of u.contributes.views[n])r.id===m&&(this.J=r.name);this.f=p.treeDataProvider,this.g=p.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(n=>this.w.fire({message:!1,element:n})));let s,c;this.B(D.Event.debounce(this.w.event,(n,r)=>(n||(n={message:!1,elements:[]}),r.element!==!1&&(s||(s=new Promise(g=>c=g),this.y=this.y.then(()=>s)),Array.isArray(r.element)?n.elements.push(...r.element):n.elements.push(r.element)),r.message&&(n.message=!0),n),200,!0)(({message:n,elements:r})=>{r.length&&(this.z=this.z.then(()=>{const g=c;return s=null,this.U(r).then(()=>g())})),n&&this.D.$setMessage(this.C,this.I)}))}async getChildren(m){const p=m?this.getExtensionElement(m):void 0;if(m&&!p)return this.G.error(`No tree item with id '${m}' found.`),Promise.resolve([]);let o=this.Q(m);return o||(o=await this.R(p)),o?o.map(i=>i.item):void 0}getExtensionElement(m){return this.i.get(m)}reveal(m,p){p=p||{select:!0,focus:!1};const o=(0,R.isUndefinedOrNull)(p.select)?!0:p.select,i=(0,R.isUndefinedOrNull)(p.focus)?!1:p.focus,l=(0,R.isUndefinedOrNull)(p.expand)?!1:p.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):m?this.y.then(()=>this.N(m)).then(u=>this.P(m,u[u.length-1]).then(s=>this.D.$reveal(this.C,{item:s.item,parentChain:u.map(c=>c.item)},{select:o,focus:i,expand:l})),u=>this.G.error(u)):this.D.$reveal(this.C,void 0,{select:o,focus:i,expand:l})}get message(){return this.I}set message(m){this.I=m,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(m){this.J=m,this.D.$setTitle(this.C,m,this.L)}get description(){return this.L}set description(m){this.L=m,this.D.$setTitle(this.C,this.J,m)}get badge(){return this.M}set badge(m){this.M?.value===m?.value&&this.M?.tooltip===m?.tooltip||(this.M=E.ViewBadge.from(m),this.D.$setBadge(this.C,m))}setExpanded(m,p){const o=this.getExtensionElement(m);o&&(p?this.r.fire(Object.freeze({element:o})):this.s.fire(Object.freeze({element:o})))}setSelection(m){(0,T.equals)(this.l,m)||(this.l=m,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(m){this.m=m}setVisible(m){m!==this.k&&(this.k=m,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(m){const p=(await Promise.all(m.map(async o=>{const i=this.getExtensionElement(o.treeItemHandle);return i?{extensionItem:i,treeItem:await this.f.getTreeItem(i),newState:o.newState?C.TreeItemCheckboxState.Checked:C.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(o=>o!==void 0);p.forEach(o=>{o.treeItem.checkboxState=o.newState?C.TreeItemCheckboxState.Checked:C.TreeItemCheckboxState.Unchecked}),this.v.fire({items:p.map(o=>[o.extensionItem,o.newState])})}async handleDrag(m,p,o){const i=[];for(const l of m){const u=this.getExtensionElement(l);u&&i.push(u)}if(!(!this.g?.handleDrag||i.length===0))return await this.g.handleDrag(i,p,o),p}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(m,p,o){const i=p?this.getExtensionElement(p):void 0;if(!(!i&&p||!this.g?.handleDrop))return(0,S.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(i,m,o):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(m,p){if(!this.f.resolveTreeItem)return;const o=this.i.get(m);if(o){const i=this.j.get(o);if(i){const l=await this.f.resolveTreeItem(i.extensionItem,o,p)??i.extensionItem;return this.db(l),i.item.tooltip=this.ab(l.tooltip),i.item.command=this.bb(i.disposableStore,l.command),i.item}}}N(m){return this.O(m).then(p=>p?this.N(p).then(o=>this.P(p,o[o.length-1]).then(i=>(o.push(i),o))):Promise.resolve([]))}O(m){const p=this.j.get(m);return p?Promise.resolve(p.parent?this.i.get(p.parent.item.handle):void 0):(0,S.asPromise)(()=>this.f.getParent(m))}P(m,p){const o=this.j.get(m);return o?Promise.resolve(o):(0,S.asPromise)(()=>this.f.getTreeItem(m)).then(i=>this.gb(m,i,p,!0)).then(i=>this.getChildren(p?p.item.handle:void 0).then(()=>{const l=this.getExtensionElement(i);if(l){const u=this.j.get(l);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}Q(m){if(m){let p;if(typeof m=="string"){const o=this.getExtensionElement(m);p=o?this.j.get(o):void 0}else p=m;return p&&p.children||void 0}return this.h}async R(m){this.nb(m);const p=new y.CancellationTokenSource(this.S.token);try{const o=m?this.j.get(m):void 0,i=await this.f.getChildren(m);if(p.token.isCancellationRequested)return;const l=await Promise.all((0,T.coalesce)(i||[]).map(async u=>{const s=await this.f.getTreeItem(u);return s&&!p.token.isCancellationRequested?this.Z(u,s,o):null}));return p.token.isCancellationRequested?void 0:(0,T.coalesce)(l)}finally{p.dispose()}}U(m){if(m.some(o=>!o))return this.S.dispose(!0),this.S=new y.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const o=this.W(m);if(o.length)return this.X(o)}return Promise.resolve(void 0)}W(m){const p=new Set,o=m.map(l=>this.j.get(l));for(const l of o)if(l&&!p.has(l.item.handle)){let u=l;for(;u&&u.parent&&o.findIndex(s=>u&&u.parent&&s&&s.item.handle===u.parent.item.handle)===-1;){const s=this.i.get(u.parent.item.handle);u=s?this.j.get(s):void 0}u&&!u.parent&&p.add(l.item.handle)}const i=[];return p.forEach(l=>{const u=this.i.get(l);if(u){const s=this.j.get(u);s&&(!s.parent||!p.has(s.parent.item.handle))&&i.push(l)}}),i}X(m){const p={};return Promise.all(m.map(o=>this.Y(o).then(i=>{i&&(p[o]=i.item)}))).then(()=>Object.keys(p).length?this.D.$refresh(this.C,p):void 0)}Y(m){const p=this.getExtensionElement(m);if(p){const o=this.j.get(p);if(o)return this.nb(p),(0,S.asPromise)(()=>this.f.getTreeItem(p)).then(i=>{if(i){const l=this.eb(p,i,o.parent);return this.lb(p,l,o,o.parent),o.dispose(),l}return null})}return Promise.resolve(null)}Z(m,p,o){const i=this.eb(m,p,o);if(p.id&&this.i.has(i.item.handle))throw new Error((0,a.localize)(10,null,p.id));return this.kb(m,i),this.mb(i,o),i}ab(m){return C.MarkdownString.isMarkdownString(m)?E.MarkdownString.from(m):m}bb(m,p){return p?{...this.F.toInternal(p,m),originalId:p.command}:void 0}cb(m){if(!m.checkboxState)return;let p,o;return typeof m.checkboxState=="number"?p=m.checkboxState:(p=m.checkboxState.state,o=m.checkboxState.tooltip),{isChecked:p===C.TreeItemCheckboxState.Checked,tooltip:o}}db(m){if(!C.TreeItem.isTreeItem(m,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(m,p,o){this.db(p);const i=new k.DisposableStore,l=this.gb(m,p,o),u=this.hb(p);return{item:{handle:l,parentHandle:o?o.item.handle:void 0,label:b(p.label,this.H),description:p.description,resourceUri:p.resourceUri,tooltip:this.ab(p.tooltip),command:this.bb(i,p.command),contextValue:p.contextValue,icon:u,iconDark:this.ib(p)||u,themeIcon:this.fb(p),collapsibleState:(0,R.isUndefinedOrNull)(p.collapsibleState)?C.TreeItemCollapsibleState.None:p.collapsibleState,accessibilityInformation:p.accessibilityInformation,checkbox:this.cb(p)},extensionItem:p,parent:o,children:void 0,disposableStore:i,dispose(){i.dispose()}}}fb(m){return m.iconPath instanceof C.ThemeIcon?m.iconPath:void 0}gb(m,{id:p,label:o,resourceUri:i},l,u){if(p)return`${w.b}/${p}`;const s=b(o,this.H),c=l?l.item.handle:w.a;let n=s?s.label:i?(0,I.basename)(i):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const r=this.j.has(m)?this.j.get(m).item.handle:void 0,g=this.Q(l)||[];let P,L=0;do{if(P=`${c}/${L}:${n}`,u||!this.i.has(P)||r===P)break;L++}while(L<=g.length);return P}hb(m){if(m.iconPath&&!(m.iconPath instanceof C.ThemeIcon))return typeof m.iconPath=="string"||A.URI.isUri(m.iconPath)?this.jb(m.iconPath):this.jb(m.iconPath.light)}ib(m){if(m.iconPath&&!(m.iconPath instanceof C.ThemeIcon)&&m.iconPath.dark)return this.jb(m.iconPath.dark)}jb(m){return A.URI.isUri(m)?m:A.URI.file(m)}kb(m,p){this.i.set(p.item.handle,m),this.j.set(m,p)}lb(m,p,o,i){this.i.delete(p.item.handle),this.j.delete(m),p.item.handle!==o.item.handle&&this.i.delete(o.item.handle),this.kb(m,p);const l=this.Q(i)||[],u=l.filter(s=>s.item.handle===o.item.handle)[0];u&&l.splice(l.indexOf(u),1,p)}mb(m,p){p?(p.children||(p.children=[]),p.children.push(m)):(this.h||(this.h=[]),this.h.push(m))}nb(m){if(m){const p=this.j.get(m);if(p){if(p.children)for(const o of p.children){const i=this.i.get(o.item.handle);i&&this.ob(i)}p.children=void 0}}else this.pb()}ob(m){const p=this.j.get(m);if(p){if(p.children)for(const o of p.children){const i=this.i.get(o.item.handle);i&&this.ob(i)}this.j.delete(m),this.i.delete(p.item.handle),p.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(m=>m.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}w.a="0",w.b="1"}),define(Se[301],ye([1,0,21,10,4,42,2,119,105,152,161,38,5,93,244,243,39,245,34,247,248,249,232,250,58,41,251,252,255,256,257,142,235,262,263,264,97,40,266,300,14,7,128,269,73,141,33,223,254,67,139,75,77,78,13,55,16,25,258,231,54,70,241,267,72,71,272,270,271,242,47,265,268,96,59,94,259,74,260,15,123,234,212,253,6,26,216,95,209,261]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v,d,b,f,w,h,m,p,o,i,l,u,s,c,n,r,g,P,L,z,_,K,F,M,N,B,U,W,x,V,X,Q,J,te,le,Z,ge,ve,De,Re,ze,se,ue,he,ee,oe,ie,O,H,q,Y,de,be,Pe,pe,Ce,ke,je,Ge,et,_e,nt,st,ht,Fe,it,ae,$,ce,Ie,Le,Be,xe,Ze,mt,ft){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function lt(ot){const rt=ot.get(he.IExtHostInitDataService),At=ot.get(ke.IExtHostFileSystemInfo),Rt=ot.get(de.IExtHostConsumerFileSystem),Ft=ot.get(u.IExtHostExtensionService),pt=ot.get(J.IExtHostWorkspace),kt=ot.get(nt.IExtHostTelemetry),Bt=ot.get(w.IExtHostConfiguration),Mt=ot.get(se.IURITransformerService),Xe=ot.get(ue.IExtHostRpcService),Ot=ot.get(F.IExtHostStorage),Ut=ot.get(Y.IExtensionStoragePaths),Ht=ot.get(ze.ILoggerService),bt=ot.get(ze.ILogService),Lt=ot.get(ie.IExtHostTunnelService),Ae=ot.get(O.IExtHostApiDeprecationService),Oe=ot.get(Q.IExtHostWindow),Ee=ot.get(et.IExtHostSecretState),re=ot.get(_e.IExtHostEditorTabs);Xe.set(E.ExtHostContext.ExtHostFileSystemInfo,At),Xe.set(E.ExtHostContext.ExtHostLogLevelServiceShape,Ht),Xe.set(E.ExtHostContext.ExtHostWorkspace,pt),Xe.set(E.ExtHostContext.ExtHostConfiguration,Bt),Xe.set(E.ExtHostContext.ExtHostExtensionService,Ft),Xe.set(E.ExtHostContext.ExtHostStorage,Ot),Xe.set(E.ExtHostContext.ExtHostTunnelService,Lt),Xe.set(E.ExtHostContext.ExtHostWindow,Oe),Xe.set(E.ExtHostContext.ExtHostSecretState,Ee),Xe.set(E.ExtHostContext.ExtHostTelemetry,kt),Xe.set(E.ExtHostContext.ExtHostEditorTabs,re);const Ne=Xe.set(E.ExtHostContext.ExtHostDecorations,ot.get(ge.IExtHostDecorations)),$e=Xe.set(E.ExtHostContext.ExtHostDocumentsAndEditors,ot.get(l.IExtHostDocumentsAndEditors)),Qe=Xe.set(E.ExtHostContext.ExtHostCommands,ot.get(b.IExtHostCommands)),Ve=Xe.set(E.ExtHostContext.ExtHostTerminalService,ot.get(M.IExtHostTerminalService)),tt=Xe.set(E.ExtHostContext.ExtHostDebugService,ot.get(De.IExtHostDebugService)),It=Xe.set(E.ExtHostContext.ExtHostSearch,ot.get(Re.IExtHostSearch)),Et=Xe.set(E.ExtHostContext.ExtHostTask,ot.get(ve.IExtHostTask)),Tt=Xe.set(E.ExtHostContext.ExtHostOutputService,ot.get(P.IExtHostOutputService)),wt=Xe.set(E.ExtHostContext.ExtHostLocalization,ot.get(Ze.IExtHostLocalizationService)),vt=Xe.set(E.ExtHostContext.ExtHostUrls,new V.ExtHostUrls(Xe)),yt=Xe.set(E.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(Xe,$e)),zt=Xe.set(E.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(Xe,$e,bt)),Xt=Xe.set(E.ExtHostContext.ExtHostDocumentSaveParticipant,new o.ExtHostDocumentSaveParticipant(bt,yt,Xe.getProxy(E.MainContext.MainThreadBulkEdits))),St=Xe.set(E.ExtHostContext.ExtHostNotebook,new ee.ExtHostNotebookController(Xe,Qe,$e,yt)),on=Xe.set(E.ExtHostContext.ExtHostNotebookDocuments,new ce.ExtHostNotebookDocuments(St)),an=Xe.set(E.ExtHostContext.ExtHostNotebookEditors,new $.ExtHostNotebookEditors(bt,St)),Zt=Xe.set(E.ExtHostContext.ExtHostNotebookKernels,new st.ExtHostNotebookKernels(Xe,rt,St,Qe,bt)),bn=Xe.set(E.ExtHostContext.ExtHostNotebookRenderers,new Fe.ExtHostNotebookRenderers(Xe,St)),Ct=Xe.set(E.ExtHostContext.ExtHostEditors,new N.ExtHostEditors(Xe,$e)),cn=Xe.set(E.ExtHostContext.ExtHostTreeViews,new B.ExtHostTreeViews(Xe.getProxy(E.MainContext.MainThreadTreeViews),Qe,bt)),On=Xe.set(E.ExtHostContext.ExtHostEditorInsets,new te.ExtHostEditorInsets(Xe.getProxy(E.MainContext.MainThreadEditorInsets),Ct,rt.remote)),en=Xe.set(E.ExtHostContext.ExtHostDiagnostics,new h.ExtHostDiagnostics(Xe,bt,At,$e)),jt=Xe.set(E.ExtHostContext.ExtHostLanguages,new r.ExtHostLanguages(Xe,yt,Qe.converter,Mt)),ut=Xe.set(E.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Xe,Mt,yt,Qe,en,bt,Ae,kt)),wn=Xe.set(E.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(Xe,ut)),Vt=Xe.set(E.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(Xe,bt,$e)),_t=Xe.set(E.ExtHostContext.ExtHostQuickOpen,(0,z.createExtHostQuickOpen)(Xe,pt,Qe)),ln=Xe.set(E.ExtHostContext.ExtHostSCM,new _.ExtHostSCM(Xe,Qe,bt)),vn=Xe.set(E.ExtHostContext.ExtHostComments,(0,f.createExtHostComments)(Xe,Qe,yt)),un=Xe.set(E.ExtHostContext.ExtHostProgress,new L.ExtHostProgress(Xe.getProxy(E.MainContext.MainThreadProgress))),En=Xe.set(E.ExtHostContext.ExtHosLabelService,new le.ExtHostLabelService(Xe)),kn=Xe.set(E.ExtHostContext.ExtHostTheming,new oe.ExtHostTheming(Xe)),tn=Xe.set(E.ExtHostContext.ExtHostAuthentication,new H.ExtHostAuthentication(Xe)),Sn=Xe.set(E.ExtHostContext.ExtHostTimeline,new q.ExtHostTimeline(Xe,Qe)),rn=Xe.set(E.ExtHostContext.ExtHostWebviews,new X.ExtHostWebviews(Xe,rt.remote,pt,bt,Ae)),sn=Xe.set(E.ExtHostContext.ExtHostWebviewPanels,new pe.ExtHostWebviewPanels(Xe,rn,pt)),Nn=Xe.set(E.ExtHostContext.ExtHostCustomEditors,new Pe.ExtHostCustomEditors(Xe,yt,Ut,rn,sn)),yn=Xe.set(E.ExtHostContext.ExtHostWebviewViews,new be.ExtHostWebviewViews(Xe,rn)),Qt=Xe.set(E.ExtHostContext.ExtHostTesting,new je.ExtHostTesting(Xe,Qe,$e)),Fn=Xe.set(E.ExtHostContext.ExtHostUriOpeners,new Ge.ExtHostUriOpeners(Xe)),Mn=Xe.set(E.ExtHostContext.ExtHostProfileContentHandlers,new ft.ExtHostProfileContentHandlers(Xe));Xe.set(E.ExtHostContext.ExtHostInteractive,new Ie.ExtHostInteractive(Xe,St,$e,Qe,bt));const Un=Object.values(E.ExtHostContext);Xe.assertRegistered(Un);const Bn=new Ce.ExtHostBulkEdits(Xe,$e),zn=new d.ExtHostClipboard(Xe),Cn=new g.ExtHostMessageService(Xe,bt),dn=new m.ExtHostDialogs(Xe),hn=new K.ExtHostStatusBar(Xe,Qe.converter);return v.ExtHostApiCommands.register(Qe),function(He,Gt,Tn){const gt=function(){let me=!He.isUnderDevelopment;function we(){me||(bt.info(`Extension '${He.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),me=!0)}return function Ue(at){if(Array.isArray(at))at.forEach(Ue);else if(typeof at=="string")we();else{const Dt=at;typeof Dt.scheme>"u"&&we(),typeof Dt.exclusive=="boolean"&&(0,Be.checkProposedApiEnabled)(He,"documentFiltersExclusive")}return at}}(),$n={getSession(me,we,Ue){return tn.getSession(He,me,we,Ue)},async hasSession(me,we){return(0,Be.checkProposedApiEnabled)(He,"authSession"),!!await tn.getSession(He,me,we,{silent:!0})},get onDidChangeSessions(){return tn.onDidChangeSessions},registerAuthenticationProvider(me,we,Ue,at){return tn.registerAuthenticationProvider(me,we,Ue,at)}},Wn={registerCommand(me,we,Ue){return Qe.registerCommand(!0,me,we,Ue,void 0,He)},registerTextEditorCommand(me,we,Ue){return Qe.registerCommand(!0,me,(...at)=>{const Dt=Ct.getActiveTextEditor();if(!Dt){bt.warn("Cannot execute "+me+" because there is no active text editor.");return}return Dt.edit(Pt=>{we.apply(Ue,[Dt,Pt,...at])}).then(Pt=>{Pt||bt.warn("Edits from command "+me+" were not applied.")},Pt=>{bt.warn("An error occurred while running command "+me,Pt)})},void 0,void 0,He)},registerDiffInformationCommand:(me,we,Ue)=>((0,Be.checkProposedApiEnabled)(He,"diffCommand"),Qe.registerCommand(!0,me,async(...at)=>{const Dt=$e.activeEditor(!0);if(!Dt){bt.warn("Cannot execute "+me+" because there is no active text editor.");return}const Pt=await Ct.getDiffInformation(Dt.id);we.apply(Ue,[Pt,...at])},void 0,void 0,He)),executeCommand(me,...we){return Qe.executeCommand(me,...we)},getCommands(me=!1){return Qe.getCommands(me)}},Pn={get machineId(){return rt.telemetryInfo.machineId},get sessionId(){return rt.telemetryInfo.sessionId},get language(){return rt.environment.appLanguage},get appName(){return rt.environment.appName},get appRoot(){return rt.environment.appRoot?.fsPath??""},get appHost(){return rt.environment.appHost},get uriScheme(){return rt.environment.appUriScheme},get clipboard(){return zn.value},get shell(){return Ve.getDefaultShell(!1)},get onDidChangeShell(){return(0,Be.checkProposedApiEnabled)(He,"envShellEvent"),Ve.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Be.checkProposedApiEnabled)(He,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Be.checkProposedApiEnabled)(He,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,nt.isNewAppInstall)(rt.telemetryInfo.firstSessionDate)},createTelemetryLogger(me){return(0,Be.checkProposedApiEnabled)(He,"telemetryLogger"),kt.instantiateLogger(He,me)},openExternal(me,we){return Oe.openUri(me,{allowTunneling:!!rt.remote.authority,allowContributedOpeners:we?.allowContributedOpeners})},async asExternalUri(me){if(me.scheme===rt.environment.appUriScheme)return vt.createAppUri(me);try{return await Oe.asExternalUri(me,{allowTunneling:!!rt.remote.authority})}catch(we){if((0,ae.matchesScheme)(me,it.Schemas.http)||(0,ae.matchesScheme)(me,it.Schemas.https))return me;throw we}},get remoteName(){return(0,Z.getRemoteName)(rt.remote.authority)},get remoteAuthority(){return(0,Be.checkProposedApiEnabled)(He,"resolvers"),rt.remote.authority},get uiKind(){return rt.uiKind},get logLevel(){return bt.getLevel()},get onDidChangeLogLevel(){return bt.onDidChangeLogLevel}};rt.environment.extensionTestsLocationURI||Object.freeze(Pn);const Hn={createTestController(me,we,Ue){return Qt.createTestController(me,we,Ue)},createTestObserver(){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Qt.createTestObserver()},runTests(me){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Qt.runTests(me)},get onDidChangeTestResults(){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Qt.onResultsChanged},get testResults(){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Qt.results}},nn=rt.remote.isRemote?W.ExtensionKind.Workspace:W.ExtensionKind.UI,jn={getExtension(me,we){(0,Be.isProposedApiEnabled)(He,"extensionsAny")||(we=!1);const Ue=Gt.mine.getExtensionDescription(me);if(Ue)return new u.Extension(Ft,He.identifier,Ue,nn,!1);if(we){const at=Gt.all.getExtensionDescription(me);if(at)return new u.Extension(Ft,He.identifier,at,nn,!0)}},get all(){const me=[];for(const we of Gt.mine.getAllExtensionDescriptions())me.push(new u.Extension(Ft,He.identifier,we,nn,!1));return me},get allAcrossExtensionHosts(){(0,Be.checkProposedApiEnabled)(He,"extensionsAny");const me=new Be.ExtensionIdentifierSet(Gt.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),we=[];for(const Ue of Gt.all.getAllExtensionDescriptions()){const at=!me.has(Ue.identifier);we.push(new u.Extension(Ft,He.identifier,Ue,nn,at))}return we},get onDidChange(){return(0,Be.isProposedApiEnabled)(He,"extensionsAny")?I.Event.any(Gt.mine.onDidChange,Gt.all.onDidChange):Gt.mine.onDidChange}},Kt={createDiagnosticCollection(me){return en.createDiagnosticCollection(He.identifier,me)},get onDidChangeDiagnostics(){return en.onDidChangeDiagnostics},getDiagnostics:me=>en.getDiagnostics(me),getLanguages(){return jt.getLanguages()},setTextDocumentLanguage(me,we){return jt.changeLanguage(me.uri,we)},match(me,we){const Ue=yt.getDocumentData(we.uri)?.notebook;return(0,R.score)(U.LanguageSelector.from(me),we.uri,we.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider(me,we,Ue){return ut.registerCodeActionProvider(He,gt(me),we,Ue)},registerDocumentPasteEditProvider(me,we,Ue){return(0,Be.checkProposedApiEnabled)(He,"documentPaste"),ut.registerDocumentPasteEditProvider(He,gt(me),we,Ue)},registerCodeLensProvider(me,we){return ut.registerCodeLensProvider(He,gt(me),we)},registerDefinitionProvider(me,we){return ut.registerDefinitionProvider(He,gt(me),we)},registerDeclarationProvider(me,we){return ut.registerDeclarationProvider(He,gt(me),we)},registerImplementationProvider(me,we){return ut.registerImplementationProvider(He,gt(me),we)},registerTypeDefinitionProvider(me,we){return ut.registerTypeDefinitionProvider(He,gt(me),we)},registerHoverProvider(me,we){return ut.registerHoverProvider(He,gt(me),we,He.identifier)},registerEvaluatableExpressionProvider(me,we){return ut.registerEvaluatableExpressionProvider(He,gt(me),we,He.identifier)},registerInlineValuesProvider(me,we){return ut.registerInlineValuesProvider(He,gt(me),we,He.identifier)},registerDocumentHighlightProvider(me,we){return ut.registerDocumentHighlightProvider(He,gt(me),we)},registerLinkedEditingRangeProvider(me,we){return ut.registerLinkedEditingRangeProvider(He,gt(me),we)},registerReferenceProvider(me,we){return ut.registerReferenceProvider(He,gt(me),we)},registerRenameProvider(me,we){return ut.registerRenameProvider(He,gt(me),we)},registerDocumentSymbolProvider(me,we,Ue){return ut.registerDocumentSymbolProvider(He,gt(me),we,Ue)},registerWorkspaceSymbolProvider(me){return ut.registerWorkspaceSymbolProvider(He,me)},registerDocumentFormattingEditProvider(me,we){return ut.registerDocumentFormattingEditProvider(He,gt(me),we)},registerDocumentRangeFormattingEditProvider(me,we){return ut.registerDocumentRangeFormattingEditProvider(He,gt(me),we)},registerOnTypeFormattingEditProvider(me,we,Ue,...at){return ut.registerOnTypeFormattingEditProvider(He,gt(me),we,[Ue].concat(at))},registerDocumentSemanticTokensProvider(me,we,Ue){return ut.registerDocumentSemanticTokensProvider(He,gt(me),we,Ue)},registerDocumentRangeSemanticTokensProvider(me,we,Ue){return ut.registerDocumentRangeSemanticTokensProvider(He,gt(me),we,Ue)},registerSignatureHelpProvider(me,we,Ue,...at){return typeof Ue=="object"?ut.registerSignatureHelpProvider(He,gt(me),we,Ue):ut.registerSignatureHelpProvider(He,gt(me),we,typeof Ue>"u"?[]:[Ue,...at])},registerCompletionItemProvider(me,we,...Ue){return ut.registerCompletionItemProvider(He,gt(me),we,Ue)},registerInlineCompletionItemProvider(me,we){return we.handleDidShowCompletionItem&&(0,Be.checkProposedApiEnabled)(He,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(He,gt(me),we)},registerDocumentLinkProvider(me,we){return ut.registerDocumentLinkProvider(He,gt(me),we)},registerColorProvider(me,we){return ut.registerColorProvider(He,gt(me),we)},registerFoldingRangeProvider(me,we){return ut.registerFoldingRangeProvider(He,gt(me),we)},registerSelectionRangeProvider(me,we){return ut.registerSelectionRangeProvider(He,me,we)},registerCallHierarchyProvider(me,we){return ut.registerCallHierarchyProvider(He,me,we)},registerTypeHierarchyProvider(me,we){return ut.registerTypeHierarchyProvider(He,me,we)},setLanguageConfiguration:(me,we)=>ut.setLanguageConfiguration(He,me,we),getTokenInformationAtPosition(me,we){return(0,Be.checkProposedApiEnabled)(He,"tokenInformation"),jt.tokenAtPosition(me,we)},registerInlayHintsProvider(me,we){return ut.registerInlayHintsProvider(He,me,we)},createLanguageStatusItem(me,we){return jt.createLanguageStatusItem(He,me,we)},registerDocumentDropEditProvider(me,we){return ut.registerDocumentOnDropEditProvider(He,me,we)}},fn={get activeTextEditor(){return Ct.getActiveTextEditor()},get visibleTextEditors(){return Ct.getVisibleTextEditors()},get activeTerminal(){return Ve.activeTerminal},get terminals(){return Ve.terminals},async showTextDocument(me,we,Ue){const at=await(D.URI.isUri(me)?Promise.resolve(An.openTextDocument(me)):Promise.resolve(me));return Ct.showTextDocument(at,we,Ue)},createTextEditorDecorationType(me){return Ct.createTextEditorDecorationType(He,me)},onDidChangeActiveTextEditor(me,we,Ue){return Ct.onDidChangeActiveTextEditor(me,we,Ue)},onDidChangeVisibleTextEditors(me,we,Ue){return Ct.onDidChangeVisibleTextEditors(me,we,Ue)},onDidChangeTextEditorSelection(me,we,Ue){return Ct.onDidChangeTextEditorSelection(me,we,Ue)},onDidChangeTextEditorOptions(me,we,Ue){return Ct.onDidChangeTextEditorOptions(me,we,Ue)},onDidChangeTextEditorVisibleRanges(me,we,Ue){return Ct.onDidChangeTextEditorVisibleRanges(me,we,Ue)},onDidChangeTextEditorViewColumn(me,we,Ue){return Ct.onDidChangeTextEditorViewColumn(me,we,Ue)},onDidCloseTerminal(me,we,Ue){return Ve.onDidCloseTerminal(me,we,Ue)},onDidOpenTerminal(me,we,Ue){return Ve.onDidOpenTerminal(me,we,Ue)},onDidChangeActiveTerminal(me,we,Ue){return Ve.onDidChangeActiveTerminal(me,we,Ue)},onDidChangeTerminalDimensions(me,we,Ue){return(0,Be.checkProposedApiEnabled)(He,"terminalDimensions"),Ve.onDidChangeTerminalDimensions(me,we,Ue)},onDidChangeTerminalState(me,we,Ue){return Ve.onDidChangeTerminalState(me,we,Ue)},onDidWriteTerminalData(me,we,Ue){return(0,Be.checkProposedApiEnabled)(He,"terminalDataWriteEvent"),Ve.onDidWriteTerminalData(me,we,Ue)},get state(){return Oe.state},onDidChangeWindowState(me,we,Ue){return Oe.onDidChangeWindowState(me,we,Ue)},showInformationMessage(me,...we){return Cn.showMessage(He,A.default.Info,me,we[0],we.slice(1))},showWarningMessage(me,...we){return Cn.showMessage(He,A.default.Warning,me,we[0],we.slice(1))},showErrorMessage(me,...we){return Cn.showMessage(He,A.default.Error,me,we[0],we.slice(1))},showQuickPick(me,we,Ue){return _t.showQuickPick(me,we,Ue)},showWorkspaceFolderPick(me){return _t.showWorkspaceFolderPick(me)},showInputBox(me,we){return _t.showInput(me,we)},showOpenDialog(me){return dn.showOpenDialog(me)},showSaveDialog(me){return dn.showSaveDialog(me)},createStatusBarItem(me,we,Ue){let at,Dt,Pt;return typeof me=="string"?(at=me,Dt=we,Pt=Ue):(Dt=me,Pt=we),hn.createStatusBarEntry(He,at,Dt,Pt)},setStatusBarMessage(me,we){return hn.setStatusBarMessage(me,we)},withScmProgress(me){return Ae.report("window.withScmProgress",He,"Use 'withProgress' instead."),un.withProgress(He,{location:W.ProgressLocation.SourceControl},(we,Ue)=>me({report(at){}}))},withProgress(me,we){return un.withProgress(He,me,we)},createOutputChannel(me,we){return Tt.createOutputChannel(me,we,He)},createWebviewPanel(me,we,Ue,at){return sn.createWebviewPanel(He,me,we,Ue,at)},createWebviewTextEditorInset(me,we,Ue,at){return(0,Be.checkProposedApiEnabled)(He,"editorInsets"),On.createWebviewEditorInset(me,we,Ue,at,He)},createTerminal(me,we,Ue){return typeof me=="object"?"pty"in me?Ve.createExtensionTerminal(me):Ve.createTerminalFromOptions(me):Ve.createTerminal(me,we,Ue)},registerTerminalLinkProvider(me){return Ve.registerLinkProvider(me)},registerTerminalProfileProvider(me,we){return Ve.registerProfileProvider(He,me,we)},registerTerminalQuickFixProvider(me,we){return(0,Be.checkProposedApiEnabled)(He,"terminalQuickFixProvider"),Ve.registerTerminalQuickFixProvider(me,He.identifier.value,we)},registerTreeDataProvider(me,we){return cn.registerTreeDataProvider(me,we,He)},createTreeView(me,we){return cn.createTreeView(me,we,He)},registerWebviewPanelSerializer:(me,we)=>sn.registerWebviewPanelSerializer(He,me,we),registerCustomEditorProvider:(me,we,Ue={})=>Nn.registerCustomEditorProvider(He,me,we,Ue),registerFileDecorationProvider(me){return Ne.registerFileDecorationProvider(me,He)},registerUriHandler(me){return vt.registerUriHandler(He.identifier,me)},createQuickPick(){return _t.createQuickPick(He)},createInputBox(){return _t.createInputBox(He)},get activeColorTheme(){return kn.activeColorTheme},onDidChangeActiveColorTheme(me,we,Ue){return kn.onDidChangeActiveColorTheme(me,we,Ue)},registerWebviewViewProvider(me,we,Ue){return yn.registerWebviewViewProvider(He,me,we,Ue?.webviewOptions)},get activeNotebookEditor(){return St.activeNotebookEditor},onDidChangeActiveNotebookEditor(me,we,Ue){return St.onDidChangeActiveNotebookEditor(me,we,Ue)},get visibleNotebookEditors(){return St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(me,we,Ue){return an.onDidChangeNotebookEditorSelection(me,we,Ue)},onDidChangeNotebookEditorVisibleRanges(me,we,Ue){return an.onDidChangeNotebookEditorVisibleRanges(me,we,Ue)},showNotebookDocument(me,we){return St.showNotebookDocument(me,we)},registerExternalUriOpener(me,we,Ue){return(0,Be.checkProposedApiEnabled)(He,"externalUriOpener"),Fn.registerExternalUriOpener(He.identifier,me,we,Ue)},registerProfileContentHandler(me,we){return(0,Be.checkProposedApiEnabled)(He,"profileContentHandlers"),Mn.registrProfileContentHandler(He,me,we)},get tabGroups(){return re.tabGroups}},An={get rootPath(){return Ae.report("workspace.rootPath",He,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),pt.getPath()},set rootPath(me){throw t.readonly()},getWorkspaceFolder(me){return pt.getWorkspaceFolder(me)},get workspaceFolders(){return pt.getWorkspaceFolders()},get name(){return pt.name},set name(me){throw t.readonly()},get workspaceFile(){return pt.workspaceFile},set workspaceFile(me){throw t.readonly()},updateWorkspaceFolders:(me,we,...Ue)=>pt.updateWorkspaceFolders(He,me,we||0,...Ue),onDidChangeWorkspaceFolders:function(me,we,Ue){return pt.onDidChangeWorkspace(me,we,Ue)},asRelativePath:(me,we)=>pt.getRelativePath(me,we),findFiles:(me,we,Ue,at)=>pt.findFiles(me,we,Ue,He.identifier,at),findTextInFiles:(me,we,Ue,at)=>{(0,Be.checkProposedApiEnabled)(He,"findTextInFiles");let Dt,Pt;return typeof we=="object"?(Dt=we,Pt=Ue):(Dt={},Pt=we,at=Ue),pt.findTextInFiles(me,Dt||{},Pt,He.identifier,at)},saveAll:me=>pt.saveAll(me),applyEdit(me,we){return Bn.applyWorkspaceEdit(me,He,we)},createFileSystemWatcher:(me,we,Ue,at)=>Vt.createFileSystemWatcher(pt,He,me,we,Ue,at),get textDocuments(){return yt.getAllDocumentData().map(me=>me.document)},set textDocuments(me){throw t.readonly()},openTextDocument(me){let we;const Ue=me;if(typeof me=="string")we=Promise.resolve(D.URI.file(me));else if(D.URI.isUri(me))we=Promise.resolve(me);else if(!Ue||typeof Ue=="object")we=yt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return we.then(at=>yt.ensureDocumentData(at).then(Dt=>Dt.document))},onDidOpenTextDocument:(me,we,Ue)=>yt.onDidAddDocument(me,we,Ue),onDidCloseTextDocument:(me,we,Ue)=>yt.onDidRemoveDocument(me,we,Ue),onDidChangeTextDocument:(me,we,Ue)=>yt.onDidChangeDocument(me,we,Ue),onDidSaveTextDocument:(me,we,Ue)=>yt.onDidSaveDocument(me,we,Ue),onWillSaveTextDocument:(me,we,Ue)=>Xt.getOnWillSaveTextDocumentEvent(He)(me,we,Ue),get notebookDocuments(){return St.notebookDocuments.map(me=>me.apiNotebook)},async openNotebookDocument(me,we){let Ue;if(D.URI.isUri(me))Ue=me,await St.openNotebookDocument(me);else if(typeof me=="string")Ue=D.URI.revive(await St.createNotebookDocument({viewType:me,content:we}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(me,we,Ue){return on.onDidSaveNotebookDocument(me,we,Ue)},onDidChangeNotebookDocument(me,we,Ue){return on.onDidChangeNotebookDocument(me,we,Ue)},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(me,we,Ue,at){return St.registerNotebookSerializer(He,me,we,Ue,(0,Be.isProposedApiEnabled)(He,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(me,we,Ue)=>Tn.onDidChangeConfiguration(me,we,Ue),getConfiguration(me,we){return we=arguments.length===1?void 0:we,Tn.getConfiguration(me,we,He)},registerTextDocumentContentProvider(me,we){return zt.registerTextDocumentContentProvider(me,we)},registerTaskProvider:(me,we)=>(Ae.report("window.registerTaskProvider",He,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(He,me,we)),registerFileSystemProvider(me,we,Ue){return(0,Le.combinedDisposable)(wn.registerFileSystemProvider(He,me,we,Ue),Rt.addFileSystemProvider(me,we))},get fs(){return Rt.value},registerFileSearchProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(He,"fileSearchProvider"),It.registerFileSearchProvider(me,we)),registerTextSearchProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(He,"textSearchProvider"),It.registerTextSearchProvider(me,we)),registerRemoteAuthorityResolver:(me,we)=>((0,Be.checkProposedApiEnabled)(He,"resolvers"),Ft.registerRemoteAuthorityResolver(me,we)),registerResourceLabelFormatter:me=>((0,Be.checkProposedApiEnabled)(He,"resolvers"),En.$registerResourceLabelFormatter(me)),onDidCreateFiles:(me,we,Ue)=>Vt.onDidCreateFile(me,we,Ue),onDidDeleteFiles:(me,we,Ue)=>Vt.onDidDeleteFile(me,we,Ue),onDidRenameFiles:(me,we,Ue)=>Vt.onDidRenameFile(me,we,Ue),onWillCreateFiles:(me,we,Ue)=>Vt.getOnWillCreateFileEvent(He)(me,we,Ue),onWillDeleteFiles:(me,we,Ue)=>Vt.getOnWillDeleteFileEvent(He)(me,we,Ue),onWillRenameFiles:(me,we,Ue)=>Vt.getOnWillRenameFileEvent(He)(me,we,Ue),openTunnel:me=>((0,Be.checkProposedApiEnabled)(He,"tunnels"),Lt.openTunnel(He,me).then(we=>{if(!we)throw new Error("cannot open tunnel");return we})),get tunnels(){return(0,Be.checkProposedApiEnabled)(He,"tunnels"),Lt.getTunnels()},onDidChangeTunnels:(me,we,Ue)=>((0,Be.checkProposedApiEnabled)(He,"tunnels"),Lt.onDidChangeTunnels(me,we,Ue)),registerPortAttributesProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(He,"portsAttributes"),Lt.registerPortsAttributesProvider(me,we)),registerTimelineProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(He,"timeline"),Sn.registerTimelineProvider(me,we,He.identifier,Qe.converter)),get isTrusted(){return pt.trusted},requestWorkspaceTrust:me=>((0,Be.checkProposedApiEnabled)(He,"workspaceTrust"),pt.requestWorkspaceTrust(me)),onDidGrantWorkspaceTrust:(me,we,Ue)=>pt.onDidGrantWorkspaceTrust(me,we,Ue),registerEditSessionIdentityProvider:(me,we)=>((0,Be.checkProposedApiEnabled)(He,"editSessionIdentityProvider"),pt.registerEditSessionIdentityProvider(me,we))},$t={get inputBox(){return Ae.report("scm.inputBox",He,"Use 'SourceControl.inputBox' instead"),ln.getLastInputBox(He)},createSourceControl(me,we,Ue){return ln.createSourceControl(He,me,we,Ue)}},mn={createCommentController(me,we){return vn.createCommentController(He,me,we)}},Vn={get activeDebugSession(){return tt.activeDebugSession},get activeDebugConsole(){return tt.activeDebugConsole},get breakpoints(){return tt.breakpoints},onDidStartDebugSession(me,we,Ue){return tt.onDidStartDebugSession(me,we,Ue)},onDidTerminateDebugSession(me,we,Ue){return tt.onDidTerminateDebugSession(me,we,Ue)},onDidChangeActiveDebugSession(me,we,Ue){return tt.onDidChangeActiveDebugSession(me,we,Ue)},onDidReceiveDebugSessionCustomEvent(me,we,Ue){return tt.onDidReceiveDebugSessionCustomEvent(me,we,Ue)},onDidChangeBreakpoints(me,we,Ue){return tt.onDidChangeBreakpoints(me,we,Ue)},registerDebugConfigurationProvider(me,we,Ue){return tt.registerDebugConfigurationProvider(me,we,Ue||xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(me,we){return tt.registerDebugAdapterDescriptorFactory(He,me,we)},registerDebugAdapterTrackerFactory(me,we){return tt.registerDebugAdapterTrackerFactory(me,we)},startDebugging(me,we,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?tt.startDebugging(me,we,{parentSession:Ue}):tt.startDebugging(me,we,Ue||{})},stopDebugging(me){return tt.stopDebugging(me)},addBreakpoints(me){return tt.addBreakpoints(me)},removeBreakpoints(me){return tt.removeBreakpoints(me)},asDebugSourceUri(me,we){return tt.asDebugSourceUri(me,we)}},qn={registerTaskProvider:(me,we)=>Et.registerTaskProvider(He,me,we),fetchTasks:me=>Et.fetchTasks(me),executeTask:me=>Et.executeTask(He,me),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(me,we,Ue)=>Et.onDidStartTask(me,we,Ue),onDidEndTask:(me,we,Ue)=>Et.onDidEndTask(me,we,Ue),onDidStartTaskProcess:(me,we,Ue)=>Et.onDidStartTaskProcess(me,we,Ue),onDidEndTaskProcess:(me,we,Ue)=>Et.onDidEndTaskProcess(me,we,Ue)},Gn={createNotebookController(me,we,Ue,at,Dt){return Zt.createNotebookController(He,me,we,Ue,at,(0,Be.isProposedApiEnabled)(He,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(me,we)=>St.registerNotebookCellStatusBarItemProvider(He,me,we),createRendererMessaging(me){return bn.createRendererMessaging(He,me)},createNotebookControllerDetectionTask(me){return(0,Be.checkProposedApiEnabled)(He,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(He,me)},registerKernelSourceActionProvider(me,we){return(0,Be.checkProposedApiEnabled)(He,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(He,me,we)},onDidChangeNotebookCellExecutionState(me,we,Ue){return(0,Be.checkProposedApiEnabled)(He,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(me,we,Ue)}},Kn={t(...me){if(typeof me[0]=="string"){const we=me.shift(),Ue=!me||typeof me[0]!="object"?me:me[0];return wt.getMessage(He.identifier.value,{message:we,args:Ue})}return wt.getMessage(He.identifier.value,me[0])},get bundle(){return wt.getBundle(He.identifier.value)},get uri(){return wt.getBundleUri(He.identifier.value)}};return{version:rt.version,authentication:$n,commands:Wn,comments:mn,debug:Vn,env:Pn,extensions:jn,l10n:Kn,languages:Kt,notebooks:Gn,scm:$t,tasks:qn,tests:Hn,window:fn,workspace:An,Breakpoint:W.Breakpoint,TerminalOutputAnchor:W.TerminalOutputAnchor,CallHierarchyIncomingCall:W.CallHierarchyIncomingCall,CallHierarchyItem:W.CallHierarchyItem,CallHierarchyOutgoingCall:W.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:a.CancellationTokenSource,CandidatePortSource:E.CandidatePortSource,CodeAction:W.CodeAction,CodeActionKind:W.CodeActionKind,CodeActionTriggerKind:W.CodeActionTriggerKind,CodeLens:W.CodeLens,Color:W.Color,ColorInformation:W.ColorInformation,ColorPresentation:W.ColorPresentation,ColorThemeKind:W.ColorThemeKind,CommentMode:W.CommentMode,CommentThreadCollapsibleState:W.CommentThreadCollapsibleState,CommentThreadState:W.CommentThreadState,CompletionItem:W.CompletionItem,CompletionItemKind:W.CompletionItemKind,CompletionItemTag:W.CompletionItemTag,CompletionList:W.CompletionList,CompletionTriggerKind:W.CompletionTriggerKind,ConfigurationTarget:W.ConfigurationTarget,CustomExecution:W.CustomExecution,DebugAdapterExecutable:W.DebugAdapterExecutable,DebugAdapterInlineImplementation:W.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:W.DebugAdapterNamedPipeServer,DebugAdapterServer:W.DebugAdapterServer,DebugConfigurationProviderTriggerKind:xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:W.DebugConsoleMode,DecorationRangeBehavior:W.DecorationRangeBehavior,Diagnostic:W.Diagnostic,DiagnosticRelatedInformation:W.DiagnosticRelatedInformation,DiagnosticSeverity:W.DiagnosticSeverity,DiagnosticTag:W.DiagnosticTag,Disposable:W.Disposable,DocumentHighlight:W.DocumentHighlight,DocumentHighlightKind:W.DocumentHighlightKind,DocumentLink:W.DocumentLink,DocumentSymbol:W.DocumentSymbol,EndOfLine:W.EndOfLine,EnvironmentVariableMutatorType:W.EnvironmentVariableMutatorType,EvaluatableExpression:W.EvaluatableExpression,InlineValueText:W.InlineValueText,InlineValueVariableLookup:W.InlineValueVariableLookup,InlineValueEvaluatableExpression:W.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:W.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:W.ExtensionKind,ExtensionMode:W.ExtensionMode,ExternalUriOpenerPriority:W.ExternalUriOpenerPriority,FileChangeType:W.FileChangeType,FileDecoration:W.FileDecoration,FileDecoration2:W.FileDecoration,FileSystemError:W.FileSystemError,FileType:T.FileType,FilePermission:T.FilePermission,FoldingRange:W.FoldingRange,FoldingRangeKind:W.FoldingRangeKind,FunctionBreakpoint:W.FunctionBreakpoint,InlineCompletionItem:W.InlineSuggestion,InlineCompletionList:W.InlineSuggestionList,Hover:W.Hover,IndentAction:C.IndentAction,Location:W.Location,MarkdownString:W.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:W.ParameterInformation,PortAutoForwardAction:W.PortAutoForwardAction,Position:W.Position,ProcessExecution:W.ProcessExecution,ProgressLocation:W.ProgressLocation,QuickInputButtons:W.QuickInputButtons,Range:W.Range,RelativePattern:W.RelativePattern,Selection:W.Selection,SelectionRange:W.SelectionRange,SemanticTokens:W.SemanticTokens,SemanticTokensBuilder:W.SemanticTokensBuilder,SemanticTokensEdit:W.SemanticTokensEdit,SemanticTokensEdits:W.SemanticTokensEdits,SemanticTokensLegend:W.SemanticTokensLegend,ShellExecution:W.ShellExecution,ShellQuoting:W.ShellQuoting,SignatureHelp:W.SignatureHelp,SignatureHelpTriggerKind:W.SignatureHelpTriggerKind,SignatureInformation:W.SignatureInformation,SnippetString:W.SnippetString,SourceBreakpoint:W.SourceBreakpoint,StandardTokenType:W.StandardTokenType,StatusBarAlignment:W.StatusBarAlignment,SymbolInformation:W.SymbolInformation,SymbolKind:W.SymbolKind,SymbolTag:W.SymbolTag,Task:W.Task,TaskGroup:W.TaskGroup,TaskPanelKind:W.TaskPanelKind,TaskRevealKind:W.TaskRevealKind,TaskScope:W.TaskScope,TerminalLink:W.TerminalLink,TerminalLocation:W.TerminalLocation,TerminalProfile:W.TerminalProfile,TerminalExitReason:W.TerminalExitReason,TerminalQuickFixType:W.TerminalQuickFixType,TextDocumentSaveReason:W.TextDocumentSaveReason,TextEdit:W.TextEdit,SnippetTextEdit:W.SnippetTextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:W.TextEditorLineNumbersStyle,TextEditorRevealType:W.TextEditorRevealType,TextEditorSelectionChangeKind:W.TextEditorSelectionChangeKind,TextDocumentChangeReason:W.TextDocumentChangeReason,ThemeColor:W.ThemeColor,ThemeIcon:W.ThemeIcon,TreeItem:W.TreeItem,TreeItem2:W.TreeItem,TreeItemCheckboxState:W.TreeItemCheckboxState,TreeItemCollapsibleState:W.TreeItemCollapsibleState,TypeHierarchyItem:W.TypeHierarchyItem,UIKind:y.UIKind,Uri:D.URI,ViewColumn:W.ViewColumn,WorkspaceEdit:W.WorkspaceEdit,DocumentDropEdit:W.DocumentDropEdit,DocumentPasteEdit:W.DocumentPasteEdit,InlayHint:W.InlayHint,InlayHintLabelPart:W.InlayHintLabelPart,InlayHintKind:W.InlayHintKind,RemoteAuthorityResolverError:W.RemoteAuthorityResolverError,ResolvedAuthority:W.ResolvedAuthority,SourceControlInputBoxValidationType:W.SourceControlInputBoxValidationType,ExtensionRuntime:W.ExtensionRuntime,TimelineItem:W.TimelineItem,NotebookRange:W.NotebookRange,NotebookCellKind:W.NotebookCellKind,NotebookCellExecutionState:W.NotebookCellExecutionState,NotebookCellData:W.NotebookCellData,NotebookData:W.NotebookData,NotebookRendererScript:W.NotebookRendererScript,NotebookCellStatusBarAlignment:W.NotebookCellStatusBarAlignment,NotebookEditorRevealType:W.NotebookEditorRevealType,NotebookCellOutput:W.NotebookCellOutput,NotebookCellOutputItem:W.NotebookCellOutputItem,NotebookCellStatusBarItem:W.NotebookCellStatusBarItem,NotebookControllerAffinity:W.NotebookControllerAffinity,NotebookControllerAffinity2:W.NotebookControllerAffinity2,NotebookEdit:W.NotebookEdit,NotebookKernelSourceAction:W.NotebookKernelSourceAction,PortAttributes:W.PortAttributes,LinkedEditingRanges:W.LinkedEditingRanges,TestResultState:W.TestResultState,TestRunRequest:W.TestRunRequest,TestMessage:W.TestMessage,TestTag:W.TestTag,TestRunProfileKind:W.TestRunProfileKind,TextSearchCompleteMessageType:ht.TextSearchCompleteMessageType,DataTransfer:W.DataTransfer,DataTransferItem:W.DataTransferItem,CoveredCount:W.CoveredCount,FileCoverage:W.FileCoverage,StatementCoverage:W.StatementCoverage,BranchCoverage:W.BranchCoverage,FunctionCoverage:W.FunctionCoverage,WorkspaceTrustState:W.WorkspaceTrustState,LanguageStatusSeverity:W.LanguageStatusSeverity,QuickPickItemKind:W.QuickPickItemKind,InputBoxValidationSeverity:W.InputBoxValidationSeverity,TabInputText:W.TextTabInput,TabInputTextDiff:W.TextDiffTabInput,TabInputTextMerge:W.TextMergeTabInput,TabInputCustom:W.CustomEditorTabInput,TabInputNotebook:W.NotebookEditorTabInput,TabInputNotebookDiff:W.NotebookDiffEditorTabInput,TabInputWebview:W.WebviewEditorTabInput,TabInputTerminal:W.TerminalEditorTabInput,TabInputInteractiveWindow:W.InteractiveWindowInput,TrustedTelemetryValue:x.TrustedTelemetryValue,LogLevel:ze.LogLevel,EditSessionIdentityMatch:mt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=lt}),define(Se[302],ye([1,0,274,311,312,2,313]),function(ne,e,a,t,I,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(T,E,y,v,d,b){const f=b.environment.useHostProxy,w=typeof f=="boolean"?f:!b.remote.isRemote,h=(0,D.createProxyResolver)({resolveProxy:p=>T.resolveProxy(p),getHttpProxySetting:()=>E.getConfiguration("http").get("proxy"),log:(p,o,...i)=>{switch(p){case D.LogLevel.Trace:v.trace(o,...i);break;case D.LogLevel.Debug:v.debug(o,...i);break;case D.LogLevel.Info:v.info(o,...i);break;case D.LogLevel.Warning:v.warn(o,...i);break;case D.LogLevel.Error:v.error(o,...i);break;case D.LogLevel.Critical:v.error(o,...i);break;case D.LogLevel.Off:break;default:l(p,o,i);break}function l(u,s,...c){v.error("Unknown log level",u),v.error(s,...c)}},getLogLevel:()=>v.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:w,env:process.env}),m=S(E,h);return R(y,m)}e.connectProxyResolver=k;function S(T,E){const y={config:T.getConfiguration("http").get("proxySupport")||"off"};T.onDidChangeConfiguration(d=>{y.config=T.getConfiguration("http").get("proxySupport")||"off"});const v={config:!!T.getConfiguration("http").get("systemCertificates")};return T.onDidChangeConfiguration(d=>{v.config=!!T.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},a,(0,D.createHttpPatch)(a,E,{config:"off"},v,!0)),on:Object.assign({},a,(0,D.createHttpPatch)(a,E,{config:"on"},v,!0)),override:Object.assign({},a,(0,D.createHttpPatch)(a,E,{config:"override"},v,!0)),onRequest:Object.assign({},a,(0,D.createHttpPatch)(a,E,y,v,!0)),default:Object.assign(a,(0,D.createHttpPatch)(a,E,y,v,!1))},https:{off:Object.assign({},t,(0,D.createHttpPatch)(t,E,{config:"off"},v,!0)),on:Object.assign({},t,(0,D.createHttpPatch)(t,E,{config:"on"},v,!0)),override:Object.assign({},t,(0,D.createHttpPatch)(t,E,{config:"override"},v,!0)),onRequest:Object.assign({},t,(0,D.createHttpPatch)(t,E,y,v,!0)),default:Object.assign(t,(0,D.createHttpPatch)(t,E,y,v,!1))},tls:Object.assign(I,(0,D.createTlsPatch)(I))}}const C=new Map;function R(T,E){return T.getExtensionPathIndex().then(y=>{const v=globalThis._VSCODE_NODE_MODULES.module,d=v._load;v._load=function(f,w,h){if(f==="tls")return E.tls;if(f!=="http"&&f!=="https")return d.apply(this,arguments);const m=E[f],p=y.findSubstr(A.URI.file(w.filename));let o=C.get(p);if(o||C.set(p,o={}),!o[f]){const i=m.default;o[f]={...i}}return o[f]}})}}),define(Se[303],ye([1,0,76,301,288,302,41,276,2,15,7,273,113,275]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class v extends I.RequireInterceptor{j(){const f=this,w=globalThis._VSCODE_NODE_MODULES.module,h=w._load;w._load=function(i,l,u){return i=p(i),f.a.has(i)?f.a.get(i).load(i,S.URI.file((0,E.realpathSync)(l.filename)),s=>h.apply(this,[s,l,u])):h.apply(this,arguments)};const m=w._resolveLookupPaths;w._resolveLookupPaths=(o,i)=>m.call(this,p(o),i);const p=o=>{for(const i of f.b){const l=i(o);if(l){o=l;break}}return o}}}class d extends D.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async nb(){this.h.createInstance(y.ExtHostConsoleForwarder);const f=this.h.invokeFunction(t.createApiFactoryAndRegisterActors);if(this.h.createInstance(k.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const m=this.h.createInstance(T.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=m.ipcHandlePath}await this.h.createInstance(v,f,{mine:this.D,all:this.F}).install(),a.mark("code/extHost/didInitAPI");const h=await this.k.getConfigProvider();await(0,A.connectProxyResolver)(this.j,h,this,this.l,this.u,this.f),a.mark("code/extHost/didInitProxyResolver")}ob(f){return f.main}async pb(f,w,h){if(w.scheme!==C.Schemas.file)throw new Error(`Cannot load URI: '${w}', must be of file-scheme`);let m=null;h.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${w.toString(!0)}`),this.l.flush();const p=f?.identifier.value;f&&await this.s.initializeLocalizedMessages(f);try{p&&a.mark(`code/extHost/willLoadExtensionCode/${p}`),m=ne.__$__nodeRequire(w.fsPath)}finally{p&&a.mark(`code/extHost/didLoadExtensionCode/${p}`),h.codeLoadingStop()}return m}async $setRemoteEnvironment(f){if(!!this.f.remote.isRemote)for(const w in f){const h=f[w];h===null?delete process.env[w]:process.env[w]=h}}}e.ExtHostExtensionService=d}),define(Se[145],ye([1,0,45,314,297,17,80,37,9,8,2,31,74,315,295,98]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const b=v.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class f{constructor(g){this.a=g}provideTextSearchResults(g,P,L,z){return this.a.appendLine(`provideTextSearchResults ${g.pattern}, ${JSON.stringify({...P,folder:P.folder.toString()})}`),new Promise((_,K)=>{z.onCancellationRequested(()=>V());const F=i(g,P),M=P.folder.fsPath,N=F.map(le=>le.match(/^-/)?le:`'${le}'`).join(" ");this.a.appendLine(`${b} ${N}
 - cwd: ${M}`);let B=a.spawn(b,F,{cwd:M});B.on("error",le=>{console.error(le),this.a.appendLine("Error: "+(le&&le.message)),K((0,T.serializeSearchError)(new T.SearchError(le&&le.message,T.SearchErrorCode.rgProcessError)))});let U=!1;const W=new m(P.maxResults,M,P.previewOptions);W.on("result",le=>{U=!0,Q="",L.report(le)});let x=!1;const V=()=>{x=!0,B?.kill(),W?.cancel()};let X=!1;W.on("hitLimit",()=>{X=!0,V()});let Q="";B.stdout.on("data",le=>{W.handleData(le),U||(Q+=le)});let J=!1;B.stdout.once("data",()=>J=!0);let te="";B.stderr.on("data",le=>{const Z=le.toString();this.a.appendLine(Z),te.length+Z.length<1e6&&(te+=Z)}),B.on("close",()=>{if(this.a.appendLine(J?"Got data from stdout":"No data from stdout"),this.a.appendLine(U?"Got result from parser":"No result from parser"),Q&&this.a.appendLine(`Got data without result: ${Q}`),this.a.appendLine(""),x)_({limitHit:X});else{W.flush(),B=null;let le;te&&!J&&(le=w(te))?K((0,T.serializeSearchError)(new T.SearchError(le.message,le.code))):_({limitHit:X})}})})}}e.RipgrepTextSearchEngine=f;function w(r){const g=r.split(`
`),P=g[0].trim();if(g.some(z=>z.startsWith("regex parse error")))return new T.SearchError(h(g),T.SearchErrorCode.regexParseError);const L=P.match(/grep config error: unknown encoding: (.*)/);if(L)return new T.SearchError(`Unknown encoding: ${L[1]}`,T.SearchErrorCode.unknownEncoding);if(P.startsWith("error parsing glob"))return new T.SearchError(P.charAt(0).toUpperCase()+P.substr(1),T.SearchErrorCode.globParseError);if(P.startsWith("the literal"))return new T.SearchError(P.charAt(0).toUpperCase()+P.substr(1),T.SearchErrorCode.invalidLiteral);if(P.startsWith("PCRE2: error compiling pattern"))return new T.SearchError(P,T.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=w;function h(r){const g=["Regex parse error"],P=r.filter(L=>L.startsWith("PCRE2:"));if(P.length>=1){const L=P[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const z=L.split(":")[1];g.push(":"+z)}}return g.join("")}e.buildRegexParseError=h;class m extends t.EventEmitter{constructor(g,P,L){super(),this.g=g,this.h=P,this.j=L,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new I.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(g,P){return super.on(g,P),this}handleData(g){if(this.b)return;const P=typeof g=="string"?g:this.d.write(g);this.k(P)}k(g){let P=g.indexOf(`
`);const L=this.a+g;if(P>=0)P+=this.a.length;else{this.a=L;return}let z=0;for(;P>=0;)this.m(L.substring(z,P).trim()),z=P+1,P=L.indexOf(`
`,z);this.a=L.substring(z)}m(g){if(this.b||!g)return;let P;try{P=JSON.parse(g)}catch{throw new Error(`malformed line from rg: ${g}`)}if(P.type==="match"){const L=p(P.data.path),z=R.URI.file(S.join(this.h,L)),_=this.n(P.data,z);this.p(_),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(P.type==="context"){const L=p(P.data.path),z=R.URI.file(S.join(this.h,L));this.o(P.data,z).forEach(K=>this.p(K))}}n(g,P){const L=g.line_number-1,z=p(g.lines),_=Buffer.from(z);let K=0,F=0,M=L;g.submatches.length===0&&g.submatches.push(z.length?{start:0,end:1,match:{text:z[0]}}:{start:0,end:0,match:{text:""}});const N=(0,A.coalesce)(g.submatches.map((B,U)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const W=p(B.match),x=_.slice(K,B.start).toString(),V=o(x),X=V.numLines>0?V.lastLineLength:V.lastLineLength+F,Q=o(W),J=V.numLines+M,te=Q.numLines+J,le=Q.numLines>0?Q.lastLineLength:Q.lastLineLength+X;return K=B.end,F=le,M=te,new E.Range(J,X,te,le)}));return(0,d.createTextSearchResult)(P,z,N,this.j)}o(g,P){const L=p(g.lines),z=g.line_number;return L.replace(/\r?\n$/,"").split(`
`).map((_,K)=>({text:_,uri:P,lineNumber:z+K}))}p(g){this.emit("result",g)}}e.RipgrepParser=m;function p(r){return r.bytes?Buffer.from(r.bytes,"base64").toString():r.text}function o(r){const g=/\n/g;let P=0,L=-1,z;for(;z=g.exec(r);)P++,L=z.index;const _=L>=0?r.length-L-1:r.length;return{numLines:P,lastLineLength:_}}function i(r,g){const P=["--hidden"];P.push(r.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:z}=(0,D.groupBy)(g.includes,K=>K.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(z&&z.length){const K=new Set;z.forEach(F=>{K.add(F)}),P.push("-g","!*"),K.forEach(F=>{l(F).map(d.anchorGlob).forEach(M=>{P.push("-g",M)})})}L&&L.length&&L.forEach(K=>{P.push("-g",K)}),g.excludes.map(d.anchorGlob).forEach(K=>P.push("-g",`!${K}`)),g.maxFileSize&&P.push("--max-filesize",g.maxFileSize+""),g.useIgnoreFiles?g.useParentIgnoreFiles||P.push("--no-ignore-parent"):P.push("--no-ignore"),g.followSymlinks&&P.push("--follow"),g.encoding&&g.encoding!=="utf8"&&P.push("--encoding",g.encoding),r.pattern==="--"&&(r.isRegExp=!0,r.pattern="\\-\\-"),r.isMultiline&&!r.isRegExp&&(r.pattern=(0,C.escapeRegExpCharacters)(r.pattern),r.isRegExp=!0),g.usePCRE2&&P.push("--pcre2"),P.push("--crlf"),r.isRegExp&&(r.pattern=u(r.pattern),P.push("--engine","auto"));let _;if(r.isWordMatch){const F=(0,C.createRegExp)(r.pattern,!!r.isRegExp,{wholeWord:r.isWordMatch}).source.replace(/\\\//g,"/");P.push("--regexp",F)}else if(r.isRegExp){let K=c(r.pattern);K=n(K),P.push("--regexp",K)}else _=r.pattern,P.push("--fixed-strings");return P.push("--no-config"),g.useGlobalIgnoreFiles||P.push("--no-ignore-global"),P.push("--json"),r.isMultiline&&P.push("--multiline"),g.beforeContext&&P.push("--before-context",g.beforeContext+""),g.afterContext&&P.push("--after-context",g.afterContext+""),P.push("--"),_&&P.push(_),P.push("."),P}function l(r){const g=(0,k.splitGlobAware)(r,"/");return g.map((P,L)=>g.slice(0,L+1).join("/"))}e.spreadGlobComponents=l;function u(r){const g=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;r.match(g);)r=r.replace(g,"$1\\x{$2}");const P=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;r.match(P);)r=r.replace(P,"$1\\x{$2}");return r}e.unicodeEscapesToPCRE2=u;const s=r=>r.type==="Assertion"&&r.kind==="lookbehind";function c(r){let g;try{g=new y.RegExpParser().parsePattern(r)}catch{return r}let P="",L=0;const z=(F,M,N)=>{P+=r.slice(L,F)+N,L=M},_=[];return new y.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const M=_[0];if(!M)z(F.start,F.end,"\\r?\\n");else if(!_.some(s))if(M.type==="CharacterClass")if(M.negate){const N=r.slice(M.start+2,F.start)+r.slice(F.end,M.end-1);M.parent?.type==="Quantifier"?z(M.start,M.end,N?`[^${N}]`:"."):z(M.start,M.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=r.slice(M.start+1,F.start)+r.slice(F.end,M.end-1);z(M.start,M.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else M.type==="Quantifier"&&z(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){_.unshift(F)},onQuantifierLeave(){_.shift()},onCharacterClassRangeEnter(F){_.unshift(F)},onCharacterClassRangeLeave(){_.shift()},onCharacterClassEnter(F){_.unshift(F)},onCharacterClassLeave(){_.shift()},onAssertionEnter(F){s(F)&&_.push(F)},onAssertionLeave(F){_[0]===F&&_.shift()}}).visit(g),P+=r.slice(L),P}e.fixRegexNewline=c;function n(r){return r.replace(/\n/g,"\\r?\\n")}e.fixNewline=n}),define(Se[304],ye([1,0,21,145,124,15]),function(ne,e,a,t,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class D{constructor(C){this.b=C,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(C,R,T,E){const y=new t.RipgrepTextSearchEngine(this.b);if(R.folder.scheme===A.Schemas.vscodeUserData){const v={...R,folder:R.folder.with({scheme:A.Schemas.file})},d=new I.Progress(b=>T.report({...b,uri:b.uri.with({scheme:R.folder.scheme})}));return this.c(E,b=>y.provideTextSearchResults(C,v,d,b))}else return this.c(E,v=>y.provideTextSearchResults(C,R,T,v))}async c(C,R){const T=k(C);this.a.add(T);const E=await R(T.token);return this.a.delete(T),E}d(){this.a.forEach(C=>C.cancel())}}e.RipgrepSearchProvider=D;function k(S){const C=new a.CancellationTokenSource;return S.onCancellationRequested(()=>C.cancel()),C}}),define(Se[305],ye([1,0,29,145,144]),function(ne,e,a,t,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class A{constructor(S){this.a=S}search(S,C,R){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const T={appendLine(y){R({message:y})}},E=new I.NativeTextSearchManager(this.a,new t.RipgrepTextSearchEngine(T),a);return new Promise((y,v)=>E.search(d=>{C(d.map(D))},S).then(d=>y({limitHit:d.limitHit,type:"success",stats:d.stats}),v))}}e.TextSearchEngineAdapter=A;function D(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((S,C)=>{if(C.ranges){const R=C;return S+(Array.isArray(R.ranges)?R.ranges.length:1)}else return S+1},0)}}}),define(Se[306],ye([1,0,17,18,10,4,109,9,44,2,38,31,296,305]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class v{constructor(m="searchProcess"){this.d=m,this.b=Object.create(null)}fileSearch(m){let p;const o=f(m),i=new A.Emitter({onDidAddFirstListener:()=>{p=(0,t.createCancelablePromise)(l=>this.doFileSearchWithEngine(E.Engine,o,u=>i.fire(u),l)),p.then(l=>i.fire(l),l=>i.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onDidRemoveLastListener:()=>{p.cancel()}});return i.event}textSearch(m){let p;const o=f(m),i=new A.Emitter({onDidAddFirstListener:()=>{p=(0,t.createCancelablePromise)(l=>this.f(o,u=>i.fire(u),l)),p.then(l=>i.fire(l),l=>i.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onDidRemoveLastListener:()=>{p.cancel()}});return i.event}f(m,p,o){return m.maxFileSize=(0,R.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new y.TextSearchEngineAdapter(m).search(o,p,p)}doFileSearch(m,p,o){return this.doFileSearchWithEngine(E.Engine,m,p,o)}doFileSearchWithEngine(m,p,o,i,l=v.a){let u=0;const s=n=>{Array.isArray(n)?(u+=n.length,o(n.map(r=>this.g(r)))):n.relativePath?(u++,o(this.g(n))):o(n)};if(p.sortByScore){let n=this.k(p,s,i);if(!n){const r=p.maxResults?Object.assign({},p,{maxResults:null}):p,g=new m(r);n=this.h(g,p,o,s,i)}return new Promise((r,g)=>{n.then(([P,L])=>{const z=L.map(_=>this.g(_));this.n(z,o,l),r(P)},g)})}const c=new m(p);return this.q(c,s,l,i).then(n=>({limitHit:n.limitHit,type:"success",stats:{detailStats:n.stats,type:this.d,fromCache:!1,resultCount:u,sortingTime:void 0}}))}g(m){return{path:m.base?(0,k.join)(m.base,m.relativePath):m.relativePath}}h(m,p,o,i,l){const u=new A.Emitter;let s=(0,t.createCancelablePromise)(n=>{let r=[];const g=P=>{Array.isArray(P)?r=P:(i(P),u.fire(P))};return this.q(m,g,-1,n).then(P=>[P,r])}),c;if(p.cacheKey){c=this.j(p.cacheKey);const n={promise:s,event:u.event,resolved:!1};c.resultsToSearchCache[p.filePattern||""]=n,s.then(()=>{n.resolved=!0},r=>{delete c.resultsToSearchCache[p.filePattern||""]}),s=this.r(s)}return s.then(([n,r])=>{const g=c?c.scorerCache:Object.create(null),P=(typeof p.maxResults!="number"||p.maxResults>0)&&S.StopWatch.create(!1);return this.l(p,r,g,l).then(L=>{const z=P?P.elapsed():-1;return[{type:"success",stats:{detailStats:n.stats,sortingTime:z,fromCache:!1,type:this.d,workspaceFolderCount:p.folderQueries.length,resultCount:L.length},messages:n.messages,limitHit:n.limitHit||typeof p.maxResults=="number"&&r.length>p.maxResults},L]})})}j(m){const p=this.b[m];return p||(this.b[m]=new d)}k(m,p,o){const i=m.cacheKey&&this.b[m.cacheKey];if(!i)return;const l=this.o(i,m.filePattern||"",p,o);if(l)return l.then(([u,s,c])=>{const n=S.StopWatch.create(!1);return this.l(m,s,i.scorerCache,o).then(r=>{const g=n.elapsed(),P={fromCache:!0,detailStats:c,type:this.d,resultCount:s.length,sortingTime:g};return[{type:"success",limitHit:u.limitHit||typeof m.maxResults=="number"&&s.length>m.maxResults,stats:P},r]})})}l(m,p,o,i){const l=(0,D.prepareQuery)(m.filePattern||""),u=(c,n)=>(0,D.compareItemsByFuzzyScore)(c,n,l,!0,b,o),s=typeof m.maxResults=="number"?m.maxResults:Number.MAX_VALUE;return a.topAsync(p,u,s,1e4,i)}n(m,p,o){if(o&&o>0)for(let i=0;i<m.length;i+=o)p(m.slice(i,i+o));else p(m)}o(m,p,o,i){const l=S.StopWatch.create(!1),u=p.indexOf(k.sep)>=0;let s;for(const g in m.resultsToSearchCache)if(p.startsWith(g)){if(u&&g.indexOf(k.sep)<0&&g!=="")continue;const P=m.resultsToSearchCache[g];s={promise:this.r(P.promise),event:P.event,resolved:P.resolved};break}if(!s)return null;const c=l.elapsed(),n=S.StopWatch.create(!1),r=s.event(o);return i&&i.onCancellationRequested(()=>{r.dispose()}),s.promise.then(([g,P])=>{if(i&&i.isCancellationRequested)throw(0,I.canceled)();const L=[],z=(0,D.prepareQuery)(p).normalizedLowercase;for(const _ of P)!(0,T.isFilePatternMatch)(_,z)||L.push(_);return[g,L,{cacheWasResolved:s.resolved,cacheLookupTime:c,cacheFilterTime:n.elapsed(),cacheEntryCount:P.length}]})}q(m,p,o,i){return new Promise((l,u)=>{let s=[];i?.onCancellationRequested(()=>m.cancel()),m.search(c=>{c&&(o?(s.push(c),o>0&&s.length>=o&&(p(s),s=[])):p(c))},c=>{p(c)},(c,n)=>{s.length&&p(s),c?u(c):l(n)})})}clearCache(m){return delete this.b[m],Promise.resolve(void 0)}r(m){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(p,o){return m.then(p,o)}catch(p){return this.then(void 0,p)}finally(p){return m.finally(p)}}}}e.SearchService=v,v.a=512;class d{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const b=new class{getItemLabel(h){return(0,k.basename)(h.relativePath)}getItemDescription(h){return(0,k.dirname)(h.relativePath)}getItemPath(h){return h.relativePath}};function f(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(w),extraFileResources:h.extraFileResources&&h.extraFileResources.map(m=>C.URI.revive(m))}}function w(h){return{...h,folder:C.URI.revive(h.folder)}}}),define(Se[307],ye([1,0,6,15,2,29,13,25,16,78,55,31,306,304,98,144]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let b=class extends C.ExtHostSearch{constructor(w,h,m,p){super(w,m,p),this.s=A,this.t=-1,this.v=null,this.w=!1;const o=new v.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new y.RipgrepSearchProvider(o)),h.remote.isRemote&&h.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const w=new v.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(t.Schemas.file,new y.RipgrepSearchProvider(w)),this.y(t.Schemas.file,new E.SearchService("fileSearchProvider"))}y(w,h){const m=this.d++;return this.v=h,this.t=m,this.c.$registerFileSearchProvider(m,this.o(w)),(0,a.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(m)})}$provideFileSearchResults(w,h,m,p){const o=(0,C.reviveQuery)(m);return w===this.t?this.z(w,h,o,p):super.$provideFileSearchResults(w,h,m,p)}z(w,h,m,p){const o=i=>{if((0,T.isSerializedFileMatch)(i)&&(i=[i]),Array.isArray(i)){this.c.$handleFileMatch(w,h,i.map(l=>I.URI.file(l.path)));return}i.message&&this.n.debug("ExtHostSearch",i.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(m,o,p)}$clearCache(w){return this.v?.clearCache(w),super.$clearCache(w)}q(w,h){return new d.NativeTextSearchManager(w,h,void 0,"textSearchProvider")}};b=qe([We(0,S.IExtHostRpcService),We(1,k.IExtHostInitDataService),We(2,R.IURITransformerService),We(3,D.ILogService)],b),e.NativeExtHostSearch=b}),define(Se[308],ye([1,0,87,279,291,290,307,303,280,77,41,78,75,40,54,72,278,277,13,292,48]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v,d,b,f,w,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(R.IExtHostExtensionService,k.ExtHostExtensionService,0),(0,a.registerSingleton)(w.ILoggerService,f.ExtHostLoggerService,1),(0,a.registerSingleton)(d.IExtensionStoragePaths,b.ExtensionStoragePaths,0),(0,a.registerSingleton)(C.IExtHostDebugService,A.ExtHostDebugService,0),(0,a.registerSingleton)(T.IExtHostSearch,D.NativeExtHostSearch,0),(0,a.registerSingleton)(E.IExtHostTask,I.ExtHostTask,0),(0,a.registerSingleton)(y.IExtHostTerminalService,t.ExtHostTerminalService,0),(0,a.registerSingleton)(v.IExtHostTunnelService,S.ExtHostTunnelService,0),(0,a.registerSingleton)(m.IExtHostVariableResolverProvider,h.NodeExtHostVariableResolverProviderService,0)}),define(Se[316],ye([1,0,219,317,76,10,116,117,200,93,289,22,29,113,18,119,215,228,293,308]),function(ne,e,a,t,I,A,D,k,S,C,R,T,E,y,v,d,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let c=0;c<process.execArgv.length;c++)process.execArgv[c]==="--inspect-port=0"&&(process.execArgv.splice(c,1),c--)}();const w=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const s=globalThis._VSCODE_NODE_MODULES.module,c=s._load;s._load=function(n){if(n==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return c.apply(this,arguments)}})();const h=process.exit.bind(process);function m(s){process.exit=function(c){if(s)h(c);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const c=new Error("An extension called process.crash() and this was prevented.");console.warn(c.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let p=function(s){h()};function o(){const s=(0,f.readExtHostConnection)(process.env);if(s.type===3)return new Promise((c,n)=>{const r=g=>{const P=g[0],L=new D.BufferedEmitter;P.on("message",z=>L.fire(T.VSBuffer.wrap(z.data))),P.on("close",()=>{p("renderer closed the MessagePort")}),P.start(),c({onMessage:L.event,send:z=>P.postMessage(z.buffer)})};process?.parentPort.on("message",g=>r(g.ports))});if(s.type===2)return new Promise((c,n)=>{let r=null;const g=setTimeout(()=>{p("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),P=108e5,L=3e5,z=new v.ProcessTimeRunOnceScheduler(()=>p("renderer disconnected for too long (1)"),P),_=new v.ProcessTimeRunOnceScheduler(()=>p("renderer disconnected for too long (2)"),L);process.on("message",(F,M)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){M.setNoDelay(!0);const N=T.VSBuffer.wrap(Buffer.from(F.initialDataChunk,"base64"));let B;if(F.skipWebSocketFrames)B=new k.NodeSocket(M,"extHost-socket");else{const U=T.VSBuffer.wrap(Buffer.from(F.inflateBytes,"base64"));B=new k.WebSocketNodeSocket(new k.NodeSocket(M,"extHost-socket"),F.permessageDeflate,U,!1)}r?(z.cancel(),_.cancel(),r.beginAcceptReconnection(B,N),r.endAcceptReconnection(),r.sendResume()):(clearTimeout(g),r=new D.PersistentProtocol(B,N),r.sendResume(),r.onDidDispose(()=>p("renderer disconnected")),c(r),r.onSocketClose(()=>{z.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(_.isScheduled())return;z.isScheduled()&&_.schedule()}});const K={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(K)});{const c=s.pipeName;return new Promise((n,r)=>{const g=a.createConnection(c,()=>{g.removeListener("error",r);const P=new D.PersistentProtocol(new k.NodeSocket(g,"extHost-renderer"));P.sendResume(),n(P)});g.once("error",r),g.on("close",()=>{p("renderer closed the socket")})})}}async function i(){const s=await o();return new class{constructor(){this.a=new D.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,s.onMessage(c=>{(0,C.isMessageOfType)(c,2)?(this.b=!0,p("received terminate message from renderer")):this.a.fire(c)})}send(c){this.b||s.send(c)}async drain(){if(s.drain)return s.drain()}}}function l(s){return new Promise(c=>{const n=s.onMessage(r=>{n.dispose();const g=JSON.parse(r.toString()),P=g.commit,L=S.default.commit;if(P&&L&&P!==L&&h(55),g.parentPid){let z=0;setInterval(function(){try{process.kill(g.parentPid,0),z=0}catch(K){K&&K.code==="EPERM"?(z++,z>=3&&p(`parent process ${g.parentPid} does not exist anymore (3 x EPERM): ${K.message} (code: ${K.code}) (errno: ${K.errno})`)):p(`parent process ${g.parentPid} does not exist anymore: ${K.message} (code: ${K.code}) (errno: ${K.errno})`)}},1e3);let _;try{_=globalThis._VSCODE_NODE_MODULES["native-watchdog"],_.start(g.parentPid)}catch(K){(0,A.onUnexpectedError)(K)}}s.send((0,C.createMessageOfType)(0)),c({protocol:s,initData:g})});s.send((0,C.createMessageOfType)(1))})}async function u(){const s=[];process.on("unhandledRejection",(z,_)=>{s.push(_),setTimeout(()=>{const K=s.indexOf(_);K>=0&&_.catch(F=>{s.splice(K,1),(0,A.isCancellationError)(F)||(console.warn(`rejected promise not handled within 1 second: ${F}`),F&&F.stack&&console.warn(`stack trace: ${F.stack}`),z&&(0,A.onUnexpectedError)(z))})},1e3)}),process.on("rejectionHandled",z=>{const _=s.indexOf(z);_>=0&&s.splice(_,1)}),process.on("uncaughtException",function(z){(0,A.onUnexpectedError)(z)}),I.mark("code/extHost/willConnectToRenderer");const c=await i();I.mark("code/extHost/didConnectToRenderer");const n=await l(c);I.mark("code/extHost/didWaitForInitData");const{initData:r}=n;m(!!r.environment.extensionTestsLocationURI),r.environment.useHostProxy=w.useHostProxy!==void 0?w.useHostProxy!=="false":void 0,r.environment.skipWorkspaceStorageLock=(0,d.boolean)(w.skipWorkspaceStorageLock,!1);const g=new class{constructor(){this.pid=process.pid}exit(_){h(_)}exists(_){return E.Promises.exists(_)}realpath(_){return(0,y.realpath)(_)}};let P=null;r.remote.authority&&w.transformURIs&&(P=(0,b.createURITransformer)(r.remote.authority));const L=new R.ExtensionHostMain(n.protocol,r,g,P);p=z=>L.terminate(z)}u().catch(s=>console.log(s))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d7b1e2a1c892511a125e4ceb9758ec8ddf907775/core/vs/workbench/api/node/extensionHostProcess.js.map
