/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ie=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/errorMessage","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/telemetryUtils","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/base/common/stopwatch","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ce=function(ee){for(var e=[],i=0,T=ee.length;i<T;i++)e[i]=Ie[ee[i]];return e};define(Ie[78],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function i(C,A){const S=Object.create(null);for(const k of C){const M=A(k);let D=S[M];D||(D=S[M]=[]),D.push(k)}return S}e.groupBy=i;function T(C,A){const S=[],k=[];for(const M of C)A.has(M)||S.push(M);for(const M of A)C.has(M)||k.push(M);return{removed:S,added:k}}e.diffSets=T;function y(C,A){const S=[],k=[];for(const[M,D]of C)A.has(M)||S.push(D);for(const[M,D]of A)C.has(M)||k.push(D);return{removed:S,added:k}}e.diffMaps=y;class L{constructor(){this.a=new Map}add(A,S){let k=this.a.get(A);k||(k=new Set,this.a.set(A,k)),k.add(S)}delete(A,S){const k=this.a.get(A);!k||(k.delete(S),k.size===0&&this.a.delete(A))}forEach(A,S){const k=this.a.get(A);!k||k.forEach(S)}}e.SetMap=L}),define(Ie[60],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function i(C){return(A,S,k)=>{let M=null,D=null;if(typeof k.value=="function"?(M="value",D=k.value):typeof k.get=="function"&&(M="get",D=k.get),!D)throw new Error("not supported");k[M]=C(D,S)}}function T(C,A,S){let k=null,M=null;if(typeof S.value=="function"?(k="value",M=S.value,M.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(k="get",M=S.get),!M)throw new Error("not supported");const D=`$memoize$${A}`;S[k]=function(...m){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:M.apply(this,m)}),this[D]}}e.memoize=T;function y(C,A,S){return i((k,M)=>{const D=`$debounce$${M}`,m=`$debounce$result$${M}`;return function(...b){this[m]||(this[m]=S?S():void 0),clearTimeout(this[D]),A&&(this[m]=A(this[m],...b),b=[this[m]]),this[D]=setTimeout(()=>{k.apply(this,b),this[m]=S?S():void 0},C)}})}e.debounce=y;function L(C,A,S){return i((k,M)=>{const D=`$throttle$timer$${M}`,m=`$throttle$result$${M}`,b=`$throttle$lastRun$${M}`,f=`$throttle$pending$${M}`;return function(...t){if(this[m]||(this[m]=S?S():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),A&&(this[m]=A(this[m],...t)),this[f])return;const c=this[b]+C;c<=Date.now()?(this[b]=Date.now(),k.apply(this,[this[m]]),this[m]=S?S():void 0):(this[f]=!0,this[D]=setTimeout(()=>{this[f]=!1,this[b]=Date.now(),k.apply(this,[this[m]]),this[m]=S?S():void 0},c-Date.now()))}})}e.throttle=L}),define(Ie[79],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class i{constructor(y){this.a=y,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=i,e.defaultGenerator=new i("id#")}),define(Ie[109],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var i;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(i=e.ScanError||(e.ScanError={}));var T;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var y;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(y=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(s){s.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function C(s,r=!1){let o=0;const h=s.length;let a="",l=0,n=16,d=0;function g(P){let F=0,B=0;for(;F<P;){const z=s.charCodeAt(o);if(z>=48&&z<=57)B=B*16+z-48;else if(z>=65&&z<=70)B=B*16+z-65+10;else if(z>=97&&z<=102)B=B*16+z-97+10;else break;o++,F++}return F<P&&(B=-1),B}function O(P){o=P,a="",l=0,n=16,d=0}function N(){const P=o;if(s.charCodeAt(o)===48)o++;else for(o++;o<s.length&&k(s.charCodeAt(o));)o++;if(o<s.length&&s.charCodeAt(o)===46)if(o++,o<s.length&&k(s.charCodeAt(o)))for(o++;o<s.length&&k(s.charCodeAt(o));)o++;else return d=3,s.substring(P,o);let F=o;if(o<s.length&&(s.charCodeAt(o)===69||s.charCodeAt(o)===101))if(o++,(o<s.length&&s.charCodeAt(o)===43||s.charCodeAt(o)===45)&&o++,o<s.length&&k(s.charCodeAt(o))){for(o++;o<s.length&&k(s.charCodeAt(o));)o++;F=o}else d=3;return s.substring(P,F)}function q(){let P="",F=o;for(;;){if(o>=h){P+=s.substring(F,o),d=2;break}const B=s.charCodeAt(o);if(B===34){P+=s.substring(F,o),o++;break}if(B===92){if(P+=s.substring(F,o),o++,o>=h){d=2;break}switch(s.charCodeAt(o++)){case 34:P+='"';break;case 92:P+="\\";break;case 47:P+="/";break;case 98:P+="\b";break;case 102:P+="\f";break;case 110:P+=`
`;break;case 114:P+="\r";break;case 116:P+="	";break;case 117:{const V=g(4);V>=0?P+=String.fromCharCode(V):d=4;break}default:d=5}F=o;continue}if(B>=0&&B<=31)if(S(B)){P+=s.substring(F,o),d=2;break}else d=6;o++}return P}function J(){if(a="",d=0,l=o,o>=h)return l=h,n=17;let P=s.charCodeAt(o);if(A(P)){do o++,a+=String.fromCharCode(P),P=s.charCodeAt(o);while(A(P));return n=15}if(S(P))return o++,a+=String.fromCharCode(P),P===13&&s.charCodeAt(o)===10&&(o++,a+=`
`),n=14;switch(P){case 123:return o++,n=1;case 125:return o++,n=2;case 91:return o++,n=3;case 93:return o++,n=4;case 58:return o++,n=6;case 44:return o++,n=5;case 34:return o++,a=q(),n=10;case 47:{const F=o-1;if(s.charCodeAt(o+1)===47){for(o+=2;o<h&&!S(s.charCodeAt(o));)o++;return a=s.substring(F,o),n=12}if(s.charCodeAt(o+1)===42){o+=2;const B=h-1;let z=!1;for(;o<B;){if(s.charCodeAt(o)===42&&s.charCodeAt(o+1)===47){o+=2,z=!0;break}o++}return z||(o++,d=1),a=s.substring(F,o),n=13}return a+=String.fromCharCode(P),o++,n=16}case 45:if(a+=String.fromCharCode(P),o++,o===h||!k(s.charCodeAt(o)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=N(),n=11;default:for(;o<h&&x(P);)o++,P=s.charCodeAt(o);if(l!==o){switch(a=s.substring(l,o),a){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return a+=String.fromCharCode(P),o++,n=16}}function x(P){if(A(P)||S(P))return!1;switch(P){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function R(){let P;do P=J();while(P>=12&&P<=15);return P}return{setPosition:O,getPosition:()=>o,scan:r?R:J,getToken:()=>n,getTokenValue:()=>a,getTokenOffset:()=>l,getTokenLength:()=>o-l,getTokenError:()=>d}}e.createScanner=C;function A(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function S(s){return s===10||s===13||s===8232||s===8233}function k(s){return s>=48&&s<=57}var M;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(M||(M={}));function D(s,r){const o=[],h=new Object;let a;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function d(g,O,N,q){l.value=g,l.offset=O,l.length=N,l.type=q,l.colonOffset=void 0,a=l}try{E(s,{onObjectBegin:(g,O)=>{if(r<=g)throw h;a=void 0,n=r>g,o.push("")},onObjectProperty:(g,O,N)=>{if(r<O||(d(g,O,N,"property"),o[o.length-1]=g,r<=O+N))throw h},onObjectEnd:(g,O)=>{if(r<=g)throw h;a=void 0,o.pop()},onArrayBegin:(g,O)=>{if(r<=g)throw h;a=void 0,o.push(0)},onArrayEnd:(g,O)=>{if(r<=g)throw h;a=void 0,o.pop()},onLiteralValue:(g,O,N)=>{if(r<O||(d(g,O,N,w(g)),r<=O+N))throw h},onSeparator:(g,O,N)=>{if(r<=O)throw h;if(g===":"&&a&&a.type==="property")a.colonOffset=O,n=!1,a=void 0;else if(g===","){const q=o[o.length-1];typeof q=="number"?o[o.length-1]=q+1:(n=!0,o[o.length-1]=""),a=void 0}}})}catch(g){if(g!==h)throw g}return{path:o,previousNode:a,isAtPropertyKey:n,matches:g=>{let O=0;for(let N=0;O<g.length&&N<o.length;N++)if(g[O]===o[N]||g[O]==="*")O++;else if(g[O]!=="**")return!1;return O===g.length}}}e.getLocation=D;function m(s,r=[],o=L.DEFAULT){let h=null,a=[];const l=[];function n(g){Array.isArray(a)?a.push(g):h!==null&&(a[h]=g)}return E(s,{onObjectBegin:()=>{const g={};n(g),l.push(a),a=g,h=null},onObjectProperty:g=>{h=g},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{const g=[];n(g),l.push(a),a=g,h=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:n,onError:(g,O,N)=>{r.push({error:g,offset:O,length:N})}},o),a[0]}e.parse=m;function b(s,r=[],o=L.DEFAULT){let h={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(g){h.type==="property"&&(h.length=g-h.offset,h=h.parent)}function l(g){return h.children.push(g),g}E(s,{onObjectBegin:g=>{h=l({type:"object",offset:g,length:-1,parent:h,children:[]})},onObjectProperty:(g,O,N)=>{h=l({type:"property",offset:O,length:-1,parent:h,children:[]}),h.children.push({type:"string",value:g,offset:O,length:N,parent:h})},onObjectEnd:(g,O)=>{h.length=g+O-h.offset,h=h.parent,a(g+O)},onArrayBegin:(g,O)=>{h=l({type:"array",offset:g,length:-1,parent:h,children:[]})},onArrayEnd:(g,O)=>{h.length=g+O-h.offset,h=h.parent,a(g+O)},onLiteralValue:(g,O,N)=>{l({type:w(g),offset:O,length:N,parent:h,value:g}),a(O+N)},onSeparator:(g,O,N)=>{h.type==="property"&&(g===":"?h.colonOffset=O:g===","&&a(O))},onError:(g,O,N)=>{r.push({error:g,offset:O,length:N})}},o);const d=h.children[0];return d&&delete d.parent,d}e.parseTree=b;function f(s,r){if(!s)return;let o=s;for(const h of r)if(typeof h=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let a=!1;for(const l of o.children)if(Array.isArray(l.children)&&l.children[0].value===h){o=l.children[1],a=!0;break}if(!a)return}else{const a=h;if(o.type!=="array"||a<0||!Array.isArray(o.children)||a>=o.children.length)return;o=o.children[a]}return o}e.findNodeAtLocation=f;function t(s){if(!s.parent||!s.parent.children)return[];const r=t(s.parent);if(s.parent.type==="property"){const o=s.parent.children[0].value;r.push(o)}else if(s.parent.type==="array"){const o=s.parent.children.indexOf(s);o!==-1&&r.push(o)}return r}e.getNodePath=t;function c(s){switch(s.type){case"array":return s.children.map(c);case"object":{const r=Object.create(null);for(const o of s.children){const h=o.children[1];h&&(r[o.children[0].value]=c(h))}return r}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=c;function u(s,r,o=!1){return r>=s.offset&&r<s.offset+s.length||o&&r===s.offset+s.length}e.contains=u;function p(s,r,o=!1){if(u(s,r,o)){const h=s.children;if(Array.isArray(h))for(let a=0;a<h.length&&h[a].offset<=r;a++){const l=p(h[a],r,o);if(l)return l}return s}}e.findNodeAtOffset=p;function E(s,r,o=L.DEFAULT){const h=C(s,!1);function a(se){return se?()=>se(h.getTokenOffset(),h.getTokenLength()):()=>!0}function l(se){return se?le=>se(le,h.getTokenOffset(),h.getTokenLength()):()=>!0}const n=a(r.onObjectBegin),d=l(r.onObjectProperty),g=a(r.onObjectEnd),O=a(r.onArrayBegin),N=a(r.onArrayEnd),q=l(r.onLiteralValue),J=l(r.onSeparator),x=a(r.onComment),R=l(r.onError),P=o&&o.disallowComments,F=o&&o.allowTrailingComma;function B(){for(;;){const se=h.scan();switch(h.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:P||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(se){case 12:case 13:P?z(10):x();break;case 16:z(1);break;case 15:case 14:break;default:return se}}}function z(se,le=[],_=[]){if(R(se),le.length+_.length>0){let me=h.getToken();for(;me!==17;){if(le.indexOf(me)!==-1){B();break}else if(_.indexOf(me)!==-1)break;me=B()}}}function V(se){const le=h.getTokenValue();return se?q(le):d(le),B(),!0}function K(){switch(h.getToken()){case 11:{let se=0;try{se=JSON.parse(h.getTokenValue()),typeof se!="number"&&(z(2),se=0)}catch{z(2)}q(se);break}case 7:q(null);break;case 8:q(!0);break;case 9:q(!1);break;default:return!1}return B(),!0}function ie(){return h.getToken()!==10?(z(3,[],[2,5]),!1):(V(!1),h.getToken()===6?(J(":"),B(),re()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function ge(){n(),B();let se=!1;for(;h.getToken()!==2&&h.getToken()!==17;){if(h.getToken()===5){if(se||z(4,[],[]),J(","),B(),h.getToken()===2&&F)break}else se&&z(6,[],[]);ie()||z(4,[],[2,5]),se=!0}return g(),h.getToken()!==2?z(7,[2],[]):B(),!0}function ue(){O(),B();let se=!1;for(;h.getToken()!==4&&h.getToken()!==17;){if(h.getToken()===5){if(se||z(4,[],[]),J(","),B(),h.getToken()===4&&F)break}else se&&z(6,[],[]);re()||z(4,[],[4,5]),se=!0}return N(),h.getToken()!==4?z(8,[4],[]):B(),!0}function re(){switch(h.getToken()){case 3:return ue();case 1:return ge();case 10:return V(!0);default:return K()}}return B(),h.getToken()===17?o.allowEmptyContent?!0:(z(4,[],[]),!1):re()?(h.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=E;function v(s,r){const o=C(s),h=[];let a,l=0,n;do switch(n=o.getPosition(),a=o.scan(),a){case 12:case 13:case 17:l!==n&&h.push(s.substring(l,n)),r!==void 0&&h.push(o.getTokenValue().replace(/[^\r\n]/g,r)),l=o.getPosition();break}while(a!==17);return h.join("")}e.stripComments=v;function w(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),define(Ie[28],Ce([1,0]),function(ee,e){"use strict";var i,T,y;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function L(f,t,c){let u=f.get(t);return u===void 0&&(u=c,f.set(t,u)),u}e.getOrSet=L;function C(f){const t=[];return f.forEach((c,u)=>{t.push(`${u} => ${c}`)}),`Map(${f.size}) {${t.join(", ")}}`}e.mapToString=C;function A(f){const t=[];return f.forEach(c=>{t.push(c)}),`Set(${f.size}) {${t.join(", ")}}`}e.setToString=A;class S{constructor(t,c){this.uri=t,this.value=c}}class k{constructor(t,c){this[i]="ResourceMap",t instanceof k?(this.b=new Map(t.b),this.c=c??k.a):(this.b=new Map,this.c=t??k.a)}set(t,c){return this.b.set(this.c(t),new S(t,c)),this}get(t){return this.b.get(this.c(t))?.value}has(t){return this.b.has(this.c(t))}get size(){return this.b.size}clear(){this.b.clear()}delete(t){return this.b.delete(this.c(t))}forEach(t,c){typeof c<"u"&&(t=t.bind(c));for(const[u,p]of this.b)t(p.value,p.uri,this)}*values(){for(const t of this.b.values())yield t.value}*keys(){for(const t of this.b.values())yield t.uri}*entries(){for(const t of this.b.values())yield[t.uri,t.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.b)yield[t.uri,t.value]}}e.ResourceMap=k,k.a=f=>f.toString();class M{constructor(t,c){this[T]="ResourceSet",!t||typeof t=="function"?this.a=new k(t):(this.a=new k(c),t.forEach(this.add,this))}get size(){return this.a.size}add(t){return this.a.set(t,t),this}clear(){this.a.clear()}delete(t){return this.a.delete(t)}forEach(t,c){this.a.forEach((u,p)=>t.call(c,p,p,this))}has(t){return this.a.has(t)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=M;var D;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(D=e.Touch||(e.Touch={}));class m{constructor(){this[y]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(t){return this.a.has(t)}get(t,c=0){const u=this.a.get(t);if(!!u)return c!==0&&this.j(u,c),u.value}set(t,c,u=0){let p=this.a.get(t);if(p)p.value=c,u!==0&&this.j(p,u);else{switch(p={key:t,value:c,next:void 0,previous:void 0},u){case 0:this.h(p);break;case 1:this.g(p);break;case 2:this.h(p);break;default:this.h(p);break}this.a.set(t,p),this.d++}return this}delete(t){return!!this.remove(t)}remove(t){const c=this.a.get(t);if(!!c)return this.a.delete(t),this.i(c),this.d--,c.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const t=this.b;return this.a.delete(t.key),this.i(t),this.d--,t.value}forEach(t,c){const u=this.e;let p=this.b;for(;p;){if(c?t.bind(c)(p.value,p.key,this):t(p.value,p.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const t=this,c=this.e;let u=this.b;const p={[Symbol.iterator](){return p},next(){if(t.e!==c)throw new Error("LinkedMap got modified during iteration.");if(u){const E={value:u.key,done:!1};return u=u.next,E}else return{value:void 0,done:!0}}};return p}values(){const t=this,c=this.e;let u=this.b;const p={[Symbol.iterator](){return p},next(){if(t.e!==c)throw new Error("LinkedMap got modified during iteration.");if(u){const E={value:u.value,done:!1};return u=u.next,E}else return{value:void 0,done:!0}}};return p}entries(){const t=this,c=this.e;let u=this.b;const p={[Symbol.iterator](){return p},next(){if(t.e!==c)throw new Error("LinkedMap got modified during iteration.");if(u){const E={value:[u.key,u.value],done:!1};return u=u.next,E}else return{value:void 0,done:!0}}};return p}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(t){if(t>=this.size)return;if(t===0){this.clear();return}let c=this.b,u=this.size;for(;c&&u>t;)this.a.delete(c.key),c=c.next,u--;this.b=c,this.d=u,c&&(c.previous=void 0),this.e++}g(t){if(!this.b&&!this.c)this.c=t;else if(this.b)t.next=this.b,this.b.previous=t;else throw new Error("Invalid list");this.b=t,this.e++}h(t){if(!this.b&&!this.c)this.b=t;else if(this.c)t.previous=this.c,this.c.next=t;else throw new Error("Invalid list");this.c=t,this.e++}i(t){if(t===this.b&&t===this.c)this.b=void 0,this.c=void 0;else if(t===this.b){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.b=t.next}else if(t===this.c){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.c=t.previous}else{const c=t.next,u=t.previous;if(!c||!u)throw new Error("Invalid list");c.previous=u,u.next=c}t.next=void 0,t.previous=void 0,this.e++}j(t,c){if(!this.b||!this.c)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(t===this.b)return;const u=t.next,p=t.previous;t===this.c?(p.next=void 0,this.c=p):(u.previous=p,p.next=u),t.previous=void 0,t.next=this.b,this.b.previous=t,this.b=t,this.e++}else if(c===2){if(t===this.c)return;const u=t.next,p=t.previous;t===this.b?(u.previous=void 0,this.b=u):(u.previous=p,p.next=u),t.next=void 0,t.previous=this.c,this.c.next=t,this.c=t,this.e++}}}toJSON(){const t=[];return this.forEach((c,u)=>{t.push([u,c])}),t}fromJSON(t){this.clear();for(const[c,u]of t)this.set(c,u)}}e.LinkedMap=m;class b extends m{constructor(t,c=1){super(),this.k=t,this.l=Math.min(Math.max(0,c),1)}get limit(){return this.k}set limit(t){this.k=t,this.m()}get ratio(){return this.l}set ratio(t){this.l=Math.min(Math.max(0,t),1),this.m()}get(t,c=2){return super.get(t,c)}peek(t){return super.get(t,0)}set(t,c){return super.set(t,c,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=b}),function(ee,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ie[110],Ce([0]),e):(ee=typeof globalThis<"u"?globalThis:ee||self,e(ee.marked={}))}(this,function(ee){"use strict";function e(Te,De){for(var ke=0;ke<De.length;ke++){var oe=De[ke];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(Te,oe.key,oe)}}function i(Te,De,ke){return De&&e(Te.prototype,De),ke&&e(Te,ke),Object.defineProperty(Te,"prototype",{writable:!1}),Te}function T(Te,De){if(!!Te){if(typeof Te=="string")return y(Te,De);var ke=Object.prototype.toString.call(Te).slice(8,-1);if(ke==="Object"&&Te.constructor&&(ke=Te.constructor.name),ke==="Map"||ke==="Set")return Array.from(Te);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return y(Te,De)}}function y(Te,De){(De==null||De>Te.length)&&(De=Te.length);for(var ke=0,oe=new Array(De);ke<De;ke++)oe[ke]=Te[ke];return oe}function L(Te,De){var ke=typeof Symbol<"u"&&Te[Symbol.iterator]||Te["@@iterator"];if(ke)return(ke=ke.call(Te)).next.bind(ke);if(Array.isArray(Te)||(ke=T(Te))||De&&Te&&typeof Te.length=="number"){ke&&(Te=ke);var oe=0;return function(){return oe>=Te.length?{done:!0}:{done:!1,value:Te[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ee.defaults=C();function A(Te){ee.defaults=Te}var S=/[&<>"']/,k=/[&<>"']/g,M=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(De){return m[De]};function f(Te,De){if(De){if(S.test(Te))return Te.replace(k,b)}else if(M.test(Te))return Te.replace(D,b);return Te}var t=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function c(Te){return Te.replace(t,function(De,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var u=/(^|[^\[])\^/g;function p(Te,De){Te=typeof Te=="string"?Te:Te.source,De=De||"";var ke={replace:function(ce,Y){return Y=Y.source||Y,Y=Y.replace(u,"$1"),Te=Te.replace(ce,Y),ke},getRegex:function(){return new RegExp(Te,De)}};return ke}var E=/[^\w:]/g,v=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function w(Te,De,ke){if(Te){var oe;try{oe=decodeURIComponent(c(ke)).replace(E,"").toLowerCase()}catch{return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}De&&!v.test(ke)&&(ke=a(De,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch{return null}return ke}var s={},r=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,h=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(Te,De){s[" "+Te]||(r.test(Te)?s[" "+Te]=Te+"/":s[" "+Te]=g(Te,"/",!0)),Te=s[" "+Te];var ke=Te.indexOf(":")===-1;return De.substring(0,2)==="//"?ke?De:Te.replace(o,"$1")+De:De.charAt(0)==="/"?ke?De:Te.replace(h,"$1")+De:Te+De}var l={exec:function(){}};function n(Te){for(var De=1,ke,oe;De<arguments.length;De++){ke=arguments[De];for(oe in ke)Object.prototype.hasOwnProperty.call(ke,oe)&&(Te[oe]=ke[oe])}return Te}function d(Te,De){var ke=Te.replace(/\|/g,function(Y,I,$){for(var H=!1,j=I;--j>=0&&$[j]==="\\";)H=!H;return H?"|":" |"}),oe=ke.split(/ \|/),ce=0;if(oe[0].trim()||oe.shift(),oe.length>0&&!oe[oe.length-1].trim()&&oe.pop(),oe.length>De)oe.splice(De);else for(;oe.length<De;)oe.push("");for(;ce<oe.length;ce++)oe[ce]=oe[ce].trim().replace(/\\\|/g,"|");return oe}function g(Te,De,ke){var oe=Te.length;if(oe===0)return"";for(var ce=0;ce<oe;){var Y=Te.charAt(oe-ce-1);if(Y===De&&!ke)ce++;else if(Y!==De&&ke)ce++;else break}return Te.slice(0,oe-ce)}function O(Te,De){if(Te.indexOf(De[1])===-1)return-1;for(var ke=Te.length,oe=0,ce=0;ce<ke;ce++)if(Te[ce]==="\\")ce++;else if(Te[ce]===De[0])oe++;else if(Te[ce]===De[1]&&(oe--,oe<0))return ce;return-1}function N(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function q(Te,De){if(De<1)return"";for(var ke="";De>1;)De&1&&(ke+=Te),De>>=1,Te+=Te;return ke+Te}function J(Te,De,ke,oe){var ce=De.href,Y=De.title?f(De.title):null,I=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){oe.state.inLink=!0;var $={type:"link",raw:ke,href:ce,title:Y,text:I,tokens:oe.inlineTokens(I)};return oe.state.inLink=!1,$}return{type:"image",raw:ke,href:ce,title:Y,text:f(I)}}function x(Te,De){var ke=Te.match(/^(\s+)(?:```)/);if(ke===null)return De;var oe=ke[1];return De.split(`
`).map(function(ce){var Y=ce.match(/^\s+/);if(Y===null)return ce;var I=Y[0];return I.length>=oe.length?ce.slice(oe.length):ce}).join(`
`)}var R=function(){function Te(ke){this.options=ke||ee.defaults}var De=Te.prototype;return De.space=function(oe){var ce=this.rules.block.newline.exec(oe);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},De.code=function(oe){var ce=this.rules.block.code.exec(oe);if(ce){var Y=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?Y:g(Y,`
`)}}},De.fences=function(oe){var ce=this.rules.block.fences.exec(oe);if(ce){var Y=ce[0],I=x(Y,ce[3]||"");return{type:"code",raw:Y,lang:ce[2]?ce[2].trim():ce[2],text:I}}},De.heading=function(oe){var ce=this.rules.block.heading.exec(oe);if(ce){var Y=ce[2].trim();if(/#$/.test(Y)){var I=g(Y,"#");(this.options.pedantic||!I||/ $/.test(I))&&(Y=I.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:Y,tokens:this.lexer.inline(Y)}}},De.hr=function(oe){var ce=this.rules.block.hr.exec(oe);if(ce)return{type:"hr",raw:ce[0]}},De.blockquote=function(oe){var ce=this.rules.block.blockquote.exec(oe);if(ce){var Y=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(Y,[]),text:Y}}},De.list=function(oe){var ce=this.rules.block.list.exec(oe);if(ce){var Y,I,$,H,j,Z,de,Se,ae,ve,be,$e,He=ce[1].trim(),tt=He.length>1,xe={type:"list",raw:"",ordered:tt,start:tt?+He.slice(0,-1):"",loose:!1,items:[]};He=tt?"\\d{1,9}\\"+He.slice(-1):"\\"+He,this.options.pedantic&&(He=tt?He:"[*+-]");for(var et=new RegExp("^( {0,3}"+He+")((?:[	 ][^\\n]*)?(?:\\n|$))");oe&&($e=!1,!(!(ce=et.exec(oe))||this.rules.block.hr.test(oe)));){if(Y=ce[0],oe=oe.substring(Y.length),Se=ce[2].split(`
`,1)[0],ae=oe.split(`
`,1)[0],this.options.pedantic?(H=2,be=Se.trimLeft()):(H=ce[2].search(/[^ ]/),H=H>4?1:H,be=Se.slice(H),H+=ce[1].length),Z=!1,!Se&&/^ *$/.test(ae)&&(Y+=ae+`
`,oe=oe.substring(ae.length+1),$e=!0),!$e)for(var it=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),dt=new RegExp("^ {0,"+Math.min(3,H-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Fe=new RegExp("^ {0,"+Math.min(3,H-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,H-1)+"}#");oe&&(ve=oe.split(`
`,1)[0],Se=ve,this.options.pedantic&&(Se=Se.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Fe.test(Se)||st.test(Se)||it.test(Se)||dt.test(oe)));){if(Se.search(/[^ ]/)>=H||!Se.trim())be+=`
`+Se.slice(H);else if(!Z)be+=`
`+Se;else break;!Z&&!Se.trim()&&(Z=!0),Y+=ve+`
`,oe=oe.substring(ve.length+1)}xe.loose||(de?xe.loose=!0:/\n *\n *$/.test(Y)&&(de=!0)),this.options.gfm&&(I=/^\[[ xX]\] /.exec(be),I&&($=I[0]!=="[ ] ",be=be.replace(/^\[[ xX]\] +/,""))),xe.items.push({type:"list_item",raw:Y,task:!!I,checked:$,loose:!1,text:be}),xe.raw+=Y}xe.items[xe.items.length-1].raw=Y.trimRight(),xe.items[xe.items.length-1].text=be.trimRight(),xe.raw=xe.raw.trimRight();var Q=xe.items.length;for(j=0;j<Q;j++){this.lexer.state.top=!1,xe.items[j].tokens=this.lexer.blockTokens(xe.items[j].text,[]);var X=xe.items[j].tokens.filter(function(Ne){return Ne.type==="space"}),pe=X.every(function(Ne){for(var Be=Ne.raw.split(""),je=0,Je=L(Be),nt;!(nt=Je()).done;){var vt=nt.value;if(vt===`
`&&(je+=1),je>1)return!0}return!1});!xe.loose&&X.length&&pe&&(xe.loose=!0,xe.items[j].loose=!0)}return xe}},De.html=function(oe){var ce=this.rules.block.html.exec(oe);if(ce){var Y={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var I=this.options.sanitizer?this.options.sanitizer(ce[0]):f(ce[0]);Y.type="paragraph",Y.text=I,Y.tokens=this.lexer.inline(I)}return Y}},De.def=function(oe){var ce=this.rules.block.def.exec(oe);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var Y=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Y,raw:ce[0],href:ce[2],title:ce[3]}}},De.table=function(oe){var ce=this.rules.block.table.exec(oe);if(ce){var Y={type:"table",header:d(ce[1]).map(function(de){return{text:de}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Y.header.length===Y.align.length){Y.raw=ce[0];var I=Y.align.length,$,H,j,Z;for($=0;$<I;$++)/^ *-+: *$/.test(Y.align[$])?Y.align[$]="right":/^ *:-+: *$/.test(Y.align[$])?Y.align[$]="center":/^ *:-+ *$/.test(Y.align[$])?Y.align[$]="left":Y.align[$]=null;for(I=Y.rows.length,$=0;$<I;$++)Y.rows[$]=d(Y.rows[$],Y.header.length).map(function(de){return{text:de}});for(I=Y.header.length,H=0;H<I;H++)Y.header[H].tokens=this.lexer.inline(Y.header[H].text);for(I=Y.rows.length,H=0;H<I;H++)for(Z=Y.rows[H],j=0;j<Z.length;j++)Z[j].tokens=this.lexer.inline(Z[j].text);return Y}}},De.lheading=function(oe){var ce=this.rules.block.lheading.exec(oe);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},De.paragraph=function(oe){var ce=this.rules.block.paragraph.exec(oe);if(ce){var Y=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:Y,tokens:this.lexer.inline(Y)}}},De.text=function(oe){var ce=this.rules.block.text.exec(oe);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},De.escape=function(oe){var ce=this.rules.inline.escape.exec(oe);if(ce)return{type:"escape",raw:ce[0],text:f(ce[1])}},De.tag=function(oe){var ce=this.rules.inline.tag.exec(oe);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):f(ce[0]):ce[0]}},De.link=function(oe){var ce=this.rules.inline.link.exec(oe);if(ce){var Y=ce[2].trim();if(!this.options.pedantic&&/^</.test(Y)){if(!/>$/.test(Y))return;var I=g(Y.slice(0,-1),"\\");if((Y.length-I.length)%2===0)return}else{var $=O(ce[2],"()");if($>-1){var H=ce[0].indexOf("!")===0?5:4,j=H+ce[1].length+$;ce[2]=ce[2].substring(0,$),ce[0]=ce[0].substring(0,j).trim(),ce[3]=""}}var Z=ce[2],de="";if(this.options.pedantic){var Se=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Z);Se&&(Z=Se[1],de=Se[3])}else de=ce[3]?ce[3].slice(1,-1):"";return Z=Z.trim(),/^</.test(Z)&&(this.options.pedantic&&!/>$/.test(Y)?Z=Z.slice(1):Z=Z.slice(1,-1)),J(ce,{href:Z&&Z.replace(this.rules.inline._escapes,"$1"),title:de&&de.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},De.reflink=function(oe,ce){var Y;if((Y=this.rules.inline.reflink.exec(oe))||(Y=this.rules.inline.nolink.exec(oe))){var I=(Y[2]||Y[1]).replace(/\s+/g," ");if(I=ce[I.toLowerCase()],!I||!I.href){var $=Y[0].charAt(0);return{type:"text",raw:$,text:$}}return J(Y,I,Y[0],this.lexer)}},De.emStrong=function(oe,ce,Y){Y===void 0&&(Y="");var I=this.rules.inline.emStrong.lDelim.exec(oe);if(!!I&&!(I[3]&&Y.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var $=I[1]||I[2]||"";if(!$||$&&(Y===""||this.rules.inline.punctuation.exec(Y))){var H=I[0].length-1,j,Z,de=H,Se=0,ae=I[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ae.lastIndex=0,ce=ce.slice(-1*oe.length+H);(I=ae.exec(ce))!=null;)if(j=I[1]||I[2]||I[3]||I[4]||I[5]||I[6],!!j){if(Z=j.length,I[3]||I[4]){de+=Z;continue}else if((I[5]||I[6])&&H%3&&!((H+Z)%3)){Se+=Z;continue}if(de-=Z,!(de>0)){if(Z=Math.min(Z,Z+de+Se),Math.min(H,Z)%2){var ve=oe.slice(1,H+I.index+Z);return{type:"em",raw:oe.slice(0,H+I.index+Z+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}var be=oe.slice(2,H+I.index+Z-1);return{type:"strong",raw:oe.slice(0,H+I.index+Z+1),text:be,tokens:this.lexer.inlineTokens(be)}}}}}},De.codespan=function(oe){var ce=this.rules.inline.code.exec(oe);if(ce){var Y=ce[2].replace(/\n/g," "),I=/[^ ]/.test(Y),$=/^ /.test(Y)&&/ $/.test(Y);return I&&$&&(Y=Y.substring(1,Y.length-1)),Y=f(Y,!0),{type:"codespan",raw:ce[0],text:Y}}},De.br=function(oe){var ce=this.rules.inline.br.exec(oe);if(ce)return{type:"br",raw:ce[0]}},De.del=function(oe){var ce=this.rules.inline.del.exec(oe);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},De.autolink=function(oe,ce){var Y=this.rules.inline.autolink.exec(oe);if(Y){var I,$;return Y[2]==="@"?(I=f(this.options.mangle?ce(Y[1]):Y[1]),$="mailto:"+I):(I=f(Y[1]),$=I),{type:"link",raw:Y[0],text:I,href:$,tokens:[{type:"text",raw:I,text:I}]}}},De.url=function(oe,ce){var Y;if(Y=this.rules.inline.url.exec(oe)){var I,$;if(Y[2]==="@")I=f(this.options.mangle?ce(Y[0]):Y[0]),$="mailto:"+I;else{var H;do H=Y[0],Y[0]=this.rules.inline._backpedal.exec(Y[0])[0];while(H!==Y[0]);I=f(Y[0]),Y[1]==="www."?$="http://"+I:$=I}return{type:"link",raw:Y[0],text:I,href:$,tokens:[{type:"text",raw:I,text:I}]}}},De.inlineText=function(oe,ce){var Y=this.rules.inline.text.exec(oe);if(Y){var I;return this.lexer.state.inRawBlock?I=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):f(Y[0]):Y[0]:I=f(this.options.smartypants?ce(Y[0]):Y[0]),{type:"text",raw:Y[0],text:I}}},Te}(),P={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};P._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,P._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,P.def=p(P.def).replace("label",P._label).replace("title",P._title).getRegex(),P.bullet=/(?:[*+-]|\d{1,9}[.)])/,P.listItemStart=p(/^( *)(bull) */).replace("bull",P.bullet).getRegex(),P.list=p(P.list).replace(/bull/g,P.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+P.def.source+")").getRegex(),P._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",P._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,P.html=p(P.html,"i").replace("comment",P._comment).replace("tag",P._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),P.paragraph=p(P._paragraph).replace("hr",P.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",P._tag).getRegex(),P.blockquote=p(P.blockquote).replace("paragraph",P.paragraph).getRegex(),P.normal=n({},P),P.gfm=n({},P.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),P.gfm.table=p(P.gfm.table).replace("hr",P.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",P._tag).getRegex(),P.gfm.paragraph=p(P._paragraph).replace("hr",P.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",P.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",P._tag).getRegex(),P.pedantic=n({},P.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",P._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:p(P.normal._paragraph).replace("hr",P.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",P.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=p(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=p(P._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=p(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=p(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=p(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=p(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=p(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=p(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=p(F.reflink).replace("label",F._label).replace("ref",P._label).getRegex(),F.nolink=p(F.nolink).replace("ref",P._label).getRegex(),F.reflinkSearch=p(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=n({},F),F.pedantic=n({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=n({},F.normal,{escape:p(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=p(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=n({},F.gfm,{br:p(F.br).replace("{2,}","*").getRegex(),text:p(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function B(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(Te){var De="",ke,oe,ce=Te.length;for(ke=0;ke<ce;ke++)oe=Te.charCodeAt(ke),Math.random()>.5&&(oe="x"+oe.toString(16)),De+="&#"+oe+";";return De}var V=function(){function Te(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||ee.defaults,this.options.tokenizer=this.options.tokenizer||new R,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:P.normal,inline:F.normal};this.options.pedantic?(oe.block=P.pedantic,oe.inline=F.pedantic):this.options.gfm&&(oe.block=P.gfm,this.options.breaks?oe.inline=F.breaks:oe.inline=F.gfm),this.tokenizer.rules=oe}Te.lex=function(oe,ce){var Y=new Te(ce);return Y.lex(oe)},Te.lexInline=function(oe,ce){var Y=new Te(ce);return Y.inlineTokens(oe)};var De=Te.prototype;return De.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`),this.blockTokens(oe,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},De.blockTokens=function(oe,ce){var Y=this;ce===void 0&&(ce=[]),this.options.pedantic?oe=oe.replace(/\t/g,"    ").replace(/^ +$/gm,""):oe=oe.replace(/^( *)(\t+)/gm,function(de,Se,ae){return Se+"    ".repeat(ae.length)});for(var I,$,H,j;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(de){return(I=de.call({lexer:Y},oe,ce))?(oe=oe.substring(I.raw.length),ce.push(I),!0):!1}))){if(I=this.tokenizer.space(oe)){oe=oe.substring(I.raw.length),I.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(I);continue}if(I=this.tokenizer.code(oe)){oe=oe.substring(I.raw.length),$=ce[ce.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue[this.inlineQueue.length-1].src=$.text):ce.push(I);continue}if(I=this.tokenizer.fences(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.heading(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.hr(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.blockquote(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.list(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.html(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.def(oe)){oe=oe.substring(I.raw.length),$=ce[ce.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+I.raw,$.text+=`
`+I.raw,this.inlineQueue[this.inlineQueue.length-1].src=$.text):this.tokens.links[I.tag]||(this.tokens.links[I.tag]={href:I.href,title:I.title});continue}if(I=this.tokenizer.table(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.lheading(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(H=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var de=1/0,Se=oe.slice(1),ae=void 0;Y.options.extensions.startBlock.forEach(function(ve){ae=ve.call({lexer:this},Se),typeof ae=="number"&&ae>=0&&(de=Math.min(de,ae))}),de<1/0&&de>=0&&(H=oe.substring(0,de+1))}(),this.state.top&&(I=this.tokenizer.paragraph(H))){$=ce[ce.length-1],j&&$.type==="paragraph"?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):ce.push(I),j=H.length!==oe.length,oe=oe.substring(I.raw.length);continue}if(I=this.tokenizer.text(oe)){oe=oe.substring(I.raw.length),$=ce[ce.length-1],$&&$.type==="text"?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):ce.push(I);continue}if(oe){var Z="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(Z);break}else throw new Error(Z)}}return this.state.top=!0,ce},De.inline=function(oe,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:oe,tokens:ce}),ce},De.inlineTokens=function(oe,ce){var Y=this;ce===void 0&&(ce=[]);var I,$,H,j=oe,Z,de,Se;if(this.tokens.links){var ae=Object.keys(this.tokens.links);if(ae.length>0)for(;(Z=this.tokenizer.rules.inline.reflinkSearch.exec(j))!=null;)ae.includes(Z[0].slice(Z[0].lastIndexOf("[")+1,-1))&&(j=j.slice(0,Z.index)+"["+q("a",Z[0].length-2)+"]"+j.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Z=this.tokenizer.rules.inline.blockSkip.exec(j))!=null;)j=j.slice(0,Z.index)+"["+q("a",Z[0].length-2)+"]"+j.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Z=this.tokenizer.rules.inline.escapedEmSt.exec(j))!=null;)j=j.slice(0,Z.index)+"++"+j.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(de||(Se=""),de=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(be){return(I=be.call({lexer:Y},oe,ce))?(oe=oe.substring(I.raw.length),ce.push(I),!0):!1}))){if(I=this.tokenizer.escape(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.tag(oe)){oe=oe.substring(I.raw.length),$=ce[ce.length-1],$&&I.type==="text"&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):ce.push(I);continue}if(I=this.tokenizer.link(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(I.raw.length),$=ce[ce.length-1],$&&I.type==="text"&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):ce.push(I);continue}if(I=this.tokenizer.emStrong(oe,j,Se)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.codespan(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.br(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.del(oe)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(I=this.tokenizer.autolink(oe,z)){oe=oe.substring(I.raw.length),ce.push(I);continue}if(!this.state.inLink&&(I=this.tokenizer.url(oe,z))){oe=oe.substring(I.raw.length),ce.push(I);continue}if(H=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var be=1/0,$e=oe.slice(1),He=void 0;Y.options.extensions.startInline.forEach(function(tt){He=tt.call({lexer:this},$e),typeof He=="number"&&He>=0&&(be=Math.min(be,He))}),be<1/0&&be>=0&&(H=oe.substring(0,be+1))}(),I=this.tokenizer.inlineText(H,B)){oe=oe.substring(I.raw.length),I.raw.slice(-1)!=="_"&&(Se=I.raw.slice(-1)),de=!0,$=ce[ce.length-1],$&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):ce.push(I);continue}if(oe){var ve="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(ve);break}else throw new Error(ve)}}return ce},i(Te,null,[{key:"rules",get:function(){return{block:P,inline:F}}}]),Te}(),K=function(){function Te(ke){this.options=ke||ee.defaults}var De=Te.prototype;return De.code=function(oe,ce,Y){var I=(ce||"").match(/\S*/)[0];if(this.options.highlight){var $=this.options.highlight(oe,I);$!=null&&$!==oe&&(Y=!0,oe=$)}return oe=oe.replace(/\n$/,"")+`
`,I?'<pre><code class="'+this.options.langPrefix+f(I,!0)+'">'+(Y?oe:f(oe,!0))+`</code></pre>
`:"<pre><code>"+(Y?oe:f(oe,!0))+`</code></pre>
`},De.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},De.html=function(oe){return oe},De.heading=function(oe,ce,Y,I){if(this.options.headerIds){var $=this.options.headerPrefix+I.slug(Y);return"<h"+ce+' id="'+$+'">'+oe+"</h"+ce+`>
`}return"<h"+ce+">"+oe+"</h"+ce+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(oe,ce,Y){var I=ce?"ol":"ul",$=ce&&Y!==1?' start="'+Y+'"':"";return"<"+I+$+`>
`+oe+"</"+I+`>
`},De.listitem=function(oe){return"<li>"+oe+`</li>
`},De.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(oe){return"<p>"+oe+`</p>
`},De.table=function(oe,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+ce+`</table>
`},De.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},De.tablecell=function(oe,ce){var Y=ce.header?"th":"td",I=ce.align?"<"+Y+' align="'+ce.align+'">':"<"+Y+">";return I+oe+("</"+Y+`>
`)},De.strong=function(oe){return"<strong>"+oe+"</strong>"},De.em=function(oe){return"<em>"+oe+"</em>"},De.codespan=function(oe){return"<code>"+oe+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(oe){return"<del>"+oe+"</del>"},De.link=function(oe,ce,Y){if(oe=w(this.options.sanitize,this.options.baseUrl,oe),oe===null)return Y;var I='<a href="'+f(oe)+'"';return ce&&(I+=' title="'+ce+'"'),I+=">"+Y+"</a>",I},De.image=function(oe,ce,Y){if(oe=w(this.options.sanitize,this.options.baseUrl,oe),oe===null)return Y;var I='<img src="'+oe+'" alt="'+Y+'"';return ce&&(I+=' title="'+ce+'"'),I+=this.options.xhtml?"/>":">",I},De.text=function(oe){return oe},Te}(),ie=function(){function Te(){}var De=Te.prototype;return De.strong=function(oe){return oe},De.em=function(oe){return oe},De.codespan=function(oe){return oe},De.del=function(oe){return oe},De.html=function(oe){return oe},De.text=function(oe){return oe},De.link=function(oe,ce,Y){return""+Y},De.image=function(oe,ce,Y){return""+Y},De.br=function(){return""},Te}(),ge=function(){function Te(){this.seen={}}var De=Te.prototype;return De.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(oe,ce){var Y=oe,I=0;if(this.seen.hasOwnProperty(Y)){I=this.seen[oe];do I++,Y=oe+"-"+I;while(this.seen.hasOwnProperty(Y))}return ce||(this.seen[oe]=I,this.seen[Y]=0),Y},De.slug=function(oe,ce){ce===void 0&&(ce={});var Y=this.serialize(oe);return this.getNextSafeSlug(Y,ce.dryrun)},Te}(),ue=function(){function Te(ke){this.options=ke||ee.defaults,this.options.renderer=this.options.renderer||new K,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ie,this.slugger=new ge}Te.parse=function(oe,ce){var Y=new Te(ce);return Y.parse(oe)},Te.parseInline=function(oe,ce){var Y=new Te(ce);return Y.parseInline(oe)};var De=Te.prototype;return De.parse=function(oe,ce){ce===void 0&&(ce=!0);var Y="",I,$,H,j,Z,de,Se,ae,ve,be,$e,He,tt,xe,et,it,dt,Fe,st,Q=oe.length;for(I=0;I<Q;I++){if(be=oe[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(st=this.options.extensions.renderers[be.type].call({parser:this},be),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(be.type))){Y+=st||"";continue}switch(be.type){case"space":continue;case"hr":{Y+=this.renderer.hr();continue}case"heading":{Y+=this.renderer.heading(this.parseInline(be.tokens),be.depth,c(this.parseInline(be.tokens,this.textRenderer)),this.slugger);continue}case"code":{Y+=this.renderer.code(be.text,be.lang,be.escaped);continue}case"table":{for(ae="",Se="",j=be.header.length,$=0;$<j;$++)Se+=this.renderer.tablecell(this.parseInline(be.header[$].tokens),{header:!0,align:be.align[$]});for(ae+=this.renderer.tablerow(Se),ve="",j=be.rows.length,$=0;$<j;$++){for(de=be.rows[$],Se="",Z=de.length,H=0;H<Z;H++)Se+=this.renderer.tablecell(this.parseInline(de[H].tokens),{header:!1,align:be.align[H]});ve+=this.renderer.tablerow(Se)}Y+=this.renderer.table(ae,ve);continue}case"blockquote":{ve=this.parse(be.tokens),Y+=this.renderer.blockquote(ve);continue}case"list":{for($e=be.ordered,He=be.start,tt=be.loose,j=be.items.length,ve="",$=0;$<j;$++)et=be.items[$],it=et.checked,dt=et.task,xe="",et.task&&(Fe=this.renderer.checkbox(it),tt?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=Fe+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=Fe+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:Fe}):xe+=Fe),xe+=this.parse(et.tokens,tt),ve+=this.renderer.listitem(xe,dt,it);Y+=this.renderer.list(ve,$e,He);continue}case"html":{Y+=this.renderer.html(be.text);continue}case"paragraph":{Y+=this.renderer.paragraph(this.parseInline(be.tokens));continue}case"text":{for(ve=be.tokens?this.parseInline(be.tokens):be.text;I+1<Q&&oe[I+1].type==="text";)be=oe[++I],ve+=`
`+(be.tokens?this.parseInline(be.tokens):be.text);Y+=ce?this.renderer.paragraph(ve):ve;continue}default:{var X='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(X);return}else throw new Error(X)}}}return Y},De.parseInline=function(oe,ce){ce=ce||this.renderer;var Y="",I,$,H,j=oe.length;for(I=0;I<j;I++){if($=oe[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[$.type]&&(H=this.options.extensions.renderers[$.type].call({parser:this},$),H!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes($.type))){Y+=H||"";continue}switch($.type){case"escape":{Y+=ce.text($.text);break}case"html":{Y+=ce.html($.text);break}case"link":{Y+=ce.link($.href,$.title,this.parseInline($.tokens,ce));break}case"image":{Y+=ce.image($.href,$.title,$.text);break}case"strong":{Y+=ce.strong(this.parseInline($.tokens,ce));break}case"em":{Y+=ce.em(this.parseInline($.tokens,ce));break}case"codespan":{Y+=ce.codespan($.text);break}case"br":{Y+=ce.br();break}case"del":{Y+=ce.del(this.parseInline($.tokens,ce));break}case"text":{Y+=ce.text($.text);break}default:{var Z='Token with "'+$.type+'" type was not found.';if(this.options.silent){console.error(Z);return}else throw new Error(Z)}}}return Y},Te}();function re(Te,De,ke){if(typeof Te>"u"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof De=="function"&&(ke=De,De=null),De=n({},re.defaults,De||{}),N(De),ke){var oe=De.highlight,ce;try{ce=V.lex(Te,De)}catch(j){return ke(j)}var Y=function(Z){var de;if(!Z)try{De.walkTokens&&re.walkTokens(ce,De.walkTokens),de=ue.parse(ce,De)}catch(Se){Z=Se}return De.highlight=oe,Z?ke(Z):ke(null,de)};if(!oe||oe.length<3||(delete De.highlight,!ce.length))return Y();var I=0;re.walkTokens(ce,function(j){j.type==="code"&&(I++,setTimeout(function(){oe(j.text,j.lang,function(Z,de){if(Z)return Y(Z);de!=null&&de!==j.text&&(j.text=de,j.escaped=!0),I--,I===0&&Y()})},0))}),I===0&&Y();return}function $(j){if(j.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+f(j.message+"",!0)+"</pre>";throw j}try{var H=V.lex(Te,De);if(De.walkTokens){if(De.async)return Promise.all(re.walkTokens(H,De.walkTokens)).then(function(){return ue.parse(H,De)}).catch($);re.walkTokens(H,De.walkTokens)}return ue.parse(H,De)}catch(j){$(j)}}re.options=re.setOptions=function(Te){return n(re.defaults,Te),A(re.defaults),re},re.getDefaults=C,re.defaults=ee.defaults,re.use=function(){for(var Te=arguments.length,De=new Array(Te),ke=0;ke<Te;ke++)De[ke]=arguments[ke];var oe=n.apply(void 0,[{}].concat(De)),ce=re.defaults.extensions||{renderers:{},childTokens:{}},Y;De.forEach(function(I){if(I.extensions&&(Y=!0,I.extensions.forEach(function(H){if(!H.name)throw new Error("extension name required");if(H.renderer){var j=ce.renderers?ce.renderers[H.name]:null;j?ce.renderers[H.name]=function(){for(var Z=arguments.length,de=new Array(Z),Se=0;Se<Z;Se++)de[Se]=arguments[Se];var ae=H.renderer.apply(this,de);return ae===!1&&(ae=j.apply(this,de)),ae}:ce.renderers[H.name]=H.renderer}if(H.tokenizer){if(!H.level||H.level!=="block"&&H.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[H.level]?ce[H.level].unshift(H.tokenizer):ce[H.level]=[H.tokenizer],H.start&&(H.level==="block"?ce.startBlock?ce.startBlock.push(H.start):ce.startBlock=[H.start]:H.level==="inline"&&(ce.startInline?ce.startInline.push(H.start):ce.startInline=[H.start]))}H.childTokens&&(ce.childTokens[H.name]=H.childTokens)})),I.renderer&&function(){var H=re.defaults.renderer||new K,j=function(Se){var ae=H[Se];H[Se]=function(){for(var ve=arguments.length,be=new Array(ve),$e=0;$e<ve;$e++)be[$e]=arguments[$e];var He=I.renderer[Se].apply(H,be);return He===!1&&(He=ae.apply(H,be)),He}};for(var Z in I.renderer)j(Z);oe.renderer=H}(),I.tokenizer&&function(){var H=re.defaults.tokenizer||new R,j=function(Se){var ae=H[Se];H[Se]=function(){for(var ve=arguments.length,be=new Array(ve),$e=0;$e<ve;$e++)be[$e]=arguments[$e];var He=I.tokenizer[Se].apply(H,be);return He===!1&&(He=ae.apply(H,be)),He}};for(var Z in I.tokenizer)j(Z);oe.tokenizer=H}(),I.walkTokens){var $=re.defaults.walkTokens;oe.walkTokens=function(H){var j=[];return j.push(I.walkTokens.call(this,H)),$&&(j=j.concat($.call(this,H))),j}}Y&&(oe.extensions=ce),re.setOptions(oe)})},re.walkTokens=function(Te,De){for(var ke=[],oe=function(){var $=Y.value;switch(ke=ke.concat(De.call(re,$)),$.type){case"table":{for(var H=L($.header),j;!(j=H()).done;){var Z=j.value;ke=ke.concat(re.walkTokens(Z.tokens,De))}for(var de=L($.rows),Se;!(Se=de()).done;)for(var ae=Se.value,ve=L(ae),be;!(be=ve()).done;){var $e=be.value;ke=ke.concat(re.walkTokens($e.tokens,De))}break}case"list":{ke=ke.concat(re.walkTokens($.items,De));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[$.type]?re.defaults.extensions.childTokens[$.type].forEach(function(He){ke=ke.concat(re.walkTokens($[He],De))}):$.tokens&&(ke=ke.concat(re.walkTokens($.tokens,De)))}},ce=L(Te),Y;!(Y=ce()).done;)oe();return ke},re.parseInline=function(Te,De){if(typeof Te>"u"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");De=n({},re.defaults,De||{}),N(De);try{var ke=V.lexInline(Te,De);return De.walkTokens&&re.walkTokens(ke,De.walkTokens),ue.parseInline(ke,De)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+f(oe.message+"",!0)+"</pre>";throw oe}},re.Parser=ue,re.parser=ue.parse,re.Renderer=K,re.TextRenderer=ie,re.Lexer=V,re.lexer=V.lex,re.Tokenizer=R,re.Slugger=ge,re.parse=re;var se=re.options,le=re.setOptions,_=re.use,me=re.walkTokens,we=re.parseInline,Me=re,We=ue.parse,Qe=V.lex;ee.Lexer=V,ee.Parser=ue,ee.Renderer=K,ee.Slugger=ge,ee.TextRenderer=ie,ee.Tokenizer=R,ee.getDefaults=C,ee.lexer=Qe,ee.marked=re,ee.options=se,ee.parse=Me,ee.parseInline=we,ee.parser=We,ee.setOptions=le,ee.use=_,ee.walkTokens=me,Object.defineProperty(ee,"__esModule",{value:!0})}),define(Ie[111],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function i(A,S,k){return Math.min(Math.max(A,S),k)}e.clamp=i;function T(A,S){return(S+A%S)%S}e.rot=T;class y{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=y;class L{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=L;class C{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const k=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=C}),function(){function ee(y){const L=[];typeof y=="number"&&L.push("code/timeOrigin",y);function C(S){L.push(S,Date.now())}function A(){const S=[];for(let k=0;k<L.length;k+=2)S.push({name:L[k],startTime:L[k+1]});return S}return{mark:C,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const C of performance.getEntriesByType("mark"))L.push({name:C.name,startTime:Math.round(y+C.startTime)});return L}};if(typeof process=="object"){const y=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function i(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=i(T))}(),function(ee,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var T in i)(typeof exports=="object"?exports:ee)[T]=i[T]}}(typeof self<"u"?self:this,function(){return function(ee){var e={};function i(T){if(e[T])return e[T].exports;var y=e[T]={i:T,l:!1,exports:{}};return ee[T].call(y.exports,y,y.exports,i),y.l=!0,y.exports}return i.m=ee,i.c=e,i.d=function(T,y,L){i.o(T,y)||Object.defineProperty(T,y,{enumerable:!0,get:L})},i.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},i.t=function(T,y){if(1&y&&(T=i(T)),8&y||4&y&&typeof T=="object"&&T&&T.__esModule)return T;var L=Object.create(null);if(i.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:T}),2&y&&typeof T!="string")for(var C in T)i.d(L,C,function(A){return T[A]}.bind(null,C));return L},i.n=function(T){var y=T&&T.__esModule?function(){return T.default}:function(){return T};return i.d(y,"a",y),y},i.o=function(T,y){return Object.prototype.hasOwnProperty.call(T,y)},i.p="",i(i.s=0)}([function(ee,e,i){(function(T){var y;e=ee.exports=_,y=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],S=e.src=[],k=0,M=k++;S[M]="0|[1-9]\\d*";var D=k++;S[D]="[0-9]+";var m=k++;S[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=k++;S[b]="("+S[M]+")\\.("+S[M]+")\\.("+S[M]+")";var f=k++;S[f]="("+S[D]+")\\.("+S[D]+")\\.("+S[D]+")";var t=k++;S[t]="(?:"+S[M]+"|"+S[m]+")";var c=k++;S[c]="(?:"+S[D]+"|"+S[m]+")";var u=k++;S[u]="(?:-("+S[t]+"(?:\\."+S[t]+")*))";var p=k++;S[p]="(?:-?("+S[c]+"(?:\\."+S[c]+")*))";var E=k++;S[E]="[0-9A-Za-z-]+";var v=k++;S[v]="(?:\\+("+S[E]+"(?:\\."+S[E]+")*))";var w=k++,s="v?"+S[b]+S[u]+"?"+S[v]+"?";S[w]="^"+s+"$";var r="[v=\\s]*"+S[f]+S[p]+"?"+S[v]+"?",o=k++;S[o]="^"+r+"$";var h=k++;S[h]="((?:<|>)?=?)";var a=k++;S[a]=S[D]+"|x|X|\\*";var l=k++;S[l]=S[M]+"|x|X|\\*";var n=k++;S[n]="[v=\\s]*("+S[l]+")(?:\\.("+S[l]+")(?:\\.("+S[l]+")(?:"+S[u]+")?"+S[v]+"?)?)?";var d=k++;S[d]="[v=\\s]*("+S[a]+")(?:\\.("+S[a]+")(?:\\.("+S[a]+")(?:"+S[p]+")?"+S[v]+"?)?)?";var g=k++;S[g]="^"+S[h]+"\\s*"+S[n]+"$";var O=k++;S[O]="^"+S[h]+"\\s*"+S[d]+"$";var N=k++;S[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var q=k++;S[q]="(?:~>?)";var J=k++;S[J]="(\\s*)"+S[q]+"\\s+",A[J]=new RegExp(S[J],"g");var x=k++;S[x]="^"+S[q]+S[n]+"$";var R=k++;S[R]="^"+S[q]+S[d]+"$";var P=k++;S[P]="(?:\\^)";var F=k++;S[F]="(\\s*)"+S[P]+"\\s+",A[F]=new RegExp(S[F],"g");var B=k++;S[B]="^"+S[P]+S[n]+"$";var z=k++;S[z]="^"+S[P]+S[d]+"$";var V=k++;S[V]="^"+S[h]+"\\s*("+r+")$|^$";var K=k++;S[K]="^"+S[h]+"\\s*("+s+")$|^$";var ie=k++;S[ie]="(\\s*)"+S[h]+"\\s*("+r+"|"+S[n]+")",A[ie]=new RegExp(S[ie],"g");var ge=k++;S[ge]="^\\s*("+S[n]+")\\s+-\\s+("+S[n]+")\\s*$";var ue=k++;S[ue]="^\\s*("+S[d]+")\\s+-\\s+("+S[d]+")\\s*$";var re=k++;S[re]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)y(se,S[se]),A[se]||(A[se]=new RegExp(S[se]));function le(ae,ve){if(ae instanceof _)return ae;if(typeof ae!="string"||ae.length>L||!(ve?A[o]:A[w]).test(ae))return null;try{return new _(ae,ve)}catch{return null}}function _(ae,ve){if(ae instanceof _){if(ae.loose===ve)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof _))return new _(ae,ve);y("SemVer",ae,ve),this.loose=ve;var be=ae.trim().match(ve?A[o]:A[w]);if(!be)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var He=+$e;if(He>=0&&He<C)return He}return $e}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=le,e.valid=function(ae,ve){var be=le(ae,ve);return be?be.version:null},e.clean=function(ae,ve){var be=le(ae.trim().replace(/^[=v]+/,""),ve);return be?be.version:null},e.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(ae){return y("SemVer.compare",this.version,this.loose,ae),ae instanceof _||(ae=new _(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},_.prototype.compareMain=function(ae){return ae instanceof _||(ae=new _(ae,this.loose)),we(this.major,ae.major)||we(this.minor,ae.minor)||we(this.patch,ae.patch)},_.prototype.comparePre=function(ae){if(ae instanceof _||(ae=new _(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var ve=0;do{var be=this.prerelease[ve],$e=ae.prerelease[ve];if(y("prerelease compare",ve,be,$e),be===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(be===void 0)return-1;if(be!==$e)return we(be,$e)}while(++ve)},_.prototype.inc=function(ae,ve){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ve);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ve);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ve),this.inc("pre",ve);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ve),this.inc("pre",ve);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ve&&(this.prerelease[0]===ve?isNaN(this.prerelease[1])&&(this.prerelease=[ve,0]):this.prerelease=[ve,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,ve,be,$e){typeof be=="string"&&($e=be,be=void 0);try{return new _(ae,be).inc(ve,$e).version}catch{return null}},e.diff=function(ae,ve){if(Te(ae,ve))return null;var be=le(ae),$e=le(ve);if(be.prerelease.length||$e.prerelease.length){for(var He in be)if((He==="major"||He==="minor"||He==="patch")&&be[He]!==$e[He])return"pre"+He;return"prerelease"}for(var He in be)if((He==="major"||He==="minor"||He==="patch")&&be[He]!==$e[He])return He},e.compareIdentifiers=we;var me=/^[0-9]+$/;function we(ae,ve){var be=me.test(ae),$e=me.test(ve);return be&&$e&&(ae=+ae,ve=+ve),be&&!$e?-1:$e&&!be?1:ae<ve?-1:ae>ve?1:0}function Me(ae,ve,be){return new _(ae,be).compare(new _(ve,be))}function We(ae,ve,be){return Me(ae,ve,be)>0}function Qe(ae,ve,be){return Me(ae,ve,be)<0}function Te(ae,ve,be){return Me(ae,ve,be)===0}function De(ae,ve,be){return Me(ae,ve,be)!==0}function ke(ae,ve,be){return Me(ae,ve,be)>=0}function oe(ae,ve,be){return Me(ae,ve,be)<=0}function ce(ae,ve,be,$e){var He;switch(ve){case"===":typeof ae=="object"&&(ae=ae.version),typeof be=="object"&&(be=be.version),He=ae===be;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof be=="object"&&(be=be.version),He=ae!==be;break;case"":case"=":case"==":He=Te(ae,be,$e);break;case"!=":He=De(ae,be,$e);break;case">":He=We(ae,be,$e);break;case">=":He=ke(ae,be,$e);break;case"<":He=Qe(ae,be,$e);break;case"<=":He=oe(ae,be,$e);break;default:throw new TypeError("Invalid operator: "+ve)}return He}function Y(ae,ve){if(ae instanceof Y){if(ae.loose===ve)return ae;ae=ae.value}if(!(this instanceof Y))return new Y(ae,ve);y("comparator",ae,ve),this.loose=ve,this.parse(ae),this.semver===I?this.value="":this.value=this.operator+this.semver.version,y("comp",this)}e.rcompareIdentifiers=function(ae,ve){return we(ve,ae)},e.major=function(ae,ve){return new _(ae,ve).major},e.minor=function(ae,ve){return new _(ae,ve).minor},e.patch=function(ae,ve){return new _(ae,ve).patch},e.compare=Me,e.compareLoose=function(ae,ve){return Me(ae,ve,!0)},e.rcompare=function(ae,ve,be){return Me(ve,ae,be)},e.sort=function(ae,ve){return ae.sort(function(be,$e){return e.compare(be,$e,ve)})},e.rsort=function(ae,ve){return ae.sort(function(be,$e){return e.rcompare(be,$e,ve)})},e.gt=We,e.lt=Qe,e.eq=Te,e.neq=De,e.gte=ke,e.lte=oe,e.cmp=ce,e.Comparator=Y;var I={};function $(ae,ve){if(ae instanceof $)return ae.loose===ve?ae:new $(ae.raw,ve);if(ae instanceof Y)return new $(ae.value,ve);if(!(this instanceof $))return new $(ae,ve);if(this.loose=ve,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function H(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function j(ae,ve,be,$e,He,tt,xe,et,it,dt,Fe,st,Q){return((ve=H(be)?"":H($e)?">="+be+".0.0":H(He)?">="+be+"."+$e+".0":">="+ve)+" "+(et=H(it)?"":H(dt)?"<"+(+it+1)+".0.0":H(Fe)?"<"+it+"."+(+dt+1)+".0":st?"<="+it+"."+dt+"."+Fe+"-"+st:"<="+et)).trim()}function Z(ae,ve){for(var be=0;be<ae.length;be++)if(!ae[be].test(ve))return!1;if(ve.prerelease.length){for(be=0;be<ae.length;be++)if(y(ae[be].semver),ae[be].semver!==I&&ae[be].semver.prerelease.length>0){var $e=ae[be].semver;if($e.major===ve.major&&$e.minor===ve.minor&&$e.patch===ve.patch)return!0}return!1}return!0}function de(ae,ve,be){try{ve=new $(ve,be)}catch{return!1}return ve.test(ae)}function Se(ae,ve,be,$e){var He,tt,xe,et,it;switch(ae=new _(ae,$e),ve=new $(ve,$e),be){case">":He=We,tt=oe,xe=Qe,et=">",it=">=";break;case"<":He=Qe,tt=ke,xe=We,et="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(de(ae,ve,$e))return!1;for(var dt=0;dt<ve.set.length;++dt){var Fe=ve.set[dt],st=null,Q=null;if(Fe.forEach(function(X){X.semver===I&&(X=new Y(">=0.0.0")),st=st||X,Q=Q||X,He(X.semver,st.semver,$e)?st=X:xe(X.semver,Q.semver,$e)&&(Q=X)}),st.operator===et||st.operator===it||(!Q.operator||Q.operator===et)&&tt(ae,Q.semver)||Q.operator===it&&xe(ae,Q.semver))return!1}return!0}Y.prototype.parse=function(ae){var ve=this.loose?A[V]:A[K],be=ae.match(ve);if(!be)throw new TypeError("Invalid comparator: "+ae);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new _(be[2],this.loose):this.semver=I},Y.prototype.toString=function(){return this.value},Y.prototype.test=function(ae){return y("Comparator.test",ae,this.loose),this.semver===I||(typeof ae=="string"&&(ae=new _(ae,this.loose)),ce(ae,this.operator,this.semver,this.loose))},Y.prototype.intersects=function(ae,ve){if(!(ae instanceof Y))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new $(ae.value,ve),de(this.value,be,ve);if(ae.operator==="")return be=new $(this.value,ve),de(ae.semver,be,ve);var $e=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),He=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),tt=this.semver.version===ae.semver.version,xe=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),et=ce(this.semver,"<",ae.semver,ve)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),it=ce(this.semver,">",ae.semver,ve)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return $e||He||tt&&xe||et||it},e.Range=$,$.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},$.prototype.toString=function(){return this.range},$.prototype.parseRange=function(ae){var ve=this.loose;ae=ae.trim(),y("range",ae,ve);var be=ve?A[ue]:A[ge];ae=ae.replace(be,j),y("hyphen replace",ae),ae=ae.replace(A[ie],"$1$2$3"),y("comparator trim",ae,A[ie]),ae=(ae=(ae=ae.replace(A[J],"$1~")).replace(A[F],"$1^")).split(/\s+/).join(" ");var $e=ve?A[V]:A[K],He=ae.split(" ").map(function(tt){return function(xe,et){return y("comp",xe),xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(st,Q){y("caret",st,Q);var X=Q?A[z]:A[B];return st.replace(X,function(pe,Ne,Be,je,Je){var nt;return y("caret",st,pe,Ne,Be,je,Je),H(Ne)?nt="":H(Be)?nt=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":H(je)?nt=Ne==="0"?">="+Ne+"."+Be+".0 <"+Ne+"."+(+Be+1)+".0":">="+Ne+"."+Be+".0 <"+(+Ne+1)+".0.0":Je?(y("replaceCaret pr",Je),Je.charAt(0)!=="-"&&(Je="-"+Je),nt=Ne==="0"?Be==="0"?">="+Ne+"."+Be+"."+je+Je+" <"+Ne+"."+Be+"."+(+je+1):">="+Ne+"."+Be+"."+je+Je+" <"+Ne+"."+(+Be+1)+".0":">="+Ne+"."+Be+"."+je+Je+" <"+(+Ne+1)+".0.0"):(y("no pr"),nt=Ne==="0"?Be==="0"?">="+Ne+"."+Be+"."+je+" <"+Ne+"."+Be+"."+(+je+1):">="+Ne+"."+Be+"."+je+" <"+Ne+"."+(+Be+1)+".0":">="+Ne+"."+Be+"."+je+" <"+(+Ne+1)+".0.0"),y("caret return",nt),nt})}(Fe,dt)}).join(" ")}(xe,et),y("caret",xe),xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(st,Q){var X=Q?A[R]:A[x];return st.replace(X,function(pe,Ne,Be,je,Je){var nt;return y("tilde",st,pe,Ne,Be,je,Je),H(Ne)?nt="":H(Be)?nt=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":H(je)?nt=">="+Ne+"."+Be+".0 <"+Ne+"."+(+Be+1)+".0":Je?(y("replaceTilde pr",Je),Je.charAt(0)!=="-"&&(Je="-"+Je),nt=">="+Ne+"."+Be+"."+je+Je+" <"+Ne+"."+(+Be+1)+".0"):nt=">="+Ne+"."+Be+"."+je+" <"+Ne+"."+(+Be+1)+".0",y("tilde return",nt),nt})}(Fe,dt)}).join(" ")}(xe,et),y("tildes",xe),xe=function(it,dt){return y("replaceXRanges",it,dt),it.split(/\s+/).map(function(Fe){return function(st,Q){st=st.trim();var X=Q?A[O]:A[g];return st.replace(X,function(pe,Ne,Be,je,Je,nt){y("xRange",st,pe,Ne,Be,je,Je,nt);var vt=H(Be),wt=vt||H(je),Tt=wt||H(Je);return Ne==="="&&Tt&&(Ne=""),vt?pe=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&Tt?(wt&&(je=0),Tt&&(Je=0),Ne===">"?(Ne=">=",wt?(Be=+Be+1,je=0,Je=0):Tt&&(je=+je+1,Je=0)):Ne==="<="&&(Ne="<",wt?Be=+Be+1:je=+je+1),pe=Ne+Be+"."+je+"."+Je):wt?pe=">="+Be+".0.0 <"+(+Be+1)+".0.0":Tt&&(pe=">="+Be+"."+je+".0 <"+Be+"."+(+je+1)+".0"),y("xRange return",pe),pe})}(Fe,dt)}).join(" ")}(xe,et),y("xrange",xe),xe=function(it,dt){return y("replaceStars",it,dt),it.trim().replace(A[re],"")}(xe,et),y("stars",xe),xe}(tt,ve)}).join(" ").split(/\s+/);return this.loose&&(He=He.filter(function(tt){return!!tt.match($e)})),He=He.map(function(tt){return new Y(tt,ve)})},$.prototype.intersects=function(ae,ve){if(!(ae instanceof $))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function($e){return ae.set.some(function(He){return He.every(function(tt){return $e.intersects(tt,ve)})})})})},e.toComparators=function(ae,ve){return new $(ae,ve).set.map(function(be){return be.map(function($e){return $e.value}).join(" ").trim().split(" ")})},$.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new _(ae,this.loose));for(var ve=0;ve<this.set.length;ve++)if(Z(this.set[ve],ae))return!0;return!1},e.satisfies=de,e.maxSatisfying=function(ae,ve,be){var $e=null,He=null;try{var tt=new $(ve,be)}catch{return null}return ae.forEach(function(xe){tt.test(xe)&&($e&&He.compare(xe)!==-1||(He=new _($e=xe,be)))}),$e},e.minSatisfying=function(ae,ve,be){var $e=null,He=null;try{var tt=new $(ve,be)}catch{return null}return ae.forEach(function(xe){tt.test(xe)&&($e&&He.compare(xe)!==1||(He=new _($e=xe,be)))}),$e},e.validRange=function(ae,ve){try{return new $(ae,ve).range||"*"}catch{return null}},e.ltr=function(ae,ve,be){return Se(ae,ve,"<",be)},e.gtr=function(ae,ve,be){return Se(ae,ve,">",be)},e.outside=Se,e.prerelease=function(ae,ve){var be=le(ae,ve);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(ae,ve,be){return ae=new $(ae,be),ve=new $(ve,be),ae.intersects(ve)},e.coerce=function(ae){if(ae instanceof _)return ae;if(typeof ae!="string")return null;var ve=ae.match(A[N]);return ve==null?null:le((ve[1]||"0")+"."+(ve[2]||"0")+"."+(ve[3]||"0"))}}).call(this,i(1))},function(ee,e){var i,T,y=ee.exports={};function L(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function A(c){if(i===setTimeout)return setTimeout(c,0);if((i===L||!i)&&setTimeout)return i=setTimeout,setTimeout(c,0);try{return i(c,0)}catch{try{return i.call(null,c,0)}catch{return i.call(this,c,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:L}catch{i=L}try{T=typeof clearTimeout=="function"?clearTimeout:C}catch{T=C}})();var S,k=[],M=!1,D=-1;function m(){M&&S&&(M=!1,S.length?k=S.concat(k):D=-1,k.length&&b())}function b(){if(!M){var c=A(m);M=!0;for(var u=k.length;u;){for(S=k,k=[];++D<u;)S&&S[D].run();D=-1,u=k.length}S=null,M=!1,function(p){if(T===clearTimeout)return clearTimeout(p);if((T===C||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(p);try{T(p)}catch{try{return T.call(null,p)}catch{return T.call(this,p)}}}(c)}}function f(c,u){this.fun=c,this.array=u}function t(){}y.nextTick=function(c){var u=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)u[p-1]=arguments[p];k.push(new f(c,u)),k.length!==1||M||A(b)},f.prototype.run=function(){this.fun.apply(null,this.array)},y.title="browser",y.browser=!0,y.env={},y.argv=[],y.version="",y.versions={},y.on=t,y.addListener=t,y.once=t,y.off=t,y.removeListener=t,y.removeAllListeners=t,y.emit=t,y.prependListener=t,y.prependOnceListener=t,y.listeners=function(c){return[]},y.binding=function(c){throw new Error("process.binding is not supported")},y.cwd=function(){return"/"},y.chdir=function(c){throw new Error("process.chdir is not supported")},y.umask=function(){return 0}}])}),define(Ie[112],Ce([1,0,11,7]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function y(v){const w=v;return w?typeof w.read=="function":!1}e.isReadable=y;function L(v){const w=v;return w?[w.on,w.pause,w.resume,w.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=L;function C(v){const w=v;return w?L(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=C;function A(v,w){return new S(v,w)}e.newWriteableStream=A;class S{constructor(w,s){this.e=w,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(w){if(!this.a.destroyed){if(this.a.flowing)this.g(w);else if(this.b.data.push(w),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(w){this.a.destroyed||(this.a.flowing?this.h(w):this.b.error.push(w))}end(w){this.a.destroyed||(typeof w<"u"&&this.write(w),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(w){this.c.data.slice(0).forEach(s=>s(w))}h(w){this.c.error.length===0?(0,i.onUnexpectedError)(w):this.c.error.slice(0).forEach(s=>s(w))}i(){this.c.end.slice(0).forEach(w=>w())}on(w,s){if(!this.a.destroyed)switch(w){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(w,s){if(this.a.destroyed)return;let r;switch(w){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const o=r.indexOf(s);o>=0&&r.splice(o,1)}}j(){if(this.b.data.length>0){const w=this.e(this.b.data);this.g(w),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const w of this.b.error)this.h(w);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(v,w){const s=[];let r;for(;(r=v.read())!==null;)s.push(r);return w(s)}e.consumeReadable=k;function M(v,w,s){const r=[];let o;for(;(o=v.read())!==null&&r.length<s;)r.push(o);return o===null&&r.length>0?w(r):{read:()=>{if(r.length>0)return r.shift();if(typeof o<"u"){const h=o;return o=void 0,h}return v.read()}}}e.peekReadable=M;function D(v,w){return new Promise((s,r)=>{const o=[];m(v,{onData:h=>{w&&o.push(h)},onError:h=>{w?r(h):s(void 0)},onEnd:()=>{s(w?w(o):void 0)}})})}e.consumeStream=D;function m(v,w){let s=!1;return v.on("error",r=>{s||w.onError(r)}),v.on("end",()=>{s||w.onEnd()}),v.on("data",r=>{s||w.onData(r)}),(0,T.toDisposable)(()=>s=!0)}e.listenStream=m;function b(v,w){return new Promise((s,r)=>{const o=new T.DisposableStore,h=[],a=d=>{if(h.push(d),h.length>w)return o.dispose(),v.pause(),s({stream:v,buffer:h,ended:!1})},l=d=>r(d),n=()=>s({stream:v,buffer:h,ended:!0});o.add((0,T.toDisposable)(()=>v.removeListener("error",l))),v.on("error",l),o.add((0,T.toDisposable)(()=>v.removeListener("end",n))),v.on("end",n),o.add((0,T.toDisposable)(()=>v.removeListener("data",a))),v.on("data",a)})}e.peekStream=b;function f(v,w){const s=A(w);return s.end(v),s}e.toStream=f;function t(){const v=A(()=>{throw new Error("not supported")});return v.end(),v}e.emptyStream=t;function c(v){let w=!1;return{read:()=>w?null:(w=!0,v)}}e.toReadable=c;function u(v,w,s){const r=A(s);return m(v,{onData:o=>r.write(w.data(o)),onError:o=>r.error(w.error?w.error(o):o),onEnd:()=>r.end()}),r}e.transform=u;function p(v,w,s){let r=!1;return{read:()=>{const o=w.read();return r?o:(r=!0,o!==null?s([v,o]):v)}}}e.prefixedReadable=p;function E(v,w,s){let r=!1;const o=A(s);return m(w,{onData:h=>r?o.write(h):(r=!0,o.write(s([v,h]))),onError:h=>o.error(h),onEnd:()=>{r||(r=!0,o.write(v)),o.end()}}),o}e.prefixedStream=E}),define(Ie[24],Ce([1,0,112]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer<"u";let y,L;class C{static alloc(d){return T?new C(Buffer.allocUnsafe(d)):new C(new Uint8Array(d))}static wrap(d){return T&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new C(d)}static fromString(d,g){return!(g?.dontUseNodeBuffer||!1)&&T?new C(Buffer.from(d)):(y||(y=new TextEncoder),new C(y.encode(d)))}static fromByteArray(d){const g=C.alloc(d.length);for(let O=0,N=d.length;O<N;O++)g.buffer[O]=d[O];return g}static concat(d,g){if(typeof g>"u"){g=0;for(let q=0,J=d.length;q<J;q++)g+=d[q].byteLength}const O=C.alloc(g);let N=0;for(let q=0,J=d.length;q<J;q++){const x=d[q];O.set(x,N),N+=x.byteLength}return O}constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}clone(){const d=C.alloc(this.byteLength);return d.set(this),d}toString(){return T?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(d,g){return new C(this.buffer.subarray(d,g))}set(d,g){if(d instanceof C)this.buffer.set(d.buffer,g);else if(d instanceof Uint8Array)this.buffer.set(d,g);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),g);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),g);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return k(this.buffer,d)}writeUInt32BE(d,g){M(this.buffer,d,g)}readUInt32LE(d){return D(this.buffer,d)}writeUInt32LE(d,g){m(this.buffer,d,g)}readUInt8(d){return b(this.buffer,d)}writeUInt8(d,g){f(this.buffer,d,g)}}e.VSBuffer=C;function A(n,d){return n[d+0]<<0>>>0|n[d+1]<<8>>>0}e.readUInt16LE=A;function S(n,d,g){n[g+0]=d&255,d=d>>>8,n[g+1]=d&255}e.writeUInt16LE=S;function k(n,d){return n[d]*2**24+n[d+1]*2**16+n[d+2]*2**8+n[d+3]}e.readUInt32BE=k;function M(n,d,g){n[g+3]=d,d=d>>>8,n[g+2]=d,d=d>>>8,n[g+1]=d,d=d>>>8,n[g]=d}e.writeUInt32BE=M;function D(n,d){return n[d+0]<<0>>>0|n[d+1]<<8>>>0|n[d+2]<<16>>>0|n[d+3]<<24>>>0}e.readUInt32LE=D;function m(n,d,g){n[g+0]=d&255,d=d>>>8,n[g+1]=d&255,d=d>>>8,n[g+2]=d&255,d=d>>>8,n[g+3]=d&255}e.writeUInt32LE=m;function b(n,d){return n[d]}e.readUInt8=b;function f(n,d,g){n[g]=d}e.writeUInt8=f;function t(n){return i.consumeReadable(n,d=>C.concat(d))}e.readableToBuffer=t;function c(n){return i.toReadable(n)}e.bufferToReadable=c;function u(n){return i.consumeStream(n,d=>C.concat(d))}e.streamToBuffer=u;async function p(n){return n.ended?C.concat(n.buffer):C.concat([...n.buffer,await u(n.stream)])}e.bufferedStreamToBuffer=p;function E(n){return i.toStream(n,d=>C.concat(d))}e.bufferToStream=E;function v(n){return i.transform(n,{data:d=>typeof d=="string"?C.fromString(d):C.wrap(d)},d=>C.concat(d))}e.streamToBufferReadableStream=v;function w(n){return i.newWriteableStream(d=>C.concat(d),n)}e.newWriteableBufferStream=w;function s(n,d){return i.prefixedReadable(n,d,g=>C.concat(g))}e.prefixedBufferReadable=s;function r(n,d){return i.prefixedStream(n,d,g=>C.concat(g))}e.prefixedBufferStream=r;function o(n){let d=0,g=0,O=0;const N=new Uint8Array(Math.floor(n.length/4*3)),q=x=>{switch(g){case 3:N[O++]=d|x,g=0;break;case 2:N[O++]=d|x>>>2,d=x<<6,g=3;break;case 1:N[O++]=d|x>>>4,d=x<<4,g=2;break;default:d=x<<2,g=1}};for(let x=0;x<n.length;x++){const R=n.charCodeAt(x);if(R>=65&&R<=90)q(R-65);else if(R>=97&&R<=122)q(R-97+26);else if(R>=48&&R<=57)q(R-48+52);else if(R===43||R===45)q(62);else if(R===47||R===95)q(63);else{if(R===61)break;throw new SyntaxError(`Unexpected base64 character ${n[x]}`)}}const J=O;for(;g>0;)q(0);return C.wrap(N).slice(0,J)}e.decodeBase64=o;const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:n},d=!0,g=!1){const O=g?a:h;let N="";const q=n.byteLength%3;let J=0;for(;J<n.byteLength-q;J+=3){const x=n[J+0],R=n[J+1],P=n[J+2];N+=O[x>>>2],N+=O[(x<<4|R>>>4)&63],N+=O[(R<<2|P>>>6)&63],N+=O[P&63]}if(q===1){const x=n[J+0];N+=O[x>>>2],N+=O[x<<4&63],d&&(N+="==")}else if(q===2){const x=n[J+0],R=n[J+1];N+=O[x>>>2],N+=O[(x<<4|R>>>4)&63],N+=O[R<<2&63],d&&(N+="=")}return N}e.encodeBase64=l}),define(Ie[34],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(y){return i.test(y)}e.isUUID=T,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(A){for(let S=0;S<A.length;S++)A[S]=Math.floor(Math.random()*256);return A};const L=new Uint8Array(16),C=[];for(let A=0;A<256;A++)C.push(A.toString(16).padStart(2,"0"));return function(){y(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let S=0,k="";return k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k+="-",k+=C[L[S++]],k+=C[L[S++]],k+="-",k+=C[L[S++]],k+=C[L[S++]],k+="-",k+=C[L[S++]],k+=C[L[S++]],k+="-",k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k+=C[L[S++]],k}}()}),define(Ie[113],Ce([1,0,16,34]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function y(A){return{id:(0,T.generateUuid)(),asString:async()=>A,asFile:()=>{},value:typeof A=="string"?A:void 0}}e.createStringDataTransferItem=y;function L(A,S,k){return{id:(0,T.generateUuid)(),asString:async()=>"",asFile:()=>({name:A,uri:S,data:k}),value:void 0}}e.createFileDataTransferItem=L;class C{constructor(){this.a=new Map}get size(){return this.a.size}has(S){return this.a.has(this.b(S))}get(S){return this.a.get(this.b(S))?.[0]}append(S,k){const M=this.a.get(S);M?M.push(k):this.a.set(this.b(S),[k])}replace(S,k){this.a.set(this.b(S),[k])}delete(S){this.a.delete(this.b(S))}*entries(){for(const[S,k]of this.a.entries())for(const M of k)yield[S,M]}values(){return Array.from(this.a.values()).flat()}forEach(S){for(const[k,M]of this.entries())S(M,k)}b(S){return S.toLowerCase()}}e.VSDataTransfer=C,e.UriList=Object.freeze({create:A=>(0,i.distinct)(A.map(S=>S.toString())).join(`\r
`),split:A=>A.split(`\r
`),parse:A=>e.UriList.split(A).filter(S=>!S.startsWith("#"))})}),define(Ie[114],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ie[115],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var i;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(i=e.IndentAction||(e.IndentAction={}));class T{constructor(A){if(this.e=null,this.f=!1,this.open=A.open,this.close=A.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(A.notIn))for(let S=0,k=A.notIn.length;S<k;S++)switch(A.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(A,S){if(A.getTokenCount()===0)return!0;const k=A.findTokenIndexAtOffset(S-2),M=A.getStandardTokenType(k);return this.isOK(M)}g(A,S){for(let k=A;k<=S;k++){const M=String.fromCharCode(k);if(!this.open.includes(M)&&!this.close.includes(M))return M}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=T;class y{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of A)L(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),L(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),L(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),L(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&L(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=y;function L(C,A,S){C.has(A)?C.get(A).push(S):C.set(A,[S])}}),define(Ie[116],Ce([17,18]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(Ie[117],Ce([1,0,116]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,y=T*60,L=y*24,C=L*7,A=L*30,S=L*365;function k(D,m,b){typeof D!="number"&&(D=D.getTime());const f=Math.round((new Date().getTime()-D)/1e3);if(f<-30)return(0,i.localize)(0,null,k(new Date().getTime()+f*1e3,!1));if(f<30)return(0,i.localize)(1,null);let t;return f<T?(t=f,m?t===1?b?(0,i.localize)(2,null,t):(0,i.localize)(3,null,t):b?(0,i.localize)(4,null,t):(0,i.localize)(5,null,t):t===1?b?(0,i.localize)(6,null,t):(0,i.localize)(7,null,t):b?(0,i.localize)(8,null,t):(0,i.localize)(9,null,t)):f<y?(t=Math.floor(f/T),m?t===1?b?(0,i.localize)(10,null,t):(0,i.localize)(11,null,t):b?(0,i.localize)(12,null,t):(0,i.localize)(13,null,t):t===1?b?(0,i.localize)(14,null,t):(0,i.localize)(15,null,t):b?(0,i.localize)(16,null,t):(0,i.localize)(17,null,t)):f<L?(t=Math.floor(f/y),m?t===1?b?(0,i.localize)(18,null,t):(0,i.localize)(19,null,t):b?(0,i.localize)(20,null,t):(0,i.localize)(21,null,t):t===1?b?(0,i.localize)(22,null,t):(0,i.localize)(23,null,t):b?(0,i.localize)(24,null,t):(0,i.localize)(25,null,t)):f<C?(t=Math.floor(f/L),m?t===1?(0,i.localize)(26,null,t):(0,i.localize)(27,null,t):t===1?(0,i.localize)(28,null,t):(0,i.localize)(29,null,t)):f<A?(t=Math.floor(f/C),m?t===1?b?(0,i.localize)(30,null,t):(0,i.localize)(31,null,t):b?(0,i.localize)(32,null,t):(0,i.localize)(33,null,t):t===1?b?(0,i.localize)(34,null,t):(0,i.localize)(35,null,t):b?(0,i.localize)(36,null,t):(0,i.localize)(37,null,t)):f<S?(t=Math.floor(f/A),m?t===1?b?(0,i.localize)(38,null,t):(0,i.localize)(39,null,t):b?(0,i.localize)(40,null,t):(0,i.localize)(41,null,t):t===1?b?(0,i.localize)(42,null,t):(0,i.localize)(43,null,t):b?(0,i.localize)(44,null,t):(0,i.localize)(45,null,t)):(t=Math.floor(f/S),m?t===1?b?(0,i.localize)(46,null,t):(0,i.localize)(47,null,t):b?(0,i.localize)(48,null,t):(0,i.localize)(49,null,t):t===1?b?(0,i.localize)(50,null,t):(0,i.localize)(51,null,t):b?(0,i.localize)(52,null,t):(0,i.localize)(53,null,t))}e.fromNow=k;function M(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=M}),define(Ie[118],Ce([17,18]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(Ie[45],Ce([1,0,16,9,118]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(D,m){return m&&(D.stack||D.stacktrace)?y.localize(0,null,A(D),C(D.stack)||C(D.stacktrace)):A(D)}function C(D){return Array.isArray(D)?D.join(`
`):D}function A(D){return typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?y.localize(1,null,D.message):D.message||y.localize(2,null)}function S(D=null,m=!1){if(!D)return y.localize(3,null);if(Array.isArray(D)){const b=i.coalesce(D),f=S(b[0],m);return b.length>1?y.localize(4,null,f,b.length):f}if(T.isString(D))return D;if(D.detail){const b=D.detail;if(b.error)return L(b.error,m);if(b.exception)return L(b.exception,m)}return D.stack?L(D,m):D.message?D.message:y.localize(5,null)}e.toErrorMessage=S;function k(D){const m=D;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=k;function M(D,m){let b;return typeof D=="string"?b=new Error(D):b=D,b.actions=m,b}e.createErrorWithActions=M}),define(Ie[61],Ce([1,0,19]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},y={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(M){const D=(0,i.extname)(M),m=T[D.toLowerCase()];return m!==void 0?m:C(M)}e.getMediaOrTextMime=L;function C(M){const D=(0,i.extname)(M);return y[D.toLowerCase()]}e.getMediaMime=C;function A(M){for(const D in y)if(y[D]===M)return D}e.getExtensionForMimeType=A;const S=/^(.+)\/(.+?)(;.+)?$/;function k(M,D){const m=S.exec(M);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:D?void 0:M}e.normalizeMimeType=k}),define(Ie[39],Ce([1,0,19,21,10,9]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(a){return a===47||a===92}e.isPathSeparator=C;function A(a){return a.replace(/[\\/]/g,i.posix.sep)}e.toSlashes=A;function S(a){return a.indexOf("/")===-1&&(a=A(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.toPosixPath=S;function k(a,l=i.posix.sep){if(!a)return"";const n=a.length,d=a.charCodeAt(0);if(C(d)){if(C(a.charCodeAt(1))&&!C(a.charCodeAt(2))){let O=3;const N=O;for(;O<n&&!C(a.charCodeAt(O));O++);if(N!==O&&!C(a.charCodeAt(O+1))){for(O+=1;O<n;O++)if(C(a.charCodeAt(O)))return a.slice(0,O+1).replace(/[\\/]/g,l)}}return l}else if(u(d)&&a.charCodeAt(1)===58)return C(a.charCodeAt(2))?a.slice(0,2)+l:a.slice(0,2);let g=a.indexOf("://");if(g!==-1){for(g+=3;g<n;g++)if(C(a.charCodeAt(g)))return a.slice(0,g+1)}return""}e.getRoot=k;function M(a){if(!T.isWindows||!a||a.length<5)return!1;let l=a.charCodeAt(0);if(l!==92||(l=a.charCodeAt(1),l!==92))return!1;let n=2;const d=n;for(;n<a.length&&(l=a.charCodeAt(n),l!==92);n++);return!(d===n||(l=a.charCodeAt(n+1),isNaN(l)||l===92))}e.isUNC=M;const D=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(a,l=T.isWindows){const n=l?D:m;return!(!a||a.length===0||/^\s+$/.test(a)||(n.lastIndex=0,n.test(a))||l&&b.test(a)||a==="."||a===".."||l&&a[a.length-1]==="."||l&&a.length!==a.trim().length||a.length>255)}e.isValidBasename=f;function t(a,l,n){const d=a===l;return!n||d?d:!a||!l?!1:(0,y.equalsIgnoreCase)(a,l)}e.isEqual=t;function c(a,l,n,d=i.sep){if(a===l)return!0;if(!a||!l||l.length>a.length)return!1;if(n){if(!(0,y.startsWithIgnoreCase)(a,l))return!1;if(l.length===a.length)return!0;let O=l.length;return l.charAt(l.length-1)===d&&O--,a.charAt(O)===d}return l.charAt(l.length-1)!==d&&(l+=d),a.indexOf(l)===0}e.isEqualOrParent=c;function u(a){return a>=65&&a<=90||a>=97&&a<=122}e.isWindowsDriveLetter=u;function p(a,l){return T.isWindows&&a.endsWith(":")&&(a+=i.sep),(0,i.isAbsolute)(a)||(a=(0,i.join)(l,a)),a=(0,i.normalize)(a),T.isWindows?(a=(0,y.rtrim)(a,i.sep),a.endsWith(":")&&(a+=i.sep)):(a=(0,y.rtrim)(a,i.sep),a||(a=i.sep)),a}e.sanitizeFilePath=p;function E(a){const l=(0,i.normalize)(a);return T.isWindows?a.length>3?!1:v(l)&&(a.length===2||l.charCodeAt(2)===92):l===i.posix.sep}e.isRootOrDriveLetter=E;function v(a,l=T.isWindows){return l?u(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.hasDriveLetter=v;function w(a){return v(a)?a[0]:void 0}e.getDriveLetter=w;function s(a,l,n){return l.length>a.length?-1:a===l?0:(n&&(a=a.toLowerCase(),l=l.toLowerCase()),a.indexOf(l))}e.indexOfPath=s;function r(a){const l=a.split(":");let n,d,g;for(const O of l){const N=Number(O);(0,L.isNumber)(N)?d===void 0?d=N:g===void 0&&(g=N):n=n?[n,O].join(":"):O}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:d!==void 0?d:void 0,column:g!==void 0?g:d!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function h(a,l,n=8){let d="";for(let O=0;O<n;O++)d+=o.charAt(Math.floor(Math.random()*o.length));let g;return l?g=`${l}-${d}`:g=d,a?(0,i.join)(a,g):g}e.randomPath=h}),define(Ie[119],Ce([1,0,28,10]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function y(...Y){return function(I,$){for(let H=0,j=Y.length;H<j;H++){const Z=Y[H](I,$);if(Z)return Z}return null}}e.or=y,e.matchesStrictPrefix=L.bind(void 0,!1),e.matchesPrefix=L.bind(void 0,!0);function L(Y,I,$){if(!$||$.length<I.length)return null;let H;return Y?H=T.startsWithIgnoreCase($,I):H=$.indexOf(I)===0,H?I.length>0?[{start:0,end:I.length}]:[]:null}function C(Y,I){const $=I.toLowerCase().indexOf(Y.toLowerCase());return $===-1?null:[{start:$,end:$+Y.length}]}e.matchesContiguousSubString=C;function A(Y,I){return S(Y.toLowerCase(),I.toLowerCase(),0,0)}e.matchesSubString=A;function S(Y,I,$,H){if($===Y.length)return[];if(H===I.length)return null;if(Y[$]===I[H]){let j=null;return(j=S(Y,I,$+1,H+1))?u({start:H,end:H+1},j):null}return S(Y,I,$,H+1)}function k(Y){return 97<=Y&&Y<=122}function M(Y){return 65<=Y&&Y<=90}e.isUpper=M;function D(Y){return 48<=Y&&Y<=57}function m(Y){return Y===32||Y===9||Y===10||Y===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Y=>b.add(Y.charCodeAt(0)));function f(Y){return m(Y)||b.has(Y)}function t(Y,I){return Y===I||f(Y)&&f(I)}function c(Y){return k(Y)||M(Y)||D(Y)}function u(Y,I){return I.length===0?I=[Y]:Y.end===I[0].start?I[0].start=Y.start:I.unshift(Y),I}function p(Y,I){for(let $=I;$<Y.length;$++){const H=Y.charCodeAt($);if(M(H)||D(H)||$>0&&!c(Y.charCodeAt($-1)))return $}return Y.length}function E(Y,I,$,H){if($===Y.length)return[];if(H===I.length)return null;if(Y[$]!==I[H].toLowerCase())return null;{let j=null,Z=H+1;for(j=E(Y,I,$+1,H+1);!j&&(Z=p(I,Z))<I.length;)j=E(Y,I,$+1,Z),Z++;return j===null?null:u({start:H,end:H+1},j)}}function v(Y){let I=0,$=0,H=0,j=0,Z=0;for(let be=0;be<Y.length;be++)Z=Y.charCodeAt(be),M(Z)&&I++,k(Z)&&$++,c(Z)&&H++,D(Z)&&j++;const de=I/Y.length,Se=$/Y.length,ae=H/Y.length,ve=j/Y.length;return{upperPercent:de,lowerPercent:Se,alphaPercent:ae,numericPercent:ve}}function w(Y){const{upperPercent:I,lowerPercent:$}=Y;return $===0&&I>.6}function s(Y){const{upperPercent:I,lowerPercent:$,alphaPercent:H,numericPercent:j}=Y;return $>.2&&I<.8&&H>.6&&j<.2}function r(Y){let I=0,$=0,H=0,j=0;for(let Z=0;Z<Y.length;Z++)H=Y.charCodeAt(Z),M(H)&&I++,k(H)&&$++,m(H)&&j++;return(I===0||$===0)&&j===0?Y.length<=30:I<=5}function o(Y,I){if(!I||(I=I.trim(),I.length===0)||!r(Y)||I.length>60)return null;const $=v(I);if(!s($)){if(!w($))return null;I=I.toLowerCase()}let H=null,j=0;for(Y=Y.toLowerCase();j<I.length&&(H=E(Y,I,0,j))===null;)j=p(I,j+1);return H}e.matchesCamelCase=o;function h(Y,I,$=!1){if(!I||I.length===0)return null;let H=null,j=0;for(Y=Y.toLowerCase(),I=I.toLowerCase();j<I.length&&(H=a(Y,I,0,j,$))===null;)j=l(I,j+1);return H}e.matchesWords=h;function a(Y,I,$,H,j){if($===Y.length)return[];if(H===I.length)return null;if(t(Y.charCodeAt($),I.charCodeAt(H))){let Z=null,de=H+1;if(Z=a(Y,I,$+1,H+1,j),!j)for(;!Z&&(de=l(I,de))<I.length;)Z=a(Y,I,$+1,de,j),de++;return Z?Y.charCodeAt($)!==I.charCodeAt(H)?Z:u({start:H,end:H+1},Z):null}else return null}function l(Y,I){for(let $=I;$<Y.length;$++)if(f(Y.charCodeAt($))||$>0&&f(Y.charCodeAt($-1)))return $;return Y.length}const n=y(e.matchesPrefix,o,C),d=y(e.matchesPrefix,o,A),g=new i.LRUCache(1e4);function O(Y,I,$=!1){if(typeof Y!="string"||typeof I!="string")return null;let H=g.get(Y);H||(H=new RegExp(T.convertSimple2RegExpPattern(Y),"i"),g.set(Y,H));const j=H.exec(I);return j?[{start:j.index,end:j.index+j[0].length}]:$?d(Y,I):n(Y,I)}e.matchesFuzzy=O;function N(Y,I){const $=We(Y,Y.toLowerCase(),0,I,I.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return $?J($):null}e.matchesFuzzy2=N;function q(Y,I,$,H,j,Z){const de=Math.min(13,Y.length);for(;$<de;$++){const Se=We(Y,I,$,H,j,Z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Se)return Se}return[0,Z]}e.anyScore=q;function J(Y){if(typeof Y>"u")return[];const I=[],$=Y[1];for(let H=Y.length-1;H>1;H--){const j=Y[H]+$,Z=I[I.length-1];Z&&Z.end===j?Z.end=j+1:I.push({start:j,end:j+1})}return I}e.createMatches=J;const x=128;function R(){const Y=[],I=[];for(let $=0;$<=x;$++)I[$]=0;for(let $=0;$<=x;$++)Y.push(I.slice(0));return Y}function P(Y){const I=[];for(let $=0;$<=Y;$++)I[$]=0;return I}const F=P(2*x),B=P(2*x),z=R(),V=R(),K=R(),ie=!1;function ge(Y,I,$,H,j){function Z(Se,ae,ve=" "){for(;Se.length<ae;)Se=ve+Se;return Se}let de=` |   |${H.split("").map(Se=>Z(Se,3)).join("|")}
`;for(let Se=0;Se<=$;Se++)Se===0?de+=" |":de+=`${I[Se-1]}|`,de+=Y[Se].slice(0,j+1).map(ae=>Z(ae.toString(),3)).join("|")+`
`;return de}function ue(Y,I,$,H){Y=Y.substr(I),$=$.substr(H),console.log(ge(V,Y,Y.length,$,$.length)),console.log(ge(K,Y,Y.length,$,$.length)),console.log(ge(z,Y,Y.length,$,$.length))}function re(Y,I){if(I<0||I>=Y.length)return!1;const $=Y.codePointAt(I);switch($){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.isEmojiImprecise($)}}function se(Y,I){if(I<0||I>=Y.length)return!1;switch(Y.charCodeAt(I)){case 32:case 9:return!0;default:return!1}}function le(Y,I,$){return I[Y]!==$[Y]}function _(Y,I,$,H,j,Z,de=!1){for(;I<$&&j<Z;)Y[I]===H[j]&&(de&&(F[I]=j),I+=1),j+=1;return I===$}e.isPatternInWord=_;var me;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(me||(me={}));var we;(function(Y){Y.Default=[-100,0];function I($){return!$||$.length===2&&$[0]===-100&&$[1]===0}Y.isDefault=I})(we=e.FuzzyScore||(e.FuzzyScore={}));class Me{constructor(I,$){this.firstMatchCanBeWeak=I,this.boostFullMatch=$}}e.FuzzyScoreOptions=Me,Me.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function We(Y,I,$,H,j,Z,de=Me.default){const Se=Y.length>x?x:Y.length,ae=H.length>x?x:H.length;if($>=Se||Z>=ae||Se-$>ae-Z||!_(I,$,Se,j,Z,ae,!0))return;Qe(Se,ae,$,Z,I,j);let ve=1,be=1,$e=$,He=Z;const tt=[!1];for(ve=1,$e=$;$e<Se;ve++,$e++){const Fe=F[$e],st=B[$e],Q=$e+1<Se?B[$e+1]:ae;for(be=Fe-Z+1,He=Fe;He<Q;be++,He++){let X=Number.MIN_SAFE_INTEGER,pe=!1;He<=st&&(X=Te(Y,I,$e,$,H,j,He,ae,Z,z[ve-1][be-1]===0,tt));let Ne=0;X!==Number.MAX_SAFE_INTEGER&&(pe=!0,Ne=X+V[ve-1][be-1]);const Be=He>Fe,je=Be?V[ve][be-1]+(z[ve][be-1]>0?-5:0):0,Je=He>Fe+1&&z[ve][be-1]>0,nt=Je?V[ve][be-2]+(z[ve][be-2]>0?-5:0):0;if(Je&&(!Be||nt>=je)&&(!pe||nt>=Ne))V[ve][be]=nt,K[ve][be]=3,z[ve][be]=0;else if(Be&&(!pe||je>=Ne))V[ve][be]=je,K[ve][be]=2,z[ve][be]=0;else if(pe)V[ve][be]=Ne,K[ve][be]=1,z[ve][be]=z[ve-1][be-1]+1;else throw new Error("not possible")}}if(ie&&ue(Y,$,H,Z),!tt[0]&&!de.firstMatchCanBeWeak)return;ve--,be--;const xe=[V[ve][be],Z];let et=0,it=0;for(;ve>=1;){let Fe=be;do{const st=K[ve][Fe];if(st===3)Fe=Fe-2;else if(st===2)Fe=Fe-1;else break}while(Fe>=1);et>1&&I[$+ve-1]===j[Z+be-1]&&!le(Fe+Z-1,H,j)&&et+1>z[ve][Fe]&&(Fe=be),Fe===be?et++:et=1,it||(it=Fe),ve--,be=Fe-1,xe.push(be)}ae===Se&&de.boostFullMatch&&(xe[0]+=2);const dt=it-Se;return xe[0]-=dt,xe}e.fuzzyScore=We;function Qe(Y,I,$,H,j,Z){let de=Y-1,Se=I-1;for(;de>=$&&Se>=H;)j[de]===Z[Se]&&(B[de]=Se,de--),Se--}function Te(Y,I,$,H,j,Z,de,Se,ae,ve,be){if(I[$]!==Z[de])return Number.MIN_SAFE_INTEGER;let $e=1,He=!1;return de===$-H?$e=Y[$]===j[de]?7:5:le(de,j,Z)&&(de===0||!le(de-1,j,Z))?($e=Y[$]===j[de]?7:5,He=!0):re(Z,de)&&(de===0||!re(Z,de-1))?$e=5:(re(Z,de-1)||se(Z,de-1))&&($e=5,He=!0),$e>1&&$===H&&(be[0]=!0),He||(He=le(de,j,Z)||re(Z,de-1)||se(Z,de-1)),$===H?de>ae&&($e-=He?3:5):ve?$e+=He?2:0:$e+=He?0:1,de+1===Se&&($e-=He?3:5),$e}function De(Y,I,$,H,j,Z,de){return oe(Y,I,$,H,j,Z,!0,de)}e.fuzzyScoreGracefulAggressive=De;function ke(Y,I,$,H,j,Z,de){return oe(Y,I,$,H,j,Z,!1,de)}e.fuzzyScoreGraceful=ke;function oe(Y,I,$,H,j,Z,de,Se){let ae=We(Y,I,$,H,j,Z,Se);if(ae&&!de)return ae;if(Y.length>=3){const ve=Math.min(7,Y.length-1);for(let be=$+1;be<ve;be++){const $e=ce(Y,be);if($e){const He=We($e,$e.toLowerCase(),$,H,j,Z,Se);He&&(He[0]-=3,(!ae||He[0]>ae[0])&&(ae=He))}}}return ae}function ce(Y,I){if(I+1>=Y.length)return;const $=Y[I],H=Y[I+1];if($!==H)return Y.slice(0,I)+H+$+Y.slice(I+2)}}),define(Ie[120],Ce([1,0,121,119,10]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const L="$(",C=new RegExp(`\\$\\(${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${C.source}`,"g");function S(c){return c.replace(A,(u,p)=>p?u:`\\${u}`)}e.escapeIcons=S;const k=new RegExp(`\\\\${C.source}`,"g");function M(c){return c.replace(k,u=>`\\${u}`)}e.markdownEscapeEscapedIcons=M;const D=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function m(c){return c.indexOf(L)===-1?c:c.replace(D,(u,p,E,v)=>E?u:p||v||"")}e.stripIcons=m;const b=new RegExp(`\\$\\(${i.CSSIcon.iconNameCharacter}+\\)`,"g");function f(c){b.lastIndex=0;let u="";const p=[];let E=0;for(;;){const v=b.lastIndex,w=b.exec(c),s=c.substring(v,w?.index);if(s.length>0){u+=s;for(let r=0;r<s.length;r++)p.push(E)}if(!w)break;E+=w[0].length}return{text:u,iconOffsets:p}}e.parseLabelWithIcons=f;function t(c,u,p=!1){const{text:E,iconOffsets:v}=u;if(!v||v.length===0)return(0,T.matchesFuzzy)(c,E,p);const w=(0,y.ltrim)(E," "),s=E.length-w.length,r=(0,T.matchesFuzzy)(c,w,p);if(r)for(const o of r){const h=v[o.start+s]+s;o.start+=h,o.end+=h}return r}e.matchesFuzzyIconAware=t}),define(Ie[29],Ce([1,0,10]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(T||(T={})),function(y){const L="error",C="warning",A="warn",S="info",k="ignore";function M(m){return m?i.equalsIgnoreCase(L,m)?y.Error:i.equalsIgnoreCase(C,m)||i.equalsIgnoreCase(A,m)?y.Warning:i.equalsIgnoreCase(S,m)?y.Info:y.Ignore:y.Ignore}y.fromValue=M;function D(m){switch(m){case y.Error:return L;case y.Warning:return C;case y.Info:return S;default:return k}}y.toString=D}(T||(T={})),e.default=T}),define(Ie[46],Ce([1,0,16,10]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class y{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const f=b.charCodeAt(0),t=this.b.charCodeAt(this.c);return f-t}value(){return this.b[this.c]}}e.StringIterator=y;class L{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,T.compareSubstring)(b,this.b,0,b.length,this.c,this.d):(0,T.compareSubstringIgnoreCase)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=L;class C{constructor(b=!0,f=!0){this.f=b,this.g=f}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let f=b.length-1;f>=0;f--,this.c--){const t=this.b.charCodeAt(f);if(!(t===47||this.f&&t===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,T.compareSubstring)(b,this.b,0,b.length,this.d,this.e):(0,T.compareSubstringIgnoreCase)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=C;var A;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(A||(A={}));class S{constructor(b,f){this.f=b,this.g=f,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,T.compareIgnoreCase)(b,this.c.scheme);if(this.d[this.e]===2)return(0,T.compareIgnoreCase)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,T.compare)(b,this.c.query);if(this.d[this.e]===5)return(0,T.compare)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=S;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var M;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(M||(M={}));class D{static forUris(b=()=>!1,f=()=>!1){return new D(new S(b,f))}static forPaths(b=!1){return new D(new C(void 0,!b))}static forStrings(){return new D(new y)}static forConfigKeys(){return new D(new L)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,f){if(f){const t=f.slice(0);(0,i.shuffle)(t);for(const c of t)this.set(c,b)}else{const t=b.slice(0);(0,i.shuffle)(t);for(const c of t)this.set(c[0],c[1])}}set(b,f){const t=this.b.reset(b);let c;this.c||(this.c=new k,this.c.segment=t.value());const u=[];for(c=this.c;;){const E=t.cmp(c.segment);if(E>0)c.left||(c.left=new k,c.left.segment=t.value()),u.push([-1,c]),c=c.left;else if(E<0)c.right||(c.right=new k,c.right.segment=t.value()),u.push([1,c]),c=c.right;else if(t.hasNext())t.next(),c.mid||(c.mid=new k,c.mid.segment=t.value()),u.push([0,c]),c=c.mid;else break}const p=c.value;c.value=f,c.key=b;for(let E=u.length-1;E>=0;E--){const v=u[E][1];v.updateHeight();const w=v.balanceFactor();if(w<-1||w>1){const s=u[E][0],r=u[E+1][0];if(s===1&&r===1)u[E][1]=v.rotateLeft();else if(s===-1&&r===-1)u[E][1]=v.rotateRight();else if(s===1&&r===-1)v.right=u[E+1][1]=u[E+1][1].rotateRight(),u[E][1]=v.rotateLeft();else if(s===-1&&r===1)v.left=u[E+1][1]=u[E+1][1].rotateLeft(),u[E][1]=v.rotateRight();else throw new Error;if(E>0)switch(u[E-1][0]){case-1:u[E-1][1].left=u[E][1];break;case 1:u[E-1][1].right=u[E][1];break;case 0:u[E-1][1].mid=u[E][1];break}else this.c=u[0][1]}}return p}get(b){return this.d(b)?.value}d(b){const f=this.b.reset(b);let t=this.c;for(;t;){const c=f.cmp(t.segment);if(c>0)t=t.left;else if(c<0)t=t.right;else if(f.hasNext())f.next(),t=t.mid;else break}return t}has(b){const f=this.d(b);return!(f?.value===void 0&&f?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,f){const t=this.b.reset(b),c=[];let u=this.c;for(;u;){const p=t.cmp(u.segment);if(p>0)c.push([-1,u]),u=u.left;else if(p<0)c.push([1,u]),u=u.right;else if(t.hasNext())t.next(),c.push([0,u]),u=u.mid;else break}if(!!u){if(f?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const p=this.f(u.right);if(p.key){const{key:E,value:v,segment:w}=p;this.e(p.key,!1),u.key=E,u.value=v,u.segment=w}}else{const p=u.left??u.right;if(c.length>0){const[E,v]=c[c.length-1];switch(E){case-1:v.left=p;break;case 0:v.mid=p;break;case 1:v.right=p;break}}else this.c=p}for(let p=c.length-1;p>=0;p--){const E=c[p][1];E.updateHeight();const v=E.balanceFactor();if(v>1?(E.right.balanceFactor()>=0||(E.right=E.right.rotateRight()),c[p][1]=E.rotateLeft()):v<-1&&(E.left.balanceFactor()<=0||(E.left=E.left.rotateLeft()),c[p][1]=E.rotateRight()),p>0)switch(c[p-1][0]){case-1:c[p-1][1].left=c[p][1];break;case 1:c[p-1][1].right=c[p][1];break;case 0:c[p-1][1].mid=c[p][1];break}else this.c=c[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const f=this.b.reset(b);let t=this.c,c;for(;t;){const u=f.cmp(t.segment);if(u>0)t=t.left;else if(u<0)t=t.right;else if(f.hasNext())f.next(),c=t.value||c,t=t.mid;else break}return t&&t.value||c}findSuperstr(b){const f=this.b.reset(b);let t=this.c;for(;t;){const c=f.cmp(t.segment);if(c>0)t=t.left;else if(c<0)t=t.right;else if(f.hasNext())f.next(),t=t.mid;else return t.mid?this.g(t.mid):void 0}}forEach(b){for(const[f,t]of this)b(t,f)}*[Symbol.iterator](){yield*this.g(this.c)}g(b){const f=[];return this.h(b,f),f[Symbol.iterator]()}h(b,f){!b||(b.left&&this.h(b.left,f),b.value&&f.push([b.key,b.value]),b.mid&&this.h(b.mid,f),b.right&&this.h(b.right,f))}_isBalanced(){const b=f=>{if(!f)return!0;const t=f.balanceFactor();return t<-1||t>1?!1:b(f.left)&&b(f.right)};return b(this.c)}}e.TernarySearchTree=D}),define(Ie[80],Ce([1,0,24,10,2]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(k){return JSON.stringify(k,A)}e.stringify=L;function C(k){let M=JSON.parse(k);return M=S(M),M}e.parse=C;function A(k,M){return M instanceof RegExp?{$mid:2,source:M.source,flags:(0,T.regExpFlags)(M)}:M}function S(k,M=0){if(!k||M>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return y.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 16:return new Date(k.source)}if(k instanceof i.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let D=0;D<k.length;++D)k[D]=S(k[D],M+1);else for(const D in k)Object.hasOwnProperty.call(k,D)&&(k[D]=S(k[D],M+1))}return k}e.revive=S}),define(Ie[13],Ce([1,0,21,2]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var y;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(y=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${y.vscodeRemoteResource}`}setPreferredWebSchema(k){this.d=k}setDelegate(k){this.e=k}setServerRootPath(k){this.f=`${k}/${y.vscodeRemoteResource}`}set(k,M,D){this.a[k]=M,this.b[k]=D}setConnectionToken(k,M){this.c[k]=M}getPreferredWebSchema(){return this.d}rewrite(k){if(this.e)return this.e(k);const M=k.authority;let D=this.a[M];D&&D.indexOf(":")!==-1&&D.indexOf("[")===-1&&(D=`[${D}]`);const m=this.b[M],b=this.c[M];let f=`path=${encodeURIComponent(k.path)}`;return typeof b=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(b)}`),T.URI.from({scheme:i.isWeb?this.d:y.vscodeRemoteResource,authority:`${D}:${m}`,path:this.f,query:f})}}e.RemoteAuthorities=new L,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class C{asBrowserUri(k){const M=this.b(k,ee);return this.uriToBrowserUri(M)}uriToBrowserUri(k){return k.scheme===y.vscodeRemote?e.RemoteAuthorities.rewrite(k):k.scheme===y.file&&(i.isNative||i.isWebWorker&&i.globals.origin===`${y.vscodeFileResource}://${C.a}`)?k.with({scheme:y.vscodeFileResource,authority:k.authority||C.a,query:null,fragment:null}):k}asFileUri(k){const M=this.b(k,ee);return this.uriToFileUri(M)}uriToFileUri(k){return k.scheme===y.vscodeFileResource?k.with({scheme:y.file,authority:k.authority!==C.a?k.authority:null,query:null,fragment:null}):k}b(k,M){return T.URI.isUri(k)?k:T.URI.parse(M.toUrl(k))}}C.a="vscode-app",e.FileAccess=new C;var A;(function(S){const k=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(k.get("3"));const M="vscode-coi";function D(b){let f;typeof b=="string"?f=new URL(b).searchParams:b instanceof URL?f=b.searchParams:T.URI.isUri(b)&&(f=new URL(b.toString(!0)).searchParams);const t=f?.get(M);if(!!t)return k.get(t)}S.getHeadersFromQuery=D;function m(b,f,t){if(!globalThis.crossOriginIsolated)return;const c=f&&t?"3":t?"2":"1";b instanceof URLSearchParams?b.set(M,c):b[M]=c}S.addSearchParam=m})(A=e.COI||(e.COI={}))}),define(Ie[22],Ce([1,0,39,13,19,21,10,2]),function(ee,e,i,T,y,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(b){return(0,A.uriToFsPath)(b,!0)}e.originalFSPath=S;class k{constructor(f){this.a=f}compare(f,t,c=!1){return f===t?0:(0,C.compare)(this.getComparisonKey(f,c),this.getComparisonKey(t,c))}isEqual(f,t,c=!1){return f===t?!0:!f||!t?!1:this.getComparisonKey(f,c)===this.getComparisonKey(t,c)}getComparisonKey(f,t=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:t?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,t,c=!1){if(f.scheme===t.scheme){if(f.scheme===T.Schemas.file)return i.isEqualOrParent(S(f),S(t),this.a(f))&&f.query===t.query&&(c||f.fragment===t.fragment);if((0,e.isEqualAuthority)(f.authority,t.authority))return i.isEqualOrParent(f.path,t.path,this.a(f),"/")&&f.query===t.query&&(c||f.fragment===t.fragment)}return!1}joinPath(f,...t){return A.URI.joinPath(f,...t)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return y.posix.basename(f.path)}extname(f){return y.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let t;return f.scheme===T.Schemas.file?t=A.URI.file(y.dirname(S(f))).path:(t=y.posix.dirname(f.path),f.authority&&t.length&&t.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),t="/")),f.with({path:t})}normalizePath(f){if(!f.path.length)return f;let t;return f.scheme===T.Schemas.file?t=A.URI.file(y.normalize(S(f))).path:t=y.posix.normalize(f.path),f.with({path:t})}relativePath(f,t){if(f.scheme!==t.scheme||!(0,e.isEqualAuthority)(f.authority,t.authority))return;if(f.scheme===T.Schemas.file){const p=y.relative(S(f),S(t));return L.isWindows?i.toSlashes(p):p}let c=f.path||"/";const u=t.path||"/";if(this.a(f)){let p=0;for(const E=Math.min(c.length,u.length);p<E&&!(c.charCodeAt(p)!==u.charCodeAt(p)&&c.charAt(p).toLowerCase()!==u.charAt(p).toLowerCase());p++);c=u.substr(0,p)+c.substr(p)}return y.posix.relative(c,u)}resolvePath(f,t){if(f.scheme===T.Schemas.file){const c=A.URI.file(y.resolve(S(f),t));return f.with({authority:c.authority,path:c.path})}return t=i.toPosixPath(t),f.with({path:y.posix.resolve(f.path,t)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,t){return f===t||f!==void 0&&t!==void 0&&(0,C.equalsIgnoreCase)(f,t)}hasTrailingPathSeparator(f,t=y.sep){if(f.scheme===T.Schemas.file){const c=S(f);return c.length>i.getRoot(c).length&&c[c.length-1]===t}else{const c=f.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,t=y.sep){return(0,e.hasTrailingPathSeparator)(f,t)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,t=y.sep){let c=!1;if(f.scheme===T.Schemas.file){const u=S(f);c=u!==void 0&&u.length===i.getRoot(u).length&&u[u.length-1]===t}else{t="/";const u=f.path;c=u.length===1&&u.charCodeAt(u.length-1)===47}return!c&&!(0,e.hasTrailingPathSeparator)(f,t)?f.with({path:f.path+"/"}):f}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(b=>b.scheme===T.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new k(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function M(b,f){const t=[];for(let c=0;c<b.length;c++){const u=f(b[c]);b.some((p,E)=>E===c?!1:(0,e.isEqualOrParent)(u,f(p)))||t.push(b[c])}return t}e.distinctParents=M;var D;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function f(t){const c=new Map;t.path.substring(t.path.indexOf(";")+1,t.path.lastIndexOf(";")).split(";").forEach(E=>{const[v,w]=E.split(":");v&&w&&c.set(v,w)});const p=t.path.substring(0,t.path.indexOf(";"));return p&&c.set(b.META_DATA_MIME,p),c}b.parseMetaData=f})(D=e.DataUri||(e.DataUri={}));function m(b,f,t){if(f){let c=b.path;return c&&c[0]!==y.posix.sep&&(c=y.posix.sep+c),b.with({scheme:t,authority:f,path:c})}return b.with({scheme:t})}e.toLocalResource=m}),define(Ie[14],Ce([1,0,20,11,5,7,22,21]),function(ee,e,i,T,y,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(le){return!!le&&typeof le.then=="function"}e.isThenable=S;function k(le){const _=new i.CancellationTokenSource,me=le(_.token),we=new Promise((Me,We)=>{const Qe=_.token.onCancellationRequested(()=>{Qe.dispose(),_.dispose(),We(new T.CancellationError)});Promise.resolve(me).then(Te=>{Qe.dispose(),_.dispose(),Me(Te)},Te=>{Qe.dispose(),_.dispose(),We(Te)})});return new class{cancel(){_.cancel()}then(Me,We){return we.then(Me,We)}catch(Me){return this.then(void 0,Me)}finally(Me){return we.finally(Me)}}}e.createCancelablePromise=k;function M(le,_,me){return new Promise((we,Me)=>{const We=_.onCancellationRequested(()=>{We.dispose(),we(me)});le.then(we,Me).finally(()=>We.dispose())})}e.raceCancellation=M;function D(le,_){return new Promise((me,we)=>{const Me=_.onCancellationRequested(()=>{Me.dispose(),we(new T.CancellationError)});le.then(me,we).finally(()=>Me.dispose())})}e.raceCancellationError=D;async function m(le){let _=-1;const me=le.map((Me,We)=>Me.then(Qe=>(_=We,Qe))),we=await Promise.race(me);return le.forEach((Me,We)=>{We!==_&&Me.cancel()}),we}e.raceCancellablePromises=m;function b(le,_,me){let we;const Me=setTimeout(()=>{we?.(void 0),me?.()},_);return Promise.race([le.finally(()=>clearTimeout(Me)),new Promise(We=>we=We)])}e.raceTimeout=b;function f(le){return new Promise((_,me)=>{const we=le();S(we)?we.then(_,me):_(we)})}e.asPromise=f;class t{constructor(){this.a=null,this.b=null,this.d=null}queue(_){if(this.a){if(this.d=_,!this.b){const me=()=>{this.b=null;const we=this.queue(this.d);return this.d=null,we};this.b=new Promise(we=>{this.a.then(me,me).then(we)})}return new Promise((me,we)=>{this.b.then(me,we)})}return this.a=_(),new Promise((me,we)=>{this.a.then(Me=>{this.a=null,me(Me)},Me=>{this.a=null,we(Me)})})}}e.Throttler=t;class c{constructor(){this.a=Promise.resolve(null)}queue(_){return this.a=this.a.then(()=>_(),()=>_())}}e.Sequencer=c;class u{constructor(){this.a=new Map}queue(_,me){const Me=(this.a.get(_)??Promise.resolve()).catch(()=>{}).then(me).finally(()=>{this.a.get(_)===Me&&this.a.delete(_)});return this.a.set(_,Me),Me}}e.SequencerByKey=u;const p=(le,_)=>{let me=!0;const we=setTimeout(()=>{me=!1,_()},le);return{isTriggered:()=>me,dispose:()=>{clearTimeout(we),me=!1}}},E=le=>{let _=!0;return queueMicrotask(()=>{_&&(_=!1,le())}),{isTriggered:()=>_,dispose:()=>{_=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class v{constructor(_){this.defaultDelay=_,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(_,me=this.defaultDelay){this.g=_,this.h(),this.b||(this.b=new Promise((Me,We)=>{this.d=Me,this.f=We}).then(()=>{if(this.b=null,this.d=null,this.g){const Me=this.g;return this.g=null,Me()}}));const we=()=>{this.a=null,this.d?.(null)};return this.a=me===e.MicrotaskDelay?E(we):p(me,we),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=v;class w{constructor(_){this.a=new v(_),this.b=new t}trigger(_,me){return this.a.trigger(()=>this.b.queue(_),me)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=w;class s{constructor(){this.a=!1,this.b=new Promise((_,me)=>{this.d=_})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=s;class r extends s{constructor(_){super(),this.f=setTimeout(()=>this.open(),_)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function o(le,_){return _?new Promise((me,we)=>{const Me=setTimeout(()=>{We.dispose(),me()},le),We=_.onCancellationRequested(()=>{clearTimeout(Me),We.dispose(),we(new T.CancellationError)})}):k(me=>o(le,me))}e.timeout=o;function h(le,_=0){const me=setTimeout(le,_);return(0,L.toDisposable)(()=>clearTimeout(me))}e.disposableTimeout=h;function a(le){const _=[];let me=0;const we=le.length;function Me(){return me<we?le[me++]():null}function We(Qe){Qe!=null&&_.push(Qe);const Te=Me();return Te?Te.then(We):Promise.resolve(_)}return Promise.resolve(null).then(We)}e.sequence=a;function l(le,_=we=>!!we,me=null){let we=0;const Me=le.length,We=()=>{if(we>=Me)return Promise.resolve(me);const Qe=le[we++];return Promise.resolve(Qe()).then(De=>_(De)?Promise.resolve(De):We())};return We()}e.first=l;function n(le,_=we=>!!we,me=null){if(le.length===0)return Promise.resolve(me);let we=le.length;const Me=()=>{we=-1;for(const We of le)We.cancel?.()};return new Promise((We,Qe)=>{for(const Te of le)Te.then(De=>{--we>=0&&_(De)?(Me(),We(De)):we===0&&We(me)}).catch(De=>{--we>=0&&(Me(),Qe(De))})})}e.firstParallel=n;class d{constructor(_){this.a=0,this.d=_,this.f=[],this.b=0,this.g=new y.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(_){return this.a++,new Promise((me,we)=>{this.f.push({factory:_,c:me,e:we}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const _=this.f.shift();this.b++;const me=_.factory();me.then(_.c,_.e),me.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=d;class g extends d{constructor(){super(1)}}e.Queue=g;class O{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const _=new K;return this.b.add(_),_.p}d(){for(const[,_]of this.a)if(_.size>0)return!1;return!0}queueFor(_,me=C.extUri){const we=me.getComparisonKey(_);let Me=this.a.get(we);return Me||(Me=new g,y.Event.once(Me.onDrained)(()=>{Me?.dispose(),this.a.delete(we),this.f()}),this.a.set(we,Me)),Me}f(){!this.d()||this.g()}g(){for(const _ of this.b)_.complete();this.b.clear()}dispose(){for(const[,_]of this.a)_.dispose();this.a.clear(),this.g()}}e.ResourceQueue=O;class N{constructor(_,me){this.a=-1,typeof _=="function"&&typeof me=="number"&&this.setIfNotSet(_,me)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(_,me){this.cancel(),this.a=setTimeout(()=>{this.a=-1,_()},me)}setIfNotSet(_,me){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,_()},me))}}e.TimeoutTimer=N;class q{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(_,me){this.cancel(),this.a=setInterval(()=>{_()},me)}}e.IntervalTimer=q;class J{constructor(_,me){this.b=-1,this.a=_,this.d=me,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(_=this.d){this.cancel(),this.b=setTimeout(this.f,_)}get delay(){return this.d}set delay(_){this.d=_}isScheduled(){return this.b!==-1}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=J;class x{constructor(_,me){me%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${me}ms is not a multiple of 1000ms.`),this.a=_,this.b=me,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(_=this.b){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(_/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=x;class R extends J{constructor(_,me){super(_,me),this.j=[]}work(_){this.j.push(_),this.isScheduled()||this.schedule()}h(){const _=this.j;this.j=[],this.a?.(_)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=R;class P extends L.Disposable{constructor(_,me){super(),this.g=_,this.h=me,this.a=[],this.b=this.B(new L.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(_){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+_.length>this.g.maxBufferedWork)return!1}else if(this.pending+_.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}return this.a.push(..._),this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new J(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=P,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=le=>{(0,A.setTimeout0)(()=>{if(_)return;const me=Date.now()+15;le(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.runWhenIdle=(le,_)=>{const me=requestIdleCallback(le,typeof _=="number"?{timeout:_}:void 0);let we=!1;return{dispose(){we||(we=!0,cancelIdleCallback(me))}}}}();class F{constructor(_){this.d=!1,this.a=()=>{try{this.f=_()}catch(me){this.g=me}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=F;async function B(le,_,me){let we;for(let Me=0;Me<me;Me++)try{return await le()}catch(We){we=We,await o(_)}throw we}e.retry=B;class z{hasPending(_){return this.a?typeof _=="number"?this.a.taskId===_:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(_,me,we){return this.a={taskId:_,cancel:()=>we?.(),promise:me},me.then(()=>this.d(_),()=>this.d(_)),me}d(_){this.a&&_===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const _=this.b;this.b=void 0,_.run().then(_.promiseResolve,_.promiseReject)}}setNext(_){if(this.b)this.b.run=_;else{let me,we;const Me=new Promise((We,Qe)=>{me=We,we=Qe});this.b={run:_,promise:Me,promiseResolve:me,promiseReject:we}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=z;class V{constructor(_,me=()=>Date.now()){this.d=_,this.f=me,this.a=0,this.b=0}increment(){const _=this.f();return _-this.a>this.d&&(this.a=_,this.b=0),this.b++,this.b}}e.IntervalCounter=V;class K{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((_,me)=>{this.a=_,this.b=me})}complete(_){return new Promise(me=>{this.a(_),this.f=!0,me()})}error(_){return new Promise(me=>{this.b(_),this.d=!0,me()})}cancel(){new Promise(_=>{this.b(new T.CancellationError),this.d=!0,_()})}}e.DeferredPromise=K;var ie;(function(le){async function _(we){let Me;const We=await Promise.all(we.map(Qe=>Qe.then(Te=>Te,Te=>{Me||(Me=Te)})));if(typeof Me<"u")throw Me;return We}le.settled=_;function me(we){return new Promise(async(Me,We)=>{try{await we(Me,We)}catch(Qe){We(Qe)}})}le.withAsyncBody=me})(ie=e.Promises||(e.Promises={}));var ge;(function(le){le[le.Initial=0]="Initial",le[le.DoneOK=1]="DoneOK",le[le.DoneError=2]="DoneError"})(ge||(ge={}));class ue{static fromArray(_){return new ue(me=>{me.emitMany(_)})}static fromPromise(_){return new ue(async me=>{me.emitMany(await _)})}static fromPromises(_){return new ue(async me=>{await Promise.all(_.map(async we=>me.emitOne(await we)))})}static merge(_){return new ue(async me=>{await Promise.all(_.map(async we=>{for await(const Me of we)me.emitOne(Me)}))})}constructor(_){this.a=0,this.b=[],this.d=null,this.f=new y.Emitter,queueMicrotask(async()=>{const me={emitOne:we=>this.g(we),emitMany:we=>this.h(we),reject:we=>this.k(we)};try{await Promise.resolve(_(me)),this.j()}catch(we){this.k(we)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let _=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(_<this.b.length)return{done:!1,value:this.b[_++]};if(this.a===1)return{done:!0,value:void 0};await y.Event.toPromise(this.f.event)}while(!0)}}}static map(_,me){return new ue(async we=>{for await(const Me of _)we.emitOne(me(Me))})}map(_){return ue.map(this,_)}static filter(_,me){return new ue(async we=>{for await(const Me of _)me(Me)&&we.emitOne(Me)})}filter(_){return ue.filter(this,_)}static coalesce(_){return ue.filter(_,me=>!!me)}coalesce(){return ue.coalesce(this)}static async toPromise(_){const me=[];for await(const we of _)me.push(we);return me}toPromise(){return ue.toPromise(this)}g(_){this.a===0&&(this.b.push(_),this.f.fire())}h(_){this.a===0&&(this.b=this.b.concat(_),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(_){this.a===0&&(this.a=2,this.d=_,this.f.fire())}}e.AsyncIterableObject=ue,ue.EMPTY=ue.fromArray([]);class re extends ue{constructor(_,me){super(me),this.l=_}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=re;function se(le){const _=new i.CancellationTokenSource,me=le(_.token);return new re(_,async we=>{const Me=_.token.onCancellationRequested(()=>{Me.dispose(),_.dispose(),we.reject(new T.CancellationError)});try{for await(const We of me){if(_.token.isCancellationRequested)return;we.emitOne(We)}Me.dispose(),_.dispose()}catch(We){Me.dispose(),_.dispose(),we.reject(We)}})}e.createCancelableAsyncIterable=se}),define(Ie[122],Ce([1,0,14,19]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const y=new i.IdleValue(()=>{const d=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:d,collatorIsNumeric:d.resolvedOptions().numeric}}),L=new i.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new i.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(d,g,O=!1){const N=d||"",q=g||"",J=y.value.collator.compare(N,q);return y.value.collatorIsNumeric&&J===0&&N!==q?N<q?-1:1:J}e.compareFileNames=A;function S(d,g){const O=L.value.collator;return d=d||"",g=g||"",v(O,d,g)}e.compareFileNamesDefault=S;function k(d,g){const O=L.value.collator;return d=d||"",g=g||"",o(d,g)||v(O,d,g)}e.compareFileNamesUpper=k;function M(d,g){const O=L.value.collator;return d=d||"",g=g||"",r(d,g)||v(O,d,g)}e.compareFileNamesLower=M;function D(d,g){return d=d||"",g=g||"",d===g?0:d<g?-1:1}e.compareFileNamesUnicode=D;function m(d,g){const[O,N]=p(d),[q,J]=p(g);let x=y.value.collator.compare(N,J);if(x===0){if(y.value.collatorIsNumeric&&N!==J)return N<J?-1:1;if(x=y.value.collator.compare(O,q),y.value.collatorIsNumeric&&x===0&&O!==q)return O<q?-1:1}return x}e.compareFileExtensions=m;function b(d,g){d=d||"",g=g||"";const O=E(d),N=E(g),q=L.value.collator,J=C.value.collator;return v(J,O,N)||v(q,d,g)}e.compareFileExtensionsDefault=b;function f(d,g){d=d||"",g=g||"";const O=E(d),N=E(g),q=L.value.collator,J=C.value.collator;return v(J,O,N)||o(d,g)||v(q,d,g)}e.compareFileExtensionsUpper=f;function t(d,g){d=d||"",g=g||"";const O=E(d),N=E(g),q=L.value.collator,J=C.value.collator;return v(J,O,N)||r(d,g)||v(q,d,g)}e.compareFileExtensionsLower=t;function c(d,g){d=d||"",g=g||"";const O=E(d).toLowerCase(),N=E(g).toLowerCase();return O!==N?O<N?-1:1:d!==g?d<g?-1:1:0}e.compareFileExtensionsUnicode=c;const u=/^(.*?)(\.([^.]*))?$/;function p(d,g=!1){const O=d?u.exec(d):[];let N=[O&&O[1]||"",O&&O[3]||""];return g&&(!N[0]&&N[1]||N[0]&&N[0].charAt(0)===".")&&(N=[N[0]+"."+N[1],""]),N}function E(d){const g=d?u.exec(d):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function v(d,g,O){const N=d.compare(g,O);return N!==0?N:g.length!==O.length?g.length<O.length?-1:1:0}function w(d){const g=d.charAt(0);return g.toLocaleUpperCase()!==g}function s(d){const g=d.charAt(0);return g.toLocaleLowerCase()!==g}function r(d,g){return w(d)&&s(g)?-1:s(d)&&w(g)?1:0}function o(d,g){return s(d)&&w(g)?-1:w(d)&&s(g)?1:0}function h(d,g,O=!1){return O||(d=d&&d.toLowerCase(),g=g&&g.toLowerCase()),d===g?0:d<g?-1:1}function a(d,g,O=!1){const N=d.split(T.sep),q=g.split(T.sep),J=N.length-1,x=q.length-1;let R,P;for(let F=0;;F++){if(R=J===F,P=x===F,R&&P)return A(N[F],q[F],O);if(R)return-1;if(P)return 1;const B=h(N[F],q[F],O);if(B!==0)return B}}e.comparePaths=a;function l(d,g,O){const N=d.toLowerCase(),q=g.toLowerCase(),J=n(d,g,O);if(J)return J;const x=N.endsWith(O),R=q.endsWith(O);if(x!==R)return x?-1:1;const P=A(N,q);return P!==0?P:N.localeCompare(q)}e.compareAnything=l;function n(d,g,O){const N=d.toLowerCase(),q=g.toLowerCase(),J=N.startsWith(O),x=q.startsWith(O);if(J!==x)return J?-1:1;if(J&&x){if(N.length<q.length)return-1;if(N.length>q.length)return 1}return 0}e.compareByPrefix=n}),define(Ie[35],Ce([1,0,16,14,39,28,19,21,10]),function(ee,e,i,T,y,L,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const M="[/\\\\]",D="[^/\\\\]",m=/\//g;function b(K,ie){switch(K){case 0:return"";case 1:return`${D}*?`;default:return`(?:${M}|${D}+${M}${ie?`|${M}${D}+`:""})*?`}}function f(K,ie){if(!K)return[];const ge=[];let ue=!1,re=!1,se="";for(const le of K){switch(le){case ie:if(!ue&&!re){ge.push(se),se="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":re=!0;break;case"]":re=!1;break}se+=le}return se&&ge.push(se),ge}e.splitGlobAware=f;function t(K){if(!K)return"";let ie="";const ge=f(K,e.GLOB_SPLIT);if(ge.every(ue=>ue===e.GLOBSTAR))ie=".*";else{let ue=!1;ge.forEach((re,se)=>{if(re===e.GLOBSTAR){if(ue)return;ie+=b(2,se===ge.length-1)}else{let le=!1,_="",me=!1,we="";for(const Me of re){if(Me!=="}"&&le){_+=Me;continue}if(me&&(Me!=="]"||!we)){let We;Me==="-"?We=Me:(Me==="^"||Me==="!")&&!we?We="^":Me===e.GLOB_SPLIT?We="":We=(0,S.escapeRegExpCharacters)(Me),we+=We;continue}switch(Me){case"{":le=!0;continue;case"[":me=!0;continue;case"}":{ie+=`(?:${f(_,",").map(Te=>t(Te)).join("|")})`,le=!1,_="";break}case"]":{ie+="["+we+"]",me=!1,we="";break}case"?":ie+=D;continue;case"*":ie+=b(1);continue;default:ie+=(0,S.escapeRegExpCharacters)(Me)}}se<ge.length-1&&(ge[se+1]!==e.GLOBSTAR||se+2<ge.length)&&(ie+=M)}ue=re===e.GLOBSTAR})}return ie}const c=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,E=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,v=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new L.LRUCache(1e4),r=function(){return!1},o=function(){return null};function h(K,ie){if(!K)return o;let ge;typeof K!="string"?ge=K.pattern:ge=K,ge=ge.trim();const ue=`${ge}_${!!ie.trimForExclusions}`;let re=s.get(ue);if(re)return a(re,K);let se;return c.test(ge)?re=n(ge.substr(4),ge):(se=u.exec(l(ge,ie)))?re=d(se[1],ge):(ie.trimForExclusions?E:p).test(ge)?re=g(ge,ie):(se=v.exec(l(ge,ie)))?re=O(se[1].substr(1),ge,!0):(se=w.exec(l(ge,ie)))?re=O(se[1],ge,!1):re=N(ge),s.set(ue,re),a(re,K)}function a(K,ie){if(typeof ie=="string")return K;const ge=function(ue,re){return(0,y.isEqualOrParent)(ue,ie.base,!A.isLinux)?K((0,S.ltrim)(ue.substr(ie.base.length),C.sep),re):null};return ge.allBasenames=K.allBasenames,ge.allPaths=K.allPaths,ge.basenames=K.basenames,ge.patterns=K.patterns,ge}function l(K,ie){return ie.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function n(K,ie){return function(ge,ue){return typeof ge=="string"&&ge.endsWith(K)?ie:null}}function d(K,ie){const ge=`/${K}`,ue=`\\${K}`,re=function(le,_){return typeof le!="string"?null:_?_===K?ie:null:le===K||le.endsWith(ge)||le.endsWith(ue)?ie:null},se=[K];return re.basenames=se,re.patterns=[ie],re.allBasenames=se,re}function g(K,ie){const ge=z(K.slice(1,-1).split(",").map(_=>h(_,ie)).filter(_=>_!==o),K),ue=ge.length;if(!ue)return o;if(ue===1)return ge[0];const re=function(_,me){for(let we=0,Me=ge.length;we<Me;we++)if(ge[we](_,me))return K;return null},se=ge.find(_=>!!_.allBasenames);se&&(re.allBasenames=se.allBasenames);const le=ge.reduce((_,me)=>me.allPaths?_.concat(me.allPaths):_,[]);return le.length&&(re.allPaths=le),re}function O(K,ie,ge){const ue=C.sep===C.posix.sep,re=ue?K:K.replace(m,C.sep),se=C.sep+re,le=C.posix.sep+K;let _;return ge?_=function(me,we){return typeof me=="string"&&(me===re||me.endsWith(se)||!ue&&(me===K||me.endsWith(le)))?ie:null}:_=function(me,we){return typeof me=="string"&&(me===re||!ue&&me===K)?ie:null},_.allPaths=[(ge?"*/":"./")+K],_}function N(K){try{const ie=new RegExp(`^${t(K)}$`);return function(ge){return ie.lastIndex=0,typeof ge=="string"&&ie.test(ge)?K:null}}catch{return o}}function q(K,ie,ge){return!K||typeof ie!="string"?!1:J(K)(ie,void 0,ge)}e.match=q;function J(K,ie={}){if(!K)return r;if(typeof K=="string"||x(K)){const ge=h(K,ie);if(ge===o)return r;const ue=function(re,se){return!!ge(re,se)};return ge.allBasenames&&(ue.allBasenames=ge.allBasenames),ge.allPaths&&(ue.allPaths=ge.allPaths),ue}return F(K,ie)}e.parse=J;function x(K){const ie=K;return ie?typeof ie.base=="string"&&typeof ie.pattern=="string":!1}e.isRelativePattern=x;function R(K){return K.allBasenames||[]}e.getBasenameTerms=R;function P(K){return K.allPaths||[]}e.getPathTerms=P;function F(K,ie){const ge=z(Object.getOwnPropertyNames(K).map(_=>B(_,K[_],ie)).filter(_=>_!==o)),ue=ge.length;if(!ue)return o;if(!ge.some(_=>!!_.requiresSiblings)){if(ue===1)return ge[0];const _=function(Me,We){let Qe;for(let Te=0,De=ge.length;Te<De;Te++){const ke=ge[Te](Me,We);if(typeof ke=="string")return ke;(0,T.isThenable)(ke)&&(Qe||(Qe=[]),Qe.push(ke))}return Qe?(async()=>{for(const Te of Qe){const De=await Te;if(typeof De=="string")return De}return null})():null},me=ge.find(Me=>!!Me.allBasenames);me&&(_.allBasenames=me.allBasenames);const we=ge.reduce((Me,We)=>We.allPaths?Me.concat(We.allPaths):Me,[]);return we.length&&(_.allPaths=we),_}const re=function(_,me,we){let Me,We;for(let Qe=0,Te=ge.length;Qe<Te;Qe++){const De=ge[Qe];De.requiresSiblings&&we&&(me||(me=(0,C.basename)(_)),Me||(Me=me.substr(0,me.length-(0,C.extname)(_).length)));const ke=De(_,me,Me,we);if(typeof ke=="string")return ke;(0,T.isThenable)(ke)&&(We||(We=[]),We.push(ke))}return We?(async()=>{for(const Qe of We){const Te=await Qe;if(typeof Te=="string")return Te}return null})():null},se=ge.find(_=>!!_.allBasenames);se&&(re.allBasenames=se.allBasenames);const le=ge.reduce((_,me)=>me.allPaths?_.concat(me.allPaths):_,[]);return le.length&&(re.allPaths=le),re}function B(K,ie,ge){if(ie===!1)return o;const ue=h(K,ge);if(ue===o)return o;if(typeof ie=="boolean")return ue;if(ie){const re=ie.when;if(typeof re=="string"){const se=(le,_,me,we)=>{if(!we||!ue(le,_))return null;const Me=re.replace("$(basename)",()=>me),We=we(Me);return(0,T.isThenable)(We)?We.then(Qe=>Qe?K:null):We?K:null};return se.requiresSiblings=!0,se}}return ue}function z(K,ie){const ge=K.filter(_=>!!_.basenames);if(ge.length<2)return K;const ue=ge.reduce((_,me)=>{const we=me.basenames;return we?_.concat(we):_},[]);let re;if(ie){re=[];for(let _=0,me=ue.length;_<me;_++)re.push(ie)}else re=ge.reduce((_,me)=>{const we=me.patterns;return we?_.concat(we):_},[]);const se=function(_,me){if(typeof _!="string")return null;if(!me){let Me;for(Me=_.length;Me>0;Me--){const We=_.charCodeAt(Me-1);if(We===47||We===92)break}me=_.substr(Me)}const we=ue.indexOf(me);return we!==-1?re[we]:null};se.basenames=ue,se.patterns=re,se.allBasenames=ue;const le=K.filter(_=>!_.basenames);return le.push(se),le}function V(K,ie){return(0,i.equals)(K,ie,(ge,ue)=>typeof ge=="string"&&typeof ue=="string"?ge===ue:typeof ge!="string"&&typeof ue!="string"?ge.base===ue.base&&ge.pattern===ue.pattern:!1)}e.patternsEquals=V}),define(Ie[81],Ce([1,0,11,120,22,10,2]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(u="",p=!1){if(this.value=u,typeof this.value!="string")throw(0,i.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(u,p=0){return this.value+=m(this.supportThemeIcons?(0,T.escapeIcons)(u):u).replace(/([ \t]+)/g,(E,v)=>"&nbsp;".repeat(v.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,p){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}appendLink(u,p,E){return this.value+="[",this.value+=this.c(p,"]"),this.value+="](",this.value+=this.c(String(u),")"),E&&(this.value+=` "${this.c(this.c(E,'"'),")")}"`),this.value+=")",this}c(u,p){const E=new RegExp((0,L.escapeRegExpCharacters)(p),"g");return u.replace(E,(v,w)=>u.charAt(w-1)!=="\\"?`\\${v}`:v)}}e.MarkdownString=S;function k(c){return M(c)?!c.value:Array.isArray(c)?c.every(k):!0}e.isEmptyMarkdownString=k;function M(c){return c instanceof S?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.isMarkdownString=M;function D(c,u){return c===u?!0:!c||!u?!1:c.value===u.value&&c.isTrusted===u.isTrusted&&c.supportThemeIcons===u.supportThemeIcons&&c.supportHtml===u.supportHtml&&(c.baseUri===u.baseUri||!!c.baseUri&&!!u.baseUri&&(0,y.isEqual)(C.URI.from(c.baseUri),C.URI.from(u.baseUri)))}e.markdownStringEqual=D;function m(c){return c.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function b(c){return c.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=b;function f(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=f;function t(c){const u=[],p=c.split("|").map(v=>v.trim());c=p[0];const E=p[1];if(E){const v=/height=(\d+)/.exec(E),w=/width=(\d+)/.exec(E),s=v?v[1]:"",r=w?w[1]:"",o=isFinite(parseInt(r)),h=isFinite(parseInt(s));o&&u.push(`width="${r}"`),h&&u.push(`height="${s}"`)}return{href:c,dimensions:u}}e.parseHrefAndDimensions=t}),define(Ie[82],Ce([1,0,16,39,19,21,22,10]),function(ee,e,i,T,y,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function S(o,h){const{os:a,tildify:l,relative:n}=h;if(n){const O=k(o,n,a);if(typeof O=="string")return O}let d=o.fsPath;if(a===1&&!L.isWindows?d=d.replace(/\//g,"\\"):a!==1&&L.isWindows&&(d=d.replace(/\\/g,"/")),a!==1&&l?.userHome){const O=l.userHome.fsPath;let N;o.scheme!==l.userHome.scheme&&o.path.startsWith(y.posix.sep)?N=l.userHome.with({path:o.path}).fsPath:N=o.fsPath,d=m(N,O,a)}return(a===1?y.win32:y.posix).normalize(M(d,a===1))}e.getPathLabel=S;function k(o,h,a){const l=a===1?y.win32:y.posix,n=a===3?C.extUri:C.extUriIgnorePathCase,d=h.getWorkspace(),g=(0,i.firstOrDefault)(d.folders);if(!g)return;o.scheme!==g.uri.scheme&&o.path.startsWith(y.posix.sep)&&(o=g.uri.with({path:o.path}));const O=h.getWorkspaceFolder(o);if(!O)return;let N;if(n.isEqual(O.uri,o)?N="":N=n.relativePath(O.uri,o)??"",N&&(N=l.normalize(N)),d.folders.length>1&&!h.noPrefix){const q=O.name?O.name:n.basenameOrAuthority(O.uri);N=N?`${q} \u2022 ${N}`:q}return N}function M(o,h=L.isWindows){return(0,T.hasDriveLetter)(o,h)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=M;let D=Object.create(null);function m(o,h,a=L.OS){if(a===1||!o||!h)return o;let l=D.original===h?D.normalized:void 0;l||(l=h,L.isWindows&&(l=(0,T.toSlashes)(l)),l=`${(0,A.rtrim)(l,y.posix.sep)}${y.posix.sep}`,D={original:h,normalized:l});let n=o;return L.isWindows&&(n=(0,T.toSlashes)(n)),(a===3?n.startsWith(l):(0,A.startsWithIgnoreCase)(n,l))?`~/${n.substr(l.length)}`:o}e.tildify=m;function b(o,h){return o.replace(/^~($|\/|\\)/,`${h}$1`)}e.untildify=b;const f="\u2026",t="\\\\",c="~";function u(o,h=y.sep){const a=new Array(o.length);let l=!1;for(let n=0;n<o.length;n++){const d=o[n];if(d===""){a[n]=`.${h}`;continue}if(!d){a[n]=d;continue}l=!0;let g="",O=d;O.indexOf(t)===0?(g=O.substr(0,O.indexOf(t)+t.length),O=O.substr(O.indexOf(t)+t.length)):O.indexOf(h)===0?(g=O.substr(0,O.indexOf(h)+h.length),O=O.substr(O.indexOf(h)+h.length)):O.indexOf(c)===0&&(g=O.substr(0,O.indexOf(c)+c.length),O=O.substr(O.indexOf(c)+c.length));const N=O.split(h);for(let q=1;l&&q<=N.length;q++)for(let J=N.length-q;l&&J>=0;J--){l=!1;let x=N.slice(J,J+q).join(h);for(let R=0;!l&&R<o.length;R++)if(R!==n&&o[R]&&o[R].indexOf(x)>-1){const P=J+q===N.length,F=J>0&&o[R].indexOf(h)>-1?h+x:x,B=o[R].endsWith(F);l=!P||B}if(!l){let R="";(N[0].endsWith(":")||g!=="")&&(J===1&&(J=0,q++,x=N[0]+h+x),J>0&&(R=N[0]+h),R=g+R),J>0&&(R=R+f+h),R=R+x,J+q<N.length&&(R=R+h+f),a[n]=R}}l&&(a[n]=d)}return a}e.shorten=u;var p;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function E(o,h=Object.create(null)){const a=[];let l=!1,n="";for(const d of o)if(d==="$"||l&&d==="{")n&&a.push({value:n,type:p.TEXT}),n="",l=!0;else if(d==="}"&&l){const g=h[n];if(typeof g=="string")g.length&&a.push({value:g,type:p.VARIABLE});else if(g){const O=a[a.length-1];(!O||O.type!==p.SEPARATOR)&&a.push({value:g.label,type:p.SEPARATOR})}n="",l=!1}else n+=d;return n&&!l&&a.push({value:n,type:p.TEXT}),a.filter((d,g)=>{if(d.type===p.SEPARATOR){const O=a[g-1],N=a[g+1];return[O,N].every(q=>q&&(q.type===p.VARIABLE||q.type===p.TEXT)&&q.value.length>0)}return!0}).map(d=>d.value).join("")}e.template=E;function v(o,h){return L.isMacintosh||h?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):o.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=v;function w(o,h){return L.isMacintosh||h?o.replace(/\(&&\w\)|&&/g,""):L.isWindows?o.replace(/&&|&/g,a=>a==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=w;function s(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=s;function r(o){const h=o.indexOf("/")!==-1?y.posix:y.win32,a=h.basename(o),l=h.dirname(o);return a.length?{name:a,parentPath:l}:{name:l,parentPath:""}}e.splitName=r}),define(Ie[123],Ce([1,0,2]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(M){return M.toJSON()}class y{constructor(D){this.a=D}transformIncoming(D){const m=this.a.transformIncoming(D);return m===D?D:T(i.URI.from(m))}transformOutgoing(D){const m=this.a.transformOutgoing(D);return m===D?D:T(i.URI.from(m))}transformOutgoingURI(D){const m=this.a.transformOutgoing(D);return m===D?D:i.URI.from(m)}transformOutgoingScheme(D){return this.a.transformOutgoingScheme(D)}}e.URITransformer=y,e.DefaultURITransformer=new class{transformIncoming(M){return M}transformOutgoing(M){return M}transformOutgoingURI(M){return M}transformOutgoingScheme(M){return M}};function L(M,D,m){if(!M||m>200)return null;if(typeof M=="object"){if(M instanceof i.URI)return D.transformOutgoing(M);for(const b in M)if(Object.hasOwnProperty.call(M,b)){const f=L(M[b],D,m+1);f!==null&&(M[b]=f)}}return null}function C(M,D){const m=L(M,D,0);return m===null?M:m}e.transformOutgoingURIs=C;function A(M,D,m,b){if(!M||b>200)return null;if(typeof M=="object"){if(M.$mid===1)return m?i.URI.revive(D.transformIncoming(M)):D.transformIncoming(M);for(const f in M)if(Object.hasOwnProperty.call(M,f)){const t=A(M[f],D,m,b+1);t!==null&&(M[f]=t)}}return null}function S(M,D){const m=A(M,D,!1,0);return m===null?M:m}e.transformIncomingURIs=S;function k(M,D){const m=A(M,D,!0,0);return m===null?M:m}e.transformAndReviveIncomingURIs=k}),define(Ie[124],Ce([1,0,35,19]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function y(L,C,A,S,k,M){if(Array.isArray(L)){let D=0;for(const m of L){const b=y(m,C,A,S,k,M);if(b===10)return b;b>D&&(D=b)}return D}else{if(typeof L=="string")return S?L==="*"?5:L===A?10:0:0;if(L){const{language:D,pattern:m,scheme:b,hasAccessToAllModels:f,notebookType:t}=L;if(!S&&!f)return 0;t&&k&&(C=k);let c=0;if(b)if(b===C.scheme)c=10;else if(b==="*")c=5;else return 0;if(D)if(D===A)c=10;else if(D==="*")c=Math.max(c,5);else return 0;if(t)if(t===M)c=10;else if(t==="*"&&M!==void 0)c=Math.max(c,5);else return 0;if(m){let u;if(typeof m=="string"?u=m:u={...m,base:(0,T.normalize)(m.base)},u===C.fsPath||(0,i.match)(u,C.fsPath))c=10;else return 0}return c}else return 0}}e.score=y}),define(Ie[83],Ce([1,0,24,21]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var y;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(y||(y={}));function L(D){for(let m=0,b=D.length;m<b;m+=4){const f=D[m+0],t=D[m+1],c=D[m+2],u=D[m+3];D[m+0]=u,D[m+1]=c,D[m+2]=t,D[m+3]=f}}function C(D){const m=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return T.isLittleEndian()||L(m),i.VSBuffer.wrap(m)}function A(D){const m=D.buffer;if(T.isLittleEndian()||L(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const b=new Uint8Array(m.byteLength);return b.set(m),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function S(D){const m=new Uint32Array(k(D));let b=0;if(m[b++]=D.id,D.type==="full")m[b++]=1,m[b++]=D.data.length,m.set(D.data,b),b+=D.data.length;else{m[b++]=2,m[b++]=D.deltas.length;for(const f of D.deltas)m[b++]=f.start,m[b++]=f.deleteCount,f.data?(m[b++]=f.data.length,m.set(f.data,b),b+=f.data.length):m[b++]=0}return C(m)}e.encodeSemanticTokensDto=S;function k(D){let m=0;if(m+=1+1,D.type==="full")m+=1+D.data.length;else{m+=1,m+=(1+1+1)*D.deltas.length;for(const b of D.deltas)b.data&&(m+=b.data.length)}return m}function M(D){const m=A(D);let b=0;const f=m[b++];if(m[b++]===1){const p=m[b++],E=m.subarray(b,b+p);return b+=p,{id:f,type:"full",data:E}}const c=m[b++],u=[];for(let p=0;p<c;p++){const E=m[b++],v=m[b++],w=m[b++];let s;w>0&&(s=m.subarray(b,b+w),b+=w),u[p]={start:E,deleteCount:v,data:s}}return{id:f,type:"delta",deltas:u}}e.decodeSemanticTokensDto=M}),define(Ie[125],Ce([17,18]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(Ie[126],Ce([1,0,125,21,127,16,23,114]),function(ee,e,i,T,y,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=k;class M{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=M;class D{constructor(X,pe,Ne,Be){this.id=X,this.name=pe,this.defaultValue=Ne,this.schema=Be}applyUpdate(X,pe){return b(X,pe)}compute(X,pe,Ne){return Ne}}class m{constructor(X,pe){this.newValue=X,this.didChange=pe}}e.ApplyUpdateResult=m;function b(Q,X){if(typeof Q!="object"||typeof X!="object"||!Q||!X)return new m(X,Q!==X);if(Array.isArray(Q)||Array.isArray(X)){const Ne=Array.isArray(Q)&&Array.isArray(X)&&L.equals(Q,X);return new m(X,!Ne)}let pe=!1;for(const Ne in X)if(X.hasOwnProperty(Ne)){const Be=b(Q[Ne],X[Ne]);Be.didChange&&(Q[Ne]=Be.newValue,pe=!0)}return new m(Q,pe)}class f{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,pe){return b(X,pe)}validate(X){return this.defaultValue}}class t{constructor(X,pe,Ne,Be){this.id=X,this.name=pe,this.defaultValue=Ne,this.schema=Be}applyUpdate(X,pe){return b(X,pe)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,pe,Ne){return Ne}}function c(Q,X){return typeof Q>"u"?X:Q==="false"?!1:Boolean(Q)}e.boolean=c;class u extends t{constructor(X,pe,Ne,Be=void 0){typeof Be<"u"&&(Be.type="boolean",Be.default=Ne),super(X,pe,Ne,Be)}validate(X){return c(X,this.defaultValue)}}function p(Q,X,pe,Ne){if(typeof Q>"u")return X;let Be=parseInt(Q,10);return isNaN(Be)?X:(Be=Math.max(pe,Be),Be=Math.min(Ne,Be),Be|0)}e.clampedInt=p;class E extends t{static clampedInt(X,pe,Ne,Be){return p(X,pe,Ne,Be)}constructor(X,pe,Ne,Be,je,Je=void 0){typeof Je<"u"&&(Je.type="integer",Je.default=Ne,Je.minimum=Be,Je.maximum=je),super(X,pe,Ne,Je),this.minimum=Be,this.maximum=je}validate(X){return E.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class v extends t{static clamp(X,pe,Ne){return X<pe?pe:X>Ne?Ne:X}static float(X,pe){if(typeof X=="number")return X;if(typeof X>"u")return pe;const Ne=parseFloat(X);return isNaN(Ne)?pe:Ne}constructor(X,pe,Ne,Be,je){typeof je<"u"&&(je.type="number",je.default=Ne),super(X,pe,Ne,je),this.validationFn=Be}validate(X){return this.validationFn(v.float(X,this.defaultValue))}}class w extends t{static string(X,pe){return typeof X!="string"?pe:X}constructor(X,pe,Ne,Be=void 0){typeof Be<"u"&&(Be.type="string",Be.default=Ne),super(X,pe,Ne,Be)}validate(X){return w.string(X,this.defaultValue)}}function s(Q,X,pe){return typeof Q!="string"||pe.indexOf(Q)===-1?X:Q}e.stringSet=s;class r extends t{constructor(X,pe,Ne,Be,je=void 0){typeof je<"u"&&(je.type="string",je.enum=Be,je.default=Ne),super(X,pe,Ne,je),this.c=Be}validate(X){return s(X,this.defaultValue,this.c)}}class o extends D{constructor(X,pe,Ne,Be,je,Je,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=je,nt.default=Be),super(X,pe,Ne,nt),this.c=je,this.d=Je}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function h(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class a extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[i.localize(0,null),i.localize(1,null),i.localize(2,null)],default:"auto",tags:["accessibility"],description:i.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,pe,Ne){return Ne===0?X.accessibilitySupport:Ne}}class l extends D{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:i.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:i.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{insertSpace:c(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function d(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(g=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function O(Q){switch(Q){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=O;function N(Q){switch(Q){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class q extends f{constructor(){super(134)}compute(X,pe,Ne){const Be=["monaco-editor"];return pe.get(35)&&Be.push(pe.get(35)),X.extraEditorClassName&&Be.push(X.extraEditorClassName),pe.get(69)==="default"?Be.push("mouse-default"):pe.get(69)==="copy"&&Be.push("mouse-copy"),pe.get(104)&&Be.push("showUnused"),pe.get(132)&&Be.push("showDeprecated"),Be.join(" ")}}class J extends u{constructor(){super(33,"emptySelectionClipboard",!0,{description:i.localize(6,null)})}compute(X,pe,Ne){return Ne&&X.emptySelectionClipboard}}class x extends D{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(37,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:i.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[i.localize(8,null),i.localize(9,null),i.localize(10,null)],description:i.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[i.localize(12,null),i.localize(13,null),i.localize(14,null)],description:i.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:i.localize(16,null),included:T.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:i.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:i.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{cursorMoveOnType:c(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":s(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":s(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(pe.loop,this.defaultValue.loop)}}}class R extends D{constructor(){super(47,"fontLigatures",R.OFF,{anyOf:[{type:"boolean",description:i.localize(19,null)},{type:"string",description:i.localize(20,null)}],description:i.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?R.OFF:X==="true"?R.ON:X:Boolean(X)?R.ON:R.OFF}}e.EditorFontLigatures=R,R.OFF='"liga" off, "calt" off',R.ON='"liga" on, "calt" on';class P extends D{constructor(){super(50,"fontVariations",P.OFF,{anyOf:[{type:"boolean",description:i.localize(22,null)},{type:"string",description:i.localize(23,null)}],description:i.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?P.OFF:X==="true"?P.TRANSLATE:X:Boolean(X)?P.TRANSLATE:P.OFF}compute(X,pe,Ne){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=P,P.OFF="normal",P.TRANSLATE="translate";class F extends f{constructor(){super(46)}compute(X,pe,Ne){return X.fontInfo}}class B extends t{constructor(){super(48,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:i.localize(25,null)})}validate(X){const pe=v.float(X,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:v.clamp(pe,6,100)}compute(X,pe,Ne){return X.fontInfo.fontSize}}class z extends D{constructor(){super(49,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.d,maximum:z.e,errorMessage:i.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:i.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(E.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,z.d,z.e))}}z.c=["normal","bold","100","200","300","400","500","600","700","800","900"],z.d=1,z.e=1e3;class V extends D{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[i.localize(28,null),i.localize(29,null),i.localize(30,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(54,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:i.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:i.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:i.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:i.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:i.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:i.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Ne,description:i.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Ne,description:i.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Ne,description:i.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Ne,description:i.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Ne,description:i.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{multiple:s(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??s(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??s(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??s(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??s(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??s(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class K extends D{constructor(){const X={enabled:!0,delay:300,sticky:!0,above:!0};super(56,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:i.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:i.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:i.localize(44,null)},"editor.hover.above":{type:"boolean",default:X.above,description:i.localize(45,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:c(pe.enabled,this.defaultValue.enabled),delay:E.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:c(pe.sticky,this.defaultValue.sticky),above:c(pe.above,this.defaultValue.above)}}}var ie;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(ie=e.RenderMinimap||(e.RenderMinimap={}));class ge extends f{constructor(){super(137)}compute(X,pe,Ne){return ge.computeLayout(pe,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const pe=X.height/X.lineHeight,Ne=X.scrollBeyondLastLine?pe-1:0,Be=(X.viewLineCount+Ne)/(X.pixelRatio*X.height),je=Math.floor(X.viewLineCount/Be);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:Ne,desiredRatio:Be,minimapLineCount:je}}static c(X,pe){const Ne=X.outerWidth,Be=X.outerHeight,je=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(je*Be),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Be};const Je=pe.stableMinimapLayoutInput,nt=Je&&X.outerHeight===Je.outerHeight&&X.lineHeight===Je.lineHeight&&X.typicalHalfwidthCharacterWidth===Je.typicalHalfwidthCharacterWidth&&X.pixelRatio===Je.pixelRatio&&X.scrollBeyondLastLine===Je.scrollBeyondLastLine&&X.minimap.enabled===Je.minimap.enabled&&X.minimap.side===Je.minimap.side&&X.minimap.size===Je.minimap.size&&X.minimap.showSlider===Je.minimap.showSlider&&X.minimap.renderCharacters===Je.minimap.renderCharacters&&X.minimap.maxColumn===Je.minimap.maxColumn&&X.minimap.scale===Je.minimap.scale&&X.verticalScrollbarWidth===Je.verticalScrollbarWidth&&X.isViewportWrapping===Je.isViewportWrapping,vt=X.lineHeight,wt=X.typicalHalfwidthCharacterWidth,Tt=X.scrollBeyondLastLine,lt=X.minimap.renderCharacters;let at=je>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Ut=X.minimap.maxColumn,Ft=X.minimap.size,Mt=X.minimap.side,ft=X.verticalScrollbarWidth,Ct=X.viewLineCount,Bt=X.remainingWidth,Nt=X.isViewportWrapping,Ge=lt?2:3;let Rt=Math.floor(je*Be);const Lt=Rt/je;let Ht=!1,mt=!1,At=Ge*at,ye=at/je,Pe=1;if(Ft==="fill"||Ft==="fit"){const{typicalViewportLineCount:Ze,extraLinesBeyondLastLine:It,desiredRatio:bt,minimapLineCount:kt}=ge.computeContainedMinimapLineCount({viewLineCount:Ct,scrollBeyondLastLine:Tt,height:Be,lineHeight:vt,pixelRatio:je});if(Ct/kt>1)Ht=!0,mt=!0,at=1,At=1,ye=at/je;else{let pt=!1,St=at+1;if(Ft==="fit"){const $t=Math.ceil((Ct+It)*At);Nt&&nt&&Bt<=pe.stableFitRemainingWidth?(pt=!0,St=pe.stableFitMaxMinimapScale):pt=$t>Rt}if(Ft==="fill"||pt){Ht=!0;const $t=at;At=Math.min(vt*je,Math.max(1,Math.floor(1/bt))),Nt&&nt&&Bt<=pe.stableFitRemainingWidth&&(St=pe.stableFitMaxMinimapScale),at=Math.min(St,Math.max(1,Math.floor(At/Ge))),at>$t&&(Pe=Math.min(2,at/$t)),ye=at/je/Pe,Rt=Math.ceil(Math.max(Ze,Ct+It)*At),Nt?(pe.stableMinimapLayoutInput=X,pe.stableFitRemainingWidth=Bt,pe.stableFitMaxMinimapScale=at):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const fe=Math.floor(Ut*ye),G=Math.min(fe,Math.max(0,Math.floor((Bt-ft-2)*ye/(wt+ye)))+e.MINIMAP_GUTTER_WIDTH);let Ae=Math.floor(je*G);const Le=Ae/je;Ae=Math.floor(Ae*Pe);const Xe=lt?1:2,ze=Mt==="left"?0:Ne-G-ft;return{renderMinimap:Xe,minimapLeft:ze,minimapWidth:G,minimapHeightIsEditorHeight:Ht,minimapIsSampling:mt,minimapScale:at,minimapLineHeight:At,minimapCanvasInnerWidth:Ae,minimapCanvasInnerHeight:Rt,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:Lt}}static computeLayout(X,pe){const Ne=pe.outerWidth|0,Be=pe.outerHeight|0,je=pe.lineHeight|0,Je=pe.lineNumbersDigitCount|0,nt=pe.typicalHalfwidthCharacterWidth,vt=pe.maxDigitWidth,wt=pe.pixelRatio,Tt=pe.viewLineCount,lt=X.get(129),at=lt==="inherit"?X.get(128):lt,Ut=at==="inherit"?X.get(124):at,Ft=X.get(127),Mt=pe.isDominatedByLongLines,ft=X.get(53),Ct=X.get(63).renderType!==0,Bt=X.get(64),Nt=X.get(98),Ge=X.get(68),Rt=X.get(96),Lt=Rt.verticalScrollbarSize,Ht=Rt.verticalHasArrows,mt=Rt.arrowSize,At=Rt.horizontalScrollbarSize,ye=X.get(39),Pe=X.get(103)!=="never";let fe=X.get(61);ye&&Pe&&(fe+=16);let G=0;if(Ct){const Et=Math.max(Je,Bt);G=Math.round(Et*vt)}let Ae=0;ft&&(Ae=je);let Le=0,Xe=Le+Ae,ze=Xe+G,Ze=ze+fe;const It=Ne-Ae-G-fe;let bt=!1,kt=!1,gt=-1;at==="inherit"&&Mt?(bt=!0,kt=!0):Ut==="on"||Ut==="bounded"?kt=!0:Ut==="wordWrapColumn"&&(gt=Ft);const pt=ge.c({outerWidth:Ne,outerHeight:Be,lineHeight:je,typicalHalfwidthCharacterWidth:nt,pixelRatio:wt,scrollBeyondLastLine:Nt,minimap:Ge,verticalScrollbarWidth:Lt,viewLineCount:Tt,remainingWidth:It,isViewportWrapping:kt},pe.memory||new M);pt.renderMinimap!==0&&pt.minimapLeft===0&&(Le+=pt.minimapWidth,Xe+=pt.minimapWidth,ze+=pt.minimapWidth,Ze+=pt.minimapWidth);const St=It-pt.minimapWidth,$t=Math.max(1,Math.floor((St-Lt-2)/nt)),Xt=Ht?mt:0;return kt&&(gt=Math.max(1,$t),Ut==="bounded"&&(gt=Math.min(gt,Ft))),{width:Ne,height:Be,glyphMarginLeft:Le,glyphMarginWidth:Ae,lineNumbersLeft:Xe,lineNumbersWidth:G,decorationsLeft:ze,decorationsWidth:fe,contentLeft:Ze,contentWidth:St,minimap:pt,viewportColumn:$t,isWordWrapMinified:bt,isViewportWrapping:kt,wrappingColumn:gt,verticalScrollbarWidth:Lt,horizontalScrollbarHeight:At,overviewRuler:{top:Xt,width:Lt,height:Be-2*Xt,right:0}}}}e.EditorLayoutInfoComputer=ge;class ue extends D{constructor(){super(131,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[i.localize(46,null),i.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:i.localize(48,null)}})}validate(X){return s(X,"simple",["simple","advanced"])}compute(X,pe,Ne){return pe.get(2)===2?"advanced":Ne}}class re extends D{constructor(){const X={enabled:!0};super(60,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:i.localize(49,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:c(X.enabled,this.defaultValue.enabled)}}}class se extends D{constructor(){const X={enabled:!1,maxLineCount:5};super(108,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:i.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:i.localize(51,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:c(pe.enabled,this.defaultValue.enabled),maxLineCount:E.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class le extends D{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(133,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:i.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[i.localize(53,null),i.localize(54,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(55,null,T.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:i.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:i.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:i.localize(59,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:s(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:E.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(pe.fontFamily,this.defaultValue.fontFamily),padding:c(pe.padding,this.defaultValue.padding)}}}class _ extends D{constructor(){super(61,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):E.clampedInt(X,this.defaultValue,0,1e3)}compute(X,pe,Ne){return Ne<0?E.clampedInt(-Ne*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ne}}class me extends v{constructor(){super(62,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>v.clamp(X,0,150),{markdownDescription:i.localize(60,null)})}compute(X,pe,Ne){return X.fontInfo.lineHeight}}class we extends D{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(68,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:i.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:i.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[i.localize(63,null),i.localize(64,null),i.localize(65,null)],default:X.size,description:i.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:i.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:i.localize(68,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:i.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:i.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:i.localize(71,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:c(pe.enabled,this.defaultValue.enabled),autohide:c(pe.autohide,this.defaultValue.autohide),size:s(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(pe.side,this.defaultValue.side,["right","left"]),showSlider:s(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(pe.renderCharacters,this.defaultValue.renderCharacters),scale:E.clampedInt(pe.scale,1,1,3),maxColumn:E.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Me(Q){return Q==="ctrlCmd"?T.isMacintosh?"metaKey":"ctrlKey":"altKey"}class We extends D{constructor(){super(79,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(73,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{top:E.clampedInt(pe.top,0,0,1e3),bottom:E.clampedInt(pe.bottom,0,0,1e3)}}}class Qe extends D{constructor(){const X={enabled:!0,cycle:!1};super(80,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:i.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:i.localize(75,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:c(pe.enabled,this.defaultValue.enabled),cycle:c(pe.cycle,this.defaultValue.cycle)}}}class Te extends f{constructor(){super(135)}compute(X,pe,Ne){return X.pixelRatio}}class De extends D{constructor(){const X={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[i.localize(76,null),i.localize(77,null),i.localize(78,null)]}];super(83,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:X.strings,description:i.localize(79,null)},comments:{anyOf:pe,default:X.comments,description:i.localize(80,null)},other:{anyOf:pe,default:X.other,description:i.localize(81,null)}},default:X,markdownDescription:i.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const wt=X?"on":"off";return{comments:wt,strings:wt,other:wt}}if(!X||typeof X!="object")return this.defaultValue;const{other:pe,comments:Ne,strings:Be}=X,je=["on","inline","off"];let Je,nt,vt;return typeof pe=="boolean"?Je=pe?"on":"off":Je=s(pe,this.defaultValue.other,je),typeof Ne=="boolean"?nt=Ne?"on":"off":nt=s(Ne,this.defaultValue.comments,je),typeof Be=="boolean"?vt=Be?"on":"off":vt=s(Be,this.defaultValue.strings,je),{other:Je,comments:nt,strings:vt}}}var ke;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(ke=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class oe extends D{constructor(){super(63,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[i.localize(83,null),i.localize(84,null),i.localize(85,null),i.localize(86,null)],default:"on",description:i.localize(87,null)})}validate(X){let pe=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(pe=4,Ne=X):X==="interval"?pe=3:X==="relative"?pe=2:X==="on"?pe=1:pe=0),{renderType:pe,renderFn:Ne}}}function ce(Q){const X=Q.get(91);return X==="editable"?Q.get(85):X!=="on"}e.filterValidationDecorations=ce;class Y extends D{constructor(){const X=[],pe={type:"number",description:i.localize(88,null)};super(95,"rulers",X,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:i.localize(89,null),format:"color-hex"}}}]},default:X,description:i.localize(90,null)})}validate(X){if(Array.isArray(X)){const pe=[];for(const Ne of X)if(typeof Ne=="number")pe.push({column:E.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const Be=Ne;pe.push({column:E.clampedInt(Be.column,0,0,1e4),color:Be.color})}return pe.sort((Ne,Be)=>Ne.column-Be.column),pe}return this.defaultValue}}function I(Q,X){if(typeof Q!="string")return X;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class $ extends D{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(96,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(91,null),i.localize(92,null),i.localize(93,null)],default:"auto",description:i.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(95,null),i.localize(96,null),i.localize(97,null)],default:"auto",description:i.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:i.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:i.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:i.localize(101,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X,Ne=E.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Be=E.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:E.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:I(pe.vertical,this.defaultValue.vertical),horizontal:I(pe.horizontal,this.defaultValue.horizontal),useShadows:c(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:E.clampedInt(pe.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:Be,verticalSliderSize:E.clampedInt(pe.verticalSliderSize,Be,0,1e3),scrollByPage:c(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class H extends D{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(118,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:i.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:i.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:i.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:i.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:i.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:i.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:i.localize(108,null)}})}applyUpdate(X,pe){let Ne=!1;pe.allowedCharacters&&X&&(C.equals(X.allowedCharacters,pe.allowedCharacters)||(X={...X,allowedCharacters:pe.allowedCharacters},Ne=!0)),pe.allowedLocales&&X&&(C.equals(X.allowedLocales,pe.allowedLocales)||(X={...X,allowedLocales:pe.allowedLocales},Ne=!0));const Be=super.applyUpdate(X,pe);return Ne?new m(Be.newValue,!0):Be}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{nonBasicASCII:Se(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:c(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:c(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Se(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Se(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,pe){if(typeof X!="object"||!X)return pe;const Ne={};for(const[Be,je]of Object.entries(X))je===!0&&(Ne[Be]=!0);return Ne}}class j extends D{constructor(){const X={enabled:!0,mode:"subwordSmart"};super(58,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:i.localize(109,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:c(pe.enabled,this.defaultValue.enabled),mode:s(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class Z extends D{constructor(){const X={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:i.localize(110,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:i.localize(111,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{enabled:c(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:c(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class de extends D{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(112,null),i.localize(113,null),i.localize(114,null)],default:X.bracketPairs,description:i.localize(115,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(116,null),i.localize(117,null),i.localize(118,null)],default:X.bracketPairsHorizontal,description:i.localize(119,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:i.localize(120,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:i.localize(121,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[i.localize(122,null),i.localize(123,null),i.localize(124,null)],default:X.highlightActiveIndentation,description:i.localize(125,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{bracketPairs:Se(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Se(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:c(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:c(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:Se(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Se(Q,X,pe){const Ne=pe.indexOf(Q);return Ne===-1?X:pe[Ne]}class ae extends D{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectQuickSuggestions:!0,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(111,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[i.localize(126,null),i.localize(127,null)],default:X.insertMode,description:i.localize(128,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:i.localize(129,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:i.localize(130,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:i.localize(131,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:i.localize(132,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:i.localize(133,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:i.localize(134,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:i.localize(135,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:i.localize(136,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:i.localize(137,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:i.localize(138,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:i.localize(139,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:i.localize(140,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:i.localize(141,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:i.localize(142,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:i.localize(143,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:i.localize(144,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:i.localize(145,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:i.localize(146,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:i.localize(147,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:i.localize(148,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:i.localize(149,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:i.localize(150,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:i.localize(151,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:i.localize(152,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:i.localize(153,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:i.localize(154,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:i.localize(155,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:i.localize(156,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:i.localize(157,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:i.localize(158,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:i.localize(159,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:i.localize(160,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:i.localize(161,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:i.localize(162,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:i.localize(163,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:i.localize(164,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:i.localize(165,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:i.localize(166,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:i.localize(167,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:i.localize(168,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const pe=X;return{insertMode:s(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectQuickSuggestions:c(pe.selectQuickSuggestions,this.defaultValue.selectQuickSuggestions),showIcons:c(pe.showIcons,this.defaultValue.showIcons),showStatusBar:c(pe.showStatusBar,this.defaultValue.showStatusBar),preview:c(pe.preview,this.defaultValue.preview),previewMode:s(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(pe.showMethods,this.defaultValue.showMethods),showFunctions:c(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:c(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:c(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:c(pe.showFields,this.defaultValue.showFields),showVariables:c(pe.showVariables,this.defaultValue.showVariables),showClasses:c(pe.showClasses,this.defaultValue.showClasses),showStructs:c(pe.showStructs,this.defaultValue.showStructs),showInterfaces:c(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:c(pe.showModules,this.defaultValue.showModules),showProperties:c(pe.showProperties,this.defaultValue.showProperties),showEvents:c(pe.showEvents,this.defaultValue.showEvents),showOperators:c(pe.showOperators,this.defaultValue.showOperators),showUnits:c(pe.showUnits,this.defaultValue.showUnits),showValues:c(pe.showValues,this.defaultValue.showValues),showConstants:c(pe.showConstants,this.defaultValue.showConstants),showEnums:c(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:c(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(pe.showKeywords,this.defaultValue.showKeywords),showWords:c(pe.showWords,this.defaultValue.showWords),showColors:c(pe.showColors,this.defaultValue.showColors),showFiles:c(pe.showFiles,this.defaultValue.showFiles),showReferences:c(pe.showReferences,this.defaultValue.showReferences),showFolders:c(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:c(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(pe.showSnippets,this.defaultValue.showSnippets),showUsers:c(pe.showUsers,this.defaultValue.showUsers),showIssues:c(pe.showIssues,this.defaultValue.showIssues)}}}class ve extends D{constructor(){super(106,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:i.localize(169,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class be extends f{constructor(){super(136)}compute(X,pe,Ne){return pe.get(85)?!0:X.tabFocusMode}}var $e;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})($e=e.WrappingIndent||(e.WrappingIndent={}));class He extends D{constructor(){super(130,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[i.localize(170,null),i.localize(171,null),i.localize(172,null),i.localize(173,null)],description:i.localize(174,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,pe,Ne){return pe.get(2)===2?0:Ne}}class tt extends f{constructor(){super(138)}compute(X,pe,Ne){const Be=pe.get(137);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Be.isWordWrapMinified,isViewportWrapping:Be.isViewportWrapping,wrappingColumn:Be.wrappingColumn}}}class xe extends D{constructor(){const X={enabled:!0};super(32,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:i.localize(175,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:c(X.enabled,this.defaultValue.enabled)}}}const et="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",dt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:T.isMacintosh?it:T.isLinux?dt:et,fontWeight:"normal",fontSize:T.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var st;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.autoClosingBrackets=5]="autoClosingBrackets",Q[Q.autoClosingDelete=6]="autoClosingDelete",Q[Q.autoClosingOvertype=7]="autoClosingOvertype",Q[Q.autoClosingQuotes=8]="autoClosingQuotes",Q[Q.autoIndent=9]="autoIndent",Q[Q.automaticLayout=10]="automaticLayout",Q[Q.autoSurround=11]="autoSurround",Q[Q.bracketPairColorization=12]="bracketPairColorization",Q[Q.guides=13]="guides",Q[Q.codeLens=14]="codeLens",Q[Q.codeLensFontFamily=15]="codeLensFontFamily",Q[Q.codeLensFontSize=16]="codeLensFontSize",Q[Q.colorDecorators=17]="colorDecorators",Q[Q.columnSelection=18]="columnSelection",Q[Q.comments=19]="comments",Q[Q.contextmenu=20]="contextmenu",Q[Q.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=22]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=24]="cursorStyle",Q[Q.cursorSurroundingLines=25]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=27]="cursorWidth",Q[Q.disableLayerHinting=28]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",Q[Q.domReadOnly=30]="domReadOnly",Q[Q.dragAndDrop=31]="dragAndDrop",Q[Q.dropIntoEditor=32]="dropIntoEditor",Q[Q.emptySelectionClipboard=33]="emptySelectionClipboard",Q[Q.experimentalWhitespaceRendering=34]="experimentalWhitespaceRendering",Q[Q.extraEditorClassName=35]="extraEditorClassName",Q[Q.fastScrollSensitivity=36]="fastScrollSensitivity",Q[Q.find=37]="find",Q[Q.fixedOverflowWidgets=38]="fixedOverflowWidgets",Q[Q.folding=39]="folding",Q[Q.foldingStrategy=40]="foldingStrategy",Q[Q.foldingHighlight=41]="foldingHighlight",Q[Q.foldingImportsByDefault=42]="foldingImportsByDefault",Q[Q.foldingMaximumRegions=43]="foldingMaximumRegions",Q[Q.unfoldOnClickAfterEndOfLine=44]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=45]="fontFamily",Q[Q.fontInfo=46]="fontInfo",Q[Q.fontLigatures=47]="fontLigatures",Q[Q.fontSize=48]="fontSize",Q[Q.fontWeight=49]="fontWeight",Q[Q.fontVariations=50]="fontVariations",Q[Q.formatOnPaste=51]="formatOnPaste",Q[Q.formatOnType=52]="formatOnType",Q[Q.glyphMargin=53]="glyphMargin",Q[Q.gotoLocation=54]="gotoLocation",Q[Q.hideCursorInOverviewRuler=55]="hideCursorInOverviewRuler",Q[Q.hover=56]="hover",Q[Q.inDiffEditor=57]="inDiffEditor",Q[Q.inlineSuggest=58]="inlineSuggest",Q[Q.letterSpacing=59]="letterSpacing",Q[Q.lightbulb=60]="lightbulb",Q[Q.lineDecorationsWidth=61]="lineDecorationsWidth",Q[Q.lineHeight=62]="lineHeight",Q[Q.lineNumbers=63]="lineNumbers",Q[Q.lineNumbersMinChars=64]="lineNumbersMinChars",Q[Q.linkedEditing=65]="linkedEditing",Q[Q.links=66]="links",Q[Q.matchBrackets=67]="matchBrackets",Q[Q.minimap=68]="minimap",Q[Q.mouseStyle=69]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=70]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=71]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=72]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=73]="multiCursorModifier",Q[Q.multiCursorPaste=74]="multiCursorPaste",Q[Q.multiCursorLimit=75]="multiCursorLimit",Q[Q.occurrencesHighlight=76]="occurrencesHighlight",Q[Q.overviewRulerBorder=77]="overviewRulerBorder",Q[Q.overviewRulerLanes=78]="overviewRulerLanes",Q[Q.padding=79]="padding",Q[Q.parameterHints=80]="parameterHints",Q[Q.peekWidgetDefaultFocus=81]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=82]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=83]="quickSuggestions",Q[Q.quickSuggestionsDelay=84]="quickSuggestionsDelay",Q[Q.readOnly=85]="readOnly",Q[Q.renameOnType=86]="renameOnType",Q[Q.renderControlCharacters=87]="renderControlCharacters",Q[Q.renderFinalNewline=88]="renderFinalNewline",Q[Q.renderLineHighlight=89]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=90]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=91]="renderValidationDecorations",Q[Q.renderWhitespace=92]="renderWhitespace",Q[Q.revealHorizontalRightPadding=93]="revealHorizontalRightPadding",Q[Q.roundedSelection=94]="roundedSelection",Q[Q.rulers=95]="rulers",Q[Q.scrollbar=96]="scrollbar",Q[Q.scrollBeyondLastColumn=97]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=98]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=99]="scrollPredominantAxis",Q[Q.selectionClipboard=100]="selectionClipboard",Q[Q.selectionHighlight=101]="selectionHighlight",Q[Q.selectOnLineNumbers=102]="selectOnLineNumbers",Q[Q.showFoldingControls=103]="showFoldingControls",Q[Q.showUnused=104]="showUnused",Q[Q.snippetSuggestions=105]="snippetSuggestions",Q[Q.smartSelect=106]="smartSelect",Q[Q.smoothScrolling=107]="smoothScrolling",Q[Q.stickyScroll=108]="stickyScroll",Q[Q.stickyTabStops=109]="stickyTabStops",Q[Q.stopRenderingLineAfter=110]="stopRenderingLineAfter",Q[Q.suggest=111]="suggest",Q[Q.suggestFontSize=112]="suggestFontSize",Q[Q.suggestLineHeight=113]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=114]="suggestOnTriggerCharacters",Q[Q.suggestSelection=115]="suggestSelection",Q[Q.tabCompletion=116]="tabCompletion",Q[Q.tabIndex=117]="tabIndex",Q[Q.unicodeHighlighting=118]="unicodeHighlighting",Q[Q.unusualLineTerminators=119]="unusualLineTerminators",Q[Q.useShadowDOM=120]="useShadowDOM",Q[Q.useTabStops=121]="useTabStops",Q[Q.wordBreak=122]="wordBreak",Q[Q.wordSeparators=123]="wordSeparators",Q[Q.wordWrap=124]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=125]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=126]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=127]="wordWrapColumn",Q[Q.wordWrapOverride1=128]="wordWrapOverride1",Q[Q.wordWrapOverride2=129]="wordWrapOverride2",Q[Q.wrappingIndent=130]="wrappingIndent",Q[Q.wrappingStrategy=131]="wrappingStrategy",Q[Q.showDeprecated=132]="showDeprecated",Q[Q.inlayHints=133]="inlayHints",Q[Q.editorClassName=134]="editorClassName",Q[Q.pixelRatio=135]="pixelRatio",Q[Q.tabFocusMode=136]="tabFocusMode",Q[Q.layoutInfo=137]="layoutInfo",Q[Q.wrappingInfo=138]="wrappingInfo"})(st=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new u(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:i.localize(176,null)})),acceptSuggestionOnEnter:Fe(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",i.localize(177,null),""],markdownDescription:i.localize(178,null)})),accessibilitySupport:Fe(new a),accessibilityPageSize:Fe(new E(3,"accessibilityPageSize",10,1,1073741824,{description:i.localize(179,null),tags:["accessibility"]})),ariaLabel:Fe(new w(4,"ariaLabel",i.localize(180,null))),autoClosingBrackets:Fe(new r(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(181,null),i.localize(182,null),""],description:i.localize(183,null)})),autoClosingDelete:Fe(new r(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",i.localize(184,null),""],description:i.localize(185,null)})),autoClosingOvertype:Fe(new r(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",i.localize(186,null),""],description:i.localize(187,null)})),autoClosingQuotes:Fe(new r(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(188,null),i.localize(189,null),""],description:i.localize(190,null)})),autoIndent:Fe(new o(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],h,{enumDescriptions:[i.localize(191,null),i.localize(192,null),i.localize(193,null),i.localize(194,null),i.localize(195,null)],description:i.localize(196,null)})),automaticLayout:Fe(new u(10,"automaticLayout",!1)),autoSurround:Fe(new r(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[i.localize(197,null),i.localize(198,null),i.localize(199,null),""],description:i.localize(200,null)})),bracketPairColorization:Fe(new Z),bracketPairGuides:Fe(new de),stickyTabStops:Fe(new u(109,"stickyTabStops",!1,{description:i.localize(201,null)})),codeLens:Fe(new u(14,"codeLens",!0,{description:i.localize(202,null)})),codeLensFontFamily:Fe(new w(15,"codeLensFontFamily","",{description:i.localize(203,null)})),codeLensFontSize:Fe(new E(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:i.localize(204,null)})),colorDecorators:Fe(new u(17,"colorDecorators",!0,{description:i.localize(205,null)})),columnSelection:Fe(new u(18,"columnSelection",!1,{description:i.localize(206,null)})),comments:Fe(new l),contextmenu:Fe(new u(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new u(21,"copyWithSyntaxHighlighting",!0,{description:i.localize(207,null)})),cursorBlinking:Fe(new o(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],d,{description:i.localize(208,null)})),cursorSmoothCaretAnimation:Fe(new u(23,"cursorSmoothCaretAnimation",!1,{description:i.localize(209,null)})),cursorStyle:Fe(new o(24,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],N,{description:i.localize(210,null)})),cursorSurroundingLines:Fe(new E(25,"cursorSurroundingLines",0,0,1073741824,{description:i.localize(211,null)})),cursorSurroundingLinesStyle:Fe(new r(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[i.localize(212,null),i.localize(213,null)],description:i.localize(214,null)})),cursorWidth:Fe(new E(27,"cursorWidth",0,0,1073741824,{markdownDescription:i.localize(215,null)})),disableLayerHinting:Fe(new u(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new u(29,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new u(30,"domReadOnly",!1)),dragAndDrop:Fe(new u(31,"dragAndDrop",!0,{description:i.localize(216,null)})),emptySelectionClipboard:Fe(new J),dropIntoEditor:Fe(new xe),stickyScroll:Fe(new se),experimentalWhitespaceRendering:Fe(new r(34,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[i.localize(217,null),i.localize(218,null),i.localize(219,null)],description:i.localize(220,null)})),extraEditorClassName:Fe(new w(35,"extraEditorClassName","")),fastScrollSensitivity:Fe(new v(36,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:i.localize(221,null)})),find:Fe(new x),fixedOverflowWidgets:Fe(new u(38,"fixedOverflowWidgets",!1)),folding:Fe(new u(39,"folding",!0,{description:i.localize(222,null)})),foldingStrategy:Fe(new r(40,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[i.localize(223,null),i.localize(224,null)],description:i.localize(225,null)})),foldingHighlight:Fe(new u(41,"foldingHighlight",!0,{description:i.localize(226,null)})),foldingImportsByDefault:Fe(new u(42,"foldingImportsByDefault",!1,{description:i.localize(227,null)})),foldingMaximumRegions:Fe(new E(43,"foldingMaximumRegions",5e3,10,65e3,{description:i.localize(228,null)})),unfoldOnClickAfterEndOfLine:Fe(new u(44,"unfoldOnClickAfterEndOfLine",!1,{description:i.localize(229,null)})),fontFamily:Fe(new w(45,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:i.localize(230,null)})),fontInfo:Fe(new F),fontLigatures2:Fe(new R),fontSize:Fe(new B),fontWeight:Fe(new z),fontVariations:Fe(new P),formatOnPaste:Fe(new u(51,"formatOnPaste",!1,{description:i.localize(231,null)})),formatOnType:Fe(new u(52,"formatOnType",!1,{description:i.localize(232,null)})),glyphMargin:Fe(new u(53,"glyphMargin",!0,{description:i.localize(233,null)})),gotoLocation:Fe(new V),hideCursorInOverviewRuler:Fe(new u(55,"hideCursorInOverviewRuler",!1,{description:i.localize(234,null)})),hover:Fe(new K),inDiffEditor:Fe(new u(57,"inDiffEditor",!1)),letterSpacing:Fe(new v(59,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>v.clamp(Q,-5,20),{description:i.localize(235,null)})),lightbulb:Fe(new re),lineDecorationsWidth:Fe(new _),lineHeight:Fe(new me),lineNumbers:Fe(new oe),lineNumbersMinChars:Fe(new E(64,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new u(65,"linkedEditing",!1,{description:i.localize(236,null)})),links:Fe(new u(66,"links",!0,{description:i.localize(237,null)})),matchBrackets:Fe(new r(67,"matchBrackets","always",["always","near","never"],{description:i.localize(238,null)})),minimap:Fe(new we),mouseStyle:Fe(new r(69,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new v(70,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:i.localize(239,null)})),mouseWheelZoom:Fe(new u(71,"mouseWheelZoom",!1,{markdownDescription:i.localize(240,null)})),multiCursorMergeOverlapping:Fe(new u(72,"multiCursorMergeOverlapping",!0,{description:i.localize(241,null)})),multiCursorModifier:Fe(new o(73,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Me,{markdownEnumDescriptions:[i.localize(242,null),i.localize(243,null)],markdownDescription:i.localize(244,null)})),multiCursorPaste:Fe(new r(74,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[i.localize(245,null),i.localize(246,null)],markdownDescription:i.localize(247,null)})),multiCursorLimit:Fe(new E(75,"multiCursorLimit",1e4,1,1e5,{markdownDescription:i.localize(248,null)})),occurrencesHighlight:Fe(new u(76,"occurrencesHighlight",!0,{description:i.localize(249,null)})),overviewRulerBorder:Fe(new u(77,"overviewRulerBorder",!0,{description:i.localize(250,null)})),overviewRulerLanes:Fe(new E(78,"overviewRulerLanes",3,0,3)),padding:Fe(new We),parameterHints:Fe(new Qe),peekWidgetDefaultFocus:Fe(new r(81,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[i.localize(251,null),i.localize(252,null)],description:i.localize(253,null)})),definitionLinkOpensInPeek:Fe(new u(82,"definitionLinkOpensInPeek",!1,{description:i.localize(254,null)})),quickSuggestions:Fe(new De),quickSuggestionsDelay:Fe(new E(84,"quickSuggestionsDelay",10,0,1073741824,{description:i.localize(255,null)})),readOnly:Fe(new u(85,"readOnly",!1)),renameOnType:Fe(new u(86,"renameOnType",!1,{description:i.localize(256,null),markdownDeprecationMessage:i.localize(257,null)})),renderControlCharacters:Fe(new u(87,"renderControlCharacters",!0,{description:i.localize(258,null),restricted:!0})),renderFinalNewline:Fe(new r(88,"renderFinalNewline",T.isLinux?"dimmed":"on",["off","on","dimmed"],{description:i.localize(259,null)})),renderLineHighlight:Fe(new r(89,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",i.localize(260,null)],description:i.localize(261,null)})),renderLineHighlightOnlyWhenFocus:Fe(new u(90,"renderLineHighlightOnlyWhenFocus",!1,{description:i.localize(262,null)})),renderValidationDecorations:Fe(new r(91,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new r(92,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",i.localize(263,null),i.localize(264,null),i.localize(265,null),""],description:i.localize(266,null)})),revealHorizontalRightPadding:Fe(new E(93,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new u(94,"roundedSelection",!0,{description:i.localize(267,null)})),rulers:Fe(new Y),scrollbar:Fe(new $),scrollBeyondLastColumn:Fe(new E(97,"scrollBeyondLastColumn",4,0,1073741824,{description:i.localize(268,null)})),scrollBeyondLastLine:Fe(new u(98,"scrollBeyondLastLine",!0,{description:i.localize(269,null)})),scrollPredominantAxis:Fe(new u(99,"scrollPredominantAxis",!0,{description:i.localize(270,null)})),selectionClipboard:Fe(new u(100,"selectionClipboard",!0,{description:i.localize(271,null),included:T.isLinux})),selectionHighlight:Fe(new u(101,"selectionHighlight",!0,{description:i.localize(272,null)})),selectOnLineNumbers:Fe(new u(102,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new r(103,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[i.localize(273,null),i.localize(274,null),i.localize(275,null)],description:i.localize(276,null)})),showUnused:Fe(new u(104,"showUnused",!0,{description:i.localize(277,null)})),showDeprecated:Fe(new u(132,"showDeprecated",!0,{description:i.localize(278,null)})),inlayHints:Fe(new le),snippetSuggestions:Fe(new r(105,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[i.localize(279,null),i.localize(280,null),i.localize(281,null),i.localize(282,null)],description:i.localize(283,null)})),smartSelect:Fe(new ve),smoothScrolling:Fe(new u(107,"smoothScrolling",!1,{description:i.localize(284,null)})),stopRenderingLineAfter:Fe(new E(110,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new ae),inlineSuggest:Fe(new j),suggestFontSize:Fe(new E(112,"suggestFontSize",0,0,1e3,{markdownDescription:i.localize(285,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new E(113,"suggestLineHeight",0,0,1e3,{markdownDescription:i.localize(286,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new u(114,"suggestOnTriggerCharacters",!0,{description:i.localize(287,null)})),suggestSelection:Fe(new r(115,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[i.localize(288,null),i.localize(289,null),i.localize(290,null)],description:i.localize(291,null)})),tabCompletion:Fe(new r(116,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[i.localize(292,null),i.localize(293,null),i.localize(294,null)],description:i.localize(295,null)})),tabIndex:Fe(new E(117,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new H),unusualLineTerminators:Fe(new r(119,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[i.localize(296,null),i.localize(297,null),i.localize(298,null)],description:i.localize(299,null)})),useShadowDOM:Fe(new u(120,"useShadowDOM",!0)),useTabStops:Fe(new u(121,"useTabStops",!0,{description:i.localize(300,null)})),wordBreak:Fe(new r(122,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[i.localize(301,null),i.localize(302,null)],description:i.localize(303,null)})),wordSeparators:Fe(new w(123,"wordSeparators",y.USUAL_WORD_SEPARATORS,{description:i.localize(304,null)})),wordWrap:Fe(new r(124,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[i.localize(305,null),i.localize(306,null),i.localize(307,null),i.localize(308,null)],description:i.localize(309,null)})),wordWrapBreakAfterCharacters:Fe(new w(125,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new w(126,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new E(127,"wordWrapColumn",80,1,1073741824,{markdownDescription:i.localize(310,null)})),wordWrapOverride1:Fe(new r(128,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new r(129,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new q),pixelRatio:Fe(new Te),tabFocusMode:Fe(new be),layoutInfo:Fe(new ge),wrappingInfo:Fe(new tt),wrappingIndent:Fe(new He),wrappingStrategy:Fe(new ue)}}),define(Ie[128],Ce([17,18]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ie[129],Ce([17,18]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ie[130],Ce([17,18]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ie[131],Ce([17,18]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(Ie[132],Ce([17,18]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(Ie[133],Ce([17,18]),function(ee,e){return ee.create("vs/platform/workspace/common/workspace",e)}),define(Ie[134],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ie[135],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ie[136],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(Ie[137],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ie[138],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ie[139],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ie[140],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ie[141],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(Ie[142],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ie[143],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ie[144],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ie[145],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ie[146],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ie[147],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ie[148],Ce([17,18]),function(ee,e){return ee.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ie[149],Ce([1,0,11]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class T{constructor(){this.a=new Map}register(L,C){this.a.set(L,C)}updateManifest(L){if(!(typeof L.main>"u"&&typeof L.browser>"u")&&(L.activationEvents===void 0&&Object.assign(L,{activationEvents:[]}),!(!Array.isArray(L.activationEvents)||!L.contributes)))for(const C in L.contributes){const A=this.a.get(C);if(!A)continue;const S=L.contributes[C],k=Array.isArray(S)?S:[S];try{A(k,L.activationEvents)}catch(M){(0,i.onUnexpectedError)(M)}}}}e.ImplicitActivationEventsImpl=T,e.ImplicitActivationEvents=new T}),define(Ie[150],Ce([1,0,22,29,130,248]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function S(u){return u=u.trim(),u==="*"||C.test(u)}e.isValidVersionStr=S;function k(u){if(!S(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=u.match(C);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=k;function M(u){if(!u)return null;const p=u.majorBase,E=u.majorMustEqual,v=u.minorBase;let w=u.minorMustEqual;const s=u.patchBase;let r=u.patchMustEqual;u.hasCaret&&(p===0||(w=!1),r=!1);let o=0;if(u.preRelease){const h=A.exec(u.preRelease);if(h){const[,a,l,n]=h;o=Date.UTC(Number(a),Number(l)-1,Number(n))}}return{majorBase:p,majorMustEqual:E,minorBase:v,minorMustEqual:w,patchBase:s,patchMustEqual:r,isMinimum:u.hasGreaterEquals,notBefore:o}}e.normalizeVersion=M;function D(u,p,E){let v;typeof u=="string"?v=M(k(u)):v=u;let w;p instanceof Date?w=p.getTime():typeof p=="string"&&(w=new Date(p).getTime());let s;if(typeof E=="string"?s=M(k(E)):s=E,!v||!s)return!1;const r=v.majorBase,o=v.minorBase,h=v.patchBase;let a=s.majorBase,l=s.minorBase,n=s.patchBase;const d=s.notBefore;let g=s.majorMustEqual,O=s.minorMustEqual,N=s.patchMustEqual;return s.isMinimum?r>a?!0:r<a?!1:o>l?!0:o<l||w&&w<d?!1:h>=n:(r===1&&a===0&&(!g||!O||!N)&&(a=1,l=0,n=0,g=!0,O=!1,N=!1),r<a?!1:r>a?!g:o<l?!1:o>l?!O:h<n?!1:h>n?!N:!(w&&w<d))}e.isValidVersion=D;function m(u,p,E,v,w){const s=[];if(typeof v.publisher<"u"&&typeof v.publisher!="string")return s.push([T.default.Error,y.localize(0,null)]),s;if(typeof v.name!="string")return s.push([T.default.Error,y.localize(1,null,"name")]),s;if(typeof v.version!="string")return s.push([T.default.Error,y.localize(2,null,"version")]),s;if(!v.engines)return s.push([T.default.Error,y.localize(3,null,"engines")]),s;if(typeof v.engines.vscode!="string")return s.push([T.default.Error,y.localize(4,null,"engines.vscode")]),s;if(typeof v.extensionDependencies<"u"&&!c(v.extensionDependencies))return s.push([T.default.Error,y.localize(5,null,"extensionDependencies")]),s;if(typeof v.activationEvents<"u"){if(!c(v.activationEvents))return s.push([T.default.Error,y.localize(6,null,"activationEvents")]),s;if(typeof v.main>"u"&&typeof v.browser>"u")return s.push([T.default.Error,y.localize(7,null,"activationEvents","main")]),s}if(typeof v.extensionKind<"u"&&typeof v.main>"u"&&s.push([T.default.Warning,y.localize(8,null,"extensionKind")]),typeof v.main<"u"){if(typeof v.main!="string")return s.push([T.default.Error,y.localize(9,null,"main")]),s;{const h=(0,i.joinPath)(E,v.main);(0,i.isEqualOrParent)(h,E)||s.push([T.default.Warning,y.localize(10,null,h.path,E.path)])}if(typeof v.activationEvents>"u")return s.push([T.default.Error,y.localize(11,null,"activationEvents","main")]),s}if(typeof v.browser<"u"){if(typeof v.browser!="string")return s.push([T.default.Error,y.localize(12,null,"browser")]),s;{const h=(0,i.joinPath)(E,v.browser);(0,i.isEqualOrParent)(h,E)||s.push([T.default.Warning,y.localize(13,null,h.path,E.path)])}if(typeof v.activationEvents>"u")return s.push([T.default.Error,y.localize(14,null,"activationEvents","browser")]),s}if(!L.valid(v.version))return s.push([T.default.Error,y.localize(15,null)]),s;const r=[];if(!b(u,p,v,w,r))for(const h of r)s.push([T.default.Error,h]);return s}e.validateExtensionManifest=m;function b(u,p,E,v,w){return v||typeof E.main>"u"&&typeof E.browser>"u"?!0:t(u,p,E.engines.vscode,w)}e.isValidExtensionVersion=b;function f(u,p,E){return u==="*"||t(p,E,u)}e.isEngineValid=f;function t(u,p,E,v=[]){const w=M(k(E));if(!w)return v.push(y.localize(16,null,E)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return v.push(y.localize(17,null,E)),!1}else if(!w.majorMustEqual)return v.push(y.localize(18,null,E)),!1;return D(u,p,w)?!0:(v.push(y.localize(19,null,u,E)),!1)}function c(u){if(!Array.isArray(u))return!1;for(let p=0,E=u.length;p<E;p++)if(typeof u[p]!="string")return!1;return!0}}),define(Ie[84],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class i{constructor(y,L=[],C=!1){this.ctor=y,this.staticArguments=L,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=i}),define(Ie[62],Ce([1,0,84]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const T=[];var y;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(y=e.InstantiationType||(e.InstantiationType={}));function L(A,S,k){S instanceof i.SyncDescriptor||(S=new i.SyncDescriptor(S,[],Boolean(k))),T.push([A,S])}e.registerSingleton=L;function C(){return T}e.getSingletonServiceDescriptors=C}),define(Ie[151],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class i{constructor(L,C){this.key=L,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=i;class T{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const C of this.a.values())C.outgoing.size===0&&L.push(C);return L}insertEdge(L,C){const A=this.lookupOrInsertNode(L),S=this.lookupOrInsertNode(C);A.outgoing.set(S.key,S),S.incoming.set(A.key,A)}removeNode(L){const C=this.b(L);this.a.delete(C);for(const A of this.a.values())A.outgoing.delete(C),A.incoming.delete(C)}lookupOrInsertNode(L){const C=this.b(L);let A=this.a.get(C);return A||(A=new i(C,L),this.a.set(C,A)),A}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[C,A]of this.a)L.push(`${C}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,C]of this.a){const A=new Set([L]),S=this.c(C,A);if(S)return S}}c(L,C){for(const[A,S]of L.outgoing){if(C.has(A))return[...C,A].join(" -> ");C.add(A);const k=this.c(S,C);if(k)return k;C.delete(A)}}}e.Graph=T}),define(Ie[3],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var i;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function A(S){return S[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=A})(i=e._util||(e._util={})),e.IInstantiationService=y("instantiationService");function T(C,A,S){A[i.DI_TARGET]===A?A[i.DI_DEPENDENCIES].push({id:C,index:S}):(A[i.DI_DEPENDENCIES]=[{id:C,index:S}],A[i.DI_TARGET]=A)}function y(C){if(i.serviceIds.has(C))return i.serviceIds.get(C);const A=function(S,k,M){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(A,S,M)};return A.toString=()=>C,i.serviceIds.set(C,A),A}e.createDecorator=y;function L(C){return C}e.refineServiceDecorator=L}),define(Ie[40],Ce([1,0,9,2,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function L(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof T.URI)}e.isConfigurationOverrides=L;function C(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof T.URI)}e.isConfigurationUpdateOverrides=C;var A;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=S;function k(u,p){const E=Object.create(null);for(const v in u)M(E,v,u[v],p);return E}e.toValuesTree=k;function M(u,p,E,v){const w=p.split("."),s=w.pop();let r=u;for(let o=0;o<w.length;o++){const h=w[o];let a=r[h];switch(typeof a){case"undefined":a=r[h]=Object.create(null);break;case"object":break;default:v(`Ignoring ${p} as ${w.slice(0,o+1).join(".")} is ${JSON.stringify(a)}`);return}r=a}if(typeof r=="object"&&r!==null)try{r[s]=E}catch{v(`Ignoring ${p} as ${w.join(".")} is ${JSON.stringify(r)}`)}else v(`Ignoring ${p} as ${w.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=M;function D(u,p){const E=p.split(".");m(u,E)}e.removeFromValueTree=D;function m(u,p){const E=p.shift();if(p.length===0){delete u[E];return}if(Object.keys(u).indexOf(E)!==-1){const v=u[E];typeof v=="object"&&!Array.isArray(v)&&(m(v,p),Object.keys(v).length===0&&delete u[E])}}function b(u,p,E){function v(r,o){let h=r;for(const a of o){if(typeof h!="object"||h===null)return;h=h[a]}return h}const w=p.split("."),s=v(u,w);return typeof s>"u"?E:s}e.getConfigurationValue=b;function f(u,p,E){Object.keys(p).forEach(v=>{v!=="__proto__"&&(v in u?i.isObject(u[v])&&i.isObject(p[v])?f(u[v],p[v],E):E&&(u[v]=p[v]):u[v]=p[v])})}e.merge=f;function t(u,p,E){const v=u.inspect(p),w=u.inspect(E);return typeof v.userValue<"u"||typeof v.workspaceValue<"u"||typeof v.workspaceFolderValue<"u"?v.value:typeof w.userValue<"u"||typeof w.workspaceValue<"u"||typeof w.workspaceFolderValue<"u"?w.value:v.defaultValue}e.getMigratedSettingValue=t;function c(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=c}),define(Ie[41],Ce([1,0,21,10,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",i.isMacintosh),L.set("isLinux",i.isLinux),L.set("isWindows",i.isWindows),L.set("isWeb",i.isWeb),L.set("isMacNative",i.isMacintosh&&!i.isWeb),L.set("isEdge",i.isEdge),L.set("isFirefox",i.isFirefox),L.set("isChrome",i.isChrome),L.set("isSafari",i.isSafari);const C=Object.prototype.hasOwnProperty;var A;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return D.INSTANCE}static true(){return m.INSTANCE}static has(R){return b.create(R)}static equals(R,P){return f.create(R,P)}static notEquals(R,P){return u.create(R,P)}static regex(R,P){return o.create(R,P)}static in(R,P){return t.create(R,P)}static notIn(R,P){return c.create(R,P)}static not(R){return p.create(R)}static and(...R){return l.create(R,null,!0)}static or(...R){return n.create(R,null,!0)}static greater(R,P){return v.create(R,P)}static greaterEquals(R,P){return w.create(R,P)}static smaller(R,P){return s.create(R,P)}static smallerEquals(R,P){return r.create(R,P)}static deserialize(R,P=!1){if(!!R)return this.c(R,P)}static c(R,P){const F=R.split("||");return n.create(F.map(B=>this.d(B,P)),null,!0)}static d(R,P){const F=R.split("&&");return l.create(F.map(B=>this.f(B,P)),null,!0)}static f(R,P){if(R=R.trim(),R.indexOf("!=")>=0){const F=R.split("!=");return u.create(F[0].trim(),this.g(F[1],P))}if(R.indexOf("==")>=0){const F=R.split("==");return f.create(F[0].trim(),this.g(F[1],P))}if(R.indexOf("=~")>=0){const F=R.split("=~");return o.create(F[0].trim(),this.h(F[1],P))}if(R.indexOf(" not in ")>=0){const F=R.split(" not in ");return c.create(F[0].trim(),this.g(F[1],P))}if(R.indexOf(" in ")>=0){const F=R.split(" in ");return t.create(F[0].trim(),this.g(F[1],P))}if(/^[^<=>]+>=[^<=>]+$/.test(R)){const F=R.split(">=");return w.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(R)){const F=R.split(">");return v.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(R)){const F=R.split("<=");return r.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(R)){const F=R.split("<");return s.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(R)?p.create(R.substr(1).trim()):b.create(R)}static g(R,P){if(R=R.trim(),R==="true")return!0;if(R==="false")return!1;const F=/^'([^']*)'$/.exec(R);return F?F[1].trim():R}static h(R,P){if((0,T.isFalsyOrWhitespace)(R)){if(P)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const F=R.indexOf("/"),B=R.lastIndexOf("/");if(F===B||F<0){if(P)throw new Error(`bad regexp-value '${R}', missing /-enclosure`);return console.warn(`bad regexp-value '${R}', missing /-enclosure`),null}const z=R.slice(F+1,B),V=R[B+1]==="i"?"i":"";try{return new RegExp(z,V)}catch(K){if(P)throw new Error(`bad regexp-value '${R}', parse error: ${K}`);return console.warn(`bad regexp-value '${R}', parse error: ${K}`),null}}}e.ContextKeyExpr=S;function k(x,R){const P=x?x.substituteConstants():void 0,F=R?R.substituteConstants():void 0;return!P&&!F?!0:!P||!F?!1:P.equals(F)}e.expressionsAreEqualWithConstantSubstitution=k;function M(x,R){return x.cmp(R)}class D{constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=D,D.INSTANCE=new D;class m{constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return D.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class b{static create(R,P=null){const F=L.get(R);return typeof F=="boolean"?F?m.INSTANCE:D.INSTANCE:new b(R,P)}constructor(R,P){this.key=R,this.c=P,this.type=2}cmp(R){return R.type!==this.type?this.type-R.type:g(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=L.get(this.key);return typeof R=="boolean"?R?m.INSTANCE:D.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.c||(this.c=p.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=b;class f{static create(R,P,F=null){if(typeof P=="boolean")return P?b.create(R,F):p.create(R,F);const B=L.get(R);return typeof B=="boolean"?P===(B?"true":"false")?m.INSTANCE:D.INSTANCE:new f(R,P,F)}constructor(R,P,F){this.c=R,this.d=P,this.f=F,this.type=4}cmp(R){return R.type!==this.type?this.type-R.type:O(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=L.get(this.c);if(typeof R=="boolean"){const P=R?"true":"false";return this.d===P?m.INSTANCE:D.INSTANCE}return this}evaluate(R){return R.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(R){return R.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=u.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=f;class t{static create(R,P){return new t(R,P)}constructor(R,P){this.d=R,this.f=P,this.type=10,this.c=null}cmp(R){return R.type!==this.type?this.type-R.type:O(this.d,this.f,R.d,R.f)}equals(R){return R.type===this.type?this.d===R.d&&this.f===R.f:!1}substituteConstants(){return this}evaluate(R){const P=R.getValue(this.f),F=R.getValue(this.d);return Array.isArray(P)?P.includes(F):typeof F=="string"&&typeof P=="object"&&P!==null?C.call(P,F):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(R){return R.mapIn(this.d,this.f)}negate(){return this.c||(this.c=c.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=t;class c{static create(R,P){return new c(R,P)}constructor(R,P){this.d=R,this.f=P,this.type=11,this.c=t.create(R,P)}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(R){return R.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=c;class u{static create(R,P,F=null){if(typeof P=="boolean")return P?p.create(R,F):b.create(R,F);const B=L.get(R);return typeof B=="boolean"?P===(B?"true":"false")?D.INSTANCE:m.INSTANCE:new u(R,P,F)}constructor(R,P,F){this.c=R,this.d=P,this.f=F,this.type=5}cmp(R){return R.type!==this.type?this.type-R.type:O(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=L.get(this.c);if(typeof R=="boolean"){const P=R?"true":"false";return this.d===P?D.INSTANCE:m.INSTANCE}return this}evaluate(R){return R.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(R){return R.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=u;class p{static create(R,P=null){const F=L.get(R);return typeof F=="boolean"?F?D.INSTANCE:m.INSTANCE:new p(R,P)}constructor(R,P){this.c=R,this.d=P,this.type=3}cmp(R){return R.type!==this.type?this.type-R.type:g(this.c,R.c)}equals(R){return R.type===this.type?this.c===R.c:!1}substituteConstants(){const R=L.get(this.c);return typeof R=="boolean"?R?D.INSTANCE:m.INSTANCE:this}evaluate(R){return!R.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(R){return R.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.ContextKeyNotExpr=p;function E(x,R){if(typeof x=="string"){const P=parseFloat(x);isNaN(P)||(x=P)}return typeof x=="string"||typeof x=="number"?R(x):D.INSTANCE}class v{static create(R,P,F=null){return E(P,B=>new v(R,B,F))}constructor(R,P,F){this.c=R,this.d=P,this.f=F,this.type=12}cmp(R){return R.type!==this.type?this.type-R.type:O(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=v;class w{static create(R,P,F=null){return E(P,B=>new w(R,B,F))}constructor(R,P,F){this.c=R,this.d=P,this.f=F,this.type=13}cmp(R){return R.type!==this.type?this.type-R.type:O(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=w;class s{static create(R,P,F=null){return E(P,B=>new s(R,B,F))}constructor(R,P,F){this.c=R,this.d=P,this.f=F,this.type=14}cmp(R){return R.type!==this.type?this.type-R.type:O(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=s;class r{static create(R,P,F=null){return E(P,B=>new r(R,B,F))}constructor(R,P,F){this.c=R,this.d=P,this.f=F,this.type=15}cmp(R){return R.type!==this.type?this.type-R.type:O(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=r;class o{static create(R,P){return new o(R,P)}constructor(R,P){this.d=R,this.f=P,this.type=7,this.c=null}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.d<R.d)return-1;if(this.d>R.d)return 1;const P=this.f?this.f.source:"",F=R.f?R.f.source:"";return P<F?-1:P>F?1:0}equals(R){if(R.type===this.type){const P=this.f?this.f.source:"",F=R.f?R.f.source:"";return this.d===R.d&&P===F}return!1}substituteConstants(){return this}evaluate(R){const P=R.getValue(this.d);return this.f?this.f.test(P):!1}serialize(){const R=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${R}`}keys(){return[this.d]}map(R){return R.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=h.create(this)),this.c}}e.ContextKeyRegexExpr=o;class h{static create(R){return new h(R)}constructor(R){this.c=R,this.type=8}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(R){return new h(this.c.map(R))}negate(){return this.c}}e.ContextKeyNotRegexExpr=h;function a(x){let R=null;for(let P=0,F=x.length;P<F;P++){const B=x[P].substituteConstants();if(x[P]!==B&&R===null){R=[];for(let z=0;z<P;z++)R[z]=x[z]}R!==null&&(R[P]=B)}return R===null?x:R}class l{static create(R,P,F){return l.d(R,P,F)}constructor(R,P){this.expr=R,this.c=P,this.type=6}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let P=0,F=this.expr.length;P<F;P++){const B=M(this.expr[P],R.expr[P]);if(B!==0)return B}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let P=0,F=this.expr.length;P<F;P++)if(!this.expr[P].equals(R.expr[P]))return!1;return!0}return!1}substituteConstants(){const R=a(this.expr);return R===this.expr?this:l.create(R,this.c,!1)}evaluate(R){for(let P=0,F=this.expr.length;P<F;P++)if(!this.expr[P].evaluate(R))return!1;return!0}static d(R,P,F){const B=[];let z=!1;for(const V of R)if(!!V){if(V.type===1){z=!0;continue}if(V.type===0)return D.INSTANCE;if(V.type===6){B.push(...V.expr);continue}B.push(V)}if(B.length===0&&z)return m.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(M);for(let V=1;V<B.length;V++)B[V-1].equals(B[V])&&(B.splice(V,1),V--);if(B.length===1)return B[0];for(;B.length>1;){const V=B[B.length-1];if(V.type!==9)break;B.pop();const K=B.pop(),ie=B.length===0,ge=n.create(V.expr.map(ue=>l.create([ue,K],null,F)),null,ie);ge&&(B.push(ge),B.sort(M))}if(B.length===1)return B[0];if(F){for(let V=0;V<B.length;V++)for(let K=V+1;K<B.length;K++)if(B[V].negate().equals(B[K]))return D.INSTANCE;if(B.length===1)return B[0]}return new l(B,P)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(const P of this.expr)R.push(...P.keys());return R}map(R){return new l(this.expr.map(P=>P.map(R)),null)}negate(){if(!this.c){const R=[];for(const P of this.expr)R.push(P.negate());this.c=n.create(R,this,!0)}return this.c}}class n{static create(R,P,F){return n.d(R,P,F)}constructor(R,P){this.expr=R,this.c=P,this.type=9}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let P=0,F=this.expr.length;P<F;P++){const B=M(this.expr[P],R.expr[P]);if(B!==0)return B}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let P=0,F=this.expr.length;P<F;P++)if(!this.expr[P].equals(R.expr[P]))return!1;return!0}return!1}substituteConstants(){const R=a(this.expr);return R===this.expr?this:n.create(R,this.c,!1)}evaluate(R){for(let P=0,F=this.expr.length;P<F;P++)if(this.expr[P].evaluate(R))return!0;return!1}static d(R,P,F){let B=[],z=!1;if(R){for(let V=0,K=R.length;V<K;V++){const ie=R[V];if(!!ie){if(ie.type===0){z=!0;continue}if(ie.type===1)return m.INSTANCE;if(ie.type===9){B=B.concat(ie.expr);continue}B.push(ie)}}if(B.length===0&&z)return D.INSTANCE;B.sort(M)}if(B.length!==0){if(B.length===1)return B[0];for(let V=1;V<B.length;V++)B[V-1].equals(B[V])&&(B.splice(V,1),V--);if(B.length===1)return B[0];if(F){for(let V=0;V<B.length;V++)for(let K=V+1;K<B.length;K++)if(B[V].negate().equals(B[K]))return m.INSTANCE;if(B.length===1)return B[0]}return new n(B,P)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(const P of this.expr)R.push(...P.keys());return R}map(R){return new n(this.expr.map(P=>P.map(R)),null)}negate(){if(!this.c){const R=[];for(const P of this.expr)R.push(P.negate());for(;R.length>1;){const P=R.shift(),F=R.shift(),B=[];for(const z of J(P))for(const V of J(F))B.push(l.create([z,V],null,!1));R.unshift(n.create(B,null,!1))}this.c=n.create(R,this,!0)}return this.c}}class d extends b{static all(){return d.d.values()}constructor(R,P,F){super(R,null),this.f=P,typeof F=="object"?d.d.push({...F,key:R}):F!==!0&&d.d.push({key:R,description:F,type:P!=null?typeof P:void 0})}bindTo(R){return R.createKey(this.key,this.f)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return f.create(this.key,R)}notEqualsTo(R){return u.create(this.key,R)}}e.RawContextKey=d,d.d=[],e.IContextKeyService=(0,y.createDecorator)("contextKeyService");function g(x,R){return x<R?-1:x>R?1:0}function O(x,R,P,F){return x<P?-1:x>P?1:R<F?-1:R>F?1:0}function N(x,R){if(x.type===0||R.type===1)return!0;if(x.type===9)return R.type===9?q(x.expr,R.expr):!1;if(R.type===9){for(const P of R.expr)if(N(x,P))return!0;return!1}if(x.type===6){if(R.type===6)return q(R.expr,x.expr);for(const P of x.expr)if(N(P,R))return!0;return!1}return x.equals(R)}e.implies=N;function q(x,R){let P=0,F=0;for(;P<x.length&&F<R.length;){const B=x[P].cmp(R[F]);if(B<0)return!1;B===0&&P++,F++}return P===x.length}function J(x){return x.type===9?x.expr:[x]}}),define(Ie[152],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,i.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,i.refineServiceDecorator)(e.IEnvironmentService)}),define(Ie[85],Ce([1,0,129,3]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function y(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=y;function L(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function C(u,p){switch(u){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function A(u,p){return p==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function S(u,p,E){return A(p,E)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===E?!0:k(E).includes(u)}e.isTargetPlatformCompatible=S;function k(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function M(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=M;var D;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(D=e.SortBy||(e.SortBy={}));var m;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var b;(function(u){u.Install="install",u.Uninstall="uninstall"})(b=e.StatisticType||(e.StatisticType={}));var f;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var t;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal",u.Signature="Signature"})(t=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class c extends Error{constructor(p,E){super(p),this.code=E,this.name=E}}e.ExtensionManagementError=c,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,i.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,i.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Ie[36],Ce([1,0,46,19,10,9,2,131,3]),function(ee,e,i,T,y,L,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function k(z){return z.create===!0}e.isFileOpenForWriteOptions=k;var M;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(M=e.FileType||(e.FileType={}));var D;(function(z){z[z.Readonly=1]="Readonly"})(D=e.FilePermission||(e.FilePermission={}));var m;(function(z){z[z.None=0]="None",z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=b;function f(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=f;function t(z){return!!(z.capabilities&32768)}e.hasFileCloneCapability=t;function c(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function u(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=u;function p(z){return b(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=p;var E;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(V,K){super(V),this.code=K}}e.FileSystemProviderError=v;function w(z,V){const K=new v(z.toString(),V);return r(K,V),K}e.createFileSystemProviderError=w;function s(z){return z||w((0,A.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=s;function r(z,V){return z.name=V?`${V} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=r;function o(z){if(!z)return E.Unknown;if(z instanceof v)return z.code;const V=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!V)return E.Unknown;switch(V[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=o;function h(z){if(z instanceof O)return z.fileOperationResult;switch(o(z)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=h;var a;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class l{constructor(V,K,ie){this.resource=V,this.operation=K,this.target=ie}isOperation(V){return this.operation===V}}e.FileOperationEvent=l;var n;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class d{constructor(V,K){this.a=void 0,this.b=void 0,this.c=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=V;const ie=new Map;for(const ge of V){const ue=ie.get(ge.type);switch(ue?ue.push([ge.resource,ge]):ie.set(ge.type,[[ge.resource,ge]]),ge.type){case 1:this.rawAdded.push(ge.resource);break;case 0:this.rawUpdated.push(ge.resource);break;case 2:this.rawDeleted.push(ge.resource);break}}for(const[ge,ue]of ie)switch(ge){case 1:this.a=i.TernarySearchTree.forUris(()=>K),this.a.fill(ue);break;case 0:this.b=i.TernarySearchTree.forUris(()=>K),this.b.fill(ue);break;case 2:this.c=i.TernarySearchTree.forUris(()=>K),this.c.fill(ue);break}}contains(V,...K){return this.d(V,{includeChildren:!1},...K)}affects(V,...K){return this.d(V,{includeChildren:!0},...K)}d(V,K,...ie){if(!V)return!1;const ge=ie.length>0;return!!((!ge||ie.includes(1))&&(this.a?.get(V)||K.includeChildren&&this.a?.findSuperstr(V))||(!ge||ie.includes(0))&&(this.b?.get(V)||K.includeChildren&&this.b?.findSuperstr(V))||(!ge||ie.includes(2))&&(this.c?.findSubstr(V)||K.includeChildren&&this.c?.findSuperstr(V)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=d;function g(z,V,K){return!z||!V||z===V||V.length>z.length?!1:(V.charAt(V.length-1)!==T.sep&&(V+=T.sep),K?(0,y.startsWithIgnoreCase)(z,V):z.indexOf(V)===0)}e.isParent=g;class O extends Error{constructor(V,K,ie){super(V),this.fileOperationResult=K,this.options=ie}}e.FileOperationError=O;class N extends O{constructor(V,K,ie){super(V,2,ie),this.stat=K}}e.NotModifiedSinceFileOperationError=N;var q;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(q=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var J;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(J=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function x(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=x;async function R(z,V){if(!V.hasProvider(C.URI.from({scheme:z.scheme})))return new Promise(K=>{const ie=V.onDidChangeFileSystemProviderRegistrations(ge=>{ge.scheme===z.scheme&&ge.added&&(ie.dispose(),K())})})}e.whenProviderRegistered=R,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class P{static formatSize(V){return(0,L.isNumber)(V)||(V=0),V<P.KB?(0,A.localize)(1,null,V.toFixed(0)):V<P.MB?(0,A.localize)(2,null,(V/P.KB).toFixed(2)):V<P.GB?(0,A.localize)(3,null,(V/P.MB).toFixed(2)):V<P.TB?(0,A.localize)(4,null,(V/P.GB).toFixed(2)):(0,A.localize)(5,null,(V/P.TB).toFixed(2))}}e.ByteSize=P,P.KB=1024,P.MB=P.KB*P.KB,P.GB=P.MB*P.KB,P.TB=P.GB*P.KB;var F;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function B(z){return{maxFileSize:z===0?300*P.MB:16*P.GB,maxHeapSize:z===0?700*P.MB:2*700*P.MB}}e.getPlatformLimits=B}),define(Ie[63],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class i{constructor(...y){this.a=new Map;for(const[L,C]of y)this.set(L,C)}set(y,L){const C=this.a.get(y);return this.a.set(y,L),C}has(y){return this.a.has(y)}get(y){return this.a.get(y)}}e.ServiceCollection=i}),define(Ie[153],Ce([1,0,14,11,7,84,151,3,63,154]),function(ee,e,i,T,y,L,C,A,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const M=!1;class D extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class m{constructor(c=new S.ServiceCollection,u=!1,p,E=M){this.f=c,this.g=u,this.h=p,this.i=E,this.o=new Set,this.f.set(A.IInstantiationService,this),this._globalGraph=E?p?._globalGraph??new C.Graph(v=>v):void 0}createChild(c){return new m(c,this.g,this,this.i)}invokeFunction(c,...u){const p=f.traceInvocation(this.i,c);let E=!1;try{return c({get:w=>{if(E)throw(0,T.illegalState)("service accessor is only valid during the invocation of its target method");const s=this.m(w,p);if(!s)throw new Error(`[invokeFunction] unknown service '${w}'`);return s}},...u)}finally{E=!0,p.stop()}}createInstance(c,...u){let p,E;return c instanceof L.SyncDescriptor?(p=f.traceCreation(this.i,c.ctor),E=this.j(c.ctor,c.staticArguments.concat(u),p)):(p=f.traceCreation(this.i,c),E=this.j(c,u,p)),p.stop(),E}j(c,u=[],p){const E=A._util.getServiceDependencies(c).sort((s,r)=>s.index-r.index),v=[];for(const s of E){const r=this.m(s.id,p);r||this.u(`[createInstance] ${c.name} depends on UNKNOWN service ${s.id}.`,!1),v.push(r)}const w=E.length>0?E[0].index:u.length;if(u.length!==w){console.trace(`[createInstance] First service dependency of ${c.name} at position ${w+1} conflicts with ${u.length} static arguments`);const s=w-u.length;s>0?u=u.concat(new Array(s)):u=u.slice(0,w)}return Reflect.construct(c,u.concat(v))}k(c,u){if(this.f.get(c)instanceof L.SyncDescriptor)this.f.set(c,u);else if(this.h)this.h.k(c,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(c){const u=this.f.get(c);return!u&&this.h?this.h.l(c):u}m(c,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const p=this.l(c);return p instanceof L.SyncDescriptor?this.q(c,p,u.branch(c,!0)):(u.branch(c,!1),p)}q(c,u,p){if(this.o.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.o.add(c);try{return this.r(c,u,p)}finally{this.o.delete(c)}}r(c,u,p){const E=new C.Graph(s=>s.id.toString());let v=0;const w=[{id:c,desc:u,_trace:p}];for(;w.length;){const s=w.pop();if(E.lookupOrInsertNode(s),v++>1e3)throw new D(E);for(const r of A._util.getServiceDependencies(s.desc.ctor)){const o=this.l(r.id);if(o||this.u(`[createInstance] ${c} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(r.id)),o instanceof L.SyncDescriptor){const h={id:r.id,desc:o,_trace:s._trace.branch(r.id,!0)};E.insertEdge(s,h),w.push(h)}}}for(;;){const s=E.roots();if(s.length===0){if(!E.isEmpty())throw new D(E);break}for(const{data:r}of s){if(this.l(r.id)instanceof L.SyncDescriptor){const h=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,h)}E.removeNode(r)}}return this.l(c)}s(c,u,p=[],E,v){if(this.f.get(c)instanceof L.SyncDescriptor)return this.t(c,u,p,E,v);if(this.h)return this.h.s(c,u,p,E,v);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(c,u,p=[],E,v){if(E){const w=new m(void 0,this.g,this,this.i);w.c=String(c);const s=new Map,r=new i.IdleValue(()=>{const o=w.j(u,p,v);for(const[h,a]of s){const l=o[h];if(typeof l=="function")for(const n of a)l.apply(o,n)}return s.clear(),o});return new Proxy(Object.create(null),{get(o,h){if(!r.isInitialized&&typeof h=="string"&&(h.startsWith("onDid")||h.startsWith("onWill"))){let n=s.get(h);return n||(n=new k.LinkedList,s.set(h,n)),(g,O,N)=>{const q=n.push([g,O,N]);return(0,y.toDisposable)(q)}}if(h in o)return o[h];const a=r.value;let l=a[h];return typeof l!="function"||(l=l.bind(a),o[h]=l),l},set(o,h,a){return r.value[h]=a,!0},getPrototypeOf(o){return u.prototype}})}else return this.j(u,p,v)}u(c,u){if(u&&console.warn(c),this.g)throw new Error(c)}}e.InstantiationService=m;var b;(function(t){t[t.None=0]="None",t[t.Creation=1]="Creation",t[t.Invocation=2]="Invocation",t[t.Branch=3]="Branch"})(b||(b={}));class f{static traceInvocation(c,u){return c?new f(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(c,u){return c?new f(1,u.name):f.c}constructor(c,u){this.type=c,this.name=u,this.g=Date.now(),this.h=[]}branch(c,u){const p=new f(3,c.toString());return this.h.push([c,u,p]),p}stop(){const c=Date.now()-this.g;f.f+=c;let u=!1;function p(v,w){const s=[],r=new Array(v+1).join("	");for(const[o,h,a]of w.h)if(h&&a){u=!0,s.push(`${r}CREATES -> ${o}`);const l=p(v+1,a);l&&s.push(l)}else s.push(`${r}uses -> ${o}`);return s.join(`
`)}const E=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(c>2||u)&&f.all.add(E.join(`
`))}}e.Trace=f,f.all=new Set,f.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}},f.f=0}),define(Ie[12],Ce([1,0,45,5,7,28,21,2,3]),function(ee,e,i,T,y,L,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function k(){return new Date().toISOString()}var M;(function(l){l[l.Off=0]="Off",l[l.Trace=1]="Trace",l[l.Debug=2]="Debug",l[l.Info=3]="Info",l[l.Warning=4]="Warning",l[l.Error=5]="Error"})(M=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=M.Info;function D(l,n,d){switch(n){case M.Trace:l.trace(d);break;case M.Debug:l.debug(d);break;case M.Info:l.info(d);break;case M.Warning:l.warn(d);break;case M.Error:l.error(d);break;case M.Off:break;default:throw new Error(`Invalid log level ${n}`)}}e.log=D;function m(l){let n="";for(let d=0;d<l.length;d++){let g=l[d];if(typeof g=="object")try{g=JSON.stringify(g)}catch{}n+=(d>0?" ":"")+g}return n}e.format=m;class b extends y.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new T.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(n){this.b!==n&&(this.b=n,this.c.fire(this.b))}getLevel(){return this.b}f(n){return this.b!==M.Off&&this.b<=n}}e.AbstractLogger=b;class f extends b{constructor(n){super(),this.h=n}f(n){return this.h||super.f(n)}trace(n,...d){this.f(M.Trace)&&this.g(M.Trace,m([n,...d]))}debug(n,...d){this.f(M.Debug)&&this.g(M.Debug,m([n,...d]))}info(n,...d){this.f(M.Info)&&this.g(M.Info,m([n,...d]))}warn(n,...d){this.f(M.Warning)&&this.g(M.Warning,m([n,...d]))}error(n,...d){if(this.f(M.Error))if(n instanceof Error){const g=Array.prototype.slice.call(arguments);g[0]=n.stack,this.g(M.Error,m(g))}else this.g(M.Error,m([n,...d]))}flush(){}}e.AbstractMessageLogger=f;class t extends b{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.g=!C.isWindows}trace(n,...d){this.f(M.Trace)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,n,...d):console.log(`[main ${k()}]`,n,...d))}debug(n,...d){this.f(M.Debug)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,n,...d):console.log(`[main ${k()}]`,n,...d))}info(n,...d){this.f(M.Info)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,n,...d):console.log(`[main ${k()}]`,n,...d))}warn(n,...d){this.f(M.Warning)&&(this.g?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,n,...d):console.warn(`[main ${k()}]`,n,...d))}error(n,...d){this.f(M.Error)&&(this.g?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,n,...d):console.error(`[main ${k()}]`,n,...d))}dispose(){}flush(){}}e.ConsoleMainLogger=t;class c extends b{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...d){this.f(M.Trace)&&console.log("%cTRACE","color: #888",n,...d)}debug(n,...d){this.f(M.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",n,...d)}info(n,...d){this.f(M.Info)&&console.log("%c INFO","color: #33f",n,...d)}warn(n,...d){this.f(M.Warning)&&console.log("%c WARN","color: #993",n,...d)}error(n,...d){this.f(M.Error)&&console.log("%c  ERR","color: #f33",n,...d)}dispose(){}flush(){}}e.ConsoleLogger=c;class u extends b{constructor(n,d=e.DEFAULT_LOG_LEVEL){super(),this.g=n,this.setLevel(d)}trace(n,...d){this.f(M.Trace)&&this.g.log(M.Trace,[this.h(n),...d])}debug(n,...d){this.f(M.Debug)&&this.g.log(M.Debug,[this.h(n),...d])}info(n,...d){this.f(M.Info)&&this.g.log(M.Info,[this.h(n),...d])}warn(n,...d){this.f(M.Warning)&&this.g.log(M.Warning,[this.h(n),...d])}error(n,...d){this.f(M.Error)&&this.g.log(M.Error,[this.h(n),...d])}h(n){return typeof n=="string"?n:(0,i.toErrorMessage)(n,this.f(M.Trace))}dispose(){}flush(){}}e.AdapterLogger=u;class p extends b{constructor(n){super(),this.g=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const d of this.g)d.setLevel(n);super.setLevel(n)}trace(n,...d){for(const g of this.g)g.trace(n,...d)}debug(n,...d){for(const g of this.g)g.debug(n,...d)}info(n,...d){for(const g of this.g)g.info(n,...d)}warn(n,...d){for(const g of this.g)g.warn(n,...d)}error(n,...d){for(const g of this.g)g.error(n,...d)}flush(){for(const n of this.g)n.flush()}dispose(){for(const n of this.g)n.dispose()}}e.MultiplexLogService=p;class E extends y.Disposable{constructor(n){super(),this.b=n,this.B(n)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(n){this.b.setLevel(n)}getLevel(){return this.b.getLevel()}trace(n,...d){this.b.trace(n,...d)}debug(n,...d){this.b.debug(n,...d)}info(n,...d){this.b.info(n,...d)}warn(n,...d){this.b.warn(n,...d)}error(n,...d){this.b.error(n,...d)}flush(){this.b.flush()}}e.LogService=E;class v extends y.Disposable{constructor(n,d){super(),this.c=n,this.b=new L.ResourceMap,this.B(d(g=>this.setLevel(g)))}getLoggers(){return[...this.b.values()].map(({logger:n})=>n)}getLogger(n){return this.b.get(n)?.logger}createLogger(n,d,g){let O=this.b.get(n)?.logger;return O||(g=d?.always?M.Trace:g,O=this.f(n,g??this.c,d),this.b.set(n,{logger:O,logLevel:g})),O}setLevel(n,d){const g=A.URI.isUri(n)?n:void 0,O=g?d:n;if(g){const N=this.b.get(g);N&&N.logLevel!==O&&(N.logLevel=O,N.logger.setLevel(O))}else this.c=O,this.b.forEach(({logLevel:N,logger:q})=>{N===void 0&&q.setLevel(this.c)})}getLogLevel(n){return this.b.get(n)?.logLevel}dispose(){this.b.forEach(({logger:n})=>n.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=v;class w{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(n){}getLevel(){return M.Info}trace(n,...d){}debug(n,...d){}info(n,...d){}warn(n,...d){}error(n,...d){}critical(n,...d){}dispose(){}flush(){}}e.NullLogger=w;class s extends w{}e.NullLogService=s;class r extends v{constructor(){super(M.Info,T.Event.None)}f(n,d,g){return new w}}e.NullLoggerService=r;function o(l){if(l.verbose)return M.Trace;if(typeof l.logLevel=="string"){const n=a(l.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function h(l){switch(l){case M.Trace:return"trace";case M.Debug:return"debug";case M.Info:return"info";case M.Warning:return"warn";case M.Error:return"error";case M.Off:return"off"}}e.LogLevelToString=h;function a(l){switch(l){case"trace":return M.Trace;case"debug":return M.Debug;case"info":return M.Info;case"warn":return M.Warning;case"error":return M.Error;case"critical":return M.Error;case"off":return M.Off}}e.parseLogLevel=a}),define(Ie[86],Ce([1,0,29,132,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(L=e.MarkerTag||(e.MarkerTag={}));var C;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function k(f,t){return t-f}S.compare=k;const M=Object.create(null);M[S.Error]=(0,T.localize)(0,null),M[S.Warning]=(0,T.localize)(1,null),M[S.Info]=(0,T.localize)(2,null);function D(f){return M[f]||""}S.toString=D;function m(f){switch(f){case i.default.Error:return S.Error;case i.default.Warning:return S.Warning;case i.default.Info:return S.Info;case i.default.Ignore:return S.Hint}}S.fromSeverity=m;function b(f){switch(f){case S.Error:return i.default.Error;case S.Warning:return i.default.Warning;case S.Info:return i.default.Info;case S.Hint:return i.default.Ignore}}S.toSeverity=b}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(S){const k="";function M(m){return D(m,!0)}S.makeKey=M;function D(m,b){const f=[k];return m.source?f.push(m.source.replace("\xA6","\\\xA6")):f.push(k),m.code?typeof m.code=="string"?f.push(m.code.replace("\xA6","\\\xA6")):f.push(m.code.value.replace("\xA6","\\\xA6")):f.push(k),m.severity!==void 0&&m.severity!==null?f.push(C.toString(m.severity)):f.push(k),m.message&&b?f.push(m.message.replace("\xA6","\\\xA6")):f.push(k),m.startLineNumber!==void 0&&m.startLineNumber!==null?f.push(m.startLineNumber.toString()):f.push(k),m.startColumn!==void 0&&m.startColumn!==null?f.push(m.startColumn.toString()):f.push(k),m.endLineNumber!==void 0&&m.endLineNumber!==null?f.push(m.endLineNumber.toString()):f.push(k),m.endColumn!==void 0&&m.endColumn!==null?f.push(m.endColumn.toString()):f.push(k),f.push(k),f.join("\xA6")}S.makeKeyOptionalMessage=D})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,y.createDecorator)("markerService")}),define(Ie[155],Ce([1,0,5,29,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=T.default,e.INotificationService=(0,y.createDecorator)("notificationService");var L;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(L=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new S,this.onDidClose=i.Event.None,this.onDidChangeVisibility=i.Event.None}updateSeverity(M){}updateMessage(M){}updateActions(M){}close(){}}e.NoOpNotification=A;class S{infinite(){}done(){}total(M){}worked(M){}}e.NoOpProgress=S}),define(Ie[87],Ce([1,0,10,2,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,y.createDecorator)("openerService");function L(k,M){return T.URI.isUri(k)?(0,i.equalsIgnoreCase)(k.scheme,M):(0,i.startsWithIgnoreCase)(k,M+":")}e.matchesScheme=L;function C(k,...M){return M.some(D=>L(k,D))}e.matchesSomeScheme=C;function A(k,M){return k.with({fragment:`${M.startLineNumber},${M.startColumn}${M.endLineNumber?`-${M.endLineNumber}${M.endColumn?`,${M.endColumn}`:""}`:""}`})}e.withSelection=A;function S(k){let M;const D=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(k.fragment);return D&&(M={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1,endLineNumber:D[4]?parseInt(D[4]):void 0,endColumn:D[4]?D[5]?parseInt(D[5]):1:void 0},k=k.with({fragment:""})),{selection:M,uri:k}}e.extractSelection=S}),define(Ie[156],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,i.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(ee,e,i,T){var y=arguments.length,L=y<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,i):T,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(ee,e,i,T);else for(var A=ee.length-1;A>=0;A--)(C=ee[A])&&(L=(y<3?C(L):y>3?C(e,i,L):C(e,i))||L);return y>3&&L&&Object.defineProperty(e,i,L),L},Ve=this&&this.__param||function(ee,e){return function(i,T){e(i,T,ee)}};define(Ie[157],Ce([1,0,14,20,7,3]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,L.createDecorator)("progressService");var C;(function(M){M[M.Explorer=1]="Explorer",M[M.Scm=3]="Scm",M[M.Extensions=5]="Extensions",M[M.Window=10]="Window",M[M.Notification=15]="Notification",M[M.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this.a}constructor(D){this.b=D}report(D){this.a=D,this.b(this.a)}}e.Progress=A,A.None=Object.freeze({report(){}});let S=class extends y.Disposable{constructor(D,m){super(),this.a=new i.DeferredPromise,m.withProgress(D,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,y.toDisposable)(()=>this.a.complete()))}report(D){this.b?this.b.report(D):this.c=D}};S=qe([Ve(1,e.IProgressService)],S),e.UnmanagedProgress=S;class k extends y.Disposable{constructor(D){super(),this.g=D,this.a=0,this.b=this.B(new y.DisposableStore)}start(D){this.stop();const m=++this.a,b=new T.CancellationTokenSource;return this.f=setTimeout(()=>{m===this.a&&(this.c=this.g.show(!0))},D),this.b.add((0,y.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,y.toDisposable)(()=>b.cancel())),this.b.add((0,y.toDisposable)(()=>this.c?this.c.done():void 0)),{id:m,token:b.token,stop:()=>this.h(m),isCurrent:()=>this.a===m}}stop(){this.h(this.a)}h(D){this.a===D&&this.b.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,L.createDecorator)("editorProgressService")}),define(Ie[30],Ce([1,0,47,9]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class y{constructor(){this.a=new Map}add(C,A){i.ok(T.isString(C)),i.ok(T.isObject(A)),i.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,A)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.Registry=new y}),define(Ie[88],Ce([1,0,5,30]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function y(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class L{constructor(){this.b=new i.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,k){this.a[y(S)]=k,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const C=new L;T.Registry.add(e.Extensions.JSONContribution,C)}),define(Ie[89],Ce([1,0,16,5,9,128,40,88,30]),function(ee,e,i,T,y,L,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var M;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(M=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const D=S.Registry.as(A.Extensions.JSONContribution);class m{constructor(){this.h=new Set,this.i=new T.Emitter,this.onDidSchemaChange=this.i.event,this.j=new T.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.r()}registerConfiguration(s,r=!0){this.registerConfigurations([s],r)}registerConfigurations(s,r=!0){const o=this.k(s,r);D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(s){const r=this.l(s);D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:s,remove:r}){const o=[];o.push(...this.l(r)),o.push(...this.k(s,!1)),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:(0,i.distinct)(o)})}registerDefaultConfigurations(s){const r=[],o=[];for(const{overrides:h,source:a}of s)for(const l in h)if(r.push(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const n=this.a.get(l),d=n?.valuesSources??new Map;if(a)for(const q of Object.keys(h[l]))d.set(q,a);const g={...n?.value||{},...h[l]};this.a.set(l,{source:a,value:g,valuesSources:d});const O=(0,C.getLanguageTagSettingPlainKey)(l),N={type:"object",default:g,description:L.localize(1,null,O),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:g,source:y.isString(a)?void 0:a,defaultValueSource:a};o.push(...t(l)),this.d[l]=N,this.b.properties[l]=N}else{this.a.set(l,{value:h[l],source:a});const n=this.d[l];n&&(this.s(l,n),this.o(l,n))}this.registerOverrideIdentifiers(o),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const r=[];for(const{overrides:o,source:h}of s)for(const a in o){const l=this.a.get(a),n=y.isString(h)?h:h?.id,d=y.isString(l?.source)?l?.source:l?.source?.id;if(n===d)if(r.push(a),this.a.delete(a),e.OVERRIDE_PROPERTY_REGEX.test(a))delete this.d[a],delete this.b.properties[a];else{const g=this.d[a];g&&(this.s(a,g),this.o(a,g))}}this.q(),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){for(const r of s)this.h.add(r);this.q()}k(s,r){const o=[];return s.forEach(h=>{o.push(...this.m(h,r,h.extensionInfo,h.restrictedProperties)),this.c.push(h),this.n(h)}),o}l(s){const r=[],o=h=>{if(h.properties)for(const a in h.properties){r.push(a);const l=this.d[a];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[a],this.p(a,h.properties[a])}h.allOf?.forEach(a=>o(a))};for(const h of s){o(h);const a=this.c.indexOf(h);a!==-1&&this.c.splice(a,1)}return r}m(s,r=!0,o,h,a=3){a=y.isUndefinedOrNull(s.scope)?a:s.scope;const l=[],n=s.properties;if(n)for(const g in n){const O=n[g];if(r&&E(g,O)){delete n[g];continue}if(O.source=o,O.defaultDefaultValue=n[g].default,this.s(g,O),e.OVERRIDE_PROPERTY_REGEX.test(g)?O.scope=void 0:(O.scope=y.isUndefinedOrNull(O.scope)?a:O.scope,O.restricted=y.isUndefinedOrNull(O.restricted)?!!h?.includes(g):O.restricted),n[g].hasOwnProperty("included")&&!n[g].included){this.f[g]=n[g],delete n[g];continue}else this.d[g]=n[g],n[g].policy?.name&&this.e.set(n[g].policy.name,g);!n[g].deprecationMessage&&n[g].markdownDeprecationMessage&&(n[g].deprecationMessage=n[g].markdownDeprecationMessage),l.push(g)}const d=s.allOf;if(d)for(const g of d)l.push(...this.m(g,r,o,h,a));return l}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}n(s){const r=o=>{const h=o.properties;if(h)for(const l in h)this.o(l,h[l]);o.allOf?.forEach(r)};r(s)}o(s,r){switch(e.allSettings.properties[s]=r,r.scope){case 1:e.applicationSettings.properties[s]=r;break;case 2:e.machineSettings.properties[s]=r;break;case 6:e.machineOverridableSettings.properties[s]=r;break;case 3:e.windowSettings.properties[s]=r;break;case 4:e.resourceSettings.properties[s]=r;break;case 5:e.resourceSettings.properties[s]=r,this.g.properties[s]=r;break}}p(s,r){switch(delete e.allSettings.properties[s],r.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.g.properties[s];break}}q(){for(const s of this.h.values()){const r=`[${s}]`,o={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.s(r,o),e.allSettings.properties[r]=o,e.applicationSettings.properties[r]=o,e.machineSettings.properties[r]=o,e.machineOverridableSettings.properties[r]=o,e.windowSettings.properties[r]=o,e.resourceSettings.properties[r]=o}this.i.fire()}r(){const s={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this.i.fire()}s(s,r){const o=this.a.get(s);let h=o?.value,a=o?.source;y.isUndefined(h)&&(h=r.defaultDefaultValue,a=void 0),y.isUndefined(h)&&(h=u(r.type)),r.default=h,r.defaultValueSource=a}}const b="\\[([^\\]]+)\\]",f=new RegExp(b,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${b})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(w){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(w)){let r=f.exec(w);for(;r?.length;){const o=r[1].trim();o&&s.push(o),r=f.exec(w)}}return(0,i.distinct)(s)}e.overrideIdentifiersFromKey=t;function c(w){return w.reduce((s,r)=>`${s}[${r}]`,"")}e.keyFromOverrideIdentifiers=c;function u(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const p=new m;S.Registry.add(e.Extensions.Configuration,p);function E(w,s){return w.trim()?e.OVERRIDE_PROPERTY_REGEX.test(w)?L.localize(7,null,w):p.getConfigurationProperties()[w]!==void 0?L.localize(8,null,w):s.policy?.name&&p.getPolicyConfigurations().get(s.policy?.name)!==void 0?L.localize(9,null,w,s.policy?.name,p.getPolicyConfigurations().get(s.policy?.name)):null:L.localize(6,null)}e.validateProperty=E;function v(){const w=[],s=p.getConfigurationProperties();for(const r of Object.keys(s))w.push([r,s[r].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=v}),define(Ie[158],Ce([1,0,16,5,109,7,28,23,9,2,40,89,30]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class b{constructor(r={},o=[],h=[],a){this.c=r,this.d=o,this.f=h,this.raw=a,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(o=>{if(o instanceof b)return o;const h=new f("");return h.parseRaw(o),h.configurationModel});this.g=r.reduce((o,h)=>h===o?h:o.merge(h),r[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(r){return r?(0,M.getConfigurationValue)(this.contents,r):this.contents}inspect(r,o){const h=this.rawConfiguration.getValue(r),a=o?this.rawConfiguration.getOverrideValue(r,o):void 0,l=o?this.rawConfiguration.override(o).getValue(r):h;return{value:h,override:a,merged:l}}getOverrideValue(r,o){const h=this.l(o);return h?r?(0,M.getConfigurationValue)(h,r):h:void 0}getKeysForOverrideIdentifier(r){const o=[];for(const h of this.overrides)h.identifiers.includes(r)&&o.push(...h.keys);return i.distinct(o)}getAllOverrideIdentifiers(){const r=[];for(const o of this.overrides)r.push(...o.identifiers);return i.distinct(r)}override(r){let o=this.b.get(r);return o||(o=this.h(r),this.b.set(r,o)),o}merge(...r){const o=A.deepClone(this.contents),h=A.deepClone(this.overrides),a=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const n of r)if(l.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.j(o,n.contents);for(const d of n.overrides){const[g]=h.filter(O=>i.equals(O.identifiers,d.identifiers));g?(this.j(g.contents,d.contents),g.keys.push(...d.keys),g.keys=i.distinct(g.keys)):h.push(A.deepClone(d))}for(const d of n.keys)a.indexOf(d)===-1&&a.push(d)}return new b(o,a,h,l.every(n=>n instanceof b)?void 0:l)}freeze(){return this.a=!0,this}clone(){return new b(A.deepClone(this.contents),[...this.keys],A.deepClone(this.overrides))}h(r){const o=this.l(r);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const h={};for(const a of i.distinct([...Object.keys(this.contents),...Object.keys(o)])){let l=this.contents[a];const n=o[a];n&&(typeof l=="object"&&typeof n=="object"?(l=A.deepClone(l),this.j(l,n)):l=n),h[a]=l}return new b(h,this.keys,this.overrides)}j(r,o){for(const h of Object.keys(o)){if(h in r&&S.isObject(r[h])&&S.isObject(o[h])){this.j(r[h],o[h]);continue}r[h]=A.deepClone(o[h])}}k(r){return this.a&&!Object.isFrozen(r)?A.deepFreeze(r):r}l(r){let o=null,h=null;const a=l=>{l&&(h?this.j(h,l):h=A.deepClone(l))};for(const l of this.overrides)i.equals(l.identifiers,[r])?o=l.contents:l.identifiers.includes(r)&&a(l.contents);return a(o),h}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,o){this.m(r),(0,M.addToValueTree)(this.contents,r,o,h=>{throw new Error(h)})}removeValue(r){this.n(r)&&(0,M.removeFromValueTree)(this.contents,r)}m(r){let o=this.keys.length;for(let h=0;h<o;h++)r.indexOf(this.keys[h])===0&&(o=h);this.keys.splice(o,1,r)}n(r){const o=this.keys.indexOf(r);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=b;class f{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new b}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,o){if(!S.isUndefinedOrNull(r)){const h=this.g(r);this.parseRaw(h,o)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,o){this.a=r;const{contents:h,keys:a,overrides:l,restricted:n,hasExcludedProperties:d}=this.h(r,o);this.b=new b(h,a,l,d?[r]:void 0),this.c=n||[]}g(r){let o={},h=null,a=[];const l=[],n=[];function d(O){Array.isArray(a)?a.push(O):h!==null&&(a[h]=O)}const g={onObjectBegin:()=>{const O={};d(O),l.push(a),a=O,h=null},onObjectProperty:O=>{h=O},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{const O=[];d(O),l.push(a),a=O,h=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:d,onError:(O,N,q)=>{n.push({error:O,offset:N,length:q})}};if(r)try{y.visit(r,g),o=a[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return o}h(r,o){const h=m.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),a=this.j(r,h,!0,o);r=a.raw;const l=(0,M.toValuesTree)(r,g=>console.error(`Conflict in settings file ${this.f}: ${g}`)),n=Object.keys(r),d=this.l(r,g=>console.error(`Conflict in settings file ${this.f}: ${g}`));return{contents:l,keys:n,overrides:d,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}j(r,o,h,a){let l=!1;if(!a?.scopes&&!a?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:l};const n={},d=[];for(const g in r)if(D.OVERRIDE_PROPERTY_REGEX.test(g)&&h){const O=this.j(r[g],o,!1,a);n[g]=O.raw,l=l||O.hasExcludedProperties,d.push(...O.restricted)}else{const O=o[g],N=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&d.push(g),(N===void 0||a.scopes===void 0||a.scopes.includes(N))&&!(a.skipRestricted&&O?.restricted)?n[g]=r[g]:l=!0}return{raw:n,restricted:d,hasExcludedProperties:l}}l(r,o){const h=[];for(const a of Object.keys(r))if(D.OVERRIDE_PROPERTY_REGEX.test(a)){const l={};for(const n in r[a])l[n]=r[a][n];h.push({identifiers:(0,D.overrideIdentifiersFromKey)(a),keys:Object.keys(l),contents:(0,M.toValuesTree)(l,o)})}return h}}e.ConfigurationModelParser=f;class t extends L.Disposable{constructor(r,o,h,a){super(),this.f=r,this.g=o,this.h=a,this.c=this.B(new T.Emitter),this.onDidChange=this.c.event,this.a=new f(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(h.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(T.Event.any(T.Event.filter(this.h.onDidFilesChange,l=>l.contains(this.f)),T.Event.filter(this.h.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&h.isEqual(l.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new b}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=t;class c{constructor(r,o,h,a,l,n,d,g,O,N,q,J,x){this.a=r,this.b=o,this.value=h,this.overrideIdentifiers=a,this.c=l,this.d=n,this.f=d,this.g=g,this.h=O,this.j=N,this.k=q,this.l=J,this.m=x}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class u{constructor(r,o,h,a,l=new b,n=new b,d=new C.ResourceMap,g=new b,O=new C.ResourceMap,N=!0){this.c=r,this.d=o,this.f=h,this.g=a,this.h=l,this.j=n,this.l=d,this.m=g,this.n=O,this.p=N,this.a=null,this.b=new C.ResourceMap,this.q=null}getValue(r,o,h){return this.s(r,o,h).getValue(r)}updateValue(r,o,h={}){let a;h.resource?(a=this.n.get(h.resource),a||(a=new b,this.n.set(h.resource,a))):a=this.m,o===void 0?a.removeValue(r):a.setValue(r,o),h.resource||(this.a=null)}inspect(r,o,h){const a=this.s(r,o,h),l=i.distinct(a.overrides.map(g=>g.identifiers).flat()).filter(g=>a.getOverrideValue(r,g)!==void 0),n=this.w(o.resource,h),d=o.resource?this.n.get(o.resource)||this.m:this.m;return new c(r,o,a.getValue(r),l.length?l:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),h?this.j.freeze():void 0,n?n.freeze():void 0,d.inspect(r,o.overrideIdentifier))}keys(r){const o=this.w(void 0,r);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.j=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,o){this.l.set(r,o),this.b.delete(r)}deleteFolderConfiguration(r){this.r.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,o){const h=[];if(!o){const{added:a,updated:l,removed:n}=v(this.c,r);o=[...a,...l,...n]}for(const a of o)for(const l of(0,D.overrideIdentifiersFromKey)(a)){const n=this.c.getKeysForOverrideIdentifier(l),d=r.getKeysForOverrideIdentifier(l),g=[...d.filter(O=>n.indexOf(O)===-1),...n.filter(O=>d.indexOf(O)===-1),...n.filter(O=>!A.equals(this.c.override(l).getValue(O),r.override(l).getValue(O)))];h.push([l,g])}return this.updateDefaultConfiguration(r),{keys:o,overrides:h}}compareAndUpdatePolicyConfiguration(r){const{added:o,updated:h,removed:a}=v(this.d,r),l=[...o,...h,...a];return l.length&&this.updatePolicyConfiguration(r),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:o,updated:h,removed:a,overrides:l}=v(this.applicationConfiguration,r),n=[...o,...h,...a];return n.length&&this.updateApplicationConfiguration(r),{keys:n,overrides:l}}compareAndUpdateLocalUserConfiguration(r){const{added:o,updated:h,removed:a,overrides:l}=v(this.localUserConfiguration,r),n=[...o,...h,...a];return n.length&&this.updateLocalUserConfiguration(r),{keys:n,overrides:l}}compareAndUpdateRemoteUserConfiguration(r){const{added:o,updated:h,removed:a,overrides:l}=v(this.remoteUserConfiguration,r),n=[...o,...h,...a];return n.length&&this.updateRemoteUserConfiguration(r),{keys:n,overrides:l}}compareAndUpdateWorkspaceConfiguration(r){const{added:o,updated:h,removed:a,overrides:l}=v(this.workspaceConfiguration,r),n=[...o,...h,...a];return n.length&&this.updateWorkspaceConfiguration(r),{keys:n,overrides:l}}compareAndUpdateFolderConfiguration(r,o){const h=this.r.get(r),{added:a,updated:l,removed:n,overrides:d}=v(h,o),g=[...a,...l,...n];return(g.length||!h)&&this.updateFolderConfiguration(r,o),{keys:g,overrides:d}}compareAndDeleteFolderConfiguration(r){const o=this.r.get(r);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:h,updated:a,removed:l,overrides:n}=v(o,void 0);return{keys:[...h,...a,...l],overrides:n}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(r,o,h){let a=this.t(o,h);return o.overrideIdentifier&&(a=a.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(a=a.merge(this.d)),a}t({resource:r},o){let h=this.u();if(o&&r){const a=o.getFolder(r);a&&(h=this.v(a.uri)||h);const l=this.n.get(r);l&&(h=h.merge(l))}return h}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(r){let o=this.b.get(r);if(!o){const h=this.u(),a=this.l.get(r);a?(o=h.merge(a),this.p&&(o=o.freeze()),this.b.set(r,o)):o=h}return o}w(r,o){if(o&&r){const h=o.getFolder(r);if(h)return this.l.get(h.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((r,o)=>{const{contents:h,overrides:a,keys:l}=this.l.get(o);return r.push([o,{contents:h,overrides:a,keys:l}]),r},[])}}allKeys(){const r=new Set;return this.c.freeze().keys.forEach(o=>r.add(o)),this.userConfiguration.freeze().keys.forEach(o=>r.add(o)),this.j.freeze().keys.forEach(o=>r.add(o)),this.l.forEach(o=>o.freeze().keys.forEach(h=>r.add(h))),[...r.values()]}x(){const r=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o)),this.j.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o)),this.l.forEach(o=>o.freeze().getAllOverrideIdentifiers().forEach(h=>r.add(h))),[...r.values()]}y(r){const o=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(h=>o.add(h)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(h=>o.add(h)),this.j.getKeysForOverrideIdentifier(r).forEach(h=>o.add(h)),this.l.forEach(h=>h.getKeysForOverrideIdentifier(r).forEach(a=>o.add(a))),[...o.values()]}static parse(r){const o=this.z(r.defaults),h=this.z(r.policy),a=this.z(r.application),l=this.z(r.user),n=this.z(r.workspace),d=r.folders.reduce((g,O)=>(g.set(k.URI.revive(O[0]),this.z(O[1])),g),new C.ResourceMap);return new u(o,h,a,l,new b,n,d,new b,new C.ResourceMap,!1)}static z(r){return new b(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=u;function p(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const r=new Set,o=new Map;for(const a of s)a.keys.forEach(l=>r.add(l)),a.overrides.forEach(([l,n])=>{const d=(0,C.getOrSet)(o,l,new Set);n.forEach(g=>d.add(g))});const h=[];return o.forEach((a,l)=>h.push([l,[...a.values()]])),{keys:[...r.values()],overrides:h}}e.mergeChanges=p;class E{constructor(r,o,h,a){this.change=r,this.b=o,this.c=h,this.d=a,this.f=void 0;const l=new Set;r.keys.forEach(d=>l.add(d)),r.overrides.forEach(([,d])=>d.forEach(g=>l.add(g))),this.affectedKeys=[...l.values()];const n=new b;this.affectedKeys.forEach(d=>n.setValue(d,{})),this.a=n.contents}get previousConfiguration(){return!this.f&&this.b&&(this.f=u.parse(this.b.data)),this.f}affectsConfiguration(r,o){if(this.g(this.a,r)){if(o){const h=this.previousConfiguration?this.previousConfiguration.getValue(r,o,this.b?.workspace):void 0,a=this.c.getValue(r,o,this.d);return!A.equals(h,a)}return!0}return!1}g(r,o){let h=(0,M.toValuesTree)({[o]:!0},()=>{}),a;for(;typeof h=="object"&&(a=Object.keys(h)[0]);){if(r=r[a],!r)return!1;h=h[a]}return!0}}e.ConfigurationChangeEvent=E;function v(s,r){const{added:o,removed:h,updated:a}=w(r?.rawConfiguration,s?.rawConfiguration),l=[],n=s?.getAllOverrideIdentifiers()||[],d=r?.getAllOverrideIdentifiers()||[];if(r){const g=d.filter(O=>!n.includes(O));for(const O of g)l.push([O,r.getKeysForOverrideIdentifier(O)])}if(s){const g=n.filter(O=>!d.includes(O));for(const O of g)l.push([O,s.getKeysForOverrideIdentifier(O)])}if(r&&s){for(const g of n)if(d.includes(g)){const O=w({contents:s.getOverrideValue(void 0,g)||{},keys:s.getKeysForOverrideIdentifier(g)},{contents:r.getOverrideValue(void 0,g)||{},keys:r.getKeysForOverrideIdentifier(g)});l.push([g,[...O.added,...O.removed,...O.updated]])}}return{added:o,removed:h,updated:a,overrides:l}}function w(s,r){const o=s?r?s.keys.filter(l=>r.keys.indexOf(l)===-1):[...s.keys]:[],h=r?s?r.keys.filter(l=>s.keys.indexOf(l)===-1):[...r.keys]:[],a=[];if(s&&r){for(const l of r.keys)if(s.keys.indexOf(l)!==-1){const n=(0,M.getConfigurationValue)(r.contents,l),d=(0,M.getConfigurationValue)(s.contents,l);A.equals(n,d)||a.push(l)}}return{added:o,removed:h,updated:a}}}),define(Ie[90],Ce([1,0,11,3]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,T.createDecorator)("remoteAuthorityResolverService");var y;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(y=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends i.ErrorNoTelemetry{static isNotAvailable(A){return A instanceof L&&A._code===y.NotAvailable}static isTemporarilyNotAvailable(A){return A instanceof L&&A._code===y.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof L&&A._code===y.NoResolverFound}static isHandled(A){return A instanceof L&&A.isHandled}constructor(A,S=y.Unknown,k){super(A),this._message=A,this._code=S,this._detail=k,this.isHandled=S===y.NotAvailable&&k===!0,Object.setPrototypeOf(this,L.prototype)}}e.RemoteAuthorityResolverError=L}),define(Ie[48],Ce([1,0,13]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function T(k){return k.scheme===i.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=T;function y(k){if(!k)return;const M=k.indexOf("+");return M<0?k:k.substr(0,M)}e.getRemoteName=y;function L(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=L;function C(k){const{host:M,port:D}=S(k);if(typeof D>"u")throw new Error("Remote authority doesn't contain a port!");return{host:M,port:D}}e.parseAuthorityWithPort=C;function A(k,M){let{host:D,port:m}=S(k);return typeof m>"u"&&(m=M),{host:D,port:m}}e.parseAuthorityWithOptionalPort=A;function S(k){const M=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(M)return{host:M[1],port:parseInt(M[2],10)};const D=k.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const m=k.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:k,port:void 0}}}),define(Ie[26],Ce([1,0,10,3,48]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=L;function C(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var S;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class k{constructor(t){this.value=t,this.c=t.toLowerCase()}static equals(t,c){if(typeof t>"u"||t===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof t=="string"||typeof c=="string"){const u=typeof t=="string"?t:t.value,p=typeof c=="string"?c:c.value;return i.equalsIgnoreCase(u,p)}return t.c===c.c}static toKey(t){return typeof t=="string"?t.toLowerCase():t.c}}e.ExtensionIdentifier=k;function M(f){return D(f)}e.isApplicationScopedExtension=M;function D(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function m(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function b(f,t){if(t){const c=`onResolveRemoteAuthority:${(0,y.getRemoteName)(t)}`;return f.activationEvents?.indexOf(c)!==-1}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ie[159],Ce([1,0,10,85,26,21,2,11,49]),function(ee,e,i,T,y,L,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function k(r,o){return r.uuid&&o.uuid?r.uuid===o.uuid:r.id===o.id?!0:(0,i.compareIgnoreCase)(r.id,o.id)===0}e.areSameExtensions=k;const M=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class D{static create(o){const h=o.manifest?o.manifest.version:o.version,a=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new D(o.identifier,h,a)}static parse(o){const h=M.exec(o);return h&&h[1]&&h[2]?new D({id:h[1]},h[2],h[4]||void 0):null}constructor(o,h,a="undefined"){this.version=h,this.targetPlatform=a,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof D?k(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=D;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(r){const o=m.exec(r);return o&&o[1]?[t(o[1]),o[2]]:[t(r),void 0]}e.getIdAndVersion=b;function f(r,o){return`${r}.${o}`}e.getExtensionId=f;function t(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=t;function c(r,o){return t(f(r,o))}e.getGalleryExtensionId=c;function u(r,o){const h=[],a=l=>{for(const n of h)if(n.some(d=>k(o(d),o(l))))return n;return null};for(const l of r){const n=a(l);n?n.push(l):h.push([l])}return h}e.groupByExtension=u;function p(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function E(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new y.ExtensionIdentifier("pprice.better-merge");function v(r,o){const h=[],a=o.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const l=a.shift();if(l&&h.every(n=>!k(n.identifier,{id:l}))){const n=r.filter(d=>k(d.identifier,{id:l}));n.length===1&&(h.push(n[0]),a.push(...n[0].manifest.extensionDependencies?.slice(0)??[]))}}return h}e.getExtensionDependencies=v;async function w(r,o){if(!L.isLinux)return!1;let h;try{h=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{h=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){o.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(l))}}return!!h&&(h.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=w;async function s(r,o){const h=await w(r,o),a=(0,T.getTargetPlatform)(h?"alpine":L.platform,S.arch);return o.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=s}),define(Ie[160],Ce([1,0,21,49,2,34]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function C(k){if(i.platform===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}async function A(k,M,D,m,b,f,t,c,u,p){const E=Object.create(null);E["common.machineId"]=t,E.sessionID=(0,L.generateUuid)()+Date.now(),E.commitHash=b,E.version=f,E["common.platformVersion"]=(M||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,i.PlatformToString)(i.platform),E["common.nodePlatform"]=T.platform,E["common.nodeArch"]=m,E["common.product"]=p||"desktop",c&&(E["common.msftInternal"]=c);let v=0;const w=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-w,enumerable:!0},"common.sequence":{get:()=>v++,enumerable:!0}}),i.isLinuxSnap&&(E["common.snap"]="true");const s=C(D);s&&(E["common.platformDetail"]=s);try{const r=await k.readFile(y.URI.file(u));E["common.source"]=r.value.toString().slice(0,30)}catch{}return E}e.resolveCommonProperties=A;function S(k){const M=T.env.USERDNSDOMAIN;if(!M)return!1;const D=M.toLowerCase();return k.some(m=>D===m)}e.verifyMicrosoftInternalDomain=S}),define(Ie[161],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,i.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,i.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var T;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(T=e.TelemetryLevel||(e.TelemetryLevel={}));var y;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(y=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ie[91],Ce([1,0,23,9,40,48,160,161]),function(ee,e,i,T,y,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TrustedTelemetryValue=void 0;class S{constructor(l){this.value=l}}e.TrustedTelemetryValue=S;class k{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(l,n){return Promise.resolve(void 0)}publicLog2(l,n){return this.publicLog(l,n)}publicLogError(l,n){return Promise.resolve(void 0)}publicLogError2(l,n){return this.publicLogError(l,n)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=k,e.NullTelemetryService=new k;class M{async publicLog(l,n,d){}async publicLogError(l,n,d){}}e.NullEndpointTelemetryService=M,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function D(a,l){return l.onDidChangeConfiguration(n=>{n.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,y.ConfigurationTargetToString)(n.source),configurationKeys:E(n.sourceConfig)})})}e.configurationTelemetry=D;function m(a,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!a.enableTelemetry||l.extensionTestsLocationURI)}e.supportsTelemetry=m;function b(a,l){return!(l.isBuilt||l.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}e.isLoggingOnly=b;function f(a){const l=a.getValue(A.TELEMETRY_SETTING_ID),n=a.getValue("telemetry.enableCrashReporter");if(a.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=f;function t(a){const l={},n={},d={};p(a,d);for(let g in d){g=g.length>150?g.substr(g.length-149):g;const O=d[g];typeof O=="number"?n[g]=O:typeof O=="boolean"?n[g]=O?1:0:typeof O=="string"?(O.length>8192&&console.warn(`Telemetry property: ${g} has been trimmed to 8192, the original length is ${O.length}`),l[g]=O.substring(0,8191)):typeof O<"u"&&O!==null&&(l[g]=O)}return{properties:l,measurements:n}}e.validateTelemetryData=t;const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function u(a){if(!a)return"none";const l=(0,L.getRemoteName)(a);return c.has(l)?l:"other"}e.cleanRemoteAuthority=u;function p(a,l,n=0,d){if(!!a)for(const g of Object.getOwnPropertyNames(a)){const O=a[g],N=d?d+g:g;Array.isArray(O)?l[N]=(0,i.safeStringify)(O):O instanceof Date?l[N]=O.toISOString():(0,T.isObject)(O)?n<2?p(O,l,n+1,N+"."):l[N]=(0,i.safeStringify)(O):l[N]=O}}function E(a){if(!a)return[];const l=[];return v(l,"",a),l}function v(a,l,n){n&&typeof n=="object"&&!Array.isArray(n)?Object.keys(n).forEach(d=>v(a,l?`${l}.${d}`:d,n[d])):a.push(l)}function w(a,l){const n=a.msftInternalDomains||[],d=l.getValue("telemetry.internalTesting");return(0,C.verifyMicrosoftInternalDomain)(n)||d}e.isInternalTelemetry=w;function s(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=s;function r(a,l){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let n=a;const d=[];for(const q of l)for(;;){const J=q.exec(a);if(!J)break;d.push([J.index,q.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,O=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let N=0;for(n="";;){const q=O.exec(a);if(!q)break;const J=d.some(([x,R])=>q.index<R&&x<O.lastIndex);!g.test(q[0])&&!J&&(n+=a.substring(N,q.index)+"<REDACTED: user-file-path>",N=O.lastIndex)}return N<a.length&&(n+=a.substr(N)),n}function o(a){if(!a)return a;const l=a.toLowerCase(),n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of n)if(d.regex.test(l))return`<REDACTED: ${d.label}>`;return a}function h(a,l){return(0,i.cloneAndChange)(a,n=>{if(n instanceof S)return n.value;if(typeof n=="string"){let d=n.replaceAll("%20"," ");d=r(d,l);for(const g of l)d=d.replace(g,"");return d=o(d),d}})}e.cleanData=h}),define(Ie[162],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class i{constructor(y){this.b=y,this.a=new Map}dispose(){for(const y of this.a.values())y.dispose()}startBuffering(y,L,C=5){const A=L(S=>{const k=typeof S=="string"?S:S.data;let M=this.a.get(y);if(M){M.data.push(k);return}const D=setTimeout(()=>this.flushBuffer(y),C);M={data:[k],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(y),A.dispose()}},this.a.set(y,M)});return A}stopBuffering(y){this.a.get(y)?.dispose()}flushBuffer(y){const L=this.a.get(y);L&&(this.a.delete(y),this.b(y,L.data.join("")))}}e.TerminalDataBufferer=i}),define(Ie[163],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var i;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST_DARK="hcDark",L.HIGH_CONTRAST_LIGHT="hcLight"})(i=e.ColorScheme||(e.ColorScheme={}));function T(L){return L===i.HIGH_CONTRAST_DARK||L===i.HIGH_CONTRAST_LIGHT}e.isHighContrast=T;function y(L){return L===i.DARK||L===i.HIGH_CONTRAST_DARK}e.isDark=y}),define(Ie[64],Ce([1,0,121,5,7,3,30,163]),function(ee,e,i,T,y,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var S;(function(c){function u(p){return p&&typeof p=="object"&&typeof p.id=="string"}c.isThemeColor=u})(S=e.ThemeColor||(e.ThemeColor={}));function k(c){return{id:c}}e.themeColorFromId=k;var M;(function(c){function u(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||S.isThemeColor(h.color))}c.isThemeIcon=u;const p=new RegExp(`^\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)$`);function E(h){const a=p.exec(h);if(!a)return;const[,l]=a;return{id:l}}c.fromString=E;function v(h){return{id:h}}c.fromId=v;function w(h,a){let l=h.id;const n=l.lastIndexOf("~");return n!==-1&&(l=l.substring(0,n)),a&&(l=`${l}~${a}`),{id:l}}c.modify=w;function s(h){const a=h.id.lastIndexOf("~");if(a!==-1)return h.id.substring(a+1)}c.getModifier=s;function r(h,a){return h.id===a.id&&h.color?.id===a.color?.id}c.isEqual=r;function o(h,a){return{id:h.id,color:a?k(a):void 0}}c.asThemeIcon=o,c.asClassNameArray=i.CSSIcon.asClassNameArray,c.asClassName=i.CSSIcon.asClassName,c.asCSSSelector=i.CSSIcon.asCSSSelector})(M=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=i.Codicon.file,e.FolderThemeIcon=i.Codicon.folder;function D(c){switch(c){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case A.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=D,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.a=[],this.a=[],this.b=new T.Emitter}onColorThemeChange(u){return this.a.push(u),this.b.fire(u),(0,y.toDisposable)(()=>{const p=this.a.indexOf(u);this.a.splice(p,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const b=new m;C.Registry.add(e.Extensions.ThemingContribution,b);function f(c){return b.onColorThemeChange(c)}e.registerThemingParticipant=f;class t extends y.Disposable{constructor(u){super(),this.k=u,this.h=u.getColorTheme(),this.B(this.k.onDidColorThemeChange(p=>this.n(p)))}n(u){this.h=u,this.updateStyles()}updateStyles(){}w(u,p){let E=this.h.getColor(u);return E&&p&&(E=p(E,this.h)),E?E.toString():null}}e.Themable=t}),define(Ie[164],Ce([1,0,5,40,3,12]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,y.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,y.createDecorator)("sharedTunnelsService");var C;(function(t){t.Http="http",t.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!c)return{address:c[1],port:+c[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function M(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=M,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function D(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=D;function m(t,c,u,p){if(u===1)return!1;if(u===2&&D(c)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(p);if(E?.length===4&&parseInt(E[1])>=18)return!1}return t<1024}e.isPortPrivileged=m;class b{constructor(c,u,p){this.remoteAddress=c,this.localAddress=u,this.b=p,this.a=new i.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=b;let f=class{constructor(c,u){this.i=c,this.j=u,this.a=new i.Emitter,this.onTunnelOpened=this.a.event,this.b=new i.Emitter,this.onTunnelClosed=this.b.event,this.c=new i.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const c=this.j.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this.e=c,c?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this.f=c.elevation,this.g=c.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const c=[],u=Array.from(this.d.values());for(const p of u){const E=Array.from(p.values());for(const v of E){const w=await v.value;w&&c.push(w)}}return c}async dispose(){for(const c of this.d.values()){for(const{value:u}of c.values())await u.then(p=>p?.dispose());c.clear()}this.d.clear()}setEnvironmentTunnel(c,u,p,E,v){this.o(c,u,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:u,localAddress:p,privacy:E,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,u){(D(c)||M(c))&&(c=e.LOCALHOST_ADDRESSES[0]);const p=this.q(c,u);if(p)return++p.refcount,p.value}openTunnel(c,u,p,E,v=!1,w,s){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${p} on local port ${E}.`),!c)return;if(u||(u="localhost"),this.e&&this.h.has(p)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(c,u,p,E,v,w,s);return r?r.then(o=>{if(!o){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,p);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const h=this.m(o);return(o.tunnelRemoteHost!==u||o.tunnelRemotePort!==p)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(h),h}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const u=this.d.get(c.tunnelRemoteHost);if(u){const p=u.get(c.tunnelRemotePort);p&&(p.refcount--,await this.n(c.tunnelRemoteHost,c.tunnelRemotePort,p))}}}}async n(c,u,p){if(p.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${u}.`);const E=p.value.then(async v=>{v&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.d.has(c)&&this.d.get(c).delete(u),E}}async closeTunnel(c,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${u} `);const p=this.d.get(c);if(p&&p.has(u)){const E=p.get(u);E.refcount=0,await this.n(c,u,E)}}o(c,u,p){this.d.has(c)||this.d.set(c,new Map),this.d.get(c).set(u,{refcount:1,value:p})}async p(c,u){const p=this.d.get(c);p&&(await p.get(u)||p.delete(u),p.size===0&&this.d.delete(c))}q(c,u){const p=[c];M(c)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):D(c)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const E=p.map(v=>this.d.get(v));for(const v of E){const w=v?.get(u);if(w)return w}}canTunnel(c){return!!k(c)}s(c,u,p,E,v,w,s){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${p} on local port ${E}.`);const r=p;this.h.add(r);const o=E===void 0?p:E,h={elevationRequired:v?this.isPortPrivileged(o):!1},a={remoteAddress:{host:u,port:p},localAddressPort:E,privacy:w,public:w?w!==A.Private:void 0,protocol:s},l=c.forwardPort(a,h);return l?(this.o(u,p,l),l.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(r)})):this.h.delete(r),l}};f=qe([Ve(0,L.ILogService),Ve(1,T.IConfigurationService)],f),e.AbstractTunnelService=f}),define(Ie[165],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,i.createDecorator)("editSessionIdentityService");var T;(function(y){y[y.Complete=100]="Complete",y[y.Partial=50]="Partial",y[y.None=0]="None"})(T=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Ie[166],Ce([1,0,13]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function T(S){return S.scheme!==i.Schemas.file&&S.scheme!==i.Schemas.vscodeRemote}e.isVirtualResource=T;function y(S){if(S.folders.length)return S.folders.every(k=>T(k.uri))?S.folders[0].uri:void 0;if(S.configuration&&T(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=y;function L(S){return y(S)?.scheme}e.getVirtualWorkspaceScheme=L;function C(S){return y(S)?.authority}e.getVirtualWorkspaceAuthority=C;function A(S){return y(S)!==void 0}e.isVirtualWorkspace=A}),define(Ie[50],Ce([1,0,133,19,46,22,2,3,13]),function(ee,e,i,T,y,L,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function k(r){const o=r;return typeof o?.id=="string"&&C.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=k,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function M(r,o){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,T.basename)(r)}:o?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const h=r;if(h.configuration)return{id:h.id,configPath:h.configuration};if(h.folders.length===1)return{id:h.id,uri:h.folders[0].uri}}e.toWorkspaceIdentifier=M;function D(r){const o=r;return typeof o?.id=="string"&&C.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=D;function m(r){const o=r;if(o?.uri)return{id:o.id,uri:C.URI.revive(o.uri)};const h=r;if(h?.configPath)return{id:h.id,configPath:C.URI.revive(h.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=m;var b;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(b=e.WorkbenchState||(e.WorkbenchState={}));function f(r){const o=r;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=f;function t(r){const o=r;return!!(o&&typeof o=="object"&&C.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=t;class c{constructor(o,h,a,l,n){this.h=o,this.j=a,this.k=l,this.l=n,this.c=y.TernarySearchTree.forUris(this.l,()=>!0),this.folders=h}update(o){this.h=o.id,this.k=o.configuration,this.j=o.transient,this.l=o.l,this.folders=o.folders}get folders(){return this.g}set folders(o){this.g=o,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(o){this.k=o}getFolder(o){return o&&this.c.findSubstr(o)||null}n(){this.c=y.TernarySearchTree.forUris(this.l,()=>!0);for(const o of this.folders)this.c.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=c;class u{constructor(o,h){this.raw=h,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,L.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function p(r){return new u({uri:r,index:0,name:(0,L.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,i.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(r,o){return L.extUriBiasedIgnorePathCase.isEqualOrParent(r,o.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function v(r){let o;return C.URI.isUri(r)?o=r:o=r.configuration,o?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=v;function w(r,o){return!E(r,o)&&!v(r)}e.isSavedWorkspace=w;function s(r){return(typeof r=="string"?(0,T.extname)(r):(0,L.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(Ie[51],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class i{constructor(y){this.d=y,this.b=new Map,this.c=1}add(y){const L=this.c++;return this.b.set(L,y),this.e(),L}get(y,L){return this.b.has(y)?this.b.get(y)[L]:void 0}delete(y){this.b.delete(y),this.e()}e(){!i.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=i,i.a=!1}),define(Ie[37],Ce([1,0,13,22,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class L{constructor(){this.a=new Set(Object.keys(i.Schemas)),this.b=new Map,this.extUri=new T.ExtUri(A=>{const S=this.b.get(A.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(A,S){S===null?this.b.delete(A.scheme):this.b.set(A.scheme,S)}isFreeScheme(A){return!this.b.has(A)&&!this.a.has(A)}getCapabilities(A){return this.b.get(A)}}e.ExtHostFileSystemInfo=L,e.IExtHostFileSystemInfo=(0,y.createDecorator)("IExtHostFileSystemInfo")}),define(Ie[27],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,i.createDecorator)("IExtHostInitDataService")}),define(Ie[167],Ce([1,0,14]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class T{constructor(C,A,S){this.h=new Map,this.a=C,this.b=A,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new i.RunOnceScheduler(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const M of k.values())M.complete()}catch(M){for(const D of k.values())D.error(M)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this.d}get(C,A){let S=this.f[C];return typeof S>"u"&&(S=A),S}update(C,A){this.f[C]=A;const S=this.h.get(C);if(S!==void 0)return S.p;const k=new i.DeferredPromise;return this.h.set(C,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.ExtensionMemento=T;class y extends T{setKeysForSync(C){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},C)}constructor(C,A){super(C.identifier.value,!0,A),this.j=C}}e.ExtensionGlobalMemento=y}),define(Ie[168],Ce([1,0,5,2]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class y{constructor(C){this.c=C,this.a=new i.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new i.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(C,A,S,k){const D=this.c.getNotebookDocument(T.URI.revive(C)).acceptModelChanged(A.value,S,k);this.b.fire(D)}$acceptDirtyStateChanged(C,A){this.c.getNotebookDocument(T.URI.revive(C)).acceptDirty(A)}$acceptModelSaved(C){const A=this.c.getNotebookDocument(T.URI.revive(C));this.a.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=y}),define(Ie[15],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,i.createDecorator)("IExtHostRpcService");class T{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.ExtHostRpcService=T});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[169],Ce([1,0,26,5]),function(ee,e,i,T){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class L{constructor(A,S){y.set(this,void 0),this.b=new T.Emitter,this.onDidChange=this.b.event,this.a=i.ExtensionIdentifier.toKey(A.identifier),Ye(this,y,S,"f"),Re(this,y,"f").onDidChangePassword(k=>{k.extensionId===this.a&&this.b.fire({key:k.key})})}get(A){return Re(this,y,"f").get(this.a,A)}store(A,S){return Re(this,y,"f").store(this.a,A,S)}delete(A){return Re(this,y,"f").delete(this.a,A)}}e.ExtensionSecrets=L,y=new WeakMap}),define(Ie[65],Ce([1,0,3,164,5,15]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var C;(function(S){function k(D){return{remoteAddress:D.remoteAddress,localAddress:D.localAddress,public:!!D.public,privacy:D.privacy??(D.public?T.TunnelPrivacyId.Public:T.TunnelPrivacyId.Private),protocol:D.protocol}}S.fromApiTunnel=k;function M(D){return{remoteAddress:{host:D.tunnelRemoteHost,port:D.tunnelRemotePort},localAddress:D.localAddress,public:D.privacy!==T.TunnelPrivacyId.ConstantPrivate&&D.privacy!==T.TunnelPrivacyId.ConstantPrivate,privacy:D.privacy,protocol:D.protocol}}S.fromServiceTunnel=M})(C=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,i.createDecorator)("IExtHostTunnelService");let A=class{constructor(k){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,M){}async getTunnels(){return[]}async setTunnelFactory(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,M){return{dispose:()=>{}}}async $providePortAttributes(k,M,D,m,b){return[]}async $forwardPort(k,M){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=qe([Ve(0,L.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(Ie[52],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,i.createDecorator)("IURITransformerService");class T{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=T}),define(Ie[170],Ce([1,0,24]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class T{constructor(){this.buffers=[]}add(S){let k=this.buffers.indexOf(S);return k<0&&(k=this.buffers.length,this.buffers.push(S)),k}}function y(A,S){if(S.serializeBuffersForPostMessage){const k=new T,M=(b,f)=>{if(f instanceof ArrayBuffer){const t=k.add(f);return{$$vscode_array_buffer_reference$$:!0,index:t}}else if(ArrayBuffer.isView(f)){const t=L(f);if(t){const c=k.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:c,view:{type:t,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},D=JSON.stringify(A,M),m=k.buffers.map(b=>{const f=new Uint8Array(b);return i.VSBuffer.wrap(f)});return{message:D,buffers:m}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=y;function L(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(A,S){const k=S.map(m=>{const b=new ArrayBuffer(m.byteLength);return new Uint8Array(b).set(m.buffer),b}),M=S.length?(m,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const f=b,{index:t}=f,c=k[t];if(f.view)switch(f.view.type){case 1:return new Int8Array(c,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(c,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(c,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(c,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(c,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(c,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(c,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(c,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(c,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(c,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(c,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return c}return b}:void 0;return{message:JSON.parse(A,M),arrayBuffers:k}}e.deserializeWebviewMessage=C}),define(Ie[92],Ce([1,0,141,9,2,7,3,30,36,13]),function(ee,e,i,T,y,L,C,A,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,i.localize)(0,null),providerDisplayName:(0,i.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var M;(function(K){K[K.PROGRAMMATIC=1]="PROGRAMMATIC",K[K.USER=2]="USER",K[K.EDIT=3]="EDIT",K[K.NAVIGATION=4]="NAVIGATION",K[K.JUMP=5]="JUMP"})(M=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var D;(function(K){K[K.IDENTICAL=1]="IDENTICAL",K[K.SIMILAR=2]="SIMILAR",K[K.DIFFERENT=3]="DIFFERENT"})(D=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function m(K){const ie=K;return!!ie&&typeof ie.getSelection=="function"&&!!ie.onDidChangeSelection}e.isEditorPaneWithSelection=m;function b(K,ie,ge){for(const ue of ge.visibleEditorPanes)if(ue.group.id===ie&&K.matches(ue.input))return ue.getViewState()}e.findViewStateForEditor=b;function f(K){if(a(K))return!1;const ie=K;return y.URI.isUri(ie?.resource)}e.isResourceEditorInput=f;function t(K){if(a(K))return!1;const ie=K;return ie?.original!==void 0&&ie.modified!==void 0}e.isResourceDiffEditorInput=t;function c(K){if(a(K)||t(K))return!1;const ie=K;return ie?.primary!==void 0&&ie.secondary!==void 0}e.isResourceSideBySideEditorInput=c;function u(K){if(a(K))return!1;const ie=K;return ie?ie.resource===void 0||ie.resource.scheme===k.Schemas.untitled||ie.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=u;const p=/Untitled-\d+/;function E(K){return K.scheme===k.Schemas.untitled&&K.path.length>1&&!p.test(K.path)}e.isUntitledWithAssociatedResource=E;function v(K){if(a(K))return!1;const ie=K;return y.URI.isUri(ie?.base?.resource)&&y.URI.isUri(ie?.input1?.resource)&&y.URI.isUri(ie?.input2?.resource)&&y.URI.isUri(ie?.result?.resource)}e.isResourceMergeEditorInput=v;var w;(function(K){K[K.SHORT=0]="SHORT",K[K.MEDIUM=1]="MEDIUM",K[K.LONG=2]="LONG"})(w=e.Verbosity||(e.Verbosity={}));var s;(function(K){K[K.EXPLICIT=1]="EXPLICIT",K[K.AUTO=2]="AUTO",K[K.FOCUS_CHANGE=3]="FOCUS_CHANGE",K[K.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s=e.SaveReason||(e.SaveReason={}));class r{constructor(){this.a=new Map}registerSource(ie,ge){let ue=this.a.get(ie);return ue||(ue={source:ie,label:ge},this.a.set(ie,ue)),ue.source}getSourceLabel(ie){return this.a.get(ie)?.label??ie}}e.SaveSourceRegistry=new r;var o;(function(K){K[K.None=0]="None",K[K.Readonly=2]="Readonly",K[K.Untitled=4]="Untitled",K[K.Singleton=8]="Singleton",K[K.RequiresTrust=16]="RequiresTrust",K[K.CanSplitInGroup=32]="CanSplitInGroup",K[K.ForceDescription=64]="ForceDescription",K[K.CanDropIntoEditor=128]="CanDropIntoEditor",K[K.MultipleEditors=256]="MultipleEditors"})(o=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class h extends L.Disposable{}e.AbstractEditorInput=h;function a(K){return K instanceof h}e.isEditorInput=a;function l(K){const ie=K;return y.URI.isUri(ie?.preferredResource)}function n(K){const ie=K;return a(ie?.primary)&&a(ie?.secondary)}e.isSideBySideEditorInput=n;function d(K){const ie=K;return a(ie?.modified)&&a(ie?.original)}e.isDiffEditorInput=d;function g(K){return a(K?.editor)}e.isEditorInputWithOptions=g;function O(K){const ie=K;return g(K)&&ie?.group!==void 0}e.isEditorInputWithOptionsAndGroup=O;function N(K){const ie=K;return typeof ie?.groupId=="number"&&a(ie.editor)}e.isEditorIdentifier=N;var q;(function(K){K[K.UNKNOWN=0]="UNKNOWN",K[K.REPLACE=1]="REPLACE",K[K.MOVE=2]="MOVE",K[K.UNPIN=3]="UNPIN"})(q=e.EditorCloseContext||(e.EditorCloseContext={}));var J;(function(K){K[K.GROUP_ACTIVE=0]="GROUP_ACTIVE",K[K.GROUP_INDEX=1]="GROUP_INDEX",K[K.GROUP_LOCKED=2]="GROUP_LOCKED",K[K.EDITOR_OPEN=3]="EDITOR_OPEN",K[K.EDITOR_CLOSE=4]="EDITOR_CLOSE",K[K.EDITOR_MOVE=5]="EDITOR_MOVE",K[K.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",K[K.EDITOR_LABEL=7]="EDITOR_LABEL",K[K.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",K[K.EDITOR_PIN=9]="EDITOR_PIN",K[K.EDITOR_STICKY=10]="EDITOR_STICKY",K[K.EDITOR_DIRTY=11]="EDITOR_DIRTY",K[K.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(J=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var x;(function(K){K[K.PRIMARY=1]="PRIMARY",K[K.SECONDARY=2]="SECONDARY",K[K.BOTH=3]="BOTH",K[K.ANY=4]="ANY"})(x=e.SideBySideEditor||(e.SideBySideEditor={}));class R{getOriginalUri(ie,ge){if(!ie)return;if(v(ie))return e.EditorResourceAccessor.getOriginalUri(ie.result,ge);if(ge?.supportSideBySide){const{primary:re,secondary:se}=this.a(ie);if(re&&se){if(ge?.supportSideBySide===x.BOTH)return{primary:this.getOriginalUri(re,{filterByScheme:ge.filterByScheme}),secondary:this.getOriginalUri(se,{filterByScheme:ge.filterByScheme})};if(ge?.supportSideBySide===x.ANY)return this.getOriginalUri(re,{filterByScheme:ge.filterByScheme})??this.getOriginalUri(se,{filterByScheme:ge.filterByScheme});ie=ge.supportSideBySide===x.PRIMARY?re:se}}if(t(ie)||c(ie)||v(ie))return;const ue=l(ie)?ie.preferredResource:ie.resource;return!ue||!ge||!ge.filterByScheme?ue:this.b(ue,ge.filterByScheme)}a(ie){return n(ie)||c(ie)?{primary:ie.primary,secondary:ie.secondary}:d(ie)||t(ie)?{primary:ie.modified,secondary:ie.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ie,ge){if(!ie)return;if(v(ie))return e.EditorResourceAccessor.getCanonicalUri(ie.result,ge);if(ge?.supportSideBySide){const{primary:re,secondary:se}=this.a(ie);if(re&&se){if(ge?.supportSideBySide===x.BOTH)return{primary:this.getCanonicalUri(re,{filterByScheme:ge.filterByScheme}),secondary:this.getCanonicalUri(se,{filterByScheme:ge.filterByScheme})};if(ge?.supportSideBySide===x.ANY)return this.getCanonicalUri(re,{filterByScheme:ge.filterByScheme})??this.getCanonicalUri(se,{filterByScheme:ge.filterByScheme});ie=ge.supportSideBySide===x.PRIMARY?re:se}}if(t(ie)||c(ie)||v(ie))return;const ue=ie.resource;return!ue||!ge||!ge.filterByScheme?ue:this.b(ue,ge.filterByScheme)}b(ie,ge){if(Array.isArray(ge)){if(ge.some(ue=>ie.scheme===ue))return ie}else if(ge===ie.scheme)return ie}}e.EditorResourceAccessor=new R;var P;(function(K){K[K.LEFT=0]="LEFT",K[K.RIGHT=1]="RIGHT"})(P=e.CloseDirection||(e.CloseDirection={}));class F{constructor(){this.c=new Map,this.d=new Map}start(ie){const ge=this.a=ie.get(C.IInstantiationService);for(const[ue,re]of this.c)this.e(ue,re,ge);this.c.clear()}e(ie,ge,ue){const re=ue.createInstance(ge);this.d.set(ie,re)}registerFileEditorFactory(ie){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ie}getFileEditorFactory(){return(0,T.assertIsDefined)(this.b)}registerEditorSerializer(ie,ge){if(this.c.has(ie)||this.d.has(ie))throw new Error(`A editor serializer with type ID '${ie}' was already registered.`);return this.a?this.e(ie,ge,this.a):this.c.set(ie,ge),(0,L.toDisposable)(()=>{this.c.delete(ie),this.d.delete(ie)})}getEditorSerializer(ie){return this.d.get(typeof ie=="string"?ie:ie.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new F);async function B(K,ie,ge){return!K||!K.length?[]:await Promise.all(K.map(async ue=>{const re=y.URI.revive(ue.fileUri);if(!re){ge.info("Cannot resolve the path because it is not valid.",ue);return}if(!await ie.canHandleResource(re)){ge.info("Cannot resolve the path because it cannot be handled",ue);return}let le=ue.exists,_=ue.type;if(typeof le!="boolean"||typeof _!="number")try{_=(await ie.stat(re)).isDirectory?S.FileType.Directory:S.FileType.Unknown,le=!0}catch(we){ge.error(we),le=!1}if(!le&&ue.openOnlyIfExists){ge.info("Cannot resolve the path because it does not exist",ue);return}if(_===S.FileType.Directory){ge.info("Cannot resolve the path because it is a directory",ue);return}const me={...ue.options,pinned:!0};return le?{resource:re,options:me}:{resource:re,options:me,forceUntitled:!0}}))}e.pathsToEditors=B;var z;(function(K){K[K.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",K[K.SEQUENTIAL=1]="SEQUENTIAL"})(z=e.EditorsOrder||(e.EditorsOrder={}));function V(K){const ie=K;if(!ie)return!1;const ge=ie;if(ge.modified)return V(ge.modified);const ue=ie;return!!(ue.contributionsState&&ue.viewState&&Array.isArray(ue.cursorState))}e.isTextEditorViewState=V}),define(Ie[171],Ce([1,0,5,14,142]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new i.Emitter,this.n=new i.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(A){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=A}onEvent(A){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=A}onRequest(A){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=A}sendResponse(A){A.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.s("response",A)}sendRequest(A,S,k,M){const D={command:A};if(S&&Object.keys(S).length>0&&(D.arguments=S),this.s("request",D),typeof M=="number"){const m=setTimeout(()=>{clearTimeout(m);const b=this.f.get(D.seq);if(b){this.f.delete(D.seq);const f={type:"response",seq:0,request_seq:D.seq,success:!1,command:A,message:(0,y.localize)(0,null,M,A)};b(f)}},M)}return k&&this.f.set(D.seq,k),D.seq}acceptMessage(A){this.j?this.j(A):(this.k.push(A),this.k.length===1&&this.q())}o(A,S){return A.type!=="event"||S.type!=="event"}async q(){let A;for(;this.k.length;){if((!A||this.o(this.k[0],A))&&await(0,T.timeout)(0),A=this.k.shift(),!A)return;switch(A.type){case"event":this.i?.(A);break;case"request":this.g?.(A);break;case"response":{const S=A,k=this.f.get(S.request_seq);k&&(this.f.delete(S.request_seq),k(S));break}}}}s(A,S){S.type=A,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const A=new Map;this.f.forEach((S,k)=>A.set(k,S)),await(0,T.timeout)(500),A.forEach((S,k)=>{S({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=L}),define(Ie[172],Ce([1,0,143,41,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new T.RawContextKey("debugType",void 0,{type:"string",description:i.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new T.RawContextKey("debugConfigurationType",void 0,{type:"string",description:i.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new T.RawContextKey("debugState","inactive",{type:"string",description:i.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new T.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:i.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new T.RawContextKey("inDebugMode",!1,{type:"boolean",description:i.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new T.RawContextKey("inDebugRepl",!1,{type:"boolean",description:i.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new T.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:i.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new T.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:i.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new T.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:i.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new T.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:i.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new T.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:i.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new T.RawContextKey("variablesFocused",!0,{type:"boolean",description:i.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new T.RawContextKey("expressionSelected",!1,{type:"boolean",description:i.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new T.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:i.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new T.RawContextKey("callStackItemType",void 0,{type:"string",description:i.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new T.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:i.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new T.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:i.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new T.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:i.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new T.RawContextKey("watchItemType",void 0,{type:"string",description:i.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new T.RawContextKey("canViewMemory",void 0,{type:"boolean",description:i.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new T.RawContextKey("breakpointItemType",void 0,{type:"string",description:i.localize(20,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new T.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:i.localize(21,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new T.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:i.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new T.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:i.localize(23,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new T.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:i.localize(24,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new T.RawContextKey("stepBackSupported",!1,{type:"boolean",description:i.localize(25,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new T.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:i.localize(26,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new T.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:i.localize(27,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new T.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:i.localize(28,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new T.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:i.localize(29,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new T.RawContextKey("breakpointsExist",!1,{type:"boolean",description:i.localize(30,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new T.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:i.localize(31,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new T.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:i.localize(32,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new T.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:i.localize(33,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new T.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:i.localize(34,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new T.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:i.localize(35,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new T.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:i.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new T.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:i.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new T.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:i.localize(38,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new T.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:i.localize(39,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new T.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:i.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new T.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:i.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new T.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:i.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new T.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:i.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new T.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:i.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new T.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:i.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new T.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:i.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new T.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:i.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new T.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:i.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new T.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:i.localize(49,null)});const L=m=>i.localize(50,null,m);e.debuggerDisabledMessage=L,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:i.localize(51,null)};var C;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(C=e.State||(e.State={}));function A(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var S;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var k;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(k=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var M;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(M=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,y.createDecorator)("debugService");var D;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(D=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ie[173],Ce([1,0,10,2,19,23,13]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function S(o,h,a){return o.replace(A,function(l,n){return h&&n.length>0&&n[0]!=="_"?l:a&&a.hasOwnProperty(n)?a[n]:l})}e.formatPII=S;function k(o){const h={};for(const a of Object.keys(o))a.startsWith("!")||(h[a]=o[a]);return h}e.filterExceptionsFromTelemetry=k;function M(o){return o.configuration.request==="attach"&&!D(o)&&(!o.parentSession||M(o.parentSession))}e.isSessionAttach=M;function D(o){let h=o.configuration.type;if(!!h)return h==="vslsShare"&&(h=o.configuration.adapterProxy.configuration.type),(0,i.equalsIgnoreCase)(h,"extensionhost")||(0,i.equalsIgnoreCase)(h,"pwa-extensionhost")?o:o.parentSession?D(o.parentSession):void 0}e.getExtensionHostDebugSession=D;function m(o){return o.type&&(o.label||o.program||o.runtime)}e.isDebuggerMainContribution=m;function b(o,h,a){let l,n=0;const d=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let g=null;for(;g=d.exec(o);){const O=g.index+1,N=O+g[0].length;if(O<=h&&N>=a){l=g[0],n=O;break}}if(l){const O=/\w+/g;let N=null;for(;(N=O.exec(l))&&!(N.index+1+n+N[0].length>=a););N&&(l=l.substring(0,O.lastIndex))}return l?{start:n,end:n+l.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=b;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function t(o){return!!(o&&o.match(f))}e.isUri=t;function c(o){if(typeof o.path=="string"&&!(typeof o.sourceReference=="number"&&o.sourceReference>0)){if(t(o.path))return T.URI.parse(o.path);if((0,y.isAbsolute)(o.path))return T.URI.file(o.path)}return o.path}function u(o){if(typeof o.path=="object"){const h=T.URI.revive(o.path);if(h)return h.scheme===C.Schemas.file?h.fsPath:h.toString()}return o.path}function p(o,h){const a=h?c:u,l=(0,L.deepClone)(o);return v(l,(n,d)=>{n&&d&&(d.path=a(d))}),l}e.convertToDAPaths=p;function E(o,h){const a=h?c:u,l=(0,L.deepClone)(o);return v(l,(n,d)=>{!n&&d&&(d.path=a(d))}),l}e.convertToVSCPaths=E;function v(o,h){switch(o.type){case"event":{const a=o;switch(a.event){case"output":h(!1,a.body.source);break;case"loadedSource":h(!1,a.body.source);break;case"breakpoint":h(!1,a.body.breakpoint.source);break;default:break}break}case"request":{const a=o;switch(a.command){case"setBreakpoints":h(!0,a.arguments.source);break;case"breakpointLocations":h(!0,a.arguments.source);break;case"source":h(!0,a.arguments.source);break;case"gotoTargets":h(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(l=>h(!1,l));break;default:break}break}case"response":{const a=o;if(a.success&&a.body)switch(a.command){case"stackTrace":a.body.stackFrames.forEach(l=>h(!1,l.source));break;case"loadedSources":a.body.sources.forEach(l=>h(!1,l));break;case"scopes":a.body.scopes.forEach(l=>h(!1,l.source));break;case"setFunctionBreakpoints":a.body.breakpoints.forEach(l=>h(!1,l.source));break;case"setBreakpoints":a.body.breakpoints.forEach(l=>h(!1,l.source));break;case"disassemble":a.body?.instructions.forEach(n=>h(!1,n.location));break;default:break}break}}}function w(o){return o.filter(h=>!h.presentation?.hidden).sort((h,a)=>h.presentation?a.presentation?h.presentation.group?a.presentation.group?h.presentation.group!==a.presentation.group?h.presentation.group.localeCompare(a.presentation.group):s(h.presentation.order,a.presentation.order):-1:a.presentation.group?1:s(h.presentation.order,a.presentation.order):-1:a.presentation?1:0)}e.getVisibleAndSorted=w;function s(o,h){return typeof o!="number"?typeof h!="number"?0:1:typeof h!="number"?-1:o-h}async function r(o,h){const a=o.getValue("debug.saveBeforeStart",{overrideIdentifier:h.activeTextEditorLanguageId});if(a!=="none"&&(await h.saveAll(),a==="allEditorsInActiveGroup")){const l=h.activeEditorPane;l&&l.input.resource?.scheme===C.Schemas.untitled&&await h.save({editor:l.input,groupId:l.group.id})}await o.reloadConfiguration()}e.saveAllBeforeDebugStart=r}),define(Ie[66],Ce([1,0,24,35,174,61,13,19,21,41]),function(ee,e,i,T,y,L,C,A,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var M;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(M=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.latex,L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.latex,L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={}));var m;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(m=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var b;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(b=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var t;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(t=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var u;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(u=e.CellEditType||(e.CellEditType={}));var p;(function(B){B.scheme=C.Schemas.vscodeNotebookCell;const z=["W","X","Y","Z","a","b","c","d","e","f"],V=new RegExp(`^[${z.join("")}]+`),K=7;function ie(_,me){const we=me.toString(K),We=`${we.length<z.length?z[we.length-1]:"z"}${we}s${(0,i.encodeBase64)(i.VSBuffer.fromString(_.scheme),!0,!0)}`;return _.with({scheme:B.scheme,fragment:We})}B.generate=ie;function ge(_){if(_.scheme!==B.scheme)return;const me=_.fragment.indexOf("s");if(me<0)return;const we=parseInt(_.fragment.substring(0,me).replace(V,""),K),Me=(0,i.decodeBase64)(_.fragment.substring(me+1)).toString();if(!isNaN(we))return{handle:we,notebook:_.with({scheme:Me,fragment:null})}}B.parse=ge;function ue(_,me){return _.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`op${me??""},${_.scheme!==C.Schemas.file?_.scheme:""}`})}B.generateCellOutputUri=ue;function re(_){if(_.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const me=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(_.fragment);if(!me)return;const we=me[1]&&me[1]!==""?me[1]:void 0,Me=me[2];return{outputId:we,notebook:_.with({scheme:Me||C.Schemas.file,fragment:null})}}B.parseCellOutputUri=re;function se(_,me,we){return B.generate(_,me).with({scheme:we})}B.generateCellPropertyUri=se;function le(_,me){if(_.scheme===me)return B.parse(_.with({scheme:B.scheme}))}B.parseCellPropertyUri=le})(p=e.CellUri||(e.CellUri={}));const E=B=>S.isWindows?B.replace(/\//g,"\\"):B;class v{constructor(z=[],V=e.NOTEBOOK_DISPLAY_ORDER){this.e=V,this.d=[...new Set(z)].map(K=>({pattern:K,matches:T.parse(E(K))}))}sort(z){const V=new Map(y.Iterable.map(z,ie=>[ie,E(ie)]));let K=[];for(const{matches:ie}of this.d)for(const[ge,ue]of V)if(ie(ue)){K.push(ge),V.delete(ge);break}return V.size&&(K=K.concat([...V.keys()].sort((ie,ge)=>this.e.indexOf(ie)-this.e.indexOf(ge)))),K}prioritize(z,V){const K=this.f(z);if(K===-1){this.d.unshift({pattern:z,matches:T.parse(E(z))});return}const ie=new Set(V.map(ue=>this.f(ue,K)));ie.delete(-1);const ge=Array.from(ie).sort();this.d.splice(K+1,0,...ge.map(ue=>this.d[ue]));for(let ue=ge.length-1;ue>=0;ue--)this.d.splice(ge[ue],1)}toArray(){return this.d.map(z=>z.pattern)}f(z,V=this.d.length){const K=E(z);for(let ie=0;ie<V;ie++)if(this.d[ie].matches(K))return ie;return-1}}e.MimeTypeDisplayOrder=v;function w(B,z,V,K=(ie,ge)=>ie===ge){const ie=[];function ge(se,le,_){if(le===0&&_.length===0)return;const me=ie[ie.length-1];me&&me.start+me.deleteCount===se?(me.deleteCount+=le,me.toInsert.push(..._)):ie.push({start:se,deleteCount:le,toInsert:_})}let ue=0,re=0;for(;;){if(ue===B.length){ge(ue,0,z.slice(re));break}if(re===z.length){ge(ue,B.length-ue,[]);break}const se=B[ue],le=z[re];if(K(se,le)){ue+=1,re+=1;continue}V(le)?(ge(ue,1,[]),ue+=1):(ge(ue,0,[le]),re+=1)}return ie}e.diff=w,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(B){B.default="default",B.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(B){const z=B;return!!((typeof z.include=="string"||T.isRelativePattern(z.include))&&(typeof z.exclude=="string"||T.isRelativePattern(z.exclude)))}e.isDocumentExcludePattern=r;function o(B,z,V){if(Array.isArray(B.viewType)&&B.viewType.indexOf(z)>=0||B.viewType===z)return!0;if(B.filenamePattern){const K=r(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,ie=r(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(T.match(K,(0,A.basename)(V.fsPath).toLowerCase()))return!(ie&&T.match(ie,(0,A.basename)(V.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var h;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(h=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class a{static create(z){return`${a.d}${z}`}static parse(z){if(z.startsWith(a.d))return z.substring(a.d.length)}}e.NotebookWorkingCopyTypeIdentifier=a,a.d="notebook/";function l(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}e.isTextStreamMime=l;const n=new TextDecoder;function d(B){const z=[];let V=!1;for(const K of B)(z.length===0||V)&&(z.push(K),V=!0);return q(z),F(i.VSBuffer.concat(z.map(K=>i.VSBuffer.wrap(K))))}e.compressOutputItemStreams=d;const g=`${String.fromCharCode(27)}[A`,O=g.split("").map(B=>B.charCodeAt(0)),N=10;function q(B){B.forEach((z,V)=>{if(V===0||z.length<g.length)return;const K=B[V-1],ie=z.subarray(0,g.length);if(ie[0]===O[0]&&ie[1]===O[1]&&ie[2]===O[2]){const ge=K.lastIndexOf(N);if(ge===-1)return;B[V-1]=K.subarray(0,ge),B[V]=z.subarray(g.length)}})}function J(B){let z=B;do B=z,z=B.replace(/[^\n]\x08/gm,"");while(z.length<B.length);return B}function x(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const z=B.match(/^(.*)\r+/m)[1];let V=B.match(/\r+(.*)$/m)[1];V=V+z.slice(V.length,z.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,V)}return B}const R="\b".charCodeAt(0),P="\r".charCodeAt(0);function F(B){return!B.buffer.includes(R)&&!B.buffer.includes(P)?B:i.VSBuffer.fromString(x(J(n.decode(B.buffer))))}}),define(Ie[175],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var T;(function(y){y[y.Output=1]="Output",y[y.OutputItems=2]="OutputItems",y[y.ExecutionState=3]="ExecutionState"})(T=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,i.createDecorator)("INotebookExecutionService")}),define(Ie[176],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function i(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=i;function T(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=T;function y(C){return Array.from(C.entries()).map(A=>[A[0],i(A[1].map)])}e.serializeEnvironmentVariableCollections=y;function L(C){return new Map(C.map(A=>[A[0],{map:T(A[1])}]))}e.deserializeEnvironmentVariableCollections=L}),define(Ie[42],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var i;(function(L){L.Delimiter="\0"})(i=e.TestIdPathParts||(e.TestIdPathParts={}));var T;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(T=e.TestPosition||(e.TestPosition={}));class y{static fromExtHostTestItem(C,A,S=C.parent){if(C._isRoot)return new y([A]);const k=[C.id];for(let M=S;M&&M.id!==A;M=M.parent)k.push(M.id);return k.push(A),new y(k.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const A=C.indexOf("\0");return A===-1?C:C.slice(0,A)}static fromString(C){return new y(C.split("\0"))}static join(C,A){return new y([...C.path,A])}static joinToString(C,A){return C.toString()+"\0"+A}static parentId(C){const A=C.lastIndexOf("\0");return A===-1?void 0:C.slice(0,A)}static compare(C,A){return C===A?0:A.startsWith(C+"\0")?2:C.startsWith(A+"\0")?3:1}constructor(C,A=C.length){if(this.path=C,this.d=A,C.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new y(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let C=1;C<=this.d;C++)yield new y(this.path,C)}*idsToRoot(){for(let C=this.d;C>0;C--)yield new y(this.path,C)}compare(C){if(typeof C=="string")return y.compare(this.toString(),C);for(let A=0;A<C.d&&A<this.d;A++)if(C.path[A]!==this.path[A])return 1;return C.d>this.d?2:C.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let C=1;C<this.d;C++)this.c+="\0",this.c+=this.path[C]}return this.c}}e.TestId=y}),define(Ie[53],Ce([1,0,2,54,42]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var L;(function(l){l[l.Unset=0]="Unset",l[l.Queued=1]="Queued",l[l.Running=2]="Running",l[l.Passed=3]="Passed",l[l.Failed=4]="Failed",l[l.Skipped=5]="Skipped",l[l.Errored=6]="Errored"})(L=e.TestResultState||(e.TestResultState={}));var C;(function(l){l[l.Run=2]="Run",l[l.Debug=4]="Debug",l[l.Coverage=8]="Coverage",l[l.HasNonDefaultProfile=16]="HasNonDefaultProfile",l[l.HasConfigurable=32]="HasConfigurable"})(C=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var A;(function(l){l.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),l.deserialize=n=>({range:T.Range.lift(n.range),uri:i.URI.revive(n.uri)})})(A=e.IRichLocation||(e.IRichLocation={}));var S;(function(l){l[l.Error=0]="Error",l[l.Output=1]="Output"})(S=e.TestMessageType||(e.TestMessageType={}));var k;(function(l){l.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&A.serialize(n.location)}),l.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&A.deserialize(n.location)})})(k=e.ITestErrorMessage||(e.ITestErrorMessage={}));const M=(l,n)=>`${n?"s":"e"}${l}`;e.getMarkId=M;var D;(function(l){l.serialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&A.serialize(n.location)}),l.deserialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&A.deserialize(n.location)})})(D=e.ITestOutputMessage||(e.ITestOutputMessage={}));var m;(function(l){l.serialize=n=>n.type===0?k.serialize(n):D.serialize(n),l.deserialize=n=>n.type===0?k.deserialize(n):D.deserialize(n)})(m=e.ITestMessage||(e.ITestMessage={}));var b;(function(l){l.serializeWithoutMessages=n=>({state:n.state,duration:n.duration,messages:[]}),l.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(m.serialize)}),l.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(m.deserialize)})})(b=e.ITestTaskState||(e.ITestTaskState={}));const f="\0",t=(l,n)=>l+f+n;e.namespaceTestTag=t;const c=l=>{const n=l.indexOf(f);return{ctrlId:l.slice(0,n),tagId:l.slice(n+1)}};e.denamespaceTestTag=c;var u;(function(l){l.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),l.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?i.URI.revive(n.uri):void 0,range:n.range?T.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(u=e.ITestItem||(e.ITestItem={}));var p;(function(l){l[l.NotExpandable=0]="NotExpandable",l[l.Expandable=1]="Expandable",l[l.BusyExpanding=2]="BusyExpanding",l[l.Expanded=3]="Expanded"})(p=e.TestItemExpandState||(e.TestItemExpandState={}));var E;(function(l){l.serialize=n=>({expand:n.expand,item:u.serialize(n.item)}),l.deserialize=n=>({controllerId:y.TestId.root(n.item.extId),expand:n.expand,item:u.deserialize(n.item)})})(E=e.InternalTestItem||(e.InternalTestItem={}));var v;(function(l){l.serialize=n=>{let d;return n.item&&(d={},n.item.label!==void 0&&(d.label=n.item.label),n.item.tags!==void 0&&(d.tags=n.item.tags),n.item.busy!==void 0&&(d.busy=n.item.busy),n.item.uri!==void 0&&(d.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(d.range=n.item.range?.toJSON()),n.item.description!==void 0&&(d.description=n.item.description),n.item.error!==void 0&&(d.error=n.item.error),n.item.sortText!==void 0&&(d.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:d}},l.deserialize=n=>{let d;return n.item&&(d={},n.item.label!==void 0&&(d.label=n.item.label),n.item.tags!==void 0&&(d.tags=n.item.tags),n.item.busy!==void 0&&(d.busy=n.item.busy),n.item.range!==void 0&&(d.range=n.item.range?T.Range.lift(n.item.range):null),n.item.description!==void 0&&(d.description=n.item.description),n.item.error!==void 0&&(d.error=n.item.error),n.item.sortText!==void 0&&(d.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:d}}})(v=e.ITestItemUpdate||(e.ITestItemUpdate={}));const w=(l,n)=>{n.expand!==void 0&&(l.expand=n.expand),n.item!==void 0&&(l.item=l.item?Object.assign(l.item,n.item):n.item)};e.applyTestItemUpdate=w;var s;(function(l){l.serializeWithoutMessages=n=>({...E.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(b.serializeWithoutMessages),retired:n.retired}),l.serialize=n=>({...E.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(b.serialize),retired:n.retired}),l.deserialize=n=>({...E.deserialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(b.deserialize),retired:!0})})(s=e.TestResultItem||(e.TestResultItem={}));var r;(function(l){l[l.Function=0]="Function",l[l.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var o;(function(l){l[l.Add=0]="Add",l[l.Update=1]="Update",l[l.DocumentSynced=2]="DocumentSynced",l[l.Remove=3]="Remove",l[l.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",l[l.Retire=5]="Retire",l[l.AddTag=6]="AddTag",l[l.RemoveTag=7]="RemoveTag"})(o=e.TestDiffOpType||(e.TestDiffOpType={}));var h;(function(l){l.deserialize=n=>n.op===0?{op:n.op,item:E.deserialize(n.item)}:n.op===1?{op:n.op,item:v.deserialize(n.item)}:n.op===2?{op:n.op,uri:i.URI.revive(n.uri),docv:n.docv}:n,l.serialize=n=>n.op===0?{op:n.op,item:E.serialize(n.item)}:n.op===1?{op:n.op,item:v.serialize(n.item)}:n})(h=e.TestsDiffOp||(e.TestsDiffOp={}));class a{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(n){const d=this.o();for(const g of n)switch(g.op){case 0:this.j(E.deserialize(g.item),d);break;case 1:this.k(v.deserialize(g.item),d);break;case 3:this.l(g.itemId,d);break;case 5:this.m(g.itemId);break;case 4:this.updatePendingRoots(g.amount);break;case 6:this.c.set(g.tag.id,g.tag);break;case 7:this.c.delete(g.id);break}d.complete?.()}j(n,d){const g=y.TestId.parentId(n.item.extId)?.toString();let O;if(!g)O=this.p(n),this.f.add(O),this.d.set(n.item.extId,O);else if(this.d.has(g)){const N=this.d.get(g);N.children.add(n.item.extId),O=this.p(n,N),this.d.set(n.item.extId,O)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(n)}`);return}return d.add?.(O),n.expand===2&&this.g++,O}k(n,d){const g=this.d.get(n.extId);if(!!g)return n.expand!==void 0&&(g.expand===2&&this.g--,n.expand===2&&this.g++),(0,e.applyTestItemUpdate)(g,n),d.update?.(g),g}l(n,d){const g=this.d.get(n);if(!g)return;const O=y.TestId.parentId(g.item.extId)?.toString();O?this.d.get(O).children.delete(g.item.extId):this.f.delete(g);const N=[[n]];for(;N.length;)for(const q of N.pop()){const J=this.d.get(q);J&&(N.push(J.children),this.d.delete(q),d.remove?.(J,J!==g),J.expand===2&&this.g--)}}m(n){}updatePendingRoots(n){this.h+=n}o(){return{}}}e.AbstractIncrementalTestCollection=a}),define(Ie[67],Ce([1,0,14,5,7,47,53,42]),function(ee,e,i,T,y,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var S;(function(p){p[p.Upsert=0]="Upsert",p[p.SetTags=1]="SetTags",p[p.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",p[p.RemoveChild=3]="RemoveChild",p[p.SetProp=4]="SetProp",p[p.Bulk=5]="Bulk",p[p.DocumentSynced=6]="DocumentSynced"})(S=e.TestItemEventOp||(e.TestItemEventOp={}));const k=(p,E)=>p===E,D=Object.entries({range:(p,E)=>p===E?!0:!p||!E?!1:p.equalsRange(E),busy:k,label:k,description:k,error:k,sortText:k,tags:(p,E)=>!(p.length!==E.length||p.some(v=>!E.includes(v)))}),m=(p,E)=>{let v;for(const[w,s]of D)s(p[w],E[w])||(v?v[w]=E[w]:v={[w]:E[w]});return v};class b extends y.Disposable{get root(){return this.m.root}constructor(E){super(),this.m=E,this.f=this.B(new i.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new T.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(E){this.h=E;for(const v of this.tree.values())this.G(v)}collectDiff(){const E=this.k;return this.k=[],E}pushDiff(E){switch(E.op){case 2:{for(const v of this.k)if(v.op===2&&v.uri===E.uri){v.docv=E.docv;return}break}case 1:{const v=this.k[this.k.length-1];if(v){if(v.op===1&&v.item.extId===E.item.extId){(0,C.applyTestItemUpdate)(v.item,E.item);return}if(v.op===0&&v.item.item.extId===E.item.extId){(0,C.applyTestItemUpdate)(v.item,E.item);return}}break}}this.k.push(E),this.f.isScheduled()||this.f.schedule()}expand(E,v){const w=this.tree.get(E);if(!!w){if((w.expandLevels===void 0||v>w.expandLevels)&&(w.expandLevels=v),w.expand===1){const s=this.I(w);return s.isOpen()?this.H(w,v-1):s.wait().then(()=>this.H(w,v-1))}else if(w.expand===3)return w.resolveBarrier?.isOpen()===!1?w.resolveBarrier.wait().then(()=>this.H(w,v-1)):this.H(w,v-1)}}dispose(){for(const E of this.tree.values())this.m.getApiFor(E.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(E,v){switch(v.op){case 3:this.L(A.TestId.joinToString(E.fullId,v.id));break;case 0:this.u(v.item,E);break;case 5:for(const w of v.ops)this.p(E,w);break;case 1:this.w(v.new,v.old,E.fullId.toString());break;case 2:this.G(E);break;case 4:this.pushDiff({op:1,item:{extId:E.fullId.toString(),item:v.update}});break;case 6:this.s(E.actual.uri);break;default:(0,L.assertNever)(v)}}s(E){E&&this.pushDiff({op:2,uri:E,docv:this.m.getDocumentVersion(E)})}u(E,v){const w=A.TestId.fromExtHostTestItem(E,this.root.id,v?.actual),s=this.m.getApiFor(E);s.parent&&s.parent!==v?.actual&&this.m.getChildren(s.parent).delete(E.id);let r=this.tree.get(w.toString());if(!r){r={fullId:w,actual:E,expandLevels:v?.expandLevels?v.expandLevels-1:void 0,expand:0},E.tags.forEach(this.y,this),this.tree.set(r.fullId.toString(),r),this.C(E,v),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:r.expand,item:this.m.toITestItem(E)}}),this.F(E,r,v);return}if(r.actual===E){this.D(E,r,v);return}if(r.actual.uri?.toString()!==E.uri?.toString())return this.L(w.toString()),this.u(E,v);const o=this.m.getChildren(r.actual),h=r.actual,a=m(this.m.toITestItem(h),this.m.toITestItem(E));this.m.getApiFor(h).listener=void 0,r.actual=E,r.expand=0,a&&(a.hasOwnProperty("tags")&&(this.w(E.tags,h.tags,w.toString()),delete a.tags),this.p(r,{op:4,update:a})),this.F(E,r,v);for(const[l,n]of o)this.m.getChildren(E).get(n.id)||this.L(A.TestId.joinToString(w,n.id));this.s(r.actual.uri)}w(E,v,w){const s=new Set(v.map(r=>r.id));for(const r of E)s.delete(r.id)||this.y(r);this.pushDiff({op:1,item:{extId:w,item:{tags:E.map(r=>(0,C.namespaceTestTag)(this.m.controllerId,r.id))}}}),s.forEach(this.z,this)}y(E){const v=this.j.get(E.id);v?v.refCount++:(this.j.set(E.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,C.namespaceTestTag)(this.m.controllerId,E.id)}}))}z(E){const v=this.j.get(E);v&&!--v.refCount&&(this.j.delete(E),this.pushDiff({op:7,id:(0,C.namespaceTestTag)(this.m.controllerId,E)}))}C(E,v){this.m.getApiFor(E).parent=v&&v.actual!==this.root?v.actual:void 0}D(E,v,w){this.C(E,w);const s=this.m.getApiFor(E);s.parent=w?.actual,s.listener=r=>this.p(v,r),this.G(v)}F(E,v,w){this.D(E,v,w);for(const[s,r]of this.m.getChildren(E))this.u(r,v)}G(E){let v;this.h?E.resolveBarrier?v=E.resolveBarrier.isOpen()?3:2:v=E.actual.canResolveChildren?1:0:v=0,v!==E.expand&&(E.expand=v,this.pushDiff({op:1,item:{extId:E.fullId.toString(),expand:v}}),v===1&&E.expandLevels!==void 0&&this.I(E))}H(E,v){if(v<0)return;const w=[];for(const[s,r]of this.m.getChildren(E.actual)){const o=this.expand(A.TestId.joinToString(E.fullId,r.id),v);(0,i.isThenable)(o)&&w.push(o)}if(w.length)return Promise.all(w).then(()=>{})}I(E){if(E.resolveBarrier)return E.resolveBarrier;if(!this.h){const r=new i.Barrier;return r.open(),r}E.expand=2,this.J(E);const v=E.resolveBarrier=new i.Barrier,w=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,r)};let s;try{s=this.h(E.actual===this.root?void 0:E.actual)}catch(r){w(r)}return(0,i.isThenable)(s)?s.catch(w).then(()=>{v.open(),this.G(E)}):(v.open(),this.G(E)),E.resolveBarrier}J(E){this.pushDiff({op:1,item:{extId:E.fullId.toString(),expand:E.expand}})}L(E){const v=this.tree.get(E);if(!v)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:E});const w=[v];for(;w.length;){const s=w.pop();if(!!s){this.m.getApiFor(s.actual).listener=void 0;for(const r of s.actual.tags)this.z(r.id);this.tree.delete(s.fullId.toString());for(const[r,o]of this.m.getChildren(s.actual))w.push(this.tree.get(A.TestId.joinToString(s.fullId,o.id)))}}}flushDiff(){const E=this.collectDiff();E.length&&this.g.fire(E)}}e.TestItemCollection=b;class f extends Error{constructor(E){super(`Attempted to insert a duplicate test item ID ${E}`)}}e.DuplicateTestItemError=f;class t extends Error{constructor(E){super(`TestItem with ID "${E}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=t;class c extends Error{constructor(E,v,w){super(`TestItem with ID "${E}" is from controller "${v}" and cannot be added as a child of an item from controller "${w}".`)}}e.MixedTestItemController=c;const u=(p,E,v)=>{let w=new Map;return{get size(){return w.size},forEach(s,r){for(const o of w.values())s.call(r,o,this)},[Symbol.iterator](){return w.entries()},replace(s){const r=new Map,o=new Set(w.keys()),h={op:5,ops:[]};for(const a of s){if(!(a instanceof v))throw new t(a.id);const l=E(a).controllerId;if(l!==p.controllerId)throw new c(a.id,l,p.controllerId);if(r.has(a.id))throw new f(a.id);r.set(a.id,a),o.delete(a.id),h.ops.push({op:0,item:a})}for(const a of o.keys())h.ops.push({op:3,id:a});p.listener?.(h),w=r},add(s){if(!(s instanceof v))throw new t(s.id);w.set(s.id,s),p.listener?.({op:0,item:s})},delete(s){w.delete(s)&&p.listener?.({op:3,id:s})},get(s){return w.get(s)},toJSON(){return Array.from(w.values())}}};e.createTestItemChildren=u}),define(Ie[93],Ce([1,0,67]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const T=new WeakMap,y=(C,A)=>{const S={controllerId:A};return T.set(C,S),S};e.createPrivateApiFor=y;const L=C=>{const A=T.get(C);if(!A)throw new i.InvalidTestItemError(C?.id||"<unknown>");return A};e.getPrivateApiFor=L}),define(Ie[68],Ce([1,0,13,2]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function y(A,S){return A.scheme===i.Schemas.http||A.scheme===i.Schemas.https?A:(S&&S.authority&&S.isRemote&&A.scheme===i.Schemas.file&&(A=T.URI.from({scheme:i.Schemas.vscodeRemote,authority:S.authority,path:A.path})),T.URI.from({scheme:i.Schemas.https,authority:`${A.scheme}+${L(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=y;function L(A){return A.replace(/./g,S=>{const k=S.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?S:"-"+k.toString(16).padStart(4,"0")})}function C(A){return A.replace(/-([0-9a-f]{4})/g,(S,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=C}),define(Ie[177],Ce([1,0,5,7,68]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class L{constructor(A,S,k){this.d=A,this.e=S,this.f=k,this.a=0,this.b=new T.DisposableStore,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const M=S.getVisibleTextEditors();for(const D of this.c.values())M.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(A=>A.inset.dispose()),this.b.dispose()}createWebviewEditorInset(A,S,k,M,D){let m;for(const E of this.e.getVisibleTextEditors(!0))if(E.value===A){m=E;break}if(!m)throw new Error("not a visible editor");const b=this,f=this.a++,t=new i.Emitter,c=new i.Emitter,u=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(E){return(0,y.asWebviewUri)(E,b.f)}get cspSource(){return y.webviewGenericCspSource}set options(E){this.b=E,b.d.$setOptions(f,E)}get options(){return this.b}set html(E){this.a=E,b.d.$setHtml(f,E)}get html(){return this.a}get onDidReceiveMessage(){return t.event}postMessage(E){return b.d.$postMessage(f,E)}},p=new class{constructor(){this.editor=A,this.line=S,this.height=k,this.webview=u,this.onDidDispose=c.event}dispose(){b.c.has(f)&&(b.c.delete(f),b.d.$disposeEditorInset(f),c.fire(),c.dispose(),t.dispose())}};return this.d.$createEditorInset(f,m.id,m.value.document.uri,S+1,k,M||{},D.identifier,D.extensionLocation),this.c.set(f,{editor:A,inset:p,onDidReceiveMessage:t}),p}$onDidDispose(A){const S=this.c.get(A);S&&S.inset.dispose()}$onDidReceiveMessage(A,S){this.c.get(A)?.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=L}),define(Ie[178],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,i.createDecorator)("configurationResolverService");var T;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(T=e.VariableKind||(e.VariableKind={}));class y extends Error{constructor(C,A){super(A),this.variable=C}}e.VariableError=y}),define(Ie[179],Ce([1,0,19,49,9,23,21,82,146,178,10]),function(ee,e,i,T,y,L,C,A,S,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class D{constructor(b,f,t,c){this.g=new Map,this.a=b,this.b=f,this.d=t,c&&(this.c=c.then(u=>this.h(u)))}h(b){if(C.isWindows){const f=Object.create(null);return Object.keys(b).forEach(t=>{f[t.toLowerCase()]=b[t]}),f}return b}resolveWithEnvironment(b,f,t){return this.j({env:this.h(b),userHome:void 0},f?f.uri:void 0,t)}async resolveAsync(b,f){const t={env:await this.c,userHome:await this.d};return this.j(t,b?b.uri:void 0,f)}async i(b,f,t,c){const u=L.deepClone(f);C.isWindows&&u.windows?Object.keys(u.windows).forEach(E=>u[E]=u.windows[E]):C.isMacintosh&&u.osx?Object.keys(u.osx).forEach(E=>u[E]=u.osx[E]):C.isLinux&&u.linux&&Object.keys(u.linux).forEach(E=>u[E]=u.linux[E]),delete u.windows,delete u.osx,delete u.linux;const p={env:await this.c,userHome:await this.d};return this.j(p,b?b.uri:void 0,u,t,c)}async resolveAnyAsync(b,f,t){return this.i(b,f,t)}async resolveAnyMap(b,f,t){const c=new Map;return{newConfig:await this.i(b,f,t,c),resolvedVariables:c}}resolveWithInteractionReplace(b,f,t,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,f,t,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,f){if(this.g.has(b))throw new Error("Variable "+b+" is contributed twice.");this.g.set(b,f)}async j(b,f,t,c,u){if(y.isString(t))return this.l(b,f,t,c,u);if(Array.isArray(t))return Promise.all(t.map(p=>this.j(b,f,p,c,u)));if(y.isObject(t)){const p=Object.create(null),E=await Promise.all(Object.keys(t).map(async v=>[await this.l(b,f,v,c,u),await this.j(b,f,t[v],c,u)]));for(const[v,w]of E)p[v]=w;return p}return t}l(b,f,t,c,u){return(0,M.replaceAsync)(t,D.VARIABLE_REGEXP,async(p,E)=>{if(E.includes(D.VARIABLE_LHS))return p;let v=await this.n(b,p,E,f,c);return u?.set(E,v),v!==p&&y.isString(v)&&v.match(D.VARIABLE_REGEXP)&&(v=await this.l(b,f,v,c,u)),v})}m(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async n(b,f,t,c,u){let p;const E=t.split(":");E.length>1&&(t=E[0],p=E[1]);const v=r=>{const o=this.a.getFilePath();if(o)return(0,A.normalizeDriveLetter)(o);throw new k.VariableError(r,(0,S.localize)(0,null,f))},w=r=>{const o=v(r);if(this.a.getWorkspaceFolderPathForFile){const h=this.a.getWorkspaceFolderPathForFile();if(h)return(0,A.normalizeDriveLetter)(h)}throw new k.VariableError(r,(0,S.localize)(1,null,f,i.basename(o)))},s=r=>{if(p){const o=this.a.getFolderUri(p);if(o)return o;throw new k.VariableError(r,(0,S.localize)(2,null,f,p))}if(c)return c;throw this.a.getWorkspaceFolderCount()>1?new k.VariableError(r,(0,S.localize)(3,null,f)):new k.VariableError(r,(0,S.localize)(4,null,f))};switch(t){case"env":if(p){if(b.env){const r=b.env[C.isWindows?p.toLowerCase():p];if(y.isString(r))return r}return""}throw new k.VariableError(k.VariableKind.Env,(0,S.localize)(5,null,f));case"config":if(p){const r=this.a.getConfigurationValue(c,p);if(y.isUndefinedOrNull(r))throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(6,null,f,p));if(y.isObject(r))throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(7,null,f,p));return r}throw new k.VariableError(k.VariableKind.Config,(0,S.localize)(8,null,f));case"command":return this.o(k.VariableKind.Command,f,p,u,"command");case"input":return this.o(k.VariableKind.Input,f,p,u,"input");case"extensionInstallFolder":if(p){const r=await this.a.getExtension(p);if(!r)throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,f,p));return this.m(r.extensionLocation)}throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,f));default:switch(t){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.m(s(k.VariableKind.WorkspaceFolder)));case"cwd":return c||p?(0,A.normalizeDriveLetter)(this.m(s(k.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.normalizeDriveLetter)(i.basename(this.m(s(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new k.VariableError(k.VariableKind.UserHome,(0,S.localize)(11,null,f))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new k.VariableError(k.VariableKind.LineNumber,(0,S.localize)(12,null,f))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new k.VariableError(k.VariableKind.SelectedText,(0,S.localize)(13,null,f))}case"file":return v(k.VariableKind.File);case"fileWorkspaceFolder":return w(k.VariableKind.FileWorkspaceFolder);case"relativeFile":return c||p?i.relative(this.m(s(k.VariableKind.RelativeFile)),v(k.VariableKind.RelativeFile)):v(k.VariableKind.RelativeFile);case"relativeFileDirname":{const r=i.dirname(v(k.VariableKind.RelativeFileDirname));if(c||p){const o=i.relative(this.m(s(k.VariableKind.RelativeFileDirname)),r);return o.length===0?".":o}return r}case"fileDirname":return i.dirname(v(k.VariableKind.FileDirname));case"fileExtname":return i.extname(v(k.VariableKind.FileExtname));case"fileBasename":return i.basename(v(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=i.basename(v(k.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-i.extname(r).length)}case"fileDirnameBasename":return i.basename(i.dirname(v(k.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||f}case"execInstallFolder":{const r=this.a.getAppRoot();return r||f}case"pathSeparator":return i.sep;default:try{const r=p?`${t}:${p}`:t;return this.o(k.VariableKind.Unknown,f,r,u,void 0)}catch{return f}}}}o(b,f,t,c,u){if(t&&c){const p=u===void 0?c[t]:c[u+":"+t];if(typeof p=="string")return p;throw new k.VariableError(b,(0,S.localize)(14,null,f))}return f}}e.AbstractVariableResolverService=D,D.VARIABLE_LHS="${",D.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ie[94],Ce([1,0,3,92]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,i.createDecorator)("editorGroupsService");var y;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(y=e.GroupDirection||(e.GroupDirection={}));var L;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(L=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var A;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function k(f){const t=f;return(0,T.isEditorInput)(t?.editor)&&(0,T.isEditorInput)(t?.replacement)}e.isEditorReplacement=k;var M;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(M=e.GroupsOrder||(e.GroupsOrder={}));var D;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(D=e.OpenEditorContext||(e.OpenEditorContext={}));function m(f){const t=f;return!!t&&typeof t.id=="number"&&Array.isArray(t.editors)}e.isEditorGroup=m;function b(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=b}),define(Ie[180],Ce([1,0,3,94]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,i.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function y(L){const C=L;return typeof L=="number"||(0,T.isEditorGroup)(C)}e.isPreferredGroup=y}),define(Ie[181],Ce([1,0,3,152]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,i.refineServiceDecorator)(T.IEnvironmentService)}),define(Ie[95],Ce([1,0,26,5,19]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class L{constructor(D){this.removedDueToLooping=D}}e.DeltaExtensionsResult=L;class C{static isHostExtension(D,m,b){if(m.getExtensionDescription(D))return!1;const f=b.getExtensionDescription(D);return f?!!((f.main||f.browser)&&f.api==="none"):!1}constructor(D){this.c=new T.Emitter,this.onDidChange=this.c.event,this.d=D,this.h()}h(){this.d.sort(S),this.e=new Map,this.f=[],this.g=new Map;for(const D of this.d){if(this.e.has(i.ExtensionIdentifier.toKey(D.identifier))){console.error("Extension `"+D.identifier.value+"` is already registered");continue}if(this.e.set(i.ExtensionIdentifier.toKey(D.identifier),D),this.f.push(D),Array.isArray(D.activationEvents))for(let m of D.activationEvents)m==="onUri"&&(m=`onUri:${i.ExtensionIdentifier.toKey(D.identifier)}`),this.g.has(m)||this.g.set(m,[]),this.g.get(m).push(D)}}set(D){this.d=D,this.h(),this.c.fire(void 0)}deltaExtensions(D,m){this.d=k(this.d,m),this.d=this.d.concat(D);const b=C.j(this.d);return this.d=k(this.d,b.map(f=>f.identifier)),this.h(),this.c.fire(void 0),new L(b)}static j(D){const m=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(u){this.d.has(u)||(this.d.add(u),this.e.push(u))}addArc(u,p){this.addNode(u),this.addNode(p),this.c.has(u)?this.c.get(u).push(p):this.c.set(u,[p])}getArcs(u){return this.c.has(u)?this.c.get(u):[]}hasOnlyGoodArcs(u,p){const E=m.getArcs(u);for(let v=0;v<E.length;v++)if(!p.has(E[v]))return!1;return!0}getNodes(){return this.e}},b=new Map;for(const u of D){const p=i.ExtensionIdentifier.toKey(u.identifier);if(b.set(p,u),u.extensionDependencies)for(const E of u.extensionDependencies){const v=i.ExtensionIdentifier.toKey(E);m.addArc(p,v)}}const f=new Set;m.getNodes().filter(u=>m.getArcs(u).length===0).forEach(u=>f.add(u));const t=m.getNodes().filter(u=>!f.has(u));let c;do{c=!1;for(let u=0;u<t.length;u++){const p=t[u];m.hasOnlyGoodArcs(p,f)&&(t.splice(u,1),u--,f.add(p),c=!0)}}while(c);return t.map(u=>b.get(u))}containsActivationEvent(D){return this.g.has(D)}containsExtension(D){return this.e.has(i.ExtensionIdentifier.toKey(D))}getExtensionDescriptionsForActivationEvent(D){const m=this.g.get(D);return m?m.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(D){const m=this.e.get(i.ExtensionIdentifier.toKey(D));return m||void 0}getExtensionDescriptionByUUID(D){for(const m of this.f)if(m.uuid===D)return m}getExtensionDescriptionByIdOrUUID(D,m){return this.getExtensionDescription(D)??(m?this.getExtensionDescriptionByUUID(m):void 0)}}e.ExtensionDescriptionRegistry=C;var A;(function(M){M[M.Builtin=0]="Builtin",M[M.User=1]="User",M[M.Dev=2]="Dev"})(A||(A={}));function S(M,D){const m=M.isBuiltin?0:M.isUnderDevelopment?2:1,b=D.isBuiltin?0:D.isUnderDevelopment?2:1;if(m!==b)return m-b;const f=y.posix.basename(M.extensionLocation.path),t=y.posix.basename(D.extensionLocation.path);return f<t?-1:f>t?1:0}function k(M,D){const m=new Set;return D.forEach(b=>m.add(i.ExtensionIdentifier.toKey(b))),M.filter(b=>!m.has(i.ExtensionIdentifier.toKey(b.identifier)))}}),define(Ie[69],Ce([1,0,24]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var y;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(y=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var L;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(L=e.MessageType||(e.MessageType={}));function C(k){const M=i.VSBuffer.alloc(1);switch(k){case 0:M.writeUInt8(1,0);break;case 1:M.writeUInt8(2,0);break;case 2:M.writeUInt8(3,0);break}return M}e.createMessageOfType=C;function A(k,M){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return M===0;case 2:return M===1;case 3:return M===2;default:return!1}}e.isMessageOfType=A;var S;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(S=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ie[70],Ce([1,0,3,5,12,27,69,48,91,23,2]),function(ee,e,i,T,y,L,C,A,S,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let D=class{constructor(t,c){this.i=t,this.a=new T.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new T.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=c.createLogger(M.URI.revive(this.i.environment.extensionTelemetryLogResource)),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(t,c){const u=this.getTelemetryDetails(),p=new m(c,t,this.g,this.f,this.getBuiltInCommonProperties(t),{isUsageEnabled:u.isUsageEnabled,isErrorsEnabled:u.isErrorsEnabled});return this.h.set(t.identifier.value,p),p.apiTelemetryLogger}$initializeTelemetryLevel(t,c,u){this.d=t,this.f=c,this.c=u??{usage:!0,error:!0}}getBuiltInCommonProperties(t){const c={};switch(c["common.extname"]=t.name,c["common.extversion"]=t.version,c["common.vscodemachineid"]=this.i.telemetryInfo.machineId,c["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,c["common.vscodeversion"]=this.i.version,c["common.isnewappinstall"]=b(this.i.telemetryInfo.firstSessionDate),c["common.product"]=this.i.environment.appHost,this.i.uiKind){case C.UIKind.Web:c["common.uikind"]="web";break;case C.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,A.getRemoteName)((0,S.cleanRemoteAuthority)(this.i.remote.authority)),c}$onDidChangeTelemetryLevel(t){this.e=this.getTelemetryConfiguration(),this.d=t;const c=this.getTelemetryDetails();this.h.forEach(u=>{u.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(t,c){const u=this.h.get(t.value);return u?(u.logError(c),!0):!1}};D=qe([Ve(0,L.IExtHostInitDataService),Ve(1,y.ILoggerService)],D),e.ExtHostTelemetry=D;class m{constructor(t,c,u,p,E,v){this.e=c,this.f=u,this.g=p,this.h=E,this.b=new T.Emitter,this.a=t,this.c={isUsageEnabled:v.isUsageEnabled,isErrorsEnabled:v.isErrorsEnabled}}updateTelemetryEnablements(t,c){this.d&&(this.c={isUsageEnabled:t,isErrorsEnabled:c},this.b.fire(this.d))}mixInCommonPropsAndCleanData(t){let c=t.properties??t;return c=(0,S.cleanData)(c,[]),this.a.additionalCommonProperties&&(c=(0,k.mixin)(c,this.a.additionalCommonProperties)),this.a.ignoreBuiltInCommonProperties||(c=(0,k.mixin)(c,this.h)),t.properties?t.properties=c:t=c,t}i(t,c){this.e.publisher==="vscode"?t=this.e.name+"/"+t:t=this.e.identifier.value+"/"+t,c=this.mixInCommonPropsAndCleanData(c||{}),this.g||this.a.logEvent(t,c),this.f.trace(t,c)}logUsage(t,c){!this.c.isUsageEnabled||this.i(t,c)}logError(t,c){!this.c.isErrorsEnabled||(typeof t=="string"?this.i(t,c):this.a.logException(t,c))}get apiTelemetryLogger(){if(!this.d){const t=this,c={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t.c.isUsageEnabled},get isErrorsEnabled(){return t.c.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t.b.event.bind(t)};this.d=Object.freeze(c)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=m;function b(f){const t=Date.now()-new Date(f).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.isNewAppInstall=b,e.IExtHostTelemetry=(0,i.createDecorator)("IExtHostTelemetry")}),define(Ie[25],Ce([1,0,5,2,3,26,159]),function(ee,e,i,T,y,L,C){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new L.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,y.createDecorator)("extensionService");class S{constructor(l){this.affinity=l,this.kind=1}equals(l){return this.kind===l.kind&&this.affinity===l.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=S;class k{constructor(l){this.affinity=l,this.kind=2}equals(l){return this.kind===l.kind&&this.affinity===l.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=k;class M{constructor(){this.kind=3,this.affinity=0}equals(l){return this.kind===l.kind}asString(){return"Remote"}}e.RemoteRunningLocation=M;class D{constructor(l){this.dependency=l}}e.MissingExtensionDependency=D;var m;(function(a){a[a.LocalProcess=1]="LocalProcess",a[a.LocalWebWorker=2]="LocalWebWorker",a[a.Remote=3]="Remote"})(m=e.ExtensionHostKind||(e.ExtensionHostKind={}));function b(a){if(a===null)return"None";switch(a){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=b;class f{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(l,n){const d=[],g=[],O=[],N=[],q=u(this.c),J=u(l),x=(B,z)=>B.extensionLocation.toString()===z.extensionLocation.toString()||B.isBuiltin===z.isBuiltin||B.isUserBuiltin===z.isUserBuiltin||B.isUnderDevelopment===z.isUnderDevelopment;for(const B of this.c){const z=J.get(L.ExtensionIdentifier.toKey(B.identifier));if(!z){d.push(B.identifier),q.delete(L.ExtensionIdentifier.toKey(B.identifier));continue}if(!x(B,z)){d.push(B.identifier),q.delete(L.ExtensionIdentifier.toKey(B.identifier));continue}}for(const B of l){const z=q.get(L.ExtensionIdentifier.toKey(B.identifier));if(!z){g.push(B);continue}if(!x(z,B)){d.push(z.identifier),q.delete(L.ExtensionIdentifier.toKey(z.identifier));continue}}const R=c(this.d),P=c(n);for(const B of this.d)P.has(L.ExtensionIdentifier.toKey(B))||O.push(B);for(const B of n)R.has(L.ExtensionIdentifier.toKey(B))||N.push(B);const F={toRemove:d,toAdd:g,myToRemove:O,myToAdd:N};return this.delta(F),F}delta(l){const{toRemove:n,toAdd:d,myToRemove:g,myToAdd:O}=l,N=c(n),q=c(g);for(let J=0;J<this.c.length;J++)N.has(L.ExtensionIdentifier.toKey(this.c[J].identifier))&&(this.c.splice(J,1),J--);for(let J=0;J<this.d.length;J++)q.has(L.ExtensionIdentifier.toKey(this.d[J]))&&(this.d.splice(J,1),J--);for(const J of d)this.c.push(J);for(const J of O)this.d.push(J)}containsExtension(l){for(const n of this.d)if(L.ExtensionIdentifier.equals(n,l))return!0;return!1}}e.ExtensionHostExtensions=f;class t{constructor(l){if(this[A]="ExtensionIdentifierSet",this.c=new Map,this.d=L.ExtensionIdentifier.toKey,l)for(const n of l)this.add(n)}get size(){return this.c.size}add(l){return this.c.set(this.d(l),l),this}clear(){this.c.clear()}delete(l){return this.c.delete(this.d(l))}has(l){return this.c.has(this.d(l))}forEach(l,n){this.c.forEach(d=>l.call(n,d,d,this))}*entries(){for(const[l,n]of this.c)yield[n,n]}keys(){return this.c.values()}values(){return this.c.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=t;function c(a){const l=new Set;for(const n of a)l.add(L.ExtensionIdentifier.toKey(n));return l}e.extensionIdentifiersArrayToSet=c;function u(a){const l=new Map;for(const n of a)l.set(L.ExtensionIdentifier.toKey(n.identifier),n);return l}function p(a,l){return a.enabledApiProposals?a.enabledApiProposals.includes(l):!1}e.isProposedApiEnabled=p;function E(a,l){if(!p(a,l))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}e.checkProposedApiEnabled=E;class v{constructor(l,n,d,g){this.codeLoadingTime=l,this.activateCallTime=n,this.activateResolvedTime=d,this.activationReason=g}}e.ActivationTimes=v;class w{constructor(l,n){this.description=l,this.value=n}}e.ExtensionPointContribution=w,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var s;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(s=e.ActivationKind||(e.ActivationKind={}));function r(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}e.toExtension=r;function o(a,l){return{identifier:new L.ExtensionIdentifier((0,C.getExtensionId)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!l,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform,browserNlsBundleUris:a.browserNlsBundleUris}}e.toExtensionDescription=o;class h{constructor(){this.onDidRegisterExtensions=i.Event.None,this.onDidChangeExtensionsStatus=i.Event.None,this.onDidChangeExtensions=i.Event.None,this.onWillActivateByEvent=i.Event.None,this.onDidChangeResponsiveChange=i.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(l,n){return Promise.resolve(0)}getInspectPorts(l,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=h}),define(Ie[182],Ce([1,0,11,95,26,25,12,14]),function(ee,e,i,T,y,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class S{constructor(u,p,E,v){this.startup=u,this.codeLoadingTime=p,this.activateCallTime=E,this.activateResolvedTime=v}}e.ExtensionActivationTimes=S,S.NONE=new S(!1,-1,-1,-1);class k{constructor(u){this.a=u,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(u,p){return u===-1||p===-1?-1:p-u}build(){return new S(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=k;class M{constructor(u,p,E,v,w,s){this.activationFailed=u,this.activationFailedError=p,this.activationTimes=E,this.module=v,this.exports=w,this.subscriptions=s}}e.ActivatedExtension=M;class D extends M{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=D;class m extends M{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=m;class b extends M{constructor(u){super(!0,u,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let f=class{constructor(u,p,E,v){this.g=v,this.a=u,this.b=p,this.c=E,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[u,p]of this.d)p.dispose()}isActivated(u){const p=this.d.get(y.ExtensionIdentifier.toKey(u));return Boolean(p&&p.value)}getActivatedExtension(u){const p=this.d.get(y.ExtensionIdentifier.toKey(u));if(!p||!p.value)throw new Error(`Extension '${u.value}' is not known or not activated`);return p.value}async activateByEvent(u,p){if(this.f[u])return;const E=this.a.getExtensionDescriptionsForActivationEvent(u);await this.h(E.map(v=>({id:v.identifier,reason:{startup:p,extensionId:v.identifier,activationEvent:u}}))),this.f[u]=!0}activateById(u,p){const E=this.a.getExtensionDescription(u);if(!E)throw new Error(`Extension '${u}' is not known`);return this.h([{id:E.identifier,reason:p}])}async h(u){const p=u.filter(E=>!this.isActivated(E.id)).map(E=>this.j(E));await Promise.all(p.map(E=>E.wait()))}j(u){if(this.d.has(y.ExtensionIdentifier.toKey(u.id)))return this.d.get(y.ExtensionIdentifier.toKey(u.id));if(this.l(u.id))return this.k(u,null,[],null);const p=this.a.getExtensionDescription(u.id);if(!p){const w=new Error(`Cannot activate unknown extension '${u.id.value}'`),s=this.k(u,null,[],new b(w));return this.c.onExtensionActivationError(u.id,w,new L.MissingExtensionDependency(u.id.value)),s}const E=[],v=typeof p.extensionDependencies>"u"?[]:p.extensionDependencies;for(const w of v){if(this.m(w))continue;const s=this.d.get(y.ExtensionIdentifier.toKey(w));if(s){E.push(s);continue}if(this.l(w)){E.push(this.j({id:this.b.getExtensionDescription(w).identifier,reason:u.reason}));continue}const r=this.a.getExtensionDescription(w);if(r){if(!r.main&&!r.browser)continue;E.push(this.j({id:r.identifier,reason:u.reason}));continue}const o=p.displayName||p.identifier.value,h=new Error(`Cannot activate the '${o}' extension because it depends on unknown extension '${w}'`),a=this.k(u,p.displayName,[],new b(h));return this.c.onExtensionActivationError(p.identifier,h,new L.MissingExtensionDependency(w)),a}return this.k(u,p.displayName,E,null)}k(u,p,E,v){const w=new t(u.id,p,u.reason,E,v,this.c,this.g);return this.d.set(y.ExtensionIdentifier.toKey(u.id),w),w}l(u){return T.ExtensionDescriptionRegistry.isHostExtension(u,this.a,this.b)}m(u){const p=this.b.getExtensionDescription(u);return p?!p.main&&!p.browser:!1}};f=qe([Ve(3,C.ILogService)],f),e.ExtensionsActivator=f;let t=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(u,p,E,v,w,s,r){this.c=u,this.d=p,this.f=E,this.g=v,this.h=w,this.j=s,this.k=r,this.a=new A.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let u=0;u<this.g.length;u++){const p=this.g[u];if(p.value&&!p.value.activationFailed){this.g.splice(u,1),u--;continue}if(p.value&&p.value.activationFailed){const E=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${p.friendlyName}' failed to activate`);E.detail=p.value.activationFailedError,this.h=new b(E),this.j.onExtensionActivationError(this.c,E,null);return}}this.g.length>0&&await Promise.race(this.g.map(u=>u.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(u){const p=new Error;if(u&&u.name&&(p.name=u.name),u&&u.message?p.message=`Activating extension '${this.c.value}' failed: ${u.message}.`:p.message=`Activating extension '${this.c.value}' failed: ${u}.`,u&&u.stack&&(p.stack=u.stack),this.h=new b(p),this.b&&i.isCancellationError(u))return;this.j.onExtensionActivationError(this.c,p,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(u)}}};t=qe([Ve(6,C.ILogService)],t)}),define(Ie[183],Ce([1,0,12,27,25]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let L=class extends i.LogService{constructor(A,S){super(A.createLogger(S.logFile,{name:y.ExtensionHostLogFileName}))}};L=qe([Ve(0,i.ILoggerService),Ve(1,T.IExtHostInitDataService)],L),e.ExtHostLogService=L});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[6],Ce([1,0,16,11,81,28,61,10,9,2,34,36,90,66,25]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m,b,f){"use strict";var t,c,u,p,E,v,w,s,r,o,h,a,l,n,d,g,O,N,q,J,x,R,P;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function F(W){return Object.assign(W,{apply:function(){const te=arguments.length===1?[]:arguments[1];return Reflect.construct(W,te,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(W,[]);{const[te,...Ee]=arguments;return Reflect.construct(W,Ee,te.constructor)}}})}var B;(function(W){W.top="top",W.bottom="bottom"})(B=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var z;(function(W){W.command="command",W.opener="opener"})(z=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let V=v=class{static from(...U){let te=U;return new v(function(){if(te){for(const Ee of te)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();te=void 0}})}constructor(U){t.set(this,void 0),Ye(this,t,U,"f")}dispose(){typeof Re(this,t,"f")=="function"&&(Re(this,t,"f").call(this),Ye(this,t,void 0,"f"))}};t=new WeakMap,V=v=qe([F],V),e.Disposable=V;let K=w=class{static Min(...U){if(U.length===0)throw new TypeError;let te=U[0];for(let Ee=1;Ee<U.length;Ee++){const Ke=U[Ee];Ke.isBefore(te)&&(te=Ke)}return te}static Max(...U){if(U.length===0)throw new TypeError;let te=U[0];for(let Ee=1;Ee<U.length;Ee++){const Ke=U[Ee];Ke.isAfter(te)&&(te=Ke)}return te}static isPosition(U){if(!U)return!1;if(U instanceof w)return!0;const{line:te,character:Ee}=U;return typeof te=="number"&&typeof Ee=="number"}static of(U){if(U instanceof w)return U;if(this.isPosition(U))return new w(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(U,te){if(U<0)throw(0,T.illegalArgument)("line must be non-negative");if(te<0)throw(0,T.illegalArgument)("character must be non-negative");this.c=U,this.e=te}isBefore(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<U.e}isBeforeOrEqual(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<=U.e}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this.c===U.c&&this.e===U.e}compareTo(U){return this.c<U.c?-1:this.c>U.line?1:this.e<U.e?-1:this.e>U.e?1:0}translate(U,te=0){if(U===null||te===null)throw(0,T.illegalArgument)();let Ee;return typeof U>"u"?Ee=0:typeof U=="number"?Ee=U:(Ee=typeof U.lineDelta=="number"?U.lineDelta:0,te=typeof U.characterDelta=="number"?U.characterDelta:0),Ee===0&&te===0?this:new w(this.line+Ee,this.character+te)}with(U,te=this.character){if(U===null||te===null)throw(0,T.illegalArgument)();let Ee;return typeof U>"u"?Ee=this.line:typeof U=="number"?Ee=U:(Ee=typeof U.line=="number"?U.line:this.line,te=typeof U.character=="number"?U.character:this.character),Ee===this.line&&te===this.character?this:new w(Ee,te)}toJSON(){return{line:this.line,character:this.character}}};K=w=qe([F],K),e.Position=K;let ie=s=class{static isRange(U){return U instanceof s?!0:U?K.isPosition(U.start)&&K.isPosition(U.end):!1}static of(U){if(U instanceof s)return U;if(this.isRange(U))return new s(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(U,te,Ee,Ke){let _e,ot;if(typeof U=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(_e=new K(U,te),ot=new K(Ee,Ke)):K.isPosition(U)&&K.isPosition(te)&&(_e=K.of(U),ot=K.of(te)),!_e||!ot)throw new Error("Invalid arguments");_e.isBefore(ot)?(this.c=_e,this.e=ot):(this.c=ot,this.e=_e)}contains(U){return s.isRange(U)?this.contains(U.start)&&this.contains(U.end):K.isPosition(U)?!(K.of(U).isBefore(this.c)||this.e.isBefore(U)):!1}isEqual(U){return this.c.isEqual(U.c)&&this.e.isEqual(U.e)}intersection(U){const te=K.Max(U.start,this.c),Ee=K.Min(U.end,this.e);if(!te.isAfter(Ee))return new s(te,Ee)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const te=K.Min(U.start,this.c),Ee=K.Max(U.end,this.end);return new s(te,Ee)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(U,te=this.end){if(U===null||te===null)throw(0,T.illegalArgument)();let Ee;return U?K.isPosition(U)?Ee=U:(Ee=U.start||this.start,te=U.end||this.end):Ee=this.start,Ee.isEqual(this.c)&&te.isEqual(this.end)?this:new s(Ee,te)}toJSON(){return[this.start,this.end]}};ie=s=qe([F],ie),e.Range=ie;let ge=r=class extends ie{static isSelection(U){return U instanceof r?!0:U?ie.isRange(U)&&K.isPosition(U.anchor)&&K.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(U,te,Ee,Ke){let _e,ot;if(typeof U=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(_e=new K(U,te),ot=new K(Ee,Ke)):K.isPosition(U)&&K.isPosition(te)&&(_e=K.of(U),ot=K.of(te)),!_e||!ot)throw new Error("Invalid arguments");super(_e,ot),this.f=_e,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ge=r=qe([F],ge),e.Selection=ge;class ue{constructor(U,te,Ee){if(typeof U!="string"||U.length===0)throw(0,T.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,T.illegalArgument)("port");if(typeof Ee<"u"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z_\-]+$/.test(Ee)))throw(0,T.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(te),this.connectionToken=Ee}}e.ResolvedAuthority=ue;class re extends Error{static NotAvailable(U,te){return new re(U,m.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(U){return new re(U,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,te=m.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(U),this._message=U,this._code=te,this._detail=Ee,Object.setPrototypeOf(this,re.prototype)}}e.RemoteAuthorityResolverError=re;var se;(function(W){W[W.LF=1]="LF",W[W.CRLF=2]="CRLF"})(se=e.EndOfLine||(e.EndOfLine={}));var le;(function(W){W[W.Replace=1]="Replace",W[W.Append=2]="Append",W[W.Prepend=3]="Prepend"})(le=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let _=o=class{static isTextEdit(U){return U instanceof o?!0:U?ie.isRange(U)&&typeof U.newText=="string":!1}static replace(U,te){return new o(U,te)}static insert(U,te){return o.replace(new ie(U,U),te)}static delete(U){return o.replace(U,"")}static setEndOfLine(U){const te=new o(new ie(new K(0,0),new K(0,0)),"");return te.newEol=U,te}get range(){return this.c}set range(U){if(U&&!ie.isRange(U))throw(0,T.illegalArgument)("range");this.c=U}get newText(){return this.e||""}set newText(U){if(U&&typeof U!="string")throw(0,T.illegalArgument)("newText");this.e=U}get newEol(){return this.f}set newEol(U){if(U&&typeof U!="number")throw(0,T.illegalArgument)("newEol");this.f=U}constructor(U,te){this.c=U,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};_=o=qe([F],_),e.TextEdit=_;let me=h=class{static isNotebookCellEdit(U){return U instanceof h?!0:U?Gt.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,te){return new h(U,te)}static insertCells(U,te){return new h(new Gt(U,U),te)}static deleteCells(U){return new h(U,[])}static updateCellMetadata(U,te){const Ee=new h(new Gt(U,U),[]);return Ee.newCellMetadata=te,Ee}static updateNotebookMetadata(U){const te=new h(new Gt(0,0),[]);return te.newNotebookMetadata=U,te}constructor(U,te){this.range=U,this.newCells=te}};me=h=qe([F],me),e.NotebookEdit=me;class we{static isSnippetTextEdit(U){return U instanceof we?!0:U?ie.isRange(U.range)&&Qe.isSnippetString(U.snippet):!1}static replace(U,te){return new we(U,te)}static insert(U,te){return we.replace(new ie(U,U),te)}constructor(U,te){this.range=U,this.snippet=te}}e.SnippetTextEdit=we;var Me;(function(W){W[W.File=1]="File",W[W.Text=2]="Text",W[W.Cell=3]="Cell",W[W.CellReplace=5]="CellReplace",W[W.Snippet=6]="Snippet"})(Me=e.FileEditType||(e.FileEditType={}));let We=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(U,te,Ee,Ke){this.c.push({_type:1,from:U,to:te,options:Ee,metadata:Ke})}createFile(U,te,Ee){this.c.push({_type:1,from:void 0,to:U,options:te,metadata:Ee})}deleteFile(U,te,Ee){this.c.push({_type:1,from:U,to:void 0,options:te,metadata:Ee})}e(U,te,Ee){this.c.push({_type:3,metadata:Ee,uri:U,edit:{editType:5,metadata:te},notebookMetadata:te})}f(U,te,Ee,Ke){const _e=te.start,ot=te.end;(_e!==ot||Ee.length>0)&&this.c.push({_type:5,uri:U,index:_e,count:ot-_e,cells:Ee,metadata:Ke})}g(U,te,Ee,Ke){this.c.push({_type:3,metadata:Ke,uri:U,edit:{editType:8,index:te,metadata:Ee}})}replace(U,te,Ee,Ke){this.c.push({_type:2,uri:U,edit:new _(te,Ee),metadata:Ke})}insert(U,te,Ee,Ke){this.replace(U,new ie(te,te),Ee,Ke)}delete(U,te,Ee){this.replace(U,te,"",Ee)}has(U){return this.c.some(te=>te._type===2&&te.uri.toString()===U.toString())}set(U,te){if(te)for(const Ee of te){if(!Ee)continue;let Ke,_e;Array.isArray(Ee)?(Ke=Ee[0],_e=Ee[1]):Ke=Ee,me.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(U,Ke.range.start,Ke.newCellMetadata,_e):Ke.newNotebookMetadata?this.e(U,Ke.newNotebookMetadata,_e):this.f(U,Ke.range,Ke.newCells,_e):we.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:U,range:Ke.range,edit:Ke.snippet,metadata:_e}):this.c.push({_type:2,uri:U,edit:Ke,metadata:_e})}else{for(let Ee=0;Ee<this.c.length;Ee++){const Ke=this.c[Ee];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===U.toString()&&(this.c[Ee]=void 0);break}}(0,i.coalesceInPlace)(this.c)}}get(U){const te=[];for(const Ee of this.c)Ee._type===2&&Ee.uri.toString()===U.toString()&&te.push(Ee.edit);return te}entries(){const U=new L.ResourceMap;for(const te of this.c)if(te._type===2){let Ee=U.get(te.uri);Ee||(Ee=[te.uri,[]],U.set(te.uri,Ee)),Ee[1].push(te.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};We=qe([F],We),e.WorkspaceEdit=We;let Qe=a=class{static isSnippetString(U){return U instanceof a?!0:U?typeof U.value=="string":!1}static c(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this.e=1,this.value=U||""}appendText(U){return this.value+=a.c(U),this}appendTabstop(U=this.e++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,te=this.e++){if(typeof U=="function"){const Ee=new a;Ee.e=this.e,U(Ee),this.e=Ee.e,U=Ee.value}else U=a.c(U);return this.value+="${",this.value+=te,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,te=this.e++){const Ee=U.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(U,te){if(typeof te=="function"){const Ee=new a;Ee.e=this.e,te(Ee),this.e=Ee.e,te=Ee.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,te&&(this.value+=":",this.value+=te),this.value+="}",this}};Qe=a=qe([F],Qe),e.SnippetString=Qe;var Te;(function(W){W[W.Unnecessary=1]="Unnecessary",W[W.Deprecated=2]="Deprecated"})(Te=e.DiagnosticTag||(e.DiagnosticTag={}));var De;(function(W){W[W.Hint=3]="Hint",W[W.Information=2]="Information",W[W.Warning=1]="Warning",W[W.Error=0]="Error"})(De=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ke=l=class{static isLocation(U){return U instanceof l?!0:U?ie.isRange(U.range)&&k.URI.isUri(U.uri):!1}constructor(U,te){if(this.uri=U,te)if(ie.isRange(te))this.range=ie.of(te);else if(K.isPosition(te))this.range=new ie(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ke=l=qe([F],ke),e.Location=ke;let oe=class{static is(U){return U?typeof U.message=="string"&&U.location&&ie.isRange(U.location.range)&&k.URI.isUri(U.location.uri):!1}constructor(U,te){this.location=U,this.message=te}static isEqual(U,te){return U===te?!0:!U||!te?!1:U.message===te.message&&U.location.range.isEqual(te.location.range)&&U.location.uri.toString()===te.location.uri.toString()}};oe=qe([F],oe),e.DiagnosticRelatedInformation=oe;let ce=class{constructor(U,te,Ee=De.Error){if(!ie.isRange(U))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=U,this.message=te,this.severity=Ee}toJSON(){return{severity:De[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,te){return U===te?!0:!U||!te?!1:U.message===te.message&&U.severity===te.severity&&U.code===te.code&&U.severity===te.severity&&U.source===te.source&&U.range.isEqual(te.range)&&(0,i.equals)(U.tags,te.tags)&&(0,i.equals)(U.relatedInformation,te.relatedInformation,oe.isEqual)}};ce=qe([F],ce),e.Diagnostic=ce;let Y=class{constructor(U,te){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=te}};Y=qe([F],Y),e.Hover=Y;var I;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(I=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let $=class{constructor(U,te=I.Text){this.range=U,this.kind=te}toJSON(){return{range:this.range,kind:I[this.kind]}}};$=qe([F],$),e.DocumentHighlight=$;var H;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(H=e.SymbolKind||(e.SymbolKind={}));var j;(function(W){W[W.Deprecated=1]="Deprecated"})(j=e.SymbolTag||(e.SymbolTag={}));let Z=n=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,te,Ee,Ke,_e){this.name=U,this.kind=te,this.containerName=_e,typeof Ee=="string"&&(this.containerName=Ee),Ke instanceof ke?this.location=Ke:Ee instanceof ie&&(this.location=new ke(Ke,Ee)),n.validate(this)}toJSON(){return{name:this.name,kind:H[this.kind],location:this.location,containerName:this.containerName}}};Z=n=qe([F],Z),e.SymbolInformation=Z;let de=d=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(d.validate)}constructor(U,te,Ee,Ke,_e){this.name=U,this.detail=te,this.kind=Ee,this.range=Ke,this.selectionRange=_e,this.children=[],d.validate(this)}};de=d=qe([F],de),e.DocumentSymbol=de;var Se;(function(W){W[W.Invoke=1]="Invoke",W[W.Automatic=2]="Automatic"})(Se=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ae=class{constructor(U,te){this.title=U,this.kind=te}};ae=qe([F],ae),e.CodeAction=ae;let ve=g=class{constructor(U){this.value=U}append(U){return new g(this.value?this.value+g.c+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+g.c)}};ve.c=".",ve=g=qe([F],ve),e.CodeActionKind=ve,ve.Empty=new ve(""),ve.QuickFix=ve.Empty.append("quickfix"),ve.Refactor=ve.Empty.append("refactor"),ve.RefactorExtract=ve.Refactor.append("extract"),ve.RefactorInline=ve.Refactor.append("inline"),ve.RefactorMove=ve.Refactor.append("move"),ve.RefactorRewrite=ve.Refactor.append("rewrite"),ve.Source=ve.Empty.append("source"),ve.SourceOrganizeImports=ve.Source.append("organizeImports"),ve.SourceFixAll=ve.Source.append("fixAll");let be=class{constructor(U,te){if(this.range=U,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};be=qe([F],be),e.SelectionRange=be;class $e{constructor(U,te,Ee,Ke,_e,ot){this.kind=U,this.name=te,this.detail=Ee,this.uri=Ke,this.range=_e,this.selectionRange=ot}}e.CallHierarchyItem=$e;class He{constructor(U,te){this.fromRanges=te,this.from=U}}e.CallHierarchyIncomingCall=He;class tt{constructor(U,te){this.fromRanges=te,this.to=U}}e.CallHierarchyOutgoingCall=tt;var xe;(function(W){W[W.Information=0]="Information",W[W.Warning=1]="Warning",W[W.Error=2]="Error"})(xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(U,te){this.range=U,this.command=te}get isResolved(){return!!this.command}};et=qe([F],et),e.CodeLens=et;let it=O=class{static isMarkdownString(U){return U instanceof O?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,te=!1){c.set(this,void 0),Ye(this,c,new y.MarkdownString(U,{supportThemeIcons:te}),"f")}get value(){return Re(this,c,"f").value}set value(U){Re(this,c,"f").value=U}get isTrusted(){return Re(this,c,"f").isTrusted}set isTrusted(U){Re(this,c,"f").isTrusted=U}get supportThemeIcons(){return Re(this,c,"f").supportThemeIcons}set supportThemeIcons(U){Re(this,c,"f").supportThemeIcons=U}get supportHtml(){return Re(this,c,"f").supportHtml}set supportHtml(U){Re(this,c,"f").supportHtml=U}get baseUri(){return Re(this,c,"f").baseUri}set baseUri(U){Re(this,c,"f").baseUri=U}appendText(U){return Re(this,c,"f").appendText(U),this}appendMarkdown(U){return Re(this,c,"f").appendMarkdown(U),this}appendCodeblock(U,te){return Re(this,c,"f").appendCodeblock(te??"",U),this}};c=new WeakMap,it=O=qe([F],it),e.MarkdownString=it;let dt=class{constructor(U,te){this.label=U,this.documentation=te}};dt=qe([F],dt),e.ParameterInformation=dt;let Fe=class{constructor(U,te){this.label=U,this.documentation=te,this.parameters=[]}};Fe=qe([F],Fe),e.SignatureInformation=Fe;let st=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};st=qe([F],st),e.SignatureHelp=st;var Q;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(Q=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var X;(function(W){W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(X=e.InlayHintKind||(e.InlayHintKind={}));let pe=class{constructor(U){this.value=U}};pe=qe([F],pe),e.InlayHintLabelPart=pe;let Ne=class{constructor(U,te,Ee){this.position=U,this.label=te,this.kind=Ee}};Ne=qe([F],Ne),e.InlayHint=Ne;var Be;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Be=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var je;(function(W){W[W.Text=0]="Text",W[W.Method=1]="Method",W[W.Function=2]="Function",W[W.Constructor=3]="Constructor",W[W.Field=4]="Field",W[W.Variable=5]="Variable",W[W.Class=6]="Class",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Unit=10]="Unit",W[W.Value=11]="Value",W[W.Enum=12]="Enum",W[W.Keyword=13]="Keyword",W[W.Snippet=14]="Snippet",W[W.Color=15]="Color",W[W.File=16]="File",W[W.Reference=17]="Reference",W[W.Folder=18]="Folder",W[W.EnumMember=19]="EnumMember",W[W.Constant=20]="Constant",W[W.Struct=21]="Struct",W[W.Event=22]="Event",W[W.Operator=23]="Operator",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue"})(je=e.CompletionItemKind||(e.CompletionItemKind={}));var Je;(function(W){W[W.Deprecated=1]="Deprecated"})(Je=e.CompletionItemTag||(e.CompletionItemTag={}));let nt=class{constructor(U,te){this.label=U,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&je[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};nt=qe([F],nt),e.CompletionItem=nt;let vt=class{constructor(U=[],te=!1){this.items=U,this.isIncomplete=te}};vt=qe([F],vt),e.CompletionList=vt;let wt=class{constructor(U,te,Ee){this.insertText=U,this.range=te,this.command=Ee}};wt=qe([F],wt),e.InlineSuggestion=wt;let Tt=class{constructor(U){this.commands=void 0,this.items=U}};Tt=qe([F],Tt),e.InlineSuggestionList=Tt;var lt;(function(W){W[W.Active=-1]="Active",W[W.Beside=-2]="Beside",W[W.One=1]="One",W[W.Two=2]="Two",W[W.Three=3]="Three",W[W.Four=4]="Four",W[W.Five=5]="Five",W[W.Six=6]="Six",W[W.Seven=7]="Seven",W[W.Eight=8]="Eight",W[W.Nine=9]="Nine"})(lt=e.ViewColumn||(e.ViewColumn={}));var at;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(at=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ut;(function(W){W[W.Off=0]="Off",W[W.On=1]="On",W[W.Relative=2]="Relative"})(Ut=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ft;(function(W){W[W.Manual=1]="Manual",W[W.AfterDelay=2]="AfterDelay",W[W.FocusOut=3]="FocusOut"})(Ft=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Mt;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(Mt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ft;(function(W){W[W.Keyboard=1]="Keyboard",W[W.Mouse=2]="Mouse",W[W.Command=3]="Command"})(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ct;(function(W){W[W.Undo=1]="Undo",W[W.Redo=2]="Redo"})(Ct=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Bt;(function(W){W[W.OpenOpen=0]="OpenOpen",W[W.ClosedClosed=1]="ClosedClosed",W[W.OpenClosed=2]="OpenClosed",W[W.ClosedOpen=3]="ClosedOpen"})(Bt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(W){function U(te){switch(te){case"keyboard":return W.Keyboard;case"mouse":return W.Mouse;case"api":return W.Command}}W.fromValue=U}(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Nt=class{constructor(U,te){if(te&&!k.URI.isUri(te))throw(0,T.illegalArgument)("target");if(!ie.isRange(U)||U.isEmpty)throw(0,T.illegalArgument)("range");this.range=U,this.target=te}};Nt=qe([F],Nt),e.DocumentLink=Nt;let Ge=class{constructor(U,te,Ee,Ke){this.red=U,this.green=te,this.blue=Ee,this.alpha=Ke}};Ge=qe([F],Ge),e.Color=Ge;let Rt=class{constructor(U,te){if(te&&!(te instanceof Ge))throw(0,T.illegalArgument)("color");if(!ie.isRange(U)||U.isEmpty)throw(0,T.illegalArgument)("range");this.range=U,this.color=te}};Rt=qe([F],Rt),e.ColorInformation=Rt;let Lt=class{constructor(U){if(!U||typeof U!="string")throw(0,T.illegalArgument)("label");this.label=U}};Lt=qe([F],Lt),e.ColorPresentation=Lt;var Ht;(function(W){W[W.RGB=0]="RGB",W[W.HEX=1]="HEX",W[W.HSL=2]="HSL"})(Ht=e.ColorFormat||(e.ColorFormat={}));var mt;(function(W){W[W.Error=0]="Error",W[W.Warning=1]="Warning",W[W.Information=2]="Information"})(mt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var At;(function(W){W[W.Unknown=0]="Unknown",W[W.Shutdown=1]="Shutdown",W[W.Process=2]="Process",W[W.User=3]="User",W[W.Extension=4]="Extension"})(At=e.TerminalExitReason||(e.TerminalExitReason={}));class ye{constructor(U,te,Ee){if(this.startIndex=U,this.length=te,this.tooltip=Ee,typeof U!="number"||U<0)throw(0,T.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,T.illegalArgument)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,T.illegalArgument)("tooltip")}}e.TerminalLink=ye;var Pe;(function(W){W[W.Panel=1]="Panel",W[W.Editor=2]="Editor"})(Pe=e.TerminalLocation||(e.TerminalLocation={}));class fe{constructor(U){if(this.options=U,typeof U!="object")throw(0,T.illegalArgument)("options")}}e.TerminalProfile=fe;var G;(function(W){W[W.Always=1]="Always",W[W.Silent=2]="Silent",W[W.Never=3]="Never"})(G=e.TaskRevealKind||(e.TaskRevealKind={}));var Ae;(function(W){W[W.Shared=1]="Shared",W[W.Dedicated=2]="Dedicated",W[W.New=3]="New"})(Ae=e.TaskPanelKind||(e.TaskPanelKind={}));let Le=N=class{static from(U){switch(U){case"clean":return N.Clean;case"build":return N.Build;case"rebuild":return N.Rebuild;case"test":return N.Test;default:return}}constructor(U,te){if(this.label=te,typeof U!="string"||typeof te!="string")throw(0,T.illegalArgument)("name");this.c=U}get id(){return this.c}};Le.Clean=new N("clean","Clean"),Le.Build=new N("build","Build"),Le.Rebuild=new N("rebuild","Rebuild"),Le.Test=new N("test","Test"),Le=N=qe([F],Le),e.TaskGroup=Le;function Xe(W){let U="";for(let te=0;te<W.length;te++)U+=W[te].replace(/,/g,",,")+",";return U}let ze=class{constructor(U,te,Ee){if(typeof U!="string")throw(0,T.illegalArgument)("process");this.e=[],this.c=U,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=Ee):this.f=te)}get process(){return this.c}set process(U){if(typeof U!="string")throw(0,T.illegalArgument)("process");this.c=U}get args(){return this.e}set args(U){Array.isArray(U)||(U=[]),this.e=U}get options(){return this.f}set options(U){this.f=U}computeId(){const U=[];if(U.push("process"),this.c!==void 0&&U.push(this.c),this.e&&this.e.length>0)for(const te of this.e)U.push(te);return Xe(U)}};ze=qe([F],ze),e.ProcessExecution=ze;let Ze=class{constructor(U,te,Ee){if(this.f=[],Array.isArray(te)){if(!U)throw(0,T.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,T.illegalArgument)("command");this.e=U,this.f=te,this.g=Ee}else{if(typeof U!="string")throw(0,T.illegalArgument)("commandLine");this.c=U,this.g=te}}get commandLine(){return this.c}set commandLine(U){if(typeof U!="string")throw(0,T.illegalArgument)("commandLine");this.c=U}get command(){return this.e?this.e:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,T.illegalArgument)("command");this.e=U}get args(){return this.f}set args(U){this.f=U||[]}get options(){return this.g}set options(U){this.g=U}computeId(){const U=[];if(U.push("shell"),this.c!==void 0&&U.push(this.c),this.e!==void 0&&U.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)U.push(typeof te=="string"?te:te.value);return Xe(U)}};Ze=qe([F],Ze),e.ShellExecution=Ze;var It;(function(W){W[W.Escape=1]="Escape",W[W.Strong=2]="Strong",W[W.Weak=3]="Weak"})(It=e.ShellQuoting||(e.ShellQuoting={}));var bt;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace"})(bt=e.TaskScope||(e.TaskScope={}));class kt{constructor(U){this.c=U}computeId(){return"customExecution"+(0,M.generateUuid)()}set callback(U){this.c=U}get callback(){return this.c}}e.CustomExecution=kt;let gt=q=class{constructor(U,te,Ee,Ke,_e,ot){this.j=!1,this.k=this.definition=U;let ut;typeof te=="string"?(this.m=this.name=te,this.t=this.source=Ee,this.execution=Ke,ut=_e,this.j=!0):te===bt.Global||te===bt.Workspace?(this.target=te,this.m=this.name=Ee,this.t=this.source=Ke,this.execution=_e,ut=ot):(this.target=te,this.m=this.name=Ee,this.t=this.source=Ke,this.execution=_e,ut=ot),typeof ut=="string"?(this.o=[ut],this.q=!0):Array.isArray(ut)?(this.o=ut,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(U){this.h=U}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof ze?this.k={type:q.e,id:this.n.computeId()}:this.n instanceof Ze?this.k={type:q.f,id:this.n.computeId()}:this.n instanceof kt?this.k={type:q.c,id:this.n.computeId()}:this.k={type:q.g,id:(0,M.generateUuid)()}}get definition(){return this.k}set definition(U){if(U==null)throw(0,T.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=U}get scope(){return this.l}set target(U){this.y(),this.l=U}get name(){return this.m}set name(U){if(typeof U!="string")throw(0,T.illegalArgument)("name");this.y(),this.m=U}get execution(){return this.n}set execution(U){U===null&&(U=void 0),this.y(),this.n=U;const te=this.k.type;(q.g===te||q.e===te||q.f===te||q.c===te)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(U){if(Array.isArray(U))this.y(),this.o=U,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.y(),this.r=U}get source(){return this.t}set source(U){if(typeof U!="string"||U.length===0)throw(0,T.illegalArgument)("source must be a string of length > 0");this.y(),this.t=U}get group(){return this.u}set group(U){U===null&&(U=void 0),this.y(),this.u=U}get detail(){return this.x}set detail(U){U===null&&(U=void 0),this.x=U}get presentationOptions(){return this.v}set presentationOptions(U){U==null&&(U=Object.create(null)),this.y(),this.v=U}get runOptions(){return this.w}set runOptions(U){U==null&&(U=Object.create(null)),this.y(),this.w=U}};gt.c="customExecution",gt.e="process",gt.f="shell",gt.g="$empty",gt=q=qe([F],gt),e.Task=gt;var pt;(function(W){W[W.SourceControl=1]="SourceControl",W[W.Window=10]="Window",W[W.Notification=15]="Notification"})(pt=e.ProgressLocation||(e.ProgressLocation={}));var St;(function(W){function U(te){const Ee=te;return(0,S.isNumber)(Ee.value)?Ee.tooltip&&!(0,S.isString)(Ee.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ee.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ee.value),!1)}W.isViewBadge=U})(St=e.ViewBadge||(e.ViewBadge={}));let $t=J=class{static isTreeItem(U,te){if(U instanceof J)return!0;const Ee=U;if(Ee.label!==void 0&&!(0,S.isString)(Ee.label)&&!Ee.label?.label)return console.log("INVALID tree item, invalid label",Ee.label),!1;if(Ee.id!==void 0&&!(0,S.isString)(Ee.id))return console.log("INVALID tree item, invalid id",Ee.id),!1;if(Ee.iconPath!==void 0&&!(0,S.isString)(Ee.iconPath)&&!k.URI.isUri(Ee.iconPath)&&(!Ee.iconPath||!(0,S.isString)(Ee.iconPath.id))){const Ke=Ee.iconPath;if(!Ke||!(0,S.isString)(Ke.light)&&!k.URI.isUri(Ke.light)&&!(0,S.isString)(Ke.dark)&&!k.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Ee.iconPath),!1}if(Ee.description!==void 0&&!(0,S.isString)(Ee.description)&&typeof Ee.description!="boolean")return console.log("INVALID tree item, invalid description",Ee.description),!1;if(Ee.resourceUri!==void 0&&!k.URI.isUri(Ee.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Ee.resourceUri),!1;if(Ee.tooltip!==void 0&&!(0,S.isString)(Ee.tooltip)&&!(Ee.tooltip instanceof it))return console.log("INVALID tree item, invalid tooltip",Ee.tooltip),!1;if(Ee.command!==void 0&&!Ee.command.command)return console.log("INVALID tree item, invalid command",Ee.command),!1;if(Ee.collapsibleState!==void 0&&Ee.collapsibleState<Xt.None&&Ee.collapsibleState>Xt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Ee.collapsibleState),!1;if(Ee.contextValue!==void 0&&!(0,S.isString)(Ee.contextValue))return console.log("INVALID tree item, invalid contextValue",Ee.contextValue),!1;if(Ee.accessibilityInformation!==void 0&&!Ee.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Ee.accessibilityInformation),!1;if(Ee.checkboxState!==void 0){(0,f.checkProposedApiEnabled)(te,"treeItemCheckbox");const Ke=(0,S.isNumber)(Ee.checkboxState)?Ee.checkboxState:(0,S.isObject)(Ee.checkboxState)&&(0,S.isNumber)(Ee.checkboxState.state)?Ee.checkboxState.state:void 0,_e=!(0,S.isNumber)(Ee.checkboxState)&&(0,S.isObject)(Ee.checkboxState)?Ee.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==Et.Checked&&Ke!==Et.Unchecked||_e!==void 0&&!(0,S.isString)(_e))return console.log("INVALID tree item, invalid checkboxState",Ee.checkboxState),!1}return!0}constructor(U,te=Xt.None){this.collapsibleState=te,k.URI.isUri(U)?this.resourceUri=U:this.label=U}};$t=J=qe([F],$t),e.TreeItem=$t;var Xt;(function(W){W[W.None=0]="None",W[W.Collapsed=1]="Collapsed",W[W.Expanded=2]="Expanded"})(Xt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var Et;(function(W){W[W.Unchecked=0]="Unchecked",W[W.Checked=1]="Checked"})(Et=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let si=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U,te){this.value=U,this.id=te??(0,M.generateUuid)()}};si=qe([F],si),e.DataTransferItem=si;let oi=class{constructor(U){u.set(this,new Map);for(const[te,Ee]of U??[]){const Ke=Re(this,u,"f").get(te);Ke?Ke.push(Ee):Re(this,u,"f").set(te,[Ee])}}get(U){return Re(this,u,"f").get(U)?.[0]}set(U,te){Re(this,u,"f").set(U,[te])}forEach(U,te){for(const[Ee,Ke]of Re(this,u,"f"))for(const _e of Ke)U.call(te,_e,Ee,this)}*[(u=new WeakMap,Symbol.iterator)](){for(const[U,te]of Re(this,u,"f"))for(const Ee of te)yield[U,Ee]}};oi=qe([F],oi),e.DataTransfer=oi;let Zt=class{constructor(U){this.insertText=U}};Zt=qe([F],Zt),e.DocumentDropEdit=Zt;let pi=class{constructor(U){this.insertText=U}};pi=qe([F],pi),e.DocumentPasteEdit=pi;let yt=class{constructor(U,te){this.id=U,this.color=te}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};yt=qe([F],yt),e.ThemeIcon=yt,yt.File=new yt("file"),yt.Folder=new yt("folder");let ai=class{constructor(U){this.id=U}};ai=qe([F],ai),e.ThemeColor=ai;var Oi;(function(W){W[W.Global=1]="Global",W[W.Workspace=2]="Workspace",W[W.WorkspaceFolder=3]="WorkspaceFolder"})(Oi=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ei=class{get base(){return this.c}set base(U){this.c=U,this.e=k.URI.file(U)}get baseUri(){return this.e}set baseUri(U){this.e=U,this.c=U.fsPath}constructor(U,te){if(typeof U!="string"&&(!U||!k.URI.isUri(U)&&!k.URI.isUri(U.uri)))throw(0,T.illegalArgument)("base");if(typeof te!="string")throw(0,T.illegalArgument)("pattern");typeof U=="string"?this.baseUri=k.URI.file(U):k.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ei=qe([F],ei),e.RelativePattern=ei;let Vt=class{constructor(U,te,Ee,Ke){this.enabled=typeof U=="boolean"?U:!0,typeof te=="string"&&(this.condition=te),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=(0,M.generateUuid)()),this.c}};Vt=qe([F],Vt),e.Breakpoint=Vt;let ct=class extends Vt{constructor(U,te,Ee,Ke,_e){if(super(te,Ee,Ke,_e),U===null)throw(0,T.illegalArgument)("location");this.location=U}};ct=qe([F],ct),e.SourceBreakpoint=ct;let vi=class extends Vt{constructor(U,te,Ee,Ke,_e){super(te,Ee,Ke,_e),this.functionName=U}};vi=qe([F],vi),e.FunctionBreakpoint=vi;let jt=class extends Vt{constructor(U,te,Ee,Ke,_e,ot,ut){if(super(Ke,_e,ot,ut),!te)throw(0,T.illegalArgument)("dataId");this.label=U,this.dataId=te,this.canPersist=Ee}};jt=qe([F],jt),e.DataBreakpoint=jt;let Qt=class{constructor(U,te,Ee){this.command=U,this.args=te||[],this.options=Ee}};Qt=qe([F],Qt),e.DebugAdapterExecutable=Qt;let ci=class{constructor(U,te){this.port=U,this.host=te}};ci=qe([F],ci),e.DebugAdapterServer=ci;let bi=class{constructor(U){this.path=U}};bi=qe([F],bi),e.DebugAdapterNamedPipeServer=bi;let ui=class{constructor(U){this.implementation=U}};ui=qe([F],ui),e.DebugAdapterInlineImplementation=ui;let Ei=class{constructor(U,te){this.range=U,this.expression=te}};Ei=qe([F],Ei),e.EvaluatableExpression=Ei;var Ci;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(Ci=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ti=class{constructor(U,te){this.range=U,this.text=te}};ti=qe([F],ti),e.InlineValueText=ti;let wi=class{constructor(U,te,Ee=!0){this.range=U,this.variableName=te,this.caseSensitiveLookup=Ee}};wi=qe([F],wi),e.InlineValueVariableLookup=wi;let ni=class{constructor(U,te){this.range=U,this.expression=te}};ni=qe([F],ni),e.InlineValueEvaluatableExpression=ni;let ri=class{constructor(U,te){this.frameId=U,this.stoppedLocation=te}};ri=qe([F],ri),e.InlineValueContext=ri;var Fi;(function(W){W[W.Changed=1]="Changed",W[W.Created=2]="Created",W[W.Deleted=3]="Deleted"})(Fi=e.FileChangeType||(e.FileChangeType={}));let Si=x=class extends Error{static FileExists(U){return new x(U,D.FileSystemProviderErrorCode.FileExists,x.FileExists)}static FileNotFound(U){return new x(U,D.FileSystemProviderErrorCode.FileNotFound,x.FileNotFound)}static FileNotADirectory(U){return new x(U,D.FileSystemProviderErrorCode.FileNotADirectory,x.FileNotADirectory)}static FileIsADirectory(U){return new x(U,D.FileSystemProviderErrorCode.FileIsADirectory,x.FileIsADirectory)}static NoPermissions(U){return new x(U,D.FileSystemProviderErrorCode.NoPermissions,x.NoPermissions)}static Unavailable(U){return new x(U,D.FileSystemProviderErrorCode.Unavailable,x.Unavailable)}constructor(U,te=D.FileSystemProviderErrorCode.Unknown,Ee){super(k.URI.isUri(U)?U.toString(!0):U),this.code=Ee?.name??"Unknown",(0,D.markAsFileSystemProviderError)(this,te),Object.setPrototypeOf(this,x.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}};Si=x=qe([F],Si),e.FileSystemError=Si;let _t=class{constructor(U,te,Ee){this.start=U,this.end=te,this.kind=Ee}};_t=qe([F],_t),e.FoldingRange=_t;var Mi;(function(W){W[W.Comment=1]="Comment",W[W.Imports=2]="Imports",W[W.Region=3]="Region"})(Mi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ni;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(Ni=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Li;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(Li=e.CommentMode||(e.CommentMode={}));var Ui;(function(W){W[W.Unresolved=0]="Unresolved",W[W.Resolved=1]="Resolved"})(Ui=e.CommentThreadState||(e.CommentThreadState={}));class Bi{constructor(U,te=[]){this.tokenTypes=U,this.tokenModifiers=te}}e.SemanticTokensLegend=Bi;function yi(W){return typeof W>"u"||(0,S.isStringArray)(W)}class li{constructor(U){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,U){this.l=!0;for(let te=0,Ee=U.tokenTypes.length;te<Ee;te++)this.j.set(U.tokenTypes[te],te);for(let te=0,Ee=U.tokenModifiers.length;te<Ee;te++)this.k.set(U.tokenModifiers[te],te)}}push(U,te,Ee,Ke,_e){if(typeof U=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ke=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.n(U,te,Ee,Ke,_e);if(ie.isRange(U)&&typeof te=="string"&&yi(Ee))return this.m(U,te,Ee);throw(0,T.illegalArgument)()}m(U,te,Ee){if(!this.l)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(te))throw new Error("`tokenType` is not in the provided legend");const Ke=U.start.line,_e=U.start.character,ot=U.end.character-U.start.character,ut=this.j.get(te);let Ot=0;if(Ee)for(const Wt of Ee){if(!this.k.has(Wt))throw new Error("`tokenModifier` is not in the provided legend");const qt=this.k.get(Wt);Ot|=1<<qt>>>0}this.n(Ke,_e,ot,ut,Ot)}n(U,te,Ee,Ke,_e){if(this.f&&(U<this.c||U===this.c&&te<this.e)){this.f=!1;const Ot=this.g.length/5|0;let Wt=0,qt=0;for(let xt=0;xt<Ot;xt++){let Yt=this.g[5*xt],Di=this.g[5*xt+1];Yt===0?(Yt=Wt,Di+=qt):Yt+=Wt,this.g[5*xt]=Yt,this.g[5*xt+1]=Di,Wt=Yt,qt=Di}}let ot=U,ut=te;this.f&&this.h>0&&(ot-=this.c,ot===0&&(ut-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=ut,this.g[this.h++]=Ee,this.g[this.h++]=Ke,this.g[this.h++]=_e,this.c=U,this.e=te}static o(U){const te=[],Ee=U.length/5|0;for(let ut=0;ut<Ee;ut++)te[ut]=ut;te.sort((ut,Ot)=>{const Wt=U[5*ut],qt=U[5*Ot];if(Wt===qt){const xt=U[5*ut+1],Yt=U[5*Ot+1];return xt-Yt}return Wt-qt});const Ke=new Uint32Array(U.length);let _e=0,ot=0;for(let ut=0;ut<Ee;ut++){const Ot=5*te[ut],Wt=U[Ot+0],qt=U[Ot+1],xt=U[Ot+2],Yt=U[Ot+3],Di=U[Ot+4],en=Wt-_e,Cn=en===0?qt-ot:qt,Ii=5*ut;Ke[Ii+0]=en,Ke[Ii+1]=Cn,Ke[Ii+2]=xt,Ke[Ii+3]=Yt,Ke[Ii+4]=Di,_e=Wt,ot=qt}return Ke}build(U){return this.f?new di(new Uint32Array(this.g),U):new di(li.o(this.g),U)}}e.SemanticTokensBuilder=li;class di{constructor(U,te){this.resultId=te,this.data=U}}e.SemanticTokens=di;class Ue{constructor(U,te,Ee){this.start=U,this.deleteCount=te,this.data=Ee}}e.SemanticTokensEdit=Ue;class Kt{constructor(U,te){this.resultId=te,this.edits=U}}e.SemanticTokensEdits=Kt;var ki;(function(W){W[W.Separate=0]="Separate",W[W.MergeWithParent=1]="MergeWithParent"})(ki=e.DebugConsoleMode||(e.DebugConsoleMode={}));let ht=class{constructor(){}};ht.Back={iconPath:new yt("arrow-left")},ht=qe([F],ht),e.QuickInputButtons=ht;var $i;(function(W){W[W.Separator=-1]="Separator",W[W.Default=0]="Default"})($i=e.QuickPickItemKind||(e.QuickPickItemKind={}));var zi;(function(W){W[W.Info=1]="Info",W[W.Warning=2]="Warning",W[W.Error=3]="Error"})(zi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Ti;(function(W){W[W.UI=1]="UI",W[W.Workspace=2]="Workspace"})(Ti=e.ExtensionKind||(e.ExtensionKind={}));class Wi{static validate(U){if(typeof U.badge=="string"){let te=(0,A.nextCharLength)(U.badge,0);if(te<U.badge.length&&(te+=(0,A.nextCharLength)(U.badge,te)),U.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!yt.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,te,Ee){this.badge=U,this.tooltip=te,this.color=Ee}}e.FileDecoration=Wi;let ii=class{constructor(U){this.kind=U}};ii=qe([F],ii),e.ColorTheme=ii;var Hi;(function(W){W[W.Light=1]="Light",W[W.Dark=2]="Dark",W[W.HighContrast=3]="HighContrast",W[W.HighContrastLight=4]="HighContrastLight"})(Hi=e.ColorThemeKind||(e.ColorThemeKind={}));class Gt{static isNotebookRange(U){return U instanceof Gt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(U,te){if(U<0)throw(0,T.illegalArgument)("start must be positive");if(te<0)throw(0,T.illegalArgument)("end must be positive");U<=te?(this.c=U,this.e=te):(this.c=te,this.e=U)}with(U){let te=this.c,Ee=this.e;return U.start!==void 0&&(te=U.start),U.end!==void 0&&(Ee=U.end),te===this.c&&Ee===this.e?this:new Gt(te,Ee)}}e.NotebookRange=Gt;class hi{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(te=>hi.isNotebookCellData(te))}static isNotebookCellData(U){return!0}constructor(U,te,Ee,Ke,_e,ot,ut){this.kind=U,this.value=te,this.languageId=Ee,this.mime=Ke,this.outputs=_e??[],this.metadata=ot,this.executionSummary=ut,hi.validate(this)}}e.NotebookCellData=hi;class Pi{constructor(U){this.cells=U}}e.NotebookData=Pi;class zt{static isNotebookCellOutputItem(U){return U instanceof zt?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const te={name:U.name,message:U.message,stack:U.stack};return zt.json(te,"application/vnd.code.notebook.error")}static stdout(U){return zt.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return zt.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,te="application/octet-stream"){return new zt(U,te)}static text(U,te=C.Mimes.text){const Ee=Re(zt,p,"f",E).encode(String(U));return new zt(Ee,te)}static json(U,te="text/x-json"){const Ee=JSON.stringify(U,void 0,"	");return zt.text(Ee,te)}constructor(U,te){this.data=U,this.mime=te;const Ee=(0,C.normalizeMimeType)(te,!0);if(!Ee)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}}e.NotebookCellOutputItem=zt,p=zt,E={value:new TextEncoder};class fi{static isNotebookCellOutput(U){return U instanceof fi?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,te=!1){const Ee=new Set,Ke=new Set;for(let _e=0;_e<U.length;_e++){const ot=U[_e],ut=(0,C.normalizeMimeType)(ot.mime);if(!Ee.has(ut)||(0,b.isTextStreamMime)(ut)){Ee.add(ut);continue}Ke.add(_e),te&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Ke.size===0?U:U.filter((_e,ot)=>!Ke.has(ot))}constructor(U,te,Ee){this.items=fi.ensureUniqueMimeTypes(U,!0),typeof te=="string"?(this.id=te,this.metadata=Ee):(this.id=(0,M.generateUuid)(),this.metadata=te??Ee)}}e.NotebookCellOutput=fi;var Vi;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(Vi=e.NotebookCellKind||(e.NotebookCellKind={}));var ji;(function(W){W[W.Idle=1]="Idle",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(ji=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var qi;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(qi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ki;(function(W){W[W.Default=0]="Default",W[W.InCenter=1]="InCenter",W[W.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",W[W.AtTop=3]="AtTop"})(Ki=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class ne{constructor(U,te){this.text=U,this.alignment=te}}e.NotebookCellStatusBarItem=ne;var he;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred"})(he=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Oe;(function(W){W[W.Default=1]="Default",W[W.Preferred=2]="Preferred",W[W.Hidden=-1]="Hidden"})(Oe=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class rt{constructor(U,te=[]){this.uri=U,this.provides=(0,i.asArray)(te)}}e.NotebookRendererScript=rt;class Dt{constructor(U){this.label=U}}e.NotebookKernelSourceAction=Dt;let Pt=class{constructor(U,te){this.label=U,this.timestamp=te}};Pt=qe([F],Pt),e.TimelineItem=Pt;var sn;(function(W){W[W.Production=1]="Production",W[W.Development=2]="Development",W[W.Test=3]="Test"})(sn=e.ExtensionMode||(e.ExtensionMode={}));var on;(function(W){W[W.Node=1]="Node",W[W.Webworker=2]="Webworker"})(on=e.ExtensionRuntime||(e.ExtensionRuntime={}));var an;(function(W){W[W.Other=0]="Other",W[W.Comment=1]="Comment",W[W.String=2]="String",W[W.RegEx=3]="RegEx"})(an=e.StandardTokenType||(e.StandardTokenType={}));class cn{constructor(U,te){this.ranges=U,this.wordPattern=te}}e.LinkedEditingRanges=cn;class un{constructor(U,te){this.c=U,this.e=te}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=un;var ln;(function(W){W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(ln=e.TestResultState||(e.TestResultState={}));var dn;(function(W){W[W.Run=1]="Run",W[W.Debug=2]="Debug",W[W.Coverage=3]="Coverage"})(dn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Gi=class{constructor(U=void 0,te=void 0,Ee=void 0){this.include=U,this.exclude=te,this.profile=Ee}};Gi=qe([F],Gi),e.TestRunRequest=Gi;let xi=R=class{static diff(U,te,Ee){const Ke=new R(U);return Ke.expectedOutput=te,Ke.actualOutput=Ee,Ke}constructor(U){this.message=U}};xi=R=qe([F],xi),e.TestMessage=xi;let Xi=class{constructor(U){this.id=U}};Xi=qe([F],Xi),e.TestTag=Xi;let mi=class{constructor(U,te){this.covered=U,this.total=te}};mi=qe([F],mi),e.CoveredCount=mi;let Qi=P=class{static fromDetails(U,te){const Ee=new mi(0,0),Ke=new mi(0,0),_e=new mi(0,0);for(const ut of te)if("branches"in ut){Ee.total+=1,Ee.covered+=ut.executionCount>0?1:0;for(const Ot of ut.branches)Ke.total+=1,Ke.covered+=Ot.executionCount>0?1:0}else _e.total+=1,_e.covered+=ut.executionCount>0?1:0;const ot=new P(U,Ee,Ke.total>0?Ke:void 0,_e.total>0?_e:void 0);return ot.detailedCoverage=te,ot}constructor(U,te,Ee,Ke){this.uri=U,this.statementCoverage=te,this.branchCoverage=Ee,this.functionCoverage=Ke}};Qi=P=qe([F],Qi),e.FileCoverage=Qi;let _i=class{constructor(U,te,Ee=[]){this.executionCount=U,this.location=te,this.branches=Ee}};_i=qe([F],_i),e.StatementCoverage=_i;let Yi=class{constructor(U,te){this.executionCount=U,this.location=te}};Yi=qe([F],Yi),e.BranchCoverage=Yi;let Ji=class{constructor(U,te){this.executionCount=U,this.location=te}};Ji=qe([F],Ji),e.FunctionCoverage=Ji;var hn;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(hn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var fn;(function(W){W[W.Untrusted=0]="Untrusted",W[W.Trusted=1]="Trusted",W[W.Unspecified=2]="Unspecified"})(fn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var mn;(function(W){W[W.Notify=1]="Notify",W[W.OpenBrowser=2]="OpenBrowser",W[W.OpenPreview=3]="OpenPreview",W[W.Silent=4]="Silent",W[W.Ignore=5]="Ignore",W[W.OpenBrowserOnce=6]="OpenBrowserOnce"})(mn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class gn{constructor(U,te,Ee,Ke,_e,ot){this.kind=U,this.name=te,this.detail=Ee,this.uri=Ke,this.range=_e,this.selectionRange=ot}}e.TypeHierarchyItem=gn;class pn{constructor(U){this.uri=U}}e.TextTabInput=pn;class vn{constructor(U,te){this.original=U,this.modified=te}}e.TextDiffTabInput=vn;class bn{constructor(U,te,Ee,Ke){this.base=U,this.input1=te,this.input2=Ee,this.result=Ke}}e.TextMergeTabInput=bn;class En{constructor(U,te){this.uri=U,this.viewType=te}}e.CustomEditorTabInput=En;class wn{constructor(U){this.viewType=U}}e.WebviewEditorTabInput=wn;class Sn{constructor(U,te){this.uri=U,this.notebookType=te}}e.NotebookEditorTabInput=Sn;class yn{constructor(U,te,Ee){this.original=U,this.modified=te,this.notebookType=Ee}}e.NotebookDiffEditorTabInput=yn;class Dn{constructor(){}}e.TerminalEditorTabInput=Dn;class In{constructor(U,te){this.uri=U,this.inputBoxUri=te}}e.InteractiveWindowInput=In}),define(Ie[96],Ce([1,0,47,13,10,249,127,6,16]),function(ee,e,i,T,y,L,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const k=new Map;function M(f,t){t?k.set(f,t):k.delete(f)}e.setWordDefinitionFor=M;function D(f){return k.get(f)}class m extends L.MirrorTextModel{constructor(t,c,u,p,E,v,w,s){super(c,u,p,E),this.m=t,this.p=v,this.q=w,this.notebook=s,this.b=!1}dispose(){(0,i.ok)(!this.b),this.b=!0,this.q=!1}equalLines(t){return(0,S.equals)(this.d,t)}get document(){if(!this.a){const t=this;this.a={get uri(){return t.c},get fileName(){return t.c.fsPath},get isUntitled(){return t.c.scheme===T.Schemas.untitled},get languageId(){return t.p},get version(){return t.g},get isClosed(){return t.b},get isDirty(){return t.q},save(){return t.r()},getText(c){return c?t.s(c):t.getText()},get eol(){return t.f===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return t.d.length},lineAt(c){return t.t(c)},offsetAt(c){return t.u(c)},positionAt(c){return t.v(c)},validateRange(c){return t.w(c)},validatePosition(c){return t.x(c)},getWordRangeAtPosition(c,u){return t.y(c,u)}}}return Object.freeze(this.a)}_acceptLanguageId(t){(0,i.ok)(!this.b),this.p=t}_acceptIsDirty(t){(0,i.ok)(!this.b),this.q=t}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(t){const c=this.w(t);if(c.isEmpty)return"";if(c.isSingleLine)return this.d[c.start.line].substring(c.start.character,c.end.character);const u=this.f,p=c.start.line,E=c.end.line,v=[];v.push(this.d[p].substring(c.start.character));for(let w=p+1;w<E;w++)v.push(this.d[w]);return v.push(this.d[E].substring(0,c.end.character)),v.join(u)}t(t){let c;if(t instanceof A.Position?c=t.line:typeof t=="number"&&(c=t),typeof c!="number"||c<0||c>=this.d.length||Math.floor(c)!==c)throw new Error("Illegal value for `line`");return new b(c,this.d[c],c===this.d.length-1)}u(t){return t=this.x(t),this.k(),this.h.getPrefixSum(t.line-1)+t.character}v(t){t=Math.floor(t),t=Math.max(0,t),this.k();const c=this.h.getIndexOf(t),u=this.d[c.index].length;return new A.Position(c.index,Math.min(c.remainder,u))}w(t){if(!(t instanceof A.Range))throw new Error("Invalid argument");const c=this.x(t.start),u=this.x(t.end);return c===t.start&&u===t.end?t:new A.Range(c.line,c.character,u.line,u.character)}x(t){if(!(t instanceof A.Position))throw new Error("Invalid argument");if(this.d.length===0)return t.with(0,0);let{line:c,character:u}=t,p=!1;if(c<0)c=0,u=0,p=!0;else if(c>=this.d.length)c=this.d.length-1,u=this.d[c].length,p=!0;else{const E=this.d[c].length;u<0?(u=0,p=!0):u>E&&(u=E,p=!0)}return p?new A.Position(c,u):t}y(t,c){const u=this.x(t);if(!c)c=D(this.p);else if((0,y.regExpLeadsToEndlessLoop)(c))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${c.source}' because it matches the empty string.`);const p=(0,C.getWordAtText)(u.character+1,(0,C.ensureValidWordDefinition)(c),this.d[u.line],0);if(p)return new A.Range(u.line,p.startColumn-1,u.line,p.endColumn-1)}}e.ExtHostDocumentData=m;class b{constructor(t,c,u){this.a=t,this.b=c,this.c=u}get lineNumber(){return this.a}get text(){return this.b}get range(){return new A.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new A.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=b}),define(Ie[184],Ce([1,0,6,15,5]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let L=class{constructor(A){this.a=new i.ColorTheme(i.ColorThemeKind.Dark),this.b=new y.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(A){let S;switch(A){case"light":S=i.ColorThemeKind.Light;break;case"hcDark":S=i.ColorThemeKind.HighContrast;break;case"hcLight":S=i.ColorThemeKind.HighContrastLight;break;default:S=i.ColorThemeKind.Dark}this.a=new i.ColorTheme(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};L=qe([Ve(0,T.IExtHostRpcService)],L),e.ExtHostTheming=L}),define(Ie[8],Ce([1,0,16,24,113,185,81,28,110,80,61,23,9,2,54,71,86,93,92,66,42,53,180,6]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m,b,f,t,c,u,p,E,v,w,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(ye){function Pe(G){const{selectionStartLineNumber:Ae,selectionStartColumn:Le,positionLineNumber:Xe,positionColumn:ze}=G,Ze=new r.Position(Ae-1,Le-1),It=new r.Position(Xe-1,ze-1);return new r.Selection(Ze,It)}ye.to=Pe;function fe(G){const{anchor:Ae,active:Le}=G;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}ye.from=fe})(o=e.Selection||(e.Selection={}));var h;(function(ye){function Pe(G){if(!G)return;const{start:Ae,end:Le}=G;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}ye.from=Pe;function fe(G){if(!G)return;const{startLineNumber:Ae,startColumn:Le,endLineNumber:Xe,endColumn:ze}=G;return new r.Range(Ae-1,Le-1,Xe-1,ze-1)}ye.to=fe})(h=e.Range||(e.Range={}));var a;(function(ye){function Pe(fe){switch(fe){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}ye.to=Pe})(a=e.TokenType||(e.TokenType={}));var l;(function(ye){function Pe(G){return new r.Position(G.lineNumber-1,G.column-1)}ye.to=Pe;function fe(G){return{lineNumber:G.line+1,column:G.character+1}}ye.from=fe})(l=e.Position||(e.Position={}));var n;(function(ye){function Pe(Ae,Le){return(0,i.coalesce)((0,i.asArray)(Ae).map(Xe=>fe(Xe,Le)))}ye.from=Pe;function fe(Ae,Le){if(typeof Ae=="string")return{$serialized:!0,language:Ae};if(Ae)return{$serialized:!0,language:Ae.language,scheme:G(Ae.scheme,Le),pattern:X.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType}}function G(Ae,Le){return Le&&typeof Ae=="string"?Le.transformOutgoingScheme(Ae):Ae}})(n=e.DocumentSelector||(e.DocumentSelector={}));var d;(function(ye){function Pe(G){switch(G){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}ye.from=Pe;function fe(G){switch(G){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}ye.to=fe})(d=e.DiagnosticTag||(e.DiagnosticTag={}));var g;(function(ye){function Pe(G){let Ae;return G.code&&((0,m.isString)(G.code)||(0,m.isNumber)(G.code)?Ae=String(G.code):Ae={value:String(G.code.value),target:G.code.target}),{...h.from(G.range),message:G.message,source:G.source,code:Ae,severity:N.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(O.from),tags:Array.isArray(G.tags)?(0,i.coalesce)(G.tags.map(d.from)):void 0}}ye.from=Pe;function fe(G){const Ae=new r.Diagnostic(h.to(G),G.message,N.to(G.severity));return Ae.source=G.source,Ae.code=(0,m.isString)(G.code)?G.code:G.code?.value,Ae.relatedInformation=G.relatedInformation&&G.relatedInformation.map(O.to),Ae.tags=G.tags&&(0,i.coalesce)(G.tags.map(d.to)),Ae}ye.to=fe})(g=e.Diagnostic||(e.Diagnostic={}));var O;(function(ye){function Pe(G){return{...h.from(G.location.range),message:G.message,resource:G.location.uri}}ye.from=Pe;function fe(G){return new r.DiagnosticRelatedInformation(new r.Location(G.resource,h.to(G)),G.message)}ye.to=fe})(O=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var N;(function(ye){function Pe(G){switch(G){case r.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}ye.from=Pe;function fe(G){switch(G){case c.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}ye.to=fe})(N=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var q;(function(ye){function Pe(G){return typeof G=="number"&&G>=r.ViewColumn.One?G-1:G===r.ViewColumn.Beside?s.SIDE_GROUP:s.ACTIVE_GROUP}ye.from=Pe;function fe(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=fe})(q=e.ViewColumn||(e.ViewColumn={}));function J(ye){return typeof ye.range<"u"}function x(ye){return ye.length===0?!0:!!J(ye[0])}e.isDecorationOptionsArr=x;var R;(function(ye){function Pe(ze){return ze.map(ye.from)}ye.fromMany=Pe;function fe(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function G(ze){let Ze;if(fe(ze)){const{language:gt,value:pt}=ze;Ze={value:"```"+gt+`
`+pt+"\n```\n"}}else r.MarkdownString.isMarkdownString(ze)?Ze={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons,supportHtml:ze.supportHtml,baseUri:ze.baseUri}:typeof ze=="string"?Ze={value:ze}:Ze={value:""};const It=Object.create(null);Ze.uris=It;const bt=gt=>{try{let pt=b.URI.parse(gt,!0);pt=pt.with({query:Ae(pt.query,It)}),It[gt]=pt}catch{}return""},kt=new S.marked.Renderer;return kt.link=bt,kt.image=gt=>typeof gt=="string"?bt(C.parseHrefAndDimensions(gt).href):"",(0,S.marked)(Ze.value,{renderer:kt}),Ze}ye.from=G;function Ae(ze,Ze){if(!ze)return ze;let It;try{It=(0,k.parse)(ze)}catch{}if(!It)return ze;let bt=!1;return It=(0,D.cloneAndChange)(It,kt=>{if(b.URI.isUri(kt)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[gt]=kt,bt=!0,gt}else return}),bt?JSON.stringify(It):ze}function Le(ze){const Ze=new r.MarkdownString(ze.value,ze.supportThemeIcons);return Ze.isTrusted=ze.isTrusted,Ze.supportHtml=ze.supportHtml,Ze.baseUri=ze.baseUri?b.URI.from(ze.baseUri):void 0,Ze}ye.to=Le;function Xe(ze){if(!!ze)return typeof ze=="string"?ze:ye.from(ze)}ye.fromStrict=Xe})(R=e.MarkdownString||(e.MarkdownString={}));function P(ye){return x(ye)?ye.map(Pe=>({range:h.from(Pe.range),hoverMessage:Array.isArray(Pe.hoverMessage)?R.fromMany(Pe.hoverMessage):Pe.hoverMessage?R.from(Pe.hoverMessage):void 0,renderOptions:Pe.renderOptions})):ye.map(Pe=>({range:h.from(Pe)}))}e.fromRangeOrRangeWithMessage=P;function F(ye){return typeof ye>"u"?ye:typeof ye=="string"?b.URI.file(ye):ye}e.pathOrURIToURI=F;var B;(function(ye){function Pe(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?F(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}ye.from=Pe})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var z;(function(ye){function Pe(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?F(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?B.from(fe.before):void 0,after:fe.after?B.from(fe.after):void 0}}ye.from=Pe})(z=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var V;(function(ye){function Pe(fe){if(typeof fe>"u")return fe;switch(fe){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}ye.from=Pe})(V=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var K;(function(ye){function Pe(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?V.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?z.from(fe.light):void 0,dark:fe.dark?z.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?F(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?B.from(fe.before):void 0,after:fe.after?B.from(fe.after):void 0}}ye.from=Pe})(K=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var ie;(function(ye){function Pe(G){return{text:G.newText,eol:G.newEol&&it.from(G.newEol),range:h.from(G.range)}}ye.from=Pe;function fe(G){const Ae=new r.TextEdit(h.to(G.range),G.text);return Ae.newEol=typeof G.eol>"u"?void 0:it.to(G.eol),Ae}ye.to=fe})(ie=e.TextEdit||(e.TextEdit={}));var ge;(function(ye){function Pe(G,Ae){const Le={edits:[]};if(G instanceof r.WorkspaceEdit){const Xe=new A.ResourceSet;for(const ze of G._allEntries())ze._type===1&&b.URI.isUri(ze.to)&&ze.from===void 0&&Xe.add(ze.to);for(const ze of G._allEntries())ze._type===1?Le.edits.push({oldResource:ze.from,newResource:ze.to,options:{...ze.options,contentsBase64:ze.options?.contents&&(0,T.encodeBase64)(T.VSBuffer.wrap(ze.options.contents))},metadata:ze.metadata}):ze._type===2?Le.edits.push({resource:ze.uri,textEdit:ie.from(ze.edit),versionId:Xe.has(ze.uri)?void 0:Ae?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===6?Le.edits.push({resource:ze.uri,textEdit:{range:h.from(ze.range),text:ze.edit.value,insertAsSnippet:!0},versionId:Xe.has(ze.uri)?void 0:Ae?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===3?Le.edits.push({metadata:ze.metadata,resource:ze.uri,cellEdit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(ze.uri)}):ze._type===5&&Le.edits.push({metadata:ze.metadata,resource:ze.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(ze.uri),cellEdit:{editType:1,index:ze.index,count:ze.count,cells:ze.cells.map(vt.from)}})}return Le}ye.from=Pe;function fe(G){const Ae=new r.WorkspaceEdit;for(const Le of G.edits)Le.textEdit?Ae.replace(b.URI.revive(Le.resource),h.to(Le.textEdit.range),Le.textEdit.text):Ae.renameFile(b.URI.revive(Le.oldResource),b.URI.revive(Le.newResource),Le.options);return Ae}ye.to=fe})(ge=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ue;(function(ye){const Pe=Object.create(null);Pe[r.SymbolKind.File]=0,Pe[r.SymbolKind.Module]=1,Pe[r.SymbolKind.Namespace]=2,Pe[r.SymbolKind.Package]=3,Pe[r.SymbolKind.Class]=4,Pe[r.SymbolKind.Method]=5,Pe[r.SymbolKind.Property]=6,Pe[r.SymbolKind.Field]=7,Pe[r.SymbolKind.Constructor]=8,Pe[r.SymbolKind.Enum]=9,Pe[r.SymbolKind.Interface]=10,Pe[r.SymbolKind.Function]=11,Pe[r.SymbolKind.Variable]=12,Pe[r.SymbolKind.Constant]=13,Pe[r.SymbolKind.String]=14,Pe[r.SymbolKind.Number]=15,Pe[r.SymbolKind.Boolean]=16,Pe[r.SymbolKind.Array]=17,Pe[r.SymbolKind.Object]=18,Pe[r.SymbolKind.Key]=19,Pe[r.SymbolKind.Null]=20,Pe[r.SymbolKind.EnumMember]=21,Pe[r.SymbolKind.Struct]=22,Pe[r.SymbolKind.Event]=23,Pe[r.SymbolKind.Operator]=24,Pe[r.SymbolKind.TypeParameter]=25;function fe(Ae){return typeof Pe[Ae]=="number"?Pe[Ae]:6}ye.from=fe;function G(Ae){for(const Le in Pe)if(Pe[Le]===Ae)return Number(Le);return r.SymbolKind.Property}ye.to=G})(ue=e.SymbolKind||(e.SymbolKind={}));var re;(function(ye){function Pe(G){switch(G){case r.SymbolTag.Deprecated:return 1}}ye.from=Pe;function fe(G){switch(G){case 1:return r.SymbolTag.Deprecated}}ye.to=fe})(re=e.SymbolTag||(e.SymbolTag={}));var se;(function(ye){function Pe(G){return{name:G.name,kind:ue.from(G.kind),tags:G.tags&&G.tags.map(re.from),containerName:G.containerName,location:Me.from(G.location)}}ye.from=Pe;function fe(G){const Ae=new r.SymbolInformation(G.name,ue.to(G.kind),G.containerName,Me.to(G.location));return Ae.tags=G.tags&&G.tags.map(re.to),Ae}ye.to=fe})(se=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var le;(function(ye){function Pe(G){const Ae={name:G.name||"!!MISSING: name!!",detail:G.detail,range:h.from(G.range),selectionRange:h.from(G.selectionRange),kind:ue.from(G.kind),tags:G.tags?.map(re.from)??[]};return G.children&&(Ae.children=G.children.map(Pe)),Ae}ye.from=Pe;function fe(G){const Ae=new r.DocumentSymbol(G.name,G.detail,ue.to(G.kind),h.to(G.range),h.to(G.selectionRange));return(0,i.isNonEmptyArray)(G.tags)&&(Ae.tags=G.tags.map(re.to)),G.children&&(Ae.children=G.children.map(fe)),Ae}ye.to=fe})(le=e.DocumentSymbol||(e.DocumentSymbol={}));var _;(function(ye){function Pe(G){const Ae=new r.CallHierarchyItem(ue.to(G.kind),G.name,G.detail||"",b.URI.revive(G.uri),h.to(G.range),h.to(G.selectionRange));return Ae._sessionId=G._sessionId,Ae._itemId=G._itemId,Ae}ye.to=Pe;function fe(G,Ae,Le){if(Ae=Ae??G._sessionId,Le=Le??G._itemId,Ae===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Le,name:G.name,detail:G.detail,kind:ue.from(G.kind),uri:G.uri,range:h.from(G.range),selectionRange:h.from(G.selectionRange),tags:G.tags?.map(re.from)}}ye.from=fe})(_=e.CallHierarchyItem||(e.CallHierarchyItem={}));var me;(function(ye){function Pe(fe){return new r.CallHierarchyIncomingCall(_.to(fe.from),fe.fromRanges.map(G=>h.to(G)))}ye.to=Pe})(me=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var we;(function(ye){function Pe(fe){return new r.CallHierarchyOutgoingCall(_.to(fe.to),fe.fromRanges.map(G=>h.to(G)))}ye.to=Pe})(we=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Me;(function(ye){function Pe(G){return{range:G.range&&h.from(G.range),uri:G.uri}}ye.from=Pe;function fe(G){return new r.Location(b.URI.revive(G.uri),h.to(G.range))}ye.to=fe})(Me=e.location||(e.location={}));var We;(function(ye){function Pe(G){const Ae=G,Le=G;return{originSelectionRange:Ae.originSelectionRange?h.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Le.uri,range:h.from(Ae.targetRange?Ae.targetRange:Le.range),targetSelectionRange:Ae.targetSelectionRange?h.from(Ae.targetSelectionRange):void 0}}ye.from=Pe;function fe(G){return{targetUri:b.URI.revive(G.uri),targetRange:h.to(G.range),targetSelectionRange:G.targetSelectionRange?h.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?h.to(G.originSelectionRange):void 0}}ye.to=fe})(We=e.DefinitionLink||(e.DefinitionLink={}));var Qe;(function(ye){function Pe(G){return{range:h.from(G.range),contents:R.fromMany(G.contents)}}ye.from=Pe;function fe(G){return new r.Hover(G.contents.map(R.to),h.to(G.range))}ye.to=fe})(Qe=e.Hover||(e.Hover={}));var Te;(function(ye){function Pe(G){return{range:h.from(G.range),expression:G.expression}}ye.from=Pe;function fe(G){return new r.EvaluatableExpression(h.to(G.range),G.expression)}ye.to=fe})(Te=e.EvaluatableExpression||(e.EvaluatableExpression={}));var De;(function(ye){function Pe(G){if(G instanceof r.InlineValueText)return{type:"text",range:h.from(G.range),text:G.text};if(G instanceof r.InlineValueVariableLookup)return{type:"variable",range:h.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof r.InlineValueEvaluatableExpression)return{type:"expression",range:h.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Pe;function fe(G){switch(G.type){case"text":return{range:h.to(G.range),text:G.text};case"variable":return{range:h.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:h.to(G.range),expression:G.expression}}}ye.to=fe})(De=e.InlineValue||(e.InlineValue={}));var ke;(function(ye){function Pe(G){return{frameId:G.frameId,stoppedLocation:h.from(G.stoppedLocation)}}ye.from=Pe;function fe(G){return new r.InlineValueContext(G.frameId,h.to(G.stoppedLocation))}ye.to=fe})(ke=e.InlineValueContext||(e.InlineValueContext={}));var oe;(function(ye){function Pe(G){return{range:h.from(G.range),kind:G.kind}}ye.from=Pe;function fe(G){return new r.DocumentHighlight(h.to(G.range),G.kind)}ye.to=fe})(oe=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(ye){function Pe(fe){switch(fe){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}ye.to=Pe})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Y;(function(ye){function Pe(fe){return{triggerKind:ce.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}ye.to=Pe})(Y=e.CompletionContext||(e.CompletionContext={}));var I;(function(ye){function Pe(G){switch(G){case r.CompletionItemTag.Deprecated:return 1}}ye.from=Pe;function fe(G){switch(G){case 1:return r.CompletionItemTag.Deprecated}}ye.to=fe})(I=e.CompletionItemTag||(e.CompletionItemTag={}));var $;(function(ye){const Pe=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function fe(Le){return Pe.get(Le)??9}ye.from=fe;const G=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Ae(Le){return G.get(Le)??r.CompletionItemKind.Property}ye.to=Ae})($=e.CompletionItemKind||(e.CompletionItemKind={}));var H;(function(ye){function Pe(fe,G){const Ae=new r.CompletionItem(fe.label);return Ae.insertText=fe.insertText,Ae.kind=$.to(fe.kind),Ae.tags=fe.tags?.map(I.to),Ae.detail=fe.detail,Ae.documentation=C.isMarkdownString(fe.documentation)?R.to(fe.documentation):fe.documentation,Ae.sortText=fe.sortText,Ae.filterText=fe.filterText,Ae.preselect=fe.preselect,Ae.commitCharacters=fe.commitCharacters,f.Range.isIRange(fe.range)?Ae.range=h.to(fe.range):typeof fe.range=="object"&&(Ae.range={inserting:h.to(fe.range.insert),replacing:h.to(fe.range.replace)}),Ae.keepWhitespace=typeof fe.insertTextRules>"u"?!1:Boolean(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Ae.insertText=new r.SnippetString(fe.insertText):(Ae.insertText=fe.insertText,Ae.textEdit=Ae.range instanceof r.Range?new r.TextEdit(Ae.range,Ae.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Ae.additionalTextEdits=fe.additionalTextEdits.map(Le=>ie.to(Le))),Ae.command=G&&fe.command?G.fromInternal(fe.command):void 0,Ae}ye.to=Pe})(H=e.CompletionItem||(e.CompletionItem={}));var j;(function(ye){function Pe(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:R.fromStrict(G.documentation)}}ye.from=Pe;function fe(G){return{label:G.label,documentation:C.isMarkdownString(G.documentation)?R.to(G.documentation):G.documentation}}ye.to=fe})(j=e.ParameterInformation||(e.ParameterInformation={}));var Z;(function(ye){function Pe(G){return{label:G.label,documentation:R.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(j.from):[],activeParameter:G.activeParameter}}ye.from=Pe;function fe(G){return{label:G.label,documentation:C.isMarkdownString(G.documentation)?R.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(j.to):[],activeParameter:G.activeParameter}}ye.to=fe})(Z=e.SignatureInformation||(e.SignatureInformation={}));var de;(function(ye){function Pe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(Z.from):[]}}ye.from=Pe;function fe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(Z.to):[]}}ye.to=fe})(de=e.SignatureHelp||(e.SignatureHelp={}));var Se;(function(ye){function Pe(fe,G){const Ae=new r.InlayHint(l.to(G.position),typeof G.label=="string"?G.label:G.label.map(ae.to.bind(void 0,fe)),G.kind&&ve.to(G.kind));return Ae.textEdits=G.textEdits&&G.textEdits.map(ie.to),Ae.tooltip=C.isMarkdownString(G.tooltip)?R.to(G.tooltip):G.tooltip,Ae.paddingLeft=G.paddingLeft,Ae.paddingRight=G.paddingRight,Ae}ye.to=Pe})(Se=e.InlayHint||(e.InlayHint={}));var ae;(function(ye){function Pe(fe,G){const Ae=new r.InlayHintLabelPart(G.label);return Ae.tooltip=C.isMarkdownString(G.tooltip)?R.to(G.tooltip):G.tooltip,t.Command.is(G.command)&&(Ae.command=fe.fromInternal(G.command)),G.location&&(Ae.location=Me.to(G.location)),Ae}ye.to=Pe})(ae=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ve;(function(ye){function Pe(G){return G}ye.from=Pe;function fe(G){return G}ye.to=fe})(ve=e.InlayHintKind||(e.InlayHintKind={}));var be;(function(ye){function Pe(G){return{range:h.from(G.range),url:G.target,tooltip:G.tooltip}}ye.from=Pe;function fe(G){let Ae;if(G.url)try{Ae=typeof G.url=="string"?b.URI.parse(G.url,!0):b.URI.revive(G.url)}catch{}return new r.DocumentLink(h.to(G.range),Ae)}ye.to=fe})(be=e.DocumentLink||(e.DocumentLink={}));var $e;(function(ye){function Pe(G){const Ae=new r.ColorPresentation(G.label);return G.textEdit&&(Ae.textEdit=ie.to(G.textEdit)),G.additionalTextEdits&&(Ae.additionalTextEdits=G.additionalTextEdits.map(Le=>ie.to(Le))),Ae}ye.to=Pe;function fe(G){return{label:G.label,textEdit:G.textEdit?ie.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Ae=>ie.from(Ae)):void 0}}ye.from=fe})($e=e.ColorPresentation||(e.ColorPresentation={}));var He;(function(ye){function Pe(G){return new r.Color(G[0],G[1],G[2],G[3])}ye.to=Pe;function fe(G){return[G.red,G.green,G.blue,G.alpha]}ye.from=fe})(He=e.Color||(e.Color={}));var tt;(function(ye){function Pe(G){return{range:h.from(G.range)}}ye.from=Pe;function fe(G){return new r.SelectionRange(h.to(G.range))}ye.to=fe})(tt=e.SelectionRange||(e.SelectionRange={}));var xe;(function(ye){function Pe(fe){switch(fe){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}ye.to=Pe})(xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var et;(function(ye){function Pe(G){switch(G){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}ye.from=Pe;function fe(G){switch(G){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}ye.to=fe})(et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var it;(function(ye){function Pe(G){if(G===r.EndOfLine.CRLF)return 1;if(G===r.EndOfLine.LF)return 0}ye.from=Pe;function fe(G){if(G===1)return r.EndOfLine.CRLF;if(G===0)return r.EndOfLine.LF}ye.to=fe})(it=e.EndOfLine||(e.EndOfLine={}));var dt;(function(ye){function Pe(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ye.from=Pe})(dt=e.ProgressLocation||(e.ProgressLocation={}));var Fe;(function(ye){function Pe(fe){const G={start:fe.start+1,end:fe.end+1};return fe.kind&&(G.kind=st.from(fe.kind)),G}ye.from=Pe})(Fe=e.FoldingRange||(e.FoldingRange={}));var st;(function(ye){function Pe(fe){if(fe)switch(fe){case r.FoldingRangeKind.Comment:return t.FoldingRangeKind.Comment;case r.FoldingRangeKind.Imports:return t.FoldingRangeKind.Imports;case r.FoldingRangeKind.Region:return t.FoldingRangeKind.Region}}ye.from=Pe})(st=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Q;(function(ye){function Pe(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?h.from(fe.selection):void 0,override:typeof fe.override=="boolean"?p.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}ye.from=Pe})(Q=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var X;(function(ye){function Pe(Le){return Le instanceof r.RelativePattern?Le.toJSON():typeof Le=="string"?Le:fe(Le)||G(Le)?new r.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}ye.from=Pe;function fe(Le){const Xe=Le;return Xe?b.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function G(Le){const Xe=Le;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Ae(Le){return typeof Le=="string"?Le:new r.RelativePattern(b.URI.revive(Le.baseUri),Le.pattern)}ye.to=Ae})(X=e.GlobPattern||(e.GlobPattern={}));var pe;(function(ye){function Pe(fe){if(fe){if(Array.isArray(fe))return fe.map(Pe);if(typeof fe=="string")return fe;{const G=fe;return{language:G.language,scheme:G.scheme,pattern:X.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}ye.from=Pe})(pe=e.LanguageSelector||(e.LanguageSelector={}));var Ne;(function(ye){function Pe(G){return{start:G.start,end:G.end}}ye.from=Pe;function fe(G){return new r.NotebookRange(G.start,G.end)}ye.to=fe})(Ne=e.NotebookRange||(e.NotebookRange={}));var Be;(function(ye){function Pe(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}ye.to=Pe;function fe(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}ye.from=fe})(Be=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var je;(function(ye){function Pe(fe){if(fe===E.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(fe===E.NotebookCellExecutionState.Pending)return;if(fe===E.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}ye.to=Pe})(je=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Je;(function(ye){function Pe(G){switch(G){case r.NotebookCellKind.Markup:return E.CellKind.Markup;case r.NotebookCellKind.Code:default:return E.CellKind.Code}}ye.from=Pe;function fe(G){switch(G){case E.CellKind.Markup:return r.NotebookCellKind.Markup;case E.CellKind.Code:default:return r.NotebookCellKind.Code}}ye.to=fe})(Je=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(ye){function Pe(G){const Ae={metadata:G.metadata??Object.create(null),cells:[]};for(const Le of G.cells)r.NotebookCellData.validate(Le),Ae.cells.push(vt.from(Le));return Ae}ye.from=Pe;function fe(G){const Ae=new r.NotebookData(G.cells.map(vt.to));return(0,m.isEmptyObject)(G.metadata)||(Ae.metadata=G.metadata),Ae}ye.to=fe})(nt=e.NotebookData||(e.NotebookData={}));var vt;(function(ye){function Pe(G){return{cellKind:Je.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:Be.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Tt.from):[]}}ye.from=Pe;function fe(G){return new r.NotebookCellData(Je.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Tt.to):void 0,G.metadata,G.internalMetadata?Be.to(G.internalMetadata):void 0)}ye.to=fe})(vt=e.NotebookCellData||(e.NotebookCellData={}));var wt;(function(ye){function Pe(G){return{mime:G.mime,valueBytes:T.VSBuffer.wrap(G.data)}}ye.from=Pe;function fe(G){return new r.NotebookCellOutputItem(G.valueBytes.buffer,G.mime)}ye.to=fe})(wt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Tt;(function(ye){function Pe(G){return{outputId:G.id,items:G.items.map(wt.from),metadata:G.metadata}}ye.from=Pe;function fe(G){const Ae=G.items.map(wt.to);return new r.NotebookCellOutput(Ae,G.outputId,G.metadata)}ye.to=fe})(Tt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var lt;(function(ye){function Pe(Ae){return G(Ae)?{include:(0,m.withNullAsUndefined)(X.from(Ae.include)),exclude:(0,m.withNullAsUndefined)(X.from(Ae.exclude))}:(0,m.withNullAsUndefined)(X.from(Ae))}ye.from=Pe;function fe(Ae){return G(Ae)?{include:X.to(Ae.include),exclude:X.to(Ae.exclude)}:X.to(Ae)}ye.to=fe;function G(Ae){const Le=Ae;return Le?!(0,m.isUndefinedOrNull)(Le.include)&&!(0,m.isUndefinedOrNull)(Le.exclude):!1}})(lt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var at;(function(ye){function Pe(fe,G,Ae){const Le=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Le,Ae),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}ye.from=Pe})(at=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ut;(function(ye){function Pe(fe,G,Ae){const Le=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:G.toInternal(Le,Ae),label:fe.label,description:fe.description,detail:fe.detail}}ye.from=Pe})(Ut=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Ft;(function(ye){function Pe(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}ye.from=Pe})(Ft=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Mt;(function(ye){function Pe(G){return{uri:G.uri,provides:G.provides}}ye.from=Pe;function fe(G){return new r.NotebookRendererScript(b.URI.revive(G.uri),G.provides)}ye.to=fe})(Mt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(ye){function Pe(G){return{message:R.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,location:G.location&&{range:h.from(G.location.range),uri:G.location.uri}}}ye.from=Pe;function fe(G){const Ae=new r.TestMessage(typeof G.message=="string"?G.message:R.to(G.message));return Ae.actualOutput=G.actual,Ae.expectedOutput=G.expected,Ae.location=G.location?Me.to(G.location):void 0,Ae}ye.to=fe})(ft=e.TestMessage||(e.TestMessage={}));var Ct;(function(ye){ye.namespace=w.namespaceTestTag,ye.denamespace=w.denamespaceTestTag})(Ct=e.TestTag||(e.TestTag={}));var Bt;(function(ye){function Pe(G){const Ae=(0,u.getPrivateApiFor)(G).controllerId;return{extId:v.TestId.fromExtHostTestItem(G,Ae).toString(),label:G.label,uri:b.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Le=>Ct.namespace(Ae,Le.id)),range:f.Range.lift(h.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&R.fromStrict(G.error)||null}}ye.from=Pe;function fe(G){return{parent:void 0,error:void 0,id:v.TestId.fromString(G.extId).localId,label:G.label,uri:b.URI.revive(G.uri),tags:(G.tags||[]).map(Ae=>{const{tagId:Le}=Ct.denamespace(Ae);return new r.TestTag(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:h.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}ye.toPlain=fe})(Bt=e.TestItem||(e.TestItem={})),function(ye){function Pe(G){return{id:G.id}}ye.from=Pe;function fe(G){return new r.TestTag(G.id)}ye.to=fe}(Ct=e.TestTag||(e.TestTag={}));var Nt;(function(ye){const Pe=(G,Ae)=>{const Le=[];for(const[ze,Ze]of Ae)v.TestId.compare(Ze.item.extId,ze)===2&&(Ae.delete(ze),Le.push(Ze));const Xe={...Bt.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(ze=>({state:ze.state,duration:ze.duration,messages:ze.messages.filter(Ze=>Ze.type===0).map(ft.to)})),children:Le.map(ze=>Pe(ze,Ae))};for(const ze of Xe.children)ze.parent=Xe;return Xe};function fe(G){const Ae=[],Le=new Map;for(const Xe of G.items){Le.set(Xe.item.extId,Xe);const ze=v.TestId.root(Xe.item.extId);G.request.targets.some(Ze=>Ze.controllerId===ze&&Ze.testIds.includes(Xe.item.extId))&&Ae.push(Xe)}return{completedAt:G.completedAt,results:Ae.map(Xe=>Pe(Xe,Le))}}ye.to=fe})(Nt=e.TestResults||(e.TestResults={}));var Ge;(function(ye){function Pe(Le){return{covered:Le.covered,total:Le.covered}}function fe(Le){return"line"in Le?l.from(Le):h.from(Le)}function G(Le){return"branches"in Le?{count:Le.executionCount,location:fe(Le.location),type:1,branches:Le.branches.length?Le.branches.map(Xe=>({count:Xe.executionCount,location:Xe.location&&fe(Xe.location)})):void 0}:{type:0,count:Le.executionCount,location:fe(Le.location)}}ye.fromDetailed=G;function Ae(Le){return{uri:Le.uri,statement:Pe(Le.statementCoverage),branch:Le.branchCoverage&&Pe(Le.branchCoverage),function:Le.functionCoverage&&Pe(Le.functionCoverage),details:Le.detailedCoverage?.map(G)}}ye.fromFile=Ae})(Ge=e.TestCoverage||(e.TestCoverage={}));var Rt;(function(ye){function Pe(fe){switch(fe){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}ye.to=Pe})(Rt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Lt;(function(ye){function Pe(G){const Ae=new r.TypeHierarchyItem(ue.to(G.kind),G.name,G.detail||"",b.URI.revive(G.uri),h.to(G.range),h.to(G.selectionRange));return Ae._sessionId=G._sessionId,Ae._itemId=G._itemId,Ae}ye.to=Pe;function fe(G,Ae,Le){if(Ae=Ae??G._sessionId,Le=Le??G._itemId,Ae===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Le,kind:ue.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:h.from(G.range),selectionRange:h.from(G.selectionRange),tags:G.tags?.map(re.from)}}ye.from=fe})(Lt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ht;(function(ye){function Pe(fe){if(!!fe)return{value:fe.value,tooltip:fe.tooltip}}ye.from=Pe})(Ht=e.ViewBadge||(e.ViewBadge={}));var mt;(function(ye){function Pe(Le,Xe,ze){const Ze=Xe.fileData;return Ze?new class extends r.DataTransferItem{asFile(){return{name:Ze.name,uri:b.URI.revive(Ze.uri),data:(0,L.once)(()=>ze())}}}("",Xe.id):Le===M.Mimes.uriList&&Xe.uriListData?new r.DataTransferItem(Ae(Xe.uriListData)):new r.DataTransferItem(Xe.asString)}ye.to=Pe;async function fe(Le,Xe){const ze=await Xe.asString();if(Le===M.Mimes.uriList)return{id:Xe.id,asString:"",fileData:void 0,uriListData:G(ze)};const Ze=Xe.asFile();return{id:Xe.id,asString:ze,fileData:Ze?{name:Ze.name,uri:Ze.uri}:void 0}}ye.from=fe;function G(Le){return y.UriList.split(Le).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return b.URI.parse(Xe)}catch{}return Xe})}function Ae(Le){return y.UriList.create(Le.map(Xe=>typeof Xe=="string"?Xe:b.URI.revive(Xe)))}})(mt=e.DataTransferItem||(e.DataTransferItem={}));var At;(function(ye){function Pe(G,Ae){const Le=G.items.map(([Xe,ze])=>[Xe,mt.to(Xe,ze,()=>Ae(ze.id))]);return new r.DataTransfer(Le)}ye.toDataTransfer=Pe;async function fe(G){const Ae={items:[]},Le=[];return G.forEach((Xe,ze)=>{Le.push((async()=>{Ae.items.push([ze,await mt.from(ze,Xe)])})())}),await Promise.all(Le),Ae}ye.toDataTransferDTO=fe})(At=e.DataTransfer||(e.DataTransfer={}))}),define(Ie[186],Ce([1,0,2,11,6,8,154]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(k,M,D,m={timeout:1500,errors:3}){this.c=k,this.d=M,this.f=D,this.g=m,this.a=new C.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(M,D,m)=>{const f={dispose:this.a.push([M,D,k])};return Array.isArray(m)&&m.push(f),f}}async $participateInSave(k,M){const D=i.URI.revive(k);let m=!1;const b=setTimeout(()=>m=!0,this.g.timeout),f=[];try{for(const t of[...this.a]){if(m)break;const c=this.d.getDocument(D),u=await this.h(t,{document:c,reason:L.TextDocumentSaveReason.to(M)});f.push(u)}}finally{clearTimeout(b)}return f}h([k,M,D],m){const b=this.b.get(k);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(D,k,M,m).then(()=>!0,f=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const t=this.b.get(k);this.b.set(k,t?t+1:1),typeof t=="number"&&t>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,M,D,m){const b=[],f=Date.now(),{document:t,reason:c}=m,{version:u}=t,p=Object.freeze({document:t,reason:c,waitUntil(E){if(Object.isFrozen(b))throw(0,T.illegalState)("waitUntil can not be called async");b.push(Promise.resolve(E))}});try{M.apply(D,[p])}catch(E){return Promise.reject(E)}return Object.freeze(b),new Promise((E,v)=>{const w=setTimeout(()=>v(new Error("timeout")),this.g.timeout);return Promise.all(b).then(s=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(w),E(s)}).catch(s=>{clearTimeout(w),v(s)})}).then(E=>{const v={edits:[]};for(const w of E)if(Array.isArray(w)&&w.every(s=>s instanceof y.TextEdit))for(const{newText:s,newEol:r,range:o}of w)v.edits.push({resource:t.uri,versionId:void 0,textEdit:{range:o&&L.Range.from(o),text:s,eol:r&&L.EndOfLine.from(r)}});if(v.edits.length!==0)return u===t.version?this.f.$tryApplyWorkspaceEdit(v):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(Ie[187],Ce([1,0,13,2,8,6,66]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(D,m,b,f){this.start=D,this.deletedCount=m,this.deletedItems=b,this.items=f}asApiEvent(){return{range:new L.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(D,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,m,b){this.notebook=D,this.h=m,this.j=b,this.handle=b.handle,this.uri=T.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(y.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(y.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:y.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return D.g},set mime(f){D.g=f},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(b)}return this.f}setOutputs(D){this.a=D.map(y.NotebookCellOutput.to)}setOutputItems(D,m,b){const f=b.map(y.NotebookCellOutputItem.to),t=this.a.find(c=>c.id===D);if(t&&(m||(t.items.length=0),t.items.push(...f),t.items.length>1&&t.items.every(c=>C.isTextStreamMime(c.mime)))){const c=new Map,u=[];t.items.forEach(p=>{let E;c.has(p.mime)?E=c.get(p.mime):(E=[],c.set(p.mime,E),u.push(p.mime)),E.push(p.data)}),t.items.length=0,u.forEach(p=>{const E=C.compressOutputItemStreams(c.get(p));t.items.push({mime:p,data:E.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(y.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.ExtHostCell=S;class k{constructor(D,m,b,f,t){this.k=D,this.l=m,this.m=b,this.uri=f,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=t.viewType,this.f=Object.freeze(t.metadata??Object.create(null)),this.r([[0,0,t.cells]],!0,void 0),this.g=t.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const D=this,m={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===i.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(b){return b=D.n(b),D.b[b].apiCell},getCells(b){return(b?D.p(b):D.b).map(t=>t.apiCell)},save(){return D.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,m,b){this.g=D.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:b});const f={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},t=[];for(const u of D.rawEvents)u.kind===C.NotebookCellsChangeType.ModelChange?this.r(u.changes,!1,f.contentChanges):u.kind===C.NotebookCellsChangeType.Move?this.s(u.index,u.length,u.newIdx,f.contentChanges):u.kind===C.NotebookCellsChangeType.Output?(this.t(u.index,u.outputs),t.push({cell:this.b[u.index].apiCell,outputs:this.b[u.index].apiCell.outputs})):u.kind===C.NotebookCellsChangeType.OutputItem?(this.u(u.index,u.outputId,u.append,u.outputItems),t.push({cell:this.b[u.index].apiCell,outputs:this.b[u.index].apiCell.outputs})):u.kind===C.NotebookCellsChangeType.ChangeCellLanguage?(this.v(u.index,u.language),t.push({cell:this.b[u.index].apiCell,document:this.b[u.index].apiCell.document})):u.kind===C.NotebookCellsChangeType.ChangeCellContent?t.push({cell:this.b[u.index].apiCell,document:this.b[u.index].apiCell.document}):u.kind===C.NotebookCellsChangeType.ChangeCellMime?this.w(u.index,u.mime):u.kind===C.NotebookCellsChangeType.ChangeCellMetadata?(this.x(u.index,u.metadata),t.push({cell:this.b[u.index].apiCell,metadata:this.b[u.index].apiCell.metadata})):u.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(u.index,u.internalMetadata),t.push({cell:this.b[u.index].apiCell,executionSummary:this.b[u.index].apiCell.executionSummary}));const c=new Map;for(let u=0;u<t.length;u++){const p=t[u],E=c.get(p.cell);if(E===void 0){const v=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...p});c.set(p.cell,v-1)}else f.cellChanges[E]={...f.cellChanges[E],...p}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let m=D.start|0,b=D.end|0;return m<0&&(m=0),b>this.b.length&&(b=this.b.length),D.with({start:m,end:b})}p(D){D=this.o(D);const m=[];for(let b=D.start;b<D.end;b++)m.push(this.b[b]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,m,b){if(this.j)return;const f=[],t=[],c=[];if(D.reverse().forEach(u=>{const E=u[2].map(s=>{const r=new S(this,this.l,s);return m||t.push(S.asModelAddData(this.apiNotebook,s)),r}),v=new A(u[0],u[1],[],E),w=this.b.splice(u[0],u[1],...E);for(const s of w)c.push(s.uri),v.deletedItems.push(s.apiCell);f.push(v)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:t,removedDocuments:c}),b)for(const u of f)b.push(u.asApiEvent())}s(D,m,b,f){const t=this.b.splice(D,m);this.b.splice(b,0,...t);const c=[new A(D,m,t.map(u=>u.apiCell),[]),new A(b,0,[],t)];for(const u of c)f.push(u.asApiEvent())}t(D,m){this.b[D].setOutputs(m)}u(D,m,b,f){this.b[D].setOutputItems(m,b,f)}v(D,m){const b=this.b[D];b.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(b.uri,m)}w(D,m){const b=this.b[D];b.apiCell.mime=m}x(D,m){this.b[D].setMetadata(m)}y(D,m){this.b[D].setInternalMetadata(m)}getCellFromApiCell(D){return this.b.find(m=>m.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(m=>m.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.ExtHostNotebookDocument=k,k.a=0}),define(Ie[97],Ce([1,0,11,8,6]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class L{constructor(A,S,k,M,D,m){this.id=A,this.f=S,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=M,this.c=m}get apiEditor(){if(!this.e){const A=this;this.e={get notebook(){return A.notebookData.apiNotebook},get selection(){return A.a[0]},set selection(S){this.selections=[S]},get selections(){return A.a},set selections(S){if(!Array.isArray(S)||!S.every(y.NotebookRange.isNotebookRange))throw(0,i.illegalArgument)("selections");A.a=S,A.g(S)},get visibleRanges(){return A.b},revealRange(S,k){A.f.$tryRevealRange(A.id,T.NotebookRange.from(S),k??y.NotebookEditorRevealType.Default)},get viewColumn(){return A.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(A){this.d=A}_acceptVisibleRanges(A){this.b=A}_acceptSelections(A){this.a=A}g(A){this.f.$trySetSelections(this.id,A.map(T.NotebookRange.from))}_acceptViewColumn(A){this.c=A}}e.ExtHostNotebookEditor=L,L.apiEditorsToExtHost=new WeakMap}),define(Ie[188],Ce([1,0,5,12,8]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let L=class{constructor(A,S){this.c=A,this.d=S,this.a=new i.Emitter,this.b=new i.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(A,S){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,S);const k=this.d.getEditorById(A);S.visibleRanges&&k._acceptVisibleRanges(S.visibleRanges.ranges.map(y.NotebookRange.to)),S.selections&&k._acceptSelections(S.selections.selections.map(y.NotebookRange.to)),S.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),S.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const S in A)this.d.getEditorById(S)._acceptViewColumn(y.ViewColumn.to(A[S]))}};L=qe([Ve(0,T.ILogService)],L),e.ExtHostNotebookEditors=L}),define(Ie[189],Ce([1,0,8,157,136,20,60,11]),function(ee,e,i,T,y,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(m){this.b=0,this.c=new Map,this.a=m}async withProgress(m,b,f){const t=this.b++,{title:c,location:u,cancellable:p}=b,E={label:(0,y.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this.a.$startProgress(t,{location:i.ProgressLocation.from(u),title:c,source:E,cancellable:p},m.isUnderDevelopment?void 0:m.identifier.value).catch(A.onUnexpectedExternalError),this.d(t,f,!!p)}d(m,b,f){let t;f&&(t=new L.CancellationTokenSource,this.c.set(m,t));const c=p=>{this.a.$progressEnd(p),this.c.delete(p),t?.dispose()};let u;try{u=b(new M(this.a,m),f&&t?t.token:L.CancellationToken.None)}catch(p){throw c(m),p}return u.then(p=>c(m),p=>c(m)),u}$acceptProgressCanceled(m){const b=this.c.get(m);b&&(b.cancel(),this.c.delete(m))}}e.ExtHostProgress=S;function k(D,m){return D.message=m.message,typeof m.increment=="number"&&(typeof D.increment=="number"?D.increment+=m.increment:D.increment=m.increment),D}class M extends T.Progress{constructor(m,b){super(f=>this.throttledReport(f)),this.c=m,this.d=b}throttledReport(m){this.c.$progressReport(this.d,m)}}qe([(0,C.throttle)(100,(D,m)=>k(D,m),()=>Object.create(null))],M.prototype,"throttledReport",null)}),define(Ie[98],Ce([1,0,54,93,42,67,53,8,2]),function(ee,e,i,T,y,L,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const k=(E,v,w,s)=>{let r=v;return{enumerable:!0,configurable:!1,get(){return r},set(o){if(!w(r,o)){const h=r;r=o,E.listener?.(s(o,h))}}}},M=(E,v)=>E===v,D={range:(E,v)=>E===v?!0:!E||!v?!1:E.isEqual(v),label:M,description:M,sortText:M,busy:M,error:M,canResolveChildren:M,tags:(E,v)=>!(E.length!==v.length||E.some(w=>!v.find(s=>w.id===s.id)))},m=E=>v=>({op:4,update:E(v)}),b=(E,v)=>({range:(()=>{let w;const s=m(r=>({range:i.Range.lift(A.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return w},set(r){E.listener?.({op:6}),D.range(w,r)||(w=r,E.listener?.(s(r)))}}})(),label:k(E,v,D.label,m(w=>({label:w}))),description:k(E,void 0,D.description,m(w=>({description:w}))),sortText:k(E,void 0,D.sortText,m(w=>({sortText:w}))),canResolveChildren:k(E,!1,D.canResolveChildren,w=>({op:2,state:w})),busy:k(E,!1,D.busy,m(w=>({busy:w}))),error:k(E,void 0,D.error,m(w=>({error:A.MarkdownString.fromStrict(w)||null}))),tags:k(E,[],D.tags,(w,s)=>({op:1,new:w.map(A.TestTag.from),old:s.map(A.TestTag.from)}))}),f=E=>{const v=y.TestId.fromString(E.extId),w=new c(v.controllerId,v.localId,E.label,S.URI.revive(E.uri)||void 0);return w.range=A.Range.to(E.range||void 0),w.description=E.description||void 0,w.sortText=E.sortText||void 0,w.tags=E.tags.map(s=>A.TestTag.to({id:(0,C.denamespaceTestTag)(s).tagId})),w},t=E=>{let v;for(const w of E.tests){const s=f(w.item);(0,T.getPrivateApiFor)(s).parent=v,v=s}return v};e.toItemFromContext=t;class c{constructor(v,w,s,r){if(w.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(w)} symbol`);const o=(0,T.createPrivateApiFor)(this,v);Object.defineProperties(this,{id:{value:w,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof u?void 0:o.parent}},children:{value:(0,L.createTestItemChildren)(o,T.getPrivateApiFor,c),enumerable:!0,writable:!1},...b(o,s)})}}e.TestItemImpl=c;class u extends c{constructor(v,w){super(v,v,w,void 0),this._isRoot=!0}}e.TestItemRootImpl=u;class p extends L.TestItemCollection{constructor(v,w,s){super({controllerId:v,getDocumentVersion:r=>r&&s.getDocument(r)?.version,getApiFor:T.getPrivateApiFor,getChildren:r=>r.children,root:new u(v,w),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=p}),define(Ie[99],Ce([1,0,47,11,79,8,6]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class A{constructor(m,b,f){const t=A.c.nextId();m.$registerTextEditorDecorationType(b.identifier,t,L.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:t,dispose(){m.$removeTextEditorDecorationType(t)}})}}e.TextEditorDecorationType=A,A.c=new y.IdGenerator("TextEditorDecorationType");class S{constructor(m,b){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,b){this.k();let f=null;if(m instanceof C.Position)f=new C.Range(m,m);else if(m instanceof C.Range)f=m;else throw new Error("Unrecognized location");this.l(f,b,!1)}insert(m,b){this.k(),this.l(new C.Range(m,m),b,!0)}delete(m){this.k();let b=null;if(m instanceof C.Range)b=m;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(m,b,f){const t=this.c.validateRange(m);this.g.push({range:t,text:b,forceMoveMarkers:f})}setEndOfLine(m){if(this.k(),m!==C.EndOfLine.LF&&m!==C.EndOfLine.CRLF)throw(0,T.illegalArgument)("endOfLine");this.h=m}}class k{constructor(m,b,f,t){this.c=m,this.d=b,this._accept(f),this.e=t;const c=this;this.value={get tabSize(){return c.f},set tabSize(u){c.m(u)},get indentSize(){return c.g},set indentSize(u){c.o(u)},get insertSpaces(){return c.h},set insertSpaces(u){c.q(u)},get cursorStyle(){return c.j},set cursorStyle(u){c.s(u)},get lineNumbers(){return c.k},set lineNumbers(u){c.t(u)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.insertSpaces,this.j=m.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(m.lineNumbers)}l(m){if(m==="auto")return"auto";if(typeof m=="number"){const b=Math.floor(m);return b>0?b:null}if(typeof m=="string"){const b=parseInt(m,10);return isNaN(b)?null:b>0?b:null}return null}m(m){const b=this.l(m);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}n(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const b=Math.floor(m);return b>0?b:null}if(typeof m=="string"){const b=parseInt(m,10);return isNaN(b)?null:b>0?b:null}return null}o(m){const b=this.n(m);if(b!==null){if(typeof b=="number"){if(this.g===b)return;this.g=b}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}p(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}q(m){const b=this.p(m);if(typeof b=="boolean"){if(this.h===b)return;this.h=b}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}s(m){this.j!==m&&(this.j=m,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}t(m){this.k!==m&&(this.k=m,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(m)})))}assign(m){const b={};let f=!1;if(typeof m.tabSize<"u"){const t=this.l(m.tabSize);t==="auto"?(f=!0,b.tabSize=t):typeof t=="number"&&this.f!==t&&(this.f=t,f=!0,b.tabSize=t)}if(typeof m.indentSize<"u"){const t=this.n(m.indentSize);t==="tabSize"?(f=!0,b.indentSize=t):typeof t=="number"&&this.g!==t&&(this.g=t,f=!0,b.indentSize=t)}if(typeof m.insertSpaces<"u"){const t=this.p(m.insertSpaces);t==="auto"?(f=!0,b.insertSpaces=t):this.h!==t&&(this.h=t,f=!0,b.insertSpaces=t)}typeof m.cursorStyle<"u"&&this.j!==m.cursorStyle&&(this.j=m.cursorStyle,f=!0,b.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.k!==m.lineNumbers&&(this.k=m.lineNumbers,f=!0,b.lineNumbers=L.TextEditorLineNumbersStyle.from(m.lineNumbers)),f&&this.u("setOptions",this.c.$trySetOptions(this.d,b))}u(m,b){b.catch(f=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(f)})}}e.ExtHostTextEditorOptions=k;class M{constructor(m,b,f,t,c,u,p,E){this.id=m,this.j=b,this.k=f,this.g=!1,this.h=new Set,this.c=c,this.d=new k(this.j,this.id,u,f),this.e=p,this.f=E;const v=this;this.value=Object.freeze({get document(){return t.getValue()},set document(w){throw(0,T.readonly)("document")},get selection(){return v.c&&v.c[0]},set selection(w){if(!(w instanceof C.Selection))throw(0,T.illegalArgument)("selection");v.c=[w],v.l()},get selections(){return v.c},set selections(w){if(!Array.isArray(w)||w.some(s=>!(s instanceof C.Selection)))throw(0,T.illegalArgument)("selections");v.c=w,v.l()},get visibleRanges(){return v.e},set visibleRanges(w){throw(0,T.readonly)("visibleRanges")},get options(){return v.d.value},set options(w){v.g||v.d.assign(w)},get viewColumn(){return v.f},set viewColumn(w){throw(0,T.readonly)("viewColumn")},edit(w,s={undoStopBefore:!0,undoStopAfter:!0}){if(v.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new S(t.getValue(),s);return w(r),v.m(r)},insertSnippet(w,s,r={undoStopBefore:!0,undoStopAfter:!0}){if(v.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!s||Array.isArray(s)&&s.length===0)o=v.c.map(h=>L.Range.from(h));else if(s instanceof C.Position){const{lineNumber:h,column:a}=L.Position.from(s);o=[{startLineNumber:h,startColumn:a,endLineNumber:h,endColumn:a}]}else if(s instanceof C.Range)o=[L.Range.from(s)];else{o=[];for(const h of s)if(h instanceof C.Range)o.push(L.Range.from(h));else{const{lineNumber:a,column:l}=L.Position.from(h);o.push({startLineNumber:a,startColumn:l,endLineNumber:a,endColumn:l})}}return b.$tryInsertSnippet(m,t.getValue().version,w.value,o,r)},setDecorations(w,s){const r=s.length===0;r&&!v.h.has(w.key)||(r?v.h.delete(w.key):v.h.add(w.key),v.n(()=>{if(L.isDecorationOptionsArr(s))return b.$trySetDecorations(m,w.key,L.fromRangeOrRangeWithMessage(s));{const o=new Array(4*s.length);for(let h=0,a=s.length;h<a;h++){const l=s[h];o[4*h]=l.start.line+1,o[4*h+1]=l.start.character+1,o[4*h+2]=l.end.line+1,o[4*h+3]=l.end.character+1}return b.$trySetDecorationsFast(m,w.key,o)}}))},revealRange(w,s){v.n(()=>b.$tryRevealRange(m,L.Range.from(w),s||C.TextEditorRevealType.Default))},show(w){b.$tryShowEditor(m,L.ViewColumn.from(w))},hide(){b.$tryHideEditor(m)}})}dispose(){(0,i.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,i.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,i.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,i.ok)(!this.g),this.f=m}_acceptSelections(m){(0,i.ok)(!this.g),this.c=m}async l(){const m=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const b=m.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const f=b.edits.map(c=>c.range);f.sort((c,u)=>c.end.line===u.end.line?c.end.character===u.end.character?c.start.line===u.start.line?c.start.character-u.start.character:c.start.line-u.start.line:c.end.character-u.end.character:c.end.line-u.end.line);for(let c=0,u=f.length-1;c<u;c++){const p=f[c].end;if(f[c+1].start.isBefore(p))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const t=b.edits.map(c=>({range:L.Range.from(c.range),text:c.text,forceMoveMarkers:c.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,t,{setEndOfLine:typeof b.setEndOfLine=="number"?L.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.ExtHostTextEditor=M}),define(Ie[190],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ie[191],Ce([1,0,147,11,29,85,88,30,26,190,156,149]),function(ee,e,i,T,y,L,C,A,S,k,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const m=A.Registry.as(C.Extensions.JSONContribution);class b{constructor(w,s,r){this.a=w,this.b=s,this.c=r}d(w,s){this.a({type:w,message:s,extensionId:this.b.identifier,extensionPointId:this.c})}error(w){this.d(y.default.Error,w)}warn(w){this.d(y.default.Warning,w)}info(w){this.d(y.default.Info,w)}}e.ExtensionMessageCollector=b;class f{static a(w){const s=new Set;for(let r=0,o=w.length;r<o;r++)s.add(S.ExtensionIdentifier.toKey(w[r].description.identifier));return s}static compute(w,s){if(!w||!w.length)return new f(s,[]);if(!s||!s.length)return new f([],w);const r=this.a(w),o=this.a(s),h=s.filter(l=>!r.has(S.ExtensionIdentifier.toKey(l.description.identifier))),a=w.filter(l=>!o.has(S.ExtensionIdentifier.toKey(l.description.identifier)));return new f(h,a)}constructor(w,s){this.added=w,this.removed=s}}e.ExtensionPointUserDelta=f;class t{constructor(w,s){this.name=w,this.defaultExtensionKind=s,this.a=null,this.b=null,this.c=null}setHandler(w){if(this.a!==null)throw new Error("Handler already set!");this.a=w,this.d()}acceptUsers(w){this.c=f.compute(this.b,w),this.b=w,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(w){(0,T.onUnexpectedError)(w)}}}e.ExtensionPoint=t;const c={type:"string",enum:["ui","workspace"],enumDescriptions:[i.localize(0,null),i.localize(1,null)]},u="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:i.localize(2,null),properties:{vscode:{type:"string",description:i.localize(3,null),default:"^1.22.0"}}},publisher:{description:i.localize(4,null),type:"string"},displayName:{description:i.localize(5,null),type:"string"},categories:{description:i.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:i.localize(7,null)}]}},galleryBanner:{type:"object",description:i.localize(8,null),properties:{color:{description:i.localize(9,null),type:"string"},theme:{description:i.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:i.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:i.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:i.localize(13,null)},enabledApiProposals:{markdownDescription:i.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:i.localize(15,null),type:"string",enum:["none"],enumDescriptions:[i.localize(16,null)]},activationEvents:{description:i.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:i.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:i.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:i.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:i.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:i.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:i.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:i.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:i.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:i.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:i.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:i.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:i.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:i.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:i.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:i.localize(32,null)},{label:"onUri",body:"onUri",description:i.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:i.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:i.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:i.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:i.localize(37,null)},{label:"onRenderer",description:i.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:i.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:i.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:i.localize(41,null)},{label:"*",description:i.localize(42,null),body:"*"}]}},badges:{type:"array",description:i.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:i.localize(44,null)},href:{type:"string",description:i.localize(45,null)},description:{type:"string",description:i.localize(46,null)}}}},markdown:{type:"string",description:i.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:i.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:i.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:i.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:i.localize(51,null),type:"array",items:c,default:["workspace"],defaultSnippets:[{body:["ui"],description:i.localize(52,null)},{body:["workspace"],description:i.localize(53,null)},{body:["ui","workspace"],description:i.localize(54,null)},{body:["workspace","ui"],description:i.localize(55,null)},{body:[],description:i.localize(56,null)}]},capabilities:{description:i.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:i.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:i.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(60,null),i.localize(61,null),i.localize(62,null)]},description:{type:"string",markdownDescription:i.localize(63,null)}}},untrustedWorkspaces:{description:i.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:i.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(66,null),i.localize(67,null),i.localize(68,null)]},restrictedConfigurations:{description:i.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:i.localize(70,null)}}}}},sponsor:{description:i.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:i.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:i.localize(73,null),type:"string"},"vscode:uninstall":{description:i.localize(74,null),type:"string"}}},icon:{type:"string",description:i.localize(75,null)},l10n:{type:"string",description:i.localize(76,null)}}};class p{constructor(){this.a=new Map}registerExtensionPoint(w){if(this.a.has(w.extensionPoint))throw new Error("Duplicate extension point: "+w.extensionPoint);const s=new t(w.extensionPoint,w.defaultExtensionKind);return this.a.set(w.extensionPoint,s),w.activationEventsGenerator&&D.ImplicitActivationEvents.register(w.extensionPoint,w.activationEventsGenerator),e.schema.properties.contributes.properties[w.extensionPoint]=w.jsonSchema,m.registerSchema(u,e.schema),s}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=p;const E={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(E.ExtensionsRegistry,new p),e.ExtensionsRegistry=A.Registry.as(E.ExtensionsRegistry),m.registerSchema(u,e.schema),m.registerSchema(M.productSchemaId,{properties:{extensionEnabledApiProposals:{description:i.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Ie[192],Ce([1,0,144,9,23,191,41,5]),function(ee,e,i,T,y,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:i.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:i.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:i.localize(2,null),default:""}}};var k;(function(m){function b(f,t,c){if(!f)return;const u=T.isString(f.type)?f.type:void 0;if(!u||u.length===0){c.error(i.localize(3,null));return}const p=[];if(Array.isArray(f.required))for(const E of f.required)T.isString(E)&&p.push(E);return{extensionId:t.value,taskType:u,required:p,properties:f.properties?y.deepClone(f.properties):{},when:f.when?C.ContextKeyExpr.deserialize(f.when):void 0}}m.from=b})(k||(k={}));const M=L.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:i.localize(4,null),type:"array",items:S}});class D{constructor(){this.d=new A.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,f)=>{M.setHandler((t,c)=>{this.c=void 0;try{for(const u of c.removed){const p=u.value;for(const E of p)this.a&&E.type&&this.a[E.type]&&delete this.a[E.type]}for(const u of c.added){const p=u.value;for(const E of p){const v=k.from(E,u.description.identifier,u.collector);v&&(this.a[v.taskType]=v)}}(c.removed.length>0||c.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const f of this.all()){const t={type:"object",additionalProperties:!1};f.required.length>0&&(t.required=f.required.slice(0)),f.properties!==void 0?t.properties=y.deepClone(f.properties):t.properties=Object.create(null),t.properties.type={type:"string",enum:[f.taskType]},b.push(t)}this.c={oneOf:b}}return this.c}}e.TaskDefinitionRegistry=new D}),define(Ie[193],Ce([1,0,145,9,22,23,41,192]),function(ee,e,i,T,y,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new C.RawContextKey("taskRunning",!1,i.localize(0,null)),e.TASKS_CATEGORY={value:i.localize(1,null),original:"Tasks"};var S;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(S=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function B(z){if(!z)return F.Strong;switch(z.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=B}(S=e.ShellQuoting||(e.ShellQuoting={}));var k;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(k=e.CommandOptions||(e.CommandOptions={}));var M;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(M=e.RevealKind||(e.RevealKind={})),function(F){function B(z){switch(z.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=B}(M=e.RevealKind||(e.RevealKind={}));var D;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(D=e.RevealProblemKind||(e.RevealProblemKind={})),function(F){function B(z){switch(z.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=B}(D=e.RevealProblemKind||(e.RevealProblemKind={}));var m;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(m=e.PanelKind||(e.PanelKind={})),function(F){function B(z){switch(z.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=B}(m=e.PanelKind||(e.PanelKind={}));var b;(function(F){F.defaults={echo:!0,reveal:M.Always,revealProblems:D.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(b=e.PresentationOptions||(e.PresentationOptions={}));var f;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(f=e.RuntimeType||(e.RuntimeType={})),function(F){function B(V){switch(V.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=B;function z(V){switch(V){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=z}(f=e.RuntimeType||(e.RuntimeType={}));var t;(function(F){function B(z){return T.isString(z)?z:z.value}F.value=B})(t=e.CommandString||(e.CommandString={}));var c;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function B(V){return V===F.Clean._id||V===F.Build._id||V===F.Rebuild._id||V===F.Test._id}F.is=B;function z(V){if(V!==void 0)return T.isString(V)?B(V)?{_id:V,isDefault:!1}:void 0:V}F.from=z})(c=e.TaskGroup||(e.TaskGroup={}));var u;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(u=e.TaskScope||(e.TaskScope={}));var p;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function B(z){switch(z){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=B})(p=e.TaskSourceKind||(e.TaskSourceKind={}));var E;(function(F){F.parallel="parallel",F.sequence="sequence"})(E=e.DependsOrder||(e.DependsOrder={}));var v;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(v=e.RunOnOptions||(e.RunOnOptions={}));var w;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:v.default,instanceLimit:1}})(w=e.RunOptions||(e.RunOptions={}));class s{constructor(B,z,V,K,ie,ge){this._label="",this._id=B,z&&(this._label=z),V&&(this.type=V),this.runOptions=K,this.configurationProperties=ie,this._source=ge}getDefinition(B){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const B={folder:this.d(),id:this._id};return JSON.stringify(B)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(B,z=!1){if(B===void 0)return!1;if(T.isString(B))return B===this._label||B===this.configurationProperties.identifier||z&&B===this._id;const V=this.getDefinition(!0);return V!==void 0&&V._key===B._key}getQualifiedLabel(){const B=this.getWorkspaceFolder();return B?`${this._label} (${B.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(B){this.c===void 0&&(this.c=[]),B&&(this.c=this.c.concat(B))}get taskLoadMessages(){return this.c}}e.CommonTask=s;class r extends s{constructor(B,z,V,K,ie,ge,ue,re){super(B,V,void 0,ue,re,z),this.command={},this._source=z,this.hasDefinedMatchers=ge,ie&&(this.command=ie)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(B=!1){if(B&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case f.Shell:z="shell";break;case f.Process:z="process";break;case f.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is(B){return B instanceof r}getMapKey(){const B=this._source.config.workspaceFolder;return B?`${B.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const B=this.d();if(!B)return;let z=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(z+=this._source.kind);const V={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:z};return JSON.stringify(V)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(B){return new r(B._id,B._source,B._label,B.type,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.CustomTask=r;class o extends s{constructor(B,z,V,K,ie,ge,ue){super(B,V,K,ge,ue,z),this._source=z,this.configures=ie}static is(B){return B instanceof o}f(B){return B}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?y.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const B=this.d();if(!B)return;let z=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(z+=this._source.kind);const V={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:z};return JSON.stringify(V)}}e.ConfiguringTask=o;class h extends s{constructor(B,z,V,K,ie,ge,ue,re,se){super(B,V,K,re,se,z),this.defines=ie,this.hasDefinedMatchers=ue,this.command=ge,this.icon=se.icon,this.hide=se.hide}clone(){return new h(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(B){return B instanceof h}getMapKey(){const B=this._source.workspaceFolder;return B?`${this._source.scope.toString()}|${B.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const B={type:"contributed",scope:this._source.scope,id:this._id};return B.folder=this.d(),JSON.stringify(B)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(B){return new h(B._id,B._source,B._label,B.type,B.defines,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.ContributedTask=h;class a extends s{constructor(B,z,V,K,ie,ge){super(B,V,K,ie,ge,z),this._source=z}clone(){return new a(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(B){return B instanceof a}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(B){return new a(B._id,B._source,B._label,B.type,B.runOptions,B.configurationProperties)}}e.InMemoryTask=a;var l;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(l=e.ExecutionEngine||(e.ExecutionEngine={})),function(F){F._default=F.Terminal}(l=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class d{constructor(B){this.c=new Map;for(let z=0;z<B.length;z++)this.c.set(B[z].uri.toString(),z)}compare(B,z){const V=B.getWorkspaceFolder(),K=z.getWorkspaceFolder();if(V&&K){let ie=this.c.get(V.uri.toString());ie=ie===void 0?0:ie+1;let ge=this.c.get(K.uri.toString());return ge=ge===void 0?0:ge+1,ie===ge?B._label.localeCompare(z._label):ie-ge}else return!V&&K?-1:V&&!K?1:0}}e.TaskSorter=d;var g;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(g=e.TaskEventKind||(e.TaskEventKind={}));var O;(function(F){F.SingleRun="singleRun",F.Background="background"})(O=e.TaskRunType||(e.TaskRunType={}));var N;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(N=e.TaskRunSource||(e.TaskRunSource={}));var q;(function(F){function B(z,V,K,ie){if(V){const ge={kind:z,taskId:V._id,taskName:V.configurationProperties.name,runType:V.configurationProperties.isBackground?"background":"singleRun",group:V.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:K,__task:V};return z==="start"?ge.resolvedVariables=ie:z==="processStarted"?ge.processId=ie:z==="processEnded"&&(ge.exitCode=ie),Object.freeze(ge)}else return Object.freeze({kind:"changed"})}F.create=B})(q=e.TaskEvent||(e.TaskEvent={}));var J;(function(F){function B(V){const K=Object.keys(V).sort();let ie="";for(const ge of K){let ue=V[ge];ue instanceof Object?ue=B(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),ie+=ge+","+ue+","}return ie}function z(V){const ie={_key:B(V),type:V.taskType};return Object.assign(ie,V),ie}F.create=z})(J=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var x;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection"})(x=e.TaskSettingId||(e.TaskSettingId={}));var R;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(R=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var P;(function(F){function B(z,V){const K=A.TaskDefinitionRegistry.get(z.type);if(K===void 0){const re=L.deepClone(z);return delete re._key,J.create(re)}const ie=Object.create(null);ie.type=K.taskType;const ge=new Set;K.required.forEach(re=>ge.add(re));const ue=K.properties;for(const re of Object.keys(ue)){const se=z[re];if(se!=null)ie[re]=se;else if(ge.has(re)){const le=ue[re];if(le.default!==void 0)ie[re]=L.deepClone(le.default);else switch(le.type){case"boolean":ie[re]=!1;break;case"number":case"integer":ie[re]=0;break;case"string":ie[re]="";break;default:V.error(i.localize(2,null,JSON.stringify(z,void 0,0),re));return}}}return J.create(ie)}F.createTaskIdentifier=B})(P=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ie[194],Ce([1,0,11]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((C,A)=>{this.b=C,this.d=A,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(C){this.f||this.h||(this.f=!0,this.g=C,this.a&&this.b(C))}resolveErr(C){this.f||this.h||(this.h=!0,this.i=C,this.a?this.d(C):(0,i.onUnexpectedError)(C))}then(C,A){return this.j().then(C,A)}catch(C){return this.j().then(void 0,C)}finally(C){return this.j().finally(C)}}e.LazyPromise=T;class y extends T{constructor(){super(),this.h=!0,this.i=new i.CancellationError}}e.CanceledLazyPromise=y}),define(Ie[43],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class i{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++i.count}}e.ProxyIdentifier=i,i.count=0;const T=[];function y(A){const S=new i(A);return T[S.nid]=S,S}e.createProxyIdentifier=y;function L(A){return T[A].sid}e.getStringIdentifierForProxy=L;class C{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=C}),define(Ie[4],Ce([1,0,43]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(t){t[t.Default=0]="Default",t[t.InCenter=1]="InCenter",t[t.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",t[t.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var y;(function(t){t[t.UnknownInput=0]="UnknownInput",t[t.TextInput=1]="TextInput",t[t.TextDiffInput=2]="TextDiffInput",t[t.TextMergeInput=3]="TextMergeInput",t[t.NotebookInput=4]="NotebookInput",t[t.NotebookDiffInput=5]="NotebookDiffInput",t[t.CustomEditorInput=6]="CustomEditorInput",t[t.WebviewEditorInput=7]="WebviewEditorInput",t[t.TerminalEditorInput=8]="TerminalEditorInput",t[t.InteractiveEditorInput=9]="InteractiveEditorInput"})(y=e.TabInputKind||(e.TabInputKind={}));var L;(function(t){t[t.TAB_OPEN=0]="TAB_OPEN",t[t.TAB_CLOSE=1]="TAB_CLOSE",t[t.TAB_UPDATE=2]="TAB_UPDATE",t[t.TAB_MOVE=3]="TAB_MOVE"})(L=e.TabModelOperationKind||(e.TabModelOperationKind={}));var C;(function(t){t[t.Editable=0]="Editable",t[t.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(t){t[t.Int8Array=1]="Int8Array",t[t.Uint8Array=2]="Uint8Array",t[t.Uint8ClampedArray=3]="Uint8ClampedArray",t[t.Int16Array=4]="Int16Array",t[t.Uint16Array=5]="Uint16Array",t[t.Int32Array=6]="Int32Array",t[t.Uint32Array=7]="Uint32Array",t[t.Float32Array=8]="Float32Array",t[t.Float64Array=9]="Float64Array",t[t.BigInt64Array=10]="BigInt64Array",t[t.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var S;(function(t){t[t.Text=1]="Text",t[t.Error=2]="Error",t[t.Rich=3]="Rich"})(S=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(t){t[t.Default=0]="Default",t[t.InCenter=1]="InCenter",t[t.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",t[t.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var M;(function(t){t[t.None=0]="None",t[t.Process=1]="Process",t[t.Output=2]="Output"})(M=e.CandidatePortSource||(e.CandidatePortSource={}));class D{static mixin(c){return c._id=D.a++,c}}e.IdObject=D,D.a=0;var m;(function(t){t.label="a",t.kind="b",t.detail="c",t.documentation="d",t.sortText="e",t.filterText="f",t.preselect="g",t.insertText="h",t.insertTextRules="i",t.range="j",t.commitCharacters="k",t.additionalTextEdits="l",t.kindModifier="m",t.commandIdent="n",t.commandId="o",t.commandArguments="p"})(m=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var b;(function(t){t.defaultRanges="a",t.completions="b",t.isIncomplete="c",t.duration="d"})(b=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var f;(function(t){t[t.Workspace=0]="Workspace",t[t.TextDocument=1]="TextDocument"})(f=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,i.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,i.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,i.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,i.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,i.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,i.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,i.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,i.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,i.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,i.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,i.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,i.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,i.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,i.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,i.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,i.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,i.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,i.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,i.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,i.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,i.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,i.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,i.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,i.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,i.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,i.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,i.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,i.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,i.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,i.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,i.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,i.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,i.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,i.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,i.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,i.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,i.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,i.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,i.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,i.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,i.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,i.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,i.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,i.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,i.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,i.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,i.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,i.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,i.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,i.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,i.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,i.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,i.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,i.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,i.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,i.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,i.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,i.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,i.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,i.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,i.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,i.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,i.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,i.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,i.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,i.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,i.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,i.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,i.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,i.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,i.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,i.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,i.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,i.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,i.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,i.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,i.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,i.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,i.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,i.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,i.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,i.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,i.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,i.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,i.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,i.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,i.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,i.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,i.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,i.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,i.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,i.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,i.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,i.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,i.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,i.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,i.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,i.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,i.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,i.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,i.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,i.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,i.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,i.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,i.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,i.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,i.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,i.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,i.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,i.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,i.createProxyIdentifier)("ExtHostLocalization")}}),define(Ie[72],Ce([1,0,3,12,4,15]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,i.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(S,k){this.c=k,this.a=new Set,this.b=S.getProxy(y.MainContext.MainThreadTelemetry)}report(S,k,M){const D=this.d(S,k);this.a.has(D)||(this.a.add(D),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${M}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:S}))}d(S,k){return`${S}-${k.identifier.value}`}};C=qe([Ve(0,L.IExtHostRpcService),Ve(1,T.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(A,S,k){}})}),define(Ie[195],Ce([1,0,5,4,6,26]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(S){this.b=new Map,this.c=[],this.d=new i.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=S.getProxy(T.MainContext.MainThreadAuthentication)}$setProviders(S){return this.c=S,Promise.resolve()}async getSession(S,k,M,D={}){const m=L.ExtensionIdentifier.toKey(S.identifier),b=this.f.get(m)||[],f=[...M].sort().join(" ");let t=b.find(c=>c.providerId===k&&c.scopes===f);if(t)return t.result;{const c=this.g(S,m,k,M,D);t={providerId:k,scopes:f,result:c},b.push(t),this.f.set(m,b);try{await c}finally{const u=b.findIndex(p=>p.providerId===k&&p.scopes===f);u>-1&&(b.splice(u),this.f.set(m,b))}return c}}async g(S,k,M,D,m={}){await this.a.$ensureProvider(M);const b=S.displayName||S.name;return this.a.$getSession(M,D,k,b,m)}async removeSession(S,k){const M=this.b.get(S);return M?M.provider.removeSession(k):this.a.$removeSession(S,k)}registerAuthenticationProvider(S,k,M,D){if(this.b.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this.b.set(S,{label:k,provider:M,options:D??{supportsMultipleAccounts:!1}}),this.c.find(b=>b.id===S)||this.c.push({id:S,label:k});const m=M.onDidChangeSessions(b=>{this.a.$sendDidChangeSessions(S,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this.a.$registerAuthenticationProvider(S,k,D?.supportsMultipleAccounts??!1),new y.Disposable(()=>{m.dispose(),this.b.delete(S);const b=this.c.findIndex(f=>f.id===S);b>-1&&this.c.splice(b),this.a.$unregisterAuthenticationProvider(S)})}$createSession(S,k){const M=this.b.get(S);if(M)return Promise.resolve(M.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,k){const M=this.b.get(S);if(M)return Promise.resolve(M.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,k){const M=this.b.get(S);if(M)return Promise.resolve(M.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,k){return this.d.fire({provider:{id:S,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(Ie[196],Ce([1,0,4,15,8]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let L=class{constructor(A,S){this.a=A.getProxy(i.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>S.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,S,k){const M=y.WorkspaceEdit.from(A,this.b);return this.a.$tryApplyWorkspaceEdit(M,void 0,k?.isRefactoring??!1)}};L=qe([Ve(0,T.IExtHostRpcService)],L),e.ExtHostBulkEdits=L}),define(Ie[197],Ce([1,0,4]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class T{constructor(L){const C=L.getProxy(i.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(A){return C.$writeText(A)}})}}e.ExtHostClipboard=T});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[38],Ce([1,0,9,6,8,23,4,16,12,80,54,250,2,7,3,15,98,24,43,45,100]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m,b,f,t,c,u,p,E,v){"use strict";var w,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{constructor(d,g){w.set(this,void 0),this.b=new Map,this.c=new Map,s.set(this,void 0),Ye(this,w,d.getProxy(C.MainContext.MainThreadCommands),"f"),this.d=g,Ye(this,s,d.getProxy(C.MainContext.MainThreadTelemetry),"f"),this.converter=new o(this,O=>{const N=this.c.get(O);return N?.result===a.Void?N:void 0},g),this.f=[{processArgument(O){return(0,k.revive)(O)}},{processArgument(O){return(0,L.cloneAndChange)(O,function(N){if(M.Range.isIRange(N))return y.Range.to(N);if(D.Position.isIPosition(N))return y.Position.to(N);if(M.Range.isIRange(N.range)&&m.URI.isUri(N.uri))return y.location.to(N);if(N instanceof u.VSBuffer)return N.buffer.buffer;if(!Array.isArray(N))return N})}}]}registerArgumentProcessor(d){this.f.push(d)}registerApiCommand(d){const g=this.registerCommand(!1,d.id,async(...O)=>{const N=d.args.map((J,x)=>{if(!J.validate(O[x]))throw new Error(`Invalid argument '${J.name}' when running '${d.id}', received: ${O[x]}`);return J.convert(O[x])}),q=await this.executeCommand(d.internalId,...N);return d.result.convert(q,O,this.converter)},void 0,{description:d.description,args:d.args,returns:d.result.description});return this.c.set(d.id,d),new T.Disposable(()=>{g.dispose(),this.c.delete(d.id)})}registerCommand(d,g,O,N,q,J){if(this.d.trace("ExtHostCommands#registerCommand",g),!g.trim().length)throw new Error("invalid id");if(this.b.has(g))throw new Error(`command '${g}' already exists`);return this.b.set(g,{callback:O,thisArg:N,description:q,extension:J}),d&&Re(this,w,"f").$registerCommand(g),new T.Disposable(()=>{this.b.delete(g)&&d&&Re(this,w,"f").$unregisterCommand(g)})}executeCommand(d,...g){return this.d.trace("ExtHostCommands#executeCommand",d),this.g(d,g,!0)}async g(d,g,O){if(this.b.has(d))return Re(this,w,"f").$fireCommandActivationEvent(d),this.h(d,g,!1);{let N=!1;const q=(0,L.cloneAndChange)(g,function(J){if(J instanceof T.Position)return y.Position.from(J);if(J instanceof T.Range)return y.Range.from(J);if(J instanceof T.Location)return y.location.from(J);if(T.NotebookRange.isNotebookRange(J))return y.NotebookRange.from(J);if(J instanceof ArrayBuffer)return N=!0,u.VSBuffer.wrap(new Uint8Array(J));if(J instanceof Uint8Array)return N=!0,u.VSBuffer.wrap(J);if(J instanceof u.VSBuffer)return N=!0,J;if(!Array.isArray(J))return J});try{const J=await Re(this,w,"f").$executeCommand(d,N?new p.SerializableObjectWithBuffers(q):q,O);return(0,k.revive)(J)}catch(J){if(J instanceof Error&&J.message==="$executeCommand:retry")return this.g(d,g,!1);throw J}}}async h(d,g,O){const N=this.b.get(d);if(!N)throw new Error("Unknown command");const{callback:q,thisArg:J,description:x}=N;if(x)for(let P=0;P<x.args.length;P++)try{(0,i.validateConstraint)(g[P],x.args[P].constraint)}catch{throw new Error(`Running the contributed command: '${d}' failed. Illegal argument '${x.args[P].name}' - ${x.args[P].description}`)}const R=v.StopWatch.create();try{return await q.apply(J,g)}catch(P){if(d===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...g);F&&(d=F.command)}throw this.d.error(P,d,N.extension?.identifier),O?new class extends Error{constructor(){super((0,E.toErrorMessage)(P)),this.id=d,this.source=N.extension?.displayName??N.extension?.name}}:P}finally{this.j(N,d,R.elapsed())}}j(d,g,O){!d.extension||d.extension.isBuiltin||Re(this,s,"f").$publicLog2("Extension:ActionExecuted",{extensionId:d.extension.identifier.value,id:g,duration:O})}$executeContributedCommand(d,...g){return this.d.trace("ExtHostCommands#$executeContributedCommand",d),this.b.has(d)?(g=g.map(O=>this.f.reduce((N,q)=>q.processArgument(N),O)),this.h(d,g,!0)):Promise.reject(new Error(`Contributed command '${d}' does not exist.`))}getCommands(d=!1){return this.d.trace("ExtHostCommands#getCommands",d),Re(this,w,"f").$getCommands().then(g=>(d&&(g=g.filter(O=>O[0]!=="_")),g))}$getContributedCommandHandlerDescriptions(){const d=Object.create(null);for(const[g,O]of this.b){const{description:N}=O;N&&(d[g]=N)}return Promise.resolve(d)}};w=new WeakMap,s=new WeakMap,r=qe([Ve(0,t.IExtHostRpcService),Ve(1,S.ILogService)],r),e.ExtHostCommands=r,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class o{constructor(d,g,O){this.d=d,this.f=g,this.g=O,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(d,g){if(!d)return;const O={$ident:void 0,id:d.command,title:d.title,tooltip:d.tooltip};if(!d.command)return O;const N=this.f(d.command);if(N)O.id=N.internalId,O.arguments=N.args.map((q,J)=>q.convert(d.arguments&&d.arguments[J]));else if((0,A.isNonEmptyArray)(d.arguments)){const q=`${d.command}/${++this.c}`;this.b.set(q,d),g.add((0,b.toDisposable)(()=>{this.b.delete(q),this.g.trace("CommandsConverter#DISPOSE",q)})),O.$ident=q,O.id=this.delegatingCommandId,O.arguments=[q],this.g.trace("CommandsConverter#CREATE",d.command,q)}return O}fromInternal(d){return typeof d.$ident=="string"?this.b.get(d.$ident):{command:d.id,title:d.title,arguments:d.arguments}}getActualCommand(...d){return this.b.get(d[0])}h(...d){const g=this.getActualCommand(...d);return this.g.trace("CommandsConverter#EXECUTE",d[0],g?g.command:"MISSING"),g?this.d.executeCommand(g.command,...g.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${d[0]}`)}}e.CommandsConverter=o;class h{constructor(d,g,O,N){this.name=d,this.description=g,this.validate=O,this.convert=N}optional(){return new h(this.name,`(optional) ${this.description}`,d=>d==null||this.validate(d),d=>d===void 0?void 0:d===null?null:this.convert(d))}with(d,g){return new h(d??this.name,g??this.description,this.validate,this.convert)}}e.ApiCommandArgument=h,h.Uri=new h("uri","Uri of a text document",n=>m.URI.isUri(n),n=>n),h.Position=new h("position","A position in a text document",n=>T.Position.isPosition(n),y.Position.from),h.Range=new h("range","A range in a text document",n=>T.Range.isRange(n),y.Range.from),h.Selection=new h("selection","A selection in a text document",n=>T.Selection.isSelection(n),y.Selection.from),h.Number=new h("number","",n=>typeof n=="number",n=>n),h.String=new h("string","",n=>typeof n=="string",n=>n),h.CallHierarchyItem=new h("item","A call hierarchy item",n=>n instanceof T.CallHierarchyItem,y.CallHierarchyItem.from),h.TypeHierarchyItem=new h("item","A type hierarchy item",n=>n instanceof T.TypeHierarchyItem,y.TypeHierarchyItem.from),h.TestItem=new h("testItem","A VS Code TestItem",n=>n instanceof c.TestItemImpl,y.TestItem.from);class a{constructor(d,g){this.description=d,this.convert=g}}e.ApiCommandResult=a,a.Void=new a("no result",n=>n);class l{constructor(d,g,O,N,q){this.id=d,this.internalId=g,this.description=O,this.args=N,this.result=q}}e.ApiCommand=l}),define(Ie[198],Ce([1,0,2,8,6,71,38,16,83,87,13]),function(ee,e,i,T,y,L,C,A,S,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",b(T.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,c)=>{if((0,A.isFalsyOrEmpty)(t))return;class u extends y.SymbolInformation{static to(E){const v=new u(E.name,T.SymbolKind.to(E.kind),E.containerName||"",new y.Location(c[0],T.Range.to(E.range)));return v.detail=E.detail,v.range=v.location.range,v.selectionRange=T.Range.to(E.selectionRange),v.children=E.children?E.children.map(u.to):[],v}}return t.map(u.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(T.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(T.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new C.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(T.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",b(T.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",b(T.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(c=>y.Position.isPosition(c)),t=>t.map(T.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(c=>{let u;for(const p of c.reverse())u=new y.SelectionRange(T.Range.to(p),u);return u}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(T.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(T.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(T.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(T.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(!!t)return{range:T.Range.to(t.range),placeholder:t.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(!!t){if(t.rejectReason)throw new Error(t.rejectReason);return T.WorkspaceEdit.to(t)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(T.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new y.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const c=(0,S.decodeSemanticTokensDto)(t);if(c.type==="full")return new y.SemanticTokens(c.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new y.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const c=(0,S.decodeSemanticTokensDto)(t);if(c.type==="full")return new y.SemanticTokens(c.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,c,u)=>{if(!t)return new y.CompletionList([]);const p=t.suggestions.map(E=>T.CompletionItem.to(E,u));return new y.CompletionList(p,t.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return T.SignatureHelp.to(t)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,c,u)=>b(p=>new y.CodeLens(T.Range.to(p.range),p.command&&u.fromInternal(p.command)))(t))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>y.Range.isRange(t),t=>y.Selection.isSelection(t)?T.Selection.from(t):T.Range.from(t)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,c,u)=>b(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(p.command)}else{const E=new y.CodeAction(p.title,p.kind?new y.CodeActionKind(p.kind):void 0);return p.edit&&(E.edit=T.WorkspaceEdit.to(p.edit)),p.command&&(E.command=u.fromInternal(p.command)),E.isPreferred=p.isPreferred,E}})(t))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(c=>new y.ColorInformation(T.Range.to(c.range),T.Color.to(c.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",t=>t instanceof y.Color,T.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:T.Range.from(t.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(T.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,c,u)=>t.map(T.InlayHint.to.bind(void 0,u)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",b(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(c=>T.NotebookExclusiveDocumentPattern.to(c))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(T.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new C.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",t=>i.URI.isUri(t)||typeof t=="string"&&(0,k.matchesSomeScheme)(t,M.Schemas.http,M.Schemas.https),t=>t),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[T.ViewColumn.from(t),void 0]:[T.ViewColumn.from(t.viewColumn),T.TextEditorOpenOptions.from(t)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[T.ViewColumn.from(t),void 0]:[T.ViewColumn.from(t.viewColumn),T.TextEditorOpenOptions.from(t)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[T.ViewColumn.from(t.viewColumn),T.TextEditorOpenOptions.from(t)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(T.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(T.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(T.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void),new C.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[C.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],C.ApiCommandResult.Void),new C.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[C.ApiCommandArgument.String.with("name","The context key name"),new C.ApiCommandArgument("value","The context key value",()=>!0,t=>t)],C.ApiCommandResult.Void)];class m{static register(c){D.forEach(c.registerApiCommand,c)}}e.ExtHostApiCommands=m;function b(t){return c=>{if(Array.isArray(c))return c.map(t)}}function f(t){if(!Array.isArray(t))return;const c=[];for(const u of t)L.isLocationLink(u)?c.push(T.DefinitionLink.to(u)):c.push(T.location.to(u));return c}}),define(Ie[199],Ce([1,0,14,60,5,7,2,71,26,8,6,25,4]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function b(f,t,c){const u=f.getProxy(m.MainContext.MainThreadComments);class p{constructor(){this.b=new Map,this.c=new Map,t.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const n=this.b.get(l.handle);return n?n.value:l}else if(l&&l.$mid===7){const n=this.b.get(l.commentControlHandle);if(!n)return l;const d=n.getCommentThread(l.commentThreadHandle);return d?d.value:l}else if(l&&(l.$mid===9||l.$mid===8)){const n=this.b.get(l.thread.commentControlHandle);if(!n)return l;const d=n.getCommentThread(l.thread.commentThreadHandle);return d?l.$mid===8?d.value:{thread:d.value,text:l.text}:l}else if(l&&l.$mid===10){const n=this.b.get(l.thread.commentControlHandle);if(!n)return l;const d=n.getCommentThread(l.thread.commentThreadHandle);if(!d)return l;const g=l.commentUniqueId,O=d.getCommentByUniqueId(g);return O||l}else if(l&&l.$mid===11){const n=this.b.get(l.thread.commentControlHandle);if(!n)return l;const d=n.getCommentThread(l.thread.commentThreadHandle);if(!d)return l;const g=l.text,O=l.commentUniqueId,N=d.getCommentByUniqueId(O);return N?(typeof N.body=="string"?N.body=g:N.body=new M.MarkdownString(g),N):l}return l}})}createCommentController(l,n,d){const g=p.a++,O=new v(l,g,n,d);this.b.set(O.handle,O);const N=this.c.get(S.ExtensionIdentifier.toKey(l.identifier))||[];return N.push(O),this.c.set(S.ExtensionIdentifier.toKey(l.identifier),N),O.value}$createCommentThreadTemplate(l,n,d){const g=this.b.get(l);!g||g.$createCommentThreadTemplate(n,d)}async $updateCommentThreadTemplate(l,n,d){const g=this.b.get(l);!g||g.$updateCommentThreadTemplate(n,d)}$deleteCommentThread(l,n){this.b.get(l)?.$deleteCommentThread(n)}$provideCommentingRanges(l,n,d){const g=this.b.get(l);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const O=c.getDocument(C.URI.revive(n));return(0,i.asPromise)(()=>g.commentingRangeProvider.provideCommentingRanges(O,d)).then(N=>N?N.map(q=>k.Range.from(q)):void 0)}$toggleReaction(l,n,d,g,O){const N=this.b.get(l);return!N||!N.reactionHandler?Promise.resolve(void 0):(0,i.asPromise)(()=>{const q=N.getCommentThread(n);if(q){const J=q.getCommentByUniqueId(g.uniqueIdInThread);if(N!==void 0&&J&&N.reactionHandler)return N.reactionHandler(J,r(O))}return Promise.resolve(void 0)})}dispose(){}}p.a=0;class E{set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){l.isEqual(this.p)||(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return(0,D.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h}set state(l){(0,D.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h=l,this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,n,d,g,O,N,q,J){this.m=n,this.n=d,this.o=g,this.p=O,this.q=N,this.extensionDescription=q,this.r=J,this.handle=E.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new y.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.MutableDisposable,this.l.value=new L.DisposableStore,this.n===void 0&&(this.n=`${l}.${this.handle}`),u.$createCommentThread(n,this.handle,this.n,this.o,k.Range.from(this.p),q.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=N,this.i.push({dispose:()=>{u.$deleteCommentThread(n,this.handle)}});const x=this;this.value={get uri(){return x.uri},get range(){return x.range},set range(R){x.range=R},get comments(){return x.comments},set comments(R){x.comments=R},get collapsibleState(){return x.collapsibleState},set collapsibleState(R){x.collapsibleState=R},get canReply(){return x.canReply},set canReply(R){x.canReply=R},get contextValue(){return x.contextValue},set contextValue(R){x.contextValue=R},get label(){return x.label},set label(R){x.label=R},get state(){return x.state},set state(R){x.state=R},dispose:()=>{x.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.DisposableStore);const l=d=>Object.prototype.hasOwnProperty.call(this.b,d),n={};l("range")&&(n.range=k.Range.from(this.p)),l("label")&&(n.label=this.label),l("contextValue")&&(n.contextValue=this.contextValue??null),l("comments")&&(n.comments=this.q.map(d=>w(this,d,this.k))),l("collapsibleState")&&(n.collapseState=o(this.g)),l("canReply")&&(n.canReply=this.canReply),l("state")&&(n.state=h(this.h)),l("isTemplate")&&(n.isTemplate=this.r),this.b={},u.$updateCommentThread(this.m,this.handle,this.n,this.o,n)}getCommentByUniqueId(l){for(const n of this.k){const d=n[0],g=n[1];if(l===g)return d}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}E.a=0,qe([(0,T.debounce)(100)],E.prototype,"eventuallyUpdateCommentThread",null);class v{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,u.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,u.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,u.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(l,n,d,g){this.f=l,this.g=n,this.h=d,this.i=g,this.a=new Map,u.$registerCommentController(this.handle,d,g);const O=this;this.value=Object.freeze({id:O.id,label:O.label,get options(){return O.options},set options(N){O.options=N},get commentingRangeProvider(){return O.commentingRangeProvider},set commentingRangeProvider(N){O.commentingRangeProvider=N},get reactionHandler(){return O.reactionHandler},set reactionHandler(N){O.reactionHandler=N},createCommentThread(N,q,J){return O.createCommentThread(N,q,J).value},dispose:()=>{O.dispose()}}),this.e=[],this.e.push({dispose:()=>{u.$unregisterCommentController(this.handle)}})}createCommentThread(l,n,d,g){if(typeof l=="string"){const O=new E(this.id,this.handle,l,n,d,g,this.f,!1);return this.a.set(O.handle,O),O}else{const O=new E(this.id,this.handle,void 0,l,n,d,this.f,!1);return this.a.set(O.handle,O),O}}$createCommentThreadTemplate(l,n){const d=new E(this.id,this.handle,void 0,C.URI.revive(l),k.Range.to(n),[],this.f,!0);return d.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this.a.set(d.handle,d),d}$updateCommentThreadTemplate(l,n){const d=this.a.get(l);d&&(d.range=k.Range.to(n))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.e.forEach(l=>l.dispose())}}function w(a,l,n){let d=n.get(l);d||(d=++a.commentHandle,n.set(l,d));const g=l.author&&l.author.iconPath?l.author.iconPath.toString():void 0;return{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:d,body:typeof l.body=="string"?l.body:k.MarkdownString.from(l.body),userName:l.author.name,userIconPath:g,label:l.label,commentReactions:l.reactions?l.reactions.map(O=>s(O)):void 0,timestamp:l.timestamp?.toJSON()}}function s(a){return{label:a.label,iconPath:a.iconPath?k.pathOrURIToURI(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted}}function r(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?C.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1}}function o(a){if(a!==void 0)switch(a){case M.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case M.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function h(a){if(a!==void 0)switch(a){case M.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case M.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new p}e.createExtHostComments=b}),define(Ie[200],Ce([1,0,23,4,27,15]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let C=class{constructor(M,D){this.a=M.getProxy(T.MainContext.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(M,D){const m=this,b=console[M];Object.defineProperty(console,M,{set:()=>{},get:()=>function(){m.e(M,D,b,arguments)}})}e(M,D,m,b){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:S(b,this.b)}),this.c&&this.f(M,m,b)}};C=qe([Ve(0,L.IExtHostRpcService),Ve(1,y.IExtHostInitDataService)],C),e.AbstractExtHostConsoleForwarder=C;const A=1e5;function S(k,M){const D=[];if(k.length)for(let m=0;m<k.length;m++){let b=k[m];if(typeof b>"u")b="undefined";else if(b instanceof Error){const f=b;f.stack?b=f.stack:b=f.toString()}D.push(b)}if(M){const m=new Error().stack;m&&D.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,i.safeStringify)(D);return m.length>A?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(Ie[101],Ce([1,0,2,4,6,3,15,12,16,10,19,25]),function(ee,e,i,T,y,L,C,A,S,k,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let m=class Ai{constructor(f,t){this.h=t,this.f=new Map,this.g=f.getProxy(T.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,t){const c=Ai.c++;this.f.set(c,{provider:f,extensionDescription:t}),this.g.$registerDecorationProvider(c,t.identifier.value);const u=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(p=>{if(!p){this.g.$onDidChange(c,null);return}const E=(0,S.asArray)(p);if(E.length<=Ai.d){this.g.$onDidChange(c,E);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,E.length);const v=E.map(r=>({uri:r,rank:(0,k.count)(r.path,"/")})),w=(0,S.groupBy)(v,(r,o)=>r.rank-o.rank||(0,k.compare)(r.uri.path,o.uri.path)),s=[];e:for(const r of w){let o;for(const h of r){const a=(0,M.dirname)(h.uri.path);if(o!==a&&(o=a,s.push(h.uri)>=Ai.d))break e}}this.g.$onDidChange(c,s)});return new y.Disposable(()=>{u?.dispose(),this.g.$unregisterDecorationProvider(c),this.f.delete(c)})}async $provideDecorations(f,t,c){if(!this.f.has(f))return Object.create(null);const u=Object.create(null),{provider:p,extensionDescription:E}=this.f.get(f);return await Promise.all(t.map(async v=>{try{const{uri:w,id:s}=v,r=await Promise.resolve(p.provideFileDecoration(i.URI.revive(w),c));if(!r)return;try{y.FileDecoration.validate(r),r.badge&&typeof r.badge!="string"&&(0,D.checkProposedApiEnabled)(E,"codiconDecoration"),u[s]=[r.propagate,r.tooltip,r.badge,r.color]}catch(o){this.h.warn(`INVALID decoration from extension '${E}': ${o}`)}}catch(w){this.h.error(w)}})),u}};m.c=0,m.d=250,m=qe([Ve(0,C.IExtHostRpcService),Ve(1,A.ILogService)],m),e.ExtHostDecorations=m,e.IExtHostDecorations=(0,L.createDecorator)("IExtHostDecorations")});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[201],Ce([1,0,134,86,2,4,6,8,5,12,28,37]),function(ee,e,i,T,y,L,C,A,S,k,M,D){"use strict";var m,b,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class t{constructor(p,E,v,w,s,r,o){this.d=p,this.e=E,this.f=v,this.g=w,m.set(this,void 0),b.set(this,void 0),f.set(this,void 0),this.c=!1,Ye(this,f,new M.ResourceMap(h=>s.getComparisonKey(h)),"f"),Ye(this,m,r,"f"),Ye(this,b,o,"f")}dispose(){this.c||(Re(this,b,"f").fire([...Re(this,f,"f").keys()]),Re(this,m,"f")?.$clear(this.e),Re(this,f,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(p,E){if(!p){this.clear();return}this.h();let v=[];if(y.URI.isUri(p)){if(!E){this.delete(p);return}Re(this,f,"f").set(p,E.slice()),v=[p]}else if(Array.isArray(p)){v=[];let s;p=[...p].sort(t.j);for(const r of p){const[o,h]=r;if((!s||o.toString()!==s.toString())&&(s&&Re(this,f,"f").get(s).length===0&&Re(this,f,"f").delete(s),s=o,v.push(o),Re(this,f,"f").set(o,[])),h)Re(this,f,"f").get(o)?.push(...h);else{const a=Re(this,f,"f").get(o);a&&(a.length=0)}}}if(Re(this,b,"f").fire(v),!Re(this,m,"f"))return;const w=[];for(const s of v){let r=[];const o=Re(this,f,"f").get(s);if(o)if(o.length>this.f){r=[];const h=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let a=0;a<4;a++)for(const l of o)if(l.severity===h[a]&&r.push({...A.Diagnostic.from(l),modelVersionId:this.g(s)})===this.f)break e;r.push({severity:T.MarkerSeverity.Info,message:(0,i.localize)(0,null,o.length-this.f),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=o.map(h=>({...A.Diagnostic.from(h),modelVersionId:this.g(s)}));w.push([s,r])}Re(this,m,"f").$changeMany(this.e,w)}delete(p){this.h(),Re(this,b,"f").fire([p]),Re(this,f,"f").delete(p),Re(this,m,"f")?.$changeMany(this.e,[[p,void 0]])}clear(){this.h(),Re(this,b,"f").fire([...Re(this,f,"f").keys()]),Re(this,f,"f").clear(),Re(this,m,"f")?.$clear(this.e)}forEach(p,E){this.h();for(const[v,w]of this)p.call(E,v,w,this)}*[(m=new WeakMap,b=new WeakMap,f=new WeakMap,Symbol.iterator)](){this.h();for(const p of Re(this,f,"f").keys())yield[p,this.get(p)]}get(p){this.h();const E=Re(this,f,"f").get(p);return Array.isArray(E)?Object.freeze(E.slice(0)):[]}has(p){return this.h(),Array.isArray(Re(this,f,"f").get(p))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(p,E){return p[0].toString()<E[0].toString()?-1:p[0].toString()>E[0].toString()?1:0}}e.DiagnosticCollection=t;let c=class gi{static _mapper(p){const E=new M.ResourceMap;for(const v of p)E.set(v,v);return{uris:Object.freeze(Array.from(E.values()))}}constructor(p,E,v,w){this.h=E,this.j=v,this.k=w,this.f=new Map,this.g=new S.DebounceEmitter({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.g.event,gi._mapper),this.e=p.getProxy(L.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(p,E){const{f:v,e:w,g:s,h:r,j:o,k:h}=this,a=new class{$changeMany(d,g){w.$changeMany(d,g),r.trace("[DiagnosticCollection] change many (extension, owner, uris)",p.value,d,g.length===0?"CLEARING":g)}$clear(d){w.$clear(d),r.trace("[DiagnosticCollection] remove all (extension, owner)",p.value,d)}dispose(){w.dispose()}};let l;if(!E)E="_generated_diagnostic_collection_name_#"+gi.c++,l=E;else if(!v.has(E))l=E;else{this.h.warn(`DiagnosticCollection with name '${E}' does already exist.`);do l=E+gi.c++;while(v.has(l))}return new class extends t{constructor(){super(E,l,gi.d,d=>h.getDocument(d)?.version,o.extUri,a,s),v.set(l,this)}dispose(){super.dispose(),v.delete(l)}}}getDiagnostics(p){if(p)return this.l(p);{const E=new Map,v=[];for(const w of this.f.values())w.forEach((s,r)=>{let o=E.get(s.toString());typeof o>"u"&&(o=v.length,E.set(s.toString(),o),v.push([s,[]])),v[o][1]=v[o][1].concat(...r)});return v}}l(p){let E=[];for(const v of this.f.values())v.has(p)&&(E=E.concat(v.get(p)));return E}$acceptMarkersChange(p){if(!this.m){const E="_generated_mirror",v=new t(E,E,gi.d,w=>{},this.j.extUri,void 0,this.g);this.f.set(E,v),this.m=v}for(const[E,v]of p)this.m.set(y.URI.revive(E),v.map(A.Diagnostic.to))}};c.c=0,c.d=1e3,c=qe([Ve(1,k.ILogService),Ve(2,D.IExtHostFileSystemInfo)],c),e.ExtHostDiagnostics=c}),define(Ie[202],Ce([1,0,2,4]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class y{constructor(C){this.a=C.getProxy(T.MainContext.MainThreadDialogs)}showOpenDialog(C){return this.a.$showOpenDialog(C).then(A=>A?A.map(S=>i.URI.revive(S)):void 0)}showSaveDialog(C){return this.a.$showSaveDialog(C).then(A=>A?i.URI.revive(A):void 0)}}e.ExtHostDialogs=y}),define(Ie[203],Ce([1,0,11,2,6,4,13,20,10]),function(ee,e,i,T,y,L,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(D,m,b){this.d=m,this.e=b,this.b=new Map,this.c=D.getProxy(L.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,m){if(Object.keys(C.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const b=k.a++;this.b.set(b,m),this.c.$registerTextContentProvider(b,D);let f;return typeof m.onDidChange=="function"&&(f=m.onDidChange(t=>{if(t.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${t.scheme}' which will be IGNORED`);return}this.d.getDocument(t)&&this.$provideTextDocumentContent(b,t).then(c=>{if(!c&&typeof c!="string")return;const u=this.d.getDocument(t);if(!u)return;const p=(0,S.splitLines)(c);if(!u.equalLines(p))return this.c.$onVirtualDocumentChange(t,c)},i.onUnexpectedError)})),new y.Disposable(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(D,m){const b=this.b.get(D);return b?Promise.resolve(b.provideTextDocumentContent(T.URI.revive(m),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=k,k.a=0}),define(Ie[204],Ce([1,0,5,7,2,4,96,8,9,23,6]),function(ee,e,i,T,y,L,C,A,S,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class D{constructor(b,f){this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter,this.d=new i.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.DisposableStore,this.h=new Map,this.f=b.getProxy(L.MainContext.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(t=>{for(const c of t)this.b.fire(c.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const c of t)this.a.fire(c.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const f=this.g.getDocument(b);if(f)return f}getDocument(b){const f=this.getDocumentData(b);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return f.document}ensureDocumentData(b){const f=this.g.getDocument(b);if(f)return Promise.resolve(f);let t=this.h.get(b.toString());return t||(t=this.f.$tryOpenDocument(b).then(c=>{this.h.delete(b.toString());const u=y.URI.revive(c);return(0,S.assertIsDefined)(this.g.getDocument(u))},c=>(this.h.delete(b.toString()),Promise.reject(c))),this.h.set(b.toString(),t)),t}createDocumentData(b){return this.f.$tryCreateDocument(b).then(f=>y.URI.revive(f))}$acceptModelLanguageChanged(b,f){const t=y.URI.revive(b),c=this.g.getDocument(t);if(!c)throw new Error("unknown document");this.b.fire(c.document),c._acceptLanguageId(f),this.a.fire(c.document)}$acceptModelSaved(b){const f=y.URI.revive(b),t=this.g.getDocument(f);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(b,f){const t=y.URI.revive(b),c=this.g.getDocument(t);if(!c)throw new Error("unknown document");c._acceptIsDirty(f),this.c.fire({document:c.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,f,t){const c=y.URI.revive(b),u=this.g.getDocument(c);if(!u)throw new Error("unknown document");u._acceptIsDirty(t),u.onEvents(f);let p;f.isUndoing?p=M.TextDocumentChangeReason.Undo:f.isRedoing&&(p=M.TextDocumentChangeReason.Redo),this.c.fire((0,k.deepFreeze)({document:u.document,contentChanges:f.changes.map(E=>({range:A.Range.to(E.range),rangeOffset:E.rangeOffset,rangeLength:E.rangeLength,text:E.text})),reason:p}))}setWordDefinitionFor(b,f){(0,C.setWordDefinitionFor)(b,f)}}e.ExtHostDocuments=D}),define(Ie[55],Ce([1,0,47,5,7,2,3,4,96,15,99,8,12,28,13,174,205]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m,b,f,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class u{constructor(v){this.value=v,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let p=class{constructor(v,w){this.h=v,this.i=w,this.a=null,this.b=new Map,this.c=new b.ResourceMap,this.d=new T.Emitter,this.e=new T.Emitter,this.f=new T.Emitter,this.g=new T.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(v){this.acceptDocumentsAndEditorsDelta(v)}acceptDocumentsAndEditorsDelta(v){const w=[],s=[],r=[];if(v.removedDocuments)for(const o of v.removedDocuments){const h=L.URI.revive(o),a=this.c.get(h);a?.unref()&&(this.c.delete(h),w.push(a.value))}if(v.addedDocuments)for(const o of v.addedDocuments){const h=L.URI.revive(o.uri);let a=this.c.get(h);if(a&&h.scheme!==f.Schemas.vscodeNotebookCell&&h.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${h} already exists!'`);a||(a=new u(new S.ExtHostDocumentData(this.h.getProxy(A.MainContext.MainThreadDocuments),h,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty,o.notebook)),this.c.set(h,a),s.push(a.value)),a.ref()}if(v.removedEditors)for(const o of v.removedEditors){const h=this.b.get(o);this.b.delete(o),h&&r.push(h)}if(v.addedEditors)for(const o of v.addedEditors){const h=L.URI.revive(o.documentUri);i.ok(this.c.has(h),`document '${h}' does not exist`),i.ok(!this.b.has(o.id),`editor '${o.id}' already exists!`);const a=this.c.get(h).value,l=new M.ExtHostTextEditor(o.id,this.h.getProxy(A.MainContext.MainThreadTextEditors),this.i,new c.Lazy(()=>a.document),o.selections.map(D.Selection.to),o.options,o.visibleRanges.map(n=>D.Range.to(n)),typeof o.editorPosition=="number"?D.ViewColumn.to(o.editorPosition):void 0);this.b.set(o.id,l)}v.newActiveEditor!==void 0&&(i.ok(v.newActiveEditor===null||this.b.has(v.newActiveEditor),`active editor '${v.newActiveEditor}' does not exist`),this.a=v.newActiveEditor),(0,y.dispose)(w),(0,y.dispose)(r),v.removedDocuments&&this.e.fire(w),v.addedDocuments&&this.d.fire(s),(v.removedEditors||v.addedEditors)&&this.f.fire(this.allEditors().map(o=>o.value)),v.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(v){return this.c.get(v)?.value}allDocuments(){return t.Iterable.map(this.c.values(),v=>v.value)}getEditor(v){return this.b.get(v)}activeEditor(v){if(!this.a)return;const w=this.b.get(this.a);return v?w:w?.value}allEditors(){return[...this.b.values()]}};p=qe([Ve(0,k.IExtHostRpcService),Ve(1,m.ILogService)],p),e.ExtHostDocumentsAndEditors=p,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ie[56],Ce([1,0,8,4,2,5,3,6,15,9,78]),function(ee,e,i,T,y,L,C,A,S,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");class D{constructor(c,u,p){this.e=p,this.d=u,this.acceptDtoUpdate(c)}get apiObject(){if(!this.a){const c=this,u={get isActive(){return c.b.id===c.e()},get label(){return c.b.label},get input(){return c.c},get isDirty(){return c.b.isDirty},get isPinned(){return c.b.isPinned},get isPreview(){return c.b.isPreview},get group(){return c.d.apiObject}};this.a=Object.freeze(u)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(c){this.b=c,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.TextTabInput(y.URI.revive(this.b.input.uri));case 2:return new A.TextDiffTabInput(y.URI.revive(this.b.input.original),y.URI.revive(this.b.input.modified));case 3:return new A.TextMergeTabInput(y.URI.revive(this.b.input.base),y.URI.revive(this.b.input.input1),y.URI.revive(this.b.input.input2),y.URI.revive(this.b.input.result));case 6:return new A.CustomEditorTabInput(y.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.WebviewEditorTabInput(this.b.input.viewType);case 4:return new A.NotebookEditorTabInput(y.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(y.URI.revive(this.b.input.original),y.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(y.URI.revive(this.b.input.uri),y.URI.revive(this.b.input.inputBoxUri));default:return}}}class m{constructor(c,u){this.c=[],this.d="",this.b=c,this.e=u;for(const p of c.tabs)p.isActive&&(this.d=p.id),this.c.push(new D(p,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const c=this,u={get isActive(){return c.b.groupId===c.e()},get viewColumn(){return i.ViewColumn.to(c.b.viewColumn)},get activeTab(){return c.c.find(p=>p.tabId===c.d)?.apiObject},get tabs(){return Object.freeze(c.c.map(p=>p.apiObject))}};this.a=Object.freeze(u)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(c){this.b=c}acceptTabOperation(c){if(c.kind===0){const p=new D(c.tabDto,this,()=>this.activeTabId());return this.c.splice(c.index,0,p),c.tabDto.isActive&&(this.d=p.tabId),p}else if(c.kind===1){const p=this.c.splice(c.index,1)[0];if(!p)throw new Error(`Tab close updated received for index ${c.index} which does not exist`);return p.tabId===this.d&&(this.d=""),p}else if(c.kind===3){if(c.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const p=this.c.splice(c.oldIndex,1)[0];if(!p)throw new Error(`Tab move updated received for index ${c.oldIndex} which does not exist`);return this.c.splice(c.index,0,p),p}const u=this.c.find(p=>p.tabId===c.tabDto.id);if(!u)throw new Error("INVALID tab");return c.tabDto.isActive?this.d=c.tabDto.id:this.d===c.tabDto.id&&!c.tabDto.isActive&&(this.d=""),u.acceptDtoUpdate(c.tabDto),u}activeTabId(){return this.d}}let b=class{constructor(c){this.b=new L.Emitter,this.c=new L.Emitter,this.e=[],this.a=c.getProxy(T.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const c=this,u={onDidChangeTabGroups:c.c.event,onDidChangeTabs:c.b.event,get all(){return Object.freeze(c.e.map(p=>p.apiObject))},get activeTabGroup(){const p=c.d;return(0,k.assertIsDefined)(c.e.find(v=>v.groupId===p)?.apiObject)},close:async(p,E)=>{const v=Array.isArray(p)?p:[p];return v.length?f(v[0])?this.j(v,E):this.i(v,E):!0}};this.f=Object.freeze(u)}return this.f}$acceptEditorTabModel(c){const u=new Set(this.e.map(o=>o.groupId)),p=new Set(c.map(o=>o.groupId)),E=(0,M.diffSets)(u,p),v=this.e.filter(o=>E.removed.includes(o.groupId)).map(o=>o.apiObject),w=[],s=[];this.e=c.map(o=>{const h=new m(o,()=>this.d);return E.added.includes(h.groupId)?w.push(h.apiObject):s.push(h.apiObject),h});const r=(0,k.assertIsDefined)(c.find(o=>o.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:w,closed:v,changed:s}))}$acceptTabGroupUpdate(c){const u=this.e.find(p=>p.groupId===c.groupId);if(!u)throw new Error("Update Group IPC call received before group creation.");u.acceptGroupDtoUpdate(c),c.isActive&&(this.d=c.groupId),this.c.fire(Object.freeze({changed:[u.apiObject],opened:[],closed:[]}))}$acceptTabOperation(c){const u=this.e.find(E=>E.groupId===c.groupId);if(!u)throw new Error("Update Tabs IPC call received before group creation.");const p=u.acceptTabOperation(c);switch(c.kind){case 0:this.b.fire(Object.freeze({opened:[p.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[p.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[p.apiObject]}));return}}g(c){for(const u of this.e)for(const p of u.tabs)if(p.apiObject===c)return p}h(c){return this.e.find(u=>u.apiObject===c)}async i(c,u){const p=[];for(const E of c){const v=this.g(E);if(!v)throw new Error("Tab close: Invalid tab not found!");p.push(v.tabId)}return this.a.$closeTab(p,u)}async j(c,u){const p=[];for(const E of c){const v=this.h(E);if(!v)throw new Error("Group close: Invalid group not found!");p.push(v.groupId)}return this.a.$closeGroup(p,u)}};b=qe([Ve(0,S.IExtHostRpcService)],b),e.ExtHostEditorTabs=b;function f(t){return t.tabs!==void 0}}),define(Ie[206],Ce([1,0,2,4,7,6,8,251,10,24,25]),function(ee,e,i,T,y,L,C,A,S,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class D{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const t=this.a.indexOf(f);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),t=[];let c,u,p=14,E=14;for(const v of f){let w=c?(0,S.commonPrefixLength)(c,v):0;for(w===0?u=1:u=E;w<v.length;w++)w+1===v.length?(p=E,E=9):E+=1,t.push([u,v.toUpperCase().charCodeAt(w),E]),t.push([u,v.toLowerCase().charCodeAt(w),E]),u=E;c=v,E=p}t.push([9,58,10]),t.push([10,47,12]),this.b=new A.StateMachine(t)}}provideDocumentLinks(f){this.c();const t=[],c=A.LinkComputer.computeLinks({getLineContent(u){return f.lineAt(u-1).text},getLineCount(){return f.lineCount}},this.b);for(const u of c){const p=C.DocumentLink.to(u);p.target&&t.push(p)}return t}}class m{constructor(f,t){this.i=t,this.b=new D,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(T.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,t,c,u={}){if(this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const p=this.h++;this.b.add(t),this.d.add(t),this.c.set(p,c);let E=2;u.isCaseSensitive&&(E+=1024),u.isReadonly&&(E+=2048),typeof c.copy=="function"&&(E+=8),typeof c.open=="function"&&typeof c.close=="function"&&typeof c.read=="function"&&typeof c.write=="function"&&((0,M.checkProposedApiEnabled)(f,"fsChunks"),E+=4),this.a.$registerFileSystemProvider(p,t,E).catch(w=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${t}`),console.error(w)});const v=c.onDidChangeFile(w=>{const s=[];for(const r of w){const{uri:o,type:h}=r;if(o.scheme!==t)continue;let a;switch(h){case L.FileChangeType.Changed:a=0;break;case L.FileChangeType.Created:a=1;break;case L.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:o,type:a})}this.a.$onFileSystemChange(p,s)});return(0,y.toDisposable)(()=>{v.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(p),this.a.$unregisterProvider(p)})}static j(f){const{type:t,ctime:c,mtime:u,size:p,permissions:E}=f;return{type:t,ctime:c,mtime:u,size:p,permissions:E}}$stat(f,t){return Promise.resolve(this.k(f).stat(i.URI.revive(t))).then(c=>m.j(c))}$readdir(f,t){return Promise.resolve(this.k(f).readDirectory(i.URI.revive(t)))}$readFile(f,t){return Promise.resolve(this.k(f).readFile(i.URI.revive(t))).then(c=>k.VSBuffer.wrap(c))}$writeFile(f,t,c,u){return Promise.resolve(this.k(f).writeFile(i.URI.revive(t),c.buffer,u))}$delete(f,t,c){return Promise.resolve(this.k(f).delete(i.URI.revive(t),c))}$rename(f,t,c,u){return Promise.resolve(this.k(f).rename(i.URI.revive(t),i.URI.revive(c),u))}$copy(f,t,c,u){const p=this.k(f);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(i.URI.revive(t),i.URI.revive(c),u))}$mkdir(f,t){return Promise.resolve(this.k(f).createDirectory(i.URI.revive(t)))}$watch(f,t,c,u){const p=this.k(f).watch(i.URI.revive(c),u);this.f.set(t,p)}$unwatch(f,t){const c=this.f.get(t);c&&(c.dispose(),this.f.delete(t))}$open(f,t,c){const u=this.k(f);if(!u.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(u.open(i.URI.revive(t),c))}$close(f,t){const c=this.k(f);if(!c.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(c.close(t))}$read(f,t,c,u){const p=this.k(f);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const E=k.VSBuffer.alloc(u);return Promise.resolve(p.read(t,c,E.buffer,0,u)).then(v=>E.slice(0,v))}$write(f,t,c,u){const p=this.k(f);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(t,c,u.buffer,0,u.byteLength))}k(f){const t=this.c.get(f);if(!t){const c=new Error;throw c.name="ENOPRO",c.message="no provider",c}return t}}e.ExtHostFileSystem=m}),define(Ie[57],Ce([1,0,4,36,6,24,3,15,37,7]),function(ee,e,i,T,y,L,C,A,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let M=class Jt{constructor(m,b){this.b=new Map,this.a=m.getProxy(i.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(t){try{const c=f.b.get(t.scheme);if(!c)return await f.a.$stat(t);await f.a.$ensureActivation(t.scheme);const u=await c.stat(t);return{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions}}catch(c){Jt.c(c)}},async readDirectory(t){try{const c=f.b.get(t.scheme);return c?(await f.a.$ensureActivation(t.scheme),(await c.readDirectory(t)).slice()):await f.a.$readdir(t)}catch(c){return Jt.c(c)}},async createDirectory(t){try{return await f.a.$mkdir(t)}catch(c){return Jt.c(c)}},async readFile(t){try{const c=f.b.get(t.scheme);return c?(await f.a.$ensureActivation(t.scheme),(await c.readFile(t)).slice()):(await f.a.$readFile(t)).buffer}catch(c){return Jt.c(c)}},async writeFile(t,c){try{return await f.a.$writeFile(t,L.VSBuffer.wrap(c))}catch(u){return Jt.c(u)}},async delete(t,c){try{const u=f.b.get(t.scheme);return u?(await f.a.$ensureActivation(t.scheme),await u.delete(t,{recursive:!1,...c})):await f.a.$delete(t,{recursive:!1,useTrash:!1,...c})}catch(u){return Jt.c(u)}},async rename(t,c,u){try{return await f.a.$rename(t,c,{overwrite:!1,...u})}catch(p){return Jt.c(p)}},async copy(t,c,u){try{return await f.a.$copy(t,c,{overwrite:!1,...u})}catch(p){return Jt.c(p)}},isWritableFileSystem(t){const c=b.getCapabilities(t);if(typeof c=="number")return!(c&2048)}})}static c(m){if(m instanceof y.FileSystemError)throw m;if(!(m instanceof Error))throw new y.FileSystemError(String(m));if(m.name==="ENOPRO")throw y.FileSystemError.Unavailable(m.message);switch(m.name){case T.FileSystemProviderErrorCode.FileExists:throw y.FileSystemError.FileExists(m.message);case T.FileSystemProviderErrorCode.FileNotFound:throw y.FileSystemError.FileNotFound(m.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw y.FileSystemError.FileNotADirectory(m.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw y.FileSystemError.FileIsADirectory(m.message);case T.FileSystemProviderErrorCode.NoPermissions:throw y.FileSystemError.NoPermissions(m.message);case T.FileSystemProviderErrorCode.Unavailable:throw y.FileSystemError.Unavailable(m.message);default:throw new y.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,b){return this.b.set(m,b),(0,k.toDisposable)(()=>this.b.delete(m))}};M=qe([Ve(0,A.IExtHostRpcService),Ve(1,S.IExtHostFileSystemInfo)],M),e.ExtHostConsumerFileSystem=M,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(Ie[207],Ce([1,0,5,35,2,4,8,6]),function(ee,e,i,T,y,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(D,m,b,f,t,c,u,p){this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter;const E=this.h(D,b,t);this.g=0,c&&(this.g+=1),u&&(this.g+=2),p&&(this.g+=4);const v=(0,T.parse)(t),w=typeof t=="string",s=f(r=>{if(!c)for(const o of r.created){const h=y.URI.revive(o);v(h.fsPath)&&(!w||m.getWorkspaceFolder(h))&&this.a.fire(h)}if(!u)for(const o of r.changed){const h=y.URI.revive(o);v(h.fsPath)&&(!w||m.getWorkspaceFolder(h))&&this.b.fire(h)}if(!p)for(const o of r.deleted){const h=y.URI.revive(o);v(h.fsPath)&&(!w||m.getWorkspaceFolder(h))&&this.c.fire(h)}});this.d=A.Disposable.from(E,this.a,this.b,this.c,s)}h(D,m,b){const f=A.Disposable.from();if(typeof b=="string")return f;const t=D.getProxy(L.MainContext.MainThreadFileSystem);let c=!1;(b.pattern.includes(T.GLOBSTAR)||b.pattern.includes(T.GLOB_SPLIT))&&(c=!0);const u=Math.random();return t.$watch(m.identifier.value,u,b.baseUri,{recursive:c,excludes:[]}),A.Disposable.from({dispose:()=>t.$unwatch(u)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class k{constructor(D,m,b){this.j=D,this.k=m,this.l=b,this.a=new i.Emitter,this.b=new i.Emitter,this.c=new i.Emitter,this.d=new i.Emitter,this.g=new i.AsyncEmitter,this.h=new i.AsyncEmitter,this.i=new i.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(D,m,b,f,t,c){return new S(this.j,D,m,this.a.event,C.GlobPattern.from(b),f,t,c)}$onFileEvent(D){this.a.fire(D)}$onDidRunFileOperation(D,m){switch(D){case 2:this.b.fire(Object.freeze({files:m.map(b=>({oldUri:y.URI.revive(b.source),newUri:y.URI.revive(b.target)}))}));break;case 1:this.d.fire(Object.freeze({files:m.map(b=>y.URI.revive(b.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:m.map(b=>y.URI.revive(b.target))}));break;default:}}getOnWillRenameFileEvent(D){return this.m(D,this.g)}getOnWillCreateFileEvent(D){return this.m(D,this.h)}getOnWillDeleteFileEvent(D){return this.m(D,this.i)}m(D,m){return(b,f,t)=>{const c=function(p){b.call(f,p)};return c.extension=D,m.event(c,void 0,t)}}async $onWillRunFileOperation(D,m,b,f){switch(D){case 2:return await this.n(this.g,{files:m.map(t=>({oldUri:y.URI.revive(t.source),newUri:y.URI.revive(t.target)}))},b,f);case 1:return await this.n(this.i,{files:m.map(t=>y.URI.revive(t.target))},b,f);case 0:case 3:return await this.n(this.h,{files:m.map(t=>y.URI.revive(t.target))},b,f)}}async n(D,m,b,f){const t=new Set,c=[];if(await D.fireAsync(m,f,async(p,E)=>{const v=Date.now(),w=await Promise.resolve(p);w instanceof A.WorkspaceEdit&&(c.push([E.extension,w]),t.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-v>b&&this.k.warn("SLOW file-participant",E.extension.identifier)}),f.isCancellationRequested||c.length===0)return;const u={edits:[]};for(const[,p]of c){const{edits:E}=C.WorkspaceEdit.from(p,{getTextDocumentVersion:v=>this.l.getDocument(v)?.version,getNotebookDocumentVersion:()=>{}});u.edits=u.edits.concat(E)}return{edit:u,extensionNames:Array.from(t)}}}e.ExtHostFileSystemEventService=k}),define(Ie[208],Ce([1,0,2,38]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class y{constructor(C,A,S,k,M){this.a=A,this.b=S,this.c=k;const D=new T.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new T.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new T.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new T.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new T.ApiCommandResult("Notebook and input URI",m=>{if(M.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const b=this.a.getEditorById(m.notebookEditorId);return M.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:i.URI.revive(m.notebookUri),inputUri:i.URI.revive(m.inputUri),notebookEditor:b.apiEditor}}return M.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:i.URI.revive(m.notebookUri),inputUri:i.URI.revive(m.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(C,A,S,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:S,uri:C,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(i.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(C,A){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[C]})}}e.ExtHostInteractive=y}),define(Ie[209],Ce([1,0,7,4]),function(ee,e,i,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class y{constructor(C){this.b=0,this.a=C.getProxy(T.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const A=this.b++;return this.a.$registerResourceLabelFormatter(A,C),(0,i.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=y}),define(Ie[210],Ce([1,0,2,23,8,6,71,4,10,54,16,9,252,20,7,83,79,51,100,11,14,25]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m,b,f,t,c,u,p,E,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class s{constructor(I,$){this.d=I,this.e=$}async provideDocumentSymbols(I,$){const H=this.d.getDocument(I),j=await this.e.provideDocumentSymbols(H,$);if(!(0,M.isFalsyOrEmpty)(j))return j[0]instanceof L.DocumentSymbol?j.map(y.DocumentSymbol.from):s.f(j)}static f(I){I=I.slice(0).sort((j,Z)=>{let de=j.location.range.start.compareTo(Z.location.range.start);return de===0&&(de=Z.location.range.end.compareTo(j.location.range.end)),de});const $=[],H=[];for(const j of I){const Z={name:j.name||"!!MISSING: name!!",kind:y.SymbolKind.from(j.kind),tags:j.tags?.map(y.SymbolTag.from)||[],detail:"",containerName:j.containerName,range:y.Range.from(j.location.range),selectionRange:y.Range.from(j.location.range),children:[]};for(;;){if(H.length===0){H.push(Z),$.push(Z);break}const de=H[H.length-1];if(k.Range.containsRange(de.range,Z.range)&&!k.Range.equalsRange(de.range,Z.range)){de.children?.push(Z),H.push(Z);break}H.pop()}}return $}}class r{constructor(I,$,H){this.g=I,this.h=$,this.j=H,this.e=new u.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(I,$){const H=this.g.getDocument(I),j=await this.j.provideCodeLenses(H,$);if(!j||$.isCancellationRequested)return;const Z=this.e.add(j),de=new f.DisposableStore;this.f.set(Z,de);const Se={cacheId:Z,lenses:[]};for(let ae=0;ae<j.length;ae++)Se.lenses.push({cacheId:[Z,ae],range:y.Range.from(j[ae].range),command:this.h.toInternal(j[ae].command,de)});return Se}async resolveCodeLens(I,$){const H=I.cacheId&&this.e.get(...I.cacheId);if(!H)return;let j;if(typeof this.j.resolveCodeLens!="function"||H.isResolved?j=H:j=await this.j.resolveCodeLens(H,$),j||(j=H),$.isCancellationRequested)return;const Z=I.cacheId&&this.f.get(I.cacheId[0]);if(!!Z)return I.command=this.h.toInternal(j.command??r.d,Z),I}releaseCodeLenses(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}}r.d={command:"missing",title:"!!MISSING: command!!"};function o(Y){return Array.isArray(Y)?Y.map(y.DefinitionLink.from):Y?[y.DefinitionLink.from(Y)]:[]}class h{constructor(I,$){this.d=I,this.e=$}async provideDefinition(I,$,H){const j=this.d.getDocument(I),Z=y.Position.to($),de=await this.e.provideDefinition(j,Z,H);return o(de)}}class a{constructor(I,$){this.d=I,this.e=$}async provideDeclaration(I,$,H){const j=this.d.getDocument(I),Z=y.Position.to($),de=await this.e.provideDeclaration(j,Z,H);return o(de)}}class l{constructor(I,$){this.d=I,this.e=$}async provideImplementation(I,$,H){const j=this.d.getDocument(I),Z=y.Position.to($),de=await this.e.provideImplementation(j,Z,H);return o(de)}}class n{constructor(I,$){this.d=I,this.e=$}async provideTypeDefinition(I,$,H){const j=this.d.getDocument(I),Z=y.Position.to($),de=await this.e.provideTypeDefinition(j,Z,H);return o(de)}}class d{constructor(I,$){this.d=I,this.e=$}async provideHover(I,$,H){const j=this.d.getDocument(I),Z=y.Position.to($),de=await this.e.provideHover(j,Z,H);if(!(!de||(0,M.isFalsyOrEmpty)(de.contents)))return de.range||(de.range=j.getWordRangeAtPosition(Z)),de.range||(de.range=new L.Range(Z,Z)),y.Hover.from(de)}}class g{constructor(I,$){this.d=I,this.e=$}async provideEvaluatableExpression(I,$,H){const j=this.d.getDocument(I),Z=y.Position.to($),de=await this.e.provideEvaluatableExpression(j,Z,H);if(de)return y.EvaluatableExpression.from(de)}}class O{constructor(I,$){this.d=I,this.e=$}async provideInlineValues(I,$,H,j){const Z=this.d.getDocument(I),de=await this.e.provideInlineValues(Z,y.Range.to($),y.InlineValueContext.to(H),j);if(Array.isArray(de))return de.map(Se=>y.InlineValue.from(Se))}}class N{constructor(I,$){this.d=I,this.e=$}async provideDocumentHighlights(I,$,H){const j=this.d.getDocument(I),Z=y.Position.to($),de=await this.e.provideDocumentHighlights(j,Z,H);if(Array.isArray(de))return de.map(y.DocumentHighlight.from)}}class q{constructor(I,$){this.d=I,this.e=$}async provideLinkedEditingRanges(I,$,H){const j=this.d.getDocument(I),Z=y.Position.to($),de=await this.e.provideLinkedEditingRanges(j,Z,H);if(de&&Array.isArray(de.ranges))return{ranges:(0,M.coalesce)(de.ranges.map(y.Range.from)),wordPattern:de.wordPattern}}}class J{constructor(I,$){this.d=I,this.e=$}async provideReferences(I,$,H,j){const Z=this.d.getDocument(I),de=y.Position.to($),Se=await this.e.provideReferences(Z,de,H,j);if(Array.isArray(Se))return Se.map(y.location.from)}}class x{constructor(I,$,H,j,Z,de,Se){this.g=I,this.h=$,this.j=H,this.k=j,this.l=Z,this.m=de,this.n=Se,this.e=new u.Cache("CodeAction"),this.f=new Map}async provideCodeActions(I,$,H,j){const Z=this.g.getDocument(I),de=m.Selection.isISelection($)?y.Selection.to($):y.Range.to($),Se=[];for(const tt of this.j.getDiagnostics(I))if(de.intersection(tt.range)&&Se.push(tt)>x.d)break;const ae={diagnostics:Se,only:H.only?new L.CodeActionKind(H.only):void 0,triggerKind:y.CodeActionTriggerKind.to(H.trigger)},ve=await this.k.provideCodeActions(Z,de,ae,j);if(!(0,M.isNonEmptyArray)(ve)||j.isCancellationRequested)return;const be=this.e.add(ve),$e=new f.DisposableStore;this.f.set(be,$e);const He=[];for(let tt=0;tt<ve.length;tt++){const xe=ve[tt];!xe||(x.o(xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),He.push({_isSynthetic:!0,title:xe.title,command:this.h.toInternal(xe,$e)})):(ae.only&&(xe.kind?ae.only.contains(xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ae.only.value} 'requested but returned code action is of kind '${xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),He.push({cacheId:[be,tt],title:xe.title,command:xe.command&&this.h.toInternal(xe.command,$e),diagnostics:xe.diagnostics&&xe.diagnostics.map(y.Diagnostic.from),edit:xe.edit&&y.WorkspaceEdit.from(xe.edit,void 0),kind:xe.kind&&xe.kind.value,isPreferred:xe.isPreferred,disabled:xe.disabled?.reason})))}return{cacheId:be,actions:He}}async resolveCodeAction(I,$){const[H,j]=I,Z=this.e.get(H,j);if(!Z||x.o(Z)||!this.k.resolveCodeAction)return;const de=await this.k.resolveCodeAction(Z,$)??Z;return de?.edit?y.WorkspaceEdit.from(de.edit,void 0):void 0}releaseCodeActions(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}static o(I){return typeof I.command=="string"&&typeof I.title=="string"}}x.d=1e3;class R{constructor(I,$,H,j){this.d=I,this.e=$,this.f=H,this.g=j}async prepareDocumentPaste(I,$,H,j){if(!this.f.prepareDocumentPaste)return;const Z=this.e.getDocument(I),de=$.map(ae=>y.Range.to(ae)),Se=y.DataTransfer.toDataTransfer(H,()=>{throw new E.NotImplementedError});return await this.f.prepareDocumentPaste(Z,de,Se,j),y.DataTransfer.toDataTransferDTO(Se)}async providePasteEdits(I,$,H,j,Z){const de=this.e.getDocument($),Se=H.map(be=>y.Range.to(be)),ae=y.DataTransfer.toDataTransfer(j,async be=>(await this.d.$resolvePasteFileData(this.g,I,be)).buffer),ve=await this.f.provideDocumentPasteEdits(de,Se,ae,Z);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?y.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class P{constructor(I,$){this.d=I,this.e=$}async provideDocumentFormattingEdits(I,$,H){const j=this.d.getDocument(I),Z=await this.e.provideDocumentFormattingEdits(j,$,H);if(Array.isArray(Z))return Z.map(y.TextEdit.from)}}class F{constructor(I,$){this.d=I,this.e=$}async provideDocumentRangeFormattingEdits(I,$,H,j){const Z=this.d.getDocument(I),de=y.Range.to($),Se=await this.e.provideDocumentRangeFormattingEdits(Z,de,H,j);if(Array.isArray(Se))return Se.map(y.TextEdit.from)}}class B{constructor(I,$){this.d=I,this.e=$,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(I,$,H,j,Z){const de=this.d.getDocument(I),Se=y.Position.to($),ae=await this.e.provideOnTypeFormattingEdits(de,Se,H,j,Z);if(Array.isArray(ae))return ae.map(y.TextEdit.from)}}class z{constructor(I,$){this.e=I,this.f=$,this.d=new u.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(I,$){const H=await this.e.provideWorkspaceSymbols(I,$);if(!(0,M.isNonEmptyArray)(H))return{symbols:[]};const j=this.d.add(H),Z={cacheId:j,symbols:[]};for(let de=0;de<H.length;de++){const Se=H[de];if(!Se||!Se.name){this.f.warn("INVALID SymbolInformation",Se);continue}Z.symbols.push({...y.WorkspaceSymbol.from(Se),cacheId:[j,de]})}return Z}async resolveWorkspaceSymbol(I,$){if(typeof this.e.resolveWorkspaceSymbol!="function"||!I.cacheId)return I;const H=this.d.get(...I.cacheId);if(H){const j=await this.e.resolveWorkspaceSymbol(H,$);return j&&(0,T.mixin)(I,y.WorkspaceSymbol.from(j),!0)}}releaseWorkspaceSymbols(I){this.d.delete(I)}}class V{static supportsResolving(I){return typeof I.prepareRename=="function"}constructor(I,$,H){this.d=I,this.e=$,this.f=H}async provideRenameEdits(I,$,H,j){const Z=this.d.getDocument(I),de=y.Position.to($);try{const Se=await this.e.provideRenameEdits(Z,de,H,j);return Se?y.WorkspaceEdit.from(Se):void 0}catch(Se){const ae=V.g(Se);return ae?{rejectReason:ae,edits:void 0}:Promise.reject(Se)}}async resolveRenameLocation(I,$,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const j=this.d.getDocument(I),Z=y.Position.to($);try{const de=await this.e.prepareRename(j,Z,H);let Se,ae;if(L.Range.isRange(de)?(Se=de,ae=j.getText(de)):(0,D.isObject)(de)&&(Se=de.range,ae=de.placeholder),!Se||!ae)return;if(Se.start.line>Z.line||Se.end.line<Z.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:y.Range.from(Se),text:ae}}catch(de){const Se=V.g(de);return Se?{rejectReason:Se,range:void 0,text:void 0}:Promise.reject(de)}}static g(I){return typeof I=="string"?I:I instanceof Error&&typeof I.message=="string"?I.message:void 0}}class K{constructor(I,$){this.resultId=I,this.tokens=$}}class ie{constructor(I,$){this.f=I,this.g=$,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(I,$,H){const j=this.f.getDocument(I),Z=$!==0?this.d.get($):null;let de=typeof Z?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(j,Z.resultId,H):await this.g.provideDocumentSemanticTokens(j,H);return Z&&this.d.delete($),de?(de=ie.h(de),this.o(ie.n(Z,de),de)):null}async releaseDocumentSemanticColoring(I){this.d.delete(I)}static h(I){return ie.j(I)?ie.k(I)?I:new L.SemanticTokens(new Uint32Array(I.data),I.resultId):ie.l(I)?ie.m(I)?I:new L.SemanticTokensEdits(I.edits.map($=>new L.SemanticTokensEdit($.start,$.deleteCount,$.data?new Uint32Array($.data):$.data)),I.resultId):I}static j(I){return I&&!!I.data}static k(I){return I.data instanceof Uint32Array}static l(I){return I&&Array.isArray(I.edits)}static m(I){for(const $ of I.edits)if(!($.data instanceof Uint32Array))return!1;return!0}static n(I,$){if(!ie.j($)||!I||!I.tokens)return $;const H=I.tokens,j=H.length,Z=$.data,de=Z.length;let Se=0;const ae=Math.min(j,de);for(;Se<ae&&H[Se]===Z[Se];)Se++;if(Se===j&&Se===de)return new L.SemanticTokensEdits([],$.resultId);let ve=0;const be=ae-Se;for(;ve<be&&H[j-ve-1]===Z[de-ve-1];)ve++;return new L.SemanticTokensEdits([{start:Se,deleteCount:j-Se-ve,data:Z.subarray(Se,de-ve)}],$.resultId)}o(I,$){if(ie.j(I)){const H=this.e++;return this.d.set(H,new K(I.resultId,I.data)),(0,t.encodeSemanticTokensDto)({id:H,type:"full",data:I.data})}if(ie.l(I)){const H=this.e++;return ie.j($)?this.d.set(H,new K($.resultId,$.data)):this.d.set(H,new K(I.resultId)),(0,t.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(I.edits||[]).map(j=>({start:j.start,deleteCount:j.deleteCount,data:j.data}))})}return null}}class ge{constructor(I,$){this.d=I,this.e=$}async provideDocumentRangeSemanticTokens(I,$,H){const j=this.d.getDocument(I),Z=await this.e.provideDocumentRangeSemanticTokens(j,y.Range.to($),H);return Z?this.f(Z):null}f(I){return(0,t.encodeSemanticTokensDto)({id:0,type:"full",data:I.data})}}class ue{static supportsResolving(I){return typeof I.resolveCompletionItem=="function"}constructor(I,$,H,j,Z){this.f=I,this.g=$,this.h=H,this.j=j,this.k=Z,this.d=new u.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(I,$,H,j){const Z=this.f.getDocument(I),de=y.Position.to($),Se=Z.getWordRangeAtPosition(de)||new L.Range(de,de),ae=Se.with({end:de}),ve=new p.StopWatch(!0),be=await this.h.provideCompletionItems(Z,de,j,y.CompletionContext.to(H));if(!be||j.isCancellationRequested)return;const $e=Array.isArray(be)?new L.CompletionList(be):be,He=ue.supportsResolving(this.h)?this.d.add($e.items):this.d.add([]),tt=new f.DisposableStore;this.e.set(He,tt);const xe=[],et={x:He,b:xe,a:{replace:y.Range.from(Se),insert:y.Range.from(ae)},c:$e.isIncomplete||void 0,d:ve.elapsed()};for(let it=0;it<$e.items.length;it++){const dt=$e.items[it],Fe=this.l(dt,[He,it],ae,Se);xe.push(Fe)}return et}async resolveCompletionItem(I,$){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...I);if(!H)return;const j=await this.h.resolveCompletionItem(H,$);if(!!j)return this.l(j,I)}releaseCompletionItems(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,$,H,j){const Z=this.e.get($[0]);if(!Z)throw Error("DisposableStore is missing...");const de=this.g.toInternal(I.command,Z),Se={x:$,a:I.label,b:I.kind!==void 0?y.CompletionItemKind.from(I.kind):void 0,m:I.tags&&I.tags.map(y.CompletionItemTag.from),c:I.detail,d:typeof I.documentation>"u"?void 0:y.MarkdownString.fromStrict(I.documentation),e:I.sortText!==I.label?I.sortText:void 0,f:I.filterText!==I.label?I.filterText:void 0,g:I.preselect||void 0,i:I.keepWhitespace?1:0,k:I.commitCharacters?.join(""),l:I.additionalTextEdits&&I.additionalTextEdits.map(y.TextEdit.from),n:de?.$ident,o:de?.id,p:de?.$ident?void 0:de?.arguments};I.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Se.h=I.textEdit.newText):typeof I.insertText=="string"?Se.h=I.insertText:I.insertText instanceof L.SnippetString&&(Se.h=I.insertText.value,Se.i|=4);let ae;return I.textEdit?ae=I.textEdit.range:I.range&&(ae=I.range),L.Range.isRange(ae)?Se.j=y.Range.from(ae):ae&&(!H?.isEqual(ae.inserting)||!j?.isEqual(ae.replacing))&&(Se.j={insert:y.Range.from(ae.inserting),replace:y.Range.from(ae.replacing)}),Se}}class re{async provideInlineCompletions(I,$,H,j){}disposeCompletions(I){}handleDidShowCompletionItem(I,$){}}class se extends re{constructor(I,$,H,j){super(),this.f=I,this.g=$,this.h=H,this.j=j,this.d=new le,this.e=(0,w.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[C.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[C.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,w.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(I,$,H,j){const Z=this.g.getDocument(I),de=y.Position.to($),Se=await this.h.provideInlineCompletionItems(Z,de,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:y.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},j);if(!Se||j.isCancellationRequested)return;const ae=Array.isArray(Se)?Se:Se.items,ve=this.e?Array.isArray(Se)?[]:Se.commands||[]:[];let be;return{pid:this.d.createReferenceId({dispose(){be?.dispose()},items:ae}),items:ae.map((He,tt)=>{let xe;He.command&&(be||(be=new f.DisposableStore),xe=this.j.toInternal(He.command,be));const et=He.insertText;return{insertText:typeof et=="string"?et:{snippet:et.value},filterText:He.filterText,range:He.range?y.Range.from(He.range):void 0,command:xe,idx:tt,completeBracketPairs:this.e?He.completeBracketPairs:!1}}),commands:ve.map(He=>(be||(be=new f.DisposableStore),this.j.toInternal(He,be)))}}disposeCompletions(I){this.d.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,$){const H=this.d.get(I)?.items[$];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H)}}class le{constructor(){this.d=new Map,this.e=1}createReferenceId(I){const $=this.e++;return this.d.set($,I),$}disposeReferenceId(I){const $=this.d.get(I);return this.d.delete(I),$}get(I){return this.d.get(I)}}class _{constructor(I,$){this.e=I,this.f=$,this.d=new u.Cache("SignatureHelp")}async provideSignatureHelp(I,$,H,j){const Z=this.e.getDocument(I),de=y.Position.to($),Se=this.g(H),ae=await this.f.provideSignatureHelp(Z,de,j,Se);if(ae){const ve=this.d.add([ae]);return{...y.SignatureHelp.from(ae),id:ve}}}g(I){let $;if(I.activeSignatureHelp){const H=y.SignatureHelp.to(I.activeSignatureHelp),j=this.d.get(I.activeSignatureHelp.id,0);j?($=j,$.activeSignature=H.activeSignature,$.activeParameter=H.activeParameter):$=H}return{...I,activeSignatureHelp:$}}releaseSignatureHelp(I){this.d.delete(I)}}class me{constructor(I,$,H,j,Z){this.f=I,this.g=$,this.h=H,this.j=j,this.k=Z,this.d=new u.Cache("InlayHints"),this.e=new Map}async provideInlayHints(I,$,H){const j=this.f.getDocument(I),Z=y.Range.to($),de=await this.h.provideInlayHints(j,Z,H);if(!Array.isArray(de)||de.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${$}`);return}if(H.isCancellationRequested)return;const Se=this.d.add(de);this.e.set(Se,new f.DisposableStore);const ae={hints:[],cacheId:Se};for(let ve=0;ve<de.length;ve++)this.l(de[ve],Z)&&ae.hints.push(this.m(de[ve],[Se,ve]));return this.j.trace(`[InlayHints] ${ae.hints.length} inlay hints from '${this.k.identifier.value}' for ${$}`),ae}async resolveInlayHint(I,$){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...I);if(!H)return;const j=await this.h.resolveInlayHint(H,$);if(!!j&&!!this.l(j))return this.m(j,I)}releaseHints(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,$){return I.label.length===0||Array.isArray(I.label)&&I.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",I),!1):!($&&!$.contains(I.position))}m(I,$){const H=this.e.get($[0]);if(!H)throw Error("DisposableStore is missing...");const j={label:"",cacheId:$,tooltip:y.MarkdownString.fromStrict(I.tooltip),position:y.Position.from(I.position),textEdits:I.textEdits&&I.textEdits.map(y.TextEdit.from),kind:I.kind&&y.InlayHintKind.from(I.kind),paddingLeft:I.paddingLeft,paddingRight:I.paddingRight};return typeof I.label=="string"?j.label=I.label:j.label=I.label.map(Z=>{const de={label:Z.value};return de.tooltip=y.MarkdownString.fromStrict(Z.tooltip),L.Location.isLocation(Z.location)&&(de.location=y.location.from(Z.location)),Z.command&&(de.command=this.g.toInternal(Z.command,H)),de}),j}}class we{constructor(I,$){this.e=I,this.f=$,this.d=new u.Cache("DocumentLink")}async provideLinks(I,$){const H=this.e.getDocument(I),j=await this.f.provideDocumentLinks(H,$);if(!(!Array.isArray(j)||j.length===0)&&!$.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:j.filter(we.g).map(y.DocumentLink.from)};{const Z=this.d.add(j),de={links:[],cacheId:Z};for(let Se=0;Se<j.length;Se++){if(!we.g(j[Se]))continue;const ae=y.DocumentLink.from(j[Se]);ae.cacheId=[Z,Se],de.links.push(ae)}return de}}}static g(I){return I.target&&I.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(I,$){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...I);if(!H)return;const j=await this.f.resolveDocumentLink(H,$);if(!(!j||!we.g(j)))return y.DocumentLink.from(j)}releaseLinks(I){this.d.delete(I)}}class Me{constructor(I,$){this.d=I,this.e=$}async provideColors(I,$){const H=this.d.getDocument(I),j=await this.e.provideDocumentColors(H,$);return Array.isArray(j)?j.map(de=>({color:y.Color.from(de.color),range:y.Range.from(de.range)})):[]}async provideColorPresentations(I,$,H){const j=this.d.getDocument(I),Z=y.Range.to($.range),de=y.Color.to($.color),Se=await this.e.provideColorPresentations(de,{document:j,range:Z},H);if(!!Array.isArray(Se))return Se.map(y.ColorPresentation.from)}}class We{constructor(I,$){this.d=I,this.e=$}async provideFoldingRanges(I,$,H){const j=this.d.getDocument(I),Z=await this.e.provideFoldingRanges(j,$,H);if(!!Array.isArray(Z))return Z.map(y.FoldingRange.from)}}class Qe{constructor(I,$,H){this.d=I,this.e=$,this.f=H}async provideSelectionRanges(I,$,H){const j=this.d.getDocument(I),Z=$.map(y.Position.to),de=await this.e.provideSelectionRanges(j,Z,H);if(!(0,M.isNonEmptyArray)(de))return[];if(de.length!==Z.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Se=[];for(let ae=0;ae<Z.length;ae++){const ve=[];Se.push(ve);let be=Z[ae],$e=de[ae];for(;;){if(!$e.range.contains(be))throw new Error("INVALID selection range, must contain the previous range");if(ve.push(y.SelectionRange.from($e)),!$e.parent)break;be=$e.range,$e=$e.parent}}return Se}}class Te{constructor(I,$){this.f=I,this.g=$,this.d=new c.IdGenerator(""),this.e=new Map}async prepareSession(I,$,H){const j=this.f.getDocument(I),Z=y.Position.to($),de=await this.g.prepareCallHierarchy(j,Z,H);if(!de)return;const Se=this.d.nextId();return this.e.set(Se,new Map),Array.isArray(de)?de.map(ae=>this.h(Se,ae)):[this.h(Se,de)]}async provideCallsTo(I,$,H){const j=this.j(I,$);if(!j)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyIncomingCalls(j,H);if(!!Z)return Z.map(de=>({from:this.h(I,de.from),fromRanges:de.fromRanges.map(Se=>y.Range.from(Se))}))}async provideCallsFrom(I,$,H){const j=this.j(I,$);if(!j)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyOutgoingCalls(j,H);if(!!Z)return Z.map(de=>({to:this.h(I,de.to),fromRanges:de.fromRanges.map(Se=>y.Range.from(Se))}))}releaseSession(I){this.e.delete(I)}h(I,$){const H=this.e.get(I),j=y.CallHierarchyItem.from($,I,H.size.toString(36));return H.set(j._itemId,$),j}j(I,$){return this.e.get(I)?.get($)}}class De{constructor(I,$){this.f=I,this.g=$,this.d=new c.IdGenerator(""),this.e=new Map}async prepareSession(I,$,H){const j=this.f.getDocument(I),Z=y.Position.to($),de=await this.g.prepareTypeHierarchy(j,Z,H);if(!de)return;const Se=this.d.nextId();return this.e.set(Se,new Map),Array.isArray(de)?de.map(ae=>this.h(Se,ae)):[this.h(Se,de)]}async provideSupertypes(I,$,H){const j=this.j(I,$);if(!j)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySupertypes(j,H);if(!!Z)return Z.map(de=>this.h(I,de))}async provideSubtypes(I,$,H){const j=this.j(I,$);if(!j)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySubtypes(j,H);if(!!Z)return Z.map(de=>this.h(I,de))}releaseSession(I){this.e.delete(I)}h(I,$){const H=this.e.get(I),j=y.TypeHierarchyItem.from($,I,H.size.toString(36));return H.set(j._itemId,$),j}j(I,$){return this.e.get(I)?.get($)}}class ke{constructor(I,$,H,j){this.d=I,this.e=$,this.f=H,this.g=j}async provideDocumentOnDropEdits(I,$,H,j,Z){const de=this.e.getDocument($),Se=y.Position.to(H),ae=y.DataTransfer.toDataTransfer(j,async be=>(await this.d.$resolveDocumentOnDropFileData(this.g,I,be)).buffer),ve=await this.f.provideDocumentDropEdits(de,Se,ae,Z);if(!!ve)return{insertText:typeof ve.insertText=="string"?ve.insertText:{snippet:ve.insertText.value},additionalEdit:ve.additionalEdit?y.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}}class oe{constructor(I,$){this.adapter=I,this.extension=$}}class ce{constructor(I,$,H,j,Z,de,Se,ae){this.g=$,this.h=H,this.j=j,this.k=Z,this.l=de,this.m=Se,this.n=ae,this.f=new Map,this.e=I.getProxy(A.MainContext.MainThreadLanguageFeatures)}o(I){return y.DocumentSelector.from(I,this.g)}p(I){return new L.Disposable(()=>{this.f.delete(I),this.e.$unregister(I)})}q(){return ce.d++}async s(I,$,H,j,Z,de=!1){const Se=this.f.get(I);if(!Se||!(Se.adapter instanceof $))return j;const ae=Date.now();de||this.l.trace(`[${Se.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const ve=H(Se.adapter,Se.extension);return Promise.resolve(ve).catch(be=>{(0,E.isCancellationError)(be)||(this.l.error(`[${Se.extension.identifier.value}] provider FAILED`),this.l.error(be),this.n.onExtensionError(Se.extension.identifier,be))}).finally(()=>{de||this.l.trace(`[${Se.extension.identifier.value}] provider DONE after ${Date.now()-ae}ms`)}),b.CancellationToken.isCancellationToken(Z)?(0,v.raceCancellationError)(ve,Z):ve}t(I,$){const H=this.q();return this.f.set(H,new oe(I,$)),H}static u(I){return I.displayName||I.name}registerDocumentSymbolProvider(I,$,H,j){const Z=this.t(new s(this.h,H),I),de=j&&j.label||ce.u(I);return this.e.$registerDocumentSymbolProvider(Z,this.o($),de),this.p(Z)}$provideDocumentSymbols(I,$,H){return this.s(I,s,j=>j.provideDocumentSymbols(i.URI.revive($),H),void 0,H)}registerCodeLensProvider(I,$,H){const j=this.q(),Z=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(j,new oe(new r(this.h,this.j.converter,H),I)),this.e.$registerCodeLensSupport(j,this.o($),Z);let de=this.p(j);if(Z!==void 0){const Se=H.onDidChangeCodeLenses(ae=>this.e.$emitCodeLensEvent(Z));de=L.Disposable.from(de,Se)}return de}$provideCodeLenses(I,$,H){return this.s(I,r,j=>j.provideCodeLenses(i.URI.revive($),H),void 0,H)}$resolveCodeLens(I,$,H){return this.s(I,r,j=>j.resolveCodeLens($,H),void 0,void 0)}$releaseCodeLenses(I,$){this.s(I,r,H=>Promise.resolve(H.releaseCodeLenses($)),void 0,void 0)}registerDefinitionProvider(I,$,H){const j=this.t(new h(this.h,H),I);return this.e.$registerDefinitionSupport(j,this.o($)),this.p(j)}$provideDefinition(I,$,H,j){return this.s(I,h,Z=>Z.provideDefinition(i.URI.revive($),H,j),[],j)}registerDeclarationProvider(I,$,H){const j=this.t(new a(this.h,H),I);return this.e.$registerDeclarationSupport(j,this.o($)),this.p(j)}$provideDeclaration(I,$,H,j){return this.s(I,a,Z=>Z.provideDeclaration(i.URI.revive($),H,j),[],j)}registerImplementationProvider(I,$,H){const j=this.t(new l(this.h,H),I);return this.e.$registerImplementationSupport(j,this.o($)),this.p(j)}$provideImplementation(I,$,H,j){return this.s(I,l,Z=>Z.provideImplementation(i.URI.revive($),H,j),[],j)}registerTypeDefinitionProvider(I,$,H){const j=this.t(new n(this.h,H),I);return this.e.$registerTypeDefinitionSupport(j,this.o($)),this.p(j)}$provideTypeDefinition(I,$,H,j){return this.s(I,n,Z=>Z.provideTypeDefinition(i.URI.revive($),H,j),[],j)}registerHoverProvider(I,$,H,j){const Z=this.t(new d(this.h,H),I);return this.e.$registerHoverProvider(Z,this.o($)),this.p(Z)}$provideHover(I,$,H,j){return this.s(I,d,Z=>Z.provideHover(i.URI.revive($),H,j),void 0,j)}registerEvaluatableExpressionProvider(I,$,H,j){const Z=this.t(new g(this.h,H),I);return this.e.$registerEvaluatableExpressionProvider(Z,this.o($)),this.p(Z)}$provideEvaluatableExpression(I,$,H,j){return this.s(I,g,Z=>Z.provideEvaluatableExpression(i.URI.revive($),H,j),void 0,j)}registerInlineValuesProvider(I,$,H,j){const Z=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,de=this.t(new O(this.h,H),I);this.e.$registerInlineValuesProvider(de,this.o($),Z);let Se=this.p(de);if(Z!==void 0){const ae=H.onDidChangeInlineValues(ve=>this.e.$emitInlineValuesEvent(Z));Se=L.Disposable.from(Se,ae)}return Se}$provideInlineValues(I,$,H,j,Z){return this.s(I,O,de=>de.provideInlineValues(i.URI.revive($),H,j,Z),void 0,Z)}registerDocumentHighlightProvider(I,$,H){const j=this.t(new N(this.h,H),I);return this.e.$registerDocumentHighlightProvider(j,this.o($)),this.p(j)}$provideDocumentHighlights(I,$,H,j){return this.s(I,N,Z=>Z.provideDocumentHighlights(i.URI.revive($),H,j),void 0,j)}registerLinkedEditingRangeProvider(I,$,H){const j=this.t(new q(this.h,H),I);return this.e.$registerLinkedEditingRangeProvider(j,this.o($)),this.p(j)}$provideLinkedEditingRanges(I,$,H,j){return this.s(I,q,async Z=>{const de=await Z.provideLinkedEditingRanges(i.URI.revive($),H,j);if(de)return{ranges:de.ranges,wordPattern:de.wordPattern?ce.w(de.wordPattern):void 0}},void 0,j)}registerReferenceProvider(I,$,H){const j=this.t(new J(this.h,H),I);return this.e.$registerReferenceSupport(j,this.o($)),this.p(j)}$provideReferences(I,$,H,j,Z){return this.s(I,J,de=>de.provideReferences(i.URI.revive($),H,j,Z),void 0,Z)}registerCodeActionProvider(I,$,H,j){const Z=new f.DisposableStore,de=this.t(new x(this.h,this.j.converter,this.k,H,this.l,I,this.m),I);return this.e.$registerQuickFixSupport(de,this.o($),{providedKinds:j?.providedCodeActionKinds?.map(Se=>Se.value),documentation:j?.documentation?.map(Se=>({kind:Se.kind.value,command:this.j.converter.toInternal(Se.command,Z)}))},ce.u(I),Boolean(H.resolveCodeAction)),Z.add(this.p(de)),Z}$provideCodeActions(I,$,H,j,Z){return this.s(I,x,de=>de.provideCodeActions(i.URI.revive($),H,j,Z),void 0,Z)}$resolveCodeAction(I,$,H){return this.s(I,x,j=>j.resolveCodeAction($,H),void 0,void 0)}$releaseCodeActions(I,$){this.s(I,x,H=>Promise.resolve(H.releaseCodeActions($)),void 0,void 0)}registerDocumentFormattingEditProvider(I,$,H){const j=this.t(new P(this.h,H),I);return this.e.$registerDocumentFormattingSupport(j,this.o($),I.identifier,I.displayName||I.name),this.p(j)}$provideDocumentFormattingEdits(I,$,H,j){return this.s(I,P,Z=>Z.provideDocumentFormattingEdits(i.URI.revive($),H,j),void 0,j)}registerDocumentRangeFormattingEditProvider(I,$,H){const j=this.t(new F(this.h,H),I);return this.e.$registerRangeFormattingSupport(j,this.o($),I.identifier,I.displayName||I.name),this.p(j)}$provideDocumentRangeFormattingEdits(I,$,H,j,Z){return this.s(I,F,de=>de.provideDocumentRangeFormattingEdits(i.URI.revive($),H,j,Z),void 0,Z)}registerOnTypeFormattingEditProvider(I,$,H,j){const Z=this.t(new B(this.h,H),I);return this.e.$registerOnTypeFormattingSupport(Z,this.o($),j,I.identifier),this.p(Z)}$provideOnTypeFormattingEdits(I,$,H,j,Z,de){return this.s(I,B,Se=>Se.provideOnTypeFormattingEdits(i.URI.revive($),H,j,Z,de),void 0,de)}registerWorkspaceSymbolProvider(I,$){const H=this.t(new z($,this.l),I);return this.e.$registerNavigateTypeSupport(H,typeof $.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(I,$,H){return this.s(I,z,j=>j.provideWorkspaceSymbols($,H),{symbols:[]},H)}$resolveWorkspaceSymbol(I,$,H){return this.s(I,z,j=>j.resolveWorkspaceSymbol($,H),void 0,void 0)}$releaseWorkspaceSymbols(I,$){this.s(I,z,H=>H.releaseWorkspaceSymbols($),void 0,void 0)}registerRenameProvider(I,$,H){const j=this.t(new V(this.h,H,this.l),I);return this.e.$registerRenameSupport(j,this.o($),V.supportsResolving(H)),this.p(j)}$provideRenameEdits(I,$,H,j,Z){return this.s(I,V,de=>de.provideRenameEdits(i.URI.revive($),H,j,Z),void 0,Z)}$resolveRenameLocation(I,$,H,j){return this.s(I,V,Z=>Z.resolveRenameLocation(i.URI.revive($),H,j),void 0,j)}registerDocumentSemanticTokensProvider(I,$,H,j){const Z=this.t(new ie(this.h,H),I),de=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Z,this.o($),j,de);let Se=this.p(Z);if(de){const ae=H.onDidChangeSemanticTokens(ve=>this.e.$emitDocumentSemanticTokensEvent(de));Se=L.Disposable.from(Se,ae)}return Se}$provideDocumentSemanticTokens(I,$,H,j){return this.s(I,ie,Z=>Z.provideDocumentSemanticTokens(i.URI.revive($),H,j),null,j)}$releaseDocumentSemanticTokens(I,$){this.s(I,ie,H=>H.releaseDocumentSemanticColoring($),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(I,$,H,j){const Z=this.t(new ge(this.h,H),I);return this.e.$registerDocumentRangeSemanticTokensProvider(Z,this.o($),j),this.p(Z)}$provideDocumentRangeSemanticTokens(I,$,H,j){return this.s(I,ge,Z=>Z.provideDocumentRangeSemanticTokens(i.URI.revive($),H,j),null,j)}registerCompletionItemProvider(I,$,H,j){const Z=this.t(new ue(this.h,this.j.converter,H,this.m,I),I);return this.e.$registerCompletionsProvider(Z,this.o($),j,ue.supportsResolving(H),`${I.identifier.value}(${j.join("")})`),this.p(Z)}$provideCompletionItems(I,$,H,j,Z){return this.s(I,ue,de=>de.provideCompletionItems(i.URI.revive($),H,j,Z),void 0,Z)}$resolveCompletionItem(I,$,H){return this.s(I,ue,j=>j.resolveCompletionItem($,H),void 0,H)}$releaseCompletionItems(I,$){this.s(I,ue,H=>H.releaseCompletionItems($),void 0,void 0)}registerInlineCompletionsProvider(I,$,H){const j=new se(I,this.h,H,this.j.converter),Z=this.t(j,I);return this.e.$registerInlineCompletionsSupport(Z,this.o($),j.supportsHandleDidShowCompletionItem),this.p(Z)}$provideInlineCompletions(I,$,H,j,Z){return this.s(I,re,de=>de.provideInlineCompletions(i.URI.revive($),H,j,Z),void 0,Z)}$handleInlineCompletionDidShow(I,$,H){this.s(I,re,async j=>{j.handleDidShowCompletionItem($,H)},void 0,void 0)}$freeInlineCompletionsList(I,$){this.s(I,re,async H=>{H.disposeCompletions($)},void 0,void 0)}registerSignatureHelpProvider(I,$,H,j){const Z=Array.isArray(j)?{triggerCharacters:j,retriggerCharacters:[]}:j,de=this.t(new _(this.h,H),I);return this.e.$registerSignatureHelpProvider(de,this.o($),Z),this.p(de)}$provideSignatureHelp(I,$,H,j,Z){return this.s(I,_,de=>de.provideSignatureHelp(i.URI.revive($),H,j,Z),void 0,Z)}$releaseSignatureHelp(I,$){this.s(I,_,H=>H.releaseSignatureHelp($),void 0,void 0)}registerInlayHintsProvider(I,$,H){const j=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,Z=this.t(new me(this.h,this.j.converter,H,this.l,I),I);this.e.$registerInlayHintsProvider(Z,this.o($),typeof H.resolveInlayHint=="function",j,ce.u(I));let de=this.p(Z);if(j!==void 0){const Se=H.onDidChangeInlayHints(ae=>this.e.$emitInlayHintsEvent(j));de=L.Disposable.from(de,Se)}return de}$provideInlayHints(I,$,H,j){return this.s(I,me,Z=>Z.provideInlayHints(i.URI.revive($),H,j),void 0,j)}$resolveInlayHint(I,$,H){return this.s(I,me,j=>j.resolveInlayHint($,H),void 0,H)}$releaseInlayHints(I,$){this.s(I,me,H=>H.releaseHints($),void 0,void 0)}registerDocumentLinkProvider(I,$,H){const j=this.t(new we(this.h,H),I);return this.e.$registerDocumentLinkProvider(j,this.o($),typeof H.resolveDocumentLink=="function"),this.p(j)}$provideDocumentLinks(I,$,H){return this.s(I,we,j=>j.provideLinks(i.URI.revive($),H),void 0,H,$.scheme==="output")}$resolveDocumentLink(I,$,H){return this.s(I,we,j=>j.resolveLink($,H),void 0,void 0,!0)}$releaseDocumentLinks(I,$){this.s(I,we,H=>H.releaseLinks($),void 0,void 0,!0)}registerColorProvider(I,$,H){const j=this.t(new Me(this.h,H),I);return this.e.$registerDocumentColorProvider(j,this.o($)),this.p(j)}$provideDocumentColors(I,$,H){return this.s(I,Me,j=>j.provideColors(i.URI.revive($),H),[],H)}$provideColorPresentations(I,$,H,j){return this.s(I,Me,Z=>Z.provideColorPresentations(i.URI.revive($),H,j),void 0,j)}registerFoldingRangeProvider(I,$,H){const j=this.q(),Z=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(j,new oe(new We(this.h,H),I)),this.e.$registerFoldingRangeProvider(j,this.o($),I.identifier,Z);let de=this.p(j);if(Z!==void 0){const Se=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Z));de=L.Disposable.from(de,Se)}return de}$provideFoldingRanges(I,$,H,j){return this.s(I,We,Z=>Z.provideFoldingRanges(i.URI.revive($),H,j),void 0,j)}registerSelectionRangeProvider(I,$,H){const j=this.t(new Qe(this.h,H,this.l),I);return this.e.$registerSelectionRangeProvider(j,this.o($)),this.p(j)}$provideSelectionRanges(I,$,H,j){return this.s(I,Qe,Z=>Z.provideSelectionRanges(i.URI.revive($),H,j),[],j)}registerCallHierarchyProvider(I,$,H){const j=this.t(new Te(this.h,H),I);return this.e.$registerCallHierarchyProvider(j,this.o($)),this.p(j)}$prepareCallHierarchy(I,$,H,j){return this.s(I,Te,Z=>Promise.resolve(Z.prepareSession(i.URI.revive($),H,j)),void 0,j)}$provideCallHierarchyIncomingCalls(I,$,H,j){return this.s(I,Te,Z=>Z.provideCallsTo($,H,j),void 0,j)}$provideCallHierarchyOutgoingCalls(I,$,H,j){return this.s(I,Te,Z=>Z.provideCallsFrom($,H,j),void 0,j)}$releaseCallHierarchy(I,$){this.s(I,Te,H=>Promise.resolve(H.releaseSession($)),void 0,void 0)}registerTypeHierarchyProvider(I,$,H){const j=this.t(new De(this.h,H),I);return this.e.$registerTypeHierarchyProvider(j,this.o($)),this.p(j)}$prepareTypeHierarchy(I,$,H,j){return this.s(I,De,Z=>Promise.resolve(Z.prepareSession(i.URI.revive($),H,j)),void 0,j)}$provideTypeHierarchySupertypes(I,$,H,j){return this.s(I,De,Z=>Z.provideSupertypes($,H,j),void 0,j)}$provideTypeHierarchySubtypes(I,$,H,j){return this.s(I,De,Z=>Z.provideSubtypes($,H,j),void 0,j)}$releaseTypeHierarchy(I,$){this.s(I,De,H=>Promise.resolve(H.releaseSession($)),void 0,void 0)}registerDocumentOnDropEditProvider(I,$,H){const j=this.q();return this.f.set(j,new oe(new ke(this.e,this.h,H,j),I)),this.e.$registerDocumentOnDropEditProvider(j,this.o($)),this.p(j)}$provideDocumentOnDropEdits(I,$,H,j,Z,de){return this.s(I,ke,Se=>Promise.resolve(Se.provideDocumentOnDropEdits($,i.URI.revive(H),j,Z,de)),void 0,void 0)}registerDocumentPasteEditProvider(I,$,H,j){const Z=this.q();return this.f.set(Z,new oe(new R(this.e,this.h,H,Z),I)),this.e.$registerPasteEditProvider(Z,this.o($),!!H.prepareDocumentPaste,j.pasteMimeTypes),this.p(Z)}$prepareDocumentPaste(I,$,H,j,Z){return this.s(I,R,de=>de.prepareDocumentPaste(i.URI.revive($),H,j,Z),void 0,Z)}$providePasteEdits(I,$,H,j,Z,de){return this.s(I,R,Se=>Se.providePasteEdits($,i.URI.revive(H),j,Z,de),void 0,de)}static w(I){return{pattern:I.source,flags:(0,S.regExpFlags)(I)}}static y(I){return{decreaseIndentPattern:ce.w(I.decreaseIndentPattern),increaseIndentPattern:ce.w(I.increaseIndentPattern),indentNextLinePattern:I.indentNextLinePattern?ce.w(I.indentNextLinePattern):void 0,unIndentedLinePattern:I.unIndentedLinePattern?ce.w(I.unIndentedLinePattern):void 0}}static z(I){return{beforeText:ce.w(I.beforeText),afterText:I.afterText?ce.w(I.afterText):void 0,previousLineText:I.previousLineText?ce.w(I.previousLineText):void 0,action:I.action}}static B(I){return I.map(ce.z)}setLanguageConfiguration(I,$,H){const{wordPattern:j}=H;if(j&&(0,S.regExpLeadsToEndlessLoop)(j))throw new Error(`Invalid language configuration: wordPattern '${j}' is not allowed to match the empty string.`);j?this.h.setWordDefinitionFor($,j):this.h.setWordDefinitionFor($,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",I,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",I,"Do not use.");const Z=this.q(),de={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?ce.w(H.wordPattern):void 0,indentationRules:H.indentationRules?ce.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?ce.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport};return this.e.$setLanguageConfiguration(Z,$,de),this.p(Z)}$setWordDefinitions(I){for(const $ of I)this.h.setWordDefinitionFor($.languageId,new RegExp($.regexSource,$.regexFlags))}}e.ExtHostLanguageFeatures=ce,ce.d=0}),define(Ie[211],Ce([1,0,4,8,6,29,14,7]),function(ee,e,i,T,y,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(M,D,m,b){this.c=D,this.d=m,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=M.getProxy(i.MainContext.MainThreadLanguages)}$acceptLanguageIds(M){this.b=M}async getLanguages(){return this.b.slice(0)}async changeLanguage(M,D){await this.a.$changeLanguage(M,D);const m=this.c.getDocumentData(M);if(!m)throw new Error(`document '${M.toString()}' NOT found`);return m.document}async tokenAtPosition(M,D){const m=M.version,b=T.Position.from(D),f=await this.a.$tokensAtPosition(M.uri,b),t={type:y.StandardTokenType.Other,range:M.getWordRangeAtPosition(D)??new y.Range(D.line,D.character,D.line,D.character)};if(!f)return t;const c={range:T.Range.to(f.range),type:T.TokenType.to(f.type)};return!c.range.contains(D)||m!==M.version?t:c}createLanguageStatusItem(M,D,m){const b=this.f++,f=this.a,t=this.g,c=`${M.identifier.value}/${D}`;if(t.has(c))throw new Error(`LanguageStatusItem with id '${D}' ALREADY exists`);t.add(c);const u={selector:m,id:D,name:M.displayName??M.name,severity:y.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let p;const E=new A.DisposableStore,v=()=>{p?.dispose(),p=(0,C.disposableTimeout)(()=>{E.clear(),this.a.$setLanguageStatus(b,{id:c,name:u.name??M.displayName??M.name,source:M.displayName??M.name,selector:T.DocumentSelector.from(u.selector,this.e),label:u.text,detail:u.detail??"",severity:u.severity===y.LanguageStatusSeverity.Error?L.default.Error:u.severity===y.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:u.command&&this.d.toInternal(u.command,E),accessibilityInfo:u.accessibilityInformation,busy:u.busy})},0)},w={dispose(){E.dispose(),p?.dispose(),f.$removeLanguageStatus(b),t.delete(c)},get id(){return u.id},get name(){return u.name},set name(s){u.name=s,v()},get selector(){return u.selector},set selector(s){u.selector=s,v()},get text(){return u.text},set text(s){u.text=s,v()},get detail(){return u.detail},set detail(s){u.detail=s,v()},get severity(){return u.severity},set severity(s){u.severity=s,v()},get accessibilityInformation(){return u.accessibilityInformation},set accessibilityInformation(s){u.accessibilityInformation=s,v()},get command(){return u.command},set command(s){u.command=s,v()},get busy(){return u.busy},set busy(s){u.busy=s,v()}};return v(),w}}e.ExtHostLanguages=S}),define(Ie[73],Ce([1,0,21,10,2,3,12,4,27,15]),function(ee,e,i,T,y,L,C,A,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let M=class{constructor(m,b,f){this.f=f,this.d=new Map,this.a=b.getProxy(A.MainContext.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===i.LANGUAGE_DEFAULT}getMessage(m,b){const{message:f,args:t,comment:c}=b;if(this.c)return(0,T.format2)(f,t??{});let u=f;c&&c.length>0&&(u+=`/${Array.isArray(c)?c.join():c}`);const p=this.d.get(m)?.contents[u];return p||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${u}`),(0,T.format2)(p??f,t??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let b;const f=await this.g(m);if(!f){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const t=await this.a.$fetchBundleContents(f),c=JSON.parse(t);b=m.isBuiltin?c.contents?.bundle:c}catch(t){this.f.error(`Failed to load translations for ${m.identifier.value} from ${f}: ${t.message}`);return}b&&this.d.set(m.identifier.value,{contents:b,uri:f})}async g(m){if(m.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(m.identifier.value);return y.URI.revive(b)}return m.l10n?y.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};M=qe([Ve(0,S.IExtHostInitDataService),Ve(1,k.IExtHostRpcService),Ve(2,C.ILogService)],M),e.ExtHostLocalizationService=M,e.IExtHostLocalizationService=(0,L.createDecorator)("IExtHostLocalizationService")}),define(Ie[212],Ce([1,0,12,4,27,15,2,5,9]),function(ee,e,i,T,y,L,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends i.AbstractLoggerService{constructor(m,b){super(b.logLevel,A.Event.None),this.g=m.getProxy(T.MainContext.MainThreadLogger)}$setLevel(m,b){b?this.setLevel(C.URI.revive(b),m):(0,S.isUndefined)(m)||this.setLevel(m)}f(m,b,f){return new M(this.g,m,b,f)}};k=qe([Ve(0,L.IExtHostRpcService),Ve(1,y.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class M extends i.AbstractMessageLogger{constructor(m,b,f,t){super(t?.always),this.m=m,this.n=b,this.k=!1,this.l=[],this.setLevel(f),this.m.$createLogger(b,t).then(()=>{this.r(this.l),this.k=!0})}g(m,b){const f=[[m,b]];this.k?this.r(f):this.l.push(...f)}r(m){this.m.$log(this.n,m)}}}),define(Ie[213],Ce([1,0,4,12,25]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function L(A){return A&&A.title}let C=class{constructor(S,k){this.b=k,this.a=S.getProxy(i.MainContext.MainThreadMessageService)}showMessage(S,k,M,D,m){const b={source:{identifier:S.identifier,label:S.displayName||S.name}};let f;typeof D=="string"||L(D)?f=[D,...m]:(b.modal=D?.modal,b.useCustom=D?.useCustom,b.detail=D?.detail,f=m),b.useCustom&&(0,y.checkProposedApiEnabled)(S,"resolvers");const t=[];for(let c=0;c<f.length;c++){const u=f[c];if(typeof u=="string")t.push({title:u,handle:c,isCloseAffordance:!1});else if(typeof u=="object"){const{title:p,isCloseAffordance:E}=u;t.push({title:p,isCloseAffordance:!!E,handle:c})}else this.b.warn("Invalid message item:",u)}return this.a.$showMessage(k,M,b,t).then(c=>{if(typeof c=="number")return f[c]})}};C=qe([Ve(1,T.ILogService)],C),e.ExtHostMessageService=C}),define(Ie[214],Ce([1,0,24,5,7,28,10,9,2,51,4,38,8,6,43,187,97]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m,b,f,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class u{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(E=>E.apiEditor)}constructor(E,v,w,s){this.q=w,this.r=s,this.f=new Map,this.g=new L.ResourceMap,this.h=new Map,this.j=new T.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new T.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new T.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=E.getProxy(M.MainContext.MainThreadNotebook),this.c=E.getProxy(M.MainContext.MainThreadNotebookDocuments),this.d=E.getProxy(M.MainContext.MainThreadNotebookEditors),this.i=v.converter,v.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===13){const o=r.notebookEditor?.notebookUri,h=r.cell.handle,l=this.g.get(o)?.getCell(h);if(l)return l.apiCell}if(r&&r.$mid===14){const o=r.uri,h=this.g.get(o);if(h)return h.apiNotebook}return r}}),u.x(v)}getEditorById(E){const v=this.h.get(E);if(!v)throw new Error(`unknown text editor: ${E}. known editors: ${[...this.h.keys()]} `);return v}getIdByEditor(E){for(const[v,w]of this.h)if(w.apiEditor===E)return v}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(E,v){const w=this.g.get(E);if(!w&&!v)throw new Error(`NO notebook document for '${E}'`);return w}static s(E,v){if(!v)return;const w=v.filenamePattern.map(s=>m.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(v.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${v.filenamePattern}`);return}return{extension:E.identifier,providerDisplayName:E.displayName||E.name,displayName:v.displayName,filenamePattern:w,exclusive:v.exclusive||!1}}registerNotebookCellStatusBarItemProvider(E,v,w){const s=u.a++,r=typeof w.onDidChangeCellStatusBarItems=="function"?u.a++:void 0;this.f.set(s,w),this.b.$registerNotebookCellStatusBarItemProvider(s,r,v);let o;return r!==void 0&&(o=w.onDidChangeCellStatusBarItems(h=>this.b.$emitCellStatusBarEvent(r))),new b.Disposable(()=>{this.f.delete(s),this.b.$unregisterNotebookCellStatusBarItemProvider(s,r),o?.dispose()})}async createNotebookDocument(E){const v=await this.c.$tryCreateNotebook({viewType:E.viewType,content:E.content&&m.NotebookData.from(E.content)});return S.URI.revive(v)}async openNotebookDocument(E){const v=this.g.get(E);if(v)return v.apiNotebook;const w=await this.c.$tryOpenNotebook(E),s=this.g.get(S.URI.revive(w));return(0,A.assertIsDefined)(s?.apiNotebook)}async showNotebookDocument(E,v){S.URI.isUri(E)&&(E=await this.openNotebookDocument(E));let w;typeof v=="object"?w={position:m.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selections:v.selections&&v.selections.map(m.NotebookRange.from),pinned:typeof v.preview=="boolean"?!v.preview:void 0}:w={preserveFocus:!1};const s=await this.d.$tryShowNotebookDocument(E.uri,E.notebookType,w),r=s&&this.h.get(s)?.apiEditor;if(r)return r;throw s?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(E,v,w,s){const r=this.f.get(E),o=S.URI.revive(v),h=this.g.get(o);if(!h||!r)return;const a=h.getCellFromIndex(w);if(!a)return;const l=await r.provideCellStatusBarItems(a.apiCell,s);if(!l)return;const n=new y.DisposableStore,d=this.p.add([n]),O=(Array.isArray(l)?l:[l]).map(N=>m.NotebookStatusBarItem.from(N,this.i,n));return{cacheId:d,items:O}}$releaseNotebookCellStatusBarItems(E){this.p.delete(E)}registerNotebookSerializer(E,v,w,s,r){if((0,C.isFalsyOrWhitespace)(v))throw new Error("viewType cannot be empty or just whitespace");const o=this.t++;return this.u.set(o,w),this.b.$registerNotebookSerializer(o,{id:E.identifier,location:E.extensionLocation},v,m.NotebookDocumentContentOptions.from(s),u.s(E,r)),(0,y.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(o)})}async $dataToNotebook(E,v,w){const s=this.u.get(E);if(!s)throw new Error("NO serializer found");const r=await s.deserializeNotebook(v.buffer,w);return new f.SerializableObjectWithBuffers(m.NotebookData.from(r))}async $notebookToData(E,v,w){const s=this.u.get(E);if(!s)throw new Error("NO serializer found");const r=await s.serializeNotebook(m.NotebookData.to(v.value),w);return i.VSBuffer.wrap(r)}w(E,v,w){if(this.h.has(v))throw new Error(`editor with id ALREADY EXSIST: ${v}`);const s=new c.ExtHostNotebookEditor(v,this.d,E,w.visibleRanges.map(m.NotebookRange.to),w.selections.map(m.NotebookRange.to),typeof w.viewColumn=="number"?m.ViewColumn.to(w.viewColumn):void 0);this.h.set(v,s)}$acceptDocumentAndEditorsDelta(E){if(E.value.removedDocuments)for(const w of E.value.removedDocuments){const s=S.URI.revive(w),r=this.g.get(s);r&&(r.dispose(),this.g.delete(s),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(o=>o.document.uri)}),this.n.fire(r.apiNotebook));for(const o of this.h.values())o.notebookData.uri.toString()===s.toString()&&this.h.delete(o.id)}if(E.value.addedDocuments){const w=[];for(const s of E.value.addedDocuments){const r=S.URI.revive(s.uri);if(this.g.has(r))throw new Error(`adding EXISTING notebook ${r} `);const o=new t.ExtHostNotebookDocument(this.c,this.q,this.r,r,s);w.push(...s.cells.map(h=>t.ExtHostCell.asModelAddData(o.apiNotebook,h))),this.g.get(r)?.dispose(),this.g.set(r,o),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this.m.fire(o.apiNotebook)}}if(E.value.addedEditors)for(const w of E.value.addedEditors){if(this.h.has(w.id))return;const s=S.URI.revive(w.documentUri),r=this.g.get(s);r&&this.w(r,w.id,w)}const v=[];if(E.value.removedEditors)for(const w of E.value.removedEditors){const s=this.h.get(w);s&&(this.h.delete(w),this.k?.id===s.id&&(this.k=void 0),v.push(s))}if(E.value.visibleEditors){this.l=E.value.visibleEditors.map(s=>this.h.get(s)).filter(s=>!!s);const w=new Set;this.l.forEach(s=>w.add(s.id));for(const s of this.h.values()){const r=w.has(s.id);s._acceptVisibility(r)}this.l=[...this.h.values()].map(s=>s).filter(s=>s.visible),this.o.fire(this.visibleNotebookEditors)}E.value.newActiveEditor===null?this.k=void 0:E.value.newActiveEditor&&(this.k=this.h.get(E.value.newActiveEditor)),E.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(E){const v=D.ApiCommandArgument.String.with("notebookType","A notebook type"),w=new D.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[v,new D.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>i.VSBuffer.wrap(r))],new D.ApiCommandResult("Notebook Data",r=>m.NotebookData.to(r.value))),s=new D.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[v,new D.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new f.SerializableObjectWithBuffers(m.NotebookData.from(r)))],new D.ApiCommandResult("Bytes",r=>r.buffer));E.registerApiCommand(w),E.registerApiCommand(s)}}e.ExtHostNotebookController=u,u.a=0}),define(Ie[215],Ce([1,0,16,14,20,5,7,28,2,26,12,51,4,38,8,6,68,175,25,43]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m,b,f,t,c,u,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let v=class{constructor(a,l,n,d,g){this.k=l,this.l=n,this.m=d,this.n=g,this.b=new A.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new D.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=a.getProxy(m.MainContext.MainThreadNotebookKernels);const O=new b.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new b.ApiCommandArgument("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const q=this.l.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:q}}else if(N&&"notebookEditor"in N){const q=this.l.getIdByEditor(N.notebookEditor);if(q===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:q}}return N})],b.ApiCommandResult.Void);this.m.registerApiCommand(O)}createNotebookController(a,l,n,d,g,O){for(const re of this.h.values())if(re.controller.id===l&&k.ExtensionIdentifier.equals(a.identifier,re.extensionId))throw new Error(`notebook controller with id '${l}' ALREADY exist`);const N=this.i++,q=this;this.n.trace(`NotebookController[${N}], CREATED by ${a.identifier.value}, ${l}`);const J=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${a.identifier}'`);let x=!1;const R=new C.DisposableStore,P=new L.Emitter,F=new L.Emitter,B={id:o(a.identifier,l),notebookType:n,extensionId:a.identifier,extensionLocation:a.extensionLocation,label:d||a.identifier.value,preloads:O?O.map(f.NotebookRendererScript.from):[]};let z=g??J,V;this.a.$addKernel(N,B).catch(re=>{console.log(re),x=!0});let K=0;const ie=()=>{if(x)return;const re=++K;Promise.resolve().then(()=>{re===K&&this.a.$updateKernel(N,B)})},ge=new A.ResourceMap,ue={get id(){return l},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:P.event,get label(){return B.label},set label(re){B.label=re??a.displayName??a.name,ie()},get detail(){return B.detail??""},set detail(re){B.detail=re,ie()},get description(){return B.description??""},set description(re){B.description=re,ie()},get kind(){return(0,p.checkProposedApiEnabled)(a,"notebookControllerKind"),B.kind??""},set kind(re){(0,p.checkProposedApiEnabled)(a,"notebookControllerKind"),B.kind=re,ie()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(re){B.supportedLanguages=re,ie()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(re){B.supportsExecutionOrder=re,ie()},get rendererScripts(){return B.preloads?B.preloads.map(f.NotebookRendererScript.to):[]},get executeHandler(){return z},set executeHandler(re){z=re??J},get interruptHandler(){return V},set interruptHandler(re){V=re,B.supportsInterrupt=Boolean(re),ie()},createNotebookCellExecution(re){if(x)throw new Error("notebook controller is DISPOSED");if(!ge.has(re.notebook.uri))throw q.n.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ge.keys()).map(se=>se.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return q._createNotebookCellExecution(re,o(a.identifier,this.id))},dispose:()=>{x||(this.n.trace(`NotebookController[${N}], DISPOSED`),x=!0,this.h.delete(N),R.dispose(),P.dispose(),F.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity(re,se){se===t.NotebookControllerAffinity2.Hidden&&(0,p.checkProposedApiEnabled)(a,"notebookControllerAffinityHidden"),q.a.$updateNotebookPriority(N,re.uri,se)},onDidReceiveMessage:F.event,postMessage(re,se){return(0,p.checkProposedApiEnabled)(a,"notebookMessaging"),q.a.$postMessage(N,se&&q.l.getIdByEditor(se),re)},asWebviewUri(re){return(0,p.checkProposedApiEnabled)(a,"notebookMessaging"),(0,c.asWebviewUri)(re,q.k.remote)}};return this.h.set(N,{extensionId:a.identifier,controller:ue,onDidReceiveMessage:F,onDidChangeSelection:P,associatedNotebooks:ge}),ue}getIdByController(a){for(const[l,n]of this.h)if(n.controller===a)return o(n.extensionId,a.id);return null}createNotebookControllerDetectionTask(a,l){const n=this.d++,d=this;this.n.trace(`NotebookControllerDetectionTask[${n}], CREATED by ${a.identifier.value}`),this.a.$addKernelDetectionTask(n,l);const g={dispose:()=>{this.c.delete(n),d.a.$removeKernelDetectionTask(n)}};return this.c.set(n,g),g}registerKernelSourceActionProvider(a,l,n){const d=this.f++,g=this;return this.e.set(d,n),this.n.trace(`NotebookKernelSourceActionProvider[${d}], CREATED by ${a.identifier.value}`),this.a.$addKernelSourceActionProvider(d,l),{dispose:()=>{this.e.delete(d),g.a.$removeKernelSourceActionProvider(d)}}}async $provideKernelSourceActions(a,l){const n=this.e.get(a);if(n){const d=new C.DisposableStore;return this.g.add([d]),(await n.provideNotebookKernelSourceActions(l)??[]).map(O=>f.NotebookKernelSourceAction.from(O,this.m.converter,d))}return[]}$acceptNotebookAssociation(a,l,n){const d=this.h.get(a);if(d){const g=this.l.getNotebookDocument(S.URI.revive(l));n?d.associatedNotebooks.set(g.uri,!0):d.associatedNotebooks.delete(g.uri),this.n.trace(`NotebookController[${a}] ASSOCIATE notebook`,g.uri.toString(),n),d.onDidChangeSelection.fire({selected:n,notebook:g.apiNotebook})}}async $executeCells(a,l,n){const d=this.h.get(a);if(!d)return;const g=this.l.getNotebookDocument(S.URI.revive(l)),O=[];for(const N of n){const q=g.getCell(N);q&&O.push(q.apiCell)}try{this.n.trace(`NotebookController[${a}] EXECUTE cells`,g.uri.toString(),O.length),await d.controller.executeHandler.call(d.controller,O,g.apiNotebook,d.controller)}catch(N){this.n.error(`NotebookController[${a}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(a,l,n){const d=this.h.get(a);if(!d)return;const g=this.l.getNotebookDocument(S.URI.revive(l));if(d.controller.interruptHandler)await d.controller.interruptHandler.call(d.controller,g.apiNotebook);else for(const O of n){const N=g.getCell(O);N&&this.b.get(N.uri)?.cancel()}}$acceptKernelMessageFromRenderer(a,l,n){const d=this.h.get(a);if(!d)return;const g=this.l.getEditorById(l);d.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:n}))}$cellExecutionChanged(a,l,n){const g=this.l.getNotebookDocument(S.URI.revive(a)).getCell(l);if(g){const O=n?f.NotebookCellExecutionState.to(n):t.NotebookCellExecutionState.Idle;O!==void 0&&this.j.fire({cell:g.apiCell,state:O})}}_createNotebookCellExecution(a,l){if(a.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const d=this.l.getNotebookDocument(a.notebook.uri).getCellFromApiCell(a);if(!d)throw new Error("invalid cell");if(this.b.has(d.uri))throw new Error(`duplicate execution for ${d.uri}`);const g=new s(l,d,this.a);this.b.set(d.uri,g);const O=g.onDidChangeState(()=>{g.state===w.Resolved&&(g.dispose(),O.dispose(),this.b.delete(d.uri))});return g.asApiObject()}};v=qe([Ve(4,M.ILogService)],v),e.ExtHostNotebookKernels=v;var w;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(w||(w={}));class s extends C.Disposable{get state(){return this.f}constructor(a,l,n){super(),this.j=l,this.k=n,this.b=s.a++,this.c=new L.Emitter,this.onDidChangeState=this.c.event,this.f=w.Init,this.g=this.B(new y.CancellationTokenSource),this.h=new r(10,d=>this.m(d)),this.i=l.internalMetadata.executionOrder,this.k.$createExecution(this.b,a,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(a){await this.h.addItem(a)}async m(a){const l=Array.isArray(a)?a:[a];return this.k.$updateExecution(this.b,new E.SerializableObjectWithBuffers(l))}n(){if(this.f===w.Init)throw new Error("Must call start before modifying cell output");if(this.f===w.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(a){let l=this.j;if(a&&(l=this.j.notebook.getCellFromApiCell(a)),!l)throw new Error("INVALID cell");return l.handle}s(a){return a.map(l=>{const n=t.NotebookCellOutput.ensureUniqueMimeTypes(l.items,!0);return n===l.items?f.NotebookCellOutput.from(l):f.NotebookCellOutput.from({items:n,id:l.id,metadata:l.metadata})})}async t(a,l,n){const d=this.r(l),g=this.s((0,i.asArray)(a));return this.l({editType:u.CellExecutionUpdateType.Output,cellHandle:d,append:n,outputs:g})}async w(a,l,n){return a=t.NotebookCellOutput.ensureUniqueMimeTypes((0,i.asArray)(a),!0),this.l({editType:u.CellExecutionUpdateType.OutputItems,items:a.map(f.NotebookCellOutputItem.from),outputId:l.id,append:n})}asApiObject(){const a=this;return Object.freeze({get token(){return a.g.token},get cell(){return a.j.apiCell},get executionOrder(){return a.i},set executionOrder(n){a.i=n,a.m([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:a.i}])},start(n){if(a.f===w.Resolved||a.f===w.Started)throw new Error("Cannot call start again");a.f=w.Started,a.c.fire(),a.m({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,d){if(a.f===w.Resolved)throw new Error("Cannot call resolve twice");a.f=w.Resolved,a.c.fire(),a.h.flush(),a.k.$completeExecution(a.b,new E.SerializableObjectWithBuffers({runEndTime:d,lastRunSuccess:n}))},clearOutput(n){return a.n(),a.t([],n,!1)},appendOutput(n,d){return a.n(),a.t(n,d,!0)},replaceOutput(n,d){return a.n(),a.t(n,d,!1)},appendOutputItems(n,d){return a.n(),a.w(n,d,!0)},replaceOutputItems(n,d){return a.n(),a.w(n,d,!1)}})}}s.a=0;class r{constructor(a,l){this.d=a,this.e=l,this.a=[],this.b=Date.now()}addItem(a){return this.a.push(a),this.c||(this.c=new T.DeferredPromise,this.b=Date.now(),(0,T.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const a=this.c;this.c=void 0;const l=this.a;return this.a=[],this.e(l).finally(()=>a.complete())}}function o(h,a){return`${h.value}/${a}`}e.createKernelId=o}),define(Ie[216],Ce([1,0,5,4,97]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class L{constructor(A,S){this.c=S,this.a=new Map,this.b=A.getProxy(T.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,S,k){const M=this.c.getEditorById(A);this.a.get(S)?.fire({editor:M.apiEditor,message:k})}createRendererMessaging(A,S){if(!A.contributes?.notebookRenderer?.some(M=>M.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(M,D,m)=>this.d(S).event(M,D,m),postMessage:(M,D)=>{y.ExtHostNotebookEditor.apiEditorsToExtHost.has(M)&&([M,D]=[D,M]);const m=D&&y.ExtHostNotebookEditor.apiEditorsToExtHost.get(D);return this.b.$postMessage(m?.id,S,M)}}}d(A){let S=this.a.get(A);return S||(S=new i.Emitter({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(A)}}),this.a.set(A,S),S)}}e.ExtHostNotebookRenderers=L}),define(Ie[217],Ce([1,0,7,2,25,4]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class C{constructor(S){this.b=new Map,this.a=S.getProxy(L.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(S,k,M){if((0,y.checkProposedApiEnabled)(S,"profileContentHandlers"),this.b.has(k))throw new Error(`Handler with id '${k}' already registered`);return this.b.set(k,M),this.a.$registerProfileContentHandler(k,M.name,S.identifier.value),(0,i.toDisposable)(()=>{this.b.delete(k),this.a.$unregisterProfileContentHandler(k)})}async $saveProfile(S,k,M,D){const m=this.b.get(S);if(!m)throw new Error(`Unknown handler with id: ${S}`);return m.saveProfile(k,M,D)}async $readProfile(S,k,M){const D=this.b.get(S);if(!D)throw new Error(`Unknown handler with id: ${S}`);return D.readProfile(T.URI.revive(k),M)}}e.ExtHostProfileContentHandlers=C}),define(Ie[218],Ce([1,0,20,5,7,4,2,6,11,16,29,64]),function(ee,e,i,T,y,L,C,A,S,k,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(b,f,t){const c=b.getProxy(L.MainContext.MainThreadQuickOpen);class u{constructor(a,l){this.e=new Map,this.f=0,this.a=a,this.b=l}showQuickPick(a,l,n=i.CancellationToken.None){this.c=void 0;const d=Promise.resolve(a),g=++this.f,O=c.$show(g,{title:l?.title,placeHolder:l?.placeHolder,matchOnDescription:l?.matchOnDescription,matchOnDetail:l?.matchOnDetail,ignoreFocusLost:l?.ignoreFocusOut,canPickMany:l?.canPickMany},n),N={},q=O.then(()=>N);return Promise.race([q,d]).then(J=>{if(J!==N)return d.then(x=>{const R=[];for(let P=0;P<x.length;P++){const F=x[P];typeof F=="string"?R.push({label:F,handle:P}):F.kind===A.QuickPickItemKind.Separator?R.push({type:"separator",label:F.label}):R.push({label:F.label,description:F.description,detail:F.detail,picked:F.picked,alwaysShow:F.alwaysShow,handle:P})}return l&&typeof l.onDidSelectItem=="function"&&(this.c=P=>{l.onDidSelectItem(x[P])}),c.$setItems(g,R),O.then(P=>{if(typeof P=="number")return x[P];if(Array.isArray(P))return P.map(F=>x[F])})})}).then(void 0,J=>{if(!(0,S.isCancellationError)(J))return c.$setError(g,J),Promise.reject(J)})}$onItemSelected(a){this.c?.(a)}showInput(a,l=i.CancellationToken.None){return this.d=a?.validateInput,c.$input(a,typeof this.d=="function",l).then(void 0,n=>{if(!(0,S.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(a){if(!this.d)return;const l=await this.d(a);if(!l||typeof l=="string")return l;let n;switch(l.severity){case A.InputBoxValidationSeverity.Info:n=M.default.Info;break;case A.InputBoxValidationSeverity.Warning:n=M.default.Warning;break;case A.InputBoxValidationSeverity.Error:n=M.default.Error;break;default:n=l.message?M.default.Error:M.default.Ignore;break}return{content:l.message,severity:n}}async showWorkspaceFolderPick(a,l=i.CancellationToken.None){const n=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[a]);if(!n)return;const d=await this.a.getWorkspaceFolders2();if(!!d)return d.find(g=>g.uri.toString()===n.uri.toString())}createQuickPick(a){const l=new r(a,()=>this.e.delete(l._id));return this.e.set(l._id,l),l}createInputBox(a){const l=new o(a,()=>this.e.delete(l._id));return this.e.set(l._id,l),l}$onDidChangeValue(a,l){this.e.get(a)?._fireDidChangeValue(l)}$onDidAccept(a){this.e.get(a)?._fireDidAccept()}$onDidChangeActive(a,l){const n=this.e.get(a);n instanceof r&&n._fireDidChangeActive(l)}$onDidChangeSelection(a,l){const n=this.e.get(a);n instanceof r&&n._fireDidChangeSelection(l)}$onDidTriggerButton(a,l){this.e.get(a)?._fireDidTriggerButton(l)}$onDidTriggerItemButton(a,l,n){const d=this.e.get(a);d instanceof r&&d._fireDidTriggerItemButton(l,n)}$onDidHide(a){this.e.get(a)?._fireDidHide()}}class p{constructor(a,l){this.x=a,this.y=l,this._id=r.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.Emitter,this.q=new T.Emitter,this.r=new T.Emitter,this.s=new T.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(a){this.b=a,this.z({title:a})}get step(){return this.c}set step(a){this.c=a,this.z({step:a})}get totalSteps(){return this.d}set totalSteps(a){this.d=a,this.z({totalSteps:a})}get enabled(){return this.g}set enabled(a){this.g=a,this.z({enabled:a})}get busy(){return this.j}set busy(a){this.j=a,this.z({busy:a})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(a){this.k=a,this.z({ignoreFocusOut:a})}get value(){return this.l}set value(a){this.l=a,this.z({value:a})}get placeholder(){return this.m}set placeholder(a){this.m=a,this.z({placeholder:a})}get buttons(){return this.n}set buttons(a){this.n=a.slice(),this.o.clear(),a.forEach((l,n)=>{const d=l===A.QuickInputButtons.Back?-1:n;this.o.set(d,l)}),this.z({buttons:a.map((l,n)=>({...s(l),tooltip:l.tooltip,handle:l===A.QuickInputButtons.Back?-1:n}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(a){this.l=a,this.q.fire(a)}_fireDidTriggerButton(a){const l=this.o.get(a);l&&this.r.fire(l)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,y.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),c.$dispose(this._id))}z(a){if(!this.v){for(const l of Object.keys(a)){const n=a[l];this.u[l]=n===void 0?null:n}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){c.$createOrUpdate(this.u),this.u={id:this._id}}}p.a=1;function E(h){if(h instanceof A.ThemeIcon)return{id:h.id};const a=w(h),l=v(h);return{dark:typeof a=="string"?C.URI.file(a):a,light:typeof l=="string"?C.URI.file(l):l}}function v(h){return typeof h=="object"&&"light"in h?h.light:h}function w(h){return typeof h=="object"&&"dark"in h?h.dark:h}function s(h){const a=E(h.iconPath);let l,n;return"id"in a?n=D.ThemeIcon.asClassName(a):l=a,{iconPath:l,iconClass:n}}class r extends p{constructor(a,l){super(a.identifier,l),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.Emitter,this.L=[],this.M=new T.Emitter,this.N=new T.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(a){this.B=a.slice(),this.C.clear(),this.D.clear(),a.forEach((n,d)=>{this.C.set(d,n),this.D.set(n,d)});const l=[];for(let n=0;n<a.length;n++){const d=a[n];d.kind===A.QuickPickItemKind.Separator?l.push({type:"separator",label:d.label}):l.push({handle:n,label:d.label,description:d.description,detail:d.detail,picked:d.picked,alwaysShow:d.alwaysShow,buttons:d.buttons?.map((g,O)=>({...s(g),tooltip:g.tooltip,handle:O}))})}this.z({items:l})}get canSelectMany(){return this.E}set canSelectMany(a){this.E=a,this.z({canSelectMany:a})}get matchOnDescription(){return this.F}set matchOnDescription(a){this.F=a,this.z({matchOnDescription:a})}get matchOnDetail(){return this.G}set matchOnDetail(a){this.G=a,this.z({matchOnDetail:a})}get sortByLabel(){return this.H}set sortByLabel(a){this.H=a,this.z({sortByLabel:a})}get keepScrollPosition(){return this.I}set keepScrollPosition(a){this.I=a,this.z({keepScrollPosition:a})}get activeItems(){return this.J}set activeItems(a){this.J=a.filter(l=>this.D.has(l)),this.z({activeItems:this.J.map(l=>this.D.get(l))})}get selectedItems(){return this.L}set selectedItems(a){this.L=a.filter(l=>this.D.has(l)),this.z({selectedItems:this.L.map(l=>this.D.get(l))})}_fireDidChangeActive(a){const l=(0,k.coalesce)(a.map(n=>this.C.get(n)));this.J=l,this.K.fire(l)}_fireDidChangeSelection(a){const l=(0,k.coalesce)(a.map(n=>this.C.get(n)));this.L=l,this.M.fire(l)}_fireDidTriggerItemButton(a,l){const n=this.C.get(a);if(!n||!n.buttons||!n.buttons.length)return;const d=n.buttons[l];d&&this.N.fire({button:d,item:n})}}class o extends p{constructor(a,l){super(a.identifier,l),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(a){this.B=a,this.z({password:a})}get prompt(){return this.C}set prompt(a){this.C=a,this.z({prompt:a})}get valueSelection(){return this.D}set valueSelection(a){this.D=a,this.z({valueSelection:a})}get validationMessage(){return this.E}set validationMessage(a){this.E=a,a?typeof a=="string"?this.z({validationMessage:a,severity:M.default.Error}):this.z({validationMessage:a.message,severity:a.severity??M.default.Error}):this.z({validationMessage:void 0,severity:M.default.Ignore})}}return new u(f,t)}e.createExtHostQuickOpen=m});var Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)},Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i};define(Ie[219],Ce([1,0,2,5,60,7,14,4,16,122,12,26,64,8,25]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m,b,f){"use strict";var t,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function u(d){if(d)return typeof d.iconPath=="string"?i.URI.file(d.iconPath):i.URI.isUri(d.iconPath)||m.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function p(d,g){if(!d.iconPath&&!g.iconPath)return 0;if(d.iconPath){if(!g.iconPath)return 1}else return-1;const O=typeof d.iconPath=="string"?d.iconPath:i.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,N=typeof g.iconPath=="string"?g.iconPath:i.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id;return(0,k.comparePaths)(O,N)}function E(d,g){let O=0;if(d.strikeThrough!==g.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==g.faded)return d.faded?1:-1;if(d.tooltip!==g.tooltip)return(d.tooltip||"").localeCompare(g.tooltip||"");if(O=p(d,g),O!==0)return O;if(d.light&&g.light)O=p(d.light,g.light);else{if(d.light)return 1;if(g.light)return-1}if(O!==0)return O;if(d.dark&&g.dark)O=p(d.dark,g.dark);else{if(d.dark)return 1;if(g.dark)return-1}return O}function v(d,g){if(d.command!==g.command)return d.command<g.command?-1:1;if(d.title!==g.title)return d.title<g.title?-1:1;if(d.tooltip!==g.tooltip){if(d.tooltip!==void 0&&g.tooltip!==void 0)return d.tooltip<g.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(g.tooltip!==void 0)return-1}if(d.arguments===g.arguments)return 0;if(d.arguments)if(g.arguments){if(d.arguments.length!==g.arguments.length)return d.arguments.length-g.arguments.length}else return 1;else return-1;for(let O=0;O<d.arguments.length;O++){const N=d.arguments[O],q=g.arguments[O];if(N!==q)return N<q?-1:1}return 0}function w(d,g){let O=(0,k.comparePaths)(d.resourceUri.fsPath,g.resourceUri.fsPath,!0);if(O!==0)return O;if(d.command&&g.command)O=v(d.command,g.command);else{if(d.command)return 1;if(g.command)return-1}if(O!==0)return O;if(d.decorations&&g.decorations)O=E(d.decorations,g.decorations);else{if(d.decorations)return 1;if(g.decorations)return-1}return O}function s(d,g){for(let O=0;O<d.length;O++)if(d[O]!==g[O])return!1;return!0}function r(d,g){return d.command===g.command&&d.title===g.title&&d.tooltip===g.tooltip&&(d.arguments&&g.arguments?s(d.arguments,g.arguments):d.arguments===g.arguments)}function o(d,g){return(0,S.equals)(d,g,r)}class h{get value(){return this.d}set value(g){g=g??"",Re(this,t,"f").$setInputBoxValue(this.l,g),this.m(g)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(g){Re(this,t,"f").$setInputBoxPlaceholder(this.l,g),this.f=g}get validateInput(){return(0,f.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(g){if((0,f.checkProposedApiEnabled)(this.k,"scmValidation"),g&&typeof g!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=g,Re(this,t,"f").$setValidationProviderIsEnabled(this.l,!!g)}get enabled(){return this.h}set enabled(g){g=!!g,this.h!==g&&(this.h=g,Re(this,t,"f").$setInputBoxEnablement(this.l,g))}get visible(){return this.j}set visible(g){g=!!g,this.j!==g&&(this.j=g,Re(this,t,"f").$setInputBoxVisibility(this.l,g))}constructor(g,O,N){this.k=g,this.l=N,t.set(this,void 0),this.d="",this.e=new T.Emitter,this.f="",this.h=!0,this.j=!0,Ye(this,t,O,"f")}showValidationMessage(g,O){(0,f.checkProposedApiEnabled)(this.k,"scmValidation"),Re(this,t,"f").$showValidationMessage(this.l,g,O)}$onInputBoxValueChange(g){this.m(g)}m(g){this.d=g,this.e.fire(g)}}e.ExtHostSCMInputBox=h,t=new WeakMap;class a{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(g){this.v=g,this.q.$updateGroupLabel(this.t,this.handle,g)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(g){this.p=g,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(g){this.f=[...g],this.k.fire()}constructor(g,O,N,q,J){this.q=g,this.s=O,this.t=N,this.u=q,this.v=J,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=a.d++}getResourceState(g){return this.g.get(g)}$executeResourceCommand(g,O){const N=this.h.get(g);return N?(0,C.asPromise)(()=>this.s.executeCommand(N.command,...N.arguments||[],O)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const g=[...this.f].sort(w),N=(0,S.sortedDiff)(this.o,g,w).map(x=>{const R=x.toInsert.map(P=>{const F=this.e++;this.g.set(F,P);const B=P.resourceUri;let z;if(P.command)if(P.command.command==="vscode.open"||P.command.command==="vscode.diff"){const me=new L.DisposableStore;z=this.s.converter.toInternal(P.command,me),this.j.set(F,me)}else this.h.set(F,P.command);const V=u(P.decorations),K=P.decorations&&u(P.decorations.light)||V,ie=P.decorations&&u(P.decorations.dark)||V,ge=[K,ie],ue=P.decorations&&P.decorations.tooltip||"",re=P.decorations&&!!P.decorations.strikeThrough,se=P.decorations&&!!P.decorations.faded,le=P.contextValue||"";return{rawResource:[F,B,ge,ue,re,se,le,z],handle:F}});return{start:x.start,deleteCount:x.deleteCount,toInsert:R}}),q=N.map(({start:x,deleteCount:R,toInsert:P})=>[x,R,P.map(F=>F.rawResource)]),J=N.reverse();for(const{start:x,deleteCount:R,toInsert:P}of J){const F=P.map(z=>z.handle),B=this.n.splice(x,R,...F);for(const z of B)this.g.delete(z),this.h.delete(z),this.j.get(z)?.dispose(),this.j.delete(z)}return this.o=g,q}dispose(){this.l=!0,this.m.fire()}}a.d=0;class l{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(g){this.g!==g&&(this.g=g,Re(this,c,"f").$updateSourceControl(this.t,{count:g}))}get quickDiffProvider(){return this.h}set quickDiffProvider(g){this.h=g,Re(this,c,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!g})}get commitTemplate(){return this.j}set commitTemplate(g){g!==this.j&&(this.j=g,Re(this,c,"f").$updateSourceControl(this.t,{commitTemplate:g}))}get acceptInputCommand(){return this.l}set acceptInputCommand(g){this.k.value=new L.DisposableStore,this.l=g;const O=this.v.converter.toInternal(g,this.k.value);Re(this,c,"f").$updateSourceControl(this.t,{acceptInputCommand:O})}get actionButton(){return(0,f.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(g){(0,f.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new L.DisposableStore,this.n=g;const O=g!==void 0?{command:this.v.converter.toInternal(g.command,this.m.value),secondaryCommands:g.secondaryCommands?.map(N=>N.map(q=>this.v.converter.toInternal(q,this.m.value))),description:g.description,enabled:g.enabled}:void 0;Re(this,c,"f").$updateSourceControl(this.t,{actionButton:O??null})}get statusBarCommands(){return this.p}set statusBarCommands(g){if(this.p&&g&&o(this.p,g))return;this.o.value=new L.DisposableStore,this.p=g;const O=(g||[]).map(N=>this.v.converter.toInternal(N,this.o.value));Re(this,c,"f").$updateSourceControl(this.t,{statusBarCommands:O})}get selected(){return this.q}constructor(g,O,N,q,J,x){this.u=g,this.v=N,this.w=q,this.x=J,this.y=x,c.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new L.MutableDisposable,this.l=void 0,this.m=new L.MutableDisposable,this.o=new L.MutableDisposable,this.p=void 0,this.q=!1,this.s=new T.Emitter,this.onDidChangeSelection=this.s.event,this.t=l.d++,this.z=new Map,this.A=new Set,Ye(this,c,O,"f"),this.f=new h(g,Re(this,c,"f"),this.t),Re(this,c,"f").$registerSourceControl(this.t,q,J,x)}createResourceGroup(g,O){const N=new a(Re(this,c,"f"),this.v,this.t,g,O),q=T.Event.once(N.onDidDispose)(()=>this.z.delete(N));return this.z.set(N,q),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const g=[],O=[];for(const[N,q]of this.z){q.dispose();const J=N.onDidUpdateResourceStates(()=>{this.A.add(N),this.eventuallyUpdateResourceStates()});T.Event.once(N.onDidDispose)(()=>{this.A.delete(N),J.dispose(),this.e.delete(N.handle),Re(this,c,"f").$unregisterGroup(this.t,N.handle)}),g.push([N.handle,N.id,N.label,N.features]);const x=N._takeResourceStateSnapshot();x.length>0&&O.push([N.handle,x]),this.e.set(N.handle,N)}Re(this,c,"f").$registerGroups(this.t,g,O),this.z.clear()}eventuallyUpdateResourceStates(){const g=[];this.A.forEach(O=>{const N=O._takeResourceStateSnapshot();N.length!==0&&g.push([O.handle,N])}),g.length>0&&Re(this,c,"f").$spliceResourceStates(this.t,g),this.A.clear()}getResourceGroup(g){return this.e.get(g)}setSelectionState(g){this.q=g,this.s.fire(g)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(g=>g.dispose()),Re(this,c,"f").$unregisterSourceControl(this.t)}}c=new WeakMap,l.d=0,qe([(0,y.debounce)(100)],l.prototype,"eventuallyAddResourceGroups",null),qe([(0,y.debounce)(100)],l.prototype,"eventuallyUpdateResourceStates",null);let n=class tn{get onDidChangeActiveProvider(){return this.j.event}constructor(g,O,N){this.l=O,this.m=N,this.g=new Map,this.h=new Map,this.j=new T.Emitter,this.e=g.getProxy(A.MainContext.MainThreadSCM),this.f=g.getProxy(A.MainContext.MainThreadTelemetry),O.registerArgumentProcessor({processArgument:q=>{if(q&&q.$mid===3){const J=this.g.get(q.sourceControlHandle);if(!J)return q;const x=J.getResourceGroup(q.groupHandle);return x?x.getResourceState(q.handle):q}else if(q&&q.$mid===4){const J=this.g.get(q.sourceControlHandle);return J?J.getResourceGroup(q.groupHandle):q}else if(q&&q.$mid===5){const J=this.g.get(q.handle);return J||q}return q}})}createSourceControl(g,O,N,q){this.m.trace("ExtHostSCM#createSourceControl",g.identifier.value,O,N,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:g.identifier.value});const J=tn.d++,x=new l(g,this.e,this.l,O,N,q);this.g.set(J,x);const R=this.h.get(D.ExtensionIdentifier.toKey(g.identifier))||[];return R.push(x),this.h.set(D.ExtensionIdentifier.toKey(g.identifier),R),x}getLastInputBox(g){this.m.trace("ExtHostSCM#getLastInputBox",g.identifier.value);const O=this.h.get(D.ExtensionIdentifier.toKey(g.identifier)),N=O&&O[O.length-1];return N&&N.inputBox}$provideOriginalResource(g,O,N){const q=i.URI.revive(O);this.m.trace("ExtHostSCM#$provideOriginalResource",g,q.toString());const J=this.g.get(g);return!J||!J.quickDiffProvider||!J.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>J.quickDiffProvider.provideOriginalResource(q,N)).then(x=>x||null)}$onInputBoxValueChange(g,O){this.m.trace("ExtHostSCM#$onInputBoxValueChange",g);const N=this.g.get(g);return N&&N.inputBox.$onInputBoxValueChange(O),Promise.resolve(void 0)}$executeResourceCommand(g,O,N,q){this.m.trace("ExtHostSCM#$executeResourceCommand",g,O,N);const J=this.g.get(g);if(!J)return Promise.resolve(void 0);const x=J.getResourceGroup(O);return x?x.$executeResourceCommand(N,q):Promise.resolve(void 0)}$validateInput(g,O,N){this.m.trace("ExtHostSCM#$validateInput",g);const q=this.g.get(g);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>q.inputBox.validateInput(O,N)).then(J=>{if(!J)return Promise.resolve(void 0);const x=b.MarkdownString.fromStrict(J.message);return x?Promise.resolve([x,J.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(g){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",g),g!==void 0&&this.g.get(g)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=g,Promise.resolve(void 0)}};n.d=0,n=qe([Ve(2,M.ILogService)],n),e.ExtHostSCM=n}),define(Ie[74],Ce([1,0,4,5,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class L{constructor(A){this.b=new T.Emitter,this.onDidChangePassword=this.b.event,this.a=A.getProxy(i.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this.b.fire(A)}get(A,S){return this.a.$getPassword(A,S)}store(A,S,k){return this.a.$setPassword(A,S,k)}delete(A,S){return this.a.$deletePassword(A,S)}}e.ExtHostSecretState=L,e.IExtHostSecretState=(0,y.createDecorator)("IExtHostSecretState")});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[220],Ce([1,0,6,4,137,7,8,9]),function(ee,e,i,T,y,L,C,A){"use strict";var S,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class M{constructor(f,t,c,u,p=i.StatusBarAlignment.Left,E){S.set(this,void 0),k.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.p=new L.DisposableStore,Ye(this,S,f,"f"),Ye(this,k,t,"f"),this.c=M.a++,this.e=c,this.f=u,this.g=p,this.h=this.t(E)}t(f){if(!!(0,A.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.q?.fromApi}get accessibilityInformation(){return this.s}set text(f){this.k=f,this.u()}set name(f){this.m=f,this.u()}set tooltip(f){this.l=f,this.u()}set color(f){this.n=f,this.u()}set backgroundColor(f){f&&!M.b.has(f.id)&&(f=void 0),this.o=f,this.u()}set command(f){this.q?.fromApi!==f&&(this.p.clear(),typeof f=="string"?this.q={fromApi:f,internal:Re(this,k,"f").toInternal({title:"",command:f},this.p)}:f?this.q={fromApi:f,internal:Re(this,k,"f").toInternal(f,this.p)}:this.q=void 0,this.u())}set accessibilityInformation(f){this.s=f,this.u()}show(){this.j=!0,this.u()}hide(){clearTimeout(this.r),this.j=!1,Re(this,S,"f").$dispose(this.c)}u(){this.i||!this.j||(clearTimeout(this.r),this.r=setTimeout(()=>{this.r=void 0;let f;this.e?this.f?f=`${this.e.identifier.value}.${this.f}`:f=this.e.identifier.value:f=this.f;let t;this.m?t=this.m:t=(0,y.localize)(0,null,this.e.displayName||this.e.name);let c=this.n;this.o&&(c=M.b.get(this.o.id));const u=C.MarkdownString.fromStrict(this.l);Re(this,S,"f").$setEntry(this.c,f,t,this.k,u,this.q?.internal,c,this.o,this.g===i.StatusBarAlignment.Left,this.h,this.s)},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=M,S=new WeakMap,k=new WeakMap,M.a=0,M.b=new Map([["statusBarItem.errorBackground",new i.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new i.ThemeColor("statusBarItem.warningForeground")]]);class D{constructor(f){this.b=[],this.a=f.createStatusBarEntry(void 0,"status.extensionMessage",i.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,y.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(f){const t={message:f};return this.b.unshift(t),this.c(),new i.Disposable(()=>{const c=this.b.indexOf(t);c>=0&&(this.b.splice(c,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class m{constructor(f,t){this.a=f.getProxy(T.MainContext.MainThreadStatusBar),this.b=t,this.c=new D(this)}createStatusBarEntry(f,t,c,u){return new M(this.a,this.b,f,t,c,u)}setStatusBarMessage(f,t){const c=this.c.setMessage(f);let u;return typeof t=="number"?u=setTimeout(()=>c.dispose(),t):typeof t<"u"&&t.then(()=>c.dispose(),()=>c.dispose()),new i.Disposable(()=>{c.dispose(),clearTimeout(u)})}}e.ExtHostStatusBar=m}),define(Ie[75],Ce([1,0,4,5,3]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class L{constructor(A,S){this.c=S,this.b=new T.Emitter,this.onDidChangeStorage=this.b.event,this.a=A.getProxy(i.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,S){this.a.$registerExtensionStorageKeysToSync(A,S)}async initializeExtensionStorage(A,S,k){const M=await this.a.$initializeExtensionStorage(A,S);let D;return M&&(D=this.d(A,S,M)),D||k}setValue(A,S,k){return this.a.$setValue(A,S,k)}$acceptValue(A,S,k){const M=this.d(A,S,k);M&&this.b.fire({shared:A,key:S,value:M})}d(A,S,k){try{return JSON.parse(k)}catch(M){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${A}): ${M}`)}}}e.ExtHostStorage=L,e.IExtHostStorage=(0,y.createDecorator)("IExtHostStorage")}),define(Ie[76],Ce([1,0,3,27,12,57,2]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,i.createDecorator)("IExtensionStoragePaths");let A=class{constructor(k,M,D){this.d=M,this.f=D,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(k){return C.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,M=await this.g(k);try{return await this.f.value.stat(M),this.d.trace("[ExtHostStorage] storage dir already exists",M),M}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",M),await this.f.value.createDirectory(M),await this.f.value.writeFile(C.URI.joinPath(M,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:C.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),M}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(k){if(this.c)return C.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return C.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=qe([Ve(0,T.IExtHostInitDataService),Ve(1,y.ILogService),Ve(2,L.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(Ie[58],Ce([1,0,5,4,3,2,15,7,6,138,11,176,20,34,162,64,9,14,8]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m,b,f,t,c,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,y.createDecorator)("IExtHostTerminalService");class E{constructor(n,d,g,O){this.k=n,this._id=d,this.l=g,this.m=O,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(q=>this.f=q);const N=this;this.value={get name(){return N.m||""},get processId(){return N.b},get creationOptions(){return N.l},get exitStatus(){return N.h},get state(){return N.j},sendText(q,J=!0){N.o(),N.k.$sendText(N._id,q,J)},show(q){N.o(),N.k.$show(N._id,q)},hide(){N.o(),N.k.$hide(N._id)},dispose(){N.a||(N.a=!0,N.k.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create(n,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:n.name,shellPath:(0,c.withNullAsUndefined)(n.shellPath),shellArgs:(0,c.withNullAsUndefined)(n.shellArgs),cwd:(0,c.withNullAsUndefined)(n.cwd),env:(0,c.withNullAsUndefined)(n.env),icon:(0,c.withNullAsUndefined)(h(n.iconPath)),color:t.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,c.withNullAsUndefined)(n.message),strictEnv:(0,c.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,c.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,c.withNullAsUndefined)(d?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,c.withNullAsUndefined)(d?.useShellEnvironment),location:d?.location||this.n(n.location,d?.resolvedExtHostIdentifier),isTransient:(0,c.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,d,g,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:g,color:t.ThemeColor.isThemeColor(O)?O.id:void 0,location:this.n(n,d),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(n,d){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&d?{parentTerminal:d}:"viewColumn"in n?{viewColumn:p.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(n){this.m=n}setExitStatus(n,d){this.h=Object.freeze({code:n,reason:d})}setDimensions(n,d){return n===this.d&&d===this.g||n===0||d===0?!1:(this.d=n,this.g=d,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(n){this.f?(this.f(n),this.f=void 0):this.b.then(d=>{d!==n&&(this.b=Promise.resolve(n))})}}e.ExtHostTerminal=E;class v{get onProcessReady(){return this.b.event}constructor(n){this.g=n,this.id=0,this.shouldPersist=!1,this.a=new i.Emitter,this.onProcessData=this.a.event,this.b=new i.Emitter,this.d=new i.Emitter,this.onDidChangeProperty=this.d.event,this.f=new i.Emitter,this.onProcessExit=this.f.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,d){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${d}`)}async start(){}shutdown(){this.g.close()}input(n){this.g.handleInput?.(n)}resize(n,d){this.g.setDimensions?.({columns:n,rows:d})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this.g.onDidWrite(d=>this.a.fire(d)),this.g.onDidClose?.((d=void 0)=>{this.f.fire(d===void 0?void 0:d)}),this.g.onDidOverrideDimensions?.(d=>{d&&this.d.fire({type:"overrideDimensions",value:{cols:d.columns,rows:d.rows}})}),this.g.onDidChangeName?.(d=>{this.d.fire({type:"title",value:d})}),this.g.open(n||void 0),n&&this.g.setDimensions?.(n),this.b.fire({pid:-1,cwd:""})}}let w=1,s=class extends A.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(n=>n.value)}get onDidWriteTerminalData(){return this.I.event}constructor(n,d){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new i.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new i.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new i.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new i.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new i.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new i.Emitter,this.onDidChangeShell=this.J.event,this.a=d.getProxy(T.MainContext.MainThreadTerminalService),this.s=new f.TerminalDataBufferer(this.a.$sendProcessData),this.I=new i.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(n),this.B({dispose:()=>{for(const[g,O]of this.g)O.shutdown(!0)}})}getDefaultShell(n){return(n?this.n:this.m)?.path||""}getDefaultShellArgs(n){return(n?this.n:this.m)?.args||[]}createExtensionTerminal(n,d){const g=new E(this.a,(0,b.generateUuid)(),n,n.name),O=new v(n.pty);return g.createExtensionTerminal(n.location,this.L(n,d).resolvedExtHostIdentifier,h(n.iconPath),a(n.color)).then(N=>{const q=this.M(N,O);this.h[N]=q}),this.f.push(g),g.value}L(n,d){if(d=d||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const g=n.location.parentTerminal;if(g){const O=this.f.find(N=>N.value===g);O&&(d.resolvedExtHostIdentifier=O._id)}}else n.location&&typeof n.location!="object"?d.location=n.location:d.location&&typeof d.location=="object"&&"splitActiveTerminal"in d.location&&(d.location={splitActiveTerminal:!0});return d}attachPtyToTerminal(n,d){if(!this.O(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const O=new v(d),N=this.M(n,O);this.h[n]=N}async $acceptActiveTerminalChanged(n){const d=this.b;if(n===null){this.b=void 0,d!==this.b&&this.F.fire(this.b);return}const g=this.O(n);g&&(this.b=g,d!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(n,d){const g=this.O(n);g&&this.I.fire({terminal:g.value,data:d})}async $acceptTerminalDimensions(n,d,g){const O=this.O(n);O&&O.setDimensions(d,g)&&this.G.fire({terminal:O.value,dimensions:O.value.dimensions})}async $acceptTerminalMaximumDimensions(n,d,g){this.g.get(n)?.resize(d,g)}async $acceptTerminalTitleChange(n,d){const g=this.O(n);g&&(g.name=d)}async $acceptTerminalClosed(n,d,g){const O=this.Q(this.f,n);if(O!==null){const N=this.f.splice(O,1)[0];N.setExitStatus(d,g),this.C.fire(N.value)}}$acceptTerminalOpened(n,d,g,O){if(d){const J=this.Q(this.f,d);if(J!==null){this.f[J]._id=n,this.D.fire(this.terminals[J]),this.f[J].isOpen=!0;return}}const N={name:O.name,shellPath:O.executable,shellArgs:O.args,cwd:typeof O.cwd=="string"?O.cwd:L.URI.revive(O.cwd),env:O.env,hideFromUser:O.hideFromUser},q=new E(this.a,n,N,g);this.f.push(q),this.D.fire(q.value),q.isOpen=!0}async $acceptTerminalProcessId(n,d){this.O(n)?._setProcessId(d)}async $startExtensionTerminal(n,d){const g=this.O(n);if(!g)return{message:(0,k.localize)(0,null,n)};g.isOpen||await new Promise(N=>{const q=this.onDidOpenTerminal(async J=>{J===g.value&&(q.dispose(),N())})});const O=this.g.get(n);O?O.startSendingEvents(d):this.j[n]={initialDimensions:d}}M(n,d){const g=new A.DisposableStore;g.add(d.onProcessReady(N=>this.a.$sendProcessReady(n,N.pid,N.cwd))),g.add(d.onDidChangeProperty(N=>this.a.$sendProcessProperty(n,N))),this.s.startBuffering(n,d.onProcessData),g.add(d.onProcessExit(N=>this.N(n,N))),this.g.set(n,d);const O=this.j[n];return O&&d instanceof v&&(d.startSendingEvents(O.initialDimensions),delete this.j[n]),g}$acceptProcessAckDataEvent(n,d){this.g.get(n)?.acknowledgeDataEvent(d)}$acceptProcessInput(n,d){this.g.get(n)?.input(d)}$acceptTerminalInteraction(n){const d=this.O(n);d?.setInteractedWith()&&this.H.fire(d.value)}$acceptProcessResize(n,d,g){try{this.g.get(n)?.resize(d,g)}catch(O){if(O.code!=="EPIPE"&&O.code!=="ERR_IPC_CHANNEL_CLOSED")throw O}}$acceptProcessShutdown(n,d){this.g.get(n)?.shutdown(d)}$acceptProcessRequestInitialCwd(n){this.g.get(n)?.getInitialCwd().then(d=>this.a.$sendProcessProperty(n,{type:"initialCwd",value:d}))}$acceptProcessRequestCwd(n){this.g.get(n)?.getCwd().then(d=>this.a.$sendProcessProperty(n,{type:"cwd",value:d}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this.u.add(n),this.u.size===1&&this.a.$startLinkProvider(),new S.Disposable(()=>{this.u.delete(n),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(n,d,g){if(this.v.has(d))throw new Error(`Terminal profile provider "${d}" already registered`);return this.v.set(d,g),this.a.$registerProfileProvider(d,n.identifier.value),new S.Disposable(()=>{this.v.delete(d),this.a.$unregisterProfileProvider(d)})}registerTerminalQuickFixProvider(n,d,g){if(this.w.has(n))throw new Error(`Terminal quick fix provider "${n}" is already registered`);return this.w.set(n,g),this.a.$registerQuickFixProvider(n,d),new S.Disposable(()=>{this.w.delete(n),this.a.$unregisterQuickFixProvider(n)})}async $provideTerminalQuickFixes(n,d){const g=new m.CancellationTokenSource().token;if(g.isCancellationRequested)return;const O=this.w.get(n);if(!!O)return O.provideTerminalQuickFixes(d,g)}async $createContributedProfileTerminal(n,d){const g=new m.CancellationTokenSource().token;let O=await this.v.get(n)?.provideTerminalProfile(g);if(!g.isCancellationRequested){if(O&&!("options"in O)&&(O={options:O}),!O||!("options"in O))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in O.options){this.createExtensionTerminal(O.options,d);return}this.createTerminalFromOptions(O.options,d)}}async $provideLinks(n,d){const g=this.O(n);if(!g)return[];this.y.delete(n),this.z.get(n)?.dispose(!0);const N=new m.CancellationTokenSource;this.z.set(n,N);const q=[],J={terminal:g.value,line:d},x=[];for(const F of this.u)x.push(u.Promises.withAsyncBody(async B=>{N.token.onCancellationRequested(()=>B({provider:F,links:[]}));const z=await F.provideTerminalLinks(J,N.token)||[];N.token.isCancellationRequested||B({provider:F,links:z})}));const R=await Promise.all(x);if(N.token.isCancellationRequested)return[];const P=new Map;for(const F of R)F&&F.links.length>0&&q.push(...F.links.map(B=>{const z={id:w++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return P.set(z.id,{provider:F.provider,link:B}),z}));return this.y.set(n,P),q}$activateLink(n,d){const g=this.y.get(n)?.get(d);!g||g.provider.handleTerminalLink(g.link)}N(n,d){this.s.stopBuffering(n),this.g.delete(n),delete this.j[n];const g=this.h[n];g&&(g.dispose(),delete this.h[n]),this.a.$sendProcessExit(n,d)}O(n){return this.P(this.f,n)}P(n,d){const g=this.Q(n,d);return g!==null?n[g]:null}Q(n,d){let g=null;return n.some((O,N)=>O._id===d?(g=N,!0):!1),g}getEnvironmentVariableCollection(n){let d=this.l.get(n.identifier.value);return d||(d=new r,this.S(n.identifier.value,d)),d}R(n,d){const g=(0,D.serializeEnvironmentVariableCollection)(d.map);this.a.$setEnvironmentVariableCollection(n,d.persistent,g.length===0?void 0:g)}$initEnvironmentVariableCollections(n){n.forEach(d=>{const g=d[0],O=new r(d[1]);this.S(g,O)})}$acceptDefaultProfile(n,d){const g=this.m;this.m=n,this.n=d,g?.path!==n.path&&this.J.fire(n.path)}S(n,d){this.l.set(n,d),d.onDidChangeCollection(()=>{this.R(n,d)})}};s=qe([Ve(1,C.IExtHostRpcService)],s),e.BaseExtHostTerminalService=s;class r{get persistent(){return this.a}set persistent(n){this.a=n,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(n){this.map=new Map,this.a=!0,this.b=new i.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,d){this.d(n,{value:d,type:S.EnvironmentVariableMutatorType.Replace})}append(n,d){this.d(n,{value:d,type:S.EnvironmentVariableMutatorType.Append})}prepend(n,d){this.d(n,{value:d,type:S.EnvironmentVariableMutatorType.Prepend})}d(n,d){const g=this.map.get(n);(!g||g.value!==d.value||g.type!==d.type)&&(this.map.set(n,d),this.b.fire())}get(n){return this.map.get(n)}forEach(n,d){this.map.forEach((g,O)=>n.call(d,O,g,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let o=class extends s{constructor(n){super(!1,n)}createTerminal(n,d,g){throw new M.NotSupportedError}createTerminalFromOptions(n,d){throw new M.NotSupportedError}};o=qe([Ve(0,C.IExtHostRpcService)],o),e.WorkerExtHostTerminalService=o;function h(l){if(!(!l||typeof l=="string"))return"id"in l?{id:l.id,color:l.color}:l}function a(l){return t.ThemeColor.isThemeColor(l)?l:void 0}});var Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)},Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i};define(Ie[221],Ce([1,0,16,14,24,20,5,185,222,7,23,9,34,4,15,98,8,6,42,67,53]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m,b,f,t,c,u,p,E,v){"use strict";var w,s;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(P,F,B){this.j=B,this.c=new C.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=P.getProxy(b.MainContext.MainThreadTesting),this.h=new q(this.f),this.g=new l(this.f),F.registerArgumentProcessor({processArgument:z=>{if(z?.$mid!==15)return z;const V=z,K=V.tests[V.tests.length-1].item.extId;return this.d.get(p.TestId.root(K))?.collection.tree.get(K)?.actual??(0,t.toItemFromContext)(z)}})}createTestController(P,F,B){if(this.d.has(P))throw new Error(`Attempt to insert a duplicate controller with ID "${P}"`);const z=new k.DisposableStore,V=z.add(new t.ExtHostTestItemCollection(P,F,this.j));V.root.label=F;const K=new Map,ie=this.f,ge={items:V.root.children,get label(){return F},set label(re){F=re,V.root.label=re,ie.$updateController(P,{label:F})},get refreshHandler(){return B},set refreshHandler(re){B=re,ie.$updateController(P,{canRefresh:!!re})},get id(){return P},createRunProfile:(re,se,le,_,me)=>{let we=(0,S.hash)(re);for(;K.has(we);)we++;return new J(this.f,K,P,we,re,se,le,_,me)},createTestItem(re,se,le){return new t.TestItemImpl(P,re,se,le)},createTestRun:(re,se,le=!0)=>this.g.createTestRun(P,V,re,se,le),set resolveHandler(re){V.resolveHandler=re},get resolveHandler(){return V.resolveHandler},dispose:()=>{z.dispose()}};ie.$registerTestController(P,F,!!B),z.add((0,k.toDisposable)(()=>ie.$unregisterTestController(P)));const ue={controller:ge,collection:V,profiles:K};return this.d.set(P,ue),z.add((0,k.toDisposable)(()=>this.d.delete(P))),z.add(V.onDidGenerateDiff(re=>ie.$publishDiff(P,re.map(v.TestsDiffOp.serialize)))),ge}createTestObserver(){return this.h.checkout()}async runTests(P,F=L.CancellationToken.None){const B=n(P);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.d.get(B.controllerId);if(!z)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:P.include?.map(V=>p.TestId.fromExtHostTestItem(V,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:x[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:P.exclude?.map(V=>V.id)},F)}$syncTests(){for(const{collection:P}of this.d.values())P.flushDiff();return Promise.resolve()}$provideFileCoverage(P,F,B){return(0,i.mapFind)(this.g.trackers,V=>V.id===P?V.getCoverage(F):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(P,F,B,z){return(0,i.mapFind)(this.g.trackers,K=>K.id===P?K.getCoverage(F):void 0)?.resolveFileCoverage(B,z)??Promise.resolve([])}$configureRunProfile(P,F){this.d.get(P)?.profiles.get(F)?.configureHandler?.()}async $refreshTests(P,F){await this.d.get(P)?.controller.refreshHandler?.(F)}$publishTestResults(P){this.results=Object.freeze(P.map(F=>(0,M.deepFreeze)(c.TestResults.to(F))).concat(this.results).sort((F,B)=>B.completedAt-F.completedAt).slice(0,32)),this.c.fire()}async $expandTest(P,F){const B=this.d.get(p.TestId.fromString(P).controllerId)?.collection;B&&(await B.expand(P,F<0?1/0:F),B.flushDiff())}$acceptDiff(P){this.h.applyDiff(P.map(v.TestsDiffOp.deserialize))}async $runControllerTests(P,F){return Promise.all(P.map(B=>this.runControllerTestRequest(B,F)))}async runControllerTestRequest(P,F){const B=this.d.get(P.controllerId);if(!B)return{};const{collection:z,profiles:V}=B,K=V.get(P.profileId);if(!K)return{};const ie=P.testIds.map(se=>z.tree.get(se)).filter(D.isDefined),ge=P.excludeExtIds.map(se=>B.collection.tree.get(se)).filter(D.isDefined).filter(se=>ie.some(le=>le.fullId.compare(se.fullId)===2));if(!ie.length)return{};const ue=new u.TestRunRequest(ie.some(se=>se.actual instanceof t.TestItemRootImpl)?void 0:ie.map(se=>se.actual),ge.map(se=>se.actual),K),re=this.g.prepareForMainThreadTestRun(ue,d.fromInternal(P,B.collection),F);try{return await K.runHandler(ue,F),{}}catch(se){return{error:String(se)}}finally{re.hasRunningTasks&&!F.isCancellationRequested&&await C.Event.toPromise(re.onEnd),re.dispose()}}$cancelExtensionTestRun(P){P===void 0?this.g.cancelAllRuns():this.g.cancelRunById(P)}};r=qe([Ve(0,f.IExtHostRpcService)],r),e.ExtHostTesting=r;const o=1e4;var h;(function(R){R[R.Running=0]="Running",R[R.Cancelling=1]="Cancelling",R[R.Ended=2]="Ended"})(h||(h={}));class a extends k.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(P,F,B){super(),this.k=P,this.l=F,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new C.Emitter),this.onEnd=this.j.event,this.h=this.B(new L.CancellationTokenSource(B));const z=this.B(new T.RunOnceScheduler(()=>this.m(),o));this.B(this.h.token.onCancellationRequested(()=>z.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(P){return this.f.get(P)?.coverage}createRun(P){const F=this.k.id,B=this.k.controllerId,z=(0,m.generateUuid)(),V=new g(this.l,F,z),K=re=>(se,...le)=>{if(ge){console.warn(`Setting the state of test "${se.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(se)||(this.s(se),re(se,...le))},ie=(re,se)=>{const le=se instanceof Array?se.map(c.TestMessage.from):[c.TestMessage.from(se)];if(re.uri&&re.range){const _={range:c.Range.from(re.range),uri:re.uri};for(const me of le)me.location=me.location||_}this.l.$appendTestMessagesInRun(F,z,p.TestId.fromExtHostTestItem(re,B).toString(),le)};let ge=!1;const ue={isPersisted:this.k.isPersisted,token:this.h.token,name:P,get coverageProvider(){return V.coverageProvider},set coverageProvider(re){V.coverageProvider=re},enqueued:K(re=>{this.l.$updateTestStateInRun(F,z,p.TestId.fromExtHostTestItem(re,B).toString(),1)}),skipped:K(re=>{this.l.$updateTestStateInRun(F,z,p.TestId.fromExtHostTestItem(re,B).toString(),5)}),started:K(re=>{this.l.$updateTestStateInRun(F,z,p.TestId.fromExtHostTestItem(re,B).toString(),2)}),errored:K((re,se,le)=>{ie(re,se),this.l.$updateTestStateInRun(F,z,p.TestId.fromExtHostTestItem(re,B).toString(),6,le)}),failed:K((re,se,le)=>{ie(re,se),this.l.$updateTestStateInRun(F,z,p.TestId.fromExtHostTestItem(re,B).toString(),4,le)}),passed:K((re,se)=>{this.l.$updateTestStateInRun(F,z,p.TestId.fromExtHostTestItem(re,this.k.controllerId).toString(),3,se)}),appendOutput:(re,se,le)=>{ge||(le&&(this.k.isIncluded(le)?this.s(le):le=void 0),this.l.$appendOutputToRun(F,z,y.VSBuffer.fromString(re),se&&c.location.from(se),le&&p.TestId.fromExtHostTestItem(le,B).toString()))},end:()=>{ge||(ge=!0,this.l.$finishedTestRunTask(F,z),this.f.delete(z),this.f.size||this.p())}};return this.f.set(z,{run:ue,coverage:V}),this.l.$startedTestRunTask(F,{id:z,name:P,running:!0}),ue}m(){for(const{run:P}of this.f.values())P.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(P){if(!(P instanceof t.TestItemImpl))throw new E.InvalidTestItemError(P.id);if(this.g.has(p.TestId.fromExtHostTestItem(P,this.k.controllerId).toString()))return;const F=[],B=this.k.colllection.root;for(;;){const z=c.TestItem.from(P);if(F.unshift(z),this.g.has(z.extId)||(this.g.add(z.extId),P===B))break;P=P.parent||B}this.l.$addTestsToRun(this.k.controllerId,this.k.id,F)}}class l{get trackers(){return this.c.values()}constructor(P){this.d=P,this.c=new Map}prepareForMainThreadTestRun(P,F,B){return this.f(P,F,B)}cancelRunById(P){for(const F of this.c.values())if(F.id===P){F.cancel();return}}cancelAllRuns(){for(const P of this.c.values())P.cancel()}createTestRun(P,F,B,z,V){const K=this.c.get(B);if(K)return K.createRun(z);const ie=d.fromPublic(P,F,B,V),ge=n(B);this.d.$startedExtensionTestRun({controllerId:P,profile:ge&&{group:x[ge.kind],id:ge.profileId},exclude:B.exclude?.map(re=>p.TestId.fromExtHostTestItem(re,F.root.id).toString())??[],id:ie.id,include:B.include?.map(re=>p.TestId.fromExtHostTestItem(re,F.root.id).toString())??[F.root.id],persist:V});const ue=this.f(B,ie);return ue.onEnd(()=>{this.d.$finishedExtensionTestRun(ie.id),ue.dispose()}),ue.createRun(z)}f(P,F,B){const z=new a(F,this.d,B);return this.c.set(P,z),z.onEnd(()=>this.c.delete(P)),z}}e.TestRunCoordinator=l;const n=R=>{if(!!R.profile){if(!(R.profile instanceof J))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return R.profile}};class d{static fromPublic(P,F,B,z){return new d(P,(0,m.generateUuid)(),B.include?.map(V=>p.TestId.fromExtHostTestItem(V,P).toString())??[P],B.exclude?.map(V=>p.TestId.fromExtHostTestItem(V,P).toString())??[],z,F)}static fromInternal(P,F){return new d(P.controllerId,P.runId,P.testIds,P.excludeExtIds,!0,F)}constructor(P,F,B,z,V,K){this.controllerId=P,this.id=F,this.isPersisted=V,this.colllection=K,this.c=B.map(ie=>ie+"\0"),this.d=z.map(ie=>ie+"\0")}isIncluded(P){const F=p.TestId.fromExtHostTestItem(P,this.controllerId).toString()+"\0";for(const B of this.d)if(F===B||F.startsWith(B))return!1;for(const B of this.c)if(F===B||F.startsWith(B))return!0;return!1}}e.TestRunDto=d;class g{set coverageProvider(P){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!P||(this.c=P,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(P,F,B){this.f=P,this.g=F,this.h=B}async provideFileCoverage(P){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(P))());try{return(await this.d)?.map(c.TestCoverage.fromFile)??[]}catch(F){throw this.d=void 0,F}}async resolveFileCoverage(P,F){const B=await this.d;let z=B?.[P];return!this.c||!B||!z?[]:(z.detailedCoverage||(z=B[P]=await this.c.resolveFileCoverage?.(z,F)??z),z.detailedCoverage?.map(c.TestCoverage.fromDetailed)??[])}}class O{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(P){this.h=P,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(P){this.c.add(P)}update(P){Object.assign(P.revived,c.TestItem.toPlain(P.item)),this.c.has(P)||this.d.add(P)}remove(P){if(this.c.has(P)){this.c.delete(P);return}this.d.delete(P);const F=p.TestId.parentId(P.item.extId);if(F&&this.g.has(F.toString())){this.g.add(P.item.extId);return}this.f.add(P)}getChangeEvent(){const{c:P,d:F,f:B}=this;return{get added(){return[...P].map(z=>z.revived)},get updated(){return[...F].map(z=>z.revived)},get removed(){return[...B].map(z=>z.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class N extends v.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new C.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(P){return this.d.get(P)}getMirroredTestDataByReference(P){return this.d.get(P.id)}p(P,F){return{...P,revived:c.TestItem.toPlain(P.item),depth:F?F.depth+1:0,children:new Set}}o(){return new O(this.q)}}e.MirroredTestCollection=N;class q{constructor(P){this.d=P}checkout(){this.c||(this.c=this.f());const P=this.c;return P.observers++,{onDidChangeTest:P.tests.onDidChangeTests,get tests(){return[...P.tests.rootTests].map(F=>F.revived)},dispose:(0,A.once)(()=>{--P.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(P){return this.c?.tests.getMirroredTestDataByReference(P)}applyDiff(P){this.c?.tests.apply(P)}f(){const P=new N;return this.d.$subscribeToDiffs(),{observers:0,tests:P}}}class J{get label(){return this.d}set label(P){P!==this.d&&(this.d=P,Re(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:P}))}get isDefault(){return this.f}set isDefault(P){P!==this.f&&(this.f=P,Re(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:P}))}get tag(){return this._tag}set tag(P){P?.id!==this._tag?.id&&(this._tag=P,Re(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:P?c.TestTag.namespace(this.controllerId,P.id):null}))}get configureHandler(){return this.c}set configureHandler(P){P!==this.c&&(this.c=P,Re(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!P}))}constructor(P,F,B,z,V,K,ie,ge=!1,ue=void 0){this.controllerId=B,this.profileId=z,this.d=V,this.kind=K,this.runHandler=ie,this.f=ge,this._tag=ue,w.set(this,void 0),s.set(this,void 0),Ye(this,w,P,"f"),Ye(this,s,F,"f"),F.set(z,this);const re=x[K];if(typeof re!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);Re(this,w,"f").$publishTestRunProfile({profileId:z,controllerId:B,tag:ue?c.TestTag.namespace(this.controllerId,ue.id):null,label:V,group:re,isDefault:ge,hasConfigurationHandler:!1})}dispose(){Re(this,s,"f")?.delete(this.profileId)&&(Ye(this,s,void 0,"f"),Re(this,w,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=J,w=new WeakMap,s=new WeakMap;const x={[u.TestRunProfileKind.Coverage]:8,[u.TestRunProfileKind.Debug]:4,[u.TestRunProfileKind.Run]:2}}),define(Ie[223],Ce([1,0,16,5,4,99,8,6]),function(ee,e,i,T,y,L,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(M,D){this.i=D,this.a=new T.Emitter,this.b=new T.Emitter,this.c=new T.Emitter,this.d=new T.Emitter,this.f=new T.Emitter,this.g=new T.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=M.getProxy(y.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(m=>this.g.fire(m)),this.i.onDidChangeActiveTextEditor(m=>this.f.fire(m))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(M){const D=this.i.allEditors();return M?D:D.map(m=>m.value)}async showTextDocument(M,D,m){let b;typeof D=="number"?b={position:C.ViewColumn.from(D),preserveFocus:m}:typeof D=="object"?b={position:C.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?C.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:b={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(M.uri,b),t=f&&this.i.getEditor(f);if(t)return t.value;throw f?new Error(`Could NOT open editor for "${M.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${M.uri.toString()}".`)}createTextEditorDecorationType(M,D){return new L.TextEditorDecorationType(this.h,M,D).value}$acceptEditorPropertiesChanged(M,D){const m=this.i.getEditor(M);if(!m)throw new Error("unknown text editor");if(D.options&&m._acceptOptions(D.options),D.selections){const b=D.selections.selections.map(C.Selection.to);m._acceptSelections(b)}if(D.visibleRanges){const b=i.coalesce(D.visibleRanges.map(C.Range.to));m._acceptVisibleRanges(b)}if(D.options&&this.b.fire({textEditor:m.value,options:{...D.options,lineNumbers:C.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const b=A.TextEditorSelectionChangeKind.fromValue(D.selections.source),f=D.selections.selections.map(C.Selection.to);this.a.fire({textEditor:m.value,selections:f,kind:b})}if(D.visibleRanges){const b=i.coalesce(D.visibleRanges.map(C.Range.to));this.c.fire({textEditor:m.value,visibleRanges:b})}}$acceptEditorPositionData(M){for(const D in M){const m=this.i.getEditor(D);if(!m)throw new Error("Unknown text editor");const b=C.ViewColumn.to(M[D]);m.value.viewColumn!==b&&(m._acceptViewColumn(b),this.d.fire({textEditor:m.value,viewColumn:b}))}}getDiffInformation(M){return Promise.resolve(this.h.$getDiffInformation(M))}}e.ExtHostEditors=S}),define(Ie[224],Ce([1,0,2,3,4,7,6,8,9]),function(ee,e,i,T,y,L,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,T.createDecorator)("IExtHostTimeline");class k{constructor(m,b){this.b=new Map,this.c=new Map,this.a=m.getProxy(y.MainContext.MainThreadTimeline),b.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===12){const t=f.uri===void 0?void 0:i.URI.revive(f.uri);return this.c.get(f.source)?.get(M(t))?.get(f.handle)}return f}})}async $getTimeline(m,b,f,t){return this.b.get(m)?.provideTimeline(i.URI.revive(b),f,t)}registerTimelineProvider(m,b,f,t){const c=new L.DisposableStore,u=this.d(b.id,t,c).bind(this);let p;b.onDidChange&&(p=b.onDidChange(v=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:b.id}),this));const E=this.c;return this.f({...b,scheme:m,onDidChange:void 0,async provideTimeline(v,w,s){w?.resetCache&&(c.clear(),E.get(b.id)?.clear());const r=await b.provideTimeline(v,w,s);if(r==null)return;const o=u(v,w);return{...r,source:b.id,items:r.items.map(o)}},dispose(){for(const v of E.values())v.get(b.id)?.clear();p?.dispose(),c.dispose()}})}d(m,b,f){return(t,c)=>{let u;if(c?.cacheResults){let p=this.c.get(m);p===void 0&&(p=new Map,this.c.set(m,p));const E=M(t);u=p.get(E),u===void 0&&(u=new Map,p.set(E,u))}return p=>{const{iconPath:E,...v}=p,w=`${m}|${p.id??p.timestamp}`;u?.set(w,p);let s,r,o;p.iconPath&&(E instanceof C.ThemeIcon?o={id:E.id,color:E.color}:i.URI.isUri(E)?(s=E,r=E):{light:s,dark:r}=E);let h;return C.MarkdownString.isMarkdownString(v.tooltip)?h=A.MarkdownString.from(v.tooltip):(0,S.isString)(v.tooltip)?h=v.tooltip:C.MarkdownString.isMarkdownString(v.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),h=A.MarkdownString.from(v.detail)):(0,S.isString)(v.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),h=v.detail),{...v,id:v.id??void 0,handle:w,source:m,command:p.command?b.toInternal(p.command,f):void 0,icon:s,iconDark:r,themeIcon:o,tooltip:h,accessibilityInformation:p.accessibilityInformation}}}}f(m){if(this.b.get(m.id))throw new Error(`Timeline Provider ${m.id} already exists.`);return this.a.$registerTimelineProvider({id:m.id,label:m.label,scheme:m.scheme}),this.b.set(m.id,m),(0,L.toDisposable)(()=>{for(const f of this.c.values())f.get(m.id)?.clear();this.b.delete(m.id),this.a.$unregisterTimelineProvider(m.id),m.dispose()})}}e.ExtHostTimeline=k;function M(D){return D?.toString()}}),define(Ie[225],Ce([1,0,7,13,2,4]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(S){this.c=new Map,this.b=S.getProxy(L.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,k,M,D){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const m=D.schemes.find(b=>!C.a.has(b));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(k,M),this.b.$registerUriOpener(k,D.schemes,S,D.label),(0,i.toDisposable)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(S,k,M){const D=this.c.get(S);if(!D)throw new Error(`Unknown opener with id: ${S}`);const m=y.URI.revive(k);return D.canOpenExternalUri(m,M)}async $openUri(S,k,M){const D=this.c.get(S);if(!D)throw new Error(`Unknown opener id: '${S}'`);return D.openExternalUri(y.URI.revive(k.resolvedUri),{sourceUri:y.URI.revive(k.sourceUri)},M)}}e.ExtHostUriOpeners=C,C.a=new Set([T.Schemas.http,T.Schemas.https])}),define(Ie[226],Ce([1,0,4,2,7,11,26]),function(ee,e,i,T,y,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(k){this.c=new Set,this.d=new Map,this.b=k.getProxy(i.MainContext.MainThreadUrls)}registerUriHandler(k,M){if(this.c.has(C.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const D=A.a++;return this.c.add(C.ExtensionIdentifier.toKey(k)),this.d.set(D,M),this.b.$registerUriHandler(D,k),(0,y.toDisposable)(()=>{this.c.delete(C.ExtensionIdentifier.toKey(k)),this.d.delete(D),this.b.$unregisterUriHandler(D)})}$handleExternalUri(k,M){const D=this.d.get(k);if(!D)return Promise.resolve(void 0);try{D.handleUri(T.URI.revive(M))}catch(m){(0,L.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(k){return T.URI.revive(await this.b.$createAppUri(k))}}e.ExtHostUrls=A,A.a=0});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[59],Ce([1,0,5,13,23,2,150,170,68,4]),function(ee,e,i,T,y,L,C,A,S,k){"use strict";var M,D,m,b,f,t,c,u,p,E,v,w,s;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class r{constructor(N,q,J,x,R,P,F){M.set(this,void 0),D.set(this,void 0),m.set(this,void 0),b.set(this,void 0),f.set(this,void 0),t.set(this,void 0),c.set(this,""),u.set(this,void 0),p.set(this,!1),E.set(this,!1),v.set(this,void 0),w.set(this,void 0),this._onMessageEmitter=new i.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,s.set(this,new i.Emitter),this._onDidDispose=Re(this,s,"f").event,Ye(this,M,N,"f"),Ye(this,D,q,"f"),Ye(this,u,J,"f"),Ye(this,b,x,"f"),Ye(this,f,R,"f"),Ye(this,t,P,"f"),Ye(this,v,o(P),"f"),Ye(this,w,h(P),"f"),Ye(this,m,F,"f")}dispose(){Ye(this,p,!0,"f"),Re(this,s,"f").fire(),Re(this,s,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(N){return Ye(this,E,!0,"f"),(0,S.asWebviewUri)(N,Re(this,b,"f"))}get cspSource(){const N=Re(this,t,"f").extensionLocation;if(N.scheme===T.Schemas.https||N.scheme===T.Schemas.http){let q=N.toString();return q.endsWith("/")||(q+="/"),q+" "+S.webviewGenericCspSource}return S.webviewGenericCspSource}get html(){return this.a(),Re(this,c,"f")}set html(N){this.a(),Re(this,c,"f")!==N&&(Ye(this,c,N,"f"),Re(this,w,"f")&&!Re(this,E,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(N)&&(Ye(this,E,!0,"f"),Re(this,m,"f").report("Webview vscode-resource: uris",Re(this,t,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Re(this,D,"f").$setHtml(Re(this,M,"f"),this.b(N)))}get options(){return this.a(),Re(this,u,"f")}set options(N){this.a(),y.equals(Re(this,u,"f"),N)||Re(this,D,"f").$setOptions(Re(this,M,"f"),n(Re(this,t,"f"),Re(this,f,"f"),N)),Ye(this,u,N,"f")}async postMessage(N){if(Re(this,p,"f"))return!1;const q=(0,A.serializeWebviewMessage)(N,{serializeBuffersForPostMessage:Re(this,v,"f")});return Re(this,D,"f").$postMessage(Re(this,M,"f"),q.message,...q.buffers)}a(){if(Re(this,p,"f"))throw new Error("Webview is disposed")}b(N){if(!Re(this,w,"f"))return N;const q=Re(this,t,"f").extensionLocation?.scheme===T.Schemas.vscodeRemote,J=Re(this,t,"f").extensionLocation.scheme===T.Schemas.vscodeRemote?Re(this,t,"f").extensionLocation.authority:void 0;return N.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(x,R,P,F,B,z)=>{const V=L.URI.from({scheme:F||"file",path:decodeURIComponent(B)}),K=(0,S.asWebviewUri)(V,{isRemote:q,authority:J}).toString();return`${R}${K}${z}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(x,R,P,F,B,z)=>{const V=L.URI.from({scheme:F||"file",path:decodeURIComponent(B)}),K=(0,S.asWebviewUri)(V,{isRemote:q,authority:J}).toString();return`${R}${K}${z}`})}}e.ExtHostWebview=r,M=new WeakMap,D=new WeakMap,m=new WeakMap,b=new WeakMap,f=new WeakMap,t=new WeakMap,c=new WeakMap,u=new WeakMap,p=new WeakMap,E=new WeakMap,v=new WeakMap,w=new WeakMap,s=new WeakMap;function o(O){try{const N=(0,C.normalizeVersion)((0,C.parseVersion)(O.engines.vscode));return!!N&&N.majorBase>=1&&N.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=o;function h(O){try{const N=(0,C.normalizeVersion)((0,C.parseVersion)(O.engines.vscode));return N?N.majorBase<1||N.majorBase===1&&N.minorBase<60:!1}catch{return!1}}class a{constructor(N,q,J,x,R){this.c=q,this.d=J,this.e=x,this.f=R,this.b=new Map,this.a=N.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(N,q,J){const x=this.g(N);if(x){const{message:R}=(0,A.deserializeWebviewMessage)(q,J.value);x._onMessageEmitter.fire(R)}}$onMissingCsp(N,q){this.e.warn(`${q} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(N,q,J){const x=new r(N,this.a,d(q),this.c,this.d,J,this.f);return this.b.set(N,x),x._onDidDispose(()=>{this.b.delete(N)}),x}deleteWebview(N){this.b.delete(N)}g(N){return this.b.get(N)}}e.ExtHostWebviews=a;function l(O){return{id:O.identifier,location:O.extensionLocation}}e.toExtensionData=l;function n(O,N,q){return{enableCommandUris:q.enableCommandUris,enableScripts:q.enableScripts,enableForms:q.enableForms,portMapping:q.portMapping,localResourceRoots:q.localResourceRoots||g(O,N)}}e.serializeWebviewOptions=n;function d(O){return{enableCommandUris:O.enableCommandUris,enableScripts:O.enableScripts,enableForms:O.enableForms,portMapping:O.portMapping,localResourceRoots:O.localResourceRoots?.map(N=>L.URI.from(N))}}function g(O,N){return[...(N?.getWorkspaceFolders()||[]).map(q=>q.uri),O.extensionLocation]}}),define(Ie[227],Ce([1,0,20,222,7,13,22,2,8,59,51,4,6]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class b{constructor(r,o){this.document=r,this.b=o,this.a=1,this.c=new M.Cache("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,o){await this.f(r).undo(),o||this.disposeBackup()}async redo(r,o){await this.f(r).redo(),o||this.disposeBackup()}disposeEdits(r){for(const o of r)this.c.delete(o)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=w(this.document.uri)+this.a++;return(0,C.joinPath)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const o=this.c.get(r,0);if(!o)throw new Error("No edit found");return o}}class f{constructor(){this.a=new Map}get(r,o){return this.a.get(this.b(r,o))}add(r,o,h){const a=this.b(r,o.uri);if(this.a.has(a))throw new Error(`Document already exists for viewType:${r} resource:${o.uri}`);const l=new b(o,h);return this.a.set(a,l),l}delete(r,o){const h=this.b(r,o.uri);this.a.delete(h)}b(r,o){return`${r}@@@${o}`}}var t;(function(s){s[s.Text=0]="Text",s[s.Custom=1]="Custom"})(t||(t={}));class c{constructor(){this.a=new Map}addTextProvider(r,o,h){return this.b(0,r,o,h)}addCustomProvider(r,o,h){return this.b(1,r,o,h)}get(r){return this.a.get(r)}b(r,o,h,a){if(this.a.has(o))throw new Error(`Provider for viewType:${o} already registered`);return this.a.set(o,{type:r,extension:h,provider:a}),new m.Disposable(()=>this.a.delete(o))}}class u{constructor(r,o,h,a,l){this.d=o,this.f=h,this.g=a,this.h=l,this.b=new c,this.c=new f,this.a=r.getProxy(D.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(r,o,h,a){const l=new y.DisposableStore;return E(h)?(l.add(this.b.addTextProvider(o,r,h)),this.a.$registerTextEditorProvider((0,k.toExtensionData)(r),o,a.webviewOptions||{},{supportsMove:!!h.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(r))):(l.add(this.b.addCustomProvider(o,r,h)),p(h)&&l.add(h.onDidChangeCustomDocument(n=>{const d=this.i(o,n.document.uri);if(v(n)){const g=d.addEdit(n);this.a.$onDidEdit(n.document.uri,o,g,n.label)}else this.a.$onContentChange(n.document.uri,o)})),this.a.$registerCustomEditorProvider((0,k.toExtensionData)(r),o,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(r))),m.Disposable.from(l,new m.Disposable(()=>{this.a.$unregisterEditorProvider(o)}))}async $createCustomDocument(r,o,h,a,l){const n=this.b.get(o);if(!n)throw new Error(`No provider found for '${o}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${o}'`);const d=A.URI.revive(r),g=await n.provider.openCustomDocument(d,{backupId:h,untitledDocumentData:a?.buffer},l);let O;return p(n.provider)&&this.f&&(O=this.f.workspaceValue(n.extension)??this.f.globalValue(n.extension)),this.c.add(o,g,O),{editable:p(n.provider)}}async $disposeCustomDocument(r,o){const h=this.b.get(o);if(!h)throw new Error(`No provider found for '${o}'`);if(h.type!==1)throw new Error(`Invalid provider type for '${o}'`);const a=A.URI.revive(r),{document:l}=this.i(o,a);this.c.delete(o,l),l.dispose()}async $resolveWebviewEditor(r,o,h,a,l,n){const d=this.b.get(h);if(!d)throw new Error(`No provider found for '${h}'`);const g=S.ViewColumn.to(l),O=this.g.createNewWebview(o,a.contentOptions,d.extension),N=this.h.createNewWebviewPanel(o,h,a.title,g,a.options,O,!0),q=A.URI.revive(r);switch(d.type){case 1:{const{document:J}=this.i(h,q);return d.provider.resolveCustomEditor(J,N,n)}case 0:{const J=this.d.getDocument(q);return d.provider.resolveCustomTextEditor(J,N,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,o,h){this.i(o,r).disposeEdits(h)}async $onMoveCustomEditor(r,o,h){const a=this.b.get(h);if(!a)throw new Error(`No provider found for '${h}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${h}'`);const l=this.h.getWebviewPanel(r);if(!l)throw new Error("No webview found");const n=A.URI.revive(o),d=this.d.getDocument(n);await a.provider.moveCustomTextEditor(d,l,i.CancellationToken.None)}async $undo(r,o,h,a){return this.i(o,r).undo(h,a)}async $redo(r,o,h,a){return this.i(o,r).redo(h,a)}async $revert(r,o,h){const a=this.i(o,r);await this.j(o).revertCustomDocument(a.document,h),a.disposeBackup()}async $onSave(r,o,h){const a=this.i(o,r);await this.j(o).saveCustomDocument(a.document,h),a.disposeBackup()}async $onSaveAs(r,o,h,a){const l=this.i(o,r);return this.j(o).saveCustomDocumentAs(l.document,A.URI.revive(h),a)}async $backup(r,o,h){const a=this.i(o,r),n=await this.j(o).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},h);return a.updateBackup(n),n.id}i(r,o){const h=this.c.get(r,A.URI.revive(o));if(!h)throw new Error("No custom document found");return h}j(r){const h=this.b.get(r)?.provider;if(!h||!p(h))throw new Error("Custom document is not editable");return h}}e.ExtHostCustomEditors=u;function p(s){return!!s.onDidChangeCustomDocument}function E(s){return typeof s.resolveCustomTextEditor=="function"}function v(s){return typeof s.undo=="function"&&typeof s.redo=="function"}function w(s){const r=s.scheme===L.Schemas.file||s.scheme===L.Schemas.untitled?s.fsPath:s.toString();return(0,T.hash)(r)+""}});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[228],Ce([1,0,5,7,2,34,8,59,4,6]),function(ee,e,i,T,y,L,C,A,S,k){"use strict";var M,D,m,b,f,t,c,u,p,E,v,w,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends T.Disposable{constructor(l,n,d,g){super(),M.set(this,void 0),D.set(this,void 0),m.set(this,void 0),b.set(this,void 0),f.set(this,void 0),t.set(this,void 0),c.set(this,void 0),u.set(this,void 0),p.set(this,!0),E.set(this,void 0),v.set(this,!1),w.set(this,this.B(new i.Emitter)),this.onDidDispose=Re(this,w,"f").event,s.set(this,this.B(new i.Emitter)),this.onDidChangeViewState=Re(this,s,"f").event,Ye(this,M,l,"f"),Ye(this,D,n,"f"),Ye(this,b,d,"f"),Ye(this,m,g.viewType,"f"),Ye(this,f,g.panelOptions,"f"),Ye(this,u,g.viewColumn,"f"),Ye(this,t,g.title,"f"),Ye(this,E,g.active,"f")}dispose(){Re(this,v,"f")||(Ye(this,v,!0,"f"),Re(this,w,"f").fire(),Re(this,D,"f").$disposeWebview(Re(this,M,"f")),Re(this,b,"f").dispose(),super.dispose())}get webview(){return this.c(),Re(this,b,"f")}get viewType(){return this.c(),Re(this,m,"f")}get title(){return this.c(),Re(this,t,"f")}set title(l){this.c(),Re(this,t,"f")!==l&&(Ye(this,t,l,"f"),Re(this,D,"f").$setTitle(Re(this,M,"f"),l))}get iconPath(){return this.c(),Re(this,c,"f")}set iconPath(l){this.c(),Re(this,c,"f")!==l&&(Ye(this,c,l,"f"),Re(this,D,"f").$setIconPath(Re(this,M,"f"),y.URI.isUri(l)?{light:l,dark:l}:l))}get options(){return Re(this,f,"f")}get viewColumn(){if(this.c(),!(typeof Re(this,u,"f")=="number"&&Re(this,u,"f")<0))return Re(this,u,"f")}get active(){return this.c(),Re(this,E,"f")}get visible(){return this.c(),Re(this,p,"f")}_updateViewState(l){Re(this,v,"f")||(this.active!==l.active||this.visible!==l.visible||this.viewColumn!==l.viewColumn)&&(Ye(this,E,l.active,"f"),Ye(this,p,l.visible,"f"),Ye(this,u,l.viewColumn,"f"),Re(this,s,"f").fire({webviewPanel:this}))}reveal(l,n){this.c(),Re(this,D,"f").$reveal(Re(this,M,"f"),{viewColumn:typeof l>"u"?void 0:C.ViewColumn.from(l),preserveFocus:!!n})}c(){if(Re(this,v,"f"))throw new Error("Webview is disposed")}}M=new WeakMap,D=new WeakMap,m=new WeakMap,b=new WeakMap,f=new WeakMap,t=new WeakMap,c=new WeakMap,u=new WeakMap,p=new WeakMap,E=new WeakMap,v=new WeakMap,w=new WeakMap,s=new WeakMap;class o{static c(){return(0,L.generateUuid)()}constructor(l,n,d){this.g=n,this.h=d,this.e=new Map,this.f=new Map,this.d=l.getProxy(S.MainContext.MainThreadWebviewPanels)}createWebviewPanel(l,n,d,g,O={}){const N=typeof g=="object"?g.viewColumn:g,q={viewColumn:C.ViewColumn.from(N),preserveFocus:typeof g=="object"&&!!g.preserveFocus},J=(0,A.shouldSerializeBuffersForPostMessage)(l),x=o.c();this.d.$createWebviewPanel((0,A.toExtensionData)(l),x,n,{title:d,panelOptions:h(O),webviewOptions:(0,A.serializeWebviewOptions)(l,this.h,O),serializeBuffersForPostMessage:J},q);const R=this.g.createNewWebview(x,O,l);return this.createNewWebviewPanel(x,n,d,N,O,R,!0)}$onDidChangeWebviewPanelViewStates(l){const n=Object.keys(l);n.sort((d,g)=>{const O=l[d],N=l[g];return O.active?1:N.active?-1:+O.visible-+N.visible});for(const d of n){const g=this.getWebviewPanel(d);if(!g)continue;const O=l[d];g._updateViewState({active:O.active,visible:O.visible,viewColumn:C.ViewColumn.to(O.position)})}}async $onDidDisposeWebviewPanel(l){this.getWebviewPanel(l)?.dispose(),this.e.delete(l),this.g.deleteWebview(l)}registerWebviewPanelSerializer(l,n,d){if(this.f.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.f.set(n,{serializer:d,extension:l}),this.d.$registerSerializer(n,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(l)}),new k.Disposable(()=>{this.f.delete(n),this.d.$unregisterSerializer(n)})}async $deserializeWebviewPanel(l,n,d,g){const O=this.f.get(n);if(!O)throw new Error(`No serializer found for '${n}'`);const{serializer:N,extension:q}=O,J=this.g.createNewWebview(l,d.webviewOptions,q),x=this.createNewWebviewPanel(l,n,d.title,g,d.panelOptions,J,d.active);await N.deserializeWebviewPanel(x,d.state)}createNewWebviewPanel(l,n,d,g,O,N,q){const J=new r(l,this.d,N,{viewType:n,title:d,viewColumn:g,panelOptions:O,active:q});return this.e.set(l,J),J}getWebviewPanel(l){return this.e.get(l)}}e.ExtHostWebviewPanels=o;function h(a){return{enableFindWidget:a.enableFindWidget,retainContextWhenHidden:a.retainContextWhenHidden}}});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[229],Ce([1,0,5,7,59,8,4,6]),function(ee,e,i,T,y,L,C,A){"use strict";var S,k,M,D,m,b,f,t,c,u,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class E extends T.Disposable{constructor(s,r,o,h,a,l){super(),S.set(this,void 0),k.set(this,void 0),M.set(this,void 0),D.set(this,void 0),m.set(this,!1),b.set(this,void 0),f.set(this,void 0),t.set(this,void 0),c.set(this,void 0),u.set(this,this.B(new i.Emitter)),this.onDidChangeVisibility=Re(this,u,"f").event,p.set(this,this.B(new i.Emitter)),this.onDidDispose=Re(this,p,"f").event,Ye(this,M,o,"f"),Ye(this,f,h,"f"),Ye(this,S,s,"f"),Ye(this,k,r,"f"),Ye(this,D,a,"f"),Ye(this,b,l,"f")}dispose(){Re(this,m,"f")||(Ye(this,m,!0,"f"),Re(this,p,"f").fire(),Re(this,D,"f").dispose(),super.dispose())}get title(){return this.a(),Re(this,f,"f")}set title(s){this.a(),Re(this,f,"f")!==s&&(Ye(this,f,s,"f"),Re(this,k,"f").$setWebviewViewTitle(Re(this,S,"f"),s))}get description(){return this.a(),Re(this,t,"f")}set description(s){this.a(),Re(this,t,"f")!==s&&(Ye(this,t,s,"f"),Re(this,k,"f").$setWebviewViewDescription(Re(this,S,"f"),s))}get visible(){return Re(this,b,"f")}get webview(){return Re(this,D,"f")}get viewType(){return Re(this,M,"f")}_setVisible(s){s===Re(this,b,"f")||Re(this,m,"f")||(Ye(this,b,s,"f"),Re(this,u,"f").fire())}get badge(){return this.a(),Re(this,c,"f")}set badge(s){this.a(),!(s?.value===Re(this,c,"f")?.value&&s?.tooltip===Re(this,c,"f")?.tooltip)&&(Ye(this,c,L.ViewBadge.from(s),"f"),Re(this,k,"f").$setWebviewViewBadge(Re(this,S,"f"),s))}show(s){this.a(),Re(this,k,"f").$show(Re(this,S,"f"),!!s)}a(){if(Re(this,m,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,k=new WeakMap,M=new WeakMap,D=new WeakMap,m=new WeakMap,b=new WeakMap,f=new WeakMap,t=new WeakMap,c=new WeakMap,u=new WeakMap,p=new WeakMap;class v{constructor(s,r){this.d=r,this.b=new Map,this.c=new Map,this.a=s.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(s,r,o,h){if(this.b.has(r))throw new Error(`View provider for '${r}' already registered`);return this.b.set(r,{provider:o,extension:s}),this.a.$registerWebviewViewProvider((0,y.toExtensionData)(s),r,{retainContextWhenHidden:h?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,y.shouldSerializeBuffersForPostMessage)(s)}),new A.Disposable(()=>{this.b.delete(r),this.a.$unregisterWebviewViewProvider(r)})}async $resolveWebviewView(s,r,o,h,a){const l=this.b.get(r);if(!l)throw new Error(`No view provider found for '${r}'`);const{provider:n,extension:d}=l,g=this.d.createNewWebview(s,{},d),O=new E(s,this.a,r,o,g,!0);this.c.set(s,O),await n.resolveWebviewView(O,{state:h},a)}async $onDidChangeWebviewViewVisibility(s,r){this.e(s)._setVisible(r)}async $disposeWebviewView(s){const r=this.e(s);this.c.delete(s),r.dispose(),this.d.deleteWebview(s)}e(s){const r=this.c.get(s);if(!r)throw new Error("No webview found");return r}}e.ExtHostWebviewViews=v}),define(Ie[102],Ce([1,0,5,4,2,13,10,3,15]),function(ee,e,i,T,y,L,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class nn{get state(){return this.d}constructor(D){this.c=new i.Emitter,this.onDidChangeWindowState=this.c.event,this.d=nn.a,this.b=D.getProxy(T.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(m=>this.$onDidChangeWindowFocus(m))}$onDidChangeWindowFocus(D){D!==this.d.focused&&(this.d={...this.d,focused:D},this.c.fire(this.d))}openUri(D,m){let b;if(typeof D=="string"){b=D;try{D=y.URI.parse(D)}catch{return Promise.reject(`Invalid uri - '${D}'`)}}return(0,C.isFalsyOrWhitespace)(D.scheme)?Promise.reject("Invalid scheme - cannot be empty"):D.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${D.scheme}'`):this.b.$openUri(D,b,m)}async asExternalUri(D,m){if((0,C.isFalsyOrWhitespace)(D.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this.b.$asExternalUri(D,m);return y.URI.from(b)}};k.a={focused:!0},k=qe([Ve(0,S.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(Ie[230],Ce([1,0,200,27,15]),function(ee,e,i,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let L=class extends i.AbstractExtHostConsoleForwarder{constructor(A,S){super(A,S)}f(A,S,k){S.apply(console,k)}};L=qe([Ve(0,y.IExtHostRpcService),Ve(1,T.IExtHostInitDataService)],L),e.ExtHostConsoleForwarder=L}),define(Ie[231],Ce([1,0,14,24,20,11,5,7,123,194,43]),function(ee,e,i,T,y,L,C,A,S,k,M){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(O,N){try{return JSON.stringify(O,N)}catch{return"null"}}const b="$$ref$$",f={[b]:-1};class t{constructor(N,q){this.jsonString=N,this.referencedBuffers=q}}function c(O,N=null,q=!1){const J=[];return{jsonString:(q?m:JSON.stringify)(O,(R,P)=>{if(typeof P>"u")return f;if(typeof P=="object"){if(P instanceof T.VSBuffer){const F=J.push(P)-1;return{[b]:F}}if(N)return N(R,P)}return P}),referencedBuffers:J}}e.stringifyJsonWithBufferRefs=c;function u(O,N,q){return JSON.parse(O,(J,x)=>{if(x){const R=x[b];if(typeof R=="number")return N[R];if(q&&x.$mid===1)return q.transformIncoming(x)}return x})}e.parseJsonAndRestoreBufferRefs=u;function p(O,N){return JSON.stringify(O,N)}function E(O){return O?(N,q)=>q&&q.$mid===1?O.transformOutgoing(q):q:null}var v;(function(O){O[O.LocalSide=0]="LocalSide",O[O.OtherSide=1]="OtherSide"})(v=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(O){O[O.Responsive=0]="Responsive",O[O.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const s=()=>{},r=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class h extends A.Disposable{constructor(N,q=null,J=null){super(),this[D]=!0,this.b=this.B(new C.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=q,this.g=J,this.h=E(this.g),this.j=!1,this.k=[],this.l=[];for(let x=0,R=M.ProxyIdentifier.count;x<R;x++)this.k[x]=null,this.l[x]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new i.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(x=>this.G(x))}dispose(){this.j=!0,Object.keys(this.s).forEach(N=>{this.s[N].resolveErr(L.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(N){this.u===0&&(this.v=Date.now()+h.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(N){this.v=Date.now()+h.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(N){this.t!==N&&(this.t=N,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(N){return this.g?(0,S.transformIncomingURIs)(N,this.g):N}getProxy(N){const{nid:q,sid:J}=N;return this.l[q]||(this.l[q]=this.F(q,J)),this.l[q]}F(N,q){const J={get:(x,R)=>(typeof R=="string"&&!x[R]&&R.charCodeAt(0)===36&&(x[R]=(...P)=>this.O(N,R,P)),R===o?q:x[R])};return new Proxy(Object.create(null),J)}set(N,q){return this.k[N.nid]=q,q}assertRegistered(N){for(let q=0,J=N.length;q<J;q++){const x=N[q];if(!this.k[x.nid])throw new Error(`Missing proxy instance ${x.sid}`)}}G(N){if(this.j)return;const q=N.byteLength,J=a.read(N,0),x=J.readUInt8(),R=J.readUInt32();switch(x){case 1:case 2:{let{rpcId:P,method:F,args:B}=n.deserializeRequestJSONArgs(J);this.g&&(B=(0,S.transformIncomingURIs)(B,this.g)),this.H(q,R,P,F,B,x===2);break}case 3:case 4:{let{rpcId:P,method:F,args:B}=n.deserializeRequestMixedArgs(J);this.g&&(B=(0,S.transformIncomingURIs)(B,this.g)),this.H(q,R,P,F,B,x===4);break}case 5:{this.f?.logIncoming(q,R,0,"ack"),this.z(R);break}case 6:{this.I(q,R);break}case 7:{this.J(q,R,void 0);break}case 9:{let P=n.deserializeReplyOKJSON(J);this.g&&(P=(0,S.transformIncomingURIs)(P,this.g)),this.J(q,R,P);break}case 10:{const P=n.deserializeReplyOKJSONWithBuffers(J,this.g);this.J(q,R,P);break}case 8:{const P=n.deserializeReplyOKVSBuffer(J);this.J(q,R,P);break}case 11:{let P=n.deserializeReplyErrError(J);this.g&&(P=(0,S.transformIncomingURIs)(P,this.g)),this.L(q,R,P);break}case 12:{this.L(q,R,void 0);break}default:console.error("received unexpected message"),console.error(N)}}H(N,q,J,x,R,P){this.f?.logIncoming(N,q,1,`receiveRequest ${(0,M.getStringIdentifierForProxy)(J)}.${x}(`,R);const F=String(q);let B,z;if(P){const K=new y.CancellationTokenSource;R.push(K.token),B=this.M(J,x,R),z=()=>K.cancel()}else B=this.M(J,x,R),z=s;this.p[F]=z;const V=n.serializeAcknowledged(q);this.f?.logOutgoing(V.byteLength,q,1,"ack"),this.c.send(V),B.then(K=>{delete this.p[F];const ie=n.serializeReplyOK(q,K,this.h);this.f?.logOutgoing(ie.byteLength,q,1,"reply:",K),this.c.send(ie)},K=>{delete this.p[F];const ie=n.serializeReplyErr(q,K);this.f?.logOutgoing(ie.byteLength,q,1,"replyErr:",K),this.c.send(ie)})}I(N,q){this.f?.logIncoming(N,q,1,"receiveCancel");const J=String(q);this.p[J]?.()}J(N,q,J){this.f?.logIncoming(N,q,0,"receiveReply:",J);const x=String(q);if(!this.s.hasOwnProperty(x))return;const R=this.s[x];delete this.s[x],R.resolveOk(J)}L(N,q,J){this.f?.logIncoming(N,q,0,"receiveReplyErr:",J);const x=String(q);if(!this.s.hasOwnProperty(x))return;const R=this.s[x];delete this.s[x];let P;J&&(J.$isError?(P=new Error,P.name=J.name,P.message=J.message,P.stack=J.stack):P=J),R.resolveErr(P)}M(N,q,J){try{return Promise.resolve(this.N(N,q,J))}catch(x){return Promise.reject(x)}}N(N,q,J){const x=this.k[N];if(!x)throw new Error("Unknown actor "+(0,M.getStringIdentifierForProxy)(N));const R=x[q];if(typeof R!="function")throw new Error("Unknown method "+q+" on actor "+(0,M.getStringIdentifierForProxy)(N));return R.apply(x,J)}O(N,q,J){if(this.j)return new k.CanceledLazyPromise;let x=null;if(J.length>0&&y.CancellationToken.isCancellationToken(J[J.length-1])&&(x=J.pop()),x&&x.isCancellationRequested)return Promise.reject(L.canceled());const R=n.serializeRequestArguments(J,this.h),P=++this.m,F=String(P),B=new k.LazyPromise;x&&x.onCancellationRequested(()=>{const V=n.serializeCancel(P);this.f?.logOutgoing(V.byteLength,P,0,"cancel"),this.c.send(n.serializeCancel(P))}),this.s[F]=B,this.y(P);const z=n.serializeRequest(P,N,q,R,!!x);return this.f?.logOutgoing(z.byteLength,P,0,`request: ${(0,M.getStringIdentifierForProxy)(N)}.${q}(`,J),this.c.send(z),B}}e.RPCProtocol=h,D=r,h.a=3*1e3;class a{static alloc(N,q,J){const x=new a(T.VSBuffer.alloc(J+1+4),0);return x.writeUInt8(N),x.writeUInt32(q),x}static read(N,q){return new a(N,q)}get buffer(){return this.a}constructor(N,q){this.a=N,this.b=q}static sizeUInt8(){return 1}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const J=this.a.slice(this.b,this.b+N).toString();return this.b+=N,J}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const J=this.a.slice(this.b,this.b+N).toString();return this.b+=N,J}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const q=this.a.slice(this.b,this.b+N);return this.b+=N,q}static sizeMixedArray(N){let q=0;q+=1;for(let J=0,x=N.length;J<x;J++){const R=N[J];switch(q+=1,R.type){case 1:q+=this.sizeLongString(R.value);break;case 2:q+=this.sizeVSBuffer(R.value);break;case 3:q+=this.sizeUInt32,q+=this.sizeLongString(R.value);for(let P=0;P<R.buffers.length;++P)q+=this.sizeVSBuffer(R.buffers[P]);break;case 4:break}}return q}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let q=0,J=N.length;q<J;q++){const x=N[q];switch(x.type){case 1:this.writeUInt8(1),this.writeLongString(x.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(x.value);break;case 3:this.writeUInt8(3),this.writeUInt32(x.buffers.length),this.writeLongString(x.value);for(let R=0;R<x.buffers.length;++R)this.writeBuffer(x.buffers[R]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const q=new Array(N);for(let J=0;J<N;J++)switch(this.readUInt8()){case 1:q[J]=this.readLongString();break;case 2:q[J]=this.readVSBuffer();break;case 3:{const R=this.readUInt32(),P=this.readLongString(),F=[];for(let B=0;B<R;++B)F.push(this.readVSBuffer());q[J]=new M.SerializableObjectWithBuffers(u(P,F,null));break}case 4:q[J]=void 0;break}return q}}a.sizeUInt32=4;var l;(function(O){O[O.Simple=0]="Simple",O[O.Mixed=1]="Mixed"})(l||(l={}));class n{static a(N){for(let q=0,J=N.length;q<J;q++)if(N[q]instanceof T.VSBuffer||N[q]instanceof M.SerializableObjectWithBuffers||typeof N[q]>"u")return!0;return!1}static serializeRequestArguments(N,q){if(this.a(N)){const J=[];for(let x=0,R=N.length;x<R;x++){const P=N[x];if(P instanceof T.VSBuffer)J[x]={type:2,value:P};else if(typeof P>"u")J[x]={type:4};else if(P instanceof M.SerializableObjectWithBuffers){const{jsonString:F,referencedBuffers:B}=c(P.value,q);J[x]={type:3,value:T.VSBuffer.fromString(F),buffers:B}}else J[x]={type:1,value:T.VSBuffer.fromString(p(P,q))}}return{type:1,args:J}}return{type:0,args:p(N,q)}}static serializeRequest(N,q,J,x,R){switch(x.type){case 0:return this.b(N,q,J,x.args,R);case 1:return this.c(N,q,J,x.args,R)}}static b(N,q,J,x,R){const P=T.VSBuffer.fromString(J),F=T.VSBuffer.fromString(x);let B=0;B+=a.sizeUInt8(),B+=a.sizeShortString(P),B+=a.sizeLongString(F);const z=a.alloc(R?2:1,N,B);return z.writeUInt8(q),z.writeShortString(P),z.writeLongString(F),z.buffer}static deserializeRequestJSONArgs(N){const q=N.readUInt8(),J=N.readShortString(),x=N.readLongString();return{rpcId:q,method:J,args:JSON.parse(x)}}static c(N,q,J,x,R){const P=T.VSBuffer.fromString(J);let F=0;F+=a.sizeUInt8(),F+=a.sizeShortString(P),F+=a.sizeMixedArray(x);const B=a.alloc(R?4:3,N,F);return B.writeUInt8(q),B.writeShortString(P),B.writeMixedArray(x),B.buffer}static deserializeRequestMixedArgs(N){const q=N.readUInt8(),J=N.readShortString(),x=N.readMixedArray(),R=new Array(x.length);for(let P=0,F=x.length;P<F;P++){const B=x[P];typeof B=="string"?R[P]=JSON.parse(B):R[P]=B}return{rpcId:q,method:J,args:R}}static serializeAcknowledged(N){return a.alloc(5,N,0).buffer}static serializeCancel(N){return a.alloc(6,N,0).buffer}static serializeReplyOK(N,q,J){if(typeof q>"u")return this.d(N);if(q instanceof T.VSBuffer)return this.e(N,q);if(q instanceof M.SerializableObjectWithBuffers){const{jsonString:x,referencedBuffers:R}=c(q.value,J,!0);return this.g(N,x,R)}else return this.f(N,m(q,J))}static d(N){return a.alloc(7,N,0).buffer}static e(N,q){let J=0;J+=a.sizeVSBuffer(q);const x=a.alloc(8,N,J);return x.writeVSBuffer(q),x.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,q){const J=T.VSBuffer.fromString(q);let x=0;x+=a.sizeLongString(J);const R=a.alloc(9,N,x);return R.writeLongString(J),R.buffer}static g(N,q,J){const x=T.VSBuffer.fromString(q);let R=0;R+=a.sizeUInt32,R+=a.sizeLongString(x);for(const F of J)R+=a.sizeVSBuffer(F);const P=a.alloc(10,N,R);P.writeUInt32(J.length),P.writeLongString(x);for(const F of J)P.writeBuffer(F);return P.buffer}static deserializeReplyOKJSON(N){const q=N.readLongString();return JSON.parse(q)}static deserializeReplyOKJSONWithBuffers(N,q){const J=N.readUInt32(),x=N.readLongString(),R=[];for(let P=0;P<J;++P)R.push(N.readVSBuffer());return new M.SerializableObjectWithBuffers(u(x,R,q))}static serializeReplyErr(N,q){const J=q?m(L.transformErrorForSerialization(q),null):void 0;if(typeof J!="string")return this.h(N);const x=T.VSBuffer.fromString(J);let R=0;R+=a.sizeLongString(x);const P=a.alloc(11,N,R);return P.writeLongString(x),P.buffer}static deserializeReplyErrError(N){const q=N.readLongString();return JSON.parse(q)}static h(N){return a.alloc(12,N,0).buffer}}var d;(function(O){O[O.RequestJSONArgs=1]="RequestJSONArgs",O[O.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",O[O.RequestMixedArgs=3]="RequestMixedArgs",O[O.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",O[O.Acknowledged=5]="Acknowledged",O[O.Cancel=6]="Cancel",O[O.ReplyOKEmpty=7]="ReplyOKEmpty",O[O.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",O[O.ReplyOKJSON=9]="ReplyOKJSON",O[O.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",O[O.ReplyErrError=11]="ReplyErrError",O[O.ReplyErrEmpty=12]="ReplyErrEmpty"})(d||(d={}));var g;(function(O){O[O.String=1]="String",O[O.VSBuffer=2]="VSBuffer",O[O.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",O[O.Undefined=4]="Undefined"})(g||(g={}))}),define(Ie[232],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const i=function(L){const C=A=>{self.removeEventListener("message",C);const S=A.data;Object.defineProperties(self,{postMessage:{value(k,M){S.postMessage(k,M)}},onmessage:{get(){return S.onmessage},set(k){S.onmessage=k}}}),S.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};self.addEventListener("message",C)}.toString();class T extends EventTarget{constructor(L,C,A){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${i})('${C}'))`,k=new Blob([S],{type:"application/javascript"}),M=URL.createObjectURL(k),D=new MessageChannel,m=M,b={type:"_newWorker",id:m,port:D.port2,url:M,options:A};L(b,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{L({type:"_terminateWorker",id:m}),URL.revokeObjectURL(M),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(f){D.port1.onmessage=f}},onmessageerror:{get(){return D.port1.onmessageerror},set(f){D.port1.onmessageerror=f}}}),D.port1.addEventListener("messageerror",f=>{const t=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(t)}),D.port1.addEventListener("message",f=>{const t=new MessageEvent("message",{data:f.data});this.dispatchEvent(t)}),D.port1.start()}}e.NestedWorker=T}),define(Ie[233],Ce([1,0,5,30,41,3,36,11,14]),function(ee,e,i,T,y,L,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new y.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new y.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new y.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,L.createDecorator)(e.OUTPUT_SERVICE_ID);var k;(function(b){b[b.Append=1]="Append",b[b.Replace=2]="Replace",b[b.Clear=3]="Clear"})(k=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class M{constructor(){this.a=new Map,this.b=new i.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new i.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(f){this.a.has(f.id)||(this.a.set(f.id,f),this.b.fire(f.id))}getChannels(){const f=[];return this.a.forEach(t=>f.push(t)),f}getChannel(f){return this.a.get(f)}removeChannel(f){this.a.delete(f),this.c.fire(f)}}T.Registry.add(e.Extensions.OutputChannels,new M);function D(b,f,t,c,u){return(0,S.createCancelablePromise)(async p=>{await(0,C.whenProviderRegistered)(t,c);const E=T.Registry.as(e.Extensions.OutputChannels);try{await m(t,1,c,u,p),E.registerChannel({id:b,label:f,file:t,log:!0})}catch(v){(0,A.isCancellationError)(v)||u.error("Error while registering log channel",t.toString(),(0,A.getErrorMessage)(v))}})}e.registerLogChannel=D;async function m(b,f,t,c,u){if(!await t.exists(b)){if(u.isCancellationRequested)throw new A.CancellationError;if(f>10)throw new Error("Timed out while waiting for file to be created");c.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",b.toString()),await(0,S.timeout)(1e3,u),await m(b,f+1,t,c,u)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new y.RawContextKey("activeOutputChannel","")}),define(Ie[103],Ce([1,0,4,3,15,26,12,233,57,27,37,117,24,9,36,5,7]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m,b,f,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class u extends C.AbstractMessageLogger{get disposed(){return this.l}constructor(w,s,r,o,h){super(),this.id=w,this.name=s,this.m=r,this.n=o,this.extension=h,this.k=0,this.l=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(a=>this.setLevel(a)))}get logLevel(){return this.getLevel()}appendLine(w){this.append(w+`
`)}append(w){this.info(w)}clear(){const w=this.k;this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Clear,w)}replace(w){const s=this.k;this.info(w),this.n.$update(this.id,A.OutputChannelUpdateMode.Replace,s),this.visible&&this.m.flush()}show(w,s){this.m.flush(),this.n.$reveal(this.id,!!(typeof w=="boolean"?w:s))}hide(){this.n.$close(this.id)}g(w,s){this.k+=m.VSBuffer.fromString(s).byteLength,(0,C.log)(this.m,w,s),this.visible&&(this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class p extends u{appendLine(w){this.append(w)}}let E=class{constructor(w,s,r,o,h,a){this.i=s,this.j=r,this.k=o,this.l=h,this.m=a,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=w.getProxy(i.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(s.logsLocation,`output_logging_${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(w){this.h=w;for(const[s,r]of this.g)r.visible=s===this.h}createOutputChannel(w,s,r){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const o=typeof s=="object"&&s.log,h=(0,b.isString)(s)?s:void 0;if((0,b.isString)(h)&&!h.trim())throw new Error("illegal argument `languageId`. must not be empty");let a;const l=this.i.environment.extensionLogLevel?.find(([d])=>L.ExtensionIdentifier.equals(r.identifier,d))?.[1];l&&(a=(0,C.parseLogLevel)(l));const n=o?this.o(w,a,r):this.n(w,h,r);return n.then(d=>{this.g.set(d.id,d),d.visible=d.id===this.h}),o?this.r(w,a??this.m.getLevel(),n):this.q(w,n)}async n(w,s,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const o=await this.c,h=this.k.extUri.joinPath(o,`${this.f++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.l.createLogger(h,{always:!0,donotRotate:!0,donotUseFormatters:!0}),l=await this.a.$register(w,h,!1,s,r.identifier.value);return new u(l,w,a,this.a,r)}async o(w,s,r){const o=await this.p(r),h=this.k.extUri.joinPath(o,`${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.l.createLogger(h,{name:w},s),l=await this.a.$register(w,h,!0,void 0,r.identifier.value);return new p(l,w,a,this.a,r)}p(w){let s=this.d.get(w.identifier.value);if(!s){const r=this.k.extUri.joinPath(this.i.logsLocation,w.identifier.value);this.d.set(w.identifier.value,s=(async()=>{try{await this.j.value.createDirectory(r)}catch(o){if((0,f.toFileSystemProviderErrorCode)(o)!==f.FileSystemProviderErrorCode.FileExists)throw o}return r})())}return s}q(w,s){let r=!1;const o=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return w},append(h){o(),s.then(a=>a.append(h))},appendLine(h){o(),s.then(a=>a.appendLine(h))},clear(){o(),s.then(h=>h.clear())},replace(h){o(),s.then(a=>a.replace(h))},show(h,a){o(),s.then(l=>l.show(h,a))},hide(){o(),s.then(h=>h.hide())},dispose(){r=!0,s.then(h=>h.dispose())}}}r(w,s,r){const o=new c.DisposableStore,h=()=>{if(o.isDisposed)throw new Error("Channel has been closed")},a=o.add(new t.Emitter);return r.then(l=>{o.add(l),o.add(l.onDidChangeLogLevel(n=>{s=n,a.fire(n)}))}),{...this.q(w,r),get logLevel(){return s},onDidChangeLogLevel:a.event,trace(l,...n){h(),r.then(d=>d.trace(l,...n))},debug(l,...n){h(),r.then(d=>d.debug(l,...n))},info(l,...n){h(),r.then(d=>d.info(l,...n))},warn(l,...n){h(),r.then(d=>d.warn(l,...n))},error(l,...n){h(),r.then(d=>d.error(l,...n))},dispose(){o.dispose()}}}};E=qe([Ve(0,y.IExtHostRpcService),Ve(1,k.IExtHostInitDataService),Ve(2,S.IExtHostConsumerFileSystem),Ve(3,M.IExtHostFileSystemInfo),Ve(4,C.ILoggerService),Ve(5,C.ILogService)],E),e.ExtHostOutputService=E,e.IExtHostOutputService=(0,T.createDecorator)("IExtHostOutputService")}),define(Ie[234],Ce([1,0,3]),function(ee,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,i.createDecorator)("remoteAgentService")}),define(Ie[235],Ce([1,0,39,13,19,21,22,2,3,166,50,181,234]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let b=class rn{constructor(t,c,u,p){this.d=t,this.e=c,this.f=u,this.g=p,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const E=await this.e.getEnvironment();return this.c=E?.userHome??t})()}hasValidBasename(t,c,u){return typeof c=="string"||typeof c>"u"?this.a.then(p=>this.h(t,p,c)):this.h(t,c,u)}h(t,c,u){return t.scheme===T.Schemas.file||t.scheme===T.Schemas.vscodeRemote?(0,i.isValidBasename)(u??(0,C.basename)(t),c===1):!0}get defaultUriScheme(){return rn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,c){if(t.remoteAuthority)return T.Schemas.vscodeRemote;const u=(0,k.getVirtualWorkspaceScheme)(c.getWorkspace());if(u)return u;const p=c.getWorkspace().folders[0];if(p)return p.uri.scheme;const E=c.getWorkspace().configuration;return E?E.scheme:T.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?y.win32:y.posix)}async fileURI(t){let c="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const p=t.indexOf("/",2);p===-1?(c=t.substring(2),t="/"):(c=t.substring(2,p),t=t.substring(p)||"/")}return A.URI.from({scheme:T.Schemas.file,authority:c,path:t,query:"",fragment:""})}};b=qe([Ve(1,m.IRemoteAgentService),Ve(2,D.IWorkbenchEnvironmentService),Ve(3,M.IWorkspaceContextService)],b),e.AbstractPathService=b}),define(Ie[104],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class i{constructor(C,A){this.line=C,this.character=A}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,A){return new i(0,0)}with(C){return new i(0,0)}}e.Position=i;class T{constructor(C,A,S,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new i(C,A),this.end=new i(S,k)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new T(0,0,0,0)}with(C){return new T(0,0,0,0)}}e.Range=T;var y;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(y=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ie[44],Ce([1,0,16,35,23,39,10,3,19,11,104,14]),function(ee,e,i,T,y,L,C,A,S,k,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return M.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",b=" characters skipped \u27EB",f=(m.length+b.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var t;(function(ue){ue[ue.file=0]="file",ue[ue.text=1]="text"})(t=e.SearchProviderType||(e.SearchProviderType={}));var c;(function(ue){ue[ue.File=1]="File",ue[ue.Text=2]="Text"})(c=e.QueryType||(e.QueryType={}));function u(ue){return!!ue.preview}e.resultIsMatch=u;function p(ue){return!!ue.resource}e.isFileMatch=p;function E(ue){return!!ue.message}e.isProgressMessage=E;var v;(function(ue){ue[ue.Normal=0]="Normal",ue[ue.NewSearchStarted=1]="NewSearchStarted"})(v=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class w{constructor(re){this.resource=re,this.results=[]}}e.FileMatch=w;class s{constructor(re,se,le){this.ranges=se;const _=Array.isArray(se)?se:[se];if(le&&le.matchLines===1&&r(_)){re=(0,C.getNLines)(re,le.matchLines);let me="",we=0,Me=0;const We=Math.floor(le.charsPerLine/5),Qe=[];for(const Te of _){const De=Math.max(Te.startColumn-We,0),ke=Te.startColumn+le.charsPerLine;if(De>Me+We+f){const oe=m+(De-Me)+b;me+=oe+re.slice(De,ke),we+=De-(Me+oe.length)}else me+=re.slice(Me,ke);Qe.push(new h(0,Te.startColumn-we,Te.endColumn-we)),Me=ke}this.preview={text:me,matches:Array.isArray(this.ranges)?Qe:Qe[0]}}else{const me=Array.isArray(se)?se[0].startLineNumber:se.startLineNumber;this.preview={text:re,matches:(0,i.mapArrayOrNot)(se,we=>new o(we.startLineNumber-me,we.startColumn,we.endLineNumber-me,we.endColumn))}}}}e.TextSearchMatch=s;function r(ue){const re=ue[0].startLineNumber;for(const se of ue)if(se.startLineNumber!==re||se.endLineNumber!==re)return!1;return!0}class o{constructor(re,se,le,_){this.startLineNumber=re,this.startColumn=se,this.endLineNumber=le,this.endColumn=_}}e.SearchRange=o;class h extends o{constructor(re,se,le){super(re,se,re,le)}}e.OneLineRange=h;var a;(function(ue){ue.List="list",ue.Tree="tree"})(a=e.ViewMode||(e.ViewMode={}));var l;(function(ue){ue.Default="default",ue.FileNames="fileNames",ue.Type="type",ue.Modified="modified",ue.CountDescending="countDescending",ue.CountAscending="countAscending"})(l=e.SearchSortOrder||(e.SearchSortOrder={}));function n(ue,re=!0){const se=ue&&ue.files&&ue.files.exclude,le=re&&ue&&ue.search&&ue.search.exclude;if(!se&&!le)return;if(!se||!le)return se||le;let _=Object.create(null);return _=y.mixin(_,y.deepClone(se)),_=y.mixin(_,y.deepClone(le),!0),_}e.getExcludes=n;function d(ue,re){return ue.excludePattern&&T.match(ue.excludePattern,re)?!1:ue.includePattern||ue.usingSearchPaths?ue.includePattern&&T.match(ue.includePattern,re)?!0:ue.usingSearchPaths?!!ue.folderQueries&&ue.folderQueries.some(se=>{const le=se.folder.fsPath;if(L.isEqualOrParent(re,le)){const _=S.relative(le,re);return!se.includePattern||!!T.match(se.includePattern,_)}else return!1}):!1:!0}e.pathIncludedInQuery=d;var g;(function(ue){ue[ue.unknownEncoding=1]="unknownEncoding",ue[ue.regexParseError=2]="regexParseError",ue[ue.globParseError=3]="globParseError",ue[ue.invalidLiteral=4]="invalidLiteral",ue[ue.rgProcessError=5]="rgProcessError",ue[ue.other=6]="other",ue[ue.canceled=7]="canceled"})(g=e.SearchErrorCode||(e.SearchErrorCode={}));class O extends Error{constructor(re,se){super(re),this.code=se}}e.SearchError=O;function N(ue){const re=ue.message;if((0,k.isCancellationError)(ue))return new O(re,g.canceled);try{const se=JSON.parse(re);return new O(se.message,se.code)}catch{return new O(re,g.other)}}e.deserializeSearchError=N;function q(ue){const re={message:ue.message,code:ue.code};return new Error(JSON.stringify(re))}e.serializeSearchError=q;function J(ue){return ue.type==="error"?!0:ue.type==="success"}e.isSerializedSearchComplete=J;function x(ue){return ue.type==="success"}e.isSerializedSearchSuccess=x;function R(ue){return!!ue.path}e.isSerializedFileMatch=R;function P(ue,re){const se=ue.searchPath?ue.searchPath:ue.relativePath;return(0,C.fuzzyContains)(se,re)}e.isFilePatternMatch=P;class F{constructor(re){this.path=re,this.results=[]}addMatch(re){this.results.push(re)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=F;function B(ue,re){const se={...ue||{},...re||{}};return Object.keys(se).filter(le=>{const _=se[le];return typeof _=="boolean"&&_})}e.resolvePatternsForProvider=B;class z{constructor(re,se){this.c=null,this.a={...re.excludePattern||{},...se.excludePattern||{}},this.b=T.parse(this.a);let le=re.includePattern;se.includePattern&&(le?le={...le,...se.includePattern}:le=se.includePattern),le&&(this.c=T.parse(le))}matchesExcludesSync(re,se,le){return!!(this.b&&this.b(re,se,le))}includedInQuerySync(re,se,le){return!(this.b&&this.b(re,se,le)||this.c&&!this.c(re,se,le))}includedInQuery(re,se,le){const _=this.b(re,se,le),me=()=>this.c?!!this.c(re,se,le):!0;return(0,D.isThenable)(_)?_.then(we=>we?!1:me()):me()}hasSiblingExcludeClauses(){return V(this.a)}}e.QueryGlobTester=z;function V(ue){for(const re in ue)if(typeof ue[re]!="boolean")return!0;return!1}function K(ue){if(!ue)return;let re;return se=>(re||(re=(ue()||Promise.resolve([])).then(le=>le?ge(le):{})),re.then(le=>!!le[se]))}e.hasSiblingPromiseFn=K;function ie(ue){if(!ue)return;let re;return se=>{if(!re){const le=ue();re=le?ge(le):{}}return!!re[se]}}e.hasSiblingFn=ie;function ge(ue){const re={};for(const se of ue)re[se]=!0;return re}}),define(Ie[31],Ce([1,0,16,14,20,5,7,46,13,111,22,10,9,2,140,3,12,155,50,37,27,15,8,6,52,44,4]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m,b,f,t,c,u,p,E,v,w,s,r,o,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function l(x,R,P){return new M.ExtUri(F=>O(F,P)).isEqual(x,R)}function n(x,R,P){return l(x.uri,R.uri,P)?0:(0,D.compare)(x.uri.toString(),R.uri.toString())}function d(x,R,P){return x.index!==R.index?x.index<R.index?-1:1:l(x.uri,R.uri,P)?(0,D.compare)(x.name,R.name):(0,D.compare)(x.uri.toString(),R.uri.toString())}function g(x,R,P,F){const B=x.slice(0).sort((V,K)=>P(V,K,F)),z=R.slice(0).sort((V,K)=>P(V,K,F));return(0,i.delta)(B,z,(V,K)=>P(V,K,F))}function O(x,R){const P=R.getCapabilities(x.scheme);return!(P&&P&1024)}class N extends p.Workspace{static toExtHostWorkspace(R,P,F,B){if(!R)return{workspace:null,added:[],removed:[]};const{id:z,name:V,folders:K,configuration:ie,transient:ge,isUntitled:ue}=R,re=[],se=P;P?K.forEach((we,Me)=>{const We=b.URI.revive(we.uri),Qe=N.e(F||P,We,B);Qe?(Qe.name=we.name,Qe.index=we.index,re.push(Qe)):re.push({uri:We,name:we.name,index:Me})}):re.push(...K.map(({uri:we,name:Me,index:We})=>({uri:b.URI.revive(we),name:Me,index:We}))),re.sort((we,Me)=>we.index<Me.index?-1:1);const le=new N(z,V,re,!!ge,ie?b.URI.revive(ie):null,!!ue,we=>O(we,B)),{added:_,removed:me}=g(se?se.workspaceFolders:[],le.workspaceFolders,n,B);return{workspace:le,added:_,removed:me}}static e(R,P,F){for(let B=0;B<R.folders.length;B++){const z=R.workspaceFolders[B];if(l(z.uri,P,F))return z}}constructor(R,P,F,B,z,V,K){super(R,F.map(ie=>new p.WorkspaceFolder(ie)),B,z,K),this.s=P,this.t=V,this.o=[],this.q=A.TernarySearchTree.forUris(K),F.forEach(ie=>{this.o.push(ie),this.q.set(ie.uri,ie)})}get name(){return this.s}get isUntitled(){return this.t}get workspaceFolders(){return this.o.slice(0)}getWorkspaceFolder(R,P){return P&&this.q.get(R)&&(R=(0,M.dirname)(R)),this.q.findSubstr(R)}resolveWorkspaceFolder(R){return this.q.get(R)}}let q=class{constructor(R,P,F,B,z){this.c=new L.Emitter,this.onDidChangeWorkspace=this.c.event,this.e=new L.Emitter,this.onDidGrantWorkspaceTrust=this.e.event,this.t=[],this.u=!1,this.v=new Map,this.y=0,this.g=B,this.q=F,this.s=z,this.h=new k.Counter,this.j=new T.Barrier,this.n=R.getProxy(a.MainContext.MainThreadWorkspace),this.o=R.getProxy(a.MainContext.MainThreadMessageService);const V=P.workspace;this.k=V?new N(V.id,V.name,[],!!V.transient,V.configuration?b.URI.revive(V.configuration):null,!!V.isUntitled,K=>O(K,F)):void 0}$initializeWorkspace(R,P){this.u=P,this.$acceptWorkspaceData(R),this.j.open()}waitForInitializeCall(){return this.j.wait()}get workspace(){return this.w}get name(){return this.w?this.w.name:void 0}get workspaceFile(){if(this.w&&this.w.configuration)return this.w.isUntitled?b.URI.from({scheme:S.Schemas.untitled,path:(0,M.basename)((0,M.dirname)(this.w.configuration))}):this.w.configuration}get w(){return this.l||this.k}getWorkspaceFolders(){if(!!this.w)return this.w.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.j.wait(),!!this.w)return this.w.workspaceFolders.slice(0)}updateWorkspaceFolders(R,P,F,...B){const z=[];if(Array.isArray(B)&&B.forEach(ue=>{b.URI.isUri(ue.uri)&&!z.some(re=>l(re.uri,ue.uri,this.q))&&z.push({uri:ue.uri,name:ue.name||(0,M.basenameOrAuthority)(ue.uri)})}),this.l||[P,F].some(ue=>typeof ue!="number"||ue<0)||F===0&&z.length===0)return!1;const V=this.w?this.w.workspaceFolders:[];if(P+F>V.length)return!1;const K=V.slice(0);K.splice(P,F,...z.map(ue=>({uri:ue.uri,name:ue.name||(0,M.basenameOrAuthority)(ue.uri),index:void 0})));for(let ue=0;ue<K.length;ue++){const re=K[ue];if(K.some((se,le)=>le!==ue&&l(re.uri,se.uri,this.q)))return!1}K.forEach((ue,re)=>ue.index=re);const{added:ie,removed:ge}=g(V,K,d,this.q);if(ie.length===0&&ge.length===0)return!1;if(this.n){const ue=R.displayName||R.name;this.n.$updateWorkspaceFolders(ue,P,F,z).then(void 0,re=>{this.l=void 0;const se={source:{identifier:R.identifier,label:R.displayName||R.name}};this.o.$showMessage(u.Severity.Error,(0,f.localize)(0,null,ue,re.toString()),se,[])})}return this.x(K),!0}getWorkspaceFolder(R,P){if(!!this.w)return this.w.getWorkspaceFolder(R,P)}async getWorkspaceFolder2(R,P){if(await this.j.wait(),!!this.w)return this.w.getWorkspaceFolder(R,P)}async resolveWorkspaceFolder(R){if(await this.j.wait(),!!this.w)return this.w.resolveWorkspaceFolder(R)}getPath(){if(!this.w)return;const{folders:R}=this.w;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,P){let F,B="";if(typeof R=="string"?(F=b.URI.file(R),B=R):typeof R<"u"&&(F=R,B=R.fsPath),!F)return B;const z=this.getWorkspaceFolder(F,!0);if(!z)return B;typeof P>"u"&&this.w&&(P=this.w.folders.length>1);let V=(0,M.relativePath)(z.uri,F);return P&&z.name&&(V=`${z.name}/${V}`),V}x(R){this.w&&(this.l=N.toExtHostWorkspace({id:this.w.id,name:this.w.name,configuration:this.w.configuration,folders:R,isUntitled:this.w.isUntitled},this.w,void 0,this.q).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:P,added:F,removed:B}=N.toExtHostWorkspace(R,this.k,this.l,this.q);this.k=P||void 0,this.l=void 0,this.c.fire(Object.freeze({added:F,removed:B}))}findFiles(R,P,F,B,z=y.CancellationToken.None){this.g.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let V;if(P===null?V=!1:P&&(typeof P=="string"?V=P:V=P.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:K,folder:ie}=J(s.GlobPattern.from(R));return this.n.$startFileSearch((0,m.withUndefinedAsNull)(K),(0,m.withUndefinedAsNull)(ie),(0,m.withUndefinedAsNull)(V),(0,m.withUndefinedAsNull)(F),z).then(ge=>Array.isArray(ge)?ge.map(ue=>b.URI.revive(ue)):[])}async findTextInFiles(R,P,F,B,z=y.CancellationToken.None){this.g.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const V=this.h.getNext(),K=typeof P.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:P.previewOptions,{includePattern:ie,folder:ge}=J(s.GlobPattern.from(P.include)),ue=typeof P.exclude=="string"?P.exclude:P.exclude?P.exclude.pattern:void 0,re={ignoreSymlinks:typeof P.followSymlinks=="boolean"?!P.followSymlinks:void 0,disregardIgnoreFiles:typeof P.useIgnoreFiles=="boolean"?!P.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof P.useGlobalIgnoreFiles=="boolean"?!P.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof P.useParentIgnoreFiles=="boolean"?!P.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof P.useDefaultExcludes=="boolean"?!P.useDefaultExcludes:!0,fileEncoding:P.encoding,maxResults:P.maxResults,previewOptions:K,afterContext:P.afterContext,beforeContext:P.beforeContext,includePattern:ie,excludePattern:ue},se=!1;if(this.t[V]=le=>{if(se)return;const _=b.URI.revive(le.resource);le.results.forEach(me=>{(0,h.resultIsMatch)(me)?F({uri:_,preview:{text:me.preview.text,matches:(0,i.mapArrayOrNot)(me.preview.matches,we=>new r.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))},ranges:(0,i.mapArrayOrNot)(me.ranges,we=>new r.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))}):F({uri:_,text:me.text,lineNumber:me.lineNumber})})},z.isCancellationRequested)return{};try{const le=await this.n.$startTextSearch(R,(0,m.withUndefinedAsNull)(ge),re,V,z);return delete this.t[V],le||{}}catch(le){throw delete this.t[V],le}}$handleTextSearchResult(R,P){this.t[P]?.(R)}saveAll(R){return this.n.$saveAll(R)}resolveProxy(R){return this.n.$resolveProxy(R)}get trusted(){return this.u}requestWorkspaceTrust(R){return this.n.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this.u||(this.u=!0,this.e.fire())}registerEditSessionIdentityProvider(R,P){if(this.v.has(R))throw new Error(`A provider has already been registered for scheme ${R}`);this.v.set(R,P);const F=this.s.transformOutgoingScheme(R),B=this.y++;return this.n.$registerEditSessionIdentityProvider(B,F),(0,C.toDisposable)(()=>{this.v.delete(R),this.n.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(R,P){this.g.info("Getting edit session identifier for workspaceFolder",R);const F=await this.resolveWorkspaceFolder(b.URI.revive(R));if(!F){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const B=this.v.get(F.uri.scheme);if(this.g.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!B),!B)return;const z=await B.provideEditSessionIdentity(F,P);if(this.g.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(R,P,F,B){this.g.info("Getting edit session identifier for workspaceFolder",R);const z=await this.resolveWorkspaceFolder(b.URI.revive(R));if(!z){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const V=this.v.get(z.uri.scheme);if(this.g.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!V),!V)return;const K=await V.provideEditSessionIdentityMatch?.(P,F,B);if(this.g.info("Provider returned edit session identifier match result: ",K),!!K)return K}};q=qe([Ve(0,w.IExtHostRpcService),Ve(1,v.IExtHostInitDataService),Ve(2,E.IExtHostFileSystemInfo),Ve(3,c.ILogService),Ve(4,o.IURITransformerService)],q),e.ExtHostWorkspace=q,e.IExtHostWorkspace=(0,t.createDecorator)("IExtHostWorkspace");function J(x){let R,P;return x&&(typeof x=="string"?R=x:(R=x.pattern,P=b.URI.revive(x.baseUri))),{includePattern:R,folder:P}}}),define(Ie[32],Ce([1,0,23,5,31,4,6,158,89,9,14,3,15,12,2]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function t(r,o){if(o){const h=o.split(".");let a=r;for(let l=0;a&&l<h.length;l++)a=a[h[l]];return a}}function c(r){return r instanceof f.URI}function u(r){return r&&r.uri instanceof f.URI&&r.languageId&&typeof r.languageId=="string"}function p(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function E(r){return r&&r.uri instanceof f.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function v(r){if(c(r))return{resource:r};if(u(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(p(r))return{overrideIdentifier:r.languageId};if(E(r))return{resource:r.uri};if(r===null)return{resource:null}}let w=class{constructor(o,h,a){this.a=o.getProxy(L.MainContext.MainThreadConfiguration),this.c=h,this.b=a,this.d=new M.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(o=>this.e)}$initializeConfiguration(o){this.e=new s(this.a,this.c,o,this.b),this.d.open()}$acceptConfigurationChanged(o,h){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(o,h))}};w=qe([Ve(0,m.IExtHostRpcService),Ve(1,y.IExtHostWorkspace),Ve(2,b.ILogService)],w),e.ExtHostConfiguration=w;class s{constructor(o,h,a,l){this.a=new T.Emitter,this.b=o,this.f=l,this.c=h,this.e=A.Configuration.parse(a),this.d=this.k(a.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(o,h){const a={data:this.e.toData(),workspace:this.c.workspace};this.e=A.Configuration.parse(o),this.d=this.k(o.configurationScopes),this.a.fire(this.j(h,a))}getConfiguration(o,h,a){const l=v(h)||{},n=this.g(o?t(this.e.getValue(void 0,l,this.c.workspace),o):this.e.getValue(void 0,l,this.c.workspace));o&&this.h(o,l,a?.identifier);function d(O){if(O==null)return null;if(typeof O=="boolean")return O?2:5;switch(O){case C.ConfigurationTarget.Global:return 2;case C.ConfigurationTarget.Workspace:return 5;case C.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(O){return typeof t(n,O)<"u"},get:(O,N)=>{this.h(o?`${o}.${O}`:O,l,a?.identifier);let q=t(n,O);if(typeof q>"u")q=N;else{let J;const x=(R,P)=>{let F;const B=()=>{J=J||(0,i.deepClone)(n),F=F||t(J,P)};return(0,k.isObject)(R)?new Proxy(R,{get:(z,V)=>{if(typeof V=="string"&&V.toLowerCase()==="tojson")return B(),()=>F;if(J)return F=F||t(J,P),F[V];const K=z[V];return typeof V=="string"?x(K,`${P}.${V}`):K},set:(z,V,K)=>(B(),F&&(F[V]=K),!0),deleteProperty:(z,V)=>(B(),F&&delete F[V],!0),defineProperty:(z,V,K)=>(B(),F&&Object.defineProperty(F,V,K),!0)}):R};q=x(q,O)}return q},update:(O,N,q,J)=>{O=o?`${o}.${O}`:O;const x=d(q);return N!==void 0?this.b.$updateConfigurationOption(x,O,N,l,J):this.b.$removeConfigurationOption(x,O,l,J)},inspect:O=>{O=o?`${o}.${O}`:O;const N=this.e.inspect(O,l,this.c.workspace);if(N)return{key:O,defaultValue:(0,i.deepClone)(N.policy?.value??N.default?.value),globalValue:(0,i.deepClone)(N.user?.value??N.application?.value),workspaceValue:(0,i.deepClone)(N.workspace?.value),workspaceFolderValue:(0,i.deepClone)(N.workspaceFolder?.value),defaultLanguageValue:(0,i.deepClone)(N.default?.override),globalLanguageValue:(0,i.deepClone)(N.user?.override??N.application?.override),workspaceLanguageValue:(0,i.deepClone)(N.workspace?.override),workspaceFolderLanguageValue:(0,i.deepClone)(N.workspaceFolder?.override),languageIds:(0,i.deepClone)(N.overrideIdentifiers)}}};return typeof n=="object"&&(0,i.mixin)(g,n,!1),Object.freeze(g)}g(o){const h=a=>(0,k.isObject)(a)?new Proxy(a,{get:(l,n)=>h(l[n]),set:(l,n,d)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(l,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(l,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return h(o)}h(o,h,a){const l=S.OVERRIDE_PROPERTY_REGEX.test(o)?4:this.d.get(o),n=a?`[${a.value}] `:"";if(l===4){typeof h?.resource>"u"&&this.f.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){h?.resource&&this.f.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(o,h){const a=new A.ConfigurationChangeEvent(o,h,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(l,n)=>a.affectsConfiguration(l,v(n))})}k(o){return o.reduce((h,a)=>(h.set(a[0],a[1]),h),new Map)}}e.ExtHostConfigProvider=s,e.IExtHostConfiguration=(0,D.createDecorator)("IExtHostConfiguration")});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[105],Ce([1,0,2,14,5,4,6,31,55,32,20,58,15,27,3,13,21,12,72,193,11]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m,b,f,t,c,u,p,E,v){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var s;(function(R){function P(B){if(B!=null)return B}R.from=P;function F(B){if(B!=null)return B}R.to=F})(s||(s={}));var r;(function(R){function P(B){if(B!=null)return B}R.from=P;function F(B){if(B!=null)return B}R.to=F})(r||(r={}));var o;(function(R){function P(B){if(B!=null)return B}R.from=P;function F(B){if(B!=null)return B}R.to=F})(o||(o={}));var h;(function(R){function P(z){if(z){const V=z;return V&&!!V.process}else return!1}R.is=P;function F(z){if(z==null)return;const V={process:z.process,args:z.args};return z.options&&(V.options=o.from(z.options)),V}R.from=F;function B(z){if(z!=null)return new C.ProcessExecution(z.process,z.args,z.options)}R.to=B})(h||(h={}));var a;(function(R){function P(B){if(B!=null)return B}R.from=P;function F(B){if(B!=null)return B}R.to=F})(a||(a={}));var l;(function(R){function P(z){if(z){const V=z;return V&&(!!V.commandLine||!!V.command)}else return!1}R.is=P;function F(z){if(z==null)return;const V={};return z.commandLine!==void 0?V.commandLine=z.commandLine:(V.command=z.command,V.args=z.args),z.options&&(V.options=a.from(z.options)),V}R.from=F;function B(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new C.ShellExecution(z.commandLine,z.options):new C.ShellExecution(z.command,z.args?z.args:[],z.options)}R.to=B})(l||(l={}));var n;(function(R){function P(z){if(z){const V=z;return V&&V.customExecution==="customExecution"}else return!1}R.is=P;function F(z){return{customExecution:"customExecution"}}R.from=F;function B(z,V){return V.get(z)}R.to=B})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var d;(function(R){function P(F,B){let z;return F.scope!==void 0&&typeof F.scope!="number"?z=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===C.TaskScope.Workspace&&B&&B.workspaceFile?z=B.workspaceFile:z=E.USER_TASKS_GROUP_KEY),{id:F._id,workspaceFolder:z}}R.from=P})(d=e.TaskHandleDTO||(e.TaskHandleDTO={}));var g;(function(R){function P(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}R.from=P})(g||(g={}));var O;(function(R){function P(z,V){if(z==null)return[];const K=[];for(const ie of z){const ge=F(ie,V);ge&&K.push(ge)}return K}R.fromMany=P;function F(z,V){if(z==null)return;let K;z.execution instanceof C.ProcessExecution?K=h.from(z.execution):z.execution instanceof C.ShellExecution?K=l.from(z.execution):z.execution&&z.execution instanceof C.CustomExecution&&(K=n.from(z.execution));const ie=s.from(z.definition);let ge;return z.scope?typeof z.scope=="number"?ge=z.scope:ge=z.scope.uri:ge=C.TaskScope.Workspace,!ie||!ge?void 0:{_id:z._id,definition:ie,name:z.name,source:{extensionId:V.identifier.value,label:z.source,scope:ge},execution:K,isBackground:z.isBackground,group:g.from(z.group),presentationOptions:r.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}R.from=F;async function B(z,V,K){if(z==null)return;let ie;h.is(z.execution)?ie=h.to(z.execution):l.is(z.execution)?ie=l.to(z.execution):n.is(z.execution)&&(ie=n.to(z._id,K));const ge=s.to(z.definition);let ue;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?ue=z.source.scope:ue=await V.resolveWorkspaceFolder(i.URI.revive(z.source.scope)):ue=C.TaskScope.Workspace),!ge||!ue)return;const re=new C.Task(ge,ue,z.name,z.source.label,ie,z.problemMatchers);return z.isBackground!==void 0&&(re.isBackground=z.isBackground),z.group!==void 0&&(re.group=C.TaskGroup.from(z.group._id),re.group&&z.group.isDefault&&(re.group=new C.TaskGroup(re.group.id,re.group.label),z.group.isDefault===!0&&(re.group.isDefault=z.group.isDefault))),z.presentationOptions&&(re.presentationOptions=r.to(z.presentationOptions)),z._id&&(re._id=z._id),z.detail&&(re.detail=z.detail),re}R.to=B})(O=e.TaskDTO||(e.TaskDTO={}));var N;(function(R){function P(B){return B}R.from=P;function F(B){if(!!B)return Object.assign(Object.create(null),B)}R.to=F})(N||(N={}));class q{constructor(P,F,B){this._id=F,this.a=B,w.set(this,void 0),Ye(this,w,P,"f")}get task(){return this.a}terminate(){Re(this,w,"f").terminateTask(this)}fireDidStartProcess(P){}fireDidEndProcess(P){}}w=new WeakMap;let J=class{constructor(P,F,B,z,V,K,ie,ge){this.q=new y.Emitter,this.r=new y.Emitter,this.s=new y.Emitter,this.t=new y.Emitter,this.a=P.getProxy(L.MainContext.MainThreadTask),this.b=B,this.c=z,this.d=V,this.e=K,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ie,this.g=ge,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(P,F,B){if(!B)return new C.Disposable(()=>{});const z=this.w();return this.j.set(z,{type:F,provider:B,extension:P}),this.a.$registerTaskProvider(z,F),new C.Disposable(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(P,F){this.a.$registerTaskSystem(P,F)}fetchTasks(P){return this.a.$fetchTasks(N.from(P)).then(async F=>{const B=[];for(const z of F){const V=await O.to(z,this.b,this.m);V&&B.push(V)}return B})}get taskExecutions(){const P=[];return this.k.forEach(F=>P.push(F)),P}terminateTask(P){if(!(P instanceof q))throw new Error("No valid task execution provided");return this.a.$terminateTask(P._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(P,F,B){const z=this.m.get(P.id);z&&(this.o.set(P.id,z),this.e.attachPtyToTerminal(F,await z.callback(B))),this.p=P.id,this.q.fire({execution:await this.y(P)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(P){const F=await this.y(P);this.l.delete(P.id),this.k.delete(P.id),this.A(P),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(P){const F=await this.y(P.id);this.s.fire({execution:F,processId:P.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(P){const F=await this.y(P.id);this.t.fire({execution:F,exitCode:P.exitCode})}$provideTasks(P,F){const B=this.j.get(P);if(!B)return Promise.reject(new Error("no handler found"));const z=[],V=(0,T.asPromise)(()=>B.provider.provideTasks(M.CancellationToken.None)).then(K=>this.u(F,z,B,K));return new Promise(K=>{V.then(ie=>{Promise.all(z).then(()=>{K(ie)})})})}async $resolveTask(P,F){const B=this.j.get(P);if(!B)return Promise.reject(new Error("no handler found"));if(F.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${B.type}].`);const z=await O.to(F,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const V=await B.provider.resolveTask(z,M.CancellationToken.None);if(!V)return;this.z(V,B);const K=O.from(V,B.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(K.execution)&&await this.x(K,V,!0),await this.v(K)}w(){return this.h++}async x(P,F,B){const z=await this.a.$createTaskId(P);!B&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,F.execution)),this.m.set(z,F.execution)}async y(P,F){if(typeof P=="string"){const V=this.l.get(P);if(!V)throw new v.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return V}const B=this.l.get(P.id);if(B)return B;const z=new Promise((V,K)=>{function ie(ge,ue,re){re?V(new q(ge,ue.id,re)):K("Unexpected: Task does not exist.")}F?ie(this,P,F):O.to(P.task,this.b,this.m).then(ge=>ie(this,P,ge))});return this.l.set(P.id,z),z.then(V=>(this.k.set(P.id,V),V),V=>Promise.reject(V))}z(P,F){P._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}A(P){this.o.get(P.id)&&this.o.delete(P.id),this.n.has(P.id)&&this.p!==P.id&&(this.m.delete(P.id),this.n.delete(P.id));const B=this.n.values();let z=B.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=B.next()}};J=qe([Ve(0,m.IExtHostRpcService),Ve(1,b.IExtHostInitDataService),Ve(2,A.IExtHostWorkspace),Ve(3,S.IExtHostDocumentsAndEditors),Ve(4,k.IExtHostConfiguration),Ve(5,D.IExtHostTerminalService),Ve(6,u.ILogService),Ve(7,p.IExtHostApiDeprecationService)],J),e.ExtHostTaskBase=J;let x=class extends J{constructor(P,F,B,z,V,K,ie,ge){super(P,F,B,z,V,K,ie,ge),this.registerTaskSystem(t.Schemas.vscodeRemote,{scheme:t.Schemas.vscodeRemote,authority:"",platform:c.PlatformToString(0)})}async executeTask(P,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const B=O.from(F,P);if(B===void 0)throw new Error("Task is not valid");if(n.is(B.execution))await this.x(B,F,!1);else throw new v.NotSupportedError;const z=await this.y(await this.a.$getTaskExecution(B),F);return this.a.$executeTask(B).catch(V=>{throw new Error(V)}),z}u(P,F,B,z){const V=[];if(z)for(const K of z){this.z(K,B),(!K.definition||!P[K.definition.type])&&this.f.warn(`The task [${K.source}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`);const ie=O.from(K,B.extension);ie&&n.is(ie.execution)?(V.push(ie),F.push(this.x(ie,K,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:V,extension:B.extension}}async v(P){if(n.is(P.execution))return P;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(P,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(P,F,B){}};x=qe([Ve(0,m.IExtHostRpcService),Ve(1,b.IExtHostInitDataService),Ve(2,A.IExtHostWorkspace),Ve(3,S.IExtHostDocumentsAndEditors),Ve(4,k.IExtHostConfiguration),Ve(5,D.IExtHostTerminalService),Ve(6,u.ILogService),Ve(7,p.IExtHostApiDeprecationService)],x),e.WorkerExtHostTask=x,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(Ie[236],Ce([1,0,19,20,45,35,22,100,44]),function(ee,e,i,T,y,L,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(m,b,f){this.k=m,this.l=b,this.o=f,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&L.parse(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&L.parse(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const b=this.k.folderQueries||[];return new Promise((f,t)=>{const c=u=>{this.f++,m(u)};if(this.g)return f({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(u=>{const p=u.toString(),E=i.basename(p);this.j&&this.j(p,E)||this.v(c,{base:u,basename:E})}),Promise.all(b.map(u=>this.p(u,c))).then(u=>{f({limitHit:this.e,stats:u[0]||void 0})},u=>{t(new Error((0,y.toErrorMessage)(u)))})})}async p(m,b){const f=new T.CancellationTokenSource,t=this.q(m),c=this.r(),u=new S.QueryGlobTester(this.k,m),p=!u.hasSiblingExcludeClauses();let E;try{this.h.add(f),E=A.StopWatch.create();const v=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},t,f.token),w=E.elapsed(),s=A.StopWatch.create();return this.g&&!this.e||(v&&v.forEach(r=>{const o=i.posix.relative(m.folder.path,r.path);if(p){const h=i.basename(r.path);this.v(b,{base:m.folder,relativePath:o,basename:h});return}this.s(c,m.folder,o,b)}),this.g&&!this.e)?null:(this.u(c,u,b),{providerTime:w,postProcessTime:s.elapsed()})}finally{f.dispose(),this.h.delete(f)}}q(m){const b=(0,S.resolvePatternsForProvider)(this.k.includePattern,m.includePattern),f=(0,S.resolvePatternsForProvider)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:f,includes:b,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},b,f,t){if(f===this.a){const u=i.basename(this.a);this.v(t,{base:b,relativePath:this.a,basename:u})}function c(u){const p=i.basename(u),E=i.dirname(u);let v=m[E];v||(v=m[E]=[],c(E)),v.push({base:b,relativePath:u,basename:p})}c(f)}u({rootEntries:m,pathToEntries:b},f,t){const c=this,u=this.a;function p(E){const v=(0,S.hasSiblingFn)(()=>E.map(w=>w.basename));for(let w=0,s=E.length;w<s;w++){const r=E[w],{relativePath:o,basename:h}=r;if(f.matchesExcludesSync(o,h,u!==h?v:void 0))continue;const a=b[o];if(a)p(a);else{if(o===u)continue;c.v(t,r)}if(c.e)break}}p(m)}v(m,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(b))}}class M{constructor(){this.b=new Map}fileSearch(m,b,f,t){const c=this.c(m.cacheKey),u=new k(m,b,c&&c.token);let p=0;const E=v=>{p+=v.length,f(v.map(w=>this.d(w)))};return this.e(u,M.a,E,t).then(v=>({limitHit:v.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:p,detailStats:v.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(!!m)return this.b.has(m)||this.b.set(m,new T.CancellationTokenSource),this.b.get(m)}d(m){return m.relativePath?{resource:C.joinPath(m.base,m.relativePath)}:{resource:m.base}}e(m,b,f,t){t.onCancellationRequested(()=>{m.cancel()});const c=p=>{p&&(u.push(p),b>0&&u.length>=b&&(f(u),u=[]))};let u=[];return m.search(c).then(p=>(u.length&&f(u),p),p=>(u.length&&f(u),Promise.reject(p)))}}e.FileSearchManager=M,M.a=512}),define(Ie[237],Ce([1,0,16,78,35,82,28,13,19,22,10,9,2,253,148,40,12,50,94,235,44]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m,b,f,t,c,u,p,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let w=class{constructor(g,O,N,q,J){this.a=g,this.b=O,this.c=N,this.d=q,this.e=J}text(g,O,N={}){g=this.f(g,N);const q=this.a.getValue(),J=O&&O.some(R=>!this.a.getValue({resource:R}).search.useRipgrep);return{...this.h(O?.map(u.toWorkspaceFolder),N),type:2,contentPattern:g,previewOptions:N.previewOptions,maxFileSize:N.maxFileSize,usePCRE2:q.search.usePCRE2||J||!1,beforeContext:N.beforeContext,afterContext:N.afterContext,userDisabledExcludesAndIgnoreFiles:N.disregardExcludeSettings&&N.disregardIgnoreFiles}}f(g,O){const N=this.a.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const q={...g,wordSeparators:N.editor.wordSeparators};return this.j(g,O)&&(q.isCaseSensitive=!0),this.k(g)&&(q.isMultiline=!0),q}file(g,O={}){return{...this.h(g,O),type:1,filePattern:O.filePattern?O.filePattern.trim():O.filePattern,exists:O.exists,sortByScore:O.sortByScore,cacheKey:O.cacheKey}}g(g,O){return g?(g=Array.isArray(g)?g.map(a):a(g),O?this.parseSearchPaths(g):{pattern:r(...Array.isArray(g)?g:[g])}):{}}h(g=[],O={}){const N=this.g(O.includePattern,O.expandPatterns),q=this.g(O.excludePattern,O.expandPatterns),J=g.length>1,x=(N.searchPaths&&N.searchPaths.length?N.searchPaths.map(F=>this.q(F,O,q)):g.map(F=>this.r(F,O,q,J))).filter(F=>!!F),R={_reason:O._reason,folderQueries:x,usingSearchPaths:!!(N.searchPaths&&N.searchPaths.length),extraFileResources:O.extraFileResources,excludePattern:q.pattern,includePattern:N.pattern,onlyOpenEditors:O.onlyOpenEditors,maxResults:O.maxResults};if(O.onlyOpenEditors){const F=i.coalesce(i.flatten(this.c.groups.map(V=>V.editors.map(K=>K.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const B=F.filter(V=>(0,v.pathIncludedInQuery)(R,V.fsPath)),z=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(z)),{...R,...z}}const P=O.extraFileResources&&O.extraFileResources.filter(F=>(0,v.pathIncludedInQuery)(R,F.fsPath));return R.extraFileResources=P&&P.length?P:void 0,R}i(g){const O=[],N=new C.ResourceMap,q={};let J=!1;return g.forEach(x=>{if(x.scheme===A.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(x)){const P=this.b.getWorkspaceFolder(x)?.uri??x.with({path:S.dirname(x.fsPath)});let F=N.get(P);F||(J=!0,F={folder:P,includePattern:{}},O.push(F),N.set(P,F));const B=S.relative(P.fsPath,x.fsPath);(0,D.assertIsDefined)(F.includePattern)[B.replace(/\\/g,"/")]=!0}else x.fsPath&&(J=!0,q[x.fsPath]=!0)}),{folderQueries:O,includePattern:q,usingSearchPaths:!0,excludePattern:J?void 0:{"**/*":!0}}}j(g,O){if(O.isSmartCase){if(g.isRegExp){if(M.containsUppercaseCharacter(g.pattern,!0))return!0}else if(M.containsUppercaseCharacter(g.pattern))return!0}return!!g.isCaseSensitive}k(g){return g.isMultiline||g.isRegExp&&(0,b.isMultilineRegexSource)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const O=z=>S.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),q=(Array.isArray(g)?g:o(g)).map(z=>{const V=this.e.resolvedUserHome;return V?(0,L.untildify)(z,V.scheme===A.Schemas.file?V.fsPath:V.path):z}),J=T.groupBy(q,z=>O(z)?"searchPaths":"exprSegments"),x=(J.exprSegments||[]).map(z=>M.rtrim(z,"/")).map(z=>M.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),h(z))),R={},P=this.m(J.searchPaths||[]);P&&P.length&&(R.searchPaths=P);const F=i.flatten(x),B=r(...F);return B&&(R.pattern=B),R}l(g,O){return O.disregardExcludeSettings?void 0:(0,v.getExcludes)(g,!O.disregardSearchExcludeSettings)}m(g){if(!g||!g.length)return[];const O=i.flatten(g.map(q=>{let{pathPortion:J,globPortion:x}=s(q);x&&(x=l(x));const R=this.n(J);return i.flatten(R.map(P=>this.o(P,x)))})),N=new Map;return O.forEach(q=>{const J=q.searchPath.toString(),x=N.get(J);x?q.pattern&&(x.pattern=x.pattern||{},x.pattern[q.pattern]=!0):N.set(J,{searchPath:q.searchPath,pattern:q.pattern?r(q.pattern):void 0})}),Array.from(N.values())}n(g){if(S.isAbsolute(g)){const O=this.b.getWorkspace().folders;return O[0]&&O[0].uri.scheme!==A.Schemas.file?[{searchPath:O[0].uri.with({path:g})}]:[{searchPath:m.URI.file(S.normalize(g))}]}if(this.b.getWorkbenchState()===2){const O=this.b.getWorkspace().folders[0].uri;if(g=a(g),g.startsWith("../")||g===".."){const q=S.posix.resolve(O.path,g);return[{searchPath:O.with({path:q})}]}const N=l(g);return[{searchPath:O,pattern:N}]}else{if(g==="./"||g===".\\")return[];{const O=g.replace(/^\.[\/\\]/,""),q=this.b.getWorkspace().folders.map(J=>{const x=O.match(new RegExp(`^${M.escapeRegExpCharacters(J.name)}(?:/(.*)|$)`));return x?{match:x,folder:J}:null}).filter(D.isDefined);if(q.length)return q.map(J=>{const x=J.match[1];return{searchPath:J.folder.uri,pattern:x&&l(x)}});{const J=g.match(/\.[\/\\](.+)[\/\\]?/),x=J?J[1]:g,R=f.localize(0,null,x);throw new Error(R)}}}}o(g,O){const N=g.pattern&&O?`${g.pattern}/${O}`:g.pattern||O,q=[{searchPath:g.searchPath,pattern:N}];return N&&!N.endsWith("**")&&q.push({searchPath:g.searchPath,pattern:N+"/**"}),q}q(g,O,N){const q=this.r((0,u.toWorkspaceFolder)(g.searchPath),O,N,!1);return q?{...q,includePattern:g.pattern}:null}r(g,O,N,q){let J;const x=m.URI.isUri(g)?g:g.uri;if(N.searchPaths){const z=N.searchPaths.filter(V=>(0,k.isEqual)(V.searchPath,x))[0];if(z&&!z.pattern)return null;z&&(J=z.pattern)}const R=this.a.getValue({resource:x}),F={...this.l(R,O)||{},...J||{}},B=m.URI.isUri(g)?(0,k.basename)(g):g.name;return{folder:x,folderName:q?B:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:R.files&&R.files.encoding,disregardIgnoreFiles:typeof O.disregardIgnoreFiles=="boolean"?O.disregardIgnoreFiles:!R.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof O.disregardGlobalIgnoreFiles=="boolean"?O.disregardGlobalIgnoreFiles:!R.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof O.disregardParentIgnoreFiles=="boolean"?O.disregardParentIgnoreFiles:!R.search.useParentIgnoreFiles,ignoreSymlinks:typeof O.ignoreSymlinks=="boolean"?O.ignoreSymlinks:!R.search.followSymlinks}}};w=qe([Ve(0,t.IConfigurationService),Ve(1,u.IWorkspaceContextService),Ve(2,p.IEditorGroupsService),Ve(3,c.ILogService),Ve(4,E.IPathService)],w),e.QueryBuilder=w;function s(d){const g=d.match(/[\*\{\}\(\)\[\]\?]/);if(g){const O=g.index,N=d.substr(0,O).match(/[/|\\][^/\\]*$/);if(N){let q=d.substr(0,N.index);return q.match(/[/\\]/)||(q+="/"),{pathPortion:q,globPortion:d.substr((N.index||0)+1)}}}return{pathPortion:d}}function r(...d){return d.length?d.reduce((g,O)=>(g[O]=!0,g),Object.create(null)):void 0}function o(d){return y.splitGlobAware(d,",").map(g=>g.trim()).filter(g=>!!g.length)}function h(d){return[`**/${d}/**`,`**/${d}`].map(O=>O.replace(/\*\*\/\*\*/g,"**"))}function a(d){return d.replace(/\\/g,"/")}function l(d){return a(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(d,g){d=i.distinct(d,q=>q.toString());const O=[],N=g.getWorkspace();return d&&d.forEach(q=>{let J;if(g.getWorkbenchState()===2)J=(0,k.relativePath)(N.folders[0].uri,q),J&&J!=="."&&(J="./"+J);else{const x=g.getWorkspaceFolder(q);if(x){const R=x.name;if(N.folders.filter(F=>F.name===R).length===1){const F=(0,k.relativePath)(x.uri,q);F===""?J=`./${x.name}`:J=`./${x.name}/${F}`}else J=q.fsPath}}J&&O.push(J)}),O}e.resolveResourcesForSearchIncludes=n}),define(Ie[238],Ce([1,0,22,2,20,11,3,237,44,50]),function(ee,e,i,T,y,L,C,A,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const M=7e3;function D(t,c){const u=c.activationEvents;if(!u)return Promise.resolve(void 0);const p=[],E=[];for(const h of u)if(/^workspaceContains:/.test(h)){const a=h.substr(18);a.indexOf("*")>=0||a.indexOf("?")>=0||t.forceUsingSearch?E.push(a):p.push(a)}if(p.length===0&&E.length===0)return Promise.resolve(void 0);let v;const w=new Promise((h,a)=>{v=h}),s=h=>v({activationEvent:h}),r=Promise.all(p.map(h=>m(t,h,s))).then(()=>{}),o=b(t,c.identifier,E,s);return Promise.all([r,o]).then(()=>{v(void 0)}),w}e.checkActivateWorkspaceContainsExtension=D;async function m(t,c,u){for(const p of t.folders)if(await t.exists(i.joinPath(T.URI.revive(p),c))){u(`workspaceContains:${c}`);return}}async function b(t,c,u,p){if(u.length===0)return Promise.resolve(void 0);const E=new y.CancellationTokenSource,v=t.checkExists(t.folders,u,E.token),w=setTimeout(async()=>{E.cancel(),t.logService.info(`Not activating extension '${c.value}': Timed out while searching for 'workspaceContains' pattern ${u.join(",")}`)},M);let s=!1;try{s=await v}catch(r){L.isCancellationError(r)||L.onUnexpectedError(r)}E.dispose(),clearTimeout(w),s&&p(`workspaceContains:${u.join(",")}`)}function f(t,c,u,p){const E=t.get(C.IInstantiationService),v=t.get(S.ISearchService),s=E.createInstance(A.QueryBuilder).file(c.map(r=>(0,k.toWorkspaceFolder)(T.URI.revive(r))),{_reason:"checkExists",includePattern:u,exists:!0});return v.fileSearch(s,p).then(r=>!!r.limitHit,r=>L.isCancellationError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=f});var Ye=this&&this.__classPrivateFieldSet||function(ee,e,i,T,y){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!y:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?y.call(ee,i):y?y.value=i:e.set(ee,i),i},Re=this&&this.__classPrivateFieldGet||function(ee,e,i,T){if(i==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?T:i==="a"?T.call(ee):T?T.value:e.get(ee)};define(Ie[33],Ce([1,0,135,19,77,22,14,7,46,2,12,4,32,182,75,31,25,95,11,26,24,167,6,90,3,27,76,15,63,65,58,5,238,74,169,13,73]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m,b,f,t,c,u,p,E,v,w,s,r,o,h,a,l,n,d,g,O,N,q,J,x,R){"use strict";var P,F,B;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let z=class Ri extends A.Disposable{constructor(se,le,_,me,we,Me,We,Qe,Te,De,ke){super(),this.a=this.B(new O.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=le,this.g=_,this.f=We,this.j=me,this.k=we,this.l=Me,this.m=Te,this.p=De,this.s=ke,this.t=this.g.getProxy(D.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(D.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(D.MainContext.MainThreadExtensionService),this.w=new C.Barrier,this.y=new C.Barrier,this.z=new C.Barrier,this.C=new C.Barrier,this.F=new u.ExtensionDescriptionRegistry(this.f.allExtensions);const oe=(0,c.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new u.ExtensionDescriptionRegistry(ie(this.F,oe)),this.G=new f.ExtHostStorage(this.g,this.l),this.H=new q.ExtHostSecretState(this.g),this.I=Qe,this.h=se.createChild(new n.ServiceCollection([f.IExtHostStorage,this.G],[q.IExtHostSecretState,this.H])),this.J=this.B(new b.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(ce,Y,I)=>{this.v.$onExtensionActivationError(ce,p.transformErrorForSerialization(Y),I)},actualActivateExtension:async(ce,Y)=>{if(u.ExtensionDescriptionRegistry.isHostExtension(ce,this.D,this.F))return await this.v.$activateExtension(ce,Y),new b.HostExtension;const I=this.D.getExtensionDescription(ce);return this.Y(I,Y)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),y.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(se){p.onUnexpectedError(se)}}async Q(){this.I.onWillDeactivateAll();let se=[];try{se=this.D.getAllExtensionDescriptions().map(we=>we.identifier).filter(we=>this.isActivated(we)).map(we=>this.X(we))}catch{}await Promise.all(se)}terminate(se,le=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${se}`),this.l.flush(),this.p.dispose(),this.J.dispose(),p.setUnexpectedErrorHandler(me=>{this.l.error(me)}),this.g.dispose();const _=this.Q();Promise.race([(0,C.timeout)(5e3),_]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${le}`):this.l.info(`Extension host exiting with code ${le}`),this.l.flush(),this.l.dispose(),this.c.exit(le)})}isActivated(se){return this.z.isOpen()?this.J.isActivated(se):!1}async getExtension(se){const le=await this.v.$getExtension(se);let _;if(le?.browserNlsBundleUris){_={};for(const me of Object.keys(le.browserNlsBundleUris))_[me]=k.URI.revive(le.browserNlsBundleUris[me])}return le&&{...le,identifier:new E.ExtensionIdentifier(le.identifier.value),extensionLocation:k.URI.revive(le.extensionLocation),browserNlsBundleUris:_}}R(se,le){return this.J.activateByEvent(se,le)}S(se,le){return this.J.activateById(se,le)}activateByIdWithErrors(se,le){return this.S(se,le).then(()=>{const _=this.J.getActivatedExtension(se);if(_.activationFailed)return Promise.reject(_.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(se=>this.D)}getExtensionExports(se){return this.z.isOpen()?this.J.getActivatedExtension(se).exports:null}async U(se){if(se.scheme!==x.Schemas.file)return se;const le=await this.c.realpath(se.fsPath);return k.URI.file(le)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(se=>new ue(se))),this.L}async W(se){const le=S.TernarySearchTree.forUris(_=>L.extUriBiasedIgnorePathCase.ignorePathCasing(_));return await Promise.all(se.map(async _=>{if(this.ob(_)){const me=await this.U(_.extensionLocation);le.set(me,_)}})),le}X(se){let le=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(se))return le;const _=this.J.getActivatedExtension(se);if(!_)return le;try{typeof _.module.deactivate=="function"&&(le=Promise.resolve(_.module.deactivate()).then(void 0,me=>(this.l.error(me),Promise.resolve(void 0))))}catch(me){this.l.error(`An error occurred when deactivating the extension '${se.value}':`),this.l.error(me)}try{(0,A.dispose)(_.subscriptions)}catch(me){this.l.error(`An error occurred when deactivating the subscriptions for extension '${se.value}':`),this.l.error(me)}return le}async Y(se,le){return this.f.remote.isRemote?this.v.$onWillActivateExtension(se.identifier):await this.v.$onWillActivateExtension(se.identifier),this.ab(se,le).then(_=>{const me=_.activationTimes;return this.v.$onDidActivateExtension(se.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,le),this.Z(se,le,"success",me),_},_=>{throw this.Z(se,le,"failure"),_})}Z(se,le,_,me){const we=V(se,le);this.u.$publicLog2("extensionActivationTimes",{...we,...me||{},outcome:_})}ab(se,le){const _=V(se,le);this.u.$publicLog2("activatePlugin",_);const me=this.ob(se);if(!me)return Promise.resolve(new b.EmptyExtension(b.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${se.identifier.value}, startup: ${le.startup}, activationEvent: '${le.activationEvent}'${se.identifier.value!==le.extensionId.value?`, root cause: ${le.extensionId.value}`:""}`),this.l.flush();const we=new b.ExtensionActivationTimesBuilder(le.startup);return Promise.all([this.pb(se,(0,L.joinPath)(se.extensionLocation,me),we),this.bb(se)]).then(Me=>(y.mark(`code/extHost/willActivateExtension/${se.identifier.value}`),Ri.cb(this.l,se.identifier,Me[0],Me[1],we))).then(Me=>(y.mark(`code/extHost/didActivateExtension/${se.identifier.value}`),Me))}bb(se){const le=new w.ExtensionGlobalMemento(se,this.G),_=new w.ExtensionMemento(se.identifier.value,!1,this.G),me=new J.ExtensionSecrets(se,this.H),we=se.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,Me=this.f.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${se.identifier.value}`),Promise.all([le.whenReady,_.whenReady,this.I.whenReady]).then(()=>{const We=this;let Qe,Te;const De=(0,c.isProposedApiEnabled)(se,"ipc")?this.f.messagePorts?.get(E.ExtensionIdentifier.toKey(se.identifier)):void 0;return Object.freeze({globalState:le,workspaceState:_,secrets:me,subscriptions:[],get extensionUri(){return se.extensionLocation},get extensionPath(){return se.extensionLocation.fsPath},asAbsolutePath(ke){return T.join(se.extensionLocation.fsPath,ke)},get storagePath(){return We.I.workspaceValue(se)?.fsPath},get globalStoragePath(){return We.I.globalValue(se).fsPath},get logPath(){return T.join(We.f.logsLocation.fsPath,se.identifier.value)},get logUri(){return k.URI.joinPath(We.f.logsLocation,se.identifier.value)},get storageUri(){return We.I.workspaceValue(se)},get globalStorageUri(){return We.I.globalValue(se)},get extensionMode(){return we},get extension(){return Qe===void 0&&(Qe=new K(We,se.identifier,se,Me,!1)),Qe},get extensionRuntime(){return(0,c.checkProposedApiEnabled)(se,"extensionRuntime"),We.extensionRuntime},get environmentVariableCollection(){return We.p.getEnvironmentVariableCollection(se)},get messagePassingProtocol(){if(!Te){if(!De)return;const ke=O.Event.buffer(O.Event.fromDOMEventEmitter(De,"message",oe=>oe.data));De.start(),Te={onDidReceiveMessage:ke,postMessage:De.postMessage.bind(De)}}return Te}})})}static cb(se,le,_,me,we){return _=_||{activate:void 0,deactivate:void 0},this.db(se,le,_,me,we).then(Me=>new b.ActivatedExtension(!1,null,we.build(),_,Me,me.subscriptions))}static db(se,le,_,me,we){if(typeof _.activate=="function")try{we.activateCallStart(),se.trace(`ExtensionService#_callActivateOptional ${le.value}`);const Me=typeof global=="object"?global:self,We=_.activate.apply(Me,[me]);return we.activateCallStop(),we.activateResolveStart(),Promise.resolve(We).then(Qe=>(we.activateResolveStop(),Qe))}catch(Me){return Promise.reject(Me)}else return Promise.resolve(_)}eb(se,le){this.S(se.identifier,{startup:!1,extensionId:se.identifier,activationEvent:le}).then(void 0,_=>{this.l.error(_)})}fb(){this.v.$setPerformanceMarks(y.getMarks());for(const se of this.D.getAllExtensionDescriptions())if(se.activationEvents)for(const le of se.activationEvents)le==="onStartupFinished"&&this.eb(se,le)}gb(){const se=this.R("*",!0).then(void 0,we=>{this.l.error(we)});this.B(this.j.onDidChangeWorkspace(we=>this.hb(we.added)));const le=this.j.workspace?this.j.workspace.folders:[],_=this.hb(le),me=Promise.all([se,_]).then(()=>{});return Promise.race([me,(0,C.timeout)(1e4)]).then(()=>{this.fb()}),me}hb(se){return se.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(le=>this.ib(se,le))).then(()=>{})}async ib(se,le){if(this.isActivated(le.identifier))return;const _=!this.f.remote.isRemote&&!!this.f.remote.authority,me={logService:this.l,folders:se.map(Me=>Me.uri),forceUsingSearch:_,exists:Me=>this.c.exists(Me.fsPath),checkExists:(Me,We,Qe)=>this.t.$checkExists(Me,We,Qe)},we=await(0,N.checkActivateWorkspaceContainsExtension)(me,le);if(!!we)return this.S(le.identifier,{startup:!0,extensionId:le.identifier,activationEvent:we.activationEvent}).then(void 0,Me=>this.l.error(Me))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(se){throw console.error(se),se}}async jb(){const{extensionDevelopmentLocationURI:se,extensionTestsLocationURI:le}=this.f.environment;if(!se||!le)throw new Error(i.localize(0,null));const _=await this.pb(null,le,new b.ExtensionActivationTimesBuilder(!1));if(!_||typeof _.run!="function")throw new Error(i.localize(1,null,le.toString()));return new Promise((me,we)=>{const Me=(Te,De)=>{Te?we(Te):me(typeof De=="number"&&De>0?1:0)},We=(0,L.originalFSPath)(le),Qe=_.run(We,Me);Qe&&Qe.then&&Qe.then(()=>{me(0)}).catch(Te=>{we(Te instanceof Error&&Te.stack?Te.stack:String(Te))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(se,le){return this.M[se]=le,(0,A.toDisposable)(()=>{delete this.M[se]})}async lb(se){const le=se.indexOf("+");if(le===-1)throw new Error("Not an authority that can be resolved!");const _=se.substr(0,le);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${_}`,!1),{authorityPrefix:_,resolver:this.M[_]}}async $resolveAuthority(se,le){this.l.info(`$resolveAuthority invoked for authority (${ge(se)})`);const{authorityPrefix:_,resolver:me}=await this.lb(se);if(!me)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${_}.`,detail:void 0}};try{this.B(await this.m.setTunnelFactory(me)),y.mark(`code/extHost/willResolveAuthority/${_}`);const we=await me.resolve(se,{resolveAttempt:le});y.mark(`code/extHost/didResolveAuthorityOK/${_}`);const Me={authority:se,host:we.host,port:we.port,connectionToken:we.connectionToken},We={extensionHostEnv:we.extensionHostEnv,isTrusted:we.isTrusted,authenticationSession:we.authenticationSessionForInitializingExtensions?{id:we.authenticationSessionForInitializingExtensions.id,providerId:we.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Me,options:We,tunnelInformation:{environmentTunnels:we.environmentTunnels,features:we.tunnelFeatures}}}}catch(we){if(y.mark(`code/extHost/didResolveAuthorityError/${_}`),we instanceof s.RemoteAuthorityResolverError)return{type:"error",error:{code:we._code,message:we._message,detail:we._detail}};throw we}}async $getCanonicalURI(se,le){this.l.info(`$getCanonicalURI invoked for authority (${ge(se)})`);const{resolver:_}=await this.lb(se);if(!_)return null;const me=k.URI.revive(le);if(typeof _.getCanonicalURI>"u")return me;const we=await(0,C.asPromise)(()=>_.getCanonicalURI(me));return we||me}static mb(se,le,_){const me=new u.ExtensionDescriptionRegistry(se.getAllExtensionDescriptions());me.deltaExtensions(_.toAdd,_.toRemove);const we=(0,c.extensionIdentifiersArrayToSet)(le.getAllExtensionDescriptions().map(We=>We.identifier));for(const We of _.myToRemove)we.delete(E.ExtensionIdentifier.toKey(We));for(const We of _.myToAdd)we.add(E.ExtensionIdentifier.toKey(We));const Me=ie(me,we);return{globalRegistry:me,myExtensions:Me}}$startExtensionHost(se){se.toAdd.forEach(me=>me.extensionLocation=k.URI.revive(me.extensionLocation));const{globalRegistry:le,myExtensions:_}=Ri.mb(this.F,this.D,se);return this.F.set(le.getAllExtensionDescriptions()),this.D.set(_),this.kb()}$activateByEvent(se,le){return le===1?this.R(se,!1):this.z.wait().then(_=>this.R(se,!1))}async $activate(se,le){return await this.z.wait(),this.D.getExtensionDescription(se)?(await this.S(se,le),!0):!1}async $deltaExtensions(se){se.toAdd.forEach(Me=>Me.extensionLocation=k.URI.revive(Me.extensionLocation));const{globalRegistry:le,myExtensions:_}=Ri.mb(this.F,this.D,se),me=await this.W(_);return(await this.getExtensionPathIndex()).setSearchTree(me),this.F.set(le.getAllExtensionDescriptions()),this.D.set(_),Promise.resolve(void 0)}async $test_latency(se){return se}async $test_up(se){return se.byteLength}async $test_down(se){const le=v.VSBuffer.alloc(se),_=Math.random()%256;for(let me=0;me<se;me++)le.writeUInt8(_,me);return le}async $updateRemoteConnectionData(se){this.P=se,this.a.fire()}};z=qe([Ve(0,o.IInstantiationService),Ve(1,e.IHostUtils),Ve(2,l.IExtHostRpcService),Ve(3,t.IExtHostWorkspace),Ve(4,m.IExtHostConfiguration),Ve(5,M.ILogService),Ve(6,h.IExtHostInitDataService),Ve(7,a.IExtensionStoragePaths),Ve(8,d.IExtHostTunnelService),Ve(9,g.IExtHostTerminalService),Ve(10,R.IExtHostLocalizationService)],z),e.AbstractExtHostExtensionService=z;function V(re,se){return{id:re.identifier.value,name:re.name,extensionVersion:re.version,publisherDisplayName:re.publisher,activationEvents:re.activationEvents?re.activationEvents.join(","):null,isBuiltin:re.isBuiltin,reason:se.activationEvent,reasonId:se.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class K{constructor(se,le,_,me,we){P.set(this,void 0),F.set(this,void 0),B.set(this,void 0),Ye(this,P,se,"f"),Ye(this,F,le,"f"),Ye(this,B,_.identifier,"f"),this.id=_.identifier.value,this.extensionUri=_.extensionLocation,this.extensionPath=T.normalize((0,L.originalFSPath)(_.extensionLocation)),this.packageJSON=_,this.extensionKind=me,this.isFromDifferentExtensionHost=we}get isActive(){return Re(this,P,"f").isActivated(Re(this,B,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Re(this,P,"f").getExtensionExports(Re(this,B,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Re(this,P,"f").activateByIdWithErrors(Re(this,B,"f"),{startup:!1,extensionId:Re(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=K,P=new WeakMap,F=new WeakMap,B=new WeakMap;function ie(re,se){return re.getAllExtensionDescriptions().filter(le=>se.has(E.ExtensionIdentifier.toKey(le.identifier)))}function ge(re){const se=re.indexOf("+");return se===-1?re:re.substring(0,se)}class ue{constructor(se){this.a=se}setSearchTree(se){this.a=se}findSubstr(se){return this.a.findSubstr(se)}forEach(se){return this.a.forEach(se)}}e.ExtensionPaths=ue}),define(Ie[239],Ce([1,0,77,2,4,32,25,26,15,27,3,33,49,12,10]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let t=class{constructor(w,s,r,o,h,a,l){this.c=w,this.d=s,this.e=r,this.f=o,this.g=h,this.h=a,this.i=l,this.a=new Map,this.b=[]}async install(){this.j(),i.mark("code/extHost/willWaitForConfig");const w=await this.f.getConfigProvider();i.mark("code/extHost/didWaitForConfig");const s=await this.g.getExtensionPathIndex();this.register(new u(this.c,s,this.d,w,this.i)),this.register(this.e.createInstance(p,s)),this.register(this.e.createInstance(c)),this.h.remote.isRemote&&this.register(this.e.createInstance(E,s,this.h.environment.appUriScheme))}register(w){if("nodeModuleName"in w)if(Array.isArray(w.nodeModuleName))for(const s of w.nodeModuleName)this.a.set(s,w);else this.a.set(w.nodeModuleName,w);typeof w.alternativeModuleName=="function"&&this.b.push(s=>w.alternativeModuleName(s))}};t=qe([Ve(2,M.IInstantiationService),Ve(3,L.IExtHostConfiguration),Ve(4,D.IExtHostExtensionService),Ve(5,k.IExtHostInitDataService),Ve(6,b.ILogService)],t),e.RequireInterceptor=t;let c=class Zi{constructor(w){if(w.environment.appRoot&&Zi.a.size){const s=(0,f.escapeRegExpCharacters)(this.c(w.environment.appRoot.fsPath)),r="[a-z0-9_.-]",o=`@${r}+\\/${r}+|${r}+`,h="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${s}/${h}\\/)(${o})(.*)$`,"i")}}alternativeModuleName(w){if(!this.b)return;const s=this.b.exec(this.c(w));if(!s)return;const[,r,o,h]=s,a=Zi.a.get(o);if(a!==void 0)return console.warn(`${o} as been renamed to ${a}, please update your imports`),r+a+h}c(w){return w.replace(/\\/g,"/")}};c.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),c=qe([Ve(0,k.IExtHostInitDataService)],c);class u{constructor(w,s,r,o,h){this.c=w,this.d=s,this.e=r,this.f=o,this.g=h,this.nodeModuleName="vscode",this.a=new Map}load(w,s){const r=this.d.findSubstr(s);if(r){let o=this.a.get(A.ExtensionIdentifier.toKey(r.identifier));return o||(o=this.c(r,this.e,this.f),this.a.set(A.ExtensionIdentifier.toKey(r.identifier),o)),o}if(!this.b){let o="";this.d.forEach((h,a)=>o+=`	${a} -> ${h.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${o}`),this.b=this.c(C.nullExtensionDescription,this.e,this.f)}return this.b}}let p=class{constructor(w,s,r){this.d=w,this.nodeModuleName="keytar",this.a=s.getProxy(y.MainContext.MainThreadTelemetry);const{environment:o}=r,h=s.getProxy(y.MainContext.MainThreadKeytar);if(o.appRoot){let a=o.appRoot.fsPath;m.platform==="win32"&&(a=a.replace(/\\/g,"/")),a[a.length-1]==="/"&&(a=a.substr(0,a.length-1)),this.b=new Set,this.b.add(`${a}/node_modules.asar/keytar`),this.b.add(`${a}/node_modules/keytar`)}this.c={getPassword:(a,l)=>h.$getPassword(a,l),setPassword:(a,l,n)=>h.$setPassword(a,l,n),deletePassword:(a,l)=>h.$deletePassword(a,l),findPassword:a=>h.$findPassword(a),findCredentials(a){return h.$findCredentials(a)}}}load(w,s){const r=this.d.findSubstr(s);return this.a.$publicLog2("shimming.keytar",{extension:r?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(w){const s=w.length;if(s<=7||!this.b)return;const r=s-7;if((w.charAt(r)==="/"||w.charAt(r)==="\\")&&w.endsWith("keytar")&&(w=w.replace(/\\/g,"/"),this.b.has(w)))return"keytar"}};p=qe([Ve(1,S.IExtHostRpcService),Ve(2,k.IExtHostInitDataService)],p);let E=class{constructor(w,s,r){this.e=w,this.f=s,this.nodeModuleName=["open","opn"],this.d=r.getProxy(y.MainContext.MainThreadTelemetry);const o=r.getProxy(y.MainContext.MainThreadWindow);this.c=(h,a)=>{const l=T.URI.parse(h);return a?this.g(h,a):l.scheme==="http"||l.scheme==="https"?o.$openUri(l,h,{allowTunneling:!0}):l.scheme==="mailto"||l.scheme===this.f?o.$openUri(l,h,{}):this.g(h,a)}}load(w,s,r){const o=this.e.findSubstr(s);return o&&(this.a=o.identifier.value,this.h()),this.b=r(w),this.c}g(w,s){return this.i(),this.b(w,s)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};E=qe([Ve(2,S.IExtHostRpcService)],E)}),define(Ie[106],Ce([1,0,205,7,19,49,3,55,56,33,6,31,179,32]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,C.createDecorator)("IExtHostVariableResolverProvider");class f extends m.AbstractVariableResolverService{constructor(u,p,E,v,w,s,r){function o(){if(E){const h=E.activeEditor();if(h)return h.document.uri;const a=v.tabGroups.all.find(l=>l.isActive)?.activeTab;if(a!==void 0){if(a.input instanceof M.TextDiffTabInput||a.input instanceof M.NotebookDiffEditorTabInput)return a.input.modified;if(a.input instanceof M.TextTabInput||a.input instanceof M.NotebookEditorTabInput||a.input instanceof M.CustomEditorTabInput)return a.input.uri}}}super({getFolderUri:h=>{const a=s.folders.filter(l=>l.name===h);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>s.folders.length,getConfigurationValue:(h,a)=>w.getConfiguration(void 0,h).get(a),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const h=o();if(h)return y.normalize(h.fsPath)},getWorkspaceFolderPathForFile:()=>{if(p){const h=o();if(h){const a=p.getWorkspaceFolder(h);if(a)return y.normalize(a.uri.fsPath)}}},getSelectedText:()=>{if(E){const h=E.activeEditor();if(h&&!h.selection.isEmpty)return h.document.getText(h.selection)}},getLineNumber:()=>{if(E){const h=E.activeEditor();if(h)return String(h.selection.end.line+1)}},getExtension:h=>u.getExtension(h)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(L.env))}}let t=class extends T.Disposable{constructor(u,p,E,v,w){super(),this.b=u,this.c=p,this.g=E,this.h=v,this.i=w,this.a=new i.Lazy(async()=>{const s=await this.h.getConfigProvider(),o={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async h=>{o.folders=await this.c.getWorkspaceFolders2()||[]})),new f(this.b,this.c,this.g,this.i,s,o,this.j())})}getResolver(){return this.a.getValue()}j(){}};t=qe([Ve(0,k.IExtHostExtensionService),Ve(1,D.IExtHostWorkspace),Ve(2,A.IExtHostDocumentsAndEditors),Ve(3,b.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs)],t),e.ExtHostVariableResolverProviderService=t}),define(Ie[107],Ce([1,0,14,5,9,2,3,4,56,33,15,6,31,171,173,32,106]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m,b,f,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,C.createDecorator)("IExtHostDebugService");let u=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(o,h,a,l,n,d){this.D=h,this.E=a,this.F=l,this.G=n,this.H=d,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new T.Emitter,this.n=new T.Emitter,this.o=new T.Emitter,this.u=new T.Emitter,this.k=o.getProxy(A.MainContext.MainThreadDebugService),this.z=new T.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new E(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(g=>{g.onDidChange(O=>{this.I(g)}),this.I(g)})}asDebugSourceUri(o,h){const a=o;if(typeof a.sourceReference=="number"&&a.sourceReference>0){let l=`debug:${encodeURIComponent(a.path||"")}`,n="?";return h&&(l+=`${n}session=${encodeURIComponent(h.id)}`,n="&"),l+=`${n}ref=${a.sourceReference}`,L.URI.parse(l)}else{if(a.path)return L.URI.file(a.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(o){const h=[];for(const a of o.getAllExtensionDescriptions())if(a.contributes){const l=a.contributes.debuggers;if(l&&l.length>0)for(const n of l)(0,f.isDebuggerMainContribution)(n)&&h.push(n.type)}this.k.$registerDebugTypes(h)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const o=[];return this.w.forEach(h=>o.push(h)),o}addBreakpoints(o){this.T();const h=o.filter(n=>{const d=n.id;return this.w.has(d)?!1:(this.w.set(d,n),!0)});this.U(h,[],[]);const a=[],l=new Map;for(const n of h)if(n instanceof D.SourceBreakpoint){let d=l.get(n.location.uri.toString());d||(d={type:"sourceMulti",uri:n.location.uri,lines:[]},l.set(n.location.uri.toString(),d),a.push(d)),d.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof D.FunctionBreakpoint&&a.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this.k.$registerBreakpoints(a)}removeBreakpoints(o){this.T();const h=o.filter(d=>this.w.delete(d.id));this.U([],h,[]);const a=h.filter(d=>d instanceof D.SourceBreakpoint).map(d=>d.id),l=h.filter(d=>d instanceof D.FunctionBreakpoint).map(d=>d.id),n=h.filter(d=>d instanceof D.DataBreakpoint).map(d=>d.id);return this.k.$unregisterBreakpoints(a,l,n)}startDebugging(o,h,a){return this.k.$startDebugging(o?o.uri:void 0,h,{parentSessionID:a.parentSession?a.parentSession.id:void 0,lifecycleManagedByParent:a.lifecycleManagedByParent,repl:a.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:a.noDebug,compact:a.compact,suppressSaveBeforeStart:a.suppressSaveBeforeStart,suppressDebugStatusbar:a.suppressDebugStatusbar??a.debugUI?.simple,suppressDebugToolbar:a.suppressDebugToolbar??a.debugUI?.simple,suppressDebugView:a.suppressDebugView??a.debugUI?.simple})}stopDebugging(o){return this.k.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,h,a){if(!h)return new D.Disposable(()=>{});const l=this.d++;return this.f.push({type:o,handle:l,provider:h}),this.k.$registerDebugConfigurationProvider(o,a,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,l),new D.Disposable(()=>{this.f=this.f.filter(n=>n.provider!==h),this.k.$unregisterDebugConfigurationProvider(l)})}registerDebugAdapterDescriptorFactory(o,h,a){if(!a)return new D.Disposable(()=>{});if(!this.P(o,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.M(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const l=this.g++;return this.h.push({type:h,handle:l,factory:a}),this.k.$registerDebugAdapterDescriptorFactory(h,l),new D.Disposable(()=>{this.h=this.h.filter(n=>n.factory!==a),this.k.$unregisterDebugAdapterDescriptorFactory(l)})}registerDebugAdapterTrackerFactory(o,h){if(!h)return new D.Disposable(()=>{});const a=this.i++;return this.j.push({type:o,handle:a,factory:h}),new D.Disposable(()=>{this.j=this.j.filter(l=>l.factory!==h)})}async $runInTerminal(o,h){return Promise.resolve(void 0)}async $substituteVariables(o,h){let a;const l=await this.W(o);return l&&(a={uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(a,h)}J(o,h){if(o.type==="implementation")return new w(o.implementation)}K(){}async $startDASession(o,h){const a=this,l=await this.V(h);return this.R(this.M(l.type),l).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}' (extension might have failed to activate)`);const d=this.L(n),g=this.J(d,l);if(!g)throw new Error(`Couldn't create a debug adapter for type '${l.type}'.`);const O=g;return this.A.set(o,O),this.Q(l).then(N=>(N&&this.B.set(o,N),O.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const J=q,x={type:"response",seq:0,command:J.command,request_seq:J.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const R=await this.C.sign(J.arguments.value);x.body={signature:R},O.sendResponse(x)}else throw new Error("no signer")}catch(R){x.success=!1,x.message=R.message,O.sendResponse(x)}}else N&&N.onDidSendMessage&&N.onDidSendMessage(q),q=(0,f.convertToVSCPaths)(q,!0),a.k.$acceptDAMessage(o,q)}),O.onError(q=>{N&&N.onError&&N.onError(q),this.k.$acceptDAError(o,q.name,q.message,q.stack)}),O.onExit(q=>{N&&N.onExit&&N.onExit((0,y.withNullAsUndefined)(q),void 0),this.k.$acceptDAExit(o,(0,y.withNullAsUndefined)(q),void 0)}),N&&N.onWillStartSession&&N.onWillStartSession(),O.startSession()))})}$sendDAMessage(o,h){h=(0,f.convertToDAPaths)(h,!1);const a=this.B.get(o);a&&a.onWillReceiveMessage&&a.onWillReceiveMessage(h),this.A.get(o)?.sendMessage(h)}$stopDASession(o){const h=this.B.get(o);this.B.delete(o),h&&h.onWillStopSession&&h.onWillStopSession();const a=this.A.get(o);return this.A.delete(o),a?a.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const h=[],a=[],l=[];if(o.added)for(const n of o.added){const d=n.id;if(d&&!this.w.has(d)){let g;if(n.type==="function")g=new D.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")g=new D.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const O=L.URI.revive(n.uri);g=new D.SourceBreakpoint(new D.Location(O,new D.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}g._id=d,this.w.set(d,g),h.push(g)}}if(o.removed)for(const n of o.removed){const d=this.w.get(n);d&&(this.w.delete(n),a.push(d))}if(o.changed){for(const n of o.changed)if(n.id){const d=this.w.get(n.id);if(d){if(d instanceof D.FunctionBreakpoint&&n.type==="function"){const g=d;g.enabled=n.enabled,g.condition=n.condition,g.hitCondition=n.hitCondition,g.logMessage=n.logMessage,g.functionName=n.functionName}else if(d instanceof D.SourceBreakpoint&&n.type==="source"){const g=d;g.enabled=n.enabled,g.condition=n.condition,g.hitCondition=n.hitCondition,g.logMessage=n.logMessage,g.location=new D.Location(L.URI.revive(n.uri),new D.Position(n.line,n.character))}l.push(d)}}}this.U(h,a,l)}$provideDebugConfigurations(o,h,a){return(0,i.asPromise)(async()=>{const l=this.O(o);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.W(h);return l.provideDebugConfigurations(n,a)}).then(l=>{if(!l)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return l})}$resolveDebugConfiguration(o,h,a,l){return(0,i.asPromise)(async()=>{const n=this.O(o);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const d=await this.W(h);return n.resolveDebugConfiguration(d,a,l)})}$resolveDebugConfigurationWithSubstitutedVariables(o,h,a,l){return(0,i.asPromise)(async()=>{const n=this.O(o);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const d=await this.W(h);return n.resolveDebugConfigurationWithSubstitutedVariables(d,a,l)})}async $provideDebugAdapter(o,h){const a=this.N(o);if(!a)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const l=await this.V(h);return this.R(a,l).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}'`);return this.L(n)})}async $acceptDebugSessionStarted(o){const h=await this.V(o);this.m.fire(h)}async $acceptDebugSessionTerminated(o){const h=await this.V(o);h&&(this.n.fire(h),this.l.delete(h.id))}async $acceptDebugSessionActiveChanged(o){this.q=o?await this.V(o):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(o,h){(await this.V(o))?._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(o,h){const l={session:await this.V(o),event:h.event,body:h.body};this.u.fire(l)}L(o){if(o instanceof D.DebugAdapterExecutable)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof D.DebugAdapterServer)return{type:"server",port:o.port,host:o.host};if(o instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:o.path};if(o instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}M(o){const h=this.h.filter(a=>a.type===o);if(h.length>0)return h[0].factory}N(o){const h=this.h.filter(a=>a.handle===o);if(h.length>0)return h[0].factory}O(o){const h=this.f.filter(a=>a.handle===o);if(h.length>0)return h[0].provider}P(o,h){if(o.contributes){const a=o.contributes.debuggers;if(a&&a.length>0){for(const l of a)if(l.label&&l.type&&l.type===h)return!0}}return!1}Q(o){const a=o.configuration.type,l=this.j.filter(n=>n.type===a||n.type==="*").map(n=>(0,i.asPromise)(()=>n.factory.createDebugAdapterTracker(o)).then(d=>d,d=>null));return Promise.race([Promise.all(l).then(n=>{const d=n.filter(g=>!!g);if(d.length>0)return new v(d)}),new Promise(n=>setTimeout(()=>n(void 0),1e3))]).catch(n=>{})}async R(o,h){const a=h.configuration.debugServer;if(typeof a=="number")return Promise.resolve(new D.DebugAdapterServer(a));if(o){const n=await this.E.getExtensionRegistry();return(0,i.asPromise)(()=>o.createDebugAdapterDescriptor(h,this.S(h,n))).then(d=>{if(d)return d})}const l=await this.E.getExtensionRegistry();return Promise.resolve(this.S(h,l))}S(o,h){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(o,h,a){(o.length>0||h.length>0||a.length>0)&&this.z.fire(Object.freeze({added:o,removed:h,changed:a}))}async V(o){if(o)if(typeof o=="string"){const h=this.l.get(o);if(h)return h}else{let h=this.l.get(o.id);if(!h){const a=await this.W(o.folderUri),l=o.parent?this.l.get(o.parent):void 0;h=new p(this.k,o.id,o.type,o.name,a,o.configuration,l),this.l.set(h.id,h),this.k.$sessionCached(h.id)}return h}throw new Error("cannot find session")}W(o){if(o){const h=L.URI.revive(o);return this.D.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}};u=qe([Ve(0,M.IExtHostRpcService),Ve(1,m.IExtHostWorkspace),Ve(2,k.IExtHostExtensionService),Ve(3,t.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs),Ve(5,c.IExtHostVariableResolverProvider)],u),e.ExtHostDebugServiceBase=u;class p{constructor(o,h,a,l,n,d,g){this.d=o,this.f=h,this.g=a,this.h=l,this.i=n,this.j=d,this.k=g}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(o){this.h=o,this.d.$setDebugSessionName(this.f,o)}get parentSession(){return this.k}_acceptNameChanged(o){this.h=o}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(o,h){return this.d.$customDebugAdapterRequest(this.f,o,h)}getDebugProtocolBreakpoint(o){return this.d.$getDebugProtocolBreakpoint(this.f,o.id)}}e.ExtHostDebugSession=p;class E{constructor(o){this.value=Object.freeze({append(h){o.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.ExtHostDebugConsole=E;class v{constructor(o){this.d=o}onWillStartSession(){this.d.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.d.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.d.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(o):void 0)}onWillStopSession(){this.d.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.d.forEach(h=>h.onError?h.onError(o):void 0)}onExit(o,h){this.d.forEach(a=>a.onExit?a.onExit(o,h):void 0)}}class w extends b.AbstractDebugAdapter{constructor(o){super(),this.h=o,o.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.h.handleMessage(o)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let s=class extends u{constructor(o,h,a,l,n,d){super(o,h,a,l,n,d)}};s=qe([Ve(0,M.IExtHostRpcService),Ve(1,m.IExtHostWorkspace),Ve(2,k.IExtHostExtensionService),Ve(3,t.IExtHostConfiguration),Ve(4,S.IExtHostEditorTabs),Ve(5,c.IExtHostVariableResolverProvider)],s),e.WorkerExtHostDebugService=s}),define(Ie[240],Ce([1,0,11,77,2,4,231,12,62,63,27,153,15,52,33,70]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m,b,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class c{static async installEarlyHandler(E){const v=E.get(A.ILogService),s=E.get(m.IExtHostRpcService).getProxy(L.MainContext.MainThreadErrors);i.setUnexpectedErrorHandler(r=>{v.error(r);const o=i.transformErrorForSerialization(r);s.$onUnexpectedError(o)})}static async installFullHandler(E){const v=E.get(A.ILogService),w=E.get(m.IExtHostRpcService),s=E.get(f.IExtHostExtensionService),r=E.get(t.IExtHostTelemetry),o=w.getProxy(L.MainContext.MainThreadExtensionService),h=w.getProxy(L.MainContext.MainThreadErrors),a=await s.getExtensionPathIndex(),l=new WeakMap;Error.prepareStackTrace=(n,d)=>{let g="",O,N;for(const q of d)g+=`
	at ${q.toString()}`,N=q.getFileName(),!O&&N&&(O=a.findSubstr(y.URI.file(N)));return l.set(n,O?.identifier),`${n.name||"Error"}: ${n.message||""}${g}`},i.setUnexpectedErrorHandler(n=>{v.error(n);const d=i.transformErrorForSerialization(n),g=l.get(n);if(!g){h.$onUnexpectedError(d);return}o.$onExtensionRuntimeError(g,d);const O=r.onExtensionError(g,n);v.trace("forwarded error to extension?",O,g)})}}Error.stackTraceLimit=100;class u{constructor(E,v,w,s,r){this.a=w,this.b=new C.RPCProtocol(E,null,s),v=u.e(v,this.b);const o=new k.ServiceCollection(...(0,S.getSingletonServiceDescriptors)());o.set(M.IExtHostInitDataService,{_serviceBrand:void 0,...v,messagePorts:r}),o.set(m.IExtHostRpcService,new m.ExtHostRpcService(this.b)),o.set(b.IURITransformerService,new b.URITransformerService(s)),o.set(f.IHostUtils,w);const h=new D.InstantiationService(o,!0);h.invokeFunction(c.installEarlyHandler),this.d=h.invokeFunction(a=>a.get(A.ILogService)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",v),this.c=h.invokeFunction(a=>a.get(f.IExtHostExtensionService)),this.c.initialize(),h.invokeFunction(c.installFullHandler)}async asBrowserUri(E){const v=this.b.getProxy(L.MainContext.MainThreadExtensionService);return y.URI.revive(await v.$asBrowserUri(E))}terminate(E){this.c.terminate(E)}static e(E,v){E.allExtensions.forEach(s=>{s.extensionLocation=y.URI.revive(v.transformIncomingURIs(s.extensionLocation));const r={};s.browserNlsBundleUris&&(Object.keys(s.browserNlsBundleUris).forEach(o=>r[o]=y.URI.revive(v.transformIncomingURIs(s.browserNlsBundleUris[o]))),s.browserNlsBundleUris=r)}),E.environment.appRoot=y.URI.revive(v.transformIncomingURIs(E.environment.appRoot));const w=E.environment.extensionDevelopmentLocationURI;return w&&(E.environment.extensionDevelopmentLocationURI=w.map(s=>y.URI.revive(v.transformIncomingURIs(s)))),E.environment.extensionTestsLocationURI=y.URI.revive(v.transformIncomingURIs(E.environment.extensionTestsLocationURI)),E.environment.globalStorageHome=y.URI.revive(v.transformIncomingURIs(E.environment.globalStorageHome)),E.environment.workspaceStorageHome=y.URI.revive(v.transformIncomingURIs(E.environment.workspaceStorageHome)),E.environment.extensionTelemetryLogResource=y.URI.revive(v.transformIncomingURIs(E.environment.extensionTelemetryLogResource)),E.nlsBaseUrl=y.URI.revive(v.transformIncomingURIs(E.nlsBaseUrl)),E.logsLocation=y.URI.revive(v.transformIncomingURIs(E.logsLocation)),E.logFile=y.URI.revive(v.transformIncomingURIs(E.logFile)),E.workspace=v.transformIncomingURIs(E.workspace),E}}e.ExtensionHostMain=u}),define(Ie[241],Ce([1,0,16,14,20,45,13,19,22,2,44]),function(ee,e,i,T,y,L,C,A,S,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class D{constructor(p,E,v,w){this.d=p,this.e=E,this.f=v,this.g=w,this.a=null,this.b=!1,this.c=0}search(p,E){const v=this.d.folderQueries||[],w=new y.CancellationTokenSource;return E.onCancellationRequested(()=>w.cancel()),new Promise((s,r)=>{this.a=new b(p);let o=!1;const h=(a,l)=>{if(!o&&!this.b){const n=this.h(a);t(a)&&typeof this.d.maxResults=="number"&&this.c+n>this.d.maxResults&&(this.b=!0,o=!0,w.cancel(),a=this.j(a,this.d.maxResults-this.c));const d=this.h(a);this.c+=d,(d>0||!t(a))&&this.a.add(a,l)}};Promise.all(v.map((a,l)=>this.k(a,n=>h(n,l),w.token))).then(a=>{w.dispose(),this.a.flush();const l=a.some(n=>!!n&&!!n.limitHit);s({limitHit:this.b||l,messages:(0,i.flatten)(a.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.g}})},a=>{w.dispose();const l=(0,L.toErrorMessage)(a);r(new Error(l))})})}h(p){return t(p)?Array.isArray(p.ranges)?p.ranges.length:1:0}j(p,E){const v=Array.isArray(p.ranges)?p.ranges:[p.ranges],w=Array.isArray(p.preview.matches)?p.preview.matches:[p.preview.matches];return{ranges:v.slice(0,E),preview:{matches:w.slice(0,E),text:p.preview.text},uri:p.uri}}async k(p,E,v){const w=new M.QueryGlobTester(this.d,p),s=[],r={report:a=>{if(!this.l(a))return;const l=p.folder.scheme===C.Schemas.file?(0,M.hasSiblingPromiseFn)(()=>this.f.readdir(S.dirname(a.uri))):void 0,n=S.relativePath(p.folder,a.uri);if(n){const d=w.includedInQuery(n,A.basename(n),l);(0,T.isThenable)(d)?s.push(d.then(g=>{g&&E(a)})):d&&E(a)}}},o=this.n(p),h=await this.e.provideTextSearchResults(m(this.d.contentPattern),o,r,v);return s.length&&await Promise.all(s),h}l(p){if(t(p)){if(Array.isArray(p.ranges)){if(!Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(p.preview.matches.length!==p.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(p){const E=(0,M.resolvePatternsForProvider)(this.d.includePattern,p.includePattern),v=(0,M.resolvePatternsForProvider)(this.d.excludePattern,p.excludePattern),w={folder:k.URI.from(p.folder),excludes:v,includes:E,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,encoding:p.fileEncoding&&this.f.toCanonicalName(p.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return w.usePCRE2=this.d.usePCRE2,w}}e.TextSearchManager=D;function m(u){return{isCaseSensitive:u.isCaseSensitive||!1,isRegExp:u.isRegExp||!1,isWordMatch:u.isWordMatch||!1,isMultiline:u.isMultiline||!1,pattern:u.pattern}}class b{constructor(p){this.e=p,this.b=-1,this.d=null,this.a=new c(512,E=>this.g(E))}add(p,E){this.d&&(this.b!==E||!S.isEqual(this.c,p.uri))&&(this.f(),this.d=null),this.d||(this.b=E,this.d={resource:p.uri,results:[]}),this.d.results.push(f(p))}f(){const p=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,p)}flush(){this.f(),this.a.flush()}g(p){this.e(p)}}e.TextSearchResultsCollector=b;function f(u){return t(u)?{preview:{matches:(0,i.mapArrayOrNot)(u.preview.matches,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character})),text:u.preview.text},ranges:(0,i.mapArrayOrNot)(u.ranges,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character}))}:{text:u.text,lineNumber:u.lineNumber}}function t(u){return!!u.preview}e.extensionResultIsMatch=t;class c{constructor(p,E){this.g=p,this.h=E,this.c=0,this.d=[],this.e=0}addItem(p,E){!p||this.j(p,E)}addItems(p,E){!p||this.k(p,E)}j(p,E){this.d.push(p),this.e+=E,this.l()}k(p,E){this.d=this.d.concat(p),this.e+=E,this.l()}l(){this.c<c.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},c.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=c,c.a=4e3,c.b=50}),define(Ie[108],Ce([1,0,7,4,3,236,15,52,12,2,241]),function(ee,e,i,T,y,L,C,A,S,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,y.createDecorator)("IExtHostSearch");let D=class{constructor(t,c,u){this.k=t,this.l=c,this.n=u,this.c=this.k.getProxy(T.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.FileSearchManager}o(t){return this.l.transformOutgoingScheme(t)}registerTextSearchProvider(t,c){if(this.g.has(t))throw new Error(`a text search provider for the scheme '${t}' is already registered`);this.g.add(t);const u=this.d++;return this.e.set(u,c),this.c.$registerTextSearchProvider(u,this.o(t)),(0,i.toDisposable)(()=>{this.g.delete(t),this.e.delete(u),this.c.$unregisterProvider(u)})}registerFileSearchProvider(t,c){if(this.i.has(t))throw new Error(`a file search provider for the scheme '${t}' is already registered`);this.i.add(t);const u=this.d++;return this.h.set(u,c),this.c.$registerFileSearchProvider(u,this.o(t)),(0,i.toDisposable)(()=>{this.i.delete(t),this.h.delete(u),this.c.$unregisterProvider(u)})}$provideFileSearchResults(t,c,u,p){const E=m(u),v=this.h.get(t);if(v)return this.j.fileSearch(E,v,w=>{this.c.$handleFileMatch(t,c,w.map(s=>s.resource))},p);throw new Error("unknown provider: "+t)}$clearCache(t){return this.j.clearCache(t),Promise.resolve(void 0)}$provideTextSearchResults(t,c,u,p){const E=this.e.get(t);if(!E||!E.provideTextSearchResults)throw new Error(`Unknown provider ${t}`);const v=m(u);return this.q(v,E).search(s=>this.c.$handleTextMatch(t,c,s),p)}$enableExtensionHostSearch(){}q(t,c){return new M.TextSearchManager(t,c,{readdir:u=>Promise.resolve([]),toCanonicalName:u=>u},"textSearchProvider")}};D=qe([Ve(0,C.IExtHostRpcService),Ve(1,A.IURITransformerService),Ve(2,S.ILogService)],D),e.ExtHostSearch=D;function m(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(b),extraFileResources:f.extraFileResources&&f.extraFileResources.map(t=>k.URI.revive(t))}}e.reviveQuery=m;function b(f){return{...f,folder:k.URI.revive(f.folder)}}}),define(Ie[242],Ce([1,0,62,103,31,101,32,38,55,58,105,107,108,75,65,72,102,57,37,74,70,56,212,12,183,106,73]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m,b,f,t,c,u,p,E,v,w,s,r,o,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(a.IExtHostLocalizationService,a.ExtHostLocalizationService,1),(0,i.registerSingleton)(r.ILoggerService,s.ExtHostLoggerService,1),(0,i.registerSingleton)(r.ILogService,o.ExtHostLogService,1),(0,i.registerSingleton)(t.IExtHostApiDeprecationService,t.ExtHostApiDeprecationService,1),(0,i.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,0),(0,i.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration,0),(0,i.registerSingleton)(u.IExtHostConsumerFileSystem,u.ExtHostConsumerFileSystem,0),(0,i.registerSingleton)(D.IExtHostDebugService,D.WorkerExtHostDebugService,0),(0,i.registerSingleton)(L.IExtHostDecorations,L.ExtHostDecorations,0),(0,i.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors,0),(0,i.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo,0),(0,i.registerSingleton)(T.IExtHostOutputService,T.ExtHostOutputService,1),(0,i.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch,0),(0,i.registerSingleton)(b.IExtHostStorage,b.ExtHostStorage,0),(0,i.registerSingleton)(M.IExtHostTask,M.WorkerExtHostTask,0),(0,i.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService,0),(0,i.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService,0),(0,i.registerSingleton)(c.IExtHostWindow,c.ExtHostWindow,0),(0,i.registerSingleton)(y.IExtHostWorkspace,y.ExtHostWorkspace,0),(0,i.registerSingleton)(E.IExtHostSecretState,E.ExtHostSecretState,0),(0,i.registerSingleton)(v.IExtHostTelemetry,v.ExtHostTelemetry,0),(0,i.registerSingleton)(w.IExtHostEditorTabs,w.ExtHostEditorTabs,0),(0,i.registerSingleton)(h.IExtHostVariableResolverProvider,h.ExtHostVariableResolverProviderService,0)}),define(Ie[243],Ce([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class i{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(y){if(y&&this.a.has(y)){const L=this.a.get(y);return this.a.delete(y),L}}addDragOperationTransfer(y,L){this.a.set(y,L)}getRenderedTreeElement(y){if(this.b.has(y))return this.b.get(y)}addRenderedTreeItemElement(y,L){this.b.set(y,L)}removeRenderedTreeItemElement(y){this.b.has(y)&&this.b.delete(y)}}e.TreeviewsService=i}),define(Ie[244],Ce([1,0,139,6,22,2,5,7,14,6,9,16,8,20,243,25]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m,b,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function c(E,v){if((0,M.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let w;return Array.isArray(E.highlights)&&(w=E.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),w=w.length?w:void 0),{label:E.label,highlights:w}}}class u{constructor(v,w,s){this.d=v,this.e=w,this.f=s,this.a=new Map,this.b=new f.TreeviewsService;function r(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}w.registerArgumentProcessor({processArgument:o=>r(o)?this.i(o):Array.isArray(o)&&o.length>0?o.map(h=>r(h)?this.i(h):h):o})}registerTreeDataProvider(v,w,s){const r=this.createTreeView(v,{treeDataProvider:w},s);return{dispose:()=>r.dispose()}}createTreeView(v,w,s){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=w.dragAndDropController?.dropMimeTypes??[],o=w.dragAndDropController?.dragMimeTypes??[],h=!!w.dragAndDropController?.handleDrag,a=!!w.dragAndDropController?.handleDrop,l=this.h(v,w,s),n=this.d.$registerTreeViewDataProvider(v,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany,dropMimeTypes:r,dragMimeTypes:o,hasHandleDrag:h,hasHandleDrop:a});return{get onDidCollapseElement(){return l.onDidCollapseElement},get onDidExpandElement(){return l.onDidExpandElement},get selection(){return l.selectedElements},get onDidChangeSelection(){return l.onDidChangeSelection},get visible(){return l.visible},get onDidChangeVisibility(){return l.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,t.checkProposedApiEnabled)(s,"treeItemCheckbox"),l.onDidChangeCheckboxState},get message(){return l.message},set message(d){l.message=d},get title(){return l.title},set title(d){l.title=d},get description(){return l.description},set description(d){l.description=d},get badge(){return l.badge},set badge(d){d!==void 0&&k.ViewBadge.isViewBadge(d)?l.badge={value:Math.floor(Math.abs(d.value)),tooltip:d.tooltip}:d===void 0&&(l.badge=void 0)},reveal:(d,g)=>l.reveal(d,g),dispose:async()=>{await n,this.a.delete(v),l.dispose()}}}$getChildren(v,w){const s=this.a.get(v);return s?s.getChildren(w):Promise.reject(new Error((0,i.localize)(0,null,v)))}async $handleDrop(v,w,s,r,o,h,a,l){const n=this.a.get(v);if(!n)return Promise.reject(new Error((0,i.localize)(1,null,v)));const d=m.DataTransfer.toDataTransfer(s,async g=>(await this.d.$resolveDropFileData(v,w,g)).buffer);return a===v&&l&&await this.g(d,n,l,o,h),n.onDrop(d,r,o)}async g(v,w,s,r,o){const h=this.b.removeDragOperationTransfer(o);if(h)(await h)?.forEach((a,l)=>{a&&v.set(l,a)});else if(o&&w.handleDrag){const a=w.handleDrag(s,v,r);this.b.addDragOperationTransfer(o,a),await a}return v}async $handleDrag(v,w,s,r){const o=this.a.get(v);if(!o)return Promise.reject(new Error((0,i.localize)(2,null,v)));const h=await this.g(new T.DataTransfer,o,w,r,s);if(!!h)return m.DataTransfer.toDataTransferDTO(h)}async $hasResolve(v){const w=this.a.get(v);if(!w)throw new Error((0,i.localize)(3,null,v));return w.hasResolve}$resolve(v,w,s){const r=this.a.get(v);if(!r)throw new Error((0,i.localize)(4,null,v));return r.resolveTreeItem(w,s)}$setExpanded(v,w,s){const r=this.a.get(v);if(!r)throw new Error((0,i.localize)(5,null,v));r.setExpanded(w,s)}$setSelection(v,w){const s=this.a.get(v);if(!s)throw new Error((0,i.localize)(6,null,v));s.setSelection(w)}$setFocus(v,w){const s=this.a.get(v);if(!s)throw new Error((0,i.localize)(7,null,v));s.setFocus(w)}$setVisible(v,w){const s=this.a.get(v);if(!s)throw new Error((0,i.localize)(8,null,v));s.setVisible(w)}$changeCheckboxState(v,w){const s=this.a.get(v);if(!s)throw new Error((0,i.localize)(9,null,v));s.setCheckboxState(w)}h(v,w,s){const r=new p(v,w,this.d,this.e.converter,this.f,s);return this.a.set(v,r),r}i(v){const w=this.a.get(v.$treeViewId);return w&&"$treeItemHandle"in v?w.getExtensionElement(v.$treeItemHandle):w&&"$focusedTreeItem"in v&&v.$focusedTreeItem?w.focusedElement:null}}e.ExtHostTreeViews=u;class p extends A.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(v=>this.getExtensionElement(v)).filter(v=>!(0,M.isUndefinedOrNull)(v))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(v,w,s,r,o,h){if(super(),this.C=v,this.D=s,this.F=r,this.G=o,this.H=h,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new C.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new C.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new C.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new C.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new C.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new C.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new b.CancellationTokenSource,h.contributes&&h.contributes.views)for(const n in h.contributes.views)for(const d of h.contributes.views[n])d.id===v&&(this.J=d.name);this.f=w.treeDataProvider,this.g=w.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(n=>this.w.fire({message:!1,element:n})));let a,l;this.B(C.Event.debounce(this.w.event,(n,d)=>(n||(n={message:!1,elements:[]}),d.element!==!1&&(a||(a=new Promise(g=>l=g),this.y=this.y.then(()=>a)),Array.isArray(d.element)?n.elements.push(...d.element):n.elements.push(d.element)),d.message&&(n.message=!0),n),200,!0)(({message:n,elements:d})=>{d.length&&(this.z=this.z.then(()=>{const g=l;return a=null,this.U(d).then(()=>g())})),n&&this.D.$setMessage(this.C,this.I)}))}async getChildren(v){const w=v?this.getExtensionElement(v):void 0;if(v&&!w)return this.G.error(`No tree item with id '${v}' found.`),Promise.resolve([]);let s=this.Q(v);return s||(s=await this.R(w)),s?s.map(r=>r.item):void 0}getExtensionElement(v){return this.i.get(v)}reveal(v,w){w=w||{select:!0,focus:!1};const s=(0,M.isUndefinedOrNull)(w.select)?!0:w.select,r=(0,M.isUndefinedOrNull)(w.focus)?!1:w.focus,o=(0,M.isUndefinedOrNull)(w.expand)?!1:w.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.y.then(()=>this.N(v)).then(h=>this.P(v,h[h.length-1]).then(a=>this.D.$reveal(this.C,{item:a.item,parentChain:h.map(l=>l.item)},{select:s,focus:r,expand:o})),h=>this.G.error(h)):this.D.$reveal(this.C,void 0,{select:s,focus:r,expand:o})}get message(){return this.I}set message(v){this.I=v,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(v){this.J=v,this.D.$setTitle(this.C,v,this.L)}get description(){return this.L}set description(v){this.L=v,this.D.$setTitle(this.C,this.J,v)}get badge(){return this.M}set badge(v){this.M?.value===v?.value&&this.M?.tooltip===v?.tooltip||(this.M=m.ViewBadge.from(v),this.D.$setBadge(this.C,v))}setExpanded(v,w){const s=this.getExtensionElement(v);s&&(w?this.r.fire(Object.freeze({element:s})):this.s.fire(Object.freeze({element:s})))}setSelection(v){(0,D.equals)(this.l,v)||(this.l=v,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(v){this.m=v}setVisible(v){v!==this.k&&(this.k=v,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(v){const w=(await Promise.all(v.map(async s=>{const r=this.getExtensionElement(s.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:s.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);w.forEach(s=>{s.treeItem.checkboxState=s.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.v.fire({items:w.map(s=>[s.extensionItem,s.newState])})}async handleDrag(v,w,s){const r=[];for(const o of v){const h=this.getExtensionElement(o);h&&r.push(h)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,w,s),w}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(v,w,s){const r=w?this.getExtensionElement(w):void 0;if(!(!r&&w||!this.g?.handleDrop))return(0,S.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(r,v,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(v,w){if(!this.f.resolveTreeItem)return;const s=this.i.get(v);if(s){const r=this.j.get(s);if(r){const o=await this.f.resolveTreeItem(r.extensionItem,s,w)??r.extensionItem;return this.db(o),r.item.tooltip=this.ab(o.tooltip),r.item.command=this.bb(r.disposableStore,o.command),r.item}}}N(v){return this.O(v).then(w=>w?this.N(w).then(s=>this.P(w,s[s.length-1]).then(r=>(s.push(r),s))):Promise.resolve([]))}O(v){const w=this.j.get(v);return w?Promise.resolve(w.parent?this.i.get(w.parent.item.handle):void 0):(0,S.asPromise)(()=>this.f.getParent(v))}P(v,w){const s=this.j.get(v);return s?Promise.resolve(s):(0,S.asPromise)(()=>this.f.getTreeItem(v)).then(r=>this.gb(v,r,w,!0)).then(r=>this.getChildren(w?w.item.handle:void 0).then(()=>{const o=this.getExtensionElement(r);if(o){const h=this.j.get(o);if(h)return Promise.resolve(h)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}Q(v){if(v){let w;if(typeof v=="string"){const s=this.getExtensionElement(v);w=s?this.j.get(s):void 0}else w=v;return w&&w.children||void 0}return this.h}async R(v){this.nb(v);const w=new b.CancellationTokenSource(this.S.token);try{const s=v?this.j.get(v):void 0,r=await this.f.getChildren(v);if(w.token.isCancellationRequested)return;const o=await Promise.all((0,D.coalesce)(r||[]).map(async h=>{const a=await this.f.getTreeItem(h);return a&&!w.token.isCancellationRequested?this.Z(h,a,s):null}));return w.token.isCancellationRequested?void 0:(0,D.coalesce)(o)}finally{w.dispose()}}U(v){if(v.some(s=>!s))return this.S.dispose(!0),this.S=new b.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const s=this.W(v);if(s.length)return this.X(s)}return Promise.resolve(void 0)}W(v){const w=new Set,s=v.map(o=>this.j.get(o));for(const o of s)if(o&&!w.has(o.item.handle)){let h=o;for(;h&&h.parent&&s.findIndex(a=>h&&h.parent&&a&&a.item.handle===h.parent.item.handle)===-1;){const a=this.i.get(h.parent.item.handle);h=a?this.j.get(a):void 0}h&&!h.parent&&w.add(o.item.handle)}const r=[];return w.forEach(o=>{const h=this.i.get(o);if(h){const a=this.j.get(h);a&&(!a.parent||!w.has(a.parent.item.handle))&&r.push(o)}}),r}X(v){const w={};return Promise.all(v.map(s=>this.Y(s).then(r=>{r&&(w[s]=r.item)}))).then(()=>Object.keys(w).length?this.D.$refresh(this.C,w):void 0)}Y(v){const w=this.getExtensionElement(v);if(w){const s=this.j.get(w);if(s)return this.nb(w),(0,S.asPromise)(()=>this.f.getTreeItem(w)).then(r=>{if(r){const o=this.eb(w,r,s.parent);return this.lb(w,o,s,s.parent),s.dispose(),o}return null})}return Promise.resolve(null)}Z(v,w,s){const r=this.eb(v,w,s);if(w.id&&this.i.has(r.item.handle))throw new Error((0,i.localize)(10,null,w.id));return this.kb(v,r),this.mb(r,s),r}ab(v){return k.MarkdownString.isMarkdownString(v)?m.MarkdownString.from(v):v}bb(v,w){return w?{...this.F.toInternal(w,v),originalId:w.command}:void 0}cb(v){if(!v.checkboxState)return;let w,s;return typeof v.checkboxState=="number"?w=v.checkboxState:(w=v.checkboxState.state,s=v.checkboxState.tooltip),{isChecked:w===k.TreeItemCheckboxState.Checked,tooltip:s}}db(v){if(!k.TreeItem.isTreeItem(v,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(v,w,s){this.db(w);const r=new A.DisposableStore,o=this.gb(v,w,s),h=this.hb(w);return{item:{handle:o,parentHandle:s?s.item.handle:void 0,label:c(w.label,this.H),description:w.description,resourceUri:w.resourceUri,tooltip:this.ab(w.tooltip),command:this.bb(r,w.command),contextValue:w.contextValue,icon:h,iconDark:this.ib(w)||h,themeIcon:this.fb(w),collapsibleState:(0,M.isUndefinedOrNull)(w.collapsibleState)?k.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation,checkbox:this.cb(w)},extensionItem:w,parent:s,children:void 0,disposableStore:r,dispose(){r.dispose()}}}fb(v){return v.iconPath instanceof k.ThemeIcon?v.iconPath:void 0}gb(v,{id:w,label:s,resourceUri:r},o,h){if(w)return`${p.b}/${w}`;const a=c(s,this.H),l=o?o.item.handle:p.a;let n=a?a.label:r?(0,y.basename)(r):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const d=this.j.has(v)?this.j.get(v).item.handle:void 0,g=this.Q(o)||[];let O,N=0;do{if(O=`${l}/${N}:${n}`,h||!this.i.has(O)||d===O)break;N++}while(N<=g.length);return O}hb(v){if(v.iconPath&&!(v.iconPath instanceof k.ThemeIcon))return typeof v.iconPath=="string"||L.URI.isUri(v.iconPath)?this.jb(v.iconPath):this.jb(v.iconPath.light)}ib(v){if(v.iconPath&&!(v.iconPath instanceof k.ThemeIcon)&&v.iconPath.dark)return this.jb(v.iconPath.dark)}jb(v){return L.URI.isUri(v)?v:L.URI.file(v)}kb(v,w){this.i.set(w.item.handle,v),this.j.set(v,w)}lb(v,w,s,r){this.i.delete(w.item.handle),this.j.delete(v),w.item.handle!==s.item.handle&&this.i.delete(s.item.handle),this.kb(v,w);const o=this.Q(r)||[],h=o.filter(a=>a.item.handle===s.item.handle)[0];h&&o.splice(o.indexOf(h),1,w)}mb(v,w){w?(w.children||(w.children=[]),w.children.push(v)):(this.h||(this.h=[]),this.h.push(v))}nb(v){if(v){const w=this.j.get(v);if(w){if(w.children)for(const s of w.children){const r=this.i.get(s.item.handle);r&&this.ob(r)}w.children=void 0}}else this.pb()}ob(v){const w=this.j.get(v);if(w){if(w.children)for(const s of w.children){const r=this.i.get(s.item.handle);r&&this.ob(r)}this.j.delete(v),this.i.delete(w.item.handle),w.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(v=>v.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}p.a="0",p.b="1"}),define(Ie[245],Ce([1,0,20,11,5,29,2,126,254,115,124,36,4,69,198,197,38,199,32,201,202,203,186,204,55,33,206,207,210,211,213,103,189,218,219,220,75,58,223,244,8,6,91,226,59,102,31,177,209,48,101,105,107,108,12,52,15,27,214,184,65,72,195,224,76,57,229,227,228,196,37,221,225,74,56,70,215,104,216,13,87,188,168,208,7,25,172,73,165,217]),function(ee,e,i,T,y,L,C,A,S,k,M,D,m,b,f,t,c,u,p,E,v,w,s,r,o,h,a,l,n,d,g,O,N,q,J,x,R,P,F,B,z,V,K,ie,ge,ue,re,se,le,_,me,we,Me,We,Qe,Te,De,ke,oe,ce,Y,I,$,H,j,Z,de,Se,ae,ve,be,$e,He,tt,xe,et,it,dt,Fe,st,Q,X,pe,Ne,Be,je,Je,nt,vt,wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Tt(lt){const at=lt.get(ke.IExtHostInitDataService),Ut=lt.get(be.IExtHostFileSystemInfo),Ft=lt.get(Z.IExtHostConsumerFileSystem),Mt=lt.get(h.IExtHostExtensionService),ft=lt.get(re.IExtHostWorkspace),Ct=lt.get(et.IExtHostTelemetry),Bt=lt.get(p.IExtHostConfiguration),Nt=lt.get(Te.IURITransformerService),Ge=lt.get(De.IExtHostRpcService),Rt=lt.get(R.IExtHostStorage),Lt=lt.get(j.IExtensionStoragePaths),Ht=lt.get(Qe.ILoggerService),mt=lt.get(Qe.ILogService),At=lt.get(Y.IExtHostTunnelService),ye=lt.get(I.IExtHostApiDeprecationService),Pe=lt.get(ue.IExtHostWindow),fe=lt.get(tt.IExtHostSecretState),G=lt.get(xe.IExtHostEditorTabs);Ge.set(m.ExtHostContext.ExtHostFileSystemInfo,Ut),Ge.set(m.ExtHostContext.ExtHostLogLevelServiceShape,Ht),Ge.set(m.ExtHostContext.ExtHostWorkspace,ft),Ge.set(m.ExtHostContext.ExtHostConfiguration,Bt),Ge.set(m.ExtHostContext.ExtHostExtensionService,Mt),Ge.set(m.ExtHostContext.ExtHostStorage,Rt),Ge.set(m.ExtHostContext.ExtHostTunnelService,At),Ge.set(m.ExtHostContext.ExtHostWindow,Pe),Ge.set(m.ExtHostContext.ExtHostSecretState,fe),Ge.set(m.ExtHostContext.ExtHostTelemetry,Ct),Ge.set(m.ExtHostContext.ExtHostEditorTabs,G);const Ae=Ge.set(m.ExtHostContext.ExtHostDecorations,lt.get(me.IExtHostDecorations)),Le=Ge.set(m.ExtHostContext.ExtHostDocumentsAndEditors,lt.get(o.IExtHostDocumentsAndEditors)),Xe=Ge.set(m.ExtHostContext.ExtHostCommands,lt.get(c.IExtHostCommands)),ze=Ge.set(m.ExtHostContext.ExtHostTerminalService,lt.get(P.IExtHostTerminalService)),Ze=Ge.set(m.ExtHostContext.ExtHostDebugService,lt.get(Me.IExtHostDebugService)),It=Ge.set(m.ExtHostContext.ExtHostSearch,lt.get(We.IExtHostSearch)),bt=Ge.set(m.ExtHostContext.ExtHostTask,lt.get(we.IExtHostTask)),kt=Ge.set(m.ExtHostContext.ExtHostOutputService,lt.get(O.IExtHostOutputService)),gt=Ge.set(m.ExtHostContext.ExtHostLocalization,lt.get(nt.IExtHostLocalizationService)),pt=Ge.set(m.ExtHostContext.ExtHostUrls,new ie.ExtHostUrls(Ge)),St=Ge.set(m.ExtHostContext.ExtHostDocuments,new r.ExtHostDocuments(Ge,Le)),$t=Ge.set(m.ExtHostContext.ExtHostDocumentContentProviders,new w.ExtHostDocumentContentProvider(Ge,Le,mt)),Xt=Ge.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new s.ExtHostDocumentSaveParticipant(mt,St,Ge.getProxy(m.MainContext.MainThreadBulkEdits))),Et=Ge.set(m.ExtHostContext.ExtHostNotebook,new oe.ExtHostNotebookController(Ge,Xe,Le,St)),si=Ge.set(m.ExtHostContext.ExtHostNotebookDocuments,new pe.ExtHostNotebookDocuments(Et)),oi=Ge.set(m.ExtHostContext.ExtHostNotebookEditors,new X.ExtHostNotebookEditors(mt,Et)),Zt=Ge.set(m.ExtHostContext.ExtHostNotebookKernels,new it.ExtHostNotebookKernels(Ge,at,Et,Xe,mt)),pi=Ge.set(m.ExtHostContext.ExtHostNotebookRenderers,new Fe.ExtHostNotebookRenderers(Ge,Et)),yt=Ge.set(m.ExtHostContext.ExtHostEditors,new F.ExtHostEditors(Ge,Le)),ai=Ge.set(m.ExtHostContext.ExtHostTreeViews,new B.ExtHostTreeViews(Ge.getProxy(m.MainContext.MainThreadTreeViews),Xe,mt)),Oi=Ge.set(m.ExtHostContext.ExtHostEditorInsets,new se.ExtHostEditorInsets(Ge.getProxy(m.MainContext.MainThreadEditorInsets),yt,at.remote)),ei=Ge.set(m.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(Ge,mt,Ut,Le)),Vt=Ge.set(m.ExtHostContext.ExtHostLanguages,new d.ExtHostLanguages(Ge,St,Xe.converter,Nt)),ct=Ge.set(m.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Ge,Nt,St,Xe,ei,mt,ye,Ct)),vi=Ge.set(m.ExtHostContext.ExtHostFileSystem,new a.ExtHostFileSystem(Ge,ct)),jt=Ge.set(m.ExtHostContext.ExtHostFileSystemEventService,new l.ExtHostFileSystemEventService(Ge,mt,Le)),Qt=Ge.set(m.ExtHostContext.ExtHostQuickOpen,(0,q.createExtHostQuickOpen)(Ge,ft,Xe)),ci=Ge.set(m.ExtHostContext.ExtHostSCM,new J.ExtHostSCM(Ge,Xe,mt)),bi=Ge.set(m.ExtHostContext.ExtHostComments,(0,u.createExtHostComments)(Ge,Xe,St)),ui=Ge.set(m.ExtHostContext.ExtHostProgress,new N.ExtHostProgress(Ge.getProxy(m.MainContext.MainThreadProgress))),Ei=Ge.set(m.ExtHostContext.ExtHosLabelService,new le.ExtHostLabelService(Ge)),Ci=Ge.set(m.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(Ge)),ti=Ge.set(m.ExtHostContext.ExtHostAuthentication,new $.ExtHostAuthentication(Ge)),wi=Ge.set(m.ExtHostContext.ExtHostTimeline,new H.ExtHostTimeline(Ge,Xe)),ni=Ge.set(m.ExtHostContext.ExtHostWebviews,new ge.ExtHostWebviews(Ge,at.remote,ft,mt,ye)),ri=Ge.set(m.ExtHostContext.ExtHostWebviewPanels,new ae.ExtHostWebviewPanels(Ge,ni,ft)),Fi=Ge.set(m.ExtHostContext.ExtHostCustomEditors,new Se.ExtHostCustomEditors(Ge,St,Lt,ni,ri)),Si=Ge.set(m.ExtHostContext.ExtHostWebviewViews,new de.ExtHostWebviewViews(Ge,ni)),_t=Ge.set(m.ExtHostContext.ExtHostTesting,new $e.ExtHostTesting(Ge,Xe,Le)),Mi=Ge.set(m.ExtHostContext.ExtHostUriOpeners,new He.ExtHostUriOpeners(Ge)),Ni=Ge.set(m.ExtHostContext.ExtHostProfileContentHandlers,new wt.ExtHostProfileContentHandlers(Ge));Ge.set(m.ExtHostContext.ExtHostInteractive,new Ne.ExtHostInteractive(Ge,Et,Le,Xe,mt));const Li=Object.values(m.ExtHostContext);Ge.assertRegistered(Li);const Ui=new ve.ExtHostBulkEdits(Ge,Le),Bi=new t.ExtHostClipboard(Ge),yi=new g.ExtHostMessageService(Ge,mt),li=new v.ExtHostDialogs(Ge),di=new x.ExtHostStatusBar(Ge,Xe.converter);return f.ExtHostApiCommands.register(Xe),function(Ue,Kt,ki){const ht=function(){let ne=!Ue.isUnderDevelopment;function he(){ne||(mt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Oe(rt){if(Array.isArray(rt))rt.forEach(Oe);else if(typeof rt=="string")he();else{const Dt=rt;typeof Dt.scheme>"u"&&he(),typeof Dt.exclusive=="boolean"&&(0,je.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return rt}}(),$i={getSession(ne,he,Oe){return ti.getSession(Ue,ne,he,Oe)},async hasSession(ne,he){return(0,je.checkProposedApiEnabled)(Ue,"authSession"),!!await ti.getSession(Ue,ne,he,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(ne,he,Oe,rt){return ti.registerAuthenticationProvider(ne,he,Oe,rt)}},zi={registerCommand(ne,he,Oe){return Xe.registerCommand(!0,ne,he,Oe,void 0,Ue)},registerTextEditorCommand(ne,he,Oe){return Xe.registerCommand(!0,ne,(...rt)=>{const Dt=yt.getActiveTextEditor();if(!Dt){mt.warn("Cannot execute "+ne+" because there is no active text editor.");return}return Dt.edit(Pt=>{he.apply(Oe,[Dt,Pt,...rt])}).then(Pt=>{Pt||mt.warn("Edits from command "+ne+" were not applied.")},Pt=>{mt.warn("An error occurred while running command "+ne,Pt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(ne,he,Oe)=>((0,je.checkProposedApiEnabled)(Ue,"diffCommand"),Xe.registerCommand(!0,ne,async(...rt)=>{const Dt=Le.activeEditor(!0);if(!Dt){mt.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Pt=await yt.getDiffInformation(Dt.id);he.apply(Oe,[Pt,...rt])},void 0,void 0,Ue)),executeCommand(ne,...he){return Xe.executeCommand(ne,...he)},getCommands(ne=!1){return Xe.getCommands(ne)}},Ti={get machineId(){return at.telemetryInfo.machineId},get sessionId(){return at.telemetryInfo.sessionId},get language(){return at.environment.appLanguage},get appName(){return at.environment.appName},get appRoot(){return at.environment.appRoot?.fsPath??""},get appHost(){return at.environment.appHost},get uriScheme(){return at.environment.appUriScheme},get clipboard(){return Bi.value},get shell(){return ze.getDefaultShell(!1)},get onDidChangeShell(){return(0,je.checkProposedApiEnabled)(Ue,"envShellEvent"),ze.onDidChangeShell},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ct.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Ue,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Ue,"telemetry"),Ct.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.isNewAppInstall)(at.telemetryInfo.firstSessionDate)},createTelemetryLogger(ne){return(0,je.checkProposedApiEnabled)(Ue,"telemetryLogger"),Ct.instantiateLogger(Ue,ne)},openExternal(ne,he){return Pe.openUri(ne,{allowTunneling:!!at.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===at.environment.appUriScheme)return pt.createAppUri(ne);try{return await Pe.asExternalUri(ne,{allowTunneling:!!at.remote.authority})}catch(he){if((0,Q.matchesScheme)(ne,st.Schemas.http)||(0,Q.matchesScheme)(ne,st.Schemas.https))return ne;throw he}},get remoteName(){return(0,_.getRemoteName)(at.remote.authority)},get remoteAuthority(){return(0,je.checkProposedApiEnabled)(Ue,"resolvers"),at.remote.authority},get uiKind(){return at.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return mt.onDidChangeLogLevel}};at.environment.extensionTestsLocationURI||Object.freeze(Ti);const Wi={createTestController(ne,he,Oe){return _t.createTestController(ne,he,Oe)},createTestObserver(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),_t.createTestObserver()},runTests(ne){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),_t.runTests(ne)},get onDidChangeTestResults(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),_t.onResultsChanged},get testResults(){return(0,je.checkProposedApiEnabled)(Ue,"testObserver"),_t.results}},ii=at.remote.isRemote?V.ExtensionKind.Workspace:V.ExtensionKind.UI,Hi={getExtension(ne,he){(0,je.isProposedApiEnabled)(Ue,"extensionsAny")||(he=!1);const Oe=Kt.mine.getExtensionDescription(ne);if(Oe)return new h.Extension(Mt,Ue.identifier,Oe,ii,!1);if(he){const rt=Kt.all.getExtensionDescription(ne);if(rt)return new h.Extension(Mt,Ue.identifier,rt,ii,!0)}},get all(){const ne=[];for(const he of Kt.mine.getAllExtensionDescriptions())ne.push(new h.Extension(Mt,Ue.identifier,he,ii,!1));return ne},get allAcrossExtensionHosts(){(0,je.checkProposedApiEnabled)(Ue,"extensionsAny");const ne=new je.ExtensionIdentifierSet(Kt.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),he=[];for(const Oe of Kt.all.getAllExtensionDescriptions()){const rt=!ne.has(Oe.identifier);he.push(new h.Extension(Mt,Ue.identifier,Oe,ii,rt))}return he},get onDidChange(){return(0,je.isProposedApiEnabled)(Ue,"extensionsAny")?y.Event.any(Kt.mine.onDidChange,Kt.all.onDidChange):Kt.mine.onDidChange}},Gt={createDiagnosticCollection(ne){return ei.createDiagnosticCollection(Ue.identifier,ne)},get onDidChangeDiagnostics(){return ei.onDidChangeDiagnostics},getDiagnostics:ne=>ei.getDiagnostics(ne),getLanguages(){return Vt.getLanguages()},setTextDocumentLanguage(ne,he){return Vt.changeLanguage(ne.uri,he)},match(ne,he){const Oe=St.getDocumentData(he.uri)?.notebook;return(0,M.score)(z.LanguageSelector.from(ne),he.uri,he.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(ne,he,Oe){return ct.registerCodeActionProvider(Ue,ht(ne),he,Oe)},registerDocumentPasteEditProvider(ne,he,Oe){return(0,je.checkProposedApiEnabled)(Ue,"documentPaste"),ct.registerDocumentPasteEditProvider(Ue,ht(ne),he,Oe)},registerCodeLensProvider(ne,he){return ct.registerCodeLensProvider(Ue,ht(ne),he)},registerDefinitionProvider(ne,he){return ct.registerDefinitionProvider(Ue,ht(ne),he)},registerDeclarationProvider(ne,he){return ct.registerDeclarationProvider(Ue,ht(ne),he)},registerImplementationProvider(ne,he){return ct.registerImplementationProvider(Ue,ht(ne),he)},registerTypeDefinitionProvider(ne,he){return ct.registerTypeDefinitionProvider(Ue,ht(ne),he)},registerHoverProvider(ne,he){return ct.registerHoverProvider(Ue,ht(ne),he,Ue.identifier)},registerEvaluatableExpressionProvider(ne,he){return ct.registerEvaluatableExpressionProvider(Ue,ht(ne),he,Ue.identifier)},registerInlineValuesProvider(ne,he){return ct.registerInlineValuesProvider(Ue,ht(ne),he,Ue.identifier)},registerDocumentHighlightProvider(ne,he){return ct.registerDocumentHighlightProvider(Ue,ht(ne),he)},registerLinkedEditingRangeProvider(ne,he){return ct.registerLinkedEditingRangeProvider(Ue,ht(ne),he)},registerReferenceProvider(ne,he){return ct.registerReferenceProvider(Ue,ht(ne),he)},registerRenameProvider(ne,he){return ct.registerRenameProvider(Ue,ht(ne),he)},registerDocumentSymbolProvider(ne,he,Oe){return ct.registerDocumentSymbolProvider(Ue,ht(ne),he,Oe)},registerWorkspaceSymbolProvider(ne){return ct.registerWorkspaceSymbolProvider(Ue,ne)},registerDocumentFormattingEditProvider(ne,he){return ct.registerDocumentFormattingEditProvider(Ue,ht(ne),he)},registerDocumentRangeFormattingEditProvider(ne,he){return ct.registerDocumentRangeFormattingEditProvider(Ue,ht(ne),he)},registerOnTypeFormattingEditProvider(ne,he,Oe,...rt){return ct.registerOnTypeFormattingEditProvider(Ue,ht(ne),he,[Oe].concat(rt))},registerDocumentSemanticTokensProvider(ne,he,Oe){return ct.registerDocumentSemanticTokensProvider(Ue,ht(ne),he,Oe)},registerDocumentRangeSemanticTokensProvider(ne,he,Oe){return ct.registerDocumentRangeSemanticTokensProvider(Ue,ht(ne),he,Oe)},registerSignatureHelpProvider(ne,he,Oe,...rt){return typeof Oe=="object"?ct.registerSignatureHelpProvider(Ue,ht(ne),he,Oe):ct.registerSignatureHelpProvider(Ue,ht(ne),he,typeof Oe>"u"?[]:[Oe,...rt])},registerCompletionItemProvider(ne,he,...Oe){return ct.registerCompletionItemProvider(Ue,ht(ne),he,Oe)},registerInlineCompletionItemProvider(ne,he){return he.handleDidShowCompletionItem&&(0,je.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Ue,ht(ne),he)},registerDocumentLinkProvider(ne,he){return ct.registerDocumentLinkProvider(Ue,ht(ne),he)},registerColorProvider(ne,he){return ct.registerColorProvider(Ue,ht(ne),he)},registerFoldingRangeProvider(ne,he){return ct.registerFoldingRangeProvider(Ue,ht(ne),he)},registerSelectionRangeProvider(ne,he){return ct.registerSelectionRangeProvider(Ue,ne,he)},registerCallHierarchyProvider(ne,he){return ct.registerCallHierarchyProvider(Ue,ne,he)},registerTypeHierarchyProvider(ne,he){return ct.registerTypeHierarchyProvider(Ue,ne,he)},setLanguageConfiguration:(ne,he)=>ct.setLanguageConfiguration(Ue,ne,he),getTokenInformationAtPosition(ne,he){return(0,je.checkProposedApiEnabled)(Ue,"tokenInformation"),Vt.tokenAtPosition(ne,he)},registerInlayHintsProvider(ne,he){return ct.registerInlayHintsProvider(Ue,ne,he)},createLanguageStatusItem(ne,he){return Vt.createLanguageStatusItem(Ue,ne,he)},registerDocumentDropEditProvider(ne,he){return ct.registerDocumentOnDropEditProvider(Ue,ne,he)}},hi={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return ze.activeTerminal},get terminals(){return ze.terminals},async showTextDocument(ne,he,Oe){const rt=await(C.URI.isUri(ne)?Promise.resolve(Pi.openTextDocument(ne)):Promise.resolve(ne));return yt.showTextDocument(rt,he,Oe)},createTextEditorDecorationType(ne){return yt.createTextEditorDecorationType(Ue,ne)},onDidChangeActiveTextEditor(ne,he,Oe){return yt.onDidChangeActiveTextEditor(ne,he,Oe)},onDidChangeVisibleTextEditors(ne,he,Oe){return yt.onDidChangeVisibleTextEditors(ne,he,Oe)},onDidChangeTextEditorSelection(ne,he,Oe){return yt.onDidChangeTextEditorSelection(ne,he,Oe)},onDidChangeTextEditorOptions(ne,he,Oe){return yt.onDidChangeTextEditorOptions(ne,he,Oe)},onDidChangeTextEditorVisibleRanges(ne,he,Oe){return yt.onDidChangeTextEditorVisibleRanges(ne,he,Oe)},onDidChangeTextEditorViewColumn(ne,he,Oe){return yt.onDidChangeTextEditorViewColumn(ne,he,Oe)},onDidCloseTerminal(ne,he,Oe){return ze.onDidCloseTerminal(ne,he,Oe)},onDidOpenTerminal(ne,he,Oe){return ze.onDidOpenTerminal(ne,he,Oe)},onDidChangeActiveTerminal(ne,he,Oe){return ze.onDidChangeActiveTerminal(ne,he,Oe)},onDidChangeTerminalDimensions(ne,he,Oe){return(0,je.checkProposedApiEnabled)(Ue,"terminalDimensions"),ze.onDidChangeTerminalDimensions(ne,he,Oe)},onDidChangeTerminalState(ne,he,Oe){return ze.onDidChangeTerminalState(ne,he,Oe)},onDidWriteTerminalData(ne,he,Oe){return(0,je.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),ze.onDidWriteTerminalData(ne,he,Oe)},get state(){return Pe.state},onDidChangeWindowState(ne,he,Oe){return Pe.onDidChangeWindowState(ne,he,Oe)},showInformationMessage(ne,...he){return yi.showMessage(Ue,L.default.Info,ne,he[0],he.slice(1))},showWarningMessage(ne,...he){return yi.showMessage(Ue,L.default.Warning,ne,he[0],he.slice(1))},showErrorMessage(ne,...he){return yi.showMessage(Ue,L.default.Error,ne,he[0],he.slice(1))},showQuickPick(ne,he,Oe){return Qt.showQuickPick(ne,he,Oe)},showWorkspaceFolderPick(ne){return Qt.showWorkspaceFolderPick(ne)},showInputBox(ne,he){return Qt.showInput(ne,he)},showOpenDialog(ne){return li.showOpenDialog(ne)},showSaveDialog(ne){return li.showSaveDialog(ne)},createStatusBarItem(ne,he,Oe){let rt,Dt,Pt;return typeof ne=="string"?(rt=ne,Dt=he,Pt=Oe):(Dt=ne,Pt=he),di.createStatusBarEntry(Ue,rt,Dt,Pt)},setStatusBarMessage(ne,he){return di.setStatusBarMessage(ne,he)},withScmProgress(ne){return ye.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),ui.withProgress(Ue,{location:V.ProgressLocation.SourceControl},(he,Oe)=>ne({report(rt){}}))},withProgress(ne,he){return ui.withProgress(Ue,ne,he)},createOutputChannel(ne,he){return kt.createOutputChannel(ne,he,Ue)},createWebviewPanel(ne,he,Oe,rt){return ri.createWebviewPanel(Ue,ne,he,Oe,rt)},createWebviewTextEditorInset(ne,he,Oe,rt){return(0,je.checkProposedApiEnabled)(Ue,"editorInsets"),Oi.createWebviewEditorInset(ne,he,Oe,rt,Ue)},createTerminal(ne,he,Oe){return typeof ne=="object"?"pty"in ne?ze.createExtensionTerminal(ne):ze.createTerminalFromOptions(ne):ze.createTerminal(ne,he,Oe)},registerTerminalLinkProvider(ne){return ze.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,he){return ze.registerProfileProvider(Ue,ne,he)},registerTerminalQuickFixProvider(ne,he){return(0,je.checkProposedApiEnabled)(Ue,"terminalQuickFixProvider"),ze.registerTerminalQuickFixProvider(ne,Ue.identifier.value,he)},registerTreeDataProvider(ne,he){return ai.registerTreeDataProvider(ne,he,Ue)},createTreeView(ne,he){return ai.createTreeView(ne,he,Ue)},registerWebviewPanelSerializer:(ne,he)=>ri.registerWebviewPanelSerializer(Ue,ne,he),registerCustomEditorProvider:(ne,he,Oe={})=>Fi.registerCustomEditorProvider(Ue,ne,he,Oe),registerFileDecorationProvider(ne){return Ae.registerFileDecorationProvider(ne,Ue)},registerUriHandler(ne){return pt.registerUriHandler(Ue.identifier,ne)},createQuickPick(){return Qt.createQuickPick(Ue)},createInputBox(){return Qt.createInputBox(Ue)},get activeColorTheme(){return Ci.activeColorTheme},onDidChangeActiveColorTheme(ne,he,Oe){return Ci.onDidChangeActiveColorTheme(ne,he,Oe)},registerWebviewViewProvider(ne,he,Oe){return Si.registerWebviewViewProvider(Ue,ne,he,Oe?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,he,Oe){return Et.onDidChangeActiveNotebookEditor(ne,he,Oe)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,he,Oe){return oi.onDidChangeNotebookEditorSelection(ne,he,Oe)},onDidChangeNotebookEditorVisibleRanges(ne,he,Oe){return oi.onDidChangeNotebookEditorVisibleRanges(ne,he,Oe)},showNotebookDocument(ne,he){return Et.showNotebookDocument(ne,he)},registerExternalUriOpener(ne,he,Oe){return(0,je.checkProposedApiEnabled)(Ue,"externalUriOpener"),Mi.registerExternalUriOpener(Ue.identifier,ne,he,Oe)},registerProfileContentHandler(ne,he){return(0,je.checkProposedApiEnabled)(Ue,"profileContentHandlers"),Ni.registrProfileContentHandler(Ue,ne,he)},get tabGroups(){return G.tabGroups}},Pi={get rootPath(){return ye.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ne){throw T.readonly()},getWorkspaceFolder(ne){return ft.getWorkspaceFolder(ne)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ne){throw T.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ne){throw T.readonly()},updateWorkspaceFolders:(ne,he,...Oe)=>ft.updateWorkspaceFolders(Ue,ne,he||0,...Oe),onDidChangeWorkspaceFolders:function(ne,he,Oe){return ft.onDidChangeWorkspace(ne,he,Oe)},asRelativePath:(ne,he)=>ft.getRelativePath(ne,he),findFiles:(ne,he,Oe,rt)=>ft.findFiles(ne,he,Oe,Ue.identifier,rt),findTextInFiles:(ne,he,Oe,rt)=>{(0,je.checkProposedApiEnabled)(Ue,"findTextInFiles");let Dt,Pt;return typeof he=="object"?(Dt=he,Pt=Oe):(Dt={},Pt=he,rt=Oe),ft.findTextInFiles(ne,Dt||{},Pt,Ue.identifier,rt)},saveAll:ne=>ft.saveAll(ne),applyEdit(ne,he){return Ui.applyWorkspaceEdit(ne,Ue,he)},createFileSystemWatcher:(ne,he,Oe,rt)=>jt.createFileSystemWatcher(ft,Ue,ne,he,Oe,rt),get textDocuments(){return St.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw T.readonly()},openTextDocument(ne){let he;const Oe=ne;if(typeof ne=="string")he=Promise.resolve(C.URI.file(ne));else if(C.URI.isUri(ne))he=Promise.resolve(ne);else if(!Oe||typeof Oe=="object")he=St.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(rt=>St.ensureDocumentData(rt).then(Dt=>Dt.document))},onDidOpenTextDocument:(ne,he,Oe)=>St.onDidAddDocument(ne,he,Oe),onDidCloseTextDocument:(ne,he,Oe)=>St.onDidRemoveDocument(ne,he,Oe),onDidChangeTextDocument:(ne,he,Oe)=>St.onDidChangeDocument(ne,he,Oe),onDidSaveTextDocument:(ne,he,Oe)=>St.onDidSaveDocument(ne,he,Oe),onWillSaveTextDocument:(ne,he,Oe)=>Xt.getOnWillSaveTextDocumentEvent(Ue)(ne,he,Oe),get notebookDocuments(){return Et.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,he){let Oe;if(C.URI.isUri(ne))Oe=ne,await Et.openNotebookDocument(ne);else if(typeof ne=="string")Oe=C.URI.revive(await Et.createNotebookDocument({viewType:ne,content:he}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(ne,he,Oe){return si.onDidSaveNotebookDocument(ne,he,Oe)},onDidChangeNotebookDocument(ne,he,Oe){return si.onDidChangeNotebookDocument(ne,he,Oe)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(ne,he,Oe,rt){return Et.registerNotebookSerializer(Ue,ne,he,Oe,(0,je.isProposedApiEnabled)(Ue,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(ne,he,Oe)=>ki.onDidChangeConfiguration(ne,he,Oe),getConfiguration(ne,he){return he=arguments.length===1?void 0:he,ki.getConfiguration(ne,he,Ue)},registerTextDocumentContentProvider(ne,he){return $t.registerTextDocumentContentProvider(ne,he)},registerTaskProvider:(ne,he)=>(ye.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),bt.registerTaskProvider(Ue,ne,he)),registerFileSystemProvider(ne,he,Oe){return(0,Be.combinedDisposable)(vi.registerFileSystemProvider(Ue,ne,he,Oe),Ft.addFileSystemProvider(ne,he))},get fs(){return Ft.value},registerFileSearchProvider:(ne,he)=>((0,je.checkProposedApiEnabled)(Ue,"fileSearchProvider"),It.registerFileSearchProvider(ne,he)),registerTextSearchProvider:(ne,he)=>((0,je.checkProposedApiEnabled)(Ue,"textSearchProvider"),It.registerTextSearchProvider(ne,he)),registerRemoteAuthorityResolver:(ne,he)=>((0,je.checkProposedApiEnabled)(Ue,"resolvers"),Mt.registerRemoteAuthorityResolver(ne,he)),registerResourceLabelFormatter:ne=>((0,je.checkProposedApiEnabled)(Ue,"resolvers"),Ei.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,he,Oe)=>jt.onDidCreateFile(ne,he,Oe),onDidDeleteFiles:(ne,he,Oe)=>jt.onDidDeleteFile(ne,he,Oe),onDidRenameFiles:(ne,he,Oe)=>jt.onDidRenameFile(ne,he,Oe),onWillCreateFiles:(ne,he,Oe)=>jt.getOnWillCreateFileEvent(Ue)(ne,he,Oe),onWillDeleteFiles:(ne,he,Oe)=>jt.getOnWillDeleteFileEvent(Ue)(ne,he,Oe),onWillRenameFiles:(ne,he,Oe)=>jt.getOnWillRenameFileEvent(Ue)(ne,he,Oe),openTunnel:ne=>((0,je.checkProposedApiEnabled)(Ue,"tunnels"),At.openTunnel(Ue,ne).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,je.checkProposedApiEnabled)(Ue,"tunnels"),At.getTunnels()},onDidChangeTunnels:(ne,he,Oe)=>((0,je.checkProposedApiEnabled)(Ue,"tunnels"),At.onDidChangeTunnels(ne,he,Oe)),registerPortAttributesProvider:(ne,he)=>((0,je.checkProposedApiEnabled)(Ue,"portsAttributes"),At.registerPortsAttributesProvider(ne,he)),registerTimelineProvider:(ne,he)=>((0,je.checkProposedApiEnabled)(Ue,"timeline"),wi.registerTimelineProvider(ne,he,Ue.identifier,Xe.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ne=>((0,je.checkProposedApiEnabled)(Ue,"workspaceTrust"),ft.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,he,Oe)=>ft.onDidGrantWorkspaceTrust(ne,he,Oe),registerEditSessionIdentityProvider:(ne,he)=>((0,je.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ne,he))},zt={get inputBox(){return ye.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),ci.getLastInputBox(Ue)},createSourceControl(ne,he,Oe){return ci.createSourceControl(Ue,ne,he,Oe)}},fi={createCommentController(ne,he){return bi.createCommentController(Ue,ne,he)}},Vi={get activeDebugSession(){return Ze.activeDebugSession},get activeDebugConsole(){return Ze.activeDebugConsole},get breakpoints(){return Ze.breakpoints},onDidStartDebugSession(ne,he,Oe){return Ze.onDidStartDebugSession(ne,he,Oe)},onDidTerminateDebugSession(ne,he,Oe){return Ze.onDidTerminateDebugSession(ne,he,Oe)},onDidChangeActiveDebugSession(ne,he,Oe){return Ze.onDidChangeActiveDebugSession(ne,he,Oe)},onDidReceiveDebugSessionCustomEvent(ne,he,Oe){return Ze.onDidReceiveDebugSessionCustomEvent(ne,he,Oe)},onDidChangeBreakpoints(ne,he,Oe){return Ze.onDidChangeBreakpoints(ne,he,Oe)},registerDebugConfigurationProvider(ne,he,Oe){return Ze.registerDebugConfigurationProvider(ne,he,Oe||Je.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,he){return Ze.registerDebugAdapterDescriptorFactory(Ue,ne,he)},registerDebugAdapterTrackerFactory(ne,he){return Ze.registerDebugAdapterTrackerFactory(ne,he)},startDebugging(ne,he,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?Ze.startDebugging(ne,he,{parentSession:Oe}):Ze.startDebugging(ne,he,Oe||{})},stopDebugging(ne){return Ze.stopDebugging(ne)},addBreakpoints(ne){return Ze.addBreakpoints(ne)},removeBreakpoints(ne){return Ze.removeBreakpoints(ne)},asDebugSourceUri(ne,he){return Ze.asDebugSourceUri(ne,he)}},ji={registerTaskProvider:(ne,he)=>bt.registerTaskProvider(Ue,ne,he),fetchTasks:ne=>bt.fetchTasks(ne),executeTask:ne=>bt.executeTask(Ue,ne),get taskExecutions(){return bt.taskExecutions},onDidStartTask:(ne,he,Oe)=>bt.onDidStartTask(ne,he,Oe),onDidEndTask:(ne,he,Oe)=>bt.onDidEndTask(ne,he,Oe),onDidStartTaskProcess:(ne,he,Oe)=>bt.onDidStartTaskProcess(ne,he,Oe),onDidEndTaskProcess:(ne,he,Oe)=>bt.onDidEndTaskProcess(ne,he,Oe)},qi={createNotebookController(ne,he,Oe,rt,Dt){return Zt.createNotebookController(Ue,ne,he,Oe,rt,(0,je.isProposedApiEnabled)(Ue,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,he)=>Et.registerNotebookCellStatusBarItemProvider(Ue,ne,he),createRendererMessaging(ne){return pi.createRendererMessaging(Ue,ne)},createNotebookControllerDetectionTask(ne){return(0,je.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(Ue,ne)},registerKernelSourceActionProvider(ne,he){return(0,je.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(Ue,ne,he)},onDidChangeNotebookCellExecutionState(ne,he,Oe){return(0,je.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(ne,he,Oe)}},Ki={t(...ne){if(typeof ne[0]=="string"){const he=ne.shift(),Oe=!ne||typeof ne[0]!="object"?ne:ne[0];return gt.getMessage(Ue.identifier.value,{message:he,args:Oe})}return gt.getMessage(Ue.identifier.value,ne[0])},get bundle(){return gt.getBundle(Ue.identifier.value)},get uri(){return gt.getBundleUri(Ue.identifier.value)}};return{version:at.version,authentication:$i,commands:zi,comments:fi,debug:Vi,env:Ti,extensions:Hi,l10n:Ki,languages:Gt,notebooks:qi,scm:zt,tasks:ji,tests:Wi,window:hi,workspace:Pi,Breakpoint:V.Breakpoint,TerminalOutputAnchor:V.TerminalOutputAnchor,CallHierarchyIncomingCall:V.CallHierarchyIncomingCall,CallHierarchyItem:V.CallHierarchyItem,CallHierarchyOutgoingCall:V.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:i.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:V.CodeAction,CodeActionKind:V.CodeActionKind,CodeActionTriggerKind:V.CodeActionTriggerKind,CodeLens:V.CodeLens,Color:V.Color,ColorInformation:V.ColorInformation,ColorPresentation:V.ColorPresentation,ColorThemeKind:V.ColorThemeKind,CommentMode:V.CommentMode,CommentThreadCollapsibleState:V.CommentThreadCollapsibleState,CommentThreadState:V.CommentThreadState,CompletionItem:V.CompletionItem,CompletionItemKind:V.CompletionItemKind,CompletionItemTag:V.CompletionItemTag,CompletionList:V.CompletionList,CompletionTriggerKind:V.CompletionTriggerKind,ConfigurationTarget:V.ConfigurationTarget,CustomExecution:V.CustomExecution,DebugAdapterExecutable:V.DebugAdapterExecutable,DebugAdapterInlineImplementation:V.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:V.DebugAdapterNamedPipeServer,DebugAdapterServer:V.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Je.DebugConfigurationProviderTriggerKind,DebugConsoleMode:V.DebugConsoleMode,DecorationRangeBehavior:V.DecorationRangeBehavior,Diagnostic:V.Diagnostic,DiagnosticRelatedInformation:V.DiagnosticRelatedInformation,DiagnosticSeverity:V.DiagnosticSeverity,DiagnosticTag:V.DiagnosticTag,Disposable:V.Disposable,DocumentHighlight:V.DocumentHighlight,DocumentHighlightKind:V.DocumentHighlightKind,DocumentLink:V.DocumentLink,DocumentSymbol:V.DocumentSymbol,EndOfLine:V.EndOfLine,EnvironmentVariableMutatorType:V.EnvironmentVariableMutatorType,EvaluatableExpression:V.EvaluatableExpression,InlineValueText:V.InlineValueText,InlineValueVariableLookup:V.InlineValueVariableLookup,InlineValueEvaluatableExpression:V.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:V.InlineCompletionTriggerKind,EventEmitter:y.Emitter,ExtensionKind:V.ExtensionKind,ExtensionMode:V.ExtensionMode,ExternalUriOpenerPriority:V.ExternalUriOpenerPriority,FileChangeType:V.FileChangeType,FileDecoration:V.FileDecoration,FileDecoration2:V.FileDecoration,FileSystemError:V.FileSystemError,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:V.FoldingRange,FoldingRangeKind:V.FoldingRangeKind,FunctionBreakpoint:V.FunctionBreakpoint,InlineCompletionItem:V.InlineSuggestion,InlineCompletionList:V.InlineSuggestionList,Hover:V.Hover,IndentAction:k.IndentAction,Location:V.Location,MarkdownString:V.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:V.ParameterInformation,PortAutoForwardAction:V.PortAutoForwardAction,Position:V.Position,ProcessExecution:V.ProcessExecution,ProgressLocation:V.ProgressLocation,QuickInputButtons:V.QuickInputButtons,Range:V.Range,RelativePattern:V.RelativePattern,Selection:V.Selection,SelectionRange:V.SelectionRange,SemanticTokens:V.SemanticTokens,SemanticTokensBuilder:V.SemanticTokensBuilder,SemanticTokensEdit:V.SemanticTokensEdit,SemanticTokensEdits:V.SemanticTokensEdits,SemanticTokensLegend:V.SemanticTokensLegend,ShellExecution:V.ShellExecution,ShellQuoting:V.ShellQuoting,SignatureHelp:V.SignatureHelp,SignatureHelpTriggerKind:V.SignatureHelpTriggerKind,SignatureInformation:V.SignatureInformation,SnippetString:V.SnippetString,SourceBreakpoint:V.SourceBreakpoint,StandardTokenType:V.StandardTokenType,StatusBarAlignment:V.StatusBarAlignment,SymbolInformation:V.SymbolInformation,SymbolKind:V.SymbolKind,SymbolTag:V.SymbolTag,Task:V.Task,TaskGroup:V.TaskGroup,TaskPanelKind:V.TaskPanelKind,TaskRevealKind:V.TaskRevealKind,TaskScope:V.TaskScope,TerminalLink:V.TerminalLink,TerminalLocation:V.TerminalLocation,TerminalProfile:V.TerminalProfile,TerminalExitReason:V.TerminalExitReason,TerminalQuickFixType:V.TerminalQuickFixType,TextDocumentSaveReason:V.TextDocumentSaveReason,TextEdit:V.TextEdit,SnippetTextEdit:V.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:V.TextEditorLineNumbersStyle,TextEditorRevealType:V.TextEditorRevealType,TextEditorSelectionChangeKind:V.TextEditorSelectionChangeKind,TextDocumentChangeReason:V.TextDocumentChangeReason,ThemeColor:V.ThemeColor,ThemeIcon:V.ThemeIcon,TreeItem:V.TreeItem,TreeItem2:V.TreeItem,TreeItemCheckboxState:V.TreeItemCheckboxState,TreeItemCollapsibleState:V.TreeItemCollapsibleState,TypeHierarchyItem:V.TypeHierarchyItem,UIKind:b.UIKind,Uri:C.URI,ViewColumn:V.ViewColumn,WorkspaceEdit:V.WorkspaceEdit,DocumentDropEdit:V.DocumentDropEdit,DocumentPasteEdit:V.DocumentPasteEdit,InlayHint:V.InlayHint,InlayHintLabelPart:V.InlayHintLabelPart,InlayHintKind:V.InlayHintKind,RemoteAuthorityResolverError:V.RemoteAuthorityResolverError,ResolvedAuthority:V.ResolvedAuthority,SourceControlInputBoxValidationType:V.SourceControlInputBoxValidationType,ExtensionRuntime:V.ExtensionRuntime,TimelineItem:V.TimelineItem,NotebookRange:V.NotebookRange,NotebookCellKind:V.NotebookCellKind,NotebookCellExecutionState:V.NotebookCellExecutionState,NotebookCellData:V.NotebookCellData,NotebookData:V.NotebookData,NotebookRendererScript:V.NotebookRendererScript,NotebookCellStatusBarAlignment:V.NotebookCellStatusBarAlignment,NotebookEditorRevealType:V.NotebookEditorRevealType,NotebookCellOutput:V.NotebookCellOutput,NotebookCellOutputItem:V.NotebookCellOutputItem,NotebookCellStatusBarItem:V.NotebookCellStatusBarItem,NotebookControllerAffinity:V.NotebookControllerAffinity,NotebookControllerAffinity2:V.NotebookControllerAffinity2,NotebookEdit:V.NotebookEdit,NotebookKernelSourceAction:V.NotebookKernelSourceAction,PortAttributes:V.PortAttributes,LinkedEditingRanges:V.LinkedEditingRanges,TestResultState:V.TestResultState,TestRunRequest:V.TestRunRequest,TestMessage:V.TestMessage,TestTag:V.TestTag,TestRunProfileKind:V.TestRunProfileKind,TextSearchCompleteMessageType:dt.TextSearchCompleteMessageType,DataTransfer:V.DataTransfer,DataTransferItem:V.DataTransferItem,CoveredCount:V.CoveredCount,FileCoverage:V.FileCoverage,StatementCoverage:V.StatementCoverage,BranchCoverage:V.BranchCoverage,FunctionCoverage:V.FunctionCoverage,WorkspaceTrustState:V.WorkspaceTrustState,LanguageStatusSeverity:V.LanguageStatusSeverity,QuickPickItemKind:V.QuickPickItemKind,InputBoxValidationSeverity:V.InputBoxValidationSeverity,TabInputText:V.TextTabInput,TabInputTextDiff:V.TextDiffTabInput,TabInputTextMerge:V.TextMergeTabInput,TabInputCustom:V.CustomEditorTabInput,TabInputNotebook:V.NotebookEditorTabInput,TabInputNotebookDiff:V.NotebookDiffEditorTabInput,TabInputWebview:V.WebviewEditorTabInput,TabInputTerminal:V.TerminalEditorTabInput,TabInputInteractiveWindow:V.InteractiveWindowInput,TrustedTelemetryValue:K.TrustedTelemetryValue,LogLevel:Qe.LogLevel,EditSessionIdentityMatch:vt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Tt}),define(Ie[246],Ce([1,0,245,33,2,239,6,14,230]),function(ee,e,i,T,y,L,C,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class k extends L.RequireInterceptor{j(){}getModule(b,f){for(const t of this.b){const c=t(b);if(c){b=c;break}}if(this.a.has(b))return this.a.get(b).load(b,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class M extends T.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=C.ExtensionRuntime.Webworker}async nb(){this.h.createInstance(S.ExtHostConsoleForwarder);const b=this.h.invokeFunction(i.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(k,b,{mine:this.D,all:this.F}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.tb()}ob(b){return b.browser}async pb(b,f,t){f=f.with({path:D(f.path,".js")});const c=b?.identifier.value;c&&performance.mark(`code/extHost/willFetchExtensionCode/${c}`);const u=y.URI.revive(await this.v.$asBrowserUri(f)),p=await fetch(u.toString(!0));if(c&&performance.mark(`code/extHost/didFetchExtensionCode/${c}`),p.status!==200)throw new Error(p.statusText);const E=await p.text(),v=`${f.toString(!0)}#vscode-extension`,w=`${E}
//# sourceURL=${v}`;let s;try{s=new Function("module","exports","require",w)}catch(a){throw console.error(c?`Loading code for extension ${c} failed: ${a.message}`:`Loading code failed: ${a.message}`),console.error(`${f.toString(!0)}${typeof a.line=="number"?` line ${a.line}`:""}${typeof a.column=="number"?` column ${a.column}`:""}`),console.error(a),a}b&&await this.s.initializeLocalizedMessages(b);const r={},o={exports:r},h=a=>{const l=this.r.getModule(a,f);if(l===void 0)throw new Error(`Cannot load module '${a}'`);return l};try{return t.codeLoadingStart(),c&&performance.mark(`code/extHost/willLoadExtensionCode/${c}`),s(o,r,h),o.exports!==r?o.exports:r}finally{c&&performance.mark(`code/extHost/didLoadExtensionCode/${c}`),t.codeLoadingStop()}}async $setRemoteEnvironment(b){}async tb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+b;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=M;function D(m,b){return m.endsWith(b)?m:m+b}}),define(Ie[247],Ce([1,0,62,33,76,246]),function(ee,e,i,T,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(T.IExtHostExtensionService,L.ExtHostExtensionService,0),(0,i.registerSingleton)(y.IExtensionStoragePaths,y.ExtensionStoragePaths,0)}),define(Ie[255],Ce([1,0,24,5,69,240,232,19,77,13,2,242,247]),function(ee,e,i,T,y,L,C,A,S,k,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const m=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(s){return/^(file|vscode-remote):/i.test(s)}const f=fetch.bind(self);function t(s){self.fetch=async function(r,o){return r instanceof Request||b(String(r))&&(r=(await s(M.URI.parse(String(r)))).toString(!0)),f(r,o)},self.XMLHttpRequest=class extends XMLHttpRequest{open(r,o,h,a,l){(async()=>(b(o.toString())&&(o=(await s(M.URI.parse(o.toString()))).toString(!0)),super.open(r,o,h??!0,a,l)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const s=self.Worker;Worker=function(r,o){if(/^file:/i.test(r.toString()))r=k.FileAccess.uriToBrowserUri(M.URI.parse(r.toString())).toString(!0);else if(/^vscode-remote:/i.test(r.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const a=`(${function(g){function O(J){return typeof J=="string"||J instanceof URL?String(J).replace(/^file:\/\//i,"vscode-file://vscode-app"):J}const N=fetch.bind(self);self.fetch=function(J,x){return J instanceof Request?N(J,x):N(O(J),x)},self.XMLHttpRequest=class extends XMLHttpRequest{open(J,x,R,P,F){return super.open(J,O(x),R??!0,P,F)}};const q=importScripts.bind(self);self.importScripts=(...J)=>{q(...J.map(O))},q(g)}.toString()}('${r}'))`;o=o||{},o.name=o.name||A.basename(r.toString());const l=new Blob([a],{type:"application/javascript"}),n=URL.createObjectURL(l);return new s(n,o)}}else self.Worker=class extends C.NestedWorker{constructor(s,r){super(m,s,{name:A.basename(s.toString()),...r})}};const c=new class{constructor(){this.pid=void 0}exit(s){D()}async exists(s){return!0}async realpath(s){return s}};class u{constructor(){const r=new MessageChannel,o=new T.Emitter;let h=!1;m(r.port2,[r.port2]),r.port1.onmessage=a=>{const{data:l}=a;if(!(l instanceof ArrayBuffer)){console.warn("UNKNOWN data received",l);return}const n=i.VSBuffer.wrap(new Uint8Array(l,0,l.byteLength));if((0,y.isMessageOfType)(n,2)){h=!0,E("received terminate message from renderer");return}o.fire(n)},this.protocol={onMessage:o.event,send:a=>{if(!h){const l=a.buffer.buffer.slice(a.buffer.byteOffset,a.buffer.byteOffset+a.buffer.byteLength);r.port1.postMessage(l,[l])}}}}}function p(s){return new Promise(r=>{const o=s.onMessage(h=>{o.dispose();const a=JSON.parse(h.toString());s.send((0,y.createMessageOfType)(0)),r({protocol:s,initData:a})});s.send((0,y.createMessageOfType)(1))})}let E=s=>D();function v(s){return!!s&&typeof s=="object"&&s.type==="vscode.init"&&s.data instanceof Map}function w(){S.mark("code/extHost/willConnectToRenderer");const s=new u;return{onmessage(r){!v(r)||p(s.protocol).then(o=>{S.mark("code/extHost/didWaitForInitData");const h=new L.ExtensionHostMain(o.protocol,o.initData,c,null,r.data);t(a=>h.asBrowserUri(a)),E=a=>h.terminate(a)})}}}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d7b1e2a1c892511a125e4ceb9758ec8ddf907775/core/vs/workbench/api/worker/extensionHostWorker.js.map
